#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 2016
#define LARGE_STATE_COUNT 693
#define SYMBOL_COUNT 524
#define ALIAS_COUNT 0
#define TOKEN_COUNT 361
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 5
#define MAX_ALIAS_SEQUENCE_LENGTH 13
#define PRODUCTION_ID_COUNT 18

enum ts_symbol_identifiers {
  sym_comment = 1,
  sym_attr_ref = 2,
  sym_comdat_ref = 3,
  sym_global_var = 4,
  sym_local_var = 5,
  sym_label = 6,
  aux_sym_metadata_ref_token1 = 7,
  sym_summary_ref = 8,
  sym_string = 9,
  aux_sym_number_token1 = 10,
  aux_sym_number_token2 = 11,
  sym_float = 12,
  sym_cstring = 13,
  anon_sym_target = 14,
  anon_sym_triple = 15,
  anon_sym_EQ = 16,
  anon_sym_datalayout = 17,
  anon_sym_source_filename = 18,
  anon_sym_declare = 19,
  anon_sym_define = 20,
  anon_sym_no_cfi = 21,
  anon_sym_private = 22,
  anon_sym_internal = 23,
  anon_sym_weak = 24,
  anon_sym_weak_odr = 25,
  anon_sym_linkonce = 26,
  anon_sym_linkonce_odr = 27,
  anon_sym_available_externally = 28,
  anon_sym_appending = 29,
  anon_sym_common = 30,
  anon_sym_extern_weak = 31,
  anon_sym_external = 32,
  anon_sym_dso_local = 33,
  anon_sym_dso_local_equivalent = 34,
  anon_sym_dso_preemptable = 35,
  anon_sym_default = 36,
  anon_sym_hidden = 37,
  anon_sym_protected = 38,
  anon_sym_dllimport = 39,
  anon_sym_dllexport = 40,
  anon_sym_ccc = 41,
  anon_sym_fastcc = 42,
  anon_sym_coldcc = 43,
  anon_sym_webkit_jscc = 44,
  anon_sym_anyregcc = 45,
  anon_sym_preserve_mostcc = 46,
  anon_sym_preserve_allcc = 47,
  anon_sym_cxx_fast_tlscc = 48,
  anon_sym_tailcc = 49,
  anon_sym_swiftcc = 50,
  anon_sym_swifttailcc = 51,
  anon_sym_cfguard_checkcc = 52,
  aux_sym_calling_conv_token1 = 53,
  aux_sym_calling_conv_token2 = 54,
  aux_sym_calling_conv_token3 = 55,
  aux_sym_calling_conv_token4 = 56,
  aux_sym_calling_conv_token5 = 57,
  aux_sym_calling_conv_token6 = 58,
  aux_sym_calling_conv_token7 = 59,
  aux_sym_calling_conv_token8 = 60,
  aux_sym_calling_conv_token9 = 61,
  aux_sym_calling_conv_token10 = 62,
  anon_sym_ghccc = 63,
  aux_sym_calling_conv_token11 = 64,
  aux_sym_calling_conv_token12 = 65,
  aux_sym_calling_conv_token13 = 66,
  aux_sym_calling_conv_token14 = 67,
  anon_sym_cc = 68,
  anon_sym_unnamed_addr = 69,
  anon_sym_local_unnamed_addr = 70,
  anon_sym_STAR = 71,
  anon_sym_void = 72,
  anon_sym_half = 73,
  anon_sym_bfloat = 74,
  anon_sym_float = 75,
  anon_sym_double = 76,
  anon_sym_x86_fp80 = 77,
  anon_sym_fp128 = 78,
  anon_sym_ppc_fp128 = 79,
  anon_sym_label = 80,
  anon_sym_metadata = 81,
  anon_sym_x86_mmx = 82,
  anon_sym_x86_amx = 83,
  anon_sym_token = 84,
  anon_sym_opaque = 85,
  anon_sym_ptr = 86,
  aux_sym_type_keyword_token1 = 87,
  anon_sym_LBRACE = 88,
  anon_sym_RBRACE = 89,
  anon_sym_LT_LBRACE = 90,
  anon_sym_RBRACE_GT = 91,
  anon_sym_LBRACK = 92,
  anon_sym_RBRACK = 93,
  anon_sym_LT = 94,
  anon_sym_GT = 95,
  anon_sym_COMMA = 96,
  anon_sym_vscale = 97,
  anon_sym_x = 98,
  anon_sym_addrspace = 99,
  anon_sym_LPAREN = 100,
  anon_sym_RPAREN = 101,
  anon_sym_DOT_DOT_DOT = 102,
  anon_sym_align = 103,
  anon_sym_section = 104,
  anon_sym_partition = 105,
  anon_sym_comdat = 106,
  anon_sym_gc = 107,
  anon_sym_prefix = 108,
  anon_sym_prologue = 109,
  anon_sym_personality = 110,
  anon_sym_alignstack = 111,
  anon_sym_allocsize = 112,
  anon_sym_alwaysinline = 113,
  anon_sym_builtin = 114,
  anon_sym_cold = 115,
  anon_sym_convergent = 116,
  anon_sym_disable_sanitizer_instrumentation = 117,
  anon_sym_hot = 118,
  anon_sym_inaccessiblememonly = 119,
  anon_sym_inaccessiblemem_or_argmemonly = 120,
  anon_sym_inlinehint = 121,
  anon_sym_jumptable = 122,
  anon_sym_minsize = 123,
  anon_sym_naked = 124,
  anon_sym_no_DASHjump_DASHtables = 125,
  anon_sym_nobuiltin = 126,
  anon_sym_noduplicate = 127,
  anon_sym_nofree = 128,
  anon_sym_noimplicitfloat = 129,
  anon_sym_noinline = 130,
  anon_sym_nomerge = 131,
  anon_sym_nonlazybind = 132,
  anon_sym_noprofile = 133,
  anon_sym_noredzone = 134,
  anon_sym_indirect_DASHtls_DASHseg_DASHrefs = 135,
  anon_sym_noreturn = 136,
  anon_sym_norecurse = 137,
  anon_sym_willreturn = 138,
  anon_sym_nosync = 139,
  anon_sym_nounwind = 140,
  anon_sym_nocallback = 141,
  anon_sym_nosanitize_coverage = 142,
  anon_sym_null_pointer_is_valid = 143,
  anon_sym_optforfuzzing = 144,
  anon_sym_optnone = 145,
  anon_sym_optsize = 146,
  anon_sym_readnone = 147,
  anon_sym_readonly = 148,
  anon_sym_writeonly = 149,
  anon_sym_argmemonly = 150,
  anon_sym_returns_twice = 151,
  anon_sym_safestack = 152,
  anon_sym_sanitize_address = 153,
  anon_sym_sanitize_memory = 154,
  anon_sym_sanitize_thread = 155,
  anon_sym_sanitize_hwaddress = 156,
  anon_sym_sanitize_memtag = 157,
  anon_sym_speculative_load_hardening = 158,
  anon_sym_speculatable = 159,
  anon_sym_ssp = 160,
  anon_sym_sspstrong = 161,
  anon_sym_sspreq = 162,
  anon_sym_strictfp = 163,
  anon_sym_nocf_check = 164,
  anon_sym_shadowcallstack = 165,
  anon_sym_mustprogress = 166,
  anon_sym_vscale_range = 167,
  anon_sym_preallocated = 168,
  anon_sym_zeroext = 169,
  anon_sym_signext = 170,
  anon_sym_inreg = 171,
  anon_sym_byval = 172,
  anon_sym_byref = 173,
  anon_sym_inalloca = 174,
  anon_sym_sret = 175,
  anon_sym_elementtype = 176,
  anon_sym_noalias = 177,
  anon_sym_nocapture = 178,
  anon_sym_nest = 179,
  anon_sym_returned = 180,
  anon_sym_nonnull = 181,
  anon_sym_dereferenceable = 182,
  anon_sym_dereferenceable_or_null = 183,
  anon_sym_swiftself = 184,
  anon_sym_swiftasync = 185,
  anon_sym_swifterror = 186,
  anon_sym_immarg = 187,
  anon_sym_noundef = 188,
  anon_sym_uwtable = 189,
  anon_sym_sync = 190,
  anon_sym_async = 191,
  anon_sym_memory = 192,
  anon_sym_argmem = 193,
  anon_sym_inaccessiblemem = 194,
  anon_sym_COLON = 195,
  anon_sym_none = 196,
  anon_sym_read = 197,
  anon_sym_write = 198,
  anon_sym_readwrite = 199,
  anon_sym_unreachable = 200,
  anon_sym_ret = 201,
  anon_sym_br = 202,
  anon_sym_resume = 203,
  anon_sym_freeze = 204,
  anon_sym_indirectbr = 205,
  anon_sym_extractelement = 206,
  anon_sym_insertelement = 207,
  anon_sym_select = 208,
  anon_sym_shufflevector = 209,
  anon_sym_fneg = 210,
  anon_sym_nsw = 211,
  anon_sym_nuw = 212,
  anon_sym_exact = 213,
  anon_sym_disjoint = 214,
  anon_sym_switch = 215,
  anon_sym_invoke = 216,
  anon_sym_to = 217,
  anon_sym_unwind = 218,
  anon_sym_cleanupret = 219,
  anon_sym_from = 220,
  anon_sym_catchret = 221,
  anon_sym_catchswitch = 222,
  anon_sym_catchpad = 223,
  anon_sym_cleanuppad = 224,
  anon_sym_callbr = 225,
  anon_sym_icmp = 226,
  anon_sym_fcmp = 227,
  anon_sym_nneg = 228,
  anon_sym_va_arg = 229,
  anon_sym_phi = 230,
  anon_sym_landingpad = 231,
  anon_sym_cleanup = 232,
  anon_sym_tail = 233,
  anon_sym_musttail = 234,
  anon_sym_notail = 235,
  anon_sym_call = 236,
  anon_sym_alloca = 237,
  anon_sym_load = 238,
  anon_sym_atomic = 239,
  anon_sym_volatile = 240,
  anon_sym_store = 241,
  anon_sym_cmpxchg = 242,
  anon_sym_atomicrmw = 243,
  anon_sym_fence = 244,
  anon_sym_getelementptr = 245,
  anon_sym_inbounds = 246,
  anon_sym_inrange = 247,
  anon_sym_extractvalue = 248,
  anon_sym_insertvalue = 249,
  anon_sym_true = 250,
  anon_sym_false = 251,
  anon_sym_null = 252,
  anon_sym_undef = 253,
  anon_sym_poison = 254,
  anon_sym_zeroinitializer = 255,
  anon_sym_catch = 256,
  anon_sym_filter = 257,
  anon_sym_blockaddress = 258,
  anon_sym_mul = 259,
  anon_sym_urem = 260,
  anon_sym_srem = 261,
  anon_sym_shl = 262,
  anon_sym_udiv = 263,
  anon_sym_sdiv = 264,
  anon_sym_lshr = 265,
  anon_sym_ashr = 266,
  anon_sym_fmul = 267,
  anon_sym_fdiv = 268,
  anon_sym_frem = 269,
  anon_sym_xchg = 270,
  anon_sym_add = 271,
  anon_sym_sub = 272,
  anon_sym_and = 273,
  anon_sym_nand = 274,
  anon_sym_or = 275,
  anon_sym_xor = 276,
  anon_sym_max = 277,
  anon_sym_min = 278,
  anon_sym_umax = 279,
  anon_sym_umin = 280,
  anon_sym_fadd = 281,
  anon_sym_fsub = 282,
  anon_sym_eq = 283,
  anon_sym_ne = 284,
  anon_sym_ugt = 285,
  anon_sym_uge = 286,
  anon_sym_ult = 287,
  anon_sym_ule = 288,
  anon_sym_sgt = 289,
  anon_sym_sge = 290,
  anon_sym_slt = 291,
  anon_sym_sle = 292,
  anon_sym_oeq = 293,
  anon_sym_ogt = 294,
  anon_sym_oge = 295,
  anon_sym_olt = 296,
  anon_sym_ole = 297,
  anon_sym_one = 298,
  anon_sym_ord = 299,
  anon_sym_ueq = 300,
  anon_sym_une = 301,
  anon_sym_uno = 302,
  anon_sym_bitcast = 303,
  anon_sym_trunc = 304,
  anon_sym_zext = 305,
  anon_sym_sext = 306,
  anon_sym_fptrunc = 307,
  anon_sym_fpext = 308,
  anon_sym_addrspacecast = 309,
  anon_sym_uitofp = 310,
  anon_sym_sitofp = 311,
  anon_sym_fptoui = 312,
  anon_sym_fptosi = 313,
  anon_sym_inttoptr = 314,
  anon_sym_ptrtoint = 315,
  anon_sym_unordered = 316,
  anon_sym_monotonic = 317,
  anon_sym_acquire = 318,
  anon_sym_release = 319,
  anon_sym_acq_rel = 320,
  anon_sym_seq_cst = 321,
  anon_sym_syncscope = 322,
  anon_sym_nnan = 323,
  anon_sym_ninf = 324,
  anon_sym_nsz = 325,
  anon_sym_arcp = 326,
  anon_sym_contract = 327,
  anon_sym_afn = 328,
  anon_sym_reassoc = 329,
  anon_sym_fast = 330,
  anon_sym_within = 331,
  anon_sym_caller = 332,
  anon_sym_uselistorder = 333,
  anon_sym_uselistorder_bb = 334,
  anon_sym_module = 335,
  anon_sym_asm = 336,
  anon_sym_sideeffect = 337,
  anon_sym_inteldialect = 338,
  anon_sym_type = 339,
  anon_sym_externally_initialized = 340,
  anon_sym_global = 341,
  anon_sym_constant = 342,
  anon_sym_alias = 343,
  anon_sym_ifunc = 344,
  anon_sym_thread_local = 345,
  anon_sym_localdynamic = 346,
  anon_sym_initialexec = 347,
  anon_sym_localexec = 348,
  anon_sym_any = 349,
  anon_sym_exactmatch = 350,
  anon_sym_largest = 351,
  anon_sym_nodeduplicate = 352,
  anon_sym_samesize = 353,
  anon_sym_distinct = 354,
  anon_sym_BANG = 355,
  anon_sym_LBRACE2 = 356,
  anon_sym_LPAREN2 = 357,
  aux_sym_specialized_md_value_token1 = 358,
  anon_sym_PIPE = 359,
  anon_sym_attributes = 360,
  sym_module = 361,
  sym_metadata_ref = 362,
  sym_metadata_name = 363,
  sym_number = 364,
  sym_var = 365,
  sym_target_definition = 366,
  sym_target_triple = 367,
  sym_data_layout = 368,
  sym_source_file_name = 369,
  sym_declare = 370,
  sym_define = 371,
  sym_metadata_attachment = 372,
  sym_function_header = 373,
  sym_linkage = 374,
  sym_linkage_aux = 375,
  sym_dso_local = 376,
  sym_visibility = 377,
  sym_dll_storage_class = 378,
  sym_calling_conv = 379,
  sym_unnamed_addr = 380,
  sym_type = 381,
  sym_type_keyword = 382,
  sym_struct_type = 383,
  sym_packed_struct_type = 384,
  sym_array_type = 385,
  sym_vector_type = 386,
  sym_struct_body = 387,
  sym_array_vector_body = 388,
  sym_addrspace = 389,
  sym_argument_list = 390,
  sym_argument = 391,
  sym_param_or_return_attrs = 392,
  sym_attribute = 393,
  sym_attribute_name = 394,
  sym_uwtable = 395,
  sym_memory_attribute = 396,
  sym_memory_attribute_val = 397,
  sym_function_body = 398,
  sym_instruction = 399,
  sym__instruction_body = 400,
  sym_instruction_unreachable = 401,
  sym_instruction_ret = 402,
  sym_instruction_br = 403,
  sym_instruction_resume = 404,
  sym_instruction_freeze = 405,
  sym_instruction_indirectbr = 406,
  sym_instruction_extractelement = 407,
  sym_instruction_insertelement = 408,
  sym_instruction_select = 409,
  sym_instruction_shufflevector = 410,
  sym_instruction_fneg = 411,
  sym_instruction_bin_op = 412,
  sym_instruction_switch = 413,
  sym_instruction_invoke = 414,
  sym_instruction_cleanupret = 415,
  sym_instruction_catchret = 416,
  sym_instruction_catchswitch = 417,
  sym_instruction_catchpad = 418,
  sym_instruction_cleanuppad = 419,
  sym_instruction_callbr = 420,
  sym_instruction_icmp = 421,
  sym_instruction_fcmp = 422,
  sym_instruction_cast = 423,
  sym_instruction_va_arg = 424,
  sym_instruction_phi = 425,
  sym_instruction_landingpad = 426,
  sym_instruction_call = 427,
  sym_instruction_alloca = 428,
  sym_instruction_load = 429,
  sym_instruction_store = 430,
  sym_instruction_cmpxchg = 431,
  sym_instruction_atomicrmw = 432,
  sym_instruction_fence = 433,
  sym_instruction_getelementptr = 434,
  sym_instruction_extractvalue = 435,
  sym_instruction_insertvalue = 436,
  sym__call_part = 437,
  sym_type_and_value = 438,
  sym_value = 439,
  sym__primitive_value = 440,
  sym_struct_value = 441,
  sym_packed_struct_value = 442,
  sym_array_value = 443,
  sym_vector_value = 444,
  sym_metadata_refs = 445,
  sym_operand_bundles = 446,
  sym_landingpad_clause = 447,
  sym_blockaddress = 448,
  sym_constant_expr = 449,
  sym_constant_cast = 450,
  sym_constant_getelementptr = 451,
  sym_constant_select = 452,
  sym_constant_icmp = 453,
  sym_constant_fcmp = 454,
  sym_constant_extractelement = 455,
  sym_constant_insertelement = 456,
  sym_constant_shufflevector = 457,
  sym_constant_extractvalue = 458,
  sym_constant_insertvalue = 459,
  sym_constant_fneg = 460,
  sym_constant_bin_op = 461,
  sym_bin_op_keyword = 462,
  sym_atomic_bin_op_keyword = 463,
  sym_icmp_cond = 464,
  sym_fcmp_cond = 465,
  sym_cast_inst = 466,
  sym_atomic_ordering = 467,
  sym_alignment = 468,
  sym__load_store_suffix = 469,
  sym_syncscope = 470,
  sym_fast_math = 471,
  sym__value_array = 472,
  sym__within = 473,
  sym__unwind_label = 474,
  sym_use_list_order = 475,
  sym_use_list_order_bb = 476,
  sym_module_asm = 477,
  sym_inline_asm = 478,
  sym_asm = 479,
  sym_global_type = 480,
  sym__global_prefix = 481,
  sym_global_global = 482,
  sym_alias = 483,
  sym_ifunc = 484,
  sym_thread_local = 485,
  sym_comdat = 486,
  sym_global_metadata = 487,
  sym_metadata = 488,
  sym_metadata_tuple = 489,
  sym_specialized_md = 490,
  sym_specialized_md_value = 491,
  sym_summary_entry = 492,
  sym_summary_value = 493,
  sym_unnamed_attr_grp = 494,
  aux_sym_module_repeat1 = 495,
  aux_sym_declare_repeat1 = 496,
  aux_sym_function_header_repeat1 = 497,
  aux_sym_function_header_repeat2 = 498,
  aux_sym_function_header_repeat3 = 499,
  aux_sym_type_repeat1 = 500,
  aux_sym_type_repeat2 = 501,
  aux_sym_struct_body_repeat1 = 502,
  aux_sym_argument_list_repeat1 = 503,
  aux_sym_attribute_repeat1 = 504,
  aux_sym_memory_attribute_repeat1 = 505,
  aux_sym_function_body_repeat1 = 506,
  aux_sym_function_body_repeat2 = 507,
  aux_sym_instruction_repeat1 = 508,
  aux_sym_instruction_select_repeat1 = 509,
  aux_sym_instruction_bin_op_repeat1 = 510,
  aux_sym_instruction_switch_repeat1 = 511,
  aux_sym_instruction_callbr_repeat1 = 512,
  aux_sym_instruction_phi_repeat1 = 513,
  aux_sym_instruction_landingpad_repeat1 = 514,
  aux_sym_instruction_alloca_repeat1 = 515,
  aux_sym_instruction_getelementptr_repeat1 = 516,
  aux_sym_instruction_extractvalue_repeat1 = 517,
  aux_sym_operand_bundles_repeat1 = 518,
  aux_sym_constant_bin_op_repeat1 = 519,
  aux_sym_global_global_repeat1 = 520,
  aux_sym_metadata_tuple_repeat1 = 521,
  aux_sym_specialized_md_repeat1 = 522,
  aux_sym_summary_entry_repeat1 = 523,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_comment] = "comment",
  [sym_attr_ref] = "attr_ref",
  [sym_comdat_ref] = "comdat_ref",
  [sym_global_var] = "global_var",
  [sym_local_var] = "local_var",
  [sym_label] = "label",
  [aux_sym_metadata_ref_token1] = "metadata_ref_token1",
  [sym_summary_ref] = "summary_ref",
  [sym_string] = "string",
  [aux_sym_number_token1] = "number_token1",
  [aux_sym_number_token2] = "number_token2",
  [sym_float] = "float",
  [sym_cstring] = "cstring",
  [anon_sym_target] = "target",
  [anon_sym_triple] = "triple",
  [anon_sym_EQ] = "=",
  [anon_sym_datalayout] = "datalayout",
  [anon_sym_source_filename] = "source_filename",
  [anon_sym_declare] = "declare",
  [anon_sym_define] = "define",
  [anon_sym_no_cfi] = "no_cfi",
  [anon_sym_private] = "private",
  [anon_sym_internal] = "internal",
  [anon_sym_weak] = "weak",
  [anon_sym_weak_odr] = "weak_odr",
  [anon_sym_linkonce] = "linkonce",
  [anon_sym_linkonce_odr] = "linkonce_odr",
  [anon_sym_available_externally] = "available_externally",
  [anon_sym_appending] = "appending",
  [anon_sym_common] = "common",
  [anon_sym_extern_weak] = "extern_weak",
  [anon_sym_external] = "external",
  [anon_sym_dso_local] = "dso_local",
  [anon_sym_dso_local_equivalent] = "dso_local_equivalent",
  [anon_sym_dso_preemptable] = "dso_preemptable",
  [anon_sym_default] = "default",
  [anon_sym_hidden] = "hidden",
  [anon_sym_protected] = "protected",
  [anon_sym_dllimport] = "dllimport",
  [anon_sym_dllexport] = "dllexport",
  [anon_sym_ccc] = "ccc",
  [anon_sym_fastcc] = "fastcc",
  [anon_sym_coldcc] = "coldcc",
  [anon_sym_webkit_jscc] = "webkit_jscc",
  [anon_sym_anyregcc] = "anyregcc",
  [anon_sym_preserve_mostcc] = "preserve_mostcc",
  [anon_sym_preserve_allcc] = "preserve_allcc",
  [anon_sym_cxx_fast_tlscc] = "cxx_fast_tlscc",
  [anon_sym_tailcc] = "tailcc",
  [anon_sym_swiftcc] = "swiftcc",
  [anon_sym_swifttailcc] = "swifttailcc",
  [anon_sym_cfguard_checkcc] = "cfguard_checkcc",
  [aux_sym_calling_conv_token1] = "calling_conv_token1",
  [aux_sym_calling_conv_token2] = "calling_conv_token2",
  [aux_sym_calling_conv_token3] = "calling_conv_token3",
  [aux_sym_calling_conv_token4] = "calling_conv_token4",
  [aux_sym_calling_conv_token5] = "calling_conv_token5",
  [aux_sym_calling_conv_token6] = "calling_conv_token6",
  [aux_sym_calling_conv_token7] = "calling_conv_token7",
  [aux_sym_calling_conv_token8] = "calling_conv_token8",
  [aux_sym_calling_conv_token9] = "calling_conv_token9",
  [aux_sym_calling_conv_token10] = "calling_conv_token10",
  [anon_sym_ghccc] = "ghccc",
  [aux_sym_calling_conv_token11] = "calling_conv_token11",
  [aux_sym_calling_conv_token12] = "calling_conv_token12",
  [aux_sym_calling_conv_token13] = "calling_conv_token13",
  [aux_sym_calling_conv_token14] = "calling_conv_token14",
  [anon_sym_cc] = "cc",
  [anon_sym_unnamed_addr] = "unnamed_addr",
  [anon_sym_local_unnamed_addr] = "local_unnamed_addr",
  [anon_sym_STAR] = "*",
  [anon_sym_void] = "void",
  [anon_sym_half] = "half",
  [anon_sym_bfloat] = "bfloat",
  [anon_sym_float] = "float",
  [anon_sym_double] = "double",
  [anon_sym_x86_fp80] = "x86_fp80",
  [anon_sym_fp128] = "fp128",
  [anon_sym_ppc_fp128] = "ppc_fp128",
  [anon_sym_label] = "label",
  [anon_sym_metadata] = "metadata",
  [anon_sym_x86_mmx] = "x86_mmx",
  [anon_sym_x86_amx] = "x86_amx",
  [anon_sym_token] = "token",
  [anon_sym_opaque] = "opaque",
  [anon_sym_ptr] = "ptr",
  [aux_sym_type_keyword_token1] = "type_keyword_token1",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_LT_LBRACE] = "<{",
  [anon_sym_RBRACE_GT] = "}>",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_COMMA] = ",",
  [anon_sym_vscale] = "vscale",
  [anon_sym_x] = "x",
  [anon_sym_addrspace] = "addrspace",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_align] = "align",
  [anon_sym_section] = "section",
  [anon_sym_partition] = "partition",
  [anon_sym_comdat] = "comdat",
  [anon_sym_gc] = "gc",
  [anon_sym_prefix] = "prefix",
  [anon_sym_prologue] = "prologue",
  [anon_sym_personality] = "personality",
  [anon_sym_alignstack] = "alignstack",
  [anon_sym_allocsize] = "allocsize",
  [anon_sym_alwaysinline] = "alwaysinline",
  [anon_sym_builtin] = "builtin",
  [anon_sym_cold] = "cold",
  [anon_sym_convergent] = "convergent",
  [anon_sym_disable_sanitizer_instrumentation] = "disable_sanitizer_instrumentation",
  [anon_sym_hot] = "hot",
  [anon_sym_inaccessiblememonly] = "inaccessiblememonly",
  [anon_sym_inaccessiblemem_or_argmemonly] = "inaccessiblemem_or_argmemonly",
  [anon_sym_inlinehint] = "inlinehint",
  [anon_sym_jumptable] = "jumptable",
  [anon_sym_minsize] = "minsize",
  [anon_sym_naked] = "naked",
  [anon_sym_no_DASHjump_DASHtables] = "no-jump-tables",
  [anon_sym_nobuiltin] = "nobuiltin",
  [anon_sym_noduplicate] = "noduplicate",
  [anon_sym_nofree] = "nofree",
  [anon_sym_noimplicitfloat] = "noimplicitfloat",
  [anon_sym_noinline] = "noinline",
  [anon_sym_nomerge] = "nomerge",
  [anon_sym_nonlazybind] = "nonlazybind",
  [anon_sym_noprofile] = "noprofile",
  [anon_sym_noredzone] = "noredzone",
  [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = "indirect-tls-seg-refs",
  [anon_sym_noreturn] = "noreturn",
  [anon_sym_norecurse] = "norecurse",
  [anon_sym_willreturn] = "willreturn",
  [anon_sym_nosync] = "nosync",
  [anon_sym_nounwind] = "nounwind",
  [anon_sym_nocallback] = "nocallback",
  [anon_sym_nosanitize_coverage] = "nosanitize_coverage",
  [anon_sym_null_pointer_is_valid] = "null_pointer_is_valid",
  [anon_sym_optforfuzzing] = "optforfuzzing",
  [anon_sym_optnone] = "optnone",
  [anon_sym_optsize] = "optsize",
  [anon_sym_readnone] = "readnone",
  [anon_sym_readonly] = "readonly",
  [anon_sym_writeonly] = "writeonly",
  [anon_sym_argmemonly] = "argmemonly",
  [anon_sym_returns_twice] = "returns_twice",
  [anon_sym_safestack] = "safestack",
  [anon_sym_sanitize_address] = "sanitize_address",
  [anon_sym_sanitize_memory] = "sanitize_memory",
  [anon_sym_sanitize_thread] = "sanitize_thread",
  [anon_sym_sanitize_hwaddress] = "sanitize_hwaddress",
  [anon_sym_sanitize_memtag] = "sanitize_memtag",
  [anon_sym_speculative_load_hardening] = "speculative_load_hardening",
  [anon_sym_speculatable] = "speculatable",
  [anon_sym_ssp] = "ssp",
  [anon_sym_sspstrong] = "sspstrong",
  [anon_sym_sspreq] = "sspreq",
  [anon_sym_strictfp] = "strictfp",
  [anon_sym_nocf_check] = "nocf_check",
  [anon_sym_shadowcallstack] = "shadowcallstack",
  [anon_sym_mustprogress] = "mustprogress",
  [anon_sym_vscale_range] = "vscale_range",
  [anon_sym_preallocated] = "preallocated",
  [anon_sym_zeroext] = "zeroext",
  [anon_sym_signext] = "signext",
  [anon_sym_inreg] = "inreg",
  [anon_sym_byval] = "byval",
  [anon_sym_byref] = "byref",
  [anon_sym_inalloca] = "inalloca",
  [anon_sym_sret] = "sret",
  [anon_sym_elementtype] = "elementtype",
  [anon_sym_noalias] = "noalias",
  [anon_sym_nocapture] = "nocapture",
  [anon_sym_nest] = "nest",
  [anon_sym_returned] = "returned",
  [anon_sym_nonnull] = "nonnull",
  [anon_sym_dereferenceable] = "dereferenceable",
  [anon_sym_dereferenceable_or_null] = "dereferenceable_or_null",
  [anon_sym_swiftself] = "swiftself",
  [anon_sym_swiftasync] = "swiftasync",
  [anon_sym_swifterror] = "swifterror",
  [anon_sym_immarg] = "immarg",
  [anon_sym_noundef] = "noundef",
  [anon_sym_uwtable] = "uwtable",
  [anon_sym_sync] = "sync",
  [anon_sym_async] = "async",
  [anon_sym_memory] = "memory",
  [anon_sym_argmem] = "argmem",
  [anon_sym_inaccessiblemem] = "inaccessiblemem",
  [anon_sym_COLON] = ":",
  [anon_sym_none] = "none",
  [anon_sym_read] = "read",
  [anon_sym_write] = "write",
  [anon_sym_readwrite] = "readwrite",
  [anon_sym_unreachable] = "unreachable",
  [anon_sym_ret] = "ret",
  [anon_sym_br] = "br",
  [anon_sym_resume] = "resume",
  [anon_sym_freeze] = "freeze",
  [anon_sym_indirectbr] = "indirectbr",
  [anon_sym_extractelement] = "extractelement",
  [anon_sym_insertelement] = "insertelement",
  [anon_sym_select] = "select",
  [anon_sym_shufflevector] = "shufflevector",
  [anon_sym_fneg] = "fneg",
  [anon_sym_nsw] = "nsw",
  [anon_sym_nuw] = "nuw",
  [anon_sym_exact] = "exact",
  [anon_sym_disjoint] = "disjoint",
  [anon_sym_switch] = "switch",
  [anon_sym_invoke] = "invoke",
  [anon_sym_to] = "to",
  [anon_sym_unwind] = "unwind",
  [anon_sym_cleanupret] = "cleanupret",
  [anon_sym_from] = "from",
  [anon_sym_catchret] = "catchret",
  [anon_sym_catchswitch] = "catchswitch",
  [anon_sym_catchpad] = "catchpad",
  [anon_sym_cleanuppad] = "cleanuppad",
  [anon_sym_callbr] = "callbr",
  [anon_sym_icmp] = "icmp",
  [anon_sym_fcmp] = "fcmp",
  [anon_sym_nneg] = "nneg",
  [anon_sym_va_arg] = "va_arg",
  [anon_sym_phi] = "phi",
  [anon_sym_landingpad] = "landingpad",
  [anon_sym_cleanup] = "cleanup",
  [anon_sym_tail] = "tail",
  [anon_sym_musttail] = "musttail",
  [anon_sym_notail] = "notail",
  [anon_sym_call] = "call",
  [anon_sym_alloca] = "alloca",
  [anon_sym_load] = "load",
  [anon_sym_atomic] = "atomic",
  [anon_sym_volatile] = "volatile",
  [anon_sym_store] = "store",
  [anon_sym_cmpxchg] = "cmpxchg",
  [anon_sym_atomicrmw] = "atomicrmw",
  [anon_sym_fence] = "fence",
  [anon_sym_getelementptr] = "getelementptr",
  [anon_sym_inbounds] = "inbounds",
  [anon_sym_inrange] = "inrange",
  [anon_sym_extractvalue] = "extractvalue",
  [anon_sym_insertvalue] = "insertvalue",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_null] = "null",
  [anon_sym_undef] = "undef",
  [anon_sym_poison] = "poison",
  [anon_sym_zeroinitializer] = "zeroinitializer",
  [anon_sym_catch] = "catch",
  [anon_sym_filter] = "filter",
  [anon_sym_blockaddress] = "blockaddress",
  [anon_sym_mul] = "mul",
  [anon_sym_urem] = "urem",
  [anon_sym_srem] = "srem",
  [anon_sym_shl] = "shl",
  [anon_sym_udiv] = "udiv",
  [anon_sym_sdiv] = "sdiv",
  [anon_sym_lshr] = "lshr",
  [anon_sym_ashr] = "ashr",
  [anon_sym_fmul] = "fmul",
  [anon_sym_fdiv] = "fdiv",
  [anon_sym_frem] = "frem",
  [anon_sym_xchg] = "xchg",
  [anon_sym_add] = "add",
  [anon_sym_sub] = "sub",
  [anon_sym_and] = "and",
  [anon_sym_nand] = "nand",
  [anon_sym_or] = "or",
  [anon_sym_xor] = "xor",
  [anon_sym_max] = "max",
  [anon_sym_min] = "min",
  [anon_sym_umax] = "umax",
  [anon_sym_umin] = "umin",
  [anon_sym_fadd] = "fadd",
  [anon_sym_fsub] = "fsub",
  [anon_sym_eq] = "eq",
  [anon_sym_ne] = "ne",
  [anon_sym_ugt] = "ugt",
  [anon_sym_uge] = "uge",
  [anon_sym_ult] = "ult",
  [anon_sym_ule] = "ule",
  [anon_sym_sgt] = "sgt",
  [anon_sym_sge] = "sge",
  [anon_sym_slt] = "slt",
  [anon_sym_sle] = "sle",
  [anon_sym_oeq] = "oeq",
  [anon_sym_ogt] = "ogt",
  [anon_sym_oge] = "oge",
  [anon_sym_olt] = "olt",
  [anon_sym_ole] = "ole",
  [anon_sym_one] = "one",
  [anon_sym_ord] = "ord",
  [anon_sym_ueq] = "ueq",
  [anon_sym_une] = "une",
  [anon_sym_uno] = "uno",
  [anon_sym_bitcast] = "bitcast",
  [anon_sym_trunc] = "trunc",
  [anon_sym_zext] = "zext",
  [anon_sym_sext] = "sext",
  [anon_sym_fptrunc] = "fptrunc",
  [anon_sym_fpext] = "fpext",
  [anon_sym_addrspacecast] = "addrspacecast",
  [anon_sym_uitofp] = "uitofp",
  [anon_sym_sitofp] = "sitofp",
  [anon_sym_fptoui] = "fptoui",
  [anon_sym_fptosi] = "fptosi",
  [anon_sym_inttoptr] = "inttoptr",
  [anon_sym_ptrtoint] = "ptrtoint",
  [anon_sym_unordered] = "unordered",
  [anon_sym_monotonic] = "monotonic",
  [anon_sym_acquire] = "acquire",
  [anon_sym_release] = "release",
  [anon_sym_acq_rel] = "acq_rel",
  [anon_sym_seq_cst] = "seq_cst",
  [anon_sym_syncscope] = "syncscope",
  [anon_sym_nnan] = "nnan",
  [anon_sym_ninf] = "ninf",
  [anon_sym_nsz] = "nsz",
  [anon_sym_arcp] = "arcp",
  [anon_sym_contract] = "contract",
  [anon_sym_afn] = "afn",
  [anon_sym_reassoc] = "reassoc",
  [anon_sym_fast] = "fast",
  [anon_sym_within] = "within",
  [anon_sym_caller] = "caller",
  [anon_sym_uselistorder] = "uselistorder",
  [anon_sym_uselistorder_bb] = "uselistorder_bb",
  [anon_sym_module] = "module",
  [anon_sym_asm] = "asm",
  [anon_sym_sideeffect] = "sideeffect",
  [anon_sym_inteldialect] = "inteldialect",
  [anon_sym_type] = "type",
  [anon_sym_externally_initialized] = "externally_initialized",
  [anon_sym_global] = "global",
  [anon_sym_constant] = "constant",
  [anon_sym_alias] = "alias",
  [anon_sym_ifunc] = "ifunc",
  [anon_sym_thread_local] = "thread_local",
  [anon_sym_localdynamic] = "localdynamic",
  [anon_sym_initialexec] = "initialexec",
  [anon_sym_localexec] = "localexec",
  [anon_sym_any] = "any",
  [anon_sym_exactmatch] = "exactmatch",
  [anon_sym_largest] = "largest",
  [anon_sym_nodeduplicate] = "nodeduplicate",
  [anon_sym_samesize] = "samesize",
  [anon_sym_distinct] = "distinct",
  [anon_sym_BANG] = "!",
  [anon_sym_LBRACE2] = "{",
  [anon_sym_LPAREN2] = "(",
  [aux_sym_specialized_md_value_token1] = "specialized_md_value_token1",
  [anon_sym_PIPE] = "|",
  [anon_sym_attributes] = "attributes",
  [sym_module] = "module",
  [sym_metadata_ref] = "metadata_ref",
  [sym_metadata_name] = "metadata_name",
  [sym_number] = "number",
  [sym_var] = "var",
  [sym_target_definition] = "target_definition",
  [sym_target_triple] = "target_triple",
  [sym_data_layout] = "data_layout",
  [sym_source_file_name] = "source_file_name",
  [sym_declare] = "declare",
  [sym_define] = "define",
  [sym_metadata_attachment] = "metadata_attachment",
  [sym_function_header] = "function_header",
  [sym_linkage] = "linkage",
  [sym_linkage_aux] = "linkage_aux",
  [sym_dso_local] = "dso_local",
  [sym_visibility] = "visibility",
  [sym_dll_storage_class] = "dll_storage_class",
  [sym_calling_conv] = "calling_conv",
  [sym_unnamed_addr] = "unnamed_addr",
  [sym_type] = "type",
  [sym_type_keyword] = "type_keyword",
  [sym_struct_type] = "struct_type",
  [sym_packed_struct_type] = "packed_struct_type",
  [sym_array_type] = "array_type",
  [sym_vector_type] = "vector_type",
  [sym_struct_body] = "struct_body",
  [sym_array_vector_body] = "array_vector_body",
  [sym_addrspace] = "addrspace",
  [sym_argument_list] = "argument_list",
  [sym_argument] = "argument",
  [sym_param_or_return_attrs] = "param_or_return_attrs",
  [sym_attribute] = "attribute",
  [sym_attribute_name] = "attribute_name",
  [sym_uwtable] = "uwtable",
  [sym_memory_attribute] = "memory_attribute",
  [sym_memory_attribute_val] = "memory_attribute_val",
  [sym_function_body] = "function_body",
  [sym_instruction] = "instruction",
  [sym__instruction_body] = "_instruction_body",
  [sym_instruction_unreachable] = "instruction_unreachable",
  [sym_instruction_ret] = "instruction_ret",
  [sym_instruction_br] = "instruction_br",
  [sym_instruction_resume] = "instruction_resume",
  [sym_instruction_freeze] = "instruction_freeze",
  [sym_instruction_indirectbr] = "instruction_indirectbr",
  [sym_instruction_extractelement] = "instruction_extractelement",
  [sym_instruction_insertelement] = "instruction_insertelement",
  [sym_instruction_select] = "instruction_select",
  [sym_instruction_shufflevector] = "instruction_shufflevector",
  [sym_instruction_fneg] = "instruction_fneg",
  [sym_instruction_bin_op] = "instruction_bin_op",
  [sym_instruction_switch] = "instruction_switch",
  [sym_instruction_invoke] = "instruction_invoke",
  [sym_instruction_cleanupret] = "instruction_cleanupret",
  [sym_instruction_catchret] = "instruction_catchret",
  [sym_instruction_catchswitch] = "instruction_catchswitch",
  [sym_instruction_catchpad] = "instruction_catchpad",
  [sym_instruction_cleanuppad] = "instruction_cleanuppad",
  [sym_instruction_callbr] = "instruction_callbr",
  [sym_instruction_icmp] = "instruction_icmp",
  [sym_instruction_fcmp] = "instruction_fcmp",
  [sym_instruction_cast] = "instruction_cast",
  [sym_instruction_va_arg] = "instruction_va_arg",
  [sym_instruction_phi] = "instruction_phi",
  [sym_instruction_landingpad] = "instruction_landingpad",
  [sym_instruction_call] = "instruction_call",
  [sym_instruction_alloca] = "instruction_alloca",
  [sym_instruction_load] = "instruction_load",
  [sym_instruction_store] = "instruction_store",
  [sym_instruction_cmpxchg] = "instruction_cmpxchg",
  [sym_instruction_atomicrmw] = "instruction_atomicrmw",
  [sym_instruction_fence] = "instruction_fence",
  [sym_instruction_getelementptr] = "instruction_getelementptr",
  [sym_instruction_extractvalue] = "instruction_extractvalue",
  [sym_instruction_insertvalue] = "instruction_insertvalue",
  [sym__call_part] = "_call_part",
  [sym_type_and_value] = "type_and_value",
  [sym_value] = "value",
  [sym__primitive_value] = "_primitive_value",
  [sym_struct_value] = "struct_value",
  [sym_packed_struct_value] = "packed_struct_value",
  [sym_array_value] = "array_value",
  [sym_vector_value] = "vector_value",
  [sym_metadata_refs] = "metadata_refs",
  [sym_operand_bundles] = "operand_bundles",
  [sym_landingpad_clause] = "landingpad_clause",
  [sym_blockaddress] = "blockaddress",
  [sym_constant_expr] = "constant_expr",
  [sym_constant_cast] = "constant_cast",
  [sym_constant_getelementptr] = "constant_getelementptr",
  [sym_constant_select] = "constant_select",
  [sym_constant_icmp] = "constant_icmp",
  [sym_constant_fcmp] = "constant_fcmp",
  [sym_constant_extractelement] = "constant_extractelement",
  [sym_constant_insertelement] = "constant_insertelement",
  [sym_constant_shufflevector] = "constant_shufflevector",
  [sym_constant_extractvalue] = "constant_extractvalue",
  [sym_constant_insertvalue] = "constant_insertvalue",
  [sym_constant_fneg] = "constant_fneg",
  [sym_constant_bin_op] = "constant_bin_op",
  [sym_bin_op_keyword] = "bin_op_keyword",
  [sym_atomic_bin_op_keyword] = "atomic_bin_op_keyword",
  [sym_icmp_cond] = "icmp_cond",
  [sym_fcmp_cond] = "fcmp_cond",
  [sym_cast_inst] = "cast_inst",
  [sym_atomic_ordering] = "atomic_ordering",
  [sym_alignment] = "alignment",
  [sym__load_store_suffix] = "_load_store_suffix",
  [sym_syncscope] = "syncscope",
  [sym_fast_math] = "fast_math",
  [sym__value_array] = "_value_array",
  [sym__within] = "_within",
  [sym__unwind_label] = "_unwind_label",
  [sym_use_list_order] = "use_list_order",
  [sym_use_list_order_bb] = "use_list_order_bb",
  [sym_module_asm] = "module_asm",
  [sym_inline_asm] = "inline_asm",
  [sym_asm] = "asm",
  [sym_global_type] = "global_type",
  [sym__global_prefix] = "_global_prefix",
  [sym_global_global] = "global_global",
  [sym_alias] = "alias",
  [sym_ifunc] = "ifunc",
  [sym_thread_local] = "thread_local",
  [sym_comdat] = "comdat",
  [sym_global_metadata] = "global_metadata",
  [sym_metadata] = "metadata",
  [sym_metadata_tuple] = "metadata_tuple",
  [sym_specialized_md] = "specialized_md",
  [sym_specialized_md_value] = "specialized_md_value",
  [sym_summary_entry] = "summary_entry",
  [sym_summary_value] = "summary_value",
  [sym_unnamed_attr_grp] = "unnamed_attr_grp",
  [aux_sym_module_repeat1] = "module_repeat1",
  [aux_sym_declare_repeat1] = "declare_repeat1",
  [aux_sym_function_header_repeat1] = "function_header_repeat1",
  [aux_sym_function_header_repeat2] = "function_header_repeat2",
  [aux_sym_function_header_repeat3] = "function_header_repeat3",
  [aux_sym_type_repeat1] = "type_repeat1",
  [aux_sym_type_repeat2] = "type_repeat2",
  [aux_sym_struct_body_repeat1] = "struct_body_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_attribute_repeat1] = "attribute_repeat1",
  [aux_sym_memory_attribute_repeat1] = "memory_attribute_repeat1",
  [aux_sym_function_body_repeat1] = "function_body_repeat1",
  [aux_sym_function_body_repeat2] = "function_body_repeat2",
  [aux_sym_instruction_repeat1] = "instruction_repeat1",
  [aux_sym_instruction_select_repeat1] = "instruction_select_repeat1",
  [aux_sym_instruction_bin_op_repeat1] = "instruction_bin_op_repeat1",
  [aux_sym_instruction_switch_repeat1] = "instruction_switch_repeat1",
  [aux_sym_instruction_callbr_repeat1] = "instruction_callbr_repeat1",
  [aux_sym_instruction_phi_repeat1] = "instruction_phi_repeat1",
  [aux_sym_instruction_landingpad_repeat1] = "instruction_landingpad_repeat1",
  [aux_sym_instruction_alloca_repeat1] = "instruction_alloca_repeat1",
  [aux_sym_instruction_getelementptr_repeat1] = "instruction_getelementptr_repeat1",
  [aux_sym_instruction_extractvalue_repeat1] = "instruction_extractvalue_repeat1",
  [aux_sym_operand_bundles_repeat1] = "operand_bundles_repeat1",
  [aux_sym_constant_bin_op_repeat1] = "constant_bin_op_repeat1",
  [aux_sym_global_global_repeat1] = "global_global_repeat1",
  [aux_sym_metadata_tuple_repeat1] = "metadata_tuple_repeat1",
  [aux_sym_specialized_md_repeat1] = "specialized_md_repeat1",
  [aux_sym_summary_entry_repeat1] = "summary_entry_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_comment] = sym_comment,
  [sym_attr_ref] = sym_attr_ref,
  [sym_comdat_ref] = sym_comdat_ref,
  [sym_global_var] = sym_global_var,
  [sym_local_var] = sym_local_var,
  [sym_label] = sym_label,
  [aux_sym_metadata_ref_token1] = aux_sym_metadata_ref_token1,
  [sym_summary_ref] = sym_summary_ref,
  [sym_string] = sym_string,
  [aux_sym_number_token1] = aux_sym_number_token1,
  [aux_sym_number_token2] = aux_sym_number_token2,
  [sym_float] = sym_float,
  [sym_cstring] = sym_cstring,
  [anon_sym_target] = anon_sym_target,
  [anon_sym_triple] = anon_sym_triple,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_datalayout] = anon_sym_datalayout,
  [anon_sym_source_filename] = anon_sym_source_filename,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_define] = anon_sym_define,
  [anon_sym_no_cfi] = anon_sym_no_cfi,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_internal] = anon_sym_internal,
  [anon_sym_weak] = anon_sym_weak,
  [anon_sym_weak_odr] = anon_sym_weak_odr,
  [anon_sym_linkonce] = anon_sym_linkonce,
  [anon_sym_linkonce_odr] = anon_sym_linkonce_odr,
  [anon_sym_available_externally] = anon_sym_available_externally,
  [anon_sym_appending] = anon_sym_appending,
  [anon_sym_common] = anon_sym_common,
  [anon_sym_extern_weak] = anon_sym_extern_weak,
  [anon_sym_external] = anon_sym_external,
  [anon_sym_dso_local] = anon_sym_dso_local,
  [anon_sym_dso_local_equivalent] = anon_sym_dso_local_equivalent,
  [anon_sym_dso_preemptable] = anon_sym_dso_preemptable,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_hidden] = anon_sym_hidden,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_dllimport] = anon_sym_dllimport,
  [anon_sym_dllexport] = anon_sym_dllexport,
  [anon_sym_ccc] = anon_sym_ccc,
  [anon_sym_fastcc] = anon_sym_fastcc,
  [anon_sym_coldcc] = anon_sym_coldcc,
  [anon_sym_webkit_jscc] = anon_sym_webkit_jscc,
  [anon_sym_anyregcc] = anon_sym_anyregcc,
  [anon_sym_preserve_mostcc] = anon_sym_preserve_mostcc,
  [anon_sym_preserve_allcc] = anon_sym_preserve_allcc,
  [anon_sym_cxx_fast_tlscc] = anon_sym_cxx_fast_tlscc,
  [anon_sym_tailcc] = anon_sym_tailcc,
  [anon_sym_swiftcc] = anon_sym_swiftcc,
  [anon_sym_swifttailcc] = anon_sym_swifttailcc,
  [anon_sym_cfguard_checkcc] = anon_sym_cfguard_checkcc,
  [aux_sym_calling_conv_token1] = aux_sym_calling_conv_token1,
  [aux_sym_calling_conv_token2] = aux_sym_calling_conv_token2,
  [aux_sym_calling_conv_token3] = aux_sym_calling_conv_token3,
  [aux_sym_calling_conv_token4] = aux_sym_calling_conv_token4,
  [aux_sym_calling_conv_token5] = aux_sym_calling_conv_token5,
  [aux_sym_calling_conv_token6] = aux_sym_calling_conv_token6,
  [aux_sym_calling_conv_token7] = aux_sym_calling_conv_token7,
  [aux_sym_calling_conv_token8] = aux_sym_calling_conv_token8,
  [aux_sym_calling_conv_token9] = aux_sym_calling_conv_token9,
  [aux_sym_calling_conv_token10] = aux_sym_calling_conv_token10,
  [anon_sym_ghccc] = anon_sym_ghccc,
  [aux_sym_calling_conv_token11] = aux_sym_calling_conv_token11,
  [aux_sym_calling_conv_token12] = aux_sym_calling_conv_token12,
  [aux_sym_calling_conv_token13] = aux_sym_calling_conv_token13,
  [aux_sym_calling_conv_token14] = aux_sym_calling_conv_token14,
  [anon_sym_cc] = anon_sym_cc,
  [anon_sym_unnamed_addr] = anon_sym_unnamed_addr,
  [anon_sym_local_unnamed_addr] = anon_sym_local_unnamed_addr,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_half] = anon_sym_half,
  [anon_sym_bfloat] = anon_sym_bfloat,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_double] = anon_sym_double,
  [anon_sym_x86_fp80] = anon_sym_x86_fp80,
  [anon_sym_fp128] = anon_sym_fp128,
  [anon_sym_ppc_fp128] = anon_sym_ppc_fp128,
  [anon_sym_label] = anon_sym_label,
  [anon_sym_metadata] = anon_sym_metadata,
  [anon_sym_x86_mmx] = anon_sym_x86_mmx,
  [anon_sym_x86_amx] = anon_sym_x86_amx,
  [anon_sym_token] = anon_sym_token,
  [anon_sym_opaque] = anon_sym_opaque,
  [anon_sym_ptr] = anon_sym_ptr,
  [aux_sym_type_keyword_token1] = aux_sym_type_keyword_token1,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_LT_LBRACE] = anon_sym_LT_LBRACE,
  [anon_sym_RBRACE_GT] = anon_sym_RBRACE_GT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_vscale] = anon_sym_vscale,
  [anon_sym_x] = anon_sym_x,
  [anon_sym_addrspace] = anon_sym_addrspace,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_align] = anon_sym_align,
  [anon_sym_section] = anon_sym_section,
  [anon_sym_partition] = anon_sym_partition,
  [anon_sym_comdat] = anon_sym_comdat,
  [anon_sym_gc] = anon_sym_gc,
  [anon_sym_prefix] = anon_sym_prefix,
  [anon_sym_prologue] = anon_sym_prologue,
  [anon_sym_personality] = anon_sym_personality,
  [anon_sym_alignstack] = anon_sym_alignstack,
  [anon_sym_allocsize] = anon_sym_allocsize,
  [anon_sym_alwaysinline] = anon_sym_alwaysinline,
  [anon_sym_builtin] = anon_sym_builtin,
  [anon_sym_cold] = anon_sym_cold,
  [anon_sym_convergent] = anon_sym_convergent,
  [anon_sym_disable_sanitizer_instrumentation] = anon_sym_disable_sanitizer_instrumentation,
  [anon_sym_hot] = anon_sym_hot,
  [anon_sym_inaccessiblememonly] = anon_sym_inaccessiblememonly,
  [anon_sym_inaccessiblemem_or_argmemonly] = anon_sym_inaccessiblemem_or_argmemonly,
  [anon_sym_inlinehint] = anon_sym_inlinehint,
  [anon_sym_jumptable] = anon_sym_jumptable,
  [anon_sym_minsize] = anon_sym_minsize,
  [anon_sym_naked] = anon_sym_naked,
  [anon_sym_no_DASHjump_DASHtables] = anon_sym_no_DASHjump_DASHtables,
  [anon_sym_nobuiltin] = anon_sym_nobuiltin,
  [anon_sym_noduplicate] = anon_sym_noduplicate,
  [anon_sym_nofree] = anon_sym_nofree,
  [anon_sym_noimplicitfloat] = anon_sym_noimplicitfloat,
  [anon_sym_noinline] = anon_sym_noinline,
  [anon_sym_nomerge] = anon_sym_nomerge,
  [anon_sym_nonlazybind] = anon_sym_nonlazybind,
  [anon_sym_noprofile] = anon_sym_noprofile,
  [anon_sym_noredzone] = anon_sym_noredzone,
  [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = anon_sym_indirect_DASHtls_DASHseg_DASHrefs,
  [anon_sym_noreturn] = anon_sym_noreturn,
  [anon_sym_norecurse] = anon_sym_norecurse,
  [anon_sym_willreturn] = anon_sym_willreturn,
  [anon_sym_nosync] = anon_sym_nosync,
  [anon_sym_nounwind] = anon_sym_nounwind,
  [anon_sym_nocallback] = anon_sym_nocallback,
  [anon_sym_nosanitize_coverage] = anon_sym_nosanitize_coverage,
  [anon_sym_null_pointer_is_valid] = anon_sym_null_pointer_is_valid,
  [anon_sym_optforfuzzing] = anon_sym_optforfuzzing,
  [anon_sym_optnone] = anon_sym_optnone,
  [anon_sym_optsize] = anon_sym_optsize,
  [anon_sym_readnone] = anon_sym_readnone,
  [anon_sym_readonly] = anon_sym_readonly,
  [anon_sym_writeonly] = anon_sym_writeonly,
  [anon_sym_argmemonly] = anon_sym_argmemonly,
  [anon_sym_returns_twice] = anon_sym_returns_twice,
  [anon_sym_safestack] = anon_sym_safestack,
  [anon_sym_sanitize_address] = anon_sym_sanitize_address,
  [anon_sym_sanitize_memory] = anon_sym_sanitize_memory,
  [anon_sym_sanitize_thread] = anon_sym_sanitize_thread,
  [anon_sym_sanitize_hwaddress] = anon_sym_sanitize_hwaddress,
  [anon_sym_sanitize_memtag] = anon_sym_sanitize_memtag,
  [anon_sym_speculative_load_hardening] = anon_sym_speculative_load_hardening,
  [anon_sym_speculatable] = anon_sym_speculatable,
  [anon_sym_ssp] = anon_sym_ssp,
  [anon_sym_sspstrong] = anon_sym_sspstrong,
  [anon_sym_sspreq] = anon_sym_sspreq,
  [anon_sym_strictfp] = anon_sym_strictfp,
  [anon_sym_nocf_check] = anon_sym_nocf_check,
  [anon_sym_shadowcallstack] = anon_sym_shadowcallstack,
  [anon_sym_mustprogress] = anon_sym_mustprogress,
  [anon_sym_vscale_range] = anon_sym_vscale_range,
  [anon_sym_preallocated] = anon_sym_preallocated,
  [anon_sym_zeroext] = anon_sym_zeroext,
  [anon_sym_signext] = anon_sym_signext,
  [anon_sym_inreg] = anon_sym_inreg,
  [anon_sym_byval] = anon_sym_byval,
  [anon_sym_byref] = anon_sym_byref,
  [anon_sym_inalloca] = anon_sym_inalloca,
  [anon_sym_sret] = anon_sym_sret,
  [anon_sym_elementtype] = anon_sym_elementtype,
  [anon_sym_noalias] = anon_sym_noalias,
  [anon_sym_nocapture] = anon_sym_nocapture,
  [anon_sym_nest] = anon_sym_nest,
  [anon_sym_returned] = anon_sym_returned,
  [anon_sym_nonnull] = anon_sym_nonnull,
  [anon_sym_dereferenceable] = anon_sym_dereferenceable,
  [anon_sym_dereferenceable_or_null] = anon_sym_dereferenceable_or_null,
  [anon_sym_swiftself] = anon_sym_swiftself,
  [anon_sym_swiftasync] = anon_sym_swiftasync,
  [anon_sym_swifterror] = anon_sym_swifterror,
  [anon_sym_immarg] = anon_sym_immarg,
  [anon_sym_noundef] = anon_sym_noundef,
  [anon_sym_uwtable] = anon_sym_uwtable,
  [anon_sym_sync] = anon_sym_sync,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_memory] = anon_sym_memory,
  [anon_sym_argmem] = anon_sym_argmem,
  [anon_sym_inaccessiblemem] = anon_sym_inaccessiblemem,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_none] = anon_sym_none,
  [anon_sym_read] = anon_sym_read,
  [anon_sym_write] = anon_sym_write,
  [anon_sym_readwrite] = anon_sym_readwrite,
  [anon_sym_unreachable] = anon_sym_unreachable,
  [anon_sym_ret] = anon_sym_ret,
  [anon_sym_br] = anon_sym_br,
  [anon_sym_resume] = anon_sym_resume,
  [anon_sym_freeze] = anon_sym_freeze,
  [anon_sym_indirectbr] = anon_sym_indirectbr,
  [anon_sym_extractelement] = anon_sym_extractelement,
  [anon_sym_insertelement] = anon_sym_insertelement,
  [anon_sym_select] = anon_sym_select,
  [anon_sym_shufflevector] = anon_sym_shufflevector,
  [anon_sym_fneg] = anon_sym_fneg,
  [anon_sym_nsw] = anon_sym_nsw,
  [anon_sym_nuw] = anon_sym_nuw,
  [anon_sym_exact] = anon_sym_exact,
  [anon_sym_disjoint] = anon_sym_disjoint,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_invoke] = anon_sym_invoke,
  [anon_sym_to] = anon_sym_to,
  [anon_sym_unwind] = anon_sym_unwind,
  [anon_sym_cleanupret] = anon_sym_cleanupret,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_catchret] = anon_sym_catchret,
  [anon_sym_catchswitch] = anon_sym_catchswitch,
  [anon_sym_catchpad] = anon_sym_catchpad,
  [anon_sym_cleanuppad] = anon_sym_cleanuppad,
  [anon_sym_callbr] = anon_sym_callbr,
  [anon_sym_icmp] = anon_sym_icmp,
  [anon_sym_fcmp] = anon_sym_fcmp,
  [anon_sym_nneg] = anon_sym_nneg,
  [anon_sym_va_arg] = anon_sym_va_arg,
  [anon_sym_phi] = anon_sym_phi,
  [anon_sym_landingpad] = anon_sym_landingpad,
  [anon_sym_cleanup] = anon_sym_cleanup,
  [anon_sym_tail] = anon_sym_tail,
  [anon_sym_musttail] = anon_sym_musttail,
  [anon_sym_notail] = anon_sym_notail,
  [anon_sym_call] = anon_sym_call,
  [anon_sym_alloca] = anon_sym_alloca,
  [anon_sym_load] = anon_sym_load,
  [anon_sym_atomic] = anon_sym_atomic,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_store] = anon_sym_store,
  [anon_sym_cmpxchg] = anon_sym_cmpxchg,
  [anon_sym_atomicrmw] = anon_sym_atomicrmw,
  [anon_sym_fence] = anon_sym_fence,
  [anon_sym_getelementptr] = anon_sym_getelementptr,
  [anon_sym_inbounds] = anon_sym_inbounds,
  [anon_sym_inrange] = anon_sym_inrange,
  [anon_sym_extractvalue] = anon_sym_extractvalue,
  [anon_sym_insertvalue] = anon_sym_insertvalue,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_null] = anon_sym_null,
  [anon_sym_undef] = anon_sym_undef,
  [anon_sym_poison] = anon_sym_poison,
  [anon_sym_zeroinitializer] = anon_sym_zeroinitializer,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_filter] = anon_sym_filter,
  [anon_sym_blockaddress] = anon_sym_blockaddress,
  [anon_sym_mul] = anon_sym_mul,
  [anon_sym_urem] = anon_sym_urem,
  [anon_sym_srem] = anon_sym_srem,
  [anon_sym_shl] = anon_sym_shl,
  [anon_sym_udiv] = anon_sym_udiv,
  [anon_sym_sdiv] = anon_sym_sdiv,
  [anon_sym_lshr] = anon_sym_lshr,
  [anon_sym_ashr] = anon_sym_ashr,
  [anon_sym_fmul] = anon_sym_fmul,
  [anon_sym_fdiv] = anon_sym_fdiv,
  [anon_sym_frem] = anon_sym_frem,
  [anon_sym_xchg] = anon_sym_xchg,
  [anon_sym_add] = anon_sym_add,
  [anon_sym_sub] = anon_sym_sub,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_nand] = anon_sym_nand,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_xor] = anon_sym_xor,
  [anon_sym_max] = anon_sym_max,
  [anon_sym_min] = anon_sym_min,
  [anon_sym_umax] = anon_sym_umax,
  [anon_sym_umin] = anon_sym_umin,
  [anon_sym_fadd] = anon_sym_fadd,
  [anon_sym_fsub] = anon_sym_fsub,
  [anon_sym_eq] = anon_sym_eq,
  [anon_sym_ne] = anon_sym_ne,
  [anon_sym_ugt] = anon_sym_ugt,
  [anon_sym_uge] = anon_sym_uge,
  [anon_sym_ult] = anon_sym_ult,
  [anon_sym_ule] = anon_sym_ule,
  [anon_sym_sgt] = anon_sym_sgt,
  [anon_sym_sge] = anon_sym_sge,
  [anon_sym_slt] = anon_sym_slt,
  [anon_sym_sle] = anon_sym_sle,
  [anon_sym_oeq] = anon_sym_oeq,
  [anon_sym_ogt] = anon_sym_ogt,
  [anon_sym_oge] = anon_sym_oge,
  [anon_sym_olt] = anon_sym_olt,
  [anon_sym_ole] = anon_sym_ole,
  [anon_sym_one] = anon_sym_one,
  [anon_sym_ord] = anon_sym_ord,
  [anon_sym_ueq] = anon_sym_ueq,
  [anon_sym_une] = anon_sym_une,
  [anon_sym_uno] = anon_sym_uno,
  [anon_sym_bitcast] = anon_sym_bitcast,
  [anon_sym_trunc] = anon_sym_trunc,
  [anon_sym_zext] = anon_sym_zext,
  [anon_sym_sext] = anon_sym_sext,
  [anon_sym_fptrunc] = anon_sym_fptrunc,
  [anon_sym_fpext] = anon_sym_fpext,
  [anon_sym_addrspacecast] = anon_sym_addrspacecast,
  [anon_sym_uitofp] = anon_sym_uitofp,
  [anon_sym_sitofp] = anon_sym_sitofp,
  [anon_sym_fptoui] = anon_sym_fptoui,
  [anon_sym_fptosi] = anon_sym_fptosi,
  [anon_sym_inttoptr] = anon_sym_inttoptr,
  [anon_sym_ptrtoint] = anon_sym_ptrtoint,
  [anon_sym_unordered] = anon_sym_unordered,
  [anon_sym_monotonic] = anon_sym_monotonic,
  [anon_sym_acquire] = anon_sym_acquire,
  [anon_sym_release] = anon_sym_release,
  [anon_sym_acq_rel] = anon_sym_acq_rel,
  [anon_sym_seq_cst] = anon_sym_seq_cst,
  [anon_sym_syncscope] = anon_sym_syncscope,
  [anon_sym_nnan] = anon_sym_nnan,
  [anon_sym_ninf] = anon_sym_ninf,
  [anon_sym_nsz] = anon_sym_nsz,
  [anon_sym_arcp] = anon_sym_arcp,
  [anon_sym_contract] = anon_sym_contract,
  [anon_sym_afn] = anon_sym_afn,
  [anon_sym_reassoc] = anon_sym_reassoc,
  [anon_sym_fast] = anon_sym_fast,
  [anon_sym_within] = anon_sym_within,
  [anon_sym_caller] = anon_sym_caller,
  [anon_sym_uselistorder] = anon_sym_uselistorder,
  [anon_sym_uselistorder_bb] = anon_sym_uselistorder_bb,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_asm] = anon_sym_asm,
  [anon_sym_sideeffect] = anon_sym_sideeffect,
  [anon_sym_inteldialect] = anon_sym_inteldialect,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_externally_initialized] = anon_sym_externally_initialized,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_constant] = anon_sym_constant,
  [anon_sym_alias] = anon_sym_alias,
  [anon_sym_ifunc] = anon_sym_ifunc,
  [anon_sym_thread_local] = anon_sym_thread_local,
  [anon_sym_localdynamic] = anon_sym_localdynamic,
  [anon_sym_initialexec] = anon_sym_initialexec,
  [anon_sym_localexec] = anon_sym_localexec,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_exactmatch] = anon_sym_exactmatch,
  [anon_sym_largest] = anon_sym_largest,
  [anon_sym_nodeduplicate] = anon_sym_nodeduplicate,
  [anon_sym_samesize] = anon_sym_samesize,
  [anon_sym_distinct] = anon_sym_distinct,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_LBRACE2] = anon_sym_LBRACE,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [aux_sym_specialized_md_value_token1] = aux_sym_specialized_md_value_token1,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_attributes] = anon_sym_attributes,
  [sym_module] = sym_module,
  [sym_metadata_ref] = sym_metadata_ref,
  [sym_metadata_name] = sym_metadata_name,
  [sym_number] = sym_number,
  [sym_var] = sym_var,
  [sym_target_definition] = sym_target_definition,
  [sym_target_triple] = sym_target_triple,
  [sym_data_layout] = sym_data_layout,
  [sym_source_file_name] = sym_source_file_name,
  [sym_declare] = sym_declare,
  [sym_define] = sym_define,
  [sym_metadata_attachment] = sym_metadata_attachment,
  [sym_function_header] = sym_function_header,
  [sym_linkage] = sym_linkage,
  [sym_linkage_aux] = sym_linkage_aux,
  [sym_dso_local] = sym_dso_local,
  [sym_visibility] = sym_visibility,
  [sym_dll_storage_class] = sym_dll_storage_class,
  [sym_calling_conv] = sym_calling_conv,
  [sym_unnamed_addr] = sym_unnamed_addr,
  [sym_type] = sym_type,
  [sym_type_keyword] = sym_type_keyword,
  [sym_struct_type] = sym_struct_type,
  [sym_packed_struct_type] = sym_packed_struct_type,
  [sym_array_type] = sym_array_type,
  [sym_vector_type] = sym_vector_type,
  [sym_struct_body] = sym_struct_body,
  [sym_array_vector_body] = sym_array_vector_body,
  [sym_addrspace] = sym_addrspace,
  [sym_argument_list] = sym_argument_list,
  [sym_argument] = sym_argument,
  [sym_param_or_return_attrs] = sym_param_or_return_attrs,
  [sym_attribute] = sym_attribute,
  [sym_attribute_name] = sym_attribute_name,
  [sym_uwtable] = sym_uwtable,
  [sym_memory_attribute] = sym_memory_attribute,
  [sym_memory_attribute_val] = sym_memory_attribute_val,
  [sym_function_body] = sym_function_body,
  [sym_instruction] = sym_instruction,
  [sym__instruction_body] = sym__instruction_body,
  [sym_instruction_unreachable] = sym_instruction_unreachable,
  [sym_instruction_ret] = sym_instruction_ret,
  [sym_instruction_br] = sym_instruction_br,
  [sym_instruction_resume] = sym_instruction_resume,
  [sym_instruction_freeze] = sym_instruction_freeze,
  [sym_instruction_indirectbr] = sym_instruction_indirectbr,
  [sym_instruction_extractelement] = sym_instruction_extractelement,
  [sym_instruction_insertelement] = sym_instruction_insertelement,
  [sym_instruction_select] = sym_instruction_select,
  [sym_instruction_shufflevector] = sym_instruction_shufflevector,
  [sym_instruction_fneg] = sym_instruction_fneg,
  [sym_instruction_bin_op] = sym_instruction_bin_op,
  [sym_instruction_switch] = sym_instruction_switch,
  [sym_instruction_invoke] = sym_instruction_invoke,
  [sym_instruction_cleanupret] = sym_instruction_cleanupret,
  [sym_instruction_catchret] = sym_instruction_catchret,
  [sym_instruction_catchswitch] = sym_instruction_catchswitch,
  [sym_instruction_catchpad] = sym_instruction_catchpad,
  [sym_instruction_cleanuppad] = sym_instruction_cleanuppad,
  [sym_instruction_callbr] = sym_instruction_callbr,
  [sym_instruction_icmp] = sym_instruction_icmp,
  [sym_instruction_fcmp] = sym_instruction_fcmp,
  [sym_instruction_cast] = sym_instruction_cast,
  [sym_instruction_va_arg] = sym_instruction_va_arg,
  [sym_instruction_phi] = sym_instruction_phi,
  [sym_instruction_landingpad] = sym_instruction_landingpad,
  [sym_instruction_call] = sym_instruction_call,
  [sym_instruction_alloca] = sym_instruction_alloca,
  [sym_instruction_load] = sym_instruction_load,
  [sym_instruction_store] = sym_instruction_store,
  [sym_instruction_cmpxchg] = sym_instruction_cmpxchg,
  [sym_instruction_atomicrmw] = sym_instruction_atomicrmw,
  [sym_instruction_fence] = sym_instruction_fence,
  [sym_instruction_getelementptr] = sym_instruction_getelementptr,
  [sym_instruction_extractvalue] = sym_instruction_extractvalue,
  [sym_instruction_insertvalue] = sym_instruction_insertvalue,
  [sym__call_part] = sym__call_part,
  [sym_type_and_value] = sym_type_and_value,
  [sym_value] = sym_value,
  [sym__primitive_value] = sym__primitive_value,
  [sym_struct_value] = sym_struct_value,
  [sym_packed_struct_value] = sym_packed_struct_value,
  [sym_array_value] = sym_array_value,
  [sym_vector_value] = sym_vector_value,
  [sym_metadata_refs] = sym_metadata_refs,
  [sym_operand_bundles] = sym_operand_bundles,
  [sym_landingpad_clause] = sym_landingpad_clause,
  [sym_blockaddress] = sym_blockaddress,
  [sym_constant_expr] = sym_constant_expr,
  [sym_constant_cast] = sym_constant_cast,
  [sym_constant_getelementptr] = sym_constant_getelementptr,
  [sym_constant_select] = sym_constant_select,
  [sym_constant_icmp] = sym_constant_icmp,
  [sym_constant_fcmp] = sym_constant_fcmp,
  [sym_constant_extractelement] = sym_constant_extractelement,
  [sym_constant_insertelement] = sym_constant_insertelement,
  [sym_constant_shufflevector] = sym_constant_shufflevector,
  [sym_constant_extractvalue] = sym_constant_extractvalue,
  [sym_constant_insertvalue] = sym_constant_insertvalue,
  [sym_constant_fneg] = sym_constant_fneg,
  [sym_constant_bin_op] = sym_constant_bin_op,
  [sym_bin_op_keyword] = sym_bin_op_keyword,
  [sym_atomic_bin_op_keyword] = sym_atomic_bin_op_keyword,
  [sym_icmp_cond] = sym_icmp_cond,
  [sym_fcmp_cond] = sym_fcmp_cond,
  [sym_cast_inst] = sym_cast_inst,
  [sym_atomic_ordering] = sym_atomic_ordering,
  [sym_alignment] = sym_alignment,
  [sym__load_store_suffix] = sym__load_store_suffix,
  [sym_syncscope] = sym_syncscope,
  [sym_fast_math] = sym_fast_math,
  [sym__value_array] = sym__value_array,
  [sym__within] = sym__within,
  [sym__unwind_label] = sym__unwind_label,
  [sym_use_list_order] = sym_use_list_order,
  [sym_use_list_order_bb] = sym_use_list_order_bb,
  [sym_module_asm] = sym_module_asm,
  [sym_inline_asm] = sym_inline_asm,
  [sym_asm] = sym_asm,
  [sym_global_type] = sym_global_type,
  [sym__global_prefix] = sym__global_prefix,
  [sym_global_global] = sym_global_global,
  [sym_alias] = sym_alias,
  [sym_ifunc] = sym_ifunc,
  [sym_thread_local] = sym_thread_local,
  [sym_comdat] = sym_comdat,
  [sym_global_metadata] = sym_global_metadata,
  [sym_metadata] = sym_metadata,
  [sym_metadata_tuple] = sym_metadata_tuple,
  [sym_specialized_md] = sym_specialized_md,
  [sym_specialized_md_value] = sym_specialized_md_value,
  [sym_summary_entry] = sym_summary_entry,
  [sym_summary_value] = sym_summary_value,
  [sym_unnamed_attr_grp] = sym_unnamed_attr_grp,
  [aux_sym_module_repeat1] = aux_sym_module_repeat1,
  [aux_sym_declare_repeat1] = aux_sym_declare_repeat1,
  [aux_sym_function_header_repeat1] = aux_sym_function_header_repeat1,
  [aux_sym_function_header_repeat2] = aux_sym_function_header_repeat2,
  [aux_sym_function_header_repeat3] = aux_sym_function_header_repeat3,
  [aux_sym_type_repeat1] = aux_sym_type_repeat1,
  [aux_sym_type_repeat2] = aux_sym_type_repeat2,
  [aux_sym_struct_body_repeat1] = aux_sym_struct_body_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_attribute_repeat1] = aux_sym_attribute_repeat1,
  [aux_sym_memory_attribute_repeat1] = aux_sym_memory_attribute_repeat1,
  [aux_sym_function_body_repeat1] = aux_sym_function_body_repeat1,
  [aux_sym_function_body_repeat2] = aux_sym_function_body_repeat2,
  [aux_sym_instruction_repeat1] = aux_sym_instruction_repeat1,
  [aux_sym_instruction_select_repeat1] = aux_sym_instruction_select_repeat1,
  [aux_sym_instruction_bin_op_repeat1] = aux_sym_instruction_bin_op_repeat1,
  [aux_sym_instruction_switch_repeat1] = aux_sym_instruction_switch_repeat1,
  [aux_sym_instruction_callbr_repeat1] = aux_sym_instruction_callbr_repeat1,
  [aux_sym_instruction_phi_repeat1] = aux_sym_instruction_phi_repeat1,
  [aux_sym_instruction_landingpad_repeat1] = aux_sym_instruction_landingpad_repeat1,
  [aux_sym_instruction_alloca_repeat1] = aux_sym_instruction_alloca_repeat1,
  [aux_sym_instruction_getelementptr_repeat1] = aux_sym_instruction_getelementptr_repeat1,
  [aux_sym_instruction_extractvalue_repeat1] = aux_sym_instruction_extractvalue_repeat1,
  [aux_sym_operand_bundles_repeat1] = aux_sym_operand_bundles_repeat1,
  [aux_sym_constant_bin_op_repeat1] = aux_sym_constant_bin_op_repeat1,
  [aux_sym_global_global_repeat1] = aux_sym_global_global_repeat1,
  [aux_sym_metadata_tuple_repeat1] = aux_sym_metadata_tuple_repeat1,
  [aux_sym_specialized_md_repeat1] = aux_sym_specialized_md_repeat1,
  [aux_sym_summary_entry_repeat1] = aux_sym_summary_entry_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_attr_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_comdat_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_global_var] = {
    .visible = true,
    .named = true,
  },
  [sym_local_var] = {
    .visible = true,
    .named = true,
  },
  [sym_label] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_metadata_ref_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_summary_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_number_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_number_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_cstring] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_triple] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_datalayout] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_source_filename] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_define] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_no_cfi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_internal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_weak] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_weak_odr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_linkonce] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_linkonce_odr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_available_externally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_appending] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_common] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern_weak] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_external] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dso_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dso_local_equivalent] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dso_preemptable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hidden] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dllimport] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dllexport] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ccc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fastcc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_coldcc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_webkit_jscc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_anyregcc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_preserve_mostcc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_preserve_allcc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cxx_fast_tlscc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_tailcc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_swiftcc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_swifttailcc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cfguard_checkcc] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_calling_conv_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token4] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token5] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token6] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token7] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token8] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token9] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token10] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_ghccc] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_calling_conv_token11] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token12] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token13] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_conv_token14] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_cc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unnamed_addr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local_unnamed_addr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_half] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bfloat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_double] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_x86_fp80] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fp128] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ppc_fp128] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_label] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_metadata] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_x86_mmx] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_x86_amx] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_token] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_opaque] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ptr] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_type_keyword_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_vscale] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_x] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_addrspace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_align] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_section] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_partition] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_comdat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_prefix] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_prologue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_personality] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignstack] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_allocsize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alwaysinline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_builtin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cold] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_convergent] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_disable_sanitizer_instrumentation] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hot] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inaccessiblememonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inaccessiblemem_or_argmemonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inlinehint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_jumptable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_minsize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_naked] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_no_DASHjump_DASHtables] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nobuiltin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noduplicate] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nofree] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noimplicitfloat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noinline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nomerge] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonlazybind] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noprofile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noredzone] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_norecurse] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_willreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nosync] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nounwind] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nocallback] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nosanitize_coverage] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_null_pointer_is_valid] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_optforfuzzing] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_optnone] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_optsize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readnone] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_writeonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_argmemonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_returns_twice] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_safestack] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sanitize_address] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sanitize_memory] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sanitize_thread] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sanitize_hwaddress] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sanitize_memtag] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_speculative_load_hardening] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_speculatable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ssp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sspstrong] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sspreq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_strictfp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nocf_check] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shadowcallstack] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mustprogress] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_vscale_range] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_preallocated] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_zeroext] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signext] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inreg] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_byval] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_byref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inalloca] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sret] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elementtype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noalias] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nocapture] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nest] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_returned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonnull] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dereferenceable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dereferenceable_or_null] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_swiftself] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_swiftasync] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_swifterror] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_immarg] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noundef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uwtable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sync] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_memory] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_argmem] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inaccessiblemem] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_none] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_read] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_write] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readwrite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unreachable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ret] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_br] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_resume] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_freeze] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_indirectbr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extractelement] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_insertelement] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_select] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shufflevector] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fneg] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nsw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nuw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exact] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_disjoint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_invoke] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_to] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unwind] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cleanupret] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catchret] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catchswitch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catchpad] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cleanuppad] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_callbr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_icmp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fcmp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nneg] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_va_arg] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_phi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_landingpad] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cleanup] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_tail] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_musttail] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_notail] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_call] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alloca] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_load] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_atomic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_store] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cmpxchg] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_atomicrmw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fence] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_getelementptr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inbounds] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inrange] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extractvalue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_insertvalue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_null] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_undef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_poison] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_zeroinitializer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_filter] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_blockaddress] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mul] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_urem] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_srem] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_udiv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sdiv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lshr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ashr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fmul] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fdiv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_frem] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xchg] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_add] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sub] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_max] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_min] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_umax] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_umin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fadd] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fsub] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ne] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ugt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uge] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ult] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ule] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sgt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sge] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_slt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sle] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_oeq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ogt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_oge] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_olt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ole] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_one] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ord] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ueq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_une] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uno] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bitcast] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_trunc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_zext] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sext] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fptrunc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fpext] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_addrspacecast] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uitofp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sitofp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fptoui] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fptosi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inttoptr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ptrtoint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unordered] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_monotonic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_acquire] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_release] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_acq_rel] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_seq_cst] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_syncscope] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nnan] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ninf] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nsz] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_arcp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_contract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_afn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_reassoc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fast] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_within] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_caller] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uselistorder] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uselistorder_bb] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sideeffect] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inteldialect] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_externally_initialized] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constant] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alias] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ifunc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_thread_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_localdynamic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_initialexec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_localexec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exactmatch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_largest] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nodeduplicate] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_samesize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_distinct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_specialized_md_value_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_attributes] = {
    .visible = true,
    .named = false,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_metadata_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_metadata_name] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_var] = {
    .visible = true,
    .named = true,
  },
  [sym_target_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_target_triple] = {
    .visible = true,
    .named = true,
  },
  [sym_data_layout] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file_name] = {
    .visible = true,
    .named = true,
  },
  [sym_declare] = {
    .visible = true,
    .named = true,
  },
  [sym_define] = {
    .visible = true,
    .named = true,
  },
  [sym_metadata_attachment] = {
    .visible = true,
    .named = true,
  },
  [sym_function_header] = {
    .visible = true,
    .named = true,
  },
  [sym_linkage] = {
    .visible = true,
    .named = true,
  },
  [sym_linkage_aux] = {
    .visible = true,
    .named = true,
  },
  [sym_dso_local] = {
    .visible = true,
    .named = true,
  },
  [sym_visibility] = {
    .visible = true,
    .named = true,
  },
  [sym_dll_storage_class] = {
    .visible = true,
    .named = true,
  },
  [sym_calling_conv] = {
    .visible = true,
    .named = true,
  },
  [sym_unnamed_addr] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_keyword] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_type] = {
    .visible = true,
    .named = true,
  },
  [sym_packed_struct_type] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_vector_type] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_body] = {
    .visible = true,
    .named = true,
  },
  [sym_array_vector_body] = {
    .visible = true,
    .named = true,
  },
  [sym_addrspace] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_param_or_return_attrs] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_name] = {
    .visible = true,
    .named = true,
  },
  [sym_uwtable] = {
    .visible = true,
    .named = true,
  },
  [sym_memory_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_memory_attribute_val] = {
    .visible = true,
    .named = true,
  },
  [sym_function_body] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction] = {
    .visible = true,
    .named = true,
  },
  [sym__instruction_body] = {
    .visible = false,
    .named = true,
  },
  [sym_instruction_unreachable] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_ret] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_br] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_resume] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_freeze] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_indirectbr] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_extractelement] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_insertelement] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_select] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_shufflevector] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_fneg] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_bin_op] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_switch] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_invoke] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_cleanupret] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_catchret] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_catchswitch] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_catchpad] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_cleanuppad] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_callbr] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_icmp] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_fcmp] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_cast] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_va_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_phi] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_landingpad] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_call] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_alloca] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_load] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_store] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_cmpxchg] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_atomicrmw] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_fence] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_getelementptr] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_extractvalue] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction_insertvalue] = {
    .visible = true,
    .named = true,
  },
  [sym__call_part] = {
    .visible = false,
    .named = true,
  },
  [sym_type_and_value] = {
    .visible = true,
    .named = true,
  },
  [sym_value] = {
    .visible = true,
    .named = true,
  },
  [sym__primitive_value] = {
    .visible = false,
    .named = true,
  },
  [sym_struct_value] = {
    .visible = true,
    .named = true,
  },
  [sym_packed_struct_value] = {
    .visible = true,
    .named = true,
  },
  [sym_array_value] = {
    .visible = true,
    .named = true,
  },
  [sym_vector_value] = {
    .visible = true,
    .named = true,
  },
  [sym_metadata_refs] = {
    .visible = true,
    .named = true,
  },
  [sym_operand_bundles] = {
    .visible = true,
    .named = true,
  },
  [sym_landingpad_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_blockaddress] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_cast] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_getelementptr] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_select] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_icmp] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_fcmp] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_extractelement] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_insertelement] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_shufflevector] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_extractvalue] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_insertvalue] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_fneg] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_bin_op] = {
    .visible = true,
    .named = true,
  },
  [sym_bin_op_keyword] = {
    .visible = true,
    .named = true,
  },
  [sym_atomic_bin_op_keyword] = {
    .visible = true,
    .named = true,
  },
  [sym_icmp_cond] = {
    .visible = true,
    .named = true,
  },
  [sym_fcmp_cond] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_inst] = {
    .visible = true,
    .named = true,
  },
  [sym_atomic_ordering] = {
    .visible = true,
    .named = true,
  },
  [sym_alignment] = {
    .visible = true,
    .named = true,
  },
  [sym__load_store_suffix] = {
    .visible = false,
    .named = true,
  },
  [sym_syncscope] = {
    .visible = true,
    .named = true,
  },
  [sym_fast_math] = {
    .visible = true,
    .named = true,
  },
  [sym__value_array] = {
    .visible = false,
    .named = true,
  },
  [sym__within] = {
    .visible = false,
    .named = true,
  },
  [sym__unwind_label] = {
    .visible = false,
    .named = true,
  },
  [sym_use_list_order] = {
    .visible = true,
    .named = true,
  },
  [sym_use_list_order_bb] = {
    .visible = true,
    .named = true,
  },
  [sym_module_asm] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_asm] = {
    .visible = true,
    .named = true,
  },
  [sym_asm] = {
    .visible = true,
    .named = true,
  },
  [sym_global_type] = {
    .visible = true,
    .named = true,
  },
  [sym__global_prefix] = {
    .visible = false,
    .named = true,
  },
  [sym_global_global] = {
    .visible = true,
    .named = true,
  },
  [sym_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_ifunc] = {
    .visible = true,
    .named = true,
  },
  [sym_thread_local] = {
    .visible = true,
    .named = true,
  },
  [sym_comdat] = {
    .visible = true,
    .named = true,
  },
  [sym_global_metadata] = {
    .visible = true,
    .named = true,
  },
  [sym_metadata] = {
    .visible = true,
    .named = true,
  },
  [sym_metadata_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_specialized_md] = {
    .visible = true,
    .named = true,
  },
  [sym_specialized_md_value] = {
    .visible = true,
    .named = true,
  },
  [sym_summary_entry] = {
    .visible = true,
    .named = true,
  },
  [sym_summary_value] = {
    .visible = true,
    .named = true,
  },
  [sym_unnamed_attr_grp] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_module_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declare_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_header_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_header_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_header_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_memory_attribute_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_body_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_instruction_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_instruction_select_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_instruction_bin_op_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_instruction_switch_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_instruction_callbr_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_instruction_phi_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_instruction_landingpad_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_instruction_alloca_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_instruction_getelementptr_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_instruction_extractvalue_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_operand_bundles_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constant_bin_op_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_global_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_metadata_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_specialized_md_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_summary_entry_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_arguments = 1,
  field_body = 2,
  field_callee = 3,
  field_inst_name = 4,
  field_name = 5,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_callee] = "callee",
  [field_inst_name] = "inst_name",
  [field_name] = "name",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 2},
  [3] = {.index = 3, .length = 1},
  [4] = {.index = 4, .length = 1},
  [5] = {.index = 5, .length = 1},
  [6] = {.index = 6, .length = 2},
  [7] = {.index = 8, .length = 3},
  [8] = {.index = 11, .length = 2},
  [9] = {.index = 13, .length = 3},
  [10] = {.index = 16, .length = 3},
  [11] = {.index = 19, .length = 2},
  [12] = {.index = 21, .length = 2},
  [13] = {.index = 23, .length = 3},
  [14] = {.index = 26, .length = 2},
  [15] = {.index = 28, .length = 2},
  [16] = {.index = 30, .length = 2},
  [17] = {.index = 32, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_body, 2},
  [1] =
    {field_arguments, 2},
    {field_name, 1},
  [3] =
    {field_inst_name, 0},
  [4] =
    {field_body, 3},
  [5] =
    {field_name, 2},
  [6] =
    {field_arguments, 3},
    {field_name, 2},
  [8] =
    {field_arguments, 1, .inherited = true},
    {field_callee, 1, .inherited = true},
    {field_inst_name, 0},
  [11] =
    {field_arguments, 4},
    {field_name, 3},
  [13] =
    {field_arguments, 2, .inherited = true},
    {field_callee, 2, .inherited = true},
    {field_inst_name, 1},
  [16] =
    {field_arguments, 2, .inherited = true},
    {field_callee, 2, .inherited = true},
    {field_inst_name, 0},
  [19] =
    {field_arguments, 5},
    {field_name, 4},
  [21] =
    {field_arguments, 2},
    {field_callee, 1},
  [23] =
    {field_arguments, 3, .inherited = true},
    {field_callee, 3, .inherited = true},
    {field_inst_name, 1},
  [26] =
    {field_arguments, 6},
    {field_name, 5},
  [28] =
    {field_arguments, 3},
    {field_callee, 2},
  [30] =
    {field_arguments, 4},
    {field_callee, 3},
  [32] =
    {field_arguments, 5},
    {field_callee, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 2,
  [5] = 3,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 3,
  [14] = 14,
  [15] = 2,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 6,
  [31] = 8,
  [32] = 7,
  [33] = 10,
  [34] = 9,
  [35] = 11,
  [36] = 18,
  [37] = 22,
  [38] = 23,
  [39] = 14,
  [40] = 16,
  [41] = 17,
  [42] = 12,
  [43] = 19,
  [44] = 21,
  [45] = 20,
  [46] = 25,
  [47] = 24,
  [48] = 3,
  [49] = 3,
  [50] = 27,
  [51] = 29,
  [52] = 2,
  [53] = 28,
  [54] = 26,
  [55] = 2,
  [56] = 3,
  [57] = 2,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 8,
  [62] = 6,
  [63] = 7,
  [64] = 9,
  [65] = 10,
  [66] = 25,
  [67] = 24,
  [68] = 11,
  [69] = 21,
  [70] = 23,
  [71] = 12,
  [72] = 19,
  [73] = 14,
  [74] = 17,
  [75] = 18,
  [76] = 22,
  [77] = 16,
  [78] = 20,
  [79] = 29,
  [80] = 26,
  [81] = 27,
  [82] = 28,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 83,
  [128] = 100,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 84,
  [138] = 113,
  [139] = 85,
  [140] = 124,
  [141] = 119,
  [142] = 109,
  [143] = 94,
  [144] = 121,
  [145] = 134,
  [146] = 120,
  [147] = 95,
  [148] = 116,
  [149] = 93,
  [150] = 122,
  [151] = 151,
  [152] = 133,
  [153] = 108,
  [154] = 131,
  [155] = 106,
  [156] = 103,
  [157] = 130,
  [158] = 129,
  [159] = 104,
  [160] = 135,
  [161] = 126,
  [162] = 132,
  [163] = 112,
  [164] = 92,
  [165] = 89,
  [166] = 98,
  [167] = 102,
  [168] = 97,
  [169] = 96,
  [170] = 88,
  [171] = 86,
  [172] = 136,
  [173] = 115,
  [174] = 118,
  [175] = 87,
  [176] = 105,
  [177] = 117,
  [178] = 110,
  [179] = 107,
  [180] = 91,
  [181] = 101,
  [182] = 123,
  [183] = 99,
  [184] = 111,
  [185] = 90,
  [186] = 114,
  [187] = 125,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 204,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 206,
  [216] = 211,
  [217] = 217,
  [218] = 218,
  [219] = 210,
  [220] = 220,
  [221] = 24,
  [222] = 222,
  [223] = 208,
  [224] = 21,
  [225] = 225,
  [226] = 203,
  [227] = 25,
  [228] = 228,
  [229] = 207,
  [230] = 202,
  [231] = 231,
  [232] = 232,
  [233] = 151,
  [234] = 234,
  [235] = 3,
  [236] = 236,
  [237] = 2,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 151,
  [247] = 247,
  [248] = 248,
  [249] = 3,
  [250] = 2,
  [251] = 251,
  [252] = 252,
  [253] = 151,
  [254] = 254,
  [255] = 255,
  [256] = 8,
  [257] = 26,
  [258] = 11,
  [259] = 7,
  [260] = 6,
  [261] = 9,
  [262] = 14,
  [263] = 203,
  [264] = 17,
  [265] = 22,
  [266] = 202,
  [267] = 23,
  [268] = 206,
  [269] = 208,
  [270] = 20,
  [271] = 12,
  [272] = 25,
  [273] = 21,
  [274] = 211,
  [275] = 18,
  [276] = 16,
  [277] = 10,
  [278] = 207,
  [279] = 210,
  [280] = 24,
  [281] = 19,
  [282] = 2,
  [283] = 28,
  [284] = 27,
  [285] = 6,
  [286] = 8,
  [287] = 7,
  [288] = 29,
  [289] = 10,
  [290] = 9,
  [291] = 3,
  [292] = 2,
  [293] = 11,
  [294] = 26,
  [295] = 3,
  [296] = 2,
  [297] = 297,
  [298] = 25,
  [299] = 23,
  [300] = 20,
  [301] = 14,
  [302] = 100,
  [303] = 21,
  [304] = 83,
  [305] = 22,
  [306] = 16,
  [307] = 19,
  [308] = 12,
  [309] = 18,
  [310] = 17,
  [311] = 24,
  [312] = 111,
  [313] = 85,
  [314] = 96,
  [315] = 95,
  [316] = 94,
  [317] = 120,
  [318] = 118,
  [319] = 117,
  [320] = 113,
  [321] = 124,
  [322] = 109,
  [323] = 119,
  [324] = 84,
  [325] = 112,
  [326] = 134,
  [327] = 121,
  [328] = 122,
  [329] = 88,
  [330] = 99,
  [331] = 97,
  [332] = 114,
  [333] = 125,
  [334] = 102,
  [335] = 123,
  [336] = 104,
  [337] = 103,
  [338] = 135,
  [339] = 126,
  [340] = 110,
  [341] = 108,
  [342] = 106,
  [343] = 98,
  [344] = 116,
  [345] = 129,
  [346] = 130,
  [347] = 86,
  [348] = 89,
  [349] = 93,
  [350] = 101,
  [351] = 131,
  [352] = 133,
  [353] = 105,
  [354] = 91,
  [355] = 90,
  [356] = 107,
  [357] = 115,
  [358] = 132,
  [359] = 87,
  [360] = 136,
  [361] = 92,
  [362] = 26,
  [363] = 29,
  [364] = 28,
  [365] = 27,
  [366] = 366,
  [367] = 367,
  [368] = 368,
  [369] = 369,
  [370] = 3,
  [371] = 371,
  [372] = 2,
  [373] = 373,
  [374] = 371,
  [375] = 373,
  [376] = 3,
  [377] = 377,
  [378] = 378,
  [379] = 378,
  [380] = 377,
  [381] = 2,
  [382] = 3,
  [383] = 3,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 2,
  [393] = 393,
  [394] = 394,
  [395] = 395,
  [396] = 393,
  [397] = 397,
  [398] = 395,
  [399] = 399,
  [400] = 394,
  [401] = 397,
  [402] = 399,
  [403] = 403,
  [404] = 404,
  [405] = 200,
  [406] = 406,
  [407] = 407,
  [408] = 408,
  [409] = 406,
  [410] = 410,
  [411] = 411,
  [412] = 407,
  [413] = 413,
  [414] = 404,
  [415] = 199,
  [416] = 416,
  [417] = 213,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 422,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 225,
  [434] = 209,
  [435] = 435,
  [436] = 231,
  [437] = 437,
  [438] = 438,
  [439] = 232,
  [440] = 440,
  [441] = 198,
  [442] = 442,
  [443] = 443,
  [444] = 444,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 212,
  [453] = 453,
  [454] = 454,
  [455] = 455,
  [456] = 456,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 466,
  [467] = 467,
  [468] = 228,
  [469] = 469,
  [470] = 222,
  [471] = 471,
  [472] = 472,
  [473] = 473,
  [474] = 214,
  [475] = 220,
  [476] = 218,
  [477] = 217,
  [478] = 478,
  [479] = 479,
  [480] = 480,
  [481] = 411,
  [482] = 403,
  [483] = 208,
  [484] = 408,
  [485] = 206,
  [486] = 413,
  [487] = 203,
  [488] = 410,
  [489] = 210,
  [490] = 490,
  [491] = 151,
  [492] = 207,
  [493] = 211,
  [494] = 202,
  [495] = 242,
  [496] = 496,
  [497] = 497,
  [498] = 428,
  [499] = 430,
  [500] = 432,
  [501] = 431,
  [502] = 429,
  [503] = 196,
  [504] = 193,
  [505] = 192,
  [506] = 191,
  [507] = 190,
  [508] = 194,
  [509] = 195,
  [510] = 189,
  [511] = 448,
  [512] = 451,
  [513] = 198,
  [514] = 446,
  [515] = 458,
  [516] = 440,
  [517] = 437,
  [518] = 456,
  [519] = 453,
  [520] = 457,
  [521] = 463,
  [522] = 449,
  [523] = 462,
  [524] = 461,
  [525] = 450,
  [526] = 459,
  [527] = 464,
  [528] = 442,
  [529] = 443,
  [530] = 460,
  [531] = 444,
  [532] = 447,
  [533] = 198,
  [534] = 455,
  [535] = 465,
  [536] = 438,
  [537] = 454,
  [538] = 198,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 7,
  [544] = 8,
  [545] = 6,
  [546] = 9,
  [547] = 10,
  [548] = 11,
  [549] = 25,
  [550] = 550,
  [551] = 20,
  [552] = 18,
  [553] = 24,
  [554] = 12,
  [555] = 17,
  [556] = 16,
  [557] = 23,
  [558] = 558,
  [559] = 21,
  [560] = 19,
  [561] = 14,
  [562] = 22,
  [563] = 26,
  [564] = 27,
  [565] = 28,
  [566] = 29,
  [567] = 567,
  [568] = 568,
  [569] = 569,
  [570] = 570,
  [571] = 571,
  [572] = 572,
  [573] = 573,
  [574] = 574,
  [575] = 575,
  [576] = 576,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 581,
  [582] = 582,
  [583] = 583,
  [584] = 584,
  [585] = 585,
  [586] = 586,
  [587] = 587,
  [588] = 588,
  [589] = 589,
  [590] = 590,
  [591] = 591,
  [592] = 592,
  [593] = 593,
  [594] = 594,
  [595] = 595,
  [596] = 596,
  [597] = 597,
  [598] = 598,
  [599] = 599,
  [600] = 600,
  [601] = 601,
  [602] = 602,
  [603] = 603,
  [604] = 604,
  [605] = 605,
  [606] = 606,
  [607] = 607,
  [608] = 608,
  [609] = 609,
  [610] = 610,
  [611] = 611,
  [612] = 612,
  [613] = 613,
  [614] = 614,
  [615] = 615,
  [616] = 616,
  [617] = 617,
  [618] = 618,
  [619] = 619,
  [620] = 620,
  [621] = 621,
  [622] = 622,
  [623] = 623,
  [624] = 624,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 629,
  [630] = 630,
  [631] = 631,
  [632] = 632,
  [633] = 633,
  [634] = 634,
  [635] = 635,
  [636] = 636,
  [637] = 637,
  [638] = 638,
  [639] = 639,
  [640] = 640,
  [641] = 641,
  [642] = 642,
  [643] = 643,
  [644] = 644,
  [645] = 645,
  [646] = 646,
  [647] = 647,
  [648] = 648,
  [649] = 649,
  [650] = 650,
  [651] = 651,
  [652] = 652,
  [653] = 653,
  [654] = 654,
  [655] = 655,
  [656] = 656,
  [657] = 657,
  [658] = 658,
  [659] = 659,
  [660] = 660,
  [661] = 661,
  [662] = 662,
  [663] = 663,
  [664] = 664,
  [665] = 665,
  [666] = 666,
  [667] = 667,
  [668] = 668,
  [669] = 669,
  [670] = 670,
  [671] = 671,
  [672] = 672,
  [673] = 673,
  [674] = 674,
  [675] = 675,
  [676] = 676,
  [677] = 677,
  [678] = 678,
  [679] = 679,
  [680] = 680,
  [681] = 681,
  [682] = 682,
  [683] = 683,
  [684] = 684,
  [685] = 685,
  [686] = 686,
  [687] = 687,
  [688] = 688,
  [689] = 689,
  [690] = 690,
  [691] = 691,
  [692] = 692,
  [693] = 693,
  [694] = 694,
  [695] = 695,
  [696] = 695,
  [697] = 697,
  [698] = 694,
  [699] = 699,
  [700] = 695,
  [701] = 701,
  [702] = 694,
  [703] = 694,
  [704] = 695,
  [705] = 705,
  [706] = 706,
  [707] = 695,
  [708] = 708,
  [709] = 694,
  [710] = 710,
  [711] = 711,
  [712] = 255,
  [713] = 254,
  [714] = 83,
  [715] = 100,
  [716] = 716,
  [717] = 129,
  [718] = 18,
  [719] = 719,
  [720] = 133,
  [721] = 26,
  [722] = 135,
  [723] = 131,
  [724] = 151,
  [725] = 725,
  [726] = 130,
  [727] = 116,
  [728] = 728,
  [729] = 729,
  [730] = 730,
  [731] = 731,
  [732] = 732,
  [733] = 733,
  [734] = 734,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 738,
  [740] = 738,
  [741] = 738,
  [742] = 738,
  [743] = 743,
  [744] = 744,
  [745] = 745,
  [746] = 746,
  [747] = 745,
  [748] = 748,
  [749] = 749,
  [750] = 749,
  [751] = 234,
  [752] = 752,
  [753] = 753,
  [754] = 754,
  [755] = 755,
  [756] = 756,
  [757] = 757,
  [758] = 757,
  [759] = 759,
  [760] = 7,
  [761] = 761,
  [762] = 762,
  [763] = 761,
  [764] = 764,
  [765] = 765,
  [766] = 761,
  [767] = 767,
  [768] = 761,
  [769] = 6,
  [770] = 761,
  [771] = 767,
  [772] = 761,
  [773] = 761,
  [774] = 774,
  [775] = 775,
  [776] = 776,
  [777] = 777,
  [778] = 778,
  [779] = 777,
  [780] = 10,
  [781] = 781,
  [782] = 782,
  [783] = 783,
  [784] = 784,
  [785] = 785,
  [786] = 786,
  [787] = 787,
  [788] = 781,
  [789] = 782,
  [790] = 783,
  [791] = 785,
  [792] = 792,
  [793] = 793,
  [794] = 786,
  [795] = 787,
  [796] = 796,
  [797] = 781,
  [798] = 782,
  [799] = 796,
  [800] = 783,
  [801] = 785,
  [802] = 785,
  [803] = 803,
  [804] = 783,
  [805] = 782,
  [806] = 806,
  [807] = 786,
  [808] = 787,
  [809] = 809,
  [810] = 787,
  [811] = 781,
  [812] = 786,
  [813] = 786,
  [814] = 787,
  [815] = 787,
  [816] = 786,
  [817] = 784,
  [818] = 818,
  [819] = 784,
  [820] = 784,
  [821] = 818,
  [822] = 803,
  [823] = 823,
  [824] = 824,
  [825] = 247,
  [826] = 248,
  [827] = 244,
  [828] = 242,
  [829] = 245,
  [830] = 778,
  [831] = 831,
  [832] = 832,
  [833] = 833,
  [834] = 834,
  [835] = 835,
  [836] = 836,
  [837] = 818,
  [838] = 838,
  [839] = 839,
  [840] = 803,
  [841] = 841,
  [842] = 831,
  [843] = 833,
  [844] = 818,
  [845] = 9,
  [846] = 803,
  [847] = 833,
  [848] = 831,
  [849] = 833,
  [850] = 850,
  [851] = 851,
  [852] = 831,
  [853] = 853,
  [854] = 854,
  [855] = 855,
  [856] = 856,
  [857] = 857,
  [858] = 858,
  [859] = 859,
  [860] = 860,
  [861] = 861,
  [862] = 862,
  [863] = 863,
  [864] = 864,
  [865] = 865,
  [866] = 866,
  [867] = 867,
  [868] = 854,
  [869] = 869,
  [870] = 870,
  [871] = 871,
  [872] = 872,
  [873] = 873,
  [874] = 874,
  [875] = 855,
  [876] = 876,
  [877] = 877,
  [878] = 857,
  [879] = 879,
  [880] = 880,
  [881] = 881,
  [882] = 882,
  [883] = 883,
  [884] = 884,
  [885] = 885,
  [886] = 886,
  [887] = 887,
  [888] = 888,
  [889] = 889,
  [890] = 890,
  [891] = 891,
  [892] = 892,
  [893] = 893,
  [894] = 874,
  [895] = 886,
  [896] = 896,
  [897] = 897,
  [898] = 898,
  [899] = 899,
  [900] = 900,
  [901] = 901,
  [902] = 902,
  [903] = 869,
  [904] = 853,
  [905] = 905,
  [906] = 906,
  [907] = 907,
  [908] = 908,
  [909] = 873,
  [910] = 910,
  [911] = 911,
  [912] = 873,
  [913] = 908,
  [914] = 887,
  [915] = 915,
  [916] = 916,
  [917] = 897,
  [918] = 918,
  [919] = 885,
  [920] = 911,
  [921] = 915,
  [922] = 922,
  [923] = 923,
  [924] = 924,
  [925] = 925,
  [926] = 870,
  [927] = 927,
  [928] = 928,
  [929] = 929,
  [930] = 867,
  [931] = 931,
  [932] = 854,
  [933] = 867,
  [934] = 853,
  [935] = 935,
  [936] = 922,
  [937] = 937,
  [938] = 871,
  [939] = 939,
  [940] = 940,
  [941] = 908,
  [942] = 866,
  [943] = 943,
  [944] = 887,
  [945] = 916,
  [946] = 946,
  [947] = 897,
  [948] = 948,
  [949] = 918,
  [950] = 885,
  [951] = 911,
  [952] = 915,
  [953] = 865,
  [954] = 954,
  [955] = 923,
  [956] = 924,
  [957] = 925,
  [958] = 958,
  [959] = 864,
  [960] = 862,
  [961] = 927,
  [962] = 931,
  [963] = 861,
  [964] = 857,
  [965] = 935,
  [966] = 966,
  [967] = 855,
  [968] = 874,
  [969] = 969,
  [970] = 853,
  [971] = 908,
  [972] = 972,
  [973] = 869,
  [974] = 974,
  [975] = 887,
  [976] = 916,
  [977] = 870,
  [978] = 874,
  [979] = 867,
  [980] = 866,
  [981] = 981,
  [982] = 916,
  [983] = 983,
  [984] = 865,
  [985] = 897,
  [986] = 918,
  [987] = 885,
  [988] = 988,
  [989] = 911,
  [990] = 864,
  [991] = 882,
  [992] = 915,
  [993] = 993,
  [994] = 923,
  [995] = 924,
  [996] = 925,
  [997] = 997,
  [998] = 862,
  [999] = 927,
  [1000] = 931,
  [1001] = 1001,
  [1002] = 1002,
  [1003] = 935,
  [1004] = 873,
  [1005] = 918,
  [1006] = 861,
  [1007] = 1007,
  [1008] = 1008,
  [1009] = 855,
  [1010] = 886,
  [1011] = 882,
  [1012] = 871,
  [1013] = 1013,
  [1014] = 1014,
  [1015] = 857,
  [1016] = 1016,
  [1017] = 1017,
  [1018] = 929,
  [1019] = 1019,
  [1020] = 929,
  [1021] = 1021,
  [1022] = 935,
  [1023] = 925,
  [1024] = 923,
  [1025] = 866,
  [1026] = 861,
  [1027] = 886,
  [1028] = 929,
  [1029] = 882,
  [1030] = 924,
  [1031] = 931,
  [1032] = 870,
  [1033] = 871,
  [1034] = 1008,
  [1035] = 854,
  [1036] = 862,
  [1037] = 865,
  [1038] = 869,
  [1039] = 929,
  [1040] = 864,
  [1041] = 927,
  [1042] = 1042,
  [1043] = 1043,
  [1044] = 1044,
  [1045] = 1045,
  [1046] = 1046,
  [1047] = 1045,
  [1048] = 1044,
  [1049] = 1049,
  [1050] = 1050,
  [1051] = 1044,
  [1052] = 1052,
  [1053] = 1049,
  [1054] = 1054,
  [1055] = 1055,
  [1056] = 1056,
  [1057] = 1057,
  [1058] = 1058,
  [1059] = 1059,
  [1060] = 1042,
  [1061] = 1046,
  [1062] = 1062,
  [1063] = 1046,
  [1064] = 1064,
  [1065] = 1065,
  [1066] = 1066,
  [1067] = 1067,
  [1068] = 1055,
  [1069] = 1069,
  [1070] = 1049,
  [1071] = 1071,
  [1072] = 1049,
  [1073] = 1073,
  [1074] = 1074,
  [1075] = 1046,
  [1076] = 1059,
  [1077] = 1077,
  [1078] = 1078,
  [1079] = 1074,
  [1080] = 1080,
  [1081] = 1080,
  [1082] = 1052,
  [1083] = 1044,
  [1084] = 1062,
  [1085] = 1085,
  [1086] = 1086,
  [1087] = 1087,
  [1088] = 1088,
  [1089] = 1089,
  [1090] = 1090,
  [1091] = 1091,
  [1092] = 576,
  [1093] = 1093,
  [1094] = 1094,
  [1095] = 1095,
  [1096] = 1096,
  [1097] = 1097,
  [1098] = 1098,
  [1099] = 1099,
  [1100] = 1100,
  [1101] = 1101,
  [1102] = 1102,
  [1103] = 1103,
  [1104] = 610,
  [1105] = 1105,
  [1106] = 1106,
  [1107] = 1107,
  [1108] = 1108,
  [1109] = 1109,
  [1110] = 1110,
  [1111] = 1111,
  [1112] = 1112,
  [1113] = 1113,
  [1114] = 1114,
  [1115] = 1115,
  [1116] = 1116,
  [1117] = 1117,
  [1118] = 1109,
  [1119] = 1119,
  [1120] = 1120,
  [1121] = 1121,
  [1122] = 1106,
  [1123] = 1123,
  [1124] = 1124,
  [1125] = 1109,
  [1126] = 1126,
  [1127] = 1106,
  [1128] = 1109,
  [1129] = 1129,
  [1130] = 1130,
  [1131] = 1131,
  [1132] = 1132,
  [1133] = 1106,
  [1134] = 1134,
  [1135] = 1135,
  [1136] = 1136,
  [1137] = 1137,
  [1138] = 1138,
  [1139] = 1139,
  [1140] = 1139,
  [1141] = 1141,
  [1142] = 1139,
  [1143] = 1143,
  [1144] = 1141,
  [1145] = 1141,
  [1146] = 1146,
  [1147] = 1139,
  [1148] = 1146,
  [1149] = 1146,
  [1150] = 1141,
  [1151] = 1146,
  [1152] = 1152,
  [1153] = 1153,
  [1154] = 1154,
  [1155] = 1155,
  [1156] = 1156,
  [1157] = 1157,
  [1158] = 1158,
  [1159] = 1159,
  [1160] = 1160,
  [1161] = 1161,
  [1162] = 1162,
  [1163] = 1163,
  [1164] = 1164,
  [1165] = 1165,
  [1166] = 1166,
  [1167] = 1166,
  [1168] = 1168,
  [1169] = 1169,
  [1170] = 1170,
  [1171] = 1166,
  [1172] = 1172,
  [1173] = 1173,
  [1174] = 1174,
  [1175] = 1175,
  [1176] = 1176,
  [1177] = 1177,
  [1178] = 1166,
  [1179] = 1179,
  [1180] = 1180,
  [1181] = 1181,
  [1182] = 1182,
  [1183] = 1183,
  [1184] = 613,
  [1185] = 1183,
  [1186] = 1183,
  [1187] = 1183,
  [1188] = 1188,
  [1189] = 1183,
  [1190] = 1183,
  [1191] = 569,
  [1192] = 1192,
  [1193] = 1193,
  [1194] = 1194,
  [1195] = 1195,
  [1196] = 1196,
  [1197] = 1197,
  [1198] = 1196,
  [1199] = 1199,
  [1200] = 1200,
  [1201] = 1201,
  [1202] = 1195,
  [1203] = 1200,
  [1204] = 1195,
  [1205] = 1200,
  [1206] = 236,
  [1207] = 1196,
  [1208] = 1195,
  [1209] = 1196,
  [1210] = 1196,
  [1211] = 1195,
  [1212] = 1195,
  [1213] = 1196,
  [1214] = 1214,
  [1215] = 1215,
  [1216] = 1216,
  [1217] = 1200,
  [1218] = 1218,
  [1219] = 1219,
  [1220] = 1220,
  [1221] = 1221,
  [1222] = 1222,
  [1223] = 1223,
  [1224] = 1224,
  [1225] = 1225,
  [1226] = 1226,
  [1227] = 1227,
  [1228] = 1220,
  [1229] = 1229,
  [1230] = 1230,
  [1231] = 1231,
  [1232] = 602,
  [1233] = 1233,
  [1234] = 1234,
  [1235] = 1235,
  [1236] = 1236,
  [1237] = 1237,
  [1238] = 1238,
  [1239] = 1239,
  [1240] = 1238,
  [1241] = 1239,
  [1242] = 1238,
  [1243] = 1239,
  [1244] = 1244,
  [1245] = 1245,
  [1246] = 1246,
  [1247] = 1247,
  [1248] = 1248,
  [1249] = 1249,
  [1250] = 1250,
  [1251] = 1248,
  [1252] = 1252,
  [1253] = 1248,
  [1254] = 1252,
  [1255] = 1248,
  [1256] = 1252,
  [1257] = 1257,
  [1258] = 1258,
  [1259] = 1259,
  [1260] = 1260,
  [1261] = 1261,
  [1262] = 1262,
  [1263] = 1263,
  [1264] = 1264,
  [1265] = 1236,
  [1266] = 1266,
  [1267] = 1267,
  [1268] = 1237,
  [1269] = 1269,
  [1270] = 1270,
  [1271] = 1270,
  [1272] = 1272,
  [1273] = 1273,
  [1274] = 1274,
  [1275] = 1275,
  [1276] = 1270,
  [1277] = 1277,
  [1278] = 1278,
  [1279] = 1278,
  [1280] = 1278,
  [1281] = 1252,
  [1282] = 1278,
  [1283] = 1283,
  [1284] = 1284,
  [1285] = 1285,
  [1286] = 1244,
  [1287] = 1287,
  [1288] = 1288,
  [1289] = 1289,
  [1290] = 1290,
  [1291] = 1291,
  [1292] = 1292,
  [1293] = 1278,
  [1294] = 1294,
  [1295] = 1295,
  [1296] = 1296,
  [1297] = 1297,
  [1298] = 83,
  [1299] = 1244,
  [1300] = 1300,
  [1301] = 1301,
  [1302] = 1302,
  [1303] = 1303,
  [1304] = 1290,
  [1305] = 1305,
  [1306] = 1306,
  [1307] = 1307,
  [1308] = 1308,
  [1309] = 100,
  [1310] = 1278,
  [1311] = 1311,
  [1312] = 1289,
  [1313] = 1313,
  [1314] = 1275,
  [1315] = 1315,
  [1316] = 1244,
  [1317] = 1317,
  [1318] = 151,
  [1319] = 1319,
  [1320] = 1290,
  [1321] = 1321,
  [1322] = 1322,
  [1323] = 1278,
  [1324] = 1324,
  [1325] = 1325,
  [1326] = 1326,
  [1327] = 1327,
  [1328] = 1328,
  [1329] = 1329,
  [1330] = 1326,
  [1331] = 1327,
  [1332] = 1332,
  [1333] = 1333,
  [1334] = 1290,
  [1335] = 1306,
  [1336] = 1326,
  [1337] = 1238,
  [1338] = 1338,
  [1339] = 1327,
  [1340] = 1340,
  [1341] = 1341,
  [1342] = 1307,
  [1343] = 1301,
  [1344] = 1300,
  [1345] = 1345,
  [1346] = 1324,
  [1347] = 1292,
  [1348] = 1291,
  [1349] = 1327,
  [1350] = 1285,
  [1351] = 1326,
  [1352] = 1260,
  [1353] = 1269,
  [1354] = 1247,
  [1355] = 1333,
  [1356] = 1277,
  [1357] = 1283,
  [1358] = 1297,
  [1359] = 1359,
  [1360] = 1278,
  [1361] = 1322,
  [1362] = 1338,
  [1363] = 1341,
  [1364] = 1302,
  [1365] = 1333,
  [1366] = 1366,
  [1367] = 1367,
  [1368] = 1368,
  [1369] = 1369,
  [1370] = 1370,
  [1371] = 1371,
  [1372] = 1371,
  [1373] = 1369,
  [1374] = 1370,
  [1375] = 1367,
  [1376] = 1306,
  [1377] = 1305,
  [1378] = 1326,
  [1379] = 1236,
  [1380] = 1266,
  [1381] = 1273,
  [1382] = 1274,
  [1383] = 1340,
  [1384] = 1327,
  [1385] = 1385,
  [1386] = 1368,
  [1387] = 1327,
  [1388] = 1188,
  [1389] = 1340,
  [1390] = 1307,
  [1391] = 1301,
  [1392] = 1300,
  [1393] = 1274,
  [1394] = 1273,
  [1395] = 1266,
  [1396] = 1292,
  [1397] = 1291,
  [1398] = 1239,
  [1399] = 1285,
  [1400] = 1326,
  [1401] = 1237,
  [1402] = 1305,
  [1403] = 1306,
  [1404] = 1270,
  [1405] = 1260,
  [1406] = 1269,
  [1407] = 1247,
  [1408] = 1277,
  [1409] = 1283,
  [1410] = 1367,
  [1411] = 1370,
  [1412] = 1371,
  [1413] = 1369,
  [1414] = 1297,
  [1415] = 1368,
  [1416] = 1322,
  [1417] = 1366,
  [1418] = 1333,
  [1419] = 1338,
  [1420] = 1341,
  [1421] = 1333,
  [1422] = 1422,
  [1423] = 1366,
  [1424] = 1368,
  [1425] = 1369,
  [1426] = 1371,
  [1427] = 1370,
  [1428] = 1367,
  [1429] = 1341,
  [1430] = 1338,
  [1431] = 1325,
  [1432] = 1306,
  [1433] = 1322,
  [1434] = 1305,
  [1435] = 1435,
  [1436] = 1329,
  [1437] = 1326,
  [1438] = 1236,
  [1439] = 1266,
  [1440] = 1273,
  [1441] = 1274,
  [1442] = 1315,
  [1443] = 1366,
  [1444] = 594,
  [1445] = 1297,
  [1446] = 1283,
  [1447] = 1277,
  [1448] = 1340,
  [1449] = 1327,
  [1450] = 1307,
  [1451] = 1263,
  [1452] = 1303,
  [1453] = 1301,
  [1454] = 1300,
  [1455] = 1296,
  [1456] = 1295,
  [1457] = 1292,
  [1458] = 1291,
  [1459] = 1288,
  [1460] = 1258,
  [1461] = 1287,
  [1462] = 1285,
  [1463] = 1247,
  [1464] = 1269,
  [1465] = 1272,
  [1466] = 1319,
  [1467] = 1237,
  [1468] = 1468,
  [1469] = 1260,
  [1470] = 89,
  [1471] = 1471,
  [1472] = 1472,
  [1473] = 1473,
  [1474] = 1474,
  [1475] = 134,
  [1476] = 126,
  [1477] = 1477,
  [1478] = 92,
  [1479] = 1479,
  [1480] = 136,
  [1481] = 1481,
  [1482] = 1482,
  [1483] = 87,
  [1484] = 1484,
  [1485] = 1485,
  [1486] = 1486,
  [1487] = 1472,
  [1488] = 1488,
  [1489] = 132,
  [1490] = 115,
  [1491] = 107,
  [1492] = 90,
  [1493] = 1493,
  [1494] = 91,
  [1495] = 105,
  [1496] = 101,
  [1497] = 1486,
  [1498] = 1498,
  [1499] = 1499,
  [1500] = 1500,
  [1501] = 1501,
  [1502] = 93,
  [1503] = 86,
  [1504] = 98,
  [1505] = 1505,
  [1506] = 106,
  [1507] = 1507,
  [1508] = 1508,
  [1509] = 108,
  [1510] = 1485,
  [1511] = 110,
  [1512] = 1485,
  [1513] = 85,
  [1514] = 119,
  [1515] = 1485,
  [1516] = 103,
  [1517] = 1517,
  [1518] = 104,
  [1519] = 1507,
  [1520] = 123,
  [1521] = 1521,
  [1522] = 125,
  [1523] = 114,
  [1524] = 1521,
  [1525] = 1525,
  [1526] = 111,
  [1527] = 112,
  [1528] = 88,
  [1529] = 1529,
  [1530] = 1498,
  [1531] = 1531,
  [1532] = 122,
  [1533] = 121,
  [1534] = 1534,
  [1535] = 120,
  [1536] = 118,
  [1537] = 117,
  [1538] = 113,
  [1539] = 124,
  [1540] = 109,
  [1541] = 1541,
  [1542] = 1542,
  [1543] = 1471,
  [1544] = 84,
  [1545] = 99,
  [1546] = 1493,
  [1547] = 97,
  [1548] = 96,
  [1549] = 95,
  [1550] = 94,
  [1551] = 102,
  [1552] = 1552,
  [1553] = 1553,
  [1554] = 1554,
  [1555] = 1555,
  [1556] = 1556,
  [1557] = 116,
  [1558] = 1558,
  [1559] = 1493,
  [1560] = 1560,
  [1561] = 1561,
  [1562] = 1562,
  [1563] = 1563,
  [1564] = 1564,
  [1565] = 1565,
  [1566] = 1566,
  [1567] = 1567,
  [1568] = 1517,
  [1569] = 1569,
  [1570] = 1479,
  [1571] = 1569,
  [1572] = 1561,
  [1573] = 1573,
  [1574] = 1507,
  [1575] = 1193,
  [1576] = 1576,
  [1577] = 1577,
  [1578] = 1493,
  [1579] = 133,
  [1580] = 131,
  [1581] = 130,
  [1582] = 129,
  [1583] = 135,
  [1584] = 1584,
  [1585] = 1507,
  [1586] = 1586,
  [1587] = 1587,
  [1588] = 1577,
  [1589] = 1589,
  [1590] = 1553,
  [1591] = 1591,
  [1592] = 1592,
  [1593] = 1593,
  [1594] = 1594,
  [1595] = 1595,
  [1596] = 1596,
  [1597] = 1597,
  [1598] = 1598,
  [1599] = 1599,
  [1600] = 1600,
  [1601] = 1601,
  [1602] = 1602,
  [1603] = 1603,
  [1604] = 1604,
  [1605] = 1605,
  [1606] = 1606,
  [1607] = 1607,
  [1608] = 1608,
  [1609] = 1609,
  [1610] = 1610,
  [1611] = 1611,
  [1612] = 1612,
  [1613] = 1613,
  [1614] = 1614,
  [1615] = 1615,
  [1616] = 1616,
  [1617] = 1617,
  [1618] = 1618,
  [1619] = 1619,
  [1620] = 1620,
  [1621] = 1621,
  [1622] = 1622,
  [1623] = 1623,
  [1624] = 1624,
  [1625] = 1625,
  [1626] = 1626,
  [1627] = 1627,
  [1628] = 1628,
  [1629] = 1629,
  [1630] = 1630,
  [1631] = 1631,
  [1632] = 1632,
  [1633] = 1633,
  [1634] = 1604,
  [1635] = 1635,
  [1636] = 1629,
  [1637] = 1635,
  [1638] = 1638,
  [1639] = 1639,
  [1640] = 1640,
  [1641] = 1617,
  [1642] = 1642,
  [1643] = 1643,
  [1644] = 1642,
  [1645] = 1645,
  [1646] = 1646,
  [1647] = 1647,
  [1648] = 1638,
  [1649] = 1639,
  [1650] = 1650,
  [1651] = 1594,
  [1652] = 1652,
  [1653] = 1629,
  [1654] = 1635,
  [1655] = 1638,
  [1656] = 1639,
  [1657] = 1657,
  [1658] = 1642,
  [1659] = 1659,
  [1660] = 1660,
  [1661] = 1661,
  [1662] = 1662,
  [1663] = 1642,
  [1664] = 1664,
  [1665] = 1642,
  [1666] = 1630,
  [1667] = 1667,
  [1668] = 1599,
  [1669] = 1669,
  [1670] = 1670,
  [1671] = 1617,
  [1672] = 1672,
  [1673] = 1673,
  [1674] = 1674,
  [1675] = 1675,
  [1676] = 1676,
  [1677] = 1639,
  [1678] = 1678,
  [1679] = 1638,
  [1680] = 1680,
  [1681] = 1681,
  [1682] = 1682,
  [1683] = 1635,
  [1684] = 1684,
  [1685] = 1673,
  [1686] = 1686,
  [1687] = 1687,
  [1688] = 1688,
  [1689] = 1650,
  [1690] = 1690,
  [1691] = 1691,
  [1692] = 1629,
  [1693] = 1693,
  [1694] = 1694,
  [1695] = 1695,
  [1696] = 1696,
  [1697] = 1697,
  [1698] = 1698,
  [1699] = 1699,
  [1700] = 1700,
  [1701] = 640,
  [1702] = 1630,
  [1703] = 1703,
  [1704] = 1704,
  [1705] = 1705,
  [1706] = 1706,
  [1707] = 1707,
  [1708] = 1708,
  [1709] = 1709,
  [1710] = 1645,
  [1711] = 1711,
  [1712] = 1712,
  [1713] = 1642,
  [1714] = 1714,
  [1715] = 1715,
  [1716] = 1716,
  [1717] = 669,
  [1718] = 1718,
  [1719] = 1719,
  [1720] = 1720,
  [1721] = 1721,
  [1722] = 1623,
  [1723] = 1622,
  [1724] = 1650,
  [1725] = 1725,
  [1726] = 1726,
  [1727] = 672,
  [1728] = 1621,
  [1729] = 1729,
  [1730] = 1617,
  [1731] = 1731,
  [1732] = 1620,
  [1733] = 1733,
  [1734] = 1734,
  [1735] = 1619,
  [1736] = 1736,
  [1737] = 1616,
  [1738] = 1615,
  [1739] = 674,
  [1740] = 1740,
  [1741] = 1614,
  [1742] = 1742,
  [1743] = 1743,
  [1744] = 1613,
  [1745] = 1612,
  [1746] = 1746,
  [1747] = 1747,
  [1748] = 1599,
  [1749] = 1608,
  [1750] = 1750,
  [1751] = 1751,
  [1752] = 1608,
  [1753] = 1650,
  [1754] = 1754,
  [1755] = 1755,
  [1756] = 1756,
  [1757] = 1757,
  [1758] = 1758,
  [1759] = 677,
  [1760] = 1760,
  [1761] = 1761,
  [1762] = 678,
  [1763] = 1604,
  [1764] = 1764,
  [1765] = 1765,
  [1766] = 1766,
  [1767] = 1612,
  [1768] = 1768,
  [1769] = 1682,
  [1770] = 1599,
  [1771] = 1771,
  [1772] = 1604,
  [1773] = 1773,
  [1774] = 1669,
  [1775] = 1775,
  [1776] = 1776,
  [1777] = 1755,
  [1778] = 1778,
  [1779] = 1779,
  [1780] = 1775,
  [1781] = 1642,
  [1782] = 1782,
  [1783] = 1783,
  [1784] = 1784,
  [1785] = 1631,
  [1786] = 1640,
  [1787] = 1787,
  [1788] = 1733,
  [1789] = 1708,
  [1790] = 1790,
  [1791] = 1608,
  [1792] = 1792,
  [1793] = 1611,
  [1794] = 1596,
  [1795] = 1714,
  [1796] = 1743,
  [1797] = 1736,
  [1798] = 1766,
  [1799] = 1799,
  [1800] = 1800,
  [1801] = 1801,
  [1802] = 1802,
  [1803] = 1803,
  [1804] = 1802,
  [1805] = 1805,
  [1806] = 1750,
  [1807] = 1751,
  [1808] = 1754,
  [1809] = 1765,
  [1810] = 1810,
  [1811] = 1811,
  [1812] = 1812,
  [1813] = 1813,
  [1814] = 1776,
  [1815] = 1755,
  [1816] = 1816,
  [1817] = 1612,
  [1818] = 1631,
  [1819] = 1810,
  [1820] = 1630,
  [1821] = 1596,
  [1822] = 1714,
  [1823] = 1743,
  [1824] = 1736,
  [1825] = 1766,
  [1826] = 1802,
  [1827] = 1803,
  [1828] = 1594,
  [1829] = 1750,
  [1830] = 1751,
  [1831] = 1754,
  [1832] = 1765,
  [1833] = 1810,
  [1834] = 1812,
  [1835] = 1813,
  [1836] = 1776,
  [1837] = 1755,
  [1838] = 679,
  [1839] = 1613,
  [1840] = 1631,
  [1841] = 687,
  [1842] = 1842,
  [1843] = 1596,
  [1844] = 1714,
  [1845] = 1743,
  [1846] = 1736,
  [1847] = 1766,
  [1848] = 1802,
  [1849] = 1803,
  [1850] = 1594,
  [1851] = 1750,
  [1852] = 1751,
  [1853] = 1754,
  [1854] = 1765,
  [1855] = 1810,
  [1856] = 1812,
  [1857] = 1813,
  [1858] = 1755,
  [1859] = 1755,
  [1860] = 1755,
  [1861] = 1755,
  [1862] = 1862,
  [1863] = 1863,
  [1864] = 1864,
  [1865] = 1659,
  [1866] = 1866,
  [1867] = 1613,
  [1868] = 1813,
  [1869] = 1869,
  [1870] = 1870,
  [1871] = 1614,
  [1872] = 1872,
  [1873] = 1639,
  [1874] = 1638,
  [1875] = 1875,
  [1876] = 1876,
  [1877] = 1635,
  [1878] = 1878,
  [1879] = 1879,
  [1880] = 1629,
  [1881] = 1881,
  [1882] = 1882,
  [1883] = 1883,
  [1884] = 1884,
  [1885] = 1620,
  [1886] = 688,
  [1887] = 1887,
  [1888] = 1711,
  [1889] = 1889,
  [1890] = 690,
  [1891] = 1891,
  [1892] = 1875,
  [1893] = 1893,
  [1894] = 1894,
  [1895] = 1617,
  [1896] = 1896,
  [1897] = 1897,
  [1898] = 1812,
  [1899] = 1889,
  [1900] = 1623,
  [1901] = 1901,
  [1902] = 1887,
  [1903] = 1711,
  [1904] = 1889,
  [1905] = 1622,
  [1906] = 1621,
  [1907] = 1875,
  [1908] = 1620,
  [1909] = 646,
  [1910] = 1910,
  [1911] = 1911,
  [1912] = 632,
  [1913] = 1913,
  [1914] = 1617,
  [1915] = 1915,
  [1916] = 1916,
  [1917] = 1917,
  [1918] = 1711,
  [1919] = 1889,
  [1920] = 1757,
  [1921] = 1706,
  [1922] = 1603,
  [1923] = 1776,
  [1924] = 1597,
  [1925] = 1896,
  [1926] = 1926,
  [1927] = 671,
  [1928] = 1595,
  [1929] = 1657,
  [1930] = 1664,
  [1931] = 1672,
  [1932] = 1719,
  [1933] = 1614,
  [1934] = 1639,
  [1935] = 1757,
  [1936] = 1706,
  [1937] = 1603,
  [1938] = 1938,
  [1939] = 1597,
  [1940] = 1896,
  [1941] = 1926,
  [1942] = 1942,
  [1943] = 1595,
  [1944] = 1657,
  [1945] = 1664,
  [1946] = 1672,
  [1947] = 1719,
  [1948] = 1638,
  [1949] = 1949,
  [1950] = 1757,
  [1951] = 1706,
  [1952] = 1603,
  [1953] = 670,
  [1954] = 1597,
  [1955] = 1896,
  [1956] = 1926,
  [1957] = 1811,
  [1958] = 1595,
  [1959] = 1657,
  [1960] = 1664,
  [1961] = 1672,
  [1962] = 1719,
  [1963] = 1926,
  [1964] = 1964,
  [1965] = 1965,
  [1966] = 1875,
  [1967] = 1967,
  [1968] = 1968,
  [1969] = 1969,
  [1970] = 1635,
  [1971] = 1971,
  [1972] = 1646,
  [1973] = 1771,
  [1974] = 667,
  [1975] = 1975,
  [1976] = 1976,
  [1977] = 1629,
  [1978] = 1615,
  [1979] = 1616,
  [1980] = 1619,
  [1981] = 1646,
  [1982] = 1771,
  [1983] = 1799,
  [1984] = 1803,
  [1985] = 1985,
  [1986] = 1619,
  [1987] = 1616,
  [1988] = 1615,
  [1989] = 1989,
  [1990] = 1646,
  [1991] = 1771,
  [1992] = 1593,
  [1993] = 1626,
  [1994] = 1746,
  [1995] = 1607,
  [1996] = 1623,
  [1997] = 1712,
  [1998] = 1593,
  [1999] = 1626,
  [2000] = 1746,
  [2001] = 1607,
  [2002] = 1642,
  [2003] = 2003,
  [2004] = 1593,
  [2005] = 1626,
  [2006] = 1746,
  [2007] = 1607,
  [2008] = 1622,
  [2009] = 1621,
  [2010] = 1964,
  [2011] = 1705,
  [2012] = 1964,
  [2013] = 1705,
  [2014] = 1964,
  [2015] = 1705,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(3117);
      ADVANCE_MAP(
        '!', 3907,
        '"', 13,
        '#', 3091,
        '$', 22,
        '%', 23,
        '(', 3909,
        ')', 3360,
        '*', 3288,
        ',', 3350,
        '.', 60,
        '0', 3140,
        ':', 3631,
        ';', 3118,
        '<', 3348,
        '=', 3164,
        '>', 3349,
        '@', 24,
        '[', 3345,
        ']', 3346,
        '^', 25,
        'a', 1347,
        'b', 2055,
        'c', 29,
        'd', 1381,
        'e', 2309,
        'f', 1352,
        'g', 1590,
        'h', 1405,
        'i', 1674,
        'j', 3003,
        'l', 1353,
        'm', 1382,
        'n', 1355,
        'o', 1884,
        'p', 1377,
        'r', 1801,
        's', 71,
        't', 1360,
        'u', 82,
        'v', 1362,
        'w', 1802,
        'x', 3354,
        'z', 1890,
        '{', 3908,
        '|', 4652,
        '}', 3342,
        '+', 3090,
        '-', 3090,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3106);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3141);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '!', 3907,
        '"', 13,
        '%', 23,
        '(', 3909,
        ')', 3360,
        '*', 3288,
        '+', 3090,
        ',', 3350,
        '-', 4647,
        '0', 3143,
        ':', 3631,
        ';', 3118,
        '<', 3347,
        '>', 3349,
        '@', 24,
        '[', 3345,
        ']', 3346,
        'a', 4069,
        'b', 4191,
        'c', 3910,
        'd', 4413,
        'f', 3986,
        'h', 3988,
        'i', 4648,
        'l', 3962,
        'm', 4150,
        'n', 4440,
        'o', 4452,
        'p', 4428,
        's', 3920,
        't', 4424,
        'u', 3918,
        'v', 4431,
        'x', 3927,
        'z', 4170,
        '{', 3341,
        '|', 4652,
        '}', 3342,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(2);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3144);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= '\\') ||
          lookahead == '_' ||
          ('e' <= lookahead && lookahead <= 'y')) ADVANCE(4651);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '!', 3907,
        '"', 13,
        '%', 23,
        '(', 3359,
        ')', 3360,
        '*', 3288,
        '+', 3090,
        ',', 3350,
        '-', 4647,
        '0', 3143,
        ':', 3631,
        ';', 3118,
        '<', 3347,
        '>', 3349,
        '@', 24,
        '[', 3345,
        ']', 3346,
        'a', 4069,
        'b', 4191,
        'c', 3910,
        'd', 4413,
        'f', 3986,
        'h', 3988,
        'i', 4648,
        'l', 3962,
        'm', 4150,
        'n', 4440,
        'o', 4452,
        'p', 4428,
        's', 3920,
        't', 4424,
        'u', 3918,
        'v', 4431,
        'x', 3927,
        'z', 4170,
        '{', 3341,
        '|', 4652,
        '}', 3342,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(2);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3144);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= '\\') ||
          lookahead == '_' ||
          ('e' <= lookahead && lookahead <= 'y')) ADVANCE(4651);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '!', 3907,
        '"', 13,
        '%', 23,
        '(', 3359,
        '*', 3288,
        ',', 3350,
        '0', 3140,
        ';', 3118,
        '<', 3348,
        '@', 24,
        '[', 3345,
        'a', 1351,
        'b', 2056,
        'c', 30,
        'd', 1876,
        'e', 2311,
        'f', 1392,
        'g', 1899,
        'h', 1405,
        'i', 1676,
        'j', 3003,
        'l', 1424,
        'm', 1387,
        'n', 1358,
        'o', 2663,
        'p', 2578,
        'r', 1901,
        's', 75,
        't', 1508,
        'u', 88,
        'v', 2604,
        'w', 1803,
        'x', 117,
        'z', 1890,
        '{', 3341,
        '}', 1300,
        '+', 3090,
        '-', 3090,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3141);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '!', 3907,
        '"', 13,
        '%', 23,
        '(', 3359,
        '*', 3288,
        ',', 3350,
        '0', 3140,
        ';', 3118,
        '<', 3348,
        '@', 24,
        '[', 3345,
        'a', 1714,
        'b', 2054,
        'c', 35,
        'd', 1944,
        'e', 3051,
        'f', 1375,
        'g', 1898,
        'h', 1406,
        'i', 1680,
        'l', 1425,
        'm', 1389,
        'n', 1475,
        'o', 2676,
        'p', 2577,
        's', 81,
        't', 2619,
        'u', 89,
        'v', 2603,
        'w', 1963,
        'x', 120,
        'z', 1992,
        '{', 3341,
        '}', 1300,
        '+', 3090,
        '-', 3090,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3141);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        '!', 3907,
        '"', 20,
        '#', 3091,
        '%', 23,
        '(', 3359,
        '*', 3288,
        '+', 3090,
        ',', 3350,
        '-', 1294,
        '0', 3138,
        ';', 3118,
        '<', 3348,
        '@', 24,
        '[', 3345,
        'a', 342,
        'b', 556,
        'c', 26,
        'd', 391,
        'e', 730,
        'f', 148,
        'g', 277,
        'h', 175,
        'i', 322,
        'j', 1226,
        'l', 149,
        'm', 150,
        'n', 155,
        'o', 970,
        'p', 157,
        'r', 393,
        's', 63,
        't', 213,
        'u', 66,
        'v', 160,
        'w', 449,
        'x', 112,
        'z', 394,
        '{', 3341,
        '}', 3342,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(5);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3139);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('k' <= lookahead && lookahead <= 'y')) ADVANCE(1298);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '!', 3907,
        '"', 20,
        '%', 23,
        '(', 3359,
        '*', 3288,
        '+', 3090,
        ',', 3350,
        '-', 1294,
        '0', 3138,
        ';', 3118,
        '<', 3348,
        '@', 24,
        '[', 3345,
        'a', 287,
        'b', 557,
        'c', 28,
        'd', 487,
        'e', 1261,
        'f', 146,
        'g', 451,
        'h', 176,
        'i', 325,
        'l', 149,
        'm', 153,
        'n', 211,
        'o', 986,
        'p', 607,
        'r', 443,
        's', 65,
        't', 213,
        'u', 68,
        'v', 161,
        'w', 450,
        'x', 112,
        'z', 526,
        '{', 3341,
        '}', 3342,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(6);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3139);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('j' <= lookahead && lookahead <= 'y')) ADVANCE(1298);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '!', 3907,
        '%', 23,
        '(', 3359,
        '0', 3148,
        ';', 3118,
        '<', 3348,
        '[', 3345,
        'a', 1770,
        'b', 2053,
        'c', 2640,
        'd', 2188,
        'e', 3054,
        'f', 1393,
        'h', 1404,
        'i', 3092,
        'l', 1422,
        'm', 2024,
        'n', 2159,
        'o', 1886,
        'p', 2665,
        'r', 1974,
        's', 70,
        't', 2620,
        'u', 90,
        'v', 2605,
        'x', 119,
        '{', 3341,
        '}', 3342,
        '+', 3094,
        '-', 3094,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(7);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3150);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '!', 21,
        '"', 13,
        '%', 23,
        '(', 3359,
        '*', 3288,
        ',', 3350,
        '0', 3140,
        ';', 3118,
        '<', 3348,
        '@', 24,
        '[', 3345,
        'a', 1350,
        'b', 2056,
        'c', 31,
        'd', 1876,
        'e', 2311,
        'f', 1391,
        'g', 1899,
        'h', 1405,
        'i', 1675,
        'j', 3003,
        'l', 1424,
        'm', 1386,
        'n', 1358,
        'o', 2663,
        'p', 2578,
        'r', 1877,
        's', 74,
        't', 1508,
        'u', 84,
        'v', 2604,
        'w', 1803,
        'x', 117,
        'z', 1890,
        '{', 3341,
        '}', 1300,
        '+', 3090,
        '-', 3090,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(8);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3141);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '"', 13,
        '%', 23,
        '(', 3909,
        '*', 3288,
        ',', 3350,
        '0', 3140,
        ';', 3118,
        '<', 3348,
        '@', 24,
        '[', 3345,
        'a', 1796,
        'b', 2146,
        'c', 35,
        'd', 1945,
        'e', 3051,
        'f', 1376,
        'g', 1898,
        'h', 2155,
        'i', 1679,
        'l', 2156,
        'm', 1390,
        'n', 1475,
        'o', 2703,
        'p', 2579,
        's', 81,
        't', 2741,
        'u', 89,
        'w', 1963,
        'x', 1616,
        'z', 1992,
        '{', 3341,
        '}', 1300,
        '+', 3090,
        '-', 3090,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(10);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3141);
      END_STATE();
    case 10:
      ADVANCE_MAP(
        '"', 13,
        '%', 23,
        '*', 3288,
        ',', 3350,
        '0', 3140,
        ';', 3118,
        '<', 3348,
        '@', 24,
        '[', 3345,
        'a', 1796,
        'b', 2146,
        'c', 35,
        'd', 1945,
        'e', 3051,
        'f', 1376,
        'g', 1898,
        'h', 2155,
        'i', 1679,
        'l', 2156,
        'm', 1390,
        'n', 1475,
        'o', 2703,
        'p', 2579,
        's', 81,
        't', 2741,
        'u', 89,
        'w', 1963,
        'x', 1616,
        'z', 1992,
        '{', 3341,
        '}', 1300,
        '+', 3090,
        '-', 3090,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(10);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3141);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        '"', 13,
        '(', 3359,
        ')', 3360,
        '+', 3094,
        ',', 3350,
        '-', 4646,
        '0', 3149,
        ':', 3631,
        ';', 3118,
        '[', 3345,
        ']', 3346,
        '^', 25,
        'a', 4272,
        'b', 4589,
        'c', 4405,
        'd', 4109,
        'e', 4283,
        'h', 4407,
        'i', 4333,
        'j', 4590,
        'l', 4213,
        'm', 4115,
        'n', 3950,
        'o', 4448,
        'p', 4467,
        'r', 4075,
        's', 3917,
        'u', 3919,
        'v', 4511,
        'w', 4114,
        'z', 4119,
        '{', 3908,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(12);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3151);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= '_') ||
          ('f' <= lookahead && lookahead <= 'y')) ADVANCE(4651);
      END_STATE();
    case 12:
      ADVANCE_MAP(
        '"', 13,
        '(', 3359,
        ')', 3360,
        '+', 3094,
        ',', 3350,
        '-', 4646,
        '0', 3149,
        ':', 3631,
        ';', 3118,
        '[', 3345,
        ']', 3346,
        '^', 25,
        'a', 4272,
        'b', 4589,
        'c', 4405,
        'd', 4109,
        'e', 4283,
        'h', 4407,
        'i', 4333,
        'j', 4590,
        'l', 4213,
        'm', 4115,
        'n', 3950,
        'o', 4448,
        'p', 4467,
        'r', 4075,
        's', 3917,
        'u', 3919,
        'v', 4511,
        'w', 4114,
        'z', 4119,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(12);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3151);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= '_') ||
          ('f' <= lookahead && lookahead <= 'y')) ADVANCE(4651);
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(3136);
      if (lookahead != 0) ADVANCE(13);
      END_STATE();
    case 14:
      if (lookahead == '"') ADVANCE(3130);
      if (lookahead != 0) ADVANCE(14);
      END_STATE();
    case 15:
      if (lookahead == '"') ADVANCE(3120);
      if (lookahead != 0) ADVANCE(15);
      END_STATE();
    case 16:
      if (lookahead == '"') ADVANCE(3126);
      if (lookahead != 0) ADVANCE(16);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(3123);
      if (lookahead != 0) ADVANCE(17);
      END_STATE();
    case 18:
      if (lookahead == '"') ADVANCE(3133);
      if (lookahead != 0) ADVANCE(18);
      END_STATE();
    case 19:
      if (lookahead == '"') ADVANCE(3161);
      if (lookahead != 0) ADVANCE(19);
      END_STATE();
    case 20:
      if (lookahead == '"') ADVANCE(3137);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 21:
      if (lookahead == '"') ADVANCE(14);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3131);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3132);
      END_STATE();
    case 22:
      if (lookahead == '"') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3121);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3122);
      END_STATE();
    case 23:
      if (lookahead == '"') ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3127);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3128);
      END_STATE();
    case 24:
      if (lookahead == '"') ADVANCE(17);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3124);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3125);
      END_STATE();
    case 25:
      if (lookahead == '"') ADVANCE(18);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3134);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3135);
      END_STATE();
    case 26:
      if (lookahead == '"') ADVANCE(19);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(736);
      if (lookahead == 'l') ADVANCE(458);
      if (lookahead == 'm') ADVANCE(981);
      if (lookahead == 'o') ADVANCE(732);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 27:
      if (lookahead == '"') ADVANCE(19);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(737);
      if (lookahead == 'l') ADVANCE(458);
      if (lookahead == 'm') ADVANCE(981);
      if (lookahead == 'o') ADVANCE(732);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 28:
      if (lookahead == '"') ADVANCE(19);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(737);
      if (lookahead == 'l') ADVANCE(458);
      if (lookahead == 'm') ADVANCE(981);
      if (lookahead == 'o') ADVANCE(832);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 29:
      ADVANCE_MAP(
        '"', 19,
        'a', 2318,
        'c', 3285,
        'f', 2103,
        'l', 1902,
        'm', 2668,
        'o', 2315,
        'x', 3045,
      );
      END_STATE();
    case 30:
      if (lookahead == '"') ADVANCE(19);
      if (lookahead == 'a') ADVANCE(2401);
      if (lookahead == 'c') ADVANCE(3285);
      if (lookahead == 'f') ADVANCE(2103);
      if (lookahead == 'o') ADVANCE(2317);
      if (lookahead == 'x') ADVANCE(3045);
      END_STATE();
    case 31:
      if (lookahead == '"') ADVANCE(19);
      if (lookahead == 'a') ADVANCE(2359);
      if (lookahead == 'c') ADVANCE(3285);
      if (lookahead == 'f') ADVANCE(2103);
      if (lookahead == 'l') ADVANCE(1902);
      if (lookahead == 'o') ADVANCE(2317);
      if (lookahead == 'x') ADVANCE(3045);
      END_STATE();
    case 32:
      if (lookahead == '"') ADVANCE(19);
      if (lookahead == 'a') ADVANCE(2319);
      if (lookahead == 'l') ADVANCE(2033);
      if (lookahead == 'm') ADVANCE(2668);
      if (lookahead == 'o') ADVANCE(2351);
      END_STATE();
    case 33:
      if (lookahead == '"') ADVANCE(19);
      if (lookahead == 'a') ADVANCE(2962);
      if (lookahead == 'l') ADVANCE(1902);
      if (lookahead == 'o') ADVANCE(2350);
      END_STATE();
    case 34:
      if (lookahead == '"') ADVANCE(19);
      if (lookahead == 'a') ADVANCE(2962);
      if (lookahead == 'l') ADVANCE(1902);
      if (lookahead == 'o') ADVANCE(2457);
      END_STATE();
    case 35:
      if (lookahead == '"') ADVANCE(19);
      if (lookahead == 'o') ADVANCE(2457);
      END_STATE();
    case 36:
      ADVANCE_MAP(
        '"', 20,
        '#', 3091,
        '%', 23,
        '(', 3909,
        ')', 3360,
        '*', 3288,
        '+', 3090,
        ',', 3350,
        '-', 1294,
        '0', 3138,
        ';', 3118,
        '<', 3348,
        '@', 24,
        '[', 3345,
        'a', 288,
        'b', 618,
        'c', 27,
        'd', 392,
        'e', 730,
        'f', 147,
        'g', 277,
        'h', 628,
        'i', 323,
        'j', 1226,
        'l', 244,
        'm', 151,
        'n', 155,
        'o', 988,
        'p', 158,
        'r', 439,
        's', 64,
        't', 214,
        'u', 67,
        'v', 162,
        'w', 449,
        'x', 284,
        'z', 394,
        '{', 3341,
        '}', 3342,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(39);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3139);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('k' <= lookahead && lookahead <= 'y')) ADVANCE(1298);
      END_STATE();
    case 37:
      ADVANCE_MAP(
        '"', 20,
        '#', 3091,
        '%', 23,
        '(', 3359,
        '+', 3094,
        ',', 3350,
        '-', 1296,
        '0', 3145,
        ';', 3118,
        '=', 3164,
        '[', 3345,
        'a', 390,
        'b', 620,
        'c', 145,
        'd', 547,
        'e', 731,
        'f', 222,
        'g', 277,
        'h', 916,
        'i', 324,
        'j', 1226,
        'l', 245,
        'm', 152,
        'n', 156,
        'o', 988,
        'p', 159,
        'r', 393,
        's', 63,
        't', 215,
        'u', 69,
        'v', 162,
        'w', 665,
        'x', 284,
        'z', 514,
        '{', 3908,
        '}', 3342,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(38);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3146);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('k' <= lookahead && lookahead <= 'y')) ADVANCE(1298);
      END_STATE();
    case 38:
      ADVANCE_MAP(
        '"', 20,
        '#', 3091,
        '%', 23,
        '(', 3359,
        '+', 3094,
        ',', 3350,
        '-', 1296,
        '0', 3145,
        ';', 3118,
        '=', 3164,
        '[', 3345,
        'a', 390,
        'b', 620,
        'c', 145,
        'd', 547,
        'e', 731,
        'f', 222,
        'g', 277,
        'h', 916,
        'i', 324,
        'j', 1226,
        'l', 245,
        'm', 152,
        'n', 156,
        'o', 988,
        'p', 159,
        'r', 393,
        's', 63,
        't', 215,
        'u', 69,
        'v', 162,
        'w', 665,
        'x', 284,
        'z', 514,
        '}', 3342,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(38);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3146);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('k' <= lookahead && lookahead <= 'y')) ADVANCE(1298);
      END_STATE();
    case 39:
      ADVANCE_MAP(
        '"', 20,
        '#', 3091,
        '%', 23,
        ')', 3360,
        '*', 3288,
        '+', 3090,
        ',', 3350,
        '-', 1294,
        '0', 3138,
        ';', 3118,
        '<', 3348,
        '@', 24,
        '[', 3345,
        'a', 288,
        'b', 618,
        'c', 27,
        'd', 392,
        'e', 730,
        'f', 147,
        'g', 277,
        'h', 628,
        'i', 323,
        'j', 1226,
        'l', 244,
        'm', 151,
        'n', 155,
        'o', 988,
        'p', 158,
        'r', 439,
        's', 64,
        't', 214,
        'u', 67,
        'v', 162,
        'w', 449,
        'x', 284,
        'z', 394,
        '{', 3341,
        '}', 3342,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(39);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3139);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('k' <= lookahead && lookahead <= 'y')) ADVANCE(1298);
      END_STATE();
    case 40:
      ADVANCE_MAP(
        '"', 20,
        '%', 23,
        '*', 3288,
        '+', 3090,
        ',', 3350,
        '-', 1294,
        '0', 3138,
        ';', 3118,
        '<', 3348,
        '@', 24,
        '[', 3345,
        'a', 289,
        'b', 619,
        'c', 28,
        'd', 488,
        'e', 1261,
        'f', 147,
        'g', 451,
        'h', 629,
        'i', 326,
        'l', 244,
        'm', 154,
        'n', 211,
        'o', 1006,
        'p', 608,
        'r', 443,
        's', 65,
        't', 214,
        'u', 68,
        'v', 163,
        'w', 450,
        'x', 284,
        'z', 526,
        '{', 3341,
        '}', 3342,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(40);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3139);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('j' <= lookahead && lookahead <= 'y')) ADVANCE(1298);
      END_STATE();
    case 41:
      ADVANCE_MAP(
        '%', 23,
        ';', 3118,
        '<', 3348,
        '[', 3345,
        'b', 2053,
        'd', 2575,
        'f', 2307,
        'h', 1404,
        'i', 3092,
        'l', 1422,
        'm', 2024,
        'o', 2675,
        'p', 2665,
        't', 2618,
        'v', 2603,
        'x', 119,
        '{', 3341,
        '}', 1300,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(41);
      END_STATE();
    case 42:
      if (lookahead == '+') ADVANCE(3093);
      if (lookahead == '-') ADVANCE(1295);
      if (lookahead == ':') ADVANCE(3129);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3156);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 43:
      if (lookahead == ',') ADVANCE(3350);
      if (lookahead == ';') ADVANCE(3118);
      if (lookahead == 'x') ADVANCE(3353);
      if (lookahead == '}') ADVANCE(1300);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(43);
      END_STATE();
    case 44:
      ADVANCE_MAP(
        '-', 2262,
        '_', 1629,
        'a', 2337,
        'b', 3018,
        'c', 1398,
        'd', 1931,
        'f', 2770,
        'i', 2465,
        'm', 1936,
        'n', 1818,
        'p', 2738,
        'r', 1819,
        's', 1436,
        't', 1487,
        'u', 2477,
      );
      END_STATE();
    case 45:
      ADVANCE_MAP(
        '-', 2262,
        '_', 1629,
        'a', 2337,
        'b', 3018,
        'c', 1398,
        'd', 2986,
        'f', 2770,
        'i', 2465,
        'm', 1936,
        'n', 1818,
        'p', 2738,
        'r', 1819,
        's', 1436,
        'u', 2477,
      );
      END_STATE();
    case 46:
      ADVANCE_MAP(
        '-', 2262,
        '_', 1629,
        'a', 2337,
        'b', 3018,
        'c', 1398,
        'd', 2986,
        'f', 2770,
        'i', 2465,
        'm', 1936,
        'n', 2330,
        'p', 2738,
        'r', 1819,
        's', 1436,
        'u', 2477,
      );
      END_STATE();
    case 47:
      ADVANCE_MAP(
        '-', 2262,
        'a', 2337,
        'b', 3018,
        'c', 1398,
        'd', 2986,
        'f', 2770,
        'i', 2465,
        'm', 1936,
        'n', 2330,
        'p', 2738,
        'r', 1819,
        's', 1436,
        'u', 2477,
      );
      END_STATE();
    case 48:
      ADVANCE_MAP(
        '-', 697,
        ':', 3129,
        '_', 293,
        'a', 750,
        'b', 1238,
        'c', 173,
        'd', 1216,
        'f', 1049,
        'i', 829,
        'm', 480,
        'n', 397,
        'p', 1033,
        'r', 399,
        's', 187,
        't', 227,
        'u', 838,
      );
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('e' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 49:
      ADVANCE_MAP(
        '-', 697,
        ':', 3129,
        'a', 750,
        'b', 1238,
        'c', 173,
        'd', 1216,
        'f', 1049,
        'i', 829,
        'm', 480,
        'n', 746,
        'p', 1033,
        'r', 399,
        's', 187,
        't', 227,
        'u', 838,
      );
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('e' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 50:
      if (lookahead == '-') ADVANCE(1172);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'b') ADVANCE(1014);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 51:
      if (lookahead == '-') ADVANCE(2928);
      END_STATE();
    case 52:
      if (lookahead == '-') ADVANCE(2928);
      if (lookahead == 'b') ADVANCE(2712);
      END_STATE();
    case 53:
      if (lookahead == '-') ADVANCE(1109);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 54:
      if (lookahead == '-') ADVANCE(2839);
      END_STATE();
    case 55:
      if (lookahead == '-') ADVANCE(1060);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 56:
      if (lookahead == '-') ADVANCE(2765);
      END_STATE();
    case 57:
      if (lookahead == '-') ADVANCE(2979);
      END_STATE();
    case 58:
      if (lookahead == '-') ADVANCE(1210);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 59:
      if (lookahead == '.') ADVANCE(3361);
      END_STATE();
    case 60:
      if (lookahead == '.') ADVANCE(59);
      END_STATE();
    case 61:
      if (lookahead == '0') ADVANCE(3305);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 62:
      if (lookahead == '0') ADVANCE(3304);
      END_STATE();
    case 63:
      ADVANCE_MAP(
        '0', 1256,
        ':', 3129,
        'a', 573,
        'd', 631,
        'e', 331,
        'h', 189,
        'i', 593,
        'p', 463,
        'r', 444,
        's', 971,
        't', 943,
        'u', 260,
        'w', 622,
      );
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 64:
      ADVANCE_MAP(
        '0', 1256,
        ':', 3129,
        'a', 573,
        'd', 631,
        'e', 330,
        'h', 189,
        'i', 593,
        'p', 463,
        'r', 444,
        's', 971,
        't', 943,
        'u', 260,
        'w', 622,
        'y', 874,
      );
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 65:
      ADVANCE_MAP(
        '0', 1256,
        ':', 3129,
        'd', 631,
        'e', 777,
        'h', 714,
        'i', 1155,
        'r', 478,
        't', 944,
        'u', 260,
        'w', 669,
        'y', 874,
      );
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 66:
      ADVANCE_MAP(
        '0', 1256,
        ':', 3129,
        'd', 633,
        'i', 1196,
        'm', 178,
        'n', 372,
        'r', 457,
        's', 522,
        'w', 1208,
      );
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 67:
      ADVANCE_MAP(
        '0', 1256,
        ':', 3129,
        'd', 633,
        'i', 1196,
        'm', 178,
        'n', 371,
        'r', 457,
        's', 522,
        'w', 1208,
      );
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 68:
      ADVANCE_MAP(
        '0', 1256,
        ':', 3129,
        'd', 633,
        'i', 1196,
        'm', 178,
        'n', 371,
        'r', 457,
        's', 522,
      );
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 69:
      ADVANCE_MAP(
        '0', 1256,
        ':', 3129,
        'd', 633,
        'i', 1196,
        'm', 178,
        'n', 1063,
        'r', 457,
        's', 522,
        'w', 1208,
      );
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 70:
      if (lookahead == '0') ADVANCE(3039);
      END_STATE();
    case 71:
      ADVANCE_MAP(
        '0', 3039,
        'a', 2072,
        'd', 2158,
        'e', 1689,
        'g', 1810,
        'h', 1421,
        'i', 1758,
        'l', 1811,
        'o', 3000,
        'p', 1919,
        'r', 1889,
        's', 2652,
        't', 2622,
        'u', 1560,
        'w', 2150,
        'y', 2502,
      );
      END_STATE();
    case 72:
      ADVANCE_MAP(
        '0', 3039,
        'a', 2072,
        'd', 2158,
        'e', 1690,
        'h', 1421,
        'i', 2105,
        'o', 3000,
        'p', 1918,
        'r', 1889,
        's', 2652,
        't', 2622,
        'u', 1560,
        'w', 2205,
      );
      END_STATE();
    case 73:
      ADVANCE_MAP(
        '0', 3039,
        'a', 2073,
        'd', 2158,
        'e', 1690,
        'h', 1421,
        'i', 2105,
        'o', 3000,
        'p', 1918,
        'r', 1889,
        's', 2652,
        't', 2732,
        'u', 1560,
        'w', 2211,
      );
      END_STATE();
    case 74:
      ADVANCE_MAP(
        '0', 3039,
        'a', 2073,
        'd', 2158,
        'e', 2339,
        'h', 1421,
        'i', 2105,
        'p', 1919,
        'r', 1889,
        's', 2652,
        't', 2732,
        'u', 1560,
        'w', 2170,
        'y', 2530,
      );
      END_STATE();
    case 75:
      ADVANCE_MAP(
        '0', 3039,
        'a', 2073,
        'd', 2158,
        'e', 2340,
        'h', 1421,
        'i', 2105,
        'p', 1919,
        'r', 1889,
        's', 2652,
        't', 2732,
        'u', 1560,
        'w', 2170,
        'y', 2532,
      );
      END_STATE();
    case 76:
      ADVANCE_MAP(
        '0', 3039,
        'a', 2073,
        'e', 1691,
        'h', 1420,
        'i', 2104,
        'o', 3000,
        'p', 1918,
        'r', 1990,
        's', 2652,
        't', 2732,
        'w', 2211,
        'y', 2530,
      );
      END_STATE();
    case 77:
      ADVANCE_MAP(
        '0', 3039,
        'a', 2073,
        'e', 2700,
        'h', 1420,
        'i', 2104,
        'o', 3000,
        'p', 1919,
        'r', 1990,
        's', 2652,
        't', 2732,
        'u', 1560,
        'w', 2170,
        'y', 2530,
      );
      END_STATE();
    case 78:
      ADVANCE_MAP(
        '0', 3039,
        'a', 2073,
        'e', 2700,
        'h', 1420,
        'i', 2104,
        'o', 3000,
        'p', 1919,
        'r', 1990,
        's', 2652,
        't', 2732,
        'w', 2170,
        'y', 2530,
      );
      END_STATE();
    case 79:
      ADVANCE_MAP(
        '0', 3039,
        'd', 2158,
        'e', 2339,
        'g', 1810,
        'h', 2283,
        'i', 2909,
        'l', 1811,
        'o', 3000,
        'r', 1947,
        'u', 1560,
        'y', 2530,
      );
      END_STATE();
    case 80:
      ADVANCE_MAP(
        '0', 3039,
        'd', 2158,
        'e', 2339,
        'h', 2283,
        'i', 2909,
        'o', 3000,
        'r', 1947,
        'u', 1560,
        'y', 2530,
      );
      END_STATE();
    case 81:
      if (lookahead == '0') ADVANCE(3039);
      if (lookahead == 'd') ADVANCE(2158);
      if (lookahead == 'e') ADVANCE(2340);
      if (lookahead == 'h') ADVANCE(2283);
      if (lookahead == 'i') ADVANCE(2909);
      if (lookahead == 'r') ADVANCE(1947);
      if (lookahead == 'u') ADVANCE(1560);
      END_STATE();
    case 82:
      ADVANCE_MAP(
        '0', 3039,
        'd', 2160,
        'e', 2698,
        'g', 1812,
        'i', 2965,
        'l', 1813,
        'm', 1412,
        'n', 1761,
        'r', 1911,
        's', 2002,
        'w', 2911,
      );
      END_STATE();
    case 83:
      ADVANCE_MAP(
        '0', 3039,
        'd', 2160,
        'g', 1812,
        'i', 2965,
        'l', 1813,
        'm', 1412,
        'n', 1764,
        'r', 1911,
        's', 2002,
      );
      END_STATE();
    case 84:
      if (lookahead == '0') ADVANCE(3039);
      if (lookahead == 'd') ADVANCE(2160);
      if (lookahead == 'i') ADVANCE(2965);
      if (lookahead == 'm') ADVANCE(1412);
      if (lookahead == 'n') ADVANCE(1763);
      if (lookahead == 'r') ADVANCE(1911);
      if (lookahead == 'w') ADVANCE(2911);
      END_STATE();
    case 85:
      ADVANCE_MAP(
        '0', 3039,
        'd', 2160,
        'i', 2965,
        'm', 1412,
        'n', 1765,
        'r', 1911,
        's', 2002,
        'w', 2911,
      );
      END_STATE();
    case 86:
      if (lookahead == '0') ADVANCE(3039);
      if (lookahead == 'd') ADVANCE(2160);
      if (lookahead == 'i') ADVANCE(2965);
      if (lookahead == 'm') ADVANCE(1412);
      if (lookahead == 'n') ADVANCE(1764);
      if (lookahead == 'r') ADVANCE(1911);
      if (lookahead == 's') ADVANCE(2002);
      END_STATE();
    case 87:
      ADVANCE_MAP(
        '0', 3039,
        'd', 2160,
        'i', 2965,
        'm', 1412,
        'n', 1762,
        'r', 1911,
        's', 2002,
        'w', 2911,
      );
      END_STATE();
    case 88:
      if (lookahead == '0') ADVANCE(3039);
      if (lookahead == 'd') ADVANCE(2160);
      if (lookahead == 'i') ADVANCE(2965);
      if (lookahead == 'm') ADVANCE(1412);
      if (lookahead == 'n') ADVANCE(1762);
      if (lookahead == 'r') ADVANCE(1911);
      if (lookahead == 'w') ADVANCE(2911);
      END_STATE();
    case 89:
      if (lookahead == '0') ADVANCE(3039);
      if (lookahead == 'd') ADVANCE(2160);
      if (lookahead == 'i') ADVANCE(2965);
      if (lookahead == 'm') ADVANCE(1412);
      if (lookahead == 'n') ADVANCE(1760);
      if (lookahead == 'r') ADVANCE(1911);
      END_STATE();
    case 90:
      if (lookahead == '0') ADVANCE(3039);
      if (lookahead == 'e') ADVANCE(2698);
      if (lookahead == 'g') ADVANCE(1812);
      if (lookahead == 'l') ADVANCE(1813);
      if (lookahead == 'n') ADVANCE(1814);
      END_STATE();
    case 91:
      if (lookahead == '0') ADVANCE(3039);
      if (lookahead == 'm') ADVANCE(1412);
      if (lookahead == 'n') ADVANCE(2499);
      if (lookahead == 's') ADVANCE(2002);
      if (lookahead == 'w') ADVANCE(2911);
      END_STATE();
    case 92:
      if (lookahead == '0') ADVANCE(3039);
      if (lookahead == 'n') ADVANCE(2499);
      if (lookahead == 's') ADVANCE(2002);
      if (lookahead == 'w') ADVANCE(2911);
      END_STATE();
    case 93:
      if (lookahead == '0') ADVANCE(1319);
      END_STATE();
    case 94:
      if (lookahead == '1') ADVANCE(99);
      END_STATE();
    case 95:
      if (lookahead == '1') ADVANCE(99);
      if (lookahead == 'e') ADVANCE(3047);
      if (lookahead == 't') ADVANCE(2573);
      END_STATE();
    case 96:
      if (lookahead == '1') ADVANCE(100);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1264);
      if (lookahead == 't') ADVANCE(911);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 97:
      if (lookahead == '1') ADVANCE(101);
      END_STATE();
    case 98:
      if (lookahead == '1') ADVANCE(102);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 99:
      if (lookahead == '2') ADVANCE(110);
      END_STATE();
    case 100:
      if (lookahead == '2') ADVANCE(113);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 101:
      if (lookahead == '2') ADVANCE(111);
      END_STATE();
    case 102:
      if (lookahead == '2') ADVANCE(115);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 103:
      if (lookahead == '3') ADVANCE(93);
      END_STATE();
    case 104:
      if (lookahead == '4') ADVANCE(103);
      END_STATE();
    case 105:
      if (lookahead == '4') ADVANCE(1321);
      END_STATE();
    case 106:
      if (lookahead == '6') ADVANCE(105);
      END_STATE();
    case 107:
      if (lookahead == '6') ADVANCE(122);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 108:
      if (lookahead == '6') ADVANCE(1306);
      END_STATE();
    case 109:
      if (lookahead == '6') ADVANCE(1307);
      END_STATE();
    case 110:
      if (lookahead == '8') ADVANCE(3308);
      END_STATE();
    case 111:
      if (lookahead == '8') ADVANCE(3311);
      END_STATE();
    case 112:
      if (lookahead == '8') ADVANCE(107);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(609);
      if (lookahead == 'o') ADVANCE(1008);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 113:
      if (lookahead == '8') ADVANCE(3309);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 114:
      if (lookahead == '8') ADVANCE(61);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 115:
      if (lookahead == '8') ADVANCE(3312);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 116:
      if (lookahead == '8') ADVANCE(108);
      END_STATE();
    case 117:
      if (lookahead == '8') ADVANCE(108);
      if (lookahead == 'c') ADVANCE(2136);
      if (lookahead == 'o') ADVANCE(2720);
      END_STATE();
    case 118:
      if (lookahead == '8') ADVANCE(62);
      END_STATE();
    case 119:
      if (lookahead == '8') ADVANCE(109);
      END_STATE();
    case 120:
      if (lookahead == '8') ADVANCE(109);
      if (lookahead == 'c') ADVANCE(2136);
      if (lookahead == 'o') ADVANCE(2720);
      END_STATE();
    case 121:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(780);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 122:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(179);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 123:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(248);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 124:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(1252);
      if (lookahead == 'a') ADVANCE(723);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 125:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(293);
      if (lookahead == 'n') ADVANCE(398);
      if (lookahead == 't') ADVANCE(227);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 126:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(566);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 127:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(294);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 128:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(1066);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 129:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(306);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 130:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(336);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 131:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(1185);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 132:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(906);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 133:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(472);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 134:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(1115);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 135:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(640);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 136:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(614);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 137:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(997);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 138:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(193);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 139:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(754);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 140:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(210);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 141:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(937);
      if (lookahead == 'o') ADVANCE(879);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 142:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(1076);
      if (lookahead == 'u') ADVANCE(688);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 143:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(656);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 144:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(1247);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 145:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(736);
      if (lookahead == 'l') ADVANCE(458);
      if (lookahead == 'm') ADVANCE(981);
      if (lookahead == 'o') ADVANCE(733);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 146:
      ADVANCE_MAP(
        ':', 3129,
        'a', 363,
        'c', 810,
        'd', 627,
        'e', 856,
        'i', 790,
        'l', 920,
        'm', 1217,
        'n', 448,
        'p', 96,
        'r', 395,
        's', 1214,
      );
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 147:
      ADVANCE_MAP(
        ':', 3129,
        'a', 363,
        'c', 810,
        'd', 627,
        'e', 856,
        'i', 790,
        'm', 1217,
        'n', 448,
        'p', 453,
        'r', 395,
        's', 1214,
      );
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 148:
      ADVANCE_MAP(
        ':', 3129,
        'a', 363,
        'c', 810,
        'd', 627,
        'e', 856,
        'l', 920,
        'm', 1217,
        'n', 448,
        'p', 96,
        'r', 395,
        's', 1214,
      );
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 149:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(264);
      if (lookahead == 'i') ADVANCE(855);
      if (lookahead == 'o') ADVANCE(180);
      if (lookahead == 's') ADVANCE(611);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 150:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1255);
      if (lookahead == 'e') ADVANCE(814);
      if (lookahead == 'i') ADVANCE(837);
      if (lookahead == 'u') ADVANCE(712);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 151:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1255);
      if (lookahead == 'e') ADVANCE(815);
      if (lookahead == 'i') ADVANCE(837);
      if (lookahead == 'o') ADVANCE(869);
      if (lookahead == 'u') ADVANCE(712);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 152:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1255);
      if (lookahead == 'e') ADVANCE(815);
      if (lookahead == 'i') ADVANCE(837);
      if (lookahead == 'u') ADVANCE(712);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 153:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1255);
      if (lookahead == 'e') ADVANCE(1183);
      if (lookahead == 'i') ADVANCE(854);
      if (lookahead == 'o') ADVANCE(869);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 154:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1255);
      if (lookahead == 'i') ADVANCE(854);
      if (lookahead == 'o') ADVANCE(869);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 155:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(706);
      if (lookahead == 'e') ADVANCE(1094);
      if (lookahead == 'o') ADVANCE(48);
      if (lookahead == 'u') ADVANCE(740);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 156:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(706);
      if (lookahead == 'e') ADVANCE(1094);
      if (lookahead == 'o') ADVANCE(49);
      if (lookahead == 'u') ADVANCE(762);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 157:
      ADVANCE_MAP(
        ':', 3129,
        'a', 1029,
        'e', 1023,
        'h', 621,
        'o', 689,
        'p', 286,
        'r', 445,
        't', 1007,
      );
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 158:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1029);
      if (lookahead == 'e') ADVANCE(1023);
      if (lookahead == 'h') ADVANCE(621);
      if (lookahead == 'o') ADVANCE(689);
      if (lookahead == 'r') ADVANCE(445);
      if (lookahead == 't') ADVANCE(1070);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 159:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1029);
      if (lookahead == 'e') ADVANCE(1023);
      if (lookahead == 'h') ADVANCE(621);
      if (lookahead == 'r') ADVANCE(446);
      if (lookahead == 't') ADVANCE(1070);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 160:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(138);
      if (lookahead == 'o') ADVANCE(637);
      if (lookahead == 's') ADVANCE(328);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 161:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(138);
      if (lookahead == 'o') ADVANCE(637);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 162:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(138);
      if (lookahead == 's') ADVANCE(328);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 163:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(138);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 164:
      ADVANCE_MAP(
        ':', 3129,
        'a', 329,
        'd', 636,
        'l', 666,
        'r', 455,
        's', 513,
        't', 523,
        'v', 940,
      );
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 165:
      ADVANCE_MAP(
        ':', 3129,
        'a', 329,
        'd', 636,
        'l', 666,
        'r', 455,
        's', 513,
        't', 1157,
        'v', 940,
      );
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 166:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1004);
      if (lookahead == 't') ADVANCE(576);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 167:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1004);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 168:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1278);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 169:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(3708);
      if (lookahead == 's') ADVANCE(676);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 170:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(3708);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 171:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(3571);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 172:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(3318);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 173:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(752);
      if (lookahead == 'f') ADVANCE(127);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 174:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1281);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 175:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(711);
      if (lookahead == 'i') ADVANCE(365);
      if (lookahead == 'o') ADVANCE(1121);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 176:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(711);
      if (lookahead == 'i') ADVANCE(365);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 177:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(698);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 178:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1257);
      if (lookahead == 'i') ADVANCE(839);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 179:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(816);
      if (lookahead == 'f') ADVANCE(980);
      if (lookahead == 'm') ADVANCE(818);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 180:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(347);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 181:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1083);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 182:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1091);
      if (lookahead == 'e') ADVANCE(1044);
      if (lookahead == 's') ADVANCE(497);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 183:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(893);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 184:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(703);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 185:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(349);
      if (lookahead == 'l') ADVANCE(496);
      if (lookahead == 's') ADVANCE(1228);
      if (lookahead == 't') ADVANCE(3642);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 186:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(349);
      if (lookahead == 's') ADVANCE(1228);
      if (lookahead == 't') ADVANCE(3642);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 187:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(909);
      if (lookahead == 'y') ADVANCE(864);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 188:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1024);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 189:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(369);
      if (lookahead == 'l') ADVANCE(3764);
      if (lookahead == 'u') ADVANCE(565);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 190:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1127);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 191:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(370);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 192:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(719);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 193:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1028);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 194:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(589);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 195:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1130);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 196:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(352);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 197:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(794);
      if (lookahead == 'f') ADVANCE(634);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 198:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1131);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 199:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(296);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 200:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(356);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 201:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(357);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 202:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(724);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 203:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(360);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 204:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(367);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 205:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(726);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 206:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(782);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 207:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(896);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 208:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1152);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 209:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(776);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 210:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1082);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 211:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(858);
      if (lookahead == 'o') ADVANCE(125);
      if (lookahead == 'u') ADVANCE(763);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 212:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1149);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 213:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(635);
      if (lookahead == 'o') ADVANCE(707);
      if (lookahead == 'r') ADVANCE(1212);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 214:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(635);
      if (lookahead == 'r') ADVANCE(1212);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 215:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(635);
      if (lookahead == 'r') ADVANCE(1237);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 216:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1225);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 217:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(368);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 218:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(292);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 219:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(764);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 220:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(638);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 221:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1101);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 222:
      ADVANCE_MAP(
        ':', 3129,
        'a', 364,
        'c', 810,
        'd', 627,
        'e', 856,
        'm', 1217,
        'n', 448,
        'p', 453,
        'r', 395,
        's', 1214,
      );
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 223:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1175);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 224:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(295);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 225:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1167);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 226:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(341);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 227:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(643);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 228:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1110);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 229:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(297);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 230:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(758);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 231:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(319);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 232:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(598);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 233:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(648);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 234:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1105);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 235:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1178);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 236:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(760);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 237:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(302);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 238:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(321);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 239:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(779);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 240:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1180);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 241:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(800);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 242:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(799);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 243:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(265);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 244:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(857);
      if (lookahead == 'i') ADVANCE(855);
      if (lookahead == 'o') ADVANCE(180);
      if (lookahead == 's') ADVANCE(611);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 245:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(857);
      if (lookahead == 'o') ADVANCE(180);
      if (lookahead == 's') ADVANCE(611);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 246:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 247:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(785);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 248:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(385);
      if (lookahead == 'h') ADVANCE(1254);
      if (lookahead == 'm') ADVANCE(467);
      if (lookahead == 't') ADVANCE(616);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 249:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(266);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 250:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(387);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 251:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(1203);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 252:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(267);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 253:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(268);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 254:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(269);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 255:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(271);
      if (lookahead == 'i') ADVANCE(1243);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 256:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(272);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 257:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(273);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 258:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(274);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 259:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'a') ADVANCE(910);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 260:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'b') ADVANCE(3787);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 261:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'b') ADVANCE(3809);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 262:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'b') ADVANCE(759);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 263:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'b') ADVANCE(1014);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 264:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'b') ADVANCE(489);
      if (lookahead == 'n') ADVANCE(366);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 265:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'b') ADVANCE(765);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 266:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'b') ADVANCE(767);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 267:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'b') ADVANCE(768);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 268:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'b') ADVANCE(769);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 269:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'b') ADVANCE(771);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 270:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'b') ADVANCE(654);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 271:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'b') ADVANCE(772);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 272:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'b') ADVANCE(773);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 273:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'b') ADVANCE(774);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 274:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'b') ADVANCE(775);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 275:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'b') ADVANCE(229);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 276:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'b') ADVANCE(796);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 277:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(3373);
      if (lookahead == 'e') ADVANCE(1161);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 278:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(169);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 279:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(3835);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 280:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(3466);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 281:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(3841);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 282:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(3605);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 283:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(3861);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 284:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(609);
      if (lookahead == 'o') ADVANCE(1008);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 285:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(603);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 286:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(126);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 287:
      ADVANCE_MAP(
        ':', 3129,
        'c', 1003,
        'd', 343,
        'l', 795,
        'n', 344,
        'p', 982,
        's', 610,
        't', 917,
        'v', 220,
      );
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 288:
      ADVANCE_MAP(
        ':', 3129,
        'c', 1003,
        'd', 389,
        'l', 626,
        'n', 344,
        'p', 982,
        'r', 591,
        's', 610,
        't', 917,
        'v', 220,
      );
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 289:
      ADVANCE_MAP(
        ':', 3129,
        'c', 1003,
        'd', 389,
        'l', 795,
        'n', 344,
        'p', 982,
        's', 610,
        't', 917,
        'v', 220,
      );
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 290:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(604);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 291:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(709);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 292:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(699);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 293:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(574);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 294:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(613);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 295:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(700);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 296:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(617);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 297:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(701);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 298:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(605);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 299:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(702);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 300:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(1224);
      if (lookahead == 'd') ADVANCE(1292);
      if (lookahead == 't') ADVANCE(1231);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 301:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(606);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 302:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(704);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 303:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(221);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 304:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(1027);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 305:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(1104);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 306:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(955);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 307:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(171);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 308:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(1133);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 309:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(1191);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 310:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(230);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 311:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(948);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 312:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(658);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 313:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(402);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 314:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(170);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 315:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(1139);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 316:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(462);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 317:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(416);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 318:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(1153);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 319:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(420);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 320:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(435);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 321:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(549);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 322:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(812);
      if (lookahead == 'm') ADVANCE(819);
      if (lookahead == 'n') ADVANCE(164);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3338);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 323:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(812);
      if (lookahead == 'm') ADVANCE(819);
      if (lookahead == 'n') ADVANCE(164);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 324:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(812);
      if (lookahead == 'm') ADVANCE(819);
      if (lookahead == 'n') ADVANCE(165);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 325:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(812);
      if (lookahead == 'n') ADVANCE(388);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3338);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 326:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(812);
      if (lookahead == 'n') ADVANCE(388);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 327:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(612);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 328:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(219);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 329:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(316);
      if (lookahead == 'l') ADVANCE(784);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 330:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(1163);
      if (lookahead == 'l') ADVANCE(473);
      if (lookahead == 'q') ADVANCE(130);
      if (lookahead == 'x') ADVANCE(1125);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 331:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(1163);
      if (lookahead == 'l') ADVANCE(473);
      if (lookahead == 'x') ADVANCE(1125);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 332:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(1219);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 333:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(552);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 334:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(1177);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 335:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(205);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 336:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(1107);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 337:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(234);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 338:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(235);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 339:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(1192);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 340:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(240);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 341:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(1207);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 342:
      ADVANCE_MAP(
        ':', 3129,
        'd', 343,
        'l', 626,
        'n', 344,
        'p', 982,
        'r', 591,
        's', 610,
        't', 917,
        'v', 220,
      );
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 343:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(3782);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 344:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(3789);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 345:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(3393);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 346:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(3807);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 347:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(3710);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 348:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(3791);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 349:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(904);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 350:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(3290);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 351:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(3421);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 352:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(3681);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 353:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(3469);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 354:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(3589);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 355:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(3217);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 356:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(3683);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 357:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(3696);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 358:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(3445);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 359:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(3553);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 360:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(3514);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 361:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(3478);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 362:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(3859);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 363:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(346);
      if (lookahead == 'l') ADVANCE(1103);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 364:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(346);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 365:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(375);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 366:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(642);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 367:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(136);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 368:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(381);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 369:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(912);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 370:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(225);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 371:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(466);
      if (lookahead == 'o') ADVANCE(1073);
      if (lookahead == 'r') ADVANCE(484);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 372:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(466);
      if (lookahead == 'r') ADVANCE(484);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 373:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(1013);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 374:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(1016);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 375:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(486);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 376:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(475);
      if (lookahead == 'w') ADVANCE(646);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 377:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(501);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 378:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(507);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 379:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(198);
      if (lookahead == 'm') ADVANCE(923);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 380:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(198);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 381:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(1058);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 382:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(649);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 383:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(1072);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 384:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(1077);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 385:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(383);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 386:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(546);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 387:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(384);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 388:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(694);
      if (lookahead == 's') ADVANCE(513);
      if (lookahead == 't') ADVANCE(523);
      if (lookahead == 'v') ADVANCE(940);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 389:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(3783);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 390:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'd') ADVANCE(389);
      if (lookahead == 'l') ADVANCE(626);
      if (lookahead == 'n') ADVANCE(344);
      if (lookahead == 'r') ADVANCE(591);
      if (lookahead == 's') ADVANCE(610);
      if (lookahead == 't') ADVANCE(917);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 391:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(563);
      if (lookahead == 'i') ADVANCE(1093);
      if (lookahead == 'l') ADVANCE(710);
      if (lookahead == 'o') ADVANCE(1213);
      if (lookahead == 's') ADVANCE(913);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 392:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(563);
      if (lookahead == 'i') ADVANCE(1093);
      if (lookahead == 'l') ADVANCE(710);
      if (lookahead == 's') ADVANCE(913);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 393:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(186);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 394:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1026);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 395:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(396);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 396:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1283);
      if (lookahead == 'm') ADVANCE(3778);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 397:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3633);
      if (lookahead == 'l') ADVANCE(174);
      if (lookahead == 'n') ADVANCE(1229);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 398:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3633);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 399:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(300);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 400:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3731);
      if (lookahead == 'n') ADVANCE(279);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 401:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3734);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 402:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3721);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 403:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3715);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 404:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3302);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 405:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3650);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 406:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3670);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 407:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3433);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 408:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3332);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 409:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3648);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 410:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3418);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 411:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3442);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 412:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3484);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 413:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3487);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 414:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3172);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 415:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3619);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 416:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3184);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 417:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3439);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 418:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3377);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 419:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3490);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 420:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3356);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 421:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3384);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 422:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3415);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 423:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3583);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 424:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3448);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 425:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3460);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 426:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3451);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 427:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3577);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 428:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3729);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 429:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3430);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 430:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3641);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 431:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3387);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 432:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3727);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 433:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3526);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 434:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3550);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 435:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3502);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 436:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3594);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 437:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3211);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 438:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3475);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 439:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(185);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 440:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3863);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 441:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3865);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 442:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(3871);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 443:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(788);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 444:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(805);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 445:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(197);
      if (lookahead == 'i') ADVANCE(1242);
      if (lookahead == 'o') ADVANCE(748);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 446:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(197);
      if (lookahead == 'o') ADVANCE(749);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 447:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1002);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 448:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(580);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 449:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(177);
      if (lookahead == 'i') ADVANCE(741);
      if (lookahead == 'r') ADVANCE(663);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 450:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(177);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 451:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1161);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 452:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(559);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 453:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1264);
      if (lookahead == 't') ADVANCE(911);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 454:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(575);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 455:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(582);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 456:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(615);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 457:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(807);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 458:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(183);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 459:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(827);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 460:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1262);
      if (lookahead == 'i') ADVANCE(835);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 461:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(128);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 462:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1113);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 463:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(332);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 464:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(134);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 465:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(903);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 466:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(560);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 467:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(808);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 468:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1037);
      if (lookahead == 'r') ADVANCE(226);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 469:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(123);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 470:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1095);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 471:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(809);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 472:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1267);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 473:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(308);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 474:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(133);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 475:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(561);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 476:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(841);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 477:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(139);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 478:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(806);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 479:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(873);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 480:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1025);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 481:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(351);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 482:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1086);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 483:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(572);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 484:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(199);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 485:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(791);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 486:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(844);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 487:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(564);
      if (lookahead == 'l') ADVANCE(710);
      if (lookahead == 'o') ADVANCE(1213);
      if (lookahead == 's') ADVANCE(913);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 488:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(564);
      if (lookahead == 'l') ADVANCE(710);
      if (lookahead == 's') ADVANCE(913);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 489:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(720);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 490:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(334);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 491:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(592);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 492:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(354);
      if (lookahead == 's') ADVANCE(131);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 493:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(355);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 494:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(339);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 495:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(359);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 496:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(228);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 497:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(744);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 498:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1197);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 499:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1035);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 500:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(362);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 501:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1017);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 502:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1138);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 503:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1020);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 504:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1045);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 505:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1038);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 506:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1143);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 507:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(902);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 508:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(407);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 509:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(728);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 510:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1021);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 511:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(899);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 512:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(555);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 513:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1041);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 514:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1046);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 515:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1246);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 516:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1005);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 517:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1112);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 518:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(184);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 519:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(823);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 520:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1265);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 521:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 522:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(753);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 523:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1039);
      if (lookahead == 't') ADVANCE(941);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 524:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1096);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 525:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1067);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 526:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1047);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 527:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1266);
      if (lookahead == 'i') ADVANCE(907);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 528:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1266);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 529:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1098);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 530:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(882);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 531:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(868);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 532:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(831);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 533:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1056);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 534:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1099);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 535:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(315);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 536:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(883);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 537:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(825);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 538:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(299);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 539:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(947);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 540:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(318);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 541:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1054);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 542:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(885);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 543:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(203);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 544:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(886);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 545:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(888);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 546:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1062);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 547:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(1036);
      if (lookahead == 'i') ADVANCE(1093);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 548:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(828);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 549:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(337);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 550:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(833);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 551:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(834);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 552:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(257);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 553:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(802);
      if (lookahead == 'v') ADVANCE(206);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 554:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(804);
      if (lookahead == 'v') ADVANCE(247);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 555:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'e') ADVANCE(836);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 556:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(792);
      if (lookahead == 'i') ADVANCE(1184);
      if (lookahead == 'l') ADVANCE(915);
      if (lookahead == 'r') ADVANCE(3646);
      if (lookahead == 'u') ADVANCE(632);
      if (lookahead == 'y') ADVANCE(1032);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 557:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(792);
      if (lookahead == 'i') ADVANCE(1184);
      if (lookahead == 'l') ADVANCE(915);
      if (lookahead == 'r') ADVANCE(3646);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 558:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(3293);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 559:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(3568);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 560:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(3742);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 561:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(3616);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 562:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(3601);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 563:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(216);
      if (lookahead == 'r') ADVANCE(454);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 564:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(216);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 565:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(577);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 566:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(974);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 567:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(975);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 568:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(1215);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 569:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(976);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 570:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(1129);
      if (lookahead == 't') ADVANCE(290);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 571:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(978);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 572:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(1089);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 573:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(517);
      if (lookahead == 'n') ADVANCE(675);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 574:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(625);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 575:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(533);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 576:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(926);
      if (lookahead == 'n') ADVANCE(951);
      if (lookahead == 's') ADVANCE(670);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 577:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(766);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 578:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(686);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 579:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'f') ADVANCE(797);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 580:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'g') ADVANCE(3662);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 581:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'g') ADVANCE(3780);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 582:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'g') ADVANCE(3562);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 583:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'g') ADVANCE(3613);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 584:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'g') ADVANCE(3692);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 585:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'g') ADVANCE(3717);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 586:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'g') ADVANCE(3194);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 587:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'g') ADVANCE(3532);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 588:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'g') ADVANCE(3481);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 589:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'g') ADVANCE(3520);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 590:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'g') ADVANCE(3523);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 591:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'g') ADVANCE(822);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 592:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'g') ADVANCE(55);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 593:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'g') ADVANCE(877);
      if (lookahead == 't') ADVANCE(942);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 594:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'g') ADVANCE(840);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 595:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'g') ADVANCE(996);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 596:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'g') ADVANCE(411);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 597:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'g') ADVANCE(434);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 598:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'g') ADVANCE(438);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 599:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'g') ADVANCE(1221);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 600:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'g') ADVANCE(530);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 601:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'g') ADVANCE(1069);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 602:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'g') ADVANCE(830);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 603:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'h') ADVANCE(992);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 604:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'h') ADVANCE(3668);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 605:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'h') ADVANCE(3679);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 606:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'h') ADVANCE(3751);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 607:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'h') ADVANCE(621);
      if (lookahead == 'o') ADVANCE(689);
      if (lookahead == 'p') ADVANCE(286);
      if (lookahead == 'r') ADVANCE(630);
      if (lookahead == 't') ADVANCE(1007);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 608:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'h') ADVANCE(621);
      if (lookahead == 'o') ADVANCE(689);
      if (lookahead == 'r') ADVANCE(630);
      if (lookahead == 't') ADVANCE(1070);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 609:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'h') ADVANCE(581);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 610:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'h') ADVANCE(1009);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 611:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'h') ADVANCE(1010);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 612:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'h') ADVANCE(585);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 613:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'h') ADVANCE(538);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 614:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'h') ADVANCE(246);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 615:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'h') ADVANCE(679);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 616:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'h') ADVANCE(1059);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 617:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'h') ADVANCE(254);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 618:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1184);
      if (lookahead == 'l') ADVANCE(915);
      if (lookahead == 'r') ADVANCE(3646);
      if (lookahead == 'u') ADVANCE(632);
      if (lookahead == 'y') ADVANCE(1032);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 619:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1184);
      if (lookahead == 'l') ADVANCE(915);
      if (lookahead == 'r') ADVANCE(3646);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 620:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1184);
      if (lookahead == 'r') ADVANCE(3646);
      if (lookahead == 'u') ADVANCE(632);
      if (lookahead == 'y') ADVANCE(1032);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 621:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(3694);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 622:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(570);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 623:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(3853);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 624:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(3851);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 625:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(3170);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 626:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(594);
      if (lookahead == 'l') ADVANCE(919);
      if (lookahead == 'w') ADVANCE(168);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 627:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1239);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 628:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(365);
      if (lookahead == 'o') ADVANCE(1121);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 629:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(365);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 630:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1242);
      if (lookahead == 'o') ADVANCE(1189);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 631:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1240);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 632:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(783);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 633:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1241);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 634:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1258);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 635:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(718);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 636:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1075);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 637:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(350);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 638:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(803);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 639:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(304);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 640:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1097);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 641:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(181);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 642:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(859);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 643:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(721);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 644:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(312);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 645:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(847);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 646:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(865);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 647:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(908);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 648:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(725);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 649:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(861);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 650:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(361);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 651:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(850);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 652:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(901);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 653:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(283);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 654:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(871);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 655:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(863);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 656:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(900);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 657:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(866);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 658:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1160);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 659:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1156);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 660:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1166);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 661:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1284);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 662:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(276);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 663:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1171);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 664:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1248);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 665:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(741);
      if (lookahead == 'r') ADVANCE(663);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 666:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(880);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 667:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(309);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 668:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(878);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 669:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1159);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 670:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1285);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 671:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1286);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 672:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1111);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 673:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(889);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 674:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(928);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 675:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1202);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 676:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1287);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 677:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(338);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 678:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(320);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 679:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(884);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 680:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1288);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 681:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1168);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 682:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1289);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 683:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(892);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 684:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1290);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 685:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(933);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 686:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(770);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 687:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(938);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 688:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1061);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 689:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1116);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 690:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(789);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 691:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(907);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 692:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1199);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 693:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(241);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 694:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1081);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 695:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1205);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 696:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'i') ADVANCE(1206);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 697:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'j') ADVANCE(1232);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 698:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'k') ADVANCE(3178);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 699:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'k') ADVANCE(3505);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 700:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'k') ADVANCE(3381);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 701:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'k') ADVANCE(3472);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 702:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'k') ADVANCE(3541);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 703:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'k') ADVANCE(3200);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 704:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'k') ADVANCE(3544);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 705:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'k') ADVANCE(965);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 706:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'k') ADVANCE(481);
      if (lookahead == 'n') ADVANCE(348);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 707:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'k') ADVANCE(476);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 708:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'k') ADVANCE(406);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 709:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'k') ADVANCE(217);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 710:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(460);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 711:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(558);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 712:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(3758);
      if (lookahead == 's') ADVANCE(1123);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 713:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(3758);
      if (lookahead == 's') ADVANCE(1176);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 714:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(3764);
      if (lookahead == 'u') ADVANCE(565);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 715:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(3705);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 716:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(3774);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 717:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(3737);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 718:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(3699);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 719:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(3565);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 720:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(3315);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 721:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(3703);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 722:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(3592);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 723:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(3203);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 724:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(3175);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 725:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(3701);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 726:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(3206);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 727:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(3598);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 728:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(3867);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 729:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(3738);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 730:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(519);
      if (lookahead == 'x') ADVANCE(1120);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 731:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(519);
      if (lookahead == 'x') ADVANCE(1174);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 732:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(345);
      if (lookahead == 'm') ADVANCE(379);
      if (lookahead == 'n') ADVANCE(1245);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 733:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(345);
      if (lookahead == 'm') ADVANCE(380);
      if (lookahead == 'n') ADVANCE(1245);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 734:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(275);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 735:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(1269);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 736:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(715);
      if (lookahead == 't') ADVANCE(285);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 737:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(715);
      if (lookahead == 't') ADVANCE(301);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 738:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(1270);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 739:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(1271);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 740:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(717);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 741:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(781);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 742:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(1274);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 743:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(1090);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 744:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(562);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 745:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(1275);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 746:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(174);
      if (lookahead == 'n') ADVANCE(1229);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 747:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(1276);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 748:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(918);
      if (lookahead == 't') ADVANCE(490);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 749:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(918);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 750:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(641);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 751:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(137);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 752:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(734);
      if (lookahead == 'p') ADVANCE(1158);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 753:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(672);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 754:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(963);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 755:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(722);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 756:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(677);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 757:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(1135);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 758:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(801);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 759:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(404);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 760:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(745);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 761:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(727);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 762:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(751);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 763:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(729);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 764:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(461);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 765:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(464);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 766:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(515);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 767:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(415);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 768:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(474);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 769:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(422);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 770:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(424);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 771:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(430);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 772:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(433);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 773:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(482);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 774:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(436);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 775:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(437);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 776:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(650);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 777:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(473);
      if (lookahead == 'q') ADVANCE(130);
      if (lookahead == 'x') ADVANCE(1125);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 778:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(644);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 779:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(659);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 780:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(966);
      if (lookahead == 'p') ADVANCE(1068);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 781:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(1055);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 782:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(1222);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 783:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(1186);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 784:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(950);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 785:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(1223);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 786:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(208);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 787:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(969);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 788:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(496);
      if (lookahead == 's') ADVANCE(1228);
      if (lookahead == 't') ADVANCE(3643);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 789:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(1194);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 790:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(1182);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 791:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(532);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 792:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(945);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 793:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(673);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 794:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(787);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 795:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(961);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 796:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(537);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 797:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(959);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 798:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(683);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 799:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(545);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 800:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(682);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 801:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(1118);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 802:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(550);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 803:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(252);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 804:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'l') ADVANCE(551);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 805:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(3762);
      if (lookahead == 't') ADVANCE(3574);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 806:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(3762);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 807:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(3760);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 808:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(935);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 809:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(141);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 810:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(972);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 811:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(1249);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 812:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(973);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 813:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(1000);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 814:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(924);
      if (lookahead == 't') ADVANCE(191);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 815:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(924);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 816:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(1259);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 817:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(923);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 818:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(1260);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 819:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(188);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 820:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(639);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 821:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(977);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 822:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(459);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 823:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(479);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 824:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(409);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 825:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(471);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 826:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(511);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 827:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(953);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 828:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(960);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 829:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(995);
      if (lookahead == 'n') ADVANCE(793);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 830:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 831:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(536);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 832:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(817);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 833:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(542);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 834:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(544);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 835:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(998);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 836:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'm') ADVANCE(1001);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 837:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(3799);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 838:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(376);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 839:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(3805);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 840:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(3363);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 841:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(3329);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 842:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(3197);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 843:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(124);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 844:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(3215);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 845:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(3745);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 846:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(492);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 847:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(3390);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 848:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(3367);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 849:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(3457);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 850:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(3427);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 851:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(3369);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 852:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(3463);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 853:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(3400);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 854:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(3800);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 855:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(705);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 856:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(313);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 857:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(366);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 858:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(348);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 859:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(595);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 860:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(279);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 861:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(586);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 862:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(587);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 863:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(588);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 864:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(280);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 865:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(353);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 866:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(590);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 867:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(281);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 868:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(333);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 869:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(956);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 870:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(735);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 871:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(358);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 872:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(282);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 873:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(1170);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 874:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(305);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 875:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(738);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 876:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(739);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 877:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(520);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 878:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(1140);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 879:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(742);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 880:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(456);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 881:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(747);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 882:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(1144);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 883:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(1187);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 884:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(1145);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 885:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(1147);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 886:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(1148);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 887:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(412);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 888:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(1150);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 889:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(417);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 890:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(419);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 891:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(426);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 892:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(431);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 893:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(1218);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 894:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(202);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 895:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(317);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 896:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(597);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 897:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(653);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 898:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(239);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 899:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(1193);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 900:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(1106);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 901:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(1179);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 902:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(657);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 903:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(382);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 904:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(958);
      if (lookahead == 'o') ADVANCE(870);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 905:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(236);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 906:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(1236);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 907:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(681);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 908:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(798);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 909:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(695);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 910:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'n') ADVANCE(696);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 911:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(1100);
      if (lookahead == 'r') ADVANCE(1227);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 912:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(1253);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 913:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(121);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 914:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(527);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 915:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(291);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 916:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(1121);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 917:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(820);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 918:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(599);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 919:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(278);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 920:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(190);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 921:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(578);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 922:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(601);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 923:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(842);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 924:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(1022);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 925:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(373);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 926:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(1031);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 927:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(845);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 928:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(848);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 929:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(1065);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 930:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(1015);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 931:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(862);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 932:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(691);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 933:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(851);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 934:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(1019);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 935:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(1030);
      if (lookahead == 't') ADVANCE(194);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 936:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(1040);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 937:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(1079);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 938:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(853);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 939:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(897);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 940:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(708);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 941:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(985);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 942:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(567);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 943:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(1050);
      if (lookahead == 'r') ADVANCE(667);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 944:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(1050);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 945:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(195);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 946:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(374);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 947:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(875);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 948:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(990);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 949:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(1052);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 950:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(307);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 951:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(887);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 952:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(569);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 953:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(876);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 954:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(1053);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 955:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(1244);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 956:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(1195);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 957:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(668);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 958:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(890);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 959:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(212);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 960:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(881);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 961:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(314);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 962:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(891);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 963:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(204);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 964:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(652);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 965:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(895);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 966:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(335);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 967:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(898);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 968:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(528);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 969:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'o') ADVANCE(340);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 970:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(166);
      if (lookahead == 'r') ADVANCE(3793);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 971:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(3528);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 972:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(3689);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 973:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(3687);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 974:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(98);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 975:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(3849);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 976:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(3847);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 977:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(58);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 978:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(3538);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 979:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(994);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 980:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(114);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 981:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(1263);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 982:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(465);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 983:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(949);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 984:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(231);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 985:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(1165);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 986:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(167);
      if (lookahead == 'r') ADVANCE(3793);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 987:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(1169);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 988:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(1122);
      if (lookahead == 'r') ADVANCE(3793);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 989:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(427);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 990:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(442);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 991:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(1042);
      if (lookahead == 't') ADVANCE(233);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 992:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(196);
      if (lookahead == 'r') ADVANCE(502);
      if (lookahead == 's') ADVANCE(1250);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 993:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(756);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 994:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(200);
      if (lookahead == 'r') ADVANCE(506);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 995:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(778);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 996:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(201);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 997:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(964);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 998:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(954);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 999:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(238);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1000:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(1209);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1001:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(1211);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1002:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'q') ADVANCE(3535);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1003:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'q') ADVANCE(142);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1004:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'q') ADVANCE(1220);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1005:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'q') ADVANCE(1230);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1006:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(3793);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1007:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(3335);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1008:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(3795);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1009:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(3772);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1010:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(3770);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1011:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(3685);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1012:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(3855);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1013:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(3182);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1014:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(3652);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1015:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(3609);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1016:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(3188);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1017:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(3883);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1018:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(3723);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1019:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(3660);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1020:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(3748);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1021:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(3754);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1022:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(1268);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1023:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(1114);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1024:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(583);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1025:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(596);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1026:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(914);
      if (lookahead == 'x') ADVANCE(1126);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1027:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(811);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1028:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1029:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(1198);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1030:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(1273);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1031:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(568);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1032:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(452);
      if (lookahead == 'v') ADVANCE(192);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1033:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(921);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1034:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(226);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1035:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(135);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1036:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(454);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1037:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(843);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1038:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(143);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1039:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(894);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1040:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(132);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1041:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(1132);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1042:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(922);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1043:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(846);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1044:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(1074);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1045:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(232);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1046:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(968);
      if (lookahead == 'x') ADVANCE(1126);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1047:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(932);
      if (lookahead == 'x') ADVANCE(1126);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1048:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(849);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1049:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(508);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1050:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(403);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1051:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(852);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1052:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(1141);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1053:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(1142);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1054:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(905);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1055:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(498);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1056:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(531);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1057:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(423);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1058:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(470);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1059:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(543);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1060:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(483);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1061:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(440);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1062:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(500);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1063:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(484);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1064:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(1108);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1065:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(377);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1066:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(207);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1067:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(600);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1068:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(512);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1069:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(524);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1070:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(1162);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1071:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(378);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1072:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(529);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1073:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(386);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1074:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(930);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1075:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(535);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1076:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(509);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1077:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(534);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1078:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(931);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1079:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(140);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1080:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(1235);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1081:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(540);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1082:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(602);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1083:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(3580);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1084:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(3756);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1085:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(3547);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1086:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(3424);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1087:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(3508);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1088:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(3517);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1089:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(3454);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1090:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(53);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1091:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(1280);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1092:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(984);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1093:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(243);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1094:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(1124);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1095:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(1084);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1096:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(1085);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1097:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(144);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1098:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(1087);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1099:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(1088);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1100:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(623);
      if (lookahead == 'u') ADVANCE(624);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1101:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(1134);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1102:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(662);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1103:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(401);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1104:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(311);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1105:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(1146);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1106:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(1173);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1107:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(1151);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1108:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(425);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1109:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(491);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1110:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(441);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1111:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(1188);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1112:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(1164);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1113:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(1102);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1114:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(967);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1115:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(259);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1116:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(927);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1117:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(647);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1118:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(1204);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1119:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(999);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1120:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(468);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1121:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3403);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1122:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(576);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1123:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(991);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1124:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3586);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1125:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3839);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1126:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3837);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1127:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3299);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1128:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3843);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1129:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(182);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1130:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3296);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1131:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3371);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1132:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(553);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1133:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3658);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1134:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3833);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1135:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3213);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1136:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3559);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1137:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3556);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1138:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3677);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1139:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(50);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1140:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3857);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1141:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3221);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1142:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3219);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1143:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3674);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1144:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3397);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1145:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3412);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1146:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3845);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1147:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3656);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1148:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3654);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1149:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3436);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1150:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3209);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1151:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(3869);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1152:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(255);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1153:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(263);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1154:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(1279);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1155:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(942);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1156:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(1272);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1157:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(941);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1158:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(1233);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1159:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(290);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1160:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(579);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1161:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(485);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1162:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(957);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1163:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(674);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1164:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(218);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1165:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(1012);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1166:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(298);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1167:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(172);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1168:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(693);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1169:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(1018);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1170:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(1154);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1171:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(539);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1172:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(743);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1173:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(1080);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1174:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(1034);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1175:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(414);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1176:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(1201);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1177:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(493);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1178:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(429);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1179:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(499);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1180:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(495);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1181:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(541);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1182:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(510);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1183:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(191);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1184:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(303);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1185:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(1251);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1186:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(645);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1187:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(987);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1188:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(929);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1189:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(490);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1190:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(1078);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1191:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(571);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1192:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(934);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1193:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(251);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1194:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(651);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1195:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(939);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1196:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(952);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1197:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(1234);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1198:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(692);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1199:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(685);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1200:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(224);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1201:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(233);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1202:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(671);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1203:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(687);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1204:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(237);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1205:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(680);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1206:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(684);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1207:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(554);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1208:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(249);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1209:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(253);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1210:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(256);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1211:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(258);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1212:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(400);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1213:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(262);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1214:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(261);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1215:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(1282);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1216:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(993);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1217:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(716);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1218:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(979);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1219:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(786);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1220:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(408);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1221:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(418);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1222:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(428);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1223:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(432);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1224:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(1064);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1225:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(757);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1226:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(813);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1227:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(867);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1228:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(824);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1229:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(755);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1230:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(664);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1231:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(1048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1232:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(821);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1233:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(1057);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1234:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(1051);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1235:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(826);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1236:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(761);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1237:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(860);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1238:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(690);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1239:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'v') ADVANCE(3776);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1240:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'v') ADVANCE(3768);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1241:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'v') ADVANCE(3766);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1242:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'v') ADVANCE(223);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1243:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'v') ADVANCE(477);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1244:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'v') ADVANCE(504);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1245:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'v') ADVANCE(525);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1246:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'v') ADVANCE(494);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1247:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'v') ADVANCE(209);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1248:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'v') ADVANCE(242);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1249:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'w') ADVANCE(3719);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1250:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'w') ADVANCE(660);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1251:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'w') ADVANCE(678);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1252:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'w') ADVANCE(518);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1253:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'w') ADVANCE(310);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1254:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'w') ADVANCE(250);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1255:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'x') ADVANCE(3797);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1256:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'x') ADVANCE(1293);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1257:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'x') ADVANCE(3803);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1258:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'x') ADVANCE(3375);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1259:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'x') ADVANCE(3325);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1260:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'x') ADVANCE(3321);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1261:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'x') ADVANCE(1120);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1262:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'x') ADVANCE(983);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1263:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'x') ADVANCE(327);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1264:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'x') ADVANCE(1128);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1265:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'x') ADVANCE(1136);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1266:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'x') ADVANCE(1137);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1267:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'x') ADVANCE(1181);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1268:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'y') ADVANCE(3625);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1269:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'y') ADVANCE(3493);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1270:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'y') ADVANCE(3496);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1271:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'y') ADVANCE(3499);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1272:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'y') ADVANCE(3379);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1273:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'y') ADVANCE(3511);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1274:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'y') ADVANCE(3406);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1275:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'y') ADVANCE(3191);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1276:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'y') ADVANCE(3409);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1277:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'y') ADVANCE(270);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1278:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'y') ADVANCE(1117);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1279:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'y') ADVANCE(989);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1280:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'y') ADVANCE(872);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1281:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'z') ADVANCE(1277);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1298);
      END_STATE();
    case 1282:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'z') ADVANCE(1291);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1298);
      END_STATE();
    case 1283:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'z') ADVANCE(405);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1298);
      END_STATE();
    case 1284:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'z') ADVANCE(410);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1298);
      END_STATE();
    case 1285:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'z') ADVANCE(413);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1298);
      END_STATE();
    case 1286:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'z') ADVANCE(469);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1298);
      END_STATE();
    case 1287:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'z') ADVANCE(421);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1298);
      END_STATE();
    case 1288:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'z') ADVANCE(521);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1298);
      END_STATE();
    case 1289:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'z') ADVANCE(503);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1298);
      END_STATE();
    case 1290:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'z') ADVANCE(505);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1298);
      END_STATE();
    case 1291:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'z') ADVANCE(655);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1298);
      END_STATE();
    case 1292:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'z') ADVANCE(962);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1298);
      END_STATE();
    case 1293:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'H' ||
          ('K' <= lookahead && lookahead <= 'M') ||
          lookahead == 'R') ADVANCE(1297);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(3152);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1294:
      if (lookahead == ':') ADVANCE(3129);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3142);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1295:
      if (lookahead == ':') ADVANCE(3129);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3156);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1296:
      if (lookahead == ':') ADVANCE(3129);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3147);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1297:
      if (lookahead == ':') ADVANCE(3129);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(3152);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1298:
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 1299:
      if (lookahead == ';') ADVANCE(3118);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1299);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 1300:
      if (lookahead == '>') ADVANCE(3344);
      END_STATE();
    case 1301:
      if (lookahead == '_') ADVANCE(2061);
      END_STATE();
    case 1302:
      if (lookahead == '_') ADVANCE(2387);
      END_STATE();
    case 1303:
      if (lookahead == '_') ADVANCE(2260);
      END_STATE();
    case 1304:
      if (lookahead == '_') ADVANCE(1494);
      END_STATE();
    case 1305:
      if (lookahead == '_') ADVANCE(1534);
      END_STATE();
    case 1306:
      if (lookahead == '_') ADVANCE(1372);
      END_STATE();
    case 1307:
      if (lookahead == '_') ADVANCE(1439);
      END_STATE();
    case 1308:
      if (lookahead == '_') ADVANCE(3097);
      END_STATE();
    case 1309:
      if (lookahead == '_') ADVANCE(3098);
      END_STATE();
    case 1310:
      if (lookahead == '_') ADVANCE(3036);
      if (lookahead == 'a') ADVANCE(2296);
      END_STATE();
    case 1311:
      if (lookahead == '_') ADVANCE(3036);
      if (lookahead == 'a') ADVANCE(2303);
      END_STATE();
    case 1312:
      if (lookahead == '_') ADVANCE(3100);
      END_STATE();
    case 1313:
      if (lookahead == '_') ADVANCE(3101);
      END_STATE();
    case 1314:
      if (lookahead == '_') ADVANCE(2068);
      END_STATE();
    case 1315:
      if (lookahead == '_') ADVANCE(3102);
      END_STATE();
    case 1316:
      if (lookahead == '_') ADVANCE(3102);
      if (lookahead == 'd') ADVANCE(2248);
      END_STATE();
    case 1317:
      if (lookahead == '_') ADVANCE(3103);
      END_STATE();
    case 1318:
      if (lookahead == '_') ADVANCE(1629);
      if (lookahead == 'n') ADVANCE(1817);
      END_STATE();
    case 1319:
      if (lookahead == '_') ADVANCE(3104);
      END_STATE();
    case 1320:
      if (lookahead == '_') ADVANCE(2142);
      END_STATE();
    case 1321:
      if (lookahead == '_') ADVANCE(3105);
      END_STATE();
    case 1322:
      if (lookahead == '_') ADVANCE(2847);
      END_STATE();
    case 1323:
      if (lookahead == '_') ADVANCE(2690);
      END_STATE();
    case 1324:
      if (lookahead == '_') ADVANCE(1692);
      END_STATE();
    case 1325:
      if (lookahead == '_') ADVANCE(2774);
      END_STATE();
    case 1326:
      if (lookahead == '_') ADVANCE(2177);
      END_STATE();
    case 1327:
      if (lookahead == '_') ADVANCE(1651);
      END_STATE();
    case 1328:
      if (lookahead == '_') ADVANCE(2554);
      END_STATE();
    case 1329:
      if (lookahead == '_') ADVANCE(2945);
      END_STATE();
    case 1330:
      if (lookahead == '_') ADVANCE(1916);
      END_STATE();
    case 1331:
      if (lookahead == '_') ADVANCE(1440);
      END_STATE();
    case 1332:
      if (lookahead == '_') ADVANCE(2993);
      END_STATE();
    case 1333:
      if (lookahead == '_') ADVANCE(2993);
      if (lookahead == 'd') ADVANCE(3067);
      if (lookahead == 'e') ADVANCE(3052);
      END_STATE();
    case 1334:
      if (lookahead == '_') ADVANCE(2777);
      if (lookahead == 'u') ADVANCE(2227);
      END_STATE();
    case 1335:
      if (lookahead == '_') ADVANCE(1631);
      END_STATE();
    case 1336:
      if (lookahead == '_') ADVANCE(1684);
      END_STATE();
    case 1337:
      if (lookahead == '_') ADVANCE(1469);
      END_STATE();
    case 1338:
      if (lookahead == '_') ADVANCE(2610);
      if (lookahead == 'o') ADVANCE(2526);
      END_STATE();
    case 1339:
      if (lookahead == '_') ADVANCE(2259);
      END_STATE();
    case 1340:
      if (lookahead == '_') ADVANCE(2197);
      END_STATE();
    case 1341:
      if (lookahead == '_') ADVANCE(2385);
      END_STATE();
    case 1342:
      if (lookahead == '_') ADVANCE(3030);
      END_STATE();
    case 1343:
      if (lookahead == '_') ADVANCE(2085);
      END_STATE();
    case 1344:
      if (lookahead == '_') ADVANCE(1490);
      END_STATE();
    case 1345:
      if (lookahead == '_') ADVANCE(1535);
      END_STATE();
    case 1346:
      if (lookahead == '_') ADVANCE(2418);
      END_STATE();
    case 1347:
      ADVANCE_MAP(
        'a', 2727,
        'c', 2696,
        'd', 1715,
        'f', 2473,
        'l', 2147,
        'm', 1746,
        'n', 1717,
        'p', 2670,
        'r', 1620,
        's', 2134,
        't', 2580,
        'v', 1478,
      );
      END_STATE();
    case 1348:
      ADVANCE_MAP(
        'a', 2727,
        'c', 2696,
        'd', 1776,
        'f', 2473,
        'l', 2175,
        'm', 1746,
        'n', 3072,
        'p', 2670,
        'r', 1622,
        't', 2906,
        'v', 1478,
      );
      END_STATE();
    case 1349:
      ADVANCE_MAP(
        'a', 2727,
        'c', 2696,
        'd', 1743,
        'l', 2175,
        'm', 1746,
        'n', 1719,
        'p', 2670,
        'r', 2123,
        't', 2906,
        'v', 1478,
      );
      END_STATE();
    case 1350:
      ADVANCE_MAP(
        'a', 2727,
        'c', 2696,
        'd', 1794,
        'l', 2175,
        'm', 1746,
        'n', 1719,
        'p', 2670,
        'r', 2123,
        's', 2132,
        'v', 1478,
      );
      END_STATE();
    case 1351:
      ADVANCE_MAP(
        'a', 2727,
        'd', 1715,
        'l', 2175,
        'm', 1746,
        'n', 1719,
        'p', 2670,
        'r', 2123,
        's', 2135,
        'v', 1478,
      );
      END_STATE();
    case 1352:
      ADVANCE_MAP(
        'a', 1748,
        'c', 2438,
        'd', 2154,
        'e', 2498,
        'i', 2384,
        'l', 2583,
        'm', 2985,
        'n', 1900,
        'p', 95,
        'r', 1805,
        's', 2983,
      );
      END_STATE();
    case 1353:
      if (lookahead == 'a') ADVANCE(1567);
      if (lookahead == 'i') ADVANCE(2474);
      if (lookahead == 'o') ADVANCE(1418);
      if (lookahead == 's') ADVANCE(2137);
      END_STATE();
    case 1354:
      if (lookahead == 'a') ADVANCE(1567);
      if (lookahead == 'i') ADVANCE(2474);
      if (lookahead == 'o') ADVANCE(1417);
      if (lookahead == 's') ADVANCE(2137);
      END_STATE();
    case 1355:
      if (lookahead == 'a') ADVANCE(2273);
      if (lookahead == 'e') ADVANCE(3812);
      if (lookahead == 'i') ADVANCE(2496);
      if (lookahead == 'n') ADVANCE(1411);
      if (lookahead == 'o') ADVANCE(44);
      if (lookahead == 's') ADVANCE(3032);
      if (lookahead == 'u') ADVANCE(2324);
      END_STATE();
    case 1356:
      if (lookahead == 'a') ADVANCE(2273);
      if (lookahead == 'e') ADVANCE(2816);
      if (lookahead == 'i') ADVANCE(2496);
      if (lookahead == 'n') ADVANCE(1410);
      if (lookahead == 'o') ADVANCE(45);
      if (lookahead == 's') ADVANCE(3032);
      if (lookahead == 'u') ADVANCE(2324);
      END_STATE();
    case 1357:
      if (lookahead == 'a') ADVANCE(2273);
      if (lookahead == 'e') ADVANCE(2816);
      if (lookahead == 'o') ADVANCE(44);
      if (lookahead == 'u') ADVANCE(2323);
      END_STATE();
    case 1358:
      if (lookahead == 'a') ADVANCE(2273);
      if (lookahead == 'e') ADVANCE(2816);
      if (lookahead == 'o') ADVANCE(45);
      if (lookahead == 'u') ADVANCE(2323);
      END_STATE();
    case 1359:
      if (lookahead == 'a') ADVANCE(2273);
      if (lookahead == 'e') ADVANCE(2816);
      if (lookahead == 'o') ADVANCE(46);
      if (lookahead == 'u') ADVANCE(2361);
      END_STATE();
    case 1360:
      if (lookahead == 'a') ADVANCE(2165);
      if (lookahead == 'h') ADVANCE(2773);
      if (lookahead == 'o') ADVANCE(3671);
      if (lookahead == 'r') ADVANCE(2164);
      if (lookahead == 'y') ADVANCE(2673);
      END_STATE();
    case 1361:
      if (lookahead == 'a') ADVANCE(2165);
      if (lookahead == 'o') ADVANCE(3671);
      if (lookahead == 'r') ADVANCE(2981);
      END_STATE();
    case 1362:
      if (lookahead == 'a') ADVANCE(1331);
      if (lookahead == 'o') ADVANCE(2168);
      if (lookahead == 's') ADVANCE(1693);
      END_STATE();
    case 1363:
      if (lookahead == 'a') ADVANCE(1331);
      if (lookahead == 'o') ADVANCE(2167);
      if (lookahead == 's') ADVANCE(1705);
      END_STATE();
    case 1364:
      ADVANCE_MAP(
        'a', 1685,
        'b', 2587,
        'd', 2219,
        'i', 2918,
        'l', 2216,
        'r', 1432,
        's', 1991,
        't', 1816,
        'v', 2584,
      );
      END_STATE();
    case 1365:
      if (lookahead == 'a') ADVANCE(1724);
      if (lookahead == 'l') ADVANCE(1934);
      if (lookahead == 's') ADVANCE(3005);
      if (lookahead == 't') ADVANCE(3644);
      END_STATE();
    case 1366:
      if (lookahead == 'a') ADVANCE(3069);
      END_STATE();
    case 1367:
      if (lookahead == 'a') ADVANCE(3707);
      if (lookahead == 's') ADVANCE(2225);
      END_STATE();
    case 1368:
      if (lookahead == 'a') ADVANCE(3270);
      if (lookahead == 'c') ADVANCE(3256);
      if (lookahead == 'e') ADVANCE(3269);
      if (lookahead == 's') ADVANCE(3260);
      if (lookahead == 't') ADVANCE(3255);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 1369:
      if (lookahead == 'a') ADVANCE(3570);
      END_STATE();
    case 1370:
      if (lookahead == 'a') ADVANCE(3317);
      END_STATE();
    case 1371:
      ADVANCE_MAP(
        'a', 2073,
        'e', 1688,
        'h', 1420,
        'i', 2104,
        'o', 3000,
        'p', 1918,
        'r', 1990,
        's', 2652,
        't', 2732,
        'w', 2211,
      );
      END_STATE();
    case 1372:
      if (lookahead == 'a') ADVANCE(3236);
      if (lookahead == 'f') ADVANCE(3238);
      if (lookahead == 'm') ADVANCE(3237);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(3241);
      END_STATE();
    case 1373:
      ADVANCE_MAP(
        'a', 1747,
        'c', 2438,
        'd', 2154,
        'e', 2498,
        'l', 2583,
        'm', 2985,
        'n', 1900,
        'p', 95,
        'r', 1804,
        's', 2983,
      );
      END_STATE();
    case 1374:
      ADVANCE_MAP(
        'a', 1747,
        'c', 2438,
        'd', 2154,
        'i', 2384,
        'l', 2583,
        'm', 2985,
        'n', 1900,
        'p', 95,
        'r', 1929,
        's', 2983,
      );
      END_STATE();
    case 1375:
      ADVANCE_MAP(
        'a', 1747,
        'c', 2438,
        'd', 2154,
        'l', 2583,
        'm', 2985,
        'n', 1900,
        'p', 95,
        'r', 1929,
        's', 2983,
      );
      END_STATE();
    case 1376:
      ADVANCE_MAP(
        'a', 1747,
        'c', 2438,
        'd', 2154,
        'm', 2985,
        'n', 1900,
        'p', 1906,
        'r', 1929,
        's', 2983,
      );
      END_STATE();
    case 1377:
      if (lookahead == 'a') ADVANCE(2768);
      if (lookahead == 'e') ADVANCE(2726);
      if (lookahead == 'h') ADVANCE(2149);
      if (lookahead == 'o') ADVANCE(2243);
      if (lookahead == 'p') ADVANCE(1624);
      if (lookahead == 'r') ADVANCE(1809);
      if (lookahead == 't') ADVANCE(2705);
      END_STATE();
    case 1378:
      if (lookahead == 'a') ADVANCE(2768);
      if (lookahead == 'e') ADVANCE(2726);
      if (lookahead == 'h') ADVANCE(2149);
      if (lookahead == 'o') ADVANCE(2243);
      if (lookahead == 'p') ADVANCE(1624);
      if (lookahead == 'r') ADVANCE(1891);
      if (lookahead == 't') ADVANCE(2704);
      END_STATE();
    case 1379:
      if (lookahead == 'a') ADVANCE(2768);
      if (lookahead == 'e') ADVANCE(2726);
      if (lookahead == 'o') ADVANCE(2243);
      if (lookahead == 'p') ADVANCE(1624);
      if (lookahead == 'r') ADVANCE(1891);
      if (lookahead == 't') ADVANCE(2704);
      END_STATE();
    case 1380:
      if (lookahead == 'a') ADVANCE(2768);
      if (lookahead == 'e') ADVANCE(2726);
      if (lookahead == 'p') ADVANCE(1624);
      if (lookahead == 'r') ADVANCE(1892);
      if (lookahead == 't') ADVANCE(2723);
      END_STATE();
    case 1381:
      if (lookahead == 'a') ADVANCE(2944);
      if (lookahead == 'e') ADVANCE(1626);
      if (lookahead == 'i') ADVANCE(2800);
      if (lookahead == 'l') ADVANCE(2306);
      if (lookahead == 'o') ADVANCE(2982);
      if (lookahead == 's') ADVANCE(2582);
      END_STATE();
    case 1382:
      if (lookahead == 'a') ADVANCE(3040);
      if (lookahead == 'e') ADVANCE(2440);
      if (lookahead == 'i') ADVANCE(2475);
      if (lookahead == 'o') ADVANCE(1775);
      if (lookahead == 's') ADVANCE(2651);
      if (lookahead == 'u') ADVANCE(2281);
      END_STATE();
    case 1383:
      if (lookahead == 'a') ADVANCE(3040);
      if (lookahead == 'e') ADVANCE(2440);
      if (lookahead == 'i') ADVANCE(2475);
      if (lookahead == 'o') ADVANCE(1775);
      if (lookahead == 's') ADVANCE(2651);
      if (lookahead == 'u') ADVANCE(2835);
      END_STATE();
    case 1384:
      if (lookahead == 'a') ADVANCE(3040);
      if (lookahead == 'e') ADVANCE(2440);
      if (lookahead == 'i') ADVANCE(2475);
      if (lookahead == 'o') ADVANCE(1774);
      if (lookahead == 'u') ADVANCE(2281);
      END_STATE();
    case 1385:
      if (lookahead == 'a') ADVANCE(3040);
      if (lookahead == 'e') ADVANCE(2440);
      if (lookahead == 'i') ADVANCE(2475);
      if (lookahead == 'o') ADVANCE(1774);
      if (lookahead == 'u') ADVANCE(2282);
      END_STATE();
    case 1386:
      if (lookahead == 'a') ADVANCE(3040);
      if (lookahead == 'e') ADVANCE(2440);
      if (lookahead == 'i') ADVANCE(2475);
      if (lookahead == 'o') ADVANCE(2497);
      if (lookahead == 's') ADVANCE(2651);
      if (lookahead == 'u') ADVANCE(2282);
      END_STATE();
    case 1387:
      if (lookahead == 'a') ADVANCE(3040);
      if (lookahead == 'e') ADVANCE(2440);
      if (lookahead == 'i') ADVANCE(2475);
      if (lookahead == 's') ADVANCE(2651);
      if (lookahead == 'u') ADVANCE(2282);
      END_STATE();
    case 1388:
      if (lookahead == 'a') ADVANCE(3040);
      if (lookahead == 'e') ADVANCE(2907);
      if (lookahead == 'i') ADVANCE(2494);
      if (lookahead == 'o') ADVANCE(1775);
      if (lookahead == 'u') ADVANCE(2280);
      END_STATE();
    case 1389:
      if (lookahead == 'a') ADVANCE(3040);
      if (lookahead == 'e') ADVANCE(2907);
      if (lookahead == 'i') ADVANCE(2494);
      if (lookahead == 'u') ADVANCE(2280);
      END_STATE();
    case 1390:
      if (lookahead == 'a') ADVANCE(3040);
      if (lookahead == 'i') ADVANCE(2494);
      if (lookahead == 'u') ADVANCE(2280);
      END_STATE();
    case 1391:
      ADVANCE_MAP(
        'a', 1750,
        'c', 2438,
        'd', 2154,
        'i', 2384,
        'l', 2583,
        'm', 2985,
        'n', 1900,
        'p', 95,
        'r', 1929,
        's', 2983,
      );
      END_STATE();
    case 1392:
      ADVANCE_MAP(
        'a', 1750,
        'c', 2438,
        'd', 2154,
        'l', 2583,
        'm', 2985,
        'n', 1900,
        'p', 95,
        'r', 1929,
        's', 2983,
      );
      END_STATE();
    case 1393:
      if (lookahead == 'a') ADVANCE(2305);
      if (lookahead == 'l') ADVANCE(2583);
      if (lookahead == 'p') ADVANCE(94);
      END_STATE();
    case 1394:
      if (lookahead == 'a') ADVANCE(2263);
      END_STATE();
    case 1395:
      if (lookahead == 'a') ADVANCE(2263);
      if (lookahead == 'b') ADVANCE(2275);
      END_STATE();
    case 1396:
      if (lookahead == 'a') ADVANCE(1740);
      if (lookahead == 'l') ADVANCE(1934);
      if (lookahead == 't') ADVANCE(3001);
      END_STATE();
    case 1397:
      if (lookahead == 'a') ADVANCE(1740);
      if (lookahead == 't') ADVANCE(3001);
      END_STATE();
    case 1398:
      if (lookahead == 'a') ADVANCE(2342);
      if (lookahead == 'f') ADVANCE(1335);
      END_STATE();
    case 1399:
      if (lookahead == 'a') ADVANCE(3074);
      END_STATE();
    case 1400:
      if (lookahead == 'a') ADVANCE(1751);
      if (lookahead == 'l') ADVANCE(2583);
      if (lookahead == 'p') ADVANCE(94);
      if (lookahead == 's') ADVANCE(2983);
      END_STATE();
    case 1401:
      if (lookahead == 'a') ADVANCE(3068);
      END_STATE();
    case 1402:
      if (lookahead == 'a') ADVANCE(2701);
      END_STATE();
    case 1403:
      if (lookahead == 'a') ADVANCE(2701);
      if (lookahead == 't') ADVANCE(2084);
      END_STATE();
    case 1404:
      if (lookahead == 'a') ADVANCE(2279);
      END_STATE();
    case 1405:
      if (lookahead == 'a') ADVANCE(2279);
      if (lookahead == 'h') ADVANCE(3023);
      if (lookahead == 'i') ADVANCE(1752);
      if (lookahead == 'o') ADVANCE(2860);
      END_STATE();
    case 1406:
      if (lookahead == 'a') ADVANCE(2279);
      if (lookahead == 'i') ADVANCE(1752);
      END_STATE();
    case 1407:
      if (lookahead == 'a') ADVANCE(2279);
      if (lookahead == 'i') ADVANCE(1752);
      if (lookahead == 'o') ADVANCE(2860);
      END_STATE();
    case 1408:
      if (lookahead == 'a') ADVANCE(2279);
      if (lookahead == 'o') ADVANCE(2860);
      END_STATE();
    case 1409:
      if (lookahead == 'a') ADVANCE(2801);
      if (lookahead == 'g') ADVANCE(2479);
      END_STATE();
    case 1410:
      if (lookahead == 'a') ADVANCE(2476);
      END_STATE();
    case 1411:
      if (lookahead == 'a') ADVANCE(2476);
      if (lookahead == 'e') ADVANCE(2091);
      END_STATE();
    case 1412:
      if (lookahead == 'a') ADVANCE(3041);
      if (lookahead == 'i') ADVANCE(2478);
      END_STATE();
    case 1413:
      if (lookahead == 'a') ADVANCE(1641);
      END_STATE();
    case 1414:
      if (lookahead == 'a') ADVANCE(1641);
      if (lookahead == 't') ADVANCE(1925);
      END_STATE();
    case 1415:
      if (lookahead == 'a') ADVANCE(1641);
      if (lookahead == 't') ADVANCE(2036);
      END_STATE();
    case 1416:
      if (lookahead == 'a') ADVANCE(1641);
      if (lookahead == 't') ADVANCE(2042);
      END_STATE();
    case 1417:
      if (lookahead == 'a') ADVANCE(1722);
      END_STATE();
    case 1418:
      if (lookahead == 'a') ADVANCE(1722);
      if (lookahead == 'c') ADVANCE(1444);
      END_STATE();
    case 1419:
      if (lookahead == 'a') ADVANCE(2829);
      END_STATE();
    case 1420:
      if (lookahead == 'a') ADVANCE(1756);
      END_STATE();
    case 1421:
      if (lookahead == 'a') ADVANCE(1756);
      if (lookahead == 'l') ADVANCE(3763);
      if (lookahead == 'u') ADVANCE(2066);
      END_STATE();
    case 1422:
      if (lookahead == 'a') ADVANCE(1566);
      END_STATE();
    case 1423:
      if (lookahead == 'a') ADVANCE(1566);
      if (lookahead == 'i') ADVANCE(2474);
      if (lookahead == 'o') ADVANCE(1700);
      END_STATE();
    case 1424:
      if (lookahead == 'a') ADVANCE(1566);
      if (lookahead == 'i') ADVANCE(2474);
      if (lookahead == 'o') ADVANCE(1700);
      if (lookahead == 's') ADVANCE(2137);
      END_STATE();
    case 1425:
      if (lookahead == 'a') ADVANCE(1566);
      if (lookahead == 'i') ADVANCE(2474);
      if (lookahead == 's') ADVANCE(2137);
      END_STATE();
    case 1426:
      if (lookahead == 'a') ADVANCE(1566);
      if (lookahead == 'o') ADVANCE(1700);
      END_STATE();
    case 1427:
      if (lookahead == 'a') ADVANCE(2268);
      END_STATE();
    case 1428:
      if (lookahead == 'a') ADVANCE(1755);
      END_STATE();
    case 1429:
      if (lookahead == 'a') ADVANCE(2501);
      END_STATE();
    case 1430:
      if (lookahead == 'a') ADVANCE(2802);
      END_STATE();
    case 1431:
      if (lookahead == 'a') ADVANCE(2729);
      END_STATE();
    case 1432:
      if (lookahead == 'a') ADVANCE(2548);
      if (lookahead == 'e') ADVANCE(2093);
      END_STATE();
    case 1433:
      if (lookahead == 'a') ADVANCE(2288);
      END_STATE();
    case 1434:
      if (lookahead == 'a') ADVANCE(2868);
      END_STATE();
    case 1435:
      if (lookahead == 'a') ADVANCE(2270);
      END_STATE();
    case 1436:
      if (lookahead == 'a') ADVANCE(2568);
      if (lookahead == 'y') ADVANCE(2511);
      END_STATE();
    case 1437:
      if (lookahead == 'a') ADVANCE(2382);
      END_STATE();
    case 1438:
      if (lookahead == 'a') ADVANCE(1753);
      END_STATE();
    case 1439:
      if (lookahead == 'a') ADVANCE(2443);
      if (lookahead == 'f') ADVANCE(2667);
      if (lookahead == 'm') ADVANCE(2445);
      END_STATE();
    case 1440:
      if (lookahead == 'a') ADVANCE(2733);
      END_STATE();
    case 1441:
      if (lookahead == 'a') ADVANCE(2100);
      END_STATE();
    case 1442:
      if (lookahead == 'a') ADVANCE(2952);
      END_STATE();
    case 1443:
      if (lookahead == 'a') ADVANCE(2740);
      END_STATE();
    case 1444:
      if (lookahead == 'a') ADVANCE(2291);
      END_STATE();
    case 1445:
      if (lookahead == 'a') ADVANCE(2871);
      END_STATE();
    case 1446:
      if (lookahead == 'a') ADVANCE(2406);
      if (lookahead == 'f') ADVANCE(2163);
      END_STATE();
    case 1447:
      if (lookahead == 'a') ADVANCE(2406);
      if (lookahead == 'f') ADVANCE(2163);
      if (lookahead == 's') ADVANCE(1953);
      END_STATE();
    case 1448:
      if (lookahead == 'a') ADVANCE(2406);
      if (lookahead == 's') ADVANCE(1953);
      END_STATE();
    case 1449:
      if (lookahead == 'a') ADVANCE(2872);
      END_STATE();
    case 1450:
      if (lookahead == 'a') ADVANCE(2292);
      END_STATE();
    case 1451:
      if (lookahead == 'a') ADVANCE(1728);
      END_STATE();
    case 1452:
      if (lookahead == 'a') ADVANCE(1733);
      END_STATE();
    case 1453:
      if (lookahead == 'a') ADVANCE(2297);
      END_STATE();
    case 1454:
      if (lookahead == 'a') ADVANCE(2820);
      if (lookahead == 'e') ADVANCE(2757);
      if (lookahead == 's') ADVANCE(1986);
      END_STATE();
    case 1455:
      if (lookahead == 'a') ADVANCE(1630);
      END_STATE();
    case 1456:
      if (lookahead == 'a') ADVANCE(1736);
      END_STATE();
    case 1457:
      if (lookahead == 'a') ADVANCE(2814);
      if (lookahead == 'l') ADVANCE(2583);
      if (lookahead == 'p') ADVANCE(94);
      END_STATE();
    case 1458:
      if (lookahead == 'a') ADVANCE(1632);
      END_STATE();
    case 1459:
      if (lookahead == 'a') ADVANCE(1757);
      END_STATE();
    case 1460:
      if (lookahead == 'a') ADVANCE(2299);
      END_STATE();
    case 1461:
      if (lookahead == 'a') ADVANCE(2815);
      END_STATE();
    case 1462:
      if (lookahead == 'a') ADVANCE(1634);
      END_STATE();
    case 1463:
      if (lookahead == 'a') ADVANCE(1739);
      if (lookahead == 'l') ADVANCE(1934);
      if (lookahead == 't') ADVANCE(3001);
      END_STATE();
    case 1464:
      if (lookahead == 'a') ADVANCE(1739);
      if (lookahead == 's') ADVANCE(3005);
      if (lookahead == 't') ADVANCE(3644);
      END_STATE();
    case 1465:
      if (lookahead == 'a') ADVANCE(1739);
      if (lookahead == 't') ADVANCE(3001);
      END_STATE();
    case 1466:
      if (lookahead == 'a') ADVANCE(2388);
      END_STATE();
    case 1467:
      if (lookahead == 'a') ADVANCE(1742);
      END_STATE();
    case 1468:
      if (lookahead == 'a') ADVANCE(2300);
      END_STATE();
    case 1469:
      if (lookahead == 'a') ADVANCE(2742);
      END_STATE();
    case 1470:
      if (lookahead == 'a') ADVANCE(1744);
      if (lookahead == 'l') ADVANCE(1934);
      END_STATE();
    case 1471:
      if (lookahead == 'a') ADVANCE(1643);
      END_STATE();
    case 1472:
      if (lookahead == 'a') ADVANCE(2904);
      END_STATE();
    case 1473:
      if (lookahead == 'a') ADVANCE(2343);
      END_STATE();
    case 1474:
      if (lookahead == 'a') ADVANCE(2500);
      if (lookahead == 'e') ADVANCE(3811);
      if (lookahead == 'o') ADVANCE(1318);
      if (lookahead == 'u') ADVANCE(2364);
      END_STATE();
    case 1475:
      if (lookahead == 'a') ADVANCE(2500);
      if (lookahead == 'o') ADVANCE(1318);
      if (lookahead == 'u') ADVANCE(2364);
      END_STATE();
    case 1476:
      if (lookahead == 'a') ADVANCE(2899);
      END_STATE();
    case 1477:
      if (lookahead == 'a') ADVANCE(2169);
      END_STATE();
    case 1478:
      if (lookahead == 'a') ADVANCE(2169);
      if (lookahead == 'r') ADVANCE(1309);
      END_STATE();
    case 1479:
      ADVANCE_MAP(
        'a', 1749,
        'c', 2438,
        'd', 2154,
        'i', 2384,
        'l', 2583,
        'm', 2985,
        'n', 1900,
        'p', 95,
        'r', 1929,
        's', 2983,
      );
      END_STATE();
    case 1480:
      if (lookahead == 'a') ADVANCE(2245);
      if (lookahead == 'o') ADVANCE(3671);
      END_STATE();
    case 1481:
      if (lookahead == 'a') ADVANCE(2836);
      END_STATE();
    case 1482:
      if (lookahead == 'a') ADVANCE(1759);
      END_STATE();
    case 1483:
      if (lookahead == 'a') ADVANCE(2549);
      END_STATE();
    case 1484:
      if (lookahead == 'a') ADVANCE(2522);
      END_STATE();
    case 1485:
      if (lookahead == 'a') ADVANCE(2349);
      END_STATE();
    case 1486:
      if (lookahead == 'a') ADVANCE(2789);
      END_STATE();
    case 1487:
      if (lookahead == 'a') ADVANCE(2179);
      END_STATE();
    case 1488:
      if (lookahead == 'a') ADVANCE(3004);
      END_STATE();
    case 1489:
      if (lookahead == 'a') ADVANCE(3004);
      if (lookahead == 'i') ADVANCE(2523);
      END_STATE();
    case 1490:
      if (lookahead == 'a') ADVANCE(1779);
      END_STATE();
    case 1491:
      if (lookahead == 'a') ADVANCE(2272);
      if (lookahead == 'e') ADVANCE(2816);
      if (lookahead == 'i') ADVANCE(2496);
      if (lookahead == 'n') ADVANCE(1411);
      if (lookahead == 'o') ADVANCE(47);
      if (lookahead == 's') ADVANCE(3032);
      if (lookahead == 'u') ADVANCE(2324);
      END_STATE();
    case 1492:
      if (lookahead == 'a') ADVANCE(2272);
      if (lookahead == 'e') ADVANCE(2816);
      if (lookahead == 'i') ADVANCE(2496);
      if (lookahead == 'n') ADVANCE(1410);
      if (lookahead == 'o') ADVANCE(47);
      if (lookahead == 's') ADVANCE(3073);
      if (lookahead == 'u') ADVANCE(2361);
      END_STATE();
    case 1493:
      if (lookahead == 'a') ADVANCE(2272);
      if (lookahead == 'e') ADVANCE(2816);
      if (lookahead == 'i') ADVANCE(2496);
      if (lookahead == 'n') ADVANCE(1410);
      if (lookahead == 'o') ADVANCE(46);
      if (lookahead == 's') ADVANCE(3073);
      if (lookahead == 'u') ADVANCE(2361);
      END_STATE();
    case 1494:
      if (lookahead == 'a') ADVANCE(2354);
      if (lookahead == 'm') ADVANCE(2597);
      END_STATE();
    case 1495:
      if (lookahead == 'a') ADVANCE(2931);
      END_STATE();
    case 1496:
      if (lookahead == 'a') ADVANCE(2450);
      END_STATE();
    case 1497:
      if (lookahead == 'a') ADVANCE(1708);
      END_STATE();
    case 1498:
      if (lookahead == 'a') ADVANCE(2833);
      END_STATE();
    case 1499:
      if (lookahead == 'a') ADVANCE(2363);
      END_STATE();
    case 1500:
      if (lookahead == 'a') ADVANCE(2356);
      END_STATE();
    case 1501:
      if (lookahead == 'a') ADVANCE(2185);
      END_STATE();
    case 1502:
      if (lookahead == 'a') ADVANCE(1633);
      END_STATE();
    case 1503:
      if (lookahead == 'a') ADVANCE(1655);
      END_STATE();
    case 1504:
      if (lookahead == 'a') ADVANCE(1670);
      END_STATE();
    case 1505:
      if (lookahead == 'a') ADVANCE(2921);
      END_STATE();
    case 1506:
      if (lookahead == 'a') ADVANCE(2452);
      END_STATE();
    case 1507:
      if (lookahead == 'a') ADVANCE(2389);
      END_STATE();
    case 1508:
      if (lookahead == 'a') ADVANCE(2244);
      if (lookahead == 'o') ADVANCE(2277);
      if (lookahead == 'r') ADVANCE(2981);
      END_STATE();
    case 1509:
      if (lookahead == 'a') ADVANCE(2115);
      END_STATE();
    case 1510:
      if (lookahead == 'a') ADVANCE(2760);
      END_STATE();
    case 1511:
      if (lookahead == 'a') ADVANCE(2414);
      END_STATE();
    case 1512:
      if (lookahead == 'a') ADVANCE(1672);
      END_STATE();
    case 1513:
      if (lookahead == 'a') ADVANCE(2837);
      if (lookahead == 'i') ADVANCE(2384);
      if (lookahead == 'l') ADVANCE(2583);
      if (lookahead == 'p') ADVANCE(94);
      END_STATE();
    case 1514:
      if (lookahead == 'a') ADVANCE(2362);
      END_STATE();
    case 1515:
      if (lookahead == 'a') ADVANCE(2935);
      END_STATE();
    case 1516:
      if (lookahead == 'a') ADVANCE(2348);
      END_STATE();
    case 1517:
      if (lookahead == 'a') ADVANCE(1673);
      END_STATE();
    case 1518:
      if (lookahead == 'a') ADVANCE(2369);
      END_STATE();
    case 1519:
      if (lookahead == 'a') ADVANCE(1712);
      if (lookahead == 's') ADVANCE(1991);
      if (lookahead == 't') ADVANCE(2041);
      END_STATE();
    case 1520:
      if (lookahead == 'a') ADVANCE(2937);
      END_STATE();
    case 1521:
      if (lookahead == 'a') ADVANCE(2938);
      END_STATE();
    case 1522:
      if (lookahead == 'a') ADVANCE(1668);
      if (lookahead == 't') ADVANCE(2036);
      END_STATE();
    case 1523:
      if (lookahead == 'a') ADVANCE(2412);
      END_STATE();
    case 1524:
      if (lookahead == 'a') ADVANCE(2379);
      END_STATE();
    case 1525:
      if (lookahead == 'a') ADVANCE(2381);
      END_STATE();
    case 1526:
      if (lookahead == 'a') ADVANCE(1570);
      END_STATE();
    case 1527:
      if (lookahead == 'a') ADVANCE(1570);
      if (lookahead == 'j') ADVANCE(2633);
      END_STATE();
    case 1528:
      if (lookahead == 'a') ADVANCE(1570);
      if (lookahead == 'j') ADVANCE(2633);
      if (lookahead == 't') ADVANCE(2226);
      END_STATE();
    case 1529:
      if (lookahead == 'a') ADVANCE(2459);
      END_STATE();
    case 1530:
      if (lookahead == 'a') ADVANCE(2555);
      END_STATE();
    case 1531:
      if (lookahead == 'a') ADVANCE(2394);
      END_STATE();
    case 1532:
      if (lookahead == 'a') ADVANCE(2413);
      END_STATE();
    case 1533:
      if (lookahead == 'a') ADVANCE(2962);
      if (lookahead == 'l') ADVANCE(1902);
      if (lookahead == 'o') ADVANCE(2352);
      END_STATE();
    case 1534:
      if (lookahead == 'a') ADVANCE(1790);
      if (lookahead == 'h') ADVANCE(3038);
      if (lookahead == 'm') ADVANCE(1917);
      if (lookahead == 't') ADVANCE(2144);
      END_STATE();
    case 1535:
      if (lookahead == 'a') ADVANCE(1783);
      END_STATE();
    case 1536:
      if (lookahead == 'a') ADVANCE(1571);
      END_STATE();
    case 1537:
      if (lookahead == 'a') ADVANCE(2766);
      if (lookahead == 'o') ADVANCE(3671);
      END_STATE();
    case 1538:
      if (lookahead == 'a') ADVANCE(2766);
      if (lookahead == 'o') ADVANCE(3671);
      if (lookahead == 'r') ADVANCE(2981);
      END_STATE();
    case 1539:
      if (lookahead == 'a') ADVANCE(2766);
      if (lookahead == 'o') ADVANCE(3671);
      if (lookahead == 'r') ADVANCE(2999);
      END_STATE();
    case 1540:
      if (lookahead == 'a') ADVANCE(2963);
      END_STATE();
    case 1541:
      if (lookahead == 'a') ADVANCE(1792);
      END_STATE();
    case 1542:
      if (lookahead == 'a') ADVANCE(2971);
      END_STATE();
    case 1543:
      if (lookahead == 'a') ADVANCE(1572);
      END_STATE();
    case 1544:
      if (lookahead == 'a') ADVANCE(1573);
      END_STATE();
    case 1545:
      if (lookahead == 'a') ADVANCE(1575);
      END_STATE();
    case 1546:
      if (lookahead == 'a') ADVANCE(1576);
      if (lookahead == 'i') ADVANCE(3027);
      END_STATE();
    case 1547:
      if (lookahead == 'a') ADVANCE(1577);
      END_STATE();
    case 1548:
      if (lookahead == 'a') ADVANCE(1578);
      END_STATE();
    case 1549:
      if (lookahead == 'a') ADVANCE(1579);
      END_STATE();
    case 1550:
      if (lookahead == 'a') ADVANCE(2415);
      END_STATE();
    case 1551:
      if (lookahead == 'a') ADVANCE(2471);
      END_STATE();
    case 1552:
      if (lookahead == 'a') ADVANCE(2570);
      END_STATE();
    case 1553:
      if (lookahead == 'a') ADVANCE(1710);
      if (lookahead == 'b') ADVANCE(2587);
      if (lookahead == 'd') ADVANCE(2252);
      if (lookahead == 'l') ADVANCE(2216);
      if (lookahead == 'r') ADVANCE(1432);
      END_STATE();
    case 1554:
      if (lookahead == 'a') ADVANCE(1710);
      if (lookahead == 'b') ADVANCE(2587);
      if (lookahead == 'd') ADVANCE(2252);
      if (lookahead == 'l') ADVANCE(2216);
      if (lookahead == 'r') ADVANCE(1432);
      if (lookahead == 's') ADVANCE(1991);
      if (lookahead == 't') ADVANCE(1894);
      END_STATE();
    case 1555:
      if (lookahead == 'a') ADVANCE(1710);
      if (lookahead == 'd') ADVANCE(2219);
      if (lookahead == 'l') ADVANCE(2216);
      if (lookahead == 'r') ADVANCE(1908);
      if (lookahead == 's') ADVANCE(1991);
      if (lookahead == 't') ADVANCE(2041);
      if (lookahead == 'v') ADVANCE(2584);
      END_STATE();
    case 1556:
      if (lookahead == 'a') ADVANCE(1710);
      if (lookahead == 'd') ADVANCE(2252);
      if (lookahead == 'l') ADVANCE(2216);
      if (lookahead == 'r') ADVANCE(1908);
      END_STATE();
    case 1557:
      if (lookahead == 'a') ADVANCE(1710);
      if (lookahead == 'd') ADVANCE(2252);
      if (lookahead == 'l') ADVANCE(2216);
      if (lookahead == 'r') ADVANCE(1908);
      if (lookahead == 's') ADVANCE(1991);
      if (lookahead == 't') ADVANCE(1894);
      END_STATE();
    case 1558:
      if (lookahead == 'a') ADVANCE(1710);
      if (lookahead == 'd') ADVANCE(2252);
      if (lookahead == 'l') ADVANCE(2216);
      if (lookahead == 'r') ADVANCE(1908);
      if (lookahead == 's') ADVANCE(1991);
      if (lookahead == 't') ADVANCE(2041);
      END_STATE();
    case 1559:
      if (lookahead == 'a') ADVANCE(1710);
      if (lookahead == 'd') ADVANCE(2252);
      if (lookahead == 'l') ADVANCE(2216);
      if (lookahead == 'r') ADVANCE(1908);
      if (lookahead == 't') ADVANCE(1893);
      END_STATE();
    case 1560:
      if (lookahead == 'b') ADVANCE(3786);
      END_STATE();
    case 1561:
      if (lookahead == 'b') ADVANCE(3808);
      END_STATE();
    case 1562:
      if (lookahead == 'b') ADVANCE(3885);
      END_STATE();
    case 1563:
      if (lookahead == 'b') ADVANCE(1562);
      END_STATE();
    case 1564:
      if (lookahead == 'b') ADVANCE(3014);
      END_STATE();
    case 1565:
      if (lookahead == 'b') ADVANCE(2355);
      END_STATE();
    case 1566:
      if (lookahead == 'b') ADVANCE(1942);
      END_STATE();
    case 1567:
      if (lookahead == 'b') ADVANCE(1942);
      if (lookahead == 'n') ADVANCE(1778);
      if (lookahead == 'r') ADVANCE(2109);
      END_STATE();
    case 1568:
      if (lookahead == 'b') ADVANCE(1462);
      END_STATE();
    case 1569:
      if (lookahead == 'b') ADVANCE(1450);
      END_STATE();
    case 1570:
      if (lookahead == 'b') ADVANCE(2366);
      END_STATE();
    case 1571:
      if (lookahead == 'b') ADVANCE(2368);
      END_STATE();
    case 1572:
      if (lookahead == 'b') ADVANCE(2371);
      END_STATE();
    case 1573:
      if (lookahead == 'b') ADVANCE(2372);
      END_STATE();
    case 1574:
      if (lookahead == 'b') ADVANCE(2195);
      END_STATE();
    case 1575:
      if (lookahead == 'b') ADVANCE(2374);
      END_STATE();
    case 1576:
      if (lookahead == 'b') ADVANCE(2375);
      END_STATE();
    case 1577:
      if (lookahead == 'b') ADVANCE(2376);
      END_STATE();
    case 1578:
      if (lookahead == 'b') ADVANCE(2377);
      END_STATE();
    case 1579:
      if (lookahead == 'b') ADVANCE(2378);
      END_STATE();
    case 1580:
      if (lookahead == 'b') ADVANCE(2403);
      END_STATE();
    case 1581:
      if (lookahead == 'b') ADVANCE(2409);
      END_STATE();
    case 1582:
      if (lookahead == 'b') ADVANCE(2411);
      END_STATE();
    case 1583:
      ADVANCE_MAP(
        'c', 2696,
        'd', 1715,
        'l', 2176,
        'n', 1716,
        'p', 2670,
        'r', 2120,
        's', 2133,
        't', 2906,
        'v', 1477,
      );
      END_STATE();
    case 1584:
      if (lookahead == 'c') ADVANCE(2696);
      if (lookahead == 'd') ADVANCE(1776);
      if (lookahead == 'f') ADVANCE(2473);
      if (lookahead == 'l') ADVANCE(2148);
      if (lookahead == 'r') ADVANCE(1621);
      if (lookahead == 't') ADVANCE(2648);
      END_STATE();
    case 1585:
      if (lookahead == 'c') ADVANCE(2696);
      if (lookahead == 'd') ADVANCE(1794);
      if (lookahead == 'n') ADVANCE(1716);
      if (lookahead == 'p') ADVANCE(2670);
      if (lookahead == 's') ADVANCE(2133);
      if (lookahead == 't') ADVANCE(2906);
      if (lookahead == 'v') ADVANCE(1477);
      END_STATE();
    case 1586:
      if (lookahead == 'c') ADVANCE(3285);
      if (lookahead == 'f') ADVANCE(2103);
      if (lookahead == 'o') ADVANCE(2317);
      if (lookahead == 'x') ADVANCE(3045);
      END_STATE();
    case 1587:
      if (lookahead == 'c') ADVANCE(3285);
      if (lookahead == 'f') ADVANCE(2103);
      if (lookahead == 'o') ADVANCE(2316);
      if (lookahead == 'x') ADVANCE(3045);
      END_STATE();
    case 1588:
      if (lookahead == 'c') ADVANCE(3372);
      END_STATE();
    case 1589:
      if (lookahead == 'c') ADVANCE(3372);
      if (lookahead == 'e') ADVANCE(2915);
      END_STATE();
    case 1590:
      if (lookahead == 'c') ADVANCE(3372);
      if (lookahead == 'e') ADVANCE(2915);
      if (lookahead == 'h') ADVANCE(1682);
      if (lookahead == 'l') ADVANCE(2581);
      END_STATE();
    case 1591:
      if (lookahead == 'c') ADVANCE(3372);
      if (lookahead == 'l') ADVANCE(2581);
      END_STATE();
    case 1592:
      if (lookahead == 'c') ADVANCE(3622);
      END_STATE();
    case 1593:
      if (lookahead == 'c') ADVANCE(1367);
      END_STATE();
    case 1594:
      if (lookahead == 'c') ADVANCE(3623);
      END_STATE();
    case 1595:
      if (lookahead == 'c') ADVANCE(3254);
      END_STATE();
    case 1596:
      if (lookahead == 'c') ADVANCE(3895);
      END_STATE();
    case 1597:
      if (lookahead == 'c') ADVANCE(3834);
      END_STATE();
    case 1598:
      if (lookahead == 'c') ADVANCE(3712);
      END_STATE();
    case 1599:
      if (lookahead == 'c') ADVANCE(3224);
      END_STATE();
    case 1600:
      if (lookahead == 'c') ADVANCE(3223);
      END_STATE();
    case 1601:
      if (lookahead == 'c') ADVANCE(3465);
      END_STATE();
    case 1602:
      if (lookahead == 'c') ADVANCE(3840);
      END_STATE();
    case 1603:
      if (lookahead == 'c') ADVANCE(3878);
      END_STATE();
    case 1604:
      if (lookahead == 'c') ADVANCE(3226);
      END_STATE();
    case 1605:
      if (lookahead == 'c') ADVANCE(3899);
      END_STATE();
    case 1606:
      if (lookahead == 'c') ADVANCE(3860);
      END_STATE();
    case 1607:
      if (lookahead == 'c') ADVANCE(3898);
      END_STATE();
    case 1608:
      if (lookahead == 'c') ADVANCE(3897);
      END_STATE();
    case 1609:
      if (lookahead == 'c') ADVANCE(3228);
      END_STATE();
    case 1610:
      if (lookahead == 'c') ADVANCE(3233);
      END_STATE();
    case 1611:
      if (lookahead == 'c') ADVANCE(3227);
      END_STATE();
    case 1612:
      if (lookahead == 'c') ADVANCE(3230);
      END_STATE();
    case 1613:
      if (lookahead == 'c') ADVANCE(3621);
      END_STATE();
    case 1614:
      if (lookahead == 'c') ADVANCE(3604);
      END_STATE();
    case 1615:
      if (lookahead == 'c') ADVANCE(3711);
      END_STATE();
    case 1616:
      if (lookahead == 'c') ADVANCE(2136);
      if (lookahead == 'o') ADVANCE(2720);
      END_STATE();
    case 1617:
      if (lookahead == 'c') ADVANCE(2125);
      END_STATE();
    case 1618:
      if (lookahead == 'c') ADVANCE(2274);
      END_STATE();
    case 1619:
      if (lookahead == 'c') ADVANCE(2653);
      END_STATE();
    case 1620:
      if (lookahead == 'c') ADVANCE(2653);
      if (lookahead == 'g') ADVANCE(2447);
      if (lookahead == 'm') ADVANCE(1308);
      END_STATE();
    case 1621:
      if (lookahead == 'c') ADVANCE(2653);
      if (lookahead == 'g') ADVANCE(2466);
      END_STATE();
    case 1622:
      if (lookahead == 'c') ADVANCE(2653);
      if (lookahead == 'g') ADVANCE(2466);
      if (lookahead == 'm') ADVANCE(1308);
      END_STATE();
    case 1623:
      if (lookahead == 'c') ADVANCE(2126);
      END_STATE();
    case 1624:
      if (lookahead == 'c') ADVANCE(1314);
      END_STATE();
    case 1625:
      if (lookahead == 'c') ADVANCE(2392);
      if (lookahead == 'f') ADVANCE(1489);
      END_STATE();
    case 1626:
      if (lookahead == 'c') ADVANCE(2392);
      if (lookahead == 'f') ADVANCE(1489);
      if (lookahead == 'r') ADVANCE(1907);
      END_STATE();
    case 1627:
      if (lookahead == 'c') ADVANCE(2392);
      if (lookahead == 'f') ADVANCE(2209);
      if (lookahead == 'r') ADVANCE(1907);
      END_STATE();
    case 1628:
      if (lookahead == 'c') ADVANCE(2127);
      END_STATE();
    case 1629:
      if (lookahead == 'c') ADVANCE(2076);
      END_STATE();
    case 1630:
      if (lookahead == 'c') ADVANCE(2264);
      END_STATE();
    case 1631:
      if (lookahead == 'c') ADVANCE(2139);
      END_STATE();
    case 1632:
      if (lookahead == 'c') ADVANCE(2265);
      END_STATE();
    case 1633:
      if (lookahead == 'c') ADVANCE(2145);
      END_STATE();
    case 1634:
      if (lookahead == 'c') ADVANCE(2266);
      END_STATE();
    case 1635:
      if (lookahead == 'c') ADVANCE(2128);
      END_STATE();
    case 1636:
      if (lookahead == 'c') ADVANCE(2267);
      END_STATE();
    case 1637:
      if (lookahead == 'c') ADVANCE(1419);
      END_STATE();
    case 1638:
      if (lookahead == 'c') ADVANCE(2129);
      END_STATE();
    case 1639:
      if (lookahead == 'c') ADVANCE(2278);
      END_STATE();
    case 1640:
      if (lookahead == 'c') ADVANCE(2989);
      if (lookahead == 'd') ADVANCE(3087);
      if (lookahead == 't') ADVANCE(3007);
      END_STATE();
    case 1641:
      if (lookahead == 'c') ADVANCE(2867);
      END_STATE();
    case 1642:
      if (lookahead == 'c') ADVANCE(2130);
      END_STATE();
    case 1643:
      if (lookahead == 'c') ADVANCE(2269);
      END_STATE();
    case 1644:
      if (lookahead == 'c') ADVANCE(2131);
      END_STATE();
    case 1645:
      if (lookahead == 'c') ADVANCE(1595);
      END_STATE();
    case 1646:
      if (lookahead == 'c') ADVANCE(1600);
      END_STATE();
    case 1647:
      if (lookahead == 'c') ADVANCE(1369);
      END_STATE();
    case 1648:
      if (lookahead == 'c') ADVANCE(2874);
      END_STATE();
    case 1649:
      if (lookahead == 'c') ADVANCE(2625);
      END_STATE();
    case 1650:
      if (lookahead == 'c') ADVANCE(2954);
      END_STATE();
    case 1651:
      if (lookahead == 'c') ADVANCE(2631);
      END_STATE();
    case 1652:
      if (lookahead == 'c') ADVANCE(1824);
      END_STATE();
    case 1653:
      if (lookahead == 'c') ADVANCE(1604);
      END_STATE();
    case 1654:
      if (lookahead == 'c') ADVANCE(2827);
      END_STATE();
    case 1655:
      if (lookahead == 'c') ADVANCE(2884);
      END_STATE();
    case 1656:
      if (lookahead == 'c') ADVANCE(2886);
      END_STATE();
    case 1657:
      if (lookahead == 'c') ADVANCE(2887);
      END_STATE();
    case 1658:
      if (lookahead == 'c') ADVANCE(1609);
      END_STATE();
    case 1659:
      if (lookahead == 'c') ADVANCE(1922);
      END_STATE();
    case 1660:
      if (lookahead == 'c') ADVANCE(1610);
      END_STATE();
    case 1661:
      if (lookahead == 'c') ADVANCE(1611);
      END_STATE();
    case 1662:
      if (lookahead == 'c') ADVANCE(1612);
      END_STATE();
    case 1663:
      if (lookahead == 'c') ADVANCE(2730);
      END_STATE();
    case 1664:
      if (lookahead == 'c') ADVANCE(1997);
      END_STATE();
    case 1665:
      if (lookahead == 'c') ADVANCE(2894);
      END_STATE();
    case 1666:
      if (lookahead == 'c') ADVANCE(2895);
      END_STATE();
    case 1667:
      if (lookahead == 'c') ADVANCE(2942);
      END_STATE();
    case 1668:
      if (lookahead == 'c') ADVANCE(2943);
      END_STATE();
    case 1669:
      if (lookahead == 'c') ADVANCE(1847);
      END_STATE();
    case 1670:
      if (lookahead == 'c') ADVANCE(1853);
      END_STATE();
    case 1671:
      if (lookahead == 'c') ADVANCE(1871);
      END_STATE();
    case 1672:
      if (lookahead == 'c') ADVANCE(2034);
      END_STATE();
    case 1673:
      if (lookahead == 'c') ADVANCE(1879);
      END_STATE();
    case 1674:
      if (lookahead == 'c') ADVANCE(2439);
      if (lookahead == 'f') ADVANCE(3008);
      if (lookahead == 'm') ADVANCE(2437);
      if (lookahead == 'n') ADVANCE(1364);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3339);
      END_STATE();
    case 1675:
      if (lookahead == 'c') ADVANCE(2439);
      if (lookahead == 'm') ADVANCE(2437);
      if (lookahead == 'n') ADVANCE(1554);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3339);
      END_STATE();
    case 1676:
      if (lookahead == 'c') ADVANCE(2439);
      if (lookahead == 'm') ADVANCE(2437);
      if (lookahead == 'n') ADVANCE(1557);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3339);
      END_STATE();
    case 1677:
      if (lookahead == 'c') ADVANCE(2439);
      if (lookahead == 'm') ADVANCE(2437);
      if (lookahead == 'n') ADVANCE(1555);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3339);
      END_STATE();
    case 1678:
      if (lookahead == 'c') ADVANCE(2439);
      if (lookahead == 'm') ADVANCE(2437);
      if (lookahead == 'n') ADVANCE(1558);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3339);
      END_STATE();
    case 1679:
      if (lookahead == 'c') ADVANCE(2439);
      if (lookahead == 'n') ADVANCE(2818);
      END_STATE();
    case 1680:
      if (lookahead == 'c') ADVANCE(2439);
      if (lookahead == 'n') ADVANCE(2818);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3339);
      END_STATE();
    case 1681:
      if (lookahead == 'c') ADVANCE(2439);
      if (lookahead == 'n') ADVANCE(1519);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3339);
      END_STATE();
    case 1682:
      if (lookahead == 'c') ADVANCE(1645);
      END_STATE();
    case 1683:
      if (lookahead == 'c') ADVANCE(2138);
      END_STATE();
    case 1684:
      if (lookahead == 'c') ADVANCE(2140);
      END_STATE();
    case 1685:
      if (lookahead == 'c') ADVANCE(1659);
      if (lookahead == 'l') ADVANCE(2390);
      END_STATE();
    case 1686:
      if (lookahead == 'c') ADVANCE(1498);
      END_STATE();
    case 1687:
      if (lookahead == 'c') ADVANCE(2202);
      END_STATE();
    case 1688:
      if (lookahead == 'c') ADVANCE(2919);
      END_STATE();
    case 1689:
      if (lookahead == 'c') ADVANCE(2919);
      if (lookahead == 'l') ADVANCE(2001);
      if (lookahead == 'q') ADVANCE(1324);
      if (lookahead == 'x') ADVANCE(2864);
      END_STATE();
    case 1690:
      if (lookahead == 'c') ADVANCE(2919);
      if (lookahead == 'l') ADVANCE(2001);
      if (lookahead == 'x') ADVANCE(2864);
      END_STATE();
    case 1691:
      if (lookahead == 'c') ADVANCE(2919);
      if (lookahead == 'q') ADVANCE(1324);
      END_STATE();
    case 1692:
      if (lookahead == 'c') ADVANCE(2832);
      END_STATE();
    case 1693:
      if (lookahead == 'c') ADVANCE(1499);
      END_STATE();
    case 1694:
      if (lookahead == 'c') ADVANCE(2991);
      END_STATE();
    case 1695:
      if (lookahead == 'c') ADVANCE(2932);
      END_STATE();
    case 1696:
      if (lookahead == 'c') ADVANCE(2045);
      END_STATE();
    case 1697:
      if (lookahead == 'c') ADVANCE(1460);
      END_STATE();
    case 1698:
      if (lookahead == 'c') ADVANCE(1485);
      END_STATE();
    case 1699:
      if (lookahead == 'c') ADVANCE(1468);
      END_STATE();
    case 1700:
      if (lookahead == 'c') ADVANCE(1473);
      END_STATE();
    case 1701:
      if (lookahead == 'c') ADVANCE(1515);
      END_STATE();
    case 1702:
      if (lookahead == 'c') ADVANCE(2953);
      END_STATE();
    case 1703:
      if (lookahead == 'c') ADVANCE(1520);
      END_STATE();
    case 1704:
      if (lookahead == 'c') ADVANCE(1521);
      END_STATE();
    case 1705:
      if (lookahead == 'c') ADVANCE(1524);
      END_STATE();
    case 1706:
      if (lookahead == 'c') ADVANCE(1525);
      END_STATE();
    case 1707:
      if (lookahead == 'c') ADVANCE(2852);
      END_STATE();
    case 1708:
      if (lookahead == 'c') ADVANCE(2976);
      END_STATE();
    case 1709:
      if (lookahead == 'c') ADVANCE(2049);
      END_STATE();
    case 1710:
      if (lookahead == 'c') ADVANCE(1709);
      if (lookahead == 'l') ADVANCE(2390);
      END_STATE();
    case 1711:
      if (lookahead == 'c') ADVANCE(2051);
      END_STATE();
    case 1712:
      if (lookahead == 'c') ADVANCE(1711);
      END_STATE();
    case 1713:
      ADVANCE_MAP(
        'd', 1715,
        'f', 2473,
        'l', 2175,
        'n', 1716,
        'p', 2670,
        'r', 1621,
        's', 2132,
        't', 2906,
        'v', 1477,
      );
      END_STATE();
    case 1714:
      if (lookahead == 'd') ADVANCE(1715);
      if (lookahead == 'n') ADVANCE(1716);
      if (lookahead == 'p') ADVANCE(2670);
      if (lookahead == 's') ADVANCE(2132);
      if (lookahead == 'v') ADVANCE(1477);
      END_STATE();
    case 1715:
      if (lookahead == 'd') ADVANCE(3784);
      END_STATE();
    case 1716:
      if (lookahead == 'd') ADVANCE(3788);
      END_STATE();
    case 1717:
      if (lookahead == 'd') ADVANCE(3788);
      if (lookahead == 'y') ADVANCE(3901);
      END_STATE();
    case 1718:
      if (lookahead == 'd') ADVANCE(3788);
      if (lookahead == 'y') ADVANCE(3900);
      END_STATE();
    case 1719:
      if (lookahead == 'd') ADVANCE(3788);
      if (lookahead == 'y') ADVANCE(2748);
      END_STATE();
    case 1720:
      if (lookahead == 'd') ADVANCE(3394);
      END_STATE();
    case 1721:
      if (lookahead == 'd') ADVANCE(3806);
      END_STATE();
    case 1722:
      if (lookahead == 'd') ADVANCE(3709);
      END_STATE();
    case 1723:
      if (lookahead == 'd') ADVANCE(3790);
      END_STATE();
    case 1724:
      if (lookahead == 'd') ADVANCE(3635);
      if (lookahead == 's') ADVANCE(2848);
      END_STATE();
    case 1725:
      if (lookahead == 'd') ADVANCE(3289);
      END_STATE();
    case 1726:
      if (lookahead == 'd') ADVANCE(3420);
      END_STATE();
    case 1727:
      if (lookahead == 'd') ADVANCE(3672);
      END_STATE();
    case 1728:
      if (lookahead == 'd') ADVANCE(3680);
      END_STATE();
    case 1729:
      if (lookahead == 'd') ADVANCE(3468);
      END_STATE();
    case 1730:
      if (lookahead == 'd') ADVANCE(3588);
      END_STATE();
    case 1731:
      if (lookahead == 'd') ADVANCE(3216);
      END_STATE();
    case 1732:
      if (lookahead == 'd') ADVANCE(3858);
      END_STATE();
    case 1733:
      if (lookahead == 'd') ADVANCE(3695);
      END_STATE();
    case 1734:
      if (lookahead == 'd') ADVANCE(3444);
      END_STATE();
    case 1735:
      if (lookahead == 'd') ADVANCE(3552);
      END_STATE();
    case 1736:
      if (lookahead == 'd') ADVANCE(3513);
      END_STATE();
    case 1737:
      if (lookahead == 'd') ADVANCE(3477);
      END_STATE();
    case 1738:
      if (lookahead == 'd') ADVANCE(3891);
      END_STATE();
    case 1739:
      if (lookahead == 'd') ADVANCE(2565);
      END_STATE();
    case 1740:
      if (lookahead == 'd') ADVANCE(2565);
      if (lookahead == 's') ADVANCE(2848);
      END_STATE();
    case 1741:
      if (lookahead == 'd') ADVANCE(3392);
      END_STATE();
    case 1742:
      if (lookahead == 'd') ADVANCE(3682);
      END_STATE();
    case 1743:
      if (lookahead == 'd') ADVANCE(3781);
      END_STATE();
    case 1744:
      if (lookahead == 'd') ADVANCE(3636);
      END_STATE();
    case 1745:
      if (lookahead == 'd') ADVANCE(3827);
      END_STATE();
    case 1746:
      if (lookahead == 'd') ADVANCE(2107);
      END_STATE();
    case 1747:
      if (lookahead == 'd') ADVANCE(1721);
      if (lookahead == 'l') ADVANCE(2828);
      END_STATE();
    case 1748:
      if (lookahead == 'd') ADVANCE(1721);
      if (lookahead == 'l') ADVANCE(2828);
      if (lookahead == 's') ADVANCE(2861);
      END_STATE();
    case 1749:
      if (lookahead == 'd') ADVANCE(1721);
      if (lookahead == 'l') ADVANCE(2828);
      if (lookahead == 's') ADVANCE(2901);
      END_STATE();
    case 1750:
      if (lookahead == 'd') ADVANCE(1721);
      if (lookahead == 'l') ADVANCE(2828);
      if (lookahead == 's') ADVANCE(2959);
      END_STATE();
    case 1751:
      if (lookahead == 'd') ADVANCE(1721);
      if (lookahead == 's') ADVANCE(2959);
      END_STATE();
    case 1752:
      if (lookahead == 'd') ADVANCE(1782);
      END_STATE();
    case 1753:
      if (lookahead == 'd') ADVANCE(1346);
      END_STATE();
    case 1754:
      if (lookahead == 'd') ADVANCE(2803);
      END_STATE();
    case 1755:
      if (lookahead == 'd') ADVANCE(1505);
      END_STATE();
    case 1756:
      if (lookahead == 'd') ADVANCE(2574);
      END_STATE();
    case 1757:
      if (lookahead == 'd') ADVANCE(1320);
      END_STATE();
    case 1758:
      if (lookahead == 'd') ADVANCE(1971);
      if (lookahead == 'g') ADVANCE(2520);
      if (lookahead == 't') ADVANCE(2621);
      END_STATE();
    case 1759:
      if (lookahead == 'd') ADVANCE(1786);
      END_STATE();
    case 1760:
      if (lookahead == 'd') ADVANCE(1915);
      END_STATE();
    case 1761:
      if (lookahead == 'd') ADVANCE(1915);
      if (lookahead == 'e') ADVANCE(3829);
      if (lookahead == 'n') ADVANCE(1496);
      if (lookahead == 'o') ADVANCE(3831);
      if (lookahead == 'r') ADVANCE(1939);
      if (lookahead == 'w') ADVANCE(2171);
      END_STATE();
    case 1762:
      if (lookahead == 'd') ADVANCE(1915);
      if (lookahead == 'n') ADVANCE(1496);
      END_STATE();
    case 1763:
      if (lookahead == 'd') ADVANCE(1915);
      if (lookahead == 'n') ADVANCE(1496);
      if (lookahead == 'o') ADVANCE(2767);
      END_STATE();
    case 1764:
      if (lookahead == 'd') ADVANCE(1915);
      if (lookahead == 'o') ADVANCE(2767);
      if (lookahead == 'w') ADVANCE(2171);
      END_STATE();
    case 1765:
      if (lookahead == 'd') ADVANCE(1915);
      if (lookahead == 'r') ADVANCE(1939);
      END_STATE();
    case 1766:
      if (lookahead == 'd') ADVANCE(2711);
      END_STATE();
    case 1767:
      if (lookahead == 'd') ADVANCE(2713);
      END_STATE();
    case 1768:
      if (lookahead == 'd') ADVANCE(2714);
      END_STATE();
    case 1769:
      if (lookahead == 'd') ADVANCE(2719);
      END_STATE();
    case 1770:
      if (lookahead == 'd') ADVANCE(1776);
      if (lookahead == 'f') ADVANCE(2473);
      if (lookahead == 'l') ADVANCE(2176);
      if (lookahead == 'r') ADVANCE(1619);
      END_STATE();
    case 1771:
      if (lookahead == 'd') ADVANCE(1924);
      if (lookahead == 'w') ADVANCE(2184);
      END_STATE();
    case 1772:
      if (lookahead == 'd') ADVANCE(1969);
      END_STATE();
    case 1773:
      if (lookahead == 'd') ADVANCE(1344);
      END_STATE();
    case 1774:
      if (lookahead == 'd') ADVANCE(3002);
      END_STATE();
    case 1775:
      if (lookahead == 'd') ADVANCE(3002);
      if (lookahead == 'n') ADVANCE(2616);
      END_STATE();
    case 1776:
      if (lookahead == 'd') ADVANCE(2799);
      END_STATE();
    case 1777:
      if (lookahead == 'd') ADVANCE(3019);
      END_STATE();
    case 1778:
      if (lookahead == 'd') ADVANCE(2178);
      END_STATE();
    case 1779:
      if (lookahead == 'd') ADVANCE(1768);
      END_STATE();
    case 1780:
      if (lookahead == 'd') ADVANCE(1449);
      END_STATE();
    case 1781:
      if (lookahead == 'd') ADVANCE(1449);
      if (lookahead == 'm') ADVANCE(2594);
      END_STATE();
    case 1782:
      if (lookahead == 'd') ADVANCE(1951);
      END_STATE();
    case 1783:
      if (lookahead == 'd') ADVANCE(1769);
      END_STATE();
    case 1784:
      if (lookahead == 'd') ADVANCE(1984);
      END_STATE();
    case 1785:
      if (lookahead == 'd') ADVANCE(2190);
      END_STATE();
    case 1786:
      if (lookahead == 'd') ADVANCE(2764);
      END_STATE();
    case 1787:
      if (lookahead == 'd') ADVANCE(2779);
      END_STATE();
    case 1788:
      if (lookahead == 'd') ADVANCE(2783);
      END_STATE();
    case 1789:
      if (lookahead == 'd') ADVANCE(1336);
      END_STATE();
    case 1790:
      if (lookahead == 'd') ADVANCE(1787);
      END_STATE();
    case 1791:
      if (lookahead == 'd') ADVANCE(2026);
      END_STATE();
    case 1792:
      if (lookahead == 'd') ADVANCE(1788);
      END_STATE();
    case 1793:
      if (lookahead == 'd') ADVANCE(1345);
      END_STATE();
    case 1794:
      if (lookahead == 'd') ADVANCE(3785);
      END_STATE();
    case 1795:
      ADVANCE_MAP(
        'd', 1794,
        'l', 2174,
        'n', 1718,
        'p', 2670,
        'r', 2122,
        's', 2132,
        't', 2646,
        'v', 1477,
      );
      END_STATE();
    case 1796:
      if (lookahead == 'd') ADVANCE(1794);
      if (lookahead == 'n') ADVANCE(1716);
      if (lookahead == 'p') ADVANCE(2670);
      if (lookahead == 's') ADVANCE(2132);
      if (lookahead == 'v') ADVANCE(1477);
      END_STATE();
    case 1797:
      if (lookahead == 'e') ADVANCE(1626);
      if (lookahead == 'i') ADVANCE(2855);
      if (lookahead == 'l') ADVANCE(2306);
      if (lookahead == 'o') ADVANCE(2982);
      if (lookahead == 's') ADVANCE(2582);
      END_STATE();
    case 1798:
      if (lookahead == 'e') ADVANCE(2440);
      if (lookahead == 'i') ADVANCE(2567);
      if (lookahead == 'o') ADVANCE(1775);
      if (lookahead == 's') ADVANCE(2651);
      if (lookahead == 'u') ADVANCE(2835);
      END_STATE();
    case 1799:
      if (lookahead == 'e') ADVANCE(2440);
      if (lookahead == 'i') ADVANCE(2567);
      if (lookahead == 'o') ADVANCE(1775);
      if (lookahead == 'u') ADVANCE(2835);
      END_STATE();
    case 1800:
      if (lookahead == 'e') ADVANCE(2440);
      if (lookahead == 'i') ADVANCE(2567);
      if (lookahead == 'o') ADVANCE(1774);
      if (lookahead == 'u') ADVANCE(2835);
      END_STATE();
    case 1801:
      if (lookahead == 'e') ADVANCE(1365);
      END_STATE();
    case 1802:
      if (lookahead == 'e') ADVANCE(1395);
      if (lookahead == 'i') ADVANCE(2329);
      if (lookahead == 'r') ADVANCE(2213);
      END_STATE();
    case 1803:
      if (lookahead == 'e') ADVANCE(1395);
      if (lookahead == 'i') ADVANCE(2328);
      if (lookahead == 'r') ADVANCE(2241);
      END_STATE();
    case 1804:
      if (lookahead == 'e') ADVANCE(1815);
      END_STATE();
    case 1805:
      if (lookahead == 'e') ADVANCE(1815);
      if (lookahead == 'o') ADVANCE(2423);
      END_STATE();
    case 1806:
      if (lookahead == 'e') ADVANCE(3823);
      if (lookahead == 't') ADVANCE(3822);
      END_STATE();
    case 1807:
      if (lookahead == 'e') ADVANCE(3825);
      if (lookahead == 't') ADVANCE(3824);
      END_STATE();
    case 1808:
      if (lookahead == 'e') ADVANCE(3826);
      END_STATE();
    case 1809:
      if (lookahead == 'e') ADVANCE(1447);
      if (lookahead == 'i') ADVANCE(3024);
      if (lookahead == 'o') ADVANCE(2336);
      END_STATE();
    case 1810:
      if (lookahead == 'e') ADVANCE(3818);
      if (lookahead == 't') ADVANCE(3817);
      END_STATE();
    case 1811:
      if (lookahead == 'e') ADVANCE(3820);
      if (lookahead == 't') ADVANCE(3819);
      END_STATE();
    case 1812:
      if (lookahead == 'e') ADVANCE(3814);
      if (lookahead == 't') ADVANCE(3813);
      END_STATE();
    case 1813:
      if (lookahead == 'e') ADVANCE(3816);
      if (lookahead == 't') ADVANCE(3815);
      END_STATE();
    case 1814:
      if (lookahead == 'e') ADVANCE(3829);
      if (lookahead == 'o') ADVANCE(3830);
      END_STATE();
    case 1815:
      if (lookahead == 'e') ADVANCE(3076);
      if (lookahead == 'm') ADVANCE(3777);
      END_STATE();
    case 1816:
      if (lookahead == 'e') ADVANCE(2289);
      if (lookahead == 't') ADVANCE(2592);
      END_STATE();
    case 1817:
      if (lookahead == 'e') ADVANCE(3632);
      END_STATE();
    case 1818:
      if (lookahead == 'e') ADVANCE(3632);
      if (lookahead == 'l') ADVANCE(1399);
      if (lookahead == 'n') ADVANCE(2990);
      END_STATE();
    case 1819:
      if (lookahead == 'e') ADVANCE(1640);
      END_STATE();
    case 1820:
      if (lookahead == 'e') ADVANCE(3730);
      END_STATE();
    case 1821:
      if (lookahead == 'e') ADVANCE(3730);
      if (lookahead == 'n') ADVANCE(1597);
      END_STATE();
    case 1822:
      if (lookahead == 'e') ADVANCE(3890);
      END_STATE();
    case 1823:
      if (lookahead == 'e') ADVANCE(3733);
      END_STATE();
    case 1824:
      if (lookahead == 'e') ADVANCE(3720);
      END_STATE();
    case 1825:
      if (lookahead == 'e') ADVANCE(3714);
      END_STATE();
    case 1826:
      if (lookahead == 'e') ADVANCE(3638);
      END_STATE();
    case 1827:
      if (lookahead == 'e') ADVANCE(3168);
      END_STATE();
    case 1828:
      if (lookahead == 'e') ADVANCE(3301);
      END_STATE();
    case 1829:
      if (lookahead == 'e') ADVANCE(3649);
      END_STATE();
    case 1830:
      if (lookahead == 'e') ADVANCE(3669);
      END_STATE();
    case 1831:
      if (lookahead == 'e') ADVANCE(3886);
      END_STATE();
    case 1832:
      if (lookahead == 'e') ADVANCE(3432);
      END_STATE();
    case 1833:
      if (lookahead == 'e') ADVANCE(3331);
      END_STATE();
    case 1834:
      if (lookahead == 'e') ADVANCE(3647);
      END_STATE();
    case 1835:
      if (lookahead == 'e') ADVANCE(3163);
      END_STATE();
    case 1836:
      if (lookahead == 'e') ADVANCE(3352);
      END_STATE();
    case 1837:
      if (lookahead == 'e') ADVANCE(3862);
      END_STATE();
    case 1838:
      if (lookahead == 'e') ADVANCE(3167);
      END_STATE();
    case 1839:
      if (lookahead == 'e') ADVANCE(3725);
      END_STATE();
    case 1840:
      if (lookahead == 'e') ADVANCE(3417);
      END_STATE();
    case 1841:
      if (lookahead == 'e') ADVANCE(3441);
      END_STATE();
    case 1842:
      if (lookahead == 'e') ADVANCE(3483);
      END_STATE();
    case 1843:
      if (lookahead == 'e') ADVANCE(3486);
      END_STATE();
    case 1844:
      if (lookahead == 'e') ADVANCE(3171);
      END_STATE();
    case 1845:
      if (lookahead == 'e') ADVANCE(3864);
      END_STATE();
    case 1846:
      if (lookahead == 'e') ADVANCE(3618);
      END_STATE();
    case 1847:
      if (lookahead == 'e') ADVANCE(3186);
      END_STATE();
    case 1848:
      if (lookahead == 'e') ADVANCE(3438);
      END_STATE();
    case 1849:
      if (lookahead == 'e') ADVANCE(3376);
      END_STATE();
    case 1850:
      if (lookahead == 'e') ADVANCE(3489);
      END_STATE();
    case 1851:
      if (lookahead == 'e') ADVANCE(3905);
      END_STATE();
    case 1852:
      if (lookahead == 'e') ADVANCE(3713);
      END_STATE();
    case 1853:
      if (lookahead == 'e') ADVANCE(3357);
      END_STATE();
    case 1854:
      if (lookahead == 'e') ADVANCE(3383);
      END_STATE();
    case 1855:
      if (lookahead == 'e') ADVANCE(3414);
      END_STATE();
    case 1856:
      if (lookahead == 'e') ADVANCE(3582);
      END_STATE();
    case 1857:
      if (lookahead == 'e') ADVANCE(3447);
      END_STATE();
    case 1858:
      if (lookahead == 'e') ADVANCE(3459);
      END_STATE();
    case 1859:
      if (lookahead == 'e') ADVANCE(3450);
      END_STATE();
    case 1860:
      if (lookahead == 'e') ADVANCE(3639);
      END_STATE();
    case 1861:
      if (lookahead == 'e') ADVANCE(3870);
      END_STATE();
    case 1862:
      if (lookahead == 'e') ADVANCE(3576);
      END_STATE();
    case 1863:
      if (lookahead == 'e') ADVANCE(3728);
      END_STATE();
    case 1864:
      if (lookahead == 'e') ADVANCE(3429);
      END_STATE();
    case 1865:
      if (lookahead == 'e') ADVANCE(3640);
      END_STATE();
    case 1866:
      if (lookahead == 'e') ADVANCE(3386);
      END_STATE();
    case 1867:
      if (lookahead == 'e') ADVANCE(3726);
      END_STATE();
    case 1868:
      if (lookahead == 'e') ADVANCE(3525);
      END_STATE();
    case 1869:
      if (lookahead == 'e') ADVANCE(3549);
      END_STATE();
    case 1870:
      if (lookahead == 'e') ADVANCE(3904);
      END_STATE();
    case 1871:
      if (lookahead == 'e') ADVANCE(3501);
      END_STATE();
    case 1872:
      if (lookahead == 'e') ADVANCE(3596);
      END_STATE();
    case 1873:
      if (lookahead == 'e') ADVANCE(3210);
      END_STATE();
    case 1874:
      if (lookahead == 'e') ADVANCE(3166);
      END_STATE();
    case 1875:
      if (lookahead == 'e') ADVANCE(3474);
      END_STATE();
    case 1876:
      if (lookahead == 'e') ADVANCE(2079);
      if (lookahead == 'i') ADVANCE(2855);
      if (lookahead == 'l') ADVANCE(2306);
      if (lookahead == 'o') ADVANCE(2982);
      if (lookahead == 's') ADVANCE(2582);
      END_STATE();
    case 1877:
      if (lookahead == 'e') ADVANCE(1463);
      END_STATE();
    case 1878:
      if (lookahead == 'e') ADVANCE(1464);
      END_STATE();
    case 1879:
      if (lookahead == 'e') ADVANCE(3355);
      END_STATE();
    case 1880:
      if (lookahead == 'e') ADVANCE(1625);
      if (lookahead == 'l') ADVANCE(2306);
      if (lookahead == 'o') ADVANCE(2982);
      if (lookahead == 's') ADVANCE(2582);
      END_STATE();
    case 1881:
      if (lookahead == 'e') ADVANCE(1470);
      END_STATE();
    case 1882:
      if (lookahead == 'e') ADVANCE(3637);
      END_STATE();
    case 1883:
      if (lookahead == 'e') ADVANCE(3351);
      END_STATE();
    case 1884:
      if (lookahead == 'e') ADVANCE(2697);
      if (lookahead == 'g') ADVANCE(1806);
      if (lookahead == 'l') ADVANCE(1807);
      if (lookahead == 'n') ADVANCE(1808);
      if (lookahead == 'p') ADVANCE(1403);
      if (lookahead == 'r') ADVANCE(3792);
      END_STATE();
    case 1885:
      if (lookahead == 'e') ADVANCE(2697);
      if (lookahead == 'g') ADVANCE(1806);
      if (lookahead == 'l') ADVANCE(1807);
      if (lookahead == 'n') ADVANCE(1808);
      if (lookahead == 'p') ADVANCE(1403);
      if (lookahead == 'r') ADVANCE(1745);
      END_STATE();
    case 1886:
      if (lookahead == 'e') ADVANCE(2697);
      if (lookahead == 'g') ADVANCE(1806);
      if (lookahead == 'l') ADVANCE(1807);
      if (lookahead == 'n') ADVANCE(1808);
      if (lookahead == 'p') ADVANCE(1402);
      if (lookahead == 'r') ADVANCE(1745);
      END_STATE();
    case 1887:
      if (lookahead == 'e') ADVANCE(1627);
      if (lookahead == 'i') ADVANCE(2855);
      if (lookahead == 'o') ADVANCE(2982);
      END_STATE();
    case 1888:
      if (lookahead == 'e') ADVANCE(1627);
      if (lookahead == 'i') ADVANCE(2811);
      if (lookahead == 'o') ADVANCE(2982);
      END_STATE();
    case 1889:
      if (lookahead == 'e') ADVANCE(2425);
      END_STATE();
    case 1890:
      if (lookahead == 'e') ADVANCE(2731);
      END_STATE();
    case 1891:
      if (lookahead == 'e') ADVANCE(1446);
      if (lookahead == 'i') ADVANCE(3024);
      if (lookahead == 'o') ADVANCE(2336);
      END_STATE();
    case 1892:
      if (lookahead == 'e') ADVANCE(1446);
      if (lookahead == 'o') ADVANCE(2335);
      END_STATE();
    case 1893:
      if (lookahead == 'e') ADVANCE(2400);
      END_STATE();
    case 1894:
      if (lookahead == 'e') ADVANCE(2400);
      if (lookahead == 't') ADVANCE(2592);
      END_STATE();
    case 1895:
      if (lookahead == 'e') ADVANCE(1448);
      if (lookahead == 'i') ADVANCE(3024);
      if (lookahead == 'o') ADVANCE(2925);
      END_STATE();
    case 1896:
      if (lookahead == 'e') ADVANCE(1396);
      END_STATE();
    case 1897:
      if (lookahead == 'e') ADVANCE(2698);
      if (lookahead == 'g') ADVANCE(1812);
      if (lookahead == 'l') ADVANCE(1813);
      if (lookahead == 'n') ADVANCE(1814);
      if (lookahead == 's') ADVANCE(2002);
      if (lookahead == 'w') ADVANCE(2911);
      END_STATE();
    case 1898:
      if (lookahead == 'e') ADVANCE(2915);
      END_STATE();
    case 1899:
      if (lookahead == 'e') ADVANCE(2915);
      if (lookahead == 'h') ADVANCE(1682);
      END_STATE();
    case 1900:
      if (lookahead == 'e') ADVANCE(2090);
      END_STATE();
    case 1901:
      if (lookahead == 'e') ADVANCE(1465);
      END_STATE();
    case 1902:
      if (lookahead == 'e') ADVANCE(1429);
      END_STATE();
    case 1903:
      if (lookahead == 'e') ADVANCE(1397);
      END_STATE();
    case 1904:
      if (lookahead == 'e') ADVANCE(2060);
      END_STATE();
    case 1905:
      if (lookahead == 'e') ADVANCE(2699);
      END_STATE();
    case 1906:
      if (lookahead == 'e') ADVANCE(3047);
      if (lookahead == 't') ADVANCE(2573);
      END_STATE();
    case 1907:
      if (lookahead == 'e') ADVANCE(2080);
      END_STATE();
    case 1908:
      if (lookahead == 'e') ADVANCE(2093);
      END_STATE();
    case 1909:
      if (lookahead == 'e') ADVANCE(3046);
      if (lookahead == 'i') ADVANCE(2470);
      END_STATE();
    case 1910:
      if (lookahead == 'e') ADVANCE(2846);
      END_STATE();
    case 1911:
      if (lookahead == 'e') ADVANCE(2426);
      END_STATE();
    case 1912:
      if (lookahead == 'e') ADVANCE(2117);
      END_STATE();
    case 1913:
      if (lookahead == 'e') ADVANCE(2851);
      END_STATE();
    case 1914:
      if (lookahead == 'e') ADVANCE(2427);
      END_STATE();
    case 1915:
      if (lookahead == 'e') ADVANCE(2062);
      END_STATE();
    case 1916:
      if (lookahead == 'e') ADVANCE(3055);
      END_STATE();
    case 1917:
      if (lookahead == 'e') ADVANCE(2432);
      END_STATE();
    case 1918:
      if (lookahead == 'e') ADVANCE(1694);
      END_STATE();
    case 1919:
      if (lookahead == 'e') ADVANCE(1694);
      if (lookahead == 'i') ADVANCE(2780);
      END_STATE();
    case 1920:
      if (lookahead == 'e') ADVANCE(1322);
      END_STATE();
    case 1921:
      if (lookahead == 'e') ADVANCE(2563);
      END_STATE();
    case 1922:
      if (lookahead == 'e') ADVANCE(2844);
      END_STATE();
    case 1923:
      if (lookahead == 'e') ADVANCE(2428);
      END_STATE();
    case 1924:
      if (lookahead == 'e') ADVANCE(2063);
      END_STATE();
    case 1925:
      if (lookahead == 'e') ADVANCE(2743);
      if (lookahead == 'r') ADVANCE(1497);
      END_STATE();
    case 1926:
      if (lookahead == 'e') ADVANCE(2463);
      END_STATE();
    case 1927:
      if (lookahead == 'e') ADVANCE(1304);
      END_STATE();
    case 1928:
      if (lookahead == 'e') ADVANCE(1726);
      END_STATE();
    case 1929:
      if (lookahead == 'e') ADVANCE(2422);
      END_STATE();
    case 1930:
      if (lookahead == 'e') ADVANCE(1305);
      END_STATE();
    case 1931:
      if (lookahead == 'e') ADVANCE(1777);
      if (lookahead == 'u') ADVANCE(2685);
      END_STATE();
    case 1932:
      if (lookahead == 'e') ADVANCE(2429);
      END_STATE();
    case 1933:
      if (lookahead == 'e') ADVANCE(1330);
      END_STATE();
    case 1934:
      if (lookahead == 'e') ADVANCE(1481);
      END_STATE();
    case 1935:
      if (lookahead == 'e') ADVANCE(2077);
      END_STATE();
    case 1936:
      if (lookahead == 'e') ADVANCE(2781);
      END_STATE();
    case 1937:
      if (lookahead == 'e') ADVANCE(2480);
      END_STATE();
    case 1938:
      if (lookahead == 'e') ADVANCE(2804);
      END_STATE();
    case 1939:
      if (lookahead == 'e') ADVANCE(1502);
      END_STATE();
    case 1940:
      if (lookahead == 'e') ADVANCE(2416);
      END_STATE();
    case 1941:
      if (lookahead == 'e') ADVANCE(2821);
      END_STATE();
    case 1942:
      if (lookahead == 'e') ADVANCE(2290);
      END_STATE();
    case 1943:
      if (lookahead == 'e') ADVANCE(2102);
      END_STATE();
    case 1944:
      if (lookahead == 'e') ADVANCE(2078);
      if (lookahead == 'l') ADVANCE(2306);
      if (lookahead == 'o') ADVANCE(2982);
      if (lookahead == 's') ADVANCE(2582);
      END_STATE();
    case 1945:
      if (lookahead == 'e') ADVANCE(2078);
      if (lookahead == 'l') ADVANCE(2306);
      if (lookahead == 's') ADVANCE(2582);
      END_STATE();
    case 1946:
      if (lookahead == 'e') ADVANCE(2517);
      END_STATE();
    case 1947:
      if (lookahead == 'e') ADVANCE(2424);
      END_STATE();
    case 1948:
      if (lookahead == 'e') ADVANCE(2709);
      END_STATE();
    case 1949:
      if (lookahead == 'e') ADVANCE(1773);
      END_STATE();
    case 1950:
      if (lookahead == 'e') ADVANCE(2430);
      END_STATE();
    case 1951:
      if (lookahead == 'e') ADVANCE(2483);
      END_STATE();
    case 1952:
      if (lookahead == 'e') ADVANCE(2431);
      END_STATE();
    case 1953:
      if (lookahead == 'e') ADVANCE(2728);
      END_STATE();
    case 1954:
      if (lookahead == 'e') ADVANCE(2807);
      END_STATE();
    case 1955:
      if (lookahead == 'e') ADVANCE(1325);
      END_STATE();
    case 1956:
      if (lookahead == 'e') ADVANCE(1695);
      END_STATE();
    case 1957:
      if (lookahead == 'e') ADVANCE(1730);
      if (lookahead == 's') ADVANCE(1329);
      END_STATE();
    case 1958:
      if (lookahead == 'e') ADVANCE(2875);
      END_STATE();
    case 1959:
      if (lookahead == 'e') ADVANCE(1427);
      END_STATE();
    case 1960:
      if (lookahead == 'e') ADVANCE(1731);
      END_STATE();
    case 1961:
      if (lookahead == 'e') ADVANCE(2294);
      END_STATE();
    case 1962:
      if (lookahead == 'e') ADVANCE(1732);
      END_STATE();
    case 1963:
      if (lookahead == 'e') ADVANCE(1394);
      END_STATE();
    case 1964:
      if (lookahead == 'e') ADVANCE(1394);
      if (lookahead == 'i') ADVANCE(2327);
      if (lookahead == 'r') ADVANCE(2241);
      END_STATE();
    case 1965:
      if (lookahead == 'e') ADVANCE(1394);
      if (lookahead == 'r') ADVANCE(2242);
      END_STATE();
    case 1966:
      if (lookahead == 'e') ADVANCE(2739);
      END_STATE();
    case 1967:
      if (lookahead == 'e') ADVANCE(1735);
      END_STATE();
    case 1968:
      if (lookahead == 'e') ADVANCE(1435);
      if (lookahead == 'i') ADVANCE(2327);
      if (lookahead == 'r') ADVANCE(2241);
      END_STATE();
    case 1969:
      if (lookahead == 'e') ADVANCE(2715);
      END_STATE();
    case 1970:
      if (lookahead == 'e') ADVANCE(1605);
      END_STATE();
    case 1971:
      if (lookahead == 'e') ADVANCE(1994);
      END_STATE();
    case 1972:
      if (lookahead == 'e') ADVANCE(1738);
      END_STATE();
    case 1973:
      if (lookahead == 'e') ADVANCE(2970);
      END_STATE();
    case 1974:
      if (lookahead == 'e') ADVANCE(1461);
      END_STATE();
    case 1975:
      if (lookahead == 'e') ADVANCE(1636);
      END_STATE();
    case 1976:
      if (lookahead == 'e') ADVANCE(2718);
      END_STATE();
    case 1977:
      if (lookahead == 'e') ADVANCE(2882);
      END_STATE();
    case 1978:
      if (lookahead == 'e') ADVANCE(2792);
      END_STATE();
    case 1979:
      if (lookahead == 'e') ADVANCE(1702);
      END_STATE();
    case 1980:
      if (lookahead == 'e') ADVANCE(1607);
      END_STATE();
    case 1981:
      if (lookahead == 'e') ADVANCE(1639);
      END_STATE();
    case 1982:
      if (lookahead == 'e') ADVANCE(2721);
      END_STATE();
    case 1983:
      if (lookahead == 'e') ADVANCE(1832);
      END_STATE();
    case 1984:
      if (lookahead == 'e') ADVANCE(2562);
      END_STATE();
    case 1985:
      if (lookahead == 'e') ADVANCE(2558);
      END_STATE();
    case 1986:
      if (lookahead == 'e') ADVANCE(2334);
      END_STATE();
    case 1987:
      if (lookahead == 'e') ADVANCE(2383);
      END_STATE();
    case 1988:
      if (lookahead == 'e') ADVANCE(2050);
      END_STATE();
    case 1989:
      if (lookahead == 'e') ADVANCE(2903);
      END_STATE();
    case 1990:
      if (lookahead == 'e') ADVANCE(2865);
      END_STATE();
    case 1991:
      if (lookahead == 'e') ADVANCE(2745);
      END_STATE();
    case 1992:
      if (lookahead == 'e') ADVANCE(2796);
      END_STATE();
    case 1993:
      if (lookahead == 'e') ADVANCE(2458);
      END_STATE();
    case 1994:
      if (lookahead == 'e') ADVANCE(2083);
      END_STATE();
    case 1995:
      if (lookahead == 'e') ADVANCE(2702);
      END_STATE();
    case 1996:
      if (lookahead == 'e') ADVANCE(3049);
      END_STATE();
    case 1997:
      if (lookahead == 'e') ADVANCE(1343);
      END_STATE();
    case 1998:
      if (lookahead == 'e') ADVANCE(3026);
      END_STATE();
    case 1999:
      if (lookahead == 'e') ADVANCE(1327);
      END_STATE();
    case 2000:
      if (lookahead == 'e') ADVANCE(1438);
      END_STATE();
    case 2001:
      if (lookahead == 'e') ADVANCE(1648);
      END_STATE();
    case 2002:
      if (lookahead == 'e') ADVANCE(2341);
      END_STATE();
    case 2003:
      if (lookahead == 'e') ADVANCE(1341);
      END_STATE();
    case 2004:
      if (lookahead == 'e') ADVANCE(3053);
      END_STATE();
    case 2005:
      if (lookahead == 'e') ADVANCE(2831);
      END_STATE();
    case 2006:
      if (lookahead == 'e') ADVANCE(2751);
      END_STATE();
    case 2007:
      if (lookahead == 'e') ADVANCE(2823);
      END_STATE();
    case 2008:
      if (lookahead == 'e') ADVANCE(3050);
      END_STATE();
    case 2009:
      if (lookahead == 'e') ADVANCE(3050);
      if (lookahead == 'i') ADVANCE(2547);
      END_STATE();
    case 2010:
      if (lookahead == 'e') ADVANCE(2825);
      END_STATE();
    case 2011:
      if (lookahead == 'e') ADVANCE(2749);
      END_STATE();
    case 2012:
      if (lookahead == 'e') ADVANCE(2826);
      END_STATE();
    case 2013:
      if (lookahead == 'e') ADVANCE(2451);
      END_STATE();
    case 2014:
      if (lookahead == 'e') ADVANCE(1456);
      END_STATE();
    case 2015:
      if (lookahead == 'e') ADVANCE(2795);
      END_STATE();
    case 2016:
      if (lookahead == 'e') ADVANCE(2531);
      END_STATE();
    case 2017:
      if (lookahead == 'e') ADVANCE(2533);
      END_STATE();
    case 2018:
      if (lookahead == 'e') ADVANCE(1657);
      END_STATE();
    case 2019:
      if (lookahead == 'e') ADVANCE(2521);
      END_STATE();
    case 2020:
      if (lookahead == 'e') ADVANCE(2454);
      END_STATE();
    case 2021:
      if (lookahead == 'e') ADVANCE(1665);
      END_STATE();
    case 2022:
      if (lookahead == 'e') ADVANCE(2761);
      END_STATE();
    case 2023:
      if (lookahead == 'e') ADVANCE(2536);
      END_STATE();
    case 2024:
      if (lookahead == 'e') ADVANCE(2907);
      END_STATE();
    case 2025:
      if (lookahead == 'e') ADVANCE(1666);
      END_STATE();
    case 2026:
      if (lookahead == 'e') ADVANCE(2762);
      END_STATE();
    case 2027:
      if (lookahead == 'e') ADVANCE(2537);
      END_STATE();
    case 2028:
      if (lookahead == 'e') ADVANCE(2456);
      END_STATE();
    case 2029:
      if (lookahead == 'e') ADVANCE(1667);
      END_STATE();
    case 2030:
      if (lookahead == 'e') ADVANCE(2624);
      END_STATE();
    case 2031:
      if (lookahead == 'e') ADVANCE(2538);
      END_STATE();
    case 2032:
      if (lookahead == 'e') ADVANCE(2143);
      END_STATE();
    case 2033:
      if (lookahead == 'e') ADVANCE(1483);
      END_STATE();
    case 2034:
      if (lookahead == 'e') ADVANCE(1686);
      END_STATE();
    case 2035:
      if (lookahead == 'e') ADVANCE(2769);
      END_STATE();
    case 2036:
      if (lookahead == 'e') ADVANCE(2769);
      if (lookahead == 'r') ADVANCE(1497);
      END_STATE();
    case 2037:
      if (lookahead == 'e') ADVANCE(2464);
      END_STATE();
    case 2038:
      if (lookahead == 'e') ADVANCE(2784);
      END_STATE();
    case 2039:
      if (lookahead == 'e') ADVANCE(2564);
      END_STATE();
    case 2040:
      if (lookahead == 'e') ADVANCE(2467);
      END_STATE();
    case 2041:
      if (lookahead == 'e') ADVANCE(2747);
      if (lookahead == 't') ADVANCE(2592);
      END_STATE();
    case 2042:
      if (lookahead == 'e') ADVANCE(2797);
      END_STATE();
    case 2043:
      if (lookahead == 'e') ADVANCE(2468);
      END_STATE();
    case 2044:
      if (lookahead == 'e') ADVANCE(2469);
      END_STATE();
    case 2045:
      if (lookahead == 'e') ADVANCE(1548);
      END_STATE();
    case 2046:
      if (lookahead == 'e') ADVANCE(2419);
      if (lookahead == 'v') ADVANCE(1466);
      END_STATE();
    case 2047:
      if (lookahead == 'e') ADVANCE(1793);
      END_STATE();
    case 2048:
      if (lookahead == 'e') ADVANCE(2420);
      if (lookahead == 'v') ADVANCE(1531);
      END_STATE();
    case 2049:
      if (lookahead == 'e') ADVANCE(2857);
      END_STATE();
    case 2050:
      if (lookahead == 'e') ADVANCE(2472);
      END_STATE();
    case 2051:
      if (lookahead == 'e') ADVANCE(2859);
      END_STATE();
    case 2052:
      if (lookahead == 'f') ADVANCE(2473);
      if (lookahead == 'l') ADVANCE(2175);
      if (lookahead == 'r') ADVANCE(1621);
      if (lookahead == 't') ADVANCE(2906);
      END_STATE();
    case 2053:
      if (lookahead == 'f') ADVANCE(2402);
      END_STATE();
    case 2054:
      if (lookahead == 'f') ADVANCE(2402);
      if (lookahead == 'i') ADVANCE(2905);
      if (lookahead == 'l') ADVANCE(2585);
      END_STATE();
    case 2055:
      if (lookahead == 'f') ADVANCE(2402);
      if (lookahead == 'i') ADVANCE(2905);
      if (lookahead == 'l') ADVANCE(2585);
      if (lookahead == 'r') ADVANCE(3645);
      if (lookahead == 'u') ADVANCE(2208);
      if (lookahead == 'y') ADVANCE(2734);
      END_STATE();
    case 2056:
      if (lookahead == 'f') ADVANCE(2402);
      if (lookahead == 'i') ADVANCE(2905);
      if (lookahead == 'l') ADVANCE(2585);
      if (lookahead == 'u') ADVANCE(2208);
      if (lookahead == 'y') ADVANCE(2734);
      END_STATE();
    case 2057:
      if (lookahead == 'f') ADVANCE(2402);
      if (lookahead == 'u') ADVANCE(2208);
      if (lookahead == 'y') ADVANCE(2734);
      END_STATE();
    case 2058:
      if (lookahead == 'f') ADVANCE(3292);
      END_STATE();
    case 2059:
      if (lookahead == 'f') ADVANCE(3873);
      END_STATE();
    case 2060:
      if (lookahead == 'f') ADVANCE(3567);
      END_STATE();
    case 2061:
      if (lookahead == 'f') ADVANCE(3275);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3283);
      END_STATE();
    case 2062:
      if (lookahead == 'f') ADVANCE(3741);
      END_STATE();
    case 2063:
      if (lookahead == 'f') ADVANCE(3615);
      END_STATE();
    case 2064:
      if (lookahead == 'f') ADVANCE(3600);
      END_STATE();
    case 2065:
      if (lookahead == 'f') ADVANCE(3008);
      if (lookahead == 'm') ADVANCE(2437);
      if (lookahead == 'n') ADVANCE(1553);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3339);
      END_STATE();
    case 2066:
      if (lookahead == 'f') ADVANCE(2086);
      END_STATE();
    case 2067:
      if (lookahead == 'f') ADVANCE(2984);
      END_STATE();
    case 2068:
      if (lookahead == 'f') ADVANCE(2656);
      END_STATE();
    case 2069:
      if (lookahead == 'f') ADVANCE(2870);
      END_STATE();
    case 2070:
      if (lookahead == 'f') ADVANCE(2870);
      if (lookahead == 't') ADVANCE(1628);
      END_STATE();
    case 2071:
      if (lookahead == 'f') ADVANCE(2657);
      END_STATE();
    case 2072:
      if (lookahead == 'f') ADVANCE(1910);
      if (lookahead == 'm') ADVANCE(1913);
      if (lookahead == 'n') ADVANCE(2222);
      END_STATE();
    case 2073:
      if (lookahead == 'f') ADVANCE(1910);
      if (lookahead == 'n') ADVANCE(2222);
      END_STATE();
    case 2074:
      if (lookahead == 'f') ADVANCE(2658);
      END_STATE();
    case 2075:
      if (lookahead == 'f') ADVANCE(2661);
      END_STATE();
    case 2076:
      if (lookahead == 'f') ADVANCE(2153);
      END_STATE();
    case 2077:
      if (lookahead == 'f') ADVANCE(2810);
      END_STATE();
    case 2078:
      if (lookahead == 'f') ADVANCE(1488);
      END_STATE();
    case 2079:
      if (lookahead == 'f') ADVANCE(1488);
      if (lookahead == 'r') ADVANCE(1907);
      END_STATE();
    case 2080:
      if (lookahead == 'f') ADVANCE(2022);
      END_STATE();
    case 2081:
      if (lookahead == 'f') ADVANCE(2902);
      END_STATE();
    case 2082:
      if (lookahead == 'f') ADVANCE(2902);
      if (lookahead == 't') ADVANCE(1628);
      END_STATE();
    case 2083:
      if (lookahead == 'f') ADVANCE(2088);
      END_STATE();
    case 2084:
      if (lookahead == 'f') ADVANCE(2595);
      if (lookahead == 'n') ADVANCE(2632);
      if (lookahead == 's') ADVANCE(2212);
      END_STATE();
    case 2085:
      if (lookahead == 'f') ADVANCE(2191);
      END_STATE();
    case 2086:
      if (lookahead == 'f') ADVANCE(2367);
      END_STATE();
    case 2087:
      if (lookahead == 'f') ADVANCE(2240);
      END_STATE();
    case 2088:
      if (lookahead == 'f') ADVANCE(2021);
      END_STATE();
    case 2089:
      if (lookahead == 'f') ADVANCE(2408);
      END_STATE();
    case 2090:
      if (lookahead == 'g') ADVANCE(3661);
      END_STATE();
    case 2091:
      if (lookahead == 'g') ADVANCE(3690);
      END_STATE();
    case 2092:
      if (lookahead == 'g') ADVANCE(3779);
      END_STATE();
    case 2093:
      if (lookahead == 'g') ADVANCE(3561);
      END_STATE();
    case 2094:
      if (lookahead == 'g') ADVANCE(3612);
      END_STATE();
    case 2095:
      if (lookahead == 'g') ADVANCE(3691);
      END_STATE();
    case 2096:
      if (lookahead == 'g') ADVANCE(3716);
      END_STATE();
    case 2097:
      if (lookahead == 'g') ADVANCE(3193);
      END_STATE();
    case 2098:
      if (lookahead == 'g') ADVANCE(3531);
      END_STATE();
    case 2099:
      if (lookahead == 'g') ADVANCE(3480);
      END_STATE();
    case 2100:
      if (lookahead == 'g') ADVANCE(3519);
      END_STATE();
    case 2101:
      if (lookahead == 'g') ADVANCE(3522);
      END_STATE();
    case 2102:
      if (lookahead == 'g') ADVANCE(56);
      END_STATE();
    case 2103:
      if (lookahead == 'g') ADVANCE(3006);
      END_STATE();
    case 2104:
      if (lookahead == 'g') ADVANCE(2520);
      END_STATE();
    case 2105:
      if (lookahead == 'g') ADVANCE(2520);
      if (lookahead == 't') ADVANCE(2621);
      END_STATE();
    case 2106:
      if (lookahead == 'g') ADVANCE(2479);
      END_STATE();
    case 2107:
      if (lookahead == 'g') ADVANCE(2669);
      END_STATE();
    case 2108:
      if (lookahead == 'g') ADVANCE(2684);
      END_STATE();
    case 2109:
      if (lookahead == 'g') ADVANCE(2005);
      END_STATE();
    case 2110:
      if (lookahead == 'g') ADVANCE(1958);
      END_STATE();
    case 2111:
      if (lookahead == 'g') ADVANCE(2495);
      END_STATE();
    case 2112:
      if (lookahead == 'g') ADVANCE(1839);
      END_STATE();
    case 2113:
      if (lookahead == 'g') ADVANCE(1841);
      END_STATE();
    case 2114:
      if (lookahead == 'g') ADVANCE(1869);
      END_STATE();
    case 2115:
      if (lookahead == 'g') ADVANCE(1875);
      END_STATE();
    case 2116:
      if (lookahead == 'g') ADVANCE(2996);
      END_STATE();
    case 2117:
      if (lookahead == 'g') ADVANCE(1653);
      END_STATE();
    case 2118:
      if (lookahead == 'g') ADVANCE(2016);
      END_STATE();
    case 2119:
      if (lookahead == 'g') ADVANCE(2453);
      END_STATE();
    case 2120:
      if (lookahead == 'g') ADVANCE(2455);
      END_STATE();
    case 2121:
      if (lookahead == 'g') ADVANCE(2771);
      END_STATE();
    case 2122:
      if (lookahead == 'g') ADVANCE(2466);
      END_STATE();
    case 2123:
      if (lookahead == 'g') ADVANCE(2466);
      if (lookahead == 'm') ADVANCE(1308);
      END_STATE();
    case 2124:
      if (lookahead == 'h') ADVANCE(1682);
      END_STATE();
    case 2125:
      if (lookahead == 'h') ADVANCE(106);
      END_STATE();
    case 2126:
      if (lookahead == 'h') ADVANCE(3752);
      END_STATE();
    case 2127:
      if (lookahead == 'h') ADVANCE(3667);
      END_STATE();
    case 2128:
      if (lookahead == 'h') ADVANCE(3678);
      END_STATE();
    case 2129:
      if (lookahead == 'h') ADVANCE(3750);
      END_STATE();
    case 2130:
      if (lookahead == 'h') ADVANCE(2682);
      END_STATE();
    case 2131:
      if (lookahead == 'h') ADVANCE(3902);
      END_STATE();
    case 2132:
      if (lookahead == 'h') ADVANCE(2706);
      END_STATE();
    case 2133:
      if (lookahead == 'h') ADVANCE(2706);
      if (lookahead == 'm') ADVANCE(3887);
      END_STATE();
    case 2134:
      if (lookahead == 'h') ADVANCE(2706);
      if (lookahead == 'm') ADVANCE(3887);
      if (lookahead == 'y') ADVANCE(2504);
      END_STATE();
    case 2135:
      if (lookahead == 'h') ADVANCE(2706);
      if (lookahead == 'y') ADVANCE(2504);
      END_STATE();
    case 2136:
      if (lookahead == 'h') ADVANCE(2092);
      END_STATE();
    case 2137:
      if (lookahead == 'h') ADVANCE(2707);
      END_STATE();
    case 2138:
      if (lookahead == 'h') ADVANCE(2096);
      END_STATE();
    case 2139:
      if (lookahead == 'h') ADVANCE(1975);
      END_STATE();
    case 2140:
      if (lookahead == 'h') ADVANCE(1981);
      END_STATE();
    case 2141:
      if (lookahead == 'h') ADVANCE(2181);
      END_STATE();
    case 2142:
      if (lookahead == 'h') ADVANCE(1486);
      END_STATE();
    case 2143:
      if (lookahead == 'h') ADVANCE(2232);
      END_STATE();
    case 2144:
      if (lookahead == 'h') ADVANCE(2786);
      END_STATE();
    case 2145:
      if (lookahead == 'h') ADVANCE(1545);
      END_STATE();
    case 2146:
      if (lookahead == 'i') ADVANCE(2905);
      if (lookahead == 'l') ADVANCE(2585);
      END_STATE();
    case 2147:
      if (lookahead == 'i') ADVANCE(1409);
      if (lookahead == 'l') ADVANCE(2590);
      if (lookahead == 'w') ADVANCE(1366);
      END_STATE();
    case 2148:
      if (lookahead == 'i') ADVANCE(1409);
      if (lookahead == 'l') ADVANCE(2612);
      if (lookahead == 'w') ADVANCE(1366);
      END_STATE();
    case 2149:
      if (lookahead == 'i') ADVANCE(3693);
      END_STATE();
    case 2150:
      if (lookahead == 'i') ADVANCE(2070);
      END_STATE();
    case 2151:
      if (lookahead == 'i') ADVANCE(3852);
      END_STATE();
    case 2152:
      if (lookahead == 'i') ADVANCE(3850);
      END_STATE();
    case 2153:
      if (lookahead == 'i') ADVANCE(3169);
      END_STATE();
    case 2154:
      if (lookahead == 'i') ADVANCE(3020);
      END_STATE();
    case 2155:
      if (lookahead == 'i') ADVANCE(1752);
      END_STATE();
    case 2156:
      if (lookahead == 'i') ADVANCE(2474);
      if (lookahead == 's') ADVANCE(2137);
      END_STATE();
    case 2157:
      if (lookahead == 'i') ADVANCE(3024);
      if (lookahead == 'o') ADVANCE(2925);
      END_STATE();
    case 2158:
      if (lookahead == 'i') ADVANCE(3021);
      END_STATE();
    case 2159:
      if (lookahead == 'i') ADVANCE(2496);
      if (lookahead == 'n') ADVANCE(1410);
      if (lookahead == 's') ADVANCE(3032);
      if (lookahead == 'u') ADVANCE(2365);
      END_STATE();
    case 2160:
      if (lookahead == 'i') ADVANCE(3022);
      END_STATE();
    case 2161:
      if (lookahead == 'i') ADVANCE(1564);
      END_STATE();
    case 2162:
      if (lookahead == 'i') ADVANCE(3029);
      END_STATE();
    case 2163:
      if (lookahead == 'i') ADVANCE(3042);
      END_STATE();
    case 2164:
      if (lookahead == 'i') ADVANCE(2683);
      if (lookahead == 'u') ADVANCE(1821);
      END_STATE();
    case 2165:
      if (lookahead == 'i') ADVANCE(2287);
      if (lookahead == 'r') ADVANCE(2110);
      END_STATE();
    case 2166:
      if (lookahead == 'i') ADVANCE(2843);
      END_STATE();
    case 2167:
      if (lookahead == 'i') ADVANCE(1725);
      END_STATE();
    case 2168:
      if (lookahead == 'i') ADVANCE(1725);
      if (lookahead == 'l') ADVANCE(1442);
      END_STATE();
    case 2169:
      if (lookahead == 'i') ADVANCE(2417);
      END_STATE();
    case 2170:
      if (lookahead == 'i') ADVANCE(2069);
      END_STATE();
    case 2171:
      if (lookahead == 'i') ADVANCE(2507);
      END_STATE();
    case 2172:
      if (lookahead == 'i') ADVANCE(1430);
      END_STATE();
    case 2173:
      if (lookahead == 'i') ADVANCE(1598);
      END_STATE();
    case 2174:
      if (lookahead == 'i') ADVANCE(2106);
      if (lookahead == 'l') ADVANCE(2590);
      if (lookahead == 'w') ADVANCE(1366);
      END_STATE();
    case 2175:
      if (lookahead == 'i') ADVANCE(2106);
      if (lookahead == 'l') ADVANCE(2612);
      if (lookahead == 'w') ADVANCE(1366);
      END_STATE();
    case 2176:
      if (lookahead == 'i') ADVANCE(2111);
      END_STATE();
    case 2177:
      if (lookahead == 'i') ADVANCE(2822);
      END_STATE();
    case 2178:
      if (lookahead == 'i') ADVANCE(2546);
      END_STATE();
    case 2179:
      if (lookahead == 'i') ADVANCE(2293);
      END_STATE();
    case 2180:
      if (lookahead == 'i') ADVANCE(2910);
      END_STATE();
    case 2181:
      if (lookahead == 'i') ADVANCE(2486);
      END_STATE();
    case 2182:
      if (lookahead == 'i') ADVANCE(2487);
      END_STATE();
    case 2183:
      if (lookahead == 'i') ADVANCE(1687);
      END_STATE();
    case 2184:
      if (lookahead == 'i') ADVANCE(2512);
      END_STATE();
    case 2185:
      if (lookahead == 'i') ADVANCE(2298);
      END_STATE();
    case 2186:
      if (lookahead == 'i') ADVANCE(1737);
      END_STATE();
    case 2187:
      if (lookahead == 'i') ADVANCE(2566);
      END_STATE();
    case 2188:
      if (lookahead == 'i') ADVANCE(2812);
      if (lookahead == 'o') ADVANCE(2982);
      END_STATE();
    case 2189:
      if (lookahead == 'i') ADVANCE(1606);
      END_STATE();
    case 2190:
      if (lookahead == 'i') ADVANCE(2503);
      END_STATE();
    case 2191:
      if (lookahead == 'i') ADVANCE(2398);
      END_STATE();
    case 2192:
      if (lookahead == 'i') ADVANCE(2490);
      END_STATE();
    case 2193:
      if (lookahead == 'i') ADVANCE(1608);
      END_STATE();
    case 2194:
      if (lookahead == 'i') ADVANCE(2559);
      END_STATE();
    case 2195:
      if (lookahead == 'i') ADVANCE(2516);
      END_STATE();
    case 2196:
      if (lookahead == 'i') ADVANCE(2506);
      END_STATE();
    case 2197:
      if (lookahead == 'i') ADVANCE(2552);
      END_STATE();
    case 2198:
      if (lookahead == 'i') ADVANCE(2510);
      END_STATE();
    case 2199:
      if (lookahead == 'i') ADVANCE(2327);
      if (lookahead == 'r') ADVANCE(2241);
      END_STATE();
    case 2200:
      if (lookahead == 'i') ADVANCE(1663);
      END_STATE();
    case 2201:
      if (lookahead == 'i') ADVANCE(1615);
      END_STATE();
    case 2202:
      if (lookahead == 'i') ADVANCE(2916);
      END_STATE();
    case 2203:
      if (lookahead == 'i') ADVANCE(2914);
      END_STATE();
    case 2204:
      if (lookahead == 'i') ADVANCE(2960);
      END_STATE();
    case 2205:
      if (lookahead == 'i') ADVANCE(2082);
      END_STATE();
    case 2206:
      if (lookahead == 'i') ADVANCE(3077);
      END_STATE();
    case 2207:
      if (lookahead == 'i') ADVANCE(1580);
      END_STATE();
    case 2208:
      if (lookahead == 'i') ADVANCE(2393);
      END_STATE();
    case 2209:
      if (lookahead == 'i') ADVANCE(2523);
      END_STATE();
    case 2210:
      if (lookahead == 'i') ADVANCE(2547);
      END_STATE();
    case 2211:
      if (lookahead == 'i') ADVANCE(2081);
      END_STATE();
    case 2212:
      if (lookahead == 'i') ADVANCE(3078);
      END_STATE();
    case 2213:
      if (lookahead == 'i') ADVANCE(2927);
      END_STATE();
    case 2214:
      if (lookahead == 'i') ADVANCE(1701);
      END_STATE();
    case 2215:
      if (lookahead == 'i') ADVANCE(1650);
      END_STATE();
    case 2216:
      if (lookahead == 'i') ADVANCE(2528);
      END_STATE();
    case 2217:
      if (lookahead == 'i') ADVANCE(2525);
      END_STATE();
    case 2218:
      if (lookahead == 'i') ADVANCE(3079);
      END_STATE();
    case 2219:
      if (lookahead == 'i') ADVANCE(2793);
      END_STATE();
    case 2220:
      if (lookahead == 'i') ADVANCE(2527);
      END_STATE();
    case 2221:
      if (lookahead == 'i') ADVANCE(3080);
      END_STATE();
    case 2222:
      if (lookahead == 'i') ADVANCE(2972);
      END_STATE();
    case 2223:
      if (lookahead == 'i') ADVANCE(2541);
      END_STATE();
    case 2224:
      if (lookahead == 'i') ADVANCE(2602);
      END_STATE();
    case 2225:
      if (lookahead == 'i') ADVANCE(3081);
      END_STATE();
    case 2226:
      if (lookahead == 'i') ADVANCE(2556);
      END_STATE();
    case 2227:
      if (lookahead == 'i') ADVANCE(2759);
      END_STATE();
    case 2228:
      if (lookahead == 'i') ADVANCE(1671);
      END_STATE();
    case 2229:
      if (lookahead == 'i') ADVANCE(3082);
      END_STATE();
    case 2230:
      if (lookahead == 'i') ADVANCE(2934);
      END_STATE();
    case 2231:
      if (lookahead == 'i') ADVANCE(2611);
      END_STATE();
    case 2232:
      if (lookahead == 'i') ADVANCE(2535);
      END_STATE();
    case 2233:
      if (lookahead == 'i') ADVANCE(3083);
      END_STATE();
    case 2234:
      if (lookahead == 'i') ADVANCE(2544);
      END_STATE();
    case 2235:
      if (lookahead == 'i') ADVANCE(3084);
      END_STATE();
    case 2236:
      if (lookahead == 'i') ADVANCE(2614);
      END_STATE();
    case 2237:
      if (lookahead == 'i') ADVANCE(2370);
      END_STATE();
    case 2238:
      if (lookahead == 'i') ADVANCE(3085);
      END_STATE();
    case 2239:
      if (lookahead == 'i') ADVANCE(1511);
      END_STATE();
    case 2240:
      if (lookahead == 'i') ADVANCE(2373);
      END_STATE();
    case 2241:
      if (lookahead == 'i') ADVANCE(2940);
      END_STATE();
    case 2242:
      if (lookahead == 'i') ADVANCE(2941);
      END_STATE();
    case 2243:
      if (lookahead == 'i') ADVANCE(2845);
      END_STATE();
    case 2244:
      if (lookahead == 'i') ADVANCE(2399);
      END_STATE();
    case 2245:
      if (lookahead == 'i') ADVANCE(2399);
      if (lookahead == 'r') ADVANCE(2110);
      END_STATE();
    case 2246:
      if (lookahead == 'i') ADVANCE(2969);
      END_STATE();
    case 2247:
      if (lookahead == 'i') ADVANCE(1518);
      END_STATE();
    case 2248:
      if (lookahead == 'i') ADVANCE(1523);
      END_STATE();
    case 2249:
      if (lookahead == 'i') ADVANCE(2968);
      END_STATE();
    case 2250:
      if (lookahead == 'i') ADVANCE(1581);
      END_STATE();
    case 2251:
      if (lookahead == 'i') ADVANCE(2407);
      END_STATE();
    case 2252:
      if (lookahead == 'i') ADVANCE(2798);
      END_STATE();
    case 2253:
      if (lookahead == 'i') ADVANCE(2973);
      END_STATE();
    case 2254:
      if (lookahead == 'i') ADVANCE(1550);
      END_STATE();
    case 2255:
      if (lookahead == 'i') ADVANCE(2977);
      END_STATE();
    case 2256:
      if (lookahead == 'i') ADVANCE(1582);
      END_STATE();
    case 2257:
      if (lookahead == 'i') ADVANCE(1704);
      END_STATE();
    case 2258:
      if (lookahead == 'i') ADVANCE(2974);
      END_STATE();
    case 2259:
      if (lookahead == 'i') ADVANCE(2569);
      END_STATE();
    case 2260:
      if (lookahead == 'j') ADVANCE(3252);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3253);
      END_STATE();
    case 2261:
      if (lookahead == 'j') ADVANCE(2633);
      if (lookahead == 't') ADVANCE(2226);
      END_STATE();
    case 2262:
      if (lookahead == 'j') ADVANCE(3011);
      END_STATE();
    case 2263:
      if (lookahead == 'k') ADVANCE(3180);
      END_STATE();
    case 2264:
      if (lookahead == 'k') ADVANCE(3504);
      END_STATE();
    case 2265:
      if (lookahead == 'k') ADVANCE(3380);
      END_STATE();
    case 2266:
      if (lookahead == 'k') ADVANCE(3471);
      END_STATE();
    case 2267:
      if (lookahead == 'k') ADVANCE(3540);
      END_STATE();
    case 2268:
      if (lookahead == 'k') ADVANCE(3199);
      END_STATE();
    case 2269:
      if (lookahead == 'k') ADVANCE(3543);
      END_STATE();
    case 2270:
      if (lookahead == 'k') ADVANCE(3177);
      END_STATE();
    case 2271:
      if (lookahead == 'k') ADVANCE(2642);
      END_STATE();
    case 2272:
      if (lookahead == 'k') ADVANCE(1928);
      END_STATE();
    case 2273:
      if (lookahead == 'k') ADVANCE(1928);
      if (lookahead == 'n') ADVANCE(1723);
      END_STATE();
    case 2274:
      if (lookahead == 'k') ADVANCE(1482);
      END_STATE();
    case 2275:
      if (lookahead == 'k') ADVANCE(2180);
      END_STATE();
    case 2276:
      if (lookahead == 'k') ADVANCE(1830);
      END_STATE();
    case 2277:
      if (lookahead == 'k') ADVANCE(1937);
      END_STATE();
    case 2278:
      if (lookahead == 'k') ADVANCE(1660);
      END_STATE();
    case 2279:
      if (lookahead == 'l') ADVANCE(2058);
      END_STATE();
    case 2280:
      if (lookahead == 'l') ADVANCE(3757);
      END_STATE();
    case 2281:
      if (lookahead == 'l') ADVANCE(3757);
      if (lookahead == 's') ADVANCE(2862);
      END_STATE();
    case 2282:
      if (lookahead == 'l') ADVANCE(3757);
      if (lookahead == 's') ADVANCE(2923);
      END_STATE();
    case 2283:
      if (lookahead == 'l') ADVANCE(3763);
      if (lookahead == 'u') ADVANCE(2066);
      END_STATE();
    case 2284:
      if (lookahead == 'l') ADVANCE(3706);
      END_STATE();
    case 2285:
      if (lookahead == 'l') ADVANCE(3773);
      END_STATE();
    case 2286:
      if (lookahead == 'l') ADVANCE(3739);
      END_STATE();
    case 2287:
      if (lookahead == 'l') ADVANCE(3698);
      END_STATE();
    case 2288:
      if (lookahead == 'l') ADVANCE(3564);
      END_STATE();
    case 2289:
      if (lookahead == 'l') ADVANCE(1316);
      if (lookahead == 'r') ADVANCE(2553);
      END_STATE();
    case 2290:
      if (lookahead == 'l') ADVANCE(3314);
      END_STATE();
    case 2291:
      if (lookahead == 'l') ADVANCE(1333);
      END_STATE();
    case 2292:
      if (lookahead == 'l') ADVANCE(3892);
      END_STATE();
    case 2293:
      if (lookahead == 'l') ADVANCE(3702);
      END_STATE();
    case 2294:
      if (lookahead == 'l') ADVANCE(3866);
      END_STATE();
    case 2295:
      if (lookahead == 'l') ADVANCE(3591);
      END_STATE();
    case 2296:
      if (lookahead == 'l') ADVANCE(3204);
      END_STATE();
    case 2297:
      if (lookahead == 'l') ADVANCE(3174);
      END_STATE();
    case 2298:
      if (lookahead == 'l') ADVANCE(3700);
      END_STATE();
    case 2299:
      if (lookahead == 'l') ADVANCE(3207);
      END_STATE();
    case 2300:
      if (lookahead == 'l') ADVANCE(3896);
      END_STATE();
    case 2301:
      if (lookahead == 'l') ADVANCE(3597);
      END_STATE();
    case 2302:
      if (lookahead == 'l') ADVANCE(3704);
      END_STATE();
    case 2303:
      if (lookahead == 'l') ADVANCE(3202);
      END_STATE();
    case 2304:
      if (lookahead == 'l') ADVANCE(3736);
      END_STATE();
    case 2305:
      if (lookahead == 'l') ADVANCE(2828);
      if (lookahead == 's') ADVANCE(2901);
      END_STATE();
    case 2306:
      if (lookahead == 'l') ADVANCE(1909);
      END_STATE();
    case 2307:
      if (lookahead == 'l') ADVANCE(2583);
      if (lookahead == 'p') ADVANCE(94);
      END_STATE();
    case 2308:
      if (lookahead == 'l') ADVANCE(1993);
      END_STATE();
    case 2309:
      if (lookahead == 'l') ADVANCE(1993);
      if (lookahead == 'q') ADVANCE(3810);
      if (lookahead == 'x') ADVANCE(1414);
      END_STATE();
    case 2310:
      if (lookahead == 'l') ADVANCE(1993);
      if (lookahead == 'x') ADVANCE(1416);
      END_STATE();
    case 2311:
      if (lookahead == 'l') ADVANCE(1993);
      if (lookahead == 'x') ADVANCE(2975);
      END_STATE();
    case 2312:
      if (lookahead == 'l') ADVANCE(1993);
      if (lookahead == 'x') ADVANCE(2949);
      END_STATE();
    case 2313:
      if (lookahead == 'l') ADVANCE(1993);
      if (lookahead == 'x') ADVANCE(1522);
      END_STATE();
    case 2314:
      if (lookahead == 'l') ADVANCE(1993);
      if (lookahead == 'x') ADVANCE(1415);
      END_STATE();
    case 2315:
      if (lookahead == 'l') ADVANCE(1720);
      if (lookahead == 'm') ADVANCE(1781);
      if (lookahead == 'n') ADVANCE(2842);
      END_STATE();
    case 2316:
      if (lookahead == 'l') ADVANCE(1720);
      if (lookahead == 'm') ADVANCE(2442);
      if (lookahead == 'n') ADVANCE(2913);
      END_STATE();
    case 2317:
      if (lookahead == 'l') ADVANCE(1720);
      if (lookahead == 'm') ADVANCE(2442);
      if (lookahead == 'n') ADVANCE(3031);
      END_STATE();
    case 2318:
      if (lookahead == 'l') ADVANCE(2284);
      if (lookahead == 't') ADVANCE(1623);
      END_STATE();
    case 2319:
      if (lookahead == 'l') ADVANCE(2284);
      if (lookahead == 't') ADVANCE(1642);
      END_STATE();
    case 2320:
      if (lookahead == 'l') ADVANCE(1568);
      END_STATE();
    case 2321:
      if (lookahead == 'l') ADVANCE(3057);
      END_STATE();
    case 2322:
      if (lookahead == 'l') ADVANCE(3058);
      END_STATE();
    case 2323:
      if (lookahead == 'l') ADVANCE(2286);
      END_STATE();
    case 2324:
      if (lookahead == 'l') ADVANCE(2286);
      if (lookahead == 'w') ADVANCE(3664);
      END_STATE();
    case 2325:
      if (lookahead == 'l') ADVANCE(3059);
      END_STATE();
    case 2326:
      if (lookahead == 'l') ADVANCE(3066);
      END_STATE();
    case 2327:
      if (lookahead == 'l') ADVANCE(2396);
      END_STATE();
    case 2328:
      if (lookahead == 'l') ADVANCE(2396);
      if (lookahead == 'n') ADVANCE(3096);
      END_STATE();
    case 2329:
      if (lookahead == 'l') ADVANCE(2396);
      if (lookahead == 'n') ADVANCE(3096);
      if (lookahead == 't') ADVANCE(2141);
      END_STATE();
    case 2330:
      if (lookahead == 'l') ADVANCE(1399);
      if (lookahead == 'n') ADVANCE(2990);
      END_STATE();
    case 2331:
      if (lookahead == 'l') ADVANCE(3062);
      END_STATE();
    case 2332:
      if (lookahead == 'l') ADVANCE(3063);
      END_STATE();
    case 2333:
      if (lookahead == 'l') ADVANCE(3064);
      END_STATE();
    case 2334:
      if (lookahead == 'l') ADVANCE(2064);
      END_STATE();
    case 2335:
      if (lookahead == 'l') ADVANCE(2615);
      END_STATE();
    case 2336:
      if (lookahead == 'l') ADVANCE(2615);
      if (lookahead == 't') ADVANCE(1956);
      END_STATE();
    case 2337:
      if (lookahead == 'l') ADVANCE(2172);
      END_STATE();
    case 2338:
      if (lookahead == 'l') ADVANCE(2813);
      END_STATE();
    case 2339:
      if (lookahead == 'l') ADVANCE(2001);
      if (lookahead == 'q') ADVANCE(1324);
      if (lookahead == 'x') ADVANCE(2864);
      END_STATE();
    case 2340:
      if (lookahead == 'l') ADVANCE(2001);
      if (lookahead == 'x') ADVANCE(2864);
      END_STATE();
    case 2341:
      if (lookahead == 'l') ADVANCE(2166);
      END_STATE();
    case 2342:
      if (lookahead == 'l') ADVANCE(2320);
      if (lookahead == 'p') ADVANCE(2917);
      END_STATE();
    case 2343:
      if (lookahead == 'l') ADVANCE(1332);
      END_STATE();
    case 2344:
      if (lookahead == 'l') ADVANCE(1323);
      END_STATE();
    case 2345:
      if (lookahead == 'l') ADVANCE(2214);
      END_STATE();
    case 2346:
      if (lookahead == 'l') ADVANCE(2295);
      END_STATE();
    case 2347:
      if (lookahead == 'l') ADVANCE(2877);
      END_STATE();
    case 2348:
      if (lookahead == 'l') ADVANCE(2186);
      END_STATE();
    case 2349:
      if (lookahead == 'l') ADVANCE(2404);
      END_STATE();
    case 2350:
      if (lookahead == 'l') ADVANCE(1741);
      if (lookahead == 'm') ADVANCE(1781);
      if (lookahead == 'n') ADVANCE(2913);
      END_STATE();
    case 2351:
      if (lookahead == 'l') ADVANCE(1741);
      if (lookahead == 'm') ADVANCE(1781);
      if (lookahead == 'n') ADVANCE(3031);
      END_STATE();
    case 2352:
      if (lookahead == 'l') ADVANCE(1741);
      if (lookahead == 'm') ADVANCE(1780);
      if (lookahead == 'n') ADVANCE(2842);
      END_STATE();
    case 2353:
      if (lookahead == 'l') ADVANCE(1741);
      if (lookahead == 'm') ADVANCE(1780);
      if (lookahead == 'n') ADVANCE(2913);
      END_STATE();
    case 2354:
      if (lookahead == 'l') ADVANCE(2391);
      END_STATE();
    case 2355:
      if (lookahead == 'l') ADVANCE(1828);
      END_STATE();
    case 2356:
      if (lookahead == 'l') ADVANCE(2332);
      END_STATE();
    case 2357:
      if (lookahead == 'l') ADVANCE(2301);
      END_STATE();
    case 2358:
      if (lookahead == 'l') ADVANCE(1831);
      END_STATE();
    case 2359:
      if (lookahead == 'l') ADVANCE(2302);
      if (lookahead == 't') ADVANCE(1638);
      END_STATE();
    case 2360:
      if (lookahead == 'l') ADVANCE(1835);
      END_STATE();
    case 2361:
      if (lookahead == 'l') ADVANCE(2344);
      END_STATE();
    case 2362:
      if (lookahead == 'l') ADVANCE(2326);
      END_STATE();
    case 2363:
      if (lookahead == 'l') ADVANCE(1836);
      END_STATE();
    case 2364:
      if (lookahead == 'l') ADVANCE(2304);
      END_STATE();
    case 2365:
      if (lookahead == 'l') ADVANCE(2304);
      if (lookahead == 'w') ADVANCE(3664);
      END_STATE();
    case 2366:
      if (lookahead == 'l') ADVANCE(1920);
      END_STATE();
    case 2367:
      if (lookahead == 'l') ADVANCE(1998);
      END_STATE();
    case 2368:
      if (lookahead == 'l') ADVANCE(1846);
      END_STATE();
    case 2369:
      if (lookahead == 'l') ADVANCE(2004);
      END_STATE();
    case 2370:
      if (lookahead == 'l') ADVANCE(1852);
      END_STATE();
    case 2371:
      if (lookahead == 'l') ADVANCE(1933);
      END_STATE();
    case 2372:
      if (lookahead == 'l') ADVANCE(1855);
      END_STATE();
    case 2373:
      if (lookahead == 'l') ADVANCE(1857);
      END_STATE();
    case 2374:
      if (lookahead == 'l') ADVANCE(1865);
      END_STATE();
    case 2375:
      if (lookahead == 'l') ADVANCE(1868);
      END_STATE();
    case 2376:
      if (lookahead == 'l') ADVANCE(1954);
      END_STATE();
    case 2377:
      if (lookahead == 'l') ADVANCE(1872);
      END_STATE();
    case 2378:
      if (lookahead == 'l') ADVANCE(1873);
      END_STATE();
    case 2379:
      if (lookahead == 'l') ADVANCE(1955);
      END_STATE();
    case 2380:
      if (lookahead == 'l') ADVANCE(1982);
      END_STATE();
    case 2381:
      if (lookahead == 'l') ADVANCE(1883);
      END_STATE();
    case 2382:
      if (lookahead == 'l') ADVANCE(1401);
      END_STATE();
    case 2383:
      if (lookahead == 'l') ADVANCE(1934);
      END_STATE();
    case 2384:
      if (lookahead == 'l') ADVANCE(2924);
      END_STATE();
    case 2385:
      if (lookahead == 'l') ADVANCE(2636);
      END_STATE();
    case 2386:
      if (lookahead == 'l') ADVANCE(2183);
      END_STATE();
    case 2387:
      if (lookahead == 'l') ADVANCE(2643);
      if (lookahead == 'p') ADVANCE(2778);
      END_STATE();
    case 2388:
      if (lookahead == 'l') ADVANCE(2997);
      END_STATE();
    case 2389:
      if (lookahead == 'l') ADVANCE(2203);
      END_STATE();
    case 2390:
      if (lookahead == 'l') ADVANCE(2617);
      END_STATE();
    case 2391:
      if (lookahead == 'l') ADVANCE(1658);
      END_STATE();
    case 2392:
      if (lookahead == 'l') ADVANCE(1510);
      END_STATE();
    case 2393:
      if (lookahead == 'l') ADVANCE(2956);
      END_STATE();
    case 2394:
      if (lookahead == 'l') ADVANCE(2998);
      END_STATE();
    case 2395:
      if (lookahead == 'l') ADVANCE(1472);
      END_STATE();
    case 2396:
      if (lookahead == 'l') ADVANCE(2758);
      END_STATE();
    case 2397:
      if (lookahead == 'l') ADVANCE(2649);
      END_STATE();
    case 2398:
      if (lookahead == 'l') ADVANCE(2039);
      END_STATE();
    case 2399:
      if (lookahead == 'l') ADVANCE(1662);
      END_STATE();
    case 2400:
      if (lookahead == 'l') ADVANCE(1315);
      if (lookahead == 'r') ADVANCE(2553);
      END_STATE();
    case 2401:
      if (lookahead == 'l') ADVANCE(2380);
      END_STATE();
    case 2402:
      if (lookahead == 'l') ADVANCE(2627);
      END_STATE();
    case 2403:
      if (lookahead == 'l') ADVANCE(2013);
      END_STATE();
    case 2404:
      if (lookahead == 'l') ADVANCE(2849);
      END_STATE();
    case 2405:
      if (lookahead == 'l') ADVANCE(2223);
      END_STATE();
    case 2406:
      if (lookahead == 'l') ADVANCE(2397);
      END_STATE();
    case 2407:
      if (lookahead == 'l') ADVANCE(2964);
      END_STATE();
    case 2408:
      if (lookahead == 'l') ADVANCE(2635);
      END_STATE();
    case 2409:
      if (lookahead == 'l') ADVANCE(2020);
      END_STATE();
    case 2410:
      if (lookahead == 'l') ADVANCE(2234);
      END_STATE();
    case 2411:
      if (lookahead == 'l') ADVANCE(2028);
      END_STATE();
    case 2412:
      if (lookahead == 'l') ADVANCE(2025);
      END_STATE();
    case 2413:
      if (lookahead == 'l') ADVANCE(2031);
      END_STATE();
    case 2414:
      if (lookahead == 'l') ADVANCE(2233);
      END_STATE();
    case 2415:
      if (lookahead == 'l') ADVANCE(2238);
      END_STATE();
    case 2416:
      if (lookahead == 'l') ADVANCE(2040);
      END_STATE();
    case 2417:
      if (lookahead == 'l') ADVANCE(1543);
      END_STATE();
    case 2418:
      if (lookahead == 'l') ADVANCE(2647);
      END_STATE();
    case 2419:
      if (lookahead == 'l') ADVANCE(2043);
      END_STATE();
    case 2420:
      if (lookahead == 'l') ADVANCE(2044);
      END_STATE();
    case 2421:
      if (lookahead == 'l') ADVANCE(2257);
      END_STATE();
    case 2422:
      if (lookahead == 'm') ADVANCE(3777);
      END_STATE();
    case 2423:
      if (lookahead == 'm') ADVANCE(3675);
      END_STATE();
    case 2424:
      if (lookahead == 'm') ADVANCE(3761);
      END_STATE();
    case 2425:
      if (lookahead == 'm') ADVANCE(3761);
      if (lookahead == 't') ADVANCE(3573);
      END_STATE();
    case 2426:
      if (lookahead == 'm') ADVANCE(3759);
      END_STATE();
    case 2427:
      if (lookahead == 'm') ADVANCE(3628);
      END_STATE();
    case 2428:
      if (lookahead == 'm') ADVANCE(3630);
      END_STATE();
    case 2429:
      if (lookahead == 'm') ADVANCE(1338);
      END_STATE();
    case 2430:
      if (lookahead == 'm') ADVANCE(3627);
      END_STATE();
    case 2431:
      if (lookahead == 'm') ADVANCE(3629);
      END_STATE();
    case 2432:
      if (lookahead == 'm') ADVANCE(2607);
      END_STATE();
    case 2433:
      if (lookahead == 'm') ADVANCE(2437);
      if (lookahead == 'n') ADVANCE(1559);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3339);
      END_STATE();
    case 2434:
      if (lookahead == 'm') ADVANCE(2437);
      if (lookahead == 'n') ADVANCE(1556);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3339);
      END_STATE();
    case 2435:
      if (lookahead == 'm') ADVANCE(3099);
      END_STATE();
    case 2436:
      if (lookahead == 'm') ADVANCE(3033);
      END_STATE();
    case 2437:
      if (lookahead == 'm') ADVANCE(1431);
      END_STATE();
    case 2438:
      if (lookahead == 'm') ADVANCE(2654);
      END_STATE();
    case 2439:
      if (lookahead == 'm') ADVANCE(2655);
      END_STATE();
    case 2440:
      if (lookahead == 'm') ADVANCE(2591);
      if (lookahead == 't') ADVANCE(1428);
      END_STATE();
    case 2441:
      if (lookahead == 'm') ADVANCE(2692);
      END_STATE();
    case 2442:
      if (lookahead == 'm') ADVANCE(2594);
      END_STATE();
    case 2443:
      if (lookahead == 'm') ADVANCE(3043);
      END_STATE();
    case 2444:
      if (lookahead == 'm') ADVANCE(2173);
      END_STATE();
    case 2445:
      if (lookahead == 'm') ADVANCE(3044);
      END_STATE();
    case 2446:
      if (lookahead == 'm') ADVANCE(2660);
      END_STATE();
    case 2447:
      if (lookahead == 'm') ADVANCE(1914);
      END_STATE();
    case 2448:
      if (lookahead == 'm') ADVANCE(1540);
      END_STATE();
    case 2449:
      if (lookahead == 'm') ADVANCE(1834);
      END_STATE();
    case 2450:
      if (lookahead == 'm') ADVANCE(1949);
      END_STATE();
    case 2451:
      if (lookahead == 'm') ADVANCE(1923);
      END_STATE();
    case 2452:
      if (lookahead == 'm') ADVANCE(1874);
      END_STATE();
    case 2453:
      if (lookahead == 'm') ADVANCE(1926);
      END_STATE();
    case 2454:
      if (lookahead == 'm') ADVANCE(1932);
      END_STATE();
    case 2455:
      if (lookahead == 'm') ADVANCE(1950);
      END_STATE();
    case 2456:
      if (lookahead == 'm') ADVANCE(1952);
      END_STATE();
    case 2457:
      if (lookahead == 'm') ADVANCE(2442);
      END_STATE();
    case 2458:
      if (lookahead == 'm') ADVANCE(1946);
      END_STATE();
    case 2459:
      if (lookahead == 'm') ADVANCE(2193);
      END_STATE();
    case 2460:
      if (lookahead == 'm') ADVANCE(2200);
      END_STATE();
    case 2461:
      if (lookahead == 'm') ADVANCE(2201);
      END_STATE();
    case 2462:
      if (lookahead == 'm') ADVANCE(1985);
      END_STATE();
    case 2463:
      if (lookahead == 'm') ADVANCE(2634);
      END_STATE();
    case 2464:
      if (lookahead == 'm') ADVANCE(2629);
      END_STATE();
    case 2465:
      if (lookahead == 'm') ADVANCE(2686);
      if (lookahead == 'n') ADVANCE(2405);
      END_STATE();
    case 2466:
      if (lookahead == 'm') ADVANCE(2037);
      END_STATE();
    case 2467:
      if (lookahead == 'm') ADVANCE(2017);
      END_STATE();
    case 2468:
      if (lookahead == 'm') ADVANCE(2023);
      END_STATE();
    case 2469:
      if (lookahead == 'm') ADVANCE(2027);
      END_STATE();
    case 2470:
      if (lookahead == 'm') ADVANCE(2689);
      END_STATE();
    case 2471:
      if (lookahead == 'm') ADVANCE(2047);
      END_STATE();
    case 2472:
      if (lookahead == 'm') ADVANCE(2694);
      END_STATE();
    case 2473:
      if (lookahead == 'n') ADVANCE(3877);
      END_STATE();
    case 2474:
      if (lookahead == 'n') ADVANCE(2271);
      END_STATE();
    case 2475:
      if (lookahead == 'n') ADVANCE(3801);
      END_STATE();
    case 2476:
      if (lookahead == 'n') ADVANCE(3872);
      END_STATE();
    case 2477:
      if (lookahead == 'n') ADVANCE(1771);
      END_STATE();
    case 2478:
      if (lookahead == 'n') ADVANCE(3804);
      END_STATE();
    case 2479:
      if (lookahead == 'n') ADVANCE(3365);
      END_STATE();
    case 2480:
      if (lookahead == 'n') ADVANCE(3328);
      END_STATE();
    case 2481:
      if (lookahead == 'n') ADVANCE(3196);
      END_STATE();
    case 2482:
      if (lookahead == 'n') ADVANCE(1310);
      END_STATE();
    case 2483:
      if (lookahead == 'n') ADVANCE(3214);
      END_STATE();
    case 2484:
      if (lookahead == 'n') ADVANCE(3744);
      END_STATE();
    case 2485:
      if (lookahead == 'n') ADVANCE(1957);
      END_STATE();
    case 2486:
      if (lookahead == 'n') ADVANCE(3881);
      END_STATE();
    case 2487:
      if (lookahead == 'n') ADVANCE(3389);
      END_STATE();
    case 2488:
      if (lookahead == 'n') ADVANCE(3366);
      END_STATE();
    case 2489:
      if (lookahead == 'n') ADVANCE(3456);
      END_STATE();
    case 2490:
      if (lookahead == 'n') ADVANCE(3426);
      END_STATE();
    case 2491:
      if (lookahead == 'n') ADVANCE(3368);
      END_STATE();
    case 2492:
      if (lookahead == 'n') ADVANCE(3462);
      END_STATE();
    case 2493:
      if (lookahead == 'n') ADVANCE(3399);
      END_STATE();
    case 2494:
      if (lookahead == 'n') ADVANCE(3798);
      END_STATE();
    case 2495:
      if (lookahead == 'n') ADVANCE(3362);
      END_STATE();
    case 2496:
      if (lookahead == 'n') ADVANCE(2059);
      END_STATE();
    case 2497:
      if (lookahead == 'n') ADVANCE(2616);
      END_STATE();
    case 2498:
      if (lookahead == 'n') ADVANCE(1652);
      END_STATE();
    case 2499:
      if (lookahead == 'n') ADVANCE(1496);
      if (lookahead == 'o') ADVANCE(2767);
      if (lookahead == 'w') ADVANCE(2171);
      END_STATE();
    case 2500:
      if (lookahead == 'n') ADVANCE(1723);
      END_STATE();
    case 2501:
      if (lookahead == 'n') ADVANCE(2987);
      END_STATE();
    case 2502:
      if (lookahead == 'n') ADVANCE(1592);
      END_STATE();
    case 2503:
      if (lookahead == 'n') ADVANCE(2097);
      END_STATE();
    case 2504:
      if (lookahead == 'n') ADVANCE(1594);
      END_STATE();
    case 2505:
      if (lookahead == 'n') ADVANCE(2098);
      END_STATE();
    case 2506:
      if (lookahead == 'n') ADVANCE(2099);
      END_STATE();
    case 2507:
      if (lookahead == 'n') ADVANCE(1727);
      END_STATE();
    case 2508:
      if (lookahead == 'n') ADVANCE(1596);
      END_STATE();
    case 2509:
      if (lookahead == 'n') ADVANCE(1754);
      END_STATE();
    case 2510:
      if (lookahead == 'n') ADVANCE(2101);
      END_STATE();
    case 2511:
      if (lookahead == 'n') ADVANCE(1601);
      END_STATE();
    case 2512:
      if (lookahead == 'n') ADVANCE(1729);
      END_STATE();
    case 2513:
      if (lookahead == 'n') ADVANCE(1529);
      END_STATE();
    case 2514:
      if (lookahead == 'n') ADVANCE(1602);
      END_STATE();
    case 2515:
      if (lookahead == 'n') ADVANCE(2321);
      END_STATE();
    case 2516:
      if (lookahead == 'n') ADVANCE(1734);
      END_STATE();
    case 2517:
      if (lookahead == 'n') ADVANCE(2929);
      END_STATE();
    case 2518:
      if (lookahead == 'n') ADVANCE(2322);
      END_STATE();
    case 2519:
      if (lookahead == 'n') ADVANCE(2325);
      END_STATE();
    case 2520:
      if (lookahead == 'n') ADVANCE(1996);
      END_STATE();
    case 2521:
      if (lookahead == 'n') ADVANCE(1696);
      END_STATE();
    case 2522:
      if (lookahead == 'n') ADVANCE(2883);
      END_STATE();
    case 2523:
      if (lookahead == 'n') ADVANCE(1827);
      END_STATE();
    case 2524:
      if (lookahead == 'n') ADVANCE(2571);
      END_STATE();
    case 2525:
      if (lookahead == 'n') ADVANCE(2885);
      END_STATE();
    case 2526:
      if (lookahead == 'n') ADVANCE(2331);
      END_STATE();
    case 2527:
      if (lookahead == 'n') ADVANCE(2888);
      END_STATE();
    case 2528:
      if (lookahead == 'n') ADVANCE(2032);
      END_STATE();
    case 2529:
      if (lookahead == 'n') ADVANCE(2333);
      END_STATE();
    case 2530:
      if (lookahead == 'n') ADVANCE(1654);
      END_STATE();
    case 2531:
      if (lookahead == 'n') ADVANCE(2891);
      END_STATE();
    case 2532:
      if (lookahead == 'n') ADVANCE(1613);
      END_STATE();
    case 2533:
      if (lookahead == 'n') ADVANCE(2947);
      END_STATE();
    case 2534:
      if (lookahead == 'n') ADVANCE(1614);
      END_STATE();
    case 2535:
      if (lookahead == 'n') ADVANCE(2893);
      END_STATE();
    case 2536:
      if (lookahead == 'n') ADVANCE(2897);
      END_STATE();
    case 2537:
      if (lookahead == 'n') ADVANCE(2898);
      END_STATE();
    case 2538:
      if (lookahead == 'n') ADVANCE(2900);
      END_STATE();
    case 2539:
      if (lookahead == 'n') ADVANCE(1842);
      END_STATE();
    case 2540:
      if (lookahead == 'n') ADVANCE(2912);
      END_STATE();
    case 2541:
      if (lookahead == 'n') ADVANCE(1848);
      END_STATE();
    case 2542:
      if (lookahead == 'n') ADVANCE(1850);
      END_STATE();
    case 2543:
      if (lookahead == 'n') ADVANCE(1859);
      END_STATE();
    case 2544:
      if (lookahead == 'n') ADVANCE(1866);
      END_STATE();
    case 2545:
      if (lookahead == 'n') ADVANCE(1311);
      END_STATE();
    case 2546:
      if (lookahead == 'n') ADVANCE(2108);
      END_STATE();
    case 2547:
      if (lookahead == 'n') ADVANCE(2249);
      END_STATE();
    case 2548:
      if (lookahead == 'n') ADVANCE(2112);
      END_STATE();
    case 2549:
      if (lookahead == 'n') ADVANCE(2992);
      END_STATE();
    case 2550:
      if (lookahead == 'n') ADVANCE(2189);
      END_STATE();
    case 2551:
      if (lookahead == 'n') ADVANCE(1669);
      END_STATE();
    case 2552:
      if (lookahead == 'n') ADVANCE(2834);
      END_STATE();
    case 2553:
      if (lookahead == 'n') ADVANCE(1453);
      END_STATE();
    case 2554:
      if (lookahead == 'n') ADVANCE(3013);
      END_STATE();
    case 2555:
      if (lookahead == 'n') ADVANCE(2114);
      END_STATE();
    case 2556:
      if (lookahead == 'n') ADVANCE(1656);
      END_STATE();
    case 2557:
      if (lookahead == 'n') ADVANCE(1507);
      END_STATE();
    case 2558:
      if (lookahead == 'n') ADVANCE(2961);
      END_STATE();
    case 2559:
      if (lookahead == 'n') ADVANCE(2936);
      END_STATE();
    case 2560:
      if (lookahead == 'n') ADVANCE(1500);
      END_STATE();
    case 2561:
      if (lookahead == 'n') ADVANCE(1514);
      END_STATE();
    case 2562:
      if (lookahead == 'n') ADVANCE(2198);
      END_STATE();
    case 2563:
      if (lookahead == 'n') ADVANCE(1785);
      END_STATE();
    case 2564:
      if (lookahead == 'n') ADVANCE(1506);
      END_STATE();
    case 2565:
      if (lookahead == 'n') ADVANCE(2637);
      if (lookahead == 'o') ADVANCE(2515);
      END_STATE();
    case 2566:
      if (lookahead == 'n') ADVANCE(2410);
      END_STATE();
    case 2567:
      if (lookahead == 'n') ADVANCE(2819);
      END_STATE();
    case 2568:
      if (lookahead == 'n') ADVANCE(2253);
      END_STATE();
    case 2569:
      if (lookahead == 'n') ADVANCE(2255);
      END_STATE();
    case 2570:
      if (lookahead == 'n') ADVANCE(2258);
      END_STATE();
    case 2571:
      if (lookahead == 'n') ADVANCE(1551);
      END_STATE();
    case 2572:
      if (lookahead == 'o') ADVANCE(2168);
      if (lookahead == 's') ADVANCE(1705);
      END_STATE();
    case 2573:
      if (lookahead == 'o') ADVANCE(2824);
      if (lookahead == 'r') ADVANCE(3015);
      END_STATE();
    case 2574:
      if (lookahead == 'o') ADVANCE(3037);
      END_STATE();
    case 2575:
      if (lookahead == 'o') ADVANCE(2982);
      END_STATE();
    case 2576:
      if (lookahead == 'o') ADVANCE(2009);
      END_STATE();
    case 2577:
      if (lookahead == 'o') ADVANCE(2243);
      if (lookahead == 'p') ADVANCE(1624);
      if (lookahead == 'r') ADVANCE(2157);
      if (lookahead == 't') ADVANCE(2704);
      END_STATE();
    case 2578:
      if (lookahead == 'o') ADVANCE(2243);
      if (lookahead == 'p') ADVANCE(1624);
      if (lookahead == 'r') ADVANCE(1895);
      if (lookahead == 't') ADVANCE(2705);
      END_STATE();
    case 2579:
      if (lookahead == 'o') ADVANCE(2243);
      if (lookahead == 'r') ADVANCE(2157);
      if (lookahead == 't') ADVANCE(2782);
      END_STATE();
    case 2580:
      if (lookahead == 'o') ADVANCE(2444);
      if (lookahead == 't') ADVANCE(2737);
      END_STATE();
    case 2581:
      if (lookahead == 'o') ADVANCE(1569);
      END_STATE();
    case 2582:
      if (lookahead == 'o') ADVANCE(1302);
      END_STATE();
    case 2583:
      if (lookahead == 'o') ADVANCE(1434);
      END_STATE();
    case 2584:
      if (lookahead == 'o') ADVANCE(2276);
      END_STATE();
    case 2585:
      if (lookahead == 'o') ADVANCE(1618);
      END_STATE();
    case 2586:
      if (lookahead == 'o') ADVANCE(2353);
      END_STATE();
    case 2587:
      if (lookahead == 'o') ADVANCE(2988);
      END_STATE();
    case 2588:
      if (lookahead == 'o') ADVANCE(2087);
      END_STATE();
    case 2589:
      if (lookahead == 'o') ADVANCE(2121);
      END_STATE();
    case 2590:
      if (lookahead == 'o') ADVANCE(1593);
      END_STATE();
    case 2591:
      if (lookahead == 'o') ADVANCE(2725);
      END_STATE();
    case 2592:
      if (lookahead == 'o') ADVANCE(2674);
      END_STATE();
    case 2593:
      if (lookahead == 'o') ADVANCE(2995);
      END_STATE();
    case 2594:
      if (lookahead == 'o') ADVANCE(2481);
      END_STATE();
    case 2595:
      if (lookahead == 'o') ADVANCE(2735);
      END_STATE();
    case 2596:
      if (lookahead == 'o') ADVANCE(1766);
      END_STATE();
    case 2597:
      if (lookahead == 'o') ADVANCE(2841);
      END_STATE();
    case 2598:
      if (lookahead == 'o') ADVANCE(2484);
      END_STATE();
    case 2599:
      if (lookahead == 'o') ADVANCE(2775);
      END_STATE();
    case 2600:
      if (lookahead == 'o') ADVANCE(1603);
      END_STATE();
    case 2601:
      if (lookahead == 'o') ADVANCE(2550);
      END_STATE();
    case 2602:
      if (lookahead == 'o') ADVANCE(2488);
      END_STATE();
    case 2603:
      if (lookahead == 'o') ADVANCE(2167);
      END_STATE();
    case 2604:
      if (lookahead == 'o') ADVANCE(2167);
      if (lookahead == 's') ADVANCE(1705);
      END_STATE();
    case 2605:
      if (lookahead == 'o') ADVANCE(2167);
      if (lookahead == 's') ADVANCE(1706);
      END_STATE();
    case 2606:
      if (lookahead == 'o') ADVANCE(2717);
      END_STATE();
    case 2607:
      if (lookahead == 'o') ADVANCE(2736);
      if (lookahead == 't') ADVANCE(1441);
      END_STATE();
    case 2608:
      if (lookahead == 'o') ADVANCE(2744);
      END_STATE();
    case 2609:
      if (lookahead == 'o') ADVANCE(2505);
      END_STATE();
    case 2610:
      if (lookahead == 'o') ADVANCE(2788);
      END_STATE();
    case 2611:
      if (lookahead == 'o') ADVANCE(2491);
      END_STATE();
    case 2612:
      if (lookahead == 'o') ADVANCE(1707);
      END_STATE();
    case 2613:
      if (lookahead == 'o') ADVANCE(2722);
      END_STATE();
    case 2614:
      if (lookahead == 'o') ADVANCE(2493);
      END_STATE();
    case 2615:
      if (lookahead == 'o') ADVANCE(2116);
      END_STATE();
    case 2616:
      if (lookahead == 'o') ADVANCE(2955);
      END_STATE();
    case 2617:
      if (lookahead == 'o') ADVANCE(1647);
      END_STATE();
    case 2618:
      if (lookahead == 'o') ADVANCE(2277);
      END_STATE();
    case 2619:
      if (lookahead == 'o') ADVANCE(2277);
      if (lookahead == 'r') ADVANCE(2981);
      END_STATE();
    case 2620:
      if (lookahead == 'o') ADVANCE(2277);
      if (lookahead == 'r') ADVANCE(2999);
      END_STATE();
    case 2621:
      if (lookahead == 'o') ADVANCE(2071);
      END_STATE();
    case 2622:
      if (lookahead == 'o') ADVANCE(2752);
      if (lookahead == 'r') ADVANCE(2215);
      END_STATE();
    case 2623:
      if (lookahead == 'o') ADVANCE(1767);
      END_STATE();
    case 2624:
      if (lookahead == 'o') ADVANCE(2518);
      END_STATE();
    case 2625:
      if (lookahead == 'o') ADVANCE(2678);
      END_STATE();
    case 2626:
      if (lookahead == 'o') ADVANCE(2755);
      END_STATE();
    case 2627:
      if (lookahead == 'o') ADVANCE(1445);
      END_STATE();
    case 2628:
      if (lookahead == 'o') ADVANCE(2074);
      END_STATE();
    case 2629:
      if (lookahead == 'o') ADVANCE(2519);
      END_STATE();
    case 2630:
      if (lookahead == 'o') ADVANCE(2756);
      END_STATE();
    case 2631:
      if (lookahead == 'o') ADVANCE(3028);
      END_STATE();
    case 2632:
      if (lookahead == 'o') ADVANCE(2539);
      END_STATE();
    case 2633:
      if (lookahead == 'o') ADVANCE(2217);
      END_STATE();
    case 2634:
      if (lookahead == 'o') ADVANCE(2529);
      END_STATE();
    case 2635:
      if (lookahead == 'o') ADVANCE(1476);
      END_STATE();
    case 2636:
      if (lookahead == 'o') ADVANCE(1459);
      END_STATE();
    case 2637:
      if (lookahead == 'o') ADVANCE(2542);
      END_STATE();
    case 2638:
      if (lookahead == 'o') ADVANCE(2543);
      END_STATE();
    case 2639:
      if (lookahead == 'o') ADVANCE(2220);
      END_STATE();
    case 2640:
      if (lookahead == 'o') ADVANCE(2540);
      END_STATE();
    case 2641:
      if (lookahead == 'o') ADVANCE(2194);
      END_STATE();
    case 2642:
      if (lookahead == 'o') ADVANCE(2551);
      END_STATE();
    case 2643:
      if (lookahead == 'o') ADVANCE(1697);
      END_STATE();
    case 2644:
      if (lookahead == 'o') ADVANCE(2557);
      END_STATE();
    case 2645:
      if (lookahead == 'o') ADVANCE(2008);
      END_STATE();
    case 2646:
      if (lookahead == 'o') ADVANCE(2460);
      if (lookahead == 't') ADVANCE(2737);
      END_STATE();
    case 2647:
      if (lookahead == 'o') ADVANCE(1699);
      END_STATE();
    case 2648:
      if (lookahead == 'o') ADVANCE(2461);
      if (lookahead == 't') ADVANCE(2737);
      END_STATE();
    case 2649:
      if (lookahead == 'o') ADVANCE(1703);
      END_STATE();
    case 2650:
      if (lookahead == 'o') ADVANCE(2210);
      END_STATE();
    case 2651:
      if (lookahead == 'p') ADVANCE(104);
      END_STATE();
    case 2652:
      if (lookahead == 'p') ADVANCE(3530);
      END_STATE();
    case 2653:
      if (lookahead == 'p') ADVANCE(3875);
      END_STATE();
    case 2654:
      if (lookahead == 'p') ADVANCE(3688);
      END_STATE();
    case 2655:
      if (lookahead == 'p') ADVANCE(3686);
      END_STATE();
    case 2656:
      if (lookahead == 'p') ADVANCE(97);
      END_STATE();
    case 2657:
      if (lookahead == 'p') ADVANCE(3848);
      END_STATE();
    case 2658:
      if (lookahead == 'p') ADVANCE(3846);
      END_STATE();
    case 2659:
      if (lookahead == 'p') ADVANCE(3697);
      END_STATE();
    case 2660:
      if (lookahead == 'p') ADVANCE(57);
      END_STATE();
    case 2661:
      if (lookahead == 'p') ADVANCE(3537);
      END_STATE();
    case 2662:
      if (lookahead == 'p') ADVANCE(1403);
      END_STATE();
    case 2663:
      if (lookahead == 'p') ADVANCE(1403);
      if (lookahead == 'r') ADVANCE(3792);
      END_STATE();
    case 2664:
      if (lookahead == 'p') ADVANCE(1624);
      if (lookahead == 'r') ADVANCE(1895);
      if (lookahead == 't') ADVANCE(2724);
      END_STATE();
    case 2665:
      if (lookahead == 'p') ADVANCE(1624);
      if (lookahead == 't') ADVANCE(2723);
      END_STATE();
    case 2666:
      if (lookahead == 'p') ADVANCE(2687);
      END_STATE();
    case 2667:
      if (lookahead == 'p') ADVANCE(118);
      END_STATE();
    case 2668:
      if (lookahead == 'p') ADVANCE(3048);
      END_STATE();
    case 2669:
      if (lookahead == 'p') ADVANCE(3012);
      END_STATE();
    case 2670:
      if (lookahead == 'p') ADVANCE(1921);
      END_STATE();
    case 2671:
      if (lookahead == 'p') ADVANCE(1504);
      END_STATE();
    case 2672:
      if (lookahead == 'p') ADVANCE(2626);
      END_STATE();
    case 2673:
      if (lookahead == 'p') ADVANCE(1822);
      END_STATE();
    case 2674:
      if (lookahead == 'p') ADVANCE(2922);
      END_STATE();
    case 2675:
      if (lookahead == 'p') ADVANCE(1402);
      END_STATE();
    case 2676:
      if (lookahead == 'p') ADVANCE(1402);
      if (lookahead == 'r') ADVANCE(3792);
      END_STATE();
    case 2677:
      if (lookahead == 'p') ADVANCE(2926);
      END_STATE();
    case 2678:
      if (lookahead == 'p') ADVANCE(1861);
      END_STATE();
    case 2679:
      if (lookahead == 'p') ADVANCE(1862);
      END_STATE();
    case 2680:
      if (lookahead == 'p') ADVANCE(2746);
      END_STATE();
    case 2681:
      if (lookahead == 'p') ADVANCE(2746);
      if (lookahead == 't') ADVANCE(1501);
      END_STATE();
    case 2682:
      if (lookahead == 'p') ADVANCE(1451);
      if (lookahead == 'r') ADVANCE(1977);
      if (lookahead == 's') ADVANCE(3034);
      END_STATE();
    case 2683:
      if (lookahead == 'p') ADVANCE(2360);
      END_STATE();
    case 2684:
      if (lookahead == 'p') ADVANCE(1452);
      END_STATE();
    case 2685:
      if (lookahead == 'p') ADVANCE(2345);
      END_STATE();
    case 2686:
      if (lookahead == 'p') ADVANCE(2386);
      END_STATE();
    case 2687:
      if (lookahead == 'p') ADVANCE(1467);
      if (lookahead == 'r') ADVANCE(1989);
      END_STATE();
    case 2688:
      if (lookahead == 'p') ADVANCE(1512);
      END_STATE();
    case 2689:
      if (lookahead == 'p') ADVANCE(2630);
      END_STATE();
    case 2690:
      if (lookahead == 'p') ADVANCE(2641);
      END_STATE();
    case 2691:
      if (lookahead == 'p') ADVANCE(1517);
      END_STATE();
    case 2692:
      if (lookahead == 'p') ADVANCE(2978);
      END_STATE();
    case 2693:
      if (lookahead == 'p') ADVANCE(2421);
      END_STATE();
    case 2694:
      if (lookahead == 'p') ADVANCE(2980);
      END_STATE();
    case 2695:
      if (lookahead == 'q') ADVANCE(3810);
      if (lookahead == 'x') ADVANCE(2975);
      END_STATE();
    case 2696:
      if (lookahead == 'q') ADVANCE(1334);
      END_STATE();
    case 2697:
      if (lookahead == 'q') ADVANCE(3821);
      END_STATE();
    case 2698:
      if (lookahead == 'q') ADVANCE(3828);
      END_STATE();
    case 2699:
      if (lookahead == 'q') ADVANCE(3534);
      END_STATE();
    case 2700:
      if (lookahead == 'q') ADVANCE(1324);
      END_STATE();
    case 2701:
      if (lookahead == 'q') ADVANCE(2994);
      END_STATE();
    case 2702:
      if (lookahead == 'q') ADVANCE(3009);
      END_STATE();
    case 2703:
      if (lookahead == 'r') ADVANCE(3792);
      END_STATE();
    case 2704:
      if (lookahead == 'r') ADVANCE(3336);
      END_STATE();
    case 2705:
      if (lookahead == 'r') ADVANCE(3336);
      if (lookahead == 'x') ADVANCE(1312);
      END_STATE();
    case 2706:
      if (lookahead == 'r') ADVANCE(3771);
      END_STATE();
    case 2707:
      if (lookahead == 'r') ADVANCE(3769);
      END_STATE();
    case 2708:
      if (lookahead == 'r') ADVANCE(3684);
      END_STATE();
    case 2709:
      if (lookahead == 'r') ADVANCE(3753);
      END_STATE();
    case 2710:
      if (lookahead == 'r') ADVANCE(3854);
      END_STATE();
    case 2711:
      if (lookahead == 'r') ADVANCE(3181);
      END_STATE();
    case 2712:
      if (lookahead == 'r') ADVANCE(3651);
      END_STATE();
    case 2713:
      if (lookahead == 'r') ADVANCE(3187);
      END_STATE();
    case 2714:
      if (lookahead == 'r') ADVANCE(3286);
      END_STATE();
    case 2715:
      if (lookahead == 'r') ADVANCE(3884);
      END_STATE();
    case 2716:
      if (lookahead == 'r') ADVANCE(3722);
      END_STATE();
    case 2717:
      if (lookahead == 'r') ADVANCE(3659);
      END_STATE();
    case 2718:
      if (lookahead == 'r') ADVANCE(3747);
      END_STATE();
    case 2719:
      if (lookahead == 'r') ADVANCE(3287);
      END_STATE();
    case 2720:
      if (lookahead == 'r') ADVANCE(3794);
      END_STATE();
    case 2721:
      if (lookahead == 'r') ADVANCE(3882);
      END_STATE();
    case 2722:
      if (lookahead == 'r') ADVANCE(3608);
      END_STATE();
    case 2723:
      if (lookahead == 'r') ADVANCE(3334);
      END_STATE();
    case 2724:
      if (lookahead == 'r') ADVANCE(3334);
      if (lookahead == 'x') ADVANCE(1312);
      END_STATE();
    case 2725:
      if (lookahead == 'r') ADVANCE(3056);
      END_STATE();
    case 2726:
      if (lookahead == 'r') ADVANCE(2840);
      END_STATE();
    case 2727:
      if (lookahead == 'r') ADVANCE(1617);
      END_STATE();
    case 2728:
      if (lookahead == 'r') ADVANCE(3025);
      END_STATE();
    case 2729:
      if (lookahead == 'r') ADVANCE(2094);
      END_STATE();
    case 2730:
      if (lookahead == 'r') ADVANCE(2436);
      END_STATE();
    case 2731:
      if (lookahead == 'r') ADVANCE(2576);
      if (lookahead == 'x') ADVANCE(2866);
      END_STATE();
    case 2732:
      if (lookahead == 'r') ADVANCE(2215);
      END_STATE();
    case 2733:
      if (lookahead == 'r') ADVANCE(2095);
      END_STATE();
    case 2734:
      if (lookahead == 'r') ADVANCE(1904);
      if (lookahead == 'v') ADVANCE(1433);
      END_STATE();
    case 2735:
      if (lookahead == 'r') ADVANCE(2067);
      END_STATE();
    case 2736:
      if (lookahead == 'r') ADVANCE(3061);
      END_STATE();
    case 2737:
      if (lookahead == 'r') ADVANCE(2161);
      END_STATE();
    case 2738:
      if (lookahead == 'r') ADVANCE(2588);
      END_STATE();
    case 2739:
      if (lookahead == 'r') ADVANCE(1326);
      END_STATE();
    case 2740:
      if (lookahead == 'r') ADVANCE(1789);
      END_STATE();
    case 2741:
      if (lookahead == 'r') ADVANCE(2981);
      END_STATE();
    case 2742:
      if (lookahead == 'r') ADVANCE(2119);
      END_STATE();
    case 2743:
      if (lookahead == 'r') ADVANCE(2482);
      END_STATE();
    case 2744:
      if (lookahead == 'r') ADVANCE(1328);
      END_STATE();
    case 2745:
      if (lookahead == 'r') ADVANCE(2873);
      END_STATE();
    case 2746:
      if (lookahead == 'r') ADVANCE(2589);
      END_STATE();
    case 2747:
      if (lookahead == 'r') ADVANCE(2553);
      END_STATE();
    case 2748:
      if (lookahead == 'r') ADVANCE(1912);
      END_STATE();
    case 2749:
      if (lookahead == 'r') ADVANCE(2645);
      END_STATE();
    case 2750:
      if (lookahead == 'r') ADVANCE(2485);
      END_STATE();
    case 2751:
      if (lookahead == 'r') ADVANCE(1509);
      END_STATE();
    case 2752:
      if (lookahead == 'r') ADVANCE(1825);
      END_STATE();
    case 2753:
      if (lookahead == 'r') ADVANCE(2489);
      END_STATE();
    case 2754:
      if (lookahead == 'r') ADVANCE(2492);
      END_STATE();
    case 2755:
      if (lookahead == 'r') ADVANCE(2889);
      END_STATE();
    case 2756:
      if (lookahead == 'r') ADVANCE(2890);
      END_STATE();
    case 2757:
      if (lookahead == 'r') ADVANCE(2787);
      END_STATE();
    case 2758:
      if (lookahead == 'r') ADVANCE(1973);
      END_STATE();
    case 2759:
      if (lookahead == 'r') ADVANCE(1837);
      END_STATE();
    case 2760:
      if (lookahead == 'r') ADVANCE(1838);
      END_STATE();
    case 2761:
      if (lookahead == 'r') ADVANCE(2019);
      END_STATE();
    case 2762:
      if (lookahead == 'r') ADVANCE(1962);
      END_STATE();
    case 2763:
      if (lookahead == 'r') ADVANCE(1856);
      END_STATE();
    case 2764:
      if (lookahead == 'r') ADVANCE(1941);
      END_STATE();
    case 2765:
      if (lookahead == 'r') ADVANCE(1935);
      END_STATE();
    case 2766:
      if (lookahead == 'r') ADVANCE(2110);
      END_STATE();
    case 2767:
      if (lookahead == 'r') ADVANCE(1791);
      END_STATE();
    case 2768:
      if (lookahead == 'r') ADVANCE(2966);
      END_STATE();
    case 2769:
      if (lookahead == 'r') ADVANCE(2545);
      END_STATE();
    case 2770:
      if (lookahead == 'r') ADVANCE(1983);
      END_STATE();
    case 2771:
      if (lookahead == 'r') ADVANCE(2007);
      END_STATE();
    case 2772:
      if (lookahead == 'r') ADVANCE(2838);
      END_STATE();
    case 2773:
      if (lookahead == 'r') ADVANCE(2000);
      END_STATE();
    case 2774:
      if (lookahead == 'r') ADVANCE(1530);
      END_STATE();
    case 2775:
      if (lookahead == 'r') ADVANCE(1772);
      END_STATE();
    case 2776:
      if (lookahead == 'r') ADVANCE(1664);
      END_STATE();
    case 2777:
      if (lookahead == 'r') ADVANCE(1961);
      END_STATE();
    case 2778:
      if (lookahead == 'r') ADVANCE(1988);
      END_STATE();
    case 2779:
      if (lookahead == 'r') ADVANCE(2010);
      END_STATE();
    case 2780:
      if (lookahead == 'r') ADVANCE(1313);
      END_STATE();
    case 2781:
      if (lookahead == 'r') ADVANCE(2113);
      END_STATE();
    case 2782:
      if (lookahead == 'r') ADVANCE(2967);
      END_STATE();
    case 2783:
      if (lookahead == 'r') ADVANCE(2012);
      END_STATE();
    case 2784:
      if (lookahead == 'r') ADVANCE(2118);
      END_STATE();
    case 2785:
      if (lookahead == 'r') ADVANCE(2609);
      END_STATE();
    case 2786:
      if (lookahead == 'r') ADVANCE(2014);
      END_STATE();
    case 2787:
      if (lookahead == 'r') ADVANCE(2613);
      END_STATE();
    case 2788:
      if (lookahead == 'r') ADVANCE(1337);
      END_STATE();
    case 2789:
      if (lookahead == 'r') ADVANCE(1784);
      END_STATE();
    case 2790:
      if (lookahead == 'r') ADVANCE(2230);
      END_STATE();
    case 2791:
      if (lookahead == 'r') ADVANCE(1503);
      END_STATE();
    case 2792:
      if (lookahead == 'r') ADVANCE(1340);
      END_STATE();
    case 2793:
      if (lookahead == 'r') ADVANCE(2018);
      END_STATE();
    case 2794:
      if (lookahead == 'r') ADVANCE(3017);
      END_STATE();
    case 2795:
      if (lookahead == 'r') ADVANCE(2560);
      END_STATE();
    case 2796:
      if (lookahead == 'r') ADVANCE(2650);
      if (lookahead == 'x') ADVANCE(2866);
      END_STATE();
    case 2797:
      if (lookahead == 'r') ADVANCE(2561);
      END_STATE();
    case 2798:
      if (lookahead == 'r') ADVANCE(2029);
      END_STATE();
    case 2799:
      if (lookahead == 'r') ADVANCE(2854);
      END_STATE();
    case 2800:
      if (lookahead == 's') ADVANCE(1528);
      END_STATE();
    case 2801:
      if (lookahead == 's') ADVANCE(3894);
      END_STATE();
    case 2802:
      if (lookahead == 's') ADVANCE(3579);
      END_STATE();
    case 2803:
      if (lookahead == 's') ADVANCE(3724);
      END_STATE();
    case 2804:
      if (lookahead == 's') ADVANCE(4653);
      END_STATE();
    case 2805:
      if (lookahead == 's') ADVANCE(3755);
      END_STATE();
    case 2806:
      if (lookahead == 's') ADVANCE(3546);
      END_STATE();
    case 2807:
      if (lookahead == 's') ADVANCE(3423);
      END_STATE();
    case 2808:
      if (lookahead == 's') ADVANCE(3507);
      END_STATE();
    case 2809:
      if (lookahead == 's') ADVANCE(3516);
      END_STATE();
    case 2810:
      if (lookahead == 's') ADVANCE(3453);
      END_STATE();
    case 2811:
      if (lookahead == 's') ADVANCE(1527);
      END_STATE();
    case 2812:
      if (lookahead == 's') ADVANCE(2261);
      END_STATE();
    case 2813:
      if (lookahead == 's') ADVANCE(54);
      END_STATE();
    case 2814:
      if (lookahead == 's') ADVANCE(2861);
      END_STATE();
    case 2815:
      if (lookahead == 's') ADVANCE(2848);
      END_STATE();
    case 2816:
      if (lookahead == 's') ADVANCE(2863);
      END_STATE();
    case 2817:
      if (lookahead == 's') ADVANCE(2671);
      END_STATE();
    case 2818:
      if (lookahead == 's') ADVANCE(1991);
      if (lookahead == 't') ADVANCE(2041);
      END_STATE();
    case 2819:
      if (lookahead == 's') ADVANCE(2206);
      END_STATE();
    case 2820:
      if (lookahead == 's') ADVANCE(3071);
      END_STATE();
    case 2821:
      if (lookahead == 's') ADVANCE(2805);
      END_STATE();
    case 2822:
      if (lookahead == 's') ADVANCE(1342);
      END_STATE();
    case 2823:
      if (lookahead == 's') ADVANCE(2806);
      END_STATE();
    case 2824:
      if (lookahead == 's') ADVANCE(2151);
      if (lookahead == 'u') ADVANCE(2152);
      END_STATE();
    case 2825:
      if (lookahead == 's') ADVANCE(2808);
      END_STATE();
    case 2826:
      if (lookahead == 's') ADVANCE(2809);
      END_STATE();
    case 2827:
      if (lookahead == 's') ADVANCE(1649);
      END_STATE();
    case 2828:
      if (lookahead == 's') ADVANCE(1823);
      END_STATE();
    case 2829:
      if (lookahead == 's') ADVANCE(2876);
      END_STATE();
    case 2830:
      if (lookahead == 's') ADVANCE(2207);
      END_STATE();
    case 2831:
      if (lookahead == 's') ADVANCE(2878);
      END_STATE();
    case 2832:
      if (lookahead == 's') ADVANCE(2879);
      END_STATE();
    case 2833:
      if (lookahead == 's') ADVANCE(2896);
      END_STATE();
    case 2834:
      if (lookahead == 's') ADVANCE(2930);
      END_STATE();
    case 2835:
      if (lookahead == 's') ADVANCE(2923);
      END_STATE();
    case 2836:
      if (lookahead == 's') ADVANCE(1845);
      END_STATE();
    case 2837:
      if (lookahead == 's') ADVANCE(2901);
      END_STATE();
    case 2838:
      if (lookahead == 's') ADVANCE(1858);
      END_STATE();
    case 2839:
      if (lookahead == 's') ADVANCE(1943);
      END_STATE();
    case 2840:
      if (lookahead == 's') ADVANCE(2644);
      END_STATE();
    case 2841:
      if (lookahead == 's') ADVANCE(2958);
      END_STATE();
    case 2842:
      if (lookahead == 's') ADVANCE(2946);
      if (lookahead == 't') ADVANCE(2791);
      if (lookahead == 'v') ADVANCE(2038);
      END_STATE();
    case 2843:
      if (lookahead == 's') ADVANCE(2950);
      END_STATE();
    case 2844:
      if (lookahead == 's') ADVANCE(2830);
      END_STATE();
    case 2845:
      if (lookahead == 's') ADVANCE(2598);
      END_STATE();
    case 2846:
      if (lookahead == 's') ADVANCE(2920);
      END_STATE();
    case 2847:
      if (lookahead == 's') ADVANCE(1552);
      END_STATE();
    case 2848:
      if (lookahead == 's') ADVANCE(2600);
      END_STATE();
    case 2849:
      if (lookahead == 's') ADVANCE(2957);
      END_STATE();
    case 2850:
      if (lookahead == 's') ADVANCE(2187);
      END_STATE();
    case 2851:
      if (lookahead == 's') ADVANCE(2218);
      END_STATE();
    case 2852:
      if (lookahead == 's') ADVANCE(2225);
      END_STATE();
    case 2853:
      if (lookahead == 's') ADVANCE(2688);
      END_STATE();
    case 2854:
      if (lookahead == 's') ADVANCE(2691);
      END_STATE();
    case 2855:
      if (lookahead == 's') ADVANCE(1526);
      END_STATE();
    case 2856:
      if (lookahead == 's') ADVANCE(2250);
      END_STATE();
    case 2857:
      if (lookahead == 's') ADVANCE(2856);
      END_STATE();
    case 2858:
      if (lookahead == 's') ADVANCE(2256);
      END_STATE();
    case 2859:
      if (lookahead == 's') ADVANCE(2858);
      END_STATE();
    case 2860:
      if (lookahead == 't') ADVANCE(3402);
      END_STATE();
    case 2861:
      if (lookahead == 't') ADVANCE(3880);
      END_STATE();
    case 2862:
      if (lookahead == 't') ADVANCE(2681);
      END_STATE();
    case 2863:
      if (lookahead == 't') ADVANCE(3585);
      END_STATE();
    case 2864:
      if (lookahead == 't') ADVANCE(3838);
      END_STATE();
    case 2865:
      if (lookahead == 't') ADVANCE(3573);
      END_STATE();
    case 2866:
      if (lookahead == 't') ADVANCE(3836);
      END_STATE();
    case 2867:
      if (lookahead == 't') ADVANCE(3665);
      END_STATE();
    case 2868:
      if (lookahead == 't') ADVANCE(3298);
      END_STATE();
    case 2869:
      if (lookahead == 't') ADVANCE(3842);
      END_STATE();
    case 2870:
      if (lookahead == 't') ADVANCE(1368);
      END_STATE();
    case 2871:
      if (lookahead == 't') ADVANCE(3295);
      END_STATE();
    case 2872:
      if (lookahead == 't') ADVANCE(3370);
      END_STATE();
    case 2873:
      if (lookahead == 't') ADVANCE(2046);
      END_STATE();
    case 2874:
      if (lookahead == 't') ADVANCE(3657);
      END_STATE();
    case 2875:
      if (lookahead == 't') ADVANCE(3162);
      END_STATE();
    case 2876:
      if (lookahead == 't') ADVANCE(3832);
      END_STATE();
    case 2877:
      if (lookahead == 't') ADVANCE(3212);
      END_STATE();
    case 2878:
      if (lookahead == 't') ADVANCE(3903);
      END_STATE();
    case 2879:
      if (lookahead == 't') ADVANCE(3868);
      END_STATE();
    case 2880:
      if (lookahead == 't') ADVANCE(3558);
      END_STATE();
    case 2881:
      if (lookahead == 't') ADVANCE(3555);
      END_STATE();
    case 2882:
      if (lookahead == 't') ADVANCE(3676);
      END_STATE();
    case 2883:
      if (lookahead == 't') ADVANCE(3893);
      END_STATE();
    case 2884:
      if (lookahead == 't') ADVANCE(3876);
      END_STATE();
    case 2885:
      if (lookahead == 't') ADVANCE(3666);
      END_STATE();
    case 2886:
      if (lookahead == 't') ADVANCE(3906);
      END_STATE();
    case 2887:
      if (lookahead == 't') ADVANCE(52);
      END_STATE();
    case 2888:
      if (lookahead == 't') ADVANCE(3856);
      END_STATE();
    case 2889:
      if (lookahead == 't') ADVANCE(3220);
      END_STATE();
    case 2890:
      if (lookahead == 't') ADVANCE(3218);
      END_STATE();
    case 2891:
      if (lookahead == 't') ADVANCE(3396);
      END_STATE();
    case 2892:
      if (lookahead == 't') ADVANCE(3165);
      END_STATE();
    case 2893:
      if (lookahead == 't') ADVANCE(3411);
      END_STATE();
    case 2894:
      if (lookahead == 't') ADVANCE(3888);
      END_STATE();
    case 2895:
      if (lookahead == 't') ADVANCE(3889);
      END_STATE();
    case 2896:
      if (lookahead == 't') ADVANCE(3844);
      END_STATE();
    case 2897:
      if (lookahead == 't') ADVANCE(3655);
      END_STATE();
    case 2898:
      if (lookahead == 't') ADVANCE(3653);
      END_STATE();
    case 2899:
      if (lookahead == 't') ADVANCE(3435);
      END_STATE();
    case 2900:
      if (lookahead == 't') ADVANCE(3208);
      END_STATE();
    case 2901:
      if (lookahead == 't') ADVANCE(3879);
      END_STATE();
    case 2902:
      if (lookahead == 't') ADVANCE(1454);
      END_STATE();
    case 2903:
      if (lookahead == 't') ADVANCE(3673);
      END_STATE();
    case 2904:
      if (lookahead == 't') ADVANCE(1546);
      END_STATE();
    case 2905:
      if (lookahead == 't') ADVANCE(1637);
      END_STATE();
    case 2906:
      if (lookahead == 't') ADVANCE(2737);
      END_STATE();
    case 2907:
      if (lookahead == 't') ADVANCE(1428);
      END_STATE();
    case 2908:
      if (lookahead == 't') ADVANCE(3070);
      END_STATE();
    case 2909:
      if (lookahead == 't') ADVANCE(2621);
      END_STATE();
    case 2910:
      if (lookahead == 't') ADVANCE(1303);
      END_STATE();
    case 2911:
      if (lookahead == 't') ADVANCE(1536);
      END_STATE();
    case 2912:
      if (lookahead == 't') ADVANCE(2791);
      END_STATE();
    case 2913:
      if (lookahead == 't') ADVANCE(2791);
      if (lookahead == 'v') ADVANCE(2038);
      END_STATE();
    case 2914:
      if (lookahead == 't') ADVANCE(3060);
      END_STATE();
    case 2915:
      if (lookahead == 't') ADVANCE(1940);
      END_STATE();
    case 2916:
      if (lookahead == 't') ADVANCE(2089);
      END_STATE();
    case 2917:
      if (lookahead == 't') ADVANCE(3016);
      END_STATE();
    case 2918:
      if (lookahead == 't') ADVANCE(2247);
      END_STATE();
    case 2919:
      if (lookahead == 't') ADVANCE(2224);
      END_STATE();
    case 2920:
      if (lookahead == 't') ADVANCE(1455);
      END_STATE();
    case 2921:
      if (lookahead == 't') ADVANCE(1370);
      END_STATE();
    case 2922:
      if (lookahead == 't') ADVANCE(2710);
      END_STATE();
    case 2923:
      if (lookahead == 't') ADVANCE(2680);
      END_STATE();
    case 2924:
      if (lookahead == 't') ADVANCE(1948);
      END_STATE();
    case 2925:
      if (lookahead == 't') ADVANCE(1956);
      END_STATE();
    case 2926:
      if (lookahead == 't') ADVANCE(2716);
      END_STATE();
    case 2927:
      if (lookahead == 't') ADVANCE(1826);
      END_STATE();
    case 2928:
      if (lookahead == 't') ADVANCE(2338);
      END_STATE();
    case 2929:
      if (lookahead == 't') ADVANCE(2908);
      END_STATE();
    case 2930:
      if (lookahead == 't') ADVANCE(2794);
      END_STATE();
    case 2931:
      if (lookahead == 't') ADVANCE(1844);
      END_STATE();
    case 2932:
      if (lookahead == 't') ADVANCE(1960);
      END_STATE();
    case 2933:
      if (lookahead == 't') ADVANCE(1938);
      END_STATE();
    case 2934:
      if (lookahead == 't') ADVANCE(1860);
      END_STATE();
    case 2935:
      if (lookahead == 't') ADVANCE(1864);
      END_STATE();
    case 2936:
      if (lookahead == 't') ADVANCE(1966);
      END_STATE();
    case 2937:
      if (lookahead == 't') ADVANCE(1967);
      END_STATE();
    case 2938:
      if (lookahead == 't') ADVANCE(1870);
      END_STATE();
    case 2939:
      if (lookahead == 't') ADVANCE(2015);
      END_STATE();
    case 2940:
      if (lookahead == 't') ADVANCE(2030);
      END_STATE();
    case 2941:
      if (lookahead == 't') ADVANCE(1882);
      END_STATE();
    case 2942:
      if (lookahead == 't') ADVANCE(51);
      END_STATE();
    case 2943:
      if (lookahead == 't') ADVANCE(2448);
      END_STATE();
    case 2944:
      if (lookahead == 't') ADVANCE(1437);
      END_STATE();
    case 2945:
      if (lookahead == 't') ADVANCE(3035);
      END_STATE();
    case 2946:
      if (lookahead == 't') ADVANCE(1484);
      END_STATE();
    case 2947:
      if (lookahead == 't') ADVANCE(2677);
      END_STATE();
    case 2948:
      if (lookahead == 't') ADVANCE(1458);
      END_STATE();
    case 2949:
      if (lookahead == 't') ADVANCE(2035);
      END_STATE();
    case 2950:
      if (lookahead == 't') ADVANCE(2599);
      END_STATE();
    case 2951:
      if (lookahead == 't') ADVANCE(2785);
      END_STATE();
    case 2952:
      if (lookahead == 't') ADVANCE(2237);
      END_STATE();
    case 2953:
      if (lookahead == 't') ADVANCE(2606);
      END_STATE();
    case 2954:
      if (lookahead == 't') ADVANCE(2075);
      END_STATE();
    case 2955:
      if (lookahead == 't') ADVANCE(2601);
      END_STATE();
    case 2956:
      if (lookahead == 't') ADVANCE(2182);
      END_STATE();
    case 2957:
      if (lookahead == 't') ADVANCE(1471);
      END_STATE();
    case 2958:
      if (lookahead == 't') ADVANCE(1661);
      END_STATE();
    case 2959:
      if (lookahead == 't') ADVANCE(1646);
      END_STATE();
    case 2960:
      if (lookahead == 't') ADVANCE(1635);
      END_STATE();
    case 2961:
      if (lookahead == 't') ADVANCE(1542);
      END_STATE();
    case 2962:
      if (lookahead == 't') ADVANCE(1638);
      END_STATE();
    case 2963:
      if (lookahead == 't') ADVANCE(1644);
      END_STATE();
    case 2964:
      if (lookahead == 't') ADVANCE(2192);
      END_STATE();
    case 2965:
      if (lookahead == 't') ADVANCE(2628);
      END_STATE();
    case 2966:
      if (lookahead == 't') ADVANCE(2246);
      END_STATE();
    case 2967:
      if (lookahead == 't') ADVANCE(2639);
      END_STATE();
    case 2968:
      if (lookahead == 't') ADVANCE(2239);
      END_STATE();
    case 2969:
      if (lookahead == 't') ADVANCE(2231);
      END_STATE();
    case 2970:
      if (lookahead == 't') ADVANCE(3010);
      END_STATE();
    case 2971:
      if (lookahead == 't') ADVANCE(2236);
      END_STATE();
    case 2972:
      if (lookahead == 't') ADVANCE(2221);
      END_STATE();
    case 2973:
      if (lookahead == 't') ADVANCE(2229);
      END_STATE();
    case 2974:
      if (lookahead == 't') ADVANCE(2235);
      END_STATE();
    case 2975:
      if (lookahead == 't') ADVANCE(2036);
      END_STATE();
    case 2976:
      if (lookahead == 't') ADVANCE(2048);
      END_STATE();
    case 2977:
      if (lookahead == 't') ADVANCE(2254);
      END_STATE();
    case 2978:
      if (lookahead == 't') ADVANCE(1544);
      END_STATE();
    case 2979:
      if (lookahead == 't') ADVANCE(1547);
      END_STATE();
    case 2980:
      if (lookahead == 't') ADVANCE(1549);
      END_STATE();
    case 2981:
      if (lookahead == 'u') ADVANCE(1821);
      END_STATE();
    case 2982:
      if (lookahead == 'u') ADVANCE(1565);
      END_STATE();
    case 2983:
      if (lookahead == 'u') ADVANCE(1561);
      END_STATE();
    case 2984:
      if (lookahead == 'u') ADVANCE(3075);
      END_STATE();
    case 2985:
      if (lookahead == 'u') ADVANCE(2285);
      END_STATE();
    case 2986:
      if (lookahead == 'u') ADVANCE(2685);
      END_STATE();
    case 2987:
      if (lookahead == 'u') ADVANCE(2659);
      END_STATE();
    case 2988:
      if (lookahead == 'u') ADVANCE(2509);
      END_STATE();
    case 2989:
      if (lookahead == 'u') ADVANCE(2772);
      END_STATE();
    case 2990:
      if (lookahead == 'u') ADVANCE(2346);
      END_STATE();
    case 2991:
      if (lookahead == 'u') ADVANCE(2395);
      END_STATE();
    case 2992:
      if (lookahead == 'u') ADVANCE(2666);
      END_STATE();
    case 2993:
      if (lookahead == 'u') ADVANCE(2524);
      END_STATE();
    case 2994:
      if (lookahead == 'u') ADVANCE(1833);
      END_STATE();
    case 2995:
      if (lookahead == 'u') ADVANCE(2892);
      END_STATE();
    case 2996:
      if (lookahead == 'u') ADVANCE(1849);
      END_STATE();
    case 2997:
      if (lookahead == 'u') ADVANCE(1863);
      END_STATE();
    case 2998:
      if (lookahead == 'u') ADVANCE(1867);
      END_STATE();
    case 2999:
      if (lookahead == 'u') ADVANCE(1820);
      END_STATE();
    case 3000:
      if (lookahead == 'u') ADVANCE(2776);
      END_STATE();
    case 3001:
      if (lookahead == 'u') ADVANCE(2750);
      END_STATE();
    case 3002:
      if (lookahead == 'u') ADVANCE(2358);
      END_STATE();
    case 3003:
      if (lookahead == 'u') ADVANCE(2441);
      END_STATE();
    case 3004:
      if (lookahead == 'u') ADVANCE(2347);
      END_STATE();
    case 3005:
      if (lookahead == 'u') ADVANCE(2449);
      END_STATE();
    case 3006:
      if (lookahead == 'u') ADVANCE(1443);
      END_STATE();
    case 3007:
      if (lookahead == 'u') ADVANCE(2753);
      END_STATE();
    case 3008:
      if (lookahead == 'u') ADVANCE(2508);
      END_STATE();
    case 3009:
      if (lookahead == 'u') ADVANCE(2162);
      END_STATE();
    case 3010:
      if (lookahead == 'u') ADVANCE(2754);
      END_STATE();
    case 3011:
      if (lookahead == 'u') ADVANCE(2446);
      END_STATE();
    case 3012:
      if (lookahead == 'u') ADVANCE(1317);
      END_STATE();
    case 3013:
      if (lookahead == 'u') ADVANCE(2357);
      END_STATE();
    case 3014:
      if (lookahead == 'u') ADVANCE(2933);
      END_STATE();
    case 3015:
      if (lookahead == 'u') ADVANCE(2514);
      END_STATE();
    case 3016:
      if (lookahead == 'u') ADVANCE(2763);
      END_STATE();
    case 3017:
      if (lookahead == 'u') ADVANCE(2462);
      END_STATE();
    case 3018:
      if (lookahead == 'u') ADVANCE(2251);
      END_STATE();
    case 3019:
      if (lookahead == 'u') ADVANCE(2693);
      END_STATE();
    case 3020:
      if (lookahead == 'v') ADVANCE(3775);
      END_STATE();
    case 3021:
      if (lookahead == 'v') ADVANCE(3767);
      END_STATE();
    case 3022:
      if (lookahead == 'v') ADVANCE(3765);
      END_STATE();
    case 3023:
      if (lookahead == 'v') ADVANCE(2435);
      END_STATE();
    case 3024:
      if (lookahead == 'v') ADVANCE(1495);
      END_STATE();
    case 3025:
      if (lookahead == 'v') ADVANCE(1927);
      END_STATE();
    case 3026:
      if (lookahead == 'v') ADVANCE(1979);
      END_STATE();
    case 3027:
      if (lookahead == 'v') ADVANCE(2003);
      END_STATE();
    case 3028:
      if (lookahead == 'v') ADVANCE(2006);
      END_STATE();
    case 3029:
      if (lookahead == 'v') ADVANCE(1532);
      END_STATE();
    case 3030:
      if (lookahead == 'v') ADVANCE(1516);
      END_STATE();
    case 3031:
      if (lookahead == 'v') ADVANCE(2038);
      END_STATE();
    case 3032:
      if (lookahead == 'w') ADVANCE(3663);
      if (lookahead == 'z') ADVANCE(3874);
      END_STATE();
    case 3033:
      if (lookahead == 'w') ADVANCE(3718);
      END_STATE();
    case 3034:
      if (lookahead == 'w') ADVANCE(2204);
      END_STATE();
    case 3035:
      if (lookahead == 'w') ADVANCE(2228);
      END_STATE();
    case 3036:
      if (lookahead == 'w') ADVANCE(1959);
      END_STATE();
    case 3037:
      if (lookahead == 'w') ADVANCE(1698);
      END_STATE();
    case 3038:
      if (lookahead == 'w') ADVANCE(1541);
      END_STATE();
    case 3039:
      if (lookahead == 'x') ADVANCE(3089);
      END_STATE();
    case 3040:
      if (lookahead == 'x') ADVANCE(3796);
      END_STATE();
    case 3041:
      if (lookahead == 'x') ADVANCE(3802);
      END_STATE();
    case 3042:
      if (lookahead == 'x') ADVANCE(3374);
      END_STATE();
    case 3043:
      if (lookahead == 'x') ADVANCE(3324);
      END_STATE();
    case 3044:
      if (lookahead == 'x') ADVANCE(3320);
      END_STATE();
    case 3045:
      if (lookahead == 'x') ADVANCE(1301);
      END_STATE();
    case 3046:
      if (lookahead == 'x') ADVANCE(2672);
      END_STATE();
    case 3047:
      if (lookahead == 'x') ADVANCE(2869);
      END_STATE();
    case 3048:
      if (lookahead == 'x') ADVANCE(1683);
      END_STATE();
    case 3049:
      if (lookahead == 'x') ADVANCE(2880);
      END_STATE();
    case 3050:
      if (lookahead == 'x') ADVANCE(2881);
      END_STATE();
    case 3051:
      if (lookahead == 'x') ADVANCE(2975);
      END_STATE();
    case 3052:
      if (lookahead == 'x') ADVANCE(1970);
      END_STATE();
    case 3053:
      if (lookahead == 'x') ADVANCE(1980);
      END_STATE();
    case 3054:
      if (lookahead == 'x') ADVANCE(1413);
      END_STATE();
    case 3055:
      if (lookahead == 'x') ADVANCE(2939);
      END_STATE();
    case 3056:
      if (lookahead == 'y') ADVANCE(3624);
      END_STATE();
    case 3057:
      if (lookahead == 'y') ADVANCE(3492);
      END_STATE();
    case 3058:
      if (lookahead == 'y') ADVANCE(3495);
      END_STATE();
    case 3059:
      if (lookahead == 'y') ADVANCE(3498);
      END_STATE();
    case 3060:
      if (lookahead == 'y') ADVANCE(3378);
      END_STATE();
    case 3061:
      if (lookahead == 'y') ADVANCE(3510);
      END_STATE();
    case 3062:
      if (lookahead == 'y') ADVANCE(3405);
      END_STATE();
    case 3063:
      if (lookahead == 'y') ADVANCE(3190);
      END_STATE();
    case 3064:
      if (lookahead == 'y') ADVANCE(3408);
      END_STATE();
    case 3065:
      if (lookahead == 'y') ADVANCE(1574);
      END_STATE();
    case 3066:
      if (lookahead == 'y') ADVANCE(1339);
      END_STATE();
    case 3067:
      if (lookahead == 'y') ADVANCE(2513);
      END_STATE();
    case 3068:
      if (lookahead == 'y') ADVANCE(2593);
      END_STATE();
    case 3069:
      if (lookahead == 'y') ADVANCE(2850);
      END_STATE();
    case 3070:
      if (lookahead == 'y') ADVANCE(2679);
      END_STATE();
    case 3071:
      if (lookahead == 'y') ADVANCE(2534);
      END_STATE();
    case 3072:
      if (lookahead == 'y') ADVANCE(2748);
      END_STATE();
    case 3073:
      if (lookahead == 'z') ADVANCE(3874);
      END_STATE();
    case 3074:
      if (lookahead == 'z') ADVANCE(3065);
      END_STATE();
    case 3075:
      if (lookahead == 'z') ADVANCE(3086);
      END_STATE();
    case 3076:
      if (lookahead == 'z') ADVANCE(1829);
      END_STATE();
    case 3077:
      if (lookahead == 'z') ADVANCE(1840);
      END_STATE();
    case 3078:
      if (lookahead == 'z') ADVANCE(1843);
      END_STATE();
    case 3079:
      if (lookahead == 'z') ADVANCE(1851);
      END_STATE();
    case 3080:
      if (lookahead == 'z') ADVANCE(1930);
      END_STATE();
    case 3081:
      if (lookahead == 'z') ADVANCE(1854);
      END_STATE();
    case 3082:
      if (lookahead == 'z') ADVANCE(1999);
      END_STATE();
    case 3083:
      if (lookahead == 'z') ADVANCE(1976);
      END_STATE();
    case 3084:
      if (lookahead == 'z') ADVANCE(1978);
      END_STATE();
    case 3085:
      if (lookahead == 'z') ADVANCE(1972);
      END_STATE();
    case 3086:
      if (lookahead == 'z') ADVANCE(2196);
      END_STATE();
    case 3087:
      if (lookahead == 'z') ADVANCE(2638);
      END_STATE();
    case 3088:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(3093);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3159);
      END_STATE();
    case 3089:
      if (lookahead == 'H' ||
          ('K' <= lookahead && lookahead <= 'M') ||
          lookahead == 'R') ADVANCE(3095);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(3153);
      END_STATE();
    case 3090:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3141);
      END_STATE();
    case 3091:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3119);
      END_STATE();
    case 3092:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3339);
      END_STATE();
    case 3093:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3159);
      END_STATE();
    case 3094:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3150);
      END_STATE();
    case 3095:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(3153);
      END_STATE();
    case 3096:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3249);
      END_STATE();
    case 3097:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3242);
      END_STATE();
    case 3098:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3245);
      END_STATE();
    case 3099:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3273);
      END_STATE();
    case 3100:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3246);
      END_STATE();
    case 3101:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3247);
      END_STATE();
    case 3102:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3248);
      END_STATE();
    case 3103:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3284);
      END_STATE();
    case 3104:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3244);
      END_STATE();
    case 3105:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3243);
      END_STATE();
    case 3106:
      if (eof) ADVANCE(3117);
      ADVANCE_MAP(
        '!', 3907,
        '"', 13,
        '#', 3091,
        '$', 22,
        '%', 23,
        '(', 3359,
        ')', 3360,
        '*', 3288,
        ',', 3350,
        '.', 60,
        '0', 3140,
        ':', 3631,
        ';', 3118,
        '<', 3348,
        '=', 3164,
        '>', 3349,
        '@', 24,
        '[', 3345,
        ']', 3346,
        '^', 25,
        'a', 1347,
        'b', 2055,
        'c', 29,
        'd', 1381,
        'e', 2309,
        'f', 1352,
        'g', 1590,
        'h', 1405,
        'i', 1674,
        'j', 3003,
        'l', 1353,
        'm', 1382,
        'n', 1355,
        'o', 1884,
        'p', 1377,
        'r', 1801,
        's', 71,
        't', 1360,
        'u', 82,
        'v', 1362,
        'w', 1802,
        'x', 3354,
        'z', 1890,
        '{', 3341,
        '|', 4652,
        '}', 3342,
        '+', 3090,
        '-', 3090,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3106);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3141);
      END_STATE();
    case 3107:
      if (eof) ADVANCE(3117);
      ADVANCE_MAP(
        '!', 3907,
        '"', 13,
        '#', 3091,
        '$', 22,
        '%', 23,
        '(', 3359,
        ')', 3360,
        '*', 3288,
        ',', 3350,
        '.', 60,
        '0', 3148,
        ';', 3118,
        '<', 3348,
        '=', 3164,
        '>', 3349,
        '@', 24,
        '[', 3345,
        ']', 3346,
        '^', 25,
        'a', 1584,
        'b', 2057,
        'c', 1533,
        'd', 1888,
        'e', 2310,
        'f', 1513,
        'g', 1591,
        'h', 1408,
        'i', 2065,
        'j', 3003,
        'l', 1426,
        'm', 1799,
        'n', 1491,
        'o', 2662,
        'p', 1380,
        'r', 1896,
        's', 76,
        't', 1537,
        'u', 92,
        'v', 2572,
        'w', 1968,
        'x', 119,
        'z', 2011,
        '{', 3341,
        '}', 3342,
        '+', 3094,
        '-', 3094,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3107);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3150);
      END_STATE();
    case 3108:
      if (eof) ADVANCE(3117);
      ADVANCE_MAP(
        '!', 3907,
        '"', 13,
        '#', 3091,
        '$', 22,
        '%', 23,
        '(', 3359,
        ')', 3360,
        '*', 3288,
        ',', 3350,
        '0', 3140,
        ';', 3118,
        '<', 3348,
        '=', 3164,
        '>', 3349,
        '@', 24,
        '[', 3345,
        ']', 3346,
        '^', 25,
        'a', 1713,
        'b', 2056,
        'c', 33,
        'd', 1797,
        'e', 2314,
        'f', 1479,
        'g', 1589,
        'h', 1407,
        'i', 1678,
        'j', 3003,
        'l', 1424,
        'm', 1385,
        'n', 1356,
        'o', 2663,
        'p', 1379,
        'r', 1903,
        's', 73,
        't', 1538,
        'u', 87,
        'v', 2604,
        'w', 1964,
        'x', 120,
        'z', 1890,
        '{', 3341,
        '}', 3342,
        '+', 3090,
        '-', 3090,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3108);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3141);
      END_STATE();
    case 3109:
      if (eof) ADVANCE(3117);
      ADVANCE_MAP(
        '!', 3907,
        '"', 13,
        '$', 22,
        '%', 23,
        '(', 3359,
        ')', 3360,
        '*', 3288,
        ',', 3350,
        '0', 3140,
        ';', 3118,
        '<', 3348,
        '>', 3349,
        '@', 24,
        '[', 3345,
        ']', 3346,
        '^', 25,
        'a', 1583,
        'b', 2054,
        'c', 34,
        'd', 1880,
        'e', 2695,
        'f', 1374,
        'g', 1898,
        'h', 1406,
        'i', 1681,
        'l', 1425,
        'm', 1388,
        'n', 1474,
        'o', 2676,
        'p', 2577,
        'r', 1881,
        's', 79,
        't', 1538,
        'u', 83,
        'v', 2603,
        'w', 1965,
        'x', 120,
        'z', 1992,
        '{', 3341,
        '}', 3342,
        '+', 3090,
        '-', 3090,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3109);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3141);
      END_STATE();
    case 3110:
      if (eof) ADVANCE(3117);
      ADVANCE_MAP(
        '!', 21,
        '"', 13,
        '#', 3091,
        '$', 22,
        '%', 23,
        '(', 3909,
        ',', 3350,
        ';', 3118,
        '<', 3348,
        '@', 24,
        '[', 3345,
        ']', 3346,
        '^', 25,
        'a', 2052,
        'b', 2057,
        'c', 2586,
        'd', 1887,
        'e', 2308,
        'f', 1393,
        'g', 1588,
        'h', 1408,
        'i', 2434,
        'j', 3003,
        'l', 1422,
        'm', 1800,
        'n', 1492,
        'o', 1885,
        'p', 1380,
        'r', 1903,
        's', 1371,
        't', 1539,
        'u', 1897,
        'v', 2604,
        'w', 2199,
        'x', 119,
        'z', 2011,
        '{', 3341,
        '}', 3342,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3112);
      END_STATE();
    case 3111:
      if (eof) ADVANCE(3117);
      ADVANCE_MAP(
        '!', 21,
        '"', 13,
        '#', 3091,
        '$', 22,
        '%', 23,
        '(', 3359,
        ')', 3360,
        '*', 3288,
        ',', 3350,
        '0', 3140,
        ';', 3118,
        '<', 3348,
        '@', 24,
        '[', 3345,
        '^', 25,
        'a', 1795,
        'b', 2055,
        'c', 32,
        'd', 1797,
        'e', 2313,
        'f', 1373,
        'g', 1589,
        'h', 1407,
        'i', 1677,
        'j', 3003,
        'l', 1354,
        'm', 1384,
        'n', 1357,
        'o', 2663,
        'p', 1378,
        'r', 1878,
        's', 72,
        't', 1361,
        'u', 85,
        'v', 1363,
        'w', 1964,
        'x', 120,
        'z', 1890,
        '{', 3341,
        '}', 3342,
        '+', 3090,
        '-', 3090,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3111);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3141);
      END_STATE();
    case 3112:
      if (eof) ADVANCE(3117);
      ADVANCE_MAP(
        '!', 21,
        '"', 13,
        '#', 3091,
        '$', 22,
        '%', 23,
        ',', 3350,
        ';', 3118,
        '<', 3348,
        '@', 24,
        '[', 3345,
        ']', 3346,
        '^', 25,
        'a', 2052,
        'b', 2057,
        'c', 2586,
        'd', 1887,
        'e', 2308,
        'f', 1393,
        'g', 1588,
        'h', 1408,
        'i', 2434,
        'j', 3003,
        'l', 1422,
        'm', 1800,
        'n', 1492,
        'o', 1885,
        'p', 1380,
        'r', 1903,
        's', 1371,
        't', 1539,
        'u', 1897,
        'v', 2604,
        'w', 2199,
        'x', 119,
        'z', 2011,
        '{', 3341,
        '}', 3342,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3112);
      END_STATE();
    case 3113:
      if (eof) ADVANCE(3117);
      ADVANCE_MAP(
        '!', 21,
        '"', 13,
        '$', 22,
        '%', 23,
        '(', 3909,
        ')', 3360,
        ',', 3350,
        '0', 3148,
        ';', 3118,
        '<', 3348,
        '=', 3164,
        '>', 3349,
        '@', 24,
        '[', 3345,
        ']', 3346,
        '^', 25,
        'a', 1348,
        'b', 2057,
        'c', 1587,
        'd', 1797,
        'e', 2312,
        'f', 1457,
        'g', 2124,
        'h', 1405,
        'i', 2433,
        'j', 3003,
        'l', 1423,
        'm', 1798,
        'n', 1493,
        'o', 2662,
        'p', 2664,
        'r', 1896,
        's', 78,
        't', 1480,
        'u', 92,
        'v', 2604,
        'w', 1803,
        'x', 116,
        'z', 2011,
        '{', 3341,
        '}', 3342,
        '+', 3094,
        '-', 3094,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3116);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3150);
      END_STATE();
    case 3114:
      if (eof) ADVANCE(3117);
      ADVANCE_MAP(
        '!', 21,
        '"', 13,
        '$', 22,
        '%', 23,
        '(', 3359,
        ')', 3360,
        ',', 3350,
        '0', 3148,
        ';', 3118,
        '<', 3348,
        '>', 3349,
        '@', 24,
        '[', 3345,
        ']', 3346,
        '^', 25,
        'a', 1349,
        'b', 2057,
        'c', 1586,
        'd', 1797,
        'e', 2312,
        'f', 1400,
        'g', 2124,
        'h', 1405,
        'i', 2433,
        'j', 3003,
        'l', 1423,
        'm', 1383,
        'n', 1359,
        'o', 2663,
        'p', 2664,
        'r', 1877,
        's', 77,
        't', 1480,
        'u', 91,
        'v', 2572,
        'w', 1803,
        'x', 117,
        'z', 2011,
        '{', 3341,
        '}', 3342,
        '+', 3094,
        '-', 3094,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3114);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3150);
      END_STATE();
    case 3115:
      if (eof) ADVANCE(3117);
      ADVANCE_MAP(
        '!', 21,
        '"', 13,
        '$', 22,
        '%', 23,
        ')', 3360,
        '*', 3288,
        ',', 3350,
        '0', 3140,
        ';', 3118,
        '<', 3348,
        '>', 3349,
        '@', 24,
        '[', 3345,
        ']', 3346,
        '^', 25,
        'a', 1585,
        'b', 2054,
        'c', 34,
        'd', 1880,
        'e', 3051,
        'f', 1374,
        'g', 1898,
        'h', 1406,
        'i', 1680,
        'l', 1425,
        'm', 1388,
        'n', 1475,
        'o', 2676,
        'p', 2577,
        'r', 1987,
        's', 80,
        't', 1538,
        'u', 86,
        'v', 2603,
        'w', 1963,
        'x', 120,
        'z', 1992,
        '{', 3341,
        '}', 3342,
        '+', 3090,
        '-', 3090,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3115);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3141);
      END_STATE();
    case 3116:
      if (eof) ADVANCE(3117);
      ADVANCE_MAP(
        '!', 21,
        '"', 13,
        '$', 22,
        '%', 23,
        ')', 3360,
        ',', 3350,
        '0', 3148,
        ';', 3118,
        '<', 3348,
        '=', 3164,
        '>', 3349,
        '@', 24,
        '[', 3345,
        ']', 3346,
        '^', 25,
        'a', 1348,
        'b', 2057,
        'c', 1587,
        'd', 1797,
        'e', 2312,
        'f', 1457,
        'g', 2124,
        'h', 1405,
        'i', 2433,
        'j', 3003,
        'l', 1423,
        'm', 1798,
        'n', 1493,
        'o', 2662,
        'p', 2664,
        'r', 1896,
        's', 78,
        't', 1480,
        'u', 92,
        'v', 2604,
        'w', 1803,
        'x', 116,
        'z', 2011,
        '{', 3341,
        '}', 3342,
        '+', 3094,
        '-', 3094,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3116);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(3150);
      END_STATE();
    case 3117:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 3118:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(3118);
      END_STATE();
    case 3119:
      ACCEPT_TOKEN(sym_attr_ref);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3119);
      END_STATE();
    case 3120:
      ACCEPT_TOKEN(sym_comdat_ref);
      END_STATE();
    case 3121:
      ACCEPT_TOKEN(sym_comdat_ref);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3121);
      END_STATE();
    case 3122:
      ACCEPT_TOKEN(sym_comdat_ref);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3122);
      END_STATE();
    case 3123:
      ACCEPT_TOKEN(sym_global_var);
      END_STATE();
    case 3124:
      ACCEPT_TOKEN(sym_global_var);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3124);
      END_STATE();
    case 3125:
      ACCEPT_TOKEN(sym_global_var);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3125);
      END_STATE();
    case 3126:
      ACCEPT_TOKEN(sym_local_var);
      END_STATE();
    case 3127:
      ACCEPT_TOKEN(sym_local_var);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3127);
      END_STATE();
    case 3128:
      ACCEPT_TOKEN(sym_local_var);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3128);
      END_STATE();
    case 3129:
      ACCEPT_TOKEN(sym_label);
      END_STATE();
    case 3130:
      ACCEPT_TOKEN(aux_sym_metadata_ref_token1);
      END_STATE();
    case 3131:
      ACCEPT_TOKEN(aux_sym_metadata_ref_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3131);
      END_STATE();
    case 3132:
      ACCEPT_TOKEN(aux_sym_metadata_ref_token1);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3132);
      END_STATE();
    case 3133:
      ACCEPT_TOKEN(sym_summary_ref);
      END_STATE();
    case 3134:
      ACCEPT_TOKEN(sym_summary_ref);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3134);
      END_STATE();
    case 3135:
      ACCEPT_TOKEN(sym_summary_ref);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3135);
      END_STATE();
    case 3136:
      ACCEPT_TOKEN(sym_string);
      END_STATE();
    case 3137:
      ACCEPT_TOKEN(sym_string);
      if (lookahead == ':') ADVANCE(3129);
      END_STATE();
    case 3138:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == '.') ADVANCE(3157);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'x') ADVANCE(3089);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3139);
      END_STATE();
    case 3139:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == '.') ADVANCE(3157);
      if (lookahead == ':') ADVANCE(3129);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3139);
      END_STATE();
    case 3140:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == '.') ADVANCE(3157);
      if (lookahead == 'x') ADVANCE(3089);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3141);
      END_STATE();
    case 3141:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == '.') ADVANCE(3157);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3141);
      END_STATE();
    case 3142:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == '.') ADVANCE(3155);
      if (lookahead == ':') ADVANCE(3129);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3142);
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3143:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == '.') ADVANCE(3158);
      if (lookahead == 'x') ADVANCE(4645);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3144);
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3144:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == '.') ADVANCE(3158);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3144);
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3145:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'x') ADVANCE(3089);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3146);
      END_STATE();
    case 3146:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == ':') ADVANCE(3129);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3146);
      END_STATE();
    case 3147:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == ':') ADVANCE(3129);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3147);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3148:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == 'x') ADVANCE(3089);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3150);
      END_STATE();
    case 3149:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == 'x') ADVANCE(4645);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3151);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3150:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3150);
      END_STATE();
    case 3151:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3151);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3152:
      ACCEPT_TOKEN(aux_sym_number_token2);
      if (lookahead == ':') ADVANCE(3129);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(3152);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3153:
      ACCEPT_TOKEN(aux_sym_number_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(3153);
      END_STATE();
    case 3154:
      ACCEPT_TOKEN(aux_sym_number_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(3154);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3155:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3155);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3156:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == ':') ADVANCE(3129);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3156);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3157:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(3088);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3157);
      END_STATE();
    case 3158:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(3911);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3158);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3159:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3159);
      END_STATE();
    case 3160:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3160);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3161:
      ACCEPT_TOKEN(sym_cstring);
      END_STATE();
    case 3162:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 3163:
      ACCEPT_TOKEN(anon_sym_triple);
      END_STATE();
    case 3164:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 3165:
      ACCEPT_TOKEN(anon_sym_datalayout);
      END_STATE();
    case 3166:
      ACCEPT_TOKEN(anon_sym_source_filename);
      END_STATE();
    case 3167:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 3168:
      ACCEPT_TOKEN(anon_sym_define);
      END_STATE();
    case 3169:
      ACCEPT_TOKEN(anon_sym_no_cfi);
      END_STATE();
    case 3170:
      ACCEPT_TOKEN(anon_sym_no_cfi);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3171:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 3172:
      ACCEPT_TOKEN(anon_sym_private);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3173:
      ACCEPT_TOKEN(anon_sym_private);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3174:
      ACCEPT_TOKEN(anon_sym_internal);
      END_STATE();
    case 3175:
      ACCEPT_TOKEN(anon_sym_internal);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3176:
      ACCEPT_TOKEN(anon_sym_internal);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3177:
      ACCEPT_TOKEN(anon_sym_weak);
      END_STATE();
    case 3178:
      ACCEPT_TOKEN(anon_sym_weak);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(925);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3179:
      ACCEPT_TOKEN(anon_sym_weak);
      if (lookahead == '_') ADVANCE(4411);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3180:
      ACCEPT_TOKEN(anon_sym_weak);
      if (lookahead == '_') ADVANCE(2596);
      END_STATE();
    case 3181:
      ACCEPT_TOKEN(anon_sym_weak_odr);
      END_STATE();
    case 3182:
      ACCEPT_TOKEN(anon_sym_weak_odr);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3183:
      ACCEPT_TOKEN(anon_sym_weak_odr);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3184:
      ACCEPT_TOKEN(anon_sym_linkonce);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(946);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3185:
      ACCEPT_TOKEN(anon_sym_linkonce);
      if (lookahead == '_') ADVANCE(4426);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3186:
      ACCEPT_TOKEN(anon_sym_linkonce);
      if (lookahead == '_') ADVANCE(2623);
      END_STATE();
    case 3187:
      ACCEPT_TOKEN(anon_sym_linkonce_odr);
      END_STATE();
    case 3188:
      ACCEPT_TOKEN(anon_sym_linkonce_odr);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3189:
      ACCEPT_TOKEN(anon_sym_linkonce_odr);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3190:
      ACCEPT_TOKEN(anon_sym_available_externally);
      END_STATE();
    case 3191:
      ACCEPT_TOKEN(anon_sym_available_externally);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3192:
      ACCEPT_TOKEN(anon_sym_available_externally);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3193:
      ACCEPT_TOKEN(anon_sym_appending);
      END_STATE();
    case 3194:
      ACCEPT_TOKEN(anon_sym_appending);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3195:
      ACCEPT_TOKEN(anon_sym_appending);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3196:
      ACCEPT_TOKEN(anon_sym_common);
      END_STATE();
    case 3197:
      ACCEPT_TOKEN(anon_sym_common);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3198:
      ACCEPT_TOKEN(anon_sym_common);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3199:
      ACCEPT_TOKEN(anon_sym_extern_weak);
      END_STATE();
    case 3200:
      ACCEPT_TOKEN(anon_sym_extern_weak);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3201:
      ACCEPT_TOKEN(anon_sym_extern_weak);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3202:
      ACCEPT_TOKEN(anon_sym_external);
      END_STATE();
    case 3203:
      ACCEPT_TOKEN(anon_sym_external);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3204:
      ACCEPT_TOKEN(anon_sym_external);
      if (lookahead == 'l') ADVANCE(3066);
      END_STATE();
    case 3205:
      ACCEPT_TOKEN(anon_sym_external);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3206:
      ACCEPT_TOKEN(anon_sym_dso_local);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(516);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3207:
      ACCEPT_TOKEN(anon_sym_dso_local);
      if (lookahead == '_') ADVANCE(1995);
      END_STATE();
    case 3208:
      ACCEPT_TOKEN(anon_sym_dso_local_equivalent);
      END_STATE();
    case 3209:
      ACCEPT_TOKEN(anon_sym_dso_local_equivalent);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3210:
      ACCEPT_TOKEN(anon_sym_dso_preemptable);
      END_STATE();
    case 3211:
      ACCEPT_TOKEN(anon_sym_dso_preemptable);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3212:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 3213:
      ACCEPT_TOKEN(anon_sym_default);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3214:
      ACCEPT_TOKEN(anon_sym_hidden);
      END_STATE();
    case 3215:
      ACCEPT_TOKEN(anon_sym_hidden);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3216:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 3217:
      ACCEPT_TOKEN(anon_sym_protected);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3218:
      ACCEPT_TOKEN(anon_sym_dllimport);
      END_STATE();
    case 3219:
      ACCEPT_TOKEN(anon_sym_dllimport);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3220:
      ACCEPT_TOKEN(anon_sym_dllexport);
      END_STATE();
    case 3221:
      ACCEPT_TOKEN(anon_sym_dllexport);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3222:
      ACCEPT_TOKEN(anon_sym_ccc);
      END_STATE();
    case 3223:
      ACCEPT_TOKEN(anon_sym_fastcc);
      END_STATE();
    case 3224:
      ACCEPT_TOKEN(anon_sym_coldcc);
      END_STATE();
    case 3225:
      ACCEPT_TOKEN(anon_sym_webkit_jscc);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3253);
      END_STATE();
    case 3226:
      ACCEPT_TOKEN(anon_sym_anyregcc);
      END_STATE();
    case 3227:
      ACCEPT_TOKEN(anon_sym_preserve_mostcc);
      END_STATE();
    case 3228:
      ACCEPT_TOKEN(anon_sym_preserve_allcc);
      END_STATE();
    case 3229:
      ACCEPT_TOKEN(anon_sym_cxx_fast_tlscc);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3283);
      END_STATE();
    case 3230:
      ACCEPT_TOKEN(anon_sym_tailcc);
      END_STATE();
    case 3231:
      ACCEPT_TOKEN(anon_sym_swiftcc);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 3232:
      ACCEPT_TOKEN(anon_sym_swifttailcc);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 3233:
      ACCEPT_TOKEN(anon_sym_cfguard_checkcc);
      END_STATE();
    case 3234:
      ACCEPT_TOKEN(aux_sym_calling_conv_token1);
      if (lookahead == '0') ADVANCE(3306);
      if (('1' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3241);
      END_STATE();
    case 3235:
      ACCEPT_TOKEN(aux_sym_calling_conv_token1);
      if (lookahead == '8') ADVANCE(3234);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3241);
      END_STATE();
    case 3236:
      ACCEPT_TOKEN(aux_sym_calling_conv_token1);
      if (lookahead == 'm') ADVANCE(3239);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3241);
      END_STATE();
    case 3237:
      ACCEPT_TOKEN(aux_sym_calling_conv_token1);
      if (lookahead == 'm') ADVANCE(3240);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3241);
      END_STATE();
    case 3238:
      ACCEPT_TOKEN(aux_sym_calling_conv_token1);
      if (lookahead == 'p') ADVANCE(3235);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3241);
      END_STATE();
    case 3239:
      ACCEPT_TOKEN(aux_sym_calling_conv_token1);
      if (lookahead == 'x') ADVANCE(3326);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3241);
      END_STATE();
    case 3240:
      ACCEPT_TOKEN(aux_sym_calling_conv_token1);
      if (lookahead == 'x') ADVANCE(3322);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3241);
      END_STATE();
    case 3241:
      ACCEPT_TOKEN(aux_sym_calling_conv_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3241);
      END_STATE();
    case 3242:
      ACCEPT_TOKEN(aux_sym_calling_conv_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3242);
      END_STATE();
    case 3243:
      ACCEPT_TOKEN(aux_sym_calling_conv_token3);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3243);
      END_STATE();
    case 3244:
      ACCEPT_TOKEN(aux_sym_calling_conv_token4);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3244);
      END_STATE();
    case 3245:
      ACCEPT_TOKEN(aux_sym_calling_conv_token5);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3245);
      END_STATE();
    case 3246:
      ACCEPT_TOKEN(aux_sym_calling_conv_token6);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3246);
      END_STATE();
    case 3247:
      ACCEPT_TOKEN(aux_sym_calling_conv_token7);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3247);
      END_STATE();
    case 3248:
      ACCEPT_TOKEN(aux_sym_calling_conv_token8);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3248);
      END_STATE();
    case 3249:
      ACCEPT_TOKEN(aux_sym_calling_conv_token9);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3249);
      END_STATE();
    case 3250:
      ACCEPT_TOKEN(aux_sym_calling_conv_token10);
      if (lookahead == 'c') ADVANCE(3225);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3253);
      END_STATE();
    case 3251:
      ACCEPT_TOKEN(aux_sym_calling_conv_token10);
      if (lookahead == 'c') ADVANCE(3250);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3253);
      END_STATE();
    case 3252:
      ACCEPT_TOKEN(aux_sym_calling_conv_token10);
      if (lookahead == 's') ADVANCE(3251);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3253);
      END_STATE();
    case 3253:
      ACCEPT_TOKEN(aux_sym_calling_conv_token10);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3253);
      END_STATE();
    case 3254:
      ACCEPT_TOKEN(anon_sym_ghccc);
      END_STATE();
    case 3255:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'a') ADVANCE(3262);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 3256:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'c') ADVANCE(3231);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 3257:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'c') ADVANCE(3606);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 3258:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'c') ADVANCE(3232);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 3259:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'c') ADVANCE(3258);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 3260:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'e') ADVANCE(3263);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 3261:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'f') ADVANCE(3602);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 3262:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'i') ADVANCE(3264);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 3263:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'l') ADVANCE(3261);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 3264:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'l') ADVANCE(3259);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 3265:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'n') ADVANCE(3257);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 3266:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'o') ADVANCE(3268);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 3267:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'r') ADVANCE(3266);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 3268:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'r') ADVANCE(3610);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 3269:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'r') ADVANCE(3267);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 3270:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 's') ADVANCE(3271);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 3271:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (lookahead == 'y') ADVANCE(3265);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 3272:
      ACCEPT_TOKEN(aux_sym_calling_conv_token11);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 3273:
      ACCEPT_TOKEN(aux_sym_calling_conv_token12);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3273);
      END_STATE();
    case 3274:
      ACCEPT_TOKEN(aux_sym_calling_conv_token13);
      if (lookahead == '_') ADVANCE(3282);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3283);
      END_STATE();
    case 3275:
      ACCEPT_TOKEN(aux_sym_calling_conv_token13);
      if (lookahead == 'a') ADVANCE(3279);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(3283);
      END_STATE();
    case 3276:
      ACCEPT_TOKEN(aux_sym_calling_conv_token13);
      if (lookahead == 'c') ADVANCE(3229);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3283);
      END_STATE();
    case 3277:
      ACCEPT_TOKEN(aux_sym_calling_conv_token13);
      if (lookahead == 'c') ADVANCE(3276);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3283);
      END_STATE();
    case 3278:
      ACCEPT_TOKEN(aux_sym_calling_conv_token13);
      if (lookahead == 'l') ADVANCE(3280);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3283);
      END_STATE();
    case 3279:
      ACCEPT_TOKEN(aux_sym_calling_conv_token13);
      if (lookahead == 's') ADVANCE(3281);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3283);
      END_STATE();
    case 3280:
      ACCEPT_TOKEN(aux_sym_calling_conv_token13);
      if (lookahead == 's') ADVANCE(3277);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3283);
      END_STATE();
    case 3281:
      ACCEPT_TOKEN(aux_sym_calling_conv_token13);
      if (lookahead == 't') ADVANCE(3274);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3283);
      END_STATE();
    case 3282:
      ACCEPT_TOKEN(aux_sym_calling_conv_token13);
      if (lookahead == 't') ADVANCE(3278);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3283);
      END_STATE();
    case 3283:
      ACCEPT_TOKEN(aux_sym_calling_conv_token13);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3283);
      END_STATE();
    case 3284:
      ACCEPT_TOKEN(aux_sym_calling_conv_token14);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3284);
      END_STATE();
    case 3285:
      ACCEPT_TOKEN(anon_sym_cc);
      if (lookahead == 'c') ADVANCE(3222);
      END_STATE();
    case 3286:
      ACCEPT_TOKEN(anon_sym_unnamed_addr);
      END_STATE();
    case 3287:
      ACCEPT_TOKEN(anon_sym_local_unnamed_addr);
      END_STATE();
    case 3288:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 3289:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 3290:
      ACCEPT_TOKEN(anon_sym_void);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3291:
      ACCEPT_TOKEN(anon_sym_void);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3292:
      ACCEPT_TOKEN(anon_sym_half);
      END_STATE();
    case 3293:
      ACCEPT_TOKEN(anon_sym_half);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3294:
      ACCEPT_TOKEN(anon_sym_half);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3295:
      ACCEPT_TOKEN(anon_sym_bfloat);
      END_STATE();
    case 3296:
      ACCEPT_TOKEN(anon_sym_bfloat);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3297:
      ACCEPT_TOKEN(anon_sym_bfloat);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3298:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 3299:
      ACCEPT_TOKEN(anon_sym_float);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3300:
      ACCEPT_TOKEN(anon_sym_float);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3301:
      ACCEPT_TOKEN(anon_sym_double);
      END_STATE();
    case 3302:
      ACCEPT_TOKEN(anon_sym_double);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3303:
      ACCEPT_TOKEN(anon_sym_double);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3304:
      ACCEPT_TOKEN(anon_sym_x86_fp80);
      END_STATE();
    case 3305:
      ACCEPT_TOKEN(anon_sym_x86_fp80);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3306:
      ACCEPT_TOKEN(anon_sym_x86_fp80);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3241);
      END_STATE();
    case 3307:
      ACCEPT_TOKEN(anon_sym_x86_fp80);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3308:
      ACCEPT_TOKEN(anon_sym_fp128);
      END_STATE();
    case 3309:
      ACCEPT_TOKEN(anon_sym_fp128);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3310:
      ACCEPT_TOKEN(anon_sym_fp128);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3311:
      ACCEPT_TOKEN(anon_sym_ppc_fp128);
      END_STATE();
    case 3312:
      ACCEPT_TOKEN(anon_sym_ppc_fp128);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3313:
      ACCEPT_TOKEN(anon_sym_ppc_fp128);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3314:
      ACCEPT_TOKEN(anon_sym_label);
      END_STATE();
    case 3315:
      ACCEPT_TOKEN(anon_sym_label);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3316:
      ACCEPT_TOKEN(anon_sym_label);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3317:
      ACCEPT_TOKEN(anon_sym_metadata);
      END_STATE();
    case 3318:
      ACCEPT_TOKEN(anon_sym_metadata);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3319:
      ACCEPT_TOKEN(anon_sym_metadata);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3320:
      ACCEPT_TOKEN(anon_sym_x86_mmx);
      END_STATE();
    case 3321:
      ACCEPT_TOKEN(anon_sym_x86_mmx);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3322:
      ACCEPT_TOKEN(anon_sym_x86_mmx);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3241);
      END_STATE();
    case 3323:
      ACCEPT_TOKEN(anon_sym_x86_mmx);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3324:
      ACCEPT_TOKEN(anon_sym_x86_amx);
      END_STATE();
    case 3325:
      ACCEPT_TOKEN(anon_sym_x86_amx);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3326:
      ACCEPT_TOKEN(anon_sym_x86_amx);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3241);
      END_STATE();
    case 3327:
      ACCEPT_TOKEN(anon_sym_x86_amx);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3328:
      ACCEPT_TOKEN(anon_sym_token);
      END_STATE();
    case 3329:
      ACCEPT_TOKEN(anon_sym_token);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3330:
      ACCEPT_TOKEN(anon_sym_token);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3331:
      ACCEPT_TOKEN(anon_sym_opaque);
      END_STATE();
    case 3332:
      ACCEPT_TOKEN(anon_sym_opaque);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3333:
      ACCEPT_TOKEN(anon_sym_opaque);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3334:
      ACCEPT_TOKEN(anon_sym_ptr);
      END_STATE();
    case 3335:
      ACCEPT_TOKEN(anon_sym_ptr);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 't') ADVANCE(957);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3336:
      ACCEPT_TOKEN(anon_sym_ptr);
      if (lookahead == 't') ADVANCE(2639);
      END_STATE();
    case 3337:
      ACCEPT_TOKEN(anon_sym_ptr);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3338:
      ACCEPT_TOKEN(aux_sym_type_keyword_token1);
      if (lookahead == ':') ADVANCE(3129);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3338);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3339:
      ACCEPT_TOKEN(aux_sym_type_keyword_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3339);
      END_STATE();
    case 3340:
      ACCEPT_TOKEN(aux_sym_type_keyword_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3340);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3341:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 3342:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 3343:
      ACCEPT_TOKEN(anon_sym_LT_LBRACE);
      END_STATE();
    case 3344:
      ACCEPT_TOKEN(anon_sym_RBRACE_GT);
      END_STATE();
    case 3345:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 3346:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 3347:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 3348:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '{') ADVANCE(3343);
      END_STATE();
    case 3349:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 3350:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 3351:
      ACCEPT_TOKEN(anon_sym_vscale);
      END_STATE();
    case 3352:
      ACCEPT_TOKEN(anon_sym_vscale);
      if (lookahead == '_') ADVANCE(2774);
      END_STATE();
    case 3353:
      ACCEPT_TOKEN(anon_sym_x);
      END_STATE();
    case 3354:
      ACCEPT_TOKEN(anon_sym_x);
      if (lookahead == 'c') ADVANCE(2136);
      END_STATE();
    case 3355:
      ACCEPT_TOKEN(anon_sym_addrspace);
      END_STATE();
    case 3356:
      ACCEPT_TOKEN(anon_sym_addrspace);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'c') ADVANCE(234);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3357:
      ACCEPT_TOKEN(anon_sym_addrspace);
      if (lookahead == 'c') ADVANCE(1498);
      END_STATE();
    case 3358:
      ACCEPT_TOKEN(anon_sym_addrspace);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3359:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 3360:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 3361:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 3362:
      ACCEPT_TOKEN(anon_sym_align);
      END_STATE();
    case 3363:
      ACCEPT_TOKEN(anon_sym_align);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(1200);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3364:
      ACCEPT_TOKEN(anon_sym_align);
      if (lookahead == 's') ADVANCE(4561);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3365:
      ACCEPT_TOKEN(anon_sym_align);
      if (lookahead == 's') ADVANCE(2948);
      END_STATE();
    case 3366:
      ACCEPT_TOKEN(anon_sym_section);
      END_STATE();
    case 3367:
      ACCEPT_TOKEN(anon_sym_section);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3368:
      ACCEPT_TOKEN(anon_sym_partition);
      END_STATE();
    case 3369:
      ACCEPT_TOKEN(anon_sym_partition);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3370:
      ACCEPT_TOKEN(anon_sym_comdat);
      END_STATE();
    case 3371:
      ACCEPT_TOKEN(anon_sym_comdat);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3372:
      ACCEPT_TOKEN(anon_sym_gc);
      END_STATE();
    case 3373:
      ACCEPT_TOKEN(anon_sym_gc);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3374:
      ACCEPT_TOKEN(anon_sym_prefix);
      END_STATE();
    case 3375:
      ACCEPT_TOKEN(anon_sym_prefix);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3376:
      ACCEPT_TOKEN(anon_sym_prologue);
      END_STATE();
    case 3377:
      ACCEPT_TOKEN(anon_sym_prologue);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3378:
      ACCEPT_TOKEN(anon_sym_personality);
      END_STATE();
    case 3379:
      ACCEPT_TOKEN(anon_sym_personality);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3380:
      ACCEPT_TOKEN(anon_sym_alignstack);
      END_STATE();
    case 3381:
      ACCEPT_TOKEN(anon_sym_alignstack);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3382:
      ACCEPT_TOKEN(anon_sym_alignstack);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3383:
      ACCEPT_TOKEN(anon_sym_allocsize);
      END_STATE();
    case 3384:
      ACCEPT_TOKEN(anon_sym_allocsize);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3385:
      ACCEPT_TOKEN(anon_sym_allocsize);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3386:
      ACCEPT_TOKEN(anon_sym_alwaysinline);
      END_STATE();
    case 3387:
      ACCEPT_TOKEN(anon_sym_alwaysinline);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3388:
      ACCEPT_TOKEN(anon_sym_alwaysinline);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3389:
      ACCEPT_TOKEN(anon_sym_builtin);
      END_STATE();
    case 3390:
      ACCEPT_TOKEN(anon_sym_builtin);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3391:
      ACCEPT_TOKEN(anon_sym_builtin);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3392:
      ACCEPT_TOKEN(anon_sym_cold);
      END_STATE();
    case 3393:
      ACCEPT_TOKEN(anon_sym_cold);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3394:
      ACCEPT_TOKEN(anon_sym_cold);
      if (lookahead == 'c') ADVANCE(1599);
      END_STATE();
    case 3395:
      ACCEPT_TOKEN(anon_sym_cold);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3396:
      ACCEPT_TOKEN(anon_sym_convergent);
      END_STATE();
    case 3397:
      ACCEPT_TOKEN(anon_sym_convergent);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3398:
      ACCEPT_TOKEN(anon_sym_convergent);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3399:
      ACCEPT_TOKEN(anon_sym_disable_sanitizer_instrumentation);
      END_STATE();
    case 3400:
      ACCEPT_TOKEN(anon_sym_disable_sanitizer_instrumentation);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3401:
      ACCEPT_TOKEN(anon_sym_disable_sanitizer_instrumentation);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3402:
      ACCEPT_TOKEN(anon_sym_hot);
      END_STATE();
    case 3403:
      ACCEPT_TOKEN(anon_sym_hot);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3404:
      ACCEPT_TOKEN(anon_sym_hot);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3405:
      ACCEPT_TOKEN(anon_sym_inaccessiblememonly);
      END_STATE();
    case 3406:
      ACCEPT_TOKEN(anon_sym_inaccessiblememonly);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3407:
      ACCEPT_TOKEN(anon_sym_inaccessiblememonly);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3408:
      ACCEPT_TOKEN(anon_sym_inaccessiblemem_or_argmemonly);
      END_STATE();
    case 3409:
      ACCEPT_TOKEN(anon_sym_inaccessiblemem_or_argmemonly);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3410:
      ACCEPT_TOKEN(anon_sym_inaccessiblemem_or_argmemonly);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3411:
      ACCEPT_TOKEN(anon_sym_inlinehint);
      END_STATE();
    case 3412:
      ACCEPT_TOKEN(anon_sym_inlinehint);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3413:
      ACCEPT_TOKEN(anon_sym_inlinehint);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3414:
      ACCEPT_TOKEN(anon_sym_jumptable);
      END_STATE();
    case 3415:
      ACCEPT_TOKEN(anon_sym_jumptable);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3416:
      ACCEPT_TOKEN(anon_sym_jumptable);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3417:
      ACCEPT_TOKEN(anon_sym_minsize);
      END_STATE();
    case 3418:
      ACCEPT_TOKEN(anon_sym_minsize);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3419:
      ACCEPT_TOKEN(anon_sym_minsize);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3420:
      ACCEPT_TOKEN(anon_sym_naked);
      END_STATE();
    case 3421:
      ACCEPT_TOKEN(anon_sym_naked);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3422:
      ACCEPT_TOKEN(anon_sym_naked);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3423:
      ACCEPT_TOKEN(anon_sym_no_DASHjump_DASHtables);
      END_STATE();
    case 3424:
      ACCEPT_TOKEN(anon_sym_no_DASHjump_DASHtables);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3425:
      ACCEPT_TOKEN(anon_sym_no_DASHjump_DASHtables);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3426:
      ACCEPT_TOKEN(anon_sym_nobuiltin);
      END_STATE();
    case 3427:
      ACCEPT_TOKEN(anon_sym_nobuiltin);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3428:
      ACCEPT_TOKEN(anon_sym_nobuiltin);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3429:
      ACCEPT_TOKEN(anon_sym_noduplicate);
      END_STATE();
    case 3430:
      ACCEPT_TOKEN(anon_sym_noduplicate);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3431:
      ACCEPT_TOKEN(anon_sym_noduplicate);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3432:
      ACCEPT_TOKEN(anon_sym_nofree);
      END_STATE();
    case 3433:
      ACCEPT_TOKEN(anon_sym_nofree);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3434:
      ACCEPT_TOKEN(anon_sym_nofree);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3435:
      ACCEPT_TOKEN(anon_sym_noimplicitfloat);
      END_STATE();
    case 3436:
      ACCEPT_TOKEN(anon_sym_noimplicitfloat);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3437:
      ACCEPT_TOKEN(anon_sym_noimplicitfloat);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3438:
      ACCEPT_TOKEN(anon_sym_noinline);
      END_STATE();
    case 3439:
      ACCEPT_TOKEN(anon_sym_noinline);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3440:
      ACCEPT_TOKEN(anon_sym_noinline);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3441:
      ACCEPT_TOKEN(anon_sym_nomerge);
      END_STATE();
    case 3442:
      ACCEPT_TOKEN(anon_sym_nomerge);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3443:
      ACCEPT_TOKEN(anon_sym_nomerge);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3444:
      ACCEPT_TOKEN(anon_sym_nonlazybind);
      END_STATE();
    case 3445:
      ACCEPT_TOKEN(anon_sym_nonlazybind);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3446:
      ACCEPT_TOKEN(anon_sym_nonlazybind);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3447:
      ACCEPT_TOKEN(anon_sym_noprofile);
      END_STATE();
    case 3448:
      ACCEPT_TOKEN(anon_sym_noprofile);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3449:
      ACCEPT_TOKEN(anon_sym_noprofile);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3450:
      ACCEPT_TOKEN(anon_sym_noredzone);
      END_STATE();
    case 3451:
      ACCEPT_TOKEN(anon_sym_noredzone);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3452:
      ACCEPT_TOKEN(anon_sym_noredzone);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3453:
      ACCEPT_TOKEN(anon_sym_indirect_DASHtls_DASHseg_DASHrefs);
      END_STATE();
    case 3454:
      ACCEPT_TOKEN(anon_sym_indirect_DASHtls_DASHseg_DASHrefs);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3455:
      ACCEPT_TOKEN(anon_sym_indirect_DASHtls_DASHseg_DASHrefs);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3456:
      ACCEPT_TOKEN(anon_sym_noreturn);
      END_STATE();
    case 3457:
      ACCEPT_TOKEN(anon_sym_noreturn);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3458:
      ACCEPT_TOKEN(anon_sym_noreturn);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3459:
      ACCEPT_TOKEN(anon_sym_norecurse);
      END_STATE();
    case 3460:
      ACCEPT_TOKEN(anon_sym_norecurse);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3461:
      ACCEPT_TOKEN(anon_sym_norecurse);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3462:
      ACCEPT_TOKEN(anon_sym_willreturn);
      END_STATE();
    case 3463:
      ACCEPT_TOKEN(anon_sym_willreturn);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3464:
      ACCEPT_TOKEN(anon_sym_willreturn);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3465:
      ACCEPT_TOKEN(anon_sym_nosync);
      END_STATE();
    case 3466:
      ACCEPT_TOKEN(anon_sym_nosync);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3467:
      ACCEPT_TOKEN(anon_sym_nosync);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3468:
      ACCEPT_TOKEN(anon_sym_nounwind);
      END_STATE();
    case 3469:
      ACCEPT_TOKEN(anon_sym_nounwind);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3470:
      ACCEPT_TOKEN(anon_sym_nounwind);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3471:
      ACCEPT_TOKEN(anon_sym_nocallback);
      END_STATE();
    case 3472:
      ACCEPT_TOKEN(anon_sym_nocallback);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3473:
      ACCEPT_TOKEN(anon_sym_nocallback);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3474:
      ACCEPT_TOKEN(anon_sym_nosanitize_coverage);
      END_STATE();
    case 3475:
      ACCEPT_TOKEN(anon_sym_nosanitize_coverage);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3476:
      ACCEPT_TOKEN(anon_sym_nosanitize_coverage);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3477:
      ACCEPT_TOKEN(anon_sym_null_pointer_is_valid);
      END_STATE();
    case 3478:
      ACCEPT_TOKEN(anon_sym_null_pointer_is_valid);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3479:
      ACCEPT_TOKEN(anon_sym_null_pointer_is_valid);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3480:
      ACCEPT_TOKEN(anon_sym_optforfuzzing);
      END_STATE();
    case 3481:
      ACCEPT_TOKEN(anon_sym_optforfuzzing);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3482:
      ACCEPT_TOKEN(anon_sym_optforfuzzing);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3483:
      ACCEPT_TOKEN(anon_sym_optnone);
      END_STATE();
    case 3484:
      ACCEPT_TOKEN(anon_sym_optnone);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3485:
      ACCEPT_TOKEN(anon_sym_optnone);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3486:
      ACCEPT_TOKEN(anon_sym_optsize);
      END_STATE();
    case 3487:
      ACCEPT_TOKEN(anon_sym_optsize);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3488:
      ACCEPT_TOKEN(anon_sym_optsize);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3489:
      ACCEPT_TOKEN(anon_sym_readnone);
      END_STATE();
    case 3490:
      ACCEPT_TOKEN(anon_sym_readnone);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3491:
      ACCEPT_TOKEN(anon_sym_readnone);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3492:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 3493:
      ACCEPT_TOKEN(anon_sym_readonly);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3494:
      ACCEPT_TOKEN(anon_sym_readonly);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3495:
      ACCEPT_TOKEN(anon_sym_writeonly);
      END_STATE();
    case 3496:
      ACCEPT_TOKEN(anon_sym_writeonly);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3497:
      ACCEPT_TOKEN(anon_sym_writeonly);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3498:
      ACCEPT_TOKEN(anon_sym_argmemonly);
      END_STATE();
    case 3499:
      ACCEPT_TOKEN(anon_sym_argmemonly);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3500:
      ACCEPT_TOKEN(anon_sym_argmemonly);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3501:
      ACCEPT_TOKEN(anon_sym_returns_twice);
      END_STATE();
    case 3502:
      ACCEPT_TOKEN(anon_sym_returns_twice);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3503:
      ACCEPT_TOKEN(anon_sym_returns_twice);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3504:
      ACCEPT_TOKEN(anon_sym_safestack);
      END_STATE();
    case 3505:
      ACCEPT_TOKEN(anon_sym_safestack);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3506:
      ACCEPT_TOKEN(anon_sym_safestack);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3507:
      ACCEPT_TOKEN(anon_sym_sanitize_address);
      END_STATE();
    case 3508:
      ACCEPT_TOKEN(anon_sym_sanitize_address);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3509:
      ACCEPT_TOKEN(anon_sym_sanitize_address);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3510:
      ACCEPT_TOKEN(anon_sym_sanitize_memory);
      END_STATE();
    case 3511:
      ACCEPT_TOKEN(anon_sym_sanitize_memory);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3512:
      ACCEPT_TOKEN(anon_sym_sanitize_memory);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3513:
      ACCEPT_TOKEN(anon_sym_sanitize_thread);
      END_STATE();
    case 3514:
      ACCEPT_TOKEN(anon_sym_sanitize_thread);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3515:
      ACCEPT_TOKEN(anon_sym_sanitize_thread);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3516:
      ACCEPT_TOKEN(anon_sym_sanitize_hwaddress);
      END_STATE();
    case 3517:
      ACCEPT_TOKEN(anon_sym_sanitize_hwaddress);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3518:
      ACCEPT_TOKEN(anon_sym_sanitize_hwaddress);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3519:
      ACCEPT_TOKEN(anon_sym_sanitize_memtag);
      END_STATE();
    case 3520:
      ACCEPT_TOKEN(anon_sym_sanitize_memtag);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3521:
      ACCEPT_TOKEN(anon_sym_sanitize_memtag);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3522:
      ACCEPT_TOKEN(anon_sym_speculative_load_hardening);
      END_STATE();
    case 3523:
      ACCEPT_TOKEN(anon_sym_speculative_load_hardening);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3524:
      ACCEPT_TOKEN(anon_sym_speculative_load_hardening);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3525:
      ACCEPT_TOKEN(anon_sym_speculatable);
      END_STATE();
    case 3526:
      ACCEPT_TOKEN(anon_sym_speculatable);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3527:
      ACCEPT_TOKEN(anon_sym_speculatable);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3528:
      ACCEPT_TOKEN(anon_sym_ssp);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(447);
      if (lookahead == 's') ADVANCE(1190);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3529:
      ACCEPT_TOKEN(anon_sym_ssp);
      if (lookahead == 'r') ADVANCE(4077);
      if (lookahead == 's') ADVANCE(4578);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3530:
      ACCEPT_TOKEN(anon_sym_ssp);
      if (lookahead == 'r') ADVANCE(1905);
      if (lookahead == 's') ADVANCE(2951);
      END_STATE();
    case 3531:
      ACCEPT_TOKEN(anon_sym_sspstrong);
      END_STATE();
    case 3532:
      ACCEPT_TOKEN(anon_sym_sspstrong);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3533:
      ACCEPT_TOKEN(anon_sym_sspstrong);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3534:
      ACCEPT_TOKEN(anon_sym_sspreq);
      END_STATE();
    case 3535:
      ACCEPT_TOKEN(anon_sym_sspreq);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3536:
      ACCEPT_TOKEN(anon_sym_sspreq);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3537:
      ACCEPT_TOKEN(anon_sym_strictfp);
      END_STATE();
    case 3538:
      ACCEPT_TOKEN(anon_sym_strictfp);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3539:
      ACCEPT_TOKEN(anon_sym_strictfp);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3540:
      ACCEPT_TOKEN(anon_sym_nocf_check);
      END_STATE();
    case 3541:
      ACCEPT_TOKEN(anon_sym_nocf_check);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3542:
      ACCEPT_TOKEN(anon_sym_nocf_check);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3543:
      ACCEPT_TOKEN(anon_sym_shadowcallstack);
      END_STATE();
    case 3544:
      ACCEPT_TOKEN(anon_sym_shadowcallstack);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3545:
      ACCEPT_TOKEN(anon_sym_shadowcallstack);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3546:
      ACCEPT_TOKEN(anon_sym_mustprogress);
      END_STATE();
    case 3547:
      ACCEPT_TOKEN(anon_sym_mustprogress);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3548:
      ACCEPT_TOKEN(anon_sym_mustprogress);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3549:
      ACCEPT_TOKEN(anon_sym_vscale_range);
      END_STATE();
    case 3550:
      ACCEPT_TOKEN(anon_sym_vscale_range);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3551:
      ACCEPT_TOKEN(anon_sym_vscale_range);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3552:
      ACCEPT_TOKEN(anon_sym_preallocated);
      END_STATE();
    case 3553:
      ACCEPT_TOKEN(anon_sym_preallocated);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3554:
      ACCEPT_TOKEN(anon_sym_preallocated);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3555:
      ACCEPT_TOKEN(anon_sym_zeroext);
      END_STATE();
    case 3556:
      ACCEPT_TOKEN(anon_sym_zeroext);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3557:
      ACCEPT_TOKEN(anon_sym_zeroext);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3558:
      ACCEPT_TOKEN(anon_sym_signext);
      END_STATE();
    case 3559:
      ACCEPT_TOKEN(anon_sym_signext);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3560:
      ACCEPT_TOKEN(anon_sym_signext);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3561:
      ACCEPT_TOKEN(anon_sym_inreg);
      END_STATE();
    case 3562:
      ACCEPT_TOKEN(anon_sym_inreg);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3563:
      ACCEPT_TOKEN(anon_sym_inreg);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3564:
      ACCEPT_TOKEN(anon_sym_byval);
      END_STATE();
    case 3565:
      ACCEPT_TOKEN(anon_sym_byval);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3566:
      ACCEPT_TOKEN(anon_sym_byval);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3567:
      ACCEPT_TOKEN(anon_sym_byref);
      END_STATE();
    case 3568:
      ACCEPT_TOKEN(anon_sym_byref);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3569:
      ACCEPT_TOKEN(anon_sym_byref);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3570:
      ACCEPT_TOKEN(anon_sym_inalloca);
      END_STATE();
    case 3571:
      ACCEPT_TOKEN(anon_sym_inalloca);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3572:
      ACCEPT_TOKEN(anon_sym_inalloca);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3573:
      ACCEPT_TOKEN(anon_sym_sret);
      END_STATE();
    case 3574:
      ACCEPT_TOKEN(anon_sym_sret);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3575:
      ACCEPT_TOKEN(anon_sym_sret);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3576:
      ACCEPT_TOKEN(anon_sym_elementtype);
      END_STATE();
    case 3577:
      ACCEPT_TOKEN(anon_sym_elementtype);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3578:
      ACCEPT_TOKEN(anon_sym_elementtype);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3579:
      ACCEPT_TOKEN(anon_sym_noalias);
      END_STATE();
    case 3580:
      ACCEPT_TOKEN(anon_sym_noalias);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3581:
      ACCEPT_TOKEN(anon_sym_noalias);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3582:
      ACCEPT_TOKEN(anon_sym_nocapture);
      END_STATE();
    case 3583:
      ACCEPT_TOKEN(anon_sym_nocapture);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3584:
      ACCEPT_TOKEN(anon_sym_nocapture);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3585:
      ACCEPT_TOKEN(anon_sym_nest);
      END_STATE();
    case 3586:
      ACCEPT_TOKEN(anon_sym_nest);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3587:
      ACCEPT_TOKEN(anon_sym_nest);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3588:
      ACCEPT_TOKEN(anon_sym_returned);
      END_STATE();
    case 3589:
      ACCEPT_TOKEN(anon_sym_returned);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3590:
      ACCEPT_TOKEN(anon_sym_returned);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3591:
      ACCEPT_TOKEN(anon_sym_nonnull);
      END_STATE();
    case 3592:
      ACCEPT_TOKEN(anon_sym_nonnull);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3593:
      ACCEPT_TOKEN(anon_sym_nonnull);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3594:
      ACCEPT_TOKEN(anon_sym_dereferenceable);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(936);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3595:
      ACCEPT_TOKEN(anon_sym_dereferenceable);
      if (lookahead == '_') ADVANCE(4419);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3596:
      ACCEPT_TOKEN(anon_sym_dereferenceable);
      if (lookahead == '_') ADVANCE(2608);
      END_STATE();
    case 3597:
      ACCEPT_TOKEN(anon_sym_dereferenceable_or_null);
      END_STATE();
    case 3598:
      ACCEPT_TOKEN(anon_sym_dereferenceable_or_null);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3599:
      ACCEPT_TOKEN(anon_sym_dereferenceable_or_null);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3600:
      ACCEPT_TOKEN(anon_sym_swiftself);
      END_STATE();
    case 3601:
      ACCEPT_TOKEN(anon_sym_swiftself);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3602:
      ACCEPT_TOKEN(anon_sym_swiftself);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 3603:
      ACCEPT_TOKEN(anon_sym_swiftself);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3604:
      ACCEPT_TOKEN(anon_sym_swiftasync);
      END_STATE();
    case 3605:
      ACCEPT_TOKEN(anon_sym_swiftasync);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3606:
      ACCEPT_TOKEN(anon_sym_swiftasync);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 3607:
      ACCEPT_TOKEN(anon_sym_swiftasync);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3608:
      ACCEPT_TOKEN(anon_sym_swifterror);
      END_STATE();
    case 3609:
      ACCEPT_TOKEN(anon_sym_swifterror);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3610:
      ACCEPT_TOKEN(anon_sym_swifterror);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3272);
      END_STATE();
    case 3611:
      ACCEPT_TOKEN(anon_sym_swifterror);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3612:
      ACCEPT_TOKEN(anon_sym_immarg);
      END_STATE();
    case 3613:
      ACCEPT_TOKEN(anon_sym_immarg);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3614:
      ACCEPT_TOKEN(anon_sym_immarg);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3615:
      ACCEPT_TOKEN(anon_sym_noundef);
      END_STATE();
    case 3616:
      ACCEPT_TOKEN(anon_sym_noundef);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3617:
      ACCEPT_TOKEN(anon_sym_noundef);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3618:
      ACCEPT_TOKEN(anon_sym_uwtable);
      END_STATE();
    case 3619:
      ACCEPT_TOKEN(anon_sym_uwtable);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3620:
      ACCEPT_TOKEN(anon_sym_uwtable);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3621:
      ACCEPT_TOKEN(anon_sym_sync);
      END_STATE();
    case 3622:
      ACCEPT_TOKEN(anon_sym_sync);
      if (lookahead == 's') ADVANCE(1649);
      END_STATE();
    case 3623:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 3624:
      ACCEPT_TOKEN(anon_sym_memory);
      END_STATE();
    case 3625:
      ACCEPT_TOKEN(anon_sym_memory);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3626:
      ACCEPT_TOKEN(anon_sym_memory);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3627:
      ACCEPT_TOKEN(anon_sym_argmem);
      END_STATE();
    case 3628:
      ACCEPT_TOKEN(anon_sym_argmem);
      if (lookahead == 'o') ADVANCE(2519);
      END_STATE();
    case 3629:
      ACCEPT_TOKEN(anon_sym_inaccessiblemem);
      END_STATE();
    case 3630:
      ACCEPT_TOKEN(anon_sym_inaccessiblemem);
      if (lookahead == '_') ADVANCE(2610);
      if (lookahead == 'o') ADVANCE(2526);
      END_STATE();
    case 3631:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 3632:
      ACCEPT_TOKEN(anon_sym_none);
      END_STATE();
    case 3633:
      ACCEPT_TOKEN(anon_sym_none);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3634:
      ACCEPT_TOKEN(anon_sym_none);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3635:
      ACCEPT_TOKEN(anon_sym_read);
      if (lookahead == 'n') ADVANCE(2637);
      if (lookahead == 'o') ADVANCE(2515);
      if (lookahead == 'w') ADVANCE(2790);
      END_STATE();
    case 3636:
      ACCEPT_TOKEN(anon_sym_read);
      if (lookahead == 'w') ADVANCE(2790);
      END_STATE();
    case 3637:
      ACCEPT_TOKEN(anon_sym_write);
      END_STATE();
    case 3638:
      ACCEPT_TOKEN(anon_sym_write);
      if (lookahead == 'o') ADVANCE(2518);
      END_STATE();
    case 3639:
      ACCEPT_TOKEN(anon_sym_readwrite);
      END_STATE();
    case 3640:
      ACCEPT_TOKEN(anon_sym_unreachable);
      END_STATE();
    case 3641:
      ACCEPT_TOKEN(anon_sym_unreachable);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3642:
      ACCEPT_TOKEN(anon_sym_ret);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'u') ADVANCE(1043);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3643:
      ACCEPT_TOKEN(anon_sym_ret);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3644:
      ACCEPT_TOKEN(anon_sym_ret);
      if (lookahead == 'u') ADVANCE(2750);
      END_STATE();
    case 3645:
      ACCEPT_TOKEN(anon_sym_br);
      END_STATE();
    case 3646:
      ACCEPT_TOKEN(anon_sym_br);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3647:
      ACCEPT_TOKEN(anon_sym_resume);
      END_STATE();
    case 3648:
      ACCEPT_TOKEN(anon_sym_resume);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3649:
      ACCEPT_TOKEN(anon_sym_freeze);
      END_STATE();
    case 3650:
      ACCEPT_TOKEN(anon_sym_freeze);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3651:
      ACCEPT_TOKEN(anon_sym_indirectbr);
      END_STATE();
    case 3652:
      ACCEPT_TOKEN(anon_sym_indirectbr);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3653:
      ACCEPT_TOKEN(anon_sym_extractelement);
      END_STATE();
    case 3654:
      ACCEPT_TOKEN(anon_sym_extractelement);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3655:
      ACCEPT_TOKEN(anon_sym_insertelement);
      END_STATE();
    case 3656:
      ACCEPT_TOKEN(anon_sym_insertelement);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3657:
      ACCEPT_TOKEN(anon_sym_select);
      END_STATE();
    case 3658:
      ACCEPT_TOKEN(anon_sym_select);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3659:
      ACCEPT_TOKEN(anon_sym_shufflevector);
      END_STATE();
    case 3660:
      ACCEPT_TOKEN(anon_sym_shufflevector);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3661:
      ACCEPT_TOKEN(anon_sym_fneg);
      END_STATE();
    case 3662:
      ACCEPT_TOKEN(anon_sym_fneg);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3663:
      ACCEPT_TOKEN(anon_sym_nsw);
      END_STATE();
    case 3664:
      ACCEPT_TOKEN(anon_sym_nuw);
      END_STATE();
    case 3665:
      ACCEPT_TOKEN(anon_sym_exact);
      END_STATE();
    case 3666:
      ACCEPT_TOKEN(anon_sym_disjoint);
      END_STATE();
    case 3667:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 3668:
      ACCEPT_TOKEN(anon_sym_switch);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3669:
      ACCEPT_TOKEN(anon_sym_invoke);
      END_STATE();
    case 3670:
      ACCEPT_TOKEN(anon_sym_invoke);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3671:
      ACCEPT_TOKEN(anon_sym_to);
      if (lookahead == 'k') ADVANCE(1937);
      END_STATE();
    case 3672:
      ACCEPT_TOKEN(anon_sym_unwind);
      END_STATE();
    case 3673:
      ACCEPT_TOKEN(anon_sym_cleanupret);
      END_STATE();
    case 3674:
      ACCEPT_TOKEN(anon_sym_cleanupret);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3675:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 3676:
      ACCEPT_TOKEN(anon_sym_catchret);
      END_STATE();
    case 3677:
      ACCEPT_TOKEN(anon_sym_catchret);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3678:
      ACCEPT_TOKEN(anon_sym_catchswitch);
      END_STATE();
    case 3679:
      ACCEPT_TOKEN(anon_sym_catchswitch);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3680:
      ACCEPT_TOKEN(anon_sym_catchpad);
      END_STATE();
    case 3681:
      ACCEPT_TOKEN(anon_sym_catchpad);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3682:
      ACCEPT_TOKEN(anon_sym_cleanuppad);
      END_STATE();
    case 3683:
      ACCEPT_TOKEN(anon_sym_cleanuppad);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3684:
      ACCEPT_TOKEN(anon_sym_callbr);
      END_STATE();
    case 3685:
      ACCEPT_TOKEN(anon_sym_callbr);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3686:
      ACCEPT_TOKEN(anon_sym_icmp);
      END_STATE();
    case 3687:
      ACCEPT_TOKEN(anon_sym_icmp);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3688:
      ACCEPT_TOKEN(anon_sym_fcmp);
      END_STATE();
    case 3689:
      ACCEPT_TOKEN(anon_sym_fcmp);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3690:
      ACCEPT_TOKEN(anon_sym_nneg);
      END_STATE();
    case 3691:
      ACCEPT_TOKEN(anon_sym_va_arg);
      END_STATE();
    case 3692:
      ACCEPT_TOKEN(anon_sym_va_arg);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3693:
      ACCEPT_TOKEN(anon_sym_phi);
      END_STATE();
    case 3694:
      ACCEPT_TOKEN(anon_sym_phi);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3695:
      ACCEPT_TOKEN(anon_sym_landingpad);
      END_STATE();
    case 3696:
      ACCEPT_TOKEN(anon_sym_landingpad);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3697:
      ACCEPT_TOKEN(anon_sym_cleanup);
      END_STATE();
    case 3698:
      ACCEPT_TOKEN(anon_sym_tail);
      END_STATE();
    case 3699:
      ACCEPT_TOKEN(anon_sym_tail);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3700:
      ACCEPT_TOKEN(anon_sym_musttail);
      END_STATE();
    case 3701:
      ACCEPT_TOKEN(anon_sym_musttail);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3702:
      ACCEPT_TOKEN(anon_sym_notail);
      END_STATE();
    case 3703:
      ACCEPT_TOKEN(anon_sym_notail);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3704:
      ACCEPT_TOKEN(anon_sym_call);
      END_STATE();
    case 3705:
      ACCEPT_TOKEN(anon_sym_call);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'b') ADVANCE(1011);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3706:
      ACCEPT_TOKEN(anon_sym_call);
      if (lookahead == 'b') ADVANCE(2708);
      END_STATE();
    case 3707:
      ACCEPT_TOKEN(anon_sym_alloca);
      END_STATE();
    case 3708:
      ACCEPT_TOKEN(anon_sym_alloca);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3709:
      ACCEPT_TOKEN(anon_sym_load);
      END_STATE();
    case 3710:
      ACCEPT_TOKEN(anon_sym_load);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3711:
      ACCEPT_TOKEN(anon_sym_atomic);
      END_STATE();
    case 3712:
      ACCEPT_TOKEN(anon_sym_atomic);
      if (lookahead == 'r') ADVANCE(2436);
      END_STATE();
    case 3713:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 3714:
      ACCEPT_TOKEN(anon_sym_store);
      END_STATE();
    case 3715:
      ACCEPT_TOKEN(anon_sym_store);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3716:
      ACCEPT_TOKEN(anon_sym_cmpxchg);
      END_STATE();
    case 3717:
      ACCEPT_TOKEN(anon_sym_cmpxchg);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3718:
      ACCEPT_TOKEN(anon_sym_atomicrmw);
      END_STATE();
    case 3719:
      ACCEPT_TOKEN(anon_sym_atomicrmw);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3720:
      ACCEPT_TOKEN(anon_sym_fence);
      END_STATE();
    case 3721:
      ACCEPT_TOKEN(anon_sym_fence);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3722:
      ACCEPT_TOKEN(anon_sym_getelementptr);
      END_STATE();
    case 3723:
      ACCEPT_TOKEN(anon_sym_getelementptr);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3724:
      ACCEPT_TOKEN(anon_sym_inbounds);
      END_STATE();
    case 3725:
      ACCEPT_TOKEN(anon_sym_inrange);
      END_STATE();
    case 3726:
      ACCEPT_TOKEN(anon_sym_extractvalue);
      END_STATE();
    case 3727:
      ACCEPT_TOKEN(anon_sym_extractvalue);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3728:
      ACCEPT_TOKEN(anon_sym_insertvalue);
      END_STATE();
    case 3729:
      ACCEPT_TOKEN(anon_sym_insertvalue);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3730:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 3731:
      ACCEPT_TOKEN(anon_sym_true);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3732:
      ACCEPT_TOKEN(anon_sym_true);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3733:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 3734:
      ACCEPT_TOKEN(anon_sym_false);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3735:
      ACCEPT_TOKEN(anon_sym_false);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3736:
      ACCEPT_TOKEN(anon_sym_null);
      END_STATE();
    case 3737:
      ACCEPT_TOKEN(anon_sym_null);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '_') ADVANCE(997);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3738:
      ACCEPT_TOKEN(anon_sym_null);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3739:
      ACCEPT_TOKEN(anon_sym_null);
      if (lookahead == '_') ADVANCE(2690);
      END_STATE();
    case 3740:
      ACCEPT_TOKEN(anon_sym_null);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3741:
      ACCEPT_TOKEN(anon_sym_undef);
      END_STATE();
    case 3742:
      ACCEPT_TOKEN(anon_sym_undef);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3743:
      ACCEPT_TOKEN(anon_sym_undef);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3744:
      ACCEPT_TOKEN(anon_sym_poison);
      END_STATE();
    case 3745:
      ACCEPT_TOKEN(anon_sym_poison);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3746:
      ACCEPT_TOKEN(anon_sym_poison);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3747:
      ACCEPT_TOKEN(anon_sym_zeroinitializer);
      END_STATE();
    case 3748:
      ACCEPT_TOKEN(anon_sym_zeroinitializer);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3749:
      ACCEPT_TOKEN(anon_sym_zeroinitializer);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3750:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 3751:
      ACCEPT_TOKEN(anon_sym_catch);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'p') ADVANCE(196);
      if (lookahead == 'r') ADVANCE(502);
      if (lookahead == 's') ADVANCE(1250);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3752:
      ACCEPT_TOKEN(anon_sym_catch);
      if (lookahead == 'p') ADVANCE(1451);
      if (lookahead == 'r') ADVANCE(1977);
      if (lookahead == 's') ADVANCE(3034);
      END_STATE();
    case 3753:
      ACCEPT_TOKEN(anon_sym_filter);
      END_STATE();
    case 3754:
      ACCEPT_TOKEN(anon_sym_filter);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3755:
      ACCEPT_TOKEN(anon_sym_blockaddress);
      END_STATE();
    case 3756:
      ACCEPT_TOKEN(anon_sym_blockaddress);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3757:
      ACCEPT_TOKEN(anon_sym_mul);
      END_STATE();
    case 3758:
      ACCEPT_TOKEN(anon_sym_mul);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3759:
      ACCEPT_TOKEN(anon_sym_urem);
      END_STATE();
    case 3760:
      ACCEPT_TOKEN(anon_sym_urem);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3761:
      ACCEPT_TOKEN(anon_sym_srem);
      END_STATE();
    case 3762:
      ACCEPT_TOKEN(anon_sym_srem);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3763:
      ACCEPT_TOKEN(anon_sym_shl);
      END_STATE();
    case 3764:
      ACCEPT_TOKEN(anon_sym_shl);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3765:
      ACCEPT_TOKEN(anon_sym_udiv);
      END_STATE();
    case 3766:
      ACCEPT_TOKEN(anon_sym_udiv);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3767:
      ACCEPT_TOKEN(anon_sym_sdiv);
      END_STATE();
    case 3768:
      ACCEPT_TOKEN(anon_sym_sdiv);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3769:
      ACCEPT_TOKEN(anon_sym_lshr);
      END_STATE();
    case 3770:
      ACCEPT_TOKEN(anon_sym_lshr);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3771:
      ACCEPT_TOKEN(anon_sym_ashr);
      END_STATE();
    case 3772:
      ACCEPT_TOKEN(anon_sym_ashr);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3773:
      ACCEPT_TOKEN(anon_sym_fmul);
      END_STATE();
    case 3774:
      ACCEPT_TOKEN(anon_sym_fmul);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3775:
      ACCEPT_TOKEN(anon_sym_fdiv);
      END_STATE();
    case 3776:
      ACCEPT_TOKEN(anon_sym_fdiv);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3777:
      ACCEPT_TOKEN(anon_sym_frem);
      END_STATE();
    case 3778:
      ACCEPT_TOKEN(anon_sym_frem);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3779:
      ACCEPT_TOKEN(anon_sym_xchg);
      END_STATE();
    case 3780:
      ACCEPT_TOKEN(anon_sym_xchg);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3781:
      ACCEPT_TOKEN(anon_sym_add);
      END_STATE();
    case 3782:
      ACCEPT_TOKEN(anon_sym_add);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(1092);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3783:
      ACCEPT_TOKEN(anon_sym_add);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 'r') ADVANCE(1119);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3784:
      ACCEPT_TOKEN(anon_sym_add);
      if (lookahead == 'r') ADVANCE(2817);
      END_STATE();
    case 3785:
      ACCEPT_TOKEN(anon_sym_add);
      if (lookahead == 'r') ADVANCE(2853);
      END_STATE();
    case 3786:
      ACCEPT_TOKEN(anon_sym_sub);
      END_STATE();
    case 3787:
      ACCEPT_TOKEN(anon_sym_sub);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3788:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 3789:
      ACCEPT_TOKEN(anon_sym_and);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3790:
      ACCEPT_TOKEN(anon_sym_nand);
      END_STATE();
    case 3791:
      ACCEPT_TOKEN(anon_sym_nand);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3792:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 3793:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3794:
      ACCEPT_TOKEN(anon_sym_xor);
      END_STATE();
    case 3795:
      ACCEPT_TOKEN(anon_sym_xor);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3796:
      ACCEPT_TOKEN(anon_sym_max);
      END_STATE();
    case 3797:
      ACCEPT_TOKEN(anon_sym_max);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3798:
      ACCEPT_TOKEN(anon_sym_min);
      END_STATE();
    case 3799:
      ACCEPT_TOKEN(anon_sym_min);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == 's') ADVANCE(661);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3800:
      ACCEPT_TOKEN(anon_sym_min);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3801:
      ACCEPT_TOKEN(anon_sym_min);
      if (lookahead == 's') ADVANCE(2206);
      END_STATE();
    case 3802:
      ACCEPT_TOKEN(anon_sym_umax);
      END_STATE();
    case 3803:
      ACCEPT_TOKEN(anon_sym_umax);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3804:
      ACCEPT_TOKEN(anon_sym_umin);
      END_STATE();
    case 3805:
      ACCEPT_TOKEN(anon_sym_umin);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3806:
      ACCEPT_TOKEN(anon_sym_fadd);
      END_STATE();
    case 3807:
      ACCEPT_TOKEN(anon_sym_fadd);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3808:
      ACCEPT_TOKEN(anon_sym_fsub);
      END_STATE();
    case 3809:
      ACCEPT_TOKEN(anon_sym_fsub);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3810:
      ACCEPT_TOKEN(anon_sym_eq);
      END_STATE();
    case 3811:
      ACCEPT_TOKEN(anon_sym_ne);
      END_STATE();
    case 3812:
      ACCEPT_TOKEN(anon_sym_ne);
      if (lookahead == 's') ADVANCE(2863);
      END_STATE();
    case 3813:
      ACCEPT_TOKEN(anon_sym_ugt);
      END_STATE();
    case 3814:
      ACCEPT_TOKEN(anon_sym_uge);
      END_STATE();
    case 3815:
      ACCEPT_TOKEN(anon_sym_ult);
      END_STATE();
    case 3816:
      ACCEPT_TOKEN(anon_sym_ule);
      END_STATE();
    case 3817:
      ACCEPT_TOKEN(anon_sym_sgt);
      END_STATE();
    case 3818:
      ACCEPT_TOKEN(anon_sym_sge);
      END_STATE();
    case 3819:
      ACCEPT_TOKEN(anon_sym_slt);
      END_STATE();
    case 3820:
      ACCEPT_TOKEN(anon_sym_sle);
      END_STATE();
    case 3821:
      ACCEPT_TOKEN(anon_sym_oeq);
      END_STATE();
    case 3822:
      ACCEPT_TOKEN(anon_sym_ogt);
      END_STATE();
    case 3823:
      ACCEPT_TOKEN(anon_sym_oge);
      END_STATE();
    case 3824:
      ACCEPT_TOKEN(anon_sym_olt);
      END_STATE();
    case 3825:
      ACCEPT_TOKEN(anon_sym_ole);
      END_STATE();
    case 3826:
      ACCEPT_TOKEN(anon_sym_one);
      END_STATE();
    case 3827:
      ACCEPT_TOKEN(anon_sym_ord);
      END_STATE();
    case 3828:
      ACCEPT_TOKEN(anon_sym_ueq);
      END_STATE();
    case 3829:
      ACCEPT_TOKEN(anon_sym_une);
      END_STATE();
    case 3830:
      ACCEPT_TOKEN(anon_sym_uno);
      END_STATE();
    case 3831:
      ACCEPT_TOKEN(anon_sym_uno);
      if (lookahead == 'r') ADVANCE(1791);
      END_STATE();
    case 3832:
      ACCEPT_TOKEN(anon_sym_bitcast);
      END_STATE();
    case 3833:
      ACCEPT_TOKEN(anon_sym_bitcast);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3834:
      ACCEPT_TOKEN(anon_sym_trunc);
      END_STATE();
    case 3835:
      ACCEPT_TOKEN(anon_sym_trunc);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3836:
      ACCEPT_TOKEN(anon_sym_zext);
      END_STATE();
    case 3837:
      ACCEPT_TOKEN(anon_sym_zext);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3838:
      ACCEPT_TOKEN(anon_sym_sext);
      END_STATE();
    case 3839:
      ACCEPT_TOKEN(anon_sym_sext);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3840:
      ACCEPT_TOKEN(anon_sym_fptrunc);
      END_STATE();
    case 3841:
      ACCEPT_TOKEN(anon_sym_fptrunc);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3842:
      ACCEPT_TOKEN(anon_sym_fpext);
      END_STATE();
    case 3843:
      ACCEPT_TOKEN(anon_sym_fpext);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3844:
      ACCEPT_TOKEN(anon_sym_addrspacecast);
      END_STATE();
    case 3845:
      ACCEPT_TOKEN(anon_sym_addrspacecast);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3846:
      ACCEPT_TOKEN(anon_sym_uitofp);
      END_STATE();
    case 3847:
      ACCEPT_TOKEN(anon_sym_uitofp);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3848:
      ACCEPT_TOKEN(anon_sym_sitofp);
      END_STATE();
    case 3849:
      ACCEPT_TOKEN(anon_sym_sitofp);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3850:
      ACCEPT_TOKEN(anon_sym_fptoui);
      END_STATE();
    case 3851:
      ACCEPT_TOKEN(anon_sym_fptoui);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3852:
      ACCEPT_TOKEN(anon_sym_fptosi);
      END_STATE();
    case 3853:
      ACCEPT_TOKEN(anon_sym_fptosi);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3854:
      ACCEPT_TOKEN(anon_sym_inttoptr);
      END_STATE();
    case 3855:
      ACCEPT_TOKEN(anon_sym_inttoptr);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3856:
      ACCEPT_TOKEN(anon_sym_ptrtoint);
      END_STATE();
    case 3857:
      ACCEPT_TOKEN(anon_sym_ptrtoint);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3858:
      ACCEPT_TOKEN(anon_sym_unordered);
      END_STATE();
    case 3859:
      ACCEPT_TOKEN(anon_sym_unordered);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3860:
      ACCEPT_TOKEN(anon_sym_monotonic);
      END_STATE();
    case 3861:
      ACCEPT_TOKEN(anon_sym_monotonic);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3862:
      ACCEPT_TOKEN(anon_sym_acquire);
      END_STATE();
    case 3863:
      ACCEPT_TOKEN(anon_sym_acquire);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3864:
      ACCEPT_TOKEN(anon_sym_release);
      END_STATE();
    case 3865:
      ACCEPT_TOKEN(anon_sym_release);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3866:
      ACCEPT_TOKEN(anon_sym_acq_rel);
      END_STATE();
    case 3867:
      ACCEPT_TOKEN(anon_sym_acq_rel);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3868:
      ACCEPT_TOKEN(anon_sym_seq_cst);
      END_STATE();
    case 3869:
      ACCEPT_TOKEN(anon_sym_seq_cst);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3870:
      ACCEPT_TOKEN(anon_sym_syncscope);
      END_STATE();
    case 3871:
      ACCEPT_TOKEN(anon_sym_syncscope);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3872:
      ACCEPT_TOKEN(anon_sym_nnan);
      END_STATE();
    case 3873:
      ACCEPT_TOKEN(anon_sym_ninf);
      END_STATE();
    case 3874:
      ACCEPT_TOKEN(anon_sym_nsz);
      END_STATE();
    case 3875:
      ACCEPT_TOKEN(anon_sym_arcp);
      END_STATE();
    case 3876:
      ACCEPT_TOKEN(anon_sym_contract);
      END_STATE();
    case 3877:
      ACCEPT_TOKEN(anon_sym_afn);
      END_STATE();
    case 3878:
      ACCEPT_TOKEN(anon_sym_reassoc);
      END_STATE();
    case 3879:
      ACCEPT_TOKEN(anon_sym_fast);
      END_STATE();
    case 3880:
      ACCEPT_TOKEN(anon_sym_fast);
      if (lookahead == 'c') ADVANCE(1600);
      END_STATE();
    case 3881:
      ACCEPT_TOKEN(anon_sym_within);
      END_STATE();
    case 3882:
      ACCEPT_TOKEN(anon_sym_caller);
      END_STATE();
    case 3883:
      ACCEPT_TOKEN(anon_sym_uselistorder);
      if (lookahead == ':') ADVANCE(3129);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1298);
      END_STATE();
    case 3884:
      ACCEPT_TOKEN(anon_sym_uselistorder);
      if (lookahead == '_') ADVANCE(1563);
      END_STATE();
    case 3885:
      ACCEPT_TOKEN(anon_sym_uselistorder_bb);
      END_STATE();
    case 3886:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 3887:
      ACCEPT_TOKEN(anon_sym_asm);
      END_STATE();
    case 3888:
      ACCEPT_TOKEN(anon_sym_sideeffect);
      END_STATE();
    case 3889:
      ACCEPT_TOKEN(anon_sym_inteldialect);
      END_STATE();
    case 3890:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 3891:
      ACCEPT_TOKEN(anon_sym_externally_initialized);
      END_STATE();
    case 3892:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 3893:
      ACCEPT_TOKEN(anon_sym_constant);
      END_STATE();
    case 3894:
      ACCEPT_TOKEN(anon_sym_alias);
      END_STATE();
    case 3895:
      ACCEPT_TOKEN(anon_sym_ifunc);
      END_STATE();
    case 3896:
      ACCEPT_TOKEN(anon_sym_thread_local);
      END_STATE();
    case 3897:
      ACCEPT_TOKEN(anon_sym_localdynamic);
      END_STATE();
    case 3898:
      ACCEPT_TOKEN(anon_sym_initialexec);
      END_STATE();
    case 3899:
      ACCEPT_TOKEN(anon_sym_localexec);
      END_STATE();
    case 3900:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 3901:
      ACCEPT_TOKEN(anon_sym_any);
      if (lookahead == 'r') ADVANCE(1912);
      END_STATE();
    case 3902:
      ACCEPT_TOKEN(anon_sym_exactmatch);
      END_STATE();
    case 3903:
      ACCEPT_TOKEN(anon_sym_largest);
      END_STATE();
    case 3904:
      ACCEPT_TOKEN(anon_sym_nodeduplicate);
      END_STATE();
    case 3905:
      ACCEPT_TOKEN(anon_sym_samesize);
      END_STATE();
    case 3906:
      ACCEPT_TOKEN(anon_sym_distinct);
      END_STATE();
    case 3907:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '"') ADVANCE(14);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3131);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(3132);
      END_STATE();
    case 3908:
      ACCEPT_TOKEN(anon_sym_LBRACE2);
      END_STATE();
    case 3909:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 3910:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '"') ADVANCE(19);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3911:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '+') ADVANCE(3093);
      if (lookahead == '-') ADVANCE(4649);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3160);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3912:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      ADVANCE_MAP(
        '-', 4261,
        'a', 4291,
        'b', 4606,
        'c', 3954,
        'd', 4592,
        'f', 4485,
        'i', 4349,
        'm', 4131,
        'n', 4292,
        'p', 4473,
        'r', 4076,
        's', 3965,
        'u', 4351,
      );
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('e' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3913:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '-') ADVANCE(4566);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3914:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '-') ADVANCE(4532);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3915:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '-') ADVANCE(4500);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3916:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '-') ADVANCE(4588);
      if (lookahead == '$' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3917:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      ADVANCE_MAP(
        '0', 4616,
        'a', 4185,
        'h', 3961,
        'i', 4201,
        'p', 4111,
        'r', 4128,
        's', 4445,
        't', 4474,
        'w', 4214,
      );
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3918:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '0') ADVANCE(4616);
      if (lookahead == 'n') ADVANCE(4068);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3919:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '0') ADVANCE(4616);
      if (lookahead == 'w') ADVANCE(4585);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3920:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '0') ADVANCE(4616);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3921:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '0') ADVANCE(3307);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3922:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '1') ADVANCE(3924);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3923:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '1') ADVANCE(3925);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3924:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '2') ADVANCE(3928);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3925:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '2') ADVANCE(3929);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3926:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '6') ADVANCE(3932);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3927:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '8') ADVANCE(3926);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3928:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '8') ADVANCE(3310);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3929:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '8') ADVANCE(3313);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3930:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '8') ADVANCE(3921);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3931:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(3974);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3932:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(3969);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3933:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4613);
      if (lookahead == 'a') ADVANCE(4276);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3934:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4209);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3935:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4451);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3936:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4025);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3937:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4490);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3938:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4222);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3939:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4034);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3940:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4554);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3941:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(3983);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3942:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4399);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3943:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4116);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3944:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4529);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3945:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4608);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3946:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4183);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3947:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4306);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3948:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4420);
      if (lookahead == 'o') ADVANCE(4381);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3949:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '_') ADVANCE(4241);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3950:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4269);
      if (lookahead == 'e') ADVANCE(4522);
      if (lookahead == 'o') ADVANCE(3912);
      if (lookahead == 'u') ADVANCE(4284);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3951:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4027);
      if (lookahead == 'd') ADVANCE(4245);
      if (lookahead == 'l') ADVANCE(4242);
      if (lookahead == 'r') ADVANCE(4113);
      if (lookahead == 't') ADVANCE(4158);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3952:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4631);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3953:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4014);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3954:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4298);
      if (lookahead == 'f') ADVANCE(3936);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3955:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3572);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3956:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(3319);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3957:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4051);
      if (lookahead == 't') ADVANCE(4598);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3958:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4634);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3959:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4461);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3960:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4262);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3961:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4060);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3962:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4013);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3963:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4469);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3964:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4512);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3965:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4402);
      if (lookahead == 'y') ADVANCE(4367);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3966:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4274);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3967:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4520);
      if (lookahead == 'e') ADVANCE(4482);
      if (lookahead == 's') ADVANCE(4146);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3968:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4267);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3969:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4337);
      if (lookahead == 'f') ADVANCE(4449);
      if (lookahead == 'm') ADVANCE(4338);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3970:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4026);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3971:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4197);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3972:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4308);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3973:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4028);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3974:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4062);
      if (lookahead == 'h') ADVANCE(4614);
      if (lookahead == 'm') ADVANCE(4129);
      if (lookahead == 't') ADVANCE(4212);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3975:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4030);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3976:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4057);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3977:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4061);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3978:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4032);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3979:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4277);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3980:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4548);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3981:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4067);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3982:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4489);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3983:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4510);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3984:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4551);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3985:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4392);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3986:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4321);
      if (lookahead == 'l') ADVANCE(4435);
      if (lookahead == 'p') ADVANCE(3922);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3987:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4562);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3988:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4299);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3989:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4552);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3990:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4553);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3991:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4218);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3992:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4568);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3993:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4332);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3994:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4570);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3995:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4305);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3996:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4205);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3997:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4571);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3998:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4307);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 3999:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4328);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4000:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4042);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4001:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4310);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4002:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4569);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4003:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4015);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4004:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4016);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4005:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4017);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4006:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4018);
      if (lookahead == 'i') ADVANCE(4609);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4007:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4019);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4008:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4020);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4009:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4074);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4010:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'a') ADVANCE(4404);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4011:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'b') ADVANCE(3975);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4012:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'b') ADVANCE(4323);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4013:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'b') ADVANCE(4151);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4014:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'b') ADVANCE(4309);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4015:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'b') ADVANCE(4313);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4016:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'b') ADVANCE(4314);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4017:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'b') ADVANCE(4315);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4018:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'b') ADVANCE(4317);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4019:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'b') ADVANCE(4318);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4020:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'b') ADVANCE(4319);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4021:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'b') ADVANCE(4233);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4022:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'b') ADVANCE(4320);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4023:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(3467);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4024:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(3607);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4025:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4210);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4026:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4263);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4027:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4037);
      if (lookahead == 'l') ADVANCE(4293);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4028:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4264);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4029:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4595);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4030:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4265);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4031:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4266);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4032:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4268);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4033:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4558);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4034:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4443);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4035:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(3955);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4036:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(3946);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4037:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4125);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4038:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4572);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4039:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4086);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4040:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4175);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4041:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4100);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4042:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4108);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4043:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4594);
      if (lookahead == 'd') ADVANCE(4644);
      if (lookahead == 't') ADVANCE(4600);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4044:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(3972);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4045:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4232);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4046:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(4538);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4047:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(3998);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4048:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(3994);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4049:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'c') ADVANCE(3997);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4050:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3395);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4051:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4400);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4052:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3422);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4053:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3470);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4054:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3590);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4055:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3446);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4056:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3554);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4057:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3515);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4058:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3479);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4059:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3291);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4060:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4406);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4061:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(3934);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4062:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4072);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4063:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4462);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4064:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4464);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4065:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4124);
      if (lookahead == 'w') ADVANCE(4225);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4066:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4492);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4067:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4002);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4068:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4142);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4069:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4066);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4070:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4152);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4071:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4228);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4072:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4503);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4073:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4506);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4074:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'd') ADVANCE(4073);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4075:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3957);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4076:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4043);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4077:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4460);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4078:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4211);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4079:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3434);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4080:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3419);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4081:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3443);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4082:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3485);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4083:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3488);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4084:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3173);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4085:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3620);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4086:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3185);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4087:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3440);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4088:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3491);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4089:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3385);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4090:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3416);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4091:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3584);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4092:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3449);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4093:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3461);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4094:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3452);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4095:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3578);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4096:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3431);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4097:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3388);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4098:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3527);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4099:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3551);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4100:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3503);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4101:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3595);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4102:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3476);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4103:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3634);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4104:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3732);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4105:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3735);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4106:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3303);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4107:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3333);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4108:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3358);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4109:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4476);
      if (lookahead == 'i') ADVANCE(4521);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4110:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4619);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4111:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4029);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4112:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4176);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4113:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4192);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4114:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3960);
      if (lookahead == 'i') ADVANCE(4286);
      if (lookahead == 'r') ADVANCE(4237);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4115:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4336);
      if (lookahead == 'i') ADVANCE(4364);
      if (lookahead == 'u') ADVANCE(4519);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4116:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4621);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4117:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4186);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4118:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3937);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4119:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4470);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4120:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4052);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4121:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3944);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4122:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4480);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4123:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4344);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4124:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4177);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4125:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4534);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4126:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4365);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4127:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3931);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4128:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4544);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4129:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4334);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4130:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3943);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4131:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4471);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4132:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3993);
      if (lookahead == 'i') ADVANCE(4607);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4133:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4335);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4134:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4054);
      if (lookahead == 's') ADVANCE(3940);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4135:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3947);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4136:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4526);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4137:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4375);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4138:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4187);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4139:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4199);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4140:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4056);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4141:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4031);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4142:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4180);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4143:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4514);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4144:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4586);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4145:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4479);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4146:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4289);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4147:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4484);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4148:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4079);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4149:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4466);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4150:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4579);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4151:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4280);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4152:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4397);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4153:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4396);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4154:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4361);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4155:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3939);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4156:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4620);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4157:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3968);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4158:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4483);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4159:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4038);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4160:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4502);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4161:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4527);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4162:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4380);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4163:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4494);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4164:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(3976);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4165:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4535);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4166:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4345);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4167:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4430);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4168:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4528);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4169:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4507);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4170:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4509);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4171:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4496);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4172:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4346);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4173:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4391);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4174:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4347);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4175:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'e') ADVANCE(4008);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4176:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(3569);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4177:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(3617);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4178:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(3603);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4179:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(3294);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4180:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(3743);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4181:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(4591);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4182:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(4447);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4183:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(4458);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4184:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(4545);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4185:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(4165);
      if (lookahead == 'n') ADVANCE(4220);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4186:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(4169);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4187:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(4517);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4188:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(4414);
      if (lookahead == 'n') ADVANCE(4432);
      if (lookahead == 's') ADVANCE(4239);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4189:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(4304);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4190:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(4253);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4191:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'f') ADVANCE(4330);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4192:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(3563);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4193:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(3614);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4194:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(3195);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4195:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(3533);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4196:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(3482);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4197:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(3521);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4198:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(3524);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4199:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(3915);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4200:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(4343);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4201:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(4374);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4202:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(4352);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4203:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(4081);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4204:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(4099);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4205:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(4102);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4206:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(4162);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4207:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(4498);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4208:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'g') ADVANCE(4350);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4209:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'h') ADVANCE(3982);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4210:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'h') ADVANCE(4141);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4211:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'h') ADVANCE(4246);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4212:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'h') ADVANCE(4499);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4213:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4363);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4214:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4184);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4215:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4636);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4216:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4288);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4217:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4033);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4218:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4329);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4219:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4045);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4220:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4576);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4221:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(3964);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4222:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4524);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4223:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4058);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4224:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4356);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4225:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4368);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4226:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4540);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4227:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4403);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4228:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4366);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4229:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4059);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4230:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4358);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4231:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4398);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4232:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4559);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4233:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4371);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4234:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4370);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4235:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4574);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4236:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4372);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4237:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4563);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4238:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4012);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4239:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4637);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4240:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4202);
      if (lookahead == 'l') ADVANCE(4408);
      if (lookahead == 'w') ADVANCE(3952);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4241:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4395);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4242:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4379);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4243:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4394);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4244:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4638);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4245:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4491);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4246:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4382);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4247:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4048);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4248:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4639);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4249:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4385);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4250:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4041);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4251:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4640);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4252:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4641);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4253:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4316);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4254:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4388);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4255:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4422);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4256:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4580);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4257:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(3999);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4258:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4642);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4259:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4582);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4260:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'i') ADVANCE(4325);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4261:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'j') ADVANCE(4593);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4262:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'k') ADVANCE(3179);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4263:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'k') ADVANCE(3506);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4264:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'k') ADVANCE(3382);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4265:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'k') ADVANCE(3473);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4266:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'k') ADVANCE(3542);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4267:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'k') ADVANCE(3201);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4268:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'k') ADVANCE(3545);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4269:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'k') ADVANCE(4120);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4270:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'k') ADVANCE(4416);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4271:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'k') ADVANCE(4154);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4272:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4240);
      if (lookahead == 'p') ADVANCE(4450);
      if (lookahead == 'r') ADVANCE(4200);
      if (lookahead == 'v') ADVANCE(3991);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4273:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4050);
      if (lookahead == 'm') ADVANCE(4339);
      if (lookahead == 'n') ADVANCE(4610);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4274:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3566);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4275:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3593);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4276:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3205);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4277:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3176);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4278:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3599);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4279:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3740);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4280:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3316);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4281:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4011);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4282:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3935);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4283:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4123);
      if (lookahead == 'x') ADVANCE(4573);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4284:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4282);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4285:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4623);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4286:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4322);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4287:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4624);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4288:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4575);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4289:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4178);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4290:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4625);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4291:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4221);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4292:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3958);
      if (lookahead == 'n') ADVANCE(4599);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4293:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4425);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4294:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4247);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4295:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4627);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4296:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4219);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4297:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4518);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4298:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4281);
      if (lookahead == 'p') ADVANCE(4557);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4299:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4179);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4300:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4628);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4301:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4629);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4302:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(3980);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4303:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4275);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4304:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4427);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4305:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4223);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4306:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4434);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4307:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4324);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4308:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4118);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4309:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4121);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4310:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4300);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4311:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4278);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4312:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4279);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4313:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4085);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4314:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4130);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4315:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4090);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4316:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4092);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4317:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4098);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4318:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4143);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4319:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4101);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4320:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4106);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4321:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4533);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4322:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4501);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4323:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4172);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4324:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4537);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4325:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4584);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4326:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4444);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4327:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4249);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4328:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4258);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4329:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4004);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4330:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4437);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4331:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4254);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4332:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'l') ADVANCE(4326);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4333:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4341);
      if (lookahead == 'n') ADVANCE(3951);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4334:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4418);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4335:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(3948);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4336:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4412);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4337:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4617);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4338:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4618);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4339:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4415);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4340:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4446);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4341:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(3963);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4342:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4459);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4343:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4166);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4344:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4137);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4345:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4433);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4346:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4133);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4347:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4438);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4348:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4153);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4349:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4456);
      if (lookahead == 'n') ADVANCE(4327);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4350:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'm') ADVANCE(4174);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4351:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4065);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4352:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3364);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4353:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3198);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4354:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3933);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4355:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4134);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4356:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3391);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4357:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3458);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4358:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3428);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4359:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3464);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4360:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3401);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4361:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3330);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4362:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3746);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4363:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4270);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4364:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4523);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4365:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4071);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4366:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4194);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4367:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4023);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4368:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4053);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4369:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4195);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4370:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4196);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4371:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4055);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4372:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4198);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4373:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4024);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4374:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4110);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4375:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4564);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4376:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4285);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4377:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4287);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4378:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4290);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4379:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4078);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4380:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4549);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4381:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4295);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4382:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4550);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4383:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4301);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4384:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4082);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4385:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4087);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4386:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4088);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4387:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4094);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4388:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4097);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4389:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4103);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4390:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4039);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4391:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4040);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4392:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4204);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4393:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(3979);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4394:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4235);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4395:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4530);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4396:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4577);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4397:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4236);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4398:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4581);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4399:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4603);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4400:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4436);
      if (lookahead == 'o') ADVANCE(4376);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4401:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4001);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4402:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4256);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4403:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4331);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4404:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'n') ADVANCE(4259);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4405:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4273);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4406:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4615);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4407:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4541);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4408:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4046);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4409:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4190);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4410:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4207);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4411:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4063);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4412:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4468);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4413:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4605);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4414:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4472);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4415:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4353);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4416:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4390);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4417:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4463);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4418:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4478);
      if (lookahead == 't') ADVANCE(3971);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4419:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4486);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4420:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4487);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4421:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4369);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4422:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4360);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4423:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4362);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4424:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4271);
      if (lookahead == 'r') ADVANCE(4596);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4425:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4035);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4426:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4064);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4427:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(3984);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4428:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4226);
      if (lookahead == 'p') ADVANCE(4036);
      if (lookahead == 't') ADVANCE(4465);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4429:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4156);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4430:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4377);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4431:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4229);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4432:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4384);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4433:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4378);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4434:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(3977);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4435:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(3989);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4436:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4386);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4437:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(3990);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4438:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4383);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4439:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4387);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4440:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4389);
      if (lookahead == 'u') ADVANCE(4312);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4441:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4231);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4442:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4243);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4443:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4611);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4444:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'o') ADVANCE(4049);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4445:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(3529);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4446:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(3916);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4447:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(3539);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4448:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(4542);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4449:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(3930);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4450:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(4126);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4451:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(4441);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4452:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(3959);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4453:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(4000);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4454:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(4095);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4455:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(4294);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4456:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(4296);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4457:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(4481);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4458:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(3923);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4459:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'p') ADVANCE(4587);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4460:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'q') ADVANCE(3536);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4461:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'q') ADVANCE(4597);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4462:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3183);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4463:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3611);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4464:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3189);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4465:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3337);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4466:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3749);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4467:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4132);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4468:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4622);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4469:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4193);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4470:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4429);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4471:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4203);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4472:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4181);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4473:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4409);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4474:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4217);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4475:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4112);
      if (lookahead == 'v') ADVANCE(3966);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4476:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4117);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4477:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4531);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4478:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4626);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4479:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3938);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4480:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4354);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4481:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4410);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4482:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4505);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4483:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4393);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4484:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3949);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4485:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4148);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4486:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3942);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4487:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3941);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4488:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4355);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4489:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4070);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4490:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3985);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4491:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4159);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4492:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4536);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4493:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4357);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4494:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(3996);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4495:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4359);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4496:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4401);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4497:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4091);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4498:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4136);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4499:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4164);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4500:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4138);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4501:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4144);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4502:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4206);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4503:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4161);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4504:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4604);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4505:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4417);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4506:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4168);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4507:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4173);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4508:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4421);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4509:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4442);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4510:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'r') ADVANCE(4208);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4511:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4044);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4512:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(3581);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4513:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(3548);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4514:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(3425);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4515:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(3509);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4516:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(3518);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4517:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(3455);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4518:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(3914);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4519:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4555);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4520:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4632);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4521:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(3953);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4522:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4543);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4523:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4215);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4524:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(3945);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4525:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4238);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4526:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4513);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4527:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4515);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4528:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4516);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4529:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4010);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4530:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4567);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4531:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4093);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4532:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4139);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4533:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4105);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4534:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4525);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4535:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4560);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4536:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4453);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4537:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4565);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4538:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4248);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4539:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4227);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4540:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 's') ADVANCE(4423);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4541:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3404);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4542:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4188);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4543:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3587);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4544:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3575);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4545:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3967);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4546:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3560);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4547:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3557);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4548:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4006);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4549:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3398);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4550:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3413);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4551:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3437);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4552:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3300);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4553:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3297);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4554:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4612);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4555:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4457);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4556:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4633);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4557:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4602);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4558:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4182);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4559:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4189);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4560:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3970);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4561:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3973);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4562:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4255);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4563:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4167);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4564:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4556);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4565:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3978);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4566:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4297);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4567:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4504);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4568:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4084);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4569:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3956);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4570:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4096);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4571:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4140);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4572:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3913);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4573:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4122);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4574:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4257);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4575:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4224);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4576:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4244);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4577:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3987);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4578:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4508);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4579:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(3981);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4580:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4251);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4581:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4145);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4582:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4252);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4583:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4171);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4584:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4230);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4585:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4003);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4586:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4601);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4587:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4005);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4588:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 't') ADVANCE(4007);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4589:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4216);
      if (lookahead == 'y') ADVANCE(4475);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4590:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4342);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4591:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4635);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4592:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4455);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4593:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4340);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4594:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4477);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4595:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4302);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4596:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4104);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4597:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4107);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4598:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4488);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4599:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4303);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4600:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4493);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4601:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4495);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4602:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4497);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4603:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4311);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4604:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4348);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4605:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4022);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4606:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'u') ADVANCE(4260);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4607:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'v') ADVANCE(3992);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4608:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'v') ADVANCE(3995);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4609:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'v') ADVANCE(4135);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4610:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'v') ADVANCE(4160);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4611:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'v') ADVANCE(4163);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4612:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'w') ADVANCE(4250);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4613:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'w') ADVANCE(4157);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4614:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'w') ADVANCE(4009);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4615:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'w') ADVANCE(4047);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4616:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'x') ADVANCE(4645);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4617:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'x') ADVANCE(3327);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4618:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'x') ADVANCE(3323);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4619:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'x') ADVANCE(4546);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4620:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'x') ADVANCE(4547);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4621:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'x') ADVANCE(4583);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4622:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'y') ADVANCE(3626);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4623:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'y') ADVANCE(3494);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4624:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'y') ADVANCE(3497);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4625:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'y') ADVANCE(3500);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4626:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'y') ADVANCE(3512);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4627:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'y') ADVANCE(3407);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4628:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'y') ADVANCE(3192);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4629:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'y') ADVANCE(3410);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4630:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'y') ADVANCE(4021);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4631:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'y') ADVANCE(4539);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4632:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'y') ADVANCE(4373);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4633:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'y') ADVANCE(4454);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4634:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'z') ADVANCE(4630);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(4651);
      END_STATE();
    case 4635:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'z') ADVANCE(4643);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(4651);
      END_STATE();
    case 4636:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'z') ADVANCE(4080);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(4651);
      END_STATE();
    case 4637:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'z') ADVANCE(4083);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(4651);
      END_STATE();
    case 4638:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'z') ADVANCE(4127);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(4651);
      END_STATE();
    case 4639:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'z') ADVANCE(4089);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(4651);
      END_STATE();
    case 4640:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'z') ADVANCE(4155);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(4651);
      END_STATE();
    case 4641:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'z') ADVANCE(4147);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(4651);
      END_STATE();
    case 4642:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'z') ADVANCE(4149);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(4651);
      END_STATE();
    case 4643:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'z') ADVANCE(4234);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(4651);
      END_STATE();
    case 4644:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'z') ADVANCE(4439);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(4651);
      END_STATE();
    case 4645:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == 'H' ||
          ('K' <= lookahead && lookahead <= 'M') ||
          lookahead == 'R') ADVANCE(4650);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(3154);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4646:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3151);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4647:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3144);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4648:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3340);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4649:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3160);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4650:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(3154);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4651:
      ACCEPT_TOKEN(aux_sym_specialized_md_value_token1);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(4651);
      END_STATE();
    case 4652:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 4653:
      ACCEPT_TOKEN(anon_sym_attributes);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 0},
  [2] = {.lex_state = 8},
  [3] = {.lex_state = 5},
  [4] = {.lex_state = 36},
  [5] = {.lex_state = 3},
  [6] = {.lex_state = 3},
  [7] = {.lex_state = 3},
  [8] = {.lex_state = 3},
  [9] = {.lex_state = 3},
  [10] = {.lex_state = 3},
  [11] = {.lex_state = 3},
  [12] = {.lex_state = 3},
  [13] = {.lex_state = 3108},
  [14] = {.lex_state = 3},
  [15] = {.lex_state = 3111},
  [16] = {.lex_state = 3},
  [17] = {.lex_state = 3},
  [18] = {.lex_state = 3},
  [19] = {.lex_state = 3},
  [20] = {.lex_state = 3},
  [21] = {.lex_state = 3},
  [22] = {.lex_state = 3},
  [23] = {.lex_state = 3},
  [24] = {.lex_state = 3},
  [25] = {.lex_state = 3},
  [26] = {.lex_state = 8},
  [27] = {.lex_state = 8},
  [28] = {.lex_state = 8},
  [29] = {.lex_state = 8},
  [30] = {.lex_state = 5},
  [31] = {.lex_state = 5},
  [32] = {.lex_state = 5},
  [33] = {.lex_state = 5},
  [34] = {.lex_state = 5},
  [35] = {.lex_state = 5},
  [36] = {.lex_state = 5},
  [37] = {.lex_state = 5},
  [38] = {.lex_state = 5},
  [39] = {.lex_state = 5},
  [40] = {.lex_state = 5},
  [41] = {.lex_state = 5},
  [42] = {.lex_state = 5},
  [43] = {.lex_state = 5},
  [44] = {.lex_state = 5},
  [45] = {.lex_state = 5},
  [46] = {.lex_state = 5},
  [47] = {.lex_state = 5},
  [48] = {.lex_state = 3108},
  [49] = {.lex_state = 3108},
  [50] = {.lex_state = 36},
  [51] = {.lex_state = 36},
  [52] = {.lex_state = 3111},
  [53] = {.lex_state = 36},
  [54] = {.lex_state = 36},
  [55] = {.lex_state = 3111},
  [56] = {.lex_state = 3108},
  [57] = {.lex_state = 3111},
  [58] = {.lex_state = 3108},
  [59] = {.lex_state = 3111},
  [60] = {.lex_state = 3111},
  [61] = {.lex_state = 3108},
  [62] = {.lex_state = 3108},
  [63] = {.lex_state = 3108},
  [64] = {.lex_state = 3108},
  [65] = {.lex_state = 3108},
  [66] = {.lex_state = 3108},
  [67] = {.lex_state = 3108},
  [68] = {.lex_state = 3108},
  [69] = {.lex_state = 3108},
  [70] = {.lex_state = 3108},
  [71] = {.lex_state = 3108},
  [72] = {.lex_state = 3108},
  [73] = {.lex_state = 3108},
  [74] = {.lex_state = 3108},
  [75] = {.lex_state = 3108},
  [76] = {.lex_state = 3108},
  [77] = {.lex_state = 3108},
  [78] = {.lex_state = 3108},
  [79] = {.lex_state = 3111},
  [80] = {.lex_state = 3111},
  [81] = {.lex_state = 3111},
  [82] = {.lex_state = 3111},
  [83] = {.lex_state = 3113},
  [84] = {.lex_state = 3114},
  [85] = {.lex_state = 3114},
  [86] = {.lex_state = 3114},
  [87] = {.lex_state = 3114},
  [88] = {.lex_state = 3114},
  [89] = {.lex_state = 3114},
  [90] = {.lex_state = 3114},
  [91] = {.lex_state = 3114},
  [92] = {.lex_state = 3114},
  [93] = {.lex_state = 3114},
  [94] = {.lex_state = 3114},
  [95] = {.lex_state = 3114},
  [96] = {.lex_state = 3114},
  [97] = {.lex_state = 3114},
  [98] = {.lex_state = 3114},
  [99] = {.lex_state = 3114},
  [100] = {.lex_state = 3113},
  [101] = {.lex_state = 3114},
  [102] = {.lex_state = 3114},
  [103] = {.lex_state = 3114},
  [104] = {.lex_state = 3114},
  [105] = {.lex_state = 3114},
  [106] = {.lex_state = 3114},
  [107] = {.lex_state = 3114},
  [108] = {.lex_state = 3114},
  [109] = {.lex_state = 3114},
  [110] = {.lex_state = 3114},
  [111] = {.lex_state = 3114},
  [112] = {.lex_state = 3114},
  [113] = {.lex_state = 3114},
  [114] = {.lex_state = 3114},
  [115] = {.lex_state = 3114},
  [116] = {.lex_state = 3114},
  [117] = {.lex_state = 3114},
  [118] = {.lex_state = 3114},
  [119] = {.lex_state = 3114},
  [120] = {.lex_state = 3114},
  [121] = {.lex_state = 3114},
  [122] = {.lex_state = 3114},
  [123] = {.lex_state = 3114},
  [124] = {.lex_state = 3114},
  [125] = {.lex_state = 3114},
  [126] = {.lex_state = 3113},
  [127] = {.lex_state = 36},
  [128] = {.lex_state = 36},
  [129] = {.lex_state = 3113},
  [130] = {.lex_state = 3113},
  [131] = {.lex_state = 3113},
  [132] = {.lex_state = 3113},
  [133] = {.lex_state = 3113},
  [134] = {.lex_state = 3113},
  [135] = {.lex_state = 3113},
  [136] = {.lex_state = 3113},
  [137] = {.lex_state = 36},
  [138] = {.lex_state = 36},
  [139] = {.lex_state = 36},
  [140] = {.lex_state = 36},
  [141] = {.lex_state = 36},
  [142] = {.lex_state = 36},
  [143] = {.lex_state = 36},
  [144] = {.lex_state = 36},
  [145] = {.lex_state = 36},
  [146] = {.lex_state = 36},
  [147] = {.lex_state = 36},
  [148] = {.lex_state = 36},
  [149] = {.lex_state = 36},
  [150] = {.lex_state = 36},
  [151] = {.lex_state = 36},
  [152] = {.lex_state = 36},
  [153] = {.lex_state = 36},
  [154] = {.lex_state = 36},
  [155] = {.lex_state = 36},
  [156] = {.lex_state = 36},
  [157] = {.lex_state = 36},
  [158] = {.lex_state = 36},
  [159] = {.lex_state = 36},
  [160] = {.lex_state = 36},
  [161] = {.lex_state = 36},
  [162] = {.lex_state = 36},
  [163] = {.lex_state = 36},
  [164] = {.lex_state = 36},
  [165] = {.lex_state = 36},
  [166] = {.lex_state = 36},
  [167] = {.lex_state = 36},
  [168] = {.lex_state = 36},
  [169] = {.lex_state = 36},
  [170] = {.lex_state = 36},
  [171] = {.lex_state = 36},
  [172] = {.lex_state = 36},
  [173] = {.lex_state = 36},
  [174] = {.lex_state = 36},
  [175] = {.lex_state = 36},
  [176] = {.lex_state = 36},
  [177] = {.lex_state = 36},
  [178] = {.lex_state = 36},
  [179] = {.lex_state = 36},
  [180] = {.lex_state = 36},
  [181] = {.lex_state = 36},
  [182] = {.lex_state = 36},
  [183] = {.lex_state = 36},
  [184] = {.lex_state = 36},
  [185] = {.lex_state = 36},
  [186] = {.lex_state = 36},
  [187] = {.lex_state = 36},
  [188] = {.lex_state = 3113},
  [189] = {.lex_state = 36},
  [190] = {.lex_state = 36},
  [191] = {.lex_state = 36},
  [192] = {.lex_state = 36},
  [193] = {.lex_state = 36},
  [194] = {.lex_state = 36},
  [195] = {.lex_state = 36},
  [196] = {.lex_state = 36},
  [197] = {.lex_state = 3113},
  [198] = {.lex_state = 36},
  [199] = {.lex_state = 37},
  [200] = {.lex_state = 3111},
  [201] = {.lex_state = 3113},
  [202] = {.lex_state = 37},
  [203] = {.lex_state = 37},
  [204] = {.lex_state = 3113},
  [205] = {.lex_state = 3113},
  [206] = {.lex_state = 37},
  [207] = {.lex_state = 37},
  [208] = {.lex_state = 37},
  [209] = {.lex_state = 37},
  [210] = {.lex_state = 37},
  [211] = {.lex_state = 37},
  [212] = {.lex_state = 37},
  [213] = {.lex_state = 3111},
  [214] = {.lex_state = 36},
  [215] = {.lex_state = 3111},
  [216] = {.lex_state = 3111},
  [217] = {.lex_state = 36},
  [218] = {.lex_state = 36},
  [219] = {.lex_state = 3111},
  [220] = {.lex_state = 36},
  [221] = {.lex_state = 36},
  [222] = {.lex_state = 36},
  [223] = {.lex_state = 3111},
  [224] = {.lex_state = 36},
  [225] = {.lex_state = 3111},
  [226] = {.lex_state = 3111},
  [227] = {.lex_state = 36},
  [228] = {.lex_state = 36},
  [229] = {.lex_state = 3111},
  [230] = {.lex_state = 3111},
  [231] = {.lex_state = 3111},
  [232] = {.lex_state = 3111},
  [233] = {.lex_state = 3111},
  [234] = {.lex_state = 3113},
  [235] = {.lex_state = 6},
  [236] = {.lex_state = 3113},
  [237] = {.lex_state = 40},
  [238] = {.lex_state = 3113},
  [239] = {.lex_state = 3113},
  [240] = {.lex_state = 3113},
  [241] = {.lex_state = 3113},
  [242] = {.lex_state = 3113},
  [243] = {.lex_state = 3113},
  [244] = {.lex_state = 3113},
  [245] = {.lex_state = 3113},
  [246] = {.lex_state = 3113},
  [247] = {.lex_state = 3113},
  [248] = {.lex_state = 3113},
  [249] = {.lex_state = 6},
  [250] = {.lex_state = 40},
  [251] = {.lex_state = 3113},
  [252] = {.lex_state = 3113},
  [253] = {.lex_state = 3107},
  [254] = {.lex_state = 3113},
  [255] = {.lex_state = 3113},
  [256] = {.lex_state = 3109},
  [257] = {.lex_state = 3107},
  [258] = {.lex_state = 3109},
  [259] = {.lex_state = 3109},
  [260] = {.lex_state = 3109},
  [261] = {.lex_state = 3109},
  [262] = {.lex_state = 3109},
  [263] = {.lex_state = 3107},
  [264] = {.lex_state = 3109},
  [265] = {.lex_state = 3109},
  [266] = {.lex_state = 3107},
  [267] = {.lex_state = 3109},
  [268] = {.lex_state = 3107},
  [269] = {.lex_state = 3107},
  [270] = {.lex_state = 3109},
  [271] = {.lex_state = 3109},
  [272] = {.lex_state = 3109},
  [273] = {.lex_state = 3109},
  [274] = {.lex_state = 3107},
  [275] = {.lex_state = 3109},
  [276] = {.lex_state = 3109},
  [277] = {.lex_state = 3109},
  [278] = {.lex_state = 3107},
  [279] = {.lex_state = 3107},
  [280] = {.lex_state = 3109},
  [281] = {.lex_state = 3109},
  [282] = {.lex_state = 3115},
  [283] = {.lex_state = 3115},
  [284] = {.lex_state = 3115},
  [285] = {.lex_state = 6},
  [286] = {.lex_state = 6},
  [287] = {.lex_state = 6},
  [288] = {.lex_state = 3115},
  [289] = {.lex_state = 6},
  [290] = {.lex_state = 6},
  [291] = {.lex_state = 3109},
  [292] = {.lex_state = 3115},
  [293] = {.lex_state = 6},
  [294] = {.lex_state = 3115},
  [295] = {.lex_state = 3109},
  [296] = {.lex_state = 3115},
  [297] = {.lex_state = 3107},
  [298] = {.lex_state = 6},
  [299] = {.lex_state = 6},
  [300] = {.lex_state = 6},
  [301] = {.lex_state = 6},
  [302] = {.lex_state = 3110},
  [303] = {.lex_state = 6},
  [304] = {.lex_state = 3110},
  [305] = {.lex_state = 6},
  [306] = {.lex_state = 6},
  [307] = {.lex_state = 6},
  [308] = {.lex_state = 6},
  [309] = {.lex_state = 6},
  [310] = {.lex_state = 6},
  [311] = {.lex_state = 6},
  [312] = {.lex_state = 3107},
  [313] = {.lex_state = 3107},
  [314] = {.lex_state = 3107},
  [315] = {.lex_state = 3107},
  [316] = {.lex_state = 3107},
  [317] = {.lex_state = 3107},
  [318] = {.lex_state = 3107},
  [319] = {.lex_state = 3107},
  [320] = {.lex_state = 3107},
  [321] = {.lex_state = 3107},
  [322] = {.lex_state = 3107},
  [323] = {.lex_state = 3107},
  [324] = {.lex_state = 3107},
  [325] = {.lex_state = 3107},
  [326] = {.lex_state = 3107},
  [327] = {.lex_state = 3107},
  [328] = {.lex_state = 3107},
  [329] = {.lex_state = 3107},
  [330] = {.lex_state = 3107},
  [331] = {.lex_state = 3107},
  [332] = {.lex_state = 3107},
  [333] = {.lex_state = 3107},
  [334] = {.lex_state = 3107},
  [335] = {.lex_state = 3107},
  [336] = {.lex_state = 3107},
  [337] = {.lex_state = 3107},
  [338] = {.lex_state = 3107},
  [339] = {.lex_state = 3107},
  [340] = {.lex_state = 3107},
  [341] = {.lex_state = 3107},
  [342] = {.lex_state = 3107},
  [343] = {.lex_state = 3107},
  [344] = {.lex_state = 3107},
  [345] = {.lex_state = 3107},
  [346] = {.lex_state = 3107},
  [347] = {.lex_state = 3107},
  [348] = {.lex_state = 3107},
  [349] = {.lex_state = 3107},
  [350] = {.lex_state = 3107},
  [351] = {.lex_state = 3107},
  [352] = {.lex_state = 3107},
  [353] = {.lex_state = 3107},
  [354] = {.lex_state = 3107},
  [355] = {.lex_state = 3107},
  [356] = {.lex_state = 3107},
  [357] = {.lex_state = 3107},
  [358] = {.lex_state = 3107},
  [359] = {.lex_state = 3107},
  [360] = {.lex_state = 3107},
  [361] = {.lex_state = 3107},
  [362] = {.lex_state = 40},
  [363] = {.lex_state = 40},
  [364] = {.lex_state = 40},
  [365] = {.lex_state = 40},
  [366] = {.lex_state = 3107},
  [367] = {.lex_state = 36},
  [368] = {.lex_state = 36},
  [369] = {.lex_state = 36},
  [370] = {.lex_state = 4},
  [371] = {.lex_state = 3115},
  [372] = {.lex_state = 9},
  [373] = {.lex_state = 3115},
  [374] = {.lex_state = 3115},
  [375] = {.lex_state = 3115},
  [376] = {.lex_state = 3109},
  [377] = {.lex_state = 3115},
  [378] = {.lex_state = 3115},
  [379] = {.lex_state = 3115},
  [380] = {.lex_state = 3115},
  [381] = {.lex_state = 3115},
  [382] = {.lex_state = 3109},
  [383] = {.lex_state = 3109},
  [384] = {.lex_state = 3115},
  [385] = {.lex_state = 3115},
  [386] = {.lex_state = 3115},
  [387] = {.lex_state = 3115},
  [388] = {.lex_state = 3115},
  [389] = {.lex_state = 3115},
  [390] = {.lex_state = 3115},
  [391] = {.lex_state = 3115},
  [392] = {.lex_state = 3115},
  [393] = {.lex_state = 3107},
  [394] = {.lex_state = 3107},
  [395] = {.lex_state = 3107},
  [396] = {.lex_state = 3107},
  [397] = {.lex_state = 3107},
  [398] = {.lex_state = 3107},
  [399] = {.lex_state = 3107},
  [400] = {.lex_state = 3107},
  [401] = {.lex_state = 3107},
  [402] = {.lex_state = 3107},
  [403] = {.lex_state = 3108},
  [404] = {.lex_state = 3107},
  [405] = {.lex_state = 3107},
  [406] = {.lex_state = 3107},
  [407] = {.lex_state = 3107},
  [408] = {.lex_state = 3108},
  [409] = {.lex_state = 3107},
  [410] = {.lex_state = 3108},
  [411] = {.lex_state = 3108},
  [412] = {.lex_state = 3107},
  [413] = {.lex_state = 3108},
  [414] = {.lex_state = 3107},
  [415] = {.lex_state = 3107},
  [416] = {.lex_state = 3111},
  [417] = {.lex_state = 3107},
  [418] = {.lex_state = 3108},
  [419] = {.lex_state = 3108},
  [420] = {.lex_state = 3108},
  [421] = {.lex_state = 3108},
  [422] = {.lex_state = 3108},
  [423] = {.lex_state = 3108},
  [424] = {.lex_state = 3108},
  [425] = {.lex_state = 3108},
  [426] = {.lex_state = 3108},
  [427] = {.lex_state = 3108},
  [428] = {.lex_state = 3108},
  [429] = {.lex_state = 3108},
  [430] = {.lex_state = 3108},
  [431] = {.lex_state = 3108},
  [432] = {.lex_state = 3108},
  [433] = {.lex_state = 3107},
  [434] = {.lex_state = 3108},
  [435] = {.lex_state = 3108},
  [436] = {.lex_state = 3107},
  [437] = {.lex_state = 3108},
  [438] = {.lex_state = 3108},
  [439] = {.lex_state = 3107},
  [440] = {.lex_state = 3108},
  [441] = {.lex_state = 3108},
  [442] = {.lex_state = 3108},
  [443] = {.lex_state = 3108},
  [444] = {.lex_state = 3108},
  [445] = {.lex_state = 11},
  [446] = {.lex_state = 3108},
  [447] = {.lex_state = 3108},
  [448] = {.lex_state = 3108},
  [449] = {.lex_state = 3108},
  [450] = {.lex_state = 3108},
  [451] = {.lex_state = 3108},
  [452] = {.lex_state = 3108},
  [453] = {.lex_state = 3108},
  [454] = {.lex_state = 3108},
  [455] = {.lex_state = 3108},
  [456] = {.lex_state = 3108},
  [457] = {.lex_state = 3108},
  [458] = {.lex_state = 3108},
  [459] = {.lex_state = 3108},
  [460] = {.lex_state = 3108},
  [461] = {.lex_state = 3108},
  [462] = {.lex_state = 3108},
  [463] = {.lex_state = 3108},
  [464] = {.lex_state = 3108},
  [465] = {.lex_state = 3108},
  [466] = {.lex_state = 11},
  [467] = {.lex_state = 11},
  [468] = {.lex_state = 3108},
  [469] = {.lex_state = 11},
  [470] = {.lex_state = 3108},
  [471] = {.lex_state = 11},
  [472] = {.lex_state = 11},
  [473] = {.lex_state = 11},
  [474] = {.lex_state = 3108},
  [475] = {.lex_state = 3108},
  [476] = {.lex_state = 3108},
  [477] = {.lex_state = 3108},
  [478] = {.lex_state = 3107},
  [479] = {.lex_state = 3107},
  [480] = {.lex_state = 3108},
  [481] = {.lex_state = 3108},
  [482] = {.lex_state = 3108},
  [483] = {.lex_state = 11},
  [484] = {.lex_state = 3108},
  [485] = {.lex_state = 11},
  [486] = {.lex_state = 3108},
  [487] = {.lex_state = 11},
  [488] = {.lex_state = 3108},
  [489] = {.lex_state = 11},
  [490] = {.lex_state = 11},
  [491] = {.lex_state = 11},
  [492] = {.lex_state = 11},
  [493] = {.lex_state = 11},
  [494] = {.lex_state = 11},
  [495] = {.lex_state = 11},
  [496] = {.lex_state = 11},
  [497] = {.lex_state = 11},
  [498] = {.lex_state = 3108},
  [499] = {.lex_state = 3108},
  [500] = {.lex_state = 3108},
  [501] = {.lex_state = 3108},
  [502] = {.lex_state = 3108},
  [503] = {.lex_state = 3108},
  [504] = {.lex_state = 3108},
  [505] = {.lex_state = 3108},
  [506] = {.lex_state = 3108},
  [507] = {.lex_state = 3108},
  [508] = {.lex_state = 3108},
  [509] = {.lex_state = 3108},
  [510] = {.lex_state = 3108},
  [511] = {.lex_state = 3108},
  [512] = {.lex_state = 3108},
  [513] = {.lex_state = 3108},
  [514] = {.lex_state = 3108},
  [515] = {.lex_state = 3108},
  [516] = {.lex_state = 3108},
  [517] = {.lex_state = 3108},
  [518] = {.lex_state = 3108},
  [519] = {.lex_state = 3108},
  [520] = {.lex_state = 3108},
  [521] = {.lex_state = 3108},
  [522] = {.lex_state = 3108},
  [523] = {.lex_state = 3108},
  [524] = {.lex_state = 3108},
  [525] = {.lex_state = 3108},
  [526] = {.lex_state = 3108},
  [527] = {.lex_state = 3108},
  [528] = {.lex_state = 3108},
  [529] = {.lex_state = 3108},
  [530] = {.lex_state = 3108},
  [531] = {.lex_state = 3108},
  [532] = {.lex_state = 3108},
  [533] = {.lex_state = 3108},
  [534] = {.lex_state = 3108},
  [535] = {.lex_state = 3108},
  [536] = {.lex_state = 3108},
  [537] = {.lex_state = 3108},
  [538] = {.lex_state = 3108},
  [539] = {.lex_state = 3108},
  [540] = {.lex_state = 3108},
  [541] = {.lex_state = 3108},
  [542] = {.lex_state = 3108},
  [543] = {.lex_state = 4},
  [544] = {.lex_state = 4},
  [545] = {.lex_state = 4},
  [546] = {.lex_state = 4},
  [547] = {.lex_state = 4},
  [548] = {.lex_state = 4},
  [549] = {.lex_state = 4},
  [550] = {.lex_state = 3111},
  [551] = {.lex_state = 4},
  [552] = {.lex_state = 4},
  [553] = {.lex_state = 4},
  [554] = {.lex_state = 4},
  [555] = {.lex_state = 4},
  [556] = {.lex_state = 4},
  [557] = {.lex_state = 4},
  [558] = {.lex_state = 3111},
  [559] = {.lex_state = 4},
  [560] = {.lex_state = 4},
  [561] = {.lex_state = 4},
  [562] = {.lex_state = 4},
  [563] = {.lex_state = 9},
  [564] = {.lex_state = 9},
  [565] = {.lex_state = 9},
  [566] = {.lex_state = 9},
  [567] = {.lex_state = 36},
  [568] = {.lex_state = 36},
  [569] = {.lex_state = 36},
  [570] = {.lex_state = 36},
  [571] = {.lex_state = 36},
  [572] = {.lex_state = 36},
  [573] = {.lex_state = 36},
  [574] = {.lex_state = 36},
  [575] = {.lex_state = 36},
  [576] = {.lex_state = 36},
  [577] = {.lex_state = 36},
  [578] = {.lex_state = 36},
  [579] = {.lex_state = 36},
  [580] = {.lex_state = 36},
  [581] = {.lex_state = 36},
  [582] = {.lex_state = 36},
  [583] = {.lex_state = 36},
  [584] = {.lex_state = 36},
  [585] = {.lex_state = 36},
  [586] = {.lex_state = 36},
  [587] = {.lex_state = 36},
  [588] = {.lex_state = 36},
  [589] = {.lex_state = 36},
  [590] = {.lex_state = 36},
  [591] = {.lex_state = 36},
  [592] = {.lex_state = 36},
  [593] = {.lex_state = 36},
  [594] = {.lex_state = 36},
  [595] = {.lex_state = 36},
  [596] = {.lex_state = 36},
  [597] = {.lex_state = 36},
  [598] = {.lex_state = 36},
  [599] = {.lex_state = 36},
  [600] = {.lex_state = 36},
  [601] = {.lex_state = 36},
  [602] = {.lex_state = 36},
  [603] = {.lex_state = 36},
  [604] = {.lex_state = 36},
  [605] = {.lex_state = 36},
  [606] = {.lex_state = 36},
  [607] = {.lex_state = 36},
  [608] = {.lex_state = 36},
  [609] = {.lex_state = 36},
  [610] = {.lex_state = 36},
  [611] = {.lex_state = 36},
  [612] = {.lex_state = 36},
  [613] = {.lex_state = 36},
  [614] = {.lex_state = 36},
  [615] = {.lex_state = 36},
  [616] = {.lex_state = 36},
  [617] = {.lex_state = 36},
  [618] = {.lex_state = 36},
  [619] = {.lex_state = 36},
  [620] = {.lex_state = 36},
  [621] = {.lex_state = 36},
  [622] = {.lex_state = 36},
  [623] = {.lex_state = 36},
  [624] = {.lex_state = 36},
  [625] = {.lex_state = 36},
  [626] = {.lex_state = 36},
  [627] = {.lex_state = 36},
  [628] = {.lex_state = 36},
  [629] = {.lex_state = 36},
  [630] = {.lex_state = 36},
  [631] = {.lex_state = 36},
  [632] = {.lex_state = 36},
  [633] = {.lex_state = 36},
  [634] = {.lex_state = 36},
  [635] = {.lex_state = 36},
  [636] = {.lex_state = 36},
  [637] = {.lex_state = 36},
  [638] = {.lex_state = 36},
  [639] = {.lex_state = 36},
  [640] = {.lex_state = 36},
  [641] = {.lex_state = 36},
  [642] = {.lex_state = 36},
  [643] = {.lex_state = 36},
  [644] = {.lex_state = 36},
  [645] = {.lex_state = 36},
  [646] = {.lex_state = 36},
  [647] = {.lex_state = 36},
  [648] = {.lex_state = 36},
  [649] = {.lex_state = 36},
  [650] = {.lex_state = 36},
  [651] = {.lex_state = 36},
  [652] = {.lex_state = 36},
  [653] = {.lex_state = 36},
  [654] = {.lex_state = 36},
  [655] = {.lex_state = 36},
  [656] = {.lex_state = 36},
  [657] = {.lex_state = 36},
  [658] = {.lex_state = 36},
  [659] = {.lex_state = 36},
  [660] = {.lex_state = 36},
  [661] = {.lex_state = 36},
  [662] = {.lex_state = 36},
  [663] = {.lex_state = 36},
  [664] = {.lex_state = 36},
  [665] = {.lex_state = 36},
  [666] = {.lex_state = 36},
  [667] = {.lex_state = 36},
  [668] = {.lex_state = 36},
  [669] = {.lex_state = 36},
  [670] = {.lex_state = 36},
  [671] = {.lex_state = 36},
  [672] = {.lex_state = 36},
  [673] = {.lex_state = 36},
  [674] = {.lex_state = 36},
  [675] = {.lex_state = 36},
  [676] = {.lex_state = 36},
  [677] = {.lex_state = 36},
  [678] = {.lex_state = 36},
  [679] = {.lex_state = 36},
  [680] = {.lex_state = 36},
  [681] = {.lex_state = 36},
  [682] = {.lex_state = 36},
  [683] = {.lex_state = 36},
  [684] = {.lex_state = 36},
  [685] = {.lex_state = 36},
  [686] = {.lex_state = 36},
  [687] = {.lex_state = 36},
  [688] = {.lex_state = 36},
  [689] = {.lex_state = 36},
  [690] = {.lex_state = 36},
  [691] = {.lex_state = 8},
  [692] = {.lex_state = 8},
  [693] = {.lex_state = 2},
  [694] = {.lex_state = 2},
  [695] = {.lex_state = 2},
  [696] = {.lex_state = 2},
  [697] = {.lex_state = 2},
  [698] = {.lex_state = 2},
  [699] = {.lex_state = 2},
  [700] = {.lex_state = 2},
  [701] = {.lex_state = 2},
  [702] = {.lex_state = 2},
  [703] = {.lex_state = 2},
  [704] = {.lex_state = 2},
  [705] = {.lex_state = 2},
  [706] = {.lex_state = 2},
  [707] = {.lex_state = 2},
  [708] = {.lex_state = 2},
  [709] = {.lex_state = 2},
  [710] = {.lex_state = 2},
  [711] = {.lex_state = 2},
  [712] = {.lex_state = 7},
  [713] = {.lex_state = 7},
  [714] = {.lex_state = 1},
  [715] = {.lex_state = 1},
  [716] = {.lex_state = 2},
  [717] = {.lex_state = 2},
  [718] = {.lex_state = 2},
  [719] = {.lex_state = 2},
  [720] = {.lex_state = 2},
  [721] = {.lex_state = 2},
  [722] = {.lex_state = 2},
  [723] = {.lex_state = 2},
  [724] = {.lex_state = 2},
  [725] = {.lex_state = 2},
  [726] = {.lex_state = 2},
  [727] = {.lex_state = 2},
  [728] = {.lex_state = 3107},
  [729] = {.lex_state = 3107},
  [730] = {.lex_state = 3107},
  [731] = {.lex_state = 0},
  [732] = {.lex_state = 0},
  [733] = {.lex_state = 3107},
  [734] = {.lex_state = 3107},
  [735] = {.lex_state = 3107},
  [736] = {.lex_state = 3107},
  [737] = {.lex_state = 3107},
  [738] = {.lex_state = 7},
  [739] = {.lex_state = 7},
  [740] = {.lex_state = 7},
  [741] = {.lex_state = 7},
  [742] = {.lex_state = 7},
  [743] = {.lex_state = 7},
  [744] = {.lex_state = 3107},
  [745] = {.lex_state = 7},
  [746] = {.lex_state = 7},
  [747] = {.lex_state = 7},
  [748] = {.lex_state = 7},
  [749] = {.lex_state = 7},
  [750] = {.lex_state = 7},
  [751] = {.lex_state = 0},
  [752] = {.lex_state = 3107},
  [753] = {.lex_state = 3107},
  [754] = {.lex_state = 0},
  [755] = {.lex_state = 0},
  [756] = {.lex_state = 7},
  [757] = {.lex_state = 3107},
  [758] = {.lex_state = 3107},
  [759] = {.lex_state = 3107},
  [760] = {.lex_state = 3108},
  [761] = {.lex_state = 3107},
  [762] = {.lex_state = 3107},
  [763] = {.lex_state = 3107},
  [764] = {.lex_state = 3107},
  [765] = {.lex_state = 3107},
  [766] = {.lex_state = 3107},
  [767] = {.lex_state = 3107},
  [768] = {.lex_state = 3107},
  [769] = {.lex_state = 3108},
  [770] = {.lex_state = 3107},
  [771] = {.lex_state = 3107},
  [772] = {.lex_state = 3107},
  [773] = {.lex_state = 3107},
  [774] = {.lex_state = 3107},
  [775] = {.lex_state = 3107},
  [776] = {.lex_state = 3107},
  [777] = {.lex_state = 3107},
  [778] = {.lex_state = 3107},
  [779] = {.lex_state = 3107},
  [780] = {.lex_state = 3108},
  [781] = {.lex_state = 3107},
  [782] = {.lex_state = 41},
  [783] = {.lex_state = 3107},
  [784] = {.lex_state = 8},
  [785] = {.lex_state = 3107},
  [786] = {.lex_state = 3107},
  [787] = {.lex_state = 41},
  [788] = {.lex_state = 3107},
  [789] = {.lex_state = 41},
  [790] = {.lex_state = 3107},
  [791] = {.lex_state = 3107},
  [792] = {.lex_state = 3107},
  [793] = {.lex_state = 3107},
  [794] = {.lex_state = 3107},
  [795] = {.lex_state = 41},
  [796] = {.lex_state = 3107},
  [797] = {.lex_state = 3107},
  [798] = {.lex_state = 41},
  [799] = {.lex_state = 3107},
  [800] = {.lex_state = 3107},
  [801] = {.lex_state = 3107},
  [802] = {.lex_state = 3107},
  [803] = {.lex_state = 3107},
  [804] = {.lex_state = 3107},
  [805] = {.lex_state = 41},
  [806] = {.lex_state = 3107},
  [807] = {.lex_state = 3107},
  [808] = {.lex_state = 41},
  [809] = {.lex_state = 3107},
  [810] = {.lex_state = 41},
  [811] = {.lex_state = 3107},
  [812] = {.lex_state = 3107},
  [813] = {.lex_state = 3107},
  [814] = {.lex_state = 41},
  [815] = {.lex_state = 41},
  [816] = {.lex_state = 3107},
  [817] = {.lex_state = 8},
  [818] = {.lex_state = 3107},
  [819] = {.lex_state = 8},
  [820] = {.lex_state = 8},
  [821] = {.lex_state = 3107},
  [822] = {.lex_state = 3107},
  [823] = {.lex_state = 3107},
  [824] = {.lex_state = 3107},
  [825] = {.lex_state = 0},
  [826] = {.lex_state = 0},
  [827] = {.lex_state = 0},
  [828] = {.lex_state = 0},
  [829] = {.lex_state = 0},
  [830] = {.lex_state = 3107},
  [831] = {.lex_state = 3107},
  [832] = {.lex_state = 3107},
  [833] = {.lex_state = 3107},
  [834] = {.lex_state = 3107},
  [835] = {.lex_state = 3107},
  [836] = {.lex_state = 3107},
  [837] = {.lex_state = 3107},
  [838] = {.lex_state = 3107},
  [839] = {.lex_state = 3107},
  [840] = {.lex_state = 3107},
  [841] = {.lex_state = 3107},
  [842] = {.lex_state = 3107},
  [843] = {.lex_state = 3107},
  [844] = {.lex_state = 3107},
  [845] = {.lex_state = 3108},
  [846] = {.lex_state = 3107},
  [847] = {.lex_state = 3107},
  [848] = {.lex_state = 3107},
  [849] = {.lex_state = 3107},
  [850] = {.lex_state = 3107},
  [851] = {.lex_state = 3107},
  [852] = {.lex_state = 3107},
  [853] = {.lex_state = 3107},
  [854] = {.lex_state = 3107},
  [855] = {.lex_state = 3107},
  [856] = {.lex_state = 3107},
  [857] = {.lex_state = 3107},
  [858] = {.lex_state = 3107},
  [859] = {.lex_state = 3107},
  [860] = {.lex_state = 3107},
  [861] = {.lex_state = 3107},
  [862] = {.lex_state = 3107},
  [863] = {.lex_state = 3107},
  [864] = {.lex_state = 3107},
  [865] = {.lex_state = 3107},
  [866] = {.lex_state = 3107},
  [867] = {.lex_state = 3107},
  [868] = {.lex_state = 3107},
  [869] = {.lex_state = 3107},
  [870] = {.lex_state = 3107},
  [871] = {.lex_state = 3107},
  [872] = {.lex_state = 3107},
  [873] = {.lex_state = 3107},
  [874] = {.lex_state = 3107},
  [875] = {.lex_state = 3107},
  [876] = {.lex_state = 3107},
  [877] = {.lex_state = 3107},
  [878] = {.lex_state = 3107},
  [879] = {.lex_state = 3107},
  [880] = {.lex_state = 3107},
  [881] = {.lex_state = 3107},
  [882] = {.lex_state = 3107},
  [883] = {.lex_state = 3107},
  [884] = {.lex_state = 3107},
  [885] = {.lex_state = 3107},
  [886] = {.lex_state = 3107},
  [887] = {.lex_state = 3107},
  [888] = {.lex_state = 3107},
  [889] = {.lex_state = 3107},
  [890] = {.lex_state = 3107},
  [891] = {.lex_state = 3107},
  [892] = {.lex_state = 3107},
  [893] = {.lex_state = 3107},
  [894] = {.lex_state = 3107},
  [895] = {.lex_state = 3107},
  [896] = {.lex_state = 3107},
  [897] = {.lex_state = 3107},
  [898] = {.lex_state = 3107},
  [899] = {.lex_state = 3107},
  [900] = {.lex_state = 3107},
  [901] = {.lex_state = 3107},
  [902] = {.lex_state = 3107},
  [903] = {.lex_state = 3107},
  [904] = {.lex_state = 3107},
  [905] = {.lex_state = 3107},
  [906] = {.lex_state = 3107},
  [907] = {.lex_state = 3107},
  [908] = {.lex_state = 3107},
  [909] = {.lex_state = 3107},
  [910] = {.lex_state = 3107},
  [911] = {.lex_state = 3107},
  [912] = {.lex_state = 3107},
  [913] = {.lex_state = 3107},
  [914] = {.lex_state = 3107},
  [915] = {.lex_state = 3107},
  [916] = {.lex_state = 3107},
  [917] = {.lex_state = 3107},
  [918] = {.lex_state = 3107},
  [919] = {.lex_state = 3107},
  [920] = {.lex_state = 3107},
  [921] = {.lex_state = 3107},
  [922] = {.lex_state = 3107},
  [923] = {.lex_state = 3107},
  [924] = {.lex_state = 3107},
  [925] = {.lex_state = 3107},
  [926] = {.lex_state = 3107},
  [927] = {.lex_state = 3107},
  [928] = {.lex_state = 3107},
  [929] = {.lex_state = 3107},
  [930] = {.lex_state = 3107},
  [931] = {.lex_state = 3107},
  [932] = {.lex_state = 3107},
  [933] = {.lex_state = 3107},
  [934] = {.lex_state = 3107},
  [935] = {.lex_state = 3107},
  [936] = {.lex_state = 3107},
  [937] = {.lex_state = 3107},
  [938] = {.lex_state = 3107},
  [939] = {.lex_state = 3107},
  [940] = {.lex_state = 3107},
  [941] = {.lex_state = 3107},
  [942] = {.lex_state = 3107},
  [943] = {.lex_state = 3107},
  [944] = {.lex_state = 3107},
  [945] = {.lex_state = 3107},
  [946] = {.lex_state = 3107},
  [947] = {.lex_state = 3107},
  [948] = {.lex_state = 3107},
  [949] = {.lex_state = 3107},
  [950] = {.lex_state = 3107},
  [951] = {.lex_state = 3107},
  [952] = {.lex_state = 3107},
  [953] = {.lex_state = 3107},
  [954] = {.lex_state = 3107},
  [955] = {.lex_state = 3107},
  [956] = {.lex_state = 3107},
  [957] = {.lex_state = 3107},
  [958] = {.lex_state = 3107},
  [959] = {.lex_state = 3107},
  [960] = {.lex_state = 3107},
  [961] = {.lex_state = 3107},
  [962] = {.lex_state = 3107},
  [963] = {.lex_state = 3107},
  [964] = {.lex_state = 3107},
  [965] = {.lex_state = 3107},
  [966] = {.lex_state = 3107},
  [967] = {.lex_state = 3107},
  [968] = {.lex_state = 3107},
  [969] = {.lex_state = 3107},
  [970] = {.lex_state = 3107},
  [971] = {.lex_state = 3107},
  [972] = {.lex_state = 3107},
  [973] = {.lex_state = 3107},
  [974] = {.lex_state = 3107},
  [975] = {.lex_state = 3107},
  [976] = {.lex_state = 3107},
  [977] = {.lex_state = 3107},
  [978] = {.lex_state = 3107},
  [979] = {.lex_state = 3107},
  [980] = {.lex_state = 3107},
  [981] = {.lex_state = 3107},
  [982] = {.lex_state = 3107},
  [983] = {.lex_state = 3107},
  [984] = {.lex_state = 3107},
  [985] = {.lex_state = 3107},
  [986] = {.lex_state = 3107},
  [987] = {.lex_state = 3107},
  [988] = {.lex_state = 3107},
  [989] = {.lex_state = 3107},
  [990] = {.lex_state = 3107},
  [991] = {.lex_state = 3107},
  [992] = {.lex_state = 3107},
  [993] = {.lex_state = 3107},
  [994] = {.lex_state = 3107},
  [995] = {.lex_state = 3107},
  [996] = {.lex_state = 3107},
  [997] = {.lex_state = 3107},
  [998] = {.lex_state = 3107},
  [999] = {.lex_state = 3107},
  [1000] = {.lex_state = 3107},
  [1001] = {.lex_state = 3107},
  [1002] = {.lex_state = 3107},
  [1003] = {.lex_state = 3107},
  [1004] = {.lex_state = 3107},
  [1005] = {.lex_state = 3107},
  [1006] = {.lex_state = 3107},
  [1007] = {.lex_state = 3107},
  [1008] = {.lex_state = 3107},
  [1009] = {.lex_state = 3107},
  [1010] = {.lex_state = 3107},
  [1011] = {.lex_state = 3107},
  [1012] = {.lex_state = 3107},
  [1013] = {.lex_state = 3107},
  [1014] = {.lex_state = 3107},
  [1015] = {.lex_state = 3107},
  [1016] = {.lex_state = 3107},
  [1017] = {.lex_state = 3107},
  [1018] = {.lex_state = 3107},
  [1019] = {.lex_state = 3107},
  [1020] = {.lex_state = 3107},
  [1021] = {.lex_state = 3107},
  [1022] = {.lex_state = 3107},
  [1023] = {.lex_state = 3107},
  [1024] = {.lex_state = 3107},
  [1025] = {.lex_state = 3107},
  [1026] = {.lex_state = 3107},
  [1027] = {.lex_state = 3107},
  [1028] = {.lex_state = 3107},
  [1029] = {.lex_state = 3107},
  [1030] = {.lex_state = 3107},
  [1031] = {.lex_state = 3107},
  [1032] = {.lex_state = 3107},
  [1033] = {.lex_state = 3107},
  [1034] = {.lex_state = 3107},
  [1035] = {.lex_state = 3107},
  [1036] = {.lex_state = 3107},
  [1037] = {.lex_state = 3107},
  [1038] = {.lex_state = 3107},
  [1039] = {.lex_state = 3107},
  [1040] = {.lex_state = 3107},
  [1041] = {.lex_state = 3107},
  [1042] = {.lex_state = 3107},
  [1043] = {.lex_state = 3107},
  [1044] = {.lex_state = 3110},
  [1045] = {.lex_state = 3107},
  [1046] = {.lex_state = 3107},
  [1047] = {.lex_state = 3107},
  [1048] = {.lex_state = 3110},
  [1049] = {.lex_state = 3110},
  [1050] = {.lex_state = 3107},
  [1051] = {.lex_state = 3110},
  [1052] = {.lex_state = 3107},
  [1053] = {.lex_state = 3110},
  [1054] = {.lex_state = 3110},
  [1055] = {.lex_state = 3107},
  [1056] = {.lex_state = 3107},
  [1057] = {.lex_state = 3107},
  [1058] = {.lex_state = 3107},
  [1059] = {.lex_state = 3107},
  [1060] = {.lex_state = 3107},
  [1061] = {.lex_state = 3107},
  [1062] = {.lex_state = 3107},
  [1063] = {.lex_state = 3107},
  [1064] = {.lex_state = 3107},
  [1065] = {.lex_state = 3107},
  [1066] = {.lex_state = 3107},
  [1067] = {.lex_state = 3107},
  [1068] = {.lex_state = 3107},
  [1069] = {.lex_state = 3110},
  [1070] = {.lex_state = 3110},
  [1071] = {.lex_state = 3107},
  [1072] = {.lex_state = 3110},
  [1073] = {.lex_state = 3107},
  [1074] = {.lex_state = 3107},
  [1075] = {.lex_state = 3107},
  [1076] = {.lex_state = 3107},
  [1077] = {.lex_state = 3107},
  [1078] = {.lex_state = 3107},
  [1079] = {.lex_state = 3107},
  [1080] = {.lex_state = 3107},
  [1081] = {.lex_state = 3107},
  [1082] = {.lex_state = 3107},
  [1083] = {.lex_state = 3110},
  [1084] = {.lex_state = 3107},
  [1085] = {.lex_state = 7},
  [1086] = {.lex_state = 3107},
  [1087] = {.lex_state = 3107},
  [1088] = {.lex_state = 3107},
  [1089] = {.lex_state = 3107},
  [1090] = {.lex_state = 0},
  [1091] = {.lex_state = 0},
  [1092] = {.lex_state = 0},
  [1093] = {.lex_state = 0},
  [1094] = {.lex_state = 0},
  [1095] = {.lex_state = 0},
  [1096] = {.lex_state = 0},
  [1097] = {.lex_state = 0},
  [1098] = {.lex_state = 0},
  [1099] = {.lex_state = 0},
  [1100] = {.lex_state = 0},
  [1101] = {.lex_state = 0},
  [1102] = {.lex_state = 0},
  [1103] = {.lex_state = 3114},
  [1104] = {.lex_state = 0},
  [1105] = {.lex_state = 0},
  [1106] = {.lex_state = 3108},
  [1107] = {.lex_state = 0},
  [1108] = {.lex_state = 0},
  [1109] = {.lex_state = 3108},
  [1110] = {.lex_state = 3114},
  [1111] = {.lex_state = 0},
  [1112] = {.lex_state = 0},
  [1113] = {.lex_state = 0},
  [1114] = {.lex_state = 0},
  [1115] = {.lex_state = 0},
  [1116] = {.lex_state = 0},
  [1117] = {.lex_state = 0},
  [1118] = {.lex_state = 3108},
  [1119] = {.lex_state = 0},
  [1120] = {.lex_state = 0},
  [1121] = {.lex_state = 0},
  [1122] = {.lex_state = 3108},
  [1123] = {.lex_state = 0},
  [1124] = {.lex_state = 3108},
  [1125] = {.lex_state = 3108},
  [1126] = {.lex_state = 0},
  [1127] = {.lex_state = 3108},
  [1128] = {.lex_state = 3108},
  [1129] = {.lex_state = 0},
  [1130] = {.lex_state = 0},
  [1131] = {.lex_state = 0},
  [1132] = {.lex_state = 0},
  [1133] = {.lex_state = 3108},
  [1134] = {.lex_state = 0},
  [1135] = {.lex_state = 0},
  [1136] = {.lex_state = 0},
  [1137] = {.lex_state = 0},
  [1138] = {.lex_state = 0},
  [1139] = {.lex_state = 3108},
  [1140] = {.lex_state = 3108},
  [1141] = {.lex_state = 3109},
  [1142] = {.lex_state = 3108},
  [1143] = {.lex_state = 3109},
  [1144] = {.lex_state = 3109},
  [1145] = {.lex_state = 3109},
  [1146] = {.lex_state = 3108},
  [1147] = {.lex_state = 3108},
  [1148] = {.lex_state = 3108},
  [1149] = {.lex_state = 3108},
  [1150] = {.lex_state = 3109},
  [1151] = {.lex_state = 3108},
  [1152] = {.lex_state = 0},
  [1153] = {.lex_state = 0},
  [1154] = {.lex_state = 3107},
  [1155] = {.lex_state = 8},
  [1156] = {.lex_state = 8},
  [1157] = {.lex_state = 8},
  [1158] = {.lex_state = 8},
  [1159] = {.lex_state = 8},
  [1160] = {.lex_state = 8},
  [1161] = {.lex_state = 0},
  [1162] = {.lex_state = 8},
  [1163] = {.lex_state = 8},
  [1164] = {.lex_state = 8},
  [1165] = {.lex_state = 8},
  [1166] = {.lex_state = 3109},
  [1167] = {.lex_state = 3109},
  [1168] = {.lex_state = 8},
  [1169] = {.lex_state = 0},
  [1170] = {.lex_state = 3109},
  [1171] = {.lex_state = 3109},
  [1172] = {.lex_state = 8},
  [1173] = {.lex_state = 8},
  [1174] = {.lex_state = 8},
  [1175] = {.lex_state = 8},
  [1176] = {.lex_state = 0},
  [1177] = {.lex_state = 0},
  [1178] = {.lex_state = 3109},
  [1179] = {.lex_state = 8},
  [1180] = {.lex_state = 0},
  [1181] = {.lex_state = 8},
  [1182] = {.lex_state = 8},
  [1183] = {.lex_state = 5},
  [1184] = {.lex_state = 8},
  [1185] = {.lex_state = 5},
  [1186] = {.lex_state = 5},
  [1187] = {.lex_state = 5},
  [1188] = {.lex_state = 0},
  [1189] = {.lex_state = 5},
  [1190] = {.lex_state = 5},
  [1191] = {.lex_state = 8},
  [1192] = {.lex_state = 3114},
  [1193] = {.lex_state = 0},
  [1194] = {.lex_state = 3111},
  [1195] = {.lex_state = 7},
  [1196] = {.lex_state = 7},
  [1197] = {.lex_state = 0},
  [1198] = {.lex_state = 7},
  [1199] = {.lex_state = 0},
  [1200] = {.lex_state = 3109},
  [1201] = {.lex_state = 0},
  [1202] = {.lex_state = 7},
  [1203] = {.lex_state = 3109},
  [1204] = {.lex_state = 7},
  [1205] = {.lex_state = 3109},
  [1206] = {.lex_state = 8},
  [1207] = {.lex_state = 7},
  [1208] = {.lex_state = 7},
  [1209] = {.lex_state = 7},
  [1210] = {.lex_state = 7},
  [1211] = {.lex_state = 7},
  [1212] = {.lex_state = 7},
  [1213] = {.lex_state = 7},
  [1214] = {.lex_state = 0},
  [1215] = {.lex_state = 0},
  [1216] = {.lex_state = 3109},
  [1217] = {.lex_state = 3109},
  [1218] = {.lex_state = 0},
  [1219] = {.lex_state = 0},
  [1220] = {.lex_state = 3113},
  [1221] = {.lex_state = 8},
  [1222] = {.lex_state = 0},
  [1223] = {.lex_state = 0},
  [1224] = {.lex_state = 0},
  [1225] = {.lex_state = 0},
  [1226] = {.lex_state = 0},
  [1227] = {.lex_state = 0},
  [1228] = {.lex_state = 3113},
  [1229] = {.lex_state = 3113},
  [1230] = {.lex_state = 0},
  [1231] = {.lex_state = 0},
  [1232] = {.lex_state = 0},
  [1233] = {.lex_state = 0},
  [1234] = {.lex_state = 3113},
  [1235] = {.lex_state = 0},
  [1236] = {.lex_state = 0},
  [1237] = {.lex_state = 0},
  [1238] = {.lex_state = 3113},
  [1239] = {.lex_state = 3113},
  [1240] = {.lex_state = 3113},
  [1241] = {.lex_state = 3113},
  [1242] = {.lex_state = 3113},
  [1243] = {.lex_state = 3113},
  [1244] = {.lex_state = 3113},
  [1245] = {.lex_state = 0},
  [1246] = {.lex_state = 0},
  [1247] = {.lex_state = 0},
  [1248] = {.lex_state = 3113},
  [1249] = {.lex_state = 3113},
  [1250] = {.lex_state = 0},
  [1251] = {.lex_state = 3113},
  [1252] = {.lex_state = 3113},
  [1253] = {.lex_state = 3113},
  [1254] = {.lex_state = 3113},
  [1255] = {.lex_state = 3113},
  [1256] = {.lex_state = 3113},
  [1257] = {.lex_state = 0},
  [1258] = {.lex_state = 0},
  [1259] = {.lex_state = 3113},
  [1260] = {.lex_state = 0},
  [1261] = {.lex_state = 0},
  [1262] = {.lex_state = 0},
  [1263] = {.lex_state = 0},
  [1264] = {.lex_state = 3113},
  [1265] = {.lex_state = 0},
  [1266] = {.lex_state = 0},
  [1267] = {.lex_state = 0},
  [1268] = {.lex_state = 0},
  [1269] = {.lex_state = 0},
  [1270] = {.lex_state = 8},
  [1271] = {.lex_state = 8},
  [1272] = {.lex_state = 0},
  [1273] = {.lex_state = 8},
  [1274] = {.lex_state = 0},
  [1275] = {.lex_state = 0},
  [1276] = {.lex_state = 8},
  [1277] = {.lex_state = 0},
  [1278] = {.lex_state = 3113},
  [1279] = {.lex_state = 3113},
  [1280] = {.lex_state = 3113},
  [1281] = {.lex_state = 3113},
  [1282] = {.lex_state = 3113},
  [1283] = {.lex_state = 0},
  [1284] = {.lex_state = 3113},
  [1285] = {.lex_state = 0},
  [1286] = {.lex_state = 3113},
  [1287] = {.lex_state = 0},
  [1288] = {.lex_state = 0},
  [1289] = {.lex_state = 0},
  [1290] = {.lex_state = 3113},
  [1291] = {.lex_state = 0},
  [1292] = {.lex_state = 0},
  [1293] = {.lex_state = 3113},
  [1294] = {.lex_state = 0},
  [1295] = {.lex_state = 0},
  [1296] = {.lex_state = 0},
  [1297] = {.lex_state = 0},
  [1298] = {.lex_state = 9},
  [1299] = {.lex_state = 3113},
  [1300] = {.lex_state = 0},
  [1301] = {.lex_state = 0},
  [1302] = {.lex_state = 0},
  [1303] = {.lex_state = 0},
  [1304] = {.lex_state = 3113},
  [1305] = {.lex_state = 0},
  [1306] = {.lex_state = 0},
  [1307] = {.lex_state = 0},
  [1308] = {.lex_state = 0},
  [1309] = {.lex_state = 9},
  [1310] = {.lex_state = 3113},
  [1311] = {.lex_state = 0},
  [1312] = {.lex_state = 0},
  [1313] = {.lex_state = 3113},
  [1314] = {.lex_state = 0},
  [1315] = {.lex_state = 0},
  [1316] = {.lex_state = 3113},
  [1317] = {.lex_state = 0},
  [1318] = {.lex_state = 43},
  [1319] = {.lex_state = 8},
  [1320] = {.lex_state = 3113},
  [1321] = {.lex_state = 0},
  [1322] = {.lex_state = 0},
  [1323] = {.lex_state = 3113},
  [1324] = {.lex_state = 8},
  [1325] = {.lex_state = 0},
  [1326] = {.lex_state = 0},
  [1327] = {.lex_state = 0},
  [1328] = {.lex_state = 0},
  [1329] = {.lex_state = 3113},
  [1330] = {.lex_state = 0},
  [1331] = {.lex_state = 0},
  [1332] = {.lex_state = 3113},
  [1333] = {.lex_state = 0},
  [1334] = {.lex_state = 3113},
  [1335] = {.lex_state = 0},
  [1336] = {.lex_state = 0},
  [1337] = {.lex_state = 3113},
  [1338] = {.lex_state = 0},
  [1339] = {.lex_state = 0},
  [1340] = {.lex_state = 0},
  [1341] = {.lex_state = 0},
  [1342] = {.lex_state = 0},
  [1343] = {.lex_state = 0},
  [1344] = {.lex_state = 0},
  [1345] = {.lex_state = 3113},
  [1346] = {.lex_state = 0},
  [1347] = {.lex_state = 0},
  [1348] = {.lex_state = 0},
  [1349] = {.lex_state = 0},
  [1350] = {.lex_state = 0},
  [1351] = {.lex_state = 0},
  [1352] = {.lex_state = 0},
  [1353] = {.lex_state = 0},
  [1354] = {.lex_state = 0},
  [1355] = {.lex_state = 0},
  [1356] = {.lex_state = 0},
  [1357] = {.lex_state = 0},
  [1358] = {.lex_state = 0},
  [1359] = {.lex_state = 0},
  [1360] = {.lex_state = 3113},
  [1361] = {.lex_state = 0},
  [1362] = {.lex_state = 0},
  [1363] = {.lex_state = 0},
  [1364] = {.lex_state = 8},
  [1365] = {.lex_state = 0},
  [1366] = {.lex_state = 0},
  [1367] = {.lex_state = 0},
  [1368] = {.lex_state = 0},
  [1369] = {.lex_state = 0},
  [1370] = {.lex_state = 8},
  [1371] = {.lex_state = 0},
  [1372] = {.lex_state = 0},
  [1373] = {.lex_state = 0},
  [1374] = {.lex_state = 8},
  [1375] = {.lex_state = 0},
  [1376] = {.lex_state = 0},
  [1377] = {.lex_state = 0},
  [1378] = {.lex_state = 0},
  [1379] = {.lex_state = 0},
  [1380] = {.lex_state = 0},
  [1381] = {.lex_state = 8},
  [1382] = {.lex_state = 0},
  [1383] = {.lex_state = 0},
  [1384] = {.lex_state = 0},
  [1385] = {.lex_state = 3113},
  [1386] = {.lex_state = 0},
  [1387] = {.lex_state = 0},
  [1388] = {.lex_state = 8},
  [1389] = {.lex_state = 0},
  [1390] = {.lex_state = 0},
  [1391] = {.lex_state = 0},
  [1392] = {.lex_state = 0},
  [1393] = {.lex_state = 0},
  [1394] = {.lex_state = 8},
  [1395] = {.lex_state = 0},
  [1396] = {.lex_state = 0},
  [1397] = {.lex_state = 0},
  [1398] = {.lex_state = 3113},
  [1399] = {.lex_state = 0},
  [1400] = {.lex_state = 0},
  [1401] = {.lex_state = 0},
  [1402] = {.lex_state = 0},
  [1403] = {.lex_state = 0},
  [1404] = {.lex_state = 8},
  [1405] = {.lex_state = 0},
  [1406] = {.lex_state = 0},
  [1407] = {.lex_state = 0},
  [1408] = {.lex_state = 0},
  [1409] = {.lex_state = 0},
  [1410] = {.lex_state = 0},
  [1411] = {.lex_state = 8},
  [1412] = {.lex_state = 0},
  [1413] = {.lex_state = 0},
  [1414] = {.lex_state = 0},
  [1415] = {.lex_state = 0},
  [1416] = {.lex_state = 0},
  [1417] = {.lex_state = 0},
  [1418] = {.lex_state = 0},
  [1419] = {.lex_state = 0},
  [1420] = {.lex_state = 0},
  [1421] = {.lex_state = 0},
  [1422] = {.lex_state = 0},
  [1423] = {.lex_state = 0},
  [1424] = {.lex_state = 0},
  [1425] = {.lex_state = 0},
  [1426] = {.lex_state = 0},
  [1427] = {.lex_state = 8},
  [1428] = {.lex_state = 0},
  [1429] = {.lex_state = 0},
  [1430] = {.lex_state = 0},
  [1431] = {.lex_state = 0},
  [1432] = {.lex_state = 0},
  [1433] = {.lex_state = 0},
  [1434] = {.lex_state = 0},
  [1435] = {.lex_state = 0},
  [1436] = {.lex_state = 3113},
  [1437] = {.lex_state = 0},
  [1438] = {.lex_state = 0},
  [1439] = {.lex_state = 0},
  [1440] = {.lex_state = 8},
  [1441] = {.lex_state = 0},
  [1442] = {.lex_state = 0},
  [1443] = {.lex_state = 0},
  [1444] = {.lex_state = 0},
  [1445] = {.lex_state = 0},
  [1446] = {.lex_state = 0},
  [1447] = {.lex_state = 0},
  [1448] = {.lex_state = 0},
  [1449] = {.lex_state = 0},
  [1450] = {.lex_state = 0},
  [1451] = {.lex_state = 0},
  [1452] = {.lex_state = 0},
  [1453] = {.lex_state = 0},
  [1454] = {.lex_state = 0},
  [1455] = {.lex_state = 0},
  [1456] = {.lex_state = 0},
  [1457] = {.lex_state = 0},
  [1458] = {.lex_state = 0},
  [1459] = {.lex_state = 0},
  [1460] = {.lex_state = 0},
  [1461] = {.lex_state = 0},
  [1462] = {.lex_state = 0},
  [1463] = {.lex_state = 0},
  [1464] = {.lex_state = 0},
  [1465] = {.lex_state = 0},
  [1466] = {.lex_state = 0},
  [1467] = {.lex_state = 0},
  [1468] = {.lex_state = 0},
  [1469] = {.lex_state = 0},
  [1470] = {.lex_state = 8},
  [1471] = {.lex_state = 0},
  [1472] = {.lex_state = 8},
  [1473] = {.lex_state = 0},
  [1474] = {.lex_state = 0},
  [1475] = {.lex_state = 8},
  [1476] = {.lex_state = 8},
  [1477] = {.lex_state = 0},
  [1478] = {.lex_state = 8},
  [1479] = {.lex_state = 8},
  [1480] = {.lex_state = 8},
  [1481] = {.lex_state = 0},
  [1482] = {.lex_state = 0},
  [1483] = {.lex_state = 8},
  [1484] = {.lex_state = 0},
  [1485] = {.lex_state = 8},
  [1486] = {.lex_state = 8},
  [1487] = {.lex_state = 8},
  [1488] = {.lex_state = 0},
  [1489] = {.lex_state = 8},
  [1490] = {.lex_state = 8},
  [1491] = {.lex_state = 8},
  [1492] = {.lex_state = 8},
  [1493] = {.lex_state = 3},
  [1494] = {.lex_state = 8},
  [1495] = {.lex_state = 8},
  [1496] = {.lex_state = 8},
  [1497] = {.lex_state = 8},
  [1498] = {.lex_state = 8},
  [1499] = {.lex_state = 0},
  [1500] = {.lex_state = 0},
  [1501] = {.lex_state = 0},
  [1502] = {.lex_state = 8},
  [1503] = {.lex_state = 8},
  [1504] = {.lex_state = 8},
  [1505] = {.lex_state = 3109},
  [1506] = {.lex_state = 8},
  [1507] = {.lex_state = 11},
  [1508] = {.lex_state = 0},
  [1509] = {.lex_state = 8},
  [1510] = {.lex_state = 8},
  [1511] = {.lex_state = 8},
  [1512] = {.lex_state = 8},
  [1513] = {.lex_state = 8},
  [1514] = {.lex_state = 8},
  [1515] = {.lex_state = 8},
  [1516] = {.lex_state = 8},
  [1517] = {.lex_state = 8},
  [1518] = {.lex_state = 8},
  [1519] = {.lex_state = 11},
  [1520] = {.lex_state = 8},
  [1521] = {.lex_state = 8},
  [1522] = {.lex_state = 8},
  [1523] = {.lex_state = 8},
  [1524] = {.lex_state = 8},
  [1525] = {.lex_state = 0},
  [1526] = {.lex_state = 8},
  [1527] = {.lex_state = 8},
  [1528] = {.lex_state = 8},
  [1529] = {.lex_state = 0},
  [1530] = {.lex_state = 8},
  [1531] = {.lex_state = 0},
  [1532] = {.lex_state = 8},
  [1533] = {.lex_state = 8},
  [1534] = {.lex_state = 3109},
  [1535] = {.lex_state = 8},
  [1536] = {.lex_state = 8},
  [1537] = {.lex_state = 8},
  [1538] = {.lex_state = 8},
  [1539] = {.lex_state = 8},
  [1540] = {.lex_state = 8},
  [1541] = {.lex_state = 3109},
  [1542] = {.lex_state = 3109},
  [1543] = {.lex_state = 0},
  [1544] = {.lex_state = 8},
  [1545] = {.lex_state = 8},
  [1546] = {.lex_state = 3},
  [1547] = {.lex_state = 8},
  [1548] = {.lex_state = 8},
  [1549] = {.lex_state = 8},
  [1550] = {.lex_state = 8},
  [1551] = {.lex_state = 8},
  [1552] = {.lex_state = 3109},
  [1553] = {.lex_state = 0},
  [1554] = {.lex_state = 0},
  [1555] = {.lex_state = 3109},
  [1556] = {.lex_state = 0},
  [1557] = {.lex_state = 8},
  [1558] = {.lex_state = 3109},
  [1559] = {.lex_state = 3},
  [1560] = {.lex_state = 0},
  [1561] = {.lex_state = 8},
  [1562] = {.lex_state = 0},
  [1563] = {.lex_state = 0},
  [1564] = {.lex_state = 0},
  [1565] = {.lex_state = 0},
  [1566] = {.lex_state = 0},
  [1567] = {.lex_state = 0},
  [1568] = {.lex_state = 8},
  [1569] = {.lex_state = 8},
  [1570] = {.lex_state = 8},
  [1571] = {.lex_state = 8},
  [1572] = {.lex_state = 8},
  [1573] = {.lex_state = 0},
  [1574] = {.lex_state = 11},
  [1575] = {.lex_state = 8},
  [1576] = {.lex_state = 0},
  [1577] = {.lex_state = 8},
  [1578] = {.lex_state = 3},
  [1579] = {.lex_state = 8},
  [1580] = {.lex_state = 8},
  [1581] = {.lex_state = 8},
  [1582] = {.lex_state = 8},
  [1583] = {.lex_state = 8},
  [1584] = {.lex_state = 0},
  [1585] = {.lex_state = 11},
  [1586] = {.lex_state = 0},
  [1587] = {.lex_state = 0},
  [1588] = {.lex_state = 8},
  [1589] = {.lex_state = 0},
  [1590] = {.lex_state = 8},
  [1591] = {.lex_state = 0},
  [1592] = {.lex_state = 0},
  [1593] = {.lex_state = 8},
  [1594] = {.lex_state = 0},
  [1595] = {.lex_state = 0},
  [1596] = {.lex_state = 0},
  [1597] = {.lex_state = 8},
  [1598] = {.lex_state = 8},
  [1599] = {.lex_state = 0},
  [1600] = {.lex_state = 0},
  [1601] = {.lex_state = 0},
  [1602] = {.lex_state = 8},
  [1603] = {.lex_state = 8},
  [1604] = {.lex_state = 0},
  [1605] = {.lex_state = 0},
  [1606] = {.lex_state = 0},
  [1607] = {.lex_state = 8},
  [1608] = {.lex_state = 0},
  [1609] = {.lex_state = 0},
  [1610] = {.lex_state = 0},
  [1611] = {.lex_state = 8},
  [1612] = {.lex_state = 0},
  [1613] = {.lex_state = 0},
  [1614] = {.lex_state = 0},
  [1615] = {.lex_state = 0},
  [1616] = {.lex_state = 0},
  [1617] = {.lex_state = 0},
  [1618] = {.lex_state = 0},
  [1619] = {.lex_state = 0},
  [1620] = {.lex_state = 0},
  [1621] = {.lex_state = 0},
  [1622] = {.lex_state = 0},
  [1623] = {.lex_state = 0},
  [1624] = {.lex_state = 0},
  [1625] = {.lex_state = 0},
  [1626] = {.lex_state = 8},
  [1627] = {.lex_state = 0},
  [1628] = {.lex_state = 0},
  [1629] = {.lex_state = 0},
  [1630] = {.lex_state = 0},
  [1631] = {.lex_state = 0},
  [1632] = {.lex_state = 0},
  [1633] = {.lex_state = 0},
  [1634] = {.lex_state = 0},
  [1635] = {.lex_state = 8},
  [1636] = {.lex_state = 0},
  [1637] = {.lex_state = 8},
  [1638] = {.lex_state = 0},
  [1639] = {.lex_state = 0},
  [1640] = {.lex_state = 0},
  [1641] = {.lex_state = 0},
  [1642] = {.lex_state = 0},
  [1643] = {.lex_state = 0},
  [1644] = {.lex_state = 0},
  [1645] = {.lex_state = 0},
  [1646] = {.lex_state = 0},
  [1647] = {.lex_state = 0},
  [1648] = {.lex_state = 0},
  [1649] = {.lex_state = 0},
  [1650] = {.lex_state = 0},
  [1651] = {.lex_state = 0},
  [1652] = {.lex_state = 0},
  [1653] = {.lex_state = 0},
  [1654] = {.lex_state = 8},
  [1655] = {.lex_state = 0},
  [1656] = {.lex_state = 0},
  [1657] = {.lex_state = 0},
  [1658] = {.lex_state = 0},
  [1659] = {.lex_state = 0},
  [1660] = {.lex_state = 0},
  [1661] = {.lex_state = 0},
  [1662] = {.lex_state = 0},
  [1663] = {.lex_state = 0},
  [1664] = {.lex_state = 0},
  [1665] = {.lex_state = 0},
  [1666] = {.lex_state = 0},
  [1667] = {.lex_state = 0},
  [1668] = {.lex_state = 0},
  [1669] = {.lex_state = 0},
  [1670] = {.lex_state = 0},
  [1671] = {.lex_state = 0},
  [1672] = {.lex_state = 8},
  [1673] = {.lex_state = 0},
  [1674] = {.lex_state = 0},
  [1675] = {.lex_state = 0},
  [1676] = {.lex_state = 0},
  [1677] = {.lex_state = 0},
  [1678] = {.lex_state = 0},
  [1679] = {.lex_state = 0},
  [1680] = {.lex_state = 0},
  [1681] = {.lex_state = 0},
  [1682] = {.lex_state = 0},
  [1683] = {.lex_state = 8},
  [1684] = {.lex_state = 0},
  [1685] = {.lex_state = 0},
  [1686] = {.lex_state = 0},
  [1687] = {.lex_state = 0},
  [1688] = {.lex_state = 0},
  [1689] = {.lex_state = 0},
  [1690] = {.lex_state = 0},
  [1691] = {.lex_state = 0},
  [1692] = {.lex_state = 0},
  [1693] = {.lex_state = 1299},
  [1694] = {.lex_state = 0},
  [1695] = {.lex_state = 0},
  [1696] = {.lex_state = 0},
  [1697] = {.lex_state = 0},
  [1698] = {.lex_state = 0},
  [1699] = {.lex_state = 0},
  [1700] = {.lex_state = 0},
  [1701] = {.lex_state = 0},
  [1702] = {.lex_state = 0},
  [1703] = {.lex_state = 0},
  [1704] = {.lex_state = 0},
  [1705] = {.lex_state = 8},
  [1706] = {.lex_state = 8},
  [1707] = {.lex_state = 0},
  [1708] = {.lex_state = 0},
  [1709] = {.lex_state = 0},
  [1710] = {.lex_state = 0},
  [1711] = {.lex_state = 0},
  [1712] = {.lex_state = 0},
  [1713] = {.lex_state = 0},
  [1714] = {.lex_state = 0},
  [1715] = {.lex_state = 0},
  [1716] = {.lex_state = 0},
  [1717] = {.lex_state = 0},
  [1718] = {.lex_state = 37},
  [1719] = {.lex_state = 0},
  [1720] = {.lex_state = 8},
  [1721] = {.lex_state = 0},
  [1722] = {.lex_state = 0},
  [1723] = {.lex_state = 0},
  [1724] = {.lex_state = 0},
  [1725] = {.lex_state = 0},
  [1726] = {.lex_state = 43},
  [1727] = {.lex_state = 0},
  [1728] = {.lex_state = 0},
  [1729] = {.lex_state = 0},
  [1730] = {.lex_state = 0},
  [1731] = {.lex_state = 0},
  [1732] = {.lex_state = 0},
  [1733] = {.lex_state = 0},
  [1734] = {.lex_state = 0},
  [1735] = {.lex_state = 0},
  [1736] = {.lex_state = 0},
  [1737] = {.lex_state = 0},
  [1738] = {.lex_state = 0},
  [1739] = {.lex_state = 0},
  [1740] = {.lex_state = 8},
  [1741] = {.lex_state = 0},
  [1742] = {.lex_state = 0},
  [1743] = {.lex_state = 0},
  [1744] = {.lex_state = 0},
  [1745] = {.lex_state = 0},
  [1746] = {.lex_state = 8},
  [1747] = {.lex_state = 0},
  [1748] = {.lex_state = 0},
  [1749] = {.lex_state = 0},
  [1750] = {.lex_state = 0},
  [1751] = {.lex_state = 0},
  [1752] = {.lex_state = 0},
  [1753] = {.lex_state = 0},
  [1754] = {.lex_state = 0},
  [1755] = {.lex_state = 8},
  [1756] = {.lex_state = 8},
  [1757] = {.lex_state = 8},
  [1758] = {.lex_state = 0},
  [1759] = {.lex_state = 0},
  [1760] = {.lex_state = 0},
  [1761] = {.lex_state = 8},
  [1762] = {.lex_state = 0},
  [1763] = {.lex_state = 0},
  [1764] = {.lex_state = 0},
  [1765] = {.lex_state = 0},
  [1766] = {.lex_state = 0},
  [1767] = {.lex_state = 0},
  [1768] = {.lex_state = 8},
  [1769] = {.lex_state = 0},
  [1770] = {.lex_state = 0},
  [1771] = {.lex_state = 0},
  [1772] = {.lex_state = 0},
  [1773] = {.lex_state = 0},
  [1774] = {.lex_state = 0},
  [1775] = {.lex_state = 0},
  [1776] = {.lex_state = 8},
  [1777] = {.lex_state = 8},
  [1778] = {.lex_state = 0},
  [1779] = {.lex_state = 0},
  [1780] = {.lex_state = 0},
  [1781] = {.lex_state = 0},
  [1782] = {.lex_state = 0},
  [1783] = {.lex_state = 0},
  [1784] = {.lex_state = 0},
  [1785] = {.lex_state = 0},
  [1786] = {.lex_state = 0},
  [1787] = {.lex_state = 0},
  [1788] = {.lex_state = 0},
  [1789] = {.lex_state = 0},
  [1790] = {.lex_state = 0},
  [1791] = {.lex_state = 0},
  [1792] = {.lex_state = 0},
  [1793] = {.lex_state = 8},
  [1794] = {.lex_state = 0},
  [1795] = {.lex_state = 0},
  [1796] = {.lex_state = 0},
  [1797] = {.lex_state = 0},
  [1798] = {.lex_state = 0},
  [1799] = {.lex_state = 0},
  [1800] = {.lex_state = 0},
  [1801] = {.lex_state = 0},
  [1802] = {.lex_state = 0},
  [1803] = {.lex_state = 0},
  [1804] = {.lex_state = 0},
  [1805] = {.lex_state = 0},
  [1806] = {.lex_state = 0},
  [1807] = {.lex_state = 0},
  [1808] = {.lex_state = 0},
  [1809] = {.lex_state = 0},
  [1810] = {.lex_state = 0},
  [1811] = {.lex_state = 8},
  [1812] = {.lex_state = 8},
  [1813] = {.lex_state = 8},
  [1814] = {.lex_state = 8},
  [1815] = {.lex_state = 8},
  [1816] = {.lex_state = 8},
  [1817] = {.lex_state = 0},
  [1818] = {.lex_state = 0},
  [1819] = {.lex_state = 0},
  [1820] = {.lex_state = 0},
  [1821] = {.lex_state = 0},
  [1822] = {.lex_state = 0},
  [1823] = {.lex_state = 0},
  [1824] = {.lex_state = 0},
  [1825] = {.lex_state = 0},
  [1826] = {.lex_state = 0},
  [1827] = {.lex_state = 0},
  [1828] = {.lex_state = 0},
  [1829] = {.lex_state = 0},
  [1830] = {.lex_state = 0},
  [1831] = {.lex_state = 0},
  [1832] = {.lex_state = 0},
  [1833] = {.lex_state = 0},
  [1834] = {.lex_state = 8},
  [1835] = {.lex_state = 8},
  [1836] = {.lex_state = 8},
  [1837] = {.lex_state = 8},
  [1838] = {.lex_state = 0},
  [1839] = {.lex_state = 0},
  [1840] = {.lex_state = 0},
  [1841] = {.lex_state = 0},
  [1842] = {.lex_state = 0},
  [1843] = {.lex_state = 0},
  [1844] = {.lex_state = 0},
  [1845] = {.lex_state = 0},
  [1846] = {.lex_state = 0},
  [1847] = {.lex_state = 0},
  [1848] = {.lex_state = 0},
  [1849] = {.lex_state = 0},
  [1850] = {.lex_state = 0},
  [1851] = {.lex_state = 0},
  [1852] = {.lex_state = 0},
  [1853] = {.lex_state = 0},
  [1854] = {.lex_state = 0},
  [1855] = {.lex_state = 0},
  [1856] = {.lex_state = 8},
  [1857] = {.lex_state = 8},
  [1858] = {.lex_state = 8},
  [1859] = {.lex_state = 8},
  [1860] = {.lex_state = 8},
  [1861] = {.lex_state = 8},
  [1862] = {.lex_state = 0},
  [1863] = {.lex_state = 0},
  [1864] = {.lex_state = 0},
  [1865] = {.lex_state = 0},
  [1866] = {.lex_state = 0},
  [1867] = {.lex_state = 0},
  [1868] = {.lex_state = 8},
  [1869] = {.lex_state = 0},
  [1870] = {.lex_state = 0},
  [1871] = {.lex_state = 0},
  [1872] = {.lex_state = 0},
  [1873] = {.lex_state = 0},
  [1874] = {.lex_state = 0},
  [1875] = {.lex_state = 0},
  [1876] = {.lex_state = 3109},
  [1877] = {.lex_state = 8},
  [1878] = {.lex_state = 0},
  [1879] = {.lex_state = 0},
  [1880] = {.lex_state = 0},
  [1881] = {.lex_state = 0},
  [1882] = {.lex_state = 8},
  [1883] = {.lex_state = 0},
  [1884] = {.lex_state = 0},
  [1885] = {.lex_state = 0},
  [1886] = {.lex_state = 0},
  [1887] = {.lex_state = 0},
  [1888] = {.lex_state = 0},
  [1889] = {.lex_state = 0},
  [1890] = {.lex_state = 0},
  [1891] = {.lex_state = 0},
  [1892] = {.lex_state = 0},
  [1893] = {.lex_state = 0},
  [1894] = {.lex_state = 0},
  [1895] = {.lex_state = 0},
  [1896] = {.lex_state = 8},
  [1897] = {.lex_state = 0},
  [1898] = {.lex_state = 8},
  [1899] = {.lex_state = 0},
  [1900] = {.lex_state = 0},
  [1901] = {.lex_state = 0},
  [1902] = {.lex_state = 0},
  [1903] = {.lex_state = 0},
  [1904] = {.lex_state = 0},
  [1905] = {.lex_state = 0},
  [1906] = {.lex_state = 0},
  [1907] = {.lex_state = 0},
  [1908] = {.lex_state = 0},
  [1909] = {.lex_state = 0},
  [1910] = {.lex_state = 0},
  [1911] = {.lex_state = 3},
  [1912] = {.lex_state = 0},
  [1913] = {.lex_state = 3109},
  [1914] = {.lex_state = 0},
  [1915] = {.lex_state = 0},
  [1916] = {.lex_state = 0},
  [1917] = {.lex_state = 0},
  [1918] = {.lex_state = 0},
  [1919] = {.lex_state = 0},
  [1920] = {.lex_state = 8},
  [1921] = {.lex_state = 8},
  [1922] = {.lex_state = 8},
  [1923] = {.lex_state = 8},
  [1924] = {.lex_state = 8},
  [1925] = {.lex_state = 8},
  [1926] = {.lex_state = 8},
  [1927] = {.lex_state = 0},
  [1928] = {.lex_state = 0},
  [1929] = {.lex_state = 0},
  [1930] = {.lex_state = 0},
  [1931] = {.lex_state = 8},
  [1932] = {.lex_state = 0},
  [1933] = {.lex_state = 0},
  [1934] = {.lex_state = 0},
  [1935] = {.lex_state = 8},
  [1936] = {.lex_state = 8},
  [1937] = {.lex_state = 8},
  [1938] = {.lex_state = 0},
  [1939] = {.lex_state = 8},
  [1940] = {.lex_state = 8},
  [1941] = {.lex_state = 8},
  [1942] = {.lex_state = 0},
  [1943] = {.lex_state = 0},
  [1944] = {.lex_state = 0},
  [1945] = {.lex_state = 0},
  [1946] = {.lex_state = 8},
  [1947] = {.lex_state = 0},
  [1948] = {.lex_state = 0},
  [1949] = {.lex_state = 43},
  [1950] = {.lex_state = 8},
  [1951] = {.lex_state = 8},
  [1952] = {.lex_state = 8},
  [1953] = {.lex_state = 0},
  [1954] = {.lex_state = 8},
  [1955] = {.lex_state = 8},
  [1956] = {.lex_state = 8},
  [1957] = {.lex_state = 8},
  [1958] = {.lex_state = 0},
  [1959] = {.lex_state = 0},
  [1960] = {.lex_state = 0},
  [1961] = {.lex_state = 8},
  [1962] = {.lex_state = 0},
  [1963] = {.lex_state = 8},
  [1964] = {.lex_state = 8},
  [1965] = {.lex_state = 8},
  [1966] = {.lex_state = 0},
  [1967] = {.lex_state = 0},
  [1968] = {.lex_state = 43},
  [1969] = {.lex_state = 0},
  [1970] = {.lex_state = 8},
  [1971] = {.lex_state = 3109},
  [1972] = {.lex_state = 0},
  [1973] = {.lex_state = 0},
  [1974] = {.lex_state = 0},
  [1975] = {.lex_state = 0},
  [1976] = {.lex_state = 0},
  [1977] = {.lex_state = 0},
  [1978] = {.lex_state = 0},
  [1979] = {.lex_state = 0},
  [1980] = {.lex_state = 0},
  [1981] = {.lex_state = 0},
  [1982] = {.lex_state = 0},
  [1983] = {.lex_state = 0},
  [1984] = {.lex_state = 0},
  [1985] = {.lex_state = 0},
  [1986] = {.lex_state = 0},
  [1987] = {.lex_state = 0},
  [1988] = {.lex_state = 0},
  [1989] = {.lex_state = 0},
  [1990] = {.lex_state = 0},
  [1991] = {.lex_state = 0},
  [1992] = {.lex_state = 8},
  [1993] = {.lex_state = 8},
  [1994] = {.lex_state = 8},
  [1995] = {.lex_state = 8},
  [1996] = {.lex_state = 0},
  [1997] = {.lex_state = 0},
  [1998] = {.lex_state = 8},
  [1999] = {.lex_state = 8},
  [2000] = {.lex_state = 8},
  [2001] = {.lex_state = 8},
  [2002] = {.lex_state = 0},
  [2003] = {.lex_state = 0},
  [2004] = {.lex_state = 8},
  [2005] = {.lex_state = 8},
  [2006] = {.lex_state = 8},
  [2007] = {.lex_state = 8},
  [2008] = {.lex_state = 0},
  [2009] = {.lex_state = 0},
  [2010] = {.lex_state = 8},
  [2011] = {.lex_state = 8},
  [2012] = {.lex_state = 8},
  [2013] = {.lex_state = 8},
  [2014] = {.lex_state = 8},
  [2015] = {.lex_state = 8},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1),
    [sym_comdat_ref] = ACTIONS(1),
    [sym_global_var] = ACTIONS(1),
    [sym_local_var] = ACTIONS(1),
    [aux_sym_metadata_ref_token1] = ACTIONS(1),
    [sym_summary_ref] = ACTIONS(1),
    [sym_string] = ACTIONS(1),
    [aux_sym_number_token1] = ACTIONS(1),
    [aux_sym_number_token2] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [sym_cstring] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [anon_sym_triple] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_datalayout] = ACTIONS(1),
    [anon_sym_source_filename] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_define] = ACTIONS(1),
    [anon_sym_no_cfi] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_internal] = ACTIONS(1),
    [anon_sym_weak] = ACTIONS(1),
    [anon_sym_weak_odr] = ACTIONS(1),
    [anon_sym_linkonce] = ACTIONS(1),
    [anon_sym_linkonce_odr] = ACTIONS(1),
    [anon_sym_available_externally] = ACTIONS(1),
    [anon_sym_appending] = ACTIONS(1),
    [anon_sym_common] = ACTIONS(1),
    [anon_sym_extern_weak] = ACTIONS(1),
    [anon_sym_external] = ACTIONS(1),
    [anon_sym_dso_local] = ACTIONS(1),
    [anon_sym_dso_local_equivalent] = ACTIONS(1),
    [anon_sym_dso_preemptable] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_hidden] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_dllimport] = ACTIONS(1),
    [anon_sym_dllexport] = ACTIONS(1),
    [anon_sym_ccc] = ACTIONS(1),
    [anon_sym_fastcc] = ACTIONS(1),
    [anon_sym_coldcc] = ACTIONS(1),
    [anon_sym_webkit_jscc] = ACTIONS(1),
    [anon_sym_anyregcc] = ACTIONS(1),
    [anon_sym_preserve_mostcc] = ACTIONS(1),
    [anon_sym_preserve_allcc] = ACTIONS(1),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(1),
    [anon_sym_swiftcc] = ACTIONS(1),
    [anon_sym_swifttailcc] = ACTIONS(1),
    [anon_sym_cfguard_checkcc] = ACTIONS(1),
    [aux_sym_calling_conv_token2] = ACTIONS(1),
    [aux_sym_calling_conv_token3] = ACTIONS(1),
    [aux_sym_calling_conv_token4] = ACTIONS(1),
    [aux_sym_calling_conv_token5] = ACTIONS(1),
    [aux_sym_calling_conv_token6] = ACTIONS(1),
    [aux_sym_calling_conv_token7] = ACTIONS(1),
    [aux_sym_calling_conv_token8] = ACTIONS(1),
    [aux_sym_calling_conv_token9] = ACTIONS(1),
    [aux_sym_calling_conv_token10] = ACTIONS(1),
    [anon_sym_ghccc] = ACTIONS(1),
    [aux_sym_calling_conv_token11] = ACTIONS(1),
    [aux_sym_calling_conv_token12] = ACTIONS(1),
    [aux_sym_calling_conv_token13] = ACTIONS(1),
    [aux_sym_calling_conv_token14] = ACTIONS(1),
    [anon_sym_cc] = ACTIONS(1),
    [anon_sym_unnamed_addr] = ACTIONS(1),
    [anon_sym_local_unnamed_addr] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_half] = ACTIONS(1),
    [anon_sym_bfloat] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_double] = ACTIONS(1),
    [anon_sym_fp128] = ACTIONS(1),
    [anon_sym_ppc_fp128] = ACTIONS(1),
    [anon_sym_label] = ACTIONS(1),
    [anon_sym_metadata] = ACTIONS(1),
    [anon_sym_token] = ACTIONS(1),
    [anon_sym_opaque] = ACTIONS(1),
    [anon_sym_ptr] = ACTIONS(1),
    [aux_sym_type_keyword_token1] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_LT_LBRACE] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_vscale] = ACTIONS(1),
    [anon_sym_x] = ACTIONS(1),
    [anon_sym_addrspace] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_align] = ACTIONS(1),
    [anon_sym_section] = ACTIONS(1),
    [anon_sym_partition] = ACTIONS(1),
    [anon_sym_comdat] = ACTIONS(1),
    [anon_sym_gc] = ACTIONS(1),
    [anon_sym_prefix] = ACTIONS(1),
    [anon_sym_prologue] = ACTIONS(1),
    [anon_sym_personality] = ACTIONS(1),
    [anon_sym_alignstack] = ACTIONS(1),
    [anon_sym_allocsize] = ACTIONS(1),
    [anon_sym_alwaysinline] = ACTIONS(1),
    [anon_sym_builtin] = ACTIONS(1),
    [anon_sym_cold] = ACTIONS(1),
    [anon_sym_convergent] = ACTIONS(1),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1),
    [anon_sym_hot] = ACTIONS(1),
    [anon_sym_inaccessiblememonly] = ACTIONS(1),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1),
    [anon_sym_inlinehint] = ACTIONS(1),
    [anon_sym_jumptable] = ACTIONS(1),
    [anon_sym_minsize] = ACTIONS(1),
    [anon_sym_naked] = ACTIONS(1),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1),
    [anon_sym_nobuiltin] = ACTIONS(1),
    [anon_sym_noduplicate] = ACTIONS(1),
    [anon_sym_nofree] = ACTIONS(1),
    [anon_sym_noimplicitfloat] = ACTIONS(1),
    [anon_sym_noinline] = ACTIONS(1),
    [anon_sym_nomerge] = ACTIONS(1),
    [anon_sym_nonlazybind] = ACTIONS(1),
    [anon_sym_noprofile] = ACTIONS(1),
    [anon_sym_noredzone] = ACTIONS(1),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1),
    [anon_sym_noreturn] = ACTIONS(1),
    [anon_sym_norecurse] = ACTIONS(1),
    [anon_sym_willreturn] = ACTIONS(1),
    [anon_sym_nosync] = ACTIONS(1),
    [anon_sym_nounwind] = ACTIONS(1),
    [anon_sym_nocallback] = ACTIONS(1),
    [anon_sym_nosanitize_coverage] = ACTIONS(1),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1),
    [anon_sym_optforfuzzing] = ACTIONS(1),
    [anon_sym_optnone] = ACTIONS(1),
    [anon_sym_optsize] = ACTIONS(1),
    [anon_sym_readnone] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_writeonly] = ACTIONS(1),
    [anon_sym_argmemonly] = ACTIONS(1),
    [anon_sym_returns_twice] = ACTIONS(1),
    [anon_sym_safestack] = ACTIONS(1),
    [anon_sym_sanitize_address] = ACTIONS(1),
    [anon_sym_sanitize_memory] = ACTIONS(1),
    [anon_sym_sanitize_thread] = ACTIONS(1),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1),
    [anon_sym_sanitize_memtag] = ACTIONS(1),
    [anon_sym_speculative_load_hardening] = ACTIONS(1),
    [anon_sym_speculatable] = ACTIONS(1),
    [anon_sym_ssp] = ACTIONS(1),
    [anon_sym_sspstrong] = ACTIONS(1),
    [anon_sym_sspreq] = ACTIONS(1),
    [anon_sym_strictfp] = ACTIONS(1),
    [anon_sym_nocf_check] = ACTIONS(1),
    [anon_sym_shadowcallstack] = ACTIONS(1),
    [anon_sym_mustprogress] = ACTIONS(1),
    [anon_sym_vscale_range] = ACTIONS(1),
    [anon_sym_preallocated] = ACTIONS(1),
    [anon_sym_zeroext] = ACTIONS(1),
    [anon_sym_signext] = ACTIONS(1),
    [anon_sym_inreg] = ACTIONS(1),
    [anon_sym_byval] = ACTIONS(1),
    [anon_sym_byref] = ACTIONS(1),
    [anon_sym_inalloca] = ACTIONS(1),
    [anon_sym_sret] = ACTIONS(1),
    [anon_sym_elementtype] = ACTIONS(1),
    [anon_sym_noalias] = ACTIONS(1),
    [anon_sym_nocapture] = ACTIONS(1),
    [anon_sym_nest] = ACTIONS(1),
    [anon_sym_returned] = ACTIONS(1),
    [anon_sym_nonnull] = ACTIONS(1),
    [anon_sym_dereferenceable] = ACTIONS(1),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1),
    [anon_sym_swiftself] = ACTIONS(1),
    [anon_sym_swiftasync] = ACTIONS(1),
    [anon_sym_swifterror] = ACTIONS(1),
    [anon_sym_immarg] = ACTIONS(1),
    [anon_sym_noundef] = ACTIONS(1),
    [anon_sym_uwtable] = ACTIONS(1),
    [anon_sym_sync] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_memory] = ACTIONS(1),
    [anon_sym_argmem] = ACTIONS(1),
    [anon_sym_inaccessiblemem] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_none] = ACTIONS(1),
    [anon_sym_read] = ACTIONS(1),
    [anon_sym_write] = ACTIONS(1),
    [anon_sym_readwrite] = ACTIONS(1),
    [anon_sym_unreachable] = ACTIONS(1),
    [anon_sym_ret] = ACTIONS(1),
    [anon_sym_br] = ACTIONS(1),
    [anon_sym_resume] = ACTIONS(1),
    [anon_sym_freeze] = ACTIONS(1),
    [anon_sym_indirectbr] = ACTIONS(1),
    [anon_sym_extractelement] = ACTIONS(1),
    [anon_sym_insertelement] = ACTIONS(1),
    [anon_sym_select] = ACTIONS(1),
    [anon_sym_shufflevector] = ACTIONS(1),
    [anon_sym_fneg] = ACTIONS(1),
    [anon_sym_nsw] = ACTIONS(1),
    [anon_sym_nuw] = ACTIONS(1),
    [anon_sym_exact] = ACTIONS(1),
    [anon_sym_disjoint] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_invoke] = ACTIONS(1),
    [anon_sym_to] = ACTIONS(1),
    [anon_sym_unwind] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_catchret] = ACTIONS(1),
    [anon_sym_catchswitch] = ACTIONS(1),
    [anon_sym_catchpad] = ACTIONS(1),
    [anon_sym_callbr] = ACTIONS(1),
    [anon_sym_icmp] = ACTIONS(1),
    [anon_sym_fcmp] = ACTIONS(1),
    [anon_sym_nneg] = ACTIONS(1),
    [anon_sym_va_arg] = ACTIONS(1),
    [anon_sym_phi] = ACTIONS(1),
    [anon_sym_landingpad] = ACTIONS(1),
    [anon_sym_cleanup] = ACTIONS(1),
    [anon_sym_tail] = ACTIONS(1),
    [anon_sym_musttail] = ACTIONS(1),
    [anon_sym_notail] = ACTIONS(1),
    [anon_sym_call] = ACTIONS(1),
    [anon_sym_alloca] = ACTIONS(1),
    [anon_sym_load] = ACTIONS(1),
    [anon_sym_atomic] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_store] = ACTIONS(1),
    [anon_sym_cmpxchg] = ACTIONS(1),
    [anon_sym_atomicrmw] = ACTIONS(1),
    [anon_sym_fence] = ACTIONS(1),
    [anon_sym_getelementptr] = ACTIONS(1),
    [anon_sym_inbounds] = ACTIONS(1),
    [anon_sym_inrange] = ACTIONS(1),
    [anon_sym_extractvalue] = ACTIONS(1),
    [anon_sym_insertvalue] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_null] = ACTIONS(1),
    [anon_sym_undef] = ACTIONS(1),
    [anon_sym_poison] = ACTIONS(1),
    [anon_sym_zeroinitializer] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_filter] = ACTIONS(1),
    [anon_sym_blockaddress] = ACTIONS(1),
    [anon_sym_mul] = ACTIONS(1),
    [anon_sym_urem] = ACTIONS(1),
    [anon_sym_srem] = ACTIONS(1),
    [anon_sym_shl] = ACTIONS(1),
    [anon_sym_udiv] = ACTIONS(1),
    [anon_sym_sdiv] = ACTIONS(1),
    [anon_sym_lshr] = ACTIONS(1),
    [anon_sym_ashr] = ACTIONS(1),
    [anon_sym_fmul] = ACTIONS(1),
    [anon_sym_fdiv] = ACTIONS(1),
    [anon_sym_frem] = ACTIONS(1),
    [anon_sym_xchg] = ACTIONS(1),
    [anon_sym_add] = ACTIONS(1),
    [anon_sym_sub] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_nand] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_max] = ACTIONS(1),
    [anon_sym_min] = ACTIONS(1),
    [anon_sym_umax] = ACTIONS(1),
    [anon_sym_umin] = ACTIONS(1),
    [anon_sym_fadd] = ACTIONS(1),
    [anon_sym_fsub] = ACTIONS(1),
    [anon_sym_eq] = ACTIONS(1),
    [anon_sym_ne] = ACTIONS(1),
    [anon_sym_ugt] = ACTIONS(1),
    [anon_sym_uge] = ACTIONS(1),
    [anon_sym_ult] = ACTIONS(1),
    [anon_sym_ule] = ACTIONS(1),
    [anon_sym_sgt] = ACTIONS(1),
    [anon_sym_sge] = ACTIONS(1),
    [anon_sym_slt] = ACTIONS(1),
    [anon_sym_sle] = ACTIONS(1),
    [anon_sym_oeq] = ACTIONS(1),
    [anon_sym_ogt] = ACTIONS(1),
    [anon_sym_oge] = ACTIONS(1),
    [anon_sym_olt] = ACTIONS(1),
    [anon_sym_ole] = ACTIONS(1),
    [anon_sym_one] = ACTIONS(1),
    [anon_sym_ueq] = ACTIONS(1),
    [anon_sym_une] = ACTIONS(1),
    [anon_sym_uno] = ACTIONS(1),
    [anon_sym_bitcast] = ACTIONS(1),
    [anon_sym_trunc] = ACTIONS(1),
    [anon_sym_zext] = ACTIONS(1),
    [anon_sym_sext] = ACTIONS(1),
    [anon_sym_fptrunc] = ACTIONS(1),
    [anon_sym_fpext] = ACTIONS(1),
    [anon_sym_addrspacecast] = ACTIONS(1),
    [anon_sym_uitofp] = ACTIONS(1),
    [anon_sym_sitofp] = ACTIONS(1),
    [anon_sym_fptoui] = ACTIONS(1),
    [anon_sym_fptosi] = ACTIONS(1),
    [anon_sym_inttoptr] = ACTIONS(1),
    [anon_sym_ptrtoint] = ACTIONS(1),
    [anon_sym_unordered] = ACTIONS(1),
    [anon_sym_monotonic] = ACTIONS(1),
    [anon_sym_acquire] = ACTIONS(1),
    [anon_sym_release] = ACTIONS(1),
    [anon_sym_acq_rel] = ACTIONS(1),
    [anon_sym_seq_cst] = ACTIONS(1),
    [anon_sym_syncscope] = ACTIONS(1),
    [anon_sym_nnan] = ACTIONS(1),
    [anon_sym_ninf] = ACTIONS(1),
    [anon_sym_nsz] = ACTIONS(1),
    [anon_sym_arcp] = ACTIONS(1),
    [anon_sym_contract] = ACTIONS(1),
    [anon_sym_afn] = ACTIONS(1),
    [anon_sym_reassoc] = ACTIONS(1),
    [anon_sym_fast] = ACTIONS(1),
    [anon_sym_within] = ACTIONS(1),
    [anon_sym_uselistorder] = ACTIONS(1),
    [anon_sym_uselistorder_bb] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_asm] = ACTIONS(1),
    [anon_sym_sideeffect] = ACTIONS(1),
    [anon_sym_inteldialect] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_externally_initialized] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_constant] = ACTIONS(1),
    [anon_sym_alias] = ACTIONS(1),
    [anon_sym_ifunc] = ACTIONS(1),
    [anon_sym_thread_local] = ACTIONS(1),
    [anon_sym_localdynamic] = ACTIONS(1),
    [anon_sym_initialexec] = ACTIONS(1),
    [anon_sym_localexec] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_largest] = ACTIONS(1),
    [anon_sym_nodeduplicate] = ACTIONS(1),
    [anon_sym_samesize] = ACTIONS(1),
    [anon_sym_distinct] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_LBRACE2] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_attributes] = ACTIONS(1),
  },
  [1] = {
    [sym_module] = STATE(1790),
    [sym_metadata_ref] = STATE(1784),
    [sym_target_definition] = STATE(755),
    [sym_source_file_name] = STATE(755),
    [sym_declare] = STATE(755),
    [sym_define] = STATE(755),
    [sym_use_list_order] = STATE(755),
    [sym_use_list_order_bb] = STATE(755),
    [sym_module_asm] = STATE(755),
    [sym_global_type] = STATE(755),
    [sym__global_prefix] = STATE(1226),
    [sym_global_global] = STATE(755),
    [sym_alias] = STATE(755),
    [sym_ifunc] = STATE(755),
    [sym_comdat] = STATE(755),
    [sym_global_metadata] = STATE(755),
    [sym_summary_entry] = STATE(755),
    [sym_unnamed_attr_grp] = STATE(755),
    [aux_sym_module_repeat1] = STATE(755),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(7),
    [sym_global_var] = ACTIONS(9),
    [sym_local_var] = ACTIONS(11),
    [aux_sym_metadata_ref_token1] = ACTIONS(13),
    [sym_summary_ref] = ACTIONS(15),
    [anon_sym_target] = ACTIONS(17),
    [anon_sym_source_filename] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_define] = ACTIONS(23),
    [anon_sym_uselistorder] = ACTIONS(25),
    [anon_sym_uselistorder_bb] = ACTIONS(27),
    [anon_sym_module] = ACTIONS(29),
    [anon_sym_attributes] = ACTIONS(31),
  },
  [2] = {
    [sym_number] = STATE(92),
    [sym_var] = STATE(92),
    [sym_linkage] = STATE(817),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(136),
    [sym__primitive_value] = STATE(92),
    [sym_struct_value] = STATE(92),
    [sym_packed_struct_value] = STATE(92),
    [sym_array_value] = STATE(92),
    [sym_vector_value] = STATE(92),
    [sym_blockaddress] = STATE(92),
    [sym_constant_expr] = STATE(92),
    [sym_constant_cast] = STATE(87),
    [sym_constant_getelementptr] = STATE(87),
    [sym_constant_select] = STATE(87),
    [sym_constant_icmp] = STATE(87),
    [sym_constant_fcmp] = STATE(87),
    [sym_constant_extractelement] = STATE(87),
    [sym_constant_insertelement] = STATE(87),
    [sym_constant_shufflevector] = STATE(87),
    [sym_constant_extractvalue] = STATE(87),
    [sym_constant_insertvalue] = STATE(87),
    [sym_constant_fneg] = STATE(87),
    [sym_constant_bin_op] = STATE(87),
    [sym_bin_op_keyword] = STATE(1122),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1597),
    [aux_sym_function_header_repeat1] = STATE(817),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(35),
    [aux_sym_metadata_ref_token1] = ACTIONS(38),
    [sym_string] = ACTIONS(40),
    [aux_sym_number_token1] = ACTIONS(43),
    [aux_sym_number_token2] = ACTIONS(45),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(49),
    [anon_sym_private] = ACTIONS(52),
    [anon_sym_internal] = ACTIONS(52),
    [anon_sym_weak] = ACTIONS(55),
    [anon_sym_weak_odr] = ACTIONS(52),
    [anon_sym_linkonce] = ACTIONS(55),
    [anon_sym_linkonce_odr] = ACTIONS(52),
    [anon_sym_available_externally] = ACTIONS(52),
    [anon_sym_appending] = ACTIONS(52),
    [anon_sym_common] = ACTIONS(52),
    [anon_sym_extern_weak] = ACTIONS(52),
    [anon_sym_external] = ACTIONS(52),
    [anon_sym_dso_local] = ACTIONS(58),
    [anon_sym_dso_local_equivalent] = ACTIONS(61),
    [anon_sym_dso_preemptable] = ACTIONS(61),
    [anon_sym_default] = ACTIONS(64),
    [anon_sym_hidden] = ACTIONS(64),
    [anon_sym_protected] = ACTIONS(64),
    [anon_sym_dllimport] = ACTIONS(67),
    [anon_sym_dllexport] = ACTIONS(67),
    [anon_sym_ccc] = ACTIONS(38),
    [anon_sym_fastcc] = ACTIONS(38),
    [anon_sym_coldcc] = ACTIONS(38),
    [anon_sym_webkit_jscc] = ACTIONS(70),
    [anon_sym_anyregcc] = ACTIONS(38),
    [anon_sym_preserve_mostcc] = ACTIONS(38),
    [anon_sym_preserve_allcc] = ACTIONS(38),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(70),
    [anon_sym_tailcc] = ACTIONS(38),
    [anon_sym_swiftcc] = ACTIONS(70),
    [anon_sym_swifttailcc] = ACTIONS(70),
    [anon_sym_cfguard_checkcc] = ACTIONS(38),
    [aux_sym_calling_conv_token1] = ACTIONS(70),
    [aux_sym_calling_conv_token2] = ACTIONS(38),
    [aux_sym_calling_conv_token3] = ACTIONS(38),
    [aux_sym_calling_conv_token4] = ACTIONS(38),
    [aux_sym_calling_conv_token5] = ACTIONS(38),
    [aux_sym_calling_conv_token6] = ACTIONS(38),
    [aux_sym_calling_conv_token7] = ACTIONS(38),
    [aux_sym_calling_conv_token8] = ACTIONS(38),
    [aux_sym_calling_conv_token9] = ACTIONS(38),
    [aux_sym_calling_conv_token10] = ACTIONS(70),
    [anon_sym_ghccc] = ACTIONS(38),
    [aux_sym_calling_conv_token11] = ACTIONS(70),
    [aux_sym_calling_conv_token12] = ACTIONS(38),
    [aux_sym_calling_conv_token13] = ACTIONS(70),
    [aux_sym_calling_conv_token14] = ACTIONS(38),
    [anon_sym_cc] = ACTIONS(70),
    [anon_sym_unnamed_addr] = ACTIONS(38),
    [anon_sym_local_unnamed_addr] = ACTIONS(38),
    [anon_sym_void] = ACTIONS(38),
    [anon_sym_half] = ACTIONS(38),
    [anon_sym_bfloat] = ACTIONS(38),
    [anon_sym_float] = ACTIONS(38),
    [anon_sym_double] = ACTIONS(38),
    [anon_sym_x86_fp80] = ACTIONS(70),
    [anon_sym_fp128] = ACTIONS(38),
    [anon_sym_ppc_fp128] = ACTIONS(38),
    [anon_sym_label] = ACTIONS(38),
    [anon_sym_metadata] = ACTIONS(38),
    [anon_sym_x86_mmx] = ACTIONS(70),
    [anon_sym_x86_amx] = ACTIONS(70),
    [anon_sym_token] = ACTIONS(38),
    [anon_sym_opaque] = ACTIONS(38),
    [anon_sym_ptr] = ACTIONS(70),
    [aux_sym_type_keyword_token1] = ACTIONS(38),
    [anon_sym_LBRACE] = ACTIONS(72),
    [anon_sym_LT_LBRACE] = ACTIONS(75),
    [anon_sym_LBRACK] = ACTIONS(78),
    [anon_sym_LT] = ACTIONS(81),
    [anon_sym_align] = ACTIONS(70),
    [anon_sym_alignstack] = ACTIONS(38),
    [anon_sym_allocsize] = ACTIONS(38),
    [anon_sym_alwaysinline] = ACTIONS(38),
    [anon_sym_builtin] = ACTIONS(38),
    [anon_sym_cold] = ACTIONS(70),
    [anon_sym_convergent] = ACTIONS(38),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(38),
    [anon_sym_hot] = ACTIONS(38),
    [anon_sym_inaccessiblememonly] = ACTIONS(38),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(38),
    [anon_sym_inlinehint] = ACTIONS(38),
    [anon_sym_jumptable] = ACTIONS(38),
    [anon_sym_minsize] = ACTIONS(38),
    [anon_sym_naked] = ACTIONS(38),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(38),
    [anon_sym_nobuiltin] = ACTIONS(38),
    [anon_sym_noduplicate] = ACTIONS(38),
    [anon_sym_nofree] = ACTIONS(38),
    [anon_sym_noimplicitfloat] = ACTIONS(38),
    [anon_sym_noinline] = ACTIONS(38),
    [anon_sym_nomerge] = ACTIONS(38),
    [anon_sym_nonlazybind] = ACTIONS(38),
    [anon_sym_noprofile] = ACTIONS(38),
    [anon_sym_noredzone] = ACTIONS(38),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(38),
    [anon_sym_noreturn] = ACTIONS(38),
    [anon_sym_norecurse] = ACTIONS(38),
    [anon_sym_willreturn] = ACTIONS(38),
    [anon_sym_nosync] = ACTIONS(38),
    [anon_sym_nounwind] = ACTIONS(38),
    [anon_sym_nocallback] = ACTIONS(38),
    [anon_sym_nosanitize_coverage] = ACTIONS(38),
    [anon_sym_null_pointer_is_valid] = ACTIONS(38),
    [anon_sym_optforfuzzing] = ACTIONS(38),
    [anon_sym_optnone] = ACTIONS(38),
    [anon_sym_optsize] = ACTIONS(38),
    [anon_sym_readnone] = ACTIONS(38),
    [anon_sym_readonly] = ACTIONS(38),
    [anon_sym_writeonly] = ACTIONS(38),
    [anon_sym_argmemonly] = ACTIONS(38),
    [anon_sym_returns_twice] = ACTIONS(38),
    [anon_sym_safestack] = ACTIONS(38),
    [anon_sym_sanitize_address] = ACTIONS(38),
    [anon_sym_sanitize_memory] = ACTIONS(38),
    [anon_sym_sanitize_thread] = ACTIONS(38),
    [anon_sym_sanitize_hwaddress] = ACTIONS(38),
    [anon_sym_sanitize_memtag] = ACTIONS(38),
    [anon_sym_speculative_load_hardening] = ACTIONS(38),
    [anon_sym_speculatable] = ACTIONS(38),
    [anon_sym_ssp] = ACTIONS(70),
    [anon_sym_sspstrong] = ACTIONS(38),
    [anon_sym_sspreq] = ACTIONS(38),
    [anon_sym_strictfp] = ACTIONS(38),
    [anon_sym_nocf_check] = ACTIONS(38),
    [anon_sym_shadowcallstack] = ACTIONS(38),
    [anon_sym_mustprogress] = ACTIONS(38),
    [anon_sym_vscale_range] = ACTIONS(38),
    [anon_sym_preallocated] = ACTIONS(38),
    [anon_sym_zeroext] = ACTIONS(38),
    [anon_sym_signext] = ACTIONS(38),
    [anon_sym_inreg] = ACTIONS(38),
    [anon_sym_byval] = ACTIONS(38),
    [anon_sym_byref] = ACTIONS(38),
    [anon_sym_inalloca] = ACTIONS(38),
    [anon_sym_sret] = ACTIONS(38),
    [anon_sym_elementtype] = ACTIONS(38),
    [anon_sym_noalias] = ACTIONS(38),
    [anon_sym_nocapture] = ACTIONS(38),
    [anon_sym_nest] = ACTIONS(38),
    [anon_sym_returned] = ACTIONS(38),
    [anon_sym_nonnull] = ACTIONS(38),
    [anon_sym_dereferenceable] = ACTIONS(70),
    [anon_sym_dereferenceable_or_null] = ACTIONS(38),
    [anon_sym_swiftself] = ACTIONS(70),
    [anon_sym_swiftasync] = ACTIONS(70),
    [anon_sym_swifterror] = ACTIONS(70),
    [anon_sym_immarg] = ACTIONS(38),
    [anon_sym_noundef] = ACTIONS(38),
    [anon_sym_uwtable] = ACTIONS(38),
    [anon_sym_memory] = ACTIONS(38),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(104),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(112),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [3] = {
    [sym_metadata_ref] = STATE(128),
    [sym_type] = STATE(4),
    [sym_type_keyword] = STATE(30),
    [sym_struct_type] = STATE(30),
    [sym_packed_struct_type] = STATE(30),
    [sym_array_type] = STATE(30),
    [sym_vector_type] = STATE(30),
    [sym_type_and_value] = STATE(145),
    [sym_metadata] = STATE(161),
    [sym_metadata_tuple] = STATE(145),
    [sym_specialized_md] = STATE(145),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(116),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(118),
    [sym_label] = ACTIONS(116),
    [aux_sym_metadata_ref_token1] = ACTIONS(120),
    [sym_string] = ACTIONS(122),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(122),
    [sym_float] = ACTIONS(122),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(122),
    [anon_sym_private] = ACTIONS(122),
    [anon_sym_internal] = ACTIONS(122),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(122),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(122),
    [anon_sym_available_externally] = ACTIONS(122),
    [anon_sym_appending] = ACTIONS(122),
    [anon_sym_common] = ACTIONS(122),
    [anon_sym_extern_weak] = ACTIONS(122),
    [anon_sym_external] = ACTIONS(122),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(122),
    [anon_sym_dso_preemptable] = ACTIONS(122),
    [anon_sym_default] = ACTIONS(122),
    [anon_sym_hidden] = ACTIONS(122),
    [anon_sym_protected] = ACTIONS(122),
    [anon_sym_dllimport] = ACTIONS(122),
    [anon_sym_dllexport] = ACTIONS(122),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(124),
    [anon_sym_half] = ACTIONS(124),
    [anon_sym_bfloat] = ACTIONS(124),
    [anon_sym_float] = ACTIONS(124),
    [anon_sym_double] = ACTIONS(124),
    [anon_sym_x86_fp80] = ACTIONS(124),
    [anon_sym_fp128] = ACTIONS(124),
    [anon_sym_ppc_fp128] = ACTIONS(124),
    [anon_sym_label] = ACTIONS(124),
    [anon_sym_metadata] = ACTIONS(126),
    [anon_sym_x86_mmx] = ACTIONS(124),
    [anon_sym_x86_amx] = ACTIONS(124),
    [anon_sym_token] = ACTIONS(124),
    [anon_sym_opaque] = ACTIONS(124),
    [anon_sym_ptr] = ACTIONS(124),
    [aux_sym_type_keyword_token1] = ACTIONS(124),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_RBRACE] = ACTIONS(116),
    [anon_sym_LT_LBRACE] = ACTIONS(130),
    [anon_sym_LBRACK] = ACTIONS(132),
    [anon_sym_LT] = ACTIONS(134),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_align] = ACTIONS(122),
    [anon_sym_section] = ACTIONS(122),
    [anon_sym_partition] = ACTIONS(122),
    [anon_sym_comdat] = ACTIONS(122),
    [anon_sym_gc] = ACTIONS(122),
    [anon_sym_prefix] = ACTIONS(122),
    [anon_sym_prologue] = ACTIONS(122),
    [anon_sym_personality] = ACTIONS(122),
    [anon_sym_alignstack] = ACTIONS(122),
    [anon_sym_allocsize] = ACTIONS(122),
    [anon_sym_alwaysinline] = ACTIONS(122),
    [anon_sym_builtin] = ACTIONS(122),
    [anon_sym_cold] = ACTIONS(122),
    [anon_sym_convergent] = ACTIONS(122),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(122),
    [anon_sym_hot] = ACTIONS(122),
    [anon_sym_inaccessiblememonly] = ACTIONS(122),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(122),
    [anon_sym_inlinehint] = ACTIONS(122),
    [anon_sym_jumptable] = ACTIONS(122),
    [anon_sym_minsize] = ACTIONS(122),
    [anon_sym_naked] = ACTIONS(122),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(122),
    [anon_sym_nobuiltin] = ACTIONS(122),
    [anon_sym_noduplicate] = ACTIONS(122),
    [anon_sym_nofree] = ACTIONS(122),
    [anon_sym_noimplicitfloat] = ACTIONS(122),
    [anon_sym_noinline] = ACTIONS(122),
    [anon_sym_nomerge] = ACTIONS(122),
    [anon_sym_nonlazybind] = ACTIONS(122),
    [anon_sym_noprofile] = ACTIONS(122),
    [anon_sym_noredzone] = ACTIONS(122),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(122),
    [anon_sym_noreturn] = ACTIONS(122),
    [anon_sym_norecurse] = ACTIONS(122),
    [anon_sym_willreturn] = ACTIONS(122),
    [anon_sym_nosync] = ACTIONS(122),
    [anon_sym_nounwind] = ACTIONS(122),
    [anon_sym_nocallback] = ACTIONS(122),
    [anon_sym_nosanitize_coverage] = ACTIONS(122),
    [anon_sym_null_pointer_is_valid] = ACTIONS(122),
    [anon_sym_optforfuzzing] = ACTIONS(122),
    [anon_sym_optnone] = ACTIONS(122),
    [anon_sym_optsize] = ACTIONS(122),
    [anon_sym_readnone] = ACTIONS(122),
    [anon_sym_readonly] = ACTIONS(122),
    [anon_sym_writeonly] = ACTIONS(122),
    [anon_sym_argmemonly] = ACTIONS(122),
    [anon_sym_returns_twice] = ACTIONS(122),
    [anon_sym_safestack] = ACTIONS(122),
    [anon_sym_sanitize_address] = ACTIONS(122),
    [anon_sym_sanitize_memory] = ACTIONS(122),
    [anon_sym_sanitize_thread] = ACTIONS(122),
    [anon_sym_sanitize_hwaddress] = ACTIONS(122),
    [anon_sym_sanitize_memtag] = ACTIONS(122),
    [anon_sym_speculative_load_hardening] = ACTIONS(122),
    [anon_sym_speculatable] = ACTIONS(122),
    [anon_sym_ssp] = ACTIONS(122),
    [anon_sym_sspstrong] = ACTIONS(122),
    [anon_sym_sspreq] = ACTIONS(122),
    [anon_sym_strictfp] = ACTIONS(122),
    [anon_sym_nocf_check] = ACTIONS(122),
    [anon_sym_shadowcallstack] = ACTIONS(122),
    [anon_sym_mustprogress] = ACTIONS(122),
    [anon_sym_vscale_range] = ACTIONS(122),
    [anon_sym_preallocated] = ACTIONS(122),
    [anon_sym_zeroext] = ACTIONS(122),
    [anon_sym_signext] = ACTIONS(122),
    [anon_sym_inreg] = ACTIONS(122),
    [anon_sym_byval] = ACTIONS(122),
    [anon_sym_byref] = ACTIONS(122),
    [anon_sym_inalloca] = ACTIONS(122),
    [anon_sym_sret] = ACTIONS(122),
    [anon_sym_elementtype] = ACTIONS(122),
    [anon_sym_noalias] = ACTIONS(122),
    [anon_sym_nocapture] = ACTIONS(122),
    [anon_sym_nest] = ACTIONS(122),
    [anon_sym_returned] = ACTIONS(122),
    [anon_sym_nonnull] = ACTIONS(122),
    [anon_sym_dereferenceable] = ACTIONS(122),
    [anon_sym_dereferenceable_or_null] = ACTIONS(122),
    [anon_sym_swiftself] = ACTIONS(122),
    [anon_sym_swiftasync] = ACTIONS(122),
    [anon_sym_swifterror] = ACTIONS(122),
    [anon_sym_immarg] = ACTIONS(122),
    [anon_sym_noundef] = ACTIONS(122),
    [anon_sym_uwtable] = ACTIONS(122),
    [anon_sym_memory] = ACTIONS(122),
    [anon_sym_none] = ACTIONS(122),
    [anon_sym_unreachable] = ACTIONS(122),
    [anon_sym_ret] = ACTIONS(122),
    [anon_sym_br] = ACTIONS(122),
    [anon_sym_resume] = ACTIONS(122),
    [anon_sym_freeze] = ACTIONS(122),
    [anon_sym_indirectbr] = ACTIONS(122),
    [anon_sym_extractelement] = ACTIONS(122),
    [anon_sym_insertelement] = ACTIONS(122),
    [anon_sym_select] = ACTIONS(122),
    [anon_sym_shufflevector] = ACTIONS(122),
    [anon_sym_fneg] = ACTIONS(122),
    [anon_sym_switch] = ACTIONS(122),
    [anon_sym_invoke] = ACTIONS(122),
    [anon_sym_cleanupret] = ACTIONS(122),
    [anon_sym_catchret] = ACTIONS(122),
    [anon_sym_catchswitch] = ACTIONS(122),
    [anon_sym_catchpad] = ACTIONS(122),
    [anon_sym_cleanuppad] = ACTIONS(122),
    [anon_sym_callbr] = ACTIONS(122),
    [anon_sym_icmp] = ACTIONS(122),
    [anon_sym_fcmp] = ACTIONS(122),
    [anon_sym_va_arg] = ACTIONS(122),
    [anon_sym_phi] = ACTIONS(122),
    [anon_sym_landingpad] = ACTIONS(122),
    [anon_sym_tail] = ACTIONS(122),
    [anon_sym_musttail] = ACTIONS(122),
    [anon_sym_notail] = ACTIONS(122),
    [anon_sym_call] = ACTIONS(122),
    [anon_sym_alloca] = ACTIONS(122),
    [anon_sym_load] = ACTIONS(122),
    [anon_sym_store] = ACTIONS(122),
    [anon_sym_cmpxchg] = ACTIONS(122),
    [anon_sym_atomicrmw] = ACTIONS(122),
    [anon_sym_fence] = ACTIONS(122),
    [anon_sym_getelementptr] = ACTIONS(122),
    [anon_sym_extractvalue] = ACTIONS(122),
    [anon_sym_insertvalue] = ACTIONS(122),
    [anon_sym_true] = ACTIONS(122),
    [anon_sym_false] = ACTIONS(122),
    [anon_sym_null] = ACTIONS(136),
    [anon_sym_undef] = ACTIONS(122),
    [anon_sym_poison] = ACTIONS(122),
    [anon_sym_zeroinitializer] = ACTIONS(122),
    [anon_sym_blockaddress] = ACTIONS(122),
    [anon_sym_mul] = ACTIONS(122),
    [anon_sym_urem] = ACTIONS(122),
    [anon_sym_srem] = ACTIONS(122),
    [anon_sym_shl] = ACTIONS(122),
    [anon_sym_udiv] = ACTIONS(122),
    [anon_sym_sdiv] = ACTIONS(122),
    [anon_sym_lshr] = ACTIONS(122),
    [anon_sym_ashr] = ACTIONS(122),
    [anon_sym_fmul] = ACTIONS(122),
    [anon_sym_fdiv] = ACTIONS(122),
    [anon_sym_frem] = ACTIONS(122),
    [anon_sym_xchg] = ACTIONS(122),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(122),
    [anon_sym_and] = ACTIONS(122),
    [anon_sym_nand] = ACTIONS(122),
    [anon_sym_or] = ACTIONS(122),
    [anon_sym_xor] = ACTIONS(122),
    [anon_sym_max] = ACTIONS(122),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(122),
    [anon_sym_umin] = ACTIONS(122),
    [anon_sym_fadd] = ACTIONS(122),
    [anon_sym_fsub] = ACTIONS(122),
    [anon_sym_bitcast] = ACTIONS(122),
    [anon_sym_trunc] = ACTIONS(122),
    [anon_sym_zext] = ACTIONS(122),
    [anon_sym_sext] = ACTIONS(122),
    [anon_sym_fptrunc] = ACTIONS(122),
    [anon_sym_fpext] = ACTIONS(122),
    [anon_sym_addrspacecast] = ACTIONS(122),
    [anon_sym_uitofp] = ACTIONS(122),
    [anon_sym_sitofp] = ACTIONS(122),
    [anon_sym_fptoui] = ACTIONS(122),
    [anon_sym_fptosi] = ACTIONS(122),
    [anon_sym_inttoptr] = ACTIONS(122),
    [anon_sym_ptrtoint] = ACTIONS(122),
    [anon_sym_uselistorder] = ACTIONS(122),
    [anon_sym_BANG] = ACTIONS(138),
  },
  [4] = {
    [sym_number] = STATE(164),
    [sym_var] = STATE(164),
    [sym_linkage] = STATE(784),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(172),
    [sym__primitive_value] = STATE(164),
    [sym_struct_value] = STATE(164),
    [sym_packed_struct_value] = STATE(164),
    [sym_array_value] = STATE(164),
    [sym_vector_value] = STATE(164),
    [sym_blockaddress] = STATE(164),
    [sym_constant_expr] = STATE(164),
    [sym_constant_cast] = STATE(175),
    [sym_constant_getelementptr] = STATE(175),
    [sym_constant_select] = STATE(175),
    [sym_constant_icmp] = STATE(175),
    [sym_constant_fcmp] = STATE(175),
    [sym_constant_extractelement] = STATE(175),
    [sym_constant_insertelement] = STATE(175),
    [sym_constant_shufflevector] = STATE(175),
    [sym_constant_extractvalue] = STATE(175),
    [sym_constant_insertvalue] = STATE(175),
    [sym_constant_fneg] = STATE(175),
    [sym_constant_bin_op] = STATE(175),
    [sym_bin_op_keyword] = STATE(1106),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1954),
    [aux_sym_function_header_repeat1] = STATE(784),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(38),
    [sym_global_var] = ACTIONS(140),
    [sym_local_var] = ACTIONS(142),
    [sym_label] = ACTIONS(38),
    [sym_string] = ACTIONS(145),
    [aux_sym_number_token1] = ACTIONS(148),
    [aux_sym_number_token2] = ACTIONS(148),
    [sym_float] = ACTIONS(150),
    [sym_cstring] = ACTIONS(152),
    [anon_sym_no_cfi] = ACTIONS(154),
    [anon_sym_private] = ACTIONS(156),
    [anon_sym_internal] = ACTIONS(156),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(156),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(156),
    [anon_sym_available_externally] = ACTIONS(156),
    [anon_sym_appending] = ACTIONS(156),
    [anon_sym_common] = ACTIONS(156),
    [anon_sym_extern_weak] = ACTIONS(156),
    [anon_sym_external] = ACTIONS(156),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(158),
    [anon_sym_dso_preemptable] = ACTIONS(158),
    [anon_sym_default] = ACTIONS(160),
    [anon_sym_hidden] = ACTIONS(160),
    [anon_sym_protected] = ACTIONS(160),
    [anon_sym_dllimport] = ACTIONS(162),
    [anon_sym_dllexport] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(164),
    [anon_sym_RBRACE] = ACTIONS(38),
    [anon_sym_LT_LBRACE] = ACTIONS(166),
    [anon_sym_LBRACK] = ACTIONS(168),
    [anon_sym_LT] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(38),
    [anon_sym_align] = ACTIONS(70),
    [anon_sym_section] = ACTIONS(70),
    [anon_sym_partition] = ACTIONS(70),
    [anon_sym_comdat] = ACTIONS(70),
    [anon_sym_gc] = ACTIONS(70),
    [anon_sym_prefix] = ACTIONS(70),
    [anon_sym_prologue] = ACTIONS(70),
    [anon_sym_personality] = ACTIONS(70),
    [anon_sym_alignstack] = ACTIONS(70),
    [anon_sym_allocsize] = ACTIONS(70),
    [anon_sym_alwaysinline] = ACTIONS(70),
    [anon_sym_builtin] = ACTIONS(70),
    [anon_sym_cold] = ACTIONS(70),
    [anon_sym_convergent] = ACTIONS(70),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(70),
    [anon_sym_hot] = ACTIONS(70),
    [anon_sym_inaccessiblememonly] = ACTIONS(70),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(70),
    [anon_sym_inlinehint] = ACTIONS(70),
    [anon_sym_jumptable] = ACTIONS(70),
    [anon_sym_minsize] = ACTIONS(70),
    [anon_sym_naked] = ACTIONS(70),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(70),
    [anon_sym_nobuiltin] = ACTIONS(70),
    [anon_sym_noduplicate] = ACTIONS(70),
    [anon_sym_nofree] = ACTIONS(70),
    [anon_sym_noimplicitfloat] = ACTIONS(70),
    [anon_sym_noinline] = ACTIONS(70),
    [anon_sym_nomerge] = ACTIONS(70),
    [anon_sym_nonlazybind] = ACTIONS(70),
    [anon_sym_noprofile] = ACTIONS(70),
    [anon_sym_noredzone] = ACTIONS(70),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(70),
    [anon_sym_noreturn] = ACTIONS(70),
    [anon_sym_norecurse] = ACTIONS(70),
    [anon_sym_willreturn] = ACTIONS(70),
    [anon_sym_nosync] = ACTIONS(70),
    [anon_sym_nounwind] = ACTIONS(70),
    [anon_sym_nocallback] = ACTIONS(70),
    [anon_sym_nosanitize_coverage] = ACTIONS(70),
    [anon_sym_null_pointer_is_valid] = ACTIONS(70),
    [anon_sym_optforfuzzing] = ACTIONS(70),
    [anon_sym_optnone] = ACTIONS(70),
    [anon_sym_optsize] = ACTIONS(70),
    [anon_sym_readnone] = ACTIONS(70),
    [anon_sym_readonly] = ACTIONS(70),
    [anon_sym_writeonly] = ACTIONS(70),
    [anon_sym_argmemonly] = ACTIONS(70),
    [anon_sym_returns_twice] = ACTIONS(70),
    [anon_sym_safestack] = ACTIONS(70),
    [anon_sym_sanitize_address] = ACTIONS(70),
    [anon_sym_sanitize_memory] = ACTIONS(70),
    [anon_sym_sanitize_thread] = ACTIONS(70),
    [anon_sym_sanitize_hwaddress] = ACTIONS(70),
    [anon_sym_sanitize_memtag] = ACTIONS(70),
    [anon_sym_speculative_load_hardening] = ACTIONS(70),
    [anon_sym_speculatable] = ACTIONS(70),
    [anon_sym_ssp] = ACTIONS(70),
    [anon_sym_sspstrong] = ACTIONS(70),
    [anon_sym_sspreq] = ACTIONS(70),
    [anon_sym_strictfp] = ACTIONS(70),
    [anon_sym_nocf_check] = ACTIONS(70),
    [anon_sym_shadowcallstack] = ACTIONS(70),
    [anon_sym_mustprogress] = ACTIONS(70),
    [anon_sym_vscale_range] = ACTIONS(70),
    [anon_sym_preallocated] = ACTIONS(70),
    [anon_sym_zeroext] = ACTIONS(70),
    [anon_sym_signext] = ACTIONS(70),
    [anon_sym_inreg] = ACTIONS(70),
    [anon_sym_byval] = ACTIONS(70),
    [anon_sym_byref] = ACTIONS(70),
    [anon_sym_inalloca] = ACTIONS(70),
    [anon_sym_sret] = ACTIONS(70),
    [anon_sym_elementtype] = ACTIONS(70),
    [anon_sym_noalias] = ACTIONS(70),
    [anon_sym_nocapture] = ACTIONS(70),
    [anon_sym_nest] = ACTIONS(70),
    [anon_sym_returned] = ACTIONS(70),
    [anon_sym_nonnull] = ACTIONS(70),
    [anon_sym_dereferenceable] = ACTIONS(70),
    [anon_sym_dereferenceable_or_null] = ACTIONS(70),
    [anon_sym_swiftself] = ACTIONS(70),
    [anon_sym_swiftasync] = ACTIONS(70),
    [anon_sym_swifterror] = ACTIONS(70),
    [anon_sym_immarg] = ACTIONS(70),
    [anon_sym_noundef] = ACTIONS(70),
    [anon_sym_uwtable] = ACTIONS(70),
    [anon_sym_memory] = ACTIONS(70),
    [anon_sym_none] = ACTIONS(150),
    [anon_sym_unreachable] = ACTIONS(70),
    [anon_sym_ret] = ACTIONS(70),
    [anon_sym_br] = ACTIONS(70),
    [anon_sym_resume] = ACTIONS(70),
    [anon_sym_freeze] = ACTIONS(70),
    [anon_sym_indirectbr] = ACTIONS(70),
    [anon_sym_extractelement] = ACTIONS(173),
    [anon_sym_insertelement] = ACTIONS(176),
    [anon_sym_select] = ACTIONS(179),
    [anon_sym_shufflevector] = ACTIONS(182),
    [anon_sym_fneg] = ACTIONS(185),
    [anon_sym_switch] = ACTIONS(70),
    [anon_sym_invoke] = ACTIONS(70),
    [anon_sym_cleanupret] = ACTIONS(70),
    [anon_sym_catchret] = ACTIONS(70),
    [anon_sym_catchswitch] = ACTIONS(70),
    [anon_sym_catchpad] = ACTIONS(70),
    [anon_sym_cleanuppad] = ACTIONS(70),
    [anon_sym_callbr] = ACTIONS(70),
    [anon_sym_icmp] = ACTIONS(188),
    [anon_sym_fcmp] = ACTIONS(191),
    [anon_sym_va_arg] = ACTIONS(70),
    [anon_sym_phi] = ACTIONS(70),
    [anon_sym_landingpad] = ACTIONS(70),
    [anon_sym_tail] = ACTIONS(70),
    [anon_sym_musttail] = ACTIONS(70),
    [anon_sym_notail] = ACTIONS(70),
    [anon_sym_call] = ACTIONS(70),
    [anon_sym_alloca] = ACTIONS(70),
    [anon_sym_load] = ACTIONS(70),
    [anon_sym_store] = ACTIONS(70),
    [anon_sym_cmpxchg] = ACTIONS(70),
    [anon_sym_atomicrmw] = ACTIONS(70),
    [anon_sym_fence] = ACTIONS(70),
    [anon_sym_getelementptr] = ACTIONS(194),
    [anon_sym_extractvalue] = ACTIONS(197),
    [anon_sym_insertvalue] = ACTIONS(200),
    [anon_sym_true] = ACTIONS(150),
    [anon_sym_false] = ACTIONS(150),
    [anon_sym_null] = ACTIONS(150),
    [anon_sym_undef] = ACTIONS(150),
    [anon_sym_poison] = ACTIONS(150),
    [anon_sym_zeroinitializer] = ACTIONS(150),
    [anon_sym_blockaddress] = ACTIONS(203),
    [anon_sym_mul] = ACTIONS(205),
    [anon_sym_urem] = ACTIONS(205),
    [anon_sym_srem] = ACTIONS(205),
    [anon_sym_shl] = ACTIONS(205),
    [anon_sym_udiv] = ACTIONS(205),
    [anon_sym_sdiv] = ACTIONS(205),
    [anon_sym_lshr] = ACTIONS(205),
    [anon_sym_ashr] = ACTIONS(205),
    [anon_sym_fmul] = ACTIONS(205),
    [anon_sym_fdiv] = ACTIONS(205),
    [anon_sym_frem] = ACTIONS(205),
    [anon_sym_xchg] = ACTIONS(208),
    [anon_sym_add] = ACTIONS(208),
    [anon_sym_sub] = ACTIONS(208),
    [anon_sym_and] = ACTIONS(208),
    [anon_sym_nand] = ACTIONS(208),
    [anon_sym_or] = ACTIONS(208),
    [anon_sym_xor] = ACTIONS(208),
    [anon_sym_max] = ACTIONS(208),
    [anon_sym_min] = ACTIONS(208),
    [anon_sym_umax] = ACTIONS(208),
    [anon_sym_umin] = ACTIONS(208),
    [anon_sym_fadd] = ACTIONS(208),
    [anon_sym_fsub] = ACTIONS(208),
    [anon_sym_bitcast] = ACTIONS(211),
    [anon_sym_trunc] = ACTIONS(211),
    [anon_sym_zext] = ACTIONS(211),
    [anon_sym_sext] = ACTIONS(211),
    [anon_sym_fptrunc] = ACTIONS(211),
    [anon_sym_fpext] = ACTIONS(211),
    [anon_sym_addrspacecast] = ACTIONS(211),
    [anon_sym_uitofp] = ACTIONS(211),
    [anon_sym_sitofp] = ACTIONS(211),
    [anon_sym_fptoui] = ACTIONS(211),
    [anon_sym_fptosi] = ACTIONS(211),
    [anon_sym_inttoptr] = ACTIONS(211),
    [anon_sym_ptrtoint] = ACTIONS(211),
    [anon_sym_uselistorder] = ACTIONS(70),
  },
  [5] = {
    [sym_metadata_ref] = STATE(100),
    [sym_type] = STATE(2),
    [sym_type_keyword] = STATE(6),
    [sym_struct_type] = STATE(6),
    [sym_packed_struct_type] = STATE(6),
    [sym_array_type] = STATE(6),
    [sym_vector_type] = STATE(6),
    [sym_type_and_value] = STATE(134),
    [sym_metadata] = STATE(126),
    [sym_metadata_tuple] = STATE(134),
    [sym_specialized_md] = STATE(134),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(214),
    [aux_sym_metadata_ref_token1] = ACTIONS(13),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_ccc] = ACTIONS(116),
    [anon_sym_fastcc] = ACTIONS(116),
    [anon_sym_coldcc] = ACTIONS(116),
    [anon_sym_webkit_jscc] = ACTIONS(122),
    [anon_sym_anyregcc] = ACTIONS(116),
    [anon_sym_preserve_mostcc] = ACTIONS(116),
    [anon_sym_preserve_allcc] = ACTIONS(116),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(122),
    [anon_sym_tailcc] = ACTIONS(116),
    [anon_sym_swiftcc] = ACTIONS(122),
    [anon_sym_swifttailcc] = ACTIONS(122),
    [anon_sym_cfguard_checkcc] = ACTIONS(116),
    [aux_sym_calling_conv_token1] = ACTIONS(122),
    [aux_sym_calling_conv_token2] = ACTIONS(116),
    [aux_sym_calling_conv_token3] = ACTIONS(116),
    [aux_sym_calling_conv_token4] = ACTIONS(116),
    [aux_sym_calling_conv_token5] = ACTIONS(116),
    [aux_sym_calling_conv_token6] = ACTIONS(116),
    [aux_sym_calling_conv_token7] = ACTIONS(116),
    [aux_sym_calling_conv_token8] = ACTIONS(116),
    [aux_sym_calling_conv_token9] = ACTIONS(116),
    [aux_sym_calling_conv_token10] = ACTIONS(122),
    [anon_sym_ghccc] = ACTIONS(116),
    [aux_sym_calling_conv_token11] = ACTIONS(122),
    [aux_sym_calling_conv_token12] = ACTIONS(116),
    [aux_sym_calling_conv_token13] = ACTIONS(122),
    [aux_sym_calling_conv_token14] = ACTIONS(116),
    [anon_sym_cc] = ACTIONS(122),
    [anon_sym_unnamed_addr] = ACTIONS(116),
    [anon_sym_local_unnamed_addr] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(216),
    [anon_sym_half] = ACTIONS(216),
    [anon_sym_bfloat] = ACTIONS(216),
    [anon_sym_float] = ACTIONS(216),
    [anon_sym_double] = ACTIONS(216),
    [anon_sym_x86_fp80] = ACTIONS(218),
    [anon_sym_fp128] = ACTIONS(216),
    [anon_sym_ppc_fp128] = ACTIONS(216),
    [anon_sym_label] = ACTIONS(216),
    [anon_sym_metadata] = ACTIONS(220),
    [anon_sym_x86_mmx] = ACTIONS(218),
    [anon_sym_x86_amx] = ACTIONS(218),
    [anon_sym_token] = ACTIONS(216),
    [anon_sym_opaque] = ACTIONS(216),
    [anon_sym_ptr] = ACTIONS(218),
    [aux_sym_type_keyword_token1] = ACTIONS(216),
    [anon_sym_LBRACE] = ACTIONS(222),
    [anon_sym_LT_LBRACE] = ACTIONS(224),
    [anon_sym_LBRACK] = ACTIONS(226),
    [anon_sym_LT] = ACTIONS(228),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_align] = ACTIONS(122),
    [anon_sym_alignstack] = ACTIONS(116),
    [anon_sym_allocsize] = ACTIONS(116),
    [anon_sym_alwaysinline] = ACTIONS(116),
    [anon_sym_builtin] = ACTIONS(116),
    [anon_sym_cold] = ACTIONS(122),
    [anon_sym_convergent] = ACTIONS(116),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(116),
    [anon_sym_hot] = ACTIONS(116),
    [anon_sym_inaccessiblememonly] = ACTIONS(116),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(116),
    [anon_sym_inlinehint] = ACTIONS(116),
    [anon_sym_jumptable] = ACTIONS(116),
    [anon_sym_minsize] = ACTIONS(116),
    [anon_sym_naked] = ACTIONS(116),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(116),
    [anon_sym_nobuiltin] = ACTIONS(116),
    [anon_sym_noduplicate] = ACTIONS(116),
    [anon_sym_nofree] = ACTIONS(116),
    [anon_sym_noimplicitfloat] = ACTIONS(116),
    [anon_sym_noinline] = ACTIONS(116),
    [anon_sym_nomerge] = ACTIONS(116),
    [anon_sym_nonlazybind] = ACTIONS(116),
    [anon_sym_noprofile] = ACTIONS(116),
    [anon_sym_noredzone] = ACTIONS(116),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(116),
    [anon_sym_noreturn] = ACTIONS(116),
    [anon_sym_norecurse] = ACTIONS(116),
    [anon_sym_willreturn] = ACTIONS(116),
    [anon_sym_nosync] = ACTIONS(116),
    [anon_sym_nounwind] = ACTIONS(116),
    [anon_sym_nocallback] = ACTIONS(116),
    [anon_sym_nosanitize_coverage] = ACTIONS(116),
    [anon_sym_null_pointer_is_valid] = ACTIONS(116),
    [anon_sym_optforfuzzing] = ACTIONS(116),
    [anon_sym_optnone] = ACTIONS(116),
    [anon_sym_optsize] = ACTIONS(116),
    [anon_sym_readnone] = ACTIONS(116),
    [anon_sym_readonly] = ACTIONS(116),
    [anon_sym_writeonly] = ACTIONS(116),
    [anon_sym_argmemonly] = ACTIONS(116),
    [anon_sym_returns_twice] = ACTIONS(116),
    [anon_sym_safestack] = ACTIONS(116),
    [anon_sym_sanitize_address] = ACTIONS(116),
    [anon_sym_sanitize_memory] = ACTIONS(116),
    [anon_sym_sanitize_thread] = ACTIONS(116),
    [anon_sym_sanitize_hwaddress] = ACTIONS(116),
    [anon_sym_sanitize_memtag] = ACTIONS(116),
    [anon_sym_speculative_load_hardening] = ACTIONS(116),
    [anon_sym_speculatable] = ACTIONS(116),
    [anon_sym_ssp] = ACTIONS(122),
    [anon_sym_sspstrong] = ACTIONS(116),
    [anon_sym_sspreq] = ACTIONS(116),
    [anon_sym_strictfp] = ACTIONS(116),
    [anon_sym_nocf_check] = ACTIONS(116),
    [anon_sym_shadowcallstack] = ACTIONS(116),
    [anon_sym_mustprogress] = ACTIONS(116),
    [anon_sym_vscale_range] = ACTIONS(116),
    [anon_sym_preallocated] = ACTIONS(116),
    [anon_sym_zeroext] = ACTIONS(116),
    [anon_sym_signext] = ACTIONS(116),
    [anon_sym_inreg] = ACTIONS(116),
    [anon_sym_byval] = ACTIONS(116),
    [anon_sym_byref] = ACTIONS(116),
    [anon_sym_inalloca] = ACTIONS(116),
    [anon_sym_sret] = ACTIONS(116),
    [anon_sym_elementtype] = ACTIONS(116),
    [anon_sym_noalias] = ACTIONS(116),
    [anon_sym_nocapture] = ACTIONS(116),
    [anon_sym_nest] = ACTIONS(116),
    [anon_sym_returned] = ACTIONS(116),
    [anon_sym_nonnull] = ACTIONS(116),
    [anon_sym_dereferenceable] = ACTIONS(122),
    [anon_sym_dereferenceable_or_null] = ACTIONS(116),
    [anon_sym_swiftself] = ACTIONS(122),
    [anon_sym_swiftasync] = ACTIONS(122),
    [anon_sym_swifterror] = ACTIONS(122),
    [anon_sym_immarg] = ACTIONS(116),
    [anon_sym_noundef] = ACTIONS(116),
    [anon_sym_uwtable] = ACTIONS(116),
    [anon_sym_memory] = ACTIONS(116),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(230),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(232),
  },
  [6] = {
    [sym_addrspace] = STATE(29),
    [sym_argument_list] = STATE(7),
    [aux_sym_type_repeat1] = STATE(10),
    [aux_sym_type_repeat2] = STATE(7),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(234),
    [sym_local_var] = ACTIONS(234),
    [aux_sym_metadata_ref_token1] = ACTIONS(234),
    [sym_string] = ACTIONS(234),
    [aux_sym_number_token1] = ACTIONS(236),
    [aux_sym_number_token2] = ACTIONS(234),
    [sym_float] = ACTIONS(234),
    [sym_cstring] = ACTIONS(234),
    [anon_sym_no_cfi] = ACTIONS(234),
    [anon_sym_private] = ACTIONS(234),
    [anon_sym_internal] = ACTIONS(234),
    [anon_sym_weak] = ACTIONS(236),
    [anon_sym_weak_odr] = ACTIONS(234),
    [anon_sym_linkonce] = ACTIONS(236),
    [anon_sym_linkonce_odr] = ACTIONS(234),
    [anon_sym_available_externally] = ACTIONS(234),
    [anon_sym_appending] = ACTIONS(234),
    [anon_sym_common] = ACTIONS(234),
    [anon_sym_extern_weak] = ACTIONS(234),
    [anon_sym_external] = ACTIONS(234),
    [anon_sym_dso_local] = ACTIONS(236),
    [anon_sym_dso_local_equivalent] = ACTIONS(234),
    [anon_sym_dso_preemptable] = ACTIONS(234),
    [anon_sym_default] = ACTIONS(234),
    [anon_sym_hidden] = ACTIONS(234),
    [anon_sym_protected] = ACTIONS(234),
    [anon_sym_dllimport] = ACTIONS(234),
    [anon_sym_dllexport] = ACTIONS(234),
    [anon_sym_ccc] = ACTIONS(234),
    [anon_sym_fastcc] = ACTIONS(234),
    [anon_sym_coldcc] = ACTIONS(234),
    [anon_sym_webkit_jscc] = ACTIONS(236),
    [anon_sym_anyregcc] = ACTIONS(234),
    [anon_sym_preserve_mostcc] = ACTIONS(234),
    [anon_sym_preserve_allcc] = ACTIONS(234),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(236),
    [anon_sym_tailcc] = ACTIONS(234),
    [anon_sym_swiftcc] = ACTIONS(236),
    [anon_sym_swifttailcc] = ACTIONS(236),
    [anon_sym_cfguard_checkcc] = ACTIONS(234),
    [aux_sym_calling_conv_token1] = ACTIONS(236),
    [aux_sym_calling_conv_token2] = ACTIONS(234),
    [aux_sym_calling_conv_token3] = ACTIONS(234),
    [aux_sym_calling_conv_token4] = ACTIONS(234),
    [aux_sym_calling_conv_token5] = ACTIONS(234),
    [aux_sym_calling_conv_token6] = ACTIONS(234),
    [aux_sym_calling_conv_token7] = ACTIONS(234),
    [aux_sym_calling_conv_token8] = ACTIONS(234),
    [aux_sym_calling_conv_token9] = ACTIONS(234),
    [aux_sym_calling_conv_token10] = ACTIONS(236),
    [anon_sym_ghccc] = ACTIONS(234),
    [aux_sym_calling_conv_token11] = ACTIONS(236),
    [aux_sym_calling_conv_token12] = ACTIONS(234),
    [aux_sym_calling_conv_token13] = ACTIONS(236),
    [aux_sym_calling_conv_token14] = ACTIONS(234),
    [anon_sym_cc] = ACTIONS(236),
    [anon_sym_unnamed_addr] = ACTIONS(234),
    [anon_sym_local_unnamed_addr] = ACTIONS(234),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_void] = ACTIONS(234),
    [anon_sym_half] = ACTIONS(234),
    [anon_sym_bfloat] = ACTIONS(234),
    [anon_sym_float] = ACTIONS(234),
    [anon_sym_double] = ACTIONS(234),
    [anon_sym_x86_fp80] = ACTIONS(236),
    [anon_sym_fp128] = ACTIONS(234),
    [anon_sym_ppc_fp128] = ACTIONS(234),
    [anon_sym_label] = ACTIONS(234),
    [anon_sym_metadata] = ACTIONS(234),
    [anon_sym_x86_mmx] = ACTIONS(236),
    [anon_sym_x86_amx] = ACTIONS(236),
    [anon_sym_token] = ACTIONS(234),
    [anon_sym_opaque] = ACTIONS(234),
    [anon_sym_ptr] = ACTIONS(236),
    [aux_sym_type_keyword_token1] = ACTIONS(234),
    [anon_sym_LBRACE] = ACTIONS(234),
    [anon_sym_LT_LBRACE] = ACTIONS(234),
    [anon_sym_RBRACE_GT] = ACTIONS(234),
    [anon_sym_LBRACK] = ACTIONS(234),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_COMMA] = ACTIONS(234),
    [anon_sym_addrspace] = ACTIONS(240),
    [anon_sym_LPAREN] = ACTIONS(242),
    [anon_sym_align] = ACTIONS(236),
    [anon_sym_alignstack] = ACTIONS(234),
    [anon_sym_allocsize] = ACTIONS(234),
    [anon_sym_alwaysinline] = ACTIONS(234),
    [anon_sym_builtin] = ACTIONS(234),
    [anon_sym_cold] = ACTIONS(236),
    [anon_sym_convergent] = ACTIONS(234),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(234),
    [anon_sym_hot] = ACTIONS(234),
    [anon_sym_inaccessiblememonly] = ACTIONS(234),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(234),
    [anon_sym_inlinehint] = ACTIONS(234),
    [anon_sym_jumptable] = ACTIONS(234),
    [anon_sym_minsize] = ACTIONS(234),
    [anon_sym_naked] = ACTIONS(234),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(234),
    [anon_sym_nobuiltin] = ACTIONS(234),
    [anon_sym_noduplicate] = ACTIONS(234),
    [anon_sym_nofree] = ACTIONS(234),
    [anon_sym_noimplicitfloat] = ACTIONS(234),
    [anon_sym_noinline] = ACTIONS(234),
    [anon_sym_nomerge] = ACTIONS(234),
    [anon_sym_nonlazybind] = ACTIONS(234),
    [anon_sym_noprofile] = ACTIONS(234),
    [anon_sym_noredzone] = ACTIONS(234),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(234),
    [anon_sym_noreturn] = ACTIONS(234),
    [anon_sym_norecurse] = ACTIONS(234),
    [anon_sym_willreturn] = ACTIONS(234),
    [anon_sym_nosync] = ACTIONS(234),
    [anon_sym_nounwind] = ACTIONS(234),
    [anon_sym_nocallback] = ACTIONS(234),
    [anon_sym_nosanitize_coverage] = ACTIONS(234),
    [anon_sym_null_pointer_is_valid] = ACTIONS(234),
    [anon_sym_optforfuzzing] = ACTIONS(234),
    [anon_sym_optnone] = ACTIONS(234),
    [anon_sym_optsize] = ACTIONS(234),
    [anon_sym_readnone] = ACTIONS(234),
    [anon_sym_readonly] = ACTIONS(234),
    [anon_sym_writeonly] = ACTIONS(234),
    [anon_sym_argmemonly] = ACTIONS(234),
    [anon_sym_returns_twice] = ACTIONS(234),
    [anon_sym_safestack] = ACTIONS(234),
    [anon_sym_sanitize_address] = ACTIONS(234),
    [anon_sym_sanitize_memory] = ACTIONS(234),
    [anon_sym_sanitize_thread] = ACTIONS(234),
    [anon_sym_sanitize_hwaddress] = ACTIONS(234),
    [anon_sym_sanitize_memtag] = ACTIONS(234),
    [anon_sym_speculative_load_hardening] = ACTIONS(234),
    [anon_sym_speculatable] = ACTIONS(234),
    [anon_sym_ssp] = ACTIONS(236),
    [anon_sym_sspstrong] = ACTIONS(234),
    [anon_sym_sspreq] = ACTIONS(234),
    [anon_sym_strictfp] = ACTIONS(234),
    [anon_sym_nocf_check] = ACTIONS(234),
    [anon_sym_shadowcallstack] = ACTIONS(234),
    [anon_sym_mustprogress] = ACTIONS(234),
    [anon_sym_vscale_range] = ACTIONS(234),
    [anon_sym_preallocated] = ACTIONS(234),
    [anon_sym_zeroext] = ACTIONS(234),
    [anon_sym_signext] = ACTIONS(234),
    [anon_sym_inreg] = ACTIONS(234),
    [anon_sym_byval] = ACTIONS(234),
    [anon_sym_byref] = ACTIONS(234),
    [anon_sym_inalloca] = ACTIONS(234),
    [anon_sym_sret] = ACTIONS(234),
    [anon_sym_elementtype] = ACTIONS(234),
    [anon_sym_noalias] = ACTIONS(234),
    [anon_sym_nocapture] = ACTIONS(234),
    [anon_sym_nest] = ACTIONS(234),
    [anon_sym_returned] = ACTIONS(234),
    [anon_sym_nonnull] = ACTIONS(234),
    [anon_sym_dereferenceable] = ACTIONS(236),
    [anon_sym_dereferenceable_or_null] = ACTIONS(234),
    [anon_sym_swiftself] = ACTIONS(236),
    [anon_sym_swiftasync] = ACTIONS(236),
    [anon_sym_swifterror] = ACTIONS(236),
    [anon_sym_immarg] = ACTIONS(234),
    [anon_sym_noundef] = ACTIONS(234),
    [anon_sym_uwtable] = ACTIONS(234),
    [anon_sym_memory] = ACTIONS(234),
    [anon_sym_none] = ACTIONS(234),
    [anon_sym_extractelement] = ACTIONS(234),
    [anon_sym_insertelement] = ACTIONS(234),
    [anon_sym_select] = ACTIONS(234),
    [anon_sym_shufflevector] = ACTIONS(234),
    [anon_sym_fneg] = ACTIONS(234),
    [anon_sym_icmp] = ACTIONS(234),
    [anon_sym_fcmp] = ACTIONS(234),
    [anon_sym_getelementptr] = ACTIONS(234),
    [anon_sym_extractvalue] = ACTIONS(234),
    [anon_sym_insertvalue] = ACTIONS(234),
    [anon_sym_true] = ACTIONS(234),
    [anon_sym_false] = ACTIONS(234),
    [anon_sym_null] = ACTIONS(236),
    [anon_sym_undef] = ACTIONS(234),
    [anon_sym_poison] = ACTIONS(234),
    [anon_sym_zeroinitializer] = ACTIONS(234),
    [anon_sym_blockaddress] = ACTIONS(234),
    [anon_sym_mul] = ACTIONS(234),
    [anon_sym_urem] = ACTIONS(234),
    [anon_sym_srem] = ACTIONS(234),
    [anon_sym_shl] = ACTIONS(234),
    [anon_sym_udiv] = ACTIONS(234),
    [anon_sym_sdiv] = ACTIONS(234),
    [anon_sym_lshr] = ACTIONS(234),
    [anon_sym_ashr] = ACTIONS(234),
    [anon_sym_fmul] = ACTIONS(234),
    [anon_sym_fdiv] = ACTIONS(234),
    [anon_sym_frem] = ACTIONS(234),
    [anon_sym_xchg] = ACTIONS(234),
    [anon_sym_add] = ACTIONS(236),
    [anon_sym_sub] = ACTIONS(234),
    [anon_sym_and] = ACTIONS(234),
    [anon_sym_nand] = ACTIONS(234),
    [anon_sym_or] = ACTIONS(234),
    [anon_sym_xor] = ACTIONS(234),
    [anon_sym_max] = ACTIONS(234),
    [anon_sym_min] = ACTIONS(236),
    [anon_sym_umax] = ACTIONS(234),
    [anon_sym_umin] = ACTIONS(234),
    [anon_sym_fadd] = ACTIONS(234),
    [anon_sym_fsub] = ACTIONS(234),
    [anon_sym_bitcast] = ACTIONS(234),
    [anon_sym_trunc] = ACTIONS(234),
    [anon_sym_zext] = ACTIONS(234),
    [anon_sym_sext] = ACTIONS(234),
    [anon_sym_fptrunc] = ACTIONS(234),
    [anon_sym_fpext] = ACTIONS(234),
    [anon_sym_addrspacecast] = ACTIONS(234),
    [anon_sym_uitofp] = ACTIONS(234),
    [anon_sym_sitofp] = ACTIONS(234),
    [anon_sym_fptoui] = ACTIONS(234),
    [anon_sym_fptosi] = ACTIONS(234),
    [anon_sym_inttoptr] = ACTIONS(234),
    [anon_sym_ptrtoint] = ACTIONS(234),
  },
  [7] = {
    [sym_addrspace] = STATE(28),
    [sym_argument_list] = STATE(8),
    [aux_sym_type_repeat1] = STATE(9),
    [aux_sym_type_repeat2] = STATE(8),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [aux_sym_metadata_ref_token1] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_ccc] = ACTIONS(244),
    [anon_sym_fastcc] = ACTIONS(244),
    [anon_sym_coldcc] = ACTIONS(244),
    [anon_sym_webkit_jscc] = ACTIONS(246),
    [anon_sym_anyregcc] = ACTIONS(244),
    [anon_sym_preserve_mostcc] = ACTIONS(244),
    [anon_sym_preserve_allcc] = ACTIONS(244),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(246),
    [anon_sym_tailcc] = ACTIONS(244),
    [anon_sym_swiftcc] = ACTIONS(246),
    [anon_sym_swifttailcc] = ACTIONS(246),
    [anon_sym_cfguard_checkcc] = ACTIONS(244),
    [aux_sym_calling_conv_token1] = ACTIONS(246),
    [aux_sym_calling_conv_token2] = ACTIONS(244),
    [aux_sym_calling_conv_token3] = ACTIONS(244),
    [aux_sym_calling_conv_token4] = ACTIONS(244),
    [aux_sym_calling_conv_token5] = ACTIONS(244),
    [aux_sym_calling_conv_token6] = ACTIONS(244),
    [aux_sym_calling_conv_token7] = ACTIONS(244),
    [aux_sym_calling_conv_token8] = ACTIONS(244),
    [aux_sym_calling_conv_token9] = ACTIONS(244),
    [aux_sym_calling_conv_token10] = ACTIONS(246),
    [anon_sym_ghccc] = ACTIONS(244),
    [aux_sym_calling_conv_token11] = ACTIONS(246),
    [aux_sym_calling_conv_token12] = ACTIONS(244),
    [aux_sym_calling_conv_token13] = ACTIONS(246),
    [aux_sym_calling_conv_token14] = ACTIONS(244),
    [anon_sym_cc] = ACTIONS(246),
    [anon_sym_unnamed_addr] = ACTIONS(244),
    [anon_sym_local_unnamed_addr] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(248),
    [anon_sym_void] = ACTIONS(244),
    [anon_sym_half] = ACTIONS(244),
    [anon_sym_bfloat] = ACTIONS(244),
    [anon_sym_float] = ACTIONS(244),
    [anon_sym_double] = ACTIONS(244),
    [anon_sym_x86_fp80] = ACTIONS(246),
    [anon_sym_fp128] = ACTIONS(244),
    [anon_sym_ppc_fp128] = ACTIONS(244),
    [anon_sym_label] = ACTIONS(244),
    [anon_sym_metadata] = ACTIONS(244),
    [anon_sym_x86_mmx] = ACTIONS(246),
    [anon_sym_x86_amx] = ACTIONS(246),
    [anon_sym_token] = ACTIONS(244),
    [anon_sym_opaque] = ACTIONS(244),
    [anon_sym_ptr] = ACTIONS(246),
    [aux_sym_type_keyword_token1] = ACTIONS(244),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE_GT] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(240),
    [anon_sym_LPAREN] = ACTIONS(242),
    [anon_sym_align] = ACTIONS(246),
    [anon_sym_alignstack] = ACTIONS(244),
    [anon_sym_allocsize] = ACTIONS(244),
    [anon_sym_alwaysinline] = ACTIONS(244),
    [anon_sym_builtin] = ACTIONS(244),
    [anon_sym_cold] = ACTIONS(246),
    [anon_sym_convergent] = ACTIONS(244),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(244),
    [anon_sym_hot] = ACTIONS(244),
    [anon_sym_inaccessiblememonly] = ACTIONS(244),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(244),
    [anon_sym_inlinehint] = ACTIONS(244),
    [anon_sym_jumptable] = ACTIONS(244),
    [anon_sym_minsize] = ACTIONS(244),
    [anon_sym_naked] = ACTIONS(244),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(244),
    [anon_sym_nobuiltin] = ACTIONS(244),
    [anon_sym_noduplicate] = ACTIONS(244),
    [anon_sym_nofree] = ACTIONS(244),
    [anon_sym_noimplicitfloat] = ACTIONS(244),
    [anon_sym_noinline] = ACTIONS(244),
    [anon_sym_nomerge] = ACTIONS(244),
    [anon_sym_nonlazybind] = ACTIONS(244),
    [anon_sym_noprofile] = ACTIONS(244),
    [anon_sym_noredzone] = ACTIONS(244),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(244),
    [anon_sym_noreturn] = ACTIONS(244),
    [anon_sym_norecurse] = ACTIONS(244),
    [anon_sym_willreturn] = ACTIONS(244),
    [anon_sym_nosync] = ACTIONS(244),
    [anon_sym_nounwind] = ACTIONS(244),
    [anon_sym_nocallback] = ACTIONS(244),
    [anon_sym_nosanitize_coverage] = ACTIONS(244),
    [anon_sym_null_pointer_is_valid] = ACTIONS(244),
    [anon_sym_optforfuzzing] = ACTIONS(244),
    [anon_sym_optnone] = ACTIONS(244),
    [anon_sym_optsize] = ACTIONS(244),
    [anon_sym_readnone] = ACTIONS(244),
    [anon_sym_readonly] = ACTIONS(244),
    [anon_sym_writeonly] = ACTIONS(244),
    [anon_sym_argmemonly] = ACTIONS(244),
    [anon_sym_returns_twice] = ACTIONS(244),
    [anon_sym_safestack] = ACTIONS(244),
    [anon_sym_sanitize_address] = ACTIONS(244),
    [anon_sym_sanitize_memory] = ACTIONS(244),
    [anon_sym_sanitize_thread] = ACTIONS(244),
    [anon_sym_sanitize_hwaddress] = ACTIONS(244),
    [anon_sym_sanitize_memtag] = ACTIONS(244),
    [anon_sym_speculative_load_hardening] = ACTIONS(244),
    [anon_sym_speculatable] = ACTIONS(244),
    [anon_sym_ssp] = ACTIONS(246),
    [anon_sym_sspstrong] = ACTIONS(244),
    [anon_sym_sspreq] = ACTIONS(244),
    [anon_sym_strictfp] = ACTIONS(244),
    [anon_sym_nocf_check] = ACTIONS(244),
    [anon_sym_shadowcallstack] = ACTIONS(244),
    [anon_sym_mustprogress] = ACTIONS(244),
    [anon_sym_vscale_range] = ACTIONS(244),
    [anon_sym_preallocated] = ACTIONS(244),
    [anon_sym_zeroext] = ACTIONS(244),
    [anon_sym_signext] = ACTIONS(244),
    [anon_sym_inreg] = ACTIONS(244),
    [anon_sym_byval] = ACTIONS(244),
    [anon_sym_byref] = ACTIONS(244),
    [anon_sym_inalloca] = ACTIONS(244),
    [anon_sym_sret] = ACTIONS(244),
    [anon_sym_elementtype] = ACTIONS(244),
    [anon_sym_noalias] = ACTIONS(244),
    [anon_sym_nocapture] = ACTIONS(244),
    [anon_sym_nest] = ACTIONS(244),
    [anon_sym_returned] = ACTIONS(244),
    [anon_sym_nonnull] = ACTIONS(244),
    [anon_sym_dereferenceable] = ACTIONS(246),
    [anon_sym_dereferenceable_or_null] = ACTIONS(244),
    [anon_sym_swiftself] = ACTIONS(246),
    [anon_sym_swiftasync] = ACTIONS(246),
    [anon_sym_swifterror] = ACTIONS(246),
    [anon_sym_immarg] = ACTIONS(244),
    [anon_sym_noundef] = ACTIONS(244),
    [anon_sym_uwtable] = ACTIONS(244),
    [anon_sym_memory] = ACTIONS(244),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
  },
  [8] = {
    [sym_addrspace] = STATE(1730),
    [sym_argument_list] = STATE(8),
    [aux_sym_type_repeat1] = STATE(1183),
    [aux_sym_type_repeat2] = STATE(8),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [aux_sym_metadata_ref_token1] = ACTIONS(250),
    [sym_string] = ACTIONS(250),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(250),
    [sym_float] = ACTIONS(250),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(250),
    [anon_sym_private] = ACTIONS(250),
    [anon_sym_internal] = ACTIONS(250),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(250),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(250),
    [anon_sym_available_externally] = ACTIONS(250),
    [anon_sym_appending] = ACTIONS(250),
    [anon_sym_common] = ACTIONS(250),
    [anon_sym_extern_weak] = ACTIONS(250),
    [anon_sym_external] = ACTIONS(250),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(250),
    [anon_sym_dso_preemptable] = ACTIONS(250),
    [anon_sym_default] = ACTIONS(250),
    [anon_sym_hidden] = ACTIONS(250),
    [anon_sym_protected] = ACTIONS(250),
    [anon_sym_dllimport] = ACTIONS(250),
    [anon_sym_dllexport] = ACTIONS(250),
    [anon_sym_ccc] = ACTIONS(250),
    [anon_sym_fastcc] = ACTIONS(250),
    [anon_sym_coldcc] = ACTIONS(250),
    [anon_sym_webkit_jscc] = ACTIONS(252),
    [anon_sym_anyregcc] = ACTIONS(250),
    [anon_sym_preserve_mostcc] = ACTIONS(250),
    [anon_sym_preserve_allcc] = ACTIONS(250),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(252),
    [anon_sym_tailcc] = ACTIONS(250),
    [anon_sym_swiftcc] = ACTIONS(252),
    [anon_sym_swifttailcc] = ACTIONS(252),
    [anon_sym_cfguard_checkcc] = ACTIONS(250),
    [aux_sym_calling_conv_token1] = ACTIONS(252),
    [aux_sym_calling_conv_token2] = ACTIONS(250),
    [aux_sym_calling_conv_token3] = ACTIONS(250),
    [aux_sym_calling_conv_token4] = ACTIONS(250),
    [aux_sym_calling_conv_token5] = ACTIONS(250),
    [aux_sym_calling_conv_token6] = ACTIONS(250),
    [aux_sym_calling_conv_token7] = ACTIONS(250),
    [aux_sym_calling_conv_token8] = ACTIONS(250),
    [aux_sym_calling_conv_token9] = ACTIONS(250),
    [aux_sym_calling_conv_token10] = ACTIONS(252),
    [anon_sym_ghccc] = ACTIONS(250),
    [aux_sym_calling_conv_token11] = ACTIONS(252),
    [aux_sym_calling_conv_token12] = ACTIONS(250),
    [aux_sym_calling_conv_token13] = ACTIONS(252),
    [aux_sym_calling_conv_token14] = ACTIONS(250),
    [anon_sym_cc] = ACTIONS(252),
    [anon_sym_unnamed_addr] = ACTIONS(250),
    [anon_sym_local_unnamed_addr] = ACTIONS(250),
    [anon_sym_STAR] = ACTIONS(254),
    [anon_sym_void] = ACTIONS(250),
    [anon_sym_half] = ACTIONS(250),
    [anon_sym_bfloat] = ACTIONS(250),
    [anon_sym_float] = ACTIONS(250),
    [anon_sym_double] = ACTIONS(250),
    [anon_sym_x86_fp80] = ACTIONS(252),
    [anon_sym_fp128] = ACTIONS(250),
    [anon_sym_ppc_fp128] = ACTIONS(250),
    [anon_sym_label] = ACTIONS(250),
    [anon_sym_metadata] = ACTIONS(250),
    [anon_sym_x86_mmx] = ACTIONS(252),
    [anon_sym_x86_amx] = ACTIONS(252),
    [anon_sym_token] = ACTIONS(250),
    [anon_sym_opaque] = ACTIONS(250),
    [anon_sym_ptr] = ACTIONS(252),
    [aux_sym_type_keyword_token1] = ACTIONS(250),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE_GT] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(257),
    [anon_sym_LPAREN] = ACTIONS(260),
    [anon_sym_align] = ACTIONS(252),
    [anon_sym_alignstack] = ACTIONS(250),
    [anon_sym_allocsize] = ACTIONS(250),
    [anon_sym_alwaysinline] = ACTIONS(250),
    [anon_sym_builtin] = ACTIONS(250),
    [anon_sym_cold] = ACTIONS(252),
    [anon_sym_convergent] = ACTIONS(250),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(250),
    [anon_sym_hot] = ACTIONS(250),
    [anon_sym_inaccessiblememonly] = ACTIONS(250),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(250),
    [anon_sym_inlinehint] = ACTIONS(250),
    [anon_sym_jumptable] = ACTIONS(250),
    [anon_sym_minsize] = ACTIONS(250),
    [anon_sym_naked] = ACTIONS(250),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(250),
    [anon_sym_nobuiltin] = ACTIONS(250),
    [anon_sym_noduplicate] = ACTIONS(250),
    [anon_sym_nofree] = ACTIONS(250),
    [anon_sym_noimplicitfloat] = ACTIONS(250),
    [anon_sym_noinline] = ACTIONS(250),
    [anon_sym_nomerge] = ACTIONS(250),
    [anon_sym_nonlazybind] = ACTIONS(250),
    [anon_sym_noprofile] = ACTIONS(250),
    [anon_sym_noredzone] = ACTIONS(250),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(250),
    [anon_sym_noreturn] = ACTIONS(250),
    [anon_sym_norecurse] = ACTIONS(250),
    [anon_sym_willreturn] = ACTIONS(250),
    [anon_sym_nosync] = ACTIONS(250),
    [anon_sym_nounwind] = ACTIONS(250),
    [anon_sym_nocallback] = ACTIONS(250),
    [anon_sym_nosanitize_coverage] = ACTIONS(250),
    [anon_sym_null_pointer_is_valid] = ACTIONS(250),
    [anon_sym_optforfuzzing] = ACTIONS(250),
    [anon_sym_optnone] = ACTIONS(250),
    [anon_sym_optsize] = ACTIONS(250),
    [anon_sym_readnone] = ACTIONS(250),
    [anon_sym_readonly] = ACTIONS(250),
    [anon_sym_writeonly] = ACTIONS(250),
    [anon_sym_argmemonly] = ACTIONS(250),
    [anon_sym_returns_twice] = ACTIONS(250),
    [anon_sym_safestack] = ACTIONS(250),
    [anon_sym_sanitize_address] = ACTIONS(250),
    [anon_sym_sanitize_memory] = ACTIONS(250),
    [anon_sym_sanitize_thread] = ACTIONS(250),
    [anon_sym_sanitize_hwaddress] = ACTIONS(250),
    [anon_sym_sanitize_memtag] = ACTIONS(250),
    [anon_sym_speculative_load_hardening] = ACTIONS(250),
    [anon_sym_speculatable] = ACTIONS(250),
    [anon_sym_ssp] = ACTIONS(252),
    [anon_sym_sspstrong] = ACTIONS(250),
    [anon_sym_sspreq] = ACTIONS(250),
    [anon_sym_strictfp] = ACTIONS(250),
    [anon_sym_nocf_check] = ACTIONS(250),
    [anon_sym_shadowcallstack] = ACTIONS(250),
    [anon_sym_mustprogress] = ACTIONS(250),
    [anon_sym_vscale_range] = ACTIONS(250),
    [anon_sym_preallocated] = ACTIONS(250),
    [anon_sym_zeroext] = ACTIONS(250),
    [anon_sym_signext] = ACTIONS(250),
    [anon_sym_inreg] = ACTIONS(250),
    [anon_sym_byval] = ACTIONS(250),
    [anon_sym_byref] = ACTIONS(250),
    [anon_sym_inalloca] = ACTIONS(250),
    [anon_sym_sret] = ACTIONS(250),
    [anon_sym_elementtype] = ACTIONS(250),
    [anon_sym_noalias] = ACTIONS(250),
    [anon_sym_nocapture] = ACTIONS(250),
    [anon_sym_nest] = ACTIONS(250),
    [anon_sym_returned] = ACTIONS(250),
    [anon_sym_nonnull] = ACTIONS(250),
    [anon_sym_dereferenceable] = ACTIONS(252),
    [anon_sym_dereferenceable_or_null] = ACTIONS(250),
    [anon_sym_swiftself] = ACTIONS(252),
    [anon_sym_swiftasync] = ACTIONS(252),
    [anon_sym_swifterror] = ACTIONS(252),
    [anon_sym_immarg] = ACTIONS(250),
    [anon_sym_noundef] = ACTIONS(250),
    [anon_sym_uwtable] = ACTIONS(250),
    [anon_sym_memory] = ACTIONS(250),
    [anon_sym_none] = ACTIONS(250),
    [anon_sym_extractelement] = ACTIONS(250),
    [anon_sym_insertelement] = ACTIONS(250),
    [anon_sym_select] = ACTIONS(250),
    [anon_sym_shufflevector] = ACTIONS(250),
    [anon_sym_fneg] = ACTIONS(250),
    [anon_sym_icmp] = ACTIONS(250),
    [anon_sym_fcmp] = ACTIONS(250),
    [anon_sym_getelementptr] = ACTIONS(250),
    [anon_sym_extractvalue] = ACTIONS(250),
    [anon_sym_insertvalue] = ACTIONS(250),
    [anon_sym_true] = ACTIONS(250),
    [anon_sym_false] = ACTIONS(250),
    [anon_sym_null] = ACTIONS(252),
    [anon_sym_undef] = ACTIONS(250),
    [anon_sym_poison] = ACTIONS(250),
    [anon_sym_zeroinitializer] = ACTIONS(250),
    [anon_sym_blockaddress] = ACTIONS(250),
    [anon_sym_mul] = ACTIONS(250),
    [anon_sym_urem] = ACTIONS(250),
    [anon_sym_srem] = ACTIONS(250),
    [anon_sym_shl] = ACTIONS(250),
    [anon_sym_udiv] = ACTIONS(250),
    [anon_sym_sdiv] = ACTIONS(250),
    [anon_sym_lshr] = ACTIONS(250),
    [anon_sym_ashr] = ACTIONS(250),
    [anon_sym_fmul] = ACTIONS(250),
    [anon_sym_fdiv] = ACTIONS(250),
    [anon_sym_frem] = ACTIONS(250),
    [anon_sym_xchg] = ACTIONS(250),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(250),
    [anon_sym_and] = ACTIONS(250),
    [anon_sym_nand] = ACTIONS(250),
    [anon_sym_or] = ACTIONS(250),
    [anon_sym_xor] = ACTIONS(250),
    [anon_sym_max] = ACTIONS(250),
    [anon_sym_min] = ACTIONS(252),
    [anon_sym_umax] = ACTIONS(250),
    [anon_sym_umin] = ACTIONS(250),
    [anon_sym_fadd] = ACTIONS(250),
    [anon_sym_fsub] = ACTIONS(250),
    [anon_sym_bitcast] = ACTIONS(250),
    [anon_sym_trunc] = ACTIONS(250),
    [anon_sym_zext] = ACTIONS(250),
    [anon_sym_sext] = ACTIONS(250),
    [anon_sym_fptrunc] = ACTIONS(250),
    [anon_sym_fpext] = ACTIONS(250),
    [anon_sym_addrspacecast] = ACTIONS(250),
    [anon_sym_uitofp] = ACTIONS(250),
    [anon_sym_sitofp] = ACTIONS(250),
    [anon_sym_fptoui] = ACTIONS(250),
    [anon_sym_fptosi] = ACTIONS(250),
    [anon_sym_inttoptr] = ACTIONS(250),
    [anon_sym_ptrtoint] = ACTIONS(250),
  },
  [9] = {
    [sym_addrspace] = STATE(27),
    [sym_argument_list] = STATE(16),
    [aux_sym_type_repeat1] = STATE(11),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [aux_sym_metadata_ref_token1] = ACTIONS(263),
    [sym_string] = ACTIONS(263),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(263),
    [sym_float] = ACTIONS(263),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(263),
    [anon_sym_private] = ACTIONS(263),
    [anon_sym_internal] = ACTIONS(263),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(263),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(263),
    [anon_sym_available_externally] = ACTIONS(263),
    [anon_sym_appending] = ACTIONS(263),
    [anon_sym_common] = ACTIONS(263),
    [anon_sym_extern_weak] = ACTIONS(263),
    [anon_sym_external] = ACTIONS(263),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(263),
    [anon_sym_dso_preemptable] = ACTIONS(263),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_hidden] = ACTIONS(263),
    [anon_sym_protected] = ACTIONS(263),
    [anon_sym_dllimport] = ACTIONS(263),
    [anon_sym_dllexport] = ACTIONS(263),
    [anon_sym_ccc] = ACTIONS(263),
    [anon_sym_fastcc] = ACTIONS(263),
    [anon_sym_coldcc] = ACTIONS(263),
    [anon_sym_webkit_jscc] = ACTIONS(265),
    [anon_sym_anyregcc] = ACTIONS(263),
    [anon_sym_preserve_mostcc] = ACTIONS(263),
    [anon_sym_preserve_allcc] = ACTIONS(263),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(265),
    [anon_sym_tailcc] = ACTIONS(263),
    [anon_sym_swiftcc] = ACTIONS(265),
    [anon_sym_swifttailcc] = ACTIONS(265),
    [anon_sym_cfguard_checkcc] = ACTIONS(263),
    [aux_sym_calling_conv_token1] = ACTIONS(265),
    [aux_sym_calling_conv_token2] = ACTIONS(263),
    [aux_sym_calling_conv_token3] = ACTIONS(263),
    [aux_sym_calling_conv_token4] = ACTIONS(263),
    [aux_sym_calling_conv_token5] = ACTIONS(263),
    [aux_sym_calling_conv_token6] = ACTIONS(263),
    [aux_sym_calling_conv_token7] = ACTIONS(263),
    [aux_sym_calling_conv_token8] = ACTIONS(263),
    [aux_sym_calling_conv_token9] = ACTIONS(263),
    [aux_sym_calling_conv_token10] = ACTIONS(265),
    [anon_sym_ghccc] = ACTIONS(263),
    [aux_sym_calling_conv_token11] = ACTIONS(265),
    [aux_sym_calling_conv_token12] = ACTIONS(263),
    [aux_sym_calling_conv_token13] = ACTIONS(265),
    [aux_sym_calling_conv_token14] = ACTIONS(263),
    [anon_sym_cc] = ACTIONS(265),
    [anon_sym_unnamed_addr] = ACTIONS(263),
    [anon_sym_local_unnamed_addr] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(267),
    [anon_sym_void] = ACTIONS(263),
    [anon_sym_half] = ACTIONS(263),
    [anon_sym_bfloat] = ACTIONS(263),
    [anon_sym_float] = ACTIONS(263),
    [anon_sym_double] = ACTIONS(263),
    [anon_sym_x86_fp80] = ACTIONS(265),
    [anon_sym_fp128] = ACTIONS(263),
    [anon_sym_ppc_fp128] = ACTIONS(263),
    [anon_sym_label] = ACTIONS(263),
    [anon_sym_metadata] = ACTIONS(263),
    [anon_sym_x86_mmx] = ACTIONS(265),
    [anon_sym_x86_amx] = ACTIONS(265),
    [anon_sym_token] = ACTIONS(263),
    [anon_sym_opaque] = ACTIONS(263),
    [anon_sym_ptr] = ACTIONS(265),
    [aux_sym_type_keyword_token1] = ACTIONS(263),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE_GT] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_addrspace] = ACTIONS(240),
    [anon_sym_LPAREN] = ACTIONS(242),
    [anon_sym_align] = ACTIONS(265),
    [anon_sym_alignstack] = ACTIONS(263),
    [anon_sym_allocsize] = ACTIONS(263),
    [anon_sym_alwaysinline] = ACTIONS(263),
    [anon_sym_builtin] = ACTIONS(263),
    [anon_sym_cold] = ACTIONS(265),
    [anon_sym_convergent] = ACTIONS(263),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(263),
    [anon_sym_hot] = ACTIONS(263),
    [anon_sym_inaccessiblememonly] = ACTIONS(263),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(263),
    [anon_sym_inlinehint] = ACTIONS(263),
    [anon_sym_jumptable] = ACTIONS(263),
    [anon_sym_minsize] = ACTIONS(263),
    [anon_sym_naked] = ACTIONS(263),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(263),
    [anon_sym_nobuiltin] = ACTIONS(263),
    [anon_sym_noduplicate] = ACTIONS(263),
    [anon_sym_nofree] = ACTIONS(263),
    [anon_sym_noimplicitfloat] = ACTIONS(263),
    [anon_sym_noinline] = ACTIONS(263),
    [anon_sym_nomerge] = ACTIONS(263),
    [anon_sym_nonlazybind] = ACTIONS(263),
    [anon_sym_noprofile] = ACTIONS(263),
    [anon_sym_noredzone] = ACTIONS(263),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(263),
    [anon_sym_noreturn] = ACTIONS(263),
    [anon_sym_norecurse] = ACTIONS(263),
    [anon_sym_willreturn] = ACTIONS(263),
    [anon_sym_nosync] = ACTIONS(263),
    [anon_sym_nounwind] = ACTIONS(263),
    [anon_sym_nocallback] = ACTIONS(263),
    [anon_sym_nosanitize_coverage] = ACTIONS(263),
    [anon_sym_null_pointer_is_valid] = ACTIONS(263),
    [anon_sym_optforfuzzing] = ACTIONS(263),
    [anon_sym_optnone] = ACTIONS(263),
    [anon_sym_optsize] = ACTIONS(263),
    [anon_sym_readnone] = ACTIONS(263),
    [anon_sym_readonly] = ACTIONS(263),
    [anon_sym_writeonly] = ACTIONS(263),
    [anon_sym_argmemonly] = ACTIONS(263),
    [anon_sym_returns_twice] = ACTIONS(263),
    [anon_sym_safestack] = ACTIONS(263),
    [anon_sym_sanitize_address] = ACTIONS(263),
    [anon_sym_sanitize_memory] = ACTIONS(263),
    [anon_sym_sanitize_thread] = ACTIONS(263),
    [anon_sym_sanitize_hwaddress] = ACTIONS(263),
    [anon_sym_sanitize_memtag] = ACTIONS(263),
    [anon_sym_speculative_load_hardening] = ACTIONS(263),
    [anon_sym_speculatable] = ACTIONS(263),
    [anon_sym_ssp] = ACTIONS(265),
    [anon_sym_sspstrong] = ACTIONS(263),
    [anon_sym_sspreq] = ACTIONS(263),
    [anon_sym_strictfp] = ACTIONS(263),
    [anon_sym_nocf_check] = ACTIONS(263),
    [anon_sym_shadowcallstack] = ACTIONS(263),
    [anon_sym_mustprogress] = ACTIONS(263),
    [anon_sym_vscale_range] = ACTIONS(263),
    [anon_sym_preallocated] = ACTIONS(263),
    [anon_sym_zeroext] = ACTIONS(263),
    [anon_sym_signext] = ACTIONS(263),
    [anon_sym_inreg] = ACTIONS(263),
    [anon_sym_byval] = ACTIONS(263),
    [anon_sym_byref] = ACTIONS(263),
    [anon_sym_inalloca] = ACTIONS(263),
    [anon_sym_sret] = ACTIONS(263),
    [anon_sym_elementtype] = ACTIONS(263),
    [anon_sym_noalias] = ACTIONS(263),
    [anon_sym_nocapture] = ACTIONS(263),
    [anon_sym_nest] = ACTIONS(263),
    [anon_sym_returned] = ACTIONS(263),
    [anon_sym_nonnull] = ACTIONS(263),
    [anon_sym_dereferenceable] = ACTIONS(265),
    [anon_sym_dereferenceable_or_null] = ACTIONS(263),
    [anon_sym_swiftself] = ACTIONS(265),
    [anon_sym_swiftasync] = ACTIONS(265),
    [anon_sym_swifterror] = ACTIONS(265),
    [anon_sym_immarg] = ACTIONS(263),
    [anon_sym_noundef] = ACTIONS(263),
    [anon_sym_uwtable] = ACTIONS(263),
    [anon_sym_memory] = ACTIONS(263),
    [anon_sym_none] = ACTIONS(263),
    [anon_sym_extractelement] = ACTIONS(263),
    [anon_sym_insertelement] = ACTIONS(263),
    [anon_sym_select] = ACTIONS(263),
    [anon_sym_shufflevector] = ACTIONS(263),
    [anon_sym_fneg] = ACTIONS(263),
    [anon_sym_icmp] = ACTIONS(263),
    [anon_sym_fcmp] = ACTIONS(263),
    [anon_sym_getelementptr] = ACTIONS(263),
    [anon_sym_extractvalue] = ACTIONS(263),
    [anon_sym_insertvalue] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(263),
    [anon_sym_false] = ACTIONS(263),
    [anon_sym_null] = ACTIONS(265),
    [anon_sym_undef] = ACTIONS(263),
    [anon_sym_poison] = ACTIONS(263),
    [anon_sym_zeroinitializer] = ACTIONS(263),
    [anon_sym_blockaddress] = ACTIONS(263),
    [anon_sym_mul] = ACTIONS(263),
    [anon_sym_urem] = ACTIONS(263),
    [anon_sym_srem] = ACTIONS(263),
    [anon_sym_shl] = ACTIONS(263),
    [anon_sym_udiv] = ACTIONS(263),
    [anon_sym_sdiv] = ACTIONS(263),
    [anon_sym_lshr] = ACTIONS(263),
    [anon_sym_ashr] = ACTIONS(263),
    [anon_sym_fmul] = ACTIONS(263),
    [anon_sym_fdiv] = ACTIONS(263),
    [anon_sym_frem] = ACTIONS(263),
    [anon_sym_xchg] = ACTIONS(263),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(263),
    [anon_sym_and] = ACTIONS(263),
    [anon_sym_nand] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(263),
    [anon_sym_xor] = ACTIONS(263),
    [anon_sym_max] = ACTIONS(263),
    [anon_sym_min] = ACTIONS(265),
    [anon_sym_umax] = ACTIONS(263),
    [anon_sym_umin] = ACTIONS(263),
    [anon_sym_fadd] = ACTIONS(263),
    [anon_sym_fsub] = ACTIONS(263),
    [anon_sym_bitcast] = ACTIONS(263),
    [anon_sym_trunc] = ACTIONS(263),
    [anon_sym_zext] = ACTIONS(263),
    [anon_sym_sext] = ACTIONS(263),
    [anon_sym_fptrunc] = ACTIONS(263),
    [anon_sym_fpext] = ACTIONS(263),
    [anon_sym_addrspacecast] = ACTIONS(263),
    [anon_sym_uitofp] = ACTIONS(263),
    [anon_sym_sitofp] = ACTIONS(263),
    [anon_sym_fptoui] = ACTIONS(263),
    [anon_sym_fptosi] = ACTIONS(263),
    [anon_sym_inttoptr] = ACTIONS(263),
    [anon_sym_ptrtoint] = ACTIONS(263),
  },
  [10] = {
    [sym_addrspace] = STATE(28),
    [sym_argument_list] = STATE(16),
    [aux_sym_type_repeat1] = STATE(11),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [aux_sym_metadata_ref_token1] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_ccc] = ACTIONS(244),
    [anon_sym_fastcc] = ACTIONS(244),
    [anon_sym_coldcc] = ACTIONS(244),
    [anon_sym_webkit_jscc] = ACTIONS(246),
    [anon_sym_anyregcc] = ACTIONS(244),
    [anon_sym_preserve_mostcc] = ACTIONS(244),
    [anon_sym_preserve_allcc] = ACTIONS(244),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(246),
    [anon_sym_tailcc] = ACTIONS(244),
    [anon_sym_swiftcc] = ACTIONS(246),
    [anon_sym_swifttailcc] = ACTIONS(246),
    [anon_sym_cfguard_checkcc] = ACTIONS(244),
    [aux_sym_calling_conv_token1] = ACTIONS(246),
    [aux_sym_calling_conv_token2] = ACTIONS(244),
    [aux_sym_calling_conv_token3] = ACTIONS(244),
    [aux_sym_calling_conv_token4] = ACTIONS(244),
    [aux_sym_calling_conv_token5] = ACTIONS(244),
    [aux_sym_calling_conv_token6] = ACTIONS(244),
    [aux_sym_calling_conv_token7] = ACTIONS(244),
    [aux_sym_calling_conv_token8] = ACTIONS(244),
    [aux_sym_calling_conv_token9] = ACTIONS(244),
    [aux_sym_calling_conv_token10] = ACTIONS(246),
    [anon_sym_ghccc] = ACTIONS(244),
    [aux_sym_calling_conv_token11] = ACTIONS(246),
    [aux_sym_calling_conv_token12] = ACTIONS(244),
    [aux_sym_calling_conv_token13] = ACTIONS(246),
    [aux_sym_calling_conv_token14] = ACTIONS(244),
    [anon_sym_cc] = ACTIONS(246),
    [anon_sym_unnamed_addr] = ACTIONS(244),
    [anon_sym_local_unnamed_addr] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(267),
    [anon_sym_void] = ACTIONS(244),
    [anon_sym_half] = ACTIONS(244),
    [anon_sym_bfloat] = ACTIONS(244),
    [anon_sym_float] = ACTIONS(244),
    [anon_sym_double] = ACTIONS(244),
    [anon_sym_x86_fp80] = ACTIONS(246),
    [anon_sym_fp128] = ACTIONS(244),
    [anon_sym_ppc_fp128] = ACTIONS(244),
    [anon_sym_label] = ACTIONS(244),
    [anon_sym_metadata] = ACTIONS(244),
    [anon_sym_x86_mmx] = ACTIONS(246),
    [anon_sym_x86_amx] = ACTIONS(246),
    [anon_sym_token] = ACTIONS(244),
    [anon_sym_opaque] = ACTIONS(244),
    [anon_sym_ptr] = ACTIONS(246),
    [aux_sym_type_keyword_token1] = ACTIONS(244),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE_GT] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(240),
    [anon_sym_LPAREN] = ACTIONS(242),
    [anon_sym_align] = ACTIONS(246),
    [anon_sym_alignstack] = ACTIONS(244),
    [anon_sym_allocsize] = ACTIONS(244),
    [anon_sym_alwaysinline] = ACTIONS(244),
    [anon_sym_builtin] = ACTIONS(244),
    [anon_sym_cold] = ACTIONS(246),
    [anon_sym_convergent] = ACTIONS(244),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(244),
    [anon_sym_hot] = ACTIONS(244),
    [anon_sym_inaccessiblememonly] = ACTIONS(244),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(244),
    [anon_sym_inlinehint] = ACTIONS(244),
    [anon_sym_jumptable] = ACTIONS(244),
    [anon_sym_minsize] = ACTIONS(244),
    [anon_sym_naked] = ACTIONS(244),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(244),
    [anon_sym_nobuiltin] = ACTIONS(244),
    [anon_sym_noduplicate] = ACTIONS(244),
    [anon_sym_nofree] = ACTIONS(244),
    [anon_sym_noimplicitfloat] = ACTIONS(244),
    [anon_sym_noinline] = ACTIONS(244),
    [anon_sym_nomerge] = ACTIONS(244),
    [anon_sym_nonlazybind] = ACTIONS(244),
    [anon_sym_noprofile] = ACTIONS(244),
    [anon_sym_noredzone] = ACTIONS(244),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(244),
    [anon_sym_noreturn] = ACTIONS(244),
    [anon_sym_norecurse] = ACTIONS(244),
    [anon_sym_willreturn] = ACTIONS(244),
    [anon_sym_nosync] = ACTIONS(244),
    [anon_sym_nounwind] = ACTIONS(244),
    [anon_sym_nocallback] = ACTIONS(244),
    [anon_sym_nosanitize_coverage] = ACTIONS(244),
    [anon_sym_null_pointer_is_valid] = ACTIONS(244),
    [anon_sym_optforfuzzing] = ACTIONS(244),
    [anon_sym_optnone] = ACTIONS(244),
    [anon_sym_optsize] = ACTIONS(244),
    [anon_sym_readnone] = ACTIONS(244),
    [anon_sym_readonly] = ACTIONS(244),
    [anon_sym_writeonly] = ACTIONS(244),
    [anon_sym_argmemonly] = ACTIONS(244),
    [anon_sym_returns_twice] = ACTIONS(244),
    [anon_sym_safestack] = ACTIONS(244),
    [anon_sym_sanitize_address] = ACTIONS(244),
    [anon_sym_sanitize_memory] = ACTIONS(244),
    [anon_sym_sanitize_thread] = ACTIONS(244),
    [anon_sym_sanitize_hwaddress] = ACTIONS(244),
    [anon_sym_sanitize_memtag] = ACTIONS(244),
    [anon_sym_speculative_load_hardening] = ACTIONS(244),
    [anon_sym_speculatable] = ACTIONS(244),
    [anon_sym_ssp] = ACTIONS(246),
    [anon_sym_sspstrong] = ACTIONS(244),
    [anon_sym_sspreq] = ACTIONS(244),
    [anon_sym_strictfp] = ACTIONS(244),
    [anon_sym_nocf_check] = ACTIONS(244),
    [anon_sym_shadowcallstack] = ACTIONS(244),
    [anon_sym_mustprogress] = ACTIONS(244),
    [anon_sym_vscale_range] = ACTIONS(244),
    [anon_sym_preallocated] = ACTIONS(244),
    [anon_sym_zeroext] = ACTIONS(244),
    [anon_sym_signext] = ACTIONS(244),
    [anon_sym_inreg] = ACTIONS(244),
    [anon_sym_byval] = ACTIONS(244),
    [anon_sym_byref] = ACTIONS(244),
    [anon_sym_inalloca] = ACTIONS(244),
    [anon_sym_sret] = ACTIONS(244),
    [anon_sym_elementtype] = ACTIONS(244),
    [anon_sym_noalias] = ACTIONS(244),
    [anon_sym_nocapture] = ACTIONS(244),
    [anon_sym_nest] = ACTIONS(244),
    [anon_sym_returned] = ACTIONS(244),
    [anon_sym_nonnull] = ACTIONS(244),
    [anon_sym_dereferenceable] = ACTIONS(246),
    [anon_sym_dereferenceable_or_null] = ACTIONS(244),
    [anon_sym_swiftself] = ACTIONS(246),
    [anon_sym_swiftasync] = ACTIONS(246),
    [anon_sym_swifterror] = ACTIONS(246),
    [anon_sym_immarg] = ACTIONS(244),
    [anon_sym_noundef] = ACTIONS(244),
    [anon_sym_uwtable] = ACTIONS(244),
    [anon_sym_memory] = ACTIONS(244),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
  },
  [11] = {
    [sym_addrspace] = STATE(1641),
    [aux_sym_type_repeat1] = STATE(11),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [aux_sym_metadata_ref_token1] = ACTIONS(269),
    [sym_string] = ACTIONS(269),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(269),
    [sym_float] = ACTIONS(269),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_internal] = ACTIONS(269),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(269),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(269),
    [anon_sym_available_externally] = ACTIONS(269),
    [anon_sym_appending] = ACTIONS(269),
    [anon_sym_common] = ACTIONS(269),
    [anon_sym_extern_weak] = ACTIONS(269),
    [anon_sym_external] = ACTIONS(269),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(269),
    [anon_sym_dso_preemptable] = ACTIONS(269),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_hidden] = ACTIONS(269),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_dllimport] = ACTIONS(269),
    [anon_sym_dllexport] = ACTIONS(269),
    [anon_sym_ccc] = ACTIONS(269),
    [anon_sym_fastcc] = ACTIONS(269),
    [anon_sym_coldcc] = ACTIONS(269),
    [anon_sym_webkit_jscc] = ACTIONS(271),
    [anon_sym_anyregcc] = ACTIONS(269),
    [anon_sym_preserve_mostcc] = ACTIONS(269),
    [anon_sym_preserve_allcc] = ACTIONS(269),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(271),
    [anon_sym_tailcc] = ACTIONS(269),
    [anon_sym_swiftcc] = ACTIONS(271),
    [anon_sym_swifttailcc] = ACTIONS(271),
    [anon_sym_cfguard_checkcc] = ACTIONS(269),
    [aux_sym_calling_conv_token1] = ACTIONS(271),
    [aux_sym_calling_conv_token2] = ACTIONS(269),
    [aux_sym_calling_conv_token3] = ACTIONS(269),
    [aux_sym_calling_conv_token4] = ACTIONS(269),
    [aux_sym_calling_conv_token5] = ACTIONS(269),
    [aux_sym_calling_conv_token6] = ACTIONS(269),
    [aux_sym_calling_conv_token7] = ACTIONS(269),
    [aux_sym_calling_conv_token8] = ACTIONS(269),
    [aux_sym_calling_conv_token9] = ACTIONS(269),
    [aux_sym_calling_conv_token10] = ACTIONS(271),
    [anon_sym_ghccc] = ACTIONS(269),
    [aux_sym_calling_conv_token11] = ACTIONS(271),
    [aux_sym_calling_conv_token12] = ACTIONS(269),
    [aux_sym_calling_conv_token13] = ACTIONS(271),
    [aux_sym_calling_conv_token14] = ACTIONS(269),
    [anon_sym_cc] = ACTIONS(271),
    [anon_sym_unnamed_addr] = ACTIONS(269),
    [anon_sym_local_unnamed_addr] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(269),
    [anon_sym_half] = ACTIONS(269),
    [anon_sym_bfloat] = ACTIONS(269),
    [anon_sym_float] = ACTIONS(269),
    [anon_sym_double] = ACTIONS(269),
    [anon_sym_x86_fp80] = ACTIONS(271),
    [anon_sym_fp128] = ACTIONS(269),
    [anon_sym_ppc_fp128] = ACTIONS(269),
    [anon_sym_label] = ACTIONS(269),
    [anon_sym_metadata] = ACTIONS(269),
    [anon_sym_x86_mmx] = ACTIONS(271),
    [anon_sym_x86_amx] = ACTIONS(271),
    [anon_sym_token] = ACTIONS(269),
    [anon_sym_opaque] = ACTIONS(269),
    [anon_sym_ptr] = ACTIONS(271),
    [aux_sym_type_keyword_token1] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE_GT] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_align] = ACTIONS(271),
    [anon_sym_alignstack] = ACTIONS(269),
    [anon_sym_allocsize] = ACTIONS(269),
    [anon_sym_alwaysinline] = ACTIONS(269),
    [anon_sym_builtin] = ACTIONS(269),
    [anon_sym_cold] = ACTIONS(271),
    [anon_sym_convergent] = ACTIONS(269),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(269),
    [anon_sym_hot] = ACTIONS(269),
    [anon_sym_inaccessiblememonly] = ACTIONS(269),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(269),
    [anon_sym_inlinehint] = ACTIONS(269),
    [anon_sym_jumptable] = ACTIONS(269),
    [anon_sym_minsize] = ACTIONS(269),
    [anon_sym_naked] = ACTIONS(269),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(269),
    [anon_sym_nobuiltin] = ACTIONS(269),
    [anon_sym_noduplicate] = ACTIONS(269),
    [anon_sym_nofree] = ACTIONS(269),
    [anon_sym_noimplicitfloat] = ACTIONS(269),
    [anon_sym_noinline] = ACTIONS(269),
    [anon_sym_nomerge] = ACTIONS(269),
    [anon_sym_nonlazybind] = ACTIONS(269),
    [anon_sym_noprofile] = ACTIONS(269),
    [anon_sym_noredzone] = ACTIONS(269),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(269),
    [anon_sym_noreturn] = ACTIONS(269),
    [anon_sym_norecurse] = ACTIONS(269),
    [anon_sym_willreturn] = ACTIONS(269),
    [anon_sym_nosync] = ACTIONS(269),
    [anon_sym_nounwind] = ACTIONS(269),
    [anon_sym_nocallback] = ACTIONS(269),
    [anon_sym_nosanitize_coverage] = ACTIONS(269),
    [anon_sym_null_pointer_is_valid] = ACTIONS(269),
    [anon_sym_optforfuzzing] = ACTIONS(269),
    [anon_sym_optnone] = ACTIONS(269),
    [anon_sym_optsize] = ACTIONS(269),
    [anon_sym_readnone] = ACTIONS(269),
    [anon_sym_readonly] = ACTIONS(269),
    [anon_sym_writeonly] = ACTIONS(269),
    [anon_sym_argmemonly] = ACTIONS(269),
    [anon_sym_returns_twice] = ACTIONS(269),
    [anon_sym_safestack] = ACTIONS(269),
    [anon_sym_sanitize_address] = ACTIONS(269),
    [anon_sym_sanitize_memory] = ACTIONS(269),
    [anon_sym_sanitize_thread] = ACTIONS(269),
    [anon_sym_sanitize_hwaddress] = ACTIONS(269),
    [anon_sym_sanitize_memtag] = ACTIONS(269),
    [anon_sym_speculative_load_hardening] = ACTIONS(269),
    [anon_sym_speculatable] = ACTIONS(269),
    [anon_sym_ssp] = ACTIONS(271),
    [anon_sym_sspstrong] = ACTIONS(269),
    [anon_sym_sspreq] = ACTIONS(269),
    [anon_sym_strictfp] = ACTIONS(269),
    [anon_sym_nocf_check] = ACTIONS(269),
    [anon_sym_shadowcallstack] = ACTIONS(269),
    [anon_sym_mustprogress] = ACTIONS(269),
    [anon_sym_vscale_range] = ACTIONS(269),
    [anon_sym_preallocated] = ACTIONS(269),
    [anon_sym_zeroext] = ACTIONS(269),
    [anon_sym_signext] = ACTIONS(269),
    [anon_sym_inreg] = ACTIONS(269),
    [anon_sym_byval] = ACTIONS(269),
    [anon_sym_byref] = ACTIONS(269),
    [anon_sym_inalloca] = ACTIONS(269),
    [anon_sym_sret] = ACTIONS(269),
    [anon_sym_elementtype] = ACTIONS(269),
    [anon_sym_noalias] = ACTIONS(269),
    [anon_sym_nocapture] = ACTIONS(269),
    [anon_sym_nest] = ACTIONS(269),
    [anon_sym_returned] = ACTIONS(269),
    [anon_sym_nonnull] = ACTIONS(269),
    [anon_sym_dereferenceable] = ACTIONS(271),
    [anon_sym_dereferenceable_or_null] = ACTIONS(269),
    [anon_sym_swiftself] = ACTIONS(271),
    [anon_sym_swiftasync] = ACTIONS(271),
    [anon_sym_swifterror] = ACTIONS(271),
    [anon_sym_immarg] = ACTIONS(269),
    [anon_sym_noundef] = ACTIONS(269),
    [anon_sym_uwtable] = ACTIONS(269),
    [anon_sym_memory] = ACTIONS(269),
    [anon_sym_none] = ACTIONS(269),
    [anon_sym_extractelement] = ACTIONS(269),
    [anon_sym_insertelement] = ACTIONS(269),
    [anon_sym_select] = ACTIONS(269),
    [anon_sym_shufflevector] = ACTIONS(269),
    [anon_sym_fneg] = ACTIONS(269),
    [anon_sym_icmp] = ACTIONS(269),
    [anon_sym_fcmp] = ACTIONS(269),
    [anon_sym_getelementptr] = ACTIONS(269),
    [anon_sym_extractvalue] = ACTIONS(269),
    [anon_sym_insertvalue] = ACTIONS(269),
    [anon_sym_true] = ACTIONS(269),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_null] = ACTIONS(271),
    [anon_sym_undef] = ACTIONS(269),
    [anon_sym_poison] = ACTIONS(269),
    [anon_sym_zeroinitializer] = ACTIONS(269),
    [anon_sym_blockaddress] = ACTIONS(269),
    [anon_sym_mul] = ACTIONS(269),
    [anon_sym_urem] = ACTIONS(269),
    [anon_sym_srem] = ACTIONS(269),
    [anon_sym_shl] = ACTIONS(269),
    [anon_sym_udiv] = ACTIONS(269),
    [anon_sym_sdiv] = ACTIONS(269),
    [anon_sym_lshr] = ACTIONS(269),
    [anon_sym_ashr] = ACTIONS(269),
    [anon_sym_fmul] = ACTIONS(269),
    [anon_sym_fdiv] = ACTIONS(269),
    [anon_sym_frem] = ACTIONS(269),
    [anon_sym_xchg] = ACTIONS(269),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(269),
    [anon_sym_and] = ACTIONS(269),
    [anon_sym_nand] = ACTIONS(269),
    [anon_sym_or] = ACTIONS(269),
    [anon_sym_xor] = ACTIONS(269),
    [anon_sym_max] = ACTIONS(269),
    [anon_sym_min] = ACTIONS(271),
    [anon_sym_umax] = ACTIONS(269),
    [anon_sym_umin] = ACTIONS(269),
    [anon_sym_fadd] = ACTIONS(269),
    [anon_sym_fsub] = ACTIONS(269),
    [anon_sym_bitcast] = ACTIONS(269),
    [anon_sym_trunc] = ACTIONS(269),
    [anon_sym_zext] = ACTIONS(269),
    [anon_sym_sext] = ACTIONS(269),
    [anon_sym_fptrunc] = ACTIONS(269),
    [anon_sym_fpext] = ACTIONS(269),
    [anon_sym_addrspacecast] = ACTIONS(269),
    [anon_sym_uitofp] = ACTIONS(269),
    [anon_sym_sitofp] = ACTIONS(269),
    [anon_sym_fptoui] = ACTIONS(269),
    [anon_sym_fptosi] = ACTIONS(269),
    [anon_sym_inttoptr] = ACTIONS(269),
    [anon_sym_ptrtoint] = ACTIONS(269),
  },
  [12] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(279),
    [sym_local_var] = ACTIONS(279),
    [aux_sym_metadata_ref_token1] = ACTIONS(279),
    [sym_string] = ACTIONS(279),
    [aux_sym_number_token1] = ACTIONS(281),
    [aux_sym_number_token2] = ACTIONS(279),
    [sym_float] = ACTIONS(279),
    [sym_cstring] = ACTIONS(279),
    [anon_sym_no_cfi] = ACTIONS(279),
    [anon_sym_private] = ACTIONS(279),
    [anon_sym_internal] = ACTIONS(279),
    [anon_sym_weak] = ACTIONS(281),
    [anon_sym_weak_odr] = ACTIONS(279),
    [anon_sym_linkonce] = ACTIONS(281),
    [anon_sym_linkonce_odr] = ACTIONS(279),
    [anon_sym_available_externally] = ACTIONS(279),
    [anon_sym_appending] = ACTIONS(279),
    [anon_sym_common] = ACTIONS(279),
    [anon_sym_extern_weak] = ACTIONS(279),
    [anon_sym_external] = ACTIONS(279),
    [anon_sym_dso_local] = ACTIONS(281),
    [anon_sym_dso_local_equivalent] = ACTIONS(279),
    [anon_sym_dso_preemptable] = ACTIONS(279),
    [anon_sym_default] = ACTIONS(279),
    [anon_sym_hidden] = ACTIONS(279),
    [anon_sym_protected] = ACTIONS(279),
    [anon_sym_dllimport] = ACTIONS(279),
    [anon_sym_dllexport] = ACTIONS(279),
    [anon_sym_ccc] = ACTIONS(279),
    [anon_sym_fastcc] = ACTIONS(279),
    [anon_sym_coldcc] = ACTIONS(279),
    [anon_sym_webkit_jscc] = ACTIONS(281),
    [anon_sym_anyregcc] = ACTIONS(279),
    [anon_sym_preserve_mostcc] = ACTIONS(279),
    [anon_sym_preserve_allcc] = ACTIONS(279),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(281),
    [anon_sym_tailcc] = ACTIONS(279),
    [anon_sym_swiftcc] = ACTIONS(281),
    [anon_sym_swifttailcc] = ACTIONS(281),
    [anon_sym_cfguard_checkcc] = ACTIONS(279),
    [aux_sym_calling_conv_token1] = ACTIONS(281),
    [aux_sym_calling_conv_token2] = ACTIONS(279),
    [aux_sym_calling_conv_token3] = ACTIONS(279),
    [aux_sym_calling_conv_token4] = ACTIONS(279),
    [aux_sym_calling_conv_token5] = ACTIONS(279),
    [aux_sym_calling_conv_token6] = ACTIONS(279),
    [aux_sym_calling_conv_token7] = ACTIONS(279),
    [aux_sym_calling_conv_token8] = ACTIONS(279),
    [aux_sym_calling_conv_token9] = ACTIONS(279),
    [aux_sym_calling_conv_token10] = ACTIONS(281),
    [anon_sym_ghccc] = ACTIONS(279),
    [aux_sym_calling_conv_token11] = ACTIONS(281),
    [aux_sym_calling_conv_token12] = ACTIONS(279),
    [aux_sym_calling_conv_token13] = ACTIONS(281),
    [aux_sym_calling_conv_token14] = ACTIONS(279),
    [anon_sym_cc] = ACTIONS(281),
    [anon_sym_unnamed_addr] = ACTIONS(279),
    [anon_sym_local_unnamed_addr] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(279),
    [anon_sym_void] = ACTIONS(279),
    [anon_sym_half] = ACTIONS(279),
    [anon_sym_bfloat] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(279),
    [anon_sym_double] = ACTIONS(279),
    [anon_sym_x86_fp80] = ACTIONS(281),
    [anon_sym_fp128] = ACTIONS(279),
    [anon_sym_ppc_fp128] = ACTIONS(279),
    [anon_sym_label] = ACTIONS(279),
    [anon_sym_metadata] = ACTIONS(279),
    [anon_sym_x86_mmx] = ACTIONS(281),
    [anon_sym_x86_amx] = ACTIONS(281),
    [anon_sym_token] = ACTIONS(279),
    [anon_sym_opaque] = ACTIONS(279),
    [anon_sym_ptr] = ACTIONS(281),
    [aux_sym_type_keyword_token1] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(279),
    [anon_sym_LT_LBRACE] = ACTIONS(279),
    [anon_sym_RBRACE_GT] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(281),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_addrspace] = ACTIONS(281),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_align] = ACTIONS(281),
    [anon_sym_alignstack] = ACTIONS(279),
    [anon_sym_allocsize] = ACTIONS(279),
    [anon_sym_alwaysinline] = ACTIONS(279),
    [anon_sym_builtin] = ACTIONS(279),
    [anon_sym_cold] = ACTIONS(281),
    [anon_sym_convergent] = ACTIONS(279),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(279),
    [anon_sym_hot] = ACTIONS(279),
    [anon_sym_inaccessiblememonly] = ACTIONS(279),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(279),
    [anon_sym_inlinehint] = ACTIONS(279),
    [anon_sym_jumptable] = ACTIONS(279),
    [anon_sym_minsize] = ACTIONS(279),
    [anon_sym_naked] = ACTIONS(279),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(279),
    [anon_sym_nobuiltin] = ACTIONS(279),
    [anon_sym_noduplicate] = ACTIONS(279),
    [anon_sym_nofree] = ACTIONS(279),
    [anon_sym_noimplicitfloat] = ACTIONS(279),
    [anon_sym_noinline] = ACTIONS(279),
    [anon_sym_nomerge] = ACTIONS(279),
    [anon_sym_nonlazybind] = ACTIONS(279),
    [anon_sym_noprofile] = ACTIONS(279),
    [anon_sym_noredzone] = ACTIONS(279),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(279),
    [anon_sym_noreturn] = ACTIONS(279),
    [anon_sym_norecurse] = ACTIONS(279),
    [anon_sym_willreturn] = ACTIONS(279),
    [anon_sym_nosync] = ACTIONS(279),
    [anon_sym_nounwind] = ACTIONS(279),
    [anon_sym_nocallback] = ACTIONS(279),
    [anon_sym_nosanitize_coverage] = ACTIONS(279),
    [anon_sym_null_pointer_is_valid] = ACTIONS(279),
    [anon_sym_optforfuzzing] = ACTIONS(279),
    [anon_sym_optnone] = ACTIONS(279),
    [anon_sym_optsize] = ACTIONS(279),
    [anon_sym_readnone] = ACTIONS(279),
    [anon_sym_readonly] = ACTIONS(279),
    [anon_sym_writeonly] = ACTIONS(279),
    [anon_sym_argmemonly] = ACTIONS(279),
    [anon_sym_returns_twice] = ACTIONS(279),
    [anon_sym_safestack] = ACTIONS(279),
    [anon_sym_sanitize_address] = ACTIONS(279),
    [anon_sym_sanitize_memory] = ACTIONS(279),
    [anon_sym_sanitize_thread] = ACTIONS(279),
    [anon_sym_sanitize_hwaddress] = ACTIONS(279),
    [anon_sym_sanitize_memtag] = ACTIONS(279),
    [anon_sym_speculative_load_hardening] = ACTIONS(279),
    [anon_sym_speculatable] = ACTIONS(279),
    [anon_sym_ssp] = ACTIONS(281),
    [anon_sym_sspstrong] = ACTIONS(279),
    [anon_sym_sspreq] = ACTIONS(279),
    [anon_sym_strictfp] = ACTIONS(279),
    [anon_sym_nocf_check] = ACTIONS(279),
    [anon_sym_shadowcallstack] = ACTIONS(279),
    [anon_sym_mustprogress] = ACTIONS(279),
    [anon_sym_vscale_range] = ACTIONS(279),
    [anon_sym_preallocated] = ACTIONS(279),
    [anon_sym_zeroext] = ACTIONS(279),
    [anon_sym_signext] = ACTIONS(279),
    [anon_sym_inreg] = ACTIONS(279),
    [anon_sym_byval] = ACTIONS(279),
    [anon_sym_byref] = ACTIONS(279),
    [anon_sym_inalloca] = ACTIONS(279),
    [anon_sym_sret] = ACTIONS(279),
    [anon_sym_elementtype] = ACTIONS(279),
    [anon_sym_noalias] = ACTIONS(279),
    [anon_sym_nocapture] = ACTIONS(279),
    [anon_sym_nest] = ACTIONS(279),
    [anon_sym_returned] = ACTIONS(279),
    [anon_sym_nonnull] = ACTIONS(279),
    [anon_sym_dereferenceable] = ACTIONS(281),
    [anon_sym_dereferenceable_or_null] = ACTIONS(279),
    [anon_sym_swiftself] = ACTIONS(281),
    [anon_sym_swiftasync] = ACTIONS(281),
    [anon_sym_swifterror] = ACTIONS(281),
    [anon_sym_immarg] = ACTIONS(279),
    [anon_sym_noundef] = ACTIONS(279),
    [anon_sym_uwtable] = ACTIONS(279),
    [anon_sym_memory] = ACTIONS(279),
    [anon_sym_none] = ACTIONS(279),
    [anon_sym_extractelement] = ACTIONS(279),
    [anon_sym_insertelement] = ACTIONS(279),
    [anon_sym_select] = ACTIONS(279),
    [anon_sym_shufflevector] = ACTIONS(279),
    [anon_sym_fneg] = ACTIONS(279),
    [anon_sym_icmp] = ACTIONS(279),
    [anon_sym_fcmp] = ACTIONS(279),
    [anon_sym_getelementptr] = ACTIONS(279),
    [anon_sym_extractvalue] = ACTIONS(279),
    [anon_sym_insertvalue] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(279),
    [anon_sym_false] = ACTIONS(279),
    [anon_sym_null] = ACTIONS(281),
    [anon_sym_undef] = ACTIONS(279),
    [anon_sym_poison] = ACTIONS(279),
    [anon_sym_zeroinitializer] = ACTIONS(279),
    [anon_sym_blockaddress] = ACTIONS(279),
    [anon_sym_mul] = ACTIONS(279),
    [anon_sym_urem] = ACTIONS(279),
    [anon_sym_srem] = ACTIONS(279),
    [anon_sym_shl] = ACTIONS(279),
    [anon_sym_udiv] = ACTIONS(279),
    [anon_sym_sdiv] = ACTIONS(279),
    [anon_sym_lshr] = ACTIONS(279),
    [anon_sym_ashr] = ACTIONS(279),
    [anon_sym_fmul] = ACTIONS(279),
    [anon_sym_fdiv] = ACTIONS(279),
    [anon_sym_frem] = ACTIONS(279),
    [anon_sym_xchg] = ACTIONS(279),
    [anon_sym_add] = ACTIONS(281),
    [anon_sym_sub] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_nand] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_xor] = ACTIONS(279),
    [anon_sym_max] = ACTIONS(279),
    [anon_sym_min] = ACTIONS(281),
    [anon_sym_umax] = ACTIONS(279),
    [anon_sym_umin] = ACTIONS(279),
    [anon_sym_fadd] = ACTIONS(279),
    [anon_sym_fsub] = ACTIONS(279),
    [anon_sym_bitcast] = ACTIONS(279),
    [anon_sym_trunc] = ACTIONS(279),
    [anon_sym_zext] = ACTIONS(279),
    [anon_sym_sext] = ACTIONS(279),
    [anon_sym_fptrunc] = ACTIONS(279),
    [anon_sym_fpext] = ACTIONS(279),
    [anon_sym_addrspacecast] = ACTIONS(279),
    [anon_sym_uitofp] = ACTIONS(279),
    [anon_sym_sitofp] = ACTIONS(279),
    [anon_sym_fptoui] = ACTIONS(279),
    [anon_sym_fptosi] = ACTIONS(279),
    [anon_sym_inttoptr] = ACTIONS(279),
    [anon_sym_ptrtoint] = ACTIONS(279),
  },
  [13] = {
    [sym_metadata_ref] = STATE(302),
    [sym_type] = STATE(15),
    [sym_type_keyword] = STATE(62),
    [sym_struct_type] = STATE(62),
    [sym_packed_struct_type] = STATE(62),
    [sym_array_type] = STATE(62),
    [sym_vector_type] = STATE(62),
    [sym_type_and_value] = STATE(326),
    [sym_metadata] = STATE(339),
    [sym_metadata_tuple] = STATE(326),
    [sym_specialized_md] = STATE(326),
    [ts_builtin_sym_end] = ACTIONS(116),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(116),
    [sym_comdat_ref] = ACTIONS(116),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(283),
    [aux_sym_metadata_ref_token1] = ACTIONS(285),
    [sym_summary_ref] = ACTIONS(116),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_target] = ACTIONS(116),
    [anon_sym_source_filename] = ACTIONS(116),
    [anon_sym_declare] = ACTIONS(116),
    [anon_sym_define] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(287),
    [anon_sym_half] = ACTIONS(287),
    [anon_sym_bfloat] = ACTIONS(287),
    [anon_sym_float] = ACTIONS(287),
    [anon_sym_double] = ACTIONS(287),
    [anon_sym_x86_fp80] = ACTIONS(287),
    [anon_sym_fp128] = ACTIONS(287),
    [anon_sym_ppc_fp128] = ACTIONS(287),
    [anon_sym_label] = ACTIONS(287),
    [anon_sym_metadata] = ACTIONS(289),
    [anon_sym_x86_mmx] = ACTIONS(287),
    [anon_sym_x86_amx] = ACTIONS(287),
    [anon_sym_token] = ACTIONS(287),
    [anon_sym_opaque] = ACTIONS(287),
    [anon_sym_ptr] = ACTIONS(291),
    [aux_sym_type_keyword_token1] = ACTIONS(287),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_LT_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(299),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_align] = ACTIONS(122),
    [anon_sym_section] = ACTIONS(116),
    [anon_sym_partition] = ACTIONS(116),
    [anon_sym_comdat] = ACTIONS(116),
    [anon_sym_gc] = ACTIONS(116),
    [anon_sym_prefix] = ACTIONS(116),
    [anon_sym_prologue] = ACTIONS(116),
    [anon_sym_personality] = ACTIONS(116),
    [anon_sym_alignstack] = ACTIONS(116),
    [anon_sym_allocsize] = ACTIONS(116),
    [anon_sym_alwaysinline] = ACTIONS(116),
    [anon_sym_builtin] = ACTIONS(116),
    [anon_sym_cold] = ACTIONS(116),
    [anon_sym_convergent] = ACTIONS(116),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(116),
    [anon_sym_hot] = ACTIONS(116),
    [anon_sym_inaccessiblememonly] = ACTIONS(116),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(116),
    [anon_sym_inlinehint] = ACTIONS(116),
    [anon_sym_jumptable] = ACTIONS(116),
    [anon_sym_minsize] = ACTIONS(116),
    [anon_sym_naked] = ACTIONS(116),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(116),
    [anon_sym_nobuiltin] = ACTIONS(116),
    [anon_sym_noduplicate] = ACTIONS(116),
    [anon_sym_nofree] = ACTIONS(116),
    [anon_sym_noimplicitfloat] = ACTIONS(116),
    [anon_sym_noinline] = ACTIONS(116),
    [anon_sym_nomerge] = ACTIONS(116),
    [anon_sym_nonlazybind] = ACTIONS(116),
    [anon_sym_noprofile] = ACTIONS(116),
    [anon_sym_noredzone] = ACTIONS(116),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(116),
    [anon_sym_noreturn] = ACTIONS(116),
    [anon_sym_norecurse] = ACTIONS(116),
    [anon_sym_willreturn] = ACTIONS(116),
    [anon_sym_nosync] = ACTIONS(116),
    [anon_sym_nounwind] = ACTIONS(116),
    [anon_sym_nocallback] = ACTIONS(116),
    [anon_sym_nosanitize_coverage] = ACTIONS(116),
    [anon_sym_null_pointer_is_valid] = ACTIONS(116),
    [anon_sym_optforfuzzing] = ACTIONS(116),
    [anon_sym_optnone] = ACTIONS(116),
    [anon_sym_optsize] = ACTIONS(116),
    [anon_sym_readnone] = ACTIONS(116),
    [anon_sym_readonly] = ACTIONS(116),
    [anon_sym_writeonly] = ACTIONS(116),
    [anon_sym_argmemonly] = ACTIONS(116),
    [anon_sym_returns_twice] = ACTIONS(116),
    [anon_sym_safestack] = ACTIONS(116),
    [anon_sym_sanitize_address] = ACTIONS(116),
    [anon_sym_sanitize_memory] = ACTIONS(116),
    [anon_sym_sanitize_thread] = ACTIONS(116),
    [anon_sym_sanitize_hwaddress] = ACTIONS(116),
    [anon_sym_sanitize_memtag] = ACTIONS(116),
    [anon_sym_speculative_load_hardening] = ACTIONS(116),
    [anon_sym_speculatable] = ACTIONS(116),
    [anon_sym_ssp] = ACTIONS(122),
    [anon_sym_sspstrong] = ACTIONS(116),
    [anon_sym_sspreq] = ACTIONS(116),
    [anon_sym_strictfp] = ACTIONS(116),
    [anon_sym_nocf_check] = ACTIONS(116),
    [anon_sym_shadowcallstack] = ACTIONS(116),
    [anon_sym_mustprogress] = ACTIONS(116),
    [anon_sym_vscale_range] = ACTIONS(116),
    [anon_sym_preallocated] = ACTIONS(116),
    [anon_sym_zeroext] = ACTIONS(116),
    [anon_sym_signext] = ACTIONS(116),
    [anon_sym_inreg] = ACTIONS(116),
    [anon_sym_byval] = ACTIONS(116),
    [anon_sym_byref] = ACTIONS(116),
    [anon_sym_inalloca] = ACTIONS(116),
    [anon_sym_sret] = ACTIONS(116),
    [anon_sym_elementtype] = ACTIONS(116),
    [anon_sym_noalias] = ACTIONS(116),
    [anon_sym_nocapture] = ACTIONS(116),
    [anon_sym_nest] = ACTIONS(116),
    [anon_sym_returned] = ACTIONS(116),
    [anon_sym_nonnull] = ACTIONS(116),
    [anon_sym_dereferenceable] = ACTIONS(122),
    [anon_sym_dereferenceable_or_null] = ACTIONS(116),
    [anon_sym_swiftself] = ACTIONS(116),
    [anon_sym_swiftasync] = ACTIONS(116),
    [anon_sym_swifterror] = ACTIONS(116),
    [anon_sym_immarg] = ACTIONS(116),
    [anon_sym_noundef] = ACTIONS(116),
    [anon_sym_uwtable] = ACTIONS(116),
    [anon_sym_memory] = ACTIONS(116),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_uselistorder] = ACTIONS(122),
    [anon_sym_uselistorder_bb] = ACTIONS(116),
    [anon_sym_module] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(303),
    [anon_sym_attributes] = ACTIONS(116),
  },
  [14] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [aux_sym_metadata_ref_token1] = ACTIONS(269),
    [sym_string] = ACTIONS(269),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(269),
    [sym_float] = ACTIONS(269),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_internal] = ACTIONS(269),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(269),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(269),
    [anon_sym_available_externally] = ACTIONS(269),
    [anon_sym_appending] = ACTIONS(269),
    [anon_sym_common] = ACTIONS(269),
    [anon_sym_extern_weak] = ACTIONS(269),
    [anon_sym_external] = ACTIONS(269),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(269),
    [anon_sym_dso_preemptable] = ACTIONS(269),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_hidden] = ACTIONS(269),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_dllimport] = ACTIONS(269),
    [anon_sym_dllexport] = ACTIONS(269),
    [anon_sym_ccc] = ACTIONS(269),
    [anon_sym_fastcc] = ACTIONS(269),
    [anon_sym_coldcc] = ACTIONS(269),
    [anon_sym_webkit_jscc] = ACTIONS(271),
    [anon_sym_anyregcc] = ACTIONS(269),
    [anon_sym_preserve_mostcc] = ACTIONS(269),
    [anon_sym_preserve_allcc] = ACTIONS(269),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(271),
    [anon_sym_tailcc] = ACTIONS(269),
    [anon_sym_swiftcc] = ACTIONS(271),
    [anon_sym_swifttailcc] = ACTIONS(271),
    [anon_sym_cfguard_checkcc] = ACTIONS(269),
    [aux_sym_calling_conv_token1] = ACTIONS(271),
    [aux_sym_calling_conv_token2] = ACTIONS(269),
    [aux_sym_calling_conv_token3] = ACTIONS(269),
    [aux_sym_calling_conv_token4] = ACTIONS(269),
    [aux_sym_calling_conv_token5] = ACTIONS(269),
    [aux_sym_calling_conv_token6] = ACTIONS(269),
    [aux_sym_calling_conv_token7] = ACTIONS(269),
    [aux_sym_calling_conv_token8] = ACTIONS(269),
    [aux_sym_calling_conv_token9] = ACTIONS(269),
    [aux_sym_calling_conv_token10] = ACTIONS(271),
    [anon_sym_ghccc] = ACTIONS(269),
    [aux_sym_calling_conv_token11] = ACTIONS(271),
    [aux_sym_calling_conv_token12] = ACTIONS(269),
    [aux_sym_calling_conv_token13] = ACTIONS(271),
    [aux_sym_calling_conv_token14] = ACTIONS(269),
    [anon_sym_cc] = ACTIONS(271),
    [anon_sym_unnamed_addr] = ACTIONS(269),
    [anon_sym_local_unnamed_addr] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(269),
    [anon_sym_void] = ACTIONS(269),
    [anon_sym_half] = ACTIONS(269),
    [anon_sym_bfloat] = ACTIONS(269),
    [anon_sym_float] = ACTIONS(269),
    [anon_sym_double] = ACTIONS(269),
    [anon_sym_x86_fp80] = ACTIONS(271),
    [anon_sym_fp128] = ACTIONS(269),
    [anon_sym_ppc_fp128] = ACTIONS(269),
    [anon_sym_label] = ACTIONS(269),
    [anon_sym_metadata] = ACTIONS(269),
    [anon_sym_x86_mmx] = ACTIONS(271),
    [anon_sym_x86_amx] = ACTIONS(271),
    [anon_sym_token] = ACTIONS(269),
    [anon_sym_opaque] = ACTIONS(269),
    [anon_sym_ptr] = ACTIONS(271),
    [aux_sym_type_keyword_token1] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE_GT] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_align] = ACTIONS(271),
    [anon_sym_alignstack] = ACTIONS(269),
    [anon_sym_allocsize] = ACTIONS(269),
    [anon_sym_alwaysinline] = ACTIONS(269),
    [anon_sym_builtin] = ACTIONS(269),
    [anon_sym_cold] = ACTIONS(271),
    [anon_sym_convergent] = ACTIONS(269),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(269),
    [anon_sym_hot] = ACTIONS(269),
    [anon_sym_inaccessiblememonly] = ACTIONS(269),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(269),
    [anon_sym_inlinehint] = ACTIONS(269),
    [anon_sym_jumptable] = ACTIONS(269),
    [anon_sym_minsize] = ACTIONS(269),
    [anon_sym_naked] = ACTIONS(269),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(269),
    [anon_sym_nobuiltin] = ACTIONS(269),
    [anon_sym_noduplicate] = ACTIONS(269),
    [anon_sym_nofree] = ACTIONS(269),
    [anon_sym_noimplicitfloat] = ACTIONS(269),
    [anon_sym_noinline] = ACTIONS(269),
    [anon_sym_nomerge] = ACTIONS(269),
    [anon_sym_nonlazybind] = ACTIONS(269),
    [anon_sym_noprofile] = ACTIONS(269),
    [anon_sym_noredzone] = ACTIONS(269),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(269),
    [anon_sym_noreturn] = ACTIONS(269),
    [anon_sym_norecurse] = ACTIONS(269),
    [anon_sym_willreturn] = ACTIONS(269),
    [anon_sym_nosync] = ACTIONS(269),
    [anon_sym_nounwind] = ACTIONS(269),
    [anon_sym_nocallback] = ACTIONS(269),
    [anon_sym_nosanitize_coverage] = ACTIONS(269),
    [anon_sym_null_pointer_is_valid] = ACTIONS(269),
    [anon_sym_optforfuzzing] = ACTIONS(269),
    [anon_sym_optnone] = ACTIONS(269),
    [anon_sym_optsize] = ACTIONS(269),
    [anon_sym_readnone] = ACTIONS(269),
    [anon_sym_readonly] = ACTIONS(269),
    [anon_sym_writeonly] = ACTIONS(269),
    [anon_sym_argmemonly] = ACTIONS(269),
    [anon_sym_returns_twice] = ACTIONS(269),
    [anon_sym_safestack] = ACTIONS(269),
    [anon_sym_sanitize_address] = ACTIONS(269),
    [anon_sym_sanitize_memory] = ACTIONS(269),
    [anon_sym_sanitize_thread] = ACTIONS(269),
    [anon_sym_sanitize_hwaddress] = ACTIONS(269),
    [anon_sym_sanitize_memtag] = ACTIONS(269),
    [anon_sym_speculative_load_hardening] = ACTIONS(269),
    [anon_sym_speculatable] = ACTIONS(269),
    [anon_sym_ssp] = ACTIONS(271),
    [anon_sym_sspstrong] = ACTIONS(269),
    [anon_sym_sspreq] = ACTIONS(269),
    [anon_sym_strictfp] = ACTIONS(269),
    [anon_sym_nocf_check] = ACTIONS(269),
    [anon_sym_shadowcallstack] = ACTIONS(269),
    [anon_sym_mustprogress] = ACTIONS(269),
    [anon_sym_vscale_range] = ACTIONS(269),
    [anon_sym_preallocated] = ACTIONS(269),
    [anon_sym_zeroext] = ACTIONS(269),
    [anon_sym_signext] = ACTIONS(269),
    [anon_sym_inreg] = ACTIONS(269),
    [anon_sym_byval] = ACTIONS(269),
    [anon_sym_byref] = ACTIONS(269),
    [anon_sym_inalloca] = ACTIONS(269),
    [anon_sym_sret] = ACTIONS(269),
    [anon_sym_elementtype] = ACTIONS(269),
    [anon_sym_noalias] = ACTIONS(269),
    [anon_sym_nocapture] = ACTIONS(269),
    [anon_sym_nest] = ACTIONS(269),
    [anon_sym_returned] = ACTIONS(269),
    [anon_sym_nonnull] = ACTIONS(269),
    [anon_sym_dereferenceable] = ACTIONS(271),
    [anon_sym_dereferenceable_or_null] = ACTIONS(269),
    [anon_sym_swiftself] = ACTIONS(271),
    [anon_sym_swiftasync] = ACTIONS(271),
    [anon_sym_swifterror] = ACTIONS(271),
    [anon_sym_immarg] = ACTIONS(269),
    [anon_sym_noundef] = ACTIONS(269),
    [anon_sym_uwtable] = ACTIONS(269),
    [anon_sym_memory] = ACTIONS(269),
    [anon_sym_none] = ACTIONS(269),
    [anon_sym_extractelement] = ACTIONS(269),
    [anon_sym_insertelement] = ACTIONS(269),
    [anon_sym_select] = ACTIONS(269),
    [anon_sym_shufflevector] = ACTIONS(269),
    [anon_sym_fneg] = ACTIONS(269),
    [anon_sym_icmp] = ACTIONS(269),
    [anon_sym_fcmp] = ACTIONS(269),
    [anon_sym_getelementptr] = ACTIONS(269),
    [anon_sym_extractvalue] = ACTIONS(269),
    [anon_sym_insertvalue] = ACTIONS(269),
    [anon_sym_true] = ACTIONS(269),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_null] = ACTIONS(271),
    [anon_sym_undef] = ACTIONS(269),
    [anon_sym_poison] = ACTIONS(269),
    [anon_sym_zeroinitializer] = ACTIONS(269),
    [anon_sym_blockaddress] = ACTIONS(269),
    [anon_sym_mul] = ACTIONS(269),
    [anon_sym_urem] = ACTIONS(269),
    [anon_sym_srem] = ACTIONS(269),
    [anon_sym_shl] = ACTIONS(269),
    [anon_sym_udiv] = ACTIONS(269),
    [anon_sym_sdiv] = ACTIONS(269),
    [anon_sym_lshr] = ACTIONS(269),
    [anon_sym_ashr] = ACTIONS(269),
    [anon_sym_fmul] = ACTIONS(269),
    [anon_sym_fdiv] = ACTIONS(269),
    [anon_sym_frem] = ACTIONS(269),
    [anon_sym_xchg] = ACTIONS(269),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(269),
    [anon_sym_and] = ACTIONS(269),
    [anon_sym_nand] = ACTIONS(269),
    [anon_sym_or] = ACTIONS(269),
    [anon_sym_xor] = ACTIONS(269),
    [anon_sym_max] = ACTIONS(269),
    [anon_sym_min] = ACTIONS(271),
    [anon_sym_umax] = ACTIONS(269),
    [anon_sym_umin] = ACTIONS(269),
    [anon_sym_fadd] = ACTIONS(269),
    [anon_sym_fsub] = ACTIONS(269),
    [anon_sym_bitcast] = ACTIONS(269),
    [anon_sym_trunc] = ACTIONS(269),
    [anon_sym_zext] = ACTIONS(269),
    [anon_sym_sext] = ACTIONS(269),
    [anon_sym_fptrunc] = ACTIONS(269),
    [anon_sym_fpext] = ACTIONS(269),
    [anon_sym_addrspacecast] = ACTIONS(269),
    [anon_sym_uitofp] = ACTIONS(269),
    [anon_sym_sitofp] = ACTIONS(269),
    [anon_sym_fptoui] = ACTIONS(269),
    [anon_sym_fptosi] = ACTIONS(269),
    [anon_sym_inttoptr] = ACTIONS(269),
    [anon_sym_ptrtoint] = ACTIONS(269),
  },
  [15] = {
    [sym_number] = STATE(361),
    [sym_var] = STATE(361),
    [sym_linkage] = STATE(820),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(360),
    [sym__primitive_value] = STATE(361),
    [sym_struct_value] = STATE(361),
    [sym_packed_struct_value] = STATE(361),
    [sym_array_value] = STATE(361),
    [sym_vector_value] = STATE(361),
    [sym_blockaddress] = STATE(361),
    [sym_constant_expr] = STATE(361),
    [sym_constant_cast] = STATE(359),
    [sym_constant_getelementptr] = STATE(359),
    [sym_constant_select] = STATE(359),
    [sym_constant_icmp] = STATE(359),
    [sym_constant_fcmp] = STATE(359),
    [sym_constant_extractelement] = STATE(359),
    [sym_constant_insertelement] = STATE(359),
    [sym_constant_shufflevector] = STATE(359),
    [sym_constant_extractvalue] = STATE(359),
    [sym_constant_insertvalue] = STATE(359),
    [sym_constant_fneg] = STATE(359),
    [sym_constant_bin_op] = STATE(359),
    [sym_bin_op_keyword] = STATE(1133),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1924),
    [aux_sym_function_header_repeat1] = STATE(820),
    [ts_builtin_sym_end] = ACTIONS(38),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(38),
    [sym_comdat_ref] = ACTIONS(38),
    [sym_global_var] = ACTIONS(305),
    [sym_local_var] = ACTIONS(305),
    [aux_sym_metadata_ref_token1] = ACTIONS(38),
    [sym_summary_ref] = ACTIONS(38),
    [sym_string] = ACTIONS(308),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [sym_float] = ACTIONS(315),
    [sym_cstring] = ACTIONS(315),
    [anon_sym_target] = ACTIONS(38),
    [anon_sym_source_filename] = ACTIONS(38),
    [anon_sym_declare] = ACTIONS(38),
    [anon_sym_define] = ACTIONS(38),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_LT_LBRACE] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(38),
    [anon_sym_align] = ACTIONS(70),
    [anon_sym_section] = ACTIONS(38),
    [anon_sym_partition] = ACTIONS(38),
    [anon_sym_comdat] = ACTIONS(38),
    [anon_sym_gc] = ACTIONS(38),
    [anon_sym_prefix] = ACTIONS(38),
    [anon_sym_prologue] = ACTIONS(38),
    [anon_sym_personality] = ACTIONS(38),
    [anon_sym_alignstack] = ACTIONS(38),
    [anon_sym_allocsize] = ACTIONS(38),
    [anon_sym_alwaysinline] = ACTIONS(38),
    [anon_sym_builtin] = ACTIONS(38),
    [anon_sym_cold] = ACTIONS(38),
    [anon_sym_convergent] = ACTIONS(38),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(38),
    [anon_sym_hot] = ACTIONS(38),
    [anon_sym_inaccessiblememonly] = ACTIONS(38),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(38),
    [anon_sym_inlinehint] = ACTIONS(38),
    [anon_sym_jumptable] = ACTIONS(38),
    [anon_sym_minsize] = ACTIONS(38),
    [anon_sym_naked] = ACTIONS(38),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(38),
    [anon_sym_nobuiltin] = ACTIONS(38),
    [anon_sym_noduplicate] = ACTIONS(38),
    [anon_sym_nofree] = ACTIONS(38),
    [anon_sym_noimplicitfloat] = ACTIONS(38),
    [anon_sym_noinline] = ACTIONS(38),
    [anon_sym_nomerge] = ACTIONS(38),
    [anon_sym_nonlazybind] = ACTIONS(38),
    [anon_sym_noprofile] = ACTIONS(38),
    [anon_sym_noredzone] = ACTIONS(38),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(38),
    [anon_sym_noreturn] = ACTIONS(38),
    [anon_sym_norecurse] = ACTIONS(38),
    [anon_sym_willreturn] = ACTIONS(38),
    [anon_sym_nosync] = ACTIONS(38),
    [anon_sym_nounwind] = ACTIONS(38),
    [anon_sym_nocallback] = ACTIONS(38),
    [anon_sym_nosanitize_coverage] = ACTIONS(38),
    [anon_sym_null_pointer_is_valid] = ACTIONS(38),
    [anon_sym_optforfuzzing] = ACTIONS(38),
    [anon_sym_optnone] = ACTIONS(38),
    [anon_sym_optsize] = ACTIONS(38),
    [anon_sym_readnone] = ACTIONS(38),
    [anon_sym_readonly] = ACTIONS(38),
    [anon_sym_writeonly] = ACTIONS(38),
    [anon_sym_argmemonly] = ACTIONS(38),
    [anon_sym_returns_twice] = ACTIONS(38),
    [anon_sym_safestack] = ACTIONS(38),
    [anon_sym_sanitize_address] = ACTIONS(38),
    [anon_sym_sanitize_memory] = ACTIONS(38),
    [anon_sym_sanitize_thread] = ACTIONS(38),
    [anon_sym_sanitize_hwaddress] = ACTIONS(38),
    [anon_sym_sanitize_memtag] = ACTIONS(38),
    [anon_sym_speculative_load_hardening] = ACTIONS(38),
    [anon_sym_speculatable] = ACTIONS(38),
    [anon_sym_ssp] = ACTIONS(70),
    [anon_sym_sspstrong] = ACTIONS(38),
    [anon_sym_sspreq] = ACTIONS(38),
    [anon_sym_strictfp] = ACTIONS(38),
    [anon_sym_nocf_check] = ACTIONS(38),
    [anon_sym_shadowcallstack] = ACTIONS(38),
    [anon_sym_mustprogress] = ACTIONS(38),
    [anon_sym_vscale_range] = ACTIONS(38),
    [anon_sym_preallocated] = ACTIONS(38),
    [anon_sym_zeroext] = ACTIONS(38),
    [anon_sym_signext] = ACTIONS(38),
    [anon_sym_inreg] = ACTIONS(38),
    [anon_sym_byval] = ACTIONS(38),
    [anon_sym_byref] = ACTIONS(38),
    [anon_sym_inalloca] = ACTIONS(38),
    [anon_sym_sret] = ACTIONS(38),
    [anon_sym_elementtype] = ACTIONS(38),
    [anon_sym_noalias] = ACTIONS(38),
    [anon_sym_nocapture] = ACTIONS(38),
    [anon_sym_nest] = ACTIONS(38),
    [anon_sym_returned] = ACTIONS(38),
    [anon_sym_nonnull] = ACTIONS(38),
    [anon_sym_dereferenceable] = ACTIONS(70),
    [anon_sym_dereferenceable_or_null] = ACTIONS(38),
    [anon_sym_swiftself] = ACTIONS(38),
    [anon_sym_swiftasync] = ACTIONS(38),
    [anon_sym_swifterror] = ACTIONS(38),
    [anon_sym_immarg] = ACTIONS(38),
    [anon_sym_noundef] = ACTIONS(38),
    [anon_sym_uwtable] = ACTIONS(38),
    [anon_sym_memory] = ACTIONS(38),
    [anon_sym_none] = ACTIONS(315),
    [anon_sym_extractelement] = ACTIONS(335),
    [anon_sym_insertelement] = ACTIONS(337),
    [anon_sym_select] = ACTIONS(339),
    [anon_sym_shufflevector] = ACTIONS(341),
    [anon_sym_fneg] = ACTIONS(343),
    [anon_sym_icmp] = ACTIONS(345),
    [anon_sym_fcmp] = ACTIONS(347),
    [anon_sym_getelementptr] = ACTIONS(349),
    [anon_sym_extractvalue] = ACTIONS(351),
    [anon_sym_insertvalue] = ACTIONS(353),
    [anon_sym_true] = ACTIONS(315),
    [anon_sym_false] = ACTIONS(315),
    [anon_sym_null] = ACTIONS(355),
    [anon_sym_undef] = ACTIONS(315),
    [anon_sym_poison] = ACTIONS(315),
    [anon_sym_zeroinitializer] = ACTIONS(315),
    [anon_sym_blockaddress] = ACTIONS(357),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(112),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
    [anon_sym_uselistorder] = ACTIONS(70),
    [anon_sym_uselistorder_bb] = ACTIONS(38),
    [anon_sym_module] = ACTIONS(38),
    [anon_sym_attributes] = ACTIONS(38),
  },
  [16] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [aux_sym_metadata_ref_token1] = ACTIONS(250),
    [sym_string] = ACTIONS(250),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(250),
    [sym_float] = ACTIONS(250),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(250),
    [anon_sym_private] = ACTIONS(250),
    [anon_sym_internal] = ACTIONS(250),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(250),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(250),
    [anon_sym_available_externally] = ACTIONS(250),
    [anon_sym_appending] = ACTIONS(250),
    [anon_sym_common] = ACTIONS(250),
    [anon_sym_extern_weak] = ACTIONS(250),
    [anon_sym_external] = ACTIONS(250),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(250),
    [anon_sym_dso_preemptable] = ACTIONS(250),
    [anon_sym_default] = ACTIONS(250),
    [anon_sym_hidden] = ACTIONS(250),
    [anon_sym_protected] = ACTIONS(250),
    [anon_sym_dllimport] = ACTIONS(250),
    [anon_sym_dllexport] = ACTIONS(250),
    [anon_sym_ccc] = ACTIONS(250),
    [anon_sym_fastcc] = ACTIONS(250),
    [anon_sym_coldcc] = ACTIONS(250),
    [anon_sym_webkit_jscc] = ACTIONS(252),
    [anon_sym_anyregcc] = ACTIONS(250),
    [anon_sym_preserve_mostcc] = ACTIONS(250),
    [anon_sym_preserve_allcc] = ACTIONS(250),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(252),
    [anon_sym_tailcc] = ACTIONS(250),
    [anon_sym_swiftcc] = ACTIONS(252),
    [anon_sym_swifttailcc] = ACTIONS(252),
    [anon_sym_cfguard_checkcc] = ACTIONS(250),
    [aux_sym_calling_conv_token1] = ACTIONS(252),
    [aux_sym_calling_conv_token2] = ACTIONS(250),
    [aux_sym_calling_conv_token3] = ACTIONS(250),
    [aux_sym_calling_conv_token4] = ACTIONS(250),
    [aux_sym_calling_conv_token5] = ACTIONS(250),
    [aux_sym_calling_conv_token6] = ACTIONS(250),
    [aux_sym_calling_conv_token7] = ACTIONS(250),
    [aux_sym_calling_conv_token8] = ACTIONS(250),
    [aux_sym_calling_conv_token9] = ACTIONS(250),
    [aux_sym_calling_conv_token10] = ACTIONS(252),
    [anon_sym_ghccc] = ACTIONS(250),
    [aux_sym_calling_conv_token11] = ACTIONS(252),
    [aux_sym_calling_conv_token12] = ACTIONS(250),
    [aux_sym_calling_conv_token13] = ACTIONS(252),
    [aux_sym_calling_conv_token14] = ACTIONS(250),
    [anon_sym_cc] = ACTIONS(252),
    [anon_sym_unnamed_addr] = ACTIONS(250),
    [anon_sym_local_unnamed_addr] = ACTIONS(250),
    [anon_sym_STAR] = ACTIONS(250),
    [anon_sym_void] = ACTIONS(250),
    [anon_sym_half] = ACTIONS(250),
    [anon_sym_bfloat] = ACTIONS(250),
    [anon_sym_float] = ACTIONS(250),
    [anon_sym_double] = ACTIONS(250),
    [anon_sym_x86_fp80] = ACTIONS(252),
    [anon_sym_fp128] = ACTIONS(250),
    [anon_sym_ppc_fp128] = ACTIONS(250),
    [anon_sym_label] = ACTIONS(250),
    [anon_sym_metadata] = ACTIONS(250),
    [anon_sym_x86_mmx] = ACTIONS(252),
    [anon_sym_x86_amx] = ACTIONS(252),
    [anon_sym_token] = ACTIONS(250),
    [anon_sym_opaque] = ACTIONS(250),
    [anon_sym_ptr] = ACTIONS(252),
    [aux_sym_type_keyword_token1] = ACTIONS(250),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE_GT] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(252),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_align] = ACTIONS(252),
    [anon_sym_alignstack] = ACTIONS(250),
    [anon_sym_allocsize] = ACTIONS(250),
    [anon_sym_alwaysinline] = ACTIONS(250),
    [anon_sym_builtin] = ACTIONS(250),
    [anon_sym_cold] = ACTIONS(252),
    [anon_sym_convergent] = ACTIONS(250),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(250),
    [anon_sym_hot] = ACTIONS(250),
    [anon_sym_inaccessiblememonly] = ACTIONS(250),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(250),
    [anon_sym_inlinehint] = ACTIONS(250),
    [anon_sym_jumptable] = ACTIONS(250),
    [anon_sym_minsize] = ACTIONS(250),
    [anon_sym_naked] = ACTIONS(250),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(250),
    [anon_sym_nobuiltin] = ACTIONS(250),
    [anon_sym_noduplicate] = ACTIONS(250),
    [anon_sym_nofree] = ACTIONS(250),
    [anon_sym_noimplicitfloat] = ACTIONS(250),
    [anon_sym_noinline] = ACTIONS(250),
    [anon_sym_nomerge] = ACTIONS(250),
    [anon_sym_nonlazybind] = ACTIONS(250),
    [anon_sym_noprofile] = ACTIONS(250),
    [anon_sym_noredzone] = ACTIONS(250),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(250),
    [anon_sym_noreturn] = ACTIONS(250),
    [anon_sym_norecurse] = ACTIONS(250),
    [anon_sym_willreturn] = ACTIONS(250),
    [anon_sym_nosync] = ACTIONS(250),
    [anon_sym_nounwind] = ACTIONS(250),
    [anon_sym_nocallback] = ACTIONS(250),
    [anon_sym_nosanitize_coverage] = ACTIONS(250),
    [anon_sym_null_pointer_is_valid] = ACTIONS(250),
    [anon_sym_optforfuzzing] = ACTIONS(250),
    [anon_sym_optnone] = ACTIONS(250),
    [anon_sym_optsize] = ACTIONS(250),
    [anon_sym_readnone] = ACTIONS(250),
    [anon_sym_readonly] = ACTIONS(250),
    [anon_sym_writeonly] = ACTIONS(250),
    [anon_sym_argmemonly] = ACTIONS(250),
    [anon_sym_returns_twice] = ACTIONS(250),
    [anon_sym_safestack] = ACTIONS(250),
    [anon_sym_sanitize_address] = ACTIONS(250),
    [anon_sym_sanitize_memory] = ACTIONS(250),
    [anon_sym_sanitize_thread] = ACTIONS(250),
    [anon_sym_sanitize_hwaddress] = ACTIONS(250),
    [anon_sym_sanitize_memtag] = ACTIONS(250),
    [anon_sym_speculative_load_hardening] = ACTIONS(250),
    [anon_sym_speculatable] = ACTIONS(250),
    [anon_sym_ssp] = ACTIONS(252),
    [anon_sym_sspstrong] = ACTIONS(250),
    [anon_sym_sspreq] = ACTIONS(250),
    [anon_sym_strictfp] = ACTIONS(250),
    [anon_sym_nocf_check] = ACTIONS(250),
    [anon_sym_shadowcallstack] = ACTIONS(250),
    [anon_sym_mustprogress] = ACTIONS(250),
    [anon_sym_vscale_range] = ACTIONS(250),
    [anon_sym_preallocated] = ACTIONS(250),
    [anon_sym_zeroext] = ACTIONS(250),
    [anon_sym_signext] = ACTIONS(250),
    [anon_sym_inreg] = ACTIONS(250),
    [anon_sym_byval] = ACTIONS(250),
    [anon_sym_byref] = ACTIONS(250),
    [anon_sym_inalloca] = ACTIONS(250),
    [anon_sym_sret] = ACTIONS(250),
    [anon_sym_elementtype] = ACTIONS(250),
    [anon_sym_noalias] = ACTIONS(250),
    [anon_sym_nocapture] = ACTIONS(250),
    [anon_sym_nest] = ACTIONS(250),
    [anon_sym_returned] = ACTIONS(250),
    [anon_sym_nonnull] = ACTIONS(250),
    [anon_sym_dereferenceable] = ACTIONS(252),
    [anon_sym_dereferenceable_or_null] = ACTIONS(250),
    [anon_sym_swiftself] = ACTIONS(252),
    [anon_sym_swiftasync] = ACTIONS(252),
    [anon_sym_swifterror] = ACTIONS(252),
    [anon_sym_immarg] = ACTIONS(250),
    [anon_sym_noundef] = ACTIONS(250),
    [anon_sym_uwtable] = ACTIONS(250),
    [anon_sym_memory] = ACTIONS(250),
    [anon_sym_none] = ACTIONS(250),
    [anon_sym_extractelement] = ACTIONS(250),
    [anon_sym_insertelement] = ACTIONS(250),
    [anon_sym_select] = ACTIONS(250),
    [anon_sym_shufflevector] = ACTIONS(250),
    [anon_sym_fneg] = ACTIONS(250),
    [anon_sym_icmp] = ACTIONS(250),
    [anon_sym_fcmp] = ACTIONS(250),
    [anon_sym_getelementptr] = ACTIONS(250),
    [anon_sym_extractvalue] = ACTIONS(250),
    [anon_sym_insertvalue] = ACTIONS(250),
    [anon_sym_true] = ACTIONS(250),
    [anon_sym_false] = ACTIONS(250),
    [anon_sym_null] = ACTIONS(252),
    [anon_sym_undef] = ACTIONS(250),
    [anon_sym_poison] = ACTIONS(250),
    [anon_sym_zeroinitializer] = ACTIONS(250),
    [anon_sym_blockaddress] = ACTIONS(250),
    [anon_sym_mul] = ACTIONS(250),
    [anon_sym_urem] = ACTIONS(250),
    [anon_sym_srem] = ACTIONS(250),
    [anon_sym_shl] = ACTIONS(250),
    [anon_sym_udiv] = ACTIONS(250),
    [anon_sym_sdiv] = ACTIONS(250),
    [anon_sym_lshr] = ACTIONS(250),
    [anon_sym_ashr] = ACTIONS(250),
    [anon_sym_fmul] = ACTIONS(250),
    [anon_sym_fdiv] = ACTIONS(250),
    [anon_sym_frem] = ACTIONS(250),
    [anon_sym_xchg] = ACTIONS(250),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(250),
    [anon_sym_and] = ACTIONS(250),
    [anon_sym_nand] = ACTIONS(250),
    [anon_sym_or] = ACTIONS(250),
    [anon_sym_xor] = ACTIONS(250),
    [anon_sym_max] = ACTIONS(250),
    [anon_sym_min] = ACTIONS(252),
    [anon_sym_umax] = ACTIONS(250),
    [anon_sym_umin] = ACTIONS(250),
    [anon_sym_fadd] = ACTIONS(250),
    [anon_sym_fsub] = ACTIONS(250),
    [anon_sym_bitcast] = ACTIONS(250),
    [anon_sym_trunc] = ACTIONS(250),
    [anon_sym_zext] = ACTIONS(250),
    [anon_sym_sext] = ACTIONS(250),
    [anon_sym_fptrunc] = ACTIONS(250),
    [anon_sym_fpext] = ACTIONS(250),
    [anon_sym_addrspacecast] = ACTIONS(250),
    [anon_sym_uitofp] = ACTIONS(250),
    [anon_sym_sitofp] = ACTIONS(250),
    [anon_sym_fptoui] = ACTIONS(250),
    [anon_sym_fptosi] = ACTIONS(250),
    [anon_sym_inttoptr] = ACTIONS(250),
    [anon_sym_ptrtoint] = ACTIONS(250),
  },
  [17] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(359),
    [sym_local_var] = ACTIONS(359),
    [aux_sym_metadata_ref_token1] = ACTIONS(359),
    [sym_string] = ACTIONS(359),
    [aux_sym_number_token1] = ACTIONS(361),
    [aux_sym_number_token2] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_cstring] = ACTIONS(359),
    [anon_sym_no_cfi] = ACTIONS(359),
    [anon_sym_private] = ACTIONS(359),
    [anon_sym_internal] = ACTIONS(359),
    [anon_sym_weak] = ACTIONS(361),
    [anon_sym_weak_odr] = ACTIONS(359),
    [anon_sym_linkonce] = ACTIONS(361),
    [anon_sym_linkonce_odr] = ACTIONS(359),
    [anon_sym_available_externally] = ACTIONS(359),
    [anon_sym_appending] = ACTIONS(359),
    [anon_sym_common] = ACTIONS(359),
    [anon_sym_extern_weak] = ACTIONS(359),
    [anon_sym_external] = ACTIONS(359),
    [anon_sym_dso_local] = ACTIONS(361),
    [anon_sym_dso_local_equivalent] = ACTIONS(359),
    [anon_sym_dso_preemptable] = ACTIONS(359),
    [anon_sym_default] = ACTIONS(359),
    [anon_sym_hidden] = ACTIONS(359),
    [anon_sym_protected] = ACTIONS(359),
    [anon_sym_dllimport] = ACTIONS(359),
    [anon_sym_dllexport] = ACTIONS(359),
    [anon_sym_ccc] = ACTIONS(359),
    [anon_sym_fastcc] = ACTIONS(359),
    [anon_sym_coldcc] = ACTIONS(359),
    [anon_sym_webkit_jscc] = ACTIONS(361),
    [anon_sym_anyregcc] = ACTIONS(359),
    [anon_sym_preserve_mostcc] = ACTIONS(359),
    [anon_sym_preserve_allcc] = ACTIONS(359),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(361),
    [anon_sym_tailcc] = ACTIONS(359),
    [anon_sym_swiftcc] = ACTIONS(361),
    [anon_sym_swifttailcc] = ACTIONS(361),
    [anon_sym_cfguard_checkcc] = ACTIONS(359),
    [aux_sym_calling_conv_token1] = ACTIONS(361),
    [aux_sym_calling_conv_token2] = ACTIONS(359),
    [aux_sym_calling_conv_token3] = ACTIONS(359),
    [aux_sym_calling_conv_token4] = ACTIONS(359),
    [aux_sym_calling_conv_token5] = ACTIONS(359),
    [aux_sym_calling_conv_token6] = ACTIONS(359),
    [aux_sym_calling_conv_token7] = ACTIONS(359),
    [aux_sym_calling_conv_token8] = ACTIONS(359),
    [aux_sym_calling_conv_token9] = ACTIONS(359),
    [aux_sym_calling_conv_token10] = ACTIONS(361),
    [anon_sym_ghccc] = ACTIONS(359),
    [aux_sym_calling_conv_token11] = ACTIONS(361),
    [aux_sym_calling_conv_token12] = ACTIONS(359),
    [aux_sym_calling_conv_token13] = ACTIONS(361),
    [aux_sym_calling_conv_token14] = ACTIONS(359),
    [anon_sym_cc] = ACTIONS(361),
    [anon_sym_unnamed_addr] = ACTIONS(359),
    [anon_sym_local_unnamed_addr] = ACTIONS(359),
    [anon_sym_STAR] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_half] = ACTIONS(359),
    [anon_sym_bfloat] = ACTIONS(359),
    [anon_sym_float] = ACTIONS(359),
    [anon_sym_double] = ACTIONS(359),
    [anon_sym_x86_fp80] = ACTIONS(361),
    [anon_sym_fp128] = ACTIONS(359),
    [anon_sym_ppc_fp128] = ACTIONS(359),
    [anon_sym_label] = ACTIONS(359),
    [anon_sym_metadata] = ACTIONS(359),
    [anon_sym_x86_mmx] = ACTIONS(361),
    [anon_sym_x86_amx] = ACTIONS(361),
    [anon_sym_token] = ACTIONS(359),
    [anon_sym_opaque] = ACTIONS(359),
    [anon_sym_ptr] = ACTIONS(361),
    [aux_sym_type_keyword_token1] = ACTIONS(359),
    [anon_sym_LBRACE] = ACTIONS(359),
    [anon_sym_LT_LBRACE] = ACTIONS(359),
    [anon_sym_RBRACE_GT] = ACTIONS(359),
    [anon_sym_LBRACK] = ACTIONS(359),
    [anon_sym_LT] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(359),
    [anon_sym_addrspace] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(359),
    [anon_sym_align] = ACTIONS(361),
    [anon_sym_alignstack] = ACTIONS(359),
    [anon_sym_allocsize] = ACTIONS(359),
    [anon_sym_alwaysinline] = ACTIONS(359),
    [anon_sym_builtin] = ACTIONS(359),
    [anon_sym_cold] = ACTIONS(361),
    [anon_sym_convergent] = ACTIONS(359),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(359),
    [anon_sym_hot] = ACTIONS(359),
    [anon_sym_inaccessiblememonly] = ACTIONS(359),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(359),
    [anon_sym_inlinehint] = ACTIONS(359),
    [anon_sym_jumptable] = ACTIONS(359),
    [anon_sym_minsize] = ACTIONS(359),
    [anon_sym_naked] = ACTIONS(359),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(359),
    [anon_sym_nobuiltin] = ACTIONS(359),
    [anon_sym_noduplicate] = ACTIONS(359),
    [anon_sym_nofree] = ACTIONS(359),
    [anon_sym_noimplicitfloat] = ACTIONS(359),
    [anon_sym_noinline] = ACTIONS(359),
    [anon_sym_nomerge] = ACTIONS(359),
    [anon_sym_nonlazybind] = ACTIONS(359),
    [anon_sym_noprofile] = ACTIONS(359),
    [anon_sym_noredzone] = ACTIONS(359),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(359),
    [anon_sym_noreturn] = ACTIONS(359),
    [anon_sym_norecurse] = ACTIONS(359),
    [anon_sym_willreturn] = ACTIONS(359),
    [anon_sym_nosync] = ACTIONS(359),
    [anon_sym_nounwind] = ACTIONS(359),
    [anon_sym_nocallback] = ACTIONS(359),
    [anon_sym_nosanitize_coverage] = ACTIONS(359),
    [anon_sym_null_pointer_is_valid] = ACTIONS(359),
    [anon_sym_optforfuzzing] = ACTIONS(359),
    [anon_sym_optnone] = ACTIONS(359),
    [anon_sym_optsize] = ACTIONS(359),
    [anon_sym_readnone] = ACTIONS(359),
    [anon_sym_readonly] = ACTIONS(359),
    [anon_sym_writeonly] = ACTIONS(359),
    [anon_sym_argmemonly] = ACTIONS(359),
    [anon_sym_returns_twice] = ACTIONS(359),
    [anon_sym_safestack] = ACTIONS(359),
    [anon_sym_sanitize_address] = ACTIONS(359),
    [anon_sym_sanitize_memory] = ACTIONS(359),
    [anon_sym_sanitize_thread] = ACTIONS(359),
    [anon_sym_sanitize_hwaddress] = ACTIONS(359),
    [anon_sym_sanitize_memtag] = ACTIONS(359),
    [anon_sym_speculative_load_hardening] = ACTIONS(359),
    [anon_sym_speculatable] = ACTIONS(359),
    [anon_sym_ssp] = ACTIONS(361),
    [anon_sym_sspstrong] = ACTIONS(359),
    [anon_sym_sspreq] = ACTIONS(359),
    [anon_sym_strictfp] = ACTIONS(359),
    [anon_sym_nocf_check] = ACTIONS(359),
    [anon_sym_shadowcallstack] = ACTIONS(359),
    [anon_sym_mustprogress] = ACTIONS(359),
    [anon_sym_vscale_range] = ACTIONS(359),
    [anon_sym_preallocated] = ACTIONS(359),
    [anon_sym_zeroext] = ACTIONS(359),
    [anon_sym_signext] = ACTIONS(359),
    [anon_sym_inreg] = ACTIONS(359),
    [anon_sym_byval] = ACTIONS(359),
    [anon_sym_byref] = ACTIONS(359),
    [anon_sym_inalloca] = ACTIONS(359),
    [anon_sym_sret] = ACTIONS(359),
    [anon_sym_elementtype] = ACTIONS(359),
    [anon_sym_noalias] = ACTIONS(359),
    [anon_sym_nocapture] = ACTIONS(359),
    [anon_sym_nest] = ACTIONS(359),
    [anon_sym_returned] = ACTIONS(359),
    [anon_sym_nonnull] = ACTIONS(359),
    [anon_sym_dereferenceable] = ACTIONS(361),
    [anon_sym_dereferenceable_or_null] = ACTIONS(359),
    [anon_sym_swiftself] = ACTIONS(361),
    [anon_sym_swiftasync] = ACTIONS(361),
    [anon_sym_swifterror] = ACTIONS(361),
    [anon_sym_immarg] = ACTIONS(359),
    [anon_sym_noundef] = ACTIONS(359),
    [anon_sym_uwtable] = ACTIONS(359),
    [anon_sym_memory] = ACTIONS(359),
    [anon_sym_none] = ACTIONS(359),
    [anon_sym_extractelement] = ACTIONS(359),
    [anon_sym_insertelement] = ACTIONS(359),
    [anon_sym_select] = ACTIONS(359),
    [anon_sym_shufflevector] = ACTIONS(359),
    [anon_sym_fneg] = ACTIONS(359),
    [anon_sym_icmp] = ACTIONS(359),
    [anon_sym_fcmp] = ACTIONS(359),
    [anon_sym_getelementptr] = ACTIONS(359),
    [anon_sym_extractvalue] = ACTIONS(359),
    [anon_sym_insertvalue] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(359),
    [anon_sym_false] = ACTIONS(359),
    [anon_sym_null] = ACTIONS(361),
    [anon_sym_undef] = ACTIONS(359),
    [anon_sym_poison] = ACTIONS(359),
    [anon_sym_zeroinitializer] = ACTIONS(359),
    [anon_sym_blockaddress] = ACTIONS(359),
    [anon_sym_mul] = ACTIONS(359),
    [anon_sym_urem] = ACTIONS(359),
    [anon_sym_srem] = ACTIONS(359),
    [anon_sym_shl] = ACTIONS(359),
    [anon_sym_udiv] = ACTIONS(359),
    [anon_sym_sdiv] = ACTIONS(359),
    [anon_sym_lshr] = ACTIONS(359),
    [anon_sym_ashr] = ACTIONS(359),
    [anon_sym_fmul] = ACTIONS(359),
    [anon_sym_fdiv] = ACTIONS(359),
    [anon_sym_frem] = ACTIONS(359),
    [anon_sym_xchg] = ACTIONS(359),
    [anon_sym_add] = ACTIONS(361),
    [anon_sym_sub] = ACTIONS(359),
    [anon_sym_and] = ACTIONS(359),
    [anon_sym_nand] = ACTIONS(359),
    [anon_sym_or] = ACTIONS(359),
    [anon_sym_xor] = ACTIONS(359),
    [anon_sym_max] = ACTIONS(359),
    [anon_sym_min] = ACTIONS(361),
    [anon_sym_umax] = ACTIONS(359),
    [anon_sym_umin] = ACTIONS(359),
    [anon_sym_fadd] = ACTIONS(359),
    [anon_sym_fsub] = ACTIONS(359),
    [anon_sym_bitcast] = ACTIONS(359),
    [anon_sym_trunc] = ACTIONS(359),
    [anon_sym_zext] = ACTIONS(359),
    [anon_sym_sext] = ACTIONS(359),
    [anon_sym_fptrunc] = ACTIONS(359),
    [anon_sym_fpext] = ACTIONS(359),
    [anon_sym_addrspacecast] = ACTIONS(359),
    [anon_sym_uitofp] = ACTIONS(359),
    [anon_sym_sitofp] = ACTIONS(359),
    [anon_sym_fptoui] = ACTIONS(359),
    [anon_sym_fptosi] = ACTIONS(359),
    [anon_sym_inttoptr] = ACTIONS(359),
    [anon_sym_ptrtoint] = ACTIONS(359),
  },
  [18] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(116),
    [aux_sym_metadata_ref_token1] = ACTIONS(116),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_ccc] = ACTIONS(116),
    [anon_sym_fastcc] = ACTIONS(116),
    [anon_sym_coldcc] = ACTIONS(116),
    [anon_sym_webkit_jscc] = ACTIONS(122),
    [anon_sym_anyregcc] = ACTIONS(116),
    [anon_sym_preserve_mostcc] = ACTIONS(116),
    [anon_sym_preserve_allcc] = ACTIONS(116),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(122),
    [anon_sym_tailcc] = ACTIONS(116),
    [anon_sym_swiftcc] = ACTIONS(122),
    [anon_sym_swifttailcc] = ACTIONS(122),
    [anon_sym_cfguard_checkcc] = ACTIONS(116),
    [aux_sym_calling_conv_token1] = ACTIONS(122),
    [aux_sym_calling_conv_token2] = ACTIONS(116),
    [aux_sym_calling_conv_token3] = ACTIONS(116),
    [aux_sym_calling_conv_token4] = ACTIONS(116),
    [aux_sym_calling_conv_token5] = ACTIONS(116),
    [aux_sym_calling_conv_token6] = ACTIONS(116),
    [aux_sym_calling_conv_token7] = ACTIONS(116),
    [aux_sym_calling_conv_token8] = ACTIONS(116),
    [aux_sym_calling_conv_token9] = ACTIONS(116),
    [aux_sym_calling_conv_token10] = ACTIONS(122),
    [anon_sym_ghccc] = ACTIONS(116),
    [aux_sym_calling_conv_token11] = ACTIONS(122),
    [aux_sym_calling_conv_token12] = ACTIONS(116),
    [aux_sym_calling_conv_token13] = ACTIONS(122),
    [aux_sym_calling_conv_token14] = ACTIONS(116),
    [anon_sym_cc] = ACTIONS(122),
    [anon_sym_unnamed_addr] = ACTIONS(116),
    [anon_sym_local_unnamed_addr] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_half] = ACTIONS(116),
    [anon_sym_bfloat] = ACTIONS(116),
    [anon_sym_float] = ACTIONS(116),
    [anon_sym_double] = ACTIONS(116),
    [anon_sym_x86_fp80] = ACTIONS(122),
    [anon_sym_fp128] = ACTIONS(116),
    [anon_sym_ppc_fp128] = ACTIONS(116),
    [anon_sym_label] = ACTIONS(116),
    [anon_sym_metadata] = ACTIONS(116),
    [anon_sym_x86_mmx] = ACTIONS(122),
    [anon_sym_x86_amx] = ACTIONS(122),
    [anon_sym_token] = ACTIONS(116),
    [anon_sym_opaque] = ACTIONS(116),
    [anon_sym_ptr] = ACTIONS(122),
    [aux_sym_type_keyword_token1] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(116),
    [anon_sym_LT_LBRACE] = ACTIONS(116),
    [anon_sym_RBRACE_GT] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(116),
    [anon_sym_LT] = ACTIONS(122),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_align] = ACTIONS(122),
    [anon_sym_alignstack] = ACTIONS(116),
    [anon_sym_allocsize] = ACTIONS(116),
    [anon_sym_alwaysinline] = ACTIONS(116),
    [anon_sym_builtin] = ACTIONS(116),
    [anon_sym_cold] = ACTIONS(122),
    [anon_sym_convergent] = ACTIONS(116),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(116),
    [anon_sym_hot] = ACTIONS(116),
    [anon_sym_inaccessiblememonly] = ACTIONS(116),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(116),
    [anon_sym_inlinehint] = ACTIONS(116),
    [anon_sym_jumptable] = ACTIONS(116),
    [anon_sym_minsize] = ACTIONS(116),
    [anon_sym_naked] = ACTIONS(116),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(116),
    [anon_sym_nobuiltin] = ACTIONS(116),
    [anon_sym_noduplicate] = ACTIONS(116),
    [anon_sym_nofree] = ACTIONS(116),
    [anon_sym_noimplicitfloat] = ACTIONS(116),
    [anon_sym_noinline] = ACTIONS(116),
    [anon_sym_nomerge] = ACTIONS(116),
    [anon_sym_nonlazybind] = ACTIONS(116),
    [anon_sym_noprofile] = ACTIONS(116),
    [anon_sym_noredzone] = ACTIONS(116),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(116),
    [anon_sym_noreturn] = ACTIONS(116),
    [anon_sym_norecurse] = ACTIONS(116),
    [anon_sym_willreturn] = ACTIONS(116),
    [anon_sym_nosync] = ACTIONS(116),
    [anon_sym_nounwind] = ACTIONS(116),
    [anon_sym_nocallback] = ACTIONS(116),
    [anon_sym_nosanitize_coverage] = ACTIONS(116),
    [anon_sym_null_pointer_is_valid] = ACTIONS(116),
    [anon_sym_optforfuzzing] = ACTIONS(116),
    [anon_sym_optnone] = ACTIONS(116),
    [anon_sym_optsize] = ACTIONS(116),
    [anon_sym_readnone] = ACTIONS(116),
    [anon_sym_readonly] = ACTIONS(116),
    [anon_sym_writeonly] = ACTIONS(116),
    [anon_sym_argmemonly] = ACTIONS(116),
    [anon_sym_returns_twice] = ACTIONS(116),
    [anon_sym_safestack] = ACTIONS(116),
    [anon_sym_sanitize_address] = ACTIONS(116),
    [anon_sym_sanitize_memory] = ACTIONS(116),
    [anon_sym_sanitize_thread] = ACTIONS(116),
    [anon_sym_sanitize_hwaddress] = ACTIONS(116),
    [anon_sym_sanitize_memtag] = ACTIONS(116),
    [anon_sym_speculative_load_hardening] = ACTIONS(116),
    [anon_sym_speculatable] = ACTIONS(116),
    [anon_sym_ssp] = ACTIONS(122),
    [anon_sym_sspstrong] = ACTIONS(116),
    [anon_sym_sspreq] = ACTIONS(116),
    [anon_sym_strictfp] = ACTIONS(116),
    [anon_sym_nocf_check] = ACTIONS(116),
    [anon_sym_shadowcallstack] = ACTIONS(116),
    [anon_sym_mustprogress] = ACTIONS(116),
    [anon_sym_vscale_range] = ACTIONS(116),
    [anon_sym_preallocated] = ACTIONS(116),
    [anon_sym_zeroext] = ACTIONS(116),
    [anon_sym_signext] = ACTIONS(116),
    [anon_sym_inreg] = ACTIONS(116),
    [anon_sym_byval] = ACTIONS(116),
    [anon_sym_byref] = ACTIONS(116),
    [anon_sym_inalloca] = ACTIONS(116),
    [anon_sym_sret] = ACTIONS(116),
    [anon_sym_elementtype] = ACTIONS(116),
    [anon_sym_noalias] = ACTIONS(116),
    [anon_sym_nocapture] = ACTIONS(116),
    [anon_sym_nest] = ACTIONS(116),
    [anon_sym_returned] = ACTIONS(116),
    [anon_sym_nonnull] = ACTIONS(116),
    [anon_sym_dereferenceable] = ACTIONS(122),
    [anon_sym_dereferenceable_or_null] = ACTIONS(116),
    [anon_sym_swiftself] = ACTIONS(122),
    [anon_sym_swiftasync] = ACTIONS(122),
    [anon_sym_swifterror] = ACTIONS(122),
    [anon_sym_immarg] = ACTIONS(116),
    [anon_sym_noundef] = ACTIONS(116),
    [anon_sym_uwtable] = ACTIONS(116),
    [anon_sym_memory] = ACTIONS(116),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(122),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
  },
  [19] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(363),
    [sym_local_var] = ACTIONS(363),
    [aux_sym_metadata_ref_token1] = ACTIONS(363),
    [sym_string] = ACTIONS(363),
    [aux_sym_number_token1] = ACTIONS(365),
    [aux_sym_number_token2] = ACTIONS(363),
    [sym_float] = ACTIONS(363),
    [sym_cstring] = ACTIONS(363),
    [anon_sym_no_cfi] = ACTIONS(363),
    [anon_sym_private] = ACTIONS(363),
    [anon_sym_internal] = ACTIONS(363),
    [anon_sym_weak] = ACTIONS(365),
    [anon_sym_weak_odr] = ACTIONS(363),
    [anon_sym_linkonce] = ACTIONS(365),
    [anon_sym_linkonce_odr] = ACTIONS(363),
    [anon_sym_available_externally] = ACTIONS(363),
    [anon_sym_appending] = ACTIONS(363),
    [anon_sym_common] = ACTIONS(363),
    [anon_sym_extern_weak] = ACTIONS(363),
    [anon_sym_external] = ACTIONS(363),
    [anon_sym_dso_local] = ACTIONS(365),
    [anon_sym_dso_local_equivalent] = ACTIONS(363),
    [anon_sym_dso_preemptable] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(363),
    [anon_sym_hidden] = ACTIONS(363),
    [anon_sym_protected] = ACTIONS(363),
    [anon_sym_dllimport] = ACTIONS(363),
    [anon_sym_dllexport] = ACTIONS(363),
    [anon_sym_ccc] = ACTIONS(363),
    [anon_sym_fastcc] = ACTIONS(363),
    [anon_sym_coldcc] = ACTIONS(363),
    [anon_sym_webkit_jscc] = ACTIONS(365),
    [anon_sym_anyregcc] = ACTIONS(363),
    [anon_sym_preserve_mostcc] = ACTIONS(363),
    [anon_sym_preserve_allcc] = ACTIONS(363),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(365),
    [anon_sym_tailcc] = ACTIONS(363),
    [anon_sym_swiftcc] = ACTIONS(365),
    [anon_sym_swifttailcc] = ACTIONS(365),
    [anon_sym_cfguard_checkcc] = ACTIONS(363),
    [aux_sym_calling_conv_token1] = ACTIONS(365),
    [aux_sym_calling_conv_token2] = ACTIONS(363),
    [aux_sym_calling_conv_token3] = ACTIONS(363),
    [aux_sym_calling_conv_token4] = ACTIONS(363),
    [aux_sym_calling_conv_token5] = ACTIONS(363),
    [aux_sym_calling_conv_token6] = ACTIONS(363),
    [aux_sym_calling_conv_token7] = ACTIONS(363),
    [aux_sym_calling_conv_token8] = ACTIONS(363),
    [aux_sym_calling_conv_token9] = ACTIONS(363),
    [aux_sym_calling_conv_token10] = ACTIONS(365),
    [anon_sym_ghccc] = ACTIONS(363),
    [aux_sym_calling_conv_token11] = ACTIONS(365),
    [aux_sym_calling_conv_token12] = ACTIONS(363),
    [aux_sym_calling_conv_token13] = ACTIONS(365),
    [aux_sym_calling_conv_token14] = ACTIONS(363),
    [anon_sym_cc] = ACTIONS(365),
    [anon_sym_unnamed_addr] = ACTIONS(363),
    [anon_sym_local_unnamed_addr] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(363),
    [anon_sym_void] = ACTIONS(363),
    [anon_sym_half] = ACTIONS(363),
    [anon_sym_bfloat] = ACTIONS(363),
    [anon_sym_float] = ACTIONS(363),
    [anon_sym_double] = ACTIONS(363),
    [anon_sym_x86_fp80] = ACTIONS(365),
    [anon_sym_fp128] = ACTIONS(363),
    [anon_sym_ppc_fp128] = ACTIONS(363),
    [anon_sym_label] = ACTIONS(363),
    [anon_sym_metadata] = ACTIONS(363),
    [anon_sym_x86_mmx] = ACTIONS(365),
    [anon_sym_x86_amx] = ACTIONS(365),
    [anon_sym_token] = ACTIONS(363),
    [anon_sym_opaque] = ACTIONS(363),
    [anon_sym_ptr] = ACTIONS(365),
    [aux_sym_type_keyword_token1] = ACTIONS(363),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_LT_LBRACE] = ACTIONS(363),
    [anon_sym_RBRACE_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_LT] = ACTIONS(365),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_addrspace] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_align] = ACTIONS(365),
    [anon_sym_alignstack] = ACTIONS(363),
    [anon_sym_allocsize] = ACTIONS(363),
    [anon_sym_alwaysinline] = ACTIONS(363),
    [anon_sym_builtin] = ACTIONS(363),
    [anon_sym_cold] = ACTIONS(365),
    [anon_sym_convergent] = ACTIONS(363),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(363),
    [anon_sym_hot] = ACTIONS(363),
    [anon_sym_inaccessiblememonly] = ACTIONS(363),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(363),
    [anon_sym_inlinehint] = ACTIONS(363),
    [anon_sym_jumptable] = ACTIONS(363),
    [anon_sym_minsize] = ACTIONS(363),
    [anon_sym_naked] = ACTIONS(363),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(363),
    [anon_sym_nobuiltin] = ACTIONS(363),
    [anon_sym_noduplicate] = ACTIONS(363),
    [anon_sym_nofree] = ACTIONS(363),
    [anon_sym_noimplicitfloat] = ACTIONS(363),
    [anon_sym_noinline] = ACTIONS(363),
    [anon_sym_nomerge] = ACTIONS(363),
    [anon_sym_nonlazybind] = ACTIONS(363),
    [anon_sym_noprofile] = ACTIONS(363),
    [anon_sym_noredzone] = ACTIONS(363),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(363),
    [anon_sym_noreturn] = ACTIONS(363),
    [anon_sym_norecurse] = ACTIONS(363),
    [anon_sym_willreturn] = ACTIONS(363),
    [anon_sym_nosync] = ACTIONS(363),
    [anon_sym_nounwind] = ACTIONS(363),
    [anon_sym_nocallback] = ACTIONS(363),
    [anon_sym_nosanitize_coverage] = ACTIONS(363),
    [anon_sym_null_pointer_is_valid] = ACTIONS(363),
    [anon_sym_optforfuzzing] = ACTIONS(363),
    [anon_sym_optnone] = ACTIONS(363),
    [anon_sym_optsize] = ACTIONS(363),
    [anon_sym_readnone] = ACTIONS(363),
    [anon_sym_readonly] = ACTIONS(363),
    [anon_sym_writeonly] = ACTIONS(363),
    [anon_sym_argmemonly] = ACTIONS(363),
    [anon_sym_returns_twice] = ACTIONS(363),
    [anon_sym_safestack] = ACTIONS(363),
    [anon_sym_sanitize_address] = ACTIONS(363),
    [anon_sym_sanitize_memory] = ACTIONS(363),
    [anon_sym_sanitize_thread] = ACTIONS(363),
    [anon_sym_sanitize_hwaddress] = ACTIONS(363),
    [anon_sym_sanitize_memtag] = ACTIONS(363),
    [anon_sym_speculative_load_hardening] = ACTIONS(363),
    [anon_sym_speculatable] = ACTIONS(363),
    [anon_sym_ssp] = ACTIONS(365),
    [anon_sym_sspstrong] = ACTIONS(363),
    [anon_sym_sspreq] = ACTIONS(363),
    [anon_sym_strictfp] = ACTIONS(363),
    [anon_sym_nocf_check] = ACTIONS(363),
    [anon_sym_shadowcallstack] = ACTIONS(363),
    [anon_sym_mustprogress] = ACTIONS(363),
    [anon_sym_vscale_range] = ACTIONS(363),
    [anon_sym_preallocated] = ACTIONS(363),
    [anon_sym_zeroext] = ACTIONS(363),
    [anon_sym_signext] = ACTIONS(363),
    [anon_sym_inreg] = ACTIONS(363),
    [anon_sym_byval] = ACTIONS(363),
    [anon_sym_byref] = ACTIONS(363),
    [anon_sym_inalloca] = ACTIONS(363),
    [anon_sym_sret] = ACTIONS(363),
    [anon_sym_elementtype] = ACTIONS(363),
    [anon_sym_noalias] = ACTIONS(363),
    [anon_sym_nocapture] = ACTIONS(363),
    [anon_sym_nest] = ACTIONS(363),
    [anon_sym_returned] = ACTIONS(363),
    [anon_sym_nonnull] = ACTIONS(363),
    [anon_sym_dereferenceable] = ACTIONS(365),
    [anon_sym_dereferenceable_or_null] = ACTIONS(363),
    [anon_sym_swiftself] = ACTIONS(365),
    [anon_sym_swiftasync] = ACTIONS(365),
    [anon_sym_swifterror] = ACTIONS(365),
    [anon_sym_immarg] = ACTIONS(363),
    [anon_sym_noundef] = ACTIONS(363),
    [anon_sym_uwtable] = ACTIONS(363),
    [anon_sym_memory] = ACTIONS(363),
    [anon_sym_none] = ACTIONS(363),
    [anon_sym_extractelement] = ACTIONS(363),
    [anon_sym_insertelement] = ACTIONS(363),
    [anon_sym_select] = ACTIONS(363),
    [anon_sym_shufflevector] = ACTIONS(363),
    [anon_sym_fneg] = ACTIONS(363),
    [anon_sym_icmp] = ACTIONS(363),
    [anon_sym_fcmp] = ACTIONS(363),
    [anon_sym_getelementptr] = ACTIONS(363),
    [anon_sym_extractvalue] = ACTIONS(363),
    [anon_sym_insertvalue] = ACTIONS(363),
    [anon_sym_true] = ACTIONS(363),
    [anon_sym_false] = ACTIONS(363),
    [anon_sym_null] = ACTIONS(365),
    [anon_sym_undef] = ACTIONS(363),
    [anon_sym_poison] = ACTIONS(363),
    [anon_sym_zeroinitializer] = ACTIONS(363),
    [anon_sym_blockaddress] = ACTIONS(363),
    [anon_sym_mul] = ACTIONS(363),
    [anon_sym_urem] = ACTIONS(363),
    [anon_sym_srem] = ACTIONS(363),
    [anon_sym_shl] = ACTIONS(363),
    [anon_sym_udiv] = ACTIONS(363),
    [anon_sym_sdiv] = ACTIONS(363),
    [anon_sym_lshr] = ACTIONS(363),
    [anon_sym_ashr] = ACTIONS(363),
    [anon_sym_fmul] = ACTIONS(363),
    [anon_sym_fdiv] = ACTIONS(363),
    [anon_sym_frem] = ACTIONS(363),
    [anon_sym_xchg] = ACTIONS(363),
    [anon_sym_add] = ACTIONS(365),
    [anon_sym_sub] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_nand] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_xor] = ACTIONS(363),
    [anon_sym_max] = ACTIONS(363),
    [anon_sym_min] = ACTIONS(365),
    [anon_sym_umax] = ACTIONS(363),
    [anon_sym_umin] = ACTIONS(363),
    [anon_sym_fadd] = ACTIONS(363),
    [anon_sym_fsub] = ACTIONS(363),
    [anon_sym_bitcast] = ACTIONS(363),
    [anon_sym_trunc] = ACTIONS(363),
    [anon_sym_zext] = ACTIONS(363),
    [anon_sym_sext] = ACTIONS(363),
    [anon_sym_fptrunc] = ACTIONS(363),
    [anon_sym_fpext] = ACTIONS(363),
    [anon_sym_addrspacecast] = ACTIONS(363),
    [anon_sym_uitofp] = ACTIONS(363),
    [anon_sym_sitofp] = ACTIONS(363),
    [anon_sym_fptoui] = ACTIONS(363),
    [anon_sym_fptosi] = ACTIONS(363),
    [anon_sym_inttoptr] = ACTIONS(363),
    [anon_sym_ptrtoint] = ACTIONS(363),
  },
  [20] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(367),
    [sym_local_var] = ACTIONS(367),
    [aux_sym_metadata_ref_token1] = ACTIONS(367),
    [sym_string] = ACTIONS(367),
    [aux_sym_number_token1] = ACTIONS(369),
    [aux_sym_number_token2] = ACTIONS(367),
    [sym_float] = ACTIONS(367),
    [sym_cstring] = ACTIONS(367),
    [anon_sym_no_cfi] = ACTIONS(367),
    [anon_sym_private] = ACTIONS(367),
    [anon_sym_internal] = ACTIONS(367),
    [anon_sym_weak] = ACTIONS(369),
    [anon_sym_weak_odr] = ACTIONS(367),
    [anon_sym_linkonce] = ACTIONS(369),
    [anon_sym_linkonce_odr] = ACTIONS(367),
    [anon_sym_available_externally] = ACTIONS(367),
    [anon_sym_appending] = ACTIONS(367),
    [anon_sym_common] = ACTIONS(367),
    [anon_sym_extern_weak] = ACTIONS(367),
    [anon_sym_external] = ACTIONS(367),
    [anon_sym_dso_local] = ACTIONS(369),
    [anon_sym_dso_local_equivalent] = ACTIONS(367),
    [anon_sym_dso_preemptable] = ACTIONS(367),
    [anon_sym_default] = ACTIONS(367),
    [anon_sym_hidden] = ACTIONS(367),
    [anon_sym_protected] = ACTIONS(367),
    [anon_sym_dllimport] = ACTIONS(367),
    [anon_sym_dllexport] = ACTIONS(367),
    [anon_sym_ccc] = ACTIONS(367),
    [anon_sym_fastcc] = ACTIONS(367),
    [anon_sym_coldcc] = ACTIONS(367),
    [anon_sym_webkit_jscc] = ACTIONS(369),
    [anon_sym_anyregcc] = ACTIONS(367),
    [anon_sym_preserve_mostcc] = ACTIONS(367),
    [anon_sym_preserve_allcc] = ACTIONS(367),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(369),
    [anon_sym_tailcc] = ACTIONS(367),
    [anon_sym_swiftcc] = ACTIONS(369),
    [anon_sym_swifttailcc] = ACTIONS(369),
    [anon_sym_cfguard_checkcc] = ACTIONS(367),
    [aux_sym_calling_conv_token1] = ACTIONS(369),
    [aux_sym_calling_conv_token2] = ACTIONS(367),
    [aux_sym_calling_conv_token3] = ACTIONS(367),
    [aux_sym_calling_conv_token4] = ACTIONS(367),
    [aux_sym_calling_conv_token5] = ACTIONS(367),
    [aux_sym_calling_conv_token6] = ACTIONS(367),
    [aux_sym_calling_conv_token7] = ACTIONS(367),
    [aux_sym_calling_conv_token8] = ACTIONS(367),
    [aux_sym_calling_conv_token9] = ACTIONS(367),
    [aux_sym_calling_conv_token10] = ACTIONS(369),
    [anon_sym_ghccc] = ACTIONS(367),
    [aux_sym_calling_conv_token11] = ACTIONS(369),
    [aux_sym_calling_conv_token12] = ACTIONS(367),
    [aux_sym_calling_conv_token13] = ACTIONS(369),
    [aux_sym_calling_conv_token14] = ACTIONS(367),
    [anon_sym_cc] = ACTIONS(369),
    [anon_sym_unnamed_addr] = ACTIONS(367),
    [anon_sym_local_unnamed_addr] = ACTIONS(367),
    [anon_sym_STAR] = ACTIONS(367),
    [anon_sym_void] = ACTIONS(367),
    [anon_sym_half] = ACTIONS(367),
    [anon_sym_bfloat] = ACTIONS(367),
    [anon_sym_float] = ACTIONS(367),
    [anon_sym_double] = ACTIONS(367),
    [anon_sym_x86_fp80] = ACTIONS(369),
    [anon_sym_fp128] = ACTIONS(367),
    [anon_sym_ppc_fp128] = ACTIONS(367),
    [anon_sym_label] = ACTIONS(367),
    [anon_sym_metadata] = ACTIONS(367),
    [anon_sym_x86_mmx] = ACTIONS(369),
    [anon_sym_x86_amx] = ACTIONS(369),
    [anon_sym_token] = ACTIONS(367),
    [anon_sym_opaque] = ACTIONS(367),
    [anon_sym_ptr] = ACTIONS(369),
    [aux_sym_type_keyword_token1] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(367),
    [anon_sym_LT_LBRACE] = ACTIONS(367),
    [anon_sym_RBRACE_GT] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_COMMA] = ACTIONS(367),
    [anon_sym_addrspace] = ACTIONS(369),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_align] = ACTIONS(369),
    [anon_sym_alignstack] = ACTIONS(367),
    [anon_sym_allocsize] = ACTIONS(367),
    [anon_sym_alwaysinline] = ACTIONS(367),
    [anon_sym_builtin] = ACTIONS(367),
    [anon_sym_cold] = ACTIONS(369),
    [anon_sym_convergent] = ACTIONS(367),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(367),
    [anon_sym_hot] = ACTIONS(367),
    [anon_sym_inaccessiblememonly] = ACTIONS(367),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(367),
    [anon_sym_inlinehint] = ACTIONS(367),
    [anon_sym_jumptable] = ACTIONS(367),
    [anon_sym_minsize] = ACTIONS(367),
    [anon_sym_naked] = ACTIONS(367),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(367),
    [anon_sym_nobuiltin] = ACTIONS(367),
    [anon_sym_noduplicate] = ACTIONS(367),
    [anon_sym_nofree] = ACTIONS(367),
    [anon_sym_noimplicitfloat] = ACTIONS(367),
    [anon_sym_noinline] = ACTIONS(367),
    [anon_sym_nomerge] = ACTIONS(367),
    [anon_sym_nonlazybind] = ACTIONS(367),
    [anon_sym_noprofile] = ACTIONS(367),
    [anon_sym_noredzone] = ACTIONS(367),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(367),
    [anon_sym_noreturn] = ACTIONS(367),
    [anon_sym_norecurse] = ACTIONS(367),
    [anon_sym_willreturn] = ACTIONS(367),
    [anon_sym_nosync] = ACTIONS(367),
    [anon_sym_nounwind] = ACTIONS(367),
    [anon_sym_nocallback] = ACTIONS(367),
    [anon_sym_nosanitize_coverage] = ACTIONS(367),
    [anon_sym_null_pointer_is_valid] = ACTIONS(367),
    [anon_sym_optforfuzzing] = ACTIONS(367),
    [anon_sym_optnone] = ACTIONS(367),
    [anon_sym_optsize] = ACTIONS(367),
    [anon_sym_readnone] = ACTIONS(367),
    [anon_sym_readonly] = ACTIONS(367),
    [anon_sym_writeonly] = ACTIONS(367),
    [anon_sym_argmemonly] = ACTIONS(367),
    [anon_sym_returns_twice] = ACTIONS(367),
    [anon_sym_safestack] = ACTIONS(367),
    [anon_sym_sanitize_address] = ACTIONS(367),
    [anon_sym_sanitize_memory] = ACTIONS(367),
    [anon_sym_sanitize_thread] = ACTIONS(367),
    [anon_sym_sanitize_hwaddress] = ACTIONS(367),
    [anon_sym_sanitize_memtag] = ACTIONS(367),
    [anon_sym_speculative_load_hardening] = ACTIONS(367),
    [anon_sym_speculatable] = ACTIONS(367),
    [anon_sym_ssp] = ACTIONS(369),
    [anon_sym_sspstrong] = ACTIONS(367),
    [anon_sym_sspreq] = ACTIONS(367),
    [anon_sym_strictfp] = ACTIONS(367),
    [anon_sym_nocf_check] = ACTIONS(367),
    [anon_sym_shadowcallstack] = ACTIONS(367),
    [anon_sym_mustprogress] = ACTIONS(367),
    [anon_sym_vscale_range] = ACTIONS(367),
    [anon_sym_preallocated] = ACTIONS(367),
    [anon_sym_zeroext] = ACTIONS(367),
    [anon_sym_signext] = ACTIONS(367),
    [anon_sym_inreg] = ACTIONS(367),
    [anon_sym_byval] = ACTIONS(367),
    [anon_sym_byref] = ACTIONS(367),
    [anon_sym_inalloca] = ACTIONS(367),
    [anon_sym_sret] = ACTIONS(367),
    [anon_sym_elementtype] = ACTIONS(367),
    [anon_sym_noalias] = ACTIONS(367),
    [anon_sym_nocapture] = ACTIONS(367),
    [anon_sym_nest] = ACTIONS(367),
    [anon_sym_returned] = ACTIONS(367),
    [anon_sym_nonnull] = ACTIONS(367),
    [anon_sym_dereferenceable] = ACTIONS(369),
    [anon_sym_dereferenceable_or_null] = ACTIONS(367),
    [anon_sym_swiftself] = ACTIONS(369),
    [anon_sym_swiftasync] = ACTIONS(369),
    [anon_sym_swifterror] = ACTIONS(369),
    [anon_sym_immarg] = ACTIONS(367),
    [anon_sym_noundef] = ACTIONS(367),
    [anon_sym_uwtable] = ACTIONS(367),
    [anon_sym_memory] = ACTIONS(367),
    [anon_sym_none] = ACTIONS(367),
    [anon_sym_extractelement] = ACTIONS(367),
    [anon_sym_insertelement] = ACTIONS(367),
    [anon_sym_select] = ACTIONS(367),
    [anon_sym_shufflevector] = ACTIONS(367),
    [anon_sym_fneg] = ACTIONS(367),
    [anon_sym_icmp] = ACTIONS(367),
    [anon_sym_fcmp] = ACTIONS(367),
    [anon_sym_getelementptr] = ACTIONS(367),
    [anon_sym_extractvalue] = ACTIONS(367),
    [anon_sym_insertvalue] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(367),
    [anon_sym_false] = ACTIONS(367),
    [anon_sym_null] = ACTIONS(369),
    [anon_sym_undef] = ACTIONS(367),
    [anon_sym_poison] = ACTIONS(367),
    [anon_sym_zeroinitializer] = ACTIONS(367),
    [anon_sym_blockaddress] = ACTIONS(367),
    [anon_sym_mul] = ACTIONS(367),
    [anon_sym_urem] = ACTIONS(367),
    [anon_sym_srem] = ACTIONS(367),
    [anon_sym_shl] = ACTIONS(367),
    [anon_sym_udiv] = ACTIONS(367),
    [anon_sym_sdiv] = ACTIONS(367),
    [anon_sym_lshr] = ACTIONS(367),
    [anon_sym_ashr] = ACTIONS(367),
    [anon_sym_fmul] = ACTIONS(367),
    [anon_sym_fdiv] = ACTIONS(367),
    [anon_sym_frem] = ACTIONS(367),
    [anon_sym_xchg] = ACTIONS(367),
    [anon_sym_add] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(367),
    [anon_sym_and] = ACTIONS(367),
    [anon_sym_nand] = ACTIONS(367),
    [anon_sym_or] = ACTIONS(367),
    [anon_sym_xor] = ACTIONS(367),
    [anon_sym_max] = ACTIONS(367),
    [anon_sym_min] = ACTIONS(369),
    [anon_sym_umax] = ACTIONS(367),
    [anon_sym_umin] = ACTIONS(367),
    [anon_sym_fadd] = ACTIONS(367),
    [anon_sym_fsub] = ACTIONS(367),
    [anon_sym_bitcast] = ACTIONS(367),
    [anon_sym_trunc] = ACTIONS(367),
    [anon_sym_zext] = ACTIONS(367),
    [anon_sym_sext] = ACTIONS(367),
    [anon_sym_fptrunc] = ACTIONS(367),
    [anon_sym_fpext] = ACTIONS(367),
    [anon_sym_addrspacecast] = ACTIONS(367),
    [anon_sym_uitofp] = ACTIONS(367),
    [anon_sym_sitofp] = ACTIONS(367),
    [anon_sym_fptoui] = ACTIONS(367),
    [anon_sym_fptosi] = ACTIONS(367),
    [anon_sym_inttoptr] = ACTIONS(367),
    [anon_sym_ptrtoint] = ACTIONS(367),
  },
  [21] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(371),
    [sym_local_var] = ACTIONS(371),
    [aux_sym_metadata_ref_token1] = ACTIONS(371),
    [sym_string] = ACTIONS(371),
    [aux_sym_number_token1] = ACTIONS(373),
    [aux_sym_number_token2] = ACTIONS(371),
    [sym_float] = ACTIONS(371),
    [sym_cstring] = ACTIONS(371),
    [anon_sym_no_cfi] = ACTIONS(371),
    [anon_sym_private] = ACTIONS(371),
    [anon_sym_internal] = ACTIONS(371),
    [anon_sym_weak] = ACTIONS(373),
    [anon_sym_weak_odr] = ACTIONS(371),
    [anon_sym_linkonce] = ACTIONS(373),
    [anon_sym_linkonce_odr] = ACTIONS(371),
    [anon_sym_available_externally] = ACTIONS(371),
    [anon_sym_appending] = ACTIONS(371),
    [anon_sym_common] = ACTIONS(371),
    [anon_sym_extern_weak] = ACTIONS(371),
    [anon_sym_external] = ACTIONS(371),
    [anon_sym_dso_local] = ACTIONS(373),
    [anon_sym_dso_local_equivalent] = ACTIONS(371),
    [anon_sym_dso_preemptable] = ACTIONS(371),
    [anon_sym_default] = ACTIONS(371),
    [anon_sym_hidden] = ACTIONS(371),
    [anon_sym_protected] = ACTIONS(371),
    [anon_sym_dllimport] = ACTIONS(371),
    [anon_sym_dllexport] = ACTIONS(371),
    [anon_sym_ccc] = ACTIONS(371),
    [anon_sym_fastcc] = ACTIONS(371),
    [anon_sym_coldcc] = ACTIONS(371),
    [anon_sym_webkit_jscc] = ACTIONS(373),
    [anon_sym_anyregcc] = ACTIONS(371),
    [anon_sym_preserve_mostcc] = ACTIONS(371),
    [anon_sym_preserve_allcc] = ACTIONS(371),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(373),
    [anon_sym_tailcc] = ACTIONS(371),
    [anon_sym_swiftcc] = ACTIONS(373),
    [anon_sym_swifttailcc] = ACTIONS(373),
    [anon_sym_cfguard_checkcc] = ACTIONS(371),
    [aux_sym_calling_conv_token1] = ACTIONS(373),
    [aux_sym_calling_conv_token2] = ACTIONS(371),
    [aux_sym_calling_conv_token3] = ACTIONS(371),
    [aux_sym_calling_conv_token4] = ACTIONS(371),
    [aux_sym_calling_conv_token5] = ACTIONS(371),
    [aux_sym_calling_conv_token6] = ACTIONS(371),
    [aux_sym_calling_conv_token7] = ACTIONS(371),
    [aux_sym_calling_conv_token8] = ACTIONS(371),
    [aux_sym_calling_conv_token9] = ACTIONS(371),
    [aux_sym_calling_conv_token10] = ACTIONS(373),
    [anon_sym_ghccc] = ACTIONS(371),
    [aux_sym_calling_conv_token11] = ACTIONS(373),
    [aux_sym_calling_conv_token12] = ACTIONS(371),
    [aux_sym_calling_conv_token13] = ACTIONS(373),
    [aux_sym_calling_conv_token14] = ACTIONS(371),
    [anon_sym_cc] = ACTIONS(373),
    [anon_sym_unnamed_addr] = ACTIONS(371),
    [anon_sym_local_unnamed_addr] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_void] = ACTIONS(371),
    [anon_sym_half] = ACTIONS(371),
    [anon_sym_bfloat] = ACTIONS(371),
    [anon_sym_float] = ACTIONS(371),
    [anon_sym_double] = ACTIONS(371),
    [anon_sym_x86_fp80] = ACTIONS(373),
    [anon_sym_fp128] = ACTIONS(371),
    [anon_sym_ppc_fp128] = ACTIONS(371),
    [anon_sym_label] = ACTIONS(371),
    [anon_sym_metadata] = ACTIONS(371),
    [anon_sym_x86_mmx] = ACTIONS(373),
    [anon_sym_x86_amx] = ACTIONS(373),
    [anon_sym_token] = ACTIONS(371),
    [anon_sym_opaque] = ACTIONS(371),
    [anon_sym_ptr] = ACTIONS(373),
    [aux_sym_type_keyword_token1] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_LT_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE_GT] = ACTIONS(371),
    [anon_sym_LBRACK] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_COMMA] = ACTIONS(371),
    [anon_sym_addrspace] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_align] = ACTIONS(373),
    [anon_sym_alignstack] = ACTIONS(371),
    [anon_sym_allocsize] = ACTIONS(371),
    [anon_sym_alwaysinline] = ACTIONS(371),
    [anon_sym_builtin] = ACTIONS(371),
    [anon_sym_cold] = ACTIONS(373),
    [anon_sym_convergent] = ACTIONS(371),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(371),
    [anon_sym_hot] = ACTIONS(371),
    [anon_sym_inaccessiblememonly] = ACTIONS(371),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(371),
    [anon_sym_inlinehint] = ACTIONS(371),
    [anon_sym_jumptable] = ACTIONS(371),
    [anon_sym_minsize] = ACTIONS(371),
    [anon_sym_naked] = ACTIONS(371),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(371),
    [anon_sym_nobuiltin] = ACTIONS(371),
    [anon_sym_noduplicate] = ACTIONS(371),
    [anon_sym_nofree] = ACTIONS(371),
    [anon_sym_noimplicitfloat] = ACTIONS(371),
    [anon_sym_noinline] = ACTIONS(371),
    [anon_sym_nomerge] = ACTIONS(371),
    [anon_sym_nonlazybind] = ACTIONS(371),
    [anon_sym_noprofile] = ACTIONS(371),
    [anon_sym_noredzone] = ACTIONS(371),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(371),
    [anon_sym_noreturn] = ACTIONS(371),
    [anon_sym_norecurse] = ACTIONS(371),
    [anon_sym_willreturn] = ACTIONS(371),
    [anon_sym_nosync] = ACTIONS(371),
    [anon_sym_nounwind] = ACTIONS(371),
    [anon_sym_nocallback] = ACTIONS(371),
    [anon_sym_nosanitize_coverage] = ACTIONS(371),
    [anon_sym_null_pointer_is_valid] = ACTIONS(371),
    [anon_sym_optforfuzzing] = ACTIONS(371),
    [anon_sym_optnone] = ACTIONS(371),
    [anon_sym_optsize] = ACTIONS(371),
    [anon_sym_readnone] = ACTIONS(371),
    [anon_sym_readonly] = ACTIONS(371),
    [anon_sym_writeonly] = ACTIONS(371),
    [anon_sym_argmemonly] = ACTIONS(371),
    [anon_sym_returns_twice] = ACTIONS(371),
    [anon_sym_safestack] = ACTIONS(371),
    [anon_sym_sanitize_address] = ACTIONS(371),
    [anon_sym_sanitize_memory] = ACTIONS(371),
    [anon_sym_sanitize_thread] = ACTIONS(371),
    [anon_sym_sanitize_hwaddress] = ACTIONS(371),
    [anon_sym_sanitize_memtag] = ACTIONS(371),
    [anon_sym_speculative_load_hardening] = ACTIONS(371),
    [anon_sym_speculatable] = ACTIONS(371),
    [anon_sym_ssp] = ACTIONS(373),
    [anon_sym_sspstrong] = ACTIONS(371),
    [anon_sym_sspreq] = ACTIONS(371),
    [anon_sym_strictfp] = ACTIONS(371),
    [anon_sym_nocf_check] = ACTIONS(371),
    [anon_sym_shadowcallstack] = ACTIONS(371),
    [anon_sym_mustprogress] = ACTIONS(371),
    [anon_sym_vscale_range] = ACTIONS(371),
    [anon_sym_preallocated] = ACTIONS(371),
    [anon_sym_zeroext] = ACTIONS(371),
    [anon_sym_signext] = ACTIONS(371),
    [anon_sym_inreg] = ACTIONS(371),
    [anon_sym_byval] = ACTIONS(371),
    [anon_sym_byref] = ACTIONS(371),
    [anon_sym_inalloca] = ACTIONS(371),
    [anon_sym_sret] = ACTIONS(371),
    [anon_sym_elementtype] = ACTIONS(371),
    [anon_sym_noalias] = ACTIONS(371),
    [anon_sym_nocapture] = ACTIONS(371),
    [anon_sym_nest] = ACTIONS(371),
    [anon_sym_returned] = ACTIONS(371),
    [anon_sym_nonnull] = ACTIONS(371),
    [anon_sym_dereferenceable] = ACTIONS(373),
    [anon_sym_dereferenceable_or_null] = ACTIONS(371),
    [anon_sym_swiftself] = ACTIONS(373),
    [anon_sym_swiftasync] = ACTIONS(373),
    [anon_sym_swifterror] = ACTIONS(373),
    [anon_sym_immarg] = ACTIONS(371),
    [anon_sym_noundef] = ACTIONS(371),
    [anon_sym_uwtable] = ACTIONS(371),
    [anon_sym_memory] = ACTIONS(371),
    [anon_sym_none] = ACTIONS(371),
    [anon_sym_extractelement] = ACTIONS(371),
    [anon_sym_insertelement] = ACTIONS(371),
    [anon_sym_select] = ACTIONS(371),
    [anon_sym_shufflevector] = ACTIONS(371),
    [anon_sym_fneg] = ACTIONS(371),
    [anon_sym_icmp] = ACTIONS(371),
    [anon_sym_fcmp] = ACTIONS(371),
    [anon_sym_getelementptr] = ACTIONS(371),
    [anon_sym_extractvalue] = ACTIONS(371),
    [anon_sym_insertvalue] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(371),
    [anon_sym_false] = ACTIONS(371),
    [anon_sym_null] = ACTIONS(373),
    [anon_sym_undef] = ACTIONS(371),
    [anon_sym_poison] = ACTIONS(371),
    [anon_sym_zeroinitializer] = ACTIONS(371),
    [anon_sym_blockaddress] = ACTIONS(371),
    [anon_sym_mul] = ACTIONS(371),
    [anon_sym_urem] = ACTIONS(371),
    [anon_sym_srem] = ACTIONS(371),
    [anon_sym_shl] = ACTIONS(371),
    [anon_sym_udiv] = ACTIONS(371),
    [anon_sym_sdiv] = ACTIONS(371),
    [anon_sym_lshr] = ACTIONS(371),
    [anon_sym_ashr] = ACTIONS(371),
    [anon_sym_fmul] = ACTIONS(371),
    [anon_sym_fdiv] = ACTIONS(371),
    [anon_sym_frem] = ACTIONS(371),
    [anon_sym_xchg] = ACTIONS(371),
    [anon_sym_add] = ACTIONS(373),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_and] = ACTIONS(371),
    [anon_sym_nand] = ACTIONS(371),
    [anon_sym_or] = ACTIONS(371),
    [anon_sym_xor] = ACTIONS(371),
    [anon_sym_max] = ACTIONS(371),
    [anon_sym_min] = ACTIONS(373),
    [anon_sym_umax] = ACTIONS(371),
    [anon_sym_umin] = ACTIONS(371),
    [anon_sym_fadd] = ACTIONS(371),
    [anon_sym_fsub] = ACTIONS(371),
    [anon_sym_bitcast] = ACTIONS(371),
    [anon_sym_trunc] = ACTIONS(371),
    [anon_sym_zext] = ACTIONS(371),
    [anon_sym_sext] = ACTIONS(371),
    [anon_sym_fptrunc] = ACTIONS(371),
    [anon_sym_fpext] = ACTIONS(371),
    [anon_sym_addrspacecast] = ACTIONS(371),
    [anon_sym_uitofp] = ACTIONS(371),
    [anon_sym_sitofp] = ACTIONS(371),
    [anon_sym_fptoui] = ACTIONS(371),
    [anon_sym_fptosi] = ACTIONS(371),
    [anon_sym_inttoptr] = ACTIONS(371),
    [anon_sym_ptrtoint] = ACTIONS(371),
  },
  [22] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(375),
    [sym_local_var] = ACTIONS(375),
    [aux_sym_metadata_ref_token1] = ACTIONS(375),
    [sym_string] = ACTIONS(375),
    [aux_sym_number_token1] = ACTIONS(377),
    [aux_sym_number_token2] = ACTIONS(375),
    [sym_float] = ACTIONS(375),
    [sym_cstring] = ACTIONS(375),
    [anon_sym_no_cfi] = ACTIONS(375),
    [anon_sym_private] = ACTIONS(375),
    [anon_sym_internal] = ACTIONS(375),
    [anon_sym_weak] = ACTIONS(377),
    [anon_sym_weak_odr] = ACTIONS(375),
    [anon_sym_linkonce] = ACTIONS(377),
    [anon_sym_linkonce_odr] = ACTIONS(375),
    [anon_sym_available_externally] = ACTIONS(375),
    [anon_sym_appending] = ACTIONS(375),
    [anon_sym_common] = ACTIONS(375),
    [anon_sym_extern_weak] = ACTIONS(375),
    [anon_sym_external] = ACTIONS(375),
    [anon_sym_dso_local] = ACTIONS(377),
    [anon_sym_dso_local_equivalent] = ACTIONS(375),
    [anon_sym_dso_preemptable] = ACTIONS(375),
    [anon_sym_default] = ACTIONS(375),
    [anon_sym_hidden] = ACTIONS(375),
    [anon_sym_protected] = ACTIONS(375),
    [anon_sym_dllimport] = ACTIONS(375),
    [anon_sym_dllexport] = ACTIONS(375),
    [anon_sym_ccc] = ACTIONS(375),
    [anon_sym_fastcc] = ACTIONS(375),
    [anon_sym_coldcc] = ACTIONS(375),
    [anon_sym_webkit_jscc] = ACTIONS(377),
    [anon_sym_anyregcc] = ACTIONS(375),
    [anon_sym_preserve_mostcc] = ACTIONS(375),
    [anon_sym_preserve_allcc] = ACTIONS(375),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(377),
    [anon_sym_tailcc] = ACTIONS(375),
    [anon_sym_swiftcc] = ACTIONS(377),
    [anon_sym_swifttailcc] = ACTIONS(377),
    [anon_sym_cfguard_checkcc] = ACTIONS(375),
    [aux_sym_calling_conv_token1] = ACTIONS(377),
    [aux_sym_calling_conv_token2] = ACTIONS(375),
    [aux_sym_calling_conv_token3] = ACTIONS(375),
    [aux_sym_calling_conv_token4] = ACTIONS(375),
    [aux_sym_calling_conv_token5] = ACTIONS(375),
    [aux_sym_calling_conv_token6] = ACTIONS(375),
    [aux_sym_calling_conv_token7] = ACTIONS(375),
    [aux_sym_calling_conv_token8] = ACTIONS(375),
    [aux_sym_calling_conv_token9] = ACTIONS(375),
    [aux_sym_calling_conv_token10] = ACTIONS(377),
    [anon_sym_ghccc] = ACTIONS(375),
    [aux_sym_calling_conv_token11] = ACTIONS(377),
    [aux_sym_calling_conv_token12] = ACTIONS(375),
    [aux_sym_calling_conv_token13] = ACTIONS(377),
    [aux_sym_calling_conv_token14] = ACTIONS(375),
    [anon_sym_cc] = ACTIONS(377),
    [anon_sym_unnamed_addr] = ACTIONS(375),
    [anon_sym_local_unnamed_addr] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(375),
    [anon_sym_void] = ACTIONS(375),
    [anon_sym_half] = ACTIONS(375),
    [anon_sym_bfloat] = ACTIONS(375),
    [anon_sym_float] = ACTIONS(375),
    [anon_sym_double] = ACTIONS(375),
    [anon_sym_x86_fp80] = ACTIONS(377),
    [anon_sym_fp128] = ACTIONS(375),
    [anon_sym_ppc_fp128] = ACTIONS(375),
    [anon_sym_label] = ACTIONS(375),
    [anon_sym_metadata] = ACTIONS(375),
    [anon_sym_x86_mmx] = ACTIONS(377),
    [anon_sym_x86_amx] = ACTIONS(377),
    [anon_sym_token] = ACTIONS(375),
    [anon_sym_opaque] = ACTIONS(375),
    [anon_sym_ptr] = ACTIONS(377),
    [aux_sym_type_keyword_token1] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(375),
    [anon_sym_LT_LBRACE] = ACTIONS(375),
    [anon_sym_RBRACE_GT] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_COMMA] = ACTIONS(375),
    [anon_sym_addrspace] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_align] = ACTIONS(377),
    [anon_sym_alignstack] = ACTIONS(375),
    [anon_sym_allocsize] = ACTIONS(375),
    [anon_sym_alwaysinline] = ACTIONS(375),
    [anon_sym_builtin] = ACTIONS(375),
    [anon_sym_cold] = ACTIONS(377),
    [anon_sym_convergent] = ACTIONS(375),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(375),
    [anon_sym_hot] = ACTIONS(375),
    [anon_sym_inaccessiblememonly] = ACTIONS(375),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(375),
    [anon_sym_inlinehint] = ACTIONS(375),
    [anon_sym_jumptable] = ACTIONS(375),
    [anon_sym_minsize] = ACTIONS(375),
    [anon_sym_naked] = ACTIONS(375),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(375),
    [anon_sym_nobuiltin] = ACTIONS(375),
    [anon_sym_noduplicate] = ACTIONS(375),
    [anon_sym_nofree] = ACTIONS(375),
    [anon_sym_noimplicitfloat] = ACTIONS(375),
    [anon_sym_noinline] = ACTIONS(375),
    [anon_sym_nomerge] = ACTIONS(375),
    [anon_sym_nonlazybind] = ACTIONS(375),
    [anon_sym_noprofile] = ACTIONS(375),
    [anon_sym_noredzone] = ACTIONS(375),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(375),
    [anon_sym_noreturn] = ACTIONS(375),
    [anon_sym_norecurse] = ACTIONS(375),
    [anon_sym_willreturn] = ACTIONS(375),
    [anon_sym_nosync] = ACTIONS(375),
    [anon_sym_nounwind] = ACTIONS(375),
    [anon_sym_nocallback] = ACTIONS(375),
    [anon_sym_nosanitize_coverage] = ACTIONS(375),
    [anon_sym_null_pointer_is_valid] = ACTIONS(375),
    [anon_sym_optforfuzzing] = ACTIONS(375),
    [anon_sym_optnone] = ACTIONS(375),
    [anon_sym_optsize] = ACTIONS(375),
    [anon_sym_readnone] = ACTIONS(375),
    [anon_sym_readonly] = ACTIONS(375),
    [anon_sym_writeonly] = ACTIONS(375),
    [anon_sym_argmemonly] = ACTIONS(375),
    [anon_sym_returns_twice] = ACTIONS(375),
    [anon_sym_safestack] = ACTIONS(375),
    [anon_sym_sanitize_address] = ACTIONS(375),
    [anon_sym_sanitize_memory] = ACTIONS(375),
    [anon_sym_sanitize_thread] = ACTIONS(375),
    [anon_sym_sanitize_hwaddress] = ACTIONS(375),
    [anon_sym_sanitize_memtag] = ACTIONS(375),
    [anon_sym_speculative_load_hardening] = ACTIONS(375),
    [anon_sym_speculatable] = ACTIONS(375),
    [anon_sym_ssp] = ACTIONS(377),
    [anon_sym_sspstrong] = ACTIONS(375),
    [anon_sym_sspreq] = ACTIONS(375),
    [anon_sym_strictfp] = ACTIONS(375),
    [anon_sym_nocf_check] = ACTIONS(375),
    [anon_sym_shadowcallstack] = ACTIONS(375),
    [anon_sym_mustprogress] = ACTIONS(375),
    [anon_sym_vscale_range] = ACTIONS(375),
    [anon_sym_preallocated] = ACTIONS(375),
    [anon_sym_zeroext] = ACTIONS(375),
    [anon_sym_signext] = ACTIONS(375),
    [anon_sym_inreg] = ACTIONS(375),
    [anon_sym_byval] = ACTIONS(375),
    [anon_sym_byref] = ACTIONS(375),
    [anon_sym_inalloca] = ACTIONS(375),
    [anon_sym_sret] = ACTIONS(375),
    [anon_sym_elementtype] = ACTIONS(375),
    [anon_sym_noalias] = ACTIONS(375),
    [anon_sym_nocapture] = ACTIONS(375),
    [anon_sym_nest] = ACTIONS(375),
    [anon_sym_returned] = ACTIONS(375),
    [anon_sym_nonnull] = ACTIONS(375),
    [anon_sym_dereferenceable] = ACTIONS(377),
    [anon_sym_dereferenceable_or_null] = ACTIONS(375),
    [anon_sym_swiftself] = ACTIONS(377),
    [anon_sym_swiftasync] = ACTIONS(377),
    [anon_sym_swifterror] = ACTIONS(377),
    [anon_sym_immarg] = ACTIONS(375),
    [anon_sym_noundef] = ACTIONS(375),
    [anon_sym_uwtable] = ACTIONS(375),
    [anon_sym_memory] = ACTIONS(375),
    [anon_sym_none] = ACTIONS(375),
    [anon_sym_extractelement] = ACTIONS(375),
    [anon_sym_insertelement] = ACTIONS(375),
    [anon_sym_select] = ACTIONS(375),
    [anon_sym_shufflevector] = ACTIONS(375),
    [anon_sym_fneg] = ACTIONS(375),
    [anon_sym_icmp] = ACTIONS(375),
    [anon_sym_fcmp] = ACTIONS(375),
    [anon_sym_getelementptr] = ACTIONS(375),
    [anon_sym_extractvalue] = ACTIONS(375),
    [anon_sym_insertvalue] = ACTIONS(375),
    [anon_sym_true] = ACTIONS(375),
    [anon_sym_false] = ACTIONS(375),
    [anon_sym_null] = ACTIONS(377),
    [anon_sym_undef] = ACTIONS(375),
    [anon_sym_poison] = ACTIONS(375),
    [anon_sym_zeroinitializer] = ACTIONS(375),
    [anon_sym_blockaddress] = ACTIONS(375),
    [anon_sym_mul] = ACTIONS(375),
    [anon_sym_urem] = ACTIONS(375),
    [anon_sym_srem] = ACTIONS(375),
    [anon_sym_shl] = ACTIONS(375),
    [anon_sym_udiv] = ACTIONS(375),
    [anon_sym_sdiv] = ACTIONS(375),
    [anon_sym_lshr] = ACTIONS(375),
    [anon_sym_ashr] = ACTIONS(375),
    [anon_sym_fmul] = ACTIONS(375),
    [anon_sym_fdiv] = ACTIONS(375),
    [anon_sym_frem] = ACTIONS(375),
    [anon_sym_xchg] = ACTIONS(375),
    [anon_sym_add] = ACTIONS(377),
    [anon_sym_sub] = ACTIONS(375),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_nand] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_xor] = ACTIONS(375),
    [anon_sym_max] = ACTIONS(375),
    [anon_sym_min] = ACTIONS(377),
    [anon_sym_umax] = ACTIONS(375),
    [anon_sym_umin] = ACTIONS(375),
    [anon_sym_fadd] = ACTIONS(375),
    [anon_sym_fsub] = ACTIONS(375),
    [anon_sym_bitcast] = ACTIONS(375),
    [anon_sym_trunc] = ACTIONS(375),
    [anon_sym_zext] = ACTIONS(375),
    [anon_sym_sext] = ACTIONS(375),
    [anon_sym_fptrunc] = ACTIONS(375),
    [anon_sym_fpext] = ACTIONS(375),
    [anon_sym_addrspacecast] = ACTIONS(375),
    [anon_sym_uitofp] = ACTIONS(375),
    [anon_sym_sitofp] = ACTIONS(375),
    [anon_sym_fptoui] = ACTIONS(375),
    [anon_sym_fptosi] = ACTIONS(375),
    [anon_sym_inttoptr] = ACTIONS(375),
    [anon_sym_ptrtoint] = ACTIONS(375),
  },
  [23] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(379),
    [sym_local_var] = ACTIONS(379),
    [aux_sym_metadata_ref_token1] = ACTIONS(379),
    [sym_string] = ACTIONS(379),
    [aux_sym_number_token1] = ACTIONS(381),
    [aux_sym_number_token2] = ACTIONS(379),
    [sym_float] = ACTIONS(379),
    [sym_cstring] = ACTIONS(379),
    [anon_sym_no_cfi] = ACTIONS(379),
    [anon_sym_private] = ACTIONS(379),
    [anon_sym_internal] = ACTIONS(379),
    [anon_sym_weak] = ACTIONS(381),
    [anon_sym_weak_odr] = ACTIONS(379),
    [anon_sym_linkonce] = ACTIONS(381),
    [anon_sym_linkonce_odr] = ACTIONS(379),
    [anon_sym_available_externally] = ACTIONS(379),
    [anon_sym_appending] = ACTIONS(379),
    [anon_sym_common] = ACTIONS(379),
    [anon_sym_extern_weak] = ACTIONS(379),
    [anon_sym_external] = ACTIONS(379),
    [anon_sym_dso_local] = ACTIONS(381),
    [anon_sym_dso_local_equivalent] = ACTIONS(379),
    [anon_sym_dso_preemptable] = ACTIONS(379),
    [anon_sym_default] = ACTIONS(379),
    [anon_sym_hidden] = ACTIONS(379),
    [anon_sym_protected] = ACTIONS(379),
    [anon_sym_dllimport] = ACTIONS(379),
    [anon_sym_dllexport] = ACTIONS(379),
    [anon_sym_ccc] = ACTIONS(379),
    [anon_sym_fastcc] = ACTIONS(379),
    [anon_sym_coldcc] = ACTIONS(379),
    [anon_sym_webkit_jscc] = ACTIONS(381),
    [anon_sym_anyregcc] = ACTIONS(379),
    [anon_sym_preserve_mostcc] = ACTIONS(379),
    [anon_sym_preserve_allcc] = ACTIONS(379),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(381),
    [anon_sym_tailcc] = ACTIONS(379),
    [anon_sym_swiftcc] = ACTIONS(381),
    [anon_sym_swifttailcc] = ACTIONS(381),
    [anon_sym_cfguard_checkcc] = ACTIONS(379),
    [aux_sym_calling_conv_token1] = ACTIONS(381),
    [aux_sym_calling_conv_token2] = ACTIONS(379),
    [aux_sym_calling_conv_token3] = ACTIONS(379),
    [aux_sym_calling_conv_token4] = ACTIONS(379),
    [aux_sym_calling_conv_token5] = ACTIONS(379),
    [aux_sym_calling_conv_token6] = ACTIONS(379),
    [aux_sym_calling_conv_token7] = ACTIONS(379),
    [aux_sym_calling_conv_token8] = ACTIONS(379),
    [aux_sym_calling_conv_token9] = ACTIONS(379),
    [aux_sym_calling_conv_token10] = ACTIONS(381),
    [anon_sym_ghccc] = ACTIONS(379),
    [aux_sym_calling_conv_token11] = ACTIONS(381),
    [aux_sym_calling_conv_token12] = ACTIONS(379),
    [aux_sym_calling_conv_token13] = ACTIONS(381),
    [aux_sym_calling_conv_token14] = ACTIONS(379),
    [anon_sym_cc] = ACTIONS(381),
    [anon_sym_unnamed_addr] = ACTIONS(379),
    [anon_sym_local_unnamed_addr] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_void] = ACTIONS(379),
    [anon_sym_half] = ACTIONS(379),
    [anon_sym_bfloat] = ACTIONS(379),
    [anon_sym_float] = ACTIONS(379),
    [anon_sym_double] = ACTIONS(379),
    [anon_sym_x86_fp80] = ACTIONS(381),
    [anon_sym_fp128] = ACTIONS(379),
    [anon_sym_ppc_fp128] = ACTIONS(379),
    [anon_sym_label] = ACTIONS(379),
    [anon_sym_metadata] = ACTIONS(379),
    [anon_sym_x86_mmx] = ACTIONS(381),
    [anon_sym_x86_amx] = ACTIONS(381),
    [anon_sym_token] = ACTIONS(379),
    [anon_sym_opaque] = ACTIONS(379),
    [anon_sym_ptr] = ACTIONS(381),
    [aux_sym_type_keyword_token1] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_LT_LBRACE] = ACTIONS(379),
    [anon_sym_RBRACE_GT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(379),
    [anon_sym_addrspace] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_align] = ACTIONS(381),
    [anon_sym_alignstack] = ACTIONS(379),
    [anon_sym_allocsize] = ACTIONS(379),
    [anon_sym_alwaysinline] = ACTIONS(379),
    [anon_sym_builtin] = ACTIONS(379),
    [anon_sym_cold] = ACTIONS(381),
    [anon_sym_convergent] = ACTIONS(379),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(379),
    [anon_sym_hot] = ACTIONS(379),
    [anon_sym_inaccessiblememonly] = ACTIONS(379),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(379),
    [anon_sym_inlinehint] = ACTIONS(379),
    [anon_sym_jumptable] = ACTIONS(379),
    [anon_sym_minsize] = ACTIONS(379),
    [anon_sym_naked] = ACTIONS(379),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(379),
    [anon_sym_nobuiltin] = ACTIONS(379),
    [anon_sym_noduplicate] = ACTIONS(379),
    [anon_sym_nofree] = ACTIONS(379),
    [anon_sym_noimplicitfloat] = ACTIONS(379),
    [anon_sym_noinline] = ACTIONS(379),
    [anon_sym_nomerge] = ACTIONS(379),
    [anon_sym_nonlazybind] = ACTIONS(379),
    [anon_sym_noprofile] = ACTIONS(379),
    [anon_sym_noredzone] = ACTIONS(379),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(379),
    [anon_sym_noreturn] = ACTIONS(379),
    [anon_sym_norecurse] = ACTIONS(379),
    [anon_sym_willreturn] = ACTIONS(379),
    [anon_sym_nosync] = ACTIONS(379),
    [anon_sym_nounwind] = ACTIONS(379),
    [anon_sym_nocallback] = ACTIONS(379),
    [anon_sym_nosanitize_coverage] = ACTIONS(379),
    [anon_sym_null_pointer_is_valid] = ACTIONS(379),
    [anon_sym_optforfuzzing] = ACTIONS(379),
    [anon_sym_optnone] = ACTIONS(379),
    [anon_sym_optsize] = ACTIONS(379),
    [anon_sym_readnone] = ACTIONS(379),
    [anon_sym_readonly] = ACTIONS(379),
    [anon_sym_writeonly] = ACTIONS(379),
    [anon_sym_argmemonly] = ACTIONS(379),
    [anon_sym_returns_twice] = ACTIONS(379),
    [anon_sym_safestack] = ACTIONS(379),
    [anon_sym_sanitize_address] = ACTIONS(379),
    [anon_sym_sanitize_memory] = ACTIONS(379),
    [anon_sym_sanitize_thread] = ACTIONS(379),
    [anon_sym_sanitize_hwaddress] = ACTIONS(379),
    [anon_sym_sanitize_memtag] = ACTIONS(379),
    [anon_sym_speculative_load_hardening] = ACTIONS(379),
    [anon_sym_speculatable] = ACTIONS(379),
    [anon_sym_ssp] = ACTIONS(381),
    [anon_sym_sspstrong] = ACTIONS(379),
    [anon_sym_sspreq] = ACTIONS(379),
    [anon_sym_strictfp] = ACTIONS(379),
    [anon_sym_nocf_check] = ACTIONS(379),
    [anon_sym_shadowcallstack] = ACTIONS(379),
    [anon_sym_mustprogress] = ACTIONS(379),
    [anon_sym_vscale_range] = ACTIONS(379),
    [anon_sym_preallocated] = ACTIONS(379),
    [anon_sym_zeroext] = ACTIONS(379),
    [anon_sym_signext] = ACTIONS(379),
    [anon_sym_inreg] = ACTIONS(379),
    [anon_sym_byval] = ACTIONS(379),
    [anon_sym_byref] = ACTIONS(379),
    [anon_sym_inalloca] = ACTIONS(379),
    [anon_sym_sret] = ACTIONS(379),
    [anon_sym_elementtype] = ACTIONS(379),
    [anon_sym_noalias] = ACTIONS(379),
    [anon_sym_nocapture] = ACTIONS(379),
    [anon_sym_nest] = ACTIONS(379),
    [anon_sym_returned] = ACTIONS(379),
    [anon_sym_nonnull] = ACTIONS(379),
    [anon_sym_dereferenceable] = ACTIONS(381),
    [anon_sym_dereferenceable_or_null] = ACTIONS(379),
    [anon_sym_swiftself] = ACTIONS(381),
    [anon_sym_swiftasync] = ACTIONS(381),
    [anon_sym_swifterror] = ACTIONS(381),
    [anon_sym_immarg] = ACTIONS(379),
    [anon_sym_noundef] = ACTIONS(379),
    [anon_sym_uwtable] = ACTIONS(379),
    [anon_sym_memory] = ACTIONS(379),
    [anon_sym_none] = ACTIONS(379),
    [anon_sym_extractelement] = ACTIONS(379),
    [anon_sym_insertelement] = ACTIONS(379),
    [anon_sym_select] = ACTIONS(379),
    [anon_sym_shufflevector] = ACTIONS(379),
    [anon_sym_fneg] = ACTIONS(379),
    [anon_sym_icmp] = ACTIONS(379),
    [anon_sym_fcmp] = ACTIONS(379),
    [anon_sym_getelementptr] = ACTIONS(379),
    [anon_sym_extractvalue] = ACTIONS(379),
    [anon_sym_insertvalue] = ACTIONS(379),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [anon_sym_null] = ACTIONS(381),
    [anon_sym_undef] = ACTIONS(379),
    [anon_sym_poison] = ACTIONS(379),
    [anon_sym_zeroinitializer] = ACTIONS(379),
    [anon_sym_blockaddress] = ACTIONS(379),
    [anon_sym_mul] = ACTIONS(379),
    [anon_sym_urem] = ACTIONS(379),
    [anon_sym_srem] = ACTIONS(379),
    [anon_sym_shl] = ACTIONS(379),
    [anon_sym_udiv] = ACTIONS(379),
    [anon_sym_sdiv] = ACTIONS(379),
    [anon_sym_lshr] = ACTIONS(379),
    [anon_sym_ashr] = ACTIONS(379),
    [anon_sym_fmul] = ACTIONS(379),
    [anon_sym_fdiv] = ACTIONS(379),
    [anon_sym_frem] = ACTIONS(379),
    [anon_sym_xchg] = ACTIONS(379),
    [anon_sym_add] = ACTIONS(381),
    [anon_sym_sub] = ACTIONS(379),
    [anon_sym_and] = ACTIONS(379),
    [anon_sym_nand] = ACTIONS(379),
    [anon_sym_or] = ACTIONS(379),
    [anon_sym_xor] = ACTIONS(379),
    [anon_sym_max] = ACTIONS(379),
    [anon_sym_min] = ACTIONS(381),
    [anon_sym_umax] = ACTIONS(379),
    [anon_sym_umin] = ACTIONS(379),
    [anon_sym_fadd] = ACTIONS(379),
    [anon_sym_fsub] = ACTIONS(379),
    [anon_sym_bitcast] = ACTIONS(379),
    [anon_sym_trunc] = ACTIONS(379),
    [anon_sym_zext] = ACTIONS(379),
    [anon_sym_sext] = ACTIONS(379),
    [anon_sym_fptrunc] = ACTIONS(379),
    [anon_sym_fpext] = ACTIONS(379),
    [anon_sym_addrspacecast] = ACTIONS(379),
    [anon_sym_uitofp] = ACTIONS(379),
    [anon_sym_sitofp] = ACTIONS(379),
    [anon_sym_fptoui] = ACTIONS(379),
    [anon_sym_fptosi] = ACTIONS(379),
    [anon_sym_inttoptr] = ACTIONS(379),
    [anon_sym_ptrtoint] = ACTIONS(379),
  },
  [24] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(383),
    [sym_local_var] = ACTIONS(383),
    [aux_sym_metadata_ref_token1] = ACTIONS(383),
    [sym_string] = ACTIONS(383),
    [aux_sym_number_token1] = ACTIONS(385),
    [aux_sym_number_token2] = ACTIONS(383),
    [sym_float] = ACTIONS(383),
    [sym_cstring] = ACTIONS(383),
    [anon_sym_no_cfi] = ACTIONS(383),
    [anon_sym_private] = ACTIONS(383),
    [anon_sym_internal] = ACTIONS(383),
    [anon_sym_weak] = ACTIONS(385),
    [anon_sym_weak_odr] = ACTIONS(383),
    [anon_sym_linkonce] = ACTIONS(385),
    [anon_sym_linkonce_odr] = ACTIONS(383),
    [anon_sym_available_externally] = ACTIONS(383),
    [anon_sym_appending] = ACTIONS(383),
    [anon_sym_common] = ACTIONS(383),
    [anon_sym_extern_weak] = ACTIONS(383),
    [anon_sym_external] = ACTIONS(383),
    [anon_sym_dso_local] = ACTIONS(385),
    [anon_sym_dso_local_equivalent] = ACTIONS(383),
    [anon_sym_dso_preemptable] = ACTIONS(383),
    [anon_sym_default] = ACTIONS(383),
    [anon_sym_hidden] = ACTIONS(383),
    [anon_sym_protected] = ACTIONS(383),
    [anon_sym_dllimport] = ACTIONS(383),
    [anon_sym_dllexport] = ACTIONS(383),
    [anon_sym_ccc] = ACTIONS(383),
    [anon_sym_fastcc] = ACTIONS(383),
    [anon_sym_coldcc] = ACTIONS(383),
    [anon_sym_webkit_jscc] = ACTIONS(385),
    [anon_sym_anyregcc] = ACTIONS(383),
    [anon_sym_preserve_mostcc] = ACTIONS(383),
    [anon_sym_preserve_allcc] = ACTIONS(383),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(385),
    [anon_sym_tailcc] = ACTIONS(383),
    [anon_sym_swiftcc] = ACTIONS(385),
    [anon_sym_swifttailcc] = ACTIONS(385),
    [anon_sym_cfguard_checkcc] = ACTIONS(383),
    [aux_sym_calling_conv_token1] = ACTIONS(385),
    [aux_sym_calling_conv_token2] = ACTIONS(383),
    [aux_sym_calling_conv_token3] = ACTIONS(383),
    [aux_sym_calling_conv_token4] = ACTIONS(383),
    [aux_sym_calling_conv_token5] = ACTIONS(383),
    [aux_sym_calling_conv_token6] = ACTIONS(383),
    [aux_sym_calling_conv_token7] = ACTIONS(383),
    [aux_sym_calling_conv_token8] = ACTIONS(383),
    [aux_sym_calling_conv_token9] = ACTIONS(383),
    [aux_sym_calling_conv_token10] = ACTIONS(385),
    [anon_sym_ghccc] = ACTIONS(383),
    [aux_sym_calling_conv_token11] = ACTIONS(385),
    [aux_sym_calling_conv_token12] = ACTIONS(383),
    [aux_sym_calling_conv_token13] = ACTIONS(385),
    [aux_sym_calling_conv_token14] = ACTIONS(383),
    [anon_sym_cc] = ACTIONS(385),
    [anon_sym_unnamed_addr] = ACTIONS(383),
    [anon_sym_local_unnamed_addr] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_void] = ACTIONS(383),
    [anon_sym_half] = ACTIONS(383),
    [anon_sym_bfloat] = ACTIONS(383),
    [anon_sym_float] = ACTIONS(383),
    [anon_sym_double] = ACTIONS(383),
    [anon_sym_x86_fp80] = ACTIONS(385),
    [anon_sym_fp128] = ACTIONS(383),
    [anon_sym_ppc_fp128] = ACTIONS(383),
    [anon_sym_label] = ACTIONS(383),
    [anon_sym_metadata] = ACTIONS(383),
    [anon_sym_x86_mmx] = ACTIONS(385),
    [anon_sym_x86_amx] = ACTIONS(385),
    [anon_sym_token] = ACTIONS(383),
    [anon_sym_opaque] = ACTIONS(383),
    [anon_sym_ptr] = ACTIONS(385),
    [aux_sym_type_keyword_token1] = ACTIONS(383),
    [anon_sym_LBRACE] = ACTIONS(383),
    [anon_sym_LT_LBRACE] = ACTIONS(383),
    [anon_sym_RBRACE_GT] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_addrspace] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_align] = ACTIONS(385),
    [anon_sym_alignstack] = ACTIONS(383),
    [anon_sym_allocsize] = ACTIONS(383),
    [anon_sym_alwaysinline] = ACTIONS(383),
    [anon_sym_builtin] = ACTIONS(383),
    [anon_sym_cold] = ACTIONS(385),
    [anon_sym_convergent] = ACTIONS(383),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(383),
    [anon_sym_hot] = ACTIONS(383),
    [anon_sym_inaccessiblememonly] = ACTIONS(383),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(383),
    [anon_sym_inlinehint] = ACTIONS(383),
    [anon_sym_jumptable] = ACTIONS(383),
    [anon_sym_minsize] = ACTIONS(383),
    [anon_sym_naked] = ACTIONS(383),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(383),
    [anon_sym_nobuiltin] = ACTIONS(383),
    [anon_sym_noduplicate] = ACTIONS(383),
    [anon_sym_nofree] = ACTIONS(383),
    [anon_sym_noimplicitfloat] = ACTIONS(383),
    [anon_sym_noinline] = ACTIONS(383),
    [anon_sym_nomerge] = ACTIONS(383),
    [anon_sym_nonlazybind] = ACTIONS(383),
    [anon_sym_noprofile] = ACTIONS(383),
    [anon_sym_noredzone] = ACTIONS(383),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(383),
    [anon_sym_noreturn] = ACTIONS(383),
    [anon_sym_norecurse] = ACTIONS(383),
    [anon_sym_willreturn] = ACTIONS(383),
    [anon_sym_nosync] = ACTIONS(383),
    [anon_sym_nounwind] = ACTIONS(383),
    [anon_sym_nocallback] = ACTIONS(383),
    [anon_sym_nosanitize_coverage] = ACTIONS(383),
    [anon_sym_null_pointer_is_valid] = ACTIONS(383),
    [anon_sym_optforfuzzing] = ACTIONS(383),
    [anon_sym_optnone] = ACTIONS(383),
    [anon_sym_optsize] = ACTIONS(383),
    [anon_sym_readnone] = ACTIONS(383),
    [anon_sym_readonly] = ACTIONS(383),
    [anon_sym_writeonly] = ACTIONS(383),
    [anon_sym_argmemonly] = ACTIONS(383),
    [anon_sym_returns_twice] = ACTIONS(383),
    [anon_sym_safestack] = ACTIONS(383),
    [anon_sym_sanitize_address] = ACTIONS(383),
    [anon_sym_sanitize_memory] = ACTIONS(383),
    [anon_sym_sanitize_thread] = ACTIONS(383),
    [anon_sym_sanitize_hwaddress] = ACTIONS(383),
    [anon_sym_sanitize_memtag] = ACTIONS(383),
    [anon_sym_speculative_load_hardening] = ACTIONS(383),
    [anon_sym_speculatable] = ACTIONS(383),
    [anon_sym_ssp] = ACTIONS(385),
    [anon_sym_sspstrong] = ACTIONS(383),
    [anon_sym_sspreq] = ACTIONS(383),
    [anon_sym_strictfp] = ACTIONS(383),
    [anon_sym_nocf_check] = ACTIONS(383),
    [anon_sym_shadowcallstack] = ACTIONS(383),
    [anon_sym_mustprogress] = ACTIONS(383),
    [anon_sym_vscale_range] = ACTIONS(383),
    [anon_sym_preallocated] = ACTIONS(383),
    [anon_sym_zeroext] = ACTIONS(383),
    [anon_sym_signext] = ACTIONS(383),
    [anon_sym_inreg] = ACTIONS(383),
    [anon_sym_byval] = ACTIONS(383),
    [anon_sym_byref] = ACTIONS(383),
    [anon_sym_inalloca] = ACTIONS(383),
    [anon_sym_sret] = ACTIONS(383),
    [anon_sym_elementtype] = ACTIONS(383),
    [anon_sym_noalias] = ACTIONS(383),
    [anon_sym_nocapture] = ACTIONS(383),
    [anon_sym_nest] = ACTIONS(383),
    [anon_sym_returned] = ACTIONS(383),
    [anon_sym_nonnull] = ACTIONS(383),
    [anon_sym_dereferenceable] = ACTIONS(385),
    [anon_sym_dereferenceable_or_null] = ACTIONS(383),
    [anon_sym_swiftself] = ACTIONS(385),
    [anon_sym_swiftasync] = ACTIONS(385),
    [anon_sym_swifterror] = ACTIONS(385),
    [anon_sym_immarg] = ACTIONS(383),
    [anon_sym_noundef] = ACTIONS(383),
    [anon_sym_uwtable] = ACTIONS(383),
    [anon_sym_memory] = ACTIONS(383),
    [anon_sym_none] = ACTIONS(383),
    [anon_sym_extractelement] = ACTIONS(383),
    [anon_sym_insertelement] = ACTIONS(383),
    [anon_sym_select] = ACTIONS(383),
    [anon_sym_shufflevector] = ACTIONS(383),
    [anon_sym_fneg] = ACTIONS(383),
    [anon_sym_icmp] = ACTIONS(383),
    [anon_sym_fcmp] = ACTIONS(383),
    [anon_sym_getelementptr] = ACTIONS(383),
    [anon_sym_extractvalue] = ACTIONS(383),
    [anon_sym_insertvalue] = ACTIONS(383),
    [anon_sym_true] = ACTIONS(383),
    [anon_sym_false] = ACTIONS(383),
    [anon_sym_null] = ACTIONS(385),
    [anon_sym_undef] = ACTIONS(383),
    [anon_sym_poison] = ACTIONS(383),
    [anon_sym_zeroinitializer] = ACTIONS(383),
    [anon_sym_blockaddress] = ACTIONS(383),
    [anon_sym_mul] = ACTIONS(383),
    [anon_sym_urem] = ACTIONS(383),
    [anon_sym_srem] = ACTIONS(383),
    [anon_sym_shl] = ACTIONS(383),
    [anon_sym_udiv] = ACTIONS(383),
    [anon_sym_sdiv] = ACTIONS(383),
    [anon_sym_lshr] = ACTIONS(383),
    [anon_sym_ashr] = ACTIONS(383),
    [anon_sym_fmul] = ACTIONS(383),
    [anon_sym_fdiv] = ACTIONS(383),
    [anon_sym_frem] = ACTIONS(383),
    [anon_sym_xchg] = ACTIONS(383),
    [anon_sym_add] = ACTIONS(385),
    [anon_sym_sub] = ACTIONS(383),
    [anon_sym_and] = ACTIONS(383),
    [anon_sym_nand] = ACTIONS(383),
    [anon_sym_or] = ACTIONS(383),
    [anon_sym_xor] = ACTIONS(383),
    [anon_sym_max] = ACTIONS(383),
    [anon_sym_min] = ACTIONS(385),
    [anon_sym_umax] = ACTIONS(383),
    [anon_sym_umin] = ACTIONS(383),
    [anon_sym_fadd] = ACTIONS(383),
    [anon_sym_fsub] = ACTIONS(383),
    [anon_sym_bitcast] = ACTIONS(383),
    [anon_sym_trunc] = ACTIONS(383),
    [anon_sym_zext] = ACTIONS(383),
    [anon_sym_sext] = ACTIONS(383),
    [anon_sym_fptrunc] = ACTIONS(383),
    [anon_sym_fpext] = ACTIONS(383),
    [anon_sym_addrspacecast] = ACTIONS(383),
    [anon_sym_uitofp] = ACTIONS(383),
    [anon_sym_sitofp] = ACTIONS(383),
    [anon_sym_fptoui] = ACTIONS(383),
    [anon_sym_fptosi] = ACTIONS(383),
    [anon_sym_inttoptr] = ACTIONS(383),
    [anon_sym_ptrtoint] = ACTIONS(383),
  },
  [25] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(387),
    [sym_local_var] = ACTIONS(387),
    [aux_sym_metadata_ref_token1] = ACTIONS(387),
    [sym_string] = ACTIONS(387),
    [aux_sym_number_token1] = ACTIONS(389),
    [aux_sym_number_token2] = ACTIONS(387),
    [sym_float] = ACTIONS(387),
    [sym_cstring] = ACTIONS(387),
    [anon_sym_no_cfi] = ACTIONS(387),
    [anon_sym_private] = ACTIONS(387),
    [anon_sym_internal] = ACTIONS(387),
    [anon_sym_weak] = ACTIONS(389),
    [anon_sym_weak_odr] = ACTIONS(387),
    [anon_sym_linkonce] = ACTIONS(389),
    [anon_sym_linkonce_odr] = ACTIONS(387),
    [anon_sym_available_externally] = ACTIONS(387),
    [anon_sym_appending] = ACTIONS(387),
    [anon_sym_common] = ACTIONS(387),
    [anon_sym_extern_weak] = ACTIONS(387),
    [anon_sym_external] = ACTIONS(387),
    [anon_sym_dso_local] = ACTIONS(389),
    [anon_sym_dso_local_equivalent] = ACTIONS(387),
    [anon_sym_dso_preemptable] = ACTIONS(387),
    [anon_sym_default] = ACTIONS(387),
    [anon_sym_hidden] = ACTIONS(387),
    [anon_sym_protected] = ACTIONS(387),
    [anon_sym_dllimport] = ACTIONS(387),
    [anon_sym_dllexport] = ACTIONS(387),
    [anon_sym_ccc] = ACTIONS(387),
    [anon_sym_fastcc] = ACTIONS(387),
    [anon_sym_coldcc] = ACTIONS(387),
    [anon_sym_webkit_jscc] = ACTIONS(389),
    [anon_sym_anyregcc] = ACTIONS(387),
    [anon_sym_preserve_mostcc] = ACTIONS(387),
    [anon_sym_preserve_allcc] = ACTIONS(387),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(389),
    [anon_sym_tailcc] = ACTIONS(387),
    [anon_sym_swiftcc] = ACTIONS(389),
    [anon_sym_swifttailcc] = ACTIONS(389),
    [anon_sym_cfguard_checkcc] = ACTIONS(387),
    [aux_sym_calling_conv_token1] = ACTIONS(389),
    [aux_sym_calling_conv_token2] = ACTIONS(387),
    [aux_sym_calling_conv_token3] = ACTIONS(387),
    [aux_sym_calling_conv_token4] = ACTIONS(387),
    [aux_sym_calling_conv_token5] = ACTIONS(387),
    [aux_sym_calling_conv_token6] = ACTIONS(387),
    [aux_sym_calling_conv_token7] = ACTIONS(387),
    [aux_sym_calling_conv_token8] = ACTIONS(387),
    [aux_sym_calling_conv_token9] = ACTIONS(387),
    [aux_sym_calling_conv_token10] = ACTIONS(389),
    [anon_sym_ghccc] = ACTIONS(387),
    [aux_sym_calling_conv_token11] = ACTIONS(389),
    [aux_sym_calling_conv_token12] = ACTIONS(387),
    [aux_sym_calling_conv_token13] = ACTIONS(389),
    [aux_sym_calling_conv_token14] = ACTIONS(387),
    [anon_sym_cc] = ACTIONS(389),
    [anon_sym_unnamed_addr] = ACTIONS(387),
    [anon_sym_local_unnamed_addr] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(387),
    [anon_sym_void] = ACTIONS(387),
    [anon_sym_half] = ACTIONS(387),
    [anon_sym_bfloat] = ACTIONS(387),
    [anon_sym_float] = ACTIONS(387),
    [anon_sym_double] = ACTIONS(387),
    [anon_sym_x86_fp80] = ACTIONS(389),
    [anon_sym_fp128] = ACTIONS(387),
    [anon_sym_ppc_fp128] = ACTIONS(387),
    [anon_sym_label] = ACTIONS(387),
    [anon_sym_metadata] = ACTIONS(387),
    [anon_sym_x86_mmx] = ACTIONS(389),
    [anon_sym_x86_amx] = ACTIONS(389),
    [anon_sym_token] = ACTIONS(387),
    [anon_sym_opaque] = ACTIONS(387),
    [anon_sym_ptr] = ACTIONS(389),
    [aux_sym_type_keyword_token1] = ACTIONS(387),
    [anon_sym_LBRACE] = ACTIONS(387),
    [anon_sym_LT_LBRACE] = ACTIONS(387),
    [anon_sym_RBRACE_GT] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_COMMA] = ACTIONS(387),
    [anon_sym_addrspace] = ACTIONS(389),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_align] = ACTIONS(389),
    [anon_sym_alignstack] = ACTIONS(387),
    [anon_sym_allocsize] = ACTIONS(387),
    [anon_sym_alwaysinline] = ACTIONS(387),
    [anon_sym_builtin] = ACTIONS(387),
    [anon_sym_cold] = ACTIONS(389),
    [anon_sym_convergent] = ACTIONS(387),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(387),
    [anon_sym_hot] = ACTIONS(387),
    [anon_sym_inaccessiblememonly] = ACTIONS(387),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(387),
    [anon_sym_inlinehint] = ACTIONS(387),
    [anon_sym_jumptable] = ACTIONS(387),
    [anon_sym_minsize] = ACTIONS(387),
    [anon_sym_naked] = ACTIONS(387),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(387),
    [anon_sym_nobuiltin] = ACTIONS(387),
    [anon_sym_noduplicate] = ACTIONS(387),
    [anon_sym_nofree] = ACTIONS(387),
    [anon_sym_noimplicitfloat] = ACTIONS(387),
    [anon_sym_noinline] = ACTIONS(387),
    [anon_sym_nomerge] = ACTIONS(387),
    [anon_sym_nonlazybind] = ACTIONS(387),
    [anon_sym_noprofile] = ACTIONS(387),
    [anon_sym_noredzone] = ACTIONS(387),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(387),
    [anon_sym_noreturn] = ACTIONS(387),
    [anon_sym_norecurse] = ACTIONS(387),
    [anon_sym_willreturn] = ACTIONS(387),
    [anon_sym_nosync] = ACTIONS(387),
    [anon_sym_nounwind] = ACTIONS(387),
    [anon_sym_nocallback] = ACTIONS(387),
    [anon_sym_nosanitize_coverage] = ACTIONS(387),
    [anon_sym_null_pointer_is_valid] = ACTIONS(387),
    [anon_sym_optforfuzzing] = ACTIONS(387),
    [anon_sym_optnone] = ACTIONS(387),
    [anon_sym_optsize] = ACTIONS(387),
    [anon_sym_readnone] = ACTIONS(387),
    [anon_sym_readonly] = ACTIONS(387),
    [anon_sym_writeonly] = ACTIONS(387),
    [anon_sym_argmemonly] = ACTIONS(387),
    [anon_sym_returns_twice] = ACTIONS(387),
    [anon_sym_safestack] = ACTIONS(387),
    [anon_sym_sanitize_address] = ACTIONS(387),
    [anon_sym_sanitize_memory] = ACTIONS(387),
    [anon_sym_sanitize_thread] = ACTIONS(387),
    [anon_sym_sanitize_hwaddress] = ACTIONS(387),
    [anon_sym_sanitize_memtag] = ACTIONS(387),
    [anon_sym_speculative_load_hardening] = ACTIONS(387),
    [anon_sym_speculatable] = ACTIONS(387),
    [anon_sym_ssp] = ACTIONS(389),
    [anon_sym_sspstrong] = ACTIONS(387),
    [anon_sym_sspreq] = ACTIONS(387),
    [anon_sym_strictfp] = ACTIONS(387),
    [anon_sym_nocf_check] = ACTIONS(387),
    [anon_sym_shadowcallstack] = ACTIONS(387),
    [anon_sym_mustprogress] = ACTIONS(387),
    [anon_sym_vscale_range] = ACTIONS(387),
    [anon_sym_preallocated] = ACTIONS(387),
    [anon_sym_zeroext] = ACTIONS(387),
    [anon_sym_signext] = ACTIONS(387),
    [anon_sym_inreg] = ACTIONS(387),
    [anon_sym_byval] = ACTIONS(387),
    [anon_sym_byref] = ACTIONS(387),
    [anon_sym_inalloca] = ACTIONS(387),
    [anon_sym_sret] = ACTIONS(387),
    [anon_sym_elementtype] = ACTIONS(387),
    [anon_sym_noalias] = ACTIONS(387),
    [anon_sym_nocapture] = ACTIONS(387),
    [anon_sym_nest] = ACTIONS(387),
    [anon_sym_returned] = ACTIONS(387),
    [anon_sym_nonnull] = ACTIONS(387),
    [anon_sym_dereferenceable] = ACTIONS(389),
    [anon_sym_dereferenceable_or_null] = ACTIONS(387),
    [anon_sym_swiftself] = ACTIONS(389),
    [anon_sym_swiftasync] = ACTIONS(389),
    [anon_sym_swifterror] = ACTIONS(389),
    [anon_sym_immarg] = ACTIONS(387),
    [anon_sym_noundef] = ACTIONS(387),
    [anon_sym_uwtable] = ACTIONS(387),
    [anon_sym_memory] = ACTIONS(387),
    [anon_sym_none] = ACTIONS(387),
    [anon_sym_extractelement] = ACTIONS(387),
    [anon_sym_insertelement] = ACTIONS(387),
    [anon_sym_select] = ACTIONS(387),
    [anon_sym_shufflevector] = ACTIONS(387),
    [anon_sym_fneg] = ACTIONS(387),
    [anon_sym_icmp] = ACTIONS(387),
    [anon_sym_fcmp] = ACTIONS(387),
    [anon_sym_getelementptr] = ACTIONS(387),
    [anon_sym_extractvalue] = ACTIONS(387),
    [anon_sym_insertvalue] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(387),
    [anon_sym_false] = ACTIONS(387),
    [anon_sym_null] = ACTIONS(389),
    [anon_sym_undef] = ACTIONS(387),
    [anon_sym_poison] = ACTIONS(387),
    [anon_sym_zeroinitializer] = ACTIONS(387),
    [anon_sym_blockaddress] = ACTIONS(387),
    [anon_sym_mul] = ACTIONS(387),
    [anon_sym_urem] = ACTIONS(387),
    [anon_sym_srem] = ACTIONS(387),
    [anon_sym_shl] = ACTIONS(387),
    [anon_sym_udiv] = ACTIONS(387),
    [anon_sym_sdiv] = ACTIONS(387),
    [anon_sym_lshr] = ACTIONS(387),
    [anon_sym_ashr] = ACTIONS(387),
    [anon_sym_fmul] = ACTIONS(387),
    [anon_sym_fdiv] = ACTIONS(387),
    [anon_sym_frem] = ACTIONS(387),
    [anon_sym_xchg] = ACTIONS(387),
    [anon_sym_add] = ACTIONS(389),
    [anon_sym_sub] = ACTIONS(387),
    [anon_sym_and] = ACTIONS(387),
    [anon_sym_nand] = ACTIONS(387),
    [anon_sym_or] = ACTIONS(387),
    [anon_sym_xor] = ACTIONS(387),
    [anon_sym_max] = ACTIONS(387),
    [anon_sym_min] = ACTIONS(389),
    [anon_sym_umax] = ACTIONS(387),
    [anon_sym_umin] = ACTIONS(387),
    [anon_sym_fadd] = ACTIONS(387),
    [anon_sym_fsub] = ACTIONS(387),
    [anon_sym_bitcast] = ACTIONS(387),
    [anon_sym_trunc] = ACTIONS(387),
    [anon_sym_zext] = ACTIONS(387),
    [anon_sym_sext] = ACTIONS(387),
    [anon_sym_fptrunc] = ACTIONS(387),
    [anon_sym_fpext] = ACTIONS(387),
    [anon_sym_addrspacecast] = ACTIONS(387),
    [anon_sym_uitofp] = ACTIONS(387),
    [anon_sym_sitofp] = ACTIONS(387),
    [anon_sym_fptoui] = ACTIONS(387),
    [anon_sym_fptosi] = ACTIONS(387),
    [anon_sym_inttoptr] = ACTIONS(387),
    [anon_sym_ptrtoint] = ACTIONS(387),
  },
  [26] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(391),
    [sym_local_var] = ACTIONS(391),
    [aux_sym_metadata_ref_token1] = ACTIONS(391),
    [sym_string] = ACTIONS(391),
    [aux_sym_number_token1] = ACTIONS(393),
    [aux_sym_number_token2] = ACTIONS(391),
    [sym_float] = ACTIONS(391),
    [sym_cstring] = ACTIONS(391),
    [anon_sym_no_cfi] = ACTIONS(391),
    [anon_sym_private] = ACTIONS(391),
    [anon_sym_internal] = ACTIONS(391),
    [anon_sym_weak] = ACTIONS(393),
    [anon_sym_weak_odr] = ACTIONS(391),
    [anon_sym_linkonce] = ACTIONS(393),
    [anon_sym_linkonce_odr] = ACTIONS(391),
    [anon_sym_available_externally] = ACTIONS(391),
    [anon_sym_appending] = ACTIONS(391),
    [anon_sym_common] = ACTIONS(391),
    [anon_sym_extern_weak] = ACTIONS(391),
    [anon_sym_external] = ACTIONS(391),
    [anon_sym_dso_local] = ACTIONS(393),
    [anon_sym_dso_local_equivalent] = ACTIONS(391),
    [anon_sym_dso_preemptable] = ACTIONS(391),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_hidden] = ACTIONS(391),
    [anon_sym_protected] = ACTIONS(391),
    [anon_sym_dllimport] = ACTIONS(391),
    [anon_sym_dllexport] = ACTIONS(391),
    [anon_sym_ccc] = ACTIONS(391),
    [anon_sym_fastcc] = ACTIONS(391),
    [anon_sym_coldcc] = ACTIONS(391),
    [anon_sym_webkit_jscc] = ACTIONS(393),
    [anon_sym_anyregcc] = ACTIONS(391),
    [anon_sym_preserve_mostcc] = ACTIONS(391),
    [anon_sym_preserve_allcc] = ACTIONS(391),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(393),
    [anon_sym_tailcc] = ACTIONS(391),
    [anon_sym_swiftcc] = ACTIONS(393),
    [anon_sym_swifttailcc] = ACTIONS(393),
    [anon_sym_cfguard_checkcc] = ACTIONS(391),
    [aux_sym_calling_conv_token1] = ACTIONS(393),
    [aux_sym_calling_conv_token2] = ACTIONS(391),
    [aux_sym_calling_conv_token3] = ACTIONS(391),
    [aux_sym_calling_conv_token4] = ACTIONS(391),
    [aux_sym_calling_conv_token5] = ACTIONS(391),
    [aux_sym_calling_conv_token6] = ACTIONS(391),
    [aux_sym_calling_conv_token7] = ACTIONS(391),
    [aux_sym_calling_conv_token8] = ACTIONS(391),
    [aux_sym_calling_conv_token9] = ACTIONS(391),
    [aux_sym_calling_conv_token10] = ACTIONS(393),
    [anon_sym_ghccc] = ACTIONS(391),
    [aux_sym_calling_conv_token11] = ACTIONS(393),
    [aux_sym_calling_conv_token12] = ACTIONS(391),
    [aux_sym_calling_conv_token13] = ACTIONS(393),
    [aux_sym_calling_conv_token14] = ACTIONS(391),
    [anon_sym_cc] = ACTIONS(393),
    [anon_sym_unnamed_addr] = ACTIONS(391),
    [anon_sym_local_unnamed_addr] = ACTIONS(391),
    [anon_sym_STAR] = ACTIONS(391),
    [anon_sym_void] = ACTIONS(391),
    [anon_sym_half] = ACTIONS(391),
    [anon_sym_bfloat] = ACTIONS(391),
    [anon_sym_float] = ACTIONS(391),
    [anon_sym_double] = ACTIONS(391),
    [anon_sym_x86_fp80] = ACTIONS(393),
    [anon_sym_fp128] = ACTIONS(391),
    [anon_sym_ppc_fp128] = ACTIONS(391),
    [anon_sym_label] = ACTIONS(391),
    [anon_sym_metadata] = ACTIONS(391),
    [anon_sym_x86_mmx] = ACTIONS(393),
    [anon_sym_x86_amx] = ACTIONS(393),
    [anon_sym_token] = ACTIONS(391),
    [anon_sym_opaque] = ACTIONS(391),
    [anon_sym_ptr] = ACTIONS(393),
    [aux_sym_type_keyword_token1] = ACTIONS(391),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_LT_LBRACE] = ACTIONS(391),
    [anon_sym_RBRACE_GT] = ACTIONS(391),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LT] = ACTIONS(393),
    [anon_sym_COMMA] = ACTIONS(391),
    [anon_sym_align] = ACTIONS(393),
    [anon_sym_alignstack] = ACTIONS(391),
    [anon_sym_allocsize] = ACTIONS(391),
    [anon_sym_alwaysinline] = ACTIONS(391),
    [anon_sym_builtin] = ACTIONS(391),
    [anon_sym_cold] = ACTIONS(393),
    [anon_sym_convergent] = ACTIONS(391),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(391),
    [anon_sym_hot] = ACTIONS(391),
    [anon_sym_inaccessiblememonly] = ACTIONS(391),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(391),
    [anon_sym_inlinehint] = ACTIONS(391),
    [anon_sym_jumptable] = ACTIONS(391),
    [anon_sym_minsize] = ACTIONS(391),
    [anon_sym_naked] = ACTIONS(391),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(391),
    [anon_sym_nobuiltin] = ACTIONS(391),
    [anon_sym_noduplicate] = ACTIONS(391),
    [anon_sym_nofree] = ACTIONS(391),
    [anon_sym_noimplicitfloat] = ACTIONS(391),
    [anon_sym_noinline] = ACTIONS(391),
    [anon_sym_nomerge] = ACTIONS(391),
    [anon_sym_nonlazybind] = ACTIONS(391),
    [anon_sym_noprofile] = ACTIONS(391),
    [anon_sym_noredzone] = ACTIONS(391),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(391),
    [anon_sym_noreturn] = ACTIONS(391),
    [anon_sym_norecurse] = ACTIONS(391),
    [anon_sym_willreturn] = ACTIONS(391),
    [anon_sym_nosync] = ACTIONS(391),
    [anon_sym_nounwind] = ACTIONS(391),
    [anon_sym_nocallback] = ACTIONS(391),
    [anon_sym_nosanitize_coverage] = ACTIONS(391),
    [anon_sym_null_pointer_is_valid] = ACTIONS(391),
    [anon_sym_optforfuzzing] = ACTIONS(391),
    [anon_sym_optnone] = ACTIONS(391),
    [anon_sym_optsize] = ACTIONS(391),
    [anon_sym_readnone] = ACTIONS(391),
    [anon_sym_readonly] = ACTIONS(391),
    [anon_sym_writeonly] = ACTIONS(391),
    [anon_sym_argmemonly] = ACTIONS(391),
    [anon_sym_returns_twice] = ACTIONS(391),
    [anon_sym_safestack] = ACTIONS(391),
    [anon_sym_sanitize_address] = ACTIONS(391),
    [anon_sym_sanitize_memory] = ACTIONS(391),
    [anon_sym_sanitize_thread] = ACTIONS(391),
    [anon_sym_sanitize_hwaddress] = ACTIONS(391),
    [anon_sym_sanitize_memtag] = ACTIONS(391),
    [anon_sym_speculative_load_hardening] = ACTIONS(391),
    [anon_sym_speculatable] = ACTIONS(391),
    [anon_sym_ssp] = ACTIONS(393),
    [anon_sym_sspstrong] = ACTIONS(391),
    [anon_sym_sspreq] = ACTIONS(391),
    [anon_sym_strictfp] = ACTIONS(391),
    [anon_sym_nocf_check] = ACTIONS(391),
    [anon_sym_shadowcallstack] = ACTIONS(391),
    [anon_sym_mustprogress] = ACTIONS(391),
    [anon_sym_vscale_range] = ACTIONS(391),
    [anon_sym_preallocated] = ACTIONS(391),
    [anon_sym_zeroext] = ACTIONS(391),
    [anon_sym_signext] = ACTIONS(391),
    [anon_sym_inreg] = ACTIONS(391),
    [anon_sym_byval] = ACTIONS(391),
    [anon_sym_byref] = ACTIONS(391),
    [anon_sym_inalloca] = ACTIONS(391),
    [anon_sym_sret] = ACTIONS(391),
    [anon_sym_elementtype] = ACTIONS(391),
    [anon_sym_noalias] = ACTIONS(391),
    [anon_sym_nocapture] = ACTIONS(391),
    [anon_sym_nest] = ACTIONS(391),
    [anon_sym_returned] = ACTIONS(391),
    [anon_sym_nonnull] = ACTIONS(391),
    [anon_sym_dereferenceable] = ACTIONS(393),
    [anon_sym_dereferenceable_or_null] = ACTIONS(391),
    [anon_sym_swiftself] = ACTIONS(393),
    [anon_sym_swiftasync] = ACTIONS(393),
    [anon_sym_swifterror] = ACTIONS(393),
    [anon_sym_immarg] = ACTIONS(391),
    [anon_sym_noundef] = ACTIONS(391),
    [anon_sym_uwtable] = ACTIONS(391),
    [anon_sym_memory] = ACTIONS(391),
    [anon_sym_none] = ACTIONS(391),
    [anon_sym_extractelement] = ACTIONS(391),
    [anon_sym_insertelement] = ACTIONS(391),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_shufflevector] = ACTIONS(391),
    [anon_sym_fneg] = ACTIONS(391),
    [anon_sym_icmp] = ACTIONS(391),
    [anon_sym_fcmp] = ACTIONS(391),
    [anon_sym_getelementptr] = ACTIONS(391),
    [anon_sym_extractvalue] = ACTIONS(391),
    [anon_sym_insertvalue] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(391),
    [anon_sym_false] = ACTIONS(391),
    [anon_sym_null] = ACTIONS(393),
    [anon_sym_undef] = ACTIONS(391),
    [anon_sym_poison] = ACTIONS(391),
    [anon_sym_zeroinitializer] = ACTIONS(391),
    [anon_sym_blockaddress] = ACTIONS(391),
    [anon_sym_mul] = ACTIONS(391),
    [anon_sym_urem] = ACTIONS(391),
    [anon_sym_srem] = ACTIONS(391),
    [anon_sym_shl] = ACTIONS(391),
    [anon_sym_udiv] = ACTIONS(391),
    [anon_sym_sdiv] = ACTIONS(391),
    [anon_sym_lshr] = ACTIONS(391),
    [anon_sym_ashr] = ACTIONS(391),
    [anon_sym_fmul] = ACTIONS(391),
    [anon_sym_fdiv] = ACTIONS(391),
    [anon_sym_frem] = ACTIONS(391),
    [anon_sym_xchg] = ACTIONS(391),
    [anon_sym_add] = ACTIONS(393),
    [anon_sym_sub] = ACTIONS(391),
    [anon_sym_and] = ACTIONS(391),
    [anon_sym_nand] = ACTIONS(391),
    [anon_sym_or] = ACTIONS(391),
    [anon_sym_xor] = ACTIONS(391),
    [anon_sym_max] = ACTIONS(391),
    [anon_sym_min] = ACTIONS(393),
    [anon_sym_umax] = ACTIONS(391),
    [anon_sym_umin] = ACTIONS(391),
    [anon_sym_fadd] = ACTIONS(391),
    [anon_sym_fsub] = ACTIONS(391),
    [anon_sym_bitcast] = ACTIONS(391),
    [anon_sym_trunc] = ACTIONS(391),
    [anon_sym_zext] = ACTIONS(391),
    [anon_sym_sext] = ACTIONS(391),
    [anon_sym_fptrunc] = ACTIONS(391),
    [anon_sym_fpext] = ACTIONS(391),
    [anon_sym_addrspacecast] = ACTIONS(391),
    [anon_sym_uitofp] = ACTIONS(391),
    [anon_sym_sitofp] = ACTIONS(391),
    [anon_sym_fptoui] = ACTIONS(391),
    [anon_sym_fptosi] = ACTIONS(391),
    [anon_sym_inttoptr] = ACTIONS(391),
    [anon_sym_ptrtoint] = ACTIONS(391),
  },
  [27] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(395),
    [sym_local_var] = ACTIONS(395),
    [aux_sym_metadata_ref_token1] = ACTIONS(395),
    [sym_string] = ACTIONS(395),
    [aux_sym_number_token1] = ACTIONS(397),
    [aux_sym_number_token2] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_cstring] = ACTIONS(395),
    [anon_sym_no_cfi] = ACTIONS(395),
    [anon_sym_private] = ACTIONS(395),
    [anon_sym_internal] = ACTIONS(395),
    [anon_sym_weak] = ACTIONS(397),
    [anon_sym_weak_odr] = ACTIONS(395),
    [anon_sym_linkonce] = ACTIONS(397),
    [anon_sym_linkonce_odr] = ACTIONS(395),
    [anon_sym_available_externally] = ACTIONS(395),
    [anon_sym_appending] = ACTIONS(395),
    [anon_sym_common] = ACTIONS(395),
    [anon_sym_extern_weak] = ACTIONS(395),
    [anon_sym_external] = ACTIONS(395),
    [anon_sym_dso_local] = ACTIONS(397),
    [anon_sym_dso_local_equivalent] = ACTIONS(395),
    [anon_sym_dso_preemptable] = ACTIONS(395),
    [anon_sym_default] = ACTIONS(395),
    [anon_sym_hidden] = ACTIONS(395),
    [anon_sym_protected] = ACTIONS(395),
    [anon_sym_dllimport] = ACTIONS(395),
    [anon_sym_dllexport] = ACTIONS(395),
    [anon_sym_ccc] = ACTIONS(395),
    [anon_sym_fastcc] = ACTIONS(395),
    [anon_sym_coldcc] = ACTIONS(395),
    [anon_sym_webkit_jscc] = ACTIONS(397),
    [anon_sym_anyregcc] = ACTIONS(395),
    [anon_sym_preserve_mostcc] = ACTIONS(395),
    [anon_sym_preserve_allcc] = ACTIONS(395),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(397),
    [anon_sym_tailcc] = ACTIONS(395),
    [anon_sym_swiftcc] = ACTIONS(397),
    [anon_sym_swifttailcc] = ACTIONS(397),
    [anon_sym_cfguard_checkcc] = ACTIONS(395),
    [aux_sym_calling_conv_token1] = ACTIONS(397),
    [aux_sym_calling_conv_token2] = ACTIONS(395),
    [aux_sym_calling_conv_token3] = ACTIONS(395),
    [aux_sym_calling_conv_token4] = ACTIONS(395),
    [aux_sym_calling_conv_token5] = ACTIONS(395),
    [aux_sym_calling_conv_token6] = ACTIONS(395),
    [aux_sym_calling_conv_token7] = ACTIONS(395),
    [aux_sym_calling_conv_token8] = ACTIONS(395),
    [aux_sym_calling_conv_token9] = ACTIONS(395),
    [aux_sym_calling_conv_token10] = ACTIONS(397),
    [anon_sym_ghccc] = ACTIONS(395),
    [aux_sym_calling_conv_token11] = ACTIONS(397),
    [aux_sym_calling_conv_token12] = ACTIONS(395),
    [aux_sym_calling_conv_token13] = ACTIONS(397),
    [aux_sym_calling_conv_token14] = ACTIONS(395),
    [anon_sym_cc] = ACTIONS(397),
    [anon_sym_unnamed_addr] = ACTIONS(395),
    [anon_sym_local_unnamed_addr] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_half] = ACTIONS(395),
    [anon_sym_bfloat] = ACTIONS(395),
    [anon_sym_float] = ACTIONS(395),
    [anon_sym_double] = ACTIONS(395),
    [anon_sym_x86_fp80] = ACTIONS(397),
    [anon_sym_fp128] = ACTIONS(395),
    [anon_sym_ppc_fp128] = ACTIONS(395),
    [anon_sym_label] = ACTIONS(395),
    [anon_sym_metadata] = ACTIONS(395),
    [anon_sym_x86_mmx] = ACTIONS(397),
    [anon_sym_x86_amx] = ACTIONS(397),
    [anon_sym_token] = ACTIONS(395),
    [anon_sym_opaque] = ACTIONS(395),
    [anon_sym_ptr] = ACTIONS(397),
    [aux_sym_type_keyword_token1] = ACTIONS(395),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_LT_LBRACE] = ACTIONS(395),
    [anon_sym_RBRACE_GT] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(395),
    [anon_sym_LT] = ACTIONS(397),
    [anon_sym_COMMA] = ACTIONS(395),
    [anon_sym_align] = ACTIONS(397),
    [anon_sym_alignstack] = ACTIONS(395),
    [anon_sym_allocsize] = ACTIONS(395),
    [anon_sym_alwaysinline] = ACTIONS(395),
    [anon_sym_builtin] = ACTIONS(395),
    [anon_sym_cold] = ACTIONS(397),
    [anon_sym_convergent] = ACTIONS(395),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(395),
    [anon_sym_hot] = ACTIONS(395),
    [anon_sym_inaccessiblememonly] = ACTIONS(395),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(395),
    [anon_sym_inlinehint] = ACTIONS(395),
    [anon_sym_jumptable] = ACTIONS(395),
    [anon_sym_minsize] = ACTIONS(395),
    [anon_sym_naked] = ACTIONS(395),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(395),
    [anon_sym_nobuiltin] = ACTIONS(395),
    [anon_sym_noduplicate] = ACTIONS(395),
    [anon_sym_nofree] = ACTIONS(395),
    [anon_sym_noimplicitfloat] = ACTIONS(395),
    [anon_sym_noinline] = ACTIONS(395),
    [anon_sym_nomerge] = ACTIONS(395),
    [anon_sym_nonlazybind] = ACTIONS(395),
    [anon_sym_noprofile] = ACTIONS(395),
    [anon_sym_noredzone] = ACTIONS(395),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(395),
    [anon_sym_noreturn] = ACTIONS(395),
    [anon_sym_norecurse] = ACTIONS(395),
    [anon_sym_willreturn] = ACTIONS(395),
    [anon_sym_nosync] = ACTIONS(395),
    [anon_sym_nounwind] = ACTIONS(395),
    [anon_sym_nocallback] = ACTIONS(395),
    [anon_sym_nosanitize_coverage] = ACTIONS(395),
    [anon_sym_null_pointer_is_valid] = ACTIONS(395),
    [anon_sym_optforfuzzing] = ACTIONS(395),
    [anon_sym_optnone] = ACTIONS(395),
    [anon_sym_optsize] = ACTIONS(395),
    [anon_sym_readnone] = ACTIONS(395),
    [anon_sym_readonly] = ACTIONS(395),
    [anon_sym_writeonly] = ACTIONS(395),
    [anon_sym_argmemonly] = ACTIONS(395),
    [anon_sym_returns_twice] = ACTIONS(395),
    [anon_sym_safestack] = ACTIONS(395),
    [anon_sym_sanitize_address] = ACTIONS(395),
    [anon_sym_sanitize_memory] = ACTIONS(395),
    [anon_sym_sanitize_thread] = ACTIONS(395),
    [anon_sym_sanitize_hwaddress] = ACTIONS(395),
    [anon_sym_sanitize_memtag] = ACTIONS(395),
    [anon_sym_speculative_load_hardening] = ACTIONS(395),
    [anon_sym_speculatable] = ACTIONS(395),
    [anon_sym_ssp] = ACTIONS(397),
    [anon_sym_sspstrong] = ACTIONS(395),
    [anon_sym_sspreq] = ACTIONS(395),
    [anon_sym_strictfp] = ACTIONS(395),
    [anon_sym_nocf_check] = ACTIONS(395),
    [anon_sym_shadowcallstack] = ACTIONS(395),
    [anon_sym_mustprogress] = ACTIONS(395),
    [anon_sym_vscale_range] = ACTIONS(395),
    [anon_sym_preallocated] = ACTIONS(395),
    [anon_sym_zeroext] = ACTIONS(395),
    [anon_sym_signext] = ACTIONS(395),
    [anon_sym_inreg] = ACTIONS(395),
    [anon_sym_byval] = ACTIONS(395),
    [anon_sym_byref] = ACTIONS(395),
    [anon_sym_inalloca] = ACTIONS(395),
    [anon_sym_sret] = ACTIONS(395),
    [anon_sym_elementtype] = ACTIONS(395),
    [anon_sym_noalias] = ACTIONS(395),
    [anon_sym_nocapture] = ACTIONS(395),
    [anon_sym_nest] = ACTIONS(395),
    [anon_sym_returned] = ACTIONS(395),
    [anon_sym_nonnull] = ACTIONS(395),
    [anon_sym_dereferenceable] = ACTIONS(397),
    [anon_sym_dereferenceable_or_null] = ACTIONS(395),
    [anon_sym_swiftself] = ACTIONS(397),
    [anon_sym_swiftasync] = ACTIONS(397),
    [anon_sym_swifterror] = ACTIONS(397),
    [anon_sym_immarg] = ACTIONS(395),
    [anon_sym_noundef] = ACTIONS(395),
    [anon_sym_uwtable] = ACTIONS(395),
    [anon_sym_memory] = ACTIONS(395),
    [anon_sym_none] = ACTIONS(395),
    [anon_sym_extractelement] = ACTIONS(395),
    [anon_sym_insertelement] = ACTIONS(395),
    [anon_sym_select] = ACTIONS(395),
    [anon_sym_shufflevector] = ACTIONS(395),
    [anon_sym_fneg] = ACTIONS(395),
    [anon_sym_icmp] = ACTIONS(395),
    [anon_sym_fcmp] = ACTIONS(395),
    [anon_sym_getelementptr] = ACTIONS(395),
    [anon_sym_extractvalue] = ACTIONS(395),
    [anon_sym_insertvalue] = ACTIONS(395),
    [anon_sym_true] = ACTIONS(395),
    [anon_sym_false] = ACTIONS(395),
    [anon_sym_null] = ACTIONS(397),
    [anon_sym_undef] = ACTIONS(395),
    [anon_sym_poison] = ACTIONS(395),
    [anon_sym_zeroinitializer] = ACTIONS(395),
    [anon_sym_blockaddress] = ACTIONS(395),
    [anon_sym_mul] = ACTIONS(395),
    [anon_sym_urem] = ACTIONS(395),
    [anon_sym_srem] = ACTIONS(395),
    [anon_sym_shl] = ACTIONS(395),
    [anon_sym_udiv] = ACTIONS(395),
    [anon_sym_sdiv] = ACTIONS(395),
    [anon_sym_lshr] = ACTIONS(395),
    [anon_sym_ashr] = ACTIONS(395),
    [anon_sym_fmul] = ACTIONS(395),
    [anon_sym_fdiv] = ACTIONS(395),
    [anon_sym_frem] = ACTIONS(395),
    [anon_sym_xchg] = ACTIONS(395),
    [anon_sym_add] = ACTIONS(397),
    [anon_sym_sub] = ACTIONS(395),
    [anon_sym_and] = ACTIONS(395),
    [anon_sym_nand] = ACTIONS(395),
    [anon_sym_or] = ACTIONS(395),
    [anon_sym_xor] = ACTIONS(395),
    [anon_sym_max] = ACTIONS(395),
    [anon_sym_min] = ACTIONS(397),
    [anon_sym_umax] = ACTIONS(395),
    [anon_sym_umin] = ACTIONS(395),
    [anon_sym_fadd] = ACTIONS(395),
    [anon_sym_fsub] = ACTIONS(395),
    [anon_sym_bitcast] = ACTIONS(395),
    [anon_sym_trunc] = ACTIONS(395),
    [anon_sym_zext] = ACTIONS(395),
    [anon_sym_sext] = ACTIONS(395),
    [anon_sym_fptrunc] = ACTIONS(395),
    [anon_sym_fpext] = ACTIONS(395),
    [anon_sym_addrspacecast] = ACTIONS(395),
    [anon_sym_uitofp] = ACTIONS(395),
    [anon_sym_sitofp] = ACTIONS(395),
    [anon_sym_fptoui] = ACTIONS(395),
    [anon_sym_fptosi] = ACTIONS(395),
    [anon_sym_inttoptr] = ACTIONS(395),
    [anon_sym_ptrtoint] = ACTIONS(395),
  },
  [28] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [aux_sym_metadata_ref_token1] = ACTIONS(263),
    [sym_string] = ACTIONS(263),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(263),
    [sym_float] = ACTIONS(263),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(263),
    [anon_sym_private] = ACTIONS(263),
    [anon_sym_internal] = ACTIONS(263),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(263),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(263),
    [anon_sym_available_externally] = ACTIONS(263),
    [anon_sym_appending] = ACTIONS(263),
    [anon_sym_common] = ACTIONS(263),
    [anon_sym_extern_weak] = ACTIONS(263),
    [anon_sym_external] = ACTIONS(263),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(263),
    [anon_sym_dso_preemptable] = ACTIONS(263),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_hidden] = ACTIONS(263),
    [anon_sym_protected] = ACTIONS(263),
    [anon_sym_dllimport] = ACTIONS(263),
    [anon_sym_dllexport] = ACTIONS(263),
    [anon_sym_ccc] = ACTIONS(263),
    [anon_sym_fastcc] = ACTIONS(263),
    [anon_sym_coldcc] = ACTIONS(263),
    [anon_sym_webkit_jscc] = ACTIONS(265),
    [anon_sym_anyregcc] = ACTIONS(263),
    [anon_sym_preserve_mostcc] = ACTIONS(263),
    [anon_sym_preserve_allcc] = ACTIONS(263),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(265),
    [anon_sym_tailcc] = ACTIONS(263),
    [anon_sym_swiftcc] = ACTIONS(265),
    [anon_sym_swifttailcc] = ACTIONS(265),
    [anon_sym_cfguard_checkcc] = ACTIONS(263),
    [aux_sym_calling_conv_token1] = ACTIONS(265),
    [aux_sym_calling_conv_token2] = ACTIONS(263),
    [aux_sym_calling_conv_token3] = ACTIONS(263),
    [aux_sym_calling_conv_token4] = ACTIONS(263),
    [aux_sym_calling_conv_token5] = ACTIONS(263),
    [aux_sym_calling_conv_token6] = ACTIONS(263),
    [aux_sym_calling_conv_token7] = ACTIONS(263),
    [aux_sym_calling_conv_token8] = ACTIONS(263),
    [aux_sym_calling_conv_token9] = ACTIONS(263),
    [aux_sym_calling_conv_token10] = ACTIONS(265),
    [anon_sym_ghccc] = ACTIONS(263),
    [aux_sym_calling_conv_token11] = ACTIONS(265),
    [aux_sym_calling_conv_token12] = ACTIONS(263),
    [aux_sym_calling_conv_token13] = ACTIONS(265),
    [aux_sym_calling_conv_token14] = ACTIONS(263),
    [anon_sym_cc] = ACTIONS(265),
    [anon_sym_unnamed_addr] = ACTIONS(263),
    [anon_sym_local_unnamed_addr] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_void] = ACTIONS(263),
    [anon_sym_half] = ACTIONS(263),
    [anon_sym_bfloat] = ACTIONS(263),
    [anon_sym_float] = ACTIONS(263),
    [anon_sym_double] = ACTIONS(263),
    [anon_sym_x86_fp80] = ACTIONS(265),
    [anon_sym_fp128] = ACTIONS(263),
    [anon_sym_ppc_fp128] = ACTIONS(263),
    [anon_sym_label] = ACTIONS(263),
    [anon_sym_metadata] = ACTIONS(263),
    [anon_sym_x86_mmx] = ACTIONS(265),
    [anon_sym_x86_amx] = ACTIONS(265),
    [anon_sym_token] = ACTIONS(263),
    [anon_sym_opaque] = ACTIONS(263),
    [anon_sym_ptr] = ACTIONS(265),
    [aux_sym_type_keyword_token1] = ACTIONS(263),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE_GT] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_align] = ACTIONS(265),
    [anon_sym_alignstack] = ACTIONS(263),
    [anon_sym_allocsize] = ACTIONS(263),
    [anon_sym_alwaysinline] = ACTIONS(263),
    [anon_sym_builtin] = ACTIONS(263),
    [anon_sym_cold] = ACTIONS(265),
    [anon_sym_convergent] = ACTIONS(263),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(263),
    [anon_sym_hot] = ACTIONS(263),
    [anon_sym_inaccessiblememonly] = ACTIONS(263),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(263),
    [anon_sym_inlinehint] = ACTIONS(263),
    [anon_sym_jumptable] = ACTIONS(263),
    [anon_sym_minsize] = ACTIONS(263),
    [anon_sym_naked] = ACTIONS(263),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(263),
    [anon_sym_nobuiltin] = ACTIONS(263),
    [anon_sym_noduplicate] = ACTIONS(263),
    [anon_sym_nofree] = ACTIONS(263),
    [anon_sym_noimplicitfloat] = ACTIONS(263),
    [anon_sym_noinline] = ACTIONS(263),
    [anon_sym_nomerge] = ACTIONS(263),
    [anon_sym_nonlazybind] = ACTIONS(263),
    [anon_sym_noprofile] = ACTIONS(263),
    [anon_sym_noredzone] = ACTIONS(263),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(263),
    [anon_sym_noreturn] = ACTIONS(263),
    [anon_sym_norecurse] = ACTIONS(263),
    [anon_sym_willreturn] = ACTIONS(263),
    [anon_sym_nosync] = ACTIONS(263),
    [anon_sym_nounwind] = ACTIONS(263),
    [anon_sym_nocallback] = ACTIONS(263),
    [anon_sym_nosanitize_coverage] = ACTIONS(263),
    [anon_sym_null_pointer_is_valid] = ACTIONS(263),
    [anon_sym_optforfuzzing] = ACTIONS(263),
    [anon_sym_optnone] = ACTIONS(263),
    [anon_sym_optsize] = ACTIONS(263),
    [anon_sym_readnone] = ACTIONS(263),
    [anon_sym_readonly] = ACTIONS(263),
    [anon_sym_writeonly] = ACTIONS(263),
    [anon_sym_argmemonly] = ACTIONS(263),
    [anon_sym_returns_twice] = ACTIONS(263),
    [anon_sym_safestack] = ACTIONS(263),
    [anon_sym_sanitize_address] = ACTIONS(263),
    [anon_sym_sanitize_memory] = ACTIONS(263),
    [anon_sym_sanitize_thread] = ACTIONS(263),
    [anon_sym_sanitize_hwaddress] = ACTIONS(263),
    [anon_sym_sanitize_memtag] = ACTIONS(263),
    [anon_sym_speculative_load_hardening] = ACTIONS(263),
    [anon_sym_speculatable] = ACTIONS(263),
    [anon_sym_ssp] = ACTIONS(265),
    [anon_sym_sspstrong] = ACTIONS(263),
    [anon_sym_sspreq] = ACTIONS(263),
    [anon_sym_strictfp] = ACTIONS(263),
    [anon_sym_nocf_check] = ACTIONS(263),
    [anon_sym_shadowcallstack] = ACTIONS(263),
    [anon_sym_mustprogress] = ACTIONS(263),
    [anon_sym_vscale_range] = ACTIONS(263),
    [anon_sym_preallocated] = ACTIONS(263),
    [anon_sym_zeroext] = ACTIONS(263),
    [anon_sym_signext] = ACTIONS(263),
    [anon_sym_inreg] = ACTIONS(263),
    [anon_sym_byval] = ACTIONS(263),
    [anon_sym_byref] = ACTIONS(263),
    [anon_sym_inalloca] = ACTIONS(263),
    [anon_sym_sret] = ACTIONS(263),
    [anon_sym_elementtype] = ACTIONS(263),
    [anon_sym_noalias] = ACTIONS(263),
    [anon_sym_nocapture] = ACTIONS(263),
    [anon_sym_nest] = ACTIONS(263),
    [anon_sym_returned] = ACTIONS(263),
    [anon_sym_nonnull] = ACTIONS(263),
    [anon_sym_dereferenceable] = ACTIONS(265),
    [anon_sym_dereferenceable_or_null] = ACTIONS(263),
    [anon_sym_swiftself] = ACTIONS(265),
    [anon_sym_swiftasync] = ACTIONS(265),
    [anon_sym_swifterror] = ACTIONS(265),
    [anon_sym_immarg] = ACTIONS(263),
    [anon_sym_noundef] = ACTIONS(263),
    [anon_sym_uwtable] = ACTIONS(263),
    [anon_sym_memory] = ACTIONS(263),
    [anon_sym_none] = ACTIONS(263),
    [anon_sym_extractelement] = ACTIONS(263),
    [anon_sym_insertelement] = ACTIONS(263),
    [anon_sym_select] = ACTIONS(263),
    [anon_sym_shufflevector] = ACTIONS(263),
    [anon_sym_fneg] = ACTIONS(263),
    [anon_sym_icmp] = ACTIONS(263),
    [anon_sym_fcmp] = ACTIONS(263),
    [anon_sym_getelementptr] = ACTIONS(263),
    [anon_sym_extractvalue] = ACTIONS(263),
    [anon_sym_insertvalue] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(263),
    [anon_sym_false] = ACTIONS(263),
    [anon_sym_null] = ACTIONS(265),
    [anon_sym_undef] = ACTIONS(263),
    [anon_sym_poison] = ACTIONS(263),
    [anon_sym_zeroinitializer] = ACTIONS(263),
    [anon_sym_blockaddress] = ACTIONS(263),
    [anon_sym_mul] = ACTIONS(263),
    [anon_sym_urem] = ACTIONS(263),
    [anon_sym_srem] = ACTIONS(263),
    [anon_sym_shl] = ACTIONS(263),
    [anon_sym_udiv] = ACTIONS(263),
    [anon_sym_sdiv] = ACTIONS(263),
    [anon_sym_lshr] = ACTIONS(263),
    [anon_sym_ashr] = ACTIONS(263),
    [anon_sym_fmul] = ACTIONS(263),
    [anon_sym_fdiv] = ACTIONS(263),
    [anon_sym_frem] = ACTIONS(263),
    [anon_sym_xchg] = ACTIONS(263),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(263),
    [anon_sym_and] = ACTIONS(263),
    [anon_sym_nand] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(263),
    [anon_sym_xor] = ACTIONS(263),
    [anon_sym_max] = ACTIONS(263),
    [anon_sym_min] = ACTIONS(265),
    [anon_sym_umax] = ACTIONS(263),
    [anon_sym_umin] = ACTIONS(263),
    [anon_sym_fadd] = ACTIONS(263),
    [anon_sym_fsub] = ACTIONS(263),
    [anon_sym_bitcast] = ACTIONS(263),
    [anon_sym_trunc] = ACTIONS(263),
    [anon_sym_zext] = ACTIONS(263),
    [anon_sym_sext] = ACTIONS(263),
    [anon_sym_fptrunc] = ACTIONS(263),
    [anon_sym_fpext] = ACTIONS(263),
    [anon_sym_addrspacecast] = ACTIONS(263),
    [anon_sym_uitofp] = ACTIONS(263),
    [anon_sym_sitofp] = ACTIONS(263),
    [anon_sym_fptoui] = ACTIONS(263),
    [anon_sym_fptosi] = ACTIONS(263),
    [anon_sym_inttoptr] = ACTIONS(263),
    [anon_sym_ptrtoint] = ACTIONS(263),
  },
  [29] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [aux_sym_metadata_ref_token1] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_ccc] = ACTIONS(244),
    [anon_sym_fastcc] = ACTIONS(244),
    [anon_sym_coldcc] = ACTIONS(244),
    [anon_sym_webkit_jscc] = ACTIONS(246),
    [anon_sym_anyregcc] = ACTIONS(244),
    [anon_sym_preserve_mostcc] = ACTIONS(244),
    [anon_sym_preserve_allcc] = ACTIONS(244),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(246),
    [anon_sym_tailcc] = ACTIONS(244),
    [anon_sym_swiftcc] = ACTIONS(246),
    [anon_sym_swifttailcc] = ACTIONS(246),
    [anon_sym_cfguard_checkcc] = ACTIONS(244),
    [aux_sym_calling_conv_token1] = ACTIONS(246),
    [aux_sym_calling_conv_token2] = ACTIONS(244),
    [aux_sym_calling_conv_token3] = ACTIONS(244),
    [aux_sym_calling_conv_token4] = ACTIONS(244),
    [aux_sym_calling_conv_token5] = ACTIONS(244),
    [aux_sym_calling_conv_token6] = ACTIONS(244),
    [aux_sym_calling_conv_token7] = ACTIONS(244),
    [aux_sym_calling_conv_token8] = ACTIONS(244),
    [aux_sym_calling_conv_token9] = ACTIONS(244),
    [aux_sym_calling_conv_token10] = ACTIONS(246),
    [anon_sym_ghccc] = ACTIONS(244),
    [aux_sym_calling_conv_token11] = ACTIONS(246),
    [aux_sym_calling_conv_token12] = ACTIONS(244),
    [aux_sym_calling_conv_token13] = ACTIONS(246),
    [aux_sym_calling_conv_token14] = ACTIONS(244),
    [anon_sym_cc] = ACTIONS(246),
    [anon_sym_unnamed_addr] = ACTIONS(244),
    [anon_sym_local_unnamed_addr] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_void] = ACTIONS(244),
    [anon_sym_half] = ACTIONS(244),
    [anon_sym_bfloat] = ACTIONS(244),
    [anon_sym_float] = ACTIONS(244),
    [anon_sym_double] = ACTIONS(244),
    [anon_sym_x86_fp80] = ACTIONS(246),
    [anon_sym_fp128] = ACTIONS(244),
    [anon_sym_ppc_fp128] = ACTIONS(244),
    [anon_sym_label] = ACTIONS(244),
    [anon_sym_metadata] = ACTIONS(244),
    [anon_sym_x86_mmx] = ACTIONS(246),
    [anon_sym_x86_amx] = ACTIONS(246),
    [anon_sym_token] = ACTIONS(244),
    [anon_sym_opaque] = ACTIONS(244),
    [anon_sym_ptr] = ACTIONS(246),
    [aux_sym_type_keyword_token1] = ACTIONS(244),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE_GT] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_align] = ACTIONS(246),
    [anon_sym_alignstack] = ACTIONS(244),
    [anon_sym_allocsize] = ACTIONS(244),
    [anon_sym_alwaysinline] = ACTIONS(244),
    [anon_sym_builtin] = ACTIONS(244),
    [anon_sym_cold] = ACTIONS(246),
    [anon_sym_convergent] = ACTIONS(244),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(244),
    [anon_sym_hot] = ACTIONS(244),
    [anon_sym_inaccessiblememonly] = ACTIONS(244),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(244),
    [anon_sym_inlinehint] = ACTIONS(244),
    [anon_sym_jumptable] = ACTIONS(244),
    [anon_sym_minsize] = ACTIONS(244),
    [anon_sym_naked] = ACTIONS(244),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(244),
    [anon_sym_nobuiltin] = ACTIONS(244),
    [anon_sym_noduplicate] = ACTIONS(244),
    [anon_sym_nofree] = ACTIONS(244),
    [anon_sym_noimplicitfloat] = ACTIONS(244),
    [anon_sym_noinline] = ACTIONS(244),
    [anon_sym_nomerge] = ACTIONS(244),
    [anon_sym_nonlazybind] = ACTIONS(244),
    [anon_sym_noprofile] = ACTIONS(244),
    [anon_sym_noredzone] = ACTIONS(244),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(244),
    [anon_sym_noreturn] = ACTIONS(244),
    [anon_sym_norecurse] = ACTIONS(244),
    [anon_sym_willreturn] = ACTIONS(244),
    [anon_sym_nosync] = ACTIONS(244),
    [anon_sym_nounwind] = ACTIONS(244),
    [anon_sym_nocallback] = ACTIONS(244),
    [anon_sym_nosanitize_coverage] = ACTIONS(244),
    [anon_sym_null_pointer_is_valid] = ACTIONS(244),
    [anon_sym_optforfuzzing] = ACTIONS(244),
    [anon_sym_optnone] = ACTIONS(244),
    [anon_sym_optsize] = ACTIONS(244),
    [anon_sym_readnone] = ACTIONS(244),
    [anon_sym_readonly] = ACTIONS(244),
    [anon_sym_writeonly] = ACTIONS(244),
    [anon_sym_argmemonly] = ACTIONS(244),
    [anon_sym_returns_twice] = ACTIONS(244),
    [anon_sym_safestack] = ACTIONS(244),
    [anon_sym_sanitize_address] = ACTIONS(244),
    [anon_sym_sanitize_memory] = ACTIONS(244),
    [anon_sym_sanitize_thread] = ACTIONS(244),
    [anon_sym_sanitize_hwaddress] = ACTIONS(244),
    [anon_sym_sanitize_memtag] = ACTIONS(244),
    [anon_sym_speculative_load_hardening] = ACTIONS(244),
    [anon_sym_speculatable] = ACTIONS(244),
    [anon_sym_ssp] = ACTIONS(246),
    [anon_sym_sspstrong] = ACTIONS(244),
    [anon_sym_sspreq] = ACTIONS(244),
    [anon_sym_strictfp] = ACTIONS(244),
    [anon_sym_nocf_check] = ACTIONS(244),
    [anon_sym_shadowcallstack] = ACTIONS(244),
    [anon_sym_mustprogress] = ACTIONS(244),
    [anon_sym_vscale_range] = ACTIONS(244),
    [anon_sym_preallocated] = ACTIONS(244),
    [anon_sym_zeroext] = ACTIONS(244),
    [anon_sym_signext] = ACTIONS(244),
    [anon_sym_inreg] = ACTIONS(244),
    [anon_sym_byval] = ACTIONS(244),
    [anon_sym_byref] = ACTIONS(244),
    [anon_sym_inalloca] = ACTIONS(244),
    [anon_sym_sret] = ACTIONS(244),
    [anon_sym_elementtype] = ACTIONS(244),
    [anon_sym_noalias] = ACTIONS(244),
    [anon_sym_nocapture] = ACTIONS(244),
    [anon_sym_nest] = ACTIONS(244),
    [anon_sym_returned] = ACTIONS(244),
    [anon_sym_nonnull] = ACTIONS(244),
    [anon_sym_dereferenceable] = ACTIONS(246),
    [anon_sym_dereferenceable_or_null] = ACTIONS(244),
    [anon_sym_swiftself] = ACTIONS(246),
    [anon_sym_swiftasync] = ACTIONS(246),
    [anon_sym_swifterror] = ACTIONS(246),
    [anon_sym_immarg] = ACTIONS(244),
    [anon_sym_noundef] = ACTIONS(244),
    [anon_sym_uwtable] = ACTIONS(244),
    [anon_sym_memory] = ACTIONS(244),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
  },
  [30] = {
    [sym_addrspace] = STATE(51),
    [sym_argument_list] = STATE(32),
    [aux_sym_type_repeat1] = STATE(33),
    [aux_sym_type_repeat2] = STATE(32),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(234),
    [sym_global_var] = ACTIONS(234),
    [sym_local_var] = ACTIONS(234),
    [sym_label] = ACTIONS(234),
    [sym_string] = ACTIONS(236),
    [aux_sym_number_token1] = ACTIONS(236),
    [aux_sym_number_token2] = ACTIONS(236),
    [sym_float] = ACTIONS(236),
    [sym_cstring] = ACTIONS(234),
    [anon_sym_no_cfi] = ACTIONS(236),
    [anon_sym_private] = ACTIONS(236),
    [anon_sym_internal] = ACTIONS(236),
    [anon_sym_weak] = ACTIONS(236),
    [anon_sym_weak_odr] = ACTIONS(236),
    [anon_sym_linkonce] = ACTIONS(236),
    [anon_sym_linkonce_odr] = ACTIONS(236),
    [anon_sym_available_externally] = ACTIONS(236),
    [anon_sym_appending] = ACTIONS(236),
    [anon_sym_common] = ACTIONS(236),
    [anon_sym_extern_weak] = ACTIONS(236),
    [anon_sym_external] = ACTIONS(236),
    [anon_sym_dso_local] = ACTIONS(236),
    [anon_sym_dso_local_equivalent] = ACTIONS(236),
    [anon_sym_dso_preemptable] = ACTIONS(236),
    [anon_sym_default] = ACTIONS(236),
    [anon_sym_hidden] = ACTIONS(236),
    [anon_sym_protected] = ACTIONS(236),
    [anon_sym_dllimport] = ACTIONS(236),
    [anon_sym_dllexport] = ACTIONS(236),
    [anon_sym_STAR] = ACTIONS(401),
    [anon_sym_LBRACE] = ACTIONS(234),
    [anon_sym_RBRACE] = ACTIONS(234),
    [anon_sym_LT_LBRACE] = ACTIONS(234),
    [anon_sym_LBRACK] = ACTIONS(234),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_COMMA] = ACTIONS(234),
    [anon_sym_addrspace] = ACTIONS(403),
    [anon_sym_LPAREN] = ACTIONS(405),
    [anon_sym_align] = ACTIONS(236),
    [anon_sym_section] = ACTIONS(236),
    [anon_sym_partition] = ACTIONS(236),
    [anon_sym_comdat] = ACTIONS(236),
    [anon_sym_gc] = ACTIONS(236),
    [anon_sym_prefix] = ACTIONS(236),
    [anon_sym_prologue] = ACTIONS(236),
    [anon_sym_personality] = ACTIONS(236),
    [anon_sym_alignstack] = ACTIONS(236),
    [anon_sym_allocsize] = ACTIONS(236),
    [anon_sym_alwaysinline] = ACTIONS(236),
    [anon_sym_builtin] = ACTIONS(236),
    [anon_sym_cold] = ACTIONS(236),
    [anon_sym_convergent] = ACTIONS(236),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(236),
    [anon_sym_hot] = ACTIONS(236),
    [anon_sym_inaccessiblememonly] = ACTIONS(236),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(236),
    [anon_sym_inlinehint] = ACTIONS(236),
    [anon_sym_jumptable] = ACTIONS(236),
    [anon_sym_minsize] = ACTIONS(236),
    [anon_sym_naked] = ACTIONS(236),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(236),
    [anon_sym_nobuiltin] = ACTIONS(236),
    [anon_sym_noduplicate] = ACTIONS(236),
    [anon_sym_nofree] = ACTIONS(236),
    [anon_sym_noimplicitfloat] = ACTIONS(236),
    [anon_sym_noinline] = ACTIONS(236),
    [anon_sym_nomerge] = ACTIONS(236),
    [anon_sym_nonlazybind] = ACTIONS(236),
    [anon_sym_noprofile] = ACTIONS(236),
    [anon_sym_noredzone] = ACTIONS(236),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(236),
    [anon_sym_noreturn] = ACTIONS(236),
    [anon_sym_norecurse] = ACTIONS(236),
    [anon_sym_willreturn] = ACTIONS(236),
    [anon_sym_nosync] = ACTIONS(236),
    [anon_sym_nounwind] = ACTIONS(236),
    [anon_sym_nocallback] = ACTIONS(236),
    [anon_sym_nosanitize_coverage] = ACTIONS(236),
    [anon_sym_null_pointer_is_valid] = ACTIONS(236),
    [anon_sym_optforfuzzing] = ACTIONS(236),
    [anon_sym_optnone] = ACTIONS(236),
    [anon_sym_optsize] = ACTIONS(236),
    [anon_sym_readnone] = ACTIONS(236),
    [anon_sym_readonly] = ACTIONS(236),
    [anon_sym_writeonly] = ACTIONS(236),
    [anon_sym_argmemonly] = ACTIONS(236),
    [anon_sym_returns_twice] = ACTIONS(236),
    [anon_sym_safestack] = ACTIONS(236),
    [anon_sym_sanitize_address] = ACTIONS(236),
    [anon_sym_sanitize_memory] = ACTIONS(236),
    [anon_sym_sanitize_thread] = ACTIONS(236),
    [anon_sym_sanitize_hwaddress] = ACTIONS(236),
    [anon_sym_sanitize_memtag] = ACTIONS(236),
    [anon_sym_speculative_load_hardening] = ACTIONS(236),
    [anon_sym_speculatable] = ACTIONS(236),
    [anon_sym_ssp] = ACTIONS(236),
    [anon_sym_sspstrong] = ACTIONS(236),
    [anon_sym_sspreq] = ACTIONS(236),
    [anon_sym_strictfp] = ACTIONS(236),
    [anon_sym_nocf_check] = ACTIONS(236),
    [anon_sym_shadowcallstack] = ACTIONS(236),
    [anon_sym_mustprogress] = ACTIONS(236),
    [anon_sym_vscale_range] = ACTIONS(236),
    [anon_sym_preallocated] = ACTIONS(236),
    [anon_sym_zeroext] = ACTIONS(236),
    [anon_sym_signext] = ACTIONS(236),
    [anon_sym_inreg] = ACTIONS(236),
    [anon_sym_byval] = ACTIONS(236),
    [anon_sym_byref] = ACTIONS(236),
    [anon_sym_inalloca] = ACTIONS(236),
    [anon_sym_sret] = ACTIONS(236),
    [anon_sym_elementtype] = ACTIONS(236),
    [anon_sym_noalias] = ACTIONS(236),
    [anon_sym_nocapture] = ACTIONS(236),
    [anon_sym_nest] = ACTIONS(236),
    [anon_sym_returned] = ACTIONS(236),
    [anon_sym_nonnull] = ACTIONS(236),
    [anon_sym_dereferenceable] = ACTIONS(236),
    [anon_sym_dereferenceable_or_null] = ACTIONS(236),
    [anon_sym_swiftself] = ACTIONS(236),
    [anon_sym_swiftasync] = ACTIONS(236),
    [anon_sym_swifterror] = ACTIONS(236),
    [anon_sym_immarg] = ACTIONS(236),
    [anon_sym_noundef] = ACTIONS(236),
    [anon_sym_uwtable] = ACTIONS(236),
    [anon_sym_memory] = ACTIONS(236),
    [anon_sym_none] = ACTIONS(236),
    [anon_sym_unreachable] = ACTIONS(236),
    [anon_sym_ret] = ACTIONS(236),
    [anon_sym_br] = ACTIONS(236),
    [anon_sym_resume] = ACTIONS(236),
    [anon_sym_freeze] = ACTIONS(236),
    [anon_sym_indirectbr] = ACTIONS(236),
    [anon_sym_extractelement] = ACTIONS(236),
    [anon_sym_insertelement] = ACTIONS(236),
    [anon_sym_select] = ACTIONS(236),
    [anon_sym_shufflevector] = ACTIONS(236),
    [anon_sym_fneg] = ACTIONS(236),
    [anon_sym_switch] = ACTIONS(236),
    [anon_sym_invoke] = ACTIONS(236),
    [anon_sym_cleanupret] = ACTIONS(236),
    [anon_sym_catchret] = ACTIONS(236),
    [anon_sym_catchswitch] = ACTIONS(236),
    [anon_sym_catchpad] = ACTIONS(236),
    [anon_sym_cleanuppad] = ACTIONS(236),
    [anon_sym_callbr] = ACTIONS(236),
    [anon_sym_icmp] = ACTIONS(236),
    [anon_sym_fcmp] = ACTIONS(236),
    [anon_sym_va_arg] = ACTIONS(236),
    [anon_sym_phi] = ACTIONS(236),
    [anon_sym_landingpad] = ACTIONS(236),
    [anon_sym_tail] = ACTIONS(236),
    [anon_sym_musttail] = ACTIONS(236),
    [anon_sym_notail] = ACTIONS(236),
    [anon_sym_call] = ACTIONS(236),
    [anon_sym_alloca] = ACTIONS(236),
    [anon_sym_load] = ACTIONS(236),
    [anon_sym_store] = ACTIONS(236),
    [anon_sym_cmpxchg] = ACTIONS(236),
    [anon_sym_atomicrmw] = ACTIONS(236),
    [anon_sym_fence] = ACTIONS(236),
    [anon_sym_getelementptr] = ACTIONS(236),
    [anon_sym_extractvalue] = ACTIONS(236),
    [anon_sym_insertvalue] = ACTIONS(236),
    [anon_sym_true] = ACTIONS(236),
    [anon_sym_false] = ACTIONS(236),
    [anon_sym_null] = ACTIONS(236),
    [anon_sym_undef] = ACTIONS(236),
    [anon_sym_poison] = ACTIONS(236),
    [anon_sym_zeroinitializer] = ACTIONS(236),
    [anon_sym_blockaddress] = ACTIONS(236),
    [anon_sym_mul] = ACTIONS(236),
    [anon_sym_urem] = ACTIONS(236),
    [anon_sym_srem] = ACTIONS(236),
    [anon_sym_shl] = ACTIONS(236),
    [anon_sym_udiv] = ACTIONS(236),
    [anon_sym_sdiv] = ACTIONS(236),
    [anon_sym_lshr] = ACTIONS(236),
    [anon_sym_ashr] = ACTIONS(236),
    [anon_sym_fmul] = ACTIONS(236),
    [anon_sym_fdiv] = ACTIONS(236),
    [anon_sym_frem] = ACTIONS(236),
    [anon_sym_xchg] = ACTIONS(236),
    [anon_sym_add] = ACTIONS(236),
    [anon_sym_sub] = ACTIONS(236),
    [anon_sym_and] = ACTIONS(236),
    [anon_sym_nand] = ACTIONS(236),
    [anon_sym_or] = ACTIONS(236),
    [anon_sym_xor] = ACTIONS(236),
    [anon_sym_max] = ACTIONS(236),
    [anon_sym_min] = ACTIONS(236),
    [anon_sym_umax] = ACTIONS(236),
    [anon_sym_umin] = ACTIONS(236),
    [anon_sym_fadd] = ACTIONS(236),
    [anon_sym_fsub] = ACTIONS(236),
    [anon_sym_bitcast] = ACTIONS(236),
    [anon_sym_trunc] = ACTIONS(236),
    [anon_sym_zext] = ACTIONS(236),
    [anon_sym_sext] = ACTIONS(236),
    [anon_sym_fptrunc] = ACTIONS(236),
    [anon_sym_fpext] = ACTIONS(236),
    [anon_sym_addrspacecast] = ACTIONS(236),
    [anon_sym_uitofp] = ACTIONS(236),
    [anon_sym_sitofp] = ACTIONS(236),
    [anon_sym_fptoui] = ACTIONS(236),
    [anon_sym_fptosi] = ACTIONS(236),
    [anon_sym_inttoptr] = ACTIONS(236),
    [anon_sym_ptrtoint] = ACTIONS(236),
    [anon_sym_uselistorder] = ACTIONS(236),
  },
  [31] = {
    [sym_addrspace] = STATE(1730),
    [sym_argument_list] = STATE(31),
    [aux_sym_type_repeat1] = STATE(1189),
    [aux_sym_type_repeat2] = STATE(31),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(250),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [sym_label] = ACTIONS(250),
    [sym_string] = ACTIONS(252),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(252),
    [anon_sym_private] = ACTIONS(252),
    [anon_sym_internal] = ACTIONS(252),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(252),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(252),
    [anon_sym_available_externally] = ACTIONS(252),
    [anon_sym_appending] = ACTIONS(252),
    [anon_sym_common] = ACTIONS(252),
    [anon_sym_extern_weak] = ACTIONS(252),
    [anon_sym_external] = ACTIONS(252),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(252),
    [anon_sym_dso_preemptable] = ACTIONS(252),
    [anon_sym_default] = ACTIONS(252),
    [anon_sym_hidden] = ACTIONS(252),
    [anon_sym_protected] = ACTIONS(252),
    [anon_sym_dllimport] = ACTIONS(252),
    [anon_sym_dllexport] = ACTIONS(252),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(257),
    [anon_sym_LPAREN] = ACTIONS(410),
    [anon_sym_align] = ACTIONS(252),
    [anon_sym_section] = ACTIONS(252),
    [anon_sym_partition] = ACTIONS(252),
    [anon_sym_comdat] = ACTIONS(252),
    [anon_sym_gc] = ACTIONS(252),
    [anon_sym_prefix] = ACTIONS(252),
    [anon_sym_prologue] = ACTIONS(252),
    [anon_sym_personality] = ACTIONS(252),
    [anon_sym_alignstack] = ACTIONS(252),
    [anon_sym_allocsize] = ACTIONS(252),
    [anon_sym_alwaysinline] = ACTIONS(252),
    [anon_sym_builtin] = ACTIONS(252),
    [anon_sym_cold] = ACTIONS(252),
    [anon_sym_convergent] = ACTIONS(252),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(252),
    [anon_sym_hot] = ACTIONS(252),
    [anon_sym_inaccessiblememonly] = ACTIONS(252),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(252),
    [anon_sym_inlinehint] = ACTIONS(252),
    [anon_sym_jumptable] = ACTIONS(252),
    [anon_sym_minsize] = ACTIONS(252),
    [anon_sym_naked] = ACTIONS(252),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(252),
    [anon_sym_nobuiltin] = ACTIONS(252),
    [anon_sym_noduplicate] = ACTIONS(252),
    [anon_sym_nofree] = ACTIONS(252),
    [anon_sym_noimplicitfloat] = ACTIONS(252),
    [anon_sym_noinline] = ACTIONS(252),
    [anon_sym_nomerge] = ACTIONS(252),
    [anon_sym_nonlazybind] = ACTIONS(252),
    [anon_sym_noprofile] = ACTIONS(252),
    [anon_sym_noredzone] = ACTIONS(252),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(252),
    [anon_sym_noreturn] = ACTIONS(252),
    [anon_sym_norecurse] = ACTIONS(252),
    [anon_sym_willreturn] = ACTIONS(252),
    [anon_sym_nosync] = ACTIONS(252),
    [anon_sym_nounwind] = ACTIONS(252),
    [anon_sym_nocallback] = ACTIONS(252),
    [anon_sym_nosanitize_coverage] = ACTIONS(252),
    [anon_sym_null_pointer_is_valid] = ACTIONS(252),
    [anon_sym_optforfuzzing] = ACTIONS(252),
    [anon_sym_optnone] = ACTIONS(252),
    [anon_sym_optsize] = ACTIONS(252),
    [anon_sym_readnone] = ACTIONS(252),
    [anon_sym_readonly] = ACTIONS(252),
    [anon_sym_writeonly] = ACTIONS(252),
    [anon_sym_argmemonly] = ACTIONS(252),
    [anon_sym_returns_twice] = ACTIONS(252),
    [anon_sym_safestack] = ACTIONS(252),
    [anon_sym_sanitize_address] = ACTIONS(252),
    [anon_sym_sanitize_memory] = ACTIONS(252),
    [anon_sym_sanitize_thread] = ACTIONS(252),
    [anon_sym_sanitize_hwaddress] = ACTIONS(252),
    [anon_sym_sanitize_memtag] = ACTIONS(252),
    [anon_sym_speculative_load_hardening] = ACTIONS(252),
    [anon_sym_speculatable] = ACTIONS(252),
    [anon_sym_ssp] = ACTIONS(252),
    [anon_sym_sspstrong] = ACTIONS(252),
    [anon_sym_sspreq] = ACTIONS(252),
    [anon_sym_strictfp] = ACTIONS(252),
    [anon_sym_nocf_check] = ACTIONS(252),
    [anon_sym_shadowcallstack] = ACTIONS(252),
    [anon_sym_mustprogress] = ACTIONS(252),
    [anon_sym_vscale_range] = ACTIONS(252),
    [anon_sym_preallocated] = ACTIONS(252),
    [anon_sym_zeroext] = ACTIONS(252),
    [anon_sym_signext] = ACTIONS(252),
    [anon_sym_inreg] = ACTIONS(252),
    [anon_sym_byval] = ACTIONS(252),
    [anon_sym_byref] = ACTIONS(252),
    [anon_sym_inalloca] = ACTIONS(252),
    [anon_sym_sret] = ACTIONS(252),
    [anon_sym_elementtype] = ACTIONS(252),
    [anon_sym_noalias] = ACTIONS(252),
    [anon_sym_nocapture] = ACTIONS(252),
    [anon_sym_nest] = ACTIONS(252),
    [anon_sym_returned] = ACTIONS(252),
    [anon_sym_nonnull] = ACTIONS(252),
    [anon_sym_dereferenceable] = ACTIONS(252),
    [anon_sym_dereferenceable_or_null] = ACTIONS(252),
    [anon_sym_swiftself] = ACTIONS(252),
    [anon_sym_swiftasync] = ACTIONS(252),
    [anon_sym_swifterror] = ACTIONS(252),
    [anon_sym_immarg] = ACTIONS(252),
    [anon_sym_noundef] = ACTIONS(252),
    [anon_sym_uwtable] = ACTIONS(252),
    [anon_sym_memory] = ACTIONS(252),
    [anon_sym_none] = ACTIONS(252),
    [anon_sym_unreachable] = ACTIONS(252),
    [anon_sym_ret] = ACTIONS(252),
    [anon_sym_br] = ACTIONS(252),
    [anon_sym_resume] = ACTIONS(252),
    [anon_sym_freeze] = ACTIONS(252),
    [anon_sym_indirectbr] = ACTIONS(252),
    [anon_sym_extractelement] = ACTIONS(252),
    [anon_sym_insertelement] = ACTIONS(252),
    [anon_sym_select] = ACTIONS(252),
    [anon_sym_shufflevector] = ACTIONS(252),
    [anon_sym_fneg] = ACTIONS(252),
    [anon_sym_switch] = ACTIONS(252),
    [anon_sym_invoke] = ACTIONS(252),
    [anon_sym_cleanupret] = ACTIONS(252),
    [anon_sym_catchret] = ACTIONS(252),
    [anon_sym_catchswitch] = ACTIONS(252),
    [anon_sym_catchpad] = ACTIONS(252),
    [anon_sym_cleanuppad] = ACTIONS(252),
    [anon_sym_callbr] = ACTIONS(252),
    [anon_sym_icmp] = ACTIONS(252),
    [anon_sym_fcmp] = ACTIONS(252),
    [anon_sym_va_arg] = ACTIONS(252),
    [anon_sym_phi] = ACTIONS(252),
    [anon_sym_landingpad] = ACTIONS(252),
    [anon_sym_tail] = ACTIONS(252),
    [anon_sym_musttail] = ACTIONS(252),
    [anon_sym_notail] = ACTIONS(252),
    [anon_sym_call] = ACTIONS(252),
    [anon_sym_alloca] = ACTIONS(252),
    [anon_sym_load] = ACTIONS(252),
    [anon_sym_store] = ACTIONS(252),
    [anon_sym_cmpxchg] = ACTIONS(252),
    [anon_sym_atomicrmw] = ACTIONS(252),
    [anon_sym_fence] = ACTIONS(252),
    [anon_sym_getelementptr] = ACTIONS(252),
    [anon_sym_extractvalue] = ACTIONS(252),
    [anon_sym_insertvalue] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(252),
    [anon_sym_false] = ACTIONS(252),
    [anon_sym_null] = ACTIONS(252),
    [anon_sym_undef] = ACTIONS(252),
    [anon_sym_poison] = ACTIONS(252),
    [anon_sym_zeroinitializer] = ACTIONS(252),
    [anon_sym_blockaddress] = ACTIONS(252),
    [anon_sym_mul] = ACTIONS(252),
    [anon_sym_urem] = ACTIONS(252),
    [anon_sym_srem] = ACTIONS(252),
    [anon_sym_shl] = ACTIONS(252),
    [anon_sym_udiv] = ACTIONS(252),
    [anon_sym_sdiv] = ACTIONS(252),
    [anon_sym_lshr] = ACTIONS(252),
    [anon_sym_ashr] = ACTIONS(252),
    [anon_sym_fmul] = ACTIONS(252),
    [anon_sym_fdiv] = ACTIONS(252),
    [anon_sym_frem] = ACTIONS(252),
    [anon_sym_xchg] = ACTIONS(252),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(252),
    [anon_sym_and] = ACTIONS(252),
    [anon_sym_nand] = ACTIONS(252),
    [anon_sym_or] = ACTIONS(252),
    [anon_sym_xor] = ACTIONS(252),
    [anon_sym_max] = ACTIONS(252),
    [anon_sym_min] = ACTIONS(252),
    [anon_sym_umax] = ACTIONS(252),
    [anon_sym_umin] = ACTIONS(252),
    [anon_sym_fadd] = ACTIONS(252),
    [anon_sym_fsub] = ACTIONS(252),
    [anon_sym_bitcast] = ACTIONS(252),
    [anon_sym_trunc] = ACTIONS(252),
    [anon_sym_zext] = ACTIONS(252),
    [anon_sym_sext] = ACTIONS(252),
    [anon_sym_fptrunc] = ACTIONS(252),
    [anon_sym_fpext] = ACTIONS(252),
    [anon_sym_addrspacecast] = ACTIONS(252),
    [anon_sym_uitofp] = ACTIONS(252),
    [anon_sym_sitofp] = ACTIONS(252),
    [anon_sym_fptoui] = ACTIONS(252),
    [anon_sym_fptosi] = ACTIONS(252),
    [anon_sym_inttoptr] = ACTIONS(252),
    [anon_sym_ptrtoint] = ACTIONS(252),
    [anon_sym_uselistorder] = ACTIONS(252),
  },
  [32] = {
    [sym_addrspace] = STATE(53),
    [sym_argument_list] = STATE(31),
    [aux_sym_type_repeat1] = STATE(34),
    [aux_sym_type_repeat2] = STATE(31),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(244),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [sym_label] = ACTIONS(244),
    [sym_string] = ACTIONS(246),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(246),
    [sym_float] = ACTIONS(246),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(246),
    [anon_sym_private] = ACTIONS(246),
    [anon_sym_internal] = ACTIONS(246),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(246),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(246),
    [anon_sym_available_externally] = ACTIONS(246),
    [anon_sym_appending] = ACTIONS(246),
    [anon_sym_common] = ACTIONS(246),
    [anon_sym_extern_weak] = ACTIONS(246),
    [anon_sym_external] = ACTIONS(246),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(246),
    [anon_sym_dso_preemptable] = ACTIONS(246),
    [anon_sym_default] = ACTIONS(246),
    [anon_sym_hidden] = ACTIONS(246),
    [anon_sym_protected] = ACTIONS(246),
    [anon_sym_dllimport] = ACTIONS(246),
    [anon_sym_dllexport] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(403),
    [anon_sym_LPAREN] = ACTIONS(405),
    [anon_sym_align] = ACTIONS(246),
    [anon_sym_section] = ACTIONS(246),
    [anon_sym_partition] = ACTIONS(246),
    [anon_sym_comdat] = ACTIONS(246),
    [anon_sym_gc] = ACTIONS(246),
    [anon_sym_prefix] = ACTIONS(246),
    [anon_sym_prologue] = ACTIONS(246),
    [anon_sym_personality] = ACTIONS(246),
    [anon_sym_alignstack] = ACTIONS(246),
    [anon_sym_allocsize] = ACTIONS(246),
    [anon_sym_alwaysinline] = ACTIONS(246),
    [anon_sym_builtin] = ACTIONS(246),
    [anon_sym_cold] = ACTIONS(246),
    [anon_sym_convergent] = ACTIONS(246),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(246),
    [anon_sym_hot] = ACTIONS(246),
    [anon_sym_inaccessiblememonly] = ACTIONS(246),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(246),
    [anon_sym_inlinehint] = ACTIONS(246),
    [anon_sym_jumptable] = ACTIONS(246),
    [anon_sym_minsize] = ACTIONS(246),
    [anon_sym_naked] = ACTIONS(246),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(246),
    [anon_sym_nobuiltin] = ACTIONS(246),
    [anon_sym_noduplicate] = ACTIONS(246),
    [anon_sym_nofree] = ACTIONS(246),
    [anon_sym_noimplicitfloat] = ACTIONS(246),
    [anon_sym_noinline] = ACTIONS(246),
    [anon_sym_nomerge] = ACTIONS(246),
    [anon_sym_nonlazybind] = ACTIONS(246),
    [anon_sym_noprofile] = ACTIONS(246),
    [anon_sym_noredzone] = ACTIONS(246),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(246),
    [anon_sym_noreturn] = ACTIONS(246),
    [anon_sym_norecurse] = ACTIONS(246),
    [anon_sym_willreturn] = ACTIONS(246),
    [anon_sym_nosync] = ACTIONS(246),
    [anon_sym_nounwind] = ACTIONS(246),
    [anon_sym_nocallback] = ACTIONS(246),
    [anon_sym_nosanitize_coverage] = ACTIONS(246),
    [anon_sym_null_pointer_is_valid] = ACTIONS(246),
    [anon_sym_optforfuzzing] = ACTIONS(246),
    [anon_sym_optnone] = ACTIONS(246),
    [anon_sym_optsize] = ACTIONS(246),
    [anon_sym_readnone] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_writeonly] = ACTIONS(246),
    [anon_sym_argmemonly] = ACTIONS(246),
    [anon_sym_returns_twice] = ACTIONS(246),
    [anon_sym_safestack] = ACTIONS(246),
    [anon_sym_sanitize_address] = ACTIONS(246),
    [anon_sym_sanitize_memory] = ACTIONS(246),
    [anon_sym_sanitize_thread] = ACTIONS(246),
    [anon_sym_sanitize_hwaddress] = ACTIONS(246),
    [anon_sym_sanitize_memtag] = ACTIONS(246),
    [anon_sym_speculative_load_hardening] = ACTIONS(246),
    [anon_sym_speculatable] = ACTIONS(246),
    [anon_sym_ssp] = ACTIONS(246),
    [anon_sym_sspstrong] = ACTIONS(246),
    [anon_sym_sspreq] = ACTIONS(246),
    [anon_sym_strictfp] = ACTIONS(246),
    [anon_sym_nocf_check] = ACTIONS(246),
    [anon_sym_shadowcallstack] = ACTIONS(246),
    [anon_sym_mustprogress] = ACTIONS(246),
    [anon_sym_vscale_range] = ACTIONS(246),
    [anon_sym_preallocated] = ACTIONS(246),
    [anon_sym_zeroext] = ACTIONS(246),
    [anon_sym_signext] = ACTIONS(246),
    [anon_sym_inreg] = ACTIONS(246),
    [anon_sym_byval] = ACTIONS(246),
    [anon_sym_byref] = ACTIONS(246),
    [anon_sym_inalloca] = ACTIONS(246),
    [anon_sym_sret] = ACTIONS(246),
    [anon_sym_elementtype] = ACTIONS(246),
    [anon_sym_noalias] = ACTIONS(246),
    [anon_sym_nocapture] = ACTIONS(246),
    [anon_sym_nest] = ACTIONS(246),
    [anon_sym_returned] = ACTIONS(246),
    [anon_sym_nonnull] = ACTIONS(246),
    [anon_sym_dereferenceable] = ACTIONS(246),
    [anon_sym_dereferenceable_or_null] = ACTIONS(246),
    [anon_sym_swiftself] = ACTIONS(246),
    [anon_sym_swiftasync] = ACTIONS(246),
    [anon_sym_swifterror] = ACTIONS(246),
    [anon_sym_immarg] = ACTIONS(246),
    [anon_sym_noundef] = ACTIONS(246),
    [anon_sym_uwtable] = ACTIONS(246),
    [anon_sym_memory] = ACTIONS(246),
    [anon_sym_none] = ACTIONS(246),
    [anon_sym_unreachable] = ACTIONS(246),
    [anon_sym_ret] = ACTIONS(246),
    [anon_sym_br] = ACTIONS(246),
    [anon_sym_resume] = ACTIONS(246),
    [anon_sym_freeze] = ACTIONS(246),
    [anon_sym_indirectbr] = ACTIONS(246),
    [anon_sym_extractelement] = ACTIONS(246),
    [anon_sym_insertelement] = ACTIONS(246),
    [anon_sym_select] = ACTIONS(246),
    [anon_sym_shufflevector] = ACTIONS(246),
    [anon_sym_fneg] = ACTIONS(246),
    [anon_sym_switch] = ACTIONS(246),
    [anon_sym_invoke] = ACTIONS(246),
    [anon_sym_cleanupret] = ACTIONS(246),
    [anon_sym_catchret] = ACTIONS(246),
    [anon_sym_catchswitch] = ACTIONS(246),
    [anon_sym_catchpad] = ACTIONS(246),
    [anon_sym_cleanuppad] = ACTIONS(246),
    [anon_sym_callbr] = ACTIONS(246),
    [anon_sym_icmp] = ACTIONS(246),
    [anon_sym_fcmp] = ACTIONS(246),
    [anon_sym_va_arg] = ACTIONS(246),
    [anon_sym_phi] = ACTIONS(246),
    [anon_sym_landingpad] = ACTIONS(246),
    [anon_sym_tail] = ACTIONS(246),
    [anon_sym_musttail] = ACTIONS(246),
    [anon_sym_notail] = ACTIONS(246),
    [anon_sym_call] = ACTIONS(246),
    [anon_sym_alloca] = ACTIONS(246),
    [anon_sym_load] = ACTIONS(246),
    [anon_sym_store] = ACTIONS(246),
    [anon_sym_cmpxchg] = ACTIONS(246),
    [anon_sym_atomicrmw] = ACTIONS(246),
    [anon_sym_fence] = ACTIONS(246),
    [anon_sym_getelementptr] = ACTIONS(246),
    [anon_sym_extractvalue] = ACTIONS(246),
    [anon_sym_insertvalue] = ACTIONS(246),
    [anon_sym_true] = ACTIONS(246),
    [anon_sym_false] = ACTIONS(246),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_undef] = ACTIONS(246),
    [anon_sym_poison] = ACTIONS(246),
    [anon_sym_zeroinitializer] = ACTIONS(246),
    [anon_sym_blockaddress] = ACTIONS(246),
    [anon_sym_mul] = ACTIONS(246),
    [anon_sym_urem] = ACTIONS(246),
    [anon_sym_srem] = ACTIONS(246),
    [anon_sym_shl] = ACTIONS(246),
    [anon_sym_udiv] = ACTIONS(246),
    [anon_sym_sdiv] = ACTIONS(246),
    [anon_sym_lshr] = ACTIONS(246),
    [anon_sym_ashr] = ACTIONS(246),
    [anon_sym_fmul] = ACTIONS(246),
    [anon_sym_fdiv] = ACTIONS(246),
    [anon_sym_frem] = ACTIONS(246),
    [anon_sym_xchg] = ACTIONS(246),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(246),
    [anon_sym_and] = ACTIONS(246),
    [anon_sym_nand] = ACTIONS(246),
    [anon_sym_or] = ACTIONS(246),
    [anon_sym_xor] = ACTIONS(246),
    [anon_sym_max] = ACTIONS(246),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(246),
    [anon_sym_umin] = ACTIONS(246),
    [anon_sym_fadd] = ACTIONS(246),
    [anon_sym_fsub] = ACTIONS(246),
    [anon_sym_bitcast] = ACTIONS(246),
    [anon_sym_trunc] = ACTIONS(246),
    [anon_sym_zext] = ACTIONS(246),
    [anon_sym_sext] = ACTIONS(246),
    [anon_sym_fptrunc] = ACTIONS(246),
    [anon_sym_fpext] = ACTIONS(246),
    [anon_sym_addrspacecast] = ACTIONS(246),
    [anon_sym_uitofp] = ACTIONS(246),
    [anon_sym_sitofp] = ACTIONS(246),
    [anon_sym_fptoui] = ACTIONS(246),
    [anon_sym_fptosi] = ACTIONS(246),
    [anon_sym_inttoptr] = ACTIONS(246),
    [anon_sym_ptrtoint] = ACTIONS(246),
    [anon_sym_uselistorder] = ACTIONS(246),
  },
  [33] = {
    [sym_addrspace] = STATE(53),
    [sym_argument_list] = STATE(40),
    [aux_sym_type_repeat1] = STATE(35),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(244),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [sym_label] = ACTIONS(244),
    [sym_string] = ACTIONS(246),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(246),
    [sym_float] = ACTIONS(246),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(246),
    [anon_sym_private] = ACTIONS(246),
    [anon_sym_internal] = ACTIONS(246),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(246),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(246),
    [anon_sym_available_externally] = ACTIONS(246),
    [anon_sym_appending] = ACTIONS(246),
    [anon_sym_common] = ACTIONS(246),
    [anon_sym_extern_weak] = ACTIONS(246),
    [anon_sym_external] = ACTIONS(246),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(246),
    [anon_sym_dso_preemptable] = ACTIONS(246),
    [anon_sym_default] = ACTIONS(246),
    [anon_sym_hidden] = ACTIONS(246),
    [anon_sym_protected] = ACTIONS(246),
    [anon_sym_dllimport] = ACTIONS(246),
    [anon_sym_dllexport] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(415),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(403),
    [anon_sym_LPAREN] = ACTIONS(405),
    [anon_sym_align] = ACTIONS(246),
    [anon_sym_section] = ACTIONS(246),
    [anon_sym_partition] = ACTIONS(246),
    [anon_sym_comdat] = ACTIONS(246),
    [anon_sym_gc] = ACTIONS(246),
    [anon_sym_prefix] = ACTIONS(246),
    [anon_sym_prologue] = ACTIONS(246),
    [anon_sym_personality] = ACTIONS(246),
    [anon_sym_alignstack] = ACTIONS(246),
    [anon_sym_allocsize] = ACTIONS(246),
    [anon_sym_alwaysinline] = ACTIONS(246),
    [anon_sym_builtin] = ACTIONS(246),
    [anon_sym_cold] = ACTIONS(246),
    [anon_sym_convergent] = ACTIONS(246),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(246),
    [anon_sym_hot] = ACTIONS(246),
    [anon_sym_inaccessiblememonly] = ACTIONS(246),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(246),
    [anon_sym_inlinehint] = ACTIONS(246),
    [anon_sym_jumptable] = ACTIONS(246),
    [anon_sym_minsize] = ACTIONS(246),
    [anon_sym_naked] = ACTIONS(246),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(246),
    [anon_sym_nobuiltin] = ACTIONS(246),
    [anon_sym_noduplicate] = ACTIONS(246),
    [anon_sym_nofree] = ACTIONS(246),
    [anon_sym_noimplicitfloat] = ACTIONS(246),
    [anon_sym_noinline] = ACTIONS(246),
    [anon_sym_nomerge] = ACTIONS(246),
    [anon_sym_nonlazybind] = ACTIONS(246),
    [anon_sym_noprofile] = ACTIONS(246),
    [anon_sym_noredzone] = ACTIONS(246),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(246),
    [anon_sym_noreturn] = ACTIONS(246),
    [anon_sym_norecurse] = ACTIONS(246),
    [anon_sym_willreturn] = ACTIONS(246),
    [anon_sym_nosync] = ACTIONS(246),
    [anon_sym_nounwind] = ACTIONS(246),
    [anon_sym_nocallback] = ACTIONS(246),
    [anon_sym_nosanitize_coverage] = ACTIONS(246),
    [anon_sym_null_pointer_is_valid] = ACTIONS(246),
    [anon_sym_optforfuzzing] = ACTIONS(246),
    [anon_sym_optnone] = ACTIONS(246),
    [anon_sym_optsize] = ACTIONS(246),
    [anon_sym_readnone] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_writeonly] = ACTIONS(246),
    [anon_sym_argmemonly] = ACTIONS(246),
    [anon_sym_returns_twice] = ACTIONS(246),
    [anon_sym_safestack] = ACTIONS(246),
    [anon_sym_sanitize_address] = ACTIONS(246),
    [anon_sym_sanitize_memory] = ACTIONS(246),
    [anon_sym_sanitize_thread] = ACTIONS(246),
    [anon_sym_sanitize_hwaddress] = ACTIONS(246),
    [anon_sym_sanitize_memtag] = ACTIONS(246),
    [anon_sym_speculative_load_hardening] = ACTIONS(246),
    [anon_sym_speculatable] = ACTIONS(246),
    [anon_sym_ssp] = ACTIONS(246),
    [anon_sym_sspstrong] = ACTIONS(246),
    [anon_sym_sspreq] = ACTIONS(246),
    [anon_sym_strictfp] = ACTIONS(246),
    [anon_sym_nocf_check] = ACTIONS(246),
    [anon_sym_shadowcallstack] = ACTIONS(246),
    [anon_sym_mustprogress] = ACTIONS(246),
    [anon_sym_vscale_range] = ACTIONS(246),
    [anon_sym_preallocated] = ACTIONS(246),
    [anon_sym_zeroext] = ACTIONS(246),
    [anon_sym_signext] = ACTIONS(246),
    [anon_sym_inreg] = ACTIONS(246),
    [anon_sym_byval] = ACTIONS(246),
    [anon_sym_byref] = ACTIONS(246),
    [anon_sym_inalloca] = ACTIONS(246),
    [anon_sym_sret] = ACTIONS(246),
    [anon_sym_elementtype] = ACTIONS(246),
    [anon_sym_noalias] = ACTIONS(246),
    [anon_sym_nocapture] = ACTIONS(246),
    [anon_sym_nest] = ACTIONS(246),
    [anon_sym_returned] = ACTIONS(246),
    [anon_sym_nonnull] = ACTIONS(246),
    [anon_sym_dereferenceable] = ACTIONS(246),
    [anon_sym_dereferenceable_or_null] = ACTIONS(246),
    [anon_sym_swiftself] = ACTIONS(246),
    [anon_sym_swiftasync] = ACTIONS(246),
    [anon_sym_swifterror] = ACTIONS(246),
    [anon_sym_immarg] = ACTIONS(246),
    [anon_sym_noundef] = ACTIONS(246),
    [anon_sym_uwtable] = ACTIONS(246),
    [anon_sym_memory] = ACTIONS(246),
    [anon_sym_none] = ACTIONS(246),
    [anon_sym_unreachable] = ACTIONS(246),
    [anon_sym_ret] = ACTIONS(246),
    [anon_sym_br] = ACTIONS(246),
    [anon_sym_resume] = ACTIONS(246),
    [anon_sym_freeze] = ACTIONS(246),
    [anon_sym_indirectbr] = ACTIONS(246),
    [anon_sym_extractelement] = ACTIONS(246),
    [anon_sym_insertelement] = ACTIONS(246),
    [anon_sym_select] = ACTIONS(246),
    [anon_sym_shufflevector] = ACTIONS(246),
    [anon_sym_fneg] = ACTIONS(246),
    [anon_sym_switch] = ACTIONS(246),
    [anon_sym_invoke] = ACTIONS(246),
    [anon_sym_cleanupret] = ACTIONS(246),
    [anon_sym_catchret] = ACTIONS(246),
    [anon_sym_catchswitch] = ACTIONS(246),
    [anon_sym_catchpad] = ACTIONS(246),
    [anon_sym_cleanuppad] = ACTIONS(246),
    [anon_sym_callbr] = ACTIONS(246),
    [anon_sym_icmp] = ACTIONS(246),
    [anon_sym_fcmp] = ACTIONS(246),
    [anon_sym_va_arg] = ACTIONS(246),
    [anon_sym_phi] = ACTIONS(246),
    [anon_sym_landingpad] = ACTIONS(246),
    [anon_sym_tail] = ACTIONS(246),
    [anon_sym_musttail] = ACTIONS(246),
    [anon_sym_notail] = ACTIONS(246),
    [anon_sym_call] = ACTIONS(246),
    [anon_sym_alloca] = ACTIONS(246),
    [anon_sym_load] = ACTIONS(246),
    [anon_sym_store] = ACTIONS(246),
    [anon_sym_cmpxchg] = ACTIONS(246),
    [anon_sym_atomicrmw] = ACTIONS(246),
    [anon_sym_fence] = ACTIONS(246),
    [anon_sym_getelementptr] = ACTIONS(246),
    [anon_sym_extractvalue] = ACTIONS(246),
    [anon_sym_insertvalue] = ACTIONS(246),
    [anon_sym_true] = ACTIONS(246),
    [anon_sym_false] = ACTIONS(246),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_undef] = ACTIONS(246),
    [anon_sym_poison] = ACTIONS(246),
    [anon_sym_zeroinitializer] = ACTIONS(246),
    [anon_sym_blockaddress] = ACTIONS(246),
    [anon_sym_mul] = ACTIONS(246),
    [anon_sym_urem] = ACTIONS(246),
    [anon_sym_srem] = ACTIONS(246),
    [anon_sym_shl] = ACTIONS(246),
    [anon_sym_udiv] = ACTIONS(246),
    [anon_sym_sdiv] = ACTIONS(246),
    [anon_sym_lshr] = ACTIONS(246),
    [anon_sym_ashr] = ACTIONS(246),
    [anon_sym_fmul] = ACTIONS(246),
    [anon_sym_fdiv] = ACTIONS(246),
    [anon_sym_frem] = ACTIONS(246),
    [anon_sym_xchg] = ACTIONS(246),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(246),
    [anon_sym_and] = ACTIONS(246),
    [anon_sym_nand] = ACTIONS(246),
    [anon_sym_or] = ACTIONS(246),
    [anon_sym_xor] = ACTIONS(246),
    [anon_sym_max] = ACTIONS(246),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(246),
    [anon_sym_umin] = ACTIONS(246),
    [anon_sym_fadd] = ACTIONS(246),
    [anon_sym_fsub] = ACTIONS(246),
    [anon_sym_bitcast] = ACTIONS(246),
    [anon_sym_trunc] = ACTIONS(246),
    [anon_sym_zext] = ACTIONS(246),
    [anon_sym_sext] = ACTIONS(246),
    [anon_sym_fptrunc] = ACTIONS(246),
    [anon_sym_fpext] = ACTIONS(246),
    [anon_sym_addrspacecast] = ACTIONS(246),
    [anon_sym_uitofp] = ACTIONS(246),
    [anon_sym_sitofp] = ACTIONS(246),
    [anon_sym_fptoui] = ACTIONS(246),
    [anon_sym_fptosi] = ACTIONS(246),
    [anon_sym_inttoptr] = ACTIONS(246),
    [anon_sym_ptrtoint] = ACTIONS(246),
    [anon_sym_uselistorder] = ACTIONS(246),
  },
  [34] = {
    [sym_addrspace] = STATE(50),
    [sym_argument_list] = STATE(40),
    [aux_sym_type_repeat1] = STATE(35),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(263),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [sym_label] = ACTIONS(263),
    [sym_string] = ACTIONS(265),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(265),
    [sym_float] = ACTIONS(265),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(265),
    [anon_sym_private] = ACTIONS(265),
    [anon_sym_internal] = ACTIONS(265),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(265),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(265),
    [anon_sym_available_externally] = ACTIONS(265),
    [anon_sym_appending] = ACTIONS(265),
    [anon_sym_common] = ACTIONS(265),
    [anon_sym_extern_weak] = ACTIONS(265),
    [anon_sym_external] = ACTIONS(265),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(265),
    [anon_sym_dso_preemptable] = ACTIONS(265),
    [anon_sym_default] = ACTIONS(265),
    [anon_sym_hidden] = ACTIONS(265),
    [anon_sym_protected] = ACTIONS(265),
    [anon_sym_dllimport] = ACTIONS(265),
    [anon_sym_dllexport] = ACTIONS(265),
    [anon_sym_STAR] = ACTIONS(415),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_addrspace] = ACTIONS(403),
    [anon_sym_LPAREN] = ACTIONS(405),
    [anon_sym_align] = ACTIONS(265),
    [anon_sym_section] = ACTIONS(265),
    [anon_sym_partition] = ACTIONS(265),
    [anon_sym_comdat] = ACTIONS(265),
    [anon_sym_gc] = ACTIONS(265),
    [anon_sym_prefix] = ACTIONS(265),
    [anon_sym_prologue] = ACTIONS(265),
    [anon_sym_personality] = ACTIONS(265),
    [anon_sym_alignstack] = ACTIONS(265),
    [anon_sym_allocsize] = ACTIONS(265),
    [anon_sym_alwaysinline] = ACTIONS(265),
    [anon_sym_builtin] = ACTIONS(265),
    [anon_sym_cold] = ACTIONS(265),
    [anon_sym_convergent] = ACTIONS(265),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(265),
    [anon_sym_hot] = ACTIONS(265),
    [anon_sym_inaccessiblememonly] = ACTIONS(265),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(265),
    [anon_sym_inlinehint] = ACTIONS(265),
    [anon_sym_jumptable] = ACTIONS(265),
    [anon_sym_minsize] = ACTIONS(265),
    [anon_sym_naked] = ACTIONS(265),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(265),
    [anon_sym_nobuiltin] = ACTIONS(265),
    [anon_sym_noduplicate] = ACTIONS(265),
    [anon_sym_nofree] = ACTIONS(265),
    [anon_sym_noimplicitfloat] = ACTIONS(265),
    [anon_sym_noinline] = ACTIONS(265),
    [anon_sym_nomerge] = ACTIONS(265),
    [anon_sym_nonlazybind] = ACTIONS(265),
    [anon_sym_noprofile] = ACTIONS(265),
    [anon_sym_noredzone] = ACTIONS(265),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(265),
    [anon_sym_noreturn] = ACTIONS(265),
    [anon_sym_norecurse] = ACTIONS(265),
    [anon_sym_willreturn] = ACTIONS(265),
    [anon_sym_nosync] = ACTIONS(265),
    [anon_sym_nounwind] = ACTIONS(265),
    [anon_sym_nocallback] = ACTIONS(265),
    [anon_sym_nosanitize_coverage] = ACTIONS(265),
    [anon_sym_null_pointer_is_valid] = ACTIONS(265),
    [anon_sym_optforfuzzing] = ACTIONS(265),
    [anon_sym_optnone] = ACTIONS(265),
    [anon_sym_optsize] = ACTIONS(265),
    [anon_sym_readnone] = ACTIONS(265),
    [anon_sym_readonly] = ACTIONS(265),
    [anon_sym_writeonly] = ACTIONS(265),
    [anon_sym_argmemonly] = ACTIONS(265),
    [anon_sym_returns_twice] = ACTIONS(265),
    [anon_sym_safestack] = ACTIONS(265),
    [anon_sym_sanitize_address] = ACTIONS(265),
    [anon_sym_sanitize_memory] = ACTIONS(265),
    [anon_sym_sanitize_thread] = ACTIONS(265),
    [anon_sym_sanitize_hwaddress] = ACTIONS(265),
    [anon_sym_sanitize_memtag] = ACTIONS(265),
    [anon_sym_speculative_load_hardening] = ACTIONS(265),
    [anon_sym_speculatable] = ACTIONS(265),
    [anon_sym_ssp] = ACTIONS(265),
    [anon_sym_sspstrong] = ACTIONS(265),
    [anon_sym_sspreq] = ACTIONS(265),
    [anon_sym_strictfp] = ACTIONS(265),
    [anon_sym_nocf_check] = ACTIONS(265),
    [anon_sym_shadowcallstack] = ACTIONS(265),
    [anon_sym_mustprogress] = ACTIONS(265),
    [anon_sym_vscale_range] = ACTIONS(265),
    [anon_sym_preallocated] = ACTIONS(265),
    [anon_sym_zeroext] = ACTIONS(265),
    [anon_sym_signext] = ACTIONS(265),
    [anon_sym_inreg] = ACTIONS(265),
    [anon_sym_byval] = ACTIONS(265),
    [anon_sym_byref] = ACTIONS(265),
    [anon_sym_inalloca] = ACTIONS(265),
    [anon_sym_sret] = ACTIONS(265),
    [anon_sym_elementtype] = ACTIONS(265),
    [anon_sym_noalias] = ACTIONS(265),
    [anon_sym_nocapture] = ACTIONS(265),
    [anon_sym_nest] = ACTIONS(265),
    [anon_sym_returned] = ACTIONS(265),
    [anon_sym_nonnull] = ACTIONS(265),
    [anon_sym_dereferenceable] = ACTIONS(265),
    [anon_sym_dereferenceable_or_null] = ACTIONS(265),
    [anon_sym_swiftself] = ACTIONS(265),
    [anon_sym_swiftasync] = ACTIONS(265),
    [anon_sym_swifterror] = ACTIONS(265),
    [anon_sym_immarg] = ACTIONS(265),
    [anon_sym_noundef] = ACTIONS(265),
    [anon_sym_uwtable] = ACTIONS(265),
    [anon_sym_memory] = ACTIONS(265),
    [anon_sym_none] = ACTIONS(265),
    [anon_sym_unreachable] = ACTIONS(265),
    [anon_sym_ret] = ACTIONS(265),
    [anon_sym_br] = ACTIONS(265),
    [anon_sym_resume] = ACTIONS(265),
    [anon_sym_freeze] = ACTIONS(265),
    [anon_sym_indirectbr] = ACTIONS(265),
    [anon_sym_extractelement] = ACTIONS(265),
    [anon_sym_insertelement] = ACTIONS(265),
    [anon_sym_select] = ACTIONS(265),
    [anon_sym_shufflevector] = ACTIONS(265),
    [anon_sym_fneg] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(265),
    [anon_sym_invoke] = ACTIONS(265),
    [anon_sym_cleanupret] = ACTIONS(265),
    [anon_sym_catchret] = ACTIONS(265),
    [anon_sym_catchswitch] = ACTIONS(265),
    [anon_sym_catchpad] = ACTIONS(265),
    [anon_sym_cleanuppad] = ACTIONS(265),
    [anon_sym_callbr] = ACTIONS(265),
    [anon_sym_icmp] = ACTIONS(265),
    [anon_sym_fcmp] = ACTIONS(265),
    [anon_sym_va_arg] = ACTIONS(265),
    [anon_sym_phi] = ACTIONS(265),
    [anon_sym_landingpad] = ACTIONS(265),
    [anon_sym_tail] = ACTIONS(265),
    [anon_sym_musttail] = ACTIONS(265),
    [anon_sym_notail] = ACTIONS(265),
    [anon_sym_call] = ACTIONS(265),
    [anon_sym_alloca] = ACTIONS(265),
    [anon_sym_load] = ACTIONS(265),
    [anon_sym_store] = ACTIONS(265),
    [anon_sym_cmpxchg] = ACTIONS(265),
    [anon_sym_atomicrmw] = ACTIONS(265),
    [anon_sym_fence] = ACTIONS(265),
    [anon_sym_getelementptr] = ACTIONS(265),
    [anon_sym_extractvalue] = ACTIONS(265),
    [anon_sym_insertvalue] = ACTIONS(265),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [anon_sym_null] = ACTIONS(265),
    [anon_sym_undef] = ACTIONS(265),
    [anon_sym_poison] = ACTIONS(265),
    [anon_sym_zeroinitializer] = ACTIONS(265),
    [anon_sym_blockaddress] = ACTIONS(265),
    [anon_sym_mul] = ACTIONS(265),
    [anon_sym_urem] = ACTIONS(265),
    [anon_sym_srem] = ACTIONS(265),
    [anon_sym_shl] = ACTIONS(265),
    [anon_sym_udiv] = ACTIONS(265),
    [anon_sym_sdiv] = ACTIONS(265),
    [anon_sym_lshr] = ACTIONS(265),
    [anon_sym_ashr] = ACTIONS(265),
    [anon_sym_fmul] = ACTIONS(265),
    [anon_sym_fdiv] = ACTIONS(265),
    [anon_sym_frem] = ACTIONS(265),
    [anon_sym_xchg] = ACTIONS(265),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(265),
    [anon_sym_and] = ACTIONS(265),
    [anon_sym_nand] = ACTIONS(265),
    [anon_sym_or] = ACTIONS(265),
    [anon_sym_xor] = ACTIONS(265),
    [anon_sym_max] = ACTIONS(265),
    [anon_sym_min] = ACTIONS(265),
    [anon_sym_umax] = ACTIONS(265),
    [anon_sym_umin] = ACTIONS(265),
    [anon_sym_fadd] = ACTIONS(265),
    [anon_sym_fsub] = ACTIONS(265),
    [anon_sym_bitcast] = ACTIONS(265),
    [anon_sym_trunc] = ACTIONS(265),
    [anon_sym_zext] = ACTIONS(265),
    [anon_sym_sext] = ACTIONS(265),
    [anon_sym_fptrunc] = ACTIONS(265),
    [anon_sym_fpext] = ACTIONS(265),
    [anon_sym_addrspacecast] = ACTIONS(265),
    [anon_sym_uitofp] = ACTIONS(265),
    [anon_sym_sitofp] = ACTIONS(265),
    [anon_sym_fptoui] = ACTIONS(265),
    [anon_sym_fptosi] = ACTIONS(265),
    [anon_sym_inttoptr] = ACTIONS(265),
    [anon_sym_ptrtoint] = ACTIONS(265),
    [anon_sym_uselistorder] = ACTIONS(265),
  },
  [35] = {
    [sym_addrspace] = STATE(1895),
    [aux_sym_type_repeat1] = STATE(35),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(269),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [sym_label] = ACTIONS(269),
    [sym_string] = ACTIONS(271),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(271),
    [sym_float] = ACTIONS(271),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(271),
    [anon_sym_private] = ACTIONS(271),
    [anon_sym_internal] = ACTIONS(271),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(271),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(271),
    [anon_sym_available_externally] = ACTIONS(271),
    [anon_sym_appending] = ACTIONS(271),
    [anon_sym_common] = ACTIONS(271),
    [anon_sym_extern_weak] = ACTIONS(271),
    [anon_sym_external] = ACTIONS(271),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(271),
    [anon_sym_dso_preemptable] = ACTIONS(271),
    [anon_sym_default] = ACTIONS(271),
    [anon_sym_hidden] = ACTIONS(271),
    [anon_sym_protected] = ACTIONS(271),
    [anon_sym_dllimport] = ACTIONS(271),
    [anon_sym_dllexport] = ACTIONS(271),
    [anon_sym_STAR] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_align] = ACTIONS(271),
    [anon_sym_section] = ACTIONS(271),
    [anon_sym_partition] = ACTIONS(271),
    [anon_sym_comdat] = ACTIONS(271),
    [anon_sym_gc] = ACTIONS(271),
    [anon_sym_prefix] = ACTIONS(271),
    [anon_sym_prologue] = ACTIONS(271),
    [anon_sym_personality] = ACTIONS(271),
    [anon_sym_alignstack] = ACTIONS(271),
    [anon_sym_allocsize] = ACTIONS(271),
    [anon_sym_alwaysinline] = ACTIONS(271),
    [anon_sym_builtin] = ACTIONS(271),
    [anon_sym_cold] = ACTIONS(271),
    [anon_sym_convergent] = ACTIONS(271),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(271),
    [anon_sym_hot] = ACTIONS(271),
    [anon_sym_inaccessiblememonly] = ACTIONS(271),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(271),
    [anon_sym_inlinehint] = ACTIONS(271),
    [anon_sym_jumptable] = ACTIONS(271),
    [anon_sym_minsize] = ACTIONS(271),
    [anon_sym_naked] = ACTIONS(271),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(271),
    [anon_sym_nobuiltin] = ACTIONS(271),
    [anon_sym_noduplicate] = ACTIONS(271),
    [anon_sym_nofree] = ACTIONS(271),
    [anon_sym_noimplicitfloat] = ACTIONS(271),
    [anon_sym_noinline] = ACTIONS(271),
    [anon_sym_nomerge] = ACTIONS(271),
    [anon_sym_nonlazybind] = ACTIONS(271),
    [anon_sym_noprofile] = ACTIONS(271),
    [anon_sym_noredzone] = ACTIONS(271),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(271),
    [anon_sym_noreturn] = ACTIONS(271),
    [anon_sym_norecurse] = ACTIONS(271),
    [anon_sym_willreturn] = ACTIONS(271),
    [anon_sym_nosync] = ACTIONS(271),
    [anon_sym_nounwind] = ACTIONS(271),
    [anon_sym_nocallback] = ACTIONS(271),
    [anon_sym_nosanitize_coverage] = ACTIONS(271),
    [anon_sym_null_pointer_is_valid] = ACTIONS(271),
    [anon_sym_optforfuzzing] = ACTIONS(271),
    [anon_sym_optnone] = ACTIONS(271),
    [anon_sym_optsize] = ACTIONS(271),
    [anon_sym_readnone] = ACTIONS(271),
    [anon_sym_readonly] = ACTIONS(271),
    [anon_sym_writeonly] = ACTIONS(271),
    [anon_sym_argmemonly] = ACTIONS(271),
    [anon_sym_returns_twice] = ACTIONS(271),
    [anon_sym_safestack] = ACTIONS(271),
    [anon_sym_sanitize_address] = ACTIONS(271),
    [anon_sym_sanitize_memory] = ACTIONS(271),
    [anon_sym_sanitize_thread] = ACTIONS(271),
    [anon_sym_sanitize_hwaddress] = ACTIONS(271),
    [anon_sym_sanitize_memtag] = ACTIONS(271),
    [anon_sym_speculative_load_hardening] = ACTIONS(271),
    [anon_sym_speculatable] = ACTIONS(271),
    [anon_sym_ssp] = ACTIONS(271),
    [anon_sym_sspstrong] = ACTIONS(271),
    [anon_sym_sspreq] = ACTIONS(271),
    [anon_sym_strictfp] = ACTIONS(271),
    [anon_sym_nocf_check] = ACTIONS(271),
    [anon_sym_shadowcallstack] = ACTIONS(271),
    [anon_sym_mustprogress] = ACTIONS(271),
    [anon_sym_vscale_range] = ACTIONS(271),
    [anon_sym_preallocated] = ACTIONS(271),
    [anon_sym_zeroext] = ACTIONS(271),
    [anon_sym_signext] = ACTIONS(271),
    [anon_sym_inreg] = ACTIONS(271),
    [anon_sym_byval] = ACTIONS(271),
    [anon_sym_byref] = ACTIONS(271),
    [anon_sym_inalloca] = ACTIONS(271),
    [anon_sym_sret] = ACTIONS(271),
    [anon_sym_elementtype] = ACTIONS(271),
    [anon_sym_noalias] = ACTIONS(271),
    [anon_sym_nocapture] = ACTIONS(271),
    [anon_sym_nest] = ACTIONS(271),
    [anon_sym_returned] = ACTIONS(271),
    [anon_sym_nonnull] = ACTIONS(271),
    [anon_sym_dereferenceable] = ACTIONS(271),
    [anon_sym_dereferenceable_or_null] = ACTIONS(271),
    [anon_sym_swiftself] = ACTIONS(271),
    [anon_sym_swiftasync] = ACTIONS(271),
    [anon_sym_swifterror] = ACTIONS(271),
    [anon_sym_immarg] = ACTIONS(271),
    [anon_sym_noundef] = ACTIONS(271),
    [anon_sym_uwtable] = ACTIONS(271),
    [anon_sym_memory] = ACTIONS(271),
    [anon_sym_none] = ACTIONS(271),
    [anon_sym_unreachable] = ACTIONS(271),
    [anon_sym_ret] = ACTIONS(271),
    [anon_sym_br] = ACTIONS(271),
    [anon_sym_resume] = ACTIONS(271),
    [anon_sym_freeze] = ACTIONS(271),
    [anon_sym_indirectbr] = ACTIONS(271),
    [anon_sym_extractelement] = ACTIONS(271),
    [anon_sym_insertelement] = ACTIONS(271),
    [anon_sym_select] = ACTIONS(271),
    [anon_sym_shufflevector] = ACTIONS(271),
    [anon_sym_fneg] = ACTIONS(271),
    [anon_sym_switch] = ACTIONS(271),
    [anon_sym_invoke] = ACTIONS(271),
    [anon_sym_cleanupret] = ACTIONS(271),
    [anon_sym_catchret] = ACTIONS(271),
    [anon_sym_catchswitch] = ACTIONS(271),
    [anon_sym_catchpad] = ACTIONS(271),
    [anon_sym_cleanuppad] = ACTIONS(271),
    [anon_sym_callbr] = ACTIONS(271),
    [anon_sym_icmp] = ACTIONS(271),
    [anon_sym_fcmp] = ACTIONS(271),
    [anon_sym_va_arg] = ACTIONS(271),
    [anon_sym_phi] = ACTIONS(271),
    [anon_sym_landingpad] = ACTIONS(271),
    [anon_sym_tail] = ACTIONS(271),
    [anon_sym_musttail] = ACTIONS(271),
    [anon_sym_notail] = ACTIONS(271),
    [anon_sym_call] = ACTIONS(271),
    [anon_sym_alloca] = ACTIONS(271),
    [anon_sym_load] = ACTIONS(271),
    [anon_sym_store] = ACTIONS(271),
    [anon_sym_cmpxchg] = ACTIONS(271),
    [anon_sym_atomicrmw] = ACTIONS(271),
    [anon_sym_fence] = ACTIONS(271),
    [anon_sym_getelementptr] = ACTIONS(271),
    [anon_sym_extractvalue] = ACTIONS(271),
    [anon_sym_insertvalue] = ACTIONS(271),
    [anon_sym_true] = ACTIONS(271),
    [anon_sym_false] = ACTIONS(271),
    [anon_sym_null] = ACTIONS(271),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_poison] = ACTIONS(271),
    [anon_sym_zeroinitializer] = ACTIONS(271),
    [anon_sym_blockaddress] = ACTIONS(271),
    [anon_sym_mul] = ACTIONS(271),
    [anon_sym_urem] = ACTIONS(271),
    [anon_sym_srem] = ACTIONS(271),
    [anon_sym_shl] = ACTIONS(271),
    [anon_sym_udiv] = ACTIONS(271),
    [anon_sym_sdiv] = ACTIONS(271),
    [anon_sym_lshr] = ACTIONS(271),
    [anon_sym_ashr] = ACTIONS(271),
    [anon_sym_fmul] = ACTIONS(271),
    [anon_sym_fdiv] = ACTIONS(271),
    [anon_sym_frem] = ACTIONS(271),
    [anon_sym_xchg] = ACTIONS(271),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(271),
    [anon_sym_nand] = ACTIONS(271),
    [anon_sym_or] = ACTIONS(271),
    [anon_sym_xor] = ACTIONS(271),
    [anon_sym_max] = ACTIONS(271),
    [anon_sym_min] = ACTIONS(271),
    [anon_sym_umax] = ACTIONS(271),
    [anon_sym_umin] = ACTIONS(271),
    [anon_sym_fadd] = ACTIONS(271),
    [anon_sym_fsub] = ACTIONS(271),
    [anon_sym_bitcast] = ACTIONS(271),
    [anon_sym_trunc] = ACTIONS(271),
    [anon_sym_zext] = ACTIONS(271),
    [anon_sym_sext] = ACTIONS(271),
    [anon_sym_fptrunc] = ACTIONS(271),
    [anon_sym_fpext] = ACTIONS(271),
    [anon_sym_addrspacecast] = ACTIONS(271),
    [anon_sym_uitofp] = ACTIONS(271),
    [anon_sym_sitofp] = ACTIONS(271),
    [anon_sym_fptoui] = ACTIONS(271),
    [anon_sym_fptosi] = ACTIONS(271),
    [anon_sym_inttoptr] = ACTIONS(271),
    [anon_sym_ptrtoint] = ACTIONS(271),
    [anon_sym_uselistorder] = ACTIONS(271),
  },
  [36] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(116),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(116),
    [sym_label] = ACTIONS(116),
    [sym_string] = ACTIONS(122),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(122),
    [sym_float] = ACTIONS(122),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(122),
    [anon_sym_private] = ACTIONS(122),
    [anon_sym_internal] = ACTIONS(122),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(122),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(122),
    [anon_sym_available_externally] = ACTIONS(122),
    [anon_sym_appending] = ACTIONS(122),
    [anon_sym_common] = ACTIONS(122),
    [anon_sym_extern_weak] = ACTIONS(122),
    [anon_sym_external] = ACTIONS(122),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(122),
    [anon_sym_dso_preemptable] = ACTIONS(122),
    [anon_sym_default] = ACTIONS(122),
    [anon_sym_hidden] = ACTIONS(122),
    [anon_sym_protected] = ACTIONS(122),
    [anon_sym_dllimport] = ACTIONS(122),
    [anon_sym_dllexport] = ACTIONS(122),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(116),
    [anon_sym_RBRACE] = ACTIONS(116),
    [anon_sym_LT_LBRACE] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(116),
    [anon_sym_LT] = ACTIONS(122),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_align] = ACTIONS(122),
    [anon_sym_section] = ACTIONS(122),
    [anon_sym_partition] = ACTIONS(122),
    [anon_sym_comdat] = ACTIONS(122),
    [anon_sym_gc] = ACTIONS(122),
    [anon_sym_prefix] = ACTIONS(122),
    [anon_sym_prologue] = ACTIONS(122),
    [anon_sym_personality] = ACTIONS(122),
    [anon_sym_alignstack] = ACTIONS(122),
    [anon_sym_allocsize] = ACTIONS(122),
    [anon_sym_alwaysinline] = ACTIONS(122),
    [anon_sym_builtin] = ACTIONS(122),
    [anon_sym_cold] = ACTIONS(122),
    [anon_sym_convergent] = ACTIONS(122),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(122),
    [anon_sym_hot] = ACTIONS(122),
    [anon_sym_inaccessiblememonly] = ACTIONS(122),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(122),
    [anon_sym_inlinehint] = ACTIONS(122),
    [anon_sym_jumptable] = ACTIONS(122),
    [anon_sym_minsize] = ACTIONS(122),
    [anon_sym_naked] = ACTIONS(122),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(122),
    [anon_sym_nobuiltin] = ACTIONS(122),
    [anon_sym_noduplicate] = ACTIONS(122),
    [anon_sym_nofree] = ACTIONS(122),
    [anon_sym_noimplicitfloat] = ACTIONS(122),
    [anon_sym_noinline] = ACTIONS(122),
    [anon_sym_nomerge] = ACTIONS(122),
    [anon_sym_nonlazybind] = ACTIONS(122),
    [anon_sym_noprofile] = ACTIONS(122),
    [anon_sym_noredzone] = ACTIONS(122),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(122),
    [anon_sym_noreturn] = ACTIONS(122),
    [anon_sym_norecurse] = ACTIONS(122),
    [anon_sym_willreturn] = ACTIONS(122),
    [anon_sym_nosync] = ACTIONS(122),
    [anon_sym_nounwind] = ACTIONS(122),
    [anon_sym_nocallback] = ACTIONS(122),
    [anon_sym_nosanitize_coverage] = ACTIONS(122),
    [anon_sym_null_pointer_is_valid] = ACTIONS(122),
    [anon_sym_optforfuzzing] = ACTIONS(122),
    [anon_sym_optnone] = ACTIONS(122),
    [anon_sym_optsize] = ACTIONS(122),
    [anon_sym_readnone] = ACTIONS(122),
    [anon_sym_readonly] = ACTIONS(122),
    [anon_sym_writeonly] = ACTIONS(122),
    [anon_sym_argmemonly] = ACTIONS(122),
    [anon_sym_returns_twice] = ACTIONS(122),
    [anon_sym_safestack] = ACTIONS(122),
    [anon_sym_sanitize_address] = ACTIONS(122),
    [anon_sym_sanitize_memory] = ACTIONS(122),
    [anon_sym_sanitize_thread] = ACTIONS(122),
    [anon_sym_sanitize_hwaddress] = ACTIONS(122),
    [anon_sym_sanitize_memtag] = ACTIONS(122),
    [anon_sym_speculative_load_hardening] = ACTIONS(122),
    [anon_sym_speculatable] = ACTIONS(122),
    [anon_sym_ssp] = ACTIONS(122),
    [anon_sym_sspstrong] = ACTIONS(122),
    [anon_sym_sspreq] = ACTIONS(122),
    [anon_sym_strictfp] = ACTIONS(122),
    [anon_sym_nocf_check] = ACTIONS(122),
    [anon_sym_shadowcallstack] = ACTIONS(122),
    [anon_sym_mustprogress] = ACTIONS(122),
    [anon_sym_vscale_range] = ACTIONS(122),
    [anon_sym_preallocated] = ACTIONS(122),
    [anon_sym_zeroext] = ACTIONS(122),
    [anon_sym_signext] = ACTIONS(122),
    [anon_sym_inreg] = ACTIONS(122),
    [anon_sym_byval] = ACTIONS(122),
    [anon_sym_byref] = ACTIONS(122),
    [anon_sym_inalloca] = ACTIONS(122),
    [anon_sym_sret] = ACTIONS(122),
    [anon_sym_elementtype] = ACTIONS(122),
    [anon_sym_noalias] = ACTIONS(122),
    [anon_sym_nocapture] = ACTIONS(122),
    [anon_sym_nest] = ACTIONS(122),
    [anon_sym_returned] = ACTIONS(122),
    [anon_sym_nonnull] = ACTIONS(122),
    [anon_sym_dereferenceable] = ACTIONS(122),
    [anon_sym_dereferenceable_or_null] = ACTIONS(122),
    [anon_sym_swiftself] = ACTIONS(122),
    [anon_sym_swiftasync] = ACTIONS(122),
    [anon_sym_swifterror] = ACTIONS(122),
    [anon_sym_immarg] = ACTIONS(122),
    [anon_sym_noundef] = ACTIONS(122),
    [anon_sym_uwtable] = ACTIONS(122),
    [anon_sym_memory] = ACTIONS(122),
    [anon_sym_none] = ACTIONS(122),
    [anon_sym_unreachable] = ACTIONS(122),
    [anon_sym_ret] = ACTIONS(122),
    [anon_sym_br] = ACTIONS(122),
    [anon_sym_resume] = ACTIONS(122),
    [anon_sym_freeze] = ACTIONS(122),
    [anon_sym_indirectbr] = ACTIONS(122),
    [anon_sym_extractelement] = ACTIONS(122),
    [anon_sym_insertelement] = ACTIONS(122),
    [anon_sym_select] = ACTIONS(122),
    [anon_sym_shufflevector] = ACTIONS(122),
    [anon_sym_fneg] = ACTIONS(122),
    [anon_sym_switch] = ACTIONS(122),
    [anon_sym_invoke] = ACTIONS(122),
    [anon_sym_cleanupret] = ACTIONS(122),
    [anon_sym_catchret] = ACTIONS(122),
    [anon_sym_catchswitch] = ACTIONS(122),
    [anon_sym_catchpad] = ACTIONS(122),
    [anon_sym_cleanuppad] = ACTIONS(122),
    [anon_sym_callbr] = ACTIONS(122),
    [anon_sym_icmp] = ACTIONS(122),
    [anon_sym_fcmp] = ACTIONS(122),
    [anon_sym_va_arg] = ACTIONS(122),
    [anon_sym_phi] = ACTIONS(122),
    [anon_sym_landingpad] = ACTIONS(122),
    [anon_sym_tail] = ACTIONS(122),
    [anon_sym_musttail] = ACTIONS(122),
    [anon_sym_notail] = ACTIONS(122),
    [anon_sym_call] = ACTIONS(122),
    [anon_sym_alloca] = ACTIONS(122),
    [anon_sym_load] = ACTIONS(122),
    [anon_sym_store] = ACTIONS(122),
    [anon_sym_cmpxchg] = ACTIONS(122),
    [anon_sym_atomicrmw] = ACTIONS(122),
    [anon_sym_fence] = ACTIONS(122),
    [anon_sym_getelementptr] = ACTIONS(122),
    [anon_sym_extractvalue] = ACTIONS(122),
    [anon_sym_insertvalue] = ACTIONS(122),
    [anon_sym_true] = ACTIONS(122),
    [anon_sym_false] = ACTIONS(122),
    [anon_sym_null] = ACTIONS(122),
    [anon_sym_undef] = ACTIONS(122),
    [anon_sym_poison] = ACTIONS(122),
    [anon_sym_zeroinitializer] = ACTIONS(122),
    [anon_sym_blockaddress] = ACTIONS(122),
    [anon_sym_mul] = ACTIONS(122),
    [anon_sym_urem] = ACTIONS(122),
    [anon_sym_srem] = ACTIONS(122),
    [anon_sym_shl] = ACTIONS(122),
    [anon_sym_udiv] = ACTIONS(122),
    [anon_sym_sdiv] = ACTIONS(122),
    [anon_sym_lshr] = ACTIONS(122),
    [anon_sym_ashr] = ACTIONS(122),
    [anon_sym_fmul] = ACTIONS(122),
    [anon_sym_fdiv] = ACTIONS(122),
    [anon_sym_frem] = ACTIONS(122),
    [anon_sym_xchg] = ACTIONS(122),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(122),
    [anon_sym_and] = ACTIONS(122),
    [anon_sym_nand] = ACTIONS(122),
    [anon_sym_or] = ACTIONS(122),
    [anon_sym_xor] = ACTIONS(122),
    [anon_sym_max] = ACTIONS(122),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(122),
    [anon_sym_umin] = ACTIONS(122),
    [anon_sym_fadd] = ACTIONS(122),
    [anon_sym_fsub] = ACTIONS(122),
    [anon_sym_bitcast] = ACTIONS(122),
    [anon_sym_trunc] = ACTIONS(122),
    [anon_sym_zext] = ACTIONS(122),
    [anon_sym_sext] = ACTIONS(122),
    [anon_sym_fptrunc] = ACTIONS(122),
    [anon_sym_fpext] = ACTIONS(122),
    [anon_sym_addrspacecast] = ACTIONS(122),
    [anon_sym_uitofp] = ACTIONS(122),
    [anon_sym_sitofp] = ACTIONS(122),
    [anon_sym_fptoui] = ACTIONS(122),
    [anon_sym_fptosi] = ACTIONS(122),
    [anon_sym_inttoptr] = ACTIONS(122),
    [anon_sym_ptrtoint] = ACTIONS(122),
    [anon_sym_uselistorder] = ACTIONS(122),
  },
  [37] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(375),
    [sym_global_var] = ACTIONS(375),
    [sym_local_var] = ACTIONS(375),
    [sym_label] = ACTIONS(375),
    [sym_string] = ACTIONS(377),
    [aux_sym_number_token1] = ACTIONS(377),
    [aux_sym_number_token2] = ACTIONS(377),
    [sym_float] = ACTIONS(377),
    [sym_cstring] = ACTIONS(375),
    [anon_sym_no_cfi] = ACTIONS(377),
    [anon_sym_private] = ACTIONS(377),
    [anon_sym_internal] = ACTIONS(377),
    [anon_sym_weak] = ACTIONS(377),
    [anon_sym_weak_odr] = ACTIONS(377),
    [anon_sym_linkonce] = ACTIONS(377),
    [anon_sym_linkonce_odr] = ACTIONS(377),
    [anon_sym_available_externally] = ACTIONS(377),
    [anon_sym_appending] = ACTIONS(377),
    [anon_sym_common] = ACTIONS(377),
    [anon_sym_extern_weak] = ACTIONS(377),
    [anon_sym_external] = ACTIONS(377),
    [anon_sym_dso_local] = ACTIONS(377),
    [anon_sym_dso_local_equivalent] = ACTIONS(377),
    [anon_sym_dso_preemptable] = ACTIONS(377),
    [anon_sym_default] = ACTIONS(377),
    [anon_sym_hidden] = ACTIONS(377),
    [anon_sym_protected] = ACTIONS(377),
    [anon_sym_dllimport] = ACTIONS(377),
    [anon_sym_dllexport] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(375),
    [anon_sym_RBRACE] = ACTIONS(375),
    [anon_sym_LT_LBRACE] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_COMMA] = ACTIONS(375),
    [anon_sym_addrspace] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_align] = ACTIONS(377),
    [anon_sym_section] = ACTIONS(377),
    [anon_sym_partition] = ACTIONS(377),
    [anon_sym_comdat] = ACTIONS(377),
    [anon_sym_gc] = ACTIONS(377),
    [anon_sym_prefix] = ACTIONS(377),
    [anon_sym_prologue] = ACTIONS(377),
    [anon_sym_personality] = ACTIONS(377),
    [anon_sym_alignstack] = ACTIONS(377),
    [anon_sym_allocsize] = ACTIONS(377),
    [anon_sym_alwaysinline] = ACTIONS(377),
    [anon_sym_builtin] = ACTIONS(377),
    [anon_sym_cold] = ACTIONS(377),
    [anon_sym_convergent] = ACTIONS(377),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(377),
    [anon_sym_hot] = ACTIONS(377),
    [anon_sym_inaccessiblememonly] = ACTIONS(377),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(377),
    [anon_sym_inlinehint] = ACTIONS(377),
    [anon_sym_jumptable] = ACTIONS(377),
    [anon_sym_minsize] = ACTIONS(377),
    [anon_sym_naked] = ACTIONS(377),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(377),
    [anon_sym_nobuiltin] = ACTIONS(377),
    [anon_sym_noduplicate] = ACTIONS(377),
    [anon_sym_nofree] = ACTIONS(377),
    [anon_sym_noimplicitfloat] = ACTIONS(377),
    [anon_sym_noinline] = ACTIONS(377),
    [anon_sym_nomerge] = ACTIONS(377),
    [anon_sym_nonlazybind] = ACTIONS(377),
    [anon_sym_noprofile] = ACTIONS(377),
    [anon_sym_noredzone] = ACTIONS(377),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(377),
    [anon_sym_noreturn] = ACTIONS(377),
    [anon_sym_norecurse] = ACTIONS(377),
    [anon_sym_willreturn] = ACTIONS(377),
    [anon_sym_nosync] = ACTIONS(377),
    [anon_sym_nounwind] = ACTIONS(377),
    [anon_sym_nocallback] = ACTIONS(377),
    [anon_sym_nosanitize_coverage] = ACTIONS(377),
    [anon_sym_null_pointer_is_valid] = ACTIONS(377),
    [anon_sym_optforfuzzing] = ACTIONS(377),
    [anon_sym_optnone] = ACTIONS(377),
    [anon_sym_optsize] = ACTIONS(377),
    [anon_sym_readnone] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_writeonly] = ACTIONS(377),
    [anon_sym_argmemonly] = ACTIONS(377),
    [anon_sym_returns_twice] = ACTIONS(377),
    [anon_sym_safestack] = ACTIONS(377),
    [anon_sym_sanitize_address] = ACTIONS(377),
    [anon_sym_sanitize_memory] = ACTIONS(377),
    [anon_sym_sanitize_thread] = ACTIONS(377),
    [anon_sym_sanitize_hwaddress] = ACTIONS(377),
    [anon_sym_sanitize_memtag] = ACTIONS(377),
    [anon_sym_speculative_load_hardening] = ACTIONS(377),
    [anon_sym_speculatable] = ACTIONS(377),
    [anon_sym_ssp] = ACTIONS(377),
    [anon_sym_sspstrong] = ACTIONS(377),
    [anon_sym_sspreq] = ACTIONS(377),
    [anon_sym_strictfp] = ACTIONS(377),
    [anon_sym_nocf_check] = ACTIONS(377),
    [anon_sym_shadowcallstack] = ACTIONS(377),
    [anon_sym_mustprogress] = ACTIONS(377),
    [anon_sym_vscale_range] = ACTIONS(377),
    [anon_sym_preallocated] = ACTIONS(377),
    [anon_sym_zeroext] = ACTIONS(377),
    [anon_sym_signext] = ACTIONS(377),
    [anon_sym_inreg] = ACTIONS(377),
    [anon_sym_byval] = ACTIONS(377),
    [anon_sym_byref] = ACTIONS(377),
    [anon_sym_inalloca] = ACTIONS(377),
    [anon_sym_sret] = ACTIONS(377),
    [anon_sym_elementtype] = ACTIONS(377),
    [anon_sym_noalias] = ACTIONS(377),
    [anon_sym_nocapture] = ACTIONS(377),
    [anon_sym_nest] = ACTIONS(377),
    [anon_sym_returned] = ACTIONS(377),
    [anon_sym_nonnull] = ACTIONS(377),
    [anon_sym_dereferenceable] = ACTIONS(377),
    [anon_sym_dereferenceable_or_null] = ACTIONS(377),
    [anon_sym_swiftself] = ACTIONS(377),
    [anon_sym_swiftasync] = ACTIONS(377),
    [anon_sym_swifterror] = ACTIONS(377),
    [anon_sym_immarg] = ACTIONS(377),
    [anon_sym_noundef] = ACTIONS(377),
    [anon_sym_uwtable] = ACTIONS(377),
    [anon_sym_memory] = ACTIONS(377),
    [anon_sym_none] = ACTIONS(377),
    [anon_sym_unreachable] = ACTIONS(377),
    [anon_sym_ret] = ACTIONS(377),
    [anon_sym_br] = ACTIONS(377),
    [anon_sym_resume] = ACTIONS(377),
    [anon_sym_freeze] = ACTIONS(377),
    [anon_sym_indirectbr] = ACTIONS(377),
    [anon_sym_extractelement] = ACTIONS(377),
    [anon_sym_insertelement] = ACTIONS(377),
    [anon_sym_select] = ACTIONS(377),
    [anon_sym_shufflevector] = ACTIONS(377),
    [anon_sym_fneg] = ACTIONS(377),
    [anon_sym_switch] = ACTIONS(377),
    [anon_sym_invoke] = ACTIONS(377),
    [anon_sym_cleanupret] = ACTIONS(377),
    [anon_sym_catchret] = ACTIONS(377),
    [anon_sym_catchswitch] = ACTIONS(377),
    [anon_sym_catchpad] = ACTIONS(377),
    [anon_sym_cleanuppad] = ACTIONS(377),
    [anon_sym_callbr] = ACTIONS(377),
    [anon_sym_icmp] = ACTIONS(377),
    [anon_sym_fcmp] = ACTIONS(377),
    [anon_sym_va_arg] = ACTIONS(377),
    [anon_sym_phi] = ACTIONS(377),
    [anon_sym_landingpad] = ACTIONS(377),
    [anon_sym_tail] = ACTIONS(377),
    [anon_sym_musttail] = ACTIONS(377),
    [anon_sym_notail] = ACTIONS(377),
    [anon_sym_call] = ACTIONS(377),
    [anon_sym_alloca] = ACTIONS(377),
    [anon_sym_load] = ACTIONS(377),
    [anon_sym_store] = ACTIONS(377),
    [anon_sym_cmpxchg] = ACTIONS(377),
    [anon_sym_atomicrmw] = ACTIONS(377),
    [anon_sym_fence] = ACTIONS(377),
    [anon_sym_getelementptr] = ACTIONS(377),
    [anon_sym_extractvalue] = ACTIONS(377),
    [anon_sym_insertvalue] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(377),
    [anon_sym_false] = ACTIONS(377),
    [anon_sym_null] = ACTIONS(377),
    [anon_sym_undef] = ACTIONS(377),
    [anon_sym_poison] = ACTIONS(377),
    [anon_sym_zeroinitializer] = ACTIONS(377),
    [anon_sym_blockaddress] = ACTIONS(377),
    [anon_sym_mul] = ACTIONS(377),
    [anon_sym_urem] = ACTIONS(377),
    [anon_sym_srem] = ACTIONS(377),
    [anon_sym_shl] = ACTIONS(377),
    [anon_sym_udiv] = ACTIONS(377),
    [anon_sym_sdiv] = ACTIONS(377),
    [anon_sym_lshr] = ACTIONS(377),
    [anon_sym_ashr] = ACTIONS(377),
    [anon_sym_fmul] = ACTIONS(377),
    [anon_sym_fdiv] = ACTIONS(377),
    [anon_sym_frem] = ACTIONS(377),
    [anon_sym_xchg] = ACTIONS(377),
    [anon_sym_add] = ACTIONS(377),
    [anon_sym_sub] = ACTIONS(377),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_nand] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_xor] = ACTIONS(377),
    [anon_sym_max] = ACTIONS(377),
    [anon_sym_min] = ACTIONS(377),
    [anon_sym_umax] = ACTIONS(377),
    [anon_sym_umin] = ACTIONS(377),
    [anon_sym_fadd] = ACTIONS(377),
    [anon_sym_fsub] = ACTIONS(377),
    [anon_sym_bitcast] = ACTIONS(377),
    [anon_sym_trunc] = ACTIONS(377),
    [anon_sym_zext] = ACTIONS(377),
    [anon_sym_sext] = ACTIONS(377),
    [anon_sym_fptrunc] = ACTIONS(377),
    [anon_sym_fpext] = ACTIONS(377),
    [anon_sym_addrspacecast] = ACTIONS(377),
    [anon_sym_uitofp] = ACTIONS(377),
    [anon_sym_sitofp] = ACTIONS(377),
    [anon_sym_fptoui] = ACTIONS(377),
    [anon_sym_fptosi] = ACTIONS(377),
    [anon_sym_inttoptr] = ACTIONS(377),
    [anon_sym_ptrtoint] = ACTIONS(377),
    [anon_sym_uselistorder] = ACTIONS(377),
  },
  [38] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(379),
    [sym_global_var] = ACTIONS(379),
    [sym_local_var] = ACTIONS(379),
    [sym_label] = ACTIONS(379),
    [sym_string] = ACTIONS(381),
    [aux_sym_number_token1] = ACTIONS(381),
    [aux_sym_number_token2] = ACTIONS(381),
    [sym_float] = ACTIONS(381),
    [sym_cstring] = ACTIONS(379),
    [anon_sym_no_cfi] = ACTIONS(381),
    [anon_sym_private] = ACTIONS(381),
    [anon_sym_internal] = ACTIONS(381),
    [anon_sym_weak] = ACTIONS(381),
    [anon_sym_weak_odr] = ACTIONS(381),
    [anon_sym_linkonce] = ACTIONS(381),
    [anon_sym_linkonce_odr] = ACTIONS(381),
    [anon_sym_available_externally] = ACTIONS(381),
    [anon_sym_appending] = ACTIONS(381),
    [anon_sym_common] = ACTIONS(381),
    [anon_sym_extern_weak] = ACTIONS(381),
    [anon_sym_external] = ACTIONS(381),
    [anon_sym_dso_local] = ACTIONS(381),
    [anon_sym_dso_local_equivalent] = ACTIONS(381),
    [anon_sym_dso_preemptable] = ACTIONS(381),
    [anon_sym_default] = ACTIONS(381),
    [anon_sym_hidden] = ACTIONS(381),
    [anon_sym_protected] = ACTIONS(381),
    [anon_sym_dllimport] = ACTIONS(381),
    [anon_sym_dllexport] = ACTIONS(381),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_LT_LBRACE] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(379),
    [anon_sym_addrspace] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_align] = ACTIONS(381),
    [anon_sym_section] = ACTIONS(381),
    [anon_sym_partition] = ACTIONS(381),
    [anon_sym_comdat] = ACTIONS(381),
    [anon_sym_gc] = ACTIONS(381),
    [anon_sym_prefix] = ACTIONS(381),
    [anon_sym_prologue] = ACTIONS(381),
    [anon_sym_personality] = ACTIONS(381),
    [anon_sym_alignstack] = ACTIONS(381),
    [anon_sym_allocsize] = ACTIONS(381),
    [anon_sym_alwaysinline] = ACTIONS(381),
    [anon_sym_builtin] = ACTIONS(381),
    [anon_sym_cold] = ACTIONS(381),
    [anon_sym_convergent] = ACTIONS(381),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(381),
    [anon_sym_hot] = ACTIONS(381),
    [anon_sym_inaccessiblememonly] = ACTIONS(381),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(381),
    [anon_sym_inlinehint] = ACTIONS(381),
    [anon_sym_jumptable] = ACTIONS(381),
    [anon_sym_minsize] = ACTIONS(381),
    [anon_sym_naked] = ACTIONS(381),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(381),
    [anon_sym_nobuiltin] = ACTIONS(381),
    [anon_sym_noduplicate] = ACTIONS(381),
    [anon_sym_nofree] = ACTIONS(381),
    [anon_sym_noimplicitfloat] = ACTIONS(381),
    [anon_sym_noinline] = ACTIONS(381),
    [anon_sym_nomerge] = ACTIONS(381),
    [anon_sym_nonlazybind] = ACTIONS(381),
    [anon_sym_noprofile] = ACTIONS(381),
    [anon_sym_noredzone] = ACTIONS(381),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(381),
    [anon_sym_noreturn] = ACTIONS(381),
    [anon_sym_norecurse] = ACTIONS(381),
    [anon_sym_willreturn] = ACTIONS(381),
    [anon_sym_nosync] = ACTIONS(381),
    [anon_sym_nounwind] = ACTIONS(381),
    [anon_sym_nocallback] = ACTIONS(381),
    [anon_sym_nosanitize_coverage] = ACTIONS(381),
    [anon_sym_null_pointer_is_valid] = ACTIONS(381),
    [anon_sym_optforfuzzing] = ACTIONS(381),
    [anon_sym_optnone] = ACTIONS(381),
    [anon_sym_optsize] = ACTIONS(381),
    [anon_sym_readnone] = ACTIONS(381),
    [anon_sym_readonly] = ACTIONS(381),
    [anon_sym_writeonly] = ACTIONS(381),
    [anon_sym_argmemonly] = ACTIONS(381),
    [anon_sym_returns_twice] = ACTIONS(381),
    [anon_sym_safestack] = ACTIONS(381),
    [anon_sym_sanitize_address] = ACTIONS(381),
    [anon_sym_sanitize_memory] = ACTIONS(381),
    [anon_sym_sanitize_thread] = ACTIONS(381),
    [anon_sym_sanitize_hwaddress] = ACTIONS(381),
    [anon_sym_sanitize_memtag] = ACTIONS(381),
    [anon_sym_speculative_load_hardening] = ACTIONS(381),
    [anon_sym_speculatable] = ACTIONS(381),
    [anon_sym_ssp] = ACTIONS(381),
    [anon_sym_sspstrong] = ACTIONS(381),
    [anon_sym_sspreq] = ACTIONS(381),
    [anon_sym_strictfp] = ACTIONS(381),
    [anon_sym_nocf_check] = ACTIONS(381),
    [anon_sym_shadowcallstack] = ACTIONS(381),
    [anon_sym_mustprogress] = ACTIONS(381),
    [anon_sym_vscale_range] = ACTIONS(381),
    [anon_sym_preallocated] = ACTIONS(381),
    [anon_sym_zeroext] = ACTIONS(381),
    [anon_sym_signext] = ACTIONS(381),
    [anon_sym_inreg] = ACTIONS(381),
    [anon_sym_byval] = ACTIONS(381),
    [anon_sym_byref] = ACTIONS(381),
    [anon_sym_inalloca] = ACTIONS(381),
    [anon_sym_sret] = ACTIONS(381),
    [anon_sym_elementtype] = ACTIONS(381),
    [anon_sym_noalias] = ACTIONS(381),
    [anon_sym_nocapture] = ACTIONS(381),
    [anon_sym_nest] = ACTIONS(381),
    [anon_sym_returned] = ACTIONS(381),
    [anon_sym_nonnull] = ACTIONS(381),
    [anon_sym_dereferenceable] = ACTIONS(381),
    [anon_sym_dereferenceable_or_null] = ACTIONS(381),
    [anon_sym_swiftself] = ACTIONS(381),
    [anon_sym_swiftasync] = ACTIONS(381),
    [anon_sym_swifterror] = ACTIONS(381),
    [anon_sym_immarg] = ACTIONS(381),
    [anon_sym_noundef] = ACTIONS(381),
    [anon_sym_uwtable] = ACTIONS(381),
    [anon_sym_memory] = ACTIONS(381),
    [anon_sym_none] = ACTIONS(381),
    [anon_sym_unreachable] = ACTIONS(381),
    [anon_sym_ret] = ACTIONS(381),
    [anon_sym_br] = ACTIONS(381),
    [anon_sym_resume] = ACTIONS(381),
    [anon_sym_freeze] = ACTIONS(381),
    [anon_sym_indirectbr] = ACTIONS(381),
    [anon_sym_extractelement] = ACTIONS(381),
    [anon_sym_insertelement] = ACTIONS(381),
    [anon_sym_select] = ACTIONS(381),
    [anon_sym_shufflevector] = ACTIONS(381),
    [anon_sym_fneg] = ACTIONS(381),
    [anon_sym_switch] = ACTIONS(381),
    [anon_sym_invoke] = ACTIONS(381),
    [anon_sym_cleanupret] = ACTIONS(381),
    [anon_sym_catchret] = ACTIONS(381),
    [anon_sym_catchswitch] = ACTIONS(381),
    [anon_sym_catchpad] = ACTIONS(381),
    [anon_sym_cleanuppad] = ACTIONS(381),
    [anon_sym_callbr] = ACTIONS(381),
    [anon_sym_icmp] = ACTIONS(381),
    [anon_sym_fcmp] = ACTIONS(381),
    [anon_sym_va_arg] = ACTIONS(381),
    [anon_sym_phi] = ACTIONS(381),
    [anon_sym_landingpad] = ACTIONS(381),
    [anon_sym_tail] = ACTIONS(381),
    [anon_sym_musttail] = ACTIONS(381),
    [anon_sym_notail] = ACTIONS(381),
    [anon_sym_call] = ACTIONS(381),
    [anon_sym_alloca] = ACTIONS(381),
    [anon_sym_load] = ACTIONS(381),
    [anon_sym_store] = ACTIONS(381),
    [anon_sym_cmpxchg] = ACTIONS(381),
    [anon_sym_atomicrmw] = ACTIONS(381),
    [anon_sym_fence] = ACTIONS(381),
    [anon_sym_getelementptr] = ACTIONS(381),
    [anon_sym_extractvalue] = ACTIONS(381),
    [anon_sym_insertvalue] = ACTIONS(381),
    [anon_sym_true] = ACTIONS(381),
    [anon_sym_false] = ACTIONS(381),
    [anon_sym_null] = ACTIONS(381),
    [anon_sym_undef] = ACTIONS(381),
    [anon_sym_poison] = ACTIONS(381),
    [anon_sym_zeroinitializer] = ACTIONS(381),
    [anon_sym_blockaddress] = ACTIONS(381),
    [anon_sym_mul] = ACTIONS(381),
    [anon_sym_urem] = ACTIONS(381),
    [anon_sym_srem] = ACTIONS(381),
    [anon_sym_shl] = ACTIONS(381),
    [anon_sym_udiv] = ACTIONS(381),
    [anon_sym_sdiv] = ACTIONS(381),
    [anon_sym_lshr] = ACTIONS(381),
    [anon_sym_ashr] = ACTIONS(381),
    [anon_sym_fmul] = ACTIONS(381),
    [anon_sym_fdiv] = ACTIONS(381),
    [anon_sym_frem] = ACTIONS(381),
    [anon_sym_xchg] = ACTIONS(381),
    [anon_sym_add] = ACTIONS(381),
    [anon_sym_sub] = ACTIONS(381),
    [anon_sym_and] = ACTIONS(381),
    [anon_sym_nand] = ACTIONS(381),
    [anon_sym_or] = ACTIONS(381),
    [anon_sym_xor] = ACTIONS(381),
    [anon_sym_max] = ACTIONS(381),
    [anon_sym_min] = ACTIONS(381),
    [anon_sym_umax] = ACTIONS(381),
    [anon_sym_umin] = ACTIONS(381),
    [anon_sym_fadd] = ACTIONS(381),
    [anon_sym_fsub] = ACTIONS(381),
    [anon_sym_bitcast] = ACTIONS(381),
    [anon_sym_trunc] = ACTIONS(381),
    [anon_sym_zext] = ACTIONS(381),
    [anon_sym_sext] = ACTIONS(381),
    [anon_sym_fptrunc] = ACTIONS(381),
    [anon_sym_fpext] = ACTIONS(381),
    [anon_sym_addrspacecast] = ACTIONS(381),
    [anon_sym_uitofp] = ACTIONS(381),
    [anon_sym_sitofp] = ACTIONS(381),
    [anon_sym_fptoui] = ACTIONS(381),
    [anon_sym_fptosi] = ACTIONS(381),
    [anon_sym_inttoptr] = ACTIONS(381),
    [anon_sym_ptrtoint] = ACTIONS(381),
    [anon_sym_uselistorder] = ACTIONS(381),
  },
  [39] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(269),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [sym_label] = ACTIONS(269),
    [sym_string] = ACTIONS(271),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(271),
    [sym_float] = ACTIONS(271),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(271),
    [anon_sym_private] = ACTIONS(271),
    [anon_sym_internal] = ACTIONS(271),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(271),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(271),
    [anon_sym_available_externally] = ACTIONS(271),
    [anon_sym_appending] = ACTIONS(271),
    [anon_sym_common] = ACTIONS(271),
    [anon_sym_extern_weak] = ACTIONS(271),
    [anon_sym_external] = ACTIONS(271),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(271),
    [anon_sym_dso_preemptable] = ACTIONS(271),
    [anon_sym_default] = ACTIONS(271),
    [anon_sym_hidden] = ACTIONS(271),
    [anon_sym_protected] = ACTIONS(271),
    [anon_sym_dllimport] = ACTIONS(271),
    [anon_sym_dllexport] = ACTIONS(271),
    [anon_sym_STAR] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_align] = ACTIONS(271),
    [anon_sym_section] = ACTIONS(271),
    [anon_sym_partition] = ACTIONS(271),
    [anon_sym_comdat] = ACTIONS(271),
    [anon_sym_gc] = ACTIONS(271),
    [anon_sym_prefix] = ACTIONS(271),
    [anon_sym_prologue] = ACTIONS(271),
    [anon_sym_personality] = ACTIONS(271),
    [anon_sym_alignstack] = ACTIONS(271),
    [anon_sym_allocsize] = ACTIONS(271),
    [anon_sym_alwaysinline] = ACTIONS(271),
    [anon_sym_builtin] = ACTIONS(271),
    [anon_sym_cold] = ACTIONS(271),
    [anon_sym_convergent] = ACTIONS(271),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(271),
    [anon_sym_hot] = ACTIONS(271),
    [anon_sym_inaccessiblememonly] = ACTIONS(271),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(271),
    [anon_sym_inlinehint] = ACTIONS(271),
    [anon_sym_jumptable] = ACTIONS(271),
    [anon_sym_minsize] = ACTIONS(271),
    [anon_sym_naked] = ACTIONS(271),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(271),
    [anon_sym_nobuiltin] = ACTIONS(271),
    [anon_sym_noduplicate] = ACTIONS(271),
    [anon_sym_nofree] = ACTIONS(271),
    [anon_sym_noimplicitfloat] = ACTIONS(271),
    [anon_sym_noinline] = ACTIONS(271),
    [anon_sym_nomerge] = ACTIONS(271),
    [anon_sym_nonlazybind] = ACTIONS(271),
    [anon_sym_noprofile] = ACTIONS(271),
    [anon_sym_noredzone] = ACTIONS(271),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(271),
    [anon_sym_noreturn] = ACTIONS(271),
    [anon_sym_norecurse] = ACTIONS(271),
    [anon_sym_willreturn] = ACTIONS(271),
    [anon_sym_nosync] = ACTIONS(271),
    [anon_sym_nounwind] = ACTIONS(271),
    [anon_sym_nocallback] = ACTIONS(271),
    [anon_sym_nosanitize_coverage] = ACTIONS(271),
    [anon_sym_null_pointer_is_valid] = ACTIONS(271),
    [anon_sym_optforfuzzing] = ACTIONS(271),
    [anon_sym_optnone] = ACTIONS(271),
    [anon_sym_optsize] = ACTIONS(271),
    [anon_sym_readnone] = ACTIONS(271),
    [anon_sym_readonly] = ACTIONS(271),
    [anon_sym_writeonly] = ACTIONS(271),
    [anon_sym_argmemonly] = ACTIONS(271),
    [anon_sym_returns_twice] = ACTIONS(271),
    [anon_sym_safestack] = ACTIONS(271),
    [anon_sym_sanitize_address] = ACTIONS(271),
    [anon_sym_sanitize_memory] = ACTIONS(271),
    [anon_sym_sanitize_thread] = ACTIONS(271),
    [anon_sym_sanitize_hwaddress] = ACTIONS(271),
    [anon_sym_sanitize_memtag] = ACTIONS(271),
    [anon_sym_speculative_load_hardening] = ACTIONS(271),
    [anon_sym_speculatable] = ACTIONS(271),
    [anon_sym_ssp] = ACTIONS(271),
    [anon_sym_sspstrong] = ACTIONS(271),
    [anon_sym_sspreq] = ACTIONS(271),
    [anon_sym_strictfp] = ACTIONS(271),
    [anon_sym_nocf_check] = ACTIONS(271),
    [anon_sym_shadowcallstack] = ACTIONS(271),
    [anon_sym_mustprogress] = ACTIONS(271),
    [anon_sym_vscale_range] = ACTIONS(271),
    [anon_sym_preallocated] = ACTIONS(271),
    [anon_sym_zeroext] = ACTIONS(271),
    [anon_sym_signext] = ACTIONS(271),
    [anon_sym_inreg] = ACTIONS(271),
    [anon_sym_byval] = ACTIONS(271),
    [anon_sym_byref] = ACTIONS(271),
    [anon_sym_inalloca] = ACTIONS(271),
    [anon_sym_sret] = ACTIONS(271),
    [anon_sym_elementtype] = ACTIONS(271),
    [anon_sym_noalias] = ACTIONS(271),
    [anon_sym_nocapture] = ACTIONS(271),
    [anon_sym_nest] = ACTIONS(271),
    [anon_sym_returned] = ACTIONS(271),
    [anon_sym_nonnull] = ACTIONS(271),
    [anon_sym_dereferenceable] = ACTIONS(271),
    [anon_sym_dereferenceable_or_null] = ACTIONS(271),
    [anon_sym_swiftself] = ACTIONS(271),
    [anon_sym_swiftasync] = ACTIONS(271),
    [anon_sym_swifterror] = ACTIONS(271),
    [anon_sym_immarg] = ACTIONS(271),
    [anon_sym_noundef] = ACTIONS(271),
    [anon_sym_uwtable] = ACTIONS(271),
    [anon_sym_memory] = ACTIONS(271),
    [anon_sym_none] = ACTIONS(271),
    [anon_sym_unreachable] = ACTIONS(271),
    [anon_sym_ret] = ACTIONS(271),
    [anon_sym_br] = ACTIONS(271),
    [anon_sym_resume] = ACTIONS(271),
    [anon_sym_freeze] = ACTIONS(271),
    [anon_sym_indirectbr] = ACTIONS(271),
    [anon_sym_extractelement] = ACTIONS(271),
    [anon_sym_insertelement] = ACTIONS(271),
    [anon_sym_select] = ACTIONS(271),
    [anon_sym_shufflevector] = ACTIONS(271),
    [anon_sym_fneg] = ACTIONS(271),
    [anon_sym_switch] = ACTIONS(271),
    [anon_sym_invoke] = ACTIONS(271),
    [anon_sym_cleanupret] = ACTIONS(271),
    [anon_sym_catchret] = ACTIONS(271),
    [anon_sym_catchswitch] = ACTIONS(271),
    [anon_sym_catchpad] = ACTIONS(271),
    [anon_sym_cleanuppad] = ACTIONS(271),
    [anon_sym_callbr] = ACTIONS(271),
    [anon_sym_icmp] = ACTIONS(271),
    [anon_sym_fcmp] = ACTIONS(271),
    [anon_sym_va_arg] = ACTIONS(271),
    [anon_sym_phi] = ACTIONS(271),
    [anon_sym_landingpad] = ACTIONS(271),
    [anon_sym_tail] = ACTIONS(271),
    [anon_sym_musttail] = ACTIONS(271),
    [anon_sym_notail] = ACTIONS(271),
    [anon_sym_call] = ACTIONS(271),
    [anon_sym_alloca] = ACTIONS(271),
    [anon_sym_load] = ACTIONS(271),
    [anon_sym_store] = ACTIONS(271),
    [anon_sym_cmpxchg] = ACTIONS(271),
    [anon_sym_atomicrmw] = ACTIONS(271),
    [anon_sym_fence] = ACTIONS(271),
    [anon_sym_getelementptr] = ACTIONS(271),
    [anon_sym_extractvalue] = ACTIONS(271),
    [anon_sym_insertvalue] = ACTIONS(271),
    [anon_sym_true] = ACTIONS(271),
    [anon_sym_false] = ACTIONS(271),
    [anon_sym_null] = ACTIONS(271),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_poison] = ACTIONS(271),
    [anon_sym_zeroinitializer] = ACTIONS(271),
    [anon_sym_blockaddress] = ACTIONS(271),
    [anon_sym_mul] = ACTIONS(271),
    [anon_sym_urem] = ACTIONS(271),
    [anon_sym_srem] = ACTIONS(271),
    [anon_sym_shl] = ACTIONS(271),
    [anon_sym_udiv] = ACTIONS(271),
    [anon_sym_sdiv] = ACTIONS(271),
    [anon_sym_lshr] = ACTIONS(271),
    [anon_sym_ashr] = ACTIONS(271),
    [anon_sym_fmul] = ACTIONS(271),
    [anon_sym_fdiv] = ACTIONS(271),
    [anon_sym_frem] = ACTIONS(271),
    [anon_sym_xchg] = ACTIONS(271),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(271),
    [anon_sym_nand] = ACTIONS(271),
    [anon_sym_or] = ACTIONS(271),
    [anon_sym_xor] = ACTIONS(271),
    [anon_sym_max] = ACTIONS(271),
    [anon_sym_min] = ACTIONS(271),
    [anon_sym_umax] = ACTIONS(271),
    [anon_sym_umin] = ACTIONS(271),
    [anon_sym_fadd] = ACTIONS(271),
    [anon_sym_fsub] = ACTIONS(271),
    [anon_sym_bitcast] = ACTIONS(271),
    [anon_sym_trunc] = ACTIONS(271),
    [anon_sym_zext] = ACTIONS(271),
    [anon_sym_sext] = ACTIONS(271),
    [anon_sym_fptrunc] = ACTIONS(271),
    [anon_sym_fpext] = ACTIONS(271),
    [anon_sym_addrspacecast] = ACTIONS(271),
    [anon_sym_uitofp] = ACTIONS(271),
    [anon_sym_sitofp] = ACTIONS(271),
    [anon_sym_fptoui] = ACTIONS(271),
    [anon_sym_fptosi] = ACTIONS(271),
    [anon_sym_inttoptr] = ACTIONS(271),
    [anon_sym_ptrtoint] = ACTIONS(271),
    [anon_sym_uselistorder] = ACTIONS(271),
  },
  [40] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(250),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [sym_label] = ACTIONS(250),
    [sym_string] = ACTIONS(252),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(252),
    [anon_sym_private] = ACTIONS(252),
    [anon_sym_internal] = ACTIONS(252),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(252),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(252),
    [anon_sym_available_externally] = ACTIONS(252),
    [anon_sym_appending] = ACTIONS(252),
    [anon_sym_common] = ACTIONS(252),
    [anon_sym_extern_weak] = ACTIONS(252),
    [anon_sym_external] = ACTIONS(252),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(252),
    [anon_sym_dso_preemptable] = ACTIONS(252),
    [anon_sym_default] = ACTIONS(252),
    [anon_sym_hidden] = ACTIONS(252),
    [anon_sym_protected] = ACTIONS(252),
    [anon_sym_dllimport] = ACTIONS(252),
    [anon_sym_dllexport] = ACTIONS(252),
    [anon_sym_STAR] = ACTIONS(250),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(252),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_align] = ACTIONS(252),
    [anon_sym_section] = ACTIONS(252),
    [anon_sym_partition] = ACTIONS(252),
    [anon_sym_comdat] = ACTIONS(252),
    [anon_sym_gc] = ACTIONS(252),
    [anon_sym_prefix] = ACTIONS(252),
    [anon_sym_prologue] = ACTIONS(252),
    [anon_sym_personality] = ACTIONS(252),
    [anon_sym_alignstack] = ACTIONS(252),
    [anon_sym_allocsize] = ACTIONS(252),
    [anon_sym_alwaysinline] = ACTIONS(252),
    [anon_sym_builtin] = ACTIONS(252),
    [anon_sym_cold] = ACTIONS(252),
    [anon_sym_convergent] = ACTIONS(252),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(252),
    [anon_sym_hot] = ACTIONS(252),
    [anon_sym_inaccessiblememonly] = ACTIONS(252),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(252),
    [anon_sym_inlinehint] = ACTIONS(252),
    [anon_sym_jumptable] = ACTIONS(252),
    [anon_sym_minsize] = ACTIONS(252),
    [anon_sym_naked] = ACTIONS(252),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(252),
    [anon_sym_nobuiltin] = ACTIONS(252),
    [anon_sym_noduplicate] = ACTIONS(252),
    [anon_sym_nofree] = ACTIONS(252),
    [anon_sym_noimplicitfloat] = ACTIONS(252),
    [anon_sym_noinline] = ACTIONS(252),
    [anon_sym_nomerge] = ACTIONS(252),
    [anon_sym_nonlazybind] = ACTIONS(252),
    [anon_sym_noprofile] = ACTIONS(252),
    [anon_sym_noredzone] = ACTIONS(252),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(252),
    [anon_sym_noreturn] = ACTIONS(252),
    [anon_sym_norecurse] = ACTIONS(252),
    [anon_sym_willreturn] = ACTIONS(252),
    [anon_sym_nosync] = ACTIONS(252),
    [anon_sym_nounwind] = ACTIONS(252),
    [anon_sym_nocallback] = ACTIONS(252),
    [anon_sym_nosanitize_coverage] = ACTIONS(252),
    [anon_sym_null_pointer_is_valid] = ACTIONS(252),
    [anon_sym_optforfuzzing] = ACTIONS(252),
    [anon_sym_optnone] = ACTIONS(252),
    [anon_sym_optsize] = ACTIONS(252),
    [anon_sym_readnone] = ACTIONS(252),
    [anon_sym_readonly] = ACTIONS(252),
    [anon_sym_writeonly] = ACTIONS(252),
    [anon_sym_argmemonly] = ACTIONS(252),
    [anon_sym_returns_twice] = ACTIONS(252),
    [anon_sym_safestack] = ACTIONS(252),
    [anon_sym_sanitize_address] = ACTIONS(252),
    [anon_sym_sanitize_memory] = ACTIONS(252),
    [anon_sym_sanitize_thread] = ACTIONS(252),
    [anon_sym_sanitize_hwaddress] = ACTIONS(252),
    [anon_sym_sanitize_memtag] = ACTIONS(252),
    [anon_sym_speculative_load_hardening] = ACTIONS(252),
    [anon_sym_speculatable] = ACTIONS(252),
    [anon_sym_ssp] = ACTIONS(252),
    [anon_sym_sspstrong] = ACTIONS(252),
    [anon_sym_sspreq] = ACTIONS(252),
    [anon_sym_strictfp] = ACTIONS(252),
    [anon_sym_nocf_check] = ACTIONS(252),
    [anon_sym_shadowcallstack] = ACTIONS(252),
    [anon_sym_mustprogress] = ACTIONS(252),
    [anon_sym_vscale_range] = ACTIONS(252),
    [anon_sym_preallocated] = ACTIONS(252),
    [anon_sym_zeroext] = ACTIONS(252),
    [anon_sym_signext] = ACTIONS(252),
    [anon_sym_inreg] = ACTIONS(252),
    [anon_sym_byval] = ACTIONS(252),
    [anon_sym_byref] = ACTIONS(252),
    [anon_sym_inalloca] = ACTIONS(252),
    [anon_sym_sret] = ACTIONS(252),
    [anon_sym_elementtype] = ACTIONS(252),
    [anon_sym_noalias] = ACTIONS(252),
    [anon_sym_nocapture] = ACTIONS(252),
    [anon_sym_nest] = ACTIONS(252),
    [anon_sym_returned] = ACTIONS(252),
    [anon_sym_nonnull] = ACTIONS(252),
    [anon_sym_dereferenceable] = ACTIONS(252),
    [anon_sym_dereferenceable_or_null] = ACTIONS(252),
    [anon_sym_swiftself] = ACTIONS(252),
    [anon_sym_swiftasync] = ACTIONS(252),
    [anon_sym_swifterror] = ACTIONS(252),
    [anon_sym_immarg] = ACTIONS(252),
    [anon_sym_noundef] = ACTIONS(252),
    [anon_sym_uwtable] = ACTIONS(252),
    [anon_sym_memory] = ACTIONS(252),
    [anon_sym_none] = ACTIONS(252),
    [anon_sym_unreachable] = ACTIONS(252),
    [anon_sym_ret] = ACTIONS(252),
    [anon_sym_br] = ACTIONS(252),
    [anon_sym_resume] = ACTIONS(252),
    [anon_sym_freeze] = ACTIONS(252),
    [anon_sym_indirectbr] = ACTIONS(252),
    [anon_sym_extractelement] = ACTIONS(252),
    [anon_sym_insertelement] = ACTIONS(252),
    [anon_sym_select] = ACTIONS(252),
    [anon_sym_shufflevector] = ACTIONS(252),
    [anon_sym_fneg] = ACTIONS(252),
    [anon_sym_switch] = ACTIONS(252),
    [anon_sym_invoke] = ACTIONS(252),
    [anon_sym_cleanupret] = ACTIONS(252),
    [anon_sym_catchret] = ACTIONS(252),
    [anon_sym_catchswitch] = ACTIONS(252),
    [anon_sym_catchpad] = ACTIONS(252),
    [anon_sym_cleanuppad] = ACTIONS(252),
    [anon_sym_callbr] = ACTIONS(252),
    [anon_sym_icmp] = ACTIONS(252),
    [anon_sym_fcmp] = ACTIONS(252),
    [anon_sym_va_arg] = ACTIONS(252),
    [anon_sym_phi] = ACTIONS(252),
    [anon_sym_landingpad] = ACTIONS(252),
    [anon_sym_tail] = ACTIONS(252),
    [anon_sym_musttail] = ACTIONS(252),
    [anon_sym_notail] = ACTIONS(252),
    [anon_sym_call] = ACTIONS(252),
    [anon_sym_alloca] = ACTIONS(252),
    [anon_sym_load] = ACTIONS(252),
    [anon_sym_store] = ACTIONS(252),
    [anon_sym_cmpxchg] = ACTIONS(252),
    [anon_sym_atomicrmw] = ACTIONS(252),
    [anon_sym_fence] = ACTIONS(252),
    [anon_sym_getelementptr] = ACTIONS(252),
    [anon_sym_extractvalue] = ACTIONS(252),
    [anon_sym_insertvalue] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(252),
    [anon_sym_false] = ACTIONS(252),
    [anon_sym_null] = ACTIONS(252),
    [anon_sym_undef] = ACTIONS(252),
    [anon_sym_poison] = ACTIONS(252),
    [anon_sym_zeroinitializer] = ACTIONS(252),
    [anon_sym_blockaddress] = ACTIONS(252),
    [anon_sym_mul] = ACTIONS(252),
    [anon_sym_urem] = ACTIONS(252),
    [anon_sym_srem] = ACTIONS(252),
    [anon_sym_shl] = ACTIONS(252),
    [anon_sym_udiv] = ACTIONS(252),
    [anon_sym_sdiv] = ACTIONS(252),
    [anon_sym_lshr] = ACTIONS(252),
    [anon_sym_ashr] = ACTIONS(252),
    [anon_sym_fmul] = ACTIONS(252),
    [anon_sym_fdiv] = ACTIONS(252),
    [anon_sym_frem] = ACTIONS(252),
    [anon_sym_xchg] = ACTIONS(252),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(252),
    [anon_sym_and] = ACTIONS(252),
    [anon_sym_nand] = ACTIONS(252),
    [anon_sym_or] = ACTIONS(252),
    [anon_sym_xor] = ACTIONS(252),
    [anon_sym_max] = ACTIONS(252),
    [anon_sym_min] = ACTIONS(252),
    [anon_sym_umax] = ACTIONS(252),
    [anon_sym_umin] = ACTIONS(252),
    [anon_sym_fadd] = ACTIONS(252),
    [anon_sym_fsub] = ACTIONS(252),
    [anon_sym_bitcast] = ACTIONS(252),
    [anon_sym_trunc] = ACTIONS(252),
    [anon_sym_zext] = ACTIONS(252),
    [anon_sym_sext] = ACTIONS(252),
    [anon_sym_fptrunc] = ACTIONS(252),
    [anon_sym_fpext] = ACTIONS(252),
    [anon_sym_addrspacecast] = ACTIONS(252),
    [anon_sym_uitofp] = ACTIONS(252),
    [anon_sym_sitofp] = ACTIONS(252),
    [anon_sym_fptoui] = ACTIONS(252),
    [anon_sym_fptosi] = ACTIONS(252),
    [anon_sym_inttoptr] = ACTIONS(252),
    [anon_sym_ptrtoint] = ACTIONS(252),
    [anon_sym_uselistorder] = ACTIONS(252),
  },
  [41] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(359),
    [sym_global_var] = ACTIONS(359),
    [sym_local_var] = ACTIONS(359),
    [sym_label] = ACTIONS(359),
    [sym_string] = ACTIONS(361),
    [aux_sym_number_token1] = ACTIONS(361),
    [aux_sym_number_token2] = ACTIONS(361),
    [sym_float] = ACTIONS(361),
    [sym_cstring] = ACTIONS(359),
    [anon_sym_no_cfi] = ACTIONS(361),
    [anon_sym_private] = ACTIONS(361),
    [anon_sym_internal] = ACTIONS(361),
    [anon_sym_weak] = ACTIONS(361),
    [anon_sym_weak_odr] = ACTIONS(361),
    [anon_sym_linkonce] = ACTIONS(361),
    [anon_sym_linkonce_odr] = ACTIONS(361),
    [anon_sym_available_externally] = ACTIONS(361),
    [anon_sym_appending] = ACTIONS(361),
    [anon_sym_common] = ACTIONS(361),
    [anon_sym_extern_weak] = ACTIONS(361),
    [anon_sym_external] = ACTIONS(361),
    [anon_sym_dso_local] = ACTIONS(361),
    [anon_sym_dso_local_equivalent] = ACTIONS(361),
    [anon_sym_dso_preemptable] = ACTIONS(361),
    [anon_sym_default] = ACTIONS(361),
    [anon_sym_hidden] = ACTIONS(361),
    [anon_sym_protected] = ACTIONS(361),
    [anon_sym_dllimport] = ACTIONS(361),
    [anon_sym_dllexport] = ACTIONS(361),
    [anon_sym_STAR] = ACTIONS(359),
    [anon_sym_LBRACE] = ACTIONS(359),
    [anon_sym_RBRACE] = ACTIONS(359),
    [anon_sym_LT_LBRACE] = ACTIONS(359),
    [anon_sym_LBRACK] = ACTIONS(359),
    [anon_sym_LT] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(359),
    [anon_sym_addrspace] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(359),
    [anon_sym_align] = ACTIONS(361),
    [anon_sym_section] = ACTIONS(361),
    [anon_sym_partition] = ACTIONS(361),
    [anon_sym_comdat] = ACTIONS(361),
    [anon_sym_gc] = ACTIONS(361),
    [anon_sym_prefix] = ACTIONS(361),
    [anon_sym_prologue] = ACTIONS(361),
    [anon_sym_personality] = ACTIONS(361),
    [anon_sym_alignstack] = ACTIONS(361),
    [anon_sym_allocsize] = ACTIONS(361),
    [anon_sym_alwaysinline] = ACTIONS(361),
    [anon_sym_builtin] = ACTIONS(361),
    [anon_sym_cold] = ACTIONS(361),
    [anon_sym_convergent] = ACTIONS(361),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(361),
    [anon_sym_hot] = ACTIONS(361),
    [anon_sym_inaccessiblememonly] = ACTIONS(361),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(361),
    [anon_sym_inlinehint] = ACTIONS(361),
    [anon_sym_jumptable] = ACTIONS(361),
    [anon_sym_minsize] = ACTIONS(361),
    [anon_sym_naked] = ACTIONS(361),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(361),
    [anon_sym_nobuiltin] = ACTIONS(361),
    [anon_sym_noduplicate] = ACTIONS(361),
    [anon_sym_nofree] = ACTIONS(361),
    [anon_sym_noimplicitfloat] = ACTIONS(361),
    [anon_sym_noinline] = ACTIONS(361),
    [anon_sym_nomerge] = ACTIONS(361),
    [anon_sym_nonlazybind] = ACTIONS(361),
    [anon_sym_noprofile] = ACTIONS(361),
    [anon_sym_noredzone] = ACTIONS(361),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(361),
    [anon_sym_noreturn] = ACTIONS(361),
    [anon_sym_norecurse] = ACTIONS(361),
    [anon_sym_willreturn] = ACTIONS(361),
    [anon_sym_nosync] = ACTIONS(361),
    [anon_sym_nounwind] = ACTIONS(361),
    [anon_sym_nocallback] = ACTIONS(361),
    [anon_sym_nosanitize_coverage] = ACTIONS(361),
    [anon_sym_null_pointer_is_valid] = ACTIONS(361),
    [anon_sym_optforfuzzing] = ACTIONS(361),
    [anon_sym_optnone] = ACTIONS(361),
    [anon_sym_optsize] = ACTIONS(361),
    [anon_sym_readnone] = ACTIONS(361),
    [anon_sym_readonly] = ACTIONS(361),
    [anon_sym_writeonly] = ACTIONS(361),
    [anon_sym_argmemonly] = ACTIONS(361),
    [anon_sym_returns_twice] = ACTIONS(361),
    [anon_sym_safestack] = ACTIONS(361),
    [anon_sym_sanitize_address] = ACTIONS(361),
    [anon_sym_sanitize_memory] = ACTIONS(361),
    [anon_sym_sanitize_thread] = ACTIONS(361),
    [anon_sym_sanitize_hwaddress] = ACTIONS(361),
    [anon_sym_sanitize_memtag] = ACTIONS(361),
    [anon_sym_speculative_load_hardening] = ACTIONS(361),
    [anon_sym_speculatable] = ACTIONS(361),
    [anon_sym_ssp] = ACTIONS(361),
    [anon_sym_sspstrong] = ACTIONS(361),
    [anon_sym_sspreq] = ACTIONS(361),
    [anon_sym_strictfp] = ACTIONS(361),
    [anon_sym_nocf_check] = ACTIONS(361),
    [anon_sym_shadowcallstack] = ACTIONS(361),
    [anon_sym_mustprogress] = ACTIONS(361),
    [anon_sym_vscale_range] = ACTIONS(361),
    [anon_sym_preallocated] = ACTIONS(361),
    [anon_sym_zeroext] = ACTIONS(361),
    [anon_sym_signext] = ACTIONS(361),
    [anon_sym_inreg] = ACTIONS(361),
    [anon_sym_byval] = ACTIONS(361),
    [anon_sym_byref] = ACTIONS(361),
    [anon_sym_inalloca] = ACTIONS(361),
    [anon_sym_sret] = ACTIONS(361),
    [anon_sym_elementtype] = ACTIONS(361),
    [anon_sym_noalias] = ACTIONS(361),
    [anon_sym_nocapture] = ACTIONS(361),
    [anon_sym_nest] = ACTIONS(361),
    [anon_sym_returned] = ACTIONS(361),
    [anon_sym_nonnull] = ACTIONS(361),
    [anon_sym_dereferenceable] = ACTIONS(361),
    [anon_sym_dereferenceable_or_null] = ACTIONS(361),
    [anon_sym_swiftself] = ACTIONS(361),
    [anon_sym_swiftasync] = ACTIONS(361),
    [anon_sym_swifterror] = ACTIONS(361),
    [anon_sym_immarg] = ACTIONS(361),
    [anon_sym_noundef] = ACTIONS(361),
    [anon_sym_uwtable] = ACTIONS(361),
    [anon_sym_memory] = ACTIONS(361),
    [anon_sym_none] = ACTIONS(361),
    [anon_sym_unreachable] = ACTIONS(361),
    [anon_sym_ret] = ACTIONS(361),
    [anon_sym_br] = ACTIONS(361),
    [anon_sym_resume] = ACTIONS(361),
    [anon_sym_freeze] = ACTIONS(361),
    [anon_sym_indirectbr] = ACTIONS(361),
    [anon_sym_extractelement] = ACTIONS(361),
    [anon_sym_insertelement] = ACTIONS(361),
    [anon_sym_select] = ACTIONS(361),
    [anon_sym_shufflevector] = ACTIONS(361),
    [anon_sym_fneg] = ACTIONS(361),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_invoke] = ACTIONS(361),
    [anon_sym_cleanupret] = ACTIONS(361),
    [anon_sym_catchret] = ACTIONS(361),
    [anon_sym_catchswitch] = ACTIONS(361),
    [anon_sym_catchpad] = ACTIONS(361),
    [anon_sym_cleanuppad] = ACTIONS(361),
    [anon_sym_callbr] = ACTIONS(361),
    [anon_sym_icmp] = ACTIONS(361),
    [anon_sym_fcmp] = ACTIONS(361),
    [anon_sym_va_arg] = ACTIONS(361),
    [anon_sym_phi] = ACTIONS(361),
    [anon_sym_landingpad] = ACTIONS(361),
    [anon_sym_tail] = ACTIONS(361),
    [anon_sym_musttail] = ACTIONS(361),
    [anon_sym_notail] = ACTIONS(361),
    [anon_sym_call] = ACTIONS(361),
    [anon_sym_alloca] = ACTIONS(361),
    [anon_sym_load] = ACTIONS(361),
    [anon_sym_store] = ACTIONS(361),
    [anon_sym_cmpxchg] = ACTIONS(361),
    [anon_sym_atomicrmw] = ACTIONS(361),
    [anon_sym_fence] = ACTIONS(361),
    [anon_sym_getelementptr] = ACTIONS(361),
    [anon_sym_extractvalue] = ACTIONS(361),
    [anon_sym_insertvalue] = ACTIONS(361),
    [anon_sym_true] = ACTIONS(361),
    [anon_sym_false] = ACTIONS(361),
    [anon_sym_null] = ACTIONS(361),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_poison] = ACTIONS(361),
    [anon_sym_zeroinitializer] = ACTIONS(361),
    [anon_sym_blockaddress] = ACTIONS(361),
    [anon_sym_mul] = ACTIONS(361),
    [anon_sym_urem] = ACTIONS(361),
    [anon_sym_srem] = ACTIONS(361),
    [anon_sym_shl] = ACTIONS(361),
    [anon_sym_udiv] = ACTIONS(361),
    [anon_sym_sdiv] = ACTIONS(361),
    [anon_sym_lshr] = ACTIONS(361),
    [anon_sym_ashr] = ACTIONS(361),
    [anon_sym_fmul] = ACTIONS(361),
    [anon_sym_fdiv] = ACTIONS(361),
    [anon_sym_frem] = ACTIONS(361),
    [anon_sym_xchg] = ACTIONS(361),
    [anon_sym_add] = ACTIONS(361),
    [anon_sym_sub] = ACTIONS(361),
    [anon_sym_and] = ACTIONS(361),
    [anon_sym_nand] = ACTIONS(361),
    [anon_sym_or] = ACTIONS(361),
    [anon_sym_xor] = ACTIONS(361),
    [anon_sym_max] = ACTIONS(361),
    [anon_sym_min] = ACTIONS(361),
    [anon_sym_umax] = ACTIONS(361),
    [anon_sym_umin] = ACTIONS(361),
    [anon_sym_fadd] = ACTIONS(361),
    [anon_sym_fsub] = ACTIONS(361),
    [anon_sym_bitcast] = ACTIONS(361),
    [anon_sym_trunc] = ACTIONS(361),
    [anon_sym_zext] = ACTIONS(361),
    [anon_sym_sext] = ACTIONS(361),
    [anon_sym_fptrunc] = ACTIONS(361),
    [anon_sym_fpext] = ACTIONS(361),
    [anon_sym_addrspacecast] = ACTIONS(361),
    [anon_sym_uitofp] = ACTIONS(361),
    [anon_sym_sitofp] = ACTIONS(361),
    [anon_sym_fptoui] = ACTIONS(361),
    [anon_sym_fptosi] = ACTIONS(361),
    [anon_sym_inttoptr] = ACTIONS(361),
    [anon_sym_ptrtoint] = ACTIONS(361),
    [anon_sym_uselistorder] = ACTIONS(361),
  },
  [42] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(279),
    [sym_global_var] = ACTIONS(279),
    [sym_local_var] = ACTIONS(279),
    [sym_label] = ACTIONS(279),
    [sym_string] = ACTIONS(281),
    [aux_sym_number_token1] = ACTIONS(281),
    [aux_sym_number_token2] = ACTIONS(281),
    [sym_float] = ACTIONS(281),
    [sym_cstring] = ACTIONS(279),
    [anon_sym_no_cfi] = ACTIONS(281),
    [anon_sym_private] = ACTIONS(281),
    [anon_sym_internal] = ACTIONS(281),
    [anon_sym_weak] = ACTIONS(281),
    [anon_sym_weak_odr] = ACTIONS(281),
    [anon_sym_linkonce] = ACTIONS(281),
    [anon_sym_linkonce_odr] = ACTIONS(281),
    [anon_sym_available_externally] = ACTIONS(281),
    [anon_sym_appending] = ACTIONS(281),
    [anon_sym_common] = ACTIONS(281),
    [anon_sym_extern_weak] = ACTIONS(281),
    [anon_sym_external] = ACTIONS(281),
    [anon_sym_dso_local] = ACTIONS(281),
    [anon_sym_dso_local_equivalent] = ACTIONS(281),
    [anon_sym_dso_preemptable] = ACTIONS(281),
    [anon_sym_default] = ACTIONS(281),
    [anon_sym_hidden] = ACTIONS(281),
    [anon_sym_protected] = ACTIONS(281),
    [anon_sym_dllimport] = ACTIONS(281),
    [anon_sym_dllexport] = ACTIONS(281),
    [anon_sym_STAR] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(279),
    [anon_sym_RBRACE] = ACTIONS(279),
    [anon_sym_LT_LBRACE] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(281),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_addrspace] = ACTIONS(281),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_align] = ACTIONS(281),
    [anon_sym_section] = ACTIONS(281),
    [anon_sym_partition] = ACTIONS(281),
    [anon_sym_comdat] = ACTIONS(281),
    [anon_sym_gc] = ACTIONS(281),
    [anon_sym_prefix] = ACTIONS(281),
    [anon_sym_prologue] = ACTIONS(281),
    [anon_sym_personality] = ACTIONS(281),
    [anon_sym_alignstack] = ACTIONS(281),
    [anon_sym_allocsize] = ACTIONS(281),
    [anon_sym_alwaysinline] = ACTIONS(281),
    [anon_sym_builtin] = ACTIONS(281),
    [anon_sym_cold] = ACTIONS(281),
    [anon_sym_convergent] = ACTIONS(281),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(281),
    [anon_sym_hot] = ACTIONS(281),
    [anon_sym_inaccessiblememonly] = ACTIONS(281),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(281),
    [anon_sym_inlinehint] = ACTIONS(281),
    [anon_sym_jumptable] = ACTIONS(281),
    [anon_sym_minsize] = ACTIONS(281),
    [anon_sym_naked] = ACTIONS(281),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(281),
    [anon_sym_nobuiltin] = ACTIONS(281),
    [anon_sym_noduplicate] = ACTIONS(281),
    [anon_sym_nofree] = ACTIONS(281),
    [anon_sym_noimplicitfloat] = ACTIONS(281),
    [anon_sym_noinline] = ACTIONS(281),
    [anon_sym_nomerge] = ACTIONS(281),
    [anon_sym_nonlazybind] = ACTIONS(281),
    [anon_sym_noprofile] = ACTIONS(281),
    [anon_sym_noredzone] = ACTIONS(281),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(281),
    [anon_sym_noreturn] = ACTIONS(281),
    [anon_sym_norecurse] = ACTIONS(281),
    [anon_sym_willreturn] = ACTIONS(281),
    [anon_sym_nosync] = ACTIONS(281),
    [anon_sym_nounwind] = ACTIONS(281),
    [anon_sym_nocallback] = ACTIONS(281),
    [anon_sym_nosanitize_coverage] = ACTIONS(281),
    [anon_sym_null_pointer_is_valid] = ACTIONS(281),
    [anon_sym_optforfuzzing] = ACTIONS(281),
    [anon_sym_optnone] = ACTIONS(281),
    [anon_sym_optsize] = ACTIONS(281),
    [anon_sym_readnone] = ACTIONS(281),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_writeonly] = ACTIONS(281),
    [anon_sym_argmemonly] = ACTIONS(281),
    [anon_sym_returns_twice] = ACTIONS(281),
    [anon_sym_safestack] = ACTIONS(281),
    [anon_sym_sanitize_address] = ACTIONS(281),
    [anon_sym_sanitize_memory] = ACTIONS(281),
    [anon_sym_sanitize_thread] = ACTIONS(281),
    [anon_sym_sanitize_hwaddress] = ACTIONS(281),
    [anon_sym_sanitize_memtag] = ACTIONS(281),
    [anon_sym_speculative_load_hardening] = ACTIONS(281),
    [anon_sym_speculatable] = ACTIONS(281),
    [anon_sym_ssp] = ACTIONS(281),
    [anon_sym_sspstrong] = ACTIONS(281),
    [anon_sym_sspreq] = ACTIONS(281),
    [anon_sym_strictfp] = ACTIONS(281),
    [anon_sym_nocf_check] = ACTIONS(281),
    [anon_sym_shadowcallstack] = ACTIONS(281),
    [anon_sym_mustprogress] = ACTIONS(281),
    [anon_sym_vscale_range] = ACTIONS(281),
    [anon_sym_preallocated] = ACTIONS(281),
    [anon_sym_zeroext] = ACTIONS(281),
    [anon_sym_signext] = ACTIONS(281),
    [anon_sym_inreg] = ACTIONS(281),
    [anon_sym_byval] = ACTIONS(281),
    [anon_sym_byref] = ACTIONS(281),
    [anon_sym_inalloca] = ACTIONS(281),
    [anon_sym_sret] = ACTIONS(281),
    [anon_sym_elementtype] = ACTIONS(281),
    [anon_sym_noalias] = ACTIONS(281),
    [anon_sym_nocapture] = ACTIONS(281),
    [anon_sym_nest] = ACTIONS(281),
    [anon_sym_returned] = ACTIONS(281),
    [anon_sym_nonnull] = ACTIONS(281),
    [anon_sym_dereferenceable] = ACTIONS(281),
    [anon_sym_dereferenceable_or_null] = ACTIONS(281),
    [anon_sym_swiftself] = ACTIONS(281),
    [anon_sym_swiftasync] = ACTIONS(281),
    [anon_sym_swifterror] = ACTIONS(281),
    [anon_sym_immarg] = ACTIONS(281),
    [anon_sym_noundef] = ACTIONS(281),
    [anon_sym_uwtable] = ACTIONS(281),
    [anon_sym_memory] = ACTIONS(281),
    [anon_sym_none] = ACTIONS(281),
    [anon_sym_unreachable] = ACTIONS(281),
    [anon_sym_ret] = ACTIONS(281),
    [anon_sym_br] = ACTIONS(281),
    [anon_sym_resume] = ACTIONS(281),
    [anon_sym_freeze] = ACTIONS(281),
    [anon_sym_indirectbr] = ACTIONS(281),
    [anon_sym_extractelement] = ACTIONS(281),
    [anon_sym_insertelement] = ACTIONS(281),
    [anon_sym_select] = ACTIONS(281),
    [anon_sym_shufflevector] = ACTIONS(281),
    [anon_sym_fneg] = ACTIONS(281),
    [anon_sym_switch] = ACTIONS(281),
    [anon_sym_invoke] = ACTIONS(281),
    [anon_sym_cleanupret] = ACTIONS(281),
    [anon_sym_catchret] = ACTIONS(281),
    [anon_sym_catchswitch] = ACTIONS(281),
    [anon_sym_catchpad] = ACTIONS(281),
    [anon_sym_cleanuppad] = ACTIONS(281),
    [anon_sym_callbr] = ACTIONS(281),
    [anon_sym_icmp] = ACTIONS(281),
    [anon_sym_fcmp] = ACTIONS(281),
    [anon_sym_va_arg] = ACTIONS(281),
    [anon_sym_phi] = ACTIONS(281),
    [anon_sym_landingpad] = ACTIONS(281),
    [anon_sym_tail] = ACTIONS(281),
    [anon_sym_musttail] = ACTIONS(281),
    [anon_sym_notail] = ACTIONS(281),
    [anon_sym_call] = ACTIONS(281),
    [anon_sym_alloca] = ACTIONS(281),
    [anon_sym_load] = ACTIONS(281),
    [anon_sym_store] = ACTIONS(281),
    [anon_sym_cmpxchg] = ACTIONS(281),
    [anon_sym_atomicrmw] = ACTIONS(281),
    [anon_sym_fence] = ACTIONS(281),
    [anon_sym_getelementptr] = ACTIONS(281),
    [anon_sym_extractvalue] = ACTIONS(281),
    [anon_sym_insertvalue] = ACTIONS(281),
    [anon_sym_true] = ACTIONS(281),
    [anon_sym_false] = ACTIONS(281),
    [anon_sym_null] = ACTIONS(281),
    [anon_sym_undef] = ACTIONS(281),
    [anon_sym_poison] = ACTIONS(281),
    [anon_sym_zeroinitializer] = ACTIONS(281),
    [anon_sym_blockaddress] = ACTIONS(281),
    [anon_sym_mul] = ACTIONS(281),
    [anon_sym_urem] = ACTIONS(281),
    [anon_sym_srem] = ACTIONS(281),
    [anon_sym_shl] = ACTIONS(281),
    [anon_sym_udiv] = ACTIONS(281),
    [anon_sym_sdiv] = ACTIONS(281),
    [anon_sym_lshr] = ACTIONS(281),
    [anon_sym_ashr] = ACTIONS(281),
    [anon_sym_fmul] = ACTIONS(281),
    [anon_sym_fdiv] = ACTIONS(281),
    [anon_sym_frem] = ACTIONS(281),
    [anon_sym_xchg] = ACTIONS(281),
    [anon_sym_add] = ACTIONS(281),
    [anon_sym_sub] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(281),
    [anon_sym_nand] = ACTIONS(281),
    [anon_sym_or] = ACTIONS(281),
    [anon_sym_xor] = ACTIONS(281),
    [anon_sym_max] = ACTIONS(281),
    [anon_sym_min] = ACTIONS(281),
    [anon_sym_umax] = ACTIONS(281),
    [anon_sym_umin] = ACTIONS(281),
    [anon_sym_fadd] = ACTIONS(281),
    [anon_sym_fsub] = ACTIONS(281),
    [anon_sym_bitcast] = ACTIONS(281),
    [anon_sym_trunc] = ACTIONS(281),
    [anon_sym_zext] = ACTIONS(281),
    [anon_sym_sext] = ACTIONS(281),
    [anon_sym_fptrunc] = ACTIONS(281),
    [anon_sym_fpext] = ACTIONS(281),
    [anon_sym_addrspacecast] = ACTIONS(281),
    [anon_sym_uitofp] = ACTIONS(281),
    [anon_sym_sitofp] = ACTIONS(281),
    [anon_sym_fptoui] = ACTIONS(281),
    [anon_sym_fptosi] = ACTIONS(281),
    [anon_sym_inttoptr] = ACTIONS(281),
    [anon_sym_ptrtoint] = ACTIONS(281),
    [anon_sym_uselistorder] = ACTIONS(281),
  },
  [43] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(363),
    [sym_global_var] = ACTIONS(363),
    [sym_local_var] = ACTIONS(363),
    [sym_label] = ACTIONS(363),
    [sym_string] = ACTIONS(365),
    [aux_sym_number_token1] = ACTIONS(365),
    [aux_sym_number_token2] = ACTIONS(365),
    [sym_float] = ACTIONS(365),
    [sym_cstring] = ACTIONS(363),
    [anon_sym_no_cfi] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_internal] = ACTIONS(365),
    [anon_sym_weak] = ACTIONS(365),
    [anon_sym_weak_odr] = ACTIONS(365),
    [anon_sym_linkonce] = ACTIONS(365),
    [anon_sym_linkonce_odr] = ACTIONS(365),
    [anon_sym_available_externally] = ACTIONS(365),
    [anon_sym_appending] = ACTIONS(365),
    [anon_sym_common] = ACTIONS(365),
    [anon_sym_extern_weak] = ACTIONS(365),
    [anon_sym_external] = ACTIONS(365),
    [anon_sym_dso_local] = ACTIONS(365),
    [anon_sym_dso_local_equivalent] = ACTIONS(365),
    [anon_sym_dso_preemptable] = ACTIONS(365),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_hidden] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_dllimport] = ACTIONS(365),
    [anon_sym_dllexport] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(363),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_LT_LBRACE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_LT] = ACTIONS(365),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_addrspace] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_align] = ACTIONS(365),
    [anon_sym_section] = ACTIONS(365),
    [anon_sym_partition] = ACTIONS(365),
    [anon_sym_comdat] = ACTIONS(365),
    [anon_sym_gc] = ACTIONS(365),
    [anon_sym_prefix] = ACTIONS(365),
    [anon_sym_prologue] = ACTIONS(365),
    [anon_sym_personality] = ACTIONS(365),
    [anon_sym_alignstack] = ACTIONS(365),
    [anon_sym_allocsize] = ACTIONS(365),
    [anon_sym_alwaysinline] = ACTIONS(365),
    [anon_sym_builtin] = ACTIONS(365),
    [anon_sym_cold] = ACTIONS(365),
    [anon_sym_convergent] = ACTIONS(365),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(365),
    [anon_sym_hot] = ACTIONS(365),
    [anon_sym_inaccessiblememonly] = ACTIONS(365),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(365),
    [anon_sym_inlinehint] = ACTIONS(365),
    [anon_sym_jumptable] = ACTIONS(365),
    [anon_sym_minsize] = ACTIONS(365),
    [anon_sym_naked] = ACTIONS(365),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(365),
    [anon_sym_nobuiltin] = ACTIONS(365),
    [anon_sym_noduplicate] = ACTIONS(365),
    [anon_sym_nofree] = ACTIONS(365),
    [anon_sym_noimplicitfloat] = ACTIONS(365),
    [anon_sym_noinline] = ACTIONS(365),
    [anon_sym_nomerge] = ACTIONS(365),
    [anon_sym_nonlazybind] = ACTIONS(365),
    [anon_sym_noprofile] = ACTIONS(365),
    [anon_sym_noredzone] = ACTIONS(365),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(365),
    [anon_sym_noreturn] = ACTIONS(365),
    [anon_sym_norecurse] = ACTIONS(365),
    [anon_sym_willreturn] = ACTIONS(365),
    [anon_sym_nosync] = ACTIONS(365),
    [anon_sym_nounwind] = ACTIONS(365),
    [anon_sym_nocallback] = ACTIONS(365),
    [anon_sym_nosanitize_coverage] = ACTIONS(365),
    [anon_sym_null_pointer_is_valid] = ACTIONS(365),
    [anon_sym_optforfuzzing] = ACTIONS(365),
    [anon_sym_optnone] = ACTIONS(365),
    [anon_sym_optsize] = ACTIONS(365),
    [anon_sym_readnone] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_writeonly] = ACTIONS(365),
    [anon_sym_argmemonly] = ACTIONS(365),
    [anon_sym_returns_twice] = ACTIONS(365),
    [anon_sym_safestack] = ACTIONS(365),
    [anon_sym_sanitize_address] = ACTIONS(365),
    [anon_sym_sanitize_memory] = ACTIONS(365),
    [anon_sym_sanitize_thread] = ACTIONS(365),
    [anon_sym_sanitize_hwaddress] = ACTIONS(365),
    [anon_sym_sanitize_memtag] = ACTIONS(365),
    [anon_sym_speculative_load_hardening] = ACTIONS(365),
    [anon_sym_speculatable] = ACTIONS(365),
    [anon_sym_ssp] = ACTIONS(365),
    [anon_sym_sspstrong] = ACTIONS(365),
    [anon_sym_sspreq] = ACTIONS(365),
    [anon_sym_strictfp] = ACTIONS(365),
    [anon_sym_nocf_check] = ACTIONS(365),
    [anon_sym_shadowcallstack] = ACTIONS(365),
    [anon_sym_mustprogress] = ACTIONS(365),
    [anon_sym_vscale_range] = ACTIONS(365),
    [anon_sym_preallocated] = ACTIONS(365),
    [anon_sym_zeroext] = ACTIONS(365),
    [anon_sym_signext] = ACTIONS(365),
    [anon_sym_inreg] = ACTIONS(365),
    [anon_sym_byval] = ACTIONS(365),
    [anon_sym_byref] = ACTIONS(365),
    [anon_sym_inalloca] = ACTIONS(365),
    [anon_sym_sret] = ACTIONS(365),
    [anon_sym_elementtype] = ACTIONS(365),
    [anon_sym_noalias] = ACTIONS(365),
    [anon_sym_nocapture] = ACTIONS(365),
    [anon_sym_nest] = ACTIONS(365),
    [anon_sym_returned] = ACTIONS(365),
    [anon_sym_nonnull] = ACTIONS(365),
    [anon_sym_dereferenceable] = ACTIONS(365),
    [anon_sym_dereferenceable_or_null] = ACTIONS(365),
    [anon_sym_swiftself] = ACTIONS(365),
    [anon_sym_swiftasync] = ACTIONS(365),
    [anon_sym_swifterror] = ACTIONS(365),
    [anon_sym_immarg] = ACTIONS(365),
    [anon_sym_noundef] = ACTIONS(365),
    [anon_sym_uwtable] = ACTIONS(365),
    [anon_sym_memory] = ACTIONS(365),
    [anon_sym_none] = ACTIONS(365),
    [anon_sym_unreachable] = ACTIONS(365),
    [anon_sym_ret] = ACTIONS(365),
    [anon_sym_br] = ACTIONS(365),
    [anon_sym_resume] = ACTIONS(365),
    [anon_sym_freeze] = ACTIONS(365),
    [anon_sym_indirectbr] = ACTIONS(365),
    [anon_sym_extractelement] = ACTIONS(365),
    [anon_sym_insertelement] = ACTIONS(365),
    [anon_sym_select] = ACTIONS(365),
    [anon_sym_shufflevector] = ACTIONS(365),
    [anon_sym_fneg] = ACTIONS(365),
    [anon_sym_switch] = ACTIONS(365),
    [anon_sym_invoke] = ACTIONS(365),
    [anon_sym_cleanupret] = ACTIONS(365),
    [anon_sym_catchret] = ACTIONS(365),
    [anon_sym_catchswitch] = ACTIONS(365),
    [anon_sym_catchpad] = ACTIONS(365),
    [anon_sym_cleanuppad] = ACTIONS(365),
    [anon_sym_callbr] = ACTIONS(365),
    [anon_sym_icmp] = ACTIONS(365),
    [anon_sym_fcmp] = ACTIONS(365),
    [anon_sym_va_arg] = ACTIONS(365),
    [anon_sym_phi] = ACTIONS(365),
    [anon_sym_landingpad] = ACTIONS(365),
    [anon_sym_tail] = ACTIONS(365),
    [anon_sym_musttail] = ACTIONS(365),
    [anon_sym_notail] = ACTIONS(365),
    [anon_sym_call] = ACTIONS(365),
    [anon_sym_alloca] = ACTIONS(365),
    [anon_sym_load] = ACTIONS(365),
    [anon_sym_store] = ACTIONS(365),
    [anon_sym_cmpxchg] = ACTIONS(365),
    [anon_sym_atomicrmw] = ACTIONS(365),
    [anon_sym_fence] = ACTIONS(365),
    [anon_sym_getelementptr] = ACTIONS(365),
    [anon_sym_extractvalue] = ACTIONS(365),
    [anon_sym_insertvalue] = ACTIONS(365),
    [anon_sym_true] = ACTIONS(365),
    [anon_sym_false] = ACTIONS(365),
    [anon_sym_null] = ACTIONS(365),
    [anon_sym_undef] = ACTIONS(365),
    [anon_sym_poison] = ACTIONS(365),
    [anon_sym_zeroinitializer] = ACTIONS(365),
    [anon_sym_blockaddress] = ACTIONS(365),
    [anon_sym_mul] = ACTIONS(365),
    [anon_sym_urem] = ACTIONS(365),
    [anon_sym_srem] = ACTIONS(365),
    [anon_sym_shl] = ACTIONS(365),
    [anon_sym_udiv] = ACTIONS(365),
    [anon_sym_sdiv] = ACTIONS(365),
    [anon_sym_lshr] = ACTIONS(365),
    [anon_sym_ashr] = ACTIONS(365),
    [anon_sym_fmul] = ACTIONS(365),
    [anon_sym_fdiv] = ACTIONS(365),
    [anon_sym_frem] = ACTIONS(365),
    [anon_sym_xchg] = ACTIONS(365),
    [anon_sym_add] = ACTIONS(365),
    [anon_sym_sub] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(365),
    [anon_sym_nand] = ACTIONS(365),
    [anon_sym_or] = ACTIONS(365),
    [anon_sym_xor] = ACTIONS(365),
    [anon_sym_max] = ACTIONS(365),
    [anon_sym_min] = ACTIONS(365),
    [anon_sym_umax] = ACTIONS(365),
    [anon_sym_umin] = ACTIONS(365),
    [anon_sym_fadd] = ACTIONS(365),
    [anon_sym_fsub] = ACTIONS(365),
    [anon_sym_bitcast] = ACTIONS(365),
    [anon_sym_trunc] = ACTIONS(365),
    [anon_sym_zext] = ACTIONS(365),
    [anon_sym_sext] = ACTIONS(365),
    [anon_sym_fptrunc] = ACTIONS(365),
    [anon_sym_fpext] = ACTIONS(365),
    [anon_sym_addrspacecast] = ACTIONS(365),
    [anon_sym_uitofp] = ACTIONS(365),
    [anon_sym_sitofp] = ACTIONS(365),
    [anon_sym_fptoui] = ACTIONS(365),
    [anon_sym_fptosi] = ACTIONS(365),
    [anon_sym_inttoptr] = ACTIONS(365),
    [anon_sym_ptrtoint] = ACTIONS(365),
    [anon_sym_uselistorder] = ACTIONS(365),
  },
  [44] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(371),
    [sym_global_var] = ACTIONS(371),
    [sym_local_var] = ACTIONS(371),
    [sym_label] = ACTIONS(371),
    [sym_string] = ACTIONS(373),
    [aux_sym_number_token1] = ACTIONS(373),
    [aux_sym_number_token2] = ACTIONS(373),
    [sym_float] = ACTIONS(373),
    [sym_cstring] = ACTIONS(371),
    [anon_sym_no_cfi] = ACTIONS(373),
    [anon_sym_private] = ACTIONS(373),
    [anon_sym_internal] = ACTIONS(373),
    [anon_sym_weak] = ACTIONS(373),
    [anon_sym_weak_odr] = ACTIONS(373),
    [anon_sym_linkonce] = ACTIONS(373),
    [anon_sym_linkonce_odr] = ACTIONS(373),
    [anon_sym_available_externally] = ACTIONS(373),
    [anon_sym_appending] = ACTIONS(373),
    [anon_sym_common] = ACTIONS(373),
    [anon_sym_extern_weak] = ACTIONS(373),
    [anon_sym_external] = ACTIONS(373),
    [anon_sym_dso_local] = ACTIONS(373),
    [anon_sym_dso_local_equivalent] = ACTIONS(373),
    [anon_sym_dso_preemptable] = ACTIONS(373),
    [anon_sym_default] = ACTIONS(373),
    [anon_sym_hidden] = ACTIONS(373),
    [anon_sym_protected] = ACTIONS(373),
    [anon_sym_dllimport] = ACTIONS(373),
    [anon_sym_dllexport] = ACTIONS(373),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(371),
    [anon_sym_LT_LBRACE] = ACTIONS(371),
    [anon_sym_LBRACK] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_COMMA] = ACTIONS(371),
    [anon_sym_addrspace] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_align] = ACTIONS(373),
    [anon_sym_section] = ACTIONS(373),
    [anon_sym_partition] = ACTIONS(373),
    [anon_sym_comdat] = ACTIONS(373),
    [anon_sym_gc] = ACTIONS(373),
    [anon_sym_prefix] = ACTIONS(373),
    [anon_sym_prologue] = ACTIONS(373),
    [anon_sym_personality] = ACTIONS(373),
    [anon_sym_alignstack] = ACTIONS(373),
    [anon_sym_allocsize] = ACTIONS(373),
    [anon_sym_alwaysinline] = ACTIONS(373),
    [anon_sym_builtin] = ACTIONS(373),
    [anon_sym_cold] = ACTIONS(373),
    [anon_sym_convergent] = ACTIONS(373),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(373),
    [anon_sym_hot] = ACTIONS(373),
    [anon_sym_inaccessiblememonly] = ACTIONS(373),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(373),
    [anon_sym_inlinehint] = ACTIONS(373),
    [anon_sym_jumptable] = ACTIONS(373),
    [anon_sym_minsize] = ACTIONS(373),
    [anon_sym_naked] = ACTIONS(373),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(373),
    [anon_sym_nobuiltin] = ACTIONS(373),
    [anon_sym_noduplicate] = ACTIONS(373),
    [anon_sym_nofree] = ACTIONS(373),
    [anon_sym_noimplicitfloat] = ACTIONS(373),
    [anon_sym_noinline] = ACTIONS(373),
    [anon_sym_nomerge] = ACTIONS(373),
    [anon_sym_nonlazybind] = ACTIONS(373),
    [anon_sym_noprofile] = ACTIONS(373),
    [anon_sym_noredzone] = ACTIONS(373),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(373),
    [anon_sym_noreturn] = ACTIONS(373),
    [anon_sym_norecurse] = ACTIONS(373),
    [anon_sym_willreturn] = ACTIONS(373),
    [anon_sym_nosync] = ACTIONS(373),
    [anon_sym_nounwind] = ACTIONS(373),
    [anon_sym_nocallback] = ACTIONS(373),
    [anon_sym_nosanitize_coverage] = ACTIONS(373),
    [anon_sym_null_pointer_is_valid] = ACTIONS(373),
    [anon_sym_optforfuzzing] = ACTIONS(373),
    [anon_sym_optnone] = ACTIONS(373),
    [anon_sym_optsize] = ACTIONS(373),
    [anon_sym_readnone] = ACTIONS(373),
    [anon_sym_readonly] = ACTIONS(373),
    [anon_sym_writeonly] = ACTIONS(373),
    [anon_sym_argmemonly] = ACTIONS(373),
    [anon_sym_returns_twice] = ACTIONS(373),
    [anon_sym_safestack] = ACTIONS(373),
    [anon_sym_sanitize_address] = ACTIONS(373),
    [anon_sym_sanitize_memory] = ACTIONS(373),
    [anon_sym_sanitize_thread] = ACTIONS(373),
    [anon_sym_sanitize_hwaddress] = ACTIONS(373),
    [anon_sym_sanitize_memtag] = ACTIONS(373),
    [anon_sym_speculative_load_hardening] = ACTIONS(373),
    [anon_sym_speculatable] = ACTIONS(373),
    [anon_sym_ssp] = ACTIONS(373),
    [anon_sym_sspstrong] = ACTIONS(373),
    [anon_sym_sspreq] = ACTIONS(373),
    [anon_sym_strictfp] = ACTIONS(373),
    [anon_sym_nocf_check] = ACTIONS(373),
    [anon_sym_shadowcallstack] = ACTIONS(373),
    [anon_sym_mustprogress] = ACTIONS(373),
    [anon_sym_vscale_range] = ACTIONS(373),
    [anon_sym_preallocated] = ACTIONS(373),
    [anon_sym_zeroext] = ACTIONS(373),
    [anon_sym_signext] = ACTIONS(373),
    [anon_sym_inreg] = ACTIONS(373),
    [anon_sym_byval] = ACTIONS(373),
    [anon_sym_byref] = ACTIONS(373),
    [anon_sym_inalloca] = ACTIONS(373),
    [anon_sym_sret] = ACTIONS(373),
    [anon_sym_elementtype] = ACTIONS(373),
    [anon_sym_noalias] = ACTIONS(373),
    [anon_sym_nocapture] = ACTIONS(373),
    [anon_sym_nest] = ACTIONS(373),
    [anon_sym_returned] = ACTIONS(373),
    [anon_sym_nonnull] = ACTIONS(373),
    [anon_sym_dereferenceable] = ACTIONS(373),
    [anon_sym_dereferenceable_or_null] = ACTIONS(373),
    [anon_sym_swiftself] = ACTIONS(373),
    [anon_sym_swiftasync] = ACTIONS(373),
    [anon_sym_swifterror] = ACTIONS(373),
    [anon_sym_immarg] = ACTIONS(373),
    [anon_sym_noundef] = ACTIONS(373),
    [anon_sym_uwtable] = ACTIONS(373),
    [anon_sym_memory] = ACTIONS(373),
    [anon_sym_none] = ACTIONS(373),
    [anon_sym_unreachable] = ACTIONS(373),
    [anon_sym_ret] = ACTIONS(373),
    [anon_sym_br] = ACTIONS(373),
    [anon_sym_resume] = ACTIONS(373),
    [anon_sym_freeze] = ACTIONS(373),
    [anon_sym_indirectbr] = ACTIONS(373),
    [anon_sym_extractelement] = ACTIONS(373),
    [anon_sym_insertelement] = ACTIONS(373),
    [anon_sym_select] = ACTIONS(373),
    [anon_sym_shufflevector] = ACTIONS(373),
    [anon_sym_fneg] = ACTIONS(373),
    [anon_sym_switch] = ACTIONS(373),
    [anon_sym_invoke] = ACTIONS(373),
    [anon_sym_cleanupret] = ACTIONS(373),
    [anon_sym_catchret] = ACTIONS(373),
    [anon_sym_catchswitch] = ACTIONS(373),
    [anon_sym_catchpad] = ACTIONS(373),
    [anon_sym_cleanuppad] = ACTIONS(373),
    [anon_sym_callbr] = ACTIONS(373),
    [anon_sym_icmp] = ACTIONS(373),
    [anon_sym_fcmp] = ACTIONS(373),
    [anon_sym_va_arg] = ACTIONS(373),
    [anon_sym_phi] = ACTIONS(373),
    [anon_sym_landingpad] = ACTIONS(373),
    [anon_sym_tail] = ACTIONS(373),
    [anon_sym_musttail] = ACTIONS(373),
    [anon_sym_notail] = ACTIONS(373),
    [anon_sym_call] = ACTIONS(373),
    [anon_sym_alloca] = ACTIONS(373),
    [anon_sym_load] = ACTIONS(373),
    [anon_sym_store] = ACTIONS(373),
    [anon_sym_cmpxchg] = ACTIONS(373),
    [anon_sym_atomicrmw] = ACTIONS(373),
    [anon_sym_fence] = ACTIONS(373),
    [anon_sym_getelementptr] = ACTIONS(373),
    [anon_sym_extractvalue] = ACTIONS(373),
    [anon_sym_insertvalue] = ACTIONS(373),
    [anon_sym_true] = ACTIONS(373),
    [anon_sym_false] = ACTIONS(373),
    [anon_sym_null] = ACTIONS(373),
    [anon_sym_undef] = ACTIONS(373),
    [anon_sym_poison] = ACTIONS(373),
    [anon_sym_zeroinitializer] = ACTIONS(373),
    [anon_sym_blockaddress] = ACTIONS(373),
    [anon_sym_mul] = ACTIONS(373),
    [anon_sym_urem] = ACTIONS(373),
    [anon_sym_srem] = ACTIONS(373),
    [anon_sym_shl] = ACTIONS(373),
    [anon_sym_udiv] = ACTIONS(373),
    [anon_sym_sdiv] = ACTIONS(373),
    [anon_sym_lshr] = ACTIONS(373),
    [anon_sym_ashr] = ACTIONS(373),
    [anon_sym_fmul] = ACTIONS(373),
    [anon_sym_fdiv] = ACTIONS(373),
    [anon_sym_frem] = ACTIONS(373),
    [anon_sym_xchg] = ACTIONS(373),
    [anon_sym_add] = ACTIONS(373),
    [anon_sym_sub] = ACTIONS(373),
    [anon_sym_and] = ACTIONS(373),
    [anon_sym_nand] = ACTIONS(373),
    [anon_sym_or] = ACTIONS(373),
    [anon_sym_xor] = ACTIONS(373),
    [anon_sym_max] = ACTIONS(373),
    [anon_sym_min] = ACTIONS(373),
    [anon_sym_umax] = ACTIONS(373),
    [anon_sym_umin] = ACTIONS(373),
    [anon_sym_fadd] = ACTIONS(373),
    [anon_sym_fsub] = ACTIONS(373),
    [anon_sym_bitcast] = ACTIONS(373),
    [anon_sym_trunc] = ACTIONS(373),
    [anon_sym_zext] = ACTIONS(373),
    [anon_sym_sext] = ACTIONS(373),
    [anon_sym_fptrunc] = ACTIONS(373),
    [anon_sym_fpext] = ACTIONS(373),
    [anon_sym_addrspacecast] = ACTIONS(373),
    [anon_sym_uitofp] = ACTIONS(373),
    [anon_sym_sitofp] = ACTIONS(373),
    [anon_sym_fptoui] = ACTIONS(373),
    [anon_sym_fptosi] = ACTIONS(373),
    [anon_sym_inttoptr] = ACTIONS(373),
    [anon_sym_ptrtoint] = ACTIONS(373),
    [anon_sym_uselistorder] = ACTIONS(373),
  },
  [45] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(367),
    [sym_global_var] = ACTIONS(367),
    [sym_local_var] = ACTIONS(367),
    [sym_label] = ACTIONS(367),
    [sym_string] = ACTIONS(369),
    [aux_sym_number_token1] = ACTIONS(369),
    [aux_sym_number_token2] = ACTIONS(369),
    [sym_float] = ACTIONS(369),
    [sym_cstring] = ACTIONS(367),
    [anon_sym_no_cfi] = ACTIONS(369),
    [anon_sym_private] = ACTIONS(369),
    [anon_sym_internal] = ACTIONS(369),
    [anon_sym_weak] = ACTIONS(369),
    [anon_sym_weak_odr] = ACTIONS(369),
    [anon_sym_linkonce] = ACTIONS(369),
    [anon_sym_linkonce_odr] = ACTIONS(369),
    [anon_sym_available_externally] = ACTIONS(369),
    [anon_sym_appending] = ACTIONS(369),
    [anon_sym_common] = ACTIONS(369),
    [anon_sym_extern_weak] = ACTIONS(369),
    [anon_sym_external] = ACTIONS(369),
    [anon_sym_dso_local] = ACTIONS(369),
    [anon_sym_dso_local_equivalent] = ACTIONS(369),
    [anon_sym_dso_preemptable] = ACTIONS(369),
    [anon_sym_default] = ACTIONS(369),
    [anon_sym_hidden] = ACTIONS(369),
    [anon_sym_protected] = ACTIONS(369),
    [anon_sym_dllimport] = ACTIONS(369),
    [anon_sym_dllexport] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(367),
    [anon_sym_RBRACE] = ACTIONS(367),
    [anon_sym_LT_LBRACE] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_COMMA] = ACTIONS(367),
    [anon_sym_addrspace] = ACTIONS(369),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_align] = ACTIONS(369),
    [anon_sym_section] = ACTIONS(369),
    [anon_sym_partition] = ACTIONS(369),
    [anon_sym_comdat] = ACTIONS(369),
    [anon_sym_gc] = ACTIONS(369),
    [anon_sym_prefix] = ACTIONS(369),
    [anon_sym_prologue] = ACTIONS(369),
    [anon_sym_personality] = ACTIONS(369),
    [anon_sym_alignstack] = ACTIONS(369),
    [anon_sym_allocsize] = ACTIONS(369),
    [anon_sym_alwaysinline] = ACTIONS(369),
    [anon_sym_builtin] = ACTIONS(369),
    [anon_sym_cold] = ACTIONS(369),
    [anon_sym_convergent] = ACTIONS(369),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(369),
    [anon_sym_hot] = ACTIONS(369),
    [anon_sym_inaccessiblememonly] = ACTIONS(369),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(369),
    [anon_sym_inlinehint] = ACTIONS(369),
    [anon_sym_jumptable] = ACTIONS(369),
    [anon_sym_minsize] = ACTIONS(369),
    [anon_sym_naked] = ACTIONS(369),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(369),
    [anon_sym_nobuiltin] = ACTIONS(369),
    [anon_sym_noduplicate] = ACTIONS(369),
    [anon_sym_nofree] = ACTIONS(369),
    [anon_sym_noimplicitfloat] = ACTIONS(369),
    [anon_sym_noinline] = ACTIONS(369),
    [anon_sym_nomerge] = ACTIONS(369),
    [anon_sym_nonlazybind] = ACTIONS(369),
    [anon_sym_noprofile] = ACTIONS(369),
    [anon_sym_noredzone] = ACTIONS(369),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(369),
    [anon_sym_noreturn] = ACTIONS(369),
    [anon_sym_norecurse] = ACTIONS(369),
    [anon_sym_willreturn] = ACTIONS(369),
    [anon_sym_nosync] = ACTIONS(369),
    [anon_sym_nounwind] = ACTIONS(369),
    [anon_sym_nocallback] = ACTIONS(369),
    [anon_sym_nosanitize_coverage] = ACTIONS(369),
    [anon_sym_null_pointer_is_valid] = ACTIONS(369),
    [anon_sym_optforfuzzing] = ACTIONS(369),
    [anon_sym_optnone] = ACTIONS(369),
    [anon_sym_optsize] = ACTIONS(369),
    [anon_sym_readnone] = ACTIONS(369),
    [anon_sym_readonly] = ACTIONS(369),
    [anon_sym_writeonly] = ACTIONS(369),
    [anon_sym_argmemonly] = ACTIONS(369),
    [anon_sym_returns_twice] = ACTIONS(369),
    [anon_sym_safestack] = ACTIONS(369),
    [anon_sym_sanitize_address] = ACTIONS(369),
    [anon_sym_sanitize_memory] = ACTIONS(369),
    [anon_sym_sanitize_thread] = ACTIONS(369),
    [anon_sym_sanitize_hwaddress] = ACTIONS(369),
    [anon_sym_sanitize_memtag] = ACTIONS(369),
    [anon_sym_speculative_load_hardening] = ACTIONS(369),
    [anon_sym_speculatable] = ACTIONS(369),
    [anon_sym_ssp] = ACTIONS(369),
    [anon_sym_sspstrong] = ACTIONS(369),
    [anon_sym_sspreq] = ACTIONS(369),
    [anon_sym_strictfp] = ACTIONS(369),
    [anon_sym_nocf_check] = ACTIONS(369),
    [anon_sym_shadowcallstack] = ACTIONS(369),
    [anon_sym_mustprogress] = ACTIONS(369),
    [anon_sym_vscale_range] = ACTIONS(369),
    [anon_sym_preallocated] = ACTIONS(369),
    [anon_sym_zeroext] = ACTIONS(369),
    [anon_sym_signext] = ACTIONS(369),
    [anon_sym_inreg] = ACTIONS(369),
    [anon_sym_byval] = ACTIONS(369),
    [anon_sym_byref] = ACTIONS(369),
    [anon_sym_inalloca] = ACTIONS(369),
    [anon_sym_sret] = ACTIONS(369),
    [anon_sym_elementtype] = ACTIONS(369),
    [anon_sym_noalias] = ACTIONS(369),
    [anon_sym_nocapture] = ACTIONS(369),
    [anon_sym_nest] = ACTIONS(369),
    [anon_sym_returned] = ACTIONS(369),
    [anon_sym_nonnull] = ACTIONS(369),
    [anon_sym_dereferenceable] = ACTIONS(369),
    [anon_sym_dereferenceable_or_null] = ACTIONS(369),
    [anon_sym_swiftself] = ACTIONS(369),
    [anon_sym_swiftasync] = ACTIONS(369),
    [anon_sym_swifterror] = ACTIONS(369),
    [anon_sym_immarg] = ACTIONS(369),
    [anon_sym_noundef] = ACTIONS(369),
    [anon_sym_uwtable] = ACTIONS(369),
    [anon_sym_memory] = ACTIONS(369),
    [anon_sym_none] = ACTIONS(369),
    [anon_sym_unreachable] = ACTIONS(369),
    [anon_sym_ret] = ACTIONS(369),
    [anon_sym_br] = ACTIONS(369),
    [anon_sym_resume] = ACTIONS(369),
    [anon_sym_freeze] = ACTIONS(369),
    [anon_sym_indirectbr] = ACTIONS(369),
    [anon_sym_extractelement] = ACTIONS(369),
    [anon_sym_insertelement] = ACTIONS(369),
    [anon_sym_select] = ACTIONS(369),
    [anon_sym_shufflevector] = ACTIONS(369),
    [anon_sym_fneg] = ACTIONS(369),
    [anon_sym_switch] = ACTIONS(369),
    [anon_sym_invoke] = ACTIONS(369),
    [anon_sym_cleanupret] = ACTIONS(369),
    [anon_sym_catchret] = ACTIONS(369),
    [anon_sym_catchswitch] = ACTIONS(369),
    [anon_sym_catchpad] = ACTIONS(369),
    [anon_sym_cleanuppad] = ACTIONS(369),
    [anon_sym_callbr] = ACTIONS(369),
    [anon_sym_icmp] = ACTIONS(369),
    [anon_sym_fcmp] = ACTIONS(369),
    [anon_sym_va_arg] = ACTIONS(369),
    [anon_sym_phi] = ACTIONS(369),
    [anon_sym_landingpad] = ACTIONS(369),
    [anon_sym_tail] = ACTIONS(369),
    [anon_sym_musttail] = ACTIONS(369),
    [anon_sym_notail] = ACTIONS(369),
    [anon_sym_call] = ACTIONS(369),
    [anon_sym_alloca] = ACTIONS(369),
    [anon_sym_load] = ACTIONS(369),
    [anon_sym_store] = ACTIONS(369),
    [anon_sym_cmpxchg] = ACTIONS(369),
    [anon_sym_atomicrmw] = ACTIONS(369),
    [anon_sym_fence] = ACTIONS(369),
    [anon_sym_getelementptr] = ACTIONS(369),
    [anon_sym_extractvalue] = ACTIONS(369),
    [anon_sym_insertvalue] = ACTIONS(369),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_null] = ACTIONS(369),
    [anon_sym_undef] = ACTIONS(369),
    [anon_sym_poison] = ACTIONS(369),
    [anon_sym_zeroinitializer] = ACTIONS(369),
    [anon_sym_blockaddress] = ACTIONS(369),
    [anon_sym_mul] = ACTIONS(369),
    [anon_sym_urem] = ACTIONS(369),
    [anon_sym_srem] = ACTIONS(369),
    [anon_sym_shl] = ACTIONS(369),
    [anon_sym_udiv] = ACTIONS(369),
    [anon_sym_sdiv] = ACTIONS(369),
    [anon_sym_lshr] = ACTIONS(369),
    [anon_sym_ashr] = ACTIONS(369),
    [anon_sym_fmul] = ACTIONS(369),
    [anon_sym_fdiv] = ACTIONS(369),
    [anon_sym_frem] = ACTIONS(369),
    [anon_sym_xchg] = ACTIONS(369),
    [anon_sym_add] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_nand] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_xor] = ACTIONS(369),
    [anon_sym_max] = ACTIONS(369),
    [anon_sym_min] = ACTIONS(369),
    [anon_sym_umax] = ACTIONS(369),
    [anon_sym_umin] = ACTIONS(369),
    [anon_sym_fadd] = ACTIONS(369),
    [anon_sym_fsub] = ACTIONS(369),
    [anon_sym_bitcast] = ACTIONS(369),
    [anon_sym_trunc] = ACTIONS(369),
    [anon_sym_zext] = ACTIONS(369),
    [anon_sym_sext] = ACTIONS(369),
    [anon_sym_fptrunc] = ACTIONS(369),
    [anon_sym_fpext] = ACTIONS(369),
    [anon_sym_addrspacecast] = ACTIONS(369),
    [anon_sym_uitofp] = ACTIONS(369),
    [anon_sym_sitofp] = ACTIONS(369),
    [anon_sym_fptoui] = ACTIONS(369),
    [anon_sym_fptosi] = ACTIONS(369),
    [anon_sym_inttoptr] = ACTIONS(369),
    [anon_sym_ptrtoint] = ACTIONS(369),
    [anon_sym_uselistorder] = ACTIONS(369),
  },
  [46] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(387),
    [sym_global_var] = ACTIONS(387),
    [sym_local_var] = ACTIONS(387),
    [sym_label] = ACTIONS(387),
    [sym_string] = ACTIONS(389),
    [aux_sym_number_token1] = ACTIONS(389),
    [aux_sym_number_token2] = ACTIONS(389),
    [sym_float] = ACTIONS(389),
    [sym_cstring] = ACTIONS(387),
    [anon_sym_no_cfi] = ACTIONS(389),
    [anon_sym_private] = ACTIONS(389),
    [anon_sym_internal] = ACTIONS(389),
    [anon_sym_weak] = ACTIONS(389),
    [anon_sym_weak_odr] = ACTIONS(389),
    [anon_sym_linkonce] = ACTIONS(389),
    [anon_sym_linkonce_odr] = ACTIONS(389),
    [anon_sym_available_externally] = ACTIONS(389),
    [anon_sym_appending] = ACTIONS(389),
    [anon_sym_common] = ACTIONS(389),
    [anon_sym_extern_weak] = ACTIONS(389),
    [anon_sym_external] = ACTIONS(389),
    [anon_sym_dso_local] = ACTIONS(389),
    [anon_sym_dso_local_equivalent] = ACTIONS(389),
    [anon_sym_dso_preemptable] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(389),
    [anon_sym_hidden] = ACTIONS(389),
    [anon_sym_protected] = ACTIONS(389),
    [anon_sym_dllimport] = ACTIONS(389),
    [anon_sym_dllexport] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(387),
    [anon_sym_LBRACE] = ACTIONS(387),
    [anon_sym_RBRACE] = ACTIONS(387),
    [anon_sym_LT_LBRACE] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_COMMA] = ACTIONS(387),
    [anon_sym_addrspace] = ACTIONS(389),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_align] = ACTIONS(389),
    [anon_sym_section] = ACTIONS(389),
    [anon_sym_partition] = ACTIONS(389),
    [anon_sym_comdat] = ACTIONS(389),
    [anon_sym_gc] = ACTIONS(389),
    [anon_sym_prefix] = ACTIONS(389),
    [anon_sym_prologue] = ACTIONS(389),
    [anon_sym_personality] = ACTIONS(389),
    [anon_sym_alignstack] = ACTIONS(389),
    [anon_sym_allocsize] = ACTIONS(389),
    [anon_sym_alwaysinline] = ACTIONS(389),
    [anon_sym_builtin] = ACTIONS(389),
    [anon_sym_cold] = ACTIONS(389),
    [anon_sym_convergent] = ACTIONS(389),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(389),
    [anon_sym_hot] = ACTIONS(389),
    [anon_sym_inaccessiblememonly] = ACTIONS(389),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(389),
    [anon_sym_inlinehint] = ACTIONS(389),
    [anon_sym_jumptable] = ACTIONS(389),
    [anon_sym_minsize] = ACTIONS(389),
    [anon_sym_naked] = ACTIONS(389),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(389),
    [anon_sym_nobuiltin] = ACTIONS(389),
    [anon_sym_noduplicate] = ACTIONS(389),
    [anon_sym_nofree] = ACTIONS(389),
    [anon_sym_noimplicitfloat] = ACTIONS(389),
    [anon_sym_noinline] = ACTIONS(389),
    [anon_sym_nomerge] = ACTIONS(389),
    [anon_sym_nonlazybind] = ACTIONS(389),
    [anon_sym_noprofile] = ACTIONS(389),
    [anon_sym_noredzone] = ACTIONS(389),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(389),
    [anon_sym_noreturn] = ACTIONS(389),
    [anon_sym_norecurse] = ACTIONS(389),
    [anon_sym_willreturn] = ACTIONS(389),
    [anon_sym_nosync] = ACTIONS(389),
    [anon_sym_nounwind] = ACTIONS(389),
    [anon_sym_nocallback] = ACTIONS(389),
    [anon_sym_nosanitize_coverage] = ACTIONS(389),
    [anon_sym_null_pointer_is_valid] = ACTIONS(389),
    [anon_sym_optforfuzzing] = ACTIONS(389),
    [anon_sym_optnone] = ACTIONS(389),
    [anon_sym_optsize] = ACTIONS(389),
    [anon_sym_readnone] = ACTIONS(389),
    [anon_sym_readonly] = ACTIONS(389),
    [anon_sym_writeonly] = ACTIONS(389),
    [anon_sym_argmemonly] = ACTIONS(389),
    [anon_sym_returns_twice] = ACTIONS(389),
    [anon_sym_safestack] = ACTIONS(389),
    [anon_sym_sanitize_address] = ACTIONS(389),
    [anon_sym_sanitize_memory] = ACTIONS(389),
    [anon_sym_sanitize_thread] = ACTIONS(389),
    [anon_sym_sanitize_hwaddress] = ACTIONS(389),
    [anon_sym_sanitize_memtag] = ACTIONS(389),
    [anon_sym_speculative_load_hardening] = ACTIONS(389),
    [anon_sym_speculatable] = ACTIONS(389),
    [anon_sym_ssp] = ACTIONS(389),
    [anon_sym_sspstrong] = ACTIONS(389),
    [anon_sym_sspreq] = ACTIONS(389),
    [anon_sym_strictfp] = ACTIONS(389),
    [anon_sym_nocf_check] = ACTIONS(389),
    [anon_sym_shadowcallstack] = ACTIONS(389),
    [anon_sym_mustprogress] = ACTIONS(389),
    [anon_sym_vscale_range] = ACTIONS(389),
    [anon_sym_preallocated] = ACTIONS(389),
    [anon_sym_zeroext] = ACTIONS(389),
    [anon_sym_signext] = ACTIONS(389),
    [anon_sym_inreg] = ACTIONS(389),
    [anon_sym_byval] = ACTIONS(389),
    [anon_sym_byref] = ACTIONS(389),
    [anon_sym_inalloca] = ACTIONS(389),
    [anon_sym_sret] = ACTIONS(389),
    [anon_sym_elementtype] = ACTIONS(389),
    [anon_sym_noalias] = ACTIONS(389),
    [anon_sym_nocapture] = ACTIONS(389),
    [anon_sym_nest] = ACTIONS(389),
    [anon_sym_returned] = ACTIONS(389),
    [anon_sym_nonnull] = ACTIONS(389),
    [anon_sym_dereferenceable] = ACTIONS(389),
    [anon_sym_dereferenceable_or_null] = ACTIONS(389),
    [anon_sym_swiftself] = ACTIONS(389),
    [anon_sym_swiftasync] = ACTIONS(389),
    [anon_sym_swifterror] = ACTIONS(389),
    [anon_sym_immarg] = ACTIONS(389),
    [anon_sym_noundef] = ACTIONS(389),
    [anon_sym_uwtable] = ACTIONS(389),
    [anon_sym_memory] = ACTIONS(389),
    [anon_sym_none] = ACTIONS(389),
    [anon_sym_unreachable] = ACTIONS(389),
    [anon_sym_ret] = ACTIONS(389),
    [anon_sym_br] = ACTIONS(389),
    [anon_sym_resume] = ACTIONS(389),
    [anon_sym_freeze] = ACTIONS(389),
    [anon_sym_indirectbr] = ACTIONS(389),
    [anon_sym_extractelement] = ACTIONS(389),
    [anon_sym_insertelement] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(389),
    [anon_sym_shufflevector] = ACTIONS(389),
    [anon_sym_fneg] = ACTIONS(389),
    [anon_sym_switch] = ACTIONS(389),
    [anon_sym_invoke] = ACTIONS(389),
    [anon_sym_cleanupret] = ACTIONS(389),
    [anon_sym_catchret] = ACTIONS(389),
    [anon_sym_catchswitch] = ACTIONS(389),
    [anon_sym_catchpad] = ACTIONS(389),
    [anon_sym_cleanuppad] = ACTIONS(389),
    [anon_sym_callbr] = ACTIONS(389),
    [anon_sym_icmp] = ACTIONS(389),
    [anon_sym_fcmp] = ACTIONS(389),
    [anon_sym_va_arg] = ACTIONS(389),
    [anon_sym_phi] = ACTIONS(389),
    [anon_sym_landingpad] = ACTIONS(389),
    [anon_sym_tail] = ACTIONS(389),
    [anon_sym_musttail] = ACTIONS(389),
    [anon_sym_notail] = ACTIONS(389),
    [anon_sym_call] = ACTIONS(389),
    [anon_sym_alloca] = ACTIONS(389),
    [anon_sym_load] = ACTIONS(389),
    [anon_sym_store] = ACTIONS(389),
    [anon_sym_cmpxchg] = ACTIONS(389),
    [anon_sym_atomicrmw] = ACTIONS(389),
    [anon_sym_fence] = ACTIONS(389),
    [anon_sym_getelementptr] = ACTIONS(389),
    [anon_sym_extractvalue] = ACTIONS(389),
    [anon_sym_insertvalue] = ACTIONS(389),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [anon_sym_null] = ACTIONS(389),
    [anon_sym_undef] = ACTIONS(389),
    [anon_sym_poison] = ACTIONS(389),
    [anon_sym_zeroinitializer] = ACTIONS(389),
    [anon_sym_blockaddress] = ACTIONS(389),
    [anon_sym_mul] = ACTIONS(389),
    [anon_sym_urem] = ACTIONS(389),
    [anon_sym_srem] = ACTIONS(389),
    [anon_sym_shl] = ACTIONS(389),
    [anon_sym_udiv] = ACTIONS(389),
    [anon_sym_sdiv] = ACTIONS(389),
    [anon_sym_lshr] = ACTIONS(389),
    [anon_sym_ashr] = ACTIONS(389),
    [anon_sym_fmul] = ACTIONS(389),
    [anon_sym_fdiv] = ACTIONS(389),
    [anon_sym_frem] = ACTIONS(389),
    [anon_sym_xchg] = ACTIONS(389),
    [anon_sym_add] = ACTIONS(389),
    [anon_sym_sub] = ACTIONS(389),
    [anon_sym_and] = ACTIONS(389),
    [anon_sym_nand] = ACTIONS(389),
    [anon_sym_or] = ACTIONS(389),
    [anon_sym_xor] = ACTIONS(389),
    [anon_sym_max] = ACTIONS(389),
    [anon_sym_min] = ACTIONS(389),
    [anon_sym_umax] = ACTIONS(389),
    [anon_sym_umin] = ACTIONS(389),
    [anon_sym_fadd] = ACTIONS(389),
    [anon_sym_fsub] = ACTIONS(389),
    [anon_sym_bitcast] = ACTIONS(389),
    [anon_sym_trunc] = ACTIONS(389),
    [anon_sym_zext] = ACTIONS(389),
    [anon_sym_sext] = ACTIONS(389),
    [anon_sym_fptrunc] = ACTIONS(389),
    [anon_sym_fpext] = ACTIONS(389),
    [anon_sym_addrspacecast] = ACTIONS(389),
    [anon_sym_uitofp] = ACTIONS(389),
    [anon_sym_sitofp] = ACTIONS(389),
    [anon_sym_fptoui] = ACTIONS(389),
    [anon_sym_fptosi] = ACTIONS(389),
    [anon_sym_inttoptr] = ACTIONS(389),
    [anon_sym_ptrtoint] = ACTIONS(389),
    [anon_sym_uselistorder] = ACTIONS(389),
  },
  [47] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(383),
    [sym_global_var] = ACTIONS(383),
    [sym_local_var] = ACTIONS(383),
    [sym_label] = ACTIONS(383),
    [sym_string] = ACTIONS(385),
    [aux_sym_number_token1] = ACTIONS(385),
    [aux_sym_number_token2] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [sym_cstring] = ACTIONS(383),
    [anon_sym_no_cfi] = ACTIONS(385),
    [anon_sym_private] = ACTIONS(385),
    [anon_sym_internal] = ACTIONS(385),
    [anon_sym_weak] = ACTIONS(385),
    [anon_sym_weak_odr] = ACTIONS(385),
    [anon_sym_linkonce] = ACTIONS(385),
    [anon_sym_linkonce_odr] = ACTIONS(385),
    [anon_sym_available_externally] = ACTIONS(385),
    [anon_sym_appending] = ACTIONS(385),
    [anon_sym_common] = ACTIONS(385),
    [anon_sym_extern_weak] = ACTIONS(385),
    [anon_sym_external] = ACTIONS(385),
    [anon_sym_dso_local] = ACTIONS(385),
    [anon_sym_dso_local_equivalent] = ACTIONS(385),
    [anon_sym_dso_preemptable] = ACTIONS(385),
    [anon_sym_default] = ACTIONS(385),
    [anon_sym_hidden] = ACTIONS(385),
    [anon_sym_protected] = ACTIONS(385),
    [anon_sym_dllimport] = ACTIONS(385),
    [anon_sym_dllexport] = ACTIONS(385),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_LBRACE] = ACTIONS(383),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_LT_LBRACE] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_addrspace] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_align] = ACTIONS(385),
    [anon_sym_section] = ACTIONS(385),
    [anon_sym_partition] = ACTIONS(385),
    [anon_sym_comdat] = ACTIONS(385),
    [anon_sym_gc] = ACTIONS(385),
    [anon_sym_prefix] = ACTIONS(385),
    [anon_sym_prologue] = ACTIONS(385),
    [anon_sym_personality] = ACTIONS(385),
    [anon_sym_alignstack] = ACTIONS(385),
    [anon_sym_allocsize] = ACTIONS(385),
    [anon_sym_alwaysinline] = ACTIONS(385),
    [anon_sym_builtin] = ACTIONS(385),
    [anon_sym_cold] = ACTIONS(385),
    [anon_sym_convergent] = ACTIONS(385),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(385),
    [anon_sym_hot] = ACTIONS(385),
    [anon_sym_inaccessiblememonly] = ACTIONS(385),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(385),
    [anon_sym_inlinehint] = ACTIONS(385),
    [anon_sym_jumptable] = ACTIONS(385),
    [anon_sym_minsize] = ACTIONS(385),
    [anon_sym_naked] = ACTIONS(385),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(385),
    [anon_sym_nobuiltin] = ACTIONS(385),
    [anon_sym_noduplicate] = ACTIONS(385),
    [anon_sym_nofree] = ACTIONS(385),
    [anon_sym_noimplicitfloat] = ACTIONS(385),
    [anon_sym_noinline] = ACTIONS(385),
    [anon_sym_nomerge] = ACTIONS(385),
    [anon_sym_nonlazybind] = ACTIONS(385),
    [anon_sym_noprofile] = ACTIONS(385),
    [anon_sym_noredzone] = ACTIONS(385),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(385),
    [anon_sym_noreturn] = ACTIONS(385),
    [anon_sym_norecurse] = ACTIONS(385),
    [anon_sym_willreturn] = ACTIONS(385),
    [anon_sym_nosync] = ACTIONS(385),
    [anon_sym_nounwind] = ACTIONS(385),
    [anon_sym_nocallback] = ACTIONS(385),
    [anon_sym_nosanitize_coverage] = ACTIONS(385),
    [anon_sym_null_pointer_is_valid] = ACTIONS(385),
    [anon_sym_optforfuzzing] = ACTIONS(385),
    [anon_sym_optnone] = ACTIONS(385),
    [anon_sym_optsize] = ACTIONS(385),
    [anon_sym_readnone] = ACTIONS(385),
    [anon_sym_readonly] = ACTIONS(385),
    [anon_sym_writeonly] = ACTIONS(385),
    [anon_sym_argmemonly] = ACTIONS(385),
    [anon_sym_returns_twice] = ACTIONS(385),
    [anon_sym_safestack] = ACTIONS(385),
    [anon_sym_sanitize_address] = ACTIONS(385),
    [anon_sym_sanitize_memory] = ACTIONS(385),
    [anon_sym_sanitize_thread] = ACTIONS(385),
    [anon_sym_sanitize_hwaddress] = ACTIONS(385),
    [anon_sym_sanitize_memtag] = ACTIONS(385),
    [anon_sym_speculative_load_hardening] = ACTIONS(385),
    [anon_sym_speculatable] = ACTIONS(385),
    [anon_sym_ssp] = ACTIONS(385),
    [anon_sym_sspstrong] = ACTIONS(385),
    [anon_sym_sspreq] = ACTIONS(385),
    [anon_sym_strictfp] = ACTIONS(385),
    [anon_sym_nocf_check] = ACTIONS(385),
    [anon_sym_shadowcallstack] = ACTIONS(385),
    [anon_sym_mustprogress] = ACTIONS(385),
    [anon_sym_vscale_range] = ACTIONS(385),
    [anon_sym_preallocated] = ACTIONS(385),
    [anon_sym_zeroext] = ACTIONS(385),
    [anon_sym_signext] = ACTIONS(385),
    [anon_sym_inreg] = ACTIONS(385),
    [anon_sym_byval] = ACTIONS(385),
    [anon_sym_byref] = ACTIONS(385),
    [anon_sym_inalloca] = ACTIONS(385),
    [anon_sym_sret] = ACTIONS(385),
    [anon_sym_elementtype] = ACTIONS(385),
    [anon_sym_noalias] = ACTIONS(385),
    [anon_sym_nocapture] = ACTIONS(385),
    [anon_sym_nest] = ACTIONS(385),
    [anon_sym_returned] = ACTIONS(385),
    [anon_sym_nonnull] = ACTIONS(385),
    [anon_sym_dereferenceable] = ACTIONS(385),
    [anon_sym_dereferenceable_or_null] = ACTIONS(385),
    [anon_sym_swiftself] = ACTIONS(385),
    [anon_sym_swiftasync] = ACTIONS(385),
    [anon_sym_swifterror] = ACTIONS(385),
    [anon_sym_immarg] = ACTIONS(385),
    [anon_sym_noundef] = ACTIONS(385),
    [anon_sym_uwtable] = ACTIONS(385),
    [anon_sym_memory] = ACTIONS(385),
    [anon_sym_none] = ACTIONS(385),
    [anon_sym_unreachable] = ACTIONS(385),
    [anon_sym_ret] = ACTIONS(385),
    [anon_sym_br] = ACTIONS(385),
    [anon_sym_resume] = ACTIONS(385),
    [anon_sym_freeze] = ACTIONS(385),
    [anon_sym_indirectbr] = ACTIONS(385),
    [anon_sym_extractelement] = ACTIONS(385),
    [anon_sym_insertelement] = ACTIONS(385),
    [anon_sym_select] = ACTIONS(385),
    [anon_sym_shufflevector] = ACTIONS(385),
    [anon_sym_fneg] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(385),
    [anon_sym_invoke] = ACTIONS(385),
    [anon_sym_cleanupret] = ACTIONS(385),
    [anon_sym_catchret] = ACTIONS(385),
    [anon_sym_catchswitch] = ACTIONS(385),
    [anon_sym_catchpad] = ACTIONS(385),
    [anon_sym_cleanuppad] = ACTIONS(385),
    [anon_sym_callbr] = ACTIONS(385),
    [anon_sym_icmp] = ACTIONS(385),
    [anon_sym_fcmp] = ACTIONS(385),
    [anon_sym_va_arg] = ACTIONS(385),
    [anon_sym_phi] = ACTIONS(385),
    [anon_sym_landingpad] = ACTIONS(385),
    [anon_sym_tail] = ACTIONS(385),
    [anon_sym_musttail] = ACTIONS(385),
    [anon_sym_notail] = ACTIONS(385),
    [anon_sym_call] = ACTIONS(385),
    [anon_sym_alloca] = ACTIONS(385),
    [anon_sym_load] = ACTIONS(385),
    [anon_sym_store] = ACTIONS(385),
    [anon_sym_cmpxchg] = ACTIONS(385),
    [anon_sym_atomicrmw] = ACTIONS(385),
    [anon_sym_fence] = ACTIONS(385),
    [anon_sym_getelementptr] = ACTIONS(385),
    [anon_sym_extractvalue] = ACTIONS(385),
    [anon_sym_insertvalue] = ACTIONS(385),
    [anon_sym_true] = ACTIONS(385),
    [anon_sym_false] = ACTIONS(385),
    [anon_sym_null] = ACTIONS(385),
    [anon_sym_undef] = ACTIONS(385),
    [anon_sym_poison] = ACTIONS(385),
    [anon_sym_zeroinitializer] = ACTIONS(385),
    [anon_sym_blockaddress] = ACTIONS(385),
    [anon_sym_mul] = ACTIONS(385),
    [anon_sym_urem] = ACTIONS(385),
    [anon_sym_srem] = ACTIONS(385),
    [anon_sym_shl] = ACTIONS(385),
    [anon_sym_udiv] = ACTIONS(385),
    [anon_sym_sdiv] = ACTIONS(385),
    [anon_sym_lshr] = ACTIONS(385),
    [anon_sym_ashr] = ACTIONS(385),
    [anon_sym_fmul] = ACTIONS(385),
    [anon_sym_fdiv] = ACTIONS(385),
    [anon_sym_frem] = ACTIONS(385),
    [anon_sym_xchg] = ACTIONS(385),
    [anon_sym_add] = ACTIONS(385),
    [anon_sym_sub] = ACTIONS(385),
    [anon_sym_and] = ACTIONS(385),
    [anon_sym_nand] = ACTIONS(385),
    [anon_sym_or] = ACTIONS(385),
    [anon_sym_xor] = ACTIONS(385),
    [anon_sym_max] = ACTIONS(385),
    [anon_sym_min] = ACTIONS(385),
    [anon_sym_umax] = ACTIONS(385),
    [anon_sym_umin] = ACTIONS(385),
    [anon_sym_fadd] = ACTIONS(385),
    [anon_sym_fsub] = ACTIONS(385),
    [anon_sym_bitcast] = ACTIONS(385),
    [anon_sym_trunc] = ACTIONS(385),
    [anon_sym_zext] = ACTIONS(385),
    [anon_sym_sext] = ACTIONS(385),
    [anon_sym_fptrunc] = ACTIONS(385),
    [anon_sym_fpext] = ACTIONS(385),
    [anon_sym_addrspacecast] = ACTIONS(385),
    [anon_sym_uitofp] = ACTIONS(385),
    [anon_sym_sitofp] = ACTIONS(385),
    [anon_sym_fptoui] = ACTIONS(385),
    [anon_sym_fptosi] = ACTIONS(385),
    [anon_sym_inttoptr] = ACTIONS(385),
    [anon_sym_ptrtoint] = ACTIONS(385),
    [anon_sym_uselistorder] = ACTIONS(385),
  },
  [48] = {
    [sym_metadata_ref] = STATE(302),
    [sym_type] = STATE(55),
    [sym_type_keyword] = STATE(62),
    [sym_struct_type] = STATE(62),
    [sym_packed_struct_type] = STATE(62),
    [sym_array_type] = STATE(62),
    [sym_vector_type] = STATE(62),
    [sym_type_and_value] = STATE(326),
    [sym_metadata] = STATE(339),
    [sym_metadata_tuple] = STATE(326),
    [sym_specialized_md] = STATE(326),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(116),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(283),
    [aux_sym_metadata_ref_token1] = ACTIONS(285),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(287),
    [anon_sym_half] = ACTIONS(287),
    [anon_sym_bfloat] = ACTIONS(287),
    [anon_sym_float] = ACTIONS(287),
    [anon_sym_double] = ACTIONS(287),
    [anon_sym_x86_fp80] = ACTIONS(287),
    [anon_sym_fp128] = ACTIONS(287),
    [anon_sym_ppc_fp128] = ACTIONS(287),
    [anon_sym_label] = ACTIONS(287),
    [anon_sym_metadata] = ACTIONS(420),
    [anon_sym_x86_mmx] = ACTIONS(287),
    [anon_sym_x86_amx] = ACTIONS(287),
    [anon_sym_token] = ACTIONS(287),
    [anon_sym_opaque] = ACTIONS(287),
    [anon_sym_ptr] = ACTIONS(291),
    [aux_sym_type_keyword_token1] = ACTIONS(287),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(116),
    [anon_sym_LT_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(299),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_align] = ACTIONS(122),
    [anon_sym_section] = ACTIONS(116),
    [anon_sym_partition] = ACTIONS(116),
    [anon_sym_comdat] = ACTIONS(116),
    [anon_sym_gc] = ACTIONS(116),
    [anon_sym_prefix] = ACTIONS(116),
    [anon_sym_prologue] = ACTIONS(116),
    [anon_sym_personality] = ACTIONS(116),
    [anon_sym_alignstack] = ACTIONS(116),
    [anon_sym_allocsize] = ACTIONS(116),
    [anon_sym_alwaysinline] = ACTIONS(116),
    [anon_sym_builtin] = ACTIONS(116),
    [anon_sym_cold] = ACTIONS(116),
    [anon_sym_convergent] = ACTIONS(116),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(116),
    [anon_sym_hot] = ACTIONS(116),
    [anon_sym_inaccessiblememonly] = ACTIONS(116),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(116),
    [anon_sym_inlinehint] = ACTIONS(116),
    [anon_sym_jumptable] = ACTIONS(116),
    [anon_sym_minsize] = ACTIONS(116),
    [anon_sym_naked] = ACTIONS(116),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(116),
    [anon_sym_nobuiltin] = ACTIONS(116),
    [anon_sym_noduplicate] = ACTIONS(116),
    [anon_sym_nofree] = ACTIONS(116),
    [anon_sym_noimplicitfloat] = ACTIONS(116),
    [anon_sym_noinline] = ACTIONS(116),
    [anon_sym_nomerge] = ACTIONS(116),
    [anon_sym_nonlazybind] = ACTIONS(116),
    [anon_sym_noprofile] = ACTIONS(116),
    [anon_sym_noredzone] = ACTIONS(116),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(116),
    [anon_sym_noreturn] = ACTIONS(116),
    [anon_sym_norecurse] = ACTIONS(116),
    [anon_sym_willreturn] = ACTIONS(116),
    [anon_sym_nosync] = ACTIONS(116),
    [anon_sym_nounwind] = ACTIONS(116),
    [anon_sym_nocallback] = ACTIONS(116),
    [anon_sym_nosanitize_coverage] = ACTIONS(116),
    [anon_sym_null_pointer_is_valid] = ACTIONS(116),
    [anon_sym_optforfuzzing] = ACTIONS(116),
    [anon_sym_optnone] = ACTIONS(116),
    [anon_sym_optsize] = ACTIONS(116),
    [anon_sym_readnone] = ACTIONS(116),
    [anon_sym_readonly] = ACTIONS(116),
    [anon_sym_writeonly] = ACTIONS(116),
    [anon_sym_argmemonly] = ACTIONS(116),
    [anon_sym_returns_twice] = ACTIONS(116),
    [anon_sym_safestack] = ACTIONS(116),
    [anon_sym_sanitize_address] = ACTIONS(116),
    [anon_sym_sanitize_memory] = ACTIONS(116),
    [anon_sym_sanitize_thread] = ACTIONS(116),
    [anon_sym_sanitize_hwaddress] = ACTIONS(116),
    [anon_sym_sanitize_memtag] = ACTIONS(116),
    [anon_sym_speculative_load_hardening] = ACTIONS(116),
    [anon_sym_speculatable] = ACTIONS(116),
    [anon_sym_ssp] = ACTIONS(122),
    [anon_sym_sspstrong] = ACTIONS(116),
    [anon_sym_sspreq] = ACTIONS(116),
    [anon_sym_strictfp] = ACTIONS(116),
    [anon_sym_nocf_check] = ACTIONS(116),
    [anon_sym_shadowcallstack] = ACTIONS(116),
    [anon_sym_mustprogress] = ACTIONS(116),
    [anon_sym_vscale_range] = ACTIONS(116),
    [anon_sym_preallocated] = ACTIONS(116),
    [anon_sym_zeroext] = ACTIONS(116),
    [anon_sym_signext] = ACTIONS(116),
    [anon_sym_inreg] = ACTIONS(116),
    [anon_sym_byval] = ACTIONS(116),
    [anon_sym_byref] = ACTIONS(116),
    [anon_sym_inalloca] = ACTIONS(116),
    [anon_sym_sret] = ACTIONS(116),
    [anon_sym_elementtype] = ACTIONS(116),
    [anon_sym_noalias] = ACTIONS(116),
    [anon_sym_nocapture] = ACTIONS(116),
    [anon_sym_nest] = ACTIONS(116),
    [anon_sym_returned] = ACTIONS(116),
    [anon_sym_nonnull] = ACTIONS(116),
    [anon_sym_dereferenceable] = ACTIONS(122),
    [anon_sym_dereferenceable_or_null] = ACTIONS(116),
    [anon_sym_swiftself] = ACTIONS(116),
    [anon_sym_swiftasync] = ACTIONS(116),
    [anon_sym_swifterror] = ACTIONS(116),
    [anon_sym_immarg] = ACTIONS(116),
    [anon_sym_noundef] = ACTIONS(116),
    [anon_sym_uwtable] = ACTIONS(116),
    [anon_sym_memory] = ACTIONS(116),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(303),
  },
  [49] = {
    [sym_metadata_ref] = STATE(302),
    [sym_type] = STATE(52),
    [sym_type_keyword] = STATE(62),
    [sym_struct_type] = STATE(62),
    [sym_packed_struct_type] = STATE(62),
    [sym_array_type] = STATE(62),
    [sym_vector_type] = STATE(62),
    [sym_type_and_value] = STATE(326),
    [sym_metadata] = STATE(339),
    [sym_metadata_tuple] = STATE(326),
    [sym_specialized_md] = STATE(326),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(116),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(283),
    [aux_sym_metadata_ref_token1] = ACTIONS(285),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(287),
    [anon_sym_half] = ACTIONS(287),
    [anon_sym_bfloat] = ACTIONS(287),
    [anon_sym_float] = ACTIONS(287),
    [anon_sym_double] = ACTIONS(287),
    [anon_sym_x86_fp80] = ACTIONS(287),
    [anon_sym_fp128] = ACTIONS(287),
    [anon_sym_ppc_fp128] = ACTIONS(287),
    [anon_sym_label] = ACTIONS(287),
    [anon_sym_metadata] = ACTIONS(422),
    [anon_sym_x86_mmx] = ACTIONS(287),
    [anon_sym_x86_amx] = ACTIONS(287),
    [anon_sym_token] = ACTIONS(287),
    [anon_sym_opaque] = ACTIONS(287),
    [anon_sym_ptr] = ACTIONS(291),
    [aux_sym_type_keyword_token1] = ACTIONS(287),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_LT_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(299),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_align] = ACTIONS(122),
    [anon_sym_section] = ACTIONS(116),
    [anon_sym_partition] = ACTIONS(116),
    [anon_sym_comdat] = ACTIONS(116),
    [anon_sym_gc] = ACTIONS(116),
    [anon_sym_prefix] = ACTIONS(116),
    [anon_sym_prologue] = ACTIONS(116),
    [anon_sym_personality] = ACTIONS(116),
    [anon_sym_alignstack] = ACTIONS(116),
    [anon_sym_allocsize] = ACTIONS(116),
    [anon_sym_alwaysinline] = ACTIONS(116),
    [anon_sym_builtin] = ACTIONS(116),
    [anon_sym_cold] = ACTIONS(116),
    [anon_sym_convergent] = ACTIONS(116),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(116),
    [anon_sym_hot] = ACTIONS(116),
    [anon_sym_inaccessiblememonly] = ACTIONS(116),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(116),
    [anon_sym_inlinehint] = ACTIONS(116),
    [anon_sym_jumptable] = ACTIONS(116),
    [anon_sym_minsize] = ACTIONS(116),
    [anon_sym_naked] = ACTIONS(116),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(116),
    [anon_sym_nobuiltin] = ACTIONS(116),
    [anon_sym_noduplicate] = ACTIONS(116),
    [anon_sym_nofree] = ACTIONS(116),
    [anon_sym_noimplicitfloat] = ACTIONS(116),
    [anon_sym_noinline] = ACTIONS(116),
    [anon_sym_nomerge] = ACTIONS(116),
    [anon_sym_nonlazybind] = ACTIONS(116),
    [anon_sym_noprofile] = ACTIONS(116),
    [anon_sym_noredzone] = ACTIONS(116),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(116),
    [anon_sym_noreturn] = ACTIONS(116),
    [anon_sym_norecurse] = ACTIONS(116),
    [anon_sym_willreturn] = ACTIONS(116),
    [anon_sym_nosync] = ACTIONS(116),
    [anon_sym_nounwind] = ACTIONS(116),
    [anon_sym_nocallback] = ACTIONS(116),
    [anon_sym_nosanitize_coverage] = ACTIONS(116),
    [anon_sym_null_pointer_is_valid] = ACTIONS(116),
    [anon_sym_optforfuzzing] = ACTIONS(116),
    [anon_sym_optnone] = ACTIONS(116),
    [anon_sym_optsize] = ACTIONS(116),
    [anon_sym_readnone] = ACTIONS(116),
    [anon_sym_readonly] = ACTIONS(116),
    [anon_sym_writeonly] = ACTIONS(116),
    [anon_sym_argmemonly] = ACTIONS(116),
    [anon_sym_returns_twice] = ACTIONS(116),
    [anon_sym_safestack] = ACTIONS(116),
    [anon_sym_sanitize_address] = ACTIONS(116),
    [anon_sym_sanitize_memory] = ACTIONS(116),
    [anon_sym_sanitize_thread] = ACTIONS(116),
    [anon_sym_sanitize_hwaddress] = ACTIONS(116),
    [anon_sym_sanitize_memtag] = ACTIONS(116),
    [anon_sym_speculative_load_hardening] = ACTIONS(116),
    [anon_sym_speculatable] = ACTIONS(116),
    [anon_sym_ssp] = ACTIONS(122),
    [anon_sym_sspstrong] = ACTIONS(116),
    [anon_sym_sspreq] = ACTIONS(116),
    [anon_sym_strictfp] = ACTIONS(116),
    [anon_sym_nocf_check] = ACTIONS(116),
    [anon_sym_shadowcallstack] = ACTIONS(116),
    [anon_sym_mustprogress] = ACTIONS(116),
    [anon_sym_vscale_range] = ACTIONS(116),
    [anon_sym_preallocated] = ACTIONS(116),
    [anon_sym_zeroext] = ACTIONS(116),
    [anon_sym_signext] = ACTIONS(116),
    [anon_sym_inreg] = ACTIONS(116),
    [anon_sym_byval] = ACTIONS(116),
    [anon_sym_byref] = ACTIONS(116),
    [anon_sym_inalloca] = ACTIONS(116),
    [anon_sym_sret] = ACTIONS(116),
    [anon_sym_elementtype] = ACTIONS(116),
    [anon_sym_noalias] = ACTIONS(116),
    [anon_sym_nocapture] = ACTIONS(116),
    [anon_sym_nest] = ACTIONS(116),
    [anon_sym_returned] = ACTIONS(116),
    [anon_sym_nonnull] = ACTIONS(116),
    [anon_sym_dereferenceable] = ACTIONS(122),
    [anon_sym_dereferenceable_or_null] = ACTIONS(116),
    [anon_sym_swiftself] = ACTIONS(116),
    [anon_sym_swiftasync] = ACTIONS(116),
    [anon_sym_swifterror] = ACTIONS(116),
    [anon_sym_immarg] = ACTIONS(116),
    [anon_sym_noundef] = ACTIONS(116),
    [anon_sym_uwtable] = ACTIONS(116),
    [anon_sym_memory] = ACTIONS(116),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_to] = ACTIONS(122),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(303),
  },
  [50] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(395),
    [sym_global_var] = ACTIONS(395),
    [sym_local_var] = ACTIONS(395),
    [sym_label] = ACTIONS(395),
    [sym_string] = ACTIONS(397),
    [aux_sym_number_token1] = ACTIONS(397),
    [aux_sym_number_token2] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_cstring] = ACTIONS(395),
    [anon_sym_no_cfi] = ACTIONS(397),
    [anon_sym_private] = ACTIONS(397),
    [anon_sym_internal] = ACTIONS(397),
    [anon_sym_weak] = ACTIONS(397),
    [anon_sym_weak_odr] = ACTIONS(397),
    [anon_sym_linkonce] = ACTIONS(397),
    [anon_sym_linkonce_odr] = ACTIONS(397),
    [anon_sym_available_externally] = ACTIONS(397),
    [anon_sym_appending] = ACTIONS(397),
    [anon_sym_common] = ACTIONS(397),
    [anon_sym_extern_weak] = ACTIONS(397),
    [anon_sym_external] = ACTIONS(397),
    [anon_sym_dso_local] = ACTIONS(397),
    [anon_sym_dso_local_equivalent] = ACTIONS(397),
    [anon_sym_dso_preemptable] = ACTIONS(397),
    [anon_sym_default] = ACTIONS(397),
    [anon_sym_hidden] = ACTIONS(397),
    [anon_sym_protected] = ACTIONS(397),
    [anon_sym_dllimport] = ACTIONS(397),
    [anon_sym_dllexport] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(424),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_RBRACE] = ACTIONS(395),
    [anon_sym_LT_LBRACE] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(395),
    [anon_sym_LT] = ACTIONS(397),
    [anon_sym_COMMA] = ACTIONS(395),
    [anon_sym_align] = ACTIONS(397),
    [anon_sym_section] = ACTIONS(397),
    [anon_sym_partition] = ACTIONS(397),
    [anon_sym_comdat] = ACTIONS(397),
    [anon_sym_gc] = ACTIONS(397),
    [anon_sym_prefix] = ACTIONS(397),
    [anon_sym_prologue] = ACTIONS(397),
    [anon_sym_personality] = ACTIONS(397),
    [anon_sym_alignstack] = ACTIONS(397),
    [anon_sym_allocsize] = ACTIONS(397),
    [anon_sym_alwaysinline] = ACTIONS(397),
    [anon_sym_builtin] = ACTIONS(397),
    [anon_sym_cold] = ACTIONS(397),
    [anon_sym_convergent] = ACTIONS(397),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(397),
    [anon_sym_hot] = ACTIONS(397),
    [anon_sym_inaccessiblememonly] = ACTIONS(397),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(397),
    [anon_sym_inlinehint] = ACTIONS(397),
    [anon_sym_jumptable] = ACTIONS(397),
    [anon_sym_minsize] = ACTIONS(397),
    [anon_sym_naked] = ACTIONS(397),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(397),
    [anon_sym_nobuiltin] = ACTIONS(397),
    [anon_sym_noduplicate] = ACTIONS(397),
    [anon_sym_nofree] = ACTIONS(397),
    [anon_sym_noimplicitfloat] = ACTIONS(397),
    [anon_sym_noinline] = ACTIONS(397),
    [anon_sym_nomerge] = ACTIONS(397),
    [anon_sym_nonlazybind] = ACTIONS(397),
    [anon_sym_noprofile] = ACTIONS(397),
    [anon_sym_noredzone] = ACTIONS(397),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(397),
    [anon_sym_noreturn] = ACTIONS(397),
    [anon_sym_norecurse] = ACTIONS(397),
    [anon_sym_willreturn] = ACTIONS(397),
    [anon_sym_nosync] = ACTIONS(397),
    [anon_sym_nounwind] = ACTIONS(397),
    [anon_sym_nocallback] = ACTIONS(397),
    [anon_sym_nosanitize_coverage] = ACTIONS(397),
    [anon_sym_null_pointer_is_valid] = ACTIONS(397),
    [anon_sym_optforfuzzing] = ACTIONS(397),
    [anon_sym_optnone] = ACTIONS(397),
    [anon_sym_optsize] = ACTIONS(397),
    [anon_sym_readnone] = ACTIONS(397),
    [anon_sym_readonly] = ACTIONS(397),
    [anon_sym_writeonly] = ACTIONS(397),
    [anon_sym_argmemonly] = ACTIONS(397),
    [anon_sym_returns_twice] = ACTIONS(397),
    [anon_sym_safestack] = ACTIONS(397),
    [anon_sym_sanitize_address] = ACTIONS(397),
    [anon_sym_sanitize_memory] = ACTIONS(397),
    [anon_sym_sanitize_thread] = ACTIONS(397),
    [anon_sym_sanitize_hwaddress] = ACTIONS(397),
    [anon_sym_sanitize_memtag] = ACTIONS(397),
    [anon_sym_speculative_load_hardening] = ACTIONS(397),
    [anon_sym_speculatable] = ACTIONS(397),
    [anon_sym_ssp] = ACTIONS(397),
    [anon_sym_sspstrong] = ACTIONS(397),
    [anon_sym_sspreq] = ACTIONS(397),
    [anon_sym_strictfp] = ACTIONS(397),
    [anon_sym_nocf_check] = ACTIONS(397),
    [anon_sym_shadowcallstack] = ACTIONS(397),
    [anon_sym_mustprogress] = ACTIONS(397),
    [anon_sym_vscale_range] = ACTIONS(397),
    [anon_sym_preallocated] = ACTIONS(397),
    [anon_sym_zeroext] = ACTIONS(397),
    [anon_sym_signext] = ACTIONS(397),
    [anon_sym_inreg] = ACTIONS(397),
    [anon_sym_byval] = ACTIONS(397),
    [anon_sym_byref] = ACTIONS(397),
    [anon_sym_inalloca] = ACTIONS(397),
    [anon_sym_sret] = ACTIONS(397),
    [anon_sym_elementtype] = ACTIONS(397),
    [anon_sym_noalias] = ACTIONS(397),
    [anon_sym_nocapture] = ACTIONS(397),
    [anon_sym_nest] = ACTIONS(397),
    [anon_sym_returned] = ACTIONS(397),
    [anon_sym_nonnull] = ACTIONS(397),
    [anon_sym_dereferenceable] = ACTIONS(397),
    [anon_sym_dereferenceable_or_null] = ACTIONS(397),
    [anon_sym_swiftself] = ACTIONS(397),
    [anon_sym_swiftasync] = ACTIONS(397),
    [anon_sym_swifterror] = ACTIONS(397),
    [anon_sym_immarg] = ACTIONS(397),
    [anon_sym_noundef] = ACTIONS(397),
    [anon_sym_uwtable] = ACTIONS(397),
    [anon_sym_memory] = ACTIONS(397),
    [anon_sym_none] = ACTIONS(397),
    [anon_sym_unreachable] = ACTIONS(397),
    [anon_sym_ret] = ACTIONS(397),
    [anon_sym_br] = ACTIONS(397),
    [anon_sym_resume] = ACTIONS(397),
    [anon_sym_freeze] = ACTIONS(397),
    [anon_sym_indirectbr] = ACTIONS(397),
    [anon_sym_extractelement] = ACTIONS(397),
    [anon_sym_insertelement] = ACTIONS(397),
    [anon_sym_select] = ACTIONS(397),
    [anon_sym_shufflevector] = ACTIONS(397),
    [anon_sym_fneg] = ACTIONS(397),
    [anon_sym_switch] = ACTIONS(397),
    [anon_sym_invoke] = ACTIONS(397),
    [anon_sym_cleanupret] = ACTIONS(397),
    [anon_sym_catchret] = ACTIONS(397),
    [anon_sym_catchswitch] = ACTIONS(397),
    [anon_sym_catchpad] = ACTIONS(397),
    [anon_sym_cleanuppad] = ACTIONS(397),
    [anon_sym_callbr] = ACTIONS(397),
    [anon_sym_icmp] = ACTIONS(397),
    [anon_sym_fcmp] = ACTIONS(397),
    [anon_sym_va_arg] = ACTIONS(397),
    [anon_sym_phi] = ACTIONS(397),
    [anon_sym_landingpad] = ACTIONS(397),
    [anon_sym_tail] = ACTIONS(397),
    [anon_sym_musttail] = ACTIONS(397),
    [anon_sym_notail] = ACTIONS(397),
    [anon_sym_call] = ACTIONS(397),
    [anon_sym_alloca] = ACTIONS(397),
    [anon_sym_load] = ACTIONS(397),
    [anon_sym_store] = ACTIONS(397),
    [anon_sym_cmpxchg] = ACTIONS(397),
    [anon_sym_atomicrmw] = ACTIONS(397),
    [anon_sym_fence] = ACTIONS(397),
    [anon_sym_getelementptr] = ACTIONS(397),
    [anon_sym_extractvalue] = ACTIONS(397),
    [anon_sym_insertvalue] = ACTIONS(397),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_false] = ACTIONS(397),
    [anon_sym_null] = ACTIONS(397),
    [anon_sym_undef] = ACTIONS(397),
    [anon_sym_poison] = ACTIONS(397),
    [anon_sym_zeroinitializer] = ACTIONS(397),
    [anon_sym_blockaddress] = ACTIONS(397),
    [anon_sym_mul] = ACTIONS(397),
    [anon_sym_urem] = ACTIONS(397),
    [anon_sym_srem] = ACTIONS(397),
    [anon_sym_shl] = ACTIONS(397),
    [anon_sym_udiv] = ACTIONS(397),
    [anon_sym_sdiv] = ACTIONS(397),
    [anon_sym_lshr] = ACTIONS(397),
    [anon_sym_ashr] = ACTIONS(397),
    [anon_sym_fmul] = ACTIONS(397),
    [anon_sym_fdiv] = ACTIONS(397),
    [anon_sym_frem] = ACTIONS(397),
    [anon_sym_xchg] = ACTIONS(397),
    [anon_sym_add] = ACTIONS(397),
    [anon_sym_sub] = ACTIONS(397),
    [anon_sym_and] = ACTIONS(397),
    [anon_sym_nand] = ACTIONS(397),
    [anon_sym_or] = ACTIONS(397),
    [anon_sym_xor] = ACTIONS(397),
    [anon_sym_max] = ACTIONS(397),
    [anon_sym_min] = ACTIONS(397),
    [anon_sym_umax] = ACTIONS(397),
    [anon_sym_umin] = ACTIONS(397),
    [anon_sym_fadd] = ACTIONS(397),
    [anon_sym_fsub] = ACTIONS(397),
    [anon_sym_bitcast] = ACTIONS(397),
    [anon_sym_trunc] = ACTIONS(397),
    [anon_sym_zext] = ACTIONS(397),
    [anon_sym_sext] = ACTIONS(397),
    [anon_sym_fptrunc] = ACTIONS(397),
    [anon_sym_fpext] = ACTIONS(397),
    [anon_sym_addrspacecast] = ACTIONS(397),
    [anon_sym_uitofp] = ACTIONS(397),
    [anon_sym_sitofp] = ACTIONS(397),
    [anon_sym_fptoui] = ACTIONS(397),
    [anon_sym_fptosi] = ACTIONS(397),
    [anon_sym_inttoptr] = ACTIONS(397),
    [anon_sym_ptrtoint] = ACTIONS(397),
    [anon_sym_uselistorder] = ACTIONS(397),
  },
  [51] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(244),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [sym_label] = ACTIONS(244),
    [sym_string] = ACTIONS(246),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(246),
    [sym_float] = ACTIONS(246),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(246),
    [anon_sym_private] = ACTIONS(246),
    [anon_sym_internal] = ACTIONS(246),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(246),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(246),
    [anon_sym_available_externally] = ACTIONS(246),
    [anon_sym_appending] = ACTIONS(246),
    [anon_sym_common] = ACTIONS(246),
    [anon_sym_extern_weak] = ACTIONS(246),
    [anon_sym_external] = ACTIONS(246),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(246),
    [anon_sym_dso_preemptable] = ACTIONS(246),
    [anon_sym_default] = ACTIONS(246),
    [anon_sym_hidden] = ACTIONS(246),
    [anon_sym_protected] = ACTIONS(246),
    [anon_sym_dllimport] = ACTIONS(246),
    [anon_sym_dllexport] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(424),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_align] = ACTIONS(246),
    [anon_sym_section] = ACTIONS(246),
    [anon_sym_partition] = ACTIONS(246),
    [anon_sym_comdat] = ACTIONS(246),
    [anon_sym_gc] = ACTIONS(246),
    [anon_sym_prefix] = ACTIONS(246),
    [anon_sym_prologue] = ACTIONS(246),
    [anon_sym_personality] = ACTIONS(246),
    [anon_sym_alignstack] = ACTIONS(246),
    [anon_sym_allocsize] = ACTIONS(246),
    [anon_sym_alwaysinline] = ACTIONS(246),
    [anon_sym_builtin] = ACTIONS(246),
    [anon_sym_cold] = ACTIONS(246),
    [anon_sym_convergent] = ACTIONS(246),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(246),
    [anon_sym_hot] = ACTIONS(246),
    [anon_sym_inaccessiblememonly] = ACTIONS(246),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(246),
    [anon_sym_inlinehint] = ACTIONS(246),
    [anon_sym_jumptable] = ACTIONS(246),
    [anon_sym_minsize] = ACTIONS(246),
    [anon_sym_naked] = ACTIONS(246),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(246),
    [anon_sym_nobuiltin] = ACTIONS(246),
    [anon_sym_noduplicate] = ACTIONS(246),
    [anon_sym_nofree] = ACTIONS(246),
    [anon_sym_noimplicitfloat] = ACTIONS(246),
    [anon_sym_noinline] = ACTIONS(246),
    [anon_sym_nomerge] = ACTIONS(246),
    [anon_sym_nonlazybind] = ACTIONS(246),
    [anon_sym_noprofile] = ACTIONS(246),
    [anon_sym_noredzone] = ACTIONS(246),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(246),
    [anon_sym_noreturn] = ACTIONS(246),
    [anon_sym_norecurse] = ACTIONS(246),
    [anon_sym_willreturn] = ACTIONS(246),
    [anon_sym_nosync] = ACTIONS(246),
    [anon_sym_nounwind] = ACTIONS(246),
    [anon_sym_nocallback] = ACTIONS(246),
    [anon_sym_nosanitize_coverage] = ACTIONS(246),
    [anon_sym_null_pointer_is_valid] = ACTIONS(246),
    [anon_sym_optforfuzzing] = ACTIONS(246),
    [anon_sym_optnone] = ACTIONS(246),
    [anon_sym_optsize] = ACTIONS(246),
    [anon_sym_readnone] = ACTIONS(246),
    [anon_sym_readonly] = ACTIONS(246),
    [anon_sym_writeonly] = ACTIONS(246),
    [anon_sym_argmemonly] = ACTIONS(246),
    [anon_sym_returns_twice] = ACTIONS(246),
    [anon_sym_safestack] = ACTIONS(246),
    [anon_sym_sanitize_address] = ACTIONS(246),
    [anon_sym_sanitize_memory] = ACTIONS(246),
    [anon_sym_sanitize_thread] = ACTIONS(246),
    [anon_sym_sanitize_hwaddress] = ACTIONS(246),
    [anon_sym_sanitize_memtag] = ACTIONS(246),
    [anon_sym_speculative_load_hardening] = ACTIONS(246),
    [anon_sym_speculatable] = ACTIONS(246),
    [anon_sym_ssp] = ACTIONS(246),
    [anon_sym_sspstrong] = ACTIONS(246),
    [anon_sym_sspreq] = ACTIONS(246),
    [anon_sym_strictfp] = ACTIONS(246),
    [anon_sym_nocf_check] = ACTIONS(246),
    [anon_sym_shadowcallstack] = ACTIONS(246),
    [anon_sym_mustprogress] = ACTIONS(246),
    [anon_sym_vscale_range] = ACTIONS(246),
    [anon_sym_preallocated] = ACTIONS(246),
    [anon_sym_zeroext] = ACTIONS(246),
    [anon_sym_signext] = ACTIONS(246),
    [anon_sym_inreg] = ACTIONS(246),
    [anon_sym_byval] = ACTIONS(246),
    [anon_sym_byref] = ACTIONS(246),
    [anon_sym_inalloca] = ACTIONS(246),
    [anon_sym_sret] = ACTIONS(246),
    [anon_sym_elementtype] = ACTIONS(246),
    [anon_sym_noalias] = ACTIONS(246),
    [anon_sym_nocapture] = ACTIONS(246),
    [anon_sym_nest] = ACTIONS(246),
    [anon_sym_returned] = ACTIONS(246),
    [anon_sym_nonnull] = ACTIONS(246),
    [anon_sym_dereferenceable] = ACTIONS(246),
    [anon_sym_dereferenceable_or_null] = ACTIONS(246),
    [anon_sym_swiftself] = ACTIONS(246),
    [anon_sym_swiftasync] = ACTIONS(246),
    [anon_sym_swifterror] = ACTIONS(246),
    [anon_sym_immarg] = ACTIONS(246),
    [anon_sym_noundef] = ACTIONS(246),
    [anon_sym_uwtable] = ACTIONS(246),
    [anon_sym_memory] = ACTIONS(246),
    [anon_sym_none] = ACTIONS(246),
    [anon_sym_unreachable] = ACTIONS(246),
    [anon_sym_ret] = ACTIONS(246),
    [anon_sym_br] = ACTIONS(246),
    [anon_sym_resume] = ACTIONS(246),
    [anon_sym_freeze] = ACTIONS(246),
    [anon_sym_indirectbr] = ACTIONS(246),
    [anon_sym_extractelement] = ACTIONS(246),
    [anon_sym_insertelement] = ACTIONS(246),
    [anon_sym_select] = ACTIONS(246),
    [anon_sym_shufflevector] = ACTIONS(246),
    [anon_sym_fneg] = ACTIONS(246),
    [anon_sym_switch] = ACTIONS(246),
    [anon_sym_invoke] = ACTIONS(246),
    [anon_sym_cleanupret] = ACTIONS(246),
    [anon_sym_catchret] = ACTIONS(246),
    [anon_sym_catchswitch] = ACTIONS(246),
    [anon_sym_catchpad] = ACTIONS(246),
    [anon_sym_cleanuppad] = ACTIONS(246),
    [anon_sym_callbr] = ACTIONS(246),
    [anon_sym_icmp] = ACTIONS(246),
    [anon_sym_fcmp] = ACTIONS(246),
    [anon_sym_va_arg] = ACTIONS(246),
    [anon_sym_phi] = ACTIONS(246),
    [anon_sym_landingpad] = ACTIONS(246),
    [anon_sym_tail] = ACTIONS(246),
    [anon_sym_musttail] = ACTIONS(246),
    [anon_sym_notail] = ACTIONS(246),
    [anon_sym_call] = ACTIONS(246),
    [anon_sym_alloca] = ACTIONS(246),
    [anon_sym_load] = ACTIONS(246),
    [anon_sym_store] = ACTIONS(246),
    [anon_sym_cmpxchg] = ACTIONS(246),
    [anon_sym_atomicrmw] = ACTIONS(246),
    [anon_sym_fence] = ACTIONS(246),
    [anon_sym_getelementptr] = ACTIONS(246),
    [anon_sym_extractvalue] = ACTIONS(246),
    [anon_sym_insertvalue] = ACTIONS(246),
    [anon_sym_true] = ACTIONS(246),
    [anon_sym_false] = ACTIONS(246),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_undef] = ACTIONS(246),
    [anon_sym_poison] = ACTIONS(246),
    [anon_sym_zeroinitializer] = ACTIONS(246),
    [anon_sym_blockaddress] = ACTIONS(246),
    [anon_sym_mul] = ACTIONS(246),
    [anon_sym_urem] = ACTIONS(246),
    [anon_sym_srem] = ACTIONS(246),
    [anon_sym_shl] = ACTIONS(246),
    [anon_sym_udiv] = ACTIONS(246),
    [anon_sym_sdiv] = ACTIONS(246),
    [anon_sym_lshr] = ACTIONS(246),
    [anon_sym_ashr] = ACTIONS(246),
    [anon_sym_fmul] = ACTIONS(246),
    [anon_sym_fdiv] = ACTIONS(246),
    [anon_sym_frem] = ACTIONS(246),
    [anon_sym_xchg] = ACTIONS(246),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(246),
    [anon_sym_and] = ACTIONS(246),
    [anon_sym_nand] = ACTIONS(246),
    [anon_sym_or] = ACTIONS(246),
    [anon_sym_xor] = ACTIONS(246),
    [anon_sym_max] = ACTIONS(246),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(246),
    [anon_sym_umin] = ACTIONS(246),
    [anon_sym_fadd] = ACTIONS(246),
    [anon_sym_fsub] = ACTIONS(246),
    [anon_sym_bitcast] = ACTIONS(246),
    [anon_sym_trunc] = ACTIONS(246),
    [anon_sym_zext] = ACTIONS(246),
    [anon_sym_sext] = ACTIONS(246),
    [anon_sym_fptrunc] = ACTIONS(246),
    [anon_sym_fpext] = ACTIONS(246),
    [anon_sym_addrspacecast] = ACTIONS(246),
    [anon_sym_uitofp] = ACTIONS(246),
    [anon_sym_sitofp] = ACTIONS(246),
    [anon_sym_fptoui] = ACTIONS(246),
    [anon_sym_fptosi] = ACTIONS(246),
    [anon_sym_inttoptr] = ACTIONS(246),
    [anon_sym_ptrtoint] = ACTIONS(246),
    [anon_sym_uselistorder] = ACTIONS(246),
  },
  [52] = {
    [sym_number] = STATE(361),
    [sym_var] = STATE(361),
    [sym_linkage] = STATE(820),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(360),
    [sym__primitive_value] = STATE(361),
    [sym_struct_value] = STATE(361),
    [sym_packed_struct_value] = STATE(361),
    [sym_array_value] = STATE(361),
    [sym_vector_value] = STATE(361),
    [sym_blockaddress] = STATE(361),
    [sym_constant_expr] = STATE(361),
    [sym_constant_cast] = STATE(359),
    [sym_constant_getelementptr] = STATE(359),
    [sym_constant_select] = STATE(359),
    [sym_constant_icmp] = STATE(359),
    [sym_constant_fcmp] = STATE(359),
    [sym_constant_extractelement] = STATE(359),
    [sym_constant_insertelement] = STATE(359),
    [sym_constant_shufflevector] = STATE(359),
    [sym_constant_extractvalue] = STATE(359),
    [sym_constant_insertvalue] = STATE(359),
    [sym_constant_fneg] = STATE(359),
    [sym_constant_bin_op] = STATE(359),
    [sym_bin_op_keyword] = STATE(1133),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1924),
    [aux_sym_function_header_repeat1] = STATE(820),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(38),
    [sym_global_var] = ACTIONS(426),
    [sym_local_var] = ACTIONS(426),
    [sym_string] = ACTIONS(308),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [sym_float] = ACTIONS(315),
    [sym_cstring] = ACTIONS(315),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_LT_LBRACE] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(428),
    [anon_sym_LT] = ACTIONS(333),
    [anon_sym_align] = ACTIONS(70),
    [anon_sym_section] = ACTIONS(38),
    [anon_sym_partition] = ACTIONS(38),
    [anon_sym_comdat] = ACTIONS(38),
    [anon_sym_gc] = ACTIONS(38),
    [anon_sym_prefix] = ACTIONS(38),
    [anon_sym_prologue] = ACTIONS(38),
    [anon_sym_personality] = ACTIONS(38),
    [anon_sym_alignstack] = ACTIONS(38),
    [anon_sym_allocsize] = ACTIONS(38),
    [anon_sym_alwaysinline] = ACTIONS(38),
    [anon_sym_builtin] = ACTIONS(38),
    [anon_sym_cold] = ACTIONS(38),
    [anon_sym_convergent] = ACTIONS(38),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(38),
    [anon_sym_hot] = ACTIONS(38),
    [anon_sym_inaccessiblememonly] = ACTIONS(38),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(38),
    [anon_sym_inlinehint] = ACTIONS(38),
    [anon_sym_jumptable] = ACTIONS(38),
    [anon_sym_minsize] = ACTIONS(38),
    [anon_sym_naked] = ACTIONS(38),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(38),
    [anon_sym_nobuiltin] = ACTIONS(38),
    [anon_sym_noduplicate] = ACTIONS(38),
    [anon_sym_nofree] = ACTIONS(38),
    [anon_sym_noimplicitfloat] = ACTIONS(38),
    [anon_sym_noinline] = ACTIONS(38),
    [anon_sym_nomerge] = ACTIONS(38),
    [anon_sym_nonlazybind] = ACTIONS(38),
    [anon_sym_noprofile] = ACTIONS(38),
    [anon_sym_noredzone] = ACTIONS(38),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(38),
    [anon_sym_noreturn] = ACTIONS(38),
    [anon_sym_norecurse] = ACTIONS(38),
    [anon_sym_willreturn] = ACTIONS(38),
    [anon_sym_nosync] = ACTIONS(38),
    [anon_sym_nounwind] = ACTIONS(38),
    [anon_sym_nocallback] = ACTIONS(38),
    [anon_sym_nosanitize_coverage] = ACTIONS(38),
    [anon_sym_null_pointer_is_valid] = ACTIONS(38),
    [anon_sym_optforfuzzing] = ACTIONS(38),
    [anon_sym_optnone] = ACTIONS(38),
    [anon_sym_optsize] = ACTIONS(38),
    [anon_sym_readnone] = ACTIONS(38),
    [anon_sym_readonly] = ACTIONS(38),
    [anon_sym_writeonly] = ACTIONS(38),
    [anon_sym_argmemonly] = ACTIONS(38),
    [anon_sym_returns_twice] = ACTIONS(38),
    [anon_sym_safestack] = ACTIONS(38),
    [anon_sym_sanitize_address] = ACTIONS(38),
    [anon_sym_sanitize_memory] = ACTIONS(38),
    [anon_sym_sanitize_thread] = ACTIONS(38),
    [anon_sym_sanitize_hwaddress] = ACTIONS(38),
    [anon_sym_sanitize_memtag] = ACTIONS(38),
    [anon_sym_speculative_load_hardening] = ACTIONS(38),
    [anon_sym_speculatable] = ACTIONS(38),
    [anon_sym_ssp] = ACTIONS(70),
    [anon_sym_sspstrong] = ACTIONS(38),
    [anon_sym_sspreq] = ACTIONS(38),
    [anon_sym_strictfp] = ACTIONS(38),
    [anon_sym_nocf_check] = ACTIONS(38),
    [anon_sym_shadowcallstack] = ACTIONS(38),
    [anon_sym_mustprogress] = ACTIONS(38),
    [anon_sym_vscale_range] = ACTIONS(38),
    [anon_sym_preallocated] = ACTIONS(38),
    [anon_sym_zeroext] = ACTIONS(38),
    [anon_sym_signext] = ACTIONS(38),
    [anon_sym_inreg] = ACTIONS(38),
    [anon_sym_byval] = ACTIONS(38),
    [anon_sym_byref] = ACTIONS(38),
    [anon_sym_inalloca] = ACTIONS(38),
    [anon_sym_sret] = ACTIONS(38),
    [anon_sym_elementtype] = ACTIONS(38),
    [anon_sym_noalias] = ACTIONS(38),
    [anon_sym_nocapture] = ACTIONS(38),
    [anon_sym_nest] = ACTIONS(38),
    [anon_sym_returned] = ACTIONS(38),
    [anon_sym_nonnull] = ACTIONS(38),
    [anon_sym_dereferenceable] = ACTIONS(70),
    [anon_sym_dereferenceable_or_null] = ACTIONS(38),
    [anon_sym_swiftself] = ACTIONS(38),
    [anon_sym_swiftasync] = ACTIONS(38),
    [anon_sym_swifterror] = ACTIONS(38),
    [anon_sym_immarg] = ACTIONS(38),
    [anon_sym_noundef] = ACTIONS(38),
    [anon_sym_uwtable] = ACTIONS(38),
    [anon_sym_memory] = ACTIONS(38),
    [anon_sym_none] = ACTIONS(315),
    [anon_sym_extractelement] = ACTIONS(335),
    [anon_sym_insertelement] = ACTIONS(337),
    [anon_sym_select] = ACTIONS(339),
    [anon_sym_shufflevector] = ACTIONS(341),
    [anon_sym_fneg] = ACTIONS(343),
    [anon_sym_to] = ACTIONS(38),
    [anon_sym_icmp] = ACTIONS(345),
    [anon_sym_fcmp] = ACTIONS(347),
    [anon_sym_getelementptr] = ACTIONS(349),
    [anon_sym_extractvalue] = ACTIONS(351),
    [anon_sym_insertvalue] = ACTIONS(353),
    [anon_sym_true] = ACTIONS(315),
    [anon_sym_false] = ACTIONS(315),
    [anon_sym_null] = ACTIONS(355),
    [anon_sym_undef] = ACTIONS(315),
    [anon_sym_poison] = ACTIONS(315),
    [anon_sym_zeroinitializer] = ACTIONS(315),
    [anon_sym_blockaddress] = ACTIONS(357),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(112),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [53] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(263),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [sym_label] = ACTIONS(263),
    [sym_string] = ACTIONS(265),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(265),
    [sym_float] = ACTIONS(265),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(265),
    [anon_sym_private] = ACTIONS(265),
    [anon_sym_internal] = ACTIONS(265),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(265),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(265),
    [anon_sym_available_externally] = ACTIONS(265),
    [anon_sym_appending] = ACTIONS(265),
    [anon_sym_common] = ACTIONS(265),
    [anon_sym_extern_weak] = ACTIONS(265),
    [anon_sym_external] = ACTIONS(265),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(265),
    [anon_sym_dso_preemptable] = ACTIONS(265),
    [anon_sym_default] = ACTIONS(265),
    [anon_sym_hidden] = ACTIONS(265),
    [anon_sym_protected] = ACTIONS(265),
    [anon_sym_dllimport] = ACTIONS(265),
    [anon_sym_dllexport] = ACTIONS(265),
    [anon_sym_STAR] = ACTIONS(424),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_align] = ACTIONS(265),
    [anon_sym_section] = ACTIONS(265),
    [anon_sym_partition] = ACTIONS(265),
    [anon_sym_comdat] = ACTIONS(265),
    [anon_sym_gc] = ACTIONS(265),
    [anon_sym_prefix] = ACTIONS(265),
    [anon_sym_prologue] = ACTIONS(265),
    [anon_sym_personality] = ACTIONS(265),
    [anon_sym_alignstack] = ACTIONS(265),
    [anon_sym_allocsize] = ACTIONS(265),
    [anon_sym_alwaysinline] = ACTIONS(265),
    [anon_sym_builtin] = ACTIONS(265),
    [anon_sym_cold] = ACTIONS(265),
    [anon_sym_convergent] = ACTIONS(265),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(265),
    [anon_sym_hot] = ACTIONS(265),
    [anon_sym_inaccessiblememonly] = ACTIONS(265),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(265),
    [anon_sym_inlinehint] = ACTIONS(265),
    [anon_sym_jumptable] = ACTIONS(265),
    [anon_sym_minsize] = ACTIONS(265),
    [anon_sym_naked] = ACTIONS(265),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(265),
    [anon_sym_nobuiltin] = ACTIONS(265),
    [anon_sym_noduplicate] = ACTIONS(265),
    [anon_sym_nofree] = ACTIONS(265),
    [anon_sym_noimplicitfloat] = ACTIONS(265),
    [anon_sym_noinline] = ACTIONS(265),
    [anon_sym_nomerge] = ACTIONS(265),
    [anon_sym_nonlazybind] = ACTIONS(265),
    [anon_sym_noprofile] = ACTIONS(265),
    [anon_sym_noredzone] = ACTIONS(265),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(265),
    [anon_sym_noreturn] = ACTIONS(265),
    [anon_sym_norecurse] = ACTIONS(265),
    [anon_sym_willreturn] = ACTIONS(265),
    [anon_sym_nosync] = ACTIONS(265),
    [anon_sym_nounwind] = ACTIONS(265),
    [anon_sym_nocallback] = ACTIONS(265),
    [anon_sym_nosanitize_coverage] = ACTIONS(265),
    [anon_sym_null_pointer_is_valid] = ACTIONS(265),
    [anon_sym_optforfuzzing] = ACTIONS(265),
    [anon_sym_optnone] = ACTIONS(265),
    [anon_sym_optsize] = ACTIONS(265),
    [anon_sym_readnone] = ACTIONS(265),
    [anon_sym_readonly] = ACTIONS(265),
    [anon_sym_writeonly] = ACTIONS(265),
    [anon_sym_argmemonly] = ACTIONS(265),
    [anon_sym_returns_twice] = ACTIONS(265),
    [anon_sym_safestack] = ACTIONS(265),
    [anon_sym_sanitize_address] = ACTIONS(265),
    [anon_sym_sanitize_memory] = ACTIONS(265),
    [anon_sym_sanitize_thread] = ACTIONS(265),
    [anon_sym_sanitize_hwaddress] = ACTIONS(265),
    [anon_sym_sanitize_memtag] = ACTIONS(265),
    [anon_sym_speculative_load_hardening] = ACTIONS(265),
    [anon_sym_speculatable] = ACTIONS(265),
    [anon_sym_ssp] = ACTIONS(265),
    [anon_sym_sspstrong] = ACTIONS(265),
    [anon_sym_sspreq] = ACTIONS(265),
    [anon_sym_strictfp] = ACTIONS(265),
    [anon_sym_nocf_check] = ACTIONS(265),
    [anon_sym_shadowcallstack] = ACTIONS(265),
    [anon_sym_mustprogress] = ACTIONS(265),
    [anon_sym_vscale_range] = ACTIONS(265),
    [anon_sym_preallocated] = ACTIONS(265),
    [anon_sym_zeroext] = ACTIONS(265),
    [anon_sym_signext] = ACTIONS(265),
    [anon_sym_inreg] = ACTIONS(265),
    [anon_sym_byval] = ACTIONS(265),
    [anon_sym_byref] = ACTIONS(265),
    [anon_sym_inalloca] = ACTIONS(265),
    [anon_sym_sret] = ACTIONS(265),
    [anon_sym_elementtype] = ACTIONS(265),
    [anon_sym_noalias] = ACTIONS(265),
    [anon_sym_nocapture] = ACTIONS(265),
    [anon_sym_nest] = ACTIONS(265),
    [anon_sym_returned] = ACTIONS(265),
    [anon_sym_nonnull] = ACTIONS(265),
    [anon_sym_dereferenceable] = ACTIONS(265),
    [anon_sym_dereferenceable_or_null] = ACTIONS(265),
    [anon_sym_swiftself] = ACTIONS(265),
    [anon_sym_swiftasync] = ACTIONS(265),
    [anon_sym_swifterror] = ACTIONS(265),
    [anon_sym_immarg] = ACTIONS(265),
    [anon_sym_noundef] = ACTIONS(265),
    [anon_sym_uwtable] = ACTIONS(265),
    [anon_sym_memory] = ACTIONS(265),
    [anon_sym_none] = ACTIONS(265),
    [anon_sym_unreachable] = ACTIONS(265),
    [anon_sym_ret] = ACTIONS(265),
    [anon_sym_br] = ACTIONS(265),
    [anon_sym_resume] = ACTIONS(265),
    [anon_sym_freeze] = ACTIONS(265),
    [anon_sym_indirectbr] = ACTIONS(265),
    [anon_sym_extractelement] = ACTIONS(265),
    [anon_sym_insertelement] = ACTIONS(265),
    [anon_sym_select] = ACTIONS(265),
    [anon_sym_shufflevector] = ACTIONS(265),
    [anon_sym_fneg] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(265),
    [anon_sym_invoke] = ACTIONS(265),
    [anon_sym_cleanupret] = ACTIONS(265),
    [anon_sym_catchret] = ACTIONS(265),
    [anon_sym_catchswitch] = ACTIONS(265),
    [anon_sym_catchpad] = ACTIONS(265),
    [anon_sym_cleanuppad] = ACTIONS(265),
    [anon_sym_callbr] = ACTIONS(265),
    [anon_sym_icmp] = ACTIONS(265),
    [anon_sym_fcmp] = ACTIONS(265),
    [anon_sym_va_arg] = ACTIONS(265),
    [anon_sym_phi] = ACTIONS(265),
    [anon_sym_landingpad] = ACTIONS(265),
    [anon_sym_tail] = ACTIONS(265),
    [anon_sym_musttail] = ACTIONS(265),
    [anon_sym_notail] = ACTIONS(265),
    [anon_sym_call] = ACTIONS(265),
    [anon_sym_alloca] = ACTIONS(265),
    [anon_sym_load] = ACTIONS(265),
    [anon_sym_store] = ACTIONS(265),
    [anon_sym_cmpxchg] = ACTIONS(265),
    [anon_sym_atomicrmw] = ACTIONS(265),
    [anon_sym_fence] = ACTIONS(265),
    [anon_sym_getelementptr] = ACTIONS(265),
    [anon_sym_extractvalue] = ACTIONS(265),
    [anon_sym_insertvalue] = ACTIONS(265),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [anon_sym_null] = ACTIONS(265),
    [anon_sym_undef] = ACTIONS(265),
    [anon_sym_poison] = ACTIONS(265),
    [anon_sym_zeroinitializer] = ACTIONS(265),
    [anon_sym_blockaddress] = ACTIONS(265),
    [anon_sym_mul] = ACTIONS(265),
    [anon_sym_urem] = ACTIONS(265),
    [anon_sym_srem] = ACTIONS(265),
    [anon_sym_shl] = ACTIONS(265),
    [anon_sym_udiv] = ACTIONS(265),
    [anon_sym_sdiv] = ACTIONS(265),
    [anon_sym_lshr] = ACTIONS(265),
    [anon_sym_ashr] = ACTIONS(265),
    [anon_sym_fmul] = ACTIONS(265),
    [anon_sym_fdiv] = ACTIONS(265),
    [anon_sym_frem] = ACTIONS(265),
    [anon_sym_xchg] = ACTIONS(265),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(265),
    [anon_sym_and] = ACTIONS(265),
    [anon_sym_nand] = ACTIONS(265),
    [anon_sym_or] = ACTIONS(265),
    [anon_sym_xor] = ACTIONS(265),
    [anon_sym_max] = ACTIONS(265),
    [anon_sym_min] = ACTIONS(265),
    [anon_sym_umax] = ACTIONS(265),
    [anon_sym_umin] = ACTIONS(265),
    [anon_sym_fadd] = ACTIONS(265),
    [anon_sym_fsub] = ACTIONS(265),
    [anon_sym_bitcast] = ACTIONS(265),
    [anon_sym_trunc] = ACTIONS(265),
    [anon_sym_zext] = ACTIONS(265),
    [anon_sym_sext] = ACTIONS(265),
    [anon_sym_fptrunc] = ACTIONS(265),
    [anon_sym_fpext] = ACTIONS(265),
    [anon_sym_addrspacecast] = ACTIONS(265),
    [anon_sym_uitofp] = ACTIONS(265),
    [anon_sym_sitofp] = ACTIONS(265),
    [anon_sym_fptoui] = ACTIONS(265),
    [anon_sym_fptosi] = ACTIONS(265),
    [anon_sym_inttoptr] = ACTIONS(265),
    [anon_sym_ptrtoint] = ACTIONS(265),
    [anon_sym_uselistorder] = ACTIONS(265),
  },
  [54] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(391),
    [sym_global_var] = ACTIONS(391),
    [sym_local_var] = ACTIONS(391),
    [sym_label] = ACTIONS(391),
    [sym_string] = ACTIONS(393),
    [aux_sym_number_token1] = ACTIONS(393),
    [aux_sym_number_token2] = ACTIONS(393),
    [sym_float] = ACTIONS(393),
    [sym_cstring] = ACTIONS(391),
    [anon_sym_no_cfi] = ACTIONS(393),
    [anon_sym_private] = ACTIONS(393),
    [anon_sym_internal] = ACTIONS(393),
    [anon_sym_weak] = ACTIONS(393),
    [anon_sym_weak_odr] = ACTIONS(393),
    [anon_sym_linkonce] = ACTIONS(393),
    [anon_sym_linkonce_odr] = ACTIONS(393),
    [anon_sym_available_externally] = ACTIONS(393),
    [anon_sym_appending] = ACTIONS(393),
    [anon_sym_common] = ACTIONS(393),
    [anon_sym_extern_weak] = ACTIONS(393),
    [anon_sym_external] = ACTIONS(393),
    [anon_sym_dso_local] = ACTIONS(393),
    [anon_sym_dso_local_equivalent] = ACTIONS(393),
    [anon_sym_dso_preemptable] = ACTIONS(393),
    [anon_sym_default] = ACTIONS(393),
    [anon_sym_hidden] = ACTIONS(393),
    [anon_sym_protected] = ACTIONS(393),
    [anon_sym_dllimport] = ACTIONS(393),
    [anon_sym_dllexport] = ACTIONS(393),
    [anon_sym_STAR] = ACTIONS(391),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_RBRACE] = ACTIONS(391),
    [anon_sym_LT_LBRACE] = ACTIONS(391),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LT] = ACTIONS(393),
    [anon_sym_COMMA] = ACTIONS(391),
    [anon_sym_align] = ACTIONS(393),
    [anon_sym_section] = ACTIONS(393),
    [anon_sym_partition] = ACTIONS(393),
    [anon_sym_comdat] = ACTIONS(393),
    [anon_sym_gc] = ACTIONS(393),
    [anon_sym_prefix] = ACTIONS(393),
    [anon_sym_prologue] = ACTIONS(393),
    [anon_sym_personality] = ACTIONS(393),
    [anon_sym_alignstack] = ACTIONS(393),
    [anon_sym_allocsize] = ACTIONS(393),
    [anon_sym_alwaysinline] = ACTIONS(393),
    [anon_sym_builtin] = ACTIONS(393),
    [anon_sym_cold] = ACTIONS(393),
    [anon_sym_convergent] = ACTIONS(393),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(393),
    [anon_sym_hot] = ACTIONS(393),
    [anon_sym_inaccessiblememonly] = ACTIONS(393),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(393),
    [anon_sym_inlinehint] = ACTIONS(393),
    [anon_sym_jumptable] = ACTIONS(393),
    [anon_sym_minsize] = ACTIONS(393),
    [anon_sym_naked] = ACTIONS(393),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(393),
    [anon_sym_nobuiltin] = ACTIONS(393),
    [anon_sym_noduplicate] = ACTIONS(393),
    [anon_sym_nofree] = ACTIONS(393),
    [anon_sym_noimplicitfloat] = ACTIONS(393),
    [anon_sym_noinline] = ACTIONS(393),
    [anon_sym_nomerge] = ACTIONS(393),
    [anon_sym_nonlazybind] = ACTIONS(393),
    [anon_sym_noprofile] = ACTIONS(393),
    [anon_sym_noredzone] = ACTIONS(393),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(393),
    [anon_sym_noreturn] = ACTIONS(393),
    [anon_sym_norecurse] = ACTIONS(393),
    [anon_sym_willreturn] = ACTIONS(393),
    [anon_sym_nosync] = ACTIONS(393),
    [anon_sym_nounwind] = ACTIONS(393),
    [anon_sym_nocallback] = ACTIONS(393),
    [anon_sym_nosanitize_coverage] = ACTIONS(393),
    [anon_sym_null_pointer_is_valid] = ACTIONS(393),
    [anon_sym_optforfuzzing] = ACTIONS(393),
    [anon_sym_optnone] = ACTIONS(393),
    [anon_sym_optsize] = ACTIONS(393),
    [anon_sym_readnone] = ACTIONS(393),
    [anon_sym_readonly] = ACTIONS(393),
    [anon_sym_writeonly] = ACTIONS(393),
    [anon_sym_argmemonly] = ACTIONS(393),
    [anon_sym_returns_twice] = ACTIONS(393),
    [anon_sym_safestack] = ACTIONS(393),
    [anon_sym_sanitize_address] = ACTIONS(393),
    [anon_sym_sanitize_memory] = ACTIONS(393),
    [anon_sym_sanitize_thread] = ACTIONS(393),
    [anon_sym_sanitize_hwaddress] = ACTIONS(393),
    [anon_sym_sanitize_memtag] = ACTIONS(393),
    [anon_sym_speculative_load_hardening] = ACTIONS(393),
    [anon_sym_speculatable] = ACTIONS(393),
    [anon_sym_ssp] = ACTIONS(393),
    [anon_sym_sspstrong] = ACTIONS(393),
    [anon_sym_sspreq] = ACTIONS(393),
    [anon_sym_strictfp] = ACTIONS(393),
    [anon_sym_nocf_check] = ACTIONS(393),
    [anon_sym_shadowcallstack] = ACTIONS(393),
    [anon_sym_mustprogress] = ACTIONS(393),
    [anon_sym_vscale_range] = ACTIONS(393),
    [anon_sym_preallocated] = ACTIONS(393),
    [anon_sym_zeroext] = ACTIONS(393),
    [anon_sym_signext] = ACTIONS(393),
    [anon_sym_inreg] = ACTIONS(393),
    [anon_sym_byval] = ACTIONS(393),
    [anon_sym_byref] = ACTIONS(393),
    [anon_sym_inalloca] = ACTIONS(393),
    [anon_sym_sret] = ACTIONS(393),
    [anon_sym_elementtype] = ACTIONS(393),
    [anon_sym_noalias] = ACTIONS(393),
    [anon_sym_nocapture] = ACTIONS(393),
    [anon_sym_nest] = ACTIONS(393),
    [anon_sym_returned] = ACTIONS(393),
    [anon_sym_nonnull] = ACTIONS(393),
    [anon_sym_dereferenceable] = ACTIONS(393),
    [anon_sym_dereferenceable_or_null] = ACTIONS(393),
    [anon_sym_swiftself] = ACTIONS(393),
    [anon_sym_swiftasync] = ACTIONS(393),
    [anon_sym_swifterror] = ACTIONS(393),
    [anon_sym_immarg] = ACTIONS(393),
    [anon_sym_noundef] = ACTIONS(393),
    [anon_sym_uwtable] = ACTIONS(393),
    [anon_sym_memory] = ACTIONS(393),
    [anon_sym_none] = ACTIONS(393),
    [anon_sym_unreachable] = ACTIONS(393),
    [anon_sym_ret] = ACTIONS(393),
    [anon_sym_br] = ACTIONS(393),
    [anon_sym_resume] = ACTIONS(393),
    [anon_sym_freeze] = ACTIONS(393),
    [anon_sym_indirectbr] = ACTIONS(393),
    [anon_sym_extractelement] = ACTIONS(393),
    [anon_sym_insertelement] = ACTIONS(393),
    [anon_sym_select] = ACTIONS(393),
    [anon_sym_shufflevector] = ACTIONS(393),
    [anon_sym_fneg] = ACTIONS(393),
    [anon_sym_switch] = ACTIONS(393),
    [anon_sym_invoke] = ACTIONS(393),
    [anon_sym_cleanupret] = ACTIONS(393),
    [anon_sym_catchret] = ACTIONS(393),
    [anon_sym_catchswitch] = ACTIONS(393),
    [anon_sym_catchpad] = ACTIONS(393),
    [anon_sym_cleanuppad] = ACTIONS(393),
    [anon_sym_callbr] = ACTIONS(393),
    [anon_sym_icmp] = ACTIONS(393),
    [anon_sym_fcmp] = ACTIONS(393),
    [anon_sym_va_arg] = ACTIONS(393),
    [anon_sym_phi] = ACTIONS(393),
    [anon_sym_landingpad] = ACTIONS(393),
    [anon_sym_tail] = ACTIONS(393),
    [anon_sym_musttail] = ACTIONS(393),
    [anon_sym_notail] = ACTIONS(393),
    [anon_sym_call] = ACTIONS(393),
    [anon_sym_alloca] = ACTIONS(393),
    [anon_sym_load] = ACTIONS(393),
    [anon_sym_store] = ACTIONS(393),
    [anon_sym_cmpxchg] = ACTIONS(393),
    [anon_sym_atomicrmw] = ACTIONS(393),
    [anon_sym_fence] = ACTIONS(393),
    [anon_sym_getelementptr] = ACTIONS(393),
    [anon_sym_extractvalue] = ACTIONS(393),
    [anon_sym_insertvalue] = ACTIONS(393),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [anon_sym_null] = ACTIONS(393),
    [anon_sym_undef] = ACTIONS(393),
    [anon_sym_poison] = ACTIONS(393),
    [anon_sym_zeroinitializer] = ACTIONS(393),
    [anon_sym_blockaddress] = ACTIONS(393),
    [anon_sym_mul] = ACTIONS(393),
    [anon_sym_urem] = ACTIONS(393),
    [anon_sym_srem] = ACTIONS(393),
    [anon_sym_shl] = ACTIONS(393),
    [anon_sym_udiv] = ACTIONS(393),
    [anon_sym_sdiv] = ACTIONS(393),
    [anon_sym_lshr] = ACTIONS(393),
    [anon_sym_ashr] = ACTIONS(393),
    [anon_sym_fmul] = ACTIONS(393),
    [anon_sym_fdiv] = ACTIONS(393),
    [anon_sym_frem] = ACTIONS(393),
    [anon_sym_xchg] = ACTIONS(393),
    [anon_sym_add] = ACTIONS(393),
    [anon_sym_sub] = ACTIONS(393),
    [anon_sym_and] = ACTIONS(393),
    [anon_sym_nand] = ACTIONS(393),
    [anon_sym_or] = ACTIONS(393),
    [anon_sym_xor] = ACTIONS(393),
    [anon_sym_max] = ACTIONS(393),
    [anon_sym_min] = ACTIONS(393),
    [anon_sym_umax] = ACTIONS(393),
    [anon_sym_umin] = ACTIONS(393),
    [anon_sym_fadd] = ACTIONS(393),
    [anon_sym_fsub] = ACTIONS(393),
    [anon_sym_bitcast] = ACTIONS(393),
    [anon_sym_trunc] = ACTIONS(393),
    [anon_sym_zext] = ACTIONS(393),
    [anon_sym_sext] = ACTIONS(393),
    [anon_sym_fptrunc] = ACTIONS(393),
    [anon_sym_fpext] = ACTIONS(393),
    [anon_sym_addrspacecast] = ACTIONS(393),
    [anon_sym_uitofp] = ACTIONS(393),
    [anon_sym_sitofp] = ACTIONS(393),
    [anon_sym_fptoui] = ACTIONS(393),
    [anon_sym_fptosi] = ACTIONS(393),
    [anon_sym_inttoptr] = ACTIONS(393),
    [anon_sym_ptrtoint] = ACTIONS(393),
    [anon_sym_uselistorder] = ACTIONS(393),
  },
  [55] = {
    [sym_number] = STATE(361),
    [sym_var] = STATE(361),
    [sym_linkage] = STATE(820),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(360),
    [sym__primitive_value] = STATE(361),
    [sym_struct_value] = STATE(361),
    [sym_packed_struct_value] = STATE(361),
    [sym_array_value] = STATE(361),
    [sym_vector_value] = STATE(361),
    [sym_blockaddress] = STATE(361),
    [sym_constant_expr] = STATE(361),
    [sym_constant_cast] = STATE(359),
    [sym_constant_getelementptr] = STATE(359),
    [sym_constant_select] = STATE(359),
    [sym_constant_icmp] = STATE(359),
    [sym_constant_fcmp] = STATE(359),
    [sym_constant_extractelement] = STATE(359),
    [sym_constant_insertelement] = STATE(359),
    [sym_constant_shufflevector] = STATE(359),
    [sym_constant_extractvalue] = STATE(359),
    [sym_constant_insertvalue] = STATE(359),
    [sym_constant_fneg] = STATE(359),
    [sym_constant_bin_op] = STATE(359),
    [sym_bin_op_keyword] = STATE(1133),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1924),
    [aux_sym_function_header_repeat1] = STATE(820),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(38),
    [sym_global_var] = ACTIONS(426),
    [sym_local_var] = ACTIONS(426),
    [sym_string] = ACTIONS(308),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [sym_float] = ACTIONS(315),
    [sym_cstring] = ACTIONS(315),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_RBRACE] = ACTIONS(38),
    [anon_sym_LT_LBRACE] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(333),
    [anon_sym_align] = ACTIONS(70),
    [anon_sym_section] = ACTIONS(38),
    [anon_sym_partition] = ACTIONS(38),
    [anon_sym_comdat] = ACTIONS(38),
    [anon_sym_gc] = ACTIONS(38),
    [anon_sym_prefix] = ACTIONS(38),
    [anon_sym_prologue] = ACTIONS(38),
    [anon_sym_personality] = ACTIONS(38),
    [anon_sym_alignstack] = ACTIONS(38),
    [anon_sym_allocsize] = ACTIONS(38),
    [anon_sym_alwaysinline] = ACTIONS(38),
    [anon_sym_builtin] = ACTIONS(38),
    [anon_sym_cold] = ACTIONS(38),
    [anon_sym_convergent] = ACTIONS(38),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(38),
    [anon_sym_hot] = ACTIONS(38),
    [anon_sym_inaccessiblememonly] = ACTIONS(38),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(38),
    [anon_sym_inlinehint] = ACTIONS(38),
    [anon_sym_jumptable] = ACTIONS(38),
    [anon_sym_minsize] = ACTIONS(38),
    [anon_sym_naked] = ACTIONS(38),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(38),
    [anon_sym_nobuiltin] = ACTIONS(38),
    [anon_sym_noduplicate] = ACTIONS(38),
    [anon_sym_nofree] = ACTIONS(38),
    [anon_sym_noimplicitfloat] = ACTIONS(38),
    [anon_sym_noinline] = ACTIONS(38),
    [anon_sym_nomerge] = ACTIONS(38),
    [anon_sym_nonlazybind] = ACTIONS(38),
    [anon_sym_noprofile] = ACTIONS(38),
    [anon_sym_noredzone] = ACTIONS(38),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(38),
    [anon_sym_noreturn] = ACTIONS(38),
    [anon_sym_norecurse] = ACTIONS(38),
    [anon_sym_willreturn] = ACTIONS(38),
    [anon_sym_nosync] = ACTIONS(38),
    [anon_sym_nounwind] = ACTIONS(38),
    [anon_sym_nocallback] = ACTIONS(38),
    [anon_sym_nosanitize_coverage] = ACTIONS(38),
    [anon_sym_null_pointer_is_valid] = ACTIONS(38),
    [anon_sym_optforfuzzing] = ACTIONS(38),
    [anon_sym_optnone] = ACTIONS(38),
    [anon_sym_optsize] = ACTIONS(38),
    [anon_sym_readnone] = ACTIONS(38),
    [anon_sym_readonly] = ACTIONS(38),
    [anon_sym_writeonly] = ACTIONS(38),
    [anon_sym_argmemonly] = ACTIONS(38),
    [anon_sym_returns_twice] = ACTIONS(38),
    [anon_sym_safestack] = ACTIONS(38),
    [anon_sym_sanitize_address] = ACTIONS(38),
    [anon_sym_sanitize_memory] = ACTIONS(38),
    [anon_sym_sanitize_thread] = ACTIONS(38),
    [anon_sym_sanitize_hwaddress] = ACTIONS(38),
    [anon_sym_sanitize_memtag] = ACTIONS(38),
    [anon_sym_speculative_load_hardening] = ACTIONS(38),
    [anon_sym_speculatable] = ACTIONS(38),
    [anon_sym_ssp] = ACTIONS(70),
    [anon_sym_sspstrong] = ACTIONS(38),
    [anon_sym_sspreq] = ACTIONS(38),
    [anon_sym_strictfp] = ACTIONS(38),
    [anon_sym_nocf_check] = ACTIONS(38),
    [anon_sym_shadowcallstack] = ACTIONS(38),
    [anon_sym_mustprogress] = ACTIONS(38),
    [anon_sym_vscale_range] = ACTIONS(38),
    [anon_sym_preallocated] = ACTIONS(38),
    [anon_sym_zeroext] = ACTIONS(38),
    [anon_sym_signext] = ACTIONS(38),
    [anon_sym_inreg] = ACTIONS(38),
    [anon_sym_byval] = ACTIONS(38),
    [anon_sym_byref] = ACTIONS(38),
    [anon_sym_inalloca] = ACTIONS(38),
    [anon_sym_sret] = ACTIONS(38),
    [anon_sym_elementtype] = ACTIONS(38),
    [anon_sym_noalias] = ACTIONS(38),
    [anon_sym_nocapture] = ACTIONS(38),
    [anon_sym_nest] = ACTIONS(38),
    [anon_sym_returned] = ACTIONS(38),
    [anon_sym_nonnull] = ACTIONS(38),
    [anon_sym_dereferenceable] = ACTIONS(70),
    [anon_sym_dereferenceable_or_null] = ACTIONS(38),
    [anon_sym_swiftself] = ACTIONS(38),
    [anon_sym_swiftasync] = ACTIONS(38),
    [anon_sym_swifterror] = ACTIONS(38),
    [anon_sym_immarg] = ACTIONS(38),
    [anon_sym_noundef] = ACTIONS(38),
    [anon_sym_uwtable] = ACTIONS(38),
    [anon_sym_memory] = ACTIONS(38),
    [anon_sym_none] = ACTIONS(315),
    [anon_sym_extractelement] = ACTIONS(335),
    [anon_sym_insertelement] = ACTIONS(337),
    [anon_sym_select] = ACTIONS(339),
    [anon_sym_shufflevector] = ACTIONS(341),
    [anon_sym_fneg] = ACTIONS(343),
    [anon_sym_icmp] = ACTIONS(345),
    [anon_sym_fcmp] = ACTIONS(347),
    [anon_sym_getelementptr] = ACTIONS(349),
    [anon_sym_extractvalue] = ACTIONS(351),
    [anon_sym_insertvalue] = ACTIONS(353),
    [anon_sym_true] = ACTIONS(315),
    [anon_sym_false] = ACTIONS(315),
    [anon_sym_null] = ACTIONS(355),
    [anon_sym_undef] = ACTIONS(315),
    [anon_sym_poison] = ACTIONS(315),
    [anon_sym_zeroinitializer] = ACTIONS(315),
    [anon_sym_blockaddress] = ACTIONS(357),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(112),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [56] = {
    [sym_metadata_ref] = STATE(302),
    [sym_type] = STATE(57),
    [sym_type_keyword] = STATE(62),
    [sym_struct_type] = STATE(62),
    [sym_packed_struct_type] = STATE(62),
    [sym_array_type] = STATE(62),
    [sym_vector_type] = STATE(62),
    [sym_type_and_value] = STATE(326),
    [sym_metadata] = STATE(339),
    [sym_metadata_tuple] = STATE(326),
    [sym_specialized_md] = STATE(326),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(116),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(283),
    [aux_sym_metadata_ref_token1] = ACTIONS(285),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(287),
    [anon_sym_half] = ACTIONS(287),
    [anon_sym_bfloat] = ACTIONS(287),
    [anon_sym_float] = ACTIONS(287),
    [anon_sym_double] = ACTIONS(287),
    [anon_sym_x86_fp80] = ACTIONS(287),
    [anon_sym_fp128] = ACTIONS(287),
    [anon_sym_ppc_fp128] = ACTIONS(287),
    [anon_sym_label] = ACTIONS(287),
    [anon_sym_metadata] = ACTIONS(431),
    [anon_sym_x86_mmx] = ACTIONS(287),
    [anon_sym_x86_amx] = ACTIONS(287),
    [anon_sym_token] = ACTIONS(287),
    [anon_sym_opaque] = ACTIONS(287),
    [anon_sym_ptr] = ACTIONS(291),
    [aux_sym_type_keyword_token1] = ACTIONS(287),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_LT_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(299),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_align] = ACTIONS(122),
    [anon_sym_section] = ACTIONS(116),
    [anon_sym_partition] = ACTIONS(116),
    [anon_sym_comdat] = ACTIONS(116),
    [anon_sym_gc] = ACTIONS(116),
    [anon_sym_prefix] = ACTIONS(116),
    [anon_sym_prologue] = ACTIONS(116),
    [anon_sym_personality] = ACTIONS(116),
    [anon_sym_alignstack] = ACTIONS(116),
    [anon_sym_allocsize] = ACTIONS(116),
    [anon_sym_alwaysinline] = ACTIONS(116),
    [anon_sym_builtin] = ACTIONS(116),
    [anon_sym_cold] = ACTIONS(116),
    [anon_sym_convergent] = ACTIONS(116),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(116),
    [anon_sym_hot] = ACTIONS(116),
    [anon_sym_inaccessiblememonly] = ACTIONS(116),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(116),
    [anon_sym_inlinehint] = ACTIONS(116),
    [anon_sym_jumptable] = ACTIONS(116),
    [anon_sym_minsize] = ACTIONS(116),
    [anon_sym_naked] = ACTIONS(116),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(116),
    [anon_sym_nobuiltin] = ACTIONS(116),
    [anon_sym_noduplicate] = ACTIONS(116),
    [anon_sym_nofree] = ACTIONS(116),
    [anon_sym_noimplicitfloat] = ACTIONS(116),
    [anon_sym_noinline] = ACTIONS(116),
    [anon_sym_nomerge] = ACTIONS(116),
    [anon_sym_nonlazybind] = ACTIONS(116),
    [anon_sym_noprofile] = ACTIONS(116),
    [anon_sym_noredzone] = ACTIONS(116),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(116),
    [anon_sym_noreturn] = ACTIONS(116),
    [anon_sym_norecurse] = ACTIONS(116),
    [anon_sym_willreturn] = ACTIONS(116),
    [anon_sym_nosync] = ACTIONS(116),
    [anon_sym_nounwind] = ACTIONS(116),
    [anon_sym_nocallback] = ACTIONS(116),
    [anon_sym_nosanitize_coverage] = ACTIONS(116),
    [anon_sym_null_pointer_is_valid] = ACTIONS(116),
    [anon_sym_optforfuzzing] = ACTIONS(116),
    [anon_sym_optnone] = ACTIONS(116),
    [anon_sym_optsize] = ACTIONS(116),
    [anon_sym_readnone] = ACTIONS(116),
    [anon_sym_readonly] = ACTIONS(116),
    [anon_sym_writeonly] = ACTIONS(116),
    [anon_sym_argmemonly] = ACTIONS(116),
    [anon_sym_returns_twice] = ACTIONS(116),
    [anon_sym_safestack] = ACTIONS(116),
    [anon_sym_sanitize_address] = ACTIONS(116),
    [anon_sym_sanitize_memory] = ACTIONS(116),
    [anon_sym_sanitize_thread] = ACTIONS(116),
    [anon_sym_sanitize_hwaddress] = ACTIONS(116),
    [anon_sym_sanitize_memtag] = ACTIONS(116),
    [anon_sym_speculative_load_hardening] = ACTIONS(116),
    [anon_sym_speculatable] = ACTIONS(116),
    [anon_sym_ssp] = ACTIONS(122),
    [anon_sym_sspstrong] = ACTIONS(116),
    [anon_sym_sspreq] = ACTIONS(116),
    [anon_sym_strictfp] = ACTIONS(116),
    [anon_sym_nocf_check] = ACTIONS(116),
    [anon_sym_shadowcallstack] = ACTIONS(116),
    [anon_sym_mustprogress] = ACTIONS(116),
    [anon_sym_vscale_range] = ACTIONS(116),
    [anon_sym_preallocated] = ACTIONS(116),
    [anon_sym_zeroext] = ACTIONS(116),
    [anon_sym_signext] = ACTIONS(116),
    [anon_sym_inreg] = ACTIONS(116),
    [anon_sym_byval] = ACTIONS(116),
    [anon_sym_byref] = ACTIONS(116),
    [anon_sym_inalloca] = ACTIONS(116),
    [anon_sym_sret] = ACTIONS(116),
    [anon_sym_elementtype] = ACTIONS(116),
    [anon_sym_noalias] = ACTIONS(116),
    [anon_sym_nocapture] = ACTIONS(116),
    [anon_sym_nest] = ACTIONS(116),
    [anon_sym_returned] = ACTIONS(116),
    [anon_sym_nonnull] = ACTIONS(116),
    [anon_sym_dereferenceable] = ACTIONS(122),
    [anon_sym_dereferenceable_or_null] = ACTIONS(116),
    [anon_sym_swiftself] = ACTIONS(116),
    [anon_sym_swiftasync] = ACTIONS(116),
    [anon_sym_swifterror] = ACTIONS(116),
    [anon_sym_immarg] = ACTIONS(116),
    [anon_sym_noundef] = ACTIONS(116),
    [anon_sym_uwtable] = ACTIONS(116),
    [anon_sym_memory] = ACTIONS(116),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(303),
  },
  [57] = {
    [sym_number] = STATE(361),
    [sym_var] = STATE(361),
    [sym_linkage] = STATE(820),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(360),
    [sym__primitive_value] = STATE(361),
    [sym_struct_value] = STATE(361),
    [sym_packed_struct_value] = STATE(361),
    [sym_array_value] = STATE(361),
    [sym_vector_value] = STATE(361),
    [sym_blockaddress] = STATE(361),
    [sym_constant_expr] = STATE(361),
    [sym_constant_cast] = STATE(359),
    [sym_constant_getelementptr] = STATE(359),
    [sym_constant_select] = STATE(359),
    [sym_constant_icmp] = STATE(359),
    [sym_constant_fcmp] = STATE(359),
    [sym_constant_extractelement] = STATE(359),
    [sym_constant_insertelement] = STATE(359),
    [sym_constant_shufflevector] = STATE(359),
    [sym_constant_extractvalue] = STATE(359),
    [sym_constant_insertvalue] = STATE(359),
    [sym_constant_fneg] = STATE(359),
    [sym_constant_bin_op] = STATE(359),
    [sym_bin_op_keyword] = STATE(1133),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1924),
    [aux_sym_function_header_repeat1] = STATE(820),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(38),
    [sym_global_var] = ACTIONS(426),
    [sym_local_var] = ACTIONS(426),
    [aux_sym_metadata_ref_token1] = ACTIONS(38),
    [sym_string] = ACTIONS(308),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [sym_float] = ACTIONS(315),
    [sym_cstring] = ACTIONS(315),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(433),
    [anon_sym_LT_LBRACE] = ACTIONS(329),
    [anon_sym_LBRACK] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(333),
    [anon_sym_align] = ACTIONS(70),
    [anon_sym_section] = ACTIONS(38),
    [anon_sym_partition] = ACTIONS(38),
    [anon_sym_comdat] = ACTIONS(38),
    [anon_sym_gc] = ACTIONS(38),
    [anon_sym_prefix] = ACTIONS(38),
    [anon_sym_prologue] = ACTIONS(38),
    [anon_sym_personality] = ACTIONS(38),
    [anon_sym_alignstack] = ACTIONS(38),
    [anon_sym_allocsize] = ACTIONS(38),
    [anon_sym_alwaysinline] = ACTIONS(38),
    [anon_sym_builtin] = ACTIONS(38),
    [anon_sym_cold] = ACTIONS(38),
    [anon_sym_convergent] = ACTIONS(38),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(38),
    [anon_sym_hot] = ACTIONS(38),
    [anon_sym_inaccessiblememonly] = ACTIONS(38),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(38),
    [anon_sym_inlinehint] = ACTIONS(38),
    [anon_sym_jumptable] = ACTIONS(38),
    [anon_sym_minsize] = ACTIONS(38),
    [anon_sym_naked] = ACTIONS(38),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(38),
    [anon_sym_nobuiltin] = ACTIONS(38),
    [anon_sym_noduplicate] = ACTIONS(38),
    [anon_sym_nofree] = ACTIONS(38),
    [anon_sym_noimplicitfloat] = ACTIONS(38),
    [anon_sym_noinline] = ACTIONS(38),
    [anon_sym_nomerge] = ACTIONS(38),
    [anon_sym_nonlazybind] = ACTIONS(38),
    [anon_sym_noprofile] = ACTIONS(38),
    [anon_sym_noredzone] = ACTIONS(38),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(38),
    [anon_sym_noreturn] = ACTIONS(38),
    [anon_sym_norecurse] = ACTIONS(38),
    [anon_sym_willreturn] = ACTIONS(38),
    [anon_sym_nosync] = ACTIONS(38),
    [anon_sym_nounwind] = ACTIONS(38),
    [anon_sym_nocallback] = ACTIONS(38),
    [anon_sym_nosanitize_coverage] = ACTIONS(38),
    [anon_sym_null_pointer_is_valid] = ACTIONS(38),
    [anon_sym_optforfuzzing] = ACTIONS(38),
    [anon_sym_optnone] = ACTIONS(38),
    [anon_sym_optsize] = ACTIONS(38),
    [anon_sym_readnone] = ACTIONS(38),
    [anon_sym_readonly] = ACTIONS(38),
    [anon_sym_writeonly] = ACTIONS(38),
    [anon_sym_argmemonly] = ACTIONS(38),
    [anon_sym_returns_twice] = ACTIONS(38),
    [anon_sym_safestack] = ACTIONS(38),
    [anon_sym_sanitize_address] = ACTIONS(38),
    [anon_sym_sanitize_memory] = ACTIONS(38),
    [anon_sym_sanitize_thread] = ACTIONS(38),
    [anon_sym_sanitize_hwaddress] = ACTIONS(38),
    [anon_sym_sanitize_memtag] = ACTIONS(38),
    [anon_sym_speculative_load_hardening] = ACTIONS(38),
    [anon_sym_speculatable] = ACTIONS(38),
    [anon_sym_ssp] = ACTIONS(70),
    [anon_sym_sspstrong] = ACTIONS(38),
    [anon_sym_sspreq] = ACTIONS(38),
    [anon_sym_strictfp] = ACTIONS(38),
    [anon_sym_nocf_check] = ACTIONS(38),
    [anon_sym_shadowcallstack] = ACTIONS(38),
    [anon_sym_mustprogress] = ACTIONS(38),
    [anon_sym_vscale_range] = ACTIONS(38),
    [anon_sym_preallocated] = ACTIONS(38),
    [anon_sym_zeroext] = ACTIONS(38),
    [anon_sym_signext] = ACTIONS(38),
    [anon_sym_inreg] = ACTIONS(38),
    [anon_sym_byval] = ACTIONS(38),
    [anon_sym_byref] = ACTIONS(38),
    [anon_sym_inalloca] = ACTIONS(38),
    [anon_sym_sret] = ACTIONS(38),
    [anon_sym_elementtype] = ACTIONS(38),
    [anon_sym_noalias] = ACTIONS(38),
    [anon_sym_nocapture] = ACTIONS(38),
    [anon_sym_nest] = ACTIONS(38),
    [anon_sym_returned] = ACTIONS(38),
    [anon_sym_nonnull] = ACTIONS(38),
    [anon_sym_dereferenceable] = ACTIONS(70),
    [anon_sym_dereferenceable_or_null] = ACTIONS(38),
    [anon_sym_swiftself] = ACTIONS(38),
    [anon_sym_swiftasync] = ACTIONS(38),
    [anon_sym_swifterror] = ACTIONS(38),
    [anon_sym_immarg] = ACTIONS(38),
    [anon_sym_noundef] = ACTIONS(38),
    [anon_sym_uwtable] = ACTIONS(38),
    [anon_sym_memory] = ACTIONS(38),
    [anon_sym_none] = ACTIONS(315),
    [anon_sym_extractelement] = ACTIONS(335),
    [anon_sym_insertelement] = ACTIONS(337),
    [anon_sym_select] = ACTIONS(339),
    [anon_sym_shufflevector] = ACTIONS(341),
    [anon_sym_fneg] = ACTIONS(343),
    [anon_sym_icmp] = ACTIONS(345),
    [anon_sym_fcmp] = ACTIONS(347),
    [anon_sym_getelementptr] = ACTIONS(349),
    [anon_sym_extractvalue] = ACTIONS(351),
    [anon_sym_insertvalue] = ACTIONS(353),
    [anon_sym_true] = ACTIONS(315),
    [anon_sym_false] = ACTIONS(315),
    [anon_sym_null] = ACTIONS(355),
    [anon_sym_undef] = ACTIONS(315),
    [anon_sym_poison] = ACTIONS(315),
    [anon_sym_zeroinitializer] = ACTIONS(315),
    [anon_sym_blockaddress] = ACTIONS(357),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(112),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [58] = {
    [sym_metadata_ref] = STATE(100),
    [sym_type] = STATE(292),
    [sym_type_keyword] = STATE(260),
    [sym_struct_type] = STATE(260),
    [sym_packed_struct_type] = STATE(260),
    [sym_array_type] = STATE(260),
    [sym_vector_type] = STATE(260),
    [sym_param_or_return_attrs] = STATE(366),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_type_and_value] = STATE(134),
    [sym_metadata] = STATE(1474),
    [sym_metadata_tuple] = STATE(134),
    [sym_specialized_md] = STATE(134),
    [aux_sym_function_header_repeat2] = STATE(366),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(436),
    [aux_sym_metadata_ref_token1] = ACTIONS(13),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(440),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(442),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_COMMA] = ACTIONS(452),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_RPAREN] = ACTIONS(452),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(230),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(232),
  },
  [59] = {
    [sym_number] = STATE(92),
    [sym_var] = STATE(92),
    [sym_linkage] = STATE(817),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_param_or_return_attrs] = STATE(60),
    [sym_attribute_name] = STATE(225),
    [sym_uwtable] = STATE(216),
    [sym_memory_attribute] = STATE(216),
    [sym_value] = STATE(1473),
    [sym__primitive_value] = STATE(92),
    [sym_struct_value] = STATE(92),
    [sym_packed_struct_value] = STATE(92),
    [sym_array_value] = STATE(92),
    [sym_vector_value] = STATE(92),
    [sym_blockaddress] = STATE(92),
    [sym_constant_expr] = STATE(92),
    [sym_constant_cast] = STATE(87),
    [sym_constant_getelementptr] = STATE(87),
    [sym_constant_select] = STATE(87),
    [sym_constant_icmp] = STATE(87),
    [sym_constant_fcmp] = STATE(87),
    [sym_constant_extractelement] = STATE(87),
    [sym_constant_insertelement] = STATE(87),
    [sym_constant_shufflevector] = STATE(87),
    [sym_constant_extractvalue] = STATE(87),
    [sym_constant_insertvalue] = STATE(87),
    [sym_constant_fneg] = STATE(87),
    [sym_constant_bin_op] = STATE(87),
    [sym_bin_op_keyword] = STATE(1122),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1597),
    [aux_sym_function_header_repeat1] = STATE(817),
    [aux_sym_function_header_repeat2] = STATE(60),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_LT_LBRACE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_LT] = ACTIONS(470),
    [anon_sym_COMMA] = ACTIONS(452),
    [anon_sym_RPAREN] = ACTIONS(452),
    [anon_sym_align] = ACTIONS(472),
    [anon_sym_alignstack] = ACTIONS(474),
    [anon_sym_allocsize] = ACTIONS(474),
    [anon_sym_alwaysinline] = ACTIONS(474),
    [anon_sym_builtin] = ACTIONS(474),
    [anon_sym_cold] = ACTIONS(474),
    [anon_sym_convergent] = ACTIONS(474),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(474),
    [anon_sym_hot] = ACTIONS(474),
    [anon_sym_inaccessiblememonly] = ACTIONS(474),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(474),
    [anon_sym_inlinehint] = ACTIONS(474),
    [anon_sym_jumptable] = ACTIONS(474),
    [anon_sym_minsize] = ACTIONS(474),
    [anon_sym_naked] = ACTIONS(474),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(474),
    [anon_sym_nobuiltin] = ACTIONS(474),
    [anon_sym_noduplicate] = ACTIONS(474),
    [anon_sym_nofree] = ACTIONS(474),
    [anon_sym_noimplicitfloat] = ACTIONS(474),
    [anon_sym_noinline] = ACTIONS(474),
    [anon_sym_nomerge] = ACTIONS(474),
    [anon_sym_nonlazybind] = ACTIONS(474),
    [anon_sym_noprofile] = ACTIONS(474),
    [anon_sym_noredzone] = ACTIONS(474),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(474),
    [anon_sym_noreturn] = ACTIONS(474),
    [anon_sym_norecurse] = ACTIONS(474),
    [anon_sym_willreturn] = ACTIONS(474),
    [anon_sym_nosync] = ACTIONS(474),
    [anon_sym_nounwind] = ACTIONS(474),
    [anon_sym_nocallback] = ACTIONS(474),
    [anon_sym_nosanitize_coverage] = ACTIONS(474),
    [anon_sym_null_pointer_is_valid] = ACTIONS(474),
    [anon_sym_optforfuzzing] = ACTIONS(474),
    [anon_sym_optnone] = ACTIONS(474),
    [anon_sym_optsize] = ACTIONS(474),
    [anon_sym_readnone] = ACTIONS(474),
    [anon_sym_readonly] = ACTIONS(474),
    [anon_sym_writeonly] = ACTIONS(474),
    [anon_sym_argmemonly] = ACTIONS(474),
    [anon_sym_returns_twice] = ACTIONS(474),
    [anon_sym_safestack] = ACTIONS(474),
    [anon_sym_sanitize_address] = ACTIONS(474),
    [anon_sym_sanitize_memory] = ACTIONS(474),
    [anon_sym_sanitize_thread] = ACTIONS(474),
    [anon_sym_sanitize_hwaddress] = ACTIONS(474),
    [anon_sym_sanitize_memtag] = ACTIONS(474),
    [anon_sym_speculative_load_hardening] = ACTIONS(474),
    [anon_sym_speculatable] = ACTIONS(474),
    [anon_sym_ssp] = ACTIONS(476),
    [anon_sym_sspstrong] = ACTIONS(474),
    [anon_sym_sspreq] = ACTIONS(474),
    [anon_sym_strictfp] = ACTIONS(474),
    [anon_sym_nocf_check] = ACTIONS(474),
    [anon_sym_shadowcallstack] = ACTIONS(474),
    [anon_sym_mustprogress] = ACTIONS(474),
    [anon_sym_vscale_range] = ACTIONS(474),
    [anon_sym_preallocated] = ACTIONS(474),
    [anon_sym_zeroext] = ACTIONS(474),
    [anon_sym_signext] = ACTIONS(474),
    [anon_sym_inreg] = ACTIONS(474),
    [anon_sym_byval] = ACTIONS(474),
    [anon_sym_byref] = ACTIONS(474),
    [anon_sym_inalloca] = ACTIONS(474),
    [anon_sym_sret] = ACTIONS(474),
    [anon_sym_elementtype] = ACTIONS(474),
    [anon_sym_noalias] = ACTIONS(474),
    [anon_sym_nocapture] = ACTIONS(474),
    [anon_sym_nest] = ACTIONS(474),
    [anon_sym_returned] = ACTIONS(474),
    [anon_sym_nonnull] = ACTIONS(474),
    [anon_sym_dereferenceable] = ACTIONS(476),
    [anon_sym_dereferenceable_or_null] = ACTIONS(474),
    [anon_sym_swiftself] = ACTIONS(474),
    [anon_sym_swiftasync] = ACTIONS(474),
    [anon_sym_swifterror] = ACTIONS(474),
    [anon_sym_immarg] = ACTIONS(474),
    [anon_sym_noundef] = ACTIONS(474),
    [anon_sym_uwtable] = ACTIONS(478),
    [anon_sym_memory] = ACTIONS(480),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(104),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(112),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [60] = {
    [sym_number] = STATE(92),
    [sym_var] = STATE(92),
    [sym_linkage] = STATE(817),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_param_or_return_attrs] = STATE(200),
    [sym_attribute_name] = STATE(225),
    [sym_uwtable] = STATE(216),
    [sym_memory_attribute] = STATE(216),
    [sym_value] = STATE(1529),
    [sym__primitive_value] = STATE(92),
    [sym_struct_value] = STATE(92),
    [sym_packed_struct_value] = STATE(92),
    [sym_array_value] = STATE(92),
    [sym_vector_value] = STATE(92),
    [sym_blockaddress] = STATE(92),
    [sym_constant_expr] = STATE(92),
    [sym_constant_cast] = STATE(87),
    [sym_constant_getelementptr] = STATE(87),
    [sym_constant_select] = STATE(87),
    [sym_constant_icmp] = STATE(87),
    [sym_constant_fcmp] = STATE(87),
    [sym_constant_extractelement] = STATE(87),
    [sym_constant_insertelement] = STATE(87),
    [sym_constant_shufflevector] = STATE(87),
    [sym_constant_extractvalue] = STATE(87),
    [sym_constant_insertvalue] = STATE(87),
    [sym_constant_fneg] = STATE(87),
    [sym_constant_bin_op] = STATE(87),
    [sym_bin_op_keyword] = STATE(1122),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1597),
    [aux_sym_function_header_repeat1] = STATE(817),
    [aux_sym_function_header_repeat2] = STATE(200),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_LT_LBRACE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_LT] = ACTIONS(470),
    [anon_sym_COMMA] = ACTIONS(482),
    [anon_sym_RPAREN] = ACTIONS(482),
    [anon_sym_align] = ACTIONS(472),
    [anon_sym_alignstack] = ACTIONS(474),
    [anon_sym_allocsize] = ACTIONS(474),
    [anon_sym_alwaysinline] = ACTIONS(474),
    [anon_sym_builtin] = ACTIONS(474),
    [anon_sym_cold] = ACTIONS(474),
    [anon_sym_convergent] = ACTIONS(474),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(474),
    [anon_sym_hot] = ACTIONS(474),
    [anon_sym_inaccessiblememonly] = ACTIONS(474),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(474),
    [anon_sym_inlinehint] = ACTIONS(474),
    [anon_sym_jumptable] = ACTIONS(474),
    [anon_sym_minsize] = ACTIONS(474),
    [anon_sym_naked] = ACTIONS(474),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(474),
    [anon_sym_nobuiltin] = ACTIONS(474),
    [anon_sym_noduplicate] = ACTIONS(474),
    [anon_sym_nofree] = ACTIONS(474),
    [anon_sym_noimplicitfloat] = ACTIONS(474),
    [anon_sym_noinline] = ACTIONS(474),
    [anon_sym_nomerge] = ACTIONS(474),
    [anon_sym_nonlazybind] = ACTIONS(474),
    [anon_sym_noprofile] = ACTIONS(474),
    [anon_sym_noredzone] = ACTIONS(474),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(474),
    [anon_sym_noreturn] = ACTIONS(474),
    [anon_sym_norecurse] = ACTIONS(474),
    [anon_sym_willreturn] = ACTIONS(474),
    [anon_sym_nosync] = ACTIONS(474),
    [anon_sym_nounwind] = ACTIONS(474),
    [anon_sym_nocallback] = ACTIONS(474),
    [anon_sym_nosanitize_coverage] = ACTIONS(474),
    [anon_sym_null_pointer_is_valid] = ACTIONS(474),
    [anon_sym_optforfuzzing] = ACTIONS(474),
    [anon_sym_optnone] = ACTIONS(474),
    [anon_sym_optsize] = ACTIONS(474),
    [anon_sym_readnone] = ACTIONS(474),
    [anon_sym_readonly] = ACTIONS(474),
    [anon_sym_writeonly] = ACTIONS(474),
    [anon_sym_argmemonly] = ACTIONS(474),
    [anon_sym_returns_twice] = ACTIONS(474),
    [anon_sym_safestack] = ACTIONS(474),
    [anon_sym_sanitize_address] = ACTIONS(474),
    [anon_sym_sanitize_memory] = ACTIONS(474),
    [anon_sym_sanitize_thread] = ACTIONS(474),
    [anon_sym_sanitize_hwaddress] = ACTIONS(474),
    [anon_sym_sanitize_memtag] = ACTIONS(474),
    [anon_sym_speculative_load_hardening] = ACTIONS(474),
    [anon_sym_speculatable] = ACTIONS(474),
    [anon_sym_ssp] = ACTIONS(476),
    [anon_sym_sspstrong] = ACTIONS(474),
    [anon_sym_sspreq] = ACTIONS(474),
    [anon_sym_strictfp] = ACTIONS(474),
    [anon_sym_nocf_check] = ACTIONS(474),
    [anon_sym_shadowcallstack] = ACTIONS(474),
    [anon_sym_mustprogress] = ACTIONS(474),
    [anon_sym_vscale_range] = ACTIONS(474),
    [anon_sym_preallocated] = ACTIONS(474),
    [anon_sym_zeroext] = ACTIONS(474),
    [anon_sym_signext] = ACTIONS(474),
    [anon_sym_inreg] = ACTIONS(474),
    [anon_sym_byval] = ACTIONS(474),
    [anon_sym_byref] = ACTIONS(474),
    [anon_sym_inalloca] = ACTIONS(474),
    [anon_sym_sret] = ACTIONS(474),
    [anon_sym_elementtype] = ACTIONS(474),
    [anon_sym_noalias] = ACTIONS(474),
    [anon_sym_nocapture] = ACTIONS(474),
    [anon_sym_nest] = ACTIONS(474),
    [anon_sym_returned] = ACTIONS(474),
    [anon_sym_nonnull] = ACTIONS(474),
    [anon_sym_dereferenceable] = ACTIONS(476),
    [anon_sym_dereferenceable_or_null] = ACTIONS(474),
    [anon_sym_swiftself] = ACTIONS(474),
    [anon_sym_swiftasync] = ACTIONS(474),
    [anon_sym_swifterror] = ACTIONS(474),
    [anon_sym_immarg] = ACTIONS(474),
    [anon_sym_noundef] = ACTIONS(474),
    [anon_sym_uwtable] = ACTIONS(478),
    [anon_sym_memory] = ACTIONS(480),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(104),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(112),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [61] = {
    [sym_addrspace] = STATE(1730),
    [sym_argument_list] = STATE(61),
    [aux_sym_type_repeat1] = STATE(1186),
    [aux_sym_type_repeat2] = STATE(61),
    [ts_builtin_sym_end] = ACTIONS(250),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(250),
    [sym_comdat_ref] = ACTIONS(250),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [aux_sym_metadata_ref_token1] = ACTIONS(250),
    [sym_summary_ref] = ACTIONS(250),
    [sym_string] = ACTIONS(250),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(250),
    [sym_float] = ACTIONS(250),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_target] = ACTIONS(250),
    [anon_sym_source_filename] = ACTIONS(250),
    [anon_sym_declare] = ACTIONS(250),
    [anon_sym_define] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(250),
    [anon_sym_private] = ACTIONS(250),
    [anon_sym_internal] = ACTIONS(250),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(250),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(250),
    [anon_sym_available_externally] = ACTIONS(250),
    [anon_sym_appending] = ACTIONS(250),
    [anon_sym_common] = ACTIONS(250),
    [anon_sym_extern_weak] = ACTIONS(250),
    [anon_sym_external] = ACTIONS(250),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(250),
    [anon_sym_dso_preemptable] = ACTIONS(250),
    [anon_sym_default] = ACTIONS(250),
    [anon_sym_hidden] = ACTIONS(250),
    [anon_sym_protected] = ACTIONS(250),
    [anon_sym_dllimport] = ACTIONS(250),
    [anon_sym_dllexport] = ACTIONS(250),
    [anon_sym_STAR] = ACTIONS(484),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(257),
    [anon_sym_LPAREN] = ACTIONS(487),
    [anon_sym_RPAREN] = ACTIONS(250),
    [anon_sym_align] = ACTIONS(252),
    [anon_sym_section] = ACTIONS(250),
    [anon_sym_partition] = ACTIONS(250),
    [anon_sym_comdat] = ACTIONS(250),
    [anon_sym_gc] = ACTIONS(250),
    [anon_sym_prefix] = ACTIONS(250),
    [anon_sym_prologue] = ACTIONS(250),
    [anon_sym_personality] = ACTIONS(250),
    [anon_sym_alignstack] = ACTIONS(250),
    [anon_sym_allocsize] = ACTIONS(250),
    [anon_sym_alwaysinline] = ACTIONS(250),
    [anon_sym_builtin] = ACTIONS(250),
    [anon_sym_cold] = ACTIONS(250),
    [anon_sym_convergent] = ACTIONS(250),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(250),
    [anon_sym_hot] = ACTIONS(250),
    [anon_sym_inaccessiblememonly] = ACTIONS(250),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(250),
    [anon_sym_inlinehint] = ACTIONS(250),
    [anon_sym_jumptable] = ACTIONS(250),
    [anon_sym_minsize] = ACTIONS(250),
    [anon_sym_naked] = ACTIONS(250),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(250),
    [anon_sym_nobuiltin] = ACTIONS(250),
    [anon_sym_noduplicate] = ACTIONS(250),
    [anon_sym_nofree] = ACTIONS(250),
    [anon_sym_noimplicitfloat] = ACTIONS(250),
    [anon_sym_noinline] = ACTIONS(250),
    [anon_sym_nomerge] = ACTIONS(250),
    [anon_sym_nonlazybind] = ACTIONS(250),
    [anon_sym_noprofile] = ACTIONS(250),
    [anon_sym_noredzone] = ACTIONS(250),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(250),
    [anon_sym_noreturn] = ACTIONS(250),
    [anon_sym_norecurse] = ACTIONS(250),
    [anon_sym_willreturn] = ACTIONS(250),
    [anon_sym_nosync] = ACTIONS(250),
    [anon_sym_nounwind] = ACTIONS(250),
    [anon_sym_nocallback] = ACTIONS(250),
    [anon_sym_nosanitize_coverage] = ACTIONS(250),
    [anon_sym_null_pointer_is_valid] = ACTIONS(250),
    [anon_sym_optforfuzzing] = ACTIONS(250),
    [anon_sym_optnone] = ACTIONS(250),
    [anon_sym_optsize] = ACTIONS(250),
    [anon_sym_readnone] = ACTIONS(250),
    [anon_sym_readonly] = ACTIONS(250),
    [anon_sym_writeonly] = ACTIONS(250),
    [anon_sym_argmemonly] = ACTIONS(250),
    [anon_sym_returns_twice] = ACTIONS(250),
    [anon_sym_safestack] = ACTIONS(250),
    [anon_sym_sanitize_address] = ACTIONS(250),
    [anon_sym_sanitize_memory] = ACTIONS(250),
    [anon_sym_sanitize_thread] = ACTIONS(250),
    [anon_sym_sanitize_hwaddress] = ACTIONS(250),
    [anon_sym_sanitize_memtag] = ACTIONS(250),
    [anon_sym_speculative_load_hardening] = ACTIONS(250),
    [anon_sym_speculatable] = ACTIONS(250),
    [anon_sym_ssp] = ACTIONS(252),
    [anon_sym_sspstrong] = ACTIONS(250),
    [anon_sym_sspreq] = ACTIONS(250),
    [anon_sym_strictfp] = ACTIONS(250),
    [anon_sym_nocf_check] = ACTIONS(250),
    [anon_sym_shadowcallstack] = ACTIONS(250),
    [anon_sym_mustprogress] = ACTIONS(250),
    [anon_sym_vscale_range] = ACTIONS(250),
    [anon_sym_preallocated] = ACTIONS(250),
    [anon_sym_zeroext] = ACTIONS(250),
    [anon_sym_signext] = ACTIONS(250),
    [anon_sym_inreg] = ACTIONS(250),
    [anon_sym_byval] = ACTIONS(250),
    [anon_sym_byref] = ACTIONS(250),
    [anon_sym_inalloca] = ACTIONS(250),
    [anon_sym_sret] = ACTIONS(250),
    [anon_sym_elementtype] = ACTIONS(250),
    [anon_sym_noalias] = ACTIONS(250),
    [anon_sym_nocapture] = ACTIONS(250),
    [anon_sym_nest] = ACTIONS(250),
    [anon_sym_returned] = ACTIONS(250),
    [anon_sym_nonnull] = ACTIONS(250),
    [anon_sym_dereferenceable] = ACTIONS(252),
    [anon_sym_dereferenceable_or_null] = ACTIONS(250),
    [anon_sym_swiftself] = ACTIONS(250),
    [anon_sym_swiftasync] = ACTIONS(250),
    [anon_sym_swifterror] = ACTIONS(250),
    [anon_sym_immarg] = ACTIONS(250),
    [anon_sym_noundef] = ACTIONS(250),
    [anon_sym_uwtable] = ACTIONS(250),
    [anon_sym_memory] = ACTIONS(250),
    [anon_sym_none] = ACTIONS(250),
    [anon_sym_extractelement] = ACTIONS(250),
    [anon_sym_insertelement] = ACTIONS(250),
    [anon_sym_select] = ACTIONS(250),
    [anon_sym_shufflevector] = ACTIONS(250),
    [anon_sym_fneg] = ACTIONS(250),
    [anon_sym_to] = ACTIONS(250),
    [anon_sym_icmp] = ACTIONS(250),
    [anon_sym_fcmp] = ACTIONS(250),
    [anon_sym_getelementptr] = ACTIONS(250),
    [anon_sym_extractvalue] = ACTIONS(250),
    [anon_sym_insertvalue] = ACTIONS(250),
    [anon_sym_true] = ACTIONS(250),
    [anon_sym_false] = ACTIONS(250),
    [anon_sym_null] = ACTIONS(252),
    [anon_sym_undef] = ACTIONS(250),
    [anon_sym_poison] = ACTIONS(250),
    [anon_sym_zeroinitializer] = ACTIONS(250),
    [anon_sym_blockaddress] = ACTIONS(250),
    [anon_sym_mul] = ACTIONS(250),
    [anon_sym_urem] = ACTIONS(250),
    [anon_sym_srem] = ACTIONS(250),
    [anon_sym_shl] = ACTIONS(250),
    [anon_sym_udiv] = ACTIONS(250),
    [anon_sym_sdiv] = ACTIONS(250),
    [anon_sym_lshr] = ACTIONS(250),
    [anon_sym_ashr] = ACTIONS(250),
    [anon_sym_fmul] = ACTIONS(250),
    [anon_sym_fdiv] = ACTIONS(250),
    [anon_sym_frem] = ACTIONS(250),
    [anon_sym_xchg] = ACTIONS(250),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(250),
    [anon_sym_and] = ACTIONS(250),
    [anon_sym_nand] = ACTIONS(250),
    [anon_sym_or] = ACTIONS(250),
    [anon_sym_xor] = ACTIONS(250),
    [anon_sym_max] = ACTIONS(250),
    [anon_sym_min] = ACTIONS(252),
    [anon_sym_umax] = ACTIONS(250),
    [anon_sym_umin] = ACTIONS(250),
    [anon_sym_fadd] = ACTIONS(250),
    [anon_sym_fsub] = ACTIONS(250),
    [anon_sym_bitcast] = ACTIONS(250),
    [anon_sym_trunc] = ACTIONS(250),
    [anon_sym_zext] = ACTIONS(250),
    [anon_sym_sext] = ACTIONS(250),
    [anon_sym_fptrunc] = ACTIONS(250),
    [anon_sym_fpext] = ACTIONS(250),
    [anon_sym_addrspacecast] = ACTIONS(250),
    [anon_sym_uitofp] = ACTIONS(250),
    [anon_sym_sitofp] = ACTIONS(250),
    [anon_sym_fptoui] = ACTIONS(250),
    [anon_sym_fptosi] = ACTIONS(250),
    [anon_sym_inttoptr] = ACTIONS(250),
    [anon_sym_ptrtoint] = ACTIONS(250),
    [anon_sym_uselistorder] = ACTIONS(252),
    [anon_sym_uselistorder_bb] = ACTIONS(250),
    [anon_sym_module] = ACTIONS(250),
    [anon_sym_attributes] = ACTIONS(250),
  },
  [62] = {
    [sym_addrspace] = STATE(79),
    [sym_argument_list] = STATE(63),
    [aux_sym_type_repeat1] = STATE(65),
    [aux_sym_type_repeat2] = STATE(63),
    [ts_builtin_sym_end] = ACTIONS(234),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(234),
    [sym_comdat_ref] = ACTIONS(234),
    [sym_global_var] = ACTIONS(234),
    [sym_local_var] = ACTIONS(234),
    [aux_sym_metadata_ref_token1] = ACTIONS(234),
    [sym_summary_ref] = ACTIONS(234),
    [sym_string] = ACTIONS(234),
    [aux_sym_number_token1] = ACTIONS(236),
    [aux_sym_number_token2] = ACTIONS(234),
    [sym_float] = ACTIONS(234),
    [sym_cstring] = ACTIONS(234),
    [anon_sym_target] = ACTIONS(234),
    [anon_sym_source_filename] = ACTIONS(234),
    [anon_sym_declare] = ACTIONS(234),
    [anon_sym_define] = ACTIONS(234),
    [anon_sym_no_cfi] = ACTIONS(234),
    [anon_sym_private] = ACTIONS(234),
    [anon_sym_internal] = ACTIONS(234),
    [anon_sym_weak] = ACTIONS(236),
    [anon_sym_weak_odr] = ACTIONS(234),
    [anon_sym_linkonce] = ACTIONS(236),
    [anon_sym_linkonce_odr] = ACTIONS(234),
    [anon_sym_available_externally] = ACTIONS(234),
    [anon_sym_appending] = ACTIONS(234),
    [anon_sym_common] = ACTIONS(234),
    [anon_sym_extern_weak] = ACTIONS(234),
    [anon_sym_external] = ACTIONS(234),
    [anon_sym_dso_local] = ACTIONS(236),
    [anon_sym_dso_local_equivalent] = ACTIONS(234),
    [anon_sym_dso_preemptable] = ACTIONS(234),
    [anon_sym_default] = ACTIONS(234),
    [anon_sym_hidden] = ACTIONS(234),
    [anon_sym_protected] = ACTIONS(234),
    [anon_sym_dllimport] = ACTIONS(234),
    [anon_sym_dllexport] = ACTIONS(234),
    [anon_sym_STAR] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(234),
    [anon_sym_RBRACE] = ACTIONS(234),
    [anon_sym_LT_LBRACE] = ACTIONS(234),
    [anon_sym_LBRACK] = ACTIONS(234),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_COMMA] = ACTIONS(234),
    [anon_sym_addrspace] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_RPAREN] = ACTIONS(234),
    [anon_sym_align] = ACTIONS(236),
    [anon_sym_section] = ACTIONS(234),
    [anon_sym_partition] = ACTIONS(234),
    [anon_sym_comdat] = ACTIONS(234),
    [anon_sym_gc] = ACTIONS(234),
    [anon_sym_prefix] = ACTIONS(234),
    [anon_sym_prologue] = ACTIONS(234),
    [anon_sym_personality] = ACTIONS(234),
    [anon_sym_alignstack] = ACTIONS(234),
    [anon_sym_allocsize] = ACTIONS(234),
    [anon_sym_alwaysinline] = ACTIONS(234),
    [anon_sym_builtin] = ACTIONS(234),
    [anon_sym_cold] = ACTIONS(234),
    [anon_sym_convergent] = ACTIONS(234),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(234),
    [anon_sym_hot] = ACTIONS(234),
    [anon_sym_inaccessiblememonly] = ACTIONS(234),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(234),
    [anon_sym_inlinehint] = ACTIONS(234),
    [anon_sym_jumptable] = ACTIONS(234),
    [anon_sym_minsize] = ACTIONS(234),
    [anon_sym_naked] = ACTIONS(234),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(234),
    [anon_sym_nobuiltin] = ACTIONS(234),
    [anon_sym_noduplicate] = ACTIONS(234),
    [anon_sym_nofree] = ACTIONS(234),
    [anon_sym_noimplicitfloat] = ACTIONS(234),
    [anon_sym_noinline] = ACTIONS(234),
    [anon_sym_nomerge] = ACTIONS(234),
    [anon_sym_nonlazybind] = ACTIONS(234),
    [anon_sym_noprofile] = ACTIONS(234),
    [anon_sym_noredzone] = ACTIONS(234),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(234),
    [anon_sym_noreturn] = ACTIONS(234),
    [anon_sym_norecurse] = ACTIONS(234),
    [anon_sym_willreturn] = ACTIONS(234),
    [anon_sym_nosync] = ACTIONS(234),
    [anon_sym_nounwind] = ACTIONS(234),
    [anon_sym_nocallback] = ACTIONS(234),
    [anon_sym_nosanitize_coverage] = ACTIONS(234),
    [anon_sym_null_pointer_is_valid] = ACTIONS(234),
    [anon_sym_optforfuzzing] = ACTIONS(234),
    [anon_sym_optnone] = ACTIONS(234),
    [anon_sym_optsize] = ACTIONS(234),
    [anon_sym_readnone] = ACTIONS(234),
    [anon_sym_readonly] = ACTIONS(234),
    [anon_sym_writeonly] = ACTIONS(234),
    [anon_sym_argmemonly] = ACTIONS(234),
    [anon_sym_returns_twice] = ACTIONS(234),
    [anon_sym_safestack] = ACTIONS(234),
    [anon_sym_sanitize_address] = ACTIONS(234),
    [anon_sym_sanitize_memory] = ACTIONS(234),
    [anon_sym_sanitize_thread] = ACTIONS(234),
    [anon_sym_sanitize_hwaddress] = ACTIONS(234),
    [anon_sym_sanitize_memtag] = ACTIONS(234),
    [anon_sym_speculative_load_hardening] = ACTIONS(234),
    [anon_sym_speculatable] = ACTIONS(234),
    [anon_sym_ssp] = ACTIONS(236),
    [anon_sym_sspstrong] = ACTIONS(234),
    [anon_sym_sspreq] = ACTIONS(234),
    [anon_sym_strictfp] = ACTIONS(234),
    [anon_sym_nocf_check] = ACTIONS(234),
    [anon_sym_shadowcallstack] = ACTIONS(234),
    [anon_sym_mustprogress] = ACTIONS(234),
    [anon_sym_vscale_range] = ACTIONS(234),
    [anon_sym_preallocated] = ACTIONS(234),
    [anon_sym_zeroext] = ACTIONS(234),
    [anon_sym_signext] = ACTIONS(234),
    [anon_sym_inreg] = ACTIONS(234),
    [anon_sym_byval] = ACTIONS(234),
    [anon_sym_byref] = ACTIONS(234),
    [anon_sym_inalloca] = ACTIONS(234),
    [anon_sym_sret] = ACTIONS(234),
    [anon_sym_elementtype] = ACTIONS(234),
    [anon_sym_noalias] = ACTIONS(234),
    [anon_sym_nocapture] = ACTIONS(234),
    [anon_sym_nest] = ACTIONS(234),
    [anon_sym_returned] = ACTIONS(234),
    [anon_sym_nonnull] = ACTIONS(234),
    [anon_sym_dereferenceable] = ACTIONS(236),
    [anon_sym_dereferenceable_or_null] = ACTIONS(234),
    [anon_sym_swiftself] = ACTIONS(234),
    [anon_sym_swiftasync] = ACTIONS(234),
    [anon_sym_swifterror] = ACTIONS(234),
    [anon_sym_immarg] = ACTIONS(234),
    [anon_sym_noundef] = ACTIONS(234),
    [anon_sym_uwtable] = ACTIONS(234),
    [anon_sym_memory] = ACTIONS(234),
    [anon_sym_none] = ACTIONS(234),
    [anon_sym_extractelement] = ACTIONS(234),
    [anon_sym_insertelement] = ACTIONS(234),
    [anon_sym_select] = ACTIONS(234),
    [anon_sym_shufflevector] = ACTIONS(234),
    [anon_sym_fneg] = ACTIONS(234),
    [anon_sym_to] = ACTIONS(234),
    [anon_sym_icmp] = ACTIONS(234),
    [anon_sym_fcmp] = ACTIONS(234),
    [anon_sym_getelementptr] = ACTIONS(234),
    [anon_sym_extractvalue] = ACTIONS(234),
    [anon_sym_insertvalue] = ACTIONS(234),
    [anon_sym_true] = ACTIONS(234),
    [anon_sym_false] = ACTIONS(234),
    [anon_sym_null] = ACTIONS(236),
    [anon_sym_undef] = ACTIONS(234),
    [anon_sym_poison] = ACTIONS(234),
    [anon_sym_zeroinitializer] = ACTIONS(234),
    [anon_sym_blockaddress] = ACTIONS(234),
    [anon_sym_mul] = ACTIONS(234),
    [anon_sym_urem] = ACTIONS(234),
    [anon_sym_srem] = ACTIONS(234),
    [anon_sym_shl] = ACTIONS(234),
    [anon_sym_udiv] = ACTIONS(234),
    [anon_sym_sdiv] = ACTIONS(234),
    [anon_sym_lshr] = ACTIONS(234),
    [anon_sym_ashr] = ACTIONS(234),
    [anon_sym_fmul] = ACTIONS(234),
    [anon_sym_fdiv] = ACTIONS(234),
    [anon_sym_frem] = ACTIONS(234),
    [anon_sym_xchg] = ACTIONS(234),
    [anon_sym_add] = ACTIONS(236),
    [anon_sym_sub] = ACTIONS(234),
    [anon_sym_and] = ACTIONS(234),
    [anon_sym_nand] = ACTIONS(234),
    [anon_sym_or] = ACTIONS(234),
    [anon_sym_xor] = ACTIONS(234),
    [anon_sym_max] = ACTIONS(234),
    [anon_sym_min] = ACTIONS(236),
    [anon_sym_umax] = ACTIONS(234),
    [anon_sym_umin] = ACTIONS(234),
    [anon_sym_fadd] = ACTIONS(234),
    [anon_sym_fsub] = ACTIONS(234),
    [anon_sym_bitcast] = ACTIONS(234),
    [anon_sym_trunc] = ACTIONS(234),
    [anon_sym_zext] = ACTIONS(234),
    [anon_sym_sext] = ACTIONS(234),
    [anon_sym_fptrunc] = ACTIONS(234),
    [anon_sym_fpext] = ACTIONS(234),
    [anon_sym_addrspacecast] = ACTIONS(234),
    [anon_sym_uitofp] = ACTIONS(234),
    [anon_sym_sitofp] = ACTIONS(234),
    [anon_sym_fptoui] = ACTIONS(234),
    [anon_sym_fptosi] = ACTIONS(234),
    [anon_sym_inttoptr] = ACTIONS(234),
    [anon_sym_ptrtoint] = ACTIONS(234),
    [anon_sym_uselistorder] = ACTIONS(236),
    [anon_sym_uselistorder_bb] = ACTIONS(234),
    [anon_sym_module] = ACTIONS(234),
    [anon_sym_attributes] = ACTIONS(234),
  },
  [63] = {
    [sym_addrspace] = STATE(82),
    [sym_argument_list] = STATE(61),
    [aux_sym_type_repeat1] = STATE(64),
    [aux_sym_type_repeat2] = STATE(61),
    [ts_builtin_sym_end] = ACTIONS(244),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(244),
    [sym_comdat_ref] = ACTIONS(244),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [aux_sym_metadata_ref_token1] = ACTIONS(244),
    [sym_summary_ref] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_target] = ACTIONS(244),
    [anon_sym_source_filename] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(244),
    [anon_sym_define] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(496),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_RPAREN] = ACTIONS(244),
    [anon_sym_align] = ACTIONS(246),
    [anon_sym_section] = ACTIONS(244),
    [anon_sym_partition] = ACTIONS(244),
    [anon_sym_comdat] = ACTIONS(244),
    [anon_sym_gc] = ACTIONS(244),
    [anon_sym_prefix] = ACTIONS(244),
    [anon_sym_prologue] = ACTIONS(244),
    [anon_sym_personality] = ACTIONS(244),
    [anon_sym_alignstack] = ACTIONS(244),
    [anon_sym_allocsize] = ACTIONS(244),
    [anon_sym_alwaysinline] = ACTIONS(244),
    [anon_sym_builtin] = ACTIONS(244),
    [anon_sym_cold] = ACTIONS(244),
    [anon_sym_convergent] = ACTIONS(244),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(244),
    [anon_sym_hot] = ACTIONS(244),
    [anon_sym_inaccessiblememonly] = ACTIONS(244),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(244),
    [anon_sym_inlinehint] = ACTIONS(244),
    [anon_sym_jumptable] = ACTIONS(244),
    [anon_sym_minsize] = ACTIONS(244),
    [anon_sym_naked] = ACTIONS(244),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(244),
    [anon_sym_nobuiltin] = ACTIONS(244),
    [anon_sym_noduplicate] = ACTIONS(244),
    [anon_sym_nofree] = ACTIONS(244),
    [anon_sym_noimplicitfloat] = ACTIONS(244),
    [anon_sym_noinline] = ACTIONS(244),
    [anon_sym_nomerge] = ACTIONS(244),
    [anon_sym_nonlazybind] = ACTIONS(244),
    [anon_sym_noprofile] = ACTIONS(244),
    [anon_sym_noredzone] = ACTIONS(244),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(244),
    [anon_sym_noreturn] = ACTIONS(244),
    [anon_sym_norecurse] = ACTIONS(244),
    [anon_sym_willreturn] = ACTIONS(244),
    [anon_sym_nosync] = ACTIONS(244),
    [anon_sym_nounwind] = ACTIONS(244),
    [anon_sym_nocallback] = ACTIONS(244),
    [anon_sym_nosanitize_coverage] = ACTIONS(244),
    [anon_sym_null_pointer_is_valid] = ACTIONS(244),
    [anon_sym_optforfuzzing] = ACTIONS(244),
    [anon_sym_optnone] = ACTIONS(244),
    [anon_sym_optsize] = ACTIONS(244),
    [anon_sym_readnone] = ACTIONS(244),
    [anon_sym_readonly] = ACTIONS(244),
    [anon_sym_writeonly] = ACTIONS(244),
    [anon_sym_argmemonly] = ACTIONS(244),
    [anon_sym_returns_twice] = ACTIONS(244),
    [anon_sym_safestack] = ACTIONS(244),
    [anon_sym_sanitize_address] = ACTIONS(244),
    [anon_sym_sanitize_memory] = ACTIONS(244),
    [anon_sym_sanitize_thread] = ACTIONS(244),
    [anon_sym_sanitize_hwaddress] = ACTIONS(244),
    [anon_sym_sanitize_memtag] = ACTIONS(244),
    [anon_sym_speculative_load_hardening] = ACTIONS(244),
    [anon_sym_speculatable] = ACTIONS(244),
    [anon_sym_ssp] = ACTIONS(246),
    [anon_sym_sspstrong] = ACTIONS(244),
    [anon_sym_sspreq] = ACTIONS(244),
    [anon_sym_strictfp] = ACTIONS(244),
    [anon_sym_nocf_check] = ACTIONS(244),
    [anon_sym_shadowcallstack] = ACTIONS(244),
    [anon_sym_mustprogress] = ACTIONS(244),
    [anon_sym_vscale_range] = ACTIONS(244),
    [anon_sym_preallocated] = ACTIONS(244),
    [anon_sym_zeroext] = ACTIONS(244),
    [anon_sym_signext] = ACTIONS(244),
    [anon_sym_inreg] = ACTIONS(244),
    [anon_sym_byval] = ACTIONS(244),
    [anon_sym_byref] = ACTIONS(244),
    [anon_sym_inalloca] = ACTIONS(244),
    [anon_sym_sret] = ACTIONS(244),
    [anon_sym_elementtype] = ACTIONS(244),
    [anon_sym_noalias] = ACTIONS(244),
    [anon_sym_nocapture] = ACTIONS(244),
    [anon_sym_nest] = ACTIONS(244),
    [anon_sym_returned] = ACTIONS(244),
    [anon_sym_nonnull] = ACTIONS(244),
    [anon_sym_dereferenceable] = ACTIONS(246),
    [anon_sym_dereferenceable_or_null] = ACTIONS(244),
    [anon_sym_swiftself] = ACTIONS(244),
    [anon_sym_swiftasync] = ACTIONS(244),
    [anon_sym_swifterror] = ACTIONS(244),
    [anon_sym_immarg] = ACTIONS(244),
    [anon_sym_noundef] = ACTIONS(244),
    [anon_sym_uwtable] = ACTIONS(244),
    [anon_sym_memory] = ACTIONS(244),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_to] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
    [anon_sym_uselistorder] = ACTIONS(246),
    [anon_sym_uselistorder_bb] = ACTIONS(244),
    [anon_sym_module] = ACTIONS(244),
    [anon_sym_attributes] = ACTIONS(244),
  },
  [64] = {
    [sym_addrspace] = STATE(81),
    [sym_argument_list] = STATE(77),
    [aux_sym_type_repeat1] = STATE(68),
    [ts_builtin_sym_end] = ACTIONS(263),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(263),
    [sym_comdat_ref] = ACTIONS(263),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [aux_sym_metadata_ref_token1] = ACTIONS(263),
    [sym_summary_ref] = ACTIONS(263),
    [sym_string] = ACTIONS(263),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(263),
    [sym_float] = ACTIONS(263),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_target] = ACTIONS(263),
    [anon_sym_source_filename] = ACTIONS(263),
    [anon_sym_declare] = ACTIONS(263),
    [anon_sym_define] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(263),
    [anon_sym_private] = ACTIONS(263),
    [anon_sym_internal] = ACTIONS(263),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(263),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(263),
    [anon_sym_available_externally] = ACTIONS(263),
    [anon_sym_appending] = ACTIONS(263),
    [anon_sym_common] = ACTIONS(263),
    [anon_sym_extern_weak] = ACTIONS(263),
    [anon_sym_external] = ACTIONS(263),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(263),
    [anon_sym_dso_preemptable] = ACTIONS(263),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_hidden] = ACTIONS(263),
    [anon_sym_protected] = ACTIONS(263),
    [anon_sym_dllimport] = ACTIONS(263),
    [anon_sym_dllexport] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(498),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_addrspace] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_RPAREN] = ACTIONS(263),
    [anon_sym_align] = ACTIONS(265),
    [anon_sym_section] = ACTIONS(263),
    [anon_sym_partition] = ACTIONS(263),
    [anon_sym_comdat] = ACTIONS(263),
    [anon_sym_gc] = ACTIONS(263),
    [anon_sym_prefix] = ACTIONS(263),
    [anon_sym_prologue] = ACTIONS(263),
    [anon_sym_personality] = ACTIONS(263),
    [anon_sym_alignstack] = ACTIONS(263),
    [anon_sym_allocsize] = ACTIONS(263),
    [anon_sym_alwaysinline] = ACTIONS(263),
    [anon_sym_builtin] = ACTIONS(263),
    [anon_sym_cold] = ACTIONS(263),
    [anon_sym_convergent] = ACTIONS(263),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(263),
    [anon_sym_hot] = ACTIONS(263),
    [anon_sym_inaccessiblememonly] = ACTIONS(263),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(263),
    [anon_sym_inlinehint] = ACTIONS(263),
    [anon_sym_jumptable] = ACTIONS(263),
    [anon_sym_minsize] = ACTIONS(263),
    [anon_sym_naked] = ACTIONS(263),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(263),
    [anon_sym_nobuiltin] = ACTIONS(263),
    [anon_sym_noduplicate] = ACTIONS(263),
    [anon_sym_nofree] = ACTIONS(263),
    [anon_sym_noimplicitfloat] = ACTIONS(263),
    [anon_sym_noinline] = ACTIONS(263),
    [anon_sym_nomerge] = ACTIONS(263),
    [anon_sym_nonlazybind] = ACTIONS(263),
    [anon_sym_noprofile] = ACTIONS(263),
    [anon_sym_noredzone] = ACTIONS(263),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(263),
    [anon_sym_noreturn] = ACTIONS(263),
    [anon_sym_norecurse] = ACTIONS(263),
    [anon_sym_willreturn] = ACTIONS(263),
    [anon_sym_nosync] = ACTIONS(263),
    [anon_sym_nounwind] = ACTIONS(263),
    [anon_sym_nocallback] = ACTIONS(263),
    [anon_sym_nosanitize_coverage] = ACTIONS(263),
    [anon_sym_null_pointer_is_valid] = ACTIONS(263),
    [anon_sym_optforfuzzing] = ACTIONS(263),
    [anon_sym_optnone] = ACTIONS(263),
    [anon_sym_optsize] = ACTIONS(263),
    [anon_sym_readnone] = ACTIONS(263),
    [anon_sym_readonly] = ACTIONS(263),
    [anon_sym_writeonly] = ACTIONS(263),
    [anon_sym_argmemonly] = ACTIONS(263),
    [anon_sym_returns_twice] = ACTIONS(263),
    [anon_sym_safestack] = ACTIONS(263),
    [anon_sym_sanitize_address] = ACTIONS(263),
    [anon_sym_sanitize_memory] = ACTIONS(263),
    [anon_sym_sanitize_thread] = ACTIONS(263),
    [anon_sym_sanitize_hwaddress] = ACTIONS(263),
    [anon_sym_sanitize_memtag] = ACTIONS(263),
    [anon_sym_speculative_load_hardening] = ACTIONS(263),
    [anon_sym_speculatable] = ACTIONS(263),
    [anon_sym_ssp] = ACTIONS(265),
    [anon_sym_sspstrong] = ACTIONS(263),
    [anon_sym_sspreq] = ACTIONS(263),
    [anon_sym_strictfp] = ACTIONS(263),
    [anon_sym_nocf_check] = ACTIONS(263),
    [anon_sym_shadowcallstack] = ACTIONS(263),
    [anon_sym_mustprogress] = ACTIONS(263),
    [anon_sym_vscale_range] = ACTIONS(263),
    [anon_sym_preallocated] = ACTIONS(263),
    [anon_sym_zeroext] = ACTIONS(263),
    [anon_sym_signext] = ACTIONS(263),
    [anon_sym_inreg] = ACTIONS(263),
    [anon_sym_byval] = ACTIONS(263),
    [anon_sym_byref] = ACTIONS(263),
    [anon_sym_inalloca] = ACTIONS(263),
    [anon_sym_sret] = ACTIONS(263),
    [anon_sym_elementtype] = ACTIONS(263),
    [anon_sym_noalias] = ACTIONS(263),
    [anon_sym_nocapture] = ACTIONS(263),
    [anon_sym_nest] = ACTIONS(263),
    [anon_sym_returned] = ACTIONS(263),
    [anon_sym_nonnull] = ACTIONS(263),
    [anon_sym_dereferenceable] = ACTIONS(265),
    [anon_sym_dereferenceable_or_null] = ACTIONS(263),
    [anon_sym_swiftself] = ACTIONS(263),
    [anon_sym_swiftasync] = ACTIONS(263),
    [anon_sym_swifterror] = ACTIONS(263),
    [anon_sym_immarg] = ACTIONS(263),
    [anon_sym_noundef] = ACTIONS(263),
    [anon_sym_uwtable] = ACTIONS(263),
    [anon_sym_memory] = ACTIONS(263),
    [anon_sym_none] = ACTIONS(263),
    [anon_sym_extractelement] = ACTIONS(263),
    [anon_sym_insertelement] = ACTIONS(263),
    [anon_sym_select] = ACTIONS(263),
    [anon_sym_shufflevector] = ACTIONS(263),
    [anon_sym_fneg] = ACTIONS(263),
    [anon_sym_to] = ACTIONS(263),
    [anon_sym_icmp] = ACTIONS(263),
    [anon_sym_fcmp] = ACTIONS(263),
    [anon_sym_getelementptr] = ACTIONS(263),
    [anon_sym_extractvalue] = ACTIONS(263),
    [anon_sym_insertvalue] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(263),
    [anon_sym_false] = ACTIONS(263),
    [anon_sym_null] = ACTIONS(265),
    [anon_sym_undef] = ACTIONS(263),
    [anon_sym_poison] = ACTIONS(263),
    [anon_sym_zeroinitializer] = ACTIONS(263),
    [anon_sym_blockaddress] = ACTIONS(263),
    [anon_sym_mul] = ACTIONS(263),
    [anon_sym_urem] = ACTIONS(263),
    [anon_sym_srem] = ACTIONS(263),
    [anon_sym_shl] = ACTIONS(263),
    [anon_sym_udiv] = ACTIONS(263),
    [anon_sym_sdiv] = ACTIONS(263),
    [anon_sym_lshr] = ACTIONS(263),
    [anon_sym_ashr] = ACTIONS(263),
    [anon_sym_fmul] = ACTIONS(263),
    [anon_sym_fdiv] = ACTIONS(263),
    [anon_sym_frem] = ACTIONS(263),
    [anon_sym_xchg] = ACTIONS(263),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(263),
    [anon_sym_and] = ACTIONS(263),
    [anon_sym_nand] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(263),
    [anon_sym_xor] = ACTIONS(263),
    [anon_sym_max] = ACTIONS(263),
    [anon_sym_min] = ACTIONS(265),
    [anon_sym_umax] = ACTIONS(263),
    [anon_sym_umin] = ACTIONS(263),
    [anon_sym_fadd] = ACTIONS(263),
    [anon_sym_fsub] = ACTIONS(263),
    [anon_sym_bitcast] = ACTIONS(263),
    [anon_sym_trunc] = ACTIONS(263),
    [anon_sym_zext] = ACTIONS(263),
    [anon_sym_sext] = ACTIONS(263),
    [anon_sym_fptrunc] = ACTIONS(263),
    [anon_sym_fpext] = ACTIONS(263),
    [anon_sym_addrspacecast] = ACTIONS(263),
    [anon_sym_uitofp] = ACTIONS(263),
    [anon_sym_sitofp] = ACTIONS(263),
    [anon_sym_fptoui] = ACTIONS(263),
    [anon_sym_fptosi] = ACTIONS(263),
    [anon_sym_inttoptr] = ACTIONS(263),
    [anon_sym_ptrtoint] = ACTIONS(263),
    [anon_sym_uselistorder] = ACTIONS(265),
    [anon_sym_uselistorder_bb] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(263),
    [anon_sym_attributes] = ACTIONS(263),
  },
  [65] = {
    [sym_addrspace] = STATE(82),
    [sym_argument_list] = STATE(77),
    [aux_sym_type_repeat1] = STATE(68),
    [ts_builtin_sym_end] = ACTIONS(244),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(244),
    [sym_comdat_ref] = ACTIONS(244),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [aux_sym_metadata_ref_token1] = ACTIONS(244),
    [sym_summary_ref] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_target] = ACTIONS(244),
    [anon_sym_source_filename] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(244),
    [anon_sym_define] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(498),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_RPAREN] = ACTIONS(244),
    [anon_sym_align] = ACTIONS(246),
    [anon_sym_section] = ACTIONS(244),
    [anon_sym_partition] = ACTIONS(244),
    [anon_sym_comdat] = ACTIONS(244),
    [anon_sym_gc] = ACTIONS(244),
    [anon_sym_prefix] = ACTIONS(244),
    [anon_sym_prologue] = ACTIONS(244),
    [anon_sym_personality] = ACTIONS(244),
    [anon_sym_alignstack] = ACTIONS(244),
    [anon_sym_allocsize] = ACTIONS(244),
    [anon_sym_alwaysinline] = ACTIONS(244),
    [anon_sym_builtin] = ACTIONS(244),
    [anon_sym_cold] = ACTIONS(244),
    [anon_sym_convergent] = ACTIONS(244),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(244),
    [anon_sym_hot] = ACTIONS(244),
    [anon_sym_inaccessiblememonly] = ACTIONS(244),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(244),
    [anon_sym_inlinehint] = ACTIONS(244),
    [anon_sym_jumptable] = ACTIONS(244),
    [anon_sym_minsize] = ACTIONS(244),
    [anon_sym_naked] = ACTIONS(244),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(244),
    [anon_sym_nobuiltin] = ACTIONS(244),
    [anon_sym_noduplicate] = ACTIONS(244),
    [anon_sym_nofree] = ACTIONS(244),
    [anon_sym_noimplicitfloat] = ACTIONS(244),
    [anon_sym_noinline] = ACTIONS(244),
    [anon_sym_nomerge] = ACTIONS(244),
    [anon_sym_nonlazybind] = ACTIONS(244),
    [anon_sym_noprofile] = ACTIONS(244),
    [anon_sym_noredzone] = ACTIONS(244),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(244),
    [anon_sym_noreturn] = ACTIONS(244),
    [anon_sym_norecurse] = ACTIONS(244),
    [anon_sym_willreturn] = ACTIONS(244),
    [anon_sym_nosync] = ACTIONS(244),
    [anon_sym_nounwind] = ACTIONS(244),
    [anon_sym_nocallback] = ACTIONS(244),
    [anon_sym_nosanitize_coverage] = ACTIONS(244),
    [anon_sym_null_pointer_is_valid] = ACTIONS(244),
    [anon_sym_optforfuzzing] = ACTIONS(244),
    [anon_sym_optnone] = ACTIONS(244),
    [anon_sym_optsize] = ACTIONS(244),
    [anon_sym_readnone] = ACTIONS(244),
    [anon_sym_readonly] = ACTIONS(244),
    [anon_sym_writeonly] = ACTIONS(244),
    [anon_sym_argmemonly] = ACTIONS(244),
    [anon_sym_returns_twice] = ACTIONS(244),
    [anon_sym_safestack] = ACTIONS(244),
    [anon_sym_sanitize_address] = ACTIONS(244),
    [anon_sym_sanitize_memory] = ACTIONS(244),
    [anon_sym_sanitize_thread] = ACTIONS(244),
    [anon_sym_sanitize_hwaddress] = ACTIONS(244),
    [anon_sym_sanitize_memtag] = ACTIONS(244),
    [anon_sym_speculative_load_hardening] = ACTIONS(244),
    [anon_sym_speculatable] = ACTIONS(244),
    [anon_sym_ssp] = ACTIONS(246),
    [anon_sym_sspstrong] = ACTIONS(244),
    [anon_sym_sspreq] = ACTIONS(244),
    [anon_sym_strictfp] = ACTIONS(244),
    [anon_sym_nocf_check] = ACTIONS(244),
    [anon_sym_shadowcallstack] = ACTIONS(244),
    [anon_sym_mustprogress] = ACTIONS(244),
    [anon_sym_vscale_range] = ACTIONS(244),
    [anon_sym_preallocated] = ACTIONS(244),
    [anon_sym_zeroext] = ACTIONS(244),
    [anon_sym_signext] = ACTIONS(244),
    [anon_sym_inreg] = ACTIONS(244),
    [anon_sym_byval] = ACTIONS(244),
    [anon_sym_byref] = ACTIONS(244),
    [anon_sym_inalloca] = ACTIONS(244),
    [anon_sym_sret] = ACTIONS(244),
    [anon_sym_elementtype] = ACTIONS(244),
    [anon_sym_noalias] = ACTIONS(244),
    [anon_sym_nocapture] = ACTIONS(244),
    [anon_sym_nest] = ACTIONS(244),
    [anon_sym_returned] = ACTIONS(244),
    [anon_sym_nonnull] = ACTIONS(244),
    [anon_sym_dereferenceable] = ACTIONS(246),
    [anon_sym_dereferenceable_or_null] = ACTIONS(244),
    [anon_sym_swiftself] = ACTIONS(244),
    [anon_sym_swiftasync] = ACTIONS(244),
    [anon_sym_swifterror] = ACTIONS(244),
    [anon_sym_immarg] = ACTIONS(244),
    [anon_sym_noundef] = ACTIONS(244),
    [anon_sym_uwtable] = ACTIONS(244),
    [anon_sym_memory] = ACTIONS(244),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_to] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
    [anon_sym_uselistorder] = ACTIONS(246),
    [anon_sym_uselistorder_bb] = ACTIONS(244),
    [anon_sym_module] = ACTIONS(244),
    [anon_sym_attributes] = ACTIONS(244),
  },
  [66] = {
    [ts_builtin_sym_end] = ACTIONS(387),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(387),
    [sym_comdat_ref] = ACTIONS(387),
    [sym_global_var] = ACTIONS(387),
    [sym_local_var] = ACTIONS(387),
    [aux_sym_metadata_ref_token1] = ACTIONS(387),
    [sym_summary_ref] = ACTIONS(387),
    [sym_string] = ACTIONS(387),
    [aux_sym_number_token1] = ACTIONS(389),
    [aux_sym_number_token2] = ACTIONS(387),
    [sym_float] = ACTIONS(387),
    [sym_cstring] = ACTIONS(387),
    [anon_sym_target] = ACTIONS(387),
    [anon_sym_source_filename] = ACTIONS(387),
    [anon_sym_declare] = ACTIONS(387),
    [anon_sym_define] = ACTIONS(387),
    [anon_sym_no_cfi] = ACTIONS(387),
    [anon_sym_private] = ACTIONS(387),
    [anon_sym_internal] = ACTIONS(387),
    [anon_sym_weak] = ACTIONS(389),
    [anon_sym_weak_odr] = ACTIONS(387),
    [anon_sym_linkonce] = ACTIONS(389),
    [anon_sym_linkonce_odr] = ACTIONS(387),
    [anon_sym_available_externally] = ACTIONS(387),
    [anon_sym_appending] = ACTIONS(387),
    [anon_sym_common] = ACTIONS(387),
    [anon_sym_extern_weak] = ACTIONS(387),
    [anon_sym_external] = ACTIONS(387),
    [anon_sym_dso_local] = ACTIONS(389),
    [anon_sym_dso_local_equivalent] = ACTIONS(387),
    [anon_sym_dso_preemptable] = ACTIONS(387),
    [anon_sym_default] = ACTIONS(387),
    [anon_sym_hidden] = ACTIONS(387),
    [anon_sym_protected] = ACTIONS(387),
    [anon_sym_dllimport] = ACTIONS(387),
    [anon_sym_dllexport] = ACTIONS(387),
    [anon_sym_unnamed_addr] = ACTIONS(387),
    [anon_sym_local_unnamed_addr] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(387),
    [anon_sym_LBRACE] = ACTIONS(387),
    [anon_sym_RBRACE] = ACTIONS(387),
    [anon_sym_LT_LBRACE] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_COMMA] = ACTIONS(387),
    [anon_sym_addrspace] = ACTIONS(389),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(387),
    [anon_sym_align] = ACTIONS(389),
    [anon_sym_section] = ACTIONS(387),
    [anon_sym_partition] = ACTIONS(387),
    [anon_sym_comdat] = ACTIONS(387),
    [anon_sym_gc] = ACTIONS(387),
    [anon_sym_prefix] = ACTIONS(387),
    [anon_sym_prologue] = ACTIONS(387),
    [anon_sym_personality] = ACTIONS(387),
    [anon_sym_alignstack] = ACTIONS(387),
    [anon_sym_allocsize] = ACTIONS(387),
    [anon_sym_alwaysinline] = ACTIONS(387),
    [anon_sym_builtin] = ACTIONS(387),
    [anon_sym_cold] = ACTIONS(387),
    [anon_sym_convergent] = ACTIONS(387),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(387),
    [anon_sym_hot] = ACTIONS(387),
    [anon_sym_inaccessiblememonly] = ACTIONS(387),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(387),
    [anon_sym_inlinehint] = ACTIONS(387),
    [anon_sym_jumptable] = ACTIONS(387),
    [anon_sym_minsize] = ACTIONS(387),
    [anon_sym_naked] = ACTIONS(387),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(387),
    [anon_sym_nobuiltin] = ACTIONS(387),
    [anon_sym_noduplicate] = ACTIONS(387),
    [anon_sym_nofree] = ACTIONS(387),
    [anon_sym_noimplicitfloat] = ACTIONS(387),
    [anon_sym_noinline] = ACTIONS(387),
    [anon_sym_nomerge] = ACTIONS(387),
    [anon_sym_nonlazybind] = ACTIONS(387),
    [anon_sym_noprofile] = ACTIONS(387),
    [anon_sym_noredzone] = ACTIONS(387),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(387),
    [anon_sym_noreturn] = ACTIONS(387),
    [anon_sym_norecurse] = ACTIONS(387),
    [anon_sym_willreturn] = ACTIONS(387),
    [anon_sym_nosync] = ACTIONS(387),
    [anon_sym_nounwind] = ACTIONS(387),
    [anon_sym_nocallback] = ACTIONS(387),
    [anon_sym_nosanitize_coverage] = ACTIONS(387),
    [anon_sym_null_pointer_is_valid] = ACTIONS(387),
    [anon_sym_optforfuzzing] = ACTIONS(387),
    [anon_sym_optnone] = ACTIONS(387),
    [anon_sym_optsize] = ACTIONS(387),
    [anon_sym_readnone] = ACTIONS(387),
    [anon_sym_readonly] = ACTIONS(387),
    [anon_sym_writeonly] = ACTIONS(387),
    [anon_sym_argmemonly] = ACTIONS(387),
    [anon_sym_returns_twice] = ACTIONS(387),
    [anon_sym_safestack] = ACTIONS(387),
    [anon_sym_sanitize_address] = ACTIONS(387),
    [anon_sym_sanitize_memory] = ACTIONS(387),
    [anon_sym_sanitize_thread] = ACTIONS(387),
    [anon_sym_sanitize_hwaddress] = ACTIONS(387),
    [anon_sym_sanitize_memtag] = ACTIONS(387),
    [anon_sym_speculative_load_hardening] = ACTIONS(387),
    [anon_sym_speculatable] = ACTIONS(387),
    [anon_sym_ssp] = ACTIONS(389),
    [anon_sym_sspstrong] = ACTIONS(387),
    [anon_sym_sspreq] = ACTIONS(387),
    [anon_sym_strictfp] = ACTIONS(387),
    [anon_sym_nocf_check] = ACTIONS(387),
    [anon_sym_shadowcallstack] = ACTIONS(387),
    [anon_sym_mustprogress] = ACTIONS(387),
    [anon_sym_vscale_range] = ACTIONS(387),
    [anon_sym_preallocated] = ACTIONS(387),
    [anon_sym_zeroext] = ACTIONS(387),
    [anon_sym_signext] = ACTIONS(387),
    [anon_sym_inreg] = ACTIONS(387),
    [anon_sym_byval] = ACTIONS(387),
    [anon_sym_byref] = ACTIONS(387),
    [anon_sym_inalloca] = ACTIONS(387),
    [anon_sym_sret] = ACTIONS(387),
    [anon_sym_elementtype] = ACTIONS(387),
    [anon_sym_noalias] = ACTIONS(387),
    [anon_sym_nocapture] = ACTIONS(387),
    [anon_sym_nest] = ACTIONS(387),
    [anon_sym_returned] = ACTIONS(387),
    [anon_sym_nonnull] = ACTIONS(387),
    [anon_sym_dereferenceable] = ACTIONS(389),
    [anon_sym_dereferenceable_or_null] = ACTIONS(387),
    [anon_sym_swiftself] = ACTIONS(387),
    [anon_sym_swiftasync] = ACTIONS(387),
    [anon_sym_swifterror] = ACTIONS(387),
    [anon_sym_immarg] = ACTIONS(387),
    [anon_sym_noundef] = ACTIONS(387),
    [anon_sym_uwtable] = ACTIONS(387),
    [anon_sym_memory] = ACTIONS(387),
    [anon_sym_none] = ACTIONS(387),
    [anon_sym_extractelement] = ACTIONS(387),
    [anon_sym_insertelement] = ACTIONS(387),
    [anon_sym_select] = ACTIONS(387),
    [anon_sym_shufflevector] = ACTIONS(387),
    [anon_sym_fneg] = ACTIONS(387),
    [anon_sym_to] = ACTIONS(387),
    [anon_sym_icmp] = ACTIONS(387),
    [anon_sym_fcmp] = ACTIONS(387),
    [anon_sym_getelementptr] = ACTIONS(387),
    [anon_sym_extractvalue] = ACTIONS(387),
    [anon_sym_insertvalue] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(387),
    [anon_sym_false] = ACTIONS(387),
    [anon_sym_null] = ACTIONS(389),
    [anon_sym_undef] = ACTIONS(387),
    [anon_sym_poison] = ACTIONS(387),
    [anon_sym_zeroinitializer] = ACTIONS(387),
    [anon_sym_blockaddress] = ACTIONS(387),
    [anon_sym_mul] = ACTIONS(387),
    [anon_sym_urem] = ACTIONS(387),
    [anon_sym_srem] = ACTIONS(387),
    [anon_sym_shl] = ACTIONS(387),
    [anon_sym_udiv] = ACTIONS(387),
    [anon_sym_sdiv] = ACTIONS(387),
    [anon_sym_lshr] = ACTIONS(387),
    [anon_sym_ashr] = ACTIONS(387),
    [anon_sym_fmul] = ACTIONS(387),
    [anon_sym_fdiv] = ACTIONS(387),
    [anon_sym_frem] = ACTIONS(387),
    [anon_sym_xchg] = ACTIONS(387),
    [anon_sym_add] = ACTIONS(389),
    [anon_sym_sub] = ACTIONS(387),
    [anon_sym_and] = ACTIONS(387),
    [anon_sym_nand] = ACTIONS(387),
    [anon_sym_or] = ACTIONS(387),
    [anon_sym_xor] = ACTIONS(387),
    [anon_sym_max] = ACTIONS(387),
    [anon_sym_min] = ACTIONS(389),
    [anon_sym_umax] = ACTIONS(387),
    [anon_sym_umin] = ACTIONS(387),
    [anon_sym_fadd] = ACTIONS(387),
    [anon_sym_fsub] = ACTIONS(387),
    [anon_sym_bitcast] = ACTIONS(387),
    [anon_sym_trunc] = ACTIONS(387),
    [anon_sym_zext] = ACTIONS(387),
    [anon_sym_sext] = ACTIONS(387),
    [anon_sym_fptrunc] = ACTIONS(387),
    [anon_sym_fpext] = ACTIONS(387),
    [anon_sym_addrspacecast] = ACTIONS(387),
    [anon_sym_uitofp] = ACTIONS(387),
    [anon_sym_sitofp] = ACTIONS(387),
    [anon_sym_fptoui] = ACTIONS(387),
    [anon_sym_fptosi] = ACTIONS(387),
    [anon_sym_inttoptr] = ACTIONS(387),
    [anon_sym_ptrtoint] = ACTIONS(387),
    [anon_sym_uselistorder] = ACTIONS(389),
    [anon_sym_uselistorder_bb] = ACTIONS(387),
    [anon_sym_module] = ACTIONS(387),
    [anon_sym_attributes] = ACTIONS(387),
  },
  [67] = {
    [ts_builtin_sym_end] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(383),
    [sym_comdat_ref] = ACTIONS(383),
    [sym_global_var] = ACTIONS(383),
    [sym_local_var] = ACTIONS(383),
    [aux_sym_metadata_ref_token1] = ACTIONS(383),
    [sym_summary_ref] = ACTIONS(383),
    [sym_string] = ACTIONS(383),
    [aux_sym_number_token1] = ACTIONS(385),
    [aux_sym_number_token2] = ACTIONS(383),
    [sym_float] = ACTIONS(383),
    [sym_cstring] = ACTIONS(383),
    [anon_sym_target] = ACTIONS(383),
    [anon_sym_source_filename] = ACTIONS(383),
    [anon_sym_declare] = ACTIONS(383),
    [anon_sym_define] = ACTIONS(383),
    [anon_sym_no_cfi] = ACTIONS(383),
    [anon_sym_private] = ACTIONS(383),
    [anon_sym_internal] = ACTIONS(383),
    [anon_sym_weak] = ACTIONS(385),
    [anon_sym_weak_odr] = ACTIONS(383),
    [anon_sym_linkonce] = ACTIONS(385),
    [anon_sym_linkonce_odr] = ACTIONS(383),
    [anon_sym_available_externally] = ACTIONS(383),
    [anon_sym_appending] = ACTIONS(383),
    [anon_sym_common] = ACTIONS(383),
    [anon_sym_extern_weak] = ACTIONS(383),
    [anon_sym_external] = ACTIONS(383),
    [anon_sym_dso_local] = ACTIONS(385),
    [anon_sym_dso_local_equivalent] = ACTIONS(383),
    [anon_sym_dso_preemptable] = ACTIONS(383),
    [anon_sym_default] = ACTIONS(383),
    [anon_sym_hidden] = ACTIONS(383),
    [anon_sym_protected] = ACTIONS(383),
    [anon_sym_dllimport] = ACTIONS(383),
    [anon_sym_dllexport] = ACTIONS(383),
    [anon_sym_unnamed_addr] = ACTIONS(383),
    [anon_sym_local_unnamed_addr] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_LBRACE] = ACTIONS(383),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_LT_LBRACE] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_addrspace] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_RPAREN] = ACTIONS(383),
    [anon_sym_align] = ACTIONS(385),
    [anon_sym_section] = ACTIONS(383),
    [anon_sym_partition] = ACTIONS(383),
    [anon_sym_comdat] = ACTIONS(383),
    [anon_sym_gc] = ACTIONS(383),
    [anon_sym_prefix] = ACTIONS(383),
    [anon_sym_prologue] = ACTIONS(383),
    [anon_sym_personality] = ACTIONS(383),
    [anon_sym_alignstack] = ACTIONS(383),
    [anon_sym_allocsize] = ACTIONS(383),
    [anon_sym_alwaysinline] = ACTIONS(383),
    [anon_sym_builtin] = ACTIONS(383),
    [anon_sym_cold] = ACTIONS(383),
    [anon_sym_convergent] = ACTIONS(383),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(383),
    [anon_sym_hot] = ACTIONS(383),
    [anon_sym_inaccessiblememonly] = ACTIONS(383),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(383),
    [anon_sym_inlinehint] = ACTIONS(383),
    [anon_sym_jumptable] = ACTIONS(383),
    [anon_sym_minsize] = ACTIONS(383),
    [anon_sym_naked] = ACTIONS(383),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(383),
    [anon_sym_nobuiltin] = ACTIONS(383),
    [anon_sym_noduplicate] = ACTIONS(383),
    [anon_sym_nofree] = ACTIONS(383),
    [anon_sym_noimplicitfloat] = ACTIONS(383),
    [anon_sym_noinline] = ACTIONS(383),
    [anon_sym_nomerge] = ACTIONS(383),
    [anon_sym_nonlazybind] = ACTIONS(383),
    [anon_sym_noprofile] = ACTIONS(383),
    [anon_sym_noredzone] = ACTIONS(383),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(383),
    [anon_sym_noreturn] = ACTIONS(383),
    [anon_sym_norecurse] = ACTIONS(383),
    [anon_sym_willreturn] = ACTIONS(383),
    [anon_sym_nosync] = ACTIONS(383),
    [anon_sym_nounwind] = ACTIONS(383),
    [anon_sym_nocallback] = ACTIONS(383),
    [anon_sym_nosanitize_coverage] = ACTIONS(383),
    [anon_sym_null_pointer_is_valid] = ACTIONS(383),
    [anon_sym_optforfuzzing] = ACTIONS(383),
    [anon_sym_optnone] = ACTIONS(383),
    [anon_sym_optsize] = ACTIONS(383),
    [anon_sym_readnone] = ACTIONS(383),
    [anon_sym_readonly] = ACTIONS(383),
    [anon_sym_writeonly] = ACTIONS(383),
    [anon_sym_argmemonly] = ACTIONS(383),
    [anon_sym_returns_twice] = ACTIONS(383),
    [anon_sym_safestack] = ACTIONS(383),
    [anon_sym_sanitize_address] = ACTIONS(383),
    [anon_sym_sanitize_memory] = ACTIONS(383),
    [anon_sym_sanitize_thread] = ACTIONS(383),
    [anon_sym_sanitize_hwaddress] = ACTIONS(383),
    [anon_sym_sanitize_memtag] = ACTIONS(383),
    [anon_sym_speculative_load_hardening] = ACTIONS(383),
    [anon_sym_speculatable] = ACTIONS(383),
    [anon_sym_ssp] = ACTIONS(385),
    [anon_sym_sspstrong] = ACTIONS(383),
    [anon_sym_sspreq] = ACTIONS(383),
    [anon_sym_strictfp] = ACTIONS(383),
    [anon_sym_nocf_check] = ACTIONS(383),
    [anon_sym_shadowcallstack] = ACTIONS(383),
    [anon_sym_mustprogress] = ACTIONS(383),
    [anon_sym_vscale_range] = ACTIONS(383),
    [anon_sym_preallocated] = ACTIONS(383),
    [anon_sym_zeroext] = ACTIONS(383),
    [anon_sym_signext] = ACTIONS(383),
    [anon_sym_inreg] = ACTIONS(383),
    [anon_sym_byval] = ACTIONS(383),
    [anon_sym_byref] = ACTIONS(383),
    [anon_sym_inalloca] = ACTIONS(383),
    [anon_sym_sret] = ACTIONS(383),
    [anon_sym_elementtype] = ACTIONS(383),
    [anon_sym_noalias] = ACTIONS(383),
    [anon_sym_nocapture] = ACTIONS(383),
    [anon_sym_nest] = ACTIONS(383),
    [anon_sym_returned] = ACTIONS(383),
    [anon_sym_nonnull] = ACTIONS(383),
    [anon_sym_dereferenceable] = ACTIONS(385),
    [anon_sym_dereferenceable_or_null] = ACTIONS(383),
    [anon_sym_swiftself] = ACTIONS(383),
    [anon_sym_swiftasync] = ACTIONS(383),
    [anon_sym_swifterror] = ACTIONS(383),
    [anon_sym_immarg] = ACTIONS(383),
    [anon_sym_noundef] = ACTIONS(383),
    [anon_sym_uwtable] = ACTIONS(383),
    [anon_sym_memory] = ACTIONS(383),
    [anon_sym_none] = ACTIONS(383),
    [anon_sym_extractelement] = ACTIONS(383),
    [anon_sym_insertelement] = ACTIONS(383),
    [anon_sym_select] = ACTIONS(383),
    [anon_sym_shufflevector] = ACTIONS(383),
    [anon_sym_fneg] = ACTIONS(383),
    [anon_sym_to] = ACTIONS(383),
    [anon_sym_icmp] = ACTIONS(383),
    [anon_sym_fcmp] = ACTIONS(383),
    [anon_sym_getelementptr] = ACTIONS(383),
    [anon_sym_extractvalue] = ACTIONS(383),
    [anon_sym_insertvalue] = ACTIONS(383),
    [anon_sym_true] = ACTIONS(383),
    [anon_sym_false] = ACTIONS(383),
    [anon_sym_null] = ACTIONS(385),
    [anon_sym_undef] = ACTIONS(383),
    [anon_sym_poison] = ACTIONS(383),
    [anon_sym_zeroinitializer] = ACTIONS(383),
    [anon_sym_blockaddress] = ACTIONS(383),
    [anon_sym_mul] = ACTIONS(383),
    [anon_sym_urem] = ACTIONS(383),
    [anon_sym_srem] = ACTIONS(383),
    [anon_sym_shl] = ACTIONS(383),
    [anon_sym_udiv] = ACTIONS(383),
    [anon_sym_sdiv] = ACTIONS(383),
    [anon_sym_lshr] = ACTIONS(383),
    [anon_sym_ashr] = ACTIONS(383),
    [anon_sym_fmul] = ACTIONS(383),
    [anon_sym_fdiv] = ACTIONS(383),
    [anon_sym_frem] = ACTIONS(383),
    [anon_sym_xchg] = ACTIONS(383),
    [anon_sym_add] = ACTIONS(385),
    [anon_sym_sub] = ACTIONS(383),
    [anon_sym_and] = ACTIONS(383),
    [anon_sym_nand] = ACTIONS(383),
    [anon_sym_or] = ACTIONS(383),
    [anon_sym_xor] = ACTIONS(383),
    [anon_sym_max] = ACTIONS(383),
    [anon_sym_min] = ACTIONS(385),
    [anon_sym_umax] = ACTIONS(383),
    [anon_sym_umin] = ACTIONS(383),
    [anon_sym_fadd] = ACTIONS(383),
    [anon_sym_fsub] = ACTIONS(383),
    [anon_sym_bitcast] = ACTIONS(383),
    [anon_sym_trunc] = ACTIONS(383),
    [anon_sym_zext] = ACTIONS(383),
    [anon_sym_sext] = ACTIONS(383),
    [anon_sym_fptrunc] = ACTIONS(383),
    [anon_sym_fpext] = ACTIONS(383),
    [anon_sym_addrspacecast] = ACTIONS(383),
    [anon_sym_uitofp] = ACTIONS(383),
    [anon_sym_sitofp] = ACTIONS(383),
    [anon_sym_fptoui] = ACTIONS(383),
    [anon_sym_fptosi] = ACTIONS(383),
    [anon_sym_inttoptr] = ACTIONS(383),
    [anon_sym_ptrtoint] = ACTIONS(383),
    [anon_sym_uselistorder] = ACTIONS(385),
    [anon_sym_uselistorder_bb] = ACTIONS(383),
    [anon_sym_module] = ACTIONS(383),
    [anon_sym_attributes] = ACTIONS(383),
  },
  [68] = {
    [sym_addrspace] = STATE(1617),
    [aux_sym_type_repeat1] = STATE(68),
    [ts_builtin_sym_end] = ACTIONS(269),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(269),
    [sym_comdat_ref] = ACTIONS(269),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [aux_sym_metadata_ref_token1] = ACTIONS(269),
    [sym_summary_ref] = ACTIONS(269),
    [sym_string] = ACTIONS(269),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(269),
    [sym_float] = ACTIONS(269),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_target] = ACTIONS(269),
    [anon_sym_source_filename] = ACTIONS(269),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_define] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_internal] = ACTIONS(269),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(269),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(269),
    [anon_sym_available_externally] = ACTIONS(269),
    [anon_sym_appending] = ACTIONS(269),
    [anon_sym_common] = ACTIONS(269),
    [anon_sym_extern_weak] = ACTIONS(269),
    [anon_sym_external] = ACTIONS(269),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(269),
    [anon_sym_dso_preemptable] = ACTIONS(269),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_hidden] = ACTIONS(269),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_dllimport] = ACTIONS(269),
    [anon_sym_dllexport] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(500),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_RPAREN] = ACTIONS(269),
    [anon_sym_align] = ACTIONS(271),
    [anon_sym_section] = ACTIONS(269),
    [anon_sym_partition] = ACTIONS(269),
    [anon_sym_comdat] = ACTIONS(269),
    [anon_sym_gc] = ACTIONS(269),
    [anon_sym_prefix] = ACTIONS(269),
    [anon_sym_prologue] = ACTIONS(269),
    [anon_sym_personality] = ACTIONS(269),
    [anon_sym_alignstack] = ACTIONS(269),
    [anon_sym_allocsize] = ACTIONS(269),
    [anon_sym_alwaysinline] = ACTIONS(269),
    [anon_sym_builtin] = ACTIONS(269),
    [anon_sym_cold] = ACTIONS(269),
    [anon_sym_convergent] = ACTIONS(269),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(269),
    [anon_sym_hot] = ACTIONS(269),
    [anon_sym_inaccessiblememonly] = ACTIONS(269),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(269),
    [anon_sym_inlinehint] = ACTIONS(269),
    [anon_sym_jumptable] = ACTIONS(269),
    [anon_sym_minsize] = ACTIONS(269),
    [anon_sym_naked] = ACTIONS(269),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(269),
    [anon_sym_nobuiltin] = ACTIONS(269),
    [anon_sym_noduplicate] = ACTIONS(269),
    [anon_sym_nofree] = ACTIONS(269),
    [anon_sym_noimplicitfloat] = ACTIONS(269),
    [anon_sym_noinline] = ACTIONS(269),
    [anon_sym_nomerge] = ACTIONS(269),
    [anon_sym_nonlazybind] = ACTIONS(269),
    [anon_sym_noprofile] = ACTIONS(269),
    [anon_sym_noredzone] = ACTIONS(269),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(269),
    [anon_sym_noreturn] = ACTIONS(269),
    [anon_sym_norecurse] = ACTIONS(269),
    [anon_sym_willreturn] = ACTIONS(269),
    [anon_sym_nosync] = ACTIONS(269),
    [anon_sym_nounwind] = ACTIONS(269),
    [anon_sym_nocallback] = ACTIONS(269),
    [anon_sym_nosanitize_coverage] = ACTIONS(269),
    [anon_sym_null_pointer_is_valid] = ACTIONS(269),
    [anon_sym_optforfuzzing] = ACTIONS(269),
    [anon_sym_optnone] = ACTIONS(269),
    [anon_sym_optsize] = ACTIONS(269),
    [anon_sym_readnone] = ACTIONS(269),
    [anon_sym_readonly] = ACTIONS(269),
    [anon_sym_writeonly] = ACTIONS(269),
    [anon_sym_argmemonly] = ACTIONS(269),
    [anon_sym_returns_twice] = ACTIONS(269),
    [anon_sym_safestack] = ACTIONS(269),
    [anon_sym_sanitize_address] = ACTIONS(269),
    [anon_sym_sanitize_memory] = ACTIONS(269),
    [anon_sym_sanitize_thread] = ACTIONS(269),
    [anon_sym_sanitize_hwaddress] = ACTIONS(269),
    [anon_sym_sanitize_memtag] = ACTIONS(269),
    [anon_sym_speculative_load_hardening] = ACTIONS(269),
    [anon_sym_speculatable] = ACTIONS(269),
    [anon_sym_ssp] = ACTIONS(271),
    [anon_sym_sspstrong] = ACTIONS(269),
    [anon_sym_sspreq] = ACTIONS(269),
    [anon_sym_strictfp] = ACTIONS(269),
    [anon_sym_nocf_check] = ACTIONS(269),
    [anon_sym_shadowcallstack] = ACTIONS(269),
    [anon_sym_mustprogress] = ACTIONS(269),
    [anon_sym_vscale_range] = ACTIONS(269),
    [anon_sym_preallocated] = ACTIONS(269),
    [anon_sym_zeroext] = ACTIONS(269),
    [anon_sym_signext] = ACTIONS(269),
    [anon_sym_inreg] = ACTIONS(269),
    [anon_sym_byval] = ACTIONS(269),
    [anon_sym_byref] = ACTIONS(269),
    [anon_sym_inalloca] = ACTIONS(269),
    [anon_sym_sret] = ACTIONS(269),
    [anon_sym_elementtype] = ACTIONS(269),
    [anon_sym_noalias] = ACTIONS(269),
    [anon_sym_nocapture] = ACTIONS(269),
    [anon_sym_nest] = ACTIONS(269),
    [anon_sym_returned] = ACTIONS(269),
    [anon_sym_nonnull] = ACTIONS(269),
    [anon_sym_dereferenceable] = ACTIONS(271),
    [anon_sym_dereferenceable_or_null] = ACTIONS(269),
    [anon_sym_swiftself] = ACTIONS(269),
    [anon_sym_swiftasync] = ACTIONS(269),
    [anon_sym_swifterror] = ACTIONS(269),
    [anon_sym_immarg] = ACTIONS(269),
    [anon_sym_noundef] = ACTIONS(269),
    [anon_sym_uwtable] = ACTIONS(269),
    [anon_sym_memory] = ACTIONS(269),
    [anon_sym_none] = ACTIONS(269),
    [anon_sym_extractelement] = ACTIONS(269),
    [anon_sym_insertelement] = ACTIONS(269),
    [anon_sym_select] = ACTIONS(269),
    [anon_sym_shufflevector] = ACTIONS(269),
    [anon_sym_fneg] = ACTIONS(269),
    [anon_sym_to] = ACTIONS(269),
    [anon_sym_icmp] = ACTIONS(269),
    [anon_sym_fcmp] = ACTIONS(269),
    [anon_sym_getelementptr] = ACTIONS(269),
    [anon_sym_extractvalue] = ACTIONS(269),
    [anon_sym_insertvalue] = ACTIONS(269),
    [anon_sym_true] = ACTIONS(269),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_null] = ACTIONS(271),
    [anon_sym_undef] = ACTIONS(269),
    [anon_sym_poison] = ACTIONS(269),
    [anon_sym_zeroinitializer] = ACTIONS(269),
    [anon_sym_blockaddress] = ACTIONS(269),
    [anon_sym_mul] = ACTIONS(269),
    [anon_sym_urem] = ACTIONS(269),
    [anon_sym_srem] = ACTIONS(269),
    [anon_sym_shl] = ACTIONS(269),
    [anon_sym_udiv] = ACTIONS(269),
    [anon_sym_sdiv] = ACTIONS(269),
    [anon_sym_lshr] = ACTIONS(269),
    [anon_sym_ashr] = ACTIONS(269),
    [anon_sym_fmul] = ACTIONS(269),
    [anon_sym_fdiv] = ACTIONS(269),
    [anon_sym_frem] = ACTIONS(269),
    [anon_sym_xchg] = ACTIONS(269),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(269),
    [anon_sym_and] = ACTIONS(269),
    [anon_sym_nand] = ACTIONS(269),
    [anon_sym_or] = ACTIONS(269),
    [anon_sym_xor] = ACTIONS(269),
    [anon_sym_max] = ACTIONS(269),
    [anon_sym_min] = ACTIONS(271),
    [anon_sym_umax] = ACTIONS(269),
    [anon_sym_umin] = ACTIONS(269),
    [anon_sym_fadd] = ACTIONS(269),
    [anon_sym_fsub] = ACTIONS(269),
    [anon_sym_bitcast] = ACTIONS(269),
    [anon_sym_trunc] = ACTIONS(269),
    [anon_sym_zext] = ACTIONS(269),
    [anon_sym_sext] = ACTIONS(269),
    [anon_sym_fptrunc] = ACTIONS(269),
    [anon_sym_fpext] = ACTIONS(269),
    [anon_sym_addrspacecast] = ACTIONS(269),
    [anon_sym_uitofp] = ACTIONS(269),
    [anon_sym_sitofp] = ACTIONS(269),
    [anon_sym_fptoui] = ACTIONS(269),
    [anon_sym_fptosi] = ACTIONS(269),
    [anon_sym_inttoptr] = ACTIONS(269),
    [anon_sym_ptrtoint] = ACTIONS(269),
    [anon_sym_uselistorder] = ACTIONS(271),
    [anon_sym_uselistorder_bb] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_attributes] = ACTIONS(269),
  },
  [69] = {
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(371),
    [sym_comdat_ref] = ACTIONS(371),
    [sym_global_var] = ACTIONS(371),
    [sym_local_var] = ACTIONS(371),
    [aux_sym_metadata_ref_token1] = ACTIONS(371),
    [sym_summary_ref] = ACTIONS(371),
    [sym_string] = ACTIONS(371),
    [aux_sym_number_token1] = ACTIONS(373),
    [aux_sym_number_token2] = ACTIONS(371),
    [sym_float] = ACTIONS(371),
    [sym_cstring] = ACTIONS(371),
    [anon_sym_target] = ACTIONS(371),
    [anon_sym_source_filename] = ACTIONS(371),
    [anon_sym_declare] = ACTIONS(371),
    [anon_sym_define] = ACTIONS(371),
    [anon_sym_no_cfi] = ACTIONS(371),
    [anon_sym_private] = ACTIONS(371),
    [anon_sym_internal] = ACTIONS(371),
    [anon_sym_weak] = ACTIONS(373),
    [anon_sym_weak_odr] = ACTIONS(371),
    [anon_sym_linkonce] = ACTIONS(373),
    [anon_sym_linkonce_odr] = ACTIONS(371),
    [anon_sym_available_externally] = ACTIONS(371),
    [anon_sym_appending] = ACTIONS(371),
    [anon_sym_common] = ACTIONS(371),
    [anon_sym_extern_weak] = ACTIONS(371),
    [anon_sym_external] = ACTIONS(371),
    [anon_sym_dso_local] = ACTIONS(373),
    [anon_sym_dso_local_equivalent] = ACTIONS(371),
    [anon_sym_dso_preemptable] = ACTIONS(371),
    [anon_sym_default] = ACTIONS(371),
    [anon_sym_hidden] = ACTIONS(371),
    [anon_sym_protected] = ACTIONS(371),
    [anon_sym_dllimport] = ACTIONS(371),
    [anon_sym_dllexport] = ACTIONS(371),
    [anon_sym_unnamed_addr] = ACTIONS(371),
    [anon_sym_local_unnamed_addr] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(371),
    [anon_sym_LT_LBRACE] = ACTIONS(371),
    [anon_sym_LBRACK] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_COMMA] = ACTIONS(371),
    [anon_sym_addrspace] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_RPAREN] = ACTIONS(371),
    [anon_sym_align] = ACTIONS(373),
    [anon_sym_section] = ACTIONS(371),
    [anon_sym_partition] = ACTIONS(371),
    [anon_sym_comdat] = ACTIONS(371),
    [anon_sym_gc] = ACTIONS(371),
    [anon_sym_prefix] = ACTIONS(371),
    [anon_sym_prologue] = ACTIONS(371),
    [anon_sym_personality] = ACTIONS(371),
    [anon_sym_alignstack] = ACTIONS(371),
    [anon_sym_allocsize] = ACTIONS(371),
    [anon_sym_alwaysinline] = ACTIONS(371),
    [anon_sym_builtin] = ACTIONS(371),
    [anon_sym_cold] = ACTIONS(371),
    [anon_sym_convergent] = ACTIONS(371),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(371),
    [anon_sym_hot] = ACTIONS(371),
    [anon_sym_inaccessiblememonly] = ACTIONS(371),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(371),
    [anon_sym_inlinehint] = ACTIONS(371),
    [anon_sym_jumptable] = ACTIONS(371),
    [anon_sym_minsize] = ACTIONS(371),
    [anon_sym_naked] = ACTIONS(371),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(371),
    [anon_sym_nobuiltin] = ACTIONS(371),
    [anon_sym_noduplicate] = ACTIONS(371),
    [anon_sym_nofree] = ACTIONS(371),
    [anon_sym_noimplicitfloat] = ACTIONS(371),
    [anon_sym_noinline] = ACTIONS(371),
    [anon_sym_nomerge] = ACTIONS(371),
    [anon_sym_nonlazybind] = ACTIONS(371),
    [anon_sym_noprofile] = ACTIONS(371),
    [anon_sym_noredzone] = ACTIONS(371),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(371),
    [anon_sym_noreturn] = ACTIONS(371),
    [anon_sym_norecurse] = ACTIONS(371),
    [anon_sym_willreturn] = ACTIONS(371),
    [anon_sym_nosync] = ACTIONS(371),
    [anon_sym_nounwind] = ACTIONS(371),
    [anon_sym_nocallback] = ACTIONS(371),
    [anon_sym_nosanitize_coverage] = ACTIONS(371),
    [anon_sym_null_pointer_is_valid] = ACTIONS(371),
    [anon_sym_optforfuzzing] = ACTIONS(371),
    [anon_sym_optnone] = ACTIONS(371),
    [anon_sym_optsize] = ACTIONS(371),
    [anon_sym_readnone] = ACTIONS(371),
    [anon_sym_readonly] = ACTIONS(371),
    [anon_sym_writeonly] = ACTIONS(371),
    [anon_sym_argmemonly] = ACTIONS(371),
    [anon_sym_returns_twice] = ACTIONS(371),
    [anon_sym_safestack] = ACTIONS(371),
    [anon_sym_sanitize_address] = ACTIONS(371),
    [anon_sym_sanitize_memory] = ACTIONS(371),
    [anon_sym_sanitize_thread] = ACTIONS(371),
    [anon_sym_sanitize_hwaddress] = ACTIONS(371),
    [anon_sym_sanitize_memtag] = ACTIONS(371),
    [anon_sym_speculative_load_hardening] = ACTIONS(371),
    [anon_sym_speculatable] = ACTIONS(371),
    [anon_sym_ssp] = ACTIONS(373),
    [anon_sym_sspstrong] = ACTIONS(371),
    [anon_sym_sspreq] = ACTIONS(371),
    [anon_sym_strictfp] = ACTIONS(371),
    [anon_sym_nocf_check] = ACTIONS(371),
    [anon_sym_shadowcallstack] = ACTIONS(371),
    [anon_sym_mustprogress] = ACTIONS(371),
    [anon_sym_vscale_range] = ACTIONS(371),
    [anon_sym_preallocated] = ACTIONS(371),
    [anon_sym_zeroext] = ACTIONS(371),
    [anon_sym_signext] = ACTIONS(371),
    [anon_sym_inreg] = ACTIONS(371),
    [anon_sym_byval] = ACTIONS(371),
    [anon_sym_byref] = ACTIONS(371),
    [anon_sym_inalloca] = ACTIONS(371),
    [anon_sym_sret] = ACTIONS(371),
    [anon_sym_elementtype] = ACTIONS(371),
    [anon_sym_noalias] = ACTIONS(371),
    [anon_sym_nocapture] = ACTIONS(371),
    [anon_sym_nest] = ACTIONS(371),
    [anon_sym_returned] = ACTIONS(371),
    [anon_sym_nonnull] = ACTIONS(371),
    [anon_sym_dereferenceable] = ACTIONS(373),
    [anon_sym_dereferenceable_or_null] = ACTIONS(371),
    [anon_sym_swiftself] = ACTIONS(371),
    [anon_sym_swiftasync] = ACTIONS(371),
    [anon_sym_swifterror] = ACTIONS(371),
    [anon_sym_immarg] = ACTIONS(371),
    [anon_sym_noundef] = ACTIONS(371),
    [anon_sym_uwtable] = ACTIONS(371),
    [anon_sym_memory] = ACTIONS(371),
    [anon_sym_none] = ACTIONS(371),
    [anon_sym_extractelement] = ACTIONS(371),
    [anon_sym_insertelement] = ACTIONS(371),
    [anon_sym_select] = ACTIONS(371),
    [anon_sym_shufflevector] = ACTIONS(371),
    [anon_sym_fneg] = ACTIONS(371),
    [anon_sym_to] = ACTIONS(371),
    [anon_sym_icmp] = ACTIONS(371),
    [anon_sym_fcmp] = ACTIONS(371),
    [anon_sym_getelementptr] = ACTIONS(371),
    [anon_sym_extractvalue] = ACTIONS(371),
    [anon_sym_insertvalue] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(371),
    [anon_sym_false] = ACTIONS(371),
    [anon_sym_null] = ACTIONS(373),
    [anon_sym_undef] = ACTIONS(371),
    [anon_sym_poison] = ACTIONS(371),
    [anon_sym_zeroinitializer] = ACTIONS(371),
    [anon_sym_blockaddress] = ACTIONS(371),
    [anon_sym_mul] = ACTIONS(371),
    [anon_sym_urem] = ACTIONS(371),
    [anon_sym_srem] = ACTIONS(371),
    [anon_sym_shl] = ACTIONS(371),
    [anon_sym_udiv] = ACTIONS(371),
    [anon_sym_sdiv] = ACTIONS(371),
    [anon_sym_lshr] = ACTIONS(371),
    [anon_sym_ashr] = ACTIONS(371),
    [anon_sym_fmul] = ACTIONS(371),
    [anon_sym_fdiv] = ACTIONS(371),
    [anon_sym_frem] = ACTIONS(371),
    [anon_sym_xchg] = ACTIONS(371),
    [anon_sym_add] = ACTIONS(373),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_and] = ACTIONS(371),
    [anon_sym_nand] = ACTIONS(371),
    [anon_sym_or] = ACTIONS(371),
    [anon_sym_xor] = ACTIONS(371),
    [anon_sym_max] = ACTIONS(371),
    [anon_sym_min] = ACTIONS(373),
    [anon_sym_umax] = ACTIONS(371),
    [anon_sym_umin] = ACTIONS(371),
    [anon_sym_fadd] = ACTIONS(371),
    [anon_sym_fsub] = ACTIONS(371),
    [anon_sym_bitcast] = ACTIONS(371),
    [anon_sym_trunc] = ACTIONS(371),
    [anon_sym_zext] = ACTIONS(371),
    [anon_sym_sext] = ACTIONS(371),
    [anon_sym_fptrunc] = ACTIONS(371),
    [anon_sym_fpext] = ACTIONS(371),
    [anon_sym_addrspacecast] = ACTIONS(371),
    [anon_sym_uitofp] = ACTIONS(371),
    [anon_sym_sitofp] = ACTIONS(371),
    [anon_sym_fptoui] = ACTIONS(371),
    [anon_sym_fptosi] = ACTIONS(371),
    [anon_sym_inttoptr] = ACTIONS(371),
    [anon_sym_ptrtoint] = ACTIONS(371),
    [anon_sym_uselistorder] = ACTIONS(373),
    [anon_sym_uselistorder_bb] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_attributes] = ACTIONS(371),
  },
  [70] = {
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(379),
    [sym_comdat_ref] = ACTIONS(379),
    [sym_global_var] = ACTIONS(379),
    [sym_local_var] = ACTIONS(379),
    [aux_sym_metadata_ref_token1] = ACTIONS(379),
    [sym_summary_ref] = ACTIONS(379),
    [sym_string] = ACTIONS(379),
    [aux_sym_number_token1] = ACTIONS(381),
    [aux_sym_number_token2] = ACTIONS(379),
    [sym_float] = ACTIONS(379),
    [sym_cstring] = ACTIONS(379),
    [anon_sym_target] = ACTIONS(379),
    [anon_sym_source_filename] = ACTIONS(379),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_define] = ACTIONS(379),
    [anon_sym_no_cfi] = ACTIONS(379),
    [anon_sym_private] = ACTIONS(379),
    [anon_sym_internal] = ACTIONS(379),
    [anon_sym_weak] = ACTIONS(381),
    [anon_sym_weak_odr] = ACTIONS(379),
    [anon_sym_linkonce] = ACTIONS(381),
    [anon_sym_linkonce_odr] = ACTIONS(379),
    [anon_sym_available_externally] = ACTIONS(379),
    [anon_sym_appending] = ACTIONS(379),
    [anon_sym_common] = ACTIONS(379),
    [anon_sym_extern_weak] = ACTIONS(379),
    [anon_sym_external] = ACTIONS(379),
    [anon_sym_dso_local] = ACTIONS(381),
    [anon_sym_dso_local_equivalent] = ACTIONS(379),
    [anon_sym_dso_preemptable] = ACTIONS(379),
    [anon_sym_default] = ACTIONS(379),
    [anon_sym_hidden] = ACTIONS(379),
    [anon_sym_protected] = ACTIONS(379),
    [anon_sym_dllimport] = ACTIONS(379),
    [anon_sym_dllexport] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_LT_LBRACE] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(379),
    [anon_sym_addrspace] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_RPAREN] = ACTIONS(379),
    [anon_sym_align] = ACTIONS(381),
    [anon_sym_section] = ACTIONS(379),
    [anon_sym_partition] = ACTIONS(379),
    [anon_sym_comdat] = ACTIONS(379),
    [anon_sym_gc] = ACTIONS(379),
    [anon_sym_prefix] = ACTIONS(379),
    [anon_sym_prologue] = ACTIONS(379),
    [anon_sym_personality] = ACTIONS(379),
    [anon_sym_alignstack] = ACTIONS(379),
    [anon_sym_allocsize] = ACTIONS(379),
    [anon_sym_alwaysinline] = ACTIONS(379),
    [anon_sym_builtin] = ACTIONS(379),
    [anon_sym_cold] = ACTIONS(379),
    [anon_sym_convergent] = ACTIONS(379),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(379),
    [anon_sym_hot] = ACTIONS(379),
    [anon_sym_inaccessiblememonly] = ACTIONS(379),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(379),
    [anon_sym_inlinehint] = ACTIONS(379),
    [anon_sym_jumptable] = ACTIONS(379),
    [anon_sym_minsize] = ACTIONS(379),
    [anon_sym_naked] = ACTIONS(379),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(379),
    [anon_sym_nobuiltin] = ACTIONS(379),
    [anon_sym_noduplicate] = ACTIONS(379),
    [anon_sym_nofree] = ACTIONS(379),
    [anon_sym_noimplicitfloat] = ACTIONS(379),
    [anon_sym_noinline] = ACTIONS(379),
    [anon_sym_nomerge] = ACTIONS(379),
    [anon_sym_nonlazybind] = ACTIONS(379),
    [anon_sym_noprofile] = ACTIONS(379),
    [anon_sym_noredzone] = ACTIONS(379),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(379),
    [anon_sym_noreturn] = ACTIONS(379),
    [anon_sym_norecurse] = ACTIONS(379),
    [anon_sym_willreturn] = ACTIONS(379),
    [anon_sym_nosync] = ACTIONS(379),
    [anon_sym_nounwind] = ACTIONS(379),
    [anon_sym_nocallback] = ACTIONS(379),
    [anon_sym_nosanitize_coverage] = ACTIONS(379),
    [anon_sym_null_pointer_is_valid] = ACTIONS(379),
    [anon_sym_optforfuzzing] = ACTIONS(379),
    [anon_sym_optnone] = ACTIONS(379),
    [anon_sym_optsize] = ACTIONS(379),
    [anon_sym_readnone] = ACTIONS(379),
    [anon_sym_readonly] = ACTIONS(379),
    [anon_sym_writeonly] = ACTIONS(379),
    [anon_sym_argmemonly] = ACTIONS(379),
    [anon_sym_returns_twice] = ACTIONS(379),
    [anon_sym_safestack] = ACTIONS(379),
    [anon_sym_sanitize_address] = ACTIONS(379),
    [anon_sym_sanitize_memory] = ACTIONS(379),
    [anon_sym_sanitize_thread] = ACTIONS(379),
    [anon_sym_sanitize_hwaddress] = ACTIONS(379),
    [anon_sym_sanitize_memtag] = ACTIONS(379),
    [anon_sym_speculative_load_hardening] = ACTIONS(379),
    [anon_sym_speculatable] = ACTIONS(379),
    [anon_sym_ssp] = ACTIONS(381),
    [anon_sym_sspstrong] = ACTIONS(379),
    [anon_sym_sspreq] = ACTIONS(379),
    [anon_sym_strictfp] = ACTIONS(379),
    [anon_sym_nocf_check] = ACTIONS(379),
    [anon_sym_shadowcallstack] = ACTIONS(379),
    [anon_sym_mustprogress] = ACTIONS(379),
    [anon_sym_vscale_range] = ACTIONS(379),
    [anon_sym_preallocated] = ACTIONS(379),
    [anon_sym_zeroext] = ACTIONS(379),
    [anon_sym_signext] = ACTIONS(379),
    [anon_sym_inreg] = ACTIONS(379),
    [anon_sym_byval] = ACTIONS(379),
    [anon_sym_byref] = ACTIONS(379),
    [anon_sym_inalloca] = ACTIONS(379),
    [anon_sym_sret] = ACTIONS(379),
    [anon_sym_elementtype] = ACTIONS(379),
    [anon_sym_noalias] = ACTIONS(379),
    [anon_sym_nocapture] = ACTIONS(379),
    [anon_sym_nest] = ACTIONS(379),
    [anon_sym_returned] = ACTIONS(379),
    [anon_sym_nonnull] = ACTIONS(379),
    [anon_sym_dereferenceable] = ACTIONS(381),
    [anon_sym_dereferenceable_or_null] = ACTIONS(379),
    [anon_sym_swiftself] = ACTIONS(379),
    [anon_sym_swiftasync] = ACTIONS(379),
    [anon_sym_swifterror] = ACTIONS(379),
    [anon_sym_immarg] = ACTIONS(379),
    [anon_sym_noundef] = ACTIONS(379),
    [anon_sym_uwtable] = ACTIONS(379),
    [anon_sym_memory] = ACTIONS(379),
    [anon_sym_none] = ACTIONS(379),
    [anon_sym_extractelement] = ACTIONS(379),
    [anon_sym_insertelement] = ACTIONS(379),
    [anon_sym_select] = ACTIONS(379),
    [anon_sym_shufflevector] = ACTIONS(379),
    [anon_sym_fneg] = ACTIONS(379),
    [anon_sym_to] = ACTIONS(379),
    [anon_sym_icmp] = ACTIONS(379),
    [anon_sym_fcmp] = ACTIONS(379),
    [anon_sym_getelementptr] = ACTIONS(379),
    [anon_sym_extractvalue] = ACTIONS(379),
    [anon_sym_insertvalue] = ACTIONS(379),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [anon_sym_null] = ACTIONS(381),
    [anon_sym_undef] = ACTIONS(379),
    [anon_sym_poison] = ACTIONS(379),
    [anon_sym_zeroinitializer] = ACTIONS(379),
    [anon_sym_blockaddress] = ACTIONS(379),
    [anon_sym_mul] = ACTIONS(379),
    [anon_sym_urem] = ACTIONS(379),
    [anon_sym_srem] = ACTIONS(379),
    [anon_sym_shl] = ACTIONS(379),
    [anon_sym_udiv] = ACTIONS(379),
    [anon_sym_sdiv] = ACTIONS(379),
    [anon_sym_lshr] = ACTIONS(379),
    [anon_sym_ashr] = ACTIONS(379),
    [anon_sym_fmul] = ACTIONS(379),
    [anon_sym_fdiv] = ACTIONS(379),
    [anon_sym_frem] = ACTIONS(379),
    [anon_sym_xchg] = ACTIONS(379),
    [anon_sym_add] = ACTIONS(381),
    [anon_sym_sub] = ACTIONS(379),
    [anon_sym_and] = ACTIONS(379),
    [anon_sym_nand] = ACTIONS(379),
    [anon_sym_or] = ACTIONS(379),
    [anon_sym_xor] = ACTIONS(379),
    [anon_sym_max] = ACTIONS(379),
    [anon_sym_min] = ACTIONS(381),
    [anon_sym_umax] = ACTIONS(379),
    [anon_sym_umin] = ACTIONS(379),
    [anon_sym_fadd] = ACTIONS(379),
    [anon_sym_fsub] = ACTIONS(379),
    [anon_sym_bitcast] = ACTIONS(379),
    [anon_sym_trunc] = ACTIONS(379),
    [anon_sym_zext] = ACTIONS(379),
    [anon_sym_sext] = ACTIONS(379),
    [anon_sym_fptrunc] = ACTIONS(379),
    [anon_sym_fpext] = ACTIONS(379),
    [anon_sym_addrspacecast] = ACTIONS(379),
    [anon_sym_uitofp] = ACTIONS(379),
    [anon_sym_sitofp] = ACTIONS(379),
    [anon_sym_fptoui] = ACTIONS(379),
    [anon_sym_fptosi] = ACTIONS(379),
    [anon_sym_inttoptr] = ACTIONS(379),
    [anon_sym_ptrtoint] = ACTIONS(379),
    [anon_sym_uselistorder] = ACTIONS(381),
    [anon_sym_uselistorder_bb] = ACTIONS(379),
    [anon_sym_module] = ACTIONS(379),
    [anon_sym_attributes] = ACTIONS(379),
  },
  [71] = {
    [ts_builtin_sym_end] = ACTIONS(279),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(279),
    [sym_comdat_ref] = ACTIONS(279),
    [sym_global_var] = ACTIONS(279),
    [sym_local_var] = ACTIONS(279),
    [aux_sym_metadata_ref_token1] = ACTIONS(279),
    [sym_summary_ref] = ACTIONS(279),
    [sym_string] = ACTIONS(279),
    [aux_sym_number_token1] = ACTIONS(281),
    [aux_sym_number_token2] = ACTIONS(279),
    [sym_float] = ACTIONS(279),
    [sym_cstring] = ACTIONS(279),
    [anon_sym_target] = ACTIONS(279),
    [anon_sym_source_filename] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(279),
    [anon_sym_define] = ACTIONS(279),
    [anon_sym_no_cfi] = ACTIONS(279),
    [anon_sym_private] = ACTIONS(279),
    [anon_sym_internal] = ACTIONS(279),
    [anon_sym_weak] = ACTIONS(281),
    [anon_sym_weak_odr] = ACTIONS(279),
    [anon_sym_linkonce] = ACTIONS(281),
    [anon_sym_linkonce_odr] = ACTIONS(279),
    [anon_sym_available_externally] = ACTIONS(279),
    [anon_sym_appending] = ACTIONS(279),
    [anon_sym_common] = ACTIONS(279),
    [anon_sym_extern_weak] = ACTIONS(279),
    [anon_sym_external] = ACTIONS(279),
    [anon_sym_dso_local] = ACTIONS(281),
    [anon_sym_dso_local_equivalent] = ACTIONS(279),
    [anon_sym_dso_preemptable] = ACTIONS(279),
    [anon_sym_default] = ACTIONS(279),
    [anon_sym_hidden] = ACTIONS(279),
    [anon_sym_protected] = ACTIONS(279),
    [anon_sym_dllimport] = ACTIONS(279),
    [anon_sym_dllexport] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(279),
    [anon_sym_RBRACE] = ACTIONS(279),
    [anon_sym_LT_LBRACE] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(281),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_addrspace] = ACTIONS(281),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_align] = ACTIONS(281),
    [anon_sym_section] = ACTIONS(279),
    [anon_sym_partition] = ACTIONS(279),
    [anon_sym_comdat] = ACTIONS(279),
    [anon_sym_gc] = ACTIONS(279),
    [anon_sym_prefix] = ACTIONS(279),
    [anon_sym_prologue] = ACTIONS(279),
    [anon_sym_personality] = ACTIONS(279),
    [anon_sym_alignstack] = ACTIONS(279),
    [anon_sym_allocsize] = ACTIONS(279),
    [anon_sym_alwaysinline] = ACTIONS(279),
    [anon_sym_builtin] = ACTIONS(279),
    [anon_sym_cold] = ACTIONS(279),
    [anon_sym_convergent] = ACTIONS(279),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(279),
    [anon_sym_hot] = ACTIONS(279),
    [anon_sym_inaccessiblememonly] = ACTIONS(279),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(279),
    [anon_sym_inlinehint] = ACTIONS(279),
    [anon_sym_jumptable] = ACTIONS(279),
    [anon_sym_minsize] = ACTIONS(279),
    [anon_sym_naked] = ACTIONS(279),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(279),
    [anon_sym_nobuiltin] = ACTIONS(279),
    [anon_sym_noduplicate] = ACTIONS(279),
    [anon_sym_nofree] = ACTIONS(279),
    [anon_sym_noimplicitfloat] = ACTIONS(279),
    [anon_sym_noinline] = ACTIONS(279),
    [anon_sym_nomerge] = ACTIONS(279),
    [anon_sym_nonlazybind] = ACTIONS(279),
    [anon_sym_noprofile] = ACTIONS(279),
    [anon_sym_noredzone] = ACTIONS(279),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(279),
    [anon_sym_noreturn] = ACTIONS(279),
    [anon_sym_norecurse] = ACTIONS(279),
    [anon_sym_willreturn] = ACTIONS(279),
    [anon_sym_nosync] = ACTIONS(279),
    [anon_sym_nounwind] = ACTIONS(279),
    [anon_sym_nocallback] = ACTIONS(279),
    [anon_sym_nosanitize_coverage] = ACTIONS(279),
    [anon_sym_null_pointer_is_valid] = ACTIONS(279),
    [anon_sym_optforfuzzing] = ACTIONS(279),
    [anon_sym_optnone] = ACTIONS(279),
    [anon_sym_optsize] = ACTIONS(279),
    [anon_sym_readnone] = ACTIONS(279),
    [anon_sym_readonly] = ACTIONS(279),
    [anon_sym_writeonly] = ACTIONS(279),
    [anon_sym_argmemonly] = ACTIONS(279),
    [anon_sym_returns_twice] = ACTIONS(279),
    [anon_sym_safestack] = ACTIONS(279),
    [anon_sym_sanitize_address] = ACTIONS(279),
    [anon_sym_sanitize_memory] = ACTIONS(279),
    [anon_sym_sanitize_thread] = ACTIONS(279),
    [anon_sym_sanitize_hwaddress] = ACTIONS(279),
    [anon_sym_sanitize_memtag] = ACTIONS(279),
    [anon_sym_speculative_load_hardening] = ACTIONS(279),
    [anon_sym_speculatable] = ACTIONS(279),
    [anon_sym_ssp] = ACTIONS(281),
    [anon_sym_sspstrong] = ACTIONS(279),
    [anon_sym_sspreq] = ACTIONS(279),
    [anon_sym_strictfp] = ACTIONS(279),
    [anon_sym_nocf_check] = ACTIONS(279),
    [anon_sym_shadowcallstack] = ACTIONS(279),
    [anon_sym_mustprogress] = ACTIONS(279),
    [anon_sym_vscale_range] = ACTIONS(279),
    [anon_sym_preallocated] = ACTIONS(279),
    [anon_sym_zeroext] = ACTIONS(279),
    [anon_sym_signext] = ACTIONS(279),
    [anon_sym_inreg] = ACTIONS(279),
    [anon_sym_byval] = ACTIONS(279),
    [anon_sym_byref] = ACTIONS(279),
    [anon_sym_inalloca] = ACTIONS(279),
    [anon_sym_sret] = ACTIONS(279),
    [anon_sym_elementtype] = ACTIONS(279),
    [anon_sym_noalias] = ACTIONS(279),
    [anon_sym_nocapture] = ACTIONS(279),
    [anon_sym_nest] = ACTIONS(279),
    [anon_sym_returned] = ACTIONS(279),
    [anon_sym_nonnull] = ACTIONS(279),
    [anon_sym_dereferenceable] = ACTIONS(281),
    [anon_sym_dereferenceable_or_null] = ACTIONS(279),
    [anon_sym_swiftself] = ACTIONS(279),
    [anon_sym_swiftasync] = ACTIONS(279),
    [anon_sym_swifterror] = ACTIONS(279),
    [anon_sym_immarg] = ACTIONS(279),
    [anon_sym_noundef] = ACTIONS(279),
    [anon_sym_uwtable] = ACTIONS(279),
    [anon_sym_memory] = ACTIONS(279),
    [anon_sym_none] = ACTIONS(279),
    [anon_sym_extractelement] = ACTIONS(279),
    [anon_sym_insertelement] = ACTIONS(279),
    [anon_sym_select] = ACTIONS(279),
    [anon_sym_shufflevector] = ACTIONS(279),
    [anon_sym_fneg] = ACTIONS(279),
    [anon_sym_to] = ACTIONS(279),
    [anon_sym_icmp] = ACTIONS(279),
    [anon_sym_fcmp] = ACTIONS(279),
    [anon_sym_getelementptr] = ACTIONS(279),
    [anon_sym_extractvalue] = ACTIONS(279),
    [anon_sym_insertvalue] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(279),
    [anon_sym_false] = ACTIONS(279),
    [anon_sym_null] = ACTIONS(281),
    [anon_sym_undef] = ACTIONS(279),
    [anon_sym_poison] = ACTIONS(279),
    [anon_sym_zeroinitializer] = ACTIONS(279),
    [anon_sym_blockaddress] = ACTIONS(279),
    [anon_sym_mul] = ACTIONS(279),
    [anon_sym_urem] = ACTIONS(279),
    [anon_sym_srem] = ACTIONS(279),
    [anon_sym_shl] = ACTIONS(279),
    [anon_sym_udiv] = ACTIONS(279),
    [anon_sym_sdiv] = ACTIONS(279),
    [anon_sym_lshr] = ACTIONS(279),
    [anon_sym_ashr] = ACTIONS(279),
    [anon_sym_fmul] = ACTIONS(279),
    [anon_sym_fdiv] = ACTIONS(279),
    [anon_sym_frem] = ACTIONS(279),
    [anon_sym_xchg] = ACTIONS(279),
    [anon_sym_add] = ACTIONS(281),
    [anon_sym_sub] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_nand] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_xor] = ACTIONS(279),
    [anon_sym_max] = ACTIONS(279),
    [anon_sym_min] = ACTIONS(281),
    [anon_sym_umax] = ACTIONS(279),
    [anon_sym_umin] = ACTIONS(279),
    [anon_sym_fadd] = ACTIONS(279),
    [anon_sym_fsub] = ACTIONS(279),
    [anon_sym_bitcast] = ACTIONS(279),
    [anon_sym_trunc] = ACTIONS(279),
    [anon_sym_zext] = ACTIONS(279),
    [anon_sym_sext] = ACTIONS(279),
    [anon_sym_fptrunc] = ACTIONS(279),
    [anon_sym_fpext] = ACTIONS(279),
    [anon_sym_addrspacecast] = ACTIONS(279),
    [anon_sym_uitofp] = ACTIONS(279),
    [anon_sym_sitofp] = ACTIONS(279),
    [anon_sym_fptoui] = ACTIONS(279),
    [anon_sym_fptosi] = ACTIONS(279),
    [anon_sym_inttoptr] = ACTIONS(279),
    [anon_sym_ptrtoint] = ACTIONS(279),
    [anon_sym_uselistorder] = ACTIONS(281),
    [anon_sym_uselistorder_bb] = ACTIONS(279),
    [anon_sym_module] = ACTIONS(279),
    [anon_sym_attributes] = ACTIONS(279),
  },
  [72] = {
    [ts_builtin_sym_end] = ACTIONS(363),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(363),
    [sym_comdat_ref] = ACTIONS(363),
    [sym_global_var] = ACTIONS(363),
    [sym_local_var] = ACTIONS(363),
    [aux_sym_metadata_ref_token1] = ACTIONS(363),
    [sym_summary_ref] = ACTIONS(363),
    [sym_string] = ACTIONS(363),
    [aux_sym_number_token1] = ACTIONS(365),
    [aux_sym_number_token2] = ACTIONS(363),
    [sym_float] = ACTIONS(363),
    [sym_cstring] = ACTIONS(363),
    [anon_sym_target] = ACTIONS(363),
    [anon_sym_source_filename] = ACTIONS(363),
    [anon_sym_declare] = ACTIONS(363),
    [anon_sym_define] = ACTIONS(363),
    [anon_sym_no_cfi] = ACTIONS(363),
    [anon_sym_private] = ACTIONS(363),
    [anon_sym_internal] = ACTIONS(363),
    [anon_sym_weak] = ACTIONS(365),
    [anon_sym_weak_odr] = ACTIONS(363),
    [anon_sym_linkonce] = ACTIONS(365),
    [anon_sym_linkonce_odr] = ACTIONS(363),
    [anon_sym_available_externally] = ACTIONS(363),
    [anon_sym_appending] = ACTIONS(363),
    [anon_sym_common] = ACTIONS(363),
    [anon_sym_extern_weak] = ACTIONS(363),
    [anon_sym_external] = ACTIONS(363),
    [anon_sym_dso_local] = ACTIONS(365),
    [anon_sym_dso_local_equivalent] = ACTIONS(363),
    [anon_sym_dso_preemptable] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(363),
    [anon_sym_hidden] = ACTIONS(363),
    [anon_sym_protected] = ACTIONS(363),
    [anon_sym_dllimport] = ACTIONS(363),
    [anon_sym_dllexport] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(363),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_LT_LBRACE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_LT] = ACTIONS(365),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_addrspace] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_align] = ACTIONS(365),
    [anon_sym_section] = ACTIONS(363),
    [anon_sym_partition] = ACTIONS(363),
    [anon_sym_comdat] = ACTIONS(363),
    [anon_sym_gc] = ACTIONS(363),
    [anon_sym_prefix] = ACTIONS(363),
    [anon_sym_prologue] = ACTIONS(363),
    [anon_sym_personality] = ACTIONS(363),
    [anon_sym_alignstack] = ACTIONS(363),
    [anon_sym_allocsize] = ACTIONS(363),
    [anon_sym_alwaysinline] = ACTIONS(363),
    [anon_sym_builtin] = ACTIONS(363),
    [anon_sym_cold] = ACTIONS(363),
    [anon_sym_convergent] = ACTIONS(363),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(363),
    [anon_sym_hot] = ACTIONS(363),
    [anon_sym_inaccessiblememonly] = ACTIONS(363),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(363),
    [anon_sym_inlinehint] = ACTIONS(363),
    [anon_sym_jumptable] = ACTIONS(363),
    [anon_sym_minsize] = ACTIONS(363),
    [anon_sym_naked] = ACTIONS(363),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(363),
    [anon_sym_nobuiltin] = ACTIONS(363),
    [anon_sym_noduplicate] = ACTIONS(363),
    [anon_sym_nofree] = ACTIONS(363),
    [anon_sym_noimplicitfloat] = ACTIONS(363),
    [anon_sym_noinline] = ACTIONS(363),
    [anon_sym_nomerge] = ACTIONS(363),
    [anon_sym_nonlazybind] = ACTIONS(363),
    [anon_sym_noprofile] = ACTIONS(363),
    [anon_sym_noredzone] = ACTIONS(363),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(363),
    [anon_sym_noreturn] = ACTIONS(363),
    [anon_sym_norecurse] = ACTIONS(363),
    [anon_sym_willreturn] = ACTIONS(363),
    [anon_sym_nosync] = ACTIONS(363),
    [anon_sym_nounwind] = ACTIONS(363),
    [anon_sym_nocallback] = ACTIONS(363),
    [anon_sym_nosanitize_coverage] = ACTIONS(363),
    [anon_sym_null_pointer_is_valid] = ACTIONS(363),
    [anon_sym_optforfuzzing] = ACTIONS(363),
    [anon_sym_optnone] = ACTIONS(363),
    [anon_sym_optsize] = ACTIONS(363),
    [anon_sym_readnone] = ACTIONS(363),
    [anon_sym_readonly] = ACTIONS(363),
    [anon_sym_writeonly] = ACTIONS(363),
    [anon_sym_argmemonly] = ACTIONS(363),
    [anon_sym_returns_twice] = ACTIONS(363),
    [anon_sym_safestack] = ACTIONS(363),
    [anon_sym_sanitize_address] = ACTIONS(363),
    [anon_sym_sanitize_memory] = ACTIONS(363),
    [anon_sym_sanitize_thread] = ACTIONS(363),
    [anon_sym_sanitize_hwaddress] = ACTIONS(363),
    [anon_sym_sanitize_memtag] = ACTIONS(363),
    [anon_sym_speculative_load_hardening] = ACTIONS(363),
    [anon_sym_speculatable] = ACTIONS(363),
    [anon_sym_ssp] = ACTIONS(365),
    [anon_sym_sspstrong] = ACTIONS(363),
    [anon_sym_sspreq] = ACTIONS(363),
    [anon_sym_strictfp] = ACTIONS(363),
    [anon_sym_nocf_check] = ACTIONS(363),
    [anon_sym_shadowcallstack] = ACTIONS(363),
    [anon_sym_mustprogress] = ACTIONS(363),
    [anon_sym_vscale_range] = ACTIONS(363),
    [anon_sym_preallocated] = ACTIONS(363),
    [anon_sym_zeroext] = ACTIONS(363),
    [anon_sym_signext] = ACTIONS(363),
    [anon_sym_inreg] = ACTIONS(363),
    [anon_sym_byval] = ACTIONS(363),
    [anon_sym_byref] = ACTIONS(363),
    [anon_sym_inalloca] = ACTIONS(363),
    [anon_sym_sret] = ACTIONS(363),
    [anon_sym_elementtype] = ACTIONS(363),
    [anon_sym_noalias] = ACTIONS(363),
    [anon_sym_nocapture] = ACTIONS(363),
    [anon_sym_nest] = ACTIONS(363),
    [anon_sym_returned] = ACTIONS(363),
    [anon_sym_nonnull] = ACTIONS(363),
    [anon_sym_dereferenceable] = ACTIONS(365),
    [anon_sym_dereferenceable_or_null] = ACTIONS(363),
    [anon_sym_swiftself] = ACTIONS(363),
    [anon_sym_swiftasync] = ACTIONS(363),
    [anon_sym_swifterror] = ACTIONS(363),
    [anon_sym_immarg] = ACTIONS(363),
    [anon_sym_noundef] = ACTIONS(363),
    [anon_sym_uwtable] = ACTIONS(363),
    [anon_sym_memory] = ACTIONS(363),
    [anon_sym_none] = ACTIONS(363),
    [anon_sym_extractelement] = ACTIONS(363),
    [anon_sym_insertelement] = ACTIONS(363),
    [anon_sym_select] = ACTIONS(363),
    [anon_sym_shufflevector] = ACTIONS(363),
    [anon_sym_fneg] = ACTIONS(363),
    [anon_sym_to] = ACTIONS(363),
    [anon_sym_icmp] = ACTIONS(363),
    [anon_sym_fcmp] = ACTIONS(363),
    [anon_sym_getelementptr] = ACTIONS(363),
    [anon_sym_extractvalue] = ACTIONS(363),
    [anon_sym_insertvalue] = ACTIONS(363),
    [anon_sym_true] = ACTIONS(363),
    [anon_sym_false] = ACTIONS(363),
    [anon_sym_null] = ACTIONS(365),
    [anon_sym_undef] = ACTIONS(363),
    [anon_sym_poison] = ACTIONS(363),
    [anon_sym_zeroinitializer] = ACTIONS(363),
    [anon_sym_blockaddress] = ACTIONS(363),
    [anon_sym_mul] = ACTIONS(363),
    [anon_sym_urem] = ACTIONS(363),
    [anon_sym_srem] = ACTIONS(363),
    [anon_sym_shl] = ACTIONS(363),
    [anon_sym_udiv] = ACTIONS(363),
    [anon_sym_sdiv] = ACTIONS(363),
    [anon_sym_lshr] = ACTIONS(363),
    [anon_sym_ashr] = ACTIONS(363),
    [anon_sym_fmul] = ACTIONS(363),
    [anon_sym_fdiv] = ACTIONS(363),
    [anon_sym_frem] = ACTIONS(363),
    [anon_sym_xchg] = ACTIONS(363),
    [anon_sym_add] = ACTIONS(365),
    [anon_sym_sub] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_nand] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_xor] = ACTIONS(363),
    [anon_sym_max] = ACTIONS(363),
    [anon_sym_min] = ACTIONS(365),
    [anon_sym_umax] = ACTIONS(363),
    [anon_sym_umin] = ACTIONS(363),
    [anon_sym_fadd] = ACTIONS(363),
    [anon_sym_fsub] = ACTIONS(363),
    [anon_sym_bitcast] = ACTIONS(363),
    [anon_sym_trunc] = ACTIONS(363),
    [anon_sym_zext] = ACTIONS(363),
    [anon_sym_sext] = ACTIONS(363),
    [anon_sym_fptrunc] = ACTIONS(363),
    [anon_sym_fpext] = ACTIONS(363),
    [anon_sym_addrspacecast] = ACTIONS(363),
    [anon_sym_uitofp] = ACTIONS(363),
    [anon_sym_sitofp] = ACTIONS(363),
    [anon_sym_fptoui] = ACTIONS(363),
    [anon_sym_fptosi] = ACTIONS(363),
    [anon_sym_inttoptr] = ACTIONS(363),
    [anon_sym_ptrtoint] = ACTIONS(363),
    [anon_sym_uselistorder] = ACTIONS(365),
    [anon_sym_uselistorder_bb] = ACTIONS(363),
    [anon_sym_module] = ACTIONS(363),
    [anon_sym_attributes] = ACTIONS(363),
  },
  [73] = {
    [ts_builtin_sym_end] = ACTIONS(269),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(269),
    [sym_comdat_ref] = ACTIONS(269),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [aux_sym_metadata_ref_token1] = ACTIONS(269),
    [sym_summary_ref] = ACTIONS(269),
    [sym_string] = ACTIONS(269),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(269),
    [sym_float] = ACTIONS(269),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_target] = ACTIONS(269),
    [anon_sym_source_filename] = ACTIONS(269),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_define] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_internal] = ACTIONS(269),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(269),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(269),
    [anon_sym_available_externally] = ACTIONS(269),
    [anon_sym_appending] = ACTIONS(269),
    [anon_sym_common] = ACTIONS(269),
    [anon_sym_extern_weak] = ACTIONS(269),
    [anon_sym_external] = ACTIONS(269),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(269),
    [anon_sym_dso_preemptable] = ACTIONS(269),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_hidden] = ACTIONS(269),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_dllimport] = ACTIONS(269),
    [anon_sym_dllexport] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_RPAREN] = ACTIONS(269),
    [anon_sym_align] = ACTIONS(271),
    [anon_sym_section] = ACTIONS(269),
    [anon_sym_partition] = ACTIONS(269),
    [anon_sym_comdat] = ACTIONS(269),
    [anon_sym_gc] = ACTIONS(269),
    [anon_sym_prefix] = ACTIONS(269),
    [anon_sym_prologue] = ACTIONS(269),
    [anon_sym_personality] = ACTIONS(269),
    [anon_sym_alignstack] = ACTIONS(269),
    [anon_sym_allocsize] = ACTIONS(269),
    [anon_sym_alwaysinline] = ACTIONS(269),
    [anon_sym_builtin] = ACTIONS(269),
    [anon_sym_cold] = ACTIONS(269),
    [anon_sym_convergent] = ACTIONS(269),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(269),
    [anon_sym_hot] = ACTIONS(269),
    [anon_sym_inaccessiblememonly] = ACTIONS(269),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(269),
    [anon_sym_inlinehint] = ACTIONS(269),
    [anon_sym_jumptable] = ACTIONS(269),
    [anon_sym_minsize] = ACTIONS(269),
    [anon_sym_naked] = ACTIONS(269),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(269),
    [anon_sym_nobuiltin] = ACTIONS(269),
    [anon_sym_noduplicate] = ACTIONS(269),
    [anon_sym_nofree] = ACTIONS(269),
    [anon_sym_noimplicitfloat] = ACTIONS(269),
    [anon_sym_noinline] = ACTIONS(269),
    [anon_sym_nomerge] = ACTIONS(269),
    [anon_sym_nonlazybind] = ACTIONS(269),
    [anon_sym_noprofile] = ACTIONS(269),
    [anon_sym_noredzone] = ACTIONS(269),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(269),
    [anon_sym_noreturn] = ACTIONS(269),
    [anon_sym_norecurse] = ACTIONS(269),
    [anon_sym_willreturn] = ACTIONS(269),
    [anon_sym_nosync] = ACTIONS(269),
    [anon_sym_nounwind] = ACTIONS(269),
    [anon_sym_nocallback] = ACTIONS(269),
    [anon_sym_nosanitize_coverage] = ACTIONS(269),
    [anon_sym_null_pointer_is_valid] = ACTIONS(269),
    [anon_sym_optforfuzzing] = ACTIONS(269),
    [anon_sym_optnone] = ACTIONS(269),
    [anon_sym_optsize] = ACTIONS(269),
    [anon_sym_readnone] = ACTIONS(269),
    [anon_sym_readonly] = ACTIONS(269),
    [anon_sym_writeonly] = ACTIONS(269),
    [anon_sym_argmemonly] = ACTIONS(269),
    [anon_sym_returns_twice] = ACTIONS(269),
    [anon_sym_safestack] = ACTIONS(269),
    [anon_sym_sanitize_address] = ACTIONS(269),
    [anon_sym_sanitize_memory] = ACTIONS(269),
    [anon_sym_sanitize_thread] = ACTIONS(269),
    [anon_sym_sanitize_hwaddress] = ACTIONS(269),
    [anon_sym_sanitize_memtag] = ACTIONS(269),
    [anon_sym_speculative_load_hardening] = ACTIONS(269),
    [anon_sym_speculatable] = ACTIONS(269),
    [anon_sym_ssp] = ACTIONS(271),
    [anon_sym_sspstrong] = ACTIONS(269),
    [anon_sym_sspreq] = ACTIONS(269),
    [anon_sym_strictfp] = ACTIONS(269),
    [anon_sym_nocf_check] = ACTIONS(269),
    [anon_sym_shadowcallstack] = ACTIONS(269),
    [anon_sym_mustprogress] = ACTIONS(269),
    [anon_sym_vscale_range] = ACTIONS(269),
    [anon_sym_preallocated] = ACTIONS(269),
    [anon_sym_zeroext] = ACTIONS(269),
    [anon_sym_signext] = ACTIONS(269),
    [anon_sym_inreg] = ACTIONS(269),
    [anon_sym_byval] = ACTIONS(269),
    [anon_sym_byref] = ACTIONS(269),
    [anon_sym_inalloca] = ACTIONS(269),
    [anon_sym_sret] = ACTIONS(269),
    [anon_sym_elementtype] = ACTIONS(269),
    [anon_sym_noalias] = ACTIONS(269),
    [anon_sym_nocapture] = ACTIONS(269),
    [anon_sym_nest] = ACTIONS(269),
    [anon_sym_returned] = ACTIONS(269),
    [anon_sym_nonnull] = ACTIONS(269),
    [anon_sym_dereferenceable] = ACTIONS(271),
    [anon_sym_dereferenceable_or_null] = ACTIONS(269),
    [anon_sym_swiftself] = ACTIONS(269),
    [anon_sym_swiftasync] = ACTIONS(269),
    [anon_sym_swifterror] = ACTIONS(269),
    [anon_sym_immarg] = ACTIONS(269),
    [anon_sym_noundef] = ACTIONS(269),
    [anon_sym_uwtable] = ACTIONS(269),
    [anon_sym_memory] = ACTIONS(269),
    [anon_sym_none] = ACTIONS(269),
    [anon_sym_extractelement] = ACTIONS(269),
    [anon_sym_insertelement] = ACTIONS(269),
    [anon_sym_select] = ACTIONS(269),
    [anon_sym_shufflevector] = ACTIONS(269),
    [anon_sym_fneg] = ACTIONS(269),
    [anon_sym_to] = ACTIONS(269),
    [anon_sym_icmp] = ACTIONS(269),
    [anon_sym_fcmp] = ACTIONS(269),
    [anon_sym_getelementptr] = ACTIONS(269),
    [anon_sym_extractvalue] = ACTIONS(269),
    [anon_sym_insertvalue] = ACTIONS(269),
    [anon_sym_true] = ACTIONS(269),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_null] = ACTIONS(271),
    [anon_sym_undef] = ACTIONS(269),
    [anon_sym_poison] = ACTIONS(269),
    [anon_sym_zeroinitializer] = ACTIONS(269),
    [anon_sym_blockaddress] = ACTIONS(269),
    [anon_sym_mul] = ACTIONS(269),
    [anon_sym_urem] = ACTIONS(269),
    [anon_sym_srem] = ACTIONS(269),
    [anon_sym_shl] = ACTIONS(269),
    [anon_sym_udiv] = ACTIONS(269),
    [anon_sym_sdiv] = ACTIONS(269),
    [anon_sym_lshr] = ACTIONS(269),
    [anon_sym_ashr] = ACTIONS(269),
    [anon_sym_fmul] = ACTIONS(269),
    [anon_sym_fdiv] = ACTIONS(269),
    [anon_sym_frem] = ACTIONS(269),
    [anon_sym_xchg] = ACTIONS(269),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(269),
    [anon_sym_and] = ACTIONS(269),
    [anon_sym_nand] = ACTIONS(269),
    [anon_sym_or] = ACTIONS(269),
    [anon_sym_xor] = ACTIONS(269),
    [anon_sym_max] = ACTIONS(269),
    [anon_sym_min] = ACTIONS(271),
    [anon_sym_umax] = ACTIONS(269),
    [anon_sym_umin] = ACTIONS(269),
    [anon_sym_fadd] = ACTIONS(269),
    [anon_sym_fsub] = ACTIONS(269),
    [anon_sym_bitcast] = ACTIONS(269),
    [anon_sym_trunc] = ACTIONS(269),
    [anon_sym_zext] = ACTIONS(269),
    [anon_sym_sext] = ACTIONS(269),
    [anon_sym_fptrunc] = ACTIONS(269),
    [anon_sym_fpext] = ACTIONS(269),
    [anon_sym_addrspacecast] = ACTIONS(269),
    [anon_sym_uitofp] = ACTIONS(269),
    [anon_sym_sitofp] = ACTIONS(269),
    [anon_sym_fptoui] = ACTIONS(269),
    [anon_sym_fptosi] = ACTIONS(269),
    [anon_sym_inttoptr] = ACTIONS(269),
    [anon_sym_ptrtoint] = ACTIONS(269),
    [anon_sym_uselistorder] = ACTIONS(271),
    [anon_sym_uselistorder_bb] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_attributes] = ACTIONS(269),
  },
  [74] = {
    [ts_builtin_sym_end] = ACTIONS(359),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(359),
    [sym_comdat_ref] = ACTIONS(359),
    [sym_global_var] = ACTIONS(359),
    [sym_local_var] = ACTIONS(359),
    [aux_sym_metadata_ref_token1] = ACTIONS(359),
    [sym_summary_ref] = ACTIONS(359),
    [sym_string] = ACTIONS(359),
    [aux_sym_number_token1] = ACTIONS(361),
    [aux_sym_number_token2] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_cstring] = ACTIONS(359),
    [anon_sym_target] = ACTIONS(359),
    [anon_sym_source_filename] = ACTIONS(359),
    [anon_sym_declare] = ACTIONS(359),
    [anon_sym_define] = ACTIONS(359),
    [anon_sym_no_cfi] = ACTIONS(359),
    [anon_sym_private] = ACTIONS(359),
    [anon_sym_internal] = ACTIONS(359),
    [anon_sym_weak] = ACTIONS(361),
    [anon_sym_weak_odr] = ACTIONS(359),
    [anon_sym_linkonce] = ACTIONS(361),
    [anon_sym_linkonce_odr] = ACTIONS(359),
    [anon_sym_available_externally] = ACTIONS(359),
    [anon_sym_appending] = ACTIONS(359),
    [anon_sym_common] = ACTIONS(359),
    [anon_sym_extern_weak] = ACTIONS(359),
    [anon_sym_external] = ACTIONS(359),
    [anon_sym_dso_local] = ACTIONS(361),
    [anon_sym_dso_local_equivalent] = ACTIONS(359),
    [anon_sym_dso_preemptable] = ACTIONS(359),
    [anon_sym_default] = ACTIONS(359),
    [anon_sym_hidden] = ACTIONS(359),
    [anon_sym_protected] = ACTIONS(359),
    [anon_sym_dllimport] = ACTIONS(359),
    [anon_sym_dllexport] = ACTIONS(359),
    [anon_sym_STAR] = ACTIONS(359),
    [anon_sym_LBRACE] = ACTIONS(359),
    [anon_sym_RBRACE] = ACTIONS(359),
    [anon_sym_LT_LBRACE] = ACTIONS(359),
    [anon_sym_LBRACK] = ACTIONS(359),
    [anon_sym_LT] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(359),
    [anon_sym_addrspace] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(359),
    [anon_sym_RPAREN] = ACTIONS(359),
    [anon_sym_align] = ACTIONS(361),
    [anon_sym_section] = ACTIONS(359),
    [anon_sym_partition] = ACTIONS(359),
    [anon_sym_comdat] = ACTIONS(359),
    [anon_sym_gc] = ACTIONS(359),
    [anon_sym_prefix] = ACTIONS(359),
    [anon_sym_prologue] = ACTIONS(359),
    [anon_sym_personality] = ACTIONS(359),
    [anon_sym_alignstack] = ACTIONS(359),
    [anon_sym_allocsize] = ACTIONS(359),
    [anon_sym_alwaysinline] = ACTIONS(359),
    [anon_sym_builtin] = ACTIONS(359),
    [anon_sym_cold] = ACTIONS(359),
    [anon_sym_convergent] = ACTIONS(359),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(359),
    [anon_sym_hot] = ACTIONS(359),
    [anon_sym_inaccessiblememonly] = ACTIONS(359),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(359),
    [anon_sym_inlinehint] = ACTIONS(359),
    [anon_sym_jumptable] = ACTIONS(359),
    [anon_sym_minsize] = ACTIONS(359),
    [anon_sym_naked] = ACTIONS(359),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(359),
    [anon_sym_nobuiltin] = ACTIONS(359),
    [anon_sym_noduplicate] = ACTIONS(359),
    [anon_sym_nofree] = ACTIONS(359),
    [anon_sym_noimplicitfloat] = ACTIONS(359),
    [anon_sym_noinline] = ACTIONS(359),
    [anon_sym_nomerge] = ACTIONS(359),
    [anon_sym_nonlazybind] = ACTIONS(359),
    [anon_sym_noprofile] = ACTIONS(359),
    [anon_sym_noredzone] = ACTIONS(359),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(359),
    [anon_sym_noreturn] = ACTIONS(359),
    [anon_sym_norecurse] = ACTIONS(359),
    [anon_sym_willreturn] = ACTIONS(359),
    [anon_sym_nosync] = ACTIONS(359),
    [anon_sym_nounwind] = ACTIONS(359),
    [anon_sym_nocallback] = ACTIONS(359),
    [anon_sym_nosanitize_coverage] = ACTIONS(359),
    [anon_sym_null_pointer_is_valid] = ACTIONS(359),
    [anon_sym_optforfuzzing] = ACTIONS(359),
    [anon_sym_optnone] = ACTIONS(359),
    [anon_sym_optsize] = ACTIONS(359),
    [anon_sym_readnone] = ACTIONS(359),
    [anon_sym_readonly] = ACTIONS(359),
    [anon_sym_writeonly] = ACTIONS(359),
    [anon_sym_argmemonly] = ACTIONS(359),
    [anon_sym_returns_twice] = ACTIONS(359),
    [anon_sym_safestack] = ACTIONS(359),
    [anon_sym_sanitize_address] = ACTIONS(359),
    [anon_sym_sanitize_memory] = ACTIONS(359),
    [anon_sym_sanitize_thread] = ACTIONS(359),
    [anon_sym_sanitize_hwaddress] = ACTIONS(359),
    [anon_sym_sanitize_memtag] = ACTIONS(359),
    [anon_sym_speculative_load_hardening] = ACTIONS(359),
    [anon_sym_speculatable] = ACTIONS(359),
    [anon_sym_ssp] = ACTIONS(361),
    [anon_sym_sspstrong] = ACTIONS(359),
    [anon_sym_sspreq] = ACTIONS(359),
    [anon_sym_strictfp] = ACTIONS(359),
    [anon_sym_nocf_check] = ACTIONS(359),
    [anon_sym_shadowcallstack] = ACTIONS(359),
    [anon_sym_mustprogress] = ACTIONS(359),
    [anon_sym_vscale_range] = ACTIONS(359),
    [anon_sym_preallocated] = ACTIONS(359),
    [anon_sym_zeroext] = ACTIONS(359),
    [anon_sym_signext] = ACTIONS(359),
    [anon_sym_inreg] = ACTIONS(359),
    [anon_sym_byval] = ACTIONS(359),
    [anon_sym_byref] = ACTIONS(359),
    [anon_sym_inalloca] = ACTIONS(359),
    [anon_sym_sret] = ACTIONS(359),
    [anon_sym_elementtype] = ACTIONS(359),
    [anon_sym_noalias] = ACTIONS(359),
    [anon_sym_nocapture] = ACTIONS(359),
    [anon_sym_nest] = ACTIONS(359),
    [anon_sym_returned] = ACTIONS(359),
    [anon_sym_nonnull] = ACTIONS(359),
    [anon_sym_dereferenceable] = ACTIONS(361),
    [anon_sym_dereferenceable_or_null] = ACTIONS(359),
    [anon_sym_swiftself] = ACTIONS(359),
    [anon_sym_swiftasync] = ACTIONS(359),
    [anon_sym_swifterror] = ACTIONS(359),
    [anon_sym_immarg] = ACTIONS(359),
    [anon_sym_noundef] = ACTIONS(359),
    [anon_sym_uwtable] = ACTIONS(359),
    [anon_sym_memory] = ACTIONS(359),
    [anon_sym_none] = ACTIONS(359),
    [anon_sym_extractelement] = ACTIONS(359),
    [anon_sym_insertelement] = ACTIONS(359),
    [anon_sym_select] = ACTIONS(359),
    [anon_sym_shufflevector] = ACTIONS(359),
    [anon_sym_fneg] = ACTIONS(359),
    [anon_sym_to] = ACTIONS(359),
    [anon_sym_icmp] = ACTIONS(359),
    [anon_sym_fcmp] = ACTIONS(359),
    [anon_sym_getelementptr] = ACTIONS(359),
    [anon_sym_extractvalue] = ACTIONS(359),
    [anon_sym_insertvalue] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(359),
    [anon_sym_false] = ACTIONS(359),
    [anon_sym_null] = ACTIONS(361),
    [anon_sym_undef] = ACTIONS(359),
    [anon_sym_poison] = ACTIONS(359),
    [anon_sym_zeroinitializer] = ACTIONS(359),
    [anon_sym_blockaddress] = ACTIONS(359),
    [anon_sym_mul] = ACTIONS(359),
    [anon_sym_urem] = ACTIONS(359),
    [anon_sym_srem] = ACTIONS(359),
    [anon_sym_shl] = ACTIONS(359),
    [anon_sym_udiv] = ACTIONS(359),
    [anon_sym_sdiv] = ACTIONS(359),
    [anon_sym_lshr] = ACTIONS(359),
    [anon_sym_ashr] = ACTIONS(359),
    [anon_sym_fmul] = ACTIONS(359),
    [anon_sym_fdiv] = ACTIONS(359),
    [anon_sym_frem] = ACTIONS(359),
    [anon_sym_xchg] = ACTIONS(359),
    [anon_sym_add] = ACTIONS(361),
    [anon_sym_sub] = ACTIONS(359),
    [anon_sym_and] = ACTIONS(359),
    [anon_sym_nand] = ACTIONS(359),
    [anon_sym_or] = ACTIONS(359),
    [anon_sym_xor] = ACTIONS(359),
    [anon_sym_max] = ACTIONS(359),
    [anon_sym_min] = ACTIONS(361),
    [anon_sym_umax] = ACTIONS(359),
    [anon_sym_umin] = ACTIONS(359),
    [anon_sym_fadd] = ACTIONS(359),
    [anon_sym_fsub] = ACTIONS(359),
    [anon_sym_bitcast] = ACTIONS(359),
    [anon_sym_trunc] = ACTIONS(359),
    [anon_sym_zext] = ACTIONS(359),
    [anon_sym_sext] = ACTIONS(359),
    [anon_sym_fptrunc] = ACTIONS(359),
    [anon_sym_fpext] = ACTIONS(359),
    [anon_sym_addrspacecast] = ACTIONS(359),
    [anon_sym_uitofp] = ACTIONS(359),
    [anon_sym_sitofp] = ACTIONS(359),
    [anon_sym_fptoui] = ACTIONS(359),
    [anon_sym_fptosi] = ACTIONS(359),
    [anon_sym_inttoptr] = ACTIONS(359),
    [anon_sym_ptrtoint] = ACTIONS(359),
    [anon_sym_uselistorder] = ACTIONS(361),
    [anon_sym_uselistorder_bb] = ACTIONS(359),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_attributes] = ACTIONS(359),
  },
  [75] = {
    [ts_builtin_sym_end] = ACTIONS(116),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(116),
    [sym_comdat_ref] = ACTIONS(116),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(116),
    [aux_sym_metadata_ref_token1] = ACTIONS(116),
    [sym_summary_ref] = ACTIONS(116),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_target] = ACTIONS(116),
    [anon_sym_source_filename] = ACTIONS(116),
    [anon_sym_declare] = ACTIONS(116),
    [anon_sym_define] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(116),
    [anon_sym_RBRACE] = ACTIONS(116),
    [anon_sym_LT_LBRACE] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(116),
    [anon_sym_LT] = ACTIONS(122),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_RPAREN] = ACTIONS(116),
    [anon_sym_align] = ACTIONS(122),
    [anon_sym_section] = ACTIONS(116),
    [anon_sym_partition] = ACTIONS(116),
    [anon_sym_comdat] = ACTIONS(116),
    [anon_sym_gc] = ACTIONS(116),
    [anon_sym_prefix] = ACTIONS(116),
    [anon_sym_prologue] = ACTIONS(116),
    [anon_sym_personality] = ACTIONS(116),
    [anon_sym_alignstack] = ACTIONS(116),
    [anon_sym_allocsize] = ACTIONS(116),
    [anon_sym_alwaysinline] = ACTIONS(116),
    [anon_sym_builtin] = ACTIONS(116),
    [anon_sym_cold] = ACTIONS(116),
    [anon_sym_convergent] = ACTIONS(116),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(116),
    [anon_sym_hot] = ACTIONS(116),
    [anon_sym_inaccessiblememonly] = ACTIONS(116),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(116),
    [anon_sym_inlinehint] = ACTIONS(116),
    [anon_sym_jumptable] = ACTIONS(116),
    [anon_sym_minsize] = ACTIONS(116),
    [anon_sym_naked] = ACTIONS(116),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(116),
    [anon_sym_nobuiltin] = ACTIONS(116),
    [anon_sym_noduplicate] = ACTIONS(116),
    [anon_sym_nofree] = ACTIONS(116),
    [anon_sym_noimplicitfloat] = ACTIONS(116),
    [anon_sym_noinline] = ACTIONS(116),
    [anon_sym_nomerge] = ACTIONS(116),
    [anon_sym_nonlazybind] = ACTIONS(116),
    [anon_sym_noprofile] = ACTIONS(116),
    [anon_sym_noredzone] = ACTIONS(116),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(116),
    [anon_sym_noreturn] = ACTIONS(116),
    [anon_sym_norecurse] = ACTIONS(116),
    [anon_sym_willreturn] = ACTIONS(116),
    [anon_sym_nosync] = ACTIONS(116),
    [anon_sym_nounwind] = ACTIONS(116),
    [anon_sym_nocallback] = ACTIONS(116),
    [anon_sym_nosanitize_coverage] = ACTIONS(116),
    [anon_sym_null_pointer_is_valid] = ACTIONS(116),
    [anon_sym_optforfuzzing] = ACTIONS(116),
    [anon_sym_optnone] = ACTIONS(116),
    [anon_sym_optsize] = ACTIONS(116),
    [anon_sym_readnone] = ACTIONS(116),
    [anon_sym_readonly] = ACTIONS(116),
    [anon_sym_writeonly] = ACTIONS(116),
    [anon_sym_argmemonly] = ACTIONS(116),
    [anon_sym_returns_twice] = ACTIONS(116),
    [anon_sym_safestack] = ACTIONS(116),
    [anon_sym_sanitize_address] = ACTIONS(116),
    [anon_sym_sanitize_memory] = ACTIONS(116),
    [anon_sym_sanitize_thread] = ACTIONS(116),
    [anon_sym_sanitize_hwaddress] = ACTIONS(116),
    [anon_sym_sanitize_memtag] = ACTIONS(116),
    [anon_sym_speculative_load_hardening] = ACTIONS(116),
    [anon_sym_speculatable] = ACTIONS(116),
    [anon_sym_ssp] = ACTIONS(122),
    [anon_sym_sspstrong] = ACTIONS(116),
    [anon_sym_sspreq] = ACTIONS(116),
    [anon_sym_strictfp] = ACTIONS(116),
    [anon_sym_nocf_check] = ACTIONS(116),
    [anon_sym_shadowcallstack] = ACTIONS(116),
    [anon_sym_mustprogress] = ACTIONS(116),
    [anon_sym_vscale_range] = ACTIONS(116),
    [anon_sym_preallocated] = ACTIONS(116),
    [anon_sym_zeroext] = ACTIONS(116),
    [anon_sym_signext] = ACTIONS(116),
    [anon_sym_inreg] = ACTIONS(116),
    [anon_sym_byval] = ACTIONS(116),
    [anon_sym_byref] = ACTIONS(116),
    [anon_sym_inalloca] = ACTIONS(116),
    [anon_sym_sret] = ACTIONS(116),
    [anon_sym_elementtype] = ACTIONS(116),
    [anon_sym_noalias] = ACTIONS(116),
    [anon_sym_nocapture] = ACTIONS(116),
    [anon_sym_nest] = ACTIONS(116),
    [anon_sym_returned] = ACTIONS(116),
    [anon_sym_nonnull] = ACTIONS(116),
    [anon_sym_dereferenceable] = ACTIONS(122),
    [anon_sym_dereferenceable_or_null] = ACTIONS(116),
    [anon_sym_swiftself] = ACTIONS(116),
    [anon_sym_swiftasync] = ACTIONS(116),
    [anon_sym_swifterror] = ACTIONS(116),
    [anon_sym_immarg] = ACTIONS(116),
    [anon_sym_noundef] = ACTIONS(116),
    [anon_sym_uwtable] = ACTIONS(116),
    [anon_sym_memory] = ACTIONS(116),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_to] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(122),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_uselistorder] = ACTIONS(122),
    [anon_sym_uselistorder_bb] = ACTIONS(116),
    [anon_sym_module] = ACTIONS(116),
    [anon_sym_attributes] = ACTIONS(116),
  },
  [76] = {
    [ts_builtin_sym_end] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(375),
    [sym_comdat_ref] = ACTIONS(375),
    [sym_global_var] = ACTIONS(375),
    [sym_local_var] = ACTIONS(375),
    [aux_sym_metadata_ref_token1] = ACTIONS(375),
    [sym_summary_ref] = ACTIONS(375),
    [sym_string] = ACTIONS(375),
    [aux_sym_number_token1] = ACTIONS(377),
    [aux_sym_number_token2] = ACTIONS(375),
    [sym_float] = ACTIONS(375),
    [sym_cstring] = ACTIONS(375),
    [anon_sym_target] = ACTIONS(375),
    [anon_sym_source_filename] = ACTIONS(375),
    [anon_sym_declare] = ACTIONS(375),
    [anon_sym_define] = ACTIONS(375),
    [anon_sym_no_cfi] = ACTIONS(375),
    [anon_sym_private] = ACTIONS(375),
    [anon_sym_internal] = ACTIONS(375),
    [anon_sym_weak] = ACTIONS(377),
    [anon_sym_weak_odr] = ACTIONS(375),
    [anon_sym_linkonce] = ACTIONS(377),
    [anon_sym_linkonce_odr] = ACTIONS(375),
    [anon_sym_available_externally] = ACTIONS(375),
    [anon_sym_appending] = ACTIONS(375),
    [anon_sym_common] = ACTIONS(375),
    [anon_sym_extern_weak] = ACTIONS(375),
    [anon_sym_external] = ACTIONS(375),
    [anon_sym_dso_local] = ACTIONS(377),
    [anon_sym_dso_local_equivalent] = ACTIONS(375),
    [anon_sym_dso_preemptable] = ACTIONS(375),
    [anon_sym_default] = ACTIONS(375),
    [anon_sym_hidden] = ACTIONS(375),
    [anon_sym_protected] = ACTIONS(375),
    [anon_sym_dllimport] = ACTIONS(375),
    [anon_sym_dllexport] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(375),
    [anon_sym_RBRACE] = ACTIONS(375),
    [anon_sym_LT_LBRACE] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_COMMA] = ACTIONS(375),
    [anon_sym_addrspace] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_RPAREN] = ACTIONS(375),
    [anon_sym_align] = ACTIONS(377),
    [anon_sym_section] = ACTIONS(375),
    [anon_sym_partition] = ACTIONS(375),
    [anon_sym_comdat] = ACTIONS(375),
    [anon_sym_gc] = ACTIONS(375),
    [anon_sym_prefix] = ACTIONS(375),
    [anon_sym_prologue] = ACTIONS(375),
    [anon_sym_personality] = ACTIONS(375),
    [anon_sym_alignstack] = ACTIONS(375),
    [anon_sym_allocsize] = ACTIONS(375),
    [anon_sym_alwaysinline] = ACTIONS(375),
    [anon_sym_builtin] = ACTIONS(375),
    [anon_sym_cold] = ACTIONS(375),
    [anon_sym_convergent] = ACTIONS(375),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(375),
    [anon_sym_hot] = ACTIONS(375),
    [anon_sym_inaccessiblememonly] = ACTIONS(375),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(375),
    [anon_sym_inlinehint] = ACTIONS(375),
    [anon_sym_jumptable] = ACTIONS(375),
    [anon_sym_minsize] = ACTIONS(375),
    [anon_sym_naked] = ACTIONS(375),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(375),
    [anon_sym_nobuiltin] = ACTIONS(375),
    [anon_sym_noduplicate] = ACTIONS(375),
    [anon_sym_nofree] = ACTIONS(375),
    [anon_sym_noimplicitfloat] = ACTIONS(375),
    [anon_sym_noinline] = ACTIONS(375),
    [anon_sym_nomerge] = ACTIONS(375),
    [anon_sym_nonlazybind] = ACTIONS(375),
    [anon_sym_noprofile] = ACTIONS(375),
    [anon_sym_noredzone] = ACTIONS(375),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(375),
    [anon_sym_noreturn] = ACTIONS(375),
    [anon_sym_norecurse] = ACTIONS(375),
    [anon_sym_willreturn] = ACTIONS(375),
    [anon_sym_nosync] = ACTIONS(375),
    [anon_sym_nounwind] = ACTIONS(375),
    [anon_sym_nocallback] = ACTIONS(375),
    [anon_sym_nosanitize_coverage] = ACTIONS(375),
    [anon_sym_null_pointer_is_valid] = ACTIONS(375),
    [anon_sym_optforfuzzing] = ACTIONS(375),
    [anon_sym_optnone] = ACTIONS(375),
    [anon_sym_optsize] = ACTIONS(375),
    [anon_sym_readnone] = ACTIONS(375),
    [anon_sym_readonly] = ACTIONS(375),
    [anon_sym_writeonly] = ACTIONS(375),
    [anon_sym_argmemonly] = ACTIONS(375),
    [anon_sym_returns_twice] = ACTIONS(375),
    [anon_sym_safestack] = ACTIONS(375),
    [anon_sym_sanitize_address] = ACTIONS(375),
    [anon_sym_sanitize_memory] = ACTIONS(375),
    [anon_sym_sanitize_thread] = ACTIONS(375),
    [anon_sym_sanitize_hwaddress] = ACTIONS(375),
    [anon_sym_sanitize_memtag] = ACTIONS(375),
    [anon_sym_speculative_load_hardening] = ACTIONS(375),
    [anon_sym_speculatable] = ACTIONS(375),
    [anon_sym_ssp] = ACTIONS(377),
    [anon_sym_sspstrong] = ACTIONS(375),
    [anon_sym_sspreq] = ACTIONS(375),
    [anon_sym_strictfp] = ACTIONS(375),
    [anon_sym_nocf_check] = ACTIONS(375),
    [anon_sym_shadowcallstack] = ACTIONS(375),
    [anon_sym_mustprogress] = ACTIONS(375),
    [anon_sym_vscale_range] = ACTIONS(375),
    [anon_sym_preallocated] = ACTIONS(375),
    [anon_sym_zeroext] = ACTIONS(375),
    [anon_sym_signext] = ACTIONS(375),
    [anon_sym_inreg] = ACTIONS(375),
    [anon_sym_byval] = ACTIONS(375),
    [anon_sym_byref] = ACTIONS(375),
    [anon_sym_inalloca] = ACTIONS(375),
    [anon_sym_sret] = ACTIONS(375),
    [anon_sym_elementtype] = ACTIONS(375),
    [anon_sym_noalias] = ACTIONS(375),
    [anon_sym_nocapture] = ACTIONS(375),
    [anon_sym_nest] = ACTIONS(375),
    [anon_sym_returned] = ACTIONS(375),
    [anon_sym_nonnull] = ACTIONS(375),
    [anon_sym_dereferenceable] = ACTIONS(377),
    [anon_sym_dereferenceable_or_null] = ACTIONS(375),
    [anon_sym_swiftself] = ACTIONS(375),
    [anon_sym_swiftasync] = ACTIONS(375),
    [anon_sym_swifterror] = ACTIONS(375),
    [anon_sym_immarg] = ACTIONS(375),
    [anon_sym_noundef] = ACTIONS(375),
    [anon_sym_uwtable] = ACTIONS(375),
    [anon_sym_memory] = ACTIONS(375),
    [anon_sym_none] = ACTIONS(375),
    [anon_sym_extractelement] = ACTIONS(375),
    [anon_sym_insertelement] = ACTIONS(375),
    [anon_sym_select] = ACTIONS(375),
    [anon_sym_shufflevector] = ACTIONS(375),
    [anon_sym_fneg] = ACTIONS(375),
    [anon_sym_to] = ACTIONS(375),
    [anon_sym_icmp] = ACTIONS(375),
    [anon_sym_fcmp] = ACTIONS(375),
    [anon_sym_getelementptr] = ACTIONS(375),
    [anon_sym_extractvalue] = ACTIONS(375),
    [anon_sym_insertvalue] = ACTIONS(375),
    [anon_sym_true] = ACTIONS(375),
    [anon_sym_false] = ACTIONS(375),
    [anon_sym_null] = ACTIONS(377),
    [anon_sym_undef] = ACTIONS(375),
    [anon_sym_poison] = ACTIONS(375),
    [anon_sym_zeroinitializer] = ACTIONS(375),
    [anon_sym_blockaddress] = ACTIONS(375),
    [anon_sym_mul] = ACTIONS(375),
    [anon_sym_urem] = ACTIONS(375),
    [anon_sym_srem] = ACTIONS(375),
    [anon_sym_shl] = ACTIONS(375),
    [anon_sym_udiv] = ACTIONS(375),
    [anon_sym_sdiv] = ACTIONS(375),
    [anon_sym_lshr] = ACTIONS(375),
    [anon_sym_ashr] = ACTIONS(375),
    [anon_sym_fmul] = ACTIONS(375),
    [anon_sym_fdiv] = ACTIONS(375),
    [anon_sym_frem] = ACTIONS(375),
    [anon_sym_xchg] = ACTIONS(375),
    [anon_sym_add] = ACTIONS(377),
    [anon_sym_sub] = ACTIONS(375),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_nand] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_xor] = ACTIONS(375),
    [anon_sym_max] = ACTIONS(375),
    [anon_sym_min] = ACTIONS(377),
    [anon_sym_umax] = ACTIONS(375),
    [anon_sym_umin] = ACTIONS(375),
    [anon_sym_fadd] = ACTIONS(375),
    [anon_sym_fsub] = ACTIONS(375),
    [anon_sym_bitcast] = ACTIONS(375),
    [anon_sym_trunc] = ACTIONS(375),
    [anon_sym_zext] = ACTIONS(375),
    [anon_sym_sext] = ACTIONS(375),
    [anon_sym_fptrunc] = ACTIONS(375),
    [anon_sym_fpext] = ACTIONS(375),
    [anon_sym_addrspacecast] = ACTIONS(375),
    [anon_sym_uitofp] = ACTIONS(375),
    [anon_sym_sitofp] = ACTIONS(375),
    [anon_sym_fptoui] = ACTIONS(375),
    [anon_sym_fptosi] = ACTIONS(375),
    [anon_sym_inttoptr] = ACTIONS(375),
    [anon_sym_ptrtoint] = ACTIONS(375),
    [anon_sym_uselistorder] = ACTIONS(377),
    [anon_sym_uselistorder_bb] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(375),
    [anon_sym_attributes] = ACTIONS(375),
  },
  [77] = {
    [ts_builtin_sym_end] = ACTIONS(250),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(250),
    [sym_comdat_ref] = ACTIONS(250),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [aux_sym_metadata_ref_token1] = ACTIONS(250),
    [sym_summary_ref] = ACTIONS(250),
    [sym_string] = ACTIONS(250),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(250),
    [sym_float] = ACTIONS(250),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_target] = ACTIONS(250),
    [anon_sym_source_filename] = ACTIONS(250),
    [anon_sym_declare] = ACTIONS(250),
    [anon_sym_define] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(250),
    [anon_sym_private] = ACTIONS(250),
    [anon_sym_internal] = ACTIONS(250),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(250),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(250),
    [anon_sym_available_externally] = ACTIONS(250),
    [anon_sym_appending] = ACTIONS(250),
    [anon_sym_common] = ACTIONS(250),
    [anon_sym_extern_weak] = ACTIONS(250),
    [anon_sym_external] = ACTIONS(250),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(250),
    [anon_sym_dso_preemptable] = ACTIONS(250),
    [anon_sym_default] = ACTIONS(250),
    [anon_sym_hidden] = ACTIONS(250),
    [anon_sym_protected] = ACTIONS(250),
    [anon_sym_dllimport] = ACTIONS(250),
    [anon_sym_dllexport] = ACTIONS(250),
    [anon_sym_STAR] = ACTIONS(250),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(252),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_RPAREN] = ACTIONS(250),
    [anon_sym_align] = ACTIONS(252),
    [anon_sym_section] = ACTIONS(250),
    [anon_sym_partition] = ACTIONS(250),
    [anon_sym_comdat] = ACTIONS(250),
    [anon_sym_gc] = ACTIONS(250),
    [anon_sym_prefix] = ACTIONS(250),
    [anon_sym_prologue] = ACTIONS(250),
    [anon_sym_personality] = ACTIONS(250),
    [anon_sym_alignstack] = ACTIONS(250),
    [anon_sym_allocsize] = ACTIONS(250),
    [anon_sym_alwaysinline] = ACTIONS(250),
    [anon_sym_builtin] = ACTIONS(250),
    [anon_sym_cold] = ACTIONS(250),
    [anon_sym_convergent] = ACTIONS(250),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(250),
    [anon_sym_hot] = ACTIONS(250),
    [anon_sym_inaccessiblememonly] = ACTIONS(250),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(250),
    [anon_sym_inlinehint] = ACTIONS(250),
    [anon_sym_jumptable] = ACTIONS(250),
    [anon_sym_minsize] = ACTIONS(250),
    [anon_sym_naked] = ACTIONS(250),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(250),
    [anon_sym_nobuiltin] = ACTIONS(250),
    [anon_sym_noduplicate] = ACTIONS(250),
    [anon_sym_nofree] = ACTIONS(250),
    [anon_sym_noimplicitfloat] = ACTIONS(250),
    [anon_sym_noinline] = ACTIONS(250),
    [anon_sym_nomerge] = ACTIONS(250),
    [anon_sym_nonlazybind] = ACTIONS(250),
    [anon_sym_noprofile] = ACTIONS(250),
    [anon_sym_noredzone] = ACTIONS(250),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(250),
    [anon_sym_noreturn] = ACTIONS(250),
    [anon_sym_norecurse] = ACTIONS(250),
    [anon_sym_willreturn] = ACTIONS(250),
    [anon_sym_nosync] = ACTIONS(250),
    [anon_sym_nounwind] = ACTIONS(250),
    [anon_sym_nocallback] = ACTIONS(250),
    [anon_sym_nosanitize_coverage] = ACTIONS(250),
    [anon_sym_null_pointer_is_valid] = ACTIONS(250),
    [anon_sym_optforfuzzing] = ACTIONS(250),
    [anon_sym_optnone] = ACTIONS(250),
    [anon_sym_optsize] = ACTIONS(250),
    [anon_sym_readnone] = ACTIONS(250),
    [anon_sym_readonly] = ACTIONS(250),
    [anon_sym_writeonly] = ACTIONS(250),
    [anon_sym_argmemonly] = ACTIONS(250),
    [anon_sym_returns_twice] = ACTIONS(250),
    [anon_sym_safestack] = ACTIONS(250),
    [anon_sym_sanitize_address] = ACTIONS(250),
    [anon_sym_sanitize_memory] = ACTIONS(250),
    [anon_sym_sanitize_thread] = ACTIONS(250),
    [anon_sym_sanitize_hwaddress] = ACTIONS(250),
    [anon_sym_sanitize_memtag] = ACTIONS(250),
    [anon_sym_speculative_load_hardening] = ACTIONS(250),
    [anon_sym_speculatable] = ACTIONS(250),
    [anon_sym_ssp] = ACTIONS(252),
    [anon_sym_sspstrong] = ACTIONS(250),
    [anon_sym_sspreq] = ACTIONS(250),
    [anon_sym_strictfp] = ACTIONS(250),
    [anon_sym_nocf_check] = ACTIONS(250),
    [anon_sym_shadowcallstack] = ACTIONS(250),
    [anon_sym_mustprogress] = ACTIONS(250),
    [anon_sym_vscale_range] = ACTIONS(250),
    [anon_sym_preallocated] = ACTIONS(250),
    [anon_sym_zeroext] = ACTIONS(250),
    [anon_sym_signext] = ACTIONS(250),
    [anon_sym_inreg] = ACTIONS(250),
    [anon_sym_byval] = ACTIONS(250),
    [anon_sym_byref] = ACTIONS(250),
    [anon_sym_inalloca] = ACTIONS(250),
    [anon_sym_sret] = ACTIONS(250),
    [anon_sym_elementtype] = ACTIONS(250),
    [anon_sym_noalias] = ACTIONS(250),
    [anon_sym_nocapture] = ACTIONS(250),
    [anon_sym_nest] = ACTIONS(250),
    [anon_sym_returned] = ACTIONS(250),
    [anon_sym_nonnull] = ACTIONS(250),
    [anon_sym_dereferenceable] = ACTIONS(252),
    [anon_sym_dereferenceable_or_null] = ACTIONS(250),
    [anon_sym_swiftself] = ACTIONS(250),
    [anon_sym_swiftasync] = ACTIONS(250),
    [anon_sym_swifterror] = ACTIONS(250),
    [anon_sym_immarg] = ACTIONS(250),
    [anon_sym_noundef] = ACTIONS(250),
    [anon_sym_uwtable] = ACTIONS(250),
    [anon_sym_memory] = ACTIONS(250),
    [anon_sym_none] = ACTIONS(250),
    [anon_sym_extractelement] = ACTIONS(250),
    [anon_sym_insertelement] = ACTIONS(250),
    [anon_sym_select] = ACTIONS(250),
    [anon_sym_shufflevector] = ACTIONS(250),
    [anon_sym_fneg] = ACTIONS(250),
    [anon_sym_to] = ACTIONS(250),
    [anon_sym_icmp] = ACTIONS(250),
    [anon_sym_fcmp] = ACTIONS(250),
    [anon_sym_getelementptr] = ACTIONS(250),
    [anon_sym_extractvalue] = ACTIONS(250),
    [anon_sym_insertvalue] = ACTIONS(250),
    [anon_sym_true] = ACTIONS(250),
    [anon_sym_false] = ACTIONS(250),
    [anon_sym_null] = ACTIONS(252),
    [anon_sym_undef] = ACTIONS(250),
    [anon_sym_poison] = ACTIONS(250),
    [anon_sym_zeroinitializer] = ACTIONS(250),
    [anon_sym_blockaddress] = ACTIONS(250),
    [anon_sym_mul] = ACTIONS(250),
    [anon_sym_urem] = ACTIONS(250),
    [anon_sym_srem] = ACTIONS(250),
    [anon_sym_shl] = ACTIONS(250),
    [anon_sym_udiv] = ACTIONS(250),
    [anon_sym_sdiv] = ACTIONS(250),
    [anon_sym_lshr] = ACTIONS(250),
    [anon_sym_ashr] = ACTIONS(250),
    [anon_sym_fmul] = ACTIONS(250),
    [anon_sym_fdiv] = ACTIONS(250),
    [anon_sym_frem] = ACTIONS(250),
    [anon_sym_xchg] = ACTIONS(250),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(250),
    [anon_sym_and] = ACTIONS(250),
    [anon_sym_nand] = ACTIONS(250),
    [anon_sym_or] = ACTIONS(250),
    [anon_sym_xor] = ACTIONS(250),
    [anon_sym_max] = ACTIONS(250),
    [anon_sym_min] = ACTIONS(252),
    [anon_sym_umax] = ACTIONS(250),
    [anon_sym_umin] = ACTIONS(250),
    [anon_sym_fadd] = ACTIONS(250),
    [anon_sym_fsub] = ACTIONS(250),
    [anon_sym_bitcast] = ACTIONS(250),
    [anon_sym_trunc] = ACTIONS(250),
    [anon_sym_zext] = ACTIONS(250),
    [anon_sym_sext] = ACTIONS(250),
    [anon_sym_fptrunc] = ACTIONS(250),
    [anon_sym_fpext] = ACTIONS(250),
    [anon_sym_addrspacecast] = ACTIONS(250),
    [anon_sym_uitofp] = ACTIONS(250),
    [anon_sym_sitofp] = ACTIONS(250),
    [anon_sym_fptoui] = ACTIONS(250),
    [anon_sym_fptosi] = ACTIONS(250),
    [anon_sym_inttoptr] = ACTIONS(250),
    [anon_sym_ptrtoint] = ACTIONS(250),
    [anon_sym_uselistorder] = ACTIONS(252),
    [anon_sym_uselistorder_bb] = ACTIONS(250),
    [anon_sym_module] = ACTIONS(250),
    [anon_sym_attributes] = ACTIONS(250),
  },
  [78] = {
    [ts_builtin_sym_end] = ACTIONS(367),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(367),
    [sym_comdat_ref] = ACTIONS(367),
    [sym_global_var] = ACTIONS(367),
    [sym_local_var] = ACTIONS(367),
    [aux_sym_metadata_ref_token1] = ACTIONS(367),
    [sym_summary_ref] = ACTIONS(367),
    [sym_string] = ACTIONS(367),
    [aux_sym_number_token1] = ACTIONS(369),
    [aux_sym_number_token2] = ACTIONS(367),
    [sym_float] = ACTIONS(367),
    [sym_cstring] = ACTIONS(367),
    [anon_sym_target] = ACTIONS(367),
    [anon_sym_source_filename] = ACTIONS(367),
    [anon_sym_declare] = ACTIONS(367),
    [anon_sym_define] = ACTIONS(367),
    [anon_sym_no_cfi] = ACTIONS(367),
    [anon_sym_private] = ACTIONS(367),
    [anon_sym_internal] = ACTIONS(367),
    [anon_sym_weak] = ACTIONS(369),
    [anon_sym_weak_odr] = ACTIONS(367),
    [anon_sym_linkonce] = ACTIONS(369),
    [anon_sym_linkonce_odr] = ACTIONS(367),
    [anon_sym_available_externally] = ACTIONS(367),
    [anon_sym_appending] = ACTIONS(367),
    [anon_sym_common] = ACTIONS(367),
    [anon_sym_extern_weak] = ACTIONS(367),
    [anon_sym_external] = ACTIONS(367),
    [anon_sym_dso_local] = ACTIONS(369),
    [anon_sym_dso_local_equivalent] = ACTIONS(367),
    [anon_sym_dso_preemptable] = ACTIONS(367),
    [anon_sym_default] = ACTIONS(367),
    [anon_sym_hidden] = ACTIONS(367),
    [anon_sym_protected] = ACTIONS(367),
    [anon_sym_dllimport] = ACTIONS(367),
    [anon_sym_dllexport] = ACTIONS(367),
    [anon_sym_STAR] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(367),
    [anon_sym_RBRACE] = ACTIONS(367),
    [anon_sym_LT_LBRACE] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_COMMA] = ACTIONS(367),
    [anon_sym_addrspace] = ACTIONS(369),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_RPAREN] = ACTIONS(367),
    [anon_sym_align] = ACTIONS(369),
    [anon_sym_section] = ACTIONS(367),
    [anon_sym_partition] = ACTIONS(367),
    [anon_sym_comdat] = ACTIONS(367),
    [anon_sym_gc] = ACTIONS(367),
    [anon_sym_prefix] = ACTIONS(367),
    [anon_sym_prologue] = ACTIONS(367),
    [anon_sym_personality] = ACTIONS(367),
    [anon_sym_alignstack] = ACTIONS(367),
    [anon_sym_allocsize] = ACTIONS(367),
    [anon_sym_alwaysinline] = ACTIONS(367),
    [anon_sym_builtin] = ACTIONS(367),
    [anon_sym_cold] = ACTIONS(367),
    [anon_sym_convergent] = ACTIONS(367),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(367),
    [anon_sym_hot] = ACTIONS(367),
    [anon_sym_inaccessiblememonly] = ACTIONS(367),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(367),
    [anon_sym_inlinehint] = ACTIONS(367),
    [anon_sym_jumptable] = ACTIONS(367),
    [anon_sym_minsize] = ACTIONS(367),
    [anon_sym_naked] = ACTIONS(367),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(367),
    [anon_sym_nobuiltin] = ACTIONS(367),
    [anon_sym_noduplicate] = ACTIONS(367),
    [anon_sym_nofree] = ACTIONS(367),
    [anon_sym_noimplicitfloat] = ACTIONS(367),
    [anon_sym_noinline] = ACTIONS(367),
    [anon_sym_nomerge] = ACTIONS(367),
    [anon_sym_nonlazybind] = ACTIONS(367),
    [anon_sym_noprofile] = ACTIONS(367),
    [anon_sym_noredzone] = ACTIONS(367),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(367),
    [anon_sym_noreturn] = ACTIONS(367),
    [anon_sym_norecurse] = ACTIONS(367),
    [anon_sym_willreturn] = ACTIONS(367),
    [anon_sym_nosync] = ACTIONS(367),
    [anon_sym_nounwind] = ACTIONS(367),
    [anon_sym_nocallback] = ACTIONS(367),
    [anon_sym_nosanitize_coverage] = ACTIONS(367),
    [anon_sym_null_pointer_is_valid] = ACTIONS(367),
    [anon_sym_optforfuzzing] = ACTIONS(367),
    [anon_sym_optnone] = ACTIONS(367),
    [anon_sym_optsize] = ACTIONS(367),
    [anon_sym_readnone] = ACTIONS(367),
    [anon_sym_readonly] = ACTIONS(367),
    [anon_sym_writeonly] = ACTIONS(367),
    [anon_sym_argmemonly] = ACTIONS(367),
    [anon_sym_returns_twice] = ACTIONS(367),
    [anon_sym_safestack] = ACTIONS(367),
    [anon_sym_sanitize_address] = ACTIONS(367),
    [anon_sym_sanitize_memory] = ACTIONS(367),
    [anon_sym_sanitize_thread] = ACTIONS(367),
    [anon_sym_sanitize_hwaddress] = ACTIONS(367),
    [anon_sym_sanitize_memtag] = ACTIONS(367),
    [anon_sym_speculative_load_hardening] = ACTIONS(367),
    [anon_sym_speculatable] = ACTIONS(367),
    [anon_sym_ssp] = ACTIONS(369),
    [anon_sym_sspstrong] = ACTIONS(367),
    [anon_sym_sspreq] = ACTIONS(367),
    [anon_sym_strictfp] = ACTIONS(367),
    [anon_sym_nocf_check] = ACTIONS(367),
    [anon_sym_shadowcallstack] = ACTIONS(367),
    [anon_sym_mustprogress] = ACTIONS(367),
    [anon_sym_vscale_range] = ACTIONS(367),
    [anon_sym_preallocated] = ACTIONS(367),
    [anon_sym_zeroext] = ACTIONS(367),
    [anon_sym_signext] = ACTIONS(367),
    [anon_sym_inreg] = ACTIONS(367),
    [anon_sym_byval] = ACTIONS(367),
    [anon_sym_byref] = ACTIONS(367),
    [anon_sym_inalloca] = ACTIONS(367),
    [anon_sym_sret] = ACTIONS(367),
    [anon_sym_elementtype] = ACTIONS(367),
    [anon_sym_noalias] = ACTIONS(367),
    [anon_sym_nocapture] = ACTIONS(367),
    [anon_sym_nest] = ACTIONS(367),
    [anon_sym_returned] = ACTIONS(367),
    [anon_sym_nonnull] = ACTIONS(367),
    [anon_sym_dereferenceable] = ACTIONS(369),
    [anon_sym_dereferenceable_or_null] = ACTIONS(367),
    [anon_sym_swiftself] = ACTIONS(367),
    [anon_sym_swiftasync] = ACTIONS(367),
    [anon_sym_swifterror] = ACTIONS(367),
    [anon_sym_immarg] = ACTIONS(367),
    [anon_sym_noundef] = ACTIONS(367),
    [anon_sym_uwtable] = ACTIONS(367),
    [anon_sym_memory] = ACTIONS(367),
    [anon_sym_none] = ACTIONS(367),
    [anon_sym_extractelement] = ACTIONS(367),
    [anon_sym_insertelement] = ACTIONS(367),
    [anon_sym_select] = ACTIONS(367),
    [anon_sym_shufflevector] = ACTIONS(367),
    [anon_sym_fneg] = ACTIONS(367),
    [anon_sym_to] = ACTIONS(367),
    [anon_sym_icmp] = ACTIONS(367),
    [anon_sym_fcmp] = ACTIONS(367),
    [anon_sym_getelementptr] = ACTIONS(367),
    [anon_sym_extractvalue] = ACTIONS(367),
    [anon_sym_insertvalue] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(367),
    [anon_sym_false] = ACTIONS(367),
    [anon_sym_null] = ACTIONS(369),
    [anon_sym_undef] = ACTIONS(367),
    [anon_sym_poison] = ACTIONS(367),
    [anon_sym_zeroinitializer] = ACTIONS(367),
    [anon_sym_blockaddress] = ACTIONS(367),
    [anon_sym_mul] = ACTIONS(367),
    [anon_sym_urem] = ACTIONS(367),
    [anon_sym_srem] = ACTIONS(367),
    [anon_sym_shl] = ACTIONS(367),
    [anon_sym_udiv] = ACTIONS(367),
    [anon_sym_sdiv] = ACTIONS(367),
    [anon_sym_lshr] = ACTIONS(367),
    [anon_sym_ashr] = ACTIONS(367),
    [anon_sym_fmul] = ACTIONS(367),
    [anon_sym_fdiv] = ACTIONS(367),
    [anon_sym_frem] = ACTIONS(367),
    [anon_sym_xchg] = ACTIONS(367),
    [anon_sym_add] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(367),
    [anon_sym_and] = ACTIONS(367),
    [anon_sym_nand] = ACTIONS(367),
    [anon_sym_or] = ACTIONS(367),
    [anon_sym_xor] = ACTIONS(367),
    [anon_sym_max] = ACTIONS(367),
    [anon_sym_min] = ACTIONS(369),
    [anon_sym_umax] = ACTIONS(367),
    [anon_sym_umin] = ACTIONS(367),
    [anon_sym_fadd] = ACTIONS(367),
    [anon_sym_fsub] = ACTIONS(367),
    [anon_sym_bitcast] = ACTIONS(367),
    [anon_sym_trunc] = ACTIONS(367),
    [anon_sym_zext] = ACTIONS(367),
    [anon_sym_sext] = ACTIONS(367),
    [anon_sym_fptrunc] = ACTIONS(367),
    [anon_sym_fpext] = ACTIONS(367),
    [anon_sym_addrspacecast] = ACTIONS(367),
    [anon_sym_uitofp] = ACTIONS(367),
    [anon_sym_sitofp] = ACTIONS(367),
    [anon_sym_fptoui] = ACTIONS(367),
    [anon_sym_fptosi] = ACTIONS(367),
    [anon_sym_inttoptr] = ACTIONS(367),
    [anon_sym_ptrtoint] = ACTIONS(367),
    [anon_sym_uselistorder] = ACTIONS(369),
    [anon_sym_uselistorder_bb] = ACTIONS(367),
    [anon_sym_module] = ACTIONS(367),
    [anon_sym_attributes] = ACTIONS(367),
  },
  [79] = {
    [ts_builtin_sym_end] = ACTIONS(244),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(244),
    [sym_comdat_ref] = ACTIONS(244),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [aux_sym_metadata_ref_token1] = ACTIONS(244),
    [sym_summary_ref] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_target] = ACTIONS(244),
    [anon_sym_source_filename] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(244),
    [anon_sym_define] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(503),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_RPAREN] = ACTIONS(244),
    [anon_sym_align] = ACTIONS(246),
    [anon_sym_section] = ACTIONS(244),
    [anon_sym_partition] = ACTIONS(244),
    [anon_sym_comdat] = ACTIONS(244),
    [anon_sym_gc] = ACTIONS(244),
    [anon_sym_prefix] = ACTIONS(244),
    [anon_sym_prologue] = ACTIONS(244),
    [anon_sym_personality] = ACTIONS(244),
    [anon_sym_alignstack] = ACTIONS(244),
    [anon_sym_allocsize] = ACTIONS(244),
    [anon_sym_alwaysinline] = ACTIONS(244),
    [anon_sym_builtin] = ACTIONS(244),
    [anon_sym_cold] = ACTIONS(244),
    [anon_sym_convergent] = ACTIONS(244),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(244),
    [anon_sym_hot] = ACTIONS(244),
    [anon_sym_inaccessiblememonly] = ACTIONS(244),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(244),
    [anon_sym_inlinehint] = ACTIONS(244),
    [anon_sym_jumptable] = ACTIONS(244),
    [anon_sym_minsize] = ACTIONS(244),
    [anon_sym_naked] = ACTIONS(244),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(244),
    [anon_sym_nobuiltin] = ACTIONS(244),
    [anon_sym_noduplicate] = ACTIONS(244),
    [anon_sym_nofree] = ACTIONS(244),
    [anon_sym_noimplicitfloat] = ACTIONS(244),
    [anon_sym_noinline] = ACTIONS(244),
    [anon_sym_nomerge] = ACTIONS(244),
    [anon_sym_nonlazybind] = ACTIONS(244),
    [anon_sym_noprofile] = ACTIONS(244),
    [anon_sym_noredzone] = ACTIONS(244),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(244),
    [anon_sym_noreturn] = ACTIONS(244),
    [anon_sym_norecurse] = ACTIONS(244),
    [anon_sym_willreturn] = ACTIONS(244),
    [anon_sym_nosync] = ACTIONS(244),
    [anon_sym_nounwind] = ACTIONS(244),
    [anon_sym_nocallback] = ACTIONS(244),
    [anon_sym_nosanitize_coverage] = ACTIONS(244),
    [anon_sym_null_pointer_is_valid] = ACTIONS(244),
    [anon_sym_optforfuzzing] = ACTIONS(244),
    [anon_sym_optnone] = ACTIONS(244),
    [anon_sym_optsize] = ACTIONS(244),
    [anon_sym_readnone] = ACTIONS(244),
    [anon_sym_readonly] = ACTIONS(244),
    [anon_sym_writeonly] = ACTIONS(244),
    [anon_sym_argmemonly] = ACTIONS(244),
    [anon_sym_returns_twice] = ACTIONS(244),
    [anon_sym_safestack] = ACTIONS(244),
    [anon_sym_sanitize_address] = ACTIONS(244),
    [anon_sym_sanitize_memory] = ACTIONS(244),
    [anon_sym_sanitize_thread] = ACTIONS(244),
    [anon_sym_sanitize_hwaddress] = ACTIONS(244),
    [anon_sym_sanitize_memtag] = ACTIONS(244),
    [anon_sym_speculative_load_hardening] = ACTIONS(244),
    [anon_sym_speculatable] = ACTIONS(244),
    [anon_sym_ssp] = ACTIONS(246),
    [anon_sym_sspstrong] = ACTIONS(244),
    [anon_sym_sspreq] = ACTIONS(244),
    [anon_sym_strictfp] = ACTIONS(244),
    [anon_sym_nocf_check] = ACTIONS(244),
    [anon_sym_shadowcallstack] = ACTIONS(244),
    [anon_sym_mustprogress] = ACTIONS(244),
    [anon_sym_vscale_range] = ACTIONS(244),
    [anon_sym_preallocated] = ACTIONS(244),
    [anon_sym_zeroext] = ACTIONS(244),
    [anon_sym_signext] = ACTIONS(244),
    [anon_sym_inreg] = ACTIONS(244),
    [anon_sym_byval] = ACTIONS(244),
    [anon_sym_byref] = ACTIONS(244),
    [anon_sym_inalloca] = ACTIONS(244),
    [anon_sym_sret] = ACTIONS(244),
    [anon_sym_elementtype] = ACTIONS(244),
    [anon_sym_noalias] = ACTIONS(244),
    [anon_sym_nocapture] = ACTIONS(244),
    [anon_sym_nest] = ACTIONS(244),
    [anon_sym_returned] = ACTIONS(244),
    [anon_sym_nonnull] = ACTIONS(244),
    [anon_sym_dereferenceable] = ACTIONS(246),
    [anon_sym_dereferenceable_or_null] = ACTIONS(244),
    [anon_sym_swiftself] = ACTIONS(244),
    [anon_sym_swiftasync] = ACTIONS(244),
    [anon_sym_swifterror] = ACTIONS(244),
    [anon_sym_immarg] = ACTIONS(244),
    [anon_sym_noundef] = ACTIONS(244),
    [anon_sym_uwtable] = ACTIONS(244),
    [anon_sym_memory] = ACTIONS(244),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_to] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
    [anon_sym_uselistorder] = ACTIONS(246),
    [anon_sym_uselistorder_bb] = ACTIONS(244),
    [anon_sym_module] = ACTIONS(244),
    [anon_sym_attributes] = ACTIONS(244),
  },
  [80] = {
    [ts_builtin_sym_end] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(391),
    [sym_comdat_ref] = ACTIONS(391),
    [sym_global_var] = ACTIONS(391),
    [sym_local_var] = ACTIONS(391),
    [aux_sym_metadata_ref_token1] = ACTIONS(391),
    [sym_summary_ref] = ACTIONS(391),
    [sym_string] = ACTIONS(391),
    [aux_sym_number_token1] = ACTIONS(393),
    [aux_sym_number_token2] = ACTIONS(391),
    [sym_float] = ACTIONS(391),
    [sym_cstring] = ACTIONS(391),
    [anon_sym_target] = ACTIONS(391),
    [anon_sym_source_filename] = ACTIONS(391),
    [anon_sym_declare] = ACTIONS(391),
    [anon_sym_define] = ACTIONS(391),
    [anon_sym_no_cfi] = ACTIONS(391),
    [anon_sym_private] = ACTIONS(391),
    [anon_sym_internal] = ACTIONS(391),
    [anon_sym_weak] = ACTIONS(393),
    [anon_sym_weak_odr] = ACTIONS(391),
    [anon_sym_linkonce] = ACTIONS(393),
    [anon_sym_linkonce_odr] = ACTIONS(391),
    [anon_sym_available_externally] = ACTIONS(391),
    [anon_sym_appending] = ACTIONS(391),
    [anon_sym_common] = ACTIONS(391),
    [anon_sym_extern_weak] = ACTIONS(391),
    [anon_sym_external] = ACTIONS(391),
    [anon_sym_dso_local] = ACTIONS(393),
    [anon_sym_dso_local_equivalent] = ACTIONS(391),
    [anon_sym_dso_preemptable] = ACTIONS(391),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_hidden] = ACTIONS(391),
    [anon_sym_protected] = ACTIONS(391),
    [anon_sym_dllimport] = ACTIONS(391),
    [anon_sym_dllexport] = ACTIONS(391),
    [anon_sym_STAR] = ACTIONS(391),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_RBRACE] = ACTIONS(391),
    [anon_sym_LT_LBRACE] = ACTIONS(391),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LT] = ACTIONS(393),
    [anon_sym_COMMA] = ACTIONS(391),
    [anon_sym_RPAREN] = ACTIONS(391),
    [anon_sym_align] = ACTIONS(393),
    [anon_sym_section] = ACTIONS(391),
    [anon_sym_partition] = ACTIONS(391),
    [anon_sym_comdat] = ACTIONS(391),
    [anon_sym_gc] = ACTIONS(391),
    [anon_sym_prefix] = ACTIONS(391),
    [anon_sym_prologue] = ACTIONS(391),
    [anon_sym_personality] = ACTIONS(391),
    [anon_sym_alignstack] = ACTIONS(391),
    [anon_sym_allocsize] = ACTIONS(391),
    [anon_sym_alwaysinline] = ACTIONS(391),
    [anon_sym_builtin] = ACTIONS(391),
    [anon_sym_cold] = ACTIONS(391),
    [anon_sym_convergent] = ACTIONS(391),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(391),
    [anon_sym_hot] = ACTIONS(391),
    [anon_sym_inaccessiblememonly] = ACTIONS(391),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(391),
    [anon_sym_inlinehint] = ACTIONS(391),
    [anon_sym_jumptable] = ACTIONS(391),
    [anon_sym_minsize] = ACTIONS(391),
    [anon_sym_naked] = ACTIONS(391),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(391),
    [anon_sym_nobuiltin] = ACTIONS(391),
    [anon_sym_noduplicate] = ACTIONS(391),
    [anon_sym_nofree] = ACTIONS(391),
    [anon_sym_noimplicitfloat] = ACTIONS(391),
    [anon_sym_noinline] = ACTIONS(391),
    [anon_sym_nomerge] = ACTIONS(391),
    [anon_sym_nonlazybind] = ACTIONS(391),
    [anon_sym_noprofile] = ACTIONS(391),
    [anon_sym_noredzone] = ACTIONS(391),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(391),
    [anon_sym_noreturn] = ACTIONS(391),
    [anon_sym_norecurse] = ACTIONS(391),
    [anon_sym_willreturn] = ACTIONS(391),
    [anon_sym_nosync] = ACTIONS(391),
    [anon_sym_nounwind] = ACTIONS(391),
    [anon_sym_nocallback] = ACTIONS(391),
    [anon_sym_nosanitize_coverage] = ACTIONS(391),
    [anon_sym_null_pointer_is_valid] = ACTIONS(391),
    [anon_sym_optforfuzzing] = ACTIONS(391),
    [anon_sym_optnone] = ACTIONS(391),
    [anon_sym_optsize] = ACTIONS(391),
    [anon_sym_readnone] = ACTIONS(391),
    [anon_sym_readonly] = ACTIONS(391),
    [anon_sym_writeonly] = ACTIONS(391),
    [anon_sym_argmemonly] = ACTIONS(391),
    [anon_sym_returns_twice] = ACTIONS(391),
    [anon_sym_safestack] = ACTIONS(391),
    [anon_sym_sanitize_address] = ACTIONS(391),
    [anon_sym_sanitize_memory] = ACTIONS(391),
    [anon_sym_sanitize_thread] = ACTIONS(391),
    [anon_sym_sanitize_hwaddress] = ACTIONS(391),
    [anon_sym_sanitize_memtag] = ACTIONS(391),
    [anon_sym_speculative_load_hardening] = ACTIONS(391),
    [anon_sym_speculatable] = ACTIONS(391),
    [anon_sym_ssp] = ACTIONS(393),
    [anon_sym_sspstrong] = ACTIONS(391),
    [anon_sym_sspreq] = ACTIONS(391),
    [anon_sym_strictfp] = ACTIONS(391),
    [anon_sym_nocf_check] = ACTIONS(391),
    [anon_sym_shadowcallstack] = ACTIONS(391),
    [anon_sym_mustprogress] = ACTIONS(391),
    [anon_sym_vscale_range] = ACTIONS(391),
    [anon_sym_preallocated] = ACTIONS(391),
    [anon_sym_zeroext] = ACTIONS(391),
    [anon_sym_signext] = ACTIONS(391),
    [anon_sym_inreg] = ACTIONS(391),
    [anon_sym_byval] = ACTIONS(391),
    [anon_sym_byref] = ACTIONS(391),
    [anon_sym_inalloca] = ACTIONS(391),
    [anon_sym_sret] = ACTIONS(391),
    [anon_sym_elementtype] = ACTIONS(391),
    [anon_sym_noalias] = ACTIONS(391),
    [anon_sym_nocapture] = ACTIONS(391),
    [anon_sym_nest] = ACTIONS(391),
    [anon_sym_returned] = ACTIONS(391),
    [anon_sym_nonnull] = ACTIONS(391),
    [anon_sym_dereferenceable] = ACTIONS(393),
    [anon_sym_dereferenceable_or_null] = ACTIONS(391),
    [anon_sym_swiftself] = ACTIONS(391),
    [anon_sym_swiftasync] = ACTIONS(391),
    [anon_sym_swifterror] = ACTIONS(391),
    [anon_sym_immarg] = ACTIONS(391),
    [anon_sym_noundef] = ACTIONS(391),
    [anon_sym_uwtable] = ACTIONS(391),
    [anon_sym_memory] = ACTIONS(391),
    [anon_sym_none] = ACTIONS(391),
    [anon_sym_extractelement] = ACTIONS(391),
    [anon_sym_insertelement] = ACTIONS(391),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_shufflevector] = ACTIONS(391),
    [anon_sym_fneg] = ACTIONS(391),
    [anon_sym_to] = ACTIONS(391),
    [anon_sym_icmp] = ACTIONS(391),
    [anon_sym_fcmp] = ACTIONS(391),
    [anon_sym_getelementptr] = ACTIONS(391),
    [anon_sym_extractvalue] = ACTIONS(391),
    [anon_sym_insertvalue] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(391),
    [anon_sym_false] = ACTIONS(391),
    [anon_sym_null] = ACTIONS(393),
    [anon_sym_undef] = ACTIONS(391),
    [anon_sym_poison] = ACTIONS(391),
    [anon_sym_zeroinitializer] = ACTIONS(391),
    [anon_sym_blockaddress] = ACTIONS(391),
    [anon_sym_mul] = ACTIONS(391),
    [anon_sym_urem] = ACTIONS(391),
    [anon_sym_srem] = ACTIONS(391),
    [anon_sym_shl] = ACTIONS(391),
    [anon_sym_udiv] = ACTIONS(391),
    [anon_sym_sdiv] = ACTIONS(391),
    [anon_sym_lshr] = ACTIONS(391),
    [anon_sym_ashr] = ACTIONS(391),
    [anon_sym_fmul] = ACTIONS(391),
    [anon_sym_fdiv] = ACTIONS(391),
    [anon_sym_frem] = ACTIONS(391),
    [anon_sym_xchg] = ACTIONS(391),
    [anon_sym_add] = ACTIONS(393),
    [anon_sym_sub] = ACTIONS(391),
    [anon_sym_and] = ACTIONS(391),
    [anon_sym_nand] = ACTIONS(391),
    [anon_sym_or] = ACTIONS(391),
    [anon_sym_xor] = ACTIONS(391),
    [anon_sym_max] = ACTIONS(391),
    [anon_sym_min] = ACTIONS(393),
    [anon_sym_umax] = ACTIONS(391),
    [anon_sym_umin] = ACTIONS(391),
    [anon_sym_fadd] = ACTIONS(391),
    [anon_sym_fsub] = ACTIONS(391),
    [anon_sym_bitcast] = ACTIONS(391),
    [anon_sym_trunc] = ACTIONS(391),
    [anon_sym_zext] = ACTIONS(391),
    [anon_sym_sext] = ACTIONS(391),
    [anon_sym_fptrunc] = ACTIONS(391),
    [anon_sym_fpext] = ACTIONS(391),
    [anon_sym_addrspacecast] = ACTIONS(391),
    [anon_sym_uitofp] = ACTIONS(391),
    [anon_sym_sitofp] = ACTIONS(391),
    [anon_sym_fptoui] = ACTIONS(391),
    [anon_sym_fptosi] = ACTIONS(391),
    [anon_sym_inttoptr] = ACTIONS(391),
    [anon_sym_ptrtoint] = ACTIONS(391),
    [anon_sym_uselistorder] = ACTIONS(393),
    [anon_sym_uselistorder_bb] = ACTIONS(391),
    [anon_sym_module] = ACTIONS(391),
    [anon_sym_attributes] = ACTIONS(391),
  },
  [81] = {
    [ts_builtin_sym_end] = ACTIONS(395),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(395),
    [sym_comdat_ref] = ACTIONS(395),
    [sym_global_var] = ACTIONS(395),
    [sym_local_var] = ACTIONS(395),
    [aux_sym_metadata_ref_token1] = ACTIONS(395),
    [sym_summary_ref] = ACTIONS(395),
    [sym_string] = ACTIONS(395),
    [aux_sym_number_token1] = ACTIONS(397),
    [aux_sym_number_token2] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_cstring] = ACTIONS(395),
    [anon_sym_target] = ACTIONS(395),
    [anon_sym_source_filename] = ACTIONS(395),
    [anon_sym_declare] = ACTIONS(395),
    [anon_sym_define] = ACTIONS(395),
    [anon_sym_no_cfi] = ACTIONS(395),
    [anon_sym_private] = ACTIONS(395),
    [anon_sym_internal] = ACTIONS(395),
    [anon_sym_weak] = ACTIONS(397),
    [anon_sym_weak_odr] = ACTIONS(395),
    [anon_sym_linkonce] = ACTIONS(397),
    [anon_sym_linkonce_odr] = ACTIONS(395),
    [anon_sym_available_externally] = ACTIONS(395),
    [anon_sym_appending] = ACTIONS(395),
    [anon_sym_common] = ACTIONS(395),
    [anon_sym_extern_weak] = ACTIONS(395),
    [anon_sym_external] = ACTIONS(395),
    [anon_sym_dso_local] = ACTIONS(397),
    [anon_sym_dso_local_equivalent] = ACTIONS(395),
    [anon_sym_dso_preemptable] = ACTIONS(395),
    [anon_sym_default] = ACTIONS(395),
    [anon_sym_hidden] = ACTIONS(395),
    [anon_sym_protected] = ACTIONS(395),
    [anon_sym_dllimport] = ACTIONS(395),
    [anon_sym_dllexport] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(503),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_RBRACE] = ACTIONS(395),
    [anon_sym_LT_LBRACE] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(395),
    [anon_sym_LT] = ACTIONS(397),
    [anon_sym_COMMA] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(395),
    [anon_sym_align] = ACTIONS(397),
    [anon_sym_section] = ACTIONS(395),
    [anon_sym_partition] = ACTIONS(395),
    [anon_sym_comdat] = ACTIONS(395),
    [anon_sym_gc] = ACTIONS(395),
    [anon_sym_prefix] = ACTIONS(395),
    [anon_sym_prologue] = ACTIONS(395),
    [anon_sym_personality] = ACTIONS(395),
    [anon_sym_alignstack] = ACTIONS(395),
    [anon_sym_allocsize] = ACTIONS(395),
    [anon_sym_alwaysinline] = ACTIONS(395),
    [anon_sym_builtin] = ACTIONS(395),
    [anon_sym_cold] = ACTIONS(395),
    [anon_sym_convergent] = ACTIONS(395),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(395),
    [anon_sym_hot] = ACTIONS(395),
    [anon_sym_inaccessiblememonly] = ACTIONS(395),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(395),
    [anon_sym_inlinehint] = ACTIONS(395),
    [anon_sym_jumptable] = ACTIONS(395),
    [anon_sym_minsize] = ACTIONS(395),
    [anon_sym_naked] = ACTIONS(395),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(395),
    [anon_sym_nobuiltin] = ACTIONS(395),
    [anon_sym_noduplicate] = ACTIONS(395),
    [anon_sym_nofree] = ACTIONS(395),
    [anon_sym_noimplicitfloat] = ACTIONS(395),
    [anon_sym_noinline] = ACTIONS(395),
    [anon_sym_nomerge] = ACTIONS(395),
    [anon_sym_nonlazybind] = ACTIONS(395),
    [anon_sym_noprofile] = ACTIONS(395),
    [anon_sym_noredzone] = ACTIONS(395),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(395),
    [anon_sym_noreturn] = ACTIONS(395),
    [anon_sym_norecurse] = ACTIONS(395),
    [anon_sym_willreturn] = ACTIONS(395),
    [anon_sym_nosync] = ACTIONS(395),
    [anon_sym_nounwind] = ACTIONS(395),
    [anon_sym_nocallback] = ACTIONS(395),
    [anon_sym_nosanitize_coverage] = ACTIONS(395),
    [anon_sym_null_pointer_is_valid] = ACTIONS(395),
    [anon_sym_optforfuzzing] = ACTIONS(395),
    [anon_sym_optnone] = ACTIONS(395),
    [anon_sym_optsize] = ACTIONS(395),
    [anon_sym_readnone] = ACTIONS(395),
    [anon_sym_readonly] = ACTIONS(395),
    [anon_sym_writeonly] = ACTIONS(395),
    [anon_sym_argmemonly] = ACTIONS(395),
    [anon_sym_returns_twice] = ACTIONS(395),
    [anon_sym_safestack] = ACTIONS(395),
    [anon_sym_sanitize_address] = ACTIONS(395),
    [anon_sym_sanitize_memory] = ACTIONS(395),
    [anon_sym_sanitize_thread] = ACTIONS(395),
    [anon_sym_sanitize_hwaddress] = ACTIONS(395),
    [anon_sym_sanitize_memtag] = ACTIONS(395),
    [anon_sym_speculative_load_hardening] = ACTIONS(395),
    [anon_sym_speculatable] = ACTIONS(395),
    [anon_sym_ssp] = ACTIONS(397),
    [anon_sym_sspstrong] = ACTIONS(395),
    [anon_sym_sspreq] = ACTIONS(395),
    [anon_sym_strictfp] = ACTIONS(395),
    [anon_sym_nocf_check] = ACTIONS(395),
    [anon_sym_shadowcallstack] = ACTIONS(395),
    [anon_sym_mustprogress] = ACTIONS(395),
    [anon_sym_vscale_range] = ACTIONS(395),
    [anon_sym_preallocated] = ACTIONS(395),
    [anon_sym_zeroext] = ACTIONS(395),
    [anon_sym_signext] = ACTIONS(395),
    [anon_sym_inreg] = ACTIONS(395),
    [anon_sym_byval] = ACTIONS(395),
    [anon_sym_byref] = ACTIONS(395),
    [anon_sym_inalloca] = ACTIONS(395),
    [anon_sym_sret] = ACTIONS(395),
    [anon_sym_elementtype] = ACTIONS(395),
    [anon_sym_noalias] = ACTIONS(395),
    [anon_sym_nocapture] = ACTIONS(395),
    [anon_sym_nest] = ACTIONS(395),
    [anon_sym_returned] = ACTIONS(395),
    [anon_sym_nonnull] = ACTIONS(395),
    [anon_sym_dereferenceable] = ACTIONS(397),
    [anon_sym_dereferenceable_or_null] = ACTIONS(395),
    [anon_sym_swiftself] = ACTIONS(395),
    [anon_sym_swiftasync] = ACTIONS(395),
    [anon_sym_swifterror] = ACTIONS(395),
    [anon_sym_immarg] = ACTIONS(395),
    [anon_sym_noundef] = ACTIONS(395),
    [anon_sym_uwtable] = ACTIONS(395),
    [anon_sym_memory] = ACTIONS(395),
    [anon_sym_none] = ACTIONS(395),
    [anon_sym_extractelement] = ACTIONS(395),
    [anon_sym_insertelement] = ACTIONS(395),
    [anon_sym_select] = ACTIONS(395),
    [anon_sym_shufflevector] = ACTIONS(395),
    [anon_sym_fneg] = ACTIONS(395),
    [anon_sym_to] = ACTIONS(395),
    [anon_sym_icmp] = ACTIONS(395),
    [anon_sym_fcmp] = ACTIONS(395),
    [anon_sym_getelementptr] = ACTIONS(395),
    [anon_sym_extractvalue] = ACTIONS(395),
    [anon_sym_insertvalue] = ACTIONS(395),
    [anon_sym_true] = ACTIONS(395),
    [anon_sym_false] = ACTIONS(395),
    [anon_sym_null] = ACTIONS(397),
    [anon_sym_undef] = ACTIONS(395),
    [anon_sym_poison] = ACTIONS(395),
    [anon_sym_zeroinitializer] = ACTIONS(395),
    [anon_sym_blockaddress] = ACTIONS(395),
    [anon_sym_mul] = ACTIONS(395),
    [anon_sym_urem] = ACTIONS(395),
    [anon_sym_srem] = ACTIONS(395),
    [anon_sym_shl] = ACTIONS(395),
    [anon_sym_udiv] = ACTIONS(395),
    [anon_sym_sdiv] = ACTIONS(395),
    [anon_sym_lshr] = ACTIONS(395),
    [anon_sym_ashr] = ACTIONS(395),
    [anon_sym_fmul] = ACTIONS(395),
    [anon_sym_fdiv] = ACTIONS(395),
    [anon_sym_frem] = ACTIONS(395),
    [anon_sym_xchg] = ACTIONS(395),
    [anon_sym_add] = ACTIONS(397),
    [anon_sym_sub] = ACTIONS(395),
    [anon_sym_and] = ACTIONS(395),
    [anon_sym_nand] = ACTIONS(395),
    [anon_sym_or] = ACTIONS(395),
    [anon_sym_xor] = ACTIONS(395),
    [anon_sym_max] = ACTIONS(395),
    [anon_sym_min] = ACTIONS(397),
    [anon_sym_umax] = ACTIONS(395),
    [anon_sym_umin] = ACTIONS(395),
    [anon_sym_fadd] = ACTIONS(395),
    [anon_sym_fsub] = ACTIONS(395),
    [anon_sym_bitcast] = ACTIONS(395),
    [anon_sym_trunc] = ACTIONS(395),
    [anon_sym_zext] = ACTIONS(395),
    [anon_sym_sext] = ACTIONS(395),
    [anon_sym_fptrunc] = ACTIONS(395),
    [anon_sym_fpext] = ACTIONS(395),
    [anon_sym_addrspacecast] = ACTIONS(395),
    [anon_sym_uitofp] = ACTIONS(395),
    [anon_sym_sitofp] = ACTIONS(395),
    [anon_sym_fptoui] = ACTIONS(395),
    [anon_sym_fptosi] = ACTIONS(395),
    [anon_sym_inttoptr] = ACTIONS(395),
    [anon_sym_ptrtoint] = ACTIONS(395),
    [anon_sym_uselistorder] = ACTIONS(397),
    [anon_sym_uselistorder_bb] = ACTIONS(395),
    [anon_sym_module] = ACTIONS(395),
    [anon_sym_attributes] = ACTIONS(395),
  },
  [82] = {
    [ts_builtin_sym_end] = ACTIONS(263),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(263),
    [sym_comdat_ref] = ACTIONS(263),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [aux_sym_metadata_ref_token1] = ACTIONS(263),
    [sym_summary_ref] = ACTIONS(263),
    [sym_string] = ACTIONS(263),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(263),
    [sym_float] = ACTIONS(263),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_target] = ACTIONS(263),
    [anon_sym_source_filename] = ACTIONS(263),
    [anon_sym_declare] = ACTIONS(263),
    [anon_sym_define] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(263),
    [anon_sym_private] = ACTIONS(263),
    [anon_sym_internal] = ACTIONS(263),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(263),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(263),
    [anon_sym_available_externally] = ACTIONS(263),
    [anon_sym_appending] = ACTIONS(263),
    [anon_sym_common] = ACTIONS(263),
    [anon_sym_extern_weak] = ACTIONS(263),
    [anon_sym_external] = ACTIONS(263),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(263),
    [anon_sym_dso_preemptable] = ACTIONS(263),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_hidden] = ACTIONS(263),
    [anon_sym_protected] = ACTIONS(263),
    [anon_sym_dllimport] = ACTIONS(263),
    [anon_sym_dllexport] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(503),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_RPAREN] = ACTIONS(263),
    [anon_sym_align] = ACTIONS(265),
    [anon_sym_section] = ACTIONS(263),
    [anon_sym_partition] = ACTIONS(263),
    [anon_sym_comdat] = ACTIONS(263),
    [anon_sym_gc] = ACTIONS(263),
    [anon_sym_prefix] = ACTIONS(263),
    [anon_sym_prologue] = ACTIONS(263),
    [anon_sym_personality] = ACTIONS(263),
    [anon_sym_alignstack] = ACTIONS(263),
    [anon_sym_allocsize] = ACTIONS(263),
    [anon_sym_alwaysinline] = ACTIONS(263),
    [anon_sym_builtin] = ACTIONS(263),
    [anon_sym_cold] = ACTIONS(263),
    [anon_sym_convergent] = ACTIONS(263),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(263),
    [anon_sym_hot] = ACTIONS(263),
    [anon_sym_inaccessiblememonly] = ACTIONS(263),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(263),
    [anon_sym_inlinehint] = ACTIONS(263),
    [anon_sym_jumptable] = ACTIONS(263),
    [anon_sym_minsize] = ACTIONS(263),
    [anon_sym_naked] = ACTIONS(263),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(263),
    [anon_sym_nobuiltin] = ACTIONS(263),
    [anon_sym_noduplicate] = ACTIONS(263),
    [anon_sym_nofree] = ACTIONS(263),
    [anon_sym_noimplicitfloat] = ACTIONS(263),
    [anon_sym_noinline] = ACTIONS(263),
    [anon_sym_nomerge] = ACTIONS(263),
    [anon_sym_nonlazybind] = ACTIONS(263),
    [anon_sym_noprofile] = ACTIONS(263),
    [anon_sym_noredzone] = ACTIONS(263),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(263),
    [anon_sym_noreturn] = ACTIONS(263),
    [anon_sym_norecurse] = ACTIONS(263),
    [anon_sym_willreturn] = ACTIONS(263),
    [anon_sym_nosync] = ACTIONS(263),
    [anon_sym_nounwind] = ACTIONS(263),
    [anon_sym_nocallback] = ACTIONS(263),
    [anon_sym_nosanitize_coverage] = ACTIONS(263),
    [anon_sym_null_pointer_is_valid] = ACTIONS(263),
    [anon_sym_optforfuzzing] = ACTIONS(263),
    [anon_sym_optnone] = ACTIONS(263),
    [anon_sym_optsize] = ACTIONS(263),
    [anon_sym_readnone] = ACTIONS(263),
    [anon_sym_readonly] = ACTIONS(263),
    [anon_sym_writeonly] = ACTIONS(263),
    [anon_sym_argmemonly] = ACTIONS(263),
    [anon_sym_returns_twice] = ACTIONS(263),
    [anon_sym_safestack] = ACTIONS(263),
    [anon_sym_sanitize_address] = ACTIONS(263),
    [anon_sym_sanitize_memory] = ACTIONS(263),
    [anon_sym_sanitize_thread] = ACTIONS(263),
    [anon_sym_sanitize_hwaddress] = ACTIONS(263),
    [anon_sym_sanitize_memtag] = ACTIONS(263),
    [anon_sym_speculative_load_hardening] = ACTIONS(263),
    [anon_sym_speculatable] = ACTIONS(263),
    [anon_sym_ssp] = ACTIONS(265),
    [anon_sym_sspstrong] = ACTIONS(263),
    [anon_sym_sspreq] = ACTIONS(263),
    [anon_sym_strictfp] = ACTIONS(263),
    [anon_sym_nocf_check] = ACTIONS(263),
    [anon_sym_shadowcallstack] = ACTIONS(263),
    [anon_sym_mustprogress] = ACTIONS(263),
    [anon_sym_vscale_range] = ACTIONS(263),
    [anon_sym_preallocated] = ACTIONS(263),
    [anon_sym_zeroext] = ACTIONS(263),
    [anon_sym_signext] = ACTIONS(263),
    [anon_sym_inreg] = ACTIONS(263),
    [anon_sym_byval] = ACTIONS(263),
    [anon_sym_byref] = ACTIONS(263),
    [anon_sym_inalloca] = ACTIONS(263),
    [anon_sym_sret] = ACTIONS(263),
    [anon_sym_elementtype] = ACTIONS(263),
    [anon_sym_noalias] = ACTIONS(263),
    [anon_sym_nocapture] = ACTIONS(263),
    [anon_sym_nest] = ACTIONS(263),
    [anon_sym_returned] = ACTIONS(263),
    [anon_sym_nonnull] = ACTIONS(263),
    [anon_sym_dereferenceable] = ACTIONS(265),
    [anon_sym_dereferenceable_or_null] = ACTIONS(263),
    [anon_sym_swiftself] = ACTIONS(263),
    [anon_sym_swiftasync] = ACTIONS(263),
    [anon_sym_swifterror] = ACTIONS(263),
    [anon_sym_immarg] = ACTIONS(263),
    [anon_sym_noundef] = ACTIONS(263),
    [anon_sym_uwtable] = ACTIONS(263),
    [anon_sym_memory] = ACTIONS(263),
    [anon_sym_none] = ACTIONS(263),
    [anon_sym_extractelement] = ACTIONS(263),
    [anon_sym_insertelement] = ACTIONS(263),
    [anon_sym_select] = ACTIONS(263),
    [anon_sym_shufflevector] = ACTIONS(263),
    [anon_sym_fneg] = ACTIONS(263),
    [anon_sym_to] = ACTIONS(263),
    [anon_sym_icmp] = ACTIONS(263),
    [anon_sym_fcmp] = ACTIONS(263),
    [anon_sym_getelementptr] = ACTIONS(263),
    [anon_sym_extractvalue] = ACTIONS(263),
    [anon_sym_insertvalue] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(263),
    [anon_sym_false] = ACTIONS(263),
    [anon_sym_null] = ACTIONS(265),
    [anon_sym_undef] = ACTIONS(263),
    [anon_sym_poison] = ACTIONS(263),
    [anon_sym_zeroinitializer] = ACTIONS(263),
    [anon_sym_blockaddress] = ACTIONS(263),
    [anon_sym_mul] = ACTIONS(263),
    [anon_sym_urem] = ACTIONS(263),
    [anon_sym_srem] = ACTIONS(263),
    [anon_sym_shl] = ACTIONS(263),
    [anon_sym_udiv] = ACTIONS(263),
    [anon_sym_sdiv] = ACTIONS(263),
    [anon_sym_lshr] = ACTIONS(263),
    [anon_sym_ashr] = ACTIONS(263),
    [anon_sym_fmul] = ACTIONS(263),
    [anon_sym_fdiv] = ACTIONS(263),
    [anon_sym_frem] = ACTIONS(263),
    [anon_sym_xchg] = ACTIONS(263),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(263),
    [anon_sym_and] = ACTIONS(263),
    [anon_sym_nand] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(263),
    [anon_sym_xor] = ACTIONS(263),
    [anon_sym_max] = ACTIONS(263),
    [anon_sym_min] = ACTIONS(265),
    [anon_sym_umax] = ACTIONS(263),
    [anon_sym_umin] = ACTIONS(263),
    [anon_sym_fadd] = ACTIONS(263),
    [anon_sym_fsub] = ACTIONS(263),
    [anon_sym_bitcast] = ACTIONS(263),
    [anon_sym_trunc] = ACTIONS(263),
    [anon_sym_zext] = ACTIONS(263),
    [anon_sym_sext] = ACTIONS(263),
    [anon_sym_fptrunc] = ACTIONS(263),
    [anon_sym_fpext] = ACTIONS(263),
    [anon_sym_addrspacecast] = ACTIONS(263),
    [anon_sym_uitofp] = ACTIONS(263),
    [anon_sym_sitofp] = ACTIONS(263),
    [anon_sym_fptoui] = ACTIONS(263),
    [anon_sym_fptosi] = ACTIONS(263),
    [anon_sym_inttoptr] = ACTIONS(263),
    [anon_sym_ptrtoint] = ACTIONS(263),
    [anon_sym_uselistorder] = ACTIONS(265),
    [anon_sym_uselistorder_bb] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(263),
    [anon_sym_attributes] = ACTIONS(263),
  },
  [83] = {
    [ts_builtin_sym_end] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(505),
    [sym_global_var] = ACTIONS(505),
    [sym_local_var] = ACTIONS(505),
    [aux_sym_metadata_ref_token1] = ACTIONS(505),
    [sym_summary_ref] = ACTIONS(505),
    [sym_string] = ACTIONS(505),
    [anon_sym_target] = ACTIONS(505),
    [anon_sym_EQ] = ACTIONS(505),
    [anon_sym_source_filename] = ACTIONS(505),
    [anon_sym_declare] = ACTIONS(505),
    [anon_sym_define] = ACTIONS(505),
    [anon_sym_no_cfi] = ACTIONS(505),
    [anon_sym_private] = ACTIONS(505),
    [anon_sym_internal] = ACTIONS(505),
    [anon_sym_weak] = ACTIONS(507),
    [anon_sym_weak_odr] = ACTIONS(505),
    [anon_sym_linkonce] = ACTIONS(507),
    [anon_sym_linkonce_odr] = ACTIONS(505),
    [anon_sym_available_externally] = ACTIONS(505),
    [anon_sym_appending] = ACTIONS(505),
    [anon_sym_common] = ACTIONS(505),
    [anon_sym_extern_weak] = ACTIONS(505),
    [anon_sym_external] = ACTIONS(505),
    [anon_sym_dso_local] = ACTIONS(507),
    [anon_sym_dso_local_equivalent] = ACTIONS(505),
    [anon_sym_dso_preemptable] = ACTIONS(505),
    [anon_sym_default] = ACTIONS(505),
    [anon_sym_hidden] = ACTIONS(505),
    [anon_sym_protected] = ACTIONS(505),
    [anon_sym_dllimport] = ACTIONS(505),
    [anon_sym_dllexport] = ACTIONS(505),
    [anon_sym_ccc] = ACTIONS(505),
    [anon_sym_fastcc] = ACTIONS(505),
    [anon_sym_coldcc] = ACTIONS(505),
    [anon_sym_webkit_jscc] = ACTIONS(507),
    [anon_sym_anyregcc] = ACTIONS(505),
    [anon_sym_preserve_mostcc] = ACTIONS(505),
    [anon_sym_preserve_allcc] = ACTIONS(505),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(507),
    [anon_sym_tailcc] = ACTIONS(505),
    [anon_sym_swiftcc] = ACTIONS(507),
    [anon_sym_swifttailcc] = ACTIONS(507),
    [anon_sym_cfguard_checkcc] = ACTIONS(505),
    [aux_sym_calling_conv_token1] = ACTIONS(507),
    [aux_sym_calling_conv_token2] = ACTIONS(505),
    [aux_sym_calling_conv_token3] = ACTIONS(505),
    [aux_sym_calling_conv_token4] = ACTIONS(505),
    [aux_sym_calling_conv_token5] = ACTIONS(505),
    [aux_sym_calling_conv_token6] = ACTIONS(505),
    [aux_sym_calling_conv_token7] = ACTIONS(505),
    [aux_sym_calling_conv_token8] = ACTIONS(505),
    [aux_sym_calling_conv_token9] = ACTIONS(505),
    [aux_sym_calling_conv_token10] = ACTIONS(507),
    [anon_sym_ghccc] = ACTIONS(505),
    [aux_sym_calling_conv_token11] = ACTIONS(507),
    [aux_sym_calling_conv_token12] = ACTIONS(505),
    [aux_sym_calling_conv_token13] = ACTIONS(507),
    [aux_sym_calling_conv_token14] = ACTIONS(505),
    [anon_sym_cc] = ACTIONS(507),
    [anon_sym_unnamed_addr] = ACTIONS(505),
    [anon_sym_local_unnamed_addr] = ACTIONS(505),
    [anon_sym_void] = ACTIONS(505),
    [anon_sym_half] = ACTIONS(505),
    [anon_sym_bfloat] = ACTIONS(505),
    [anon_sym_float] = ACTIONS(505),
    [anon_sym_double] = ACTIONS(505),
    [anon_sym_x86_fp80] = ACTIONS(507),
    [anon_sym_fp128] = ACTIONS(505),
    [anon_sym_ppc_fp128] = ACTIONS(505),
    [anon_sym_label] = ACTIONS(505),
    [anon_sym_metadata] = ACTIONS(505),
    [anon_sym_x86_mmx] = ACTIONS(507),
    [anon_sym_x86_amx] = ACTIONS(507),
    [anon_sym_token] = ACTIONS(505),
    [anon_sym_opaque] = ACTIONS(505),
    [anon_sym_ptr] = ACTIONS(505),
    [aux_sym_type_keyword_token1] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(505),
    [anon_sym_RBRACE] = ACTIONS(505),
    [anon_sym_LT_LBRACE] = ACTIONS(505),
    [anon_sym_LBRACK] = ACTIONS(505),
    [anon_sym_RBRACK] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(505),
    [anon_sym_COMMA] = ACTIONS(505),
    [anon_sym_RPAREN] = ACTIONS(505),
    [anon_sym_align] = ACTIONS(507),
    [anon_sym_alignstack] = ACTIONS(505),
    [anon_sym_allocsize] = ACTIONS(505),
    [anon_sym_alwaysinline] = ACTIONS(505),
    [anon_sym_builtin] = ACTIONS(505),
    [anon_sym_cold] = ACTIONS(507),
    [anon_sym_convergent] = ACTIONS(505),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(505),
    [anon_sym_hot] = ACTIONS(505),
    [anon_sym_inaccessiblememonly] = ACTIONS(505),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(505),
    [anon_sym_inlinehint] = ACTIONS(505),
    [anon_sym_jumptable] = ACTIONS(505),
    [anon_sym_minsize] = ACTIONS(505),
    [anon_sym_naked] = ACTIONS(505),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(505),
    [anon_sym_nobuiltin] = ACTIONS(505),
    [anon_sym_noduplicate] = ACTIONS(505),
    [anon_sym_nofree] = ACTIONS(505),
    [anon_sym_noimplicitfloat] = ACTIONS(505),
    [anon_sym_noinline] = ACTIONS(505),
    [anon_sym_nomerge] = ACTIONS(505),
    [anon_sym_nonlazybind] = ACTIONS(505),
    [anon_sym_noprofile] = ACTIONS(505),
    [anon_sym_noredzone] = ACTIONS(505),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(505),
    [anon_sym_noreturn] = ACTIONS(505),
    [anon_sym_norecurse] = ACTIONS(505),
    [anon_sym_willreturn] = ACTIONS(505),
    [anon_sym_nosync] = ACTIONS(505),
    [anon_sym_nounwind] = ACTIONS(505),
    [anon_sym_nocallback] = ACTIONS(505),
    [anon_sym_nosanitize_coverage] = ACTIONS(505),
    [anon_sym_null_pointer_is_valid] = ACTIONS(505),
    [anon_sym_optforfuzzing] = ACTIONS(505),
    [anon_sym_optnone] = ACTIONS(505),
    [anon_sym_optsize] = ACTIONS(505),
    [anon_sym_readnone] = ACTIONS(505),
    [anon_sym_readonly] = ACTIONS(505),
    [anon_sym_writeonly] = ACTIONS(505),
    [anon_sym_argmemonly] = ACTIONS(505),
    [anon_sym_returns_twice] = ACTIONS(505),
    [anon_sym_safestack] = ACTIONS(505),
    [anon_sym_sanitize_address] = ACTIONS(505),
    [anon_sym_sanitize_memory] = ACTIONS(505),
    [anon_sym_sanitize_thread] = ACTIONS(505),
    [anon_sym_sanitize_hwaddress] = ACTIONS(505),
    [anon_sym_sanitize_memtag] = ACTIONS(505),
    [anon_sym_speculative_load_hardening] = ACTIONS(505),
    [anon_sym_speculatable] = ACTIONS(505),
    [anon_sym_ssp] = ACTIONS(507),
    [anon_sym_sspstrong] = ACTIONS(505),
    [anon_sym_sspreq] = ACTIONS(505),
    [anon_sym_strictfp] = ACTIONS(505),
    [anon_sym_nocf_check] = ACTIONS(505),
    [anon_sym_shadowcallstack] = ACTIONS(505),
    [anon_sym_mustprogress] = ACTIONS(505),
    [anon_sym_vscale_range] = ACTIONS(505),
    [anon_sym_preallocated] = ACTIONS(505),
    [anon_sym_zeroext] = ACTIONS(505),
    [anon_sym_signext] = ACTIONS(505),
    [anon_sym_inreg] = ACTIONS(505),
    [anon_sym_byval] = ACTIONS(505),
    [anon_sym_byref] = ACTIONS(505),
    [anon_sym_inalloca] = ACTIONS(505),
    [anon_sym_sret] = ACTIONS(505),
    [anon_sym_elementtype] = ACTIONS(505),
    [anon_sym_noalias] = ACTIONS(505),
    [anon_sym_nocapture] = ACTIONS(505),
    [anon_sym_nest] = ACTIONS(505),
    [anon_sym_returned] = ACTIONS(505),
    [anon_sym_nonnull] = ACTIONS(505),
    [anon_sym_dereferenceable] = ACTIONS(507),
    [anon_sym_dereferenceable_or_null] = ACTIONS(505),
    [anon_sym_swiftself] = ACTIONS(507),
    [anon_sym_swiftasync] = ACTIONS(507),
    [anon_sym_swifterror] = ACTIONS(507),
    [anon_sym_immarg] = ACTIONS(505),
    [anon_sym_noundef] = ACTIONS(505),
    [anon_sym_uwtable] = ACTIONS(505),
    [anon_sym_memory] = ACTIONS(505),
    [anon_sym_to] = ACTIONS(507),
    [anon_sym_unwind] = ACTIONS(505),
    [anon_sym_unordered] = ACTIONS(505),
    [anon_sym_monotonic] = ACTIONS(505),
    [anon_sym_acquire] = ACTIONS(505),
    [anon_sym_release] = ACTIONS(505),
    [anon_sym_acq_rel] = ACTIONS(505),
    [anon_sym_seq_cst] = ACTIONS(505),
    [anon_sym_syncscope] = ACTIONS(505),
    [anon_sym_uselistorder] = ACTIONS(507),
    [anon_sym_uselistorder_bb] = ACTIONS(505),
    [anon_sym_module] = ACTIONS(505),
    [anon_sym_LPAREN2] = ACTIONS(505),
    [anon_sym_attributes] = ACTIONS(505),
  },
  [84] = {
    [ts_builtin_sym_end] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(509),
    [sym_global_var] = ACTIONS(509),
    [sym_local_var] = ACTIONS(509),
    [aux_sym_metadata_ref_token1] = ACTIONS(509),
    [sym_summary_ref] = ACTIONS(509),
    [sym_string] = ACTIONS(509),
    [anon_sym_target] = ACTIONS(509),
    [anon_sym_source_filename] = ACTIONS(509),
    [anon_sym_declare] = ACTIONS(509),
    [anon_sym_define] = ACTIONS(509),
    [anon_sym_no_cfi] = ACTIONS(509),
    [anon_sym_private] = ACTIONS(509),
    [anon_sym_internal] = ACTIONS(509),
    [anon_sym_weak] = ACTIONS(511),
    [anon_sym_weak_odr] = ACTIONS(509),
    [anon_sym_linkonce] = ACTIONS(511),
    [anon_sym_linkonce_odr] = ACTIONS(509),
    [anon_sym_available_externally] = ACTIONS(509),
    [anon_sym_appending] = ACTIONS(509),
    [anon_sym_common] = ACTIONS(509),
    [anon_sym_extern_weak] = ACTIONS(509),
    [anon_sym_external] = ACTIONS(509),
    [anon_sym_dso_local] = ACTIONS(511),
    [anon_sym_dso_local_equivalent] = ACTIONS(509),
    [anon_sym_dso_preemptable] = ACTIONS(509),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_hidden] = ACTIONS(509),
    [anon_sym_protected] = ACTIONS(509),
    [anon_sym_dllimport] = ACTIONS(509),
    [anon_sym_dllexport] = ACTIONS(509),
    [anon_sym_ccc] = ACTIONS(509),
    [anon_sym_fastcc] = ACTIONS(509),
    [anon_sym_coldcc] = ACTIONS(509),
    [anon_sym_webkit_jscc] = ACTIONS(511),
    [anon_sym_anyregcc] = ACTIONS(509),
    [anon_sym_preserve_mostcc] = ACTIONS(509),
    [anon_sym_preserve_allcc] = ACTIONS(509),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(511),
    [anon_sym_tailcc] = ACTIONS(509),
    [anon_sym_swiftcc] = ACTIONS(511),
    [anon_sym_swifttailcc] = ACTIONS(511),
    [anon_sym_cfguard_checkcc] = ACTIONS(509),
    [aux_sym_calling_conv_token1] = ACTIONS(511),
    [aux_sym_calling_conv_token2] = ACTIONS(509),
    [aux_sym_calling_conv_token3] = ACTIONS(509),
    [aux_sym_calling_conv_token4] = ACTIONS(509),
    [aux_sym_calling_conv_token5] = ACTIONS(509),
    [aux_sym_calling_conv_token6] = ACTIONS(509),
    [aux_sym_calling_conv_token7] = ACTIONS(509),
    [aux_sym_calling_conv_token8] = ACTIONS(509),
    [aux_sym_calling_conv_token9] = ACTIONS(509),
    [aux_sym_calling_conv_token10] = ACTIONS(511),
    [anon_sym_ghccc] = ACTIONS(509),
    [aux_sym_calling_conv_token11] = ACTIONS(511),
    [aux_sym_calling_conv_token12] = ACTIONS(509),
    [aux_sym_calling_conv_token13] = ACTIONS(511),
    [aux_sym_calling_conv_token14] = ACTIONS(509),
    [anon_sym_cc] = ACTIONS(511),
    [anon_sym_unnamed_addr] = ACTIONS(509),
    [anon_sym_local_unnamed_addr] = ACTIONS(509),
    [anon_sym_void] = ACTIONS(509),
    [anon_sym_half] = ACTIONS(509),
    [anon_sym_bfloat] = ACTIONS(509),
    [anon_sym_float] = ACTIONS(509),
    [anon_sym_double] = ACTIONS(509),
    [anon_sym_x86_fp80] = ACTIONS(511),
    [anon_sym_fp128] = ACTIONS(509),
    [anon_sym_ppc_fp128] = ACTIONS(509),
    [anon_sym_label] = ACTIONS(509),
    [anon_sym_metadata] = ACTIONS(509),
    [anon_sym_x86_mmx] = ACTIONS(511),
    [anon_sym_x86_amx] = ACTIONS(511),
    [anon_sym_token] = ACTIONS(509),
    [anon_sym_opaque] = ACTIONS(509),
    [anon_sym_ptr] = ACTIONS(509),
    [aux_sym_type_keyword_token1] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_RBRACE] = ACTIONS(509),
    [anon_sym_LT_LBRACE] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(509),
    [anon_sym_RBRACK] = ACTIONS(509),
    [anon_sym_LT] = ACTIONS(511),
    [anon_sym_GT] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_RPAREN] = ACTIONS(509),
    [anon_sym_align] = ACTIONS(511),
    [anon_sym_alignstack] = ACTIONS(509),
    [anon_sym_allocsize] = ACTIONS(509),
    [anon_sym_alwaysinline] = ACTIONS(509),
    [anon_sym_builtin] = ACTIONS(509),
    [anon_sym_cold] = ACTIONS(511),
    [anon_sym_convergent] = ACTIONS(509),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(509),
    [anon_sym_hot] = ACTIONS(509),
    [anon_sym_inaccessiblememonly] = ACTIONS(509),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(509),
    [anon_sym_inlinehint] = ACTIONS(509),
    [anon_sym_jumptable] = ACTIONS(509),
    [anon_sym_minsize] = ACTIONS(509),
    [anon_sym_naked] = ACTIONS(509),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(509),
    [anon_sym_nobuiltin] = ACTIONS(509),
    [anon_sym_noduplicate] = ACTIONS(509),
    [anon_sym_nofree] = ACTIONS(509),
    [anon_sym_noimplicitfloat] = ACTIONS(509),
    [anon_sym_noinline] = ACTIONS(509),
    [anon_sym_nomerge] = ACTIONS(509),
    [anon_sym_nonlazybind] = ACTIONS(509),
    [anon_sym_noprofile] = ACTIONS(509),
    [anon_sym_noredzone] = ACTIONS(509),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(509),
    [anon_sym_noreturn] = ACTIONS(509),
    [anon_sym_norecurse] = ACTIONS(509),
    [anon_sym_willreturn] = ACTIONS(509),
    [anon_sym_nosync] = ACTIONS(509),
    [anon_sym_nounwind] = ACTIONS(509),
    [anon_sym_nocallback] = ACTIONS(509),
    [anon_sym_nosanitize_coverage] = ACTIONS(509),
    [anon_sym_null_pointer_is_valid] = ACTIONS(509),
    [anon_sym_optforfuzzing] = ACTIONS(509),
    [anon_sym_optnone] = ACTIONS(509),
    [anon_sym_optsize] = ACTIONS(509),
    [anon_sym_readnone] = ACTIONS(509),
    [anon_sym_readonly] = ACTIONS(509),
    [anon_sym_writeonly] = ACTIONS(509),
    [anon_sym_argmemonly] = ACTIONS(509),
    [anon_sym_returns_twice] = ACTIONS(509),
    [anon_sym_safestack] = ACTIONS(509),
    [anon_sym_sanitize_address] = ACTIONS(509),
    [anon_sym_sanitize_memory] = ACTIONS(509),
    [anon_sym_sanitize_thread] = ACTIONS(509),
    [anon_sym_sanitize_hwaddress] = ACTIONS(509),
    [anon_sym_sanitize_memtag] = ACTIONS(509),
    [anon_sym_speculative_load_hardening] = ACTIONS(509),
    [anon_sym_speculatable] = ACTIONS(509),
    [anon_sym_ssp] = ACTIONS(511),
    [anon_sym_sspstrong] = ACTIONS(509),
    [anon_sym_sspreq] = ACTIONS(509),
    [anon_sym_strictfp] = ACTIONS(509),
    [anon_sym_nocf_check] = ACTIONS(509),
    [anon_sym_shadowcallstack] = ACTIONS(509),
    [anon_sym_mustprogress] = ACTIONS(509),
    [anon_sym_vscale_range] = ACTIONS(509),
    [anon_sym_preallocated] = ACTIONS(509),
    [anon_sym_zeroext] = ACTIONS(509),
    [anon_sym_signext] = ACTIONS(509),
    [anon_sym_inreg] = ACTIONS(509),
    [anon_sym_byval] = ACTIONS(509),
    [anon_sym_byref] = ACTIONS(509),
    [anon_sym_inalloca] = ACTIONS(509),
    [anon_sym_sret] = ACTIONS(509),
    [anon_sym_elementtype] = ACTIONS(509),
    [anon_sym_noalias] = ACTIONS(509),
    [anon_sym_nocapture] = ACTIONS(509),
    [anon_sym_nest] = ACTIONS(509),
    [anon_sym_returned] = ACTIONS(509),
    [anon_sym_nonnull] = ACTIONS(509),
    [anon_sym_dereferenceable] = ACTIONS(511),
    [anon_sym_dereferenceable_or_null] = ACTIONS(509),
    [anon_sym_swiftself] = ACTIONS(511),
    [anon_sym_swiftasync] = ACTIONS(511),
    [anon_sym_swifterror] = ACTIONS(511),
    [anon_sym_immarg] = ACTIONS(509),
    [anon_sym_noundef] = ACTIONS(509),
    [anon_sym_uwtable] = ACTIONS(509),
    [anon_sym_memory] = ACTIONS(509),
    [anon_sym_to] = ACTIONS(511),
    [anon_sym_unwind] = ACTIONS(509),
    [anon_sym_unordered] = ACTIONS(509),
    [anon_sym_monotonic] = ACTIONS(509),
    [anon_sym_acquire] = ACTIONS(509),
    [anon_sym_release] = ACTIONS(509),
    [anon_sym_acq_rel] = ACTIONS(509),
    [anon_sym_seq_cst] = ACTIONS(509),
    [anon_sym_syncscope] = ACTIONS(509),
    [anon_sym_uselistorder] = ACTIONS(511),
    [anon_sym_uselistorder_bb] = ACTIONS(509),
    [anon_sym_module] = ACTIONS(509),
    [anon_sym_attributes] = ACTIONS(509),
  },
  [85] = {
    [ts_builtin_sym_end] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(513),
    [sym_global_var] = ACTIONS(513),
    [sym_local_var] = ACTIONS(513),
    [aux_sym_metadata_ref_token1] = ACTIONS(513),
    [sym_summary_ref] = ACTIONS(513),
    [sym_string] = ACTIONS(513),
    [anon_sym_target] = ACTIONS(513),
    [anon_sym_source_filename] = ACTIONS(513),
    [anon_sym_declare] = ACTIONS(513),
    [anon_sym_define] = ACTIONS(513),
    [anon_sym_no_cfi] = ACTIONS(513),
    [anon_sym_private] = ACTIONS(513),
    [anon_sym_internal] = ACTIONS(513),
    [anon_sym_weak] = ACTIONS(515),
    [anon_sym_weak_odr] = ACTIONS(513),
    [anon_sym_linkonce] = ACTIONS(515),
    [anon_sym_linkonce_odr] = ACTIONS(513),
    [anon_sym_available_externally] = ACTIONS(513),
    [anon_sym_appending] = ACTIONS(513),
    [anon_sym_common] = ACTIONS(513),
    [anon_sym_extern_weak] = ACTIONS(513),
    [anon_sym_external] = ACTIONS(513),
    [anon_sym_dso_local] = ACTIONS(515),
    [anon_sym_dso_local_equivalent] = ACTIONS(513),
    [anon_sym_dso_preemptable] = ACTIONS(513),
    [anon_sym_default] = ACTIONS(513),
    [anon_sym_hidden] = ACTIONS(513),
    [anon_sym_protected] = ACTIONS(513),
    [anon_sym_dllimport] = ACTIONS(513),
    [anon_sym_dllexport] = ACTIONS(513),
    [anon_sym_ccc] = ACTIONS(513),
    [anon_sym_fastcc] = ACTIONS(513),
    [anon_sym_coldcc] = ACTIONS(513),
    [anon_sym_webkit_jscc] = ACTIONS(515),
    [anon_sym_anyregcc] = ACTIONS(513),
    [anon_sym_preserve_mostcc] = ACTIONS(513),
    [anon_sym_preserve_allcc] = ACTIONS(513),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(515),
    [anon_sym_tailcc] = ACTIONS(513),
    [anon_sym_swiftcc] = ACTIONS(515),
    [anon_sym_swifttailcc] = ACTIONS(515),
    [anon_sym_cfguard_checkcc] = ACTIONS(513),
    [aux_sym_calling_conv_token1] = ACTIONS(515),
    [aux_sym_calling_conv_token2] = ACTIONS(513),
    [aux_sym_calling_conv_token3] = ACTIONS(513),
    [aux_sym_calling_conv_token4] = ACTIONS(513),
    [aux_sym_calling_conv_token5] = ACTIONS(513),
    [aux_sym_calling_conv_token6] = ACTIONS(513),
    [aux_sym_calling_conv_token7] = ACTIONS(513),
    [aux_sym_calling_conv_token8] = ACTIONS(513),
    [aux_sym_calling_conv_token9] = ACTIONS(513),
    [aux_sym_calling_conv_token10] = ACTIONS(515),
    [anon_sym_ghccc] = ACTIONS(513),
    [aux_sym_calling_conv_token11] = ACTIONS(515),
    [aux_sym_calling_conv_token12] = ACTIONS(513),
    [aux_sym_calling_conv_token13] = ACTIONS(515),
    [aux_sym_calling_conv_token14] = ACTIONS(513),
    [anon_sym_cc] = ACTIONS(515),
    [anon_sym_unnamed_addr] = ACTIONS(513),
    [anon_sym_local_unnamed_addr] = ACTIONS(513),
    [anon_sym_void] = ACTIONS(513),
    [anon_sym_half] = ACTIONS(513),
    [anon_sym_bfloat] = ACTIONS(513),
    [anon_sym_float] = ACTIONS(513),
    [anon_sym_double] = ACTIONS(513),
    [anon_sym_x86_fp80] = ACTIONS(515),
    [anon_sym_fp128] = ACTIONS(513),
    [anon_sym_ppc_fp128] = ACTIONS(513),
    [anon_sym_label] = ACTIONS(513),
    [anon_sym_metadata] = ACTIONS(513),
    [anon_sym_x86_mmx] = ACTIONS(515),
    [anon_sym_x86_amx] = ACTIONS(515),
    [anon_sym_token] = ACTIONS(513),
    [anon_sym_opaque] = ACTIONS(513),
    [anon_sym_ptr] = ACTIONS(513),
    [aux_sym_type_keyword_token1] = ACTIONS(513),
    [anon_sym_LBRACE] = ACTIONS(513),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_LT_LBRACE] = ACTIONS(513),
    [anon_sym_LBRACK] = ACTIONS(513),
    [anon_sym_RBRACK] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(515),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_COMMA] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(513),
    [anon_sym_RPAREN] = ACTIONS(513),
    [anon_sym_align] = ACTIONS(515),
    [anon_sym_alignstack] = ACTIONS(513),
    [anon_sym_allocsize] = ACTIONS(513),
    [anon_sym_alwaysinline] = ACTIONS(513),
    [anon_sym_builtin] = ACTIONS(513),
    [anon_sym_cold] = ACTIONS(515),
    [anon_sym_convergent] = ACTIONS(513),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(513),
    [anon_sym_hot] = ACTIONS(513),
    [anon_sym_inaccessiblememonly] = ACTIONS(513),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(513),
    [anon_sym_inlinehint] = ACTIONS(513),
    [anon_sym_jumptable] = ACTIONS(513),
    [anon_sym_minsize] = ACTIONS(513),
    [anon_sym_naked] = ACTIONS(513),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(513),
    [anon_sym_nobuiltin] = ACTIONS(513),
    [anon_sym_noduplicate] = ACTIONS(513),
    [anon_sym_nofree] = ACTIONS(513),
    [anon_sym_noimplicitfloat] = ACTIONS(513),
    [anon_sym_noinline] = ACTIONS(513),
    [anon_sym_nomerge] = ACTIONS(513),
    [anon_sym_nonlazybind] = ACTIONS(513),
    [anon_sym_noprofile] = ACTIONS(513),
    [anon_sym_noredzone] = ACTIONS(513),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(513),
    [anon_sym_noreturn] = ACTIONS(513),
    [anon_sym_norecurse] = ACTIONS(513),
    [anon_sym_willreturn] = ACTIONS(513),
    [anon_sym_nosync] = ACTIONS(513),
    [anon_sym_nounwind] = ACTIONS(513),
    [anon_sym_nocallback] = ACTIONS(513),
    [anon_sym_nosanitize_coverage] = ACTIONS(513),
    [anon_sym_null_pointer_is_valid] = ACTIONS(513),
    [anon_sym_optforfuzzing] = ACTIONS(513),
    [anon_sym_optnone] = ACTIONS(513),
    [anon_sym_optsize] = ACTIONS(513),
    [anon_sym_readnone] = ACTIONS(513),
    [anon_sym_readonly] = ACTIONS(513),
    [anon_sym_writeonly] = ACTIONS(513),
    [anon_sym_argmemonly] = ACTIONS(513),
    [anon_sym_returns_twice] = ACTIONS(513),
    [anon_sym_safestack] = ACTIONS(513),
    [anon_sym_sanitize_address] = ACTIONS(513),
    [anon_sym_sanitize_memory] = ACTIONS(513),
    [anon_sym_sanitize_thread] = ACTIONS(513),
    [anon_sym_sanitize_hwaddress] = ACTIONS(513),
    [anon_sym_sanitize_memtag] = ACTIONS(513),
    [anon_sym_speculative_load_hardening] = ACTIONS(513),
    [anon_sym_speculatable] = ACTIONS(513),
    [anon_sym_ssp] = ACTIONS(515),
    [anon_sym_sspstrong] = ACTIONS(513),
    [anon_sym_sspreq] = ACTIONS(513),
    [anon_sym_strictfp] = ACTIONS(513),
    [anon_sym_nocf_check] = ACTIONS(513),
    [anon_sym_shadowcallstack] = ACTIONS(513),
    [anon_sym_mustprogress] = ACTIONS(513),
    [anon_sym_vscale_range] = ACTIONS(513),
    [anon_sym_preallocated] = ACTIONS(513),
    [anon_sym_zeroext] = ACTIONS(513),
    [anon_sym_signext] = ACTIONS(513),
    [anon_sym_inreg] = ACTIONS(513),
    [anon_sym_byval] = ACTIONS(513),
    [anon_sym_byref] = ACTIONS(513),
    [anon_sym_inalloca] = ACTIONS(513),
    [anon_sym_sret] = ACTIONS(513),
    [anon_sym_elementtype] = ACTIONS(513),
    [anon_sym_noalias] = ACTIONS(513),
    [anon_sym_nocapture] = ACTIONS(513),
    [anon_sym_nest] = ACTIONS(513),
    [anon_sym_returned] = ACTIONS(513),
    [anon_sym_nonnull] = ACTIONS(513),
    [anon_sym_dereferenceable] = ACTIONS(515),
    [anon_sym_dereferenceable_or_null] = ACTIONS(513),
    [anon_sym_swiftself] = ACTIONS(515),
    [anon_sym_swiftasync] = ACTIONS(515),
    [anon_sym_swifterror] = ACTIONS(515),
    [anon_sym_immarg] = ACTIONS(513),
    [anon_sym_noundef] = ACTIONS(513),
    [anon_sym_uwtable] = ACTIONS(513),
    [anon_sym_memory] = ACTIONS(513),
    [anon_sym_to] = ACTIONS(515),
    [anon_sym_unwind] = ACTIONS(513),
    [anon_sym_unordered] = ACTIONS(513),
    [anon_sym_monotonic] = ACTIONS(513),
    [anon_sym_acquire] = ACTIONS(513),
    [anon_sym_release] = ACTIONS(513),
    [anon_sym_acq_rel] = ACTIONS(513),
    [anon_sym_seq_cst] = ACTIONS(513),
    [anon_sym_syncscope] = ACTIONS(513),
    [anon_sym_uselistorder] = ACTIONS(515),
    [anon_sym_uselistorder_bb] = ACTIONS(513),
    [anon_sym_module] = ACTIONS(513),
    [anon_sym_attributes] = ACTIONS(513),
  },
  [86] = {
    [ts_builtin_sym_end] = ACTIONS(517),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(517),
    [sym_global_var] = ACTIONS(517),
    [sym_local_var] = ACTIONS(517),
    [aux_sym_metadata_ref_token1] = ACTIONS(517),
    [sym_summary_ref] = ACTIONS(517),
    [sym_string] = ACTIONS(517),
    [anon_sym_target] = ACTIONS(517),
    [anon_sym_source_filename] = ACTIONS(517),
    [anon_sym_declare] = ACTIONS(517),
    [anon_sym_define] = ACTIONS(517),
    [anon_sym_no_cfi] = ACTIONS(517),
    [anon_sym_private] = ACTIONS(517),
    [anon_sym_internal] = ACTIONS(517),
    [anon_sym_weak] = ACTIONS(519),
    [anon_sym_weak_odr] = ACTIONS(517),
    [anon_sym_linkonce] = ACTIONS(519),
    [anon_sym_linkonce_odr] = ACTIONS(517),
    [anon_sym_available_externally] = ACTIONS(517),
    [anon_sym_appending] = ACTIONS(517),
    [anon_sym_common] = ACTIONS(517),
    [anon_sym_extern_weak] = ACTIONS(517),
    [anon_sym_external] = ACTIONS(517),
    [anon_sym_dso_local] = ACTIONS(519),
    [anon_sym_dso_local_equivalent] = ACTIONS(517),
    [anon_sym_dso_preemptable] = ACTIONS(517),
    [anon_sym_default] = ACTIONS(517),
    [anon_sym_hidden] = ACTIONS(517),
    [anon_sym_protected] = ACTIONS(517),
    [anon_sym_dllimport] = ACTIONS(517),
    [anon_sym_dllexport] = ACTIONS(517),
    [anon_sym_ccc] = ACTIONS(517),
    [anon_sym_fastcc] = ACTIONS(517),
    [anon_sym_coldcc] = ACTIONS(517),
    [anon_sym_webkit_jscc] = ACTIONS(519),
    [anon_sym_anyregcc] = ACTIONS(517),
    [anon_sym_preserve_mostcc] = ACTIONS(517),
    [anon_sym_preserve_allcc] = ACTIONS(517),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(519),
    [anon_sym_tailcc] = ACTIONS(517),
    [anon_sym_swiftcc] = ACTIONS(519),
    [anon_sym_swifttailcc] = ACTIONS(519),
    [anon_sym_cfguard_checkcc] = ACTIONS(517),
    [aux_sym_calling_conv_token1] = ACTIONS(519),
    [aux_sym_calling_conv_token2] = ACTIONS(517),
    [aux_sym_calling_conv_token3] = ACTIONS(517),
    [aux_sym_calling_conv_token4] = ACTIONS(517),
    [aux_sym_calling_conv_token5] = ACTIONS(517),
    [aux_sym_calling_conv_token6] = ACTIONS(517),
    [aux_sym_calling_conv_token7] = ACTIONS(517),
    [aux_sym_calling_conv_token8] = ACTIONS(517),
    [aux_sym_calling_conv_token9] = ACTIONS(517),
    [aux_sym_calling_conv_token10] = ACTIONS(519),
    [anon_sym_ghccc] = ACTIONS(517),
    [aux_sym_calling_conv_token11] = ACTIONS(519),
    [aux_sym_calling_conv_token12] = ACTIONS(517),
    [aux_sym_calling_conv_token13] = ACTIONS(519),
    [aux_sym_calling_conv_token14] = ACTIONS(517),
    [anon_sym_cc] = ACTIONS(519),
    [anon_sym_unnamed_addr] = ACTIONS(517),
    [anon_sym_local_unnamed_addr] = ACTIONS(517),
    [anon_sym_void] = ACTIONS(517),
    [anon_sym_half] = ACTIONS(517),
    [anon_sym_bfloat] = ACTIONS(517),
    [anon_sym_float] = ACTIONS(517),
    [anon_sym_double] = ACTIONS(517),
    [anon_sym_x86_fp80] = ACTIONS(519),
    [anon_sym_fp128] = ACTIONS(517),
    [anon_sym_ppc_fp128] = ACTIONS(517),
    [anon_sym_label] = ACTIONS(517),
    [anon_sym_metadata] = ACTIONS(517),
    [anon_sym_x86_mmx] = ACTIONS(519),
    [anon_sym_x86_amx] = ACTIONS(519),
    [anon_sym_token] = ACTIONS(517),
    [anon_sym_opaque] = ACTIONS(517),
    [anon_sym_ptr] = ACTIONS(517),
    [aux_sym_type_keyword_token1] = ACTIONS(517),
    [anon_sym_LBRACE] = ACTIONS(517),
    [anon_sym_RBRACE] = ACTIONS(517),
    [anon_sym_LT_LBRACE] = ACTIONS(517),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_RBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_GT] = ACTIONS(517),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_LPAREN] = ACTIONS(517),
    [anon_sym_RPAREN] = ACTIONS(517),
    [anon_sym_align] = ACTIONS(519),
    [anon_sym_alignstack] = ACTIONS(517),
    [anon_sym_allocsize] = ACTIONS(517),
    [anon_sym_alwaysinline] = ACTIONS(517),
    [anon_sym_builtin] = ACTIONS(517),
    [anon_sym_cold] = ACTIONS(519),
    [anon_sym_convergent] = ACTIONS(517),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(517),
    [anon_sym_hot] = ACTIONS(517),
    [anon_sym_inaccessiblememonly] = ACTIONS(517),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(517),
    [anon_sym_inlinehint] = ACTIONS(517),
    [anon_sym_jumptable] = ACTIONS(517),
    [anon_sym_minsize] = ACTIONS(517),
    [anon_sym_naked] = ACTIONS(517),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(517),
    [anon_sym_nobuiltin] = ACTIONS(517),
    [anon_sym_noduplicate] = ACTIONS(517),
    [anon_sym_nofree] = ACTIONS(517),
    [anon_sym_noimplicitfloat] = ACTIONS(517),
    [anon_sym_noinline] = ACTIONS(517),
    [anon_sym_nomerge] = ACTIONS(517),
    [anon_sym_nonlazybind] = ACTIONS(517),
    [anon_sym_noprofile] = ACTIONS(517),
    [anon_sym_noredzone] = ACTIONS(517),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(517),
    [anon_sym_noreturn] = ACTIONS(517),
    [anon_sym_norecurse] = ACTIONS(517),
    [anon_sym_willreturn] = ACTIONS(517),
    [anon_sym_nosync] = ACTIONS(517),
    [anon_sym_nounwind] = ACTIONS(517),
    [anon_sym_nocallback] = ACTIONS(517),
    [anon_sym_nosanitize_coverage] = ACTIONS(517),
    [anon_sym_null_pointer_is_valid] = ACTIONS(517),
    [anon_sym_optforfuzzing] = ACTIONS(517),
    [anon_sym_optnone] = ACTIONS(517),
    [anon_sym_optsize] = ACTIONS(517),
    [anon_sym_readnone] = ACTIONS(517),
    [anon_sym_readonly] = ACTIONS(517),
    [anon_sym_writeonly] = ACTIONS(517),
    [anon_sym_argmemonly] = ACTIONS(517),
    [anon_sym_returns_twice] = ACTIONS(517),
    [anon_sym_safestack] = ACTIONS(517),
    [anon_sym_sanitize_address] = ACTIONS(517),
    [anon_sym_sanitize_memory] = ACTIONS(517),
    [anon_sym_sanitize_thread] = ACTIONS(517),
    [anon_sym_sanitize_hwaddress] = ACTIONS(517),
    [anon_sym_sanitize_memtag] = ACTIONS(517),
    [anon_sym_speculative_load_hardening] = ACTIONS(517),
    [anon_sym_speculatable] = ACTIONS(517),
    [anon_sym_ssp] = ACTIONS(519),
    [anon_sym_sspstrong] = ACTIONS(517),
    [anon_sym_sspreq] = ACTIONS(517),
    [anon_sym_strictfp] = ACTIONS(517),
    [anon_sym_nocf_check] = ACTIONS(517),
    [anon_sym_shadowcallstack] = ACTIONS(517),
    [anon_sym_mustprogress] = ACTIONS(517),
    [anon_sym_vscale_range] = ACTIONS(517),
    [anon_sym_preallocated] = ACTIONS(517),
    [anon_sym_zeroext] = ACTIONS(517),
    [anon_sym_signext] = ACTIONS(517),
    [anon_sym_inreg] = ACTIONS(517),
    [anon_sym_byval] = ACTIONS(517),
    [anon_sym_byref] = ACTIONS(517),
    [anon_sym_inalloca] = ACTIONS(517),
    [anon_sym_sret] = ACTIONS(517),
    [anon_sym_elementtype] = ACTIONS(517),
    [anon_sym_noalias] = ACTIONS(517),
    [anon_sym_nocapture] = ACTIONS(517),
    [anon_sym_nest] = ACTIONS(517),
    [anon_sym_returned] = ACTIONS(517),
    [anon_sym_nonnull] = ACTIONS(517),
    [anon_sym_dereferenceable] = ACTIONS(519),
    [anon_sym_dereferenceable_or_null] = ACTIONS(517),
    [anon_sym_swiftself] = ACTIONS(519),
    [anon_sym_swiftasync] = ACTIONS(519),
    [anon_sym_swifterror] = ACTIONS(519),
    [anon_sym_immarg] = ACTIONS(517),
    [anon_sym_noundef] = ACTIONS(517),
    [anon_sym_uwtable] = ACTIONS(517),
    [anon_sym_memory] = ACTIONS(517),
    [anon_sym_to] = ACTIONS(519),
    [anon_sym_unwind] = ACTIONS(517),
    [anon_sym_unordered] = ACTIONS(517),
    [anon_sym_monotonic] = ACTIONS(517),
    [anon_sym_acquire] = ACTIONS(517),
    [anon_sym_release] = ACTIONS(517),
    [anon_sym_acq_rel] = ACTIONS(517),
    [anon_sym_seq_cst] = ACTIONS(517),
    [anon_sym_syncscope] = ACTIONS(517),
    [anon_sym_uselistorder] = ACTIONS(519),
    [anon_sym_uselistorder_bb] = ACTIONS(517),
    [anon_sym_module] = ACTIONS(517),
    [anon_sym_attributes] = ACTIONS(517),
  },
  [87] = {
    [ts_builtin_sym_end] = ACTIONS(521),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(521),
    [sym_global_var] = ACTIONS(521),
    [sym_local_var] = ACTIONS(521),
    [aux_sym_metadata_ref_token1] = ACTIONS(521),
    [sym_summary_ref] = ACTIONS(521),
    [sym_string] = ACTIONS(521),
    [anon_sym_target] = ACTIONS(521),
    [anon_sym_source_filename] = ACTIONS(521),
    [anon_sym_declare] = ACTIONS(521),
    [anon_sym_define] = ACTIONS(521),
    [anon_sym_no_cfi] = ACTIONS(521),
    [anon_sym_private] = ACTIONS(521),
    [anon_sym_internal] = ACTIONS(521),
    [anon_sym_weak] = ACTIONS(523),
    [anon_sym_weak_odr] = ACTIONS(521),
    [anon_sym_linkonce] = ACTIONS(523),
    [anon_sym_linkonce_odr] = ACTIONS(521),
    [anon_sym_available_externally] = ACTIONS(521),
    [anon_sym_appending] = ACTIONS(521),
    [anon_sym_common] = ACTIONS(521),
    [anon_sym_extern_weak] = ACTIONS(521),
    [anon_sym_external] = ACTIONS(521),
    [anon_sym_dso_local] = ACTIONS(523),
    [anon_sym_dso_local_equivalent] = ACTIONS(521),
    [anon_sym_dso_preemptable] = ACTIONS(521),
    [anon_sym_default] = ACTIONS(521),
    [anon_sym_hidden] = ACTIONS(521),
    [anon_sym_protected] = ACTIONS(521),
    [anon_sym_dllimport] = ACTIONS(521),
    [anon_sym_dllexport] = ACTIONS(521),
    [anon_sym_ccc] = ACTIONS(521),
    [anon_sym_fastcc] = ACTIONS(521),
    [anon_sym_coldcc] = ACTIONS(521),
    [anon_sym_webkit_jscc] = ACTIONS(523),
    [anon_sym_anyregcc] = ACTIONS(521),
    [anon_sym_preserve_mostcc] = ACTIONS(521),
    [anon_sym_preserve_allcc] = ACTIONS(521),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(523),
    [anon_sym_tailcc] = ACTIONS(521),
    [anon_sym_swiftcc] = ACTIONS(523),
    [anon_sym_swifttailcc] = ACTIONS(523),
    [anon_sym_cfguard_checkcc] = ACTIONS(521),
    [aux_sym_calling_conv_token1] = ACTIONS(523),
    [aux_sym_calling_conv_token2] = ACTIONS(521),
    [aux_sym_calling_conv_token3] = ACTIONS(521),
    [aux_sym_calling_conv_token4] = ACTIONS(521),
    [aux_sym_calling_conv_token5] = ACTIONS(521),
    [aux_sym_calling_conv_token6] = ACTIONS(521),
    [aux_sym_calling_conv_token7] = ACTIONS(521),
    [aux_sym_calling_conv_token8] = ACTIONS(521),
    [aux_sym_calling_conv_token9] = ACTIONS(521),
    [aux_sym_calling_conv_token10] = ACTIONS(523),
    [anon_sym_ghccc] = ACTIONS(521),
    [aux_sym_calling_conv_token11] = ACTIONS(523),
    [aux_sym_calling_conv_token12] = ACTIONS(521),
    [aux_sym_calling_conv_token13] = ACTIONS(523),
    [aux_sym_calling_conv_token14] = ACTIONS(521),
    [anon_sym_cc] = ACTIONS(523),
    [anon_sym_unnamed_addr] = ACTIONS(521),
    [anon_sym_local_unnamed_addr] = ACTIONS(521),
    [anon_sym_void] = ACTIONS(521),
    [anon_sym_half] = ACTIONS(521),
    [anon_sym_bfloat] = ACTIONS(521),
    [anon_sym_float] = ACTIONS(521),
    [anon_sym_double] = ACTIONS(521),
    [anon_sym_x86_fp80] = ACTIONS(523),
    [anon_sym_fp128] = ACTIONS(521),
    [anon_sym_ppc_fp128] = ACTIONS(521),
    [anon_sym_label] = ACTIONS(521),
    [anon_sym_metadata] = ACTIONS(521),
    [anon_sym_x86_mmx] = ACTIONS(523),
    [anon_sym_x86_amx] = ACTIONS(523),
    [anon_sym_token] = ACTIONS(521),
    [anon_sym_opaque] = ACTIONS(521),
    [anon_sym_ptr] = ACTIONS(521),
    [aux_sym_type_keyword_token1] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_RBRACE] = ACTIONS(521),
    [anon_sym_LT_LBRACE] = ACTIONS(521),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_RBRACK] = ACTIONS(521),
    [anon_sym_LT] = ACTIONS(523),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_COMMA] = ACTIONS(521),
    [anon_sym_LPAREN] = ACTIONS(521),
    [anon_sym_RPAREN] = ACTIONS(521),
    [anon_sym_align] = ACTIONS(523),
    [anon_sym_alignstack] = ACTIONS(521),
    [anon_sym_allocsize] = ACTIONS(521),
    [anon_sym_alwaysinline] = ACTIONS(521),
    [anon_sym_builtin] = ACTIONS(521),
    [anon_sym_cold] = ACTIONS(523),
    [anon_sym_convergent] = ACTIONS(521),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(521),
    [anon_sym_hot] = ACTIONS(521),
    [anon_sym_inaccessiblememonly] = ACTIONS(521),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(521),
    [anon_sym_inlinehint] = ACTIONS(521),
    [anon_sym_jumptable] = ACTIONS(521),
    [anon_sym_minsize] = ACTIONS(521),
    [anon_sym_naked] = ACTIONS(521),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(521),
    [anon_sym_nobuiltin] = ACTIONS(521),
    [anon_sym_noduplicate] = ACTIONS(521),
    [anon_sym_nofree] = ACTIONS(521),
    [anon_sym_noimplicitfloat] = ACTIONS(521),
    [anon_sym_noinline] = ACTIONS(521),
    [anon_sym_nomerge] = ACTIONS(521),
    [anon_sym_nonlazybind] = ACTIONS(521),
    [anon_sym_noprofile] = ACTIONS(521),
    [anon_sym_noredzone] = ACTIONS(521),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(521),
    [anon_sym_noreturn] = ACTIONS(521),
    [anon_sym_norecurse] = ACTIONS(521),
    [anon_sym_willreturn] = ACTIONS(521),
    [anon_sym_nosync] = ACTIONS(521),
    [anon_sym_nounwind] = ACTIONS(521),
    [anon_sym_nocallback] = ACTIONS(521),
    [anon_sym_nosanitize_coverage] = ACTIONS(521),
    [anon_sym_null_pointer_is_valid] = ACTIONS(521),
    [anon_sym_optforfuzzing] = ACTIONS(521),
    [anon_sym_optnone] = ACTIONS(521),
    [anon_sym_optsize] = ACTIONS(521),
    [anon_sym_readnone] = ACTIONS(521),
    [anon_sym_readonly] = ACTIONS(521),
    [anon_sym_writeonly] = ACTIONS(521),
    [anon_sym_argmemonly] = ACTIONS(521),
    [anon_sym_returns_twice] = ACTIONS(521),
    [anon_sym_safestack] = ACTIONS(521),
    [anon_sym_sanitize_address] = ACTIONS(521),
    [anon_sym_sanitize_memory] = ACTIONS(521),
    [anon_sym_sanitize_thread] = ACTIONS(521),
    [anon_sym_sanitize_hwaddress] = ACTIONS(521),
    [anon_sym_sanitize_memtag] = ACTIONS(521),
    [anon_sym_speculative_load_hardening] = ACTIONS(521),
    [anon_sym_speculatable] = ACTIONS(521),
    [anon_sym_ssp] = ACTIONS(523),
    [anon_sym_sspstrong] = ACTIONS(521),
    [anon_sym_sspreq] = ACTIONS(521),
    [anon_sym_strictfp] = ACTIONS(521),
    [anon_sym_nocf_check] = ACTIONS(521),
    [anon_sym_shadowcallstack] = ACTIONS(521),
    [anon_sym_mustprogress] = ACTIONS(521),
    [anon_sym_vscale_range] = ACTIONS(521),
    [anon_sym_preallocated] = ACTIONS(521),
    [anon_sym_zeroext] = ACTIONS(521),
    [anon_sym_signext] = ACTIONS(521),
    [anon_sym_inreg] = ACTIONS(521),
    [anon_sym_byval] = ACTIONS(521),
    [anon_sym_byref] = ACTIONS(521),
    [anon_sym_inalloca] = ACTIONS(521),
    [anon_sym_sret] = ACTIONS(521),
    [anon_sym_elementtype] = ACTIONS(521),
    [anon_sym_noalias] = ACTIONS(521),
    [anon_sym_nocapture] = ACTIONS(521),
    [anon_sym_nest] = ACTIONS(521),
    [anon_sym_returned] = ACTIONS(521),
    [anon_sym_nonnull] = ACTIONS(521),
    [anon_sym_dereferenceable] = ACTIONS(523),
    [anon_sym_dereferenceable_or_null] = ACTIONS(521),
    [anon_sym_swiftself] = ACTIONS(523),
    [anon_sym_swiftasync] = ACTIONS(523),
    [anon_sym_swifterror] = ACTIONS(523),
    [anon_sym_immarg] = ACTIONS(521),
    [anon_sym_noundef] = ACTIONS(521),
    [anon_sym_uwtable] = ACTIONS(521),
    [anon_sym_memory] = ACTIONS(521),
    [anon_sym_to] = ACTIONS(523),
    [anon_sym_unwind] = ACTIONS(521),
    [anon_sym_unordered] = ACTIONS(521),
    [anon_sym_monotonic] = ACTIONS(521),
    [anon_sym_acquire] = ACTIONS(521),
    [anon_sym_release] = ACTIONS(521),
    [anon_sym_acq_rel] = ACTIONS(521),
    [anon_sym_seq_cst] = ACTIONS(521),
    [anon_sym_syncscope] = ACTIONS(521),
    [anon_sym_uselistorder] = ACTIONS(523),
    [anon_sym_uselistorder_bb] = ACTIONS(521),
    [anon_sym_module] = ACTIONS(521),
    [anon_sym_attributes] = ACTIONS(521),
  },
  [88] = {
    [ts_builtin_sym_end] = ACTIONS(525),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(525),
    [sym_global_var] = ACTIONS(525),
    [sym_local_var] = ACTIONS(525),
    [aux_sym_metadata_ref_token1] = ACTIONS(525),
    [sym_summary_ref] = ACTIONS(525),
    [sym_string] = ACTIONS(525),
    [anon_sym_target] = ACTIONS(525),
    [anon_sym_source_filename] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(525),
    [anon_sym_define] = ACTIONS(525),
    [anon_sym_no_cfi] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_internal] = ACTIONS(525),
    [anon_sym_weak] = ACTIONS(527),
    [anon_sym_weak_odr] = ACTIONS(525),
    [anon_sym_linkonce] = ACTIONS(527),
    [anon_sym_linkonce_odr] = ACTIONS(525),
    [anon_sym_available_externally] = ACTIONS(525),
    [anon_sym_appending] = ACTIONS(525),
    [anon_sym_common] = ACTIONS(525),
    [anon_sym_extern_weak] = ACTIONS(525),
    [anon_sym_external] = ACTIONS(525),
    [anon_sym_dso_local] = ACTIONS(527),
    [anon_sym_dso_local_equivalent] = ACTIONS(525),
    [anon_sym_dso_preemptable] = ACTIONS(525),
    [anon_sym_default] = ACTIONS(525),
    [anon_sym_hidden] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_dllimport] = ACTIONS(525),
    [anon_sym_dllexport] = ACTIONS(525),
    [anon_sym_ccc] = ACTIONS(525),
    [anon_sym_fastcc] = ACTIONS(525),
    [anon_sym_coldcc] = ACTIONS(525),
    [anon_sym_webkit_jscc] = ACTIONS(527),
    [anon_sym_anyregcc] = ACTIONS(525),
    [anon_sym_preserve_mostcc] = ACTIONS(525),
    [anon_sym_preserve_allcc] = ACTIONS(525),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(527),
    [anon_sym_tailcc] = ACTIONS(525),
    [anon_sym_swiftcc] = ACTIONS(527),
    [anon_sym_swifttailcc] = ACTIONS(527),
    [anon_sym_cfguard_checkcc] = ACTIONS(525),
    [aux_sym_calling_conv_token1] = ACTIONS(527),
    [aux_sym_calling_conv_token2] = ACTIONS(525),
    [aux_sym_calling_conv_token3] = ACTIONS(525),
    [aux_sym_calling_conv_token4] = ACTIONS(525),
    [aux_sym_calling_conv_token5] = ACTIONS(525),
    [aux_sym_calling_conv_token6] = ACTIONS(525),
    [aux_sym_calling_conv_token7] = ACTIONS(525),
    [aux_sym_calling_conv_token8] = ACTIONS(525),
    [aux_sym_calling_conv_token9] = ACTIONS(525),
    [aux_sym_calling_conv_token10] = ACTIONS(527),
    [anon_sym_ghccc] = ACTIONS(525),
    [aux_sym_calling_conv_token11] = ACTIONS(527),
    [aux_sym_calling_conv_token12] = ACTIONS(525),
    [aux_sym_calling_conv_token13] = ACTIONS(527),
    [aux_sym_calling_conv_token14] = ACTIONS(525),
    [anon_sym_cc] = ACTIONS(527),
    [anon_sym_unnamed_addr] = ACTIONS(525),
    [anon_sym_local_unnamed_addr] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_half] = ACTIONS(525),
    [anon_sym_bfloat] = ACTIONS(525),
    [anon_sym_float] = ACTIONS(525),
    [anon_sym_double] = ACTIONS(525),
    [anon_sym_x86_fp80] = ACTIONS(527),
    [anon_sym_fp128] = ACTIONS(525),
    [anon_sym_ppc_fp128] = ACTIONS(525),
    [anon_sym_label] = ACTIONS(525),
    [anon_sym_metadata] = ACTIONS(525),
    [anon_sym_x86_mmx] = ACTIONS(527),
    [anon_sym_x86_amx] = ACTIONS(527),
    [anon_sym_token] = ACTIONS(525),
    [anon_sym_opaque] = ACTIONS(525),
    [anon_sym_ptr] = ACTIONS(525),
    [aux_sym_type_keyword_token1] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(525),
    [anon_sym_RBRACE] = ACTIONS(525),
    [anon_sym_LT_LBRACE] = ACTIONS(525),
    [anon_sym_LBRACK] = ACTIONS(525),
    [anon_sym_RBRACK] = ACTIONS(525),
    [anon_sym_LT] = ACTIONS(527),
    [anon_sym_GT] = ACTIONS(525),
    [anon_sym_COMMA] = ACTIONS(525),
    [anon_sym_LPAREN] = ACTIONS(525),
    [anon_sym_RPAREN] = ACTIONS(525),
    [anon_sym_align] = ACTIONS(527),
    [anon_sym_alignstack] = ACTIONS(525),
    [anon_sym_allocsize] = ACTIONS(525),
    [anon_sym_alwaysinline] = ACTIONS(525),
    [anon_sym_builtin] = ACTIONS(525),
    [anon_sym_cold] = ACTIONS(527),
    [anon_sym_convergent] = ACTIONS(525),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(525),
    [anon_sym_hot] = ACTIONS(525),
    [anon_sym_inaccessiblememonly] = ACTIONS(525),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(525),
    [anon_sym_inlinehint] = ACTIONS(525),
    [anon_sym_jumptable] = ACTIONS(525),
    [anon_sym_minsize] = ACTIONS(525),
    [anon_sym_naked] = ACTIONS(525),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(525),
    [anon_sym_nobuiltin] = ACTIONS(525),
    [anon_sym_noduplicate] = ACTIONS(525),
    [anon_sym_nofree] = ACTIONS(525),
    [anon_sym_noimplicitfloat] = ACTIONS(525),
    [anon_sym_noinline] = ACTIONS(525),
    [anon_sym_nomerge] = ACTIONS(525),
    [anon_sym_nonlazybind] = ACTIONS(525),
    [anon_sym_noprofile] = ACTIONS(525),
    [anon_sym_noredzone] = ACTIONS(525),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(525),
    [anon_sym_noreturn] = ACTIONS(525),
    [anon_sym_norecurse] = ACTIONS(525),
    [anon_sym_willreturn] = ACTIONS(525),
    [anon_sym_nosync] = ACTIONS(525),
    [anon_sym_nounwind] = ACTIONS(525),
    [anon_sym_nocallback] = ACTIONS(525),
    [anon_sym_nosanitize_coverage] = ACTIONS(525),
    [anon_sym_null_pointer_is_valid] = ACTIONS(525),
    [anon_sym_optforfuzzing] = ACTIONS(525),
    [anon_sym_optnone] = ACTIONS(525),
    [anon_sym_optsize] = ACTIONS(525),
    [anon_sym_readnone] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_writeonly] = ACTIONS(525),
    [anon_sym_argmemonly] = ACTIONS(525),
    [anon_sym_returns_twice] = ACTIONS(525),
    [anon_sym_safestack] = ACTIONS(525),
    [anon_sym_sanitize_address] = ACTIONS(525),
    [anon_sym_sanitize_memory] = ACTIONS(525),
    [anon_sym_sanitize_thread] = ACTIONS(525),
    [anon_sym_sanitize_hwaddress] = ACTIONS(525),
    [anon_sym_sanitize_memtag] = ACTIONS(525),
    [anon_sym_speculative_load_hardening] = ACTIONS(525),
    [anon_sym_speculatable] = ACTIONS(525),
    [anon_sym_ssp] = ACTIONS(527),
    [anon_sym_sspstrong] = ACTIONS(525),
    [anon_sym_sspreq] = ACTIONS(525),
    [anon_sym_strictfp] = ACTIONS(525),
    [anon_sym_nocf_check] = ACTIONS(525),
    [anon_sym_shadowcallstack] = ACTIONS(525),
    [anon_sym_mustprogress] = ACTIONS(525),
    [anon_sym_vscale_range] = ACTIONS(525),
    [anon_sym_preallocated] = ACTIONS(525),
    [anon_sym_zeroext] = ACTIONS(525),
    [anon_sym_signext] = ACTIONS(525),
    [anon_sym_inreg] = ACTIONS(525),
    [anon_sym_byval] = ACTIONS(525),
    [anon_sym_byref] = ACTIONS(525),
    [anon_sym_inalloca] = ACTIONS(525),
    [anon_sym_sret] = ACTIONS(525),
    [anon_sym_elementtype] = ACTIONS(525),
    [anon_sym_noalias] = ACTIONS(525),
    [anon_sym_nocapture] = ACTIONS(525),
    [anon_sym_nest] = ACTIONS(525),
    [anon_sym_returned] = ACTIONS(525),
    [anon_sym_nonnull] = ACTIONS(525),
    [anon_sym_dereferenceable] = ACTIONS(527),
    [anon_sym_dereferenceable_or_null] = ACTIONS(525),
    [anon_sym_swiftself] = ACTIONS(527),
    [anon_sym_swiftasync] = ACTIONS(527),
    [anon_sym_swifterror] = ACTIONS(527),
    [anon_sym_immarg] = ACTIONS(525),
    [anon_sym_noundef] = ACTIONS(525),
    [anon_sym_uwtable] = ACTIONS(525),
    [anon_sym_memory] = ACTIONS(525),
    [anon_sym_to] = ACTIONS(527),
    [anon_sym_unwind] = ACTIONS(525),
    [anon_sym_unordered] = ACTIONS(525),
    [anon_sym_monotonic] = ACTIONS(525),
    [anon_sym_acquire] = ACTIONS(525),
    [anon_sym_release] = ACTIONS(525),
    [anon_sym_acq_rel] = ACTIONS(525),
    [anon_sym_seq_cst] = ACTIONS(525),
    [anon_sym_syncscope] = ACTIONS(525),
    [anon_sym_uselistorder] = ACTIONS(527),
    [anon_sym_uselistorder_bb] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(525),
    [anon_sym_attributes] = ACTIONS(525),
  },
  [89] = {
    [ts_builtin_sym_end] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(529),
    [sym_global_var] = ACTIONS(529),
    [sym_local_var] = ACTIONS(529),
    [aux_sym_metadata_ref_token1] = ACTIONS(529),
    [sym_summary_ref] = ACTIONS(529),
    [sym_string] = ACTIONS(529),
    [anon_sym_target] = ACTIONS(529),
    [anon_sym_source_filename] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_define] = ACTIONS(529),
    [anon_sym_no_cfi] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_internal] = ACTIONS(529),
    [anon_sym_weak] = ACTIONS(531),
    [anon_sym_weak_odr] = ACTIONS(529),
    [anon_sym_linkonce] = ACTIONS(531),
    [anon_sym_linkonce_odr] = ACTIONS(529),
    [anon_sym_available_externally] = ACTIONS(529),
    [anon_sym_appending] = ACTIONS(529),
    [anon_sym_common] = ACTIONS(529),
    [anon_sym_extern_weak] = ACTIONS(529),
    [anon_sym_external] = ACTIONS(529),
    [anon_sym_dso_local] = ACTIONS(531),
    [anon_sym_dso_local_equivalent] = ACTIONS(529),
    [anon_sym_dso_preemptable] = ACTIONS(529),
    [anon_sym_default] = ACTIONS(529),
    [anon_sym_hidden] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_dllimport] = ACTIONS(529),
    [anon_sym_dllexport] = ACTIONS(529),
    [anon_sym_ccc] = ACTIONS(529),
    [anon_sym_fastcc] = ACTIONS(529),
    [anon_sym_coldcc] = ACTIONS(529),
    [anon_sym_webkit_jscc] = ACTIONS(531),
    [anon_sym_anyregcc] = ACTIONS(529),
    [anon_sym_preserve_mostcc] = ACTIONS(529),
    [anon_sym_preserve_allcc] = ACTIONS(529),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(531),
    [anon_sym_tailcc] = ACTIONS(529),
    [anon_sym_swiftcc] = ACTIONS(531),
    [anon_sym_swifttailcc] = ACTIONS(531),
    [anon_sym_cfguard_checkcc] = ACTIONS(529),
    [aux_sym_calling_conv_token1] = ACTIONS(531),
    [aux_sym_calling_conv_token2] = ACTIONS(529),
    [aux_sym_calling_conv_token3] = ACTIONS(529),
    [aux_sym_calling_conv_token4] = ACTIONS(529),
    [aux_sym_calling_conv_token5] = ACTIONS(529),
    [aux_sym_calling_conv_token6] = ACTIONS(529),
    [aux_sym_calling_conv_token7] = ACTIONS(529),
    [aux_sym_calling_conv_token8] = ACTIONS(529),
    [aux_sym_calling_conv_token9] = ACTIONS(529),
    [aux_sym_calling_conv_token10] = ACTIONS(531),
    [anon_sym_ghccc] = ACTIONS(529),
    [aux_sym_calling_conv_token11] = ACTIONS(531),
    [aux_sym_calling_conv_token12] = ACTIONS(529),
    [aux_sym_calling_conv_token13] = ACTIONS(531),
    [aux_sym_calling_conv_token14] = ACTIONS(529),
    [anon_sym_cc] = ACTIONS(531),
    [anon_sym_unnamed_addr] = ACTIONS(529),
    [anon_sym_local_unnamed_addr] = ACTIONS(529),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_half] = ACTIONS(529),
    [anon_sym_bfloat] = ACTIONS(529),
    [anon_sym_float] = ACTIONS(529),
    [anon_sym_double] = ACTIONS(529),
    [anon_sym_x86_fp80] = ACTIONS(531),
    [anon_sym_fp128] = ACTIONS(529),
    [anon_sym_ppc_fp128] = ACTIONS(529),
    [anon_sym_label] = ACTIONS(529),
    [anon_sym_metadata] = ACTIONS(529),
    [anon_sym_x86_mmx] = ACTIONS(531),
    [anon_sym_x86_amx] = ACTIONS(531),
    [anon_sym_token] = ACTIONS(529),
    [anon_sym_opaque] = ACTIONS(529),
    [anon_sym_ptr] = ACTIONS(529),
    [aux_sym_type_keyword_token1] = ACTIONS(529),
    [anon_sym_LBRACE] = ACTIONS(529),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_LT_LBRACE] = ACTIONS(529),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_RBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(529),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_RPAREN] = ACTIONS(529),
    [anon_sym_align] = ACTIONS(531),
    [anon_sym_alignstack] = ACTIONS(529),
    [anon_sym_allocsize] = ACTIONS(529),
    [anon_sym_alwaysinline] = ACTIONS(529),
    [anon_sym_builtin] = ACTIONS(529),
    [anon_sym_cold] = ACTIONS(531),
    [anon_sym_convergent] = ACTIONS(529),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(529),
    [anon_sym_hot] = ACTIONS(529),
    [anon_sym_inaccessiblememonly] = ACTIONS(529),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(529),
    [anon_sym_inlinehint] = ACTIONS(529),
    [anon_sym_jumptable] = ACTIONS(529),
    [anon_sym_minsize] = ACTIONS(529),
    [anon_sym_naked] = ACTIONS(529),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(529),
    [anon_sym_nobuiltin] = ACTIONS(529),
    [anon_sym_noduplicate] = ACTIONS(529),
    [anon_sym_nofree] = ACTIONS(529),
    [anon_sym_noimplicitfloat] = ACTIONS(529),
    [anon_sym_noinline] = ACTIONS(529),
    [anon_sym_nomerge] = ACTIONS(529),
    [anon_sym_nonlazybind] = ACTIONS(529),
    [anon_sym_noprofile] = ACTIONS(529),
    [anon_sym_noredzone] = ACTIONS(529),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(529),
    [anon_sym_noreturn] = ACTIONS(529),
    [anon_sym_norecurse] = ACTIONS(529),
    [anon_sym_willreturn] = ACTIONS(529),
    [anon_sym_nosync] = ACTIONS(529),
    [anon_sym_nounwind] = ACTIONS(529),
    [anon_sym_nocallback] = ACTIONS(529),
    [anon_sym_nosanitize_coverage] = ACTIONS(529),
    [anon_sym_null_pointer_is_valid] = ACTIONS(529),
    [anon_sym_optforfuzzing] = ACTIONS(529),
    [anon_sym_optnone] = ACTIONS(529),
    [anon_sym_optsize] = ACTIONS(529),
    [anon_sym_readnone] = ACTIONS(529),
    [anon_sym_readonly] = ACTIONS(529),
    [anon_sym_writeonly] = ACTIONS(529),
    [anon_sym_argmemonly] = ACTIONS(529),
    [anon_sym_returns_twice] = ACTIONS(529),
    [anon_sym_safestack] = ACTIONS(529),
    [anon_sym_sanitize_address] = ACTIONS(529),
    [anon_sym_sanitize_memory] = ACTIONS(529),
    [anon_sym_sanitize_thread] = ACTIONS(529),
    [anon_sym_sanitize_hwaddress] = ACTIONS(529),
    [anon_sym_sanitize_memtag] = ACTIONS(529),
    [anon_sym_speculative_load_hardening] = ACTIONS(529),
    [anon_sym_speculatable] = ACTIONS(529),
    [anon_sym_ssp] = ACTIONS(531),
    [anon_sym_sspstrong] = ACTIONS(529),
    [anon_sym_sspreq] = ACTIONS(529),
    [anon_sym_strictfp] = ACTIONS(529),
    [anon_sym_nocf_check] = ACTIONS(529),
    [anon_sym_shadowcallstack] = ACTIONS(529),
    [anon_sym_mustprogress] = ACTIONS(529),
    [anon_sym_vscale_range] = ACTIONS(529),
    [anon_sym_preallocated] = ACTIONS(529),
    [anon_sym_zeroext] = ACTIONS(529),
    [anon_sym_signext] = ACTIONS(529),
    [anon_sym_inreg] = ACTIONS(529),
    [anon_sym_byval] = ACTIONS(529),
    [anon_sym_byref] = ACTIONS(529),
    [anon_sym_inalloca] = ACTIONS(529),
    [anon_sym_sret] = ACTIONS(529),
    [anon_sym_elementtype] = ACTIONS(529),
    [anon_sym_noalias] = ACTIONS(529),
    [anon_sym_nocapture] = ACTIONS(529),
    [anon_sym_nest] = ACTIONS(529),
    [anon_sym_returned] = ACTIONS(529),
    [anon_sym_nonnull] = ACTIONS(529),
    [anon_sym_dereferenceable] = ACTIONS(531),
    [anon_sym_dereferenceable_or_null] = ACTIONS(529),
    [anon_sym_swiftself] = ACTIONS(531),
    [anon_sym_swiftasync] = ACTIONS(531),
    [anon_sym_swifterror] = ACTIONS(531),
    [anon_sym_immarg] = ACTIONS(529),
    [anon_sym_noundef] = ACTIONS(529),
    [anon_sym_uwtable] = ACTIONS(529),
    [anon_sym_memory] = ACTIONS(529),
    [anon_sym_to] = ACTIONS(531),
    [anon_sym_unwind] = ACTIONS(529),
    [anon_sym_unordered] = ACTIONS(529),
    [anon_sym_monotonic] = ACTIONS(529),
    [anon_sym_acquire] = ACTIONS(529),
    [anon_sym_release] = ACTIONS(529),
    [anon_sym_acq_rel] = ACTIONS(529),
    [anon_sym_seq_cst] = ACTIONS(529),
    [anon_sym_syncscope] = ACTIONS(529),
    [anon_sym_uselistorder] = ACTIONS(531),
    [anon_sym_uselistorder_bb] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_attributes] = ACTIONS(529),
  },
  [90] = {
    [ts_builtin_sym_end] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(533),
    [sym_global_var] = ACTIONS(533),
    [sym_local_var] = ACTIONS(533),
    [aux_sym_metadata_ref_token1] = ACTIONS(533),
    [sym_summary_ref] = ACTIONS(533),
    [sym_string] = ACTIONS(533),
    [anon_sym_target] = ACTIONS(533),
    [anon_sym_source_filename] = ACTIONS(533),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_define] = ACTIONS(533),
    [anon_sym_no_cfi] = ACTIONS(533),
    [anon_sym_private] = ACTIONS(533),
    [anon_sym_internal] = ACTIONS(533),
    [anon_sym_weak] = ACTIONS(535),
    [anon_sym_weak_odr] = ACTIONS(533),
    [anon_sym_linkonce] = ACTIONS(535),
    [anon_sym_linkonce_odr] = ACTIONS(533),
    [anon_sym_available_externally] = ACTIONS(533),
    [anon_sym_appending] = ACTIONS(533),
    [anon_sym_common] = ACTIONS(533),
    [anon_sym_extern_weak] = ACTIONS(533),
    [anon_sym_external] = ACTIONS(533),
    [anon_sym_dso_local] = ACTIONS(535),
    [anon_sym_dso_local_equivalent] = ACTIONS(533),
    [anon_sym_dso_preemptable] = ACTIONS(533),
    [anon_sym_default] = ACTIONS(533),
    [anon_sym_hidden] = ACTIONS(533),
    [anon_sym_protected] = ACTIONS(533),
    [anon_sym_dllimport] = ACTIONS(533),
    [anon_sym_dllexport] = ACTIONS(533),
    [anon_sym_ccc] = ACTIONS(533),
    [anon_sym_fastcc] = ACTIONS(533),
    [anon_sym_coldcc] = ACTIONS(533),
    [anon_sym_webkit_jscc] = ACTIONS(535),
    [anon_sym_anyregcc] = ACTIONS(533),
    [anon_sym_preserve_mostcc] = ACTIONS(533),
    [anon_sym_preserve_allcc] = ACTIONS(533),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(535),
    [anon_sym_tailcc] = ACTIONS(533),
    [anon_sym_swiftcc] = ACTIONS(535),
    [anon_sym_swifttailcc] = ACTIONS(535),
    [anon_sym_cfguard_checkcc] = ACTIONS(533),
    [aux_sym_calling_conv_token1] = ACTIONS(535),
    [aux_sym_calling_conv_token2] = ACTIONS(533),
    [aux_sym_calling_conv_token3] = ACTIONS(533),
    [aux_sym_calling_conv_token4] = ACTIONS(533),
    [aux_sym_calling_conv_token5] = ACTIONS(533),
    [aux_sym_calling_conv_token6] = ACTIONS(533),
    [aux_sym_calling_conv_token7] = ACTIONS(533),
    [aux_sym_calling_conv_token8] = ACTIONS(533),
    [aux_sym_calling_conv_token9] = ACTIONS(533),
    [aux_sym_calling_conv_token10] = ACTIONS(535),
    [anon_sym_ghccc] = ACTIONS(533),
    [aux_sym_calling_conv_token11] = ACTIONS(535),
    [aux_sym_calling_conv_token12] = ACTIONS(533),
    [aux_sym_calling_conv_token13] = ACTIONS(535),
    [aux_sym_calling_conv_token14] = ACTIONS(533),
    [anon_sym_cc] = ACTIONS(535),
    [anon_sym_unnamed_addr] = ACTIONS(533),
    [anon_sym_local_unnamed_addr] = ACTIONS(533),
    [anon_sym_void] = ACTIONS(533),
    [anon_sym_half] = ACTIONS(533),
    [anon_sym_bfloat] = ACTIONS(533),
    [anon_sym_float] = ACTIONS(533),
    [anon_sym_double] = ACTIONS(533),
    [anon_sym_x86_fp80] = ACTIONS(535),
    [anon_sym_fp128] = ACTIONS(533),
    [anon_sym_ppc_fp128] = ACTIONS(533),
    [anon_sym_label] = ACTIONS(533),
    [anon_sym_metadata] = ACTIONS(533),
    [anon_sym_x86_mmx] = ACTIONS(535),
    [anon_sym_x86_amx] = ACTIONS(535),
    [anon_sym_token] = ACTIONS(533),
    [anon_sym_opaque] = ACTIONS(533),
    [anon_sym_ptr] = ACTIONS(533),
    [aux_sym_type_keyword_token1] = ACTIONS(533),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_RBRACE] = ACTIONS(533),
    [anon_sym_LT_LBRACE] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(533),
    [anon_sym_RBRACK] = ACTIONS(533),
    [anon_sym_LT] = ACTIONS(535),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_COMMA] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(533),
    [anon_sym_RPAREN] = ACTIONS(533),
    [anon_sym_align] = ACTIONS(535),
    [anon_sym_alignstack] = ACTIONS(533),
    [anon_sym_allocsize] = ACTIONS(533),
    [anon_sym_alwaysinline] = ACTIONS(533),
    [anon_sym_builtin] = ACTIONS(533),
    [anon_sym_cold] = ACTIONS(535),
    [anon_sym_convergent] = ACTIONS(533),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(533),
    [anon_sym_hot] = ACTIONS(533),
    [anon_sym_inaccessiblememonly] = ACTIONS(533),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(533),
    [anon_sym_inlinehint] = ACTIONS(533),
    [anon_sym_jumptable] = ACTIONS(533),
    [anon_sym_minsize] = ACTIONS(533),
    [anon_sym_naked] = ACTIONS(533),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(533),
    [anon_sym_nobuiltin] = ACTIONS(533),
    [anon_sym_noduplicate] = ACTIONS(533),
    [anon_sym_nofree] = ACTIONS(533),
    [anon_sym_noimplicitfloat] = ACTIONS(533),
    [anon_sym_noinline] = ACTIONS(533),
    [anon_sym_nomerge] = ACTIONS(533),
    [anon_sym_nonlazybind] = ACTIONS(533),
    [anon_sym_noprofile] = ACTIONS(533),
    [anon_sym_noredzone] = ACTIONS(533),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(533),
    [anon_sym_noreturn] = ACTIONS(533),
    [anon_sym_norecurse] = ACTIONS(533),
    [anon_sym_willreturn] = ACTIONS(533),
    [anon_sym_nosync] = ACTIONS(533),
    [anon_sym_nounwind] = ACTIONS(533),
    [anon_sym_nocallback] = ACTIONS(533),
    [anon_sym_nosanitize_coverage] = ACTIONS(533),
    [anon_sym_null_pointer_is_valid] = ACTIONS(533),
    [anon_sym_optforfuzzing] = ACTIONS(533),
    [anon_sym_optnone] = ACTIONS(533),
    [anon_sym_optsize] = ACTIONS(533),
    [anon_sym_readnone] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(533),
    [anon_sym_writeonly] = ACTIONS(533),
    [anon_sym_argmemonly] = ACTIONS(533),
    [anon_sym_returns_twice] = ACTIONS(533),
    [anon_sym_safestack] = ACTIONS(533),
    [anon_sym_sanitize_address] = ACTIONS(533),
    [anon_sym_sanitize_memory] = ACTIONS(533),
    [anon_sym_sanitize_thread] = ACTIONS(533),
    [anon_sym_sanitize_hwaddress] = ACTIONS(533),
    [anon_sym_sanitize_memtag] = ACTIONS(533),
    [anon_sym_speculative_load_hardening] = ACTIONS(533),
    [anon_sym_speculatable] = ACTIONS(533),
    [anon_sym_ssp] = ACTIONS(535),
    [anon_sym_sspstrong] = ACTIONS(533),
    [anon_sym_sspreq] = ACTIONS(533),
    [anon_sym_strictfp] = ACTIONS(533),
    [anon_sym_nocf_check] = ACTIONS(533),
    [anon_sym_shadowcallstack] = ACTIONS(533),
    [anon_sym_mustprogress] = ACTIONS(533),
    [anon_sym_vscale_range] = ACTIONS(533),
    [anon_sym_preallocated] = ACTIONS(533),
    [anon_sym_zeroext] = ACTIONS(533),
    [anon_sym_signext] = ACTIONS(533),
    [anon_sym_inreg] = ACTIONS(533),
    [anon_sym_byval] = ACTIONS(533),
    [anon_sym_byref] = ACTIONS(533),
    [anon_sym_inalloca] = ACTIONS(533),
    [anon_sym_sret] = ACTIONS(533),
    [anon_sym_elementtype] = ACTIONS(533),
    [anon_sym_noalias] = ACTIONS(533),
    [anon_sym_nocapture] = ACTIONS(533),
    [anon_sym_nest] = ACTIONS(533),
    [anon_sym_returned] = ACTIONS(533),
    [anon_sym_nonnull] = ACTIONS(533),
    [anon_sym_dereferenceable] = ACTIONS(535),
    [anon_sym_dereferenceable_or_null] = ACTIONS(533),
    [anon_sym_swiftself] = ACTIONS(535),
    [anon_sym_swiftasync] = ACTIONS(535),
    [anon_sym_swifterror] = ACTIONS(535),
    [anon_sym_immarg] = ACTIONS(533),
    [anon_sym_noundef] = ACTIONS(533),
    [anon_sym_uwtable] = ACTIONS(533),
    [anon_sym_memory] = ACTIONS(533),
    [anon_sym_to] = ACTIONS(535),
    [anon_sym_unwind] = ACTIONS(533),
    [anon_sym_unordered] = ACTIONS(533),
    [anon_sym_monotonic] = ACTIONS(533),
    [anon_sym_acquire] = ACTIONS(533),
    [anon_sym_release] = ACTIONS(533),
    [anon_sym_acq_rel] = ACTIONS(533),
    [anon_sym_seq_cst] = ACTIONS(533),
    [anon_sym_syncscope] = ACTIONS(533),
    [anon_sym_uselistorder] = ACTIONS(535),
    [anon_sym_uselistorder_bb] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_attributes] = ACTIONS(533),
  },
  [91] = {
    [ts_builtin_sym_end] = ACTIONS(537),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(537),
    [sym_global_var] = ACTIONS(537),
    [sym_local_var] = ACTIONS(537),
    [aux_sym_metadata_ref_token1] = ACTIONS(537),
    [sym_summary_ref] = ACTIONS(537),
    [sym_string] = ACTIONS(537),
    [anon_sym_target] = ACTIONS(537),
    [anon_sym_source_filename] = ACTIONS(537),
    [anon_sym_declare] = ACTIONS(537),
    [anon_sym_define] = ACTIONS(537),
    [anon_sym_no_cfi] = ACTIONS(537),
    [anon_sym_private] = ACTIONS(537),
    [anon_sym_internal] = ACTIONS(537),
    [anon_sym_weak] = ACTIONS(539),
    [anon_sym_weak_odr] = ACTIONS(537),
    [anon_sym_linkonce] = ACTIONS(539),
    [anon_sym_linkonce_odr] = ACTIONS(537),
    [anon_sym_available_externally] = ACTIONS(537),
    [anon_sym_appending] = ACTIONS(537),
    [anon_sym_common] = ACTIONS(537),
    [anon_sym_extern_weak] = ACTIONS(537),
    [anon_sym_external] = ACTIONS(537),
    [anon_sym_dso_local] = ACTIONS(539),
    [anon_sym_dso_local_equivalent] = ACTIONS(537),
    [anon_sym_dso_preemptable] = ACTIONS(537),
    [anon_sym_default] = ACTIONS(537),
    [anon_sym_hidden] = ACTIONS(537),
    [anon_sym_protected] = ACTIONS(537),
    [anon_sym_dllimport] = ACTIONS(537),
    [anon_sym_dllexport] = ACTIONS(537),
    [anon_sym_ccc] = ACTIONS(537),
    [anon_sym_fastcc] = ACTIONS(537),
    [anon_sym_coldcc] = ACTIONS(537),
    [anon_sym_webkit_jscc] = ACTIONS(539),
    [anon_sym_anyregcc] = ACTIONS(537),
    [anon_sym_preserve_mostcc] = ACTIONS(537),
    [anon_sym_preserve_allcc] = ACTIONS(537),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(539),
    [anon_sym_tailcc] = ACTIONS(537),
    [anon_sym_swiftcc] = ACTIONS(539),
    [anon_sym_swifttailcc] = ACTIONS(539),
    [anon_sym_cfguard_checkcc] = ACTIONS(537),
    [aux_sym_calling_conv_token1] = ACTIONS(539),
    [aux_sym_calling_conv_token2] = ACTIONS(537),
    [aux_sym_calling_conv_token3] = ACTIONS(537),
    [aux_sym_calling_conv_token4] = ACTIONS(537),
    [aux_sym_calling_conv_token5] = ACTIONS(537),
    [aux_sym_calling_conv_token6] = ACTIONS(537),
    [aux_sym_calling_conv_token7] = ACTIONS(537),
    [aux_sym_calling_conv_token8] = ACTIONS(537),
    [aux_sym_calling_conv_token9] = ACTIONS(537),
    [aux_sym_calling_conv_token10] = ACTIONS(539),
    [anon_sym_ghccc] = ACTIONS(537),
    [aux_sym_calling_conv_token11] = ACTIONS(539),
    [aux_sym_calling_conv_token12] = ACTIONS(537),
    [aux_sym_calling_conv_token13] = ACTIONS(539),
    [aux_sym_calling_conv_token14] = ACTIONS(537),
    [anon_sym_cc] = ACTIONS(539),
    [anon_sym_unnamed_addr] = ACTIONS(537),
    [anon_sym_local_unnamed_addr] = ACTIONS(537),
    [anon_sym_void] = ACTIONS(537),
    [anon_sym_half] = ACTIONS(537),
    [anon_sym_bfloat] = ACTIONS(537),
    [anon_sym_float] = ACTIONS(537),
    [anon_sym_double] = ACTIONS(537),
    [anon_sym_x86_fp80] = ACTIONS(539),
    [anon_sym_fp128] = ACTIONS(537),
    [anon_sym_ppc_fp128] = ACTIONS(537),
    [anon_sym_label] = ACTIONS(537),
    [anon_sym_metadata] = ACTIONS(537),
    [anon_sym_x86_mmx] = ACTIONS(539),
    [anon_sym_x86_amx] = ACTIONS(539),
    [anon_sym_token] = ACTIONS(537),
    [anon_sym_opaque] = ACTIONS(537),
    [anon_sym_ptr] = ACTIONS(537),
    [aux_sym_type_keyword_token1] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_LT_LBRACE] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(537),
    [anon_sym_RBRACK] = ACTIONS(537),
    [anon_sym_LT] = ACTIONS(539),
    [anon_sym_GT] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(537),
    [anon_sym_LPAREN] = ACTIONS(537),
    [anon_sym_RPAREN] = ACTIONS(537),
    [anon_sym_align] = ACTIONS(539),
    [anon_sym_alignstack] = ACTIONS(537),
    [anon_sym_allocsize] = ACTIONS(537),
    [anon_sym_alwaysinline] = ACTIONS(537),
    [anon_sym_builtin] = ACTIONS(537),
    [anon_sym_cold] = ACTIONS(539),
    [anon_sym_convergent] = ACTIONS(537),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(537),
    [anon_sym_hot] = ACTIONS(537),
    [anon_sym_inaccessiblememonly] = ACTIONS(537),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(537),
    [anon_sym_inlinehint] = ACTIONS(537),
    [anon_sym_jumptable] = ACTIONS(537),
    [anon_sym_minsize] = ACTIONS(537),
    [anon_sym_naked] = ACTIONS(537),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(537),
    [anon_sym_nobuiltin] = ACTIONS(537),
    [anon_sym_noduplicate] = ACTIONS(537),
    [anon_sym_nofree] = ACTIONS(537),
    [anon_sym_noimplicitfloat] = ACTIONS(537),
    [anon_sym_noinline] = ACTIONS(537),
    [anon_sym_nomerge] = ACTIONS(537),
    [anon_sym_nonlazybind] = ACTIONS(537),
    [anon_sym_noprofile] = ACTIONS(537),
    [anon_sym_noredzone] = ACTIONS(537),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(537),
    [anon_sym_noreturn] = ACTIONS(537),
    [anon_sym_norecurse] = ACTIONS(537),
    [anon_sym_willreturn] = ACTIONS(537),
    [anon_sym_nosync] = ACTIONS(537),
    [anon_sym_nounwind] = ACTIONS(537),
    [anon_sym_nocallback] = ACTIONS(537),
    [anon_sym_nosanitize_coverage] = ACTIONS(537),
    [anon_sym_null_pointer_is_valid] = ACTIONS(537),
    [anon_sym_optforfuzzing] = ACTIONS(537),
    [anon_sym_optnone] = ACTIONS(537),
    [anon_sym_optsize] = ACTIONS(537),
    [anon_sym_readnone] = ACTIONS(537),
    [anon_sym_readonly] = ACTIONS(537),
    [anon_sym_writeonly] = ACTIONS(537),
    [anon_sym_argmemonly] = ACTIONS(537),
    [anon_sym_returns_twice] = ACTIONS(537),
    [anon_sym_safestack] = ACTIONS(537),
    [anon_sym_sanitize_address] = ACTIONS(537),
    [anon_sym_sanitize_memory] = ACTIONS(537),
    [anon_sym_sanitize_thread] = ACTIONS(537),
    [anon_sym_sanitize_hwaddress] = ACTIONS(537),
    [anon_sym_sanitize_memtag] = ACTIONS(537),
    [anon_sym_speculative_load_hardening] = ACTIONS(537),
    [anon_sym_speculatable] = ACTIONS(537),
    [anon_sym_ssp] = ACTIONS(539),
    [anon_sym_sspstrong] = ACTIONS(537),
    [anon_sym_sspreq] = ACTIONS(537),
    [anon_sym_strictfp] = ACTIONS(537),
    [anon_sym_nocf_check] = ACTIONS(537),
    [anon_sym_shadowcallstack] = ACTIONS(537),
    [anon_sym_mustprogress] = ACTIONS(537),
    [anon_sym_vscale_range] = ACTIONS(537),
    [anon_sym_preallocated] = ACTIONS(537),
    [anon_sym_zeroext] = ACTIONS(537),
    [anon_sym_signext] = ACTIONS(537),
    [anon_sym_inreg] = ACTIONS(537),
    [anon_sym_byval] = ACTIONS(537),
    [anon_sym_byref] = ACTIONS(537),
    [anon_sym_inalloca] = ACTIONS(537),
    [anon_sym_sret] = ACTIONS(537),
    [anon_sym_elementtype] = ACTIONS(537),
    [anon_sym_noalias] = ACTIONS(537),
    [anon_sym_nocapture] = ACTIONS(537),
    [anon_sym_nest] = ACTIONS(537),
    [anon_sym_returned] = ACTIONS(537),
    [anon_sym_nonnull] = ACTIONS(537),
    [anon_sym_dereferenceable] = ACTIONS(539),
    [anon_sym_dereferenceable_or_null] = ACTIONS(537),
    [anon_sym_swiftself] = ACTIONS(539),
    [anon_sym_swiftasync] = ACTIONS(539),
    [anon_sym_swifterror] = ACTIONS(539),
    [anon_sym_immarg] = ACTIONS(537),
    [anon_sym_noundef] = ACTIONS(537),
    [anon_sym_uwtable] = ACTIONS(537),
    [anon_sym_memory] = ACTIONS(537),
    [anon_sym_to] = ACTIONS(539),
    [anon_sym_unwind] = ACTIONS(537),
    [anon_sym_unordered] = ACTIONS(537),
    [anon_sym_monotonic] = ACTIONS(537),
    [anon_sym_acquire] = ACTIONS(537),
    [anon_sym_release] = ACTIONS(537),
    [anon_sym_acq_rel] = ACTIONS(537),
    [anon_sym_seq_cst] = ACTIONS(537),
    [anon_sym_syncscope] = ACTIONS(537),
    [anon_sym_uselistorder] = ACTIONS(539),
    [anon_sym_uselistorder_bb] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_attributes] = ACTIONS(537),
  },
  [92] = {
    [ts_builtin_sym_end] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(541),
    [sym_global_var] = ACTIONS(541),
    [sym_local_var] = ACTIONS(541),
    [aux_sym_metadata_ref_token1] = ACTIONS(541),
    [sym_summary_ref] = ACTIONS(541),
    [sym_string] = ACTIONS(541),
    [anon_sym_target] = ACTIONS(541),
    [anon_sym_source_filename] = ACTIONS(541),
    [anon_sym_declare] = ACTIONS(541),
    [anon_sym_define] = ACTIONS(541),
    [anon_sym_no_cfi] = ACTIONS(541),
    [anon_sym_private] = ACTIONS(541),
    [anon_sym_internal] = ACTIONS(541),
    [anon_sym_weak] = ACTIONS(543),
    [anon_sym_weak_odr] = ACTIONS(541),
    [anon_sym_linkonce] = ACTIONS(543),
    [anon_sym_linkonce_odr] = ACTIONS(541),
    [anon_sym_available_externally] = ACTIONS(541),
    [anon_sym_appending] = ACTIONS(541),
    [anon_sym_common] = ACTIONS(541),
    [anon_sym_extern_weak] = ACTIONS(541),
    [anon_sym_external] = ACTIONS(541),
    [anon_sym_dso_local] = ACTIONS(543),
    [anon_sym_dso_local_equivalent] = ACTIONS(541),
    [anon_sym_dso_preemptable] = ACTIONS(541),
    [anon_sym_default] = ACTIONS(541),
    [anon_sym_hidden] = ACTIONS(541),
    [anon_sym_protected] = ACTIONS(541),
    [anon_sym_dllimport] = ACTIONS(541),
    [anon_sym_dllexport] = ACTIONS(541),
    [anon_sym_ccc] = ACTIONS(541),
    [anon_sym_fastcc] = ACTIONS(541),
    [anon_sym_coldcc] = ACTIONS(541),
    [anon_sym_webkit_jscc] = ACTIONS(543),
    [anon_sym_anyregcc] = ACTIONS(541),
    [anon_sym_preserve_mostcc] = ACTIONS(541),
    [anon_sym_preserve_allcc] = ACTIONS(541),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(543),
    [anon_sym_tailcc] = ACTIONS(541),
    [anon_sym_swiftcc] = ACTIONS(543),
    [anon_sym_swifttailcc] = ACTIONS(543),
    [anon_sym_cfguard_checkcc] = ACTIONS(541),
    [aux_sym_calling_conv_token1] = ACTIONS(543),
    [aux_sym_calling_conv_token2] = ACTIONS(541),
    [aux_sym_calling_conv_token3] = ACTIONS(541),
    [aux_sym_calling_conv_token4] = ACTIONS(541),
    [aux_sym_calling_conv_token5] = ACTIONS(541),
    [aux_sym_calling_conv_token6] = ACTIONS(541),
    [aux_sym_calling_conv_token7] = ACTIONS(541),
    [aux_sym_calling_conv_token8] = ACTIONS(541),
    [aux_sym_calling_conv_token9] = ACTIONS(541),
    [aux_sym_calling_conv_token10] = ACTIONS(543),
    [anon_sym_ghccc] = ACTIONS(541),
    [aux_sym_calling_conv_token11] = ACTIONS(543),
    [aux_sym_calling_conv_token12] = ACTIONS(541),
    [aux_sym_calling_conv_token13] = ACTIONS(543),
    [aux_sym_calling_conv_token14] = ACTIONS(541),
    [anon_sym_cc] = ACTIONS(543),
    [anon_sym_unnamed_addr] = ACTIONS(541),
    [anon_sym_local_unnamed_addr] = ACTIONS(541),
    [anon_sym_void] = ACTIONS(541),
    [anon_sym_half] = ACTIONS(541),
    [anon_sym_bfloat] = ACTIONS(541),
    [anon_sym_float] = ACTIONS(541),
    [anon_sym_double] = ACTIONS(541),
    [anon_sym_x86_fp80] = ACTIONS(543),
    [anon_sym_fp128] = ACTIONS(541),
    [anon_sym_ppc_fp128] = ACTIONS(541),
    [anon_sym_label] = ACTIONS(541),
    [anon_sym_metadata] = ACTIONS(541),
    [anon_sym_x86_mmx] = ACTIONS(543),
    [anon_sym_x86_amx] = ACTIONS(543),
    [anon_sym_token] = ACTIONS(541),
    [anon_sym_opaque] = ACTIONS(541),
    [anon_sym_ptr] = ACTIONS(541),
    [aux_sym_type_keyword_token1] = ACTIONS(541),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(541),
    [anon_sym_LT_LBRACE] = ACTIONS(541),
    [anon_sym_LBRACK] = ACTIONS(541),
    [anon_sym_RBRACK] = ACTIONS(541),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(541),
    [anon_sym_COMMA] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(541),
    [anon_sym_RPAREN] = ACTIONS(541),
    [anon_sym_align] = ACTIONS(543),
    [anon_sym_alignstack] = ACTIONS(541),
    [anon_sym_allocsize] = ACTIONS(541),
    [anon_sym_alwaysinline] = ACTIONS(541),
    [anon_sym_builtin] = ACTIONS(541),
    [anon_sym_cold] = ACTIONS(543),
    [anon_sym_convergent] = ACTIONS(541),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(541),
    [anon_sym_hot] = ACTIONS(541),
    [anon_sym_inaccessiblememonly] = ACTIONS(541),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(541),
    [anon_sym_inlinehint] = ACTIONS(541),
    [anon_sym_jumptable] = ACTIONS(541),
    [anon_sym_minsize] = ACTIONS(541),
    [anon_sym_naked] = ACTIONS(541),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(541),
    [anon_sym_nobuiltin] = ACTIONS(541),
    [anon_sym_noduplicate] = ACTIONS(541),
    [anon_sym_nofree] = ACTIONS(541),
    [anon_sym_noimplicitfloat] = ACTIONS(541),
    [anon_sym_noinline] = ACTIONS(541),
    [anon_sym_nomerge] = ACTIONS(541),
    [anon_sym_nonlazybind] = ACTIONS(541),
    [anon_sym_noprofile] = ACTIONS(541),
    [anon_sym_noredzone] = ACTIONS(541),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(541),
    [anon_sym_noreturn] = ACTIONS(541),
    [anon_sym_norecurse] = ACTIONS(541),
    [anon_sym_willreturn] = ACTIONS(541),
    [anon_sym_nosync] = ACTIONS(541),
    [anon_sym_nounwind] = ACTIONS(541),
    [anon_sym_nocallback] = ACTIONS(541),
    [anon_sym_nosanitize_coverage] = ACTIONS(541),
    [anon_sym_null_pointer_is_valid] = ACTIONS(541),
    [anon_sym_optforfuzzing] = ACTIONS(541),
    [anon_sym_optnone] = ACTIONS(541),
    [anon_sym_optsize] = ACTIONS(541),
    [anon_sym_readnone] = ACTIONS(541),
    [anon_sym_readonly] = ACTIONS(541),
    [anon_sym_writeonly] = ACTIONS(541),
    [anon_sym_argmemonly] = ACTIONS(541),
    [anon_sym_returns_twice] = ACTIONS(541),
    [anon_sym_safestack] = ACTIONS(541),
    [anon_sym_sanitize_address] = ACTIONS(541),
    [anon_sym_sanitize_memory] = ACTIONS(541),
    [anon_sym_sanitize_thread] = ACTIONS(541),
    [anon_sym_sanitize_hwaddress] = ACTIONS(541),
    [anon_sym_sanitize_memtag] = ACTIONS(541),
    [anon_sym_speculative_load_hardening] = ACTIONS(541),
    [anon_sym_speculatable] = ACTIONS(541),
    [anon_sym_ssp] = ACTIONS(543),
    [anon_sym_sspstrong] = ACTIONS(541),
    [anon_sym_sspreq] = ACTIONS(541),
    [anon_sym_strictfp] = ACTIONS(541),
    [anon_sym_nocf_check] = ACTIONS(541),
    [anon_sym_shadowcallstack] = ACTIONS(541),
    [anon_sym_mustprogress] = ACTIONS(541),
    [anon_sym_vscale_range] = ACTIONS(541),
    [anon_sym_preallocated] = ACTIONS(541),
    [anon_sym_zeroext] = ACTIONS(541),
    [anon_sym_signext] = ACTIONS(541),
    [anon_sym_inreg] = ACTIONS(541),
    [anon_sym_byval] = ACTIONS(541),
    [anon_sym_byref] = ACTIONS(541),
    [anon_sym_inalloca] = ACTIONS(541),
    [anon_sym_sret] = ACTIONS(541),
    [anon_sym_elementtype] = ACTIONS(541),
    [anon_sym_noalias] = ACTIONS(541),
    [anon_sym_nocapture] = ACTIONS(541),
    [anon_sym_nest] = ACTIONS(541),
    [anon_sym_returned] = ACTIONS(541),
    [anon_sym_nonnull] = ACTIONS(541),
    [anon_sym_dereferenceable] = ACTIONS(543),
    [anon_sym_dereferenceable_or_null] = ACTIONS(541),
    [anon_sym_swiftself] = ACTIONS(543),
    [anon_sym_swiftasync] = ACTIONS(543),
    [anon_sym_swifterror] = ACTIONS(543),
    [anon_sym_immarg] = ACTIONS(541),
    [anon_sym_noundef] = ACTIONS(541),
    [anon_sym_uwtable] = ACTIONS(541),
    [anon_sym_memory] = ACTIONS(541),
    [anon_sym_to] = ACTIONS(543),
    [anon_sym_unwind] = ACTIONS(541),
    [anon_sym_unordered] = ACTIONS(541),
    [anon_sym_monotonic] = ACTIONS(541),
    [anon_sym_acquire] = ACTIONS(541),
    [anon_sym_release] = ACTIONS(541),
    [anon_sym_acq_rel] = ACTIONS(541),
    [anon_sym_seq_cst] = ACTIONS(541),
    [anon_sym_syncscope] = ACTIONS(541),
    [anon_sym_uselistorder] = ACTIONS(543),
    [anon_sym_uselistorder_bb] = ACTIONS(541),
    [anon_sym_module] = ACTIONS(541),
    [anon_sym_attributes] = ACTIONS(541),
  },
  [93] = {
    [ts_builtin_sym_end] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(545),
    [sym_global_var] = ACTIONS(545),
    [sym_local_var] = ACTIONS(545),
    [aux_sym_metadata_ref_token1] = ACTIONS(545),
    [sym_summary_ref] = ACTIONS(545),
    [sym_string] = ACTIONS(545),
    [anon_sym_target] = ACTIONS(545),
    [anon_sym_source_filename] = ACTIONS(545),
    [anon_sym_declare] = ACTIONS(545),
    [anon_sym_define] = ACTIONS(545),
    [anon_sym_no_cfi] = ACTIONS(545),
    [anon_sym_private] = ACTIONS(545),
    [anon_sym_internal] = ACTIONS(545),
    [anon_sym_weak] = ACTIONS(547),
    [anon_sym_weak_odr] = ACTIONS(545),
    [anon_sym_linkonce] = ACTIONS(547),
    [anon_sym_linkonce_odr] = ACTIONS(545),
    [anon_sym_available_externally] = ACTIONS(545),
    [anon_sym_appending] = ACTIONS(545),
    [anon_sym_common] = ACTIONS(545),
    [anon_sym_extern_weak] = ACTIONS(545),
    [anon_sym_external] = ACTIONS(545),
    [anon_sym_dso_local] = ACTIONS(547),
    [anon_sym_dso_local_equivalent] = ACTIONS(545),
    [anon_sym_dso_preemptable] = ACTIONS(545),
    [anon_sym_default] = ACTIONS(545),
    [anon_sym_hidden] = ACTIONS(545),
    [anon_sym_protected] = ACTIONS(545),
    [anon_sym_dllimport] = ACTIONS(545),
    [anon_sym_dllexport] = ACTIONS(545),
    [anon_sym_ccc] = ACTIONS(545),
    [anon_sym_fastcc] = ACTIONS(545),
    [anon_sym_coldcc] = ACTIONS(545),
    [anon_sym_webkit_jscc] = ACTIONS(547),
    [anon_sym_anyregcc] = ACTIONS(545),
    [anon_sym_preserve_mostcc] = ACTIONS(545),
    [anon_sym_preserve_allcc] = ACTIONS(545),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(547),
    [anon_sym_tailcc] = ACTIONS(545),
    [anon_sym_swiftcc] = ACTIONS(547),
    [anon_sym_swifttailcc] = ACTIONS(547),
    [anon_sym_cfguard_checkcc] = ACTIONS(545),
    [aux_sym_calling_conv_token1] = ACTIONS(547),
    [aux_sym_calling_conv_token2] = ACTIONS(545),
    [aux_sym_calling_conv_token3] = ACTIONS(545),
    [aux_sym_calling_conv_token4] = ACTIONS(545),
    [aux_sym_calling_conv_token5] = ACTIONS(545),
    [aux_sym_calling_conv_token6] = ACTIONS(545),
    [aux_sym_calling_conv_token7] = ACTIONS(545),
    [aux_sym_calling_conv_token8] = ACTIONS(545),
    [aux_sym_calling_conv_token9] = ACTIONS(545),
    [aux_sym_calling_conv_token10] = ACTIONS(547),
    [anon_sym_ghccc] = ACTIONS(545),
    [aux_sym_calling_conv_token11] = ACTIONS(547),
    [aux_sym_calling_conv_token12] = ACTIONS(545),
    [aux_sym_calling_conv_token13] = ACTIONS(547),
    [aux_sym_calling_conv_token14] = ACTIONS(545),
    [anon_sym_cc] = ACTIONS(547),
    [anon_sym_unnamed_addr] = ACTIONS(545),
    [anon_sym_local_unnamed_addr] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(545),
    [anon_sym_half] = ACTIONS(545),
    [anon_sym_bfloat] = ACTIONS(545),
    [anon_sym_float] = ACTIONS(545),
    [anon_sym_double] = ACTIONS(545),
    [anon_sym_x86_fp80] = ACTIONS(547),
    [anon_sym_fp128] = ACTIONS(545),
    [anon_sym_ppc_fp128] = ACTIONS(545),
    [anon_sym_label] = ACTIONS(545),
    [anon_sym_metadata] = ACTIONS(545),
    [anon_sym_x86_mmx] = ACTIONS(547),
    [anon_sym_x86_amx] = ACTIONS(547),
    [anon_sym_token] = ACTIONS(545),
    [anon_sym_opaque] = ACTIONS(545),
    [anon_sym_ptr] = ACTIONS(545),
    [aux_sym_type_keyword_token1] = ACTIONS(545),
    [anon_sym_LBRACE] = ACTIONS(545),
    [anon_sym_RBRACE] = ACTIONS(545),
    [anon_sym_LT_LBRACE] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(545),
    [anon_sym_RBRACK] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(545),
    [anon_sym_COMMA] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(545),
    [anon_sym_RPAREN] = ACTIONS(545),
    [anon_sym_align] = ACTIONS(547),
    [anon_sym_alignstack] = ACTIONS(545),
    [anon_sym_allocsize] = ACTIONS(545),
    [anon_sym_alwaysinline] = ACTIONS(545),
    [anon_sym_builtin] = ACTIONS(545),
    [anon_sym_cold] = ACTIONS(547),
    [anon_sym_convergent] = ACTIONS(545),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(545),
    [anon_sym_hot] = ACTIONS(545),
    [anon_sym_inaccessiblememonly] = ACTIONS(545),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(545),
    [anon_sym_inlinehint] = ACTIONS(545),
    [anon_sym_jumptable] = ACTIONS(545),
    [anon_sym_minsize] = ACTIONS(545),
    [anon_sym_naked] = ACTIONS(545),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(545),
    [anon_sym_nobuiltin] = ACTIONS(545),
    [anon_sym_noduplicate] = ACTIONS(545),
    [anon_sym_nofree] = ACTIONS(545),
    [anon_sym_noimplicitfloat] = ACTIONS(545),
    [anon_sym_noinline] = ACTIONS(545),
    [anon_sym_nomerge] = ACTIONS(545),
    [anon_sym_nonlazybind] = ACTIONS(545),
    [anon_sym_noprofile] = ACTIONS(545),
    [anon_sym_noredzone] = ACTIONS(545),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(545),
    [anon_sym_noreturn] = ACTIONS(545),
    [anon_sym_norecurse] = ACTIONS(545),
    [anon_sym_willreturn] = ACTIONS(545),
    [anon_sym_nosync] = ACTIONS(545),
    [anon_sym_nounwind] = ACTIONS(545),
    [anon_sym_nocallback] = ACTIONS(545),
    [anon_sym_nosanitize_coverage] = ACTIONS(545),
    [anon_sym_null_pointer_is_valid] = ACTIONS(545),
    [anon_sym_optforfuzzing] = ACTIONS(545),
    [anon_sym_optnone] = ACTIONS(545),
    [anon_sym_optsize] = ACTIONS(545),
    [anon_sym_readnone] = ACTIONS(545),
    [anon_sym_readonly] = ACTIONS(545),
    [anon_sym_writeonly] = ACTIONS(545),
    [anon_sym_argmemonly] = ACTIONS(545),
    [anon_sym_returns_twice] = ACTIONS(545),
    [anon_sym_safestack] = ACTIONS(545),
    [anon_sym_sanitize_address] = ACTIONS(545),
    [anon_sym_sanitize_memory] = ACTIONS(545),
    [anon_sym_sanitize_thread] = ACTIONS(545),
    [anon_sym_sanitize_hwaddress] = ACTIONS(545),
    [anon_sym_sanitize_memtag] = ACTIONS(545),
    [anon_sym_speculative_load_hardening] = ACTIONS(545),
    [anon_sym_speculatable] = ACTIONS(545),
    [anon_sym_ssp] = ACTIONS(547),
    [anon_sym_sspstrong] = ACTIONS(545),
    [anon_sym_sspreq] = ACTIONS(545),
    [anon_sym_strictfp] = ACTIONS(545),
    [anon_sym_nocf_check] = ACTIONS(545),
    [anon_sym_shadowcallstack] = ACTIONS(545),
    [anon_sym_mustprogress] = ACTIONS(545),
    [anon_sym_vscale_range] = ACTIONS(545),
    [anon_sym_preallocated] = ACTIONS(545),
    [anon_sym_zeroext] = ACTIONS(545),
    [anon_sym_signext] = ACTIONS(545),
    [anon_sym_inreg] = ACTIONS(545),
    [anon_sym_byval] = ACTIONS(545),
    [anon_sym_byref] = ACTIONS(545),
    [anon_sym_inalloca] = ACTIONS(545),
    [anon_sym_sret] = ACTIONS(545),
    [anon_sym_elementtype] = ACTIONS(545),
    [anon_sym_noalias] = ACTIONS(545),
    [anon_sym_nocapture] = ACTIONS(545),
    [anon_sym_nest] = ACTIONS(545),
    [anon_sym_returned] = ACTIONS(545),
    [anon_sym_nonnull] = ACTIONS(545),
    [anon_sym_dereferenceable] = ACTIONS(547),
    [anon_sym_dereferenceable_or_null] = ACTIONS(545),
    [anon_sym_swiftself] = ACTIONS(547),
    [anon_sym_swiftasync] = ACTIONS(547),
    [anon_sym_swifterror] = ACTIONS(547),
    [anon_sym_immarg] = ACTIONS(545),
    [anon_sym_noundef] = ACTIONS(545),
    [anon_sym_uwtable] = ACTIONS(545),
    [anon_sym_memory] = ACTIONS(545),
    [anon_sym_to] = ACTIONS(547),
    [anon_sym_unwind] = ACTIONS(545),
    [anon_sym_unordered] = ACTIONS(545),
    [anon_sym_monotonic] = ACTIONS(545),
    [anon_sym_acquire] = ACTIONS(545),
    [anon_sym_release] = ACTIONS(545),
    [anon_sym_acq_rel] = ACTIONS(545),
    [anon_sym_seq_cst] = ACTIONS(545),
    [anon_sym_syncscope] = ACTIONS(545),
    [anon_sym_uselistorder] = ACTIONS(547),
    [anon_sym_uselistorder_bb] = ACTIONS(545),
    [anon_sym_module] = ACTIONS(545),
    [anon_sym_attributes] = ACTIONS(545),
  },
  [94] = {
    [ts_builtin_sym_end] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(549),
    [sym_global_var] = ACTIONS(549),
    [sym_local_var] = ACTIONS(549),
    [aux_sym_metadata_ref_token1] = ACTIONS(549),
    [sym_summary_ref] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [anon_sym_target] = ACTIONS(549),
    [anon_sym_source_filename] = ACTIONS(549),
    [anon_sym_declare] = ACTIONS(549),
    [anon_sym_define] = ACTIONS(549),
    [anon_sym_no_cfi] = ACTIONS(549),
    [anon_sym_private] = ACTIONS(549),
    [anon_sym_internal] = ACTIONS(549),
    [anon_sym_weak] = ACTIONS(551),
    [anon_sym_weak_odr] = ACTIONS(549),
    [anon_sym_linkonce] = ACTIONS(551),
    [anon_sym_linkonce_odr] = ACTIONS(549),
    [anon_sym_available_externally] = ACTIONS(549),
    [anon_sym_appending] = ACTIONS(549),
    [anon_sym_common] = ACTIONS(549),
    [anon_sym_extern_weak] = ACTIONS(549),
    [anon_sym_external] = ACTIONS(549),
    [anon_sym_dso_local] = ACTIONS(551),
    [anon_sym_dso_local_equivalent] = ACTIONS(549),
    [anon_sym_dso_preemptable] = ACTIONS(549),
    [anon_sym_default] = ACTIONS(549),
    [anon_sym_hidden] = ACTIONS(549),
    [anon_sym_protected] = ACTIONS(549),
    [anon_sym_dllimport] = ACTIONS(549),
    [anon_sym_dllexport] = ACTIONS(549),
    [anon_sym_ccc] = ACTIONS(549),
    [anon_sym_fastcc] = ACTIONS(549),
    [anon_sym_coldcc] = ACTIONS(549),
    [anon_sym_webkit_jscc] = ACTIONS(551),
    [anon_sym_anyregcc] = ACTIONS(549),
    [anon_sym_preserve_mostcc] = ACTIONS(549),
    [anon_sym_preserve_allcc] = ACTIONS(549),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(551),
    [anon_sym_tailcc] = ACTIONS(549),
    [anon_sym_swiftcc] = ACTIONS(551),
    [anon_sym_swifttailcc] = ACTIONS(551),
    [anon_sym_cfguard_checkcc] = ACTIONS(549),
    [aux_sym_calling_conv_token1] = ACTIONS(551),
    [aux_sym_calling_conv_token2] = ACTIONS(549),
    [aux_sym_calling_conv_token3] = ACTIONS(549),
    [aux_sym_calling_conv_token4] = ACTIONS(549),
    [aux_sym_calling_conv_token5] = ACTIONS(549),
    [aux_sym_calling_conv_token6] = ACTIONS(549),
    [aux_sym_calling_conv_token7] = ACTIONS(549),
    [aux_sym_calling_conv_token8] = ACTIONS(549),
    [aux_sym_calling_conv_token9] = ACTIONS(549),
    [aux_sym_calling_conv_token10] = ACTIONS(551),
    [anon_sym_ghccc] = ACTIONS(549),
    [aux_sym_calling_conv_token11] = ACTIONS(551),
    [aux_sym_calling_conv_token12] = ACTIONS(549),
    [aux_sym_calling_conv_token13] = ACTIONS(551),
    [aux_sym_calling_conv_token14] = ACTIONS(549),
    [anon_sym_cc] = ACTIONS(551),
    [anon_sym_unnamed_addr] = ACTIONS(549),
    [anon_sym_local_unnamed_addr] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(549),
    [anon_sym_half] = ACTIONS(549),
    [anon_sym_bfloat] = ACTIONS(549),
    [anon_sym_float] = ACTIONS(549),
    [anon_sym_double] = ACTIONS(549),
    [anon_sym_x86_fp80] = ACTIONS(551),
    [anon_sym_fp128] = ACTIONS(549),
    [anon_sym_ppc_fp128] = ACTIONS(549),
    [anon_sym_label] = ACTIONS(549),
    [anon_sym_metadata] = ACTIONS(549),
    [anon_sym_x86_mmx] = ACTIONS(551),
    [anon_sym_x86_amx] = ACTIONS(551),
    [anon_sym_token] = ACTIONS(549),
    [anon_sym_opaque] = ACTIONS(549),
    [anon_sym_ptr] = ACTIONS(549),
    [aux_sym_type_keyword_token1] = ACTIONS(549),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(549),
    [anon_sym_LT_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(549),
    [anon_sym_RBRACK] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_GT] = ACTIONS(549),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(549),
    [anon_sym_RPAREN] = ACTIONS(549),
    [anon_sym_align] = ACTIONS(551),
    [anon_sym_alignstack] = ACTIONS(549),
    [anon_sym_allocsize] = ACTIONS(549),
    [anon_sym_alwaysinline] = ACTIONS(549),
    [anon_sym_builtin] = ACTIONS(549),
    [anon_sym_cold] = ACTIONS(551),
    [anon_sym_convergent] = ACTIONS(549),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(549),
    [anon_sym_hot] = ACTIONS(549),
    [anon_sym_inaccessiblememonly] = ACTIONS(549),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(549),
    [anon_sym_inlinehint] = ACTIONS(549),
    [anon_sym_jumptable] = ACTIONS(549),
    [anon_sym_minsize] = ACTIONS(549),
    [anon_sym_naked] = ACTIONS(549),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(549),
    [anon_sym_nobuiltin] = ACTIONS(549),
    [anon_sym_noduplicate] = ACTIONS(549),
    [anon_sym_nofree] = ACTIONS(549),
    [anon_sym_noimplicitfloat] = ACTIONS(549),
    [anon_sym_noinline] = ACTIONS(549),
    [anon_sym_nomerge] = ACTIONS(549),
    [anon_sym_nonlazybind] = ACTIONS(549),
    [anon_sym_noprofile] = ACTIONS(549),
    [anon_sym_noredzone] = ACTIONS(549),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(549),
    [anon_sym_noreturn] = ACTIONS(549),
    [anon_sym_norecurse] = ACTIONS(549),
    [anon_sym_willreturn] = ACTIONS(549),
    [anon_sym_nosync] = ACTIONS(549),
    [anon_sym_nounwind] = ACTIONS(549),
    [anon_sym_nocallback] = ACTIONS(549),
    [anon_sym_nosanitize_coverage] = ACTIONS(549),
    [anon_sym_null_pointer_is_valid] = ACTIONS(549),
    [anon_sym_optforfuzzing] = ACTIONS(549),
    [anon_sym_optnone] = ACTIONS(549),
    [anon_sym_optsize] = ACTIONS(549),
    [anon_sym_readnone] = ACTIONS(549),
    [anon_sym_readonly] = ACTIONS(549),
    [anon_sym_writeonly] = ACTIONS(549),
    [anon_sym_argmemonly] = ACTIONS(549),
    [anon_sym_returns_twice] = ACTIONS(549),
    [anon_sym_safestack] = ACTIONS(549),
    [anon_sym_sanitize_address] = ACTIONS(549),
    [anon_sym_sanitize_memory] = ACTIONS(549),
    [anon_sym_sanitize_thread] = ACTIONS(549),
    [anon_sym_sanitize_hwaddress] = ACTIONS(549),
    [anon_sym_sanitize_memtag] = ACTIONS(549),
    [anon_sym_speculative_load_hardening] = ACTIONS(549),
    [anon_sym_speculatable] = ACTIONS(549),
    [anon_sym_ssp] = ACTIONS(551),
    [anon_sym_sspstrong] = ACTIONS(549),
    [anon_sym_sspreq] = ACTIONS(549),
    [anon_sym_strictfp] = ACTIONS(549),
    [anon_sym_nocf_check] = ACTIONS(549),
    [anon_sym_shadowcallstack] = ACTIONS(549),
    [anon_sym_mustprogress] = ACTIONS(549),
    [anon_sym_vscale_range] = ACTIONS(549),
    [anon_sym_preallocated] = ACTIONS(549),
    [anon_sym_zeroext] = ACTIONS(549),
    [anon_sym_signext] = ACTIONS(549),
    [anon_sym_inreg] = ACTIONS(549),
    [anon_sym_byval] = ACTIONS(549),
    [anon_sym_byref] = ACTIONS(549),
    [anon_sym_inalloca] = ACTIONS(549),
    [anon_sym_sret] = ACTIONS(549),
    [anon_sym_elementtype] = ACTIONS(549),
    [anon_sym_noalias] = ACTIONS(549),
    [anon_sym_nocapture] = ACTIONS(549),
    [anon_sym_nest] = ACTIONS(549),
    [anon_sym_returned] = ACTIONS(549),
    [anon_sym_nonnull] = ACTIONS(549),
    [anon_sym_dereferenceable] = ACTIONS(551),
    [anon_sym_dereferenceable_or_null] = ACTIONS(549),
    [anon_sym_swiftself] = ACTIONS(551),
    [anon_sym_swiftasync] = ACTIONS(551),
    [anon_sym_swifterror] = ACTIONS(551),
    [anon_sym_immarg] = ACTIONS(549),
    [anon_sym_noundef] = ACTIONS(549),
    [anon_sym_uwtable] = ACTIONS(549),
    [anon_sym_memory] = ACTIONS(549),
    [anon_sym_to] = ACTIONS(551),
    [anon_sym_unwind] = ACTIONS(549),
    [anon_sym_unordered] = ACTIONS(549),
    [anon_sym_monotonic] = ACTIONS(549),
    [anon_sym_acquire] = ACTIONS(549),
    [anon_sym_release] = ACTIONS(549),
    [anon_sym_acq_rel] = ACTIONS(549),
    [anon_sym_seq_cst] = ACTIONS(549),
    [anon_sym_syncscope] = ACTIONS(549),
    [anon_sym_uselistorder] = ACTIONS(551),
    [anon_sym_uselistorder_bb] = ACTIONS(549),
    [anon_sym_module] = ACTIONS(549),
    [anon_sym_attributes] = ACTIONS(549),
  },
  [95] = {
    [ts_builtin_sym_end] = ACTIONS(553),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(553),
    [sym_global_var] = ACTIONS(553),
    [sym_local_var] = ACTIONS(553),
    [aux_sym_metadata_ref_token1] = ACTIONS(553),
    [sym_summary_ref] = ACTIONS(553),
    [sym_string] = ACTIONS(553),
    [anon_sym_target] = ACTIONS(553),
    [anon_sym_source_filename] = ACTIONS(553),
    [anon_sym_declare] = ACTIONS(553),
    [anon_sym_define] = ACTIONS(553),
    [anon_sym_no_cfi] = ACTIONS(553),
    [anon_sym_private] = ACTIONS(553),
    [anon_sym_internal] = ACTIONS(553),
    [anon_sym_weak] = ACTIONS(555),
    [anon_sym_weak_odr] = ACTIONS(553),
    [anon_sym_linkonce] = ACTIONS(555),
    [anon_sym_linkonce_odr] = ACTIONS(553),
    [anon_sym_available_externally] = ACTIONS(553),
    [anon_sym_appending] = ACTIONS(553),
    [anon_sym_common] = ACTIONS(553),
    [anon_sym_extern_weak] = ACTIONS(553),
    [anon_sym_external] = ACTIONS(553),
    [anon_sym_dso_local] = ACTIONS(555),
    [anon_sym_dso_local_equivalent] = ACTIONS(553),
    [anon_sym_dso_preemptable] = ACTIONS(553),
    [anon_sym_default] = ACTIONS(553),
    [anon_sym_hidden] = ACTIONS(553),
    [anon_sym_protected] = ACTIONS(553),
    [anon_sym_dllimport] = ACTIONS(553),
    [anon_sym_dllexport] = ACTIONS(553),
    [anon_sym_ccc] = ACTIONS(553),
    [anon_sym_fastcc] = ACTIONS(553),
    [anon_sym_coldcc] = ACTIONS(553),
    [anon_sym_webkit_jscc] = ACTIONS(555),
    [anon_sym_anyregcc] = ACTIONS(553),
    [anon_sym_preserve_mostcc] = ACTIONS(553),
    [anon_sym_preserve_allcc] = ACTIONS(553),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(555),
    [anon_sym_tailcc] = ACTIONS(553),
    [anon_sym_swiftcc] = ACTIONS(555),
    [anon_sym_swifttailcc] = ACTIONS(555),
    [anon_sym_cfguard_checkcc] = ACTIONS(553),
    [aux_sym_calling_conv_token1] = ACTIONS(555),
    [aux_sym_calling_conv_token2] = ACTIONS(553),
    [aux_sym_calling_conv_token3] = ACTIONS(553),
    [aux_sym_calling_conv_token4] = ACTIONS(553),
    [aux_sym_calling_conv_token5] = ACTIONS(553),
    [aux_sym_calling_conv_token6] = ACTIONS(553),
    [aux_sym_calling_conv_token7] = ACTIONS(553),
    [aux_sym_calling_conv_token8] = ACTIONS(553),
    [aux_sym_calling_conv_token9] = ACTIONS(553),
    [aux_sym_calling_conv_token10] = ACTIONS(555),
    [anon_sym_ghccc] = ACTIONS(553),
    [aux_sym_calling_conv_token11] = ACTIONS(555),
    [aux_sym_calling_conv_token12] = ACTIONS(553),
    [aux_sym_calling_conv_token13] = ACTIONS(555),
    [aux_sym_calling_conv_token14] = ACTIONS(553),
    [anon_sym_cc] = ACTIONS(555),
    [anon_sym_unnamed_addr] = ACTIONS(553),
    [anon_sym_local_unnamed_addr] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(553),
    [anon_sym_half] = ACTIONS(553),
    [anon_sym_bfloat] = ACTIONS(553),
    [anon_sym_float] = ACTIONS(553),
    [anon_sym_double] = ACTIONS(553),
    [anon_sym_x86_fp80] = ACTIONS(555),
    [anon_sym_fp128] = ACTIONS(553),
    [anon_sym_ppc_fp128] = ACTIONS(553),
    [anon_sym_label] = ACTIONS(553),
    [anon_sym_metadata] = ACTIONS(553),
    [anon_sym_x86_mmx] = ACTIONS(555),
    [anon_sym_x86_amx] = ACTIONS(555),
    [anon_sym_token] = ACTIONS(553),
    [anon_sym_opaque] = ACTIONS(553),
    [anon_sym_ptr] = ACTIONS(553),
    [aux_sym_type_keyword_token1] = ACTIONS(553),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_RBRACE] = ACTIONS(553),
    [anon_sym_LT_LBRACE] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_GT] = ACTIONS(553),
    [anon_sym_COMMA] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_RPAREN] = ACTIONS(553),
    [anon_sym_align] = ACTIONS(555),
    [anon_sym_alignstack] = ACTIONS(553),
    [anon_sym_allocsize] = ACTIONS(553),
    [anon_sym_alwaysinline] = ACTIONS(553),
    [anon_sym_builtin] = ACTIONS(553),
    [anon_sym_cold] = ACTIONS(555),
    [anon_sym_convergent] = ACTIONS(553),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(553),
    [anon_sym_hot] = ACTIONS(553),
    [anon_sym_inaccessiblememonly] = ACTIONS(553),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(553),
    [anon_sym_inlinehint] = ACTIONS(553),
    [anon_sym_jumptable] = ACTIONS(553),
    [anon_sym_minsize] = ACTIONS(553),
    [anon_sym_naked] = ACTIONS(553),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(553),
    [anon_sym_nobuiltin] = ACTIONS(553),
    [anon_sym_noduplicate] = ACTIONS(553),
    [anon_sym_nofree] = ACTIONS(553),
    [anon_sym_noimplicitfloat] = ACTIONS(553),
    [anon_sym_noinline] = ACTIONS(553),
    [anon_sym_nomerge] = ACTIONS(553),
    [anon_sym_nonlazybind] = ACTIONS(553),
    [anon_sym_noprofile] = ACTIONS(553),
    [anon_sym_noredzone] = ACTIONS(553),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(553),
    [anon_sym_noreturn] = ACTIONS(553),
    [anon_sym_norecurse] = ACTIONS(553),
    [anon_sym_willreturn] = ACTIONS(553),
    [anon_sym_nosync] = ACTIONS(553),
    [anon_sym_nounwind] = ACTIONS(553),
    [anon_sym_nocallback] = ACTIONS(553),
    [anon_sym_nosanitize_coverage] = ACTIONS(553),
    [anon_sym_null_pointer_is_valid] = ACTIONS(553),
    [anon_sym_optforfuzzing] = ACTIONS(553),
    [anon_sym_optnone] = ACTIONS(553),
    [anon_sym_optsize] = ACTIONS(553),
    [anon_sym_readnone] = ACTIONS(553),
    [anon_sym_readonly] = ACTIONS(553),
    [anon_sym_writeonly] = ACTIONS(553),
    [anon_sym_argmemonly] = ACTIONS(553),
    [anon_sym_returns_twice] = ACTIONS(553),
    [anon_sym_safestack] = ACTIONS(553),
    [anon_sym_sanitize_address] = ACTIONS(553),
    [anon_sym_sanitize_memory] = ACTIONS(553),
    [anon_sym_sanitize_thread] = ACTIONS(553),
    [anon_sym_sanitize_hwaddress] = ACTIONS(553),
    [anon_sym_sanitize_memtag] = ACTIONS(553),
    [anon_sym_speculative_load_hardening] = ACTIONS(553),
    [anon_sym_speculatable] = ACTIONS(553),
    [anon_sym_ssp] = ACTIONS(555),
    [anon_sym_sspstrong] = ACTIONS(553),
    [anon_sym_sspreq] = ACTIONS(553),
    [anon_sym_strictfp] = ACTIONS(553),
    [anon_sym_nocf_check] = ACTIONS(553),
    [anon_sym_shadowcallstack] = ACTIONS(553),
    [anon_sym_mustprogress] = ACTIONS(553),
    [anon_sym_vscale_range] = ACTIONS(553),
    [anon_sym_preallocated] = ACTIONS(553),
    [anon_sym_zeroext] = ACTIONS(553),
    [anon_sym_signext] = ACTIONS(553),
    [anon_sym_inreg] = ACTIONS(553),
    [anon_sym_byval] = ACTIONS(553),
    [anon_sym_byref] = ACTIONS(553),
    [anon_sym_inalloca] = ACTIONS(553),
    [anon_sym_sret] = ACTIONS(553),
    [anon_sym_elementtype] = ACTIONS(553),
    [anon_sym_noalias] = ACTIONS(553),
    [anon_sym_nocapture] = ACTIONS(553),
    [anon_sym_nest] = ACTIONS(553),
    [anon_sym_returned] = ACTIONS(553),
    [anon_sym_nonnull] = ACTIONS(553),
    [anon_sym_dereferenceable] = ACTIONS(555),
    [anon_sym_dereferenceable_or_null] = ACTIONS(553),
    [anon_sym_swiftself] = ACTIONS(555),
    [anon_sym_swiftasync] = ACTIONS(555),
    [anon_sym_swifterror] = ACTIONS(555),
    [anon_sym_immarg] = ACTIONS(553),
    [anon_sym_noundef] = ACTIONS(553),
    [anon_sym_uwtable] = ACTIONS(553),
    [anon_sym_memory] = ACTIONS(553),
    [anon_sym_to] = ACTIONS(555),
    [anon_sym_unwind] = ACTIONS(553),
    [anon_sym_unordered] = ACTIONS(553),
    [anon_sym_monotonic] = ACTIONS(553),
    [anon_sym_acquire] = ACTIONS(553),
    [anon_sym_release] = ACTIONS(553),
    [anon_sym_acq_rel] = ACTIONS(553),
    [anon_sym_seq_cst] = ACTIONS(553),
    [anon_sym_syncscope] = ACTIONS(553),
    [anon_sym_uselistorder] = ACTIONS(555),
    [anon_sym_uselistorder_bb] = ACTIONS(553),
    [anon_sym_module] = ACTIONS(553),
    [anon_sym_attributes] = ACTIONS(553),
  },
  [96] = {
    [ts_builtin_sym_end] = ACTIONS(557),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(557),
    [sym_global_var] = ACTIONS(557),
    [sym_local_var] = ACTIONS(557),
    [aux_sym_metadata_ref_token1] = ACTIONS(557),
    [sym_summary_ref] = ACTIONS(557),
    [sym_string] = ACTIONS(557),
    [anon_sym_target] = ACTIONS(557),
    [anon_sym_source_filename] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_define] = ACTIONS(557),
    [anon_sym_no_cfi] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_internal] = ACTIONS(557),
    [anon_sym_weak] = ACTIONS(559),
    [anon_sym_weak_odr] = ACTIONS(557),
    [anon_sym_linkonce] = ACTIONS(559),
    [anon_sym_linkonce_odr] = ACTIONS(557),
    [anon_sym_available_externally] = ACTIONS(557),
    [anon_sym_appending] = ACTIONS(557),
    [anon_sym_common] = ACTIONS(557),
    [anon_sym_extern_weak] = ACTIONS(557),
    [anon_sym_external] = ACTIONS(557),
    [anon_sym_dso_local] = ACTIONS(559),
    [anon_sym_dso_local_equivalent] = ACTIONS(557),
    [anon_sym_dso_preemptable] = ACTIONS(557),
    [anon_sym_default] = ACTIONS(557),
    [anon_sym_hidden] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_dllimport] = ACTIONS(557),
    [anon_sym_dllexport] = ACTIONS(557),
    [anon_sym_ccc] = ACTIONS(557),
    [anon_sym_fastcc] = ACTIONS(557),
    [anon_sym_coldcc] = ACTIONS(557),
    [anon_sym_webkit_jscc] = ACTIONS(559),
    [anon_sym_anyregcc] = ACTIONS(557),
    [anon_sym_preserve_mostcc] = ACTIONS(557),
    [anon_sym_preserve_allcc] = ACTIONS(557),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(559),
    [anon_sym_tailcc] = ACTIONS(557),
    [anon_sym_swiftcc] = ACTIONS(559),
    [anon_sym_swifttailcc] = ACTIONS(559),
    [anon_sym_cfguard_checkcc] = ACTIONS(557),
    [aux_sym_calling_conv_token1] = ACTIONS(559),
    [aux_sym_calling_conv_token2] = ACTIONS(557),
    [aux_sym_calling_conv_token3] = ACTIONS(557),
    [aux_sym_calling_conv_token4] = ACTIONS(557),
    [aux_sym_calling_conv_token5] = ACTIONS(557),
    [aux_sym_calling_conv_token6] = ACTIONS(557),
    [aux_sym_calling_conv_token7] = ACTIONS(557),
    [aux_sym_calling_conv_token8] = ACTIONS(557),
    [aux_sym_calling_conv_token9] = ACTIONS(557),
    [aux_sym_calling_conv_token10] = ACTIONS(559),
    [anon_sym_ghccc] = ACTIONS(557),
    [aux_sym_calling_conv_token11] = ACTIONS(559),
    [aux_sym_calling_conv_token12] = ACTIONS(557),
    [aux_sym_calling_conv_token13] = ACTIONS(559),
    [aux_sym_calling_conv_token14] = ACTIONS(557),
    [anon_sym_cc] = ACTIONS(559),
    [anon_sym_unnamed_addr] = ACTIONS(557),
    [anon_sym_local_unnamed_addr] = ACTIONS(557),
    [anon_sym_void] = ACTIONS(557),
    [anon_sym_half] = ACTIONS(557),
    [anon_sym_bfloat] = ACTIONS(557),
    [anon_sym_float] = ACTIONS(557),
    [anon_sym_double] = ACTIONS(557),
    [anon_sym_x86_fp80] = ACTIONS(559),
    [anon_sym_fp128] = ACTIONS(557),
    [anon_sym_ppc_fp128] = ACTIONS(557),
    [anon_sym_label] = ACTIONS(557),
    [anon_sym_metadata] = ACTIONS(557),
    [anon_sym_x86_mmx] = ACTIONS(559),
    [anon_sym_x86_amx] = ACTIONS(559),
    [anon_sym_token] = ACTIONS(557),
    [anon_sym_opaque] = ACTIONS(557),
    [anon_sym_ptr] = ACTIONS(557),
    [aux_sym_type_keyword_token1] = ACTIONS(557),
    [anon_sym_LBRACE] = ACTIONS(557),
    [anon_sym_RBRACE] = ACTIONS(557),
    [anon_sym_LT_LBRACE] = ACTIONS(557),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_RBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_GT] = ACTIONS(557),
    [anon_sym_COMMA] = ACTIONS(557),
    [anon_sym_LPAREN] = ACTIONS(557),
    [anon_sym_RPAREN] = ACTIONS(557),
    [anon_sym_align] = ACTIONS(559),
    [anon_sym_alignstack] = ACTIONS(557),
    [anon_sym_allocsize] = ACTIONS(557),
    [anon_sym_alwaysinline] = ACTIONS(557),
    [anon_sym_builtin] = ACTIONS(557),
    [anon_sym_cold] = ACTIONS(559),
    [anon_sym_convergent] = ACTIONS(557),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(557),
    [anon_sym_hot] = ACTIONS(557),
    [anon_sym_inaccessiblememonly] = ACTIONS(557),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(557),
    [anon_sym_inlinehint] = ACTIONS(557),
    [anon_sym_jumptable] = ACTIONS(557),
    [anon_sym_minsize] = ACTIONS(557),
    [anon_sym_naked] = ACTIONS(557),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(557),
    [anon_sym_nobuiltin] = ACTIONS(557),
    [anon_sym_noduplicate] = ACTIONS(557),
    [anon_sym_nofree] = ACTIONS(557),
    [anon_sym_noimplicitfloat] = ACTIONS(557),
    [anon_sym_noinline] = ACTIONS(557),
    [anon_sym_nomerge] = ACTIONS(557),
    [anon_sym_nonlazybind] = ACTIONS(557),
    [anon_sym_noprofile] = ACTIONS(557),
    [anon_sym_noredzone] = ACTIONS(557),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(557),
    [anon_sym_noreturn] = ACTIONS(557),
    [anon_sym_norecurse] = ACTIONS(557),
    [anon_sym_willreturn] = ACTIONS(557),
    [anon_sym_nosync] = ACTIONS(557),
    [anon_sym_nounwind] = ACTIONS(557),
    [anon_sym_nocallback] = ACTIONS(557),
    [anon_sym_nosanitize_coverage] = ACTIONS(557),
    [anon_sym_null_pointer_is_valid] = ACTIONS(557),
    [anon_sym_optforfuzzing] = ACTIONS(557),
    [anon_sym_optnone] = ACTIONS(557),
    [anon_sym_optsize] = ACTIONS(557),
    [anon_sym_readnone] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(557),
    [anon_sym_writeonly] = ACTIONS(557),
    [anon_sym_argmemonly] = ACTIONS(557),
    [anon_sym_returns_twice] = ACTIONS(557),
    [anon_sym_safestack] = ACTIONS(557),
    [anon_sym_sanitize_address] = ACTIONS(557),
    [anon_sym_sanitize_memory] = ACTIONS(557),
    [anon_sym_sanitize_thread] = ACTIONS(557),
    [anon_sym_sanitize_hwaddress] = ACTIONS(557),
    [anon_sym_sanitize_memtag] = ACTIONS(557),
    [anon_sym_speculative_load_hardening] = ACTIONS(557),
    [anon_sym_speculatable] = ACTIONS(557),
    [anon_sym_ssp] = ACTIONS(559),
    [anon_sym_sspstrong] = ACTIONS(557),
    [anon_sym_sspreq] = ACTIONS(557),
    [anon_sym_strictfp] = ACTIONS(557),
    [anon_sym_nocf_check] = ACTIONS(557),
    [anon_sym_shadowcallstack] = ACTIONS(557),
    [anon_sym_mustprogress] = ACTIONS(557),
    [anon_sym_vscale_range] = ACTIONS(557),
    [anon_sym_preallocated] = ACTIONS(557),
    [anon_sym_zeroext] = ACTIONS(557),
    [anon_sym_signext] = ACTIONS(557),
    [anon_sym_inreg] = ACTIONS(557),
    [anon_sym_byval] = ACTIONS(557),
    [anon_sym_byref] = ACTIONS(557),
    [anon_sym_inalloca] = ACTIONS(557),
    [anon_sym_sret] = ACTIONS(557),
    [anon_sym_elementtype] = ACTIONS(557),
    [anon_sym_noalias] = ACTIONS(557),
    [anon_sym_nocapture] = ACTIONS(557),
    [anon_sym_nest] = ACTIONS(557),
    [anon_sym_returned] = ACTIONS(557),
    [anon_sym_nonnull] = ACTIONS(557),
    [anon_sym_dereferenceable] = ACTIONS(559),
    [anon_sym_dereferenceable_or_null] = ACTIONS(557),
    [anon_sym_swiftself] = ACTIONS(559),
    [anon_sym_swiftasync] = ACTIONS(559),
    [anon_sym_swifterror] = ACTIONS(559),
    [anon_sym_immarg] = ACTIONS(557),
    [anon_sym_noundef] = ACTIONS(557),
    [anon_sym_uwtable] = ACTIONS(557),
    [anon_sym_memory] = ACTIONS(557),
    [anon_sym_to] = ACTIONS(559),
    [anon_sym_unwind] = ACTIONS(557),
    [anon_sym_unordered] = ACTIONS(557),
    [anon_sym_monotonic] = ACTIONS(557),
    [anon_sym_acquire] = ACTIONS(557),
    [anon_sym_release] = ACTIONS(557),
    [anon_sym_acq_rel] = ACTIONS(557),
    [anon_sym_seq_cst] = ACTIONS(557),
    [anon_sym_syncscope] = ACTIONS(557),
    [anon_sym_uselistorder] = ACTIONS(559),
    [anon_sym_uselistorder_bb] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_attributes] = ACTIONS(557),
  },
  [97] = {
    [ts_builtin_sym_end] = ACTIONS(561),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(561),
    [sym_global_var] = ACTIONS(561),
    [sym_local_var] = ACTIONS(561),
    [aux_sym_metadata_ref_token1] = ACTIONS(561),
    [sym_summary_ref] = ACTIONS(561),
    [sym_string] = ACTIONS(561),
    [anon_sym_target] = ACTIONS(561),
    [anon_sym_source_filename] = ACTIONS(561),
    [anon_sym_declare] = ACTIONS(561),
    [anon_sym_define] = ACTIONS(561),
    [anon_sym_no_cfi] = ACTIONS(561),
    [anon_sym_private] = ACTIONS(561),
    [anon_sym_internal] = ACTIONS(561),
    [anon_sym_weak] = ACTIONS(563),
    [anon_sym_weak_odr] = ACTIONS(561),
    [anon_sym_linkonce] = ACTIONS(563),
    [anon_sym_linkonce_odr] = ACTIONS(561),
    [anon_sym_available_externally] = ACTIONS(561),
    [anon_sym_appending] = ACTIONS(561),
    [anon_sym_common] = ACTIONS(561),
    [anon_sym_extern_weak] = ACTIONS(561),
    [anon_sym_external] = ACTIONS(561),
    [anon_sym_dso_local] = ACTIONS(563),
    [anon_sym_dso_local_equivalent] = ACTIONS(561),
    [anon_sym_dso_preemptable] = ACTIONS(561),
    [anon_sym_default] = ACTIONS(561),
    [anon_sym_hidden] = ACTIONS(561),
    [anon_sym_protected] = ACTIONS(561),
    [anon_sym_dllimport] = ACTIONS(561),
    [anon_sym_dllexport] = ACTIONS(561),
    [anon_sym_ccc] = ACTIONS(561),
    [anon_sym_fastcc] = ACTIONS(561),
    [anon_sym_coldcc] = ACTIONS(561),
    [anon_sym_webkit_jscc] = ACTIONS(563),
    [anon_sym_anyregcc] = ACTIONS(561),
    [anon_sym_preserve_mostcc] = ACTIONS(561),
    [anon_sym_preserve_allcc] = ACTIONS(561),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(563),
    [anon_sym_tailcc] = ACTIONS(561),
    [anon_sym_swiftcc] = ACTIONS(563),
    [anon_sym_swifttailcc] = ACTIONS(563),
    [anon_sym_cfguard_checkcc] = ACTIONS(561),
    [aux_sym_calling_conv_token1] = ACTIONS(563),
    [aux_sym_calling_conv_token2] = ACTIONS(561),
    [aux_sym_calling_conv_token3] = ACTIONS(561),
    [aux_sym_calling_conv_token4] = ACTIONS(561),
    [aux_sym_calling_conv_token5] = ACTIONS(561),
    [aux_sym_calling_conv_token6] = ACTIONS(561),
    [aux_sym_calling_conv_token7] = ACTIONS(561),
    [aux_sym_calling_conv_token8] = ACTIONS(561),
    [aux_sym_calling_conv_token9] = ACTIONS(561),
    [aux_sym_calling_conv_token10] = ACTIONS(563),
    [anon_sym_ghccc] = ACTIONS(561),
    [aux_sym_calling_conv_token11] = ACTIONS(563),
    [aux_sym_calling_conv_token12] = ACTIONS(561),
    [aux_sym_calling_conv_token13] = ACTIONS(563),
    [aux_sym_calling_conv_token14] = ACTIONS(561),
    [anon_sym_cc] = ACTIONS(563),
    [anon_sym_unnamed_addr] = ACTIONS(561),
    [anon_sym_local_unnamed_addr] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_half] = ACTIONS(561),
    [anon_sym_bfloat] = ACTIONS(561),
    [anon_sym_float] = ACTIONS(561),
    [anon_sym_double] = ACTIONS(561),
    [anon_sym_x86_fp80] = ACTIONS(563),
    [anon_sym_fp128] = ACTIONS(561),
    [anon_sym_ppc_fp128] = ACTIONS(561),
    [anon_sym_label] = ACTIONS(561),
    [anon_sym_metadata] = ACTIONS(561),
    [anon_sym_x86_mmx] = ACTIONS(563),
    [anon_sym_x86_amx] = ACTIONS(563),
    [anon_sym_token] = ACTIONS(561),
    [anon_sym_opaque] = ACTIONS(561),
    [anon_sym_ptr] = ACTIONS(561),
    [aux_sym_type_keyword_token1] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(561),
    [anon_sym_RBRACE] = ACTIONS(561),
    [anon_sym_LT_LBRACE] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(561),
    [anon_sym_RBRACK] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(563),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(561),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_RPAREN] = ACTIONS(561),
    [anon_sym_align] = ACTIONS(563),
    [anon_sym_alignstack] = ACTIONS(561),
    [anon_sym_allocsize] = ACTIONS(561),
    [anon_sym_alwaysinline] = ACTIONS(561),
    [anon_sym_builtin] = ACTIONS(561),
    [anon_sym_cold] = ACTIONS(563),
    [anon_sym_convergent] = ACTIONS(561),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(561),
    [anon_sym_hot] = ACTIONS(561),
    [anon_sym_inaccessiblememonly] = ACTIONS(561),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(561),
    [anon_sym_inlinehint] = ACTIONS(561),
    [anon_sym_jumptable] = ACTIONS(561),
    [anon_sym_minsize] = ACTIONS(561),
    [anon_sym_naked] = ACTIONS(561),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(561),
    [anon_sym_nobuiltin] = ACTIONS(561),
    [anon_sym_noduplicate] = ACTIONS(561),
    [anon_sym_nofree] = ACTIONS(561),
    [anon_sym_noimplicitfloat] = ACTIONS(561),
    [anon_sym_noinline] = ACTIONS(561),
    [anon_sym_nomerge] = ACTIONS(561),
    [anon_sym_nonlazybind] = ACTIONS(561),
    [anon_sym_noprofile] = ACTIONS(561),
    [anon_sym_noredzone] = ACTIONS(561),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(561),
    [anon_sym_noreturn] = ACTIONS(561),
    [anon_sym_norecurse] = ACTIONS(561),
    [anon_sym_willreturn] = ACTIONS(561),
    [anon_sym_nosync] = ACTIONS(561),
    [anon_sym_nounwind] = ACTIONS(561),
    [anon_sym_nocallback] = ACTIONS(561),
    [anon_sym_nosanitize_coverage] = ACTIONS(561),
    [anon_sym_null_pointer_is_valid] = ACTIONS(561),
    [anon_sym_optforfuzzing] = ACTIONS(561),
    [anon_sym_optnone] = ACTIONS(561),
    [anon_sym_optsize] = ACTIONS(561),
    [anon_sym_readnone] = ACTIONS(561),
    [anon_sym_readonly] = ACTIONS(561),
    [anon_sym_writeonly] = ACTIONS(561),
    [anon_sym_argmemonly] = ACTIONS(561),
    [anon_sym_returns_twice] = ACTIONS(561),
    [anon_sym_safestack] = ACTIONS(561),
    [anon_sym_sanitize_address] = ACTIONS(561),
    [anon_sym_sanitize_memory] = ACTIONS(561),
    [anon_sym_sanitize_thread] = ACTIONS(561),
    [anon_sym_sanitize_hwaddress] = ACTIONS(561),
    [anon_sym_sanitize_memtag] = ACTIONS(561),
    [anon_sym_speculative_load_hardening] = ACTIONS(561),
    [anon_sym_speculatable] = ACTIONS(561),
    [anon_sym_ssp] = ACTIONS(563),
    [anon_sym_sspstrong] = ACTIONS(561),
    [anon_sym_sspreq] = ACTIONS(561),
    [anon_sym_strictfp] = ACTIONS(561),
    [anon_sym_nocf_check] = ACTIONS(561),
    [anon_sym_shadowcallstack] = ACTIONS(561),
    [anon_sym_mustprogress] = ACTIONS(561),
    [anon_sym_vscale_range] = ACTIONS(561),
    [anon_sym_preallocated] = ACTIONS(561),
    [anon_sym_zeroext] = ACTIONS(561),
    [anon_sym_signext] = ACTIONS(561),
    [anon_sym_inreg] = ACTIONS(561),
    [anon_sym_byval] = ACTIONS(561),
    [anon_sym_byref] = ACTIONS(561),
    [anon_sym_inalloca] = ACTIONS(561),
    [anon_sym_sret] = ACTIONS(561),
    [anon_sym_elementtype] = ACTIONS(561),
    [anon_sym_noalias] = ACTIONS(561),
    [anon_sym_nocapture] = ACTIONS(561),
    [anon_sym_nest] = ACTIONS(561),
    [anon_sym_returned] = ACTIONS(561),
    [anon_sym_nonnull] = ACTIONS(561),
    [anon_sym_dereferenceable] = ACTIONS(563),
    [anon_sym_dereferenceable_or_null] = ACTIONS(561),
    [anon_sym_swiftself] = ACTIONS(563),
    [anon_sym_swiftasync] = ACTIONS(563),
    [anon_sym_swifterror] = ACTIONS(563),
    [anon_sym_immarg] = ACTIONS(561),
    [anon_sym_noundef] = ACTIONS(561),
    [anon_sym_uwtable] = ACTIONS(561),
    [anon_sym_memory] = ACTIONS(561),
    [anon_sym_to] = ACTIONS(563),
    [anon_sym_unwind] = ACTIONS(561),
    [anon_sym_unordered] = ACTIONS(561),
    [anon_sym_monotonic] = ACTIONS(561),
    [anon_sym_acquire] = ACTIONS(561),
    [anon_sym_release] = ACTIONS(561),
    [anon_sym_acq_rel] = ACTIONS(561),
    [anon_sym_seq_cst] = ACTIONS(561),
    [anon_sym_syncscope] = ACTIONS(561),
    [anon_sym_uselistorder] = ACTIONS(563),
    [anon_sym_uselistorder_bb] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(561),
    [anon_sym_attributes] = ACTIONS(561),
  },
  [98] = {
    [ts_builtin_sym_end] = ACTIONS(565),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(565),
    [sym_global_var] = ACTIONS(565),
    [sym_local_var] = ACTIONS(565),
    [aux_sym_metadata_ref_token1] = ACTIONS(565),
    [sym_summary_ref] = ACTIONS(565),
    [sym_string] = ACTIONS(565),
    [anon_sym_target] = ACTIONS(565),
    [anon_sym_source_filename] = ACTIONS(565),
    [anon_sym_declare] = ACTIONS(565),
    [anon_sym_define] = ACTIONS(565),
    [anon_sym_no_cfi] = ACTIONS(565),
    [anon_sym_private] = ACTIONS(565),
    [anon_sym_internal] = ACTIONS(565),
    [anon_sym_weak] = ACTIONS(567),
    [anon_sym_weak_odr] = ACTIONS(565),
    [anon_sym_linkonce] = ACTIONS(567),
    [anon_sym_linkonce_odr] = ACTIONS(565),
    [anon_sym_available_externally] = ACTIONS(565),
    [anon_sym_appending] = ACTIONS(565),
    [anon_sym_common] = ACTIONS(565),
    [anon_sym_extern_weak] = ACTIONS(565),
    [anon_sym_external] = ACTIONS(565),
    [anon_sym_dso_local] = ACTIONS(567),
    [anon_sym_dso_local_equivalent] = ACTIONS(565),
    [anon_sym_dso_preemptable] = ACTIONS(565),
    [anon_sym_default] = ACTIONS(565),
    [anon_sym_hidden] = ACTIONS(565),
    [anon_sym_protected] = ACTIONS(565),
    [anon_sym_dllimport] = ACTIONS(565),
    [anon_sym_dllexport] = ACTIONS(565),
    [anon_sym_ccc] = ACTIONS(565),
    [anon_sym_fastcc] = ACTIONS(565),
    [anon_sym_coldcc] = ACTIONS(565),
    [anon_sym_webkit_jscc] = ACTIONS(567),
    [anon_sym_anyregcc] = ACTIONS(565),
    [anon_sym_preserve_mostcc] = ACTIONS(565),
    [anon_sym_preserve_allcc] = ACTIONS(565),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(567),
    [anon_sym_tailcc] = ACTIONS(565),
    [anon_sym_swiftcc] = ACTIONS(567),
    [anon_sym_swifttailcc] = ACTIONS(567),
    [anon_sym_cfguard_checkcc] = ACTIONS(565),
    [aux_sym_calling_conv_token1] = ACTIONS(567),
    [aux_sym_calling_conv_token2] = ACTIONS(565),
    [aux_sym_calling_conv_token3] = ACTIONS(565),
    [aux_sym_calling_conv_token4] = ACTIONS(565),
    [aux_sym_calling_conv_token5] = ACTIONS(565),
    [aux_sym_calling_conv_token6] = ACTIONS(565),
    [aux_sym_calling_conv_token7] = ACTIONS(565),
    [aux_sym_calling_conv_token8] = ACTIONS(565),
    [aux_sym_calling_conv_token9] = ACTIONS(565),
    [aux_sym_calling_conv_token10] = ACTIONS(567),
    [anon_sym_ghccc] = ACTIONS(565),
    [aux_sym_calling_conv_token11] = ACTIONS(567),
    [aux_sym_calling_conv_token12] = ACTIONS(565),
    [aux_sym_calling_conv_token13] = ACTIONS(567),
    [aux_sym_calling_conv_token14] = ACTIONS(565),
    [anon_sym_cc] = ACTIONS(567),
    [anon_sym_unnamed_addr] = ACTIONS(565),
    [anon_sym_local_unnamed_addr] = ACTIONS(565),
    [anon_sym_void] = ACTIONS(565),
    [anon_sym_half] = ACTIONS(565),
    [anon_sym_bfloat] = ACTIONS(565),
    [anon_sym_float] = ACTIONS(565),
    [anon_sym_double] = ACTIONS(565),
    [anon_sym_x86_fp80] = ACTIONS(567),
    [anon_sym_fp128] = ACTIONS(565),
    [anon_sym_ppc_fp128] = ACTIONS(565),
    [anon_sym_label] = ACTIONS(565),
    [anon_sym_metadata] = ACTIONS(565),
    [anon_sym_x86_mmx] = ACTIONS(567),
    [anon_sym_x86_amx] = ACTIONS(567),
    [anon_sym_token] = ACTIONS(565),
    [anon_sym_opaque] = ACTIONS(565),
    [anon_sym_ptr] = ACTIONS(565),
    [aux_sym_type_keyword_token1] = ACTIONS(565),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_LT_LBRACE] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_RBRACK] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(565),
    [anon_sym_align] = ACTIONS(567),
    [anon_sym_alignstack] = ACTIONS(565),
    [anon_sym_allocsize] = ACTIONS(565),
    [anon_sym_alwaysinline] = ACTIONS(565),
    [anon_sym_builtin] = ACTIONS(565),
    [anon_sym_cold] = ACTIONS(567),
    [anon_sym_convergent] = ACTIONS(565),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(565),
    [anon_sym_hot] = ACTIONS(565),
    [anon_sym_inaccessiblememonly] = ACTIONS(565),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(565),
    [anon_sym_inlinehint] = ACTIONS(565),
    [anon_sym_jumptable] = ACTIONS(565),
    [anon_sym_minsize] = ACTIONS(565),
    [anon_sym_naked] = ACTIONS(565),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(565),
    [anon_sym_nobuiltin] = ACTIONS(565),
    [anon_sym_noduplicate] = ACTIONS(565),
    [anon_sym_nofree] = ACTIONS(565),
    [anon_sym_noimplicitfloat] = ACTIONS(565),
    [anon_sym_noinline] = ACTIONS(565),
    [anon_sym_nomerge] = ACTIONS(565),
    [anon_sym_nonlazybind] = ACTIONS(565),
    [anon_sym_noprofile] = ACTIONS(565),
    [anon_sym_noredzone] = ACTIONS(565),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(565),
    [anon_sym_noreturn] = ACTIONS(565),
    [anon_sym_norecurse] = ACTIONS(565),
    [anon_sym_willreturn] = ACTIONS(565),
    [anon_sym_nosync] = ACTIONS(565),
    [anon_sym_nounwind] = ACTIONS(565),
    [anon_sym_nocallback] = ACTIONS(565),
    [anon_sym_nosanitize_coverage] = ACTIONS(565),
    [anon_sym_null_pointer_is_valid] = ACTIONS(565),
    [anon_sym_optforfuzzing] = ACTIONS(565),
    [anon_sym_optnone] = ACTIONS(565),
    [anon_sym_optsize] = ACTIONS(565),
    [anon_sym_readnone] = ACTIONS(565),
    [anon_sym_readonly] = ACTIONS(565),
    [anon_sym_writeonly] = ACTIONS(565),
    [anon_sym_argmemonly] = ACTIONS(565),
    [anon_sym_returns_twice] = ACTIONS(565),
    [anon_sym_safestack] = ACTIONS(565),
    [anon_sym_sanitize_address] = ACTIONS(565),
    [anon_sym_sanitize_memory] = ACTIONS(565),
    [anon_sym_sanitize_thread] = ACTIONS(565),
    [anon_sym_sanitize_hwaddress] = ACTIONS(565),
    [anon_sym_sanitize_memtag] = ACTIONS(565),
    [anon_sym_speculative_load_hardening] = ACTIONS(565),
    [anon_sym_speculatable] = ACTIONS(565),
    [anon_sym_ssp] = ACTIONS(567),
    [anon_sym_sspstrong] = ACTIONS(565),
    [anon_sym_sspreq] = ACTIONS(565),
    [anon_sym_strictfp] = ACTIONS(565),
    [anon_sym_nocf_check] = ACTIONS(565),
    [anon_sym_shadowcallstack] = ACTIONS(565),
    [anon_sym_mustprogress] = ACTIONS(565),
    [anon_sym_vscale_range] = ACTIONS(565),
    [anon_sym_preallocated] = ACTIONS(565),
    [anon_sym_zeroext] = ACTIONS(565),
    [anon_sym_signext] = ACTIONS(565),
    [anon_sym_inreg] = ACTIONS(565),
    [anon_sym_byval] = ACTIONS(565),
    [anon_sym_byref] = ACTIONS(565),
    [anon_sym_inalloca] = ACTIONS(565),
    [anon_sym_sret] = ACTIONS(565),
    [anon_sym_elementtype] = ACTIONS(565),
    [anon_sym_noalias] = ACTIONS(565),
    [anon_sym_nocapture] = ACTIONS(565),
    [anon_sym_nest] = ACTIONS(565),
    [anon_sym_returned] = ACTIONS(565),
    [anon_sym_nonnull] = ACTIONS(565),
    [anon_sym_dereferenceable] = ACTIONS(567),
    [anon_sym_dereferenceable_or_null] = ACTIONS(565),
    [anon_sym_swiftself] = ACTIONS(567),
    [anon_sym_swiftasync] = ACTIONS(567),
    [anon_sym_swifterror] = ACTIONS(567),
    [anon_sym_immarg] = ACTIONS(565),
    [anon_sym_noundef] = ACTIONS(565),
    [anon_sym_uwtable] = ACTIONS(565),
    [anon_sym_memory] = ACTIONS(565),
    [anon_sym_to] = ACTIONS(567),
    [anon_sym_unwind] = ACTIONS(565),
    [anon_sym_unordered] = ACTIONS(565),
    [anon_sym_monotonic] = ACTIONS(565),
    [anon_sym_acquire] = ACTIONS(565),
    [anon_sym_release] = ACTIONS(565),
    [anon_sym_acq_rel] = ACTIONS(565),
    [anon_sym_seq_cst] = ACTIONS(565),
    [anon_sym_syncscope] = ACTIONS(565),
    [anon_sym_uselistorder] = ACTIONS(567),
    [anon_sym_uselistorder_bb] = ACTIONS(565),
    [anon_sym_module] = ACTIONS(565),
    [anon_sym_attributes] = ACTIONS(565),
  },
  [99] = {
    [ts_builtin_sym_end] = ACTIONS(569),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(569),
    [sym_global_var] = ACTIONS(569),
    [sym_local_var] = ACTIONS(569),
    [aux_sym_metadata_ref_token1] = ACTIONS(569),
    [sym_summary_ref] = ACTIONS(569),
    [sym_string] = ACTIONS(569),
    [anon_sym_target] = ACTIONS(569),
    [anon_sym_source_filename] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_define] = ACTIONS(569),
    [anon_sym_no_cfi] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_internal] = ACTIONS(569),
    [anon_sym_weak] = ACTIONS(571),
    [anon_sym_weak_odr] = ACTIONS(569),
    [anon_sym_linkonce] = ACTIONS(571),
    [anon_sym_linkonce_odr] = ACTIONS(569),
    [anon_sym_available_externally] = ACTIONS(569),
    [anon_sym_appending] = ACTIONS(569),
    [anon_sym_common] = ACTIONS(569),
    [anon_sym_extern_weak] = ACTIONS(569),
    [anon_sym_external] = ACTIONS(569),
    [anon_sym_dso_local] = ACTIONS(571),
    [anon_sym_dso_local_equivalent] = ACTIONS(569),
    [anon_sym_dso_preemptable] = ACTIONS(569),
    [anon_sym_default] = ACTIONS(569),
    [anon_sym_hidden] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_dllimport] = ACTIONS(569),
    [anon_sym_dllexport] = ACTIONS(569),
    [anon_sym_ccc] = ACTIONS(569),
    [anon_sym_fastcc] = ACTIONS(569),
    [anon_sym_coldcc] = ACTIONS(569),
    [anon_sym_webkit_jscc] = ACTIONS(571),
    [anon_sym_anyregcc] = ACTIONS(569),
    [anon_sym_preserve_mostcc] = ACTIONS(569),
    [anon_sym_preserve_allcc] = ACTIONS(569),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(571),
    [anon_sym_tailcc] = ACTIONS(569),
    [anon_sym_swiftcc] = ACTIONS(571),
    [anon_sym_swifttailcc] = ACTIONS(571),
    [anon_sym_cfguard_checkcc] = ACTIONS(569),
    [aux_sym_calling_conv_token1] = ACTIONS(571),
    [aux_sym_calling_conv_token2] = ACTIONS(569),
    [aux_sym_calling_conv_token3] = ACTIONS(569),
    [aux_sym_calling_conv_token4] = ACTIONS(569),
    [aux_sym_calling_conv_token5] = ACTIONS(569),
    [aux_sym_calling_conv_token6] = ACTIONS(569),
    [aux_sym_calling_conv_token7] = ACTIONS(569),
    [aux_sym_calling_conv_token8] = ACTIONS(569),
    [aux_sym_calling_conv_token9] = ACTIONS(569),
    [aux_sym_calling_conv_token10] = ACTIONS(571),
    [anon_sym_ghccc] = ACTIONS(569),
    [aux_sym_calling_conv_token11] = ACTIONS(571),
    [aux_sym_calling_conv_token12] = ACTIONS(569),
    [aux_sym_calling_conv_token13] = ACTIONS(571),
    [aux_sym_calling_conv_token14] = ACTIONS(569),
    [anon_sym_cc] = ACTIONS(571),
    [anon_sym_unnamed_addr] = ACTIONS(569),
    [anon_sym_local_unnamed_addr] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(569),
    [anon_sym_half] = ACTIONS(569),
    [anon_sym_bfloat] = ACTIONS(569),
    [anon_sym_float] = ACTIONS(569),
    [anon_sym_double] = ACTIONS(569),
    [anon_sym_x86_fp80] = ACTIONS(571),
    [anon_sym_fp128] = ACTIONS(569),
    [anon_sym_ppc_fp128] = ACTIONS(569),
    [anon_sym_label] = ACTIONS(569),
    [anon_sym_metadata] = ACTIONS(569),
    [anon_sym_x86_mmx] = ACTIONS(571),
    [anon_sym_x86_amx] = ACTIONS(571),
    [anon_sym_token] = ACTIONS(569),
    [anon_sym_opaque] = ACTIONS(569),
    [anon_sym_ptr] = ACTIONS(569),
    [aux_sym_type_keyword_token1] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_LT_LBRACE] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_RBRACK] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(569),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(569),
    [anon_sym_RPAREN] = ACTIONS(569),
    [anon_sym_align] = ACTIONS(571),
    [anon_sym_alignstack] = ACTIONS(569),
    [anon_sym_allocsize] = ACTIONS(569),
    [anon_sym_alwaysinline] = ACTIONS(569),
    [anon_sym_builtin] = ACTIONS(569),
    [anon_sym_cold] = ACTIONS(571),
    [anon_sym_convergent] = ACTIONS(569),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(569),
    [anon_sym_hot] = ACTIONS(569),
    [anon_sym_inaccessiblememonly] = ACTIONS(569),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(569),
    [anon_sym_inlinehint] = ACTIONS(569),
    [anon_sym_jumptable] = ACTIONS(569),
    [anon_sym_minsize] = ACTIONS(569),
    [anon_sym_naked] = ACTIONS(569),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(569),
    [anon_sym_nobuiltin] = ACTIONS(569),
    [anon_sym_noduplicate] = ACTIONS(569),
    [anon_sym_nofree] = ACTIONS(569),
    [anon_sym_noimplicitfloat] = ACTIONS(569),
    [anon_sym_noinline] = ACTIONS(569),
    [anon_sym_nomerge] = ACTIONS(569),
    [anon_sym_nonlazybind] = ACTIONS(569),
    [anon_sym_noprofile] = ACTIONS(569),
    [anon_sym_noredzone] = ACTIONS(569),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(569),
    [anon_sym_noreturn] = ACTIONS(569),
    [anon_sym_norecurse] = ACTIONS(569),
    [anon_sym_willreturn] = ACTIONS(569),
    [anon_sym_nosync] = ACTIONS(569),
    [anon_sym_nounwind] = ACTIONS(569),
    [anon_sym_nocallback] = ACTIONS(569),
    [anon_sym_nosanitize_coverage] = ACTIONS(569),
    [anon_sym_null_pointer_is_valid] = ACTIONS(569),
    [anon_sym_optforfuzzing] = ACTIONS(569),
    [anon_sym_optnone] = ACTIONS(569),
    [anon_sym_optsize] = ACTIONS(569),
    [anon_sym_readnone] = ACTIONS(569),
    [anon_sym_readonly] = ACTIONS(569),
    [anon_sym_writeonly] = ACTIONS(569),
    [anon_sym_argmemonly] = ACTIONS(569),
    [anon_sym_returns_twice] = ACTIONS(569),
    [anon_sym_safestack] = ACTIONS(569),
    [anon_sym_sanitize_address] = ACTIONS(569),
    [anon_sym_sanitize_memory] = ACTIONS(569),
    [anon_sym_sanitize_thread] = ACTIONS(569),
    [anon_sym_sanitize_hwaddress] = ACTIONS(569),
    [anon_sym_sanitize_memtag] = ACTIONS(569),
    [anon_sym_speculative_load_hardening] = ACTIONS(569),
    [anon_sym_speculatable] = ACTIONS(569),
    [anon_sym_ssp] = ACTIONS(571),
    [anon_sym_sspstrong] = ACTIONS(569),
    [anon_sym_sspreq] = ACTIONS(569),
    [anon_sym_strictfp] = ACTIONS(569),
    [anon_sym_nocf_check] = ACTIONS(569),
    [anon_sym_shadowcallstack] = ACTIONS(569),
    [anon_sym_mustprogress] = ACTIONS(569),
    [anon_sym_vscale_range] = ACTIONS(569),
    [anon_sym_preallocated] = ACTIONS(569),
    [anon_sym_zeroext] = ACTIONS(569),
    [anon_sym_signext] = ACTIONS(569),
    [anon_sym_inreg] = ACTIONS(569),
    [anon_sym_byval] = ACTIONS(569),
    [anon_sym_byref] = ACTIONS(569),
    [anon_sym_inalloca] = ACTIONS(569),
    [anon_sym_sret] = ACTIONS(569),
    [anon_sym_elementtype] = ACTIONS(569),
    [anon_sym_noalias] = ACTIONS(569),
    [anon_sym_nocapture] = ACTIONS(569),
    [anon_sym_nest] = ACTIONS(569),
    [anon_sym_returned] = ACTIONS(569),
    [anon_sym_nonnull] = ACTIONS(569),
    [anon_sym_dereferenceable] = ACTIONS(571),
    [anon_sym_dereferenceable_or_null] = ACTIONS(569),
    [anon_sym_swiftself] = ACTIONS(571),
    [anon_sym_swiftasync] = ACTIONS(571),
    [anon_sym_swifterror] = ACTIONS(571),
    [anon_sym_immarg] = ACTIONS(569),
    [anon_sym_noundef] = ACTIONS(569),
    [anon_sym_uwtable] = ACTIONS(569),
    [anon_sym_memory] = ACTIONS(569),
    [anon_sym_to] = ACTIONS(571),
    [anon_sym_unwind] = ACTIONS(569),
    [anon_sym_unordered] = ACTIONS(569),
    [anon_sym_monotonic] = ACTIONS(569),
    [anon_sym_acquire] = ACTIONS(569),
    [anon_sym_release] = ACTIONS(569),
    [anon_sym_acq_rel] = ACTIONS(569),
    [anon_sym_seq_cst] = ACTIONS(569),
    [anon_sym_syncscope] = ACTIONS(569),
    [anon_sym_uselistorder] = ACTIONS(571),
    [anon_sym_uselistorder_bb] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_attributes] = ACTIONS(569),
  },
  [100] = {
    [ts_builtin_sym_end] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(573),
    [sym_global_var] = ACTIONS(573),
    [sym_local_var] = ACTIONS(573),
    [aux_sym_metadata_ref_token1] = ACTIONS(573),
    [sym_summary_ref] = ACTIONS(573),
    [sym_string] = ACTIONS(573),
    [anon_sym_target] = ACTIONS(573),
    [anon_sym_source_filename] = ACTIONS(573),
    [anon_sym_declare] = ACTIONS(573),
    [anon_sym_define] = ACTIONS(573),
    [anon_sym_no_cfi] = ACTIONS(573),
    [anon_sym_private] = ACTIONS(573),
    [anon_sym_internal] = ACTIONS(573),
    [anon_sym_weak] = ACTIONS(575),
    [anon_sym_weak_odr] = ACTIONS(573),
    [anon_sym_linkonce] = ACTIONS(575),
    [anon_sym_linkonce_odr] = ACTIONS(573),
    [anon_sym_available_externally] = ACTIONS(573),
    [anon_sym_appending] = ACTIONS(573),
    [anon_sym_common] = ACTIONS(573),
    [anon_sym_extern_weak] = ACTIONS(573),
    [anon_sym_external] = ACTIONS(573),
    [anon_sym_dso_local] = ACTIONS(575),
    [anon_sym_dso_local_equivalent] = ACTIONS(573),
    [anon_sym_dso_preemptable] = ACTIONS(573),
    [anon_sym_default] = ACTIONS(573),
    [anon_sym_hidden] = ACTIONS(573),
    [anon_sym_protected] = ACTIONS(573),
    [anon_sym_dllimport] = ACTIONS(573),
    [anon_sym_dllexport] = ACTIONS(573),
    [anon_sym_ccc] = ACTIONS(573),
    [anon_sym_fastcc] = ACTIONS(573),
    [anon_sym_coldcc] = ACTIONS(573),
    [anon_sym_webkit_jscc] = ACTIONS(575),
    [anon_sym_anyregcc] = ACTIONS(573),
    [anon_sym_preserve_mostcc] = ACTIONS(573),
    [anon_sym_preserve_allcc] = ACTIONS(573),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(575),
    [anon_sym_tailcc] = ACTIONS(573),
    [anon_sym_swiftcc] = ACTIONS(575),
    [anon_sym_swifttailcc] = ACTIONS(575),
    [anon_sym_cfguard_checkcc] = ACTIONS(573),
    [aux_sym_calling_conv_token1] = ACTIONS(575),
    [aux_sym_calling_conv_token2] = ACTIONS(573),
    [aux_sym_calling_conv_token3] = ACTIONS(573),
    [aux_sym_calling_conv_token4] = ACTIONS(573),
    [aux_sym_calling_conv_token5] = ACTIONS(573),
    [aux_sym_calling_conv_token6] = ACTIONS(573),
    [aux_sym_calling_conv_token7] = ACTIONS(573),
    [aux_sym_calling_conv_token8] = ACTIONS(573),
    [aux_sym_calling_conv_token9] = ACTIONS(573),
    [aux_sym_calling_conv_token10] = ACTIONS(575),
    [anon_sym_ghccc] = ACTIONS(573),
    [aux_sym_calling_conv_token11] = ACTIONS(575),
    [aux_sym_calling_conv_token12] = ACTIONS(573),
    [aux_sym_calling_conv_token13] = ACTIONS(575),
    [aux_sym_calling_conv_token14] = ACTIONS(573),
    [anon_sym_cc] = ACTIONS(575),
    [anon_sym_unnamed_addr] = ACTIONS(573),
    [anon_sym_local_unnamed_addr] = ACTIONS(573),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_half] = ACTIONS(573),
    [anon_sym_bfloat] = ACTIONS(573),
    [anon_sym_float] = ACTIONS(573),
    [anon_sym_double] = ACTIONS(573),
    [anon_sym_x86_fp80] = ACTIONS(575),
    [anon_sym_fp128] = ACTIONS(573),
    [anon_sym_ppc_fp128] = ACTIONS(573),
    [anon_sym_label] = ACTIONS(573),
    [anon_sym_metadata] = ACTIONS(573),
    [anon_sym_x86_mmx] = ACTIONS(575),
    [anon_sym_x86_amx] = ACTIONS(575),
    [anon_sym_token] = ACTIONS(573),
    [anon_sym_opaque] = ACTIONS(573),
    [anon_sym_ptr] = ACTIONS(573),
    [aux_sym_type_keyword_token1] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(573),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_LT_LBRACE] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_RBRACK] = ACTIONS(573),
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_GT] = ACTIONS(573),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_align] = ACTIONS(575),
    [anon_sym_alignstack] = ACTIONS(573),
    [anon_sym_allocsize] = ACTIONS(573),
    [anon_sym_alwaysinline] = ACTIONS(573),
    [anon_sym_builtin] = ACTIONS(573),
    [anon_sym_cold] = ACTIONS(575),
    [anon_sym_convergent] = ACTIONS(573),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(573),
    [anon_sym_hot] = ACTIONS(573),
    [anon_sym_inaccessiblememonly] = ACTIONS(573),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(573),
    [anon_sym_inlinehint] = ACTIONS(573),
    [anon_sym_jumptable] = ACTIONS(573),
    [anon_sym_minsize] = ACTIONS(573),
    [anon_sym_naked] = ACTIONS(573),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(573),
    [anon_sym_nobuiltin] = ACTIONS(573),
    [anon_sym_noduplicate] = ACTIONS(573),
    [anon_sym_nofree] = ACTIONS(573),
    [anon_sym_noimplicitfloat] = ACTIONS(573),
    [anon_sym_noinline] = ACTIONS(573),
    [anon_sym_nomerge] = ACTIONS(573),
    [anon_sym_nonlazybind] = ACTIONS(573),
    [anon_sym_noprofile] = ACTIONS(573),
    [anon_sym_noredzone] = ACTIONS(573),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(573),
    [anon_sym_noreturn] = ACTIONS(573),
    [anon_sym_norecurse] = ACTIONS(573),
    [anon_sym_willreturn] = ACTIONS(573),
    [anon_sym_nosync] = ACTIONS(573),
    [anon_sym_nounwind] = ACTIONS(573),
    [anon_sym_nocallback] = ACTIONS(573),
    [anon_sym_nosanitize_coverage] = ACTIONS(573),
    [anon_sym_null_pointer_is_valid] = ACTIONS(573),
    [anon_sym_optforfuzzing] = ACTIONS(573),
    [anon_sym_optnone] = ACTIONS(573),
    [anon_sym_optsize] = ACTIONS(573),
    [anon_sym_readnone] = ACTIONS(573),
    [anon_sym_readonly] = ACTIONS(573),
    [anon_sym_writeonly] = ACTIONS(573),
    [anon_sym_argmemonly] = ACTIONS(573),
    [anon_sym_returns_twice] = ACTIONS(573),
    [anon_sym_safestack] = ACTIONS(573),
    [anon_sym_sanitize_address] = ACTIONS(573),
    [anon_sym_sanitize_memory] = ACTIONS(573),
    [anon_sym_sanitize_thread] = ACTIONS(573),
    [anon_sym_sanitize_hwaddress] = ACTIONS(573),
    [anon_sym_sanitize_memtag] = ACTIONS(573),
    [anon_sym_speculative_load_hardening] = ACTIONS(573),
    [anon_sym_speculatable] = ACTIONS(573),
    [anon_sym_ssp] = ACTIONS(575),
    [anon_sym_sspstrong] = ACTIONS(573),
    [anon_sym_sspreq] = ACTIONS(573),
    [anon_sym_strictfp] = ACTIONS(573),
    [anon_sym_nocf_check] = ACTIONS(573),
    [anon_sym_shadowcallstack] = ACTIONS(573),
    [anon_sym_mustprogress] = ACTIONS(573),
    [anon_sym_vscale_range] = ACTIONS(573),
    [anon_sym_preallocated] = ACTIONS(573),
    [anon_sym_zeroext] = ACTIONS(573),
    [anon_sym_signext] = ACTIONS(573),
    [anon_sym_inreg] = ACTIONS(573),
    [anon_sym_byval] = ACTIONS(573),
    [anon_sym_byref] = ACTIONS(573),
    [anon_sym_inalloca] = ACTIONS(573),
    [anon_sym_sret] = ACTIONS(573),
    [anon_sym_elementtype] = ACTIONS(573),
    [anon_sym_noalias] = ACTIONS(573),
    [anon_sym_nocapture] = ACTIONS(573),
    [anon_sym_nest] = ACTIONS(573),
    [anon_sym_returned] = ACTIONS(573),
    [anon_sym_nonnull] = ACTIONS(573),
    [anon_sym_dereferenceable] = ACTIONS(575),
    [anon_sym_dereferenceable_or_null] = ACTIONS(573),
    [anon_sym_swiftself] = ACTIONS(575),
    [anon_sym_swiftasync] = ACTIONS(575),
    [anon_sym_swifterror] = ACTIONS(575),
    [anon_sym_immarg] = ACTIONS(573),
    [anon_sym_noundef] = ACTIONS(573),
    [anon_sym_uwtable] = ACTIONS(573),
    [anon_sym_memory] = ACTIONS(573),
    [anon_sym_to] = ACTIONS(575),
    [anon_sym_unwind] = ACTIONS(573),
    [anon_sym_unordered] = ACTIONS(573),
    [anon_sym_monotonic] = ACTIONS(573),
    [anon_sym_acquire] = ACTIONS(573),
    [anon_sym_release] = ACTIONS(573),
    [anon_sym_acq_rel] = ACTIONS(573),
    [anon_sym_seq_cst] = ACTIONS(573),
    [anon_sym_syncscope] = ACTIONS(573),
    [anon_sym_uselistorder] = ACTIONS(575),
    [anon_sym_uselistorder_bb] = ACTIONS(573),
    [anon_sym_module] = ACTIONS(573),
    [anon_sym_LPAREN2] = ACTIONS(577),
    [anon_sym_attributes] = ACTIONS(573),
  },
  [101] = {
    [ts_builtin_sym_end] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(579),
    [sym_global_var] = ACTIONS(579),
    [sym_local_var] = ACTIONS(579),
    [aux_sym_metadata_ref_token1] = ACTIONS(579),
    [sym_summary_ref] = ACTIONS(579),
    [sym_string] = ACTIONS(579),
    [anon_sym_target] = ACTIONS(579),
    [anon_sym_source_filename] = ACTIONS(579),
    [anon_sym_declare] = ACTIONS(579),
    [anon_sym_define] = ACTIONS(579),
    [anon_sym_no_cfi] = ACTIONS(579),
    [anon_sym_private] = ACTIONS(579),
    [anon_sym_internal] = ACTIONS(579),
    [anon_sym_weak] = ACTIONS(581),
    [anon_sym_weak_odr] = ACTIONS(579),
    [anon_sym_linkonce] = ACTIONS(581),
    [anon_sym_linkonce_odr] = ACTIONS(579),
    [anon_sym_available_externally] = ACTIONS(579),
    [anon_sym_appending] = ACTIONS(579),
    [anon_sym_common] = ACTIONS(579),
    [anon_sym_extern_weak] = ACTIONS(579),
    [anon_sym_external] = ACTIONS(579),
    [anon_sym_dso_local] = ACTIONS(581),
    [anon_sym_dso_local_equivalent] = ACTIONS(579),
    [anon_sym_dso_preemptable] = ACTIONS(579),
    [anon_sym_default] = ACTIONS(579),
    [anon_sym_hidden] = ACTIONS(579),
    [anon_sym_protected] = ACTIONS(579),
    [anon_sym_dllimport] = ACTIONS(579),
    [anon_sym_dllexport] = ACTIONS(579),
    [anon_sym_ccc] = ACTIONS(579),
    [anon_sym_fastcc] = ACTIONS(579),
    [anon_sym_coldcc] = ACTIONS(579),
    [anon_sym_webkit_jscc] = ACTIONS(581),
    [anon_sym_anyregcc] = ACTIONS(579),
    [anon_sym_preserve_mostcc] = ACTIONS(579),
    [anon_sym_preserve_allcc] = ACTIONS(579),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(581),
    [anon_sym_tailcc] = ACTIONS(579),
    [anon_sym_swiftcc] = ACTIONS(581),
    [anon_sym_swifttailcc] = ACTIONS(581),
    [anon_sym_cfguard_checkcc] = ACTIONS(579),
    [aux_sym_calling_conv_token1] = ACTIONS(581),
    [aux_sym_calling_conv_token2] = ACTIONS(579),
    [aux_sym_calling_conv_token3] = ACTIONS(579),
    [aux_sym_calling_conv_token4] = ACTIONS(579),
    [aux_sym_calling_conv_token5] = ACTIONS(579),
    [aux_sym_calling_conv_token6] = ACTIONS(579),
    [aux_sym_calling_conv_token7] = ACTIONS(579),
    [aux_sym_calling_conv_token8] = ACTIONS(579),
    [aux_sym_calling_conv_token9] = ACTIONS(579),
    [aux_sym_calling_conv_token10] = ACTIONS(581),
    [anon_sym_ghccc] = ACTIONS(579),
    [aux_sym_calling_conv_token11] = ACTIONS(581),
    [aux_sym_calling_conv_token12] = ACTIONS(579),
    [aux_sym_calling_conv_token13] = ACTIONS(581),
    [aux_sym_calling_conv_token14] = ACTIONS(579),
    [anon_sym_cc] = ACTIONS(581),
    [anon_sym_unnamed_addr] = ACTIONS(579),
    [anon_sym_local_unnamed_addr] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_half] = ACTIONS(579),
    [anon_sym_bfloat] = ACTIONS(579),
    [anon_sym_float] = ACTIONS(579),
    [anon_sym_double] = ACTIONS(579),
    [anon_sym_x86_fp80] = ACTIONS(581),
    [anon_sym_fp128] = ACTIONS(579),
    [anon_sym_ppc_fp128] = ACTIONS(579),
    [anon_sym_label] = ACTIONS(579),
    [anon_sym_metadata] = ACTIONS(579),
    [anon_sym_x86_mmx] = ACTIONS(581),
    [anon_sym_x86_amx] = ACTIONS(581),
    [anon_sym_token] = ACTIONS(579),
    [anon_sym_opaque] = ACTIONS(579),
    [anon_sym_ptr] = ACTIONS(579),
    [aux_sym_type_keyword_token1] = ACTIONS(579),
    [anon_sym_LBRACE] = ACTIONS(579),
    [anon_sym_RBRACE] = ACTIONS(579),
    [anon_sym_LT_LBRACE] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(579),
    [anon_sym_RBRACK] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_GT] = ACTIONS(579),
    [anon_sym_COMMA] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(579),
    [anon_sym_RPAREN] = ACTIONS(579),
    [anon_sym_align] = ACTIONS(581),
    [anon_sym_alignstack] = ACTIONS(579),
    [anon_sym_allocsize] = ACTIONS(579),
    [anon_sym_alwaysinline] = ACTIONS(579),
    [anon_sym_builtin] = ACTIONS(579),
    [anon_sym_cold] = ACTIONS(581),
    [anon_sym_convergent] = ACTIONS(579),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(579),
    [anon_sym_hot] = ACTIONS(579),
    [anon_sym_inaccessiblememonly] = ACTIONS(579),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(579),
    [anon_sym_inlinehint] = ACTIONS(579),
    [anon_sym_jumptable] = ACTIONS(579),
    [anon_sym_minsize] = ACTIONS(579),
    [anon_sym_naked] = ACTIONS(579),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(579),
    [anon_sym_nobuiltin] = ACTIONS(579),
    [anon_sym_noduplicate] = ACTIONS(579),
    [anon_sym_nofree] = ACTIONS(579),
    [anon_sym_noimplicitfloat] = ACTIONS(579),
    [anon_sym_noinline] = ACTIONS(579),
    [anon_sym_nomerge] = ACTIONS(579),
    [anon_sym_nonlazybind] = ACTIONS(579),
    [anon_sym_noprofile] = ACTIONS(579),
    [anon_sym_noredzone] = ACTIONS(579),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(579),
    [anon_sym_noreturn] = ACTIONS(579),
    [anon_sym_norecurse] = ACTIONS(579),
    [anon_sym_willreturn] = ACTIONS(579),
    [anon_sym_nosync] = ACTIONS(579),
    [anon_sym_nounwind] = ACTIONS(579),
    [anon_sym_nocallback] = ACTIONS(579),
    [anon_sym_nosanitize_coverage] = ACTIONS(579),
    [anon_sym_null_pointer_is_valid] = ACTIONS(579),
    [anon_sym_optforfuzzing] = ACTIONS(579),
    [anon_sym_optnone] = ACTIONS(579),
    [anon_sym_optsize] = ACTIONS(579),
    [anon_sym_readnone] = ACTIONS(579),
    [anon_sym_readonly] = ACTIONS(579),
    [anon_sym_writeonly] = ACTIONS(579),
    [anon_sym_argmemonly] = ACTIONS(579),
    [anon_sym_returns_twice] = ACTIONS(579),
    [anon_sym_safestack] = ACTIONS(579),
    [anon_sym_sanitize_address] = ACTIONS(579),
    [anon_sym_sanitize_memory] = ACTIONS(579),
    [anon_sym_sanitize_thread] = ACTIONS(579),
    [anon_sym_sanitize_hwaddress] = ACTIONS(579),
    [anon_sym_sanitize_memtag] = ACTIONS(579),
    [anon_sym_speculative_load_hardening] = ACTIONS(579),
    [anon_sym_speculatable] = ACTIONS(579),
    [anon_sym_ssp] = ACTIONS(581),
    [anon_sym_sspstrong] = ACTIONS(579),
    [anon_sym_sspreq] = ACTIONS(579),
    [anon_sym_strictfp] = ACTIONS(579),
    [anon_sym_nocf_check] = ACTIONS(579),
    [anon_sym_shadowcallstack] = ACTIONS(579),
    [anon_sym_mustprogress] = ACTIONS(579),
    [anon_sym_vscale_range] = ACTIONS(579),
    [anon_sym_preallocated] = ACTIONS(579),
    [anon_sym_zeroext] = ACTIONS(579),
    [anon_sym_signext] = ACTIONS(579),
    [anon_sym_inreg] = ACTIONS(579),
    [anon_sym_byval] = ACTIONS(579),
    [anon_sym_byref] = ACTIONS(579),
    [anon_sym_inalloca] = ACTIONS(579),
    [anon_sym_sret] = ACTIONS(579),
    [anon_sym_elementtype] = ACTIONS(579),
    [anon_sym_noalias] = ACTIONS(579),
    [anon_sym_nocapture] = ACTIONS(579),
    [anon_sym_nest] = ACTIONS(579),
    [anon_sym_returned] = ACTIONS(579),
    [anon_sym_nonnull] = ACTIONS(579),
    [anon_sym_dereferenceable] = ACTIONS(581),
    [anon_sym_dereferenceable_or_null] = ACTIONS(579),
    [anon_sym_swiftself] = ACTIONS(581),
    [anon_sym_swiftasync] = ACTIONS(581),
    [anon_sym_swifterror] = ACTIONS(581),
    [anon_sym_immarg] = ACTIONS(579),
    [anon_sym_noundef] = ACTIONS(579),
    [anon_sym_uwtable] = ACTIONS(579),
    [anon_sym_memory] = ACTIONS(579),
    [anon_sym_to] = ACTIONS(581),
    [anon_sym_unwind] = ACTIONS(579),
    [anon_sym_unordered] = ACTIONS(579),
    [anon_sym_monotonic] = ACTIONS(579),
    [anon_sym_acquire] = ACTIONS(579),
    [anon_sym_release] = ACTIONS(579),
    [anon_sym_acq_rel] = ACTIONS(579),
    [anon_sym_seq_cst] = ACTIONS(579),
    [anon_sym_syncscope] = ACTIONS(579),
    [anon_sym_uselistorder] = ACTIONS(581),
    [anon_sym_uselistorder_bb] = ACTIONS(579),
    [anon_sym_module] = ACTIONS(579),
    [anon_sym_attributes] = ACTIONS(579),
  },
  [102] = {
    [ts_builtin_sym_end] = ACTIONS(583),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(583),
    [sym_global_var] = ACTIONS(583),
    [sym_local_var] = ACTIONS(583),
    [aux_sym_metadata_ref_token1] = ACTIONS(583),
    [sym_summary_ref] = ACTIONS(583),
    [sym_string] = ACTIONS(583),
    [anon_sym_target] = ACTIONS(583),
    [anon_sym_source_filename] = ACTIONS(583),
    [anon_sym_declare] = ACTIONS(583),
    [anon_sym_define] = ACTIONS(583),
    [anon_sym_no_cfi] = ACTIONS(583),
    [anon_sym_private] = ACTIONS(583),
    [anon_sym_internal] = ACTIONS(583),
    [anon_sym_weak] = ACTIONS(585),
    [anon_sym_weak_odr] = ACTIONS(583),
    [anon_sym_linkonce] = ACTIONS(585),
    [anon_sym_linkonce_odr] = ACTIONS(583),
    [anon_sym_available_externally] = ACTIONS(583),
    [anon_sym_appending] = ACTIONS(583),
    [anon_sym_common] = ACTIONS(583),
    [anon_sym_extern_weak] = ACTIONS(583),
    [anon_sym_external] = ACTIONS(583),
    [anon_sym_dso_local] = ACTIONS(585),
    [anon_sym_dso_local_equivalent] = ACTIONS(583),
    [anon_sym_dso_preemptable] = ACTIONS(583),
    [anon_sym_default] = ACTIONS(583),
    [anon_sym_hidden] = ACTIONS(583),
    [anon_sym_protected] = ACTIONS(583),
    [anon_sym_dllimport] = ACTIONS(583),
    [anon_sym_dllexport] = ACTIONS(583),
    [anon_sym_ccc] = ACTIONS(583),
    [anon_sym_fastcc] = ACTIONS(583),
    [anon_sym_coldcc] = ACTIONS(583),
    [anon_sym_webkit_jscc] = ACTIONS(585),
    [anon_sym_anyregcc] = ACTIONS(583),
    [anon_sym_preserve_mostcc] = ACTIONS(583),
    [anon_sym_preserve_allcc] = ACTIONS(583),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(585),
    [anon_sym_tailcc] = ACTIONS(583),
    [anon_sym_swiftcc] = ACTIONS(585),
    [anon_sym_swifttailcc] = ACTIONS(585),
    [anon_sym_cfguard_checkcc] = ACTIONS(583),
    [aux_sym_calling_conv_token1] = ACTIONS(585),
    [aux_sym_calling_conv_token2] = ACTIONS(583),
    [aux_sym_calling_conv_token3] = ACTIONS(583),
    [aux_sym_calling_conv_token4] = ACTIONS(583),
    [aux_sym_calling_conv_token5] = ACTIONS(583),
    [aux_sym_calling_conv_token6] = ACTIONS(583),
    [aux_sym_calling_conv_token7] = ACTIONS(583),
    [aux_sym_calling_conv_token8] = ACTIONS(583),
    [aux_sym_calling_conv_token9] = ACTIONS(583),
    [aux_sym_calling_conv_token10] = ACTIONS(585),
    [anon_sym_ghccc] = ACTIONS(583),
    [aux_sym_calling_conv_token11] = ACTIONS(585),
    [aux_sym_calling_conv_token12] = ACTIONS(583),
    [aux_sym_calling_conv_token13] = ACTIONS(585),
    [aux_sym_calling_conv_token14] = ACTIONS(583),
    [anon_sym_cc] = ACTIONS(585),
    [anon_sym_unnamed_addr] = ACTIONS(583),
    [anon_sym_local_unnamed_addr] = ACTIONS(583),
    [anon_sym_void] = ACTIONS(583),
    [anon_sym_half] = ACTIONS(583),
    [anon_sym_bfloat] = ACTIONS(583),
    [anon_sym_float] = ACTIONS(583),
    [anon_sym_double] = ACTIONS(583),
    [anon_sym_x86_fp80] = ACTIONS(585),
    [anon_sym_fp128] = ACTIONS(583),
    [anon_sym_ppc_fp128] = ACTIONS(583),
    [anon_sym_label] = ACTIONS(583),
    [anon_sym_metadata] = ACTIONS(583),
    [anon_sym_x86_mmx] = ACTIONS(585),
    [anon_sym_x86_amx] = ACTIONS(585),
    [anon_sym_token] = ACTIONS(583),
    [anon_sym_opaque] = ACTIONS(583),
    [anon_sym_ptr] = ACTIONS(583),
    [aux_sym_type_keyword_token1] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(583),
    [anon_sym_LT_LBRACE] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(583),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(583),
    [anon_sym_RPAREN] = ACTIONS(583),
    [anon_sym_align] = ACTIONS(585),
    [anon_sym_alignstack] = ACTIONS(583),
    [anon_sym_allocsize] = ACTIONS(583),
    [anon_sym_alwaysinline] = ACTIONS(583),
    [anon_sym_builtin] = ACTIONS(583),
    [anon_sym_cold] = ACTIONS(585),
    [anon_sym_convergent] = ACTIONS(583),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(583),
    [anon_sym_hot] = ACTIONS(583),
    [anon_sym_inaccessiblememonly] = ACTIONS(583),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(583),
    [anon_sym_inlinehint] = ACTIONS(583),
    [anon_sym_jumptable] = ACTIONS(583),
    [anon_sym_minsize] = ACTIONS(583),
    [anon_sym_naked] = ACTIONS(583),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(583),
    [anon_sym_nobuiltin] = ACTIONS(583),
    [anon_sym_noduplicate] = ACTIONS(583),
    [anon_sym_nofree] = ACTIONS(583),
    [anon_sym_noimplicitfloat] = ACTIONS(583),
    [anon_sym_noinline] = ACTIONS(583),
    [anon_sym_nomerge] = ACTIONS(583),
    [anon_sym_nonlazybind] = ACTIONS(583),
    [anon_sym_noprofile] = ACTIONS(583),
    [anon_sym_noredzone] = ACTIONS(583),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(583),
    [anon_sym_noreturn] = ACTIONS(583),
    [anon_sym_norecurse] = ACTIONS(583),
    [anon_sym_willreturn] = ACTIONS(583),
    [anon_sym_nosync] = ACTIONS(583),
    [anon_sym_nounwind] = ACTIONS(583),
    [anon_sym_nocallback] = ACTIONS(583),
    [anon_sym_nosanitize_coverage] = ACTIONS(583),
    [anon_sym_null_pointer_is_valid] = ACTIONS(583),
    [anon_sym_optforfuzzing] = ACTIONS(583),
    [anon_sym_optnone] = ACTIONS(583),
    [anon_sym_optsize] = ACTIONS(583),
    [anon_sym_readnone] = ACTIONS(583),
    [anon_sym_readonly] = ACTIONS(583),
    [anon_sym_writeonly] = ACTIONS(583),
    [anon_sym_argmemonly] = ACTIONS(583),
    [anon_sym_returns_twice] = ACTIONS(583),
    [anon_sym_safestack] = ACTIONS(583),
    [anon_sym_sanitize_address] = ACTIONS(583),
    [anon_sym_sanitize_memory] = ACTIONS(583),
    [anon_sym_sanitize_thread] = ACTIONS(583),
    [anon_sym_sanitize_hwaddress] = ACTIONS(583),
    [anon_sym_sanitize_memtag] = ACTIONS(583),
    [anon_sym_speculative_load_hardening] = ACTIONS(583),
    [anon_sym_speculatable] = ACTIONS(583),
    [anon_sym_ssp] = ACTIONS(585),
    [anon_sym_sspstrong] = ACTIONS(583),
    [anon_sym_sspreq] = ACTIONS(583),
    [anon_sym_strictfp] = ACTIONS(583),
    [anon_sym_nocf_check] = ACTIONS(583),
    [anon_sym_shadowcallstack] = ACTIONS(583),
    [anon_sym_mustprogress] = ACTIONS(583),
    [anon_sym_vscale_range] = ACTIONS(583),
    [anon_sym_preallocated] = ACTIONS(583),
    [anon_sym_zeroext] = ACTIONS(583),
    [anon_sym_signext] = ACTIONS(583),
    [anon_sym_inreg] = ACTIONS(583),
    [anon_sym_byval] = ACTIONS(583),
    [anon_sym_byref] = ACTIONS(583),
    [anon_sym_inalloca] = ACTIONS(583),
    [anon_sym_sret] = ACTIONS(583),
    [anon_sym_elementtype] = ACTIONS(583),
    [anon_sym_noalias] = ACTIONS(583),
    [anon_sym_nocapture] = ACTIONS(583),
    [anon_sym_nest] = ACTIONS(583),
    [anon_sym_returned] = ACTIONS(583),
    [anon_sym_nonnull] = ACTIONS(583),
    [anon_sym_dereferenceable] = ACTIONS(585),
    [anon_sym_dereferenceable_or_null] = ACTIONS(583),
    [anon_sym_swiftself] = ACTIONS(585),
    [anon_sym_swiftasync] = ACTIONS(585),
    [anon_sym_swifterror] = ACTIONS(585),
    [anon_sym_immarg] = ACTIONS(583),
    [anon_sym_noundef] = ACTIONS(583),
    [anon_sym_uwtable] = ACTIONS(583),
    [anon_sym_memory] = ACTIONS(583),
    [anon_sym_to] = ACTIONS(585),
    [anon_sym_unwind] = ACTIONS(583),
    [anon_sym_unordered] = ACTIONS(583),
    [anon_sym_monotonic] = ACTIONS(583),
    [anon_sym_acquire] = ACTIONS(583),
    [anon_sym_release] = ACTIONS(583),
    [anon_sym_acq_rel] = ACTIONS(583),
    [anon_sym_seq_cst] = ACTIONS(583),
    [anon_sym_syncscope] = ACTIONS(583),
    [anon_sym_uselistorder] = ACTIONS(585),
    [anon_sym_uselistorder_bb] = ACTIONS(583),
    [anon_sym_module] = ACTIONS(583),
    [anon_sym_attributes] = ACTIONS(583),
  },
  [103] = {
    [ts_builtin_sym_end] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(587),
    [sym_global_var] = ACTIONS(587),
    [sym_local_var] = ACTIONS(587),
    [aux_sym_metadata_ref_token1] = ACTIONS(587),
    [sym_summary_ref] = ACTIONS(587),
    [sym_string] = ACTIONS(587),
    [anon_sym_target] = ACTIONS(587),
    [anon_sym_source_filename] = ACTIONS(587),
    [anon_sym_declare] = ACTIONS(587),
    [anon_sym_define] = ACTIONS(587),
    [anon_sym_no_cfi] = ACTIONS(587),
    [anon_sym_private] = ACTIONS(587),
    [anon_sym_internal] = ACTIONS(587),
    [anon_sym_weak] = ACTIONS(589),
    [anon_sym_weak_odr] = ACTIONS(587),
    [anon_sym_linkonce] = ACTIONS(589),
    [anon_sym_linkonce_odr] = ACTIONS(587),
    [anon_sym_available_externally] = ACTIONS(587),
    [anon_sym_appending] = ACTIONS(587),
    [anon_sym_common] = ACTIONS(587),
    [anon_sym_extern_weak] = ACTIONS(587),
    [anon_sym_external] = ACTIONS(587),
    [anon_sym_dso_local] = ACTIONS(589),
    [anon_sym_dso_local_equivalent] = ACTIONS(587),
    [anon_sym_dso_preemptable] = ACTIONS(587),
    [anon_sym_default] = ACTIONS(587),
    [anon_sym_hidden] = ACTIONS(587),
    [anon_sym_protected] = ACTIONS(587),
    [anon_sym_dllimport] = ACTIONS(587),
    [anon_sym_dllexport] = ACTIONS(587),
    [anon_sym_ccc] = ACTIONS(587),
    [anon_sym_fastcc] = ACTIONS(587),
    [anon_sym_coldcc] = ACTIONS(587),
    [anon_sym_webkit_jscc] = ACTIONS(589),
    [anon_sym_anyregcc] = ACTIONS(587),
    [anon_sym_preserve_mostcc] = ACTIONS(587),
    [anon_sym_preserve_allcc] = ACTIONS(587),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(589),
    [anon_sym_tailcc] = ACTIONS(587),
    [anon_sym_swiftcc] = ACTIONS(589),
    [anon_sym_swifttailcc] = ACTIONS(589),
    [anon_sym_cfguard_checkcc] = ACTIONS(587),
    [aux_sym_calling_conv_token1] = ACTIONS(589),
    [aux_sym_calling_conv_token2] = ACTIONS(587),
    [aux_sym_calling_conv_token3] = ACTIONS(587),
    [aux_sym_calling_conv_token4] = ACTIONS(587),
    [aux_sym_calling_conv_token5] = ACTIONS(587),
    [aux_sym_calling_conv_token6] = ACTIONS(587),
    [aux_sym_calling_conv_token7] = ACTIONS(587),
    [aux_sym_calling_conv_token8] = ACTIONS(587),
    [aux_sym_calling_conv_token9] = ACTIONS(587),
    [aux_sym_calling_conv_token10] = ACTIONS(589),
    [anon_sym_ghccc] = ACTIONS(587),
    [aux_sym_calling_conv_token11] = ACTIONS(589),
    [aux_sym_calling_conv_token12] = ACTIONS(587),
    [aux_sym_calling_conv_token13] = ACTIONS(589),
    [aux_sym_calling_conv_token14] = ACTIONS(587),
    [anon_sym_cc] = ACTIONS(589),
    [anon_sym_unnamed_addr] = ACTIONS(587),
    [anon_sym_local_unnamed_addr] = ACTIONS(587),
    [anon_sym_void] = ACTIONS(587),
    [anon_sym_half] = ACTIONS(587),
    [anon_sym_bfloat] = ACTIONS(587),
    [anon_sym_float] = ACTIONS(587),
    [anon_sym_double] = ACTIONS(587),
    [anon_sym_x86_fp80] = ACTIONS(589),
    [anon_sym_fp128] = ACTIONS(587),
    [anon_sym_ppc_fp128] = ACTIONS(587),
    [anon_sym_label] = ACTIONS(587),
    [anon_sym_metadata] = ACTIONS(587),
    [anon_sym_x86_mmx] = ACTIONS(589),
    [anon_sym_x86_amx] = ACTIONS(589),
    [anon_sym_token] = ACTIONS(587),
    [anon_sym_opaque] = ACTIONS(587),
    [anon_sym_ptr] = ACTIONS(587),
    [aux_sym_type_keyword_token1] = ACTIONS(587),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_RBRACE] = ACTIONS(587),
    [anon_sym_LT_LBRACE] = ACTIONS(587),
    [anon_sym_LBRACK] = ACTIONS(587),
    [anon_sym_RBRACK] = ACTIONS(587),
    [anon_sym_LT] = ACTIONS(589),
    [anon_sym_GT] = ACTIONS(587),
    [anon_sym_COMMA] = ACTIONS(587),
    [anon_sym_LPAREN] = ACTIONS(587),
    [anon_sym_RPAREN] = ACTIONS(587),
    [anon_sym_align] = ACTIONS(589),
    [anon_sym_alignstack] = ACTIONS(587),
    [anon_sym_allocsize] = ACTIONS(587),
    [anon_sym_alwaysinline] = ACTIONS(587),
    [anon_sym_builtin] = ACTIONS(587),
    [anon_sym_cold] = ACTIONS(589),
    [anon_sym_convergent] = ACTIONS(587),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(587),
    [anon_sym_hot] = ACTIONS(587),
    [anon_sym_inaccessiblememonly] = ACTIONS(587),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(587),
    [anon_sym_inlinehint] = ACTIONS(587),
    [anon_sym_jumptable] = ACTIONS(587),
    [anon_sym_minsize] = ACTIONS(587),
    [anon_sym_naked] = ACTIONS(587),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(587),
    [anon_sym_nobuiltin] = ACTIONS(587),
    [anon_sym_noduplicate] = ACTIONS(587),
    [anon_sym_nofree] = ACTIONS(587),
    [anon_sym_noimplicitfloat] = ACTIONS(587),
    [anon_sym_noinline] = ACTIONS(587),
    [anon_sym_nomerge] = ACTIONS(587),
    [anon_sym_nonlazybind] = ACTIONS(587),
    [anon_sym_noprofile] = ACTIONS(587),
    [anon_sym_noredzone] = ACTIONS(587),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(587),
    [anon_sym_noreturn] = ACTIONS(587),
    [anon_sym_norecurse] = ACTIONS(587),
    [anon_sym_willreturn] = ACTIONS(587),
    [anon_sym_nosync] = ACTIONS(587),
    [anon_sym_nounwind] = ACTIONS(587),
    [anon_sym_nocallback] = ACTIONS(587),
    [anon_sym_nosanitize_coverage] = ACTIONS(587),
    [anon_sym_null_pointer_is_valid] = ACTIONS(587),
    [anon_sym_optforfuzzing] = ACTIONS(587),
    [anon_sym_optnone] = ACTIONS(587),
    [anon_sym_optsize] = ACTIONS(587),
    [anon_sym_readnone] = ACTIONS(587),
    [anon_sym_readonly] = ACTIONS(587),
    [anon_sym_writeonly] = ACTIONS(587),
    [anon_sym_argmemonly] = ACTIONS(587),
    [anon_sym_returns_twice] = ACTIONS(587),
    [anon_sym_safestack] = ACTIONS(587),
    [anon_sym_sanitize_address] = ACTIONS(587),
    [anon_sym_sanitize_memory] = ACTIONS(587),
    [anon_sym_sanitize_thread] = ACTIONS(587),
    [anon_sym_sanitize_hwaddress] = ACTIONS(587),
    [anon_sym_sanitize_memtag] = ACTIONS(587),
    [anon_sym_speculative_load_hardening] = ACTIONS(587),
    [anon_sym_speculatable] = ACTIONS(587),
    [anon_sym_ssp] = ACTIONS(589),
    [anon_sym_sspstrong] = ACTIONS(587),
    [anon_sym_sspreq] = ACTIONS(587),
    [anon_sym_strictfp] = ACTIONS(587),
    [anon_sym_nocf_check] = ACTIONS(587),
    [anon_sym_shadowcallstack] = ACTIONS(587),
    [anon_sym_mustprogress] = ACTIONS(587),
    [anon_sym_vscale_range] = ACTIONS(587),
    [anon_sym_preallocated] = ACTIONS(587),
    [anon_sym_zeroext] = ACTIONS(587),
    [anon_sym_signext] = ACTIONS(587),
    [anon_sym_inreg] = ACTIONS(587),
    [anon_sym_byval] = ACTIONS(587),
    [anon_sym_byref] = ACTIONS(587),
    [anon_sym_inalloca] = ACTIONS(587),
    [anon_sym_sret] = ACTIONS(587),
    [anon_sym_elementtype] = ACTIONS(587),
    [anon_sym_noalias] = ACTIONS(587),
    [anon_sym_nocapture] = ACTIONS(587),
    [anon_sym_nest] = ACTIONS(587),
    [anon_sym_returned] = ACTIONS(587),
    [anon_sym_nonnull] = ACTIONS(587),
    [anon_sym_dereferenceable] = ACTIONS(589),
    [anon_sym_dereferenceable_or_null] = ACTIONS(587),
    [anon_sym_swiftself] = ACTIONS(589),
    [anon_sym_swiftasync] = ACTIONS(589),
    [anon_sym_swifterror] = ACTIONS(589),
    [anon_sym_immarg] = ACTIONS(587),
    [anon_sym_noundef] = ACTIONS(587),
    [anon_sym_uwtable] = ACTIONS(587),
    [anon_sym_memory] = ACTIONS(587),
    [anon_sym_to] = ACTIONS(589),
    [anon_sym_unwind] = ACTIONS(587),
    [anon_sym_unordered] = ACTIONS(587),
    [anon_sym_monotonic] = ACTIONS(587),
    [anon_sym_acquire] = ACTIONS(587),
    [anon_sym_release] = ACTIONS(587),
    [anon_sym_acq_rel] = ACTIONS(587),
    [anon_sym_seq_cst] = ACTIONS(587),
    [anon_sym_syncscope] = ACTIONS(587),
    [anon_sym_uselistorder] = ACTIONS(589),
    [anon_sym_uselistorder_bb] = ACTIONS(587),
    [anon_sym_module] = ACTIONS(587),
    [anon_sym_attributes] = ACTIONS(587),
  },
  [104] = {
    [ts_builtin_sym_end] = ACTIONS(591),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(591),
    [sym_global_var] = ACTIONS(591),
    [sym_local_var] = ACTIONS(591),
    [aux_sym_metadata_ref_token1] = ACTIONS(591),
    [sym_summary_ref] = ACTIONS(591),
    [sym_string] = ACTIONS(591),
    [anon_sym_target] = ACTIONS(591),
    [anon_sym_source_filename] = ACTIONS(591),
    [anon_sym_declare] = ACTIONS(591),
    [anon_sym_define] = ACTIONS(591),
    [anon_sym_no_cfi] = ACTIONS(591),
    [anon_sym_private] = ACTIONS(591),
    [anon_sym_internal] = ACTIONS(591),
    [anon_sym_weak] = ACTIONS(593),
    [anon_sym_weak_odr] = ACTIONS(591),
    [anon_sym_linkonce] = ACTIONS(593),
    [anon_sym_linkonce_odr] = ACTIONS(591),
    [anon_sym_available_externally] = ACTIONS(591),
    [anon_sym_appending] = ACTIONS(591),
    [anon_sym_common] = ACTIONS(591),
    [anon_sym_extern_weak] = ACTIONS(591),
    [anon_sym_external] = ACTIONS(591),
    [anon_sym_dso_local] = ACTIONS(593),
    [anon_sym_dso_local_equivalent] = ACTIONS(591),
    [anon_sym_dso_preemptable] = ACTIONS(591),
    [anon_sym_default] = ACTIONS(591),
    [anon_sym_hidden] = ACTIONS(591),
    [anon_sym_protected] = ACTIONS(591),
    [anon_sym_dllimport] = ACTIONS(591),
    [anon_sym_dllexport] = ACTIONS(591),
    [anon_sym_ccc] = ACTIONS(591),
    [anon_sym_fastcc] = ACTIONS(591),
    [anon_sym_coldcc] = ACTIONS(591),
    [anon_sym_webkit_jscc] = ACTIONS(593),
    [anon_sym_anyregcc] = ACTIONS(591),
    [anon_sym_preserve_mostcc] = ACTIONS(591),
    [anon_sym_preserve_allcc] = ACTIONS(591),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(593),
    [anon_sym_tailcc] = ACTIONS(591),
    [anon_sym_swiftcc] = ACTIONS(593),
    [anon_sym_swifttailcc] = ACTIONS(593),
    [anon_sym_cfguard_checkcc] = ACTIONS(591),
    [aux_sym_calling_conv_token1] = ACTIONS(593),
    [aux_sym_calling_conv_token2] = ACTIONS(591),
    [aux_sym_calling_conv_token3] = ACTIONS(591),
    [aux_sym_calling_conv_token4] = ACTIONS(591),
    [aux_sym_calling_conv_token5] = ACTIONS(591),
    [aux_sym_calling_conv_token6] = ACTIONS(591),
    [aux_sym_calling_conv_token7] = ACTIONS(591),
    [aux_sym_calling_conv_token8] = ACTIONS(591),
    [aux_sym_calling_conv_token9] = ACTIONS(591),
    [aux_sym_calling_conv_token10] = ACTIONS(593),
    [anon_sym_ghccc] = ACTIONS(591),
    [aux_sym_calling_conv_token11] = ACTIONS(593),
    [aux_sym_calling_conv_token12] = ACTIONS(591),
    [aux_sym_calling_conv_token13] = ACTIONS(593),
    [aux_sym_calling_conv_token14] = ACTIONS(591),
    [anon_sym_cc] = ACTIONS(593),
    [anon_sym_unnamed_addr] = ACTIONS(591),
    [anon_sym_local_unnamed_addr] = ACTIONS(591),
    [anon_sym_void] = ACTIONS(591),
    [anon_sym_half] = ACTIONS(591),
    [anon_sym_bfloat] = ACTIONS(591),
    [anon_sym_float] = ACTIONS(591),
    [anon_sym_double] = ACTIONS(591),
    [anon_sym_x86_fp80] = ACTIONS(593),
    [anon_sym_fp128] = ACTIONS(591),
    [anon_sym_ppc_fp128] = ACTIONS(591),
    [anon_sym_label] = ACTIONS(591),
    [anon_sym_metadata] = ACTIONS(591),
    [anon_sym_x86_mmx] = ACTIONS(593),
    [anon_sym_x86_amx] = ACTIONS(593),
    [anon_sym_token] = ACTIONS(591),
    [anon_sym_opaque] = ACTIONS(591),
    [anon_sym_ptr] = ACTIONS(591),
    [aux_sym_type_keyword_token1] = ACTIONS(591),
    [anon_sym_LBRACE] = ACTIONS(591),
    [anon_sym_RBRACE] = ACTIONS(591),
    [anon_sym_LT_LBRACE] = ACTIONS(591),
    [anon_sym_LBRACK] = ACTIONS(591),
    [anon_sym_RBRACK] = ACTIONS(591),
    [anon_sym_LT] = ACTIONS(593),
    [anon_sym_GT] = ACTIONS(591),
    [anon_sym_COMMA] = ACTIONS(591),
    [anon_sym_LPAREN] = ACTIONS(591),
    [anon_sym_RPAREN] = ACTIONS(591),
    [anon_sym_align] = ACTIONS(593),
    [anon_sym_alignstack] = ACTIONS(591),
    [anon_sym_allocsize] = ACTIONS(591),
    [anon_sym_alwaysinline] = ACTIONS(591),
    [anon_sym_builtin] = ACTIONS(591),
    [anon_sym_cold] = ACTIONS(593),
    [anon_sym_convergent] = ACTIONS(591),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(591),
    [anon_sym_hot] = ACTIONS(591),
    [anon_sym_inaccessiblememonly] = ACTIONS(591),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(591),
    [anon_sym_inlinehint] = ACTIONS(591),
    [anon_sym_jumptable] = ACTIONS(591),
    [anon_sym_minsize] = ACTIONS(591),
    [anon_sym_naked] = ACTIONS(591),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(591),
    [anon_sym_nobuiltin] = ACTIONS(591),
    [anon_sym_noduplicate] = ACTIONS(591),
    [anon_sym_nofree] = ACTIONS(591),
    [anon_sym_noimplicitfloat] = ACTIONS(591),
    [anon_sym_noinline] = ACTIONS(591),
    [anon_sym_nomerge] = ACTIONS(591),
    [anon_sym_nonlazybind] = ACTIONS(591),
    [anon_sym_noprofile] = ACTIONS(591),
    [anon_sym_noredzone] = ACTIONS(591),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(591),
    [anon_sym_noreturn] = ACTIONS(591),
    [anon_sym_norecurse] = ACTIONS(591),
    [anon_sym_willreturn] = ACTIONS(591),
    [anon_sym_nosync] = ACTIONS(591),
    [anon_sym_nounwind] = ACTIONS(591),
    [anon_sym_nocallback] = ACTIONS(591),
    [anon_sym_nosanitize_coverage] = ACTIONS(591),
    [anon_sym_null_pointer_is_valid] = ACTIONS(591),
    [anon_sym_optforfuzzing] = ACTIONS(591),
    [anon_sym_optnone] = ACTIONS(591),
    [anon_sym_optsize] = ACTIONS(591),
    [anon_sym_readnone] = ACTIONS(591),
    [anon_sym_readonly] = ACTIONS(591),
    [anon_sym_writeonly] = ACTIONS(591),
    [anon_sym_argmemonly] = ACTIONS(591),
    [anon_sym_returns_twice] = ACTIONS(591),
    [anon_sym_safestack] = ACTIONS(591),
    [anon_sym_sanitize_address] = ACTIONS(591),
    [anon_sym_sanitize_memory] = ACTIONS(591),
    [anon_sym_sanitize_thread] = ACTIONS(591),
    [anon_sym_sanitize_hwaddress] = ACTIONS(591),
    [anon_sym_sanitize_memtag] = ACTIONS(591),
    [anon_sym_speculative_load_hardening] = ACTIONS(591),
    [anon_sym_speculatable] = ACTIONS(591),
    [anon_sym_ssp] = ACTIONS(593),
    [anon_sym_sspstrong] = ACTIONS(591),
    [anon_sym_sspreq] = ACTIONS(591),
    [anon_sym_strictfp] = ACTIONS(591),
    [anon_sym_nocf_check] = ACTIONS(591),
    [anon_sym_shadowcallstack] = ACTIONS(591),
    [anon_sym_mustprogress] = ACTIONS(591),
    [anon_sym_vscale_range] = ACTIONS(591),
    [anon_sym_preallocated] = ACTIONS(591),
    [anon_sym_zeroext] = ACTIONS(591),
    [anon_sym_signext] = ACTIONS(591),
    [anon_sym_inreg] = ACTIONS(591),
    [anon_sym_byval] = ACTIONS(591),
    [anon_sym_byref] = ACTIONS(591),
    [anon_sym_inalloca] = ACTIONS(591),
    [anon_sym_sret] = ACTIONS(591),
    [anon_sym_elementtype] = ACTIONS(591),
    [anon_sym_noalias] = ACTIONS(591),
    [anon_sym_nocapture] = ACTIONS(591),
    [anon_sym_nest] = ACTIONS(591),
    [anon_sym_returned] = ACTIONS(591),
    [anon_sym_nonnull] = ACTIONS(591),
    [anon_sym_dereferenceable] = ACTIONS(593),
    [anon_sym_dereferenceable_or_null] = ACTIONS(591),
    [anon_sym_swiftself] = ACTIONS(593),
    [anon_sym_swiftasync] = ACTIONS(593),
    [anon_sym_swifterror] = ACTIONS(593),
    [anon_sym_immarg] = ACTIONS(591),
    [anon_sym_noundef] = ACTIONS(591),
    [anon_sym_uwtable] = ACTIONS(591),
    [anon_sym_memory] = ACTIONS(591),
    [anon_sym_to] = ACTIONS(593),
    [anon_sym_unwind] = ACTIONS(591),
    [anon_sym_unordered] = ACTIONS(591),
    [anon_sym_monotonic] = ACTIONS(591),
    [anon_sym_acquire] = ACTIONS(591),
    [anon_sym_release] = ACTIONS(591),
    [anon_sym_acq_rel] = ACTIONS(591),
    [anon_sym_seq_cst] = ACTIONS(591),
    [anon_sym_syncscope] = ACTIONS(591),
    [anon_sym_uselistorder] = ACTIONS(593),
    [anon_sym_uselistorder_bb] = ACTIONS(591),
    [anon_sym_module] = ACTIONS(591),
    [anon_sym_attributes] = ACTIONS(591),
  },
  [105] = {
    [ts_builtin_sym_end] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(595),
    [sym_global_var] = ACTIONS(595),
    [sym_local_var] = ACTIONS(595),
    [aux_sym_metadata_ref_token1] = ACTIONS(595),
    [sym_summary_ref] = ACTIONS(595),
    [sym_string] = ACTIONS(595),
    [anon_sym_target] = ACTIONS(595),
    [anon_sym_source_filename] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_define] = ACTIONS(595),
    [anon_sym_no_cfi] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_internal] = ACTIONS(595),
    [anon_sym_weak] = ACTIONS(597),
    [anon_sym_weak_odr] = ACTIONS(595),
    [anon_sym_linkonce] = ACTIONS(597),
    [anon_sym_linkonce_odr] = ACTIONS(595),
    [anon_sym_available_externally] = ACTIONS(595),
    [anon_sym_appending] = ACTIONS(595),
    [anon_sym_common] = ACTIONS(595),
    [anon_sym_extern_weak] = ACTIONS(595),
    [anon_sym_external] = ACTIONS(595),
    [anon_sym_dso_local] = ACTIONS(597),
    [anon_sym_dso_local_equivalent] = ACTIONS(595),
    [anon_sym_dso_preemptable] = ACTIONS(595),
    [anon_sym_default] = ACTIONS(595),
    [anon_sym_hidden] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_dllimport] = ACTIONS(595),
    [anon_sym_dllexport] = ACTIONS(595),
    [anon_sym_ccc] = ACTIONS(595),
    [anon_sym_fastcc] = ACTIONS(595),
    [anon_sym_coldcc] = ACTIONS(595),
    [anon_sym_webkit_jscc] = ACTIONS(597),
    [anon_sym_anyregcc] = ACTIONS(595),
    [anon_sym_preserve_mostcc] = ACTIONS(595),
    [anon_sym_preserve_allcc] = ACTIONS(595),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(597),
    [anon_sym_tailcc] = ACTIONS(595),
    [anon_sym_swiftcc] = ACTIONS(597),
    [anon_sym_swifttailcc] = ACTIONS(597),
    [anon_sym_cfguard_checkcc] = ACTIONS(595),
    [aux_sym_calling_conv_token1] = ACTIONS(597),
    [aux_sym_calling_conv_token2] = ACTIONS(595),
    [aux_sym_calling_conv_token3] = ACTIONS(595),
    [aux_sym_calling_conv_token4] = ACTIONS(595),
    [aux_sym_calling_conv_token5] = ACTIONS(595),
    [aux_sym_calling_conv_token6] = ACTIONS(595),
    [aux_sym_calling_conv_token7] = ACTIONS(595),
    [aux_sym_calling_conv_token8] = ACTIONS(595),
    [aux_sym_calling_conv_token9] = ACTIONS(595),
    [aux_sym_calling_conv_token10] = ACTIONS(597),
    [anon_sym_ghccc] = ACTIONS(595),
    [aux_sym_calling_conv_token11] = ACTIONS(597),
    [aux_sym_calling_conv_token12] = ACTIONS(595),
    [aux_sym_calling_conv_token13] = ACTIONS(597),
    [aux_sym_calling_conv_token14] = ACTIONS(595),
    [anon_sym_cc] = ACTIONS(597),
    [anon_sym_unnamed_addr] = ACTIONS(595),
    [anon_sym_local_unnamed_addr] = ACTIONS(595),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_half] = ACTIONS(595),
    [anon_sym_bfloat] = ACTIONS(595),
    [anon_sym_float] = ACTIONS(595),
    [anon_sym_double] = ACTIONS(595),
    [anon_sym_x86_fp80] = ACTIONS(597),
    [anon_sym_fp128] = ACTIONS(595),
    [anon_sym_ppc_fp128] = ACTIONS(595),
    [anon_sym_label] = ACTIONS(595),
    [anon_sym_metadata] = ACTIONS(595),
    [anon_sym_x86_mmx] = ACTIONS(597),
    [anon_sym_x86_amx] = ACTIONS(597),
    [anon_sym_token] = ACTIONS(595),
    [anon_sym_opaque] = ACTIONS(595),
    [anon_sym_ptr] = ACTIONS(595),
    [aux_sym_type_keyword_token1] = ACTIONS(595),
    [anon_sym_LBRACE] = ACTIONS(595),
    [anon_sym_RBRACE] = ACTIONS(595),
    [anon_sym_LT_LBRACE] = ACTIONS(595),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_RBRACK] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_GT] = ACTIONS(595),
    [anon_sym_COMMA] = ACTIONS(595),
    [anon_sym_LPAREN] = ACTIONS(595),
    [anon_sym_RPAREN] = ACTIONS(595),
    [anon_sym_align] = ACTIONS(597),
    [anon_sym_alignstack] = ACTIONS(595),
    [anon_sym_allocsize] = ACTIONS(595),
    [anon_sym_alwaysinline] = ACTIONS(595),
    [anon_sym_builtin] = ACTIONS(595),
    [anon_sym_cold] = ACTIONS(597),
    [anon_sym_convergent] = ACTIONS(595),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(595),
    [anon_sym_hot] = ACTIONS(595),
    [anon_sym_inaccessiblememonly] = ACTIONS(595),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(595),
    [anon_sym_inlinehint] = ACTIONS(595),
    [anon_sym_jumptable] = ACTIONS(595),
    [anon_sym_minsize] = ACTIONS(595),
    [anon_sym_naked] = ACTIONS(595),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(595),
    [anon_sym_nobuiltin] = ACTIONS(595),
    [anon_sym_noduplicate] = ACTIONS(595),
    [anon_sym_nofree] = ACTIONS(595),
    [anon_sym_noimplicitfloat] = ACTIONS(595),
    [anon_sym_noinline] = ACTIONS(595),
    [anon_sym_nomerge] = ACTIONS(595),
    [anon_sym_nonlazybind] = ACTIONS(595),
    [anon_sym_noprofile] = ACTIONS(595),
    [anon_sym_noredzone] = ACTIONS(595),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(595),
    [anon_sym_noreturn] = ACTIONS(595),
    [anon_sym_norecurse] = ACTIONS(595),
    [anon_sym_willreturn] = ACTIONS(595),
    [anon_sym_nosync] = ACTIONS(595),
    [anon_sym_nounwind] = ACTIONS(595),
    [anon_sym_nocallback] = ACTIONS(595),
    [anon_sym_nosanitize_coverage] = ACTIONS(595),
    [anon_sym_null_pointer_is_valid] = ACTIONS(595),
    [anon_sym_optforfuzzing] = ACTIONS(595),
    [anon_sym_optnone] = ACTIONS(595),
    [anon_sym_optsize] = ACTIONS(595),
    [anon_sym_readnone] = ACTIONS(595),
    [anon_sym_readonly] = ACTIONS(595),
    [anon_sym_writeonly] = ACTIONS(595),
    [anon_sym_argmemonly] = ACTIONS(595),
    [anon_sym_returns_twice] = ACTIONS(595),
    [anon_sym_safestack] = ACTIONS(595),
    [anon_sym_sanitize_address] = ACTIONS(595),
    [anon_sym_sanitize_memory] = ACTIONS(595),
    [anon_sym_sanitize_thread] = ACTIONS(595),
    [anon_sym_sanitize_hwaddress] = ACTIONS(595),
    [anon_sym_sanitize_memtag] = ACTIONS(595),
    [anon_sym_speculative_load_hardening] = ACTIONS(595),
    [anon_sym_speculatable] = ACTIONS(595),
    [anon_sym_ssp] = ACTIONS(597),
    [anon_sym_sspstrong] = ACTIONS(595),
    [anon_sym_sspreq] = ACTIONS(595),
    [anon_sym_strictfp] = ACTIONS(595),
    [anon_sym_nocf_check] = ACTIONS(595),
    [anon_sym_shadowcallstack] = ACTIONS(595),
    [anon_sym_mustprogress] = ACTIONS(595),
    [anon_sym_vscale_range] = ACTIONS(595),
    [anon_sym_preallocated] = ACTIONS(595),
    [anon_sym_zeroext] = ACTIONS(595),
    [anon_sym_signext] = ACTIONS(595),
    [anon_sym_inreg] = ACTIONS(595),
    [anon_sym_byval] = ACTIONS(595),
    [anon_sym_byref] = ACTIONS(595),
    [anon_sym_inalloca] = ACTIONS(595),
    [anon_sym_sret] = ACTIONS(595),
    [anon_sym_elementtype] = ACTIONS(595),
    [anon_sym_noalias] = ACTIONS(595),
    [anon_sym_nocapture] = ACTIONS(595),
    [anon_sym_nest] = ACTIONS(595),
    [anon_sym_returned] = ACTIONS(595),
    [anon_sym_nonnull] = ACTIONS(595),
    [anon_sym_dereferenceable] = ACTIONS(597),
    [anon_sym_dereferenceable_or_null] = ACTIONS(595),
    [anon_sym_swiftself] = ACTIONS(597),
    [anon_sym_swiftasync] = ACTIONS(597),
    [anon_sym_swifterror] = ACTIONS(597),
    [anon_sym_immarg] = ACTIONS(595),
    [anon_sym_noundef] = ACTIONS(595),
    [anon_sym_uwtable] = ACTIONS(595),
    [anon_sym_memory] = ACTIONS(595),
    [anon_sym_to] = ACTIONS(597),
    [anon_sym_unwind] = ACTIONS(595),
    [anon_sym_unordered] = ACTIONS(595),
    [anon_sym_monotonic] = ACTIONS(595),
    [anon_sym_acquire] = ACTIONS(595),
    [anon_sym_release] = ACTIONS(595),
    [anon_sym_acq_rel] = ACTIONS(595),
    [anon_sym_seq_cst] = ACTIONS(595),
    [anon_sym_syncscope] = ACTIONS(595),
    [anon_sym_uselistorder] = ACTIONS(597),
    [anon_sym_uselistorder_bb] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_attributes] = ACTIONS(595),
  },
  [106] = {
    [ts_builtin_sym_end] = ACTIONS(599),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(599),
    [sym_global_var] = ACTIONS(599),
    [sym_local_var] = ACTIONS(599),
    [aux_sym_metadata_ref_token1] = ACTIONS(599),
    [sym_summary_ref] = ACTIONS(599),
    [sym_string] = ACTIONS(599),
    [anon_sym_target] = ACTIONS(599),
    [anon_sym_source_filename] = ACTIONS(599),
    [anon_sym_declare] = ACTIONS(599),
    [anon_sym_define] = ACTIONS(599),
    [anon_sym_no_cfi] = ACTIONS(599),
    [anon_sym_private] = ACTIONS(599),
    [anon_sym_internal] = ACTIONS(599),
    [anon_sym_weak] = ACTIONS(601),
    [anon_sym_weak_odr] = ACTIONS(599),
    [anon_sym_linkonce] = ACTIONS(601),
    [anon_sym_linkonce_odr] = ACTIONS(599),
    [anon_sym_available_externally] = ACTIONS(599),
    [anon_sym_appending] = ACTIONS(599),
    [anon_sym_common] = ACTIONS(599),
    [anon_sym_extern_weak] = ACTIONS(599),
    [anon_sym_external] = ACTIONS(599),
    [anon_sym_dso_local] = ACTIONS(601),
    [anon_sym_dso_local_equivalent] = ACTIONS(599),
    [anon_sym_dso_preemptable] = ACTIONS(599),
    [anon_sym_default] = ACTIONS(599),
    [anon_sym_hidden] = ACTIONS(599),
    [anon_sym_protected] = ACTIONS(599),
    [anon_sym_dllimport] = ACTIONS(599),
    [anon_sym_dllexport] = ACTIONS(599),
    [anon_sym_ccc] = ACTIONS(599),
    [anon_sym_fastcc] = ACTIONS(599),
    [anon_sym_coldcc] = ACTIONS(599),
    [anon_sym_webkit_jscc] = ACTIONS(601),
    [anon_sym_anyregcc] = ACTIONS(599),
    [anon_sym_preserve_mostcc] = ACTIONS(599),
    [anon_sym_preserve_allcc] = ACTIONS(599),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(601),
    [anon_sym_tailcc] = ACTIONS(599),
    [anon_sym_swiftcc] = ACTIONS(601),
    [anon_sym_swifttailcc] = ACTIONS(601),
    [anon_sym_cfguard_checkcc] = ACTIONS(599),
    [aux_sym_calling_conv_token1] = ACTIONS(601),
    [aux_sym_calling_conv_token2] = ACTIONS(599),
    [aux_sym_calling_conv_token3] = ACTIONS(599),
    [aux_sym_calling_conv_token4] = ACTIONS(599),
    [aux_sym_calling_conv_token5] = ACTIONS(599),
    [aux_sym_calling_conv_token6] = ACTIONS(599),
    [aux_sym_calling_conv_token7] = ACTIONS(599),
    [aux_sym_calling_conv_token8] = ACTIONS(599),
    [aux_sym_calling_conv_token9] = ACTIONS(599),
    [aux_sym_calling_conv_token10] = ACTIONS(601),
    [anon_sym_ghccc] = ACTIONS(599),
    [aux_sym_calling_conv_token11] = ACTIONS(601),
    [aux_sym_calling_conv_token12] = ACTIONS(599),
    [aux_sym_calling_conv_token13] = ACTIONS(601),
    [aux_sym_calling_conv_token14] = ACTIONS(599),
    [anon_sym_cc] = ACTIONS(601),
    [anon_sym_unnamed_addr] = ACTIONS(599),
    [anon_sym_local_unnamed_addr] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(599),
    [anon_sym_half] = ACTIONS(599),
    [anon_sym_bfloat] = ACTIONS(599),
    [anon_sym_float] = ACTIONS(599),
    [anon_sym_double] = ACTIONS(599),
    [anon_sym_x86_fp80] = ACTIONS(601),
    [anon_sym_fp128] = ACTIONS(599),
    [anon_sym_ppc_fp128] = ACTIONS(599),
    [anon_sym_label] = ACTIONS(599),
    [anon_sym_metadata] = ACTIONS(599),
    [anon_sym_x86_mmx] = ACTIONS(601),
    [anon_sym_x86_amx] = ACTIONS(601),
    [anon_sym_token] = ACTIONS(599),
    [anon_sym_opaque] = ACTIONS(599),
    [anon_sym_ptr] = ACTIONS(599),
    [aux_sym_type_keyword_token1] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(599),
    [anon_sym_RBRACE] = ACTIONS(599),
    [anon_sym_LT_LBRACE] = ACTIONS(599),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_RBRACK] = ACTIONS(599),
    [anon_sym_LT] = ACTIONS(601),
    [anon_sym_GT] = ACTIONS(599),
    [anon_sym_COMMA] = ACTIONS(599),
    [anon_sym_LPAREN] = ACTIONS(599),
    [anon_sym_RPAREN] = ACTIONS(599),
    [anon_sym_align] = ACTIONS(601),
    [anon_sym_alignstack] = ACTIONS(599),
    [anon_sym_allocsize] = ACTIONS(599),
    [anon_sym_alwaysinline] = ACTIONS(599),
    [anon_sym_builtin] = ACTIONS(599),
    [anon_sym_cold] = ACTIONS(601),
    [anon_sym_convergent] = ACTIONS(599),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(599),
    [anon_sym_hot] = ACTIONS(599),
    [anon_sym_inaccessiblememonly] = ACTIONS(599),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(599),
    [anon_sym_inlinehint] = ACTIONS(599),
    [anon_sym_jumptable] = ACTIONS(599),
    [anon_sym_minsize] = ACTIONS(599),
    [anon_sym_naked] = ACTIONS(599),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(599),
    [anon_sym_nobuiltin] = ACTIONS(599),
    [anon_sym_noduplicate] = ACTIONS(599),
    [anon_sym_nofree] = ACTIONS(599),
    [anon_sym_noimplicitfloat] = ACTIONS(599),
    [anon_sym_noinline] = ACTIONS(599),
    [anon_sym_nomerge] = ACTIONS(599),
    [anon_sym_nonlazybind] = ACTIONS(599),
    [anon_sym_noprofile] = ACTIONS(599),
    [anon_sym_noredzone] = ACTIONS(599),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(599),
    [anon_sym_noreturn] = ACTIONS(599),
    [anon_sym_norecurse] = ACTIONS(599),
    [anon_sym_willreturn] = ACTIONS(599),
    [anon_sym_nosync] = ACTIONS(599),
    [anon_sym_nounwind] = ACTIONS(599),
    [anon_sym_nocallback] = ACTIONS(599),
    [anon_sym_nosanitize_coverage] = ACTIONS(599),
    [anon_sym_null_pointer_is_valid] = ACTIONS(599),
    [anon_sym_optforfuzzing] = ACTIONS(599),
    [anon_sym_optnone] = ACTIONS(599),
    [anon_sym_optsize] = ACTIONS(599),
    [anon_sym_readnone] = ACTIONS(599),
    [anon_sym_readonly] = ACTIONS(599),
    [anon_sym_writeonly] = ACTIONS(599),
    [anon_sym_argmemonly] = ACTIONS(599),
    [anon_sym_returns_twice] = ACTIONS(599),
    [anon_sym_safestack] = ACTIONS(599),
    [anon_sym_sanitize_address] = ACTIONS(599),
    [anon_sym_sanitize_memory] = ACTIONS(599),
    [anon_sym_sanitize_thread] = ACTIONS(599),
    [anon_sym_sanitize_hwaddress] = ACTIONS(599),
    [anon_sym_sanitize_memtag] = ACTIONS(599),
    [anon_sym_speculative_load_hardening] = ACTIONS(599),
    [anon_sym_speculatable] = ACTIONS(599),
    [anon_sym_ssp] = ACTIONS(601),
    [anon_sym_sspstrong] = ACTIONS(599),
    [anon_sym_sspreq] = ACTIONS(599),
    [anon_sym_strictfp] = ACTIONS(599),
    [anon_sym_nocf_check] = ACTIONS(599),
    [anon_sym_shadowcallstack] = ACTIONS(599),
    [anon_sym_mustprogress] = ACTIONS(599),
    [anon_sym_vscale_range] = ACTIONS(599),
    [anon_sym_preallocated] = ACTIONS(599),
    [anon_sym_zeroext] = ACTIONS(599),
    [anon_sym_signext] = ACTIONS(599),
    [anon_sym_inreg] = ACTIONS(599),
    [anon_sym_byval] = ACTIONS(599),
    [anon_sym_byref] = ACTIONS(599),
    [anon_sym_inalloca] = ACTIONS(599),
    [anon_sym_sret] = ACTIONS(599),
    [anon_sym_elementtype] = ACTIONS(599),
    [anon_sym_noalias] = ACTIONS(599),
    [anon_sym_nocapture] = ACTIONS(599),
    [anon_sym_nest] = ACTIONS(599),
    [anon_sym_returned] = ACTIONS(599),
    [anon_sym_nonnull] = ACTIONS(599),
    [anon_sym_dereferenceable] = ACTIONS(601),
    [anon_sym_dereferenceable_or_null] = ACTIONS(599),
    [anon_sym_swiftself] = ACTIONS(601),
    [anon_sym_swiftasync] = ACTIONS(601),
    [anon_sym_swifterror] = ACTIONS(601),
    [anon_sym_immarg] = ACTIONS(599),
    [anon_sym_noundef] = ACTIONS(599),
    [anon_sym_uwtable] = ACTIONS(599),
    [anon_sym_memory] = ACTIONS(599),
    [anon_sym_to] = ACTIONS(601),
    [anon_sym_unwind] = ACTIONS(599),
    [anon_sym_unordered] = ACTIONS(599),
    [anon_sym_monotonic] = ACTIONS(599),
    [anon_sym_acquire] = ACTIONS(599),
    [anon_sym_release] = ACTIONS(599),
    [anon_sym_acq_rel] = ACTIONS(599),
    [anon_sym_seq_cst] = ACTIONS(599),
    [anon_sym_syncscope] = ACTIONS(599),
    [anon_sym_uselistorder] = ACTIONS(601),
    [anon_sym_uselistorder_bb] = ACTIONS(599),
    [anon_sym_module] = ACTIONS(599),
    [anon_sym_attributes] = ACTIONS(599),
  },
  [107] = {
    [ts_builtin_sym_end] = ACTIONS(603),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(603),
    [sym_global_var] = ACTIONS(603),
    [sym_local_var] = ACTIONS(603),
    [aux_sym_metadata_ref_token1] = ACTIONS(603),
    [sym_summary_ref] = ACTIONS(603),
    [sym_string] = ACTIONS(603),
    [anon_sym_target] = ACTIONS(603),
    [anon_sym_source_filename] = ACTIONS(603),
    [anon_sym_declare] = ACTIONS(603),
    [anon_sym_define] = ACTIONS(603),
    [anon_sym_no_cfi] = ACTIONS(603),
    [anon_sym_private] = ACTIONS(603),
    [anon_sym_internal] = ACTIONS(603),
    [anon_sym_weak] = ACTIONS(605),
    [anon_sym_weak_odr] = ACTIONS(603),
    [anon_sym_linkonce] = ACTIONS(605),
    [anon_sym_linkonce_odr] = ACTIONS(603),
    [anon_sym_available_externally] = ACTIONS(603),
    [anon_sym_appending] = ACTIONS(603),
    [anon_sym_common] = ACTIONS(603),
    [anon_sym_extern_weak] = ACTIONS(603),
    [anon_sym_external] = ACTIONS(603),
    [anon_sym_dso_local] = ACTIONS(605),
    [anon_sym_dso_local_equivalent] = ACTIONS(603),
    [anon_sym_dso_preemptable] = ACTIONS(603),
    [anon_sym_default] = ACTIONS(603),
    [anon_sym_hidden] = ACTIONS(603),
    [anon_sym_protected] = ACTIONS(603),
    [anon_sym_dllimport] = ACTIONS(603),
    [anon_sym_dllexport] = ACTIONS(603),
    [anon_sym_ccc] = ACTIONS(603),
    [anon_sym_fastcc] = ACTIONS(603),
    [anon_sym_coldcc] = ACTIONS(603),
    [anon_sym_webkit_jscc] = ACTIONS(605),
    [anon_sym_anyregcc] = ACTIONS(603),
    [anon_sym_preserve_mostcc] = ACTIONS(603),
    [anon_sym_preserve_allcc] = ACTIONS(603),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(605),
    [anon_sym_tailcc] = ACTIONS(603),
    [anon_sym_swiftcc] = ACTIONS(605),
    [anon_sym_swifttailcc] = ACTIONS(605),
    [anon_sym_cfguard_checkcc] = ACTIONS(603),
    [aux_sym_calling_conv_token1] = ACTIONS(605),
    [aux_sym_calling_conv_token2] = ACTIONS(603),
    [aux_sym_calling_conv_token3] = ACTIONS(603),
    [aux_sym_calling_conv_token4] = ACTIONS(603),
    [aux_sym_calling_conv_token5] = ACTIONS(603),
    [aux_sym_calling_conv_token6] = ACTIONS(603),
    [aux_sym_calling_conv_token7] = ACTIONS(603),
    [aux_sym_calling_conv_token8] = ACTIONS(603),
    [aux_sym_calling_conv_token9] = ACTIONS(603),
    [aux_sym_calling_conv_token10] = ACTIONS(605),
    [anon_sym_ghccc] = ACTIONS(603),
    [aux_sym_calling_conv_token11] = ACTIONS(605),
    [aux_sym_calling_conv_token12] = ACTIONS(603),
    [aux_sym_calling_conv_token13] = ACTIONS(605),
    [aux_sym_calling_conv_token14] = ACTIONS(603),
    [anon_sym_cc] = ACTIONS(605),
    [anon_sym_unnamed_addr] = ACTIONS(603),
    [anon_sym_local_unnamed_addr] = ACTIONS(603),
    [anon_sym_void] = ACTIONS(603),
    [anon_sym_half] = ACTIONS(603),
    [anon_sym_bfloat] = ACTIONS(603),
    [anon_sym_float] = ACTIONS(603),
    [anon_sym_double] = ACTIONS(603),
    [anon_sym_x86_fp80] = ACTIONS(605),
    [anon_sym_fp128] = ACTIONS(603),
    [anon_sym_ppc_fp128] = ACTIONS(603),
    [anon_sym_label] = ACTIONS(603),
    [anon_sym_metadata] = ACTIONS(603),
    [anon_sym_x86_mmx] = ACTIONS(605),
    [anon_sym_x86_amx] = ACTIONS(605),
    [anon_sym_token] = ACTIONS(603),
    [anon_sym_opaque] = ACTIONS(603),
    [anon_sym_ptr] = ACTIONS(603),
    [aux_sym_type_keyword_token1] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(603),
    [anon_sym_RBRACE] = ACTIONS(603),
    [anon_sym_LT_LBRACE] = ACTIONS(603),
    [anon_sym_LBRACK] = ACTIONS(603),
    [anon_sym_RBRACK] = ACTIONS(603),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_GT] = ACTIONS(603),
    [anon_sym_COMMA] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(603),
    [anon_sym_RPAREN] = ACTIONS(603),
    [anon_sym_align] = ACTIONS(605),
    [anon_sym_alignstack] = ACTIONS(603),
    [anon_sym_allocsize] = ACTIONS(603),
    [anon_sym_alwaysinline] = ACTIONS(603),
    [anon_sym_builtin] = ACTIONS(603),
    [anon_sym_cold] = ACTIONS(605),
    [anon_sym_convergent] = ACTIONS(603),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(603),
    [anon_sym_hot] = ACTIONS(603),
    [anon_sym_inaccessiblememonly] = ACTIONS(603),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(603),
    [anon_sym_inlinehint] = ACTIONS(603),
    [anon_sym_jumptable] = ACTIONS(603),
    [anon_sym_minsize] = ACTIONS(603),
    [anon_sym_naked] = ACTIONS(603),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(603),
    [anon_sym_nobuiltin] = ACTIONS(603),
    [anon_sym_noduplicate] = ACTIONS(603),
    [anon_sym_nofree] = ACTIONS(603),
    [anon_sym_noimplicitfloat] = ACTIONS(603),
    [anon_sym_noinline] = ACTIONS(603),
    [anon_sym_nomerge] = ACTIONS(603),
    [anon_sym_nonlazybind] = ACTIONS(603),
    [anon_sym_noprofile] = ACTIONS(603),
    [anon_sym_noredzone] = ACTIONS(603),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(603),
    [anon_sym_noreturn] = ACTIONS(603),
    [anon_sym_norecurse] = ACTIONS(603),
    [anon_sym_willreturn] = ACTIONS(603),
    [anon_sym_nosync] = ACTIONS(603),
    [anon_sym_nounwind] = ACTIONS(603),
    [anon_sym_nocallback] = ACTIONS(603),
    [anon_sym_nosanitize_coverage] = ACTIONS(603),
    [anon_sym_null_pointer_is_valid] = ACTIONS(603),
    [anon_sym_optforfuzzing] = ACTIONS(603),
    [anon_sym_optnone] = ACTIONS(603),
    [anon_sym_optsize] = ACTIONS(603),
    [anon_sym_readnone] = ACTIONS(603),
    [anon_sym_readonly] = ACTIONS(603),
    [anon_sym_writeonly] = ACTIONS(603),
    [anon_sym_argmemonly] = ACTIONS(603),
    [anon_sym_returns_twice] = ACTIONS(603),
    [anon_sym_safestack] = ACTIONS(603),
    [anon_sym_sanitize_address] = ACTIONS(603),
    [anon_sym_sanitize_memory] = ACTIONS(603),
    [anon_sym_sanitize_thread] = ACTIONS(603),
    [anon_sym_sanitize_hwaddress] = ACTIONS(603),
    [anon_sym_sanitize_memtag] = ACTIONS(603),
    [anon_sym_speculative_load_hardening] = ACTIONS(603),
    [anon_sym_speculatable] = ACTIONS(603),
    [anon_sym_ssp] = ACTIONS(605),
    [anon_sym_sspstrong] = ACTIONS(603),
    [anon_sym_sspreq] = ACTIONS(603),
    [anon_sym_strictfp] = ACTIONS(603),
    [anon_sym_nocf_check] = ACTIONS(603),
    [anon_sym_shadowcallstack] = ACTIONS(603),
    [anon_sym_mustprogress] = ACTIONS(603),
    [anon_sym_vscale_range] = ACTIONS(603),
    [anon_sym_preallocated] = ACTIONS(603),
    [anon_sym_zeroext] = ACTIONS(603),
    [anon_sym_signext] = ACTIONS(603),
    [anon_sym_inreg] = ACTIONS(603),
    [anon_sym_byval] = ACTIONS(603),
    [anon_sym_byref] = ACTIONS(603),
    [anon_sym_inalloca] = ACTIONS(603),
    [anon_sym_sret] = ACTIONS(603),
    [anon_sym_elementtype] = ACTIONS(603),
    [anon_sym_noalias] = ACTIONS(603),
    [anon_sym_nocapture] = ACTIONS(603),
    [anon_sym_nest] = ACTIONS(603),
    [anon_sym_returned] = ACTIONS(603),
    [anon_sym_nonnull] = ACTIONS(603),
    [anon_sym_dereferenceable] = ACTIONS(605),
    [anon_sym_dereferenceable_or_null] = ACTIONS(603),
    [anon_sym_swiftself] = ACTIONS(605),
    [anon_sym_swiftasync] = ACTIONS(605),
    [anon_sym_swifterror] = ACTIONS(605),
    [anon_sym_immarg] = ACTIONS(603),
    [anon_sym_noundef] = ACTIONS(603),
    [anon_sym_uwtable] = ACTIONS(603),
    [anon_sym_memory] = ACTIONS(603),
    [anon_sym_to] = ACTIONS(605),
    [anon_sym_unwind] = ACTIONS(603),
    [anon_sym_unordered] = ACTIONS(603),
    [anon_sym_monotonic] = ACTIONS(603),
    [anon_sym_acquire] = ACTIONS(603),
    [anon_sym_release] = ACTIONS(603),
    [anon_sym_acq_rel] = ACTIONS(603),
    [anon_sym_seq_cst] = ACTIONS(603),
    [anon_sym_syncscope] = ACTIONS(603),
    [anon_sym_uselistorder] = ACTIONS(605),
    [anon_sym_uselistorder_bb] = ACTIONS(603),
    [anon_sym_module] = ACTIONS(603),
    [anon_sym_attributes] = ACTIONS(603),
  },
  [108] = {
    [ts_builtin_sym_end] = ACTIONS(607),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(607),
    [sym_global_var] = ACTIONS(607),
    [sym_local_var] = ACTIONS(607),
    [aux_sym_metadata_ref_token1] = ACTIONS(607),
    [sym_summary_ref] = ACTIONS(607),
    [sym_string] = ACTIONS(607),
    [anon_sym_target] = ACTIONS(607),
    [anon_sym_source_filename] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(607),
    [anon_sym_define] = ACTIONS(607),
    [anon_sym_no_cfi] = ACTIONS(607),
    [anon_sym_private] = ACTIONS(607),
    [anon_sym_internal] = ACTIONS(607),
    [anon_sym_weak] = ACTIONS(609),
    [anon_sym_weak_odr] = ACTIONS(607),
    [anon_sym_linkonce] = ACTIONS(609),
    [anon_sym_linkonce_odr] = ACTIONS(607),
    [anon_sym_available_externally] = ACTIONS(607),
    [anon_sym_appending] = ACTIONS(607),
    [anon_sym_common] = ACTIONS(607),
    [anon_sym_extern_weak] = ACTIONS(607),
    [anon_sym_external] = ACTIONS(607),
    [anon_sym_dso_local] = ACTIONS(609),
    [anon_sym_dso_local_equivalent] = ACTIONS(607),
    [anon_sym_dso_preemptable] = ACTIONS(607),
    [anon_sym_default] = ACTIONS(607),
    [anon_sym_hidden] = ACTIONS(607),
    [anon_sym_protected] = ACTIONS(607),
    [anon_sym_dllimport] = ACTIONS(607),
    [anon_sym_dllexport] = ACTIONS(607),
    [anon_sym_ccc] = ACTIONS(607),
    [anon_sym_fastcc] = ACTIONS(607),
    [anon_sym_coldcc] = ACTIONS(607),
    [anon_sym_webkit_jscc] = ACTIONS(609),
    [anon_sym_anyregcc] = ACTIONS(607),
    [anon_sym_preserve_mostcc] = ACTIONS(607),
    [anon_sym_preserve_allcc] = ACTIONS(607),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(609),
    [anon_sym_tailcc] = ACTIONS(607),
    [anon_sym_swiftcc] = ACTIONS(609),
    [anon_sym_swifttailcc] = ACTIONS(609),
    [anon_sym_cfguard_checkcc] = ACTIONS(607),
    [aux_sym_calling_conv_token1] = ACTIONS(609),
    [aux_sym_calling_conv_token2] = ACTIONS(607),
    [aux_sym_calling_conv_token3] = ACTIONS(607),
    [aux_sym_calling_conv_token4] = ACTIONS(607),
    [aux_sym_calling_conv_token5] = ACTIONS(607),
    [aux_sym_calling_conv_token6] = ACTIONS(607),
    [aux_sym_calling_conv_token7] = ACTIONS(607),
    [aux_sym_calling_conv_token8] = ACTIONS(607),
    [aux_sym_calling_conv_token9] = ACTIONS(607),
    [aux_sym_calling_conv_token10] = ACTIONS(609),
    [anon_sym_ghccc] = ACTIONS(607),
    [aux_sym_calling_conv_token11] = ACTIONS(609),
    [aux_sym_calling_conv_token12] = ACTIONS(607),
    [aux_sym_calling_conv_token13] = ACTIONS(609),
    [aux_sym_calling_conv_token14] = ACTIONS(607),
    [anon_sym_cc] = ACTIONS(609),
    [anon_sym_unnamed_addr] = ACTIONS(607),
    [anon_sym_local_unnamed_addr] = ACTIONS(607),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_half] = ACTIONS(607),
    [anon_sym_bfloat] = ACTIONS(607),
    [anon_sym_float] = ACTIONS(607),
    [anon_sym_double] = ACTIONS(607),
    [anon_sym_x86_fp80] = ACTIONS(609),
    [anon_sym_fp128] = ACTIONS(607),
    [anon_sym_ppc_fp128] = ACTIONS(607),
    [anon_sym_label] = ACTIONS(607),
    [anon_sym_metadata] = ACTIONS(607),
    [anon_sym_x86_mmx] = ACTIONS(609),
    [anon_sym_x86_amx] = ACTIONS(609),
    [anon_sym_token] = ACTIONS(607),
    [anon_sym_opaque] = ACTIONS(607),
    [anon_sym_ptr] = ACTIONS(607),
    [aux_sym_type_keyword_token1] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(607),
    [anon_sym_RBRACE] = ACTIONS(607),
    [anon_sym_LT_LBRACE] = ACTIONS(607),
    [anon_sym_LBRACK] = ACTIONS(607),
    [anon_sym_RBRACK] = ACTIONS(607),
    [anon_sym_LT] = ACTIONS(609),
    [anon_sym_GT] = ACTIONS(607),
    [anon_sym_COMMA] = ACTIONS(607),
    [anon_sym_LPAREN] = ACTIONS(607),
    [anon_sym_RPAREN] = ACTIONS(607),
    [anon_sym_align] = ACTIONS(609),
    [anon_sym_alignstack] = ACTIONS(607),
    [anon_sym_allocsize] = ACTIONS(607),
    [anon_sym_alwaysinline] = ACTIONS(607),
    [anon_sym_builtin] = ACTIONS(607),
    [anon_sym_cold] = ACTIONS(609),
    [anon_sym_convergent] = ACTIONS(607),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(607),
    [anon_sym_hot] = ACTIONS(607),
    [anon_sym_inaccessiblememonly] = ACTIONS(607),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(607),
    [anon_sym_inlinehint] = ACTIONS(607),
    [anon_sym_jumptable] = ACTIONS(607),
    [anon_sym_minsize] = ACTIONS(607),
    [anon_sym_naked] = ACTIONS(607),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(607),
    [anon_sym_nobuiltin] = ACTIONS(607),
    [anon_sym_noduplicate] = ACTIONS(607),
    [anon_sym_nofree] = ACTIONS(607),
    [anon_sym_noimplicitfloat] = ACTIONS(607),
    [anon_sym_noinline] = ACTIONS(607),
    [anon_sym_nomerge] = ACTIONS(607),
    [anon_sym_nonlazybind] = ACTIONS(607),
    [anon_sym_noprofile] = ACTIONS(607),
    [anon_sym_noredzone] = ACTIONS(607),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(607),
    [anon_sym_noreturn] = ACTIONS(607),
    [anon_sym_norecurse] = ACTIONS(607),
    [anon_sym_willreturn] = ACTIONS(607),
    [anon_sym_nosync] = ACTIONS(607),
    [anon_sym_nounwind] = ACTIONS(607),
    [anon_sym_nocallback] = ACTIONS(607),
    [anon_sym_nosanitize_coverage] = ACTIONS(607),
    [anon_sym_null_pointer_is_valid] = ACTIONS(607),
    [anon_sym_optforfuzzing] = ACTIONS(607),
    [anon_sym_optnone] = ACTIONS(607),
    [anon_sym_optsize] = ACTIONS(607),
    [anon_sym_readnone] = ACTIONS(607),
    [anon_sym_readonly] = ACTIONS(607),
    [anon_sym_writeonly] = ACTIONS(607),
    [anon_sym_argmemonly] = ACTIONS(607),
    [anon_sym_returns_twice] = ACTIONS(607),
    [anon_sym_safestack] = ACTIONS(607),
    [anon_sym_sanitize_address] = ACTIONS(607),
    [anon_sym_sanitize_memory] = ACTIONS(607),
    [anon_sym_sanitize_thread] = ACTIONS(607),
    [anon_sym_sanitize_hwaddress] = ACTIONS(607),
    [anon_sym_sanitize_memtag] = ACTIONS(607),
    [anon_sym_speculative_load_hardening] = ACTIONS(607),
    [anon_sym_speculatable] = ACTIONS(607),
    [anon_sym_ssp] = ACTIONS(609),
    [anon_sym_sspstrong] = ACTIONS(607),
    [anon_sym_sspreq] = ACTIONS(607),
    [anon_sym_strictfp] = ACTIONS(607),
    [anon_sym_nocf_check] = ACTIONS(607),
    [anon_sym_shadowcallstack] = ACTIONS(607),
    [anon_sym_mustprogress] = ACTIONS(607),
    [anon_sym_vscale_range] = ACTIONS(607),
    [anon_sym_preallocated] = ACTIONS(607),
    [anon_sym_zeroext] = ACTIONS(607),
    [anon_sym_signext] = ACTIONS(607),
    [anon_sym_inreg] = ACTIONS(607),
    [anon_sym_byval] = ACTIONS(607),
    [anon_sym_byref] = ACTIONS(607),
    [anon_sym_inalloca] = ACTIONS(607),
    [anon_sym_sret] = ACTIONS(607),
    [anon_sym_elementtype] = ACTIONS(607),
    [anon_sym_noalias] = ACTIONS(607),
    [anon_sym_nocapture] = ACTIONS(607),
    [anon_sym_nest] = ACTIONS(607),
    [anon_sym_returned] = ACTIONS(607),
    [anon_sym_nonnull] = ACTIONS(607),
    [anon_sym_dereferenceable] = ACTIONS(609),
    [anon_sym_dereferenceable_or_null] = ACTIONS(607),
    [anon_sym_swiftself] = ACTIONS(609),
    [anon_sym_swiftasync] = ACTIONS(609),
    [anon_sym_swifterror] = ACTIONS(609),
    [anon_sym_immarg] = ACTIONS(607),
    [anon_sym_noundef] = ACTIONS(607),
    [anon_sym_uwtable] = ACTIONS(607),
    [anon_sym_memory] = ACTIONS(607),
    [anon_sym_to] = ACTIONS(609),
    [anon_sym_unwind] = ACTIONS(607),
    [anon_sym_unordered] = ACTIONS(607),
    [anon_sym_monotonic] = ACTIONS(607),
    [anon_sym_acquire] = ACTIONS(607),
    [anon_sym_release] = ACTIONS(607),
    [anon_sym_acq_rel] = ACTIONS(607),
    [anon_sym_seq_cst] = ACTIONS(607),
    [anon_sym_syncscope] = ACTIONS(607),
    [anon_sym_uselistorder] = ACTIONS(609),
    [anon_sym_uselistorder_bb] = ACTIONS(607),
    [anon_sym_module] = ACTIONS(607),
    [anon_sym_attributes] = ACTIONS(607),
  },
  [109] = {
    [ts_builtin_sym_end] = ACTIONS(611),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(611),
    [sym_global_var] = ACTIONS(611),
    [sym_local_var] = ACTIONS(611),
    [aux_sym_metadata_ref_token1] = ACTIONS(611),
    [sym_summary_ref] = ACTIONS(611),
    [sym_string] = ACTIONS(611),
    [anon_sym_target] = ACTIONS(611),
    [anon_sym_source_filename] = ACTIONS(611),
    [anon_sym_declare] = ACTIONS(611),
    [anon_sym_define] = ACTIONS(611),
    [anon_sym_no_cfi] = ACTIONS(611),
    [anon_sym_private] = ACTIONS(611),
    [anon_sym_internal] = ACTIONS(611),
    [anon_sym_weak] = ACTIONS(613),
    [anon_sym_weak_odr] = ACTIONS(611),
    [anon_sym_linkonce] = ACTIONS(613),
    [anon_sym_linkonce_odr] = ACTIONS(611),
    [anon_sym_available_externally] = ACTIONS(611),
    [anon_sym_appending] = ACTIONS(611),
    [anon_sym_common] = ACTIONS(611),
    [anon_sym_extern_weak] = ACTIONS(611),
    [anon_sym_external] = ACTIONS(611),
    [anon_sym_dso_local] = ACTIONS(613),
    [anon_sym_dso_local_equivalent] = ACTIONS(611),
    [anon_sym_dso_preemptable] = ACTIONS(611),
    [anon_sym_default] = ACTIONS(611),
    [anon_sym_hidden] = ACTIONS(611),
    [anon_sym_protected] = ACTIONS(611),
    [anon_sym_dllimport] = ACTIONS(611),
    [anon_sym_dllexport] = ACTIONS(611),
    [anon_sym_ccc] = ACTIONS(611),
    [anon_sym_fastcc] = ACTIONS(611),
    [anon_sym_coldcc] = ACTIONS(611),
    [anon_sym_webkit_jscc] = ACTIONS(613),
    [anon_sym_anyregcc] = ACTIONS(611),
    [anon_sym_preserve_mostcc] = ACTIONS(611),
    [anon_sym_preserve_allcc] = ACTIONS(611),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(613),
    [anon_sym_tailcc] = ACTIONS(611),
    [anon_sym_swiftcc] = ACTIONS(613),
    [anon_sym_swifttailcc] = ACTIONS(613),
    [anon_sym_cfguard_checkcc] = ACTIONS(611),
    [aux_sym_calling_conv_token1] = ACTIONS(613),
    [aux_sym_calling_conv_token2] = ACTIONS(611),
    [aux_sym_calling_conv_token3] = ACTIONS(611),
    [aux_sym_calling_conv_token4] = ACTIONS(611),
    [aux_sym_calling_conv_token5] = ACTIONS(611),
    [aux_sym_calling_conv_token6] = ACTIONS(611),
    [aux_sym_calling_conv_token7] = ACTIONS(611),
    [aux_sym_calling_conv_token8] = ACTIONS(611),
    [aux_sym_calling_conv_token9] = ACTIONS(611),
    [aux_sym_calling_conv_token10] = ACTIONS(613),
    [anon_sym_ghccc] = ACTIONS(611),
    [aux_sym_calling_conv_token11] = ACTIONS(613),
    [aux_sym_calling_conv_token12] = ACTIONS(611),
    [aux_sym_calling_conv_token13] = ACTIONS(613),
    [aux_sym_calling_conv_token14] = ACTIONS(611),
    [anon_sym_cc] = ACTIONS(613),
    [anon_sym_unnamed_addr] = ACTIONS(611),
    [anon_sym_local_unnamed_addr] = ACTIONS(611),
    [anon_sym_void] = ACTIONS(611),
    [anon_sym_half] = ACTIONS(611),
    [anon_sym_bfloat] = ACTIONS(611),
    [anon_sym_float] = ACTIONS(611),
    [anon_sym_double] = ACTIONS(611),
    [anon_sym_x86_fp80] = ACTIONS(613),
    [anon_sym_fp128] = ACTIONS(611),
    [anon_sym_ppc_fp128] = ACTIONS(611),
    [anon_sym_label] = ACTIONS(611),
    [anon_sym_metadata] = ACTIONS(611),
    [anon_sym_x86_mmx] = ACTIONS(613),
    [anon_sym_x86_amx] = ACTIONS(613),
    [anon_sym_token] = ACTIONS(611),
    [anon_sym_opaque] = ACTIONS(611),
    [anon_sym_ptr] = ACTIONS(611),
    [aux_sym_type_keyword_token1] = ACTIONS(611),
    [anon_sym_LBRACE] = ACTIONS(611),
    [anon_sym_RBRACE] = ACTIONS(611),
    [anon_sym_LT_LBRACE] = ACTIONS(611),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_RBRACK] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(613),
    [anon_sym_GT] = ACTIONS(611),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_LPAREN] = ACTIONS(611),
    [anon_sym_RPAREN] = ACTIONS(611),
    [anon_sym_align] = ACTIONS(613),
    [anon_sym_alignstack] = ACTIONS(611),
    [anon_sym_allocsize] = ACTIONS(611),
    [anon_sym_alwaysinline] = ACTIONS(611),
    [anon_sym_builtin] = ACTIONS(611),
    [anon_sym_cold] = ACTIONS(613),
    [anon_sym_convergent] = ACTIONS(611),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(611),
    [anon_sym_hot] = ACTIONS(611),
    [anon_sym_inaccessiblememonly] = ACTIONS(611),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(611),
    [anon_sym_inlinehint] = ACTIONS(611),
    [anon_sym_jumptable] = ACTIONS(611),
    [anon_sym_minsize] = ACTIONS(611),
    [anon_sym_naked] = ACTIONS(611),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(611),
    [anon_sym_nobuiltin] = ACTIONS(611),
    [anon_sym_noduplicate] = ACTIONS(611),
    [anon_sym_nofree] = ACTIONS(611),
    [anon_sym_noimplicitfloat] = ACTIONS(611),
    [anon_sym_noinline] = ACTIONS(611),
    [anon_sym_nomerge] = ACTIONS(611),
    [anon_sym_nonlazybind] = ACTIONS(611),
    [anon_sym_noprofile] = ACTIONS(611),
    [anon_sym_noredzone] = ACTIONS(611),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(611),
    [anon_sym_noreturn] = ACTIONS(611),
    [anon_sym_norecurse] = ACTIONS(611),
    [anon_sym_willreturn] = ACTIONS(611),
    [anon_sym_nosync] = ACTIONS(611),
    [anon_sym_nounwind] = ACTIONS(611),
    [anon_sym_nocallback] = ACTIONS(611),
    [anon_sym_nosanitize_coverage] = ACTIONS(611),
    [anon_sym_null_pointer_is_valid] = ACTIONS(611),
    [anon_sym_optforfuzzing] = ACTIONS(611),
    [anon_sym_optnone] = ACTIONS(611),
    [anon_sym_optsize] = ACTIONS(611),
    [anon_sym_readnone] = ACTIONS(611),
    [anon_sym_readonly] = ACTIONS(611),
    [anon_sym_writeonly] = ACTIONS(611),
    [anon_sym_argmemonly] = ACTIONS(611),
    [anon_sym_returns_twice] = ACTIONS(611),
    [anon_sym_safestack] = ACTIONS(611),
    [anon_sym_sanitize_address] = ACTIONS(611),
    [anon_sym_sanitize_memory] = ACTIONS(611),
    [anon_sym_sanitize_thread] = ACTIONS(611),
    [anon_sym_sanitize_hwaddress] = ACTIONS(611),
    [anon_sym_sanitize_memtag] = ACTIONS(611),
    [anon_sym_speculative_load_hardening] = ACTIONS(611),
    [anon_sym_speculatable] = ACTIONS(611),
    [anon_sym_ssp] = ACTIONS(613),
    [anon_sym_sspstrong] = ACTIONS(611),
    [anon_sym_sspreq] = ACTIONS(611),
    [anon_sym_strictfp] = ACTIONS(611),
    [anon_sym_nocf_check] = ACTIONS(611),
    [anon_sym_shadowcallstack] = ACTIONS(611),
    [anon_sym_mustprogress] = ACTIONS(611),
    [anon_sym_vscale_range] = ACTIONS(611),
    [anon_sym_preallocated] = ACTIONS(611),
    [anon_sym_zeroext] = ACTIONS(611),
    [anon_sym_signext] = ACTIONS(611),
    [anon_sym_inreg] = ACTIONS(611),
    [anon_sym_byval] = ACTIONS(611),
    [anon_sym_byref] = ACTIONS(611),
    [anon_sym_inalloca] = ACTIONS(611),
    [anon_sym_sret] = ACTIONS(611),
    [anon_sym_elementtype] = ACTIONS(611),
    [anon_sym_noalias] = ACTIONS(611),
    [anon_sym_nocapture] = ACTIONS(611),
    [anon_sym_nest] = ACTIONS(611),
    [anon_sym_returned] = ACTIONS(611),
    [anon_sym_nonnull] = ACTIONS(611),
    [anon_sym_dereferenceable] = ACTIONS(613),
    [anon_sym_dereferenceable_or_null] = ACTIONS(611),
    [anon_sym_swiftself] = ACTIONS(613),
    [anon_sym_swiftasync] = ACTIONS(613),
    [anon_sym_swifterror] = ACTIONS(613),
    [anon_sym_immarg] = ACTIONS(611),
    [anon_sym_noundef] = ACTIONS(611),
    [anon_sym_uwtable] = ACTIONS(611),
    [anon_sym_memory] = ACTIONS(611),
    [anon_sym_to] = ACTIONS(613),
    [anon_sym_unwind] = ACTIONS(611),
    [anon_sym_unordered] = ACTIONS(611),
    [anon_sym_monotonic] = ACTIONS(611),
    [anon_sym_acquire] = ACTIONS(611),
    [anon_sym_release] = ACTIONS(611),
    [anon_sym_acq_rel] = ACTIONS(611),
    [anon_sym_seq_cst] = ACTIONS(611),
    [anon_sym_syncscope] = ACTIONS(611),
    [anon_sym_uselistorder] = ACTIONS(613),
    [anon_sym_uselistorder_bb] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(611),
    [anon_sym_attributes] = ACTIONS(611),
  },
  [110] = {
    [ts_builtin_sym_end] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(615),
    [sym_global_var] = ACTIONS(615),
    [sym_local_var] = ACTIONS(615),
    [aux_sym_metadata_ref_token1] = ACTIONS(615),
    [sym_summary_ref] = ACTIONS(615),
    [sym_string] = ACTIONS(615),
    [anon_sym_target] = ACTIONS(615),
    [anon_sym_source_filename] = ACTIONS(615),
    [anon_sym_declare] = ACTIONS(615),
    [anon_sym_define] = ACTIONS(615),
    [anon_sym_no_cfi] = ACTIONS(615),
    [anon_sym_private] = ACTIONS(615),
    [anon_sym_internal] = ACTIONS(615),
    [anon_sym_weak] = ACTIONS(617),
    [anon_sym_weak_odr] = ACTIONS(615),
    [anon_sym_linkonce] = ACTIONS(617),
    [anon_sym_linkonce_odr] = ACTIONS(615),
    [anon_sym_available_externally] = ACTIONS(615),
    [anon_sym_appending] = ACTIONS(615),
    [anon_sym_common] = ACTIONS(615),
    [anon_sym_extern_weak] = ACTIONS(615),
    [anon_sym_external] = ACTIONS(615),
    [anon_sym_dso_local] = ACTIONS(617),
    [anon_sym_dso_local_equivalent] = ACTIONS(615),
    [anon_sym_dso_preemptable] = ACTIONS(615),
    [anon_sym_default] = ACTIONS(615),
    [anon_sym_hidden] = ACTIONS(615),
    [anon_sym_protected] = ACTIONS(615),
    [anon_sym_dllimport] = ACTIONS(615),
    [anon_sym_dllexport] = ACTIONS(615),
    [anon_sym_ccc] = ACTIONS(615),
    [anon_sym_fastcc] = ACTIONS(615),
    [anon_sym_coldcc] = ACTIONS(615),
    [anon_sym_webkit_jscc] = ACTIONS(617),
    [anon_sym_anyregcc] = ACTIONS(615),
    [anon_sym_preserve_mostcc] = ACTIONS(615),
    [anon_sym_preserve_allcc] = ACTIONS(615),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(617),
    [anon_sym_tailcc] = ACTIONS(615),
    [anon_sym_swiftcc] = ACTIONS(617),
    [anon_sym_swifttailcc] = ACTIONS(617),
    [anon_sym_cfguard_checkcc] = ACTIONS(615),
    [aux_sym_calling_conv_token1] = ACTIONS(617),
    [aux_sym_calling_conv_token2] = ACTIONS(615),
    [aux_sym_calling_conv_token3] = ACTIONS(615),
    [aux_sym_calling_conv_token4] = ACTIONS(615),
    [aux_sym_calling_conv_token5] = ACTIONS(615),
    [aux_sym_calling_conv_token6] = ACTIONS(615),
    [aux_sym_calling_conv_token7] = ACTIONS(615),
    [aux_sym_calling_conv_token8] = ACTIONS(615),
    [aux_sym_calling_conv_token9] = ACTIONS(615),
    [aux_sym_calling_conv_token10] = ACTIONS(617),
    [anon_sym_ghccc] = ACTIONS(615),
    [aux_sym_calling_conv_token11] = ACTIONS(617),
    [aux_sym_calling_conv_token12] = ACTIONS(615),
    [aux_sym_calling_conv_token13] = ACTIONS(617),
    [aux_sym_calling_conv_token14] = ACTIONS(615),
    [anon_sym_cc] = ACTIONS(617),
    [anon_sym_unnamed_addr] = ACTIONS(615),
    [anon_sym_local_unnamed_addr] = ACTIONS(615),
    [anon_sym_void] = ACTIONS(615),
    [anon_sym_half] = ACTIONS(615),
    [anon_sym_bfloat] = ACTIONS(615),
    [anon_sym_float] = ACTIONS(615),
    [anon_sym_double] = ACTIONS(615),
    [anon_sym_x86_fp80] = ACTIONS(617),
    [anon_sym_fp128] = ACTIONS(615),
    [anon_sym_ppc_fp128] = ACTIONS(615),
    [anon_sym_label] = ACTIONS(615),
    [anon_sym_metadata] = ACTIONS(615),
    [anon_sym_x86_mmx] = ACTIONS(617),
    [anon_sym_x86_amx] = ACTIONS(617),
    [anon_sym_token] = ACTIONS(615),
    [anon_sym_opaque] = ACTIONS(615),
    [anon_sym_ptr] = ACTIONS(615),
    [aux_sym_type_keyword_token1] = ACTIONS(615),
    [anon_sym_LBRACE] = ACTIONS(615),
    [anon_sym_RBRACE] = ACTIONS(615),
    [anon_sym_LT_LBRACE] = ACTIONS(615),
    [anon_sym_LBRACK] = ACTIONS(615),
    [anon_sym_RBRACK] = ACTIONS(615),
    [anon_sym_LT] = ACTIONS(617),
    [anon_sym_GT] = ACTIONS(615),
    [anon_sym_COMMA] = ACTIONS(615),
    [anon_sym_LPAREN] = ACTIONS(615),
    [anon_sym_RPAREN] = ACTIONS(615),
    [anon_sym_align] = ACTIONS(617),
    [anon_sym_alignstack] = ACTIONS(615),
    [anon_sym_allocsize] = ACTIONS(615),
    [anon_sym_alwaysinline] = ACTIONS(615),
    [anon_sym_builtin] = ACTIONS(615),
    [anon_sym_cold] = ACTIONS(617),
    [anon_sym_convergent] = ACTIONS(615),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(615),
    [anon_sym_hot] = ACTIONS(615),
    [anon_sym_inaccessiblememonly] = ACTIONS(615),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(615),
    [anon_sym_inlinehint] = ACTIONS(615),
    [anon_sym_jumptable] = ACTIONS(615),
    [anon_sym_minsize] = ACTIONS(615),
    [anon_sym_naked] = ACTIONS(615),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(615),
    [anon_sym_nobuiltin] = ACTIONS(615),
    [anon_sym_noduplicate] = ACTIONS(615),
    [anon_sym_nofree] = ACTIONS(615),
    [anon_sym_noimplicitfloat] = ACTIONS(615),
    [anon_sym_noinline] = ACTIONS(615),
    [anon_sym_nomerge] = ACTIONS(615),
    [anon_sym_nonlazybind] = ACTIONS(615),
    [anon_sym_noprofile] = ACTIONS(615),
    [anon_sym_noredzone] = ACTIONS(615),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(615),
    [anon_sym_noreturn] = ACTIONS(615),
    [anon_sym_norecurse] = ACTIONS(615),
    [anon_sym_willreturn] = ACTIONS(615),
    [anon_sym_nosync] = ACTIONS(615),
    [anon_sym_nounwind] = ACTIONS(615),
    [anon_sym_nocallback] = ACTIONS(615),
    [anon_sym_nosanitize_coverage] = ACTIONS(615),
    [anon_sym_null_pointer_is_valid] = ACTIONS(615),
    [anon_sym_optforfuzzing] = ACTIONS(615),
    [anon_sym_optnone] = ACTIONS(615),
    [anon_sym_optsize] = ACTIONS(615),
    [anon_sym_readnone] = ACTIONS(615),
    [anon_sym_readonly] = ACTIONS(615),
    [anon_sym_writeonly] = ACTIONS(615),
    [anon_sym_argmemonly] = ACTIONS(615),
    [anon_sym_returns_twice] = ACTIONS(615),
    [anon_sym_safestack] = ACTIONS(615),
    [anon_sym_sanitize_address] = ACTIONS(615),
    [anon_sym_sanitize_memory] = ACTIONS(615),
    [anon_sym_sanitize_thread] = ACTIONS(615),
    [anon_sym_sanitize_hwaddress] = ACTIONS(615),
    [anon_sym_sanitize_memtag] = ACTIONS(615),
    [anon_sym_speculative_load_hardening] = ACTIONS(615),
    [anon_sym_speculatable] = ACTIONS(615),
    [anon_sym_ssp] = ACTIONS(617),
    [anon_sym_sspstrong] = ACTIONS(615),
    [anon_sym_sspreq] = ACTIONS(615),
    [anon_sym_strictfp] = ACTIONS(615),
    [anon_sym_nocf_check] = ACTIONS(615),
    [anon_sym_shadowcallstack] = ACTIONS(615),
    [anon_sym_mustprogress] = ACTIONS(615),
    [anon_sym_vscale_range] = ACTIONS(615),
    [anon_sym_preallocated] = ACTIONS(615),
    [anon_sym_zeroext] = ACTIONS(615),
    [anon_sym_signext] = ACTIONS(615),
    [anon_sym_inreg] = ACTIONS(615),
    [anon_sym_byval] = ACTIONS(615),
    [anon_sym_byref] = ACTIONS(615),
    [anon_sym_inalloca] = ACTIONS(615),
    [anon_sym_sret] = ACTIONS(615),
    [anon_sym_elementtype] = ACTIONS(615),
    [anon_sym_noalias] = ACTIONS(615),
    [anon_sym_nocapture] = ACTIONS(615),
    [anon_sym_nest] = ACTIONS(615),
    [anon_sym_returned] = ACTIONS(615),
    [anon_sym_nonnull] = ACTIONS(615),
    [anon_sym_dereferenceable] = ACTIONS(617),
    [anon_sym_dereferenceable_or_null] = ACTIONS(615),
    [anon_sym_swiftself] = ACTIONS(617),
    [anon_sym_swiftasync] = ACTIONS(617),
    [anon_sym_swifterror] = ACTIONS(617),
    [anon_sym_immarg] = ACTIONS(615),
    [anon_sym_noundef] = ACTIONS(615),
    [anon_sym_uwtable] = ACTIONS(615),
    [anon_sym_memory] = ACTIONS(615),
    [anon_sym_to] = ACTIONS(617),
    [anon_sym_unwind] = ACTIONS(615),
    [anon_sym_unordered] = ACTIONS(615),
    [anon_sym_monotonic] = ACTIONS(615),
    [anon_sym_acquire] = ACTIONS(615),
    [anon_sym_release] = ACTIONS(615),
    [anon_sym_acq_rel] = ACTIONS(615),
    [anon_sym_seq_cst] = ACTIONS(615),
    [anon_sym_syncscope] = ACTIONS(615),
    [anon_sym_uselistorder] = ACTIONS(617),
    [anon_sym_uselistorder_bb] = ACTIONS(615),
    [anon_sym_module] = ACTIONS(615),
    [anon_sym_attributes] = ACTIONS(615),
  },
  [111] = {
    [ts_builtin_sym_end] = ACTIONS(619),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(619),
    [sym_global_var] = ACTIONS(619),
    [sym_local_var] = ACTIONS(619),
    [aux_sym_metadata_ref_token1] = ACTIONS(619),
    [sym_summary_ref] = ACTIONS(619),
    [sym_string] = ACTIONS(619),
    [anon_sym_target] = ACTIONS(619),
    [anon_sym_source_filename] = ACTIONS(619),
    [anon_sym_declare] = ACTIONS(619),
    [anon_sym_define] = ACTIONS(619),
    [anon_sym_no_cfi] = ACTIONS(619),
    [anon_sym_private] = ACTIONS(619),
    [anon_sym_internal] = ACTIONS(619),
    [anon_sym_weak] = ACTIONS(621),
    [anon_sym_weak_odr] = ACTIONS(619),
    [anon_sym_linkonce] = ACTIONS(621),
    [anon_sym_linkonce_odr] = ACTIONS(619),
    [anon_sym_available_externally] = ACTIONS(619),
    [anon_sym_appending] = ACTIONS(619),
    [anon_sym_common] = ACTIONS(619),
    [anon_sym_extern_weak] = ACTIONS(619),
    [anon_sym_external] = ACTIONS(619),
    [anon_sym_dso_local] = ACTIONS(621),
    [anon_sym_dso_local_equivalent] = ACTIONS(619),
    [anon_sym_dso_preemptable] = ACTIONS(619),
    [anon_sym_default] = ACTIONS(619),
    [anon_sym_hidden] = ACTIONS(619),
    [anon_sym_protected] = ACTIONS(619),
    [anon_sym_dllimport] = ACTIONS(619),
    [anon_sym_dllexport] = ACTIONS(619),
    [anon_sym_ccc] = ACTIONS(619),
    [anon_sym_fastcc] = ACTIONS(619),
    [anon_sym_coldcc] = ACTIONS(619),
    [anon_sym_webkit_jscc] = ACTIONS(621),
    [anon_sym_anyregcc] = ACTIONS(619),
    [anon_sym_preserve_mostcc] = ACTIONS(619),
    [anon_sym_preserve_allcc] = ACTIONS(619),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(621),
    [anon_sym_tailcc] = ACTIONS(619),
    [anon_sym_swiftcc] = ACTIONS(621),
    [anon_sym_swifttailcc] = ACTIONS(621),
    [anon_sym_cfguard_checkcc] = ACTIONS(619),
    [aux_sym_calling_conv_token1] = ACTIONS(621),
    [aux_sym_calling_conv_token2] = ACTIONS(619),
    [aux_sym_calling_conv_token3] = ACTIONS(619),
    [aux_sym_calling_conv_token4] = ACTIONS(619),
    [aux_sym_calling_conv_token5] = ACTIONS(619),
    [aux_sym_calling_conv_token6] = ACTIONS(619),
    [aux_sym_calling_conv_token7] = ACTIONS(619),
    [aux_sym_calling_conv_token8] = ACTIONS(619),
    [aux_sym_calling_conv_token9] = ACTIONS(619),
    [aux_sym_calling_conv_token10] = ACTIONS(621),
    [anon_sym_ghccc] = ACTIONS(619),
    [aux_sym_calling_conv_token11] = ACTIONS(621),
    [aux_sym_calling_conv_token12] = ACTIONS(619),
    [aux_sym_calling_conv_token13] = ACTIONS(621),
    [aux_sym_calling_conv_token14] = ACTIONS(619),
    [anon_sym_cc] = ACTIONS(621),
    [anon_sym_unnamed_addr] = ACTIONS(619),
    [anon_sym_local_unnamed_addr] = ACTIONS(619),
    [anon_sym_void] = ACTIONS(619),
    [anon_sym_half] = ACTIONS(619),
    [anon_sym_bfloat] = ACTIONS(619),
    [anon_sym_float] = ACTIONS(619),
    [anon_sym_double] = ACTIONS(619),
    [anon_sym_x86_fp80] = ACTIONS(621),
    [anon_sym_fp128] = ACTIONS(619),
    [anon_sym_ppc_fp128] = ACTIONS(619),
    [anon_sym_label] = ACTIONS(619),
    [anon_sym_metadata] = ACTIONS(619),
    [anon_sym_x86_mmx] = ACTIONS(621),
    [anon_sym_x86_amx] = ACTIONS(621),
    [anon_sym_token] = ACTIONS(619),
    [anon_sym_opaque] = ACTIONS(619),
    [anon_sym_ptr] = ACTIONS(619),
    [aux_sym_type_keyword_token1] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(619),
    [anon_sym_LT_LBRACE] = ACTIONS(619),
    [anon_sym_LBRACK] = ACTIONS(619),
    [anon_sym_RBRACK] = ACTIONS(619),
    [anon_sym_LT] = ACTIONS(621),
    [anon_sym_GT] = ACTIONS(619),
    [anon_sym_COMMA] = ACTIONS(619),
    [anon_sym_LPAREN] = ACTIONS(619),
    [anon_sym_RPAREN] = ACTIONS(619),
    [anon_sym_align] = ACTIONS(621),
    [anon_sym_alignstack] = ACTIONS(619),
    [anon_sym_allocsize] = ACTIONS(619),
    [anon_sym_alwaysinline] = ACTIONS(619),
    [anon_sym_builtin] = ACTIONS(619),
    [anon_sym_cold] = ACTIONS(621),
    [anon_sym_convergent] = ACTIONS(619),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(619),
    [anon_sym_hot] = ACTIONS(619),
    [anon_sym_inaccessiblememonly] = ACTIONS(619),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(619),
    [anon_sym_inlinehint] = ACTIONS(619),
    [anon_sym_jumptable] = ACTIONS(619),
    [anon_sym_minsize] = ACTIONS(619),
    [anon_sym_naked] = ACTIONS(619),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(619),
    [anon_sym_nobuiltin] = ACTIONS(619),
    [anon_sym_noduplicate] = ACTIONS(619),
    [anon_sym_nofree] = ACTIONS(619),
    [anon_sym_noimplicitfloat] = ACTIONS(619),
    [anon_sym_noinline] = ACTIONS(619),
    [anon_sym_nomerge] = ACTIONS(619),
    [anon_sym_nonlazybind] = ACTIONS(619),
    [anon_sym_noprofile] = ACTIONS(619),
    [anon_sym_noredzone] = ACTIONS(619),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(619),
    [anon_sym_noreturn] = ACTIONS(619),
    [anon_sym_norecurse] = ACTIONS(619),
    [anon_sym_willreturn] = ACTIONS(619),
    [anon_sym_nosync] = ACTIONS(619),
    [anon_sym_nounwind] = ACTIONS(619),
    [anon_sym_nocallback] = ACTIONS(619),
    [anon_sym_nosanitize_coverage] = ACTIONS(619),
    [anon_sym_null_pointer_is_valid] = ACTIONS(619),
    [anon_sym_optforfuzzing] = ACTIONS(619),
    [anon_sym_optnone] = ACTIONS(619),
    [anon_sym_optsize] = ACTIONS(619),
    [anon_sym_readnone] = ACTIONS(619),
    [anon_sym_readonly] = ACTIONS(619),
    [anon_sym_writeonly] = ACTIONS(619),
    [anon_sym_argmemonly] = ACTIONS(619),
    [anon_sym_returns_twice] = ACTIONS(619),
    [anon_sym_safestack] = ACTIONS(619),
    [anon_sym_sanitize_address] = ACTIONS(619),
    [anon_sym_sanitize_memory] = ACTIONS(619),
    [anon_sym_sanitize_thread] = ACTIONS(619),
    [anon_sym_sanitize_hwaddress] = ACTIONS(619),
    [anon_sym_sanitize_memtag] = ACTIONS(619),
    [anon_sym_speculative_load_hardening] = ACTIONS(619),
    [anon_sym_speculatable] = ACTIONS(619),
    [anon_sym_ssp] = ACTIONS(621),
    [anon_sym_sspstrong] = ACTIONS(619),
    [anon_sym_sspreq] = ACTIONS(619),
    [anon_sym_strictfp] = ACTIONS(619),
    [anon_sym_nocf_check] = ACTIONS(619),
    [anon_sym_shadowcallstack] = ACTIONS(619),
    [anon_sym_mustprogress] = ACTIONS(619),
    [anon_sym_vscale_range] = ACTIONS(619),
    [anon_sym_preallocated] = ACTIONS(619),
    [anon_sym_zeroext] = ACTIONS(619),
    [anon_sym_signext] = ACTIONS(619),
    [anon_sym_inreg] = ACTIONS(619),
    [anon_sym_byval] = ACTIONS(619),
    [anon_sym_byref] = ACTIONS(619),
    [anon_sym_inalloca] = ACTIONS(619),
    [anon_sym_sret] = ACTIONS(619),
    [anon_sym_elementtype] = ACTIONS(619),
    [anon_sym_noalias] = ACTIONS(619),
    [anon_sym_nocapture] = ACTIONS(619),
    [anon_sym_nest] = ACTIONS(619),
    [anon_sym_returned] = ACTIONS(619),
    [anon_sym_nonnull] = ACTIONS(619),
    [anon_sym_dereferenceable] = ACTIONS(621),
    [anon_sym_dereferenceable_or_null] = ACTIONS(619),
    [anon_sym_swiftself] = ACTIONS(621),
    [anon_sym_swiftasync] = ACTIONS(621),
    [anon_sym_swifterror] = ACTIONS(621),
    [anon_sym_immarg] = ACTIONS(619),
    [anon_sym_noundef] = ACTIONS(619),
    [anon_sym_uwtable] = ACTIONS(619),
    [anon_sym_memory] = ACTIONS(619),
    [anon_sym_to] = ACTIONS(621),
    [anon_sym_unwind] = ACTIONS(619),
    [anon_sym_unordered] = ACTIONS(619),
    [anon_sym_monotonic] = ACTIONS(619),
    [anon_sym_acquire] = ACTIONS(619),
    [anon_sym_release] = ACTIONS(619),
    [anon_sym_acq_rel] = ACTIONS(619),
    [anon_sym_seq_cst] = ACTIONS(619),
    [anon_sym_syncscope] = ACTIONS(619),
    [anon_sym_uselistorder] = ACTIONS(621),
    [anon_sym_uselistorder_bb] = ACTIONS(619),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_attributes] = ACTIONS(619),
  },
  [112] = {
    [ts_builtin_sym_end] = ACTIONS(623),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(623),
    [sym_global_var] = ACTIONS(623),
    [sym_local_var] = ACTIONS(623),
    [aux_sym_metadata_ref_token1] = ACTIONS(623),
    [sym_summary_ref] = ACTIONS(623),
    [sym_string] = ACTIONS(623),
    [anon_sym_target] = ACTIONS(623),
    [anon_sym_source_filename] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_define] = ACTIONS(623),
    [anon_sym_no_cfi] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(623),
    [anon_sym_weak] = ACTIONS(625),
    [anon_sym_weak_odr] = ACTIONS(623),
    [anon_sym_linkonce] = ACTIONS(625),
    [anon_sym_linkonce_odr] = ACTIONS(623),
    [anon_sym_available_externally] = ACTIONS(623),
    [anon_sym_appending] = ACTIONS(623),
    [anon_sym_common] = ACTIONS(623),
    [anon_sym_extern_weak] = ACTIONS(623),
    [anon_sym_external] = ACTIONS(623),
    [anon_sym_dso_local] = ACTIONS(625),
    [anon_sym_dso_local_equivalent] = ACTIONS(623),
    [anon_sym_dso_preemptable] = ACTIONS(623),
    [anon_sym_default] = ACTIONS(623),
    [anon_sym_hidden] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_dllimport] = ACTIONS(623),
    [anon_sym_dllexport] = ACTIONS(623),
    [anon_sym_ccc] = ACTIONS(623),
    [anon_sym_fastcc] = ACTIONS(623),
    [anon_sym_coldcc] = ACTIONS(623),
    [anon_sym_webkit_jscc] = ACTIONS(625),
    [anon_sym_anyregcc] = ACTIONS(623),
    [anon_sym_preserve_mostcc] = ACTIONS(623),
    [anon_sym_preserve_allcc] = ACTIONS(623),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(625),
    [anon_sym_tailcc] = ACTIONS(623),
    [anon_sym_swiftcc] = ACTIONS(625),
    [anon_sym_swifttailcc] = ACTIONS(625),
    [anon_sym_cfguard_checkcc] = ACTIONS(623),
    [aux_sym_calling_conv_token1] = ACTIONS(625),
    [aux_sym_calling_conv_token2] = ACTIONS(623),
    [aux_sym_calling_conv_token3] = ACTIONS(623),
    [aux_sym_calling_conv_token4] = ACTIONS(623),
    [aux_sym_calling_conv_token5] = ACTIONS(623),
    [aux_sym_calling_conv_token6] = ACTIONS(623),
    [aux_sym_calling_conv_token7] = ACTIONS(623),
    [aux_sym_calling_conv_token8] = ACTIONS(623),
    [aux_sym_calling_conv_token9] = ACTIONS(623),
    [aux_sym_calling_conv_token10] = ACTIONS(625),
    [anon_sym_ghccc] = ACTIONS(623),
    [aux_sym_calling_conv_token11] = ACTIONS(625),
    [aux_sym_calling_conv_token12] = ACTIONS(623),
    [aux_sym_calling_conv_token13] = ACTIONS(625),
    [aux_sym_calling_conv_token14] = ACTIONS(623),
    [anon_sym_cc] = ACTIONS(625),
    [anon_sym_unnamed_addr] = ACTIONS(623),
    [anon_sym_local_unnamed_addr] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(623),
    [anon_sym_half] = ACTIONS(623),
    [anon_sym_bfloat] = ACTIONS(623),
    [anon_sym_float] = ACTIONS(623),
    [anon_sym_double] = ACTIONS(623),
    [anon_sym_x86_fp80] = ACTIONS(625),
    [anon_sym_fp128] = ACTIONS(623),
    [anon_sym_ppc_fp128] = ACTIONS(623),
    [anon_sym_label] = ACTIONS(623),
    [anon_sym_metadata] = ACTIONS(623),
    [anon_sym_x86_mmx] = ACTIONS(625),
    [anon_sym_x86_amx] = ACTIONS(625),
    [anon_sym_token] = ACTIONS(623),
    [anon_sym_opaque] = ACTIONS(623),
    [anon_sym_ptr] = ACTIONS(623),
    [aux_sym_type_keyword_token1] = ACTIONS(623),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(623),
    [anon_sym_LT_LBRACE] = ACTIONS(623),
    [anon_sym_LBRACK] = ACTIONS(623),
    [anon_sym_RBRACK] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(625),
    [anon_sym_GT] = ACTIONS(623),
    [anon_sym_COMMA] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_RPAREN] = ACTIONS(623),
    [anon_sym_align] = ACTIONS(625),
    [anon_sym_alignstack] = ACTIONS(623),
    [anon_sym_allocsize] = ACTIONS(623),
    [anon_sym_alwaysinline] = ACTIONS(623),
    [anon_sym_builtin] = ACTIONS(623),
    [anon_sym_cold] = ACTIONS(625),
    [anon_sym_convergent] = ACTIONS(623),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(623),
    [anon_sym_hot] = ACTIONS(623),
    [anon_sym_inaccessiblememonly] = ACTIONS(623),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(623),
    [anon_sym_inlinehint] = ACTIONS(623),
    [anon_sym_jumptable] = ACTIONS(623),
    [anon_sym_minsize] = ACTIONS(623),
    [anon_sym_naked] = ACTIONS(623),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(623),
    [anon_sym_nobuiltin] = ACTIONS(623),
    [anon_sym_noduplicate] = ACTIONS(623),
    [anon_sym_nofree] = ACTIONS(623),
    [anon_sym_noimplicitfloat] = ACTIONS(623),
    [anon_sym_noinline] = ACTIONS(623),
    [anon_sym_nomerge] = ACTIONS(623),
    [anon_sym_nonlazybind] = ACTIONS(623),
    [anon_sym_noprofile] = ACTIONS(623),
    [anon_sym_noredzone] = ACTIONS(623),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(623),
    [anon_sym_noreturn] = ACTIONS(623),
    [anon_sym_norecurse] = ACTIONS(623),
    [anon_sym_willreturn] = ACTIONS(623),
    [anon_sym_nosync] = ACTIONS(623),
    [anon_sym_nounwind] = ACTIONS(623),
    [anon_sym_nocallback] = ACTIONS(623),
    [anon_sym_nosanitize_coverage] = ACTIONS(623),
    [anon_sym_null_pointer_is_valid] = ACTIONS(623),
    [anon_sym_optforfuzzing] = ACTIONS(623),
    [anon_sym_optnone] = ACTIONS(623),
    [anon_sym_optsize] = ACTIONS(623),
    [anon_sym_readnone] = ACTIONS(623),
    [anon_sym_readonly] = ACTIONS(623),
    [anon_sym_writeonly] = ACTIONS(623),
    [anon_sym_argmemonly] = ACTIONS(623),
    [anon_sym_returns_twice] = ACTIONS(623),
    [anon_sym_safestack] = ACTIONS(623),
    [anon_sym_sanitize_address] = ACTIONS(623),
    [anon_sym_sanitize_memory] = ACTIONS(623),
    [anon_sym_sanitize_thread] = ACTIONS(623),
    [anon_sym_sanitize_hwaddress] = ACTIONS(623),
    [anon_sym_sanitize_memtag] = ACTIONS(623),
    [anon_sym_speculative_load_hardening] = ACTIONS(623),
    [anon_sym_speculatable] = ACTIONS(623),
    [anon_sym_ssp] = ACTIONS(625),
    [anon_sym_sspstrong] = ACTIONS(623),
    [anon_sym_sspreq] = ACTIONS(623),
    [anon_sym_strictfp] = ACTIONS(623),
    [anon_sym_nocf_check] = ACTIONS(623),
    [anon_sym_shadowcallstack] = ACTIONS(623),
    [anon_sym_mustprogress] = ACTIONS(623),
    [anon_sym_vscale_range] = ACTIONS(623),
    [anon_sym_preallocated] = ACTIONS(623),
    [anon_sym_zeroext] = ACTIONS(623),
    [anon_sym_signext] = ACTIONS(623),
    [anon_sym_inreg] = ACTIONS(623),
    [anon_sym_byval] = ACTIONS(623),
    [anon_sym_byref] = ACTIONS(623),
    [anon_sym_inalloca] = ACTIONS(623),
    [anon_sym_sret] = ACTIONS(623),
    [anon_sym_elementtype] = ACTIONS(623),
    [anon_sym_noalias] = ACTIONS(623),
    [anon_sym_nocapture] = ACTIONS(623),
    [anon_sym_nest] = ACTIONS(623),
    [anon_sym_returned] = ACTIONS(623),
    [anon_sym_nonnull] = ACTIONS(623),
    [anon_sym_dereferenceable] = ACTIONS(625),
    [anon_sym_dereferenceable_or_null] = ACTIONS(623),
    [anon_sym_swiftself] = ACTIONS(625),
    [anon_sym_swiftasync] = ACTIONS(625),
    [anon_sym_swifterror] = ACTIONS(625),
    [anon_sym_immarg] = ACTIONS(623),
    [anon_sym_noundef] = ACTIONS(623),
    [anon_sym_uwtable] = ACTIONS(623),
    [anon_sym_memory] = ACTIONS(623),
    [anon_sym_to] = ACTIONS(625),
    [anon_sym_unwind] = ACTIONS(623),
    [anon_sym_unordered] = ACTIONS(623),
    [anon_sym_monotonic] = ACTIONS(623),
    [anon_sym_acquire] = ACTIONS(623),
    [anon_sym_release] = ACTIONS(623),
    [anon_sym_acq_rel] = ACTIONS(623),
    [anon_sym_seq_cst] = ACTIONS(623),
    [anon_sym_syncscope] = ACTIONS(623),
    [anon_sym_uselistorder] = ACTIONS(625),
    [anon_sym_uselistorder_bb] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_attributes] = ACTIONS(623),
  },
  [113] = {
    [ts_builtin_sym_end] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(627),
    [sym_global_var] = ACTIONS(627),
    [sym_local_var] = ACTIONS(627),
    [aux_sym_metadata_ref_token1] = ACTIONS(627),
    [sym_summary_ref] = ACTIONS(627),
    [sym_string] = ACTIONS(627),
    [anon_sym_target] = ACTIONS(627),
    [anon_sym_source_filename] = ACTIONS(627),
    [anon_sym_declare] = ACTIONS(627),
    [anon_sym_define] = ACTIONS(627),
    [anon_sym_no_cfi] = ACTIONS(627),
    [anon_sym_private] = ACTIONS(627),
    [anon_sym_internal] = ACTIONS(627),
    [anon_sym_weak] = ACTIONS(629),
    [anon_sym_weak_odr] = ACTIONS(627),
    [anon_sym_linkonce] = ACTIONS(629),
    [anon_sym_linkonce_odr] = ACTIONS(627),
    [anon_sym_available_externally] = ACTIONS(627),
    [anon_sym_appending] = ACTIONS(627),
    [anon_sym_common] = ACTIONS(627),
    [anon_sym_extern_weak] = ACTIONS(627),
    [anon_sym_external] = ACTIONS(627),
    [anon_sym_dso_local] = ACTIONS(629),
    [anon_sym_dso_local_equivalent] = ACTIONS(627),
    [anon_sym_dso_preemptable] = ACTIONS(627),
    [anon_sym_default] = ACTIONS(627),
    [anon_sym_hidden] = ACTIONS(627),
    [anon_sym_protected] = ACTIONS(627),
    [anon_sym_dllimport] = ACTIONS(627),
    [anon_sym_dllexport] = ACTIONS(627),
    [anon_sym_ccc] = ACTIONS(627),
    [anon_sym_fastcc] = ACTIONS(627),
    [anon_sym_coldcc] = ACTIONS(627),
    [anon_sym_webkit_jscc] = ACTIONS(629),
    [anon_sym_anyregcc] = ACTIONS(627),
    [anon_sym_preserve_mostcc] = ACTIONS(627),
    [anon_sym_preserve_allcc] = ACTIONS(627),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(629),
    [anon_sym_tailcc] = ACTIONS(627),
    [anon_sym_swiftcc] = ACTIONS(629),
    [anon_sym_swifttailcc] = ACTIONS(629),
    [anon_sym_cfguard_checkcc] = ACTIONS(627),
    [aux_sym_calling_conv_token1] = ACTIONS(629),
    [aux_sym_calling_conv_token2] = ACTIONS(627),
    [aux_sym_calling_conv_token3] = ACTIONS(627),
    [aux_sym_calling_conv_token4] = ACTIONS(627),
    [aux_sym_calling_conv_token5] = ACTIONS(627),
    [aux_sym_calling_conv_token6] = ACTIONS(627),
    [aux_sym_calling_conv_token7] = ACTIONS(627),
    [aux_sym_calling_conv_token8] = ACTIONS(627),
    [aux_sym_calling_conv_token9] = ACTIONS(627),
    [aux_sym_calling_conv_token10] = ACTIONS(629),
    [anon_sym_ghccc] = ACTIONS(627),
    [aux_sym_calling_conv_token11] = ACTIONS(629),
    [aux_sym_calling_conv_token12] = ACTIONS(627),
    [aux_sym_calling_conv_token13] = ACTIONS(629),
    [aux_sym_calling_conv_token14] = ACTIONS(627),
    [anon_sym_cc] = ACTIONS(629),
    [anon_sym_unnamed_addr] = ACTIONS(627),
    [anon_sym_local_unnamed_addr] = ACTIONS(627),
    [anon_sym_void] = ACTIONS(627),
    [anon_sym_half] = ACTIONS(627),
    [anon_sym_bfloat] = ACTIONS(627),
    [anon_sym_float] = ACTIONS(627),
    [anon_sym_double] = ACTIONS(627),
    [anon_sym_x86_fp80] = ACTIONS(629),
    [anon_sym_fp128] = ACTIONS(627),
    [anon_sym_ppc_fp128] = ACTIONS(627),
    [anon_sym_label] = ACTIONS(627),
    [anon_sym_metadata] = ACTIONS(627),
    [anon_sym_x86_mmx] = ACTIONS(629),
    [anon_sym_x86_amx] = ACTIONS(629),
    [anon_sym_token] = ACTIONS(627),
    [anon_sym_opaque] = ACTIONS(627),
    [anon_sym_ptr] = ACTIONS(627),
    [aux_sym_type_keyword_token1] = ACTIONS(627),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_RBRACE] = ACTIONS(627),
    [anon_sym_LT_LBRACE] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_RBRACK] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(629),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_COMMA] = ACTIONS(627),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_RPAREN] = ACTIONS(627),
    [anon_sym_align] = ACTIONS(629),
    [anon_sym_alignstack] = ACTIONS(627),
    [anon_sym_allocsize] = ACTIONS(627),
    [anon_sym_alwaysinline] = ACTIONS(627),
    [anon_sym_builtin] = ACTIONS(627),
    [anon_sym_cold] = ACTIONS(629),
    [anon_sym_convergent] = ACTIONS(627),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(627),
    [anon_sym_hot] = ACTIONS(627),
    [anon_sym_inaccessiblememonly] = ACTIONS(627),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(627),
    [anon_sym_inlinehint] = ACTIONS(627),
    [anon_sym_jumptable] = ACTIONS(627),
    [anon_sym_minsize] = ACTIONS(627),
    [anon_sym_naked] = ACTIONS(627),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(627),
    [anon_sym_nobuiltin] = ACTIONS(627),
    [anon_sym_noduplicate] = ACTIONS(627),
    [anon_sym_nofree] = ACTIONS(627),
    [anon_sym_noimplicitfloat] = ACTIONS(627),
    [anon_sym_noinline] = ACTIONS(627),
    [anon_sym_nomerge] = ACTIONS(627),
    [anon_sym_nonlazybind] = ACTIONS(627),
    [anon_sym_noprofile] = ACTIONS(627),
    [anon_sym_noredzone] = ACTIONS(627),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(627),
    [anon_sym_noreturn] = ACTIONS(627),
    [anon_sym_norecurse] = ACTIONS(627),
    [anon_sym_willreturn] = ACTIONS(627),
    [anon_sym_nosync] = ACTIONS(627),
    [anon_sym_nounwind] = ACTIONS(627),
    [anon_sym_nocallback] = ACTIONS(627),
    [anon_sym_nosanitize_coverage] = ACTIONS(627),
    [anon_sym_null_pointer_is_valid] = ACTIONS(627),
    [anon_sym_optforfuzzing] = ACTIONS(627),
    [anon_sym_optnone] = ACTIONS(627),
    [anon_sym_optsize] = ACTIONS(627),
    [anon_sym_readnone] = ACTIONS(627),
    [anon_sym_readonly] = ACTIONS(627),
    [anon_sym_writeonly] = ACTIONS(627),
    [anon_sym_argmemonly] = ACTIONS(627),
    [anon_sym_returns_twice] = ACTIONS(627),
    [anon_sym_safestack] = ACTIONS(627),
    [anon_sym_sanitize_address] = ACTIONS(627),
    [anon_sym_sanitize_memory] = ACTIONS(627),
    [anon_sym_sanitize_thread] = ACTIONS(627),
    [anon_sym_sanitize_hwaddress] = ACTIONS(627),
    [anon_sym_sanitize_memtag] = ACTIONS(627),
    [anon_sym_speculative_load_hardening] = ACTIONS(627),
    [anon_sym_speculatable] = ACTIONS(627),
    [anon_sym_ssp] = ACTIONS(629),
    [anon_sym_sspstrong] = ACTIONS(627),
    [anon_sym_sspreq] = ACTIONS(627),
    [anon_sym_strictfp] = ACTIONS(627),
    [anon_sym_nocf_check] = ACTIONS(627),
    [anon_sym_shadowcallstack] = ACTIONS(627),
    [anon_sym_mustprogress] = ACTIONS(627),
    [anon_sym_vscale_range] = ACTIONS(627),
    [anon_sym_preallocated] = ACTIONS(627),
    [anon_sym_zeroext] = ACTIONS(627),
    [anon_sym_signext] = ACTIONS(627),
    [anon_sym_inreg] = ACTIONS(627),
    [anon_sym_byval] = ACTIONS(627),
    [anon_sym_byref] = ACTIONS(627),
    [anon_sym_inalloca] = ACTIONS(627),
    [anon_sym_sret] = ACTIONS(627),
    [anon_sym_elementtype] = ACTIONS(627),
    [anon_sym_noalias] = ACTIONS(627),
    [anon_sym_nocapture] = ACTIONS(627),
    [anon_sym_nest] = ACTIONS(627),
    [anon_sym_returned] = ACTIONS(627),
    [anon_sym_nonnull] = ACTIONS(627),
    [anon_sym_dereferenceable] = ACTIONS(629),
    [anon_sym_dereferenceable_or_null] = ACTIONS(627),
    [anon_sym_swiftself] = ACTIONS(629),
    [anon_sym_swiftasync] = ACTIONS(629),
    [anon_sym_swifterror] = ACTIONS(629),
    [anon_sym_immarg] = ACTIONS(627),
    [anon_sym_noundef] = ACTIONS(627),
    [anon_sym_uwtable] = ACTIONS(627),
    [anon_sym_memory] = ACTIONS(627),
    [anon_sym_to] = ACTIONS(629),
    [anon_sym_unwind] = ACTIONS(627),
    [anon_sym_unordered] = ACTIONS(627),
    [anon_sym_monotonic] = ACTIONS(627),
    [anon_sym_acquire] = ACTIONS(627),
    [anon_sym_release] = ACTIONS(627),
    [anon_sym_acq_rel] = ACTIONS(627),
    [anon_sym_seq_cst] = ACTIONS(627),
    [anon_sym_syncscope] = ACTIONS(627),
    [anon_sym_uselistorder] = ACTIONS(629),
    [anon_sym_uselistorder_bb] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(627),
    [anon_sym_attributes] = ACTIONS(627),
  },
  [114] = {
    [ts_builtin_sym_end] = ACTIONS(631),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(631),
    [sym_global_var] = ACTIONS(631),
    [sym_local_var] = ACTIONS(631),
    [aux_sym_metadata_ref_token1] = ACTIONS(631),
    [sym_summary_ref] = ACTIONS(631),
    [sym_string] = ACTIONS(631),
    [anon_sym_target] = ACTIONS(631),
    [anon_sym_source_filename] = ACTIONS(631),
    [anon_sym_declare] = ACTIONS(631),
    [anon_sym_define] = ACTIONS(631),
    [anon_sym_no_cfi] = ACTIONS(631),
    [anon_sym_private] = ACTIONS(631),
    [anon_sym_internal] = ACTIONS(631),
    [anon_sym_weak] = ACTIONS(633),
    [anon_sym_weak_odr] = ACTIONS(631),
    [anon_sym_linkonce] = ACTIONS(633),
    [anon_sym_linkonce_odr] = ACTIONS(631),
    [anon_sym_available_externally] = ACTIONS(631),
    [anon_sym_appending] = ACTIONS(631),
    [anon_sym_common] = ACTIONS(631),
    [anon_sym_extern_weak] = ACTIONS(631),
    [anon_sym_external] = ACTIONS(631),
    [anon_sym_dso_local] = ACTIONS(633),
    [anon_sym_dso_local_equivalent] = ACTIONS(631),
    [anon_sym_dso_preemptable] = ACTIONS(631),
    [anon_sym_default] = ACTIONS(631),
    [anon_sym_hidden] = ACTIONS(631),
    [anon_sym_protected] = ACTIONS(631),
    [anon_sym_dllimport] = ACTIONS(631),
    [anon_sym_dllexport] = ACTIONS(631),
    [anon_sym_ccc] = ACTIONS(631),
    [anon_sym_fastcc] = ACTIONS(631),
    [anon_sym_coldcc] = ACTIONS(631),
    [anon_sym_webkit_jscc] = ACTIONS(633),
    [anon_sym_anyregcc] = ACTIONS(631),
    [anon_sym_preserve_mostcc] = ACTIONS(631),
    [anon_sym_preserve_allcc] = ACTIONS(631),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(633),
    [anon_sym_tailcc] = ACTIONS(631),
    [anon_sym_swiftcc] = ACTIONS(633),
    [anon_sym_swifttailcc] = ACTIONS(633),
    [anon_sym_cfguard_checkcc] = ACTIONS(631),
    [aux_sym_calling_conv_token1] = ACTIONS(633),
    [aux_sym_calling_conv_token2] = ACTIONS(631),
    [aux_sym_calling_conv_token3] = ACTIONS(631),
    [aux_sym_calling_conv_token4] = ACTIONS(631),
    [aux_sym_calling_conv_token5] = ACTIONS(631),
    [aux_sym_calling_conv_token6] = ACTIONS(631),
    [aux_sym_calling_conv_token7] = ACTIONS(631),
    [aux_sym_calling_conv_token8] = ACTIONS(631),
    [aux_sym_calling_conv_token9] = ACTIONS(631),
    [aux_sym_calling_conv_token10] = ACTIONS(633),
    [anon_sym_ghccc] = ACTIONS(631),
    [aux_sym_calling_conv_token11] = ACTIONS(633),
    [aux_sym_calling_conv_token12] = ACTIONS(631),
    [aux_sym_calling_conv_token13] = ACTIONS(633),
    [aux_sym_calling_conv_token14] = ACTIONS(631),
    [anon_sym_cc] = ACTIONS(633),
    [anon_sym_unnamed_addr] = ACTIONS(631),
    [anon_sym_local_unnamed_addr] = ACTIONS(631),
    [anon_sym_void] = ACTIONS(631),
    [anon_sym_half] = ACTIONS(631),
    [anon_sym_bfloat] = ACTIONS(631),
    [anon_sym_float] = ACTIONS(631),
    [anon_sym_double] = ACTIONS(631),
    [anon_sym_x86_fp80] = ACTIONS(633),
    [anon_sym_fp128] = ACTIONS(631),
    [anon_sym_ppc_fp128] = ACTIONS(631),
    [anon_sym_label] = ACTIONS(631),
    [anon_sym_metadata] = ACTIONS(631),
    [anon_sym_x86_mmx] = ACTIONS(633),
    [anon_sym_x86_amx] = ACTIONS(633),
    [anon_sym_token] = ACTIONS(631),
    [anon_sym_opaque] = ACTIONS(631),
    [anon_sym_ptr] = ACTIONS(631),
    [aux_sym_type_keyword_token1] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(631),
    [anon_sym_RBRACE] = ACTIONS(631),
    [anon_sym_LT_LBRACE] = ACTIONS(631),
    [anon_sym_LBRACK] = ACTIONS(631),
    [anon_sym_RBRACK] = ACTIONS(631),
    [anon_sym_LT] = ACTIONS(633),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_COMMA] = ACTIONS(631),
    [anon_sym_LPAREN] = ACTIONS(631),
    [anon_sym_RPAREN] = ACTIONS(631),
    [anon_sym_align] = ACTIONS(633),
    [anon_sym_alignstack] = ACTIONS(631),
    [anon_sym_allocsize] = ACTIONS(631),
    [anon_sym_alwaysinline] = ACTIONS(631),
    [anon_sym_builtin] = ACTIONS(631),
    [anon_sym_cold] = ACTIONS(633),
    [anon_sym_convergent] = ACTIONS(631),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(631),
    [anon_sym_hot] = ACTIONS(631),
    [anon_sym_inaccessiblememonly] = ACTIONS(631),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(631),
    [anon_sym_inlinehint] = ACTIONS(631),
    [anon_sym_jumptable] = ACTIONS(631),
    [anon_sym_minsize] = ACTIONS(631),
    [anon_sym_naked] = ACTIONS(631),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(631),
    [anon_sym_nobuiltin] = ACTIONS(631),
    [anon_sym_noduplicate] = ACTIONS(631),
    [anon_sym_nofree] = ACTIONS(631),
    [anon_sym_noimplicitfloat] = ACTIONS(631),
    [anon_sym_noinline] = ACTIONS(631),
    [anon_sym_nomerge] = ACTIONS(631),
    [anon_sym_nonlazybind] = ACTIONS(631),
    [anon_sym_noprofile] = ACTIONS(631),
    [anon_sym_noredzone] = ACTIONS(631),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(631),
    [anon_sym_noreturn] = ACTIONS(631),
    [anon_sym_norecurse] = ACTIONS(631),
    [anon_sym_willreturn] = ACTIONS(631),
    [anon_sym_nosync] = ACTIONS(631),
    [anon_sym_nounwind] = ACTIONS(631),
    [anon_sym_nocallback] = ACTIONS(631),
    [anon_sym_nosanitize_coverage] = ACTIONS(631),
    [anon_sym_null_pointer_is_valid] = ACTIONS(631),
    [anon_sym_optforfuzzing] = ACTIONS(631),
    [anon_sym_optnone] = ACTIONS(631),
    [anon_sym_optsize] = ACTIONS(631),
    [anon_sym_readnone] = ACTIONS(631),
    [anon_sym_readonly] = ACTIONS(631),
    [anon_sym_writeonly] = ACTIONS(631),
    [anon_sym_argmemonly] = ACTIONS(631),
    [anon_sym_returns_twice] = ACTIONS(631),
    [anon_sym_safestack] = ACTIONS(631),
    [anon_sym_sanitize_address] = ACTIONS(631),
    [anon_sym_sanitize_memory] = ACTIONS(631),
    [anon_sym_sanitize_thread] = ACTIONS(631),
    [anon_sym_sanitize_hwaddress] = ACTIONS(631),
    [anon_sym_sanitize_memtag] = ACTIONS(631),
    [anon_sym_speculative_load_hardening] = ACTIONS(631),
    [anon_sym_speculatable] = ACTIONS(631),
    [anon_sym_ssp] = ACTIONS(633),
    [anon_sym_sspstrong] = ACTIONS(631),
    [anon_sym_sspreq] = ACTIONS(631),
    [anon_sym_strictfp] = ACTIONS(631),
    [anon_sym_nocf_check] = ACTIONS(631),
    [anon_sym_shadowcallstack] = ACTIONS(631),
    [anon_sym_mustprogress] = ACTIONS(631),
    [anon_sym_vscale_range] = ACTIONS(631),
    [anon_sym_preallocated] = ACTIONS(631),
    [anon_sym_zeroext] = ACTIONS(631),
    [anon_sym_signext] = ACTIONS(631),
    [anon_sym_inreg] = ACTIONS(631),
    [anon_sym_byval] = ACTIONS(631),
    [anon_sym_byref] = ACTIONS(631),
    [anon_sym_inalloca] = ACTIONS(631),
    [anon_sym_sret] = ACTIONS(631),
    [anon_sym_elementtype] = ACTIONS(631),
    [anon_sym_noalias] = ACTIONS(631),
    [anon_sym_nocapture] = ACTIONS(631),
    [anon_sym_nest] = ACTIONS(631),
    [anon_sym_returned] = ACTIONS(631),
    [anon_sym_nonnull] = ACTIONS(631),
    [anon_sym_dereferenceable] = ACTIONS(633),
    [anon_sym_dereferenceable_or_null] = ACTIONS(631),
    [anon_sym_swiftself] = ACTIONS(633),
    [anon_sym_swiftasync] = ACTIONS(633),
    [anon_sym_swifterror] = ACTIONS(633),
    [anon_sym_immarg] = ACTIONS(631),
    [anon_sym_noundef] = ACTIONS(631),
    [anon_sym_uwtable] = ACTIONS(631),
    [anon_sym_memory] = ACTIONS(631),
    [anon_sym_to] = ACTIONS(633),
    [anon_sym_unwind] = ACTIONS(631),
    [anon_sym_unordered] = ACTIONS(631),
    [anon_sym_monotonic] = ACTIONS(631),
    [anon_sym_acquire] = ACTIONS(631),
    [anon_sym_release] = ACTIONS(631),
    [anon_sym_acq_rel] = ACTIONS(631),
    [anon_sym_seq_cst] = ACTIONS(631),
    [anon_sym_syncscope] = ACTIONS(631),
    [anon_sym_uselistorder] = ACTIONS(633),
    [anon_sym_uselistorder_bb] = ACTIONS(631),
    [anon_sym_module] = ACTIONS(631),
    [anon_sym_attributes] = ACTIONS(631),
  },
  [115] = {
    [ts_builtin_sym_end] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(635),
    [sym_global_var] = ACTIONS(635),
    [sym_local_var] = ACTIONS(635),
    [aux_sym_metadata_ref_token1] = ACTIONS(635),
    [sym_summary_ref] = ACTIONS(635),
    [sym_string] = ACTIONS(635),
    [anon_sym_target] = ACTIONS(635),
    [anon_sym_source_filename] = ACTIONS(635),
    [anon_sym_declare] = ACTIONS(635),
    [anon_sym_define] = ACTIONS(635),
    [anon_sym_no_cfi] = ACTIONS(635),
    [anon_sym_private] = ACTIONS(635),
    [anon_sym_internal] = ACTIONS(635),
    [anon_sym_weak] = ACTIONS(637),
    [anon_sym_weak_odr] = ACTIONS(635),
    [anon_sym_linkonce] = ACTIONS(637),
    [anon_sym_linkonce_odr] = ACTIONS(635),
    [anon_sym_available_externally] = ACTIONS(635),
    [anon_sym_appending] = ACTIONS(635),
    [anon_sym_common] = ACTIONS(635),
    [anon_sym_extern_weak] = ACTIONS(635),
    [anon_sym_external] = ACTIONS(635),
    [anon_sym_dso_local] = ACTIONS(637),
    [anon_sym_dso_local_equivalent] = ACTIONS(635),
    [anon_sym_dso_preemptable] = ACTIONS(635),
    [anon_sym_default] = ACTIONS(635),
    [anon_sym_hidden] = ACTIONS(635),
    [anon_sym_protected] = ACTIONS(635),
    [anon_sym_dllimport] = ACTIONS(635),
    [anon_sym_dllexport] = ACTIONS(635),
    [anon_sym_ccc] = ACTIONS(635),
    [anon_sym_fastcc] = ACTIONS(635),
    [anon_sym_coldcc] = ACTIONS(635),
    [anon_sym_webkit_jscc] = ACTIONS(637),
    [anon_sym_anyregcc] = ACTIONS(635),
    [anon_sym_preserve_mostcc] = ACTIONS(635),
    [anon_sym_preserve_allcc] = ACTIONS(635),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(637),
    [anon_sym_tailcc] = ACTIONS(635),
    [anon_sym_swiftcc] = ACTIONS(637),
    [anon_sym_swifttailcc] = ACTIONS(637),
    [anon_sym_cfguard_checkcc] = ACTIONS(635),
    [aux_sym_calling_conv_token1] = ACTIONS(637),
    [aux_sym_calling_conv_token2] = ACTIONS(635),
    [aux_sym_calling_conv_token3] = ACTIONS(635),
    [aux_sym_calling_conv_token4] = ACTIONS(635),
    [aux_sym_calling_conv_token5] = ACTIONS(635),
    [aux_sym_calling_conv_token6] = ACTIONS(635),
    [aux_sym_calling_conv_token7] = ACTIONS(635),
    [aux_sym_calling_conv_token8] = ACTIONS(635),
    [aux_sym_calling_conv_token9] = ACTIONS(635),
    [aux_sym_calling_conv_token10] = ACTIONS(637),
    [anon_sym_ghccc] = ACTIONS(635),
    [aux_sym_calling_conv_token11] = ACTIONS(637),
    [aux_sym_calling_conv_token12] = ACTIONS(635),
    [aux_sym_calling_conv_token13] = ACTIONS(637),
    [aux_sym_calling_conv_token14] = ACTIONS(635),
    [anon_sym_cc] = ACTIONS(637),
    [anon_sym_unnamed_addr] = ACTIONS(635),
    [anon_sym_local_unnamed_addr] = ACTIONS(635),
    [anon_sym_void] = ACTIONS(635),
    [anon_sym_half] = ACTIONS(635),
    [anon_sym_bfloat] = ACTIONS(635),
    [anon_sym_float] = ACTIONS(635),
    [anon_sym_double] = ACTIONS(635),
    [anon_sym_x86_fp80] = ACTIONS(637),
    [anon_sym_fp128] = ACTIONS(635),
    [anon_sym_ppc_fp128] = ACTIONS(635),
    [anon_sym_label] = ACTIONS(635),
    [anon_sym_metadata] = ACTIONS(635),
    [anon_sym_x86_mmx] = ACTIONS(637),
    [anon_sym_x86_amx] = ACTIONS(637),
    [anon_sym_token] = ACTIONS(635),
    [anon_sym_opaque] = ACTIONS(635),
    [anon_sym_ptr] = ACTIONS(635),
    [aux_sym_type_keyword_token1] = ACTIONS(635),
    [anon_sym_LBRACE] = ACTIONS(635),
    [anon_sym_RBRACE] = ACTIONS(635),
    [anon_sym_LT_LBRACE] = ACTIONS(635),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(637),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_COMMA] = ACTIONS(635),
    [anon_sym_LPAREN] = ACTIONS(635),
    [anon_sym_RPAREN] = ACTIONS(635),
    [anon_sym_align] = ACTIONS(637),
    [anon_sym_alignstack] = ACTIONS(635),
    [anon_sym_allocsize] = ACTIONS(635),
    [anon_sym_alwaysinline] = ACTIONS(635),
    [anon_sym_builtin] = ACTIONS(635),
    [anon_sym_cold] = ACTIONS(637),
    [anon_sym_convergent] = ACTIONS(635),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(635),
    [anon_sym_hot] = ACTIONS(635),
    [anon_sym_inaccessiblememonly] = ACTIONS(635),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(635),
    [anon_sym_inlinehint] = ACTIONS(635),
    [anon_sym_jumptable] = ACTIONS(635),
    [anon_sym_minsize] = ACTIONS(635),
    [anon_sym_naked] = ACTIONS(635),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(635),
    [anon_sym_nobuiltin] = ACTIONS(635),
    [anon_sym_noduplicate] = ACTIONS(635),
    [anon_sym_nofree] = ACTIONS(635),
    [anon_sym_noimplicitfloat] = ACTIONS(635),
    [anon_sym_noinline] = ACTIONS(635),
    [anon_sym_nomerge] = ACTIONS(635),
    [anon_sym_nonlazybind] = ACTIONS(635),
    [anon_sym_noprofile] = ACTIONS(635),
    [anon_sym_noredzone] = ACTIONS(635),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(635),
    [anon_sym_noreturn] = ACTIONS(635),
    [anon_sym_norecurse] = ACTIONS(635),
    [anon_sym_willreturn] = ACTIONS(635),
    [anon_sym_nosync] = ACTIONS(635),
    [anon_sym_nounwind] = ACTIONS(635),
    [anon_sym_nocallback] = ACTIONS(635),
    [anon_sym_nosanitize_coverage] = ACTIONS(635),
    [anon_sym_null_pointer_is_valid] = ACTIONS(635),
    [anon_sym_optforfuzzing] = ACTIONS(635),
    [anon_sym_optnone] = ACTIONS(635),
    [anon_sym_optsize] = ACTIONS(635),
    [anon_sym_readnone] = ACTIONS(635),
    [anon_sym_readonly] = ACTIONS(635),
    [anon_sym_writeonly] = ACTIONS(635),
    [anon_sym_argmemonly] = ACTIONS(635),
    [anon_sym_returns_twice] = ACTIONS(635),
    [anon_sym_safestack] = ACTIONS(635),
    [anon_sym_sanitize_address] = ACTIONS(635),
    [anon_sym_sanitize_memory] = ACTIONS(635),
    [anon_sym_sanitize_thread] = ACTIONS(635),
    [anon_sym_sanitize_hwaddress] = ACTIONS(635),
    [anon_sym_sanitize_memtag] = ACTIONS(635),
    [anon_sym_speculative_load_hardening] = ACTIONS(635),
    [anon_sym_speculatable] = ACTIONS(635),
    [anon_sym_ssp] = ACTIONS(637),
    [anon_sym_sspstrong] = ACTIONS(635),
    [anon_sym_sspreq] = ACTIONS(635),
    [anon_sym_strictfp] = ACTIONS(635),
    [anon_sym_nocf_check] = ACTIONS(635),
    [anon_sym_shadowcallstack] = ACTIONS(635),
    [anon_sym_mustprogress] = ACTIONS(635),
    [anon_sym_vscale_range] = ACTIONS(635),
    [anon_sym_preallocated] = ACTIONS(635),
    [anon_sym_zeroext] = ACTIONS(635),
    [anon_sym_signext] = ACTIONS(635),
    [anon_sym_inreg] = ACTIONS(635),
    [anon_sym_byval] = ACTIONS(635),
    [anon_sym_byref] = ACTIONS(635),
    [anon_sym_inalloca] = ACTIONS(635),
    [anon_sym_sret] = ACTIONS(635),
    [anon_sym_elementtype] = ACTIONS(635),
    [anon_sym_noalias] = ACTIONS(635),
    [anon_sym_nocapture] = ACTIONS(635),
    [anon_sym_nest] = ACTIONS(635),
    [anon_sym_returned] = ACTIONS(635),
    [anon_sym_nonnull] = ACTIONS(635),
    [anon_sym_dereferenceable] = ACTIONS(637),
    [anon_sym_dereferenceable_or_null] = ACTIONS(635),
    [anon_sym_swiftself] = ACTIONS(637),
    [anon_sym_swiftasync] = ACTIONS(637),
    [anon_sym_swifterror] = ACTIONS(637),
    [anon_sym_immarg] = ACTIONS(635),
    [anon_sym_noundef] = ACTIONS(635),
    [anon_sym_uwtable] = ACTIONS(635),
    [anon_sym_memory] = ACTIONS(635),
    [anon_sym_to] = ACTIONS(637),
    [anon_sym_unwind] = ACTIONS(635),
    [anon_sym_unordered] = ACTIONS(635),
    [anon_sym_monotonic] = ACTIONS(635),
    [anon_sym_acquire] = ACTIONS(635),
    [anon_sym_release] = ACTIONS(635),
    [anon_sym_acq_rel] = ACTIONS(635),
    [anon_sym_seq_cst] = ACTIONS(635),
    [anon_sym_syncscope] = ACTIONS(635),
    [anon_sym_uselistorder] = ACTIONS(637),
    [anon_sym_uselistorder_bb] = ACTIONS(635),
    [anon_sym_module] = ACTIONS(635),
    [anon_sym_attributes] = ACTIONS(635),
  },
  [116] = {
    [ts_builtin_sym_end] = ACTIONS(639),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(639),
    [sym_global_var] = ACTIONS(639),
    [sym_local_var] = ACTIONS(639),
    [aux_sym_metadata_ref_token1] = ACTIONS(639),
    [sym_summary_ref] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [anon_sym_target] = ACTIONS(639),
    [anon_sym_source_filename] = ACTIONS(639),
    [anon_sym_declare] = ACTIONS(639),
    [anon_sym_define] = ACTIONS(639),
    [anon_sym_no_cfi] = ACTIONS(639),
    [anon_sym_private] = ACTIONS(639),
    [anon_sym_internal] = ACTIONS(639),
    [anon_sym_weak] = ACTIONS(641),
    [anon_sym_weak_odr] = ACTIONS(639),
    [anon_sym_linkonce] = ACTIONS(641),
    [anon_sym_linkonce_odr] = ACTIONS(639),
    [anon_sym_available_externally] = ACTIONS(639),
    [anon_sym_appending] = ACTIONS(639),
    [anon_sym_common] = ACTIONS(639),
    [anon_sym_extern_weak] = ACTIONS(639),
    [anon_sym_external] = ACTIONS(639),
    [anon_sym_dso_local] = ACTIONS(641),
    [anon_sym_dso_local_equivalent] = ACTIONS(639),
    [anon_sym_dso_preemptable] = ACTIONS(639),
    [anon_sym_default] = ACTIONS(639),
    [anon_sym_hidden] = ACTIONS(639),
    [anon_sym_protected] = ACTIONS(639),
    [anon_sym_dllimport] = ACTIONS(639),
    [anon_sym_dllexport] = ACTIONS(639),
    [anon_sym_ccc] = ACTIONS(639),
    [anon_sym_fastcc] = ACTIONS(639),
    [anon_sym_coldcc] = ACTIONS(639),
    [anon_sym_webkit_jscc] = ACTIONS(641),
    [anon_sym_anyregcc] = ACTIONS(639),
    [anon_sym_preserve_mostcc] = ACTIONS(639),
    [anon_sym_preserve_allcc] = ACTIONS(639),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(641),
    [anon_sym_tailcc] = ACTIONS(639),
    [anon_sym_swiftcc] = ACTIONS(641),
    [anon_sym_swifttailcc] = ACTIONS(641),
    [anon_sym_cfguard_checkcc] = ACTIONS(639),
    [aux_sym_calling_conv_token1] = ACTIONS(641),
    [aux_sym_calling_conv_token2] = ACTIONS(639),
    [aux_sym_calling_conv_token3] = ACTIONS(639),
    [aux_sym_calling_conv_token4] = ACTIONS(639),
    [aux_sym_calling_conv_token5] = ACTIONS(639),
    [aux_sym_calling_conv_token6] = ACTIONS(639),
    [aux_sym_calling_conv_token7] = ACTIONS(639),
    [aux_sym_calling_conv_token8] = ACTIONS(639),
    [aux_sym_calling_conv_token9] = ACTIONS(639),
    [aux_sym_calling_conv_token10] = ACTIONS(641),
    [anon_sym_ghccc] = ACTIONS(639),
    [aux_sym_calling_conv_token11] = ACTIONS(641),
    [aux_sym_calling_conv_token12] = ACTIONS(639),
    [aux_sym_calling_conv_token13] = ACTIONS(641),
    [aux_sym_calling_conv_token14] = ACTIONS(639),
    [anon_sym_cc] = ACTIONS(641),
    [anon_sym_unnamed_addr] = ACTIONS(639),
    [anon_sym_local_unnamed_addr] = ACTIONS(639),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_half] = ACTIONS(639),
    [anon_sym_bfloat] = ACTIONS(639),
    [anon_sym_float] = ACTIONS(639),
    [anon_sym_double] = ACTIONS(639),
    [anon_sym_x86_fp80] = ACTIONS(641),
    [anon_sym_fp128] = ACTIONS(639),
    [anon_sym_ppc_fp128] = ACTIONS(639),
    [anon_sym_label] = ACTIONS(639),
    [anon_sym_metadata] = ACTIONS(639),
    [anon_sym_x86_mmx] = ACTIONS(641),
    [anon_sym_x86_amx] = ACTIONS(641),
    [anon_sym_token] = ACTIONS(639),
    [anon_sym_opaque] = ACTIONS(639),
    [anon_sym_ptr] = ACTIONS(639),
    [aux_sym_type_keyword_token1] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(639),
    [anon_sym_RBRACE] = ACTIONS(639),
    [anon_sym_LT_LBRACE] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(639),
    [anon_sym_LT] = ACTIONS(641),
    [anon_sym_GT] = ACTIONS(639),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_RPAREN] = ACTIONS(639),
    [anon_sym_align] = ACTIONS(641),
    [anon_sym_alignstack] = ACTIONS(639),
    [anon_sym_allocsize] = ACTIONS(639),
    [anon_sym_alwaysinline] = ACTIONS(639),
    [anon_sym_builtin] = ACTIONS(639),
    [anon_sym_cold] = ACTIONS(641),
    [anon_sym_convergent] = ACTIONS(639),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(639),
    [anon_sym_hot] = ACTIONS(639),
    [anon_sym_inaccessiblememonly] = ACTIONS(639),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(639),
    [anon_sym_inlinehint] = ACTIONS(639),
    [anon_sym_jumptable] = ACTIONS(639),
    [anon_sym_minsize] = ACTIONS(639),
    [anon_sym_naked] = ACTIONS(639),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(639),
    [anon_sym_nobuiltin] = ACTIONS(639),
    [anon_sym_noduplicate] = ACTIONS(639),
    [anon_sym_nofree] = ACTIONS(639),
    [anon_sym_noimplicitfloat] = ACTIONS(639),
    [anon_sym_noinline] = ACTIONS(639),
    [anon_sym_nomerge] = ACTIONS(639),
    [anon_sym_nonlazybind] = ACTIONS(639),
    [anon_sym_noprofile] = ACTIONS(639),
    [anon_sym_noredzone] = ACTIONS(639),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(639),
    [anon_sym_noreturn] = ACTIONS(639),
    [anon_sym_norecurse] = ACTIONS(639),
    [anon_sym_willreturn] = ACTIONS(639),
    [anon_sym_nosync] = ACTIONS(639),
    [anon_sym_nounwind] = ACTIONS(639),
    [anon_sym_nocallback] = ACTIONS(639),
    [anon_sym_nosanitize_coverage] = ACTIONS(639),
    [anon_sym_null_pointer_is_valid] = ACTIONS(639),
    [anon_sym_optforfuzzing] = ACTIONS(639),
    [anon_sym_optnone] = ACTIONS(639),
    [anon_sym_optsize] = ACTIONS(639),
    [anon_sym_readnone] = ACTIONS(639),
    [anon_sym_readonly] = ACTIONS(639),
    [anon_sym_writeonly] = ACTIONS(639),
    [anon_sym_argmemonly] = ACTIONS(639),
    [anon_sym_returns_twice] = ACTIONS(639),
    [anon_sym_safestack] = ACTIONS(639),
    [anon_sym_sanitize_address] = ACTIONS(639),
    [anon_sym_sanitize_memory] = ACTIONS(639),
    [anon_sym_sanitize_thread] = ACTIONS(639),
    [anon_sym_sanitize_hwaddress] = ACTIONS(639),
    [anon_sym_sanitize_memtag] = ACTIONS(639),
    [anon_sym_speculative_load_hardening] = ACTIONS(639),
    [anon_sym_speculatable] = ACTIONS(639),
    [anon_sym_ssp] = ACTIONS(641),
    [anon_sym_sspstrong] = ACTIONS(639),
    [anon_sym_sspreq] = ACTIONS(639),
    [anon_sym_strictfp] = ACTIONS(639),
    [anon_sym_nocf_check] = ACTIONS(639),
    [anon_sym_shadowcallstack] = ACTIONS(639),
    [anon_sym_mustprogress] = ACTIONS(639),
    [anon_sym_vscale_range] = ACTIONS(639),
    [anon_sym_preallocated] = ACTIONS(639),
    [anon_sym_zeroext] = ACTIONS(639),
    [anon_sym_signext] = ACTIONS(639),
    [anon_sym_inreg] = ACTIONS(639),
    [anon_sym_byval] = ACTIONS(639),
    [anon_sym_byref] = ACTIONS(639),
    [anon_sym_inalloca] = ACTIONS(639),
    [anon_sym_sret] = ACTIONS(639),
    [anon_sym_elementtype] = ACTIONS(639),
    [anon_sym_noalias] = ACTIONS(639),
    [anon_sym_nocapture] = ACTIONS(639),
    [anon_sym_nest] = ACTIONS(639),
    [anon_sym_returned] = ACTIONS(639),
    [anon_sym_nonnull] = ACTIONS(639),
    [anon_sym_dereferenceable] = ACTIONS(641),
    [anon_sym_dereferenceable_or_null] = ACTIONS(639),
    [anon_sym_swiftself] = ACTIONS(641),
    [anon_sym_swiftasync] = ACTIONS(641),
    [anon_sym_swifterror] = ACTIONS(641),
    [anon_sym_immarg] = ACTIONS(639),
    [anon_sym_noundef] = ACTIONS(639),
    [anon_sym_uwtable] = ACTIONS(639),
    [anon_sym_memory] = ACTIONS(639),
    [anon_sym_to] = ACTIONS(641),
    [anon_sym_unwind] = ACTIONS(639),
    [anon_sym_unordered] = ACTIONS(639),
    [anon_sym_monotonic] = ACTIONS(639),
    [anon_sym_acquire] = ACTIONS(639),
    [anon_sym_release] = ACTIONS(639),
    [anon_sym_acq_rel] = ACTIONS(639),
    [anon_sym_seq_cst] = ACTIONS(639),
    [anon_sym_syncscope] = ACTIONS(639),
    [anon_sym_uselistorder] = ACTIONS(641),
    [anon_sym_uselistorder_bb] = ACTIONS(639),
    [anon_sym_module] = ACTIONS(639),
    [anon_sym_attributes] = ACTIONS(639),
  },
  [117] = {
    [ts_builtin_sym_end] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(643),
    [sym_global_var] = ACTIONS(643),
    [sym_local_var] = ACTIONS(643),
    [aux_sym_metadata_ref_token1] = ACTIONS(643),
    [sym_summary_ref] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [anon_sym_target] = ACTIONS(643),
    [anon_sym_source_filename] = ACTIONS(643),
    [anon_sym_declare] = ACTIONS(643),
    [anon_sym_define] = ACTIONS(643),
    [anon_sym_no_cfi] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_internal] = ACTIONS(643),
    [anon_sym_weak] = ACTIONS(645),
    [anon_sym_weak_odr] = ACTIONS(643),
    [anon_sym_linkonce] = ACTIONS(645),
    [anon_sym_linkonce_odr] = ACTIONS(643),
    [anon_sym_available_externally] = ACTIONS(643),
    [anon_sym_appending] = ACTIONS(643),
    [anon_sym_common] = ACTIONS(643),
    [anon_sym_extern_weak] = ACTIONS(643),
    [anon_sym_external] = ACTIONS(643),
    [anon_sym_dso_local] = ACTIONS(645),
    [anon_sym_dso_local_equivalent] = ACTIONS(643),
    [anon_sym_dso_preemptable] = ACTIONS(643),
    [anon_sym_default] = ACTIONS(643),
    [anon_sym_hidden] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_dllimport] = ACTIONS(643),
    [anon_sym_dllexport] = ACTIONS(643),
    [anon_sym_ccc] = ACTIONS(643),
    [anon_sym_fastcc] = ACTIONS(643),
    [anon_sym_coldcc] = ACTIONS(643),
    [anon_sym_webkit_jscc] = ACTIONS(645),
    [anon_sym_anyregcc] = ACTIONS(643),
    [anon_sym_preserve_mostcc] = ACTIONS(643),
    [anon_sym_preserve_allcc] = ACTIONS(643),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(645),
    [anon_sym_tailcc] = ACTIONS(643),
    [anon_sym_swiftcc] = ACTIONS(645),
    [anon_sym_swifttailcc] = ACTIONS(645),
    [anon_sym_cfguard_checkcc] = ACTIONS(643),
    [aux_sym_calling_conv_token1] = ACTIONS(645),
    [aux_sym_calling_conv_token2] = ACTIONS(643),
    [aux_sym_calling_conv_token3] = ACTIONS(643),
    [aux_sym_calling_conv_token4] = ACTIONS(643),
    [aux_sym_calling_conv_token5] = ACTIONS(643),
    [aux_sym_calling_conv_token6] = ACTIONS(643),
    [aux_sym_calling_conv_token7] = ACTIONS(643),
    [aux_sym_calling_conv_token8] = ACTIONS(643),
    [aux_sym_calling_conv_token9] = ACTIONS(643),
    [aux_sym_calling_conv_token10] = ACTIONS(645),
    [anon_sym_ghccc] = ACTIONS(643),
    [aux_sym_calling_conv_token11] = ACTIONS(645),
    [aux_sym_calling_conv_token12] = ACTIONS(643),
    [aux_sym_calling_conv_token13] = ACTIONS(645),
    [aux_sym_calling_conv_token14] = ACTIONS(643),
    [anon_sym_cc] = ACTIONS(645),
    [anon_sym_unnamed_addr] = ACTIONS(643),
    [anon_sym_local_unnamed_addr] = ACTIONS(643),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_half] = ACTIONS(643),
    [anon_sym_bfloat] = ACTIONS(643),
    [anon_sym_float] = ACTIONS(643),
    [anon_sym_double] = ACTIONS(643),
    [anon_sym_x86_fp80] = ACTIONS(645),
    [anon_sym_fp128] = ACTIONS(643),
    [anon_sym_ppc_fp128] = ACTIONS(643),
    [anon_sym_label] = ACTIONS(643),
    [anon_sym_metadata] = ACTIONS(643),
    [anon_sym_x86_mmx] = ACTIONS(645),
    [anon_sym_x86_amx] = ACTIONS(645),
    [anon_sym_token] = ACTIONS(643),
    [anon_sym_opaque] = ACTIONS(643),
    [anon_sym_ptr] = ACTIONS(643),
    [aux_sym_type_keyword_token1] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(643),
    [anon_sym_RBRACE] = ACTIONS(643),
    [anon_sym_LT_LBRACE] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(643),
    [anon_sym_LT] = ACTIONS(645),
    [anon_sym_GT] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(643),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_align] = ACTIONS(645),
    [anon_sym_alignstack] = ACTIONS(643),
    [anon_sym_allocsize] = ACTIONS(643),
    [anon_sym_alwaysinline] = ACTIONS(643),
    [anon_sym_builtin] = ACTIONS(643),
    [anon_sym_cold] = ACTIONS(645),
    [anon_sym_convergent] = ACTIONS(643),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(643),
    [anon_sym_hot] = ACTIONS(643),
    [anon_sym_inaccessiblememonly] = ACTIONS(643),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(643),
    [anon_sym_inlinehint] = ACTIONS(643),
    [anon_sym_jumptable] = ACTIONS(643),
    [anon_sym_minsize] = ACTIONS(643),
    [anon_sym_naked] = ACTIONS(643),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(643),
    [anon_sym_nobuiltin] = ACTIONS(643),
    [anon_sym_noduplicate] = ACTIONS(643),
    [anon_sym_nofree] = ACTIONS(643),
    [anon_sym_noimplicitfloat] = ACTIONS(643),
    [anon_sym_noinline] = ACTIONS(643),
    [anon_sym_nomerge] = ACTIONS(643),
    [anon_sym_nonlazybind] = ACTIONS(643),
    [anon_sym_noprofile] = ACTIONS(643),
    [anon_sym_noredzone] = ACTIONS(643),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(643),
    [anon_sym_noreturn] = ACTIONS(643),
    [anon_sym_norecurse] = ACTIONS(643),
    [anon_sym_willreturn] = ACTIONS(643),
    [anon_sym_nosync] = ACTIONS(643),
    [anon_sym_nounwind] = ACTIONS(643),
    [anon_sym_nocallback] = ACTIONS(643),
    [anon_sym_nosanitize_coverage] = ACTIONS(643),
    [anon_sym_null_pointer_is_valid] = ACTIONS(643),
    [anon_sym_optforfuzzing] = ACTIONS(643),
    [anon_sym_optnone] = ACTIONS(643),
    [anon_sym_optsize] = ACTIONS(643),
    [anon_sym_readnone] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_writeonly] = ACTIONS(643),
    [anon_sym_argmemonly] = ACTIONS(643),
    [anon_sym_returns_twice] = ACTIONS(643),
    [anon_sym_safestack] = ACTIONS(643),
    [anon_sym_sanitize_address] = ACTIONS(643),
    [anon_sym_sanitize_memory] = ACTIONS(643),
    [anon_sym_sanitize_thread] = ACTIONS(643),
    [anon_sym_sanitize_hwaddress] = ACTIONS(643),
    [anon_sym_sanitize_memtag] = ACTIONS(643),
    [anon_sym_speculative_load_hardening] = ACTIONS(643),
    [anon_sym_speculatable] = ACTIONS(643),
    [anon_sym_ssp] = ACTIONS(645),
    [anon_sym_sspstrong] = ACTIONS(643),
    [anon_sym_sspreq] = ACTIONS(643),
    [anon_sym_strictfp] = ACTIONS(643),
    [anon_sym_nocf_check] = ACTIONS(643),
    [anon_sym_shadowcallstack] = ACTIONS(643),
    [anon_sym_mustprogress] = ACTIONS(643),
    [anon_sym_vscale_range] = ACTIONS(643),
    [anon_sym_preallocated] = ACTIONS(643),
    [anon_sym_zeroext] = ACTIONS(643),
    [anon_sym_signext] = ACTIONS(643),
    [anon_sym_inreg] = ACTIONS(643),
    [anon_sym_byval] = ACTIONS(643),
    [anon_sym_byref] = ACTIONS(643),
    [anon_sym_inalloca] = ACTIONS(643),
    [anon_sym_sret] = ACTIONS(643),
    [anon_sym_elementtype] = ACTIONS(643),
    [anon_sym_noalias] = ACTIONS(643),
    [anon_sym_nocapture] = ACTIONS(643),
    [anon_sym_nest] = ACTIONS(643),
    [anon_sym_returned] = ACTIONS(643),
    [anon_sym_nonnull] = ACTIONS(643),
    [anon_sym_dereferenceable] = ACTIONS(645),
    [anon_sym_dereferenceable_or_null] = ACTIONS(643),
    [anon_sym_swiftself] = ACTIONS(645),
    [anon_sym_swiftasync] = ACTIONS(645),
    [anon_sym_swifterror] = ACTIONS(645),
    [anon_sym_immarg] = ACTIONS(643),
    [anon_sym_noundef] = ACTIONS(643),
    [anon_sym_uwtable] = ACTIONS(643),
    [anon_sym_memory] = ACTIONS(643),
    [anon_sym_to] = ACTIONS(645),
    [anon_sym_unwind] = ACTIONS(643),
    [anon_sym_unordered] = ACTIONS(643),
    [anon_sym_monotonic] = ACTIONS(643),
    [anon_sym_acquire] = ACTIONS(643),
    [anon_sym_release] = ACTIONS(643),
    [anon_sym_acq_rel] = ACTIONS(643),
    [anon_sym_seq_cst] = ACTIONS(643),
    [anon_sym_syncscope] = ACTIONS(643),
    [anon_sym_uselistorder] = ACTIONS(645),
    [anon_sym_uselistorder_bb] = ACTIONS(643),
    [anon_sym_module] = ACTIONS(643),
    [anon_sym_attributes] = ACTIONS(643),
  },
  [118] = {
    [ts_builtin_sym_end] = ACTIONS(647),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(647),
    [sym_global_var] = ACTIONS(647),
    [sym_local_var] = ACTIONS(647),
    [aux_sym_metadata_ref_token1] = ACTIONS(647),
    [sym_summary_ref] = ACTIONS(647),
    [sym_string] = ACTIONS(647),
    [anon_sym_target] = ACTIONS(647),
    [anon_sym_source_filename] = ACTIONS(647),
    [anon_sym_declare] = ACTIONS(647),
    [anon_sym_define] = ACTIONS(647),
    [anon_sym_no_cfi] = ACTIONS(647),
    [anon_sym_private] = ACTIONS(647),
    [anon_sym_internal] = ACTIONS(647),
    [anon_sym_weak] = ACTIONS(649),
    [anon_sym_weak_odr] = ACTIONS(647),
    [anon_sym_linkonce] = ACTIONS(649),
    [anon_sym_linkonce_odr] = ACTIONS(647),
    [anon_sym_available_externally] = ACTIONS(647),
    [anon_sym_appending] = ACTIONS(647),
    [anon_sym_common] = ACTIONS(647),
    [anon_sym_extern_weak] = ACTIONS(647),
    [anon_sym_external] = ACTIONS(647),
    [anon_sym_dso_local] = ACTIONS(649),
    [anon_sym_dso_local_equivalent] = ACTIONS(647),
    [anon_sym_dso_preemptable] = ACTIONS(647),
    [anon_sym_default] = ACTIONS(647),
    [anon_sym_hidden] = ACTIONS(647),
    [anon_sym_protected] = ACTIONS(647),
    [anon_sym_dllimport] = ACTIONS(647),
    [anon_sym_dllexport] = ACTIONS(647),
    [anon_sym_ccc] = ACTIONS(647),
    [anon_sym_fastcc] = ACTIONS(647),
    [anon_sym_coldcc] = ACTIONS(647),
    [anon_sym_webkit_jscc] = ACTIONS(649),
    [anon_sym_anyregcc] = ACTIONS(647),
    [anon_sym_preserve_mostcc] = ACTIONS(647),
    [anon_sym_preserve_allcc] = ACTIONS(647),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(649),
    [anon_sym_tailcc] = ACTIONS(647),
    [anon_sym_swiftcc] = ACTIONS(649),
    [anon_sym_swifttailcc] = ACTIONS(649),
    [anon_sym_cfguard_checkcc] = ACTIONS(647),
    [aux_sym_calling_conv_token1] = ACTIONS(649),
    [aux_sym_calling_conv_token2] = ACTIONS(647),
    [aux_sym_calling_conv_token3] = ACTIONS(647),
    [aux_sym_calling_conv_token4] = ACTIONS(647),
    [aux_sym_calling_conv_token5] = ACTIONS(647),
    [aux_sym_calling_conv_token6] = ACTIONS(647),
    [aux_sym_calling_conv_token7] = ACTIONS(647),
    [aux_sym_calling_conv_token8] = ACTIONS(647),
    [aux_sym_calling_conv_token9] = ACTIONS(647),
    [aux_sym_calling_conv_token10] = ACTIONS(649),
    [anon_sym_ghccc] = ACTIONS(647),
    [aux_sym_calling_conv_token11] = ACTIONS(649),
    [aux_sym_calling_conv_token12] = ACTIONS(647),
    [aux_sym_calling_conv_token13] = ACTIONS(649),
    [aux_sym_calling_conv_token14] = ACTIONS(647),
    [anon_sym_cc] = ACTIONS(649),
    [anon_sym_unnamed_addr] = ACTIONS(647),
    [anon_sym_local_unnamed_addr] = ACTIONS(647),
    [anon_sym_void] = ACTIONS(647),
    [anon_sym_half] = ACTIONS(647),
    [anon_sym_bfloat] = ACTIONS(647),
    [anon_sym_float] = ACTIONS(647),
    [anon_sym_double] = ACTIONS(647),
    [anon_sym_x86_fp80] = ACTIONS(649),
    [anon_sym_fp128] = ACTIONS(647),
    [anon_sym_ppc_fp128] = ACTIONS(647),
    [anon_sym_label] = ACTIONS(647),
    [anon_sym_metadata] = ACTIONS(647),
    [anon_sym_x86_mmx] = ACTIONS(649),
    [anon_sym_x86_amx] = ACTIONS(649),
    [anon_sym_token] = ACTIONS(647),
    [anon_sym_opaque] = ACTIONS(647),
    [anon_sym_ptr] = ACTIONS(647),
    [aux_sym_type_keyword_token1] = ACTIONS(647),
    [anon_sym_LBRACE] = ACTIONS(647),
    [anon_sym_RBRACE] = ACTIONS(647),
    [anon_sym_LT_LBRACE] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(647),
    [anon_sym_RBRACK] = ACTIONS(647),
    [anon_sym_LT] = ACTIONS(649),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_COMMA] = ACTIONS(647),
    [anon_sym_LPAREN] = ACTIONS(647),
    [anon_sym_RPAREN] = ACTIONS(647),
    [anon_sym_align] = ACTIONS(649),
    [anon_sym_alignstack] = ACTIONS(647),
    [anon_sym_allocsize] = ACTIONS(647),
    [anon_sym_alwaysinline] = ACTIONS(647),
    [anon_sym_builtin] = ACTIONS(647),
    [anon_sym_cold] = ACTIONS(649),
    [anon_sym_convergent] = ACTIONS(647),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(647),
    [anon_sym_hot] = ACTIONS(647),
    [anon_sym_inaccessiblememonly] = ACTIONS(647),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(647),
    [anon_sym_inlinehint] = ACTIONS(647),
    [anon_sym_jumptable] = ACTIONS(647),
    [anon_sym_minsize] = ACTIONS(647),
    [anon_sym_naked] = ACTIONS(647),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(647),
    [anon_sym_nobuiltin] = ACTIONS(647),
    [anon_sym_noduplicate] = ACTIONS(647),
    [anon_sym_nofree] = ACTIONS(647),
    [anon_sym_noimplicitfloat] = ACTIONS(647),
    [anon_sym_noinline] = ACTIONS(647),
    [anon_sym_nomerge] = ACTIONS(647),
    [anon_sym_nonlazybind] = ACTIONS(647),
    [anon_sym_noprofile] = ACTIONS(647),
    [anon_sym_noredzone] = ACTIONS(647),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(647),
    [anon_sym_noreturn] = ACTIONS(647),
    [anon_sym_norecurse] = ACTIONS(647),
    [anon_sym_willreturn] = ACTIONS(647),
    [anon_sym_nosync] = ACTIONS(647),
    [anon_sym_nounwind] = ACTIONS(647),
    [anon_sym_nocallback] = ACTIONS(647),
    [anon_sym_nosanitize_coverage] = ACTIONS(647),
    [anon_sym_null_pointer_is_valid] = ACTIONS(647),
    [anon_sym_optforfuzzing] = ACTIONS(647),
    [anon_sym_optnone] = ACTIONS(647),
    [anon_sym_optsize] = ACTIONS(647),
    [anon_sym_readnone] = ACTIONS(647),
    [anon_sym_readonly] = ACTIONS(647),
    [anon_sym_writeonly] = ACTIONS(647),
    [anon_sym_argmemonly] = ACTIONS(647),
    [anon_sym_returns_twice] = ACTIONS(647),
    [anon_sym_safestack] = ACTIONS(647),
    [anon_sym_sanitize_address] = ACTIONS(647),
    [anon_sym_sanitize_memory] = ACTIONS(647),
    [anon_sym_sanitize_thread] = ACTIONS(647),
    [anon_sym_sanitize_hwaddress] = ACTIONS(647),
    [anon_sym_sanitize_memtag] = ACTIONS(647),
    [anon_sym_speculative_load_hardening] = ACTIONS(647),
    [anon_sym_speculatable] = ACTIONS(647),
    [anon_sym_ssp] = ACTIONS(649),
    [anon_sym_sspstrong] = ACTIONS(647),
    [anon_sym_sspreq] = ACTIONS(647),
    [anon_sym_strictfp] = ACTIONS(647),
    [anon_sym_nocf_check] = ACTIONS(647),
    [anon_sym_shadowcallstack] = ACTIONS(647),
    [anon_sym_mustprogress] = ACTIONS(647),
    [anon_sym_vscale_range] = ACTIONS(647),
    [anon_sym_preallocated] = ACTIONS(647),
    [anon_sym_zeroext] = ACTIONS(647),
    [anon_sym_signext] = ACTIONS(647),
    [anon_sym_inreg] = ACTIONS(647),
    [anon_sym_byval] = ACTIONS(647),
    [anon_sym_byref] = ACTIONS(647),
    [anon_sym_inalloca] = ACTIONS(647),
    [anon_sym_sret] = ACTIONS(647),
    [anon_sym_elementtype] = ACTIONS(647),
    [anon_sym_noalias] = ACTIONS(647),
    [anon_sym_nocapture] = ACTIONS(647),
    [anon_sym_nest] = ACTIONS(647),
    [anon_sym_returned] = ACTIONS(647),
    [anon_sym_nonnull] = ACTIONS(647),
    [anon_sym_dereferenceable] = ACTIONS(649),
    [anon_sym_dereferenceable_or_null] = ACTIONS(647),
    [anon_sym_swiftself] = ACTIONS(649),
    [anon_sym_swiftasync] = ACTIONS(649),
    [anon_sym_swifterror] = ACTIONS(649),
    [anon_sym_immarg] = ACTIONS(647),
    [anon_sym_noundef] = ACTIONS(647),
    [anon_sym_uwtable] = ACTIONS(647),
    [anon_sym_memory] = ACTIONS(647),
    [anon_sym_to] = ACTIONS(649),
    [anon_sym_unwind] = ACTIONS(647),
    [anon_sym_unordered] = ACTIONS(647),
    [anon_sym_monotonic] = ACTIONS(647),
    [anon_sym_acquire] = ACTIONS(647),
    [anon_sym_release] = ACTIONS(647),
    [anon_sym_acq_rel] = ACTIONS(647),
    [anon_sym_seq_cst] = ACTIONS(647),
    [anon_sym_syncscope] = ACTIONS(647),
    [anon_sym_uselistorder] = ACTIONS(649),
    [anon_sym_uselistorder_bb] = ACTIONS(647),
    [anon_sym_module] = ACTIONS(647),
    [anon_sym_attributes] = ACTIONS(647),
  },
  [119] = {
    [ts_builtin_sym_end] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(651),
    [sym_global_var] = ACTIONS(651),
    [sym_local_var] = ACTIONS(651),
    [aux_sym_metadata_ref_token1] = ACTIONS(651),
    [sym_summary_ref] = ACTIONS(651),
    [sym_string] = ACTIONS(651),
    [anon_sym_target] = ACTIONS(651),
    [anon_sym_source_filename] = ACTIONS(651),
    [anon_sym_declare] = ACTIONS(651),
    [anon_sym_define] = ACTIONS(651),
    [anon_sym_no_cfi] = ACTIONS(651),
    [anon_sym_private] = ACTIONS(651),
    [anon_sym_internal] = ACTIONS(651),
    [anon_sym_weak] = ACTIONS(653),
    [anon_sym_weak_odr] = ACTIONS(651),
    [anon_sym_linkonce] = ACTIONS(653),
    [anon_sym_linkonce_odr] = ACTIONS(651),
    [anon_sym_available_externally] = ACTIONS(651),
    [anon_sym_appending] = ACTIONS(651),
    [anon_sym_common] = ACTIONS(651),
    [anon_sym_extern_weak] = ACTIONS(651),
    [anon_sym_external] = ACTIONS(651),
    [anon_sym_dso_local] = ACTIONS(653),
    [anon_sym_dso_local_equivalent] = ACTIONS(651),
    [anon_sym_dso_preemptable] = ACTIONS(651),
    [anon_sym_default] = ACTIONS(651),
    [anon_sym_hidden] = ACTIONS(651),
    [anon_sym_protected] = ACTIONS(651),
    [anon_sym_dllimport] = ACTIONS(651),
    [anon_sym_dllexport] = ACTIONS(651),
    [anon_sym_ccc] = ACTIONS(651),
    [anon_sym_fastcc] = ACTIONS(651),
    [anon_sym_coldcc] = ACTIONS(651),
    [anon_sym_webkit_jscc] = ACTIONS(653),
    [anon_sym_anyregcc] = ACTIONS(651),
    [anon_sym_preserve_mostcc] = ACTIONS(651),
    [anon_sym_preserve_allcc] = ACTIONS(651),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(653),
    [anon_sym_tailcc] = ACTIONS(651),
    [anon_sym_swiftcc] = ACTIONS(653),
    [anon_sym_swifttailcc] = ACTIONS(653),
    [anon_sym_cfguard_checkcc] = ACTIONS(651),
    [aux_sym_calling_conv_token1] = ACTIONS(653),
    [aux_sym_calling_conv_token2] = ACTIONS(651),
    [aux_sym_calling_conv_token3] = ACTIONS(651),
    [aux_sym_calling_conv_token4] = ACTIONS(651),
    [aux_sym_calling_conv_token5] = ACTIONS(651),
    [aux_sym_calling_conv_token6] = ACTIONS(651),
    [aux_sym_calling_conv_token7] = ACTIONS(651),
    [aux_sym_calling_conv_token8] = ACTIONS(651),
    [aux_sym_calling_conv_token9] = ACTIONS(651),
    [aux_sym_calling_conv_token10] = ACTIONS(653),
    [anon_sym_ghccc] = ACTIONS(651),
    [aux_sym_calling_conv_token11] = ACTIONS(653),
    [aux_sym_calling_conv_token12] = ACTIONS(651),
    [aux_sym_calling_conv_token13] = ACTIONS(653),
    [aux_sym_calling_conv_token14] = ACTIONS(651),
    [anon_sym_cc] = ACTIONS(653),
    [anon_sym_unnamed_addr] = ACTIONS(651),
    [anon_sym_local_unnamed_addr] = ACTIONS(651),
    [anon_sym_void] = ACTIONS(651),
    [anon_sym_half] = ACTIONS(651),
    [anon_sym_bfloat] = ACTIONS(651),
    [anon_sym_float] = ACTIONS(651),
    [anon_sym_double] = ACTIONS(651),
    [anon_sym_x86_fp80] = ACTIONS(653),
    [anon_sym_fp128] = ACTIONS(651),
    [anon_sym_ppc_fp128] = ACTIONS(651),
    [anon_sym_label] = ACTIONS(651),
    [anon_sym_metadata] = ACTIONS(651),
    [anon_sym_x86_mmx] = ACTIONS(653),
    [anon_sym_x86_amx] = ACTIONS(653),
    [anon_sym_token] = ACTIONS(651),
    [anon_sym_opaque] = ACTIONS(651),
    [anon_sym_ptr] = ACTIONS(651),
    [aux_sym_type_keyword_token1] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(651),
    [anon_sym_RBRACE] = ACTIONS(651),
    [anon_sym_LT_LBRACE] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_RBRACK] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(653),
    [anon_sym_GT] = ACTIONS(651),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_align] = ACTIONS(653),
    [anon_sym_alignstack] = ACTIONS(651),
    [anon_sym_allocsize] = ACTIONS(651),
    [anon_sym_alwaysinline] = ACTIONS(651),
    [anon_sym_builtin] = ACTIONS(651),
    [anon_sym_cold] = ACTIONS(653),
    [anon_sym_convergent] = ACTIONS(651),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(651),
    [anon_sym_hot] = ACTIONS(651),
    [anon_sym_inaccessiblememonly] = ACTIONS(651),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(651),
    [anon_sym_inlinehint] = ACTIONS(651),
    [anon_sym_jumptable] = ACTIONS(651),
    [anon_sym_minsize] = ACTIONS(651),
    [anon_sym_naked] = ACTIONS(651),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(651),
    [anon_sym_nobuiltin] = ACTIONS(651),
    [anon_sym_noduplicate] = ACTIONS(651),
    [anon_sym_nofree] = ACTIONS(651),
    [anon_sym_noimplicitfloat] = ACTIONS(651),
    [anon_sym_noinline] = ACTIONS(651),
    [anon_sym_nomerge] = ACTIONS(651),
    [anon_sym_nonlazybind] = ACTIONS(651),
    [anon_sym_noprofile] = ACTIONS(651),
    [anon_sym_noredzone] = ACTIONS(651),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(651),
    [anon_sym_noreturn] = ACTIONS(651),
    [anon_sym_norecurse] = ACTIONS(651),
    [anon_sym_willreturn] = ACTIONS(651),
    [anon_sym_nosync] = ACTIONS(651),
    [anon_sym_nounwind] = ACTIONS(651),
    [anon_sym_nocallback] = ACTIONS(651),
    [anon_sym_nosanitize_coverage] = ACTIONS(651),
    [anon_sym_null_pointer_is_valid] = ACTIONS(651),
    [anon_sym_optforfuzzing] = ACTIONS(651),
    [anon_sym_optnone] = ACTIONS(651),
    [anon_sym_optsize] = ACTIONS(651),
    [anon_sym_readnone] = ACTIONS(651),
    [anon_sym_readonly] = ACTIONS(651),
    [anon_sym_writeonly] = ACTIONS(651),
    [anon_sym_argmemonly] = ACTIONS(651),
    [anon_sym_returns_twice] = ACTIONS(651),
    [anon_sym_safestack] = ACTIONS(651),
    [anon_sym_sanitize_address] = ACTIONS(651),
    [anon_sym_sanitize_memory] = ACTIONS(651),
    [anon_sym_sanitize_thread] = ACTIONS(651),
    [anon_sym_sanitize_hwaddress] = ACTIONS(651),
    [anon_sym_sanitize_memtag] = ACTIONS(651),
    [anon_sym_speculative_load_hardening] = ACTIONS(651),
    [anon_sym_speculatable] = ACTIONS(651),
    [anon_sym_ssp] = ACTIONS(653),
    [anon_sym_sspstrong] = ACTIONS(651),
    [anon_sym_sspreq] = ACTIONS(651),
    [anon_sym_strictfp] = ACTIONS(651),
    [anon_sym_nocf_check] = ACTIONS(651),
    [anon_sym_shadowcallstack] = ACTIONS(651),
    [anon_sym_mustprogress] = ACTIONS(651),
    [anon_sym_vscale_range] = ACTIONS(651),
    [anon_sym_preallocated] = ACTIONS(651),
    [anon_sym_zeroext] = ACTIONS(651),
    [anon_sym_signext] = ACTIONS(651),
    [anon_sym_inreg] = ACTIONS(651),
    [anon_sym_byval] = ACTIONS(651),
    [anon_sym_byref] = ACTIONS(651),
    [anon_sym_inalloca] = ACTIONS(651),
    [anon_sym_sret] = ACTIONS(651),
    [anon_sym_elementtype] = ACTIONS(651),
    [anon_sym_noalias] = ACTIONS(651),
    [anon_sym_nocapture] = ACTIONS(651),
    [anon_sym_nest] = ACTIONS(651),
    [anon_sym_returned] = ACTIONS(651),
    [anon_sym_nonnull] = ACTIONS(651),
    [anon_sym_dereferenceable] = ACTIONS(653),
    [anon_sym_dereferenceable_or_null] = ACTIONS(651),
    [anon_sym_swiftself] = ACTIONS(653),
    [anon_sym_swiftasync] = ACTIONS(653),
    [anon_sym_swifterror] = ACTIONS(653),
    [anon_sym_immarg] = ACTIONS(651),
    [anon_sym_noundef] = ACTIONS(651),
    [anon_sym_uwtable] = ACTIONS(651),
    [anon_sym_memory] = ACTIONS(651),
    [anon_sym_to] = ACTIONS(653),
    [anon_sym_unwind] = ACTIONS(651),
    [anon_sym_unordered] = ACTIONS(651),
    [anon_sym_monotonic] = ACTIONS(651),
    [anon_sym_acquire] = ACTIONS(651),
    [anon_sym_release] = ACTIONS(651),
    [anon_sym_acq_rel] = ACTIONS(651),
    [anon_sym_seq_cst] = ACTIONS(651),
    [anon_sym_syncscope] = ACTIONS(651),
    [anon_sym_uselistorder] = ACTIONS(653),
    [anon_sym_uselistorder_bb] = ACTIONS(651),
    [anon_sym_module] = ACTIONS(651),
    [anon_sym_attributes] = ACTIONS(651),
  },
  [120] = {
    [ts_builtin_sym_end] = ACTIONS(655),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(655),
    [sym_global_var] = ACTIONS(655),
    [sym_local_var] = ACTIONS(655),
    [aux_sym_metadata_ref_token1] = ACTIONS(655),
    [sym_summary_ref] = ACTIONS(655),
    [sym_string] = ACTIONS(655),
    [anon_sym_target] = ACTIONS(655),
    [anon_sym_source_filename] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_define] = ACTIONS(655),
    [anon_sym_no_cfi] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_internal] = ACTIONS(655),
    [anon_sym_weak] = ACTIONS(657),
    [anon_sym_weak_odr] = ACTIONS(655),
    [anon_sym_linkonce] = ACTIONS(657),
    [anon_sym_linkonce_odr] = ACTIONS(655),
    [anon_sym_available_externally] = ACTIONS(655),
    [anon_sym_appending] = ACTIONS(655),
    [anon_sym_common] = ACTIONS(655),
    [anon_sym_extern_weak] = ACTIONS(655),
    [anon_sym_external] = ACTIONS(655),
    [anon_sym_dso_local] = ACTIONS(657),
    [anon_sym_dso_local_equivalent] = ACTIONS(655),
    [anon_sym_dso_preemptable] = ACTIONS(655),
    [anon_sym_default] = ACTIONS(655),
    [anon_sym_hidden] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_dllimport] = ACTIONS(655),
    [anon_sym_dllexport] = ACTIONS(655),
    [anon_sym_ccc] = ACTIONS(655),
    [anon_sym_fastcc] = ACTIONS(655),
    [anon_sym_coldcc] = ACTIONS(655),
    [anon_sym_webkit_jscc] = ACTIONS(657),
    [anon_sym_anyregcc] = ACTIONS(655),
    [anon_sym_preserve_mostcc] = ACTIONS(655),
    [anon_sym_preserve_allcc] = ACTIONS(655),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(657),
    [anon_sym_tailcc] = ACTIONS(655),
    [anon_sym_swiftcc] = ACTIONS(657),
    [anon_sym_swifttailcc] = ACTIONS(657),
    [anon_sym_cfguard_checkcc] = ACTIONS(655),
    [aux_sym_calling_conv_token1] = ACTIONS(657),
    [aux_sym_calling_conv_token2] = ACTIONS(655),
    [aux_sym_calling_conv_token3] = ACTIONS(655),
    [aux_sym_calling_conv_token4] = ACTIONS(655),
    [aux_sym_calling_conv_token5] = ACTIONS(655),
    [aux_sym_calling_conv_token6] = ACTIONS(655),
    [aux_sym_calling_conv_token7] = ACTIONS(655),
    [aux_sym_calling_conv_token8] = ACTIONS(655),
    [aux_sym_calling_conv_token9] = ACTIONS(655),
    [aux_sym_calling_conv_token10] = ACTIONS(657),
    [anon_sym_ghccc] = ACTIONS(655),
    [aux_sym_calling_conv_token11] = ACTIONS(657),
    [aux_sym_calling_conv_token12] = ACTIONS(655),
    [aux_sym_calling_conv_token13] = ACTIONS(657),
    [aux_sym_calling_conv_token14] = ACTIONS(655),
    [anon_sym_cc] = ACTIONS(657),
    [anon_sym_unnamed_addr] = ACTIONS(655),
    [anon_sym_local_unnamed_addr] = ACTIONS(655),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_half] = ACTIONS(655),
    [anon_sym_bfloat] = ACTIONS(655),
    [anon_sym_float] = ACTIONS(655),
    [anon_sym_double] = ACTIONS(655),
    [anon_sym_x86_fp80] = ACTIONS(657),
    [anon_sym_fp128] = ACTIONS(655),
    [anon_sym_ppc_fp128] = ACTIONS(655),
    [anon_sym_label] = ACTIONS(655),
    [anon_sym_metadata] = ACTIONS(655),
    [anon_sym_x86_mmx] = ACTIONS(657),
    [anon_sym_x86_amx] = ACTIONS(657),
    [anon_sym_token] = ACTIONS(655),
    [anon_sym_opaque] = ACTIONS(655),
    [anon_sym_ptr] = ACTIONS(655),
    [aux_sym_type_keyword_token1] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(655),
    [anon_sym_LT_LBRACE] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_RBRACK] = ACTIONS(655),
    [anon_sym_LT] = ACTIONS(657),
    [anon_sym_GT] = ACTIONS(655),
    [anon_sym_COMMA] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_RPAREN] = ACTIONS(655),
    [anon_sym_align] = ACTIONS(657),
    [anon_sym_alignstack] = ACTIONS(655),
    [anon_sym_allocsize] = ACTIONS(655),
    [anon_sym_alwaysinline] = ACTIONS(655),
    [anon_sym_builtin] = ACTIONS(655),
    [anon_sym_cold] = ACTIONS(657),
    [anon_sym_convergent] = ACTIONS(655),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(655),
    [anon_sym_hot] = ACTIONS(655),
    [anon_sym_inaccessiblememonly] = ACTIONS(655),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(655),
    [anon_sym_inlinehint] = ACTIONS(655),
    [anon_sym_jumptable] = ACTIONS(655),
    [anon_sym_minsize] = ACTIONS(655),
    [anon_sym_naked] = ACTIONS(655),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(655),
    [anon_sym_nobuiltin] = ACTIONS(655),
    [anon_sym_noduplicate] = ACTIONS(655),
    [anon_sym_nofree] = ACTIONS(655),
    [anon_sym_noimplicitfloat] = ACTIONS(655),
    [anon_sym_noinline] = ACTIONS(655),
    [anon_sym_nomerge] = ACTIONS(655),
    [anon_sym_nonlazybind] = ACTIONS(655),
    [anon_sym_noprofile] = ACTIONS(655),
    [anon_sym_noredzone] = ACTIONS(655),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(655),
    [anon_sym_noreturn] = ACTIONS(655),
    [anon_sym_norecurse] = ACTIONS(655),
    [anon_sym_willreturn] = ACTIONS(655),
    [anon_sym_nosync] = ACTIONS(655),
    [anon_sym_nounwind] = ACTIONS(655),
    [anon_sym_nocallback] = ACTIONS(655),
    [anon_sym_nosanitize_coverage] = ACTIONS(655),
    [anon_sym_null_pointer_is_valid] = ACTIONS(655),
    [anon_sym_optforfuzzing] = ACTIONS(655),
    [anon_sym_optnone] = ACTIONS(655),
    [anon_sym_optsize] = ACTIONS(655),
    [anon_sym_readnone] = ACTIONS(655),
    [anon_sym_readonly] = ACTIONS(655),
    [anon_sym_writeonly] = ACTIONS(655),
    [anon_sym_argmemonly] = ACTIONS(655),
    [anon_sym_returns_twice] = ACTIONS(655),
    [anon_sym_safestack] = ACTIONS(655),
    [anon_sym_sanitize_address] = ACTIONS(655),
    [anon_sym_sanitize_memory] = ACTIONS(655),
    [anon_sym_sanitize_thread] = ACTIONS(655),
    [anon_sym_sanitize_hwaddress] = ACTIONS(655),
    [anon_sym_sanitize_memtag] = ACTIONS(655),
    [anon_sym_speculative_load_hardening] = ACTIONS(655),
    [anon_sym_speculatable] = ACTIONS(655),
    [anon_sym_ssp] = ACTIONS(657),
    [anon_sym_sspstrong] = ACTIONS(655),
    [anon_sym_sspreq] = ACTIONS(655),
    [anon_sym_strictfp] = ACTIONS(655),
    [anon_sym_nocf_check] = ACTIONS(655),
    [anon_sym_shadowcallstack] = ACTIONS(655),
    [anon_sym_mustprogress] = ACTIONS(655),
    [anon_sym_vscale_range] = ACTIONS(655),
    [anon_sym_preallocated] = ACTIONS(655),
    [anon_sym_zeroext] = ACTIONS(655),
    [anon_sym_signext] = ACTIONS(655),
    [anon_sym_inreg] = ACTIONS(655),
    [anon_sym_byval] = ACTIONS(655),
    [anon_sym_byref] = ACTIONS(655),
    [anon_sym_inalloca] = ACTIONS(655),
    [anon_sym_sret] = ACTIONS(655),
    [anon_sym_elementtype] = ACTIONS(655),
    [anon_sym_noalias] = ACTIONS(655),
    [anon_sym_nocapture] = ACTIONS(655),
    [anon_sym_nest] = ACTIONS(655),
    [anon_sym_returned] = ACTIONS(655),
    [anon_sym_nonnull] = ACTIONS(655),
    [anon_sym_dereferenceable] = ACTIONS(657),
    [anon_sym_dereferenceable_or_null] = ACTIONS(655),
    [anon_sym_swiftself] = ACTIONS(657),
    [anon_sym_swiftasync] = ACTIONS(657),
    [anon_sym_swifterror] = ACTIONS(657),
    [anon_sym_immarg] = ACTIONS(655),
    [anon_sym_noundef] = ACTIONS(655),
    [anon_sym_uwtable] = ACTIONS(655),
    [anon_sym_memory] = ACTIONS(655),
    [anon_sym_to] = ACTIONS(657),
    [anon_sym_unwind] = ACTIONS(655),
    [anon_sym_unordered] = ACTIONS(655),
    [anon_sym_monotonic] = ACTIONS(655),
    [anon_sym_acquire] = ACTIONS(655),
    [anon_sym_release] = ACTIONS(655),
    [anon_sym_acq_rel] = ACTIONS(655),
    [anon_sym_seq_cst] = ACTIONS(655),
    [anon_sym_syncscope] = ACTIONS(655),
    [anon_sym_uselistorder] = ACTIONS(657),
    [anon_sym_uselistorder_bb] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_attributes] = ACTIONS(655),
  },
  [121] = {
    [ts_builtin_sym_end] = ACTIONS(659),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(659),
    [sym_global_var] = ACTIONS(659),
    [sym_local_var] = ACTIONS(659),
    [aux_sym_metadata_ref_token1] = ACTIONS(659),
    [sym_summary_ref] = ACTIONS(659),
    [sym_string] = ACTIONS(659),
    [anon_sym_target] = ACTIONS(659),
    [anon_sym_source_filename] = ACTIONS(659),
    [anon_sym_declare] = ACTIONS(659),
    [anon_sym_define] = ACTIONS(659),
    [anon_sym_no_cfi] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_weak] = ACTIONS(661),
    [anon_sym_weak_odr] = ACTIONS(659),
    [anon_sym_linkonce] = ACTIONS(661),
    [anon_sym_linkonce_odr] = ACTIONS(659),
    [anon_sym_available_externally] = ACTIONS(659),
    [anon_sym_appending] = ACTIONS(659),
    [anon_sym_common] = ACTIONS(659),
    [anon_sym_extern_weak] = ACTIONS(659),
    [anon_sym_external] = ACTIONS(659),
    [anon_sym_dso_local] = ACTIONS(661),
    [anon_sym_dso_local_equivalent] = ACTIONS(659),
    [anon_sym_dso_preemptable] = ACTIONS(659),
    [anon_sym_default] = ACTIONS(659),
    [anon_sym_hidden] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_dllimport] = ACTIONS(659),
    [anon_sym_dllexport] = ACTIONS(659),
    [anon_sym_ccc] = ACTIONS(659),
    [anon_sym_fastcc] = ACTIONS(659),
    [anon_sym_coldcc] = ACTIONS(659),
    [anon_sym_webkit_jscc] = ACTIONS(661),
    [anon_sym_anyregcc] = ACTIONS(659),
    [anon_sym_preserve_mostcc] = ACTIONS(659),
    [anon_sym_preserve_allcc] = ACTIONS(659),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(661),
    [anon_sym_tailcc] = ACTIONS(659),
    [anon_sym_swiftcc] = ACTIONS(661),
    [anon_sym_swifttailcc] = ACTIONS(661),
    [anon_sym_cfguard_checkcc] = ACTIONS(659),
    [aux_sym_calling_conv_token1] = ACTIONS(661),
    [aux_sym_calling_conv_token2] = ACTIONS(659),
    [aux_sym_calling_conv_token3] = ACTIONS(659),
    [aux_sym_calling_conv_token4] = ACTIONS(659),
    [aux_sym_calling_conv_token5] = ACTIONS(659),
    [aux_sym_calling_conv_token6] = ACTIONS(659),
    [aux_sym_calling_conv_token7] = ACTIONS(659),
    [aux_sym_calling_conv_token8] = ACTIONS(659),
    [aux_sym_calling_conv_token9] = ACTIONS(659),
    [aux_sym_calling_conv_token10] = ACTIONS(661),
    [anon_sym_ghccc] = ACTIONS(659),
    [aux_sym_calling_conv_token11] = ACTIONS(661),
    [aux_sym_calling_conv_token12] = ACTIONS(659),
    [aux_sym_calling_conv_token13] = ACTIONS(661),
    [aux_sym_calling_conv_token14] = ACTIONS(659),
    [anon_sym_cc] = ACTIONS(661),
    [anon_sym_unnamed_addr] = ACTIONS(659),
    [anon_sym_local_unnamed_addr] = ACTIONS(659),
    [anon_sym_void] = ACTIONS(659),
    [anon_sym_half] = ACTIONS(659),
    [anon_sym_bfloat] = ACTIONS(659),
    [anon_sym_float] = ACTIONS(659),
    [anon_sym_double] = ACTIONS(659),
    [anon_sym_x86_fp80] = ACTIONS(661),
    [anon_sym_fp128] = ACTIONS(659),
    [anon_sym_ppc_fp128] = ACTIONS(659),
    [anon_sym_label] = ACTIONS(659),
    [anon_sym_metadata] = ACTIONS(659),
    [anon_sym_x86_mmx] = ACTIONS(661),
    [anon_sym_x86_amx] = ACTIONS(661),
    [anon_sym_token] = ACTIONS(659),
    [anon_sym_opaque] = ACTIONS(659),
    [anon_sym_ptr] = ACTIONS(659),
    [aux_sym_type_keyword_token1] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(659),
    [anon_sym_LT_LBRACE] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_RBRACK] = ACTIONS(659),
    [anon_sym_LT] = ACTIONS(661),
    [anon_sym_GT] = ACTIONS(659),
    [anon_sym_COMMA] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(659),
    [anon_sym_RPAREN] = ACTIONS(659),
    [anon_sym_align] = ACTIONS(661),
    [anon_sym_alignstack] = ACTIONS(659),
    [anon_sym_allocsize] = ACTIONS(659),
    [anon_sym_alwaysinline] = ACTIONS(659),
    [anon_sym_builtin] = ACTIONS(659),
    [anon_sym_cold] = ACTIONS(661),
    [anon_sym_convergent] = ACTIONS(659),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(659),
    [anon_sym_hot] = ACTIONS(659),
    [anon_sym_inaccessiblememonly] = ACTIONS(659),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(659),
    [anon_sym_inlinehint] = ACTIONS(659),
    [anon_sym_jumptable] = ACTIONS(659),
    [anon_sym_minsize] = ACTIONS(659),
    [anon_sym_naked] = ACTIONS(659),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(659),
    [anon_sym_nobuiltin] = ACTIONS(659),
    [anon_sym_noduplicate] = ACTIONS(659),
    [anon_sym_nofree] = ACTIONS(659),
    [anon_sym_noimplicitfloat] = ACTIONS(659),
    [anon_sym_noinline] = ACTIONS(659),
    [anon_sym_nomerge] = ACTIONS(659),
    [anon_sym_nonlazybind] = ACTIONS(659),
    [anon_sym_noprofile] = ACTIONS(659),
    [anon_sym_noredzone] = ACTIONS(659),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(659),
    [anon_sym_noreturn] = ACTIONS(659),
    [anon_sym_norecurse] = ACTIONS(659),
    [anon_sym_willreturn] = ACTIONS(659),
    [anon_sym_nosync] = ACTIONS(659),
    [anon_sym_nounwind] = ACTIONS(659),
    [anon_sym_nocallback] = ACTIONS(659),
    [anon_sym_nosanitize_coverage] = ACTIONS(659),
    [anon_sym_null_pointer_is_valid] = ACTIONS(659),
    [anon_sym_optforfuzzing] = ACTIONS(659),
    [anon_sym_optnone] = ACTIONS(659),
    [anon_sym_optsize] = ACTIONS(659),
    [anon_sym_readnone] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_writeonly] = ACTIONS(659),
    [anon_sym_argmemonly] = ACTIONS(659),
    [anon_sym_returns_twice] = ACTIONS(659),
    [anon_sym_safestack] = ACTIONS(659),
    [anon_sym_sanitize_address] = ACTIONS(659),
    [anon_sym_sanitize_memory] = ACTIONS(659),
    [anon_sym_sanitize_thread] = ACTIONS(659),
    [anon_sym_sanitize_hwaddress] = ACTIONS(659),
    [anon_sym_sanitize_memtag] = ACTIONS(659),
    [anon_sym_speculative_load_hardening] = ACTIONS(659),
    [anon_sym_speculatable] = ACTIONS(659),
    [anon_sym_ssp] = ACTIONS(661),
    [anon_sym_sspstrong] = ACTIONS(659),
    [anon_sym_sspreq] = ACTIONS(659),
    [anon_sym_strictfp] = ACTIONS(659),
    [anon_sym_nocf_check] = ACTIONS(659),
    [anon_sym_shadowcallstack] = ACTIONS(659),
    [anon_sym_mustprogress] = ACTIONS(659),
    [anon_sym_vscale_range] = ACTIONS(659),
    [anon_sym_preallocated] = ACTIONS(659),
    [anon_sym_zeroext] = ACTIONS(659),
    [anon_sym_signext] = ACTIONS(659),
    [anon_sym_inreg] = ACTIONS(659),
    [anon_sym_byval] = ACTIONS(659),
    [anon_sym_byref] = ACTIONS(659),
    [anon_sym_inalloca] = ACTIONS(659),
    [anon_sym_sret] = ACTIONS(659),
    [anon_sym_elementtype] = ACTIONS(659),
    [anon_sym_noalias] = ACTIONS(659),
    [anon_sym_nocapture] = ACTIONS(659),
    [anon_sym_nest] = ACTIONS(659),
    [anon_sym_returned] = ACTIONS(659),
    [anon_sym_nonnull] = ACTIONS(659),
    [anon_sym_dereferenceable] = ACTIONS(661),
    [anon_sym_dereferenceable_or_null] = ACTIONS(659),
    [anon_sym_swiftself] = ACTIONS(661),
    [anon_sym_swiftasync] = ACTIONS(661),
    [anon_sym_swifterror] = ACTIONS(661),
    [anon_sym_immarg] = ACTIONS(659),
    [anon_sym_noundef] = ACTIONS(659),
    [anon_sym_uwtable] = ACTIONS(659),
    [anon_sym_memory] = ACTIONS(659),
    [anon_sym_to] = ACTIONS(661),
    [anon_sym_unwind] = ACTIONS(659),
    [anon_sym_unordered] = ACTIONS(659),
    [anon_sym_monotonic] = ACTIONS(659),
    [anon_sym_acquire] = ACTIONS(659),
    [anon_sym_release] = ACTIONS(659),
    [anon_sym_acq_rel] = ACTIONS(659),
    [anon_sym_seq_cst] = ACTIONS(659),
    [anon_sym_syncscope] = ACTIONS(659),
    [anon_sym_uselistorder] = ACTIONS(661),
    [anon_sym_uselistorder_bb] = ACTIONS(659),
    [anon_sym_module] = ACTIONS(659),
    [anon_sym_attributes] = ACTIONS(659),
  },
  [122] = {
    [ts_builtin_sym_end] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(663),
    [sym_global_var] = ACTIONS(663),
    [sym_local_var] = ACTIONS(663),
    [aux_sym_metadata_ref_token1] = ACTIONS(663),
    [sym_summary_ref] = ACTIONS(663),
    [sym_string] = ACTIONS(663),
    [anon_sym_target] = ACTIONS(663),
    [anon_sym_source_filename] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_define] = ACTIONS(663),
    [anon_sym_no_cfi] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_internal] = ACTIONS(663),
    [anon_sym_weak] = ACTIONS(665),
    [anon_sym_weak_odr] = ACTIONS(663),
    [anon_sym_linkonce] = ACTIONS(665),
    [anon_sym_linkonce_odr] = ACTIONS(663),
    [anon_sym_available_externally] = ACTIONS(663),
    [anon_sym_appending] = ACTIONS(663),
    [anon_sym_common] = ACTIONS(663),
    [anon_sym_extern_weak] = ACTIONS(663),
    [anon_sym_external] = ACTIONS(663),
    [anon_sym_dso_local] = ACTIONS(665),
    [anon_sym_dso_local_equivalent] = ACTIONS(663),
    [anon_sym_dso_preemptable] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_hidden] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_dllimport] = ACTIONS(663),
    [anon_sym_dllexport] = ACTIONS(663),
    [anon_sym_ccc] = ACTIONS(663),
    [anon_sym_fastcc] = ACTIONS(663),
    [anon_sym_coldcc] = ACTIONS(663),
    [anon_sym_webkit_jscc] = ACTIONS(665),
    [anon_sym_anyregcc] = ACTIONS(663),
    [anon_sym_preserve_mostcc] = ACTIONS(663),
    [anon_sym_preserve_allcc] = ACTIONS(663),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(665),
    [anon_sym_tailcc] = ACTIONS(663),
    [anon_sym_swiftcc] = ACTIONS(665),
    [anon_sym_swifttailcc] = ACTIONS(665),
    [anon_sym_cfguard_checkcc] = ACTIONS(663),
    [aux_sym_calling_conv_token1] = ACTIONS(665),
    [aux_sym_calling_conv_token2] = ACTIONS(663),
    [aux_sym_calling_conv_token3] = ACTIONS(663),
    [aux_sym_calling_conv_token4] = ACTIONS(663),
    [aux_sym_calling_conv_token5] = ACTIONS(663),
    [aux_sym_calling_conv_token6] = ACTIONS(663),
    [aux_sym_calling_conv_token7] = ACTIONS(663),
    [aux_sym_calling_conv_token8] = ACTIONS(663),
    [aux_sym_calling_conv_token9] = ACTIONS(663),
    [aux_sym_calling_conv_token10] = ACTIONS(665),
    [anon_sym_ghccc] = ACTIONS(663),
    [aux_sym_calling_conv_token11] = ACTIONS(665),
    [aux_sym_calling_conv_token12] = ACTIONS(663),
    [aux_sym_calling_conv_token13] = ACTIONS(665),
    [aux_sym_calling_conv_token14] = ACTIONS(663),
    [anon_sym_cc] = ACTIONS(665),
    [anon_sym_unnamed_addr] = ACTIONS(663),
    [anon_sym_local_unnamed_addr] = ACTIONS(663),
    [anon_sym_void] = ACTIONS(663),
    [anon_sym_half] = ACTIONS(663),
    [anon_sym_bfloat] = ACTIONS(663),
    [anon_sym_float] = ACTIONS(663),
    [anon_sym_double] = ACTIONS(663),
    [anon_sym_x86_fp80] = ACTIONS(665),
    [anon_sym_fp128] = ACTIONS(663),
    [anon_sym_ppc_fp128] = ACTIONS(663),
    [anon_sym_label] = ACTIONS(663),
    [anon_sym_metadata] = ACTIONS(663),
    [anon_sym_x86_mmx] = ACTIONS(665),
    [anon_sym_x86_amx] = ACTIONS(665),
    [anon_sym_token] = ACTIONS(663),
    [anon_sym_opaque] = ACTIONS(663),
    [anon_sym_ptr] = ACTIONS(663),
    [aux_sym_type_keyword_token1] = ACTIONS(663),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_RBRACE] = ACTIONS(663),
    [anon_sym_LT_LBRACE] = ACTIONS(663),
    [anon_sym_LBRACK] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(663),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(663),
    [anon_sym_RPAREN] = ACTIONS(663),
    [anon_sym_align] = ACTIONS(665),
    [anon_sym_alignstack] = ACTIONS(663),
    [anon_sym_allocsize] = ACTIONS(663),
    [anon_sym_alwaysinline] = ACTIONS(663),
    [anon_sym_builtin] = ACTIONS(663),
    [anon_sym_cold] = ACTIONS(665),
    [anon_sym_convergent] = ACTIONS(663),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(663),
    [anon_sym_hot] = ACTIONS(663),
    [anon_sym_inaccessiblememonly] = ACTIONS(663),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(663),
    [anon_sym_inlinehint] = ACTIONS(663),
    [anon_sym_jumptable] = ACTIONS(663),
    [anon_sym_minsize] = ACTIONS(663),
    [anon_sym_naked] = ACTIONS(663),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(663),
    [anon_sym_nobuiltin] = ACTIONS(663),
    [anon_sym_noduplicate] = ACTIONS(663),
    [anon_sym_nofree] = ACTIONS(663),
    [anon_sym_noimplicitfloat] = ACTIONS(663),
    [anon_sym_noinline] = ACTIONS(663),
    [anon_sym_nomerge] = ACTIONS(663),
    [anon_sym_nonlazybind] = ACTIONS(663),
    [anon_sym_noprofile] = ACTIONS(663),
    [anon_sym_noredzone] = ACTIONS(663),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(663),
    [anon_sym_noreturn] = ACTIONS(663),
    [anon_sym_norecurse] = ACTIONS(663),
    [anon_sym_willreturn] = ACTIONS(663),
    [anon_sym_nosync] = ACTIONS(663),
    [anon_sym_nounwind] = ACTIONS(663),
    [anon_sym_nocallback] = ACTIONS(663),
    [anon_sym_nosanitize_coverage] = ACTIONS(663),
    [anon_sym_null_pointer_is_valid] = ACTIONS(663),
    [anon_sym_optforfuzzing] = ACTIONS(663),
    [anon_sym_optnone] = ACTIONS(663),
    [anon_sym_optsize] = ACTIONS(663),
    [anon_sym_readnone] = ACTIONS(663),
    [anon_sym_readonly] = ACTIONS(663),
    [anon_sym_writeonly] = ACTIONS(663),
    [anon_sym_argmemonly] = ACTIONS(663),
    [anon_sym_returns_twice] = ACTIONS(663),
    [anon_sym_safestack] = ACTIONS(663),
    [anon_sym_sanitize_address] = ACTIONS(663),
    [anon_sym_sanitize_memory] = ACTIONS(663),
    [anon_sym_sanitize_thread] = ACTIONS(663),
    [anon_sym_sanitize_hwaddress] = ACTIONS(663),
    [anon_sym_sanitize_memtag] = ACTIONS(663),
    [anon_sym_speculative_load_hardening] = ACTIONS(663),
    [anon_sym_speculatable] = ACTIONS(663),
    [anon_sym_ssp] = ACTIONS(665),
    [anon_sym_sspstrong] = ACTIONS(663),
    [anon_sym_sspreq] = ACTIONS(663),
    [anon_sym_strictfp] = ACTIONS(663),
    [anon_sym_nocf_check] = ACTIONS(663),
    [anon_sym_shadowcallstack] = ACTIONS(663),
    [anon_sym_mustprogress] = ACTIONS(663),
    [anon_sym_vscale_range] = ACTIONS(663),
    [anon_sym_preallocated] = ACTIONS(663),
    [anon_sym_zeroext] = ACTIONS(663),
    [anon_sym_signext] = ACTIONS(663),
    [anon_sym_inreg] = ACTIONS(663),
    [anon_sym_byval] = ACTIONS(663),
    [anon_sym_byref] = ACTIONS(663),
    [anon_sym_inalloca] = ACTIONS(663),
    [anon_sym_sret] = ACTIONS(663),
    [anon_sym_elementtype] = ACTIONS(663),
    [anon_sym_noalias] = ACTIONS(663),
    [anon_sym_nocapture] = ACTIONS(663),
    [anon_sym_nest] = ACTIONS(663),
    [anon_sym_returned] = ACTIONS(663),
    [anon_sym_nonnull] = ACTIONS(663),
    [anon_sym_dereferenceable] = ACTIONS(665),
    [anon_sym_dereferenceable_or_null] = ACTIONS(663),
    [anon_sym_swiftself] = ACTIONS(665),
    [anon_sym_swiftasync] = ACTIONS(665),
    [anon_sym_swifterror] = ACTIONS(665),
    [anon_sym_immarg] = ACTIONS(663),
    [anon_sym_noundef] = ACTIONS(663),
    [anon_sym_uwtable] = ACTIONS(663),
    [anon_sym_memory] = ACTIONS(663),
    [anon_sym_to] = ACTIONS(665),
    [anon_sym_unwind] = ACTIONS(663),
    [anon_sym_unordered] = ACTIONS(663),
    [anon_sym_monotonic] = ACTIONS(663),
    [anon_sym_acquire] = ACTIONS(663),
    [anon_sym_release] = ACTIONS(663),
    [anon_sym_acq_rel] = ACTIONS(663),
    [anon_sym_seq_cst] = ACTIONS(663),
    [anon_sym_syncscope] = ACTIONS(663),
    [anon_sym_uselistorder] = ACTIONS(665),
    [anon_sym_uselistorder_bb] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_attributes] = ACTIONS(663),
  },
  [123] = {
    [ts_builtin_sym_end] = ACTIONS(667),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(667),
    [sym_global_var] = ACTIONS(667),
    [sym_local_var] = ACTIONS(667),
    [aux_sym_metadata_ref_token1] = ACTIONS(667),
    [sym_summary_ref] = ACTIONS(667),
    [sym_string] = ACTIONS(667),
    [anon_sym_target] = ACTIONS(667),
    [anon_sym_source_filename] = ACTIONS(667),
    [anon_sym_declare] = ACTIONS(667),
    [anon_sym_define] = ACTIONS(667),
    [anon_sym_no_cfi] = ACTIONS(667),
    [anon_sym_private] = ACTIONS(667),
    [anon_sym_internal] = ACTIONS(667),
    [anon_sym_weak] = ACTIONS(669),
    [anon_sym_weak_odr] = ACTIONS(667),
    [anon_sym_linkonce] = ACTIONS(669),
    [anon_sym_linkonce_odr] = ACTIONS(667),
    [anon_sym_available_externally] = ACTIONS(667),
    [anon_sym_appending] = ACTIONS(667),
    [anon_sym_common] = ACTIONS(667),
    [anon_sym_extern_weak] = ACTIONS(667),
    [anon_sym_external] = ACTIONS(667),
    [anon_sym_dso_local] = ACTIONS(669),
    [anon_sym_dso_local_equivalent] = ACTIONS(667),
    [anon_sym_dso_preemptable] = ACTIONS(667),
    [anon_sym_default] = ACTIONS(667),
    [anon_sym_hidden] = ACTIONS(667),
    [anon_sym_protected] = ACTIONS(667),
    [anon_sym_dllimport] = ACTIONS(667),
    [anon_sym_dllexport] = ACTIONS(667),
    [anon_sym_ccc] = ACTIONS(667),
    [anon_sym_fastcc] = ACTIONS(667),
    [anon_sym_coldcc] = ACTIONS(667),
    [anon_sym_webkit_jscc] = ACTIONS(669),
    [anon_sym_anyregcc] = ACTIONS(667),
    [anon_sym_preserve_mostcc] = ACTIONS(667),
    [anon_sym_preserve_allcc] = ACTIONS(667),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(669),
    [anon_sym_tailcc] = ACTIONS(667),
    [anon_sym_swiftcc] = ACTIONS(669),
    [anon_sym_swifttailcc] = ACTIONS(669),
    [anon_sym_cfguard_checkcc] = ACTIONS(667),
    [aux_sym_calling_conv_token1] = ACTIONS(669),
    [aux_sym_calling_conv_token2] = ACTIONS(667),
    [aux_sym_calling_conv_token3] = ACTIONS(667),
    [aux_sym_calling_conv_token4] = ACTIONS(667),
    [aux_sym_calling_conv_token5] = ACTIONS(667),
    [aux_sym_calling_conv_token6] = ACTIONS(667),
    [aux_sym_calling_conv_token7] = ACTIONS(667),
    [aux_sym_calling_conv_token8] = ACTIONS(667),
    [aux_sym_calling_conv_token9] = ACTIONS(667),
    [aux_sym_calling_conv_token10] = ACTIONS(669),
    [anon_sym_ghccc] = ACTIONS(667),
    [aux_sym_calling_conv_token11] = ACTIONS(669),
    [aux_sym_calling_conv_token12] = ACTIONS(667),
    [aux_sym_calling_conv_token13] = ACTIONS(669),
    [aux_sym_calling_conv_token14] = ACTIONS(667),
    [anon_sym_cc] = ACTIONS(669),
    [anon_sym_unnamed_addr] = ACTIONS(667),
    [anon_sym_local_unnamed_addr] = ACTIONS(667),
    [anon_sym_void] = ACTIONS(667),
    [anon_sym_half] = ACTIONS(667),
    [anon_sym_bfloat] = ACTIONS(667),
    [anon_sym_float] = ACTIONS(667),
    [anon_sym_double] = ACTIONS(667),
    [anon_sym_x86_fp80] = ACTIONS(669),
    [anon_sym_fp128] = ACTIONS(667),
    [anon_sym_ppc_fp128] = ACTIONS(667),
    [anon_sym_label] = ACTIONS(667),
    [anon_sym_metadata] = ACTIONS(667),
    [anon_sym_x86_mmx] = ACTIONS(669),
    [anon_sym_x86_amx] = ACTIONS(669),
    [anon_sym_token] = ACTIONS(667),
    [anon_sym_opaque] = ACTIONS(667),
    [anon_sym_ptr] = ACTIONS(667),
    [aux_sym_type_keyword_token1] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(667),
    [anon_sym_LT_LBRACE] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_RBRACK] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(669),
    [anon_sym_GT] = ACTIONS(667),
    [anon_sym_COMMA] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(667),
    [anon_sym_RPAREN] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_alignstack] = ACTIONS(667),
    [anon_sym_allocsize] = ACTIONS(667),
    [anon_sym_alwaysinline] = ACTIONS(667),
    [anon_sym_builtin] = ACTIONS(667),
    [anon_sym_cold] = ACTIONS(669),
    [anon_sym_convergent] = ACTIONS(667),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(667),
    [anon_sym_hot] = ACTIONS(667),
    [anon_sym_inaccessiblememonly] = ACTIONS(667),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(667),
    [anon_sym_inlinehint] = ACTIONS(667),
    [anon_sym_jumptable] = ACTIONS(667),
    [anon_sym_minsize] = ACTIONS(667),
    [anon_sym_naked] = ACTIONS(667),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(667),
    [anon_sym_nobuiltin] = ACTIONS(667),
    [anon_sym_noduplicate] = ACTIONS(667),
    [anon_sym_nofree] = ACTIONS(667),
    [anon_sym_noimplicitfloat] = ACTIONS(667),
    [anon_sym_noinline] = ACTIONS(667),
    [anon_sym_nomerge] = ACTIONS(667),
    [anon_sym_nonlazybind] = ACTIONS(667),
    [anon_sym_noprofile] = ACTIONS(667),
    [anon_sym_noredzone] = ACTIONS(667),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(667),
    [anon_sym_noreturn] = ACTIONS(667),
    [anon_sym_norecurse] = ACTIONS(667),
    [anon_sym_willreturn] = ACTIONS(667),
    [anon_sym_nosync] = ACTIONS(667),
    [anon_sym_nounwind] = ACTIONS(667),
    [anon_sym_nocallback] = ACTIONS(667),
    [anon_sym_nosanitize_coverage] = ACTIONS(667),
    [anon_sym_null_pointer_is_valid] = ACTIONS(667),
    [anon_sym_optforfuzzing] = ACTIONS(667),
    [anon_sym_optnone] = ACTIONS(667),
    [anon_sym_optsize] = ACTIONS(667),
    [anon_sym_readnone] = ACTIONS(667),
    [anon_sym_readonly] = ACTIONS(667),
    [anon_sym_writeonly] = ACTIONS(667),
    [anon_sym_argmemonly] = ACTIONS(667),
    [anon_sym_returns_twice] = ACTIONS(667),
    [anon_sym_safestack] = ACTIONS(667),
    [anon_sym_sanitize_address] = ACTIONS(667),
    [anon_sym_sanitize_memory] = ACTIONS(667),
    [anon_sym_sanitize_thread] = ACTIONS(667),
    [anon_sym_sanitize_hwaddress] = ACTIONS(667),
    [anon_sym_sanitize_memtag] = ACTIONS(667),
    [anon_sym_speculative_load_hardening] = ACTIONS(667),
    [anon_sym_speculatable] = ACTIONS(667),
    [anon_sym_ssp] = ACTIONS(669),
    [anon_sym_sspstrong] = ACTIONS(667),
    [anon_sym_sspreq] = ACTIONS(667),
    [anon_sym_strictfp] = ACTIONS(667),
    [anon_sym_nocf_check] = ACTIONS(667),
    [anon_sym_shadowcallstack] = ACTIONS(667),
    [anon_sym_mustprogress] = ACTIONS(667),
    [anon_sym_vscale_range] = ACTIONS(667),
    [anon_sym_preallocated] = ACTIONS(667),
    [anon_sym_zeroext] = ACTIONS(667),
    [anon_sym_signext] = ACTIONS(667),
    [anon_sym_inreg] = ACTIONS(667),
    [anon_sym_byval] = ACTIONS(667),
    [anon_sym_byref] = ACTIONS(667),
    [anon_sym_inalloca] = ACTIONS(667),
    [anon_sym_sret] = ACTIONS(667),
    [anon_sym_elementtype] = ACTIONS(667),
    [anon_sym_noalias] = ACTIONS(667),
    [anon_sym_nocapture] = ACTIONS(667),
    [anon_sym_nest] = ACTIONS(667),
    [anon_sym_returned] = ACTIONS(667),
    [anon_sym_nonnull] = ACTIONS(667),
    [anon_sym_dereferenceable] = ACTIONS(669),
    [anon_sym_dereferenceable_or_null] = ACTIONS(667),
    [anon_sym_swiftself] = ACTIONS(669),
    [anon_sym_swiftasync] = ACTIONS(669),
    [anon_sym_swifterror] = ACTIONS(669),
    [anon_sym_immarg] = ACTIONS(667),
    [anon_sym_noundef] = ACTIONS(667),
    [anon_sym_uwtable] = ACTIONS(667),
    [anon_sym_memory] = ACTIONS(667),
    [anon_sym_to] = ACTIONS(669),
    [anon_sym_unwind] = ACTIONS(667),
    [anon_sym_unordered] = ACTIONS(667),
    [anon_sym_monotonic] = ACTIONS(667),
    [anon_sym_acquire] = ACTIONS(667),
    [anon_sym_release] = ACTIONS(667),
    [anon_sym_acq_rel] = ACTIONS(667),
    [anon_sym_seq_cst] = ACTIONS(667),
    [anon_sym_syncscope] = ACTIONS(667),
    [anon_sym_uselistorder] = ACTIONS(669),
    [anon_sym_uselistorder_bb] = ACTIONS(667),
    [anon_sym_module] = ACTIONS(667),
    [anon_sym_attributes] = ACTIONS(667),
  },
  [124] = {
    [ts_builtin_sym_end] = ACTIONS(671),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(671),
    [sym_global_var] = ACTIONS(671),
    [sym_local_var] = ACTIONS(671),
    [aux_sym_metadata_ref_token1] = ACTIONS(671),
    [sym_summary_ref] = ACTIONS(671),
    [sym_string] = ACTIONS(671),
    [anon_sym_target] = ACTIONS(671),
    [anon_sym_source_filename] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_define] = ACTIONS(671),
    [anon_sym_no_cfi] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_internal] = ACTIONS(671),
    [anon_sym_weak] = ACTIONS(673),
    [anon_sym_weak_odr] = ACTIONS(671),
    [anon_sym_linkonce] = ACTIONS(673),
    [anon_sym_linkonce_odr] = ACTIONS(671),
    [anon_sym_available_externally] = ACTIONS(671),
    [anon_sym_appending] = ACTIONS(671),
    [anon_sym_common] = ACTIONS(671),
    [anon_sym_extern_weak] = ACTIONS(671),
    [anon_sym_external] = ACTIONS(671),
    [anon_sym_dso_local] = ACTIONS(673),
    [anon_sym_dso_local_equivalent] = ACTIONS(671),
    [anon_sym_dso_preemptable] = ACTIONS(671),
    [anon_sym_default] = ACTIONS(671),
    [anon_sym_hidden] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_dllimport] = ACTIONS(671),
    [anon_sym_dllexport] = ACTIONS(671),
    [anon_sym_ccc] = ACTIONS(671),
    [anon_sym_fastcc] = ACTIONS(671),
    [anon_sym_coldcc] = ACTIONS(671),
    [anon_sym_webkit_jscc] = ACTIONS(673),
    [anon_sym_anyregcc] = ACTIONS(671),
    [anon_sym_preserve_mostcc] = ACTIONS(671),
    [anon_sym_preserve_allcc] = ACTIONS(671),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(673),
    [anon_sym_tailcc] = ACTIONS(671),
    [anon_sym_swiftcc] = ACTIONS(673),
    [anon_sym_swifttailcc] = ACTIONS(673),
    [anon_sym_cfguard_checkcc] = ACTIONS(671),
    [aux_sym_calling_conv_token1] = ACTIONS(673),
    [aux_sym_calling_conv_token2] = ACTIONS(671),
    [aux_sym_calling_conv_token3] = ACTIONS(671),
    [aux_sym_calling_conv_token4] = ACTIONS(671),
    [aux_sym_calling_conv_token5] = ACTIONS(671),
    [aux_sym_calling_conv_token6] = ACTIONS(671),
    [aux_sym_calling_conv_token7] = ACTIONS(671),
    [aux_sym_calling_conv_token8] = ACTIONS(671),
    [aux_sym_calling_conv_token9] = ACTIONS(671),
    [aux_sym_calling_conv_token10] = ACTIONS(673),
    [anon_sym_ghccc] = ACTIONS(671),
    [aux_sym_calling_conv_token11] = ACTIONS(673),
    [aux_sym_calling_conv_token12] = ACTIONS(671),
    [aux_sym_calling_conv_token13] = ACTIONS(673),
    [aux_sym_calling_conv_token14] = ACTIONS(671),
    [anon_sym_cc] = ACTIONS(673),
    [anon_sym_unnamed_addr] = ACTIONS(671),
    [anon_sym_local_unnamed_addr] = ACTIONS(671),
    [anon_sym_void] = ACTIONS(671),
    [anon_sym_half] = ACTIONS(671),
    [anon_sym_bfloat] = ACTIONS(671),
    [anon_sym_float] = ACTIONS(671),
    [anon_sym_double] = ACTIONS(671),
    [anon_sym_x86_fp80] = ACTIONS(673),
    [anon_sym_fp128] = ACTIONS(671),
    [anon_sym_ppc_fp128] = ACTIONS(671),
    [anon_sym_label] = ACTIONS(671),
    [anon_sym_metadata] = ACTIONS(671),
    [anon_sym_x86_mmx] = ACTIONS(673),
    [anon_sym_x86_amx] = ACTIONS(673),
    [anon_sym_token] = ACTIONS(671),
    [anon_sym_opaque] = ACTIONS(671),
    [anon_sym_ptr] = ACTIONS(671),
    [aux_sym_type_keyword_token1] = ACTIONS(671),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(671),
    [anon_sym_LT_LBRACE] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_RBRACK] = ACTIONS(671),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_GT] = ACTIONS(671),
    [anon_sym_COMMA] = ACTIONS(671),
    [anon_sym_LPAREN] = ACTIONS(671),
    [anon_sym_RPAREN] = ACTIONS(671),
    [anon_sym_align] = ACTIONS(673),
    [anon_sym_alignstack] = ACTIONS(671),
    [anon_sym_allocsize] = ACTIONS(671),
    [anon_sym_alwaysinline] = ACTIONS(671),
    [anon_sym_builtin] = ACTIONS(671),
    [anon_sym_cold] = ACTIONS(673),
    [anon_sym_convergent] = ACTIONS(671),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(671),
    [anon_sym_hot] = ACTIONS(671),
    [anon_sym_inaccessiblememonly] = ACTIONS(671),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(671),
    [anon_sym_inlinehint] = ACTIONS(671),
    [anon_sym_jumptable] = ACTIONS(671),
    [anon_sym_minsize] = ACTIONS(671),
    [anon_sym_naked] = ACTIONS(671),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(671),
    [anon_sym_nobuiltin] = ACTIONS(671),
    [anon_sym_noduplicate] = ACTIONS(671),
    [anon_sym_nofree] = ACTIONS(671),
    [anon_sym_noimplicitfloat] = ACTIONS(671),
    [anon_sym_noinline] = ACTIONS(671),
    [anon_sym_nomerge] = ACTIONS(671),
    [anon_sym_nonlazybind] = ACTIONS(671),
    [anon_sym_noprofile] = ACTIONS(671),
    [anon_sym_noredzone] = ACTIONS(671),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(671),
    [anon_sym_noreturn] = ACTIONS(671),
    [anon_sym_norecurse] = ACTIONS(671),
    [anon_sym_willreturn] = ACTIONS(671),
    [anon_sym_nosync] = ACTIONS(671),
    [anon_sym_nounwind] = ACTIONS(671),
    [anon_sym_nocallback] = ACTIONS(671),
    [anon_sym_nosanitize_coverage] = ACTIONS(671),
    [anon_sym_null_pointer_is_valid] = ACTIONS(671),
    [anon_sym_optforfuzzing] = ACTIONS(671),
    [anon_sym_optnone] = ACTIONS(671),
    [anon_sym_optsize] = ACTIONS(671),
    [anon_sym_readnone] = ACTIONS(671),
    [anon_sym_readonly] = ACTIONS(671),
    [anon_sym_writeonly] = ACTIONS(671),
    [anon_sym_argmemonly] = ACTIONS(671),
    [anon_sym_returns_twice] = ACTIONS(671),
    [anon_sym_safestack] = ACTIONS(671),
    [anon_sym_sanitize_address] = ACTIONS(671),
    [anon_sym_sanitize_memory] = ACTIONS(671),
    [anon_sym_sanitize_thread] = ACTIONS(671),
    [anon_sym_sanitize_hwaddress] = ACTIONS(671),
    [anon_sym_sanitize_memtag] = ACTIONS(671),
    [anon_sym_speculative_load_hardening] = ACTIONS(671),
    [anon_sym_speculatable] = ACTIONS(671),
    [anon_sym_ssp] = ACTIONS(673),
    [anon_sym_sspstrong] = ACTIONS(671),
    [anon_sym_sspreq] = ACTIONS(671),
    [anon_sym_strictfp] = ACTIONS(671),
    [anon_sym_nocf_check] = ACTIONS(671),
    [anon_sym_shadowcallstack] = ACTIONS(671),
    [anon_sym_mustprogress] = ACTIONS(671),
    [anon_sym_vscale_range] = ACTIONS(671),
    [anon_sym_preallocated] = ACTIONS(671),
    [anon_sym_zeroext] = ACTIONS(671),
    [anon_sym_signext] = ACTIONS(671),
    [anon_sym_inreg] = ACTIONS(671),
    [anon_sym_byval] = ACTIONS(671),
    [anon_sym_byref] = ACTIONS(671),
    [anon_sym_inalloca] = ACTIONS(671),
    [anon_sym_sret] = ACTIONS(671),
    [anon_sym_elementtype] = ACTIONS(671),
    [anon_sym_noalias] = ACTIONS(671),
    [anon_sym_nocapture] = ACTIONS(671),
    [anon_sym_nest] = ACTIONS(671),
    [anon_sym_returned] = ACTIONS(671),
    [anon_sym_nonnull] = ACTIONS(671),
    [anon_sym_dereferenceable] = ACTIONS(673),
    [anon_sym_dereferenceable_or_null] = ACTIONS(671),
    [anon_sym_swiftself] = ACTIONS(673),
    [anon_sym_swiftasync] = ACTIONS(673),
    [anon_sym_swifterror] = ACTIONS(673),
    [anon_sym_immarg] = ACTIONS(671),
    [anon_sym_noundef] = ACTIONS(671),
    [anon_sym_uwtable] = ACTIONS(671),
    [anon_sym_memory] = ACTIONS(671),
    [anon_sym_to] = ACTIONS(673),
    [anon_sym_unwind] = ACTIONS(671),
    [anon_sym_unordered] = ACTIONS(671),
    [anon_sym_monotonic] = ACTIONS(671),
    [anon_sym_acquire] = ACTIONS(671),
    [anon_sym_release] = ACTIONS(671),
    [anon_sym_acq_rel] = ACTIONS(671),
    [anon_sym_seq_cst] = ACTIONS(671),
    [anon_sym_syncscope] = ACTIONS(671),
    [anon_sym_uselistorder] = ACTIONS(673),
    [anon_sym_uselistorder_bb] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_attributes] = ACTIONS(671),
  },
  [125] = {
    [ts_builtin_sym_end] = ACTIONS(675),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(675),
    [sym_global_var] = ACTIONS(675),
    [sym_local_var] = ACTIONS(675),
    [aux_sym_metadata_ref_token1] = ACTIONS(675),
    [sym_summary_ref] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [anon_sym_target] = ACTIONS(675),
    [anon_sym_source_filename] = ACTIONS(675),
    [anon_sym_declare] = ACTIONS(675),
    [anon_sym_define] = ACTIONS(675),
    [anon_sym_no_cfi] = ACTIONS(675),
    [anon_sym_private] = ACTIONS(675),
    [anon_sym_internal] = ACTIONS(675),
    [anon_sym_weak] = ACTIONS(677),
    [anon_sym_weak_odr] = ACTIONS(675),
    [anon_sym_linkonce] = ACTIONS(677),
    [anon_sym_linkonce_odr] = ACTIONS(675),
    [anon_sym_available_externally] = ACTIONS(675),
    [anon_sym_appending] = ACTIONS(675),
    [anon_sym_common] = ACTIONS(675),
    [anon_sym_extern_weak] = ACTIONS(675),
    [anon_sym_external] = ACTIONS(675),
    [anon_sym_dso_local] = ACTIONS(677),
    [anon_sym_dso_local_equivalent] = ACTIONS(675),
    [anon_sym_dso_preemptable] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_hidden] = ACTIONS(675),
    [anon_sym_protected] = ACTIONS(675),
    [anon_sym_dllimport] = ACTIONS(675),
    [anon_sym_dllexport] = ACTIONS(675),
    [anon_sym_ccc] = ACTIONS(675),
    [anon_sym_fastcc] = ACTIONS(675),
    [anon_sym_coldcc] = ACTIONS(675),
    [anon_sym_webkit_jscc] = ACTIONS(677),
    [anon_sym_anyregcc] = ACTIONS(675),
    [anon_sym_preserve_mostcc] = ACTIONS(675),
    [anon_sym_preserve_allcc] = ACTIONS(675),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(677),
    [anon_sym_tailcc] = ACTIONS(675),
    [anon_sym_swiftcc] = ACTIONS(677),
    [anon_sym_swifttailcc] = ACTIONS(677),
    [anon_sym_cfguard_checkcc] = ACTIONS(675),
    [aux_sym_calling_conv_token1] = ACTIONS(677),
    [aux_sym_calling_conv_token2] = ACTIONS(675),
    [aux_sym_calling_conv_token3] = ACTIONS(675),
    [aux_sym_calling_conv_token4] = ACTIONS(675),
    [aux_sym_calling_conv_token5] = ACTIONS(675),
    [aux_sym_calling_conv_token6] = ACTIONS(675),
    [aux_sym_calling_conv_token7] = ACTIONS(675),
    [aux_sym_calling_conv_token8] = ACTIONS(675),
    [aux_sym_calling_conv_token9] = ACTIONS(675),
    [aux_sym_calling_conv_token10] = ACTIONS(677),
    [anon_sym_ghccc] = ACTIONS(675),
    [aux_sym_calling_conv_token11] = ACTIONS(677),
    [aux_sym_calling_conv_token12] = ACTIONS(675),
    [aux_sym_calling_conv_token13] = ACTIONS(677),
    [aux_sym_calling_conv_token14] = ACTIONS(675),
    [anon_sym_cc] = ACTIONS(677),
    [anon_sym_unnamed_addr] = ACTIONS(675),
    [anon_sym_local_unnamed_addr] = ACTIONS(675),
    [anon_sym_void] = ACTIONS(675),
    [anon_sym_half] = ACTIONS(675),
    [anon_sym_bfloat] = ACTIONS(675),
    [anon_sym_float] = ACTIONS(675),
    [anon_sym_double] = ACTIONS(675),
    [anon_sym_x86_fp80] = ACTIONS(677),
    [anon_sym_fp128] = ACTIONS(675),
    [anon_sym_ppc_fp128] = ACTIONS(675),
    [anon_sym_label] = ACTIONS(675),
    [anon_sym_metadata] = ACTIONS(675),
    [anon_sym_x86_mmx] = ACTIONS(677),
    [anon_sym_x86_amx] = ACTIONS(677),
    [anon_sym_token] = ACTIONS(675),
    [anon_sym_opaque] = ACTIONS(675),
    [anon_sym_ptr] = ACTIONS(675),
    [aux_sym_type_keyword_token1] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(675),
    [anon_sym_RBRACE] = ACTIONS(675),
    [anon_sym_LT_LBRACE] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_RBRACK] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_GT] = ACTIONS(675),
    [anon_sym_COMMA] = ACTIONS(675),
    [anon_sym_LPAREN] = ACTIONS(675),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_align] = ACTIONS(677),
    [anon_sym_alignstack] = ACTIONS(675),
    [anon_sym_allocsize] = ACTIONS(675),
    [anon_sym_alwaysinline] = ACTIONS(675),
    [anon_sym_builtin] = ACTIONS(675),
    [anon_sym_cold] = ACTIONS(677),
    [anon_sym_convergent] = ACTIONS(675),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(675),
    [anon_sym_hot] = ACTIONS(675),
    [anon_sym_inaccessiblememonly] = ACTIONS(675),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(675),
    [anon_sym_inlinehint] = ACTIONS(675),
    [anon_sym_jumptable] = ACTIONS(675),
    [anon_sym_minsize] = ACTIONS(675),
    [anon_sym_naked] = ACTIONS(675),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(675),
    [anon_sym_nobuiltin] = ACTIONS(675),
    [anon_sym_noduplicate] = ACTIONS(675),
    [anon_sym_nofree] = ACTIONS(675),
    [anon_sym_noimplicitfloat] = ACTIONS(675),
    [anon_sym_noinline] = ACTIONS(675),
    [anon_sym_nomerge] = ACTIONS(675),
    [anon_sym_nonlazybind] = ACTIONS(675),
    [anon_sym_noprofile] = ACTIONS(675),
    [anon_sym_noredzone] = ACTIONS(675),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(675),
    [anon_sym_noreturn] = ACTIONS(675),
    [anon_sym_norecurse] = ACTIONS(675),
    [anon_sym_willreturn] = ACTIONS(675),
    [anon_sym_nosync] = ACTIONS(675),
    [anon_sym_nounwind] = ACTIONS(675),
    [anon_sym_nocallback] = ACTIONS(675),
    [anon_sym_nosanitize_coverage] = ACTIONS(675),
    [anon_sym_null_pointer_is_valid] = ACTIONS(675),
    [anon_sym_optforfuzzing] = ACTIONS(675),
    [anon_sym_optnone] = ACTIONS(675),
    [anon_sym_optsize] = ACTIONS(675),
    [anon_sym_readnone] = ACTIONS(675),
    [anon_sym_readonly] = ACTIONS(675),
    [anon_sym_writeonly] = ACTIONS(675),
    [anon_sym_argmemonly] = ACTIONS(675),
    [anon_sym_returns_twice] = ACTIONS(675),
    [anon_sym_safestack] = ACTIONS(675),
    [anon_sym_sanitize_address] = ACTIONS(675),
    [anon_sym_sanitize_memory] = ACTIONS(675),
    [anon_sym_sanitize_thread] = ACTIONS(675),
    [anon_sym_sanitize_hwaddress] = ACTIONS(675),
    [anon_sym_sanitize_memtag] = ACTIONS(675),
    [anon_sym_speculative_load_hardening] = ACTIONS(675),
    [anon_sym_speculatable] = ACTIONS(675),
    [anon_sym_ssp] = ACTIONS(677),
    [anon_sym_sspstrong] = ACTIONS(675),
    [anon_sym_sspreq] = ACTIONS(675),
    [anon_sym_strictfp] = ACTIONS(675),
    [anon_sym_nocf_check] = ACTIONS(675),
    [anon_sym_shadowcallstack] = ACTIONS(675),
    [anon_sym_mustprogress] = ACTIONS(675),
    [anon_sym_vscale_range] = ACTIONS(675),
    [anon_sym_preallocated] = ACTIONS(675),
    [anon_sym_zeroext] = ACTIONS(675),
    [anon_sym_signext] = ACTIONS(675),
    [anon_sym_inreg] = ACTIONS(675),
    [anon_sym_byval] = ACTIONS(675),
    [anon_sym_byref] = ACTIONS(675),
    [anon_sym_inalloca] = ACTIONS(675),
    [anon_sym_sret] = ACTIONS(675),
    [anon_sym_elementtype] = ACTIONS(675),
    [anon_sym_noalias] = ACTIONS(675),
    [anon_sym_nocapture] = ACTIONS(675),
    [anon_sym_nest] = ACTIONS(675),
    [anon_sym_returned] = ACTIONS(675),
    [anon_sym_nonnull] = ACTIONS(675),
    [anon_sym_dereferenceable] = ACTIONS(677),
    [anon_sym_dereferenceable_or_null] = ACTIONS(675),
    [anon_sym_swiftself] = ACTIONS(677),
    [anon_sym_swiftasync] = ACTIONS(677),
    [anon_sym_swifterror] = ACTIONS(677),
    [anon_sym_immarg] = ACTIONS(675),
    [anon_sym_noundef] = ACTIONS(675),
    [anon_sym_uwtable] = ACTIONS(675),
    [anon_sym_memory] = ACTIONS(675),
    [anon_sym_to] = ACTIONS(677),
    [anon_sym_unwind] = ACTIONS(675),
    [anon_sym_unordered] = ACTIONS(675),
    [anon_sym_monotonic] = ACTIONS(675),
    [anon_sym_acquire] = ACTIONS(675),
    [anon_sym_release] = ACTIONS(675),
    [anon_sym_acq_rel] = ACTIONS(675),
    [anon_sym_seq_cst] = ACTIONS(675),
    [anon_sym_syncscope] = ACTIONS(675),
    [anon_sym_uselistorder] = ACTIONS(677),
    [anon_sym_uselistorder_bb] = ACTIONS(675),
    [anon_sym_module] = ACTIONS(675),
    [anon_sym_attributes] = ACTIONS(675),
  },
  [126] = {
    [ts_builtin_sym_end] = ACTIONS(679),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(679),
    [sym_global_var] = ACTIONS(679),
    [sym_local_var] = ACTIONS(679),
    [aux_sym_metadata_ref_token1] = ACTIONS(679),
    [sym_summary_ref] = ACTIONS(679),
    [sym_string] = ACTIONS(679),
    [anon_sym_target] = ACTIONS(679),
    [anon_sym_source_filename] = ACTIONS(679),
    [anon_sym_declare] = ACTIONS(679),
    [anon_sym_define] = ACTIONS(679),
    [anon_sym_no_cfi] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_internal] = ACTIONS(679),
    [anon_sym_weak] = ACTIONS(681),
    [anon_sym_weak_odr] = ACTIONS(679),
    [anon_sym_linkonce] = ACTIONS(681),
    [anon_sym_linkonce_odr] = ACTIONS(679),
    [anon_sym_available_externally] = ACTIONS(679),
    [anon_sym_appending] = ACTIONS(679),
    [anon_sym_common] = ACTIONS(679),
    [anon_sym_extern_weak] = ACTIONS(679),
    [anon_sym_external] = ACTIONS(679),
    [anon_sym_dso_local] = ACTIONS(681),
    [anon_sym_dso_local_equivalent] = ACTIONS(679),
    [anon_sym_dso_preemptable] = ACTIONS(679),
    [anon_sym_default] = ACTIONS(679),
    [anon_sym_hidden] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_dllimport] = ACTIONS(679),
    [anon_sym_dllexport] = ACTIONS(679),
    [anon_sym_ccc] = ACTIONS(679),
    [anon_sym_fastcc] = ACTIONS(679),
    [anon_sym_coldcc] = ACTIONS(679),
    [anon_sym_webkit_jscc] = ACTIONS(681),
    [anon_sym_anyregcc] = ACTIONS(679),
    [anon_sym_preserve_mostcc] = ACTIONS(679),
    [anon_sym_preserve_allcc] = ACTIONS(679),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(681),
    [anon_sym_tailcc] = ACTIONS(679),
    [anon_sym_swiftcc] = ACTIONS(681),
    [anon_sym_swifttailcc] = ACTIONS(681),
    [anon_sym_cfguard_checkcc] = ACTIONS(679),
    [aux_sym_calling_conv_token1] = ACTIONS(681),
    [aux_sym_calling_conv_token2] = ACTIONS(679),
    [aux_sym_calling_conv_token3] = ACTIONS(679),
    [aux_sym_calling_conv_token4] = ACTIONS(679),
    [aux_sym_calling_conv_token5] = ACTIONS(679),
    [aux_sym_calling_conv_token6] = ACTIONS(679),
    [aux_sym_calling_conv_token7] = ACTIONS(679),
    [aux_sym_calling_conv_token8] = ACTIONS(679),
    [aux_sym_calling_conv_token9] = ACTIONS(679),
    [aux_sym_calling_conv_token10] = ACTIONS(681),
    [anon_sym_ghccc] = ACTIONS(679),
    [aux_sym_calling_conv_token11] = ACTIONS(681),
    [aux_sym_calling_conv_token12] = ACTIONS(679),
    [aux_sym_calling_conv_token13] = ACTIONS(681),
    [aux_sym_calling_conv_token14] = ACTIONS(679),
    [anon_sym_cc] = ACTIONS(681),
    [anon_sym_unnamed_addr] = ACTIONS(679),
    [anon_sym_local_unnamed_addr] = ACTIONS(679),
    [anon_sym_void] = ACTIONS(679),
    [anon_sym_half] = ACTIONS(679),
    [anon_sym_bfloat] = ACTIONS(679),
    [anon_sym_float] = ACTIONS(679),
    [anon_sym_double] = ACTIONS(679),
    [anon_sym_x86_fp80] = ACTIONS(681),
    [anon_sym_fp128] = ACTIONS(679),
    [anon_sym_ppc_fp128] = ACTIONS(679),
    [anon_sym_label] = ACTIONS(679),
    [anon_sym_metadata] = ACTIONS(679),
    [anon_sym_x86_mmx] = ACTIONS(681),
    [anon_sym_x86_amx] = ACTIONS(681),
    [anon_sym_token] = ACTIONS(679),
    [anon_sym_opaque] = ACTIONS(679),
    [anon_sym_ptr] = ACTIONS(679),
    [aux_sym_type_keyword_token1] = ACTIONS(679),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(679),
    [anon_sym_LT_LBRACE] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(679),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_COMMA] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_alignstack] = ACTIONS(679),
    [anon_sym_allocsize] = ACTIONS(679),
    [anon_sym_alwaysinline] = ACTIONS(679),
    [anon_sym_builtin] = ACTIONS(679),
    [anon_sym_cold] = ACTIONS(681),
    [anon_sym_convergent] = ACTIONS(679),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(679),
    [anon_sym_hot] = ACTIONS(679),
    [anon_sym_inaccessiblememonly] = ACTIONS(679),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(679),
    [anon_sym_inlinehint] = ACTIONS(679),
    [anon_sym_jumptable] = ACTIONS(679),
    [anon_sym_minsize] = ACTIONS(679),
    [anon_sym_naked] = ACTIONS(679),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(679),
    [anon_sym_nobuiltin] = ACTIONS(679),
    [anon_sym_noduplicate] = ACTIONS(679),
    [anon_sym_nofree] = ACTIONS(679),
    [anon_sym_noimplicitfloat] = ACTIONS(679),
    [anon_sym_noinline] = ACTIONS(679),
    [anon_sym_nomerge] = ACTIONS(679),
    [anon_sym_nonlazybind] = ACTIONS(679),
    [anon_sym_noprofile] = ACTIONS(679),
    [anon_sym_noredzone] = ACTIONS(679),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(679),
    [anon_sym_noreturn] = ACTIONS(679),
    [anon_sym_norecurse] = ACTIONS(679),
    [anon_sym_willreturn] = ACTIONS(679),
    [anon_sym_nosync] = ACTIONS(679),
    [anon_sym_nounwind] = ACTIONS(679),
    [anon_sym_nocallback] = ACTIONS(679),
    [anon_sym_nosanitize_coverage] = ACTIONS(679),
    [anon_sym_null_pointer_is_valid] = ACTIONS(679),
    [anon_sym_optforfuzzing] = ACTIONS(679),
    [anon_sym_optnone] = ACTIONS(679),
    [anon_sym_optsize] = ACTIONS(679),
    [anon_sym_readnone] = ACTIONS(679),
    [anon_sym_readonly] = ACTIONS(679),
    [anon_sym_writeonly] = ACTIONS(679),
    [anon_sym_argmemonly] = ACTIONS(679),
    [anon_sym_returns_twice] = ACTIONS(679),
    [anon_sym_safestack] = ACTIONS(679),
    [anon_sym_sanitize_address] = ACTIONS(679),
    [anon_sym_sanitize_memory] = ACTIONS(679),
    [anon_sym_sanitize_thread] = ACTIONS(679),
    [anon_sym_sanitize_hwaddress] = ACTIONS(679),
    [anon_sym_sanitize_memtag] = ACTIONS(679),
    [anon_sym_speculative_load_hardening] = ACTIONS(679),
    [anon_sym_speculatable] = ACTIONS(679),
    [anon_sym_ssp] = ACTIONS(681),
    [anon_sym_sspstrong] = ACTIONS(679),
    [anon_sym_sspreq] = ACTIONS(679),
    [anon_sym_strictfp] = ACTIONS(679),
    [anon_sym_nocf_check] = ACTIONS(679),
    [anon_sym_shadowcallstack] = ACTIONS(679),
    [anon_sym_mustprogress] = ACTIONS(679),
    [anon_sym_vscale_range] = ACTIONS(679),
    [anon_sym_preallocated] = ACTIONS(679),
    [anon_sym_zeroext] = ACTIONS(679),
    [anon_sym_signext] = ACTIONS(679),
    [anon_sym_inreg] = ACTIONS(679),
    [anon_sym_byval] = ACTIONS(679),
    [anon_sym_byref] = ACTIONS(679),
    [anon_sym_inalloca] = ACTIONS(679),
    [anon_sym_sret] = ACTIONS(679),
    [anon_sym_elementtype] = ACTIONS(679),
    [anon_sym_noalias] = ACTIONS(679),
    [anon_sym_nocapture] = ACTIONS(679),
    [anon_sym_nest] = ACTIONS(679),
    [anon_sym_returned] = ACTIONS(679),
    [anon_sym_nonnull] = ACTIONS(679),
    [anon_sym_dereferenceable] = ACTIONS(681),
    [anon_sym_dereferenceable_or_null] = ACTIONS(679),
    [anon_sym_swiftself] = ACTIONS(681),
    [anon_sym_swiftasync] = ACTIONS(681),
    [anon_sym_swifterror] = ACTIONS(681),
    [anon_sym_immarg] = ACTIONS(679),
    [anon_sym_noundef] = ACTIONS(679),
    [anon_sym_uwtable] = ACTIONS(679),
    [anon_sym_memory] = ACTIONS(679),
    [anon_sym_to] = ACTIONS(681),
    [anon_sym_unwind] = ACTIONS(679),
    [anon_sym_unordered] = ACTIONS(679),
    [anon_sym_monotonic] = ACTIONS(679),
    [anon_sym_acquire] = ACTIONS(679),
    [anon_sym_release] = ACTIONS(679),
    [anon_sym_acq_rel] = ACTIONS(679),
    [anon_sym_seq_cst] = ACTIONS(679),
    [anon_sym_syncscope] = ACTIONS(679),
    [anon_sym_uselistorder] = ACTIONS(681),
    [anon_sym_uselistorder_bb] = ACTIONS(679),
    [anon_sym_module] = ACTIONS(679),
    [anon_sym_attributes] = ACTIONS(679),
  },
  [127] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(505),
    [sym_local_var] = ACTIONS(505),
    [sym_label] = ACTIONS(505),
    [sym_string] = ACTIONS(507),
    [anon_sym_RBRACE] = ACTIONS(505),
    [anon_sym_LBRACK] = ACTIONS(505),
    [anon_sym_COMMA] = ACTIONS(505),
    [anon_sym_align] = ACTIONS(507),
    [anon_sym_section] = ACTIONS(507),
    [anon_sym_partition] = ACTIONS(507),
    [anon_sym_comdat] = ACTIONS(507),
    [anon_sym_gc] = ACTIONS(507),
    [anon_sym_prefix] = ACTIONS(507),
    [anon_sym_prologue] = ACTIONS(507),
    [anon_sym_personality] = ACTIONS(507),
    [anon_sym_alignstack] = ACTIONS(507),
    [anon_sym_allocsize] = ACTIONS(507),
    [anon_sym_alwaysinline] = ACTIONS(507),
    [anon_sym_builtin] = ACTIONS(507),
    [anon_sym_cold] = ACTIONS(507),
    [anon_sym_convergent] = ACTIONS(507),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(507),
    [anon_sym_hot] = ACTIONS(507),
    [anon_sym_inaccessiblememonly] = ACTIONS(507),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(507),
    [anon_sym_inlinehint] = ACTIONS(507),
    [anon_sym_jumptable] = ACTIONS(507),
    [anon_sym_minsize] = ACTIONS(507),
    [anon_sym_naked] = ACTIONS(507),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(507),
    [anon_sym_nobuiltin] = ACTIONS(507),
    [anon_sym_noduplicate] = ACTIONS(507),
    [anon_sym_nofree] = ACTIONS(507),
    [anon_sym_noimplicitfloat] = ACTIONS(507),
    [anon_sym_noinline] = ACTIONS(507),
    [anon_sym_nomerge] = ACTIONS(507),
    [anon_sym_nonlazybind] = ACTIONS(507),
    [anon_sym_noprofile] = ACTIONS(507),
    [anon_sym_noredzone] = ACTIONS(507),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(507),
    [anon_sym_noreturn] = ACTIONS(507),
    [anon_sym_norecurse] = ACTIONS(507),
    [anon_sym_willreturn] = ACTIONS(507),
    [anon_sym_nosync] = ACTIONS(507),
    [anon_sym_nounwind] = ACTIONS(507),
    [anon_sym_nocallback] = ACTIONS(507),
    [anon_sym_nosanitize_coverage] = ACTIONS(507),
    [anon_sym_null_pointer_is_valid] = ACTIONS(507),
    [anon_sym_optforfuzzing] = ACTIONS(507),
    [anon_sym_optnone] = ACTIONS(507),
    [anon_sym_optsize] = ACTIONS(507),
    [anon_sym_readnone] = ACTIONS(507),
    [anon_sym_readonly] = ACTIONS(507),
    [anon_sym_writeonly] = ACTIONS(507),
    [anon_sym_argmemonly] = ACTIONS(507),
    [anon_sym_returns_twice] = ACTIONS(507),
    [anon_sym_safestack] = ACTIONS(507),
    [anon_sym_sanitize_address] = ACTIONS(507),
    [anon_sym_sanitize_memory] = ACTIONS(507),
    [anon_sym_sanitize_thread] = ACTIONS(507),
    [anon_sym_sanitize_hwaddress] = ACTIONS(507),
    [anon_sym_sanitize_memtag] = ACTIONS(507),
    [anon_sym_speculative_load_hardening] = ACTIONS(507),
    [anon_sym_speculatable] = ACTIONS(507),
    [anon_sym_ssp] = ACTIONS(507),
    [anon_sym_sspstrong] = ACTIONS(507),
    [anon_sym_sspreq] = ACTIONS(507),
    [anon_sym_strictfp] = ACTIONS(507),
    [anon_sym_nocf_check] = ACTIONS(507),
    [anon_sym_shadowcallstack] = ACTIONS(507),
    [anon_sym_mustprogress] = ACTIONS(507),
    [anon_sym_vscale_range] = ACTIONS(507),
    [anon_sym_preallocated] = ACTIONS(507),
    [anon_sym_zeroext] = ACTIONS(507),
    [anon_sym_signext] = ACTIONS(507),
    [anon_sym_inreg] = ACTIONS(507),
    [anon_sym_byval] = ACTIONS(507),
    [anon_sym_byref] = ACTIONS(507),
    [anon_sym_inalloca] = ACTIONS(507),
    [anon_sym_sret] = ACTIONS(507),
    [anon_sym_elementtype] = ACTIONS(507),
    [anon_sym_noalias] = ACTIONS(507),
    [anon_sym_nocapture] = ACTIONS(507),
    [anon_sym_nest] = ACTIONS(507),
    [anon_sym_returned] = ACTIONS(507),
    [anon_sym_nonnull] = ACTIONS(507),
    [anon_sym_dereferenceable] = ACTIONS(507),
    [anon_sym_dereferenceable_or_null] = ACTIONS(507),
    [anon_sym_swiftself] = ACTIONS(507),
    [anon_sym_swiftasync] = ACTIONS(507),
    [anon_sym_swifterror] = ACTIONS(507),
    [anon_sym_immarg] = ACTIONS(507),
    [anon_sym_noundef] = ACTIONS(507),
    [anon_sym_uwtable] = ACTIONS(507),
    [anon_sym_memory] = ACTIONS(507),
    [anon_sym_unreachable] = ACTIONS(507),
    [anon_sym_ret] = ACTIONS(507),
    [anon_sym_br] = ACTIONS(507),
    [anon_sym_resume] = ACTIONS(507),
    [anon_sym_freeze] = ACTIONS(507),
    [anon_sym_indirectbr] = ACTIONS(507),
    [anon_sym_extractelement] = ACTIONS(507),
    [anon_sym_insertelement] = ACTIONS(507),
    [anon_sym_select] = ACTIONS(507),
    [anon_sym_shufflevector] = ACTIONS(507),
    [anon_sym_fneg] = ACTIONS(507),
    [anon_sym_switch] = ACTIONS(507),
    [anon_sym_invoke] = ACTIONS(507),
    [anon_sym_cleanupret] = ACTIONS(507),
    [anon_sym_catchret] = ACTIONS(507),
    [anon_sym_catchswitch] = ACTIONS(507),
    [anon_sym_catchpad] = ACTIONS(507),
    [anon_sym_cleanuppad] = ACTIONS(507),
    [anon_sym_callbr] = ACTIONS(507),
    [anon_sym_icmp] = ACTIONS(507),
    [anon_sym_fcmp] = ACTIONS(507),
    [anon_sym_va_arg] = ACTIONS(507),
    [anon_sym_phi] = ACTIONS(507),
    [anon_sym_landingpad] = ACTIONS(507),
    [anon_sym_tail] = ACTIONS(507),
    [anon_sym_musttail] = ACTIONS(507),
    [anon_sym_notail] = ACTIONS(507),
    [anon_sym_call] = ACTIONS(507),
    [anon_sym_alloca] = ACTIONS(507),
    [anon_sym_load] = ACTIONS(507),
    [anon_sym_store] = ACTIONS(507),
    [anon_sym_cmpxchg] = ACTIONS(507),
    [anon_sym_atomicrmw] = ACTIONS(507),
    [anon_sym_fence] = ACTIONS(507),
    [anon_sym_getelementptr] = ACTIONS(507),
    [anon_sym_extractvalue] = ACTIONS(507),
    [anon_sym_insertvalue] = ACTIONS(507),
    [anon_sym_catch] = ACTIONS(507),
    [anon_sym_filter] = ACTIONS(507),
    [anon_sym_mul] = ACTIONS(507),
    [anon_sym_urem] = ACTIONS(507),
    [anon_sym_srem] = ACTIONS(507),
    [anon_sym_shl] = ACTIONS(507),
    [anon_sym_udiv] = ACTIONS(507),
    [anon_sym_sdiv] = ACTIONS(507),
    [anon_sym_lshr] = ACTIONS(507),
    [anon_sym_ashr] = ACTIONS(507),
    [anon_sym_fmul] = ACTIONS(507),
    [anon_sym_fdiv] = ACTIONS(507),
    [anon_sym_frem] = ACTIONS(507),
    [anon_sym_xchg] = ACTIONS(507),
    [anon_sym_add] = ACTIONS(507),
    [anon_sym_sub] = ACTIONS(507),
    [anon_sym_and] = ACTIONS(507),
    [anon_sym_nand] = ACTIONS(507),
    [anon_sym_or] = ACTIONS(507),
    [anon_sym_xor] = ACTIONS(507),
    [anon_sym_max] = ACTIONS(507),
    [anon_sym_min] = ACTIONS(507),
    [anon_sym_umax] = ACTIONS(507),
    [anon_sym_umin] = ACTIONS(507),
    [anon_sym_fadd] = ACTIONS(507),
    [anon_sym_fsub] = ACTIONS(507),
    [anon_sym_bitcast] = ACTIONS(507),
    [anon_sym_trunc] = ACTIONS(507),
    [anon_sym_zext] = ACTIONS(507),
    [anon_sym_sext] = ACTIONS(507),
    [anon_sym_fptrunc] = ACTIONS(507),
    [anon_sym_fpext] = ACTIONS(507),
    [anon_sym_addrspacecast] = ACTIONS(507),
    [anon_sym_uitofp] = ACTIONS(507),
    [anon_sym_sitofp] = ACTIONS(507),
    [anon_sym_fptoui] = ACTIONS(507),
    [anon_sym_fptosi] = ACTIONS(507),
    [anon_sym_inttoptr] = ACTIONS(507),
    [anon_sym_ptrtoint] = ACTIONS(507),
    [anon_sym_unordered] = ACTIONS(507),
    [anon_sym_monotonic] = ACTIONS(507),
    [anon_sym_acquire] = ACTIONS(507),
    [anon_sym_release] = ACTIONS(507),
    [anon_sym_acq_rel] = ACTIONS(507),
    [anon_sym_seq_cst] = ACTIONS(507),
    [anon_sym_syncscope] = ACTIONS(507),
    [anon_sym_uselistorder] = ACTIONS(507),
    [anon_sym_LPAREN2] = ACTIONS(505),
  },
  [128] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(573),
    [sym_local_var] = ACTIONS(573),
    [sym_label] = ACTIONS(573),
    [sym_string] = ACTIONS(575),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_align] = ACTIONS(575),
    [anon_sym_section] = ACTIONS(575),
    [anon_sym_partition] = ACTIONS(575),
    [anon_sym_comdat] = ACTIONS(575),
    [anon_sym_gc] = ACTIONS(575),
    [anon_sym_prefix] = ACTIONS(575),
    [anon_sym_prologue] = ACTIONS(575),
    [anon_sym_personality] = ACTIONS(575),
    [anon_sym_alignstack] = ACTIONS(575),
    [anon_sym_allocsize] = ACTIONS(575),
    [anon_sym_alwaysinline] = ACTIONS(575),
    [anon_sym_builtin] = ACTIONS(575),
    [anon_sym_cold] = ACTIONS(575),
    [anon_sym_convergent] = ACTIONS(575),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(575),
    [anon_sym_hot] = ACTIONS(575),
    [anon_sym_inaccessiblememonly] = ACTIONS(575),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(575),
    [anon_sym_inlinehint] = ACTIONS(575),
    [anon_sym_jumptable] = ACTIONS(575),
    [anon_sym_minsize] = ACTIONS(575),
    [anon_sym_naked] = ACTIONS(575),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(575),
    [anon_sym_nobuiltin] = ACTIONS(575),
    [anon_sym_noduplicate] = ACTIONS(575),
    [anon_sym_nofree] = ACTIONS(575),
    [anon_sym_noimplicitfloat] = ACTIONS(575),
    [anon_sym_noinline] = ACTIONS(575),
    [anon_sym_nomerge] = ACTIONS(575),
    [anon_sym_nonlazybind] = ACTIONS(575),
    [anon_sym_noprofile] = ACTIONS(575),
    [anon_sym_noredzone] = ACTIONS(575),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(575),
    [anon_sym_noreturn] = ACTIONS(575),
    [anon_sym_norecurse] = ACTIONS(575),
    [anon_sym_willreturn] = ACTIONS(575),
    [anon_sym_nosync] = ACTIONS(575),
    [anon_sym_nounwind] = ACTIONS(575),
    [anon_sym_nocallback] = ACTIONS(575),
    [anon_sym_nosanitize_coverage] = ACTIONS(575),
    [anon_sym_null_pointer_is_valid] = ACTIONS(575),
    [anon_sym_optforfuzzing] = ACTIONS(575),
    [anon_sym_optnone] = ACTIONS(575),
    [anon_sym_optsize] = ACTIONS(575),
    [anon_sym_readnone] = ACTIONS(575),
    [anon_sym_readonly] = ACTIONS(575),
    [anon_sym_writeonly] = ACTIONS(575),
    [anon_sym_argmemonly] = ACTIONS(575),
    [anon_sym_returns_twice] = ACTIONS(575),
    [anon_sym_safestack] = ACTIONS(575),
    [anon_sym_sanitize_address] = ACTIONS(575),
    [anon_sym_sanitize_memory] = ACTIONS(575),
    [anon_sym_sanitize_thread] = ACTIONS(575),
    [anon_sym_sanitize_hwaddress] = ACTIONS(575),
    [anon_sym_sanitize_memtag] = ACTIONS(575),
    [anon_sym_speculative_load_hardening] = ACTIONS(575),
    [anon_sym_speculatable] = ACTIONS(575),
    [anon_sym_ssp] = ACTIONS(575),
    [anon_sym_sspstrong] = ACTIONS(575),
    [anon_sym_sspreq] = ACTIONS(575),
    [anon_sym_strictfp] = ACTIONS(575),
    [anon_sym_nocf_check] = ACTIONS(575),
    [anon_sym_shadowcallstack] = ACTIONS(575),
    [anon_sym_mustprogress] = ACTIONS(575),
    [anon_sym_vscale_range] = ACTIONS(575),
    [anon_sym_preallocated] = ACTIONS(575),
    [anon_sym_zeroext] = ACTIONS(575),
    [anon_sym_signext] = ACTIONS(575),
    [anon_sym_inreg] = ACTIONS(575),
    [anon_sym_byval] = ACTIONS(575),
    [anon_sym_byref] = ACTIONS(575),
    [anon_sym_inalloca] = ACTIONS(575),
    [anon_sym_sret] = ACTIONS(575),
    [anon_sym_elementtype] = ACTIONS(575),
    [anon_sym_noalias] = ACTIONS(575),
    [anon_sym_nocapture] = ACTIONS(575),
    [anon_sym_nest] = ACTIONS(575),
    [anon_sym_returned] = ACTIONS(575),
    [anon_sym_nonnull] = ACTIONS(575),
    [anon_sym_dereferenceable] = ACTIONS(575),
    [anon_sym_dereferenceable_or_null] = ACTIONS(575),
    [anon_sym_swiftself] = ACTIONS(575),
    [anon_sym_swiftasync] = ACTIONS(575),
    [anon_sym_swifterror] = ACTIONS(575),
    [anon_sym_immarg] = ACTIONS(575),
    [anon_sym_noundef] = ACTIONS(575),
    [anon_sym_uwtable] = ACTIONS(575),
    [anon_sym_memory] = ACTIONS(575),
    [anon_sym_unreachable] = ACTIONS(575),
    [anon_sym_ret] = ACTIONS(575),
    [anon_sym_br] = ACTIONS(575),
    [anon_sym_resume] = ACTIONS(575),
    [anon_sym_freeze] = ACTIONS(575),
    [anon_sym_indirectbr] = ACTIONS(575),
    [anon_sym_extractelement] = ACTIONS(575),
    [anon_sym_insertelement] = ACTIONS(575),
    [anon_sym_select] = ACTIONS(575),
    [anon_sym_shufflevector] = ACTIONS(575),
    [anon_sym_fneg] = ACTIONS(575),
    [anon_sym_switch] = ACTIONS(575),
    [anon_sym_invoke] = ACTIONS(575),
    [anon_sym_cleanupret] = ACTIONS(575),
    [anon_sym_catchret] = ACTIONS(575),
    [anon_sym_catchswitch] = ACTIONS(575),
    [anon_sym_catchpad] = ACTIONS(575),
    [anon_sym_cleanuppad] = ACTIONS(575),
    [anon_sym_callbr] = ACTIONS(575),
    [anon_sym_icmp] = ACTIONS(575),
    [anon_sym_fcmp] = ACTIONS(575),
    [anon_sym_va_arg] = ACTIONS(575),
    [anon_sym_phi] = ACTIONS(575),
    [anon_sym_landingpad] = ACTIONS(575),
    [anon_sym_tail] = ACTIONS(575),
    [anon_sym_musttail] = ACTIONS(575),
    [anon_sym_notail] = ACTIONS(575),
    [anon_sym_call] = ACTIONS(575),
    [anon_sym_alloca] = ACTIONS(575),
    [anon_sym_load] = ACTIONS(575),
    [anon_sym_store] = ACTIONS(575),
    [anon_sym_cmpxchg] = ACTIONS(575),
    [anon_sym_atomicrmw] = ACTIONS(575),
    [anon_sym_fence] = ACTIONS(575),
    [anon_sym_getelementptr] = ACTIONS(575),
    [anon_sym_extractvalue] = ACTIONS(575),
    [anon_sym_insertvalue] = ACTIONS(575),
    [anon_sym_catch] = ACTIONS(575),
    [anon_sym_filter] = ACTIONS(575),
    [anon_sym_mul] = ACTIONS(575),
    [anon_sym_urem] = ACTIONS(575),
    [anon_sym_srem] = ACTIONS(575),
    [anon_sym_shl] = ACTIONS(575),
    [anon_sym_udiv] = ACTIONS(575),
    [anon_sym_sdiv] = ACTIONS(575),
    [anon_sym_lshr] = ACTIONS(575),
    [anon_sym_ashr] = ACTIONS(575),
    [anon_sym_fmul] = ACTIONS(575),
    [anon_sym_fdiv] = ACTIONS(575),
    [anon_sym_frem] = ACTIONS(575),
    [anon_sym_xchg] = ACTIONS(575),
    [anon_sym_add] = ACTIONS(575),
    [anon_sym_sub] = ACTIONS(575),
    [anon_sym_and] = ACTIONS(575),
    [anon_sym_nand] = ACTIONS(575),
    [anon_sym_or] = ACTIONS(575),
    [anon_sym_xor] = ACTIONS(575),
    [anon_sym_max] = ACTIONS(575),
    [anon_sym_min] = ACTIONS(575),
    [anon_sym_umax] = ACTIONS(575),
    [anon_sym_umin] = ACTIONS(575),
    [anon_sym_fadd] = ACTIONS(575),
    [anon_sym_fsub] = ACTIONS(575),
    [anon_sym_bitcast] = ACTIONS(575),
    [anon_sym_trunc] = ACTIONS(575),
    [anon_sym_zext] = ACTIONS(575),
    [anon_sym_sext] = ACTIONS(575),
    [anon_sym_fptrunc] = ACTIONS(575),
    [anon_sym_fpext] = ACTIONS(575),
    [anon_sym_addrspacecast] = ACTIONS(575),
    [anon_sym_uitofp] = ACTIONS(575),
    [anon_sym_sitofp] = ACTIONS(575),
    [anon_sym_fptoui] = ACTIONS(575),
    [anon_sym_fptosi] = ACTIONS(575),
    [anon_sym_inttoptr] = ACTIONS(575),
    [anon_sym_ptrtoint] = ACTIONS(575),
    [anon_sym_unordered] = ACTIONS(575),
    [anon_sym_monotonic] = ACTIONS(575),
    [anon_sym_acquire] = ACTIONS(575),
    [anon_sym_release] = ACTIONS(575),
    [anon_sym_acq_rel] = ACTIONS(575),
    [anon_sym_seq_cst] = ACTIONS(575),
    [anon_sym_syncscope] = ACTIONS(575),
    [anon_sym_uselistorder] = ACTIONS(575),
    [anon_sym_LPAREN2] = ACTIONS(683),
  },
  [129] = {
    [ts_builtin_sym_end] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(685),
    [sym_global_var] = ACTIONS(685),
    [sym_local_var] = ACTIONS(685),
    [aux_sym_metadata_ref_token1] = ACTIONS(685),
    [sym_summary_ref] = ACTIONS(685),
    [sym_string] = ACTIONS(685),
    [anon_sym_target] = ACTIONS(685),
    [anon_sym_source_filename] = ACTIONS(685),
    [anon_sym_declare] = ACTIONS(685),
    [anon_sym_define] = ACTIONS(685),
    [anon_sym_no_cfi] = ACTIONS(685),
    [anon_sym_private] = ACTIONS(685),
    [anon_sym_internal] = ACTIONS(685),
    [anon_sym_weak] = ACTIONS(687),
    [anon_sym_weak_odr] = ACTIONS(685),
    [anon_sym_linkonce] = ACTIONS(687),
    [anon_sym_linkonce_odr] = ACTIONS(685),
    [anon_sym_available_externally] = ACTIONS(685),
    [anon_sym_appending] = ACTIONS(685),
    [anon_sym_common] = ACTIONS(685),
    [anon_sym_extern_weak] = ACTIONS(685),
    [anon_sym_external] = ACTIONS(685),
    [anon_sym_dso_local] = ACTIONS(687),
    [anon_sym_dso_local_equivalent] = ACTIONS(685),
    [anon_sym_dso_preemptable] = ACTIONS(685),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_hidden] = ACTIONS(685),
    [anon_sym_protected] = ACTIONS(685),
    [anon_sym_dllimport] = ACTIONS(685),
    [anon_sym_dllexport] = ACTIONS(685),
    [anon_sym_ccc] = ACTIONS(685),
    [anon_sym_fastcc] = ACTIONS(685),
    [anon_sym_coldcc] = ACTIONS(685),
    [anon_sym_webkit_jscc] = ACTIONS(687),
    [anon_sym_anyregcc] = ACTIONS(685),
    [anon_sym_preserve_mostcc] = ACTIONS(685),
    [anon_sym_preserve_allcc] = ACTIONS(685),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(687),
    [anon_sym_tailcc] = ACTIONS(685),
    [anon_sym_swiftcc] = ACTIONS(687),
    [anon_sym_swifttailcc] = ACTIONS(687),
    [anon_sym_cfguard_checkcc] = ACTIONS(685),
    [aux_sym_calling_conv_token1] = ACTIONS(687),
    [aux_sym_calling_conv_token2] = ACTIONS(685),
    [aux_sym_calling_conv_token3] = ACTIONS(685),
    [aux_sym_calling_conv_token4] = ACTIONS(685),
    [aux_sym_calling_conv_token5] = ACTIONS(685),
    [aux_sym_calling_conv_token6] = ACTIONS(685),
    [aux_sym_calling_conv_token7] = ACTIONS(685),
    [aux_sym_calling_conv_token8] = ACTIONS(685),
    [aux_sym_calling_conv_token9] = ACTIONS(685),
    [aux_sym_calling_conv_token10] = ACTIONS(687),
    [anon_sym_ghccc] = ACTIONS(685),
    [aux_sym_calling_conv_token11] = ACTIONS(687),
    [aux_sym_calling_conv_token12] = ACTIONS(685),
    [aux_sym_calling_conv_token13] = ACTIONS(687),
    [aux_sym_calling_conv_token14] = ACTIONS(685),
    [anon_sym_cc] = ACTIONS(687),
    [anon_sym_unnamed_addr] = ACTIONS(685),
    [anon_sym_local_unnamed_addr] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(685),
    [anon_sym_half] = ACTIONS(685),
    [anon_sym_bfloat] = ACTIONS(685),
    [anon_sym_float] = ACTIONS(685),
    [anon_sym_double] = ACTIONS(685),
    [anon_sym_x86_fp80] = ACTIONS(687),
    [anon_sym_fp128] = ACTIONS(685),
    [anon_sym_ppc_fp128] = ACTIONS(685),
    [anon_sym_label] = ACTIONS(685),
    [anon_sym_metadata] = ACTIONS(685),
    [anon_sym_x86_mmx] = ACTIONS(687),
    [anon_sym_x86_amx] = ACTIONS(687),
    [anon_sym_token] = ACTIONS(685),
    [anon_sym_opaque] = ACTIONS(685),
    [anon_sym_ptr] = ACTIONS(685),
    [aux_sym_type_keyword_token1] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(685),
    [anon_sym_RBRACE] = ACTIONS(685),
    [anon_sym_LT_LBRACE] = ACTIONS(685),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_RBRACK] = ACTIONS(685),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_GT] = ACTIONS(685),
    [anon_sym_COMMA] = ACTIONS(685),
    [anon_sym_RPAREN] = ACTIONS(685),
    [anon_sym_align] = ACTIONS(687),
    [anon_sym_alignstack] = ACTIONS(685),
    [anon_sym_allocsize] = ACTIONS(685),
    [anon_sym_alwaysinline] = ACTIONS(685),
    [anon_sym_builtin] = ACTIONS(685),
    [anon_sym_cold] = ACTIONS(687),
    [anon_sym_convergent] = ACTIONS(685),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(685),
    [anon_sym_hot] = ACTIONS(685),
    [anon_sym_inaccessiblememonly] = ACTIONS(685),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(685),
    [anon_sym_inlinehint] = ACTIONS(685),
    [anon_sym_jumptable] = ACTIONS(685),
    [anon_sym_minsize] = ACTIONS(685),
    [anon_sym_naked] = ACTIONS(685),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(685),
    [anon_sym_nobuiltin] = ACTIONS(685),
    [anon_sym_noduplicate] = ACTIONS(685),
    [anon_sym_nofree] = ACTIONS(685),
    [anon_sym_noimplicitfloat] = ACTIONS(685),
    [anon_sym_noinline] = ACTIONS(685),
    [anon_sym_nomerge] = ACTIONS(685),
    [anon_sym_nonlazybind] = ACTIONS(685),
    [anon_sym_noprofile] = ACTIONS(685),
    [anon_sym_noredzone] = ACTIONS(685),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(685),
    [anon_sym_noreturn] = ACTIONS(685),
    [anon_sym_norecurse] = ACTIONS(685),
    [anon_sym_willreturn] = ACTIONS(685),
    [anon_sym_nosync] = ACTIONS(685),
    [anon_sym_nounwind] = ACTIONS(685),
    [anon_sym_nocallback] = ACTIONS(685),
    [anon_sym_nosanitize_coverage] = ACTIONS(685),
    [anon_sym_null_pointer_is_valid] = ACTIONS(685),
    [anon_sym_optforfuzzing] = ACTIONS(685),
    [anon_sym_optnone] = ACTIONS(685),
    [anon_sym_optsize] = ACTIONS(685),
    [anon_sym_readnone] = ACTIONS(685),
    [anon_sym_readonly] = ACTIONS(685),
    [anon_sym_writeonly] = ACTIONS(685),
    [anon_sym_argmemonly] = ACTIONS(685),
    [anon_sym_returns_twice] = ACTIONS(685),
    [anon_sym_safestack] = ACTIONS(685),
    [anon_sym_sanitize_address] = ACTIONS(685),
    [anon_sym_sanitize_memory] = ACTIONS(685),
    [anon_sym_sanitize_thread] = ACTIONS(685),
    [anon_sym_sanitize_hwaddress] = ACTIONS(685),
    [anon_sym_sanitize_memtag] = ACTIONS(685),
    [anon_sym_speculative_load_hardening] = ACTIONS(685),
    [anon_sym_speculatable] = ACTIONS(685),
    [anon_sym_ssp] = ACTIONS(687),
    [anon_sym_sspstrong] = ACTIONS(685),
    [anon_sym_sspreq] = ACTIONS(685),
    [anon_sym_strictfp] = ACTIONS(685),
    [anon_sym_nocf_check] = ACTIONS(685),
    [anon_sym_shadowcallstack] = ACTIONS(685),
    [anon_sym_mustprogress] = ACTIONS(685),
    [anon_sym_vscale_range] = ACTIONS(685),
    [anon_sym_preallocated] = ACTIONS(685),
    [anon_sym_zeroext] = ACTIONS(685),
    [anon_sym_signext] = ACTIONS(685),
    [anon_sym_inreg] = ACTIONS(685),
    [anon_sym_byval] = ACTIONS(685),
    [anon_sym_byref] = ACTIONS(685),
    [anon_sym_inalloca] = ACTIONS(685),
    [anon_sym_sret] = ACTIONS(685),
    [anon_sym_elementtype] = ACTIONS(685),
    [anon_sym_noalias] = ACTIONS(685),
    [anon_sym_nocapture] = ACTIONS(685),
    [anon_sym_nest] = ACTIONS(685),
    [anon_sym_returned] = ACTIONS(685),
    [anon_sym_nonnull] = ACTIONS(685),
    [anon_sym_dereferenceable] = ACTIONS(687),
    [anon_sym_dereferenceable_or_null] = ACTIONS(685),
    [anon_sym_swiftself] = ACTIONS(687),
    [anon_sym_swiftasync] = ACTIONS(687),
    [anon_sym_swifterror] = ACTIONS(687),
    [anon_sym_immarg] = ACTIONS(685),
    [anon_sym_noundef] = ACTIONS(685),
    [anon_sym_uwtable] = ACTIONS(685),
    [anon_sym_memory] = ACTIONS(685),
    [anon_sym_to] = ACTIONS(687),
    [anon_sym_unwind] = ACTIONS(685),
    [anon_sym_unordered] = ACTIONS(685),
    [anon_sym_monotonic] = ACTIONS(685),
    [anon_sym_acquire] = ACTIONS(685),
    [anon_sym_release] = ACTIONS(685),
    [anon_sym_acq_rel] = ACTIONS(685),
    [anon_sym_seq_cst] = ACTIONS(685),
    [anon_sym_syncscope] = ACTIONS(685),
    [anon_sym_uselistorder] = ACTIONS(687),
    [anon_sym_uselistorder_bb] = ACTIONS(685),
    [anon_sym_module] = ACTIONS(685),
    [anon_sym_attributes] = ACTIONS(685),
  },
  [130] = {
    [ts_builtin_sym_end] = ACTIONS(689),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(689),
    [sym_global_var] = ACTIONS(689),
    [sym_local_var] = ACTIONS(689),
    [aux_sym_metadata_ref_token1] = ACTIONS(689),
    [sym_summary_ref] = ACTIONS(689),
    [sym_string] = ACTIONS(689),
    [anon_sym_target] = ACTIONS(689),
    [anon_sym_source_filename] = ACTIONS(689),
    [anon_sym_declare] = ACTIONS(689),
    [anon_sym_define] = ACTIONS(689),
    [anon_sym_no_cfi] = ACTIONS(689),
    [anon_sym_private] = ACTIONS(689),
    [anon_sym_internal] = ACTIONS(689),
    [anon_sym_weak] = ACTIONS(691),
    [anon_sym_weak_odr] = ACTIONS(689),
    [anon_sym_linkonce] = ACTIONS(691),
    [anon_sym_linkonce_odr] = ACTIONS(689),
    [anon_sym_available_externally] = ACTIONS(689),
    [anon_sym_appending] = ACTIONS(689),
    [anon_sym_common] = ACTIONS(689),
    [anon_sym_extern_weak] = ACTIONS(689),
    [anon_sym_external] = ACTIONS(689),
    [anon_sym_dso_local] = ACTIONS(691),
    [anon_sym_dso_local_equivalent] = ACTIONS(689),
    [anon_sym_dso_preemptable] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(689),
    [anon_sym_hidden] = ACTIONS(689),
    [anon_sym_protected] = ACTIONS(689),
    [anon_sym_dllimport] = ACTIONS(689),
    [anon_sym_dllexport] = ACTIONS(689),
    [anon_sym_ccc] = ACTIONS(689),
    [anon_sym_fastcc] = ACTIONS(689),
    [anon_sym_coldcc] = ACTIONS(689),
    [anon_sym_webkit_jscc] = ACTIONS(691),
    [anon_sym_anyregcc] = ACTIONS(689),
    [anon_sym_preserve_mostcc] = ACTIONS(689),
    [anon_sym_preserve_allcc] = ACTIONS(689),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(691),
    [anon_sym_tailcc] = ACTIONS(689),
    [anon_sym_swiftcc] = ACTIONS(691),
    [anon_sym_swifttailcc] = ACTIONS(691),
    [anon_sym_cfguard_checkcc] = ACTIONS(689),
    [aux_sym_calling_conv_token1] = ACTIONS(691),
    [aux_sym_calling_conv_token2] = ACTIONS(689),
    [aux_sym_calling_conv_token3] = ACTIONS(689),
    [aux_sym_calling_conv_token4] = ACTIONS(689),
    [aux_sym_calling_conv_token5] = ACTIONS(689),
    [aux_sym_calling_conv_token6] = ACTIONS(689),
    [aux_sym_calling_conv_token7] = ACTIONS(689),
    [aux_sym_calling_conv_token8] = ACTIONS(689),
    [aux_sym_calling_conv_token9] = ACTIONS(689),
    [aux_sym_calling_conv_token10] = ACTIONS(691),
    [anon_sym_ghccc] = ACTIONS(689),
    [aux_sym_calling_conv_token11] = ACTIONS(691),
    [aux_sym_calling_conv_token12] = ACTIONS(689),
    [aux_sym_calling_conv_token13] = ACTIONS(691),
    [aux_sym_calling_conv_token14] = ACTIONS(689),
    [anon_sym_cc] = ACTIONS(691),
    [anon_sym_unnamed_addr] = ACTIONS(689),
    [anon_sym_local_unnamed_addr] = ACTIONS(689),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_half] = ACTIONS(689),
    [anon_sym_bfloat] = ACTIONS(689),
    [anon_sym_float] = ACTIONS(689),
    [anon_sym_double] = ACTIONS(689),
    [anon_sym_x86_fp80] = ACTIONS(691),
    [anon_sym_fp128] = ACTIONS(689),
    [anon_sym_ppc_fp128] = ACTIONS(689),
    [anon_sym_label] = ACTIONS(689),
    [anon_sym_metadata] = ACTIONS(689),
    [anon_sym_x86_mmx] = ACTIONS(691),
    [anon_sym_x86_amx] = ACTIONS(691),
    [anon_sym_token] = ACTIONS(689),
    [anon_sym_opaque] = ACTIONS(689),
    [anon_sym_ptr] = ACTIONS(689),
    [aux_sym_type_keyword_token1] = ACTIONS(689),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_RBRACE] = ACTIONS(689),
    [anon_sym_LT_LBRACE] = ACTIONS(689),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_RBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(691),
    [anon_sym_GT] = ACTIONS(689),
    [anon_sym_COMMA] = ACTIONS(689),
    [anon_sym_RPAREN] = ACTIONS(689),
    [anon_sym_align] = ACTIONS(691),
    [anon_sym_alignstack] = ACTIONS(689),
    [anon_sym_allocsize] = ACTIONS(689),
    [anon_sym_alwaysinline] = ACTIONS(689),
    [anon_sym_builtin] = ACTIONS(689),
    [anon_sym_cold] = ACTIONS(691),
    [anon_sym_convergent] = ACTIONS(689),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(689),
    [anon_sym_hot] = ACTIONS(689),
    [anon_sym_inaccessiblememonly] = ACTIONS(689),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(689),
    [anon_sym_inlinehint] = ACTIONS(689),
    [anon_sym_jumptable] = ACTIONS(689),
    [anon_sym_minsize] = ACTIONS(689),
    [anon_sym_naked] = ACTIONS(689),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(689),
    [anon_sym_nobuiltin] = ACTIONS(689),
    [anon_sym_noduplicate] = ACTIONS(689),
    [anon_sym_nofree] = ACTIONS(689),
    [anon_sym_noimplicitfloat] = ACTIONS(689),
    [anon_sym_noinline] = ACTIONS(689),
    [anon_sym_nomerge] = ACTIONS(689),
    [anon_sym_nonlazybind] = ACTIONS(689),
    [anon_sym_noprofile] = ACTIONS(689),
    [anon_sym_noredzone] = ACTIONS(689),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(689),
    [anon_sym_noreturn] = ACTIONS(689),
    [anon_sym_norecurse] = ACTIONS(689),
    [anon_sym_willreturn] = ACTIONS(689),
    [anon_sym_nosync] = ACTIONS(689),
    [anon_sym_nounwind] = ACTIONS(689),
    [anon_sym_nocallback] = ACTIONS(689),
    [anon_sym_nosanitize_coverage] = ACTIONS(689),
    [anon_sym_null_pointer_is_valid] = ACTIONS(689),
    [anon_sym_optforfuzzing] = ACTIONS(689),
    [anon_sym_optnone] = ACTIONS(689),
    [anon_sym_optsize] = ACTIONS(689),
    [anon_sym_readnone] = ACTIONS(689),
    [anon_sym_readonly] = ACTIONS(689),
    [anon_sym_writeonly] = ACTIONS(689),
    [anon_sym_argmemonly] = ACTIONS(689),
    [anon_sym_returns_twice] = ACTIONS(689),
    [anon_sym_safestack] = ACTIONS(689),
    [anon_sym_sanitize_address] = ACTIONS(689),
    [anon_sym_sanitize_memory] = ACTIONS(689),
    [anon_sym_sanitize_thread] = ACTIONS(689),
    [anon_sym_sanitize_hwaddress] = ACTIONS(689),
    [anon_sym_sanitize_memtag] = ACTIONS(689),
    [anon_sym_speculative_load_hardening] = ACTIONS(689),
    [anon_sym_speculatable] = ACTIONS(689),
    [anon_sym_ssp] = ACTIONS(691),
    [anon_sym_sspstrong] = ACTIONS(689),
    [anon_sym_sspreq] = ACTIONS(689),
    [anon_sym_strictfp] = ACTIONS(689),
    [anon_sym_nocf_check] = ACTIONS(689),
    [anon_sym_shadowcallstack] = ACTIONS(689),
    [anon_sym_mustprogress] = ACTIONS(689),
    [anon_sym_vscale_range] = ACTIONS(689),
    [anon_sym_preallocated] = ACTIONS(689),
    [anon_sym_zeroext] = ACTIONS(689),
    [anon_sym_signext] = ACTIONS(689),
    [anon_sym_inreg] = ACTIONS(689),
    [anon_sym_byval] = ACTIONS(689),
    [anon_sym_byref] = ACTIONS(689),
    [anon_sym_inalloca] = ACTIONS(689),
    [anon_sym_sret] = ACTIONS(689),
    [anon_sym_elementtype] = ACTIONS(689),
    [anon_sym_noalias] = ACTIONS(689),
    [anon_sym_nocapture] = ACTIONS(689),
    [anon_sym_nest] = ACTIONS(689),
    [anon_sym_returned] = ACTIONS(689),
    [anon_sym_nonnull] = ACTIONS(689),
    [anon_sym_dereferenceable] = ACTIONS(691),
    [anon_sym_dereferenceable_or_null] = ACTIONS(689),
    [anon_sym_swiftself] = ACTIONS(691),
    [anon_sym_swiftasync] = ACTIONS(691),
    [anon_sym_swifterror] = ACTIONS(691),
    [anon_sym_immarg] = ACTIONS(689),
    [anon_sym_noundef] = ACTIONS(689),
    [anon_sym_uwtable] = ACTIONS(689),
    [anon_sym_memory] = ACTIONS(689),
    [anon_sym_to] = ACTIONS(691),
    [anon_sym_unwind] = ACTIONS(689),
    [anon_sym_unordered] = ACTIONS(689),
    [anon_sym_monotonic] = ACTIONS(689),
    [anon_sym_acquire] = ACTIONS(689),
    [anon_sym_release] = ACTIONS(689),
    [anon_sym_acq_rel] = ACTIONS(689),
    [anon_sym_seq_cst] = ACTIONS(689),
    [anon_sym_syncscope] = ACTIONS(689),
    [anon_sym_uselistorder] = ACTIONS(691),
    [anon_sym_uselistorder_bb] = ACTIONS(689),
    [anon_sym_module] = ACTIONS(689),
    [anon_sym_attributes] = ACTIONS(689),
  },
  [131] = {
    [ts_builtin_sym_end] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(693),
    [sym_global_var] = ACTIONS(693),
    [sym_local_var] = ACTIONS(693),
    [aux_sym_metadata_ref_token1] = ACTIONS(693),
    [sym_summary_ref] = ACTIONS(693),
    [sym_string] = ACTIONS(693),
    [anon_sym_target] = ACTIONS(693),
    [anon_sym_source_filename] = ACTIONS(693),
    [anon_sym_declare] = ACTIONS(693),
    [anon_sym_define] = ACTIONS(693),
    [anon_sym_no_cfi] = ACTIONS(693),
    [anon_sym_private] = ACTIONS(693),
    [anon_sym_internal] = ACTIONS(693),
    [anon_sym_weak] = ACTIONS(695),
    [anon_sym_weak_odr] = ACTIONS(693),
    [anon_sym_linkonce] = ACTIONS(695),
    [anon_sym_linkonce_odr] = ACTIONS(693),
    [anon_sym_available_externally] = ACTIONS(693),
    [anon_sym_appending] = ACTIONS(693),
    [anon_sym_common] = ACTIONS(693),
    [anon_sym_extern_weak] = ACTIONS(693),
    [anon_sym_external] = ACTIONS(693),
    [anon_sym_dso_local] = ACTIONS(695),
    [anon_sym_dso_local_equivalent] = ACTIONS(693),
    [anon_sym_dso_preemptable] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_hidden] = ACTIONS(693),
    [anon_sym_protected] = ACTIONS(693),
    [anon_sym_dllimport] = ACTIONS(693),
    [anon_sym_dllexport] = ACTIONS(693),
    [anon_sym_ccc] = ACTIONS(693),
    [anon_sym_fastcc] = ACTIONS(693),
    [anon_sym_coldcc] = ACTIONS(693),
    [anon_sym_webkit_jscc] = ACTIONS(695),
    [anon_sym_anyregcc] = ACTIONS(693),
    [anon_sym_preserve_mostcc] = ACTIONS(693),
    [anon_sym_preserve_allcc] = ACTIONS(693),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(695),
    [anon_sym_tailcc] = ACTIONS(693),
    [anon_sym_swiftcc] = ACTIONS(695),
    [anon_sym_swifttailcc] = ACTIONS(695),
    [anon_sym_cfguard_checkcc] = ACTIONS(693),
    [aux_sym_calling_conv_token1] = ACTIONS(695),
    [aux_sym_calling_conv_token2] = ACTIONS(693),
    [aux_sym_calling_conv_token3] = ACTIONS(693),
    [aux_sym_calling_conv_token4] = ACTIONS(693),
    [aux_sym_calling_conv_token5] = ACTIONS(693),
    [aux_sym_calling_conv_token6] = ACTIONS(693),
    [aux_sym_calling_conv_token7] = ACTIONS(693),
    [aux_sym_calling_conv_token8] = ACTIONS(693),
    [aux_sym_calling_conv_token9] = ACTIONS(693),
    [aux_sym_calling_conv_token10] = ACTIONS(695),
    [anon_sym_ghccc] = ACTIONS(693),
    [aux_sym_calling_conv_token11] = ACTIONS(695),
    [aux_sym_calling_conv_token12] = ACTIONS(693),
    [aux_sym_calling_conv_token13] = ACTIONS(695),
    [aux_sym_calling_conv_token14] = ACTIONS(693),
    [anon_sym_cc] = ACTIONS(695),
    [anon_sym_unnamed_addr] = ACTIONS(693),
    [anon_sym_local_unnamed_addr] = ACTIONS(693),
    [anon_sym_void] = ACTIONS(693),
    [anon_sym_half] = ACTIONS(693),
    [anon_sym_bfloat] = ACTIONS(693),
    [anon_sym_float] = ACTIONS(693),
    [anon_sym_double] = ACTIONS(693),
    [anon_sym_x86_fp80] = ACTIONS(695),
    [anon_sym_fp128] = ACTIONS(693),
    [anon_sym_ppc_fp128] = ACTIONS(693),
    [anon_sym_label] = ACTIONS(693),
    [anon_sym_metadata] = ACTIONS(693),
    [anon_sym_x86_mmx] = ACTIONS(695),
    [anon_sym_x86_amx] = ACTIONS(695),
    [anon_sym_token] = ACTIONS(693),
    [anon_sym_opaque] = ACTIONS(693),
    [anon_sym_ptr] = ACTIONS(693),
    [aux_sym_type_keyword_token1] = ACTIONS(693),
    [anon_sym_LBRACE] = ACTIONS(693),
    [anon_sym_RBRACE] = ACTIONS(693),
    [anon_sym_LT_LBRACE] = ACTIONS(693),
    [anon_sym_LBRACK] = ACTIONS(693),
    [anon_sym_RBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(693),
    [anon_sym_COMMA] = ACTIONS(693),
    [anon_sym_RPAREN] = ACTIONS(693),
    [anon_sym_align] = ACTIONS(695),
    [anon_sym_alignstack] = ACTIONS(693),
    [anon_sym_allocsize] = ACTIONS(693),
    [anon_sym_alwaysinline] = ACTIONS(693),
    [anon_sym_builtin] = ACTIONS(693),
    [anon_sym_cold] = ACTIONS(695),
    [anon_sym_convergent] = ACTIONS(693),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(693),
    [anon_sym_hot] = ACTIONS(693),
    [anon_sym_inaccessiblememonly] = ACTIONS(693),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(693),
    [anon_sym_inlinehint] = ACTIONS(693),
    [anon_sym_jumptable] = ACTIONS(693),
    [anon_sym_minsize] = ACTIONS(693),
    [anon_sym_naked] = ACTIONS(693),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(693),
    [anon_sym_nobuiltin] = ACTIONS(693),
    [anon_sym_noduplicate] = ACTIONS(693),
    [anon_sym_nofree] = ACTIONS(693),
    [anon_sym_noimplicitfloat] = ACTIONS(693),
    [anon_sym_noinline] = ACTIONS(693),
    [anon_sym_nomerge] = ACTIONS(693),
    [anon_sym_nonlazybind] = ACTIONS(693),
    [anon_sym_noprofile] = ACTIONS(693),
    [anon_sym_noredzone] = ACTIONS(693),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(693),
    [anon_sym_noreturn] = ACTIONS(693),
    [anon_sym_norecurse] = ACTIONS(693),
    [anon_sym_willreturn] = ACTIONS(693),
    [anon_sym_nosync] = ACTIONS(693),
    [anon_sym_nounwind] = ACTIONS(693),
    [anon_sym_nocallback] = ACTIONS(693),
    [anon_sym_nosanitize_coverage] = ACTIONS(693),
    [anon_sym_null_pointer_is_valid] = ACTIONS(693),
    [anon_sym_optforfuzzing] = ACTIONS(693),
    [anon_sym_optnone] = ACTIONS(693),
    [anon_sym_optsize] = ACTIONS(693),
    [anon_sym_readnone] = ACTIONS(693),
    [anon_sym_readonly] = ACTIONS(693),
    [anon_sym_writeonly] = ACTIONS(693),
    [anon_sym_argmemonly] = ACTIONS(693),
    [anon_sym_returns_twice] = ACTIONS(693),
    [anon_sym_safestack] = ACTIONS(693),
    [anon_sym_sanitize_address] = ACTIONS(693),
    [anon_sym_sanitize_memory] = ACTIONS(693),
    [anon_sym_sanitize_thread] = ACTIONS(693),
    [anon_sym_sanitize_hwaddress] = ACTIONS(693),
    [anon_sym_sanitize_memtag] = ACTIONS(693),
    [anon_sym_speculative_load_hardening] = ACTIONS(693),
    [anon_sym_speculatable] = ACTIONS(693),
    [anon_sym_ssp] = ACTIONS(695),
    [anon_sym_sspstrong] = ACTIONS(693),
    [anon_sym_sspreq] = ACTIONS(693),
    [anon_sym_strictfp] = ACTIONS(693),
    [anon_sym_nocf_check] = ACTIONS(693),
    [anon_sym_shadowcallstack] = ACTIONS(693),
    [anon_sym_mustprogress] = ACTIONS(693),
    [anon_sym_vscale_range] = ACTIONS(693),
    [anon_sym_preallocated] = ACTIONS(693),
    [anon_sym_zeroext] = ACTIONS(693),
    [anon_sym_signext] = ACTIONS(693),
    [anon_sym_inreg] = ACTIONS(693),
    [anon_sym_byval] = ACTIONS(693),
    [anon_sym_byref] = ACTIONS(693),
    [anon_sym_inalloca] = ACTIONS(693),
    [anon_sym_sret] = ACTIONS(693),
    [anon_sym_elementtype] = ACTIONS(693),
    [anon_sym_noalias] = ACTIONS(693),
    [anon_sym_nocapture] = ACTIONS(693),
    [anon_sym_nest] = ACTIONS(693),
    [anon_sym_returned] = ACTIONS(693),
    [anon_sym_nonnull] = ACTIONS(693),
    [anon_sym_dereferenceable] = ACTIONS(695),
    [anon_sym_dereferenceable_or_null] = ACTIONS(693),
    [anon_sym_swiftself] = ACTIONS(695),
    [anon_sym_swiftasync] = ACTIONS(695),
    [anon_sym_swifterror] = ACTIONS(695),
    [anon_sym_immarg] = ACTIONS(693),
    [anon_sym_noundef] = ACTIONS(693),
    [anon_sym_uwtable] = ACTIONS(693),
    [anon_sym_memory] = ACTIONS(693),
    [anon_sym_to] = ACTIONS(695),
    [anon_sym_unwind] = ACTIONS(693),
    [anon_sym_unordered] = ACTIONS(693),
    [anon_sym_monotonic] = ACTIONS(693),
    [anon_sym_acquire] = ACTIONS(693),
    [anon_sym_release] = ACTIONS(693),
    [anon_sym_acq_rel] = ACTIONS(693),
    [anon_sym_seq_cst] = ACTIONS(693),
    [anon_sym_syncscope] = ACTIONS(693),
    [anon_sym_uselistorder] = ACTIONS(695),
    [anon_sym_uselistorder_bb] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(693),
    [anon_sym_attributes] = ACTIONS(693),
  },
  [132] = {
    [ts_builtin_sym_end] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(697),
    [sym_global_var] = ACTIONS(697),
    [sym_local_var] = ACTIONS(697),
    [aux_sym_metadata_ref_token1] = ACTIONS(697),
    [sym_summary_ref] = ACTIONS(697),
    [sym_string] = ACTIONS(697),
    [anon_sym_target] = ACTIONS(697),
    [anon_sym_source_filename] = ACTIONS(697),
    [anon_sym_declare] = ACTIONS(697),
    [anon_sym_define] = ACTIONS(697),
    [anon_sym_no_cfi] = ACTIONS(697),
    [anon_sym_private] = ACTIONS(697),
    [anon_sym_internal] = ACTIONS(697),
    [anon_sym_weak] = ACTIONS(699),
    [anon_sym_weak_odr] = ACTIONS(697),
    [anon_sym_linkonce] = ACTIONS(699),
    [anon_sym_linkonce_odr] = ACTIONS(697),
    [anon_sym_available_externally] = ACTIONS(697),
    [anon_sym_appending] = ACTIONS(697),
    [anon_sym_common] = ACTIONS(697),
    [anon_sym_extern_weak] = ACTIONS(697),
    [anon_sym_external] = ACTIONS(697),
    [anon_sym_dso_local] = ACTIONS(699),
    [anon_sym_dso_local_equivalent] = ACTIONS(697),
    [anon_sym_dso_preemptable] = ACTIONS(697),
    [anon_sym_default] = ACTIONS(697),
    [anon_sym_hidden] = ACTIONS(697),
    [anon_sym_protected] = ACTIONS(697),
    [anon_sym_dllimport] = ACTIONS(697),
    [anon_sym_dllexport] = ACTIONS(697),
    [anon_sym_ccc] = ACTIONS(697),
    [anon_sym_fastcc] = ACTIONS(697),
    [anon_sym_coldcc] = ACTIONS(697),
    [anon_sym_webkit_jscc] = ACTIONS(699),
    [anon_sym_anyregcc] = ACTIONS(697),
    [anon_sym_preserve_mostcc] = ACTIONS(697),
    [anon_sym_preserve_allcc] = ACTIONS(697),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(699),
    [anon_sym_tailcc] = ACTIONS(697),
    [anon_sym_swiftcc] = ACTIONS(699),
    [anon_sym_swifttailcc] = ACTIONS(699),
    [anon_sym_cfguard_checkcc] = ACTIONS(697),
    [aux_sym_calling_conv_token1] = ACTIONS(699),
    [aux_sym_calling_conv_token2] = ACTIONS(697),
    [aux_sym_calling_conv_token3] = ACTIONS(697),
    [aux_sym_calling_conv_token4] = ACTIONS(697),
    [aux_sym_calling_conv_token5] = ACTIONS(697),
    [aux_sym_calling_conv_token6] = ACTIONS(697),
    [aux_sym_calling_conv_token7] = ACTIONS(697),
    [aux_sym_calling_conv_token8] = ACTIONS(697),
    [aux_sym_calling_conv_token9] = ACTIONS(697),
    [aux_sym_calling_conv_token10] = ACTIONS(699),
    [anon_sym_ghccc] = ACTIONS(697),
    [aux_sym_calling_conv_token11] = ACTIONS(699),
    [aux_sym_calling_conv_token12] = ACTIONS(697),
    [aux_sym_calling_conv_token13] = ACTIONS(699),
    [aux_sym_calling_conv_token14] = ACTIONS(697),
    [anon_sym_cc] = ACTIONS(699),
    [anon_sym_unnamed_addr] = ACTIONS(697),
    [anon_sym_local_unnamed_addr] = ACTIONS(697),
    [anon_sym_void] = ACTIONS(697),
    [anon_sym_half] = ACTIONS(697),
    [anon_sym_bfloat] = ACTIONS(697),
    [anon_sym_float] = ACTIONS(697),
    [anon_sym_double] = ACTIONS(697),
    [anon_sym_x86_fp80] = ACTIONS(699),
    [anon_sym_fp128] = ACTIONS(697),
    [anon_sym_ppc_fp128] = ACTIONS(697),
    [anon_sym_label] = ACTIONS(697),
    [anon_sym_metadata] = ACTIONS(697),
    [anon_sym_x86_mmx] = ACTIONS(699),
    [anon_sym_x86_amx] = ACTIONS(699),
    [anon_sym_token] = ACTIONS(697),
    [anon_sym_opaque] = ACTIONS(697),
    [anon_sym_ptr] = ACTIONS(697),
    [aux_sym_type_keyword_token1] = ACTIONS(697),
    [anon_sym_LBRACE] = ACTIONS(697),
    [anon_sym_RBRACE] = ACTIONS(697),
    [anon_sym_LT_LBRACE] = ACTIONS(697),
    [anon_sym_LBRACK] = ACTIONS(697),
    [anon_sym_RBRACK] = ACTIONS(697),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_GT] = ACTIONS(697),
    [anon_sym_COMMA] = ACTIONS(697),
    [anon_sym_RPAREN] = ACTIONS(697),
    [anon_sym_align] = ACTIONS(699),
    [anon_sym_alignstack] = ACTIONS(697),
    [anon_sym_allocsize] = ACTIONS(697),
    [anon_sym_alwaysinline] = ACTIONS(697),
    [anon_sym_builtin] = ACTIONS(697),
    [anon_sym_cold] = ACTIONS(699),
    [anon_sym_convergent] = ACTIONS(697),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(697),
    [anon_sym_hot] = ACTIONS(697),
    [anon_sym_inaccessiblememonly] = ACTIONS(697),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(697),
    [anon_sym_inlinehint] = ACTIONS(697),
    [anon_sym_jumptable] = ACTIONS(697),
    [anon_sym_minsize] = ACTIONS(697),
    [anon_sym_naked] = ACTIONS(697),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(697),
    [anon_sym_nobuiltin] = ACTIONS(697),
    [anon_sym_noduplicate] = ACTIONS(697),
    [anon_sym_nofree] = ACTIONS(697),
    [anon_sym_noimplicitfloat] = ACTIONS(697),
    [anon_sym_noinline] = ACTIONS(697),
    [anon_sym_nomerge] = ACTIONS(697),
    [anon_sym_nonlazybind] = ACTIONS(697),
    [anon_sym_noprofile] = ACTIONS(697),
    [anon_sym_noredzone] = ACTIONS(697),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(697),
    [anon_sym_noreturn] = ACTIONS(697),
    [anon_sym_norecurse] = ACTIONS(697),
    [anon_sym_willreturn] = ACTIONS(697),
    [anon_sym_nosync] = ACTIONS(697),
    [anon_sym_nounwind] = ACTIONS(697),
    [anon_sym_nocallback] = ACTIONS(697),
    [anon_sym_nosanitize_coverage] = ACTIONS(697),
    [anon_sym_null_pointer_is_valid] = ACTIONS(697),
    [anon_sym_optforfuzzing] = ACTIONS(697),
    [anon_sym_optnone] = ACTIONS(697),
    [anon_sym_optsize] = ACTIONS(697),
    [anon_sym_readnone] = ACTIONS(697),
    [anon_sym_readonly] = ACTIONS(697),
    [anon_sym_writeonly] = ACTIONS(697),
    [anon_sym_argmemonly] = ACTIONS(697),
    [anon_sym_returns_twice] = ACTIONS(697),
    [anon_sym_safestack] = ACTIONS(697),
    [anon_sym_sanitize_address] = ACTIONS(697),
    [anon_sym_sanitize_memory] = ACTIONS(697),
    [anon_sym_sanitize_thread] = ACTIONS(697),
    [anon_sym_sanitize_hwaddress] = ACTIONS(697),
    [anon_sym_sanitize_memtag] = ACTIONS(697),
    [anon_sym_speculative_load_hardening] = ACTIONS(697),
    [anon_sym_speculatable] = ACTIONS(697),
    [anon_sym_ssp] = ACTIONS(699),
    [anon_sym_sspstrong] = ACTIONS(697),
    [anon_sym_sspreq] = ACTIONS(697),
    [anon_sym_strictfp] = ACTIONS(697),
    [anon_sym_nocf_check] = ACTIONS(697),
    [anon_sym_shadowcallstack] = ACTIONS(697),
    [anon_sym_mustprogress] = ACTIONS(697),
    [anon_sym_vscale_range] = ACTIONS(697),
    [anon_sym_preallocated] = ACTIONS(697),
    [anon_sym_zeroext] = ACTIONS(697),
    [anon_sym_signext] = ACTIONS(697),
    [anon_sym_inreg] = ACTIONS(697),
    [anon_sym_byval] = ACTIONS(697),
    [anon_sym_byref] = ACTIONS(697),
    [anon_sym_inalloca] = ACTIONS(697),
    [anon_sym_sret] = ACTIONS(697),
    [anon_sym_elementtype] = ACTIONS(697),
    [anon_sym_noalias] = ACTIONS(697),
    [anon_sym_nocapture] = ACTIONS(697),
    [anon_sym_nest] = ACTIONS(697),
    [anon_sym_returned] = ACTIONS(697),
    [anon_sym_nonnull] = ACTIONS(697),
    [anon_sym_dereferenceable] = ACTIONS(699),
    [anon_sym_dereferenceable_or_null] = ACTIONS(697),
    [anon_sym_swiftself] = ACTIONS(699),
    [anon_sym_swiftasync] = ACTIONS(699),
    [anon_sym_swifterror] = ACTIONS(699),
    [anon_sym_immarg] = ACTIONS(697),
    [anon_sym_noundef] = ACTIONS(697),
    [anon_sym_uwtable] = ACTIONS(697),
    [anon_sym_memory] = ACTIONS(697),
    [anon_sym_to] = ACTIONS(699),
    [anon_sym_unwind] = ACTIONS(697),
    [anon_sym_unordered] = ACTIONS(697),
    [anon_sym_monotonic] = ACTIONS(697),
    [anon_sym_acquire] = ACTIONS(697),
    [anon_sym_release] = ACTIONS(697),
    [anon_sym_acq_rel] = ACTIONS(697),
    [anon_sym_seq_cst] = ACTIONS(697),
    [anon_sym_syncscope] = ACTIONS(697),
    [anon_sym_uselistorder] = ACTIONS(699),
    [anon_sym_uselistorder_bb] = ACTIONS(697),
    [anon_sym_module] = ACTIONS(697),
    [anon_sym_attributes] = ACTIONS(697),
  },
  [133] = {
    [ts_builtin_sym_end] = ACTIONS(701),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(701),
    [sym_global_var] = ACTIONS(701),
    [sym_local_var] = ACTIONS(701),
    [aux_sym_metadata_ref_token1] = ACTIONS(701),
    [sym_summary_ref] = ACTIONS(701),
    [sym_string] = ACTIONS(701),
    [anon_sym_target] = ACTIONS(701),
    [anon_sym_source_filename] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_define] = ACTIONS(701),
    [anon_sym_no_cfi] = ACTIONS(701),
    [anon_sym_private] = ACTIONS(701),
    [anon_sym_internal] = ACTIONS(701),
    [anon_sym_weak] = ACTIONS(703),
    [anon_sym_weak_odr] = ACTIONS(701),
    [anon_sym_linkonce] = ACTIONS(703),
    [anon_sym_linkonce_odr] = ACTIONS(701),
    [anon_sym_available_externally] = ACTIONS(701),
    [anon_sym_appending] = ACTIONS(701),
    [anon_sym_common] = ACTIONS(701),
    [anon_sym_extern_weak] = ACTIONS(701),
    [anon_sym_external] = ACTIONS(701),
    [anon_sym_dso_local] = ACTIONS(703),
    [anon_sym_dso_local_equivalent] = ACTIONS(701),
    [anon_sym_dso_preemptable] = ACTIONS(701),
    [anon_sym_default] = ACTIONS(701),
    [anon_sym_hidden] = ACTIONS(701),
    [anon_sym_protected] = ACTIONS(701),
    [anon_sym_dllimport] = ACTIONS(701),
    [anon_sym_dllexport] = ACTIONS(701),
    [anon_sym_ccc] = ACTIONS(701),
    [anon_sym_fastcc] = ACTIONS(701),
    [anon_sym_coldcc] = ACTIONS(701),
    [anon_sym_webkit_jscc] = ACTIONS(703),
    [anon_sym_anyregcc] = ACTIONS(701),
    [anon_sym_preserve_mostcc] = ACTIONS(701),
    [anon_sym_preserve_allcc] = ACTIONS(701),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(703),
    [anon_sym_tailcc] = ACTIONS(701),
    [anon_sym_swiftcc] = ACTIONS(703),
    [anon_sym_swifttailcc] = ACTIONS(703),
    [anon_sym_cfguard_checkcc] = ACTIONS(701),
    [aux_sym_calling_conv_token1] = ACTIONS(703),
    [aux_sym_calling_conv_token2] = ACTIONS(701),
    [aux_sym_calling_conv_token3] = ACTIONS(701),
    [aux_sym_calling_conv_token4] = ACTIONS(701),
    [aux_sym_calling_conv_token5] = ACTIONS(701),
    [aux_sym_calling_conv_token6] = ACTIONS(701),
    [aux_sym_calling_conv_token7] = ACTIONS(701),
    [aux_sym_calling_conv_token8] = ACTIONS(701),
    [aux_sym_calling_conv_token9] = ACTIONS(701),
    [aux_sym_calling_conv_token10] = ACTIONS(703),
    [anon_sym_ghccc] = ACTIONS(701),
    [aux_sym_calling_conv_token11] = ACTIONS(703),
    [aux_sym_calling_conv_token12] = ACTIONS(701),
    [aux_sym_calling_conv_token13] = ACTIONS(703),
    [aux_sym_calling_conv_token14] = ACTIONS(701),
    [anon_sym_cc] = ACTIONS(703),
    [anon_sym_unnamed_addr] = ACTIONS(701),
    [anon_sym_local_unnamed_addr] = ACTIONS(701),
    [anon_sym_void] = ACTIONS(701),
    [anon_sym_half] = ACTIONS(701),
    [anon_sym_bfloat] = ACTIONS(701),
    [anon_sym_float] = ACTIONS(701),
    [anon_sym_double] = ACTIONS(701),
    [anon_sym_x86_fp80] = ACTIONS(703),
    [anon_sym_fp128] = ACTIONS(701),
    [anon_sym_ppc_fp128] = ACTIONS(701),
    [anon_sym_label] = ACTIONS(701),
    [anon_sym_metadata] = ACTIONS(701),
    [anon_sym_x86_mmx] = ACTIONS(703),
    [anon_sym_x86_amx] = ACTIONS(703),
    [anon_sym_token] = ACTIONS(701),
    [anon_sym_opaque] = ACTIONS(701),
    [anon_sym_ptr] = ACTIONS(701),
    [aux_sym_type_keyword_token1] = ACTIONS(701),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_RBRACE] = ACTIONS(701),
    [anon_sym_LT_LBRACE] = ACTIONS(701),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_RBRACK] = ACTIONS(701),
    [anon_sym_LT] = ACTIONS(703),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_COMMA] = ACTIONS(701),
    [anon_sym_RPAREN] = ACTIONS(701),
    [anon_sym_align] = ACTIONS(703),
    [anon_sym_alignstack] = ACTIONS(701),
    [anon_sym_allocsize] = ACTIONS(701),
    [anon_sym_alwaysinline] = ACTIONS(701),
    [anon_sym_builtin] = ACTIONS(701),
    [anon_sym_cold] = ACTIONS(703),
    [anon_sym_convergent] = ACTIONS(701),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(701),
    [anon_sym_hot] = ACTIONS(701),
    [anon_sym_inaccessiblememonly] = ACTIONS(701),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(701),
    [anon_sym_inlinehint] = ACTIONS(701),
    [anon_sym_jumptable] = ACTIONS(701),
    [anon_sym_minsize] = ACTIONS(701),
    [anon_sym_naked] = ACTIONS(701),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(701),
    [anon_sym_nobuiltin] = ACTIONS(701),
    [anon_sym_noduplicate] = ACTIONS(701),
    [anon_sym_nofree] = ACTIONS(701),
    [anon_sym_noimplicitfloat] = ACTIONS(701),
    [anon_sym_noinline] = ACTIONS(701),
    [anon_sym_nomerge] = ACTIONS(701),
    [anon_sym_nonlazybind] = ACTIONS(701),
    [anon_sym_noprofile] = ACTIONS(701),
    [anon_sym_noredzone] = ACTIONS(701),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(701),
    [anon_sym_noreturn] = ACTIONS(701),
    [anon_sym_norecurse] = ACTIONS(701),
    [anon_sym_willreturn] = ACTIONS(701),
    [anon_sym_nosync] = ACTIONS(701),
    [anon_sym_nounwind] = ACTIONS(701),
    [anon_sym_nocallback] = ACTIONS(701),
    [anon_sym_nosanitize_coverage] = ACTIONS(701),
    [anon_sym_null_pointer_is_valid] = ACTIONS(701),
    [anon_sym_optforfuzzing] = ACTIONS(701),
    [anon_sym_optnone] = ACTIONS(701),
    [anon_sym_optsize] = ACTIONS(701),
    [anon_sym_readnone] = ACTIONS(701),
    [anon_sym_readonly] = ACTIONS(701),
    [anon_sym_writeonly] = ACTIONS(701),
    [anon_sym_argmemonly] = ACTIONS(701),
    [anon_sym_returns_twice] = ACTIONS(701),
    [anon_sym_safestack] = ACTIONS(701),
    [anon_sym_sanitize_address] = ACTIONS(701),
    [anon_sym_sanitize_memory] = ACTIONS(701),
    [anon_sym_sanitize_thread] = ACTIONS(701),
    [anon_sym_sanitize_hwaddress] = ACTIONS(701),
    [anon_sym_sanitize_memtag] = ACTIONS(701),
    [anon_sym_speculative_load_hardening] = ACTIONS(701),
    [anon_sym_speculatable] = ACTIONS(701),
    [anon_sym_ssp] = ACTIONS(703),
    [anon_sym_sspstrong] = ACTIONS(701),
    [anon_sym_sspreq] = ACTIONS(701),
    [anon_sym_strictfp] = ACTIONS(701),
    [anon_sym_nocf_check] = ACTIONS(701),
    [anon_sym_shadowcallstack] = ACTIONS(701),
    [anon_sym_mustprogress] = ACTIONS(701),
    [anon_sym_vscale_range] = ACTIONS(701),
    [anon_sym_preallocated] = ACTIONS(701),
    [anon_sym_zeroext] = ACTIONS(701),
    [anon_sym_signext] = ACTIONS(701),
    [anon_sym_inreg] = ACTIONS(701),
    [anon_sym_byval] = ACTIONS(701),
    [anon_sym_byref] = ACTIONS(701),
    [anon_sym_inalloca] = ACTIONS(701),
    [anon_sym_sret] = ACTIONS(701),
    [anon_sym_elementtype] = ACTIONS(701),
    [anon_sym_noalias] = ACTIONS(701),
    [anon_sym_nocapture] = ACTIONS(701),
    [anon_sym_nest] = ACTIONS(701),
    [anon_sym_returned] = ACTIONS(701),
    [anon_sym_nonnull] = ACTIONS(701),
    [anon_sym_dereferenceable] = ACTIONS(703),
    [anon_sym_dereferenceable_or_null] = ACTIONS(701),
    [anon_sym_swiftself] = ACTIONS(703),
    [anon_sym_swiftasync] = ACTIONS(703),
    [anon_sym_swifterror] = ACTIONS(703),
    [anon_sym_immarg] = ACTIONS(701),
    [anon_sym_noundef] = ACTIONS(701),
    [anon_sym_uwtable] = ACTIONS(701),
    [anon_sym_memory] = ACTIONS(701),
    [anon_sym_to] = ACTIONS(703),
    [anon_sym_unwind] = ACTIONS(701),
    [anon_sym_unordered] = ACTIONS(701),
    [anon_sym_monotonic] = ACTIONS(701),
    [anon_sym_acquire] = ACTIONS(701),
    [anon_sym_release] = ACTIONS(701),
    [anon_sym_acq_rel] = ACTIONS(701),
    [anon_sym_seq_cst] = ACTIONS(701),
    [anon_sym_syncscope] = ACTIONS(701),
    [anon_sym_uselistorder] = ACTIONS(703),
    [anon_sym_uselistorder_bb] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_attributes] = ACTIONS(701),
  },
  [134] = {
    [ts_builtin_sym_end] = ACTIONS(705),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(705),
    [sym_global_var] = ACTIONS(705),
    [sym_local_var] = ACTIONS(705),
    [aux_sym_metadata_ref_token1] = ACTIONS(705),
    [sym_summary_ref] = ACTIONS(705),
    [sym_string] = ACTIONS(705),
    [anon_sym_target] = ACTIONS(705),
    [anon_sym_source_filename] = ACTIONS(705),
    [anon_sym_declare] = ACTIONS(705),
    [anon_sym_define] = ACTIONS(705),
    [anon_sym_no_cfi] = ACTIONS(705),
    [anon_sym_private] = ACTIONS(705),
    [anon_sym_internal] = ACTIONS(705),
    [anon_sym_weak] = ACTIONS(707),
    [anon_sym_weak_odr] = ACTIONS(705),
    [anon_sym_linkonce] = ACTIONS(707),
    [anon_sym_linkonce_odr] = ACTIONS(705),
    [anon_sym_available_externally] = ACTIONS(705),
    [anon_sym_appending] = ACTIONS(705),
    [anon_sym_common] = ACTIONS(705),
    [anon_sym_extern_weak] = ACTIONS(705),
    [anon_sym_external] = ACTIONS(705),
    [anon_sym_dso_local] = ACTIONS(707),
    [anon_sym_dso_local_equivalent] = ACTIONS(705),
    [anon_sym_dso_preemptable] = ACTIONS(705),
    [anon_sym_default] = ACTIONS(705),
    [anon_sym_hidden] = ACTIONS(705),
    [anon_sym_protected] = ACTIONS(705),
    [anon_sym_dllimport] = ACTIONS(705),
    [anon_sym_dllexport] = ACTIONS(705),
    [anon_sym_ccc] = ACTIONS(705),
    [anon_sym_fastcc] = ACTIONS(705),
    [anon_sym_coldcc] = ACTIONS(705),
    [anon_sym_webkit_jscc] = ACTIONS(707),
    [anon_sym_anyregcc] = ACTIONS(705),
    [anon_sym_preserve_mostcc] = ACTIONS(705),
    [anon_sym_preserve_allcc] = ACTIONS(705),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(707),
    [anon_sym_tailcc] = ACTIONS(705),
    [anon_sym_swiftcc] = ACTIONS(707),
    [anon_sym_swifttailcc] = ACTIONS(707),
    [anon_sym_cfguard_checkcc] = ACTIONS(705),
    [aux_sym_calling_conv_token1] = ACTIONS(707),
    [aux_sym_calling_conv_token2] = ACTIONS(705),
    [aux_sym_calling_conv_token3] = ACTIONS(705),
    [aux_sym_calling_conv_token4] = ACTIONS(705),
    [aux_sym_calling_conv_token5] = ACTIONS(705),
    [aux_sym_calling_conv_token6] = ACTIONS(705),
    [aux_sym_calling_conv_token7] = ACTIONS(705),
    [aux_sym_calling_conv_token8] = ACTIONS(705),
    [aux_sym_calling_conv_token9] = ACTIONS(705),
    [aux_sym_calling_conv_token10] = ACTIONS(707),
    [anon_sym_ghccc] = ACTIONS(705),
    [aux_sym_calling_conv_token11] = ACTIONS(707),
    [aux_sym_calling_conv_token12] = ACTIONS(705),
    [aux_sym_calling_conv_token13] = ACTIONS(707),
    [aux_sym_calling_conv_token14] = ACTIONS(705),
    [anon_sym_cc] = ACTIONS(707),
    [anon_sym_unnamed_addr] = ACTIONS(705),
    [anon_sym_local_unnamed_addr] = ACTIONS(705),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_half] = ACTIONS(705),
    [anon_sym_bfloat] = ACTIONS(705),
    [anon_sym_float] = ACTIONS(705),
    [anon_sym_double] = ACTIONS(705),
    [anon_sym_x86_fp80] = ACTIONS(707),
    [anon_sym_fp128] = ACTIONS(705),
    [anon_sym_ppc_fp128] = ACTIONS(705),
    [anon_sym_label] = ACTIONS(705),
    [anon_sym_metadata] = ACTIONS(705),
    [anon_sym_x86_mmx] = ACTIONS(707),
    [anon_sym_x86_amx] = ACTIONS(707),
    [anon_sym_token] = ACTIONS(705),
    [anon_sym_opaque] = ACTIONS(705),
    [anon_sym_ptr] = ACTIONS(705),
    [aux_sym_type_keyword_token1] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(705),
    [anon_sym_RBRACE] = ACTIONS(705),
    [anon_sym_LT_LBRACE] = ACTIONS(705),
    [anon_sym_LBRACK] = ACTIONS(705),
    [anon_sym_RBRACK] = ACTIONS(705),
    [anon_sym_LT] = ACTIONS(707),
    [anon_sym_GT] = ACTIONS(705),
    [anon_sym_COMMA] = ACTIONS(705),
    [anon_sym_RPAREN] = ACTIONS(705),
    [anon_sym_align] = ACTIONS(707),
    [anon_sym_alignstack] = ACTIONS(705),
    [anon_sym_allocsize] = ACTIONS(705),
    [anon_sym_alwaysinline] = ACTIONS(705),
    [anon_sym_builtin] = ACTIONS(705),
    [anon_sym_cold] = ACTIONS(707),
    [anon_sym_convergent] = ACTIONS(705),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(705),
    [anon_sym_hot] = ACTIONS(705),
    [anon_sym_inaccessiblememonly] = ACTIONS(705),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(705),
    [anon_sym_inlinehint] = ACTIONS(705),
    [anon_sym_jumptable] = ACTIONS(705),
    [anon_sym_minsize] = ACTIONS(705),
    [anon_sym_naked] = ACTIONS(705),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(705),
    [anon_sym_nobuiltin] = ACTIONS(705),
    [anon_sym_noduplicate] = ACTIONS(705),
    [anon_sym_nofree] = ACTIONS(705),
    [anon_sym_noimplicitfloat] = ACTIONS(705),
    [anon_sym_noinline] = ACTIONS(705),
    [anon_sym_nomerge] = ACTIONS(705),
    [anon_sym_nonlazybind] = ACTIONS(705),
    [anon_sym_noprofile] = ACTIONS(705),
    [anon_sym_noredzone] = ACTIONS(705),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(705),
    [anon_sym_noreturn] = ACTIONS(705),
    [anon_sym_norecurse] = ACTIONS(705),
    [anon_sym_willreturn] = ACTIONS(705),
    [anon_sym_nosync] = ACTIONS(705),
    [anon_sym_nounwind] = ACTIONS(705),
    [anon_sym_nocallback] = ACTIONS(705),
    [anon_sym_nosanitize_coverage] = ACTIONS(705),
    [anon_sym_null_pointer_is_valid] = ACTIONS(705),
    [anon_sym_optforfuzzing] = ACTIONS(705),
    [anon_sym_optnone] = ACTIONS(705),
    [anon_sym_optsize] = ACTIONS(705),
    [anon_sym_readnone] = ACTIONS(705),
    [anon_sym_readonly] = ACTIONS(705),
    [anon_sym_writeonly] = ACTIONS(705),
    [anon_sym_argmemonly] = ACTIONS(705),
    [anon_sym_returns_twice] = ACTIONS(705),
    [anon_sym_safestack] = ACTIONS(705),
    [anon_sym_sanitize_address] = ACTIONS(705),
    [anon_sym_sanitize_memory] = ACTIONS(705),
    [anon_sym_sanitize_thread] = ACTIONS(705),
    [anon_sym_sanitize_hwaddress] = ACTIONS(705),
    [anon_sym_sanitize_memtag] = ACTIONS(705),
    [anon_sym_speculative_load_hardening] = ACTIONS(705),
    [anon_sym_speculatable] = ACTIONS(705),
    [anon_sym_ssp] = ACTIONS(707),
    [anon_sym_sspstrong] = ACTIONS(705),
    [anon_sym_sspreq] = ACTIONS(705),
    [anon_sym_strictfp] = ACTIONS(705),
    [anon_sym_nocf_check] = ACTIONS(705),
    [anon_sym_shadowcallstack] = ACTIONS(705),
    [anon_sym_mustprogress] = ACTIONS(705),
    [anon_sym_vscale_range] = ACTIONS(705),
    [anon_sym_preallocated] = ACTIONS(705),
    [anon_sym_zeroext] = ACTIONS(705),
    [anon_sym_signext] = ACTIONS(705),
    [anon_sym_inreg] = ACTIONS(705),
    [anon_sym_byval] = ACTIONS(705),
    [anon_sym_byref] = ACTIONS(705),
    [anon_sym_inalloca] = ACTIONS(705),
    [anon_sym_sret] = ACTIONS(705),
    [anon_sym_elementtype] = ACTIONS(705),
    [anon_sym_noalias] = ACTIONS(705),
    [anon_sym_nocapture] = ACTIONS(705),
    [anon_sym_nest] = ACTIONS(705),
    [anon_sym_returned] = ACTIONS(705),
    [anon_sym_nonnull] = ACTIONS(705),
    [anon_sym_dereferenceable] = ACTIONS(707),
    [anon_sym_dereferenceable_or_null] = ACTIONS(705),
    [anon_sym_swiftself] = ACTIONS(707),
    [anon_sym_swiftasync] = ACTIONS(707),
    [anon_sym_swifterror] = ACTIONS(707),
    [anon_sym_immarg] = ACTIONS(705),
    [anon_sym_noundef] = ACTIONS(705),
    [anon_sym_uwtable] = ACTIONS(705),
    [anon_sym_memory] = ACTIONS(705),
    [anon_sym_to] = ACTIONS(707),
    [anon_sym_unwind] = ACTIONS(705),
    [anon_sym_unordered] = ACTIONS(705),
    [anon_sym_monotonic] = ACTIONS(705),
    [anon_sym_acquire] = ACTIONS(705),
    [anon_sym_release] = ACTIONS(705),
    [anon_sym_acq_rel] = ACTIONS(705),
    [anon_sym_seq_cst] = ACTIONS(705),
    [anon_sym_syncscope] = ACTIONS(705),
    [anon_sym_uselistorder] = ACTIONS(707),
    [anon_sym_uselistorder_bb] = ACTIONS(705),
    [anon_sym_module] = ACTIONS(705),
    [anon_sym_attributes] = ACTIONS(705),
  },
  [135] = {
    [ts_builtin_sym_end] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(709),
    [sym_global_var] = ACTIONS(709),
    [sym_local_var] = ACTIONS(709),
    [aux_sym_metadata_ref_token1] = ACTIONS(709),
    [sym_summary_ref] = ACTIONS(709),
    [sym_string] = ACTIONS(709),
    [anon_sym_target] = ACTIONS(709),
    [anon_sym_source_filename] = ACTIONS(709),
    [anon_sym_declare] = ACTIONS(709),
    [anon_sym_define] = ACTIONS(709),
    [anon_sym_no_cfi] = ACTIONS(709),
    [anon_sym_private] = ACTIONS(709),
    [anon_sym_internal] = ACTIONS(709),
    [anon_sym_weak] = ACTIONS(711),
    [anon_sym_weak_odr] = ACTIONS(709),
    [anon_sym_linkonce] = ACTIONS(711),
    [anon_sym_linkonce_odr] = ACTIONS(709),
    [anon_sym_available_externally] = ACTIONS(709),
    [anon_sym_appending] = ACTIONS(709),
    [anon_sym_common] = ACTIONS(709),
    [anon_sym_extern_weak] = ACTIONS(709),
    [anon_sym_external] = ACTIONS(709),
    [anon_sym_dso_local] = ACTIONS(711),
    [anon_sym_dso_local_equivalent] = ACTIONS(709),
    [anon_sym_dso_preemptable] = ACTIONS(709),
    [anon_sym_default] = ACTIONS(709),
    [anon_sym_hidden] = ACTIONS(709),
    [anon_sym_protected] = ACTIONS(709),
    [anon_sym_dllimport] = ACTIONS(709),
    [anon_sym_dllexport] = ACTIONS(709),
    [anon_sym_ccc] = ACTIONS(709),
    [anon_sym_fastcc] = ACTIONS(709),
    [anon_sym_coldcc] = ACTIONS(709),
    [anon_sym_webkit_jscc] = ACTIONS(711),
    [anon_sym_anyregcc] = ACTIONS(709),
    [anon_sym_preserve_mostcc] = ACTIONS(709),
    [anon_sym_preserve_allcc] = ACTIONS(709),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(711),
    [anon_sym_tailcc] = ACTIONS(709),
    [anon_sym_swiftcc] = ACTIONS(711),
    [anon_sym_swifttailcc] = ACTIONS(711),
    [anon_sym_cfguard_checkcc] = ACTIONS(709),
    [aux_sym_calling_conv_token1] = ACTIONS(711),
    [aux_sym_calling_conv_token2] = ACTIONS(709),
    [aux_sym_calling_conv_token3] = ACTIONS(709),
    [aux_sym_calling_conv_token4] = ACTIONS(709),
    [aux_sym_calling_conv_token5] = ACTIONS(709),
    [aux_sym_calling_conv_token6] = ACTIONS(709),
    [aux_sym_calling_conv_token7] = ACTIONS(709),
    [aux_sym_calling_conv_token8] = ACTIONS(709),
    [aux_sym_calling_conv_token9] = ACTIONS(709),
    [aux_sym_calling_conv_token10] = ACTIONS(711),
    [anon_sym_ghccc] = ACTIONS(709),
    [aux_sym_calling_conv_token11] = ACTIONS(711),
    [aux_sym_calling_conv_token12] = ACTIONS(709),
    [aux_sym_calling_conv_token13] = ACTIONS(711),
    [aux_sym_calling_conv_token14] = ACTIONS(709),
    [anon_sym_cc] = ACTIONS(711),
    [anon_sym_unnamed_addr] = ACTIONS(709),
    [anon_sym_local_unnamed_addr] = ACTIONS(709),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_half] = ACTIONS(709),
    [anon_sym_bfloat] = ACTIONS(709),
    [anon_sym_float] = ACTIONS(709),
    [anon_sym_double] = ACTIONS(709),
    [anon_sym_x86_fp80] = ACTIONS(711),
    [anon_sym_fp128] = ACTIONS(709),
    [anon_sym_ppc_fp128] = ACTIONS(709),
    [anon_sym_label] = ACTIONS(709),
    [anon_sym_metadata] = ACTIONS(709),
    [anon_sym_x86_mmx] = ACTIONS(711),
    [anon_sym_x86_amx] = ACTIONS(711),
    [anon_sym_token] = ACTIONS(709),
    [anon_sym_opaque] = ACTIONS(709),
    [anon_sym_ptr] = ACTIONS(709),
    [aux_sym_type_keyword_token1] = ACTIONS(709),
    [anon_sym_LBRACE] = ACTIONS(709),
    [anon_sym_RBRACE] = ACTIONS(709),
    [anon_sym_LT_LBRACE] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(709),
    [anon_sym_RBRACK] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_GT] = ACTIONS(709),
    [anon_sym_COMMA] = ACTIONS(709),
    [anon_sym_RPAREN] = ACTIONS(709),
    [anon_sym_align] = ACTIONS(711),
    [anon_sym_alignstack] = ACTIONS(709),
    [anon_sym_allocsize] = ACTIONS(709),
    [anon_sym_alwaysinline] = ACTIONS(709),
    [anon_sym_builtin] = ACTIONS(709),
    [anon_sym_cold] = ACTIONS(711),
    [anon_sym_convergent] = ACTIONS(709),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(709),
    [anon_sym_hot] = ACTIONS(709),
    [anon_sym_inaccessiblememonly] = ACTIONS(709),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(709),
    [anon_sym_inlinehint] = ACTIONS(709),
    [anon_sym_jumptable] = ACTIONS(709),
    [anon_sym_minsize] = ACTIONS(709),
    [anon_sym_naked] = ACTIONS(709),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(709),
    [anon_sym_nobuiltin] = ACTIONS(709),
    [anon_sym_noduplicate] = ACTIONS(709),
    [anon_sym_nofree] = ACTIONS(709),
    [anon_sym_noimplicitfloat] = ACTIONS(709),
    [anon_sym_noinline] = ACTIONS(709),
    [anon_sym_nomerge] = ACTIONS(709),
    [anon_sym_nonlazybind] = ACTIONS(709),
    [anon_sym_noprofile] = ACTIONS(709),
    [anon_sym_noredzone] = ACTIONS(709),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(709),
    [anon_sym_noreturn] = ACTIONS(709),
    [anon_sym_norecurse] = ACTIONS(709),
    [anon_sym_willreturn] = ACTIONS(709),
    [anon_sym_nosync] = ACTIONS(709),
    [anon_sym_nounwind] = ACTIONS(709),
    [anon_sym_nocallback] = ACTIONS(709),
    [anon_sym_nosanitize_coverage] = ACTIONS(709),
    [anon_sym_null_pointer_is_valid] = ACTIONS(709),
    [anon_sym_optforfuzzing] = ACTIONS(709),
    [anon_sym_optnone] = ACTIONS(709),
    [anon_sym_optsize] = ACTIONS(709),
    [anon_sym_readnone] = ACTIONS(709),
    [anon_sym_readonly] = ACTIONS(709),
    [anon_sym_writeonly] = ACTIONS(709),
    [anon_sym_argmemonly] = ACTIONS(709),
    [anon_sym_returns_twice] = ACTIONS(709),
    [anon_sym_safestack] = ACTIONS(709),
    [anon_sym_sanitize_address] = ACTIONS(709),
    [anon_sym_sanitize_memory] = ACTIONS(709),
    [anon_sym_sanitize_thread] = ACTIONS(709),
    [anon_sym_sanitize_hwaddress] = ACTIONS(709),
    [anon_sym_sanitize_memtag] = ACTIONS(709),
    [anon_sym_speculative_load_hardening] = ACTIONS(709),
    [anon_sym_speculatable] = ACTIONS(709),
    [anon_sym_ssp] = ACTIONS(711),
    [anon_sym_sspstrong] = ACTIONS(709),
    [anon_sym_sspreq] = ACTIONS(709),
    [anon_sym_strictfp] = ACTIONS(709),
    [anon_sym_nocf_check] = ACTIONS(709),
    [anon_sym_shadowcallstack] = ACTIONS(709),
    [anon_sym_mustprogress] = ACTIONS(709),
    [anon_sym_vscale_range] = ACTIONS(709),
    [anon_sym_preallocated] = ACTIONS(709),
    [anon_sym_zeroext] = ACTIONS(709),
    [anon_sym_signext] = ACTIONS(709),
    [anon_sym_inreg] = ACTIONS(709),
    [anon_sym_byval] = ACTIONS(709),
    [anon_sym_byref] = ACTIONS(709),
    [anon_sym_inalloca] = ACTIONS(709),
    [anon_sym_sret] = ACTIONS(709),
    [anon_sym_elementtype] = ACTIONS(709),
    [anon_sym_noalias] = ACTIONS(709),
    [anon_sym_nocapture] = ACTIONS(709),
    [anon_sym_nest] = ACTIONS(709),
    [anon_sym_returned] = ACTIONS(709),
    [anon_sym_nonnull] = ACTIONS(709),
    [anon_sym_dereferenceable] = ACTIONS(711),
    [anon_sym_dereferenceable_or_null] = ACTIONS(709),
    [anon_sym_swiftself] = ACTIONS(711),
    [anon_sym_swiftasync] = ACTIONS(711),
    [anon_sym_swifterror] = ACTIONS(711),
    [anon_sym_immarg] = ACTIONS(709),
    [anon_sym_noundef] = ACTIONS(709),
    [anon_sym_uwtable] = ACTIONS(709),
    [anon_sym_memory] = ACTIONS(709),
    [anon_sym_to] = ACTIONS(711),
    [anon_sym_unwind] = ACTIONS(709),
    [anon_sym_unordered] = ACTIONS(709),
    [anon_sym_monotonic] = ACTIONS(709),
    [anon_sym_acquire] = ACTIONS(709),
    [anon_sym_release] = ACTIONS(709),
    [anon_sym_acq_rel] = ACTIONS(709),
    [anon_sym_seq_cst] = ACTIONS(709),
    [anon_sym_syncscope] = ACTIONS(709),
    [anon_sym_uselistorder] = ACTIONS(711),
    [anon_sym_uselistorder_bb] = ACTIONS(709),
    [anon_sym_module] = ACTIONS(709),
    [anon_sym_attributes] = ACTIONS(709),
  },
  [136] = {
    [ts_builtin_sym_end] = ACTIONS(679),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(679),
    [sym_global_var] = ACTIONS(679),
    [sym_local_var] = ACTIONS(679),
    [aux_sym_metadata_ref_token1] = ACTIONS(679),
    [sym_summary_ref] = ACTIONS(679),
    [sym_string] = ACTIONS(679),
    [anon_sym_target] = ACTIONS(679),
    [anon_sym_source_filename] = ACTIONS(679),
    [anon_sym_declare] = ACTIONS(679),
    [anon_sym_define] = ACTIONS(679),
    [anon_sym_no_cfi] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_internal] = ACTIONS(679),
    [anon_sym_weak] = ACTIONS(681),
    [anon_sym_weak_odr] = ACTIONS(679),
    [anon_sym_linkonce] = ACTIONS(681),
    [anon_sym_linkonce_odr] = ACTIONS(679),
    [anon_sym_available_externally] = ACTIONS(679),
    [anon_sym_appending] = ACTIONS(679),
    [anon_sym_common] = ACTIONS(679),
    [anon_sym_extern_weak] = ACTIONS(679),
    [anon_sym_external] = ACTIONS(679),
    [anon_sym_dso_local] = ACTIONS(681),
    [anon_sym_dso_local_equivalent] = ACTIONS(679),
    [anon_sym_dso_preemptable] = ACTIONS(679),
    [anon_sym_default] = ACTIONS(679),
    [anon_sym_hidden] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_dllimport] = ACTIONS(679),
    [anon_sym_dllexport] = ACTIONS(679),
    [anon_sym_ccc] = ACTIONS(679),
    [anon_sym_fastcc] = ACTIONS(679),
    [anon_sym_coldcc] = ACTIONS(679),
    [anon_sym_webkit_jscc] = ACTIONS(681),
    [anon_sym_anyregcc] = ACTIONS(679),
    [anon_sym_preserve_mostcc] = ACTIONS(679),
    [anon_sym_preserve_allcc] = ACTIONS(679),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(681),
    [anon_sym_tailcc] = ACTIONS(679),
    [anon_sym_swiftcc] = ACTIONS(681),
    [anon_sym_swifttailcc] = ACTIONS(681),
    [anon_sym_cfguard_checkcc] = ACTIONS(679),
    [aux_sym_calling_conv_token1] = ACTIONS(681),
    [aux_sym_calling_conv_token2] = ACTIONS(679),
    [aux_sym_calling_conv_token3] = ACTIONS(679),
    [aux_sym_calling_conv_token4] = ACTIONS(679),
    [aux_sym_calling_conv_token5] = ACTIONS(679),
    [aux_sym_calling_conv_token6] = ACTIONS(679),
    [aux_sym_calling_conv_token7] = ACTIONS(679),
    [aux_sym_calling_conv_token8] = ACTIONS(679),
    [aux_sym_calling_conv_token9] = ACTIONS(679),
    [aux_sym_calling_conv_token10] = ACTIONS(681),
    [anon_sym_ghccc] = ACTIONS(679),
    [aux_sym_calling_conv_token11] = ACTIONS(681),
    [aux_sym_calling_conv_token12] = ACTIONS(679),
    [aux_sym_calling_conv_token13] = ACTIONS(681),
    [aux_sym_calling_conv_token14] = ACTIONS(679),
    [anon_sym_cc] = ACTIONS(681),
    [anon_sym_unnamed_addr] = ACTIONS(679),
    [anon_sym_local_unnamed_addr] = ACTIONS(679),
    [anon_sym_void] = ACTIONS(679),
    [anon_sym_half] = ACTIONS(679),
    [anon_sym_bfloat] = ACTIONS(679),
    [anon_sym_float] = ACTIONS(679),
    [anon_sym_double] = ACTIONS(679),
    [anon_sym_x86_fp80] = ACTIONS(681),
    [anon_sym_fp128] = ACTIONS(679),
    [anon_sym_ppc_fp128] = ACTIONS(679),
    [anon_sym_label] = ACTIONS(679),
    [anon_sym_metadata] = ACTIONS(679),
    [anon_sym_x86_mmx] = ACTIONS(681),
    [anon_sym_x86_amx] = ACTIONS(681),
    [anon_sym_token] = ACTIONS(679),
    [anon_sym_opaque] = ACTIONS(679),
    [anon_sym_ptr] = ACTIONS(679),
    [aux_sym_type_keyword_token1] = ACTIONS(679),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(679),
    [anon_sym_LT_LBRACE] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(679),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(679),
    [anon_sym_COMMA] = ACTIONS(679),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_alignstack] = ACTIONS(679),
    [anon_sym_allocsize] = ACTIONS(679),
    [anon_sym_alwaysinline] = ACTIONS(679),
    [anon_sym_builtin] = ACTIONS(679),
    [anon_sym_cold] = ACTIONS(681),
    [anon_sym_convergent] = ACTIONS(679),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(679),
    [anon_sym_hot] = ACTIONS(679),
    [anon_sym_inaccessiblememonly] = ACTIONS(679),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(679),
    [anon_sym_inlinehint] = ACTIONS(679),
    [anon_sym_jumptable] = ACTIONS(679),
    [anon_sym_minsize] = ACTIONS(679),
    [anon_sym_naked] = ACTIONS(679),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(679),
    [anon_sym_nobuiltin] = ACTIONS(679),
    [anon_sym_noduplicate] = ACTIONS(679),
    [anon_sym_nofree] = ACTIONS(679),
    [anon_sym_noimplicitfloat] = ACTIONS(679),
    [anon_sym_noinline] = ACTIONS(679),
    [anon_sym_nomerge] = ACTIONS(679),
    [anon_sym_nonlazybind] = ACTIONS(679),
    [anon_sym_noprofile] = ACTIONS(679),
    [anon_sym_noredzone] = ACTIONS(679),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(679),
    [anon_sym_noreturn] = ACTIONS(679),
    [anon_sym_norecurse] = ACTIONS(679),
    [anon_sym_willreturn] = ACTIONS(679),
    [anon_sym_nosync] = ACTIONS(679),
    [anon_sym_nounwind] = ACTIONS(679),
    [anon_sym_nocallback] = ACTIONS(679),
    [anon_sym_nosanitize_coverage] = ACTIONS(679),
    [anon_sym_null_pointer_is_valid] = ACTIONS(679),
    [anon_sym_optforfuzzing] = ACTIONS(679),
    [anon_sym_optnone] = ACTIONS(679),
    [anon_sym_optsize] = ACTIONS(679),
    [anon_sym_readnone] = ACTIONS(679),
    [anon_sym_readonly] = ACTIONS(679),
    [anon_sym_writeonly] = ACTIONS(679),
    [anon_sym_argmemonly] = ACTIONS(679),
    [anon_sym_returns_twice] = ACTIONS(679),
    [anon_sym_safestack] = ACTIONS(679),
    [anon_sym_sanitize_address] = ACTIONS(679),
    [anon_sym_sanitize_memory] = ACTIONS(679),
    [anon_sym_sanitize_thread] = ACTIONS(679),
    [anon_sym_sanitize_hwaddress] = ACTIONS(679),
    [anon_sym_sanitize_memtag] = ACTIONS(679),
    [anon_sym_speculative_load_hardening] = ACTIONS(679),
    [anon_sym_speculatable] = ACTIONS(679),
    [anon_sym_ssp] = ACTIONS(681),
    [anon_sym_sspstrong] = ACTIONS(679),
    [anon_sym_sspreq] = ACTIONS(679),
    [anon_sym_strictfp] = ACTIONS(679),
    [anon_sym_nocf_check] = ACTIONS(679),
    [anon_sym_shadowcallstack] = ACTIONS(679),
    [anon_sym_mustprogress] = ACTIONS(679),
    [anon_sym_vscale_range] = ACTIONS(679),
    [anon_sym_preallocated] = ACTIONS(679),
    [anon_sym_zeroext] = ACTIONS(679),
    [anon_sym_signext] = ACTIONS(679),
    [anon_sym_inreg] = ACTIONS(679),
    [anon_sym_byval] = ACTIONS(679),
    [anon_sym_byref] = ACTIONS(679),
    [anon_sym_inalloca] = ACTIONS(679),
    [anon_sym_sret] = ACTIONS(679),
    [anon_sym_elementtype] = ACTIONS(679),
    [anon_sym_noalias] = ACTIONS(679),
    [anon_sym_nocapture] = ACTIONS(679),
    [anon_sym_nest] = ACTIONS(679),
    [anon_sym_returned] = ACTIONS(679),
    [anon_sym_nonnull] = ACTIONS(679),
    [anon_sym_dereferenceable] = ACTIONS(681),
    [anon_sym_dereferenceable_or_null] = ACTIONS(679),
    [anon_sym_swiftself] = ACTIONS(681),
    [anon_sym_swiftasync] = ACTIONS(681),
    [anon_sym_swifterror] = ACTIONS(681),
    [anon_sym_immarg] = ACTIONS(679),
    [anon_sym_noundef] = ACTIONS(679),
    [anon_sym_uwtable] = ACTIONS(679),
    [anon_sym_memory] = ACTIONS(679),
    [anon_sym_to] = ACTIONS(681),
    [anon_sym_unwind] = ACTIONS(679),
    [anon_sym_unordered] = ACTIONS(679),
    [anon_sym_monotonic] = ACTIONS(679),
    [anon_sym_acquire] = ACTIONS(679),
    [anon_sym_release] = ACTIONS(679),
    [anon_sym_acq_rel] = ACTIONS(679),
    [anon_sym_seq_cst] = ACTIONS(679),
    [anon_sym_syncscope] = ACTIONS(679),
    [anon_sym_uselistorder] = ACTIONS(681),
    [anon_sym_uselistorder_bb] = ACTIONS(679),
    [anon_sym_module] = ACTIONS(679),
    [anon_sym_attributes] = ACTIONS(679),
  },
  [137] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(509),
    [sym_local_var] = ACTIONS(509),
    [sym_label] = ACTIONS(509),
    [sym_string] = ACTIONS(511),
    [anon_sym_RBRACE] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(509),
    [anon_sym_align] = ACTIONS(511),
    [anon_sym_section] = ACTIONS(511),
    [anon_sym_partition] = ACTIONS(511),
    [anon_sym_comdat] = ACTIONS(511),
    [anon_sym_gc] = ACTIONS(511),
    [anon_sym_prefix] = ACTIONS(511),
    [anon_sym_prologue] = ACTIONS(511),
    [anon_sym_personality] = ACTIONS(511),
    [anon_sym_alignstack] = ACTIONS(511),
    [anon_sym_allocsize] = ACTIONS(511),
    [anon_sym_alwaysinline] = ACTIONS(511),
    [anon_sym_builtin] = ACTIONS(511),
    [anon_sym_cold] = ACTIONS(511),
    [anon_sym_convergent] = ACTIONS(511),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(511),
    [anon_sym_hot] = ACTIONS(511),
    [anon_sym_inaccessiblememonly] = ACTIONS(511),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(511),
    [anon_sym_inlinehint] = ACTIONS(511),
    [anon_sym_jumptable] = ACTIONS(511),
    [anon_sym_minsize] = ACTIONS(511),
    [anon_sym_naked] = ACTIONS(511),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(511),
    [anon_sym_nobuiltin] = ACTIONS(511),
    [anon_sym_noduplicate] = ACTIONS(511),
    [anon_sym_nofree] = ACTIONS(511),
    [anon_sym_noimplicitfloat] = ACTIONS(511),
    [anon_sym_noinline] = ACTIONS(511),
    [anon_sym_nomerge] = ACTIONS(511),
    [anon_sym_nonlazybind] = ACTIONS(511),
    [anon_sym_noprofile] = ACTIONS(511),
    [anon_sym_noredzone] = ACTIONS(511),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(511),
    [anon_sym_noreturn] = ACTIONS(511),
    [anon_sym_norecurse] = ACTIONS(511),
    [anon_sym_willreturn] = ACTIONS(511),
    [anon_sym_nosync] = ACTIONS(511),
    [anon_sym_nounwind] = ACTIONS(511),
    [anon_sym_nocallback] = ACTIONS(511),
    [anon_sym_nosanitize_coverage] = ACTIONS(511),
    [anon_sym_null_pointer_is_valid] = ACTIONS(511),
    [anon_sym_optforfuzzing] = ACTIONS(511),
    [anon_sym_optnone] = ACTIONS(511),
    [anon_sym_optsize] = ACTIONS(511),
    [anon_sym_readnone] = ACTIONS(511),
    [anon_sym_readonly] = ACTIONS(511),
    [anon_sym_writeonly] = ACTIONS(511),
    [anon_sym_argmemonly] = ACTIONS(511),
    [anon_sym_returns_twice] = ACTIONS(511),
    [anon_sym_safestack] = ACTIONS(511),
    [anon_sym_sanitize_address] = ACTIONS(511),
    [anon_sym_sanitize_memory] = ACTIONS(511),
    [anon_sym_sanitize_thread] = ACTIONS(511),
    [anon_sym_sanitize_hwaddress] = ACTIONS(511),
    [anon_sym_sanitize_memtag] = ACTIONS(511),
    [anon_sym_speculative_load_hardening] = ACTIONS(511),
    [anon_sym_speculatable] = ACTIONS(511),
    [anon_sym_ssp] = ACTIONS(511),
    [anon_sym_sspstrong] = ACTIONS(511),
    [anon_sym_sspreq] = ACTIONS(511),
    [anon_sym_strictfp] = ACTIONS(511),
    [anon_sym_nocf_check] = ACTIONS(511),
    [anon_sym_shadowcallstack] = ACTIONS(511),
    [anon_sym_mustprogress] = ACTIONS(511),
    [anon_sym_vscale_range] = ACTIONS(511),
    [anon_sym_preallocated] = ACTIONS(511),
    [anon_sym_zeroext] = ACTIONS(511),
    [anon_sym_signext] = ACTIONS(511),
    [anon_sym_inreg] = ACTIONS(511),
    [anon_sym_byval] = ACTIONS(511),
    [anon_sym_byref] = ACTIONS(511),
    [anon_sym_inalloca] = ACTIONS(511),
    [anon_sym_sret] = ACTIONS(511),
    [anon_sym_elementtype] = ACTIONS(511),
    [anon_sym_noalias] = ACTIONS(511),
    [anon_sym_nocapture] = ACTIONS(511),
    [anon_sym_nest] = ACTIONS(511),
    [anon_sym_returned] = ACTIONS(511),
    [anon_sym_nonnull] = ACTIONS(511),
    [anon_sym_dereferenceable] = ACTIONS(511),
    [anon_sym_dereferenceable_or_null] = ACTIONS(511),
    [anon_sym_swiftself] = ACTIONS(511),
    [anon_sym_swiftasync] = ACTIONS(511),
    [anon_sym_swifterror] = ACTIONS(511),
    [anon_sym_immarg] = ACTIONS(511),
    [anon_sym_noundef] = ACTIONS(511),
    [anon_sym_uwtable] = ACTIONS(511),
    [anon_sym_memory] = ACTIONS(511),
    [anon_sym_unreachable] = ACTIONS(511),
    [anon_sym_ret] = ACTIONS(511),
    [anon_sym_br] = ACTIONS(511),
    [anon_sym_resume] = ACTIONS(511),
    [anon_sym_freeze] = ACTIONS(511),
    [anon_sym_indirectbr] = ACTIONS(511),
    [anon_sym_extractelement] = ACTIONS(511),
    [anon_sym_insertelement] = ACTIONS(511),
    [anon_sym_select] = ACTIONS(511),
    [anon_sym_shufflevector] = ACTIONS(511),
    [anon_sym_fneg] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(511),
    [anon_sym_invoke] = ACTIONS(511),
    [anon_sym_cleanupret] = ACTIONS(511),
    [anon_sym_catchret] = ACTIONS(511),
    [anon_sym_catchswitch] = ACTIONS(511),
    [anon_sym_catchpad] = ACTIONS(511),
    [anon_sym_cleanuppad] = ACTIONS(511),
    [anon_sym_callbr] = ACTIONS(511),
    [anon_sym_icmp] = ACTIONS(511),
    [anon_sym_fcmp] = ACTIONS(511),
    [anon_sym_va_arg] = ACTIONS(511),
    [anon_sym_phi] = ACTIONS(511),
    [anon_sym_landingpad] = ACTIONS(511),
    [anon_sym_tail] = ACTIONS(511),
    [anon_sym_musttail] = ACTIONS(511),
    [anon_sym_notail] = ACTIONS(511),
    [anon_sym_call] = ACTIONS(511),
    [anon_sym_alloca] = ACTIONS(511),
    [anon_sym_load] = ACTIONS(511),
    [anon_sym_store] = ACTIONS(511),
    [anon_sym_cmpxchg] = ACTIONS(511),
    [anon_sym_atomicrmw] = ACTIONS(511),
    [anon_sym_fence] = ACTIONS(511),
    [anon_sym_getelementptr] = ACTIONS(511),
    [anon_sym_extractvalue] = ACTIONS(511),
    [anon_sym_insertvalue] = ACTIONS(511),
    [anon_sym_catch] = ACTIONS(511),
    [anon_sym_filter] = ACTIONS(511),
    [anon_sym_mul] = ACTIONS(511),
    [anon_sym_urem] = ACTIONS(511),
    [anon_sym_srem] = ACTIONS(511),
    [anon_sym_shl] = ACTIONS(511),
    [anon_sym_udiv] = ACTIONS(511),
    [anon_sym_sdiv] = ACTIONS(511),
    [anon_sym_lshr] = ACTIONS(511),
    [anon_sym_ashr] = ACTIONS(511),
    [anon_sym_fmul] = ACTIONS(511),
    [anon_sym_fdiv] = ACTIONS(511),
    [anon_sym_frem] = ACTIONS(511),
    [anon_sym_xchg] = ACTIONS(511),
    [anon_sym_add] = ACTIONS(511),
    [anon_sym_sub] = ACTIONS(511),
    [anon_sym_and] = ACTIONS(511),
    [anon_sym_nand] = ACTIONS(511),
    [anon_sym_or] = ACTIONS(511),
    [anon_sym_xor] = ACTIONS(511),
    [anon_sym_max] = ACTIONS(511),
    [anon_sym_min] = ACTIONS(511),
    [anon_sym_umax] = ACTIONS(511),
    [anon_sym_umin] = ACTIONS(511),
    [anon_sym_fadd] = ACTIONS(511),
    [anon_sym_fsub] = ACTIONS(511),
    [anon_sym_bitcast] = ACTIONS(511),
    [anon_sym_trunc] = ACTIONS(511),
    [anon_sym_zext] = ACTIONS(511),
    [anon_sym_sext] = ACTIONS(511),
    [anon_sym_fptrunc] = ACTIONS(511),
    [anon_sym_fpext] = ACTIONS(511),
    [anon_sym_addrspacecast] = ACTIONS(511),
    [anon_sym_uitofp] = ACTIONS(511),
    [anon_sym_sitofp] = ACTIONS(511),
    [anon_sym_fptoui] = ACTIONS(511),
    [anon_sym_fptosi] = ACTIONS(511),
    [anon_sym_inttoptr] = ACTIONS(511),
    [anon_sym_ptrtoint] = ACTIONS(511),
    [anon_sym_unordered] = ACTIONS(511),
    [anon_sym_monotonic] = ACTIONS(511),
    [anon_sym_acquire] = ACTIONS(511),
    [anon_sym_release] = ACTIONS(511),
    [anon_sym_acq_rel] = ACTIONS(511),
    [anon_sym_seq_cst] = ACTIONS(511),
    [anon_sym_syncscope] = ACTIONS(511),
    [anon_sym_uselistorder] = ACTIONS(511),
  },
  [138] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(627),
    [sym_local_var] = ACTIONS(627),
    [sym_label] = ACTIONS(627),
    [sym_string] = ACTIONS(629),
    [anon_sym_RBRACE] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_COMMA] = ACTIONS(627),
    [anon_sym_align] = ACTIONS(629),
    [anon_sym_section] = ACTIONS(629),
    [anon_sym_partition] = ACTIONS(629),
    [anon_sym_comdat] = ACTIONS(629),
    [anon_sym_gc] = ACTIONS(629),
    [anon_sym_prefix] = ACTIONS(629),
    [anon_sym_prologue] = ACTIONS(629),
    [anon_sym_personality] = ACTIONS(629),
    [anon_sym_alignstack] = ACTIONS(629),
    [anon_sym_allocsize] = ACTIONS(629),
    [anon_sym_alwaysinline] = ACTIONS(629),
    [anon_sym_builtin] = ACTIONS(629),
    [anon_sym_cold] = ACTIONS(629),
    [anon_sym_convergent] = ACTIONS(629),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(629),
    [anon_sym_hot] = ACTIONS(629),
    [anon_sym_inaccessiblememonly] = ACTIONS(629),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(629),
    [anon_sym_inlinehint] = ACTIONS(629),
    [anon_sym_jumptable] = ACTIONS(629),
    [anon_sym_minsize] = ACTIONS(629),
    [anon_sym_naked] = ACTIONS(629),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(629),
    [anon_sym_nobuiltin] = ACTIONS(629),
    [anon_sym_noduplicate] = ACTIONS(629),
    [anon_sym_nofree] = ACTIONS(629),
    [anon_sym_noimplicitfloat] = ACTIONS(629),
    [anon_sym_noinline] = ACTIONS(629),
    [anon_sym_nomerge] = ACTIONS(629),
    [anon_sym_nonlazybind] = ACTIONS(629),
    [anon_sym_noprofile] = ACTIONS(629),
    [anon_sym_noredzone] = ACTIONS(629),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(629),
    [anon_sym_noreturn] = ACTIONS(629),
    [anon_sym_norecurse] = ACTIONS(629),
    [anon_sym_willreturn] = ACTIONS(629),
    [anon_sym_nosync] = ACTIONS(629),
    [anon_sym_nounwind] = ACTIONS(629),
    [anon_sym_nocallback] = ACTIONS(629),
    [anon_sym_nosanitize_coverage] = ACTIONS(629),
    [anon_sym_null_pointer_is_valid] = ACTIONS(629),
    [anon_sym_optforfuzzing] = ACTIONS(629),
    [anon_sym_optnone] = ACTIONS(629),
    [anon_sym_optsize] = ACTIONS(629),
    [anon_sym_readnone] = ACTIONS(629),
    [anon_sym_readonly] = ACTIONS(629),
    [anon_sym_writeonly] = ACTIONS(629),
    [anon_sym_argmemonly] = ACTIONS(629),
    [anon_sym_returns_twice] = ACTIONS(629),
    [anon_sym_safestack] = ACTIONS(629),
    [anon_sym_sanitize_address] = ACTIONS(629),
    [anon_sym_sanitize_memory] = ACTIONS(629),
    [anon_sym_sanitize_thread] = ACTIONS(629),
    [anon_sym_sanitize_hwaddress] = ACTIONS(629),
    [anon_sym_sanitize_memtag] = ACTIONS(629),
    [anon_sym_speculative_load_hardening] = ACTIONS(629),
    [anon_sym_speculatable] = ACTIONS(629),
    [anon_sym_ssp] = ACTIONS(629),
    [anon_sym_sspstrong] = ACTIONS(629),
    [anon_sym_sspreq] = ACTIONS(629),
    [anon_sym_strictfp] = ACTIONS(629),
    [anon_sym_nocf_check] = ACTIONS(629),
    [anon_sym_shadowcallstack] = ACTIONS(629),
    [anon_sym_mustprogress] = ACTIONS(629),
    [anon_sym_vscale_range] = ACTIONS(629),
    [anon_sym_preallocated] = ACTIONS(629),
    [anon_sym_zeroext] = ACTIONS(629),
    [anon_sym_signext] = ACTIONS(629),
    [anon_sym_inreg] = ACTIONS(629),
    [anon_sym_byval] = ACTIONS(629),
    [anon_sym_byref] = ACTIONS(629),
    [anon_sym_inalloca] = ACTIONS(629),
    [anon_sym_sret] = ACTIONS(629),
    [anon_sym_elementtype] = ACTIONS(629),
    [anon_sym_noalias] = ACTIONS(629),
    [anon_sym_nocapture] = ACTIONS(629),
    [anon_sym_nest] = ACTIONS(629),
    [anon_sym_returned] = ACTIONS(629),
    [anon_sym_nonnull] = ACTIONS(629),
    [anon_sym_dereferenceable] = ACTIONS(629),
    [anon_sym_dereferenceable_or_null] = ACTIONS(629),
    [anon_sym_swiftself] = ACTIONS(629),
    [anon_sym_swiftasync] = ACTIONS(629),
    [anon_sym_swifterror] = ACTIONS(629),
    [anon_sym_immarg] = ACTIONS(629),
    [anon_sym_noundef] = ACTIONS(629),
    [anon_sym_uwtable] = ACTIONS(629),
    [anon_sym_memory] = ACTIONS(629),
    [anon_sym_unreachable] = ACTIONS(629),
    [anon_sym_ret] = ACTIONS(629),
    [anon_sym_br] = ACTIONS(629),
    [anon_sym_resume] = ACTIONS(629),
    [anon_sym_freeze] = ACTIONS(629),
    [anon_sym_indirectbr] = ACTIONS(629),
    [anon_sym_extractelement] = ACTIONS(629),
    [anon_sym_insertelement] = ACTIONS(629),
    [anon_sym_select] = ACTIONS(629),
    [anon_sym_shufflevector] = ACTIONS(629),
    [anon_sym_fneg] = ACTIONS(629),
    [anon_sym_switch] = ACTIONS(629),
    [anon_sym_invoke] = ACTIONS(629),
    [anon_sym_cleanupret] = ACTIONS(629),
    [anon_sym_catchret] = ACTIONS(629),
    [anon_sym_catchswitch] = ACTIONS(629),
    [anon_sym_catchpad] = ACTIONS(629),
    [anon_sym_cleanuppad] = ACTIONS(629),
    [anon_sym_callbr] = ACTIONS(629),
    [anon_sym_icmp] = ACTIONS(629),
    [anon_sym_fcmp] = ACTIONS(629),
    [anon_sym_va_arg] = ACTIONS(629),
    [anon_sym_phi] = ACTIONS(629),
    [anon_sym_landingpad] = ACTIONS(629),
    [anon_sym_tail] = ACTIONS(629),
    [anon_sym_musttail] = ACTIONS(629),
    [anon_sym_notail] = ACTIONS(629),
    [anon_sym_call] = ACTIONS(629),
    [anon_sym_alloca] = ACTIONS(629),
    [anon_sym_load] = ACTIONS(629),
    [anon_sym_store] = ACTIONS(629),
    [anon_sym_cmpxchg] = ACTIONS(629),
    [anon_sym_atomicrmw] = ACTIONS(629),
    [anon_sym_fence] = ACTIONS(629),
    [anon_sym_getelementptr] = ACTIONS(629),
    [anon_sym_extractvalue] = ACTIONS(629),
    [anon_sym_insertvalue] = ACTIONS(629),
    [anon_sym_catch] = ACTIONS(629),
    [anon_sym_filter] = ACTIONS(629),
    [anon_sym_mul] = ACTIONS(629),
    [anon_sym_urem] = ACTIONS(629),
    [anon_sym_srem] = ACTIONS(629),
    [anon_sym_shl] = ACTIONS(629),
    [anon_sym_udiv] = ACTIONS(629),
    [anon_sym_sdiv] = ACTIONS(629),
    [anon_sym_lshr] = ACTIONS(629),
    [anon_sym_ashr] = ACTIONS(629),
    [anon_sym_fmul] = ACTIONS(629),
    [anon_sym_fdiv] = ACTIONS(629),
    [anon_sym_frem] = ACTIONS(629),
    [anon_sym_xchg] = ACTIONS(629),
    [anon_sym_add] = ACTIONS(629),
    [anon_sym_sub] = ACTIONS(629),
    [anon_sym_and] = ACTIONS(629),
    [anon_sym_nand] = ACTIONS(629),
    [anon_sym_or] = ACTIONS(629),
    [anon_sym_xor] = ACTIONS(629),
    [anon_sym_max] = ACTIONS(629),
    [anon_sym_min] = ACTIONS(629),
    [anon_sym_umax] = ACTIONS(629),
    [anon_sym_umin] = ACTIONS(629),
    [anon_sym_fadd] = ACTIONS(629),
    [anon_sym_fsub] = ACTIONS(629),
    [anon_sym_bitcast] = ACTIONS(629),
    [anon_sym_trunc] = ACTIONS(629),
    [anon_sym_zext] = ACTIONS(629),
    [anon_sym_sext] = ACTIONS(629),
    [anon_sym_fptrunc] = ACTIONS(629),
    [anon_sym_fpext] = ACTIONS(629),
    [anon_sym_addrspacecast] = ACTIONS(629),
    [anon_sym_uitofp] = ACTIONS(629),
    [anon_sym_sitofp] = ACTIONS(629),
    [anon_sym_fptoui] = ACTIONS(629),
    [anon_sym_fptosi] = ACTIONS(629),
    [anon_sym_inttoptr] = ACTIONS(629),
    [anon_sym_ptrtoint] = ACTIONS(629),
    [anon_sym_unordered] = ACTIONS(629),
    [anon_sym_monotonic] = ACTIONS(629),
    [anon_sym_acquire] = ACTIONS(629),
    [anon_sym_release] = ACTIONS(629),
    [anon_sym_acq_rel] = ACTIONS(629),
    [anon_sym_seq_cst] = ACTIONS(629),
    [anon_sym_syncscope] = ACTIONS(629),
    [anon_sym_uselistorder] = ACTIONS(629),
  },
  [139] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(513),
    [sym_local_var] = ACTIONS(513),
    [sym_label] = ACTIONS(513),
    [sym_string] = ACTIONS(515),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_LBRACK] = ACTIONS(513),
    [anon_sym_COMMA] = ACTIONS(513),
    [anon_sym_align] = ACTIONS(515),
    [anon_sym_section] = ACTIONS(515),
    [anon_sym_partition] = ACTIONS(515),
    [anon_sym_comdat] = ACTIONS(515),
    [anon_sym_gc] = ACTIONS(515),
    [anon_sym_prefix] = ACTIONS(515),
    [anon_sym_prologue] = ACTIONS(515),
    [anon_sym_personality] = ACTIONS(515),
    [anon_sym_alignstack] = ACTIONS(515),
    [anon_sym_allocsize] = ACTIONS(515),
    [anon_sym_alwaysinline] = ACTIONS(515),
    [anon_sym_builtin] = ACTIONS(515),
    [anon_sym_cold] = ACTIONS(515),
    [anon_sym_convergent] = ACTIONS(515),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(515),
    [anon_sym_hot] = ACTIONS(515),
    [anon_sym_inaccessiblememonly] = ACTIONS(515),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(515),
    [anon_sym_inlinehint] = ACTIONS(515),
    [anon_sym_jumptable] = ACTIONS(515),
    [anon_sym_minsize] = ACTIONS(515),
    [anon_sym_naked] = ACTIONS(515),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(515),
    [anon_sym_nobuiltin] = ACTIONS(515),
    [anon_sym_noduplicate] = ACTIONS(515),
    [anon_sym_nofree] = ACTIONS(515),
    [anon_sym_noimplicitfloat] = ACTIONS(515),
    [anon_sym_noinline] = ACTIONS(515),
    [anon_sym_nomerge] = ACTIONS(515),
    [anon_sym_nonlazybind] = ACTIONS(515),
    [anon_sym_noprofile] = ACTIONS(515),
    [anon_sym_noredzone] = ACTIONS(515),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(515),
    [anon_sym_noreturn] = ACTIONS(515),
    [anon_sym_norecurse] = ACTIONS(515),
    [anon_sym_willreturn] = ACTIONS(515),
    [anon_sym_nosync] = ACTIONS(515),
    [anon_sym_nounwind] = ACTIONS(515),
    [anon_sym_nocallback] = ACTIONS(515),
    [anon_sym_nosanitize_coverage] = ACTIONS(515),
    [anon_sym_null_pointer_is_valid] = ACTIONS(515),
    [anon_sym_optforfuzzing] = ACTIONS(515),
    [anon_sym_optnone] = ACTIONS(515),
    [anon_sym_optsize] = ACTIONS(515),
    [anon_sym_readnone] = ACTIONS(515),
    [anon_sym_readonly] = ACTIONS(515),
    [anon_sym_writeonly] = ACTIONS(515),
    [anon_sym_argmemonly] = ACTIONS(515),
    [anon_sym_returns_twice] = ACTIONS(515),
    [anon_sym_safestack] = ACTIONS(515),
    [anon_sym_sanitize_address] = ACTIONS(515),
    [anon_sym_sanitize_memory] = ACTIONS(515),
    [anon_sym_sanitize_thread] = ACTIONS(515),
    [anon_sym_sanitize_hwaddress] = ACTIONS(515),
    [anon_sym_sanitize_memtag] = ACTIONS(515),
    [anon_sym_speculative_load_hardening] = ACTIONS(515),
    [anon_sym_speculatable] = ACTIONS(515),
    [anon_sym_ssp] = ACTIONS(515),
    [anon_sym_sspstrong] = ACTIONS(515),
    [anon_sym_sspreq] = ACTIONS(515),
    [anon_sym_strictfp] = ACTIONS(515),
    [anon_sym_nocf_check] = ACTIONS(515),
    [anon_sym_shadowcallstack] = ACTIONS(515),
    [anon_sym_mustprogress] = ACTIONS(515),
    [anon_sym_vscale_range] = ACTIONS(515),
    [anon_sym_preallocated] = ACTIONS(515),
    [anon_sym_zeroext] = ACTIONS(515),
    [anon_sym_signext] = ACTIONS(515),
    [anon_sym_inreg] = ACTIONS(515),
    [anon_sym_byval] = ACTIONS(515),
    [anon_sym_byref] = ACTIONS(515),
    [anon_sym_inalloca] = ACTIONS(515),
    [anon_sym_sret] = ACTIONS(515),
    [anon_sym_elementtype] = ACTIONS(515),
    [anon_sym_noalias] = ACTIONS(515),
    [anon_sym_nocapture] = ACTIONS(515),
    [anon_sym_nest] = ACTIONS(515),
    [anon_sym_returned] = ACTIONS(515),
    [anon_sym_nonnull] = ACTIONS(515),
    [anon_sym_dereferenceable] = ACTIONS(515),
    [anon_sym_dereferenceable_or_null] = ACTIONS(515),
    [anon_sym_swiftself] = ACTIONS(515),
    [anon_sym_swiftasync] = ACTIONS(515),
    [anon_sym_swifterror] = ACTIONS(515),
    [anon_sym_immarg] = ACTIONS(515),
    [anon_sym_noundef] = ACTIONS(515),
    [anon_sym_uwtable] = ACTIONS(515),
    [anon_sym_memory] = ACTIONS(515),
    [anon_sym_unreachable] = ACTIONS(515),
    [anon_sym_ret] = ACTIONS(515),
    [anon_sym_br] = ACTIONS(515),
    [anon_sym_resume] = ACTIONS(515),
    [anon_sym_freeze] = ACTIONS(515),
    [anon_sym_indirectbr] = ACTIONS(515),
    [anon_sym_extractelement] = ACTIONS(515),
    [anon_sym_insertelement] = ACTIONS(515),
    [anon_sym_select] = ACTIONS(515),
    [anon_sym_shufflevector] = ACTIONS(515),
    [anon_sym_fneg] = ACTIONS(515),
    [anon_sym_switch] = ACTIONS(515),
    [anon_sym_invoke] = ACTIONS(515),
    [anon_sym_cleanupret] = ACTIONS(515),
    [anon_sym_catchret] = ACTIONS(515),
    [anon_sym_catchswitch] = ACTIONS(515),
    [anon_sym_catchpad] = ACTIONS(515),
    [anon_sym_cleanuppad] = ACTIONS(515),
    [anon_sym_callbr] = ACTIONS(515),
    [anon_sym_icmp] = ACTIONS(515),
    [anon_sym_fcmp] = ACTIONS(515),
    [anon_sym_va_arg] = ACTIONS(515),
    [anon_sym_phi] = ACTIONS(515),
    [anon_sym_landingpad] = ACTIONS(515),
    [anon_sym_tail] = ACTIONS(515),
    [anon_sym_musttail] = ACTIONS(515),
    [anon_sym_notail] = ACTIONS(515),
    [anon_sym_call] = ACTIONS(515),
    [anon_sym_alloca] = ACTIONS(515),
    [anon_sym_load] = ACTIONS(515),
    [anon_sym_store] = ACTIONS(515),
    [anon_sym_cmpxchg] = ACTIONS(515),
    [anon_sym_atomicrmw] = ACTIONS(515),
    [anon_sym_fence] = ACTIONS(515),
    [anon_sym_getelementptr] = ACTIONS(515),
    [anon_sym_extractvalue] = ACTIONS(515),
    [anon_sym_insertvalue] = ACTIONS(515),
    [anon_sym_catch] = ACTIONS(515),
    [anon_sym_filter] = ACTIONS(515),
    [anon_sym_mul] = ACTIONS(515),
    [anon_sym_urem] = ACTIONS(515),
    [anon_sym_srem] = ACTIONS(515),
    [anon_sym_shl] = ACTIONS(515),
    [anon_sym_udiv] = ACTIONS(515),
    [anon_sym_sdiv] = ACTIONS(515),
    [anon_sym_lshr] = ACTIONS(515),
    [anon_sym_ashr] = ACTIONS(515),
    [anon_sym_fmul] = ACTIONS(515),
    [anon_sym_fdiv] = ACTIONS(515),
    [anon_sym_frem] = ACTIONS(515),
    [anon_sym_xchg] = ACTIONS(515),
    [anon_sym_add] = ACTIONS(515),
    [anon_sym_sub] = ACTIONS(515),
    [anon_sym_and] = ACTIONS(515),
    [anon_sym_nand] = ACTIONS(515),
    [anon_sym_or] = ACTIONS(515),
    [anon_sym_xor] = ACTIONS(515),
    [anon_sym_max] = ACTIONS(515),
    [anon_sym_min] = ACTIONS(515),
    [anon_sym_umax] = ACTIONS(515),
    [anon_sym_umin] = ACTIONS(515),
    [anon_sym_fadd] = ACTIONS(515),
    [anon_sym_fsub] = ACTIONS(515),
    [anon_sym_bitcast] = ACTIONS(515),
    [anon_sym_trunc] = ACTIONS(515),
    [anon_sym_zext] = ACTIONS(515),
    [anon_sym_sext] = ACTIONS(515),
    [anon_sym_fptrunc] = ACTIONS(515),
    [anon_sym_fpext] = ACTIONS(515),
    [anon_sym_addrspacecast] = ACTIONS(515),
    [anon_sym_uitofp] = ACTIONS(515),
    [anon_sym_sitofp] = ACTIONS(515),
    [anon_sym_fptoui] = ACTIONS(515),
    [anon_sym_fptosi] = ACTIONS(515),
    [anon_sym_inttoptr] = ACTIONS(515),
    [anon_sym_ptrtoint] = ACTIONS(515),
    [anon_sym_unordered] = ACTIONS(515),
    [anon_sym_monotonic] = ACTIONS(515),
    [anon_sym_acquire] = ACTIONS(515),
    [anon_sym_release] = ACTIONS(515),
    [anon_sym_acq_rel] = ACTIONS(515),
    [anon_sym_seq_cst] = ACTIONS(515),
    [anon_sym_syncscope] = ACTIONS(515),
    [anon_sym_uselistorder] = ACTIONS(515),
  },
  [140] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(671),
    [sym_local_var] = ACTIONS(671),
    [sym_label] = ACTIONS(671),
    [sym_string] = ACTIONS(673),
    [anon_sym_RBRACE] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_COMMA] = ACTIONS(671),
    [anon_sym_align] = ACTIONS(673),
    [anon_sym_section] = ACTIONS(673),
    [anon_sym_partition] = ACTIONS(673),
    [anon_sym_comdat] = ACTIONS(673),
    [anon_sym_gc] = ACTIONS(673),
    [anon_sym_prefix] = ACTIONS(673),
    [anon_sym_prologue] = ACTIONS(673),
    [anon_sym_personality] = ACTIONS(673),
    [anon_sym_alignstack] = ACTIONS(673),
    [anon_sym_allocsize] = ACTIONS(673),
    [anon_sym_alwaysinline] = ACTIONS(673),
    [anon_sym_builtin] = ACTIONS(673),
    [anon_sym_cold] = ACTIONS(673),
    [anon_sym_convergent] = ACTIONS(673),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(673),
    [anon_sym_hot] = ACTIONS(673),
    [anon_sym_inaccessiblememonly] = ACTIONS(673),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(673),
    [anon_sym_inlinehint] = ACTIONS(673),
    [anon_sym_jumptable] = ACTIONS(673),
    [anon_sym_minsize] = ACTIONS(673),
    [anon_sym_naked] = ACTIONS(673),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(673),
    [anon_sym_nobuiltin] = ACTIONS(673),
    [anon_sym_noduplicate] = ACTIONS(673),
    [anon_sym_nofree] = ACTIONS(673),
    [anon_sym_noimplicitfloat] = ACTIONS(673),
    [anon_sym_noinline] = ACTIONS(673),
    [anon_sym_nomerge] = ACTIONS(673),
    [anon_sym_nonlazybind] = ACTIONS(673),
    [anon_sym_noprofile] = ACTIONS(673),
    [anon_sym_noredzone] = ACTIONS(673),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(673),
    [anon_sym_noreturn] = ACTIONS(673),
    [anon_sym_norecurse] = ACTIONS(673),
    [anon_sym_willreturn] = ACTIONS(673),
    [anon_sym_nosync] = ACTIONS(673),
    [anon_sym_nounwind] = ACTIONS(673),
    [anon_sym_nocallback] = ACTIONS(673),
    [anon_sym_nosanitize_coverage] = ACTIONS(673),
    [anon_sym_null_pointer_is_valid] = ACTIONS(673),
    [anon_sym_optforfuzzing] = ACTIONS(673),
    [anon_sym_optnone] = ACTIONS(673),
    [anon_sym_optsize] = ACTIONS(673),
    [anon_sym_readnone] = ACTIONS(673),
    [anon_sym_readonly] = ACTIONS(673),
    [anon_sym_writeonly] = ACTIONS(673),
    [anon_sym_argmemonly] = ACTIONS(673),
    [anon_sym_returns_twice] = ACTIONS(673),
    [anon_sym_safestack] = ACTIONS(673),
    [anon_sym_sanitize_address] = ACTIONS(673),
    [anon_sym_sanitize_memory] = ACTIONS(673),
    [anon_sym_sanitize_thread] = ACTIONS(673),
    [anon_sym_sanitize_hwaddress] = ACTIONS(673),
    [anon_sym_sanitize_memtag] = ACTIONS(673),
    [anon_sym_speculative_load_hardening] = ACTIONS(673),
    [anon_sym_speculatable] = ACTIONS(673),
    [anon_sym_ssp] = ACTIONS(673),
    [anon_sym_sspstrong] = ACTIONS(673),
    [anon_sym_sspreq] = ACTIONS(673),
    [anon_sym_strictfp] = ACTIONS(673),
    [anon_sym_nocf_check] = ACTIONS(673),
    [anon_sym_shadowcallstack] = ACTIONS(673),
    [anon_sym_mustprogress] = ACTIONS(673),
    [anon_sym_vscale_range] = ACTIONS(673),
    [anon_sym_preallocated] = ACTIONS(673),
    [anon_sym_zeroext] = ACTIONS(673),
    [anon_sym_signext] = ACTIONS(673),
    [anon_sym_inreg] = ACTIONS(673),
    [anon_sym_byval] = ACTIONS(673),
    [anon_sym_byref] = ACTIONS(673),
    [anon_sym_inalloca] = ACTIONS(673),
    [anon_sym_sret] = ACTIONS(673),
    [anon_sym_elementtype] = ACTIONS(673),
    [anon_sym_noalias] = ACTIONS(673),
    [anon_sym_nocapture] = ACTIONS(673),
    [anon_sym_nest] = ACTIONS(673),
    [anon_sym_returned] = ACTIONS(673),
    [anon_sym_nonnull] = ACTIONS(673),
    [anon_sym_dereferenceable] = ACTIONS(673),
    [anon_sym_dereferenceable_or_null] = ACTIONS(673),
    [anon_sym_swiftself] = ACTIONS(673),
    [anon_sym_swiftasync] = ACTIONS(673),
    [anon_sym_swifterror] = ACTIONS(673),
    [anon_sym_immarg] = ACTIONS(673),
    [anon_sym_noundef] = ACTIONS(673),
    [anon_sym_uwtable] = ACTIONS(673),
    [anon_sym_memory] = ACTIONS(673),
    [anon_sym_unreachable] = ACTIONS(673),
    [anon_sym_ret] = ACTIONS(673),
    [anon_sym_br] = ACTIONS(673),
    [anon_sym_resume] = ACTIONS(673),
    [anon_sym_freeze] = ACTIONS(673),
    [anon_sym_indirectbr] = ACTIONS(673),
    [anon_sym_extractelement] = ACTIONS(673),
    [anon_sym_insertelement] = ACTIONS(673),
    [anon_sym_select] = ACTIONS(673),
    [anon_sym_shufflevector] = ACTIONS(673),
    [anon_sym_fneg] = ACTIONS(673),
    [anon_sym_switch] = ACTIONS(673),
    [anon_sym_invoke] = ACTIONS(673),
    [anon_sym_cleanupret] = ACTIONS(673),
    [anon_sym_catchret] = ACTIONS(673),
    [anon_sym_catchswitch] = ACTIONS(673),
    [anon_sym_catchpad] = ACTIONS(673),
    [anon_sym_cleanuppad] = ACTIONS(673),
    [anon_sym_callbr] = ACTIONS(673),
    [anon_sym_icmp] = ACTIONS(673),
    [anon_sym_fcmp] = ACTIONS(673),
    [anon_sym_va_arg] = ACTIONS(673),
    [anon_sym_phi] = ACTIONS(673),
    [anon_sym_landingpad] = ACTIONS(673),
    [anon_sym_tail] = ACTIONS(673),
    [anon_sym_musttail] = ACTIONS(673),
    [anon_sym_notail] = ACTIONS(673),
    [anon_sym_call] = ACTIONS(673),
    [anon_sym_alloca] = ACTIONS(673),
    [anon_sym_load] = ACTIONS(673),
    [anon_sym_store] = ACTIONS(673),
    [anon_sym_cmpxchg] = ACTIONS(673),
    [anon_sym_atomicrmw] = ACTIONS(673),
    [anon_sym_fence] = ACTIONS(673),
    [anon_sym_getelementptr] = ACTIONS(673),
    [anon_sym_extractvalue] = ACTIONS(673),
    [anon_sym_insertvalue] = ACTIONS(673),
    [anon_sym_catch] = ACTIONS(673),
    [anon_sym_filter] = ACTIONS(673),
    [anon_sym_mul] = ACTIONS(673),
    [anon_sym_urem] = ACTIONS(673),
    [anon_sym_srem] = ACTIONS(673),
    [anon_sym_shl] = ACTIONS(673),
    [anon_sym_udiv] = ACTIONS(673),
    [anon_sym_sdiv] = ACTIONS(673),
    [anon_sym_lshr] = ACTIONS(673),
    [anon_sym_ashr] = ACTIONS(673),
    [anon_sym_fmul] = ACTIONS(673),
    [anon_sym_fdiv] = ACTIONS(673),
    [anon_sym_frem] = ACTIONS(673),
    [anon_sym_xchg] = ACTIONS(673),
    [anon_sym_add] = ACTIONS(673),
    [anon_sym_sub] = ACTIONS(673),
    [anon_sym_and] = ACTIONS(673),
    [anon_sym_nand] = ACTIONS(673),
    [anon_sym_or] = ACTIONS(673),
    [anon_sym_xor] = ACTIONS(673),
    [anon_sym_max] = ACTIONS(673),
    [anon_sym_min] = ACTIONS(673),
    [anon_sym_umax] = ACTIONS(673),
    [anon_sym_umin] = ACTIONS(673),
    [anon_sym_fadd] = ACTIONS(673),
    [anon_sym_fsub] = ACTIONS(673),
    [anon_sym_bitcast] = ACTIONS(673),
    [anon_sym_trunc] = ACTIONS(673),
    [anon_sym_zext] = ACTIONS(673),
    [anon_sym_sext] = ACTIONS(673),
    [anon_sym_fptrunc] = ACTIONS(673),
    [anon_sym_fpext] = ACTIONS(673),
    [anon_sym_addrspacecast] = ACTIONS(673),
    [anon_sym_uitofp] = ACTIONS(673),
    [anon_sym_sitofp] = ACTIONS(673),
    [anon_sym_fptoui] = ACTIONS(673),
    [anon_sym_fptosi] = ACTIONS(673),
    [anon_sym_inttoptr] = ACTIONS(673),
    [anon_sym_ptrtoint] = ACTIONS(673),
    [anon_sym_unordered] = ACTIONS(673),
    [anon_sym_monotonic] = ACTIONS(673),
    [anon_sym_acquire] = ACTIONS(673),
    [anon_sym_release] = ACTIONS(673),
    [anon_sym_acq_rel] = ACTIONS(673),
    [anon_sym_seq_cst] = ACTIONS(673),
    [anon_sym_syncscope] = ACTIONS(673),
    [anon_sym_uselistorder] = ACTIONS(673),
  },
  [141] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(651),
    [sym_local_var] = ACTIONS(651),
    [sym_label] = ACTIONS(651),
    [sym_string] = ACTIONS(653),
    [anon_sym_RBRACE] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_align] = ACTIONS(653),
    [anon_sym_section] = ACTIONS(653),
    [anon_sym_partition] = ACTIONS(653),
    [anon_sym_comdat] = ACTIONS(653),
    [anon_sym_gc] = ACTIONS(653),
    [anon_sym_prefix] = ACTIONS(653),
    [anon_sym_prologue] = ACTIONS(653),
    [anon_sym_personality] = ACTIONS(653),
    [anon_sym_alignstack] = ACTIONS(653),
    [anon_sym_allocsize] = ACTIONS(653),
    [anon_sym_alwaysinline] = ACTIONS(653),
    [anon_sym_builtin] = ACTIONS(653),
    [anon_sym_cold] = ACTIONS(653),
    [anon_sym_convergent] = ACTIONS(653),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(653),
    [anon_sym_hot] = ACTIONS(653),
    [anon_sym_inaccessiblememonly] = ACTIONS(653),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(653),
    [anon_sym_inlinehint] = ACTIONS(653),
    [anon_sym_jumptable] = ACTIONS(653),
    [anon_sym_minsize] = ACTIONS(653),
    [anon_sym_naked] = ACTIONS(653),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(653),
    [anon_sym_nobuiltin] = ACTIONS(653),
    [anon_sym_noduplicate] = ACTIONS(653),
    [anon_sym_nofree] = ACTIONS(653),
    [anon_sym_noimplicitfloat] = ACTIONS(653),
    [anon_sym_noinline] = ACTIONS(653),
    [anon_sym_nomerge] = ACTIONS(653),
    [anon_sym_nonlazybind] = ACTIONS(653),
    [anon_sym_noprofile] = ACTIONS(653),
    [anon_sym_noredzone] = ACTIONS(653),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(653),
    [anon_sym_noreturn] = ACTIONS(653),
    [anon_sym_norecurse] = ACTIONS(653),
    [anon_sym_willreturn] = ACTIONS(653),
    [anon_sym_nosync] = ACTIONS(653),
    [anon_sym_nounwind] = ACTIONS(653),
    [anon_sym_nocallback] = ACTIONS(653),
    [anon_sym_nosanitize_coverage] = ACTIONS(653),
    [anon_sym_null_pointer_is_valid] = ACTIONS(653),
    [anon_sym_optforfuzzing] = ACTIONS(653),
    [anon_sym_optnone] = ACTIONS(653),
    [anon_sym_optsize] = ACTIONS(653),
    [anon_sym_readnone] = ACTIONS(653),
    [anon_sym_readonly] = ACTIONS(653),
    [anon_sym_writeonly] = ACTIONS(653),
    [anon_sym_argmemonly] = ACTIONS(653),
    [anon_sym_returns_twice] = ACTIONS(653),
    [anon_sym_safestack] = ACTIONS(653),
    [anon_sym_sanitize_address] = ACTIONS(653),
    [anon_sym_sanitize_memory] = ACTIONS(653),
    [anon_sym_sanitize_thread] = ACTIONS(653),
    [anon_sym_sanitize_hwaddress] = ACTIONS(653),
    [anon_sym_sanitize_memtag] = ACTIONS(653),
    [anon_sym_speculative_load_hardening] = ACTIONS(653),
    [anon_sym_speculatable] = ACTIONS(653),
    [anon_sym_ssp] = ACTIONS(653),
    [anon_sym_sspstrong] = ACTIONS(653),
    [anon_sym_sspreq] = ACTIONS(653),
    [anon_sym_strictfp] = ACTIONS(653),
    [anon_sym_nocf_check] = ACTIONS(653),
    [anon_sym_shadowcallstack] = ACTIONS(653),
    [anon_sym_mustprogress] = ACTIONS(653),
    [anon_sym_vscale_range] = ACTIONS(653),
    [anon_sym_preallocated] = ACTIONS(653),
    [anon_sym_zeroext] = ACTIONS(653),
    [anon_sym_signext] = ACTIONS(653),
    [anon_sym_inreg] = ACTIONS(653),
    [anon_sym_byval] = ACTIONS(653),
    [anon_sym_byref] = ACTIONS(653),
    [anon_sym_inalloca] = ACTIONS(653),
    [anon_sym_sret] = ACTIONS(653),
    [anon_sym_elementtype] = ACTIONS(653),
    [anon_sym_noalias] = ACTIONS(653),
    [anon_sym_nocapture] = ACTIONS(653),
    [anon_sym_nest] = ACTIONS(653),
    [anon_sym_returned] = ACTIONS(653),
    [anon_sym_nonnull] = ACTIONS(653),
    [anon_sym_dereferenceable] = ACTIONS(653),
    [anon_sym_dereferenceable_or_null] = ACTIONS(653),
    [anon_sym_swiftself] = ACTIONS(653),
    [anon_sym_swiftasync] = ACTIONS(653),
    [anon_sym_swifterror] = ACTIONS(653),
    [anon_sym_immarg] = ACTIONS(653),
    [anon_sym_noundef] = ACTIONS(653),
    [anon_sym_uwtable] = ACTIONS(653),
    [anon_sym_memory] = ACTIONS(653),
    [anon_sym_unreachable] = ACTIONS(653),
    [anon_sym_ret] = ACTIONS(653),
    [anon_sym_br] = ACTIONS(653),
    [anon_sym_resume] = ACTIONS(653),
    [anon_sym_freeze] = ACTIONS(653),
    [anon_sym_indirectbr] = ACTIONS(653),
    [anon_sym_extractelement] = ACTIONS(653),
    [anon_sym_insertelement] = ACTIONS(653),
    [anon_sym_select] = ACTIONS(653),
    [anon_sym_shufflevector] = ACTIONS(653),
    [anon_sym_fneg] = ACTIONS(653),
    [anon_sym_switch] = ACTIONS(653),
    [anon_sym_invoke] = ACTIONS(653),
    [anon_sym_cleanupret] = ACTIONS(653),
    [anon_sym_catchret] = ACTIONS(653),
    [anon_sym_catchswitch] = ACTIONS(653),
    [anon_sym_catchpad] = ACTIONS(653),
    [anon_sym_cleanuppad] = ACTIONS(653),
    [anon_sym_callbr] = ACTIONS(653),
    [anon_sym_icmp] = ACTIONS(653),
    [anon_sym_fcmp] = ACTIONS(653),
    [anon_sym_va_arg] = ACTIONS(653),
    [anon_sym_phi] = ACTIONS(653),
    [anon_sym_landingpad] = ACTIONS(653),
    [anon_sym_tail] = ACTIONS(653),
    [anon_sym_musttail] = ACTIONS(653),
    [anon_sym_notail] = ACTIONS(653),
    [anon_sym_call] = ACTIONS(653),
    [anon_sym_alloca] = ACTIONS(653),
    [anon_sym_load] = ACTIONS(653),
    [anon_sym_store] = ACTIONS(653),
    [anon_sym_cmpxchg] = ACTIONS(653),
    [anon_sym_atomicrmw] = ACTIONS(653),
    [anon_sym_fence] = ACTIONS(653),
    [anon_sym_getelementptr] = ACTIONS(653),
    [anon_sym_extractvalue] = ACTIONS(653),
    [anon_sym_insertvalue] = ACTIONS(653),
    [anon_sym_catch] = ACTIONS(653),
    [anon_sym_filter] = ACTIONS(653),
    [anon_sym_mul] = ACTIONS(653),
    [anon_sym_urem] = ACTIONS(653),
    [anon_sym_srem] = ACTIONS(653),
    [anon_sym_shl] = ACTIONS(653),
    [anon_sym_udiv] = ACTIONS(653),
    [anon_sym_sdiv] = ACTIONS(653),
    [anon_sym_lshr] = ACTIONS(653),
    [anon_sym_ashr] = ACTIONS(653),
    [anon_sym_fmul] = ACTIONS(653),
    [anon_sym_fdiv] = ACTIONS(653),
    [anon_sym_frem] = ACTIONS(653),
    [anon_sym_xchg] = ACTIONS(653),
    [anon_sym_add] = ACTIONS(653),
    [anon_sym_sub] = ACTIONS(653),
    [anon_sym_and] = ACTIONS(653),
    [anon_sym_nand] = ACTIONS(653),
    [anon_sym_or] = ACTIONS(653),
    [anon_sym_xor] = ACTIONS(653),
    [anon_sym_max] = ACTIONS(653),
    [anon_sym_min] = ACTIONS(653),
    [anon_sym_umax] = ACTIONS(653),
    [anon_sym_umin] = ACTIONS(653),
    [anon_sym_fadd] = ACTIONS(653),
    [anon_sym_fsub] = ACTIONS(653),
    [anon_sym_bitcast] = ACTIONS(653),
    [anon_sym_trunc] = ACTIONS(653),
    [anon_sym_zext] = ACTIONS(653),
    [anon_sym_sext] = ACTIONS(653),
    [anon_sym_fptrunc] = ACTIONS(653),
    [anon_sym_fpext] = ACTIONS(653),
    [anon_sym_addrspacecast] = ACTIONS(653),
    [anon_sym_uitofp] = ACTIONS(653),
    [anon_sym_sitofp] = ACTIONS(653),
    [anon_sym_fptoui] = ACTIONS(653),
    [anon_sym_fptosi] = ACTIONS(653),
    [anon_sym_inttoptr] = ACTIONS(653),
    [anon_sym_ptrtoint] = ACTIONS(653),
    [anon_sym_unordered] = ACTIONS(653),
    [anon_sym_monotonic] = ACTIONS(653),
    [anon_sym_acquire] = ACTIONS(653),
    [anon_sym_release] = ACTIONS(653),
    [anon_sym_acq_rel] = ACTIONS(653),
    [anon_sym_seq_cst] = ACTIONS(653),
    [anon_sym_syncscope] = ACTIONS(653),
    [anon_sym_uselistorder] = ACTIONS(653),
  },
  [142] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(611),
    [sym_local_var] = ACTIONS(611),
    [sym_label] = ACTIONS(611),
    [sym_string] = ACTIONS(613),
    [anon_sym_RBRACE] = ACTIONS(611),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_align] = ACTIONS(613),
    [anon_sym_section] = ACTIONS(613),
    [anon_sym_partition] = ACTIONS(613),
    [anon_sym_comdat] = ACTIONS(613),
    [anon_sym_gc] = ACTIONS(613),
    [anon_sym_prefix] = ACTIONS(613),
    [anon_sym_prologue] = ACTIONS(613),
    [anon_sym_personality] = ACTIONS(613),
    [anon_sym_alignstack] = ACTIONS(613),
    [anon_sym_allocsize] = ACTIONS(613),
    [anon_sym_alwaysinline] = ACTIONS(613),
    [anon_sym_builtin] = ACTIONS(613),
    [anon_sym_cold] = ACTIONS(613),
    [anon_sym_convergent] = ACTIONS(613),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(613),
    [anon_sym_hot] = ACTIONS(613),
    [anon_sym_inaccessiblememonly] = ACTIONS(613),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(613),
    [anon_sym_inlinehint] = ACTIONS(613),
    [anon_sym_jumptable] = ACTIONS(613),
    [anon_sym_minsize] = ACTIONS(613),
    [anon_sym_naked] = ACTIONS(613),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(613),
    [anon_sym_nobuiltin] = ACTIONS(613),
    [anon_sym_noduplicate] = ACTIONS(613),
    [anon_sym_nofree] = ACTIONS(613),
    [anon_sym_noimplicitfloat] = ACTIONS(613),
    [anon_sym_noinline] = ACTIONS(613),
    [anon_sym_nomerge] = ACTIONS(613),
    [anon_sym_nonlazybind] = ACTIONS(613),
    [anon_sym_noprofile] = ACTIONS(613),
    [anon_sym_noredzone] = ACTIONS(613),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(613),
    [anon_sym_noreturn] = ACTIONS(613),
    [anon_sym_norecurse] = ACTIONS(613),
    [anon_sym_willreturn] = ACTIONS(613),
    [anon_sym_nosync] = ACTIONS(613),
    [anon_sym_nounwind] = ACTIONS(613),
    [anon_sym_nocallback] = ACTIONS(613),
    [anon_sym_nosanitize_coverage] = ACTIONS(613),
    [anon_sym_null_pointer_is_valid] = ACTIONS(613),
    [anon_sym_optforfuzzing] = ACTIONS(613),
    [anon_sym_optnone] = ACTIONS(613),
    [anon_sym_optsize] = ACTIONS(613),
    [anon_sym_readnone] = ACTIONS(613),
    [anon_sym_readonly] = ACTIONS(613),
    [anon_sym_writeonly] = ACTIONS(613),
    [anon_sym_argmemonly] = ACTIONS(613),
    [anon_sym_returns_twice] = ACTIONS(613),
    [anon_sym_safestack] = ACTIONS(613),
    [anon_sym_sanitize_address] = ACTIONS(613),
    [anon_sym_sanitize_memory] = ACTIONS(613),
    [anon_sym_sanitize_thread] = ACTIONS(613),
    [anon_sym_sanitize_hwaddress] = ACTIONS(613),
    [anon_sym_sanitize_memtag] = ACTIONS(613),
    [anon_sym_speculative_load_hardening] = ACTIONS(613),
    [anon_sym_speculatable] = ACTIONS(613),
    [anon_sym_ssp] = ACTIONS(613),
    [anon_sym_sspstrong] = ACTIONS(613),
    [anon_sym_sspreq] = ACTIONS(613),
    [anon_sym_strictfp] = ACTIONS(613),
    [anon_sym_nocf_check] = ACTIONS(613),
    [anon_sym_shadowcallstack] = ACTIONS(613),
    [anon_sym_mustprogress] = ACTIONS(613),
    [anon_sym_vscale_range] = ACTIONS(613),
    [anon_sym_preallocated] = ACTIONS(613),
    [anon_sym_zeroext] = ACTIONS(613),
    [anon_sym_signext] = ACTIONS(613),
    [anon_sym_inreg] = ACTIONS(613),
    [anon_sym_byval] = ACTIONS(613),
    [anon_sym_byref] = ACTIONS(613),
    [anon_sym_inalloca] = ACTIONS(613),
    [anon_sym_sret] = ACTIONS(613),
    [anon_sym_elementtype] = ACTIONS(613),
    [anon_sym_noalias] = ACTIONS(613),
    [anon_sym_nocapture] = ACTIONS(613),
    [anon_sym_nest] = ACTIONS(613),
    [anon_sym_returned] = ACTIONS(613),
    [anon_sym_nonnull] = ACTIONS(613),
    [anon_sym_dereferenceable] = ACTIONS(613),
    [anon_sym_dereferenceable_or_null] = ACTIONS(613),
    [anon_sym_swiftself] = ACTIONS(613),
    [anon_sym_swiftasync] = ACTIONS(613),
    [anon_sym_swifterror] = ACTIONS(613),
    [anon_sym_immarg] = ACTIONS(613),
    [anon_sym_noundef] = ACTIONS(613),
    [anon_sym_uwtable] = ACTIONS(613),
    [anon_sym_memory] = ACTIONS(613),
    [anon_sym_unreachable] = ACTIONS(613),
    [anon_sym_ret] = ACTIONS(613),
    [anon_sym_br] = ACTIONS(613),
    [anon_sym_resume] = ACTIONS(613),
    [anon_sym_freeze] = ACTIONS(613),
    [anon_sym_indirectbr] = ACTIONS(613),
    [anon_sym_extractelement] = ACTIONS(613),
    [anon_sym_insertelement] = ACTIONS(613),
    [anon_sym_select] = ACTIONS(613),
    [anon_sym_shufflevector] = ACTIONS(613),
    [anon_sym_fneg] = ACTIONS(613),
    [anon_sym_switch] = ACTIONS(613),
    [anon_sym_invoke] = ACTIONS(613),
    [anon_sym_cleanupret] = ACTIONS(613),
    [anon_sym_catchret] = ACTIONS(613),
    [anon_sym_catchswitch] = ACTIONS(613),
    [anon_sym_catchpad] = ACTIONS(613),
    [anon_sym_cleanuppad] = ACTIONS(613),
    [anon_sym_callbr] = ACTIONS(613),
    [anon_sym_icmp] = ACTIONS(613),
    [anon_sym_fcmp] = ACTIONS(613),
    [anon_sym_va_arg] = ACTIONS(613),
    [anon_sym_phi] = ACTIONS(613),
    [anon_sym_landingpad] = ACTIONS(613),
    [anon_sym_tail] = ACTIONS(613),
    [anon_sym_musttail] = ACTIONS(613),
    [anon_sym_notail] = ACTIONS(613),
    [anon_sym_call] = ACTIONS(613),
    [anon_sym_alloca] = ACTIONS(613),
    [anon_sym_load] = ACTIONS(613),
    [anon_sym_store] = ACTIONS(613),
    [anon_sym_cmpxchg] = ACTIONS(613),
    [anon_sym_atomicrmw] = ACTIONS(613),
    [anon_sym_fence] = ACTIONS(613),
    [anon_sym_getelementptr] = ACTIONS(613),
    [anon_sym_extractvalue] = ACTIONS(613),
    [anon_sym_insertvalue] = ACTIONS(613),
    [anon_sym_catch] = ACTIONS(613),
    [anon_sym_filter] = ACTIONS(613),
    [anon_sym_mul] = ACTIONS(613),
    [anon_sym_urem] = ACTIONS(613),
    [anon_sym_srem] = ACTIONS(613),
    [anon_sym_shl] = ACTIONS(613),
    [anon_sym_udiv] = ACTIONS(613),
    [anon_sym_sdiv] = ACTIONS(613),
    [anon_sym_lshr] = ACTIONS(613),
    [anon_sym_ashr] = ACTIONS(613),
    [anon_sym_fmul] = ACTIONS(613),
    [anon_sym_fdiv] = ACTIONS(613),
    [anon_sym_frem] = ACTIONS(613),
    [anon_sym_xchg] = ACTIONS(613),
    [anon_sym_add] = ACTIONS(613),
    [anon_sym_sub] = ACTIONS(613),
    [anon_sym_and] = ACTIONS(613),
    [anon_sym_nand] = ACTIONS(613),
    [anon_sym_or] = ACTIONS(613),
    [anon_sym_xor] = ACTIONS(613),
    [anon_sym_max] = ACTIONS(613),
    [anon_sym_min] = ACTIONS(613),
    [anon_sym_umax] = ACTIONS(613),
    [anon_sym_umin] = ACTIONS(613),
    [anon_sym_fadd] = ACTIONS(613),
    [anon_sym_fsub] = ACTIONS(613),
    [anon_sym_bitcast] = ACTIONS(613),
    [anon_sym_trunc] = ACTIONS(613),
    [anon_sym_zext] = ACTIONS(613),
    [anon_sym_sext] = ACTIONS(613),
    [anon_sym_fptrunc] = ACTIONS(613),
    [anon_sym_fpext] = ACTIONS(613),
    [anon_sym_addrspacecast] = ACTIONS(613),
    [anon_sym_uitofp] = ACTIONS(613),
    [anon_sym_sitofp] = ACTIONS(613),
    [anon_sym_fptoui] = ACTIONS(613),
    [anon_sym_fptosi] = ACTIONS(613),
    [anon_sym_inttoptr] = ACTIONS(613),
    [anon_sym_ptrtoint] = ACTIONS(613),
    [anon_sym_unordered] = ACTIONS(613),
    [anon_sym_monotonic] = ACTIONS(613),
    [anon_sym_acquire] = ACTIONS(613),
    [anon_sym_release] = ACTIONS(613),
    [anon_sym_acq_rel] = ACTIONS(613),
    [anon_sym_seq_cst] = ACTIONS(613),
    [anon_sym_syncscope] = ACTIONS(613),
    [anon_sym_uselistorder] = ACTIONS(613),
  },
  [143] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(549),
    [sym_local_var] = ACTIONS(549),
    [sym_label] = ACTIONS(549),
    [sym_string] = ACTIONS(551),
    [anon_sym_RBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(549),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_align] = ACTIONS(551),
    [anon_sym_section] = ACTIONS(551),
    [anon_sym_partition] = ACTIONS(551),
    [anon_sym_comdat] = ACTIONS(551),
    [anon_sym_gc] = ACTIONS(551),
    [anon_sym_prefix] = ACTIONS(551),
    [anon_sym_prologue] = ACTIONS(551),
    [anon_sym_personality] = ACTIONS(551),
    [anon_sym_alignstack] = ACTIONS(551),
    [anon_sym_allocsize] = ACTIONS(551),
    [anon_sym_alwaysinline] = ACTIONS(551),
    [anon_sym_builtin] = ACTIONS(551),
    [anon_sym_cold] = ACTIONS(551),
    [anon_sym_convergent] = ACTIONS(551),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(551),
    [anon_sym_hot] = ACTIONS(551),
    [anon_sym_inaccessiblememonly] = ACTIONS(551),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(551),
    [anon_sym_inlinehint] = ACTIONS(551),
    [anon_sym_jumptable] = ACTIONS(551),
    [anon_sym_minsize] = ACTIONS(551),
    [anon_sym_naked] = ACTIONS(551),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(551),
    [anon_sym_nobuiltin] = ACTIONS(551),
    [anon_sym_noduplicate] = ACTIONS(551),
    [anon_sym_nofree] = ACTIONS(551),
    [anon_sym_noimplicitfloat] = ACTIONS(551),
    [anon_sym_noinline] = ACTIONS(551),
    [anon_sym_nomerge] = ACTIONS(551),
    [anon_sym_nonlazybind] = ACTIONS(551),
    [anon_sym_noprofile] = ACTIONS(551),
    [anon_sym_noredzone] = ACTIONS(551),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(551),
    [anon_sym_noreturn] = ACTIONS(551),
    [anon_sym_norecurse] = ACTIONS(551),
    [anon_sym_willreturn] = ACTIONS(551),
    [anon_sym_nosync] = ACTIONS(551),
    [anon_sym_nounwind] = ACTIONS(551),
    [anon_sym_nocallback] = ACTIONS(551),
    [anon_sym_nosanitize_coverage] = ACTIONS(551),
    [anon_sym_null_pointer_is_valid] = ACTIONS(551),
    [anon_sym_optforfuzzing] = ACTIONS(551),
    [anon_sym_optnone] = ACTIONS(551),
    [anon_sym_optsize] = ACTIONS(551),
    [anon_sym_readnone] = ACTIONS(551),
    [anon_sym_readonly] = ACTIONS(551),
    [anon_sym_writeonly] = ACTIONS(551),
    [anon_sym_argmemonly] = ACTIONS(551),
    [anon_sym_returns_twice] = ACTIONS(551),
    [anon_sym_safestack] = ACTIONS(551),
    [anon_sym_sanitize_address] = ACTIONS(551),
    [anon_sym_sanitize_memory] = ACTIONS(551),
    [anon_sym_sanitize_thread] = ACTIONS(551),
    [anon_sym_sanitize_hwaddress] = ACTIONS(551),
    [anon_sym_sanitize_memtag] = ACTIONS(551),
    [anon_sym_speculative_load_hardening] = ACTIONS(551),
    [anon_sym_speculatable] = ACTIONS(551),
    [anon_sym_ssp] = ACTIONS(551),
    [anon_sym_sspstrong] = ACTIONS(551),
    [anon_sym_sspreq] = ACTIONS(551),
    [anon_sym_strictfp] = ACTIONS(551),
    [anon_sym_nocf_check] = ACTIONS(551),
    [anon_sym_shadowcallstack] = ACTIONS(551),
    [anon_sym_mustprogress] = ACTIONS(551),
    [anon_sym_vscale_range] = ACTIONS(551),
    [anon_sym_preallocated] = ACTIONS(551),
    [anon_sym_zeroext] = ACTIONS(551),
    [anon_sym_signext] = ACTIONS(551),
    [anon_sym_inreg] = ACTIONS(551),
    [anon_sym_byval] = ACTIONS(551),
    [anon_sym_byref] = ACTIONS(551),
    [anon_sym_inalloca] = ACTIONS(551),
    [anon_sym_sret] = ACTIONS(551),
    [anon_sym_elementtype] = ACTIONS(551),
    [anon_sym_noalias] = ACTIONS(551),
    [anon_sym_nocapture] = ACTIONS(551),
    [anon_sym_nest] = ACTIONS(551),
    [anon_sym_returned] = ACTIONS(551),
    [anon_sym_nonnull] = ACTIONS(551),
    [anon_sym_dereferenceable] = ACTIONS(551),
    [anon_sym_dereferenceable_or_null] = ACTIONS(551),
    [anon_sym_swiftself] = ACTIONS(551),
    [anon_sym_swiftasync] = ACTIONS(551),
    [anon_sym_swifterror] = ACTIONS(551),
    [anon_sym_immarg] = ACTIONS(551),
    [anon_sym_noundef] = ACTIONS(551),
    [anon_sym_uwtable] = ACTIONS(551),
    [anon_sym_memory] = ACTIONS(551),
    [anon_sym_unreachable] = ACTIONS(551),
    [anon_sym_ret] = ACTIONS(551),
    [anon_sym_br] = ACTIONS(551),
    [anon_sym_resume] = ACTIONS(551),
    [anon_sym_freeze] = ACTIONS(551),
    [anon_sym_indirectbr] = ACTIONS(551),
    [anon_sym_extractelement] = ACTIONS(551),
    [anon_sym_insertelement] = ACTIONS(551),
    [anon_sym_select] = ACTIONS(551),
    [anon_sym_shufflevector] = ACTIONS(551),
    [anon_sym_fneg] = ACTIONS(551),
    [anon_sym_switch] = ACTIONS(551),
    [anon_sym_invoke] = ACTIONS(551),
    [anon_sym_cleanupret] = ACTIONS(551),
    [anon_sym_catchret] = ACTIONS(551),
    [anon_sym_catchswitch] = ACTIONS(551),
    [anon_sym_catchpad] = ACTIONS(551),
    [anon_sym_cleanuppad] = ACTIONS(551),
    [anon_sym_callbr] = ACTIONS(551),
    [anon_sym_icmp] = ACTIONS(551),
    [anon_sym_fcmp] = ACTIONS(551),
    [anon_sym_va_arg] = ACTIONS(551),
    [anon_sym_phi] = ACTIONS(551),
    [anon_sym_landingpad] = ACTIONS(551),
    [anon_sym_tail] = ACTIONS(551),
    [anon_sym_musttail] = ACTIONS(551),
    [anon_sym_notail] = ACTIONS(551),
    [anon_sym_call] = ACTIONS(551),
    [anon_sym_alloca] = ACTIONS(551),
    [anon_sym_load] = ACTIONS(551),
    [anon_sym_store] = ACTIONS(551),
    [anon_sym_cmpxchg] = ACTIONS(551),
    [anon_sym_atomicrmw] = ACTIONS(551),
    [anon_sym_fence] = ACTIONS(551),
    [anon_sym_getelementptr] = ACTIONS(551),
    [anon_sym_extractvalue] = ACTIONS(551),
    [anon_sym_insertvalue] = ACTIONS(551),
    [anon_sym_catch] = ACTIONS(551),
    [anon_sym_filter] = ACTIONS(551),
    [anon_sym_mul] = ACTIONS(551),
    [anon_sym_urem] = ACTIONS(551),
    [anon_sym_srem] = ACTIONS(551),
    [anon_sym_shl] = ACTIONS(551),
    [anon_sym_udiv] = ACTIONS(551),
    [anon_sym_sdiv] = ACTIONS(551),
    [anon_sym_lshr] = ACTIONS(551),
    [anon_sym_ashr] = ACTIONS(551),
    [anon_sym_fmul] = ACTIONS(551),
    [anon_sym_fdiv] = ACTIONS(551),
    [anon_sym_frem] = ACTIONS(551),
    [anon_sym_xchg] = ACTIONS(551),
    [anon_sym_add] = ACTIONS(551),
    [anon_sym_sub] = ACTIONS(551),
    [anon_sym_and] = ACTIONS(551),
    [anon_sym_nand] = ACTIONS(551),
    [anon_sym_or] = ACTIONS(551),
    [anon_sym_xor] = ACTIONS(551),
    [anon_sym_max] = ACTIONS(551),
    [anon_sym_min] = ACTIONS(551),
    [anon_sym_umax] = ACTIONS(551),
    [anon_sym_umin] = ACTIONS(551),
    [anon_sym_fadd] = ACTIONS(551),
    [anon_sym_fsub] = ACTIONS(551),
    [anon_sym_bitcast] = ACTIONS(551),
    [anon_sym_trunc] = ACTIONS(551),
    [anon_sym_zext] = ACTIONS(551),
    [anon_sym_sext] = ACTIONS(551),
    [anon_sym_fptrunc] = ACTIONS(551),
    [anon_sym_fpext] = ACTIONS(551),
    [anon_sym_addrspacecast] = ACTIONS(551),
    [anon_sym_uitofp] = ACTIONS(551),
    [anon_sym_sitofp] = ACTIONS(551),
    [anon_sym_fptoui] = ACTIONS(551),
    [anon_sym_fptosi] = ACTIONS(551),
    [anon_sym_inttoptr] = ACTIONS(551),
    [anon_sym_ptrtoint] = ACTIONS(551),
    [anon_sym_unordered] = ACTIONS(551),
    [anon_sym_monotonic] = ACTIONS(551),
    [anon_sym_acquire] = ACTIONS(551),
    [anon_sym_release] = ACTIONS(551),
    [anon_sym_acq_rel] = ACTIONS(551),
    [anon_sym_seq_cst] = ACTIONS(551),
    [anon_sym_syncscope] = ACTIONS(551),
    [anon_sym_uselistorder] = ACTIONS(551),
  },
  [144] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(659),
    [sym_local_var] = ACTIONS(659),
    [sym_label] = ACTIONS(659),
    [sym_string] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_COMMA] = ACTIONS(659),
    [anon_sym_align] = ACTIONS(661),
    [anon_sym_section] = ACTIONS(661),
    [anon_sym_partition] = ACTIONS(661),
    [anon_sym_comdat] = ACTIONS(661),
    [anon_sym_gc] = ACTIONS(661),
    [anon_sym_prefix] = ACTIONS(661),
    [anon_sym_prologue] = ACTIONS(661),
    [anon_sym_personality] = ACTIONS(661),
    [anon_sym_alignstack] = ACTIONS(661),
    [anon_sym_allocsize] = ACTIONS(661),
    [anon_sym_alwaysinline] = ACTIONS(661),
    [anon_sym_builtin] = ACTIONS(661),
    [anon_sym_cold] = ACTIONS(661),
    [anon_sym_convergent] = ACTIONS(661),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(661),
    [anon_sym_hot] = ACTIONS(661),
    [anon_sym_inaccessiblememonly] = ACTIONS(661),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(661),
    [anon_sym_inlinehint] = ACTIONS(661),
    [anon_sym_jumptable] = ACTIONS(661),
    [anon_sym_minsize] = ACTIONS(661),
    [anon_sym_naked] = ACTIONS(661),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(661),
    [anon_sym_nobuiltin] = ACTIONS(661),
    [anon_sym_noduplicate] = ACTIONS(661),
    [anon_sym_nofree] = ACTIONS(661),
    [anon_sym_noimplicitfloat] = ACTIONS(661),
    [anon_sym_noinline] = ACTIONS(661),
    [anon_sym_nomerge] = ACTIONS(661),
    [anon_sym_nonlazybind] = ACTIONS(661),
    [anon_sym_noprofile] = ACTIONS(661),
    [anon_sym_noredzone] = ACTIONS(661),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(661),
    [anon_sym_noreturn] = ACTIONS(661),
    [anon_sym_norecurse] = ACTIONS(661),
    [anon_sym_willreturn] = ACTIONS(661),
    [anon_sym_nosync] = ACTIONS(661),
    [anon_sym_nounwind] = ACTIONS(661),
    [anon_sym_nocallback] = ACTIONS(661),
    [anon_sym_nosanitize_coverage] = ACTIONS(661),
    [anon_sym_null_pointer_is_valid] = ACTIONS(661),
    [anon_sym_optforfuzzing] = ACTIONS(661),
    [anon_sym_optnone] = ACTIONS(661),
    [anon_sym_optsize] = ACTIONS(661),
    [anon_sym_readnone] = ACTIONS(661),
    [anon_sym_readonly] = ACTIONS(661),
    [anon_sym_writeonly] = ACTIONS(661),
    [anon_sym_argmemonly] = ACTIONS(661),
    [anon_sym_returns_twice] = ACTIONS(661),
    [anon_sym_safestack] = ACTIONS(661),
    [anon_sym_sanitize_address] = ACTIONS(661),
    [anon_sym_sanitize_memory] = ACTIONS(661),
    [anon_sym_sanitize_thread] = ACTIONS(661),
    [anon_sym_sanitize_hwaddress] = ACTIONS(661),
    [anon_sym_sanitize_memtag] = ACTIONS(661),
    [anon_sym_speculative_load_hardening] = ACTIONS(661),
    [anon_sym_speculatable] = ACTIONS(661),
    [anon_sym_ssp] = ACTIONS(661),
    [anon_sym_sspstrong] = ACTIONS(661),
    [anon_sym_sspreq] = ACTIONS(661),
    [anon_sym_strictfp] = ACTIONS(661),
    [anon_sym_nocf_check] = ACTIONS(661),
    [anon_sym_shadowcallstack] = ACTIONS(661),
    [anon_sym_mustprogress] = ACTIONS(661),
    [anon_sym_vscale_range] = ACTIONS(661),
    [anon_sym_preallocated] = ACTIONS(661),
    [anon_sym_zeroext] = ACTIONS(661),
    [anon_sym_signext] = ACTIONS(661),
    [anon_sym_inreg] = ACTIONS(661),
    [anon_sym_byval] = ACTIONS(661),
    [anon_sym_byref] = ACTIONS(661),
    [anon_sym_inalloca] = ACTIONS(661),
    [anon_sym_sret] = ACTIONS(661),
    [anon_sym_elementtype] = ACTIONS(661),
    [anon_sym_noalias] = ACTIONS(661),
    [anon_sym_nocapture] = ACTIONS(661),
    [anon_sym_nest] = ACTIONS(661),
    [anon_sym_returned] = ACTIONS(661),
    [anon_sym_nonnull] = ACTIONS(661),
    [anon_sym_dereferenceable] = ACTIONS(661),
    [anon_sym_dereferenceable_or_null] = ACTIONS(661),
    [anon_sym_swiftself] = ACTIONS(661),
    [anon_sym_swiftasync] = ACTIONS(661),
    [anon_sym_swifterror] = ACTIONS(661),
    [anon_sym_immarg] = ACTIONS(661),
    [anon_sym_noundef] = ACTIONS(661),
    [anon_sym_uwtable] = ACTIONS(661),
    [anon_sym_memory] = ACTIONS(661),
    [anon_sym_unreachable] = ACTIONS(661),
    [anon_sym_ret] = ACTIONS(661),
    [anon_sym_br] = ACTIONS(661),
    [anon_sym_resume] = ACTIONS(661),
    [anon_sym_freeze] = ACTIONS(661),
    [anon_sym_indirectbr] = ACTIONS(661),
    [anon_sym_extractelement] = ACTIONS(661),
    [anon_sym_insertelement] = ACTIONS(661),
    [anon_sym_select] = ACTIONS(661),
    [anon_sym_shufflevector] = ACTIONS(661),
    [anon_sym_fneg] = ACTIONS(661),
    [anon_sym_switch] = ACTIONS(661),
    [anon_sym_invoke] = ACTIONS(661),
    [anon_sym_cleanupret] = ACTIONS(661),
    [anon_sym_catchret] = ACTIONS(661),
    [anon_sym_catchswitch] = ACTIONS(661),
    [anon_sym_catchpad] = ACTIONS(661),
    [anon_sym_cleanuppad] = ACTIONS(661),
    [anon_sym_callbr] = ACTIONS(661),
    [anon_sym_icmp] = ACTIONS(661),
    [anon_sym_fcmp] = ACTIONS(661),
    [anon_sym_va_arg] = ACTIONS(661),
    [anon_sym_phi] = ACTIONS(661),
    [anon_sym_landingpad] = ACTIONS(661),
    [anon_sym_tail] = ACTIONS(661),
    [anon_sym_musttail] = ACTIONS(661),
    [anon_sym_notail] = ACTIONS(661),
    [anon_sym_call] = ACTIONS(661),
    [anon_sym_alloca] = ACTIONS(661),
    [anon_sym_load] = ACTIONS(661),
    [anon_sym_store] = ACTIONS(661),
    [anon_sym_cmpxchg] = ACTIONS(661),
    [anon_sym_atomicrmw] = ACTIONS(661),
    [anon_sym_fence] = ACTIONS(661),
    [anon_sym_getelementptr] = ACTIONS(661),
    [anon_sym_extractvalue] = ACTIONS(661),
    [anon_sym_insertvalue] = ACTIONS(661),
    [anon_sym_catch] = ACTIONS(661),
    [anon_sym_filter] = ACTIONS(661),
    [anon_sym_mul] = ACTIONS(661),
    [anon_sym_urem] = ACTIONS(661),
    [anon_sym_srem] = ACTIONS(661),
    [anon_sym_shl] = ACTIONS(661),
    [anon_sym_udiv] = ACTIONS(661),
    [anon_sym_sdiv] = ACTIONS(661),
    [anon_sym_lshr] = ACTIONS(661),
    [anon_sym_ashr] = ACTIONS(661),
    [anon_sym_fmul] = ACTIONS(661),
    [anon_sym_fdiv] = ACTIONS(661),
    [anon_sym_frem] = ACTIONS(661),
    [anon_sym_xchg] = ACTIONS(661),
    [anon_sym_add] = ACTIONS(661),
    [anon_sym_sub] = ACTIONS(661),
    [anon_sym_and] = ACTIONS(661),
    [anon_sym_nand] = ACTIONS(661),
    [anon_sym_or] = ACTIONS(661),
    [anon_sym_xor] = ACTIONS(661),
    [anon_sym_max] = ACTIONS(661),
    [anon_sym_min] = ACTIONS(661),
    [anon_sym_umax] = ACTIONS(661),
    [anon_sym_umin] = ACTIONS(661),
    [anon_sym_fadd] = ACTIONS(661),
    [anon_sym_fsub] = ACTIONS(661),
    [anon_sym_bitcast] = ACTIONS(661),
    [anon_sym_trunc] = ACTIONS(661),
    [anon_sym_zext] = ACTIONS(661),
    [anon_sym_sext] = ACTIONS(661),
    [anon_sym_fptrunc] = ACTIONS(661),
    [anon_sym_fpext] = ACTIONS(661),
    [anon_sym_addrspacecast] = ACTIONS(661),
    [anon_sym_uitofp] = ACTIONS(661),
    [anon_sym_sitofp] = ACTIONS(661),
    [anon_sym_fptoui] = ACTIONS(661),
    [anon_sym_fptosi] = ACTIONS(661),
    [anon_sym_inttoptr] = ACTIONS(661),
    [anon_sym_ptrtoint] = ACTIONS(661),
    [anon_sym_unordered] = ACTIONS(661),
    [anon_sym_monotonic] = ACTIONS(661),
    [anon_sym_acquire] = ACTIONS(661),
    [anon_sym_release] = ACTIONS(661),
    [anon_sym_acq_rel] = ACTIONS(661),
    [anon_sym_seq_cst] = ACTIONS(661),
    [anon_sym_syncscope] = ACTIONS(661),
    [anon_sym_uselistorder] = ACTIONS(661),
  },
  [145] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(705),
    [sym_local_var] = ACTIONS(705),
    [sym_label] = ACTIONS(705),
    [sym_string] = ACTIONS(707),
    [anon_sym_RBRACE] = ACTIONS(705),
    [anon_sym_LBRACK] = ACTIONS(705),
    [anon_sym_COMMA] = ACTIONS(705),
    [anon_sym_align] = ACTIONS(707),
    [anon_sym_section] = ACTIONS(707),
    [anon_sym_partition] = ACTIONS(707),
    [anon_sym_comdat] = ACTIONS(707),
    [anon_sym_gc] = ACTIONS(707),
    [anon_sym_prefix] = ACTIONS(707),
    [anon_sym_prologue] = ACTIONS(707),
    [anon_sym_personality] = ACTIONS(707),
    [anon_sym_alignstack] = ACTIONS(707),
    [anon_sym_allocsize] = ACTIONS(707),
    [anon_sym_alwaysinline] = ACTIONS(707),
    [anon_sym_builtin] = ACTIONS(707),
    [anon_sym_cold] = ACTIONS(707),
    [anon_sym_convergent] = ACTIONS(707),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(707),
    [anon_sym_hot] = ACTIONS(707),
    [anon_sym_inaccessiblememonly] = ACTIONS(707),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(707),
    [anon_sym_inlinehint] = ACTIONS(707),
    [anon_sym_jumptable] = ACTIONS(707),
    [anon_sym_minsize] = ACTIONS(707),
    [anon_sym_naked] = ACTIONS(707),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(707),
    [anon_sym_nobuiltin] = ACTIONS(707),
    [anon_sym_noduplicate] = ACTIONS(707),
    [anon_sym_nofree] = ACTIONS(707),
    [anon_sym_noimplicitfloat] = ACTIONS(707),
    [anon_sym_noinline] = ACTIONS(707),
    [anon_sym_nomerge] = ACTIONS(707),
    [anon_sym_nonlazybind] = ACTIONS(707),
    [anon_sym_noprofile] = ACTIONS(707),
    [anon_sym_noredzone] = ACTIONS(707),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(707),
    [anon_sym_noreturn] = ACTIONS(707),
    [anon_sym_norecurse] = ACTIONS(707),
    [anon_sym_willreturn] = ACTIONS(707),
    [anon_sym_nosync] = ACTIONS(707),
    [anon_sym_nounwind] = ACTIONS(707),
    [anon_sym_nocallback] = ACTIONS(707),
    [anon_sym_nosanitize_coverage] = ACTIONS(707),
    [anon_sym_null_pointer_is_valid] = ACTIONS(707),
    [anon_sym_optforfuzzing] = ACTIONS(707),
    [anon_sym_optnone] = ACTIONS(707),
    [anon_sym_optsize] = ACTIONS(707),
    [anon_sym_readnone] = ACTIONS(707),
    [anon_sym_readonly] = ACTIONS(707),
    [anon_sym_writeonly] = ACTIONS(707),
    [anon_sym_argmemonly] = ACTIONS(707),
    [anon_sym_returns_twice] = ACTIONS(707),
    [anon_sym_safestack] = ACTIONS(707),
    [anon_sym_sanitize_address] = ACTIONS(707),
    [anon_sym_sanitize_memory] = ACTIONS(707),
    [anon_sym_sanitize_thread] = ACTIONS(707),
    [anon_sym_sanitize_hwaddress] = ACTIONS(707),
    [anon_sym_sanitize_memtag] = ACTIONS(707),
    [anon_sym_speculative_load_hardening] = ACTIONS(707),
    [anon_sym_speculatable] = ACTIONS(707),
    [anon_sym_ssp] = ACTIONS(707),
    [anon_sym_sspstrong] = ACTIONS(707),
    [anon_sym_sspreq] = ACTIONS(707),
    [anon_sym_strictfp] = ACTIONS(707),
    [anon_sym_nocf_check] = ACTIONS(707),
    [anon_sym_shadowcallstack] = ACTIONS(707),
    [anon_sym_mustprogress] = ACTIONS(707),
    [anon_sym_vscale_range] = ACTIONS(707),
    [anon_sym_preallocated] = ACTIONS(707),
    [anon_sym_zeroext] = ACTIONS(707),
    [anon_sym_signext] = ACTIONS(707),
    [anon_sym_inreg] = ACTIONS(707),
    [anon_sym_byval] = ACTIONS(707),
    [anon_sym_byref] = ACTIONS(707),
    [anon_sym_inalloca] = ACTIONS(707),
    [anon_sym_sret] = ACTIONS(707),
    [anon_sym_elementtype] = ACTIONS(707),
    [anon_sym_noalias] = ACTIONS(707),
    [anon_sym_nocapture] = ACTIONS(707),
    [anon_sym_nest] = ACTIONS(707),
    [anon_sym_returned] = ACTIONS(707),
    [anon_sym_nonnull] = ACTIONS(707),
    [anon_sym_dereferenceable] = ACTIONS(707),
    [anon_sym_dereferenceable_or_null] = ACTIONS(707),
    [anon_sym_swiftself] = ACTIONS(707),
    [anon_sym_swiftasync] = ACTIONS(707),
    [anon_sym_swifterror] = ACTIONS(707),
    [anon_sym_immarg] = ACTIONS(707),
    [anon_sym_noundef] = ACTIONS(707),
    [anon_sym_uwtable] = ACTIONS(707),
    [anon_sym_memory] = ACTIONS(707),
    [anon_sym_unreachable] = ACTIONS(707),
    [anon_sym_ret] = ACTIONS(707),
    [anon_sym_br] = ACTIONS(707),
    [anon_sym_resume] = ACTIONS(707),
    [anon_sym_freeze] = ACTIONS(707),
    [anon_sym_indirectbr] = ACTIONS(707),
    [anon_sym_extractelement] = ACTIONS(707),
    [anon_sym_insertelement] = ACTIONS(707),
    [anon_sym_select] = ACTIONS(707),
    [anon_sym_shufflevector] = ACTIONS(707),
    [anon_sym_fneg] = ACTIONS(707),
    [anon_sym_switch] = ACTIONS(707),
    [anon_sym_invoke] = ACTIONS(707),
    [anon_sym_cleanupret] = ACTIONS(707),
    [anon_sym_catchret] = ACTIONS(707),
    [anon_sym_catchswitch] = ACTIONS(707),
    [anon_sym_catchpad] = ACTIONS(707),
    [anon_sym_cleanuppad] = ACTIONS(707),
    [anon_sym_callbr] = ACTIONS(707),
    [anon_sym_icmp] = ACTIONS(707),
    [anon_sym_fcmp] = ACTIONS(707),
    [anon_sym_va_arg] = ACTIONS(707),
    [anon_sym_phi] = ACTIONS(707),
    [anon_sym_landingpad] = ACTIONS(707),
    [anon_sym_tail] = ACTIONS(707),
    [anon_sym_musttail] = ACTIONS(707),
    [anon_sym_notail] = ACTIONS(707),
    [anon_sym_call] = ACTIONS(707),
    [anon_sym_alloca] = ACTIONS(707),
    [anon_sym_load] = ACTIONS(707),
    [anon_sym_store] = ACTIONS(707),
    [anon_sym_cmpxchg] = ACTIONS(707),
    [anon_sym_atomicrmw] = ACTIONS(707),
    [anon_sym_fence] = ACTIONS(707),
    [anon_sym_getelementptr] = ACTIONS(707),
    [anon_sym_extractvalue] = ACTIONS(707),
    [anon_sym_insertvalue] = ACTIONS(707),
    [anon_sym_catch] = ACTIONS(707),
    [anon_sym_filter] = ACTIONS(707),
    [anon_sym_mul] = ACTIONS(707),
    [anon_sym_urem] = ACTIONS(707),
    [anon_sym_srem] = ACTIONS(707),
    [anon_sym_shl] = ACTIONS(707),
    [anon_sym_udiv] = ACTIONS(707),
    [anon_sym_sdiv] = ACTIONS(707),
    [anon_sym_lshr] = ACTIONS(707),
    [anon_sym_ashr] = ACTIONS(707),
    [anon_sym_fmul] = ACTIONS(707),
    [anon_sym_fdiv] = ACTIONS(707),
    [anon_sym_frem] = ACTIONS(707),
    [anon_sym_xchg] = ACTIONS(707),
    [anon_sym_add] = ACTIONS(707),
    [anon_sym_sub] = ACTIONS(707),
    [anon_sym_and] = ACTIONS(707),
    [anon_sym_nand] = ACTIONS(707),
    [anon_sym_or] = ACTIONS(707),
    [anon_sym_xor] = ACTIONS(707),
    [anon_sym_max] = ACTIONS(707),
    [anon_sym_min] = ACTIONS(707),
    [anon_sym_umax] = ACTIONS(707),
    [anon_sym_umin] = ACTIONS(707),
    [anon_sym_fadd] = ACTIONS(707),
    [anon_sym_fsub] = ACTIONS(707),
    [anon_sym_bitcast] = ACTIONS(707),
    [anon_sym_trunc] = ACTIONS(707),
    [anon_sym_zext] = ACTIONS(707),
    [anon_sym_sext] = ACTIONS(707),
    [anon_sym_fptrunc] = ACTIONS(707),
    [anon_sym_fpext] = ACTIONS(707),
    [anon_sym_addrspacecast] = ACTIONS(707),
    [anon_sym_uitofp] = ACTIONS(707),
    [anon_sym_sitofp] = ACTIONS(707),
    [anon_sym_fptoui] = ACTIONS(707),
    [anon_sym_fptosi] = ACTIONS(707),
    [anon_sym_inttoptr] = ACTIONS(707),
    [anon_sym_ptrtoint] = ACTIONS(707),
    [anon_sym_unordered] = ACTIONS(707),
    [anon_sym_monotonic] = ACTIONS(707),
    [anon_sym_acquire] = ACTIONS(707),
    [anon_sym_release] = ACTIONS(707),
    [anon_sym_acq_rel] = ACTIONS(707),
    [anon_sym_seq_cst] = ACTIONS(707),
    [anon_sym_syncscope] = ACTIONS(707),
    [anon_sym_uselistorder] = ACTIONS(707),
  },
  [146] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(655),
    [sym_local_var] = ACTIONS(655),
    [sym_label] = ACTIONS(655),
    [sym_string] = ACTIONS(657),
    [anon_sym_RBRACE] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_COMMA] = ACTIONS(655),
    [anon_sym_align] = ACTIONS(657),
    [anon_sym_section] = ACTIONS(657),
    [anon_sym_partition] = ACTIONS(657),
    [anon_sym_comdat] = ACTIONS(657),
    [anon_sym_gc] = ACTIONS(657),
    [anon_sym_prefix] = ACTIONS(657),
    [anon_sym_prologue] = ACTIONS(657),
    [anon_sym_personality] = ACTIONS(657),
    [anon_sym_alignstack] = ACTIONS(657),
    [anon_sym_allocsize] = ACTIONS(657),
    [anon_sym_alwaysinline] = ACTIONS(657),
    [anon_sym_builtin] = ACTIONS(657),
    [anon_sym_cold] = ACTIONS(657),
    [anon_sym_convergent] = ACTIONS(657),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(657),
    [anon_sym_hot] = ACTIONS(657),
    [anon_sym_inaccessiblememonly] = ACTIONS(657),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(657),
    [anon_sym_inlinehint] = ACTIONS(657),
    [anon_sym_jumptable] = ACTIONS(657),
    [anon_sym_minsize] = ACTIONS(657),
    [anon_sym_naked] = ACTIONS(657),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(657),
    [anon_sym_nobuiltin] = ACTIONS(657),
    [anon_sym_noduplicate] = ACTIONS(657),
    [anon_sym_nofree] = ACTIONS(657),
    [anon_sym_noimplicitfloat] = ACTIONS(657),
    [anon_sym_noinline] = ACTIONS(657),
    [anon_sym_nomerge] = ACTIONS(657),
    [anon_sym_nonlazybind] = ACTIONS(657),
    [anon_sym_noprofile] = ACTIONS(657),
    [anon_sym_noredzone] = ACTIONS(657),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(657),
    [anon_sym_noreturn] = ACTIONS(657),
    [anon_sym_norecurse] = ACTIONS(657),
    [anon_sym_willreturn] = ACTIONS(657),
    [anon_sym_nosync] = ACTIONS(657),
    [anon_sym_nounwind] = ACTIONS(657),
    [anon_sym_nocallback] = ACTIONS(657),
    [anon_sym_nosanitize_coverage] = ACTIONS(657),
    [anon_sym_null_pointer_is_valid] = ACTIONS(657),
    [anon_sym_optforfuzzing] = ACTIONS(657),
    [anon_sym_optnone] = ACTIONS(657),
    [anon_sym_optsize] = ACTIONS(657),
    [anon_sym_readnone] = ACTIONS(657),
    [anon_sym_readonly] = ACTIONS(657),
    [anon_sym_writeonly] = ACTIONS(657),
    [anon_sym_argmemonly] = ACTIONS(657),
    [anon_sym_returns_twice] = ACTIONS(657),
    [anon_sym_safestack] = ACTIONS(657),
    [anon_sym_sanitize_address] = ACTIONS(657),
    [anon_sym_sanitize_memory] = ACTIONS(657),
    [anon_sym_sanitize_thread] = ACTIONS(657),
    [anon_sym_sanitize_hwaddress] = ACTIONS(657),
    [anon_sym_sanitize_memtag] = ACTIONS(657),
    [anon_sym_speculative_load_hardening] = ACTIONS(657),
    [anon_sym_speculatable] = ACTIONS(657),
    [anon_sym_ssp] = ACTIONS(657),
    [anon_sym_sspstrong] = ACTIONS(657),
    [anon_sym_sspreq] = ACTIONS(657),
    [anon_sym_strictfp] = ACTIONS(657),
    [anon_sym_nocf_check] = ACTIONS(657),
    [anon_sym_shadowcallstack] = ACTIONS(657),
    [anon_sym_mustprogress] = ACTIONS(657),
    [anon_sym_vscale_range] = ACTIONS(657),
    [anon_sym_preallocated] = ACTIONS(657),
    [anon_sym_zeroext] = ACTIONS(657),
    [anon_sym_signext] = ACTIONS(657),
    [anon_sym_inreg] = ACTIONS(657),
    [anon_sym_byval] = ACTIONS(657),
    [anon_sym_byref] = ACTIONS(657),
    [anon_sym_inalloca] = ACTIONS(657),
    [anon_sym_sret] = ACTIONS(657),
    [anon_sym_elementtype] = ACTIONS(657),
    [anon_sym_noalias] = ACTIONS(657),
    [anon_sym_nocapture] = ACTIONS(657),
    [anon_sym_nest] = ACTIONS(657),
    [anon_sym_returned] = ACTIONS(657),
    [anon_sym_nonnull] = ACTIONS(657),
    [anon_sym_dereferenceable] = ACTIONS(657),
    [anon_sym_dereferenceable_or_null] = ACTIONS(657),
    [anon_sym_swiftself] = ACTIONS(657),
    [anon_sym_swiftasync] = ACTIONS(657),
    [anon_sym_swifterror] = ACTIONS(657),
    [anon_sym_immarg] = ACTIONS(657),
    [anon_sym_noundef] = ACTIONS(657),
    [anon_sym_uwtable] = ACTIONS(657),
    [anon_sym_memory] = ACTIONS(657),
    [anon_sym_unreachable] = ACTIONS(657),
    [anon_sym_ret] = ACTIONS(657),
    [anon_sym_br] = ACTIONS(657),
    [anon_sym_resume] = ACTIONS(657),
    [anon_sym_freeze] = ACTIONS(657),
    [anon_sym_indirectbr] = ACTIONS(657),
    [anon_sym_extractelement] = ACTIONS(657),
    [anon_sym_insertelement] = ACTIONS(657),
    [anon_sym_select] = ACTIONS(657),
    [anon_sym_shufflevector] = ACTIONS(657),
    [anon_sym_fneg] = ACTIONS(657),
    [anon_sym_switch] = ACTIONS(657),
    [anon_sym_invoke] = ACTIONS(657),
    [anon_sym_cleanupret] = ACTIONS(657),
    [anon_sym_catchret] = ACTIONS(657),
    [anon_sym_catchswitch] = ACTIONS(657),
    [anon_sym_catchpad] = ACTIONS(657),
    [anon_sym_cleanuppad] = ACTIONS(657),
    [anon_sym_callbr] = ACTIONS(657),
    [anon_sym_icmp] = ACTIONS(657),
    [anon_sym_fcmp] = ACTIONS(657),
    [anon_sym_va_arg] = ACTIONS(657),
    [anon_sym_phi] = ACTIONS(657),
    [anon_sym_landingpad] = ACTIONS(657),
    [anon_sym_tail] = ACTIONS(657),
    [anon_sym_musttail] = ACTIONS(657),
    [anon_sym_notail] = ACTIONS(657),
    [anon_sym_call] = ACTIONS(657),
    [anon_sym_alloca] = ACTIONS(657),
    [anon_sym_load] = ACTIONS(657),
    [anon_sym_store] = ACTIONS(657),
    [anon_sym_cmpxchg] = ACTIONS(657),
    [anon_sym_atomicrmw] = ACTIONS(657),
    [anon_sym_fence] = ACTIONS(657),
    [anon_sym_getelementptr] = ACTIONS(657),
    [anon_sym_extractvalue] = ACTIONS(657),
    [anon_sym_insertvalue] = ACTIONS(657),
    [anon_sym_catch] = ACTIONS(657),
    [anon_sym_filter] = ACTIONS(657),
    [anon_sym_mul] = ACTIONS(657),
    [anon_sym_urem] = ACTIONS(657),
    [anon_sym_srem] = ACTIONS(657),
    [anon_sym_shl] = ACTIONS(657),
    [anon_sym_udiv] = ACTIONS(657),
    [anon_sym_sdiv] = ACTIONS(657),
    [anon_sym_lshr] = ACTIONS(657),
    [anon_sym_ashr] = ACTIONS(657),
    [anon_sym_fmul] = ACTIONS(657),
    [anon_sym_fdiv] = ACTIONS(657),
    [anon_sym_frem] = ACTIONS(657),
    [anon_sym_xchg] = ACTIONS(657),
    [anon_sym_add] = ACTIONS(657),
    [anon_sym_sub] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(657),
    [anon_sym_nand] = ACTIONS(657),
    [anon_sym_or] = ACTIONS(657),
    [anon_sym_xor] = ACTIONS(657),
    [anon_sym_max] = ACTIONS(657),
    [anon_sym_min] = ACTIONS(657),
    [anon_sym_umax] = ACTIONS(657),
    [anon_sym_umin] = ACTIONS(657),
    [anon_sym_fadd] = ACTIONS(657),
    [anon_sym_fsub] = ACTIONS(657),
    [anon_sym_bitcast] = ACTIONS(657),
    [anon_sym_trunc] = ACTIONS(657),
    [anon_sym_zext] = ACTIONS(657),
    [anon_sym_sext] = ACTIONS(657),
    [anon_sym_fptrunc] = ACTIONS(657),
    [anon_sym_fpext] = ACTIONS(657),
    [anon_sym_addrspacecast] = ACTIONS(657),
    [anon_sym_uitofp] = ACTIONS(657),
    [anon_sym_sitofp] = ACTIONS(657),
    [anon_sym_fptoui] = ACTIONS(657),
    [anon_sym_fptosi] = ACTIONS(657),
    [anon_sym_inttoptr] = ACTIONS(657),
    [anon_sym_ptrtoint] = ACTIONS(657),
    [anon_sym_unordered] = ACTIONS(657),
    [anon_sym_monotonic] = ACTIONS(657),
    [anon_sym_acquire] = ACTIONS(657),
    [anon_sym_release] = ACTIONS(657),
    [anon_sym_acq_rel] = ACTIONS(657),
    [anon_sym_seq_cst] = ACTIONS(657),
    [anon_sym_syncscope] = ACTIONS(657),
    [anon_sym_uselistorder] = ACTIONS(657),
  },
  [147] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(553),
    [sym_local_var] = ACTIONS(553),
    [sym_label] = ACTIONS(553),
    [sym_string] = ACTIONS(555),
    [anon_sym_RBRACE] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_COMMA] = ACTIONS(553),
    [anon_sym_align] = ACTIONS(555),
    [anon_sym_section] = ACTIONS(555),
    [anon_sym_partition] = ACTIONS(555),
    [anon_sym_comdat] = ACTIONS(555),
    [anon_sym_gc] = ACTIONS(555),
    [anon_sym_prefix] = ACTIONS(555),
    [anon_sym_prologue] = ACTIONS(555),
    [anon_sym_personality] = ACTIONS(555),
    [anon_sym_alignstack] = ACTIONS(555),
    [anon_sym_allocsize] = ACTIONS(555),
    [anon_sym_alwaysinline] = ACTIONS(555),
    [anon_sym_builtin] = ACTIONS(555),
    [anon_sym_cold] = ACTIONS(555),
    [anon_sym_convergent] = ACTIONS(555),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(555),
    [anon_sym_hot] = ACTIONS(555),
    [anon_sym_inaccessiblememonly] = ACTIONS(555),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(555),
    [anon_sym_inlinehint] = ACTIONS(555),
    [anon_sym_jumptable] = ACTIONS(555),
    [anon_sym_minsize] = ACTIONS(555),
    [anon_sym_naked] = ACTIONS(555),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(555),
    [anon_sym_nobuiltin] = ACTIONS(555),
    [anon_sym_noduplicate] = ACTIONS(555),
    [anon_sym_nofree] = ACTIONS(555),
    [anon_sym_noimplicitfloat] = ACTIONS(555),
    [anon_sym_noinline] = ACTIONS(555),
    [anon_sym_nomerge] = ACTIONS(555),
    [anon_sym_nonlazybind] = ACTIONS(555),
    [anon_sym_noprofile] = ACTIONS(555),
    [anon_sym_noredzone] = ACTIONS(555),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(555),
    [anon_sym_noreturn] = ACTIONS(555),
    [anon_sym_norecurse] = ACTIONS(555),
    [anon_sym_willreturn] = ACTIONS(555),
    [anon_sym_nosync] = ACTIONS(555),
    [anon_sym_nounwind] = ACTIONS(555),
    [anon_sym_nocallback] = ACTIONS(555),
    [anon_sym_nosanitize_coverage] = ACTIONS(555),
    [anon_sym_null_pointer_is_valid] = ACTIONS(555),
    [anon_sym_optforfuzzing] = ACTIONS(555),
    [anon_sym_optnone] = ACTIONS(555),
    [anon_sym_optsize] = ACTIONS(555),
    [anon_sym_readnone] = ACTIONS(555),
    [anon_sym_readonly] = ACTIONS(555),
    [anon_sym_writeonly] = ACTIONS(555),
    [anon_sym_argmemonly] = ACTIONS(555),
    [anon_sym_returns_twice] = ACTIONS(555),
    [anon_sym_safestack] = ACTIONS(555),
    [anon_sym_sanitize_address] = ACTIONS(555),
    [anon_sym_sanitize_memory] = ACTIONS(555),
    [anon_sym_sanitize_thread] = ACTIONS(555),
    [anon_sym_sanitize_hwaddress] = ACTIONS(555),
    [anon_sym_sanitize_memtag] = ACTIONS(555),
    [anon_sym_speculative_load_hardening] = ACTIONS(555),
    [anon_sym_speculatable] = ACTIONS(555),
    [anon_sym_ssp] = ACTIONS(555),
    [anon_sym_sspstrong] = ACTIONS(555),
    [anon_sym_sspreq] = ACTIONS(555),
    [anon_sym_strictfp] = ACTIONS(555),
    [anon_sym_nocf_check] = ACTIONS(555),
    [anon_sym_shadowcallstack] = ACTIONS(555),
    [anon_sym_mustprogress] = ACTIONS(555),
    [anon_sym_vscale_range] = ACTIONS(555),
    [anon_sym_preallocated] = ACTIONS(555),
    [anon_sym_zeroext] = ACTIONS(555),
    [anon_sym_signext] = ACTIONS(555),
    [anon_sym_inreg] = ACTIONS(555),
    [anon_sym_byval] = ACTIONS(555),
    [anon_sym_byref] = ACTIONS(555),
    [anon_sym_inalloca] = ACTIONS(555),
    [anon_sym_sret] = ACTIONS(555),
    [anon_sym_elementtype] = ACTIONS(555),
    [anon_sym_noalias] = ACTIONS(555),
    [anon_sym_nocapture] = ACTIONS(555),
    [anon_sym_nest] = ACTIONS(555),
    [anon_sym_returned] = ACTIONS(555),
    [anon_sym_nonnull] = ACTIONS(555),
    [anon_sym_dereferenceable] = ACTIONS(555),
    [anon_sym_dereferenceable_or_null] = ACTIONS(555),
    [anon_sym_swiftself] = ACTIONS(555),
    [anon_sym_swiftasync] = ACTIONS(555),
    [anon_sym_swifterror] = ACTIONS(555),
    [anon_sym_immarg] = ACTIONS(555),
    [anon_sym_noundef] = ACTIONS(555),
    [anon_sym_uwtable] = ACTIONS(555),
    [anon_sym_memory] = ACTIONS(555),
    [anon_sym_unreachable] = ACTIONS(555),
    [anon_sym_ret] = ACTIONS(555),
    [anon_sym_br] = ACTIONS(555),
    [anon_sym_resume] = ACTIONS(555),
    [anon_sym_freeze] = ACTIONS(555),
    [anon_sym_indirectbr] = ACTIONS(555),
    [anon_sym_extractelement] = ACTIONS(555),
    [anon_sym_insertelement] = ACTIONS(555),
    [anon_sym_select] = ACTIONS(555),
    [anon_sym_shufflevector] = ACTIONS(555),
    [anon_sym_fneg] = ACTIONS(555),
    [anon_sym_switch] = ACTIONS(555),
    [anon_sym_invoke] = ACTIONS(555),
    [anon_sym_cleanupret] = ACTIONS(555),
    [anon_sym_catchret] = ACTIONS(555),
    [anon_sym_catchswitch] = ACTIONS(555),
    [anon_sym_catchpad] = ACTIONS(555),
    [anon_sym_cleanuppad] = ACTIONS(555),
    [anon_sym_callbr] = ACTIONS(555),
    [anon_sym_icmp] = ACTIONS(555),
    [anon_sym_fcmp] = ACTIONS(555),
    [anon_sym_va_arg] = ACTIONS(555),
    [anon_sym_phi] = ACTIONS(555),
    [anon_sym_landingpad] = ACTIONS(555),
    [anon_sym_tail] = ACTIONS(555),
    [anon_sym_musttail] = ACTIONS(555),
    [anon_sym_notail] = ACTIONS(555),
    [anon_sym_call] = ACTIONS(555),
    [anon_sym_alloca] = ACTIONS(555),
    [anon_sym_load] = ACTIONS(555),
    [anon_sym_store] = ACTIONS(555),
    [anon_sym_cmpxchg] = ACTIONS(555),
    [anon_sym_atomicrmw] = ACTIONS(555),
    [anon_sym_fence] = ACTIONS(555),
    [anon_sym_getelementptr] = ACTIONS(555),
    [anon_sym_extractvalue] = ACTIONS(555),
    [anon_sym_insertvalue] = ACTIONS(555),
    [anon_sym_catch] = ACTIONS(555),
    [anon_sym_filter] = ACTIONS(555),
    [anon_sym_mul] = ACTIONS(555),
    [anon_sym_urem] = ACTIONS(555),
    [anon_sym_srem] = ACTIONS(555),
    [anon_sym_shl] = ACTIONS(555),
    [anon_sym_udiv] = ACTIONS(555),
    [anon_sym_sdiv] = ACTIONS(555),
    [anon_sym_lshr] = ACTIONS(555),
    [anon_sym_ashr] = ACTIONS(555),
    [anon_sym_fmul] = ACTIONS(555),
    [anon_sym_fdiv] = ACTIONS(555),
    [anon_sym_frem] = ACTIONS(555),
    [anon_sym_xchg] = ACTIONS(555),
    [anon_sym_add] = ACTIONS(555),
    [anon_sym_sub] = ACTIONS(555),
    [anon_sym_and] = ACTIONS(555),
    [anon_sym_nand] = ACTIONS(555),
    [anon_sym_or] = ACTIONS(555),
    [anon_sym_xor] = ACTIONS(555),
    [anon_sym_max] = ACTIONS(555),
    [anon_sym_min] = ACTIONS(555),
    [anon_sym_umax] = ACTIONS(555),
    [anon_sym_umin] = ACTIONS(555),
    [anon_sym_fadd] = ACTIONS(555),
    [anon_sym_fsub] = ACTIONS(555),
    [anon_sym_bitcast] = ACTIONS(555),
    [anon_sym_trunc] = ACTIONS(555),
    [anon_sym_zext] = ACTIONS(555),
    [anon_sym_sext] = ACTIONS(555),
    [anon_sym_fptrunc] = ACTIONS(555),
    [anon_sym_fpext] = ACTIONS(555),
    [anon_sym_addrspacecast] = ACTIONS(555),
    [anon_sym_uitofp] = ACTIONS(555),
    [anon_sym_sitofp] = ACTIONS(555),
    [anon_sym_fptoui] = ACTIONS(555),
    [anon_sym_fptosi] = ACTIONS(555),
    [anon_sym_inttoptr] = ACTIONS(555),
    [anon_sym_ptrtoint] = ACTIONS(555),
    [anon_sym_unordered] = ACTIONS(555),
    [anon_sym_monotonic] = ACTIONS(555),
    [anon_sym_acquire] = ACTIONS(555),
    [anon_sym_release] = ACTIONS(555),
    [anon_sym_acq_rel] = ACTIONS(555),
    [anon_sym_seq_cst] = ACTIONS(555),
    [anon_sym_syncscope] = ACTIONS(555),
    [anon_sym_uselistorder] = ACTIONS(555),
  },
  [148] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(639),
    [sym_local_var] = ACTIONS(639),
    [sym_label] = ACTIONS(639),
    [sym_string] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_align] = ACTIONS(641),
    [anon_sym_section] = ACTIONS(641),
    [anon_sym_partition] = ACTIONS(641),
    [anon_sym_comdat] = ACTIONS(641),
    [anon_sym_gc] = ACTIONS(641),
    [anon_sym_prefix] = ACTIONS(641),
    [anon_sym_prologue] = ACTIONS(641),
    [anon_sym_personality] = ACTIONS(641),
    [anon_sym_alignstack] = ACTIONS(641),
    [anon_sym_allocsize] = ACTIONS(641),
    [anon_sym_alwaysinline] = ACTIONS(641),
    [anon_sym_builtin] = ACTIONS(641),
    [anon_sym_cold] = ACTIONS(641),
    [anon_sym_convergent] = ACTIONS(641),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(641),
    [anon_sym_hot] = ACTIONS(641),
    [anon_sym_inaccessiblememonly] = ACTIONS(641),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(641),
    [anon_sym_inlinehint] = ACTIONS(641),
    [anon_sym_jumptable] = ACTIONS(641),
    [anon_sym_minsize] = ACTIONS(641),
    [anon_sym_naked] = ACTIONS(641),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(641),
    [anon_sym_nobuiltin] = ACTIONS(641),
    [anon_sym_noduplicate] = ACTIONS(641),
    [anon_sym_nofree] = ACTIONS(641),
    [anon_sym_noimplicitfloat] = ACTIONS(641),
    [anon_sym_noinline] = ACTIONS(641),
    [anon_sym_nomerge] = ACTIONS(641),
    [anon_sym_nonlazybind] = ACTIONS(641),
    [anon_sym_noprofile] = ACTIONS(641),
    [anon_sym_noredzone] = ACTIONS(641),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(641),
    [anon_sym_noreturn] = ACTIONS(641),
    [anon_sym_norecurse] = ACTIONS(641),
    [anon_sym_willreturn] = ACTIONS(641),
    [anon_sym_nosync] = ACTIONS(641),
    [anon_sym_nounwind] = ACTIONS(641),
    [anon_sym_nocallback] = ACTIONS(641),
    [anon_sym_nosanitize_coverage] = ACTIONS(641),
    [anon_sym_null_pointer_is_valid] = ACTIONS(641),
    [anon_sym_optforfuzzing] = ACTIONS(641),
    [anon_sym_optnone] = ACTIONS(641),
    [anon_sym_optsize] = ACTIONS(641),
    [anon_sym_readnone] = ACTIONS(641),
    [anon_sym_readonly] = ACTIONS(641),
    [anon_sym_writeonly] = ACTIONS(641),
    [anon_sym_argmemonly] = ACTIONS(641),
    [anon_sym_returns_twice] = ACTIONS(641),
    [anon_sym_safestack] = ACTIONS(641),
    [anon_sym_sanitize_address] = ACTIONS(641),
    [anon_sym_sanitize_memory] = ACTIONS(641),
    [anon_sym_sanitize_thread] = ACTIONS(641),
    [anon_sym_sanitize_hwaddress] = ACTIONS(641),
    [anon_sym_sanitize_memtag] = ACTIONS(641),
    [anon_sym_speculative_load_hardening] = ACTIONS(641),
    [anon_sym_speculatable] = ACTIONS(641),
    [anon_sym_ssp] = ACTIONS(641),
    [anon_sym_sspstrong] = ACTIONS(641),
    [anon_sym_sspreq] = ACTIONS(641),
    [anon_sym_strictfp] = ACTIONS(641),
    [anon_sym_nocf_check] = ACTIONS(641),
    [anon_sym_shadowcallstack] = ACTIONS(641),
    [anon_sym_mustprogress] = ACTIONS(641),
    [anon_sym_vscale_range] = ACTIONS(641),
    [anon_sym_preallocated] = ACTIONS(641),
    [anon_sym_zeroext] = ACTIONS(641),
    [anon_sym_signext] = ACTIONS(641),
    [anon_sym_inreg] = ACTIONS(641),
    [anon_sym_byval] = ACTIONS(641),
    [anon_sym_byref] = ACTIONS(641),
    [anon_sym_inalloca] = ACTIONS(641),
    [anon_sym_sret] = ACTIONS(641),
    [anon_sym_elementtype] = ACTIONS(641),
    [anon_sym_noalias] = ACTIONS(641),
    [anon_sym_nocapture] = ACTIONS(641),
    [anon_sym_nest] = ACTIONS(641),
    [anon_sym_returned] = ACTIONS(641),
    [anon_sym_nonnull] = ACTIONS(641),
    [anon_sym_dereferenceable] = ACTIONS(641),
    [anon_sym_dereferenceable_or_null] = ACTIONS(641),
    [anon_sym_swiftself] = ACTIONS(641),
    [anon_sym_swiftasync] = ACTIONS(641),
    [anon_sym_swifterror] = ACTIONS(641),
    [anon_sym_immarg] = ACTIONS(641),
    [anon_sym_noundef] = ACTIONS(641),
    [anon_sym_uwtable] = ACTIONS(641),
    [anon_sym_memory] = ACTIONS(641),
    [anon_sym_unreachable] = ACTIONS(641),
    [anon_sym_ret] = ACTIONS(641),
    [anon_sym_br] = ACTIONS(641),
    [anon_sym_resume] = ACTIONS(641),
    [anon_sym_freeze] = ACTIONS(641),
    [anon_sym_indirectbr] = ACTIONS(641),
    [anon_sym_extractelement] = ACTIONS(641),
    [anon_sym_insertelement] = ACTIONS(641),
    [anon_sym_select] = ACTIONS(641),
    [anon_sym_shufflevector] = ACTIONS(641),
    [anon_sym_fneg] = ACTIONS(641),
    [anon_sym_switch] = ACTIONS(641),
    [anon_sym_invoke] = ACTIONS(641),
    [anon_sym_cleanupret] = ACTIONS(641),
    [anon_sym_catchret] = ACTIONS(641),
    [anon_sym_catchswitch] = ACTIONS(641),
    [anon_sym_catchpad] = ACTIONS(641),
    [anon_sym_cleanuppad] = ACTIONS(641),
    [anon_sym_callbr] = ACTIONS(641),
    [anon_sym_icmp] = ACTIONS(641),
    [anon_sym_fcmp] = ACTIONS(641),
    [anon_sym_va_arg] = ACTIONS(641),
    [anon_sym_phi] = ACTIONS(641),
    [anon_sym_landingpad] = ACTIONS(641),
    [anon_sym_tail] = ACTIONS(641),
    [anon_sym_musttail] = ACTIONS(641),
    [anon_sym_notail] = ACTIONS(641),
    [anon_sym_call] = ACTIONS(641),
    [anon_sym_alloca] = ACTIONS(641),
    [anon_sym_load] = ACTIONS(641),
    [anon_sym_store] = ACTIONS(641),
    [anon_sym_cmpxchg] = ACTIONS(641),
    [anon_sym_atomicrmw] = ACTIONS(641),
    [anon_sym_fence] = ACTIONS(641),
    [anon_sym_getelementptr] = ACTIONS(641),
    [anon_sym_extractvalue] = ACTIONS(641),
    [anon_sym_insertvalue] = ACTIONS(641),
    [anon_sym_catch] = ACTIONS(641),
    [anon_sym_filter] = ACTIONS(641),
    [anon_sym_mul] = ACTIONS(641),
    [anon_sym_urem] = ACTIONS(641),
    [anon_sym_srem] = ACTIONS(641),
    [anon_sym_shl] = ACTIONS(641),
    [anon_sym_udiv] = ACTIONS(641),
    [anon_sym_sdiv] = ACTIONS(641),
    [anon_sym_lshr] = ACTIONS(641),
    [anon_sym_ashr] = ACTIONS(641),
    [anon_sym_fmul] = ACTIONS(641),
    [anon_sym_fdiv] = ACTIONS(641),
    [anon_sym_frem] = ACTIONS(641),
    [anon_sym_xchg] = ACTIONS(641),
    [anon_sym_add] = ACTIONS(641),
    [anon_sym_sub] = ACTIONS(641),
    [anon_sym_and] = ACTIONS(641),
    [anon_sym_nand] = ACTIONS(641),
    [anon_sym_or] = ACTIONS(641),
    [anon_sym_xor] = ACTIONS(641),
    [anon_sym_max] = ACTIONS(641),
    [anon_sym_min] = ACTIONS(641),
    [anon_sym_umax] = ACTIONS(641),
    [anon_sym_umin] = ACTIONS(641),
    [anon_sym_fadd] = ACTIONS(641),
    [anon_sym_fsub] = ACTIONS(641),
    [anon_sym_bitcast] = ACTIONS(641),
    [anon_sym_trunc] = ACTIONS(641),
    [anon_sym_zext] = ACTIONS(641),
    [anon_sym_sext] = ACTIONS(641),
    [anon_sym_fptrunc] = ACTIONS(641),
    [anon_sym_fpext] = ACTIONS(641),
    [anon_sym_addrspacecast] = ACTIONS(641),
    [anon_sym_uitofp] = ACTIONS(641),
    [anon_sym_sitofp] = ACTIONS(641),
    [anon_sym_fptoui] = ACTIONS(641),
    [anon_sym_fptosi] = ACTIONS(641),
    [anon_sym_inttoptr] = ACTIONS(641),
    [anon_sym_ptrtoint] = ACTIONS(641),
    [anon_sym_unordered] = ACTIONS(641),
    [anon_sym_monotonic] = ACTIONS(641),
    [anon_sym_acquire] = ACTIONS(641),
    [anon_sym_release] = ACTIONS(641),
    [anon_sym_acq_rel] = ACTIONS(641),
    [anon_sym_seq_cst] = ACTIONS(641),
    [anon_sym_syncscope] = ACTIONS(641),
    [anon_sym_uselistorder] = ACTIONS(641),
  },
  [149] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(545),
    [sym_local_var] = ACTIONS(545),
    [sym_label] = ACTIONS(545),
    [sym_string] = ACTIONS(547),
    [anon_sym_RBRACE] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(545),
    [anon_sym_COMMA] = ACTIONS(545),
    [anon_sym_align] = ACTIONS(547),
    [anon_sym_section] = ACTIONS(547),
    [anon_sym_partition] = ACTIONS(547),
    [anon_sym_comdat] = ACTIONS(547),
    [anon_sym_gc] = ACTIONS(547),
    [anon_sym_prefix] = ACTIONS(547),
    [anon_sym_prologue] = ACTIONS(547),
    [anon_sym_personality] = ACTIONS(547),
    [anon_sym_alignstack] = ACTIONS(547),
    [anon_sym_allocsize] = ACTIONS(547),
    [anon_sym_alwaysinline] = ACTIONS(547),
    [anon_sym_builtin] = ACTIONS(547),
    [anon_sym_cold] = ACTIONS(547),
    [anon_sym_convergent] = ACTIONS(547),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(547),
    [anon_sym_hot] = ACTIONS(547),
    [anon_sym_inaccessiblememonly] = ACTIONS(547),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(547),
    [anon_sym_inlinehint] = ACTIONS(547),
    [anon_sym_jumptable] = ACTIONS(547),
    [anon_sym_minsize] = ACTIONS(547),
    [anon_sym_naked] = ACTIONS(547),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(547),
    [anon_sym_nobuiltin] = ACTIONS(547),
    [anon_sym_noduplicate] = ACTIONS(547),
    [anon_sym_nofree] = ACTIONS(547),
    [anon_sym_noimplicitfloat] = ACTIONS(547),
    [anon_sym_noinline] = ACTIONS(547),
    [anon_sym_nomerge] = ACTIONS(547),
    [anon_sym_nonlazybind] = ACTIONS(547),
    [anon_sym_noprofile] = ACTIONS(547),
    [anon_sym_noredzone] = ACTIONS(547),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(547),
    [anon_sym_noreturn] = ACTIONS(547),
    [anon_sym_norecurse] = ACTIONS(547),
    [anon_sym_willreturn] = ACTIONS(547),
    [anon_sym_nosync] = ACTIONS(547),
    [anon_sym_nounwind] = ACTIONS(547),
    [anon_sym_nocallback] = ACTIONS(547),
    [anon_sym_nosanitize_coverage] = ACTIONS(547),
    [anon_sym_null_pointer_is_valid] = ACTIONS(547),
    [anon_sym_optforfuzzing] = ACTIONS(547),
    [anon_sym_optnone] = ACTIONS(547),
    [anon_sym_optsize] = ACTIONS(547),
    [anon_sym_readnone] = ACTIONS(547),
    [anon_sym_readonly] = ACTIONS(547),
    [anon_sym_writeonly] = ACTIONS(547),
    [anon_sym_argmemonly] = ACTIONS(547),
    [anon_sym_returns_twice] = ACTIONS(547),
    [anon_sym_safestack] = ACTIONS(547),
    [anon_sym_sanitize_address] = ACTIONS(547),
    [anon_sym_sanitize_memory] = ACTIONS(547),
    [anon_sym_sanitize_thread] = ACTIONS(547),
    [anon_sym_sanitize_hwaddress] = ACTIONS(547),
    [anon_sym_sanitize_memtag] = ACTIONS(547),
    [anon_sym_speculative_load_hardening] = ACTIONS(547),
    [anon_sym_speculatable] = ACTIONS(547),
    [anon_sym_ssp] = ACTIONS(547),
    [anon_sym_sspstrong] = ACTIONS(547),
    [anon_sym_sspreq] = ACTIONS(547),
    [anon_sym_strictfp] = ACTIONS(547),
    [anon_sym_nocf_check] = ACTIONS(547),
    [anon_sym_shadowcallstack] = ACTIONS(547),
    [anon_sym_mustprogress] = ACTIONS(547),
    [anon_sym_vscale_range] = ACTIONS(547),
    [anon_sym_preallocated] = ACTIONS(547),
    [anon_sym_zeroext] = ACTIONS(547),
    [anon_sym_signext] = ACTIONS(547),
    [anon_sym_inreg] = ACTIONS(547),
    [anon_sym_byval] = ACTIONS(547),
    [anon_sym_byref] = ACTIONS(547),
    [anon_sym_inalloca] = ACTIONS(547),
    [anon_sym_sret] = ACTIONS(547),
    [anon_sym_elementtype] = ACTIONS(547),
    [anon_sym_noalias] = ACTIONS(547),
    [anon_sym_nocapture] = ACTIONS(547),
    [anon_sym_nest] = ACTIONS(547),
    [anon_sym_returned] = ACTIONS(547),
    [anon_sym_nonnull] = ACTIONS(547),
    [anon_sym_dereferenceable] = ACTIONS(547),
    [anon_sym_dereferenceable_or_null] = ACTIONS(547),
    [anon_sym_swiftself] = ACTIONS(547),
    [anon_sym_swiftasync] = ACTIONS(547),
    [anon_sym_swifterror] = ACTIONS(547),
    [anon_sym_immarg] = ACTIONS(547),
    [anon_sym_noundef] = ACTIONS(547),
    [anon_sym_uwtable] = ACTIONS(547),
    [anon_sym_memory] = ACTIONS(547),
    [anon_sym_unreachable] = ACTIONS(547),
    [anon_sym_ret] = ACTIONS(547),
    [anon_sym_br] = ACTIONS(547),
    [anon_sym_resume] = ACTIONS(547),
    [anon_sym_freeze] = ACTIONS(547),
    [anon_sym_indirectbr] = ACTIONS(547),
    [anon_sym_extractelement] = ACTIONS(547),
    [anon_sym_insertelement] = ACTIONS(547),
    [anon_sym_select] = ACTIONS(547),
    [anon_sym_shufflevector] = ACTIONS(547),
    [anon_sym_fneg] = ACTIONS(547),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_invoke] = ACTIONS(547),
    [anon_sym_cleanupret] = ACTIONS(547),
    [anon_sym_catchret] = ACTIONS(547),
    [anon_sym_catchswitch] = ACTIONS(547),
    [anon_sym_catchpad] = ACTIONS(547),
    [anon_sym_cleanuppad] = ACTIONS(547),
    [anon_sym_callbr] = ACTIONS(547),
    [anon_sym_icmp] = ACTIONS(547),
    [anon_sym_fcmp] = ACTIONS(547),
    [anon_sym_va_arg] = ACTIONS(547),
    [anon_sym_phi] = ACTIONS(547),
    [anon_sym_landingpad] = ACTIONS(547),
    [anon_sym_tail] = ACTIONS(547),
    [anon_sym_musttail] = ACTIONS(547),
    [anon_sym_notail] = ACTIONS(547),
    [anon_sym_call] = ACTIONS(547),
    [anon_sym_alloca] = ACTIONS(547),
    [anon_sym_load] = ACTIONS(547),
    [anon_sym_store] = ACTIONS(547),
    [anon_sym_cmpxchg] = ACTIONS(547),
    [anon_sym_atomicrmw] = ACTIONS(547),
    [anon_sym_fence] = ACTIONS(547),
    [anon_sym_getelementptr] = ACTIONS(547),
    [anon_sym_extractvalue] = ACTIONS(547),
    [anon_sym_insertvalue] = ACTIONS(547),
    [anon_sym_catch] = ACTIONS(547),
    [anon_sym_filter] = ACTIONS(547),
    [anon_sym_mul] = ACTIONS(547),
    [anon_sym_urem] = ACTIONS(547),
    [anon_sym_srem] = ACTIONS(547),
    [anon_sym_shl] = ACTIONS(547),
    [anon_sym_udiv] = ACTIONS(547),
    [anon_sym_sdiv] = ACTIONS(547),
    [anon_sym_lshr] = ACTIONS(547),
    [anon_sym_ashr] = ACTIONS(547),
    [anon_sym_fmul] = ACTIONS(547),
    [anon_sym_fdiv] = ACTIONS(547),
    [anon_sym_frem] = ACTIONS(547),
    [anon_sym_xchg] = ACTIONS(547),
    [anon_sym_add] = ACTIONS(547),
    [anon_sym_sub] = ACTIONS(547),
    [anon_sym_and] = ACTIONS(547),
    [anon_sym_nand] = ACTIONS(547),
    [anon_sym_or] = ACTIONS(547),
    [anon_sym_xor] = ACTIONS(547),
    [anon_sym_max] = ACTIONS(547),
    [anon_sym_min] = ACTIONS(547),
    [anon_sym_umax] = ACTIONS(547),
    [anon_sym_umin] = ACTIONS(547),
    [anon_sym_fadd] = ACTIONS(547),
    [anon_sym_fsub] = ACTIONS(547),
    [anon_sym_bitcast] = ACTIONS(547),
    [anon_sym_trunc] = ACTIONS(547),
    [anon_sym_zext] = ACTIONS(547),
    [anon_sym_sext] = ACTIONS(547),
    [anon_sym_fptrunc] = ACTIONS(547),
    [anon_sym_fpext] = ACTIONS(547),
    [anon_sym_addrspacecast] = ACTIONS(547),
    [anon_sym_uitofp] = ACTIONS(547),
    [anon_sym_sitofp] = ACTIONS(547),
    [anon_sym_fptoui] = ACTIONS(547),
    [anon_sym_fptosi] = ACTIONS(547),
    [anon_sym_inttoptr] = ACTIONS(547),
    [anon_sym_ptrtoint] = ACTIONS(547),
    [anon_sym_unordered] = ACTIONS(547),
    [anon_sym_monotonic] = ACTIONS(547),
    [anon_sym_acquire] = ACTIONS(547),
    [anon_sym_release] = ACTIONS(547),
    [anon_sym_acq_rel] = ACTIONS(547),
    [anon_sym_seq_cst] = ACTIONS(547),
    [anon_sym_syncscope] = ACTIONS(547),
    [anon_sym_uselistorder] = ACTIONS(547),
  },
  [150] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(663),
    [sym_local_var] = ACTIONS(663),
    [sym_label] = ACTIONS(663),
    [sym_string] = ACTIONS(665),
    [anon_sym_RBRACE] = ACTIONS(663),
    [anon_sym_LBRACK] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_align] = ACTIONS(665),
    [anon_sym_section] = ACTIONS(665),
    [anon_sym_partition] = ACTIONS(665),
    [anon_sym_comdat] = ACTIONS(665),
    [anon_sym_gc] = ACTIONS(665),
    [anon_sym_prefix] = ACTIONS(665),
    [anon_sym_prologue] = ACTIONS(665),
    [anon_sym_personality] = ACTIONS(665),
    [anon_sym_alignstack] = ACTIONS(665),
    [anon_sym_allocsize] = ACTIONS(665),
    [anon_sym_alwaysinline] = ACTIONS(665),
    [anon_sym_builtin] = ACTIONS(665),
    [anon_sym_cold] = ACTIONS(665),
    [anon_sym_convergent] = ACTIONS(665),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(665),
    [anon_sym_hot] = ACTIONS(665),
    [anon_sym_inaccessiblememonly] = ACTIONS(665),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(665),
    [anon_sym_inlinehint] = ACTIONS(665),
    [anon_sym_jumptable] = ACTIONS(665),
    [anon_sym_minsize] = ACTIONS(665),
    [anon_sym_naked] = ACTIONS(665),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(665),
    [anon_sym_nobuiltin] = ACTIONS(665),
    [anon_sym_noduplicate] = ACTIONS(665),
    [anon_sym_nofree] = ACTIONS(665),
    [anon_sym_noimplicitfloat] = ACTIONS(665),
    [anon_sym_noinline] = ACTIONS(665),
    [anon_sym_nomerge] = ACTIONS(665),
    [anon_sym_nonlazybind] = ACTIONS(665),
    [anon_sym_noprofile] = ACTIONS(665),
    [anon_sym_noredzone] = ACTIONS(665),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(665),
    [anon_sym_noreturn] = ACTIONS(665),
    [anon_sym_norecurse] = ACTIONS(665),
    [anon_sym_willreturn] = ACTIONS(665),
    [anon_sym_nosync] = ACTIONS(665),
    [anon_sym_nounwind] = ACTIONS(665),
    [anon_sym_nocallback] = ACTIONS(665),
    [anon_sym_nosanitize_coverage] = ACTIONS(665),
    [anon_sym_null_pointer_is_valid] = ACTIONS(665),
    [anon_sym_optforfuzzing] = ACTIONS(665),
    [anon_sym_optnone] = ACTIONS(665),
    [anon_sym_optsize] = ACTIONS(665),
    [anon_sym_readnone] = ACTIONS(665),
    [anon_sym_readonly] = ACTIONS(665),
    [anon_sym_writeonly] = ACTIONS(665),
    [anon_sym_argmemonly] = ACTIONS(665),
    [anon_sym_returns_twice] = ACTIONS(665),
    [anon_sym_safestack] = ACTIONS(665),
    [anon_sym_sanitize_address] = ACTIONS(665),
    [anon_sym_sanitize_memory] = ACTIONS(665),
    [anon_sym_sanitize_thread] = ACTIONS(665),
    [anon_sym_sanitize_hwaddress] = ACTIONS(665),
    [anon_sym_sanitize_memtag] = ACTIONS(665),
    [anon_sym_speculative_load_hardening] = ACTIONS(665),
    [anon_sym_speculatable] = ACTIONS(665),
    [anon_sym_ssp] = ACTIONS(665),
    [anon_sym_sspstrong] = ACTIONS(665),
    [anon_sym_sspreq] = ACTIONS(665),
    [anon_sym_strictfp] = ACTIONS(665),
    [anon_sym_nocf_check] = ACTIONS(665),
    [anon_sym_shadowcallstack] = ACTIONS(665),
    [anon_sym_mustprogress] = ACTIONS(665),
    [anon_sym_vscale_range] = ACTIONS(665),
    [anon_sym_preallocated] = ACTIONS(665),
    [anon_sym_zeroext] = ACTIONS(665),
    [anon_sym_signext] = ACTIONS(665),
    [anon_sym_inreg] = ACTIONS(665),
    [anon_sym_byval] = ACTIONS(665),
    [anon_sym_byref] = ACTIONS(665),
    [anon_sym_inalloca] = ACTIONS(665),
    [anon_sym_sret] = ACTIONS(665),
    [anon_sym_elementtype] = ACTIONS(665),
    [anon_sym_noalias] = ACTIONS(665),
    [anon_sym_nocapture] = ACTIONS(665),
    [anon_sym_nest] = ACTIONS(665),
    [anon_sym_returned] = ACTIONS(665),
    [anon_sym_nonnull] = ACTIONS(665),
    [anon_sym_dereferenceable] = ACTIONS(665),
    [anon_sym_dereferenceable_or_null] = ACTIONS(665),
    [anon_sym_swiftself] = ACTIONS(665),
    [anon_sym_swiftasync] = ACTIONS(665),
    [anon_sym_swifterror] = ACTIONS(665),
    [anon_sym_immarg] = ACTIONS(665),
    [anon_sym_noundef] = ACTIONS(665),
    [anon_sym_uwtable] = ACTIONS(665),
    [anon_sym_memory] = ACTIONS(665),
    [anon_sym_unreachable] = ACTIONS(665),
    [anon_sym_ret] = ACTIONS(665),
    [anon_sym_br] = ACTIONS(665),
    [anon_sym_resume] = ACTIONS(665),
    [anon_sym_freeze] = ACTIONS(665),
    [anon_sym_indirectbr] = ACTIONS(665),
    [anon_sym_extractelement] = ACTIONS(665),
    [anon_sym_insertelement] = ACTIONS(665),
    [anon_sym_select] = ACTIONS(665),
    [anon_sym_shufflevector] = ACTIONS(665),
    [anon_sym_fneg] = ACTIONS(665),
    [anon_sym_switch] = ACTIONS(665),
    [anon_sym_invoke] = ACTIONS(665),
    [anon_sym_cleanupret] = ACTIONS(665),
    [anon_sym_catchret] = ACTIONS(665),
    [anon_sym_catchswitch] = ACTIONS(665),
    [anon_sym_catchpad] = ACTIONS(665),
    [anon_sym_cleanuppad] = ACTIONS(665),
    [anon_sym_callbr] = ACTIONS(665),
    [anon_sym_icmp] = ACTIONS(665),
    [anon_sym_fcmp] = ACTIONS(665),
    [anon_sym_va_arg] = ACTIONS(665),
    [anon_sym_phi] = ACTIONS(665),
    [anon_sym_landingpad] = ACTIONS(665),
    [anon_sym_tail] = ACTIONS(665),
    [anon_sym_musttail] = ACTIONS(665),
    [anon_sym_notail] = ACTIONS(665),
    [anon_sym_call] = ACTIONS(665),
    [anon_sym_alloca] = ACTIONS(665),
    [anon_sym_load] = ACTIONS(665),
    [anon_sym_store] = ACTIONS(665),
    [anon_sym_cmpxchg] = ACTIONS(665),
    [anon_sym_atomicrmw] = ACTIONS(665),
    [anon_sym_fence] = ACTIONS(665),
    [anon_sym_getelementptr] = ACTIONS(665),
    [anon_sym_extractvalue] = ACTIONS(665),
    [anon_sym_insertvalue] = ACTIONS(665),
    [anon_sym_catch] = ACTIONS(665),
    [anon_sym_filter] = ACTIONS(665),
    [anon_sym_mul] = ACTIONS(665),
    [anon_sym_urem] = ACTIONS(665),
    [anon_sym_srem] = ACTIONS(665),
    [anon_sym_shl] = ACTIONS(665),
    [anon_sym_udiv] = ACTIONS(665),
    [anon_sym_sdiv] = ACTIONS(665),
    [anon_sym_lshr] = ACTIONS(665),
    [anon_sym_ashr] = ACTIONS(665),
    [anon_sym_fmul] = ACTIONS(665),
    [anon_sym_fdiv] = ACTIONS(665),
    [anon_sym_frem] = ACTIONS(665),
    [anon_sym_xchg] = ACTIONS(665),
    [anon_sym_add] = ACTIONS(665),
    [anon_sym_sub] = ACTIONS(665),
    [anon_sym_and] = ACTIONS(665),
    [anon_sym_nand] = ACTIONS(665),
    [anon_sym_or] = ACTIONS(665),
    [anon_sym_xor] = ACTIONS(665),
    [anon_sym_max] = ACTIONS(665),
    [anon_sym_min] = ACTIONS(665),
    [anon_sym_umax] = ACTIONS(665),
    [anon_sym_umin] = ACTIONS(665),
    [anon_sym_fadd] = ACTIONS(665),
    [anon_sym_fsub] = ACTIONS(665),
    [anon_sym_bitcast] = ACTIONS(665),
    [anon_sym_trunc] = ACTIONS(665),
    [anon_sym_zext] = ACTIONS(665),
    [anon_sym_sext] = ACTIONS(665),
    [anon_sym_fptrunc] = ACTIONS(665),
    [anon_sym_fpext] = ACTIONS(665),
    [anon_sym_addrspacecast] = ACTIONS(665),
    [anon_sym_uitofp] = ACTIONS(665),
    [anon_sym_sitofp] = ACTIONS(665),
    [anon_sym_fptoui] = ACTIONS(665),
    [anon_sym_fptosi] = ACTIONS(665),
    [anon_sym_inttoptr] = ACTIONS(665),
    [anon_sym_ptrtoint] = ACTIONS(665),
    [anon_sym_unordered] = ACTIONS(665),
    [anon_sym_monotonic] = ACTIONS(665),
    [anon_sym_acquire] = ACTIONS(665),
    [anon_sym_release] = ACTIONS(665),
    [anon_sym_acq_rel] = ACTIONS(665),
    [anon_sym_seq_cst] = ACTIONS(665),
    [anon_sym_syncscope] = ACTIONS(665),
    [anon_sym_uselistorder] = ACTIONS(665),
  },
  [151] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(713),
    [sym_local_var] = ACTIONS(713),
    [sym_label] = ACTIONS(713),
    [sym_string] = ACTIONS(715),
    [anon_sym_RBRACE] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_align] = ACTIONS(715),
    [anon_sym_section] = ACTIONS(715),
    [anon_sym_partition] = ACTIONS(715),
    [anon_sym_comdat] = ACTIONS(715),
    [anon_sym_gc] = ACTIONS(715),
    [anon_sym_prefix] = ACTIONS(715),
    [anon_sym_prologue] = ACTIONS(715),
    [anon_sym_personality] = ACTIONS(715),
    [anon_sym_alignstack] = ACTIONS(715),
    [anon_sym_allocsize] = ACTIONS(715),
    [anon_sym_alwaysinline] = ACTIONS(715),
    [anon_sym_builtin] = ACTIONS(715),
    [anon_sym_cold] = ACTIONS(715),
    [anon_sym_convergent] = ACTIONS(715),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(715),
    [anon_sym_hot] = ACTIONS(715),
    [anon_sym_inaccessiblememonly] = ACTIONS(715),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(715),
    [anon_sym_inlinehint] = ACTIONS(715),
    [anon_sym_jumptable] = ACTIONS(715),
    [anon_sym_minsize] = ACTIONS(715),
    [anon_sym_naked] = ACTIONS(715),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(715),
    [anon_sym_nobuiltin] = ACTIONS(715),
    [anon_sym_noduplicate] = ACTIONS(715),
    [anon_sym_nofree] = ACTIONS(715),
    [anon_sym_noimplicitfloat] = ACTIONS(715),
    [anon_sym_noinline] = ACTIONS(715),
    [anon_sym_nomerge] = ACTIONS(715),
    [anon_sym_nonlazybind] = ACTIONS(715),
    [anon_sym_noprofile] = ACTIONS(715),
    [anon_sym_noredzone] = ACTIONS(715),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(715),
    [anon_sym_noreturn] = ACTIONS(715),
    [anon_sym_norecurse] = ACTIONS(715),
    [anon_sym_willreturn] = ACTIONS(715),
    [anon_sym_nosync] = ACTIONS(715),
    [anon_sym_nounwind] = ACTIONS(715),
    [anon_sym_nocallback] = ACTIONS(715),
    [anon_sym_nosanitize_coverage] = ACTIONS(715),
    [anon_sym_null_pointer_is_valid] = ACTIONS(715),
    [anon_sym_optforfuzzing] = ACTIONS(715),
    [anon_sym_optnone] = ACTIONS(715),
    [anon_sym_optsize] = ACTIONS(715),
    [anon_sym_readnone] = ACTIONS(715),
    [anon_sym_readonly] = ACTIONS(715),
    [anon_sym_writeonly] = ACTIONS(715),
    [anon_sym_argmemonly] = ACTIONS(715),
    [anon_sym_returns_twice] = ACTIONS(715),
    [anon_sym_safestack] = ACTIONS(715),
    [anon_sym_sanitize_address] = ACTIONS(715),
    [anon_sym_sanitize_memory] = ACTIONS(715),
    [anon_sym_sanitize_thread] = ACTIONS(715),
    [anon_sym_sanitize_hwaddress] = ACTIONS(715),
    [anon_sym_sanitize_memtag] = ACTIONS(715),
    [anon_sym_speculative_load_hardening] = ACTIONS(715),
    [anon_sym_speculatable] = ACTIONS(715),
    [anon_sym_ssp] = ACTIONS(715),
    [anon_sym_sspstrong] = ACTIONS(715),
    [anon_sym_sspreq] = ACTIONS(715),
    [anon_sym_strictfp] = ACTIONS(715),
    [anon_sym_nocf_check] = ACTIONS(715),
    [anon_sym_shadowcallstack] = ACTIONS(715),
    [anon_sym_mustprogress] = ACTIONS(715),
    [anon_sym_vscale_range] = ACTIONS(715),
    [anon_sym_preallocated] = ACTIONS(715),
    [anon_sym_zeroext] = ACTIONS(715),
    [anon_sym_signext] = ACTIONS(715),
    [anon_sym_inreg] = ACTIONS(715),
    [anon_sym_byval] = ACTIONS(715),
    [anon_sym_byref] = ACTIONS(715),
    [anon_sym_inalloca] = ACTIONS(715),
    [anon_sym_sret] = ACTIONS(715),
    [anon_sym_elementtype] = ACTIONS(715),
    [anon_sym_noalias] = ACTIONS(715),
    [anon_sym_nocapture] = ACTIONS(715),
    [anon_sym_nest] = ACTIONS(715),
    [anon_sym_returned] = ACTIONS(715),
    [anon_sym_nonnull] = ACTIONS(715),
    [anon_sym_dereferenceable] = ACTIONS(715),
    [anon_sym_dereferenceable_or_null] = ACTIONS(715),
    [anon_sym_swiftself] = ACTIONS(715),
    [anon_sym_swiftasync] = ACTIONS(715),
    [anon_sym_swifterror] = ACTIONS(715),
    [anon_sym_immarg] = ACTIONS(715),
    [anon_sym_noundef] = ACTIONS(715),
    [anon_sym_uwtable] = ACTIONS(715),
    [anon_sym_memory] = ACTIONS(715),
    [anon_sym_unreachable] = ACTIONS(715),
    [anon_sym_ret] = ACTIONS(715),
    [anon_sym_br] = ACTIONS(715),
    [anon_sym_resume] = ACTIONS(715),
    [anon_sym_freeze] = ACTIONS(715),
    [anon_sym_indirectbr] = ACTIONS(715),
    [anon_sym_extractelement] = ACTIONS(715),
    [anon_sym_insertelement] = ACTIONS(715),
    [anon_sym_select] = ACTIONS(715),
    [anon_sym_shufflevector] = ACTIONS(715),
    [anon_sym_fneg] = ACTIONS(715),
    [anon_sym_switch] = ACTIONS(715),
    [anon_sym_invoke] = ACTIONS(715),
    [anon_sym_cleanupret] = ACTIONS(715),
    [anon_sym_catchret] = ACTIONS(715),
    [anon_sym_catchswitch] = ACTIONS(715),
    [anon_sym_catchpad] = ACTIONS(715),
    [anon_sym_cleanuppad] = ACTIONS(715),
    [anon_sym_callbr] = ACTIONS(715),
    [anon_sym_icmp] = ACTIONS(715),
    [anon_sym_fcmp] = ACTIONS(715),
    [anon_sym_va_arg] = ACTIONS(715),
    [anon_sym_phi] = ACTIONS(715),
    [anon_sym_landingpad] = ACTIONS(715),
    [anon_sym_tail] = ACTIONS(715),
    [anon_sym_musttail] = ACTIONS(715),
    [anon_sym_notail] = ACTIONS(715),
    [anon_sym_call] = ACTIONS(715),
    [anon_sym_alloca] = ACTIONS(715),
    [anon_sym_load] = ACTIONS(715),
    [anon_sym_store] = ACTIONS(715),
    [anon_sym_cmpxchg] = ACTIONS(715),
    [anon_sym_atomicrmw] = ACTIONS(715),
    [anon_sym_fence] = ACTIONS(715),
    [anon_sym_getelementptr] = ACTIONS(715),
    [anon_sym_extractvalue] = ACTIONS(715),
    [anon_sym_insertvalue] = ACTIONS(715),
    [anon_sym_catch] = ACTIONS(715),
    [anon_sym_filter] = ACTIONS(715),
    [anon_sym_mul] = ACTIONS(715),
    [anon_sym_urem] = ACTIONS(715),
    [anon_sym_srem] = ACTIONS(715),
    [anon_sym_shl] = ACTIONS(715),
    [anon_sym_udiv] = ACTIONS(715),
    [anon_sym_sdiv] = ACTIONS(715),
    [anon_sym_lshr] = ACTIONS(715),
    [anon_sym_ashr] = ACTIONS(715),
    [anon_sym_fmul] = ACTIONS(715),
    [anon_sym_fdiv] = ACTIONS(715),
    [anon_sym_frem] = ACTIONS(715),
    [anon_sym_xchg] = ACTIONS(715),
    [anon_sym_add] = ACTIONS(715),
    [anon_sym_sub] = ACTIONS(715),
    [anon_sym_and] = ACTIONS(715),
    [anon_sym_nand] = ACTIONS(715),
    [anon_sym_or] = ACTIONS(715),
    [anon_sym_xor] = ACTIONS(715),
    [anon_sym_max] = ACTIONS(715),
    [anon_sym_min] = ACTIONS(715),
    [anon_sym_umax] = ACTIONS(715),
    [anon_sym_umin] = ACTIONS(715),
    [anon_sym_fadd] = ACTIONS(715),
    [anon_sym_fsub] = ACTIONS(715),
    [anon_sym_bitcast] = ACTIONS(715),
    [anon_sym_trunc] = ACTIONS(715),
    [anon_sym_zext] = ACTIONS(715),
    [anon_sym_sext] = ACTIONS(715),
    [anon_sym_fptrunc] = ACTIONS(715),
    [anon_sym_fpext] = ACTIONS(715),
    [anon_sym_addrspacecast] = ACTIONS(715),
    [anon_sym_uitofp] = ACTIONS(715),
    [anon_sym_sitofp] = ACTIONS(715),
    [anon_sym_fptoui] = ACTIONS(715),
    [anon_sym_fptosi] = ACTIONS(715),
    [anon_sym_inttoptr] = ACTIONS(715),
    [anon_sym_ptrtoint] = ACTIONS(715),
    [anon_sym_unordered] = ACTIONS(715),
    [anon_sym_monotonic] = ACTIONS(715),
    [anon_sym_acquire] = ACTIONS(715),
    [anon_sym_release] = ACTIONS(715),
    [anon_sym_acq_rel] = ACTIONS(715),
    [anon_sym_seq_cst] = ACTIONS(715),
    [anon_sym_syncscope] = ACTIONS(715),
    [anon_sym_uselistorder] = ACTIONS(715),
  },
  [152] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(701),
    [sym_local_var] = ACTIONS(701),
    [sym_label] = ACTIONS(701),
    [sym_string] = ACTIONS(703),
    [anon_sym_RBRACE] = ACTIONS(701),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_COMMA] = ACTIONS(701),
    [anon_sym_align] = ACTIONS(703),
    [anon_sym_section] = ACTIONS(703),
    [anon_sym_partition] = ACTIONS(703),
    [anon_sym_comdat] = ACTIONS(703),
    [anon_sym_gc] = ACTIONS(703),
    [anon_sym_prefix] = ACTIONS(703),
    [anon_sym_prologue] = ACTIONS(703),
    [anon_sym_personality] = ACTIONS(703),
    [anon_sym_alignstack] = ACTIONS(703),
    [anon_sym_allocsize] = ACTIONS(703),
    [anon_sym_alwaysinline] = ACTIONS(703),
    [anon_sym_builtin] = ACTIONS(703),
    [anon_sym_cold] = ACTIONS(703),
    [anon_sym_convergent] = ACTIONS(703),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(703),
    [anon_sym_hot] = ACTIONS(703),
    [anon_sym_inaccessiblememonly] = ACTIONS(703),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(703),
    [anon_sym_inlinehint] = ACTIONS(703),
    [anon_sym_jumptable] = ACTIONS(703),
    [anon_sym_minsize] = ACTIONS(703),
    [anon_sym_naked] = ACTIONS(703),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(703),
    [anon_sym_nobuiltin] = ACTIONS(703),
    [anon_sym_noduplicate] = ACTIONS(703),
    [anon_sym_nofree] = ACTIONS(703),
    [anon_sym_noimplicitfloat] = ACTIONS(703),
    [anon_sym_noinline] = ACTIONS(703),
    [anon_sym_nomerge] = ACTIONS(703),
    [anon_sym_nonlazybind] = ACTIONS(703),
    [anon_sym_noprofile] = ACTIONS(703),
    [anon_sym_noredzone] = ACTIONS(703),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(703),
    [anon_sym_noreturn] = ACTIONS(703),
    [anon_sym_norecurse] = ACTIONS(703),
    [anon_sym_willreturn] = ACTIONS(703),
    [anon_sym_nosync] = ACTIONS(703),
    [anon_sym_nounwind] = ACTIONS(703),
    [anon_sym_nocallback] = ACTIONS(703),
    [anon_sym_nosanitize_coverage] = ACTIONS(703),
    [anon_sym_null_pointer_is_valid] = ACTIONS(703),
    [anon_sym_optforfuzzing] = ACTIONS(703),
    [anon_sym_optnone] = ACTIONS(703),
    [anon_sym_optsize] = ACTIONS(703),
    [anon_sym_readnone] = ACTIONS(703),
    [anon_sym_readonly] = ACTIONS(703),
    [anon_sym_writeonly] = ACTIONS(703),
    [anon_sym_argmemonly] = ACTIONS(703),
    [anon_sym_returns_twice] = ACTIONS(703),
    [anon_sym_safestack] = ACTIONS(703),
    [anon_sym_sanitize_address] = ACTIONS(703),
    [anon_sym_sanitize_memory] = ACTIONS(703),
    [anon_sym_sanitize_thread] = ACTIONS(703),
    [anon_sym_sanitize_hwaddress] = ACTIONS(703),
    [anon_sym_sanitize_memtag] = ACTIONS(703),
    [anon_sym_speculative_load_hardening] = ACTIONS(703),
    [anon_sym_speculatable] = ACTIONS(703),
    [anon_sym_ssp] = ACTIONS(703),
    [anon_sym_sspstrong] = ACTIONS(703),
    [anon_sym_sspreq] = ACTIONS(703),
    [anon_sym_strictfp] = ACTIONS(703),
    [anon_sym_nocf_check] = ACTIONS(703),
    [anon_sym_shadowcallstack] = ACTIONS(703),
    [anon_sym_mustprogress] = ACTIONS(703),
    [anon_sym_vscale_range] = ACTIONS(703),
    [anon_sym_preallocated] = ACTIONS(703),
    [anon_sym_zeroext] = ACTIONS(703),
    [anon_sym_signext] = ACTIONS(703),
    [anon_sym_inreg] = ACTIONS(703),
    [anon_sym_byval] = ACTIONS(703),
    [anon_sym_byref] = ACTIONS(703),
    [anon_sym_inalloca] = ACTIONS(703),
    [anon_sym_sret] = ACTIONS(703),
    [anon_sym_elementtype] = ACTIONS(703),
    [anon_sym_noalias] = ACTIONS(703),
    [anon_sym_nocapture] = ACTIONS(703),
    [anon_sym_nest] = ACTIONS(703),
    [anon_sym_returned] = ACTIONS(703),
    [anon_sym_nonnull] = ACTIONS(703),
    [anon_sym_dereferenceable] = ACTIONS(703),
    [anon_sym_dereferenceable_or_null] = ACTIONS(703),
    [anon_sym_swiftself] = ACTIONS(703),
    [anon_sym_swiftasync] = ACTIONS(703),
    [anon_sym_swifterror] = ACTIONS(703),
    [anon_sym_immarg] = ACTIONS(703),
    [anon_sym_noundef] = ACTIONS(703),
    [anon_sym_uwtable] = ACTIONS(703),
    [anon_sym_memory] = ACTIONS(703),
    [anon_sym_unreachable] = ACTIONS(703),
    [anon_sym_ret] = ACTIONS(703),
    [anon_sym_br] = ACTIONS(703),
    [anon_sym_resume] = ACTIONS(703),
    [anon_sym_freeze] = ACTIONS(703),
    [anon_sym_indirectbr] = ACTIONS(703),
    [anon_sym_extractelement] = ACTIONS(703),
    [anon_sym_insertelement] = ACTIONS(703),
    [anon_sym_select] = ACTIONS(703),
    [anon_sym_shufflevector] = ACTIONS(703),
    [anon_sym_fneg] = ACTIONS(703),
    [anon_sym_switch] = ACTIONS(703),
    [anon_sym_invoke] = ACTIONS(703),
    [anon_sym_cleanupret] = ACTIONS(703),
    [anon_sym_catchret] = ACTIONS(703),
    [anon_sym_catchswitch] = ACTIONS(703),
    [anon_sym_catchpad] = ACTIONS(703),
    [anon_sym_cleanuppad] = ACTIONS(703),
    [anon_sym_callbr] = ACTIONS(703),
    [anon_sym_icmp] = ACTIONS(703),
    [anon_sym_fcmp] = ACTIONS(703),
    [anon_sym_va_arg] = ACTIONS(703),
    [anon_sym_phi] = ACTIONS(703),
    [anon_sym_landingpad] = ACTIONS(703),
    [anon_sym_tail] = ACTIONS(703),
    [anon_sym_musttail] = ACTIONS(703),
    [anon_sym_notail] = ACTIONS(703),
    [anon_sym_call] = ACTIONS(703),
    [anon_sym_alloca] = ACTIONS(703),
    [anon_sym_load] = ACTIONS(703),
    [anon_sym_store] = ACTIONS(703),
    [anon_sym_cmpxchg] = ACTIONS(703),
    [anon_sym_atomicrmw] = ACTIONS(703),
    [anon_sym_fence] = ACTIONS(703),
    [anon_sym_getelementptr] = ACTIONS(703),
    [anon_sym_extractvalue] = ACTIONS(703),
    [anon_sym_insertvalue] = ACTIONS(703),
    [anon_sym_catch] = ACTIONS(703),
    [anon_sym_filter] = ACTIONS(703),
    [anon_sym_mul] = ACTIONS(703),
    [anon_sym_urem] = ACTIONS(703),
    [anon_sym_srem] = ACTIONS(703),
    [anon_sym_shl] = ACTIONS(703),
    [anon_sym_udiv] = ACTIONS(703),
    [anon_sym_sdiv] = ACTIONS(703),
    [anon_sym_lshr] = ACTIONS(703),
    [anon_sym_ashr] = ACTIONS(703),
    [anon_sym_fmul] = ACTIONS(703),
    [anon_sym_fdiv] = ACTIONS(703),
    [anon_sym_frem] = ACTIONS(703),
    [anon_sym_xchg] = ACTIONS(703),
    [anon_sym_add] = ACTIONS(703),
    [anon_sym_sub] = ACTIONS(703),
    [anon_sym_and] = ACTIONS(703),
    [anon_sym_nand] = ACTIONS(703),
    [anon_sym_or] = ACTIONS(703),
    [anon_sym_xor] = ACTIONS(703),
    [anon_sym_max] = ACTIONS(703),
    [anon_sym_min] = ACTIONS(703),
    [anon_sym_umax] = ACTIONS(703),
    [anon_sym_umin] = ACTIONS(703),
    [anon_sym_fadd] = ACTIONS(703),
    [anon_sym_fsub] = ACTIONS(703),
    [anon_sym_bitcast] = ACTIONS(703),
    [anon_sym_trunc] = ACTIONS(703),
    [anon_sym_zext] = ACTIONS(703),
    [anon_sym_sext] = ACTIONS(703),
    [anon_sym_fptrunc] = ACTIONS(703),
    [anon_sym_fpext] = ACTIONS(703),
    [anon_sym_addrspacecast] = ACTIONS(703),
    [anon_sym_uitofp] = ACTIONS(703),
    [anon_sym_sitofp] = ACTIONS(703),
    [anon_sym_fptoui] = ACTIONS(703),
    [anon_sym_fptosi] = ACTIONS(703),
    [anon_sym_inttoptr] = ACTIONS(703),
    [anon_sym_ptrtoint] = ACTIONS(703),
    [anon_sym_unordered] = ACTIONS(703),
    [anon_sym_monotonic] = ACTIONS(703),
    [anon_sym_acquire] = ACTIONS(703),
    [anon_sym_release] = ACTIONS(703),
    [anon_sym_acq_rel] = ACTIONS(703),
    [anon_sym_seq_cst] = ACTIONS(703),
    [anon_sym_syncscope] = ACTIONS(703),
    [anon_sym_uselistorder] = ACTIONS(703),
  },
  [153] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(607),
    [sym_local_var] = ACTIONS(607),
    [sym_label] = ACTIONS(607),
    [sym_string] = ACTIONS(609),
    [anon_sym_RBRACE] = ACTIONS(607),
    [anon_sym_LBRACK] = ACTIONS(607),
    [anon_sym_COMMA] = ACTIONS(607),
    [anon_sym_align] = ACTIONS(609),
    [anon_sym_section] = ACTIONS(609),
    [anon_sym_partition] = ACTIONS(609),
    [anon_sym_comdat] = ACTIONS(609),
    [anon_sym_gc] = ACTIONS(609),
    [anon_sym_prefix] = ACTIONS(609),
    [anon_sym_prologue] = ACTIONS(609),
    [anon_sym_personality] = ACTIONS(609),
    [anon_sym_alignstack] = ACTIONS(609),
    [anon_sym_allocsize] = ACTIONS(609),
    [anon_sym_alwaysinline] = ACTIONS(609),
    [anon_sym_builtin] = ACTIONS(609),
    [anon_sym_cold] = ACTIONS(609),
    [anon_sym_convergent] = ACTIONS(609),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(609),
    [anon_sym_hot] = ACTIONS(609),
    [anon_sym_inaccessiblememonly] = ACTIONS(609),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(609),
    [anon_sym_inlinehint] = ACTIONS(609),
    [anon_sym_jumptable] = ACTIONS(609),
    [anon_sym_minsize] = ACTIONS(609),
    [anon_sym_naked] = ACTIONS(609),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(609),
    [anon_sym_nobuiltin] = ACTIONS(609),
    [anon_sym_noduplicate] = ACTIONS(609),
    [anon_sym_nofree] = ACTIONS(609),
    [anon_sym_noimplicitfloat] = ACTIONS(609),
    [anon_sym_noinline] = ACTIONS(609),
    [anon_sym_nomerge] = ACTIONS(609),
    [anon_sym_nonlazybind] = ACTIONS(609),
    [anon_sym_noprofile] = ACTIONS(609),
    [anon_sym_noredzone] = ACTIONS(609),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(609),
    [anon_sym_noreturn] = ACTIONS(609),
    [anon_sym_norecurse] = ACTIONS(609),
    [anon_sym_willreturn] = ACTIONS(609),
    [anon_sym_nosync] = ACTIONS(609),
    [anon_sym_nounwind] = ACTIONS(609),
    [anon_sym_nocallback] = ACTIONS(609),
    [anon_sym_nosanitize_coverage] = ACTIONS(609),
    [anon_sym_null_pointer_is_valid] = ACTIONS(609),
    [anon_sym_optforfuzzing] = ACTIONS(609),
    [anon_sym_optnone] = ACTIONS(609),
    [anon_sym_optsize] = ACTIONS(609),
    [anon_sym_readnone] = ACTIONS(609),
    [anon_sym_readonly] = ACTIONS(609),
    [anon_sym_writeonly] = ACTIONS(609),
    [anon_sym_argmemonly] = ACTIONS(609),
    [anon_sym_returns_twice] = ACTIONS(609),
    [anon_sym_safestack] = ACTIONS(609),
    [anon_sym_sanitize_address] = ACTIONS(609),
    [anon_sym_sanitize_memory] = ACTIONS(609),
    [anon_sym_sanitize_thread] = ACTIONS(609),
    [anon_sym_sanitize_hwaddress] = ACTIONS(609),
    [anon_sym_sanitize_memtag] = ACTIONS(609),
    [anon_sym_speculative_load_hardening] = ACTIONS(609),
    [anon_sym_speculatable] = ACTIONS(609),
    [anon_sym_ssp] = ACTIONS(609),
    [anon_sym_sspstrong] = ACTIONS(609),
    [anon_sym_sspreq] = ACTIONS(609),
    [anon_sym_strictfp] = ACTIONS(609),
    [anon_sym_nocf_check] = ACTIONS(609),
    [anon_sym_shadowcallstack] = ACTIONS(609),
    [anon_sym_mustprogress] = ACTIONS(609),
    [anon_sym_vscale_range] = ACTIONS(609),
    [anon_sym_preallocated] = ACTIONS(609),
    [anon_sym_zeroext] = ACTIONS(609),
    [anon_sym_signext] = ACTIONS(609),
    [anon_sym_inreg] = ACTIONS(609),
    [anon_sym_byval] = ACTIONS(609),
    [anon_sym_byref] = ACTIONS(609),
    [anon_sym_inalloca] = ACTIONS(609),
    [anon_sym_sret] = ACTIONS(609),
    [anon_sym_elementtype] = ACTIONS(609),
    [anon_sym_noalias] = ACTIONS(609),
    [anon_sym_nocapture] = ACTIONS(609),
    [anon_sym_nest] = ACTIONS(609),
    [anon_sym_returned] = ACTIONS(609),
    [anon_sym_nonnull] = ACTIONS(609),
    [anon_sym_dereferenceable] = ACTIONS(609),
    [anon_sym_dereferenceable_or_null] = ACTIONS(609),
    [anon_sym_swiftself] = ACTIONS(609),
    [anon_sym_swiftasync] = ACTIONS(609),
    [anon_sym_swifterror] = ACTIONS(609),
    [anon_sym_immarg] = ACTIONS(609),
    [anon_sym_noundef] = ACTIONS(609),
    [anon_sym_uwtable] = ACTIONS(609),
    [anon_sym_memory] = ACTIONS(609),
    [anon_sym_unreachable] = ACTIONS(609),
    [anon_sym_ret] = ACTIONS(609),
    [anon_sym_br] = ACTIONS(609),
    [anon_sym_resume] = ACTIONS(609),
    [anon_sym_freeze] = ACTIONS(609),
    [anon_sym_indirectbr] = ACTIONS(609),
    [anon_sym_extractelement] = ACTIONS(609),
    [anon_sym_insertelement] = ACTIONS(609),
    [anon_sym_select] = ACTIONS(609),
    [anon_sym_shufflevector] = ACTIONS(609),
    [anon_sym_fneg] = ACTIONS(609),
    [anon_sym_switch] = ACTIONS(609),
    [anon_sym_invoke] = ACTIONS(609),
    [anon_sym_cleanupret] = ACTIONS(609),
    [anon_sym_catchret] = ACTIONS(609),
    [anon_sym_catchswitch] = ACTIONS(609),
    [anon_sym_catchpad] = ACTIONS(609),
    [anon_sym_cleanuppad] = ACTIONS(609),
    [anon_sym_callbr] = ACTIONS(609),
    [anon_sym_icmp] = ACTIONS(609),
    [anon_sym_fcmp] = ACTIONS(609),
    [anon_sym_va_arg] = ACTIONS(609),
    [anon_sym_phi] = ACTIONS(609),
    [anon_sym_landingpad] = ACTIONS(609),
    [anon_sym_tail] = ACTIONS(609),
    [anon_sym_musttail] = ACTIONS(609),
    [anon_sym_notail] = ACTIONS(609),
    [anon_sym_call] = ACTIONS(609),
    [anon_sym_alloca] = ACTIONS(609),
    [anon_sym_load] = ACTIONS(609),
    [anon_sym_store] = ACTIONS(609),
    [anon_sym_cmpxchg] = ACTIONS(609),
    [anon_sym_atomicrmw] = ACTIONS(609),
    [anon_sym_fence] = ACTIONS(609),
    [anon_sym_getelementptr] = ACTIONS(609),
    [anon_sym_extractvalue] = ACTIONS(609),
    [anon_sym_insertvalue] = ACTIONS(609),
    [anon_sym_catch] = ACTIONS(609),
    [anon_sym_filter] = ACTIONS(609),
    [anon_sym_mul] = ACTIONS(609),
    [anon_sym_urem] = ACTIONS(609),
    [anon_sym_srem] = ACTIONS(609),
    [anon_sym_shl] = ACTIONS(609),
    [anon_sym_udiv] = ACTIONS(609),
    [anon_sym_sdiv] = ACTIONS(609),
    [anon_sym_lshr] = ACTIONS(609),
    [anon_sym_ashr] = ACTIONS(609),
    [anon_sym_fmul] = ACTIONS(609),
    [anon_sym_fdiv] = ACTIONS(609),
    [anon_sym_frem] = ACTIONS(609),
    [anon_sym_xchg] = ACTIONS(609),
    [anon_sym_add] = ACTIONS(609),
    [anon_sym_sub] = ACTIONS(609),
    [anon_sym_and] = ACTIONS(609),
    [anon_sym_nand] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(609),
    [anon_sym_xor] = ACTIONS(609),
    [anon_sym_max] = ACTIONS(609),
    [anon_sym_min] = ACTIONS(609),
    [anon_sym_umax] = ACTIONS(609),
    [anon_sym_umin] = ACTIONS(609),
    [anon_sym_fadd] = ACTIONS(609),
    [anon_sym_fsub] = ACTIONS(609),
    [anon_sym_bitcast] = ACTIONS(609),
    [anon_sym_trunc] = ACTIONS(609),
    [anon_sym_zext] = ACTIONS(609),
    [anon_sym_sext] = ACTIONS(609),
    [anon_sym_fptrunc] = ACTIONS(609),
    [anon_sym_fpext] = ACTIONS(609),
    [anon_sym_addrspacecast] = ACTIONS(609),
    [anon_sym_uitofp] = ACTIONS(609),
    [anon_sym_sitofp] = ACTIONS(609),
    [anon_sym_fptoui] = ACTIONS(609),
    [anon_sym_fptosi] = ACTIONS(609),
    [anon_sym_inttoptr] = ACTIONS(609),
    [anon_sym_ptrtoint] = ACTIONS(609),
    [anon_sym_unordered] = ACTIONS(609),
    [anon_sym_monotonic] = ACTIONS(609),
    [anon_sym_acquire] = ACTIONS(609),
    [anon_sym_release] = ACTIONS(609),
    [anon_sym_acq_rel] = ACTIONS(609),
    [anon_sym_seq_cst] = ACTIONS(609),
    [anon_sym_syncscope] = ACTIONS(609),
    [anon_sym_uselistorder] = ACTIONS(609),
  },
  [154] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(693),
    [sym_local_var] = ACTIONS(693),
    [sym_label] = ACTIONS(693),
    [sym_string] = ACTIONS(695),
    [anon_sym_RBRACE] = ACTIONS(693),
    [anon_sym_LBRACK] = ACTIONS(693),
    [anon_sym_COMMA] = ACTIONS(693),
    [anon_sym_align] = ACTIONS(695),
    [anon_sym_section] = ACTIONS(695),
    [anon_sym_partition] = ACTIONS(695),
    [anon_sym_comdat] = ACTIONS(695),
    [anon_sym_gc] = ACTIONS(695),
    [anon_sym_prefix] = ACTIONS(695),
    [anon_sym_prologue] = ACTIONS(695),
    [anon_sym_personality] = ACTIONS(695),
    [anon_sym_alignstack] = ACTIONS(695),
    [anon_sym_allocsize] = ACTIONS(695),
    [anon_sym_alwaysinline] = ACTIONS(695),
    [anon_sym_builtin] = ACTIONS(695),
    [anon_sym_cold] = ACTIONS(695),
    [anon_sym_convergent] = ACTIONS(695),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(695),
    [anon_sym_hot] = ACTIONS(695),
    [anon_sym_inaccessiblememonly] = ACTIONS(695),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(695),
    [anon_sym_inlinehint] = ACTIONS(695),
    [anon_sym_jumptable] = ACTIONS(695),
    [anon_sym_minsize] = ACTIONS(695),
    [anon_sym_naked] = ACTIONS(695),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(695),
    [anon_sym_nobuiltin] = ACTIONS(695),
    [anon_sym_noduplicate] = ACTIONS(695),
    [anon_sym_nofree] = ACTIONS(695),
    [anon_sym_noimplicitfloat] = ACTIONS(695),
    [anon_sym_noinline] = ACTIONS(695),
    [anon_sym_nomerge] = ACTIONS(695),
    [anon_sym_nonlazybind] = ACTIONS(695),
    [anon_sym_noprofile] = ACTIONS(695),
    [anon_sym_noredzone] = ACTIONS(695),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(695),
    [anon_sym_noreturn] = ACTIONS(695),
    [anon_sym_norecurse] = ACTIONS(695),
    [anon_sym_willreturn] = ACTIONS(695),
    [anon_sym_nosync] = ACTIONS(695),
    [anon_sym_nounwind] = ACTIONS(695),
    [anon_sym_nocallback] = ACTIONS(695),
    [anon_sym_nosanitize_coverage] = ACTIONS(695),
    [anon_sym_null_pointer_is_valid] = ACTIONS(695),
    [anon_sym_optforfuzzing] = ACTIONS(695),
    [anon_sym_optnone] = ACTIONS(695),
    [anon_sym_optsize] = ACTIONS(695),
    [anon_sym_readnone] = ACTIONS(695),
    [anon_sym_readonly] = ACTIONS(695),
    [anon_sym_writeonly] = ACTIONS(695),
    [anon_sym_argmemonly] = ACTIONS(695),
    [anon_sym_returns_twice] = ACTIONS(695),
    [anon_sym_safestack] = ACTIONS(695),
    [anon_sym_sanitize_address] = ACTIONS(695),
    [anon_sym_sanitize_memory] = ACTIONS(695),
    [anon_sym_sanitize_thread] = ACTIONS(695),
    [anon_sym_sanitize_hwaddress] = ACTIONS(695),
    [anon_sym_sanitize_memtag] = ACTIONS(695),
    [anon_sym_speculative_load_hardening] = ACTIONS(695),
    [anon_sym_speculatable] = ACTIONS(695),
    [anon_sym_ssp] = ACTIONS(695),
    [anon_sym_sspstrong] = ACTIONS(695),
    [anon_sym_sspreq] = ACTIONS(695),
    [anon_sym_strictfp] = ACTIONS(695),
    [anon_sym_nocf_check] = ACTIONS(695),
    [anon_sym_shadowcallstack] = ACTIONS(695),
    [anon_sym_mustprogress] = ACTIONS(695),
    [anon_sym_vscale_range] = ACTIONS(695),
    [anon_sym_preallocated] = ACTIONS(695),
    [anon_sym_zeroext] = ACTIONS(695),
    [anon_sym_signext] = ACTIONS(695),
    [anon_sym_inreg] = ACTIONS(695),
    [anon_sym_byval] = ACTIONS(695),
    [anon_sym_byref] = ACTIONS(695),
    [anon_sym_inalloca] = ACTIONS(695),
    [anon_sym_sret] = ACTIONS(695),
    [anon_sym_elementtype] = ACTIONS(695),
    [anon_sym_noalias] = ACTIONS(695),
    [anon_sym_nocapture] = ACTIONS(695),
    [anon_sym_nest] = ACTIONS(695),
    [anon_sym_returned] = ACTIONS(695),
    [anon_sym_nonnull] = ACTIONS(695),
    [anon_sym_dereferenceable] = ACTIONS(695),
    [anon_sym_dereferenceable_or_null] = ACTIONS(695),
    [anon_sym_swiftself] = ACTIONS(695),
    [anon_sym_swiftasync] = ACTIONS(695),
    [anon_sym_swifterror] = ACTIONS(695),
    [anon_sym_immarg] = ACTIONS(695),
    [anon_sym_noundef] = ACTIONS(695),
    [anon_sym_uwtable] = ACTIONS(695),
    [anon_sym_memory] = ACTIONS(695),
    [anon_sym_unreachable] = ACTIONS(695),
    [anon_sym_ret] = ACTIONS(695),
    [anon_sym_br] = ACTIONS(695),
    [anon_sym_resume] = ACTIONS(695),
    [anon_sym_freeze] = ACTIONS(695),
    [anon_sym_indirectbr] = ACTIONS(695),
    [anon_sym_extractelement] = ACTIONS(695),
    [anon_sym_insertelement] = ACTIONS(695),
    [anon_sym_select] = ACTIONS(695),
    [anon_sym_shufflevector] = ACTIONS(695),
    [anon_sym_fneg] = ACTIONS(695),
    [anon_sym_switch] = ACTIONS(695),
    [anon_sym_invoke] = ACTIONS(695),
    [anon_sym_cleanupret] = ACTIONS(695),
    [anon_sym_catchret] = ACTIONS(695),
    [anon_sym_catchswitch] = ACTIONS(695),
    [anon_sym_catchpad] = ACTIONS(695),
    [anon_sym_cleanuppad] = ACTIONS(695),
    [anon_sym_callbr] = ACTIONS(695),
    [anon_sym_icmp] = ACTIONS(695),
    [anon_sym_fcmp] = ACTIONS(695),
    [anon_sym_va_arg] = ACTIONS(695),
    [anon_sym_phi] = ACTIONS(695),
    [anon_sym_landingpad] = ACTIONS(695),
    [anon_sym_tail] = ACTIONS(695),
    [anon_sym_musttail] = ACTIONS(695),
    [anon_sym_notail] = ACTIONS(695),
    [anon_sym_call] = ACTIONS(695),
    [anon_sym_alloca] = ACTIONS(695),
    [anon_sym_load] = ACTIONS(695),
    [anon_sym_store] = ACTIONS(695),
    [anon_sym_cmpxchg] = ACTIONS(695),
    [anon_sym_atomicrmw] = ACTIONS(695),
    [anon_sym_fence] = ACTIONS(695),
    [anon_sym_getelementptr] = ACTIONS(695),
    [anon_sym_extractvalue] = ACTIONS(695),
    [anon_sym_insertvalue] = ACTIONS(695),
    [anon_sym_catch] = ACTIONS(695),
    [anon_sym_filter] = ACTIONS(695),
    [anon_sym_mul] = ACTIONS(695),
    [anon_sym_urem] = ACTIONS(695),
    [anon_sym_srem] = ACTIONS(695),
    [anon_sym_shl] = ACTIONS(695),
    [anon_sym_udiv] = ACTIONS(695),
    [anon_sym_sdiv] = ACTIONS(695),
    [anon_sym_lshr] = ACTIONS(695),
    [anon_sym_ashr] = ACTIONS(695),
    [anon_sym_fmul] = ACTIONS(695),
    [anon_sym_fdiv] = ACTIONS(695),
    [anon_sym_frem] = ACTIONS(695),
    [anon_sym_xchg] = ACTIONS(695),
    [anon_sym_add] = ACTIONS(695),
    [anon_sym_sub] = ACTIONS(695),
    [anon_sym_and] = ACTIONS(695),
    [anon_sym_nand] = ACTIONS(695),
    [anon_sym_or] = ACTIONS(695),
    [anon_sym_xor] = ACTIONS(695),
    [anon_sym_max] = ACTIONS(695),
    [anon_sym_min] = ACTIONS(695),
    [anon_sym_umax] = ACTIONS(695),
    [anon_sym_umin] = ACTIONS(695),
    [anon_sym_fadd] = ACTIONS(695),
    [anon_sym_fsub] = ACTIONS(695),
    [anon_sym_bitcast] = ACTIONS(695),
    [anon_sym_trunc] = ACTIONS(695),
    [anon_sym_zext] = ACTIONS(695),
    [anon_sym_sext] = ACTIONS(695),
    [anon_sym_fptrunc] = ACTIONS(695),
    [anon_sym_fpext] = ACTIONS(695),
    [anon_sym_addrspacecast] = ACTIONS(695),
    [anon_sym_uitofp] = ACTIONS(695),
    [anon_sym_sitofp] = ACTIONS(695),
    [anon_sym_fptoui] = ACTIONS(695),
    [anon_sym_fptosi] = ACTIONS(695),
    [anon_sym_inttoptr] = ACTIONS(695),
    [anon_sym_ptrtoint] = ACTIONS(695),
    [anon_sym_unordered] = ACTIONS(695),
    [anon_sym_monotonic] = ACTIONS(695),
    [anon_sym_acquire] = ACTIONS(695),
    [anon_sym_release] = ACTIONS(695),
    [anon_sym_acq_rel] = ACTIONS(695),
    [anon_sym_seq_cst] = ACTIONS(695),
    [anon_sym_syncscope] = ACTIONS(695),
    [anon_sym_uselistorder] = ACTIONS(695),
  },
  [155] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(599),
    [sym_local_var] = ACTIONS(599),
    [sym_label] = ACTIONS(599),
    [sym_string] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(599),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_COMMA] = ACTIONS(599),
    [anon_sym_align] = ACTIONS(601),
    [anon_sym_section] = ACTIONS(601),
    [anon_sym_partition] = ACTIONS(601),
    [anon_sym_comdat] = ACTIONS(601),
    [anon_sym_gc] = ACTIONS(601),
    [anon_sym_prefix] = ACTIONS(601),
    [anon_sym_prologue] = ACTIONS(601),
    [anon_sym_personality] = ACTIONS(601),
    [anon_sym_alignstack] = ACTIONS(601),
    [anon_sym_allocsize] = ACTIONS(601),
    [anon_sym_alwaysinline] = ACTIONS(601),
    [anon_sym_builtin] = ACTIONS(601),
    [anon_sym_cold] = ACTIONS(601),
    [anon_sym_convergent] = ACTIONS(601),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(601),
    [anon_sym_hot] = ACTIONS(601),
    [anon_sym_inaccessiblememonly] = ACTIONS(601),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(601),
    [anon_sym_inlinehint] = ACTIONS(601),
    [anon_sym_jumptable] = ACTIONS(601),
    [anon_sym_minsize] = ACTIONS(601),
    [anon_sym_naked] = ACTIONS(601),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(601),
    [anon_sym_nobuiltin] = ACTIONS(601),
    [anon_sym_noduplicate] = ACTIONS(601),
    [anon_sym_nofree] = ACTIONS(601),
    [anon_sym_noimplicitfloat] = ACTIONS(601),
    [anon_sym_noinline] = ACTIONS(601),
    [anon_sym_nomerge] = ACTIONS(601),
    [anon_sym_nonlazybind] = ACTIONS(601),
    [anon_sym_noprofile] = ACTIONS(601),
    [anon_sym_noredzone] = ACTIONS(601),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(601),
    [anon_sym_noreturn] = ACTIONS(601),
    [anon_sym_norecurse] = ACTIONS(601),
    [anon_sym_willreturn] = ACTIONS(601),
    [anon_sym_nosync] = ACTIONS(601),
    [anon_sym_nounwind] = ACTIONS(601),
    [anon_sym_nocallback] = ACTIONS(601),
    [anon_sym_nosanitize_coverage] = ACTIONS(601),
    [anon_sym_null_pointer_is_valid] = ACTIONS(601),
    [anon_sym_optforfuzzing] = ACTIONS(601),
    [anon_sym_optnone] = ACTIONS(601),
    [anon_sym_optsize] = ACTIONS(601),
    [anon_sym_readnone] = ACTIONS(601),
    [anon_sym_readonly] = ACTIONS(601),
    [anon_sym_writeonly] = ACTIONS(601),
    [anon_sym_argmemonly] = ACTIONS(601),
    [anon_sym_returns_twice] = ACTIONS(601),
    [anon_sym_safestack] = ACTIONS(601),
    [anon_sym_sanitize_address] = ACTIONS(601),
    [anon_sym_sanitize_memory] = ACTIONS(601),
    [anon_sym_sanitize_thread] = ACTIONS(601),
    [anon_sym_sanitize_hwaddress] = ACTIONS(601),
    [anon_sym_sanitize_memtag] = ACTIONS(601),
    [anon_sym_speculative_load_hardening] = ACTIONS(601),
    [anon_sym_speculatable] = ACTIONS(601),
    [anon_sym_ssp] = ACTIONS(601),
    [anon_sym_sspstrong] = ACTIONS(601),
    [anon_sym_sspreq] = ACTIONS(601),
    [anon_sym_strictfp] = ACTIONS(601),
    [anon_sym_nocf_check] = ACTIONS(601),
    [anon_sym_shadowcallstack] = ACTIONS(601),
    [anon_sym_mustprogress] = ACTIONS(601),
    [anon_sym_vscale_range] = ACTIONS(601),
    [anon_sym_preallocated] = ACTIONS(601),
    [anon_sym_zeroext] = ACTIONS(601),
    [anon_sym_signext] = ACTIONS(601),
    [anon_sym_inreg] = ACTIONS(601),
    [anon_sym_byval] = ACTIONS(601),
    [anon_sym_byref] = ACTIONS(601),
    [anon_sym_inalloca] = ACTIONS(601),
    [anon_sym_sret] = ACTIONS(601),
    [anon_sym_elementtype] = ACTIONS(601),
    [anon_sym_noalias] = ACTIONS(601),
    [anon_sym_nocapture] = ACTIONS(601),
    [anon_sym_nest] = ACTIONS(601),
    [anon_sym_returned] = ACTIONS(601),
    [anon_sym_nonnull] = ACTIONS(601),
    [anon_sym_dereferenceable] = ACTIONS(601),
    [anon_sym_dereferenceable_or_null] = ACTIONS(601),
    [anon_sym_swiftself] = ACTIONS(601),
    [anon_sym_swiftasync] = ACTIONS(601),
    [anon_sym_swifterror] = ACTIONS(601),
    [anon_sym_immarg] = ACTIONS(601),
    [anon_sym_noundef] = ACTIONS(601),
    [anon_sym_uwtable] = ACTIONS(601),
    [anon_sym_memory] = ACTIONS(601),
    [anon_sym_unreachable] = ACTIONS(601),
    [anon_sym_ret] = ACTIONS(601),
    [anon_sym_br] = ACTIONS(601),
    [anon_sym_resume] = ACTIONS(601),
    [anon_sym_freeze] = ACTIONS(601),
    [anon_sym_indirectbr] = ACTIONS(601),
    [anon_sym_extractelement] = ACTIONS(601),
    [anon_sym_insertelement] = ACTIONS(601),
    [anon_sym_select] = ACTIONS(601),
    [anon_sym_shufflevector] = ACTIONS(601),
    [anon_sym_fneg] = ACTIONS(601),
    [anon_sym_switch] = ACTIONS(601),
    [anon_sym_invoke] = ACTIONS(601),
    [anon_sym_cleanupret] = ACTIONS(601),
    [anon_sym_catchret] = ACTIONS(601),
    [anon_sym_catchswitch] = ACTIONS(601),
    [anon_sym_catchpad] = ACTIONS(601),
    [anon_sym_cleanuppad] = ACTIONS(601),
    [anon_sym_callbr] = ACTIONS(601),
    [anon_sym_icmp] = ACTIONS(601),
    [anon_sym_fcmp] = ACTIONS(601),
    [anon_sym_va_arg] = ACTIONS(601),
    [anon_sym_phi] = ACTIONS(601),
    [anon_sym_landingpad] = ACTIONS(601),
    [anon_sym_tail] = ACTIONS(601),
    [anon_sym_musttail] = ACTIONS(601),
    [anon_sym_notail] = ACTIONS(601),
    [anon_sym_call] = ACTIONS(601),
    [anon_sym_alloca] = ACTIONS(601),
    [anon_sym_load] = ACTIONS(601),
    [anon_sym_store] = ACTIONS(601),
    [anon_sym_cmpxchg] = ACTIONS(601),
    [anon_sym_atomicrmw] = ACTIONS(601),
    [anon_sym_fence] = ACTIONS(601),
    [anon_sym_getelementptr] = ACTIONS(601),
    [anon_sym_extractvalue] = ACTIONS(601),
    [anon_sym_insertvalue] = ACTIONS(601),
    [anon_sym_catch] = ACTIONS(601),
    [anon_sym_filter] = ACTIONS(601),
    [anon_sym_mul] = ACTIONS(601),
    [anon_sym_urem] = ACTIONS(601),
    [anon_sym_srem] = ACTIONS(601),
    [anon_sym_shl] = ACTIONS(601),
    [anon_sym_udiv] = ACTIONS(601),
    [anon_sym_sdiv] = ACTIONS(601),
    [anon_sym_lshr] = ACTIONS(601),
    [anon_sym_ashr] = ACTIONS(601),
    [anon_sym_fmul] = ACTIONS(601),
    [anon_sym_fdiv] = ACTIONS(601),
    [anon_sym_frem] = ACTIONS(601),
    [anon_sym_xchg] = ACTIONS(601),
    [anon_sym_add] = ACTIONS(601),
    [anon_sym_sub] = ACTIONS(601),
    [anon_sym_and] = ACTIONS(601),
    [anon_sym_nand] = ACTIONS(601),
    [anon_sym_or] = ACTIONS(601),
    [anon_sym_xor] = ACTIONS(601),
    [anon_sym_max] = ACTIONS(601),
    [anon_sym_min] = ACTIONS(601),
    [anon_sym_umax] = ACTIONS(601),
    [anon_sym_umin] = ACTIONS(601),
    [anon_sym_fadd] = ACTIONS(601),
    [anon_sym_fsub] = ACTIONS(601),
    [anon_sym_bitcast] = ACTIONS(601),
    [anon_sym_trunc] = ACTIONS(601),
    [anon_sym_zext] = ACTIONS(601),
    [anon_sym_sext] = ACTIONS(601),
    [anon_sym_fptrunc] = ACTIONS(601),
    [anon_sym_fpext] = ACTIONS(601),
    [anon_sym_addrspacecast] = ACTIONS(601),
    [anon_sym_uitofp] = ACTIONS(601),
    [anon_sym_sitofp] = ACTIONS(601),
    [anon_sym_fptoui] = ACTIONS(601),
    [anon_sym_fptosi] = ACTIONS(601),
    [anon_sym_inttoptr] = ACTIONS(601),
    [anon_sym_ptrtoint] = ACTIONS(601),
    [anon_sym_unordered] = ACTIONS(601),
    [anon_sym_monotonic] = ACTIONS(601),
    [anon_sym_acquire] = ACTIONS(601),
    [anon_sym_release] = ACTIONS(601),
    [anon_sym_acq_rel] = ACTIONS(601),
    [anon_sym_seq_cst] = ACTIONS(601),
    [anon_sym_syncscope] = ACTIONS(601),
    [anon_sym_uselistorder] = ACTIONS(601),
  },
  [156] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(587),
    [sym_local_var] = ACTIONS(587),
    [sym_label] = ACTIONS(587),
    [sym_string] = ACTIONS(589),
    [anon_sym_RBRACE] = ACTIONS(587),
    [anon_sym_LBRACK] = ACTIONS(587),
    [anon_sym_COMMA] = ACTIONS(587),
    [anon_sym_align] = ACTIONS(589),
    [anon_sym_section] = ACTIONS(589),
    [anon_sym_partition] = ACTIONS(589),
    [anon_sym_comdat] = ACTIONS(589),
    [anon_sym_gc] = ACTIONS(589),
    [anon_sym_prefix] = ACTIONS(589),
    [anon_sym_prologue] = ACTIONS(589),
    [anon_sym_personality] = ACTIONS(589),
    [anon_sym_alignstack] = ACTIONS(589),
    [anon_sym_allocsize] = ACTIONS(589),
    [anon_sym_alwaysinline] = ACTIONS(589),
    [anon_sym_builtin] = ACTIONS(589),
    [anon_sym_cold] = ACTIONS(589),
    [anon_sym_convergent] = ACTIONS(589),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(589),
    [anon_sym_hot] = ACTIONS(589),
    [anon_sym_inaccessiblememonly] = ACTIONS(589),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(589),
    [anon_sym_inlinehint] = ACTIONS(589),
    [anon_sym_jumptable] = ACTIONS(589),
    [anon_sym_minsize] = ACTIONS(589),
    [anon_sym_naked] = ACTIONS(589),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(589),
    [anon_sym_nobuiltin] = ACTIONS(589),
    [anon_sym_noduplicate] = ACTIONS(589),
    [anon_sym_nofree] = ACTIONS(589),
    [anon_sym_noimplicitfloat] = ACTIONS(589),
    [anon_sym_noinline] = ACTIONS(589),
    [anon_sym_nomerge] = ACTIONS(589),
    [anon_sym_nonlazybind] = ACTIONS(589),
    [anon_sym_noprofile] = ACTIONS(589),
    [anon_sym_noredzone] = ACTIONS(589),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(589),
    [anon_sym_noreturn] = ACTIONS(589),
    [anon_sym_norecurse] = ACTIONS(589),
    [anon_sym_willreturn] = ACTIONS(589),
    [anon_sym_nosync] = ACTIONS(589),
    [anon_sym_nounwind] = ACTIONS(589),
    [anon_sym_nocallback] = ACTIONS(589),
    [anon_sym_nosanitize_coverage] = ACTIONS(589),
    [anon_sym_null_pointer_is_valid] = ACTIONS(589),
    [anon_sym_optforfuzzing] = ACTIONS(589),
    [anon_sym_optnone] = ACTIONS(589),
    [anon_sym_optsize] = ACTIONS(589),
    [anon_sym_readnone] = ACTIONS(589),
    [anon_sym_readonly] = ACTIONS(589),
    [anon_sym_writeonly] = ACTIONS(589),
    [anon_sym_argmemonly] = ACTIONS(589),
    [anon_sym_returns_twice] = ACTIONS(589),
    [anon_sym_safestack] = ACTIONS(589),
    [anon_sym_sanitize_address] = ACTIONS(589),
    [anon_sym_sanitize_memory] = ACTIONS(589),
    [anon_sym_sanitize_thread] = ACTIONS(589),
    [anon_sym_sanitize_hwaddress] = ACTIONS(589),
    [anon_sym_sanitize_memtag] = ACTIONS(589),
    [anon_sym_speculative_load_hardening] = ACTIONS(589),
    [anon_sym_speculatable] = ACTIONS(589),
    [anon_sym_ssp] = ACTIONS(589),
    [anon_sym_sspstrong] = ACTIONS(589),
    [anon_sym_sspreq] = ACTIONS(589),
    [anon_sym_strictfp] = ACTIONS(589),
    [anon_sym_nocf_check] = ACTIONS(589),
    [anon_sym_shadowcallstack] = ACTIONS(589),
    [anon_sym_mustprogress] = ACTIONS(589),
    [anon_sym_vscale_range] = ACTIONS(589),
    [anon_sym_preallocated] = ACTIONS(589),
    [anon_sym_zeroext] = ACTIONS(589),
    [anon_sym_signext] = ACTIONS(589),
    [anon_sym_inreg] = ACTIONS(589),
    [anon_sym_byval] = ACTIONS(589),
    [anon_sym_byref] = ACTIONS(589),
    [anon_sym_inalloca] = ACTIONS(589),
    [anon_sym_sret] = ACTIONS(589),
    [anon_sym_elementtype] = ACTIONS(589),
    [anon_sym_noalias] = ACTIONS(589),
    [anon_sym_nocapture] = ACTIONS(589),
    [anon_sym_nest] = ACTIONS(589),
    [anon_sym_returned] = ACTIONS(589),
    [anon_sym_nonnull] = ACTIONS(589),
    [anon_sym_dereferenceable] = ACTIONS(589),
    [anon_sym_dereferenceable_or_null] = ACTIONS(589),
    [anon_sym_swiftself] = ACTIONS(589),
    [anon_sym_swiftasync] = ACTIONS(589),
    [anon_sym_swifterror] = ACTIONS(589),
    [anon_sym_immarg] = ACTIONS(589),
    [anon_sym_noundef] = ACTIONS(589),
    [anon_sym_uwtable] = ACTIONS(589),
    [anon_sym_memory] = ACTIONS(589),
    [anon_sym_unreachable] = ACTIONS(589),
    [anon_sym_ret] = ACTIONS(589),
    [anon_sym_br] = ACTIONS(589),
    [anon_sym_resume] = ACTIONS(589),
    [anon_sym_freeze] = ACTIONS(589),
    [anon_sym_indirectbr] = ACTIONS(589),
    [anon_sym_extractelement] = ACTIONS(589),
    [anon_sym_insertelement] = ACTIONS(589),
    [anon_sym_select] = ACTIONS(589),
    [anon_sym_shufflevector] = ACTIONS(589),
    [anon_sym_fneg] = ACTIONS(589),
    [anon_sym_switch] = ACTIONS(589),
    [anon_sym_invoke] = ACTIONS(589),
    [anon_sym_cleanupret] = ACTIONS(589),
    [anon_sym_catchret] = ACTIONS(589),
    [anon_sym_catchswitch] = ACTIONS(589),
    [anon_sym_catchpad] = ACTIONS(589),
    [anon_sym_cleanuppad] = ACTIONS(589),
    [anon_sym_callbr] = ACTIONS(589),
    [anon_sym_icmp] = ACTIONS(589),
    [anon_sym_fcmp] = ACTIONS(589),
    [anon_sym_va_arg] = ACTIONS(589),
    [anon_sym_phi] = ACTIONS(589),
    [anon_sym_landingpad] = ACTIONS(589),
    [anon_sym_tail] = ACTIONS(589),
    [anon_sym_musttail] = ACTIONS(589),
    [anon_sym_notail] = ACTIONS(589),
    [anon_sym_call] = ACTIONS(589),
    [anon_sym_alloca] = ACTIONS(589),
    [anon_sym_load] = ACTIONS(589),
    [anon_sym_store] = ACTIONS(589),
    [anon_sym_cmpxchg] = ACTIONS(589),
    [anon_sym_atomicrmw] = ACTIONS(589),
    [anon_sym_fence] = ACTIONS(589),
    [anon_sym_getelementptr] = ACTIONS(589),
    [anon_sym_extractvalue] = ACTIONS(589),
    [anon_sym_insertvalue] = ACTIONS(589),
    [anon_sym_catch] = ACTIONS(589),
    [anon_sym_filter] = ACTIONS(589),
    [anon_sym_mul] = ACTIONS(589),
    [anon_sym_urem] = ACTIONS(589),
    [anon_sym_srem] = ACTIONS(589),
    [anon_sym_shl] = ACTIONS(589),
    [anon_sym_udiv] = ACTIONS(589),
    [anon_sym_sdiv] = ACTIONS(589),
    [anon_sym_lshr] = ACTIONS(589),
    [anon_sym_ashr] = ACTIONS(589),
    [anon_sym_fmul] = ACTIONS(589),
    [anon_sym_fdiv] = ACTIONS(589),
    [anon_sym_frem] = ACTIONS(589),
    [anon_sym_xchg] = ACTIONS(589),
    [anon_sym_add] = ACTIONS(589),
    [anon_sym_sub] = ACTIONS(589),
    [anon_sym_and] = ACTIONS(589),
    [anon_sym_nand] = ACTIONS(589),
    [anon_sym_or] = ACTIONS(589),
    [anon_sym_xor] = ACTIONS(589),
    [anon_sym_max] = ACTIONS(589),
    [anon_sym_min] = ACTIONS(589),
    [anon_sym_umax] = ACTIONS(589),
    [anon_sym_umin] = ACTIONS(589),
    [anon_sym_fadd] = ACTIONS(589),
    [anon_sym_fsub] = ACTIONS(589),
    [anon_sym_bitcast] = ACTIONS(589),
    [anon_sym_trunc] = ACTIONS(589),
    [anon_sym_zext] = ACTIONS(589),
    [anon_sym_sext] = ACTIONS(589),
    [anon_sym_fptrunc] = ACTIONS(589),
    [anon_sym_fpext] = ACTIONS(589),
    [anon_sym_addrspacecast] = ACTIONS(589),
    [anon_sym_uitofp] = ACTIONS(589),
    [anon_sym_sitofp] = ACTIONS(589),
    [anon_sym_fptoui] = ACTIONS(589),
    [anon_sym_fptosi] = ACTIONS(589),
    [anon_sym_inttoptr] = ACTIONS(589),
    [anon_sym_ptrtoint] = ACTIONS(589),
    [anon_sym_unordered] = ACTIONS(589),
    [anon_sym_monotonic] = ACTIONS(589),
    [anon_sym_acquire] = ACTIONS(589),
    [anon_sym_release] = ACTIONS(589),
    [anon_sym_acq_rel] = ACTIONS(589),
    [anon_sym_seq_cst] = ACTIONS(589),
    [anon_sym_syncscope] = ACTIONS(589),
    [anon_sym_uselistorder] = ACTIONS(589),
  },
  [157] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(689),
    [sym_local_var] = ACTIONS(689),
    [sym_label] = ACTIONS(689),
    [sym_string] = ACTIONS(691),
    [anon_sym_RBRACE] = ACTIONS(689),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_COMMA] = ACTIONS(689),
    [anon_sym_align] = ACTIONS(691),
    [anon_sym_section] = ACTIONS(691),
    [anon_sym_partition] = ACTIONS(691),
    [anon_sym_comdat] = ACTIONS(691),
    [anon_sym_gc] = ACTIONS(691),
    [anon_sym_prefix] = ACTIONS(691),
    [anon_sym_prologue] = ACTIONS(691),
    [anon_sym_personality] = ACTIONS(691),
    [anon_sym_alignstack] = ACTIONS(691),
    [anon_sym_allocsize] = ACTIONS(691),
    [anon_sym_alwaysinline] = ACTIONS(691),
    [anon_sym_builtin] = ACTIONS(691),
    [anon_sym_cold] = ACTIONS(691),
    [anon_sym_convergent] = ACTIONS(691),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(691),
    [anon_sym_hot] = ACTIONS(691),
    [anon_sym_inaccessiblememonly] = ACTIONS(691),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(691),
    [anon_sym_inlinehint] = ACTIONS(691),
    [anon_sym_jumptable] = ACTIONS(691),
    [anon_sym_minsize] = ACTIONS(691),
    [anon_sym_naked] = ACTIONS(691),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(691),
    [anon_sym_nobuiltin] = ACTIONS(691),
    [anon_sym_noduplicate] = ACTIONS(691),
    [anon_sym_nofree] = ACTIONS(691),
    [anon_sym_noimplicitfloat] = ACTIONS(691),
    [anon_sym_noinline] = ACTIONS(691),
    [anon_sym_nomerge] = ACTIONS(691),
    [anon_sym_nonlazybind] = ACTIONS(691),
    [anon_sym_noprofile] = ACTIONS(691),
    [anon_sym_noredzone] = ACTIONS(691),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(691),
    [anon_sym_noreturn] = ACTIONS(691),
    [anon_sym_norecurse] = ACTIONS(691),
    [anon_sym_willreturn] = ACTIONS(691),
    [anon_sym_nosync] = ACTIONS(691),
    [anon_sym_nounwind] = ACTIONS(691),
    [anon_sym_nocallback] = ACTIONS(691),
    [anon_sym_nosanitize_coverage] = ACTIONS(691),
    [anon_sym_null_pointer_is_valid] = ACTIONS(691),
    [anon_sym_optforfuzzing] = ACTIONS(691),
    [anon_sym_optnone] = ACTIONS(691),
    [anon_sym_optsize] = ACTIONS(691),
    [anon_sym_readnone] = ACTIONS(691),
    [anon_sym_readonly] = ACTIONS(691),
    [anon_sym_writeonly] = ACTIONS(691),
    [anon_sym_argmemonly] = ACTIONS(691),
    [anon_sym_returns_twice] = ACTIONS(691),
    [anon_sym_safestack] = ACTIONS(691),
    [anon_sym_sanitize_address] = ACTIONS(691),
    [anon_sym_sanitize_memory] = ACTIONS(691),
    [anon_sym_sanitize_thread] = ACTIONS(691),
    [anon_sym_sanitize_hwaddress] = ACTIONS(691),
    [anon_sym_sanitize_memtag] = ACTIONS(691),
    [anon_sym_speculative_load_hardening] = ACTIONS(691),
    [anon_sym_speculatable] = ACTIONS(691),
    [anon_sym_ssp] = ACTIONS(691),
    [anon_sym_sspstrong] = ACTIONS(691),
    [anon_sym_sspreq] = ACTIONS(691),
    [anon_sym_strictfp] = ACTIONS(691),
    [anon_sym_nocf_check] = ACTIONS(691),
    [anon_sym_shadowcallstack] = ACTIONS(691),
    [anon_sym_mustprogress] = ACTIONS(691),
    [anon_sym_vscale_range] = ACTIONS(691),
    [anon_sym_preallocated] = ACTIONS(691),
    [anon_sym_zeroext] = ACTIONS(691),
    [anon_sym_signext] = ACTIONS(691),
    [anon_sym_inreg] = ACTIONS(691),
    [anon_sym_byval] = ACTIONS(691),
    [anon_sym_byref] = ACTIONS(691),
    [anon_sym_inalloca] = ACTIONS(691),
    [anon_sym_sret] = ACTIONS(691),
    [anon_sym_elementtype] = ACTIONS(691),
    [anon_sym_noalias] = ACTIONS(691),
    [anon_sym_nocapture] = ACTIONS(691),
    [anon_sym_nest] = ACTIONS(691),
    [anon_sym_returned] = ACTIONS(691),
    [anon_sym_nonnull] = ACTIONS(691),
    [anon_sym_dereferenceable] = ACTIONS(691),
    [anon_sym_dereferenceable_or_null] = ACTIONS(691),
    [anon_sym_swiftself] = ACTIONS(691),
    [anon_sym_swiftasync] = ACTIONS(691),
    [anon_sym_swifterror] = ACTIONS(691),
    [anon_sym_immarg] = ACTIONS(691),
    [anon_sym_noundef] = ACTIONS(691),
    [anon_sym_uwtable] = ACTIONS(691),
    [anon_sym_memory] = ACTIONS(691),
    [anon_sym_unreachable] = ACTIONS(691),
    [anon_sym_ret] = ACTIONS(691),
    [anon_sym_br] = ACTIONS(691),
    [anon_sym_resume] = ACTIONS(691),
    [anon_sym_freeze] = ACTIONS(691),
    [anon_sym_indirectbr] = ACTIONS(691),
    [anon_sym_extractelement] = ACTIONS(691),
    [anon_sym_insertelement] = ACTIONS(691),
    [anon_sym_select] = ACTIONS(691),
    [anon_sym_shufflevector] = ACTIONS(691),
    [anon_sym_fneg] = ACTIONS(691),
    [anon_sym_switch] = ACTIONS(691),
    [anon_sym_invoke] = ACTIONS(691),
    [anon_sym_cleanupret] = ACTIONS(691),
    [anon_sym_catchret] = ACTIONS(691),
    [anon_sym_catchswitch] = ACTIONS(691),
    [anon_sym_catchpad] = ACTIONS(691),
    [anon_sym_cleanuppad] = ACTIONS(691),
    [anon_sym_callbr] = ACTIONS(691),
    [anon_sym_icmp] = ACTIONS(691),
    [anon_sym_fcmp] = ACTIONS(691),
    [anon_sym_va_arg] = ACTIONS(691),
    [anon_sym_phi] = ACTIONS(691),
    [anon_sym_landingpad] = ACTIONS(691),
    [anon_sym_tail] = ACTIONS(691),
    [anon_sym_musttail] = ACTIONS(691),
    [anon_sym_notail] = ACTIONS(691),
    [anon_sym_call] = ACTIONS(691),
    [anon_sym_alloca] = ACTIONS(691),
    [anon_sym_load] = ACTIONS(691),
    [anon_sym_store] = ACTIONS(691),
    [anon_sym_cmpxchg] = ACTIONS(691),
    [anon_sym_atomicrmw] = ACTIONS(691),
    [anon_sym_fence] = ACTIONS(691),
    [anon_sym_getelementptr] = ACTIONS(691),
    [anon_sym_extractvalue] = ACTIONS(691),
    [anon_sym_insertvalue] = ACTIONS(691),
    [anon_sym_catch] = ACTIONS(691),
    [anon_sym_filter] = ACTIONS(691),
    [anon_sym_mul] = ACTIONS(691),
    [anon_sym_urem] = ACTIONS(691),
    [anon_sym_srem] = ACTIONS(691),
    [anon_sym_shl] = ACTIONS(691),
    [anon_sym_udiv] = ACTIONS(691),
    [anon_sym_sdiv] = ACTIONS(691),
    [anon_sym_lshr] = ACTIONS(691),
    [anon_sym_ashr] = ACTIONS(691),
    [anon_sym_fmul] = ACTIONS(691),
    [anon_sym_fdiv] = ACTIONS(691),
    [anon_sym_frem] = ACTIONS(691),
    [anon_sym_xchg] = ACTIONS(691),
    [anon_sym_add] = ACTIONS(691),
    [anon_sym_sub] = ACTIONS(691),
    [anon_sym_and] = ACTIONS(691),
    [anon_sym_nand] = ACTIONS(691),
    [anon_sym_or] = ACTIONS(691),
    [anon_sym_xor] = ACTIONS(691),
    [anon_sym_max] = ACTIONS(691),
    [anon_sym_min] = ACTIONS(691),
    [anon_sym_umax] = ACTIONS(691),
    [anon_sym_umin] = ACTIONS(691),
    [anon_sym_fadd] = ACTIONS(691),
    [anon_sym_fsub] = ACTIONS(691),
    [anon_sym_bitcast] = ACTIONS(691),
    [anon_sym_trunc] = ACTIONS(691),
    [anon_sym_zext] = ACTIONS(691),
    [anon_sym_sext] = ACTIONS(691),
    [anon_sym_fptrunc] = ACTIONS(691),
    [anon_sym_fpext] = ACTIONS(691),
    [anon_sym_addrspacecast] = ACTIONS(691),
    [anon_sym_uitofp] = ACTIONS(691),
    [anon_sym_sitofp] = ACTIONS(691),
    [anon_sym_fptoui] = ACTIONS(691),
    [anon_sym_fptosi] = ACTIONS(691),
    [anon_sym_inttoptr] = ACTIONS(691),
    [anon_sym_ptrtoint] = ACTIONS(691),
    [anon_sym_unordered] = ACTIONS(691),
    [anon_sym_monotonic] = ACTIONS(691),
    [anon_sym_acquire] = ACTIONS(691),
    [anon_sym_release] = ACTIONS(691),
    [anon_sym_acq_rel] = ACTIONS(691),
    [anon_sym_seq_cst] = ACTIONS(691),
    [anon_sym_syncscope] = ACTIONS(691),
    [anon_sym_uselistorder] = ACTIONS(691),
  },
  [158] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(685),
    [sym_local_var] = ACTIONS(685),
    [sym_label] = ACTIONS(685),
    [sym_string] = ACTIONS(687),
    [anon_sym_RBRACE] = ACTIONS(685),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_COMMA] = ACTIONS(685),
    [anon_sym_align] = ACTIONS(687),
    [anon_sym_section] = ACTIONS(687),
    [anon_sym_partition] = ACTIONS(687),
    [anon_sym_comdat] = ACTIONS(687),
    [anon_sym_gc] = ACTIONS(687),
    [anon_sym_prefix] = ACTIONS(687),
    [anon_sym_prologue] = ACTIONS(687),
    [anon_sym_personality] = ACTIONS(687),
    [anon_sym_alignstack] = ACTIONS(687),
    [anon_sym_allocsize] = ACTIONS(687),
    [anon_sym_alwaysinline] = ACTIONS(687),
    [anon_sym_builtin] = ACTIONS(687),
    [anon_sym_cold] = ACTIONS(687),
    [anon_sym_convergent] = ACTIONS(687),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(687),
    [anon_sym_hot] = ACTIONS(687),
    [anon_sym_inaccessiblememonly] = ACTIONS(687),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(687),
    [anon_sym_inlinehint] = ACTIONS(687),
    [anon_sym_jumptable] = ACTIONS(687),
    [anon_sym_minsize] = ACTIONS(687),
    [anon_sym_naked] = ACTIONS(687),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(687),
    [anon_sym_nobuiltin] = ACTIONS(687),
    [anon_sym_noduplicate] = ACTIONS(687),
    [anon_sym_nofree] = ACTIONS(687),
    [anon_sym_noimplicitfloat] = ACTIONS(687),
    [anon_sym_noinline] = ACTIONS(687),
    [anon_sym_nomerge] = ACTIONS(687),
    [anon_sym_nonlazybind] = ACTIONS(687),
    [anon_sym_noprofile] = ACTIONS(687),
    [anon_sym_noredzone] = ACTIONS(687),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(687),
    [anon_sym_noreturn] = ACTIONS(687),
    [anon_sym_norecurse] = ACTIONS(687),
    [anon_sym_willreturn] = ACTIONS(687),
    [anon_sym_nosync] = ACTIONS(687),
    [anon_sym_nounwind] = ACTIONS(687),
    [anon_sym_nocallback] = ACTIONS(687),
    [anon_sym_nosanitize_coverage] = ACTIONS(687),
    [anon_sym_null_pointer_is_valid] = ACTIONS(687),
    [anon_sym_optforfuzzing] = ACTIONS(687),
    [anon_sym_optnone] = ACTIONS(687),
    [anon_sym_optsize] = ACTIONS(687),
    [anon_sym_readnone] = ACTIONS(687),
    [anon_sym_readonly] = ACTIONS(687),
    [anon_sym_writeonly] = ACTIONS(687),
    [anon_sym_argmemonly] = ACTIONS(687),
    [anon_sym_returns_twice] = ACTIONS(687),
    [anon_sym_safestack] = ACTIONS(687),
    [anon_sym_sanitize_address] = ACTIONS(687),
    [anon_sym_sanitize_memory] = ACTIONS(687),
    [anon_sym_sanitize_thread] = ACTIONS(687),
    [anon_sym_sanitize_hwaddress] = ACTIONS(687),
    [anon_sym_sanitize_memtag] = ACTIONS(687),
    [anon_sym_speculative_load_hardening] = ACTIONS(687),
    [anon_sym_speculatable] = ACTIONS(687),
    [anon_sym_ssp] = ACTIONS(687),
    [anon_sym_sspstrong] = ACTIONS(687),
    [anon_sym_sspreq] = ACTIONS(687),
    [anon_sym_strictfp] = ACTIONS(687),
    [anon_sym_nocf_check] = ACTIONS(687),
    [anon_sym_shadowcallstack] = ACTIONS(687),
    [anon_sym_mustprogress] = ACTIONS(687),
    [anon_sym_vscale_range] = ACTIONS(687),
    [anon_sym_preallocated] = ACTIONS(687),
    [anon_sym_zeroext] = ACTIONS(687),
    [anon_sym_signext] = ACTIONS(687),
    [anon_sym_inreg] = ACTIONS(687),
    [anon_sym_byval] = ACTIONS(687),
    [anon_sym_byref] = ACTIONS(687),
    [anon_sym_inalloca] = ACTIONS(687),
    [anon_sym_sret] = ACTIONS(687),
    [anon_sym_elementtype] = ACTIONS(687),
    [anon_sym_noalias] = ACTIONS(687),
    [anon_sym_nocapture] = ACTIONS(687),
    [anon_sym_nest] = ACTIONS(687),
    [anon_sym_returned] = ACTIONS(687),
    [anon_sym_nonnull] = ACTIONS(687),
    [anon_sym_dereferenceable] = ACTIONS(687),
    [anon_sym_dereferenceable_or_null] = ACTIONS(687),
    [anon_sym_swiftself] = ACTIONS(687),
    [anon_sym_swiftasync] = ACTIONS(687),
    [anon_sym_swifterror] = ACTIONS(687),
    [anon_sym_immarg] = ACTIONS(687),
    [anon_sym_noundef] = ACTIONS(687),
    [anon_sym_uwtable] = ACTIONS(687),
    [anon_sym_memory] = ACTIONS(687),
    [anon_sym_unreachable] = ACTIONS(687),
    [anon_sym_ret] = ACTIONS(687),
    [anon_sym_br] = ACTIONS(687),
    [anon_sym_resume] = ACTIONS(687),
    [anon_sym_freeze] = ACTIONS(687),
    [anon_sym_indirectbr] = ACTIONS(687),
    [anon_sym_extractelement] = ACTIONS(687),
    [anon_sym_insertelement] = ACTIONS(687),
    [anon_sym_select] = ACTIONS(687),
    [anon_sym_shufflevector] = ACTIONS(687),
    [anon_sym_fneg] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_invoke] = ACTIONS(687),
    [anon_sym_cleanupret] = ACTIONS(687),
    [anon_sym_catchret] = ACTIONS(687),
    [anon_sym_catchswitch] = ACTIONS(687),
    [anon_sym_catchpad] = ACTIONS(687),
    [anon_sym_cleanuppad] = ACTIONS(687),
    [anon_sym_callbr] = ACTIONS(687),
    [anon_sym_icmp] = ACTIONS(687),
    [anon_sym_fcmp] = ACTIONS(687),
    [anon_sym_va_arg] = ACTIONS(687),
    [anon_sym_phi] = ACTIONS(687),
    [anon_sym_landingpad] = ACTIONS(687),
    [anon_sym_tail] = ACTIONS(687),
    [anon_sym_musttail] = ACTIONS(687),
    [anon_sym_notail] = ACTIONS(687),
    [anon_sym_call] = ACTIONS(687),
    [anon_sym_alloca] = ACTIONS(687),
    [anon_sym_load] = ACTIONS(687),
    [anon_sym_store] = ACTIONS(687),
    [anon_sym_cmpxchg] = ACTIONS(687),
    [anon_sym_atomicrmw] = ACTIONS(687),
    [anon_sym_fence] = ACTIONS(687),
    [anon_sym_getelementptr] = ACTIONS(687),
    [anon_sym_extractvalue] = ACTIONS(687),
    [anon_sym_insertvalue] = ACTIONS(687),
    [anon_sym_catch] = ACTIONS(687),
    [anon_sym_filter] = ACTIONS(687),
    [anon_sym_mul] = ACTIONS(687),
    [anon_sym_urem] = ACTIONS(687),
    [anon_sym_srem] = ACTIONS(687),
    [anon_sym_shl] = ACTIONS(687),
    [anon_sym_udiv] = ACTIONS(687),
    [anon_sym_sdiv] = ACTIONS(687),
    [anon_sym_lshr] = ACTIONS(687),
    [anon_sym_ashr] = ACTIONS(687),
    [anon_sym_fmul] = ACTIONS(687),
    [anon_sym_fdiv] = ACTIONS(687),
    [anon_sym_frem] = ACTIONS(687),
    [anon_sym_xchg] = ACTIONS(687),
    [anon_sym_add] = ACTIONS(687),
    [anon_sym_sub] = ACTIONS(687),
    [anon_sym_and] = ACTIONS(687),
    [anon_sym_nand] = ACTIONS(687),
    [anon_sym_or] = ACTIONS(687),
    [anon_sym_xor] = ACTIONS(687),
    [anon_sym_max] = ACTIONS(687),
    [anon_sym_min] = ACTIONS(687),
    [anon_sym_umax] = ACTIONS(687),
    [anon_sym_umin] = ACTIONS(687),
    [anon_sym_fadd] = ACTIONS(687),
    [anon_sym_fsub] = ACTIONS(687),
    [anon_sym_bitcast] = ACTIONS(687),
    [anon_sym_trunc] = ACTIONS(687),
    [anon_sym_zext] = ACTIONS(687),
    [anon_sym_sext] = ACTIONS(687),
    [anon_sym_fptrunc] = ACTIONS(687),
    [anon_sym_fpext] = ACTIONS(687),
    [anon_sym_addrspacecast] = ACTIONS(687),
    [anon_sym_uitofp] = ACTIONS(687),
    [anon_sym_sitofp] = ACTIONS(687),
    [anon_sym_fptoui] = ACTIONS(687),
    [anon_sym_fptosi] = ACTIONS(687),
    [anon_sym_inttoptr] = ACTIONS(687),
    [anon_sym_ptrtoint] = ACTIONS(687),
    [anon_sym_unordered] = ACTIONS(687),
    [anon_sym_monotonic] = ACTIONS(687),
    [anon_sym_acquire] = ACTIONS(687),
    [anon_sym_release] = ACTIONS(687),
    [anon_sym_acq_rel] = ACTIONS(687),
    [anon_sym_seq_cst] = ACTIONS(687),
    [anon_sym_syncscope] = ACTIONS(687),
    [anon_sym_uselistorder] = ACTIONS(687),
  },
  [159] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(591),
    [sym_local_var] = ACTIONS(591),
    [sym_label] = ACTIONS(591),
    [sym_string] = ACTIONS(593),
    [anon_sym_RBRACE] = ACTIONS(591),
    [anon_sym_LBRACK] = ACTIONS(591),
    [anon_sym_COMMA] = ACTIONS(591),
    [anon_sym_align] = ACTIONS(593),
    [anon_sym_section] = ACTIONS(593),
    [anon_sym_partition] = ACTIONS(593),
    [anon_sym_comdat] = ACTIONS(593),
    [anon_sym_gc] = ACTIONS(593),
    [anon_sym_prefix] = ACTIONS(593),
    [anon_sym_prologue] = ACTIONS(593),
    [anon_sym_personality] = ACTIONS(593),
    [anon_sym_alignstack] = ACTIONS(593),
    [anon_sym_allocsize] = ACTIONS(593),
    [anon_sym_alwaysinline] = ACTIONS(593),
    [anon_sym_builtin] = ACTIONS(593),
    [anon_sym_cold] = ACTIONS(593),
    [anon_sym_convergent] = ACTIONS(593),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(593),
    [anon_sym_hot] = ACTIONS(593),
    [anon_sym_inaccessiblememonly] = ACTIONS(593),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(593),
    [anon_sym_inlinehint] = ACTIONS(593),
    [anon_sym_jumptable] = ACTIONS(593),
    [anon_sym_minsize] = ACTIONS(593),
    [anon_sym_naked] = ACTIONS(593),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(593),
    [anon_sym_nobuiltin] = ACTIONS(593),
    [anon_sym_noduplicate] = ACTIONS(593),
    [anon_sym_nofree] = ACTIONS(593),
    [anon_sym_noimplicitfloat] = ACTIONS(593),
    [anon_sym_noinline] = ACTIONS(593),
    [anon_sym_nomerge] = ACTIONS(593),
    [anon_sym_nonlazybind] = ACTIONS(593),
    [anon_sym_noprofile] = ACTIONS(593),
    [anon_sym_noredzone] = ACTIONS(593),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(593),
    [anon_sym_noreturn] = ACTIONS(593),
    [anon_sym_norecurse] = ACTIONS(593),
    [anon_sym_willreturn] = ACTIONS(593),
    [anon_sym_nosync] = ACTIONS(593),
    [anon_sym_nounwind] = ACTIONS(593),
    [anon_sym_nocallback] = ACTIONS(593),
    [anon_sym_nosanitize_coverage] = ACTIONS(593),
    [anon_sym_null_pointer_is_valid] = ACTIONS(593),
    [anon_sym_optforfuzzing] = ACTIONS(593),
    [anon_sym_optnone] = ACTIONS(593),
    [anon_sym_optsize] = ACTIONS(593),
    [anon_sym_readnone] = ACTIONS(593),
    [anon_sym_readonly] = ACTIONS(593),
    [anon_sym_writeonly] = ACTIONS(593),
    [anon_sym_argmemonly] = ACTIONS(593),
    [anon_sym_returns_twice] = ACTIONS(593),
    [anon_sym_safestack] = ACTIONS(593),
    [anon_sym_sanitize_address] = ACTIONS(593),
    [anon_sym_sanitize_memory] = ACTIONS(593),
    [anon_sym_sanitize_thread] = ACTIONS(593),
    [anon_sym_sanitize_hwaddress] = ACTIONS(593),
    [anon_sym_sanitize_memtag] = ACTIONS(593),
    [anon_sym_speculative_load_hardening] = ACTIONS(593),
    [anon_sym_speculatable] = ACTIONS(593),
    [anon_sym_ssp] = ACTIONS(593),
    [anon_sym_sspstrong] = ACTIONS(593),
    [anon_sym_sspreq] = ACTIONS(593),
    [anon_sym_strictfp] = ACTIONS(593),
    [anon_sym_nocf_check] = ACTIONS(593),
    [anon_sym_shadowcallstack] = ACTIONS(593),
    [anon_sym_mustprogress] = ACTIONS(593),
    [anon_sym_vscale_range] = ACTIONS(593),
    [anon_sym_preallocated] = ACTIONS(593),
    [anon_sym_zeroext] = ACTIONS(593),
    [anon_sym_signext] = ACTIONS(593),
    [anon_sym_inreg] = ACTIONS(593),
    [anon_sym_byval] = ACTIONS(593),
    [anon_sym_byref] = ACTIONS(593),
    [anon_sym_inalloca] = ACTIONS(593),
    [anon_sym_sret] = ACTIONS(593),
    [anon_sym_elementtype] = ACTIONS(593),
    [anon_sym_noalias] = ACTIONS(593),
    [anon_sym_nocapture] = ACTIONS(593),
    [anon_sym_nest] = ACTIONS(593),
    [anon_sym_returned] = ACTIONS(593),
    [anon_sym_nonnull] = ACTIONS(593),
    [anon_sym_dereferenceable] = ACTIONS(593),
    [anon_sym_dereferenceable_or_null] = ACTIONS(593),
    [anon_sym_swiftself] = ACTIONS(593),
    [anon_sym_swiftasync] = ACTIONS(593),
    [anon_sym_swifterror] = ACTIONS(593),
    [anon_sym_immarg] = ACTIONS(593),
    [anon_sym_noundef] = ACTIONS(593),
    [anon_sym_uwtable] = ACTIONS(593),
    [anon_sym_memory] = ACTIONS(593),
    [anon_sym_unreachable] = ACTIONS(593),
    [anon_sym_ret] = ACTIONS(593),
    [anon_sym_br] = ACTIONS(593),
    [anon_sym_resume] = ACTIONS(593),
    [anon_sym_freeze] = ACTIONS(593),
    [anon_sym_indirectbr] = ACTIONS(593),
    [anon_sym_extractelement] = ACTIONS(593),
    [anon_sym_insertelement] = ACTIONS(593),
    [anon_sym_select] = ACTIONS(593),
    [anon_sym_shufflevector] = ACTIONS(593),
    [anon_sym_fneg] = ACTIONS(593),
    [anon_sym_switch] = ACTIONS(593),
    [anon_sym_invoke] = ACTIONS(593),
    [anon_sym_cleanupret] = ACTIONS(593),
    [anon_sym_catchret] = ACTIONS(593),
    [anon_sym_catchswitch] = ACTIONS(593),
    [anon_sym_catchpad] = ACTIONS(593),
    [anon_sym_cleanuppad] = ACTIONS(593),
    [anon_sym_callbr] = ACTIONS(593),
    [anon_sym_icmp] = ACTIONS(593),
    [anon_sym_fcmp] = ACTIONS(593),
    [anon_sym_va_arg] = ACTIONS(593),
    [anon_sym_phi] = ACTIONS(593),
    [anon_sym_landingpad] = ACTIONS(593),
    [anon_sym_tail] = ACTIONS(593),
    [anon_sym_musttail] = ACTIONS(593),
    [anon_sym_notail] = ACTIONS(593),
    [anon_sym_call] = ACTIONS(593),
    [anon_sym_alloca] = ACTIONS(593),
    [anon_sym_load] = ACTIONS(593),
    [anon_sym_store] = ACTIONS(593),
    [anon_sym_cmpxchg] = ACTIONS(593),
    [anon_sym_atomicrmw] = ACTIONS(593),
    [anon_sym_fence] = ACTIONS(593),
    [anon_sym_getelementptr] = ACTIONS(593),
    [anon_sym_extractvalue] = ACTIONS(593),
    [anon_sym_insertvalue] = ACTIONS(593),
    [anon_sym_catch] = ACTIONS(593),
    [anon_sym_filter] = ACTIONS(593),
    [anon_sym_mul] = ACTIONS(593),
    [anon_sym_urem] = ACTIONS(593),
    [anon_sym_srem] = ACTIONS(593),
    [anon_sym_shl] = ACTIONS(593),
    [anon_sym_udiv] = ACTIONS(593),
    [anon_sym_sdiv] = ACTIONS(593),
    [anon_sym_lshr] = ACTIONS(593),
    [anon_sym_ashr] = ACTIONS(593),
    [anon_sym_fmul] = ACTIONS(593),
    [anon_sym_fdiv] = ACTIONS(593),
    [anon_sym_frem] = ACTIONS(593),
    [anon_sym_xchg] = ACTIONS(593),
    [anon_sym_add] = ACTIONS(593),
    [anon_sym_sub] = ACTIONS(593),
    [anon_sym_and] = ACTIONS(593),
    [anon_sym_nand] = ACTIONS(593),
    [anon_sym_or] = ACTIONS(593),
    [anon_sym_xor] = ACTIONS(593),
    [anon_sym_max] = ACTIONS(593),
    [anon_sym_min] = ACTIONS(593),
    [anon_sym_umax] = ACTIONS(593),
    [anon_sym_umin] = ACTIONS(593),
    [anon_sym_fadd] = ACTIONS(593),
    [anon_sym_fsub] = ACTIONS(593),
    [anon_sym_bitcast] = ACTIONS(593),
    [anon_sym_trunc] = ACTIONS(593),
    [anon_sym_zext] = ACTIONS(593),
    [anon_sym_sext] = ACTIONS(593),
    [anon_sym_fptrunc] = ACTIONS(593),
    [anon_sym_fpext] = ACTIONS(593),
    [anon_sym_addrspacecast] = ACTIONS(593),
    [anon_sym_uitofp] = ACTIONS(593),
    [anon_sym_sitofp] = ACTIONS(593),
    [anon_sym_fptoui] = ACTIONS(593),
    [anon_sym_fptosi] = ACTIONS(593),
    [anon_sym_inttoptr] = ACTIONS(593),
    [anon_sym_ptrtoint] = ACTIONS(593),
    [anon_sym_unordered] = ACTIONS(593),
    [anon_sym_monotonic] = ACTIONS(593),
    [anon_sym_acquire] = ACTIONS(593),
    [anon_sym_release] = ACTIONS(593),
    [anon_sym_acq_rel] = ACTIONS(593),
    [anon_sym_seq_cst] = ACTIONS(593),
    [anon_sym_syncscope] = ACTIONS(593),
    [anon_sym_uselistorder] = ACTIONS(593),
  },
  [160] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(709),
    [sym_local_var] = ACTIONS(709),
    [sym_label] = ACTIONS(709),
    [sym_string] = ACTIONS(711),
    [anon_sym_RBRACE] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(709),
    [anon_sym_COMMA] = ACTIONS(709),
    [anon_sym_align] = ACTIONS(711),
    [anon_sym_section] = ACTIONS(711),
    [anon_sym_partition] = ACTIONS(711),
    [anon_sym_comdat] = ACTIONS(711),
    [anon_sym_gc] = ACTIONS(711),
    [anon_sym_prefix] = ACTIONS(711),
    [anon_sym_prologue] = ACTIONS(711),
    [anon_sym_personality] = ACTIONS(711),
    [anon_sym_alignstack] = ACTIONS(711),
    [anon_sym_allocsize] = ACTIONS(711),
    [anon_sym_alwaysinline] = ACTIONS(711),
    [anon_sym_builtin] = ACTIONS(711),
    [anon_sym_cold] = ACTIONS(711),
    [anon_sym_convergent] = ACTIONS(711),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(711),
    [anon_sym_hot] = ACTIONS(711),
    [anon_sym_inaccessiblememonly] = ACTIONS(711),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(711),
    [anon_sym_inlinehint] = ACTIONS(711),
    [anon_sym_jumptable] = ACTIONS(711),
    [anon_sym_minsize] = ACTIONS(711),
    [anon_sym_naked] = ACTIONS(711),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(711),
    [anon_sym_nobuiltin] = ACTIONS(711),
    [anon_sym_noduplicate] = ACTIONS(711),
    [anon_sym_nofree] = ACTIONS(711),
    [anon_sym_noimplicitfloat] = ACTIONS(711),
    [anon_sym_noinline] = ACTIONS(711),
    [anon_sym_nomerge] = ACTIONS(711),
    [anon_sym_nonlazybind] = ACTIONS(711),
    [anon_sym_noprofile] = ACTIONS(711),
    [anon_sym_noredzone] = ACTIONS(711),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(711),
    [anon_sym_noreturn] = ACTIONS(711),
    [anon_sym_norecurse] = ACTIONS(711),
    [anon_sym_willreturn] = ACTIONS(711),
    [anon_sym_nosync] = ACTIONS(711),
    [anon_sym_nounwind] = ACTIONS(711),
    [anon_sym_nocallback] = ACTIONS(711),
    [anon_sym_nosanitize_coverage] = ACTIONS(711),
    [anon_sym_null_pointer_is_valid] = ACTIONS(711),
    [anon_sym_optforfuzzing] = ACTIONS(711),
    [anon_sym_optnone] = ACTIONS(711),
    [anon_sym_optsize] = ACTIONS(711),
    [anon_sym_readnone] = ACTIONS(711),
    [anon_sym_readonly] = ACTIONS(711),
    [anon_sym_writeonly] = ACTIONS(711),
    [anon_sym_argmemonly] = ACTIONS(711),
    [anon_sym_returns_twice] = ACTIONS(711),
    [anon_sym_safestack] = ACTIONS(711),
    [anon_sym_sanitize_address] = ACTIONS(711),
    [anon_sym_sanitize_memory] = ACTIONS(711),
    [anon_sym_sanitize_thread] = ACTIONS(711),
    [anon_sym_sanitize_hwaddress] = ACTIONS(711),
    [anon_sym_sanitize_memtag] = ACTIONS(711),
    [anon_sym_speculative_load_hardening] = ACTIONS(711),
    [anon_sym_speculatable] = ACTIONS(711),
    [anon_sym_ssp] = ACTIONS(711),
    [anon_sym_sspstrong] = ACTIONS(711),
    [anon_sym_sspreq] = ACTIONS(711),
    [anon_sym_strictfp] = ACTIONS(711),
    [anon_sym_nocf_check] = ACTIONS(711),
    [anon_sym_shadowcallstack] = ACTIONS(711),
    [anon_sym_mustprogress] = ACTIONS(711),
    [anon_sym_vscale_range] = ACTIONS(711),
    [anon_sym_preallocated] = ACTIONS(711),
    [anon_sym_zeroext] = ACTIONS(711),
    [anon_sym_signext] = ACTIONS(711),
    [anon_sym_inreg] = ACTIONS(711),
    [anon_sym_byval] = ACTIONS(711),
    [anon_sym_byref] = ACTIONS(711),
    [anon_sym_inalloca] = ACTIONS(711),
    [anon_sym_sret] = ACTIONS(711),
    [anon_sym_elementtype] = ACTIONS(711),
    [anon_sym_noalias] = ACTIONS(711),
    [anon_sym_nocapture] = ACTIONS(711),
    [anon_sym_nest] = ACTIONS(711),
    [anon_sym_returned] = ACTIONS(711),
    [anon_sym_nonnull] = ACTIONS(711),
    [anon_sym_dereferenceable] = ACTIONS(711),
    [anon_sym_dereferenceable_or_null] = ACTIONS(711),
    [anon_sym_swiftself] = ACTIONS(711),
    [anon_sym_swiftasync] = ACTIONS(711),
    [anon_sym_swifterror] = ACTIONS(711),
    [anon_sym_immarg] = ACTIONS(711),
    [anon_sym_noundef] = ACTIONS(711),
    [anon_sym_uwtable] = ACTIONS(711),
    [anon_sym_memory] = ACTIONS(711),
    [anon_sym_unreachable] = ACTIONS(711),
    [anon_sym_ret] = ACTIONS(711),
    [anon_sym_br] = ACTIONS(711),
    [anon_sym_resume] = ACTIONS(711),
    [anon_sym_freeze] = ACTIONS(711),
    [anon_sym_indirectbr] = ACTIONS(711),
    [anon_sym_extractelement] = ACTIONS(711),
    [anon_sym_insertelement] = ACTIONS(711),
    [anon_sym_select] = ACTIONS(711),
    [anon_sym_shufflevector] = ACTIONS(711),
    [anon_sym_fneg] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_invoke] = ACTIONS(711),
    [anon_sym_cleanupret] = ACTIONS(711),
    [anon_sym_catchret] = ACTIONS(711),
    [anon_sym_catchswitch] = ACTIONS(711),
    [anon_sym_catchpad] = ACTIONS(711),
    [anon_sym_cleanuppad] = ACTIONS(711),
    [anon_sym_callbr] = ACTIONS(711),
    [anon_sym_icmp] = ACTIONS(711),
    [anon_sym_fcmp] = ACTIONS(711),
    [anon_sym_va_arg] = ACTIONS(711),
    [anon_sym_phi] = ACTIONS(711),
    [anon_sym_landingpad] = ACTIONS(711),
    [anon_sym_tail] = ACTIONS(711),
    [anon_sym_musttail] = ACTIONS(711),
    [anon_sym_notail] = ACTIONS(711),
    [anon_sym_call] = ACTIONS(711),
    [anon_sym_alloca] = ACTIONS(711),
    [anon_sym_load] = ACTIONS(711),
    [anon_sym_store] = ACTIONS(711),
    [anon_sym_cmpxchg] = ACTIONS(711),
    [anon_sym_atomicrmw] = ACTIONS(711),
    [anon_sym_fence] = ACTIONS(711),
    [anon_sym_getelementptr] = ACTIONS(711),
    [anon_sym_extractvalue] = ACTIONS(711),
    [anon_sym_insertvalue] = ACTIONS(711),
    [anon_sym_catch] = ACTIONS(711),
    [anon_sym_filter] = ACTIONS(711),
    [anon_sym_mul] = ACTIONS(711),
    [anon_sym_urem] = ACTIONS(711),
    [anon_sym_srem] = ACTIONS(711),
    [anon_sym_shl] = ACTIONS(711),
    [anon_sym_udiv] = ACTIONS(711),
    [anon_sym_sdiv] = ACTIONS(711),
    [anon_sym_lshr] = ACTIONS(711),
    [anon_sym_ashr] = ACTIONS(711),
    [anon_sym_fmul] = ACTIONS(711),
    [anon_sym_fdiv] = ACTIONS(711),
    [anon_sym_frem] = ACTIONS(711),
    [anon_sym_xchg] = ACTIONS(711),
    [anon_sym_add] = ACTIONS(711),
    [anon_sym_sub] = ACTIONS(711),
    [anon_sym_and] = ACTIONS(711),
    [anon_sym_nand] = ACTIONS(711),
    [anon_sym_or] = ACTIONS(711),
    [anon_sym_xor] = ACTIONS(711),
    [anon_sym_max] = ACTIONS(711),
    [anon_sym_min] = ACTIONS(711),
    [anon_sym_umax] = ACTIONS(711),
    [anon_sym_umin] = ACTIONS(711),
    [anon_sym_fadd] = ACTIONS(711),
    [anon_sym_fsub] = ACTIONS(711),
    [anon_sym_bitcast] = ACTIONS(711),
    [anon_sym_trunc] = ACTIONS(711),
    [anon_sym_zext] = ACTIONS(711),
    [anon_sym_sext] = ACTIONS(711),
    [anon_sym_fptrunc] = ACTIONS(711),
    [anon_sym_fpext] = ACTIONS(711),
    [anon_sym_addrspacecast] = ACTIONS(711),
    [anon_sym_uitofp] = ACTIONS(711),
    [anon_sym_sitofp] = ACTIONS(711),
    [anon_sym_fptoui] = ACTIONS(711),
    [anon_sym_fptosi] = ACTIONS(711),
    [anon_sym_inttoptr] = ACTIONS(711),
    [anon_sym_ptrtoint] = ACTIONS(711),
    [anon_sym_unordered] = ACTIONS(711),
    [anon_sym_monotonic] = ACTIONS(711),
    [anon_sym_acquire] = ACTIONS(711),
    [anon_sym_release] = ACTIONS(711),
    [anon_sym_acq_rel] = ACTIONS(711),
    [anon_sym_seq_cst] = ACTIONS(711),
    [anon_sym_syncscope] = ACTIONS(711),
    [anon_sym_uselistorder] = ACTIONS(711),
  },
  [161] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(679),
    [sym_local_var] = ACTIONS(679),
    [sym_label] = ACTIONS(679),
    [sym_string] = ACTIONS(681),
    [anon_sym_RBRACE] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(679),
    [anon_sym_COMMA] = ACTIONS(679),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_section] = ACTIONS(681),
    [anon_sym_partition] = ACTIONS(681),
    [anon_sym_comdat] = ACTIONS(681),
    [anon_sym_gc] = ACTIONS(681),
    [anon_sym_prefix] = ACTIONS(681),
    [anon_sym_prologue] = ACTIONS(681),
    [anon_sym_personality] = ACTIONS(681),
    [anon_sym_alignstack] = ACTIONS(681),
    [anon_sym_allocsize] = ACTIONS(681),
    [anon_sym_alwaysinline] = ACTIONS(681),
    [anon_sym_builtin] = ACTIONS(681),
    [anon_sym_cold] = ACTIONS(681),
    [anon_sym_convergent] = ACTIONS(681),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(681),
    [anon_sym_hot] = ACTIONS(681),
    [anon_sym_inaccessiblememonly] = ACTIONS(681),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(681),
    [anon_sym_inlinehint] = ACTIONS(681),
    [anon_sym_jumptable] = ACTIONS(681),
    [anon_sym_minsize] = ACTIONS(681),
    [anon_sym_naked] = ACTIONS(681),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(681),
    [anon_sym_nobuiltin] = ACTIONS(681),
    [anon_sym_noduplicate] = ACTIONS(681),
    [anon_sym_nofree] = ACTIONS(681),
    [anon_sym_noimplicitfloat] = ACTIONS(681),
    [anon_sym_noinline] = ACTIONS(681),
    [anon_sym_nomerge] = ACTIONS(681),
    [anon_sym_nonlazybind] = ACTIONS(681),
    [anon_sym_noprofile] = ACTIONS(681),
    [anon_sym_noredzone] = ACTIONS(681),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(681),
    [anon_sym_noreturn] = ACTIONS(681),
    [anon_sym_norecurse] = ACTIONS(681),
    [anon_sym_willreturn] = ACTIONS(681),
    [anon_sym_nosync] = ACTIONS(681),
    [anon_sym_nounwind] = ACTIONS(681),
    [anon_sym_nocallback] = ACTIONS(681),
    [anon_sym_nosanitize_coverage] = ACTIONS(681),
    [anon_sym_null_pointer_is_valid] = ACTIONS(681),
    [anon_sym_optforfuzzing] = ACTIONS(681),
    [anon_sym_optnone] = ACTIONS(681),
    [anon_sym_optsize] = ACTIONS(681),
    [anon_sym_readnone] = ACTIONS(681),
    [anon_sym_readonly] = ACTIONS(681),
    [anon_sym_writeonly] = ACTIONS(681),
    [anon_sym_argmemonly] = ACTIONS(681),
    [anon_sym_returns_twice] = ACTIONS(681),
    [anon_sym_safestack] = ACTIONS(681),
    [anon_sym_sanitize_address] = ACTIONS(681),
    [anon_sym_sanitize_memory] = ACTIONS(681),
    [anon_sym_sanitize_thread] = ACTIONS(681),
    [anon_sym_sanitize_hwaddress] = ACTIONS(681),
    [anon_sym_sanitize_memtag] = ACTIONS(681),
    [anon_sym_speculative_load_hardening] = ACTIONS(681),
    [anon_sym_speculatable] = ACTIONS(681),
    [anon_sym_ssp] = ACTIONS(681),
    [anon_sym_sspstrong] = ACTIONS(681),
    [anon_sym_sspreq] = ACTIONS(681),
    [anon_sym_strictfp] = ACTIONS(681),
    [anon_sym_nocf_check] = ACTIONS(681),
    [anon_sym_shadowcallstack] = ACTIONS(681),
    [anon_sym_mustprogress] = ACTIONS(681),
    [anon_sym_vscale_range] = ACTIONS(681),
    [anon_sym_preallocated] = ACTIONS(681),
    [anon_sym_zeroext] = ACTIONS(681),
    [anon_sym_signext] = ACTIONS(681),
    [anon_sym_inreg] = ACTIONS(681),
    [anon_sym_byval] = ACTIONS(681),
    [anon_sym_byref] = ACTIONS(681),
    [anon_sym_inalloca] = ACTIONS(681),
    [anon_sym_sret] = ACTIONS(681),
    [anon_sym_elementtype] = ACTIONS(681),
    [anon_sym_noalias] = ACTIONS(681),
    [anon_sym_nocapture] = ACTIONS(681),
    [anon_sym_nest] = ACTIONS(681),
    [anon_sym_returned] = ACTIONS(681),
    [anon_sym_nonnull] = ACTIONS(681),
    [anon_sym_dereferenceable] = ACTIONS(681),
    [anon_sym_dereferenceable_or_null] = ACTIONS(681),
    [anon_sym_swiftself] = ACTIONS(681),
    [anon_sym_swiftasync] = ACTIONS(681),
    [anon_sym_swifterror] = ACTIONS(681),
    [anon_sym_immarg] = ACTIONS(681),
    [anon_sym_noundef] = ACTIONS(681),
    [anon_sym_uwtable] = ACTIONS(681),
    [anon_sym_memory] = ACTIONS(681),
    [anon_sym_unreachable] = ACTIONS(681),
    [anon_sym_ret] = ACTIONS(681),
    [anon_sym_br] = ACTIONS(681),
    [anon_sym_resume] = ACTIONS(681),
    [anon_sym_freeze] = ACTIONS(681),
    [anon_sym_indirectbr] = ACTIONS(681),
    [anon_sym_extractelement] = ACTIONS(681),
    [anon_sym_insertelement] = ACTIONS(681),
    [anon_sym_select] = ACTIONS(681),
    [anon_sym_shufflevector] = ACTIONS(681),
    [anon_sym_fneg] = ACTIONS(681),
    [anon_sym_switch] = ACTIONS(681),
    [anon_sym_invoke] = ACTIONS(681),
    [anon_sym_cleanupret] = ACTIONS(681),
    [anon_sym_catchret] = ACTIONS(681),
    [anon_sym_catchswitch] = ACTIONS(681),
    [anon_sym_catchpad] = ACTIONS(681),
    [anon_sym_cleanuppad] = ACTIONS(681),
    [anon_sym_callbr] = ACTIONS(681),
    [anon_sym_icmp] = ACTIONS(681),
    [anon_sym_fcmp] = ACTIONS(681),
    [anon_sym_va_arg] = ACTIONS(681),
    [anon_sym_phi] = ACTIONS(681),
    [anon_sym_landingpad] = ACTIONS(681),
    [anon_sym_tail] = ACTIONS(681),
    [anon_sym_musttail] = ACTIONS(681),
    [anon_sym_notail] = ACTIONS(681),
    [anon_sym_call] = ACTIONS(681),
    [anon_sym_alloca] = ACTIONS(681),
    [anon_sym_load] = ACTIONS(681),
    [anon_sym_store] = ACTIONS(681),
    [anon_sym_cmpxchg] = ACTIONS(681),
    [anon_sym_atomicrmw] = ACTIONS(681),
    [anon_sym_fence] = ACTIONS(681),
    [anon_sym_getelementptr] = ACTIONS(681),
    [anon_sym_extractvalue] = ACTIONS(681),
    [anon_sym_insertvalue] = ACTIONS(681),
    [anon_sym_catch] = ACTIONS(681),
    [anon_sym_filter] = ACTIONS(681),
    [anon_sym_mul] = ACTIONS(681),
    [anon_sym_urem] = ACTIONS(681),
    [anon_sym_srem] = ACTIONS(681),
    [anon_sym_shl] = ACTIONS(681),
    [anon_sym_udiv] = ACTIONS(681),
    [anon_sym_sdiv] = ACTIONS(681),
    [anon_sym_lshr] = ACTIONS(681),
    [anon_sym_ashr] = ACTIONS(681),
    [anon_sym_fmul] = ACTIONS(681),
    [anon_sym_fdiv] = ACTIONS(681),
    [anon_sym_frem] = ACTIONS(681),
    [anon_sym_xchg] = ACTIONS(681),
    [anon_sym_add] = ACTIONS(681),
    [anon_sym_sub] = ACTIONS(681),
    [anon_sym_and] = ACTIONS(681),
    [anon_sym_nand] = ACTIONS(681),
    [anon_sym_or] = ACTIONS(681),
    [anon_sym_xor] = ACTIONS(681),
    [anon_sym_max] = ACTIONS(681),
    [anon_sym_min] = ACTIONS(681),
    [anon_sym_umax] = ACTIONS(681),
    [anon_sym_umin] = ACTIONS(681),
    [anon_sym_fadd] = ACTIONS(681),
    [anon_sym_fsub] = ACTIONS(681),
    [anon_sym_bitcast] = ACTIONS(681),
    [anon_sym_trunc] = ACTIONS(681),
    [anon_sym_zext] = ACTIONS(681),
    [anon_sym_sext] = ACTIONS(681),
    [anon_sym_fptrunc] = ACTIONS(681),
    [anon_sym_fpext] = ACTIONS(681),
    [anon_sym_addrspacecast] = ACTIONS(681),
    [anon_sym_uitofp] = ACTIONS(681),
    [anon_sym_sitofp] = ACTIONS(681),
    [anon_sym_fptoui] = ACTIONS(681),
    [anon_sym_fptosi] = ACTIONS(681),
    [anon_sym_inttoptr] = ACTIONS(681),
    [anon_sym_ptrtoint] = ACTIONS(681),
    [anon_sym_unordered] = ACTIONS(681),
    [anon_sym_monotonic] = ACTIONS(681),
    [anon_sym_acquire] = ACTIONS(681),
    [anon_sym_release] = ACTIONS(681),
    [anon_sym_acq_rel] = ACTIONS(681),
    [anon_sym_seq_cst] = ACTIONS(681),
    [anon_sym_syncscope] = ACTIONS(681),
    [anon_sym_uselistorder] = ACTIONS(681),
  },
  [162] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(697),
    [sym_local_var] = ACTIONS(697),
    [sym_label] = ACTIONS(697),
    [sym_string] = ACTIONS(699),
    [anon_sym_RBRACE] = ACTIONS(697),
    [anon_sym_LBRACK] = ACTIONS(697),
    [anon_sym_COMMA] = ACTIONS(697),
    [anon_sym_align] = ACTIONS(699),
    [anon_sym_section] = ACTIONS(699),
    [anon_sym_partition] = ACTIONS(699),
    [anon_sym_comdat] = ACTIONS(699),
    [anon_sym_gc] = ACTIONS(699),
    [anon_sym_prefix] = ACTIONS(699),
    [anon_sym_prologue] = ACTIONS(699),
    [anon_sym_personality] = ACTIONS(699),
    [anon_sym_alignstack] = ACTIONS(699),
    [anon_sym_allocsize] = ACTIONS(699),
    [anon_sym_alwaysinline] = ACTIONS(699),
    [anon_sym_builtin] = ACTIONS(699),
    [anon_sym_cold] = ACTIONS(699),
    [anon_sym_convergent] = ACTIONS(699),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(699),
    [anon_sym_hot] = ACTIONS(699),
    [anon_sym_inaccessiblememonly] = ACTIONS(699),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(699),
    [anon_sym_inlinehint] = ACTIONS(699),
    [anon_sym_jumptable] = ACTIONS(699),
    [anon_sym_minsize] = ACTIONS(699),
    [anon_sym_naked] = ACTIONS(699),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(699),
    [anon_sym_nobuiltin] = ACTIONS(699),
    [anon_sym_noduplicate] = ACTIONS(699),
    [anon_sym_nofree] = ACTIONS(699),
    [anon_sym_noimplicitfloat] = ACTIONS(699),
    [anon_sym_noinline] = ACTIONS(699),
    [anon_sym_nomerge] = ACTIONS(699),
    [anon_sym_nonlazybind] = ACTIONS(699),
    [anon_sym_noprofile] = ACTIONS(699),
    [anon_sym_noredzone] = ACTIONS(699),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(699),
    [anon_sym_noreturn] = ACTIONS(699),
    [anon_sym_norecurse] = ACTIONS(699),
    [anon_sym_willreturn] = ACTIONS(699),
    [anon_sym_nosync] = ACTIONS(699),
    [anon_sym_nounwind] = ACTIONS(699),
    [anon_sym_nocallback] = ACTIONS(699),
    [anon_sym_nosanitize_coverage] = ACTIONS(699),
    [anon_sym_null_pointer_is_valid] = ACTIONS(699),
    [anon_sym_optforfuzzing] = ACTIONS(699),
    [anon_sym_optnone] = ACTIONS(699),
    [anon_sym_optsize] = ACTIONS(699),
    [anon_sym_readnone] = ACTIONS(699),
    [anon_sym_readonly] = ACTIONS(699),
    [anon_sym_writeonly] = ACTIONS(699),
    [anon_sym_argmemonly] = ACTIONS(699),
    [anon_sym_returns_twice] = ACTIONS(699),
    [anon_sym_safestack] = ACTIONS(699),
    [anon_sym_sanitize_address] = ACTIONS(699),
    [anon_sym_sanitize_memory] = ACTIONS(699),
    [anon_sym_sanitize_thread] = ACTIONS(699),
    [anon_sym_sanitize_hwaddress] = ACTIONS(699),
    [anon_sym_sanitize_memtag] = ACTIONS(699),
    [anon_sym_speculative_load_hardening] = ACTIONS(699),
    [anon_sym_speculatable] = ACTIONS(699),
    [anon_sym_ssp] = ACTIONS(699),
    [anon_sym_sspstrong] = ACTIONS(699),
    [anon_sym_sspreq] = ACTIONS(699),
    [anon_sym_strictfp] = ACTIONS(699),
    [anon_sym_nocf_check] = ACTIONS(699),
    [anon_sym_shadowcallstack] = ACTIONS(699),
    [anon_sym_mustprogress] = ACTIONS(699),
    [anon_sym_vscale_range] = ACTIONS(699),
    [anon_sym_preallocated] = ACTIONS(699),
    [anon_sym_zeroext] = ACTIONS(699),
    [anon_sym_signext] = ACTIONS(699),
    [anon_sym_inreg] = ACTIONS(699),
    [anon_sym_byval] = ACTIONS(699),
    [anon_sym_byref] = ACTIONS(699),
    [anon_sym_inalloca] = ACTIONS(699),
    [anon_sym_sret] = ACTIONS(699),
    [anon_sym_elementtype] = ACTIONS(699),
    [anon_sym_noalias] = ACTIONS(699),
    [anon_sym_nocapture] = ACTIONS(699),
    [anon_sym_nest] = ACTIONS(699),
    [anon_sym_returned] = ACTIONS(699),
    [anon_sym_nonnull] = ACTIONS(699),
    [anon_sym_dereferenceable] = ACTIONS(699),
    [anon_sym_dereferenceable_or_null] = ACTIONS(699),
    [anon_sym_swiftself] = ACTIONS(699),
    [anon_sym_swiftasync] = ACTIONS(699),
    [anon_sym_swifterror] = ACTIONS(699),
    [anon_sym_immarg] = ACTIONS(699),
    [anon_sym_noundef] = ACTIONS(699),
    [anon_sym_uwtable] = ACTIONS(699),
    [anon_sym_memory] = ACTIONS(699),
    [anon_sym_unreachable] = ACTIONS(699),
    [anon_sym_ret] = ACTIONS(699),
    [anon_sym_br] = ACTIONS(699),
    [anon_sym_resume] = ACTIONS(699),
    [anon_sym_freeze] = ACTIONS(699),
    [anon_sym_indirectbr] = ACTIONS(699),
    [anon_sym_extractelement] = ACTIONS(699),
    [anon_sym_insertelement] = ACTIONS(699),
    [anon_sym_select] = ACTIONS(699),
    [anon_sym_shufflevector] = ACTIONS(699),
    [anon_sym_fneg] = ACTIONS(699),
    [anon_sym_switch] = ACTIONS(699),
    [anon_sym_invoke] = ACTIONS(699),
    [anon_sym_cleanupret] = ACTIONS(699),
    [anon_sym_catchret] = ACTIONS(699),
    [anon_sym_catchswitch] = ACTIONS(699),
    [anon_sym_catchpad] = ACTIONS(699),
    [anon_sym_cleanuppad] = ACTIONS(699),
    [anon_sym_callbr] = ACTIONS(699),
    [anon_sym_icmp] = ACTIONS(699),
    [anon_sym_fcmp] = ACTIONS(699),
    [anon_sym_va_arg] = ACTIONS(699),
    [anon_sym_phi] = ACTIONS(699),
    [anon_sym_landingpad] = ACTIONS(699),
    [anon_sym_tail] = ACTIONS(699),
    [anon_sym_musttail] = ACTIONS(699),
    [anon_sym_notail] = ACTIONS(699),
    [anon_sym_call] = ACTIONS(699),
    [anon_sym_alloca] = ACTIONS(699),
    [anon_sym_load] = ACTIONS(699),
    [anon_sym_store] = ACTIONS(699),
    [anon_sym_cmpxchg] = ACTIONS(699),
    [anon_sym_atomicrmw] = ACTIONS(699),
    [anon_sym_fence] = ACTIONS(699),
    [anon_sym_getelementptr] = ACTIONS(699),
    [anon_sym_extractvalue] = ACTIONS(699),
    [anon_sym_insertvalue] = ACTIONS(699),
    [anon_sym_catch] = ACTIONS(699),
    [anon_sym_filter] = ACTIONS(699),
    [anon_sym_mul] = ACTIONS(699),
    [anon_sym_urem] = ACTIONS(699),
    [anon_sym_srem] = ACTIONS(699),
    [anon_sym_shl] = ACTIONS(699),
    [anon_sym_udiv] = ACTIONS(699),
    [anon_sym_sdiv] = ACTIONS(699),
    [anon_sym_lshr] = ACTIONS(699),
    [anon_sym_ashr] = ACTIONS(699),
    [anon_sym_fmul] = ACTIONS(699),
    [anon_sym_fdiv] = ACTIONS(699),
    [anon_sym_frem] = ACTIONS(699),
    [anon_sym_xchg] = ACTIONS(699),
    [anon_sym_add] = ACTIONS(699),
    [anon_sym_sub] = ACTIONS(699),
    [anon_sym_and] = ACTIONS(699),
    [anon_sym_nand] = ACTIONS(699),
    [anon_sym_or] = ACTIONS(699),
    [anon_sym_xor] = ACTIONS(699),
    [anon_sym_max] = ACTIONS(699),
    [anon_sym_min] = ACTIONS(699),
    [anon_sym_umax] = ACTIONS(699),
    [anon_sym_umin] = ACTIONS(699),
    [anon_sym_fadd] = ACTIONS(699),
    [anon_sym_fsub] = ACTIONS(699),
    [anon_sym_bitcast] = ACTIONS(699),
    [anon_sym_trunc] = ACTIONS(699),
    [anon_sym_zext] = ACTIONS(699),
    [anon_sym_sext] = ACTIONS(699),
    [anon_sym_fptrunc] = ACTIONS(699),
    [anon_sym_fpext] = ACTIONS(699),
    [anon_sym_addrspacecast] = ACTIONS(699),
    [anon_sym_uitofp] = ACTIONS(699),
    [anon_sym_sitofp] = ACTIONS(699),
    [anon_sym_fptoui] = ACTIONS(699),
    [anon_sym_fptosi] = ACTIONS(699),
    [anon_sym_inttoptr] = ACTIONS(699),
    [anon_sym_ptrtoint] = ACTIONS(699),
    [anon_sym_unordered] = ACTIONS(699),
    [anon_sym_monotonic] = ACTIONS(699),
    [anon_sym_acquire] = ACTIONS(699),
    [anon_sym_release] = ACTIONS(699),
    [anon_sym_acq_rel] = ACTIONS(699),
    [anon_sym_seq_cst] = ACTIONS(699),
    [anon_sym_syncscope] = ACTIONS(699),
    [anon_sym_uselistorder] = ACTIONS(699),
  },
  [163] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(623),
    [sym_local_var] = ACTIONS(623),
    [sym_label] = ACTIONS(623),
    [sym_string] = ACTIONS(625),
    [anon_sym_RBRACE] = ACTIONS(623),
    [anon_sym_LBRACK] = ACTIONS(623),
    [anon_sym_COMMA] = ACTIONS(623),
    [anon_sym_align] = ACTIONS(625),
    [anon_sym_section] = ACTIONS(625),
    [anon_sym_partition] = ACTIONS(625),
    [anon_sym_comdat] = ACTIONS(625),
    [anon_sym_gc] = ACTIONS(625),
    [anon_sym_prefix] = ACTIONS(625),
    [anon_sym_prologue] = ACTIONS(625),
    [anon_sym_personality] = ACTIONS(625),
    [anon_sym_alignstack] = ACTIONS(625),
    [anon_sym_allocsize] = ACTIONS(625),
    [anon_sym_alwaysinline] = ACTIONS(625),
    [anon_sym_builtin] = ACTIONS(625),
    [anon_sym_cold] = ACTIONS(625),
    [anon_sym_convergent] = ACTIONS(625),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(625),
    [anon_sym_hot] = ACTIONS(625),
    [anon_sym_inaccessiblememonly] = ACTIONS(625),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(625),
    [anon_sym_inlinehint] = ACTIONS(625),
    [anon_sym_jumptable] = ACTIONS(625),
    [anon_sym_minsize] = ACTIONS(625),
    [anon_sym_naked] = ACTIONS(625),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(625),
    [anon_sym_nobuiltin] = ACTIONS(625),
    [anon_sym_noduplicate] = ACTIONS(625),
    [anon_sym_nofree] = ACTIONS(625),
    [anon_sym_noimplicitfloat] = ACTIONS(625),
    [anon_sym_noinline] = ACTIONS(625),
    [anon_sym_nomerge] = ACTIONS(625),
    [anon_sym_nonlazybind] = ACTIONS(625),
    [anon_sym_noprofile] = ACTIONS(625),
    [anon_sym_noredzone] = ACTIONS(625),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(625),
    [anon_sym_noreturn] = ACTIONS(625),
    [anon_sym_norecurse] = ACTIONS(625),
    [anon_sym_willreturn] = ACTIONS(625),
    [anon_sym_nosync] = ACTIONS(625),
    [anon_sym_nounwind] = ACTIONS(625),
    [anon_sym_nocallback] = ACTIONS(625),
    [anon_sym_nosanitize_coverage] = ACTIONS(625),
    [anon_sym_null_pointer_is_valid] = ACTIONS(625),
    [anon_sym_optforfuzzing] = ACTIONS(625),
    [anon_sym_optnone] = ACTIONS(625),
    [anon_sym_optsize] = ACTIONS(625),
    [anon_sym_readnone] = ACTIONS(625),
    [anon_sym_readonly] = ACTIONS(625),
    [anon_sym_writeonly] = ACTIONS(625),
    [anon_sym_argmemonly] = ACTIONS(625),
    [anon_sym_returns_twice] = ACTIONS(625),
    [anon_sym_safestack] = ACTIONS(625),
    [anon_sym_sanitize_address] = ACTIONS(625),
    [anon_sym_sanitize_memory] = ACTIONS(625),
    [anon_sym_sanitize_thread] = ACTIONS(625),
    [anon_sym_sanitize_hwaddress] = ACTIONS(625),
    [anon_sym_sanitize_memtag] = ACTIONS(625),
    [anon_sym_speculative_load_hardening] = ACTIONS(625),
    [anon_sym_speculatable] = ACTIONS(625),
    [anon_sym_ssp] = ACTIONS(625),
    [anon_sym_sspstrong] = ACTIONS(625),
    [anon_sym_sspreq] = ACTIONS(625),
    [anon_sym_strictfp] = ACTIONS(625),
    [anon_sym_nocf_check] = ACTIONS(625),
    [anon_sym_shadowcallstack] = ACTIONS(625),
    [anon_sym_mustprogress] = ACTIONS(625),
    [anon_sym_vscale_range] = ACTIONS(625),
    [anon_sym_preallocated] = ACTIONS(625),
    [anon_sym_zeroext] = ACTIONS(625),
    [anon_sym_signext] = ACTIONS(625),
    [anon_sym_inreg] = ACTIONS(625),
    [anon_sym_byval] = ACTIONS(625),
    [anon_sym_byref] = ACTIONS(625),
    [anon_sym_inalloca] = ACTIONS(625),
    [anon_sym_sret] = ACTIONS(625),
    [anon_sym_elementtype] = ACTIONS(625),
    [anon_sym_noalias] = ACTIONS(625),
    [anon_sym_nocapture] = ACTIONS(625),
    [anon_sym_nest] = ACTIONS(625),
    [anon_sym_returned] = ACTIONS(625),
    [anon_sym_nonnull] = ACTIONS(625),
    [anon_sym_dereferenceable] = ACTIONS(625),
    [anon_sym_dereferenceable_or_null] = ACTIONS(625),
    [anon_sym_swiftself] = ACTIONS(625),
    [anon_sym_swiftasync] = ACTIONS(625),
    [anon_sym_swifterror] = ACTIONS(625),
    [anon_sym_immarg] = ACTIONS(625),
    [anon_sym_noundef] = ACTIONS(625),
    [anon_sym_uwtable] = ACTIONS(625),
    [anon_sym_memory] = ACTIONS(625),
    [anon_sym_unreachable] = ACTIONS(625),
    [anon_sym_ret] = ACTIONS(625),
    [anon_sym_br] = ACTIONS(625),
    [anon_sym_resume] = ACTIONS(625),
    [anon_sym_freeze] = ACTIONS(625),
    [anon_sym_indirectbr] = ACTIONS(625),
    [anon_sym_extractelement] = ACTIONS(625),
    [anon_sym_insertelement] = ACTIONS(625),
    [anon_sym_select] = ACTIONS(625),
    [anon_sym_shufflevector] = ACTIONS(625),
    [anon_sym_fneg] = ACTIONS(625),
    [anon_sym_switch] = ACTIONS(625),
    [anon_sym_invoke] = ACTIONS(625),
    [anon_sym_cleanupret] = ACTIONS(625),
    [anon_sym_catchret] = ACTIONS(625),
    [anon_sym_catchswitch] = ACTIONS(625),
    [anon_sym_catchpad] = ACTIONS(625),
    [anon_sym_cleanuppad] = ACTIONS(625),
    [anon_sym_callbr] = ACTIONS(625),
    [anon_sym_icmp] = ACTIONS(625),
    [anon_sym_fcmp] = ACTIONS(625),
    [anon_sym_va_arg] = ACTIONS(625),
    [anon_sym_phi] = ACTIONS(625),
    [anon_sym_landingpad] = ACTIONS(625),
    [anon_sym_tail] = ACTIONS(625),
    [anon_sym_musttail] = ACTIONS(625),
    [anon_sym_notail] = ACTIONS(625),
    [anon_sym_call] = ACTIONS(625),
    [anon_sym_alloca] = ACTIONS(625),
    [anon_sym_load] = ACTIONS(625),
    [anon_sym_store] = ACTIONS(625),
    [anon_sym_cmpxchg] = ACTIONS(625),
    [anon_sym_atomicrmw] = ACTIONS(625),
    [anon_sym_fence] = ACTIONS(625),
    [anon_sym_getelementptr] = ACTIONS(625),
    [anon_sym_extractvalue] = ACTIONS(625),
    [anon_sym_insertvalue] = ACTIONS(625),
    [anon_sym_catch] = ACTIONS(625),
    [anon_sym_filter] = ACTIONS(625),
    [anon_sym_mul] = ACTIONS(625),
    [anon_sym_urem] = ACTIONS(625),
    [anon_sym_srem] = ACTIONS(625),
    [anon_sym_shl] = ACTIONS(625),
    [anon_sym_udiv] = ACTIONS(625),
    [anon_sym_sdiv] = ACTIONS(625),
    [anon_sym_lshr] = ACTIONS(625),
    [anon_sym_ashr] = ACTIONS(625),
    [anon_sym_fmul] = ACTIONS(625),
    [anon_sym_fdiv] = ACTIONS(625),
    [anon_sym_frem] = ACTIONS(625),
    [anon_sym_xchg] = ACTIONS(625),
    [anon_sym_add] = ACTIONS(625),
    [anon_sym_sub] = ACTIONS(625),
    [anon_sym_and] = ACTIONS(625),
    [anon_sym_nand] = ACTIONS(625),
    [anon_sym_or] = ACTIONS(625),
    [anon_sym_xor] = ACTIONS(625),
    [anon_sym_max] = ACTIONS(625),
    [anon_sym_min] = ACTIONS(625),
    [anon_sym_umax] = ACTIONS(625),
    [anon_sym_umin] = ACTIONS(625),
    [anon_sym_fadd] = ACTIONS(625),
    [anon_sym_fsub] = ACTIONS(625),
    [anon_sym_bitcast] = ACTIONS(625),
    [anon_sym_trunc] = ACTIONS(625),
    [anon_sym_zext] = ACTIONS(625),
    [anon_sym_sext] = ACTIONS(625),
    [anon_sym_fptrunc] = ACTIONS(625),
    [anon_sym_fpext] = ACTIONS(625),
    [anon_sym_addrspacecast] = ACTIONS(625),
    [anon_sym_uitofp] = ACTIONS(625),
    [anon_sym_sitofp] = ACTIONS(625),
    [anon_sym_fptoui] = ACTIONS(625),
    [anon_sym_fptosi] = ACTIONS(625),
    [anon_sym_inttoptr] = ACTIONS(625),
    [anon_sym_ptrtoint] = ACTIONS(625),
    [anon_sym_unordered] = ACTIONS(625),
    [anon_sym_monotonic] = ACTIONS(625),
    [anon_sym_acquire] = ACTIONS(625),
    [anon_sym_release] = ACTIONS(625),
    [anon_sym_acq_rel] = ACTIONS(625),
    [anon_sym_seq_cst] = ACTIONS(625),
    [anon_sym_syncscope] = ACTIONS(625),
    [anon_sym_uselistorder] = ACTIONS(625),
  },
  [164] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(541),
    [sym_local_var] = ACTIONS(541),
    [sym_label] = ACTIONS(541),
    [sym_string] = ACTIONS(543),
    [anon_sym_RBRACE] = ACTIONS(541),
    [anon_sym_LBRACK] = ACTIONS(541),
    [anon_sym_COMMA] = ACTIONS(541),
    [anon_sym_align] = ACTIONS(543),
    [anon_sym_section] = ACTIONS(543),
    [anon_sym_partition] = ACTIONS(543),
    [anon_sym_comdat] = ACTIONS(543),
    [anon_sym_gc] = ACTIONS(543),
    [anon_sym_prefix] = ACTIONS(543),
    [anon_sym_prologue] = ACTIONS(543),
    [anon_sym_personality] = ACTIONS(543),
    [anon_sym_alignstack] = ACTIONS(543),
    [anon_sym_allocsize] = ACTIONS(543),
    [anon_sym_alwaysinline] = ACTIONS(543),
    [anon_sym_builtin] = ACTIONS(543),
    [anon_sym_cold] = ACTIONS(543),
    [anon_sym_convergent] = ACTIONS(543),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(543),
    [anon_sym_hot] = ACTIONS(543),
    [anon_sym_inaccessiblememonly] = ACTIONS(543),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(543),
    [anon_sym_inlinehint] = ACTIONS(543),
    [anon_sym_jumptable] = ACTIONS(543),
    [anon_sym_minsize] = ACTIONS(543),
    [anon_sym_naked] = ACTIONS(543),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(543),
    [anon_sym_nobuiltin] = ACTIONS(543),
    [anon_sym_noduplicate] = ACTIONS(543),
    [anon_sym_nofree] = ACTIONS(543),
    [anon_sym_noimplicitfloat] = ACTIONS(543),
    [anon_sym_noinline] = ACTIONS(543),
    [anon_sym_nomerge] = ACTIONS(543),
    [anon_sym_nonlazybind] = ACTIONS(543),
    [anon_sym_noprofile] = ACTIONS(543),
    [anon_sym_noredzone] = ACTIONS(543),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(543),
    [anon_sym_noreturn] = ACTIONS(543),
    [anon_sym_norecurse] = ACTIONS(543),
    [anon_sym_willreturn] = ACTIONS(543),
    [anon_sym_nosync] = ACTIONS(543),
    [anon_sym_nounwind] = ACTIONS(543),
    [anon_sym_nocallback] = ACTIONS(543),
    [anon_sym_nosanitize_coverage] = ACTIONS(543),
    [anon_sym_null_pointer_is_valid] = ACTIONS(543),
    [anon_sym_optforfuzzing] = ACTIONS(543),
    [anon_sym_optnone] = ACTIONS(543),
    [anon_sym_optsize] = ACTIONS(543),
    [anon_sym_readnone] = ACTIONS(543),
    [anon_sym_readonly] = ACTIONS(543),
    [anon_sym_writeonly] = ACTIONS(543),
    [anon_sym_argmemonly] = ACTIONS(543),
    [anon_sym_returns_twice] = ACTIONS(543),
    [anon_sym_safestack] = ACTIONS(543),
    [anon_sym_sanitize_address] = ACTIONS(543),
    [anon_sym_sanitize_memory] = ACTIONS(543),
    [anon_sym_sanitize_thread] = ACTIONS(543),
    [anon_sym_sanitize_hwaddress] = ACTIONS(543),
    [anon_sym_sanitize_memtag] = ACTIONS(543),
    [anon_sym_speculative_load_hardening] = ACTIONS(543),
    [anon_sym_speculatable] = ACTIONS(543),
    [anon_sym_ssp] = ACTIONS(543),
    [anon_sym_sspstrong] = ACTIONS(543),
    [anon_sym_sspreq] = ACTIONS(543),
    [anon_sym_strictfp] = ACTIONS(543),
    [anon_sym_nocf_check] = ACTIONS(543),
    [anon_sym_shadowcallstack] = ACTIONS(543),
    [anon_sym_mustprogress] = ACTIONS(543),
    [anon_sym_vscale_range] = ACTIONS(543),
    [anon_sym_preallocated] = ACTIONS(543),
    [anon_sym_zeroext] = ACTIONS(543),
    [anon_sym_signext] = ACTIONS(543),
    [anon_sym_inreg] = ACTIONS(543),
    [anon_sym_byval] = ACTIONS(543),
    [anon_sym_byref] = ACTIONS(543),
    [anon_sym_inalloca] = ACTIONS(543),
    [anon_sym_sret] = ACTIONS(543),
    [anon_sym_elementtype] = ACTIONS(543),
    [anon_sym_noalias] = ACTIONS(543),
    [anon_sym_nocapture] = ACTIONS(543),
    [anon_sym_nest] = ACTIONS(543),
    [anon_sym_returned] = ACTIONS(543),
    [anon_sym_nonnull] = ACTIONS(543),
    [anon_sym_dereferenceable] = ACTIONS(543),
    [anon_sym_dereferenceable_or_null] = ACTIONS(543),
    [anon_sym_swiftself] = ACTIONS(543),
    [anon_sym_swiftasync] = ACTIONS(543),
    [anon_sym_swifterror] = ACTIONS(543),
    [anon_sym_immarg] = ACTIONS(543),
    [anon_sym_noundef] = ACTIONS(543),
    [anon_sym_uwtable] = ACTIONS(543),
    [anon_sym_memory] = ACTIONS(543),
    [anon_sym_unreachable] = ACTIONS(543),
    [anon_sym_ret] = ACTIONS(543),
    [anon_sym_br] = ACTIONS(543),
    [anon_sym_resume] = ACTIONS(543),
    [anon_sym_freeze] = ACTIONS(543),
    [anon_sym_indirectbr] = ACTIONS(543),
    [anon_sym_extractelement] = ACTIONS(543),
    [anon_sym_insertelement] = ACTIONS(543),
    [anon_sym_select] = ACTIONS(543),
    [anon_sym_shufflevector] = ACTIONS(543),
    [anon_sym_fneg] = ACTIONS(543),
    [anon_sym_switch] = ACTIONS(543),
    [anon_sym_invoke] = ACTIONS(543),
    [anon_sym_cleanupret] = ACTIONS(543),
    [anon_sym_catchret] = ACTIONS(543),
    [anon_sym_catchswitch] = ACTIONS(543),
    [anon_sym_catchpad] = ACTIONS(543),
    [anon_sym_cleanuppad] = ACTIONS(543),
    [anon_sym_callbr] = ACTIONS(543),
    [anon_sym_icmp] = ACTIONS(543),
    [anon_sym_fcmp] = ACTIONS(543),
    [anon_sym_va_arg] = ACTIONS(543),
    [anon_sym_phi] = ACTIONS(543),
    [anon_sym_landingpad] = ACTIONS(543),
    [anon_sym_tail] = ACTIONS(543),
    [anon_sym_musttail] = ACTIONS(543),
    [anon_sym_notail] = ACTIONS(543),
    [anon_sym_call] = ACTIONS(543),
    [anon_sym_alloca] = ACTIONS(543),
    [anon_sym_load] = ACTIONS(543),
    [anon_sym_store] = ACTIONS(543),
    [anon_sym_cmpxchg] = ACTIONS(543),
    [anon_sym_atomicrmw] = ACTIONS(543),
    [anon_sym_fence] = ACTIONS(543),
    [anon_sym_getelementptr] = ACTIONS(543),
    [anon_sym_extractvalue] = ACTIONS(543),
    [anon_sym_insertvalue] = ACTIONS(543),
    [anon_sym_catch] = ACTIONS(543),
    [anon_sym_filter] = ACTIONS(543),
    [anon_sym_mul] = ACTIONS(543),
    [anon_sym_urem] = ACTIONS(543),
    [anon_sym_srem] = ACTIONS(543),
    [anon_sym_shl] = ACTIONS(543),
    [anon_sym_udiv] = ACTIONS(543),
    [anon_sym_sdiv] = ACTIONS(543),
    [anon_sym_lshr] = ACTIONS(543),
    [anon_sym_ashr] = ACTIONS(543),
    [anon_sym_fmul] = ACTIONS(543),
    [anon_sym_fdiv] = ACTIONS(543),
    [anon_sym_frem] = ACTIONS(543),
    [anon_sym_xchg] = ACTIONS(543),
    [anon_sym_add] = ACTIONS(543),
    [anon_sym_sub] = ACTIONS(543),
    [anon_sym_and] = ACTIONS(543),
    [anon_sym_nand] = ACTIONS(543),
    [anon_sym_or] = ACTIONS(543),
    [anon_sym_xor] = ACTIONS(543),
    [anon_sym_max] = ACTIONS(543),
    [anon_sym_min] = ACTIONS(543),
    [anon_sym_umax] = ACTIONS(543),
    [anon_sym_umin] = ACTIONS(543),
    [anon_sym_fadd] = ACTIONS(543),
    [anon_sym_fsub] = ACTIONS(543),
    [anon_sym_bitcast] = ACTIONS(543),
    [anon_sym_trunc] = ACTIONS(543),
    [anon_sym_zext] = ACTIONS(543),
    [anon_sym_sext] = ACTIONS(543),
    [anon_sym_fptrunc] = ACTIONS(543),
    [anon_sym_fpext] = ACTIONS(543),
    [anon_sym_addrspacecast] = ACTIONS(543),
    [anon_sym_uitofp] = ACTIONS(543),
    [anon_sym_sitofp] = ACTIONS(543),
    [anon_sym_fptoui] = ACTIONS(543),
    [anon_sym_fptosi] = ACTIONS(543),
    [anon_sym_inttoptr] = ACTIONS(543),
    [anon_sym_ptrtoint] = ACTIONS(543),
    [anon_sym_unordered] = ACTIONS(543),
    [anon_sym_monotonic] = ACTIONS(543),
    [anon_sym_acquire] = ACTIONS(543),
    [anon_sym_release] = ACTIONS(543),
    [anon_sym_acq_rel] = ACTIONS(543),
    [anon_sym_seq_cst] = ACTIONS(543),
    [anon_sym_syncscope] = ACTIONS(543),
    [anon_sym_uselistorder] = ACTIONS(543),
  },
  [165] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(529),
    [sym_local_var] = ACTIONS(529),
    [sym_label] = ACTIONS(529),
    [sym_string] = ACTIONS(531),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_align] = ACTIONS(531),
    [anon_sym_section] = ACTIONS(531),
    [anon_sym_partition] = ACTIONS(531),
    [anon_sym_comdat] = ACTIONS(531),
    [anon_sym_gc] = ACTIONS(531),
    [anon_sym_prefix] = ACTIONS(531),
    [anon_sym_prologue] = ACTIONS(531),
    [anon_sym_personality] = ACTIONS(531),
    [anon_sym_alignstack] = ACTIONS(531),
    [anon_sym_allocsize] = ACTIONS(531),
    [anon_sym_alwaysinline] = ACTIONS(531),
    [anon_sym_builtin] = ACTIONS(531),
    [anon_sym_cold] = ACTIONS(531),
    [anon_sym_convergent] = ACTIONS(531),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(531),
    [anon_sym_hot] = ACTIONS(531),
    [anon_sym_inaccessiblememonly] = ACTIONS(531),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(531),
    [anon_sym_inlinehint] = ACTIONS(531),
    [anon_sym_jumptable] = ACTIONS(531),
    [anon_sym_minsize] = ACTIONS(531),
    [anon_sym_naked] = ACTIONS(531),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(531),
    [anon_sym_nobuiltin] = ACTIONS(531),
    [anon_sym_noduplicate] = ACTIONS(531),
    [anon_sym_nofree] = ACTIONS(531),
    [anon_sym_noimplicitfloat] = ACTIONS(531),
    [anon_sym_noinline] = ACTIONS(531),
    [anon_sym_nomerge] = ACTIONS(531),
    [anon_sym_nonlazybind] = ACTIONS(531),
    [anon_sym_noprofile] = ACTIONS(531),
    [anon_sym_noredzone] = ACTIONS(531),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(531),
    [anon_sym_noreturn] = ACTIONS(531),
    [anon_sym_norecurse] = ACTIONS(531),
    [anon_sym_willreturn] = ACTIONS(531),
    [anon_sym_nosync] = ACTIONS(531),
    [anon_sym_nounwind] = ACTIONS(531),
    [anon_sym_nocallback] = ACTIONS(531),
    [anon_sym_nosanitize_coverage] = ACTIONS(531),
    [anon_sym_null_pointer_is_valid] = ACTIONS(531),
    [anon_sym_optforfuzzing] = ACTIONS(531),
    [anon_sym_optnone] = ACTIONS(531),
    [anon_sym_optsize] = ACTIONS(531),
    [anon_sym_readnone] = ACTIONS(531),
    [anon_sym_readonly] = ACTIONS(531),
    [anon_sym_writeonly] = ACTIONS(531),
    [anon_sym_argmemonly] = ACTIONS(531),
    [anon_sym_returns_twice] = ACTIONS(531),
    [anon_sym_safestack] = ACTIONS(531),
    [anon_sym_sanitize_address] = ACTIONS(531),
    [anon_sym_sanitize_memory] = ACTIONS(531),
    [anon_sym_sanitize_thread] = ACTIONS(531),
    [anon_sym_sanitize_hwaddress] = ACTIONS(531),
    [anon_sym_sanitize_memtag] = ACTIONS(531),
    [anon_sym_speculative_load_hardening] = ACTIONS(531),
    [anon_sym_speculatable] = ACTIONS(531),
    [anon_sym_ssp] = ACTIONS(531),
    [anon_sym_sspstrong] = ACTIONS(531),
    [anon_sym_sspreq] = ACTIONS(531),
    [anon_sym_strictfp] = ACTIONS(531),
    [anon_sym_nocf_check] = ACTIONS(531),
    [anon_sym_shadowcallstack] = ACTIONS(531),
    [anon_sym_mustprogress] = ACTIONS(531),
    [anon_sym_vscale_range] = ACTIONS(531),
    [anon_sym_preallocated] = ACTIONS(531),
    [anon_sym_zeroext] = ACTIONS(531),
    [anon_sym_signext] = ACTIONS(531),
    [anon_sym_inreg] = ACTIONS(531),
    [anon_sym_byval] = ACTIONS(531),
    [anon_sym_byref] = ACTIONS(531),
    [anon_sym_inalloca] = ACTIONS(531),
    [anon_sym_sret] = ACTIONS(531),
    [anon_sym_elementtype] = ACTIONS(531),
    [anon_sym_noalias] = ACTIONS(531),
    [anon_sym_nocapture] = ACTIONS(531),
    [anon_sym_nest] = ACTIONS(531),
    [anon_sym_returned] = ACTIONS(531),
    [anon_sym_nonnull] = ACTIONS(531),
    [anon_sym_dereferenceable] = ACTIONS(531),
    [anon_sym_dereferenceable_or_null] = ACTIONS(531),
    [anon_sym_swiftself] = ACTIONS(531),
    [anon_sym_swiftasync] = ACTIONS(531),
    [anon_sym_swifterror] = ACTIONS(531),
    [anon_sym_immarg] = ACTIONS(531),
    [anon_sym_noundef] = ACTIONS(531),
    [anon_sym_uwtable] = ACTIONS(531),
    [anon_sym_memory] = ACTIONS(531),
    [anon_sym_unreachable] = ACTIONS(531),
    [anon_sym_ret] = ACTIONS(531),
    [anon_sym_br] = ACTIONS(531),
    [anon_sym_resume] = ACTIONS(531),
    [anon_sym_freeze] = ACTIONS(531),
    [anon_sym_indirectbr] = ACTIONS(531),
    [anon_sym_extractelement] = ACTIONS(531),
    [anon_sym_insertelement] = ACTIONS(531),
    [anon_sym_select] = ACTIONS(531),
    [anon_sym_shufflevector] = ACTIONS(531),
    [anon_sym_fneg] = ACTIONS(531),
    [anon_sym_switch] = ACTIONS(531),
    [anon_sym_invoke] = ACTIONS(531),
    [anon_sym_cleanupret] = ACTIONS(531),
    [anon_sym_catchret] = ACTIONS(531),
    [anon_sym_catchswitch] = ACTIONS(531),
    [anon_sym_catchpad] = ACTIONS(531),
    [anon_sym_cleanuppad] = ACTIONS(531),
    [anon_sym_callbr] = ACTIONS(531),
    [anon_sym_icmp] = ACTIONS(531),
    [anon_sym_fcmp] = ACTIONS(531),
    [anon_sym_va_arg] = ACTIONS(531),
    [anon_sym_phi] = ACTIONS(531),
    [anon_sym_landingpad] = ACTIONS(531),
    [anon_sym_tail] = ACTIONS(531),
    [anon_sym_musttail] = ACTIONS(531),
    [anon_sym_notail] = ACTIONS(531),
    [anon_sym_call] = ACTIONS(531),
    [anon_sym_alloca] = ACTIONS(531),
    [anon_sym_load] = ACTIONS(531),
    [anon_sym_store] = ACTIONS(531),
    [anon_sym_cmpxchg] = ACTIONS(531),
    [anon_sym_atomicrmw] = ACTIONS(531),
    [anon_sym_fence] = ACTIONS(531),
    [anon_sym_getelementptr] = ACTIONS(531),
    [anon_sym_extractvalue] = ACTIONS(531),
    [anon_sym_insertvalue] = ACTIONS(531),
    [anon_sym_catch] = ACTIONS(531),
    [anon_sym_filter] = ACTIONS(531),
    [anon_sym_mul] = ACTIONS(531),
    [anon_sym_urem] = ACTIONS(531),
    [anon_sym_srem] = ACTIONS(531),
    [anon_sym_shl] = ACTIONS(531),
    [anon_sym_udiv] = ACTIONS(531),
    [anon_sym_sdiv] = ACTIONS(531),
    [anon_sym_lshr] = ACTIONS(531),
    [anon_sym_ashr] = ACTIONS(531),
    [anon_sym_fmul] = ACTIONS(531),
    [anon_sym_fdiv] = ACTIONS(531),
    [anon_sym_frem] = ACTIONS(531),
    [anon_sym_xchg] = ACTIONS(531),
    [anon_sym_add] = ACTIONS(531),
    [anon_sym_sub] = ACTIONS(531),
    [anon_sym_and] = ACTIONS(531),
    [anon_sym_nand] = ACTIONS(531),
    [anon_sym_or] = ACTIONS(531),
    [anon_sym_xor] = ACTIONS(531),
    [anon_sym_max] = ACTIONS(531),
    [anon_sym_min] = ACTIONS(531),
    [anon_sym_umax] = ACTIONS(531),
    [anon_sym_umin] = ACTIONS(531),
    [anon_sym_fadd] = ACTIONS(531),
    [anon_sym_fsub] = ACTIONS(531),
    [anon_sym_bitcast] = ACTIONS(531),
    [anon_sym_trunc] = ACTIONS(531),
    [anon_sym_zext] = ACTIONS(531),
    [anon_sym_sext] = ACTIONS(531),
    [anon_sym_fptrunc] = ACTIONS(531),
    [anon_sym_fpext] = ACTIONS(531),
    [anon_sym_addrspacecast] = ACTIONS(531),
    [anon_sym_uitofp] = ACTIONS(531),
    [anon_sym_sitofp] = ACTIONS(531),
    [anon_sym_fptoui] = ACTIONS(531),
    [anon_sym_fptosi] = ACTIONS(531),
    [anon_sym_inttoptr] = ACTIONS(531),
    [anon_sym_ptrtoint] = ACTIONS(531),
    [anon_sym_unordered] = ACTIONS(531),
    [anon_sym_monotonic] = ACTIONS(531),
    [anon_sym_acquire] = ACTIONS(531),
    [anon_sym_release] = ACTIONS(531),
    [anon_sym_acq_rel] = ACTIONS(531),
    [anon_sym_seq_cst] = ACTIONS(531),
    [anon_sym_syncscope] = ACTIONS(531),
    [anon_sym_uselistorder] = ACTIONS(531),
  },
  [166] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(565),
    [sym_local_var] = ACTIONS(565),
    [sym_label] = ACTIONS(565),
    [sym_string] = ACTIONS(567),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_align] = ACTIONS(567),
    [anon_sym_section] = ACTIONS(567),
    [anon_sym_partition] = ACTIONS(567),
    [anon_sym_comdat] = ACTIONS(567),
    [anon_sym_gc] = ACTIONS(567),
    [anon_sym_prefix] = ACTIONS(567),
    [anon_sym_prologue] = ACTIONS(567),
    [anon_sym_personality] = ACTIONS(567),
    [anon_sym_alignstack] = ACTIONS(567),
    [anon_sym_allocsize] = ACTIONS(567),
    [anon_sym_alwaysinline] = ACTIONS(567),
    [anon_sym_builtin] = ACTIONS(567),
    [anon_sym_cold] = ACTIONS(567),
    [anon_sym_convergent] = ACTIONS(567),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(567),
    [anon_sym_hot] = ACTIONS(567),
    [anon_sym_inaccessiblememonly] = ACTIONS(567),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(567),
    [anon_sym_inlinehint] = ACTIONS(567),
    [anon_sym_jumptable] = ACTIONS(567),
    [anon_sym_minsize] = ACTIONS(567),
    [anon_sym_naked] = ACTIONS(567),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(567),
    [anon_sym_nobuiltin] = ACTIONS(567),
    [anon_sym_noduplicate] = ACTIONS(567),
    [anon_sym_nofree] = ACTIONS(567),
    [anon_sym_noimplicitfloat] = ACTIONS(567),
    [anon_sym_noinline] = ACTIONS(567),
    [anon_sym_nomerge] = ACTIONS(567),
    [anon_sym_nonlazybind] = ACTIONS(567),
    [anon_sym_noprofile] = ACTIONS(567),
    [anon_sym_noredzone] = ACTIONS(567),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(567),
    [anon_sym_noreturn] = ACTIONS(567),
    [anon_sym_norecurse] = ACTIONS(567),
    [anon_sym_willreturn] = ACTIONS(567),
    [anon_sym_nosync] = ACTIONS(567),
    [anon_sym_nounwind] = ACTIONS(567),
    [anon_sym_nocallback] = ACTIONS(567),
    [anon_sym_nosanitize_coverage] = ACTIONS(567),
    [anon_sym_null_pointer_is_valid] = ACTIONS(567),
    [anon_sym_optforfuzzing] = ACTIONS(567),
    [anon_sym_optnone] = ACTIONS(567),
    [anon_sym_optsize] = ACTIONS(567),
    [anon_sym_readnone] = ACTIONS(567),
    [anon_sym_readonly] = ACTIONS(567),
    [anon_sym_writeonly] = ACTIONS(567),
    [anon_sym_argmemonly] = ACTIONS(567),
    [anon_sym_returns_twice] = ACTIONS(567),
    [anon_sym_safestack] = ACTIONS(567),
    [anon_sym_sanitize_address] = ACTIONS(567),
    [anon_sym_sanitize_memory] = ACTIONS(567),
    [anon_sym_sanitize_thread] = ACTIONS(567),
    [anon_sym_sanitize_hwaddress] = ACTIONS(567),
    [anon_sym_sanitize_memtag] = ACTIONS(567),
    [anon_sym_speculative_load_hardening] = ACTIONS(567),
    [anon_sym_speculatable] = ACTIONS(567),
    [anon_sym_ssp] = ACTIONS(567),
    [anon_sym_sspstrong] = ACTIONS(567),
    [anon_sym_sspreq] = ACTIONS(567),
    [anon_sym_strictfp] = ACTIONS(567),
    [anon_sym_nocf_check] = ACTIONS(567),
    [anon_sym_shadowcallstack] = ACTIONS(567),
    [anon_sym_mustprogress] = ACTIONS(567),
    [anon_sym_vscale_range] = ACTIONS(567),
    [anon_sym_preallocated] = ACTIONS(567),
    [anon_sym_zeroext] = ACTIONS(567),
    [anon_sym_signext] = ACTIONS(567),
    [anon_sym_inreg] = ACTIONS(567),
    [anon_sym_byval] = ACTIONS(567),
    [anon_sym_byref] = ACTIONS(567),
    [anon_sym_inalloca] = ACTIONS(567),
    [anon_sym_sret] = ACTIONS(567),
    [anon_sym_elementtype] = ACTIONS(567),
    [anon_sym_noalias] = ACTIONS(567),
    [anon_sym_nocapture] = ACTIONS(567),
    [anon_sym_nest] = ACTIONS(567),
    [anon_sym_returned] = ACTIONS(567),
    [anon_sym_nonnull] = ACTIONS(567),
    [anon_sym_dereferenceable] = ACTIONS(567),
    [anon_sym_dereferenceable_or_null] = ACTIONS(567),
    [anon_sym_swiftself] = ACTIONS(567),
    [anon_sym_swiftasync] = ACTIONS(567),
    [anon_sym_swifterror] = ACTIONS(567),
    [anon_sym_immarg] = ACTIONS(567),
    [anon_sym_noundef] = ACTIONS(567),
    [anon_sym_uwtable] = ACTIONS(567),
    [anon_sym_memory] = ACTIONS(567),
    [anon_sym_unreachable] = ACTIONS(567),
    [anon_sym_ret] = ACTIONS(567),
    [anon_sym_br] = ACTIONS(567),
    [anon_sym_resume] = ACTIONS(567),
    [anon_sym_freeze] = ACTIONS(567),
    [anon_sym_indirectbr] = ACTIONS(567),
    [anon_sym_extractelement] = ACTIONS(567),
    [anon_sym_insertelement] = ACTIONS(567),
    [anon_sym_select] = ACTIONS(567),
    [anon_sym_shufflevector] = ACTIONS(567),
    [anon_sym_fneg] = ACTIONS(567),
    [anon_sym_switch] = ACTIONS(567),
    [anon_sym_invoke] = ACTIONS(567),
    [anon_sym_cleanupret] = ACTIONS(567),
    [anon_sym_catchret] = ACTIONS(567),
    [anon_sym_catchswitch] = ACTIONS(567),
    [anon_sym_catchpad] = ACTIONS(567),
    [anon_sym_cleanuppad] = ACTIONS(567),
    [anon_sym_callbr] = ACTIONS(567),
    [anon_sym_icmp] = ACTIONS(567),
    [anon_sym_fcmp] = ACTIONS(567),
    [anon_sym_va_arg] = ACTIONS(567),
    [anon_sym_phi] = ACTIONS(567),
    [anon_sym_landingpad] = ACTIONS(567),
    [anon_sym_tail] = ACTIONS(567),
    [anon_sym_musttail] = ACTIONS(567),
    [anon_sym_notail] = ACTIONS(567),
    [anon_sym_call] = ACTIONS(567),
    [anon_sym_alloca] = ACTIONS(567),
    [anon_sym_load] = ACTIONS(567),
    [anon_sym_store] = ACTIONS(567),
    [anon_sym_cmpxchg] = ACTIONS(567),
    [anon_sym_atomicrmw] = ACTIONS(567),
    [anon_sym_fence] = ACTIONS(567),
    [anon_sym_getelementptr] = ACTIONS(567),
    [anon_sym_extractvalue] = ACTIONS(567),
    [anon_sym_insertvalue] = ACTIONS(567),
    [anon_sym_catch] = ACTIONS(567),
    [anon_sym_filter] = ACTIONS(567),
    [anon_sym_mul] = ACTIONS(567),
    [anon_sym_urem] = ACTIONS(567),
    [anon_sym_srem] = ACTIONS(567),
    [anon_sym_shl] = ACTIONS(567),
    [anon_sym_udiv] = ACTIONS(567),
    [anon_sym_sdiv] = ACTIONS(567),
    [anon_sym_lshr] = ACTIONS(567),
    [anon_sym_ashr] = ACTIONS(567),
    [anon_sym_fmul] = ACTIONS(567),
    [anon_sym_fdiv] = ACTIONS(567),
    [anon_sym_frem] = ACTIONS(567),
    [anon_sym_xchg] = ACTIONS(567),
    [anon_sym_add] = ACTIONS(567),
    [anon_sym_sub] = ACTIONS(567),
    [anon_sym_and] = ACTIONS(567),
    [anon_sym_nand] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(567),
    [anon_sym_xor] = ACTIONS(567),
    [anon_sym_max] = ACTIONS(567),
    [anon_sym_min] = ACTIONS(567),
    [anon_sym_umax] = ACTIONS(567),
    [anon_sym_umin] = ACTIONS(567),
    [anon_sym_fadd] = ACTIONS(567),
    [anon_sym_fsub] = ACTIONS(567),
    [anon_sym_bitcast] = ACTIONS(567),
    [anon_sym_trunc] = ACTIONS(567),
    [anon_sym_zext] = ACTIONS(567),
    [anon_sym_sext] = ACTIONS(567),
    [anon_sym_fptrunc] = ACTIONS(567),
    [anon_sym_fpext] = ACTIONS(567),
    [anon_sym_addrspacecast] = ACTIONS(567),
    [anon_sym_uitofp] = ACTIONS(567),
    [anon_sym_sitofp] = ACTIONS(567),
    [anon_sym_fptoui] = ACTIONS(567),
    [anon_sym_fptosi] = ACTIONS(567),
    [anon_sym_inttoptr] = ACTIONS(567),
    [anon_sym_ptrtoint] = ACTIONS(567),
    [anon_sym_unordered] = ACTIONS(567),
    [anon_sym_monotonic] = ACTIONS(567),
    [anon_sym_acquire] = ACTIONS(567),
    [anon_sym_release] = ACTIONS(567),
    [anon_sym_acq_rel] = ACTIONS(567),
    [anon_sym_seq_cst] = ACTIONS(567),
    [anon_sym_syncscope] = ACTIONS(567),
    [anon_sym_uselistorder] = ACTIONS(567),
  },
  [167] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(583),
    [sym_local_var] = ACTIONS(583),
    [sym_label] = ACTIONS(583),
    [sym_string] = ACTIONS(585),
    [anon_sym_RBRACE] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_align] = ACTIONS(585),
    [anon_sym_section] = ACTIONS(585),
    [anon_sym_partition] = ACTIONS(585),
    [anon_sym_comdat] = ACTIONS(585),
    [anon_sym_gc] = ACTIONS(585),
    [anon_sym_prefix] = ACTIONS(585),
    [anon_sym_prologue] = ACTIONS(585),
    [anon_sym_personality] = ACTIONS(585),
    [anon_sym_alignstack] = ACTIONS(585),
    [anon_sym_allocsize] = ACTIONS(585),
    [anon_sym_alwaysinline] = ACTIONS(585),
    [anon_sym_builtin] = ACTIONS(585),
    [anon_sym_cold] = ACTIONS(585),
    [anon_sym_convergent] = ACTIONS(585),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(585),
    [anon_sym_hot] = ACTIONS(585),
    [anon_sym_inaccessiblememonly] = ACTIONS(585),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(585),
    [anon_sym_inlinehint] = ACTIONS(585),
    [anon_sym_jumptable] = ACTIONS(585),
    [anon_sym_minsize] = ACTIONS(585),
    [anon_sym_naked] = ACTIONS(585),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(585),
    [anon_sym_nobuiltin] = ACTIONS(585),
    [anon_sym_noduplicate] = ACTIONS(585),
    [anon_sym_nofree] = ACTIONS(585),
    [anon_sym_noimplicitfloat] = ACTIONS(585),
    [anon_sym_noinline] = ACTIONS(585),
    [anon_sym_nomerge] = ACTIONS(585),
    [anon_sym_nonlazybind] = ACTIONS(585),
    [anon_sym_noprofile] = ACTIONS(585),
    [anon_sym_noredzone] = ACTIONS(585),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(585),
    [anon_sym_noreturn] = ACTIONS(585),
    [anon_sym_norecurse] = ACTIONS(585),
    [anon_sym_willreturn] = ACTIONS(585),
    [anon_sym_nosync] = ACTIONS(585),
    [anon_sym_nounwind] = ACTIONS(585),
    [anon_sym_nocallback] = ACTIONS(585),
    [anon_sym_nosanitize_coverage] = ACTIONS(585),
    [anon_sym_null_pointer_is_valid] = ACTIONS(585),
    [anon_sym_optforfuzzing] = ACTIONS(585),
    [anon_sym_optnone] = ACTIONS(585),
    [anon_sym_optsize] = ACTIONS(585),
    [anon_sym_readnone] = ACTIONS(585),
    [anon_sym_readonly] = ACTIONS(585),
    [anon_sym_writeonly] = ACTIONS(585),
    [anon_sym_argmemonly] = ACTIONS(585),
    [anon_sym_returns_twice] = ACTIONS(585),
    [anon_sym_safestack] = ACTIONS(585),
    [anon_sym_sanitize_address] = ACTIONS(585),
    [anon_sym_sanitize_memory] = ACTIONS(585),
    [anon_sym_sanitize_thread] = ACTIONS(585),
    [anon_sym_sanitize_hwaddress] = ACTIONS(585),
    [anon_sym_sanitize_memtag] = ACTIONS(585),
    [anon_sym_speculative_load_hardening] = ACTIONS(585),
    [anon_sym_speculatable] = ACTIONS(585),
    [anon_sym_ssp] = ACTIONS(585),
    [anon_sym_sspstrong] = ACTIONS(585),
    [anon_sym_sspreq] = ACTIONS(585),
    [anon_sym_strictfp] = ACTIONS(585),
    [anon_sym_nocf_check] = ACTIONS(585),
    [anon_sym_shadowcallstack] = ACTIONS(585),
    [anon_sym_mustprogress] = ACTIONS(585),
    [anon_sym_vscale_range] = ACTIONS(585),
    [anon_sym_preallocated] = ACTIONS(585),
    [anon_sym_zeroext] = ACTIONS(585),
    [anon_sym_signext] = ACTIONS(585),
    [anon_sym_inreg] = ACTIONS(585),
    [anon_sym_byval] = ACTIONS(585),
    [anon_sym_byref] = ACTIONS(585),
    [anon_sym_inalloca] = ACTIONS(585),
    [anon_sym_sret] = ACTIONS(585),
    [anon_sym_elementtype] = ACTIONS(585),
    [anon_sym_noalias] = ACTIONS(585),
    [anon_sym_nocapture] = ACTIONS(585),
    [anon_sym_nest] = ACTIONS(585),
    [anon_sym_returned] = ACTIONS(585),
    [anon_sym_nonnull] = ACTIONS(585),
    [anon_sym_dereferenceable] = ACTIONS(585),
    [anon_sym_dereferenceable_or_null] = ACTIONS(585),
    [anon_sym_swiftself] = ACTIONS(585),
    [anon_sym_swiftasync] = ACTIONS(585),
    [anon_sym_swifterror] = ACTIONS(585),
    [anon_sym_immarg] = ACTIONS(585),
    [anon_sym_noundef] = ACTIONS(585),
    [anon_sym_uwtable] = ACTIONS(585),
    [anon_sym_memory] = ACTIONS(585),
    [anon_sym_unreachable] = ACTIONS(585),
    [anon_sym_ret] = ACTIONS(585),
    [anon_sym_br] = ACTIONS(585),
    [anon_sym_resume] = ACTIONS(585),
    [anon_sym_freeze] = ACTIONS(585),
    [anon_sym_indirectbr] = ACTIONS(585),
    [anon_sym_extractelement] = ACTIONS(585),
    [anon_sym_insertelement] = ACTIONS(585),
    [anon_sym_select] = ACTIONS(585),
    [anon_sym_shufflevector] = ACTIONS(585),
    [anon_sym_fneg] = ACTIONS(585),
    [anon_sym_switch] = ACTIONS(585),
    [anon_sym_invoke] = ACTIONS(585),
    [anon_sym_cleanupret] = ACTIONS(585),
    [anon_sym_catchret] = ACTIONS(585),
    [anon_sym_catchswitch] = ACTIONS(585),
    [anon_sym_catchpad] = ACTIONS(585),
    [anon_sym_cleanuppad] = ACTIONS(585),
    [anon_sym_callbr] = ACTIONS(585),
    [anon_sym_icmp] = ACTIONS(585),
    [anon_sym_fcmp] = ACTIONS(585),
    [anon_sym_va_arg] = ACTIONS(585),
    [anon_sym_phi] = ACTIONS(585),
    [anon_sym_landingpad] = ACTIONS(585),
    [anon_sym_tail] = ACTIONS(585),
    [anon_sym_musttail] = ACTIONS(585),
    [anon_sym_notail] = ACTIONS(585),
    [anon_sym_call] = ACTIONS(585),
    [anon_sym_alloca] = ACTIONS(585),
    [anon_sym_load] = ACTIONS(585),
    [anon_sym_store] = ACTIONS(585),
    [anon_sym_cmpxchg] = ACTIONS(585),
    [anon_sym_atomicrmw] = ACTIONS(585),
    [anon_sym_fence] = ACTIONS(585),
    [anon_sym_getelementptr] = ACTIONS(585),
    [anon_sym_extractvalue] = ACTIONS(585),
    [anon_sym_insertvalue] = ACTIONS(585),
    [anon_sym_catch] = ACTIONS(585),
    [anon_sym_filter] = ACTIONS(585),
    [anon_sym_mul] = ACTIONS(585),
    [anon_sym_urem] = ACTIONS(585),
    [anon_sym_srem] = ACTIONS(585),
    [anon_sym_shl] = ACTIONS(585),
    [anon_sym_udiv] = ACTIONS(585),
    [anon_sym_sdiv] = ACTIONS(585),
    [anon_sym_lshr] = ACTIONS(585),
    [anon_sym_ashr] = ACTIONS(585),
    [anon_sym_fmul] = ACTIONS(585),
    [anon_sym_fdiv] = ACTIONS(585),
    [anon_sym_frem] = ACTIONS(585),
    [anon_sym_xchg] = ACTIONS(585),
    [anon_sym_add] = ACTIONS(585),
    [anon_sym_sub] = ACTIONS(585),
    [anon_sym_and] = ACTIONS(585),
    [anon_sym_nand] = ACTIONS(585),
    [anon_sym_or] = ACTIONS(585),
    [anon_sym_xor] = ACTIONS(585),
    [anon_sym_max] = ACTIONS(585),
    [anon_sym_min] = ACTIONS(585),
    [anon_sym_umax] = ACTIONS(585),
    [anon_sym_umin] = ACTIONS(585),
    [anon_sym_fadd] = ACTIONS(585),
    [anon_sym_fsub] = ACTIONS(585),
    [anon_sym_bitcast] = ACTIONS(585),
    [anon_sym_trunc] = ACTIONS(585),
    [anon_sym_zext] = ACTIONS(585),
    [anon_sym_sext] = ACTIONS(585),
    [anon_sym_fptrunc] = ACTIONS(585),
    [anon_sym_fpext] = ACTIONS(585),
    [anon_sym_addrspacecast] = ACTIONS(585),
    [anon_sym_uitofp] = ACTIONS(585),
    [anon_sym_sitofp] = ACTIONS(585),
    [anon_sym_fptoui] = ACTIONS(585),
    [anon_sym_fptosi] = ACTIONS(585),
    [anon_sym_inttoptr] = ACTIONS(585),
    [anon_sym_ptrtoint] = ACTIONS(585),
    [anon_sym_unordered] = ACTIONS(585),
    [anon_sym_monotonic] = ACTIONS(585),
    [anon_sym_acquire] = ACTIONS(585),
    [anon_sym_release] = ACTIONS(585),
    [anon_sym_acq_rel] = ACTIONS(585),
    [anon_sym_seq_cst] = ACTIONS(585),
    [anon_sym_syncscope] = ACTIONS(585),
    [anon_sym_uselistorder] = ACTIONS(585),
  },
  [168] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(561),
    [sym_local_var] = ACTIONS(561),
    [sym_label] = ACTIONS(561),
    [sym_string] = ACTIONS(563),
    [anon_sym_RBRACE] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(561),
    [anon_sym_align] = ACTIONS(563),
    [anon_sym_section] = ACTIONS(563),
    [anon_sym_partition] = ACTIONS(563),
    [anon_sym_comdat] = ACTIONS(563),
    [anon_sym_gc] = ACTIONS(563),
    [anon_sym_prefix] = ACTIONS(563),
    [anon_sym_prologue] = ACTIONS(563),
    [anon_sym_personality] = ACTIONS(563),
    [anon_sym_alignstack] = ACTIONS(563),
    [anon_sym_allocsize] = ACTIONS(563),
    [anon_sym_alwaysinline] = ACTIONS(563),
    [anon_sym_builtin] = ACTIONS(563),
    [anon_sym_cold] = ACTIONS(563),
    [anon_sym_convergent] = ACTIONS(563),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(563),
    [anon_sym_hot] = ACTIONS(563),
    [anon_sym_inaccessiblememonly] = ACTIONS(563),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(563),
    [anon_sym_inlinehint] = ACTIONS(563),
    [anon_sym_jumptable] = ACTIONS(563),
    [anon_sym_minsize] = ACTIONS(563),
    [anon_sym_naked] = ACTIONS(563),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(563),
    [anon_sym_nobuiltin] = ACTIONS(563),
    [anon_sym_noduplicate] = ACTIONS(563),
    [anon_sym_nofree] = ACTIONS(563),
    [anon_sym_noimplicitfloat] = ACTIONS(563),
    [anon_sym_noinline] = ACTIONS(563),
    [anon_sym_nomerge] = ACTIONS(563),
    [anon_sym_nonlazybind] = ACTIONS(563),
    [anon_sym_noprofile] = ACTIONS(563),
    [anon_sym_noredzone] = ACTIONS(563),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(563),
    [anon_sym_noreturn] = ACTIONS(563),
    [anon_sym_norecurse] = ACTIONS(563),
    [anon_sym_willreturn] = ACTIONS(563),
    [anon_sym_nosync] = ACTIONS(563),
    [anon_sym_nounwind] = ACTIONS(563),
    [anon_sym_nocallback] = ACTIONS(563),
    [anon_sym_nosanitize_coverage] = ACTIONS(563),
    [anon_sym_null_pointer_is_valid] = ACTIONS(563),
    [anon_sym_optforfuzzing] = ACTIONS(563),
    [anon_sym_optnone] = ACTIONS(563),
    [anon_sym_optsize] = ACTIONS(563),
    [anon_sym_readnone] = ACTIONS(563),
    [anon_sym_readonly] = ACTIONS(563),
    [anon_sym_writeonly] = ACTIONS(563),
    [anon_sym_argmemonly] = ACTIONS(563),
    [anon_sym_returns_twice] = ACTIONS(563),
    [anon_sym_safestack] = ACTIONS(563),
    [anon_sym_sanitize_address] = ACTIONS(563),
    [anon_sym_sanitize_memory] = ACTIONS(563),
    [anon_sym_sanitize_thread] = ACTIONS(563),
    [anon_sym_sanitize_hwaddress] = ACTIONS(563),
    [anon_sym_sanitize_memtag] = ACTIONS(563),
    [anon_sym_speculative_load_hardening] = ACTIONS(563),
    [anon_sym_speculatable] = ACTIONS(563),
    [anon_sym_ssp] = ACTIONS(563),
    [anon_sym_sspstrong] = ACTIONS(563),
    [anon_sym_sspreq] = ACTIONS(563),
    [anon_sym_strictfp] = ACTIONS(563),
    [anon_sym_nocf_check] = ACTIONS(563),
    [anon_sym_shadowcallstack] = ACTIONS(563),
    [anon_sym_mustprogress] = ACTIONS(563),
    [anon_sym_vscale_range] = ACTIONS(563),
    [anon_sym_preallocated] = ACTIONS(563),
    [anon_sym_zeroext] = ACTIONS(563),
    [anon_sym_signext] = ACTIONS(563),
    [anon_sym_inreg] = ACTIONS(563),
    [anon_sym_byval] = ACTIONS(563),
    [anon_sym_byref] = ACTIONS(563),
    [anon_sym_inalloca] = ACTIONS(563),
    [anon_sym_sret] = ACTIONS(563),
    [anon_sym_elementtype] = ACTIONS(563),
    [anon_sym_noalias] = ACTIONS(563),
    [anon_sym_nocapture] = ACTIONS(563),
    [anon_sym_nest] = ACTIONS(563),
    [anon_sym_returned] = ACTIONS(563),
    [anon_sym_nonnull] = ACTIONS(563),
    [anon_sym_dereferenceable] = ACTIONS(563),
    [anon_sym_dereferenceable_or_null] = ACTIONS(563),
    [anon_sym_swiftself] = ACTIONS(563),
    [anon_sym_swiftasync] = ACTIONS(563),
    [anon_sym_swifterror] = ACTIONS(563),
    [anon_sym_immarg] = ACTIONS(563),
    [anon_sym_noundef] = ACTIONS(563),
    [anon_sym_uwtable] = ACTIONS(563),
    [anon_sym_memory] = ACTIONS(563),
    [anon_sym_unreachable] = ACTIONS(563),
    [anon_sym_ret] = ACTIONS(563),
    [anon_sym_br] = ACTIONS(563),
    [anon_sym_resume] = ACTIONS(563),
    [anon_sym_freeze] = ACTIONS(563),
    [anon_sym_indirectbr] = ACTIONS(563),
    [anon_sym_extractelement] = ACTIONS(563),
    [anon_sym_insertelement] = ACTIONS(563),
    [anon_sym_select] = ACTIONS(563),
    [anon_sym_shufflevector] = ACTIONS(563),
    [anon_sym_fneg] = ACTIONS(563),
    [anon_sym_switch] = ACTIONS(563),
    [anon_sym_invoke] = ACTIONS(563),
    [anon_sym_cleanupret] = ACTIONS(563),
    [anon_sym_catchret] = ACTIONS(563),
    [anon_sym_catchswitch] = ACTIONS(563),
    [anon_sym_catchpad] = ACTIONS(563),
    [anon_sym_cleanuppad] = ACTIONS(563),
    [anon_sym_callbr] = ACTIONS(563),
    [anon_sym_icmp] = ACTIONS(563),
    [anon_sym_fcmp] = ACTIONS(563),
    [anon_sym_va_arg] = ACTIONS(563),
    [anon_sym_phi] = ACTIONS(563),
    [anon_sym_landingpad] = ACTIONS(563),
    [anon_sym_tail] = ACTIONS(563),
    [anon_sym_musttail] = ACTIONS(563),
    [anon_sym_notail] = ACTIONS(563),
    [anon_sym_call] = ACTIONS(563),
    [anon_sym_alloca] = ACTIONS(563),
    [anon_sym_load] = ACTIONS(563),
    [anon_sym_store] = ACTIONS(563),
    [anon_sym_cmpxchg] = ACTIONS(563),
    [anon_sym_atomicrmw] = ACTIONS(563),
    [anon_sym_fence] = ACTIONS(563),
    [anon_sym_getelementptr] = ACTIONS(563),
    [anon_sym_extractvalue] = ACTIONS(563),
    [anon_sym_insertvalue] = ACTIONS(563),
    [anon_sym_catch] = ACTIONS(563),
    [anon_sym_filter] = ACTIONS(563),
    [anon_sym_mul] = ACTIONS(563),
    [anon_sym_urem] = ACTIONS(563),
    [anon_sym_srem] = ACTIONS(563),
    [anon_sym_shl] = ACTIONS(563),
    [anon_sym_udiv] = ACTIONS(563),
    [anon_sym_sdiv] = ACTIONS(563),
    [anon_sym_lshr] = ACTIONS(563),
    [anon_sym_ashr] = ACTIONS(563),
    [anon_sym_fmul] = ACTIONS(563),
    [anon_sym_fdiv] = ACTIONS(563),
    [anon_sym_frem] = ACTIONS(563),
    [anon_sym_xchg] = ACTIONS(563),
    [anon_sym_add] = ACTIONS(563),
    [anon_sym_sub] = ACTIONS(563),
    [anon_sym_and] = ACTIONS(563),
    [anon_sym_nand] = ACTIONS(563),
    [anon_sym_or] = ACTIONS(563),
    [anon_sym_xor] = ACTIONS(563),
    [anon_sym_max] = ACTIONS(563),
    [anon_sym_min] = ACTIONS(563),
    [anon_sym_umax] = ACTIONS(563),
    [anon_sym_umin] = ACTIONS(563),
    [anon_sym_fadd] = ACTIONS(563),
    [anon_sym_fsub] = ACTIONS(563),
    [anon_sym_bitcast] = ACTIONS(563),
    [anon_sym_trunc] = ACTIONS(563),
    [anon_sym_zext] = ACTIONS(563),
    [anon_sym_sext] = ACTIONS(563),
    [anon_sym_fptrunc] = ACTIONS(563),
    [anon_sym_fpext] = ACTIONS(563),
    [anon_sym_addrspacecast] = ACTIONS(563),
    [anon_sym_uitofp] = ACTIONS(563),
    [anon_sym_sitofp] = ACTIONS(563),
    [anon_sym_fptoui] = ACTIONS(563),
    [anon_sym_fptosi] = ACTIONS(563),
    [anon_sym_inttoptr] = ACTIONS(563),
    [anon_sym_ptrtoint] = ACTIONS(563),
    [anon_sym_unordered] = ACTIONS(563),
    [anon_sym_monotonic] = ACTIONS(563),
    [anon_sym_acquire] = ACTIONS(563),
    [anon_sym_release] = ACTIONS(563),
    [anon_sym_acq_rel] = ACTIONS(563),
    [anon_sym_seq_cst] = ACTIONS(563),
    [anon_sym_syncscope] = ACTIONS(563),
    [anon_sym_uselistorder] = ACTIONS(563),
  },
  [169] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(557),
    [sym_local_var] = ACTIONS(557),
    [sym_label] = ACTIONS(557),
    [sym_string] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(557),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_COMMA] = ACTIONS(557),
    [anon_sym_align] = ACTIONS(559),
    [anon_sym_section] = ACTIONS(559),
    [anon_sym_partition] = ACTIONS(559),
    [anon_sym_comdat] = ACTIONS(559),
    [anon_sym_gc] = ACTIONS(559),
    [anon_sym_prefix] = ACTIONS(559),
    [anon_sym_prologue] = ACTIONS(559),
    [anon_sym_personality] = ACTIONS(559),
    [anon_sym_alignstack] = ACTIONS(559),
    [anon_sym_allocsize] = ACTIONS(559),
    [anon_sym_alwaysinline] = ACTIONS(559),
    [anon_sym_builtin] = ACTIONS(559),
    [anon_sym_cold] = ACTIONS(559),
    [anon_sym_convergent] = ACTIONS(559),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(559),
    [anon_sym_hot] = ACTIONS(559),
    [anon_sym_inaccessiblememonly] = ACTIONS(559),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(559),
    [anon_sym_inlinehint] = ACTIONS(559),
    [anon_sym_jumptable] = ACTIONS(559),
    [anon_sym_minsize] = ACTIONS(559),
    [anon_sym_naked] = ACTIONS(559),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(559),
    [anon_sym_nobuiltin] = ACTIONS(559),
    [anon_sym_noduplicate] = ACTIONS(559),
    [anon_sym_nofree] = ACTIONS(559),
    [anon_sym_noimplicitfloat] = ACTIONS(559),
    [anon_sym_noinline] = ACTIONS(559),
    [anon_sym_nomerge] = ACTIONS(559),
    [anon_sym_nonlazybind] = ACTIONS(559),
    [anon_sym_noprofile] = ACTIONS(559),
    [anon_sym_noredzone] = ACTIONS(559),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(559),
    [anon_sym_noreturn] = ACTIONS(559),
    [anon_sym_norecurse] = ACTIONS(559),
    [anon_sym_willreturn] = ACTIONS(559),
    [anon_sym_nosync] = ACTIONS(559),
    [anon_sym_nounwind] = ACTIONS(559),
    [anon_sym_nocallback] = ACTIONS(559),
    [anon_sym_nosanitize_coverage] = ACTIONS(559),
    [anon_sym_null_pointer_is_valid] = ACTIONS(559),
    [anon_sym_optforfuzzing] = ACTIONS(559),
    [anon_sym_optnone] = ACTIONS(559),
    [anon_sym_optsize] = ACTIONS(559),
    [anon_sym_readnone] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(559),
    [anon_sym_writeonly] = ACTIONS(559),
    [anon_sym_argmemonly] = ACTIONS(559),
    [anon_sym_returns_twice] = ACTIONS(559),
    [anon_sym_safestack] = ACTIONS(559),
    [anon_sym_sanitize_address] = ACTIONS(559),
    [anon_sym_sanitize_memory] = ACTIONS(559),
    [anon_sym_sanitize_thread] = ACTIONS(559),
    [anon_sym_sanitize_hwaddress] = ACTIONS(559),
    [anon_sym_sanitize_memtag] = ACTIONS(559),
    [anon_sym_speculative_load_hardening] = ACTIONS(559),
    [anon_sym_speculatable] = ACTIONS(559),
    [anon_sym_ssp] = ACTIONS(559),
    [anon_sym_sspstrong] = ACTIONS(559),
    [anon_sym_sspreq] = ACTIONS(559),
    [anon_sym_strictfp] = ACTIONS(559),
    [anon_sym_nocf_check] = ACTIONS(559),
    [anon_sym_shadowcallstack] = ACTIONS(559),
    [anon_sym_mustprogress] = ACTIONS(559),
    [anon_sym_vscale_range] = ACTIONS(559),
    [anon_sym_preallocated] = ACTIONS(559),
    [anon_sym_zeroext] = ACTIONS(559),
    [anon_sym_signext] = ACTIONS(559),
    [anon_sym_inreg] = ACTIONS(559),
    [anon_sym_byval] = ACTIONS(559),
    [anon_sym_byref] = ACTIONS(559),
    [anon_sym_inalloca] = ACTIONS(559),
    [anon_sym_sret] = ACTIONS(559),
    [anon_sym_elementtype] = ACTIONS(559),
    [anon_sym_noalias] = ACTIONS(559),
    [anon_sym_nocapture] = ACTIONS(559),
    [anon_sym_nest] = ACTIONS(559),
    [anon_sym_returned] = ACTIONS(559),
    [anon_sym_nonnull] = ACTIONS(559),
    [anon_sym_dereferenceable] = ACTIONS(559),
    [anon_sym_dereferenceable_or_null] = ACTIONS(559),
    [anon_sym_swiftself] = ACTIONS(559),
    [anon_sym_swiftasync] = ACTIONS(559),
    [anon_sym_swifterror] = ACTIONS(559),
    [anon_sym_immarg] = ACTIONS(559),
    [anon_sym_noundef] = ACTIONS(559),
    [anon_sym_uwtable] = ACTIONS(559),
    [anon_sym_memory] = ACTIONS(559),
    [anon_sym_unreachable] = ACTIONS(559),
    [anon_sym_ret] = ACTIONS(559),
    [anon_sym_br] = ACTIONS(559),
    [anon_sym_resume] = ACTIONS(559),
    [anon_sym_freeze] = ACTIONS(559),
    [anon_sym_indirectbr] = ACTIONS(559),
    [anon_sym_extractelement] = ACTIONS(559),
    [anon_sym_insertelement] = ACTIONS(559),
    [anon_sym_select] = ACTIONS(559),
    [anon_sym_shufflevector] = ACTIONS(559),
    [anon_sym_fneg] = ACTIONS(559),
    [anon_sym_switch] = ACTIONS(559),
    [anon_sym_invoke] = ACTIONS(559),
    [anon_sym_cleanupret] = ACTIONS(559),
    [anon_sym_catchret] = ACTIONS(559),
    [anon_sym_catchswitch] = ACTIONS(559),
    [anon_sym_catchpad] = ACTIONS(559),
    [anon_sym_cleanuppad] = ACTIONS(559),
    [anon_sym_callbr] = ACTIONS(559),
    [anon_sym_icmp] = ACTIONS(559),
    [anon_sym_fcmp] = ACTIONS(559),
    [anon_sym_va_arg] = ACTIONS(559),
    [anon_sym_phi] = ACTIONS(559),
    [anon_sym_landingpad] = ACTIONS(559),
    [anon_sym_tail] = ACTIONS(559),
    [anon_sym_musttail] = ACTIONS(559),
    [anon_sym_notail] = ACTIONS(559),
    [anon_sym_call] = ACTIONS(559),
    [anon_sym_alloca] = ACTIONS(559),
    [anon_sym_load] = ACTIONS(559),
    [anon_sym_store] = ACTIONS(559),
    [anon_sym_cmpxchg] = ACTIONS(559),
    [anon_sym_atomicrmw] = ACTIONS(559),
    [anon_sym_fence] = ACTIONS(559),
    [anon_sym_getelementptr] = ACTIONS(559),
    [anon_sym_extractvalue] = ACTIONS(559),
    [anon_sym_insertvalue] = ACTIONS(559),
    [anon_sym_catch] = ACTIONS(559),
    [anon_sym_filter] = ACTIONS(559),
    [anon_sym_mul] = ACTIONS(559),
    [anon_sym_urem] = ACTIONS(559),
    [anon_sym_srem] = ACTIONS(559),
    [anon_sym_shl] = ACTIONS(559),
    [anon_sym_udiv] = ACTIONS(559),
    [anon_sym_sdiv] = ACTIONS(559),
    [anon_sym_lshr] = ACTIONS(559),
    [anon_sym_ashr] = ACTIONS(559),
    [anon_sym_fmul] = ACTIONS(559),
    [anon_sym_fdiv] = ACTIONS(559),
    [anon_sym_frem] = ACTIONS(559),
    [anon_sym_xchg] = ACTIONS(559),
    [anon_sym_add] = ACTIONS(559),
    [anon_sym_sub] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_nand] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_xor] = ACTIONS(559),
    [anon_sym_max] = ACTIONS(559),
    [anon_sym_min] = ACTIONS(559),
    [anon_sym_umax] = ACTIONS(559),
    [anon_sym_umin] = ACTIONS(559),
    [anon_sym_fadd] = ACTIONS(559),
    [anon_sym_fsub] = ACTIONS(559),
    [anon_sym_bitcast] = ACTIONS(559),
    [anon_sym_trunc] = ACTIONS(559),
    [anon_sym_zext] = ACTIONS(559),
    [anon_sym_sext] = ACTIONS(559),
    [anon_sym_fptrunc] = ACTIONS(559),
    [anon_sym_fpext] = ACTIONS(559),
    [anon_sym_addrspacecast] = ACTIONS(559),
    [anon_sym_uitofp] = ACTIONS(559),
    [anon_sym_sitofp] = ACTIONS(559),
    [anon_sym_fptoui] = ACTIONS(559),
    [anon_sym_fptosi] = ACTIONS(559),
    [anon_sym_inttoptr] = ACTIONS(559),
    [anon_sym_ptrtoint] = ACTIONS(559),
    [anon_sym_unordered] = ACTIONS(559),
    [anon_sym_monotonic] = ACTIONS(559),
    [anon_sym_acquire] = ACTIONS(559),
    [anon_sym_release] = ACTIONS(559),
    [anon_sym_acq_rel] = ACTIONS(559),
    [anon_sym_seq_cst] = ACTIONS(559),
    [anon_sym_syncscope] = ACTIONS(559),
    [anon_sym_uselistorder] = ACTIONS(559),
  },
  [170] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(525),
    [sym_local_var] = ACTIONS(525),
    [sym_label] = ACTIONS(525),
    [sym_string] = ACTIONS(527),
    [anon_sym_RBRACE] = ACTIONS(525),
    [anon_sym_LBRACK] = ACTIONS(525),
    [anon_sym_COMMA] = ACTIONS(525),
    [anon_sym_align] = ACTIONS(527),
    [anon_sym_section] = ACTIONS(527),
    [anon_sym_partition] = ACTIONS(527),
    [anon_sym_comdat] = ACTIONS(527),
    [anon_sym_gc] = ACTIONS(527),
    [anon_sym_prefix] = ACTIONS(527),
    [anon_sym_prologue] = ACTIONS(527),
    [anon_sym_personality] = ACTIONS(527),
    [anon_sym_alignstack] = ACTIONS(527),
    [anon_sym_allocsize] = ACTIONS(527),
    [anon_sym_alwaysinline] = ACTIONS(527),
    [anon_sym_builtin] = ACTIONS(527),
    [anon_sym_cold] = ACTIONS(527),
    [anon_sym_convergent] = ACTIONS(527),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(527),
    [anon_sym_hot] = ACTIONS(527),
    [anon_sym_inaccessiblememonly] = ACTIONS(527),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(527),
    [anon_sym_inlinehint] = ACTIONS(527),
    [anon_sym_jumptable] = ACTIONS(527),
    [anon_sym_minsize] = ACTIONS(527),
    [anon_sym_naked] = ACTIONS(527),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(527),
    [anon_sym_nobuiltin] = ACTIONS(527),
    [anon_sym_noduplicate] = ACTIONS(527),
    [anon_sym_nofree] = ACTIONS(527),
    [anon_sym_noimplicitfloat] = ACTIONS(527),
    [anon_sym_noinline] = ACTIONS(527),
    [anon_sym_nomerge] = ACTIONS(527),
    [anon_sym_nonlazybind] = ACTIONS(527),
    [anon_sym_noprofile] = ACTIONS(527),
    [anon_sym_noredzone] = ACTIONS(527),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(527),
    [anon_sym_noreturn] = ACTIONS(527),
    [anon_sym_norecurse] = ACTIONS(527),
    [anon_sym_willreturn] = ACTIONS(527),
    [anon_sym_nosync] = ACTIONS(527),
    [anon_sym_nounwind] = ACTIONS(527),
    [anon_sym_nocallback] = ACTIONS(527),
    [anon_sym_nosanitize_coverage] = ACTIONS(527),
    [anon_sym_null_pointer_is_valid] = ACTIONS(527),
    [anon_sym_optforfuzzing] = ACTIONS(527),
    [anon_sym_optnone] = ACTIONS(527),
    [anon_sym_optsize] = ACTIONS(527),
    [anon_sym_readnone] = ACTIONS(527),
    [anon_sym_readonly] = ACTIONS(527),
    [anon_sym_writeonly] = ACTIONS(527),
    [anon_sym_argmemonly] = ACTIONS(527),
    [anon_sym_returns_twice] = ACTIONS(527),
    [anon_sym_safestack] = ACTIONS(527),
    [anon_sym_sanitize_address] = ACTIONS(527),
    [anon_sym_sanitize_memory] = ACTIONS(527),
    [anon_sym_sanitize_thread] = ACTIONS(527),
    [anon_sym_sanitize_hwaddress] = ACTIONS(527),
    [anon_sym_sanitize_memtag] = ACTIONS(527),
    [anon_sym_speculative_load_hardening] = ACTIONS(527),
    [anon_sym_speculatable] = ACTIONS(527),
    [anon_sym_ssp] = ACTIONS(527),
    [anon_sym_sspstrong] = ACTIONS(527),
    [anon_sym_sspreq] = ACTIONS(527),
    [anon_sym_strictfp] = ACTIONS(527),
    [anon_sym_nocf_check] = ACTIONS(527),
    [anon_sym_shadowcallstack] = ACTIONS(527),
    [anon_sym_mustprogress] = ACTIONS(527),
    [anon_sym_vscale_range] = ACTIONS(527),
    [anon_sym_preallocated] = ACTIONS(527),
    [anon_sym_zeroext] = ACTIONS(527),
    [anon_sym_signext] = ACTIONS(527),
    [anon_sym_inreg] = ACTIONS(527),
    [anon_sym_byval] = ACTIONS(527),
    [anon_sym_byref] = ACTIONS(527),
    [anon_sym_inalloca] = ACTIONS(527),
    [anon_sym_sret] = ACTIONS(527),
    [anon_sym_elementtype] = ACTIONS(527),
    [anon_sym_noalias] = ACTIONS(527),
    [anon_sym_nocapture] = ACTIONS(527),
    [anon_sym_nest] = ACTIONS(527),
    [anon_sym_returned] = ACTIONS(527),
    [anon_sym_nonnull] = ACTIONS(527),
    [anon_sym_dereferenceable] = ACTIONS(527),
    [anon_sym_dereferenceable_or_null] = ACTIONS(527),
    [anon_sym_swiftself] = ACTIONS(527),
    [anon_sym_swiftasync] = ACTIONS(527),
    [anon_sym_swifterror] = ACTIONS(527),
    [anon_sym_immarg] = ACTIONS(527),
    [anon_sym_noundef] = ACTIONS(527),
    [anon_sym_uwtable] = ACTIONS(527),
    [anon_sym_memory] = ACTIONS(527),
    [anon_sym_unreachable] = ACTIONS(527),
    [anon_sym_ret] = ACTIONS(527),
    [anon_sym_br] = ACTIONS(527),
    [anon_sym_resume] = ACTIONS(527),
    [anon_sym_freeze] = ACTIONS(527),
    [anon_sym_indirectbr] = ACTIONS(527),
    [anon_sym_extractelement] = ACTIONS(527),
    [anon_sym_insertelement] = ACTIONS(527),
    [anon_sym_select] = ACTIONS(527),
    [anon_sym_shufflevector] = ACTIONS(527),
    [anon_sym_fneg] = ACTIONS(527),
    [anon_sym_switch] = ACTIONS(527),
    [anon_sym_invoke] = ACTIONS(527),
    [anon_sym_cleanupret] = ACTIONS(527),
    [anon_sym_catchret] = ACTIONS(527),
    [anon_sym_catchswitch] = ACTIONS(527),
    [anon_sym_catchpad] = ACTIONS(527),
    [anon_sym_cleanuppad] = ACTIONS(527),
    [anon_sym_callbr] = ACTIONS(527),
    [anon_sym_icmp] = ACTIONS(527),
    [anon_sym_fcmp] = ACTIONS(527),
    [anon_sym_va_arg] = ACTIONS(527),
    [anon_sym_phi] = ACTIONS(527),
    [anon_sym_landingpad] = ACTIONS(527),
    [anon_sym_tail] = ACTIONS(527),
    [anon_sym_musttail] = ACTIONS(527),
    [anon_sym_notail] = ACTIONS(527),
    [anon_sym_call] = ACTIONS(527),
    [anon_sym_alloca] = ACTIONS(527),
    [anon_sym_load] = ACTIONS(527),
    [anon_sym_store] = ACTIONS(527),
    [anon_sym_cmpxchg] = ACTIONS(527),
    [anon_sym_atomicrmw] = ACTIONS(527),
    [anon_sym_fence] = ACTIONS(527),
    [anon_sym_getelementptr] = ACTIONS(527),
    [anon_sym_extractvalue] = ACTIONS(527),
    [anon_sym_insertvalue] = ACTIONS(527),
    [anon_sym_catch] = ACTIONS(527),
    [anon_sym_filter] = ACTIONS(527),
    [anon_sym_mul] = ACTIONS(527),
    [anon_sym_urem] = ACTIONS(527),
    [anon_sym_srem] = ACTIONS(527),
    [anon_sym_shl] = ACTIONS(527),
    [anon_sym_udiv] = ACTIONS(527),
    [anon_sym_sdiv] = ACTIONS(527),
    [anon_sym_lshr] = ACTIONS(527),
    [anon_sym_ashr] = ACTIONS(527),
    [anon_sym_fmul] = ACTIONS(527),
    [anon_sym_fdiv] = ACTIONS(527),
    [anon_sym_frem] = ACTIONS(527),
    [anon_sym_xchg] = ACTIONS(527),
    [anon_sym_add] = ACTIONS(527),
    [anon_sym_sub] = ACTIONS(527),
    [anon_sym_and] = ACTIONS(527),
    [anon_sym_nand] = ACTIONS(527),
    [anon_sym_or] = ACTIONS(527),
    [anon_sym_xor] = ACTIONS(527),
    [anon_sym_max] = ACTIONS(527),
    [anon_sym_min] = ACTIONS(527),
    [anon_sym_umax] = ACTIONS(527),
    [anon_sym_umin] = ACTIONS(527),
    [anon_sym_fadd] = ACTIONS(527),
    [anon_sym_fsub] = ACTIONS(527),
    [anon_sym_bitcast] = ACTIONS(527),
    [anon_sym_trunc] = ACTIONS(527),
    [anon_sym_zext] = ACTIONS(527),
    [anon_sym_sext] = ACTIONS(527),
    [anon_sym_fptrunc] = ACTIONS(527),
    [anon_sym_fpext] = ACTIONS(527),
    [anon_sym_addrspacecast] = ACTIONS(527),
    [anon_sym_uitofp] = ACTIONS(527),
    [anon_sym_sitofp] = ACTIONS(527),
    [anon_sym_fptoui] = ACTIONS(527),
    [anon_sym_fptosi] = ACTIONS(527),
    [anon_sym_inttoptr] = ACTIONS(527),
    [anon_sym_ptrtoint] = ACTIONS(527),
    [anon_sym_unordered] = ACTIONS(527),
    [anon_sym_monotonic] = ACTIONS(527),
    [anon_sym_acquire] = ACTIONS(527),
    [anon_sym_release] = ACTIONS(527),
    [anon_sym_acq_rel] = ACTIONS(527),
    [anon_sym_seq_cst] = ACTIONS(527),
    [anon_sym_syncscope] = ACTIONS(527),
    [anon_sym_uselistorder] = ACTIONS(527),
  },
  [171] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(517),
    [sym_local_var] = ACTIONS(517),
    [sym_label] = ACTIONS(517),
    [sym_string] = ACTIONS(519),
    [anon_sym_RBRACE] = ACTIONS(517),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_align] = ACTIONS(519),
    [anon_sym_section] = ACTIONS(519),
    [anon_sym_partition] = ACTIONS(519),
    [anon_sym_comdat] = ACTIONS(519),
    [anon_sym_gc] = ACTIONS(519),
    [anon_sym_prefix] = ACTIONS(519),
    [anon_sym_prologue] = ACTIONS(519),
    [anon_sym_personality] = ACTIONS(519),
    [anon_sym_alignstack] = ACTIONS(519),
    [anon_sym_allocsize] = ACTIONS(519),
    [anon_sym_alwaysinline] = ACTIONS(519),
    [anon_sym_builtin] = ACTIONS(519),
    [anon_sym_cold] = ACTIONS(519),
    [anon_sym_convergent] = ACTIONS(519),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(519),
    [anon_sym_hot] = ACTIONS(519),
    [anon_sym_inaccessiblememonly] = ACTIONS(519),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(519),
    [anon_sym_inlinehint] = ACTIONS(519),
    [anon_sym_jumptable] = ACTIONS(519),
    [anon_sym_minsize] = ACTIONS(519),
    [anon_sym_naked] = ACTIONS(519),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(519),
    [anon_sym_nobuiltin] = ACTIONS(519),
    [anon_sym_noduplicate] = ACTIONS(519),
    [anon_sym_nofree] = ACTIONS(519),
    [anon_sym_noimplicitfloat] = ACTIONS(519),
    [anon_sym_noinline] = ACTIONS(519),
    [anon_sym_nomerge] = ACTIONS(519),
    [anon_sym_nonlazybind] = ACTIONS(519),
    [anon_sym_noprofile] = ACTIONS(519),
    [anon_sym_noredzone] = ACTIONS(519),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(519),
    [anon_sym_noreturn] = ACTIONS(519),
    [anon_sym_norecurse] = ACTIONS(519),
    [anon_sym_willreturn] = ACTIONS(519),
    [anon_sym_nosync] = ACTIONS(519),
    [anon_sym_nounwind] = ACTIONS(519),
    [anon_sym_nocallback] = ACTIONS(519),
    [anon_sym_nosanitize_coverage] = ACTIONS(519),
    [anon_sym_null_pointer_is_valid] = ACTIONS(519),
    [anon_sym_optforfuzzing] = ACTIONS(519),
    [anon_sym_optnone] = ACTIONS(519),
    [anon_sym_optsize] = ACTIONS(519),
    [anon_sym_readnone] = ACTIONS(519),
    [anon_sym_readonly] = ACTIONS(519),
    [anon_sym_writeonly] = ACTIONS(519),
    [anon_sym_argmemonly] = ACTIONS(519),
    [anon_sym_returns_twice] = ACTIONS(519),
    [anon_sym_safestack] = ACTIONS(519),
    [anon_sym_sanitize_address] = ACTIONS(519),
    [anon_sym_sanitize_memory] = ACTIONS(519),
    [anon_sym_sanitize_thread] = ACTIONS(519),
    [anon_sym_sanitize_hwaddress] = ACTIONS(519),
    [anon_sym_sanitize_memtag] = ACTIONS(519),
    [anon_sym_speculative_load_hardening] = ACTIONS(519),
    [anon_sym_speculatable] = ACTIONS(519),
    [anon_sym_ssp] = ACTIONS(519),
    [anon_sym_sspstrong] = ACTIONS(519),
    [anon_sym_sspreq] = ACTIONS(519),
    [anon_sym_strictfp] = ACTIONS(519),
    [anon_sym_nocf_check] = ACTIONS(519),
    [anon_sym_shadowcallstack] = ACTIONS(519),
    [anon_sym_mustprogress] = ACTIONS(519),
    [anon_sym_vscale_range] = ACTIONS(519),
    [anon_sym_preallocated] = ACTIONS(519),
    [anon_sym_zeroext] = ACTIONS(519),
    [anon_sym_signext] = ACTIONS(519),
    [anon_sym_inreg] = ACTIONS(519),
    [anon_sym_byval] = ACTIONS(519),
    [anon_sym_byref] = ACTIONS(519),
    [anon_sym_inalloca] = ACTIONS(519),
    [anon_sym_sret] = ACTIONS(519),
    [anon_sym_elementtype] = ACTIONS(519),
    [anon_sym_noalias] = ACTIONS(519),
    [anon_sym_nocapture] = ACTIONS(519),
    [anon_sym_nest] = ACTIONS(519),
    [anon_sym_returned] = ACTIONS(519),
    [anon_sym_nonnull] = ACTIONS(519),
    [anon_sym_dereferenceable] = ACTIONS(519),
    [anon_sym_dereferenceable_or_null] = ACTIONS(519),
    [anon_sym_swiftself] = ACTIONS(519),
    [anon_sym_swiftasync] = ACTIONS(519),
    [anon_sym_swifterror] = ACTIONS(519),
    [anon_sym_immarg] = ACTIONS(519),
    [anon_sym_noundef] = ACTIONS(519),
    [anon_sym_uwtable] = ACTIONS(519),
    [anon_sym_memory] = ACTIONS(519),
    [anon_sym_unreachable] = ACTIONS(519),
    [anon_sym_ret] = ACTIONS(519),
    [anon_sym_br] = ACTIONS(519),
    [anon_sym_resume] = ACTIONS(519),
    [anon_sym_freeze] = ACTIONS(519),
    [anon_sym_indirectbr] = ACTIONS(519),
    [anon_sym_extractelement] = ACTIONS(519),
    [anon_sym_insertelement] = ACTIONS(519),
    [anon_sym_select] = ACTIONS(519),
    [anon_sym_shufflevector] = ACTIONS(519),
    [anon_sym_fneg] = ACTIONS(519),
    [anon_sym_switch] = ACTIONS(519),
    [anon_sym_invoke] = ACTIONS(519),
    [anon_sym_cleanupret] = ACTIONS(519),
    [anon_sym_catchret] = ACTIONS(519),
    [anon_sym_catchswitch] = ACTIONS(519),
    [anon_sym_catchpad] = ACTIONS(519),
    [anon_sym_cleanuppad] = ACTIONS(519),
    [anon_sym_callbr] = ACTIONS(519),
    [anon_sym_icmp] = ACTIONS(519),
    [anon_sym_fcmp] = ACTIONS(519),
    [anon_sym_va_arg] = ACTIONS(519),
    [anon_sym_phi] = ACTIONS(519),
    [anon_sym_landingpad] = ACTIONS(519),
    [anon_sym_tail] = ACTIONS(519),
    [anon_sym_musttail] = ACTIONS(519),
    [anon_sym_notail] = ACTIONS(519),
    [anon_sym_call] = ACTIONS(519),
    [anon_sym_alloca] = ACTIONS(519),
    [anon_sym_load] = ACTIONS(519),
    [anon_sym_store] = ACTIONS(519),
    [anon_sym_cmpxchg] = ACTIONS(519),
    [anon_sym_atomicrmw] = ACTIONS(519),
    [anon_sym_fence] = ACTIONS(519),
    [anon_sym_getelementptr] = ACTIONS(519),
    [anon_sym_extractvalue] = ACTIONS(519),
    [anon_sym_insertvalue] = ACTIONS(519),
    [anon_sym_catch] = ACTIONS(519),
    [anon_sym_filter] = ACTIONS(519),
    [anon_sym_mul] = ACTIONS(519),
    [anon_sym_urem] = ACTIONS(519),
    [anon_sym_srem] = ACTIONS(519),
    [anon_sym_shl] = ACTIONS(519),
    [anon_sym_udiv] = ACTIONS(519),
    [anon_sym_sdiv] = ACTIONS(519),
    [anon_sym_lshr] = ACTIONS(519),
    [anon_sym_ashr] = ACTIONS(519),
    [anon_sym_fmul] = ACTIONS(519),
    [anon_sym_fdiv] = ACTIONS(519),
    [anon_sym_frem] = ACTIONS(519),
    [anon_sym_xchg] = ACTIONS(519),
    [anon_sym_add] = ACTIONS(519),
    [anon_sym_sub] = ACTIONS(519),
    [anon_sym_and] = ACTIONS(519),
    [anon_sym_nand] = ACTIONS(519),
    [anon_sym_or] = ACTIONS(519),
    [anon_sym_xor] = ACTIONS(519),
    [anon_sym_max] = ACTIONS(519),
    [anon_sym_min] = ACTIONS(519),
    [anon_sym_umax] = ACTIONS(519),
    [anon_sym_umin] = ACTIONS(519),
    [anon_sym_fadd] = ACTIONS(519),
    [anon_sym_fsub] = ACTIONS(519),
    [anon_sym_bitcast] = ACTIONS(519),
    [anon_sym_trunc] = ACTIONS(519),
    [anon_sym_zext] = ACTIONS(519),
    [anon_sym_sext] = ACTIONS(519),
    [anon_sym_fptrunc] = ACTIONS(519),
    [anon_sym_fpext] = ACTIONS(519),
    [anon_sym_addrspacecast] = ACTIONS(519),
    [anon_sym_uitofp] = ACTIONS(519),
    [anon_sym_sitofp] = ACTIONS(519),
    [anon_sym_fptoui] = ACTIONS(519),
    [anon_sym_fptosi] = ACTIONS(519),
    [anon_sym_inttoptr] = ACTIONS(519),
    [anon_sym_ptrtoint] = ACTIONS(519),
    [anon_sym_unordered] = ACTIONS(519),
    [anon_sym_monotonic] = ACTIONS(519),
    [anon_sym_acquire] = ACTIONS(519),
    [anon_sym_release] = ACTIONS(519),
    [anon_sym_acq_rel] = ACTIONS(519),
    [anon_sym_seq_cst] = ACTIONS(519),
    [anon_sym_syncscope] = ACTIONS(519),
    [anon_sym_uselistorder] = ACTIONS(519),
  },
  [172] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(679),
    [sym_local_var] = ACTIONS(679),
    [sym_label] = ACTIONS(679),
    [sym_string] = ACTIONS(681),
    [anon_sym_RBRACE] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(679),
    [anon_sym_COMMA] = ACTIONS(679),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_section] = ACTIONS(681),
    [anon_sym_partition] = ACTIONS(681),
    [anon_sym_comdat] = ACTIONS(681),
    [anon_sym_gc] = ACTIONS(681),
    [anon_sym_prefix] = ACTIONS(681),
    [anon_sym_prologue] = ACTIONS(681),
    [anon_sym_personality] = ACTIONS(681),
    [anon_sym_alignstack] = ACTIONS(681),
    [anon_sym_allocsize] = ACTIONS(681),
    [anon_sym_alwaysinline] = ACTIONS(681),
    [anon_sym_builtin] = ACTIONS(681),
    [anon_sym_cold] = ACTIONS(681),
    [anon_sym_convergent] = ACTIONS(681),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(681),
    [anon_sym_hot] = ACTIONS(681),
    [anon_sym_inaccessiblememonly] = ACTIONS(681),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(681),
    [anon_sym_inlinehint] = ACTIONS(681),
    [anon_sym_jumptable] = ACTIONS(681),
    [anon_sym_minsize] = ACTIONS(681),
    [anon_sym_naked] = ACTIONS(681),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(681),
    [anon_sym_nobuiltin] = ACTIONS(681),
    [anon_sym_noduplicate] = ACTIONS(681),
    [anon_sym_nofree] = ACTIONS(681),
    [anon_sym_noimplicitfloat] = ACTIONS(681),
    [anon_sym_noinline] = ACTIONS(681),
    [anon_sym_nomerge] = ACTIONS(681),
    [anon_sym_nonlazybind] = ACTIONS(681),
    [anon_sym_noprofile] = ACTIONS(681),
    [anon_sym_noredzone] = ACTIONS(681),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(681),
    [anon_sym_noreturn] = ACTIONS(681),
    [anon_sym_norecurse] = ACTIONS(681),
    [anon_sym_willreturn] = ACTIONS(681),
    [anon_sym_nosync] = ACTIONS(681),
    [anon_sym_nounwind] = ACTIONS(681),
    [anon_sym_nocallback] = ACTIONS(681),
    [anon_sym_nosanitize_coverage] = ACTIONS(681),
    [anon_sym_null_pointer_is_valid] = ACTIONS(681),
    [anon_sym_optforfuzzing] = ACTIONS(681),
    [anon_sym_optnone] = ACTIONS(681),
    [anon_sym_optsize] = ACTIONS(681),
    [anon_sym_readnone] = ACTIONS(681),
    [anon_sym_readonly] = ACTIONS(681),
    [anon_sym_writeonly] = ACTIONS(681),
    [anon_sym_argmemonly] = ACTIONS(681),
    [anon_sym_returns_twice] = ACTIONS(681),
    [anon_sym_safestack] = ACTIONS(681),
    [anon_sym_sanitize_address] = ACTIONS(681),
    [anon_sym_sanitize_memory] = ACTIONS(681),
    [anon_sym_sanitize_thread] = ACTIONS(681),
    [anon_sym_sanitize_hwaddress] = ACTIONS(681),
    [anon_sym_sanitize_memtag] = ACTIONS(681),
    [anon_sym_speculative_load_hardening] = ACTIONS(681),
    [anon_sym_speculatable] = ACTIONS(681),
    [anon_sym_ssp] = ACTIONS(681),
    [anon_sym_sspstrong] = ACTIONS(681),
    [anon_sym_sspreq] = ACTIONS(681),
    [anon_sym_strictfp] = ACTIONS(681),
    [anon_sym_nocf_check] = ACTIONS(681),
    [anon_sym_shadowcallstack] = ACTIONS(681),
    [anon_sym_mustprogress] = ACTIONS(681),
    [anon_sym_vscale_range] = ACTIONS(681),
    [anon_sym_preallocated] = ACTIONS(681),
    [anon_sym_zeroext] = ACTIONS(681),
    [anon_sym_signext] = ACTIONS(681),
    [anon_sym_inreg] = ACTIONS(681),
    [anon_sym_byval] = ACTIONS(681),
    [anon_sym_byref] = ACTIONS(681),
    [anon_sym_inalloca] = ACTIONS(681),
    [anon_sym_sret] = ACTIONS(681),
    [anon_sym_elementtype] = ACTIONS(681),
    [anon_sym_noalias] = ACTIONS(681),
    [anon_sym_nocapture] = ACTIONS(681),
    [anon_sym_nest] = ACTIONS(681),
    [anon_sym_returned] = ACTIONS(681),
    [anon_sym_nonnull] = ACTIONS(681),
    [anon_sym_dereferenceable] = ACTIONS(681),
    [anon_sym_dereferenceable_or_null] = ACTIONS(681),
    [anon_sym_swiftself] = ACTIONS(681),
    [anon_sym_swiftasync] = ACTIONS(681),
    [anon_sym_swifterror] = ACTIONS(681),
    [anon_sym_immarg] = ACTIONS(681),
    [anon_sym_noundef] = ACTIONS(681),
    [anon_sym_uwtable] = ACTIONS(681),
    [anon_sym_memory] = ACTIONS(681),
    [anon_sym_unreachable] = ACTIONS(681),
    [anon_sym_ret] = ACTIONS(681),
    [anon_sym_br] = ACTIONS(681),
    [anon_sym_resume] = ACTIONS(681),
    [anon_sym_freeze] = ACTIONS(681),
    [anon_sym_indirectbr] = ACTIONS(681),
    [anon_sym_extractelement] = ACTIONS(681),
    [anon_sym_insertelement] = ACTIONS(681),
    [anon_sym_select] = ACTIONS(681),
    [anon_sym_shufflevector] = ACTIONS(681),
    [anon_sym_fneg] = ACTIONS(681),
    [anon_sym_switch] = ACTIONS(681),
    [anon_sym_invoke] = ACTIONS(681),
    [anon_sym_cleanupret] = ACTIONS(681),
    [anon_sym_catchret] = ACTIONS(681),
    [anon_sym_catchswitch] = ACTIONS(681),
    [anon_sym_catchpad] = ACTIONS(681),
    [anon_sym_cleanuppad] = ACTIONS(681),
    [anon_sym_callbr] = ACTIONS(681),
    [anon_sym_icmp] = ACTIONS(681),
    [anon_sym_fcmp] = ACTIONS(681),
    [anon_sym_va_arg] = ACTIONS(681),
    [anon_sym_phi] = ACTIONS(681),
    [anon_sym_landingpad] = ACTIONS(681),
    [anon_sym_tail] = ACTIONS(681),
    [anon_sym_musttail] = ACTIONS(681),
    [anon_sym_notail] = ACTIONS(681),
    [anon_sym_call] = ACTIONS(681),
    [anon_sym_alloca] = ACTIONS(681),
    [anon_sym_load] = ACTIONS(681),
    [anon_sym_store] = ACTIONS(681),
    [anon_sym_cmpxchg] = ACTIONS(681),
    [anon_sym_atomicrmw] = ACTIONS(681),
    [anon_sym_fence] = ACTIONS(681),
    [anon_sym_getelementptr] = ACTIONS(681),
    [anon_sym_extractvalue] = ACTIONS(681),
    [anon_sym_insertvalue] = ACTIONS(681),
    [anon_sym_catch] = ACTIONS(681),
    [anon_sym_filter] = ACTIONS(681),
    [anon_sym_mul] = ACTIONS(681),
    [anon_sym_urem] = ACTIONS(681),
    [anon_sym_srem] = ACTIONS(681),
    [anon_sym_shl] = ACTIONS(681),
    [anon_sym_udiv] = ACTIONS(681),
    [anon_sym_sdiv] = ACTIONS(681),
    [anon_sym_lshr] = ACTIONS(681),
    [anon_sym_ashr] = ACTIONS(681),
    [anon_sym_fmul] = ACTIONS(681),
    [anon_sym_fdiv] = ACTIONS(681),
    [anon_sym_frem] = ACTIONS(681),
    [anon_sym_xchg] = ACTIONS(681),
    [anon_sym_add] = ACTIONS(681),
    [anon_sym_sub] = ACTIONS(681),
    [anon_sym_and] = ACTIONS(681),
    [anon_sym_nand] = ACTIONS(681),
    [anon_sym_or] = ACTIONS(681),
    [anon_sym_xor] = ACTIONS(681),
    [anon_sym_max] = ACTIONS(681),
    [anon_sym_min] = ACTIONS(681),
    [anon_sym_umax] = ACTIONS(681),
    [anon_sym_umin] = ACTIONS(681),
    [anon_sym_fadd] = ACTIONS(681),
    [anon_sym_fsub] = ACTIONS(681),
    [anon_sym_bitcast] = ACTIONS(681),
    [anon_sym_trunc] = ACTIONS(681),
    [anon_sym_zext] = ACTIONS(681),
    [anon_sym_sext] = ACTIONS(681),
    [anon_sym_fptrunc] = ACTIONS(681),
    [anon_sym_fpext] = ACTIONS(681),
    [anon_sym_addrspacecast] = ACTIONS(681),
    [anon_sym_uitofp] = ACTIONS(681),
    [anon_sym_sitofp] = ACTIONS(681),
    [anon_sym_fptoui] = ACTIONS(681),
    [anon_sym_fptosi] = ACTIONS(681),
    [anon_sym_inttoptr] = ACTIONS(681),
    [anon_sym_ptrtoint] = ACTIONS(681),
    [anon_sym_unordered] = ACTIONS(681),
    [anon_sym_monotonic] = ACTIONS(681),
    [anon_sym_acquire] = ACTIONS(681),
    [anon_sym_release] = ACTIONS(681),
    [anon_sym_acq_rel] = ACTIONS(681),
    [anon_sym_seq_cst] = ACTIONS(681),
    [anon_sym_syncscope] = ACTIONS(681),
    [anon_sym_uselistorder] = ACTIONS(681),
  },
  [173] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(635),
    [sym_local_var] = ACTIONS(635),
    [sym_label] = ACTIONS(635),
    [sym_string] = ACTIONS(637),
    [anon_sym_RBRACE] = ACTIONS(635),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_COMMA] = ACTIONS(635),
    [anon_sym_align] = ACTIONS(637),
    [anon_sym_section] = ACTIONS(637),
    [anon_sym_partition] = ACTIONS(637),
    [anon_sym_comdat] = ACTIONS(637),
    [anon_sym_gc] = ACTIONS(637),
    [anon_sym_prefix] = ACTIONS(637),
    [anon_sym_prologue] = ACTIONS(637),
    [anon_sym_personality] = ACTIONS(637),
    [anon_sym_alignstack] = ACTIONS(637),
    [anon_sym_allocsize] = ACTIONS(637),
    [anon_sym_alwaysinline] = ACTIONS(637),
    [anon_sym_builtin] = ACTIONS(637),
    [anon_sym_cold] = ACTIONS(637),
    [anon_sym_convergent] = ACTIONS(637),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(637),
    [anon_sym_hot] = ACTIONS(637),
    [anon_sym_inaccessiblememonly] = ACTIONS(637),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(637),
    [anon_sym_inlinehint] = ACTIONS(637),
    [anon_sym_jumptable] = ACTIONS(637),
    [anon_sym_minsize] = ACTIONS(637),
    [anon_sym_naked] = ACTIONS(637),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(637),
    [anon_sym_nobuiltin] = ACTIONS(637),
    [anon_sym_noduplicate] = ACTIONS(637),
    [anon_sym_nofree] = ACTIONS(637),
    [anon_sym_noimplicitfloat] = ACTIONS(637),
    [anon_sym_noinline] = ACTIONS(637),
    [anon_sym_nomerge] = ACTIONS(637),
    [anon_sym_nonlazybind] = ACTIONS(637),
    [anon_sym_noprofile] = ACTIONS(637),
    [anon_sym_noredzone] = ACTIONS(637),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(637),
    [anon_sym_noreturn] = ACTIONS(637),
    [anon_sym_norecurse] = ACTIONS(637),
    [anon_sym_willreturn] = ACTIONS(637),
    [anon_sym_nosync] = ACTIONS(637),
    [anon_sym_nounwind] = ACTIONS(637),
    [anon_sym_nocallback] = ACTIONS(637),
    [anon_sym_nosanitize_coverage] = ACTIONS(637),
    [anon_sym_null_pointer_is_valid] = ACTIONS(637),
    [anon_sym_optforfuzzing] = ACTIONS(637),
    [anon_sym_optnone] = ACTIONS(637),
    [anon_sym_optsize] = ACTIONS(637),
    [anon_sym_readnone] = ACTIONS(637),
    [anon_sym_readonly] = ACTIONS(637),
    [anon_sym_writeonly] = ACTIONS(637),
    [anon_sym_argmemonly] = ACTIONS(637),
    [anon_sym_returns_twice] = ACTIONS(637),
    [anon_sym_safestack] = ACTIONS(637),
    [anon_sym_sanitize_address] = ACTIONS(637),
    [anon_sym_sanitize_memory] = ACTIONS(637),
    [anon_sym_sanitize_thread] = ACTIONS(637),
    [anon_sym_sanitize_hwaddress] = ACTIONS(637),
    [anon_sym_sanitize_memtag] = ACTIONS(637),
    [anon_sym_speculative_load_hardening] = ACTIONS(637),
    [anon_sym_speculatable] = ACTIONS(637),
    [anon_sym_ssp] = ACTIONS(637),
    [anon_sym_sspstrong] = ACTIONS(637),
    [anon_sym_sspreq] = ACTIONS(637),
    [anon_sym_strictfp] = ACTIONS(637),
    [anon_sym_nocf_check] = ACTIONS(637),
    [anon_sym_shadowcallstack] = ACTIONS(637),
    [anon_sym_mustprogress] = ACTIONS(637),
    [anon_sym_vscale_range] = ACTIONS(637),
    [anon_sym_preallocated] = ACTIONS(637),
    [anon_sym_zeroext] = ACTIONS(637),
    [anon_sym_signext] = ACTIONS(637),
    [anon_sym_inreg] = ACTIONS(637),
    [anon_sym_byval] = ACTIONS(637),
    [anon_sym_byref] = ACTIONS(637),
    [anon_sym_inalloca] = ACTIONS(637),
    [anon_sym_sret] = ACTIONS(637),
    [anon_sym_elementtype] = ACTIONS(637),
    [anon_sym_noalias] = ACTIONS(637),
    [anon_sym_nocapture] = ACTIONS(637),
    [anon_sym_nest] = ACTIONS(637),
    [anon_sym_returned] = ACTIONS(637),
    [anon_sym_nonnull] = ACTIONS(637),
    [anon_sym_dereferenceable] = ACTIONS(637),
    [anon_sym_dereferenceable_or_null] = ACTIONS(637),
    [anon_sym_swiftself] = ACTIONS(637),
    [anon_sym_swiftasync] = ACTIONS(637),
    [anon_sym_swifterror] = ACTIONS(637),
    [anon_sym_immarg] = ACTIONS(637),
    [anon_sym_noundef] = ACTIONS(637),
    [anon_sym_uwtable] = ACTIONS(637),
    [anon_sym_memory] = ACTIONS(637),
    [anon_sym_unreachable] = ACTIONS(637),
    [anon_sym_ret] = ACTIONS(637),
    [anon_sym_br] = ACTIONS(637),
    [anon_sym_resume] = ACTIONS(637),
    [anon_sym_freeze] = ACTIONS(637),
    [anon_sym_indirectbr] = ACTIONS(637),
    [anon_sym_extractelement] = ACTIONS(637),
    [anon_sym_insertelement] = ACTIONS(637),
    [anon_sym_select] = ACTIONS(637),
    [anon_sym_shufflevector] = ACTIONS(637),
    [anon_sym_fneg] = ACTIONS(637),
    [anon_sym_switch] = ACTIONS(637),
    [anon_sym_invoke] = ACTIONS(637),
    [anon_sym_cleanupret] = ACTIONS(637),
    [anon_sym_catchret] = ACTIONS(637),
    [anon_sym_catchswitch] = ACTIONS(637),
    [anon_sym_catchpad] = ACTIONS(637),
    [anon_sym_cleanuppad] = ACTIONS(637),
    [anon_sym_callbr] = ACTIONS(637),
    [anon_sym_icmp] = ACTIONS(637),
    [anon_sym_fcmp] = ACTIONS(637),
    [anon_sym_va_arg] = ACTIONS(637),
    [anon_sym_phi] = ACTIONS(637),
    [anon_sym_landingpad] = ACTIONS(637),
    [anon_sym_tail] = ACTIONS(637),
    [anon_sym_musttail] = ACTIONS(637),
    [anon_sym_notail] = ACTIONS(637),
    [anon_sym_call] = ACTIONS(637),
    [anon_sym_alloca] = ACTIONS(637),
    [anon_sym_load] = ACTIONS(637),
    [anon_sym_store] = ACTIONS(637),
    [anon_sym_cmpxchg] = ACTIONS(637),
    [anon_sym_atomicrmw] = ACTIONS(637),
    [anon_sym_fence] = ACTIONS(637),
    [anon_sym_getelementptr] = ACTIONS(637),
    [anon_sym_extractvalue] = ACTIONS(637),
    [anon_sym_insertvalue] = ACTIONS(637),
    [anon_sym_catch] = ACTIONS(637),
    [anon_sym_filter] = ACTIONS(637),
    [anon_sym_mul] = ACTIONS(637),
    [anon_sym_urem] = ACTIONS(637),
    [anon_sym_srem] = ACTIONS(637),
    [anon_sym_shl] = ACTIONS(637),
    [anon_sym_udiv] = ACTIONS(637),
    [anon_sym_sdiv] = ACTIONS(637),
    [anon_sym_lshr] = ACTIONS(637),
    [anon_sym_ashr] = ACTIONS(637),
    [anon_sym_fmul] = ACTIONS(637),
    [anon_sym_fdiv] = ACTIONS(637),
    [anon_sym_frem] = ACTIONS(637),
    [anon_sym_xchg] = ACTIONS(637),
    [anon_sym_add] = ACTIONS(637),
    [anon_sym_sub] = ACTIONS(637),
    [anon_sym_and] = ACTIONS(637),
    [anon_sym_nand] = ACTIONS(637),
    [anon_sym_or] = ACTIONS(637),
    [anon_sym_xor] = ACTIONS(637),
    [anon_sym_max] = ACTIONS(637),
    [anon_sym_min] = ACTIONS(637),
    [anon_sym_umax] = ACTIONS(637),
    [anon_sym_umin] = ACTIONS(637),
    [anon_sym_fadd] = ACTIONS(637),
    [anon_sym_fsub] = ACTIONS(637),
    [anon_sym_bitcast] = ACTIONS(637),
    [anon_sym_trunc] = ACTIONS(637),
    [anon_sym_zext] = ACTIONS(637),
    [anon_sym_sext] = ACTIONS(637),
    [anon_sym_fptrunc] = ACTIONS(637),
    [anon_sym_fpext] = ACTIONS(637),
    [anon_sym_addrspacecast] = ACTIONS(637),
    [anon_sym_uitofp] = ACTIONS(637),
    [anon_sym_sitofp] = ACTIONS(637),
    [anon_sym_fptoui] = ACTIONS(637),
    [anon_sym_fptosi] = ACTIONS(637),
    [anon_sym_inttoptr] = ACTIONS(637),
    [anon_sym_ptrtoint] = ACTIONS(637),
    [anon_sym_unordered] = ACTIONS(637),
    [anon_sym_monotonic] = ACTIONS(637),
    [anon_sym_acquire] = ACTIONS(637),
    [anon_sym_release] = ACTIONS(637),
    [anon_sym_acq_rel] = ACTIONS(637),
    [anon_sym_seq_cst] = ACTIONS(637),
    [anon_sym_syncscope] = ACTIONS(637),
    [anon_sym_uselistorder] = ACTIONS(637),
  },
  [174] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(647),
    [sym_local_var] = ACTIONS(647),
    [sym_label] = ACTIONS(647),
    [sym_string] = ACTIONS(649),
    [anon_sym_RBRACE] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(647),
    [anon_sym_COMMA] = ACTIONS(647),
    [anon_sym_align] = ACTIONS(649),
    [anon_sym_section] = ACTIONS(649),
    [anon_sym_partition] = ACTIONS(649),
    [anon_sym_comdat] = ACTIONS(649),
    [anon_sym_gc] = ACTIONS(649),
    [anon_sym_prefix] = ACTIONS(649),
    [anon_sym_prologue] = ACTIONS(649),
    [anon_sym_personality] = ACTIONS(649),
    [anon_sym_alignstack] = ACTIONS(649),
    [anon_sym_allocsize] = ACTIONS(649),
    [anon_sym_alwaysinline] = ACTIONS(649),
    [anon_sym_builtin] = ACTIONS(649),
    [anon_sym_cold] = ACTIONS(649),
    [anon_sym_convergent] = ACTIONS(649),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(649),
    [anon_sym_hot] = ACTIONS(649),
    [anon_sym_inaccessiblememonly] = ACTIONS(649),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(649),
    [anon_sym_inlinehint] = ACTIONS(649),
    [anon_sym_jumptable] = ACTIONS(649),
    [anon_sym_minsize] = ACTIONS(649),
    [anon_sym_naked] = ACTIONS(649),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(649),
    [anon_sym_nobuiltin] = ACTIONS(649),
    [anon_sym_noduplicate] = ACTIONS(649),
    [anon_sym_nofree] = ACTIONS(649),
    [anon_sym_noimplicitfloat] = ACTIONS(649),
    [anon_sym_noinline] = ACTIONS(649),
    [anon_sym_nomerge] = ACTIONS(649),
    [anon_sym_nonlazybind] = ACTIONS(649),
    [anon_sym_noprofile] = ACTIONS(649),
    [anon_sym_noredzone] = ACTIONS(649),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(649),
    [anon_sym_noreturn] = ACTIONS(649),
    [anon_sym_norecurse] = ACTIONS(649),
    [anon_sym_willreturn] = ACTIONS(649),
    [anon_sym_nosync] = ACTIONS(649),
    [anon_sym_nounwind] = ACTIONS(649),
    [anon_sym_nocallback] = ACTIONS(649),
    [anon_sym_nosanitize_coverage] = ACTIONS(649),
    [anon_sym_null_pointer_is_valid] = ACTIONS(649),
    [anon_sym_optforfuzzing] = ACTIONS(649),
    [anon_sym_optnone] = ACTIONS(649),
    [anon_sym_optsize] = ACTIONS(649),
    [anon_sym_readnone] = ACTIONS(649),
    [anon_sym_readonly] = ACTIONS(649),
    [anon_sym_writeonly] = ACTIONS(649),
    [anon_sym_argmemonly] = ACTIONS(649),
    [anon_sym_returns_twice] = ACTIONS(649),
    [anon_sym_safestack] = ACTIONS(649),
    [anon_sym_sanitize_address] = ACTIONS(649),
    [anon_sym_sanitize_memory] = ACTIONS(649),
    [anon_sym_sanitize_thread] = ACTIONS(649),
    [anon_sym_sanitize_hwaddress] = ACTIONS(649),
    [anon_sym_sanitize_memtag] = ACTIONS(649),
    [anon_sym_speculative_load_hardening] = ACTIONS(649),
    [anon_sym_speculatable] = ACTIONS(649),
    [anon_sym_ssp] = ACTIONS(649),
    [anon_sym_sspstrong] = ACTIONS(649),
    [anon_sym_sspreq] = ACTIONS(649),
    [anon_sym_strictfp] = ACTIONS(649),
    [anon_sym_nocf_check] = ACTIONS(649),
    [anon_sym_shadowcallstack] = ACTIONS(649),
    [anon_sym_mustprogress] = ACTIONS(649),
    [anon_sym_vscale_range] = ACTIONS(649),
    [anon_sym_preallocated] = ACTIONS(649),
    [anon_sym_zeroext] = ACTIONS(649),
    [anon_sym_signext] = ACTIONS(649),
    [anon_sym_inreg] = ACTIONS(649),
    [anon_sym_byval] = ACTIONS(649),
    [anon_sym_byref] = ACTIONS(649),
    [anon_sym_inalloca] = ACTIONS(649),
    [anon_sym_sret] = ACTIONS(649),
    [anon_sym_elementtype] = ACTIONS(649),
    [anon_sym_noalias] = ACTIONS(649),
    [anon_sym_nocapture] = ACTIONS(649),
    [anon_sym_nest] = ACTIONS(649),
    [anon_sym_returned] = ACTIONS(649),
    [anon_sym_nonnull] = ACTIONS(649),
    [anon_sym_dereferenceable] = ACTIONS(649),
    [anon_sym_dereferenceable_or_null] = ACTIONS(649),
    [anon_sym_swiftself] = ACTIONS(649),
    [anon_sym_swiftasync] = ACTIONS(649),
    [anon_sym_swifterror] = ACTIONS(649),
    [anon_sym_immarg] = ACTIONS(649),
    [anon_sym_noundef] = ACTIONS(649),
    [anon_sym_uwtable] = ACTIONS(649),
    [anon_sym_memory] = ACTIONS(649),
    [anon_sym_unreachable] = ACTIONS(649),
    [anon_sym_ret] = ACTIONS(649),
    [anon_sym_br] = ACTIONS(649),
    [anon_sym_resume] = ACTIONS(649),
    [anon_sym_freeze] = ACTIONS(649),
    [anon_sym_indirectbr] = ACTIONS(649),
    [anon_sym_extractelement] = ACTIONS(649),
    [anon_sym_insertelement] = ACTIONS(649),
    [anon_sym_select] = ACTIONS(649),
    [anon_sym_shufflevector] = ACTIONS(649),
    [anon_sym_fneg] = ACTIONS(649),
    [anon_sym_switch] = ACTIONS(649),
    [anon_sym_invoke] = ACTIONS(649),
    [anon_sym_cleanupret] = ACTIONS(649),
    [anon_sym_catchret] = ACTIONS(649),
    [anon_sym_catchswitch] = ACTIONS(649),
    [anon_sym_catchpad] = ACTIONS(649),
    [anon_sym_cleanuppad] = ACTIONS(649),
    [anon_sym_callbr] = ACTIONS(649),
    [anon_sym_icmp] = ACTIONS(649),
    [anon_sym_fcmp] = ACTIONS(649),
    [anon_sym_va_arg] = ACTIONS(649),
    [anon_sym_phi] = ACTIONS(649),
    [anon_sym_landingpad] = ACTIONS(649),
    [anon_sym_tail] = ACTIONS(649),
    [anon_sym_musttail] = ACTIONS(649),
    [anon_sym_notail] = ACTIONS(649),
    [anon_sym_call] = ACTIONS(649),
    [anon_sym_alloca] = ACTIONS(649),
    [anon_sym_load] = ACTIONS(649),
    [anon_sym_store] = ACTIONS(649),
    [anon_sym_cmpxchg] = ACTIONS(649),
    [anon_sym_atomicrmw] = ACTIONS(649),
    [anon_sym_fence] = ACTIONS(649),
    [anon_sym_getelementptr] = ACTIONS(649),
    [anon_sym_extractvalue] = ACTIONS(649),
    [anon_sym_insertvalue] = ACTIONS(649),
    [anon_sym_catch] = ACTIONS(649),
    [anon_sym_filter] = ACTIONS(649),
    [anon_sym_mul] = ACTIONS(649),
    [anon_sym_urem] = ACTIONS(649),
    [anon_sym_srem] = ACTIONS(649),
    [anon_sym_shl] = ACTIONS(649),
    [anon_sym_udiv] = ACTIONS(649),
    [anon_sym_sdiv] = ACTIONS(649),
    [anon_sym_lshr] = ACTIONS(649),
    [anon_sym_ashr] = ACTIONS(649),
    [anon_sym_fmul] = ACTIONS(649),
    [anon_sym_fdiv] = ACTIONS(649),
    [anon_sym_frem] = ACTIONS(649),
    [anon_sym_xchg] = ACTIONS(649),
    [anon_sym_add] = ACTIONS(649),
    [anon_sym_sub] = ACTIONS(649),
    [anon_sym_and] = ACTIONS(649),
    [anon_sym_nand] = ACTIONS(649),
    [anon_sym_or] = ACTIONS(649),
    [anon_sym_xor] = ACTIONS(649),
    [anon_sym_max] = ACTIONS(649),
    [anon_sym_min] = ACTIONS(649),
    [anon_sym_umax] = ACTIONS(649),
    [anon_sym_umin] = ACTIONS(649),
    [anon_sym_fadd] = ACTIONS(649),
    [anon_sym_fsub] = ACTIONS(649),
    [anon_sym_bitcast] = ACTIONS(649),
    [anon_sym_trunc] = ACTIONS(649),
    [anon_sym_zext] = ACTIONS(649),
    [anon_sym_sext] = ACTIONS(649),
    [anon_sym_fptrunc] = ACTIONS(649),
    [anon_sym_fpext] = ACTIONS(649),
    [anon_sym_addrspacecast] = ACTIONS(649),
    [anon_sym_uitofp] = ACTIONS(649),
    [anon_sym_sitofp] = ACTIONS(649),
    [anon_sym_fptoui] = ACTIONS(649),
    [anon_sym_fptosi] = ACTIONS(649),
    [anon_sym_inttoptr] = ACTIONS(649),
    [anon_sym_ptrtoint] = ACTIONS(649),
    [anon_sym_unordered] = ACTIONS(649),
    [anon_sym_monotonic] = ACTIONS(649),
    [anon_sym_acquire] = ACTIONS(649),
    [anon_sym_release] = ACTIONS(649),
    [anon_sym_acq_rel] = ACTIONS(649),
    [anon_sym_seq_cst] = ACTIONS(649),
    [anon_sym_syncscope] = ACTIONS(649),
    [anon_sym_uselistorder] = ACTIONS(649),
  },
  [175] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(521),
    [sym_local_var] = ACTIONS(521),
    [sym_label] = ACTIONS(521),
    [sym_string] = ACTIONS(523),
    [anon_sym_RBRACE] = ACTIONS(521),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_COMMA] = ACTIONS(521),
    [anon_sym_align] = ACTIONS(523),
    [anon_sym_section] = ACTIONS(523),
    [anon_sym_partition] = ACTIONS(523),
    [anon_sym_comdat] = ACTIONS(523),
    [anon_sym_gc] = ACTIONS(523),
    [anon_sym_prefix] = ACTIONS(523),
    [anon_sym_prologue] = ACTIONS(523),
    [anon_sym_personality] = ACTIONS(523),
    [anon_sym_alignstack] = ACTIONS(523),
    [anon_sym_allocsize] = ACTIONS(523),
    [anon_sym_alwaysinline] = ACTIONS(523),
    [anon_sym_builtin] = ACTIONS(523),
    [anon_sym_cold] = ACTIONS(523),
    [anon_sym_convergent] = ACTIONS(523),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(523),
    [anon_sym_hot] = ACTIONS(523),
    [anon_sym_inaccessiblememonly] = ACTIONS(523),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(523),
    [anon_sym_inlinehint] = ACTIONS(523),
    [anon_sym_jumptable] = ACTIONS(523),
    [anon_sym_minsize] = ACTIONS(523),
    [anon_sym_naked] = ACTIONS(523),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(523),
    [anon_sym_nobuiltin] = ACTIONS(523),
    [anon_sym_noduplicate] = ACTIONS(523),
    [anon_sym_nofree] = ACTIONS(523),
    [anon_sym_noimplicitfloat] = ACTIONS(523),
    [anon_sym_noinline] = ACTIONS(523),
    [anon_sym_nomerge] = ACTIONS(523),
    [anon_sym_nonlazybind] = ACTIONS(523),
    [anon_sym_noprofile] = ACTIONS(523),
    [anon_sym_noredzone] = ACTIONS(523),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(523),
    [anon_sym_noreturn] = ACTIONS(523),
    [anon_sym_norecurse] = ACTIONS(523),
    [anon_sym_willreturn] = ACTIONS(523),
    [anon_sym_nosync] = ACTIONS(523),
    [anon_sym_nounwind] = ACTIONS(523),
    [anon_sym_nocallback] = ACTIONS(523),
    [anon_sym_nosanitize_coverage] = ACTIONS(523),
    [anon_sym_null_pointer_is_valid] = ACTIONS(523),
    [anon_sym_optforfuzzing] = ACTIONS(523),
    [anon_sym_optnone] = ACTIONS(523),
    [anon_sym_optsize] = ACTIONS(523),
    [anon_sym_readnone] = ACTIONS(523),
    [anon_sym_readonly] = ACTIONS(523),
    [anon_sym_writeonly] = ACTIONS(523),
    [anon_sym_argmemonly] = ACTIONS(523),
    [anon_sym_returns_twice] = ACTIONS(523),
    [anon_sym_safestack] = ACTIONS(523),
    [anon_sym_sanitize_address] = ACTIONS(523),
    [anon_sym_sanitize_memory] = ACTIONS(523),
    [anon_sym_sanitize_thread] = ACTIONS(523),
    [anon_sym_sanitize_hwaddress] = ACTIONS(523),
    [anon_sym_sanitize_memtag] = ACTIONS(523),
    [anon_sym_speculative_load_hardening] = ACTIONS(523),
    [anon_sym_speculatable] = ACTIONS(523),
    [anon_sym_ssp] = ACTIONS(523),
    [anon_sym_sspstrong] = ACTIONS(523),
    [anon_sym_sspreq] = ACTIONS(523),
    [anon_sym_strictfp] = ACTIONS(523),
    [anon_sym_nocf_check] = ACTIONS(523),
    [anon_sym_shadowcallstack] = ACTIONS(523),
    [anon_sym_mustprogress] = ACTIONS(523),
    [anon_sym_vscale_range] = ACTIONS(523),
    [anon_sym_preallocated] = ACTIONS(523),
    [anon_sym_zeroext] = ACTIONS(523),
    [anon_sym_signext] = ACTIONS(523),
    [anon_sym_inreg] = ACTIONS(523),
    [anon_sym_byval] = ACTIONS(523),
    [anon_sym_byref] = ACTIONS(523),
    [anon_sym_inalloca] = ACTIONS(523),
    [anon_sym_sret] = ACTIONS(523),
    [anon_sym_elementtype] = ACTIONS(523),
    [anon_sym_noalias] = ACTIONS(523),
    [anon_sym_nocapture] = ACTIONS(523),
    [anon_sym_nest] = ACTIONS(523),
    [anon_sym_returned] = ACTIONS(523),
    [anon_sym_nonnull] = ACTIONS(523),
    [anon_sym_dereferenceable] = ACTIONS(523),
    [anon_sym_dereferenceable_or_null] = ACTIONS(523),
    [anon_sym_swiftself] = ACTIONS(523),
    [anon_sym_swiftasync] = ACTIONS(523),
    [anon_sym_swifterror] = ACTIONS(523),
    [anon_sym_immarg] = ACTIONS(523),
    [anon_sym_noundef] = ACTIONS(523),
    [anon_sym_uwtable] = ACTIONS(523),
    [anon_sym_memory] = ACTIONS(523),
    [anon_sym_unreachable] = ACTIONS(523),
    [anon_sym_ret] = ACTIONS(523),
    [anon_sym_br] = ACTIONS(523),
    [anon_sym_resume] = ACTIONS(523),
    [anon_sym_freeze] = ACTIONS(523),
    [anon_sym_indirectbr] = ACTIONS(523),
    [anon_sym_extractelement] = ACTIONS(523),
    [anon_sym_insertelement] = ACTIONS(523),
    [anon_sym_select] = ACTIONS(523),
    [anon_sym_shufflevector] = ACTIONS(523),
    [anon_sym_fneg] = ACTIONS(523),
    [anon_sym_switch] = ACTIONS(523),
    [anon_sym_invoke] = ACTIONS(523),
    [anon_sym_cleanupret] = ACTIONS(523),
    [anon_sym_catchret] = ACTIONS(523),
    [anon_sym_catchswitch] = ACTIONS(523),
    [anon_sym_catchpad] = ACTIONS(523),
    [anon_sym_cleanuppad] = ACTIONS(523),
    [anon_sym_callbr] = ACTIONS(523),
    [anon_sym_icmp] = ACTIONS(523),
    [anon_sym_fcmp] = ACTIONS(523),
    [anon_sym_va_arg] = ACTIONS(523),
    [anon_sym_phi] = ACTIONS(523),
    [anon_sym_landingpad] = ACTIONS(523),
    [anon_sym_tail] = ACTIONS(523),
    [anon_sym_musttail] = ACTIONS(523),
    [anon_sym_notail] = ACTIONS(523),
    [anon_sym_call] = ACTIONS(523),
    [anon_sym_alloca] = ACTIONS(523),
    [anon_sym_load] = ACTIONS(523),
    [anon_sym_store] = ACTIONS(523),
    [anon_sym_cmpxchg] = ACTIONS(523),
    [anon_sym_atomicrmw] = ACTIONS(523),
    [anon_sym_fence] = ACTIONS(523),
    [anon_sym_getelementptr] = ACTIONS(523),
    [anon_sym_extractvalue] = ACTIONS(523),
    [anon_sym_insertvalue] = ACTIONS(523),
    [anon_sym_catch] = ACTIONS(523),
    [anon_sym_filter] = ACTIONS(523),
    [anon_sym_mul] = ACTIONS(523),
    [anon_sym_urem] = ACTIONS(523),
    [anon_sym_srem] = ACTIONS(523),
    [anon_sym_shl] = ACTIONS(523),
    [anon_sym_udiv] = ACTIONS(523),
    [anon_sym_sdiv] = ACTIONS(523),
    [anon_sym_lshr] = ACTIONS(523),
    [anon_sym_ashr] = ACTIONS(523),
    [anon_sym_fmul] = ACTIONS(523),
    [anon_sym_fdiv] = ACTIONS(523),
    [anon_sym_frem] = ACTIONS(523),
    [anon_sym_xchg] = ACTIONS(523),
    [anon_sym_add] = ACTIONS(523),
    [anon_sym_sub] = ACTIONS(523),
    [anon_sym_and] = ACTIONS(523),
    [anon_sym_nand] = ACTIONS(523),
    [anon_sym_or] = ACTIONS(523),
    [anon_sym_xor] = ACTIONS(523),
    [anon_sym_max] = ACTIONS(523),
    [anon_sym_min] = ACTIONS(523),
    [anon_sym_umax] = ACTIONS(523),
    [anon_sym_umin] = ACTIONS(523),
    [anon_sym_fadd] = ACTIONS(523),
    [anon_sym_fsub] = ACTIONS(523),
    [anon_sym_bitcast] = ACTIONS(523),
    [anon_sym_trunc] = ACTIONS(523),
    [anon_sym_zext] = ACTIONS(523),
    [anon_sym_sext] = ACTIONS(523),
    [anon_sym_fptrunc] = ACTIONS(523),
    [anon_sym_fpext] = ACTIONS(523),
    [anon_sym_addrspacecast] = ACTIONS(523),
    [anon_sym_uitofp] = ACTIONS(523),
    [anon_sym_sitofp] = ACTIONS(523),
    [anon_sym_fptoui] = ACTIONS(523),
    [anon_sym_fptosi] = ACTIONS(523),
    [anon_sym_inttoptr] = ACTIONS(523),
    [anon_sym_ptrtoint] = ACTIONS(523),
    [anon_sym_unordered] = ACTIONS(523),
    [anon_sym_monotonic] = ACTIONS(523),
    [anon_sym_acquire] = ACTIONS(523),
    [anon_sym_release] = ACTIONS(523),
    [anon_sym_acq_rel] = ACTIONS(523),
    [anon_sym_seq_cst] = ACTIONS(523),
    [anon_sym_syncscope] = ACTIONS(523),
    [anon_sym_uselistorder] = ACTIONS(523),
  },
  [176] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(595),
    [sym_local_var] = ACTIONS(595),
    [sym_label] = ACTIONS(595),
    [sym_string] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(595),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_COMMA] = ACTIONS(595),
    [anon_sym_align] = ACTIONS(597),
    [anon_sym_section] = ACTIONS(597),
    [anon_sym_partition] = ACTIONS(597),
    [anon_sym_comdat] = ACTIONS(597),
    [anon_sym_gc] = ACTIONS(597),
    [anon_sym_prefix] = ACTIONS(597),
    [anon_sym_prologue] = ACTIONS(597),
    [anon_sym_personality] = ACTIONS(597),
    [anon_sym_alignstack] = ACTIONS(597),
    [anon_sym_allocsize] = ACTIONS(597),
    [anon_sym_alwaysinline] = ACTIONS(597),
    [anon_sym_builtin] = ACTIONS(597),
    [anon_sym_cold] = ACTIONS(597),
    [anon_sym_convergent] = ACTIONS(597),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(597),
    [anon_sym_hot] = ACTIONS(597),
    [anon_sym_inaccessiblememonly] = ACTIONS(597),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(597),
    [anon_sym_inlinehint] = ACTIONS(597),
    [anon_sym_jumptable] = ACTIONS(597),
    [anon_sym_minsize] = ACTIONS(597),
    [anon_sym_naked] = ACTIONS(597),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(597),
    [anon_sym_nobuiltin] = ACTIONS(597),
    [anon_sym_noduplicate] = ACTIONS(597),
    [anon_sym_nofree] = ACTIONS(597),
    [anon_sym_noimplicitfloat] = ACTIONS(597),
    [anon_sym_noinline] = ACTIONS(597),
    [anon_sym_nomerge] = ACTIONS(597),
    [anon_sym_nonlazybind] = ACTIONS(597),
    [anon_sym_noprofile] = ACTIONS(597),
    [anon_sym_noredzone] = ACTIONS(597),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(597),
    [anon_sym_noreturn] = ACTIONS(597),
    [anon_sym_norecurse] = ACTIONS(597),
    [anon_sym_willreturn] = ACTIONS(597),
    [anon_sym_nosync] = ACTIONS(597),
    [anon_sym_nounwind] = ACTIONS(597),
    [anon_sym_nocallback] = ACTIONS(597),
    [anon_sym_nosanitize_coverage] = ACTIONS(597),
    [anon_sym_null_pointer_is_valid] = ACTIONS(597),
    [anon_sym_optforfuzzing] = ACTIONS(597),
    [anon_sym_optnone] = ACTIONS(597),
    [anon_sym_optsize] = ACTIONS(597),
    [anon_sym_readnone] = ACTIONS(597),
    [anon_sym_readonly] = ACTIONS(597),
    [anon_sym_writeonly] = ACTIONS(597),
    [anon_sym_argmemonly] = ACTIONS(597),
    [anon_sym_returns_twice] = ACTIONS(597),
    [anon_sym_safestack] = ACTIONS(597),
    [anon_sym_sanitize_address] = ACTIONS(597),
    [anon_sym_sanitize_memory] = ACTIONS(597),
    [anon_sym_sanitize_thread] = ACTIONS(597),
    [anon_sym_sanitize_hwaddress] = ACTIONS(597),
    [anon_sym_sanitize_memtag] = ACTIONS(597),
    [anon_sym_speculative_load_hardening] = ACTIONS(597),
    [anon_sym_speculatable] = ACTIONS(597),
    [anon_sym_ssp] = ACTIONS(597),
    [anon_sym_sspstrong] = ACTIONS(597),
    [anon_sym_sspreq] = ACTIONS(597),
    [anon_sym_strictfp] = ACTIONS(597),
    [anon_sym_nocf_check] = ACTIONS(597),
    [anon_sym_shadowcallstack] = ACTIONS(597),
    [anon_sym_mustprogress] = ACTIONS(597),
    [anon_sym_vscale_range] = ACTIONS(597),
    [anon_sym_preallocated] = ACTIONS(597),
    [anon_sym_zeroext] = ACTIONS(597),
    [anon_sym_signext] = ACTIONS(597),
    [anon_sym_inreg] = ACTIONS(597),
    [anon_sym_byval] = ACTIONS(597),
    [anon_sym_byref] = ACTIONS(597),
    [anon_sym_inalloca] = ACTIONS(597),
    [anon_sym_sret] = ACTIONS(597),
    [anon_sym_elementtype] = ACTIONS(597),
    [anon_sym_noalias] = ACTIONS(597),
    [anon_sym_nocapture] = ACTIONS(597),
    [anon_sym_nest] = ACTIONS(597),
    [anon_sym_returned] = ACTIONS(597),
    [anon_sym_nonnull] = ACTIONS(597),
    [anon_sym_dereferenceable] = ACTIONS(597),
    [anon_sym_dereferenceable_or_null] = ACTIONS(597),
    [anon_sym_swiftself] = ACTIONS(597),
    [anon_sym_swiftasync] = ACTIONS(597),
    [anon_sym_swifterror] = ACTIONS(597),
    [anon_sym_immarg] = ACTIONS(597),
    [anon_sym_noundef] = ACTIONS(597),
    [anon_sym_uwtable] = ACTIONS(597),
    [anon_sym_memory] = ACTIONS(597),
    [anon_sym_unreachable] = ACTIONS(597),
    [anon_sym_ret] = ACTIONS(597),
    [anon_sym_br] = ACTIONS(597),
    [anon_sym_resume] = ACTIONS(597),
    [anon_sym_freeze] = ACTIONS(597),
    [anon_sym_indirectbr] = ACTIONS(597),
    [anon_sym_extractelement] = ACTIONS(597),
    [anon_sym_insertelement] = ACTIONS(597),
    [anon_sym_select] = ACTIONS(597),
    [anon_sym_shufflevector] = ACTIONS(597),
    [anon_sym_fneg] = ACTIONS(597),
    [anon_sym_switch] = ACTIONS(597),
    [anon_sym_invoke] = ACTIONS(597),
    [anon_sym_cleanupret] = ACTIONS(597),
    [anon_sym_catchret] = ACTIONS(597),
    [anon_sym_catchswitch] = ACTIONS(597),
    [anon_sym_catchpad] = ACTIONS(597),
    [anon_sym_cleanuppad] = ACTIONS(597),
    [anon_sym_callbr] = ACTIONS(597),
    [anon_sym_icmp] = ACTIONS(597),
    [anon_sym_fcmp] = ACTIONS(597),
    [anon_sym_va_arg] = ACTIONS(597),
    [anon_sym_phi] = ACTIONS(597),
    [anon_sym_landingpad] = ACTIONS(597),
    [anon_sym_tail] = ACTIONS(597),
    [anon_sym_musttail] = ACTIONS(597),
    [anon_sym_notail] = ACTIONS(597),
    [anon_sym_call] = ACTIONS(597),
    [anon_sym_alloca] = ACTIONS(597),
    [anon_sym_load] = ACTIONS(597),
    [anon_sym_store] = ACTIONS(597),
    [anon_sym_cmpxchg] = ACTIONS(597),
    [anon_sym_atomicrmw] = ACTIONS(597),
    [anon_sym_fence] = ACTIONS(597),
    [anon_sym_getelementptr] = ACTIONS(597),
    [anon_sym_extractvalue] = ACTIONS(597),
    [anon_sym_insertvalue] = ACTIONS(597),
    [anon_sym_catch] = ACTIONS(597),
    [anon_sym_filter] = ACTIONS(597),
    [anon_sym_mul] = ACTIONS(597),
    [anon_sym_urem] = ACTIONS(597),
    [anon_sym_srem] = ACTIONS(597),
    [anon_sym_shl] = ACTIONS(597),
    [anon_sym_udiv] = ACTIONS(597),
    [anon_sym_sdiv] = ACTIONS(597),
    [anon_sym_lshr] = ACTIONS(597),
    [anon_sym_ashr] = ACTIONS(597),
    [anon_sym_fmul] = ACTIONS(597),
    [anon_sym_fdiv] = ACTIONS(597),
    [anon_sym_frem] = ACTIONS(597),
    [anon_sym_xchg] = ACTIONS(597),
    [anon_sym_add] = ACTIONS(597),
    [anon_sym_sub] = ACTIONS(597),
    [anon_sym_and] = ACTIONS(597),
    [anon_sym_nand] = ACTIONS(597),
    [anon_sym_or] = ACTIONS(597),
    [anon_sym_xor] = ACTIONS(597),
    [anon_sym_max] = ACTIONS(597),
    [anon_sym_min] = ACTIONS(597),
    [anon_sym_umax] = ACTIONS(597),
    [anon_sym_umin] = ACTIONS(597),
    [anon_sym_fadd] = ACTIONS(597),
    [anon_sym_fsub] = ACTIONS(597),
    [anon_sym_bitcast] = ACTIONS(597),
    [anon_sym_trunc] = ACTIONS(597),
    [anon_sym_zext] = ACTIONS(597),
    [anon_sym_sext] = ACTIONS(597),
    [anon_sym_fptrunc] = ACTIONS(597),
    [anon_sym_fpext] = ACTIONS(597),
    [anon_sym_addrspacecast] = ACTIONS(597),
    [anon_sym_uitofp] = ACTIONS(597),
    [anon_sym_sitofp] = ACTIONS(597),
    [anon_sym_fptoui] = ACTIONS(597),
    [anon_sym_fptosi] = ACTIONS(597),
    [anon_sym_inttoptr] = ACTIONS(597),
    [anon_sym_ptrtoint] = ACTIONS(597),
    [anon_sym_unordered] = ACTIONS(597),
    [anon_sym_monotonic] = ACTIONS(597),
    [anon_sym_acquire] = ACTIONS(597),
    [anon_sym_release] = ACTIONS(597),
    [anon_sym_acq_rel] = ACTIONS(597),
    [anon_sym_seq_cst] = ACTIONS(597),
    [anon_sym_syncscope] = ACTIONS(597),
    [anon_sym_uselistorder] = ACTIONS(597),
  },
  [177] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(643),
    [sym_local_var] = ACTIONS(643),
    [sym_label] = ACTIONS(643),
    [sym_string] = ACTIONS(645),
    [anon_sym_RBRACE] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_align] = ACTIONS(645),
    [anon_sym_section] = ACTIONS(645),
    [anon_sym_partition] = ACTIONS(645),
    [anon_sym_comdat] = ACTIONS(645),
    [anon_sym_gc] = ACTIONS(645),
    [anon_sym_prefix] = ACTIONS(645),
    [anon_sym_prologue] = ACTIONS(645),
    [anon_sym_personality] = ACTIONS(645),
    [anon_sym_alignstack] = ACTIONS(645),
    [anon_sym_allocsize] = ACTIONS(645),
    [anon_sym_alwaysinline] = ACTIONS(645),
    [anon_sym_builtin] = ACTIONS(645),
    [anon_sym_cold] = ACTIONS(645),
    [anon_sym_convergent] = ACTIONS(645),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(645),
    [anon_sym_hot] = ACTIONS(645),
    [anon_sym_inaccessiblememonly] = ACTIONS(645),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(645),
    [anon_sym_inlinehint] = ACTIONS(645),
    [anon_sym_jumptable] = ACTIONS(645),
    [anon_sym_minsize] = ACTIONS(645),
    [anon_sym_naked] = ACTIONS(645),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(645),
    [anon_sym_nobuiltin] = ACTIONS(645),
    [anon_sym_noduplicate] = ACTIONS(645),
    [anon_sym_nofree] = ACTIONS(645),
    [anon_sym_noimplicitfloat] = ACTIONS(645),
    [anon_sym_noinline] = ACTIONS(645),
    [anon_sym_nomerge] = ACTIONS(645),
    [anon_sym_nonlazybind] = ACTIONS(645),
    [anon_sym_noprofile] = ACTIONS(645),
    [anon_sym_noredzone] = ACTIONS(645),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(645),
    [anon_sym_noreturn] = ACTIONS(645),
    [anon_sym_norecurse] = ACTIONS(645),
    [anon_sym_willreturn] = ACTIONS(645),
    [anon_sym_nosync] = ACTIONS(645),
    [anon_sym_nounwind] = ACTIONS(645),
    [anon_sym_nocallback] = ACTIONS(645),
    [anon_sym_nosanitize_coverage] = ACTIONS(645),
    [anon_sym_null_pointer_is_valid] = ACTIONS(645),
    [anon_sym_optforfuzzing] = ACTIONS(645),
    [anon_sym_optnone] = ACTIONS(645),
    [anon_sym_optsize] = ACTIONS(645),
    [anon_sym_readnone] = ACTIONS(645),
    [anon_sym_readonly] = ACTIONS(645),
    [anon_sym_writeonly] = ACTIONS(645),
    [anon_sym_argmemonly] = ACTIONS(645),
    [anon_sym_returns_twice] = ACTIONS(645),
    [anon_sym_safestack] = ACTIONS(645),
    [anon_sym_sanitize_address] = ACTIONS(645),
    [anon_sym_sanitize_memory] = ACTIONS(645),
    [anon_sym_sanitize_thread] = ACTIONS(645),
    [anon_sym_sanitize_hwaddress] = ACTIONS(645),
    [anon_sym_sanitize_memtag] = ACTIONS(645),
    [anon_sym_speculative_load_hardening] = ACTIONS(645),
    [anon_sym_speculatable] = ACTIONS(645),
    [anon_sym_ssp] = ACTIONS(645),
    [anon_sym_sspstrong] = ACTIONS(645),
    [anon_sym_sspreq] = ACTIONS(645),
    [anon_sym_strictfp] = ACTIONS(645),
    [anon_sym_nocf_check] = ACTIONS(645),
    [anon_sym_shadowcallstack] = ACTIONS(645),
    [anon_sym_mustprogress] = ACTIONS(645),
    [anon_sym_vscale_range] = ACTIONS(645),
    [anon_sym_preallocated] = ACTIONS(645),
    [anon_sym_zeroext] = ACTIONS(645),
    [anon_sym_signext] = ACTIONS(645),
    [anon_sym_inreg] = ACTIONS(645),
    [anon_sym_byval] = ACTIONS(645),
    [anon_sym_byref] = ACTIONS(645),
    [anon_sym_inalloca] = ACTIONS(645),
    [anon_sym_sret] = ACTIONS(645),
    [anon_sym_elementtype] = ACTIONS(645),
    [anon_sym_noalias] = ACTIONS(645),
    [anon_sym_nocapture] = ACTIONS(645),
    [anon_sym_nest] = ACTIONS(645),
    [anon_sym_returned] = ACTIONS(645),
    [anon_sym_nonnull] = ACTIONS(645),
    [anon_sym_dereferenceable] = ACTIONS(645),
    [anon_sym_dereferenceable_or_null] = ACTIONS(645),
    [anon_sym_swiftself] = ACTIONS(645),
    [anon_sym_swiftasync] = ACTIONS(645),
    [anon_sym_swifterror] = ACTIONS(645),
    [anon_sym_immarg] = ACTIONS(645),
    [anon_sym_noundef] = ACTIONS(645),
    [anon_sym_uwtable] = ACTIONS(645),
    [anon_sym_memory] = ACTIONS(645),
    [anon_sym_unreachable] = ACTIONS(645),
    [anon_sym_ret] = ACTIONS(645),
    [anon_sym_br] = ACTIONS(645),
    [anon_sym_resume] = ACTIONS(645),
    [anon_sym_freeze] = ACTIONS(645),
    [anon_sym_indirectbr] = ACTIONS(645),
    [anon_sym_extractelement] = ACTIONS(645),
    [anon_sym_insertelement] = ACTIONS(645),
    [anon_sym_select] = ACTIONS(645),
    [anon_sym_shufflevector] = ACTIONS(645),
    [anon_sym_fneg] = ACTIONS(645),
    [anon_sym_switch] = ACTIONS(645),
    [anon_sym_invoke] = ACTIONS(645),
    [anon_sym_cleanupret] = ACTIONS(645),
    [anon_sym_catchret] = ACTIONS(645),
    [anon_sym_catchswitch] = ACTIONS(645),
    [anon_sym_catchpad] = ACTIONS(645),
    [anon_sym_cleanuppad] = ACTIONS(645),
    [anon_sym_callbr] = ACTIONS(645),
    [anon_sym_icmp] = ACTIONS(645),
    [anon_sym_fcmp] = ACTIONS(645),
    [anon_sym_va_arg] = ACTIONS(645),
    [anon_sym_phi] = ACTIONS(645),
    [anon_sym_landingpad] = ACTIONS(645),
    [anon_sym_tail] = ACTIONS(645),
    [anon_sym_musttail] = ACTIONS(645),
    [anon_sym_notail] = ACTIONS(645),
    [anon_sym_call] = ACTIONS(645),
    [anon_sym_alloca] = ACTIONS(645),
    [anon_sym_load] = ACTIONS(645),
    [anon_sym_store] = ACTIONS(645),
    [anon_sym_cmpxchg] = ACTIONS(645),
    [anon_sym_atomicrmw] = ACTIONS(645),
    [anon_sym_fence] = ACTIONS(645),
    [anon_sym_getelementptr] = ACTIONS(645),
    [anon_sym_extractvalue] = ACTIONS(645),
    [anon_sym_insertvalue] = ACTIONS(645),
    [anon_sym_catch] = ACTIONS(645),
    [anon_sym_filter] = ACTIONS(645),
    [anon_sym_mul] = ACTIONS(645),
    [anon_sym_urem] = ACTIONS(645),
    [anon_sym_srem] = ACTIONS(645),
    [anon_sym_shl] = ACTIONS(645),
    [anon_sym_udiv] = ACTIONS(645),
    [anon_sym_sdiv] = ACTIONS(645),
    [anon_sym_lshr] = ACTIONS(645),
    [anon_sym_ashr] = ACTIONS(645),
    [anon_sym_fmul] = ACTIONS(645),
    [anon_sym_fdiv] = ACTIONS(645),
    [anon_sym_frem] = ACTIONS(645),
    [anon_sym_xchg] = ACTIONS(645),
    [anon_sym_add] = ACTIONS(645),
    [anon_sym_sub] = ACTIONS(645),
    [anon_sym_and] = ACTIONS(645),
    [anon_sym_nand] = ACTIONS(645),
    [anon_sym_or] = ACTIONS(645),
    [anon_sym_xor] = ACTIONS(645),
    [anon_sym_max] = ACTIONS(645),
    [anon_sym_min] = ACTIONS(645),
    [anon_sym_umax] = ACTIONS(645),
    [anon_sym_umin] = ACTIONS(645),
    [anon_sym_fadd] = ACTIONS(645),
    [anon_sym_fsub] = ACTIONS(645),
    [anon_sym_bitcast] = ACTIONS(645),
    [anon_sym_trunc] = ACTIONS(645),
    [anon_sym_zext] = ACTIONS(645),
    [anon_sym_sext] = ACTIONS(645),
    [anon_sym_fptrunc] = ACTIONS(645),
    [anon_sym_fpext] = ACTIONS(645),
    [anon_sym_addrspacecast] = ACTIONS(645),
    [anon_sym_uitofp] = ACTIONS(645),
    [anon_sym_sitofp] = ACTIONS(645),
    [anon_sym_fptoui] = ACTIONS(645),
    [anon_sym_fptosi] = ACTIONS(645),
    [anon_sym_inttoptr] = ACTIONS(645),
    [anon_sym_ptrtoint] = ACTIONS(645),
    [anon_sym_unordered] = ACTIONS(645),
    [anon_sym_monotonic] = ACTIONS(645),
    [anon_sym_acquire] = ACTIONS(645),
    [anon_sym_release] = ACTIONS(645),
    [anon_sym_acq_rel] = ACTIONS(645),
    [anon_sym_seq_cst] = ACTIONS(645),
    [anon_sym_syncscope] = ACTIONS(645),
    [anon_sym_uselistorder] = ACTIONS(645),
  },
  [178] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(615),
    [sym_local_var] = ACTIONS(615),
    [sym_label] = ACTIONS(615),
    [sym_string] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(615),
    [anon_sym_LBRACK] = ACTIONS(615),
    [anon_sym_COMMA] = ACTIONS(615),
    [anon_sym_align] = ACTIONS(617),
    [anon_sym_section] = ACTIONS(617),
    [anon_sym_partition] = ACTIONS(617),
    [anon_sym_comdat] = ACTIONS(617),
    [anon_sym_gc] = ACTIONS(617),
    [anon_sym_prefix] = ACTIONS(617),
    [anon_sym_prologue] = ACTIONS(617),
    [anon_sym_personality] = ACTIONS(617),
    [anon_sym_alignstack] = ACTIONS(617),
    [anon_sym_allocsize] = ACTIONS(617),
    [anon_sym_alwaysinline] = ACTIONS(617),
    [anon_sym_builtin] = ACTIONS(617),
    [anon_sym_cold] = ACTIONS(617),
    [anon_sym_convergent] = ACTIONS(617),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(617),
    [anon_sym_hot] = ACTIONS(617),
    [anon_sym_inaccessiblememonly] = ACTIONS(617),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(617),
    [anon_sym_inlinehint] = ACTIONS(617),
    [anon_sym_jumptable] = ACTIONS(617),
    [anon_sym_minsize] = ACTIONS(617),
    [anon_sym_naked] = ACTIONS(617),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(617),
    [anon_sym_nobuiltin] = ACTIONS(617),
    [anon_sym_noduplicate] = ACTIONS(617),
    [anon_sym_nofree] = ACTIONS(617),
    [anon_sym_noimplicitfloat] = ACTIONS(617),
    [anon_sym_noinline] = ACTIONS(617),
    [anon_sym_nomerge] = ACTIONS(617),
    [anon_sym_nonlazybind] = ACTIONS(617),
    [anon_sym_noprofile] = ACTIONS(617),
    [anon_sym_noredzone] = ACTIONS(617),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(617),
    [anon_sym_noreturn] = ACTIONS(617),
    [anon_sym_norecurse] = ACTIONS(617),
    [anon_sym_willreturn] = ACTIONS(617),
    [anon_sym_nosync] = ACTIONS(617),
    [anon_sym_nounwind] = ACTIONS(617),
    [anon_sym_nocallback] = ACTIONS(617),
    [anon_sym_nosanitize_coverage] = ACTIONS(617),
    [anon_sym_null_pointer_is_valid] = ACTIONS(617),
    [anon_sym_optforfuzzing] = ACTIONS(617),
    [anon_sym_optnone] = ACTIONS(617),
    [anon_sym_optsize] = ACTIONS(617),
    [anon_sym_readnone] = ACTIONS(617),
    [anon_sym_readonly] = ACTIONS(617),
    [anon_sym_writeonly] = ACTIONS(617),
    [anon_sym_argmemonly] = ACTIONS(617),
    [anon_sym_returns_twice] = ACTIONS(617),
    [anon_sym_safestack] = ACTIONS(617),
    [anon_sym_sanitize_address] = ACTIONS(617),
    [anon_sym_sanitize_memory] = ACTIONS(617),
    [anon_sym_sanitize_thread] = ACTIONS(617),
    [anon_sym_sanitize_hwaddress] = ACTIONS(617),
    [anon_sym_sanitize_memtag] = ACTIONS(617),
    [anon_sym_speculative_load_hardening] = ACTIONS(617),
    [anon_sym_speculatable] = ACTIONS(617),
    [anon_sym_ssp] = ACTIONS(617),
    [anon_sym_sspstrong] = ACTIONS(617),
    [anon_sym_sspreq] = ACTIONS(617),
    [anon_sym_strictfp] = ACTIONS(617),
    [anon_sym_nocf_check] = ACTIONS(617),
    [anon_sym_shadowcallstack] = ACTIONS(617),
    [anon_sym_mustprogress] = ACTIONS(617),
    [anon_sym_vscale_range] = ACTIONS(617),
    [anon_sym_preallocated] = ACTIONS(617),
    [anon_sym_zeroext] = ACTIONS(617),
    [anon_sym_signext] = ACTIONS(617),
    [anon_sym_inreg] = ACTIONS(617),
    [anon_sym_byval] = ACTIONS(617),
    [anon_sym_byref] = ACTIONS(617),
    [anon_sym_inalloca] = ACTIONS(617),
    [anon_sym_sret] = ACTIONS(617),
    [anon_sym_elementtype] = ACTIONS(617),
    [anon_sym_noalias] = ACTIONS(617),
    [anon_sym_nocapture] = ACTIONS(617),
    [anon_sym_nest] = ACTIONS(617),
    [anon_sym_returned] = ACTIONS(617),
    [anon_sym_nonnull] = ACTIONS(617),
    [anon_sym_dereferenceable] = ACTIONS(617),
    [anon_sym_dereferenceable_or_null] = ACTIONS(617),
    [anon_sym_swiftself] = ACTIONS(617),
    [anon_sym_swiftasync] = ACTIONS(617),
    [anon_sym_swifterror] = ACTIONS(617),
    [anon_sym_immarg] = ACTIONS(617),
    [anon_sym_noundef] = ACTIONS(617),
    [anon_sym_uwtable] = ACTIONS(617),
    [anon_sym_memory] = ACTIONS(617),
    [anon_sym_unreachable] = ACTIONS(617),
    [anon_sym_ret] = ACTIONS(617),
    [anon_sym_br] = ACTIONS(617),
    [anon_sym_resume] = ACTIONS(617),
    [anon_sym_freeze] = ACTIONS(617),
    [anon_sym_indirectbr] = ACTIONS(617),
    [anon_sym_extractelement] = ACTIONS(617),
    [anon_sym_insertelement] = ACTIONS(617),
    [anon_sym_select] = ACTIONS(617),
    [anon_sym_shufflevector] = ACTIONS(617),
    [anon_sym_fneg] = ACTIONS(617),
    [anon_sym_switch] = ACTIONS(617),
    [anon_sym_invoke] = ACTIONS(617),
    [anon_sym_cleanupret] = ACTIONS(617),
    [anon_sym_catchret] = ACTIONS(617),
    [anon_sym_catchswitch] = ACTIONS(617),
    [anon_sym_catchpad] = ACTIONS(617),
    [anon_sym_cleanuppad] = ACTIONS(617),
    [anon_sym_callbr] = ACTIONS(617),
    [anon_sym_icmp] = ACTIONS(617),
    [anon_sym_fcmp] = ACTIONS(617),
    [anon_sym_va_arg] = ACTIONS(617),
    [anon_sym_phi] = ACTIONS(617),
    [anon_sym_landingpad] = ACTIONS(617),
    [anon_sym_tail] = ACTIONS(617),
    [anon_sym_musttail] = ACTIONS(617),
    [anon_sym_notail] = ACTIONS(617),
    [anon_sym_call] = ACTIONS(617),
    [anon_sym_alloca] = ACTIONS(617),
    [anon_sym_load] = ACTIONS(617),
    [anon_sym_store] = ACTIONS(617),
    [anon_sym_cmpxchg] = ACTIONS(617),
    [anon_sym_atomicrmw] = ACTIONS(617),
    [anon_sym_fence] = ACTIONS(617),
    [anon_sym_getelementptr] = ACTIONS(617),
    [anon_sym_extractvalue] = ACTIONS(617),
    [anon_sym_insertvalue] = ACTIONS(617),
    [anon_sym_catch] = ACTIONS(617),
    [anon_sym_filter] = ACTIONS(617),
    [anon_sym_mul] = ACTIONS(617),
    [anon_sym_urem] = ACTIONS(617),
    [anon_sym_srem] = ACTIONS(617),
    [anon_sym_shl] = ACTIONS(617),
    [anon_sym_udiv] = ACTIONS(617),
    [anon_sym_sdiv] = ACTIONS(617),
    [anon_sym_lshr] = ACTIONS(617),
    [anon_sym_ashr] = ACTIONS(617),
    [anon_sym_fmul] = ACTIONS(617),
    [anon_sym_fdiv] = ACTIONS(617),
    [anon_sym_frem] = ACTIONS(617),
    [anon_sym_xchg] = ACTIONS(617),
    [anon_sym_add] = ACTIONS(617),
    [anon_sym_sub] = ACTIONS(617),
    [anon_sym_and] = ACTIONS(617),
    [anon_sym_nand] = ACTIONS(617),
    [anon_sym_or] = ACTIONS(617),
    [anon_sym_xor] = ACTIONS(617),
    [anon_sym_max] = ACTIONS(617),
    [anon_sym_min] = ACTIONS(617),
    [anon_sym_umax] = ACTIONS(617),
    [anon_sym_umin] = ACTIONS(617),
    [anon_sym_fadd] = ACTIONS(617),
    [anon_sym_fsub] = ACTIONS(617),
    [anon_sym_bitcast] = ACTIONS(617),
    [anon_sym_trunc] = ACTIONS(617),
    [anon_sym_zext] = ACTIONS(617),
    [anon_sym_sext] = ACTIONS(617),
    [anon_sym_fptrunc] = ACTIONS(617),
    [anon_sym_fpext] = ACTIONS(617),
    [anon_sym_addrspacecast] = ACTIONS(617),
    [anon_sym_uitofp] = ACTIONS(617),
    [anon_sym_sitofp] = ACTIONS(617),
    [anon_sym_fptoui] = ACTIONS(617),
    [anon_sym_fptosi] = ACTIONS(617),
    [anon_sym_inttoptr] = ACTIONS(617),
    [anon_sym_ptrtoint] = ACTIONS(617),
    [anon_sym_unordered] = ACTIONS(617),
    [anon_sym_monotonic] = ACTIONS(617),
    [anon_sym_acquire] = ACTIONS(617),
    [anon_sym_release] = ACTIONS(617),
    [anon_sym_acq_rel] = ACTIONS(617),
    [anon_sym_seq_cst] = ACTIONS(617),
    [anon_sym_syncscope] = ACTIONS(617),
    [anon_sym_uselistorder] = ACTIONS(617),
  },
  [179] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(603),
    [sym_local_var] = ACTIONS(603),
    [sym_label] = ACTIONS(603),
    [sym_string] = ACTIONS(605),
    [anon_sym_RBRACE] = ACTIONS(603),
    [anon_sym_LBRACK] = ACTIONS(603),
    [anon_sym_COMMA] = ACTIONS(603),
    [anon_sym_align] = ACTIONS(605),
    [anon_sym_section] = ACTIONS(605),
    [anon_sym_partition] = ACTIONS(605),
    [anon_sym_comdat] = ACTIONS(605),
    [anon_sym_gc] = ACTIONS(605),
    [anon_sym_prefix] = ACTIONS(605),
    [anon_sym_prologue] = ACTIONS(605),
    [anon_sym_personality] = ACTIONS(605),
    [anon_sym_alignstack] = ACTIONS(605),
    [anon_sym_allocsize] = ACTIONS(605),
    [anon_sym_alwaysinline] = ACTIONS(605),
    [anon_sym_builtin] = ACTIONS(605),
    [anon_sym_cold] = ACTIONS(605),
    [anon_sym_convergent] = ACTIONS(605),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(605),
    [anon_sym_hot] = ACTIONS(605),
    [anon_sym_inaccessiblememonly] = ACTIONS(605),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(605),
    [anon_sym_inlinehint] = ACTIONS(605),
    [anon_sym_jumptable] = ACTIONS(605),
    [anon_sym_minsize] = ACTIONS(605),
    [anon_sym_naked] = ACTIONS(605),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(605),
    [anon_sym_nobuiltin] = ACTIONS(605),
    [anon_sym_noduplicate] = ACTIONS(605),
    [anon_sym_nofree] = ACTIONS(605),
    [anon_sym_noimplicitfloat] = ACTIONS(605),
    [anon_sym_noinline] = ACTIONS(605),
    [anon_sym_nomerge] = ACTIONS(605),
    [anon_sym_nonlazybind] = ACTIONS(605),
    [anon_sym_noprofile] = ACTIONS(605),
    [anon_sym_noredzone] = ACTIONS(605),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(605),
    [anon_sym_noreturn] = ACTIONS(605),
    [anon_sym_norecurse] = ACTIONS(605),
    [anon_sym_willreturn] = ACTIONS(605),
    [anon_sym_nosync] = ACTIONS(605),
    [anon_sym_nounwind] = ACTIONS(605),
    [anon_sym_nocallback] = ACTIONS(605),
    [anon_sym_nosanitize_coverage] = ACTIONS(605),
    [anon_sym_null_pointer_is_valid] = ACTIONS(605),
    [anon_sym_optforfuzzing] = ACTIONS(605),
    [anon_sym_optnone] = ACTIONS(605),
    [anon_sym_optsize] = ACTIONS(605),
    [anon_sym_readnone] = ACTIONS(605),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_writeonly] = ACTIONS(605),
    [anon_sym_argmemonly] = ACTIONS(605),
    [anon_sym_returns_twice] = ACTIONS(605),
    [anon_sym_safestack] = ACTIONS(605),
    [anon_sym_sanitize_address] = ACTIONS(605),
    [anon_sym_sanitize_memory] = ACTIONS(605),
    [anon_sym_sanitize_thread] = ACTIONS(605),
    [anon_sym_sanitize_hwaddress] = ACTIONS(605),
    [anon_sym_sanitize_memtag] = ACTIONS(605),
    [anon_sym_speculative_load_hardening] = ACTIONS(605),
    [anon_sym_speculatable] = ACTIONS(605),
    [anon_sym_ssp] = ACTIONS(605),
    [anon_sym_sspstrong] = ACTIONS(605),
    [anon_sym_sspreq] = ACTIONS(605),
    [anon_sym_strictfp] = ACTIONS(605),
    [anon_sym_nocf_check] = ACTIONS(605),
    [anon_sym_shadowcallstack] = ACTIONS(605),
    [anon_sym_mustprogress] = ACTIONS(605),
    [anon_sym_vscale_range] = ACTIONS(605),
    [anon_sym_preallocated] = ACTIONS(605),
    [anon_sym_zeroext] = ACTIONS(605),
    [anon_sym_signext] = ACTIONS(605),
    [anon_sym_inreg] = ACTIONS(605),
    [anon_sym_byval] = ACTIONS(605),
    [anon_sym_byref] = ACTIONS(605),
    [anon_sym_inalloca] = ACTIONS(605),
    [anon_sym_sret] = ACTIONS(605),
    [anon_sym_elementtype] = ACTIONS(605),
    [anon_sym_noalias] = ACTIONS(605),
    [anon_sym_nocapture] = ACTIONS(605),
    [anon_sym_nest] = ACTIONS(605),
    [anon_sym_returned] = ACTIONS(605),
    [anon_sym_nonnull] = ACTIONS(605),
    [anon_sym_dereferenceable] = ACTIONS(605),
    [anon_sym_dereferenceable_or_null] = ACTIONS(605),
    [anon_sym_swiftself] = ACTIONS(605),
    [anon_sym_swiftasync] = ACTIONS(605),
    [anon_sym_swifterror] = ACTIONS(605),
    [anon_sym_immarg] = ACTIONS(605),
    [anon_sym_noundef] = ACTIONS(605),
    [anon_sym_uwtable] = ACTIONS(605),
    [anon_sym_memory] = ACTIONS(605),
    [anon_sym_unreachable] = ACTIONS(605),
    [anon_sym_ret] = ACTIONS(605),
    [anon_sym_br] = ACTIONS(605),
    [anon_sym_resume] = ACTIONS(605),
    [anon_sym_freeze] = ACTIONS(605),
    [anon_sym_indirectbr] = ACTIONS(605),
    [anon_sym_extractelement] = ACTIONS(605),
    [anon_sym_insertelement] = ACTIONS(605),
    [anon_sym_select] = ACTIONS(605),
    [anon_sym_shufflevector] = ACTIONS(605),
    [anon_sym_fneg] = ACTIONS(605),
    [anon_sym_switch] = ACTIONS(605),
    [anon_sym_invoke] = ACTIONS(605),
    [anon_sym_cleanupret] = ACTIONS(605),
    [anon_sym_catchret] = ACTIONS(605),
    [anon_sym_catchswitch] = ACTIONS(605),
    [anon_sym_catchpad] = ACTIONS(605),
    [anon_sym_cleanuppad] = ACTIONS(605),
    [anon_sym_callbr] = ACTIONS(605),
    [anon_sym_icmp] = ACTIONS(605),
    [anon_sym_fcmp] = ACTIONS(605),
    [anon_sym_va_arg] = ACTIONS(605),
    [anon_sym_phi] = ACTIONS(605),
    [anon_sym_landingpad] = ACTIONS(605),
    [anon_sym_tail] = ACTIONS(605),
    [anon_sym_musttail] = ACTIONS(605),
    [anon_sym_notail] = ACTIONS(605),
    [anon_sym_call] = ACTIONS(605),
    [anon_sym_alloca] = ACTIONS(605),
    [anon_sym_load] = ACTIONS(605),
    [anon_sym_store] = ACTIONS(605),
    [anon_sym_cmpxchg] = ACTIONS(605),
    [anon_sym_atomicrmw] = ACTIONS(605),
    [anon_sym_fence] = ACTIONS(605),
    [anon_sym_getelementptr] = ACTIONS(605),
    [anon_sym_extractvalue] = ACTIONS(605),
    [anon_sym_insertvalue] = ACTIONS(605),
    [anon_sym_catch] = ACTIONS(605),
    [anon_sym_filter] = ACTIONS(605),
    [anon_sym_mul] = ACTIONS(605),
    [anon_sym_urem] = ACTIONS(605),
    [anon_sym_srem] = ACTIONS(605),
    [anon_sym_shl] = ACTIONS(605),
    [anon_sym_udiv] = ACTIONS(605),
    [anon_sym_sdiv] = ACTIONS(605),
    [anon_sym_lshr] = ACTIONS(605),
    [anon_sym_ashr] = ACTIONS(605),
    [anon_sym_fmul] = ACTIONS(605),
    [anon_sym_fdiv] = ACTIONS(605),
    [anon_sym_frem] = ACTIONS(605),
    [anon_sym_xchg] = ACTIONS(605),
    [anon_sym_add] = ACTIONS(605),
    [anon_sym_sub] = ACTIONS(605),
    [anon_sym_and] = ACTIONS(605),
    [anon_sym_nand] = ACTIONS(605),
    [anon_sym_or] = ACTIONS(605),
    [anon_sym_xor] = ACTIONS(605),
    [anon_sym_max] = ACTIONS(605),
    [anon_sym_min] = ACTIONS(605),
    [anon_sym_umax] = ACTIONS(605),
    [anon_sym_umin] = ACTIONS(605),
    [anon_sym_fadd] = ACTIONS(605),
    [anon_sym_fsub] = ACTIONS(605),
    [anon_sym_bitcast] = ACTIONS(605),
    [anon_sym_trunc] = ACTIONS(605),
    [anon_sym_zext] = ACTIONS(605),
    [anon_sym_sext] = ACTIONS(605),
    [anon_sym_fptrunc] = ACTIONS(605),
    [anon_sym_fpext] = ACTIONS(605),
    [anon_sym_addrspacecast] = ACTIONS(605),
    [anon_sym_uitofp] = ACTIONS(605),
    [anon_sym_sitofp] = ACTIONS(605),
    [anon_sym_fptoui] = ACTIONS(605),
    [anon_sym_fptosi] = ACTIONS(605),
    [anon_sym_inttoptr] = ACTIONS(605),
    [anon_sym_ptrtoint] = ACTIONS(605),
    [anon_sym_unordered] = ACTIONS(605),
    [anon_sym_monotonic] = ACTIONS(605),
    [anon_sym_acquire] = ACTIONS(605),
    [anon_sym_release] = ACTIONS(605),
    [anon_sym_acq_rel] = ACTIONS(605),
    [anon_sym_seq_cst] = ACTIONS(605),
    [anon_sym_syncscope] = ACTIONS(605),
    [anon_sym_uselistorder] = ACTIONS(605),
  },
  [180] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(537),
    [sym_local_var] = ACTIONS(537),
    [sym_label] = ACTIONS(537),
    [sym_string] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(537),
    [anon_sym_align] = ACTIONS(539),
    [anon_sym_section] = ACTIONS(539),
    [anon_sym_partition] = ACTIONS(539),
    [anon_sym_comdat] = ACTIONS(539),
    [anon_sym_gc] = ACTIONS(539),
    [anon_sym_prefix] = ACTIONS(539),
    [anon_sym_prologue] = ACTIONS(539),
    [anon_sym_personality] = ACTIONS(539),
    [anon_sym_alignstack] = ACTIONS(539),
    [anon_sym_allocsize] = ACTIONS(539),
    [anon_sym_alwaysinline] = ACTIONS(539),
    [anon_sym_builtin] = ACTIONS(539),
    [anon_sym_cold] = ACTIONS(539),
    [anon_sym_convergent] = ACTIONS(539),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(539),
    [anon_sym_hot] = ACTIONS(539),
    [anon_sym_inaccessiblememonly] = ACTIONS(539),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(539),
    [anon_sym_inlinehint] = ACTIONS(539),
    [anon_sym_jumptable] = ACTIONS(539),
    [anon_sym_minsize] = ACTIONS(539),
    [anon_sym_naked] = ACTIONS(539),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(539),
    [anon_sym_nobuiltin] = ACTIONS(539),
    [anon_sym_noduplicate] = ACTIONS(539),
    [anon_sym_nofree] = ACTIONS(539),
    [anon_sym_noimplicitfloat] = ACTIONS(539),
    [anon_sym_noinline] = ACTIONS(539),
    [anon_sym_nomerge] = ACTIONS(539),
    [anon_sym_nonlazybind] = ACTIONS(539),
    [anon_sym_noprofile] = ACTIONS(539),
    [anon_sym_noredzone] = ACTIONS(539),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(539),
    [anon_sym_noreturn] = ACTIONS(539),
    [anon_sym_norecurse] = ACTIONS(539),
    [anon_sym_willreturn] = ACTIONS(539),
    [anon_sym_nosync] = ACTIONS(539),
    [anon_sym_nounwind] = ACTIONS(539),
    [anon_sym_nocallback] = ACTIONS(539),
    [anon_sym_nosanitize_coverage] = ACTIONS(539),
    [anon_sym_null_pointer_is_valid] = ACTIONS(539),
    [anon_sym_optforfuzzing] = ACTIONS(539),
    [anon_sym_optnone] = ACTIONS(539),
    [anon_sym_optsize] = ACTIONS(539),
    [anon_sym_readnone] = ACTIONS(539),
    [anon_sym_readonly] = ACTIONS(539),
    [anon_sym_writeonly] = ACTIONS(539),
    [anon_sym_argmemonly] = ACTIONS(539),
    [anon_sym_returns_twice] = ACTIONS(539),
    [anon_sym_safestack] = ACTIONS(539),
    [anon_sym_sanitize_address] = ACTIONS(539),
    [anon_sym_sanitize_memory] = ACTIONS(539),
    [anon_sym_sanitize_thread] = ACTIONS(539),
    [anon_sym_sanitize_hwaddress] = ACTIONS(539),
    [anon_sym_sanitize_memtag] = ACTIONS(539),
    [anon_sym_speculative_load_hardening] = ACTIONS(539),
    [anon_sym_speculatable] = ACTIONS(539),
    [anon_sym_ssp] = ACTIONS(539),
    [anon_sym_sspstrong] = ACTIONS(539),
    [anon_sym_sspreq] = ACTIONS(539),
    [anon_sym_strictfp] = ACTIONS(539),
    [anon_sym_nocf_check] = ACTIONS(539),
    [anon_sym_shadowcallstack] = ACTIONS(539),
    [anon_sym_mustprogress] = ACTIONS(539),
    [anon_sym_vscale_range] = ACTIONS(539),
    [anon_sym_preallocated] = ACTIONS(539),
    [anon_sym_zeroext] = ACTIONS(539),
    [anon_sym_signext] = ACTIONS(539),
    [anon_sym_inreg] = ACTIONS(539),
    [anon_sym_byval] = ACTIONS(539),
    [anon_sym_byref] = ACTIONS(539),
    [anon_sym_inalloca] = ACTIONS(539),
    [anon_sym_sret] = ACTIONS(539),
    [anon_sym_elementtype] = ACTIONS(539),
    [anon_sym_noalias] = ACTIONS(539),
    [anon_sym_nocapture] = ACTIONS(539),
    [anon_sym_nest] = ACTIONS(539),
    [anon_sym_returned] = ACTIONS(539),
    [anon_sym_nonnull] = ACTIONS(539),
    [anon_sym_dereferenceable] = ACTIONS(539),
    [anon_sym_dereferenceable_or_null] = ACTIONS(539),
    [anon_sym_swiftself] = ACTIONS(539),
    [anon_sym_swiftasync] = ACTIONS(539),
    [anon_sym_swifterror] = ACTIONS(539),
    [anon_sym_immarg] = ACTIONS(539),
    [anon_sym_noundef] = ACTIONS(539),
    [anon_sym_uwtable] = ACTIONS(539),
    [anon_sym_memory] = ACTIONS(539),
    [anon_sym_unreachable] = ACTIONS(539),
    [anon_sym_ret] = ACTIONS(539),
    [anon_sym_br] = ACTIONS(539),
    [anon_sym_resume] = ACTIONS(539),
    [anon_sym_freeze] = ACTIONS(539),
    [anon_sym_indirectbr] = ACTIONS(539),
    [anon_sym_extractelement] = ACTIONS(539),
    [anon_sym_insertelement] = ACTIONS(539),
    [anon_sym_select] = ACTIONS(539),
    [anon_sym_shufflevector] = ACTIONS(539),
    [anon_sym_fneg] = ACTIONS(539),
    [anon_sym_switch] = ACTIONS(539),
    [anon_sym_invoke] = ACTIONS(539),
    [anon_sym_cleanupret] = ACTIONS(539),
    [anon_sym_catchret] = ACTIONS(539),
    [anon_sym_catchswitch] = ACTIONS(539),
    [anon_sym_catchpad] = ACTIONS(539),
    [anon_sym_cleanuppad] = ACTIONS(539),
    [anon_sym_callbr] = ACTIONS(539),
    [anon_sym_icmp] = ACTIONS(539),
    [anon_sym_fcmp] = ACTIONS(539),
    [anon_sym_va_arg] = ACTIONS(539),
    [anon_sym_phi] = ACTIONS(539),
    [anon_sym_landingpad] = ACTIONS(539),
    [anon_sym_tail] = ACTIONS(539),
    [anon_sym_musttail] = ACTIONS(539),
    [anon_sym_notail] = ACTIONS(539),
    [anon_sym_call] = ACTIONS(539),
    [anon_sym_alloca] = ACTIONS(539),
    [anon_sym_load] = ACTIONS(539),
    [anon_sym_store] = ACTIONS(539),
    [anon_sym_cmpxchg] = ACTIONS(539),
    [anon_sym_atomicrmw] = ACTIONS(539),
    [anon_sym_fence] = ACTIONS(539),
    [anon_sym_getelementptr] = ACTIONS(539),
    [anon_sym_extractvalue] = ACTIONS(539),
    [anon_sym_insertvalue] = ACTIONS(539),
    [anon_sym_catch] = ACTIONS(539),
    [anon_sym_filter] = ACTIONS(539),
    [anon_sym_mul] = ACTIONS(539),
    [anon_sym_urem] = ACTIONS(539),
    [anon_sym_srem] = ACTIONS(539),
    [anon_sym_shl] = ACTIONS(539),
    [anon_sym_udiv] = ACTIONS(539),
    [anon_sym_sdiv] = ACTIONS(539),
    [anon_sym_lshr] = ACTIONS(539),
    [anon_sym_ashr] = ACTIONS(539),
    [anon_sym_fmul] = ACTIONS(539),
    [anon_sym_fdiv] = ACTIONS(539),
    [anon_sym_frem] = ACTIONS(539),
    [anon_sym_xchg] = ACTIONS(539),
    [anon_sym_add] = ACTIONS(539),
    [anon_sym_sub] = ACTIONS(539),
    [anon_sym_and] = ACTIONS(539),
    [anon_sym_nand] = ACTIONS(539),
    [anon_sym_or] = ACTIONS(539),
    [anon_sym_xor] = ACTIONS(539),
    [anon_sym_max] = ACTIONS(539),
    [anon_sym_min] = ACTIONS(539),
    [anon_sym_umax] = ACTIONS(539),
    [anon_sym_umin] = ACTIONS(539),
    [anon_sym_fadd] = ACTIONS(539),
    [anon_sym_fsub] = ACTIONS(539),
    [anon_sym_bitcast] = ACTIONS(539),
    [anon_sym_trunc] = ACTIONS(539),
    [anon_sym_zext] = ACTIONS(539),
    [anon_sym_sext] = ACTIONS(539),
    [anon_sym_fptrunc] = ACTIONS(539),
    [anon_sym_fpext] = ACTIONS(539),
    [anon_sym_addrspacecast] = ACTIONS(539),
    [anon_sym_uitofp] = ACTIONS(539),
    [anon_sym_sitofp] = ACTIONS(539),
    [anon_sym_fptoui] = ACTIONS(539),
    [anon_sym_fptosi] = ACTIONS(539),
    [anon_sym_inttoptr] = ACTIONS(539),
    [anon_sym_ptrtoint] = ACTIONS(539),
    [anon_sym_unordered] = ACTIONS(539),
    [anon_sym_monotonic] = ACTIONS(539),
    [anon_sym_acquire] = ACTIONS(539),
    [anon_sym_release] = ACTIONS(539),
    [anon_sym_acq_rel] = ACTIONS(539),
    [anon_sym_seq_cst] = ACTIONS(539),
    [anon_sym_syncscope] = ACTIONS(539),
    [anon_sym_uselistorder] = ACTIONS(539),
  },
  [181] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(579),
    [sym_local_var] = ACTIONS(579),
    [sym_label] = ACTIONS(579),
    [sym_string] = ACTIONS(581),
    [anon_sym_RBRACE] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(579),
    [anon_sym_COMMA] = ACTIONS(579),
    [anon_sym_align] = ACTIONS(581),
    [anon_sym_section] = ACTIONS(581),
    [anon_sym_partition] = ACTIONS(581),
    [anon_sym_comdat] = ACTIONS(581),
    [anon_sym_gc] = ACTIONS(581),
    [anon_sym_prefix] = ACTIONS(581),
    [anon_sym_prologue] = ACTIONS(581),
    [anon_sym_personality] = ACTIONS(581),
    [anon_sym_alignstack] = ACTIONS(581),
    [anon_sym_allocsize] = ACTIONS(581),
    [anon_sym_alwaysinline] = ACTIONS(581),
    [anon_sym_builtin] = ACTIONS(581),
    [anon_sym_cold] = ACTIONS(581),
    [anon_sym_convergent] = ACTIONS(581),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(581),
    [anon_sym_hot] = ACTIONS(581),
    [anon_sym_inaccessiblememonly] = ACTIONS(581),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(581),
    [anon_sym_inlinehint] = ACTIONS(581),
    [anon_sym_jumptable] = ACTIONS(581),
    [anon_sym_minsize] = ACTIONS(581),
    [anon_sym_naked] = ACTIONS(581),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(581),
    [anon_sym_nobuiltin] = ACTIONS(581),
    [anon_sym_noduplicate] = ACTIONS(581),
    [anon_sym_nofree] = ACTIONS(581),
    [anon_sym_noimplicitfloat] = ACTIONS(581),
    [anon_sym_noinline] = ACTIONS(581),
    [anon_sym_nomerge] = ACTIONS(581),
    [anon_sym_nonlazybind] = ACTIONS(581),
    [anon_sym_noprofile] = ACTIONS(581),
    [anon_sym_noredzone] = ACTIONS(581),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(581),
    [anon_sym_noreturn] = ACTIONS(581),
    [anon_sym_norecurse] = ACTIONS(581),
    [anon_sym_willreturn] = ACTIONS(581),
    [anon_sym_nosync] = ACTIONS(581),
    [anon_sym_nounwind] = ACTIONS(581),
    [anon_sym_nocallback] = ACTIONS(581),
    [anon_sym_nosanitize_coverage] = ACTIONS(581),
    [anon_sym_null_pointer_is_valid] = ACTIONS(581),
    [anon_sym_optforfuzzing] = ACTIONS(581),
    [anon_sym_optnone] = ACTIONS(581),
    [anon_sym_optsize] = ACTIONS(581),
    [anon_sym_readnone] = ACTIONS(581),
    [anon_sym_readonly] = ACTIONS(581),
    [anon_sym_writeonly] = ACTIONS(581),
    [anon_sym_argmemonly] = ACTIONS(581),
    [anon_sym_returns_twice] = ACTIONS(581),
    [anon_sym_safestack] = ACTIONS(581),
    [anon_sym_sanitize_address] = ACTIONS(581),
    [anon_sym_sanitize_memory] = ACTIONS(581),
    [anon_sym_sanitize_thread] = ACTIONS(581),
    [anon_sym_sanitize_hwaddress] = ACTIONS(581),
    [anon_sym_sanitize_memtag] = ACTIONS(581),
    [anon_sym_speculative_load_hardening] = ACTIONS(581),
    [anon_sym_speculatable] = ACTIONS(581),
    [anon_sym_ssp] = ACTIONS(581),
    [anon_sym_sspstrong] = ACTIONS(581),
    [anon_sym_sspreq] = ACTIONS(581),
    [anon_sym_strictfp] = ACTIONS(581),
    [anon_sym_nocf_check] = ACTIONS(581),
    [anon_sym_shadowcallstack] = ACTIONS(581),
    [anon_sym_mustprogress] = ACTIONS(581),
    [anon_sym_vscale_range] = ACTIONS(581),
    [anon_sym_preallocated] = ACTIONS(581),
    [anon_sym_zeroext] = ACTIONS(581),
    [anon_sym_signext] = ACTIONS(581),
    [anon_sym_inreg] = ACTIONS(581),
    [anon_sym_byval] = ACTIONS(581),
    [anon_sym_byref] = ACTIONS(581),
    [anon_sym_inalloca] = ACTIONS(581),
    [anon_sym_sret] = ACTIONS(581),
    [anon_sym_elementtype] = ACTIONS(581),
    [anon_sym_noalias] = ACTIONS(581),
    [anon_sym_nocapture] = ACTIONS(581),
    [anon_sym_nest] = ACTIONS(581),
    [anon_sym_returned] = ACTIONS(581),
    [anon_sym_nonnull] = ACTIONS(581),
    [anon_sym_dereferenceable] = ACTIONS(581),
    [anon_sym_dereferenceable_or_null] = ACTIONS(581),
    [anon_sym_swiftself] = ACTIONS(581),
    [anon_sym_swiftasync] = ACTIONS(581),
    [anon_sym_swifterror] = ACTIONS(581),
    [anon_sym_immarg] = ACTIONS(581),
    [anon_sym_noundef] = ACTIONS(581),
    [anon_sym_uwtable] = ACTIONS(581),
    [anon_sym_memory] = ACTIONS(581),
    [anon_sym_unreachable] = ACTIONS(581),
    [anon_sym_ret] = ACTIONS(581),
    [anon_sym_br] = ACTIONS(581),
    [anon_sym_resume] = ACTIONS(581),
    [anon_sym_freeze] = ACTIONS(581),
    [anon_sym_indirectbr] = ACTIONS(581),
    [anon_sym_extractelement] = ACTIONS(581),
    [anon_sym_insertelement] = ACTIONS(581),
    [anon_sym_select] = ACTIONS(581),
    [anon_sym_shufflevector] = ACTIONS(581),
    [anon_sym_fneg] = ACTIONS(581),
    [anon_sym_switch] = ACTIONS(581),
    [anon_sym_invoke] = ACTIONS(581),
    [anon_sym_cleanupret] = ACTIONS(581),
    [anon_sym_catchret] = ACTIONS(581),
    [anon_sym_catchswitch] = ACTIONS(581),
    [anon_sym_catchpad] = ACTIONS(581),
    [anon_sym_cleanuppad] = ACTIONS(581),
    [anon_sym_callbr] = ACTIONS(581),
    [anon_sym_icmp] = ACTIONS(581),
    [anon_sym_fcmp] = ACTIONS(581),
    [anon_sym_va_arg] = ACTIONS(581),
    [anon_sym_phi] = ACTIONS(581),
    [anon_sym_landingpad] = ACTIONS(581),
    [anon_sym_tail] = ACTIONS(581),
    [anon_sym_musttail] = ACTIONS(581),
    [anon_sym_notail] = ACTIONS(581),
    [anon_sym_call] = ACTIONS(581),
    [anon_sym_alloca] = ACTIONS(581),
    [anon_sym_load] = ACTIONS(581),
    [anon_sym_store] = ACTIONS(581),
    [anon_sym_cmpxchg] = ACTIONS(581),
    [anon_sym_atomicrmw] = ACTIONS(581),
    [anon_sym_fence] = ACTIONS(581),
    [anon_sym_getelementptr] = ACTIONS(581),
    [anon_sym_extractvalue] = ACTIONS(581),
    [anon_sym_insertvalue] = ACTIONS(581),
    [anon_sym_catch] = ACTIONS(581),
    [anon_sym_filter] = ACTIONS(581),
    [anon_sym_mul] = ACTIONS(581),
    [anon_sym_urem] = ACTIONS(581),
    [anon_sym_srem] = ACTIONS(581),
    [anon_sym_shl] = ACTIONS(581),
    [anon_sym_udiv] = ACTIONS(581),
    [anon_sym_sdiv] = ACTIONS(581),
    [anon_sym_lshr] = ACTIONS(581),
    [anon_sym_ashr] = ACTIONS(581),
    [anon_sym_fmul] = ACTIONS(581),
    [anon_sym_fdiv] = ACTIONS(581),
    [anon_sym_frem] = ACTIONS(581),
    [anon_sym_xchg] = ACTIONS(581),
    [anon_sym_add] = ACTIONS(581),
    [anon_sym_sub] = ACTIONS(581),
    [anon_sym_and] = ACTIONS(581),
    [anon_sym_nand] = ACTIONS(581),
    [anon_sym_or] = ACTIONS(581),
    [anon_sym_xor] = ACTIONS(581),
    [anon_sym_max] = ACTIONS(581),
    [anon_sym_min] = ACTIONS(581),
    [anon_sym_umax] = ACTIONS(581),
    [anon_sym_umin] = ACTIONS(581),
    [anon_sym_fadd] = ACTIONS(581),
    [anon_sym_fsub] = ACTIONS(581),
    [anon_sym_bitcast] = ACTIONS(581),
    [anon_sym_trunc] = ACTIONS(581),
    [anon_sym_zext] = ACTIONS(581),
    [anon_sym_sext] = ACTIONS(581),
    [anon_sym_fptrunc] = ACTIONS(581),
    [anon_sym_fpext] = ACTIONS(581),
    [anon_sym_addrspacecast] = ACTIONS(581),
    [anon_sym_uitofp] = ACTIONS(581),
    [anon_sym_sitofp] = ACTIONS(581),
    [anon_sym_fptoui] = ACTIONS(581),
    [anon_sym_fptosi] = ACTIONS(581),
    [anon_sym_inttoptr] = ACTIONS(581),
    [anon_sym_ptrtoint] = ACTIONS(581),
    [anon_sym_unordered] = ACTIONS(581),
    [anon_sym_monotonic] = ACTIONS(581),
    [anon_sym_acquire] = ACTIONS(581),
    [anon_sym_release] = ACTIONS(581),
    [anon_sym_acq_rel] = ACTIONS(581),
    [anon_sym_seq_cst] = ACTIONS(581),
    [anon_sym_syncscope] = ACTIONS(581),
    [anon_sym_uselistorder] = ACTIONS(581),
  },
  [182] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(667),
    [sym_local_var] = ACTIONS(667),
    [sym_label] = ACTIONS(667),
    [sym_string] = ACTIONS(669),
    [anon_sym_RBRACE] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_COMMA] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_section] = ACTIONS(669),
    [anon_sym_partition] = ACTIONS(669),
    [anon_sym_comdat] = ACTIONS(669),
    [anon_sym_gc] = ACTIONS(669),
    [anon_sym_prefix] = ACTIONS(669),
    [anon_sym_prologue] = ACTIONS(669),
    [anon_sym_personality] = ACTIONS(669),
    [anon_sym_alignstack] = ACTIONS(669),
    [anon_sym_allocsize] = ACTIONS(669),
    [anon_sym_alwaysinline] = ACTIONS(669),
    [anon_sym_builtin] = ACTIONS(669),
    [anon_sym_cold] = ACTIONS(669),
    [anon_sym_convergent] = ACTIONS(669),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(669),
    [anon_sym_hot] = ACTIONS(669),
    [anon_sym_inaccessiblememonly] = ACTIONS(669),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(669),
    [anon_sym_inlinehint] = ACTIONS(669),
    [anon_sym_jumptable] = ACTIONS(669),
    [anon_sym_minsize] = ACTIONS(669),
    [anon_sym_naked] = ACTIONS(669),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(669),
    [anon_sym_nobuiltin] = ACTIONS(669),
    [anon_sym_noduplicate] = ACTIONS(669),
    [anon_sym_nofree] = ACTIONS(669),
    [anon_sym_noimplicitfloat] = ACTIONS(669),
    [anon_sym_noinline] = ACTIONS(669),
    [anon_sym_nomerge] = ACTIONS(669),
    [anon_sym_nonlazybind] = ACTIONS(669),
    [anon_sym_noprofile] = ACTIONS(669),
    [anon_sym_noredzone] = ACTIONS(669),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(669),
    [anon_sym_noreturn] = ACTIONS(669),
    [anon_sym_norecurse] = ACTIONS(669),
    [anon_sym_willreturn] = ACTIONS(669),
    [anon_sym_nosync] = ACTIONS(669),
    [anon_sym_nounwind] = ACTIONS(669),
    [anon_sym_nocallback] = ACTIONS(669),
    [anon_sym_nosanitize_coverage] = ACTIONS(669),
    [anon_sym_null_pointer_is_valid] = ACTIONS(669),
    [anon_sym_optforfuzzing] = ACTIONS(669),
    [anon_sym_optnone] = ACTIONS(669),
    [anon_sym_optsize] = ACTIONS(669),
    [anon_sym_readnone] = ACTIONS(669),
    [anon_sym_readonly] = ACTIONS(669),
    [anon_sym_writeonly] = ACTIONS(669),
    [anon_sym_argmemonly] = ACTIONS(669),
    [anon_sym_returns_twice] = ACTIONS(669),
    [anon_sym_safestack] = ACTIONS(669),
    [anon_sym_sanitize_address] = ACTIONS(669),
    [anon_sym_sanitize_memory] = ACTIONS(669),
    [anon_sym_sanitize_thread] = ACTIONS(669),
    [anon_sym_sanitize_hwaddress] = ACTIONS(669),
    [anon_sym_sanitize_memtag] = ACTIONS(669),
    [anon_sym_speculative_load_hardening] = ACTIONS(669),
    [anon_sym_speculatable] = ACTIONS(669),
    [anon_sym_ssp] = ACTIONS(669),
    [anon_sym_sspstrong] = ACTIONS(669),
    [anon_sym_sspreq] = ACTIONS(669),
    [anon_sym_strictfp] = ACTIONS(669),
    [anon_sym_nocf_check] = ACTIONS(669),
    [anon_sym_shadowcallstack] = ACTIONS(669),
    [anon_sym_mustprogress] = ACTIONS(669),
    [anon_sym_vscale_range] = ACTIONS(669),
    [anon_sym_preallocated] = ACTIONS(669),
    [anon_sym_zeroext] = ACTIONS(669),
    [anon_sym_signext] = ACTIONS(669),
    [anon_sym_inreg] = ACTIONS(669),
    [anon_sym_byval] = ACTIONS(669),
    [anon_sym_byref] = ACTIONS(669),
    [anon_sym_inalloca] = ACTIONS(669),
    [anon_sym_sret] = ACTIONS(669),
    [anon_sym_elementtype] = ACTIONS(669),
    [anon_sym_noalias] = ACTIONS(669),
    [anon_sym_nocapture] = ACTIONS(669),
    [anon_sym_nest] = ACTIONS(669),
    [anon_sym_returned] = ACTIONS(669),
    [anon_sym_nonnull] = ACTIONS(669),
    [anon_sym_dereferenceable] = ACTIONS(669),
    [anon_sym_dereferenceable_or_null] = ACTIONS(669),
    [anon_sym_swiftself] = ACTIONS(669),
    [anon_sym_swiftasync] = ACTIONS(669),
    [anon_sym_swifterror] = ACTIONS(669),
    [anon_sym_immarg] = ACTIONS(669),
    [anon_sym_noundef] = ACTIONS(669),
    [anon_sym_uwtable] = ACTIONS(669),
    [anon_sym_memory] = ACTIONS(669),
    [anon_sym_unreachable] = ACTIONS(669),
    [anon_sym_ret] = ACTIONS(669),
    [anon_sym_br] = ACTIONS(669),
    [anon_sym_resume] = ACTIONS(669),
    [anon_sym_freeze] = ACTIONS(669),
    [anon_sym_indirectbr] = ACTIONS(669),
    [anon_sym_extractelement] = ACTIONS(669),
    [anon_sym_insertelement] = ACTIONS(669),
    [anon_sym_select] = ACTIONS(669),
    [anon_sym_shufflevector] = ACTIONS(669),
    [anon_sym_fneg] = ACTIONS(669),
    [anon_sym_switch] = ACTIONS(669),
    [anon_sym_invoke] = ACTIONS(669),
    [anon_sym_cleanupret] = ACTIONS(669),
    [anon_sym_catchret] = ACTIONS(669),
    [anon_sym_catchswitch] = ACTIONS(669),
    [anon_sym_catchpad] = ACTIONS(669),
    [anon_sym_cleanuppad] = ACTIONS(669),
    [anon_sym_callbr] = ACTIONS(669),
    [anon_sym_icmp] = ACTIONS(669),
    [anon_sym_fcmp] = ACTIONS(669),
    [anon_sym_va_arg] = ACTIONS(669),
    [anon_sym_phi] = ACTIONS(669),
    [anon_sym_landingpad] = ACTIONS(669),
    [anon_sym_tail] = ACTIONS(669),
    [anon_sym_musttail] = ACTIONS(669),
    [anon_sym_notail] = ACTIONS(669),
    [anon_sym_call] = ACTIONS(669),
    [anon_sym_alloca] = ACTIONS(669),
    [anon_sym_load] = ACTIONS(669),
    [anon_sym_store] = ACTIONS(669),
    [anon_sym_cmpxchg] = ACTIONS(669),
    [anon_sym_atomicrmw] = ACTIONS(669),
    [anon_sym_fence] = ACTIONS(669),
    [anon_sym_getelementptr] = ACTIONS(669),
    [anon_sym_extractvalue] = ACTIONS(669),
    [anon_sym_insertvalue] = ACTIONS(669),
    [anon_sym_catch] = ACTIONS(669),
    [anon_sym_filter] = ACTIONS(669),
    [anon_sym_mul] = ACTIONS(669),
    [anon_sym_urem] = ACTIONS(669),
    [anon_sym_srem] = ACTIONS(669),
    [anon_sym_shl] = ACTIONS(669),
    [anon_sym_udiv] = ACTIONS(669),
    [anon_sym_sdiv] = ACTIONS(669),
    [anon_sym_lshr] = ACTIONS(669),
    [anon_sym_ashr] = ACTIONS(669),
    [anon_sym_fmul] = ACTIONS(669),
    [anon_sym_fdiv] = ACTIONS(669),
    [anon_sym_frem] = ACTIONS(669),
    [anon_sym_xchg] = ACTIONS(669),
    [anon_sym_add] = ACTIONS(669),
    [anon_sym_sub] = ACTIONS(669),
    [anon_sym_and] = ACTIONS(669),
    [anon_sym_nand] = ACTIONS(669),
    [anon_sym_or] = ACTIONS(669),
    [anon_sym_xor] = ACTIONS(669),
    [anon_sym_max] = ACTIONS(669),
    [anon_sym_min] = ACTIONS(669),
    [anon_sym_umax] = ACTIONS(669),
    [anon_sym_umin] = ACTIONS(669),
    [anon_sym_fadd] = ACTIONS(669),
    [anon_sym_fsub] = ACTIONS(669),
    [anon_sym_bitcast] = ACTIONS(669),
    [anon_sym_trunc] = ACTIONS(669),
    [anon_sym_zext] = ACTIONS(669),
    [anon_sym_sext] = ACTIONS(669),
    [anon_sym_fptrunc] = ACTIONS(669),
    [anon_sym_fpext] = ACTIONS(669),
    [anon_sym_addrspacecast] = ACTIONS(669),
    [anon_sym_uitofp] = ACTIONS(669),
    [anon_sym_sitofp] = ACTIONS(669),
    [anon_sym_fptoui] = ACTIONS(669),
    [anon_sym_fptosi] = ACTIONS(669),
    [anon_sym_inttoptr] = ACTIONS(669),
    [anon_sym_ptrtoint] = ACTIONS(669),
    [anon_sym_unordered] = ACTIONS(669),
    [anon_sym_monotonic] = ACTIONS(669),
    [anon_sym_acquire] = ACTIONS(669),
    [anon_sym_release] = ACTIONS(669),
    [anon_sym_acq_rel] = ACTIONS(669),
    [anon_sym_seq_cst] = ACTIONS(669),
    [anon_sym_syncscope] = ACTIONS(669),
    [anon_sym_uselistorder] = ACTIONS(669),
  },
  [183] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(569),
    [sym_local_var] = ACTIONS(569),
    [sym_label] = ACTIONS(569),
    [sym_string] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_align] = ACTIONS(571),
    [anon_sym_section] = ACTIONS(571),
    [anon_sym_partition] = ACTIONS(571),
    [anon_sym_comdat] = ACTIONS(571),
    [anon_sym_gc] = ACTIONS(571),
    [anon_sym_prefix] = ACTIONS(571),
    [anon_sym_prologue] = ACTIONS(571),
    [anon_sym_personality] = ACTIONS(571),
    [anon_sym_alignstack] = ACTIONS(571),
    [anon_sym_allocsize] = ACTIONS(571),
    [anon_sym_alwaysinline] = ACTIONS(571),
    [anon_sym_builtin] = ACTIONS(571),
    [anon_sym_cold] = ACTIONS(571),
    [anon_sym_convergent] = ACTIONS(571),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(571),
    [anon_sym_hot] = ACTIONS(571),
    [anon_sym_inaccessiblememonly] = ACTIONS(571),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(571),
    [anon_sym_inlinehint] = ACTIONS(571),
    [anon_sym_jumptable] = ACTIONS(571),
    [anon_sym_minsize] = ACTIONS(571),
    [anon_sym_naked] = ACTIONS(571),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(571),
    [anon_sym_nobuiltin] = ACTIONS(571),
    [anon_sym_noduplicate] = ACTIONS(571),
    [anon_sym_nofree] = ACTIONS(571),
    [anon_sym_noimplicitfloat] = ACTIONS(571),
    [anon_sym_noinline] = ACTIONS(571),
    [anon_sym_nomerge] = ACTIONS(571),
    [anon_sym_nonlazybind] = ACTIONS(571),
    [anon_sym_noprofile] = ACTIONS(571),
    [anon_sym_noredzone] = ACTIONS(571),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(571),
    [anon_sym_noreturn] = ACTIONS(571),
    [anon_sym_norecurse] = ACTIONS(571),
    [anon_sym_willreturn] = ACTIONS(571),
    [anon_sym_nosync] = ACTIONS(571),
    [anon_sym_nounwind] = ACTIONS(571),
    [anon_sym_nocallback] = ACTIONS(571),
    [anon_sym_nosanitize_coverage] = ACTIONS(571),
    [anon_sym_null_pointer_is_valid] = ACTIONS(571),
    [anon_sym_optforfuzzing] = ACTIONS(571),
    [anon_sym_optnone] = ACTIONS(571),
    [anon_sym_optsize] = ACTIONS(571),
    [anon_sym_readnone] = ACTIONS(571),
    [anon_sym_readonly] = ACTIONS(571),
    [anon_sym_writeonly] = ACTIONS(571),
    [anon_sym_argmemonly] = ACTIONS(571),
    [anon_sym_returns_twice] = ACTIONS(571),
    [anon_sym_safestack] = ACTIONS(571),
    [anon_sym_sanitize_address] = ACTIONS(571),
    [anon_sym_sanitize_memory] = ACTIONS(571),
    [anon_sym_sanitize_thread] = ACTIONS(571),
    [anon_sym_sanitize_hwaddress] = ACTIONS(571),
    [anon_sym_sanitize_memtag] = ACTIONS(571),
    [anon_sym_speculative_load_hardening] = ACTIONS(571),
    [anon_sym_speculatable] = ACTIONS(571),
    [anon_sym_ssp] = ACTIONS(571),
    [anon_sym_sspstrong] = ACTIONS(571),
    [anon_sym_sspreq] = ACTIONS(571),
    [anon_sym_strictfp] = ACTIONS(571),
    [anon_sym_nocf_check] = ACTIONS(571),
    [anon_sym_shadowcallstack] = ACTIONS(571),
    [anon_sym_mustprogress] = ACTIONS(571),
    [anon_sym_vscale_range] = ACTIONS(571),
    [anon_sym_preallocated] = ACTIONS(571),
    [anon_sym_zeroext] = ACTIONS(571),
    [anon_sym_signext] = ACTIONS(571),
    [anon_sym_inreg] = ACTIONS(571),
    [anon_sym_byval] = ACTIONS(571),
    [anon_sym_byref] = ACTIONS(571),
    [anon_sym_inalloca] = ACTIONS(571),
    [anon_sym_sret] = ACTIONS(571),
    [anon_sym_elementtype] = ACTIONS(571),
    [anon_sym_noalias] = ACTIONS(571),
    [anon_sym_nocapture] = ACTIONS(571),
    [anon_sym_nest] = ACTIONS(571),
    [anon_sym_returned] = ACTIONS(571),
    [anon_sym_nonnull] = ACTIONS(571),
    [anon_sym_dereferenceable] = ACTIONS(571),
    [anon_sym_dereferenceable_or_null] = ACTIONS(571),
    [anon_sym_swiftself] = ACTIONS(571),
    [anon_sym_swiftasync] = ACTIONS(571),
    [anon_sym_swifterror] = ACTIONS(571),
    [anon_sym_immarg] = ACTIONS(571),
    [anon_sym_noundef] = ACTIONS(571),
    [anon_sym_uwtable] = ACTIONS(571),
    [anon_sym_memory] = ACTIONS(571),
    [anon_sym_unreachable] = ACTIONS(571),
    [anon_sym_ret] = ACTIONS(571),
    [anon_sym_br] = ACTIONS(571),
    [anon_sym_resume] = ACTIONS(571),
    [anon_sym_freeze] = ACTIONS(571),
    [anon_sym_indirectbr] = ACTIONS(571),
    [anon_sym_extractelement] = ACTIONS(571),
    [anon_sym_insertelement] = ACTIONS(571),
    [anon_sym_select] = ACTIONS(571),
    [anon_sym_shufflevector] = ACTIONS(571),
    [anon_sym_fneg] = ACTIONS(571),
    [anon_sym_switch] = ACTIONS(571),
    [anon_sym_invoke] = ACTIONS(571),
    [anon_sym_cleanupret] = ACTIONS(571),
    [anon_sym_catchret] = ACTIONS(571),
    [anon_sym_catchswitch] = ACTIONS(571),
    [anon_sym_catchpad] = ACTIONS(571),
    [anon_sym_cleanuppad] = ACTIONS(571),
    [anon_sym_callbr] = ACTIONS(571),
    [anon_sym_icmp] = ACTIONS(571),
    [anon_sym_fcmp] = ACTIONS(571),
    [anon_sym_va_arg] = ACTIONS(571),
    [anon_sym_phi] = ACTIONS(571),
    [anon_sym_landingpad] = ACTIONS(571),
    [anon_sym_tail] = ACTIONS(571),
    [anon_sym_musttail] = ACTIONS(571),
    [anon_sym_notail] = ACTIONS(571),
    [anon_sym_call] = ACTIONS(571),
    [anon_sym_alloca] = ACTIONS(571),
    [anon_sym_load] = ACTIONS(571),
    [anon_sym_store] = ACTIONS(571),
    [anon_sym_cmpxchg] = ACTIONS(571),
    [anon_sym_atomicrmw] = ACTIONS(571),
    [anon_sym_fence] = ACTIONS(571),
    [anon_sym_getelementptr] = ACTIONS(571),
    [anon_sym_extractvalue] = ACTIONS(571),
    [anon_sym_insertvalue] = ACTIONS(571),
    [anon_sym_catch] = ACTIONS(571),
    [anon_sym_filter] = ACTIONS(571),
    [anon_sym_mul] = ACTIONS(571),
    [anon_sym_urem] = ACTIONS(571),
    [anon_sym_srem] = ACTIONS(571),
    [anon_sym_shl] = ACTIONS(571),
    [anon_sym_udiv] = ACTIONS(571),
    [anon_sym_sdiv] = ACTIONS(571),
    [anon_sym_lshr] = ACTIONS(571),
    [anon_sym_ashr] = ACTIONS(571),
    [anon_sym_fmul] = ACTIONS(571),
    [anon_sym_fdiv] = ACTIONS(571),
    [anon_sym_frem] = ACTIONS(571),
    [anon_sym_xchg] = ACTIONS(571),
    [anon_sym_add] = ACTIONS(571),
    [anon_sym_sub] = ACTIONS(571),
    [anon_sym_and] = ACTIONS(571),
    [anon_sym_nand] = ACTIONS(571),
    [anon_sym_or] = ACTIONS(571),
    [anon_sym_xor] = ACTIONS(571),
    [anon_sym_max] = ACTIONS(571),
    [anon_sym_min] = ACTIONS(571),
    [anon_sym_umax] = ACTIONS(571),
    [anon_sym_umin] = ACTIONS(571),
    [anon_sym_fadd] = ACTIONS(571),
    [anon_sym_fsub] = ACTIONS(571),
    [anon_sym_bitcast] = ACTIONS(571),
    [anon_sym_trunc] = ACTIONS(571),
    [anon_sym_zext] = ACTIONS(571),
    [anon_sym_sext] = ACTIONS(571),
    [anon_sym_fptrunc] = ACTIONS(571),
    [anon_sym_fpext] = ACTIONS(571),
    [anon_sym_addrspacecast] = ACTIONS(571),
    [anon_sym_uitofp] = ACTIONS(571),
    [anon_sym_sitofp] = ACTIONS(571),
    [anon_sym_fptoui] = ACTIONS(571),
    [anon_sym_fptosi] = ACTIONS(571),
    [anon_sym_inttoptr] = ACTIONS(571),
    [anon_sym_ptrtoint] = ACTIONS(571),
    [anon_sym_unordered] = ACTIONS(571),
    [anon_sym_monotonic] = ACTIONS(571),
    [anon_sym_acquire] = ACTIONS(571),
    [anon_sym_release] = ACTIONS(571),
    [anon_sym_acq_rel] = ACTIONS(571),
    [anon_sym_seq_cst] = ACTIONS(571),
    [anon_sym_syncscope] = ACTIONS(571),
    [anon_sym_uselistorder] = ACTIONS(571),
  },
  [184] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(619),
    [sym_local_var] = ACTIONS(619),
    [sym_label] = ACTIONS(619),
    [sym_string] = ACTIONS(621),
    [anon_sym_RBRACE] = ACTIONS(619),
    [anon_sym_LBRACK] = ACTIONS(619),
    [anon_sym_COMMA] = ACTIONS(619),
    [anon_sym_align] = ACTIONS(621),
    [anon_sym_section] = ACTIONS(621),
    [anon_sym_partition] = ACTIONS(621),
    [anon_sym_comdat] = ACTIONS(621),
    [anon_sym_gc] = ACTIONS(621),
    [anon_sym_prefix] = ACTIONS(621),
    [anon_sym_prologue] = ACTIONS(621),
    [anon_sym_personality] = ACTIONS(621),
    [anon_sym_alignstack] = ACTIONS(621),
    [anon_sym_allocsize] = ACTIONS(621),
    [anon_sym_alwaysinline] = ACTIONS(621),
    [anon_sym_builtin] = ACTIONS(621),
    [anon_sym_cold] = ACTIONS(621),
    [anon_sym_convergent] = ACTIONS(621),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(621),
    [anon_sym_hot] = ACTIONS(621),
    [anon_sym_inaccessiblememonly] = ACTIONS(621),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(621),
    [anon_sym_inlinehint] = ACTIONS(621),
    [anon_sym_jumptable] = ACTIONS(621),
    [anon_sym_minsize] = ACTIONS(621),
    [anon_sym_naked] = ACTIONS(621),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(621),
    [anon_sym_nobuiltin] = ACTIONS(621),
    [anon_sym_noduplicate] = ACTIONS(621),
    [anon_sym_nofree] = ACTIONS(621),
    [anon_sym_noimplicitfloat] = ACTIONS(621),
    [anon_sym_noinline] = ACTIONS(621),
    [anon_sym_nomerge] = ACTIONS(621),
    [anon_sym_nonlazybind] = ACTIONS(621),
    [anon_sym_noprofile] = ACTIONS(621),
    [anon_sym_noredzone] = ACTIONS(621),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(621),
    [anon_sym_noreturn] = ACTIONS(621),
    [anon_sym_norecurse] = ACTIONS(621),
    [anon_sym_willreturn] = ACTIONS(621),
    [anon_sym_nosync] = ACTIONS(621),
    [anon_sym_nounwind] = ACTIONS(621),
    [anon_sym_nocallback] = ACTIONS(621),
    [anon_sym_nosanitize_coverage] = ACTIONS(621),
    [anon_sym_null_pointer_is_valid] = ACTIONS(621),
    [anon_sym_optforfuzzing] = ACTIONS(621),
    [anon_sym_optnone] = ACTIONS(621),
    [anon_sym_optsize] = ACTIONS(621),
    [anon_sym_readnone] = ACTIONS(621),
    [anon_sym_readonly] = ACTIONS(621),
    [anon_sym_writeonly] = ACTIONS(621),
    [anon_sym_argmemonly] = ACTIONS(621),
    [anon_sym_returns_twice] = ACTIONS(621),
    [anon_sym_safestack] = ACTIONS(621),
    [anon_sym_sanitize_address] = ACTIONS(621),
    [anon_sym_sanitize_memory] = ACTIONS(621),
    [anon_sym_sanitize_thread] = ACTIONS(621),
    [anon_sym_sanitize_hwaddress] = ACTIONS(621),
    [anon_sym_sanitize_memtag] = ACTIONS(621),
    [anon_sym_speculative_load_hardening] = ACTIONS(621),
    [anon_sym_speculatable] = ACTIONS(621),
    [anon_sym_ssp] = ACTIONS(621),
    [anon_sym_sspstrong] = ACTIONS(621),
    [anon_sym_sspreq] = ACTIONS(621),
    [anon_sym_strictfp] = ACTIONS(621),
    [anon_sym_nocf_check] = ACTIONS(621),
    [anon_sym_shadowcallstack] = ACTIONS(621),
    [anon_sym_mustprogress] = ACTIONS(621),
    [anon_sym_vscale_range] = ACTIONS(621),
    [anon_sym_preallocated] = ACTIONS(621),
    [anon_sym_zeroext] = ACTIONS(621),
    [anon_sym_signext] = ACTIONS(621),
    [anon_sym_inreg] = ACTIONS(621),
    [anon_sym_byval] = ACTIONS(621),
    [anon_sym_byref] = ACTIONS(621),
    [anon_sym_inalloca] = ACTIONS(621),
    [anon_sym_sret] = ACTIONS(621),
    [anon_sym_elementtype] = ACTIONS(621),
    [anon_sym_noalias] = ACTIONS(621),
    [anon_sym_nocapture] = ACTIONS(621),
    [anon_sym_nest] = ACTIONS(621),
    [anon_sym_returned] = ACTIONS(621),
    [anon_sym_nonnull] = ACTIONS(621),
    [anon_sym_dereferenceable] = ACTIONS(621),
    [anon_sym_dereferenceable_or_null] = ACTIONS(621),
    [anon_sym_swiftself] = ACTIONS(621),
    [anon_sym_swiftasync] = ACTIONS(621),
    [anon_sym_swifterror] = ACTIONS(621),
    [anon_sym_immarg] = ACTIONS(621),
    [anon_sym_noundef] = ACTIONS(621),
    [anon_sym_uwtable] = ACTIONS(621),
    [anon_sym_memory] = ACTIONS(621),
    [anon_sym_unreachable] = ACTIONS(621),
    [anon_sym_ret] = ACTIONS(621),
    [anon_sym_br] = ACTIONS(621),
    [anon_sym_resume] = ACTIONS(621),
    [anon_sym_freeze] = ACTIONS(621),
    [anon_sym_indirectbr] = ACTIONS(621),
    [anon_sym_extractelement] = ACTIONS(621),
    [anon_sym_insertelement] = ACTIONS(621),
    [anon_sym_select] = ACTIONS(621),
    [anon_sym_shufflevector] = ACTIONS(621),
    [anon_sym_fneg] = ACTIONS(621),
    [anon_sym_switch] = ACTIONS(621),
    [anon_sym_invoke] = ACTIONS(621),
    [anon_sym_cleanupret] = ACTIONS(621),
    [anon_sym_catchret] = ACTIONS(621),
    [anon_sym_catchswitch] = ACTIONS(621),
    [anon_sym_catchpad] = ACTIONS(621),
    [anon_sym_cleanuppad] = ACTIONS(621),
    [anon_sym_callbr] = ACTIONS(621),
    [anon_sym_icmp] = ACTIONS(621),
    [anon_sym_fcmp] = ACTIONS(621),
    [anon_sym_va_arg] = ACTIONS(621),
    [anon_sym_phi] = ACTIONS(621),
    [anon_sym_landingpad] = ACTIONS(621),
    [anon_sym_tail] = ACTIONS(621),
    [anon_sym_musttail] = ACTIONS(621),
    [anon_sym_notail] = ACTIONS(621),
    [anon_sym_call] = ACTIONS(621),
    [anon_sym_alloca] = ACTIONS(621),
    [anon_sym_load] = ACTIONS(621),
    [anon_sym_store] = ACTIONS(621),
    [anon_sym_cmpxchg] = ACTIONS(621),
    [anon_sym_atomicrmw] = ACTIONS(621),
    [anon_sym_fence] = ACTIONS(621),
    [anon_sym_getelementptr] = ACTIONS(621),
    [anon_sym_extractvalue] = ACTIONS(621),
    [anon_sym_insertvalue] = ACTIONS(621),
    [anon_sym_catch] = ACTIONS(621),
    [anon_sym_filter] = ACTIONS(621),
    [anon_sym_mul] = ACTIONS(621),
    [anon_sym_urem] = ACTIONS(621),
    [anon_sym_srem] = ACTIONS(621),
    [anon_sym_shl] = ACTIONS(621),
    [anon_sym_udiv] = ACTIONS(621),
    [anon_sym_sdiv] = ACTIONS(621),
    [anon_sym_lshr] = ACTIONS(621),
    [anon_sym_ashr] = ACTIONS(621),
    [anon_sym_fmul] = ACTIONS(621),
    [anon_sym_fdiv] = ACTIONS(621),
    [anon_sym_frem] = ACTIONS(621),
    [anon_sym_xchg] = ACTIONS(621),
    [anon_sym_add] = ACTIONS(621),
    [anon_sym_sub] = ACTIONS(621),
    [anon_sym_and] = ACTIONS(621),
    [anon_sym_nand] = ACTIONS(621),
    [anon_sym_or] = ACTIONS(621),
    [anon_sym_xor] = ACTIONS(621),
    [anon_sym_max] = ACTIONS(621),
    [anon_sym_min] = ACTIONS(621),
    [anon_sym_umax] = ACTIONS(621),
    [anon_sym_umin] = ACTIONS(621),
    [anon_sym_fadd] = ACTIONS(621),
    [anon_sym_fsub] = ACTIONS(621),
    [anon_sym_bitcast] = ACTIONS(621),
    [anon_sym_trunc] = ACTIONS(621),
    [anon_sym_zext] = ACTIONS(621),
    [anon_sym_sext] = ACTIONS(621),
    [anon_sym_fptrunc] = ACTIONS(621),
    [anon_sym_fpext] = ACTIONS(621),
    [anon_sym_addrspacecast] = ACTIONS(621),
    [anon_sym_uitofp] = ACTIONS(621),
    [anon_sym_sitofp] = ACTIONS(621),
    [anon_sym_fptoui] = ACTIONS(621),
    [anon_sym_fptosi] = ACTIONS(621),
    [anon_sym_inttoptr] = ACTIONS(621),
    [anon_sym_ptrtoint] = ACTIONS(621),
    [anon_sym_unordered] = ACTIONS(621),
    [anon_sym_monotonic] = ACTIONS(621),
    [anon_sym_acquire] = ACTIONS(621),
    [anon_sym_release] = ACTIONS(621),
    [anon_sym_acq_rel] = ACTIONS(621),
    [anon_sym_seq_cst] = ACTIONS(621),
    [anon_sym_syncscope] = ACTIONS(621),
    [anon_sym_uselistorder] = ACTIONS(621),
  },
  [185] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(533),
    [sym_local_var] = ACTIONS(533),
    [sym_label] = ACTIONS(533),
    [sym_string] = ACTIONS(535),
    [anon_sym_RBRACE] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(533),
    [anon_sym_COMMA] = ACTIONS(533),
    [anon_sym_align] = ACTIONS(535),
    [anon_sym_section] = ACTIONS(535),
    [anon_sym_partition] = ACTIONS(535),
    [anon_sym_comdat] = ACTIONS(535),
    [anon_sym_gc] = ACTIONS(535),
    [anon_sym_prefix] = ACTIONS(535),
    [anon_sym_prologue] = ACTIONS(535),
    [anon_sym_personality] = ACTIONS(535),
    [anon_sym_alignstack] = ACTIONS(535),
    [anon_sym_allocsize] = ACTIONS(535),
    [anon_sym_alwaysinline] = ACTIONS(535),
    [anon_sym_builtin] = ACTIONS(535),
    [anon_sym_cold] = ACTIONS(535),
    [anon_sym_convergent] = ACTIONS(535),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(535),
    [anon_sym_hot] = ACTIONS(535),
    [anon_sym_inaccessiblememonly] = ACTIONS(535),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(535),
    [anon_sym_inlinehint] = ACTIONS(535),
    [anon_sym_jumptable] = ACTIONS(535),
    [anon_sym_minsize] = ACTIONS(535),
    [anon_sym_naked] = ACTIONS(535),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(535),
    [anon_sym_nobuiltin] = ACTIONS(535),
    [anon_sym_noduplicate] = ACTIONS(535),
    [anon_sym_nofree] = ACTIONS(535),
    [anon_sym_noimplicitfloat] = ACTIONS(535),
    [anon_sym_noinline] = ACTIONS(535),
    [anon_sym_nomerge] = ACTIONS(535),
    [anon_sym_nonlazybind] = ACTIONS(535),
    [anon_sym_noprofile] = ACTIONS(535),
    [anon_sym_noredzone] = ACTIONS(535),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(535),
    [anon_sym_noreturn] = ACTIONS(535),
    [anon_sym_norecurse] = ACTIONS(535),
    [anon_sym_willreturn] = ACTIONS(535),
    [anon_sym_nosync] = ACTIONS(535),
    [anon_sym_nounwind] = ACTIONS(535),
    [anon_sym_nocallback] = ACTIONS(535),
    [anon_sym_nosanitize_coverage] = ACTIONS(535),
    [anon_sym_null_pointer_is_valid] = ACTIONS(535),
    [anon_sym_optforfuzzing] = ACTIONS(535),
    [anon_sym_optnone] = ACTIONS(535),
    [anon_sym_optsize] = ACTIONS(535),
    [anon_sym_readnone] = ACTIONS(535),
    [anon_sym_readonly] = ACTIONS(535),
    [anon_sym_writeonly] = ACTIONS(535),
    [anon_sym_argmemonly] = ACTIONS(535),
    [anon_sym_returns_twice] = ACTIONS(535),
    [anon_sym_safestack] = ACTIONS(535),
    [anon_sym_sanitize_address] = ACTIONS(535),
    [anon_sym_sanitize_memory] = ACTIONS(535),
    [anon_sym_sanitize_thread] = ACTIONS(535),
    [anon_sym_sanitize_hwaddress] = ACTIONS(535),
    [anon_sym_sanitize_memtag] = ACTIONS(535),
    [anon_sym_speculative_load_hardening] = ACTIONS(535),
    [anon_sym_speculatable] = ACTIONS(535),
    [anon_sym_ssp] = ACTIONS(535),
    [anon_sym_sspstrong] = ACTIONS(535),
    [anon_sym_sspreq] = ACTIONS(535),
    [anon_sym_strictfp] = ACTIONS(535),
    [anon_sym_nocf_check] = ACTIONS(535),
    [anon_sym_shadowcallstack] = ACTIONS(535),
    [anon_sym_mustprogress] = ACTIONS(535),
    [anon_sym_vscale_range] = ACTIONS(535),
    [anon_sym_preallocated] = ACTIONS(535),
    [anon_sym_zeroext] = ACTIONS(535),
    [anon_sym_signext] = ACTIONS(535),
    [anon_sym_inreg] = ACTIONS(535),
    [anon_sym_byval] = ACTIONS(535),
    [anon_sym_byref] = ACTIONS(535),
    [anon_sym_inalloca] = ACTIONS(535),
    [anon_sym_sret] = ACTIONS(535),
    [anon_sym_elementtype] = ACTIONS(535),
    [anon_sym_noalias] = ACTIONS(535),
    [anon_sym_nocapture] = ACTIONS(535),
    [anon_sym_nest] = ACTIONS(535),
    [anon_sym_returned] = ACTIONS(535),
    [anon_sym_nonnull] = ACTIONS(535),
    [anon_sym_dereferenceable] = ACTIONS(535),
    [anon_sym_dereferenceable_or_null] = ACTIONS(535),
    [anon_sym_swiftself] = ACTIONS(535),
    [anon_sym_swiftasync] = ACTIONS(535),
    [anon_sym_swifterror] = ACTIONS(535),
    [anon_sym_immarg] = ACTIONS(535),
    [anon_sym_noundef] = ACTIONS(535),
    [anon_sym_uwtable] = ACTIONS(535),
    [anon_sym_memory] = ACTIONS(535),
    [anon_sym_unreachable] = ACTIONS(535),
    [anon_sym_ret] = ACTIONS(535),
    [anon_sym_br] = ACTIONS(535),
    [anon_sym_resume] = ACTIONS(535),
    [anon_sym_freeze] = ACTIONS(535),
    [anon_sym_indirectbr] = ACTIONS(535),
    [anon_sym_extractelement] = ACTIONS(535),
    [anon_sym_insertelement] = ACTIONS(535),
    [anon_sym_select] = ACTIONS(535),
    [anon_sym_shufflevector] = ACTIONS(535),
    [anon_sym_fneg] = ACTIONS(535),
    [anon_sym_switch] = ACTIONS(535),
    [anon_sym_invoke] = ACTIONS(535),
    [anon_sym_cleanupret] = ACTIONS(535),
    [anon_sym_catchret] = ACTIONS(535),
    [anon_sym_catchswitch] = ACTIONS(535),
    [anon_sym_catchpad] = ACTIONS(535),
    [anon_sym_cleanuppad] = ACTIONS(535),
    [anon_sym_callbr] = ACTIONS(535),
    [anon_sym_icmp] = ACTIONS(535),
    [anon_sym_fcmp] = ACTIONS(535),
    [anon_sym_va_arg] = ACTIONS(535),
    [anon_sym_phi] = ACTIONS(535),
    [anon_sym_landingpad] = ACTIONS(535),
    [anon_sym_tail] = ACTIONS(535),
    [anon_sym_musttail] = ACTIONS(535),
    [anon_sym_notail] = ACTIONS(535),
    [anon_sym_call] = ACTIONS(535),
    [anon_sym_alloca] = ACTIONS(535),
    [anon_sym_load] = ACTIONS(535),
    [anon_sym_store] = ACTIONS(535),
    [anon_sym_cmpxchg] = ACTIONS(535),
    [anon_sym_atomicrmw] = ACTIONS(535),
    [anon_sym_fence] = ACTIONS(535),
    [anon_sym_getelementptr] = ACTIONS(535),
    [anon_sym_extractvalue] = ACTIONS(535),
    [anon_sym_insertvalue] = ACTIONS(535),
    [anon_sym_catch] = ACTIONS(535),
    [anon_sym_filter] = ACTIONS(535),
    [anon_sym_mul] = ACTIONS(535),
    [anon_sym_urem] = ACTIONS(535),
    [anon_sym_srem] = ACTIONS(535),
    [anon_sym_shl] = ACTIONS(535),
    [anon_sym_udiv] = ACTIONS(535),
    [anon_sym_sdiv] = ACTIONS(535),
    [anon_sym_lshr] = ACTIONS(535),
    [anon_sym_ashr] = ACTIONS(535),
    [anon_sym_fmul] = ACTIONS(535),
    [anon_sym_fdiv] = ACTIONS(535),
    [anon_sym_frem] = ACTIONS(535),
    [anon_sym_xchg] = ACTIONS(535),
    [anon_sym_add] = ACTIONS(535),
    [anon_sym_sub] = ACTIONS(535),
    [anon_sym_and] = ACTIONS(535),
    [anon_sym_nand] = ACTIONS(535),
    [anon_sym_or] = ACTIONS(535),
    [anon_sym_xor] = ACTIONS(535),
    [anon_sym_max] = ACTIONS(535),
    [anon_sym_min] = ACTIONS(535),
    [anon_sym_umax] = ACTIONS(535),
    [anon_sym_umin] = ACTIONS(535),
    [anon_sym_fadd] = ACTIONS(535),
    [anon_sym_fsub] = ACTIONS(535),
    [anon_sym_bitcast] = ACTIONS(535),
    [anon_sym_trunc] = ACTIONS(535),
    [anon_sym_zext] = ACTIONS(535),
    [anon_sym_sext] = ACTIONS(535),
    [anon_sym_fptrunc] = ACTIONS(535),
    [anon_sym_fpext] = ACTIONS(535),
    [anon_sym_addrspacecast] = ACTIONS(535),
    [anon_sym_uitofp] = ACTIONS(535),
    [anon_sym_sitofp] = ACTIONS(535),
    [anon_sym_fptoui] = ACTIONS(535),
    [anon_sym_fptosi] = ACTIONS(535),
    [anon_sym_inttoptr] = ACTIONS(535),
    [anon_sym_ptrtoint] = ACTIONS(535),
    [anon_sym_unordered] = ACTIONS(535),
    [anon_sym_monotonic] = ACTIONS(535),
    [anon_sym_acquire] = ACTIONS(535),
    [anon_sym_release] = ACTIONS(535),
    [anon_sym_acq_rel] = ACTIONS(535),
    [anon_sym_seq_cst] = ACTIONS(535),
    [anon_sym_syncscope] = ACTIONS(535),
    [anon_sym_uselistorder] = ACTIONS(535),
  },
  [186] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(631),
    [sym_local_var] = ACTIONS(631),
    [sym_label] = ACTIONS(631),
    [sym_string] = ACTIONS(633),
    [anon_sym_RBRACE] = ACTIONS(631),
    [anon_sym_LBRACK] = ACTIONS(631),
    [anon_sym_COMMA] = ACTIONS(631),
    [anon_sym_align] = ACTIONS(633),
    [anon_sym_section] = ACTIONS(633),
    [anon_sym_partition] = ACTIONS(633),
    [anon_sym_comdat] = ACTIONS(633),
    [anon_sym_gc] = ACTIONS(633),
    [anon_sym_prefix] = ACTIONS(633),
    [anon_sym_prologue] = ACTIONS(633),
    [anon_sym_personality] = ACTIONS(633),
    [anon_sym_alignstack] = ACTIONS(633),
    [anon_sym_allocsize] = ACTIONS(633),
    [anon_sym_alwaysinline] = ACTIONS(633),
    [anon_sym_builtin] = ACTIONS(633),
    [anon_sym_cold] = ACTIONS(633),
    [anon_sym_convergent] = ACTIONS(633),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(633),
    [anon_sym_hot] = ACTIONS(633),
    [anon_sym_inaccessiblememonly] = ACTIONS(633),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(633),
    [anon_sym_inlinehint] = ACTIONS(633),
    [anon_sym_jumptable] = ACTIONS(633),
    [anon_sym_minsize] = ACTIONS(633),
    [anon_sym_naked] = ACTIONS(633),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(633),
    [anon_sym_nobuiltin] = ACTIONS(633),
    [anon_sym_noduplicate] = ACTIONS(633),
    [anon_sym_nofree] = ACTIONS(633),
    [anon_sym_noimplicitfloat] = ACTIONS(633),
    [anon_sym_noinline] = ACTIONS(633),
    [anon_sym_nomerge] = ACTIONS(633),
    [anon_sym_nonlazybind] = ACTIONS(633),
    [anon_sym_noprofile] = ACTIONS(633),
    [anon_sym_noredzone] = ACTIONS(633),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(633),
    [anon_sym_noreturn] = ACTIONS(633),
    [anon_sym_norecurse] = ACTIONS(633),
    [anon_sym_willreturn] = ACTIONS(633),
    [anon_sym_nosync] = ACTIONS(633),
    [anon_sym_nounwind] = ACTIONS(633),
    [anon_sym_nocallback] = ACTIONS(633),
    [anon_sym_nosanitize_coverage] = ACTIONS(633),
    [anon_sym_null_pointer_is_valid] = ACTIONS(633),
    [anon_sym_optforfuzzing] = ACTIONS(633),
    [anon_sym_optnone] = ACTIONS(633),
    [anon_sym_optsize] = ACTIONS(633),
    [anon_sym_readnone] = ACTIONS(633),
    [anon_sym_readonly] = ACTIONS(633),
    [anon_sym_writeonly] = ACTIONS(633),
    [anon_sym_argmemonly] = ACTIONS(633),
    [anon_sym_returns_twice] = ACTIONS(633),
    [anon_sym_safestack] = ACTIONS(633),
    [anon_sym_sanitize_address] = ACTIONS(633),
    [anon_sym_sanitize_memory] = ACTIONS(633),
    [anon_sym_sanitize_thread] = ACTIONS(633),
    [anon_sym_sanitize_hwaddress] = ACTIONS(633),
    [anon_sym_sanitize_memtag] = ACTIONS(633),
    [anon_sym_speculative_load_hardening] = ACTIONS(633),
    [anon_sym_speculatable] = ACTIONS(633),
    [anon_sym_ssp] = ACTIONS(633),
    [anon_sym_sspstrong] = ACTIONS(633),
    [anon_sym_sspreq] = ACTIONS(633),
    [anon_sym_strictfp] = ACTIONS(633),
    [anon_sym_nocf_check] = ACTIONS(633),
    [anon_sym_shadowcallstack] = ACTIONS(633),
    [anon_sym_mustprogress] = ACTIONS(633),
    [anon_sym_vscale_range] = ACTIONS(633),
    [anon_sym_preallocated] = ACTIONS(633),
    [anon_sym_zeroext] = ACTIONS(633),
    [anon_sym_signext] = ACTIONS(633),
    [anon_sym_inreg] = ACTIONS(633),
    [anon_sym_byval] = ACTIONS(633),
    [anon_sym_byref] = ACTIONS(633),
    [anon_sym_inalloca] = ACTIONS(633),
    [anon_sym_sret] = ACTIONS(633),
    [anon_sym_elementtype] = ACTIONS(633),
    [anon_sym_noalias] = ACTIONS(633),
    [anon_sym_nocapture] = ACTIONS(633),
    [anon_sym_nest] = ACTIONS(633),
    [anon_sym_returned] = ACTIONS(633),
    [anon_sym_nonnull] = ACTIONS(633),
    [anon_sym_dereferenceable] = ACTIONS(633),
    [anon_sym_dereferenceable_or_null] = ACTIONS(633),
    [anon_sym_swiftself] = ACTIONS(633),
    [anon_sym_swiftasync] = ACTIONS(633),
    [anon_sym_swifterror] = ACTIONS(633),
    [anon_sym_immarg] = ACTIONS(633),
    [anon_sym_noundef] = ACTIONS(633),
    [anon_sym_uwtable] = ACTIONS(633),
    [anon_sym_memory] = ACTIONS(633),
    [anon_sym_unreachable] = ACTIONS(633),
    [anon_sym_ret] = ACTIONS(633),
    [anon_sym_br] = ACTIONS(633),
    [anon_sym_resume] = ACTIONS(633),
    [anon_sym_freeze] = ACTIONS(633),
    [anon_sym_indirectbr] = ACTIONS(633),
    [anon_sym_extractelement] = ACTIONS(633),
    [anon_sym_insertelement] = ACTIONS(633),
    [anon_sym_select] = ACTIONS(633),
    [anon_sym_shufflevector] = ACTIONS(633),
    [anon_sym_fneg] = ACTIONS(633),
    [anon_sym_switch] = ACTIONS(633),
    [anon_sym_invoke] = ACTIONS(633),
    [anon_sym_cleanupret] = ACTIONS(633),
    [anon_sym_catchret] = ACTIONS(633),
    [anon_sym_catchswitch] = ACTIONS(633),
    [anon_sym_catchpad] = ACTIONS(633),
    [anon_sym_cleanuppad] = ACTIONS(633),
    [anon_sym_callbr] = ACTIONS(633),
    [anon_sym_icmp] = ACTIONS(633),
    [anon_sym_fcmp] = ACTIONS(633),
    [anon_sym_va_arg] = ACTIONS(633),
    [anon_sym_phi] = ACTIONS(633),
    [anon_sym_landingpad] = ACTIONS(633),
    [anon_sym_tail] = ACTIONS(633),
    [anon_sym_musttail] = ACTIONS(633),
    [anon_sym_notail] = ACTIONS(633),
    [anon_sym_call] = ACTIONS(633),
    [anon_sym_alloca] = ACTIONS(633),
    [anon_sym_load] = ACTIONS(633),
    [anon_sym_store] = ACTIONS(633),
    [anon_sym_cmpxchg] = ACTIONS(633),
    [anon_sym_atomicrmw] = ACTIONS(633),
    [anon_sym_fence] = ACTIONS(633),
    [anon_sym_getelementptr] = ACTIONS(633),
    [anon_sym_extractvalue] = ACTIONS(633),
    [anon_sym_insertvalue] = ACTIONS(633),
    [anon_sym_catch] = ACTIONS(633),
    [anon_sym_filter] = ACTIONS(633),
    [anon_sym_mul] = ACTIONS(633),
    [anon_sym_urem] = ACTIONS(633),
    [anon_sym_srem] = ACTIONS(633),
    [anon_sym_shl] = ACTIONS(633),
    [anon_sym_udiv] = ACTIONS(633),
    [anon_sym_sdiv] = ACTIONS(633),
    [anon_sym_lshr] = ACTIONS(633),
    [anon_sym_ashr] = ACTIONS(633),
    [anon_sym_fmul] = ACTIONS(633),
    [anon_sym_fdiv] = ACTIONS(633),
    [anon_sym_frem] = ACTIONS(633),
    [anon_sym_xchg] = ACTIONS(633),
    [anon_sym_add] = ACTIONS(633),
    [anon_sym_sub] = ACTIONS(633),
    [anon_sym_and] = ACTIONS(633),
    [anon_sym_nand] = ACTIONS(633),
    [anon_sym_or] = ACTIONS(633),
    [anon_sym_xor] = ACTIONS(633),
    [anon_sym_max] = ACTIONS(633),
    [anon_sym_min] = ACTIONS(633),
    [anon_sym_umax] = ACTIONS(633),
    [anon_sym_umin] = ACTIONS(633),
    [anon_sym_fadd] = ACTIONS(633),
    [anon_sym_fsub] = ACTIONS(633),
    [anon_sym_bitcast] = ACTIONS(633),
    [anon_sym_trunc] = ACTIONS(633),
    [anon_sym_zext] = ACTIONS(633),
    [anon_sym_sext] = ACTIONS(633),
    [anon_sym_fptrunc] = ACTIONS(633),
    [anon_sym_fpext] = ACTIONS(633),
    [anon_sym_addrspacecast] = ACTIONS(633),
    [anon_sym_uitofp] = ACTIONS(633),
    [anon_sym_sitofp] = ACTIONS(633),
    [anon_sym_fptoui] = ACTIONS(633),
    [anon_sym_fptosi] = ACTIONS(633),
    [anon_sym_inttoptr] = ACTIONS(633),
    [anon_sym_ptrtoint] = ACTIONS(633),
    [anon_sym_unordered] = ACTIONS(633),
    [anon_sym_monotonic] = ACTIONS(633),
    [anon_sym_acquire] = ACTIONS(633),
    [anon_sym_release] = ACTIONS(633),
    [anon_sym_acq_rel] = ACTIONS(633),
    [anon_sym_seq_cst] = ACTIONS(633),
    [anon_sym_syncscope] = ACTIONS(633),
    [anon_sym_uselistorder] = ACTIONS(633),
  },
  [187] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(675),
    [sym_local_var] = ACTIONS(675),
    [sym_label] = ACTIONS(675),
    [sym_string] = ACTIONS(677),
    [anon_sym_RBRACE] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_COMMA] = ACTIONS(675),
    [anon_sym_align] = ACTIONS(677),
    [anon_sym_section] = ACTIONS(677),
    [anon_sym_partition] = ACTIONS(677),
    [anon_sym_comdat] = ACTIONS(677),
    [anon_sym_gc] = ACTIONS(677),
    [anon_sym_prefix] = ACTIONS(677),
    [anon_sym_prologue] = ACTIONS(677),
    [anon_sym_personality] = ACTIONS(677),
    [anon_sym_alignstack] = ACTIONS(677),
    [anon_sym_allocsize] = ACTIONS(677),
    [anon_sym_alwaysinline] = ACTIONS(677),
    [anon_sym_builtin] = ACTIONS(677),
    [anon_sym_cold] = ACTIONS(677),
    [anon_sym_convergent] = ACTIONS(677),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(677),
    [anon_sym_hot] = ACTIONS(677),
    [anon_sym_inaccessiblememonly] = ACTIONS(677),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(677),
    [anon_sym_inlinehint] = ACTIONS(677),
    [anon_sym_jumptable] = ACTIONS(677),
    [anon_sym_minsize] = ACTIONS(677),
    [anon_sym_naked] = ACTIONS(677),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(677),
    [anon_sym_nobuiltin] = ACTIONS(677),
    [anon_sym_noduplicate] = ACTIONS(677),
    [anon_sym_nofree] = ACTIONS(677),
    [anon_sym_noimplicitfloat] = ACTIONS(677),
    [anon_sym_noinline] = ACTIONS(677),
    [anon_sym_nomerge] = ACTIONS(677),
    [anon_sym_nonlazybind] = ACTIONS(677),
    [anon_sym_noprofile] = ACTIONS(677),
    [anon_sym_noredzone] = ACTIONS(677),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(677),
    [anon_sym_noreturn] = ACTIONS(677),
    [anon_sym_norecurse] = ACTIONS(677),
    [anon_sym_willreturn] = ACTIONS(677),
    [anon_sym_nosync] = ACTIONS(677),
    [anon_sym_nounwind] = ACTIONS(677),
    [anon_sym_nocallback] = ACTIONS(677),
    [anon_sym_nosanitize_coverage] = ACTIONS(677),
    [anon_sym_null_pointer_is_valid] = ACTIONS(677),
    [anon_sym_optforfuzzing] = ACTIONS(677),
    [anon_sym_optnone] = ACTIONS(677),
    [anon_sym_optsize] = ACTIONS(677),
    [anon_sym_readnone] = ACTIONS(677),
    [anon_sym_readonly] = ACTIONS(677),
    [anon_sym_writeonly] = ACTIONS(677),
    [anon_sym_argmemonly] = ACTIONS(677),
    [anon_sym_returns_twice] = ACTIONS(677),
    [anon_sym_safestack] = ACTIONS(677),
    [anon_sym_sanitize_address] = ACTIONS(677),
    [anon_sym_sanitize_memory] = ACTIONS(677),
    [anon_sym_sanitize_thread] = ACTIONS(677),
    [anon_sym_sanitize_hwaddress] = ACTIONS(677),
    [anon_sym_sanitize_memtag] = ACTIONS(677),
    [anon_sym_speculative_load_hardening] = ACTIONS(677),
    [anon_sym_speculatable] = ACTIONS(677),
    [anon_sym_ssp] = ACTIONS(677),
    [anon_sym_sspstrong] = ACTIONS(677),
    [anon_sym_sspreq] = ACTIONS(677),
    [anon_sym_strictfp] = ACTIONS(677),
    [anon_sym_nocf_check] = ACTIONS(677),
    [anon_sym_shadowcallstack] = ACTIONS(677),
    [anon_sym_mustprogress] = ACTIONS(677),
    [anon_sym_vscale_range] = ACTIONS(677),
    [anon_sym_preallocated] = ACTIONS(677),
    [anon_sym_zeroext] = ACTIONS(677),
    [anon_sym_signext] = ACTIONS(677),
    [anon_sym_inreg] = ACTIONS(677),
    [anon_sym_byval] = ACTIONS(677),
    [anon_sym_byref] = ACTIONS(677),
    [anon_sym_inalloca] = ACTIONS(677),
    [anon_sym_sret] = ACTIONS(677),
    [anon_sym_elementtype] = ACTIONS(677),
    [anon_sym_noalias] = ACTIONS(677),
    [anon_sym_nocapture] = ACTIONS(677),
    [anon_sym_nest] = ACTIONS(677),
    [anon_sym_returned] = ACTIONS(677),
    [anon_sym_nonnull] = ACTIONS(677),
    [anon_sym_dereferenceable] = ACTIONS(677),
    [anon_sym_dereferenceable_or_null] = ACTIONS(677),
    [anon_sym_swiftself] = ACTIONS(677),
    [anon_sym_swiftasync] = ACTIONS(677),
    [anon_sym_swifterror] = ACTIONS(677),
    [anon_sym_immarg] = ACTIONS(677),
    [anon_sym_noundef] = ACTIONS(677),
    [anon_sym_uwtable] = ACTIONS(677),
    [anon_sym_memory] = ACTIONS(677),
    [anon_sym_unreachable] = ACTIONS(677),
    [anon_sym_ret] = ACTIONS(677),
    [anon_sym_br] = ACTIONS(677),
    [anon_sym_resume] = ACTIONS(677),
    [anon_sym_freeze] = ACTIONS(677),
    [anon_sym_indirectbr] = ACTIONS(677),
    [anon_sym_extractelement] = ACTIONS(677),
    [anon_sym_insertelement] = ACTIONS(677),
    [anon_sym_select] = ACTIONS(677),
    [anon_sym_shufflevector] = ACTIONS(677),
    [anon_sym_fneg] = ACTIONS(677),
    [anon_sym_switch] = ACTIONS(677),
    [anon_sym_invoke] = ACTIONS(677),
    [anon_sym_cleanupret] = ACTIONS(677),
    [anon_sym_catchret] = ACTIONS(677),
    [anon_sym_catchswitch] = ACTIONS(677),
    [anon_sym_catchpad] = ACTIONS(677),
    [anon_sym_cleanuppad] = ACTIONS(677),
    [anon_sym_callbr] = ACTIONS(677),
    [anon_sym_icmp] = ACTIONS(677),
    [anon_sym_fcmp] = ACTIONS(677),
    [anon_sym_va_arg] = ACTIONS(677),
    [anon_sym_phi] = ACTIONS(677),
    [anon_sym_landingpad] = ACTIONS(677),
    [anon_sym_tail] = ACTIONS(677),
    [anon_sym_musttail] = ACTIONS(677),
    [anon_sym_notail] = ACTIONS(677),
    [anon_sym_call] = ACTIONS(677),
    [anon_sym_alloca] = ACTIONS(677),
    [anon_sym_load] = ACTIONS(677),
    [anon_sym_store] = ACTIONS(677),
    [anon_sym_cmpxchg] = ACTIONS(677),
    [anon_sym_atomicrmw] = ACTIONS(677),
    [anon_sym_fence] = ACTIONS(677),
    [anon_sym_getelementptr] = ACTIONS(677),
    [anon_sym_extractvalue] = ACTIONS(677),
    [anon_sym_insertvalue] = ACTIONS(677),
    [anon_sym_catch] = ACTIONS(677),
    [anon_sym_filter] = ACTIONS(677),
    [anon_sym_mul] = ACTIONS(677),
    [anon_sym_urem] = ACTIONS(677),
    [anon_sym_srem] = ACTIONS(677),
    [anon_sym_shl] = ACTIONS(677),
    [anon_sym_udiv] = ACTIONS(677),
    [anon_sym_sdiv] = ACTIONS(677),
    [anon_sym_lshr] = ACTIONS(677),
    [anon_sym_ashr] = ACTIONS(677),
    [anon_sym_fmul] = ACTIONS(677),
    [anon_sym_fdiv] = ACTIONS(677),
    [anon_sym_frem] = ACTIONS(677),
    [anon_sym_xchg] = ACTIONS(677),
    [anon_sym_add] = ACTIONS(677),
    [anon_sym_sub] = ACTIONS(677),
    [anon_sym_and] = ACTIONS(677),
    [anon_sym_nand] = ACTIONS(677),
    [anon_sym_or] = ACTIONS(677),
    [anon_sym_xor] = ACTIONS(677),
    [anon_sym_max] = ACTIONS(677),
    [anon_sym_min] = ACTIONS(677),
    [anon_sym_umax] = ACTIONS(677),
    [anon_sym_umin] = ACTIONS(677),
    [anon_sym_fadd] = ACTIONS(677),
    [anon_sym_fsub] = ACTIONS(677),
    [anon_sym_bitcast] = ACTIONS(677),
    [anon_sym_trunc] = ACTIONS(677),
    [anon_sym_zext] = ACTIONS(677),
    [anon_sym_sext] = ACTIONS(677),
    [anon_sym_fptrunc] = ACTIONS(677),
    [anon_sym_fpext] = ACTIONS(677),
    [anon_sym_addrspacecast] = ACTIONS(677),
    [anon_sym_uitofp] = ACTIONS(677),
    [anon_sym_sitofp] = ACTIONS(677),
    [anon_sym_fptoui] = ACTIONS(677),
    [anon_sym_fptosi] = ACTIONS(677),
    [anon_sym_inttoptr] = ACTIONS(677),
    [anon_sym_ptrtoint] = ACTIONS(677),
    [anon_sym_unordered] = ACTIONS(677),
    [anon_sym_monotonic] = ACTIONS(677),
    [anon_sym_acquire] = ACTIONS(677),
    [anon_sym_release] = ACTIONS(677),
    [anon_sym_acq_rel] = ACTIONS(677),
    [anon_sym_seq_cst] = ACTIONS(677),
    [anon_sym_syncscope] = ACTIONS(677),
    [anon_sym_uselistorder] = ACTIONS(677),
  },
  [188] = {
    [sym_metadata_name] = STATE(747),
    [sym_metadata_attachment] = STATE(236),
    [sym_function_header] = STATE(1137),
    [sym_linkage] = STATE(205),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_calling_conv] = STATE(399),
    [sym_unnamed_addr] = STATE(1060),
    [sym_type] = STATE(1659),
    [sym_type_keyword] = STATE(769),
    [sym_struct_type] = STATE(769),
    [sym_packed_struct_type] = STATE(769),
    [sym_array_type] = STATE(769),
    [sym_vector_type] = STATE(769),
    [sym_param_or_return_attrs] = STATE(394),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [aux_sym_declare_repeat1] = STATE(236),
    [aux_sym_function_header_repeat1] = STATE(205),
    [aux_sym_function_header_repeat2] = STATE(394),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(717),
    [aux_sym_metadata_ref_token1] = ACTIONS(719),
    [sym_string] = ACTIONS(721),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_ccc] = ACTIONS(721),
    [anon_sym_fastcc] = ACTIONS(721),
    [anon_sym_coldcc] = ACTIONS(721),
    [anon_sym_webkit_jscc] = ACTIONS(723),
    [anon_sym_anyregcc] = ACTIONS(721),
    [anon_sym_preserve_mostcc] = ACTIONS(721),
    [anon_sym_preserve_allcc] = ACTIONS(721),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(723),
    [anon_sym_tailcc] = ACTIONS(721),
    [anon_sym_swiftcc] = ACTIONS(723),
    [anon_sym_swifttailcc] = ACTIONS(723),
    [anon_sym_cfguard_checkcc] = ACTIONS(721),
    [aux_sym_calling_conv_token1] = ACTIONS(723),
    [aux_sym_calling_conv_token2] = ACTIONS(721),
    [aux_sym_calling_conv_token3] = ACTIONS(721),
    [aux_sym_calling_conv_token4] = ACTIONS(721),
    [aux_sym_calling_conv_token5] = ACTIONS(721),
    [aux_sym_calling_conv_token6] = ACTIONS(721),
    [aux_sym_calling_conv_token7] = ACTIONS(721),
    [aux_sym_calling_conv_token8] = ACTIONS(721),
    [aux_sym_calling_conv_token9] = ACTIONS(721),
    [aux_sym_calling_conv_token10] = ACTIONS(723),
    [anon_sym_ghccc] = ACTIONS(721),
    [aux_sym_calling_conv_token11] = ACTIONS(723),
    [aux_sym_calling_conv_token12] = ACTIONS(721),
    [aux_sym_calling_conv_token13] = ACTIONS(723),
    [aux_sym_calling_conv_token14] = ACTIONS(721),
    [anon_sym_cc] = ACTIONS(725),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(442),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(442),
    [anon_sym_x86_amx] = ACTIONS(442),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(458),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(458),
    [anon_sym_swiftasync] = ACTIONS(458),
    [anon_sym_swifterror] = ACTIONS(458),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [189] = {
    [sym_attribute] = STATE(192),
    [sym_attribute_name] = STATE(209),
    [sym_uwtable] = STATE(211),
    [sym_memory_attribute] = STATE(211),
    [sym_operand_bundles] = STATE(667),
    [sym_alignment] = STATE(214),
    [aux_sym_function_header_repeat3] = STATE(192),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(729),
    [sym_local_var] = ACTIONS(731),
    [sym_label] = ACTIONS(731),
    [sym_string] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_COMMA] = ACTIONS(731),
    [anon_sym_align] = ACTIONS(737),
    [anon_sym_section] = ACTIONS(739),
    [anon_sym_partition] = ACTIONS(739),
    [anon_sym_comdat] = ACTIONS(741),
    [anon_sym_gc] = ACTIONS(739),
    [anon_sym_prefix] = ACTIONS(743),
    [anon_sym_prologue] = ACTIONS(743),
    [anon_sym_personality] = ACTIONS(743),
    [anon_sym_alignstack] = ACTIONS(745),
    [anon_sym_allocsize] = ACTIONS(745),
    [anon_sym_alwaysinline] = ACTIONS(745),
    [anon_sym_builtin] = ACTIONS(745),
    [anon_sym_cold] = ACTIONS(745),
    [anon_sym_convergent] = ACTIONS(745),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(745),
    [anon_sym_hot] = ACTIONS(745),
    [anon_sym_inaccessiblememonly] = ACTIONS(745),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(745),
    [anon_sym_inlinehint] = ACTIONS(745),
    [anon_sym_jumptable] = ACTIONS(745),
    [anon_sym_minsize] = ACTIONS(745),
    [anon_sym_naked] = ACTIONS(745),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(745),
    [anon_sym_nobuiltin] = ACTIONS(745),
    [anon_sym_noduplicate] = ACTIONS(745),
    [anon_sym_nofree] = ACTIONS(745),
    [anon_sym_noimplicitfloat] = ACTIONS(745),
    [anon_sym_noinline] = ACTIONS(745),
    [anon_sym_nomerge] = ACTIONS(745),
    [anon_sym_nonlazybind] = ACTIONS(745),
    [anon_sym_noprofile] = ACTIONS(745),
    [anon_sym_noredzone] = ACTIONS(745),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(745),
    [anon_sym_noreturn] = ACTIONS(745),
    [anon_sym_norecurse] = ACTIONS(745),
    [anon_sym_willreturn] = ACTIONS(745),
    [anon_sym_nosync] = ACTIONS(745),
    [anon_sym_nounwind] = ACTIONS(745),
    [anon_sym_nocallback] = ACTIONS(745),
    [anon_sym_nosanitize_coverage] = ACTIONS(745),
    [anon_sym_null_pointer_is_valid] = ACTIONS(745),
    [anon_sym_optforfuzzing] = ACTIONS(745),
    [anon_sym_optnone] = ACTIONS(745),
    [anon_sym_optsize] = ACTIONS(745),
    [anon_sym_readnone] = ACTIONS(745),
    [anon_sym_readonly] = ACTIONS(745),
    [anon_sym_writeonly] = ACTIONS(745),
    [anon_sym_argmemonly] = ACTIONS(745),
    [anon_sym_returns_twice] = ACTIONS(745),
    [anon_sym_safestack] = ACTIONS(745),
    [anon_sym_sanitize_address] = ACTIONS(745),
    [anon_sym_sanitize_memory] = ACTIONS(745),
    [anon_sym_sanitize_thread] = ACTIONS(745),
    [anon_sym_sanitize_hwaddress] = ACTIONS(745),
    [anon_sym_sanitize_memtag] = ACTIONS(745),
    [anon_sym_speculative_load_hardening] = ACTIONS(745),
    [anon_sym_speculatable] = ACTIONS(745),
    [anon_sym_ssp] = ACTIONS(745),
    [anon_sym_sspstrong] = ACTIONS(745),
    [anon_sym_sspreq] = ACTIONS(745),
    [anon_sym_strictfp] = ACTIONS(745),
    [anon_sym_nocf_check] = ACTIONS(745),
    [anon_sym_shadowcallstack] = ACTIONS(745),
    [anon_sym_mustprogress] = ACTIONS(745),
    [anon_sym_vscale_range] = ACTIONS(745),
    [anon_sym_preallocated] = ACTIONS(745),
    [anon_sym_zeroext] = ACTIONS(745),
    [anon_sym_signext] = ACTIONS(745),
    [anon_sym_inreg] = ACTIONS(745),
    [anon_sym_byval] = ACTIONS(745),
    [anon_sym_byref] = ACTIONS(745),
    [anon_sym_inalloca] = ACTIONS(745),
    [anon_sym_sret] = ACTIONS(745),
    [anon_sym_elementtype] = ACTIONS(745),
    [anon_sym_noalias] = ACTIONS(745),
    [anon_sym_nocapture] = ACTIONS(745),
    [anon_sym_nest] = ACTIONS(745),
    [anon_sym_returned] = ACTIONS(745),
    [anon_sym_nonnull] = ACTIONS(745),
    [anon_sym_dereferenceable] = ACTIONS(745),
    [anon_sym_dereferenceable_or_null] = ACTIONS(745),
    [anon_sym_swiftself] = ACTIONS(745),
    [anon_sym_swiftasync] = ACTIONS(745),
    [anon_sym_swifterror] = ACTIONS(745),
    [anon_sym_immarg] = ACTIONS(745),
    [anon_sym_noundef] = ACTIONS(745),
    [anon_sym_uwtable] = ACTIONS(747),
    [anon_sym_memory] = ACTIONS(749),
    [anon_sym_unreachable] = ACTIONS(751),
    [anon_sym_ret] = ACTIONS(751),
    [anon_sym_br] = ACTIONS(751),
    [anon_sym_resume] = ACTIONS(751),
    [anon_sym_freeze] = ACTIONS(751),
    [anon_sym_indirectbr] = ACTIONS(751),
    [anon_sym_extractelement] = ACTIONS(751),
    [anon_sym_insertelement] = ACTIONS(751),
    [anon_sym_select] = ACTIONS(751),
    [anon_sym_shufflevector] = ACTIONS(751),
    [anon_sym_fneg] = ACTIONS(751),
    [anon_sym_switch] = ACTIONS(751),
    [anon_sym_invoke] = ACTIONS(751),
    [anon_sym_cleanupret] = ACTIONS(751),
    [anon_sym_catchret] = ACTIONS(751),
    [anon_sym_catchswitch] = ACTIONS(751),
    [anon_sym_catchpad] = ACTIONS(751),
    [anon_sym_cleanuppad] = ACTIONS(751),
    [anon_sym_callbr] = ACTIONS(751),
    [anon_sym_icmp] = ACTIONS(751),
    [anon_sym_fcmp] = ACTIONS(751),
    [anon_sym_va_arg] = ACTIONS(751),
    [anon_sym_phi] = ACTIONS(751),
    [anon_sym_landingpad] = ACTIONS(751),
    [anon_sym_tail] = ACTIONS(751),
    [anon_sym_musttail] = ACTIONS(751),
    [anon_sym_notail] = ACTIONS(751),
    [anon_sym_call] = ACTIONS(751),
    [anon_sym_alloca] = ACTIONS(751),
    [anon_sym_load] = ACTIONS(751),
    [anon_sym_store] = ACTIONS(751),
    [anon_sym_cmpxchg] = ACTIONS(751),
    [anon_sym_atomicrmw] = ACTIONS(751),
    [anon_sym_fence] = ACTIONS(751),
    [anon_sym_getelementptr] = ACTIONS(751),
    [anon_sym_extractvalue] = ACTIONS(751),
    [anon_sym_insertvalue] = ACTIONS(751),
    [anon_sym_mul] = ACTIONS(751),
    [anon_sym_urem] = ACTIONS(751),
    [anon_sym_srem] = ACTIONS(751),
    [anon_sym_shl] = ACTIONS(751),
    [anon_sym_udiv] = ACTIONS(751),
    [anon_sym_sdiv] = ACTIONS(751),
    [anon_sym_lshr] = ACTIONS(751),
    [anon_sym_ashr] = ACTIONS(751),
    [anon_sym_fmul] = ACTIONS(751),
    [anon_sym_fdiv] = ACTIONS(751),
    [anon_sym_frem] = ACTIONS(751),
    [anon_sym_xchg] = ACTIONS(751),
    [anon_sym_add] = ACTIONS(751),
    [anon_sym_sub] = ACTIONS(751),
    [anon_sym_and] = ACTIONS(751),
    [anon_sym_nand] = ACTIONS(751),
    [anon_sym_or] = ACTIONS(751),
    [anon_sym_xor] = ACTIONS(751),
    [anon_sym_max] = ACTIONS(751),
    [anon_sym_min] = ACTIONS(751),
    [anon_sym_umax] = ACTIONS(751),
    [anon_sym_umin] = ACTIONS(751),
    [anon_sym_fadd] = ACTIONS(751),
    [anon_sym_fsub] = ACTIONS(751),
    [anon_sym_bitcast] = ACTIONS(751),
    [anon_sym_trunc] = ACTIONS(751),
    [anon_sym_zext] = ACTIONS(751),
    [anon_sym_sext] = ACTIONS(751),
    [anon_sym_fptrunc] = ACTIONS(751),
    [anon_sym_fpext] = ACTIONS(751),
    [anon_sym_addrspacecast] = ACTIONS(751),
    [anon_sym_uitofp] = ACTIONS(751),
    [anon_sym_sitofp] = ACTIONS(751),
    [anon_sym_fptoui] = ACTIONS(751),
    [anon_sym_fptosi] = ACTIONS(751),
    [anon_sym_inttoptr] = ACTIONS(751),
    [anon_sym_ptrtoint] = ACTIONS(751),
    [anon_sym_uselistorder] = ACTIONS(751),
  },
  [190] = {
    [sym_attribute] = STATE(198),
    [sym_attribute_name] = STATE(209),
    [sym_uwtable] = STATE(211),
    [sym_memory_attribute] = STATE(211),
    [sym_operand_bundles] = STATE(670),
    [sym_alignment] = STATE(214),
    [aux_sym_function_header_repeat3] = STATE(198),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(729),
    [sym_local_var] = ACTIONS(753),
    [sym_label] = ACTIONS(753),
    [sym_string] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(753),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_COMMA] = ACTIONS(753),
    [anon_sym_align] = ACTIONS(737),
    [anon_sym_section] = ACTIONS(739),
    [anon_sym_partition] = ACTIONS(739),
    [anon_sym_comdat] = ACTIONS(741),
    [anon_sym_gc] = ACTIONS(739),
    [anon_sym_prefix] = ACTIONS(743),
    [anon_sym_prologue] = ACTIONS(743),
    [anon_sym_personality] = ACTIONS(743),
    [anon_sym_alignstack] = ACTIONS(745),
    [anon_sym_allocsize] = ACTIONS(745),
    [anon_sym_alwaysinline] = ACTIONS(745),
    [anon_sym_builtin] = ACTIONS(745),
    [anon_sym_cold] = ACTIONS(745),
    [anon_sym_convergent] = ACTIONS(745),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(745),
    [anon_sym_hot] = ACTIONS(745),
    [anon_sym_inaccessiblememonly] = ACTIONS(745),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(745),
    [anon_sym_inlinehint] = ACTIONS(745),
    [anon_sym_jumptable] = ACTIONS(745),
    [anon_sym_minsize] = ACTIONS(745),
    [anon_sym_naked] = ACTIONS(745),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(745),
    [anon_sym_nobuiltin] = ACTIONS(745),
    [anon_sym_noduplicate] = ACTIONS(745),
    [anon_sym_nofree] = ACTIONS(745),
    [anon_sym_noimplicitfloat] = ACTIONS(745),
    [anon_sym_noinline] = ACTIONS(745),
    [anon_sym_nomerge] = ACTIONS(745),
    [anon_sym_nonlazybind] = ACTIONS(745),
    [anon_sym_noprofile] = ACTIONS(745),
    [anon_sym_noredzone] = ACTIONS(745),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(745),
    [anon_sym_noreturn] = ACTIONS(745),
    [anon_sym_norecurse] = ACTIONS(745),
    [anon_sym_willreturn] = ACTIONS(745),
    [anon_sym_nosync] = ACTIONS(745),
    [anon_sym_nounwind] = ACTIONS(745),
    [anon_sym_nocallback] = ACTIONS(745),
    [anon_sym_nosanitize_coverage] = ACTIONS(745),
    [anon_sym_null_pointer_is_valid] = ACTIONS(745),
    [anon_sym_optforfuzzing] = ACTIONS(745),
    [anon_sym_optnone] = ACTIONS(745),
    [anon_sym_optsize] = ACTIONS(745),
    [anon_sym_readnone] = ACTIONS(745),
    [anon_sym_readonly] = ACTIONS(745),
    [anon_sym_writeonly] = ACTIONS(745),
    [anon_sym_argmemonly] = ACTIONS(745),
    [anon_sym_returns_twice] = ACTIONS(745),
    [anon_sym_safestack] = ACTIONS(745),
    [anon_sym_sanitize_address] = ACTIONS(745),
    [anon_sym_sanitize_memory] = ACTIONS(745),
    [anon_sym_sanitize_thread] = ACTIONS(745),
    [anon_sym_sanitize_hwaddress] = ACTIONS(745),
    [anon_sym_sanitize_memtag] = ACTIONS(745),
    [anon_sym_speculative_load_hardening] = ACTIONS(745),
    [anon_sym_speculatable] = ACTIONS(745),
    [anon_sym_ssp] = ACTIONS(745),
    [anon_sym_sspstrong] = ACTIONS(745),
    [anon_sym_sspreq] = ACTIONS(745),
    [anon_sym_strictfp] = ACTIONS(745),
    [anon_sym_nocf_check] = ACTIONS(745),
    [anon_sym_shadowcallstack] = ACTIONS(745),
    [anon_sym_mustprogress] = ACTIONS(745),
    [anon_sym_vscale_range] = ACTIONS(745),
    [anon_sym_preallocated] = ACTIONS(745),
    [anon_sym_zeroext] = ACTIONS(745),
    [anon_sym_signext] = ACTIONS(745),
    [anon_sym_inreg] = ACTIONS(745),
    [anon_sym_byval] = ACTIONS(745),
    [anon_sym_byref] = ACTIONS(745),
    [anon_sym_inalloca] = ACTIONS(745),
    [anon_sym_sret] = ACTIONS(745),
    [anon_sym_elementtype] = ACTIONS(745),
    [anon_sym_noalias] = ACTIONS(745),
    [anon_sym_nocapture] = ACTIONS(745),
    [anon_sym_nest] = ACTIONS(745),
    [anon_sym_returned] = ACTIONS(745),
    [anon_sym_nonnull] = ACTIONS(745),
    [anon_sym_dereferenceable] = ACTIONS(745),
    [anon_sym_dereferenceable_or_null] = ACTIONS(745),
    [anon_sym_swiftself] = ACTIONS(745),
    [anon_sym_swiftasync] = ACTIONS(745),
    [anon_sym_swifterror] = ACTIONS(745),
    [anon_sym_immarg] = ACTIONS(745),
    [anon_sym_noundef] = ACTIONS(745),
    [anon_sym_uwtable] = ACTIONS(747),
    [anon_sym_memory] = ACTIONS(749),
    [anon_sym_unreachable] = ACTIONS(755),
    [anon_sym_ret] = ACTIONS(755),
    [anon_sym_br] = ACTIONS(755),
    [anon_sym_resume] = ACTIONS(755),
    [anon_sym_freeze] = ACTIONS(755),
    [anon_sym_indirectbr] = ACTIONS(755),
    [anon_sym_extractelement] = ACTIONS(755),
    [anon_sym_insertelement] = ACTIONS(755),
    [anon_sym_select] = ACTIONS(755),
    [anon_sym_shufflevector] = ACTIONS(755),
    [anon_sym_fneg] = ACTIONS(755),
    [anon_sym_switch] = ACTIONS(755),
    [anon_sym_invoke] = ACTIONS(755),
    [anon_sym_cleanupret] = ACTIONS(755),
    [anon_sym_catchret] = ACTIONS(755),
    [anon_sym_catchswitch] = ACTIONS(755),
    [anon_sym_catchpad] = ACTIONS(755),
    [anon_sym_cleanuppad] = ACTIONS(755),
    [anon_sym_callbr] = ACTIONS(755),
    [anon_sym_icmp] = ACTIONS(755),
    [anon_sym_fcmp] = ACTIONS(755),
    [anon_sym_va_arg] = ACTIONS(755),
    [anon_sym_phi] = ACTIONS(755),
    [anon_sym_landingpad] = ACTIONS(755),
    [anon_sym_tail] = ACTIONS(755),
    [anon_sym_musttail] = ACTIONS(755),
    [anon_sym_notail] = ACTIONS(755),
    [anon_sym_call] = ACTIONS(755),
    [anon_sym_alloca] = ACTIONS(755),
    [anon_sym_load] = ACTIONS(755),
    [anon_sym_store] = ACTIONS(755),
    [anon_sym_cmpxchg] = ACTIONS(755),
    [anon_sym_atomicrmw] = ACTIONS(755),
    [anon_sym_fence] = ACTIONS(755),
    [anon_sym_getelementptr] = ACTIONS(755),
    [anon_sym_extractvalue] = ACTIONS(755),
    [anon_sym_insertvalue] = ACTIONS(755),
    [anon_sym_mul] = ACTIONS(755),
    [anon_sym_urem] = ACTIONS(755),
    [anon_sym_srem] = ACTIONS(755),
    [anon_sym_shl] = ACTIONS(755),
    [anon_sym_udiv] = ACTIONS(755),
    [anon_sym_sdiv] = ACTIONS(755),
    [anon_sym_lshr] = ACTIONS(755),
    [anon_sym_ashr] = ACTIONS(755),
    [anon_sym_fmul] = ACTIONS(755),
    [anon_sym_fdiv] = ACTIONS(755),
    [anon_sym_frem] = ACTIONS(755),
    [anon_sym_xchg] = ACTIONS(755),
    [anon_sym_add] = ACTIONS(755),
    [anon_sym_sub] = ACTIONS(755),
    [anon_sym_and] = ACTIONS(755),
    [anon_sym_nand] = ACTIONS(755),
    [anon_sym_or] = ACTIONS(755),
    [anon_sym_xor] = ACTIONS(755),
    [anon_sym_max] = ACTIONS(755),
    [anon_sym_min] = ACTIONS(755),
    [anon_sym_umax] = ACTIONS(755),
    [anon_sym_umin] = ACTIONS(755),
    [anon_sym_fadd] = ACTIONS(755),
    [anon_sym_fsub] = ACTIONS(755),
    [anon_sym_bitcast] = ACTIONS(755),
    [anon_sym_trunc] = ACTIONS(755),
    [anon_sym_zext] = ACTIONS(755),
    [anon_sym_sext] = ACTIONS(755),
    [anon_sym_fptrunc] = ACTIONS(755),
    [anon_sym_fpext] = ACTIONS(755),
    [anon_sym_addrspacecast] = ACTIONS(755),
    [anon_sym_uitofp] = ACTIONS(755),
    [anon_sym_sitofp] = ACTIONS(755),
    [anon_sym_fptoui] = ACTIONS(755),
    [anon_sym_fptosi] = ACTIONS(755),
    [anon_sym_inttoptr] = ACTIONS(755),
    [anon_sym_ptrtoint] = ACTIONS(755),
    [anon_sym_uselistorder] = ACTIONS(755),
  },
  [191] = {
    [sym_attribute] = STATE(196),
    [sym_attribute_name] = STATE(209),
    [sym_uwtable] = STATE(211),
    [sym_memory_attribute] = STATE(211),
    [sym_operand_bundles] = STATE(688),
    [sym_alignment] = STATE(214),
    [aux_sym_function_header_repeat3] = STATE(196),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(729),
    [sym_local_var] = ACTIONS(757),
    [sym_label] = ACTIONS(757),
    [sym_string] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_COMMA] = ACTIONS(757),
    [anon_sym_align] = ACTIONS(737),
    [anon_sym_section] = ACTIONS(739),
    [anon_sym_partition] = ACTIONS(739),
    [anon_sym_comdat] = ACTIONS(741),
    [anon_sym_gc] = ACTIONS(739),
    [anon_sym_prefix] = ACTIONS(743),
    [anon_sym_prologue] = ACTIONS(743),
    [anon_sym_personality] = ACTIONS(743),
    [anon_sym_alignstack] = ACTIONS(745),
    [anon_sym_allocsize] = ACTIONS(745),
    [anon_sym_alwaysinline] = ACTIONS(745),
    [anon_sym_builtin] = ACTIONS(745),
    [anon_sym_cold] = ACTIONS(745),
    [anon_sym_convergent] = ACTIONS(745),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(745),
    [anon_sym_hot] = ACTIONS(745),
    [anon_sym_inaccessiblememonly] = ACTIONS(745),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(745),
    [anon_sym_inlinehint] = ACTIONS(745),
    [anon_sym_jumptable] = ACTIONS(745),
    [anon_sym_minsize] = ACTIONS(745),
    [anon_sym_naked] = ACTIONS(745),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(745),
    [anon_sym_nobuiltin] = ACTIONS(745),
    [anon_sym_noduplicate] = ACTIONS(745),
    [anon_sym_nofree] = ACTIONS(745),
    [anon_sym_noimplicitfloat] = ACTIONS(745),
    [anon_sym_noinline] = ACTIONS(745),
    [anon_sym_nomerge] = ACTIONS(745),
    [anon_sym_nonlazybind] = ACTIONS(745),
    [anon_sym_noprofile] = ACTIONS(745),
    [anon_sym_noredzone] = ACTIONS(745),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(745),
    [anon_sym_noreturn] = ACTIONS(745),
    [anon_sym_norecurse] = ACTIONS(745),
    [anon_sym_willreturn] = ACTIONS(745),
    [anon_sym_nosync] = ACTIONS(745),
    [anon_sym_nounwind] = ACTIONS(745),
    [anon_sym_nocallback] = ACTIONS(745),
    [anon_sym_nosanitize_coverage] = ACTIONS(745),
    [anon_sym_null_pointer_is_valid] = ACTIONS(745),
    [anon_sym_optforfuzzing] = ACTIONS(745),
    [anon_sym_optnone] = ACTIONS(745),
    [anon_sym_optsize] = ACTIONS(745),
    [anon_sym_readnone] = ACTIONS(745),
    [anon_sym_readonly] = ACTIONS(745),
    [anon_sym_writeonly] = ACTIONS(745),
    [anon_sym_argmemonly] = ACTIONS(745),
    [anon_sym_returns_twice] = ACTIONS(745),
    [anon_sym_safestack] = ACTIONS(745),
    [anon_sym_sanitize_address] = ACTIONS(745),
    [anon_sym_sanitize_memory] = ACTIONS(745),
    [anon_sym_sanitize_thread] = ACTIONS(745),
    [anon_sym_sanitize_hwaddress] = ACTIONS(745),
    [anon_sym_sanitize_memtag] = ACTIONS(745),
    [anon_sym_speculative_load_hardening] = ACTIONS(745),
    [anon_sym_speculatable] = ACTIONS(745),
    [anon_sym_ssp] = ACTIONS(745),
    [anon_sym_sspstrong] = ACTIONS(745),
    [anon_sym_sspreq] = ACTIONS(745),
    [anon_sym_strictfp] = ACTIONS(745),
    [anon_sym_nocf_check] = ACTIONS(745),
    [anon_sym_shadowcallstack] = ACTIONS(745),
    [anon_sym_mustprogress] = ACTIONS(745),
    [anon_sym_vscale_range] = ACTIONS(745),
    [anon_sym_preallocated] = ACTIONS(745),
    [anon_sym_zeroext] = ACTIONS(745),
    [anon_sym_signext] = ACTIONS(745),
    [anon_sym_inreg] = ACTIONS(745),
    [anon_sym_byval] = ACTIONS(745),
    [anon_sym_byref] = ACTIONS(745),
    [anon_sym_inalloca] = ACTIONS(745),
    [anon_sym_sret] = ACTIONS(745),
    [anon_sym_elementtype] = ACTIONS(745),
    [anon_sym_noalias] = ACTIONS(745),
    [anon_sym_nocapture] = ACTIONS(745),
    [anon_sym_nest] = ACTIONS(745),
    [anon_sym_returned] = ACTIONS(745),
    [anon_sym_nonnull] = ACTIONS(745),
    [anon_sym_dereferenceable] = ACTIONS(745),
    [anon_sym_dereferenceable_or_null] = ACTIONS(745),
    [anon_sym_swiftself] = ACTIONS(745),
    [anon_sym_swiftasync] = ACTIONS(745),
    [anon_sym_swifterror] = ACTIONS(745),
    [anon_sym_immarg] = ACTIONS(745),
    [anon_sym_noundef] = ACTIONS(745),
    [anon_sym_uwtable] = ACTIONS(747),
    [anon_sym_memory] = ACTIONS(749),
    [anon_sym_unreachable] = ACTIONS(759),
    [anon_sym_ret] = ACTIONS(759),
    [anon_sym_br] = ACTIONS(759),
    [anon_sym_resume] = ACTIONS(759),
    [anon_sym_freeze] = ACTIONS(759),
    [anon_sym_indirectbr] = ACTIONS(759),
    [anon_sym_extractelement] = ACTIONS(759),
    [anon_sym_insertelement] = ACTIONS(759),
    [anon_sym_select] = ACTIONS(759),
    [anon_sym_shufflevector] = ACTIONS(759),
    [anon_sym_fneg] = ACTIONS(759),
    [anon_sym_switch] = ACTIONS(759),
    [anon_sym_invoke] = ACTIONS(759),
    [anon_sym_cleanupret] = ACTIONS(759),
    [anon_sym_catchret] = ACTIONS(759),
    [anon_sym_catchswitch] = ACTIONS(759),
    [anon_sym_catchpad] = ACTIONS(759),
    [anon_sym_cleanuppad] = ACTIONS(759),
    [anon_sym_callbr] = ACTIONS(759),
    [anon_sym_icmp] = ACTIONS(759),
    [anon_sym_fcmp] = ACTIONS(759),
    [anon_sym_va_arg] = ACTIONS(759),
    [anon_sym_phi] = ACTIONS(759),
    [anon_sym_landingpad] = ACTIONS(759),
    [anon_sym_tail] = ACTIONS(759),
    [anon_sym_musttail] = ACTIONS(759),
    [anon_sym_notail] = ACTIONS(759),
    [anon_sym_call] = ACTIONS(759),
    [anon_sym_alloca] = ACTIONS(759),
    [anon_sym_load] = ACTIONS(759),
    [anon_sym_store] = ACTIONS(759),
    [anon_sym_cmpxchg] = ACTIONS(759),
    [anon_sym_atomicrmw] = ACTIONS(759),
    [anon_sym_fence] = ACTIONS(759),
    [anon_sym_getelementptr] = ACTIONS(759),
    [anon_sym_extractvalue] = ACTIONS(759),
    [anon_sym_insertvalue] = ACTIONS(759),
    [anon_sym_mul] = ACTIONS(759),
    [anon_sym_urem] = ACTIONS(759),
    [anon_sym_srem] = ACTIONS(759),
    [anon_sym_shl] = ACTIONS(759),
    [anon_sym_udiv] = ACTIONS(759),
    [anon_sym_sdiv] = ACTIONS(759),
    [anon_sym_lshr] = ACTIONS(759),
    [anon_sym_ashr] = ACTIONS(759),
    [anon_sym_fmul] = ACTIONS(759),
    [anon_sym_fdiv] = ACTIONS(759),
    [anon_sym_frem] = ACTIONS(759),
    [anon_sym_xchg] = ACTIONS(759),
    [anon_sym_add] = ACTIONS(759),
    [anon_sym_sub] = ACTIONS(759),
    [anon_sym_and] = ACTIONS(759),
    [anon_sym_nand] = ACTIONS(759),
    [anon_sym_or] = ACTIONS(759),
    [anon_sym_xor] = ACTIONS(759),
    [anon_sym_max] = ACTIONS(759),
    [anon_sym_min] = ACTIONS(759),
    [anon_sym_umax] = ACTIONS(759),
    [anon_sym_umin] = ACTIONS(759),
    [anon_sym_fadd] = ACTIONS(759),
    [anon_sym_fsub] = ACTIONS(759),
    [anon_sym_bitcast] = ACTIONS(759),
    [anon_sym_trunc] = ACTIONS(759),
    [anon_sym_zext] = ACTIONS(759),
    [anon_sym_sext] = ACTIONS(759),
    [anon_sym_fptrunc] = ACTIONS(759),
    [anon_sym_fpext] = ACTIONS(759),
    [anon_sym_addrspacecast] = ACTIONS(759),
    [anon_sym_uitofp] = ACTIONS(759),
    [anon_sym_sitofp] = ACTIONS(759),
    [anon_sym_fptoui] = ACTIONS(759),
    [anon_sym_fptosi] = ACTIONS(759),
    [anon_sym_inttoptr] = ACTIONS(759),
    [anon_sym_ptrtoint] = ACTIONS(759),
    [anon_sym_uselistorder] = ACTIONS(759),
  },
  [192] = {
    [sym_attribute] = STATE(198),
    [sym_attribute_name] = STATE(209),
    [sym_uwtable] = STATE(211),
    [sym_memory_attribute] = STATE(211),
    [sym_operand_bundles] = STATE(690),
    [sym_alignment] = STATE(214),
    [aux_sym_function_header_repeat3] = STATE(198),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(729),
    [sym_local_var] = ACTIONS(761),
    [sym_label] = ACTIONS(761),
    [sym_string] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_COMMA] = ACTIONS(761),
    [anon_sym_align] = ACTIONS(737),
    [anon_sym_section] = ACTIONS(739),
    [anon_sym_partition] = ACTIONS(739),
    [anon_sym_comdat] = ACTIONS(741),
    [anon_sym_gc] = ACTIONS(739),
    [anon_sym_prefix] = ACTIONS(743),
    [anon_sym_prologue] = ACTIONS(743),
    [anon_sym_personality] = ACTIONS(743),
    [anon_sym_alignstack] = ACTIONS(745),
    [anon_sym_allocsize] = ACTIONS(745),
    [anon_sym_alwaysinline] = ACTIONS(745),
    [anon_sym_builtin] = ACTIONS(745),
    [anon_sym_cold] = ACTIONS(745),
    [anon_sym_convergent] = ACTIONS(745),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(745),
    [anon_sym_hot] = ACTIONS(745),
    [anon_sym_inaccessiblememonly] = ACTIONS(745),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(745),
    [anon_sym_inlinehint] = ACTIONS(745),
    [anon_sym_jumptable] = ACTIONS(745),
    [anon_sym_minsize] = ACTIONS(745),
    [anon_sym_naked] = ACTIONS(745),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(745),
    [anon_sym_nobuiltin] = ACTIONS(745),
    [anon_sym_noduplicate] = ACTIONS(745),
    [anon_sym_nofree] = ACTIONS(745),
    [anon_sym_noimplicitfloat] = ACTIONS(745),
    [anon_sym_noinline] = ACTIONS(745),
    [anon_sym_nomerge] = ACTIONS(745),
    [anon_sym_nonlazybind] = ACTIONS(745),
    [anon_sym_noprofile] = ACTIONS(745),
    [anon_sym_noredzone] = ACTIONS(745),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(745),
    [anon_sym_noreturn] = ACTIONS(745),
    [anon_sym_norecurse] = ACTIONS(745),
    [anon_sym_willreturn] = ACTIONS(745),
    [anon_sym_nosync] = ACTIONS(745),
    [anon_sym_nounwind] = ACTIONS(745),
    [anon_sym_nocallback] = ACTIONS(745),
    [anon_sym_nosanitize_coverage] = ACTIONS(745),
    [anon_sym_null_pointer_is_valid] = ACTIONS(745),
    [anon_sym_optforfuzzing] = ACTIONS(745),
    [anon_sym_optnone] = ACTIONS(745),
    [anon_sym_optsize] = ACTIONS(745),
    [anon_sym_readnone] = ACTIONS(745),
    [anon_sym_readonly] = ACTIONS(745),
    [anon_sym_writeonly] = ACTIONS(745),
    [anon_sym_argmemonly] = ACTIONS(745),
    [anon_sym_returns_twice] = ACTIONS(745),
    [anon_sym_safestack] = ACTIONS(745),
    [anon_sym_sanitize_address] = ACTIONS(745),
    [anon_sym_sanitize_memory] = ACTIONS(745),
    [anon_sym_sanitize_thread] = ACTIONS(745),
    [anon_sym_sanitize_hwaddress] = ACTIONS(745),
    [anon_sym_sanitize_memtag] = ACTIONS(745),
    [anon_sym_speculative_load_hardening] = ACTIONS(745),
    [anon_sym_speculatable] = ACTIONS(745),
    [anon_sym_ssp] = ACTIONS(745),
    [anon_sym_sspstrong] = ACTIONS(745),
    [anon_sym_sspreq] = ACTIONS(745),
    [anon_sym_strictfp] = ACTIONS(745),
    [anon_sym_nocf_check] = ACTIONS(745),
    [anon_sym_shadowcallstack] = ACTIONS(745),
    [anon_sym_mustprogress] = ACTIONS(745),
    [anon_sym_vscale_range] = ACTIONS(745),
    [anon_sym_preallocated] = ACTIONS(745),
    [anon_sym_zeroext] = ACTIONS(745),
    [anon_sym_signext] = ACTIONS(745),
    [anon_sym_inreg] = ACTIONS(745),
    [anon_sym_byval] = ACTIONS(745),
    [anon_sym_byref] = ACTIONS(745),
    [anon_sym_inalloca] = ACTIONS(745),
    [anon_sym_sret] = ACTIONS(745),
    [anon_sym_elementtype] = ACTIONS(745),
    [anon_sym_noalias] = ACTIONS(745),
    [anon_sym_nocapture] = ACTIONS(745),
    [anon_sym_nest] = ACTIONS(745),
    [anon_sym_returned] = ACTIONS(745),
    [anon_sym_nonnull] = ACTIONS(745),
    [anon_sym_dereferenceable] = ACTIONS(745),
    [anon_sym_dereferenceable_or_null] = ACTIONS(745),
    [anon_sym_swiftself] = ACTIONS(745),
    [anon_sym_swiftasync] = ACTIONS(745),
    [anon_sym_swifterror] = ACTIONS(745),
    [anon_sym_immarg] = ACTIONS(745),
    [anon_sym_noundef] = ACTIONS(745),
    [anon_sym_uwtable] = ACTIONS(747),
    [anon_sym_memory] = ACTIONS(749),
    [anon_sym_unreachable] = ACTIONS(763),
    [anon_sym_ret] = ACTIONS(763),
    [anon_sym_br] = ACTIONS(763),
    [anon_sym_resume] = ACTIONS(763),
    [anon_sym_freeze] = ACTIONS(763),
    [anon_sym_indirectbr] = ACTIONS(763),
    [anon_sym_extractelement] = ACTIONS(763),
    [anon_sym_insertelement] = ACTIONS(763),
    [anon_sym_select] = ACTIONS(763),
    [anon_sym_shufflevector] = ACTIONS(763),
    [anon_sym_fneg] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(763),
    [anon_sym_invoke] = ACTIONS(763),
    [anon_sym_cleanupret] = ACTIONS(763),
    [anon_sym_catchret] = ACTIONS(763),
    [anon_sym_catchswitch] = ACTIONS(763),
    [anon_sym_catchpad] = ACTIONS(763),
    [anon_sym_cleanuppad] = ACTIONS(763),
    [anon_sym_callbr] = ACTIONS(763),
    [anon_sym_icmp] = ACTIONS(763),
    [anon_sym_fcmp] = ACTIONS(763),
    [anon_sym_va_arg] = ACTIONS(763),
    [anon_sym_phi] = ACTIONS(763),
    [anon_sym_landingpad] = ACTIONS(763),
    [anon_sym_tail] = ACTIONS(763),
    [anon_sym_musttail] = ACTIONS(763),
    [anon_sym_notail] = ACTIONS(763),
    [anon_sym_call] = ACTIONS(763),
    [anon_sym_alloca] = ACTIONS(763),
    [anon_sym_load] = ACTIONS(763),
    [anon_sym_store] = ACTIONS(763),
    [anon_sym_cmpxchg] = ACTIONS(763),
    [anon_sym_atomicrmw] = ACTIONS(763),
    [anon_sym_fence] = ACTIONS(763),
    [anon_sym_getelementptr] = ACTIONS(763),
    [anon_sym_extractvalue] = ACTIONS(763),
    [anon_sym_insertvalue] = ACTIONS(763),
    [anon_sym_mul] = ACTIONS(763),
    [anon_sym_urem] = ACTIONS(763),
    [anon_sym_srem] = ACTIONS(763),
    [anon_sym_shl] = ACTIONS(763),
    [anon_sym_udiv] = ACTIONS(763),
    [anon_sym_sdiv] = ACTIONS(763),
    [anon_sym_lshr] = ACTIONS(763),
    [anon_sym_ashr] = ACTIONS(763),
    [anon_sym_fmul] = ACTIONS(763),
    [anon_sym_fdiv] = ACTIONS(763),
    [anon_sym_frem] = ACTIONS(763),
    [anon_sym_xchg] = ACTIONS(763),
    [anon_sym_add] = ACTIONS(763),
    [anon_sym_sub] = ACTIONS(763),
    [anon_sym_and] = ACTIONS(763),
    [anon_sym_nand] = ACTIONS(763),
    [anon_sym_or] = ACTIONS(763),
    [anon_sym_xor] = ACTIONS(763),
    [anon_sym_max] = ACTIONS(763),
    [anon_sym_min] = ACTIONS(763),
    [anon_sym_umax] = ACTIONS(763),
    [anon_sym_umin] = ACTIONS(763),
    [anon_sym_fadd] = ACTIONS(763),
    [anon_sym_fsub] = ACTIONS(763),
    [anon_sym_bitcast] = ACTIONS(763),
    [anon_sym_trunc] = ACTIONS(763),
    [anon_sym_zext] = ACTIONS(763),
    [anon_sym_sext] = ACTIONS(763),
    [anon_sym_fptrunc] = ACTIONS(763),
    [anon_sym_fpext] = ACTIONS(763),
    [anon_sym_addrspacecast] = ACTIONS(763),
    [anon_sym_uitofp] = ACTIONS(763),
    [anon_sym_sitofp] = ACTIONS(763),
    [anon_sym_fptoui] = ACTIONS(763),
    [anon_sym_fptosi] = ACTIONS(763),
    [anon_sym_inttoptr] = ACTIONS(763),
    [anon_sym_ptrtoint] = ACTIONS(763),
    [anon_sym_uselistorder] = ACTIONS(763),
  },
  [193] = {
    [sym_attribute] = STATE(198),
    [sym_attribute_name] = STATE(209),
    [sym_uwtable] = STATE(211),
    [sym_memory_attribute] = STATE(211),
    [sym_operand_bundles] = STATE(678),
    [sym_alignment] = STATE(214),
    [aux_sym_function_header_repeat3] = STATE(198),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(729),
    [sym_local_var] = ACTIONS(765),
    [sym_label] = ACTIONS(765),
    [sym_string] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(765),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_COMMA] = ACTIONS(765),
    [anon_sym_align] = ACTIONS(737),
    [anon_sym_section] = ACTIONS(739),
    [anon_sym_partition] = ACTIONS(739),
    [anon_sym_comdat] = ACTIONS(741),
    [anon_sym_gc] = ACTIONS(739),
    [anon_sym_prefix] = ACTIONS(743),
    [anon_sym_prologue] = ACTIONS(743),
    [anon_sym_personality] = ACTIONS(743),
    [anon_sym_alignstack] = ACTIONS(745),
    [anon_sym_allocsize] = ACTIONS(745),
    [anon_sym_alwaysinline] = ACTIONS(745),
    [anon_sym_builtin] = ACTIONS(745),
    [anon_sym_cold] = ACTIONS(745),
    [anon_sym_convergent] = ACTIONS(745),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(745),
    [anon_sym_hot] = ACTIONS(745),
    [anon_sym_inaccessiblememonly] = ACTIONS(745),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(745),
    [anon_sym_inlinehint] = ACTIONS(745),
    [anon_sym_jumptable] = ACTIONS(745),
    [anon_sym_minsize] = ACTIONS(745),
    [anon_sym_naked] = ACTIONS(745),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(745),
    [anon_sym_nobuiltin] = ACTIONS(745),
    [anon_sym_noduplicate] = ACTIONS(745),
    [anon_sym_nofree] = ACTIONS(745),
    [anon_sym_noimplicitfloat] = ACTIONS(745),
    [anon_sym_noinline] = ACTIONS(745),
    [anon_sym_nomerge] = ACTIONS(745),
    [anon_sym_nonlazybind] = ACTIONS(745),
    [anon_sym_noprofile] = ACTIONS(745),
    [anon_sym_noredzone] = ACTIONS(745),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(745),
    [anon_sym_noreturn] = ACTIONS(745),
    [anon_sym_norecurse] = ACTIONS(745),
    [anon_sym_willreturn] = ACTIONS(745),
    [anon_sym_nosync] = ACTIONS(745),
    [anon_sym_nounwind] = ACTIONS(745),
    [anon_sym_nocallback] = ACTIONS(745),
    [anon_sym_nosanitize_coverage] = ACTIONS(745),
    [anon_sym_null_pointer_is_valid] = ACTIONS(745),
    [anon_sym_optforfuzzing] = ACTIONS(745),
    [anon_sym_optnone] = ACTIONS(745),
    [anon_sym_optsize] = ACTIONS(745),
    [anon_sym_readnone] = ACTIONS(745),
    [anon_sym_readonly] = ACTIONS(745),
    [anon_sym_writeonly] = ACTIONS(745),
    [anon_sym_argmemonly] = ACTIONS(745),
    [anon_sym_returns_twice] = ACTIONS(745),
    [anon_sym_safestack] = ACTIONS(745),
    [anon_sym_sanitize_address] = ACTIONS(745),
    [anon_sym_sanitize_memory] = ACTIONS(745),
    [anon_sym_sanitize_thread] = ACTIONS(745),
    [anon_sym_sanitize_hwaddress] = ACTIONS(745),
    [anon_sym_sanitize_memtag] = ACTIONS(745),
    [anon_sym_speculative_load_hardening] = ACTIONS(745),
    [anon_sym_speculatable] = ACTIONS(745),
    [anon_sym_ssp] = ACTIONS(745),
    [anon_sym_sspstrong] = ACTIONS(745),
    [anon_sym_sspreq] = ACTIONS(745),
    [anon_sym_strictfp] = ACTIONS(745),
    [anon_sym_nocf_check] = ACTIONS(745),
    [anon_sym_shadowcallstack] = ACTIONS(745),
    [anon_sym_mustprogress] = ACTIONS(745),
    [anon_sym_vscale_range] = ACTIONS(745),
    [anon_sym_preallocated] = ACTIONS(745),
    [anon_sym_zeroext] = ACTIONS(745),
    [anon_sym_signext] = ACTIONS(745),
    [anon_sym_inreg] = ACTIONS(745),
    [anon_sym_byval] = ACTIONS(745),
    [anon_sym_byref] = ACTIONS(745),
    [anon_sym_inalloca] = ACTIONS(745),
    [anon_sym_sret] = ACTIONS(745),
    [anon_sym_elementtype] = ACTIONS(745),
    [anon_sym_noalias] = ACTIONS(745),
    [anon_sym_nocapture] = ACTIONS(745),
    [anon_sym_nest] = ACTIONS(745),
    [anon_sym_returned] = ACTIONS(745),
    [anon_sym_nonnull] = ACTIONS(745),
    [anon_sym_dereferenceable] = ACTIONS(745),
    [anon_sym_dereferenceable_or_null] = ACTIONS(745),
    [anon_sym_swiftself] = ACTIONS(745),
    [anon_sym_swiftasync] = ACTIONS(745),
    [anon_sym_swifterror] = ACTIONS(745),
    [anon_sym_immarg] = ACTIONS(745),
    [anon_sym_noundef] = ACTIONS(745),
    [anon_sym_uwtable] = ACTIONS(747),
    [anon_sym_memory] = ACTIONS(749),
    [anon_sym_unreachable] = ACTIONS(767),
    [anon_sym_ret] = ACTIONS(767),
    [anon_sym_br] = ACTIONS(767),
    [anon_sym_resume] = ACTIONS(767),
    [anon_sym_freeze] = ACTIONS(767),
    [anon_sym_indirectbr] = ACTIONS(767),
    [anon_sym_extractelement] = ACTIONS(767),
    [anon_sym_insertelement] = ACTIONS(767),
    [anon_sym_select] = ACTIONS(767),
    [anon_sym_shufflevector] = ACTIONS(767),
    [anon_sym_fneg] = ACTIONS(767),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_invoke] = ACTIONS(767),
    [anon_sym_cleanupret] = ACTIONS(767),
    [anon_sym_catchret] = ACTIONS(767),
    [anon_sym_catchswitch] = ACTIONS(767),
    [anon_sym_catchpad] = ACTIONS(767),
    [anon_sym_cleanuppad] = ACTIONS(767),
    [anon_sym_callbr] = ACTIONS(767),
    [anon_sym_icmp] = ACTIONS(767),
    [anon_sym_fcmp] = ACTIONS(767),
    [anon_sym_va_arg] = ACTIONS(767),
    [anon_sym_phi] = ACTIONS(767),
    [anon_sym_landingpad] = ACTIONS(767),
    [anon_sym_tail] = ACTIONS(767),
    [anon_sym_musttail] = ACTIONS(767),
    [anon_sym_notail] = ACTIONS(767),
    [anon_sym_call] = ACTIONS(767),
    [anon_sym_alloca] = ACTIONS(767),
    [anon_sym_load] = ACTIONS(767),
    [anon_sym_store] = ACTIONS(767),
    [anon_sym_cmpxchg] = ACTIONS(767),
    [anon_sym_atomicrmw] = ACTIONS(767),
    [anon_sym_fence] = ACTIONS(767),
    [anon_sym_getelementptr] = ACTIONS(767),
    [anon_sym_extractvalue] = ACTIONS(767),
    [anon_sym_insertvalue] = ACTIONS(767),
    [anon_sym_mul] = ACTIONS(767),
    [anon_sym_urem] = ACTIONS(767),
    [anon_sym_srem] = ACTIONS(767),
    [anon_sym_shl] = ACTIONS(767),
    [anon_sym_udiv] = ACTIONS(767),
    [anon_sym_sdiv] = ACTIONS(767),
    [anon_sym_lshr] = ACTIONS(767),
    [anon_sym_ashr] = ACTIONS(767),
    [anon_sym_fmul] = ACTIONS(767),
    [anon_sym_fdiv] = ACTIONS(767),
    [anon_sym_frem] = ACTIONS(767),
    [anon_sym_xchg] = ACTIONS(767),
    [anon_sym_add] = ACTIONS(767),
    [anon_sym_sub] = ACTIONS(767),
    [anon_sym_and] = ACTIONS(767),
    [anon_sym_nand] = ACTIONS(767),
    [anon_sym_or] = ACTIONS(767),
    [anon_sym_xor] = ACTIONS(767),
    [anon_sym_max] = ACTIONS(767),
    [anon_sym_min] = ACTIONS(767),
    [anon_sym_umax] = ACTIONS(767),
    [anon_sym_umin] = ACTIONS(767),
    [anon_sym_fadd] = ACTIONS(767),
    [anon_sym_fsub] = ACTIONS(767),
    [anon_sym_bitcast] = ACTIONS(767),
    [anon_sym_trunc] = ACTIONS(767),
    [anon_sym_zext] = ACTIONS(767),
    [anon_sym_sext] = ACTIONS(767),
    [anon_sym_fptrunc] = ACTIONS(767),
    [anon_sym_fpext] = ACTIONS(767),
    [anon_sym_addrspacecast] = ACTIONS(767),
    [anon_sym_uitofp] = ACTIONS(767),
    [anon_sym_sitofp] = ACTIONS(767),
    [anon_sym_fptoui] = ACTIONS(767),
    [anon_sym_fptosi] = ACTIONS(767),
    [anon_sym_inttoptr] = ACTIONS(767),
    [anon_sym_ptrtoint] = ACTIONS(767),
    [anon_sym_uselistorder] = ACTIONS(767),
  },
  [194] = {
    [sym_attribute] = STATE(190),
    [sym_attribute_name] = STATE(209),
    [sym_uwtable] = STATE(211),
    [sym_memory_attribute] = STATE(211),
    [sym_operand_bundles] = STATE(646),
    [sym_alignment] = STATE(214),
    [aux_sym_function_header_repeat3] = STATE(190),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(729),
    [sym_local_var] = ACTIONS(769),
    [sym_label] = ACTIONS(769),
    [sym_string] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_COMMA] = ACTIONS(769),
    [anon_sym_align] = ACTIONS(737),
    [anon_sym_section] = ACTIONS(739),
    [anon_sym_partition] = ACTIONS(739),
    [anon_sym_comdat] = ACTIONS(741),
    [anon_sym_gc] = ACTIONS(739),
    [anon_sym_prefix] = ACTIONS(743),
    [anon_sym_prologue] = ACTIONS(743),
    [anon_sym_personality] = ACTIONS(743),
    [anon_sym_alignstack] = ACTIONS(745),
    [anon_sym_allocsize] = ACTIONS(745),
    [anon_sym_alwaysinline] = ACTIONS(745),
    [anon_sym_builtin] = ACTIONS(745),
    [anon_sym_cold] = ACTIONS(745),
    [anon_sym_convergent] = ACTIONS(745),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(745),
    [anon_sym_hot] = ACTIONS(745),
    [anon_sym_inaccessiblememonly] = ACTIONS(745),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(745),
    [anon_sym_inlinehint] = ACTIONS(745),
    [anon_sym_jumptable] = ACTIONS(745),
    [anon_sym_minsize] = ACTIONS(745),
    [anon_sym_naked] = ACTIONS(745),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(745),
    [anon_sym_nobuiltin] = ACTIONS(745),
    [anon_sym_noduplicate] = ACTIONS(745),
    [anon_sym_nofree] = ACTIONS(745),
    [anon_sym_noimplicitfloat] = ACTIONS(745),
    [anon_sym_noinline] = ACTIONS(745),
    [anon_sym_nomerge] = ACTIONS(745),
    [anon_sym_nonlazybind] = ACTIONS(745),
    [anon_sym_noprofile] = ACTIONS(745),
    [anon_sym_noredzone] = ACTIONS(745),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(745),
    [anon_sym_noreturn] = ACTIONS(745),
    [anon_sym_norecurse] = ACTIONS(745),
    [anon_sym_willreturn] = ACTIONS(745),
    [anon_sym_nosync] = ACTIONS(745),
    [anon_sym_nounwind] = ACTIONS(745),
    [anon_sym_nocallback] = ACTIONS(745),
    [anon_sym_nosanitize_coverage] = ACTIONS(745),
    [anon_sym_null_pointer_is_valid] = ACTIONS(745),
    [anon_sym_optforfuzzing] = ACTIONS(745),
    [anon_sym_optnone] = ACTIONS(745),
    [anon_sym_optsize] = ACTIONS(745),
    [anon_sym_readnone] = ACTIONS(745),
    [anon_sym_readonly] = ACTIONS(745),
    [anon_sym_writeonly] = ACTIONS(745),
    [anon_sym_argmemonly] = ACTIONS(745),
    [anon_sym_returns_twice] = ACTIONS(745),
    [anon_sym_safestack] = ACTIONS(745),
    [anon_sym_sanitize_address] = ACTIONS(745),
    [anon_sym_sanitize_memory] = ACTIONS(745),
    [anon_sym_sanitize_thread] = ACTIONS(745),
    [anon_sym_sanitize_hwaddress] = ACTIONS(745),
    [anon_sym_sanitize_memtag] = ACTIONS(745),
    [anon_sym_speculative_load_hardening] = ACTIONS(745),
    [anon_sym_speculatable] = ACTIONS(745),
    [anon_sym_ssp] = ACTIONS(745),
    [anon_sym_sspstrong] = ACTIONS(745),
    [anon_sym_sspreq] = ACTIONS(745),
    [anon_sym_strictfp] = ACTIONS(745),
    [anon_sym_nocf_check] = ACTIONS(745),
    [anon_sym_shadowcallstack] = ACTIONS(745),
    [anon_sym_mustprogress] = ACTIONS(745),
    [anon_sym_vscale_range] = ACTIONS(745),
    [anon_sym_preallocated] = ACTIONS(745),
    [anon_sym_zeroext] = ACTIONS(745),
    [anon_sym_signext] = ACTIONS(745),
    [anon_sym_inreg] = ACTIONS(745),
    [anon_sym_byval] = ACTIONS(745),
    [anon_sym_byref] = ACTIONS(745),
    [anon_sym_inalloca] = ACTIONS(745),
    [anon_sym_sret] = ACTIONS(745),
    [anon_sym_elementtype] = ACTIONS(745),
    [anon_sym_noalias] = ACTIONS(745),
    [anon_sym_nocapture] = ACTIONS(745),
    [anon_sym_nest] = ACTIONS(745),
    [anon_sym_returned] = ACTIONS(745),
    [anon_sym_nonnull] = ACTIONS(745),
    [anon_sym_dereferenceable] = ACTIONS(745),
    [anon_sym_dereferenceable_or_null] = ACTIONS(745),
    [anon_sym_swiftself] = ACTIONS(745),
    [anon_sym_swiftasync] = ACTIONS(745),
    [anon_sym_swifterror] = ACTIONS(745),
    [anon_sym_immarg] = ACTIONS(745),
    [anon_sym_noundef] = ACTIONS(745),
    [anon_sym_uwtable] = ACTIONS(747),
    [anon_sym_memory] = ACTIONS(749),
    [anon_sym_unreachable] = ACTIONS(771),
    [anon_sym_ret] = ACTIONS(771),
    [anon_sym_br] = ACTIONS(771),
    [anon_sym_resume] = ACTIONS(771),
    [anon_sym_freeze] = ACTIONS(771),
    [anon_sym_indirectbr] = ACTIONS(771),
    [anon_sym_extractelement] = ACTIONS(771),
    [anon_sym_insertelement] = ACTIONS(771),
    [anon_sym_select] = ACTIONS(771),
    [anon_sym_shufflevector] = ACTIONS(771),
    [anon_sym_fneg] = ACTIONS(771),
    [anon_sym_switch] = ACTIONS(771),
    [anon_sym_invoke] = ACTIONS(771),
    [anon_sym_cleanupret] = ACTIONS(771),
    [anon_sym_catchret] = ACTIONS(771),
    [anon_sym_catchswitch] = ACTIONS(771),
    [anon_sym_catchpad] = ACTIONS(771),
    [anon_sym_cleanuppad] = ACTIONS(771),
    [anon_sym_callbr] = ACTIONS(771),
    [anon_sym_icmp] = ACTIONS(771),
    [anon_sym_fcmp] = ACTIONS(771),
    [anon_sym_va_arg] = ACTIONS(771),
    [anon_sym_phi] = ACTIONS(771),
    [anon_sym_landingpad] = ACTIONS(771),
    [anon_sym_tail] = ACTIONS(771),
    [anon_sym_musttail] = ACTIONS(771),
    [anon_sym_notail] = ACTIONS(771),
    [anon_sym_call] = ACTIONS(771),
    [anon_sym_alloca] = ACTIONS(771),
    [anon_sym_load] = ACTIONS(771),
    [anon_sym_store] = ACTIONS(771),
    [anon_sym_cmpxchg] = ACTIONS(771),
    [anon_sym_atomicrmw] = ACTIONS(771),
    [anon_sym_fence] = ACTIONS(771),
    [anon_sym_getelementptr] = ACTIONS(771),
    [anon_sym_extractvalue] = ACTIONS(771),
    [anon_sym_insertvalue] = ACTIONS(771),
    [anon_sym_mul] = ACTIONS(771),
    [anon_sym_urem] = ACTIONS(771),
    [anon_sym_srem] = ACTIONS(771),
    [anon_sym_shl] = ACTIONS(771),
    [anon_sym_udiv] = ACTIONS(771),
    [anon_sym_sdiv] = ACTIONS(771),
    [anon_sym_lshr] = ACTIONS(771),
    [anon_sym_ashr] = ACTIONS(771),
    [anon_sym_fmul] = ACTIONS(771),
    [anon_sym_fdiv] = ACTIONS(771),
    [anon_sym_frem] = ACTIONS(771),
    [anon_sym_xchg] = ACTIONS(771),
    [anon_sym_add] = ACTIONS(771),
    [anon_sym_sub] = ACTIONS(771),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_nand] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_xor] = ACTIONS(771),
    [anon_sym_max] = ACTIONS(771),
    [anon_sym_min] = ACTIONS(771),
    [anon_sym_umax] = ACTIONS(771),
    [anon_sym_umin] = ACTIONS(771),
    [anon_sym_fadd] = ACTIONS(771),
    [anon_sym_fsub] = ACTIONS(771),
    [anon_sym_bitcast] = ACTIONS(771),
    [anon_sym_trunc] = ACTIONS(771),
    [anon_sym_zext] = ACTIONS(771),
    [anon_sym_sext] = ACTIONS(771),
    [anon_sym_fptrunc] = ACTIONS(771),
    [anon_sym_fpext] = ACTIONS(771),
    [anon_sym_addrspacecast] = ACTIONS(771),
    [anon_sym_uitofp] = ACTIONS(771),
    [anon_sym_sitofp] = ACTIONS(771),
    [anon_sym_fptoui] = ACTIONS(771),
    [anon_sym_fptosi] = ACTIONS(771),
    [anon_sym_inttoptr] = ACTIONS(771),
    [anon_sym_ptrtoint] = ACTIONS(771),
    [anon_sym_uselistorder] = ACTIONS(771),
  },
  [195] = {
    [sym_attribute] = STATE(193),
    [sym_attribute_name] = STATE(209),
    [sym_uwtable] = STATE(211),
    [sym_memory_attribute] = STATE(211),
    [sym_operand_bundles] = STATE(679),
    [sym_alignment] = STATE(214),
    [aux_sym_function_header_repeat3] = STATE(193),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(729),
    [sym_local_var] = ACTIONS(773),
    [sym_label] = ACTIONS(773),
    [sym_string] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_COMMA] = ACTIONS(773),
    [anon_sym_align] = ACTIONS(737),
    [anon_sym_section] = ACTIONS(739),
    [anon_sym_partition] = ACTIONS(739),
    [anon_sym_comdat] = ACTIONS(741),
    [anon_sym_gc] = ACTIONS(739),
    [anon_sym_prefix] = ACTIONS(743),
    [anon_sym_prologue] = ACTIONS(743),
    [anon_sym_personality] = ACTIONS(743),
    [anon_sym_alignstack] = ACTIONS(745),
    [anon_sym_allocsize] = ACTIONS(745),
    [anon_sym_alwaysinline] = ACTIONS(745),
    [anon_sym_builtin] = ACTIONS(745),
    [anon_sym_cold] = ACTIONS(745),
    [anon_sym_convergent] = ACTIONS(745),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(745),
    [anon_sym_hot] = ACTIONS(745),
    [anon_sym_inaccessiblememonly] = ACTIONS(745),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(745),
    [anon_sym_inlinehint] = ACTIONS(745),
    [anon_sym_jumptable] = ACTIONS(745),
    [anon_sym_minsize] = ACTIONS(745),
    [anon_sym_naked] = ACTIONS(745),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(745),
    [anon_sym_nobuiltin] = ACTIONS(745),
    [anon_sym_noduplicate] = ACTIONS(745),
    [anon_sym_nofree] = ACTIONS(745),
    [anon_sym_noimplicitfloat] = ACTIONS(745),
    [anon_sym_noinline] = ACTIONS(745),
    [anon_sym_nomerge] = ACTIONS(745),
    [anon_sym_nonlazybind] = ACTIONS(745),
    [anon_sym_noprofile] = ACTIONS(745),
    [anon_sym_noredzone] = ACTIONS(745),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(745),
    [anon_sym_noreturn] = ACTIONS(745),
    [anon_sym_norecurse] = ACTIONS(745),
    [anon_sym_willreturn] = ACTIONS(745),
    [anon_sym_nosync] = ACTIONS(745),
    [anon_sym_nounwind] = ACTIONS(745),
    [anon_sym_nocallback] = ACTIONS(745),
    [anon_sym_nosanitize_coverage] = ACTIONS(745),
    [anon_sym_null_pointer_is_valid] = ACTIONS(745),
    [anon_sym_optforfuzzing] = ACTIONS(745),
    [anon_sym_optnone] = ACTIONS(745),
    [anon_sym_optsize] = ACTIONS(745),
    [anon_sym_readnone] = ACTIONS(745),
    [anon_sym_readonly] = ACTIONS(745),
    [anon_sym_writeonly] = ACTIONS(745),
    [anon_sym_argmemonly] = ACTIONS(745),
    [anon_sym_returns_twice] = ACTIONS(745),
    [anon_sym_safestack] = ACTIONS(745),
    [anon_sym_sanitize_address] = ACTIONS(745),
    [anon_sym_sanitize_memory] = ACTIONS(745),
    [anon_sym_sanitize_thread] = ACTIONS(745),
    [anon_sym_sanitize_hwaddress] = ACTIONS(745),
    [anon_sym_sanitize_memtag] = ACTIONS(745),
    [anon_sym_speculative_load_hardening] = ACTIONS(745),
    [anon_sym_speculatable] = ACTIONS(745),
    [anon_sym_ssp] = ACTIONS(745),
    [anon_sym_sspstrong] = ACTIONS(745),
    [anon_sym_sspreq] = ACTIONS(745),
    [anon_sym_strictfp] = ACTIONS(745),
    [anon_sym_nocf_check] = ACTIONS(745),
    [anon_sym_shadowcallstack] = ACTIONS(745),
    [anon_sym_mustprogress] = ACTIONS(745),
    [anon_sym_vscale_range] = ACTIONS(745),
    [anon_sym_preallocated] = ACTIONS(745),
    [anon_sym_zeroext] = ACTIONS(745),
    [anon_sym_signext] = ACTIONS(745),
    [anon_sym_inreg] = ACTIONS(745),
    [anon_sym_byval] = ACTIONS(745),
    [anon_sym_byref] = ACTIONS(745),
    [anon_sym_inalloca] = ACTIONS(745),
    [anon_sym_sret] = ACTIONS(745),
    [anon_sym_elementtype] = ACTIONS(745),
    [anon_sym_noalias] = ACTIONS(745),
    [anon_sym_nocapture] = ACTIONS(745),
    [anon_sym_nest] = ACTIONS(745),
    [anon_sym_returned] = ACTIONS(745),
    [anon_sym_nonnull] = ACTIONS(745),
    [anon_sym_dereferenceable] = ACTIONS(745),
    [anon_sym_dereferenceable_or_null] = ACTIONS(745),
    [anon_sym_swiftself] = ACTIONS(745),
    [anon_sym_swiftasync] = ACTIONS(745),
    [anon_sym_swifterror] = ACTIONS(745),
    [anon_sym_immarg] = ACTIONS(745),
    [anon_sym_noundef] = ACTIONS(745),
    [anon_sym_uwtable] = ACTIONS(747),
    [anon_sym_memory] = ACTIONS(749),
    [anon_sym_unreachable] = ACTIONS(775),
    [anon_sym_ret] = ACTIONS(775),
    [anon_sym_br] = ACTIONS(775),
    [anon_sym_resume] = ACTIONS(775),
    [anon_sym_freeze] = ACTIONS(775),
    [anon_sym_indirectbr] = ACTIONS(775),
    [anon_sym_extractelement] = ACTIONS(775),
    [anon_sym_insertelement] = ACTIONS(775),
    [anon_sym_select] = ACTIONS(775),
    [anon_sym_shufflevector] = ACTIONS(775),
    [anon_sym_fneg] = ACTIONS(775),
    [anon_sym_switch] = ACTIONS(775),
    [anon_sym_invoke] = ACTIONS(775),
    [anon_sym_cleanupret] = ACTIONS(775),
    [anon_sym_catchret] = ACTIONS(775),
    [anon_sym_catchswitch] = ACTIONS(775),
    [anon_sym_catchpad] = ACTIONS(775),
    [anon_sym_cleanuppad] = ACTIONS(775),
    [anon_sym_callbr] = ACTIONS(775),
    [anon_sym_icmp] = ACTIONS(775),
    [anon_sym_fcmp] = ACTIONS(775),
    [anon_sym_va_arg] = ACTIONS(775),
    [anon_sym_phi] = ACTIONS(775),
    [anon_sym_landingpad] = ACTIONS(775),
    [anon_sym_tail] = ACTIONS(775),
    [anon_sym_musttail] = ACTIONS(775),
    [anon_sym_notail] = ACTIONS(775),
    [anon_sym_call] = ACTIONS(775),
    [anon_sym_alloca] = ACTIONS(775),
    [anon_sym_load] = ACTIONS(775),
    [anon_sym_store] = ACTIONS(775),
    [anon_sym_cmpxchg] = ACTIONS(775),
    [anon_sym_atomicrmw] = ACTIONS(775),
    [anon_sym_fence] = ACTIONS(775),
    [anon_sym_getelementptr] = ACTIONS(775),
    [anon_sym_extractvalue] = ACTIONS(775),
    [anon_sym_insertvalue] = ACTIONS(775),
    [anon_sym_mul] = ACTIONS(775),
    [anon_sym_urem] = ACTIONS(775),
    [anon_sym_srem] = ACTIONS(775),
    [anon_sym_shl] = ACTIONS(775),
    [anon_sym_udiv] = ACTIONS(775),
    [anon_sym_sdiv] = ACTIONS(775),
    [anon_sym_lshr] = ACTIONS(775),
    [anon_sym_ashr] = ACTIONS(775),
    [anon_sym_fmul] = ACTIONS(775),
    [anon_sym_fdiv] = ACTIONS(775),
    [anon_sym_frem] = ACTIONS(775),
    [anon_sym_xchg] = ACTIONS(775),
    [anon_sym_add] = ACTIONS(775),
    [anon_sym_sub] = ACTIONS(775),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_nand] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_xor] = ACTIONS(775),
    [anon_sym_max] = ACTIONS(775),
    [anon_sym_min] = ACTIONS(775),
    [anon_sym_umax] = ACTIONS(775),
    [anon_sym_umin] = ACTIONS(775),
    [anon_sym_fadd] = ACTIONS(775),
    [anon_sym_fsub] = ACTIONS(775),
    [anon_sym_bitcast] = ACTIONS(775),
    [anon_sym_trunc] = ACTIONS(775),
    [anon_sym_zext] = ACTIONS(775),
    [anon_sym_sext] = ACTIONS(775),
    [anon_sym_fptrunc] = ACTIONS(775),
    [anon_sym_fpext] = ACTIONS(775),
    [anon_sym_addrspacecast] = ACTIONS(775),
    [anon_sym_uitofp] = ACTIONS(775),
    [anon_sym_sitofp] = ACTIONS(775),
    [anon_sym_fptoui] = ACTIONS(775),
    [anon_sym_fptosi] = ACTIONS(775),
    [anon_sym_inttoptr] = ACTIONS(775),
    [anon_sym_ptrtoint] = ACTIONS(775),
    [anon_sym_uselistorder] = ACTIONS(775),
  },
  [196] = {
    [sym_attribute] = STATE(198),
    [sym_attribute_name] = STATE(209),
    [sym_uwtable] = STATE(211),
    [sym_memory_attribute] = STATE(211),
    [sym_operand_bundles] = STATE(687),
    [sym_alignment] = STATE(214),
    [aux_sym_function_header_repeat3] = STATE(198),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(729),
    [sym_local_var] = ACTIONS(777),
    [sym_label] = ACTIONS(777),
    [sym_string] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(735),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_align] = ACTIONS(737),
    [anon_sym_section] = ACTIONS(739),
    [anon_sym_partition] = ACTIONS(739),
    [anon_sym_comdat] = ACTIONS(741),
    [anon_sym_gc] = ACTIONS(739),
    [anon_sym_prefix] = ACTIONS(743),
    [anon_sym_prologue] = ACTIONS(743),
    [anon_sym_personality] = ACTIONS(743),
    [anon_sym_alignstack] = ACTIONS(745),
    [anon_sym_allocsize] = ACTIONS(745),
    [anon_sym_alwaysinline] = ACTIONS(745),
    [anon_sym_builtin] = ACTIONS(745),
    [anon_sym_cold] = ACTIONS(745),
    [anon_sym_convergent] = ACTIONS(745),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(745),
    [anon_sym_hot] = ACTIONS(745),
    [anon_sym_inaccessiblememonly] = ACTIONS(745),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(745),
    [anon_sym_inlinehint] = ACTIONS(745),
    [anon_sym_jumptable] = ACTIONS(745),
    [anon_sym_minsize] = ACTIONS(745),
    [anon_sym_naked] = ACTIONS(745),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(745),
    [anon_sym_nobuiltin] = ACTIONS(745),
    [anon_sym_noduplicate] = ACTIONS(745),
    [anon_sym_nofree] = ACTIONS(745),
    [anon_sym_noimplicitfloat] = ACTIONS(745),
    [anon_sym_noinline] = ACTIONS(745),
    [anon_sym_nomerge] = ACTIONS(745),
    [anon_sym_nonlazybind] = ACTIONS(745),
    [anon_sym_noprofile] = ACTIONS(745),
    [anon_sym_noredzone] = ACTIONS(745),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(745),
    [anon_sym_noreturn] = ACTIONS(745),
    [anon_sym_norecurse] = ACTIONS(745),
    [anon_sym_willreturn] = ACTIONS(745),
    [anon_sym_nosync] = ACTIONS(745),
    [anon_sym_nounwind] = ACTIONS(745),
    [anon_sym_nocallback] = ACTIONS(745),
    [anon_sym_nosanitize_coverage] = ACTIONS(745),
    [anon_sym_null_pointer_is_valid] = ACTIONS(745),
    [anon_sym_optforfuzzing] = ACTIONS(745),
    [anon_sym_optnone] = ACTIONS(745),
    [anon_sym_optsize] = ACTIONS(745),
    [anon_sym_readnone] = ACTIONS(745),
    [anon_sym_readonly] = ACTIONS(745),
    [anon_sym_writeonly] = ACTIONS(745),
    [anon_sym_argmemonly] = ACTIONS(745),
    [anon_sym_returns_twice] = ACTIONS(745),
    [anon_sym_safestack] = ACTIONS(745),
    [anon_sym_sanitize_address] = ACTIONS(745),
    [anon_sym_sanitize_memory] = ACTIONS(745),
    [anon_sym_sanitize_thread] = ACTIONS(745),
    [anon_sym_sanitize_hwaddress] = ACTIONS(745),
    [anon_sym_sanitize_memtag] = ACTIONS(745),
    [anon_sym_speculative_load_hardening] = ACTIONS(745),
    [anon_sym_speculatable] = ACTIONS(745),
    [anon_sym_ssp] = ACTIONS(745),
    [anon_sym_sspstrong] = ACTIONS(745),
    [anon_sym_sspreq] = ACTIONS(745),
    [anon_sym_strictfp] = ACTIONS(745),
    [anon_sym_nocf_check] = ACTIONS(745),
    [anon_sym_shadowcallstack] = ACTIONS(745),
    [anon_sym_mustprogress] = ACTIONS(745),
    [anon_sym_vscale_range] = ACTIONS(745),
    [anon_sym_preallocated] = ACTIONS(745),
    [anon_sym_zeroext] = ACTIONS(745),
    [anon_sym_signext] = ACTIONS(745),
    [anon_sym_inreg] = ACTIONS(745),
    [anon_sym_byval] = ACTIONS(745),
    [anon_sym_byref] = ACTIONS(745),
    [anon_sym_inalloca] = ACTIONS(745),
    [anon_sym_sret] = ACTIONS(745),
    [anon_sym_elementtype] = ACTIONS(745),
    [anon_sym_noalias] = ACTIONS(745),
    [anon_sym_nocapture] = ACTIONS(745),
    [anon_sym_nest] = ACTIONS(745),
    [anon_sym_returned] = ACTIONS(745),
    [anon_sym_nonnull] = ACTIONS(745),
    [anon_sym_dereferenceable] = ACTIONS(745),
    [anon_sym_dereferenceable_or_null] = ACTIONS(745),
    [anon_sym_swiftself] = ACTIONS(745),
    [anon_sym_swiftasync] = ACTIONS(745),
    [anon_sym_swifterror] = ACTIONS(745),
    [anon_sym_immarg] = ACTIONS(745),
    [anon_sym_noundef] = ACTIONS(745),
    [anon_sym_uwtable] = ACTIONS(747),
    [anon_sym_memory] = ACTIONS(749),
    [anon_sym_unreachable] = ACTIONS(779),
    [anon_sym_ret] = ACTIONS(779),
    [anon_sym_br] = ACTIONS(779),
    [anon_sym_resume] = ACTIONS(779),
    [anon_sym_freeze] = ACTIONS(779),
    [anon_sym_indirectbr] = ACTIONS(779),
    [anon_sym_extractelement] = ACTIONS(779),
    [anon_sym_insertelement] = ACTIONS(779),
    [anon_sym_select] = ACTIONS(779),
    [anon_sym_shufflevector] = ACTIONS(779),
    [anon_sym_fneg] = ACTIONS(779),
    [anon_sym_switch] = ACTIONS(779),
    [anon_sym_invoke] = ACTIONS(779),
    [anon_sym_cleanupret] = ACTIONS(779),
    [anon_sym_catchret] = ACTIONS(779),
    [anon_sym_catchswitch] = ACTIONS(779),
    [anon_sym_catchpad] = ACTIONS(779),
    [anon_sym_cleanuppad] = ACTIONS(779),
    [anon_sym_callbr] = ACTIONS(779),
    [anon_sym_icmp] = ACTIONS(779),
    [anon_sym_fcmp] = ACTIONS(779),
    [anon_sym_va_arg] = ACTIONS(779),
    [anon_sym_phi] = ACTIONS(779),
    [anon_sym_landingpad] = ACTIONS(779),
    [anon_sym_tail] = ACTIONS(779),
    [anon_sym_musttail] = ACTIONS(779),
    [anon_sym_notail] = ACTIONS(779),
    [anon_sym_call] = ACTIONS(779),
    [anon_sym_alloca] = ACTIONS(779),
    [anon_sym_load] = ACTIONS(779),
    [anon_sym_store] = ACTIONS(779),
    [anon_sym_cmpxchg] = ACTIONS(779),
    [anon_sym_atomicrmw] = ACTIONS(779),
    [anon_sym_fence] = ACTIONS(779),
    [anon_sym_getelementptr] = ACTIONS(779),
    [anon_sym_extractvalue] = ACTIONS(779),
    [anon_sym_insertvalue] = ACTIONS(779),
    [anon_sym_mul] = ACTIONS(779),
    [anon_sym_urem] = ACTIONS(779),
    [anon_sym_srem] = ACTIONS(779),
    [anon_sym_shl] = ACTIONS(779),
    [anon_sym_udiv] = ACTIONS(779),
    [anon_sym_sdiv] = ACTIONS(779),
    [anon_sym_lshr] = ACTIONS(779),
    [anon_sym_ashr] = ACTIONS(779),
    [anon_sym_fmul] = ACTIONS(779),
    [anon_sym_fdiv] = ACTIONS(779),
    [anon_sym_frem] = ACTIONS(779),
    [anon_sym_xchg] = ACTIONS(779),
    [anon_sym_add] = ACTIONS(779),
    [anon_sym_sub] = ACTIONS(779),
    [anon_sym_and] = ACTIONS(779),
    [anon_sym_nand] = ACTIONS(779),
    [anon_sym_or] = ACTIONS(779),
    [anon_sym_xor] = ACTIONS(779),
    [anon_sym_max] = ACTIONS(779),
    [anon_sym_min] = ACTIONS(779),
    [anon_sym_umax] = ACTIONS(779),
    [anon_sym_umin] = ACTIONS(779),
    [anon_sym_fadd] = ACTIONS(779),
    [anon_sym_fsub] = ACTIONS(779),
    [anon_sym_bitcast] = ACTIONS(779),
    [anon_sym_trunc] = ACTIONS(779),
    [anon_sym_zext] = ACTIONS(779),
    [anon_sym_sext] = ACTIONS(779),
    [anon_sym_fptrunc] = ACTIONS(779),
    [anon_sym_fpext] = ACTIONS(779),
    [anon_sym_addrspacecast] = ACTIONS(779),
    [anon_sym_uitofp] = ACTIONS(779),
    [anon_sym_sitofp] = ACTIONS(779),
    [anon_sym_fptoui] = ACTIONS(779),
    [anon_sym_fptosi] = ACTIONS(779),
    [anon_sym_inttoptr] = ACTIONS(779),
    [anon_sym_ptrtoint] = ACTIONS(779),
    [anon_sym_uselistorder] = ACTIONS(779),
  },
  [197] = {
    [sym_metadata_name] = STATE(747),
    [sym_metadata_attachment] = STATE(188),
    [sym_function_header] = STATE(1136),
    [sym_linkage] = STATE(205),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_calling_conv] = STATE(399),
    [sym_unnamed_addr] = STATE(1060),
    [sym_type] = STATE(1659),
    [sym_type_keyword] = STATE(769),
    [sym_struct_type] = STATE(769),
    [sym_packed_struct_type] = STATE(769),
    [sym_array_type] = STATE(769),
    [sym_vector_type] = STATE(769),
    [sym_param_or_return_attrs] = STATE(394),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [aux_sym_declare_repeat1] = STATE(188),
    [aux_sym_function_header_repeat1] = STATE(205),
    [aux_sym_function_header_repeat2] = STATE(394),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(717),
    [aux_sym_metadata_ref_token1] = ACTIONS(719),
    [sym_string] = ACTIONS(721),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_ccc] = ACTIONS(721),
    [anon_sym_fastcc] = ACTIONS(721),
    [anon_sym_coldcc] = ACTIONS(721),
    [anon_sym_webkit_jscc] = ACTIONS(723),
    [anon_sym_anyregcc] = ACTIONS(721),
    [anon_sym_preserve_mostcc] = ACTIONS(721),
    [anon_sym_preserve_allcc] = ACTIONS(721),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(723),
    [anon_sym_tailcc] = ACTIONS(721),
    [anon_sym_swiftcc] = ACTIONS(723),
    [anon_sym_swifttailcc] = ACTIONS(723),
    [anon_sym_cfguard_checkcc] = ACTIONS(721),
    [aux_sym_calling_conv_token1] = ACTIONS(723),
    [aux_sym_calling_conv_token2] = ACTIONS(721),
    [aux_sym_calling_conv_token3] = ACTIONS(721),
    [aux_sym_calling_conv_token4] = ACTIONS(721),
    [aux_sym_calling_conv_token5] = ACTIONS(721),
    [aux_sym_calling_conv_token6] = ACTIONS(721),
    [aux_sym_calling_conv_token7] = ACTIONS(721),
    [aux_sym_calling_conv_token8] = ACTIONS(721),
    [aux_sym_calling_conv_token9] = ACTIONS(721),
    [aux_sym_calling_conv_token10] = ACTIONS(723),
    [anon_sym_ghccc] = ACTIONS(721),
    [aux_sym_calling_conv_token11] = ACTIONS(723),
    [aux_sym_calling_conv_token12] = ACTIONS(721),
    [aux_sym_calling_conv_token13] = ACTIONS(723),
    [aux_sym_calling_conv_token14] = ACTIONS(721),
    [anon_sym_cc] = ACTIONS(725),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(442),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(442),
    [anon_sym_x86_amx] = ACTIONS(442),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(458),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(458),
    [anon_sym_swiftasync] = ACTIONS(458),
    [anon_sym_swifterror] = ACTIONS(458),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [198] = {
    [sym_attribute] = STATE(198),
    [sym_attribute_name] = STATE(209),
    [sym_uwtable] = STATE(211),
    [sym_memory_attribute] = STATE(211),
    [sym_alignment] = STATE(214),
    [aux_sym_function_header_repeat3] = STATE(198),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(781),
    [sym_local_var] = ACTIONS(784),
    [sym_label] = ACTIONS(784),
    [sym_string] = ACTIONS(786),
    [anon_sym_RBRACE] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(784),
    [anon_sym_COMMA] = ACTIONS(784),
    [anon_sym_align] = ACTIONS(789),
    [anon_sym_section] = ACTIONS(792),
    [anon_sym_partition] = ACTIONS(792),
    [anon_sym_comdat] = ACTIONS(795),
    [anon_sym_gc] = ACTIONS(792),
    [anon_sym_prefix] = ACTIONS(798),
    [anon_sym_prologue] = ACTIONS(798),
    [anon_sym_personality] = ACTIONS(798),
    [anon_sym_alignstack] = ACTIONS(801),
    [anon_sym_allocsize] = ACTIONS(801),
    [anon_sym_alwaysinline] = ACTIONS(801),
    [anon_sym_builtin] = ACTIONS(801),
    [anon_sym_cold] = ACTIONS(801),
    [anon_sym_convergent] = ACTIONS(801),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(801),
    [anon_sym_hot] = ACTIONS(801),
    [anon_sym_inaccessiblememonly] = ACTIONS(801),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(801),
    [anon_sym_inlinehint] = ACTIONS(801),
    [anon_sym_jumptable] = ACTIONS(801),
    [anon_sym_minsize] = ACTIONS(801),
    [anon_sym_naked] = ACTIONS(801),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(801),
    [anon_sym_nobuiltin] = ACTIONS(801),
    [anon_sym_noduplicate] = ACTIONS(801),
    [anon_sym_nofree] = ACTIONS(801),
    [anon_sym_noimplicitfloat] = ACTIONS(801),
    [anon_sym_noinline] = ACTIONS(801),
    [anon_sym_nomerge] = ACTIONS(801),
    [anon_sym_nonlazybind] = ACTIONS(801),
    [anon_sym_noprofile] = ACTIONS(801),
    [anon_sym_noredzone] = ACTIONS(801),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(801),
    [anon_sym_noreturn] = ACTIONS(801),
    [anon_sym_norecurse] = ACTIONS(801),
    [anon_sym_willreturn] = ACTIONS(801),
    [anon_sym_nosync] = ACTIONS(801),
    [anon_sym_nounwind] = ACTIONS(801),
    [anon_sym_nocallback] = ACTIONS(801),
    [anon_sym_nosanitize_coverage] = ACTIONS(801),
    [anon_sym_null_pointer_is_valid] = ACTIONS(801),
    [anon_sym_optforfuzzing] = ACTIONS(801),
    [anon_sym_optnone] = ACTIONS(801),
    [anon_sym_optsize] = ACTIONS(801),
    [anon_sym_readnone] = ACTIONS(801),
    [anon_sym_readonly] = ACTIONS(801),
    [anon_sym_writeonly] = ACTIONS(801),
    [anon_sym_argmemonly] = ACTIONS(801),
    [anon_sym_returns_twice] = ACTIONS(801),
    [anon_sym_safestack] = ACTIONS(801),
    [anon_sym_sanitize_address] = ACTIONS(801),
    [anon_sym_sanitize_memory] = ACTIONS(801),
    [anon_sym_sanitize_thread] = ACTIONS(801),
    [anon_sym_sanitize_hwaddress] = ACTIONS(801),
    [anon_sym_sanitize_memtag] = ACTIONS(801),
    [anon_sym_speculative_load_hardening] = ACTIONS(801),
    [anon_sym_speculatable] = ACTIONS(801),
    [anon_sym_ssp] = ACTIONS(801),
    [anon_sym_sspstrong] = ACTIONS(801),
    [anon_sym_sspreq] = ACTIONS(801),
    [anon_sym_strictfp] = ACTIONS(801),
    [anon_sym_nocf_check] = ACTIONS(801),
    [anon_sym_shadowcallstack] = ACTIONS(801),
    [anon_sym_mustprogress] = ACTIONS(801),
    [anon_sym_vscale_range] = ACTIONS(801),
    [anon_sym_preallocated] = ACTIONS(801),
    [anon_sym_zeroext] = ACTIONS(801),
    [anon_sym_signext] = ACTIONS(801),
    [anon_sym_inreg] = ACTIONS(801),
    [anon_sym_byval] = ACTIONS(801),
    [anon_sym_byref] = ACTIONS(801),
    [anon_sym_inalloca] = ACTIONS(801),
    [anon_sym_sret] = ACTIONS(801),
    [anon_sym_elementtype] = ACTIONS(801),
    [anon_sym_noalias] = ACTIONS(801),
    [anon_sym_nocapture] = ACTIONS(801),
    [anon_sym_nest] = ACTIONS(801),
    [anon_sym_returned] = ACTIONS(801),
    [anon_sym_nonnull] = ACTIONS(801),
    [anon_sym_dereferenceable] = ACTIONS(801),
    [anon_sym_dereferenceable_or_null] = ACTIONS(801),
    [anon_sym_swiftself] = ACTIONS(801),
    [anon_sym_swiftasync] = ACTIONS(801),
    [anon_sym_swifterror] = ACTIONS(801),
    [anon_sym_immarg] = ACTIONS(801),
    [anon_sym_noundef] = ACTIONS(801),
    [anon_sym_uwtable] = ACTIONS(804),
    [anon_sym_memory] = ACTIONS(807),
    [anon_sym_unreachable] = ACTIONS(810),
    [anon_sym_ret] = ACTIONS(810),
    [anon_sym_br] = ACTIONS(810),
    [anon_sym_resume] = ACTIONS(810),
    [anon_sym_freeze] = ACTIONS(810),
    [anon_sym_indirectbr] = ACTIONS(810),
    [anon_sym_extractelement] = ACTIONS(810),
    [anon_sym_insertelement] = ACTIONS(810),
    [anon_sym_select] = ACTIONS(810),
    [anon_sym_shufflevector] = ACTIONS(810),
    [anon_sym_fneg] = ACTIONS(810),
    [anon_sym_switch] = ACTIONS(810),
    [anon_sym_invoke] = ACTIONS(810),
    [anon_sym_cleanupret] = ACTIONS(810),
    [anon_sym_catchret] = ACTIONS(810),
    [anon_sym_catchswitch] = ACTIONS(810),
    [anon_sym_catchpad] = ACTIONS(810),
    [anon_sym_cleanuppad] = ACTIONS(810),
    [anon_sym_callbr] = ACTIONS(810),
    [anon_sym_icmp] = ACTIONS(810),
    [anon_sym_fcmp] = ACTIONS(810),
    [anon_sym_va_arg] = ACTIONS(810),
    [anon_sym_phi] = ACTIONS(810),
    [anon_sym_landingpad] = ACTIONS(810),
    [anon_sym_tail] = ACTIONS(810),
    [anon_sym_musttail] = ACTIONS(810),
    [anon_sym_notail] = ACTIONS(810),
    [anon_sym_call] = ACTIONS(810),
    [anon_sym_alloca] = ACTIONS(810),
    [anon_sym_load] = ACTIONS(810),
    [anon_sym_store] = ACTIONS(810),
    [anon_sym_cmpxchg] = ACTIONS(810),
    [anon_sym_atomicrmw] = ACTIONS(810),
    [anon_sym_fence] = ACTIONS(810),
    [anon_sym_getelementptr] = ACTIONS(810),
    [anon_sym_extractvalue] = ACTIONS(810),
    [anon_sym_insertvalue] = ACTIONS(810),
    [anon_sym_mul] = ACTIONS(810),
    [anon_sym_urem] = ACTIONS(810),
    [anon_sym_srem] = ACTIONS(810),
    [anon_sym_shl] = ACTIONS(810),
    [anon_sym_udiv] = ACTIONS(810),
    [anon_sym_sdiv] = ACTIONS(810),
    [anon_sym_lshr] = ACTIONS(810),
    [anon_sym_ashr] = ACTIONS(810),
    [anon_sym_fmul] = ACTIONS(810),
    [anon_sym_fdiv] = ACTIONS(810),
    [anon_sym_frem] = ACTIONS(810),
    [anon_sym_xchg] = ACTIONS(810),
    [anon_sym_add] = ACTIONS(810),
    [anon_sym_sub] = ACTIONS(810),
    [anon_sym_and] = ACTIONS(810),
    [anon_sym_nand] = ACTIONS(810),
    [anon_sym_or] = ACTIONS(810),
    [anon_sym_xor] = ACTIONS(810),
    [anon_sym_max] = ACTIONS(810),
    [anon_sym_min] = ACTIONS(810),
    [anon_sym_umax] = ACTIONS(810),
    [anon_sym_umin] = ACTIONS(810),
    [anon_sym_fadd] = ACTIONS(810),
    [anon_sym_fsub] = ACTIONS(810),
    [anon_sym_bitcast] = ACTIONS(810),
    [anon_sym_trunc] = ACTIONS(810),
    [anon_sym_zext] = ACTIONS(810),
    [anon_sym_sext] = ACTIONS(810),
    [anon_sym_fptrunc] = ACTIONS(810),
    [anon_sym_fpext] = ACTIONS(810),
    [anon_sym_addrspacecast] = ACTIONS(810),
    [anon_sym_uitofp] = ACTIONS(810),
    [anon_sym_sitofp] = ACTIONS(810),
    [anon_sym_fptoui] = ACTIONS(810),
    [anon_sym_fptosi] = ACTIONS(810),
    [anon_sym_inttoptr] = ACTIONS(810),
    [anon_sym_ptrtoint] = ACTIONS(810),
    [anon_sym_uselistorder] = ACTIONS(810),
  },
  [199] = {
    [sym_number] = STATE(217),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(812),
    [sym_local_var] = ACTIONS(812),
    [sym_label] = ACTIONS(812),
    [sym_string] = ACTIONS(814),
    [aux_sym_number_token1] = ACTIONS(148),
    [aux_sym_number_token2] = ACTIONS(148),
    [anon_sym_EQ] = ACTIONS(812),
    [anon_sym_RBRACE] = ACTIONS(812),
    [anon_sym_LBRACK] = ACTIONS(812),
    [anon_sym_COMMA] = ACTIONS(812),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_align] = ACTIONS(814),
    [anon_sym_section] = ACTIONS(814),
    [anon_sym_partition] = ACTIONS(814),
    [anon_sym_comdat] = ACTIONS(814),
    [anon_sym_gc] = ACTIONS(814),
    [anon_sym_prefix] = ACTIONS(814),
    [anon_sym_prologue] = ACTIONS(814),
    [anon_sym_personality] = ACTIONS(814),
    [anon_sym_alignstack] = ACTIONS(814),
    [anon_sym_allocsize] = ACTIONS(814),
    [anon_sym_alwaysinline] = ACTIONS(814),
    [anon_sym_builtin] = ACTIONS(814),
    [anon_sym_cold] = ACTIONS(814),
    [anon_sym_convergent] = ACTIONS(814),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(814),
    [anon_sym_hot] = ACTIONS(814),
    [anon_sym_inaccessiblememonly] = ACTIONS(814),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(814),
    [anon_sym_inlinehint] = ACTIONS(814),
    [anon_sym_jumptable] = ACTIONS(814),
    [anon_sym_minsize] = ACTIONS(814),
    [anon_sym_naked] = ACTIONS(814),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(814),
    [anon_sym_nobuiltin] = ACTIONS(814),
    [anon_sym_noduplicate] = ACTIONS(814),
    [anon_sym_nofree] = ACTIONS(814),
    [anon_sym_noimplicitfloat] = ACTIONS(814),
    [anon_sym_noinline] = ACTIONS(814),
    [anon_sym_nomerge] = ACTIONS(814),
    [anon_sym_nonlazybind] = ACTIONS(814),
    [anon_sym_noprofile] = ACTIONS(814),
    [anon_sym_noredzone] = ACTIONS(814),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(814),
    [anon_sym_noreturn] = ACTIONS(814),
    [anon_sym_norecurse] = ACTIONS(814),
    [anon_sym_willreturn] = ACTIONS(814),
    [anon_sym_nosync] = ACTIONS(814),
    [anon_sym_nounwind] = ACTIONS(814),
    [anon_sym_nocallback] = ACTIONS(814),
    [anon_sym_nosanitize_coverage] = ACTIONS(814),
    [anon_sym_null_pointer_is_valid] = ACTIONS(814),
    [anon_sym_optforfuzzing] = ACTIONS(814),
    [anon_sym_optnone] = ACTIONS(814),
    [anon_sym_optsize] = ACTIONS(814),
    [anon_sym_readnone] = ACTIONS(814),
    [anon_sym_readonly] = ACTIONS(814),
    [anon_sym_writeonly] = ACTIONS(814),
    [anon_sym_argmemonly] = ACTIONS(814),
    [anon_sym_returns_twice] = ACTIONS(814),
    [anon_sym_safestack] = ACTIONS(814),
    [anon_sym_sanitize_address] = ACTIONS(814),
    [anon_sym_sanitize_memory] = ACTIONS(814),
    [anon_sym_sanitize_thread] = ACTIONS(814),
    [anon_sym_sanitize_hwaddress] = ACTIONS(814),
    [anon_sym_sanitize_memtag] = ACTIONS(814),
    [anon_sym_speculative_load_hardening] = ACTIONS(814),
    [anon_sym_speculatable] = ACTIONS(814),
    [anon_sym_ssp] = ACTIONS(814),
    [anon_sym_sspstrong] = ACTIONS(814),
    [anon_sym_sspreq] = ACTIONS(814),
    [anon_sym_strictfp] = ACTIONS(814),
    [anon_sym_nocf_check] = ACTIONS(814),
    [anon_sym_shadowcallstack] = ACTIONS(814),
    [anon_sym_mustprogress] = ACTIONS(814),
    [anon_sym_vscale_range] = ACTIONS(814),
    [anon_sym_preallocated] = ACTIONS(814),
    [anon_sym_zeroext] = ACTIONS(814),
    [anon_sym_signext] = ACTIONS(814),
    [anon_sym_inreg] = ACTIONS(814),
    [anon_sym_byval] = ACTIONS(814),
    [anon_sym_byref] = ACTIONS(814),
    [anon_sym_inalloca] = ACTIONS(814),
    [anon_sym_sret] = ACTIONS(814),
    [anon_sym_elementtype] = ACTIONS(814),
    [anon_sym_noalias] = ACTIONS(814),
    [anon_sym_nocapture] = ACTIONS(814),
    [anon_sym_nest] = ACTIONS(814),
    [anon_sym_returned] = ACTIONS(814),
    [anon_sym_nonnull] = ACTIONS(814),
    [anon_sym_dereferenceable] = ACTIONS(814),
    [anon_sym_dereferenceable_or_null] = ACTIONS(814),
    [anon_sym_swiftself] = ACTIONS(814),
    [anon_sym_swiftasync] = ACTIONS(814),
    [anon_sym_swifterror] = ACTIONS(814),
    [anon_sym_immarg] = ACTIONS(814),
    [anon_sym_noundef] = ACTIONS(814),
    [anon_sym_uwtable] = ACTIONS(814),
    [anon_sym_memory] = ACTIONS(814),
    [anon_sym_unreachable] = ACTIONS(814),
    [anon_sym_ret] = ACTIONS(814),
    [anon_sym_br] = ACTIONS(814),
    [anon_sym_resume] = ACTIONS(814),
    [anon_sym_freeze] = ACTIONS(814),
    [anon_sym_indirectbr] = ACTIONS(814),
    [anon_sym_extractelement] = ACTIONS(814),
    [anon_sym_insertelement] = ACTIONS(814),
    [anon_sym_select] = ACTIONS(814),
    [anon_sym_shufflevector] = ACTIONS(814),
    [anon_sym_fneg] = ACTIONS(814),
    [anon_sym_switch] = ACTIONS(814),
    [anon_sym_invoke] = ACTIONS(814),
    [anon_sym_cleanupret] = ACTIONS(814),
    [anon_sym_catchret] = ACTIONS(814),
    [anon_sym_catchswitch] = ACTIONS(814),
    [anon_sym_catchpad] = ACTIONS(814),
    [anon_sym_cleanuppad] = ACTIONS(814),
    [anon_sym_callbr] = ACTIONS(814),
    [anon_sym_icmp] = ACTIONS(814),
    [anon_sym_fcmp] = ACTIONS(814),
    [anon_sym_va_arg] = ACTIONS(814),
    [anon_sym_phi] = ACTIONS(814),
    [anon_sym_landingpad] = ACTIONS(814),
    [anon_sym_tail] = ACTIONS(814),
    [anon_sym_musttail] = ACTIONS(814),
    [anon_sym_notail] = ACTIONS(814),
    [anon_sym_call] = ACTIONS(814),
    [anon_sym_alloca] = ACTIONS(814),
    [anon_sym_load] = ACTIONS(814),
    [anon_sym_store] = ACTIONS(814),
    [anon_sym_cmpxchg] = ACTIONS(814),
    [anon_sym_atomicrmw] = ACTIONS(814),
    [anon_sym_fence] = ACTIONS(814),
    [anon_sym_getelementptr] = ACTIONS(814),
    [anon_sym_extractvalue] = ACTIONS(814),
    [anon_sym_insertvalue] = ACTIONS(814),
    [anon_sym_mul] = ACTIONS(814),
    [anon_sym_urem] = ACTIONS(814),
    [anon_sym_srem] = ACTIONS(814),
    [anon_sym_shl] = ACTIONS(814),
    [anon_sym_udiv] = ACTIONS(814),
    [anon_sym_sdiv] = ACTIONS(814),
    [anon_sym_lshr] = ACTIONS(814),
    [anon_sym_ashr] = ACTIONS(814),
    [anon_sym_fmul] = ACTIONS(814),
    [anon_sym_fdiv] = ACTIONS(814),
    [anon_sym_frem] = ACTIONS(814),
    [anon_sym_xchg] = ACTIONS(814),
    [anon_sym_add] = ACTIONS(814),
    [anon_sym_sub] = ACTIONS(814),
    [anon_sym_and] = ACTIONS(814),
    [anon_sym_nand] = ACTIONS(814),
    [anon_sym_or] = ACTIONS(814),
    [anon_sym_xor] = ACTIONS(814),
    [anon_sym_max] = ACTIONS(814),
    [anon_sym_min] = ACTIONS(814),
    [anon_sym_umax] = ACTIONS(814),
    [anon_sym_umin] = ACTIONS(814),
    [anon_sym_fadd] = ACTIONS(814),
    [anon_sym_fsub] = ACTIONS(814),
    [anon_sym_bitcast] = ACTIONS(814),
    [anon_sym_trunc] = ACTIONS(814),
    [anon_sym_zext] = ACTIONS(814),
    [anon_sym_sext] = ACTIONS(814),
    [anon_sym_fptrunc] = ACTIONS(814),
    [anon_sym_fpext] = ACTIONS(814),
    [anon_sym_addrspacecast] = ACTIONS(814),
    [anon_sym_uitofp] = ACTIONS(814),
    [anon_sym_sitofp] = ACTIONS(814),
    [anon_sym_fptoui] = ACTIONS(814),
    [anon_sym_fptosi] = ACTIONS(814),
    [anon_sym_inttoptr] = ACTIONS(814),
    [anon_sym_ptrtoint] = ACTIONS(814),
    [anon_sym_uselistorder] = ACTIONS(814),
  },
  [200] = {
    [sym_param_or_return_attrs] = STATE(200),
    [sym_attribute_name] = STATE(225),
    [sym_uwtable] = STATE(216),
    [sym_memory_attribute] = STATE(216),
    [aux_sym_function_header_repeat2] = STATE(200),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(816),
    [sym_local_var] = ACTIONS(816),
    [sym_string] = ACTIONS(816),
    [aux_sym_number_token1] = ACTIONS(818),
    [aux_sym_number_token2] = ACTIONS(816),
    [sym_float] = ACTIONS(816),
    [sym_cstring] = ACTIONS(816),
    [anon_sym_no_cfi] = ACTIONS(816),
    [anon_sym_private] = ACTIONS(816),
    [anon_sym_internal] = ACTIONS(816),
    [anon_sym_weak] = ACTIONS(818),
    [anon_sym_weak_odr] = ACTIONS(816),
    [anon_sym_linkonce] = ACTIONS(818),
    [anon_sym_linkonce_odr] = ACTIONS(816),
    [anon_sym_available_externally] = ACTIONS(816),
    [anon_sym_appending] = ACTIONS(816),
    [anon_sym_common] = ACTIONS(816),
    [anon_sym_extern_weak] = ACTIONS(816),
    [anon_sym_external] = ACTIONS(816),
    [anon_sym_dso_local] = ACTIONS(818),
    [anon_sym_dso_local_equivalent] = ACTIONS(816),
    [anon_sym_dso_preemptable] = ACTIONS(816),
    [anon_sym_default] = ACTIONS(816),
    [anon_sym_hidden] = ACTIONS(816),
    [anon_sym_protected] = ACTIONS(816),
    [anon_sym_dllimport] = ACTIONS(816),
    [anon_sym_dllexport] = ACTIONS(816),
    [anon_sym_LBRACE] = ACTIONS(816),
    [anon_sym_LT_LBRACE] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_COMMA] = ACTIONS(816),
    [anon_sym_RPAREN] = ACTIONS(816),
    [anon_sym_align] = ACTIONS(820),
    [anon_sym_alignstack] = ACTIONS(823),
    [anon_sym_allocsize] = ACTIONS(823),
    [anon_sym_alwaysinline] = ACTIONS(823),
    [anon_sym_builtin] = ACTIONS(823),
    [anon_sym_cold] = ACTIONS(823),
    [anon_sym_convergent] = ACTIONS(823),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(823),
    [anon_sym_hot] = ACTIONS(823),
    [anon_sym_inaccessiblememonly] = ACTIONS(823),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(823),
    [anon_sym_inlinehint] = ACTIONS(823),
    [anon_sym_jumptable] = ACTIONS(823),
    [anon_sym_minsize] = ACTIONS(823),
    [anon_sym_naked] = ACTIONS(823),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(823),
    [anon_sym_nobuiltin] = ACTIONS(823),
    [anon_sym_noduplicate] = ACTIONS(823),
    [anon_sym_nofree] = ACTIONS(823),
    [anon_sym_noimplicitfloat] = ACTIONS(823),
    [anon_sym_noinline] = ACTIONS(823),
    [anon_sym_nomerge] = ACTIONS(823),
    [anon_sym_nonlazybind] = ACTIONS(823),
    [anon_sym_noprofile] = ACTIONS(823),
    [anon_sym_noredzone] = ACTIONS(823),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(823),
    [anon_sym_noreturn] = ACTIONS(823),
    [anon_sym_norecurse] = ACTIONS(823),
    [anon_sym_willreturn] = ACTIONS(823),
    [anon_sym_nosync] = ACTIONS(823),
    [anon_sym_nounwind] = ACTIONS(823),
    [anon_sym_nocallback] = ACTIONS(823),
    [anon_sym_nosanitize_coverage] = ACTIONS(823),
    [anon_sym_null_pointer_is_valid] = ACTIONS(823),
    [anon_sym_optforfuzzing] = ACTIONS(823),
    [anon_sym_optnone] = ACTIONS(823),
    [anon_sym_optsize] = ACTIONS(823),
    [anon_sym_readnone] = ACTIONS(823),
    [anon_sym_readonly] = ACTIONS(823),
    [anon_sym_writeonly] = ACTIONS(823),
    [anon_sym_argmemonly] = ACTIONS(823),
    [anon_sym_returns_twice] = ACTIONS(823),
    [anon_sym_safestack] = ACTIONS(823),
    [anon_sym_sanitize_address] = ACTIONS(823),
    [anon_sym_sanitize_memory] = ACTIONS(823),
    [anon_sym_sanitize_thread] = ACTIONS(823),
    [anon_sym_sanitize_hwaddress] = ACTIONS(823),
    [anon_sym_sanitize_memtag] = ACTIONS(823),
    [anon_sym_speculative_load_hardening] = ACTIONS(823),
    [anon_sym_speculatable] = ACTIONS(823),
    [anon_sym_ssp] = ACTIONS(826),
    [anon_sym_sspstrong] = ACTIONS(823),
    [anon_sym_sspreq] = ACTIONS(823),
    [anon_sym_strictfp] = ACTIONS(823),
    [anon_sym_nocf_check] = ACTIONS(823),
    [anon_sym_shadowcallstack] = ACTIONS(823),
    [anon_sym_mustprogress] = ACTIONS(823),
    [anon_sym_vscale_range] = ACTIONS(823),
    [anon_sym_preallocated] = ACTIONS(823),
    [anon_sym_zeroext] = ACTIONS(823),
    [anon_sym_signext] = ACTIONS(823),
    [anon_sym_inreg] = ACTIONS(823),
    [anon_sym_byval] = ACTIONS(823),
    [anon_sym_byref] = ACTIONS(823),
    [anon_sym_inalloca] = ACTIONS(823),
    [anon_sym_sret] = ACTIONS(823),
    [anon_sym_elementtype] = ACTIONS(823),
    [anon_sym_noalias] = ACTIONS(823),
    [anon_sym_nocapture] = ACTIONS(823),
    [anon_sym_nest] = ACTIONS(823),
    [anon_sym_returned] = ACTIONS(823),
    [anon_sym_nonnull] = ACTIONS(823),
    [anon_sym_dereferenceable] = ACTIONS(826),
    [anon_sym_dereferenceable_or_null] = ACTIONS(823),
    [anon_sym_swiftself] = ACTIONS(823),
    [anon_sym_swiftasync] = ACTIONS(823),
    [anon_sym_swifterror] = ACTIONS(823),
    [anon_sym_immarg] = ACTIONS(823),
    [anon_sym_noundef] = ACTIONS(823),
    [anon_sym_uwtable] = ACTIONS(829),
    [anon_sym_memory] = ACTIONS(832),
    [anon_sym_none] = ACTIONS(816),
    [anon_sym_extractelement] = ACTIONS(816),
    [anon_sym_insertelement] = ACTIONS(816),
    [anon_sym_select] = ACTIONS(816),
    [anon_sym_shufflevector] = ACTIONS(816),
    [anon_sym_fneg] = ACTIONS(816),
    [anon_sym_icmp] = ACTIONS(816),
    [anon_sym_fcmp] = ACTIONS(816),
    [anon_sym_getelementptr] = ACTIONS(816),
    [anon_sym_extractvalue] = ACTIONS(816),
    [anon_sym_insertvalue] = ACTIONS(816),
    [anon_sym_true] = ACTIONS(816),
    [anon_sym_false] = ACTIONS(816),
    [anon_sym_null] = ACTIONS(818),
    [anon_sym_undef] = ACTIONS(816),
    [anon_sym_poison] = ACTIONS(816),
    [anon_sym_zeroinitializer] = ACTIONS(816),
    [anon_sym_blockaddress] = ACTIONS(816),
    [anon_sym_mul] = ACTIONS(816),
    [anon_sym_urem] = ACTIONS(816),
    [anon_sym_srem] = ACTIONS(816),
    [anon_sym_shl] = ACTIONS(816),
    [anon_sym_udiv] = ACTIONS(816),
    [anon_sym_sdiv] = ACTIONS(816),
    [anon_sym_lshr] = ACTIONS(816),
    [anon_sym_ashr] = ACTIONS(816),
    [anon_sym_fmul] = ACTIONS(816),
    [anon_sym_fdiv] = ACTIONS(816),
    [anon_sym_frem] = ACTIONS(816),
    [anon_sym_xchg] = ACTIONS(816),
    [anon_sym_add] = ACTIONS(818),
    [anon_sym_sub] = ACTIONS(816),
    [anon_sym_and] = ACTIONS(816),
    [anon_sym_nand] = ACTIONS(816),
    [anon_sym_or] = ACTIONS(816),
    [anon_sym_xor] = ACTIONS(816),
    [anon_sym_max] = ACTIONS(816),
    [anon_sym_min] = ACTIONS(818),
    [anon_sym_umax] = ACTIONS(816),
    [anon_sym_umin] = ACTIONS(816),
    [anon_sym_fadd] = ACTIONS(816),
    [anon_sym_fsub] = ACTIONS(816),
    [anon_sym_bitcast] = ACTIONS(816),
    [anon_sym_trunc] = ACTIONS(816),
    [anon_sym_zext] = ACTIONS(816),
    [anon_sym_sext] = ACTIONS(816),
    [anon_sym_fptrunc] = ACTIONS(816),
    [anon_sym_fpext] = ACTIONS(816),
    [anon_sym_addrspacecast] = ACTIONS(816),
    [anon_sym_uitofp] = ACTIONS(816),
    [anon_sym_sitofp] = ACTIONS(816),
    [anon_sym_fptoui] = ACTIONS(816),
    [anon_sym_fptosi] = ACTIONS(816),
    [anon_sym_inttoptr] = ACTIONS(816),
    [anon_sym_ptrtoint] = ACTIONS(816),
  },
  [201] = {
    [sym_function_header] = STATE(1182),
    [sym_linkage] = STATE(204),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_calling_conv] = STATE(402),
    [sym_unnamed_addr] = STATE(1042),
    [sym_type] = STATE(1865),
    [sym_type_keyword] = STATE(769),
    [sym_struct_type] = STATE(769),
    [sym_packed_struct_type] = STATE(769),
    [sym_array_type] = STATE(769),
    [sym_vector_type] = STATE(769),
    [sym_param_or_return_attrs] = STATE(400),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [aux_sym_function_header_repeat1] = STATE(204),
    [aux_sym_function_header_repeat2] = STATE(400),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(717),
    [sym_string] = ACTIONS(721),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_ccc] = ACTIONS(721),
    [anon_sym_fastcc] = ACTIONS(721),
    [anon_sym_coldcc] = ACTIONS(721),
    [anon_sym_webkit_jscc] = ACTIONS(723),
    [anon_sym_anyregcc] = ACTIONS(721),
    [anon_sym_preserve_mostcc] = ACTIONS(721),
    [anon_sym_preserve_allcc] = ACTIONS(721),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(723),
    [anon_sym_tailcc] = ACTIONS(721),
    [anon_sym_swiftcc] = ACTIONS(723),
    [anon_sym_swifttailcc] = ACTIONS(723),
    [anon_sym_cfguard_checkcc] = ACTIONS(721),
    [aux_sym_calling_conv_token1] = ACTIONS(723),
    [aux_sym_calling_conv_token2] = ACTIONS(721),
    [aux_sym_calling_conv_token3] = ACTIONS(721),
    [aux_sym_calling_conv_token4] = ACTIONS(721),
    [aux_sym_calling_conv_token5] = ACTIONS(721),
    [aux_sym_calling_conv_token6] = ACTIONS(721),
    [aux_sym_calling_conv_token7] = ACTIONS(721),
    [aux_sym_calling_conv_token8] = ACTIONS(721),
    [aux_sym_calling_conv_token9] = ACTIONS(721),
    [aux_sym_calling_conv_token10] = ACTIONS(723),
    [anon_sym_ghccc] = ACTIONS(721),
    [aux_sym_calling_conv_token11] = ACTIONS(723),
    [aux_sym_calling_conv_token12] = ACTIONS(721),
    [aux_sym_calling_conv_token13] = ACTIONS(723),
    [aux_sym_calling_conv_token14] = ACTIONS(721),
    [anon_sym_cc] = ACTIONS(725),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(442),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(442),
    [anon_sym_x86_amx] = ACTIONS(442),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(458),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(458),
    [anon_sym_swiftasync] = ACTIONS(458),
    [anon_sym_swifterror] = ACTIONS(458),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [202] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(835),
    [sym_local_var] = ACTIONS(835),
    [sym_label] = ACTIONS(835),
    [sym_string] = ACTIONS(837),
    [anon_sym_EQ] = ACTIONS(835),
    [anon_sym_RBRACE] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(835),
    [anon_sym_align] = ACTIONS(837),
    [anon_sym_section] = ACTIONS(837),
    [anon_sym_partition] = ACTIONS(837),
    [anon_sym_comdat] = ACTIONS(837),
    [anon_sym_gc] = ACTIONS(837),
    [anon_sym_prefix] = ACTIONS(837),
    [anon_sym_prologue] = ACTIONS(837),
    [anon_sym_personality] = ACTIONS(837),
    [anon_sym_alignstack] = ACTIONS(837),
    [anon_sym_allocsize] = ACTIONS(837),
    [anon_sym_alwaysinline] = ACTIONS(837),
    [anon_sym_builtin] = ACTIONS(837),
    [anon_sym_cold] = ACTIONS(837),
    [anon_sym_convergent] = ACTIONS(837),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(837),
    [anon_sym_hot] = ACTIONS(837),
    [anon_sym_inaccessiblememonly] = ACTIONS(837),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(837),
    [anon_sym_inlinehint] = ACTIONS(837),
    [anon_sym_jumptable] = ACTIONS(837),
    [anon_sym_minsize] = ACTIONS(837),
    [anon_sym_naked] = ACTIONS(837),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(837),
    [anon_sym_nobuiltin] = ACTIONS(837),
    [anon_sym_noduplicate] = ACTIONS(837),
    [anon_sym_nofree] = ACTIONS(837),
    [anon_sym_noimplicitfloat] = ACTIONS(837),
    [anon_sym_noinline] = ACTIONS(837),
    [anon_sym_nomerge] = ACTIONS(837),
    [anon_sym_nonlazybind] = ACTIONS(837),
    [anon_sym_noprofile] = ACTIONS(837),
    [anon_sym_noredzone] = ACTIONS(837),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(837),
    [anon_sym_noreturn] = ACTIONS(837),
    [anon_sym_norecurse] = ACTIONS(837),
    [anon_sym_willreturn] = ACTIONS(837),
    [anon_sym_nosync] = ACTIONS(837),
    [anon_sym_nounwind] = ACTIONS(837),
    [anon_sym_nocallback] = ACTIONS(837),
    [anon_sym_nosanitize_coverage] = ACTIONS(837),
    [anon_sym_null_pointer_is_valid] = ACTIONS(837),
    [anon_sym_optforfuzzing] = ACTIONS(837),
    [anon_sym_optnone] = ACTIONS(837),
    [anon_sym_optsize] = ACTIONS(837),
    [anon_sym_readnone] = ACTIONS(837),
    [anon_sym_readonly] = ACTIONS(837),
    [anon_sym_writeonly] = ACTIONS(837),
    [anon_sym_argmemonly] = ACTIONS(837),
    [anon_sym_returns_twice] = ACTIONS(837),
    [anon_sym_safestack] = ACTIONS(837),
    [anon_sym_sanitize_address] = ACTIONS(837),
    [anon_sym_sanitize_memory] = ACTIONS(837),
    [anon_sym_sanitize_thread] = ACTIONS(837),
    [anon_sym_sanitize_hwaddress] = ACTIONS(837),
    [anon_sym_sanitize_memtag] = ACTIONS(837),
    [anon_sym_speculative_load_hardening] = ACTIONS(837),
    [anon_sym_speculatable] = ACTIONS(837),
    [anon_sym_ssp] = ACTIONS(837),
    [anon_sym_sspstrong] = ACTIONS(837),
    [anon_sym_sspreq] = ACTIONS(837),
    [anon_sym_strictfp] = ACTIONS(837),
    [anon_sym_nocf_check] = ACTIONS(837),
    [anon_sym_shadowcallstack] = ACTIONS(837),
    [anon_sym_mustprogress] = ACTIONS(837),
    [anon_sym_vscale_range] = ACTIONS(837),
    [anon_sym_preallocated] = ACTIONS(837),
    [anon_sym_zeroext] = ACTIONS(837),
    [anon_sym_signext] = ACTIONS(837),
    [anon_sym_inreg] = ACTIONS(837),
    [anon_sym_byval] = ACTIONS(837),
    [anon_sym_byref] = ACTIONS(837),
    [anon_sym_inalloca] = ACTIONS(837),
    [anon_sym_sret] = ACTIONS(837),
    [anon_sym_elementtype] = ACTIONS(837),
    [anon_sym_noalias] = ACTIONS(837),
    [anon_sym_nocapture] = ACTIONS(837),
    [anon_sym_nest] = ACTIONS(837),
    [anon_sym_returned] = ACTIONS(837),
    [anon_sym_nonnull] = ACTIONS(837),
    [anon_sym_dereferenceable] = ACTIONS(837),
    [anon_sym_dereferenceable_or_null] = ACTIONS(837),
    [anon_sym_swiftself] = ACTIONS(837),
    [anon_sym_swiftasync] = ACTIONS(837),
    [anon_sym_swifterror] = ACTIONS(837),
    [anon_sym_immarg] = ACTIONS(837),
    [anon_sym_noundef] = ACTIONS(837),
    [anon_sym_uwtable] = ACTIONS(837),
    [anon_sym_memory] = ACTIONS(837),
    [anon_sym_unreachable] = ACTIONS(837),
    [anon_sym_ret] = ACTIONS(837),
    [anon_sym_br] = ACTIONS(837),
    [anon_sym_resume] = ACTIONS(837),
    [anon_sym_freeze] = ACTIONS(837),
    [anon_sym_indirectbr] = ACTIONS(837),
    [anon_sym_extractelement] = ACTIONS(837),
    [anon_sym_insertelement] = ACTIONS(837),
    [anon_sym_select] = ACTIONS(837),
    [anon_sym_shufflevector] = ACTIONS(837),
    [anon_sym_fneg] = ACTIONS(837),
    [anon_sym_switch] = ACTIONS(837),
    [anon_sym_invoke] = ACTIONS(837),
    [anon_sym_cleanupret] = ACTIONS(837),
    [anon_sym_catchret] = ACTIONS(837),
    [anon_sym_catchswitch] = ACTIONS(837),
    [anon_sym_catchpad] = ACTIONS(837),
    [anon_sym_cleanuppad] = ACTIONS(837),
    [anon_sym_callbr] = ACTIONS(837),
    [anon_sym_icmp] = ACTIONS(837),
    [anon_sym_fcmp] = ACTIONS(837),
    [anon_sym_va_arg] = ACTIONS(837),
    [anon_sym_phi] = ACTIONS(837),
    [anon_sym_landingpad] = ACTIONS(837),
    [anon_sym_tail] = ACTIONS(837),
    [anon_sym_musttail] = ACTIONS(837),
    [anon_sym_notail] = ACTIONS(837),
    [anon_sym_call] = ACTIONS(837),
    [anon_sym_alloca] = ACTIONS(837),
    [anon_sym_load] = ACTIONS(837),
    [anon_sym_store] = ACTIONS(837),
    [anon_sym_cmpxchg] = ACTIONS(837),
    [anon_sym_atomicrmw] = ACTIONS(837),
    [anon_sym_fence] = ACTIONS(837),
    [anon_sym_getelementptr] = ACTIONS(837),
    [anon_sym_extractvalue] = ACTIONS(837),
    [anon_sym_insertvalue] = ACTIONS(837),
    [anon_sym_mul] = ACTIONS(837),
    [anon_sym_urem] = ACTIONS(837),
    [anon_sym_srem] = ACTIONS(837),
    [anon_sym_shl] = ACTIONS(837),
    [anon_sym_udiv] = ACTIONS(837),
    [anon_sym_sdiv] = ACTIONS(837),
    [anon_sym_lshr] = ACTIONS(837),
    [anon_sym_ashr] = ACTIONS(837),
    [anon_sym_fmul] = ACTIONS(837),
    [anon_sym_fdiv] = ACTIONS(837),
    [anon_sym_frem] = ACTIONS(837),
    [anon_sym_xchg] = ACTIONS(837),
    [anon_sym_add] = ACTIONS(837),
    [anon_sym_sub] = ACTIONS(837),
    [anon_sym_and] = ACTIONS(837),
    [anon_sym_nand] = ACTIONS(837),
    [anon_sym_or] = ACTIONS(837),
    [anon_sym_xor] = ACTIONS(837),
    [anon_sym_max] = ACTIONS(837),
    [anon_sym_min] = ACTIONS(837),
    [anon_sym_umax] = ACTIONS(837),
    [anon_sym_umin] = ACTIONS(837),
    [anon_sym_fadd] = ACTIONS(837),
    [anon_sym_fsub] = ACTIONS(837),
    [anon_sym_bitcast] = ACTIONS(837),
    [anon_sym_trunc] = ACTIONS(837),
    [anon_sym_zext] = ACTIONS(837),
    [anon_sym_sext] = ACTIONS(837),
    [anon_sym_fptrunc] = ACTIONS(837),
    [anon_sym_fpext] = ACTIONS(837),
    [anon_sym_addrspacecast] = ACTIONS(837),
    [anon_sym_uitofp] = ACTIONS(837),
    [anon_sym_sitofp] = ACTIONS(837),
    [anon_sym_fptoui] = ACTIONS(837),
    [anon_sym_fptosi] = ACTIONS(837),
    [anon_sym_inttoptr] = ACTIONS(837),
    [anon_sym_ptrtoint] = ACTIONS(837),
    [anon_sym_uselistorder] = ACTIONS(837),
  },
  [203] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(839),
    [sym_local_var] = ACTIONS(839),
    [sym_label] = ACTIONS(839),
    [sym_string] = ACTIONS(841),
    [anon_sym_EQ] = ACTIONS(839),
    [anon_sym_RBRACE] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(839),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_align] = ACTIONS(841),
    [anon_sym_section] = ACTIONS(841),
    [anon_sym_partition] = ACTIONS(841),
    [anon_sym_comdat] = ACTIONS(841),
    [anon_sym_gc] = ACTIONS(841),
    [anon_sym_prefix] = ACTIONS(841),
    [anon_sym_prologue] = ACTIONS(841),
    [anon_sym_personality] = ACTIONS(841),
    [anon_sym_alignstack] = ACTIONS(841),
    [anon_sym_allocsize] = ACTIONS(841),
    [anon_sym_alwaysinline] = ACTIONS(841),
    [anon_sym_builtin] = ACTIONS(841),
    [anon_sym_cold] = ACTIONS(841),
    [anon_sym_convergent] = ACTIONS(841),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(841),
    [anon_sym_hot] = ACTIONS(841),
    [anon_sym_inaccessiblememonly] = ACTIONS(841),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(841),
    [anon_sym_inlinehint] = ACTIONS(841),
    [anon_sym_jumptable] = ACTIONS(841),
    [anon_sym_minsize] = ACTIONS(841),
    [anon_sym_naked] = ACTIONS(841),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(841),
    [anon_sym_nobuiltin] = ACTIONS(841),
    [anon_sym_noduplicate] = ACTIONS(841),
    [anon_sym_nofree] = ACTIONS(841),
    [anon_sym_noimplicitfloat] = ACTIONS(841),
    [anon_sym_noinline] = ACTIONS(841),
    [anon_sym_nomerge] = ACTIONS(841),
    [anon_sym_nonlazybind] = ACTIONS(841),
    [anon_sym_noprofile] = ACTIONS(841),
    [anon_sym_noredzone] = ACTIONS(841),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(841),
    [anon_sym_noreturn] = ACTIONS(841),
    [anon_sym_norecurse] = ACTIONS(841),
    [anon_sym_willreturn] = ACTIONS(841),
    [anon_sym_nosync] = ACTIONS(841),
    [anon_sym_nounwind] = ACTIONS(841),
    [anon_sym_nocallback] = ACTIONS(841),
    [anon_sym_nosanitize_coverage] = ACTIONS(841),
    [anon_sym_null_pointer_is_valid] = ACTIONS(841),
    [anon_sym_optforfuzzing] = ACTIONS(841),
    [anon_sym_optnone] = ACTIONS(841),
    [anon_sym_optsize] = ACTIONS(841),
    [anon_sym_readnone] = ACTIONS(841),
    [anon_sym_readonly] = ACTIONS(841),
    [anon_sym_writeonly] = ACTIONS(841),
    [anon_sym_argmemonly] = ACTIONS(841),
    [anon_sym_returns_twice] = ACTIONS(841),
    [anon_sym_safestack] = ACTIONS(841),
    [anon_sym_sanitize_address] = ACTIONS(841),
    [anon_sym_sanitize_memory] = ACTIONS(841),
    [anon_sym_sanitize_thread] = ACTIONS(841),
    [anon_sym_sanitize_hwaddress] = ACTIONS(841),
    [anon_sym_sanitize_memtag] = ACTIONS(841),
    [anon_sym_speculative_load_hardening] = ACTIONS(841),
    [anon_sym_speculatable] = ACTIONS(841),
    [anon_sym_ssp] = ACTIONS(841),
    [anon_sym_sspstrong] = ACTIONS(841),
    [anon_sym_sspreq] = ACTIONS(841),
    [anon_sym_strictfp] = ACTIONS(841),
    [anon_sym_nocf_check] = ACTIONS(841),
    [anon_sym_shadowcallstack] = ACTIONS(841),
    [anon_sym_mustprogress] = ACTIONS(841),
    [anon_sym_vscale_range] = ACTIONS(841),
    [anon_sym_preallocated] = ACTIONS(841),
    [anon_sym_zeroext] = ACTIONS(841),
    [anon_sym_signext] = ACTIONS(841),
    [anon_sym_inreg] = ACTIONS(841),
    [anon_sym_byval] = ACTIONS(841),
    [anon_sym_byref] = ACTIONS(841),
    [anon_sym_inalloca] = ACTIONS(841),
    [anon_sym_sret] = ACTIONS(841),
    [anon_sym_elementtype] = ACTIONS(841),
    [anon_sym_noalias] = ACTIONS(841),
    [anon_sym_nocapture] = ACTIONS(841),
    [anon_sym_nest] = ACTIONS(841),
    [anon_sym_returned] = ACTIONS(841),
    [anon_sym_nonnull] = ACTIONS(841),
    [anon_sym_dereferenceable] = ACTIONS(841),
    [anon_sym_dereferenceable_or_null] = ACTIONS(841),
    [anon_sym_swiftself] = ACTIONS(841),
    [anon_sym_swiftasync] = ACTIONS(841),
    [anon_sym_swifterror] = ACTIONS(841),
    [anon_sym_immarg] = ACTIONS(841),
    [anon_sym_noundef] = ACTIONS(841),
    [anon_sym_uwtable] = ACTIONS(841),
    [anon_sym_memory] = ACTIONS(841),
    [anon_sym_unreachable] = ACTIONS(841),
    [anon_sym_ret] = ACTIONS(841),
    [anon_sym_br] = ACTIONS(841),
    [anon_sym_resume] = ACTIONS(841),
    [anon_sym_freeze] = ACTIONS(841),
    [anon_sym_indirectbr] = ACTIONS(841),
    [anon_sym_extractelement] = ACTIONS(841),
    [anon_sym_insertelement] = ACTIONS(841),
    [anon_sym_select] = ACTIONS(841),
    [anon_sym_shufflevector] = ACTIONS(841),
    [anon_sym_fneg] = ACTIONS(841),
    [anon_sym_switch] = ACTIONS(841),
    [anon_sym_invoke] = ACTIONS(841),
    [anon_sym_cleanupret] = ACTIONS(841),
    [anon_sym_catchret] = ACTIONS(841),
    [anon_sym_catchswitch] = ACTIONS(841),
    [anon_sym_catchpad] = ACTIONS(841),
    [anon_sym_cleanuppad] = ACTIONS(841),
    [anon_sym_callbr] = ACTIONS(841),
    [anon_sym_icmp] = ACTIONS(841),
    [anon_sym_fcmp] = ACTIONS(841),
    [anon_sym_va_arg] = ACTIONS(841),
    [anon_sym_phi] = ACTIONS(841),
    [anon_sym_landingpad] = ACTIONS(841),
    [anon_sym_tail] = ACTIONS(841),
    [anon_sym_musttail] = ACTIONS(841),
    [anon_sym_notail] = ACTIONS(841),
    [anon_sym_call] = ACTIONS(841),
    [anon_sym_alloca] = ACTIONS(841),
    [anon_sym_load] = ACTIONS(841),
    [anon_sym_store] = ACTIONS(841),
    [anon_sym_cmpxchg] = ACTIONS(841),
    [anon_sym_atomicrmw] = ACTIONS(841),
    [anon_sym_fence] = ACTIONS(841),
    [anon_sym_getelementptr] = ACTIONS(841),
    [anon_sym_extractvalue] = ACTIONS(841),
    [anon_sym_insertvalue] = ACTIONS(841),
    [anon_sym_mul] = ACTIONS(841),
    [anon_sym_urem] = ACTIONS(841),
    [anon_sym_srem] = ACTIONS(841),
    [anon_sym_shl] = ACTIONS(841),
    [anon_sym_udiv] = ACTIONS(841),
    [anon_sym_sdiv] = ACTIONS(841),
    [anon_sym_lshr] = ACTIONS(841),
    [anon_sym_ashr] = ACTIONS(841),
    [anon_sym_fmul] = ACTIONS(841),
    [anon_sym_fdiv] = ACTIONS(841),
    [anon_sym_frem] = ACTIONS(841),
    [anon_sym_xchg] = ACTIONS(841),
    [anon_sym_add] = ACTIONS(841),
    [anon_sym_sub] = ACTIONS(841),
    [anon_sym_and] = ACTIONS(841),
    [anon_sym_nand] = ACTIONS(841),
    [anon_sym_or] = ACTIONS(841),
    [anon_sym_xor] = ACTIONS(841),
    [anon_sym_max] = ACTIONS(841),
    [anon_sym_min] = ACTIONS(841),
    [anon_sym_umax] = ACTIONS(841),
    [anon_sym_umin] = ACTIONS(841),
    [anon_sym_fadd] = ACTIONS(841),
    [anon_sym_fsub] = ACTIONS(841),
    [anon_sym_bitcast] = ACTIONS(841),
    [anon_sym_trunc] = ACTIONS(841),
    [anon_sym_zext] = ACTIONS(841),
    [anon_sym_sext] = ACTIONS(841),
    [anon_sym_fptrunc] = ACTIONS(841),
    [anon_sym_fpext] = ACTIONS(841),
    [anon_sym_addrspacecast] = ACTIONS(841),
    [anon_sym_uitofp] = ACTIONS(841),
    [anon_sym_sitofp] = ACTIONS(841),
    [anon_sym_fptoui] = ACTIONS(841),
    [anon_sym_fptosi] = ACTIONS(841),
    [anon_sym_inttoptr] = ACTIONS(841),
    [anon_sym_ptrtoint] = ACTIONS(841),
    [anon_sym_uselistorder] = ACTIONS(841),
  },
  [204] = {
    [sym_linkage] = STATE(234),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_calling_conv] = STATE(397),
    [sym_unnamed_addr] = STATE(1045),
    [sym_type] = STATE(1780),
    [sym_type_keyword] = STATE(769),
    [sym_struct_type] = STATE(769),
    [sym_packed_struct_type] = STATE(769),
    [sym_array_type] = STATE(769),
    [sym_vector_type] = STATE(769),
    [sym_param_or_return_attrs] = STATE(396),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [aux_sym_function_header_repeat1] = STATE(234),
    [aux_sym_function_header_repeat2] = STATE(396),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(717),
    [sym_string] = ACTIONS(721),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_ccc] = ACTIONS(721),
    [anon_sym_fastcc] = ACTIONS(721),
    [anon_sym_coldcc] = ACTIONS(721),
    [anon_sym_webkit_jscc] = ACTIONS(723),
    [anon_sym_anyregcc] = ACTIONS(721),
    [anon_sym_preserve_mostcc] = ACTIONS(721),
    [anon_sym_preserve_allcc] = ACTIONS(721),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(723),
    [anon_sym_tailcc] = ACTIONS(721),
    [anon_sym_swiftcc] = ACTIONS(723),
    [anon_sym_swifttailcc] = ACTIONS(723),
    [anon_sym_cfguard_checkcc] = ACTIONS(721),
    [aux_sym_calling_conv_token1] = ACTIONS(723),
    [aux_sym_calling_conv_token2] = ACTIONS(721),
    [aux_sym_calling_conv_token3] = ACTIONS(721),
    [aux_sym_calling_conv_token4] = ACTIONS(721),
    [aux_sym_calling_conv_token5] = ACTIONS(721),
    [aux_sym_calling_conv_token6] = ACTIONS(721),
    [aux_sym_calling_conv_token7] = ACTIONS(721),
    [aux_sym_calling_conv_token8] = ACTIONS(721),
    [aux_sym_calling_conv_token9] = ACTIONS(721),
    [aux_sym_calling_conv_token10] = ACTIONS(723),
    [anon_sym_ghccc] = ACTIONS(721),
    [aux_sym_calling_conv_token11] = ACTIONS(723),
    [aux_sym_calling_conv_token12] = ACTIONS(721),
    [aux_sym_calling_conv_token13] = ACTIONS(723),
    [aux_sym_calling_conv_token14] = ACTIONS(721),
    [anon_sym_cc] = ACTIONS(725),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(442),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(442),
    [anon_sym_x86_amx] = ACTIONS(442),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(458),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(458),
    [anon_sym_swiftasync] = ACTIONS(458),
    [anon_sym_swifterror] = ACTIONS(458),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [205] = {
    [sym_linkage] = STATE(234),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_calling_conv] = STATE(401),
    [sym_unnamed_addr] = STATE(1047),
    [sym_type] = STATE(1775),
    [sym_type_keyword] = STATE(769),
    [sym_struct_type] = STATE(769),
    [sym_packed_struct_type] = STATE(769),
    [sym_array_type] = STATE(769),
    [sym_vector_type] = STATE(769),
    [sym_param_or_return_attrs] = STATE(393),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [aux_sym_function_header_repeat1] = STATE(234),
    [aux_sym_function_header_repeat2] = STATE(393),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(717),
    [sym_string] = ACTIONS(721),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_ccc] = ACTIONS(721),
    [anon_sym_fastcc] = ACTIONS(721),
    [anon_sym_coldcc] = ACTIONS(721),
    [anon_sym_webkit_jscc] = ACTIONS(723),
    [anon_sym_anyregcc] = ACTIONS(721),
    [anon_sym_preserve_mostcc] = ACTIONS(721),
    [anon_sym_preserve_allcc] = ACTIONS(721),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(723),
    [anon_sym_tailcc] = ACTIONS(721),
    [anon_sym_swiftcc] = ACTIONS(723),
    [anon_sym_swifttailcc] = ACTIONS(723),
    [anon_sym_cfguard_checkcc] = ACTIONS(721),
    [aux_sym_calling_conv_token1] = ACTIONS(723),
    [aux_sym_calling_conv_token2] = ACTIONS(721),
    [aux_sym_calling_conv_token3] = ACTIONS(721),
    [aux_sym_calling_conv_token4] = ACTIONS(721),
    [aux_sym_calling_conv_token5] = ACTIONS(721),
    [aux_sym_calling_conv_token6] = ACTIONS(721),
    [aux_sym_calling_conv_token7] = ACTIONS(721),
    [aux_sym_calling_conv_token8] = ACTIONS(721),
    [aux_sym_calling_conv_token9] = ACTIONS(721),
    [aux_sym_calling_conv_token10] = ACTIONS(723),
    [anon_sym_ghccc] = ACTIONS(721),
    [aux_sym_calling_conv_token11] = ACTIONS(723),
    [aux_sym_calling_conv_token12] = ACTIONS(721),
    [aux_sym_calling_conv_token13] = ACTIONS(723),
    [aux_sym_calling_conv_token14] = ACTIONS(721),
    [anon_sym_cc] = ACTIONS(725),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(442),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(442),
    [anon_sym_x86_amx] = ACTIONS(442),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(458),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(458),
    [anon_sym_swiftasync] = ACTIONS(458),
    [anon_sym_swifterror] = ACTIONS(458),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [206] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(843),
    [sym_local_var] = ACTIONS(843),
    [sym_label] = ACTIONS(843),
    [sym_string] = ACTIONS(845),
    [anon_sym_EQ] = ACTIONS(843),
    [anon_sym_RBRACE] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_align] = ACTIONS(845),
    [anon_sym_section] = ACTIONS(845),
    [anon_sym_partition] = ACTIONS(845),
    [anon_sym_comdat] = ACTIONS(845),
    [anon_sym_gc] = ACTIONS(845),
    [anon_sym_prefix] = ACTIONS(845),
    [anon_sym_prologue] = ACTIONS(845),
    [anon_sym_personality] = ACTIONS(845),
    [anon_sym_alignstack] = ACTIONS(845),
    [anon_sym_allocsize] = ACTIONS(845),
    [anon_sym_alwaysinline] = ACTIONS(845),
    [anon_sym_builtin] = ACTIONS(845),
    [anon_sym_cold] = ACTIONS(845),
    [anon_sym_convergent] = ACTIONS(845),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(845),
    [anon_sym_hot] = ACTIONS(845),
    [anon_sym_inaccessiblememonly] = ACTIONS(845),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(845),
    [anon_sym_inlinehint] = ACTIONS(845),
    [anon_sym_jumptable] = ACTIONS(845),
    [anon_sym_minsize] = ACTIONS(845),
    [anon_sym_naked] = ACTIONS(845),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(845),
    [anon_sym_nobuiltin] = ACTIONS(845),
    [anon_sym_noduplicate] = ACTIONS(845),
    [anon_sym_nofree] = ACTIONS(845),
    [anon_sym_noimplicitfloat] = ACTIONS(845),
    [anon_sym_noinline] = ACTIONS(845),
    [anon_sym_nomerge] = ACTIONS(845),
    [anon_sym_nonlazybind] = ACTIONS(845),
    [anon_sym_noprofile] = ACTIONS(845),
    [anon_sym_noredzone] = ACTIONS(845),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(845),
    [anon_sym_noreturn] = ACTIONS(845),
    [anon_sym_norecurse] = ACTIONS(845),
    [anon_sym_willreturn] = ACTIONS(845),
    [anon_sym_nosync] = ACTIONS(845),
    [anon_sym_nounwind] = ACTIONS(845),
    [anon_sym_nocallback] = ACTIONS(845),
    [anon_sym_nosanitize_coverage] = ACTIONS(845),
    [anon_sym_null_pointer_is_valid] = ACTIONS(845),
    [anon_sym_optforfuzzing] = ACTIONS(845),
    [anon_sym_optnone] = ACTIONS(845),
    [anon_sym_optsize] = ACTIONS(845),
    [anon_sym_readnone] = ACTIONS(845),
    [anon_sym_readonly] = ACTIONS(845),
    [anon_sym_writeonly] = ACTIONS(845),
    [anon_sym_argmemonly] = ACTIONS(845),
    [anon_sym_returns_twice] = ACTIONS(845),
    [anon_sym_safestack] = ACTIONS(845),
    [anon_sym_sanitize_address] = ACTIONS(845),
    [anon_sym_sanitize_memory] = ACTIONS(845),
    [anon_sym_sanitize_thread] = ACTIONS(845),
    [anon_sym_sanitize_hwaddress] = ACTIONS(845),
    [anon_sym_sanitize_memtag] = ACTIONS(845),
    [anon_sym_speculative_load_hardening] = ACTIONS(845),
    [anon_sym_speculatable] = ACTIONS(845),
    [anon_sym_ssp] = ACTIONS(845),
    [anon_sym_sspstrong] = ACTIONS(845),
    [anon_sym_sspreq] = ACTIONS(845),
    [anon_sym_strictfp] = ACTIONS(845),
    [anon_sym_nocf_check] = ACTIONS(845),
    [anon_sym_shadowcallstack] = ACTIONS(845),
    [anon_sym_mustprogress] = ACTIONS(845),
    [anon_sym_vscale_range] = ACTIONS(845),
    [anon_sym_preallocated] = ACTIONS(845),
    [anon_sym_zeroext] = ACTIONS(845),
    [anon_sym_signext] = ACTIONS(845),
    [anon_sym_inreg] = ACTIONS(845),
    [anon_sym_byval] = ACTIONS(845),
    [anon_sym_byref] = ACTIONS(845),
    [anon_sym_inalloca] = ACTIONS(845),
    [anon_sym_sret] = ACTIONS(845),
    [anon_sym_elementtype] = ACTIONS(845),
    [anon_sym_noalias] = ACTIONS(845),
    [anon_sym_nocapture] = ACTIONS(845),
    [anon_sym_nest] = ACTIONS(845),
    [anon_sym_returned] = ACTIONS(845),
    [anon_sym_nonnull] = ACTIONS(845),
    [anon_sym_dereferenceable] = ACTIONS(845),
    [anon_sym_dereferenceable_or_null] = ACTIONS(845),
    [anon_sym_swiftself] = ACTIONS(845),
    [anon_sym_swiftasync] = ACTIONS(845),
    [anon_sym_swifterror] = ACTIONS(845),
    [anon_sym_immarg] = ACTIONS(845),
    [anon_sym_noundef] = ACTIONS(845),
    [anon_sym_uwtable] = ACTIONS(845),
    [anon_sym_memory] = ACTIONS(845),
    [anon_sym_unreachable] = ACTIONS(845),
    [anon_sym_ret] = ACTIONS(845),
    [anon_sym_br] = ACTIONS(845),
    [anon_sym_resume] = ACTIONS(845),
    [anon_sym_freeze] = ACTIONS(845),
    [anon_sym_indirectbr] = ACTIONS(845),
    [anon_sym_extractelement] = ACTIONS(845),
    [anon_sym_insertelement] = ACTIONS(845),
    [anon_sym_select] = ACTIONS(845),
    [anon_sym_shufflevector] = ACTIONS(845),
    [anon_sym_fneg] = ACTIONS(845),
    [anon_sym_switch] = ACTIONS(845),
    [anon_sym_invoke] = ACTIONS(845),
    [anon_sym_cleanupret] = ACTIONS(845),
    [anon_sym_catchret] = ACTIONS(845),
    [anon_sym_catchswitch] = ACTIONS(845),
    [anon_sym_catchpad] = ACTIONS(845),
    [anon_sym_cleanuppad] = ACTIONS(845),
    [anon_sym_callbr] = ACTIONS(845),
    [anon_sym_icmp] = ACTIONS(845),
    [anon_sym_fcmp] = ACTIONS(845),
    [anon_sym_va_arg] = ACTIONS(845),
    [anon_sym_phi] = ACTIONS(845),
    [anon_sym_landingpad] = ACTIONS(845),
    [anon_sym_tail] = ACTIONS(845),
    [anon_sym_musttail] = ACTIONS(845),
    [anon_sym_notail] = ACTIONS(845),
    [anon_sym_call] = ACTIONS(845),
    [anon_sym_alloca] = ACTIONS(845),
    [anon_sym_load] = ACTIONS(845),
    [anon_sym_store] = ACTIONS(845),
    [anon_sym_cmpxchg] = ACTIONS(845),
    [anon_sym_atomicrmw] = ACTIONS(845),
    [anon_sym_fence] = ACTIONS(845),
    [anon_sym_getelementptr] = ACTIONS(845),
    [anon_sym_extractvalue] = ACTIONS(845),
    [anon_sym_insertvalue] = ACTIONS(845),
    [anon_sym_mul] = ACTIONS(845),
    [anon_sym_urem] = ACTIONS(845),
    [anon_sym_srem] = ACTIONS(845),
    [anon_sym_shl] = ACTIONS(845),
    [anon_sym_udiv] = ACTIONS(845),
    [anon_sym_sdiv] = ACTIONS(845),
    [anon_sym_lshr] = ACTIONS(845),
    [anon_sym_ashr] = ACTIONS(845),
    [anon_sym_fmul] = ACTIONS(845),
    [anon_sym_fdiv] = ACTIONS(845),
    [anon_sym_frem] = ACTIONS(845),
    [anon_sym_xchg] = ACTIONS(845),
    [anon_sym_add] = ACTIONS(845),
    [anon_sym_sub] = ACTIONS(845),
    [anon_sym_and] = ACTIONS(845),
    [anon_sym_nand] = ACTIONS(845),
    [anon_sym_or] = ACTIONS(845),
    [anon_sym_xor] = ACTIONS(845),
    [anon_sym_max] = ACTIONS(845),
    [anon_sym_min] = ACTIONS(845),
    [anon_sym_umax] = ACTIONS(845),
    [anon_sym_umin] = ACTIONS(845),
    [anon_sym_fadd] = ACTIONS(845),
    [anon_sym_fsub] = ACTIONS(845),
    [anon_sym_bitcast] = ACTIONS(845),
    [anon_sym_trunc] = ACTIONS(845),
    [anon_sym_zext] = ACTIONS(845),
    [anon_sym_sext] = ACTIONS(845),
    [anon_sym_fptrunc] = ACTIONS(845),
    [anon_sym_fpext] = ACTIONS(845),
    [anon_sym_addrspacecast] = ACTIONS(845),
    [anon_sym_uitofp] = ACTIONS(845),
    [anon_sym_sitofp] = ACTIONS(845),
    [anon_sym_fptoui] = ACTIONS(845),
    [anon_sym_fptosi] = ACTIONS(845),
    [anon_sym_inttoptr] = ACTIONS(845),
    [anon_sym_ptrtoint] = ACTIONS(845),
    [anon_sym_uselistorder] = ACTIONS(845),
  },
  [207] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(847),
    [sym_local_var] = ACTIONS(847),
    [sym_label] = ACTIONS(847),
    [sym_string] = ACTIONS(849),
    [anon_sym_EQ] = ACTIONS(847),
    [anon_sym_RBRACE] = ACTIONS(847),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_COMMA] = ACTIONS(847),
    [anon_sym_LPAREN] = ACTIONS(847),
    [anon_sym_align] = ACTIONS(849),
    [anon_sym_section] = ACTIONS(849),
    [anon_sym_partition] = ACTIONS(849),
    [anon_sym_comdat] = ACTIONS(849),
    [anon_sym_gc] = ACTIONS(849),
    [anon_sym_prefix] = ACTIONS(849),
    [anon_sym_prologue] = ACTIONS(849),
    [anon_sym_personality] = ACTIONS(849),
    [anon_sym_alignstack] = ACTIONS(849),
    [anon_sym_allocsize] = ACTIONS(849),
    [anon_sym_alwaysinline] = ACTIONS(849),
    [anon_sym_builtin] = ACTIONS(849),
    [anon_sym_cold] = ACTIONS(849),
    [anon_sym_convergent] = ACTIONS(849),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(849),
    [anon_sym_hot] = ACTIONS(849),
    [anon_sym_inaccessiblememonly] = ACTIONS(849),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(849),
    [anon_sym_inlinehint] = ACTIONS(849),
    [anon_sym_jumptable] = ACTIONS(849),
    [anon_sym_minsize] = ACTIONS(849),
    [anon_sym_naked] = ACTIONS(849),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(849),
    [anon_sym_nobuiltin] = ACTIONS(849),
    [anon_sym_noduplicate] = ACTIONS(849),
    [anon_sym_nofree] = ACTIONS(849),
    [anon_sym_noimplicitfloat] = ACTIONS(849),
    [anon_sym_noinline] = ACTIONS(849),
    [anon_sym_nomerge] = ACTIONS(849),
    [anon_sym_nonlazybind] = ACTIONS(849),
    [anon_sym_noprofile] = ACTIONS(849),
    [anon_sym_noredzone] = ACTIONS(849),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(849),
    [anon_sym_noreturn] = ACTIONS(849),
    [anon_sym_norecurse] = ACTIONS(849),
    [anon_sym_willreturn] = ACTIONS(849),
    [anon_sym_nosync] = ACTIONS(849),
    [anon_sym_nounwind] = ACTIONS(849),
    [anon_sym_nocallback] = ACTIONS(849),
    [anon_sym_nosanitize_coverage] = ACTIONS(849),
    [anon_sym_null_pointer_is_valid] = ACTIONS(849),
    [anon_sym_optforfuzzing] = ACTIONS(849),
    [anon_sym_optnone] = ACTIONS(849),
    [anon_sym_optsize] = ACTIONS(849),
    [anon_sym_readnone] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_writeonly] = ACTIONS(849),
    [anon_sym_argmemonly] = ACTIONS(849),
    [anon_sym_returns_twice] = ACTIONS(849),
    [anon_sym_safestack] = ACTIONS(849),
    [anon_sym_sanitize_address] = ACTIONS(849),
    [anon_sym_sanitize_memory] = ACTIONS(849),
    [anon_sym_sanitize_thread] = ACTIONS(849),
    [anon_sym_sanitize_hwaddress] = ACTIONS(849),
    [anon_sym_sanitize_memtag] = ACTIONS(849),
    [anon_sym_speculative_load_hardening] = ACTIONS(849),
    [anon_sym_speculatable] = ACTIONS(849),
    [anon_sym_ssp] = ACTIONS(849),
    [anon_sym_sspstrong] = ACTIONS(849),
    [anon_sym_sspreq] = ACTIONS(849),
    [anon_sym_strictfp] = ACTIONS(849),
    [anon_sym_nocf_check] = ACTIONS(849),
    [anon_sym_shadowcallstack] = ACTIONS(849),
    [anon_sym_mustprogress] = ACTIONS(849),
    [anon_sym_vscale_range] = ACTIONS(849),
    [anon_sym_preallocated] = ACTIONS(849),
    [anon_sym_zeroext] = ACTIONS(849),
    [anon_sym_signext] = ACTIONS(849),
    [anon_sym_inreg] = ACTIONS(849),
    [anon_sym_byval] = ACTIONS(849),
    [anon_sym_byref] = ACTIONS(849),
    [anon_sym_inalloca] = ACTIONS(849),
    [anon_sym_sret] = ACTIONS(849),
    [anon_sym_elementtype] = ACTIONS(849),
    [anon_sym_noalias] = ACTIONS(849),
    [anon_sym_nocapture] = ACTIONS(849),
    [anon_sym_nest] = ACTIONS(849),
    [anon_sym_returned] = ACTIONS(849),
    [anon_sym_nonnull] = ACTIONS(849),
    [anon_sym_dereferenceable] = ACTIONS(849),
    [anon_sym_dereferenceable_or_null] = ACTIONS(849),
    [anon_sym_swiftself] = ACTIONS(849),
    [anon_sym_swiftasync] = ACTIONS(849),
    [anon_sym_swifterror] = ACTIONS(849),
    [anon_sym_immarg] = ACTIONS(849),
    [anon_sym_noundef] = ACTIONS(849),
    [anon_sym_uwtable] = ACTIONS(849),
    [anon_sym_memory] = ACTIONS(849),
    [anon_sym_unreachable] = ACTIONS(849),
    [anon_sym_ret] = ACTIONS(849),
    [anon_sym_br] = ACTIONS(849),
    [anon_sym_resume] = ACTIONS(849),
    [anon_sym_freeze] = ACTIONS(849),
    [anon_sym_indirectbr] = ACTIONS(849),
    [anon_sym_extractelement] = ACTIONS(849),
    [anon_sym_insertelement] = ACTIONS(849),
    [anon_sym_select] = ACTIONS(849),
    [anon_sym_shufflevector] = ACTIONS(849),
    [anon_sym_fneg] = ACTIONS(849),
    [anon_sym_switch] = ACTIONS(849),
    [anon_sym_invoke] = ACTIONS(849),
    [anon_sym_cleanupret] = ACTIONS(849),
    [anon_sym_catchret] = ACTIONS(849),
    [anon_sym_catchswitch] = ACTIONS(849),
    [anon_sym_catchpad] = ACTIONS(849),
    [anon_sym_cleanuppad] = ACTIONS(849),
    [anon_sym_callbr] = ACTIONS(849),
    [anon_sym_icmp] = ACTIONS(849),
    [anon_sym_fcmp] = ACTIONS(849),
    [anon_sym_va_arg] = ACTIONS(849),
    [anon_sym_phi] = ACTIONS(849),
    [anon_sym_landingpad] = ACTIONS(849),
    [anon_sym_tail] = ACTIONS(849),
    [anon_sym_musttail] = ACTIONS(849),
    [anon_sym_notail] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_alloca] = ACTIONS(849),
    [anon_sym_load] = ACTIONS(849),
    [anon_sym_store] = ACTIONS(849),
    [anon_sym_cmpxchg] = ACTIONS(849),
    [anon_sym_atomicrmw] = ACTIONS(849),
    [anon_sym_fence] = ACTIONS(849),
    [anon_sym_getelementptr] = ACTIONS(849),
    [anon_sym_extractvalue] = ACTIONS(849),
    [anon_sym_insertvalue] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_urem] = ACTIONS(849),
    [anon_sym_srem] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_udiv] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_lshr] = ACTIONS(849),
    [anon_sym_ashr] = ACTIONS(849),
    [anon_sym_fmul] = ACTIONS(849),
    [anon_sym_fdiv] = ACTIONS(849),
    [anon_sym_frem] = ACTIONS(849),
    [anon_sym_xchg] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_nand] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_max] = ACTIONS(849),
    [anon_sym_min] = ACTIONS(849),
    [anon_sym_umax] = ACTIONS(849),
    [anon_sym_umin] = ACTIONS(849),
    [anon_sym_fadd] = ACTIONS(849),
    [anon_sym_fsub] = ACTIONS(849),
    [anon_sym_bitcast] = ACTIONS(849),
    [anon_sym_trunc] = ACTIONS(849),
    [anon_sym_zext] = ACTIONS(849),
    [anon_sym_sext] = ACTIONS(849),
    [anon_sym_fptrunc] = ACTIONS(849),
    [anon_sym_fpext] = ACTIONS(849),
    [anon_sym_addrspacecast] = ACTIONS(849),
    [anon_sym_uitofp] = ACTIONS(849),
    [anon_sym_sitofp] = ACTIONS(849),
    [anon_sym_fptoui] = ACTIONS(849),
    [anon_sym_fptosi] = ACTIONS(849),
    [anon_sym_inttoptr] = ACTIONS(849),
    [anon_sym_ptrtoint] = ACTIONS(849),
    [anon_sym_uselistorder] = ACTIONS(849),
  },
  [208] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(851),
    [sym_local_var] = ACTIONS(851),
    [sym_label] = ACTIONS(851),
    [sym_string] = ACTIONS(853),
    [anon_sym_EQ] = ACTIONS(851),
    [anon_sym_RBRACE] = ACTIONS(851),
    [anon_sym_LBRACK] = ACTIONS(851),
    [anon_sym_COMMA] = ACTIONS(851),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_align] = ACTIONS(853),
    [anon_sym_section] = ACTIONS(853),
    [anon_sym_partition] = ACTIONS(853),
    [anon_sym_comdat] = ACTIONS(853),
    [anon_sym_gc] = ACTIONS(853),
    [anon_sym_prefix] = ACTIONS(853),
    [anon_sym_prologue] = ACTIONS(853),
    [anon_sym_personality] = ACTIONS(853),
    [anon_sym_alignstack] = ACTIONS(853),
    [anon_sym_allocsize] = ACTIONS(853),
    [anon_sym_alwaysinline] = ACTIONS(853),
    [anon_sym_builtin] = ACTIONS(853),
    [anon_sym_cold] = ACTIONS(853),
    [anon_sym_convergent] = ACTIONS(853),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(853),
    [anon_sym_hot] = ACTIONS(853),
    [anon_sym_inaccessiblememonly] = ACTIONS(853),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(853),
    [anon_sym_inlinehint] = ACTIONS(853),
    [anon_sym_jumptable] = ACTIONS(853),
    [anon_sym_minsize] = ACTIONS(853),
    [anon_sym_naked] = ACTIONS(853),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(853),
    [anon_sym_nobuiltin] = ACTIONS(853),
    [anon_sym_noduplicate] = ACTIONS(853),
    [anon_sym_nofree] = ACTIONS(853),
    [anon_sym_noimplicitfloat] = ACTIONS(853),
    [anon_sym_noinline] = ACTIONS(853),
    [anon_sym_nomerge] = ACTIONS(853),
    [anon_sym_nonlazybind] = ACTIONS(853),
    [anon_sym_noprofile] = ACTIONS(853),
    [anon_sym_noredzone] = ACTIONS(853),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(853),
    [anon_sym_noreturn] = ACTIONS(853),
    [anon_sym_norecurse] = ACTIONS(853),
    [anon_sym_willreturn] = ACTIONS(853),
    [anon_sym_nosync] = ACTIONS(853),
    [anon_sym_nounwind] = ACTIONS(853),
    [anon_sym_nocallback] = ACTIONS(853),
    [anon_sym_nosanitize_coverage] = ACTIONS(853),
    [anon_sym_null_pointer_is_valid] = ACTIONS(853),
    [anon_sym_optforfuzzing] = ACTIONS(853),
    [anon_sym_optnone] = ACTIONS(853),
    [anon_sym_optsize] = ACTIONS(853),
    [anon_sym_readnone] = ACTIONS(853),
    [anon_sym_readonly] = ACTIONS(853),
    [anon_sym_writeonly] = ACTIONS(853),
    [anon_sym_argmemonly] = ACTIONS(853),
    [anon_sym_returns_twice] = ACTIONS(853),
    [anon_sym_safestack] = ACTIONS(853),
    [anon_sym_sanitize_address] = ACTIONS(853),
    [anon_sym_sanitize_memory] = ACTIONS(853),
    [anon_sym_sanitize_thread] = ACTIONS(853),
    [anon_sym_sanitize_hwaddress] = ACTIONS(853),
    [anon_sym_sanitize_memtag] = ACTIONS(853),
    [anon_sym_speculative_load_hardening] = ACTIONS(853),
    [anon_sym_speculatable] = ACTIONS(853),
    [anon_sym_ssp] = ACTIONS(853),
    [anon_sym_sspstrong] = ACTIONS(853),
    [anon_sym_sspreq] = ACTIONS(853),
    [anon_sym_strictfp] = ACTIONS(853),
    [anon_sym_nocf_check] = ACTIONS(853),
    [anon_sym_shadowcallstack] = ACTIONS(853),
    [anon_sym_mustprogress] = ACTIONS(853),
    [anon_sym_vscale_range] = ACTIONS(853),
    [anon_sym_preallocated] = ACTIONS(853),
    [anon_sym_zeroext] = ACTIONS(853),
    [anon_sym_signext] = ACTIONS(853),
    [anon_sym_inreg] = ACTIONS(853),
    [anon_sym_byval] = ACTIONS(853),
    [anon_sym_byref] = ACTIONS(853),
    [anon_sym_inalloca] = ACTIONS(853),
    [anon_sym_sret] = ACTIONS(853),
    [anon_sym_elementtype] = ACTIONS(853),
    [anon_sym_noalias] = ACTIONS(853),
    [anon_sym_nocapture] = ACTIONS(853),
    [anon_sym_nest] = ACTIONS(853),
    [anon_sym_returned] = ACTIONS(853),
    [anon_sym_nonnull] = ACTIONS(853),
    [anon_sym_dereferenceable] = ACTIONS(853),
    [anon_sym_dereferenceable_or_null] = ACTIONS(853),
    [anon_sym_swiftself] = ACTIONS(853),
    [anon_sym_swiftasync] = ACTIONS(853),
    [anon_sym_swifterror] = ACTIONS(853),
    [anon_sym_immarg] = ACTIONS(853),
    [anon_sym_noundef] = ACTIONS(853),
    [anon_sym_uwtable] = ACTIONS(853),
    [anon_sym_memory] = ACTIONS(853),
    [anon_sym_unreachable] = ACTIONS(853),
    [anon_sym_ret] = ACTIONS(853),
    [anon_sym_br] = ACTIONS(853),
    [anon_sym_resume] = ACTIONS(853),
    [anon_sym_freeze] = ACTIONS(853),
    [anon_sym_indirectbr] = ACTIONS(853),
    [anon_sym_extractelement] = ACTIONS(853),
    [anon_sym_insertelement] = ACTIONS(853),
    [anon_sym_select] = ACTIONS(853),
    [anon_sym_shufflevector] = ACTIONS(853),
    [anon_sym_fneg] = ACTIONS(853),
    [anon_sym_switch] = ACTIONS(853),
    [anon_sym_invoke] = ACTIONS(853),
    [anon_sym_cleanupret] = ACTIONS(853),
    [anon_sym_catchret] = ACTIONS(853),
    [anon_sym_catchswitch] = ACTIONS(853),
    [anon_sym_catchpad] = ACTIONS(853),
    [anon_sym_cleanuppad] = ACTIONS(853),
    [anon_sym_callbr] = ACTIONS(853),
    [anon_sym_icmp] = ACTIONS(853),
    [anon_sym_fcmp] = ACTIONS(853),
    [anon_sym_va_arg] = ACTIONS(853),
    [anon_sym_phi] = ACTIONS(853),
    [anon_sym_landingpad] = ACTIONS(853),
    [anon_sym_tail] = ACTIONS(853),
    [anon_sym_musttail] = ACTIONS(853),
    [anon_sym_notail] = ACTIONS(853),
    [anon_sym_call] = ACTIONS(853),
    [anon_sym_alloca] = ACTIONS(853),
    [anon_sym_load] = ACTIONS(853),
    [anon_sym_store] = ACTIONS(853),
    [anon_sym_cmpxchg] = ACTIONS(853),
    [anon_sym_atomicrmw] = ACTIONS(853),
    [anon_sym_fence] = ACTIONS(853),
    [anon_sym_getelementptr] = ACTIONS(853),
    [anon_sym_extractvalue] = ACTIONS(853),
    [anon_sym_insertvalue] = ACTIONS(853),
    [anon_sym_mul] = ACTIONS(853),
    [anon_sym_urem] = ACTIONS(853),
    [anon_sym_srem] = ACTIONS(853),
    [anon_sym_shl] = ACTIONS(853),
    [anon_sym_udiv] = ACTIONS(853),
    [anon_sym_sdiv] = ACTIONS(853),
    [anon_sym_lshr] = ACTIONS(853),
    [anon_sym_ashr] = ACTIONS(853),
    [anon_sym_fmul] = ACTIONS(853),
    [anon_sym_fdiv] = ACTIONS(853),
    [anon_sym_frem] = ACTIONS(853),
    [anon_sym_xchg] = ACTIONS(853),
    [anon_sym_add] = ACTIONS(853),
    [anon_sym_sub] = ACTIONS(853),
    [anon_sym_and] = ACTIONS(853),
    [anon_sym_nand] = ACTIONS(853),
    [anon_sym_or] = ACTIONS(853),
    [anon_sym_xor] = ACTIONS(853),
    [anon_sym_max] = ACTIONS(853),
    [anon_sym_min] = ACTIONS(853),
    [anon_sym_umax] = ACTIONS(853),
    [anon_sym_umin] = ACTIONS(853),
    [anon_sym_fadd] = ACTIONS(853),
    [anon_sym_fsub] = ACTIONS(853),
    [anon_sym_bitcast] = ACTIONS(853),
    [anon_sym_trunc] = ACTIONS(853),
    [anon_sym_zext] = ACTIONS(853),
    [anon_sym_sext] = ACTIONS(853),
    [anon_sym_fptrunc] = ACTIONS(853),
    [anon_sym_fpext] = ACTIONS(853),
    [anon_sym_addrspacecast] = ACTIONS(853),
    [anon_sym_uitofp] = ACTIONS(853),
    [anon_sym_sitofp] = ACTIONS(853),
    [anon_sym_fptoui] = ACTIONS(853),
    [anon_sym_fptosi] = ACTIONS(853),
    [anon_sym_inttoptr] = ACTIONS(853),
    [anon_sym_ptrtoint] = ACTIONS(853),
    [anon_sym_uselistorder] = ACTIONS(853),
  },
  [209] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(855),
    [sym_local_var] = ACTIONS(855),
    [sym_label] = ACTIONS(855),
    [sym_string] = ACTIONS(857),
    [anon_sym_EQ] = ACTIONS(859),
    [anon_sym_RBRACE] = ACTIONS(855),
    [anon_sym_LBRACK] = ACTIONS(855),
    [anon_sym_COMMA] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(861),
    [anon_sym_align] = ACTIONS(857),
    [anon_sym_section] = ACTIONS(857),
    [anon_sym_partition] = ACTIONS(857),
    [anon_sym_comdat] = ACTIONS(857),
    [anon_sym_gc] = ACTIONS(857),
    [anon_sym_prefix] = ACTIONS(857),
    [anon_sym_prologue] = ACTIONS(857),
    [anon_sym_personality] = ACTIONS(857),
    [anon_sym_alignstack] = ACTIONS(857),
    [anon_sym_allocsize] = ACTIONS(857),
    [anon_sym_alwaysinline] = ACTIONS(857),
    [anon_sym_builtin] = ACTIONS(857),
    [anon_sym_cold] = ACTIONS(857),
    [anon_sym_convergent] = ACTIONS(857),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(857),
    [anon_sym_hot] = ACTIONS(857),
    [anon_sym_inaccessiblememonly] = ACTIONS(857),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(857),
    [anon_sym_inlinehint] = ACTIONS(857),
    [anon_sym_jumptable] = ACTIONS(857),
    [anon_sym_minsize] = ACTIONS(857),
    [anon_sym_naked] = ACTIONS(857),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(857),
    [anon_sym_nobuiltin] = ACTIONS(857),
    [anon_sym_noduplicate] = ACTIONS(857),
    [anon_sym_nofree] = ACTIONS(857),
    [anon_sym_noimplicitfloat] = ACTIONS(857),
    [anon_sym_noinline] = ACTIONS(857),
    [anon_sym_nomerge] = ACTIONS(857),
    [anon_sym_nonlazybind] = ACTIONS(857),
    [anon_sym_noprofile] = ACTIONS(857),
    [anon_sym_noredzone] = ACTIONS(857),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(857),
    [anon_sym_noreturn] = ACTIONS(857),
    [anon_sym_norecurse] = ACTIONS(857),
    [anon_sym_willreturn] = ACTIONS(857),
    [anon_sym_nosync] = ACTIONS(857),
    [anon_sym_nounwind] = ACTIONS(857),
    [anon_sym_nocallback] = ACTIONS(857),
    [anon_sym_nosanitize_coverage] = ACTIONS(857),
    [anon_sym_null_pointer_is_valid] = ACTIONS(857),
    [anon_sym_optforfuzzing] = ACTIONS(857),
    [anon_sym_optnone] = ACTIONS(857),
    [anon_sym_optsize] = ACTIONS(857),
    [anon_sym_readnone] = ACTIONS(857),
    [anon_sym_readonly] = ACTIONS(857),
    [anon_sym_writeonly] = ACTIONS(857),
    [anon_sym_argmemonly] = ACTIONS(857),
    [anon_sym_returns_twice] = ACTIONS(857),
    [anon_sym_safestack] = ACTIONS(857),
    [anon_sym_sanitize_address] = ACTIONS(857),
    [anon_sym_sanitize_memory] = ACTIONS(857),
    [anon_sym_sanitize_thread] = ACTIONS(857),
    [anon_sym_sanitize_hwaddress] = ACTIONS(857),
    [anon_sym_sanitize_memtag] = ACTIONS(857),
    [anon_sym_speculative_load_hardening] = ACTIONS(857),
    [anon_sym_speculatable] = ACTIONS(857),
    [anon_sym_ssp] = ACTIONS(857),
    [anon_sym_sspstrong] = ACTIONS(857),
    [anon_sym_sspreq] = ACTIONS(857),
    [anon_sym_strictfp] = ACTIONS(857),
    [anon_sym_nocf_check] = ACTIONS(857),
    [anon_sym_shadowcallstack] = ACTIONS(857),
    [anon_sym_mustprogress] = ACTIONS(857),
    [anon_sym_vscale_range] = ACTIONS(857),
    [anon_sym_preallocated] = ACTIONS(857),
    [anon_sym_zeroext] = ACTIONS(857),
    [anon_sym_signext] = ACTIONS(857),
    [anon_sym_inreg] = ACTIONS(857),
    [anon_sym_byval] = ACTIONS(857),
    [anon_sym_byref] = ACTIONS(857),
    [anon_sym_inalloca] = ACTIONS(857),
    [anon_sym_sret] = ACTIONS(857),
    [anon_sym_elementtype] = ACTIONS(857),
    [anon_sym_noalias] = ACTIONS(857),
    [anon_sym_nocapture] = ACTIONS(857),
    [anon_sym_nest] = ACTIONS(857),
    [anon_sym_returned] = ACTIONS(857),
    [anon_sym_nonnull] = ACTIONS(857),
    [anon_sym_dereferenceable] = ACTIONS(857),
    [anon_sym_dereferenceable_or_null] = ACTIONS(857),
    [anon_sym_swiftself] = ACTIONS(857),
    [anon_sym_swiftasync] = ACTIONS(857),
    [anon_sym_swifterror] = ACTIONS(857),
    [anon_sym_immarg] = ACTIONS(857),
    [anon_sym_noundef] = ACTIONS(857),
    [anon_sym_uwtable] = ACTIONS(857),
    [anon_sym_memory] = ACTIONS(857),
    [anon_sym_unreachable] = ACTIONS(857),
    [anon_sym_ret] = ACTIONS(857),
    [anon_sym_br] = ACTIONS(857),
    [anon_sym_resume] = ACTIONS(857),
    [anon_sym_freeze] = ACTIONS(857),
    [anon_sym_indirectbr] = ACTIONS(857),
    [anon_sym_extractelement] = ACTIONS(857),
    [anon_sym_insertelement] = ACTIONS(857),
    [anon_sym_select] = ACTIONS(857),
    [anon_sym_shufflevector] = ACTIONS(857),
    [anon_sym_fneg] = ACTIONS(857),
    [anon_sym_switch] = ACTIONS(857),
    [anon_sym_invoke] = ACTIONS(857),
    [anon_sym_cleanupret] = ACTIONS(857),
    [anon_sym_catchret] = ACTIONS(857),
    [anon_sym_catchswitch] = ACTIONS(857),
    [anon_sym_catchpad] = ACTIONS(857),
    [anon_sym_cleanuppad] = ACTIONS(857),
    [anon_sym_callbr] = ACTIONS(857),
    [anon_sym_icmp] = ACTIONS(857),
    [anon_sym_fcmp] = ACTIONS(857),
    [anon_sym_va_arg] = ACTIONS(857),
    [anon_sym_phi] = ACTIONS(857),
    [anon_sym_landingpad] = ACTIONS(857),
    [anon_sym_tail] = ACTIONS(857),
    [anon_sym_musttail] = ACTIONS(857),
    [anon_sym_notail] = ACTIONS(857),
    [anon_sym_call] = ACTIONS(857),
    [anon_sym_alloca] = ACTIONS(857),
    [anon_sym_load] = ACTIONS(857),
    [anon_sym_store] = ACTIONS(857),
    [anon_sym_cmpxchg] = ACTIONS(857),
    [anon_sym_atomicrmw] = ACTIONS(857),
    [anon_sym_fence] = ACTIONS(857),
    [anon_sym_getelementptr] = ACTIONS(857),
    [anon_sym_extractvalue] = ACTIONS(857),
    [anon_sym_insertvalue] = ACTIONS(857),
    [anon_sym_mul] = ACTIONS(857),
    [anon_sym_urem] = ACTIONS(857),
    [anon_sym_srem] = ACTIONS(857),
    [anon_sym_shl] = ACTIONS(857),
    [anon_sym_udiv] = ACTIONS(857),
    [anon_sym_sdiv] = ACTIONS(857),
    [anon_sym_lshr] = ACTIONS(857),
    [anon_sym_ashr] = ACTIONS(857),
    [anon_sym_fmul] = ACTIONS(857),
    [anon_sym_fdiv] = ACTIONS(857),
    [anon_sym_frem] = ACTIONS(857),
    [anon_sym_xchg] = ACTIONS(857),
    [anon_sym_add] = ACTIONS(857),
    [anon_sym_sub] = ACTIONS(857),
    [anon_sym_and] = ACTIONS(857),
    [anon_sym_nand] = ACTIONS(857),
    [anon_sym_or] = ACTIONS(857),
    [anon_sym_xor] = ACTIONS(857),
    [anon_sym_max] = ACTIONS(857),
    [anon_sym_min] = ACTIONS(857),
    [anon_sym_umax] = ACTIONS(857),
    [anon_sym_umin] = ACTIONS(857),
    [anon_sym_fadd] = ACTIONS(857),
    [anon_sym_fsub] = ACTIONS(857),
    [anon_sym_bitcast] = ACTIONS(857),
    [anon_sym_trunc] = ACTIONS(857),
    [anon_sym_zext] = ACTIONS(857),
    [anon_sym_sext] = ACTIONS(857),
    [anon_sym_fptrunc] = ACTIONS(857),
    [anon_sym_fpext] = ACTIONS(857),
    [anon_sym_addrspacecast] = ACTIONS(857),
    [anon_sym_uitofp] = ACTIONS(857),
    [anon_sym_sitofp] = ACTIONS(857),
    [anon_sym_fptoui] = ACTIONS(857),
    [anon_sym_fptosi] = ACTIONS(857),
    [anon_sym_inttoptr] = ACTIONS(857),
    [anon_sym_ptrtoint] = ACTIONS(857),
    [anon_sym_uselistorder] = ACTIONS(857),
  },
  [210] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(863),
    [sym_local_var] = ACTIONS(863),
    [sym_label] = ACTIONS(863),
    [sym_string] = ACTIONS(865),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_RBRACE] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_COMMA] = ACTIONS(863),
    [anon_sym_LPAREN] = ACTIONS(867),
    [anon_sym_align] = ACTIONS(865),
    [anon_sym_section] = ACTIONS(865),
    [anon_sym_partition] = ACTIONS(865),
    [anon_sym_comdat] = ACTIONS(865),
    [anon_sym_gc] = ACTIONS(865),
    [anon_sym_prefix] = ACTIONS(865),
    [anon_sym_prologue] = ACTIONS(865),
    [anon_sym_personality] = ACTIONS(865),
    [anon_sym_alignstack] = ACTIONS(865),
    [anon_sym_allocsize] = ACTIONS(865),
    [anon_sym_alwaysinline] = ACTIONS(865),
    [anon_sym_builtin] = ACTIONS(865),
    [anon_sym_cold] = ACTIONS(865),
    [anon_sym_convergent] = ACTIONS(865),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(865),
    [anon_sym_hot] = ACTIONS(865),
    [anon_sym_inaccessiblememonly] = ACTIONS(865),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(865),
    [anon_sym_inlinehint] = ACTIONS(865),
    [anon_sym_jumptable] = ACTIONS(865),
    [anon_sym_minsize] = ACTIONS(865),
    [anon_sym_naked] = ACTIONS(865),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(865),
    [anon_sym_nobuiltin] = ACTIONS(865),
    [anon_sym_noduplicate] = ACTIONS(865),
    [anon_sym_nofree] = ACTIONS(865),
    [anon_sym_noimplicitfloat] = ACTIONS(865),
    [anon_sym_noinline] = ACTIONS(865),
    [anon_sym_nomerge] = ACTIONS(865),
    [anon_sym_nonlazybind] = ACTIONS(865),
    [anon_sym_noprofile] = ACTIONS(865),
    [anon_sym_noredzone] = ACTIONS(865),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(865),
    [anon_sym_noreturn] = ACTIONS(865),
    [anon_sym_norecurse] = ACTIONS(865),
    [anon_sym_willreturn] = ACTIONS(865),
    [anon_sym_nosync] = ACTIONS(865),
    [anon_sym_nounwind] = ACTIONS(865),
    [anon_sym_nocallback] = ACTIONS(865),
    [anon_sym_nosanitize_coverage] = ACTIONS(865),
    [anon_sym_null_pointer_is_valid] = ACTIONS(865),
    [anon_sym_optforfuzzing] = ACTIONS(865),
    [anon_sym_optnone] = ACTIONS(865),
    [anon_sym_optsize] = ACTIONS(865),
    [anon_sym_readnone] = ACTIONS(865),
    [anon_sym_readonly] = ACTIONS(865),
    [anon_sym_writeonly] = ACTIONS(865),
    [anon_sym_argmemonly] = ACTIONS(865),
    [anon_sym_returns_twice] = ACTIONS(865),
    [anon_sym_safestack] = ACTIONS(865),
    [anon_sym_sanitize_address] = ACTIONS(865),
    [anon_sym_sanitize_memory] = ACTIONS(865),
    [anon_sym_sanitize_thread] = ACTIONS(865),
    [anon_sym_sanitize_hwaddress] = ACTIONS(865),
    [anon_sym_sanitize_memtag] = ACTIONS(865),
    [anon_sym_speculative_load_hardening] = ACTIONS(865),
    [anon_sym_speculatable] = ACTIONS(865),
    [anon_sym_ssp] = ACTIONS(865),
    [anon_sym_sspstrong] = ACTIONS(865),
    [anon_sym_sspreq] = ACTIONS(865),
    [anon_sym_strictfp] = ACTIONS(865),
    [anon_sym_nocf_check] = ACTIONS(865),
    [anon_sym_shadowcallstack] = ACTIONS(865),
    [anon_sym_mustprogress] = ACTIONS(865),
    [anon_sym_vscale_range] = ACTIONS(865),
    [anon_sym_preallocated] = ACTIONS(865),
    [anon_sym_zeroext] = ACTIONS(865),
    [anon_sym_signext] = ACTIONS(865),
    [anon_sym_inreg] = ACTIONS(865),
    [anon_sym_byval] = ACTIONS(865),
    [anon_sym_byref] = ACTIONS(865),
    [anon_sym_inalloca] = ACTIONS(865),
    [anon_sym_sret] = ACTIONS(865),
    [anon_sym_elementtype] = ACTIONS(865),
    [anon_sym_noalias] = ACTIONS(865),
    [anon_sym_nocapture] = ACTIONS(865),
    [anon_sym_nest] = ACTIONS(865),
    [anon_sym_returned] = ACTIONS(865),
    [anon_sym_nonnull] = ACTIONS(865),
    [anon_sym_dereferenceable] = ACTIONS(865),
    [anon_sym_dereferenceable_or_null] = ACTIONS(865),
    [anon_sym_swiftself] = ACTIONS(865),
    [anon_sym_swiftasync] = ACTIONS(865),
    [anon_sym_swifterror] = ACTIONS(865),
    [anon_sym_immarg] = ACTIONS(865),
    [anon_sym_noundef] = ACTIONS(865),
    [anon_sym_uwtable] = ACTIONS(865),
    [anon_sym_memory] = ACTIONS(865),
    [anon_sym_unreachable] = ACTIONS(865),
    [anon_sym_ret] = ACTIONS(865),
    [anon_sym_br] = ACTIONS(865),
    [anon_sym_resume] = ACTIONS(865),
    [anon_sym_freeze] = ACTIONS(865),
    [anon_sym_indirectbr] = ACTIONS(865),
    [anon_sym_extractelement] = ACTIONS(865),
    [anon_sym_insertelement] = ACTIONS(865),
    [anon_sym_select] = ACTIONS(865),
    [anon_sym_shufflevector] = ACTIONS(865),
    [anon_sym_fneg] = ACTIONS(865),
    [anon_sym_switch] = ACTIONS(865),
    [anon_sym_invoke] = ACTIONS(865),
    [anon_sym_cleanupret] = ACTIONS(865),
    [anon_sym_catchret] = ACTIONS(865),
    [anon_sym_catchswitch] = ACTIONS(865),
    [anon_sym_catchpad] = ACTIONS(865),
    [anon_sym_cleanuppad] = ACTIONS(865),
    [anon_sym_callbr] = ACTIONS(865),
    [anon_sym_icmp] = ACTIONS(865),
    [anon_sym_fcmp] = ACTIONS(865),
    [anon_sym_va_arg] = ACTIONS(865),
    [anon_sym_phi] = ACTIONS(865),
    [anon_sym_landingpad] = ACTIONS(865),
    [anon_sym_tail] = ACTIONS(865),
    [anon_sym_musttail] = ACTIONS(865),
    [anon_sym_notail] = ACTIONS(865),
    [anon_sym_call] = ACTIONS(865),
    [anon_sym_alloca] = ACTIONS(865),
    [anon_sym_load] = ACTIONS(865),
    [anon_sym_store] = ACTIONS(865),
    [anon_sym_cmpxchg] = ACTIONS(865),
    [anon_sym_atomicrmw] = ACTIONS(865),
    [anon_sym_fence] = ACTIONS(865),
    [anon_sym_getelementptr] = ACTIONS(865),
    [anon_sym_extractvalue] = ACTIONS(865),
    [anon_sym_insertvalue] = ACTIONS(865),
    [anon_sym_mul] = ACTIONS(865),
    [anon_sym_urem] = ACTIONS(865),
    [anon_sym_srem] = ACTIONS(865),
    [anon_sym_shl] = ACTIONS(865),
    [anon_sym_udiv] = ACTIONS(865),
    [anon_sym_sdiv] = ACTIONS(865),
    [anon_sym_lshr] = ACTIONS(865),
    [anon_sym_ashr] = ACTIONS(865),
    [anon_sym_fmul] = ACTIONS(865),
    [anon_sym_fdiv] = ACTIONS(865),
    [anon_sym_frem] = ACTIONS(865),
    [anon_sym_xchg] = ACTIONS(865),
    [anon_sym_add] = ACTIONS(865),
    [anon_sym_sub] = ACTIONS(865),
    [anon_sym_and] = ACTIONS(865),
    [anon_sym_nand] = ACTIONS(865),
    [anon_sym_or] = ACTIONS(865),
    [anon_sym_xor] = ACTIONS(865),
    [anon_sym_max] = ACTIONS(865),
    [anon_sym_min] = ACTIONS(865),
    [anon_sym_umax] = ACTIONS(865),
    [anon_sym_umin] = ACTIONS(865),
    [anon_sym_fadd] = ACTIONS(865),
    [anon_sym_fsub] = ACTIONS(865),
    [anon_sym_bitcast] = ACTIONS(865),
    [anon_sym_trunc] = ACTIONS(865),
    [anon_sym_zext] = ACTIONS(865),
    [anon_sym_sext] = ACTIONS(865),
    [anon_sym_fptrunc] = ACTIONS(865),
    [anon_sym_fpext] = ACTIONS(865),
    [anon_sym_addrspacecast] = ACTIONS(865),
    [anon_sym_uitofp] = ACTIONS(865),
    [anon_sym_sitofp] = ACTIONS(865),
    [anon_sym_fptoui] = ACTIONS(865),
    [anon_sym_fptosi] = ACTIONS(865),
    [anon_sym_inttoptr] = ACTIONS(865),
    [anon_sym_ptrtoint] = ACTIONS(865),
    [anon_sym_uselistorder] = ACTIONS(865),
  },
  [211] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(812),
    [sym_local_var] = ACTIONS(812),
    [sym_label] = ACTIONS(812),
    [sym_string] = ACTIONS(814),
    [anon_sym_EQ] = ACTIONS(812),
    [anon_sym_RBRACE] = ACTIONS(812),
    [anon_sym_LBRACK] = ACTIONS(812),
    [anon_sym_COMMA] = ACTIONS(812),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_align] = ACTIONS(814),
    [anon_sym_section] = ACTIONS(814),
    [anon_sym_partition] = ACTIONS(814),
    [anon_sym_comdat] = ACTIONS(814),
    [anon_sym_gc] = ACTIONS(814),
    [anon_sym_prefix] = ACTIONS(814),
    [anon_sym_prologue] = ACTIONS(814),
    [anon_sym_personality] = ACTIONS(814),
    [anon_sym_alignstack] = ACTIONS(814),
    [anon_sym_allocsize] = ACTIONS(814),
    [anon_sym_alwaysinline] = ACTIONS(814),
    [anon_sym_builtin] = ACTIONS(814),
    [anon_sym_cold] = ACTIONS(814),
    [anon_sym_convergent] = ACTIONS(814),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(814),
    [anon_sym_hot] = ACTIONS(814),
    [anon_sym_inaccessiblememonly] = ACTIONS(814),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(814),
    [anon_sym_inlinehint] = ACTIONS(814),
    [anon_sym_jumptable] = ACTIONS(814),
    [anon_sym_minsize] = ACTIONS(814),
    [anon_sym_naked] = ACTIONS(814),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(814),
    [anon_sym_nobuiltin] = ACTIONS(814),
    [anon_sym_noduplicate] = ACTIONS(814),
    [anon_sym_nofree] = ACTIONS(814),
    [anon_sym_noimplicitfloat] = ACTIONS(814),
    [anon_sym_noinline] = ACTIONS(814),
    [anon_sym_nomerge] = ACTIONS(814),
    [anon_sym_nonlazybind] = ACTIONS(814),
    [anon_sym_noprofile] = ACTIONS(814),
    [anon_sym_noredzone] = ACTIONS(814),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(814),
    [anon_sym_noreturn] = ACTIONS(814),
    [anon_sym_norecurse] = ACTIONS(814),
    [anon_sym_willreturn] = ACTIONS(814),
    [anon_sym_nosync] = ACTIONS(814),
    [anon_sym_nounwind] = ACTIONS(814),
    [anon_sym_nocallback] = ACTIONS(814),
    [anon_sym_nosanitize_coverage] = ACTIONS(814),
    [anon_sym_null_pointer_is_valid] = ACTIONS(814),
    [anon_sym_optforfuzzing] = ACTIONS(814),
    [anon_sym_optnone] = ACTIONS(814),
    [anon_sym_optsize] = ACTIONS(814),
    [anon_sym_readnone] = ACTIONS(814),
    [anon_sym_readonly] = ACTIONS(814),
    [anon_sym_writeonly] = ACTIONS(814),
    [anon_sym_argmemonly] = ACTIONS(814),
    [anon_sym_returns_twice] = ACTIONS(814),
    [anon_sym_safestack] = ACTIONS(814),
    [anon_sym_sanitize_address] = ACTIONS(814),
    [anon_sym_sanitize_memory] = ACTIONS(814),
    [anon_sym_sanitize_thread] = ACTIONS(814),
    [anon_sym_sanitize_hwaddress] = ACTIONS(814),
    [anon_sym_sanitize_memtag] = ACTIONS(814),
    [anon_sym_speculative_load_hardening] = ACTIONS(814),
    [anon_sym_speculatable] = ACTIONS(814),
    [anon_sym_ssp] = ACTIONS(814),
    [anon_sym_sspstrong] = ACTIONS(814),
    [anon_sym_sspreq] = ACTIONS(814),
    [anon_sym_strictfp] = ACTIONS(814),
    [anon_sym_nocf_check] = ACTIONS(814),
    [anon_sym_shadowcallstack] = ACTIONS(814),
    [anon_sym_mustprogress] = ACTIONS(814),
    [anon_sym_vscale_range] = ACTIONS(814),
    [anon_sym_preallocated] = ACTIONS(814),
    [anon_sym_zeroext] = ACTIONS(814),
    [anon_sym_signext] = ACTIONS(814),
    [anon_sym_inreg] = ACTIONS(814),
    [anon_sym_byval] = ACTIONS(814),
    [anon_sym_byref] = ACTIONS(814),
    [anon_sym_inalloca] = ACTIONS(814),
    [anon_sym_sret] = ACTIONS(814),
    [anon_sym_elementtype] = ACTIONS(814),
    [anon_sym_noalias] = ACTIONS(814),
    [anon_sym_nocapture] = ACTIONS(814),
    [anon_sym_nest] = ACTIONS(814),
    [anon_sym_returned] = ACTIONS(814),
    [anon_sym_nonnull] = ACTIONS(814),
    [anon_sym_dereferenceable] = ACTIONS(814),
    [anon_sym_dereferenceable_or_null] = ACTIONS(814),
    [anon_sym_swiftself] = ACTIONS(814),
    [anon_sym_swiftasync] = ACTIONS(814),
    [anon_sym_swifterror] = ACTIONS(814),
    [anon_sym_immarg] = ACTIONS(814),
    [anon_sym_noundef] = ACTIONS(814),
    [anon_sym_uwtable] = ACTIONS(814),
    [anon_sym_memory] = ACTIONS(814),
    [anon_sym_unreachable] = ACTIONS(814),
    [anon_sym_ret] = ACTIONS(814),
    [anon_sym_br] = ACTIONS(814),
    [anon_sym_resume] = ACTIONS(814),
    [anon_sym_freeze] = ACTIONS(814),
    [anon_sym_indirectbr] = ACTIONS(814),
    [anon_sym_extractelement] = ACTIONS(814),
    [anon_sym_insertelement] = ACTIONS(814),
    [anon_sym_select] = ACTIONS(814),
    [anon_sym_shufflevector] = ACTIONS(814),
    [anon_sym_fneg] = ACTIONS(814),
    [anon_sym_switch] = ACTIONS(814),
    [anon_sym_invoke] = ACTIONS(814),
    [anon_sym_cleanupret] = ACTIONS(814),
    [anon_sym_catchret] = ACTIONS(814),
    [anon_sym_catchswitch] = ACTIONS(814),
    [anon_sym_catchpad] = ACTIONS(814),
    [anon_sym_cleanuppad] = ACTIONS(814),
    [anon_sym_callbr] = ACTIONS(814),
    [anon_sym_icmp] = ACTIONS(814),
    [anon_sym_fcmp] = ACTIONS(814),
    [anon_sym_va_arg] = ACTIONS(814),
    [anon_sym_phi] = ACTIONS(814),
    [anon_sym_landingpad] = ACTIONS(814),
    [anon_sym_tail] = ACTIONS(814),
    [anon_sym_musttail] = ACTIONS(814),
    [anon_sym_notail] = ACTIONS(814),
    [anon_sym_call] = ACTIONS(814),
    [anon_sym_alloca] = ACTIONS(814),
    [anon_sym_load] = ACTIONS(814),
    [anon_sym_store] = ACTIONS(814),
    [anon_sym_cmpxchg] = ACTIONS(814),
    [anon_sym_atomicrmw] = ACTIONS(814),
    [anon_sym_fence] = ACTIONS(814),
    [anon_sym_getelementptr] = ACTIONS(814),
    [anon_sym_extractvalue] = ACTIONS(814),
    [anon_sym_insertvalue] = ACTIONS(814),
    [anon_sym_mul] = ACTIONS(814),
    [anon_sym_urem] = ACTIONS(814),
    [anon_sym_srem] = ACTIONS(814),
    [anon_sym_shl] = ACTIONS(814),
    [anon_sym_udiv] = ACTIONS(814),
    [anon_sym_sdiv] = ACTIONS(814),
    [anon_sym_lshr] = ACTIONS(814),
    [anon_sym_ashr] = ACTIONS(814),
    [anon_sym_fmul] = ACTIONS(814),
    [anon_sym_fdiv] = ACTIONS(814),
    [anon_sym_frem] = ACTIONS(814),
    [anon_sym_xchg] = ACTIONS(814),
    [anon_sym_add] = ACTIONS(814),
    [anon_sym_sub] = ACTIONS(814),
    [anon_sym_and] = ACTIONS(814),
    [anon_sym_nand] = ACTIONS(814),
    [anon_sym_or] = ACTIONS(814),
    [anon_sym_xor] = ACTIONS(814),
    [anon_sym_max] = ACTIONS(814),
    [anon_sym_min] = ACTIONS(814),
    [anon_sym_umax] = ACTIONS(814),
    [anon_sym_umin] = ACTIONS(814),
    [anon_sym_fadd] = ACTIONS(814),
    [anon_sym_fsub] = ACTIONS(814),
    [anon_sym_bitcast] = ACTIONS(814),
    [anon_sym_trunc] = ACTIONS(814),
    [anon_sym_zext] = ACTIONS(814),
    [anon_sym_sext] = ACTIONS(814),
    [anon_sym_fptrunc] = ACTIONS(814),
    [anon_sym_fpext] = ACTIONS(814),
    [anon_sym_addrspacecast] = ACTIONS(814),
    [anon_sym_uitofp] = ACTIONS(814),
    [anon_sym_sitofp] = ACTIONS(814),
    [anon_sym_fptoui] = ACTIONS(814),
    [anon_sym_fptosi] = ACTIONS(814),
    [anon_sym_inttoptr] = ACTIONS(814),
    [anon_sym_ptrtoint] = ACTIONS(814),
    [anon_sym_uselistorder] = ACTIONS(814),
  },
  [212] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(855),
    [sym_local_var] = ACTIONS(855),
    [sym_label] = ACTIONS(855),
    [sym_string] = ACTIONS(857),
    [anon_sym_RBRACE] = ACTIONS(855),
    [anon_sym_LBRACK] = ACTIONS(855),
    [anon_sym_COMMA] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_align] = ACTIONS(857),
    [anon_sym_section] = ACTIONS(857),
    [anon_sym_partition] = ACTIONS(857),
    [anon_sym_comdat] = ACTIONS(857),
    [anon_sym_gc] = ACTIONS(857),
    [anon_sym_prefix] = ACTIONS(857),
    [anon_sym_prologue] = ACTIONS(857),
    [anon_sym_personality] = ACTIONS(857),
    [anon_sym_alignstack] = ACTIONS(857),
    [anon_sym_allocsize] = ACTIONS(857),
    [anon_sym_alwaysinline] = ACTIONS(857),
    [anon_sym_builtin] = ACTIONS(857),
    [anon_sym_cold] = ACTIONS(857),
    [anon_sym_convergent] = ACTIONS(857),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(857),
    [anon_sym_hot] = ACTIONS(857),
    [anon_sym_inaccessiblememonly] = ACTIONS(857),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(857),
    [anon_sym_inlinehint] = ACTIONS(857),
    [anon_sym_jumptable] = ACTIONS(857),
    [anon_sym_minsize] = ACTIONS(857),
    [anon_sym_naked] = ACTIONS(857),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(857),
    [anon_sym_nobuiltin] = ACTIONS(857),
    [anon_sym_noduplicate] = ACTIONS(857),
    [anon_sym_nofree] = ACTIONS(857),
    [anon_sym_noimplicitfloat] = ACTIONS(857),
    [anon_sym_noinline] = ACTIONS(857),
    [anon_sym_nomerge] = ACTIONS(857),
    [anon_sym_nonlazybind] = ACTIONS(857),
    [anon_sym_noprofile] = ACTIONS(857),
    [anon_sym_noredzone] = ACTIONS(857),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(857),
    [anon_sym_noreturn] = ACTIONS(857),
    [anon_sym_norecurse] = ACTIONS(857),
    [anon_sym_willreturn] = ACTIONS(857),
    [anon_sym_nosync] = ACTIONS(857),
    [anon_sym_nounwind] = ACTIONS(857),
    [anon_sym_nocallback] = ACTIONS(857),
    [anon_sym_nosanitize_coverage] = ACTIONS(857),
    [anon_sym_null_pointer_is_valid] = ACTIONS(857),
    [anon_sym_optforfuzzing] = ACTIONS(857),
    [anon_sym_optnone] = ACTIONS(857),
    [anon_sym_optsize] = ACTIONS(857),
    [anon_sym_readnone] = ACTIONS(857),
    [anon_sym_readonly] = ACTIONS(857),
    [anon_sym_writeonly] = ACTIONS(857),
    [anon_sym_argmemonly] = ACTIONS(857),
    [anon_sym_returns_twice] = ACTIONS(857),
    [anon_sym_safestack] = ACTIONS(857),
    [anon_sym_sanitize_address] = ACTIONS(857),
    [anon_sym_sanitize_memory] = ACTIONS(857),
    [anon_sym_sanitize_thread] = ACTIONS(857),
    [anon_sym_sanitize_hwaddress] = ACTIONS(857),
    [anon_sym_sanitize_memtag] = ACTIONS(857),
    [anon_sym_speculative_load_hardening] = ACTIONS(857),
    [anon_sym_speculatable] = ACTIONS(857),
    [anon_sym_ssp] = ACTIONS(857),
    [anon_sym_sspstrong] = ACTIONS(857),
    [anon_sym_sspreq] = ACTIONS(857),
    [anon_sym_strictfp] = ACTIONS(857),
    [anon_sym_nocf_check] = ACTIONS(857),
    [anon_sym_shadowcallstack] = ACTIONS(857),
    [anon_sym_mustprogress] = ACTIONS(857),
    [anon_sym_vscale_range] = ACTIONS(857),
    [anon_sym_preallocated] = ACTIONS(857),
    [anon_sym_zeroext] = ACTIONS(857),
    [anon_sym_signext] = ACTIONS(857),
    [anon_sym_inreg] = ACTIONS(857),
    [anon_sym_byval] = ACTIONS(857),
    [anon_sym_byref] = ACTIONS(857),
    [anon_sym_inalloca] = ACTIONS(857),
    [anon_sym_sret] = ACTIONS(857),
    [anon_sym_elementtype] = ACTIONS(857),
    [anon_sym_noalias] = ACTIONS(857),
    [anon_sym_nocapture] = ACTIONS(857),
    [anon_sym_nest] = ACTIONS(857),
    [anon_sym_returned] = ACTIONS(857),
    [anon_sym_nonnull] = ACTIONS(857),
    [anon_sym_dereferenceable] = ACTIONS(857),
    [anon_sym_dereferenceable_or_null] = ACTIONS(857),
    [anon_sym_swiftself] = ACTIONS(857),
    [anon_sym_swiftasync] = ACTIONS(857),
    [anon_sym_swifterror] = ACTIONS(857),
    [anon_sym_immarg] = ACTIONS(857),
    [anon_sym_noundef] = ACTIONS(857),
    [anon_sym_uwtable] = ACTIONS(857),
    [anon_sym_memory] = ACTIONS(857),
    [anon_sym_unreachable] = ACTIONS(857),
    [anon_sym_ret] = ACTIONS(857),
    [anon_sym_br] = ACTIONS(857),
    [anon_sym_resume] = ACTIONS(857),
    [anon_sym_freeze] = ACTIONS(857),
    [anon_sym_indirectbr] = ACTIONS(857),
    [anon_sym_extractelement] = ACTIONS(857),
    [anon_sym_insertelement] = ACTIONS(857),
    [anon_sym_select] = ACTIONS(857),
    [anon_sym_shufflevector] = ACTIONS(857),
    [anon_sym_fneg] = ACTIONS(857),
    [anon_sym_switch] = ACTIONS(857),
    [anon_sym_invoke] = ACTIONS(857),
    [anon_sym_cleanupret] = ACTIONS(857),
    [anon_sym_catchret] = ACTIONS(857),
    [anon_sym_catchswitch] = ACTIONS(857),
    [anon_sym_catchpad] = ACTIONS(857),
    [anon_sym_cleanuppad] = ACTIONS(857),
    [anon_sym_callbr] = ACTIONS(857),
    [anon_sym_icmp] = ACTIONS(857),
    [anon_sym_fcmp] = ACTIONS(857),
    [anon_sym_va_arg] = ACTIONS(857),
    [anon_sym_phi] = ACTIONS(857),
    [anon_sym_landingpad] = ACTIONS(857),
    [anon_sym_tail] = ACTIONS(857),
    [anon_sym_musttail] = ACTIONS(857),
    [anon_sym_notail] = ACTIONS(857),
    [anon_sym_call] = ACTIONS(857),
    [anon_sym_alloca] = ACTIONS(857),
    [anon_sym_load] = ACTIONS(857),
    [anon_sym_store] = ACTIONS(857),
    [anon_sym_cmpxchg] = ACTIONS(857),
    [anon_sym_atomicrmw] = ACTIONS(857),
    [anon_sym_fence] = ACTIONS(857),
    [anon_sym_getelementptr] = ACTIONS(857),
    [anon_sym_extractvalue] = ACTIONS(857),
    [anon_sym_insertvalue] = ACTIONS(857),
    [anon_sym_mul] = ACTIONS(857),
    [anon_sym_urem] = ACTIONS(857),
    [anon_sym_srem] = ACTIONS(857),
    [anon_sym_shl] = ACTIONS(857),
    [anon_sym_udiv] = ACTIONS(857),
    [anon_sym_sdiv] = ACTIONS(857),
    [anon_sym_lshr] = ACTIONS(857),
    [anon_sym_ashr] = ACTIONS(857),
    [anon_sym_fmul] = ACTIONS(857),
    [anon_sym_fdiv] = ACTIONS(857),
    [anon_sym_frem] = ACTIONS(857),
    [anon_sym_xchg] = ACTIONS(857),
    [anon_sym_add] = ACTIONS(857),
    [anon_sym_sub] = ACTIONS(857),
    [anon_sym_and] = ACTIONS(857),
    [anon_sym_nand] = ACTIONS(857),
    [anon_sym_or] = ACTIONS(857),
    [anon_sym_xor] = ACTIONS(857),
    [anon_sym_max] = ACTIONS(857),
    [anon_sym_min] = ACTIONS(857),
    [anon_sym_umax] = ACTIONS(857),
    [anon_sym_umin] = ACTIONS(857),
    [anon_sym_fadd] = ACTIONS(857),
    [anon_sym_fsub] = ACTIONS(857),
    [anon_sym_bitcast] = ACTIONS(857),
    [anon_sym_trunc] = ACTIONS(857),
    [anon_sym_zext] = ACTIONS(857),
    [anon_sym_sext] = ACTIONS(857),
    [anon_sym_fptrunc] = ACTIONS(857),
    [anon_sym_fpext] = ACTIONS(857),
    [anon_sym_addrspacecast] = ACTIONS(857),
    [anon_sym_uitofp] = ACTIONS(857),
    [anon_sym_sitofp] = ACTIONS(857),
    [anon_sym_fptoui] = ACTIONS(857),
    [anon_sym_fptosi] = ACTIONS(857),
    [anon_sym_inttoptr] = ACTIONS(857),
    [anon_sym_ptrtoint] = ACTIONS(857),
    [anon_sym_uselistorder] = ACTIONS(857),
  },
  [213] = {
    [sym_number] = STATE(232),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(812),
    [sym_local_var] = ACTIONS(812),
    [sym_string] = ACTIONS(812),
    [aux_sym_number_token1] = ACTIONS(872),
    [aux_sym_number_token2] = ACTIONS(874),
    [sym_float] = ACTIONS(812),
    [sym_cstring] = ACTIONS(812),
    [anon_sym_no_cfi] = ACTIONS(812),
    [anon_sym_private] = ACTIONS(812),
    [anon_sym_internal] = ACTIONS(812),
    [anon_sym_weak] = ACTIONS(814),
    [anon_sym_weak_odr] = ACTIONS(812),
    [anon_sym_linkonce] = ACTIONS(814),
    [anon_sym_linkonce_odr] = ACTIONS(812),
    [anon_sym_available_externally] = ACTIONS(812),
    [anon_sym_appending] = ACTIONS(812),
    [anon_sym_common] = ACTIONS(812),
    [anon_sym_extern_weak] = ACTIONS(812),
    [anon_sym_external] = ACTIONS(812),
    [anon_sym_dso_local] = ACTIONS(814),
    [anon_sym_dso_local_equivalent] = ACTIONS(812),
    [anon_sym_dso_preemptable] = ACTIONS(812),
    [anon_sym_default] = ACTIONS(812),
    [anon_sym_hidden] = ACTIONS(812),
    [anon_sym_protected] = ACTIONS(812),
    [anon_sym_dllimport] = ACTIONS(812),
    [anon_sym_dllexport] = ACTIONS(812),
    [anon_sym_LBRACE] = ACTIONS(812),
    [anon_sym_LT_LBRACE] = ACTIONS(812),
    [anon_sym_LBRACK] = ACTIONS(812),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_COMMA] = ACTIONS(812),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_RPAREN] = ACTIONS(812),
    [anon_sym_align] = ACTIONS(814),
    [anon_sym_alignstack] = ACTIONS(812),
    [anon_sym_allocsize] = ACTIONS(812),
    [anon_sym_alwaysinline] = ACTIONS(812),
    [anon_sym_builtin] = ACTIONS(812),
    [anon_sym_cold] = ACTIONS(812),
    [anon_sym_convergent] = ACTIONS(812),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(812),
    [anon_sym_hot] = ACTIONS(812),
    [anon_sym_inaccessiblememonly] = ACTIONS(812),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(812),
    [anon_sym_inlinehint] = ACTIONS(812),
    [anon_sym_jumptable] = ACTIONS(812),
    [anon_sym_minsize] = ACTIONS(812),
    [anon_sym_naked] = ACTIONS(812),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(812),
    [anon_sym_nobuiltin] = ACTIONS(812),
    [anon_sym_noduplicate] = ACTIONS(812),
    [anon_sym_nofree] = ACTIONS(812),
    [anon_sym_noimplicitfloat] = ACTIONS(812),
    [anon_sym_noinline] = ACTIONS(812),
    [anon_sym_nomerge] = ACTIONS(812),
    [anon_sym_nonlazybind] = ACTIONS(812),
    [anon_sym_noprofile] = ACTIONS(812),
    [anon_sym_noredzone] = ACTIONS(812),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(812),
    [anon_sym_noreturn] = ACTIONS(812),
    [anon_sym_norecurse] = ACTIONS(812),
    [anon_sym_willreturn] = ACTIONS(812),
    [anon_sym_nosync] = ACTIONS(812),
    [anon_sym_nounwind] = ACTIONS(812),
    [anon_sym_nocallback] = ACTIONS(812),
    [anon_sym_nosanitize_coverage] = ACTIONS(812),
    [anon_sym_null_pointer_is_valid] = ACTIONS(812),
    [anon_sym_optforfuzzing] = ACTIONS(812),
    [anon_sym_optnone] = ACTIONS(812),
    [anon_sym_optsize] = ACTIONS(812),
    [anon_sym_readnone] = ACTIONS(812),
    [anon_sym_readonly] = ACTIONS(812),
    [anon_sym_writeonly] = ACTIONS(812),
    [anon_sym_argmemonly] = ACTIONS(812),
    [anon_sym_returns_twice] = ACTIONS(812),
    [anon_sym_safestack] = ACTIONS(812),
    [anon_sym_sanitize_address] = ACTIONS(812),
    [anon_sym_sanitize_memory] = ACTIONS(812),
    [anon_sym_sanitize_thread] = ACTIONS(812),
    [anon_sym_sanitize_hwaddress] = ACTIONS(812),
    [anon_sym_sanitize_memtag] = ACTIONS(812),
    [anon_sym_speculative_load_hardening] = ACTIONS(812),
    [anon_sym_speculatable] = ACTIONS(812),
    [anon_sym_ssp] = ACTIONS(814),
    [anon_sym_sspstrong] = ACTIONS(812),
    [anon_sym_sspreq] = ACTIONS(812),
    [anon_sym_strictfp] = ACTIONS(812),
    [anon_sym_nocf_check] = ACTIONS(812),
    [anon_sym_shadowcallstack] = ACTIONS(812),
    [anon_sym_mustprogress] = ACTIONS(812),
    [anon_sym_vscale_range] = ACTIONS(812),
    [anon_sym_preallocated] = ACTIONS(812),
    [anon_sym_zeroext] = ACTIONS(812),
    [anon_sym_signext] = ACTIONS(812),
    [anon_sym_inreg] = ACTIONS(812),
    [anon_sym_byval] = ACTIONS(812),
    [anon_sym_byref] = ACTIONS(812),
    [anon_sym_inalloca] = ACTIONS(812),
    [anon_sym_sret] = ACTIONS(812),
    [anon_sym_elementtype] = ACTIONS(812),
    [anon_sym_noalias] = ACTIONS(812),
    [anon_sym_nocapture] = ACTIONS(812),
    [anon_sym_nest] = ACTIONS(812),
    [anon_sym_returned] = ACTIONS(812),
    [anon_sym_nonnull] = ACTIONS(812),
    [anon_sym_dereferenceable] = ACTIONS(814),
    [anon_sym_dereferenceable_or_null] = ACTIONS(812),
    [anon_sym_swiftself] = ACTIONS(812),
    [anon_sym_swiftasync] = ACTIONS(812),
    [anon_sym_swifterror] = ACTIONS(812),
    [anon_sym_immarg] = ACTIONS(812),
    [anon_sym_noundef] = ACTIONS(812),
    [anon_sym_uwtable] = ACTIONS(812),
    [anon_sym_memory] = ACTIONS(812),
    [anon_sym_none] = ACTIONS(812),
    [anon_sym_extractelement] = ACTIONS(812),
    [anon_sym_insertelement] = ACTIONS(812),
    [anon_sym_select] = ACTIONS(812),
    [anon_sym_shufflevector] = ACTIONS(812),
    [anon_sym_fneg] = ACTIONS(812),
    [anon_sym_icmp] = ACTIONS(812),
    [anon_sym_fcmp] = ACTIONS(812),
    [anon_sym_getelementptr] = ACTIONS(812),
    [anon_sym_extractvalue] = ACTIONS(812),
    [anon_sym_insertvalue] = ACTIONS(812),
    [anon_sym_true] = ACTIONS(812),
    [anon_sym_false] = ACTIONS(812),
    [anon_sym_null] = ACTIONS(814),
    [anon_sym_undef] = ACTIONS(812),
    [anon_sym_poison] = ACTIONS(812),
    [anon_sym_zeroinitializer] = ACTIONS(812),
    [anon_sym_blockaddress] = ACTIONS(812),
    [anon_sym_mul] = ACTIONS(812),
    [anon_sym_urem] = ACTIONS(812),
    [anon_sym_srem] = ACTIONS(812),
    [anon_sym_shl] = ACTIONS(812),
    [anon_sym_udiv] = ACTIONS(812),
    [anon_sym_sdiv] = ACTIONS(812),
    [anon_sym_lshr] = ACTIONS(812),
    [anon_sym_ashr] = ACTIONS(812),
    [anon_sym_fmul] = ACTIONS(812),
    [anon_sym_fdiv] = ACTIONS(812),
    [anon_sym_frem] = ACTIONS(812),
    [anon_sym_xchg] = ACTIONS(812),
    [anon_sym_add] = ACTIONS(814),
    [anon_sym_sub] = ACTIONS(812),
    [anon_sym_and] = ACTIONS(812),
    [anon_sym_nand] = ACTIONS(812),
    [anon_sym_or] = ACTIONS(812),
    [anon_sym_xor] = ACTIONS(812),
    [anon_sym_max] = ACTIONS(812),
    [anon_sym_min] = ACTIONS(814),
    [anon_sym_umax] = ACTIONS(812),
    [anon_sym_umin] = ACTIONS(812),
    [anon_sym_fadd] = ACTIONS(812),
    [anon_sym_fsub] = ACTIONS(812),
    [anon_sym_bitcast] = ACTIONS(812),
    [anon_sym_trunc] = ACTIONS(812),
    [anon_sym_zext] = ACTIONS(812),
    [anon_sym_sext] = ACTIONS(812),
    [anon_sym_fptrunc] = ACTIONS(812),
    [anon_sym_fpext] = ACTIONS(812),
    [anon_sym_addrspacecast] = ACTIONS(812),
    [anon_sym_uitofp] = ACTIONS(812),
    [anon_sym_sitofp] = ACTIONS(812),
    [anon_sym_fptoui] = ACTIONS(812),
    [anon_sym_fptosi] = ACTIONS(812),
    [anon_sym_inttoptr] = ACTIONS(812),
    [anon_sym_ptrtoint] = ACTIONS(812),
  },
  [214] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(855),
    [sym_local_var] = ACTIONS(855),
    [sym_label] = ACTIONS(855),
    [sym_string] = ACTIONS(857),
    [anon_sym_RBRACE] = ACTIONS(855),
    [anon_sym_LBRACK] = ACTIONS(855),
    [anon_sym_COMMA] = ACTIONS(855),
    [anon_sym_align] = ACTIONS(857),
    [anon_sym_section] = ACTIONS(857),
    [anon_sym_partition] = ACTIONS(857),
    [anon_sym_comdat] = ACTIONS(857),
    [anon_sym_gc] = ACTIONS(857),
    [anon_sym_prefix] = ACTIONS(857),
    [anon_sym_prologue] = ACTIONS(857),
    [anon_sym_personality] = ACTIONS(857),
    [anon_sym_alignstack] = ACTIONS(857),
    [anon_sym_allocsize] = ACTIONS(857),
    [anon_sym_alwaysinline] = ACTIONS(857),
    [anon_sym_builtin] = ACTIONS(857),
    [anon_sym_cold] = ACTIONS(857),
    [anon_sym_convergent] = ACTIONS(857),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(857),
    [anon_sym_hot] = ACTIONS(857),
    [anon_sym_inaccessiblememonly] = ACTIONS(857),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(857),
    [anon_sym_inlinehint] = ACTIONS(857),
    [anon_sym_jumptable] = ACTIONS(857),
    [anon_sym_minsize] = ACTIONS(857),
    [anon_sym_naked] = ACTIONS(857),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(857),
    [anon_sym_nobuiltin] = ACTIONS(857),
    [anon_sym_noduplicate] = ACTIONS(857),
    [anon_sym_nofree] = ACTIONS(857),
    [anon_sym_noimplicitfloat] = ACTIONS(857),
    [anon_sym_noinline] = ACTIONS(857),
    [anon_sym_nomerge] = ACTIONS(857),
    [anon_sym_nonlazybind] = ACTIONS(857),
    [anon_sym_noprofile] = ACTIONS(857),
    [anon_sym_noredzone] = ACTIONS(857),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(857),
    [anon_sym_noreturn] = ACTIONS(857),
    [anon_sym_norecurse] = ACTIONS(857),
    [anon_sym_willreturn] = ACTIONS(857),
    [anon_sym_nosync] = ACTIONS(857),
    [anon_sym_nounwind] = ACTIONS(857),
    [anon_sym_nocallback] = ACTIONS(857),
    [anon_sym_nosanitize_coverage] = ACTIONS(857),
    [anon_sym_null_pointer_is_valid] = ACTIONS(857),
    [anon_sym_optforfuzzing] = ACTIONS(857),
    [anon_sym_optnone] = ACTIONS(857),
    [anon_sym_optsize] = ACTIONS(857),
    [anon_sym_readnone] = ACTIONS(857),
    [anon_sym_readonly] = ACTIONS(857),
    [anon_sym_writeonly] = ACTIONS(857),
    [anon_sym_argmemonly] = ACTIONS(857),
    [anon_sym_returns_twice] = ACTIONS(857),
    [anon_sym_safestack] = ACTIONS(857),
    [anon_sym_sanitize_address] = ACTIONS(857),
    [anon_sym_sanitize_memory] = ACTIONS(857),
    [anon_sym_sanitize_thread] = ACTIONS(857),
    [anon_sym_sanitize_hwaddress] = ACTIONS(857),
    [anon_sym_sanitize_memtag] = ACTIONS(857),
    [anon_sym_speculative_load_hardening] = ACTIONS(857),
    [anon_sym_speculatable] = ACTIONS(857),
    [anon_sym_ssp] = ACTIONS(857),
    [anon_sym_sspstrong] = ACTIONS(857),
    [anon_sym_sspreq] = ACTIONS(857),
    [anon_sym_strictfp] = ACTIONS(857),
    [anon_sym_nocf_check] = ACTIONS(857),
    [anon_sym_shadowcallstack] = ACTIONS(857),
    [anon_sym_mustprogress] = ACTIONS(857),
    [anon_sym_vscale_range] = ACTIONS(857),
    [anon_sym_preallocated] = ACTIONS(857),
    [anon_sym_zeroext] = ACTIONS(857),
    [anon_sym_signext] = ACTIONS(857),
    [anon_sym_inreg] = ACTIONS(857),
    [anon_sym_byval] = ACTIONS(857),
    [anon_sym_byref] = ACTIONS(857),
    [anon_sym_inalloca] = ACTIONS(857),
    [anon_sym_sret] = ACTIONS(857),
    [anon_sym_elementtype] = ACTIONS(857),
    [anon_sym_noalias] = ACTIONS(857),
    [anon_sym_nocapture] = ACTIONS(857),
    [anon_sym_nest] = ACTIONS(857),
    [anon_sym_returned] = ACTIONS(857),
    [anon_sym_nonnull] = ACTIONS(857),
    [anon_sym_dereferenceable] = ACTIONS(857),
    [anon_sym_dereferenceable_or_null] = ACTIONS(857),
    [anon_sym_swiftself] = ACTIONS(857),
    [anon_sym_swiftasync] = ACTIONS(857),
    [anon_sym_swifterror] = ACTIONS(857),
    [anon_sym_immarg] = ACTIONS(857),
    [anon_sym_noundef] = ACTIONS(857),
    [anon_sym_uwtable] = ACTIONS(857),
    [anon_sym_memory] = ACTIONS(857),
    [anon_sym_unreachable] = ACTIONS(857),
    [anon_sym_ret] = ACTIONS(857),
    [anon_sym_br] = ACTIONS(857),
    [anon_sym_resume] = ACTIONS(857),
    [anon_sym_freeze] = ACTIONS(857),
    [anon_sym_indirectbr] = ACTIONS(857),
    [anon_sym_extractelement] = ACTIONS(857),
    [anon_sym_insertelement] = ACTIONS(857),
    [anon_sym_select] = ACTIONS(857),
    [anon_sym_shufflevector] = ACTIONS(857),
    [anon_sym_fneg] = ACTIONS(857),
    [anon_sym_switch] = ACTIONS(857),
    [anon_sym_invoke] = ACTIONS(857),
    [anon_sym_cleanupret] = ACTIONS(857),
    [anon_sym_catchret] = ACTIONS(857),
    [anon_sym_catchswitch] = ACTIONS(857),
    [anon_sym_catchpad] = ACTIONS(857),
    [anon_sym_cleanuppad] = ACTIONS(857),
    [anon_sym_callbr] = ACTIONS(857),
    [anon_sym_icmp] = ACTIONS(857),
    [anon_sym_fcmp] = ACTIONS(857),
    [anon_sym_va_arg] = ACTIONS(857),
    [anon_sym_phi] = ACTIONS(857),
    [anon_sym_landingpad] = ACTIONS(857),
    [anon_sym_tail] = ACTIONS(857),
    [anon_sym_musttail] = ACTIONS(857),
    [anon_sym_notail] = ACTIONS(857),
    [anon_sym_call] = ACTIONS(857),
    [anon_sym_alloca] = ACTIONS(857),
    [anon_sym_load] = ACTIONS(857),
    [anon_sym_store] = ACTIONS(857),
    [anon_sym_cmpxchg] = ACTIONS(857),
    [anon_sym_atomicrmw] = ACTIONS(857),
    [anon_sym_fence] = ACTIONS(857),
    [anon_sym_getelementptr] = ACTIONS(857),
    [anon_sym_extractvalue] = ACTIONS(857),
    [anon_sym_insertvalue] = ACTIONS(857),
    [anon_sym_mul] = ACTIONS(857),
    [anon_sym_urem] = ACTIONS(857),
    [anon_sym_srem] = ACTIONS(857),
    [anon_sym_shl] = ACTIONS(857),
    [anon_sym_udiv] = ACTIONS(857),
    [anon_sym_sdiv] = ACTIONS(857),
    [anon_sym_lshr] = ACTIONS(857),
    [anon_sym_ashr] = ACTIONS(857),
    [anon_sym_fmul] = ACTIONS(857),
    [anon_sym_fdiv] = ACTIONS(857),
    [anon_sym_frem] = ACTIONS(857),
    [anon_sym_xchg] = ACTIONS(857),
    [anon_sym_add] = ACTIONS(857),
    [anon_sym_sub] = ACTIONS(857),
    [anon_sym_and] = ACTIONS(857),
    [anon_sym_nand] = ACTIONS(857),
    [anon_sym_or] = ACTIONS(857),
    [anon_sym_xor] = ACTIONS(857),
    [anon_sym_max] = ACTIONS(857),
    [anon_sym_min] = ACTIONS(857),
    [anon_sym_umax] = ACTIONS(857),
    [anon_sym_umin] = ACTIONS(857),
    [anon_sym_fadd] = ACTIONS(857),
    [anon_sym_fsub] = ACTIONS(857),
    [anon_sym_bitcast] = ACTIONS(857),
    [anon_sym_trunc] = ACTIONS(857),
    [anon_sym_zext] = ACTIONS(857),
    [anon_sym_sext] = ACTIONS(857),
    [anon_sym_fptrunc] = ACTIONS(857),
    [anon_sym_fpext] = ACTIONS(857),
    [anon_sym_addrspacecast] = ACTIONS(857),
    [anon_sym_uitofp] = ACTIONS(857),
    [anon_sym_sitofp] = ACTIONS(857),
    [anon_sym_fptoui] = ACTIONS(857),
    [anon_sym_fptosi] = ACTIONS(857),
    [anon_sym_inttoptr] = ACTIONS(857),
    [anon_sym_ptrtoint] = ACTIONS(857),
    [anon_sym_uselistorder] = ACTIONS(857),
  },
  [215] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(843),
    [sym_local_var] = ACTIONS(843),
    [sym_string] = ACTIONS(843),
    [aux_sym_number_token1] = ACTIONS(845),
    [aux_sym_number_token2] = ACTIONS(843),
    [sym_float] = ACTIONS(843),
    [sym_cstring] = ACTIONS(843),
    [anon_sym_no_cfi] = ACTIONS(843),
    [anon_sym_private] = ACTIONS(843),
    [anon_sym_internal] = ACTIONS(843),
    [anon_sym_weak] = ACTIONS(845),
    [anon_sym_weak_odr] = ACTIONS(843),
    [anon_sym_linkonce] = ACTIONS(845),
    [anon_sym_linkonce_odr] = ACTIONS(843),
    [anon_sym_available_externally] = ACTIONS(843),
    [anon_sym_appending] = ACTIONS(843),
    [anon_sym_common] = ACTIONS(843),
    [anon_sym_extern_weak] = ACTIONS(843),
    [anon_sym_external] = ACTIONS(843),
    [anon_sym_dso_local] = ACTIONS(845),
    [anon_sym_dso_local_equivalent] = ACTIONS(843),
    [anon_sym_dso_preemptable] = ACTIONS(843),
    [anon_sym_default] = ACTIONS(843),
    [anon_sym_hidden] = ACTIONS(843),
    [anon_sym_protected] = ACTIONS(843),
    [anon_sym_dllimport] = ACTIONS(843),
    [anon_sym_dllexport] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_LT_LBRACE] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(845),
    [anon_sym_COMMA] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_RPAREN] = ACTIONS(843),
    [anon_sym_align] = ACTIONS(845),
    [anon_sym_alignstack] = ACTIONS(843),
    [anon_sym_allocsize] = ACTIONS(843),
    [anon_sym_alwaysinline] = ACTIONS(843),
    [anon_sym_builtin] = ACTIONS(843),
    [anon_sym_cold] = ACTIONS(843),
    [anon_sym_convergent] = ACTIONS(843),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(843),
    [anon_sym_hot] = ACTIONS(843),
    [anon_sym_inaccessiblememonly] = ACTIONS(843),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(843),
    [anon_sym_inlinehint] = ACTIONS(843),
    [anon_sym_jumptable] = ACTIONS(843),
    [anon_sym_minsize] = ACTIONS(843),
    [anon_sym_naked] = ACTIONS(843),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(843),
    [anon_sym_nobuiltin] = ACTIONS(843),
    [anon_sym_noduplicate] = ACTIONS(843),
    [anon_sym_nofree] = ACTIONS(843),
    [anon_sym_noimplicitfloat] = ACTIONS(843),
    [anon_sym_noinline] = ACTIONS(843),
    [anon_sym_nomerge] = ACTIONS(843),
    [anon_sym_nonlazybind] = ACTIONS(843),
    [anon_sym_noprofile] = ACTIONS(843),
    [anon_sym_noredzone] = ACTIONS(843),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(843),
    [anon_sym_noreturn] = ACTIONS(843),
    [anon_sym_norecurse] = ACTIONS(843),
    [anon_sym_willreturn] = ACTIONS(843),
    [anon_sym_nosync] = ACTIONS(843),
    [anon_sym_nounwind] = ACTIONS(843),
    [anon_sym_nocallback] = ACTIONS(843),
    [anon_sym_nosanitize_coverage] = ACTIONS(843),
    [anon_sym_null_pointer_is_valid] = ACTIONS(843),
    [anon_sym_optforfuzzing] = ACTIONS(843),
    [anon_sym_optnone] = ACTIONS(843),
    [anon_sym_optsize] = ACTIONS(843),
    [anon_sym_readnone] = ACTIONS(843),
    [anon_sym_readonly] = ACTIONS(843),
    [anon_sym_writeonly] = ACTIONS(843),
    [anon_sym_argmemonly] = ACTIONS(843),
    [anon_sym_returns_twice] = ACTIONS(843),
    [anon_sym_safestack] = ACTIONS(843),
    [anon_sym_sanitize_address] = ACTIONS(843),
    [anon_sym_sanitize_memory] = ACTIONS(843),
    [anon_sym_sanitize_thread] = ACTIONS(843),
    [anon_sym_sanitize_hwaddress] = ACTIONS(843),
    [anon_sym_sanitize_memtag] = ACTIONS(843),
    [anon_sym_speculative_load_hardening] = ACTIONS(843),
    [anon_sym_speculatable] = ACTIONS(843),
    [anon_sym_ssp] = ACTIONS(845),
    [anon_sym_sspstrong] = ACTIONS(843),
    [anon_sym_sspreq] = ACTIONS(843),
    [anon_sym_strictfp] = ACTIONS(843),
    [anon_sym_nocf_check] = ACTIONS(843),
    [anon_sym_shadowcallstack] = ACTIONS(843),
    [anon_sym_mustprogress] = ACTIONS(843),
    [anon_sym_vscale_range] = ACTIONS(843),
    [anon_sym_preallocated] = ACTIONS(843),
    [anon_sym_zeroext] = ACTIONS(843),
    [anon_sym_signext] = ACTIONS(843),
    [anon_sym_inreg] = ACTIONS(843),
    [anon_sym_byval] = ACTIONS(843),
    [anon_sym_byref] = ACTIONS(843),
    [anon_sym_inalloca] = ACTIONS(843),
    [anon_sym_sret] = ACTIONS(843),
    [anon_sym_elementtype] = ACTIONS(843),
    [anon_sym_noalias] = ACTIONS(843),
    [anon_sym_nocapture] = ACTIONS(843),
    [anon_sym_nest] = ACTIONS(843),
    [anon_sym_returned] = ACTIONS(843),
    [anon_sym_nonnull] = ACTIONS(843),
    [anon_sym_dereferenceable] = ACTIONS(845),
    [anon_sym_dereferenceable_or_null] = ACTIONS(843),
    [anon_sym_swiftself] = ACTIONS(843),
    [anon_sym_swiftasync] = ACTIONS(843),
    [anon_sym_swifterror] = ACTIONS(843),
    [anon_sym_immarg] = ACTIONS(843),
    [anon_sym_noundef] = ACTIONS(843),
    [anon_sym_uwtable] = ACTIONS(843),
    [anon_sym_memory] = ACTIONS(843),
    [anon_sym_none] = ACTIONS(843),
    [anon_sym_extractelement] = ACTIONS(843),
    [anon_sym_insertelement] = ACTIONS(843),
    [anon_sym_select] = ACTIONS(843),
    [anon_sym_shufflevector] = ACTIONS(843),
    [anon_sym_fneg] = ACTIONS(843),
    [anon_sym_icmp] = ACTIONS(843),
    [anon_sym_fcmp] = ACTIONS(843),
    [anon_sym_getelementptr] = ACTIONS(843),
    [anon_sym_extractvalue] = ACTIONS(843),
    [anon_sym_insertvalue] = ACTIONS(843),
    [anon_sym_true] = ACTIONS(843),
    [anon_sym_false] = ACTIONS(843),
    [anon_sym_null] = ACTIONS(845),
    [anon_sym_undef] = ACTIONS(843),
    [anon_sym_poison] = ACTIONS(843),
    [anon_sym_zeroinitializer] = ACTIONS(843),
    [anon_sym_blockaddress] = ACTIONS(843),
    [anon_sym_mul] = ACTIONS(843),
    [anon_sym_urem] = ACTIONS(843),
    [anon_sym_srem] = ACTIONS(843),
    [anon_sym_shl] = ACTIONS(843),
    [anon_sym_udiv] = ACTIONS(843),
    [anon_sym_sdiv] = ACTIONS(843),
    [anon_sym_lshr] = ACTIONS(843),
    [anon_sym_ashr] = ACTIONS(843),
    [anon_sym_fmul] = ACTIONS(843),
    [anon_sym_fdiv] = ACTIONS(843),
    [anon_sym_frem] = ACTIONS(843),
    [anon_sym_xchg] = ACTIONS(843),
    [anon_sym_add] = ACTIONS(845),
    [anon_sym_sub] = ACTIONS(843),
    [anon_sym_and] = ACTIONS(843),
    [anon_sym_nand] = ACTIONS(843),
    [anon_sym_or] = ACTIONS(843),
    [anon_sym_xor] = ACTIONS(843),
    [anon_sym_max] = ACTIONS(843),
    [anon_sym_min] = ACTIONS(845),
    [anon_sym_umax] = ACTIONS(843),
    [anon_sym_umin] = ACTIONS(843),
    [anon_sym_fadd] = ACTIONS(843),
    [anon_sym_fsub] = ACTIONS(843),
    [anon_sym_bitcast] = ACTIONS(843),
    [anon_sym_trunc] = ACTIONS(843),
    [anon_sym_zext] = ACTIONS(843),
    [anon_sym_sext] = ACTIONS(843),
    [anon_sym_fptrunc] = ACTIONS(843),
    [anon_sym_fpext] = ACTIONS(843),
    [anon_sym_addrspacecast] = ACTIONS(843),
    [anon_sym_uitofp] = ACTIONS(843),
    [anon_sym_sitofp] = ACTIONS(843),
    [anon_sym_fptoui] = ACTIONS(843),
    [anon_sym_fptosi] = ACTIONS(843),
    [anon_sym_inttoptr] = ACTIONS(843),
    [anon_sym_ptrtoint] = ACTIONS(843),
  },
  [216] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(812),
    [sym_local_var] = ACTIONS(812),
    [sym_string] = ACTIONS(812),
    [aux_sym_number_token1] = ACTIONS(814),
    [aux_sym_number_token2] = ACTIONS(812),
    [sym_float] = ACTIONS(812),
    [sym_cstring] = ACTIONS(812),
    [anon_sym_no_cfi] = ACTIONS(812),
    [anon_sym_private] = ACTIONS(812),
    [anon_sym_internal] = ACTIONS(812),
    [anon_sym_weak] = ACTIONS(814),
    [anon_sym_weak_odr] = ACTIONS(812),
    [anon_sym_linkonce] = ACTIONS(814),
    [anon_sym_linkonce_odr] = ACTIONS(812),
    [anon_sym_available_externally] = ACTIONS(812),
    [anon_sym_appending] = ACTIONS(812),
    [anon_sym_common] = ACTIONS(812),
    [anon_sym_extern_weak] = ACTIONS(812),
    [anon_sym_external] = ACTIONS(812),
    [anon_sym_dso_local] = ACTIONS(814),
    [anon_sym_dso_local_equivalent] = ACTIONS(812),
    [anon_sym_dso_preemptable] = ACTIONS(812),
    [anon_sym_default] = ACTIONS(812),
    [anon_sym_hidden] = ACTIONS(812),
    [anon_sym_protected] = ACTIONS(812),
    [anon_sym_dllimport] = ACTIONS(812),
    [anon_sym_dllexport] = ACTIONS(812),
    [anon_sym_LBRACE] = ACTIONS(812),
    [anon_sym_LT_LBRACE] = ACTIONS(812),
    [anon_sym_LBRACK] = ACTIONS(812),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_COMMA] = ACTIONS(812),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_RPAREN] = ACTIONS(812),
    [anon_sym_align] = ACTIONS(814),
    [anon_sym_alignstack] = ACTIONS(812),
    [anon_sym_allocsize] = ACTIONS(812),
    [anon_sym_alwaysinline] = ACTIONS(812),
    [anon_sym_builtin] = ACTIONS(812),
    [anon_sym_cold] = ACTIONS(812),
    [anon_sym_convergent] = ACTIONS(812),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(812),
    [anon_sym_hot] = ACTIONS(812),
    [anon_sym_inaccessiblememonly] = ACTIONS(812),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(812),
    [anon_sym_inlinehint] = ACTIONS(812),
    [anon_sym_jumptable] = ACTIONS(812),
    [anon_sym_minsize] = ACTIONS(812),
    [anon_sym_naked] = ACTIONS(812),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(812),
    [anon_sym_nobuiltin] = ACTIONS(812),
    [anon_sym_noduplicate] = ACTIONS(812),
    [anon_sym_nofree] = ACTIONS(812),
    [anon_sym_noimplicitfloat] = ACTIONS(812),
    [anon_sym_noinline] = ACTIONS(812),
    [anon_sym_nomerge] = ACTIONS(812),
    [anon_sym_nonlazybind] = ACTIONS(812),
    [anon_sym_noprofile] = ACTIONS(812),
    [anon_sym_noredzone] = ACTIONS(812),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(812),
    [anon_sym_noreturn] = ACTIONS(812),
    [anon_sym_norecurse] = ACTIONS(812),
    [anon_sym_willreturn] = ACTIONS(812),
    [anon_sym_nosync] = ACTIONS(812),
    [anon_sym_nounwind] = ACTIONS(812),
    [anon_sym_nocallback] = ACTIONS(812),
    [anon_sym_nosanitize_coverage] = ACTIONS(812),
    [anon_sym_null_pointer_is_valid] = ACTIONS(812),
    [anon_sym_optforfuzzing] = ACTIONS(812),
    [anon_sym_optnone] = ACTIONS(812),
    [anon_sym_optsize] = ACTIONS(812),
    [anon_sym_readnone] = ACTIONS(812),
    [anon_sym_readonly] = ACTIONS(812),
    [anon_sym_writeonly] = ACTIONS(812),
    [anon_sym_argmemonly] = ACTIONS(812),
    [anon_sym_returns_twice] = ACTIONS(812),
    [anon_sym_safestack] = ACTIONS(812),
    [anon_sym_sanitize_address] = ACTIONS(812),
    [anon_sym_sanitize_memory] = ACTIONS(812),
    [anon_sym_sanitize_thread] = ACTIONS(812),
    [anon_sym_sanitize_hwaddress] = ACTIONS(812),
    [anon_sym_sanitize_memtag] = ACTIONS(812),
    [anon_sym_speculative_load_hardening] = ACTIONS(812),
    [anon_sym_speculatable] = ACTIONS(812),
    [anon_sym_ssp] = ACTIONS(814),
    [anon_sym_sspstrong] = ACTIONS(812),
    [anon_sym_sspreq] = ACTIONS(812),
    [anon_sym_strictfp] = ACTIONS(812),
    [anon_sym_nocf_check] = ACTIONS(812),
    [anon_sym_shadowcallstack] = ACTIONS(812),
    [anon_sym_mustprogress] = ACTIONS(812),
    [anon_sym_vscale_range] = ACTIONS(812),
    [anon_sym_preallocated] = ACTIONS(812),
    [anon_sym_zeroext] = ACTIONS(812),
    [anon_sym_signext] = ACTIONS(812),
    [anon_sym_inreg] = ACTIONS(812),
    [anon_sym_byval] = ACTIONS(812),
    [anon_sym_byref] = ACTIONS(812),
    [anon_sym_inalloca] = ACTIONS(812),
    [anon_sym_sret] = ACTIONS(812),
    [anon_sym_elementtype] = ACTIONS(812),
    [anon_sym_noalias] = ACTIONS(812),
    [anon_sym_nocapture] = ACTIONS(812),
    [anon_sym_nest] = ACTIONS(812),
    [anon_sym_returned] = ACTIONS(812),
    [anon_sym_nonnull] = ACTIONS(812),
    [anon_sym_dereferenceable] = ACTIONS(814),
    [anon_sym_dereferenceable_or_null] = ACTIONS(812),
    [anon_sym_swiftself] = ACTIONS(812),
    [anon_sym_swiftasync] = ACTIONS(812),
    [anon_sym_swifterror] = ACTIONS(812),
    [anon_sym_immarg] = ACTIONS(812),
    [anon_sym_noundef] = ACTIONS(812),
    [anon_sym_uwtable] = ACTIONS(812),
    [anon_sym_memory] = ACTIONS(812),
    [anon_sym_none] = ACTIONS(812),
    [anon_sym_extractelement] = ACTIONS(812),
    [anon_sym_insertelement] = ACTIONS(812),
    [anon_sym_select] = ACTIONS(812),
    [anon_sym_shufflevector] = ACTIONS(812),
    [anon_sym_fneg] = ACTIONS(812),
    [anon_sym_icmp] = ACTIONS(812),
    [anon_sym_fcmp] = ACTIONS(812),
    [anon_sym_getelementptr] = ACTIONS(812),
    [anon_sym_extractvalue] = ACTIONS(812),
    [anon_sym_insertvalue] = ACTIONS(812),
    [anon_sym_true] = ACTIONS(812),
    [anon_sym_false] = ACTIONS(812),
    [anon_sym_null] = ACTIONS(814),
    [anon_sym_undef] = ACTIONS(812),
    [anon_sym_poison] = ACTIONS(812),
    [anon_sym_zeroinitializer] = ACTIONS(812),
    [anon_sym_blockaddress] = ACTIONS(812),
    [anon_sym_mul] = ACTIONS(812),
    [anon_sym_urem] = ACTIONS(812),
    [anon_sym_srem] = ACTIONS(812),
    [anon_sym_shl] = ACTIONS(812),
    [anon_sym_udiv] = ACTIONS(812),
    [anon_sym_sdiv] = ACTIONS(812),
    [anon_sym_lshr] = ACTIONS(812),
    [anon_sym_ashr] = ACTIONS(812),
    [anon_sym_fmul] = ACTIONS(812),
    [anon_sym_fdiv] = ACTIONS(812),
    [anon_sym_frem] = ACTIONS(812),
    [anon_sym_xchg] = ACTIONS(812),
    [anon_sym_add] = ACTIONS(814),
    [anon_sym_sub] = ACTIONS(812),
    [anon_sym_and] = ACTIONS(812),
    [anon_sym_nand] = ACTIONS(812),
    [anon_sym_or] = ACTIONS(812),
    [anon_sym_xor] = ACTIONS(812),
    [anon_sym_max] = ACTIONS(812),
    [anon_sym_min] = ACTIONS(814),
    [anon_sym_umax] = ACTIONS(812),
    [anon_sym_umin] = ACTIONS(812),
    [anon_sym_fadd] = ACTIONS(812),
    [anon_sym_fsub] = ACTIONS(812),
    [anon_sym_bitcast] = ACTIONS(812),
    [anon_sym_trunc] = ACTIONS(812),
    [anon_sym_zext] = ACTIONS(812),
    [anon_sym_sext] = ACTIONS(812),
    [anon_sym_fptrunc] = ACTIONS(812),
    [anon_sym_fpext] = ACTIONS(812),
    [anon_sym_addrspacecast] = ACTIONS(812),
    [anon_sym_uitofp] = ACTIONS(812),
    [anon_sym_sitofp] = ACTIONS(812),
    [anon_sym_fptoui] = ACTIONS(812),
    [anon_sym_fptosi] = ACTIONS(812),
    [anon_sym_inttoptr] = ACTIONS(812),
    [anon_sym_ptrtoint] = ACTIONS(812),
  },
  [217] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(876),
    [sym_local_var] = ACTIONS(876),
    [sym_label] = ACTIONS(876),
    [sym_string] = ACTIONS(878),
    [anon_sym_RBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(876),
    [anon_sym_COMMA] = ACTIONS(876),
    [anon_sym_align] = ACTIONS(878),
    [anon_sym_section] = ACTIONS(878),
    [anon_sym_partition] = ACTIONS(878),
    [anon_sym_comdat] = ACTIONS(878),
    [anon_sym_gc] = ACTIONS(878),
    [anon_sym_prefix] = ACTIONS(878),
    [anon_sym_prologue] = ACTIONS(878),
    [anon_sym_personality] = ACTIONS(878),
    [anon_sym_alignstack] = ACTIONS(878),
    [anon_sym_allocsize] = ACTIONS(878),
    [anon_sym_alwaysinline] = ACTIONS(878),
    [anon_sym_builtin] = ACTIONS(878),
    [anon_sym_cold] = ACTIONS(878),
    [anon_sym_convergent] = ACTIONS(878),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(878),
    [anon_sym_hot] = ACTIONS(878),
    [anon_sym_inaccessiblememonly] = ACTIONS(878),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(878),
    [anon_sym_inlinehint] = ACTIONS(878),
    [anon_sym_jumptable] = ACTIONS(878),
    [anon_sym_minsize] = ACTIONS(878),
    [anon_sym_naked] = ACTIONS(878),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(878),
    [anon_sym_nobuiltin] = ACTIONS(878),
    [anon_sym_noduplicate] = ACTIONS(878),
    [anon_sym_nofree] = ACTIONS(878),
    [anon_sym_noimplicitfloat] = ACTIONS(878),
    [anon_sym_noinline] = ACTIONS(878),
    [anon_sym_nomerge] = ACTIONS(878),
    [anon_sym_nonlazybind] = ACTIONS(878),
    [anon_sym_noprofile] = ACTIONS(878),
    [anon_sym_noredzone] = ACTIONS(878),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(878),
    [anon_sym_noreturn] = ACTIONS(878),
    [anon_sym_norecurse] = ACTIONS(878),
    [anon_sym_willreturn] = ACTIONS(878),
    [anon_sym_nosync] = ACTIONS(878),
    [anon_sym_nounwind] = ACTIONS(878),
    [anon_sym_nocallback] = ACTIONS(878),
    [anon_sym_nosanitize_coverage] = ACTIONS(878),
    [anon_sym_null_pointer_is_valid] = ACTIONS(878),
    [anon_sym_optforfuzzing] = ACTIONS(878),
    [anon_sym_optnone] = ACTIONS(878),
    [anon_sym_optsize] = ACTIONS(878),
    [anon_sym_readnone] = ACTIONS(878),
    [anon_sym_readonly] = ACTIONS(878),
    [anon_sym_writeonly] = ACTIONS(878),
    [anon_sym_argmemonly] = ACTIONS(878),
    [anon_sym_returns_twice] = ACTIONS(878),
    [anon_sym_safestack] = ACTIONS(878),
    [anon_sym_sanitize_address] = ACTIONS(878),
    [anon_sym_sanitize_memory] = ACTIONS(878),
    [anon_sym_sanitize_thread] = ACTIONS(878),
    [anon_sym_sanitize_hwaddress] = ACTIONS(878),
    [anon_sym_sanitize_memtag] = ACTIONS(878),
    [anon_sym_speculative_load_hardening] = ACTIONS(878),
    [anon_sym_speculatable] = ACTIONS(878),
    [anon_sym_ssp] = ACTIONS(878),
    [anon_sym_sspstrong] = ACTIONS(878),
    [anon_sym_sspreq] = ACTIONS(878),
    [anon_sym_strictfp] = ACTIONS(878),
    [anon_sym_nocf_check] = ACTIONS(878),
    [anon_sym_shadowcallstack] = ACTIONS(878),
    [anon_sym_mustprogress] = ACTIONS(878),
    [anon_sym_vscale_range] = ACTIONS(878),
    [anon_sym_preallocated] = ACTIONS(878),
    [anon_sym_zeroext] = ACTIONS(878),
    [anon_sym_signext] = ACTIONS(878),
    [anon_sym_inreg] = ACTIONS(878),
    [anon_sym_byval] = ACTIONS(878),
    [anon_sym_byref] = ACTIONS(878),
    [anon_sym_inalloca] = ACTIONS(878),
    [anon_sym_sret] = ACTIONS(878),
    [anon_sym_elementtype] = ACTIONS(878),
    [anon_sym_noalias] = ACTIONS(878),
    [anon_sym_nocapture] = ACTIONS(878),
    [anon_sym_nest] = ACTIONS(878),
    [anon_sym_returned] = ACTIONS(878),
    [anon_sym_nonnull] = ACTIONS(878),
    [anon_sym_dereferenceable] = ACTIONS(878),
    [anon_sym_dereferenceable_or_null] = ACTIONS(878),
    [anon_sym_swiftself] = ACTIONS(878),
    [anon_sym_swiftasync] = ACTIONS(878),
    [anon_sym_swifterror] = ACTIONS(878),
    [anon_sym_immarg] = ACTIONS(878),
    [anon_sym_noundef] = ACTIONS(878),
    [anon_sym_uwtable] = ACTIONS(878),
    [anon_sym_memory] = ACTIONS(878),
    [anon_sym_unreachable] = ACTIONS(878),
    [anon_sym_ret] = ACTIONS(878),
    [anon_sym_br] = ACTIONS(878),
    [anon_sym_resume] = ACTIONS(878),
    [anon_sym_freeze] = ACTIONS(878),
    [anon_sym_indirectbr] = ACTIONS(878),
    [anon_sym_extractelement] = ACTIONS(878),
    [anon_sym_insertelement] = ACTIONS(878),
    [anon_sym_select] = ACTIONS(878),
    [anon_sym_shufflevector] = ACTIONS(878),
    [anon_sym_fneg] = ACTIONS(878),
    [anon_sym_switch] = ACTIONS(878),
    [anon_sym_invoke] = ACTIONS(878),
    [anon_sym_cleanupret] = ACTIONS(878),
    [anon_sym_catchret] = ACTIONS(878),
    [anon_sym_catchswitch] = ACTIONS(878),
    [anon_sym_catchpad] = ACTIONS(878),
    [anon_sym_cleanuppad] = ACTIONS(878),
    [anon_sym_callbr] = ACTIONS(878),
    [anon_sym_icmp] = ACTIONS(878),
    [anon_sym_fcmp] = ACTIONS(878),
    [anon_sym_va_arg] = ACTIONS(878),
    [anon_sym_phi] = ACTIONS(878),
    [anon_sym_landingpad] = ACTIONS(878),
    [anon_sym_tail] = ACTIONS(878),
    [anon_sym_musttail] = ACTIONS(878),
    [anon_sym_notail] = ACTIONS(878),
    [anon_sym_call] = ACTIONS(878),
    [anon_sym_alloca] = ACTIONS(878),
    [anon_sym_load] = ACTIONS(878),
    [anon_sym_store] = ACTIONS(878),
    [anon_sym_cmpxchg] = ACTIONS(878),
    [anon_sym_atomicrmw] = ACTIONS(878),
    [anon_sym_fence] = ACTIONS(878),
    [anon_sym_getelementptr] = ACTIONS(878),
    [anon_sym_extractvalue] = ACTIONS(878),
    [anon_sym_insertvalue] = ACTIONS(878),
    [anon_sym_mul] = ACTIONS(878),
    [anon_sym_urem] = ACTIONS(878),
    [anon_sym_srem] = ACTIONS(878),
    [anon_sym_shl] = ACTIONS(878),
    [anon_sym_udiv] = ACTIONS(878),
    [anon_sym_sdiv] = ACTIONS(878),
    [anon_sym_lshr] = ACTIONS(878),
    [anon_sym_ashr] = ACTIONS(878),
    [anon_sym_fmul] = ACTIONS(878),
    [anon_sym_fdiv] = ACTIONS(878),
    [anon_sym_frem] = ACTIONS(878),
    [anon_sym_xchg] = ACTIONS(878),
    [anon_sym_add] = ACTIONS(878),
    [anon_sym_sub] = ACTIONS(878),
    [anon_sym_and] = ACTIONS(878),
    [anon_sym_nand] = ACTIONS(878),
    [anon_sym_or] = ACTIONS(878),
    [anon_sym_xor] = ACTIONS(878),
    [anon_sym_max] = ACTIONS(878),
    [anon_sym_min] = ACTIONS(878),
    [anon_sym_umax] = ACTIONS(878),
    [anon_sym_umin] = ACTIONS(878),
    [anon_sym_fadd] = ACTIONS(878),
    [anon_sym_fsub] = ACTIONS(878),
    [anon_sym_bitcast] = ACTIONS(878),
    [anon_sym_trunc] = ACTIONS(878),
    [anon_sym_zext] = ACTIONS(878),
    [anon_sym_sext] = ACTIONS(878),
    [anon_sym_fptrunc] = ACTIONS(878),
    [anon_sym_fpext] = ACTIONS(878),
    [anon_sym_addrspacecast] = ACTIONS(878),
    [anon_sym_uitofp] = ACTIONS(878),
    [anon_sym_sitofp] = ACTIONS(878),
    [anon_sym_fptoui] = ACTIONS(878),
    [anon_sym_fptosi] = ACTIONS(878),
    [anon_sym_inttoptr] = ACTIONS(878),
    [anon_sym_ptrtoint] = ACTIONS(878),
    [anon_sym_uselistorder] = ACTIONS(878),
  },
  [218] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(880),
    [sym_local_var] = ACTIONS(880),
    [sym_label] = ACTIONS(880),
    [sym_string] = ACTIONS(882),
    [anon_sym_RBRACE] = ACTIONS(880),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_COMMA] = ACTIONS(880),
    [anon_sym_align] = ACTIONS(882),
    [anon_sym_section] = ACTIONS(882),
    [anon_sym_partition] = ACTIONS(882),
    [anon_sym_comdat] = ACTIONS(882),
    [anon_sym_gc] = ACTIONS(882),
    [anon_sym_prefix] = ACTIONS(882),
    [anon_sym_prologue] = ACTIONS(882),
    [anon_sym_personality] = ACTIONS(882),
    [anon_sym_alignstack] = ACTIONS(882),
    [anon_sym_allocsize] = ACTIONS(882),
    [anon_sym_alwaysinline] = ACTIONS(882),
    [anon_sym_builtin] = ACTIONS(882),
    [anon_sym_cold] = ACTIONS(882),
    [anon_sym_convergent] = ACTIONS(882),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(882),
    [anon_sym_hot] = ACTIONS(882),
    [anon_sym_inaccessiblememonly] = ACTIONS(882),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(882),
    [anon_sym_inlinehint] = ACTIONS(882),
    [anon_sym_jumptable] = ACTIONS(882),
    [anon_sym_minsize] = ACTIONS(882),
    [anon_sym_naked] = ACTIONS(882),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(882),
    [anon_sym_nobuiltin] = ACTIONS(882),
    [anon_sym_noduplicate] = ACTIONS(882),
    [anon_sym_nofree] = ACTIONS(882),
    [anon_sym_noimplicitfloat] = ACTIONS(882),
    [anon_sym_noinline] = ACTIONS(882),
    [anon_sym_nomerge] = ACTIONS(882),
    [anon_sym_nonlazybind] = ACTIONS(882),
    [anon_sym_noprofile] = ACTIONS(882),
    [anon_sym_noredzone] = ACTIONS(882),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(882),
    [anon_sym_noreturn] = ACTIONS(882),
    [anon_sym_norecurse] = ACTIONS(882),
    [anon_sym_willreturn] = ACTIONS(882),
    [anon_sym_nosync] = ACTIONS(882),
    [anon_sym_nounwind] = ACTIONS(882),
    [anon_sym_nocallback] = ACTIONS(882),
    [anon_sym_nosanitize_coverage] = ACTIONS(882),
    [anon_sym_null_pointer_is_valid] = ACTIONS(882),
    [anon_sym_optforfuzzing] = ACTIONS(882),
    [anon_sym_optnone] = ACTIONS(882),
    [anon_sym_optsize] = ACTIONS(882),
    [anon_sym_readnone] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_writeonly] = ACTIONS(882),
    [anon_sym_argmemonly] = ACTIONS(882),
    [anon_sym_returns_twice] = ACTIONS(882),
    [anon_sym_safestack] = ACTIONS(882),
    [anon_sym_sanitize_address] = ACTIONS(882),
    [anon_sym_sanitize_memory] = ACTIONS(882),
    [anon_sym_sanitize_thread] = ACTIONS(882),
    [anon_sym_sanitize_hwaddress] = ACTIONS(882),
    [anon_sym_sanitize_memtag] = ACTIONS(882),
    [anon_sym_speculative_load_hardening] = ACTIONS(882),
    [anon_sym_speculatable] = ACTIONS(882),
    [anon_sym_ssp] = ACTIONS(882),
    [anon_sym_sspstrong] = ACTIONS(882),
    [anon_sym_sspreq] = ACTIONS(882),
    [anon_sym_strictfp] = ACTIONS(882),
    [anon_sym_nocf_check] = ACTIONS(882),
    [anon_sym_shadowcallstack] = ACTIONS(882),
    [anon_sym_mustprogress] = ACTIONS(882),
    [anon_sym_vscale_range] = ACTIONS(882),
    [anon_sym_preallocated] = ACTIONS(882),
    [anon_sym_zeroext] = ACTIONS(882),
    [anon_sym_signext] = ACTIONS(882),
    [anon_sym_inreg] = ACTIONS(882),
    [anon_sym_byval] = ACTIONS(882),
    [anon_sym_byref] = ACTIONS(882),
    [anon_sym_inalloca] = ACTIONS(882),
    [anon_sym_sret] = ACTIONS(882),
    [anon_sym_elementtype] = ACTIONS(882),
    [anon_sym_noalias] = ACTIONS(882),
    [anon_sym_nocapture] = ACTIONS(882),
    [anon_sym_nest] = ACTIONS(882),
    [anon_sym_returned] = ACTIONS(882),
    [anon_sym_nonnull] = ACTIONS(882),
    [anon_sym_dereferenceable] = ACTIONS(882),
    [anon_sym_dereferenceable_or_null] = ACTIONS(882),
    [anon_sym_swiftself] = ACTIONS(882),
    [anon_sym_swiftasync] = ACTIONS(882),
    [anon_sym_swifterror] = ACTIONS(882),
    [anon_sym_immarg] = ACTIONS(882),
    [anon_sym_noundef] = ACTIONS(882),
    [anon_sym_uwtable] = ACTIONS(882),
    [anon_sym_memory] = ACTIONS(882),
    [anon_sym_unreachable] = ACTIONS(882),
    [anon_sym_ret] = ACTIONS(882),
    [anon_sym_br] = ACTIONS(882),
    [anon_sym_resume] = ACTIONS(882),
    [anon_sym_freeze] = ACTIONS(882),
    [anon_sym_indirectbr] = ACTIONS(882),
    [anon_sym_extractelement] = ACTIONS(882),
    [anon_sym_insertelement] = ACTIONS(882),
    [anon_sym_select] = ACTIONS(882),
    [anon_sym_shufflevector] = ACTIONS(882),
    [anon_sym_fneg] = ACTIONS(882),
    [anon_sym_switch] = ACTIONS(882),
    [anon_sym_invoke] = ACTIONS(882),
    [anon_sym_cleanupret] = ACTIONS(882),
    [anon_sym_catchret] = ACTIONS(882),
    [anon_sym_catchswitch] = ACTIONS(882),
    [anon_sym_catchpad] = ACTIONS(882),
    [anon_sym_cleanuppad] = ACTIONS(882),
    [anon_sym_callbr] = ACTIONS(882),
    [anon_sym_icmp] = ACTIONS(882),
    [anon_sym_fcmp] = ACTIONS(882),
    [anon_sym_va_arg] = ACTIONS(882),
    [anon_sym_phi] = ACTIONS(882),
    [anon_sym_landingpad] = ACTIONS(882),
    [anon_sym_tail] = ACTIONS(882),
    [anon_sym_musttail] = ACTIONS(882),
    [anon_sym_notail] = ACTIONS(882),
    [anon_sym_call] = ACTIONS(882),
    [anon_sym_alloca] = ACTIONS(882),
    [anon_sym_load] = ACTIONS(882),
    [anon_sym_store] = ACTIONS(882),
    [anon_sym_cmpxchg] = ACTIONS(882),
    [anon_sym_atomicrmw] = ACTIONS(882),
    [anon_sym_fence] = ACTIONS(882),
    [anon_sym_getelementptr] = ACTIONS(882),
    [anon_sym_extractvalue] = ACTIONS(882),
    [anon_sym_insertvalue] = ACTIONS(882),
    [anon_sym_mul] = ACTIONS(882),
    [anon_sym_urem] = ACTIONS(882),
    [anon_sym_srem] = ACTIONS(882),
    [anon_sym_shl] = ACTIONS(882),
    [anon_sym_udiv] = ACTIONS(882),
    [anon_sym_sdiv] = ACTIONS(882),
    [anon_sym_lshr] = ACTIONS(882),
    [anon_sym_ashr] = ACTIONS(882),
    [anon_sym_fmul] = ACTIONS(882),
    [anon_sym_fdiv] = ACTIONS(882),
    [anon_sym_frem] = ACTIONS(882),
    [anon_sym_xchg] = ACTIONS(882),
    [anon_sym_add] = ACTIONS(882),
    [anon_sym_sub] = ACTIONS(882),
    [anon_sym_and] = ACTIONS(882),
    [anon_sym_nand] = ACTIONS(882),
    [anon_sym_or] = ACTIONS(882),
    [anon_sym_xor] = ACTIONS(882),
    [anon_sym_max] = ACTIONS(882),
    [anon_sym_min] = ACTIONS(882),
    [anon_sym_umax] = ACTIONS(882),
    [anon_sym_umin] = ACTIONS(882),
    [anon_sym_fadd] = ACTIONS(882),
    [anon_sym_fsub] = ACTIONS(882),
    [anon_sym_bitcast] = ACTIONS(882),
    [anon_sym_trunc] = ACTIONS(882),
    [anon_sym_zext] = ACTIONS(882),
    [anon_sym_sext] = ACTIONS(882),
    [anon_sym_fptrunc] = ACTIONS(882),
    [anon_sym_fpext] = ACTIONS(882),
    [anon_sym_addrspacecast] = ACTIONS(882),
    [anon_sym_uitofp] = ACTIONS(882),
    [anon_sym_sitofp] = ACTIONS(882),
    [anon_sym_fptoui] = ACTIONS(882),
    [anon_sym_fptosi] = ACTIONS(882),
    [anon_sym_inttoptr] = ACTIONS(882),
    [anon_sym_ptrtoint] = ACTIONS(882),
    [anon_sym_uselistorder] = ACTIONS(882),
  },
  [219] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(863),
    [sym_local_var] = ACTIONS(863),
    [sym_string] = ACTIONS(863),
    [aux_sym_number_token1] = ACTIONS(865),
    [aux_sym_number_token2] = ACTIONS(863),
    [sym_float] = ACTIONS(863),
    [sym_cstring] = ACTIONS(863),
    [anon_sym_no_cfi] = ACTIONS(863),
    [anon_sym_private] = ACTIONS(863),
    [anon_sym_internal] = ACTIONS(863),
    [anon_sym_weak] = ACTIONS(865),
    [anon_sym_weak_odr] = ACTIONS(863),
    [anon_sym_linkonce] = ACTIONS(865),
    [anon_sym_linkonce_odr] = ACTIONS(863),
    [anon_sym_available_externally] = ACTIONS(863),
    [anon_sym_appending] = ACTIONS(863),
    [anon_sym_common] = ACTIONS(863),
    [anon_sym_extern_weak] = ACTIONS(863),
    [anon_sym_external] = ACTIONS(863),
    [anon_sym_dso_local] = ACTIONS(865),
    [anon_sym_dso_local_equivalent] = ACTIONS(863),
    [anon_sym_dso_preemptable] = ACTIONS(863),
    [anon_sym_default] = ACTIONS(863),
    [anon_sym_hidden] = ACTIONS(863),
    [anon_sym_protected] = ACTIONS(863),
    [anon_sym_dllimport] = ACTIONS(863),
    [anon_sym_dllexport] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(863),
    [anon_sym_LT_LBRACE] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_COMMA] = ACTIONS(863),
    [anon_sym_LPAREN] = ACTIONS(884),
    [anon_sym_RPAREN] = ACTIONS(863),
    [anon_sym_align] = ACTIONS(865),
    [anon_sym_alignstack] = ACTIONS(863),
    [anon_sym_allocsize] = ACTIONS(863),
    [anon_sym_alwaysinline] = ACTIONS(863),
    [anon_sym_builtin] = ACTIONS(863),
    [anon_sym_cold] = ACTIONS(863),
    [anon_sym_convergent] = ACTIONS(863),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(863),
    [anon_sym_hot] = ACTIONS(863),
    [anon_sym_inaccessiblememonly] = ACTIONS(863),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(863),
    [anon_sym_inlinehint] = ACTIONS(863),
    [anon_sym_jumptable] = ACTIONS(863),
    [anon_sym_minsize] = ACTIONS(863),
    [anon_sym_naked] = ACTIONS(863),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(863),
    [anon_sym_nobuiltin] = ACTIONS(863),
    [anon_sym_noduplicate] = ACTIONS(863),
    [anon_sym_nofree] = ACTIONS(863),
    [anon_sym_noimplicitfloat] = ACTIONS(863),
    [anon_sym_noinline] = ACTIONS(863),
    [anon_sym_nomerge] = ACTIONS(863),
    [anon_sym_nonlazybind] = ACTIONS(863),
    [anon_sym_noprofile] = ACTIONS(863),
    [anon_sym_noredzone] = ACTIONS(863),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(863),
    [anon_sym_noreturn] = ACTIONS(863),
    [anon_sym_norecurse] = ACTIONS(863),
    [anon_sym_willreturn] = ACTIONS(863),
    [anon_sym_nosync] = ACTIONS(863),
    [anon_sym_nounwind] = ACTIONS(863),
    [anon_sym_nocallback] = ACTIONS(863),
    [anon_sym_nosanitize_coverage] = ACTIONS(863),
    [anon_sym_null_pointer_is_valid] = ACTIONS(863),
    [anon_sym_optforfuzzing] = ACTIONS(863),
    [anon_sym_optnone] = ACTIONS(863),
    [anon_sym_optsize] = ACTIONS(863),
    [anon_sym_readnone] = ACTIONS(863),
    [anon_sym_readonly] = ACTIONS(863),
    [anon_sym_writeonly] = ACTIONS(863),
    [anon_sym_argmemonly] = ACTIONS(863),
    [anon_sym_returns_twice] = ACTIONS(863),
    [anon_sym_safestack] = ACTIONS(863),
    [anon_sym_sanitize_address] = ACTIONS(863),
    [anon_sym_sanitize_memory] = ACTIONS(863),
    [anon_sym_sanitize_thread] = ACTIONS(863),
    [anon_sym_sanitize_hwaddress] = ACTIONS(863),
    [anon_sym_sanitize_memtag] = ACTIONS(863),
    [anon_sym_speculative_load_hardening] = ACTIONS(863),
    [anon_sym_speculatable] = ACTIONS(863),
    [anon_sym_ssp] = ACTIONS(865),
    [anon_sym_sspstrong] = ACTIONS(863),
    [anon_sym_sspreq] = ACTIONS(863),
    [anon_sym_strictfp] = ACTIONS(863),
    [anon_sym_nocf_check] = ACTIONS(863),
    [anon_sym_shadowcallstack] = ACTIONS(863),
    [anon_sym_mustprogress] = ACTIONS(863),
    [anon_sym_vscale_range] = ACTIONS(863),
    [anon_sym_preallocated] = ACTIONS(863),
    [anon_sym_zeroext] = ACTIONS(863),
    [anon_sym_signext] = ACTIONS(863),
    [anon_sym_inreg] = ACTIONS(863),
    [anon_sym_byval] = ACTIONS(863),
    [anon_sym_byref] = ACTIONS(863),
    [anon_sym_inalloca] = ACTIONS(863),
    [anon_sym_sret] = ACTIONS(863),
    [anon_sym_elementtype] = ACTIONS(863),
    [anon_sym_noalias] = ACTIONS(863),
    [anon_sym_nocapture] = ACTIONS(863),
    [anon_sym_nest] = ACTIONS(863),
    [anon_sym_returned] = ACTIONS(863),
    [anon_sym_nonnull] = ACTIONS(863),
    [anon_sym_dereferenceable] = ACTIONS(865),
    [anon_sym_dereferenceable_or_null] = ACTIONS(863),
    [anon_sym_swiftself] = ACTIONS(863),
    [anon_sym_swiftasync] = ACTIONS(863),
    [anon_sym_swifterror] = ACTIONS(863),
    [anon_sym_immarg] = ACTIONS(863),
    [anon_sym_noundef] = ACTIONS(863),
    [anon_sym_uwtable] = ACTIONS(863),
    [anon_sym_memory] = ACTIONS(863),
    [anon_sym_none] = ACTIONS(863),
    [anon_sym_extractelement] = ACTIONS(863),
    [anon_sym_insertelement] = ACTIONS(863),
    [anon_sym_select] = ACTIONS(863),
    [anon_sym_shufflevector] = ACTIONS(863),
    [anon_sym_fneg] = ACTIONS(863),
    [anon_sym_icmp] = ACTIONS(863),
    [anon_sym_fcmp] = ACTIONS(863),
    [anon_sym_getelementptr] = ACTIONS(863),
    [anon_sym_extractvalue] = ACTIONS(863),
    [anon_sym_insertvalue] = ACTIONS(863),
    [anon_sym_true] = ACTIONS(863),
    [anon_sym_false] = ACTIONS(863),
    [anon_sym_null] = ACTIONS(865),
    [anon_sym_undef] = ACTIONS(863),
    [anon_sym_poison] = ACTIONS(863),
    [anon_sym_zeroinitializer] = ACTIONS(863),
    [anon_sym_blockaddress] = ACTIONS(863),
    [anon_sym_mul] = ACTIONS(863),
    [anon_sym_urem] = ACTIONS(863),
    [anon_sym_srem] = ACTIONS(863),
    [anon_sym_shl] = ACTIONS(863),
    [anon_sym_udiv] = ACTIONS(863),
    [anon_sym_sdiv] = ACTIONS(863),
    [anon_sym_lshr] = ACTIONS(863),
    [anon_sym_ashr] = ACTIONS(863),
    [anon_sym_fmul] = ACTIONS(863),
    [anon_sym_fdiv] = ACTIONS(863),
    [anon_sym_frem] = ACTIONS(863),
    [anon_sym_xchg] = ACTIONS(863),
    [anon_sym_add] = ACTIONS(865),
    [anon_sym_sub] = ACTIONS(863),
    [anon_sym_and] = ACTIONS(863),
    [anon_sym_nand] = ACTIONS(863),
    [anon_sym_or] = ACTIONS(863),
    [anon_sym_xor] = ACTIONS(863),
    [anon_sym_max] = ACTIONS(863),
    [anon_sym_min] = ACTIONS(865),
    [anon_sym_umax] = ACTIONS(863),
    [anon_sym_umin] = ACTIONS(863),
    [anon_sym_fadd] = ACTIONS(863),
    [anon_sym_fsub] = ACTIONS(863),
    [anon_sym_bitcast] = ACTIONS(863),
    [anon_sym_trunc] = ACTIONS(863),
    [anon_sym_zext] = ACTIONS(863),
    [anon_sym_sext] = ACTIONS(863),
    [anon_sym_fptrunc] = ACTIONS(863),
    [anon_sym_fpext] = ACTIONS(863),
    [anon_sym_addrspacecast] = ACTIONS(863),
    [anon_sym_uitofp] = ACTIONS(863),
    [anon_sym_sitofp] = ACTIONS(863),
    [anon_sym_fptoui] = ACTIONS(863),
    [anon_sym_fptosi] = ACTIONS(863),
    [anon_sym_inttoptr] = ACTIONS(863),
    [anon_sym_ptrtoint] = ACTIONS(863),
  },
  [220] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(887),
    [sym_local_var] = ACTIONS(887),
    [sym_label] = ACTIONS(887),
    [sym_string] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_align] = ACTIONS(889),
    [anon_sym_section] = ACTIONS(889),
    [anon_sym_partition] = ACTIONS(889),
    [anon_sym_comdat] = ACTIONS(889),
    [anon_sym_gc] = ACTIONS(889),
    [anon_sym_prefix] = ACTIONS(889),
    [anon_sym_prologue] = ACTIONS(889),
    [anon_sym_personality] = ACTIONS(889),
    [anon_sym_alignstack] = ACTIONS(889),
    [anon_sym_allocsize] = ACTIONS(889),
    [anon_sym_alwaysinline] = ACTIONS(889),
    [anon_sym_builtin] = ACTIONS(889),
    [anon_sym_cold] = ACTIONS(889),
    [anon_sym_convergent] = ACTIONS(889),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(889),
    [anon_sym_hot] = ACTIONS(889),
    [anon_sym_inaccessiblememonly] = ACTIONS(889),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(889),
    [anon_sym_inlinehint] = ACTIONS(889),
    [anon_sym_jumptable] = ACTIONS(889),
    [anon_sym_minsize] = ACTIONS(889),
    [anon_sym_naked] = ACTIONS(889),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(889),
    [anon_sym_nobuiltin] = ACTIONS(889),
    [anon_sym_noduplicate] = ACTIONS(889),
    [anon_sym_nofree] = ACTIONS(889),
    [anon_sym_noimplicitfloat] = ACTIONS(889),
    [anon_sym_noinline] = ACTIONS(889),
    [anon_sym_nomerge] = ACTIONS(889),
    [anon_sym_nonlazybind] = ACTIONS(889),
    [anon_sym_noprofile] = ACTIONS(889),
    [anon_sym_noredzone] = ACTIONS(889),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(889),
    [anon_sym_noreturn] = ACTIONS(889),
    [anon_sym_norecurse] = ACTIONS(889),
    [anon_sym_willreturn] = ACTIONS(889),
    [anon_sym_nosync] = ACTIONS(889),
    [anon_sym_nounwind] = ACTIONS(889),
    [anon_sym_nocallback] = ACTIONS(889),
    [anon_sym_nosanitize_coverage] = ACTIONS(889),
    [anon_sym_null_pointer_is_valid] = ACTIONS(889),
    [anon_sym_optforfuzzing] = ACTIONS(889),
    [anon_sym_optnone] = ACTIONS(889),
    [anon_sym_optsize] = ACTIONS(889),
    [anon_sym_readnone] = ACTIONS(889),
    [anon_sym_readonly] = ACTIONS(889),
    [anon_sym_writeonly] = ACTIONS(889),
    [anon_sym_argmemonly] = ACTIONS(889),
    [anon_sym_returns_twice] = ACTIONS(889),
    [anon_sym_safestack] = ACTIONS(889),
    [anon_sym_sanitize_address] = ACTIONS(889),
    [anon_sym_sanitize_memory] = ACTIONS(889),
    [anon_sym_sanitize_thread] = ACTIONS(889),
    [anon_sym_sanitize_hwaddress] = ACTIONS(889),
    [anon_sym_sanitize_memtag] = ACTIONS(889),
    [anon_sym_speculative_load_hardening] = ACTIONS(889),
    [anon_sym_speculatable] = ACTIONS(889),
    [anon_sym_ssp] = ACTIONS(889),
    [anon_sym_sspstrong] = ACTIONS(889),
    [anon_sym_sspreq] = ACTIONS(889),
    [anon_sym_strictfp] = ACTIONS(889),
    [anon_sym_nocf_check] = ACTIONS(889),
    [anon_sym_shadowcallstack] = ACTIONS(889),
    [anon_sym_mustprogress] = ACTIONS(889),
    [anon_sym_vscale_range] = ACTIONS(889),
    [anon_sym_preallocated] = ACTIONS(889),
    [anon_sym_zeroext] = ACTIONS(889),
    [anon_sym_signext] = ACTIONS(889),
    [anon_sym_inreg] = ACTIONS(889),
    [anon_sym_byval] = ACTIONS(889),
    [anon_sym_byref] = ACTIONS(889),
    [anon_sym_inalloca] = ACTIONS(889),
    [anon_sym_sret] = ACTIONS(889),
    [anon_sym_elementtype] = ACTIONS(889),
    [anon_sym_noalias] = ACTIONS(889),
    [anon_sym_nocapture] = ACTIONS(889),
    [anon_sym_nest] = ACTIONS(889),
    [anon_sym_returned] = ACTIONS(889),
    [anon_sym_nonnull] = ACTIONS(889),
    [anon_sym_dereferenceable] = ACTIONS(889),
    [anon_sym_dereferenceable_or_null] = ACTIONS(889),
    [anon_sym_swiftself] = ACTIONS(889),
    [anon_sym_swiftasync] = ACTIONS(889),
    [anon_sym_swifterror] = ACTIONS(889),
    [anon_sym_immarg] = ACTIONS(889),
    [anon_sym_noundef] = ACTIONS(889),
    [anon_sym_uwtable] = ACTIONS(889),
    [anon_sym_memory] = ACTIONS(889),
    [anon_sym_unreachable] = ACTIONS(889),
    [anon_sym_ret] = ACTIONS(889),
    [anon_sym_br] = ACTIONS(889),
    [anon_sym_resume] = ACTIONS(889),
    [anon_sym_freeze] = ACTIONS(889),
    [anon_sym_indirectbr] = ACTIONS(889),
    [anon_sym_extractelement] = ACTIONS(889),
    [anon_sym_insertelement] = ACTIONS(889),
    [anon_sym_select] = ACTIONS(889),
    [anon_sym_shufflevector] = ACTIONS(889),
    [anon_sym_fneg] = ACTIONS(889),
    [anon_sym_switch] = ACTIONS(889),
    [anon_sym_invoke] = ACTIONS(889),
    [anon_sym_cleanupret] = ACTIONS(889),
    [anon_sym_catchret] = ACTIONS(889),
    [anon_sym_catchswitch] = ACTIONS(889),
    [anon_sym_catchpad] = ACTIONS(889),
    [anon_sym_cleanuppad] = ACTIONS(889),
    [anon_sym_callbr] = ACTIONS(889),
    [anon_sym_icmp] = ACTIONS(889),
    [anon_sym_fcmp] = ACTIONS(889),
    [anon_sym_va_arg] = ACTIONS(889),
    [anon_sym_phi] = ACTIONS(889),
    [anon_sym_landingpad] = ACTIONS(889),
    [anon_sym_tail] = ACTIONS(889),
    [anon_sym_musttail] = ACTIONS(889),
    [anon_sym_notail] = ACTIONS(889),
    [anon_sym_call] = ACTIONS(889),
    [anon_sym_alloca] = ACTIONS(889),
    [anon_sym_load] = ACTIONS(889),
    [anon_sym_store] = ACTIONS(889),
    [anon_sym_cmpxchg] = ACTIONS(889),
    [anon_sym_atomicrmw] = ACTIONS(889),
    [anon_sym_fence] = ACTIONS(889),
    [anon_sym_getelementptr] = ACTIONS(889),
    [anon_sym_extractvalue] = ACTIONS(889),
    [anon_sym_insertvalue] = ACTIONS(889),
    [anon_sym_mul] = ACTIONS(889),
    [anon_sym_urem] = ACTIONS(889),
    [anon_sym_srem] = ACTIONS(889),
    [anon_sym_shl] = ACTIONS(889),
    [anon_sym_udiv] = ACTIONS(889),
    [anon_sym_sdiv] = ACTIONS(889),
    [anon_sym_lshr] = ACTIONS(889),
    [anon_sym_ashr] = ACTIONS(889),
    [anon_sym_fmul] = ACTIONS(889),
    [anon_sym_fdiv] = ACTIONS(889),
    [anon_sym_frem] = ACTIONS(889),
    [anon_sym_xchg] = ACTIONS(889),
    [anon_sym_add] = ACTIONS(889),
    [anon_sym_sub] = ACTIONS(889),
    [anon_sym_and] = ACTIONS(889),
    [anon_sym_nand] = ACTIONS(889),
    [anon_sym_or] = ACTIONS(889),
    [anon_sym_xor] = ACTIONS(889),
    [anon_sym_max] = ACTIONS(889),
    [anon_sym_min] = ACTIONS(889),
    [anon_sym_umax] = ACTIONS(889),
    [anon_sym_umin] = ACTIONS(889),
    [anon_sym_fadd] = ACTIONS(889),
    [anon_sym_fsub] = ACTIONS(889),
    [anon_sym_bitcast] = ACTIONS(889),
    [anon_sym_trunc] = ACTIONS(889),
    [anon_sym_zext] = ACTIONS(889),
    [anon_sym_sext] = ACTIONS(889),
    [anon_sym_fptrunc] = ACTIONS(889),
    [anon_sym_fpext] = ACTIONS(889),
    [anon_sym_addrspacecast] = ACTIONS(889),
    [anon_sym_uitofp] = ACTIONS(889),
    [anon_sym_sitofp] = ACTIONS(889),
    [anon_sym_fptoui] = ACTIONS(889),
    [anon_sym_fptosi] = ACTIONS(889),
    [anon_sym_inttoptr] = ACTIONS(889),
    [anon_sym_ptrtoint] = ACTIONS(889),
    [anon_sym_uselistorder] = ACTIONS(889),
  },
  [221] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(383),
    [sym_local_var] = ACTIONS(383),
    [sym_label] = ACTIONS(383),
    [sym_string] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_align] = ACTIONS(385),
    [anon_sym_section] = ACTIONS(385),
    [anon_sym_partition] = ACTIONS(385),
    [anon_sym_comdat] = ACTIONS(385),
    [anon_sym_gc] = ACTIONS(385),
    [anon_sym_prefix] = ACTIONS(385),
    [anon_sym_prologue] = ACTIONS(385),
    [anon_sym_personality] = ACTIONS(385),
    [anon_sym_alignstack] = ACTIONS(385),
    [anon_sym_allocsize] = ACTIONS(385),
    [anon_sym_alwaysinline] = ACTIONS(385),
    [anon_sym_builtin] = ACTIONS(385),
    [anon_sym_cold] = ACTIONS(385),
    [anon_sym_convergent] = ACTIONS(385),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(385),
    [anon_sym_hot] = ACTIONS(385),
    [anon_sym_inaccessiblememonly] = ACTIONS(385),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(385),
    [anon_sym_inlinehint] = ACTIONS(385),
    [anon_sym_jumptable] = ACTIONS(385),
    [anon_sym_minsize] = ACTIONS(385),
    [anon_sym_naked] = ACTIONS(385),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(385),
    [anon_sym_nobuiltin] = ACTIONS(385),
    [anon_sym_noduplicate] = ACTIONS(385),
    [anon_sym_nofree] = ACTIONS(385),
    [anon_sym_noimplicitfloat] = ACTIONS(385),
    [anon_sym_noinline] = ACTIONS(385),
    [anon_sym_nomerge] = ACTIONS(385),
    [anon_sym_nonlazybind] = ACTIONS(385),
    [anon_sym_noprofile] = ACTIONS(385),
    [anon_sym_noredzone] = ACTIONS(385),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(385),
    [anon_sym_noreturn] = ACTIONS(385),
    [anon_sym_norecurse] = ACTIONS(385),
    [anon_sym_willreturn] = ACTIONS(385),
    [anon_sym_nosync] = ACTIONS(385),
    [anon_sym_nounwind] = ACTIONS(385),
    [anon_sym_nocallback] = ACTIONS(385),
    [anon_sym_nosanitize_coverage] = ACTIONS(385),
    [anon_sym_null_pointer_is_valid] = ACTIONS(385),
    [anon_sym_optforfuzzing] = ACTIONS(385),
    [anon_sym_optnone] = ACTIONS(385),
    [anon_sym_optsize] = ACTIONS(385),
    [anon_sym_readnone] = ACTIONS(385),
    [anon_sym_readonly] = ACTIONS(385),
    [anon_sym_writeonly] = ACTIONS(385),
    [anon_sym_argmemonly] = ACTIONS(385),
    [anon_sym_returns_twice] = ACTIONS(385),
    [anon_sym_safestack] = ACTIONS(385),
    [anon_sym_sanitize_address] = ACTIONS(385),
    [anon_sym_sanitize_memory] = ACTIONS(385),
    [anon_sym_sanitize_thread] = ACTIONS(385),
    [anon_sym_sanitize_hwaddress] = ACTIONS(385),
    [anon_sym_sanitize_memtag] = ACTIONS(385),
    [anon_sym_speculative_load_hardening] = ACTIONS(385),
    [anon_sym_speculatable] = ACTIONS(385),
    [anon_sym_ssp] = ACTIONS(385),
    [anon_sym_sspstrong] = ACTIONS(385),
    [anon_sym_sspreq] = ACTIONS(385),
    [anon_sym_strictfp] = ACTIONS(385),
    [anon_sym_nocf_check] = ACTIONS(385),
    [anon_sym_shadowcallstack] = ACTIONS(385),
    [anon_sym_mustprogress] = ACTIONS(385),
    [anon_sym_vscale_range] = ACTIONS(385),
    [anon_sym_preallocated] = ACTIONS(385),
    [anon_sym_zeroext] = ACTIONS(385),
    [anon_sym_signext] = ACTIONS(385),
    [anon_sym_inreg] = ACTIONS(385),
    [anon_sym_byval] = ACTIONS(385),
    [anon_sym_byref] = ACTIONS(385),
    [anon_sym_inalloca] = ACTIONS(385),
    [anon_sym_sret] = ACTIONS(385),
    [anon_sym_elementtype] = ACTIONS(385),
    [anon_sym_noalias] = ACTIONS(385),
    [anon_sym_nocapture] = ACTIONS(385),
    [anon_sym_nest] = ACTIONS(385),
    [anon_sym_returned] = ACTIONS(385),
    [anon_sym_nonnull] = ACTIONS(385),
    [anon_sym_dereferenceable] = ACTIONS(385),
    [anon_sym_dereferenceable_or_null] = ACTIONS(385),
    [anon_sym_swiftself] = ACTIONS(385),
    [anon_sym_swiftasync] = ACTIONS(385),
    [anon_sym_swifterror] = ACTIONS(385),
    [anon_sym_immarg] = ACTIONS(385),
    [anon_sym_noundef] = ACTIONS(385),
    [anon_sym_uwtable] = ACTIONS(385),
    [anon_sym_memory] = ACTIONS(385),
    [anon_sym_unreachable] = ACTIONS(385),
    [anon_sym_ret] = ACTIONS(385),
    [anon_sym_br] = ACTIONS(385),
    [anon_sym_resume] = ACTIONS(385),
    [anon_sym_freeze] = ACTIONS(385),
    [anon_sym_indirectbr] = ACTIONS(385),
    [anon_sym_extractelement] = ACTIONS(385),
    [anon_sym_insertelement] = ACTIONS(385),
    [anon_sym_select] = ACTIONS(385),
    [anon_sym_shufflevector] = ACTIONS(385),
    [anon_sym_fneg] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(385),
    [anon_sym_invoke] = ACTIONS(385),
    [anon_sym_cleanupret] = ACTIONS(385),
    [anon_sym_catchret] = ACTIONS(385),
    [anon_sym_catchswitch] = ACTIONS(385),
    [anon_sym_catchpad] = ACTIONS(385),
    [anon_sym_cleanuppad] = ACTIONS(385),
    [anon_sym_callbr] = ACTIONS(385),
    [anon_sym_icmp] = ACTIONS(385),
    [anon_sym_fcmp] = ACTIONS(385),
    [anon_sym_va_arg] = ACTIONS(385),
    [anon_sym_phi] = ACTIONS(385),
    [anon_sym_landingpad] = ACTIONS(385),
    [anon_sym_tail] = ACTIONS(385),
    [anon_sym_musttail] = ACTIONS(385),
    [anon_sym_notail] = ACTIONS(385),
    [anon_sym_call] = ACTIONS(385),
    [anon_sym_alloca] = ACTIONS(385),
    [anon_sym_load] = ACTIONS(385),
    [anon_sym_store] = ACTIONS(385),
    [anon_sym_cmpxchg] = ACTIONS(385),
    [anon_sym_atomicrmw] = ACTIONS(385),
    [anon_sym_fence] = ACTIONS(385),
    [anon_sym_getelementptr] = ACTIONS(385),
    [anon_sym_extractvalue] = ACTIONS(385),
    [anon_sym_insertvalue] = ACTIONS(385),
    [anon_sym_mul] = ACTIONS(385),
    [anon_sym_urem] = ACTIONS(385),
    [anon_sym_srem] = ACTIONS(385),
    [anon_sym_shl] = ACTIONS(385),
    [anon_sym_udiv] = ACTIONS(385),
    [anon_sym_sdiv] = ACTIONS(385),
    [anon_sym_lshr] = ACTIONS(385),
    [anon_sym_ashr] = ACTIONS(385),
    [anon_sym_fmul] = ACTIONS(385),
    [anon_sym_fdiv] = ACTIONS(385),
    [anon_sym_frem] = ACTIONS(385),
    [anon_sym_xchg] = ACTIONS(385),
    [anon_sym_add] = ACTIONS(385),
    [anon_sym_sub] = ACTIONS(385),
    [anon_sym_and] = ACTIONS(385),
    [anon_sym_nand] = ACTIONS(385),
    [anon_sym_or] = ACTIONS(385),
    [anon_sym_xor] = ACTIONS(385),
    [anon_sym_max] = ACTIONS(385),
    [anon_sym_min] = ACTIONS(385),
    [anon_sym_umax] = ACTIONS(385),
    [anon_sym_umin] = ACTIONS(385),
    [anon_sym_fadd] = ACTIONS(385),
    [anon_sym_fsub] = ACTIONS(385),
    [anon_sym_bitcast] = ACTIONS(385),
    [anon_sym_trunc] = ACTIONS(385),
    [anon_sym_zext] = ACTIONS(385),
    [anon_sym_sext] = ACTIONS(385),
    [anon_sym_fptrunc] = ACTIONS(385),
    [anon_sym_fpext] = ACTIONS(385),
    [anon_sym_addrspacecast] = ACTIONS(385),
    [anon_sym_uitofp] = ACTIONS(385),
    [anon_sym_sitofp] = ACTIONS(385),
    [anon_sym_fptoui] = ACTIONS(385),
    [anon_sym_fptosi] = ACTIONS(385),
    [anon_sym_inttoptr] = ACTIONS(385),
    [anon_sym_ptrtoint] = ACTIONS(385),
    [anon_sym_uselistorder] = ACTIONS(385),
  },
  [222] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(891),
    [sym_local_var] = ACTIONS(891),
    [sym_label] = ACTIONS(891),
    [sym_string] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_align] = ACTIONS(893),
    [anon_sym_section] = ACTIONS(893),
    [anon_sym_partition] = ACTIONS(893),
    [anon_sym_comdat] = ACTIONS(893),
    [anon_sym_gc] = ACTIONS(893),
    [anon_sym_prefix] = ACTIONS(893),
    [anon_sym_prologue] = ACTIONS(893),
    [anon_sym_personality] = ACTIONS(893),
    [anon_sym_alignstack] = ACTIONS(893),
    [anon_sym_allocsize] = ACTIONS(893),
    [anon_sym_alwaysinline] = ACTIONS(893),
    [anon_sym_builtin] = ACTIONS(893),
    [anon_sym_cold] = ACTIONS(893),
    [anon_sym_convergent] = ACTIONS(893),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(893),
    [anon_sym_hot] = ACTIONS(893),
    [anon_sym_inaccessiblememonly] = ACTIONS(893),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(893),
    [anon_sym_inlinehint] = ACTIONS(893),
    [anon_sym_jumptable] = ACTIONS(893),
    [anon_sym_minsize] = ACTIONS(893),
    [anon_sym_naked] = ACTIONS(893),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(893),
    [anon_sym_nobuiltin] = ACTIONS(893),
    [anon_sym_noduplicate] = ACTIONS(893),
    [anon_sym_nofree] = ACTIONS(893),
    [anon_sym_noimplicitfloat] = ACTIONS(893),
    [anon_sym_noinline] = ACTIONS(893),
    [anon_sym_nomerge] = ACTIONS(893),
    [anon_sym_nonlazybind] = ACTIONS(893),
    [anon_sym_noprofile] = ACTIONS(893),
    [anon_sym_noredzone] = ACTIONS(893),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(893),
    [anon_sym_noreturn] = ACTIONS(893),
    [anon_sym_norecurse] = ACTIONS(893),
    [anon_sym_willreturn] = ACTIONS(893),
    [anon_sym_nosync] = ACTIONS(893),
    [anon_sym_nounwind] = ACTIONS(893),
    [anon_sym_nocallback] = ACTIONS(893),
    [anon_sym_nosanitize_coverage] = ACTIONS(893),
    [anon_sym_null_pointer_is_valid] = ACTIONS(893),
    [anon_sym_optforfuzzing] = ACTIONS(893),
    [anon_sym_optnone] = ACTIONS(893),
    [anon_sym_optsize] = ACTIONS(893),
    [anon_sym_readnone] = ACTIONS(893),
    [anon_sym_readonly] = ACTIONS(893),
    [anon_sym_writeonly] = ACTIONS(893),
    [anon_sym_argmemonly] = ACTIONS(893),
    [anon_sym_returns_twice] = ACTIONS(893),
    [anon_sym_safestack] = ACTIONS(893),
    [anon_sym_sanitize_address] = ACTIONS(893),
    [anon_sym_sanitize_memory] = ACTIONS(893),
    [anon_sym_sanitize_thread] = ACTIONS(893),
    [anon_sym_sanitize_hwaddress] = ACTIONS(893),
    [anon_sym_sanitize_memtag] = ACTIONS(893),
    [anon_sym_speculative_load_hardening] = ACTIONS(893),
    [anon_sym_speculatable] = ACTIONS(893),
    [anon_sym_ssp] = ACTIONS(893),
    [anon_sym_sspstrong] = ACTIONS(893),
    [anon_sym_sspreq] = ACTIONS(893),
    [anon_sym_strictfp] = ACTIONS(893),
    [anon_sym_nocf_check] = ACTIONS(893),
    [anon_sym_shadowcallstack] = ACTIONS(893),
    [anon_sym_mustprogress] = ACTIONS(893),
    [anon_sym_vscale_range] = ACTIONS(893),
    [anon_sym_preallocated] = ACTIONS(893),
    [anon_sym_zeroext] = ACTIONS(893),
    [anon_sym_signext] = ACTIONS(893),
    [anon_sym_inreg] = ACTIONS(893),
    [anon_sym_byval] = ACTIONS(893),
    [anon_sym_byref] = ACTIONS(893),
    [anon_sym_inalloca] = ACTIONS(893),
    [anon_sym_sret] = ACTIONS(893),
    [anon_sym_elementtype] = ACTIONS(893),
    [anon_sym_noalias] = ACTIONS(893),
    [anon_sym_nocapture] = ACTIONS(893),
    [anon_sym_nest] = ACTIONS(893),
    [anon_sym_returned] = ACTIONS(893),
    [anon_sym_nonnull] = ACTIONS(893),
    [anon_sym_dereferenceable] = ACTIONS(893),
    [anon_sym_dereferenceable_or_null] = ACTIONS(893),
    [anon_sym_swiftself] = ACTIONS(893),
    [anon_sym_swiftasync] = ACTIONS(893),
    [anon_sym_swifterror] = ACTIONS(893),
    [anon_sym_immarg] = ACTIONS(893),
    [anon_sym_noundef] = ACTIONS(893),
    [anon_sym_uwtable] = ACTIONS(893),
    [anon_sym_memory] = ACTIONS(893),
    [anon_sym_unreachable] = ACTIONS(893),
    [anon_sym_ret] = ACTIONS(893),
    [anon_sym_br] = ACTIONS(893),
    [anon_sym_resume] = ACTIONS(893),
    [anon_sym_freeze] = ACTIONS(893),
    [anon_sym_indirectbr] = ACTIONS(893),
    [anon_sym_extractelement] = ACTIONS(893),
    [anon_sym_insertelement] = ACTIONS(893),
    [anon_sym_select] = ACTIONS(893),
    [anon_sym_shufflevector] = ACTIONS(893),
    [anon_sym_fneg] = ACTIONS(893),
    [anon_sym_switch] = ACTIONS(893),
    [anon_sym_invoke] = ACTIONS(893),
    [anon_sym_cleanupret] = ACTIONS(893),
    [anon_sym_catchret] = ACTIONS(893),
    [anon_sym_catchswitch] = ACTIONS(893),
    [anon_sym_catchpad] = ACTIONS(893),
    [anon_sym_cleanuppad] = ACTIONS(893),
    [anon_sym_callbr] = ACTIONS(893),
    [anon_sym_icmp] = ACTIONS(893),
    [anon_sym_fcmp] = ACTIONS(893),
    [anon_sym_va_arg] = ACTIONS(893),
    [anon_sym_phi] = ACTIONS(893),
    [anon_sym_landingpad] = ACTIONS(893),
    [anon_sym_tail] = ACTIONS(893),
    [anon_sym_musttail] = ACTIONS(893),
    [anon_sym_notail] = ACTIONS(893),
    [anon_sym_call] = ACTIONS(893),
    [anon_sym_alloca] = ACTIONS(893),
    [anon_sym_load] = ACTIONS(893),
    [anon_sym_store] = ACTIONS(893),
    [anon_sym_cmpxchg] = ACTIONS(893),
    [anon_sym_atomicrmw] = ACTIONS(893),
    [anon_sym_fence] = ACTIONS(893),
    [anon_sym_getelementptr] = ACTIONS(893),
    [anon_sym_extractvalue] = ACTIONS(893),
    [anon_sym_insertvalue] = ACTIONS(893),
    [anon_sym_mul] = ACTIONS(893),
    [anon_sym_urem] = ACTIONS(893),
    [anon_sym_srem] = ACTIONS(893),
    [anon_sym_shl] = ACTIONS(893),
    [anon_sym_udiv] = ACTIONS(893),
    [anon_sym_sdiv] = ACTIONS(893),
    [anon_sym_lshr] = ACTIONS(893),
    [anon_sym_ashr] = ACTIONS(893),
    [anon_sym_fmul] = ACTIONS(893),
    [anon_sym_fdiv] = ACTIONS(893),
    [anon_sym_frem] = ACTIONS(893),
    [anon_sym_xchg] = ACTIONS(893),
    [anon_sym_add] = ACTIONS(893),
    [anon_sym_sub] = ACTIONS(893),
    [anon_sym_and] = ACTIONS(893),
    [anon_sym_nand] = ACTIONS(893),
    [anon_sym_or] = ACTIONS(893),
    [anon_sym_xor] = ACTIONS(893),
    [anon_sym_max] = ACTIONS(893),
    [anon_sym_min] = ACTIONS(893),
    [anon_sym_umax] = ACTIONS(893),
    [anon_sym_umin] = ACTIONS(893),
    [anon_sym_fadd] = ACTIONS(893),
    [anon_sym_fsub] = ACTIONS(893),
    [anon_sym_bitcast] = ACTIONS(893),
    [anon_sym_trunc] = ACTIONS(893),
    [anon_sym_zext] = ACTIONS(893),
    [anon_sym_sext] = ACTIONS(893),
    [anon_sym_fptrunc] = ACTIONS(893),
    [anon_sym_fpext] = ACTIONS(893),
    [anon_sym_addrspacecast] = ACTIONS(893),
    [anon_sym_uitofp] = ACTIONS(893),
    [anon_sym_sitofp] = ACTIONS(893),
    [anon_sym_fptoui] = ACTIONS(893),
    [anon_sym_fptosi] = ACTIONS(893),
    [anon_sym_inttoptr] = ACTIONS(893),
    [anon_sym_ptrtoint] = ACTIONS(893),
    [anon_sym_uselistorder] = ACTIONS(893),
  },
  [223] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(851),
    [sym_local_var] = ACTIONS(851),
    [sym_string] = ACTIONS(851),
    [aux_sym_number_token1] = ACTIONS(853),
    [aux_sym_number_token2] = ACTIONS(851),
    [sym_float] = ACTIONS(851),
    [sym_cstring] = ACTIONS(851),
    [anon_sym_no_cfi] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_internal] = ACTIONS(851),
    [anon_sym_weak] = ACTIONS(853),
    [anon_sym_weak_odr] = ACTIONS(851),
    [anon_sym_linkonce] = ACTIONS(853),
    [anon_sym_linkonce_odr] = ACTIONS(851),
    [anon_sym_available_externally] = ACTIONS(851),
    [anon_sym_appending] = ACTIONS(851),
    [anon_sym_common] = ACTIONS(851),
    [anon_sym_extern_weak] = ACTIONS(851),
    [anon_sym_external] = ACTIONS(851),
    [anon_sym_dso_local] = ACTIONS(853),
    [anon_sym_dso_local_equivalent] = ACTIONS(851),
    [anon_sym_dso_preemptable] = ACTIONS(851),
    [anon_sym_default] = ACTIONS(851),
    [anon_sym_hidden] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_dllimport] = ACTIONS(851),
    [anon_sym_dllexport] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(851),
    [anon_sym_LT_LBRACE] = ACTIONS(851),
    [anon_sym_LBRACK] = ACTIONS(851),
    [anon_sym_LT] = ACTIONS(853),
    [anon_sym_COMMA] = ACTIONS(851),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_RPAREN] = ACTIONS(851),
    [anon_sym_align] = ACTIONS(853),
    [anon_sym_alignstack] = ACTIONS(851),
    [anon_sym_allocsize] = ACTIONS(851),
    [anon_sym_alwaysinline] = ACTIONS(851),
    [anon_sym_builtin] = ACTIONS(851),
    [anon_sym_cold] = ACTIONS(851),
    [anon_sym_convergent] = ACTIONS(851),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(851),
    [anon_sym_hot] = ACTIONS(851),
    [anon_sym_inaccessiblememonly] = ACTIONS(851),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(851),
    [anon_sym_inlinehint] = ACTIONS(851),
    [anon_sym_jumptable] = ACTIONS(851),
    [anon_sym_minsize] = ACTIONS(851),
    [anon_sym_naked] = ACTIONS(851),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(851),
    [anon_sym_nobuiltin] = ACTIONS(851),
    [anon_sym_noduplicate] = ACTIONS(851),
    [anon_sym_nofree] = ACTIONS(851),
    [anon_sym_noimplicitfloat] = ACTIONS(851),
    [anon_sym_noinline] = ACTIONS(851),
    [anon_sym_nomerge] = ACTIONS(851),
    [anon_sym_nonlazybind] = ACTIONS(851),
    [anon_sym_noprofile] = ACTIONS(851),
    [anon_sym_noredzone] = ACTIONS(851),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(851),
    [anon_sym_noreturn] = ACTIONS(851),
    [anon_sym_norecurse] = ACTIONS(851),
    [anon_sym_willreturn] = ACTIONS(851),
    [anon_sym_nosync] = ACTIONS(851),
    [anon_sym_nounwind] = ACTIONS(851),
    [anon_sym_nocallback] = ACTIONS(851),
    [anon_sym_nosanitize_coverage] = ACTIONS(851),
    [anon_sym_null_pointer_is_valid] = ACTIONS(851),
    [anon_sym_optforfuzzing] = ACTIONS(851),
    [anon_sym_optnone] = ACTIONS(851),
    [anon_sym_optsize] = ACTIONS(851),
    [anon_sym_readnone] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_writeonly] = ACTIONS(851),
    [anon_sym_argmemonly] = ACTIONS(851),
    [anon_sym_returns_twice] = ACTIONS(851),
    [anon_sym_safestack] = ACTIONS(851),
    [anon_sym_sanitize_address] = ACTIONS(851),
    [anon_sym_sanitize_memory] = ACTIONS(851),
    [anon_sym_sanitize_thread] = ACTIONS(851),
    [anon_sym_sanitize_hwaddress] = ACTIONS(851),
    [anon_sym_sanitize_memtag] = ACTIONS(851),
    [anon_sym_speculative_load_hardening] = ACTIONS(851),
    [anon_sym_speculatable] = ACTIONS(851),
    [anon_sym_ssp] = ACTIONS(853),
    [anon_sym_sspstrong] = ACTIONS(851),
    [anon_sym_sspreq] = ACTIONS(851),
    [anon_sym_strictfp] = ACTIONS(851),
    [anon_sym_nocf_check] = ACTIONS(851),
    [anon_sym_shadowcallstack] = ACTIONS(851),
    [anon_sym_mustprogress] = ACTIONS(851),
    [anon_sym_vscale_range] = ACTIONS(851),
    [anon_sym_preallocated] = ACTIONS(851),
    [anon_sym_zeroext] = ACTIONS(851),
    [anon_sym_signext] = ACTIONS(851),
    [anon_sym_inreg] = ACTIONS(851),
    [anon_sym_byval] = ACTIONS(851),
    [anon_sym_byref] = ACTIONS(851),
    [anon_sym_inalloca] = ACTIONS(851),
    [anon_sym_sret] = ACTIONS(851),
    [anon_sym_elementtype] = ACTIONS(851),
    [anon_sym_noalias] = ACTIONS(851),
    [anon_sym_nocapture] = ACTIONS(851),
    [anon_sym_nest] = ACTIONS(851),
    [anon_sym_returned] = ACTIONS(851),
    [anon_sym_nonnull] = ACTIONS(851),
    [anon_sym_dereferenceable] = ACTIONS(853),
    [anon_sym_dereferenceable_or_null] = ACTIONS(851),
    [anon_sym_swiftself] = ACTIONS(851),
    [anon_sym_swiftasync] = ACTIONS(851),
    [anon_sym_swifterror] = ACTIONS(851),
    [anon_sym_immarg] = ACTIONS(851),
    [anon_sym_noundef] = ACTIONS(851),
    [anon_sym_uwtable] = ACTIONS(851),
    [anon_sym_memory] = ACTIONS(851),
    [anon_sym_none] = ACTIONS(851),
    [anon_sym_extractelement] = ACTIONS(851),
    [anon_sym_insertelement] = ACTIONS(851),
    [anon_sym_select] = ACTIONS(851),
    [anon_sym_shufflevector] = ACTIONS(851),
    [anon_sym_fneg] = ACTIONS(851),
    [anon_sym_icmp] = ACTIONS(851),
    [anon_sym_fcmp] = ACTIONS(851),
    [anon_sym_getelementptr] = ACTIONS(851),
    [anon_sym_extractvalue] = ACTIONS(851),
    [anon_sym_insertvalue] = ACTIONS(851),
    [anon_sym_true] = ACTIONS(851),
    [anon_sym_false] = ACTIONS(851),
    [anon_sym_null] = ACTIONS(853),
    [anon_sym_undef] = ACTIONS(851),
    [anon_sym_poison] = ACTIONS(851),
    [anon_sym_zeroinitializer] = ACTIONS(851),
    [anon_sym_blockaddress] = ACTIONS(851),
    [anon_sym_mul] = ACTIONS(851),
    [anon_sym_urem] = ACTIONS(851),
    [anon_sym_srem] = ACTIONS(851),
    [anon_sym_shl] = ACTIONS(851),
    [anon_sym_udiv] = ACTIONS(851),
    [anon_sym_sdiv] = ACTIONS(851),
    [anon_sym_lshr] = ACTIONS(851),
    [anon_sym_ashr] = ACTIONS(851),
    [anon_sym_fmul] = ACTIONS(851),
    [anon_sym_fdiv] = ACTIONS(851),
    [anon_sym_frem] = ACTIONS(851),
    [anon_sym_xchg] = ACTIONS(851),
    [anon_sym_add] = ACTIONS(853),
    [anon_sym_sub] = ACTIONS(851),
    [anon_sym_and] = ACTIONS(851),
    [anon_sym_nand] = ACTIONS(851),
    [anon_sym_or] = ACTIONS(851),
    [anon_sym_xor] = ACTIONS(851),
    [anon_sym_max] = ACTIONS(851),
    [anon_sym_min] = ACTIONS(853),
    [anon_sym_umax] = ACTIONS(851),
    [anon_sym_umin] = ACTIONS(851),
    [anon_sym_fadd] = ACTIONS(851),
    [anon_sym_fsub] = ACTIONS(851),
    [anon_sym_bitcast] = ACTIONS(851),
    [anon_sym_trunc] = ACTIONS(851),
    [anon_sym_zext] = ACTIONS(851),
    [anon_sym_sext] = ACTIONS(851),
    [anon_sym_fptrunc] = ACTIONS(851),
    [anon_sym_fpext] = ACTIONS(851),
    [anon_sym_addrspacecast] = ACTIONS(851),
    [anon_sym_uitofp] = ACTIONS(851),
    [anon_sym_sitofp] = ACTIONS(851),
    [anon_sym_fptoui] = ACTIONS(851),
    [anon_sym_fptosi] = ACTIONS(851),
    [anon_sym_inttoptr] = ACTIONS(851),
    [anon_sym_ptrtoint] = ACTIONS(851),
  },
  [224] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(371),
    [sym_local_var] = ACTIONS(371),
    [sym_label] = ACTIONS(371),
    [sym_string] = ACTIONS(373),
    [anon_sym_RBRACE] = ACTIONS(371),
    [anon_sym_LBRACK] = ACTIONS(371),
    [anon_sym_COMMA] = ACTIONS(371),
    [anon_sym_align] = ACTIONS(373),
    [anon_sym_section] = ACTIONS(373),
    [anon_sym_partition] = ACTIONS(373),
    [anon_sym_comdat] = ACTIONS(373),
    [anon_sym_gc] = ACTIONS(373),
    [anon_sym_prefix] = ACTIONS(373),
    [anon_sym_prologue] = ACTIONS(373),
    [anon_sym_personality] = ACTIONS(373),
    [anon_sym_alignstack] = ACTIONS(373),
    [anon_sym_allocsize] = ACTIONS(373),
    [anon_sym_alwaysinline] = ACTIONS(373),
    [anon_sym_builtin] = ACTIONS(373),
    [anon_sym_cold] = ACTIONS(373),
    [anon_sym_convergent] = ACTIONS(373),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(373),
    [anon_sym_hot] = ACTIONS(373),
    [anon_sym_inaccessiblememonly] = ACTIONS(373),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(373),
    [anon_sym_inlinehint] = ACTIONS(373),
    [anon_sym_jumptable] = ACTIONS(373),
    [anon_sym_minsize] = ACTIONS(373),
    [anon_sym_naked] = ACTIONS(373),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(373),
    [anon_sym_nobuiltin] = ACTIONS(373),
    [anon_sym_noduplicate] = ACTIONS(373),
    [anon_sym_nofree] = ACTIONS(373),
    [anon_sym_noimplicitfloat] = ACTIONS(373),
    [anon_sym_noinline] = ACTIONS(373),
    [anon_sym_nomerge] = ACTIONS(373),
    [anon_sym_nonlazybind] = ACTIONS(373),
    [anon_sym_noprofile] = ACTIONS(373),
    [anon_sym_noredzone] = ACTIONS(373),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(373),
    [anon_sym_noreturn] = ACTIONS(373),
    [anon_sym_norecurse] = ACTIONS(373),
    [anon_sym_willreturn] = ACTIONS(373),
    [anon_sym_nosync] = ACTIONS(373),
    [anon_sym_nounwind] = ACTIONS(373),
    [anon_sym_nocallback] = ACTIONS(373),
    [anon_sym_nosanitize_coverage] = ACTIONS(373),
    [anon_sym_null_pointer_is_valid] = ACTIONS(373),
    [anon_sym_optforfuzzing] = ACTIONS(373),
    [anon_sym_optnone] = ACTIONS(373),
    [anon_sym_optsize] = ACTIONS(373),
    [anon_sym_readnone] = ACTIONS(373),
    [anon_sym_readonly] = ACTIONS(373),
    [anon_sym_writeonly] = ACTIONS(373),
    [anon_sym_argmemonly] = ACTIONS(373),
    [anon_sym_returns_twice] = ACTIONS(373),
    [anon_sym_safestack] = ACTIONS(373),
    [anon_sym_sanitize_address] = ACTIONS(373),
    [anon_sym_sanitize_memory] = ACTIONS(373),
    [anon_sym_sanitize_thread] = ACTIONS(373),
    [anon_sym_sanitize_hwaddress] = ACTIONS(373),
    [anon_sym_sanitize_memtag] = ACTIONS(373),
    [anon_sym_speculative_load_hardening] = ACTIONS(373),
    [anon_sym_speculatable] = ACTIONS(373),
    [anon_sym_ssp] = ACTIONS(373),
    [anon_sym_sspstrong] = ACTIONS(373),
    [anon_sym_sspreq] = ACTIONS(373),
    [anon_sym_strictfp] = ACTIONS(373),
    [anon_sym_nocf_check] = ACTIONS(373),
    [anon_sym_shadowcallstack] = ACTIONS(373),
    [anon_sym_mustprogress] = ACTIONS(373),
    [anon_sym_vscale_range] = ACTIONS(373),
    [anon_sym_preallocated] = ACTIONS(373),
    [anon_sym_zeroext] = ACTIONS(373),
    [anon_sym_signext] = ACTIONS(373),
    [anon_sym_inreg] = ACTIONS(373),
    [anon_sym_byval] = ACTIONS(373),
    [anon_sym_byref] = ACTIONS(373),
    [anon_sym_inalloca] = ACTIONS(373),
    [anon_sym_sret] = ACTIONS(373),
    [anon_sym_elementtype] = ACTIONS(373),
    [anon_sym_noalias] = ACTIONS(373),
    [anon_sym_nocapture] = ACTIONS(373),
    [anon_sym_nest] = ACTIONS(373),
    [anon_sym_returned] = ACTIONS(373),
    [anon_sym_nonnull] = ACTIONS(373),
    [anon_sym_dereferenceable] = ACTIONS(373),
    [anon_sym_dereferenceable_or_null] = ACTIONS(373),
    [anon_sym_swiftself] = ACTIONS(373),
    [anon_sym_swiftasync] = ACTIONS(373),
    [anon_sym_swifterror] = ACTIONS(373),
    [anon_sym_immarg] = ACTIONS(373),
    [anon_sym_noundef] = ACTIONS(373),
    [anon_sym_uwtable] = ACTIONS(373),
    [anon_sym_memory] = ACTIONS(373),
    [anon_sym_unreachable] = ACTIONS(373),
    [anon_sym_ret] = ACTIONS(373),
    [anon_sym_br] = ACTIONS(373),
    [anon_sym_resume] = ACTIONS(373),
    [anon_sym_freeze] = ACTIONS(373),
    [anon_sym_indirectbr] = ACTIONS(373),
    [anon_sym_extractelement] = ACTIONS(373),
    [anon_sym_insertelement] = ACTIONS(373),
    [anon_sym_select] = ACTIONS(373),
    [anon_sym_shufflevector] = ACTIONS(373),
    [anon_sym_fneg] = ACTIONS(373),
    [anon_sym_switch] = ACTIONS(373),
    [anon_sym_invoke] = ACTIONS(373),
    [anon_sym_cleanupret] = ACTIONS(373),
    [anon_sym_catchret] = ACTIONS(373),
    [anon_sym_catchswitch] = ACTIONS(373),
    [anon_sym_catchpad] = ACTIONS(373),
    [anon_sym_cleanuppad] = ACTIONS(373),
    [anon_sym_callbr] = ACTIONS(373),
    [anon_sym_icmp] = ACTIONS(373),
    [anon_sym_fcmp] = ACTIONS(373),
    [anon_sym_va_arg] = ACTIONS(373),
    [anon_sym_phi] = ACTIONS(373),
    [anon_sym_landingpad] = ACTIONS(373),
    [anon_sym_tail] = ACTIONS(373),
    [anon_sym_musttail] = ACTIONS(373),
    [anon_sym_notail] = ACTIONS(373),
    [anon_sym_call] = ACTIONS(373),
    [anon_sym_alloca] = ACTIONS(373),
    [anon_sym_load] = ACTIONS(373),
    [anon_sym_store] = ACTIONS(373),
    [anon_sym_cmpxchg] = ACTIONS(373),
    [anon_sym_atomicrmw] = ACTIONS(373),
    [anon_sym_fence] = ACTIONS(373),
    [anon_sym_getelementptr] = ACTIONS(373),
    [anon_sym_extractvalue] = ACTIONS(373),
    [anon_sym_insertvalue] = ACTIONS(373),
    [anon_sym_mul] = ACTIONS(373),
    [anon_sym_urem] = ACTIONS(373),
    [anon_sym_srem] = ACTIONS(373),
    [anon_sym_shl] = ACTIONS(373),
    [anon_sym_udiv] = ACTIONS(373),
    [anon_sym_sdiv] = ACTIONS(373),
    [anon_sym_lshr] = ACTIONS(373),
    [anon_sym_ashr] = ACTIONS(373),
    [anon_sym_fmul] = ACTIONS(373),
    [anon_sym_fdiv] = ACTIONS(373),
    [anon_sym_frem] = ACTIONS(373),
    [anon_sym_xchg] = ACTIONS(373),
    [anon_sym_add] = ACTIONS(373),
    [anon_sym_sub] = ACTIONS(373),
    [anon_sym_and] = ACTIONS(373),
    [anon_sym_nand] = ACTIONS(373),
    [anon_sym_or] = ACTIONS(373),
    [anon_sym_xor] = ACTIONS(373),
    [anon_sym_max] = ACTIONS(373),
    [anon_sym_min] = ACTIONS(373),
    [anon_sym_umax] = ACTIONS(373),
    [anon_sym_umin] = ACTIONS(373),
    [anon_sym_fadd] = ACTIONS(373),
    [anon_sym_fsub] = ACTIONS(373),
    [anon_sym_bitcast] = ACTIONS(373),
    [anon_sym_trunc] = ACTIONS(373),
    [anon_sym_zext] = ACTIONS(373),
    [anon_sym_sext] = ACTIONS(373),
    [anon_sym_fptrunc] = ACTIONS(373),
    [anon_sym_fpext] = ACTIONS(373),
    [anon_sym_addrspacecast] = ACTIONS(373),
    [anon_sym_uitofp] = ACTIONS(373),
    [anon_sym_sitofp] = ACTIONS(373),
    [anon_sym_fptoui] = ACTIONS(373),
    [anon_sym_fptosi] = ACTIONS(373),
    [anon_sym_inttoptr] = ACTIONS(373),
    [anon_sym_ptrtoint] = ACTIONS(373),
    [anon_sym_uselistorder] = ACTIONS(373),
  },
  [225] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(895),
    [sym_local_var] = ACTIONS(895),
    [sym_string] = ACTIONS(895),
    [aux_sym_number_token1] = ACTIONS(897),
    [aux_sym_number_token2] = ACTIONS(895),
    [sym_float] = ACTIONS(895),
    [sym_cstring] = ACTIONS(895),
    [anon_sym_no_cfi] = ACTIONS(895),
    [anon_sym_private] = ACTIONS(895),
    [anon_sym_internal] = ACTIONS(895),
    [anon_sym_weak] = ACTIONS(897),
    [anon_sym_weak_odr] = ACTIONS(895),
    [anon_sym_linkonce] = ACTIONS(897),
    [anon_sym_linkonce_odr] = ACTIONS(895),
    [anon_sym_available_externally] = ACTIONS(895),
    [anon_sym_appending] = ACTIONS(895),
    [anon_sym_common] = ACTIONS(895),
    [anon_sym_extern_weak] = ACTIONS(895),
    [anon_sym_external] = ACTIONS(895),
    [anon_sym_dso_local] = ACTIONS(897),
    [anon_sym_dso_local_equivalent] = ACTIONS(895),
    [anon_sym_dso_preemptable] = ACTIONS(895),
    [anon_sym_default] = ACTIONS(895),
    [anon_sym_hidden] = ACTIONS(895),
    [anon_sym_protected] = ACTIONS(895),
    [anon_sym_dllimport] = ACTIONS(895),
    [anon_sym_dllexport] = ACTIONS(895),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_LT_LBRACE] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_COMMA] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(899),
    [anon_sym_RPAREN] = ACTIONS(895),
    [anon_sym_align] = ACTIONS(897),
    [anon_sym_alignstack] = ACTIONS(895),
    [anon_sym_allocsize] = ACTIONS(895),
    [anon_sym_alwaysinline] = ACTIONS(895),
    [anon_sym_builtin] = ACTIONS(895),
    [anon_sym_cold] = ACTIONS(895),
    [anon_sym_convergent] = ACTIONS(895),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(895),
    [anon_sym_hot] = ACTIONS(895),
    [anon_sym_inaccessiblememonly] = ACTIONS(895),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(895),
    [anon_sym_inlinehint] = ACTIONS(895),
    [anon_sym_jumptable] = ACTIONS(895),
    [anon_sym_minsize] = ACTIONS(895),
    [anon_sym_naked] = ACTIONS(895),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(895),
    [anon_sym_nobuiltin] = ACTIONS(895),
    [anon_sym_noduplicate] = ACTIONS(895),
    [anon_sym_nofree] = ACTIONS(895),
    [anon_sym_noimplicitfloat] = ACTIONS(895),
    [anon_sym_noinline] = ACTIONS(895),
    [anon_sym_nomerge] = ACTIONS(895),
    [anon_sym_nonlazybind] = ACTIONS(895),
    [anon_sym_noprofile] = ACTIONS(895),
    [anon_sym_noredzone] = ACTIONS(895),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(895),
    [anon_sym_noreturn] = ACTIONS(895),
    [anon_sym_norecurse] = ACTIONS(895),
    [anon_sym_willreturn] = ACTIONS(895),
    [anon_sym_nosync] = ACTIONS(895),
    [anon_sym_nounwind] = ACTIONS(895),
    [anon_sym_nocallback] = ACTIONS(895),
    [anon_sym_nosanitize_coverage] = ACTIONS(895),
    [anon_sym_null_pointer_is_valid] = ACTIONS(895),
    [anon_sym_optforfuzzing] = ACTIONS(895),
    [anon_sym_optnone] = ACTIONS(895),
    [anon_sym_optsize] = ACTIONS(895),
    [anon_sym_readnone] = ACTIONS(895),
    [anon_sym_readonly] = ACTIONS(895),
    [anon_sym_writeonly] = ACTIONS(895),
    [anon_sym_argmemonly] = ACTIONS(895),
    [anon_sym_returns_twice] = ACTIONS(895),
    [anon_sym_safestack] = ACTIONS(895),
    [anon_sym_sanitize_address] = ACTIONS(895),
    [anon_sym_sanitize_memory] = ACTIONS(895),
    [anon_sym_sanitize_thread] = ACTIONS(895),
    [anon_sym_sanitize_hwaddress] = ACTIONS(895),
    [anon_sym_sanitize_memtag] = ACTIONS(895),
    [anon_sym_speculative_load_hardening] = ACTIONS(895),
    [anon_sym_speculatable] = ACTIONS(895),
    [anon_sym_ssp] = ACTIONS(897),
    [anon_sym_sspstrong] = ACTIONS(895),
    [anon_sym_sspreq] = ACTIONS(895),
    [anon_sym_strictfp] = ACTIONS(895),
    [anon_sym_nocf_check] = ACTIONS(895),
    [anon_sym_shadowcallstack] = ACTIONS(895),
    [anon_sym_mustprogress] = ACTIONS(895),
    [anon_sym_vscale_range] = ACTIONS(895),
    [anon_sym_preallocated] = ACTIONS(895),
    [anon_sym_zeroext] = ACTIONS(895),
    [anon_sym_signext] = ACTIONS(895),
    [anon_sym_inreg] = ACTIONS(895),
    [anon_sym_byval] = ACTIONS(895),
    [anon_sym_byref] = ACTIONS(895),
    [anon_sym_inalloca] = ACTIONS(895),
    [anon_sym_sret] = ACTIONS(895),
    [anon_sym_elementtype] = ACTIONS(895),
    [anon_sym_noalias] = ACTIONS(895),
    [anon_sym_nocapture] = ACTIONS(895),
    [anon_sym_nest] = ACTIONS(895),
    [anon_sym_returned] = ACTIONS(895),
    [anon_sym_nonnull] = ACTIONS(895),
    [anon_sym_dereferenceable] = ACTIONS(897),
    [anon_sym_dereferenceable_or_null] = ACTIONS(895),
    [anon_sym_swiftself] = ACTIONS(895),
    [anon_sym_swiftasync] = ACTIONS(895),
    [anon_sym_swifterror] = ACTIONS(895),
    [anon_sym_immarg] = ACTIONS(895),
    [anon_sym_noundef] = ACTIONS(895),
    [anon_sym_uwtable] = ACTIONS(895),
    [anon_sym_memory] = ACTIONS(895),
    [anon_sym_none] = ACTIONS(895),
    [anon_sym_extractelement] = ACTIONS(895),
    [anon_sym_insertelement] = ACTIONS(895),
    [anon_sym_select] = ACTIONS(895),
    [anon_sym_shufflevector] = ACTIONS(895),
    [anon_sym_fneg] = ACTIONS(895),
    [anon_sym_icmp] = ACTIONS(895),
    [anon_sym_fcmp] = ACTIONS(895),
    [anon_sym_getelementptr] = ACTIONS(895),
    [anon_sym_extractvalue] = ACTIONS(895),
    [anon_sym_insertvalue] = ACTIONS(895),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_null] = ACTIONS(897),
    [anon_sym_undef] = ACTIONS(895),
    [anon_sym_poison] = ACTIONS(895),
    [anon_sym_zeroinitializer] = ACTIONS(895),
    [anon_sym_blockaddress] = ACTIONS(895),
    [anon_sym_mul] = ACTIONS(895),
    [anon_sym_urem] = ACTIONS(895),
    [anon_sym_srem] = ACTIONS(895),
    [anon_sym_shl] = ACTIONS(895),
    [anon_sym_udiv] = ACTIONS(895),
    [anon_sym_sdiv] = ACTIONS(895),
    [anon_sym_lshr] = ACTIONS(895),
    [anon_sym_ashr] = ACTIONS(895),
    [anon_sym_fmul] = ACTIONS(895),
    [anon_sym_fdiv] = ACTIONS(895),
    [anon_sym_frem] = ACTIONS(895),
    [anon_sym_xchg] = ACTIONS(895),
    [anon_sym_add] = ACTIONS(897),
    [anon_sym_sub] = ACTIONS(895),
    [anon_sym_and] = ACTIONS(895),
    [anon_sym_nand] = ACTIONS(895),
    [anon_sym_or] = ACTIONS(895),
    [anon_sym_xor] = ACTIONS(895),
    [anon_sym_max] = ACTIONS(895),
    [anon_sym_min] = ACTIONS(897),
    [anon_sym_umax] = ACTIONS(895),
    [anon_sym_umin] = ACTIONS(895),
    [anon_sym_fadd] = ACTIONS(895),
    [anon_sym_fsub] = ACTIONS(895),
    [anon_sym_bitcast] = ACTIONS(895),
    [anon_sym_trunc] = ACTIONS(895),
    [anon_sym_zext] = ACTIONS(895),
    [anon_sym_sext] = ACTIONS(895),
    [anon_sym_fptrunc] = ACTIONS(895),
    [anon_sym_fpext] = ACTIONS(895),
    [anon_sym_addrspacecast] = ACTIONS(895),
    [anon_sym_uitofp] = ACTIONS(895),
    [anon_sym_sitofp] = ACTIONS(895),
    [anon_sym_fptoui] = ACTIONS(895),
    [anon_sym_fptosi] = ACTIONS(895),
    [anon_sym_inttoptr] = ACTIONS(895),
    [anon_sym_ptrtoint] = ACTIONS(895),
  },
  [226] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(839),
    [sym_local_var] = ACTIONS(839),
    [sym_string] = ACTIONS(839),
    [aux_sym_number_token1] = ACTIONS(841),
    [aux_sym_number_token2] = ACTIONS(839),
    [sym_float] = ACTIONS(839),
    [sym_cstring] = ACTIONS(839),
    [anon_sym_no_cfi] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_internal] = ACTIONS(839),
    [anon_sym_weak] = ACTIONS(841),
    [anon_sym_weak_odr] = ACTIONS(839),
    [anon_sym_linkonce] = ACTIONS(841),
    [anon_sym_linkonce_odr] = ACTIONS(839),
    [anon_sym_available_externally] = ACTIONS(839),
    [anon_sym_appending] = ACTIONS(839),
    [anon_sym_common] = ACTIONS(839),
    [anon_sym_extern_weak] = ACTIONS(839),
    [anon_sym_external] = ACTIONS(839),
    [anon_sym_dso_local] = ACTIONS(841),
    [anon_sym_dso_local_equivalent] = ACTIONS(839),
    [anon_sym_dso_preemptable] = ACTIONS(839),
    [anon_sym_default] = ACTIONS(839),
    [anon_sym_hidden] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_dllimport] = ACTIONS(839),
    [anon_sym_dllexport] = ACTIONS(839),
    [anon_sym_LBRACE] = ACTIONS(839),
    [anon_sym_LT_LBRACE] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_RPAREN] = ACTIONS(839),
    [anon_sym_align] = ACTIONS(841),
    [anon_sym_alignstack] = ACTIONS(839),
    [anon_sym_allocsize] = ACTIONS(839),
    [anon_sym_alwaysinline] = ACTIONS(839),
    [anon_sym_builtin] = ACTIONS(839),
    [anon_sym_cold] = ACTIONS(839),
    [anon_sym_convergent] = ACTIONS(839),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(839),
    [anon_sym_hot] = ACTIONS(839),
    [anon_sym_inaccessiblememonly] = ACTIONS(839),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(839),
    [anon_sym_inlinehint] = ACTIONS(839),
    [anon_sym_jumptable] = ACTIONS(839),
    [anon_sym_minsize] = ACTIONS(839),
    [anon_sym_naked] = ACTIONS(839),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(839),
    [anon_sym_nobuiltin] = ACTIONS(839),
    [anon_sym_noduplicate] = ACTIONS(839),
    [anon_sym_nofree] = ACTIONS(839),
    [anon_sym_noimplicitfloat] = ACTIONS(839),
    [anon_sym_noinline] = ACTIONS(839),
    [anon_sym_nomerge] = ACTIONS(839),
    [anon_sym_nonlazybind] = ACTIONS(839),
    [anon_sym_noprofile] = ACTIONS(839),
    [anon_sym_noredzone] = ACTIONS(839),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(839),
    [anon_sym_noreturn] = ACTIONS(839),
    [anon_sym_norecurse] = ACTIONS(839),
    [anon_sym_willreturn] = ACTIONS(839),
    [anon_sym_nosync] = ACTIONS(839),
    [anon_sym_nounwind] = ACTIONS(839),
    [anon_sym_nocallback] = ACTIONS(839),
    [anon_sym_nosanitize_coverage] = ACTIONS(839),
    [anon_sym_null_pointer_is_valid] = ACTIONS(839),
    [anon_sym_optforfuzzing] = ACTIONS(839),
    [anon_sym_optnone] = ACTIONS(839),
    [anon_sym_optsize] = ACTIONS(839),
    [anon_sym_readnone] = ACTIONS(839),
    [anon_sym_readonly] = ACTIONS(839),
    [anon_sym_writeonly] = ACTIONS(839),
    [anon_sym_argmemonly] = ACTIONS(839),
    [anon_sym_returns_twice] = ACTIONS(839),
    [anon_sym_safestack] = ACTIONS(839),
    [anon_sym_sanitize_address] = ACTIONS(839),
    [anon_sym_sanitize_memory] = ACTIONS(839),
    [anon_sym_sanitize_thread] = ACTIONS(839),
    [anon_sym_sanitize_hwaddress] = ACTIONS(839),
    [anon_sym_sanitize_memtag] = ACTIONS(839),
    [anon_sym_speculative_load_hardening] = ACTIONS(839),
    [anon_sym_speculatable] = ACTIONS(839),
    [anon_sym_ssp] = ACTIONS(841),
    [anon_sym_sspstrong] = ACTIONS(839),
    [anon_sym_sspreq] = ACTIONS(839),
    [anon_sym_strictfp] = ACTIONS(839),
    [anon_sym_nocf_check] = ACTIONS(839),
    [anon_sym_shadowcallstack] = ACTIONS(839),
    [anon_sym_mustprogress] = ACTIONS(839),
    [anon_sym_vscale_range] = ACTIONS(839),
    [anon_sym_preallocated] = ACTIONS(839),
    [anon_sym_zeroext] = ACTIONS(839),
    [anon_sym_signext] = ACTIONS(839),
    [anon_sym_inreg] = ACTIONS(839),
    [anon_sym_byval] = ACTIONS(839),
    [anon_sym_byref] = ACTIONS(839),
    [anon_sym_inalloca] = ACTIONS(839),
    [anon_sym_sret] = ACTIONS(839),
    [anon_sym_elementtype] = ACTIONS(839),
    [anon_sym_noalias] = ACTIONS(839),
    [anon_sym_nocapture] = ACTIONS(839),
    [anon_sym_nest] = ACTIONS(839),
    [anon_sym_returned] = ACTIONS(839),
    [anon_sym_nonnull] = ACTIONS(839),
    [anon_sym_dereferenceable] = ACTIONS(841),
    [anon_sym_dereferenceable_or_null] = ACTIONS(839),
    [anon_sym_swiftself] = ACTIONS(839),
    [anon_sym_swiftasync] = ACTIONS(839),
    [anon_sym_swifterror] = ACTIONS(839),
    [anon_sym_immarg] = ACTIONS(839),
    [anon_sym_noundef] = ACTIONS(839),
    [anon_sym_uwtable] = ACTIONS(839),
    [anon_sym_memory] = ACTIONS(839),
    [anon_sym_none] = ACTIONS(839),
    [anon_sym_extractelement] = ACTIONS(839),
    [anon_sym_insertelement] = ACTIONS(839),
    [anon_sym_select] = ACTIONS(839),
    [anon_sym_shufflevector] = ACTIONS(839),
    [anon_sym_fneg] = ACTIONS(839),
    [anon_sym_icmp] = ACTIONS(839),
    [anon_sym_fcmp] = ACTIONS(839),
    [anon_sym_getelementptr] = ACTIONS(839),
    [anon_sym_extractvalue] = ACTIONS(839),
    [anon_sym_insertvalue] = ACTIONS(839),
    [anon_sym_true] = ACTIONS(839),
    [anon_sym_false] = ACTIONS(839),
    [anon_sym_null] = ACTIONS(841),
    [anon_sym_undef] = ACTIONS(839),
    [anon_sym_poison] = ACTIONS(839),
    [anon_sym_zeroinitializer] = ACTIONS(839),
    [anon_sym_blockaddress] = ACTIONS(839),
    [anon_sym_mul] = ACTIONS(839),
    [anon_sym_urem] = ACTIONS(839),
    [anon_sym_srem] = ACTIONS(839),
    [anon_sym_shl] = ACTIONS(839),
    [anon_sym_udiv] = ACTIONS(839),
    [anon_sym_sdiv] = ACTIONS(839),
    [anon_sym_lshr] = ACTIONS(839),
    [anon_sym_ashr] = ACTIONS(839),
    [anon_sym_fmul] = ACTIONS(839),
    [anon_sym_fdiv] = ACTIONS(839),
    [anon_sym_frem] = ACTIONS(839),
    [anon_sym_xchg] = ACTIONS(839),
    [anon_sym_add] = ACTIONS(841),
    [anon_sym_sub] = ACTIONS(839),
    [anon_sym_and] = ACTIONS(839),
    [anon_sym_nand] = ACTIONS(839),
    [anon_sym_or] = ACTIONS(839),
    [anon_sym_xor] = ACTIONS(839),
    [anon_sym_max] = ACTIONS(839),
    [anon_sym_min] = ACTIONS(841),
    [anon_sym_umax] = ACTIONS(839),
    [anon_sym_umin] = ACTIONS(839),
    [anon_sym_fadd] = ACTIONS(839),
    [anon_sym_fsub] = ACTIONS(839),
    [anon_sym_bitcast] = ACTIONS(839),
    [anon_sym_trunc] = ACTIONS(839),
    [anon_sym_zext] = ACTIONS(839),
    [anon_sym_sext] = ACTIONS(839),
    [anon_sym_fptrunc] = ACTIONS(839),
    [anon_sym_fpext] = ACTIONS(839),
    [anon_sym_addrspacecast] = ACTIONS(839),
    [anon_sym_uitofp] = ACTIONS(839),
    [anon_sym_sitofp] = ACTIONS(839),
    [anon_sym_fptoui] = ACTIONS(839),
    [anon_sym_fptosi] = ACTIONS(839),
    [anon_sym_inttoptr] = ACTIONS(839),
    [anon_sym_ptrtoint] = ACTIONS(839),
  },
  [227] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(387),
    [sym_local_var] = ACTIONS(387),
    [sym_label] = ACTIONS(387),
    [sym_string] = ACTIONS(389),
    [anon_sym_RBRACE] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(387),
    [anon_sym_COMMA] = ACTIONS(387),
    [anon_sym_align] = ACTIONS(389),
    [anon_sym_section] = ACTIONS(389),
    [anon_sym_partition] = ACTIONS(389),
    [anon_sym_comdat] = ACTIONS(389),
    [anon_sym_gc] = ACTIONS(389),
    [anon_sym_prefix] = ACTIONS(389),
    [anon_sym_prologue] = ACTIONS(389),
    [anon_sym_personality] = ACTIONS(389),
    [anon_sym_alignstack] = ACTIONS(389),
    [anon_sym_allocsize] = ACTIONS(389),
    [anon_sym_alwaysinline] = ACTIONS(389),
    [anon_sym_builtin] = ACTIONS(389),
    [anon_sym_cold] = ACTIONS(389),
    [anon_sym_convergent] = ACTIONS(389),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(389),
    [anon_sym_hot] = ACTIONS(389),
    [anon_sym_inaccessiblememonly] = ACTIONS(389),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(389),
    [anon_sym_inlinehint] = ACTIONS(389),
    [anon_sym_jumptable] = ACTIONS(389),
    [anon_sym_minsize] = ACTIONS(389),
    [anon_sym_naked] = ACTIONS(389),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(389),
    [anon_sym_nobuiltin] = ACTIONS(389),
    [anon_sym_noduplicate] = ACTIONS(389),
    [anon_sym_nofree] = ACTIONS(389),
    [anon_sym_noimplicitfloat] = ACTIONS(389),
    [anon_sym_noinline] = ACTIONS(389),
    [anon_sym_nomerge] = ACTIONS(389),
    [anon_sym_nonlazybind] = ACTIONS(389),
    [anon_sym_noprofile] = ACTIONS(389),
    [anon_sym_noredzone] = ACTIONS(389),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(389),
    [anon_sym_noreturn] = ACTIONS(389),
    [anon_sym_norecurse] = ACTIONS(389),
    [anon_sym_willreturn] = ACTIONS(389),
    [anon_sym_nosync] = ACTIONS(389),
    [anon_sym_nounwind] = ACTIONS(389),
    [anon_sym_nocallback] = ACTIONS(389),
    [anon_sym_nosanitize_coverage] = ACTIONS(389),
    [anon_sym_null_pointer_is_valid] = ACTIONS(389),
    [anon_sym_optforfuzzing] = ACTIONS(389),
    [anon_sym_optnone] = ACTIONS(389),
    [anon_sym_optsize] = ACTIONS(389),
    [anon_sym_readnone] = ACTIONS(389),
    [anon_sym_readonly] = ACTIONS(389),
    [anon_sym_writeonly] = ACTIONS(389),
    [anon_sym_argmemonly] = ACTIONS(389),
    [anon_sym_returns_twice] = ACTIONS(389),
    [anon_sym_safestack] = ACTIONS(389),
    [anon_sym_sanitize_address] = ACTIONS(389),
    [anon_sym_sanitize_memory] = ACTIONS(389),
    [anon_sym_sanitize_thread] = ACTIONS(389),
    [anon_sym_sanitize_hwaddress] = ACTIONS(389),
    [anon_sym_sanitize_memtag] = ACTIONS(389),
    [anon_sym_speculative_load_hardening] = ACTIONS(389),
    [anon_sym_speculatable] = ACTIONS(389),
    [anon_sym_ssp] = ACTIONS(389),
    [anon_sym_sspstrong] = ACTIONS(389),
    [anon_sym_sspreq] = ACTIONS(389),
    [anon_sym_strictfp] = ACTIONS(389),
    [anon_sym_nocf_check] = ACTIONS(389),
    [anon_sym_shadowcallstack] = ACTIONS(389),
    [anon_sym_mustprogress] = ACTIONS(389),
    [anon_sym_vscale_range] = ACTIONS(389),
    [anon_sym_preallocated] = ACTIONS(389),
    [anon_sym_zeroext] = ACTIONS(389),
    [anon_sym_signext] = ACTIONS(389),
    [anon_sym_inreg] = ACTIONS(389),
    [anon_sym_byval] = ACTIONS(389),
    [anon_sym_byref] = ACTIONS(389),
    [anon_sym_inalloca] = ACTIONS(389),
    [anon_sym_sret] = ACTIONS(389),
    [anon_sym_elementtype] = ACTIONS(389),
    [anon_sym_noalias] = ACTIONS(389),
    [anon_sym_nocapture] = ACTIONS(389),
    [anon_sym_nest] = ACTIONS(389),
    [anon_sym_returned] = ACTIONS(389),
    [anon_sym_nonnull] = ACTIONS(389),
    [anon_sym_dereferenceable] = ACTIONS(389),
    [anon_sym_dereferenceable_or_null] = ACTIONS(389),
    [anon_sym_swiftself] = ACTIONS(389),
    [anon_sym_swiftasync] = ACTIONS(389),
    [anon_sym_swifterror] = ACTIONS(389),
    [anon_sym_immarg] = ACTIONS(389),
    [anon_sym_noundef] = ACTIONS(389),
    [anon_sym_uwtable] = ACTIONS(389),
    [anon_sym_memory] = ACTIONS(389),
    [anon_sym_unreachable] = ACTIONS(389),
    [anon_sym_ret] = ACTIONS(389),
    [anon_sym_br] = ACTIONS(389),
    [anon_sym_resume] = ACTIONS(389),
    [anon_sym_freeze] = ACTIONS(389),
    [anon_sym_indirectbr] = ACTIONS(389),
    [anon_sym_extractelement] = ACTIONS(389),
    [anon_sym_insertelement] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(389),
    [anon_sym_shufflevector] = ACTIONS(389),
    [anon_sym_fneg] = ACTIONS(389),
    [anon_sym_switch] = ACTIONS(389),
    [anon_sym_invoke] = ACTIONS(389),
    [anon_sym_cleanupret] = ACTIONS(389),
    [anon_sym_catchret] = ACTIONS(389),
    [anon_sym_catchswitch] = ACTIONS(389),
    [anon_sym_catchpad] = ACTIONS(389),
    [anon_sym_cleanuppad] = ACTIONS(389),
    [anon_sym_callbr] = ACTIONS(389),
    [anon_sym_icmp] = ACTIONS(389),
    [anon_sym_fcmp] = ACTIONS(389),
    [anon_sym_va_arg] = ACTIONS(389),
    [anon_sym_phi] = ACTIONS(389),
    [anon_sym_landingpad] = ACTIONS(389),
    [anon_sym_tail] = ACTIONS(389),
    [anon_sym_musttail] = ACTIONS(389),
    [anon_sym_notail] = ACTIONS(389),
    [anon_sym_call] = ACTIONS(389),
    [anon_sym_alloca] = ACTIONS(389),
    [anon_sym_load] = ACTIONS(389),
    [anon_sym_store] = ACTIONS(389),
    [anon_sym_cmpxchg] = ACTIONS(389),
    [anon_sym_atomicrmw] = ACTIONS(389),
    [anon_sym_fence] = ACTIONS(389),
    [anon_sym_getelementptr] = ACTIONS(389),
    [anon_sym_extractvalue] = ACTIONS(389),
    [anon_sym_insertvalue] = ACTIONS(389),
    [anon_sym_mul] = ACTIONS(389),
    [anon_sym_urem] = ACTIONS(389),
    [anon_sym_srem] = ACTIONS(389),
    [anon_sym_shl] = ACTIONS(389),
    [anon_sym_udiv] = ACTIONS(389),
    [anon_sym_sdiv] = ACTIONS(389),
    [anon_sym_lshr] = ACTIONS(389),
    [anon_sym_ashr] = ACTIONS(389),
    [anon_sym_fmul] = ACTIONS(389),
    [anon_sym_fdiv] = ACTIONS(389),
    [anon_sym_frem] = ACTIONS(389),
    [anon_sym_xchg] = ACTIONS(389),
    [anon_sym_add] = ACTIONS(389),
    [anon_sym_sub] = ACTIONS(389),
    [anon_sym_and] = ACTIONS(389),
    [anon_sym_nand] = ACTIONS(389),
    [anon_sym_or] = ACTIONS(389),
    [anon_sym_xor] = ACTIONS(389),
    [anon_sym_max] = ACTIONS(389),
    [anon_sym_min] = ACTIONS(389),
    [anon_sym_umax] = ACTIONS(389),
    [anon_sym_umin] = ACTIONS(389),
    [anon_sym_fadd] = ACTIONS(389),
    [anon_sym_fsub] = ACTIONS(389),
    [anon_sym_bitcast] = ACTIONS(389),
    [anon_sym_trunc] = ACTIONS(389),
    [anon_sym_zext] = ACTIONS(389),
    [anon_sym_sext] = ACTIONS(389),
    [anon_sym_fptrunc] = ACTIONS(389),
    [anon_sym_fpext] = ACTIONS(389),
    [anon_sym_addrspacecast] = ACTIONS(389),
    [anon_sym_uitofp] = ACTIONS(389),
    [anon_sym_sitofp] = ACTIONS(389),
    [anon_sym_fptoui] = ACTIONS(389),
    [anon_sym_fptosi] = ACTIONS(389),
    [anon_sym_inttoptr] = ACTIONS(389),
    [anon_sym_ptrtoint] = ACTIONS(389),
    [anon_sym_uselistorder] = ACTIONS(389),
  },
  [228] = {
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(901),
    [sym_local_var] = ACTIONS(901),
    [sym_label] = ACTIONS(901),
    [sym_string] = ACTIONS(903),
    [anon_sym_RBRACE] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(901),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_align] = ACTIONS(903),
    [anon_sym_section] = ACTIONS(903),
    [anon_sym_partition] = ACTIONS(903),
    [anon_sym_comdat] = ACTIONS(903),
    [anon_sym_gc] = ACTIONS(903),
    [anon_sym_prefix] = ACTIONS(903),
    [anon_sym_prologue] = ACTIONS(903),
    [anon_sym_personality] = ACTIONS(903),
    [anon_sym_alignstack] = ACTIONS(903),
    [anon_sym_allocsize] = ACTIONS(903),
    [anon_sym_alwaysinline] = ACTIONS(903),
    [anon_sym_builtin] = ACTIONS(903),
    [anon_sym_cold] = ACTIONS(903),
    [anon_sym_convergent] = ACTIONS(903),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(903),
    [anon_sym_hot] = ACTIONS(903),
    [anon_sym_inaccessiblememonly] = ACTIONS(903),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(903),
    [anon_sym_inlinehint] = ACTIONS(903),
    [anon_sym_jumptable] = ACTIONS(903),
    [anon_sym_minsize] = ACTIONS(903),
    [anon_sym_naked] = ACTIONS(903),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(903),
    [anon_sym_nobuiltin] = ACTIONS(903),
    [anon_sym_noduplicate] = ACTIONS(903),
    [anon_sym_nofree] = ACTIONS(903),
    [anon_sym_noimplicitfloat] = ACTIONS(903),
    [anon_sym_noinline] = ACTIONS(903),
    [anon_sym_nomerge] = ACTIONS(903),
    [anon_sym_nonlazybind] = ACTIONS(903),
    [anon_sym_noprofile] = ACTIONS(903),
    [anon_sym_noredzone] = ACTIONS(903),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(903),
    [anon_sym_noreturn] = ACTIONS(903),
    [anon_sym_norecurse] = ACTIONS(903),
    [anon_sym_willreturn] = ACTIONS(903),
    [anon_sym_nosync] = ACTIONS(903),
    [anon_sym_nounwind] = ACTIONS(903),
    [anon_sym_nocallback] = ACTIONS(903),
    [anon_sym_nosanitize_coverage] = ACTIONS(903),
    [anon_sym_null_pointer_is_valid] = ACTIONS(903),
    [anon_sym_optforfuzzing] = ACTIONS(903),
    [anon_sym_optnone] = ACTIONS(903),
    [anon_sym_optsize] = ACTIONS(903),
    [anon_sym_readnone] = ACTIONS(903),
    [anon_sym_readonly] = ACTIONS(903),
    [anon_sym_writeonly] = ACTIONS(903),
    [anon_sym_argmemonly] = ACTIONS(903),
    [anon_sym_returns_twice] = ACTIONS(903),
    [anon_sym_safestack] = ACTIONS(903),
    [anon_sym_sanitize_address] = ACTIONS(903),
    [anon_sym_sanitize_memory] = ACTIONS(903),
    [anon_sym_sanitize_thread] = ACTIONS(903),
    [anon_sym_sanitize_hwaddress] = ACTIONS(903),
    [anon_sym_sanitize_memtag] = ACTIONS(903),
    [anon_sym_speculative_load_hardening] = ACTIONS(903),
    [anon_sym_speculatable] = ACTIONS(903),
    [anon_sym_ssp] = ACTIONS(903),
    [anon_sym_sspstrong] = ACTIONS(903),
    [anon_sym_sspreq] = ACTIONS(903),
    [anon_sym_strictfp] = ACTIONS(903),
    [anon_sym_nocf_check] = ACTIONS(903),
    [anon_sym_shadowcallstack] = ACTIONS(903),
    [anon_sym_mustprogress] = ACTIONS(903),
    [anon_sym_vscale_range] = ACTIONS(903),
    [anon_sym_preallocated] = ACTIONS(903),
    [anon_sym_zeroext] = ACTIONS(903),
    [anon_sym_signext] = ACTIONS(903),
    [anon_sym_inreg] = ACTIONS(903),
    [anon_sym_byval] = ACTIONS(903),
    [anon_sym_byref] = ACTIONS(903),
    [anon_sym_inalloca] = ACTIONS(903),
    [anon_sym_sret] = ACTIONS(903),
    [anon_sym_elementtype] = ACTIONS(903),
    [anon_sym_noalias] = ACTIONS(903),
    [anon_sym_nocapture] = ACTIONS(903),
    [anon_sym_nest] = ACTIONS(903),
    [anon_sym_returned] = ACTIONS(903),
    [anon_sym_nonnull] = ACTIONS(903),
    [anon_sym_dereferenceable] = ACTIONS(903),
    [anon_sym_dereferenceable_or_null] = ACTIONS(903),
    [anon_sym_swiftself] = ACTIONS(903),
    [anon_sym_swiftasync] = ACTIONS(903),
    [anon_sym_swifterror] = ACTIONS(903),
    [anon_sym_immarg] = ACTIONS(903),
    [anon_sym_noundef] = ACTIONS(903),
    [anon_sym_uwtable] = ACTIONS(903),
    [anon_sym_memory] = ACTIONS(903),
    [anon_sym_unreachable] = ACTIONS(903),
    [anon_sym_ret] = ACTIONS(903),
    [anon_sym_br] = ACTIONS(903),
    [anon_sym_resume] = ACTIONS(903),
    [anon_sym_freeze] = ACTIONS(903),
    [anon_sym_indirectbr] = ACTIONS(903),
    [anon_sym_extractelement] = ACTIONS(903),
    [anon_sym_insertelement] = ACTIONS(903),
    [anon_sym_select] = ACTIONS(903),
    [anon_sym_shufflevector] = ACTIONS(903),
    [anon_sym_fneg] = ACTIONS(903),
    [anon_sym_switch] = ACTIONS(903),
    [anon_sym_invoke] = ACTIONS(903),
    [anon_sym_cleanupret] = ACTIONS(903),
    [anon_sym_catchret] = ACTIONS(903),
    [anon_sym_catchswitch] = ACTIONS(903),
    [anon_sym_catchpad] = ACTIONS(903),
    [anon_sym_cleanuppad] = ACTIONS(903),
    [anon_sym_callbr] = ACTIONS(903),
    [anon_sym_icmp] = ACTIONS(903),
    [anon_sym_fcmp] = ACTIONS(903),
    [anon_sym_va_arg] = ACTIONS(903),
    [anon_sym_phi] = ACTIONS(903),
    [anon_sym_landingpad] = ACTIONS(903),
    [anon_sym_tail] = ACTIONS(903),
    [anon_sym_musttail] = ACTIONS(903),
    [anon_sym_notail] = ACTIONS(903),
    [anon_sym_call] = ACTIONS(903),
    [anon_sym_alloca] = ACTIONS(903),
    [anon_sym_load] = ACTIONS(903),
    [anon_sym_store] = ACTIONS(903),
    [anon_sym_cmpxchg] = ACTIONS(903),
    [anon_sym_atomicrmw] = ACTIONS(903),
    [anon_sym_fence] = ACTIONS(903),
    [anon_sym_getelementptr] = ACTIONS(903),
    [anon_sym_extractvalue] = ACTIONS(903),
    [anon_sym_insertvalue] = ACTIONS(903),
    [anon_sym_mul] = ACTIONS(903),
    [anon_sym_urem] = ACTIONS(903),
    [anon_sym_srem] = ACTIONS(903),
    [anon_sym_shl] = ACTIONS(903),
    [anon_sym_udiv] = ACTIONS(903),
    [anon_sym_sdiv] = ACTIONS(903),
    [anon_sym_lshr] = ACTIONS(903),
    [anon_sym_ashr] = ACTIONS(903),
    [anon_sym_fmul] = ACTIONS(903),
    [anon_sym_fdiv] = ACTIONS(903),
    [anon_sym_frem] = ACTIONS(903),
    [anon_sym_xchg] = ACTIONS(903),
    [anon_sym_add] = ACTIONS(903),
    [anon_sym_sub] = ACTIONS(903),
    [anon_sym_and] = ACTIONS(903),
    [anon_sym_nand] = ACTIONS(903),
    [anon_sym_or] = ACTIONS(903),
    [anon_sym_xor] = ACTIONS(903),
    [anon_sym_max] = ACTIONS(903),
    [anon_sym_min] = ACTIONS(903),
    [anon_sym_umax] = ACTIONS(903),
    [anon_sym_umin] = ACTIONS(903),
    [anon_sym_fadd] = ACTIONS(903),
    [anon_sym_fsub] = ACTIONS(903),
    [anon_sym_bitcast] = ACTIONS(903),
    [anon_sym_trunc] = ACTIONS(903),
    [anon_sym_zext] = ACTIONS(903),
    [anon_sym_sext] = ACTIONS(903),
    [anon_sym_fptrunc] = ACTIONS(903),
    [anon_sym_fpext] = ACTIONS(903),
    [anon_sym_addrspacecast] = ACTIONS(903),
    [anon_sym_uitofp] = ACTIONS(903),
    [anon_sym_sitofp] = ACTIONS(903),
    [anon_sym_fptoui] = ACTIONS(903),
    [anon_sym_fptosi] = ACTIONS(903),
    [anon_sym_inttoptr] = ACTIONS(903),
    [anon_sym_ptrtoint] = ACTIONS(903),
    [anon_sym_uselistorder] = ACTIONS(903),
  },
  [229] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(847),
    [sym_local_var] = ACTIONS(847),
    [sym_string] = ACTIONS(847),
    [aux_sym_number_token1] = ACTIONS(849),
    [aux_sym_number_token2] = ACTIONS(847),
    [sym_float] = ACTIONS(847),
    [sym_cstring] = ACTIONS(847),
    [anon_sym_no_cfi] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_internal] = ACTIONS(847),
    [anon_sym_weak] = ACTIONS(849),
    [anon_sym_weak_odr] = ACTIONS(847),
    [anon_sym_linkonce] = ACTIONS(849),
    [anon_sym_linkonce_odr] = ACTIONS(847),
    [anon_sym_available_externally] = ACTIONS(847),
    [anon_sym_appending] = ACTIONS(847),
    [anon_sym_common] = ACTIONS(847),
    [anon_sym_extern_weak] = ACTIONS(847),
    [anon_sym_external] = ACTIONS(847),
    [anon_sym_dso_local] = ACTIONS(849),
    [anon_sym_dso_local_equivalent] = ACTIONS(847),
    [anon_sym_dso_preemptable] = ACTIONS(847),
    [anon_sym_default] = ACTIONS(847),
    [anon_sym_hidden] = ACTIONS(847),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_dllimport] = ACTIONS(847),
    [anon_sym_dllexport] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(847),
    [anon_sym_LT_LBRACE] = ACTIONS(847),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(847),
    [anon_sym_LPAREN] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(847),
    [anon_sym_align] = ACTIONS(849),
    [anon_sym_alignstack] = ACTIONS(847),
    [anon_sym_allocsize] = ACTIONS(847),
    [anon_sym_alwaysinline] = ACTIONS(847),
    [anon_sym_builtin] = ACTIONS(847),
    [anon_sym_cold] = ACTIONS(847),
    [anon_sym_convergent] = ACTIONS(847),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(847),
    [anon_sym_hot] = ACTIONS(847),
    [anon_sym_inaccessiblememonly] = ACTIONS(847),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(847),
    [anon_sym_inlinehint] = ACTIONS(847),
    [anon_sym_jumptable] = ACTIONS(847),
    [anon_sym_minsize] = ACTIONS(847),
    [anon_sym_naked] = ACTIONS(847),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(847),
    [anon_sym_nobuiltin] = ACTIONS(847),
    [anon_sym_noduplicate] = ACTIONS(847),
    [anon_sym_nofree] = ACTIONS(847),
    [anon_sym_noimplicitfloat] = ACTIONS(847),
    [anon_sym_noinline] = ACTIONS(847),
    [anon_sym_nomerge] = ACTIONS(847),
    [anon_sym_nonlazybind] = ACTIONS(847),
    [anon_sym_noprofile] = ACTIONS(847),
    [anon_sym_noredzone] = ACTIONS(847),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(847),
    [anon_sym_noreturn] = ACTIONS(847),
    [anon_sym_norecurse] = ACTIONS(847),
    [anon_sym_willreturn] = ACTIONS(847),
    [anon_sym_nosync] = ACTIONS(847),
    [anon_sym_nounwind] = ACTIONS(847),
    [anon_sym_nocallback] = ACTIONS(847),
    [anon_sym_nosanitize_coverage] = ACTIONS(847),
    [anon_sym_null_pointer_is_valid] = ACTIONS(847),
    [anon_sym_optforfuzzing] = ACTIONS(847),
    [anon_sym_optnone] = ACTIONS(847),
    [anon_sym_optsize] = ACTIONS(847),
    [anon_sym_readnone] = ACTIONS(847),
    [anon_sym_readonly] = ACTIONS(847),
    [anon_sym_writeonly] = ACTIONS(847),
    [anon_sym_argmemonly] = ACTIONS(847),
    [anon_sym_returns_twice] = ACTIONS(847),
    [anon_sym_safestack] = ACTIONS(847),
    [anon_sym_sanitize_address] = ACTIONS(847),
    [anon_sym_sanitize_memory] = ACTIONS(847),
    [anon_sym_sanitize_thread] = ACTIONS(847),
    [anon_sym_sanitize_hwaddress] = ACTIONS(847),
    [anon_sym_sanitize_memtag] = ACTIONS(847),
    [anon_sym_speculative_load_hardening] = ACTIONS(847),
    [anon_sym_speculatable] = ACTIONS(847),
    [anon_sym_ssp] = ACTIONS(849),
    [anon_sym_sspstrong] = ACTIONS(847),
    [anon_sym_sspreq] = ACTIONS(847),
    [anon_sym_strictfp] = ACTIONS(847),
    [anon_sym_nocf_check] = ACTIONS(847),
    [anon_sym_shadowcallstack] = ACTIONS(847),
    [anon_sym_mustprogress] = ACTIONS(847),
    [anon_sym_vscale_range] = ACTIONS(847),
    [anon_sym_preallocated] = ACTIONS(847),
    [anon_sym_zeroext] = ACTIONS(847),
    [anon_sym_signext] = ACTIONS(847),
    [anon_sym_inreg] = ACTIONS(847),
    [anon_sym_byval] = ACTIONS(847),
    [anon_sym_byref] = ACTIONS(847),
    [anon_sym_inalloca] = ACTIONS(847),
    [anon_sym_sret] = ACTIONS(847),
    [anon_sym_elementtype] = ACTIONS(847),
    [anon_sym_noalias] = ACTIONS(847),
    [anon_sym_nocapture] = ACTIONS(847),
    [anon_sym_nest] = ACTIONS(847),
    [anon_sym_returned] = ACTIONS(847),
    [anon_sym_nonnull] = ACTIONS(847),
    [anon_sym_dereferenceable] = ACTIONS(849),
    [anon_sym_dereferenceable_or_null] = ACTIONS(847),
    [anon_sym_swiftself] = ACTIONS(847),
    [anon_sym_swiftasync] = ACTIONS(847),
    [anon_sym_swifterror] = ACTIONS(847),
    [anon_sym_immarg] = ACTIONS(847),
    [anon_sym_noundef] = ACTIONS(847),
    [anon_sym_uwtable] = ACTIONS(847),
    [anon_sym_memory] = ACTIONS(847),
    [anon_sym_none] = ACTIONS(847),
    [anon_sym_extractelement] = ACTIONS(847),
    [anon_sym_insertelement] = ACTIONS(847),
    [anon_sym_select] = ACTIONS(847),
    [anon_sym_shufflevector] = ACTIONS(847),
    [anon_sym_fneg] = ACTIONS(847),
    [anon_sym_icmp] = ACTIONS(847),
    [anon_sym_fcmp] = ACTIONS(847),
    [anon_sym_getelementptr] = ACTIONS(847),
    [anon_sym_extractvalue] = ACTIONS(847),
    [anon_sym_insertvalue] = ACTIONS(847),
    [anon_sym_true] = ACTIONS(847),
    [anon_sym_false] = ACTIONS(847),
    [anon_sym_null] = ACTIONS(849),
    [anon_sym_undef] = ACTIONS(847),
    [anon_sym_poison] = ACTIONS(847),
    [anon_sym_zeroinitializer] = ACTIONS(847),
    [anon_sym_blockaddress] = ACTIONS(847),
    [anon_sym_mul] = ACTIONS(847),
    [anon_sym_urem] = ACTIONS(847),
    [anon_sym_srem] = ACTIONS(847),
    [anon_sym_shl] = ACTIONS(847),
    [anon_sym_udiv] = ACTIONS(847),
    [anon_sym_sdiv] = ACTIONS(847),
    [anon_sym_lshr] = ACTIONS(847),
    [anon_sym_ashr] = ACTIONS(847),
    [anon_sym_fmul] = ACTIONS(847),
    [anon_sym_fdiv] = ACTIONS(847),
    [anon_sym_frem] = ACTIONS(847),
    [anon_sym_xchg] = ACTIONS(847),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(847),
    [anon_sym_and] = ACTIONS(847),
    [anon_sym_nand] = ACTIONS(847),
    [anon_sym_or] = ACTIONS(847),
    [anon_sym_xor] = ACTIONS(847),
    [anon_sym_max] = ACTIONS(847),
    [anon_sym_min] = ACTIONS(849),
    [anon_sym_umax] = ACTIONS(847),
    [anon_sym_umin] = ACTIONS(847),
    [anon_sym_fadd] = ACTIONS(847),
    [anon_sym_fsub] = ACTIONS(847),
    [anon_sym_bitcast] = ACTIONS(847),
    [anon_sym_trunc] = ACTIONS(847),
    [anon_sym_zext] = ACTIONS(847),
    [anon_sym_sext] = ACTIONS(847),
    [anon_sym_fptrunc] = ACTIONS(847),
    [anon_sym_fpext] = ACTIONS(847),
    [anon_sym_addrspacecast] = ACTIONS(847),
    [anon_sym_uitofp] = ACTIONS(847),
    [anon_sym_sitofp] = ACTIONS(847),
    [anon_sym_fptoui] = ACTIONS(847),
    [anon_sym_fptosi] = ACTIONS(847),
    [anon_sym_inttoptr] = ACTIONS(847),
    [anon_sym_ptrtoint] = ACTIONS(847),
  },
  [230] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(835),
    [sym_local_var] = ACTIONS(835),
    [sym_string] = ACTIONS(835),
    [aux_sym_number_token1] = ACTIONS(837),
    [aux_sym_number_token2] = ACTIONS(835),
    [sym_float] = ACTIONS(835),
    [sym_cstring] = ACTIONS(835),
    [anon_sym_no_cfi] = ACTIONS(835),
    [anon_sym_private] = ACTIONS(835),
    [anon_sym_internal] = ACTIONS(835),
    [anon_sym_weak] = ACTIONS(837),
    [anon_sym_weak_odr] = ACTIONS(835),
    [anon_sym_linkonce] = ACTIONS(837),
    [anon_sym_linkonce_odr] = ACTIONS(835),
    [anon_sym_available_externally] = ACTIONS(835),
    [anon_sym_appending] = ACTIONS(835),
    [anon_sym_common] = ACTIONS(835),
    [anon_sym_extern_weak] = ACTIONS(835),
    [anon_sym_external] = ACTIONS(835),
    [anon_sym_dso_local] = ACTIONS(837),
    [anon_sym_dso_local_equivalent] = ACTIONS(835),
    [anon_sym_dso_preemptable] = ACTIONS(835),
    [anon_sym_default] = ACTIONS(835),
    [anon_sym_hidden] = ACTIONS(835),
    [anon_sym_protected] = ACTIONS(835),
    [anon_sym_dllimport] = ACTIONS(835),
    [anon_sym_dllexport] = ACTIONS(835),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_LT_LBRACE] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(835),
    [anon_sym_align] = ACTIONS(837),
    [anon_sym_alignstack] = ACTIONS(835),
    [anon_sym_allocsize] = ACTIONS(835),
    [anon_sym_alwaysinline] = ACTIONS(835),
    [anon_sym_builtin] = ACTIONS(835),
    [anon_sym_cold] = ACTIONS(835),
    [anon_sym_convergent] = ACTIONS(835),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(835),
    [anon_sym_hot] = ACTIONS(835),
    [anon_sym_inaccessiblememonly] = ACTIONS(835),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(835),
    [anon_sym_inlinehint] = ACTIONS(835),
    [anon_sym_jumptable] = ACTIONS(835),
    [anon_sym_minsize] = ACTIONS(835),
    [anon_sym_naked] = ACTIONS(835),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(835),
    [anon_sym_nobuiltin] = ACTIONS(835),
    [anon_sym_noduplicate] = ACTIONS(835),
    [anon_sym_nofree] = ACTIONS(835),
    [anon_sym_noimplicitfloat] = ACTIONS(835),
    [anon_sym_noinline] = ACTIONS(835),
    [anon_sym_nomerge] = ACTIONS(835),
    [anon_sym_nonlazybind] = ACTIONS(835),
    [anon_sym_noprofile] = ACTIONS(835),
    [anon_sym_noredzone] = ACTIONS(835),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(835),
    [anon_sym_noreturn] = ACTIONS(835),
    [anon_sym_norecurse] = ACTIONS(835),
    [anon_sym_willreturn] = ACTIONS(835),
    [anon_sym_nosync] = ACTIONS(835),
    [anon_sym_nounwind] = ACTIONS(835),
    [anon_sym_nocallback] = ACTIONS(835),
    [anon_sym_nosanitize_coverage] = ACTIONS(835),
    [anon_sym_null_pointer_is_valid] = ACTIONS(835),
    [anon_sym_optforfuzzing] = ACTIONS(835),
    [anon_sym_optnone] = ACTIONS(835),
    [anon_sym_optsize] = ACTIONS(835),
    [anon_sym_readnone] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_writeonly] = ACTIONS(835),
    [anon_sym_argmemonly] = ACTIONS(835),
    [anon_sym_returns_twice] = ACTIONS(835),
    [anon_sym_safestack] = ACTIONS(835),
    [anon_sym_sanitize_address] = ACTIONS(835),
    [anon_sym_sanitize_memory] = ACTIONS(835),
    [anon_sym_sanitize_thread] = ACTIONS(835),
    [anon_sym_sanitize_hwaddress] = ACTIONS(835),
    [anon_sym_sanitize_memtag] = ACTIONS(835),
    [anon_sym_speculative_load_hardening] = ACTIONS(835),
    [anon_sym_speculatable] = ACTIONS(835),
    [anon_sym_ssp] = ACTIONS(837),
    [anon_sym_sspstrong] = ACTIONS(835),
    [anon_sym_sspreq] = ACTIONS(835),
    [anon_sym_strictfp] = ACTIONS(835),
    [anon_sym_nocf_check] = ACTIONS(835),
    [anon_sym_shadowcallstack] = ACTIONS(835),
    [anon_sym_mustprogress] = ACTIONS(835),
    [anon_sym_vscale_range] = ACTIONS(835),
    [anon_sym_preallocated] = ACTIONS(835),
    [anon_sym_zeroext] = ACTIONS(835),
    [anon_sym_signext] = ACTIONS(835),
    [anon_sym_inreg] = ACTIONS(835),
    [anon_sym_byval] = ACTIONS(835),
    [anon_sym_byref] = ACTIONS(835),
    [anon_sym_inalloca] = ACTIONS(835),
    [anon_sym_sret] = ACTIONS(835),
    [anon_sym_elementtype] = ACTIONS(835),
    [anon_sym_noalias] = ACTIONS(835),
    [anon_sym_nocapture] = ACTIONS(835),
    [anon_sym_nest] = ACTIONS(835),
    [anon_sym_returned] = ACTIONS(835),
    [anon_sym_nonnull] = ACTIONS(835),
    [anon_sym_dereferenceable] = ACTIONS(837),
    [anon_sym_dereferenceable_or_null] = ACTIONS(835),
    [anon_sym_swiftself] = ACTIONS(835),
    [anon_sym_swiftasync] = ACTIONS(835),
    [anon_sym_swifterror] = ACTIONS(835),
    [anon_sym_immarg] = ACTIONS(835),
    [anon_sym_noundef] = ACTIONS(835),
    [anon_sym_uwtable] = ACTIONS(835),
    [anon_sym_memory] = ACTIONS(835),
    [anon_sym_none] = ACTIONS(835),
    [anon_sym_extractelement] = ACTIONS(835),
    [anon_sym_insertelement] = ACTIONS(835),
    [anon_sym_select] = ACTIONS(835),
    [anon_sym_shufflevector] = ACTIONS(835),
    [anon_sym_fneg] = ACTIONS(835),
    [anon_sym_icmp] = ACTIONS(835),
    [anon_sym_fcmp] = ACTIONS(835),
    [anon_sym_getelementptr] = ACTIONS(835),
    [anon_sym_extractvalue] = ACTIONS(835),
    [anon_sym_insertvalue] = ACTIONS(835),
    [anon_sym_true] = ACTIONS(835),
    [anon_sym_false] = ACTIONS(835),
    [anon_sym_null] = ACTIONS(837),
    [anon_sym_undef] = ACTIONS(835),
    [anon_sym_poison] = ACTIONS(835),
    [anon_sym_zeroinitializer] = ACTIONS(835),
    [anon_sym_blockaddress] = ACTIONS(835),
    [anon_sym_mul] = ACTIONS(835),
    [anon_sym_urem] = ACTIONS(835),
    [anon_sym_srem] = ACTIONS(835),
    [anon_sym_shl] = ACTIONS(835),
    [anon_sym_udiv] = ACTIONS(835),
    [anon_sym_sdiv] = ACTIONS(835),
    [anon_sym_lshr] = ACTIONS(835),
    [anon_sym_ashr] = ACTIONS(835),
    [anon_sym_fmul] = ACTIONS(835),
    [anon_sym_fdiv] = ACTIONS(835),
    [anon_sym_frem] = ACTIONS(835),
    [anon_sym_xchg] = ACTIONS(835),
    [anon_sym_add] = ACTIONS(837),
    [anon_sym_sub] = ACTIONS(835),
    [anon_sym_and] = ACTIONS(835),
    [anon_sym_nand] = ACTIONS(835),
    [anon_sym_or] = ACTIONS(835),
    [anon_sym_xor] = ACTIONS(835),
    [anon_sym_max] = ACTIONS(835),
    [anon_sym_min] = ACTIONS(837),
    [anon_sym_umax] = ACTIONS(835),
    [anon_sym_umin] = ACTIONS(835),
    [anon_sym_fadd] = ACTIONS(835),
    [anon_sym_fsub] = ACTIONS(835),
    [anon_sym_bitcast] = ACTIONS(835),
    [anon_sym_trunc] = ACTIONS(835),
    [anon_sym_zext] = ACTIONS(835),
    [anon_sym_sext] = ACTIONS(835),
    [anon_sym_fptrunc] = ACTIONS(835),
    [anon_sym_fpext] = ACTIONS(835),
    [anon_sym_addrspacecast] = ACTIONS(835),
    [anon_sym_uitofp] = ACTIONS(835),
    [anon_sym_sitofp] = ACTIONS(835),
    [anon_sym_fptoui] = ACTIONS(835),
    [anon_sym_fptosi] = ACTIONS(835),
    [anon_sym_inttoptr] = ACTIONS(835),
    [anon_sym_ptrtoint] = ACTIONS(835),
  },
  [231] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(905),
    [sym_local_var] = ACTIONS(905),
    [sym_string] = ACTIONS(905),
    [aux_sym_number_token1] = ACTIONS(907),
    [aux_sym_number_token2] = ACTIONS(905),
    [sym_float] = ACTIONS(905),
    [sym_cstring] = ACTIONS(905),
    [anon_sym_no_cfi] = ACTIONS(905),
    [anon_sym_private] = ACTIONS(905),
    [anon_sym_internal] = ACTIONS(905),
    [anon_sym_weak] = ACTIONS(907),
    [anon_sym_weak_odr] = ACTIONS(905),
    [anon_sym_linkonce] = ACTIONS(907),
    [anon_sym_linkonce_odr] = ACTIONS(905),
    [anon_sym_available_externally] = ACTIONS(905),
    [anon_sym_appending] = ACTIONS(905),
    [anon_sym_common] = ACTIONS(905),
    [anon_sym_extern_weak] = ACTIONS(905),
    [anon_sym_external] = ACTIONS(905),
    [anon_sym_dso_local] = ACTIONS(907),
    [anon_sym_dso_local_equivalent] = ACTIONS(905),
    [anon_sym_dso_preemptable] = ACTIONS(905),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_hidden] = ACTIONS(905),
    [anon_sym_protected] = ACTIONS(905),
    [anon_sym_dllimport] = ACTIONS(905),
    [anon_sym_dllexport] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_LT_LBRACE] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_align] = ACTIONS(907),
    [anon_sym_alignstack] = ACTIONS(905),
    [anon_sym_allocsize] = ACTIONS(905),
    [anon_sym_alwaysinline] = ACTIONS(905),
    [anon_sym_builtin] = ACTIONS(905),
    [anon_sym_cold] = ACTIONS(905),
    [anon_sym_convergent] = ACTIONS(905),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(905),
    [anon_sym_hot] = ACTIONS(905),
    [anon_sym_inaccessiblememonly] = ACTIONS(905),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(905),
    [anon_sym_inlinehint] = ACTIONS(905),
    [anon_sym_jumptable] = ACTIONS(905),
    [anon_sym_minsize] = ACTIONS(905),
    [anon_sym_naked] = ACTIONS(905),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(905),
    [anon_sym_nobuiltin] = ACTIONS(905),
    [anon_sym_noduplicate] = ACTIONS(905),
    [anon_sym_nofree] = ACTIONS(905),
    [anon_sym_noimplicitfloat] = ACTIONS(905),
    [anon_sym_noinline] = ACTIONS(905),
    [anon_sym_nomerge] = ACTIONS(905),
    [anon_sym_nonlazybind] = ACTIONS(905),
    [anon_sym_noprofile] = ACTIONS(905),
    [anon_sym_noredzone] = ACTIONS(905),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(905),
    [anon_sym_noreturn] = ACTIONS(905),
    [anon_sym_norecurse] = ACTIONS(905),
    [anon_sym_willreturn] = ACTIONS(905),
    [anon_sym_nosync] = ACTIONS(905),
    [anon_sym_nounwind] = ACTIONS(905),
    [anon_sym_nocallback] = ACTIONS(905),
    [anon_sym_nosanitize_coverage] = ACTIONS(905),
    [anon_sym_null_pointer_is_valid] = ACTIONS(905),
    [anon_sym_optforfuzzing] = ACTIONS(905),
    [anon_sym_optnone] = ACTIONS(905),
    [anon_sym_optsize] = ACTIONS(905),
    [anon_sym_readnone] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_writeonly] = ACTIONS(905),
    [anon_sym_argmemonly] = ACTIONS(905),
    [anon_sym_returns_twice] = ACTIONS(905),
    [anon_sym_safestack] = ACTIONS(905),
    [anon_sym_sanitize_address] = ACTIONS(905),
    [anon_sym_sanitize_memory] = ACTIONS(905),
    [anon_sym_sanitize_thread] = ACTIONS(905),
    [anon_sym_sanitize_hwaddress] = ACTIONS(905),
    [anon_sym_sanitize_memtag] = ACTIONS(905),
    [anon_sym_speculative_load_hardening] = ACTIONS(905),
    [anon_sym_speculatable] = ACTIONS(905),
    [anon_sym_ssp] = ACTIONS(907),
    [anon_sym_sspstrong] = ACTIONS(905),
    [anon_sym_sspreq] = ACTIONS(905),
    [anon_sym_strictfp] = ACTIONS(905),
    [anon_sym_nocf_check] = ACTIONS(905),
    [anon_sym_shadowcallstack] = ACTIONS(905),
    [anon_sym_mustprogress] = ACTIONS(905),
    [anon_sym_vscale_range] = ACTIONS(905),
    [anon_sym_preallocated] = ACTIONS(905),
    [anon_sym_zeroext] = ACTIONS(905),
    [anon_sym_signext] = ACTIONS(905),
    [anon_sym_inreg] = ACTIONS(905),
    [anon_sym_byval] = ACTIONS(905),
    [anon_sym_byref] = ACTIONS(905),
    [anon_sym_inalloca] = ACTIONS(905),
    [anon_sym_sret] = ACTIONS(905),
    [anon_sym_elementtype] = ACTIONS(905),
    [anon_sym_noalias] = ACTIONS(905),
    [anon_sym_nocapture] = ACTIONS(905),
    [anon_sym_nest] = ACTIONS(905),
    [anon_sym_returned] = ACTIONS(905),
    [anon_sym_nonnull] = ACTIONS(905),
    [anon_sym_dereferenceable] = ACTIONS(907),
    [anon_sym_dereferenceable_or_null] = ACTIONS(905),
    [anon_sym_swiftself] = ACTIONS(905),
    [anon_sym_swiftasync] = ACTIONS(905),
    [anon_sym_swifterror] = ACTIONS(905),
    [anon_sym_immarg] = ACTIONS(905),
    [anon_sym_noundef] = ACTIONS(905),
    [anon_sym_uwtable] = ACTIONS(905),
    [anon_sym_memory] = ACTIONS(905),
    [anon_sym_none] = ACTIONS(905),
    [anon_sym_extractelement] = ACTIONS(905),
    [anon_sym_insertelement] = ACTIONS(905),
    [anon_sym_select] = ACTIONS(905),
    [anon_sym_shufflevector] = ACTIONS(905),
    [anon_sym_fneg] = ACTIONS(905),
    [anon_sym_icmp] = ACTIONS(905),
    [anon_sym_fcmp] = ACTIONS(905),
    [anon_sym_getelementptr] = ACTIONS(905),
    [anon_sym_extractvalue] = ACTIONS(905),
    [anon_sym_insertvalue] = ACTIONS(905),
    [anon_sym_true] = ACTIONS(905),
    [anon_sym_false] = ACTIONS(905),
    [anon_sym_null] = ACTIONS(907),
    [anon_sym_undef] = ACTIONS(905),
    [anon_sym_poison] = ACTIONS(905),
    [anon_sym_zeroinitializer] = ACTIONS(905),
    [anon_sym_blockaddress] = ACTIONS(905),
    [anon_sym_mul] = ACTIONS(905),
    [anon_sym_urem] = ACTIONS(905),
    [anon_sym_srem] = ACTIONS(905),
    [anon_sym_shl] = ACTIONS(905),
    [anon_sym_udiv] = ACTIONS(905),
    [anon_sym_sdiv] = ACTIONS(905),
    [anon_sym_lshr] = ACTIONS(905),
    [anon_sym_ashr] = ACTIONS(905),
    [anon_sym_fmul] = ACTIONS(905),
    [anon_sym_fdiv] = ACTIONS(905),
    [anon_sym_frem] = ACTIONS(905),
    [anon_sym_xchg] = ACTIONS(905),
    [anon_sym_add] = ACTIONS(907),
    [anon_sym_sub] = ACTIONS(905),
    [anon_sym_and] = ACTIONS(905),
    [anon_sym_nand] = ACTIONS(905),
    [anon_sym_or] = ACTIONS(905),
    [anon_sym_xor] = ACTIONS(905),
    [anon_sym_max] = ACTIONS(905),
    [anon_sym_min] = ACTIONS(907),
    [anon_sym_umax] = ACTIONS(905),
    [anon_sym_umin] = ACTIONS(905),
    [anon_sym_fadd] = ACTIONS(905),
    [anon_sym_fsub] = ACTIONS(905),
    [anon_sym_bitcast] = ACTIONS(905),
    [anon_sym_trunc] = ACTIONS(905),
    [anon_sym_zext] = ACTIONS(905),
    [anon_sym_sext] = ACTIONS(905),
    [anon_sym_fptrunc] = ACTIONS(905),
    [anon_sym_fpext] = ACTIONS(905),
    [anon_sym_addrspacecast] = ACTIONS(905),
    [anon_sym_uitofp] = ACTIONS(905),
    [anon_sym_sitofp] = ACTIONS(905),
    [anon_sym_fptoui] = ACTIONS(905),
    [anon_sym_fptosi] = ACTIONS(905),
    [anon_sym_inttoptr] = ACTIONS(905),
    [anon_sym_ptrtoint] = ACTIONS(905),
  },
  [232] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(909),
    [sym_local_var] = ACTIONS(909),
    [sym_string] = ACTIONS(909),
    [aux_sym_number_token1] = ACTIONS(911),
    [aux_sym_number_token2] = ACTIONS(909),
    [sym_float] = ACTIONS(909),
    [sym_cstring] = ACTIONS(909),
    [anon_sym_no_cfi] = ACTIONS(909),
    [anon_sym_private] = ACTIONS(909),
    [anon_sym_internal] = ACTIONS(909),
    [anon_sym_weak] = ACTIONS(911),
    [anon_sym_weak_odr] = ACTIONS(909),
    [anon_sym_linkonce] = ACTIONS(911),
    [anon_sym_linkonce_odr] = ACTIONS(909),
    [anon_sym_available_externally] = ACTIONS(909),
    [anon_sym_appending] = ACTIONS(909),
    [anon_sym_common] = ACTIONS(909),
    [anon_sym_extern_weak] = ACTIONS(909),
    [anon_sym_external] = ACTIONS(909),
    [anon_sym_dso_local] = ACTIONS(911),
    [anon_sym_dso_local_equivalent] = ACTIONS(909),
    [anon_sym_dso_preemptable] = ACTIONS(909),
    [anon_sym_default] = ACTIONS(909),
    [anon_sym_hidden] = ACTIONS(909),
    [anon_sym_protected] = ACTIONS(909),
    [anon_sym_dllimport] = ACTIONS(909),
    [anon_sym_dllexport] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_LT_LBRACE] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_align] = ACTIONS(911),
    [anon_sym_alignstack] = ACTIONS(909),
    [anon_sym_allocsize] = ACTIONS(909),
    [anon_sym_alwaysinline] = ACTIONS(909),
    [anon_sym_builtin] = ACTIONS(909),
    [anon_sym_cold] = ACTIONS(909),
    [anon_sym_convergent] = ACTIONS(909),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(909),
    [anon_sym_hot] = ACTIONS(909),
    [anon_sym_inaccessiblememonly] = ACTIONS(909),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(909),
    [anon_sym_inlinehint] = ACTIONS(909),
    [anon_sym_jumptable] = ACTIONS(909),
    [anon_sym_minsize] = ACTIONS(909),
    [anon_sym_naked] = ACTIONS(909),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(909),
    [anon_sym_nobuiltin] = ACTIONS(909),
    [anon_sym_noduplicate] = ACTIONS(909),
    [anon_sym_nofree] = ACTIONS(909),
    [anon_sym_noimplicitfloat] = ACTIONS(909),
    [anon_sym_noinline] = ACTIONS(909),
    [anon_sym_nomerge] = ACTIONS(909),
    [anon_sym_nonlazybind] = ACTIONS(909),
    [anon_sym_noprofile] = ACTIONS(909),
    [anon_sym_noredzone] = ACTIONS(909),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(909),
    [anon_sym_noreturn] = ACTIONS(909),
    [anon_sym_norecurse] = ACTIONS(909),
    [anon_sym_willreturn] = ACTIONS(909),
    [anon_sym_nosync] = ACTIONS(909),
    [anon_sym_nounwind] = ACTIONS(909),
    [anon_sym_nocallback] = ACTIONS(909),
    [anon_sym_nosanitize_coverage] = ACTIONS(909),
    [anon_sym_null_pointer_is_valid] = ACTIONS(909),
    [anon_sym_optforfuzzing] = ACTIONS(909),
    [anon_sym_optnone] = ACTIONS(909),
    [anon_sym_optsize] = ACTIONS(909),
    [anon_sym_readnone] = ACTIONS(909),
    [anon_sym_readonly] = ACTIONS(909),
    [anon_sym_writeonly] = ACTIONS(909),
    [anon_sym_argmemonly] = ACTIONS(909),
    [anon_sym_returns_twice] = ACTIONS(909),
    [anon_sym_safestack] = ACTIONS(909),
    [anon_sym_sanitize_address] = ACTIONS(909),
    [anon_sym_sanitize_memory] = ACTIONS(909),
    [anon_sym_sanitize_thread] = ACTIONS(909),
    [anon_sym_sanitize_hwaddress] = ACTIONS(909),
    [anon_sym_sanitize_memtag] = ACTIONS(909),
    [anon_sym_speculative_load_hardening] = ACTIONS(909),
    [anon_sym_speculatable] = ACTIONS(909),
    [anon_sym_ssp] = ACTIONS(911),
    [anon_sym_sspstrong] = ACTIONS(909),
    [anon_sym_sspreq] = ACTIONS(909),
    [anon_sym_strictfp] = ACTIONS(909),
    [anon_sym_nocf_check] = ACTIONS(909),
    [anon_sym_shadowcallstack] = ACTIONS(909),
    [anon_sym_mustprogress] = ACTIONS(909),
    [anon_sym_vscale_range] = ACTIONS(909),
    [anon_sym_preallocated] = ACTIONS(909),
    [anon_sym_zeroext] = ACTIONS(909),
    [anon_sym_signext] = ACTIONS(909),
    [anon_sym_inreg] = ACTIONS(909),
    [anon_sym_byval] = ACTIONS(909),
    [anon_sym_byref] = ACTIONS(909),
    [anon_sym_inalloca] = ACTIONS(909),
    [anon_sym_sret] = ACTIONS(909),
    [anon_sym_elementtype] = ACTIONS(909),
    [anon_sym_noalias] = ACTIONS(909),
    [anon_sym_nocapture] = ACTIONS(909),
    [anon_sym_nest] = ACTIONS(909),
    [anon_sym_returned] = ACTIONS(909),
    [anon_sym_nonnull] = ACTIONS(909),
    [anon_sym_dereferenceable] = ACTIONS(911),
    [anon_sym_dereferenceable_or_null] = ACTIONS(909),
    [anon_sym_swiftself] = ACTIONS(909),
    [anon_sym_swiftasync] = ACTIONS(909),
    [anon_sym_swifterror] = ACTIONS(909),
    [anon_sym_immarg] = ACTIONS(909),
    [anon_sym_noundef] = ACTIONS(909),
    [anon_sym_uwtable] = ACTIONS(909),
    [anon_sym_memory] = ACTIONS(909),
    [anon_sym_none] = ACTIONS(909),
    [anon_sym_extractelement] = ACTIONS(909),
    [anon_sym_insertelement] = ACTIONS(909),
    [anon_sym_select] = ACTIONS(909),
    [anon_sym_shufflevector] = ACTIONS(909),
    [anon_sym_fneg] = ACTIONS(909),
    [anon_sym_icmp] = ACTIONS(909),
    [anon_sym_fcmp] = ACTIONS(909),
    [anon_sym_getelementptr] = ACTIONS(909),
    [anon_sym_extractvalue] = ACTIONS(909),
    [anon_sym_insertvalue] = ACTIONS(909),
    [anon_sym_true] = ACTIONS(909),
    [anon_sym_false] = ACTIONS(909),
    [anon_sym_null] = ACTIONS(911),
    [anon_sym_undef] = ACTIONS(909),
    [anon_sym_poison] = ACTIONS(909),
    [anon_sym_zeroinitializer] = ACTIONS(909),
    [anon_sym_blockaddress] = ACTIONS(909),
    [anon_sym_mul] = ACTIONS(909),
    [anon_sym_urem] = ACTIONS(909),
    [anon_sym_srem] = ACTIONS(909),
    [anon_sym_shl] = ACTIONS(909),
    [anon_sym_udiv] = ACTIONS(909),
    [anon_sym_sdiv] = ACTIONS(909),
    [anon_sym_lshr] = ACTIONS(909),
    [anon_sym_ashr] = ACTIONS(909),
    [anon_sym_fmul] = ACTIONS(909),
    [anon_sym_fdiv] = ACTIONS(909),
    [anon_sym_frem] = ACTIONS(909),
    [anon_sym_xchg] = ACTIONS(909),
    [anon_sym_add] = ACTIONS(911),
    [anon_sym_sub] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(909),
    [anon_sym_nand] = ACTIONS(909),
    [anon_sym_or] = ACTIONS(909),
    [anon_sym_xor] = ACTIONS(909),
    [anon_sym_max] = ACTIONS(909),
    [anon_sym_min] = ACTIONS(911),
    [anon_sym_umax] = ACTIONS(909),
    [anon_sym_umin] = ACTIONS(909),
    [anon_sym_fadd] = ACTIONS(909),
    [anon_sym_fsub] = ACTIONS(909),
    [anon_sym_bitcast] = ACTIONS(909),
    [anon_sym_trunc] = ACTIONS(909),
    [anon_sym_zext] = ACTIONS(909),
    [anon_sym_sext] = ACTIONS(909),
    [anon_sym_fptrunc] = ACTIONS(909),
    [anon_sym_fpext] = ACTIONS(909),
    [anon_sym_addrspacecast] = ACTIONS(909),
    [anon_sym_uitofp] = ACTIONS(909),
    [anon_sym_sitofp] = ACTIONS(909),
    [anon_sym_fptoui] = ACTIONS(909),
    [anon_sym_fptosi] = ACTIONS(909),
    [anon_sym_inttoptr] = ACTIONS(909),
    [anon_sym_ptrtoint] = ACTIONS(909),
  },
  [233] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(713),
    [sym_local_var] = ACTIONS(713),
    [sym_string] = ACTIONS(713),
    [aux_sym_number_token1] = ACTIONS(715),
    [aux_sym_number_token2] = ACTIONS(713),
    [sym_float] = ACTIONS(713),
    [sym_cstring] = ACTIONS(713),
    [anon_sym_no_cfi] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_internal] = ACTIONS(713),
    [anon_sym_weak] = ACTIONS(715),
    [anon_sym_weak_odr] = ACTIONS(713),
    [anon_sym_linkonce] = ACTIONS(715),
    [anon_sym_linkonce_odr] = ACTIONS(713),
    [anon_sym_available_externally] = ACTIONS(713),
    [anon_sym_appending] = ACTIONS(713),
    [anon_sym_common] = ACTIONS(713),
    [anon_sym_extern_weak] = ACTIONS(713),
    [anon_sym_external] = ACTIONS(713),
    [anon_sym_dso_local] = ACTIONS(715),
    [anon_sym_dso_local_equivalent] = ACTIONS(713),
    [anon_sym_dso_preemptable] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(713),
    [anon_sym_hidden] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_dllimport] = ACTIONS(713),
    [anon_sym_dllexport] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(713),
    [anon_sym_LT_LBRACE] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(713),
    [anon_sym_align] = ACTIONS(715),
    [anon_sym_alignstack] = ACTIONS(713),
    [anon_sym_allocsize] = ACTIONS(713),
    [anon_sym_alwaysinline] = ACTIONS(713),
    [anon_sym_builtin] = ACTIONS(713),
    [anon_sym_cold] = ACTIONS(713),
    [anon_sym_convergent] = ACTIONS(713),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(713),
    [anon_sym_hot] = ACTIONS(713),
    [anon_sym_inaccessiblememonly] = ACTIONS(713),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(713),
    [anon_sym_inlinehint] = ACTIONS(713),
    [anon_sym_jumptable] = ACTIONS(713),
    [anon_sym_minsize] = ACTIONS(713),
    [anon_sym_naked] = ACTIONS(713),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(713),
    [anon_sym_nobuiltin] = ACTIONS(713),
    [anon_sym_noduplicate] = ACTIONS(713),
    [anon_sym_nofree] = ACTIONS(713),
    [anon_sym_noimplicitfloat] = ACTIONS(713),
    [anon_sym_noinline] = ACTIONS(713),
    [anon_sym_nomerge] = ACTIONS(713),
    [anon_sym_nonlazybind] = ACTIONS(713),
    [anon_sym_noprofile] = ACTIONS(713),
    [anon_sym_noredzone] = ACTIONS(713),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(713),
    [anon_sym_noreturn] = ACTIONS(713),
    [anon_sym_norecurse] = ACTIONS(713),
    [anon_sym_willreturn] = ACTIONS(713),
    [anon_sym_nosync] = ACTIONS(713),
    [anon_sym_nounwind] = ACTIONS(713),
    [anon_sym_nocallback] = ACTIONS(713),
    [anon_sym_nosanitize_coverage] = ACTIONS(713),
    [anon_sym_null_pointer_is_valid] = ACTIONS(713),
    [anon_sym_optforfuzzing] = ACTIONS(713),
    [anon_sym_optnone] = ACTIONS(713),
    [anon_sym_optsize] = ACTIONS(713),
    [anon_sym_readnone] = ACTIONS(713),
    [anon_sym_readonly] = ACTIONS(713),
    [anon_sym_writeonly] = ACTIONS(713),
    [anon_sym_argmemonly] = ACTIONS(713),
    [anon_sym_returns_twice] = ACTIONS(713),
    [anon_sym_safestack] = ACTIONS(713),
    [anon_sym_sanitize_address] = ACTIONS(713),
    [anon_sym_sanitize_memory] = ACTIONS(713),
    [anon_sym_sanitize_thread] = ACTIONS(713),
    [anon_sym_sanitize_hwaddress] = ACTIONS(713),
    [anon_sym_sanitize_memtag] = ACTIONS(713),
    [anon_sym_speculative_load_hardening] = ACTIONS(713),
    [anon_sym_speculatable] = ACTIONS(713),
    [anon_sym_ssp] = ACTIONS(715),
    [anon_sym_sspstrong] = ACTIONS(713),
    [anon_sym_sspreq] = ACTIONS(713),
    [anon_sym_strictfp] = ACTIONS(713),
    [anon_sym_nocf_check] = ACTIONS(713),
    [anon_sym_shadowcallstack] = ACTIONS(713),
    [anon_sym_mustprogress] = ACTIONS(713),
    [anon_sym_vscale_range] = ACTIONS(713),
    [anon_sym_preallocated] = ACTIONS(713),
    [anon_sym_zeroext] = ACTIONS(713),
    [anon_sym_signext] = ACTIONS(713),
    [anon_sym_inreg] = ACTIONS(713),
    [anon_sym_byval] = ACTIONS(713),
    [anon_sym_byref] = ACTIONS(713),
    [anon_sym_inalloca] = ACTIONS(713),
    [anon_sym_sret] = ACTIONS(713),
    [anon_sym_elementtype] = ACTIONS(713),
    [anon_sym_noalias] = ACTIONS(713),
    [anon_sym_nocapture] = ACTIONS(713),
    [anon_sym_nest] = ACTIONS(713),
    [anon_sym_returned] = ACTIONS(713),
    [anon_sym_nonnull] = ACTIONS(713),
    [anon_sym_dereferenceable] = ACTIONS(715),
    [anon_sym_dereferenceable_or_null] = ACTIONS(713),
    [anon_sym_swiftself] = ACTIONS(713),
    [anon_sym_swiftasync] = ACTIONS(713),
    [anon_sym_swifterror] = ACTIONS(713),
    [anon_sym_immarg] = ACTIONS(713),
    [anon_sym_noundef] = ACTIONS(713),
    [anon_sym_uwtable] = ACTIONS(713),
    [anon_sym_memory] = ACTIONS(713),
    [anon_sym_none] = ACTIONS(713),
    [anon_sym_extractelement] = ACTIONS(713),
    [anon_sym_insertelement] = ACTIONS(713),
    [anon_sym_select] = ACTIONS(713),
    [anon_sym_shufflevector] = ACTIONS(713),
    [anon_sym_fneg] = ACTIONS(713),
    [anon_sym_icmp] = ACTIONS(713),
    [anon_sym_fcmp] = ACTIONS(713),
    [anon_sym_getelementptr] = ACTIONS(713),
    [anon_sym_extractvalue] = ACTIONS(713),
    [anon_sym_insertvalue] = ACTIONS(713),
    [anon_sym_true] = ACTIONS(713),
    [anon_sym_false] = ACTIONS(713),
    [anon_sym_null] = ACTIONS(715),
    [anon_sym_undef] = ACTIONS(713),
    [anon_sym_poison] = ACTIONS(713),
    [anon_sym_zeroinitializer] = ACTIONS(713),
    [anon_sym_blockaddress] = ACTIONS(713),
    [anon_sym_mul] = ACTIONS(713),
    [anon_sym_urem] = ACTIONS(713),
    [anon_sym_srem] = ACTIONS(713),
    [anon_sym_shl] = ACTIONS(713),
    [anon_sym_udiv] = ACTIONS(713),
    [anon_sym_sdiv] = ACTIONS(713),
    [anon_sym_lshr] = ACTIONS(713),
    [anon_sym_ashr] = ACTIONS(713),
    [anon_sym_fmul] = ACTIONS(713),
    [anon_sym_fdiv] = ACTIONS(713),
    [anon_sym_frem] = ACTIONS(713),
    [anon_sym_xchg] = ACTIONS(713),
    [anon_sym_add] = ACTIONS(715),
    [anon_sym_sub] = ACTIONS(713),
    [anon_sym_and] = ACTIONS(713),
    [anon_sym_nand] = ACTIONS(713),
    [anon_sym_or] = ACTIONS(713),
    [anon_sym_xor] = ACTIONS(713),
    [anon_sym_max] = ACTIONS(713),
    [anon_sym_min] = ACTIONS(715),
    [anon_sym_umax] = ACTIONS(713),
    [anon_sym_umin] = ACTIONS(713),
    [anon_sym_fadd] = ACTIONS(713),
    [anon_sym_fsub] = ACTIONS(713),
    [anon_sym_bitcast] = ACTIONS(713),
    [anon_sym_trunc] = ACTIONS(713),
    [anon_sym_zext] = ACTIONS(713),
    [anon_sym_sext] = ACTIONS(713),
    [anon_sym_fptrunc] = ACTIONS(713),
    [anon_sym_fpext] = ACTIONS(713),
    [anon_sym_addrspacecast] = ACTIONS(713),
    [anon_sym_uitofp] = ACTIONS(713),
    [anon_sym_sitofp] = ACTIONS(713),
    [anon_sym_fptoui] = ACTIONS(713),
    [anon_sym_fptosi] = ACTIONS(713),
    [anon_sym_inttoptr] = ACTIONS(713),
    [anon_sym_ptrtoint] = ACTIONS(713),
  },
  [234] = {
    [sym_linkage] = STATE(234),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [aux_sym_function_header_repeat1] = STATE(234),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(913),
    [sym_local_var] = ACTIONS(913),
    [sym_string] = ACTIONS(913),
    [anon_sym_no_cfi] = ACTIONS(915),
    [anon_sym_private] = ACTIONS(918),
    [anon_sym_internal] = ACTIONS(918),
    [anon_sym_weak] = ACTIONS(921),
    [anon_sym_weak_odr] = ACTIONS(918),
    [anon_sym_linkonce] = ACTIONS(921),
    [anon_sym_linkonce_odr] = ACTIONS(918),
    [anon_sym_available_externally] = ACTIONS(918),
    [anon_sym_appending] = ACTIONS(918),
    [anon_sym_common] = ACTIONS(918),
    [anon_sym_extern_weak] = ACTIONS(918),
    [anon_sym_external] = ACTIONS(918),
    [anon_sym_dso_local] = ACTIONS(924),
    [anon_sym_dso_local_equivalent] = ACTIONS(927),
    [anon_sym_dso_preemptable] = ACTIONS(927),
    [anon_sym_default] = ACTIONS(930),
    [anon_sym_hidden] = ACTIONS(930),
    [anon_sym_protected] = ACTIONS(930),
    [anon_sym_dllimport] = ACTIONS(933),
    [anon_sym_dllexport] = ACTIONS(933),
    [anon_sym_ccc] = ACTIONS(913),
    [anon_sym_fastcc] = ACTIONS(913),
    [anon_sym_coldcc] = ACTIONS(913),
    [anon_sym_webkit_jscc] = ACTIONS(936),
    [anon_sym_anyregcc] = ACTIONS(913),
    [anon_sym_preserve_mostcc] = ACTIONS(913),
    [anon_sym_preserve_allcc] = ACTIONS(913),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(936),
    [anon_sym_tailcc] = ACTIONS(913),
    [anon_sym_swiftcc] = ACTIONS(936),
    [anon_sym_swifttailcc] = ACTIONS(936),
    [anon_sym_cfguard_checkcc] = ACTIONS(913),
    [aux_sym_calling_conv_token1] = ACTIONS(936),
    [aux_sym_calling_conv_token2] = ACTIONS(913),
    [aux_sym_calling_conv_token3] = ACTIONS(913),
    [aux_sym_calling_conv_token4] = ACTIONS(913),
    [aux_sym_calling_conv_token5] = ACTIONS(913),
    [aux_sym_calling_conv_token6] = ACTIONS(913),
    [aux_sym_calling_conv_token7] = ACTIONS(913),
    [aux_sym_calling_conv_token8] = ACTIONS(913),
    [aux_sym_calling_conv_token9] = ACTIONS(913),
    [aux_sym_calling_conv_token10] = ACTIONS(936),
    [anon_sym_ghccc] = ACTIONS(913),
    [aux_sym_calling_conv_token11] = ACTIONS(936),
    [aux_sym_calling_conv_token12] = ACTIONS(913),
    [aux_sym_calling_conv_token13] = ACTIONS(936),
    [aux_sym_calling_conv_token14] = ACTIONS(913),
    [anon_sym_cc] = ACTIONS(936),
    [anon_sym_unnamed_addr] = ACTIONS(913),
    [anon_sym_local_unnamed_addr] = ACTIONS(913),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_half] = ACTIONS(913),
    [anon_sym_bfloat] = ACTIONS(913),
    [anon_sym_float] = ACTIONS(913),
    [anon_sym_double] = ACTIONS(913),
    [anon_sym_x86_fp80] = ACTIONS(936),
    [anon_sym_fp128] = ACTIONS(913),
    [anon_sym_ppc_fp128] = ACTIONS(913),
    [anon_sym_label] = ACTIONS(913),
    [anon_sym_metadata] = ACTIONS(913),
    [anon_sym_x86_mmx] = ACTIONS(936),
    [anon_sym_x86_amx] = ACTIONS(936),
    [anon_sym_token] = ACTIONS(913),
    [anon_sym_opaque] = ACTIONS(913),
    [anon_sym_ptr] = ACTIONS(913),
    [aux_sym_type_keyword_token1] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(913),
    [anon_sym_LT_LBRACE] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(936),
    [anon_sym_align] = ACTIONS(936),
    [anon_sym_alignstack] = ACTIONS(913),
    [anon_sym_allocsize] = ACTIONS(913),
    [anon_sym_alwaysinline] = ACTIONS(913),
    [anon_sym_builtin] = ACTIONS(913),
    [anon_sym_cold] = ACTIONS(936),
    [anon_sym_convergent] = ACTIONS(913),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(913),
    [anon_sym_hot] = ACTIONS(913),
    [anon_sym_inaccessiblememonly] = ACTIONS(913),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(913),
    [anon_sym_inlinehint] = ACTIONS(913),
    [anon_sym_jumptable] = ACTIONS(913),
    [anon_sym_minsize] = ACTIONS(913),
    [anon_sym_naked] = ACTIONS(913),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(913),
    [anon_sym_nobuiltin] = ACTIONS(913),
    [anon_sym_noduplicate] = ACTIONS(913),
    [anon_sym_nofree] = ACTIONS(913),
    [anon_sym_noimplicitfloat] = ACTIONS(913),
    [anon_sym_noinline] = ACTIONS(913),
    [anon_sym_nomerge] = ACTIONS(913),
    [anon_sym_nonlazybind] = ACTIONS(913),
    [anon_sym_noprofile] = ACTIONS(913),
    [anon_sym_noredzone] = ACTIONS(913),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(913),
    [anon_sym_noreturn] = ACTIONS(913),
    [anon_sym_norecurse] = ACTIONS(913),
    [anon_sym_willreturn] = ACTIONS(913),
    [anon_sym_nosync] = ACTIONS(913),
    [anon_sym_nounwind] = ACTIONS(913),
    [anon_sym_nocallback] = ACTIONS(913),
    [anon_sym_nosanitize_coverage] = ACTIONS(913),
    [anon_sym_null_pointer_is_valid] = ACTIONS(913),
    [anon_sym_optforfuzzing] = ACTIONS(913),
    [anon_sym_optnone] = ACTIONS(913),
    [anon_sym_optsize] = ACTIONS(913),
    [anon_sym_readnone] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_writeonly] = ACTIONS(913),
    [anon_sym_argmemonly] = ACTIONS(913),
    [anon_sym_returns_twice] = ACTIONS(913),
    [anon_sym_safestack] = ACTIONS(913),
    [anon_sym_sanitize_address] = ACTIONS(913),
    [anon_sym_sanitize_memory] = ACTIONS(913),
    [anon_sym_sanitize_thread] = ACTIONS(913),
    [anon_sym_sanitize_hwaddress] = ACTIONS(913),
    [anon_sym_sanitize_memtag] = ACTIONS(913),
    [anon_sym_speculative_load_hardening] = ACTIONS(913),
    [anon_sym_speculatable] = ACTIONS(913),
    [anon_sym_ssp] = ACTIONS(936),
    [anon_sym_sspstrong] = ACTIONS(913),
    [anon_sym_sspreq] = ACTIONS(913),
    [anon_sym_strictfp] = ACTIONS(913),
    [anon_sym_nocf_check] = ACTIONS(913),
    [anon_sym_shadowcallstack] = ACTIONS(913),
    [anon_sym_mustprogress] = ACTIONS(913),
    [anon_sym_vscale_range] = ACTIONS(913),
    [anon_sym_preallocated] = ACTIONS(913),
    [anon_sym_zeroext] = ACTIONS(913),
    [anon_sym_signext] = ACTIONS(913),
    [anon_sym_inreg] = ACTIONS(913),
    [anon_sym_byval] = ACTIONS(913),
    [anon_sym_byref] = ACTIONS(913),
    [anon_sym_inalloca] = ACTIONS(913),
    [anon_sym_sret] = ACTIONS(913),
    [anon_sym_elementtype] = ACTIONS(913),
    [anon_sym_noalias] = ACTIONS(913),
    [anon_sym_nocapture] = ACTIONS(913),
    [anon_sym_nest] = ACTIONS(913),
    [anon_sym_returned] = ACTIONS(913),
    [anon_sym_nonnull] = ACTIONS(913),
    [anon_sym_dereferenceable] = ACTIONS(936),
    [anon_sym_dereferenceable_or_null] = ACTIONS(913),
    [anon_sym_swiftself] = ACTIONS(936),
    [anon_sym_swiftasync] = ACTIONS(936),
    [anon_sym_swifterror] = ACTIONS(936),
    [anon_sym_immarg] = ACTIONS(913),
    [anon_sym_noundef] = ACTIONS(913),
    [anon_sym_uwtable] = ACTIONS(913),
    [anon_sym_memory] = ACTIONS(913),
  },
  [235] = {
    [sym_metadata_ref] = STATE(128),
    [sym_type] = STATE(237),
    [sym_type_keyword] = STATE(285),
    [sym_struct_type] = STATE(285),
    [sym_packed_struct_type] = STATE(285),
    [sym_array_type] = STATE(285),
    [sym_vector_type] = STATE(285),
    [sym_type_and_value] = STATE(145),
    [sym_metadata] = STATE(161),
    [sym_metadata_tuple] = STATE(145),
    [sym_specialized_md] = STATE(145),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(938),
    [sym_label] = ACTIONS(116),
    [aux_sym_metadata_ref_token1] = ACTIONS(120),
    [sym_string] = ACTIONS(122),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(122),
    [sym_float] = ACTIONS(122),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(122),
    [anon_sym_private] = ACTIONS(122),
    [anon_sym_internal] = ACTIONS(122),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(122),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(122),
    [anon_sym_available_externally] = ACTIONS(122),
    [anon_sym_appending] = ACTIONS(122),
    [anon_sym_common] = ACTIONS(122),
    [anon_sym_extern_weak] = ACTIONS(122),
    [anon_sym_external] = ACTIONS(122),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(122),
    [anon_sym_dso_preemptable] = ACTIONS(122),
    [anon_sym_default] = ACTIONS(122),
    [anon_sym_hidden] = ACTIONS(122),
    [anon_sym_protected] = ACTIONS(122),
    [anon_sym_dllimport] = ACTIONS(122),
    [anon_sym_dllexport] = ACTIONS(122),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(940),
    [anon_sym_half] = ACTIONS(940),
    [anon_sym_bfloat] = ACTIONS(940),
    [anon_sym_float] = ACTIONS(940),
    [anon_sym_double] = ACTIONS(940),
    [anon_sym_x86_fp80] = ACTIONS(940),
    [anon_sym_fp128] = ACTIONS(940),
    [anon_sym_ppc_fp128] = ACTIONS(940),
    [anon_sym_label] = ACTIONS(940),
    [anon_sym_metadata] = ACTIONS(942),
    [anon_sym_x86_mmx] = ACTIONS(940),
    [anon_sym_x86_amx] = ACTIONS(940),
    [anon_sym_token] = ACTIONS(940),
    [anon_sym_opaque] = ACTIONS(940),
    [anon_sym_ptr] = ACTIONS(940),
    [aux_sym_type_keyword_token1] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(944),
    [anon_sym_RBRACE] = ACTIONS(116),
    [anon_sym_LT_LBRACE] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(948),
    [anon_sym_LT] = ACTIONS(950),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_none] = ACTIONS(122),
    [anon_sym_unreachable] = ACTIONS(122),
    [anon_sym_ret] = ACTIONS(122),
    [anon_sym_br] = ACTIONS(122),
    [anon_sym_resume] = ACTIONS(122),
    [anon_sym_freeze] = ACTIONS(122),
    [anon_sym_indirectbr] = ACTIONS(122),
    [anon_sym_extractelement] = ACTIONS(122),
    [anon_sym_insertelement] = ACTIONS(122),
    [anon_sym_select] = ACTIONS(122),
    [anon_sym_shufflevector] = ACTIONS(122),
    [anon_sym_fneg] = ACTIONS(122),
    [anon_sym_switch] = ACTIONS(122),
    [anon_sym_invoke] = ACTIONS(122),
    [anon_sym_cleanupret] = ACTIONS(122),
    [anon_sym_catchret] = ACTIONS(122),
    [anon_sym_catchswitch] = ACTIONS(122),
    [anon_sym_catchpad] = ACTIONS(122),
    [anon_sym_cleanuppad] = ACTIONS(122),
    [anon_sym_callbr] = ACTIONS(122),
    [anon_sym_icmp] = ACTIONS(122),
    [anon_sym_fcmp] = ACTIONS(122),
    [anon_sym_va_arg] = ACTIONS(122),
    [anon_sym_phi] = ACTIONS(122),
    [anon_sym_landingpad] = ACTIONS(122),
    [anon_sym_tail] = ACTIONS(122),
    [anon_sym_musttail] = ACTIONS(122),
    [anon_sym_notail] = ACTIONS(122),
    [anon_sym_call] = ACTIONS(122),
    [anon_sym_alloca] = ACTIONS(122),
    [anon_sym_load] = ACTIONS(122),
    [anon_sym_store] = ACTIONS(122),
    [anon_sym_cmpxchg] = ACTIONS(122),
    [anon_sym_atomicrmw] = ACTIONS(122),
    [anon_sym_fence] = ACTIONS(122),
    [anon_sym_getelementptr] = ACTIONS(122),
    [anon_sym_extractvalue] = ACTIONS(122),
    [anon_sym_insertvalue] = ACTIONS(122),
    [anon_sym_true] = ACTIONS(122),
    [anon_sym_false] = ACTIONS(122),
    [anon_sym_null] = ACTIONS(136),
    [anon_sym_undef] = ACTIONS(122),
    [anon_sym_poison] = ACTIONS(122),
    [anon_sym_zeroinitializer] = ACTIONS(122),
    [anon_sym_catch] = ACTIONS(122),
    [anon_sym_filter] = ACTIONS(122),
    [anon_sym_blockaddress] = ACTIONS(122),
    [anon_sym_mul] = ACTIONS(122),
    [anon_sym_urem] = ACTIONS(122),
    [anon_sym_srem] = ACTIONS(122),
    [anon_sym_shl] = ACTIONS(122),
    [anon_sym_udiv] = ACTIONS(122),
    [anon_sym_sdiv] = ACTIONS(122),
    [anon_sym_lshr] = ACTIONS(122),
    [anon_sym_ashr] = ACTIONS(122),
    [anon_sym_fmul] = ACTIONS(122),
    [anon_sym_fdiv] = ACTIONS(122),
    [anon_sym_frem] = ACTIONS(122),
    [anon_sym_xchg] = ACTIONS(122),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(122),
    [anon_sym_and] = ACTIONS(122),
    [anon_sym_nand] = ACTIONS(122),
    [anon_sym_or] = ACTIONS(122),
    [anon_sym_xor] = ACTIONS(122),
    [anon_sym_max] = ACTIONS(122),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(122),
    [anon_sym_umin] = ACTIONS(122),
    [anon_sym_fadd] = ACTIONS(122),
    [anon_sym_fsub] = ACTIONS(122),
    [anon_sym_bitcast] = ACTIONS(122),
    [anon_sym_trunc] = ACTIONS(122),
    [anon_sym_zext] = ACTIONS(122),
    [anon_sym_sext] = ACTIONS(122),
    [anon_sym_fptrunc] = ACTIONS(122),
    [anon_sym_fpext] = ACTIONS(122),
    [anon_sym_addrspacecast] = ACTIONS(122),
    [anon_sym_uitofp] = ACTIONS(122),
    [anon_sym_sitofp] = ACTIONS(122),
    [anon_sym_fptoui] = ACTIONS(122),
    [anon_sym_fptosi] = ACTIONS(122),
    [anon_sym_inttoptr] = ACTIONS(122),
    [anon_sym_ptrtoint] = ACTIONS(122),
    [anon_sym_unordered] = ACTIONS(122),
    [anon_sym_monotonic] = ACTIONS(122),
    [anon_sym_acquire] = ACTIONS(122),
    [anon_sym_release] = ACTIONS(122),
    [anon_sym_acq_rel] = ACTIONS(122),
    [anon_sym_seq_cst] = ACTIONS(122),
    [anon_sym_syncscope] = ACTIONS(122),
    [anon_sym_uselistorder] = ACTIONS(122),
    [anon_sym_BANG] = ACTIONS(138),
  },
  [236] = {
    [sym_metadata_name] = STATE(747),
    [sym_metadata_attachment] = STATE(236),
    [aux_sym_declare_repeat1] = STATE(236),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(952),
    [aux_sym_metadata_ref_token1] = ACTIONS(954),
    [sym_string] = ACTIONS(952),
    [anon_sym_no_cfi] = ACTIONS(952),
    [anon_sym_private] = ACTIONS(952),
    [anon_sym_internal] = ACTIONS(952),
    [anon_sym_weak] = ACTIONS(957),
    [anon_sym_weak_odr] = ACTIONS(952),
    [anon_sym_linkonce] = ACTIONS(957),
    [anon_sym_linkonce_odr] = ACTIONS(952),
    [anon_sym_available_externally] = ACTIONS(952),
    [anon_sym_appending] = ACTIONS(952),
    [anon_sym_common] = ACTIONS(952),
    [anon_sym_extern_weak] = ACTIONS(952),
    [anon_sym_external] = ACTIONS(952),
    [anon_sym_dso_local] = ACTIONS(957),
    [anon_sym_dso_local_equivalent] = ACTIONS(952),
    [anon_sym_dso_preemptable] = ACTIONS(952),
    [anon_sym_default] = ACTIONS(952),
    [anon_sym_hidden] = ACTIONS(952),
    [anon_sym_protected] = ACTIONS(952),
    [anon_sym_dllimport] = ACTIONS(952),
    [anon_sym_dllexport] = ACTIONS(952),
    [anon_sym_ccc] = ACTIONS(952),
    [anon_sym_fastcc] = ACTIONS(952),
    [anon_sym_coldcc] = ACTIONS(952),
    [anon_sym_webkit_jscc] = ACTIONS(957),
    [anon_sym_anyregcc] = ACTIONS(952),
    [anon_sym_preserve_mostcc] = ACTIONS(952),
    [anon_sym_preserve_allcc] = ACTIONS(952),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(957),
    [anon_sym_tailcc] = ACTIONS(952),
    [anon_sym_swiftcc] = ACTIONS(957),
    [anon_sym_swifttailcc] = ACTIONS(957),
    [anon_sym_cfguard_checkcc] = ACTIONS(952),
    [aux_sym_calling_conv_token1] = ACTIONS(957),
    [aux_sym_calling_conv_token2] = ACTIONS(952),
    [aux_sym_calling_conv_token3] = ACTIONS(952),
    [aux_sym_calling_conv_token4] = ACTIONS(952),
    [aux_sym_calling_conv_token5] = ACTIONS(952),
    [aux_sym_calling_conv_token6] = ACTIONS(952),
    [aux_sym_calling_conv_token7] = ACTIONS(952),
    [aux_sym_calling_conv_token8] = ACTIONS(952),
    [aux_sym_calling_conv_token9] = ACTIONS(952),
    [aux_sym_calling_conv_token10] = ACTIONS(957),
    [anon_sym_ghccc] = ACTIONS(952),
    [aux_sym_calling_conv_token11] = ACTIONS(957),
    [aux_sym_calling_conv_token12] = ACTIONS(952),
    [aux_sym_calling_conv_token13] = ACTIONS(957),
    [aux_sym_calling_conv_token14] = ACTIONS(952),
    [anon_sym_cc] = ACTIONS(957),
    [anon_sym_unnamed_addr] = ACTIONS(952),
    [anon_sym_local_unnamed_addr] = ACTIONS(952),
    [anon_sym_void] = ACTIONS(952),
    [anon_sym_half] = ACTIONS(952),
    [anon_sym_bfloat] = ACTIONS(952),
    [anon_sym_float] = ACTIONS(952),
    [anon_sym_double] = ACTIONS(952),
    [anon_sym_x86_fp80] = ACTIONS(957),
    [anon_sym_fp128] = ACTIONS(952),
    [anon_sym_ppc_fp128] = ACTIONS(952),
    [anon_sym_label] = ACTIONS(952),
    [anon_sym_metadata] = ACTIONS(952),
    [anon_sym_x86_mmx] = ACTIONS(957),
    [anon_sym_x86_amx] = ACTIONS(957),
    [anon_sym_token] = ACTIONS(952),
    [anon_sym_opaque] = ACTIONS(952),
    [anon_sym_ptr] = ACTIONS(952),
    [aux_sym_type_keyword_token1] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(952),
    [anon_sym_LT_LBRACE] = ACTIONS(952),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(957),
    [anon_sym_align] = ACTIONS(957),
    [anon_sym_alignstack] = ACTIONS(952),
    [anon_sym_allocsize] = ACTIONS(952),
    [anon_sym_alwaysinline] = ACTIONS(952),
    [anon_sym_builtin] = ACTIONS(952),
    [anon_sym_cold] = ACTIONS(957),
    [anon_sym_convergent] = ACTIONS(952),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(952),
    [anon_sym_hot] = ACTIONS(952),
    [anon_sym_inaccessiblememonly] = ACTIONS(952),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(952),
    [anon_sym_inlinehint] = ACTIONS(952),
    [anon_sym_jumptable] = ACTIONS(952),
    [anon_sym_minsize] = ACTIONS(952),
    [anon_sym_naked] = ACTIONS(952),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(952),
    [anon_sym_nobuiltin] = ACTIONS(952),
    [anon_sym_noduplicate] = ACTIONS(952),
    [anon_sym_nofree] = ACTIONS(952),
    [anon_sym_noimplicitfloat] = ACTIONS(952),
    [anon_sym_noinline] = ACTIONS(952),
    [anon_sym_nomerge] = ACTIONS(952),
    [anon_sym_nonlazybind] = ACTIONS(952),
    [anon_sym_noprofile] = ACTIONS(952),
    [anon_sym_noredzone] = ACTIONS(952),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(952),
    [anon_sym_noreturn] = ACTIONS(952),
    [anon_sym_norecurse] = ACTIONS(952),
    [anon_sym_willreturn] = ACTIONS(952),
    [anon_sym_nosync] = ACTIONS(952),
    [anon_sym_nounwind] = ACTIONS(952),
    [anon_sym_nocallback] = ACTIONS(952),
    [anon_sym_nosanitize_coverage] = ACTIONS(952),
    [anon_sym_null_pointer_is_valid] = ACTIONS(952),
    [anon_sym_optforfuzzing] = ACTIONS(952),
    [anon_sym_optnone] = ACTIONS(952),
    [anon_sym_optsize] = ACTIONS(952),
    [anon_sym_readnone] = ACTIONS(952),
    [anon_sym_readonly] = ACTIONS(952),
    [anon_sym_writeonly] = ACTIONS(952),
    [anon_sym_argmemonly] = ACTIONS(952),
    [anon_sym_returns_twice] = ACTIONS(952),
    [anon_sym_safestack] = ACTIONS(952),
    [anon_sym_sanitize_address] = ACTIONS(952),
    [anon_sym_sanitize_memory] = ACTIONS(952),
    [anon_sym_sanitize_thread] = ACTIONS(952),
    [anon_sym_sanitize_hwaddress] = ACTIONS(952),
    [anon_sym_sanitize_memtag] = ACTIONS(952),
    [anon_sym_speculative_load_hardening] = ACTIONS(952),
    [anon_sym_speculatable] = ACTIONS(952),
    [anon_sym_ssp] = ACTIONS(957),
    [anon_sym_sspstrong] = ACTIONS(952),
    [anon_sym_sspreq] = ACTIONS(952),
    [anon_sym_strictfp] = ACTIONS(952),
    [anon_sym_nocf_check] = ACTIONS(952),
    [anon_sym_shadowcallstack] = ACTIONS(952),
    [anon_sym_mustprogress] = ACTIONS(952),
    [anon_sym_vscale_range] = ACTIONS(952),
    [anon_sym_preallocated] = ACTIONS(952),
    [anon_sym_zeroext] = ACTIONS(952),
    [anon_sym_signext] = ACTIONS(952),
    [anon_sym_inreg] = ACTIONS(952),
    [anon_sym_byval] = ACTIONS(952),
    [anon_sym_byref] = ACTIONS(952),
    [anon_sym_inalloca] = ACTIONS(952),
    [anon_sym_sret] = ACTIONS(952),
    [anon_sym_elementtype] = ACTIONS(952),
    [anon_sym_noalias] = ACTIONS(952),
    [anon_sym_nocapture] = ACTIONS(952),
    [anon_sym_nest] = ACTIONS(952),
    [anon_sym_returned] = ACTIONS(952),
    [anon_sym_nonnull] = ACTIONS(952),
    [anon_sym_dereferenceable] = ACTIONS(957),
    [anon_sym_dereferenceable_or_null] = ACTIONS(952),
    [anon_sym_swiftself] = ACTIONS(957),
    [anon_sym_swiftasync] = ACTIONS(957),
    [anon_sym_swifterror] = ACTIONS(957),
    [anon_sym_immarg] = ACTIONS(952),
    [anon_sym_noundef] = ACTIONS(952),
    [anon_sym_uwtable] = ACTIONS(952),
    [anon_sym_memory] = ACTIONS(952),
  },
  [237] = {
    [sym_number] = STATE(164),
    [sym_var] = STATE(164),
    [sym_linkage] = STATE(784),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(172),
    [sym__primitive_value] = STATE(164),
    [sym_struct_value] = STATE(164),
    [sym_packed_struct_value] = STATE(164),
    [sym_array_value] = STATE(164),
    [sym_vector_value] = STATE(164),
    [sym_blockaddress] = STATE(164),
    [sym_constant_expr] = STATE(164),
    [sym_constant_cast] = STATE(175),
    [sym_constant_getelementptr] = STATE(175),
    [sym_constant_select] = STATE(175),
    [sym_constant_icmp] = STATE(175),
    [sym_constant_fcmp] = STATE(175),
    [sym_constant_extractelement] = STATE(175),
    [sym_constant_insertelement] = STATE(175),
    [sym_constant_shufflevector] = STATE(175),
    [sym_constant_extractvalue] = STATE(175),
    [sym_constant_insertvalue] = STATE(175),
    [sym_constant_fneg] = STATE(175),
    [sym_constant_bin_op] = STATE(175),
    [sym_bin_op_keyword] = STATE(1106),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1954),
    [aux_sym_function_header_repeat1] = STATE(784),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(140),
    [sym_local_var] = ACTIONS(142),
    [sym_label] = ACTIONS(38),
    [sym_string] = ACTIONS(150),
    [aux_sym_number_token1] = ACTIONS(148),
    [aux_sym_number_token2] = ACTIONS(148),
    [sym_float] = ACTIONS(150),
    [sym_cstring] = ACTIONS(152),
    [anon_sym_no_cfi] = ACTIONS(154),
    [anon_sym_private] = ACTIONS(156),
    [anon_sym_internal] = ACTIONS(156),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(156),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(156),
    [anon_sym_available_externally] = ACTIONS(156),
    [anon_sym_appending] = ACTIONS(156),
    [anon_sym_common] = ACTIONS(156),
    [anon_sym_extern_weak] = ACTIONS(156),
    [anon_sym_external] = ACTIONS(156),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(158),
    [anon_sym_dso_preemptable] = ACTIONS(158),
    [anon_sym_default] = ACTIONS(160),
    [anon_sym_hidden] = ACTIONS(160),
    [anon_sym_protected] = ACTIONS(160),
    [anon_sym_dllimport] = ACTIONS(162),
    [anon_sym_dllexport] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(164),
    [anon_sym_RBRACE] = ACTIONS(38),
    [anon_sym_LT_LBRACE] = ACTIONS(166),
    [anon_sym_LBRACK] = ACTIONS(959),
    [anon_sym_LT] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(38),
    [anon_sym_none] = ACTIONS(150),
    [anon_sym_unreachable] = ACTIONS(70),
    [anon_sym_ret] = ACTIONS(70),
    [anon_sym_br] = ACTIONS(70),
    [anon_sym_resume] = ACTIONS(70),
    [anon_sym_freeze] = ACTIONS(70),
    [anon_sym_indirectbr] = ACTIONS(70),
    [anon_sym_extractelement] = ACTIONS(173),
    [anon_sym_insertelement] = ACTIONS(176),
    [anon_sym_select] = ACTIONS(179),
    [anon_sym_shufflevector] = ACTIONS(182),
    [anon_sym_fneg] = ACTIONS(185),
    [anon_sym_switch] = ACTIONS(70),
    [anon_sym_invoke] = ACTIONS(70),
    [anon_sym_cleanupret] = ACTIONS(70),
    [anon_sym_catchret] = ACTIONS(70),
    [anon_sym_catchswitch] = ACTIONS(70),
    [anon_sym_catchpad] = ACTIONS(70),
    [anon_sym_cleanuppad] = ACTIONS(70),
    [anon_sym_callbr] = ACTIONS(70),
    [anon_sym_icmp] = ACTIONS(188),
    [anon_sym_fcmp] = ACTIONS(191),
    [anon_sym_va_arg] = ACTIONS(70),
    [anon_sym_phi] = ACTIONS(70),
    [anon_sym_landingpad] = ACTIONS(70),
    [anon_sym_tail] = ACTIONS(70),
    [anon_sym_musttail] = ACTIONS(70),
    [anon_sym_notail] = ACTIONS(70),
    [anon_sym_call] = ACTIONS(70),
    [anon_sym_alloca] = ACTIONS(70),
    [anon_sym_load] = ACTIONS(70),
    [anon_sym_store] = ACTIONS(70),
    [anon_sym_cmpxchg] = ACTIONS(70),
    [anon_sym_atomicrmw] = ACTIONS(70),
    [anon_sym_fence] = ACTIONS(70),
    [anon_sym_getelementptr] = ACTIONS(194),
    [anon_sym_extractvalue] = ACTIONS(197),
    [anon_sym_insertvalue] = ACTIONS(200),
    [anon_sym_true] = ACTIONS(150),
    [anon_sym_false] = ACTIONS(150),
    [anon_sym_null] = ACTIONS(150),
    [anon_sym_undef] = ACTIONS(150),
    [anon_sym_poison] = ACTIONS(150),
    [anon_sym_zeroinitializer] = ACTIONS(150),
    [anon_sym_catch] = ACTIONS(70),
    [anon_sym_filter] = ACTIONS(70),
    [anon_sym_blockaddress] = ACTIONS(203),
    [anon_sym_mul] = ACTIONS(205),
    [anon_sym_urem] = ACTIONS(205),
    [anon_sym_srem] = ACTIONS(205),
    [anon_sym_shl] = ACTIONS(205),
    [anon_sym_udiv] = ACTIONS(205),
    [anon_sym_sdiv] = ACTIONS(205),
    [anon_sym_lshr] = ACTIONS(205),
    [anon_sym_ashr] = ACTIONS(205),
    [anon_sym_fmul] = ACTIONS(205),
    [anon_sym_fdiv] = ACTIONS(205),
    [anon_sym_frem] = ACTIONS(205),
    [anon_sym_xchg] = ACTIONS(208),
    [anon_sym_add] = ACTIONS(208),
    [anon_sym_sub] = ACTIONS(208),
    [anon_sym_and] = ACTIONS(208),
    [anon_sym_nand] = ACTIONS(208),
    [anon_sym_or] = ACTIONS(208),
    [anon_sym_xor] = ACTIONS(208),
    [anon_sym_max] = ACTIONS(208),
    [anon_sym_min] = ACTIONS(208),
    [anon_sym_umax] = ACTIONS(208),
    [anon_sym_umin] = ACTIONS(208),
    [anon_sym_fadd] = ACTIONS(208),
    [anon_sym_fsub] = ACTIONS(208),
    [anon_sym_bitcast] = ACTIONS(211),
    [anon_sym_trunc] = ACTIONS(211),
    [anon_sym_zext] = ACTIONS(211),
    [anon_sym_sext] = ACTIONS(211),
    [anon_sym_fptrunc] = ACTIONS(211),
    [anon_sym_fpext] = ACTIONS(211),
    [anon_sym_addrspacecast] = ACTIONS(211),
    [anon_sym_uitofp] = ACTIONS(211),
    [anon_sym_sitofp] = ACTIONS(211),
    [anon_sym_fptoui] = ACTIONS(211),
    [anon_sym_fptosi] = ACTIONS(211),
    [anon_sym_inttoptr] = ACTIONS(211),
    [anon_sym_ptrtoint] = ACTIONS(211),
    [anon_sym_unordered] = ACTIONS(70),
    [anon_sym_monotonic] = ACTIONS(70),
    [anon_sym_acquire] = ACTIONS(70),
    [anon_sym_release] = ACTIONS(70),
    [anon_sym_acq_rel] = ACTIONS(70),
    [anon_sym_seq_cst] = ACTIONS(70),
    [anon_sym_syncscope] = ACTIONS(70),
    [anon_sym_uselistorder] = ACTIONS(70),
  },
  [238] = {
    [sym_calling_conv] = STATE(404),
    [sym_type] = STATE(374),
    [sym_type_keyword] = STATE(260),
    [sym_struct_type] = STATE(260),
    [sym_packed_struct_type] = STATE(260),
    [sym_array_type] = STATE(260),
    [sym_vector_type] = STATE(260),
    [sym_addrspace] = STATE(1081),
    [sym_param_or_return_attrs] = STATE(412),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym__call_part] = STATE(647),
    [sym_fast_math] = STATE(254),
    [aux_sym_function_header_repeat2] = STATE(412),
    [aux_sym_instruction_select_repeat1] = STATE(254),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [sym_string] = ACTIONS(721),
    [anon_sym_ccc] = ACTIONS(721),
    [anon_sym_fastcc] = ACTIONS(721),
    [anon_sym_coldcc] = ACTIONS(721),
    [anon_sym_webkit_jscc] = ACTIONS(723),
    [anon_sym_anyregcc] = ACTIONS(721),
    [anon_sym_preserve_mostcc] = ACTIONS(721),
    [anon_sym_preserve_allcc] = ACTIONS(721),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(723),
    [anon_sym_tailcc] = ACTIONS(721),
    [anon_sym_swiftcc] = ACTIONS(723),
    [anon_sym_swifttailcc] = ACTIONS(723),
    [anon_sym_cfguard_checkcc] = ACTIONS(721),
    [aux_sym_calling_conv_token1] = ACTIONS(723),
    [aux_sym_calling_conv_token2] = ACTIONS(721),
    [aux_sym_calling_conv_token3] = ACTIONS(721),
    [aux_sym_calling_conv_token4] = ACTIONS(721),
    [aux_sym_calling_conv_token5] = ACTIONS(721),
    [aux_sym_calling_conv_token6] = ACTIONS(721),
    [aux_sym_calling_conv_token7] = ACTIONS(721),
    [aux_sym_calling_conv_token8] = ACTIONS(721),
    [aux_sym_calling_conv_token9] = ACTIONS(721),
    [aux_sym_calling_conv_token10] = ACTIONS(723),
    [anon_sym_ghccc] = ACTIONS(721),
    [aux_sym_calling_conv_token11] = ACTIONS(723),
    [aux_sym_calling_conv_token12] = ACTIONS(721),
    [aux_sym_calling_conv_token13] = ACTIONS(723),
    [aux_sym_calling_conv_token14] = ACTIONS(721),
    [anon_sym_cc] = ACTIONS(725),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(442),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(442),
    [anon_sym_x86_amx] = ACTIONS(442),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(458),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(458),
    [anon_sym_swiftasync] = ACTIONS(458),
    [anon_sym_swifterror] = ACTIONS(458),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_nnan] = ACTIONS(963),
    [anon_sym_ninf] = ACTIONS(963),
    [anon_sym_nsz] = ACTIONS(963),
    [anon_sym_arcp] = ACTIONS(963),
    [anon_sym_contract] = ACTIONS(963),
    [anon_sym_afn] = ACTIONS(963),
    [anon_sym_reassoc] = ACTIONS(963),
    [anon_sym_fast] = ACTIONS(965),
  },
  [239] = {
    [sym_calling_conv] = STATE(404),
    [sym_type] = STATE(374),
    [sym_type_keyword] = STATE(260),
    [sym_struct_type] = STATE(260),
    [sym_packed_struct_type] = STATE(260),
    [sym_array_type] = STATE(260),
    [sym_vector_type] = STATE(260),
    [sym_addrspace] = STATE(1081),
    [sym_param_or_return_attrs] = STATE(412),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym__call_part] = STATE(635),
    [sym_fast_math] = STATE(254),
    [aux_sym_function_header_repeat2] = STATE(412),
    [aux_sym_instruction_select_repeat1] = STATE(254),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [sym_string] = ACTIONS(721),
    [anon_sym_ccc] = ACTIONS(721),
    [anon_sym_fastcc] = ACTIONS(721),
    [anon_sym_coldcc] = ACTIONS(721),
    [anon_sym_webkit_jscc] = ACTIONS(723),
    [anon_sym_anyregcc] = ACTIONS(721),
    [anon_sym_preserve_mostcc] = ACTIONS(721),
    [anon_sym_preserve_allcc] = ACTIONS(721),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(723),
    [anon_sym_tailcc] = ACTIONS(721),
    [anon_sym_swiftcc] = ACTIONS(723),
    [anon_sym_swifttailcc] = ACTIONS(723),
    [anon_sym_cfguard_checkcc] = ACTIONS(721),
    [aux_sym_calling_conv_token1] = ACTIONS(723),
    [aux_sym_calling_conv_token2] = ACTIONS(721),
    [aux_sym_calling_conv_token3] = ACTIONS(721),
    [aux_sym_calling_conv_token4] = ACTIONS(721),
    [aux_sym_calling_conv_token5] = ACTIONS(721),
    [aux_sym_calling_conv_token6] = ACTIONS(721),
    [aux_sym_calling_conv_token7] = ACTIONS(721),
    [aux_sym_calling_conv_token8] = ACTIONS(721),
    [aux_sym_calling_conv_token9] = ACTIONS(721),
    [aux_sym_calling_conv_token10] = ACTIONS(723),
    [anon_sym_ghccc] = ACTIONS(721),
    [aux_sym_calling_conv_token11] = ACTIONS(723),
    [aux_sym_calling_conv_token12] = ACTIONS(721),
    [aux_sym_calling_conv_token13] = ACTIONS(723),
    [aux_sym_calling_conv_token14] = ACTIONS(721),
    [anon_sym_cc] = ACTIONS(725),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(442),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(442),
    [anon_sym_x86_amx] = ACTIONS(442),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(458),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(458),
    [anon_sym_swiftasync] = ACTIONS(458),
    [anon_sym_swifterror] = ACTIONS(458),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_nnan] = ACTIONS(963),
    [anon_sym_ninf] = ACTIONS(963),
    [anon_sym_nsz] = ACTIONS(963),
    [anon_sym_arcp] = ACTIONS(963),
    [anon_sym_contract] = ACTIONS(963),
    [anon_sym_afn] = ACTIONS(963),
    [anon_sym_reassoc] = ACTIONS(963),
    [anon_sym_fast] = ACTIONS(965),
  },
  [240] = {
    [sym_calling_conv] = STATE(404),
    [sym_type] = STATE(374),
    [sym_type_keyword] = STATE(260),
    [sym_struct_type] = STATE(260),
    [sym_packed_struct_type] = STATE(260),
    [sym_array_type] = STATE(260),
    [sym_vector_type] = STATE(260),
    [sym_addrspace] = STATE(1081),
    [sym_param_or_return_attrs] = STATE(412),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym__call_part] = STATE(638),
    [sym_fast_math] = STATE(238),
    [aux_sym_function_header_repeat2] = STATE(412),
    [aux_sym_instruction_select_repeat1] = STATE(238),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [sym_string] = ACTIONS(721),
    [anon_sym_ccc] = ACTIONS(721),
    [anon_sym_fastcc] = ACTIONS(721),
    [anon_sym_coldcc] = ACTIONS(721),
    [anon_sym_webkit_jscc] = ACTIONS(723),
    [anon_sym_anyregcc] = ACTIONS(721),
    [anon_sym_preserve_mostcc] = ACTIONS(721),
    [anon_sym_preserve_allcc] = ACTIONS(721),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(723),
    [anon_sym_tailcc] = ACTIONS(721),
    [anon_sym_swiftcc] = ACTIONS(723),
    [anon_sym_swifttailcc] = ACTIONS(723),
    [anon_sym_cfguard_checkcc] = ACTIONS(721),
    [aux_sym_calling_conv_token1] = ACTIONS(723),
    [aux_sym_calling_conv_token2] = ACTIONS(721),
    [aux_sym_calling_conv_token3] = ACTIONS(721),
    [aux_sym_calling_conv_token4] = ACTIONS(721),
    [aux_sym_calling_conv_token5] = ACTIONS(721),
    [aux_sym_calling_conv_token6] = ACTIONS(721),
    [aux_sym_calling_conv_token7] = ACTIONS(721),
    [aux_sym_calling_conv_token8] = ACTIONS(721),
    [aux_sym_calling_conv_token9] = ACTIONS(721),
    [aux_sym_calling_conv_token10] = ACTIONS(723),
    [anon_sym_ghccc] = ACTIONS(721),
    [aux_sym_calling_conv_token11] = ACTIONS(723),
    [aux_sym_calling_conv_token12] = ACTIONS(721),
    [aux_sym_calling_conv_token13] = ACTIONS(723),
    [aux_sym_calling_conv_token14] = ACTIONS(721),
    [anon_sym_cc] = ACTIONS(725),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(442),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(442),
    [anon_sym_x86_amx] = ACTIONS(442),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(458),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(458),
    [anon_sym_swiftasync] = ACTIONS(458),
    [anon_sym_swifterror] = ACTIONS(458),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_nnan] = ACTIONS(963),
    [anon_sym_ninf] = ACTIONS(963),
    [anon_sym_nsz] = ACTIONS(963),
    [anon_sym_arcp] = ACTIONS(963),
    [anon_sym_contract] = ACTIONS(963),
    [anon_sym_afn] = ACTIONS(963),
    [anon_sym_reassoc] = ACTIONS(963),
    [anon_sym_fast] = ACTIONS(965),
  },
  [241] = {
    [sym_calling_conv] = STATE(404),
    [sym_type] = STATE(374),
    [sym_type_keyword] = STATE(260),
    [sym_struct_type] = STATE(260),
    [sym_packed_struct_type] = STATE(260),
    [sym_array_type] = STATE(260),
    [sym_vector_type] = STATE(260),
    [sym_addrspace] = STATE(1081),
    [sym_param_or_return_attrs] = STATE(412),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym__call_part] = STATE(612),
    [sym_fast_math] = STATE(239),
    [aux_sym_function_header_repeat2] = STATE(412),
    [aux_sym_instruction_select_repeat1] = STATE(239),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [sym_string] = ACTIONS(721),
    [anon_sym_ccc] = ACTIONS(721),
    [anon_sym_fastcc] = ACTIONS(721),
    [anon_sym_coldcc] = ACTIONS(721),
    [anon_sym_webkit_jscc] = ACTIONS(723),
    [anon_sym_anyregcc] = ACTIONS(721),
    [anon_sym_preserve_mostcc] = ACTIONS(721),
    [anon_sym_preserve_allcc] = ACTIONS(721),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(723),
    [anon_sym_tailcc] = ACTIONS(721),
    [anon_sym_swiftcc] = ACTIONS(723),
    [anon_sym_swifttailcc] = ACTIONS(723),
    [anon_sym_cfguard_checkcc] = ACTIONS(721),
    [aux_sym_calling_conv_token1] = ACTIONS(723),
    [aux_sym_calling_conv_token2] = ACTIONS(721),
    [aux_sym_calling_conv_token3] = ACTIONS(721),
    [aux_sym_calling_conv_token4] = ACTIONS(721),
    [aux_sym_calling_conv_token5] = ACTIONS(721),
    [aux_sym_calling_conv_token6] = ACTIONS(721),
    [aux_sym_calling_conv_token7] = ACTIONS(721),
    [aux_sym_calling_conv_token8] = ACTIONS(721),
    [aux_sym_calling_conv_token9] = ACTIONS(721),
    [aux_sym_calling_conv_token10] = ACTIONS(723),
    [anon_sym_ghccc] = ACTIONS(721),
    [aux_sym_calling_conv_token11] = ACTIONS(723),
    [aux_sym_calling_conv_token12] = ACTIONS(721),
    [aux_sym_calling_conv_token13] = ACTIONS(723),
    [aux_sym_calling_conv_token14] = ACTIONS(721),
    [anon_sym_cc] = ACTIONS(725),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(442),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(442),
    [anon_sym_x86_amx] = ACTIONS(442),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(458),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(458),
    [anon_sym_swiftasync] = ACTIONS(458),
    [anon_sym_swifterror] = ACTIONS(458),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_nnan] = ACTIONS(963),
    [anon_sym_ninf] = ACTIONS(963),
    [anon_sym_nsz] = ACTIONS(963),
    [anon_sym_arcp] = ACTIONS(963),
    [anon_sym_contract] = ACTIONS(963),
    [anon_sym_afn] = ACTIONS(963),
    [anon_sym_reassoc] = ACTIONS(963),
    [anon_sym_fast] = ACTIONS(965),
  },
  [242] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(967),
    [sym_local_var] = ACTIONS(967),
    [sym_string] = ACTIONS(967),
    [anon_sym_no_cfi] = ACTIONS(967),
    [anon_sym_private] = ACTIONS(967),
    [anon_sym_internal] = ACTIONS(967),
    [anon_sym_weak] = ACTIONS(969),
    [anon_sym_weak_odr] = ACTIONS(967),
    [anon_sym_linkonce] = ACTIONS(969),
    [anon_sym_linkonce_odr] = ACTIONS(967),
    [anon_sym_available_externally] = ACTIONS(967),
    [anon_sym_appending] = ACTIONS(967),
    [anon_sym_common] = ACTIONS(967),
    [anon_sym_extern_weak] = ACTIONS(967),
    [anon_sym_external] = ACTIONS(967),
    [anon_sym_dso_local] = ACTIONS(969),
    [anon_sym_dso_local_equivalent] = ACTIONS(967),
    [anon_sym_dso_preemptable] = ACTIONS(967),
    [anon_sym_default] = ACTIONS(967),
    [anon_sym_hidden] = ACTIONS(967),
    [anon_sym_protected] = ACTIONS(967),
    [anon_sym_dllimport] = ACTIONS(967),
    [anon_sym_dllexport] = ACTIONS(967),
    [anon_sym_ccc] = ACTIONS(967),
    [anon_sym_fastcc] = ACTIONS(967),
    [anon_sym_coldcc] = ACTIONS(967),
    [anon_sym_webkit_jscc] = ACTIONS(969),
    [anon_sym_anyregcc] = ACTIONS(967),
    [anon_sym_preserve_mostcc] = ACTIONS(967),
    [anon_sym_preserve_allcc] = ACTIONS(967),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(969),
    [anon_sym_tailcc] = ACTIONS(967),
    [anon_sym_swiftcc] = ACTIONS(969),
    [anon_sym_swifttailcc] = ACTIONS(969),
    [anon_sym_cfguard_checkcc] = ACTIONS(967),
    [aux_sym_calling_conv_token1] = ACTIONS(969),
    [aux_sym_calling_conv_token2] = ACTIONS(967),
    [aux_sym_calling_conv_token3] = ACTIONS(967),
    [aux_sym_calling_conv_token4] = ACTIONS(967),
    [aux_sym_calling_conv_token5] = ACTIONS(967),
    [aux_sym_calling_conv_token6] = ACTIONS(967),
    [aux_sym_calling_conv_token7] = ACTIONS(967),
    [aux_sym_calling_conv_token8] = ACTIONS(967),
    [aux_sym_calling_conv_token9] = ACTIONS(967),
    [aux_sym_calling_conv_token10] = ACTIONS(969),
    [anon_sym_ghccc] = ACTIONS(967),
    [aux_sym_calling_conv_token11] = ACTIONS(969),
    [aux_sym_calling_conv_token12] = ACTIONS(967),
    [aux_sym_calling_conv_token13] = ACTIONS(969),
    [aux_sym_calling_conv_token14] = ACTIONS(967),
    [anon_sym_cc] = ACTIONS(969),
    [anon_sym_unnamed_addr] = ACTIONS(967),
    [anon_sym_local_unnamed_addr] = ACTIONS(967),
    [anon_sym_void] = ACTIONS(967),
    [anon_sym_half] = ACTIONS(967),
    [anon_sym_bfloat] = ACTIONS(967),
    [anon_sym_float] = ACTIONS(967),
    [anon_sym_double] = ACTIONS(967),
    [anon_sym_x86_fp80] = ACTIONS(969),
    [anon_sym_fp128] = ACTIONS(967),
    [anon_sym_ppc_fp128] = ACTIONS(967),
    [anon_sym_label] = ACTIONS(967),
    [anon_sym_metadata] = ACTIONS(967),
    [anon_sym_x86_mmx] = ACTIONS(969),
    [anon_sym_x86_amx] = ACTIONS(969),
    [anon_sym_token] = ACTIONS(967),
    [anon_sym_opaque] = ACTIONS(967),
    [anon_sym_ptr] = ACTIONS(967),
    [aux_sym_type_keyword_token1] = ACTIONS(967),
    [anon_sym_LBRACE] = ACTIONS(967),
    [anon_sym_LT_LBRACE] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(967),
    [anon_sym_LT] = ACTIONS(969),
    [anon_sym_align] = ACTIONS(969),
    [anon_sym_alignstack] = ACTIONS(967),
    [anon_sym_allocsize] = ACTIONS(967),
    [anon_sym_alwaysinline] = ACTIONS(967),
    [anon_sym_builtin] = ACTIONS(967),
    [anon_sym_cold] = ACTIONS(969),
    [anon_sym_convergent] = ACTIONS(967),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(967),
    [anon_sym_hot] = ACTIONS(967),
    [anon_sym_inaccessiblememonly] = ACTIONS(967),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(967),
    [anon_sym_inlinehint] = ACTIONS(967),
    [anon_sym_jumptable] = ACTIONS(967),
    [anon_sym_minsize] = ACTIONS(967),
    [anon_sym_naked] = ACTIONS(967),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(967),
    [anon_sym_nobuiltin] = ACTIONS(967),
    [anon_sym_noduplicate] = ACTIONS(967),
    [anon_sym_nofree] = ACTIONS(967),
    [anon_sym_noimplicitfloat] = ACTIONS(967),
    [anon_sym_noinline] = ACTIONS(967),
    [anon_sym_nomerge] = ACTIONS(967),
    [anon_sym_nonlazybind] = ACTIONS(967),
    [anon_sym_noprofile] = ACTIONS(967),
    [anon_sym_noredzone] = ACTIONS(967),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(967),
    [anon_sym_noreturn] = ACTIONS(967),
    [anon_sym_norecurse] = ACTIONS(967),
    [anon_sym_willreturn] = ACTIONS(967),
    [anon_sym_nosync] = ACTIONS(967),
    [anon_sym_nounwind] = ACTIONS(967),
    [anon_sym_nocallback] = ACTIONS(967),
    [anon_sym_nosanitize_coverage] = ACTIONS(967),
    [anon_sym_null_pointer_is_valid] = ACTIONS(967),
    [anon_sym_optforfuzzing] = ACTIONS(967),
    [anon_sym_optnone] = ACTIONS(967),
    [anon_sym_optsize] = ACTIONS(967),
    [anon_sym_readnone] = ACTIONS(967),
    [anon_sym_readonly] = ACTIONS(967),
    [anon_sym_writeonly] = ACTIONS(967),
    [anon_sym_argmemonly] = ACTIONS(967),
    [anon_sym_returns_twice] = ACTIONS(967),
    [anon_sym_safestack] = ACTIONS(967),
    [anon_sym_sanitize_address] = ACTIONS(967),
    [anon_sym_sanitize_memory] = ACTIONS(967),
    [anon_sym_sanitize_thread] = ACTIONS(967),
    [anon_sym_sanitize_hwaddress] = ACTIONS(967),
    [anon_sym_sanitize_memtag] = ACTIONS(967),
    [anon_sym_speculative_load_hardening] = ACTIONS(967),
    [anon_sym_speculatable] = ACTIONS(967),
    [anon_sym_ssp] = ACTIONS(969),
    [anon_sym_sspstrong] = ACTIONS(967),
    [anon_sym_sspreq] = ACTIONS(967),
    [anon_sym_strictfp] = ACTIONS(967),
    [anon_sym_nocf_check] = ACTIONS(967),
    [anon_sym_shadowcallstack] = ACTIONS(967),
    [anon_sym_mustprogress] = ACTIONS(967),
    [anon_sym_vscale_range] = ACTIONS(967),
    [anon_sym_preallocated] = ACTIONS(967),
    [anon_sym_zeroext] = ACTIONS(967),
    [anon_sym_signext] = ACTIONS(967),
    [anon_sym_inreg] = ACTIONS(967),
    [anon_sym_byval] = ACTIONS(967),
    [anon_sym_byref] = ACTIONS(967),
    [anon_sym_inalloca] = ACTIONS(967),
    [anon_sym_sret] = ACTIONS(967),
    [anon_sym_elementtype] = ACTIONS(967),
    [anon_sym_noalias] = ACTIONS(967),
    [anon_sym_nocapture] = ACTIONS(967),
    [anon_sym_nest] = ACTIONS(967),
    [anon_sym_returned] = ACTIONS(967),
    [anon_sym_nonnull] = ACTIONS(967),
    [anon_sym_dereferenceable] = ACTIONS(969),
    [anon_sym_dereferenceable_or_null] = ACTIONS(967),
    [anon_sym_swiftself] = ACTIONS(969),
    [anon_sym_swiftasync] = ACTIONS(969),
    [anon_sym_swifterror] = ACTIONS(969),
    [anon_sym_immarg] = ACTIONS(967),
    [anon_sym_noundef] = ACTIONS(967),
    [anon_sym_uwtable] = ACTIONS(967),
    [anon_sym_memory] = ACTIONS(967),
  },
  [243] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(971),
    [aux_sym_metadata_ref_token1] = ACTIONS(971),
    [sym_string] = ACTIONS(971),
    [anon_sym_no_cfi] = ACTIONS(971),
    [anon_sym_private] = ACTIONS(971),
    [anon_sym_internal] = ACTIONS(971),
    [anon_sym_weak] = ACTIONS(973),
    [anon_sym_weak_odr] = ACTIONS(971),
    [anon_sym_linkonce] = ACTIONS(973),
    [anon_sym_linkonce_odr] = ACTIONS(971),
    [anon_sym_available_externally] = ACTIONS(971),
    [anon_sym_appending] = ACTIONS(971),
    [anon_sym_common] = ACTIONS(971),
    [anon_sym_extern_weak] = ACTIONS(971),
    [anon_sym_external] = ACTIONS(971),
    [anon_sym_dso_local] = ACTIONS(973),
    [anon_sym_dso_local_equivalent] = ACTIONS(971),
    [anon_sym_dso_preemptable] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(971),
    [anon_sym_hidden] = ACTIONS(971),
    [anon_sym_protected] = ACTIONS(971),
    [anon_sym_dllimport] = ACTIONS(971),
    [anon_sym_dllexport] = ACTIONS(971),
    [anon_sym_ccc] = ACTIONS(971),
    [anon_sym_fastcc] = ACTIONS(971),
    [anon_sym_coldcc] = ACTIONS(971),
    [anon_sym_webkit_jscc] = ACTIONS(973),
    [anon_sym_anyregcc] = ACTIONS(971),
    [anon_sym_preserve_mostcc] = ACTIONS(971),
    [anon_sym_preserve_allcc] = ACTIONS(971),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(973),
    [anon_sym_tailcc] = ACTIONS(971),
    [anon_sym_swiftcc] = ACTIONS(973),
    [anon_sym_swifttailcc] = ACTIONS(973),
    [anon_sym_cfguard_checkcc] = ACTIONS(971),
    [aux_sym_calling_conv_token1] = ACTIONS(973),
    [aux_sym_calling_conv_token2] = ACTIONS(971),
    [aux_sym_calling_conv_token3] = ACTIONS(971),
    [aux_sym_calling_conv_token4] = ACTIONS(971),
    [aux_sym_calling_conv_token5] = ACTIONS(971),
    [aux_sym_calling_conv_token6] = ACTIONS(971),
    [aux_sym_calling_conv_token7] = ACTIONS(971),
    [aux_sym_calling_conv_token8] = ACTIONS(971),
    [aux_sym_calling_conv_token9] = ACTIONS(971),
    [aux_sym_calling_conv_token10] = ACTIONS(973),
    [anon_sym_ghccc] = ACTIONS(971),
    [aux_sym_calling_conv_token11] = ACTIONS(973),
    [aux_sym_calling_conv_token12] = ACTIONS(971),
    [aux_sym_calling_conv_token13] = ACTIONS(973),
    [aux_sym_calling_conv_token14] = ACTIONS(971),
    [anon_sym_cc] = ACTIONS(973),
    [anon_sym_unnamed_addr] = ACTIONS(971),
    [anon_sym_local_unnamed_addr] = ACTIONS(971),
    [anon_sym_void] = ACTIONS(971),
    [anon_sym_half] = ACTIONS(971),
    [anon_sym_bfloat] = ACTIONS(971),
    [anon_sym_float] = ACTIONS(971),
    [anon_sym_double] = ACTIONS(971),
    [anon_sym_x86_fp80] = ACTIONS(973),
    [anon_sym_fp128] = ACTIONS(971),
    [anon_sym_ppc_fp128] = ACTIONS(971),
    [anon_sym_label] = ACTIONS(971),
    [anon_sym_metadata] = ACTIONS(971),
    [anon_sym_x86_mmx] = ACTIONS(973),
    [anon_sym_x86_amx] = ACTIONS(973),
    [anon_sym_token] = ACTIONS(971),
    [anon_sym_opaque] = ACTIONS(971),
    [anon_sym_ptr] = ACTIONS(971),
    [aux_sym_type_keyword_token1] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(971),
    [anon_sym_LT_LBRACE] = ACTIONS(971),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_align] = ACTIONS(973),
    [anon_sym_alignstack] = ACTIONS(971),
    [anon_sym_allocsize] = ACTIONS(971),
    [anon_sym_alwaysinline] = ACTIONS(971),
    [anon_sym_builtin] = ACTIONS(971),
    [anon_sym_cold] = ACTIONS(973),
    [anon_sym_convergent] = ACTIONS(971),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(971),
    [anon_sym_hot] = ACTIONS(971),
    [anon_sym_inaccessiblememonly] = ACTIONS(971),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(971),
    [anon_sym_inlinehint] = ACTIONS(971),
    [anon_sym_jumptable] = ACTIONS(971),
    [anon_sym_minsize] = ACTIONS(971),
    [anon_sym_naked] = ACTIONS(971),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(971),
    [anon_sym_nobuiltin] = ACTIONS(971),
    [anon_sym_noduplicate] = ACTIONS(971),
    [anon_sym_nofree] = ACTIONS(971),
    [anon_sym_noimplicitfloat] = ACTIONS(971),
    [anon_sym_noinline] = ACTIONS(971),
    [anon_sym_nomerge] = ACTIONS(971),
    [anon_sym_nonlazybind] = ACTIONS(971),
    [anon_sym_noprofile] = ACTIONS(971),
    [anon_sym_noredzone] = ACTIONS(971),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(971),
    [anon_sym_noreturn] = ACTIONS(971),
    [anon_sym_norecurse] = ACTIONS(971),
    [anon_sym_willreturn] = ACTIONS(971),
    [anon_sym_nosync] = ACTIONS(971),
    [anon_sym_nounwind] = ACTIONS(971),
    [anon_sym_nocallback] = ACTIONS(971),
    [anon_sym_nosanitize_coverage] = ACTIONS(971),
    [anon_sym_null_pointer_is_valid] = ACTIONS(971),
    [anon_sym_optforfuzzing] = ACTIONS(971),
    [anon_sym_optnone] = ACTIONS(971),
    [anon_sym_optsize] = ACTIONS(971),
    [anon_sym_readnone] = ACTIONS(971),
    [anon_sym_readonly] = ACTIONS(971),
    [anon_sym_writeonly] = ACTIONS(971),
    [anon_sym_argmemonly] = ACTIONS(971),
    [anon_sym_returns_twice] = ACTIONS(971),
    [anon_sym_safestack] = ACTIONS(971),
    [anon_sym_sanitize_address] = ACTIONS(971),
    [anon_sym_sanitize_memory] = ACTIONS(971),
    [anon_sym_sanitize_thread] = ACTIONS(971),
    [anon_sym_sanitize_hwaddress] = ACTIONS(971),
    [anon_sym_sanitize_memtag] = ACTIONS(971),
    [anon_sym_speculative_load_hardening] = ACTIONS(971),
    [anon_sym_speculatable] = ACTIONS(971),
    [anon_sym_ssp] = ACTIONS(973),
    [anon_sym_sspstrong] = ACTIONS(971),
    [anon_sym_sspreq] = ACTIONS(971),
    [anon_sym_strictfp] = ACTIONS(971),
    [anon_sym_nocf_check] = ACTIONS(971),
    [anon_sym_shadowcallstack] = ACTIONS(971),
    [anon_sym_mustprogress] = ACTIONS(971),
    [anon_sym_vscale_range] = ACTIONS(971),
    [anon_sym_preallocated] = ACTIONS(971),
    [anon_sym_zeroext] = ACTIONS(971),
    [anon_sym_signext] = ACTIONS(971),
    [anon_sym_inreg] = ACTIONS(971),
    [anon_sym_byval] = ACTIONS(971),
    [anon_sym_byref] = ACTIONS(971),
    [anon_sym_inalloca] = ACTIONS(971),
    [anon_sym_sret] = ACTIONS(971),
    [anon_sym_elementtype] = ACTIONS(971),
    [anon_sym_noalias] = ACTIONS(971),
    [anon_sym_nocapture] = ACTIONS(971),
    [anon_sym_nest] = ACTIONS(971),
    [anon_sym_returned] = ACTIONS(971),
    [anon_sym_nonnull] = ACTIONS(971),
    [anon_sym_dereferenceable] = ACTIONS(973),
    [anon_sym_dereferenceable_or_null] = ACTIONS(971),
    [anon_sym_swiftself] = ACTIONS(973),
    [anon_sym_swiftasync] = ACTIONS(973),
    [anon_sym_swifterror] = ACTIONS(973),
    [anon_sym_immarg] = ACTIONS(971),
    [anon_sym_noundef] = ACTIONS(971),
    [anon_sym_uwtable] = ACTIONS(971),
    [anon_sym_memory] = ACTIONS(971),
  },
  [244] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(975),
    [sym_local_var] = ACTIONS(975),
    [sym_string] = ACTIONS(975),
    [anon_sym_no_cfi] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_internal] = ACTIONS(975),
    [anon_sym_weak] = ACTIONS(977),
    [anon_sym_weak_odr] = ACTIONS(975),
    [anon_sym_linkonce] = ACTIONS(977),
    [anon_sym_linkonce_odr] = ACTIONS(975),
    [anon_sym_available_externally] = ACTIONS(975),
    [anon_sym_appending] = ACTIONS(975),
    [anon_sym_common] = ACTIONS(975),
    [anon_sym_extern_weak] = ACTIONS(975),
    [anon_sym_external] = ACTIONS(975),
    [anon_sym_dso_local] = ACTIONS(977),
    [anon_sym_dso_local_equivalent] = ACTIONS(975),
    [anon_sym_dso_preemptable] = ACTIONS(975),
    [anon_sym_default] = ACTIONS(975),
    [anon_sym_hidden] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_dllimport] = ACTIONS(975),
    [anon_sym_dllexport] = ACTIONS(975),
    [anon_sym_ccc] = ACTIONS(975),
    [anon_sym_fastcc] = ACTIONS(975),
    [anon_sym_coldcc] = ACTIONS(975),
    [anon_sym_webkit_jscc] = ACTIONS(977),
    [anon_sym_anyregcc] = ACTIONS(975),
    [anon_sym_preserve_mostcc] = ACTIONS(975),
    [anon_sym_preserve_allcc] = ACTIONS(975),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(977),
    [anon_sym_tailcc] = ACTIONS(975),
    [anon_sym_swiftcc] = ACTIONS(977),
    [anon_sym_swifttailcc] = ACTIONS(977),
    [anon_sym_cfguard_checkcc] = ACTIONS(975),
    [aux_sym_calling_conv_token1] = ACTIONS(977),
    [aux_sym_calling_conv_token2] = ACTIONS(975),
    [aux_sym_calling_conv_token3] = ACTIONS(975),
    [aux_sym_calling_conv_token4] = ACTIONS(975),
    [aux_sym_calling_conv_token5] = ACTIONS(975),
    [aux_sym_calling_conv_token6] = ACTIONS(975),
    [aux_sym_calling_conv_token7] = ACTIONS(975),
    [aux_sym_calling_conv_token8] = ACTIONS(975),
    [aux_sym_calling_conv_token9] = ACTIONS(975),
    [aux_sym_calling_conv_token10] = ACTIONS(977),
    [anon_sym_ghccc] = ACTIONS(975),
    [aux_sym_calling_conv_token11] = ACTIONS(977),
    [aux_sym_calling_conv_token12] = ACTIONS(975),
    [aux_sym_calling_conv_token13] = ACTIONS(977),
    [aux_sym_calling_conv_token14] = ACTIONS(975),
    [anon_sym_cc] = ACTIONS(977),
    [anon_sym_unnamed_addr] = ACTIONS(975),
    [anon_sym_local_unnamed_addr] = ACTIONS(975),
    [anon_sym_void] = ACTIONS(975),
    [anon_sym_half] = ACTIONS(975),
    [anon_sym_bfloat] = ACTIONS(975),
    [anon_sym_float] = ACTIONS(975),
    [anon_sym_double] = ACTIONS(975),
    [anon_sym_x86_fp80] = ACTIONS(977),
    [anon_sym_fp128] = ACTIONS(975),
    [anon_sym_ppc_fp128] = ACTIONS(975),
    [anon_sym_label] = ACTIONS(975),
    [anon_sym_metadata] = ACTIONS(975),
    [anon_sym_x86_mmx] = ACTIONS(977),
    [anon_sym_x86_amx] = ACTIONS(977),
    [anon_sym_token] = ACTIONS(975),
    [anon_sym_opaque] = ACTIONS(975),
    [anon_sym_ptr] = ACTIONS(975),
    [aux_sym_type_keyword_token1] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(975),
    [anon_sym_LT_LBRACE] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(975),
    [anon_sym_LT] = ACTIONS(977),
    [anon_sym_align] = ACTIONS(977),
    [anon_sym_alignstack] = ACTIONS(975),
    [anon_sym_allocsize] = ACTIONS(975),
    [anon_sym_alwaysinline] = ACTIONS(975),
    [anon_sym_builtin] = ACTIONS(975),
    [anon_sym_cold] = ACTIONS(977),
    [anon_sym_convergent] = ACTIONS(975),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(975),
    [anon_sym_hot] = ACTIONS(975),
    [anon_sym_inaccessiblememonly] = ACTIONS(975),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(975),
    [anon_sym_inlinehint] = ACTIONS(975),
    [anon_sym_jumptable] = ACTIONS(975),
    [anon_sym_minsize] = ACTIONS(975),
    [anon_sym_naked] = ACTIONS(975),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(975),
    [anon_sym_nobuiltin] = ACTIONS(975),
    [anon_sym_noduplicate] = ACTIONS(975),
    [anon_sym_nofree] = ACTIONS(975),
    [anon_sym_noimplicitfloat] = ACTIONS(975),
    [anon_sym_noinline] = ACTIONS(975),
    [anon_sym_nomerge] = ACTIONS(975),
    [anon_sym_nonlazybind] = ACTIONS(975),
    [anon_sym_noprofile] = ACTIONS(975),
    [anon_sym_noredzone] = ACTIONS(975),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(975),
    [anon_sym_noreturn] = ACTIONS(975),
    [anon_sym_norecurse] = ACTIONS(975),
    [anon_sym_willreturn] = ACTIONS(975),
    [anon_sym_nosync] = ACTIONS(975),
    [anon_sym_nounwind] = ACTIONS(975),
    [anon_sym_nocallback] = ACTIONS(975),
    [anon_sym_nosanitize_coverage] = ACTIONS(975),
    [anon_sym_null_pointer_is_valid] = ACTIONS(975),
    [anon_sym_optforfuzzing] = ACTIONS(975),
    [anon_sym_optnone] = ACTIONS(975),
    [anon_sym_optsize] = ACTIONS(975),
    [anon_sym_readnone] = ACTIONS(975),
    [anon_sym_readonly] = ACTIONS(975),
    [anon_sym_writeonly] = ACTIONS(975),
    [anon_sym_argmemonly] = ACTIONS(975),
    [anon_sym_returns_twice] = ACTIONS(975),
    [anon_sym_safestack] = ACTIONS(975),
    [anon_sym_sanitize_address] = ACTIONS(975),
    [anon_sym_sanitize_memory] = ACTIONS(975),
    [anon_sym_sanitize_thread] = ACTIONS(975),
    [anon_sym_sanitize_hwaddress] = ACTIONS(975),
    [anon_sym_sanitize_memtag] = ACTIONS(975),
    [anon_sym_speculative_load_hardening] = ACTIONS(975),
    [anon_sym_speculatable] = ACTIONS(975),
    [anon_sym_ssp] = ACTIONS(977),
    [anon_sym_sspstrong] = ACTIONS(975),
    [anon_sym_sspreq] = ACTIONS(975),
    [anon_sym_strictfp] = ACTIONS(975),
    [anon_sym_nocf_check] = ACTIONS(975),
    [anon_sym_shadowcallstack] = ACTIONS(975),
    [anon_sym_mustprogress] = ACTIONS(975),
    [anon_sym_vscale_range] = ACTIONS(975),
    [anon_sym_preallocated] = ACTIONS(975),
    [anon_sym_zeroext] = ACTIONS(975),
    [anon_sym_signext] = ACTIONS(975),
    [anon_sym_inreg] = ACTIONS(975),
    [anon_sym_byval] = ACTIONS(975),
    [anon_sym_byref] = ACTIONS(975),
    [anon_sym_inalloca] = ACTIONS(975),
    [anon_sym_sret] = ACTIONS(975),
    [anon_sym_elementtype] = ACTIONS(975),
    [anon_sym_noalias] = ACTIONS(975),
    [anon_sym_nocapture] = ACTIONS(975),
    [anon_sym_nest] = ACTIONS(975),
    [anon_sym_returned] = ACTIONS(975),
    [anon_sym_nonnull] = ACTIONS(975),
    [anon_sym_dereferenceable] = ACTIONS(977),
    [anon_sym_dereferenceable_or_null] = ACTIONS(975),
    [anon_sym_swiftself] = ACTIONS(977),
    [anon_sym_swiftasync] = ACTIONS(977),
    [anon_sym_swifterror] = ACTIONS(977),
    [anon_sym_immarg] = ACTIONS(975),
    [anon_sym_noundef] = ACTIONS(975),
    [anon_sym_uwtable] = ACTIONS(975),
    [anon_sym_memory] = ACTIONS(975),
  },
  [245] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(979),
    [sym_local_var] = ACTIONS(979),
    [sym_string] = ACTIONS(979),
    [anon_sym_no_cfi] = ACTIONS(979),
    [anon_sym_private] = ACTIONS(979),
    [anon_sym_internal] = ACTIONS(979),
    [anon_sym_weak] = ACTIONS(981),
    [anon_sym_weak_odr] = ACTIONS(979),
    [anon_sym_linkonce] = ACTIONS(981),
    [anon_sym_linkonce_odr] = ACTIONS(979),
    [anon_sym_available_externally] = ACTIONS(979),
    [anon_sym_appending] = ACTIONS(979),
    [anon_sym_common] = ACTIONS(979),
    [anon_sym_extern_weak] = ACTIONS(979),
    [anon_sym_external] = ACTIONS(979),
    [anon_sym_dso_local] = ACTIONS(981),
    [anon_sym_dso_local_equivalent] = ACTIONS(979),
    [anon_sym_dso_preemptable] = ACTIONS(979),
    [anon_sym_default] = ACTIONS(979),
    [anon_sym_hidden] = ACTIONS(979),
    [anon_sym_protected] = ACTIONS(979),
    [anon_sym_dllimport] = ACTIONS(979),
    [anon_sym_dllexport] = ACTIONS(979),
    [anon_sym_ccc] = ACTIONS(979),
    [anon_sym_fastcc] = ACTIONS(979),
    [anon_sym_coldcc] = ACTIONS(979),
    [anon_sym_webkit_jscc] = ACTIONS(981),
    [anon_sym_anyregcc] = ACTIONS(979),
    [anon_sym_preserve_mostcc] = ACTIONS(979),
    [anon_sym_preserve_allcc] = ACTIONS(979),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(981),
    [anon_sym_tailcc] = ACTIONS(979),
    [anon_sym_swiftcc] = ACTIONS(981),
    [anon_sym_swifttailcc] = ACTIONS(981),
    [anon_sym_cfguard_checkcc] = ACTIONS(979),
    [aux_sym_calling_conv_token1] = ACTIONS(981),
    [aux_sym_calling_conv_token2] = ACTIONS(979),
    [aux_sym_calling_conv_token3] = ACTIONS(979),
    [aux_sym_calling_conv_token4] = ACTIONS(979),
    [aux_sym_calling_conv_token5] = ACTIONS(979),
    [aux_sym_calling_conv_token6] = ACTIONS(979),
    [aux_sym_calling_conv_token7] = ACTIONS(979),
    [aux_sym_calling_conv_token8] = ACTIONS(979),
    [aux_sym_calling_conv_token9] = ACTIONS(979),
    [aux_sym_calling_conv_token10] = ACTIONS(981),
    [anon_sym_ghccc] = ACTIONS(979),
    [aux_sym_calling_conv_token11] = ACTIONS(981),
    [aux_sym_calling_conv_token12] = ACTIONS(979),
    [aux_sym_calling_conv_token13] = ACTIONS(981),
    [aux_sym_calling_conv_token14] = ACTIONS(979),
    [anon_sym_cc] = ACTIONS(981),
    [anon_sym_unnamed_addr] = ACTIONS(979),
    [anon_sym_local_unnamed_addr] = ACTIONS(979),
    [anon_sym_void] = ACTIONS(979),
    [anon_sym_half] = ACTIONS(979),
    [anon_sym_bfloat] = ACTIONS(979),
    [anon_sym_float] = ACTIONS(979),
    [anon_sym_double] = ACTIONS(979),
    [anon_sym_x86_fp80] = ACTIONS(981),
    [anon_sym_fp128] = ACTIONS(979),
    [anon_sym_ppc_fp128] = ACTIONS(979),
    [anon_sym_label] = ACTIONS(979),
    [anon_sym_metadata] = ACTIONS(979),
    [anon_sym_x86_mmx] = ACTIONS(981),
    [anon_sym_x86_amx] = ACTIONS(981),
    [anon_sym_token] = ACTIONS(979),
    [anon_sym_opaque] = ACTIONS(979),
    [anon_sym_ptr] = ACTIONS(979),
    [aux_sym_type_keyword_token1] = ACTIONS(979),
    [anon_sym_LBRACE] = ACTIONS(979),
    [anon_sym_LT_LBRACE] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(979),
    [anon_sym_LT] = ACTIONS(981),
    [anon_sym_align] = ACTIONS(981),
    [anon_sym_alignstack] = ACTIONS(979),
    [anon_sym_allocsize] = ACTIONS(979),
    [anon_sym_alwaysinline] = ACTIONS(979),
    [anon_sym_builtin] = ACTIONS(979),
    [anon_sym_cold] = ACTIONS(981),
    [anon_sym_convergent] = ACTIONS(979),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(979),
    [anon_sym_hot] = ACTIONS(979),
    [anon_sym_inaccessiblememonly] = ACTIONS(979),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(979),
    [anon_sym_inlinehint] = ACTIONS(979),
    [anon_sym_jumptable] = ACTIONS(979),
    [anon_sym_minsize] = ACTIONS(979),
    [anon_sym_naked] = ACTIONS(979),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(979),
    [anon_sym_nobuiltin] = ACTIONS(979),
    [anon_sym_noduplicate] = ACTIONS(979),
    [anon_sym_nofree] = ACTIONS(979),
    [anon_sym_noimplicitfloat] = ACTIONS(979),
    [anon_sym_noinline] = ACTIONS(979),
    [anon_sym_nomerge] = ACTIONS(979),
    [anon_sym_nonlazybind] = ACTIONS(979),
    [anon_sym_noprofile] = ACTIONS(979),
    [anon_sym_noredzone] = ACTIONS(979),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(979),
    [anon_sym_noreturn] = ACTIONS(979),
    [anon_sym_norecurse] = ACTIONS(979),
    [anon_sym_willreturn] = ACTIONS(979),
    [anon_sym_nosync] = ACTIONS(979),
    [anon_sym_nounwind] = ACTIONS(979),
    [anon_sym_nocallback] = ACTIONS(979),
    [anon_sym_nosanitize_coverage] = ACTIONS(979),
    [anon_sym_null_pointer_is_valid] = ACTIONS(979),
    [anon_sym_optforfuzzing] = ACTIONS(979),
    [anon_sym_optnone] = ACTIONS(979),
    [anon_sym_optsize] = ACTIONS(979),
    [anon_sym_readnone] = ACTIONS(979),
    [anon_sym_readonly] = ACTIONS(979),
    [anon_sym_writeonly] = ACTIONS(979),
    [anon_sym_argmemonly] = ACTIONS(979),
    [anon_sym_returns_twice] = ACTIONS(979),
    [anon_sym_safestack] = ACTIONS(979),
    [anon_sym_sanitize_address] = ACTIONS(979),
    [anon_sym_sanitize_memory] = ACTIONS(979),
    [anon_sym_sanitize_thread] = ACTIONS(979),
    [anon_sym_sanitize_hwaddress] = ACTIONS(979),
    [anon_sym_sanitize_memtag] = ACTIONS(979),
    [anon_sym_speculative_load_hardening] = ACTIONS(979),
    [anon_sym_speculatable] = ACTIONS(979),
    [anon_sym_ssp] = ACTIONS(981),
    [anon_sym_sspstrong] = ACTIONS(979),
    [anon_sym_sspreq] = ACTIONS(979),
    [anon_sym_strictfp] = ACTIONS(979),
    [anon_sym_nocf_check] = ACTIONS(979),
    [anon_sym_shadowcallstack] = ACTIONS(979),
    [anon_sym_mustprogress] = ACTIONS(979),
    [anon_sym_vscale_range] = ACTIONS(979),
    [anon_sym_preallocated] = ACTIONS(979),
    [anon_sym_zeroext] = ACTIONS(979),
    [anon_sym_signext] = ACTIONS(979),
    [anon_sym_inreg] = ACTIONS(979),
    [anon_sym_byval] = ACTIONS(979),
    [anon_sym_byref] = ACTIONS(979),
    [anon_sym_inalloca] = ACTIONS(979),
    [anon_sym_sret] = ACTIONS(979),
    [anon_sym_elementtype] = ACTIONS(979),
    [anon_sym_noalias] = ACTIONS(979),
    [anon_sym_nocapture] = ACTIONS(979),
    [anon_sym_nest] = ACTIONS(979),
    [anon_sym_returned] = ACTIONS(979),
    [anon_sym_nonnull] = ACTIONS(979),
    [anon_sym_dereferenceable] = ACTIONS(981),
    [anon_sym_dereferenceable_or_null] = ACTIONS(979),
    [anon_sym_swiftself] = ACTIONS(981),
    [anon_sym_swiftasync] = ACTIONS(981),
    [anon_sym_swifterror] = ACTIONS(981),
    [anon_sym_immarg] = ACTIONS(979),
    [anon_sym_noundef] = ACTIONS(979),
    [anon_sym_uwtable] = ACTIONS(979),
    [anon_sym_memory] = ACTIONS(979),
  },
  [246] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(713),
    [aux_sym_metadata_ref_token1] = ACTIONS(713),
    [sym_string] = ACTIONS(713),
    [anon_sym_no_cfi] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_internal] = ACTIONS(713),
    [anon_sym_weak] = ACTIONS(715),
    [anon_sym_weak_odr] = ACTIONS(713),
    [anon_sym_linkonce] = ACTIONS(715),
    [anon_sym_linkonce_odr] = ACTIONS(713),
    [anon_sym_available_externally] = ACTIONS(713),
    [anon_sym_appending] = ACTIONS(713),
    [anon_sym_common] = ACTIONS(713),
    [anon_sym_extern_weak] = ACTIONS(713),
    [anon_sym_external] = ACTIONS(713),
    [anon_sym_dso_local] = ACTIONS(715),
    [anon_sym_dso_local_equivalent] = ACTIONS(713),
    [anon_sym_dso_preemptable] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(713),
    [anon_sym_hidden] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_dllimport] = ACTIONS(713),
    [anon_sym_dllexport] = ACTIONS(713),
    [anon_sym_ccc] = ACTIONS(713),
    [anon_sym_fastcc] = ACTIONS(713),
    [anon_sym_coldcc] = ACTIONS(713),
    [anon_sym_webkit_jscc] = ACTIONS(715),
    [anon_sym_anyregcc] = ACTIONS(713),
    [anon_sym_preserve_mostcc] = ACTIONS(713),
    [anon_sym_preserve_allcc] = ACTIONS(713),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(715),
    [anon_sym_tailcc] = ACTIONS(713),
    [anon_sym_swiftcc] = ACTIONS(715),
    [anon_sym_swifttailcc] = ACTIONS(715),
    [anon_sym_cfguard_checkcc] = ACTIONS(713),
    [aux_sym_calling_conv_token1] = ACTIONS(715),
    [aux_sym_calling_conv_token2] = ACTIONS(713),
    [aux_sym_calling_conv_token3] = ACTIONS(713),
    [aux_sym_calling_conv_token4] = ACTIONS(713),
    [aux_sym_calling_conv_token5] = ACTIONS(713),
    [aux_sym_calling_conv_token6] = ACTIONS(713),
    [aux_sym_calling_conv_token7] = ACTIONS(713),
    [aux_sym_calling_conv_token8] = ACTIONS(713),
    [aux_sym_calling_conv_token9] = ACTIONS(713),
    [aux_sym_calling_conv_token10] = ACTIONS(715),
    [anon_sym_ghccc] = ACTIONS(713),
    [aux_sym_calling_conv_token11] = ACTIONS(715),
    [aux_sym_calling_conv_token12] = ACTIONS(713),
    [aux_sym_calling_conv_token13] = ACTIONS(715),
    [aux_sym_calling_conv_token14] = ACTIONS(713),
    [anon_sym_cc] = ACTIONS(715),
    [anon_sym_unnamed_addr] = ACTIONS(713),
    [anon_sym_local_unnamed_addr] = ACTIONS(713),
    [anon_sym_void] = ACTIONS(713),
    [anon_sym_half] = ACTIONS(713),
    [anon_sym_bfloat] = ACTIONS(713),
    [anon_sym_float] = ACTIONS(713),
    [anon_sym_double] = ACTIONS(713),
    [anon_sym_x86_fp80] = ACTIONS(715),
    [anon_sym_fp128] = ACTIONS(713),
    [anon_sym_ppc_fp128] = ACTIONS(713),
    [anon_sym_label] = ACTIONS(713),
    [anon_sym_metadata] = ACTIONS(713),
    [anon_sym_x86_mmx] = ACTIONS(715),
    [anon_sym_x86_amx] = ACTIONS(715),
    [anon_sym_token] = ACTIONS(713),
    [anon_sym_opaque] = ACTIONS(713),
    [anon_sym_ptr] = ACTIONS(713),
    [aux_sym_type_keyword_token1] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(713),
    [anon_sym_LT_LBRACE] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_align] = ACTIONS(715),
    [anon_sym_alignstack] = ACTIONS(713),
    [anon_sym_allocsize] = ACTIONS(713),
    [anon_sym_alwaysinline] = ACTIONS(713),
    [anon_sym_builtin] = ACTIONS(713),
    [anon_sym_cold] = ACTIONS(715),
    [anon_sym_convergent] = ACTIONS(713),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(713),
    [anon_sym_hot] = ACTIONS(713),
    [anon_sym_inaccessiblememonly] = ACTIONS(713),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(713),
    [anon_sym_inlinehint] = ACTIONS(713),
    [anon_sym_jumptable] = ACTIONS(713),
    [anon_sym_minsize] = ACTIONS(713),
    [anon_sym_naked] = ACTIONS(713),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(713),
    [anon_sym_nobuiltin] = ACTIONS(713),
    [anon_sym_noduplicate] = ACTIONS(713),
    [anon_sym_nofree] = ACTIONS(713),
    [anon_sym_noimplicitfloat] = ACTIONS(713),
    [anon_sym_noinline] = ACTIONS(713),
    [anon_sym_nomerge] = ACTIONS(713),
    [anon_sym_nonlazybind] = ACTIONS(713),
    [anon_sym_noprofile] = ACTIONS(713),
    [anon_sym_noredzone] = ACTIONS(713),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(713),
    [anon_sym_noreturn] = ACTIONS(713),
    [anon_sym_norecurse] = ACTIONS(713),
    [anon_sym_willreturn] = ACTIONS(713),
    [anon_sym_nosync] = ACTIONS(713),
    [anon_sym_nounwind] = ACTIONS(713),
    [anon_sym_nocallback] = ACTIONS(713),
    [anon_sym_nosanitize_coverage] = ACTIONS(713),
    [anon_sym_null_pointer_is_valid] = ACTIONS(713),
    [anon_sym_optforfuzzing] = ACTIONS(713),
    [anon_sym_optnone] = ACTIONS(713),
    [anon_sym_optsize] = ACTIONS(713),
    [anon_sym_readnone] = ACTIONS(713),
    [anon_sym_readonly] = ACTIONS(713),
    [anon_sym_writeonly] = ACTIONS(713),
    [anon_sym_argmemonly] = ACTIONS(713),
    [anon_sym_returns_twice] = ACTIONS(713),
    [anon_sym_safestack] = ACTIONS(713),
    [anon_sym_sanitize_address] = ACTIONS(713),
    [anon_sym_sanitize_memory] = ACTIONS(713),
    [anon_sym_sanitize_thread] = ACTIONS(713),
    [anon_sym_sanitize_hwaddress] = ACTIONS(713),
    [anon_sym_sanitize_memtag] = ACTIONS(713),
    [anon_sym_speculative_load_hardening] = ACTIONS(713),
    [anon_sym_speculatable] = ACTIONS(713),
    [anon_sym_ssp] = ACTIONS(715),
    [anon_sym_sspstrong] = ACTIONS(713),
    [anon_sym_sspreq] = ACTIONS(713),
    [anon_sym_strictfp] = ACTIONS(713),
    [anon_sym_nocf_check] = ACTIONS(713),
    [anon_sym_shadowcallstack] = ACTIONS(713),
    [anon_sym_mustprogress] = ACTIONS(713),
    [anon_sym_vscale_range] = ACTIONS(713),
    [anon_sym_preallocated] = ACTIONS(713),
    [anon_sym_zeroext] = ACTIONS(713),
    [anon_sym_signext] = ACTIONS(713),
    [anon_sym_inreg] = ACTIONS(713),
    [anon_sym_byval] = ACTIONS(713),
    [anon_sym_byref] = ACTIONS(713),
    [anon_sym_inalloca] = ACTIONS(713),
    [anon_sym_sret] = ACTIONS(713),
    [anon_sym_elementtype] = ACTIONS(713),
    [anon_sym_noalias] = ACTIONS(713),
    [anon_sym_nocapture] = ACTIONS(713),
    [anon_sym_nest] = ACTIONS(713),
    [anon_sym_returned] = ACTIONS(713),
    [anon_sym_nonnull] = ACTIONS(713),
    [anon_sym_dereferenceable] = ACTIONS(715),
    [anon_sym_dereferenceable_or_null] = ACTIONS(713),
    [anon_sym_swiftself] = ACTIONS(715),
    [anon_sym_swiftasync] = ACTIONS(715),
    [anon_sym_swifterror] = ACTIONS(715),
    [anon_sym_immarg] = ACTIONS(713),
    [anon_sym_noundef] = ACTIONS(713),
    [anon_sym_uwtable] = ACTIONS(713),
    [anon_sym_memory] = ACTIONS(713),
  },
  [247] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(983),
    [sym_local_var] = ACTIONS(983),
    [sym_string] = ACTIONS(983),
    [anon_sym_no_cfi] = ACTIONS(983),
    [anon_sym_private] = ACTIONS(983),
    [anon_sym_internal] = ACTIONS(983),
    [anon_sym_weak] = ACTIONS(985),
    [anon_sym_weak_odr] = ACTIONS(983),
    [anon_sym_linkonce] = ACTIONS(985),
    [anon_sym_linkonce_odr] = ACTIONS(983),
    [anon_sym_available_externally] = ACTIONS(983),
    [anon_sym_appending] = ACTIONS(983),
    [anon_sym_common] = ACTIONS(983),
    [anon_sym_extern_weak] = ACTIONS(983),
    [anon_sym_external] = ACTIONS(983),
    [anon_sym_dso_local] = ACTIONS(985),
    [anon_sym_dso_local_equivalent] = ACTIONS(983),
    [anon_sym_dso_preemptable] = ACTIONS(983),
    [anon_sym_default] = ACTIONS(983),
    [anon_sym_hidden] = ACTIONS(983),
    [anon_sym_protected] = ACTIONS(983),
    [anon_sym_dllimport] = ACTIONS(983),
    [anon_sym_dllexport] = ACTIONS(983),
    [anon_sym_ccc] = ACTIONS(983),
    [anon_sym_fastcc] = ACTIONS(983),
    [anon_sym_coldcc] = ACTIONS(983),
    [anon_sym_webkit_jscc] = ACTIONS(985),
    [anon_sym_anyregcc] = ACTIONS(983),
    [anon_sym_preserve_mostcc] = ACTIONS(983),
    [anon_sym_preserve_allcc] = ACTIONS(983),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(985),
    [anon_sym_tailcc] = ACTIONS(983),
    [anon_sym_swiftcc] = ACTIONS(985),
    [anon_sym_swifttailcc] = ACTIONS(985),
    [anon_sym_cfguard_checkcc] = ACTIONS(983),
    [aux_sym_calling_conv_token1] = ACTIONS(985),
    [aux_sym_calling_conv_token2] = ACTIONS(983),
    [aux_sym_calling_conv_token3] = ACTIONS(983),
    [aux_sym_calling_conv_token4] = ACTIONS(983),
    [aux_sym_calling_conv_token5] = ACTIONS(983),
    [aux_sym_calling_conv_token6] = ACTIONS(983),
    [aux_sym_calling_conv_token7] = ACTIONS(983),
    [aux_sym_calling_conv_token8] = ACTIONS(983),
    [aux_sym_calling_conv_token9] = ACTIONS(983),
    [aux_sym_calling_conv_token10] = ACTIONS(985),
    [anon_sym_ghccc] = ACTIONS(983),
    [aux_sym_calling_conv_token11] = ACTIONS(985),
    [aux_sym_calling_conv_token12] = ACTIONS(983),
    [aux_sym_calling_conv_token13] = ACTIONS(985),
    [aux_sym_calling_conv_token14] = ACTIONS(983),
    [anon_sym_cc] = ACTIONS(985),
    [anon_sym_unnamed_addr] = ACTIONS(983),
    [anon_sym_local_unnamed_addr] = ACTIONS(983),
    [anon_sym_void] = ACTIONS(983),
    [anon_sym_half] = ACTIONS(983),
    [anon_sym_bfloat] = ACTIONS(983),
    [anon_sym_float] = ACTIONS(983),
    [anon_sym_double] = ACTIONS(983),
    [anon_sym_x86_fp80] = ACTIONS(985),
    [anon_sym_fp128] = ACTIONS(983),
    [anon_sym_ppc_fp128] = ACTIONS(983),
    [anon_sym_label] = ACTIONS(983),
    [anon_sym_metadata] = ACTIONS(983),
    [anon_sym_x86_mmx] = ACTIONS(985),
    [anon_sym_x86_amx] = ACTIONS(985),
    [anon_sym_token] = ACTIONS(983),
    [anon_sym_opaque] = ACTIONS(983),
    [anon_sym_ptr] = ACTIONS(983),
    [aux_sym_type_keyword_token1] = ACTIONS(983),
    [anon_sym_LBRACE] = ACTIONS(983),
    [anon_sym_LT_LBRACE] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_align] = ACTIONS(985),
    [anon_sym_alignstack] = ACTIONS(983),
    [anon_sym_allocsize] = ACTIONS(983),
    [anon_sym_alwaysinline] = ACTIONS(983),
    [anon_sym_builtin] = ACTIONS(983),
    [anon_sym_cold] = ACTIONS(985),
    [anon_sym_convergent] = ACTIONS(983),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(983),
    [anon_sym_hot] = ACTIONS(983),
    [anon_sym_inaccessiblememonly] = ACTIONS(983),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(983),
    [anon_sym_inlinehint] = ACTIONS(983),
    [anon_sym_jumptable] = ACTIONS(983),
    [anon_sym_minsize] = ACTIONS(983),
    [anon_sym_naked] = ACTIONS(983),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(983),
    [anon_sym_nobuiltin] = ACTIONS(983),
    [anon_sym_noduplicate] = ACTIONS(983),
    [anon_sym_nofree] = ACTIONS(983),
    [anon_sym_noimplicitfloat] = ACTIONS(983),
    [anon_sym_noinline] = ACTIONS(983),
    [anon_sym_nomerge] = ACTIONS(983),
    [anon_sym_nonlazybind] = ACTIONS(983),
    [anon_sym_noprofile] = ACTIONS(983),
    [anon_sym_noredzone] = ACTIONS(983),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(983),
    [anon_sym_noreturn] = ACTIONS(983),
    [anon_sym_norecurse] = ACTIONS(983),
    [anon_sym_willreturn] = ACTIONS(983),
    [anon_sym_nosync] = ACTIONS(983),
    [anon_sym_nounwind] = ACTIONS(983),
    [anon_sym_nocallback] = ACTIONS(983),
    [anon_sym_nosanitize_coverage] = ACTIONS(983),
    [anon_sym_null_pointer_is_valid] = ACTIONS(983),
    [anon_sym_optforfuzzing] = ACTIONS(983),
    [anon_sym_optnone] = ACTIONS(983),
    [anon_sym_optsize] = ACTIONS(983),
    [anon_sym_readnone] = ACTIONS(983),
    [anon_sym_readonly] = ACTIONS(983),
    [anon_sym_writeonly] = ACTIONS(983),
    [anon_sym_argmemonly] = ACTIONS(983),
    [anon_sym_returns_twice] = ACTIONS(983),
    [anon_sym_safestack] = ACTIONS(983),
    [anon_sym_sanitize_address] = ACTIONS(983),
    [anon_sym_sanitize_memory] = ACTIONS(983),
    [anon_sym_sanitize_thread] = ACTIONS(983),
    [anon_sym_sanitize_hwaddress] = ACTIONS(983),
    [anon_sym_sanitize_memtag] = ACTIONS(983),
    [anon_sym_speculative_load_hardening] = ACTIONS(983),
    [anon_sym_speculatable] = ACTIONS(983),
    [anon_sym_ssp] = ACTIONS(985),
    [anon_sym_sspstrong] = ACTIONS(983),
    [anon_sym_sspreq] = ACTIONS(983),
    [anon_sym_strictfp] = ACTIONS(983),
    [anon_sym_nocf_check] = ACTIONS(983),
    [anon_sym_shadowcallstack] = ACTIONS(983),
    [anon_sym_mustprogress] = ACTIONS(983),
    [anon_sym_vscale_range] = ACTIONS(983),
    [anon_sym_preallocated] = ACTIONS(983),
    [anon_sym_zeroext] = ACTIONS(983),
    [anon_sym_signext] = ACTIONS(983),
    [anon_sym_inreg] = ACTIONS(983),
    [anon_sym_byval] = ACTIONS(983),
    [anon_sym_byref] = ACTIONS(983),
    [anon_sym_inalloca] = ACTIONS(983),
    [anon_sym_sret] = ACTIONS(983),
    [anon_sym_elementtype] = ACTIONS(983),
    [anon_sym_noalias] = ACTIONS(983),
    [anon_sym_nocapture] = ACTIONS(983),
    [anon_sym_nest] = ACTIONS(983),
    [anon_sym_returned] = ACTIONS(983),
    [anon_sym_nonnull] = ACTIONS(983),
    [anon_sym_dereferenceable] = ACTIONS(985),
    [anon_sym_dereferenceable_or_null] = ACTIONS(983),
    [anon_sym_swiftself] = ACTIONS(985),
    [anon_sym_swiftasync] = ACTIONS(985),
    [anon_sym_swifterror] = ACTIONS(985),
    [anon_sym_immarg] = ACTIONS(983),
    [anon_sym_noundef] = ACTIONS(983),
    [anon_sym_uwtable] = ACTIONS(983),
    [anon_sym_memory] = ACTIONS(983),
  },
  [248] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(987),
    [sym_local_var] = ACTIONS(987),
    [sym_string] = ACTIONS(987),
    [anon_sym_no_cfi] = ACTIONS(987),
    [anon_sym_private] = ACTIONS(987),
    [anon_sym_internal] = ACTIONS(987),
    [anon_sym_weak] = ACTIONS(989),
    [anon_sym_weak_odr] = ACTIONS(987),
    [anon_sym_linkonce] = ACTIONS(989),
    [anon_sym_linkonce_odr] = ACTIONS(987),
    [anon_sym_available_externally] = ACTIONS(987),
    [anon_sym_appending] = ACTIONS(987),
    [anon_sym_common] = ACTIONS(987),
    [anon_sym_extern_weak] = ACTIONS(987),
    [anon_sym_external] = ACTIONS(987),
    [anon_sym_dso_local] = ACTIONS(989),
    [anon_sym_dso_local_equivalent] = ACTIONS(987),
    [anon_sym_dso_preemptable] = ACTIONS(987),
    [anon_sym_default] = ACTIONS(987),
    [anon_sym_hidden] = ACTIONS(987),
    [anon_sym_protected] = ACTIONS(987),
    [anon_sym_dllimport] = ACTIONS(987),
    [anon_sym_dllexport] = ACTIONS(987),
    [anon_sym_ccc] = ACTIONS(987),
    [anon_sym_fastcc] = ACTIONS(987),
    [anon_sym_coldcc] = ACTIONS(987),
    [anon_sym_webkit_jscc] = ACTIONS(989),
    [anon_sym_anyregcc] = ACTIONS(987),
    [anon_sym_preserve_mostcc] = ACTIONS(987),
    [anon_sym_preserve_allcc] = ACTIONS(987),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(989),
    [anon_sym_tailcc] = ACTIONS(987),
    [anon_sym_swiftcc] = ACTIONS(989),
    [anon_sym_swifttailcc] = ACTIONS(989),
    [anon_sym_cfguard_checkcc] = ACTIONS(987),
    [aux_sym_calling_conv_token1] = ACTIONS(989),
    [aux_sym_calling_conv_token2] = ACTIONS(987),
    [aux_sym_calling_conv_token3] = ACTIONS(987),
    [aux_sym_calling_conv_token4] = ACTIONS(987),
    [aux_sym_calling_conv_token5] = ACTIONS(987),
    [aux_sym_calling_conv_token6] = ACTIONS(987),
    [aux_sym_calling_conv_token7] = ACTIONS(987),
    [aux_sym_calling_conv_token8] = ACTIONS(987),
    [aux_sym_calling_conv_token9] = ACTIONS(987),
    [aux_sym_calling_conv_token10] = ACTIONS(989),
    [anon_sym_ghccc] = ACTIONS(987),
    [aux_sym_calling_conv_token11] = ACTIONS(989),
    [aux_sym_calling_conv_token12] = ACTIONS(987),
    [aux_sym_calling_conv_token13] = ACTIONS(989),
    [aux_sym_calling_conv_token14] = ACTIONS(987),
    [anon_sym_cc] = ACTIONS(989),
    [anon_sym_unnamed_addr] = ACTIONS(987),
    [anon_sym_local_unnamed_addr] = ACTIONS(987),
    [anon_sym_void] = ACTIONS(987),
    [anon_sym_half] = ACTIONS(987),
    [anon_sym_bfloat] = ACTIONS(987),
    [anon_sym_float] = ACTIONS(987),
    [anon_sym_double] = ACTIONS(987),
    [anon_sym_x86_fp80] = ACTIONS(989),
    [anon_sym_fp128] = ACTIONS(987),
    [anon_sym_ppc_fp128] = ACTIONS(987),
    [anon_sym_label] = ACTIONS(987),
    [anon_sym_metadata] = ACTIONS(987),
    [anon_sym_x86_mmx] = ACTIONS(989),
    [anon_sym_x86_amx] = ACTIONS(989),
    [anon_sym_token] = ACTIONS(987),
    [anon_sym_opaque] = ACTIONS(987),
    [anon_sym_ptr] = ACTIONS(987),
    [aux_sym_type_keyword_token1] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(987),
    [anon_sym_LT_LBRACE] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_LT] = ACTIONS(989),
    [anon_sym_align] = ACTIONS(989),
    [anon_sym_alignstack] = ACTIONS(987),
    [anon_sym_allocsize] = ACTIONS(987),
    [anon_sym_alwaysinline] = ACTIONS(987),
    [anon_sym_builtin] = ACTIONS(987),
    [anon_sym_cold] = ACTIONS(989),
    [anon_sym_convergent] = ACTIONS(987),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(987),
    [anon_sym_hot] = ACTIONS(987),
    [anon_sym_inaccessiblememonly] = ACTIONS(987),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(987),
    [anon_sym_inlinehint] = ACTIONS(987),
    [anon_sym_jumptable] = ACTIONS(987),
    [anon_sym_minsize] = ACTIONS(987),
    [anon_sym_naked] = ACTIONS(987),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(987),
    [anon_sym_nobuiltin] = ACTIONS(987),
    [anon_sym_noduplicate] = ACTIONS(987),
    [anon_sym_nofree] = ACTIONS(987),
    [anon_sym_noimplicitfloat] = ACTIONS(987),
    [anon_sym_noinline] = ACTIONS(987),
    [anon_sym_nomerge] = ACTIONS(987),
    [anon_sym_nonlazybind] = ACTIONS(987),
    [anon_sym_noprofile] = ACTIONS(987),
    [anon_sym_noredzone] = ACTIONS(987),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(987),
    [anon_sym_noreturn] = ACTIONS(987),
    [anon_sym_norecurse] = ACTIONS(987),
    [anon_sym_willreturn] = ACTIONS(987),
    [anon_sym_nosync] = ACTIONS(987),
    [anon_sym_nounwind] = ACTIONS(987),
    [anon_sym_nocallback] = ACTIONS(987),
    [anon_sym_nosanitize_coverage] = ACTIONS(987),
    [anon_sym_null_pointer_is_valid] = ACTIONS(987),
    [anon_sym_optforfuzzing] = ACTIONS(987),
    [anon_sym_optnone] = ACTIONS(987),
    [anon_sym_optsize] = ACTIONS(987),
    [anon_sym_readnone] = ACTIONS(987),
    [anon_sym_readonly] = ACTIONS(987),
    [anon_sym_writeonly] = ACTIONS(987),
    [anon_sym_argmemonly] = ACTIONS(987),
    [anon_sym_returns_twice] = ACTIONS(987),
    [anon_sym_safestack] = ACTIONS(987),
    [anon_sym_sanitize_address] = ACTIONS(987),
    [anon_sym_sanitize_memory] = ACTIONS(987),
    [anon_sym_sanitize_thread] = ACTIONS(987),
    [anon_sym_sanitize_hwaddress] = ACTIONS(987),
    [anon_sym_sanitize_memtag] = ACTIONS(987),
    [anon_sym_speculative_load_hardening] = ACTIONS(987),
    [anon_sym_speculatable] = ACTIONS(987),
    [anon_sym_ssp] = ACTIONS(989),
    [anon_sym_sspstrong] = ACTIONS(987),
    [anon_sym_sspreq] = ACTIONS(987),
    [anon_sym_strictfp] = ACTIONS(987),
    [anon_sym_nocf_check] = ACTIONS(987),
    [anon_sym_shadowcallstack] = ACTIONS(987),
    [anon_sym_mustprogress] = ACTIONS(987),
    [anon_sym_vscale_range] = ACTIONS(987),
    [anon_sym_preallocated] = ACTIONS(987),
    [anon_sym_zeroext] = ACTIONS(987),
    [anon_sym_signext] = ACTIONS(987),
    [anon_sym_inreg] = ACTIONS(987),
    [anon_sym_byval] = ACTIONS(987),
    [anon_sym_byref] = ACTIONS(987),
    [anon_sym_inalloca] = ACTIONS(987),
    [anon_sym_sret] = ACTIONS(987),
    [anon_sym_elementtype] = ACTIONS(987),
    [anon_sym_noalias] = ACTIONS(987),
    [anon_sym_nocapture] = ACTIONS(987),
    [anon_sym_nest] = ACTIONS(987),
    [anon_sym_returned] = ACTIONS(987),
    [anon_sym_nonnull] = ACTIONS(987),
    [anon_sym_dereferenceable] = ACTIONS(989),
    [anon_sym_dereferenceable_or_null] = ACTIONS(987),
    [anon_sym_swiftself] = ACTIONS(989),
    [anon_sym_swiftasync] = ACTIONS(989),
    [anon_sym_swifterror] = ACTIONS(989),
    [anon_sym_immarg] = ACTIONS(987),
    [anon_sym_noundef] = ACTIONS(987),
    [anon_sym_uwtable] = ACTIONS(987),
    [anon_sym_memory] = ACTIONS(987),
  },
  [249] = {
    [sym_metadata_ref] = STATE(128),
    [sym_type] = STATE(250),
    [sym_type_keyword] = STATE(285),
    [sym_struct_type] = STATE(285),
    [sym_packed_struct_type] = STATE(285),
    [sym_array_type] = STATE(285),
    [sym_vector_type] = STATE(285),
    [sym_type_and_value] = STATE(145),
    [sym_metadata] = STATE(161),
    [sym_metadata_tuple] = STATE(145),
    [sym_specialized_md] = STATE(145),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(938),
    [sym_label] = ACTIONS(116),
    [aux_sym_metadata_ref_token1] = ACTIONS(120),
    [sym_string] = ACTIONS(122),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(122),
    [sym_float] = ACTIONS(122),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(122),
    [anon_sym_private] = ACTIONS(122),
    [anon_sym_internal] = ACTIONS(122),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(122),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(122),
    [anon_sym_available_externally] = ACTIONS(122),
    [anon_sym_appending] = ACTIONS(122),
    [anon_sym_common] = ACTIONS(122),
    [anon_sym_extern_weak] = ACTIONS(122),
    [anon_sym_external] = ACTIONS(122),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(122),
    [anon_sym_dso_preemptable] = ACTIONS(122),
    [anon_sym_default] = ACTIONS(122),
    [anon_sym_hidden] = ACTIONS(122),
    [anon_sym_protected] = ACTIONS(122),
    [anon_sym_dllimport] = ACTIONS(122),
    [anon_sym_dllexport] = ACTIONS(122),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(940),
    [anon_sym_half] = ACTIONS(940),
    [anon_sym_bfloat] = ACTIONS(940),
    [anon_sym_float] = ACTIONS(940),
    [anon_sym_double] = ACTIONS(940),
    [anon_sym_x86_fp80] = ACTIONS(940),
    [anon_sym_fp128] = ACTIONS(940),
    [anon_sym_ppc_fp128] = ACTIONS(940),
    [anon_sym_label] = ACTIONS(940),
    [anon_sym_metadata] = ACTIONS(991),
    [anon_sym_x86_mmx] = ACTIONS(940),
    [anon_sym_x86_amx] = ACTIONS(940),
    [anon_sym_token] = ACTIONS(940),
    [anon_sym_opaque] = ACTIONS(940),
    [anon_sym_ptr] = ACTIONS(940),
    [aux_sym_type_keyword_token1] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(944),
    [anon_sym_RBRACE] = ACTIONS(116),
    [anon_sym_LT_LBRACE] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(948),
    [anon_sym_LT] = ACTIONS(950),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_none] = ACTIONS(122),
    [anon_sym_unreachable] = ACTIONS(122),
    [anon_sym_ret] = ACTIONS(122),
    [anon_sym_br] = ACTIONS(122),
    [anon_sym_resume] = ACTIONS(122),
    [anon_sym_freeze] = ACTIONS(122),
    [anon_sym_indirectbr] = ACTIONS(122),
    [anon_sym_extractelement] = ACTIONS(122),
    [anon_sym_insertelement] = ACTIONS(122),
    [anon_sym_select] = ACTIONS(122),
    [anon_sym_shufflevector] = ACTIONS(122),
    [anon_sym_fneg] = ACTIONS(122),
    [anon_sym_switch] = ACTIONS(122),
    [anon_sym_invoke] = ACTIONS(122),
    [anon_sym_cleanupret] = ACTIONS(122),
    [anon_sym_catchret] = ACTIONS(122),
    [anon_sym_catchswitch] = ACTIONS(122),
    [anon_sym_catchpad] = ACTIONS(122),
    [anon_sym_cleanuppad] = ACTIONS(122),
    [anon_sym_callbr] = ACTIONS(122),
    [anon_sym_icmp] = ACTIONS(122),
    [anon_sym_fcmp] = ACTIONS(122),
    [anon_sym_va_arg] = ACTIONS(122),
    [anon_sym_phi] = ACTIONS(122),
    [anon_sym_landingpad] = ACTIONS(122),
    [anon_sym_tail] = ACTIONS(122),
    [anon_sym_musttail] = ACTIONS(122),
    [anon_sym_notail] = ACTIONS(122),
    [anon_sym_call] = ACTIONS(122),
    [anon_sym_alloca] = ACTIONS(122),
    [anon_sym_load] = ACTIONS(122),
    [anon_sym_store] = ACTIONS(122),
    [anon_sym_cmpxchg] = ACTIONS(122),
    [anon_sym_atomicrmw] = ACTIONS(122),
    [anon_sym_fence] = ACTIONS(122),
    [anon_sym_getelementptr] = ACTIONS(122),
    [anon_sym_extractvalue] = ACTIONS(122),
    [anon_sym_insertvalue] = ACTIONS(122),
    [anon_sym_true] = ACTIONS(122),
    [anon_sym_false] = ACTIONS(122),
    [anon_sym_null] = ACTIONS(136),
    [anon_sym_undef] = ACTIONS(122),
    [anon_sym_poison] = ACTIONS(122),
    [anon_sym_zeroinitializer] = ACTIONS(122),
    [anon_sym_blockaddress] = ACTIONS(122),
    [anon_sym_mul] = ACTIONS(122),
    [anon_sym_urem] = ACTIONS(122),
    [anon_sym_srem] = ACTIONS(122),
    [anon_sym_shl] = ACTIONS(122),
    [anon_sym_udiv] = ACTIONS(122),
    [anon_sym_sdiv] = ACTIONS(122),
    [anon_sym_lshr] = ACTIONS(122),
    [anon_sym_ashr] = ACTIONS(122),
    [anon_sym_fmul] = ACTIONS(122),
    [anon_sym_fdiv] = ACTIONS(122),
    [anon_sym_frem] = ACTIONS(122),
    [anon_sym_xchg] = ACTIONS(122),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(122),
    [anon_sym_and] = ACTIONS(122),
    [anon_sym_nand] = ACTIONS(122),
    [anon_sym_or] = ACTIONS(122),
    [anon_sym_xor] = ACTIONS(122),
    [anon_sym_max] = ACTIONS(122),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(122),
    [anon_sym_umin] = ACTIONS(122),
    [anon_sym_fadd] = ACTIONS(122),
    [anon_sym_fsub] = ACTIONS(122),
    [anon_sym_bitcast] = ACTIONS(122),
    [anon_sym_trunc] = ACTIONS(122),
    [anon_sym_zext] = ACTIONS(122),
    [anon_sym_sext] = ACTIONS(122),
    [anon_sym_fptrunc] = ACTIONS(122),
    [anon_sym_fpext] = ACTIONS(122),
    [anon_sym_addrspacecast] = ACTIONS(122),
    [anon_sym_uitofp] = ACTIONS(122),
    [anon_sym_sitofp] = ACTIONS(122),
    [anon_sym_fptoui] = ACTIONS(122),
    [anon_sym_fptosi] = ACTIONS(122),
    [anon_sym_inttoptr] = ACTIONS(122),
    [anon_sym_ptrtoint] = ACTIONS(122),
    [anon_sym_uselistorder] = ACTIONS(122),
    [anon_sym_BANG] = ACTIONS(138),
  },
  [250] = {
    [sym_number] = STATE(164),
    [sym_var] = STATE(164),
    [sym_linkage] = STATE(784),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(172),
    [sym__primitive_value] = STATE(164),
    [sym_struct_value] = STATE(164),
    [sym_packed_struct_value] = STATE(164),
    [sym_array_value] = STATE(164),
    [sym_vector_value] = STATE(164),
    [sym_blockaddress] = STATE(164),
    [sym_constant_expr] = STATE(164),
    [sym_constant_cast] = STATE(175),
    [sym_constant_getelementptr] = STATE(175),
    [sym_constant_select] = STATE(175),
    [sym_constant_icmp] = STATE(175),
    [sym_constant_fcmp] = STATE(175),
    [sym_constant_extractelement] = STATE(175),
    [sym_constant_insertelement] = STATE(175),
    [sym_constant_shufflevector] = STATE(175),
    [sym_constant_extractvalue] = STATE(175),
    [sym_constant_insertvalue] = STATE(175),
    [sym_constant_fneg] = STATE(175),
    [sym_constant_bin_op] = STATE(175),
    [sym_bin_op_keyword] = STATE(1106),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1954),
    [aux_sym_function_header_repeat1] = STATE(784),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(140),
    [sym_local_var] = ACTIONS(142),
    [sym_label] = ACTIONS(38),
    [sym_string] = ACTIONS(150),
    [aux_sym_number_token1] = ACTIONS(148),
    [aux_sym_number_token2] = ACTIONS(148),
    [sym_float] = ACTIONS(150),
    [sym_cstring] = ACTIONS(152),
    [anon_sym_no_cfi] = ACTIONS(154),
    [anon_sym_private] = ACTIONS(156),
    [anon_sym_internal] = ACTIONS(156),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(156),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(156),
    [anon_sym_available_externally] = ACTIONS(156),
    [anon_sym_appending] = ACTIONS(156),
    [anon_sym_common] = ACTIONS(156),
    [anon_sym_extern_weak] = ACTIONS(156),
    [anon_sym_external] = ACTIONS(156),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(158),
    [anon_sym_dso_preemptable] = ACTIONS(158),
    [anon_sym_default] = ACTIONS(160),
    [anon_sym_hidden] = ACTIONS(160),
    [anon_sym_protected] = ACTIONS(160),
    [anon_sym_dllimport] = ACTIONS(162),
    [anon_sym_dllexport] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(164),
    [anon_sym_RBRACE] = ACTIONS(38),
    [anon_sym_LT_LBRACE] = ACTIONS(166),
    [anon_sym_LBRACK] = ACTIONS(168),
    [anon_sym_LT] = ACTIONS(171),
    [anon_sym_COMMA] = ACTIONS(38),
    [anon_sym_none] = ACTIONS(150),
    [anon_sym_unreachable] = ACTIONS(70),
    [anon_sym_ret] = ACTIONS(70),
    [anon_sym_br] = ACTIONS(70),
    [anon_sym_resume] = ACTIONS(70),
    [anon_sym_freeze] = ACTIONS(70),
    [anon_sym_indirectbr] = ACTIONS(70),
    [anon_sym_extractelement] = ACTIONS(173),
    [anon_sym_insertelement] = ACTIONS(176),
    [anon_sym_select] = ACTIONS(179),
    [anon_sym_shufflevector] = ACTIONS(182),
    [anon_sym_fneg] = ACTIONS(185),
    [anon_sym_switch] = ACTIONS(70),
    [anon_sym_invoke] = ACTIONS(70),
    [anon_sym_cleanupret] = ACTIONS(70),
    [anon_sym_catchret] = ACTIONS(70),
    [anon_sym_catchswitch] = ACTIONS(70),
    [anon_sym_catchpad] = ACTIONS(70),
    [anon_sym_cleanuppad] = ACTIONS(70),
    [anon_sym_callbr] = ACTIONS(70),
    [anon_sym_icmp] = ACTIONS(188),
    [anon_sym_fcmp] = ACTIONS(191),
    [anon_sym_va_arg] = ACTIONS(70),
    [anon_sym_phi] = ACTIONS(70),
    [anon_sym_landingpad] = ACTIONS(70),
    [anon_sym_tail] = ACTIONS(70),
    [anon_sym_musttail] = ACTIONS(70),
    [anon_sym_notail] = ACTIONS(70),
    [anon_sym_call] = ACTIONS(70),
    [anon_sym_alloca] = ACTIONS(70),
    [anon_sym_load] = ACTIONS(70),
    [anon_sym_store] = ACTIONS(70),
    [anon_sym_cmpxchg] = ACTIONS(70),
    [anon_sym_atomicrmw] = ACTIONS(70),
    [anon_sym_fence] = ACTIONS(70),
    [anon_sym_getelementptr] = ACTIONS(194),
    [anon_sym_extractvalue] = ACTIONS(197),
    [anon_sym_insertvalue] = ACTIONS(200),
    [anon_sym_true] = ACTIONS(150),
    [anon_sym_false] = ACTIONS(150),
    [anon_sym_null] = ACTIONS(150),
    [anon_sym_undef] = ACTIONS(150),
    [anon_sym_poison] = ACTIONS(150),
    [anon_sym_zeroinitializer] = ACTIONS(150),
    [anon_sym_blockaddress] = ACTIONS(203),
    [anon_sym_mul] = ACTIONS(205),
    [anon_sym_urem] = ACTIONS(205),
    [anon_sym_srem] = ACTIONS(205),
    [anon_sym_shl] = ACTIONS(205),
    [anon_sym_udiv] = ACTIONS(205),
    [anon_sym_sdiv] = ACTIONS(205),
    [anon_sym_lshr] = ACTIONS(205),
    [anon_sym_ashr] = ACTIONS(205),
    [anon_sym_fmul] = ACTIONS(205),
    [anon_sym_fdiv] = ACTIONS(205),
    [anon_sym_frem] = ACTIONS(205),
    [anon_sym_xchg] = ACTIONS(208),
    [anon_sym_add] = ACTIONS(208),
    [anon_sym_sub] = ACTIONS(208),
    [anon_sym_and] = ACTIONS(208),
    [anon_sym_nand] = ACTIONS(208),
    [anon_sym_or] = ACTIONS(208),
    [anon_sym_xor] = ACTIONS(208),
    [anon_sym_max] = ACTIONS(208),
    [anon_sym_min] = ACTIONS(208),
    [anon_sym_umax] = ACTIONS(208),
    [anon_sym_umin] = ACTIONS(208),
    [anon_sym_fadd] = ACTIONS(208),
    [anon_sym_fsub] = ACTIONS(208),
    [anon_sym_bitcast] = ACTIONS(211),
    [anon_sym_trunc] = ACTIONS(211),
    [anon_sym_zext] = ACTIONS(211),
    [anon_sym_sext] = ACTIONS(211),
    [anon_sym_fptrunc] = ACTIONS(211),
    [anon_sym_fpext] = ACTIONS(211),
    [anon_sym_addrspacecast] = ACTIONS(211),
    [anon_sym_uitofp] = ACTIONS(211),
    [anon_sym_sitofp] = ACTIONS(211),
    [anon_sym_fptoui] = ACTIONS(211),
    [anon_sym_fptosi] = ACTIONS(211),
    [anon_sym_inttoptr] = ACTIONS(211),
    [anon_sym_ptrtoint] = ACTIONS(211),
    [anon_sym_uselistorder] = ACTIONS(70),
  },
  [251] = {
    [sym_calling_conv] = STATE(414),
    [sym_type] = STATE(371),
    [sym_type_keyword] = STATE(260),
    [sym_struct_type] = STATE(260),
    [sym_packed_struct_type] = STATE(260),
    [sym_array_type] = STATE(260),
    [sym_vector_type] = STATE(260),
    [sym_addrspace] = STATE(1080),
    [sym_param_or_return_attrs] = STATE(407),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym__call_part] = STATE(1662),
    [aux_sym_function_header_repeat2] = STATE(407),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [sym_string] = ACTIONS(721),
    [anon_sym_ccc] = ACTIONS(721),
    [anon_sym_fastcc] = ACTIONS(721),
    [anon_sym_coldcc] = ACTIONS(721),
    [anon_sym_webkit_jscc] = ACTIONS(723),
    [anon_sym_anyregcc] = ACTIONS(721),
    [anon_sym_preserve_mostcc] = ACTIONS(721),
    [anon_sym_preserve_allcc] = ACTIONS(721),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(723),
    [anon_sym_tailcc] = ACTIONS(721),
    [anon_sym_swiftcc] = ACTIONS(723),
    [anon_sym_swifttailcc] = ACTIONS(723),
    [anon_sym_cfguard_checkcc] = ACTIONS(721),
    [aux_sym_calling_conv_token1] = ACTIONS(723),
    [aux_sym_calling_conv_token2] = ACTIONS(721),
    [aux_sym_calling_conv_token3] = ACTIONS(721),
    [aux_sym_calling_conv_token4] = ACTIONS(721),
    [aux_sym_calling_conv_token5] = ACTIONS(721),
    [aux_sym_calling_conv_token6] = ACTIONS(721),
    [aux_sym_calling_conv_token7] = ACTIONS(721),
    [aux_sym_calling_conv_token8] = ACTIONS(721),
    [aux_sym_calling_conv_token9] = ACTIONS(721),
    [aux_sym_calling_conv_token10] = ACTIONS(723),
    [anon_sym_ghccc] = ACTIONS(721),
    [aux_sym_calling_conv_token11] = ACTIONS(723),
    [aux_sym_calling_conv_token12] = ACTIONS(721),
    [aux_sym_calling_conv_token13] = ACTIONS(723),
    [aux_sym_calling_conv_token14] = ACTIONS(721),
    [anon_sym_cc] = ACTIONS(725),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(442),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(442),
    [anon_sym_x86_amx] = ACTIONS(442),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(458),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(458),
    [anon_sym_swiftasync] = ACTIONS(458),
    [anon_sym_swifterror] = ACTIONS(458),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [252] = {
    [sym_calling_conv] = STATE(414),
    [sym_type] = STATE(371),
    [sym_type_keyword] = STATE(260),
    [sym_struct_type] = STATE(260),
    [sym_packed_struct_type] = STATE(260),
    [sym_array_type] = STATE(260),
    [sym_vector_type] = STATE(260),
    [sym_addrspace] = STATE(1080),
    [sym_param_or_return_attrs] = STATE(407),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym__call_part] = STATE(1628),
    [aux_sym_function_header_repeat2] = STATE(407),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [sym_string] = ACTIONS(721),
    [anon_sym_ccc] = ACTIONS(721),
    [anon_sym_fastcc] = ACTIONS(721),
    [anon_sym_coldcc] = ACTIONS(721),
    [anon_sym_webkit_jscc] = ACTIONS(723),
    [anon_sym_anyregcc] = ACTIONS(721),
    [anon_sym_preserve_mostcc] = ACTIONS(721),
    [anon_sym_preserve_allcc] = ACTIONS(721),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(723),
    [anon_sym_tailcc] = ACTIONS(721),
    [anon_sym_swiftcc] = ACTIONS(723),
    [anon_sym_swifttailcc] = ACTIONS(723),
    [anon_sym_cfguard_checkcc] = ACTIONS(721),
    [aux_sym_calling_conv_token1] = ACTIONS(723),
    [aux_sym_calling_conv_token2] = ACTIONS(721),
    [aux_sym_calling_conv_token3] = ACTIONS(721),
    [aux_sym_calling_conv_token4] = ACTIONS(721),
    [aux_sym_calling_conv_token5] = ACTIONS(721),
    [aux_sym_calling_conv_token6] = ACTIONS(721),
    [aux_sym_calling_conv_token7] = ACTIONS(721),
    [aux_sym_calling_conv_token8] = ACTIONS(721),
    [aux_sym_calling_conv_token9] = ACTIONS(721),
    [aux_sym_calling_conv_token10] = ACTIONS(723),
    [anon_sym_ghccc] = ACTIONS(721),
    [aux_sym_calling_conv_token11] = ACTIONS(723),
    [aux_sym_calling_conv_token12] = ACTIONS(721),
    [aux_sym_calling_conv_token13] = ACTIONS(723),
    [aux_sym_calling_conv_token14] = ACTIONS(721),
    [anon_sym_cc] = ACTIONS(725),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(442),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(442),
    [anon_sym_x86_amx] = ACTIONS(442),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(458),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(458),
    [anon_sym_swiftasync] = ACTIONS(458),
    [anon_sym_swifterror] = ACTIONS(458),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [253] = {
    [ts_builtin_sym_end] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(713),
    [sym_comdat_ref] = ACTIONS(713),
    [sym_global_var] = ACTIONS(713),
    [sym_local_var] = ACTIONS(713),
    [aux_sym_metadata_ref_token1] = ACTIONS(713),
    [sym_summary_ref] = ACTIONS(713),
    [sym_string] = ACTIONS(713),
    [anon_sym_target] = ACTIONS(713),
    [anon_sym_source_filename] = ACTIONS(713),
    [anon_sym_declare] = ACTIONS(713),
    [anon_sym_define] = ACTIONS(713),
    [anon_sym_unnamed_addr] = ACTIONS(713),
    [anon_sym_local_unnamed_addr] = ACTIONS(713),
    [anon_sym_void] = ACTIONS(713),
    [anon_sym_half] = ACTIONS(713),
    [anon_sym_bfloat] = ACTIONS(713),
    [anon_sym_float] = ACTIONS(713),
    [anon_sym_double] = ACTIONS(713),
    [anon_sym_x86_fp80] = ACTIONS(713),
    [anon_sym_fp128] = ACTIONS(713),
    [anon_sym_ppc_fp128] = ACTIONS(713),
    [anon_sym_label] = ACTIONS(713),
    [anon_sym_metadata] = ACTIONS(713),
    [anon_sym_x86_mmx] = ACTIONS(713),
    [anon_sym_x86_amx] = ACTIONS(713),
    [anon_sym_token] = ACTIONS(713),
    [anon_sym_opaque] = ACTIONS(713),
    [anon_sym_ptr] = ACTIONS(713),
    [aux_sym_type_keyword_token1] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(713),
    [anon_sym_RBRACE] = ACTIONS(713),
    [anon_sym_LT_LBRACE] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(713),
    [anon_sym_RBRACK] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_GT] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_addrspace] = ACTIONS(713),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(713),
    [anon_sym_align] = ACTIONS(715),
    [anon_sym_section] = ACTIONS(713),
    [anon_sym_partition] = ACTIONS(713),
    [anon_sym_comdat] = ACTIONS(713),
    [anon_sym_gc] = ACTIONS(713),
    [anon_sym_prefix] = ACTIONS(713),
    [anon_sym_prologue] = ACTIONS(713),
    [anon_sym_personality] = ACTIONS(713),
    [anon_sym_alignstack] = ACTIONS(713),
    [anon_sym_allocsize] = ACTIONS(713),
    [anon_sym_alwaysinline] = ACTIONS(713),
    [anon_sym_builtin] = ACTIONS(713),
    [anon_sym_cold] = ACTIONS(713),
    [anon_sym_convergent] = ACTIONS(713),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(713),
    [anon_sym_hot] = ACTIONS(713),
    [anon_sym_inaccessiblememonly] = ACTIONS(713),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(713),
    [anon_sym_inlinehint] = ACTIONS(713),
    [anon_sym_jumptable] = ACTIONS(713),
    [anon_sym_minsize] = ACTIONS(713),
    [anon_sym_naked] = ACTIONS(713),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(713),
    [anon_sym_nobuiltin] = ACTIONS(713),
    [anon_sym_noduplicate] = ACTIONS(713),
    [anon_sym_nofree] = ACTIONS(713),
    [anon_sym_noimplicitfloat] = ACTIONS(713),
    [anon_sym_noinline] = ACTIONS(713),
    [anon_sym_nomerge] = ACTIONS(713),
    [anon_sym_nonlazybind] = ACTIONS(713),
    [anon_sym_noprofile] = ACTIONS(713),
    [anon_sym_noredzone] = ACTIONS(713),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(713),
    [anon_sym_noreturn] = ACTIONS(713),
    [anon_sym_norecurse] = ACTIONS(713),
    [anon_sym_willreturn] = ACTIONS(713),
    [anon_sym_nosync] = ACTIONS(713),
    [anon_sym_nounwind] = ACTIONS(713),
    [anon_sym_nocallback] = ACTIONS(713),
    [anon_sym_nosanitize_coverage] = ACTIONS(713),
    [anon_sym_null_pointer_is_valid] = ACTIONS(713),
    [anon_sym_optforfuzzing] = ACTIONS(713),
    [anon_sym_optnone] = ACTIONS(713),
    [anon_sym_optsize] = ACTIONS(713),
    [anon_sym_readnone] = ACTIONS(713),
    [anon_sym_readonly] = ACTIONS(713),
    [anon_sym_writeonly] = ACTIONS(713),
    [anon_sym_argmemonly] = ACTIONS(713),
    [anon_sym_returns_twice] = ACTIONS(713),
    [anon_sym_safestack] = ACTIONS(713),
    [anon_sym_sanitize_address] = ACTIONS(713),
    [anon_sym_sanitize_memory] = ACTIONS(713),
    [anon_sym_sanitize_thread] = ACTIONS(713),
    [anon_sym_sanitize_hwaddress] = ACTIONS(713),
    [anon_sym_sanitize_memtag] = ACTIONS(713),
    [anon_sym_speculative_load_hardening] = ACTIONS(713),
    [anon_sym_speculatable] = ACTIONS(713),
    [anon_sym_ssp] = ACTIONS(715),
    [anon_sym_sspstrong] = ACTIONS(713),
    [anon_sym_sspreq] = ACTIONS(713),
    [anon_sym_strictfp] = ACTIONS(713),
    [anon_sym_nocf_check] = ACTIONS(713),
    [anon_sym_shadowcallstack] = ACTIONS(713),
    [anon_sym_mustprogress] = ACTIONS(713),
    [anon_sym_vscale_range] = ACTIONS(713),
    [anon_sym_preallocated] = ACTIONS(713),
    [anon_sym_zeroext] = ACTIONS(713),
    [anon_sym_signext] = ACTIONS(713),
    [anon_sym_inreg] = ACTIONS(713),
    [anon_sym_byval] = ACTIONS(713),
    [anon_sym_byref] = ACTIONS(713),
    [anon_sym_inalloca] = ACTIONS(713),
    [anon_sym_sret] = ACTIONS(713),
    [anon_sym_elementtype] = ACTIONS(713),
    [anon_sym_noalias] = ACTIONS(713),
    [anon_sym_nocapture] = ACTIONS(713),
    [anon_sym_nest] = ACTIONS(713),
    [anon_sym_returned] = ACTIONS(713),
    [anon_sym_nonnull] = ACTIONS(713),
    [anon_sym_dereferenceable] = ACTIONS(715),
    [anon_sym_dereferenceable_or_null] = ACTIONS(713),
    [anon_sym_swiftself] = ACTIONS(713),
    [anon_sym_swiftasync] = ACTIONS(713),
    [anon_sym_swifterror] = ACTIONS(713),
    [anon_sym_immarg] = ACTIONS(713),
    [anon_sym_noundef] = ACTIONS(713),
    [anon_sym_uwtable] = ACTIONS(713),
    [anon_sym_memory] = ACTIONS(713),
    [anon_sym_to] = ACTIONS(715),
    [anon_sym_unwind] = ACTIONS(713),
    [anon_sym_null] = ACTIONS(715),
    [anon_sym_unordered] = ACTIONS(713),
    [anon_sym_monotonic] = ACTIONS(713),
    [anon_sym_acquire] = ACTIONS(713),
    [anon_sym_release] = ACTIONS(713),
    [anon_sym_acq_rel] = ACTIONS(713),
    [anon_sym_seq_cst] = ACTIONS(713),
    [anon_sym_syncscope] = ACTIONS(713),
    [anon_sym_uselistorder] = ACTIONS(715),
    [anon_sym_uselistorder_bb] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_attributes] = ACTIONS(713),
  },
  [254] = {
    [sym_fast_math] = STATE(254),
    [aux_sym_instruction_select_repeat1] = STATE(254),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(993),
    [sym_string] = ACTIONS(993),
    [anon_sym_ccc] = ACTIONS(993),
    [anon_sym_fastcc] = ACTIONS(993),
    [anon_sym_coldcc] = ACTIONS(993),
    [anon_sym_webkit_jscc] = ACTIONS(995),
    [anon_sym_anyregcc] = ACTIONS(993),
    [anon_sym_preserve_mostcc] = ACTIONS(993),
    [anon_sym_preserve_allcc] = ACTIONS(993),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(995),
    [anon_sym_tailcc] = ACTIONS(993),
    [anon_sym_swiftcc] = ACTIONS(995),
    [anon_sym_swifttailcc] = ACTIONS(995),
    [anon_sym_cfguard_checkcc] = ACTIONS(993),
    [aux_sym_calling_conv_token1] = ACTIONS(995),
    [aux_sym_calling_conv_token2] = ACTIONS(993),
    [aux_sym_calling_conv_token3] = ACTIONS(993),
    [aux_sym_calling_conv_token4] = ACTIONS(993),
    [aux_sym_calling_conv_token5] = ACTIONS(993),
    [aux_sym_calling_conv_token6] = ACTIONS(993),
    [aux_sym_calling_conv_token7] = ACTIONS(993),
    [aux_sym_calling_conv_token8] = ACTIONS(993),
    [aux_sym_calling_conv_token9] = ACTIONS(993),
    [aux_sym_calling_conv_token10] = ACTIONS(995),
    [anon_sym_ghccc] = ACTIONS(993),
    [aux_sym_calling_conv_token11] = ACTIONS(995),
    [aux_sym_calling_conv_token12] = ACTIONS(993),
    [aux_sym_calling_conv_token13] = ACTIONS(995),
    [aux_sym_calling_conv_token14] = ACTIONS(993),
    [anon_sym_cc] = ACTIONS(995),
    [anon_sym_void] = ACTIONS(993),
    [anon_sym_half] = ACTIONS(993),
    [anon_sym_bfloat] = ACTIONS(993),
    [anon_sym_float] = ACTIONS(993),
    [anon_sym_double] = ACTIONS(993),
    [anon_sym_x86_fp80] = ACTIONS(995),
    [anon_sym_fp128] = ACTIONS(993),
    [anon_sym_ppc_fp128] = ACTIONS(993),
    [anon_sym_label] = ACTIONS(993),
    [anon_sym_metadata] = ACTIONS(993),
    [anon_sym_x86_mmx] = ACTIONS(995),
    [anon_sym_x86_amx] = ACTIONS(995),
    [anon_sym_token] = ACTIONS(993),
    [anon_sym_opaque] = ACTIONS(993),
    [anon_sym_ptr] = ACTIONS(993),
    [aux_sym_type_keyword_token1] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_LT_LBRACE] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_addrspace] = ACTIONS(993),
    [anon_sym_align] = ACTIONS(995),
    [anon_sym_alignstack] = ACTIONS(993),
    [anon_sym_allocsize] = ACTIONS(993),
    [anon_sym_alwaysinline] = ACTIONS(993),
    [anon_sym_builtin] = ACTIONS(993),
    [anon_sym_cold] = ACTIONS(995),
    [anon_sym_convergent] = ACTIONS(993),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(993),
    [anon_sym_hot] = ACTIONS(993),
    [anon_sym_inaccessiblememonly] = ACTIONS(993),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(993),
    [anon_sym_inlinehint] = ACTIONS(993),
    [anon_sym_jumptable] = ACTIONS(993),
    [anon_sym_minsize] = ACTIONS(993),
    [anon_sym_naked] = ACTIONS(993),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(993),
    [anon_sym_nobuiltin] = ACTIONS(993),
    [anon_sym_noduplicate] = ACTIONS(993),
    [anon_sym_nofree] = ACTIONS(993),
    [anon_sym_noimplicitfloat] = ACTIONS(993),
    [anon_sym_noinline] = ACTIONS(993),
    [anon_sym_nomerge] = ACTIONS(993),
    [anon_sym_nonlazybind] = ACTIONS(993),
    [anon_sym_noprofile] = ACTIONS(993),
    [anon_sym_noredzone] = ACTIONS(993),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(993),
    [anon_sym_noreturn] = ACTIONS(993),
    [anon_sym_norecurse] = ACTIONS(993),
    [anon_sym_willreturn] = ACTIONS(993),
    [anon_sym_nosync] = ACTIONS(993),
    [anon_sym_nounwind] = ACTIONS(993),
    [anon_sym_nocallback] = ACTIONS(993),
    [anon_sym_nosanitize_coverage] = ACTIONS(993),
    [anon_sym_null_pointer_is_valid] = ACTIONS(993),
    [anon_sym_optforfuzzing] = ACTIONS(993),
    [anon_sym_optnone] = ACTIONS(993),
    [anon_sym_optsize] = ACTIONS(993),
    [anon_sym_readnone] = ACTIONS(993),
    [anon_sym_readonly] = ACTIONS(993),
    [anon_sym_writeonly] = ACTIONS(993),
    [anon_sym_argmemonly] = ACTIONS(993),
    [anon_sym_returns_twice] = ACTIONS(993),
    [anon_sym_safestack] = ACTIONS(993),
    [anon_sym_sanitize_address] = ACTIONS(993),
    [anon_sym_sanitize_memory] = ACTIONS(993),
    [anon_sym_sanitize_thread] = ACTIONS(993),
    [anon_sym_sanitize_hwaddress] = ACTIONS(993),
    [anon_sym_sanitize_memtag] = ACTIONS(993),
    [anon_sym_speculative_load_hardening] = ACTIONS(993),
    [anon_sym_speculatable] = ACTIONS(993),
    [anon_sym_ssp] = ACTIONS(995),
    [anon_sym_sspstrong] = ACTIONS(993),
    [anon_sym_sspreq] = ACTIONS(993),
    [anon_sym_strictfp] = ACTIONS(993),
    [anon_sym_nocf_check] = ACTIONS(993),
    [anon_sym_shadowcallstack] = ACTIONS(993),
    [anon_sym_mustprogress] = ACTIONS(993),
    [anon_sym_vscale_range] = ACTIONS(993),
    [anon_sym_preallocated] = ACTIONS(993),
    [anon_sym_zeroext] = ACTIONS(993),
    [anon_sym_signext] = ACTIONS(993),
    [anon_sym_inreg] = ACTIONS(993),
    [anon_sym_byval] = ACTIONS(993),
    [anon_sym_byref] = ACTIONS(993),
    [anon_sym_inalloca] = ACTIONS(993),
    [anon_sym_sret] = ACTIONS(993),
    [anon_sym_elementtype] = ACTIONS(993),
    [anon_sym_noalias] = ACTIONS(993),
    [anon_sym_nocapture] = ACTIONS(993),
    [anon_sym_nest] = ACTIONS(993),
    [anon_sym_returned] = ACTIONS(993),
    [anon_sym_nonnull] = ACTIONS(993),
    [anon_sym_dereferenceable] = ACTIONS(995),
    [anon_sym_dereferenceable_or_null] = ACTIONS(993),
    [anon_sym_swiftself] = ACTIONS(995),
    [anon_sym_swiftasync] = ACTIONS(995),
    [anon_sym_swifterror] = ACTIONS(995),
    [anon_sym_immarg] = ACTIONS(993),
    [anon_sym_noundef] = ACTIONS(993),
    [anon_sym_uwtable] = ACTIONS(993),
    [anon_sym_memory] = ACTIONS(993),
    [anon_sym_nnan] = ACTIONS(997),
    [anon_sym_ninf] = ACTIONS(997),
    [anon_sym_nsz] = ACTIONS(997),
    [anon_sym_arcp] = ACTIONS(997),
    [anon_sym_contract] = ACTIONS(997),
    [anon_sym_afn] = ACTIONS(997),
    [anon_sym_reassoc] = ACTIONS(997),
    [anon_sym_fast] = ACTIONS(1000),
  },
  [255] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1003),
    [sym_string] = ACTIONS(1003),
    [anon_sym_ccc] = ACTIONS(1003),
    [anon_sym_fastcc] = ACTIONS(1003),
    [anon_sym_coldcc] = ACTIONS(1003),
    [anon_sym_webkit_jscc] = ACTIONS(1005),
    [anon_sym_anyregcc] = ACTIONS(1003),
    [anon_sym_preserve_mostcc] = ACTIONS(1003),
    [anon_sym_preserve_allcc] = ACTIONS(1003),
    [anon_sym_cxx_fast_tlscc] = ACTIONS(1005),
    [anon_sym_tailcc] = ACTIONS(1003),
    [anon_sym_swiftcc] = ACTIONS(1005),
    [anon_sym_swifttailcc] = ACTIONS(1005),
    [anon_sym_cfguard_checkcc] = ACTIONS(1003),
    [aux_sym_calling_conv_token1] = ACTIONS(1005),
    [aux_sym_calling_conv_token2] = ACTIONS(1003),
    [aux_sym_calling_conv_token3] = ACTIONS(1003),
    [aux_sym_calling_conv_token4] = ACTIONS(1003),
    [aux_sym_calling_conv_token5] = ACTIONS(1003),
    [aux_sym_calling_conv_token6] = ACTIONS(1003),
    [aux_sym_calling_conv_token7] = ACTIONS(1003),
    [aux_sym_calling_conv_token8] = ACTIONS(1003),
    [aux_sym_calling_conv_token9] = ACTIONS(1003),
    [aux_sym_calling_conv_token10] = ACTIONS(1005),
    [anon_sym_ghccc] = ACTIONS(1003),
    [aux_sym_calling_conv_token11] = ACTIONS(1005),
    [aux_sym_calling_conv_token12] = ACTIONS(1003),
    [aux_sym_calling_conv_token13] = ACTIONS(1005),
    [aux_sym_calling_conv_token14] = ACTIONS(1003),
    [anon_sym_cc] = ACTIONS(1005),
    [anon_sym_void] = ACTIONS(1003),
    [anon_sym_half] = ACTIONS(1003),
    [anon_sym_bfloat] = ACTIONS(1003),
    [anon_sym_float] = ACTIONS(1003),
    [anon_sym_double] = ACTIONS(1003),
    [anon_sym_x86_fp80] = ACTIONS(1005),
    [anon_sym_fp128] = ACTIONS(1003),
    [anon_sym_ppc_fp128] = ACTIONS(1003),
    [anon_sym_label] = ACTIONS(1003),
    [anon_sym_metadata] = ACTIONS(1003),
    [anon_sym_x86_mmx] = ACTIONS(1005),
    [anon_sym_x86_amx] = ACTIONS(1005),
    [anon_sym_token] = ACTIONS(1003),
    [anon_sym_opaque] = ACTIONS(1003),
    [anon_sym_ptr] = ACTIONS(1003),
    [aux_sym_type_keyword_token1] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1003),
    [anon_sym_LT_LBRACE] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LT] = ACTIONS(1005),
    [anon_sym_addrspace] = ACTIONS(1003),
    [anon_sym_align] = ACTIONS(1005),
    [anon_sym_alignstack] = ACTIONS(1003),
    [anon_sym_allocsize] = ACTIONS(1003),
    [anon_sym_alwaysinline] = ACTIONS(1003),
    [anon_sym_builtin] = ACTIONS(1003),
    [anon_sym_cold] = ACTIONS(1005),
    [anon_sym_convergent] = ACTIONS(1003),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1003),
    [anon_sym_hot] = ACTIONS(1003),
    [anon_sym_inaccessiblememonly] = ACTIONS(1003),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1003),
    [anon_sym_inlinehint] = ACTIONS(1003),
    [anon_sym_jumptable] = ACTIONS(1003),
    [anon_sym_minsize] = ACTIONS(1003),
    [anon_sym_naked] = ACTIONS(1003),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1003),
    [anon_sym_nobuiltin] = ACTIONS(1003),
    [anon_sym_noduplicate] = ACTIONS(1003),
    [anon_sym_nofree] = ACTIONS(1003),
    [anon_sym_noimplicitfloat] = ACTIONS(1003),
    [anon_sym_noinline] = ACTIONS(1003),
    [anon_sym_nomerge] = ACTIONS(1003),
    [anon_sym_nonlazybind] = ACTIONS(1003),
    [anon_sym_noprofile] = ACTIONS(1003),
    [anon_sym_noredzone] = ACTIONS(1003),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1003),
    [anon_sym_noreturn] = ACTIONS(1003),
    [anon_sym_norecurse] = ACTIONS(1003),
    [anon_sym_willreturn] = ACTIONS(1003),
    [anon_sym_nosync] = ACTIONS(1003),
    [anon_sym_nounwind] = ACTIONS(1003),
    [anon_sym_nocallback] = ACTIONS(1003),
    [anon_sym_nosanitize_coverage] = ACTIONS(1003),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1003),
    [anon_sym_optforfuzzing] = ACTIONS(1003),
    [anon_sym_optnone] = ACTIONS(1003),
    [anon_sym_optsize] = ACTIONS(1003),
    [anon_sym_readnone] = ACTIONS(1003),
    [anon_sym_readonly] = ACTIONS(1003),
    [anon_sym_writeonly] = ACTIONS(1003),
    [anon_sym_argmemonly] = ACTIONS(1003),
    [anon_sym_returns_twice] = ACTIONS(1003),
    [anon_sym_safestack] = ACTIONS(1003),
    [anon_sym_sanitize_address] = ACTIONS(1003),
    [anon_sym_sanitize_memory] = ACTIONS(1003),
    [anon_sym_sanitize_thread] = ACTIONS(1003),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1003),
    [anon_sym_sanitize_memtag] = ACTIONS(1003),
    [anon_sym_speculative_load_hardening] = ACTIONS(1003),
    [anon_sym_speculatable] = ACTIONS(1003),
    [anon_sym_ssp] = ACTIONS(1005),
    [anon_sym_sspstrong] = ACTIONS(1003),
    [anon_sym_sspreq] = ACTIONS(1003),
    [anon_sym_strictfp] = ACTIONS(1003),
    [anon_sym_nocf_check] = ACTIONS(1003),
    [anon_sym_shadowcallstack] = ACTIONS(1003),
    [anon_sym_mustprogress] = ACTIONS(1003),
    [anon_sym_vscale_range] = ACTIONS(1003),
    [anon_sym_preallocated] = ACTIONS(1003),
    [anon_sym_zeroext] = ACTIONS(1003),
    [anon_sym_signext] = ACTIONS(1003),
    [anon_sym_inreg] = ACTIONS(1003),
    [anon_sym_byval] = ACTIONS(1003),
    [anon_sym_byref] = ACTIONS(1003),
    [anon_sym_inalloca] = ACTIONS(1003),
    [anon_sym_sret] = ACTIONS(1003),
    [anon_sym_elementtype] = ACTIONS(1003),
    [anon_sym_noalias] = ACTIONS(1003),
    [anon_sym_nocapture] = ACTIONS(1003),
    [anon_sym_nest] = ACTIONS(1003),
    [anon_sym_returned] = ACTIONS(1003),
    [anon_sym_nonnull] = ACTIONS(1003),
    [anon_sym_dereferenceable] = ACTIONS(1005),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1003),
    [anon_sym_swiftself] = ACTIONS(1005),
    [anon_sym_swiftasync] = ACTIONS(1005),
    [anon_sym_swifterror] = ACTIONS(1005),
    [anon_sym_immarg] = ACTIONS(1003),
    [anon_sym_noundef] = ACTIONS(1003),
    [anon_sym_uwtable] = ACTIONS(1003),
    [anon_sym_memory] = ACTIONS(1003),
    [anon_sym_nnan] = ACTIONS(1003),
    [anon_sym_ninf] = ACTIONS(1003),
    [anon_sym_nsz] = ACTIONS(1003),
    [anon_sym_arcp] = ACTIONS(1003),
    [anon_sym_contract] = ACTIONS(1003),
    [anon_sym_afn] = ACTIONS(1003),
    [anon_sym_reassoc] = ACTIONS(1003),
    [anon_sym_fast] = ACTIONS(1005),
  },
  [256] = {
    [sym_addrspace] = STATE(1730),
    [sym_argument_list] = STATE(256),
    [aux_sym_type_repeat1] = STATE(1187),
    [aux_sym_type_repeat2] = STATE(256),
    [ts_builtin_sym_end] = ACTIONS(250),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(250),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [aux_sym_metadata_ref_token1] = ACTIONS(250),
    [sym_summary_ref] = ACTIONS(250),
    [sym_string] = ACTIONS(250),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(250),
    [sym_float] = ACTIONS(250),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_target] = ACTIONS(250),
    [anon_sym_source_filename] = ACTIONS(250),
    [anon_sym_declare] = ACTIONS(250),
    [anon_sym_define] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(250),
    [anon_sym_private] = ACTIONS(250),
    [anon_sym_internal] = ACTIONS(250),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(250),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(250),
    [anon_sym_available_externally] = ACTIONS(250),
    [anon_sym_appending] = ACTIONS(250),
    [anon_sym_common] = ACTIONS(250),
    [anon_sym_extern_weak] = ACTIONS(250),
    [anon_sym_external] = ACTIONS(250),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(250),
    [anon_sym_dso_preemptable] = ACTIONS(250),
    [anon_sym_default] = ACTIONS(250),
    [anon_sym_hidden] = ACTIONS(250),
    [anon_sym_protected] = ACTIONS(250),
    [anon_sym_dllimport] = ACTIONS(250),
    [anon_sym_dllexport] = ACTIONS(250),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_void] = ACTIONS(250),
    [anon_sym_half] = ACTIONS(250),
    [anon_sym_bfloat] = ACTIONS(250),
    [anon_sym_float] = ACTIONS(250),
    [anon_sym_double] = ACTIONS(250),
    [anon_sym_x86_fp80] = ACTIONS(250),
    [anon_sym_fp128] = ACTIONS(250),
    [anon_sym_ppc_fp128] = ACTIONS(250),
    [anon_sym_label] = ACTIONS(250),
    [anon_sym_metadata] = ACTIONS(250),
    [anon_sym_x86_mmx] = ACTIONS(250),
    [anon_sym_x86_amx] = ACTIONS(250),
    [anon_sym_token] = ACTIONS(250),
    [anon_sym_opaque] = ACTIONS(250),
    [anon_sym_ptr] = ACTIONS(252),
    [aux_sym_type_keyword_token1] = ACTIONS(250),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_RBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_GT] = ACTIONS(250),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(257),
    [anon_sym_LPAREN] = ACTIONS(1010),
    [anon_sym_RPAREN] = ACTIONS(250),
    [anon_sym_none] = ACTIONS(250),
    [anon_sym_extractelement] = ACTIONS(250),
    [anon_sym_insertelement] = ACTIONS(250),
    [anon_sym_select] = ACTIONS(250),
    [anon_sym_shufflevector] = ACTIONS(250),
    [anon_sym_fneg] = ACTIONS(250),
    [anon_sym_to] = ACTIONS(252),
    [anon_sym_unwind] = ACTIONS(250),
    [anon_sym_icmp] = ACTIONS(250),
    [anon_sym_fcmp] = ACTIONS(250),
    [anon_sym_cleanup] = ACTIONS(250),
    [anon_sym_getelementptr] = ACTIONS(250),
    [anon_sym_extractvalue] = ACTIONS(250),
    [anon_sym_insertvalue] = ACTIONS(250),
    [anon_sym_true] = ACTIONS(250),
    [anon_sym_false] = ACTIONS(250),
    [anon_sym_null] = ACTIONS(250),
    [anon_sym_undef] = ACTIONS(250),
    [anon_sym_poison] = ACTIONS(250),
    [anon_sym_zeroinitializer] = ACTIONS(250),
    [anon_sym_catch] = ACTIONS(250),
    [anon_sym_filter] = ACTIONS(250),
    [anon_sym_blockaddress] = ACTIONS(250),
    [anon_sym_mul] = ACTIONS(250),
    [anon_sym_urem] = ACTIONS(250),
    [anon_sym_srem] = ACTIONS(250),
    [anon_sym_shl] = ACTIONS(250),
    [anon_sym_udiv] = ACTIONS(250),
    [anon_sym_sdiv] = ACTIONS(250),
    [anon_sym_lshr] = ACTIONS(250),
    [anon_sym_ashr] = ACTIONS(250),
    [anon_sym_fmul] = ACTIONS(250),
    [anon_sym_fdiv] = ACTIONS(250),
    [anon_sym_frem] = ACTIONS(250),
    [anon_sym_xchg] = ACTIONS(250),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(250),
    [anon_sym_and] = ACTIONS(250),
    [anon_sym_nand] = ACTIONS(250),
    [anon_sym_or] = ACTIONS(250),
    [anon_sym_xor] = ACTIONS(250),
    [anon_sym_max] = ACTIONS(250),
    [anon_sym_min] = ACTIONS(250),
    [anon_sym_umax] = ACTIONS(250),
    [anon_sym_umin] = ACTIONS(250),
    [anon_sym_fadd] = ACTIONS(250),
    [anon_sym_fsub] = ACTIONS(250),
    [anon_sym_bitcast] = ACTIONS(250),
    [anon_sym_trunc] = ACTIONS(250),
    [anon_sym_zext] = ACTIONS(250),
    [anon_sym_sext] = ACTIONS(250),
    [anon_sym_fptrunc] = ACTIONS(250),
    [anon_sym_fpext] = ACTIONS(250),
    [anon_sym_addrspacecast] = ACTIONS(250),
    [anon_sym_uitofp] = ACTIONS(250),
    [anon_sym_sitofp] = ACTIONS(250),
    [anon_sym_fptoui] = ACTIONS(250),
    [anon_sym_fptosi] = ACTIONS(250),
    [anon_sym_inttoptr] = ACTIONS(250),
    [anon_sym_ptrtoint] = ACTIONS(250),
    [anon_sym_unordered] = ACTIONS(250),
    [anon_sym_monotonic] = ACTIONS(250),
    [anon_sym_acquire] = ACTIONS(250),
    [anon_sym_release] = ACTIONS(250),
    [anon_sym_acq_rel] = ACTIONS(250),
    [anon_sym_seq_cst] = ACTIONS(250),
    [anon_sym_syncscope] = ACTIONS(250),
    [anon_sym_uselistorder] = ACTIONS(252),
    [anon_sym_uselistorder_bb] = ACTIONS(250),
    [anon_sym_module] = ACTIONS(250),
    [anon_sym_asm] = ACTIONS(250),
    [anon_sym_attributes] = ACTIONS(250),
  },
  [257] = {
    [ts_builtin_sym_end] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(391),
    [sym_comdat_ref] = ACTIONS(391),
    [sym_global_var] = ACTIONS(391),
    [sym_local_var] = ACTIONS(391),
    [aux_sym_metadata_ref_token1] = ACTIONS(391),
    [sym_summary_ref] = ACTIONS(391),
    [sym_string] = ACTIONS(391),
    [anon_sym_target] = ACTIONS(391),
    [anon_sym_source_filename] = ACTIONS(391),
    [anon_sym_declare] = ACTIONS(391),
    [anon_sym_define] = ACTIONS(391),
    [anon_sym_STAR] = ACTIONS(391),
    [anon_sym_void] = ACTIONS(391),
    [anon_sym_half] = ACTIONS(391),
    [anon_sym_bfloat] = ACTIONS(391),
    [anon_sym_float] = ACTIONS(391),
    [anon_sym_double] = ACTIONS(391),
    [anon_sym_x86_fp80] = ACTIONS(391),
    [anon_sym_fp128] = ACTIONS(391),
    [anon_sym_ppc_fp128] = ACTIONS(391),
    [anon_sym_label] = ACTIONS(391),
    [anon_sym_metadata] = ACTIONS(391),
    [anon_sym_x86_mmx] = ACTIONS(391),
    [anon_sym_x86_amx] = ACTIONS(391),
    [anon_sym_token] = ACTIONS(391),
    [anon_sym_opaque] = ACTIONS(391),
    [anon_sym_ptr] = ACTIONS(391),
    [aux_sym_type_keyword_token1] = ACTIONS(391),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_RBRACE] = ACTIONS(391),
    [anon_sym_LT_LBRACE] = ACTIONS(391),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_RBRACK] = ACTIONS(391),
    [anon_sym_LT] = ACTIONS(393),
    [anon_sym_GT] = ACTIONS(391),
    [anon_sym_COMMA] = ACTIONS(391),
    [anon_sym_RPAREN] = ACTIONS(391),
    [anon_sym_align] = ACTIONS(393),
    [anon_sym_section] = ACTIONS(391),
    [anon_sym_partition] = ACTIONS(391),
    [anon_sym_comdat] = ACTIONS(391),
    [anon_sym_gc] = ACTIONS(391),
    [anon_sym_prefix] = ACTIONS(391),
    [anon_sym_prologue] = ACTIONS(391),
    [anon_sym_personality] = ACTIONS(391),
    [anon_sym_alignstack] = ACTIONS(391),
    [anon_sym_allocsize] = ACTIONS(391),
    [anon_sym_alwaysinline] = ACTIONS(391),
    [anon_sym_builtin] = ACTIONS(391),
    [anon_sym_cold] = ACTIONS(391),
    [anon_sym_convergent] = ACTIONS(391),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(391),
    [anon_sym_hot] = ACTIONS(391),
    [anon_sym_inaccessiblememonly] = ACTIONS(391),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(391),
    [anon_sym_inlinehint] = ACTIONS(391),
    [anon_sym_jumptable] = ACTIONS(391),
    [anon_sym_minsize] = ACTIONS(391),
    [anon_sym_naked] = ACTIONS(391),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(391),
    [anon_sym_nobuiltin] = ACTIONS(391),
    [anon_sym_noduplicate] = ACTIONS(391),
    [anon_sym_nofree] = ACTIONS(391),
    [anon_sym_noimplicitfloat] = ACTIONS(391),
    [anon_sym_noinline] = ACTIONS(391),
    [anon_sym_nomerge] = ACTIONS(391),
    [anon_sym_nonlazybind] = ACTIONS(391),
    [anon_sym_noprofile] = ACTIONS(391),
    [anon_sym_noredzone] = ACTIONS(391),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(391),
    [anon_sym_noreturn] = ACTIONS(391),
    [anon_sym_norecurse] = ACTIONS(391),
    [anon_sym_willreturn] = ACTIONS(391),
    [anon_sym_nosync] = ACTIONS(391),
    [anon_sym_nounwind] = ACTIONS(391),
    [anon_sym_nocallback] = ACTIONS(391),
    [anon_sym_nosanitize_coverage] = ACTIONS(391),
    [anon_sym_null_pointer_is_valid] = ACTIONS(391),
    [anon_sym_optforfuzzing] = ACTIONS(391),
    [anon_sym_optnone] = ACTIONS(391),
    [anon_sym_optsize] = ACTIONS(391),
    [anon_sym_readnone] = ACTIONS(391),
    [anon_sym_readonly] = ACTIONS(391),
    [anon_sym_writeonly] = ACTIONS(391),
    [anon_sym_argmemonly] = ACTIONS(391),
    [anon_sym_returns_twice] = ACTIONS(391),
    [anon_sym_safestack] = ACTIONS(391),
    [anon_sym_sanitize_address] = ACTIONS(391),
    [anon_sym_sanitize_memory] = ACTIONS(391),
    [anon_sym_sanitize_thread] = ACTIONS(391),
    [anon_sym_sanitize_hwaddress] = ACTIONS(391),
    [anon_sym_sanitize_memtag] = ACTIONS(391),
    [anon_sym_speculative_load_hardening] = ACTIONS(391),
    [anon_sym_speculatable] = ACTIONS(391),
    [anon_sym_ssp] = ACTIONS(393),
    [anon_sym_sspstrong] = ACTIONS(391),
    [anon_sym_sspreq] = ACTIONS(391),
    [anon_sym_strictfp] = ACTIONS(391),
    [anon_sym_nocf_check] = ACTIONS(391),
    [anon_sym_shadowcallstack] = ACTIONS(391),
    [anon_sym_mustprogress] = ACTIONS(391),
    [anon_sym_vscale_range] = ACTIONS(391),
    [anon_sym_preallocated] = ACTIONS(391),
    [anon_sym_zeroext] = ACTIONS(391),
    [anon_sym_signext] = ACTIONS(391),
    [anon_sym_inreg] = ACTIONS(391),
    [anon_sym_byval] = ACTIONS(391),
    [anon_sym_byref] = ACTIONS(391),
    [anon_sym_inalloca] = ACTIONS(391),
    [anon_sym_sret] = ACTIONS(391),
    [anon_sym_elementtype] = ACTIONS(391),
    [anon_sym_noalias] = ACTIONS(391),
    [anon_sym_nocapture] = ACTIONS(391),
    [anon_sym_nest] = ACTIONS(391),
    [anon_sym_returned] = ACTIONS(391),
    [anon_sym_nonnull] = ACTIONS(391),
    [anon_sym_dereferenceable] = ACTIONS(393),
    [anon_sym_dereferenceable_or_null] = ACTIONS(391),
    [anon_sym_swiftself] = ACTIONS(391),
    [anon_sym_swiftasync] = ACTIONS(391),
    [anon_sym_swifterror] = ACTIONS(391),
    [anon_sym_immarg] = ACTIONS(391),
    [anon_sym_noundef] = ACTIONS(391),
    [anon_sym_uwtable] = ACTIONS(391),
    [anon_sym_memory] = ACTIONS(391),
    [anon_sym_cleanup] = ACTIONS(391),
    [anon_sym_catch] = ACTIONS(391),
    [anon_sym_filter] = ACTIONS(391),
    [anon_sym_uselistorder] = ACTIONS(393),
    [anon_sym_uselistorder_bb] = ACTIONS(391),
    [anon_sym_module] = ACTIONS(391),
    [anon_sym_externally_initialized] = ACTIONS(391),
    [anon_sym_global] = ACTIONS(391),
    [anon_sym_constant] = ACTIONS(391),
    [anon_sym_alias] = ACTIONS(391),
    [anon_sym_ifunc] = ACTIONS(391),
    [anon_sym_attributes] = ACTIONS(391),
  },
  [258] = {
    [sym_addrspace] = STATE(1730),
    [aux_sym_type_repeat1] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(269),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(269),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [aux_sym_metadata_ref_token1] = ACTIONS(269),
    [sym_summary_ref] = ACTIONS(269),
    [sym_string] = ACTIONS(269),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(269),
    [sym_float] = ACTIONS(269),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_target] = ACTIONS(269),
    [anon_sym_source_filename] = ACTIONS(269),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_define] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_internal] = ACTIONS(269),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(269),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(269),
    [anon_sym_available_externally] = ACTIONS(269),
    [anon_sym_appending] = ACTIONS(269),
    [anon_sym_common] = ACTIONS(269),
    [anon_sym_extern_weak] = ACTIONS(269),
    [anon_sym_external] = ACTIONS(269),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(269),
    [anon_sym_dso_preemptable] = ACTIONS(269),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_hidden] = ACTIONS(269),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_dllimport] = ACTIONS(269),
    [anon_sym_dllexport] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(1013),
    [anon_sym_void] = ACTIONS(269),
    [anon_sym_half] = ACTIONS(269),
    [anon_sym_bfloat] = ACTIONS(269),
    [anon_sym_float] = ACTIONS(269),
    [anon_sym_double] = ACTIONS(269),
    [anon_sym_x86_fp80] = ACTIONS(269),
    [anon_sym_fp128] = ACTIONS(269),
    [anon_sym_ppc_fp128] = ACTIONS(269),
    [anon_sym_label] = ACTIONS(269),
    [anon_sym_metadata] = ACTIONS(269),
    [anon_sym_x86_mmx] = ACTIONS(269),
    [anon_sym_x86_amx] = ACTIONS(269),
    [anon_sym_token] = ACTIONS(269),
    [anon_sym_opaque] = ACTIONS(269),
    [anon_sym_ptr] = ACTIONS(271),
    [aux_sym_type_keyword_token1] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_RBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_GT] = ACTIONS(269),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_RPAREN] = ACTIONS(269),
    [anon_sym_none] = ACTIONS(269),
    [anon_sym_extractelement] = ACTIONS(269),
    [anon_sym_insertelement] = ACTIONS(269),
    [anon_sym_select] = ACTIONS(269),
    [anon_sym_shufflevector] = ACTIONS(269),
    [anon_sym_fneg] = ACTIONS(269),
    [anon_sym_to] = ACTIONS(271),
    [anon_sym_unwind] = ACTIONS(269),
    [anon_sym_icmp] = ACTIONS(269),
    [anon_sym_fcmp] = ACTIONS(269),
    [anon_sym_cleanup] = ACTIONS(269),
    [anon_sym_getelementptr] = ACTIONS(269),
    [anon_sym_extractvalue] = ACTIONS(269),
    [anon_sym_insertvalue] = ACTIONS(269),
    [anon_sym_true] = ACTIONS(269),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_null] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(269),
    [anon_sym_poison] = ACTIONS(269),
    [anon_sym_zeroinitializer] = ACTIONS(269),
    [anon_sym_catch] = ACTIONS(269),
    [anon_sym_filter] = ACTIONS(269),
    [anon_sym_blockaddress] = ACTIONS(269),
    [anon_sym_mul] = ACTIONS(269),
    [anon_sym_urem] = ACTIONS(269),
    [anon_sym_srem] = ACTIONS(269),
    [anon_sym_shl] = ACTIONS(269),
    [anon_sym_udiv] = ACTIONS(269),
    [anon_sym_sdiv] = ACTIONS(269),
    [anon_sym_lshr] = ACTIONS(269),
    [anon_sym_ashr] = ACTIONS(269),
    [anon_sym_fmul] = ACTIONS(269),
    [anon_sym_fdiv] = ACTIONS(269),
    [anon_sym_frem] = ACTIONS(269),
    [anon_sym_xchg] = ACTIONS(269),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(269),
    [anon_sym_and] = ACTIONS(269),
    [anon_sym_nand] = ACTIONS(269),
    [anon_sym_or] = ACTIONS(269),
    [anon_sym_xor] = ACTIONS(269),
    [anon_sym_max] = ACTIONS(269),
    [anon_sym_min] = ACTIONS(269),
    [anon_sym_umax] = ACTIONS(269),
    [anon_sym_umin] = ACTIONS(269),
    [anon_sym_fadd] = ACTIONS(269),
    [anon_sym_fsub] = ACTIONS(269),
    [anon_sym_bitcast] = ACTIONS(269),
    [anon_sym_trunc] = ACTIONS(269),
    [anon_sym_zext] = ACTIONS(269),
    [anon_sym_sext] = ACTIONS(269),
    [anon_sym_fptrunc] = ACTIONS(269),
    [anon_sym_fpext] = ACTIONS(269),
    [anon_sym_addrspacecast] = ACTIONS(269),
    [anon_sym_uitofp] = ACTIONS(269),
    [anon_sym_sitofp] = ACTIONS(269),
    [anon_sym_fptoui] = ACTIONS(269),
    [anon_sym_fptosi] = ACTIONS(269),
    [anon_sym_inttoptr] = ACTIONS(269),
    [anon_sym_ptrtoint] = ACTIONS(269),
    [anon_sym_unordered] = ACTIONS(269),
    [anon_sym_monotonic] = ACTIONS(269),
    [anon_sym_acquire] = ACTIONS(269),
    [anon_sym_release] = ACTIONS(269),
    [anon_sym_acq_rel] = ACTIONS(269),
    [anon_sym_seq_cst] = ACTIONS(269),
    [anon_sym_syncscope] = ACTIONS(269),
    [anon_sym_uselistorder] = ACTIONS(271),
    [anon_sym_uselistorder_bb] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_asm] = ACTIONS(269),
    [anon_sym_attributes] = ACTIONS(269),
  },
  [259] = {
    [sym_addrspace] = STATE(283),
    [sym_argument_list] = STATE(256),
    [aux_sym_type_repeat1] = STATE(261),
    [aux_sym_type_repeat2] = STATE(256),
    [ts_builtin_sym_end] = ACTIONS(244),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(244),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [aux_sym_metadata_ref_token1] = ACTIONS(244),
    [sym_summary_ref] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_target] = ACTIONS(244),
    [anon_sym_source_filename] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(244),
    [anon_sym_define] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(244),
    [anon_sym_half] = ACTIONS(244),
    [anon_sym_bfloat] = ACTIONS(244),
    [anon_sym_float] = ACTIONS(244),
    [anon_sym_double] = ACTIONS(244),
    [anon_sym_x86_fp80] = ACTIONS(244),
    [anon_sym_fp128] = ACTIONS(244),
    [anon_sym_ppc_fp128] = ACTIONS(244),
    [anon_sym_label] = ACTIONS(244),
    [anon_sym_metadata] = ACTIONS(244),
    [anon_sym_x86_mmx] = ACTIONS(244),
    [anon_sym_x86_amx] = ACTIONS(244),
    [anon_sym_token] = ACTIONS(244),
    [anon_sym_opaque] = ACTIONS(244),
    [anon_sym_ptr] = ACTIONS(246),
    [aux_sym_type_keyword_token1] = ACTIONS(244),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_RBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_GT] = ACTIONS(244),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_RPAREN] = ACTIONS(244),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_to] = ACTIONS(246),
    [anon_sym_unwind] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(244),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(244),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
    [anon_sym_unordered] = ACTIONS(244),
    [anon_sym_monotonic] = ACTIONS(244),
    [anon_sym_acquire] = ACTIONS(244),
    [anon_sym_release] = ACTIONS(244),
    [anon_sym_acq_rel] = ACTIONS(244),
    [anon_sym_seq_cst] = ACTIONS(244),
    [anon_sym_syncscope] = ACTIONS(244),
    [anon_sym_uselistorder] = ACTIONS(246),
    [anon_sym_uselistorder_bb] = ACTIONS(244),
    [anon_sym_module] = ACTIONS(244),
    [anon_sym_asm] = ACTIONS(244),
    [anon_sym_attributes] = ACTIONS(244),
  },
  [260] = {
    [sym_addrspace] = STATE(288),
    [sym_argument_list] = STATE(259),
    [aux_sym_type_repeat1] = STATE(277),
    [aux_sym_type_repeat2] = STATE(259),
    [ts_builtin_sym_end] = ACTIONS(234),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(234),
    [sym_global_var] = ACTIONS(234),
    [sym_local_var] = ACTIONS(234),
    [aux_sym_metadata_ref_token1] = ACTIONS(234),
    [sym_summary_ref] = ACTIONS(234),
    [sym_string] = ACTIONS(234),
    [aux_sym_number_token1] = ACTIONS(236),
    [aux_sym_number_token2] = ACTIONS(234),
    [sym_float] = ACTIONS(234),
    [sym_cstring] = ACTIONS(234),
    [anon_sym_target] = ACTIONS(234),
    [anon_sym_source_filename] = ACTIONS(234),
    [anon_sym_declare] = ACTIONS(234),
    [anon_sym_define] = ACTIONS(234),
    [anon_sym_no_cfi] = ACTIONS(234),
    [anon_sym_private] = ACTIONS(234),
    [anon_sym_internal] = ACTIONS(234),
    [anon_sym_weak] = ACTIONS(236),
    [anon_sym_weak_odr] = ACTIONS(234),
    [anon_sym_linkonce] = ACTIONS(236),
    [anon_sym_linkonce_odr] = ACTIONS(234),
    [anon_sym_available_externally] = ACTIONS(234),
    [anon_sym_appending] = ACTIONS(234),
    [anon_sym_common] = ACTIONS(234),
    [anon_sym_extern_weak] = ACTIONS(234),
    [anon_sym_external] = ACTIONS(234),
    [anon_sym_dso_local] = ACTIONS(236),
    [anon_sym_dso_local_equivalent] = ACTIONS(234),
    [anon_sym_dso_preemptable] = ACTIONS(234),
    [anon_sym_default] = ACTIONS(234),
    [anon_sym_hidden] = ACTIONS(234),
    [anon_sym_protected] = ACTIONS(234),
    [anon_sym_dllimport] = ACTIONS(234),
    [anon_sym_dllexport] = ACTIONS(234),
    [anon_sym_STAR] = ACTIONS(1022),
    [anon_sym_void] = ACTIONS(234),
    [anon_sym_half] = ACTIONS(234),
    [anon_sym_bfloat] = ACTIONS(234),
    [anon_sym_float] = ACTIONS(234),
    [anon_sym_double] = ACTIONS(234),
    [anon_sym_x86_fp80] = ACTIONS(234),
    [anon_sym_fp128] = ACTIONS(234),
    [anon_sym_ppc_fp128] = ACTIONS(234),
    [anon_sym_label] = ACTIONS(234),
    [anon_sym_metadata] = ACTIONS(234),
    [anon_sym_x86_mmx] = ACTIONS(234),
    [anon_sym_x86_amx] = ACTIONS(234),
    [anon_sym_token] = ACTIONS(234),
    [anon_sym_opaque] = ACTIONS(234),
    [anon_sym_ptr] = ACTIONS(236),
    [aux_sym_type_keyword_token1] = ACTIONS(234),
    [anon_sym_LBRACE] = ACTIONS(234),
    [anon_sym_RBRACE] = ACTIONS(234),
    [anon_sym_LT_LBRACE] = ACTIONS(234),
    [anon_sym_LBRACK] = ACTIONS(234),
    [anon_sym_RBRACK] = ACTIONS(234),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(234),
    [anon_sym_COMMA] = ACTIONS(234),
    [anon_sym_addrspace] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_RPAREN] = ACTIONS(234),
    [anon_sym_none] = ACTIONS(234),
    [anon_sym_extractelement] = ACTIONS(234),
    [anon_sym_insertelement] = ACTIONS(234),
    [anon_sym_select] = ACTIONS(234),
    [anon_sym_shufflevector] = ACTIONS(234),
    [anon_sym_fneg] = ACTIONS(234),
    [anon_sym_to] = ACTIONS(236),
    [anon_sym_unwind] = ACTIONS(234),
    [anon_sym_icmp] = ACTIONS(234),
    [anon_sym_fcmp] = ACTIONS(234),
    [anon_sym_getelementptr] = ACTIONS(234),
    [anon_sym_extractvalue] = ACTIONS(234),
    [anon_sym_insertvalue] = ACTIONS(234),
    [anon_sym_true] = ACTIONS(234),
    [anon_sym_false] = ACTIONS(234),
    [anon_sym_null] = ACTIONS(234),
    [anon_sym_undef] = ACTIONS(234),
    [anon_sym_poison] = ACTIONS(234),
    [anon_sym_zeroinitializer] = ACTIONS(234),
    [anon_sym_blockaddress] = ACTIONS(234),
    [anon_sym_mul] = ACTIONS(234),
    [anon_sym_urem] = ACTIONS(234),
    [anon_sym_srem] = ACTIONS(234),
    [anon_sym_shl] = ACTIONS(234),
    [anon_sym_udiv] = ACTIONS(234),
    [anon_sym_sdiv] = ACTIONS(234),
    [anon_sym_lshr] = ACTIONS(234),
    [anon_sym_ashr] = ACTIONS(234),
    [anon_sym_fmul] = ACTIONS(234),
    [anon_sym_fdiv] = ACTIONS(234),
    [anon_sym_frem] = ACTIONS(234),
    [anon_sym_xchg] = ACTIONS(234),
    [anon_sym_add] = ACTIONS(236),
    [anon_sym_sub] = ACTIONS(234),
    [anon_sym_and] = ACTIONS(234),
    [anon_sym_nand] = ACTIONS(234),
    [anon_sym_or] = ACTIONS(234),
    [anon_sym_xor] = ACTIONS(234),
    [anon_sym_max] = ACTIONS(234),
    [anon_sym_min] = ACTIONS(234),
    [anon_sym_umax] = ACTIONS(234),
    [anon_sym_umin] = ACTIONS(234),
    [anon_sym_fadd] = ACTIONS(234),
    [anon_sym_fsub] = ACTIONS(234),
    [anon_sym_bitcast] = ACTIONS(234),
    [anon_sym_trunc] = ACTIONS(234),
    [anon_sym_zext] = ACTIONS(234),
    [anon_sym_sext] = ACTIONS(234),
    [anon_sym_fptrunc] = ACTIONS(234),
    [anon_sym_fpext] = ACTIONS(234),
    [anon_sym_addrspacecast] = ACTIONS(234),
    [anon_sym_uitofp] = ACTIONS(234),
    [anon_sym_sitofp] = ACTIONS(234),
    [anon_sym_fptoui] = ACTIONS(234),
    [anon_sym_fptosi] = ACTIONS(234),
    [anon_sym_inttoptr] = ACTIONS(234),
    [anon_sym_ptrtoint] = ACTIONS(234),
    [anon_sym_unordered] = ACTIONS(234),
    [anon_sym_monotonic] = ACTIONS(234),
    [anon_sym_acquire] = ACTIONS(234),
    [anon_sym_release] = ACTIONS(234),
    [anon_sym_acq_rel] = ACTIONS(234),
    [anon_sym_seq_cst] = ACTIONS(234),
    [anon_sym_syncscope] = ACTIONS(234),
    [anon_sym_uselistorder] = ACTIONS(236),
    [anon_sym_uselistorder_bb] = ACTIONS(234),
    [anon_sym_module] = ACTIONS(234),
    [anon_sym_asm] = ACTIONS(234),
    [anon_sym_attributes] = ACTIONS(234),
  },
  [261] = {
    [sym_addrspace] = STATE(284),
    [sym_argument_list] = STATE(276),
    [aux_sym_type_repeat1] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(263),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(263),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [aux_sym_metadata_ref_token1] = ACTIONS(263),
    [sym_summary_ref] = ACTIONS(263),
    [sym_string] = ACTIONS(263),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(263),
    [sym_float] = ACTIONS(263),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_target] = ACTIONS(263),
    [anon_sym_source_filename] = ACTIONS(263),
    [anon_sym_declare] = ACTIONS(263),
    [anon_sym_define] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(263),
    [anon_sym_private] = ACTIONS(263),
    [anon_sym_internal] = ACTIONS(263),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(263),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(263),
    [anon_sym_available_externally] = ACTIONS(263),
    [anon_sym_appending] = ACTIONS(263),
    [anon_sym_common] = ACTIONS(263),
    [anon_sym_extern_weak] = ACTIONS(263),
    [anon_sym_external] = ACTIONS(263),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(263),
    [anon_sym_dso_preemptable] = ACTIONS(263),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_hidden] = ACTIONS(263),
    [anon_sym_protected] = ACTIONS(263),
    [anon_sym_dllimport] = ACTIONS(263),
    [anon_sym_dllexport] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(1024),
    [anon_sym_void] = ACTIONS(263),
    [anon_sym_half] = ACTIONS(263),
    [anon_sym_bfloat] = ACTIONS(263),
    [anon_sym_float] = ACTIONS(263),
    [anon_sym_double] = ACTIONS(263),
    [anon_sym_x86_fp80] = ACTIONS(263),
    [anon_sym_fp128] = ACTIONS(263),
    [anon_sym_ppc_fp128] = ACTIONS(263),
    [anon_sym_label] = ACTIONS(263),
    [anon_sym_metadata] = ACTIONS(263),
    [anon_sym_x86_mmx] = ACTIONS(263),
    [anon_sym_x86_amx] = ACTIONS(263),
    [anon_sym_token] = ACTIONS(263),
    [anon_sym_opaque] = ACTIONS(263),
    [anon_sym_ptr] = ACTIONS(265),
    [aux_sym_type_keyword_token1] = ACTIONS(263),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_RBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_addrspace] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_RPAREN] = ACTIONS(263),
    [anon_sym_none] = ACTIONS(263),
    [anon_sym_extractelement] = ACTIONS(263),
    [anon_sym_insertelement] = ACTIONS(263),
    [anon_sym_select] = ACTIONS(263),
    [anon_sym_shufflevector] = ACTIONS(263),
    [anon_sym_fneg] = ACTIONS(263),
    [anon_sym_to] = ACTIONS(265),
    [anon_sym_unwind] = ACTIONS(263),
    [anon_sym_icmp] = ACTIONS(263),
    [anon_sym_fcmp] = ACTIONS(263),
    [anon_sym_getelementptr] = ACTIONS(263),
    [anon_sym_extractvalue] = ACTIONS(263),
    [anon_sym_insertvalue] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(263),
    [anon_sym_false] = ACTIONS(263),
    [anon_sym_null] = ACTIONS(263),
    [anon_sym_undef] = ACTIONS(263),
    [anon_sym_poison] = ACTIONS(263),
    [anon_sym_zeroinitializer] = ACTIONS(263),
    [anon_sym_blockaddress] = ACTIONS(263),
    [anon_sym_mul] = ACTIONS(263),
    [anon_sym_urem] = ACTIONS(263),
    [anon_sym_srem] = ACTIONS(263),
    [anon_sym_shl] = ACTIONS(263),
    [anon_sym_udiv] = ACTIONS(263),
    [anon_sym_sdiv] = ACTIONS(263),
    [anon_sym_lshr] = ACTIONS(263),
    [anon_sym_ashr] = ACTIONS(263),
    [anon_sym_fmul] = ACTIONS(263),
    [anon_sym_fdiv] = ACTIONS(263),
    [anon_sym_frem] = ACTIONS(263),
    [anon_sym_xchg] = ACTIONS(263),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(263),
    [anon_sym_and] = ACTIONS(263),
    [anon_sym_nand] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(263),
    [anon_sym_xor] = ACTIONS(263),
    [anon_sym_max] = ACTIONS(263),
    [anon_sym_min] = ACTIONS(263),
    [anon_sym_umax] = ACTIONS(263),
    [anon_sym_umin] = ACTIONS(263),
    [anon_sym_fadd] = ACTIONS(263),
    [anon_sym_fsub] = ACTIONS(263),
    [anon_sym_bitcast] = ACTIONS(263),
    [anon_sym_trunc] = ACTIONS(263),
    [anon_sym_zext] = ACTIONS(263),
    [anon_sym_sext] = ACTIONS(263),
    [anon_sym_fptrunc] = ACTIONS(263),
    [anon_sym_fpext] = ACTIONS(263),
    [anon_sym_addrspacecast] = ACTIONS(263),
    [anon_sym_uitofp] = ACTIONS(263),
    [anon_sym_sitofp] = ACTIONS(263),
    [anon_sym_fptoui] = ACTIONS(263),
    [anon_sym_fptosi] = ACTIONS(263),
    [anon_sym_inttoptr] = ACTIONS(263),
    [anon_sym_ptrtoint] = ACTIONS(263),
    [anon_sym_unordered] = ACTIONS(263),
    [anon_sym_monotonic] = ACTIONS(263),
    [anon_sym_acquire] = ACTIONS(263),
    [anon_sym_release] = ACTIONS(263),
    [anon_sym_acq_rel] = ACTIONS(263),
    [anon_sym_seq_cst] = ACTIONS(263),
    [anon_sym_syncscope] = ACTIONS(263),
    [anon_sym_uselistorder] = ACTIONS(265),
    [anon_sym_uselistorder_bb] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(263),
    [anon_sym_asm] = ACTIONS(263),
    [anon_sym_attributes] = ACTIONS(263),
  },
  [262] = {
    [ts_builtin_sym_end] = ACTIONS(269),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(269),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [aux_sym_metadata_ref_token1] = ACTIONS(269),
    [sym_summary_ref] = ACTIONS(269),
    [sym_string] = ACTIONS(269),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(269),
    [sym_float] = ACTIONS(269),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_target] = ACTIONS(269),
    [anon_sym_source_filename] = ACTIONS(269),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_define] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_internal] = ACTIONS(269),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(269),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(269),
    [anon_sym_available_externally] = ACTIONS(269),
    [anon_sym_appending] = ACTIONS(269),
    [anon_sym_common] = ACTIONS(269),
    [anon_sym_extern_weak] = ACTIONS(269),
    [anon_sym_external] = ACTIONS(269),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(269),
    [anon_sym_dso_preemptable] = ACTIONS(269),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_hidden] = ACTIONS(269),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_dllimport] = ACTIONS(269),
    [anon_sym_dllexport] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(269),
    [anon_sym_void] = ACTIONS(269),
    [anon_sym_half] = ACTIONS(269),
    [anon_sym_bfloat] = ACTIONS(269),
    [anon_sym_float] = ACTIONS(269),
    [anon_sym_double] = ACTIONS(269),
    [anon_sym_x86_fp80] = ACTIONS(269),
    [anon_sym_fp128] = ACTIONS(269),
    [anon_sym_ppc_fp128] = ACTIONS(269),
    [anon_sym_label] = ACTIONS(269),
    [anon_sym_metadata] = ACTIONS(269),
    [anon_sym_x86_mmx] = ACTIONS(269),
    [anon_sym_x86_amx] = ACTIONS(269),
    [anon_sym_token] = ACTIONS(269),
    [anon_sym_opaque] = ACTIONS(269),
    [anon_sym_ptr] = ACTIONS(271),
    [aux_sym_type_keyword_token1] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_RBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_GT] = ACTIONS(269),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_RPAREN] = ACTIONS(269),
    [anon_sym_none] = ACTIONS(269),
    [anon_sym_extractelement] = ACTIONS(269),
    [anon_sym_insertelement] = ACTIONS(269),
    [anon_sym_select] = ACTIONS(269),
    [anon_sym_shufflevector] = ACTIONS(269),
    [anon_sym_fneg] = ACTIONS(269),
    [anon_sym_to] = ACTIONS(271),
    [anon_sym_unwind] = ACTIONS(269),
    [anon_sym_icmp] = ACTIONS(269),
    [anon_sym_fcmp] = ACTIONS(269),
    [anon_sym_cleanup] = ACTIONS(269),
    [anon_sym_getelementptr] = ACTIONS(269),
    [anon_sym_extractvalue] = ACTIONS(269),
    [anon_sym_insertvalue] = ACTIONS(269),
    [anon_sym_true] = ACTIONS(269),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_null] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(269),
    [anon_sym_poison] = ACTIONS(269),
    [anon_sym_zeroinitializer] = ACTIONS(269),
    [anon_sym_catch] = ACTIONS(269),
    [anon_sym_filter] = ACTIONS(269),
    [anon_sym_blockaddress] = ACTIONS(269),
    [anon_sym_mul] = ACTIONS(269),
    [anon_sym_urem] = ACTIONS(269),
    [anon_sym_srem] = ACTIONS(269),
    [anon_sym_shl] = ACTIONS(269),
    [anon_sym_udiv] = ACTIONS(269),
    [anon_sym_sdiv] = ACTIONS(269),
    [anon_sym_lshr] = ACTIONS(269),
    [anon_sym_ashr] = ACTIONS(269),
    [anon_sym_fmul] = ACTIONS(269),
    [anon_sym_fdiv] = ACTIONS(269),
    [anon_sym_frem] = ACTIONS(269),
    [anon_sym_xchg] = ACTIONS(269),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(269),
    [anon_sym_and] = ACTIONS(269),
    [anon_sym_nand] = ACTIONS(269),
    [anon_sym_or] = ACTIONS(269),
    [anon_sym_xor] = ACTIONS(269),
    [anon_sym_max] = ACTIONS(269),
    [anon_sym_min] = ACTIONS(269),
    [anon_sym_umax] = ACTIONS(269),
    [anon_sym_umin] = ACTIONS(269),
    [anon_sym_fadd] = ACTIONS(269),
    [anon_sym_fsub] = ACTIONS(269),
    [anon_sym_bitcast] = ACTIONS(269),
    [anon_sym_trunc] = ACTIONS(269),
    [anon_sym_zext] = ACTIONS(269),
    [anon_sym_sext] = ACTIONS(269),
    [anon_sym_fptrunc] = ACTIONS(269),
    [anon_sym_fpext] = ACTIONS(269),
    [anon_sym_addrspacecast] = ACTIONS(269),
    [anon_sym_uitofp] = ACTIONS(269),
    [anon_sym_sitofp] = ACTIONS(269),
    [anon_sym_fptoui] = ACTIONS(269),
    [anon_sym_fptosi] = ACTIONS(269),
    [anon_sym_inttoptr] = ACTIONS(269),
    [anon_sym_ptrtoint] = ACTIONS(269),
    [anon_sym_unordered] = ACTIONS(269),
    [anon_sym_monotonic] = ACTIONS(269),
    [anon_sym_acquire] = ACTIONS(269),
    [anon_sym_release] = ACTIONS(269),
    [anon_sym_acq_rel] = ACTIONS(269),
    [anon_sym_seq_cst] = ACTIONS(269),
    [anon_sym_syncscope] = ACTIONS(269),
    [anon_sym_uselistorder] = ACTIONS(271),
    [anon_sym_uselistorder_bb] = ACTIONS(269),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_asm] = ACTIONS(269),
    [anon_sym_attributes] = ACTIONS(269),
  },
  [263] = {
    [ts_builtin_sym_end] = ACTIONS(839),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(839),
    [sym_comdat_ref] = ACTIONS(839),
    [sym_global_var] = ACTIONS(839),
    [sym_local_var] = ACTIONS(839),
    [aux_sym_metadata_ref_token1] = ACTIONS(839),
    [sym_summary_ref] = ACTIONS(839),
    [sym_string] = ACTIONS(839),
    [anon_sym_target] = ACTIONS(839),
    [anon_sym_EQ] = ACTIONS(839),
    [anon_sym_source_filename] = ACTIONS(839),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_define] = ACTIONS(839),
    [anon_sym_unnamed_addr] = ACTIONS(839),
    [anon_sym_local_unnamed_addr] = ACTIONS(839),
    [anon_sym_void] = ACTIONS(839),
    [anon_sym_half] = ACTIONS(839),
    [anon_sym_bfloat] = ACTIONS(839),
    [anon_sym_float] = ACTIONS(839),
    [anon_sym_double] = ACTIONS(839),
    [anon_sym_x86_fp80] = ACTIONS(839),
    [anon_sym_fp128] = ACTIONS(839),
    [anon_sym_ppc_fp128] = ACTIONS(839),
    [anon_sym_label] = ACTIONS(839),
    [anon_sym_metadata] = ACTIONS(839),
    [anon_sym_x86_mmx] = ACTIONS(839),
    [anon_sym_x86_amx] = ACTIONS(839),
    [anon_sym_token] = ACTIONS(839),
    [anon_sym_opaque] = ACTIONS(839),
    [anon_sym_ptr] = ACTIONS(839),
    [aux_sym_type_keyword_token1] = ACTIONS(839),
    [anon_sym_LBRACE] = ACTIONS(839),
    [anon_sym_RBRACE] = ACTIONS(839),
    [anon_sym_LT_LBRACE] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_addrspace] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_RPAREN] = ACTIONS(839),
    [anon_sym_align] = ACTIONS(841),
    [anon_sym_section] = ACTIONS(839),
    [anon_sym_partition] = ACTIONS(839),
    [anon_sym_comdat] = ACTIONS(839),
    [anon_sym_gc] = ACTIONS(839),
    [anon_sym_prefix] = ACTIONS(839),
    [anon_sym_prologue] = ACTIONS(839),
    [anon_sym_personality] = ACTIONS(839),
    [anon_sym_alignstack] = ACTIONS(839),
    [anon_sym_allocsize] = ACTIONS(839),
    [anon_sym_alwaysinline] = ACTIONS(839),
    [anon_sym_builtin] = ACTIONS(839),
    [anon_sym_cold] = ACTIONS(839),
    [anon_sym_convergent] = ACTIONS(839),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(839),
    [anon_sym_hot] = ACTIONS(839),
    [anon_sym_inaccessiblememonly] = ACTIONS(839),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(839),
    [anon_sym_inlinehint] = ACTIONS(839),
    [anon_sym_jumptable] = ACTIONS(839),
    [anon_sym_minsize] = ACTIONS(839),
    [anon_sym_naked] = ACTIONS(839),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(839),
    [anon_sym_nobuiltin] = ACTIONS(839),
    [anon_sym_noduplicate] = ACTIONS(839),
    [anon_sym_nofree] = ACTIONS(839),
    [anon_sym_noimplicitfloat] = ACTIONS(839),
    [anon_sym_noinline] = ACTIONS(839),
    [anon_sym_nomerge] = ACTIONS(839),
    [anon_sym_nonlazybind] = ACTIONS(839),
    [anon_sym_noprofile] = ACTIONS(839),
    [anon_sym_noredzone] = ACTIONS(839),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(839),
    [anon_sym_noreturn] = ACTIONS(839),
    [anon_sym_norecurse] = ACTIONS(839),
    [anon_sym_willreturn] = ACTIONS(839),
    [anon_sym_nosync] = ACTIONS(839),
    [anon_sym_nounwind] = ACTIONS(839),
    [anon_sym_nocallback] = ACTIONS(839),
    [anon_sym_nosanitize_coverage] = ACTIONS(839),
    [anon_sym_null_pointer_is_valid] = ACTIONS(839),
    [anon_sym_optforfuzzing] = ACTIONS(839),
    [anon_sym_optnone] = ACTIONS(839),
    [anon_sym_optsize] = ACTIONS(839),
    [anon_sym_readnone] = ACTIONS(839),
    [anon_sym_readonly] = ACTIONS(839),
    [anon_sym_writeonly] = ACTIONS(839),
    [anon_sym_argmemonly] = ACTIONS(839),
    [anon_sym_returns_twice] = ACTIONS(839),
    [anon_sym_safestack] = ACTIONS(839),
    [anon_sym_sanitize_address] = ACTIONS(839),
    [anon_sym_sanitize_memory] = ACTIONS(839),
    [anon_sym_sanitize_thread] = ACTIONS(839),
    [anon_sym_sanitize_hwaddress] = ACTIONS(839),
    [anon_sym_sanitize_memtag] = ACTIONS(839),
    [anon_sym_speculative_load_hardening] = ACTIONS(839),
    [anon_sym_speculatable] = ACTIONS(839),
    [anon_sym_ssp] = ACTIONS(841),
    [anon_sym_sspstrong] = ACTIONS(839),
    [anon_sym_sspreq] = ACTIONS(839),
    [anon_sym_strictfp] = ACTIONS(839),
    [anon_sym_nocf_check] = ACTIONS(839),
    [anon_sym_shadowcallstack] = ACTIONS(839),
    [anon_sym_mustprogress] = ACTIONS(839),
    [anon_sym_vscale_range] = ACTIONS(839),
    [anon_sym_preallocated] = ACTIONS(839),
    [anon_sym_zeroext] = ACTIONS(839),
    [anon_sym_signext] = ACTIONS(839),
    [anon_sym_inreg] = ACTIONS(839),
    [anon_sym_byval] = ACTIONS(839),
    [anon_sym_byref] = ACTIONS(839),
    [anon_sym_inalloca] = ACTIONS(839),
    [anon_sym_sret] = ACTIONS(839),
    [anon_sym_elementtype] = ACTIONS(839),
    [anon_sym_noalias] = ACTIONS(839),
    [anon_sym_nocapture] = ACTIONS(839),
    [anon_sym_nest] = ACTIONS(839),
    [anon_sym_returned] = ACTIONS(839),
    [anon_sym_nonnull] = ACTIONS(839),
    [anon_sym_dereferenceable] = ACTIONS(841),
    [anon_sym_dereferenceable_or_null] = ACTIONS(839),
    [anon_sym_swiftself] = ACTIONS(839),
    [anon_sym_swiftasync] = ACTIONS(839),
    [anon_sym_swifterror] = ACTIONS(839),
    [anon_sym_immarg] = ACTIONS(839),
    [anon_sym_noundef] = ACTIONS(839),
    [anon_sym_uwtable] = ACTIONS(839),
    [anon_sym_memory] = ACTIONS(839),
    [anon_sym_to] = ACTIONS(841),
    [anon_sym_null] = ACTIONS(841),
    [anon_sym_uselistorder] = ACTIONS(841),
    [anon_sym_uselistorder_bb] = ACTIONS(839),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_attributes] = ACTIONS(839),
  },
  [264] = {
    [ts_builtin_sym_end] = ACTIONS(359),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(359),
    [sym_global_var] = ACTIONS(359),
    [sym_local_var] = ACTIONS(359),
    [aux_sym_metadata_ref_token1] = ACTIONS(359),
    [sym_summary_ref] = ACTIONS(359),
    [sym_string] = ACTIONS(359),
    [aux_sym_number_token1] = ACTIONS(361),
    [aux_sym_number_token2] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_cstring] = ACTIONS(359),
    [anon_sym_target] = ACTIONS(359),
    [anon_sym_source_filename] = ACTIONS(359),
    [anon_sym_declare] = ACTIONS(359),
    [anon_sym_define] = ACTIONS(359),
    [anon_sym_no_cfi] = ACTIONS(359),
    [anon_sym_private] = ACTIONS(359),
    [anon_sym_internal] = ACTIONS(359),
    [anon_sym_weak] = ACTIONS(361),
    [anon_sym_weak_odr] = ACTIONS(359),
    [anon_sym_linkonce] = ACTIONS(361),
    [anon_sym_linkonce_odr] = ACTIONS(359),
    [anon_sym_available_externally] = ACTIONS(359),
    [anon_sym_appending] = ACTIONS(359),
    [anon_sym_common] = ACTIONS(359),
    [anon_sym_extern_weak] = ACTIONS(359),
    [anon_sym_external] = ACTIONS(359),
    [anon_sym_dso_local] = ACTIONS(361),
    [anon_sym_dso_local_equivalent] = ACTIONS(359),
    [anon_sym_dso_preemptable] = ACTIONS(359),
    [anon_sym_default] = ACTIONS(359),
    [anon_sym_hidden] = ACTIONS(359),
    [anon_sym_protected] = ACTIONS(359),
    [anon_sym_dllimport] = ACTIONS(359),
    [anon_sym_dllexport] = ACTIONS(359),
    [anon_sym_STAR] = ACTIONS(359),
    [anon_sym_void] = ACTIONS(359),
    [anon_sym_half] = ACTIONS(359),
    [anon_sym_bfloat] = ACTIONS(359),
    [anon_sym_float] = ACTIONS(359),
    [anon_sym_double] = ACTIONS(359),
    [anon_sym_x86_fp80] = ACTIONS(359),
    [anon_sym_fp128] = ACTIONS(359),
    [anon_sym_ppc_fp128] = ACTIONS(359),
    [anon_sym_label] = ACTIONS(359),
    [anon_sym_metadata] = ACTIONS(359),
    [anon_sym_x86_mmx] = ACTIONS(359),
    [anon_sym_x86_amx] = ACTIONS(359),
    [anon_sym_token] = ACTIONS(359),
    [anon_sym_opaque] = ACTIONS(359),
    [anon_sym_ptr] = ACTIONS(361),
    [aux_sym_type_keyword_token1] = ACTIONS(359),
    [anon_sym_LBRACE] = ACTIONS(359),
    [anon_sym_RBRACE] = ACTIONS(359),
    [anon_sym_LT_LBRACE] = ACTIONS(359),
    [anon_sym_LBRACK] = ACTIONS(359),
    [anon_sym_RBRACK] = ACTIONS(359),
    [anon_sym_LT] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(359),
    [anon_sym_COMMA] = ACTIONS(359),
    [anon_sym_addrspace] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(359),
    [anon_sym_RPAREN] = ACTIONS(359),
    [anon_sym_none] = ACTIONS(359),
    [anon_sym_extractelement] = ACTIONS(359),
    [anon_sym_insertelement] = ACTIONS(359),
    [anon_sym_select] = ACTIONS(359),
    [anon_sym_shufflevector] = ACTIONS(359),
    [anon_sym_fneg] = ACTIONS(359),
    [anon_sym_to] = ACTIONS(361),
    [anon_sym_unwind] = ACTIONS(359),
    [anon_sym_icmp] = ACTIONS(359),
    [anon_sym_fcmp] = ACTIONS(359),
    [anon_sym_cleanup] = ACTIONS(359),
    [anon_sym_getelementptr] = ACTIONS(359),
    [anon_sym_extractvalue] = ACTIONS(359),
    [anon_sym_insertvalue] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(359),
    [anon_sym_false] = ACTIONS(359),
    [anon_sym_null] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(359),
    [anon_sym_poison] = ACTIONS(359),
    [anon_sym_zeroinitializer] = ACTIONS(359),
    [anon_sym_catch] = ACTIONS(359),
    [anon_sym_filter] = ACTIONS(359),
    [anon_sym_blockaddress] = ACTIONS(359),
    [anon_sym_mul] = ACTIONS(359),
    [anon_sym_urem] = ACTIONS(359),
    [anon_sym_srem] = ACTIONS(359),
    [anon_sym_shl] = ACTIONS(359),
    [anon_sym_udiv] = ACTIONS(359),
    [anon_sym_sdiv] = ACTIONS(359),
    [anon_sym_lshr] = ACTIONS(359),
    [anon_sym_ashr] = ACTIONS(359),
    [anon_sym_fmul] = ACTIONS(359),
    [anon_sym_fdiv] = ACTIONS(359),
    [anon_sym_frem] = ACTIONS(359),
    [anon_sym_xchg] = ACTIONS(359),
    [anon_sym_add] = ACTIONS(361),
    [anon_sym_sub] = ACTIONS(359),
    [anon_sym_and] = ACTIONS(359),
    [anon_sym_nand] = ACTIONS(359),
    [anon_sym_or] = ACTIONS(359),
    [anon_sym_xor] = ACTIONS(359),
    [anon_sym_max] = ACTIONS(359),
    [anon_sym_min] = ACTIONS(359),
    [anon_sym_umax] = ACTIONS(359),
    [anon_sym_umin] = ACTIONS(359),
    [anon_sym_fadd] = ACTIONS(359),
    [anon_sym_fsub] = ACTIONS(359),
    [anon_sym_bitcast] = ACTIONS(359),
    [anon_sym_trunc] = ACTIONS(359),
    [anon_sym_zext] = ACTIONS(359),
    [anon_sym_sext] = ACTIONS(359),
    [anon_sym_fptrunc] = ACTIONS(359),
    [anon_sym_fpext] = ACTIONS(359),
    [anon_sym_addrspacecast] = ACTIONS(359),
    [anon_sym_uitofp] = ACTIONS(359),
    [anon_sym_sitofp] = ACTIONS(359),
    [anon_sym_fptoui] = ACTIONS(359),
    [anon_sym_fptosi] = ACTIONS(359),
    [anon_sym_inttoptr] = ACTIONS(359),
    [anon_sym_ptrtoint] = ACTIONS(359),
    [anon_sym_unordered] = ACTIONS(359),
    [anon_sym_monotonic] = ACTIONS(359),
    [anon_sym_acquire] = ACTIONS(359),
    [anon_sym_release] = ACTIONS(359),
    [anon_sym_acq_rel] = ACTIONS(359),
    [anon_sym_seq_cst] = ACTIONS(359),
    [anon_sym_syncscope] = ACTIONS(359),
    [anon_sym_uselistorder] = ACTIONS(361),
    [anon_sym_uselistorder_bb] = ACTIONS(359),
    [anon_sym_module] = ACTIONS(359),
    [anon_sym_asm] = ACTIONS(359),
    [anon_sym_attributes] = ACTIONS(359),
  },
  [265] = {
    [ts_builtin_sym_end] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(375),
    [sym_global_var] = ACTIONS(375),
    [sym_local_var] = ACTIONS(375),
    [aux_sym_metadata_ref_token1] = ACTIONS(375),
    [sym_summary_ref] = ACTIONS(375),
    [sym_string] = ACTIONS(375),
    [aux_sym_number_token1] = ACTIONS(377),
    [aux_sym_number_token2] = ACTIONS(375),
    [sym_float] = ACTIONS(375),
    [sym_cstring] = ACTIONS(375),
    [anon_sym_target] = ACTIONS(375),
    [anon_sym_source_filename] = ACTIONS(375),
    [anon_sym_declare] = ACTIONS(375),
    [anon_sym_define] = ACTIONS(375),
    [anon_sym_no_cfi] = ACTIONS(375),
    [anon_sym_private] = ACTIONS(375),
    [anon_sym_internal] = ACTIONS(375),
    [anon_sym_weak] = ACTIONS(377),
    [anon_sym_weak_odr] = ACTIONS(375),
    [anon_sym_linkonce] = ACTIONS(377),
    [anon_sym_linkonce_odr] = ACTIONS(375),
    [anon_sym_available_externally] = ACTIONS(375),
    [anon_sym_appending] = ACTIONS(375),
    [anon_sym_common] = ACTIONS(375),
    [anon_sym_extern_weak] = ACTIONS(375),
    [anon_sym_external] = ACTIONS(375),
    [anon_sym_dso_local] = ACTIONS(377),
    [anon_sym_dso_local_equivalent] = ACTIONS(375),
    [anon_sym_dso_preemptable] = ACTIONS(375),
    [anon_sym_default] = ACTIONS(375),
    [anon_sym_hidden] = ACTIONS(375),
    [anon_sym_protected] = ACTIONS(375),
    [anon_sym_dllimport] = ACTIONS(375),
    [anon_sym_dllexport] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(375),
    [anon_sym_void] = ACTIONS(375),
    [anon_sym_half] = ACTIONS(375),
    [anon_sym_bfloat] = ACTIONS(375),
    [anon_sym_float] = ACTIONS(375),
    [anon_sym_double] = ACTIONS(375),
    [anon_sym_x86_fp80] = ACTIONS(375),
    [anon_sym_fp128] = ACTIONS(375),
    [anon_sym_ppc_fp128] = ACTIONS(375),
    [anon_sym_label] = ACTIONS(375),
    [anon_sym_metadata] = ACTIONS(375),
    [anon_sym_x86_mmx] = ACTIONS(375),
    [anon_sym_x86_amx] = ACTIONS(375),
    [anon_sym_token] = ACTIONS(375),
    [anon_sym_opaque] = ACTIONS(375),
    [anon_sym_ptr] = ACTIONS(377),
    [aux_sym_type_keyword_token1] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(375),
    [anon_sym_RBRACE] = ACTIONS(375),
    [anon_sym_LT_LBRACE] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_RBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_COMMA] = ACTIONS(375),
    [anon_sym_addrspace] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_RPAREN] = ACTIONS(375),
    [anon_sym_none] = ACTIONS(375),
    [anon_sym_extractelement] = ACTIONS(375),
    [anon_sym_insertelement] = ACTIONS(375),
    [anon_sym_select] = ACTIONS(375),
    [anon_sym_shufflevector] = ACTIONS(375),
    [anon_sym_fneg] = ACTIONS(375),
    [anon_sym_to] = ACTIONS(377),
    [anon_sym_unwind] = ACTIONS(375),
    [anon_sym_icmp] = ACTIONS(375),
    [anon_sym_fcmp] = ACTIONS(375),
    [anon_sym_cleanup] = ACTIONS(375),
    [anon_sym_getelementptr] = ACTIONS(375),
    [anon_sym_extractvalue] = ACTIONS(375),
    [anon_sym_insertvalue] = ACTIONS(375),
    [anon_sym_true] = ACTIONS(375),
    [anon_sym_false] = ACTIONS(375),
    [anon_sym_null] = ACTIONS(375),
    [anon_sym_undef] = ACTIONS(375),
    [anon_sym_poison] = ACTIONS(375),
    [anon_sym_zeroinitializer] = ACTIONS(375),
    [anon_sym_catch] = ACTIONS(375),
    [anon_sym_filter] = ACTIONS(375),
    [anon_sym_blockaddress] = ACTIONS(375),
    [anon_sym_mul] = ACTIONS(375),
    [anon_sym_urem] = ACTIONS(375),
    [anon_sym_srem] = ACTIONS(375),
    [anon_sym_shl] = ACTIONS(375),
    [anon_sym_udiv] = ACTIONS(375),
    [anon_sym_sdiv] = ACTIONS(375),
    [anon_sym_lshr] = ACTIONS(375),
    [anon_sym_ashr] = ACTIONS(375),
    [anon_sym_fmul] = ACTIONS(375),
    [anon_sym_fdiv] = ACTIONS(375),
    [anon_sym_frem] = ACTIONS(375),
    [anon_sym_xchg] = ACTIONS(375),
    [anon_sym_add] = ACTIONS(377),
    [anon_sym_sub] = ACTIONS(375),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_nand] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_xor] = ACTIONS(375),
    [anon_sym_max] = ACTIONS(375),
    [anon_sym_min] = ACTIONS(375),
    [anon_sym_umax] = ACTIONS(375),
    [anon_sym_umin] = ACTIONS(375),
    [anon_sym_fadd] = ACTIONS(375),
    [anon_sym_fsub] = ACTIONS(375),
    [anon_sym_bitcast] = ACTIONS(375),
    [anon_sym_trunc] = ACTIONS(375),
    [anon_sym_zext] = ACTIONS(375),
    [anon_sym_sext] = ACTIONS(375),
    [anon_sym_fptrunc] = ACTIONS(375),
    [anon_sym_fpext] = ACTIONS(375),
    [anon_sym_addrspacecast] = ACTIONS(375),
    [anon_sym_uitofp] = ACTIONS(375),
    [anon_sym_sitofp] = ACTIONS(375),
    [anon_sym_fptoui] = ACTIONS(375),
    [anon_sym_fptosi] = ACTIONS(375),
    [anon_sym_inttoptr] = ACTIONS(375),
    [anon_sym_ptrtoint] = ACTIONS(375),
    [anon_sym_unordered] = ACTIONS(375),
    [anon_sym_monotonic] = ACTIONS(375),
    [anon_sym_acquire] = ACTIONS(375),
    [anon_sym_release] = ACTIONS(375),
    [anon_sym_acq_rel] = ACTIONS(375),
    [anon_sym_seq_cst] = ACTIONS(375),
    [anon_sym_syncscope] = ACTIONS(375),
    [anon_sym_uselistorder] = ACTIONS(377),
    [anon_sym_uselistorder_bb] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(375),
    [anon_sym_asm] = ACTIONS(375),
    [anon_sym_attributes] = ACTIONS(375),
  },
  [266] = {
    [ts_builtin_sym_end] = ACTIONS(835),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(835),
    [sym_comdat_ref] = ACTIONS(835),
    [sym_global_var] = ACTIONS(835),
    [sym_local_var] = ACTIONS(835),
    [aux_sym_metadata_ref_token1] = ACTIONS(835),
    [sym_summary_ref] = ACTIONS(835),
    [sym_string] = ACTIONS(835),
    [anon_sym_target] = ACTIONS(835),
    [anon_sym_EQ] = ACTIONS(835),
    [anon_sym_source_filename] = ACTIONS(835),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_define] = ACTIONS(835),
    [anon_sym_unnamed_addr] = ACTIONS(835),
    [anon_sym_local_unnamed_addr] = ACTIONS(835),
    [anon_sym_void] = ACTIONS(835),
    [anon_sym_half] = ACTIONS(835),
    [anon_sym_bfloat] = ACTIONS(835),
    [anon_sym_float] = ACTIONS(835),
    [anon_sym_double] = ACTIONS(835),
    [anon_sym_x86_fp80] = ACTIONS(835),
    [anon_sym_fp128] = ACTIONS(835),
    [anon_sym_ppc_fp128] = ACTIONS(835),
    [anon_sym_label] = ACTIONS(835),
    [anon_sym_metadata] = ACTIONS(835),
    [anon_sym_x86_mmx] = ACTIONS(835),
    [anon_sym_x86_amx] = ACTIONS(835),
    [anon_sym_token] = ACTIONS(835),
    [anon_sym_opaque] = ACTIONS(835),
    [anon_sym_ptr] = ACTIONS(835),
    [aux_sym_type_keyword_token1] = ACTIONS(835),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_RBRACE] = ACTIONS(835),
    [anon_sym_LT_LBRACE] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_LT] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_addrspace] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(835),
    [anon_sym_align] = ACTIONS(837),
    [anon_sym_section] = ACTIONS(835),
    [anon_sym_partition] = ACTIONS(835),
    [anon_sym_comdat] = ACTIONS(835),
    [anon_sym_gc] = ACTIONS(835),
    [anon_sym_prefix] = ACTIONS(835),
    [anon_sym_prologue] = ACTIONS(835),
    [anon_sym_personality] = ACTIONS(835),
    [anon_sym_alignstack] = ACTIONS(835),
    [anon_sym_allocsize] = ACTIONS(835),
    [anon_sym_alwaysinline] = ACTIONS(835),
    [anon_sym_builtin] = ACTIONS(835),
    [anon_sym_cold] = ACTIONS(835),
    [anon_sym_convergent] = ACTIONS(835),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(835),
    [anon_sym_hot] = ACTIONS(835),
    [anon_sym_inaccessiblememonly] = ACTIONS(835),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(835),
    [anon_sym_inlinehint] = ACTIONS(835),
    [anon_sym_jumptable] = ACTIONS(835),
    [anon_sym_minsize] = ACTIONS(835),
    [anon_sym_naked] = ACTIONS(835),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(835),
    [anon_sym_nobuiltin] = ACTIONS(835),
    [anon_sym_noduplicate] = ACTIONS(835),
    [anon_sym_nofree] = ACTIONS(835),
    [anon_sym_noimplicitfloat] = ACTIONS(835),
    [anon_sym_noinline] = ACTIONS(835),
    [anon_sym_nomerge] = ACTIONS(835),
    [anon_sym_nonlazybind] = ACTIONS(835),
    [anon_sym_noprofile] = ACTIONS(835),
    [anon_sym_noredzone] = ACTIONS(835),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(835),
    [anon_sym_noreturn] = ACTIONS(835),
    [anon_sym_norecurse] = ACTIONS(835),
    [anon_sym_willreturn] = ACTIONS(835),
    [anon_sym_nosync] = ACTIONS(835),
    [anon_sym_nounwind] = ACTIONS(835),
    [anon_sym_nocallback] = ACTIONS(835),
    [anon_sym_nosanitize_coverage] = ACTIONS(835),
    [anon_sym_null_pointer_is_valid] = ACTIONS(835),
    [anon_sym_optforfuzzing] = ACTIONS(835),
    [anon_sym_optnone] = ACTIONS(835),
    [anon_sym_optsize] = ACTIONS(835),
    [anon_sym_readnone] = ACTIONS(835),
    [anon_sym_readonly] = ACTIONS(835),
    [anon_sym_writeonly] = ACTIONS(835),
    [anon_sym_argmemonly] = ACTIONS(835),
    [anon_sym_returns_twice] = ACTIONS(835),
    [anon_sym_safestack] = ACTIONS(835),
    [anon_sym_sanitize_address] = ACTIONS(835),
    [anon_sym_sanitize_memory] = ACTIONS(835),
    [anon_sym_sanitize_thread] = ACTIONS(835),
    [anon_sym_sanitize_hwaddress] = ACTIONS(835),
    [anon_sym_sanitize_memtag] = ACTIONS(835),
    [anon_sym_speculative_load_hardening] = ACTIONS(835),
    [anon_sym_speculatable] = ACTIONS(835),
    [anon_sym_ssp] = ACTIONS(837),
    [anon_sym_sspstrong] = ACTIONS(835),
    [anon_sym_sspreq] = ACTIONS(835),
    [anon_sym_strictfp] = ACTIONS(835),
    [anon_sym_nocf_check] = ACTIONS(835),
    [anon_sym_shadowcallstack] = ACTIONS(835),
    [anon_sym_mustprogress] = ACTIONS(835),
    [anon_sym_vscale_range] = ACTIONS(835),
    [anon_sym_preallocated] = ACTIONS(835),
    [anon_sym_zeroext] = ACTIONS(835),
    [anon_sym_signext] = ACTIONS(835),
    [anon_sym_inreg] = ACTIONS(835),
    [anon_sym_byval] = ACTIONS(835),
    [anon_sym_byref] = ACTIONS(835),
    [anon_sym_inalloca] = ACTIONS(835),
    [anon_sym_sret] = ACTIONS(835),
    [anon_sym_elementtype] = ACTIONS(835),
    [anon_sym_noalias] = ACTIONS(835),
    [anon_sym_nocapture] = ACTIONS(835),
    [anon_sym_nest] = ACTIONS(835),
    [anon_sym_returned] = ACTIONS(835),
    [anon_sym_nonnull] = ACTIONS(835),
    [anon_sym_dereferenceable] = ACTIONS(837),
    [anon_sym_dereferenceable_or_null] = ACTIONS(835),
    [anon_sym_swiftself] = ACTIONS(835),
    [anon_sym_swiftasync] = ACTIONS(835),
    [anon_sym_swifterror] = ACTIONS(835),
    [anon_sym_immarg] = ACTIONS(835),
    [anon_sym_noundef] = ACTIONS(835),
    [anon_sym_uwtable] = ACTIONS(835),
    [anon_sym_memory] = ACTIONS(835),
    [anon_sym_to] = ACTIONS(837),
    [anon_sym_null] = ACTIONS(837),
    [anon_sym_uselistorder] = ACTIONS(837),
    [anon_sym_uselistorder_bb] = ACTIONS(835),
    [anon_sym_module] = ACTIONS(835),
    [anon_sym_BANG] = ACTIONS(837),
    [anon_sym_attributes] = ACTIONS(835),
  },
  [267] = {
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(379),
    [sym_global_var] = ACTIONS(379),
    [sym_local_var] = ACTIONS(379),
    [aux_sym_metadata_ref_token1] = ACTIONS(379),
    [sym_summary_ref] = ACTIONS(379),
    [sym_string] = ACTIONS(379),
    [aux_sym_number_token1] = ACTIONS(381),
    [aux_sym_number_token2] = ACTIONS(379),
    [sym_float] = ACTIONS(379),
    [sym_cstring] = ACTIONS(379),
    [anon_sym_target] = ACTIONS(379),
    [anon_sym_source_filename] = ACTIONS(379),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_define] = ACTIONS(379),
    [anon_sym_no_cfi] = ACTIONS(379),
    [anon_sym_private] = ACTIONS(379),
    [anon_sym_internal] = ACTIONS(379),
    [anon_sym_weak] = ACTIONS(381),
    [anon_sym_weak_odr] = ACTIONS(379),
    [anon_sym_linkonce] = ACTIONS(381),
    [anon_sym_linkonce_odr] = ACTIONS(379),
    [anon_sym_available_externally] = ACTIONS(379),
    [anon_sym_appending] = ACTIONS(379),
    [anon_sym_common] = ACTIONS(379),
    [anon_sym_extern_weak] = ACTIONS(379),
    [anon_sym_external] = ACTIONS(379),
    [anon_sym_dso_local] = ACTIONS(381),
    [anon_sym_dso_local_equivalent] = ACTIONS(379),
    [anon_sym_dso_preemptable] = ACTIONS(379),
    [anon_sym_default] = ACTIONS(379),
    [anon_sym_hidden] = ACTIONS(379),
    [anon_sym_protected] = ACTIONS(379),
    [anon_sym_dllimport] = ACTIONS(379),
    [anon_sym_dllexport] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_void] = ACTIONS(379),
    [anon_sym_half] = ACTIONS(379),
    [anon_sym_bfloat] = ACTIONS(379),
    [anon_sym_float] = ACTIONS(379),
    [anon_sym_double] = ACTIONS(379),
    [anon_sym_x86_fp80] = ACTIONS(379),
    [anon_sym_fp128] = ACTIONS(379),
    [anon_sym_ppc_fp128] = ACTIONS(379),
    [anon_sym_label] = ACTIONS(379),
    [anon_sym_metadata] = ACTIONS(379),
    [anon_sym_x86_mmx] = ACTIONS(379),
    [anon_sym_x86_amx] = ACTIONS(379),
    [anon_sym_token] = ACTIONS(379),
    [anon_sym_opaque] = ACTIONS(379),
    [anon_sym_ptr] = ACTIONS(381),
    [aux_sym_type_keyword_token1] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_LT_LBRACE] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(379),
    [anon_sym_RBRACK] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_GT] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(379),
    [anon_sym_addrspace] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_RPAREN] = ACTIONS(379),
    [anon_sym_none] = ACTIONS(379),
    [anon_sym_extractelement] = ACTIONS(379),
    [anon_sym_insertelement] = ACTIONS(379),
    [anon_sym_select] = ACTIONS(379),
    [anon_sym_shufflevector] = ACTIONS(379),
    [anon_sym_fneg] = ACTIONS(379),
    [anon_sym_to] = ACTIONS(381),
    [anon_sym_unwind] = ACTIONS(379),
    [anon_sym_icmp] = ACTIONS(379),
    [anon_sym_fcmp] = ACTIONS(379),
    [anon_sym_cleanup] = ACTIONS(379),
    [anon_sym_getelementptr] = ACTIONS(379),
    [anon_sym_extractvalue] = ACTIONS(379),
    [anon_sym_insertvalue] = ACTIONS(379),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [anon_sym_null] = ACTIONS(379),
    [anon_sym_undef] = ACTIONS(379),
    [anon_sym_poison] = ACTIONS(379),
    [anon_sym_zeroinitializer] = ACTIONS(379),
    [anon_sym_catch] = ACTIONS(379),
    [anon_sym_filter] = ACTIONS(379),
    [anon_sym_blockaddress] = ACTIONS(379),
    [anon_sym_mul] = ACTIONS(379),
    [anon_sym_urem] = ACTIONS(379),
    [anon_sym_srem] = ACTIONS(379),
    [anon_sym_shl] = ACTIONS(379),
    [anon_sym_udiv] = ACTIONS(379),
    [anon_sym_sdiv] = ACTIONS(379),
    [anon_sym_lshr] = ACTIONS(379),
    [anon_sym_ashr] = ACTIONS(379),
    [anon_sym_fmul] = ACTIONS(379),
    [anon_sym_fdiv] = ACTIONS(379),
    [anon_sym_frem] = ACTIONS(379),
    [anon_sym_xchg] = ACTIONS(379),
    [anon_sym_add] = ACTIONS(381),
    [anon_sym_sub] = ACTIONS(379),
    [anon_sym_and] = ACTIONS(379),
    [anon_sym_nand] = ACTIONS(379),
    [anon_sym_or] = ACTIONS(379),
    [anon_sym_xor] = ACTIONS(379),
    [anon_sym_max] = ACTIONS(379),
    [anon_sym_min] = ACTIONS(379),
    [anon_sym_umax] = ACTIONS(379),
    [anon_sym_umin] = ACTIONS(379),
    [anon_sym_fadd] = ACTIONS(379),
    [anon_sym_fsub] = ACTIONS(379),
    [anon_sym_bitcast] = ACTIONS(379),
    [anon_sym_trunc] = ACTIONS(379),
    [anon_sym_zext] = ACTIONS(379),
    [anon_sym_sext] = ACTIONS(379),
    [anon_sym_fptrunc] = ACTIONS(379),
    [anon_sym_fpext] = ACTIONS(379),
    [anon_sym_addrspacecast] = ACTIONS(379),
    [anon_sym_uitofp] = ACTIONS(379),
    [anon_sym_sitofp] = ACTIONS(379),
    [anon_sym_fptoui] = ACTIONS(379),
    [anon_sym_fptosi] = ACTIONS(379),
    [anon_sym_inttoptr] = ACTIONS(379),
    [anon_sym_ptrtoint] = ACTIONS(379),
    [anon_sym_unordered] = ACTIONS(379),
    [anon_sym_monotonic] = ACTIONS(379),
    [anon_sym_acquire] = ACTIONS(379),
    [anon_sym_release] = ACTIONS(379),
    [anon_sym_acq_rel] = ACTIONS(379),
    [anon_sym_seq_cst] = ACTIONS(379),
    [anon_sym_syncscope] = ACTIONS(379),
    [anon_sym_uselistorder] = ACTIONS(381),
    [anon_sym_uselistorder_bb] = ACTIONS(379),
    [anon_sym_module] = ACTIONS(379),
    [anon_sym_asm] = ACTIONS(379),
    [anon_sym_attributes] = ACTIONS(379),
  },
  [268] = {
    [ts_builtin_sym_end] = ACTIONS(843),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(843),
    [sym_comdat_ref] = ACTIONS(843),
    [sym_global_var] = ACTIONS(843),
    [sym_local_var] = ACTIONS(843),
    [aux_sym_metadata_ref_token1] = ACTIONS(843),
    [sym_summary_ref] = ACTIONS(843),
    [sym_string] = ACTIONS(843),
    [anon_sym_target] = ACTIONS(843),
    [anon_sym_EQ] = ACTIONS(843),
    [anon_sym_source_filename] = ACTIONS(843),
    [anon_sym_declare] = ACTIONS(843),
    [anon_sym_define] = ACTIONS(843),
    [anon_sym_unnamed_addr] = ACTIONS(843),
    [anon_sym_local_unnamed_addr] = ACTIONS(843),
    [anon_sym_void] = ACTIONS(843),
    [anon_sym_half] = ACTIONS(843),
    [anon_sym_bfloat] = ACTIONS(843),
    [anon_sym_float] = ACTIONS(843),
    [anon_sym_double] = ACTIONS(843),
    [anon_sym_x86_fp80] = ACTIONS(843),
    [anon_sym_fp128] = ACTIONS(843),
    [anon_sym_ppc_fp128] = ACTIONS(843),
    [anon_sym_label] = ACTIONS(843),
    [anon_sym_metadata] = ACTIONS(843),
    [anon_sym_x86_mmx] = ACTIONS(843),
    [anon_sym_x86_amx] = ACTIONS(843),
    [anon_sym_token] = ACTIONS(843),
    [anon_sym_opaque] = ACTIONS(843),
    [anon_sym_ptr] = ACTIONS(843),
    [aux_sym_type_keyword_token1] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_RBRACE] = ACTIONS(843),
    [anon_sym_LT_LBRACE] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(845),
    [anon_sym_COMMA] = ACTIONS(843),
    [anon_sym_addrspace] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_RPAREN] = ACTIONS(843),
    [anon_sym_align] = ACTIONS(845),
    [anon_sym_section] = ACTIONS(843),
    [anon_sym_partition] = ACTIONS(843),
    [anon_sym_comdat] = ACTIONS(843),
    [anon_sym_gc] = ACTIONS(843),
    [anon_sym_prefix] = ACTIONS(843),
    [anon_sym_prologue] = ACTIONS(843),
    [anon_sym_personality] = ACTIONS(843),
    [anon_sym_alignstack] = ACTIONS(843),
    [anon_sym_allocsize] = ACTIONS(843),
    [anon_sym_alwaysinline] = ACTIONS(843),
    [anon_sym_builtin] = ACTIONS(843),
    [anon_sym_cold] = ACTIONS(843),
    [anon_sym_convergent] = ACTIONS(843),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(843),
    [anon_sym_hot] = ACTIONS(843),
    [anon_sym_inaccessiblememonly] = ACTIONS(843),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(843),
    [anon_sym_inlinehint] = ACTIONS(843),
    [anon_sym_jumptable] = ACTIONS(843),
    [anon_sym_minsize] = ACTIONS(843),
    [anon_sym_naked] = ACTIONS(843),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(843),
    [anon_sym_nobuiltin] = ACTIONS(843),
    [anon_sym_noduplicate] = ACTIONS(843),
    [anon_sym_nofree] = ACTIONS(843),
    [anon_sym_noimplicitfloat] = ACTIONS(843),
    [anon_sym_noinline] = ACTIONS(843),
    [anon_sym_nomerge] = ACTIONS(843),
    [anon_sym_nonlazybind] = ACTIONS(843),
    [anon_sym_noprofile] = ACTIONS(843),
    [anon_sym_noredzone] = ACTIONS(843),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(843),
    [anon_sym_noreturn] = ACTIONS(843),
    [anon_sym_norecurse] = ACTIONS(843),
    [anon_sym_willreturn] = ACTIONS(843),
    [anon_sym_nosync] = ACTIONS(843),
    [anon_sym_nounwind] = ACTIONS(843),
    [anon_sym_nocallback] = ACTIONS(843),
    [anon_sym_nosanitize_coverage] = ACTIONS(843),
    [anon_sym_null_pointer_is_valid] = ACTIONS(843),
    [anon_sym_optforfuzzing] = ACTIONS(843),
    [anon_sym_optnone] = ACTIONS(843),
    [anon_sym_optsize] = ACTIONS(843),
    [anon_sym_readnone] = ACTIONS(843),
    [anon_sym_readonly] = ACTIONS(843),
    [anon_sym_writeonly] = ACTIONS(843),
    [anon_sym_argmemonly] = ACTIONS(843),
    [anon_sym_returns_twice] = ACTIONS(843),
    [anon_sym_safestack] = ACTIONS(843),
    [anon_sym_sanitize_address] = ACTIONS(843),
    [anon_sym_sanitize_memory] = ACTIONS(843),
    [anon_sym_sanitize_thread] = ACTIONS(843),
    [anon_sym_sanitize_hwaddress] = ACTIONS(843),
    [anon_sym_sanitize_memtag] = ACTIONS(843),
    [anon_sym_speculative_load_hardening] = ACTIONS(843),
    [anon_sym_speculatable] = ACTIONS(843),
    [anon_sym_ssp] = ACTIONS(845),
    [anon_sym_sspstrong] = ACTIONS(843),
    [anon_sym_sspreq] = ACTIONS(843),
    [anon_sym_strictfp] = ACTIONS(843),
    [anon_sym_nocf_check] = ACTIONS(843),
    [anon_sym_shadowcallstack] = ACTIONS(843),
    [anon_sym_mustprogress] = ACTIONS(843),
    [anon_sym_vscale_range] = ACTIONS(843),
    [anon_sym_preallocated] = ACTIONS(843),
    [anon_sym_zeroext] = ACTIONS(843),
    [anon_sym_signext] = ACTIONS(843),
    [anon_sym_inreg] = ACTIONS(843),
    [anon_sym_byval] = ACTIONS(843),
    [anon_sym_byref] = ACTIONS(843),
    [anon_sym_inalloca] = ACTIONS(843),
    [anon_sym_sret] = ACTIONS(843),
    [anon_sym_elementtype] = ACTIONS(843),
    [anon_sym_noalias] = ACTIONS(843),
    [anon_sym_nocapture] = ACTIONS(843),
    [anon_sym_nest] = ACTIONS(843),
    [anon_sym_returned] = ACTIONS(843),
    [anon_sym_nonnull] = ACTIONS(843),
    [anon_sym_dereferenceable] = ACTIONS(845),
    [anon_sym_dereferenceable_or_null] = ACTIONS(843),
    [anon_sym_swiftself] = ACTIONS(843),
    [anon_sym_swiftasync] = ACTIONS(843),
    [anon_sym_swifterror] = ACTIONS(843),
    [anon_sym_immarg] = ACTIONS(843),
    [anon_sym_noundef] = ACTIONS(843),
    [anon_sym_uwtable] = ACTIONS(843),
    [anon_sym_memory] = ACTIONS(843),
    [anon_sym_to] = ACTIONS(845),
    [anon_sym_null] = ACTIONS(845),
    [anon_sym_uselistorder] = ACTIONS(845),
    [anon_sym_uselistorder_bb] = ACTIONS(843),
    [anon_sym_module] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(845),
    [anon_sym_attributes] = ACTIONS(843),
  },
  [269] = {
    [ts_builtin_sym_end] = ACTIONS(851),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(851),
    [sym_comdat_ref] = ACTIONS(851),
    [sym_global_var] = ACTIONS(851),
    [sym_local_var] = ACTIONS(851),
    [aux_sym_metadata_ref_token1] = ACTIONS(851),
    [sym_summary_ref] = ACTIONS(851),
    [sym_string] = ACTIONS(851),
    [anon_sym_target] = ACTIONS(851),
    [anon_sym_EQ] = ACTIONS(851),
    [anon_sym_source_filename] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_define] = ACTIONS(851),
    [anon_sym_unnamed_addr] = ACTIONS(851),
    [anon_sym_local_unnamed_addr] = ACTIONS(851),
    [anon_sym_void] = ACTIONS(851),
    [anon_sym_half] = ACTIONS(851),
    [anon_sym_bfloat] = ACTIONS(851),
    [anon_sym_float] = ACTIONS(851),
    [anon_sym_double] = ACTIONS(851),
    [anon_sym_x86_fp80] = ACTIONS(851),
    [anon_sym_fp128] = ACTIONS(851),
    [anon_sym_ppc_fp128] = ACTIONS(851),
    [anon_sym_label] = ACTIONS(851),
    [anon_sym_metadata] = ACTIONS(851),
    [anon_sym_x86_mmx] = ACTIONS(851),
    [anon_sym_x86_amx] = ACTIONS(851),
    [anon_sym_token] = ACTIONS(851),
    [anon_sym_opaque] = ACTIONS(851),
    [anon_sym_ptr] = ACTIONS(851),
    [aux_sym_type_keyword_token1] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(851),
    [anon_sym_RBRACE] = ACTIONS(851),
    [anon_sym_LT_LBRACE] = ACTIONS(851),
    [anon_sym_LBRACK] = ACTIONS(851),
    [anon_sym_LT] = ACTIONS(853),
    [anon_sym_COMMA] = ACTIONS(851),
    [anon_sym_addrspace] = ACTIONS(851),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_RPAREN] = ACTIONS(851),
    [anon_sym_align] = ACTIONS(853),
    [anon_sym_section] = ACTIONS(851),
    [anon_sym_partition] = ACTIONS(851),
    [anon_sym_comdat] = ACTIONS(851),
    [anon_sym_gc] = ACTIONS(851),
    [anon_sym_prefix] = ACTIONS(851),
    [anon_sym_prologue] = ACTIONS(851),
    [anon_sym_personality] = ACTIONS(851),
    [anon_sym_alignstack] = ACTIONS(851),
    [anon_sym_allocsize] = ACTIONS(851),
    [anon_sym_alwaysinline] = ACTIONS(851),
    [anon_sym_builtin] = ACTIONS(851),
    [anon_sym_cold] = ACTIONS(851),
    [anon_sym_convergent] = ACTIONS(851),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(851),
    [anon_sym_hot] = ACTIONS(851),
    [anon_sym_inaccessiblememonly] = ACTIONS(851),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(851),
    [anon_sym_inlinehint] = ACTIONS(851),
    [anon_sym_jumptable] = ACTIONS(851),
    [anon_sym_minsize] = ACTIONS(851),
    [anon_sym_naked] = ACTIONS(851),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(851),
    [anon_sym_nobuiltin] = ACTIONS(851),
    [anon_sym_noduplicate] = ACTIONS(851),
    [anon_sym_nofree] = ACTIONS(851),
    [anon_sym_noimplicitfloat] = ACTIONS(851),
    [anon_sym_noinline] = ACTIONS(851),
    [anon_sym_nomerge] = ACTIONS(851),
    [anon_sym_nonlazybind] = ACTIONS(851),
    [anon_sym_noprofile] = ACTIONS(851),
    [anon_sym_noredzone] = ACTIONS(851),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(851),
    [anon_sym_noreturn] = ACTIONS(851),
    [anon_sym_norecurse] = ACTIONS(851),
    [anon_sym_willreturn] = ACTIONS(851),
    [anon_sym_nosync] = ACTIONS(851),
    [anon_sym_nounwind] = ACTIONS(851),
    [anon_sym_nocallback] = ACTIONS(851),
    [anon_sym_nosanitize_coverage] = ACTIONS(851),
    [anon_sym_null_pointer_is_valid] = ACTIONS(851),
    [anon_sym_optforfuzzing] = ACTIONS(851),
    [anon_sym_optnone] = ACTIONS(851),
    [anon_sym_optsize] = ACTIONS(851),
    [anon_sym_readnone] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_writeonly] = ACTIONS(851),
    [anon_sym_argmemonly] = ACTIONS(851),
    [anon_sym_returns_twice] = ACTIONS(851),
    [anon_sym_safestack] = ACTIONS(851),
    [anon_sym_sanitize_address] = ACTIONS(851),
    [anon_sym_sanitize_memory] = ACTIONS(851),
    [anon_sym_sanitize_thread] = ACTIONS(851),
    [anon_sym_sanitize_hwaddress] = ACTIONS(851),
    [anon_sym_sanitize_memtag] = ACTIONS(851),
    [anon_sym_speculative_load_hardening] = ACTIONS(851),
    [anon_sym_speculatable] = ACTIONS(851),
    [anon_sym_ssp] = ACTIONS(853),
    [anon_sym_sspstrong] = ACTIONS(851),
    [anon_sym_sspreq] = ACTIONS(851),
    [anon_sym_strictfp] = ACTIONS(851),
    [anon_sym_nocf_check] = ACTIONS(851),
    [anon_sym_shadowcallstack] = ACTIONS(851),
    [anon_sym_mustprogress] = ACTIONS(851),
    [anon_sym_vscale_range] = ACTIONS(851),
    [anon_sym_preallocated] = ACTIONS(851),
    [anon_sym_zeroext] = ACTIONS(851),
    [anon_sym_signext] = ACTIONS(851),
    [anon_sym_inreg] = ACTIONS(851),
    [anon_sym_byval] = ACTIONS(851),
    [anon_sym_byref] = ACTIONS(851),
    [anon_sym_inalloca] = ACTIONS(851),
    [anon_sym_sret] = ACTIONS(851),
    [anon_sym_elementtype] = ACTIONS(851),
    [anon_sym_noalias] = ACTIONS(851),
    [anon_sym_nocapture] = ACTIONS(851),
    [anon_sym_nest] = ACTIONS(851),
    [anon_sym_returned] = ACTIONS(851),
    [anon_sym_nonnull] = ACTIONS(851),
    [anon_sym_dereferenceable] = ACTIONS(853),
    [anon_sym_dereferenceable_or_null] = ACTIONS(851),
    [anon_sym_swiftself] = ACTIONS(851),
    [anon_sym_swiftasync] = ACTIONS(851),
    [anon_sym_swifterror] = ACTIONS(851),
    [anon_sym_immarg] = ACTIONS(851),
    [anon_sym_noundef] = ACTIONS(851),
    [anon_sym_uwtable] = ACTIONS(851),
    [anon_sym_memory] = ACTIONS(851),
    [anon_sym_to] = ACTIONS(853),
    [anon_sym_null] = ACTIONS(853),
    [anon_sym_uselistorder] = ACTIONS(853),
    [anon_sym_uselistorder_bb] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(853),
    [anon_sym_attributes] = ACTIONS(851),
  },
  [270] = {
    [ts_builtin_sym_end] = ACTIONS(367),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(367),
    [sym_global_var] = ACTIONS(367),
    [sym_local_var] = ACTIONS(367),
    [aux_sym_metadata_ref_token1] = ACTIONS(367),
    [sym_summary_ref] = ACTIONS(367),
    [sym_string] = ACTIONS(367),
    [aux_sym_number_token1] = ACTIONS(369),
    [aux_sym_number_token2] = ACTIONS(367),
    [sym_float] = ACTIONS(367),
    [sym_cstring] = ACTIONS(367),
    [anon_sym_target] = ACTIONS(367),
    [anon_sym_source_filename] = ACTIONS(367),
    [anon_sym_declare] = ACTIONS(367),
    [anon_sym_define] = ACTIONS(367),
    [anon_sym_no_cfi] = ACTIONS(367),
    [anon_sym_private] = ACTIONS(367),
    [anon_sym_internal] = ACTIONS(367),
    [anon_sym_weak] = ACTIONS(369),
    [anon_sym_weak_odr] = ACTIONS(367),
    [anon_sym_linkonce] = ACTIONS(369),
    [anon_sym_linkonce_odr] = ACTIONS(367),
    [anon_sym_available_externally] = ACTIONS(367),
    [anon_sym_appending] = ACTIONS(367),
    [anon_sym_common] = ACTIONS(367),
    [anon_sym_extern_weak] = ACTIONS(367),
    [anon_sym_external] = ACTIONS(367),
    [anon_sym_dso_local] = ACTIONS(369),
    [anon_sym_dso_local_equivalent] = ACTIONS(367),
    [anon_sym_dso_preemptable] = ACTIONS(367),
    [anon_sym_default] = ACTIONS(367),
    [anon_sym_hidden] = ACTIONS(367),
    [anon_sym_protected] = ACTIONS(367),
    [anon_sym_dllimport] = ACTIONS(367),
    [anon_sym_dllexport] = ACTIONS(367),
    [anon_sym_STAR] = ACTIONS(367),
    [anon_sym_void] = ACTIONS(367),
    [anon_sym_half] = ACTIONS(367),
    [anon_sym_bfloat] = ACTIONS(367),
    [anon_sym_float] = ACTIONS(367),
    [anon_sym_double] = ACTIONS(367),
    [anon_sym_x86_fp80] = ACTIONS(367),
    [anon_sym_fp128] = ACTIONS(367),
    [anon_sym_ppc_fp128] = ACTIONS(367),
    [anon_sym_label] = ACTIONS(367),
    [anon_sym_metadata] = ACTIONS(367),
    [anon_sym_x86_mmx] = ACTIONS(367),
    [anon_sym_x86_amx] = ACTIONS(367),
    [anon_sym_token] = ACTIONS(367),
    [anon_sym_opaque] = ACTIONS(367),
    [anon_sym_ptr] = ACTIONS(369),
    [aux_sym_type_keyword_token1] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(367),
    [anon_sym_RBRACE] = ACTIONS(367),
    [anon_sym_LT_LBRACE] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(367),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(367),
    [anon_sym_COMMA] = ACTIONS(367),
    [anon_sym_addrspace] = ACTIONS(369),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_RPAREN] = ACTIONS(367),
    [anon_sym_none] = ACTIONS(367),
    [anon_sym_extractelement] = ACTIONS(367),
    [anon_sym_insertelement] = ACTIONS(367),
    [anon_sym_select] = ACTIONS(367),
    [anon_sym_shufflevector] = ACTIONS(367),
    [anon_sym_fneg] = ACTIONS(367),
    [anon_sym_to] = ACTIONS(369),
    [anon_sym_unwind] = ACTIONS(367),
    [anon_sym_icmp] = ACTIONS(367),
    [anon_sym_fcmp] = ACTIONS(367),
    [anon_sym_cleanup] = ACTIONS(367),
    [anon_sym_getelementptr] = ACTIONS(367),
    [anon_sym_extractvalue] = ACTIONS(367),
    [anon_sym_insertvalue] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(367),
    [anon_sym_false] = ACTIONS(367),
    [anon_sym_null] = ACTIONS(367),
    [anon_sym_undef] = ACTIONS(367),
    [anon_sym_poison] = ACTIONS(367),
    [anon_sym_zeroinitializer] = ACTIONS(367),
    [anon_sym_catch] = ACTIONS(367),
    [anon_sym_filter] = ACTIONS(367),
    [anon_sym_blockaddress] = ACTIONS(367),
    [anon_sym_mul] = ACTIONS(367),
    [anon_sym_urem] = ACTIONS(367),
    [anon_sym_srem] = ACTIONS(367),
    [anon_sym_shl] = ACTIONS(367),
    [anon_sym_udiv] = ACTIONS(367),
    [anon_sym_sdiv] = ACTIONS(367),
    [anon_sym_lshr] = ACTIONS(367),
    [anon_sym_ashr] = ACTIONS(367),
    [anon_sym_fmul] = ACTIONS(367),
    [anon_sym_fdiv] = ACTIONS(367),
    [anon_sym_frem] = ACTIONS(367),
    [anon_sym_xchg] = ACTIONS(367),
    [anon_sym_add] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(367),
    [anon_sym_and] = ACTIONS(367),
    [anon_sym_nand] = ACTIONS(367),
    [anon_sym_or] = ACTIONS(367),
    [anon_sym_xor] = ACTIONS(367),
    [anon_sym_max] = ACTIONS(367),
    [anon_sym_min] = ACTIONS(367),
    [anon_sym_umax] = ACTIONS(367),
    [anon_sym_umin] = ACTIONS(367),
    [anon_sym_fadd] = ACTIONS(367),
    [anon_sym_fsub] = ACTIONS(367),
    [anon_sym_bitcast] = ACTIONS(367),
    [anon_sym_trunc] = ACTIONS(367),
    [anon_sym_zext] = ACTIONS(367),
    [anon_sym_sext] = ACTIONS(367),
    [anon_sym_fptrunc] = ACTIONS(367),
    [anon_sym_fpext] = ACTIONS(367),
    [anon_sym_addrspacecast] = ACTIONS(367),
    [anon_sym_uitofp] = ACTIONS(367),
    [anon_sym_sitofp] = ACTIONS(367),
    [anon_sym_fptoui] = ACTIONS(367),
    [anon_sym_fptosi] = ACTIONS(367),
    [anon_sym_inttoptr] = ACTIONS(367),
    [anon_sym_ptrtoint] = ACTIONS(367),
    [anon_sym_unordered] = ACTIONS(367),
    [anon_sym_monotonic] = ACTIONS(367),
    [anon_sym_acquire] = ACTIONS(367),
    [anon_sym_release] = ACTIONS(367),
    [anon_sym_acq_rel] = ACTIONS(367),
    [anon_sym_seq_cst] = ACTIONS(367),
    [anon_sym_syncscope] = ACTIONS(367),
    [anon_sym_uselistorder] = ACTIONS(369),
    [anon_sym_uselistorder_bb] = ACTIONS(367),
    [anon_sym_module] = ACTIONS(367),
    [anon_sym_asm] = ACTIONS(367),
    [anon_sym_attributes] = ACTIONS(367),
  },
  [271] = {
    [ts_builtin_sym_end] = ACTIONS(279),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(279),
    [sym_global_var] = ACTIONS(279),
    [sym_local_var] = ACTIONS(279),
    [aux_sym_metadata_ref_token1] = ACTIONS(279),
    [sym_summary_ref] = ACTIONS(279),
    [sym_string] = ACTIONS(279),
    [aux_sym_number_token1] = ACTIONS(281),
    [aux_sym_number_token2] = ACTIONS(279),
    [sym_float] = ACTIONS(279),
    [sym_cstring] = ACTIONS(279),
    [anon_sym_target] = ACTIONS(279),
    [anon_sym_source_filename] = ACTIONS(279),
    [anon_sym_declare] = ACTIONS(279),
    [anon_sym_define] = ACTIONS(279),
    [anon_sym_no_cfi] = ACTIONS(279),
    [anon_sym_private] = ACTIONS(279),
    [anon_sym_internal] = ACTIONS(279),
    [anon_sym_weak] = ACTIONS(281),
    [anon_sym_weak_odr] = ACTIONS(279),
    [anon_sym_linkonce] = ACTIONS(281),
    [anon_sym_linkonce_odr] = ACTIONS(279),
    [anon_sym_available_externally] = ACTIONS(279),
    [anon_sym_appending] = ACTIONS(279),
    [anon_sym_common] = ACTIONS(279),
    [anon_sym_extern_weak] = ACTIONS(279),
    [anon_sym_external] = ACTIONS(279),
    [anon_sym_dso_local] = ACTIONS(281),
    [anon_sym_dso_local_equivalent] = ACTIONS(279),
    [anon_sym_dso_preemptable] = ACTIONS(279),
    [anon_sym_default] = ACTIONS(279),
    [anon_sym_hidden] = ACTIONS(279),
    [anon_sym_protected] = ACTIONS(279),
    [anon_sym_dllimport] = ACTIONS(279),
    [anon_sym_dllexport] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(279),
    [anon_sym_void] = ACTIONS(279),
    [anon_sym_half] = ACTIONS(279),
    [anon_sym_bfloat] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(279),
    [anon_sym_double] = ACTIONS(279),
    [anon_sym_x86_fp80] = ACTIONS(279),
    [anon_sym_fp128] = ACTIONS(279),
    [anon_sym_ppc_fp128] = ACTIONS(279),
    [anon_sym_label] = ACTIONS(279),
    [anon_sym_metadata] = ACTIONS(279),
    [anon_sym_x86_mmx] = ACTIONS(279),
    [anon_sym_x86_amx] = ACTIONS(279),
    [anon_sym_token] = ACTIONS(279),
    [anon_sym_opaque] = ACTIONS(279),
    [anon_sym_ptr] = ACTIONS(281),
    [aux_sym_type_keyword_token1] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(279),
    [anon_sym_RBRACE] = ACTIONS(279),
    [anon_sym_LT_LBRACE] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(281),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_addrspace] = ACTIONS(281),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_none] = ACTIONS(279),
    [anon_sym_extractelement] = ACTIONS(279),
    [anon_sym_insertelement] = ACTIONS(279),
    [anon_sym_select] = ACTIONS(279),
    [anon_sym_shufflevector] = ACTIONS(279),
    [anon_sym_fneg] = ACTIONS(279),
    [anon_sym_to] = ACTIONS(281),
    [anon_sym_unwind] = ACTIONS(279),
    [anon_sym_icmp] = ACTIONS(279),
    [anon_sym_fcmp] = ACTIONS(279),
    [anon_sym_cleanup] = ACTIONS(279),
    [anon_sym_getelementptr] = ACTIONS(279),
    [anon_sym_extractvalue] = ACTIONS(279),
    [anon_sym_insertvalue] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(279),
    [anon_sym_false] = ACTIONS(279),
    [anon_sym_null] = ACTIONS(279),
    [anon_sym_undef] = ACTIONS(279),
    [anon_sym_poison] = ACTIONS(279),
    [anon_sym_zeroinitializer] = ACTIONS(279),
    [anon_sym_catch] = ACTIONS(279),
    [anon_sym_filter] = ACTIONS(279),
    [anon_sym_blockaddress] = ACTIONS(279),
    [anon_sym_mul] = ACTIONS(279),
    [anon_sym_urem] = ACTIONS(279),
    [anon_sym_srem] = ACTIONS(279),
    [anon_sym_shl] = ACTIONS(279),
    [anon_sym_udiv] = ACTIONS(279),
    [anon_sym_sdiv] = ACTIONS(279),
    [anon_sym_lshr] = ACTIONS(279),
    [anon_sym_ashr] = ACTIONS(279),
    [anon_sym_fmul] = ACTIONS(279),
    [anon_sym_fdiv] = ACTIONS(279),
    [anon_sym_frem] = ACTIONS(279),
    [anon_sym_xchg] = ACTIONS(279),
    [anon_sym_add] = ACTIONS(281),
    [anon_sym_sub] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_nand] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_xor] = ACTIONS(279),
    [anon_sym_max] = ACTIONS(279),
    [anon_sym_min] = ACTIONS(279),
    [anon_sym_umax] = ACTIONS(279),
    [anon_sym_umin] = ACTIONS(279),
    [anon_sym_fadd] = ACTIONS(279),
    [anon_sym_fsub] = ACTIONS(279),
    [anon_sym_bitcast] = ACTIONS(279),
    [anon_sym_trunc] = ACTIONS(279),
    [anon_sym_zext] = ACTIONS(279),
    [anon_sym_sext] = ACTIONS(279),
    [anon_sym_fptrunc] = ACTIONS(279),
    [anon_sym_fpext] = ACTIONS(279),
    [anon_sym_addrspacecast] = ACTIONS(279),
    [anon_sym_uitofp] = ACTIONS(279),
    [anon_sym_sitofp] = ACTIONS(279),
    [anon_sym_fptoui] = ACTIONS(279),
    [anon_sym_fptosi] = ACTIONS(279),
    [anon_sym_inttoptr] = ACTIONS(279),
    [anon_sym_ptrtoint] = ACTIONS(279),
    [anon_sym_unordered] = ACTIONS(279),
    [anon_sym_monotonic] = ACTIONS(279),
    [anon_sym_acquire] = ACTIONS(279),
    [anon_sym_release] = ACTIONS(279),
    [anon_sym_acq_rel] = ACTIONS(279),
    [anon_sym_seq_cst] = ACTIONS(279),
    [anon_sym_syncscope] = ACTIONS(279),
    [anon_sym_uselistorder] = ACTIONS(281),
    [anon_sym_uselistorder_bb] = ACTIONS(279),
    [anon_sym_module] = ACTIONS(279),
    [anon_sym_asm] = ACTIONS(279),
    [anon_sym_attributes] = ACTIONS(279),
  },
  [272] = {
    [ts_builtin_sym_end] = ACTIONS(387),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(387),
    [sym_global_var] = ACTIONS(387),
    [sym_local_var] = ACTIONS(387),
    [aux_sym_metadata_ref_token1] = ACTIONS(387),
    [sym_summary_ref] = ACTIONS(387),
    [sym_string] = ACTIONS(387),
    [aux_sym_number_token1] = ACTIONS(389),
    [aux_sym_number_token2] = ACTIONS(387),
    [sym_float] = ACTIONS(387),
    [sym_cstring] = ACTIONS(387),
    [anon_sym_target] = ACTIONS(387),
    [anon_sym_source_filename] = ACTIONS(387),
    [anon_sym_declare] = ACTIONS(387),
    [anon_sym_define] = ACTIONS(387),
    [anon_sym_no_cfi] = ACTIONS(387),
    [anon_sym_private] = ACTIONS(387),
    [anon_sym_internal] = ACTIONS(387),
    [anon_sym_weak] = ACTIONS(389),
    [anon_sym_weak_odr] = ACTIONS(387),
    [anon_sym_linkonce] = ACTIONS(389),
    [anon_sym_linkonce_odr] = ACTIONS(387),
    [anon_sym_available_externally] = ACTIONS(387),
    [anon_sym_appending] = ACTIONS(387),
    [anon_sym_common] = ACTIONS(387),
    [anon_sym_extern_weak] = ACTIONS(387),
    [anon_sym_external] = ACTIONS(387),
    [anon_sym_dso_local] = ACTIONS(389),
    [anon_sym_dso_local_equivalent] = ACTIONS(387),
    [anon_sym_dso_preemptable] = ACTIONS(387),
    [anon_sym_default] = ACTIONS(387),
    [anon_sym_hidden] = ACTIONS(387),
    [anon_sym_protected] = ACTIONS(387),
    [anon_sym_dllimport] = ACTIONS(387),
    [anon_sym_dllexport] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(387),
    [anon_sym_void] = ACTIONS(387),
    [anon_sym_half] = ACTIONS(387),
    [anon_sym_bfloat] = ACTIONS(387),
    [anon_sym_float] = ACTIONS(387),
    [anon_sym_double] = ACTIONS(387),
    [anon_sym_x86_fp80] = ACTIONS(387),
    [anon_sym_fp128] = ACTIONS(387),
    [anon_sym_ppc_fp128] = ACTIONS(387),
    [anon_sym_label] = ACTIONS(387),
    [anon_sym_metadata] = ACTIONS(387),
    [anon_sym_x86_mmx] = ACTIONS(387),
    [anon_sym_x86_amx] = ACTIONS(387),
    [anon_sym_token] = ACTIONS(387),
    [anon_sym_opaque] = ACTIONS(387),
    [anon_sym_ptr] = ACTIONS(389),
    [aux_sym_type_keyword_token1] = ACTIONS(387),
    [anon_sym_LBRACE] = ACTIONS(387),
    [anon_sym_RBRACE] = ACTIONS(387),
    [anon_sym_LT_LBRACE] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(387),
    [anon_sym_RBRACK] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_GT] = ACTIONS(387),
    [anon_sym_COMMA] = ACTIONS(387),
    [anon_sym_addrspace] = ACTIONS(389),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(387),
    [anon_sym_none] = ACTIONS(387),
    [anon_sym_extractelement] = ACTIONS(387),
    [anon_sym_insertelement] = ACTIONS(387),
    [anon_sym_select] = ACTIONS(387),
    [anon_sym_shufflevector] = ACTIONS(387),
    [anon_sym_fneg] = ACTIONS(387),
    [anon_sym_to] = ACTIONS(389),
    [anon_sym_unwind] = ACTIONS(387),
    [anon_sym_icmp] = ACTIONS(387),
    [anon_sym_fcmp] = ACTIONS(387),
    [anon_sym_cleanup] = ACTIONS(387),
    [anon_sym_getelementptr] = ACTIONS(387),
    [anon_sym_extractvalue] = ACTIONS(387),
    [anon_sym_insertvalue] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(387),
    [anon_sym_false] = ACTIONS(387),
    [anon_sym_null] = ACTIONS(387),
    [anon_sym_undef] = ACTIONS(387),
    [anon_sym_poison] = ACTIONS(387),
    [anon_sym_zeroinitializer] = ACTIONS(387),
    [anon_sym_catch] = ACTIONS(387),
    [anon_sym_filter] = ACTIONS(387),
    [anon_sym_blockaddress] = ACTIONS(387),
    [anon_sym_mul] = ACTIONS(387),
    [anon_sym_urem] = ACTIONS(387),
    [anon_sym_srem] = ACTIONS(387),
    [anon_sym_shl] = ACTIONS(387),
    [anon_sym_udiv] = ACTIONS(387),
    [anon_sym_sdiv] = ACTIONS(387),
    [anon_sym_lshr] = ACTIONS(387),
    [anon_sym_ashr] = ACTIONS(387),
    [anon_sym_fmul] = ACTIONS(387),
    [anon_sym_fdiv] = ACTIONS(387),
    [anon_sym_frem] = ACTIONS(387),
    [anon_sym_xchg] = ACTIONS(387),
    [anon_sym_add] = ACTIONS(389),
    [anon_sym_sub] = ACTIONS(387),
    [anon_sym_and] = ACTIONS(387),
    [anon_sym_nand] = ACTIONS(387),
    [anon_sym_or] = ACTIONS(387),
    [anon_sym_xor] = ACTIONS(387),
    [anon_sym_max] = ACTIONS(387),
    [anon_sym_min] = ACTIONS(387),
    [anon_sym_umax] = ACTIONS(387),
    [anon_sym_umin] = ACTIONS(387),
    [anon_sym_fadd] = ACTIONS(387),
    [anon_sym_fsub] = ACTIONS(387),
    [anon_sym_bitcast] = ACTIONS(387),
    [anon_sym_trunc] = ACTIONS(387),
    [anon_sym_zext] = ACTIONS(387),
    [anon_sym_sext] = ACTIONS(387),
    [anon_sym_fptrunc] = ACTIONS(387),
    [anon_sym_fpext] = ACTIONS(387),
    [anon_sym_addrspacecast] = ACTIONS(387),
    [anon_sym_uitofp] = ACTIONS(387),
    [anon_sym_sitofp] = ACTIONS(387),
    [anon_sym_fptoui] = ACTIONS(387),
    [anon_sym_fptosi] = ACTIONS(387),
    [anon_sym_inttoptr] = ACTIONS(387),
    [anon_sym_ptrtoint] = ACTIONS(387),
    [anon_sym_unordered] = ACTIONS(387),
    [anon_sym_monotonic] = ACTIONS(387),
    [anon_sym_acquire] = ACTIONS(387),
    [anon_sym_release] = ACTIONS(387),
    [anon_sym_acq_rel] = ACTIONS(387),
    [anon_sym_seq_cst] = ACTIONS(387),
    [anon_sym_syncscope] = ACTIONS(387),
    [anon_sym_uselistorder] = ACTIONS(389),
    [anon_sym_uselistorder_bb] = ACTIONS(387),
    [anon_sym_module] = ACTIONS(387),
    [anon_sym_asm] = ACTIONS(387),
    [anon_sym_attributes] = ACTIONS(387),
  },
  [273] = {
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(371),
    [sym_global_var] = ACTIONS(371),
    [sym_local_var] = ACTIONS(371),
    [aux_sym_metadata_ref_token1] = ACTIONS(371),
    [sym_summary_ref] = ACTIONS(371),
    [sym_string] = ACTIONS(371),
    [aux_sym_number_token1] = ACTIONS(373),
    [aux_sym_number_token2] = ACTIONS(371),
    [sym_float] = ACTIONS(371),
    [sym_cstring] = ACTIONS(371),
    [anon_sym_target] = ACTIONS(371),
    [anon_sym_source_filename] = ACTIONS(371),
    [anon_sym_declare] = ACTIONS(371),
    [anon_sym_define] = ACTIONS(371),
    [anon_sym_no_cfi] = ACTIONS(371),
    [anon_sym_private] = ACTIONS(371),
    [anon_sym_internal] = ACTIONS(371),
    [anon_sym_weak] = ACTIONS(373),
    [anon_sym_weak_odr] = ACTIONS(371),
    [anon_sym_linkonce] = ACTIONS(373),
    [anon_sym_linkonce_odr] = ACTIONS(371),
    [anon_sym_available_externally] = ACTIONS(371),
    [anon_sym_appending] = ACTIONS(371),
    [anon_sym_common] = ACTIONS(371),
    [anon_sym_extern_weak] = ACTIONS(371),
    [anon_sym_external] = ACTIONS(371),
    [anon_sym_dso_local] = ACTIONS(373),
    [anon_sym_dso_local_equivalent] = ACTIONS(371),
    [anon_sym_dso_preemptable] = ACTIONS(371),
    [anon_sym_default] = ACTIONS(371),
    [anon_sym_hidden] = ACTIONS(371),
    [anon_sym_protected] = ACTIONS(371),
    [anon_sym_dllimport] = ACTIONS(371),
    [anon_sym_dllexport] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_void] = ACTIONS(371),
    [anon_sym_half] = ACTIONS(371),
    [anon_sym_bfloat] = ACTIONS(371),
    [anon_sym_float] = ACTIONS(371),
    [anon_sym_double] = ACTIONS(371),
    [anon_sym_x86_fp80] = ACTIONS(371),
    [anon_sym_fp128] = ACTIONS(371),
    [anon_sym_ppc_fp128] = ACTIONS(371),
    [anon_sym_label] = ACTIONS(371),
    [anon_sym_metadata] = ACTIONS(371),
    [anon_sym_x86_mmx] = ACTIONS(371),
    [anon_sym_x86_amx] = ACTIONS(371),
    [anon_sym_token] = ACTIONS(371),
    [anon_sym_opaque] = ACTIONS(371),
    [anon_sym_ptr] = ACTIONS(373),
    [aux_sym_type_keyword_token1] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(371),
    [anon_sym_LT_LBRACE] = ACTIONS(371),
    [anon_sym_LBRACK] = ACTIONS(371),
    [anon_sym_RBRACK] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_COMMA] = ACTIONS(371),
    [anon_sym_addrspace] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_RPAREN] = ACTIONS(371),
    [anon_sym_none] = ACTIONS(371),
    [anon_sym_extractelement] = ACTIONS(371),
    [anon_sym_insertelement] = ACTIONS(371),
    [anon_sym_select] = ACTIONS(371),
    [anon_sym_shufflevector] = ACTIONS(371),
    [anon_sym_fneg] = ACTIONS(371),
    [anon_sym_to] = ACTIONS(373),
    [anon_sym_unwind] = ACTIONS(371),
    [anon_sym_icmp] = ACTIONS(371),
    [anon_sym_fcmp] = ACTIONS(371),
    [anon_sym_cleanup] = ACTIONS(371),
    [anon_sym_getelementptr] = ACTIONS(371),
    [anon_sym_extractvalue] = ACTIONS(371),
    [anon_sym_insertvalue] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(371),
    [anon_sym_false] = ACTIONS(371),
    [anon_sym_null] = ACTIONS(371),
    [anon_sym_undef] = ACTIONS(371),
    [anon_sym_poison] = ACTIONS(371),
    [anon_sym_zeroinitializer] = ACTIONS(371),
    [anon_sym_catch] = ACTIONS(371),
    [anon_sym_filter] = ACTIONS(371),
    [anon_sym_blockaddress] = ACTIONS(371),
    [anon_sym_mul] = ACTIONS(371),
    [anon_sym_urem] = ACTIONS(371),
    [anon_sym_srem] = ACTIONS(371),
    [anon_sym_shl] = ACTIONS(371),
    [anon_sym_udiv] = ACTIONS(371),
    [anon_sym_sdiv] = ACTIONS(371),
    [anon_sym_lshr] = ACTIONS(371),
    [anon_sym_ashr] = ACTIONS(371),
    [anon_sym_fmul] = ACTIONS(371),
    [anon_sym_fdiv] = ACTIONS(371),
    [anon_sym_frem] = ACTIONS(371),
    [anon_sym_xchg] = ACTIONS(371),
    [anon_sym_add] = ACTIONS(373),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_and] = ACTIONS(371),
    [anon_sym_nand] = ACTIONS(371),
    [anon_sym_or] = ACTIONS(371),
    [anon_sym_xor] = ACTIONS(371),
    [anon_sym_max] = ACTIONS(371),
    [anon_sym_min] = ACTIONS(371),
    [anon_sym_umax] = ACTIONS(371),
    [anon_sym_umin] = ACTIONS(371),
    [anon_sym_fadd] = ACTIONS(371),
    [anon_sym_fsub] = ACTIONS(371),
    [anon_sym_bitcast] = ACTIONS(371),
    [anon_sym_trunc] = ACTIONS(371),
    [anon_sym_zext] = ACTIONS(371),
    [anon_sym_sext] = ACTIONS(371),
    [anon_sym_fptrunc] = ACTIONS(371),
    [anon_sym_fpext] = ACTIONS(371),
    [anon_sym_addrspacecast] = ACTIONS(371),
    [anon_sym_uitofp] = ACTIONS(371),
    [anon_sym_sitofp] = ACTIONS(371),
    [anon_sym_fptoui] = ACTIONS(371),
    [anon_sym_fptosi] = ACTIONS(371),
    [anon_sym_inttoptr] = ACTIONS(371),
    [anon_sym_ptrtoint] = ACTIONS(371),
    [anon_sym_unordered] = ACTIONS(371),
    [anon_sym_monotonic] = ACTIONS(371),
    [anon_sym_acquire] = ACTIONS(371),
    [anon_sym_release] = ACTIONS(371),
    [anon_sym_acq_rel] = ACTIONS(371),
    [anon_sym_seq_cst] = ACTIONS(371),
    [anon_sym_syncscope] = ACTIONS(371),
    [anon_sym_uselistorder] = ACTIONS(373),
    [anon_sym_uselistorder_bb] = ACTIONS(371),
    [anon_sym_module] = ACTIONS(371),
    [anon_sym_asm] = ACTIONS(371),
    [anon_sym_attributes] = ACTIONS(371),
  },
  [274] = {
    [ts_builtin_sym_end] = ACTIONS(812),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(812),
    [sym_comdat_ref] = ACTIONS(812),
    [sym_global_var] = ACTIONS(812),
    [sym_local_var] = ACTIONS(812),
    [aux_sym_metadata_ref_token1] = ACTIONS(812),
    [sym_summary_ref] = ACTIONS(812),
    [sym_string] = ACTIONS(812),
    [anon_sym_target] = ACTIONS(812),
    [anon_sym_EQ] = ACTIONS(812),
    [anon_sym_source_filename] = ACTIONS(812),
    [anon_sym_declare] = ACTIONS(812),
    [anon_sym_define] = ACTIONS(812),
    [anon_sym_unnamed_addr] = ACTIONS(812),
    [anon_sym_local_unnamed_addr] = ACTIONS(812),
    [anon_sym_void] = ACTIONS(812),
    [anon_sym_half] = ACTIONS(812),
    [anon_sym_bfloat] = ACTIONS(812),
    [anon_sym_float] = ACTIONS(812),
    [anon_sym_double] = ACTIONS(812),
    [anon_sym_x86_fp80] = ACTIONS(812),
    [anon_sym_fp128] = ACTIONS(812),
    [anon_sym_ppc_fp128] = ACTIONS(812),
    [anon_sym_label] = ACTIONS(812),
    [anon_sym_metadata] = ACTIONS(812),
    [anon_sym_x86_mmx] = ACTIONS(812),
    [anon_sym_x86_amx] = ACTIONS(812),
    [anon_sym_token] = ACTIONS(812),
    [anon_sym_opaque] = ACTIONS(812),
    [anon_sym_ptr] = ACTIONS(812),
    [aux_sym_type_keyword_token1] = ACTIONS(812),
    [anon_sym_LBRACE] = ACTIONS(812),
    [anon_sym_RBRACE] = ACTIONS(812),
    [anon_sym_LT_LBRACE] = ACTIONS(812),
    [anon_sym_LBRACK] = ACTIONS(812),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_COMMA] = ACTIONS(812),
    [anon_sym_addrspace] = ACTIONS(812),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_RPAREN] = ACTIONS(812),
    [anon_sym_align] = ACTIONS(814),
    [anon_sym_section] = ACTIONS(812),
    [anon_sym_partition] = ACTIONS(812),
    [anon_sym_comdat] = ACTIONS(812),
    [anon_sym_gc] = ACTIONS(812),
    [anon_sym_prefix] = ACTIONS(812),
    [anon_sym_prologue] = ACTIONS(812),
    [anon_sym_personality] = ACTIONS(812),
    [anon_sym_alignstack] = ACTIONS(812),
    [anon_sym_allocsize] = ACTIONS(812),
    [anon_sym_alwaysinline] = ACTIONS(812),
    [anon_sym_builtin] = ACTIONS(812),
    [anon_sym_cold] = ACTIONS(812),
    [anon_sym_convergent] = ACTIONS(812),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(812),
    [anon_sym_hot] = ACTIONS(812),
    [anon_sym_inaccessiblememonly] = ACTIONS(812),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(812),
    [anon_sym_inlinehint] = ACTIONS(812),
    [anon_sym_jumptable] = ACTIONS(812),
    [anon_sym_minsize] = ACTIONS(812),
    [anon_sym_naked] = ACTIONS(812),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(812),
    [anon_sym_nobuiltin] = ACTIONS(812),
    [anon_sym_noduplicate] = ACTIONS(812),
    [anon_sym_nofree] = ACTIONS(812),
    [anon_sym_noimplicitfloat] = ACTIONS(812),
    [anon_sym_noinline] = ACTIONS(812),
    [anon_sym_nomerge] = ACTIONS(812),
    [anon_sym_nonlazybind] = ACTIONS(812),
    [anon_sym_noprofile] = ACTIONS(812),
    [anon_sym_noredzone] = ACTIONS(812),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(812),
    [anon_sym_noreturn] = ACTIONS(812),
    [anon_sym_norecurse] = ACTIONS(812),
    [anon_sym_willreturn] = ACTIONS(812),
    [anon_sym_nosync] = ACTIONS(812),
    [anon_sym_nounwind] = ACTIONS(812),
    [anon_sym_nocallback] = ACTIONS(812),
    [anon_sym_nosanitize_coverage] = ACTIONS(812),
    [anon_sym_null_pointer_is_valid] = ACTIONS(812),
    [anon_sym_optforfuzzing] = ACTIONS(812),
    [anon_sym_optnone] = ACTIONS(812),
    [anon_sym_optsize] = ACTIONS(812),
    [anon_sym_readnone] = ACTIONS(812),
    [anon_sym_readonly] = ACTIONS(812),
    [anon_sym_writeonly] = ACTIONS(812),
    [anon_sym_argmemonly] = ACTIONS(812),
    [anon_sym_returns_twice] = ACTIONS(812),
    [anon_sym_safestack] = ACTIONS(812),
    [anon_sym_sanitize_address] = ACTIONS(812),
    [anon_sym_sanitize_memory] = ACTIONS(812),
    [anon_sym_sanitize_thread] = ACTIONS(812),
    [anon_sym_sanitize_hwaddress] = ACTIONS(812),
    [anon_sym_sanitize_memtag] = ACTIONS(812),
    [anon_sym_speculative_load_hardening] = ACTIONS(812),
    [anon_sym_speculatable] = ACTIONS(812),
    [anon_sym_ssp] = ACTIONS(814),
    [anon_sym_sspstrong] = ACTIONS(812),
    [anon_sym_sspreq] = ACTIONS(812),
    [anon_sym_strictfp] = ACTIONS(812),
    [anon_sym_nocf_check] = ACTIONS(812),
    [anon_sym_shadowcallstack] = ACTIONS(812),
    [anon_sym_mustprogress] = ACTIONS(812),
    [anon_sym_vscale_range] = ACTIONS(812),
    [anon_sym_preallocated] = ACTIONS(812),
    [anon_sym_zeroext] = ACTIONS(812),
    [anon_sym_signext] = ACTIONS(812),
    [anon_sym_inreg] = ACTIONS(812),
    [anon_sym_byval] = ACTIONS(812),
    [anon_sym_byref] = ACTIONS(812),
    [anon_sym_inalloca] = ACTIONS(812),
    [anon_sym_sret] = ACTIONS(812),
    [anon_sym_elementtype] = ACTIONS(812),
    [anon_sym_noalias] = ACTIONS(812),
    [anon_sym_nocapture] = ACTIONS(812),
    [anon_sym_nest] = ACTIONS(812),
    [anon_sym_returned] = ACTIONS(812),
    [anon_sym_nonnull] = ACTIONS(812),
    [anon_sym_dereferenceable] = ACTIONS(814),
    [anon_sym_dereferenceable_or_null] = ACTIONS(812),
    [anon_sym_swiftself] = ACTIONS(812),
    [anon_sym_swiftasync] = ACTIONS(812),
    [anon_sym_swifterror] = ACTIONS(812),
    [anon_sym_immarg] = ACTIONS(812),
    [anon_sym_noundef] = ACTIONS(812),
    [anon_sym_uwtable] = ACTIONS(812),
    [anon_sym_memory] = ACTIONS(812),
    [anon_sym_to] = ACTIONS(814),
    [anon_sym_null] = ACTIONS(814),
    [anon_sym_uselistorder] = ACTIONS(814),
    [anon_sym_uselistorder_bb] = ACTIONS(812),
    [anon_sym_module] = ACTIONS(812),
    [anon_sym_BANG] = ACTIONS(814),
    [anon_sym_attributes] = ACTIONS(812),
  },
  [275] = {
    [ts_builtin_sym_end] = ACTIONS(116),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(116),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(116),
    [aux_sym_metadata_ref_token1] = ACTIONS(116),
    [sym_summary_ref] = ACTIONS(116),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_target] = ACTIONS(116),
    [anon_sym_source_filename] = ACTIONS(116),
    [anon_sym_declare] = ACTIONS(116),
    [anon_sym_define] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_half] = ACTIONS(116),
    [anon_sym_bfloat] = ACTIONS(116),
    [anon_sym_float] = ACTIONS(116),
    [anon_sym_double] = ACTIONS(116),
    [anon_sym_x86_fp80] = ACTIONS(116),
    [anon_sym_fp128] = ACTIONS(116),
    [anon_sym_ppc_fp128] = ACTIONS(116),
    [anon_sym_label] = ACTIONS(116),
    [anon_sym_metadata] = ACTIONS(116),
    [anon_sym_x86_mmx] = ACTIONS(116),
    [anon_sym_x86_amx] = ACTIONS(116),
    [anon_sym_token] = ACTIONS(116),
    [anon_sym_opaque] = ACTIONS(116),
    [anon_sym_ptr] = ACTIONS(122),
    [aux_sym_type_keyword_token1] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(116),
    [anon_sym_RBRACE] = ACTIONS(116),
    [anon_sym_LT_LBRACE] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(116),
    [anon_sym_RBRACK] = ACTIONS(116),
    [anon_sym_LT] = ACTIONS(122),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_RPAREN] = ACTIONS(116),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_to] = ACTIONS(122),
    [anon_sym_unwind] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_cleanup] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(116),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_catch] = ACTIONS(116),
    [anon_sym_filter] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(116),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_unordered] = ACTIONS(116),
    [anon_sym_monotonic] = ACTIONS(116),
    [anon_sym_acquire] = ACTIONS(116),
    [anon_sym_release] = ACTIONS(116),
    [anon_sym_acq_rel] = ACTIONS(116),
    [anon_sym_seq_cst] = ACTIONS(116),
    [anon_sym_syncscope] = ACTIONS(116),
    [anon_sym_uselistorder] = ACTIONS(122),
    [anon_sym_uselistorder_bb] = ACTIONS(116),
    [anon_sym_module] = ACTIONS(116),
    [anon_sym_asm] = ACTIONS(116),
    [anon_sym_attributes] = ACTIONS(116),
  },
  [276] = {
    [ts_builtin_sym_end] = ACTIONS(250),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(250),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [aux_sym_metadata_ref_token1] = ACTIONS(250),
    [sym_summary_ref] = ACTIONS(250),
    [sym_string] = ACTIONS(250),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(250),
    [sym_float] = ACTIONS(250),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_target] = ACTIONS(250),
    [anon_sym_source_filename] = ACTIONS(250),
    [anon_sym_declare] = ACTIONS(250),
    [anon_sym_define] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(250),
    [anon_sym_private] = ACTIONS(250),
    [anon_sym_internal] = ACTIONS(250),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(250),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(250),
    [anon_sym_available_externally] = ACTIONS(250),
    [anon_sym_appending] = ACTIONS(250),
    [anon_sym_common] = ACTIONS(250),
    [anon_sym_extern_weak] = ACTIONS(250),
    [anon_sym_external] = ACTIONS(250),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(250),
    [anon_sym_dso_preemptable] = ACTIONS(250),
    [anon_sym_default] = ACTIONS(250),
    [anon_sym_hidden] = ACTIONS(250),
    [anon_sym_protected] = ACTIONS(250),
    [anon_sym_dllimport] = ACTIONS(250),
    [anon_sym_dllexport] = ACTIONS(250),
    [anon_sym_STAR] = ACTIONS(250),
    [anon_sym_void] = ACTIONS(250),
    [anon_sym_half] = ACTIONS(250),
    [anon_sym_bfloat] = ACTIONS(250),
    [anon_sym_float] = ACTIONS(250),
    [anon_sym_double] = ACTIONS(250),
    [anon_sym_x86_fp80] = ACTIONS(250),
    [anon_sym_fp128] = ACTIONS(250),
    [anon_sym_ppc_fp128] = ACTIONS(250),
    [anon_sym_label] = ACTIONS(250),
    [anon_sym_metadata] = ACTIONS(250),
    [anon_sym_x86_mmx] = ACTIONS(250),
    [anon_sym_x86_amx] = ACTIONS(250),
    [anon_sym_token] = ACTIONS(250),
    [anon_sym_opaque] = ACTIONS(250),
    [anon_sym_ptr] = ACTIONS(252),
    [aux_sym_type_keyword_token1] = ACTIONS(250),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_RBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_GT] = ACTIONS(250),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(252),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_RPAREN] = ACTIONS(250),
    [anon_sym_none] = ACTIONS(250),
    [anon_sym_extractelement] = ACTIONS(250),
    [anon_sym_insertelement] = ACTIONS(250),
    [anon_sym_select] = ACTIONS(250),
    [anon_sym_shufflevector] = ACTIONS(250),
    [anon_sym_fneg] = ACTIONS(250),
    [anon_sym_to] = ACTIONS(252),
    [anon_sym_unwind] = ACTIONS(250),
    [anon_sym_icmp] = ACTIONS(250),
    [anon_sym_fcmp] = ACTIONS(250),
    [anon_sym_cleanup] = ACTIONS(250),
    [anon_sym_getelementptr] = ACTIONS(250),
    [anon_sym_extractvalue] = ACTIONS(250),
    [anon_sym_insertvalue] = ACTIONS(250),
    [anon_sym_true] = ACTIONS(250),
    [anon_sym_false] = ACTIONS(250),
    [anon_sym_null] = ACTIONS(250),
    [anon_sym_undef] = ACTIONS(250),
    [anon_sym_poison] = ACTIONS(250),
    [anon_sym_zeroinitializer] = ACTIONS(250),
    [anon_sym_catch] = ACTIONS(250),
    [anon_sym_filter] = ACTIONS(250),
    [anon_sym_blockaddress] = ACTIONS(250),
    [anon_sym_mul] = ACTIONS(250),
    [anon_sym_urem] = ACTIONS(250),
    [anon_sym_srem] = ACTIONS(250),
    [anon_sym_shl] = ACTIONS(250),
    [anon_sym_udiv] = ACTIONS(250),
    [anon_sym_sdiv] = ACTIONS(250),
    [anon_sym_lshr] = ACTIONS(250),
    [anon_sym_ashr] = ACTIONS(250),
    [anon_sym_fmul] = ACTIONS(250),
    [anon_sym_fdiv] = ACTIONS(250),
    [anon_sym_frem] = ACTIONS(250),
    [anon_sym_xchg] = ACTIONS(250),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(250),
    [anon_sym_and] = ACTIONS(250),
    [anon_sym_nand] = ACTIONS(250),
    [anon_sym_or] = ACTIONS(250),
    [anon_sym_xor] = ACTIONS(250),
    [anon_sym_max] = ACTIONS(250),
    [anon_sym_min] = ACTIONS(250),
    [anon_sym_umax] = ACTIONS(250),
    [anon_sym_umin] = ACTIONS(250),
    [anon_sym_fadd] = ACTIONS(250),
    [anon_sym_fsub] = ACTIONS(250),
    [anon_sym_bitcast] = ACTIONS(250),
    [anon_sym_trunc] = ACTIONS(250),
    [anon_sym_zext] = ACTIONS(250),
    [anon_sym_sext] = ACTIONS(250),
    [anon_sym_fptrunc] = ACTIONS(250),
    [anon_sym_fpext] = ACTIONS(250),
    [anon_sym_addrspacecast] = ACTIONS(250),
    [anon_sym_uitofp] = ACTIONS(250),
    [anon_sym_sitofp] = ACTIONS(250),
    [anon_sym_fptoui] = ACTIONS(250),
    [anon_sym_fptosi] = ACTIONS(250),
    [anon_sym_inttoptr] = ACTIONS(250),
    [anon_sym_ptrtoint] = ACTIONS(250),
    [anon_sym_unordered] = ACTIONS(250),
    [anon_sym_monotonic] = ACTIONS(250),
    [anon_sym_acquire] = ACTIONS(250),
    [anon_sym_release] = ACTIONS(250),
    [anon_sym_acq_rel] = ACTIONS(250),
    [anon_sym_seq_cst] = ACTIONS(250),
    [anon_sym_syncscope] = ACTIONS(250),
    [anon_sym_uselistorder] = ACTIONS(252),
    [anon_sym_uselistorder_bb] = ACTIONS(250),
    [anon_sym_module] = ACTIONS(250),
    [anon_sym_asm] = ACTIONS(250),
    [anon_sym_attributes] = ACTIONS(250),
  },
  [277] = {
    [sym_addrspace] = STATE(283),
    [sym_argument_list] = STATE(276),
    [aux_sym_type_repeat1] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(244),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(244),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [aux_sym_metadata_ref_token1] = ACTIONS(244),
    [sym_summary_ref] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_target] = ACTIONS(244),
    [anon_sym_source_filename] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(244),
    [anon_sym_define] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(1024),
    [anon_sym_void] = ACTIONS(244),
    [anon_sym_half] = ACTIONS(244),
    [anon_sym_bfloat] = ACTIONS(244),
    [anon_sym_float] = ACTIONS(244),
    [anon_sym_double] = ACTIONS(244),
    [anon_sym_x86_fp80] = ACTIONS(244),
    [anon_sym_fp128] = ACTIONS(244),
    [anon_sym_ppc_fp128] = ACTIONS(244),
    [anon_sym_label] = ACTIONS(244),
    [anon_sym_metadata] = ACTIONS(244),
    [anon_sym_x86_mmx] = ACTIONS(244),
    [anon_sym_x86_amx] = ACTIONS(244),
    [anon_sym_token] = ACTIONS(244),
    [anon_sym_opaque] = ACTIONS(244),
    [anon_sym_ptr] = ACTIONS(246),
    [aux_sym_type_keyword_token1] = ACTIONS(244),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_RBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_GT] = ACTIONS(244),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_RPAREN] = ACTIONS(244),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_to] = ACTIONS(246),
    [anon_sym_unwind] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(244),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(244),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
    [anon_sym_unordered] = ACTIONS(244),
    [anon_sym_monotonic] = ACTIONS(244),
    [anon_sym_acquire] = ACTIONS(244),
    [anon_sym_release] = ACTIONS(244),
    [anon_sym_acq_rel] = ACTIONS(244),
    [anon_sym_seq_cst] = ACTIONS(244),
    [anon_sym_syncscope] = ACTIONS(244),
    [anon_sym_uselistorder] = ACTIONS(246),
    [anon_sym_uselistorder_bb] = ACTIONS(244),
    [anon_sym_module] = ACTIONS(244),
    [anon_sym_asm] = ACTIONS(244),
    [anon_sym_attributes] = ACTIONS(244),
  },
  [278] = {
    [ts_builtin_sym_end] = ACTIONS(847),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(847),
    [sym_comdat_ref] = ACTIONS(847),
    [sym_global_var] = ACTIONS(847),
    [sym_local_var] = ACTIONS(847),
    [aux_sym_metadata_ref_token1] = ACTIONS(847),
    [sym_summary_ref] = ACTIONS(847),
    [sym_string] = ACTIONS(847),
    [anon_sym_target] = ACTIONS(847),
    [anon_sym_EQ] = ACTIONS(847),
    [anon_sym_source_filename] = ACTIONS(847),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_define] = ACTIONS(847),
    [anon_sym_unnamed_addr] = ACTIONS(847),
    [anon_sym_local_unnamed_addr] = ACTIONS(847),
    [anon_sym_void] = ACTIONS(847),
    [anon_sym_half] = ACTIONS(847),
    [anon_sym_bfloat] = ACTIONS(847),
    [anon_sym_float] = ACTIONS(847),
    [anon_sym_double] = ACTIONS(847),
    [anon_sym_x86_fp80] = ACTIONS(847),
    [anon_sym_fp128] = ACTIONS(847),
    [anon_sym_ppc_fp128] = ACTIONS(847),
    [anon_sym_label] = ACTIONS(847),
    [anon_sym_metadata] = ACTIONS(847),
    [anon_sym_x86_mmx] = ACTIONS(847),
    [anon_sym_x86_amx] = ACTIONS(847),
    [anon_sym_token] = ACTIONS(847),
    [anon_sym_opaque] = ACTIONS(847),
    [anon_sym_ptr] = ACTIONS(847),
    [aux_sym_type_keyword_token1] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(847),
    [anon_sym_RBRACE] = ACTIONS(847),
    [anon_sym_LT_LBRACE] = ACTIONS(847),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(847),
    [anon_sym_addrspace] = ACTIONS(847),
    [anon_sym_LPAREN] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(847),
    [anon_sym_align] = ACTIONS(849),
    [anon_sym_section] = ACTIONS(847),
    [anon_sym_partition] = ACTIONS(847),
    [anon_sym_comdat] = ACTIONS(847),
    [anon_sym_gc] = ACTIONS(847),
    [anon_sym_prefix] = ACTIONS(847),
    [anon_sym_prologue] = ACTIONS(847),
    [anon_sym_personality] = ACTIONS(847),
    [anon_sym_alignstack] = ACTIONS(847),
    [anon_sym_allocsize] = ACTIONS(847),
    [anon_sym_alwaysinline] = ACTIONS(847),
    [anon_sym_builtin] = ACTIONS(847),
    [anon_sym_cold] = ACTIONS(847),
    [anon_sym_convergent] = ACTIONS(847),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(847),
    [anon_sym_hot] = ACTIONS(847),
    [anon_sym_inaccessiblememonly] = ACTIONS(847),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(847),
    [anon_sym_inlinehint] = ACTIONS(847),
    [anon_sym_jumptable] = ACTIONS(847),
    [anon_sym_minsize] = ACTIONS(847),
    [anon_sym_naked] = ACTIONS(847),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(847),
    [anon_sym_nobuiltin] = ACTIONS(847),
    [anon_sym_noduplicate] = ACTIONS(847),
    [anon_sym_nofree] = ACTIONS(847),
    [anon_sym_noimplicitfloat] = ACTIONS(847),
    [anon_sym_noinline] = ACTIONS(847),
    [anon_sym_nomerge] = ACTIONS(847),
    [anon_sym_nonlazybind] = ACTIONS(847),
    [anon_sym_noprofile] = ACTIONS(847),
    [anon_sym_noredzone] = ACTIONS(847),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(847),
    [anon_sym_noreturn] = ACTIONS(847),
    [anon_sym_norecurse] = ACTIONS(847),
    [anon_sym_willreturn] = ACTIONS(847),
    [anon_sym_nosync] = ACTIONS(847),
    [anon_sym_nounwind] = ACTIONS(847),
    [anon_sym_nocallback] = ACTIONS(847),
    [anon_sym_nosanitize_coverage] = ACTIONS(847),
    [anon_sym_null_pointer_is_valid] = ACTIONS(847),
    [anon_sym_optforfuzzing] = ACTIONS(847),
    [anon_sym_optnone] = ACTIONS(847),
    [anon_sym_optsize] = ACTIONS(847),
    [anon_sym_readnone] = ACTIONS(847),
    [anon_sym_readonly] = ACTIONS(847),
    [anon_sym_writeonly] = ACTIONS(847),
    [anon_sym_argmemonly] = ACTIONS(847),
    [anon_sym_returns_twice] = ACTIONS(847),
    [anon_sym_safestack] = ACTIONS(847),
    [anon_sym_sanitize_address] = ACTIONS(847),
    [anon_sym_sanitize_memory] = ACTIONS(847),
    [anon_sym_sanitize_thread] = ACTIONS(847),
    [anon_sym_sanitize_hwaddress] = ACTIONS(847),
    [anon_sym_sanitize_memtag] = ACTIONS(847),
    [anon_sym_speculative_load_hardening] = ACTIONS(847),
    [anon_sym_speculatable] = ACTIONS(847),
    [anon_sym_ssp] = ACTIONS(849),
    [anon_sym_sspstrong] = ACTIONS(847),
    [anon_sym_sspreq] = ACTIONS(847),
    [anon_sym_strictfp] = ACTIONS(847),
    [anon_sym_nocf_check] = ACTIONS(847),
    [anon_sym_shadowcallstack] = ACTIONS(847),
    [anon_sym_mustprogress] = ACTIONS(847),
    [anon_sym_vscale_range] = ACTIONS(847),
    [anon_sym_preallocated] = ACTIONS(847),
    [anon_sym_zeroext] = ACTIONS(847),
    [anon_sym_signext] = ACTIONS(847),
    [anon_sym_inreg] = ACTIONS(847),
    [anon_sym_byval] = ACTIONS(847),
    [anon_sym_byref] = ACTIONS(847),
    [anon_sym_inalloca] = ACTIONS(847),
    [anon_sym_sret] = ACTIONS(847),
    [anon_sym_elementtype] = ACTIONS(847),
    [anon_sym_noalias] = ACTIONS(847),
    [anon_sym_nocapture] = ACTIONS(847),
    [anon_sym_nest] = ACTIONS(847),
    [anon_sym_returned] = ACTIONS(847),
    [anon_sym_nonnull] = ACTIONS(847),
    [anon_sym_dereferenceable] = ACTIONS(849),
    [anon_sym_dereferenceable_or_null] = ACTIONS(847),
    [anon_sym_swiftself] = ACTIONS(847),
    [anon_sym_swiftasync] = ACTIONS(847),
    [anon_sym_swifterror] = ACTIONS(847),
    [anon_sym_immarg] = ACTIONS(847),
    [anon_sym_noundef] = ACTIONS(847),
    [anon_sym_uwtable] = ACTIONS(847),
    [anon_sym_memory] = ACTIONS(847),
    [anon_sym_to] = ACTIONS(849),
    [anon_sym_null] = ACTIONS(849),
    [anon_sym_uselistorder] = ACTIONS(849),
    [anon_sym_uselistorder_bb] = ACTIONS(847),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_BANG] = ACTIONS(849),
    [anon_sym_attributes] = ACTIONS(847),
  },
  [279] = {
    [ts_builtin_sym_end] = ACTIONS(863),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(863),
    [sym_comdat_ref] = ACTIONS(863),
    [sym_global_var] = ACTIONS(863),
    [sym_local_var] = ACTIONS(863),
    [aux_sym_metadata_ref_token1] = ACTIONS(863),
    [sym_summary_ref] = ACTIONS(863),
    [sym_string] = ACTIONS(863),
    [anon_sym_target] = ACTIONS(863),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_source_filename] = ACTIONS(863),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_define] = ACTIONS(863),
    [anon_sym_unnamed_addr] = ACTIONS(863),
    [anon_sym_local_unnamed_addr] = ACTIONS(863),
    [anon_sym_void] = ACTIONS(863),
    [anon_sym_half] = ACTIONS(863),
    [anon_sym_bfloat] = ACTIONS(863),
    [anon_sym_float] = ACTIONS(863),
    [anon_sym_double] = ACTIONS(863),
    [anon_sym_x86_fp80] = ACTIONS(863),
    [anon_sym_fp128] = ACTIONS(863),
    [anon_sym_ppc_fp128] = ACTIONS(863),
    [anon_sym_label] = ACTIONS(863),
    [anon_sym_metadata] = ACTIONS(863),
    [anon_sym_x86_mmx] = ACTIONS(863),
    [anon_sym_x86_amx] = ACTIONS(863),
    [anon_sym_token] = ACTIONS(863),
    [anon_sym_opaque] = ACTIONS(863),
    [anon_sym_ptr] = ACTIONS(863),
    [aux_sym_type_keyword_token1] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(863),
    [anon_sym_RBRACE] = ACTIONS(863),
    [anon_sym_LT_LBRACE] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_COMMA] = ACTIONS(863),
    [anon_sym_addrspace] = ACTIONS(863),
    [anon_sym_LPAREN] = ACTIONS(1026),
    [anon_sym_RPAREN] = ACTIONS(863),
    [anon_sym_align] = ACTIONS(865),
    [anon_sym_section] = ACTIONS(863),
    [anon_sym_partition] = ACTIONS(863),
    [anon_sym_comdat] = ACTIONS(863),
    [anon_sym_gc] = ACTIONS(863),
    [anon_sym_prefix] = ACTIONS(863),
    [anon_sym_prologue] = ACTIONS(863),
    [anon_sym_personality] = ACTIONS(863),
    [anon_sym_alignstack] = ACTIONS(863),
    [anon_sym_allocsize] = ACTIONS(863),
    [anon_sym_alwaysinline] = ACTIONS(863),
    [anon_sym_builtin] = ACTIONS(863),
    [anon_sym_cold] = ACTIONS(863),
    [anon_sym_convergent] = ACTIONS(863),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(863),
    [anon_sym_hot] = ACTIONS(863),
    [anon_sym_inaccessiblememonly] = ACTIONS(863),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(863),
    [anon_sym_inlinehint] = ACTIONS(863),
    [anon_sym_jumptable] = ACTIONS(863),
    [anon_sym_minsize] = ACTIONS(863),
    [anon_sym_naked] = ACTIONS(863),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(863),
    [anon_sym_nobuiltin] = ACTIONS(863),
    [anon_sym_noduplicate] = ACTIONS(863),
    [anon_sym_nofree] = ACTIONS(863),
    [anon_sym_noimplicitfloat] = ACTIONS(863),
    [anon_sym_noinline] = ACTIONS(863),
    [anon_sym_nomerge] = ACTIONS(863),
    [anon_sym_nonlazybind] = ACTIONS(863),
    [anon_sym_noprofile] = ACTIONS(863),
    [anon_sym_noredzone] = ACTIONS(863),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(863),
    [anon_sym_noreturn] = ACTIONS(863),
    [anon_sym_norecurse] = ACTIONS(863),
    [anon_sym_willreturn] = ACTIONS(863),
    [anon_sym_nosync] = ACTIONS(863),
    [anon_sym_nounwind] = ACTIONS(863),
    [anon_sym_nocallback] = ACTIONS(863),
    [anon_sym_nosanitize_coverage] = ACTIONS(863),
    [anon_sym_null_pointer_is_valid] = ACTIONS(863),
    [anon_sym_optforfuzzing] = ACTIONS(863),
    [anon_sym_optnone] = ACTIONS(863),
    [anon_sym_optsize] = ACTIONS(863),
    [anon_sym_readnone] = ACTIONS(863),
    [anon_sym_readonly] = ACTIONS(863),
    [anon_sym_writeonly] = ACTIONS(863),
    [anon_sym_argmemonly] = ACTIONS(863),
    [anon_sym_returns_twice] = ACTIONS(863),
    [anon_sym_safestack] = ACTIONS(863),
    [anon_sym_sanitize_address] = ACTIONS(863),
    [anon_sym_sanitize_memory] = ACTIONS(863),
    [anon_sym_sanitize_thread] = ACTIONS(863),
    [anon_sym_sanitize_hwaddress] = ACTIONS(863),
    [anon_sym_sanitize_memtag] = ACTIONS(863),
    [anon_sym_speculative_load_hardening] = ACTIONS(863),
    [anon_sym_speculatable] = ACTIONS(863),
    [anon_sym_ssp] = ACTIONS(865),
    [anon_sym_sspstrong] = ACTIONS(863),
    [anon_sym_sspreq] = ACTIONS(863),
    [anon_sym_strictfp] = ACTIONS(863),
    [anon_sym_nocf_check] = ACTIONS(863),
    [anon_sym_shadowcallstack] = ACTIONS(863),
    [anon_sym_mustprogress] = ACTIONS(863),
    [anon_sym_vscale_range] = ACTIONS(863),
    [anon_sym_preallocated] = ACTIONS(863),
    [anon_sym_zeroext] = ACTIONS(863),
    [anon_sym_signext] = ACTIONS(863),
    [anon_sym_inreg] = ACTIONS(863),
    [anon_sym_byval] = ACTIONS(863),
    [anon_sym_byref] = ACTIONS(863),
    [anon_sym_inalloca] = ACTIONS(863),
    [anon_sym_sret] = ACTIONS(863),
    [anon_sym_elementtype] = ACTIONS(863),
    [anon_sym_noalias] = ACTIONS(863),
    [anon_sym_nocapture] = ACTIONS(863),
    [anon_sym_nest] = ACTIONS(863),
    [anon_sym_returned] = ACTIONS(863),
    [anon_sym_nonnull] = ACTIONS(863),
    [anon_sym_dereferenceable] = ACTIONS(865),
    [anon_sym_dereferenceable_or_null] = ACTIONS(863),
    [anon_sym_swiftself] = ACTIONS(863),
    [anon_sym_swiftasync] = ACTIONS(863),
    [anon_sym_swifterror] = ACTIONS(863),
    [anon_sym_immarg] = ACTIONS(863),
    [anon_sym_noundef] = ACTIONS(863),
    [anon_sym_uwtable] = ACTIONS(863),
    [anon_sym_memory] = ACTIONS(863),
    [anon_sym_to] = ACTIONS(865),
    [anon_sym_null] = ACTIONS(865),
    [anon_sym_uselistorder] = ACTIONS(865),
    [anon_sym_uselistorder_bb] = ACTIONS(863),
    [anon_sym_module] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_attributes] = ACTIONS(863),
  },
  [280] = {
    [ts_builtin_sym_end] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(383),
    [sym_global_var] = ACTIONS(383),
    [sym_local_var] = ACTIONS(383),
    [aux_sym_metadata_ref_token1] = ACTIONS(383),
    [sym_summary_ref] = ACTIONS(383),
    [sym_string] = ACTIONS(383),
    [aux_sym_number_token1] = ACTIONS(385),
    [aux_sym_number_token2] = ACTIONS(383),
    [sym_float] = ACTIONS(383),
    [sym_cstring] = ACTIONS(383),
    [anon_sym_target] = ACTIONS(383),
    [anon_sym_source_filename] = ACTIONS(383),
    [anon_sym_declare] = ACTIONS(383),
    [anon_sym_define] = ACTIONS(383),
    [anon_sym_no_cfi] = ACTIONS(383),
    [anon_sym_private] = ACTIONS(383),
    [anon_sym_internal] = ACTIONS(383),
    [anon_sym_weak] = ACTIONS(385),
    [anon_sym_weak_odr] = ACTIONS(383),
    [anon_sym_linkonce] = ACTIONS(385),
    [anon_sym_linkonce_odr] = ACTIONS(383),
    [anon_sym_available_externally] = ACTIONS(383),
    [anon_sym_appending] = ACTIONS(383),
    [anon_sym_common] = ACTIONS(383),
    [anon_sym_extern_weak] = ACTIONS(383),
    [anon_sym_external] = ACTIONS(383),
    [anon_sym_dso_local] = ACTIONS(385),
    [anon_sym_dso_local_equivalent] = ACTIONS(383),
    [anon_sym_dso_preemptable] = ACTIONS(383),
    [anon_sym_default] = ACTIONS(383),
    [anon_sym_hidden] = ACTIONS(383),
    [anon_sym_protected] = ACTIONS(383),
    [anon_sym_dllimport] = ACTIONS(383),
    [anon_sym_dllexport] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_void] = ACTIONS(383),
    [anon_sym_half] = ACTIONS(383),
    [anon_sym_bfloat] = ACTIONS(383),
    [anon_sym_float] = ACTIONS(383),
    [anon_sym_double] = ACTIONS(383),
    [anon_sym_x86_fp80] = ACTIONS(383),
    [anon_sym_fp128] = ACTIONS(383),
    [anon_sym_ppc_fp128] = ACTIONS(383),
    [anon_sym_label] = ACTIONS(383),
    [anon_sym_metadata] = ACTIONS(383),
    [anon_sym_x86_mmx] = ACTIONS(383),
    [anon_sym_x86_amx] = ACTIONS(383),
    [anon_sym_token] = ACTIONS(383),
    [anon_sym_opaque] = ACTIONS(383),
    [anon_sym_ptr] = ACTIONS(385),
    [aux_sym_type_keyword_token1] = ACTIONS(383),
    [anon_sym_LBRACE] = ACTIONS(383),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_LT_LBRACE] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_RBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_addrspace] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_RPAREN] = ACTIONS(383),
    [anon_sym_none] = ACTIONS(383),
    [anon_sym_extractelement] = ACTIONS(383),
    [anon_sym_insertelement] = ACTIONS(383),
    [anon_sym_select] = ACTIONS(383),
    [anon_sym_shufflevector] = ACTIONS(383),
    [anon_sym_fneg] = ACTIONS(383),
    [anon_sym_to] = ACTIONS(385),
    [anon_sym_unwind] = ACTIONS(383),
    [anon_sym_icmp] = ACTIONS(383),
    [anon_sym_fcmp] = ACTIONS(383),
    [anon_sym_cleanup] = ACTIONS(383),
    [anon_sym_getelementptr] = ACTIONS(383),
    [anon_sym_extractvalue] = ACTIONS(383),
    [anon_sym_insertvalue] = ACTIONS(383),
    [anon_sym_true] = ACTIONS(383),
    [anon_sym_false] = ACTIONS(383),
    [anon_sym_null] = ACTIONS(383),
    [anon_sym_undef] = ACTIONS(383),
    [anon_sym_poison] = ACTIONS(383),
    [anon_sym_zeroinitializer] = ACTIONS(383),
    [anon_sym_catch] = ACTIONS(383),
    [anon_sym_filter] = ACTIONS(383),
    [anon_sym_blockaddress] = ACTIONS(383),
    [anon_sym_mul] = ACTIONS(383),
    [anon_sym_urem] = ACTIONS(383),
    [anon_sym_srem] = ACTIONS(383),
    [anon_sym_shl] = ACTIONS(383),
    [anon_sym_udiv] = ACTIONS(383),
    [anon_sym_sdiv] = ACTIONS(383),
    [anon_sym_lshr] = ACTIONS(383),
    [anon_sym_ashr] = ACTIONS(383),
    [anon_sym_fmul] = ACTIONS(383),
    [anon_sym_fdiv] = ACTIONS(383),
    [anon_sym_frem] = ACTIONS(383),
    [anon_sym_xchg] = ACTIONS(383),
    [anon_sym_add] = ACTIONS(385),
    [anon_sym_sub] = ACTIONS(383),
    [anon_sym_and] = ACTIONS(383),
    [anon_sym_nand] = ACTIONS(383),
    [anon_sym_or] = ACTIONS(383),
    [anon_sym_xor] = ACTIONS(383),
    [anon_sym_max] = ACTIONS(383),
    [anon_sym_min] = ACTIONS(383),
    [anon_sym_umax] = ACTIONS(383),
    [anon_sym_umin] = ACTIONS(383),
    [anon_sym_fadd] = ACTIONS(383),
    [anon_sym_fsub] = ACTIONS(383),
    [anon_sym_bitcast] = ACTIONS(383),
    [anon_sym_trunc] = ACTIONS(383),
    [anon_sym_zext] = ACTIONS(383),
    [anon_sym_sext] = ACTIONS(383),
    [anon_sym_fptrunc] = ACTIONS(383),
    [anon_sym_fpext] = ACTIONS(383),
    [anon_sym_addrspacecast] = ACTIONS(383),
    [anon_sym_uitofp] = ACTIONS(383),
    [anon_sym_sitofp] = ACTIONS(383),
    [anon_sym_fptoui] = ACTIONS(383),
    [anon_sym_fptosi] = ACTIONS(383),
    [anon_sym_inttoptr] = ACTIONS(383),
    [anon_sym_ptrtoint] = ACTIONS(383),
    [anon_sym_unordered] = ACTIONS(383),
    [anon_sym_monotonic] = ACTIONS(383),
    [anon_sym_acquire] = ACTIONS(383),
    [anon_sym_release] = ACTIONS(383),
    [anon_sym_acq_rel] = ACTIONS(383),
    [anon_sym_seq_cst] = ACTIONS(383),
    [anon_sym_syncscope] = ACTIONS(383),
    [anon_sym_uselistorder] = ACTIONS(385),
    [anon_sym_uselistorder_bb] = ACTIONS(383),
    [anon_sym_module] = ACTIONS(383),
    [anon_sym_asm] = ACTIONS(383),
    [anon_sym_attributes] = ACTIONS(383),
  },
  [281] = {
    [ts_builtin_sym_end] = ACTIONS(363),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(363),
    [sym_global_var] = ACTIONS(363),
    [sym_local_var] = ACTIONS(363),
    [aux_sym_metadata_ref_token1] = ACTIONS(363),
    [sym_summary_ref] = ACTIONS(363),
    [sym_string] = ACTIONS(363),
    [aux_sym_number_token1] = ACTIONS(365),
    [aux_sym_number_token2] = ACTIONS(363),
    [sym_float] = ACTIONS(363),
    [sym_cstring] = ACTIONS(363),
    [anon_sym_target] = ACTIONS(363),
    [anon_sym_source_filename] = ACTIONS(363),
    [anon_sym_declare] = ACTIONS(363),
    [anon_sym_define] = ACTIONS(363),
    [anon_sym_no_cfi] = ACTIONS(363),
    [anon_sym_private] = ACTIONS(363),
    [anon_sym_internal] = ACTIONS(363),
    [anon_sym_weak] = ACTIONS(365),
    [anon_sym_weak_odr] = ACTIONS(363),
    [anon_sym_linkonce] = ACTIONS(365),
    [anon_sym_linkonce_odr] = ACTIONS(363),
    [anon_sym_available_externally] = ACTIONS(363),
    [anon_sym_appending] = ACTIONS(363),
    [anon_sym_common] = ACTIONS(363),
    [anon_sym_extern_weak] = ACTIONS(363),
    [anon_sym_external] = ACTIONS(363),
    [anon_sym_dso_local] = ACTIONS(365),
    [anon_sym_dso_local_equivalent] = ACTIONS(363),
    [anon_sym_dso_preemptable] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(363),
    [anon_sym_hidden] = ACTIONS(363),
    [anon_sym_protected] = ACTIONS(363),
    [anon_sym_dllimport] = ACTIONS(363),
    [anon_sym_dllexport] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(363),
    [anon_sym_void] = ACTIONS(363),
    [anon_sym_half] = ACTIONS(363),
    [anon_sym_bfloat] = ACTIONS(363),
    [anon_sym_float] = ACTIONS(363),
    [anon_sym_double] = ACTIONS(363),
    [anon_sym_x86_fp80] = ACTIONS(363),
    [anon_sym_fp128] = ACTIONS(363),
    [anon_sym_ppc_fp128] = ACTIONS(363),
    [anon_sym_label] = ACTIONS(363),
    [anon_sym_metadata] = ACTIONS(363),
    [anon_sym_x86_mmx] = ACTIONS(363),
    [anon_sym_x86_amx] = ACTIONS(363),
    [anon_sym_token] = ACTIONS(363),
    [anon_sym_opaque] = ACTIONS(363),
    [anon_sym_ptr] = ACTIONS(365),
    [aux_sym_type_keyword_token1] = ACTIONS(363),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_LT_LBRACE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_RBRACK] = ACTIONS(363),
    [anon_sym_LT] = ACTIONS(365),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_addrspace] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_none] = ACTIONS(363),
    [anon_sym_extractelement] = ACTIONS(363),
    [anon_sym_insertelement] = ACTIONS(363),
    [anon_sym_select] = ACTIONS(363),
    [anon_sym_shufflevector] = ACTIONS(363),
    [anon_sym_fneg] = ACTIONS(363),
    [anon_sym_to] = ACTIONS(365),
    [anon_sym_unwind] = ACTIONS(363),
    [anon_sym_icmp] = ACTIONS(363),
    [anon_sym_fcmp] = ACTIONS(363),
    [anon_sym_cleanup] = ACTIONS(363),
    [anon_sym_getelementptr] = ACTIONS(363),
    [anon_sym_extractvalue] = ACTIONS(363),
    [anon_sym_insertvalue] = ACTIONS(363),
    [anon_sym_true] = ACTIONS(363),
    [anon_sym_false] = ACTIONS(363),
    [anon_sym_null] = ACTIONS(363),
    [anon_sym_undef] = ACTIONS(363),
    [anon_sym_poison] = ACTIONS(363),
    [anon_sym_zeroinitializer] = ACTIONS(363),
    [anon_sym_catch] = ACTIONS(363),
    [anon_sym_filter] = ACTIONS(363),
    [anon_sym_blockaddress] = ACTIONS(363),
    [anon_sym_mul] = ACTIONS(363),
    [anon_sym_urem] = ACTIONS(363),
    [anon_sym_srem] = ACTIONS(363),
    [anon_sym_shl] = ACTIONS(363),
    [anon_sym_udiv] = ACTIONS(363),
    [anon_sym_sdiv] = ACTIONS(363),
    [anon_sym_lshr] = ACTIONS(363),
    [anon_sym_ashr] = ACTIONS(363),
    [anon_sym_fmul] = ACTIONS(363),
    [anon_sym_fdiv] = ACTIONS(363),
    [anon_sym_frem] = ACTIONS(363),
    [anon_sym_xchg] = ACTIONS(363),
    [anon_sym_add] = ACTIONS(365),
    [anon_sym_sub] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_nand] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_xor] = ACTIONS(363),
    [anon_sym_max] = ACTIONS(363),
    [anon_sym_min] = ACTIONS(363),
    [anon_sym_umax] = ACTIONS(363),
    [anon_sym_umin] = ACTIONS(363),
    [anon_sym_fadd] = ACTIONS(363),
    [anon_sym_fsub] = ACTIONS(363),
    [anon_sym_bitcast] = ACTIONS(363),
    [anon_sym_trunc] = ACTIONS(363),
    [anon_sym_zext] = ACTIONS(363),
    [anon_sym_sext] = ACTIONS(363),
    [anon_sym_fptrunc] = ACTIONS(363),
    [anon_sym_fpext] = ACTIONS(363),
    [anon_sym_addrspacecast] = ACTIONS(363),
    [anon_sym_uitofp] = ACTIONS(363),
    [anon_sym_sitofp] = ACTIONS(363),
    [anon_sym_fptoui] = ACTIONS(363),
    [anon_sym_fptosi] = ACTIONS(363),
    [anon_sym_inttoptr] = ACTIONS(363),
    [anon_sym_ptrtoint] = ACTIONS(363),
    [anon_sym_unordered] = ACTIONS(363),
    [anon_sym_monotonic] = ACTIONS(363),
    [anon_sym_acquire] = ACTIONS(363),
    [anon_sym_release] = ACTIONS(363),
    [anon_sym_acq_rel] = ACTIONS(363),
    [anon_sym_seq_cst] = ACTIONS(363),
    [anon_sym_syncscope] = ACTIONS(363),
    [anon_sym_uselistorder] = ACTIONS(365),
    [anon_sym_uselistorder_bb] = ACTIONS(363),
    [anon_sym_module] = ACTIONS(363),
    [anon_sym_asm] = ACTIONS(363),
    [anon_sym_attributes] = ACTIONS(363),
  },
  [282] = {
    [sym_number] = STATE(361),
    [sym_var] = STATE(361),
    [sym_linkage] = STATE(820),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(360),
    [sym__primitive_value] = STATE(361),
    [sym_struct_value] = STATE(361),
    [sym_packed_struct_value] = STATE(361),
    [sym_array_value] = STATE(361),
    [sym_vector_value] = STATE(361),
    [sym_blockaddress] = STATE(361),
    [sym_constant_expr] = STATE(361),
    [sym_constant_cast] = STATE(359),
    [sym_constant_getelementptr] = STATE(359),
    [sym_constant_select] = STATE(359),
    [sym_constant_icmp] = STATE(359),
    [sym_constant_fcmp] = STATE(359),
    [sym_constant_extractelement] = STATE(359),
    [sym_constant_insertelement] = STATE(359),
    [sym_constant_shufflevector] = STATE(359),
    [sym_constant_extractvalue] = STATE(359),
    [sym_constant_insertvalue] = STATE(359),
    [sym_constant_fneg] = STATE(359),
    [sym_constant_bin_op] = STATE(359),
    [sym_bin_op_keyword] = STATE(1133),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1924),
    [aux_sym_function_header_repeat1] = STATE(820),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(426),
    [sym_local_var] = ACTIONS(305),
    [sym_string] = ACTIONS(315),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [sym_float] = ACTIONS(315),
    [sym_cstring] = ACTIONS(315),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_void] = ACTIONS(38),
    [anon_sym_half] = ACTIONS(38),
    [anon_sym_bfloat] = ACTIONS(38),
    [anon_sym_float] = ACTIONS(38),
    [anon_sym_double] = ACTIONS(38),
    [anon_sym_x86_fp80] = ACTIONS(38),
    [anon_sym_fp128] = ACTIONS(38),
    [anon_sym_ppc_fp128] = ACTIONS(38),
    [anon_sym_label] = ACTIONS(38),
    [anon_sym_metadata] = ACTIONS(38),
    [anon_sym_x86_mmx] = ACTIONS(38),
    [anon_sym_x86_amx] = ACTIONS(38),
    [anon_sym_token] = ACTIONS(38),
    [anon_sym_opaque] = ACTIONS(38),
    [anon_sym_ptr] = ACTIONS(70),
    [aux_sym_type_keyword_token1] = ACTIONS(38),
    [anon_sym_LBRACE] = ACTIONS(433),
    [anon_sym_LT_LBRACE] = ACTIONS(1029),
    [anon_sym_LBRACK] = ACTIONS(428),
    [anon_sym_RBRACK] = ACTIONS(38),
    [anon_sym_LT] = ACTIONS(1032),
    [anon_sym_none] = ACTIONS(315),
    [anon_sym_extractelement] = ACTIONS(335),
    [anon_sym_insertelement] = ACTIONS(337),
    [anon_sym_select] = ACTIONS(339),
    [anon_sym_shufflevector] = ACTIONS(341),
    [anon_sym_fneg] = ACTIONS(343),
    [anon_sym_icmp] = ACTIONS(345),
    [anon_sym_fcmp] = ACTIONS(347),
    [anon_sym_getelementptr] = ACTIONS(349),
    [anon_sym_extractvalue] = ACTIONS(351),
    [anon_sym_insertvalue] = ACTIONS(353),
    [anon_sym_true] = ACTIONS(315),
    [anon_sym_false] = ACTIONS(315),
    [anon_sym_null] = ACTIONS(315),
    [anon_sym_undef] = ACTIONS(315),
    [anon_sym_poison] = ACTIONS(315),
    [anon_sym_zeroinitializer] = ACTIONS(315),
    [anon_sym_blockaddress] = ACTIONS(357),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [283] = {
    [ts_builtin_sym_end] = ACTIONS(263),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(263),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [aux_sym_metadata_ref_token1] = ACTIONS(263),
    [sym_summary_ref] = ACTIONS(263),
    [sym_string] = ACTIONS(263),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(263),
    [sym_float] = ACTIONS(263),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_target] = ACTIONS(263),
    [anon_sym_source_filename] = ACTIONS(263),
    [anon_sym_declare] = ACTIONS(263),
    [anon_sym_define] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(263),
    [anon_sym_private] = ACTIONS(263),
    [anon_sym_internal] = ACTIONS(263),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(263),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(263),
    [anon_sym_available_externally] = ACTIONS(263),
    [anon_sym_appending] = ACTIONS(263),
    [anon_sym_common] = ACTIONS(263),
    [anon_sym_extern_weak] = ACTIONS(263),
    [anon_sym_external] = ACTIONS(263),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(263),
    [anon_sym_dso_preemptable] = ACTIONS(263),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_hidden] = ACTIONS(263),
    [anon_sym_protected] = ACTIONS(263),
    [anon_sym_dllimport] = ACTIONS(263),
    [anon_sym_dllexport] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(263),
    [anon_sym_half] = ACTIONS(263),
    [anon_sym_bfloat] = ACTIONS(263),
    [anon_sym_float] = ACTIONS(263),
    [anon_sym_double] = ACTIONS(263),
    [anon_sym_x86_fp80] = ACTIONS(263),
    [anon_sym_fp128] = ACTIONS(263),
    [anon_sym_ppc_fp128] = ACTIONS(263),
    [anon_sym_label] = ACTIONS(263),
    [anon_sym_metadata] = ACTIONS(263),
    [anon_sym_x86_mmx] = ACTIONS(263),
    [anon_sym_x86_amx] = ACTIONS(263),
    [anon_sym_token] = ACTIONS(263),
    [anon_sym_opaque] = ACTIONS(263),
    [anon_sym_ptr] = ACTIONS(265),
    [aux_sym_type_keyword_token1] = ACTIONS(263),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_RBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_RPAREN] = ACTIONS(263),
    [anon_sym_none] = ACTIONS(263),
    [anon_sym_extractelement] = ACTIONS(263),
    [anon_sym_insertelement] = ACTIONS(263),
    [anon_sym_select] = ACTIONS(263),
    [anon_sym_shufflevector] = ACTIONS(263),
    [anon_sym_fneg] = ACTIONS(263),
    [anon_sym_to] = ACTIONS(265),
    [anon_sym_unwind] = ACTIONS(263),
    [anon_sym_icmp] = ACTIONS(263),
    [anon_sym_fcmp] = ACTIONS(263),
    [anon_sym_cleanup] = ACTIONS(263),
    [anon_sym_getelementptr] = ACTIONS(263),
    [anon_sym_extractvalue] = ACTIONS(263),
    [anon_sym_insertvalue] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(263),
    [anon_sym_false] = ACTIONS(263),
    [anon_sym_null] = ACTIONS(263),
    [anon_sym_undef] = ACTIONS(263),
    [anon_sym_poison] = ACTIONS(263),
    [anon_sym_zeroinitializer] = ACTIONS(263),
    [anon_sym_catch] = ACTIONS(263),
    [anon_sym_filter] = ACTIONS(263),
    [anon_sym_blockaddress] = ACTIONS(263),
    [anon_sym_mul] = ACTIONS(263),
    [anon_sym_urem] = ACTIONS(263),
    [anon_sym_srem] = ACTIONS(263),
    [anon_sym_shl] = ACTIONS(263),
    [anon_sym_udiv] = ACTIONS(263),
    [anon_sym_sdiv] = ACTIONS(263),
    [anon_sym_lshr] = ACTIONS(263),
    [anon_sym_ashr] = ACTIONS(263),
    [anon_sym_fmul] = ACTIONS(263),
    [anon_sym_fdiv] = ACTIONS(263),
    [anon_sym_frem] = ACTIONS(263),
    [anon_sym_xchg] = ACTIONS(263),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(263),
    [anon_sym_and] = ACTIONS(263),
    [anon_sym_nand] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(263),
    [anon_sym_xor] = ACTIONS(263),
    [anon_sym_max] = ACTIONS(263),
    [anon_sym_min] = ACTIONS(263),
    [anon_sym_umax] = ACTIONS(263),
    [anon_sym_umin] = ACTIONS(263),
    [anon_sym_fadd] = ACTIONS(263),
    [anon_sym_fsub] = ACTIONS(263),
    [anon_sym_bitcast] = ACTIONS(263),
    [anon_sym_trunc] = ACTIONS(263),
    [anon_sym_zext] = ACTIONS(263),
    [anon_sym_sext] = ACTIONS(263),
    [anon_sym_fptrunc] = ACTIONS(263),
    [anon_sym_fpext] = ACTIONS(263),
    [anon_sym_addrspacecast] = ACTIONS(263),
    [anon_sym_uitofp] = ACTIONS(263),
    [anon_sym_sitofp] = ACTIONS(263),
    [anon_sym_fptoui] = ACTIONS(263),
    [anon_sym_fptosi] = ACTIONS(263),
    [anon_sym_inttoptr] = ACTIONS(263),
    [anon_sym_ptrtoint] = ACTIONS(263),
    [anon_sym_unordered] = ACTIONS(263),
    [anon_sym_monotonic] = ACTIONS(263),
    [anon_sym_acquire] = ACTIONS(263),
    [anon_sym_release] = ACTIONS(263),
    [anon_sym_acq_rel] = ACTIONS(263),
    [anon_sym_seq_cst] = ACTIONS(263),
    [anon_sym_syncscope] = ACTIONS(263),
    [anon_sym_uselistorder] = ACTIONS(265),
    [anon_sym_uselistorder_bb] = ACTIONS(263),
    [anon_sym_module] = ACTIONS(263),
    [anon_sym_asm] = ACTIONS(263),
    [anon_sym_attributes] = ACTIONS(263),
  },
  [284] = {
    [ts_builtin_sym_end] = ACTIONS(395),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(395),
    [sym_global_var] = ACTIONS(395),
    [sym_local_var] = ACTIONS(395),
    [aux_sym_metadata_ref_token1] = ACTIONS(395),
    [sym_summary_ref] = ACTIONS(395),
    [sym_string] = ACTIONS(395),
    [aux_sym_number_token1] = ACTIONS(397),
    [aux_sym_number_token2] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_cstring] = ACTIONS(395),
    [anon_sym_target] = ACTIONS(395),
    [anon_sym_source_filename] = ACTIONS(395),
    [anon_sym_declare] = ACTIONS(395),
    [anon_sym_define] = ACTIONS(395),
    [anon_sym_no_cfi] = ACTIONS(395),
    [anon_sym_private] = ACTIONS(395),
    [anon_sym_internal] = ACTIONS(395),
    [anon_sym_weak] = ACTIONS(397),
    [anon_sym_weak_odr] = ACTIONS(395),
    [anon_sym_linkonce] = ACTIONS(397),
    [anon_sym_linkonce_odr] = ACTIONS(395),
    [anon_sym_available_externally] = ACTIONS(395),
    [anon_sym_appending] = ACTIONS(395),
    [anon_sym_common] = ACTIONS(395),
    [anon_sym_extern_weak] = ACTIONS(395),
    [anon_sym_external] = ACTIONS(395),
    [anon_sym_dso_local] = ACTIONS(397),
    [anon_sym_dso_local_equivalent] = ACTIONS(395),
    [anon_sym_dso_preemptable] = ACTIONS(395),
    [anon_sym_default] = ACTIONS(395),
    [anon_sym_hidden] = ACTIONS(395),
    [anon_sym_protected] = ACTIONS(395),
    [anon_sym_dllimport] = ACTIONS(395),
    [anon_sym_dllexport] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_half] = ACTIONS(395),
    [anon_sym_bfloat] = ACTIONS(395),
    [anon_sym_float] = ACTIONS(395),
    [anon_sym_double] = ACTIONS(395),
    [anon_sym_x86_fp80] = ACTIONS(395),
    [anon_sym_fp128] = ACTIONS(395),
    [anon_sym_ppc_fp128] = ACTIONS(395),
    [anon_sym_label] = ACTIONS(395),
    [anon_sym_metadata] = ACTIONS(395),
    [anon_sym_x86_mmx] = ACTIONS(395),
    [anon_sym_x86_amx] = ACTIONS(395),
    [anon_sym_token] = ACTIONS(395),
    [anon_sym_opaque] = ACTIONS(395),
    [anon_sym_ptr] = ACTIONS(397),
    [aux_sym_type_keyword_token1] = ACTIONS(395),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_RBRACE] = ACTIONS(395),
    [anon_sym_LT_LBRACE] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(395),
    [anon_sym_RBRACK] = ACTIONS(395),
    [anon_sym_LT] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(395),
    [anon_sym_none] = ACTIONS(395),
    [anon_sym_extractelement] = ACTIONS(395),
    [anon_sym_insertelement] = ACTIONS(395),
    [anon_sym_select] = ACTIONS(395),
    [anon_sym_shufflevector] = ACTIONS(395),
    [anon_sym_fneg] = ACTIONS(395),
    [anon_sym_to] = ACTIONS(397),
    [anon_sym_unwind] = ACTIONS(395),
    [anon_sym_icmp] = ACTIONS(395),
    [anon_sym_fcmp] = ACTIONS(395),
    [anon_sym_cleanup] = ACTIONS(395),
    [anon_sym_getelementptr] = ACTIONS(395),
    [anon_sym_extractvalue] = ACTIONS(395),
    [anon_sym_insertvalue] = ACTIONS(395),
    [anon_sym_true] = ACTIONS(395),
    [anon_sym_false] = ACTIONS(395),
    [anon_sym_null] = ACTIONS(395),
    [anon_sym_undef] = ACTIONS(395),
    [anon_sym_poison] = ACTIONS(395),
    [anon_sym_zeroinitializer] = ACTIONS(395),
    [anon_sym_catch] = ACTIONS(395),
    [anon_sym_filter] = ACTIONS(395),
    [anon_sym_blockaddress] = ACTIONS(395),
    [anon_sym_mul] = ACTIONS(395),
    [anon_sym_urem] = ACTIONS(395),
    [anon_sym_srem] = ACTIONS(395),
    [anon_sym_shl] = ACTIONS(395),
    [anon_sym_udiv] = ACTIONS(395),
    [anon_sym_sdiv] = ACTIONS(395),
    [anon_sym_lshr] = ACTIONS(395),
    [anon_sym_ashr] = ACTIONS(395),
    [anon_sym_fmul] = ACTIONS(395),
    [anon_sym_fdiv] = ACTIONS(395),
    [anon_sym_frem] = ACTIONS(395),
    [anon_sym_xchg] = ACTIONS(395),
    [anon_sym_add] = ACTIONS(397),
    [anon_sym_sub] = ACTIONS(395),
    [anon_sym_and] = ACTIONS(395),
    [anon_sym_nand] = ACTIONS(395),
    [anon_sym_or] = ACTIONS(395),
    [anon_sym_xor] = ACTIONS(395),
    [anon_sym_max] = ACTIONS(395),
    [anon_sym_min] = ACTIONS(395),
    [anon_sym_umax] = ACTIONS(395),
    [anon_sym_umin] = ACTIONS(395),
    [anon_sym_fadd] = ACTIONS(395),
    [anon_sym_fsub] = ACTIONS(395),
    [anon_sym_bitcast] = ACTIONS(395),
    [anon_sym_trunc] = ACTIONS(395),
    [anon_sym_zext] = ACTIONS(395),
    [anon_sym_sext] = ACTIONS(395),
    [anon_sym_fptrunc] = ACTIONS(395),
    [anon_sym_fpext] = ACTIONS(395),
    [anon_sym_addrspacecast] = ACTIONS(395),
    [anon_sym_uitofp] = ACTIONS(395),
    [anon_sym_sitofp] = ACTIONS(395),
    [anon_sym_fptoui] = ACTIONS(395),
    [anon_sym_fptosi] = ACTIONS(395),
    [anon_sym_inttoptr] = ACTIONS(395),
    [anon_sym_ptrtoint] = ACTIONS(395),
    [anon_sym_unordered] = ACTIONS(395),
    [anon_sym_monotonic] = ACTIONS(395),
    [anon_sym_acquire] = ACTIONS(395),
    [anon_sym_release] = ACTIONS(395),
    [anon_sym_acq_rel] = ACTIONS(395),
    [anon_sym_seq_cst] = ACTIONS(395),
    [anon_sym_syncscope] = ACTIONS(395),
    [anon_sym_uselistorder] = ACTIONS(397),
    [anon_sym_uselistorder_bb] = ACTIONS(395),
    [anon_sym_module] = ACTIONS(395),
    [anon_sym_asm] = ACTIONS(395),
    [anon_sym_attributes] = ACTIONS(395),
  },
  [285] = {
    [sym_addrspace] = STATE(363),
    [sym_argument_list] = STATE(287),
    [aux_sym_type_repeat1] = STATE(289),
    [aux_sym_type_repeat2] = STATE(287),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(234),
    [sym_local_var] = ACTIONS(234),
    [sym_label] = ACTIONS(234),
    [sym_string] = ACTIONS(236),
    [aux_sym_number_token1] = ACTIONS(236),
    [aux_sym_number_token2] = ACTIONS(236),
    [sym_float] = ACTIONS(236),
    [sym_cstring] = ACTIONS(234),
    [anon_sym_no_cfi] = ACTIONS(236),
    [anon_sym_private] = ACTIONS(236),
    [anon_sym_internal] = ACTIONS(236),
    [anon_sym_weak] = ACTIONS(236),
    [anon_sym_weak_odr] = ACTIONS(236),
    [anon_sym_linkonce] = ACTIONS(236),
    [anon_sym_linkonce_odr] = ACTIONS(236),
    [anon_sym_available_externally] = ACTIONS(236),
    [anon_sym_appending] = ACTIONS(236),
    [anon_sym_common] = ACTIONS(236),
    [anon_sym_extern_weak] = ACTIONS(236),
    [anon_sym_external] = ACTIONS(236),
    [anon_sym_dso_local] = ACTIONS(236),
    [anon_sym_dso_local_equivalent] = ACTIONS(236),
    [anon_sym_dso_preemptable] = ACTIONS(236),
    [anon_sym_default] = ACTIONS(236),
    [anon_sym_hidden] = ACTIONS(236),
    [anon_sym_protected] = ACTIONS(236),
    [anon_sym_dllimport] = ACTIONS(236),
    [anon_sym_dllexport] = ACTIONS(236),
    [anon_sym_STAR] = ACTIONS(1037),
    [anon_sym_LBRACE] = ACTIONS(234),
    [anon_sym_RBRACE] = ACTIONS(234),
    [anon_sym_LT_LBRACE] = ACTIONS(234),
    [anon_sym_LBRACK] = ACTIONS(234),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_COMMA] = ACTIONS(234),
    [anon_sym_addrspace] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1041),
    [anon_sym_none] = ACTIONS(236),
    [anon_sym_unreachable] = ACTIONS(236),
    [anon_sym_ret] = ACTIONS(236),
    [anon_sym_br] = ACTIONS(236),
    [anon_sym_resume] = ACTIONS(236),
    [anon_sym_freeze] = ACTIONS(236),
    [anon_sym_indirectbr] = ACTIONS(236),
    [anon_sym_extractelement] = ACTIONS(236),
    [anon_sym_insertelement] = ACTIONS(236),
    [anon_sym_select] = ACTIONS(236),
    [anon_sym_shufflevector] = ACTIONS(236),
    [anon_sym_fneg] = ACTIONS(236),
    [anon_sym_switch] = ACTIONS(236),
    [anon_sym_invoke] = ACTIONS(236),
    [anon_sym_cleanupret] = ACTIONS(236),
    [anon_sym_catchret] = ACTIONS(236),
    [anon_sym_catchswitch] = ACTIONS(236),
    [anon_sym_catchpad] = ACTIONS(236),
    [anon_sym_cleanuppad] = ACTIONS(236),
    [anon_sym_callbr] = ACTIONS(236),
    [anon_sym_icmp] = ACTIONS(236),
    [anon_sym_fcmp] = ACTIONS(236),
    [anon_sym_va_arg] = ACTIONS(236),
    [anon_sym_phi] = ACTIONS(236),
    [anon_sym_landingpad] = ACTIONS(236),
    [anon_sym_tail] = ACTIONS(236),
    [anon_sym_musttail] = ACTIONS(236),
    [anon_sym_notail] = ACTIONS(236),
    [anon_sym_call] = ACTIONS(236),
    [anon_sym_alloca] = ACTIONS(236),
    [anon_sym_load] = ACTIONS(236),
    [anon_sym_store] = ACTIONS(236),
    [anon_sym_cmpxchg] = ACTIONS(236),
    [anon_sym_atomicrmw] = ACTIONS(236),
    [anon_sym_fence] = ACTIONS(236),
    [anon_sym_getelementptr] = ACTIONS(236),
    [anon_sym_extractvalue] = ACTIONS(236),
    [anon_sym_insertvalue] = ACTIONS(236),
    [anon_sym_true] = ACTIONS(236),
    [anon_sym_false] = ACTIONS(236),
    [anon_sym_null] = ACTIONS(236),
    [anon_sym_undef] = ACTIONS(236),
    [anon_sym_poison] = ACTIONS(236),
    [anon_sym_zeroinitializer] = ACTIONS(236),
    [anon_sym_catch] = ACTIONS(236),
    [anon_sym_filter] = ACTIONS(236),
    [anon_sym_blockaddress] = ACTIONS(236),
    [anon_sym_mul] = ACTIONS(236),
    [anon_sym_urem] = ACTIONS(236),
    [anon_sym_srem] = ACTIONS(236),
    [anon_sym_shl] = ACTIONS(236),
    [anon_sym_udiv] = ACTIONS(236),
    [anon_sym_sdiv] = ACTIONS(236),
    [anon_sym_lshr] = ACTIONS(236),
    [anon_sym_ashr] = ACTIONS(236),
    [anon_sym_fmul] = ACTIONS(236),
    [anon_sym_fdiv] = ACTIONS(236),
    [anon_sym_frem] = ACTIONS(236),
    [anon_sym_xchg] = ACTIONS(236),
    [anon_sym_add] = ACTIONS(236),
    [anon_sym_sub] = ACTIONS(236),
    [anon_sym_and] = ACTIONS(236),
    [anon_sym_nand] = ACTIONS(236),
    [anon_sym_or] = ACTIONS(236),
    [anon_sym_xor] = ACTIONS(236),
    [anon_sym_max] = ACTIONS(236),
    [anon_sym_min] = ACTIONS(236),
    [anon_sym_umax] = ACTIONS(236),
    [anon_sym_umin] = ACTIONS(236),
    [anon_sym_fadd] = ACTIONS(236),
    [anon_sym_fsub] = ACTIONS(236),
    [anon_sym_bitcast] = ACTIONS(236),
    [anon_sym_trunc] = ACTIONS(236),
    [anon_sym_zext] = ACTIONS(236),
    [anon_sym_sext] = ACTIONS(236),
    [anon_sym_fptrunc] = ACTIONS(236),
    [anon_sym_fpext] = ACTIONS(236),
    [anon_sym_addrspacecast] = ACTIONS(236),
    [anon_sym_uitofp] = ACTIONS(236),
    [anon_sym_sitofp] = ACTIONS(236),
    [anon_sym_fptoui] = ACTIONS(236),
    [anon_sym_fptosi] = ACTIONS(236),
    [anon_sym_inttoptr] = ACTIONS(236),
    [anon_sym_ptrtoint] = ACTIONS(236),
    [anon_sym_unordered] = ACTIONS(236),
    [anon_sym_monotonic] = ACTIONS(236),
    [anon_sym_acquire] = ACTIONS(236),
    [anon_sym_release] = ACTIONS(236),
    [anon_sym_acq_rel] = ACTIONS(236),
    [anon_sym_seq_cst] = ACTIONS(236),
    [anon_sym_syncscope] = ACTIONS(236),
    [anon_sym_uselistorder] = ACTIONS(236),
  },
  [286] = {
    [sym_addrspace] = STATE(1730),
    [sym_argument_list] = STATE(286),
    [aux_sym_type_repeat1] = STATE(1190),
    [aux_sym_type_repeat2] = STATE(286),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [sym_label] = ACTIONS(250),
    [sym_string] = ACTIONS(252),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(252),
    [anon_sym_private] = ACTIONS(252),
    [anon_sym_internal] = ACTIONS(252),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(252),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(252),
    [anon_sym_available_externally] = ACTIONS(252),
    [anon_sym_appending] = ACTIONS(252),
    [anon_sym_common] = ACTIONS(252),
    [anon_sym_extern_weak] = ACTIONS(252),
    [anon_sym_external] = ACTIONS(252),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(252),
    [anon_sym_dso_preemptable] = ACTIONS(252),
    [anon_sym_default] = ACTIONS(252),
    [anon_sym_hidden] = ACTIONS(252),
    [anon_sym_protected] = ACTIONS(252),
    [anon_sym_dllimport] = ACTIONS(252),
    [anon_sym_dllexport] = ACTIONS(252),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(257),
    [anon_sym_LPAREN] = ACTIONS(1046),
    [anon_sym_none] = ACTIONS(252),
    [anon_sym_unreachable] = ACTIONS(252),
    [anon_sym_ret] = ACTIONS(252),
    [anon_sym_br] = ACTIONS(252),
    [anon_sym_resume] = ACTIONS(252),
    [anon_sym_freeze] = ACTIONS(252),
    [anon_sym_indirectbr] = ACTIONS(252),
    [anon_sym_extractelement] = ACTIONS(252),
    [anon_sym_insertelement] = ACTIONS(252),
    [anon_sym_select] = ACTIONS(252),
    [anon_sym_shufflevector] = ACTIONS(252),
    [anon_sym_fneg] = ACTIONS(252),
    [anon_sym_switch] = ACTIONS(252),
    [anon_sym_invoke] = ACTIONS(252),
    [anon_sym_cleanupret] = ACTIONS(252),
    [anon_sym_catchret] = ACTIONS(252),
    [anon_sym_catchswitch] = ACTIONS(252),
    [anon_sym_catchpad] = ACTIONS(252),
    [anon_sym_cleanuppad] = ACTIONS(252),
    [anon_sym_callbr] = ACTIONS(252),
    [anon_sym_icmp] = ACTIONS(252),
    [anon_sym_fcmp] = ACTIONS(252),
    [anon_sym_va_arg] = ACTIONS(252),
    [anon_sym_phi] = ACTIONS(252),
    [anon_sym_landingpad] = ACTIONS(252),
    [anon_sym_tail] = ACTIONS(252),
    [anon_sym_musttail] = ACTIONS(252),
    [anon_sym_notail] = ACTIONS(252),
    [anon_sym_call] = ACTIONS(252),
    [anon_sym_alloca] = ACTIONS(252),
    [anon_sym_load] = ACTIONS(252),
    [anon_sym_store] = ACTIONS(252),
    [anon_sym_cmpxchg] = ACTIONS(252),
    [anon_sym_atomicrmw] = ACTIONS(252),
    [anon_sym_fence] = ACTIONS(252),
    [anon_sym_getelementptr] = ACTIONS(252),
    [anon_sym_extractvalue] = ACTIONS(252),
    [anon_sym_insertvalue] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(252),
    [anon_sym_false] = ACTIONS(252),
    [anon_sym_null] = ACTIONS(252),
    [anon_sym_undef] = ACTIONS(252),
    [anon_sym_poison] = ACTIONS(252),
    [anon_sym_zeroinitializer] = ACTIONS(252),
    [anon_sym_catch] = ACTIONS(252),
    [anon_sym_filter] = ACTIONS(252),
    [anon_sym_blockaddress] = ACTIONS(252),
    [anon_sym_mul] = ACTIONS(252),
    [anon_sym_urem] = ACTIONS(252),
    [anon_sym_srem] = ACTIONS(252),
    [anon_sym_shl] = ACTIONS(252),
    [anon_sym_udiv] = ACTIONS(252),
    [anon_sym_sdiv] = ACTIONS(252),
    [anon_sym_lshr] = ACTIONS(252),
    [anon_sym_ashr] = ACTIONS(252),
    [anon_sym_fmul] = ACTIONS(252),
    [anon_sym_fdiv] = ACTIONS(252),
    [anon_sym_frem] = ACTIONS(252),
    [anon_sym_xchg] = ACTIONS(252),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(252),
    [anon_sym_and] = ACTIONS(252),
    [anon_sym_nand] = ACTIONS(252),
    [anon_sym_or] = ACTIONS(252),
    [anon_sym_xor] = ACTIONS(252),
    [anon_sym_max] = ACTIONS(252),
    [anon_sym_min] = ACTIONS(252),
    [anon_sym_umax] = ACTIONS(252),
    [anon_sym_umin] = ACTIONS(252),
    [anon_sym_fadd] = ACTIONS(252),
    [anon_sym_fsub] = ACTIONS(252),
    [anon_sym_bitcast] = ACTIONS(252),
    [anon_sym_trunc] = ACTIONS(252),
    [anon_sym_zext] = ACTIONS(252),
    [anon_sym_sext] = ACTIONS(252),
    [anon_sym_fptrunc] = ACTIONS(252),
    [anon_sym_fpext] = ACTIONS(252),
    [anon_sym_addrspacecast] = ACTIONS(252),
    [anon_sym_uitofp] = ACTIONS(252),
    [anon_sym_sitofp] = ACTIONS(252),
    [anon_sym_fptoui] = ACTIONS(252),
    [anon_sym_fptosi] = ACTIONS(252),
    [anon_sym_inttoptr] = ACTIONS(252),
    [anon_sym_ptrtoint] = ACTIONS(252),
    [anon_sym_unordered] = ACTIONS(252),
    [anon_sym_monotonic] = ACTIONS(252),
    [anon_sym_acquire] = ACTIONS(252),
    [anon_sym_release] = ACTIONS(252),
    [anon_sym_acq_rel] = ACTIONS(252),
    [anon_sym_seq_cst] = ACTIONS(252),
    [anon_sym_syncscope] = ACTIONS(252),
    [anon_sym_uselistorder] = ACTIONS(252),
  },
  [287] = {
    [sym_addrspace] = STATE(364),
    [sym_argument_list] = STATE(286),
    [aux_sym_type_repeat1] = STATE(290),
    [aux_sym_type_repeat2] = STATE(286),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [sym_label] = ACTIONS(244),
    [sym_string] = ACTIONS(246),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(246),
    [sym_float] = ACTIONS(246),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(246),
    [anon_sym_private] = ACTIONS(246),
    [anon_sym_internal] = ACTIONS(246),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(246),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(246),
    [anon_sym_available_externally] = ACTIONS(246),
    [anon_sym_appending] = ACTIONS(246),
    [anon_sym_common] = ACTIONS(246),
    [anon_sym_extern_weak] = ACTIONS(246),
    [anon_sym_external] = ACTIONS(246),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(246),
    [anon_sym_dso_preemptable] = ACTIONS(246),
    [anon_sym_default] = ACTIONS(246),
    [anon_sym_hidden] = ACTIONS(246),
    [anon_sym_protected] = ACTIONS(246),
    [anon_sym_dllimport] = ACTIONS(246),
    [anon_sym_dllexport] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1041),
    [anon_sym_none] = ACTIONS(246),
    [anon_sym_unreachable] = ACTIONS(246),
    [anon_sym_ret] = ACTIONS(246),
    [anon_sym_br] = ACTIONS(246),
    [anon_sym_resume] = ACTIONS(246),
    [anon_sym_freeze] = ACTIONS(246),
    [anon_sym_indirectbr] = ACTIONS(246),
    [anon_sym_extractelement] = ACTIONS(246),
    [anon_sym_insertelement] = ACTIONS(246),
    [anon_sym_select] = ACTIONS(246),
    [anon_sym_shufflevector] = ACTIONS(246),
    [anon_sym_fneg] = ACTIONS(246),
    [anon_sym_switch] = ACTIONS(246),
    [anon_sym_invoke] = ACTIONS(246),
    [anon_sym_cleanupret] = ACTIONS(246),
    [anon_sym_catchret] = ACTIONS(246),
    [anon_sym_catchswitch] = ACTIONS(246),
    [anon_sym_catchpad] = ACTIONS(246),
    [anon_sym_cleanuppad] = ACTIONS(246),
    [anon_sym_callbr] = ACTIONS(246),
    [anon_sym_icmp] = ACTIONS(246),
    [anon_sym_fcmp] = ACTIONS(246),
    [anon_sym_va_arg] = ACTIONS(246),
    [anon_sym_phi] = ACTIONS(246),
    [anon_sym_landingpad] = ACTIONS(246),
    [anon_sym_tail] = ACTIONS(246),
    [anon_sym_musttail] = ACTIONS(246),
    [anon_sym_notail] = ACTIONS(246),
    [anon_sym_call] = ACTIONS(246),
    [anon_sym_alloca] = ACTIONS(246),
    [anon_sym_load] = ACTIONS(246),
    [anon_sym_store] = ACTIONS(246),
    [anon_sym_cmpxchg] = ACTIONS(246),
    [anon_sym_atomicrmw] = ACTIONS(246),
    [anon_sym_fence] = ACTIONS(246),
    [anon_sym_getelementptr] = ACTIONS(246),
    [anon_sym_extractvalue] = ACTIONS(246),
    [anon_sym_insertvalue] = ACTIONS(246),
    [anon_sym_true] = ACTIONS(246),
    [anon_sym_false] = ACTIONS(246),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_undef] = ACTIONS(246),
    [anon_sym_poison] = ACTIONS(246),
    [anon_sym_zeroinitializer] = ACTIONS(246),
    [anon_sym_catch] = ACTIONS(246),
    [anon_sym_filter] = ACTIONS(246),
    [anon_sym_blockaddress] = ACTIONS(246),
    [anon_sym_mul] = ACTIONS(246),
    [anon_sym_urem] = ACTIONS(246),
    [anon_sym_srem] = ACTIONS(246),
    [anon_sym_shl] = ACTIONS(246),
    [anon_sym_udiv] = ACTIONS(246),
    [anon_sym_sdiv] = ACTIONS(246),
    [anon_sym_lshr] = ACTIONS(246),
    [anon_sym_ashr] = ACTIONS(246),
    [anon_sym_fmul] = ACTIONS(246),
    [anon_sym_fdiv] = ACTIONS(246),
    [anon_sym_frem] = ACTIONS(246),
    [anon_sym_xchg] = ACTIONS(246),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(246),
    [anon_sym_and] = ACTIONS(246),
    [anon_sym_nand] = ACTIONS(246),
    [anon_sym_or] = ACTIONS(246),
    [anon_sym_xor] = ACTIONS(246),
    [anon_sym_max] = ACTIONS(246),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(246),
    [anon_sym_umin] = ACTIONS(246),
    [anon_sym_fadd] = ACTIONS(246),
    [anon_sym_fsub] = ACTIONS(246),
    [anon_sym_bitcast] = ACTIONS(246),
    [anon_sym_trunc] = ACTIONS(246),
    [anon_sym_zext] = ACTIONS(246),
    [anon_sym_sext] = ACTIONS(246),
    [anon_sym_fptrunc] = ACTIONS(246),
    [anon_sym_fpext] = ACTIONS(246),
    [anon_sym_addrspacecast] = ACTIONS(246),
    [anon_sym_uitofp] = ACTIONS(246),
    [anon_sym_sitofp] = ACTIONS(246),
    [anon_sym_fptoui] = ACTIONS(246),
    [anon_sym_fptosi] = ACTIONS(246),
    [anon_sym_inttoptr] = ACTIONS(246),
    [anon_sym_ptrtoint] = ACTIONS(246),
    [anon_sym_unordered] = ACTIONS(246),
    [anon_sym_monotonic] = ACTIONS(246),
    [anon_sym_acquire] = ACTIONS(246),
    [anon_sym_release] = ACTIONS(246),
    [anon_sym_acq_rel] = ACTIONS(246),
    [anon_sym_seq_cst] = ACTIONS(246),
    [anon_sym_syncscope] = ACTIONS(246),
    [anon_sym_uselistorder] = ACTIONS(246),
  },
  [288] = {
    [ts_builtin_sym_end] = ACTIONS(244),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(244),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [aux_sym_metadata_ref_token1] = ACTIONS(244),
    [sym_summary_ref] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_target] = ACTIONS(244),
    [anon_sym_source_filename] = ACTIONS(244),
    [anon_sym_declare] = ACTIONS(244),
    [anon_sym_define] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(244),
    [anon_sym_half] = ACTIONS(244),
    [anon_sym_bfloat] = ACTIONS(244),
    [anon_sym_float] = ACTIONS(244),
    [anon_sym_double] = ACTIONS(244),
    [anon_sym_x86_fp80] = ACTIONS(244),
    [anon_sym_fp128] = ACTIONS(244),
    [anon_sym_ppc_fp128] = ACTIONS(244),
    [anon_sym_label] = ACTIONS(244),
    [anon_sym_metadata] = ACTIONS(244),
    [anon_sym_x86_mmx] = ACTIONS(244),
    [anon_sym_x86_amx] = ACTIONS(244),
    [anon_sym_token] = ACTIONS(244),
    [anon_sym_opaque] = ACTIONS(244),
    [anon_sym_ptr] = ACTIONS(246),
    [aux_sym_type_keyword_token1] = ACTIONS(244),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_RBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_GT] = ACTIONS(244),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_RPAREN] = ACTIONS(244),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_to] = ACTIONS(246),
    [anon_sym_unwind] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_cleanup] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(244),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_catch] = ACTIONS(244),
    [anon_sym_filter] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(244),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
    [anon_sym_unordered] = ACTIONS(244),
    [anon_sym_monotonic] = ACTIONS(244),
    [anon_sym_acquire] = ACTIONS(244),
    [anon_sym_release] = ACTIONS(244),
    [anon_sym_acq_rel] = ACTIONS(244),
    [anon_sym_seq_cst] = ACTIONS(244),
    [anon_sym_syncscope] = ACTIONS(244),
    [anon_sym_uselistorder] = ACTIONS(246),
    [anon_sym_uselistorder_bb] = ACTIONS(244),
    [anon_sym_module] = ACTIONS(244),
    [anon_sym_asm] = ACTIONS(244),
    [anon_sym_attributes] = ACTIONS(244),
  },
  [289] = {
    [sym_addrspace] = STATE(364),
    [sym_argument_list] = STATE(306),
    [aux_sym_type_repeat1] = STATE(293),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [sym_label] = ACTIONS(244),
    [sym_string] = ACTIONS(246),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(246),
    [sym_float] = ACTIONS(246),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(246),
    [anon_sym_private] = ACTIONS(246),
    [anon_sym_internal] = ACTIONS(246),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(246),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(246),
    [anon_sym_available_externally] = ACTIONS(246),
    [anon_sym_appending] = ACTIONS(246),
    [anon_sym_common] = ACTIONS(246),
    [anon_sym_extern_weak] = ACTIONS(246),
    [anon_sym_external] = ACTIONS(246),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(246),
    [anon_sym_dso_preemptable] = ACTIONS(246),
    [anon_sym_default] = ACTIONS(246),
    [anon_sym_hidden] = ACTIONS(246),
    [anon_sym_protected] = ACTIONS(246),
    [anon_sym_dllimport] = ACTIONS(246),
    [anon_sym_dllexport] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1041),
    [anon_sym_none] = ACTIONS(246),
    [anon_sym_unreachable] = ACTIONS(246),
    [anon_sym_ret] = ACTIONS(246),
    [anon_sym_br] = ACTIONS(246),
    [anon_sym_resume] = ACTIONS(246),
    [anon_sym_freeze] = ACTIONS(246),
    [anon_sym_indirectbr] = ACTIONS(246),
    [anon_sym_extractelement] = ACTIONS(246),
    [anon_sym_insertelement] = ACTIONS(246),
    [anon_sym_select] = ACTIONS(246),
    [anon_sym_shufflevector] = ACTIONS(246),
    [anon_sym_fneg] = ACTIONS(246),
    [anon_sym_switch] = ACTIONS(246),
    [anon_sym_invoke] = ACTIONS(246),
    [anon_sym_cleanupret] = ACTIONS(246),
    [anon_sym_catchret] = ACTIONS(246),
    [anon_sym_catchswitch] = ACTIONS(246),
    [anon_sym_catchpad] = ACTIONS(246),
    [anon_sym_cleanuppad] = ACTIONS(246),
    [anon_sym_callbr] = ACTIONS(246),
    [anon_sym_icmp] = ACTIONS(246),
    [anon_sym_fcmp] = ACTIONS(246),
    [anon_sym_va_arg] = ACTIONS(246),
    [anon_sym_phi] = ACTIONS(246),
    [anon_sym_landingpad] = ACTIONS(246),
    [anon_sym_tail] = ACTIONS(246),
    [anon_sym_musttail] = ACTIONS(246),
    [anon_sym_notail] = ACTIONS(246),
    [anon_sym_call] = ACTIONS(246),
    [anon_sym_alloca] = ACTIONS(246),
    [anon_sym_load] = ACTIONS(246),
    [anon_sym_store] = ACTIONS(246),
    [anon_sym_cmpxchg] = ACTIONS(246),
    [anon_sym_atomicrmw] = ACTIONS(246),
    [anon_sym_fence] = ACTIONS(246),
    [anon_sym_getelementptr] = ACTIONS(246),
    [anon_sym_extractvalue] = ACTIONS(246),
    [anon_sym_insertvalue] = ACTIONS(246),
    [anon_sym_true] = ACTIONS(246),
    [anon_sym_false] = ACTIONS(246),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_undef] = ACTIONS(246),
    [anon_sym_poison] = ACTIONS(246),
    [anon_sym_zeroinitializer] = ACTIONS(246),
    [anon_sym_catch] = ACTIONS(246),
    [anon_sym_filter] = ACTIONS(246),
    [anon_sym_blockaddress] = ACTIONS(246),
    [anon_sym_mul] = ACTIONS(246),
    [anon_sym_urem] = ACTIONS(246),
    [anon_sym_srem] = ACTIONS(246),
    [anon_sym_shl] = ACTIONS(246),
    [anon_sym_udiv] = ACTIONS(246),
    [anon_sym_sdiv] = ACTIONS(246),
    [anon_sym_lshr] = ACTIONS(246),
    [anon_sym_ashr] = ACTIONS(246),
    [anon_sym_fmul] = ACTIONS(246),
    [anon_sym_fdiv] = ACTIONS(246),
    [anon_sym_frem] = ACTIONS(246),
    [anon_sym_xchg] = ACTIONS(246),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(246),
    [anon_sym_and] = ACTIONS(246),
    [anon_sym_nand] = ACTIONS(246),
    [anon_sym_or] = ACTIONS(246),
    [anon_sym_xor] = ACTIONS(246),
    [anon_sym_max] = ACTIONS(246),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(246),
    [anon_sym_umin] = ACTIONS(246),
    [anon_sym_fadd] = ACTIONS(246),
    [anon_sym_fsub] = ACTIONS(246),
    [anon_sym_bitcast] = ACTIONS(246),
    [anon_sym_trunc] = ACTIONS(246),
    [anon_sym_zext] = ACTIONS(246),
    [anon_sym_sext] = ACTIONS(246),
    [anon_sym_fptrunc] = ACTIONS(246),
    [anon_sym_fpext] = ACTIONS(246),
    [anon_sym_addrspacecast] = ACTIONS(246),
    [anon_sym_uitofp] = ACTIONS(246),
    [anon_sym_sitofp] = ACTIONS(246),
    [anon_sym_fptoui] = ACTIONS(246),
    [anon_sym_fptosi] = ACTIONS(246),
    [anon_sym_inttoptr] = ACTIONS(246),
    [anon_sym_ptrtoint] = ACTIONS(246),
    [anon_sym_unordered] = ACTIONS(246),
    [anon_sym_monotonic] = ACTIONS(246),
    [anon_sym_acquire] = ACTIONS(246),
    [anon_sym_release] = ACTIONS(246),
    [anon_sym_acq_rel] = ACTIONS(246),
    [anon_sym_seq_cst] = ACTIONS(246),
    [anon_sym_syncscope] = ACTIONS(246),
    [anon_sym_uselistorder] = ACTIONS(246),
  },
  [290] = {
    [sym_addrspace] = STATE(365),
    [sym_argument_list] = STATE(306),
    [aux_sym_type_repeat1] = STATE(293),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [sym_label] = ACTIONS(263),
    [sym_string] = ACTIONS(265),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(265),
    [sym_float] = ACTIONS(265),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(265),
    [anon_sym_private] = ACTIONS(265),
    [anon_sym_internal] = ACTIONS(265),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(265),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(265),
    [anon_sym_available_externally] = ACTIONS(265),
    [anon_sym_appending] = ACTIONS(265),
    [anon_sym_common] = ACTIONS(265),
    [anon_sym_extern_weak] = ACTIONS(265),
    [anon_sym_external] = ACTIONS(265),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(265),
    [anon_sym_dso_preemptable] = ACTIONS(265),
    [anon_sym_default] = ACTIONS(265),
    [anon_sym_hidden] = ACTIONS(265),
    [anon_sym_protected] = ACTIONS(265),
    [anon_sym_dllimport] = ACTIONS(265),
    [anon_sym_dllexport] = ACTIONS(265),
    [anon_sym_STAR] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_addrspace] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1041),
    [anon_sym_none] = ACTIONS(265),
    [anon_sym_unreachable] = ACTIONS(265),
    [anon_sym_ret] = ACTIONS(265),
    [anon_sym_br] = ACTIONS(265),
    [anon_sym_resume] = ACTIONS(265),
    [anon_sym_freeze] = ACTIONS(265),
    [anon_sym_indirectbr] = ACTIONS(265),
    [anon_sym_extractelement] = ACTIONS(265),
    [anon_sym_insertelement] = ACTIONS(265),
    [anon_sym_select] = ACTIONS(265),
    [anon_sym_shufflevector] = ACTIONS(265),
    [anon_sym_fneg] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(265),
    [anon_sym_invoke] = ACTIONS(265),
    [anon_sym_cleanupret] = ACTIONS(265),
    [anon_sym_catchret] = ACTIONS(265),
    [anon_sym_catchswitch] = ACTIONS(265),
    [anon_sym_catchpad] = ACTIONS(265),
    [anon_sym_cleanuppad] = ACTIONS(265),
    [anon_sym_callbr] = ACTIONS(265),
    [anon_sym_icmp] = ACTIONS(265),
    [anon_sym_fcmp] = ACTIONS(265),
    [anon_sym_va_arg] = ACTIONS(265),
    [anon_sym_phi] = ACTIONS(265),
    [anon_sym_landingpad] = ACTIONS(265),
    [anon_sym_tail] = ACTIONS(265),
    [anon_sym_musttail] = ACTIONS(265),
    [anon_sym_notail] = ACTIONS(265),
    [anon_sym_call] = ACTIONS(265),
    [anon_sym_alloca] = ACTIONS(265),
    [anon_sym_load] = ACTIONS(265),
    [anon_sym_store] = ACTIONS(265),
    [anon_sym_cmpxchg] = ACTIONS(265),
    [anon_sym_atomicrmw] = ACTIONS(265),
    [anon_sym_fence] = ACTIONS(265),
    [anon_sym_getelementptr] = ACTIONS(265),
    [anon_sym_extractvalue] = ACTIONS(265),
    [anon_sym_insertvalue] = ACTIONS(265),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [anon_sym_null] = ACTIONS(265),
    [anon_sym_undef] = ACTIONS(265),
    [anon_sym_poison] = ACTIONS(265),
    [anon_sym_zeroinitializer] = ACTIONS(265),
    [anon_sym_catch] = ACTIONS(265),
    [anon_sym_filter] = ACTIONS(265),
    [anon_sym_blockaddress] = ACTIONS(265),
    [anon_sym_mul] = ACTIONS(265),
    [anon_sym_urem] = ACTIONS(265),
    [anon_sym_srem] = ACTIONS(265),
    [anon_sym_shl] = ACTIONS(265),
    [anon_sym_udiv] = ACTIONS(265),
    [anon_sym_sdiv] = ACTIONS(265),
    [anon_sym_lshr] = ACTIONS(265),
    [anon_sym_ashr] = ACTIONS(265),
    [anon_sym_fmul] = ACTIONS(265),
    [anon_sym_fdiv] = ACTIONS(265),
    [anon_sym_frem] = ACTIONS(265),
    [anon_sym_xchg] = ACTIONS(265),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(265),
    [anon_sym_and] = ACTIONS(265),
    [anon_sym_nand] = ACTIONS(265),
    [anon_sym_or] = ACTIONS(265),
    [anon_sym_xor] = ACTIONS(265),
    [anon_sym_max] = ACTIONS(265),
    [anon_sym_min] = ACTIONS(265),
    [anon_sym_umax] = ACTIONS(265),
    [anon_sym_umin] = ACTIONS(265),
    [anon_sym_fadd] = ACTIONS(265),
    [anon_sym_fsub] = ACTIONS(265),
    [anon_sym_bitcast] = ACTIONS(265),
    [anon_sym_trunc] = ACTIONS(265),
    [anon_sym_zext] = ACTIONS(265),
    [anon_sym_sext] = ACTIONS(265),
    [anon_sym_fptrunc] = ACTIONS(265),
    [anon_sym_fpext] = ACTIONS(265),
    [anon_sym_addrspacecast] = ACTIONS(265),
    [anon_sym_uitofp] = ACTIONS(265),
    [anon_sym_sitofp] = ACTIONS(265),
    [anon_sym_fptoui] = ACTIONS(265),
    [anon_sym_fptosi] = ACTIONS(265),
    [anon_sym_inttoptr] = ACTIONS(265),
    [anon_sym_ptrtoint] = ACTIONS(265),
    [anon_sym_unordered] = ACTIONS(265),
    [anon_sym_monotonic] = ACTIONS(265),
    [anon_sym_acquire] = ACTIONS(265),
    [anon_sym_release] = ACTIONS(265),
    [anon_sym_acq_rel] = ACTIONS(265),
    [anon_sym_seq_cst] = ACTIONS(265),
    [anon_sym_syncscope] = ACTIONS(265),
    [anon_sym_uselistorder] = ACTIONS(265),
  },
  [291] = {
    [sym_metadata_ref] = STATE(100),
    [sym_type] = STATE(292),
    [sym_type_keyword] = STATE(260),
    [sym_struct_type] = STATE(260),
    [sym_packed_struct_type] = STATE(260),
    [sym_array_type] = STATE(260),
    [sym_vector_type] = STATE(260),
    [sym_type_and_value] = STATE(134),
    [sym_metadata] = STATE(126),
    [sym_metadata_tuple] = STATE(134),
    [sym_specialized_md] = STATE(134),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(436),
    [aux_sym_metadata_ref_token1] = ACTIONS(13),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(440),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(442),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_RBRACE] = ACTIONS(116),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_RBRACK] = ACTIONS(116),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_GT] = ACTIONS(116),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_RPAREN] = ACTIONS(116),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_to] = ACTIONS(122),
    [anon_sym_unwind] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(1053),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(116),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_unordered] = ACTIONS(116),
    [anon_sym_monotonic] = ACTIONS(116),
    [anon_sym_acquire] = ACTIONS(116),
    [anon_sym_release] = ACTIONS(116),
    [anon_sym_acq_rel] = ACTIONS(116),
    [anon_sym_seq_cst] = ACTIONS(116),
    [anon_sym_syncscope] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(232),
  },
  [292] = {
    [sym_number] = STATE(92),
    [sym_var] = STATE(92),
    [sym_linkage] = STATE(817),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(136),
    [sym__primitive_value] = STATE(92),
    [sym_struct_value] = STATE(92),
    [sym_packed_struct_value] = STATE(92),
    [sym_array_value] = STATE(92),
    [sym_vector_value] = STATE(92),
    [sym_blockaddress] = STATE(92),
    [sym_constant_expr] = STATE(92),
    [sym_constant_cast] = STATE(87),
    [sym_constant_getelementptr] = STATE(87),
    [sym_constant_select] = STATE(87),
    [sym_constant_icmp] = STATE(87),
    [sym_constant_fcmp] = STATE(87),
    [sym_constant_extractelement] = STATE(87),
    [sym_constant_insertelement] = STATE(87),
    [sym_constant_shufflevector] = STATE(87),
    [sym_constant_extractvalue] = STATE(87),
    [sym_constant_insertvalue] = STATE(87),
    [sym_constant_fneg] = STATE(87),
    [sym_constant_bin_op] = STATE(87),
    [sym_bin_op_keyword] = STATE(1122),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1597),
    [aux_sym_function_header_repeat1] = STATE(817),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_RBRACE] = ACTIONS(38),
    [anon_sym_LT_LBRACE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_RBRACK] = ACTIONS(38),
    [anon_sym_LT] = ACTIONS(470),
    [anon_sym_GT] = ACTIONS(38),
    [anon_sym_COMMA] = ACTIONS(38),
    [anon_sym_RPAREN] = ACTIONS(38),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_to] = ACTIONS(38),
    [anon_sym_unwind] = ACTIONS(38),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
    [anon_sym_unordered] = ACTIONS(38),
    [anon_sym_monotonic] = ACTIONS(38),
    [anon_sym_acquire] = ACTIONS(38),
    [anon_sym_release] = ACTIONS(38),
    [anon_sym_acq_rel] = ACTIONS(38),
    [anon_sym_seq_cst] = ACTIONS(38),
    [anon_sym_syncscope] = ACTIONS(38),
  },
  [293] = {
    [sym_addrspace] = STATE(1671),
    [aux_sym_type_repeat1] = STATE(293),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [sym_label] = ACTIONS(269),
    [sym_string] = ACTIONS(271),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(271),
    [sym_float] = ACTIONS(271),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(271),
    [anon_sym_private] = ACTIONS(271),
    [anon_sym_internal] = ACTIONS(271),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(271),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(271),
    [anon_sym_available_externally] = ACTIONS(271),
    [anon_sym_appending] = ACTIONS(271),
    [anon_sym_common] = ACTIONS(271),
    [anon_sym_extern_weak] = ACTIONS(271),
    [anon_sym_external] = ACTIONS(271),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(271),
    [anon_sym_dso_preemptable] = ACTIONS(271),
    [anon_sym_default] = ACTIONS(271),
    [anon_sym_hidden] = ACTIONS(271),
    [anon_sym_protected] = ACTIONS(271),
    [anon_sym_dllimport] = ACTIONS(271),
    [anon_sym_dllexport] = ACTIONS(271),
    [anon_sym_STAR] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_none] = ACTIONS(271),
    [anon_sym_unreachable] = ACTIONS(271),
    [anon_sym_ret] = ACTIONS(271),
    [anon_sym_br] = ACTIONS(271),
    [anon_sym_resume] = ACTIONS(271),
    [anon_sym_freeze] = ACTIONS(271),
    [anon_sym_indirectbr] = ACTIONS(271),
    [anon_sym_extractelement] = ACTIONS(271),
    [anon_sym_insertelement] = ACTIONS(271),
    [anon_sym_select] = ACTIONS(271),
    [anon_sym_shufflevector] = ACTIONS(271),
    [anon_sym_fneg] = ACTIONS(271),
    [anon_sym_switch] = ACTIONS(271),
    [anon_sym_invoke] = ACTIONS(271),
    [anon_sym_cleanupret] = ACTIONS(271),
    [anon_sym_catchret] = ACTIONS(271),
    [anon_sym_catchswitch] = ACTIONS(271),
    [anon_sym_catchpad] = ACTIONS(271),
    [anon_sym_cleanuppad] = ACTIONS(271),
    [anon_sym_callbr] = ACTIONS(271),
    [anon_sym_icmp] = ACTIONS(271),
    [anon_sym_fcmp] = ACTIONS(271),
    [anon_sym_va_arg] = ACTIONS(271),
    [anon_sym_phi] = ACTIONS(271),
    [anon_sym_landingpad] = ACTIONS(271),
    [anon_sym_tail] = ACTIONS(271),
    [anon_sym_musttail] = ACTIONS(271),
    [anon_sym_notail] = ACTIONS(271),
    [anon_sym_call] = ACTIONS(271),
    [anon_sym_alloca] = ACTIONS(271),
    [anon_sym_load] = ACTIONS(271),
    [anon_sym_store] = ACTIONS(271),
    [anon_sym_cmpxchg] = ACTIONS(271),
    [anon_sym_atomicrmw] = ACTIONS(271),
    [anon_sym_fence] = ACTIONS(271),
    [anon_sym_getelementptr] = ACTIONS(271),
    [anon_sym_extractvalue] = ACTIONS(271),
    [anon_sym_insertvalue] = ACTIONS(271),
    [anon_sym_true] = ACTIONS(271),
    [anon_sym_false] = ACTIONS(271),
    [anon_sym_null] = ACTIONS(271),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_poison] = ACTIONS(271),
    [anon_sym_zeroinitializer] = ACTIONS(271),
    [anon_sym_catch] = ACTIONS(271),
    [anon_sym_filter] = ACTIONS(271),
    [anon_sym_blockaddress] = ACTIONS(271),
    [anon_sym_mul] = ACTIONS(271),
    [anon_sym_urem] = ACTIONS(271),
    [anon_sym_srem] = ACTIONS(271),
    [anon_sym_shl] = ACTIONS(271),
    [anon_sym_udiv] = ACTIONS(271),
    [anon_sym_sdiv] = ACTIONS(271),
    [anon_sym_lshr] = ACTIONS(271),
    [anon_sym_ashr] = ACTIONS(271),
    [anon_sym_fmul] = ACTIONS(271),
    [anon_sym_fdiv] = ACTIONS(271),
    [anon_sym_frem] = ACTIONS(271),
    [anon_sym_xchg] = ACTIONS(271),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(271),
    [anon_sym_nand] = ACTIONS(271),
    [anon_sym_or] = ACTIONS(271),
    [anon_sym_xor] = ACTIONS(271),
    [anon_sym_max] = ACTIONS(271),
    [anon_sym_min] = ACTIONS(271),
    [anon_sym_umax] = ACTIONS(271),
    [anon_sym_umin] = ACTIONS(271),
    [anon_sym_fadd] = ACTIONS(271),
    [anon_sym_fsub] = ACTIONS(271),
    [anon_sym_bitcast] = ACTIONS(271),
    [anon_sym_trunc] = ACTIONS(271),
    [anon_sym_zext] = ACTIONS(271),
    [anon_sym_sext] = ACTIONS(271),
    [anon_sym_fptrunc] = ACTIONS(271),
    [anon_sym_fpext] = ACTIONS(271),
    [anon_sym_addrspacecast] = ACTIONS(271),
    [anon_sym_uitofp] = ACTIONS(271),
    [anon_sym_sitofp] = ACTIONS(271),
    [anon_sym_fptoui] = ACTIONS(271),
    [anon_sym_fptosi] = ACTIONS(271),
    [anon_sym_inttoptr] = ACTIONS(271),
    [anon_sym_ptrtoint] = ACTIONS(271),
    [anon_sym_unordered] = ACTIONS(271),
    [anon_sym_monotonic] = ACTIONS(271),
    [anon_sym_acquire] = ACTIONS(271),
    [anon_sym_release] = ACTIONS(271),
    [anon_sym_acq_rel] = ACTIONS(271),
    [anon_sym_seq_cst] = ACTIONS(271),
    [anon_sym_syncscope] = ACTIONS(271),
    [anon_sym_uselistorder] = ACTIONS(271),
  },
  [294] = {
    [ts_builtin_sym_end] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(391),
    [sym_global_var] = ACTIONS(391),
    [sym_local_var] = ACTIONS(391),
    [aux_sym_metadata_ref_token1] = ACTIONS(391),
    [sym_summary_ref] = ACTIONS(391),
    [sym_string] = ACTIONS(391),
    [aux_sym_number_token1] = ACTIONS(393),
    [aux_sym_number_token2] = ACTIONS(391),
    [sym_float] = ACTIONS(391),
    [sym_cstring] = ACTIONS(391),
    [anon_sym_target] = ACTIONS(391),
    [anon_sym_source_filename] = ACTIONS(391),
    [anon_sym_declare] = ACTIONS(391),
    [anon_sym_define] = ACTIONS(391),
    [anon_sym_no_cfi] = ACTIONS(391),
    [anon_sym_private] = ACTIONS(391),
    [anon_sym_internal] = ACTIONS(391),
    [anon_sym_weak] = ACTIONS(393),
    [anon_sym_weak_odr] = ACTIONS(391),
    [anon_sym_linkonce] = ACTIONS(393),
    [anon_sym_linkonce_odr] = ACTIONS(391),
    [anon_sym_available_externally] = ACTIONS(391),
    [anon_sym_appending] = ACTIONS(391),
    [anon_sym_common] = ACTIONS(391),
    [anon_sym_extern_weak] = ACTIONS(391),
    [anon_sym_external] = ACTIONS(391),
    [anon_sym_dso_local] = ACTIONS(393),
    [anon_sym_dso_local_equivalent] = ACTIONS(391),
    [anon_sym_dso_preemptable] = ACTIONS(391),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_hidden] = ACTIONS(391),
    [anon_sym_protected] = ACTIONS(391),
    [anon_sym_dllimport] = ACTIONS(391),
    [anon_sym_dllexport] = ACTIONS(391),
    [anon_sym_STAR] = ACTIONS(391),
    [anon_sym_void] = ACTIONS(391),
    [anon_sym_half] = ACTIONS(391),
    [anon_sym_bfloat] = ACTIONS(391),
    [anon_sym_float] = ACTIONS(391),
    [anon_sym_double] = ACTIONS(391),
    [anon_sym_x86_fp80] = ACTIONS(391),
    [anon_sym_fp128] = ACTIONS(391),
    [anon_sym_ppc_fp128] = ACTIONS(391),
    [anon_sym_label] = ACTIONS(391),
    [anon_sym_metadata] = ACTIONS(391),
    [anon_sym_x86_mmx] = ACTIONS(391),
    [anon_sym_x86_amx] = ACTIONS(391),
    [anon_sym_token] = ACTIONS(391),
    [anon_sym_opaque] = ACTIONS(391),
    [anon_sym_ptr] = ACTIONS(393),
    [aux_sym_type_keyword_token1] = ACTIONS(391),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_RBRACE] = ACTIONS(391),
    [anon_sym_LT_LBRACE] = ACTIONS(391),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_RBRACK] = ACTIONS(391),
    [anon_sym_LT] = ACTIONS(393),
    [anon_sym_GT] = ACTIONS(391),
    [anon_sym_COMMA] = ACTIONS(391),
    [anon_sym_RPAREN] = ACTIONS(391),
    [anon_sym_none] = ACTIONS(391),
    [anon_sym_extractelement] = ACTIONS(391),
    [anon_sym_insertelement] = ACTIONS(391),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_shufflevector] = ACTIONS(391),
    [anon_sym_fneg] = ACTIONS(391),
    [anon_sym_to] = ACTIONS(393),
    [anon_sym_unwind] = ACTIONS(391),
    [anon_sym_icmp] = ACTIONS(391),
    [anon_sym_fcmp] = ACTIONS(391),
    [anon_sym_getelementptr] = ACTIONS(391),
    [anon_sym_extractvalue] = ACTIONS(391),
    [anon_sym_insertvalue] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(391),
    [anon_sym_false] = ACTIONS(391),
    [anon_sym_null] = ACTIONS(391),
    [anon_sym_undef] = ACTIONS(391),
    [anon_sym_poison] = ACTIONS(391),
    [anon_sym_zeroinitializer] = ACTIONS(391),
    [anon_sym_blockaddress] = ACTIONS(391),
    [anon_sym_mul] = ACTIONS(391),
    [anon_sym_urem] = ACTIONS(391),
    [anon_sym_srem] = ACTIONS(391),
    [anon_sym_shl] = ACTIONS(391),
    [anon_sym_udiv] = ACTIONS(391),
    [anon_sym_sdiv] = ACTIONS(391),
    [anon_sym_lshr] = ACTIONS(391),
    [anon_sym_ashr] = ACTIONS(391),
    [anon_sym_fmul] = ACTIONS(391),
    [anon_sym_fdiv] = ACTIONS(391),
    [anon_sym_frem] = ACTIONS(391),
    [anon_sym_xchg] = ACTIONS(391),
    [anon_sym_add] = ACTIONS(393),
    [anon_sym_sub] = ACTIONS(391),
    [anon_sym_and] = ACTIONS(391),
    [anon_sym_nand] = ACTIONS(391),
    [anon_sym_or] = ACTIONS(391),
    [anon_sym_xor] = ACTIONS(391),
    [anon_sym_max] = ACTIONS(391),
    [anon_sym_min] = ACTIONS(391),
    [anon_sym_umax] = ACTIONS(391),
    [anon_sym_umin] = ACTIONS(391),
    [anon_sym_fadd] = ACTIONS(391),
    [anon_sym_fsub] = ACTIONS(391),
    [anon_sym_bitcast] = ACTIONS(391),
    [anon_sym_trunc] = ACTIONS(391),
    [anon_sym_zext] = ACTIONS(391),
    [anon_sym_sext] = ACTIONS(391),
    [anon_sym_fptrunc] = ACTIONS(391),
    [anon_sym_fpext] = ACTIONS(391),
    [anon_sym_addrspacecast] = ACTIONS(391),
    [anon_sym_uitofp] = ACTIONS(391),
    [anon_sym_sitofp] = ACTIONS(391),
    [anon_sym_fptoui] = ACTIONS(391),
    [anon_sym_fptosi] = ACTIONS(391),
    [anon_sym_inttoptr] = ACTIONS(391),
    [anon_sym_ptrtoint] = ACTIONS(391),
    [anon_sym_unordered] = ACTIONS(391),
    [anon_sym_monotonic] = ACTIONS(391),
    [anon_sym_acquire] = ACTIONS(391),
    [anon_sym_release] = ACTIONS(391),
    [anon_sym_acq_rel] = ACTIONS(391),
    [anon_sym_seq_cst] = ACTIONS(391),
    [anon_sym_syncscope] = ACTIONS(391),
    [anon_sym_uselistorder] = ACTIONS(393),
    [anon_sym_uselistorder_bb] = ACTIONS(391),
    [anon_sym_module] = ACTIONS(391),
    [anon_sym_asm] = ACTIONS(391),
    [anon_sym_attributes] = ACTIONS(391),
  },
  [295] = {
    [sym_metadata_ref] = STATE(100),
    [sym_type] = STATE(296),
    [sym_type_keyword] = STATE(260),
    [sym_struct_type] = STATE(260),
    [sym_packed_struct_type] = STATE(260),
    [sym_array_type] = STATE(260),
    [sym_vector_type] = STATE(260),
    [sym_type_and_value] = STATE(134),
    [sym_metadata] = STATE(126),
    [sym_metadata_tuple] = STATE(134),
    [sym_specialized_md] = STATE(134),
    [ts_builtin_sym_end] = ACTIONS(116),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(116),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(436),
    [aux_sym_metadata_ref_token1] = ACTIONS(13),
    [sym_summary_ref] = ACTIONS(116),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_target] = ACTIONS(116),
    [anon_sym_source_filename] = ACTIONS(116),
    [anon_sym_declare] = ACTIONS(116),
    [anon_sym_define] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(1058),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(442),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(1053),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(116),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_uselistorder] = ACTIONS(122),
    [anon_sym_uselistorder_bb] = ACTIONS(116),
    [anon_sym_module] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(232),
    [anon_sym_attributes] = ACTIONS(116),
  },
  [296] = {
    [sym_number] = STATE(92),
    [sym_var] = STATE(92),
    [sym_linkage] = STATE(817),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(136),
    [sym__primitive_value] = STATE(92),
    [sym_struct_value] = STATE(92),
    [sym_packed_struct_value] = STATE(92),
    [sym_array_value] = STATE(92),
    [sym_vector_value] = STATE(92),
    [sym_blockaddress] = STATE(92),
    [sym_constant_expr] = STATE(92),
    [sym_constant_cast] = STATE(87),
    [sym_constant_getelementptr] = STATE(87),
    [sym_constant_select] = STATE(87),
    [sym_constant_icmp] = STATE(87),
    [sym_constant_fcmp] = STATE(87),
    [sym_constant_extractelement] = STATE(87),
    [sym_constant_insertelement] = STATE(87),
    [sym_constant_shufflevector] = STATE(87),
    [sym_constant_extractvalue] = STATE(87),
    [sym_constant_insertvalue] = STATE(87),
    [sym_constant_fneg] = STATE(87),
    [sym_constant_bin_op] = STATE(87),
    [sym_bin_op_keyword] = STATE(1122),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1597),
    [aux_sym_function_header_repeat1] = STATE(817),
    [ts_builtin_sym_end] = ACTIONS(38),
    [sym_comment] = ACTIONS(3),
    [sym_comdat_ref] = ACTIONS(38),
    [sym_global_var] = ACTIONS(35),
    [sym_local_var] = ACTIONS(35),
    [aux_sym_metadata_ref_token1] = ACTIONS(38),
    [sym_summary_ref] = ACTIONS(38),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_target] = ACTIONS(38),
    [anon_sym_source_filename] = ACTIONS(38),
    [anon_sym_declare] = ACTIONS(38),
    [anon_sym_define] = ACTIONS(38),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_LT_LBRACE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_LT] = ACTIONS(470),
    [anon_sym_COMMA] = ACTIONS(38),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
    [anon_sym_uselistorder] = ACTIONS(70),
    [anon_sym_uselistorder_bb] = ACTIONS(38),
    [anon_sym_module] = ACTIONS(38),
    [anon_sym_attributes] = ACTIONS(38),
  },
  [297] = {
    [ts_builtin_sym_end] = ACTIONS(1060),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1060),
    [sym_comdat_ref] = ACTIONS(1060),
    [sym_global_var] = ACTIONS(1060),
    [sym_local_var] = ACTIONS(1060),
    [aux_sym_metadata_ref_token1] = ACTIONS(1060),
    [sym_summary_ref] = ACTIONS(1060),
    [sym_string] = ACTIONS(1060),
    [anon_sym_target] = ACTIONS(1060),
    [anon_sym_source_filename] = ACTIONS(1060),
    [anon_sym_declare] = ACTIONS(1060),
    [anon_sym_define] = ACTIONS(1060),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_half] = ACTIONS(1060),
    [anon_sym_bfloat] = ACTIONS(1060),
    [anon_sym_float] = ACTIONS(1060),
    [anon_sym_double] = ACTIONS(1060),
    [anon_sym_x86_fp80] = ACTIONS(1060),
    [anon_sym_fp128] = ACTIONS(1060),
    [anon_sym_ppc_fp128] = ACTIONS(1060),
    [anon_sym_label] = ACTIONS(1060),
    [anon_sym_metadata] = ACTIONS(1060),
    [anon_sym_x86_mmx] = ACTIONS(1060),
    [anon_sym_x86_amx] = ACTIONS(1060),
    [anon_sym_token] = ACTIONS(1060),
    [anon_sym_opaque] = ACTIONS(1060),
    [anon_sym_ptr] = ACTIONS(1060),
    [aux_sym_type_keyword_token1] = ACTIONS(1060),
    [anon_sym_LBRACE] = ACTIONS(1060),
    [anon_sym_LT_LBRACE] = ACTIONS(1060),
    [anon_sym_LBRACK] = ACTIONS(1060),
    [anon_sym_LT] = ACTIONS(1062),
    [anon_sym_addrspace] = ACTIONS(1060),
    [anon_sym_align] = ACTIONS(1062),
    [anon_sym_section] = ACTIONS(1060),
    [anon_sym_partition] = ACTIONS(1060),
    [anon_sym_comdat] = ACTIONS(1060),
    [anon_sym_gc] = ACTIONS(1060),
    [anon_sym_prefix] = ACTIONS(1060),
    [anon_sym_prologue] = ACTIONS(1060),
    [anon_sym_personality] = ACTIONS(1060),
    [anon_sym_alignstack] = ACTIONS(1060),
    [anon_sym_allocsize] = ACTIONS(1060),
    [anon_sym_alwaysinline] = ACTIONS(1060),
    [anon_sym_builtin] = ACTIONS(1060),
    [anon_sym_cold] = ACTIONS(1060),
    [anon_sym_convergent] = ACTIONS(1060),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1060),
    [anon_sym_hot] = ACTIONS(1060),
    [anon_sym_inaccessiblememonly] = ACTIONS(1060),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1060),
    [anon_sym_inlinehint] = ACTIONS(1060),
    [anon_sym_jumptable] = ACTIONS(1060),
    [anon_sym_minsize] = ACTIONS(1060),
    [anon_sym_naked] = ACTIONS(1060),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1060),
    [anon_sym_nobuiltin] = ACTIONS(1060),
    [anon_sym_noduplicate] = ACTIONS(1060),
    [anon_sym_nofree] = ACTIONS(1060),
    [anon_sym_noimplicitfloat] = ACTIONS(1060),
    [anon_sym_noinline] = ACTIONS(1060),
    [anon_sym_nomerge] = ACTIONS(1060),
    [anon_sym_nonlazybind] = ACTIONS(1060),
    [anon_sym_noprofile] = ACTIONS(1060),
    [anon_sym_noredzone] = ACTIONS(1060),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1060),
    [anon_sym_noreturn] = ACTIONS(1060),
    [anon_sym_norecurse] = ACTIONS(1060),
    [anon_sym_willreturn] = ACTIONS(1060),
    [anon_sym_nosync] = ACTIONS(1060),
    [anon_sym_nounwind] = ACTIONS(1060),
    [anon_sym_nocallback] = ACTIONS(1060),
    [anon_sym_nosanitize_coverage] = ACTIONS(1060),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1060),
    [anon_sym_optforfuzzing] = ACTIONS(1060),
    [anon_sym_optnone] = ACTIONS(1060),
    [anon_sym_optsize] = ACTIONS(1060),
    [anon_sym_readnone] = ACTIONS(1060),
    [anon_sym_readonly] = ACTIONS(1060),
    [anon_sym_writeonly] = ACTIONS(1060),
    [anon_sym_argmemonly] = ACTIONS(1060),
    [anon_sym_returns_twice] = ACTIONS(1060),
    [anon_sym_safestack] = ACTIONS(1060),
    [anon_sym_sanitize_address] = ACTIONS(1060),
    [anon_sym_sanitize_memory] = ACTIONS(1060),
    [anon_sym_sanitize_thread] = ACTIONS(1060),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1060),
    [anon_sym_sanitize_memtag] = ACTIONS(1060),
    [anon_sym_speculative_load_hardening] = ACTIONS(1060),
    [anon_sym_speculatable] = ACTIONS(1060),
    [anon_sym_ssp] = ACTIONS(1062),
    [anon_sym_sspstrong] = ACTIONS(1060),
    [anon_sym_sspreq] = ACTIONS(1060),
    [anon_sym_strictfp] = ACTIONS(1060),
    [anon_sym_nocf_check] = ACTIONS(1060),
    [anon_sym_shadowcallstack] = ACTIONS(1060),
    [anon_sym_mustprogress] = ACTIONS(1060),
    [anon_sym_vscale_range] = ACTIONS(1060),
    [anon_sym_preallocated] = ACTIONS(1060),
    [anon_sym_zeroext] = ACTIONS(1060),
    [anon_sym_signext] = ACTIONS(1060),
    [anon_sym_inreg] = ACTIONS(1060),
    [anon_sym_byval] = ACTIONS(1060),
    [anon_sym_byref] = ACTIONS(1060),
    [anon_sym_inalloca] = ACTIONS(1060),
    [anon_sym_sret] = ACTIONS(1060),
    [anon_sym_elementtype] = ACTIONS(1060),
    [anon_sym_noalias] = ACTIONS(1060),
    [anon_sym_nocapture] = ACTIONS(1060),
    [anon_sym_nest] = ACTIONS(1060),
    [anon_sym_returned] = ACTIONS(1060),
    [anon_sym_nonnull] = ACTIONS(1060),
    [anon_sym_dereferenceable] = ACTIONS(1062),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1060),
    [anon_sym_swiftself] = ACTIONS(1060),
    [anon_sym_swiftasync] = ACTIONS(1060),
    [anon_sym_swifterror] = ACTIONS(1060),
    [anon_sym_immarg] = ACTIONS(1060),
    [anon_sym_noundef] = ACTIONS(1060),
    [anon_sym_uwtable] = ACTIONS(1060),
    [anon_sym_memory] = ACTIONS(1060),
    [anon_sym_uselistorder] = ACTIONS(1062),
    [anon_sym_uselistorder_bb] = ACTIONS(1060),
    [anon_sym_module] = ACTIONS(1060),
    [anon_sym_externally_initialized] = ACTIONS(1060),
    [anon_sym_global] = ACTIONS(1060),
    [anon_sym_constant] = ACTIONS(1060),
    [anon_sym_alias] = ACTIONS(1060),
    [anon_sym_ifunc] = ACTIONS(1060),
    [anon_sym_attributes] = ACTIONS(1060),
  },
  [298] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(387),
    [sym_local_var] = ACTIONS(387),
    [sym_label] = ACTIONS(387),
    [sym_string] = ACTIONS(389),
    [aux_sym_number_token1] = ACTIONS(389),
    [aux_sym_number_token2] = ACTIONS(389),
    [sym_float] = ACTIONS(389),
    [sym_cstring] = ACTIONS(387),
    [anon_sym_no_cfi] = ACTIONS(389),
    [anon_sym_private] = ACTIONS(389),
    [anon_sym_internal] = ACTIONS(389),
    [anon_sym_weak] = ACTIONS(389),
    [anon_sym_weak_odr] = ACTIONS(389),
    [anon_sym_linkonce] = ACTIONS(389),
    [anon_sym_linkonce_odr] = ACTIONS(389),
    [anon_sym_available_externally] = ACTIONS(389),
    [anon_sym_appending] = ACTIONS(389),
    [anon_sym_common] = ACTIONS(389),
    [anon_sym_extern_weak] = ACTIONS(389),
    [anon_sym_external] = ACTIONS(389),
    [anon_sym_dso_local] = ACTIONS(389),
    [anon_sym_dso_local_equivalent] = ACTIONS(389),
    [anon_sym_dso_preemptable] = ACTIONS(389),
    [anon_sym_default] = ACTIONS(389),
    [anon_sym_hidden] = ACTIONS(389),
    [anon_sym_protected] = ACTIONS(389),
    [anon_sym_dllimport] = ACTIONS(389),
    [anon_sym_dllexport] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(387),
    [anon_sym_LBRACE] = ACTIONS(387),
    [anon_sym_RBRACE] = ACTIONS(387),
    [anon_sym_LT_LBRACE] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_COMMA] = ACTIONS(387),
    [anon_sym_addrspace] = ACTIONS(389),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_none] = ACTIONS(389),
    [anon_sym_unreachable] = ACTIONS(389),
    [anon_sym_ret] = ACTIONS(389),
    [anon_sym_br] = ACTIONS(389),
    [anon_sym_resume] = ACTIONS(389),
    [anon_sym_freeze] = ACTIONS(389),
    [anon_sym_indirectbr] = ACTIONS(389),
    [anon_sym_extractelement] = ACTIONS(389),
    [anon_sym_insertelement] = ACTIONS(389),
    [anon_sym_select] = ACTIONS(389),
    [anon_sym_shufflevector] = ACTIONS(389),
    [anon_sym_fneg] = ACTIONS(389),
    [anon_sym_switch] = ACTIONS(389),
    [anon_sym_invoke] = ACTIONS(389),
    [anon_sym_cleanupret] = ACTIONS(389),
    [anon_sym_catchret] = ACTIONS(389),
    [anon_sym_catchswitch] = ACTIONS(389),
    [anon_sym_catchpad] = ACTIONS(389),
    [anon_sym_cleanuppad] = ACTIONS(389),
    [anon_sym_callbr] = ACTIONS(389),
    [anon_sym_icmp] = ACTIONS(389),
    [anon_sym_fcmp] = ACTIONS(389),
    [anon_sym_va_arg] = ACTIONS(389),
    [anon_sym_phi] = ACTIONS(389),
    [anon_sym_landingpad] = ACTIONS(389),
    [anon_sym_tail] = ACTIONS(389),
    [anon_sym_musttail] = ACTIONS(389),
    [anon_sym_notail] = ACTIONS(389),
    [anon_sym_call] = ACTIONS(389),
    [anon_sym_alloca] = ACTIONS(389),
    [anon_sym_load] = ACTIONS(389),
    [anon_sym_store] = ACTIONS(389),
    [anon_sym_cmpxchg] = ACTIONS(389),
    [anon_sym_atomicrmw] = ACTIONS(389),
    [anon_sym_fence] = ACTIONS(389),
    [anon_sym_getelementptr] = ACTIONS(389),
    [anon_sym_extractvalue] = ACTIONS(389),
    [anon_sym_insertvalue] = ACTIONS(389),
    [anon_sym_true] = ACTIONS(389),
    [anon_sym_false] = ACTIONS(389),
    [anon_sym_null] = ACTIONS(389),
    [anon_sym_undef] = ACTIONS(389),
    [anon_sym_poison] = ACTIONS(389),
    [anon_sym_zeroinitializer] = ACTIONS(389),
    [anon_sym_catch] = ACTIONS(389),
    [anon_sym_filter] = ACTIONS(389),
    [anon_sym_blockaddress] = ACTIONS(389),
    [anon_sym_mul] = ACTIONS(389),
    [anon_sym_urem] = ACTIONS(389),
    [anon_sym_srem] = ACTIONS(389),
    [anon_sym_shl] = ACTIONS(389),
    [anon_sym_udiv] = ACTIONS(389),
    [anon_sym_sdiv] = ACTIONS(389),
    [anon_sym_lshr] = ACTIONS(389),
    [anon_sym_ashr] = ACTIONS(389),
    [anon_sym_fmul] = ACTIONS(389),
    [anon_sym_fdiv] = ACTIONS(389),
    [anon_sym_frem] = ACTIONS(389),
    [anon_sym_xchg] = ACTIONS(389),
    [anon_sym_add] = ACTIONS(389),
    [anon_sym_sub] = ACTIONS(389),
    [anon_sym_and] = ACTIONS(389),
    [anon_sym_nand] = ACTIONS(389),
    [anon_sym_or] = ACTIONS(389),
    [anon_sym_xor] = ACTIONS(389),
    [anon_sym_max] = ACTIONS(389),
    [anon_sym_min] = ACTIONS(389),
    [anon_sym_umax] = ACTIONS(389),
    [anon_sym_umin] = ACTIONS(389),
    [anon_sym_fadd] = ACTIONS(389),
    [anon_sym_fsub] = ACTIONS(389),
    [anon_sym_bitcast] = ACTIONS(389),
    [anon_sym_trunc] = ACTIONS(389),
    [anon_sym_zext] = ACTIONS(389),
    [anon_sym_sext] = ACTIONS(389),
    [anon_sym_fptrunc] = ACTIONS(389),
    [anon_sym_fpext] = ACTIONS(389),
    [anon_sym_addrspacecast] = ACTIONS(389),
    [anon_sym_uitofp] = ACTIONS(389),
    [anon_sym_sitofp] = ACTIONS(389),
    [anon_sym_fptoui] = ACTIONS(389),
    [anon_sym_fptosi] = ACTIONS(389),
    [anon_sym_inttoptr] = ACTIONS(389),
    [anon_sym_ptrtoint] = ACTIONS(389),
    [anon_sym_unordered] = ACTIONS(389),
    [anon_sym_monotonic] = ACTIONS(389),
    [anon_sym_acquire] = ACTIONS(389),
    [anon_sym_release] = ACTIONS(389),
    [anon_sym_acq_rel] = ACTIONS(389),
    [anon_sym_seq_cst] = ACTIONS(389),
    [anon_sym_syncscope] = ACTIONS(389),
    [anon_sym_uselistorder] = ACTIONS(389),
  },
  [299] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(379),
    [sym_local_var] = ACTIONS(379),
    [sym_label] = ACTIONS(379),
    [sym_string] = ACTIONS(381),
    [aux_sym_number_token1] = ACTIONS(381),
    [aux_sym_number_token2] = ACTIONS(381),
    [sym_float] = ACTIONS(381),
    [sym_cstring] = ACTIONS(379),
    [anon_sym_no_cfi] = ACTIONS(381),
    [anon_sym_private] = ACTIONS(381),
    [anon_sym_internal] = ACTIONS(381),
    [anon_sym_weak] = ACTIONS(381),
    [anon_sym_weak_odr] = ACTIONS(381),
    [anon_sym_linkonce] = ACTIONS(381),
    [anon_sym_linkonce_odr] = ACTIONS(381),
    [anon_sym_available_externally] = ACTIONS(381),
    [anon_sym_appending] = ACTIONS(381),
    [anon_sym_common] = ACTIONS(381),
    [anon_sym_extern_weak] = ACTIONS(381),
    [anon_sym_external] = ACTIONS(381),
    [anon_sym_dso_local] = ACTIONS(381),
    [anon_sym_dso_local_equivalent] = ACTIONS(381),
    [anon_sym_dso_preemptable] = ACTIONS(381),
    [anon_sym_default] = ACTIONS(381),
    [anon_sym_hidden] = ACTIONS(381),
    [anon_sym_protected] = ACTIONS(381),
    [anon_sym_dllimport] = ACTIONS(381),
    [anon_sym_dllexport] = ACTIONS(381),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_LT_LBRACE] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(379),
    [anon_sym_addrspace] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_none] = ACTIONS(381),
    [anon_sym_unreachable] = ACTIONS(381),
    [anon_sym_ret] = ACTIONS(381),
    [anon_sym_br] = ACTIONS(381),
    [anon_sym_resume] = ACTIONS(381),
    [anon_sym_freeze] = ACTIONS(381),
    [anon_sym_indirectbr] = ACTIONS(381),
    [anon_sym_extractelement] = ACTIONS(381),
    [anon_sym_insertelement] = ACTIONS(381),
    [anon_sym_select] = ACTIONS(381),
    [anon_sym_shufflevector] = ACTIONS(381),
    [anon_sym_fneg] = ACTIONS(381),
    [anon_sym_switch] = ACTIONS(381),
    [anon_sym_invoke] = ACTIONS(381),
    [anon_sym_cleanupret] = ACTIONS(381),
    [anon_sym_catchret] = ACTIONS(381),
    [anon_sym_catchswitch] = ACTIONS(381),
    [anon_sym_catchpad] = ACTIONS(381),
    [anon_sym_cleanuppad] = ACTIONS(381),
    [anon_sym_callbr] = ACTIONS(381),
    [anon_sym_icmp] = ACTIONS(381),
    [anon_sym_fcmp] = ACTIONS(381),
    [anon_sym_va_arg] = ACTIONS(381),
    [anon_sym_phi] = ACTIONS(381),
    [anon_sym_landingpad] = ACTIONS(381),
    [anon_sym_tail] = ACTIONS(381),
    [anon_sym_musttail] = ACTIONS(381),
    [anon_sym_notail] = ACTIONS(381),
    [anon_sym_call] = ACTIONS(381),
    [anon_sym_alloca] = ACTIONS(381),
    [anon_sym_load] = ACTIONS(381),
    [anon_sym_store] = ACTIONS(381),
    [anon_sym_cmpxchg] = ACTIONS(381),
    [anon_sym_atomicrmw] = ACTIONS(381),
    [anon_sym_fence] = ACTIONS(381),
    [anon_sym_getelementptr] = ACTIONS(381),
    [anon_sym_extractvalue] = ACTIONS(381),
    [anon_sym_insertvalue] = ACTIONS(381),
    [anon_sym_true] = ACTIONS(381),
    [anon_sym_false] = ACTIONS(381),
    [anon_sym_null] = ACTIONS(381),
    [anon_sym_undef] = ACTIONS(381),
    [anon_sym_poison] = ACTIONS(381),
    [anon_sym_zeroinitializer] = ACTIONS(381),
    [anon_sym_catch] = ACTIONS(381),
    [anon_sym_filter] = ACTIONS(381),
    [anon_sym_blockaddress] = ACTIONS(381),
    [anon_sym_mul] = ACTIONS(381),
    [anon_sym_urem] = ACTIONS(381),
    [anon_sym_srem] = ACTIONS(381),
    [anon_sym_shl] = ACTIONS(381),
    [anon_sym_udiv] = ACTIONS(381),
    [anon_sym_sdiv] = ACTIONS(381),
    [anon_sym_lshr] = ACTIONS(381),
    [anon_sym_ashr] = ACTIONS(381),
    [anon_sym_fmul] = ACTIONS(381),
    [anon_sym_fdiv] = ACTIONS(381),
    [anon_sym_frem] = ACTIONS(381),
    [anon_sym_xchg] = ACTIONS(381),
    [anon_sym_add] = ACTIONS(381),
    [anon_sym_sub] = ACTIONS(381),
    [anon_sym_and] = ACTIONS(381),
    [anon_sym_nand] = ACTIONS(381),
    [anon_sym_or] = ACTIONS(381),
    [anon_sym_xor] = ACTIONS(381),
    [anon_sym_max] = ACTIONS(381),
    [anon_sym_min] = ACTIONS(381),
    [anon_sym_umax] = ACTIONS(381),
    [anon_sym_umin] = ACTIONS(381),
    [anon_sym_fadd] = ACTIONS(381),
    [anon_sym_fsub] = ACTIONS(381),
    [anon_sym_bitcast] = ACTIONS(381),
    [anon_sym_trunc] = ACTIONS(381),
    [anon_sym_zext] = ACTIONS(381),
    [anon_sym_sext] = ACTIONS(381),
    [anon_sym_fptrunc] = ACTIONS(381),
    [anon_sym_fpext] = ACTIONS(381),
    [anon_sym_addrspacecast] = ACTIONS(381),
    [anon_sym_uitofp] = ACTIONS(381),
    [anon_sym_sitofp] = ACTIONS(381),
    [anon_sym_fptoui] = ACTIONS(381),
    [anon_sym_fptosi] = ACTIONS(381),
    [anon_sym_inttoptr] = ACTIONS(381),
    [anon_sym_ptrtoint] = ACTIONS(381),
    [anon_sym_unordered] = ACTIONS(381),
    [anon_sym_monotonic] = ACTIONS(381),
    [anon_sym_acquire] = ACTIONS(381),
    [anon_sym_release] = ACTIONS(381),
    [anon_sym_acq_rel] = ACTIONS(381),
    [anon_sym_seq_cst] = ACTIONS(381),
    [anon_sym_syncscope] = ACTIONS(381),
    [anon_sym_uselistorder] = ACTIONS(381),
  },
  [300] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(367),
    [sym_local_var] = ACTIONS(367),
    [sym_label] = ACTIONS(367),
    [sym_string] = ACTIONS(369),
    [aux_sym_number_token1] = ACTIONS(369),
    [aux_sym_number_token2] = ACTIONS(369),
    [sym_float] = ACTIONS(369),
    [sym_cstring] = ACTIONS(367),
    [anon_sym_no_cfi] = ACTIONS(369),
    [anon_sym_private] = ACTIONS(369),
    [anon_sym_internal] = ACTIONS(369),
    [anon_sym_weak] = ACTIONS(369),
    [anon_sym_weak_odr] = ACTIONS(369),
    [anon_sym_linkonce] = ACTIONS(369),
    [anon_sym_linkonce_odr] = ACTIONS(369),
    [anon_sym_available_externally] = ACTIONS(369),
    [anon_sym_appending] = ACTIONS(369),
    [anon_sym_common] = ACTIONS(369),
    [anon_sym_extern_weak] = ACTIONS(369),
    [anon_sym_external] = ACTIONS(369),
    [anon_sym_dso_local] = ACTIONS(369),
    [anon_sym_dso_local_equivalent] = ACTIONS(369),
    [anon_sym_dso_preemptable] = ACTIONS(369),
    [anon_sym_default] = ACTIONS(369),
    [anon_sym_hidden] = ACTIONS(369),
    [anon_sym_protected] = ACTIONS(369),
    [anon_sym_dllimport] = ACTIONS(369),
    [anon_sym_dllexport] = ACTIONS(369),
    [anon_sym_STAR] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(367),
    [anon_sym_RBRACE] = ACTIONS(367),
    [anon_sym_LT_LBRACE] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_COMMA] = ACTIONS(367),
    [anon_sym_addrspace] = ACTIONS(369),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_none] = ACTIONS(369),
    [anon_sym_unreachable] = ACTIONS(369),
    [anon_sym_ret] = ACTIONS(369),
    [anon_sym_br] = ACTIONS(369),
    [anon_sym_resume] = ACTIONS(369),
    [anon_sym_freeze] = ACTIONS(369),
    [anon_sym_indirectbr] = ACTIONS(369),
    [anon_sym_extractelement] = ACTIONS(369),
    [anon_sym_insertelement] = ACTIONS(369),
    [anon_sym_select] = ACTIONS(369),
    [anon_sym_shufflevector] = ACTIONS(369),
    [anon_sym_fneg] = ACTIONS(369),
    [anon_sym_switch] = ACTIONS(369),
    [anon_sym_invoke] = ACTIONS(369),
    [anon_sym_cleanupret] = ACTIONS(369),
    [anon_sym_catchret] = ACTIONS(369),
    [anon_sym_catchswitch] = ACTIONS(369),
    [anon_sym_catchpad] = ACTIONS(369),
    [anon_sym_cleanuppad] = ACTIONS(369),
    [anon_sym_callbr] = ACTIONS(369),
    [anon_sym_icmp] = ACTIONS(369),
    [anon_sym_fcmp] = ACTIONS(369),
    [anon_sym_va_arg] = ACTIONS(369),
    [anon_sym_phi] = ACTIONS(369),
    [anon_sym_landingpad] = ACTIONS(369),
    [anon_sym_tail] = ACTIONS(369),
    [anon_sym_musttail] = ACTIONS(369),
    [anon_sym_notail] = ACTIONS(369),
    [anon_sym_call] = ACTIONS(369),
    [anon_sym_alloca] = ACTIONS(369),
    [anon_sym_load] = ACTIONS(369),
    [anon_sym_store] = ACTIONS(369),
    [anon_sym_cmpxchg] = ACTIONS(369),
    [anon_sym_atomicrmw] = ACTIONS(369),
    [anon_sym_fence] = ACTIONS(369),
    [anon_sym_getelementptr] = ACTIONS(369),
    [anon_sym_extractvalue] = ACTIONS(369),
    [anon_sym_insertvalue] = ACTIONS(369),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_null] = ACTIONS(369),
    [anon_sym_undef] = ACTIONS(369),
    [anon_sym_poison] = ACTIONS(369),
    [anon_sym_zeroinitializer] = ACTIONS(369),
    [anon_sym_catch] = ACTIONS(369),
    [anon_sym_filter] = ACTIONS(369),
    [anon_sym_blockaddress] = ACTIONS(369),
    [anon_sym_mul] = ACTIONS(369),
    [anon_sym_urem] = ACTIONS(369),
    [anon_sym_srem] = ACTIONS(369),
    [anon_sym_shl] = ACTIONS(369),
    [anon_sym_udiv] = ACTIONS(369),
    [anon_sym_sdiv] = ACTIONS(369),
    [anon_sym_lshr] = ACTIONS(369),
    [anon_sym_ashr] = ACTIONS(369),
    [anon_sym_fmul] = ACTIONS(369),
    [anon_sym_fdiv] = ACTIONS(369),
    [anon_sym_frem] = ACTIONS(369),
    [anon_sym_xchg] = ACTIONS(369),
    [anon_sym_add] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(369),
    [anon_sym_and] = ACTIONS(369),
    [anon_sym_nand] = ACTIONS(369),
    [anon_sym_or] = ACTIONS(369),
    [anon_sym_xor] = ACTIONS(369),
    [anon_sym_max] = ACTIONS(369),
    [anon_sym_min] = ACTIONS(369),
    [anon_sym_umax] = ACTIONS(369),
    [anon_sym_umin] = ACTIONS(369),
    [anon_sym_fadd] = ACTIONS(369),
    [anon_sym_fsub] = ACTIONS(369),
    [anon_sym_bitcast] = ACTIONS(369),
    [anon_sym_trunc] = ACTIONS(369),
    [anon_sym_zext] = ACTIONS(369),
    [anon_sym_sext] = ACTIONS(369),
    [anon_sym_fptrunc] = ACTIONS(369),
    [anon_sym_fpext] = ACTIONS(369),
    [anon_sym_addrspacecast] = ACTIONS(369),
    [anon_sym_uitofp] = ACTIONS(369),
    [anon_sym_sitofp] = ACTIONS(369),
    [anon_sym_fptoui] = ACTIONS(369),
    [anon_sym_fptosi] = ACTIONS(369),
    [anon_sym_inttoptr] = ACTIONS(369),
    [anon_sym_ptrtoint] = ACTIONS(369),
    [anon_sym_unordered] = ACTIONS(369),
    [anon_sym_monotonic] = ACTIONS(369),
    [anon_sym_acquire] = ACTIONS(369),
    [anon_sym_release] = ACTIONS(369),
    [anon_sym_acq_rel] = ACTIONS(369),
    [anon_sym_seq_cst] = ACTIONS(369),
    [anon_sym_syncscope] = ACTIONS(369),
    [anon_sym_uselistorder] = ACTIONS(369),
  },
  [301] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [sym_label] = ACTIONS(269),
    [sym_string] = ACTIONS(271),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(271),
    [sym_float] = ACTIONS(271),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(271),
    [anon_sym_private] = ACTIONS(271),
    [anon_sym_internal] = ACTIONS(271),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(271),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(271),
    [anon_sym_available_externally] = ACTIONS(271),
    [anon_sym_appending] = ACTIONS(271),
    [anon_sym_common] = ACTIONS(271),
    [anon_sym_extern_weak] = ACTIONS(271),
    [anon_sym_external] = ACTIONS(271),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(271),
    [anon_sym_dso_preemptable] = ACTIONS(271),
    [anon_sym_default] = ACTIONS(271),
    [anon_sym_hidden] = ACTIONS(271),
    [anon_sym_protected] = ACTIONS(271),
    [anon_sym_dllimport] = ACTIONS(271),
    [anon_sym_dllexport] = ACTIONS(271),
    [anon_sym_STAR] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_none] = ACTIONS(271),
    [anon_sym_unreachable] = ACTIONS(271),
    [anon_sym_ret] = ACTIONS(271),
    [anon_sym_br] = ACTIONS(271),
    [anon_sym_resume] = ACTIONS(271),
    [anon_sym_freeze] = ACTIONS(271),
    [anon_sym_indirectbr] = ACTIONS(271),
    [anon_sym_extractelement] = ACTIONS(271),
    [anon_sym_insertelement] = ACTIONS(271),
    [anon_sym_select] = ACTIONS(271),
    [anon_sym_shufflevector] = ACTIONS(271),
    [anon_sym_fneg] = ACTIONS(271),
    [anon_sym_switch] = ACTIONS(271),
    [anon_sym_invoke] = ACTIONS(271),
    [anon_sym_cleanupret] = ACTIONS(271),
    [anon_sym_catchret] = ACTIONS(271),
    [anon_sym_catchswitch] = ACTIONS(271),
    [anon_sym_catchpad] = ACTIONS(271),
    [anon_sym_cleanuppad] = ACTIONS(271),
    [anon_sym_callbr] = ACTIONS(271),
    [anon_sym_icmp] = ACTIONS(271),
    [anon_sym_fcmp] = ACTIONS(271),
    [anon_sym_va_arg] = ACTIONS(271),
    [anon_sym_phi] = ACTIONS(271),
    [anon_sym_landingpad] = ACTIONS(271),
    [anon_sym_tail] = ACTIONS(271),
    [anon_sym_musttail] = ACTIONS(271),
    [anon_sym_notail] = ACTIONS(271),
    [anon_sym_call] = ACTIONS(271),
    [anon_sym_alloca] = ACTIONS(271),
    [anon_sym_load] = ACTIONS(271),
    [anon_sym_store] = ACTIONS(271),
    [anon_sym_cmpxchg] = ACTIONS(271),
    [anon_sym_atomicrmw] = ACTIONS(271),
    [anon_sym_fence] = ACTIONS(271),
    [anon_sym_getelementptr] = ACTIONS(271),
    [anon_sym_extractvalue] = ACTIONS(271),
    [anon_sym_insertvalue] = ACTIONS(271),
    [anon_sym_true] = ACTIONS(271),
    [anon_sym_false] = ACTIONS(271),
    [anon_sym_null] = ACTIONS(271),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_poison] = ACTIONS(271),
    [anon_sym_zeroinitializer] = ACTIONS(271),
    [anon_sym_catch] = ACTIONS(271),
    [anon_sym_filter] = ACTIONS(271),
    [anon_sym_blockaddress] = ACTIONS(271),
    [anon_sym_mul] = ACTIONS(271),
    [anon_sym_urem] = ACTIONS(271),
    [anon_sym_srem] = ACTIONS(271),
    [anon_sym_shl] = ACTIONS(271),
    [anon_sym_udiv] = ACTIONS(271),
    [anon_sym_sdiv] = ACTIONS(271),
    [anon_sym_lshr] = ACTIONS(271),
    [anon_sym_ashr] = ACTIONS(271),
    [anon_sym_fmul] = ACTIONS(271),
    [anon_sym_fdiv] = ACTIONS(271),
    [anon_sym_frem] = ACTIONS(271),
    [anon_sym_xchg] = ACTIONS(271),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(271),
    [anon_sym_and] = ACTIONS(271),
    [anon_sym_nand] = ACTIONS(271),
    [anon_sym_or] = ACTIONS(271),
    [anon_sym_xor] = ACTIONS(271),
    [anon_sym_max] = ACTIONS(271),
    [anon_sym_min] = ACTIONS(271),
    [anon_sym_umax] = ACTIONS(271),
    [anon_sym_umin] = ACTIONS(271),
    [anon_sym_fadd] = ACTIONS(271),
    [anon_sym_fsub] = ACTIONS(271),
    [anon_sym_bitcast] = ACTIONS(271),
    [anon_sym_trunc] = ACTIONS(271),
    [anon_sym_zext] = ACTIONS(271),
    [anon_sym_sext] = ACTIONS(271),
    [anon_sym_fptrunc] = ACTIONS(271),
    [anon_sym_fpext] = ACTIONS(271),
    [anon_sym_addrspacecast] = ACTIONS(271),
    [anon_sym_uitofp] = ACTIONS(271),
    [anon_sym_sitofp] = ACTIONS(271),
    [anon_sym_fptoui] = ACTIONS(271),
    [anon_sym_fptosi] = ACTIONS(271),
    [anon_sym_inttoptr] = ACTIONS(271),
    [anon_sym_ptrtoint] = ACTIONS(271),
    [anon_sym_unordered] = ACTIONS(271),
    [anon_sym_monotonic] = ACTIONS(271),
    [anon_sym_acquire] = ACTIONS(271),
    [anon_sym_release] = ACTIONS(271),
    [anon_sym_acq_rel] = ACTIONS(271),
    [anon_sym_seq_cst] = ACTIONS(271),
    [anon_sym_syncscope] = ACTIONS(271),
    [anon_sym_uselistorder] = ACTIONS(271),
  },
  [302] = {
    [ts_builtin_sym_end] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(573),
    [sym_comdat_ref] = ACTIONS(573),
    [sym_global_var] = ACTIONS(573),
    [sym_local_var] = ACTIONS(573),
    [aux_sym_metadata_ref_token1] = ACTIONS(573),
    [sym_summary_ref] = ACTIONS(573),
    [sym_string] = ACTIONS(573),
    [anon_sym_target] = ACTIONS(573),
    [anon_sym_source_filename] = ACTIONS(573),
    [anon_sym_declare] = ACTIONS(573),
    [anon_sym_define] = ACTIONS(573),
    [anon_sym_void] = ACTIONS(573),
    [anon_sym_half] = ACTIONS(573),
    [anon_sym_bfloat] = ACTIONS(573),
    [anon_sym_float] = ACTIONS(573),
    [anon_sym_double] = ACTIONS(573),
    [anon_sym_x86_fp80] = ACTIONS(573),
    [anon_sym_fp128] = ACTIONS(573),
    [anon_sym_ppc_fp128] = ACTIONS(573),
    [anon_sym_label] = ACTIONS(573),
    [anon_sym_metadata] = ACTIONS(573),
    [anon_sym_x86_mmx] = ACTIONS(573),
    [anon_sym_x86_amx] = ACTIONS(573),
    [anon_sym_token] = ACTIONS(573),
    [anon_sym_opaque] = ACTIONS(573),
    [anon_sym_ptr] = ACTIONS(573),
    [aux_sym_type_keyword_token1] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(573),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_LT_LBRACE] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_RBRACK] = ACTIONS(573),
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_align] = ACTIONS(575),
    [anon_sym_section] = ACTIONS(573),
    [anon_sym_partition] = ACTIONS(573),
    [anon_sym_comdat] = ACTIONS(573),
    [anon_sym_gc] = ACTIONS(573),
    [anon_sym_prefix] = ACTIONS(573),
    [anon_sym_prologue] = ACTIONS(573),
    [anon_sym_personality] = ACTIONS(573),
    [anon_sym_alignstack] = ACTIONS(573),
    [anon_sym_allocsize] = ACTIONS(573),
    [anon_sym_alwaysinline] = ACTIONS(573),
    [anon_sym_builtin] = ACTIONS(573),
    [anon_sym_cold] = ACTIONS(573),
    [anon_sym_convergent] = ACTIONS(573),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(573),
    [anon_sym_hot] = ACTIONS(573),
    [anon_sym_inaccessiblememonly] = ACTIONS(573),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(573),
    [anon_sym_inlinehint] = ACTIONS(573),
    [anon_sym_jumptable] = ACTIONS(573),
    [anon_sym_minsize] = ACTIONS(573),
    [anon_sym_naked] = ACTIONS(573),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(573),
    [anon_sym_nobuiltin] = ACTIONS(573),
    [anon_sym_noduplicate] = ACTIONS(573),
    [anon_sym_nofree] = ACTIONS(573),
    [anon_sym_noimplicitfloat] = ACTIONS(573),
    [anon_sym_noinline] = ACTIONS(573),
    [anon_sym_nomerge] = ACTIONS(573),
    [anon_sym_nonlazybind] = ACTIONS(573),
    [anon_sym_noprofile] = ACTIONS(573),
    [anon_sym_noredzone] = ACTIONS(573),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(573),
    [anon_sym_noreturn] = ACTIONS(573),
    [anon_sym_norecurse] = ACTIONS(573),
    [anon_sym_willreturn] = ACTIONS(573),
    [anon_sym_nosync] = ACTIONS(573),
    [anon_sym_nounwind] = ACTIONS(573),
    [anon_sym_nocallback] = ACTIONS(573),
    [anon_sym_nosanitize_coverage] = ACTIONS(573),
    [anon_sym_null_pointer_is_valid] = ACTIONS(573),
    [anon_sym_optforfuzzing] = ACTIONS(573),
    [anon_sym_optnone] = ACTIONS(573),
    [anon_sym_optsize] = ACTIONS(573),
    [anon_sym_readnone] = ACTIONS(573),
    [anon_sym_readonly] = ACTIONS(573),
    [anon_sym_writeonly] = ACTIONS(573),
    [anon_sym_argmemonly] = ACTIONS(573),
    [anon_sym_returns_twice] = ACTIONS(573),
    [anon_sym_safestack] = ACTIONS(573),
    [anon_sym_sanitize_address] = ACTIONS(573),
    [anon_sym_sanitize_memory] = ACTIONS(573),
    [anon_sym_sanitize_thread] = ACTIONS(573),
    [anon_sym_sanitize_hwaddress] = ACTIONS(573),
    [anon_sym_sanitize_memtag] = ACTIONS(573),
    [anon_sym_speculative_load_hardening] = ACTIONS(573),
    [anon_sym_speculatable] = ACTIONS(573),
    [anon_sym_ssp] = ACTIONS(575),
    [anon_sym_sspstrong] = ACTIONS(573),
    [anon_sym_sspreq] = ACTIONS(573),
    [anon_sym_strictfp] = ACTIONS(573),
    [anon_sym_nocf_check] = ACTIONS(573),
    [anon_sym_shadowcallstack] = ACTIONS(573),
    [anon_sym_mustprogress] = ACTIONS(573),
    [anon_sym_vscale_range] = ACTIONS(573),
    [anon_sym_preallocated] = ACTIONS(573),
    [anon_sym_zeroext] = ACTIONS(573),
    [anon_sym_signext] = ACTIONS(573),
    [anon_sym_inreg] = ACTIONS(573),
    [anon_sym_byval] = ACTIONS(573),
    [anon_sym_byref] = ACTIONS(573),
    [anon_sym_inalloca] = ACTIONS(573),
    [anon_sym_sret] = ACTIONS(573),
    [anon_sym_elementtype] = ACTIONS(573),
    [anon_sym_noalias] = ACTIONS(573),
    [anon_sym_nocapture] = ACTIONS(573),
    [anon_sym_nest] = ACTIONS(573),
    [anon_sym_returned] = ACTIONS(573),
    [anon_sym_nonnull] = ACTIONS(573),
    [anon_sym_dereferenceable] = ACTIONS(575),
    [anon_sym_dereferenceable_or_null] = ACTIONS(573),
    [anon_sym_swiftself] = ACTIONS(573),
    [anon_sym_swiftasync] = ACTIONS(573),
    [anon_sym_swifterror] = ACTIONS(573),
    [anon_sym_immarg] = ACTIONS(573),
    [anon_sym_noundef] = ACTIONS(573),
    [anon_sym_uwtable] = ACTIONS(573),
    [anon_sym_memory] = ACTIONS(573),
    [anon_sym_to] = ACTIONS(575),
    [anon_sym_uselistorder] = ACTIONS(575),
    [anon_sym_uselistorder_bb] = ACTIONS(573),
    [anon_sym_module] = ACTIONS(573),
    [anon_sym_LPAREN2] = ACTIONS(1064),
    [anon_sym_attributes] = ACTIONS(573),
  },
  [303] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(371),
    [sym_local_var] = ACTIONS(371),
    [sym_label] = ACTIONS(371),
    [sym_string] = ACTIONS(373),
    [aux_sym_number_token1] = ACTIONS(373),
    [aux_sym_number_token2] = ACTIONS(373),
    [sym_float] = ACTIONS(373),
    [sym_cstring] = ACTIONS(371),
    [anon_sym_no_cfi] = ACTIONS(373),
    [anon_sym_private] = ACTIONS(373),
    [anon_sym_internal] = ACTIONS(373),
    [anon_sym_weak] = ACTIONS(373),
    [anon_sym_weak_odr] = ACTIONS(373),
    [anon_sym_linkonce] = ACTIONS(373),
    [anon_sym_linkonce_odr] = ACTIONS(373),
    [anon_sym_available_externally] = ACTIONS(373),
    [anon_sym_appending] = ACTIONS(373),
    [anon_sym_common] = ACTIONS(373),
    [anon_sym_extern_weak] = ACTIONS(373),
    [anon_sym_external] = ACTIONS(373),
    [anon_sym_dso_local] = ACTIONS(373),
    [anon_sym_dso_local_equivalent] = ACTIONS(373),
    [anon_sym_dso_preemptable] = ACTIONS(373),
    [anon_sym_default] = ACTIONS(373),
    [anon_sym_hidden] = ACTIONS(373),
    [anon_sym_protected] = ACTIONS(373),
    [anon_sym_dllimport] = ACTIONS(373),
    [anon_sym_dllexport] = ACTIONS(373),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(371),
    [anon_sym_LT_LBRACE] = ACTIONS(371),
    [anon_sym_LBRACK] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_COMMA] = ACTIONS(371),
    [anon_sym_addrspace] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_none] = ACTIONS(373),
    [anon_sym_unreachable] = ACTIONS(373),
    [anon_sym_ret] = ACTIONS(373),
    [anon_sym_br] = ACTIONS(373),
    [anon_sym_resume] = ACTIONS(373),
    [anon_sym_freeze] = ACTIONS(373),
    [anon_sym_indirectbr] = ACTIONS(373),
    [anon_sym_extractelement] = ACTIONS(373),
    [anon_sym_insertelement] = ACTIONS(373),
    [anon_sym_select] = ACTIONS(373),
    [anon_sym_shufflevector] = ACTIONS(373),
    [anon_sym_fneg] = ACTIONS(373),
    [anon_sym_switch] = ACTIONS(373),
    [anon_sym_invoke] = ACTIONS(373),
    [anon_sym_cleanupret] = ACTIONS(373),
    [anon_sym_catchret] = ACTIONS(373),
    [anon_sym_catchswitch] = ACTIONS(373),
    [anon_sym_catchpad] = ACTIONS(373),
    [anon_sym_cleanuppad] = ACTIONS(373),
    [anon_sym_callbr] = ACTIONS(373),
    [anon_sym_icmp] = ACTIONS(373),
    [anon_sym_fcmp] = ACTIONS(373),
    [anon_sym_va_arg] = ACTIONS(373),
    [anon_sym_phi] = ACTIONS(373),
    [anon_sym_landingpad] = ACTIONS(373),
    [anon_sym_tail] = ACTIONS(373),
    [anon_sym_musttail] = ACTIONS(373),
    [anon_sym_notail] = ACTIONS(373),
    [anon_sym_call] = ACTIONS(373),
    [anon_sym_alloca] = ACTIONS(373),
    [anon_sym_load] = ACTIONS(373),
    [anon_sym_store] = ACTIONS(373),
    [anon_sym_cmpxchg] = ACTIONS(373),
    [anon_sym_atomicrmw] = ACTIONS(373),
    [anon_sym_fence] = ACTIONS(373),
    [anon_sym_getelementptr] = ACTIONS(373),
    [anon_sym_extractvalue] = ACTIONS(373),
    [anon_sym_insertvalue] = ACTIONS(373),
    [anon_sym_true] = ACTIONS(373),
    [anon_sym_false] = ACTIONS(373),
    [anon_sym_null] = ACTIONS(373),
    [anon_sym_undef] = ACTIONS(373),
    [anon_sym_poison] = ACTIONS(373),
    [anon_sym_zeroinitializer] = ACTIONS(373),
    [anon_sym_catch] = ACTIONS(373),
    [anon_sym_filter] = ACTIONS(373),
    [anon_sym_blockaddress] = ACTIONS(373),
    [anon_sym_mul] = ACTIONS(373),
    [anon_sym_urem] = ACTIONS(373),
    [anon_sym_srem] = ACTIONS(373),
    [anon_sym_shl] = ACTIONS(373),
    [anon_sym_udiv] = ACTIONS(373),
    [anon_sym_sdiv] = ACTIONS(373),
    [anon_sym_lshr] = ACTIONS(373),
    [anon_sym_ashr] = ACTIONS(373),
    [anon_sym_fmul] = ACTIONS(373),
    [anon_sym_fdiv] = ACTIONS(373),
    [anon_sym_frem] = ACTIONS(373),
    [anon_sym_xchg] = ACTIONS(373),
    [anon_sym_add] = ACTIONS(373),
    [anon_sym_sub] = ACTIONS(373),
    [anon_sym_and] = ACTIONS(373),
    [anon_sym_nand] = ACTIONS(373),
    [anon_sym_or] = ACTIONS(373),
    [anon_sym_xor] = ACTIONS(373),
    [anon_sym_max] = ACTIONS(373),
    [anon_sym_min] = ACTIONS(373),
    [anon_sym_umax] = ACTIONS(373),
    [anon_sym_umin] = ACTIONS(373),
    [anon_sym_fadd] = ACTIONS(373),
    [anon_sym_fsub] = ACTIONS(373),
    [anon_sym_bitcast] = ACTIONS(373),
    [anon_sym_trunc] = ACTIONS(373),
    [anon_sym_zext] = ACTIONS(373),
    [anon_sym_sext] = ACTIONS(373),
    [anon_sym_fptrunc] = ACTIONS(373),
    [anon_sym_fpext] = ACTIONS(373),
    [anon_sym_addrspacecast] = ACTIONS(373),
    [anon_sym_uitofp] = ACTIONS(373),
    [anon_sym_sitofp] = ACTIONS(373),
    [anon_sym_fptoui] = ACTIONS(373),
    [anon_sym_fptosi] = ACTIONS(373),
    [anon_sym_inttoptr] = ACTIONS(373),
    [anon_sym_ptrtoint] = ACTIONS(373),
    [anon_sym_unordered] = ACTIONS(373),
    [anon_sym_monotonic] = ACTIONS(373),
    [anon_sym_acquire] = ACTIONS(373),
    [anon_sym_release] = ACTIONS(373),
    [anon_sym_acq_rel] = ACTIONS(373),
    [anon_sym_seq_cst] = ACTIONS(373),
    [anon_sym_syncscope] = ACTIONS(373),
    [anon_sym_uselistorder] = ACTIONS(373),
  },
  [304] = {
    [ts_builtin_sym_end] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(505),
    [sym_comdat_ref] = ACTIONS(505),
    [sym_global_var] = ACTIONS(505),
    [sym_local_var] = ACTIONS(505),
    [aux_sym_metadata_ref_token1] = ACTIONS(505),
    [sym_summary_ref] = ACTIONS(505),
    [sym_string] = ACTIONS(505),
    [anon_sym_target] = ACTIONS(505),
    [anon_sym_source_filename] = ACTIONS(505),
    [anon_sym_declare] = ACTIONS(505),
    [anon_sym_define] = ACTIONS(505),
    [anon_sym_void] = ACTIONS(505),
    [anon_sym_half] = ACTIONS(505),
    [anon_sym_bfloat] = ACTIONS(505),
    [anon_sym_float] = ACTIONS(505),
    [anon_sym_double] = ACTIONS(505),
    [anon_sym_x86_fp80] = ACTIONS(505),
    [anon_sym_fp128] = ACTIONS(505),
    [anon_sym_ppc_fp128] = ACTIONS(505),
    [anon_sym_label] = ACTIONS(505),
    [anon_sym_metadata] = ACTIONS(505),
    [anon_sym_x86_mmx] = ACTIONS(505),
    [anon_sym_x86_amx] = ACTIONS(505),
    [anon_sym_token] = ACTIONS(505),
    [anon_sym_opaque] = ACTIONS(505),
    [anon_sym_ptr] = ACTIONS(505),
    [aux_sym_type_keyword_token1] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(505),
    [anon_sym_RBRACE] = ACTIONS(505),
    [anon_sym_LT_LBRACE] = ACTIONS(505),
    [anon_sym_LBRACK] = ACTIONS(505),
    [anon_sym_RBRACK] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(507),
    [anon_sym_COMMA] = ACTIONS(505),
    [anon_sym_align] = ACTIONS(507),
    [anon_sym_section] = ACTIONS(505),
    [anon_sym_partition] = ACTIONS(505),
    [anon_sym_comdat] = ACTIONS(505),
    [anon_sym_gc] = ACTIONS(505),
    [anon_sym_prefix] = ACTIONS(505),
    [anon_sym_prologue] = ACTIONS(505),
    [anon_sym_personality] = ACTIONS(505),
    [anon_sym_alignstack] = ACTIONS(505),
    [anon_sym_allocsize] = ACTIONS(505),
    [anon_sym_alwaysinline] = ACTIONS(505),
    [anon_sym_builtin] = ACTIONS(505),
    [anon_sym_cold] = ACTIONS(505),
    [anon_sym_convergent] = ACTIONS(505),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(505),
    [anon_sym_hot] = ACTIONS(505),
    [anon_sym_inaccessiblememonly] = ACTIONS(505),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(505),
    [anon_sym_inlinehint] = ACTIONS(505),
    [anon_sym_jumptable] = ACTIONS(505),
    [anon_sym_minsize] = ACTIONS(505),
    [anon_sym_naked] = ACTIONS(505),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(505),
    [anon_sym_nobuiltin] = ACTIONS(505),
    [anon_sym_noduplicate] = ACTIONS(505),
    [anon_sym_nofree] = ACTIONS(505),
    [anon_sym_noimplicitfloat] = ACTIONS(505),
    [anon_sym_noinline] = ACTIONS(505),
    [anon_sym_nomerge] = ACTIONS(505),
    [anon_sym_nonlazybind] = ACTIONS(505),
    [anon_sym_noprofile] = ACTIONS(505),
    [anon_sym_noredzone] = ACTIONS(505),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(505),
    [anon_sym_noreturn] = ACTIONS(505),
    [anon_sym_norecurse] = ACTIONS(505),
    [anon_sym_willreturn] = ACTIONS(505),
    [anon_sym_nosync] = ACTIONS(505),
    [anon_sym_nounwind] = ACTIONS(505),
    [anon_sym_nocallback] = ACTIONS(505),
    [anon_sym_nosanitize_coverage] = ACTIONS(505),
    [anon_sym_null_pointer_is_valid] = ACTIONS(505),
    [anon_sym_optforfuzzing] = ACTIONS(505),
    [anon_sym_optnone] = ACTIONS(505),
    [anon_sym_optsize] = ACTIONS(505),
    [anon_sym_readnone] = ACTIONS(505),
    [anon_sym_readonly] = ACTIONS(505),
    [anon_sym_writeonly] = ACTIONS(505),
    [anon_sym_argmemonly] = ACTIONS(505),
    [anon_sym_returns_twice] = ACTIONS(505),
    [anon_sym_safestack] = ACTIONS(505),
    [anon_sym_sanitize_address] = ACTIONS(505),
    [anon_sym_sanitize_memory] = ACTIONS(505),
    [anon_sym_sanitize_thread] = ACTIONS(505),
    [anon_sym_sanitize_hwaddress] = ACTIONS(505),
    [anon_sym_sanitize_memtag] = ACTIONS(505),
    [anon_sym_speculative_load_hardening] = ACTIONS(505),
    [anon_sym_speculatable] = ACTIONS(505),
    [anon_sym_ssp] = ACTIONS(507),
    [anon_sym_sspstrong] = ACTIONS(505),
    [anon_sym_sspreq] = ACTIONS(505),
    [anon_sym_strictfp] = ACTIONS(505),
    [anon_sym_nocf_check] = ACTIONS(505),
    [anon_sym_shadowcallstack] = ACTIONS(505),
    [anon_sym_mustprogress] = ACTIONS(505),
    [anon_sym_vscale_range] = ACTIONS(505),
    [anon_sym_preallocated] = ACTIONS(505),
    [anon_sym_zeroext] = ACTIONS(505),
    [anon_sym_signext] = ACTIONS(505),
    [anon_sym_inreg] = ACTIONS(505),
    [anon_sym_byval] = ACTIONS(505),
    [anon_sym_byref] = ACTIONS(505),
    [anon_sym_inalloca] = ACTIONS(505),
    [anon_sym_sret] = ACTIONS(505),
    [anon_sym_elementtype] = ACTIONS(505),
    [anon_sym_noalias] = ACTIONS(505),
    [anon_sym_nocapture] = ACTIONS(505),
    [anon_sym_nest] = ACTIONS(505),
    [anon_sym_returned] = ACTIONS(505),
    [anon_sym_nonnull] = ACTIONS(505),
    [anon_sym_dereferenceable] = ACTIONS(507),
    [anon_sym_dereferenceable_or_null] = ACTIONS(505),
    [anon_sym_swiftself] = ACTIONS(505),
    [anon_sym_swiftasync] = ACTIONS(505),
    [anon_sym_swifterror] = ACTIONS(505),
    [anon_sym_immarg] = ACTIONS(505),
    [anon_sym_noundef] = ACTIONS(505),
    [anon_sym_uwtable] = ACTIONS(505),
    [anon_sym_memory] = ACTIONS(505),
    [anon_sym_to] = ACTIONS(507),
    [anon_sym_uselistorder] = ACTIONS(507),
    [anon_sym_uselistorder_bb] = ACTIONS(505),
    [anon_sym_module] = ACTIONS(505),
    [anon_sym_LPAREN2] = ACTIONS(505),
    [anon_sym_attributes] = ACTIONS(505),
  },
  [305] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(375),
    [sym_local_var] = ACTIONS(375),
    [sym_label] = ACTIONS(375),
    [sym_string] = ACTIONS(377),
    [aux_sym_number_token1] = ACTIONS(377),
    [aux_sym_number_token2] = ACTIONS(377),
    [sym_float] = ACTIONS(377),
    [sym_cstring] = ACTIONS(375),
    [anon_sym_no_cfi] = ACTIONS(377),
    [anon_sym_private] = ACTIONS(377),
    [anon_sym_internal] = ACTIONS(377),
    [anon_sym_weak] = ACTIONS(377),
    [anon_sym_weak_odr] = ACTIONS(377),
    [anon_sym_linkonce] = ACTIONS(377),
    [anon_sym_linkonce_odr] = ACTIONS(377),
    [anon_sym_available_externally] = ACTIONS(377),
    [anon_sym_appending] = ACTIONS(377),
    [anon_sym_common] = ACTIONS(377),
    [anon_sym_extern_weak] = ACTIONS(377),
    [anon_sym_external] = ACTIONS(377),
    [anon_sym_dso_local] = ACTIONS(377),
    [anon_sym_dso_local_equivalent] = ACTIONS(377),
    [anon_sym_dso_preemptable] = ACTIONS(377),
    [anon_sym_default] = ACTIONS(377),
    [anon_sym_hidden] = ACTIONS(377),
    [anon_sym_protected] = ACTIONS(377),
    [anon_sym_dllimport] = ACTIONS(377),
    [anon_sym_dllexport] = ACTIONS(377),
    [anon_sym_STAR] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(375),
    [anon_sym_RBRACE] = ACTIONS(375),
    [anon_sym_LT_LBRACE] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_COMMA] = ACTIONS(375),
    [anon_sym_addrspace] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_none] = ACTIONS(377),
    [anon_sym_unreachable] = ACTIONS(377),
    [anon_sym_ret] = ACTIONS(377),
    [anon_sym_br] = ACTIONS(377),
    [anon_sym_resume] = ACTIONS(377),
    [anon_sym_freeze] = ACTIONS(377),
    [anon_sym_indirectbr] = ACTIONS(377),
    [anon_sym_extractelement] = ACTIONS(377),
    [anon_sym_insertelement] = ACTIONS(377),
    [anon_sym_select] = ACTIONS(377),
    [anon_sym_shufflevector] = ACTIONS(377),
    [anon_sym_fneg] = ACTIONS(377),
    [anon_sym_switch] = ACTIONS(377),
    [anon_sym_invoke] = ACTIONS(377),
    [anon_sym_cleanupret] = ACTIONS(377),
    [anon_sym_catchret] = ACTIONS(377),
    [anon_sym_catchswitch] = ACTIONS(377),
    [anon_sym_catchpad] = ACTIONS(377),
    [anon_sym_cleanuppad] = ACTIONS(377),
    [anon_sym_callbr] = ACTIONS(377),
    [anon_sym_icmp] = ACTIONS(377),
    [anon_sym_fcmp] = ACTIONS(377),
    [anon_sym_va_arg] = ACTIONS(377),
    [anon_sym_phi] = ACTIONS(377),
    [anon_sym_landingpad] = ACTIONS(377),
    [anon_sym_tail] = ACTIONS(377),
    [anon_sym_musttail] = ACTIONS(377),
    [anon_sym_notail] = ACTIONS(377),
    [anon_sym_call] = ACTIONS(377),
    [anon_sym_alloca] = ACTIONS(377),
    [anon_sym_load] = ACTIONS(377),
    [anon_sym_store] = ACTIONS(377),
    [anon_sym_cmpxchg] = ACTIONS(377),
    [anon_sym_atomicrmw] = ACTIONS(377),
    [anon_sym_fence] = ACTIONS(377),
    [anon_sym_getelementptr] = ACTIONS(377),
    [anon_sym_extractvalue] = ACTIONS(377),
    [anon_sym_insertvalue] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(377),
    [anon_sym_false] = ACTIONS(377),
    [anon_sym_null] = ACTIONS(377),
    [anon_sym_undef] = ACTIONS(377),
    [anon_sym_poison] = ACTIONS(377),
    [anon_sym_zeroinitializer] = ACTIONS(377),
    [anon_sym_catch] = ACTIONS(377),
    [anon_sym_filter] = ACTIONS(377),
    [anon_sym_blockaddress] = ACTIONS(377),
    [anon_sym_mul] = ACTIONS(377),
    [anon_sym_urem] = ACTIONS(377),
    [anon_sym_srem] = ACTIONS(377),
    [anon_sym_shl] = ACTIONS(377),
    [anon_sym_udiv] = ACTIONS(377),
    [anon_sym_sdiv] = ACTIONS(377),
    [anon_sym_lshr] = ACTIONS(377),
    [anon_sym_ashr] = ACTIONS(377),
    [anon_sym_fmul] = ACTIONS(377),
    [anon_sym_fdiv] = ACTIONS(377),
    [anon_sym_frem] = ACTIONS(377),
    [anon_sym_xchg] = ACTIONS(377),
    [anon_sym_add] = ACTIONS(377),
    [anon_sym_sub] = ACTIONS(377),
    [anon_sym_and] = ACTIONS(377),
    [anon_sym_nand] = ACTIONS(377),
    [anon_sym_or] = ACTIONS(377),
    [anon_sym_xor] = ACTIONS(377),
    [anon_sym_max] = ACTIONS(377),
    [anon_sym_min] = ACTIONS(377),
    [anon_sym_umax] = ACTIONS(377),
    [anon_sym_umin] = ACTIONS(377),
    [anon_sym_fadd] = ACTIONS(377),
    [anon_sym_fsub] = ACTIONS(377),
    [anon_sym_bitcast] = ACTIONS(377),
    [anon_sym_trunc] = ACTIONS(377),
    [anon_sym_zext] = ACTIONS(377),
    [anon_sym_sext] = ACTIONS(377),
    [anon_sym_fptrunc] = ACTIONS(377),
    [anon_sym_fpext] = ACTIONS(377),
    [anon_sym_addrspacecast] = ACTIONS(377),
    [anon_sym_uitofp] = ACTIONS(377),
    [anon_sym_sitofp] = ACTIONS(377),
    [anon_sym_fptoui] = ACTIONS(377),
    [anon_sym_fptosi] = ACTIONS(377),
    [anon_sym_inttoptr] = ACTIONS(377),
    [anon_sym_ptrtoint] = ACTIONS(377),
    [anon_sym_unordered] = ACTIONS(377),
    [anon_sym_monotonic] = ACTIONS(377),
    [anon_sym_acquire] = ACTIONS(377),
    [anon_sym_release] = ACTIONS(377),
    [anon_sym_acq_rel] = ACTIONS(377),
    [anon_sym_seq_cst] = ACTIONS(377),
    [anon_sym_syncscope] = ACTIONS(377),
    [anon_sym_uselistorder] = ACTIONS(377),
  },
  [306] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [sym_label] = ACTIONS(250),
    [sym_string] = ACTIONS(252),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(252),
    [sym_float] = ACTIONS(252),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(252),
    [anon_sym_private] = ACTIONS(252),
    [anon_sym_internal] = ACTIONS(252),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(252),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(252),
    [anon_sym_available_externally] = ACTIONS(252),
    [anon_sym_appending] = ACTIONS(252),
    [anon_sym_common] = ACTIONS(252),
    [anon_sym_extern_weak] = ACTIONS(252),
    [anon_sym_external] = ACTIONS(252),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(252),
    [anon_sym_dso_preemptable] = ACTIONS(252),
    [anon_sym_default] = ACTIONS(252),
    [anon_sym_hidden] = ACTIONS(252),
    [anon_sym_protected] = ACTIONS(252),
    [anon_sym_dllimport] = ACTIONS(252),
    [anon_sym_dllexport] = ACTIONS(252),
    [anon_sym_STAR] = ACTIONS(250),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(252),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_none] = ACTIONS(252),
    [anon_sym_unreachable] = ACTIONS(252),
    [anon_sym_ret] = ACTIONS(252),
    [anon_sym_br] = ACTIONS(252),
    [anon_sym_resume] = ACTIONS(252),
    [anon_sym_freeze] = ACTIONS(252),
    [anon_sym_indirectbr] = ACTIONS(252),
    [anon_sym_extractelement] = ACTIONS(252),
    [anon_sym_insertelement] = ACTIONS(252),
    [anon_sym_select] = ACTIONS(252),
    [anon_sym_shufflevector] = ACTIONS(252),
    [anon_sym_fneg] = ACTIONS(252),
    [anon_sym_switch] = ACTIONS(252),
    [anon_sym_invoke] = ACTIONS(252),
    [anon_sym_cleanupret] = ACTIONS(252),
    [anon_sym_catchret] = ACTIONS(252),
    [anon_sym_catchswitch] = ACTIONS(252),
    [anon_sym_catchpad] = ACTIONS(252),
    [anon_sym_cleanuppad] = ACTIONS(252),
    [anon_sym_callbr] = ACTIONS(252),
    [anon_sym_icmp] = ACTIONS(252),
    [anon_sym_fcmp] = ACTIONS(252),
    [anon_sym_va_arg] = ACTIONS(252),
    [anon_sym_phi] = ACTIONS(252),
    [anon_sym_landingpad] = ACTIONS(252),
    [anon_sym_tail] = ACTIONS(252),
    [anon_sym_musttail] = ACTIONS(252),
    [anon_sym_notail] = ACTIONS(252),
    [anon_sym_call] = ACTIONS(252),
    [anon_sym_alloca] = ACTIONS(252),
    [anon_sym_load] = ACTIONS(252),
    [anon_sym_store] = ACTIONS(252),
    [anon_sym_cmpxchg] = ACTIONS(252),
    [anon_sym_atomicrmw] = ACTIONS(252),
    [anon_sym_fence] = ACTIONS(252),
    [anon_sym_getelementptr] = ACTIONS(252),
    [anon_sym_extractvalue] = ACTIONS(252),
    [anon_sym_insertvalue] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(252),
    [anon_sym_false] = ACTIONS(252),
    [anon_sym_null] = ACTIONS(252),
    [anon_sym_undef] = ACTIONS(252),
    [anon_sym_poison] = ACTIONS(252),
    [anon_sym_zeroinitializer] = ACTIONS(252),
    [anon_sym_catch] = ACTIONS(252),
    [anon_sym_filter] = ACTIONS(252),
    [anon_sym_blockaddress] = ACTIONS(252),
    [anon_sym_mul] = ACTIONS(252),
    [anon_sym_urem] = ACTIONS(252),
    [anon_sym_srem] = ACTIONS(252),
    [anon_sym_shl] = ACTIONS(252),
    [anon_sym_udiv] = ACTIONS(252),
    [anon_sym_sdiv] = ACTIONS(252),
    [anon_sym_lshr] = ACTIONS(252),
    [anon_sym_ashr] = ACTIONS(252),
    [anon_sym_fmul] = ACTIONS(252),
    [anon_sym_fdiv] = ACTIONS(252),
    [anon_sym_frem] = ACTIONS(252),
    [anon_sym_xchg] = ACTIONS(252),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(252),
    [anon_sym_and] = ACTIONS(252),
    [anon_sym_nand] = ACTIONS(252),
    [anon_sym_or] = ACTIONS(252),
    [anon_sym_xor] = ACTIONS(252),
    [anon_sym_max] = ACTIONS(252),
    [anon_sym_min] = ACTIONS(252),
    [anon_sym_umax] = ACTIONS(252),
    [anon_sym_umin] = ACTIONS(252),
    [anon_sym_fadd] = ACTIONS(252),
    [anon_sym_fsub] = ACTIONS(252),
    [anon_sym_bitcast] = ACTIONS(252),
    [anon_sym_trunc] = ACTIONS(252),
    [anon_sym_zext] = ACTIONS(252),
    [anon_sym_sext] = ACTIONS(252),
    [anon_sym_fptrunc] = ACTIONS(252),
    [anon_sym_fpext] = ACTIONS(252),
    [anon_sym_addrspacecast] = ACTIONS(252),
    [anon_sym_uitofp] = ACTIONS(252),
    [anon_sym_sitofp] = ACTIONS(252),
    [anon_sym_fptoui] = ACTIONS(252),
    [anon_sym_fptosi] = ACTIONS(252),
    [anon_sym_inttoptr] = ACTIONS(252),
    [anon_sym_ptrtoint] = ACTIONS(252),
    [anon_sym_unordered] = ACTIONS(252),
    [anon_sym_monotonic] = ACTIONS(252),
    [anon_sym_acquire] = ACTIONS(252),
    [anon_sym_release] = ACTIONS(252),
    [anon_sym_acq_rel] = ACTIONS(252),
    [anon_sym_seq_cst] = ACTIONS(252),
    [anon_sym_syncscope] = ACTIONS(252),
    [anon_sym_uselistorder] = ACTIONS(252),
  },
  [307] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(363),
    [sym_local_var] = ACTIONS(363),
    [sym_label] = ACTIONS(363),
    [sym_string] = ACTIONS(365),
    [aux_sym_number_token1] = ACTIONS(365),
    [aux_sym_number_token2] = ACTIONS(365),
    [sym_float] = ACTIONS(365),
    [sym_cstring] = ACTIONS(363),
    [anon_sym_no_cfi] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_internal] = ACTIONS(365),
    [anon_sym_weak] = ACTIONS(365),
    [anon_sym_weak_odr] = ACTIONS(365),
    [anon_sym_linkonce] = ACTIONS(365),
    [anon_sym_linkonce_odr] = ACTIONS(365),
    [anon_sym_available_externally] = ACTIONS(365),
    [anon_sym_appending] = ACTIONS(365),
    [anon_sym_common] = ACTIONS(365),
    [anon_sym_extern_weak] = ACTIONS(365),
    [anon_sym_external] = ACTIONS(365),
    [anon_sym_dso_local] = ACTIONS(365),
    [anon_sym_dso_local_equivalent] = ACTIONS(365),
    [anon_sym_dso_preemptable] = ACTIONS(365),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_hidden] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_dllimport] = ACTIONS(365),
    [anon_sym_dllexport] = ACTIONS(365),
    [anon_sym_STAR] = ACTIONS(363),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_LT_LBRACE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_LT] = ACTIONS(365),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_addrspace] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_none] = ACTIONS(365),
    [anon_sym_unreachable] = ACTIONS(365),
    [anon_sym_ret] = ACTIONS(365),
    [anon_sym_br] = ACTIONS(365),
    [anon_sym_resume] = ACTIONS(365),
    [anon_sym_freeze] = ACTIONS(365),
    [anon_sym_indirectbr] = ACTIONS(365),
    [anon_sym_extractelement] = ACTIONS(365),
    [anon_sym_insertelement] = ACTIONS(365),
    [anon_sym_select] = ACTIONS(365),
    [anon_sym_shufflevector] = ACTIONS(365),
    [anon_sym_fneg] = ACTIONS(365),
    [anon_sym_switch] = ACTIONS(365),
    [anon_sym_invoke] = ACTIONS(365),
    [anon_sym_cleanupret] = ACTIONS(365),
    [anon_sym_catchret] = ACTIONS(365),
    [anon_sym_catchswitch] = ACTIONS(365),
    [anon_sym_catchpad] = ACTIONS(365),
    [anon_sym_cleanuppad] = ACTIONS(365),
    [anon_sym_callbr] = ACTIONS(365),
    [anon_sym_icmp] = ACTIONS(365),
    [anon_sym_fcmp] = ACTIONS(365),
    [anon_sym_va_arg] = ACTIONS(365),
    [anon_sym_phi] = ACTIONS(365),
    [anon_sym_landingpad] = ACTIONS(365),
    [anon_sym_tail] = ACTIONS(365),
    [anon_sym_musttail] = ACTIONS(365),
    [anon_sym_notail] = ACTIONS(365),
    [anon_sym_call] = ACTIONS(365),
    [anon_sym_alloca] = ACTIONS(365),
    [anon_sym_load] = ACTIONS(365),
    [anon_sym_store] = ACTIONS(365),
    [anon_sym_cmpxchg] = ACTIONS(365),
    [anon_sym_atomicrmw] = ACTIONS(365),
    [anon_sym_fence] = ACTIONS(365),
    [anon_sym_getelementptr] = ACTIONS(365),
    [anon_sym_extractvalue] = ACTIONS(365),
    [anon_sym_insertvalue] = ACTIONS(365),
    [anon_sym_true] = ACTIONS(365),
    [anon_sym_false] = ACTIONS(365),
    [anon_sym_null] = ACTIONS(365),
    [anon_sym_undef] = ACTIONS(365),
    [anon_sym_poison] = ACTIONS(365),
    [anon_sym_zeroinitializer] = ACTIONS(365),
    [anon_sym_catch] = ACTIONS(365),
    [anon_sym_filter] = ACTIONS(365),
    [anon_sym_blockaddress] = ACTIONS(365),
    [anon_sym_mul] = ACTIONS(365),
    [anon_sym_urem] = ACTIONS(365),
    [anon_sym_srem] = ACTIONS(365),
    [anon_sym_shl] = ACTIONS(365),
    [anon_sym_udiv] = ACTIONS(365),
    [anon_sym_sdiv] = ACTIONS(365),
    [anon_sym_lshr] = ACTIONS(365),
    [anon_sym_ashr] = ACTIONS(365),
    [anon_sym_fmul] = ACTIONS(365),
    [anon_sym_fdiv] = ACTIONS(365),
    [anon_sym_frem] = ACTIONS(365),
    [anon_sym_xchg] = ACTIONS(365),
    [anon_sym_add] = ACTIONS(365),
    [anon_sym_sub] = ACTIONS(365),
    [anon_sym_and] = ACTIONS(365),
    [anon_sym_nand] = ACTIONS(365),
    [anon_sym_or] = ACTIONS(365),
    [anon_sym_xor] = ACTIONS(365),
    [anon_sym_max] = ACTIONS(365),
    [anon_sym_min] = ACTIONS(365),
    [anon_sym_umax] = ACTIONS(365),
    [anon_sym_umin] = ACTIONS(365),
    [anon_sym_fadd] = ACTIONS(365),
    [anon_sym_fsub] = ACTIONS(365),
    [anon_sym_bitcast] = ACTIONS(365),
    [anon_sym_trunc] = ACTIONS(365),
    [anon_sym_zext] = ACTIONS(365),
    [anon_sym_sext] = ACTIONS(365),
    [anon_sym_fptrunc] = ACTIONS(365),
    [anon_sym_fpext] = ACTIONS(365),
    [anon_sym_addrspacecast] = ACTIONS(365),
    [anon_sym_uitofp] = ACTIONS(365),
    [anon_sym_sitofp] = ACTIONS(365),
    [anon_sym_fptoui] = ACTIONS(365),
    [anon_sym_fptosi] = ACTIONS(365),
    [anon_sym_inttoptr] = ACTIONS(365),
    [anon_sym_ptrtoint] = ACTIONS(365),
    [anon_sym_unordered] = ACTIONS(365),
    [anon_sym_monotonic] = ACTIONS(365),
    [anon_sym_acquire] = ACTIONS(365),
    [anon_sym_release] = ACTIONS(365),
    [anon_sym_acq_rel] = ACTIONS(365),
    [anon_sym_seq_cst] = ACTIONS(365),
    [anon_sym_syncscope] = ACTIONS(365),
    [anon_sym_uselistorder] = ACTIONS(365),
  },
  [308] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(279),
    [sym_local_var] = ACTIONS(279),
    [sym_label] = ACTIONS(279),
    [sym_string] = ACTIONS(281),
    [aux_sym_number_token1] = ACTIONS(281),
    [aux_sym_number_token2] = ACTIONS(281),
    [sym_float] = ACTIONS(281),
    [sym_cstring] = ACTIONS(279),
    [anon_sym_no_cfi] = ACTIONS(281),
    [anon_sym_private] = ACTIONS(281),
    [anon_sym_internal] = ACTIONS(281),
    [anon_sym_weak] = ACTIONS(281),
    [anon_sym_weak_odr] = ACTIONS(281),
    [anon_sym_linkonce] = ACTIONS(281),
    [anon_sym_linkonce_odr] = ACTIONS(281),
    [anon_sym_available_externally] = ACTIONS(281),
    [anon_sym_appending] = ACTIONS(281),
    [anon_sym_common] = ACTIONS(281),
    [anon_sym_extern_weak] = ACTIONS(281),
    [anon_sym_external] = ACTIONS(281),
    [anon_sym_dso_local] = ACTIONS(281),
    [anon_sym_dso_local_equivalent] = ACTIONS(281),
    [anon_sym_dso_preemptable] = ACTIONS(281),
    [anon_sym_default] = ACTIONS(281),
    [anon_sym_hidden] = ACTIONS(281),
    [anon_sym_protected] = ACTIONS(281),
    [anon_sym_dllimport] = ACTIONS(281),
    [anon_sym_dllexport] = ACTIONS(281),
    [anon_sym_STAR] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(279),
    [anon_sym_RBRACE] = ACTIONS(279),
    [anon_sym_LT_LBRACE] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(281),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_addrspace] = ACTIONS(281),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_none] = ACTIONS(281),
    [anon_sym_unreachable] = ACTIONS(281),
    [anon_sym_ret] = ACTIONS(281),
    [anon_sym_br] = ACTIONS(281),
    [anon_sym_resume] = ACTIONS(281),
    [anon_sym_freeze] = ACTIONS(281),
    [anon_sym_indirectbr] = ACTIONS(281),
    [anon_sym_extractelement] = ACTIONS(281),
    [anon_sym_insertelement] = ACTIONS(281),
    [anon_sym_select] = ACTIONS(281),
    [anon_sym_shufflevector] = ACTIONS(281),
    [anon_sym_fneg] = ACTIONS(281),
    [anon_sym_switch] = ACTIONS(281),
    [anon_sym_invoke] = ACTIONS(281),
    [anon_sym_cleanupret] = ACTIONS(281),
    [anon_sym_catchret] = ACTIONS(281),
    [anon_sym_catchswitch] = ACTIONS(281),
    [anon_sym_catchpad] = ACTIONS(281),
    [anon_sym_cleanuppad] = ACTIONS(281),
    [anon_sym_callbr] = ACTIONS(281),
    [anon_sym_icmp] = ACTIONS(281),
    [anon_sym_fcmp] = ACTIONS(281),
    [anon_sym_va_arg] = ACTIONS(281),
    [anon_sym_phi] = ACTIONS(281),
    [anon_sym_landingpad] = ACTIONS(281),
    [anon_sym_tail] = ACTIONS(281),
    [anon_sym_musttail] = ACTIONS(281),
    [anon_sym_notail] = ACTIONS(281),
    [anon_sym_call] = ACTIONS(281),
    [anon_sym_alloca] = ACTIONS(281),
    [anon_sym_load] = ACTIONS(281),
    [anon_sym_store] = ACTIONS(281),
    [anon_sym_cmpxchg] = ACTIONS(281),
    [anon_sym_atomicrmw] = ACTIONS(281),
    [anon_sym_fence] = ACTIONS(281),
    [anon_sym_getelementptr] = ACTIONS(281),
    [anon_sym_extractvalue] = ACTIONS(281),
    [anon_sym_insertvalue] = ACTIONS(281),
    [anon_sym_true] = ACTIONS(281),
    [anon_sym_false] = ACTIONS(281),
    [anon_sym_null] = ACTIONS(281),
    [anon_sym_undef] = ACTIONS(281),
    [anon_sym_poison] = ACTIONS(281),
    [anon_sym_zeroinitializer] = ACTIONS(281),
    [anon_sym_catch] = ACTIONS(281),
    [anon_sym_filter] = ACTIONS(281),
    [anon_sym_blockaddress] = ACTIONS(281),
    [anon_sym_mul] = ACTIONS(281),
    [anon_sym_urem] = ACTIONS(281),
    [anon_sym_srem] = ACTIONS(281),
    [anon_sym_shl] = ACTIONS(281),
    [anon_sym_udiv] = ACTIONS(281),
    [anon_sym_sdiv] = ACTIONS(281),
    [anon_sym_lshr] = ACTIONS(281),
    [anon_sym_ashr] = ACTIONS(281),
    [anon_sym_fmul] = ACTIONS(281),
    [anon_sym_fdiv] = ACTIONS(281),
    [anon_sym_frem] = ACTIONS(281),
    [anon_sym_xchg] = ACTIONS(281),
    [anon_sym_add] = ACTIONS(281),
    [anon_sym_sub] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(281),
    [anon_sym_nand] = ACTIONS(281),
    [anon_sym_or] = ACTIONS(281),
    [anon_sym_xor] = ACTIONS(281),
    [anon_sym_max] = ACTIONS(281),
    [anon_sym_min] = ACTIONS(281),
    [anon_sym_umax] = ACTIONS(281),
    [anon_sym_umin] = ACTIONS(281),
    [anon_sym_fadd] = ACTIONS(281),
    [anon_sym_fsub] = ACTIONS(281),
    [anon_sym_bitcast] = ACTIONS(281),
    [anon_sym_trunc] = ACTIONS(281),
    [anon_sym_zext] = ACTIONS(281),
    [anon_sym_sext] = ACTIONS(281),
    [anon_sym_fptrunc] = ACTIONS(281),
    [anon_sym_fpext] = ACTIONS(281),
    [anon_sym_addrspacecast] = ACTIONS(281),
    [anon_sym_uitofp] = ACTIONS(281),
    [anon_sym_sitofp] = ACTIONS(281),
    [anon_sym_fptoui] = ACTIONS(281),
    [anon_sym_fptosi] = ACTIONS(281),
    [anon_sym_inttoptr] = ACTIONS(281),
    [anon_sym_ptrtoint] = ACTIONS(281),
    [anon_sym_unordered] = ACTIONS(281),
    [anon_sym_monotonic] = ACTIONS(281),
    [anon_sym_acquire] = ACTIONS(281),
    [anon_sym_release] = ACTIONS(281),
    [anon_sym_acq_rel] = ACTIONS(281),
    [anon_sym_seq_cst] = ACTIONS(281),
    [anon_sym_syncscope] = ACTIONS(281),
    [anon_sym_uselistorder] = ACTIONS(281),
  },
  [309] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(116),
    [sym_label] = ACTIONS(116),
    [sym_string] = ACTIONS(122),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(122),
    [sym_float] = ACTIONS(122),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(122),
    [anon_sym_private] = ACTIONS(122),
    [anon_sym_internal] = ACTIONS(122),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(122),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(122),
    [anon_sym_available_externally] = ACTIONS(122),
    [anon_sym_appending] = ACTIONS(122),
    [anon_sym_common] = ACTIONS(122),
    [anon_sym_extern_weak] = ACTIONS(122),
    [anon_sym_external] = ACTIONS(122),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(122),
    [anon_sym_dso_preemptable] = ACTIONS(122),
    [anon_sym_default] = ACTIONS(122),
    [anon_sym_hidden] = ACTIONS(122),
    [anon_sym_protected] = ACTIONS(122),
    [anon_sym_dllimport] = ACTIONS(122),
    [anon_sym_dllexport] = ACTIONS(122),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(116),
    [anon_sym_RBRACE] = ACTIONS(116),
    [anon_sym_LT_LBRACE] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(116),
    [anon_sym_LT] = ACTIONS(122),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_none] = ACTIONS(122),
    [anon_sym_unreachable] = ACTIONS(122),
    [anon_sym_ret] = ACTIONS(122),
    [anon_sym_br] = ACTIONS(122),
    [anon_sym_resume] = ACTIONS(122),
    [anon_sym_freeze] = ACTIONS(122),
    [anon_sym_indirectbr] = ACTIONS(122),
    [anon_sym_extractelement] = ACTIONS(122),
    [anon_sym_insertelement] = ACTIONS(122),
    [anon_sym_select] = ACTIONS(122),
    [anon_sym_shufflevector] = ACTIONS(122),
    [anon_sym_fneg] = ACTIONS(122),
    [anon_sym_switch] = ACTIONS(122),
    [anon_sym_invoke] = ACTIONS(122),
    [anon_sym_cleanupret] = ACTIONS(122),
    [anon_sym_catchret] = ACTIONS(122),
    [anon_sym_catchswitch] = ACTIONS(122),
    [anon_sym_catchpad] = ACTIONS(122),
    [anon_sym_cleanuppad] = ACTIONS(122),
    [anon_sym_callbr] = ACTIONS(122),
    [anon_sym_icmp] = ACTIONS(122),
    [anon_sym_fcmp] = ACTIONS(122),
    [anon_sym_va_arg] = ACTIONS(122),
    [anon_sym_phi] = ACTIONS(122),
    [anon_sym_landingpad] = ACTIONS(122),
    [anon_sym_tail] = ACTIONS(122),
    [anon_sym_musttail] = ACTIONS(122),
    [anon_sym_notail] = ACTIONS(122),
    [anon_sym_call] = ACTIONS(122),
    [anon_sym_alloca] = ACTIONS(122),
    [anon_sym_load] = ACTIONS(122),
    [anon_sym_store] = ACTIONS(122),
    [anon_sym_cmpxchg] = ACTIONS(122),
    [anon_sym_atomicrmw] = ACTIONS(122),
    [anon_sym_fence] = ACTIONS(122),
    [anon_sym_getelementptr] = ACTIONS(122),
    [anon_sym_extractvalue] = ACTIONS(122),
    [anon_sym_insertvalue] = ACTIONS(122),
    [anon_sym_true] = ACTIONS(122),
    [anon_sym_false] = ACTIONS(122),
    [anon_sym_null] = ACTIONS(122),
    [anon_sym_undef] = ACTIONS(122),
    [anon_sym_poison] = ACTIONS(122),
    [anon_sym_zeroinitializer] = ACTIONS(122),
    [anon_sym_catch] = ACTIONS(122),
    [anon_sym_filter] = ACTIONS(122),
    [anon_sym_blockaddress] = ACTIONS(122),
    [anon_sym_mul] = ACTIONS(122),
    [anon_sym_urem] = ACTIONS(122),
    [anon_sym_srem] = ACTIONS(122),
    [anon_sym_shl] = ACTIONS(122),
    [anon_sym_udiv] = ACTIONS(122),
    [anon_sym_sdiv] = ACTIONS(122),
    [anon_sym_lshr] = ACTIONS(122),
    [anon_sym_ashr] = ACTIONS(122),
    [anon_sym_fmul] = ACTIONS(122),
    [anon_sym_fdiv] = ACTIONS(122),
    [anon_sym_frem] = ACTIONS(122),
    [anon_sym_xchg] = ACTIONS(122),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(122),
    [anon_sym_and] = ACTIONS(122),
    [anon_sym_nand] = ACTIONS(122),
    [anon_sym_or] = ACTIONS(122),
    [anon_sym_xor] = ACTIONS(122),
    [anon_sym_max] = ACTIONS(122),
    [anon_sym_min] = ACTIONS(122),
    [anon_sym_umax] = ACTIONS(122),
    [anon_sym_umin] = ACTIONS(122),
    [anon_sym_fadd] = ACTIONS(122),
    [anon_sym_fsub] = ACTIONS(122),
    [anon_sym_bitcast] = ACTIONS(122),
    [anon_sym_trunc] = ACTIONS(122),
    [anon_sym_zext] = ACTIONS(122),
    [anon_sym_sext] = ACTIONS(122),
    [anon_sym_fptrunc] = ACTIONS(122),
    [anon_sym_fpext] = ACTIONS(122),
    [anon_sym_addrspacecast] = ACTIONS(122),
    [anon_sym_uitofp] = ACTIONS(122),
    [anon_sym_sitofp] = ACTIONS(122),
    [anon_sym_fptoui] = ACTIONS(122),
    [anon_sym_fptosi] = ACTIONS(122),
    [anon_sym_inttoptr] = ACTIONS(122),
    [anon_sym_ptrtoint] = ACTIONS(122),
    [anon_sym_unordered] = ACTIONS(122),
    [anon_sym_monotonic] = ACTIONS(122),
    [anon_sym_acquire] = ACTIONS(122),
    [anon_sym_release] = ACTIONS(122),
    [anon_sym_acq_rel] = ACTIONS(122),
    [anon_sym_seq_cst] = ACTIONS(122),
    [anon_sym_syncscope] = ACTIONS(122),
    [anon_sym_uselistorder] = ACTIONS(122),
  },
  [310] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(359),
    [sym_local_var] = ACTIONS(359),
    [sym_label] = ACTIONS(359),
    [sym_string] = ACTIONS(361),
    [aux_sym_number_token1] = ACTIONS(361),
    [aux_sym_number_token2] = ACTIONS(361),
    [sym_float] = ACTIONS(361),
    [sym_cstring] = ACTIONS(359),
    [anon_sym_no_cfi] = ACTIONS(361),
    [anon_sym_private] = ACTIONS(361),
    [anon_sym_internal] = ACTIONS(361),
    [anon_sym_weak] = ACTIONS(361),
    [anon_sym_weak_odr] = ACTIONS(361),
    [anon_sym_linkonce] = ACTIONS(361),
    [anon_sym_linkonce_odr] = ACTIONS(361),
    [anon_sym_available_externally] = ACTIONS(361),
    [anon_sym_appending] = ACTIONS(361),
    [anon_sym_common] = ACTIONS(361),
    [anon_sym_extern_weak] = ACTIONS(361),
    [anon_sym_external] = ACTIONS(361),
    [anon_sym_dso_local] = ACTIONS(361),
    [anon_sym_dso_local_equivalent] = ACTIONS(361),
    [anon_sym_dso_preemptable] = ACTIONS(361),
    [anon_sym_default] = ACTIONS(361),
    [anon_sym_hidden] = ACTIONS(361),
    [anon_sym_protected] = ACTIONS(361),
    [anon_sym_dllimport] = ACTIONS(361),
    [anon_sym_dllexport] = ACTIONS(361),
    [anon_sym_STAR] = ACTIONS(359),
    [anon_sym_LBRACE] = ACTIONS(359),
    [anon_sym_RBRACE] = ACTIONS(359),
    [anon_sym_LT_LBRACE] = ACTIONS(359),
    [anon_sym_LBRACK] = ACTIONS(359),
    [anon_sym_LT] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(359),
    [anon_sym_addrspace] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(359),
    [anon_sym_none] = ACTIONS(361),
    [anon_sym_unreachable] = ACTIONS(361),
    [anon_sym_ret] = ACTIONS(361),
    [anon_sym_br] = ACTIONS(361),
    [anon_sym_resume] = ACTIONS(361),
    [anon_sym_freeze] = ACTIONS(361),
    [anon_sym_indirectbr] = ACTIONS(361),
    [anon_sym_extractelement] = ACTIONS(361),
    [anon_sym_insertelement] = ACTIONS(361),
    [anon_sym_select] = ACTIONS(361),
    [anon_sym_shufflevector] = ACTIONS(361),
    [anon_sym_fneg] = ACTIONS(361),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_invoke] = ACTIONS(361),
    [anon_sym_cleanupret] = ACTIONS(361),
    [anon_sym_catchret] = ACTIONS(361),
    [anon_sym_catchswitch] = ACTIONS(361),
    [anon_sym_catchpad] = ACTIONS(361),
    [anon_sym_cleanuppad] = ACTIONS(361),
    [anon_sym_callbr] = ACTIONS(361),
    [anon_sym_icmp] = ACTIONS(361),
    [anon_sym_fcmp] = ACTIONS(361),
    [anon_sym_va_arg] = ACTIONS(361),
    [anon_sym_phi] = ACTIONS(361),
    [anon_sym_landingpad] = ACTIONS(361),
    [anon_sym_tail] = ACTIONS(361),
    [anon_sym_musttail] = ACTIONS(361),
    [anon_sym_notail] = ACTIONS(361),
    [anon_sym_call] = ACTIONS(361),
    [anon_sym_alloca] = ACTIONS(361),
    [anon_sym_load] = ACTIONS(361),
    [anon_sym_store] = ACTIONS(361),
    [anon_sym_cmpxchg] = ACTIONS(361),
    [anon_sym_atomicrmw] = ACTIONS(361),
    [anon_sym_fence] = ACTIONS(361),
    [anon_sym_getelementptr] = ACTIONS(361),
    [anon_sym_extractvalue] = ACTIONS(361),
    [anon_sym_insertvalue] = ACTIONS(361),
    [anon_sym_true] = ACTIONS(361),
    [anon_sym_false] = ACTIONS(361),
    [anon_sym_null] = ACTIONS(361),
    [anon_sym_undef] = ACTIONS(361),
    [anon_sym_poison] = ACTIONS(361),
    [anon_sym_zeroinitializer] = ACTIONS(361),
    [anon_sym_catch] = ACTIONS(361),
    [anon_sym_filter] = ACTIONS(361),
    [anon_sym_blockaddress] = ACTIONS(361),
    [anon_sym_mul] = ACTIONS(361),
    [anon_sym_urem] = ACTIONS(361),
    [anon_sym_srem] = ACTIONS(361),
    [anon_sym_shl] = ACTIONS(361),
    [anon_sym_udiv] = ACTIONS(361),
    [anon_sym_sdiv] = ACTIONS(361),
    [anon_sym_lshr] = ACTIONS(361),
    [anon_sym_ashr] = ACTIONS(361),
    [anon_sym_fmul] = ACTIONS(361),
    [anon_sym_fdiv] = ACTIONS(361),
    [anon_sym_frem] = ACTIONS(361),
    [anon_sym_xchg] = ACTIONS(361),
    [anon_sym_add] = ACTIONS(361),
    [anon_sym_sub] = ACTIONS(361),
    [anon_sym_and] = ACTIONS(361),
    [anon_sym_nand] = ACTIONS(361),
    [anon_sym_or] = ACTIONS(361),
    [anon_sym_xor] = ACTIONS(361),
    [anon_sym_max] = ACTIONS(361),
    [anon_sym_min] = ACTIONS(361),
    [anon_sym_umax] = ACTIONS(361),
    [anon_sym_umin] = ACTIONS(361),
    [anon_sym_fadd] = ACTIONS(361),
    [anon_sym_fsub] = ACTIONS(361),
    [anon_sym_bitcast] = ACTIONS(361),
    [anon_sym_trunc] = ACTIONS(361),
    [anon_sym_zext] = ACTIONS(361),
    [anon_sym_sext] = ACTIONS(361),
    [anon_sym_fptrunc] = ACTIONS(361),
    [anon_sym_fpext] = ACTIONS(361),
    [anon_sym_addrspacecast] = ACTIONS(361),
    [anon_sym_uitofp] = ACTIONS(361),
    [anon_sym_sitofp] = ACTIONS(361),
    [anon_sym_fptoui] = ACTIONS(361),
    [anon_sym_fptosi] = ACTIONS(361),
    [anon_sym_inttoptr] = ACTIONS(361),
    [anon_sym_ptrtoint] = ACTIONS(361),
    [anon_sym_unordered] = ACTIONS(361),
    [anon_sym_monotonic] = ACTIONS(361),
    [anon_sym_acquire] = ACTIONS(361),
    [anon_sym_release] = ACTIONS(361),
    [anon_sym_acq_rel] = ACTIONS(361),
    [anon_sym_seq_cst] = ACTIONS(361),
    [anon_sym_syncscope] = ACTIONS(361),
    [anon_sym_uselistorder] = ACTIONS(361),
  },
  [311] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(383),
    [sym_local_var] = ACTIONS(383),
    [sym_label] = ACTIONS(383),
    [sym_string] = ACTIONS(385),
    [aux_sym_number_token1] = ACTIONS(385),
    [aux_sym_number_token2] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [sym_cstring] = ACTIONS(383),
    [anon_sym_no_cfi] = ACTIONS(385),
    [anon_sym_private] = ACTIONS(385),
    [anon_sym_internal] = ACTIONS(385),
    [anon_sym_weak] = ACTIONS(385),
    [anon_sym_weak_odr] = ACTIONS(385),
    [anon_sym_linkonce] = ACTIONS(385),
    [anon_sym_linkonce_odr] = ACTIONS(385),
    [anon_sym_available_externally] = ACTIONS(385),
    [anon_sym_appending] = ACTIONS(385),
    [anon_sym_common] = ACTIONS(385),
    [anon_sym_extern_weak] = ACTIONS(385),
    [anon_sym_external] = ACTIONS(385),
    [anon_sym_dso_local] = ACTIONS(385),
    [anon_sym_dso_local_equivalent] = ACTIONS(385),
    [anon_sym_dso_preemptable] = ACTIONS(385),
    [anon_sym_default] = ACTIONS(385),
    [anon_sym_hidden] = ACTIONS(385),
    [anon_sym_protected] = ACTIONS(385),
    [anon_sym_dllimport] = ACTIONS(385),
    [anon_sym_dllexport] = ACTIONS(385),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_LBRACE] = ACTIONS(383),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_LT_LBRACE] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_addrspace] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_none] = ACTIONS(385),
    [anon_sym_unreachable] = ACTIONS(385),
    [anon_sym_ret] = ACTIONS(385),
    [anon_sym_br] = ACTIONS(385),
    [anon_sym_resume] = ACTIONS(385),
    [anon_sym_freeze] = ACTIONS(385),
    [anon_sym_indirectbr] = ACTIONS(385),
    [anon_sym_extractelement] = ACTIONS(385),
    [anon_sym_insertelement] = ACTIONS(385),
    [anon_sym_select] = ACTIONS(385),
    [anon_sym_shufflevector] = ACTIONS(385),
    [anon_sym_fneg] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(385),
    [anon_sym_invoke] = ACTIONS(385),
    [anon_sym_cleanupret] = ACTIONS(385),
    [anon_sym_catchret] = ACTIONS(385),
    [anon_sym_catchswitch] = ACTIONS(385),
    [anon_sym_catchpad] = ACTIONS(385),
    [anon_sym_cleanuppad] = ACTIONS(385),
    [anon_sym_callbr] = ACTIONS(385),
    [anon_sym_icmp] = ACTIONS(385),
    [anon_sym_fcmp] = ACTIONS(385),
    [anon_sym_va_arg] = ACTIONS(385),
    [anon_sym_phi] = ACTIONS(385),
    [anon_sym_landingpad] = ACTIONS(385),
    [anon_sym_tail] = ACTIONS(385),
    [anon_sym_musttail] = ACTIONS(385),
    [anon_sym_notail] = ACTIONS(385),
    [anon_sym_call] = ACTIONS(385),
    [anon_sym_alloca] = ACTIONS(385),
    [anon_sym_load] = ACTIONS(385),
    [anon_sym_store] = ACTIONS(385),
    [anon_sym_cmpxchg] = ACTIONS(385),
    [anon_sym_atomicrmw] = ACTIONS(385),
    [anon_sym_fence] = ACTIONS(385),
    [anon_sym_getelementptr] = ACTIONS(385),
    [anon_sym_extractvalue] = ACTIONS(385),
    [anon_sym_insertvalue] = ACTIONS(385),
    [anon_sym_true] = ACTIONS(385),
    [anon_sym_false] = ACTIONS(385),
    [anon_sym_null] = ACTIONS(385),
    [anon_sym_undef] = ACTIONS(385),
    [anon_sym_poison] = ACTIONS(385),
    [anon_sym_zeroinitializer] = ACTIONS(385),
    [anon_sym_catch] = ACTIONS(385),
    [anon_sym_filter] = ACTIONS(385),
    [anon_sym_blockaddress] = ACTIONS(385),
    [anon_sym_mul] = ACTIONS(385),
    [anon_sym_urem] = ACTIONS(385),
    [anon_sym_srem] = ACTIONS(385),
    [anon_sym_shl] = ACTIONS(385),
    [anon_sym_udiv] = ACTIONS(385),
    [anon_sym_sdiv] = ACTIONS(385),
    [anon_sym_lshr] = ACTIONS(385),
    [anon_sym_ashr] = ACTIONS(385),
    [anon_sym_fmul] = ACTIONS(385),
    [anon_sym_fdiv] = ACTIONS(385),
    [anon_sym_frem] = ACTIONS(385),
    [anon_sym_xchg] = ACTIONS(385),
    [anon_sym_add] = ACTIONS(385),
    [anon_sym_sub] = ACTIONS(385),
    [anon_sym_and] = ACTIONS(385),
    [anon_sym_nand] = ACTIONS(385),
    [anon_sym_or] = ACTIONS(385),
    [anon_sym_xor] = ACTIONS(385),
    [anon_sym_max] = ACTIONS(385),
    [anon_sym_min] = ACTIONS(385),
    [anon_sym_umax] = ACTIONS(385),
    [anon_sym_umin] = ACTIONS(385),
    [anon_sym_fadd] = ACTIONS(385),
    [anon_sym_fsub] = ACTIONS(385),
    [anon_sym_bitcast] = ACTIONS(385),
    [anon_sym_trunc] = ACTIONS(385),
    [anon_sym_zext] = ACTIONS(385),
    [anon_sym_sext] = ACTIONS(385),
    [anon_sym_fptrunc] = ACTIONS(385),
    [anon_sym_fpext] = ACTIONS(385),
    [anon_sym_addrspacecast] = ACTIONS(385),
    [anon_sym_uitofp] = ACTIONS(385),
    [anon_sym_sitofp] = ACTIONS(385),
    [anon_sym_fptoui] = ACTIONS(385),
    [anon_sym_fptosi] = ACTIONS(385),
    [anon_sym_inttoptr] = ACTIONS(385),
    [anon_sym_ptrtoint] = ACTIONS(385),
    [anon_sym_unordered] = ACTIONS(385),
    [anon_sym_monotonic] = ACTIONS(385),
    [anon_sym_acquire] = ACTIONS(385),
    [anon_sym_release] = ACTIONS(385),
    [anon_sym_acq_rel] = ACTIONS(385),
    [anon_sym_seq_cst] = ACTIONS(385),
    [anon_sym_syncscope] = ACTIONS(385),
    [anon_sym_uselistorder] = ACTIONS(385),
  },
  [312] = {
    [ts_builtin_sym_end] = ACTIONS(619),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(619),
    [sym_comdat_ref] = ACTIONS(619),
    [sym_global_var] = ACTIONS(619),
    [sym_local_var] = ACTIONS(619),
    [aux_sym_metadata_ref_token1] = ACTIONS(619),
    [sym_summary_ref] = ACTIONS(619),
    [sym_string] = ACTIONS(619),
    [anon_sym_target] = ACTIONS(619),
    [anon_sym_source_filename] = ACTIONS(619),
    [anon_sym_declare] = ACTIONS(619),
    [anon_sym_define] = ACTIONS(619),
    [anon_sym_void] = ACTIONS(619),
    [anon_sym_half] = ACTIONS(619),
    [anon_sym_bfloat] = ACTIONS(619),
    [anon_sym_float] = ACTIONS(619),
    [anon_sym_double] = ACTIONS(619),
    [anon_sym_x86_fp80] = ACTIONS(619),
    [anon_sym_fp128] = ACTIONS(619),
    [anon_sym_ppc_fp128] = ACTIONS(619),
    [anon_sym_label] = ACTIONS(619),
    [anon_sym_metadata] = ACTIONS(619),
    [anon_sym_x86_mmx] = ACTIONS(619),
    [anon_sym_x86_amx] = ACTIONS(619),
    [anon_sym_token] = ACTIONS(619),
    [anon_sym_opaque] = ACTIONS(619),
    [anon_sym_ptr] = ACTIONS(619),
    [aux_sym_type_keyword_token1] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(619),
    [anon_sym_LT_LBRACE] = ACTIONS(619),
    [anon_sym_LBRACK] = ACTIONS(619),
    [anon_sym_RBRACK] = ACTIONS(619),
    [anon_sym_LT] = ACTIONS(621),
    [anon_sym_COMMA] = ACTIONS(619),
    [anon_sym_align] = ACTIONS(621),
    [anon_sym_section] = ACTIONS(619),
    [anon_sym_partition] = ACTIONS(619),
    [anon_sym_comdat] = ACTIONS(619),
    [anon_sym_gc] = ACTIONS(619),
    [anon_sym_prefix] = ACTIONS(619),
    [anon_sym_prologue] = ACTIONS(619),
    [anon_sym_personality] = ACTIONS(619),
    [anon_sym_alignstack] = ACTIONS(619),
    [anon_sym_allocsize] = ACTIONS(619),
    [anon_sym_alwaysinline] = ACTIONS(619),
    [anon_sym_builtin] = ACTIONS(619),
    [anon_sym_cold] = ACTIONS(619),
    [anon_sym_convergent] = ACTIONS(619),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(619),
    [anon_sym_hot] = ACTIONS(619),
    [anon_sym_inaccessiblememonly] = ACTIONS(619),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(619),
    [anon_sym_inlinehint] = ACTIONS(619),
    [anon_sym_jumptable] = ACTIONS(619),
    [anon_sym_minsize] = ACTIONS(619),
    [anon_sym_naked] = ACTIONS(619),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(619),
    [anon_sym_nobuiltin] = ACTIONS(619),
    [anon_sym_noduplicate] = ACTIONS(619),
    [anon_sym_nofree] = ACTIONS(619),
    [anon_sym_noimplicitfloat] = ACTIONS(619),
    [anon_sym_noinline] = ACTIONS(619),
    [anon_sym_nomerge] = ACTIONS(619),
    [anon_sym_nonlazybind] = ACTIONS(619),
    [anon_sym_noprofile] = ACTIONS(619),
    [anon_sym_noredzone] = ACTIONS(619),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(619),
    [anon_sym_noreturn] = ACTIONS(619),
    [anon_sym_norecurse] = ACTIONS(619),
    [anon_sym_willreturn] = ACTIONS(619),
    [anon_sym_nosync] = ACTIONS(619),
    [anon_sym_nounwind] = ACTIONS(619),
    [anon_sym_nocallback] = ACTIONS(619),
    [anon_sym_nosanitize_coverage] = ACTIONS(619),
    [anon_sym_null_pointer_is_valid] = ACTIONS(619),
    [anon_sym_optforfuzzing] = ACTIONS(619),
    [anon_sym_optnone] = ACTIONS(619),
    [anon_sym_optsize] = ACTIONS(619),
    [anon_sym_readnone] = ACTIONS(619),
    [anon_sym_readonly] = ACTIONS(619),
    [anon_sym_writeonly] = ACTIONS(619),
    [anon_sym_argmemonly] = ACTIONS(619),
    [anon_sym_returns_twice] = ACTIONS(619),
    [anon_sym_safestack] = ACTIONS(619),
    [anon_sym_sanitize_address] = ACTIONS(619),
    [anon_sym_sanitize_memory] = ACTIONS(619),
    [anon_sym_sanitize_thread] = ACTIONS(619),
    [anon_sym_sanitize_hwaddress] = ACTIONS(619),
    [anon_sym_sanitize_memtag] = ACTIONS(619),
    [anon_sym_speculative_load_hardening] = ACTIONS(619),
    [anon_sym_speculatable] = ACTIONS(619),
    [anon_sym_ssp] = ACTIONS(621),
    [anon_sym_sspstrong] = ACTIONS(619),
    [anon_sym_sspreq] = ACTIONS(619),
    [anon_sym_strictfp] = ACTIONS(619),
    [anon_sym_nocf_check] = ACTIONS(619),
    [anon_sym_shadowcallstack] = ACTIONS(619),
    [anon_sym_mustprogress] = ACTIONS(619),
    [anon_sym_vscale_range] = ACTIONS(619),
    [anon_sym_preallocated] = ACTIONS(619),
    [anon_sym_zeroext] = ACTIONS(619),
    [anon_sym_signext] = ACTIONS(619),
    [anon_sym_inreg] = ACTIONS(619),
    [anon_sym_byval] = ACTIONS(619),
    [anon_sym_byref] = ACTIONS(619),
    [anon_sym_inalloca] = ACTIONS(619),
    [anon_sym_sret] = ACTIONS(619),
    [anon_sym_elementtype] = ACTIONS(619),
    [anon_sym_noalias] = ACTIONS(619),
    [anon_sym_nocapture] = ACTIONS(619),
    [anon_sym_nest] = ACTIONS(619),
    [anon_sym_returned] = ACTIONS(619),
    [anon_sym_nonnull] = ACTIONS(619),
    [anon_sym_dereferenceable] = ACTIONS(621),
    [anon_sym_dereferenceable_or_null] = ACTIONS(619),
    [anon_sym_swiftself] = ACTIONS(619),
    [anon_sym_swiftasync] = ACTIONS(619),
    [anon_sym_swifterror] = ACTIONS(619),
    [anon_sym_immarg] = ACTIONS(619),
    [anon_sym_noundef] = ACTIONS(619),
    [anon_sym_uwtable] = ACTIONS(619),
    [anon_sym_memory] = ACTIONS(619),
    [anon_sym_to] = ACTIONS(621),
    [anon_sym_uselistorder] = ACTIONS(621),
    [anon_sym_uselistorder_bb] = ACTIONS(619),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_attributes] = ACTIONS(619),
  },
  [313] = {
    [ts_builtin_sym_end] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(513),
    [sym_comdat_ref] = ACTIONS(513),
    [sym_global_var] = ACTIONS(513),
    [sym_local_var] = ACTIONS(513),
    [aux_sym_metadata_ref_token1] = ACTIONS(513),
    [sym_summary_ref] = ACTIONS(513),
    [sym_string] = ACTIONS(513),
    [anon_sym_target] = ACTIONS(513),
    [anon_sym_source_filename] = ACTIONS(513),
    [anon_sym_declare] = ACTIONS(513),
    [anon_sym_define] = ACTIONS(513),
    [anon_sym_void] = ACTIONS(513),
    [anon_sym_half] = ACTIONS(513),
    [anon_sym_bfloat] = ACTIONS(513),
    [anon_sym_float] = ACTIONS(513),
    [anon_sym_double] = ACTIONS(513),
    [anon_sym_x86_fp80] = ACTIONS(513),
    [anon_sym_fp128] = ACTIONS(513),
    [anon_sym_ppc_fp128] = ACTIONS(513),
    [anon_sym_label] = ACTIONS(513),
    [anon_sym_metadata] = ACTIONS(513),
    [anon_sym_x86_mmx] = ACTIONS(513),
    [anon_sym_x86_amx] = ACTIONS(513),
    [anon_sym_token] = ACTIONS(513),
    [anon_sym_opaque] = ACTIONS(513),
    [anon_sym_ptr] = ACTIONS(513),
    [aux_sym_type_keyword_token1] = ACTIONS(513),
    [anon_sym_LBRACE] = ACTIONS(513),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_LT_LBRACE] = ACTIONS(513),
    [anon_sym_LBRACK] = ACTIONS(513),
    [anon_sym_RBRACK] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(513),
    [anon_sym_align] = ACTIONS(515),
    [anon_sym_section] = ACTIONS(513),
    [anon_sym_partition] = ACTIONS(513),
    [anon_sym_comdat] = ACTIONS(513),
    [anon_sym_gc] = ACTIONS(513),
    [anon_sym_prefix] = ACTIONS(513),
    [anon_sym_prologue] = ACTIONS(513),
    [anon_sym_personality] = ACTIONS(513),
    [anon_sym_alignstack] = ACTIONS(513),
    [anon_sym_allocsize] = ACTIONS(513),
    [anon_sym_alwaysinline] = ACTIONS(513),
    [anon_sym_builtin] = ACTIONS(513),
    [anon_sym_cold] = ACTIONS(513),
    [anon_sym_convergent] = ACTIONS(513),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(513),
    [anon_sym_hot] = ACTIONS(513),
    [anon_sym_inaccessiblememonly] = ACTIONS(513),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(513),
    [anon_sym_inlinehint] = ACTIONS(513),
    [anon_sym_jumptable] = ACTIONS(513),
    [anon_sym_minsize] = ACTIONS(513),
    [anon_sym_naked] = ACTIONS(513),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(513),
    [anon_sym_nobuiltin] = ACTIONS(513),
    [anon_sym_noduplicate] = ACTIONS(513),
    [anon_sym_nofree] = ACTIONS(513),
    [anon_sym_noimplicitfloat] = ACTIONS(513),
    [anon_sym_noinline] = ACTIONS(513),
    [anon_sym_nomerge] = ACTIONS(513),
    [anon_sym_nonlazybind] = ACTIONS(513),
    [anon_sym_noprofile] = ACTIONS(513),
    [anon_sym_noredzone] = ACTIONS(513),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(513),
    [anon_sym_noreturn] = ACTIONS(513),
    [anon_sym_norecurse] = ACTIONS(513),
    [anon_sym_willreturn] = ACTIONS(513),
    [anon_sym_nosync] = ACTIONS(513),
    [anon_sym_nounwind] = ACTIONS(513),
    [anon_sym_nocallback] = ACTIONS(513),
    [anon_sym_nosanitize_coverage] = ACTIONS(513),
    [anon_sym_null_pointer_is_valid] = ACTIONS(513),
    [anon_sym_optforfuzzing] = ACTIONS(513),
    [anon_sym_optnone] = ACTIONS(513),
    [anon_sym_optsize] = ACTIONS(513),
    [anon_sym_readnone] = ACTIONS(513),
    [anon_sym_readonly] = ACTIONS(513),
    [anon_sym_writeonly] = ACTIONS(513),
    [anon_sym_argmemonly] = ACTIONS(513),
    [anon_sym_returns_twice] = ACTIONS(513),
    [anon_sym_safestack] = ACTIONS(513),
    [anon_sym_sanitize_address] = ACTIONS(513),
    [anon_sym_sanitize_memory] = ACTIONS(513),
    [anon_sym_sanitize_thread] = ACTIONS(513),
    [anon_sym_sanitize_hwaddress] = ACTIONS(513),
    [anon_sym_sanitize_memtag] = ACTIONS(513),
    [anon_sym_speculative_load_hardening] = ACTIONS(513),
    [anon_sym_speculatable] = ACTIONS(513),
    [anon_sym_ssp] = ACTIONS(515),
    [anon_sym_sspstrong] = ACTIONS(513),
    [anon_sym_sspreq] = ACTIONS(513),
    [anon_sym_strictfp] = ACTIONS(513),
    [anon_sym_nocf_check] = ACTIONS(513),
    [anon_sym_shadowcallstack] = ACTIONS(513),
    [anon_sym_mustprogress] = ACTIONS(513),
    [anon_sym_vscale_range] = ACTIONS(513),
    [anon_sym_preallocated] = ACTIONS(513),
    [anon_sym_zeroext] = ACTIONS(513),
    [anon_sym_signext] = ACTIONS(513),
    [anon_sym_inreg] = ACTIONS(513),
    [anon_sym_byval] = ACTIONS(513),
    [anon_sym_byref] = ACTIONS(513),
    [anon_sym_inalloca] = ACTIONS(513),
    [anon_sym_sret] = ACTIONS(513),
    [anon_sym_elementtype] = ACTIONS(513),
    [anon_sym_noalias] = ACTIONS(513),
    [anon_sym_nocapture] = ACTIONS(513),
    [anon_sym_nest] = ACTIONS(513),
    [anon_sym_returned] = ACTIONS(513),
    [anon_sym_nonnull] = ACTIONS(513),
    [anon_sym_dereferenceable] = ACTIONS(515),
    [anon_sym_dereferenceable_or_null] = ACTIONS(513),
    [anon_sym_swiftself] = ACTIONS(513),
    [anon_sym_swiftasync] = ACTIONS(513),
    [anon_sym_swifterror] = ACTIONS(513),
    [anon_sym_immarg] = ACTIONS(513),
    [anon_sym_noundef] = ACTIONS(513),
    [anon_sym_uwtable] = ACTIONS(513),
    [anon_sym_memory] = ACTIONS(513),
    [anon_sym_to] = ACTIONS(515),
    [anon_sym_uselistorder] = ACTIONS(515),
    [anon_sym_uselistorder_bb] = ACTIONS(513),
    [anon_sym_module] = ACTIONS(513),
    [anon_sym_attributes] = ACTIONS(513),
  },
  [314] = {
    [ts_builtin_sym_end] = ACTIONS(557),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(557),
    [sym_comdat_ref] = ACTIONS(557),
    [sym_global_var] = ACTIONS(557),
    [sym_local_var] = ACTIONS(557),
    [aux_sym_metadata_ref_token1] = ACTIONS(557),
    [sym_summary_ref] = ACTIONS(557),
    [sym_string] = ACTIONS(557),
    [anon_sym_target] = ACTIONS(557),
    [anon_sym_source_filename] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_define] = ACTIONS(557),
    [anon_sym_void] = ACTIONS(557),
    [anon_sym_half] = ACTIONS(557),
    [anon_sym_bfloat] = ACTIONS(557),
    [anon_sym_float] = ACTIONS(557),
    [anon_sym_double] = ACTIONS(557),
    [anon_sym_x86_fp80] = ACTIONS(557),
    [anon_sym_fp128] = ACTIONS(557),
    [anon_sym_ppc_fp128] = ACTIONS(557),
    [anon_sym_label] = ACTIONS(557),
    [anon_sym_metadata] = ACTIONS(557),
    [anon_sym_x86_mmx] = ACTIONS(557),
    [anon_sym_x86_amx] = ACTIONS(557),
    [anon_sym_token] = ACTIONS(557),
    [anon_sym_opaque] = ACTIONS(557),
    [anon_sym_ptr] = ACTIONS(557),
    [aux_sym_type_keyword_token1] = ACTIONS(557),
    [anon_sym_LBRACE] = ACTIONS(557),
    [anon_sym_RBRACE] = ACTIONS(557),
    [anon_sym_LT_LBRACE] = ACTIONS(557),
    [anon_sym_LBRACK] = ACTIONS(557),
    [anon_sym_RBRACK] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_COMMA] = ACTIONS(557),
    [anon_sym_align] = ACTIONS(559),
    [anon_sym_section] = ACTIONS(557),
    [anon_sym_partition] = ACTIONS(557),
    [anon_sym_comdat] = ACTIONS(557),
    [anon_sym_gc] = ACTIONS(557),
    [anon_sym_prefix] = ACTIONS(557),
    [anon_sym_prologue] = ACTIONS(557),
    [anon_sym_personality] = ACTIONS(557),
    [anon_sym_alignstack] = ACTIONS(557),
    [anon_sym_allocsize] = ACTIONS(557),
    [anon_sym_alwaysinline] = ACTIONS(557),
    [anon_sym_builtin] = ACTIONS(557),
    [anon_sym_cold] = ACTIONS(557),
    [anon_sym_convergent] = ACTIONS(557),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(557),
    [anon_sym_hot] = ACTIONS(557),
    [anon_sym_inaccessiblememonly] = ACTIONS(557),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(557),
    [anon_sym_inlinehint] = ACTIONS(557),
    [anon_sym_jumptable] = ACTIONS(557),
    [anon_sym_minsize] = ACTIONS(557),
    [anon_sym_naked] = ACTIONS(557),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(557),
    [anon_sym_nobuiltin] = ACTIONS(557),
    [anon_sym_noduplicate] = ACTIONS(557),
    [anon_sym_nofree] = ACTIONS(557),
    [anon_sym_noimplicitfloat] = ACTIONS(557),
    [anon_sym_noinline] = ACTIONS(557),
    [anon_sym_nomerge] = ACTIONS(557),
    [anon_sym_nonlazybind] = ACTIONS(557),
    [anon_sym_noprofile] = ACTIONS(557),
    [anon_sym_noredzone] = ACTIONS(557),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(557),
    [anon_sym_noreturn] = ACTIONS(557),
    [anon_sym_norecurse] = ACTIONS(557),
    [anon_sym_willreturn] = ACTIONS(557),
    [anon_sym_nosync] = ACTIONS(557),
    [anon_sym_nounwind] = ACTIONS(557),
    [anon_sym_nocallback] = ACTIONS(557),
    [anon_sym_nosanitize_coverage] = ACTIONS(557),
    [anon_sym_null_pointer_is_valid] = ACTIONS(557),
    [anon_sym_optforfuzzing] = ACTIONS(557),
    [anon_sym_optnone] = ACTIONS(557),
    [anon_sym_optsize] = ACTIONS(557),
    [anon_sym_readnone] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(557),
    [anon_sym_writeonly] = ACTIONS(557),
    [anon_sym_argmemonly] = ACTIONS(557),
    [anon_sym_returns_twice] = ACTIONS(557),
    [anon_sym_safestack] = ACTIONS(557),
    [anon_sym_sanitize_address] = ACTIONS(557),
    [anon_sym_sanitize_memory] = ACTIONS(557),
    [anon_sym_sanitize_thread] = ACTIONS(557),
    [anon_sym_sanitize_hwaddress] = ACTIONS(557),
    [anon_sym_sanitize_memtag] = ACTIONS(557),
    [anon_sym_speculative_load_hardening] = ACTIONS(557),
    [anon_sym_speculatable] = ACTIONS(557),
    [anon_sym_ssp] = ACTIONS(559),
    [anon_sym_sspstrong] = ACTIONS(557),
    [anon_sym_sspreq] = ACTIONS(557),
    [anon_sym_strictfp] = ACTIONS(557),
    [anon_sym_nocf_check] = ACTIONS(557),
    [anon_sym_shadowcallstack] = ACTIONS(557),
    [anon_sym_mustprogress] = ACTIONS(557),
    [anon_sym_vscale_range] = ACTIONS(557),
    [anon_sym_preallocated] = ACTIONS(557),
    [anon_sym_zeroext] = ACTIONS(557),
    [anon_sym_signext] = ACTIONS(557),
    [anon_sym_inreg] = ACTIONS(557),
    [anon_sym_byval] = ACTIONS(557),
    [anon_sym_byref] = ACTIONS(557),
    [anon_sym_inalloca] = ACTIONS(557),
    [anon_sym_sret] = ACTIONS(557),
    [anon_sym_elementtype] = ACTIONS(557),
    [anon_sym_noalias] = ACTIONS(557),
    [anon_sym_nocapture] = ACTIONS(557),
    [anon_sym_nest] = ACTIONS(557),
    [anon_sym_returned] = ACTIONS(557),
    [anon_sym_nonnull] = ACTIONS(557),
    [anon_sym_dereferenceable] = ACTIONS(559),
    [anon_sym_dereferenceable_or_null] = ACTIONS(557),
    [anon_sym_swiftself] = ACTIONS(557),
    [anon_sym_swiftasync] = ACTIONS(557),
    [anon_sym_swifterror] = ACTIONS(557),
    [anon_sym_immarg] = ACTIONS(557),
    [anon_sym_noundef] = ACTIONS(557),
    [anon_sym_uwtable] = ACTIONS(557),
    [anon_sym_memory] = ACTIONS(557),
    [anon_sym_to] = ACTIONS(559),
    [anon_sym_uselistorder] = ACTIONS(559),
    [anon_sym_uselistorder_bb] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_attributes] = ACTIONS(557),
  },
  [315] = {
    [ts_builtin_sym_end] = ACTIONS(553),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(553),
    [sym_comdat_ref] = ACTIONS(553),
    [sym_global_var] = ACTIONS(553),
    [sym_local_var] = ACTIONS(553),
    [aux_sym_metadata_ref_token1] = ACTIONS(553),
    [sym_summary_ref] = ACTIONS(553),
    [sym_string] = ACTIONS(553),
    [anon_sym_target] = ACTIONS(553),
    [anon_sym_source_filename] = ACTIONS(553),
    [anon_sym_declare] = ACTIONS(553),
    [anon_sym_define] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(553),
    [anon_sym_half] = ACTIONS(553),
    [anon_sym_bfloat] = ACTIONS(553),
    [anon_sym_float] = ACTIONS(553),
    [anon_sym_double] = ACTIONS(553),
    [anon_sym_x86_fp80] = ACTIONS(553),
    [anon_sym_fp128] = ACTIONS(553),
    [anon_sym_ppc_fp128] = ACTIONS(553),
    [anon_sym_label] = ACTIONS(553),
    [anon_sym_metadata] = ACTIONS(553),
    [anon_sym_x86_mmx] = ACTIONS(553),
    [anon_sym_x86_amx] = ACTIONS(553),
    [anon_sym_token] = ACTIONS(553),
    [anon_sym_opaque] = ACTIONS(553),
    [anon_sym_ptr] = ACTIONS(553),
    [aux_sym_type_keyword_token1] = ACTIONS(553),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_RBRACE] = ACTIONS(553),
    [anon_sym_LT_LBRACE] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(553),
    [anon_sym_align] = ACTIONS(555),
    [anon_sym_section] = ACTIONS(553),
    [anon_sym_partition] = ACTIONS(553),
    [anon_sym_comdat] = ACTIONS(553),
    [anon_sym_gc] = ACTIONS(553),
    [anon_sym_prefix] = ACTIONS(553),
    [anon_sym_prologue] = ACTIONS(553),
    [anon_sym_personality] = ACTIONS(553),
    [anon_sym_alignstack] = ACTIONS(553),
    [anon_sym_allocsize] = ACTIONS(553),
    [anon_sym_alwaysinline] = ACTIONS(553),
    [anon_sym_builtin] = ACTIONS(553),
    [anon_sym_cold] = ACTIONS(553),
    [anon_sym_convergent] = ACTIONS(553),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(553),
    [anon_sym_hot] = ACTIONS(553),
    [anon_sym_inaccessiblememonly] = ACTIONS(553),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(553),
    [anon_sym_inlinehint] = ACTIONS(553),
    [anon_sym_jumptable] = ACTIONS(553),
    [anon_sym_minsize] = ACTIONS(553),
    [anon_sym_naked] = ACTIONS(553),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(553),
    [anon_sym_nobuiltin] = ACTIONS(553),
    [anon_sym_noduplicate] = ACTIONS(553),
    [anon_sym_nofree] = ACTIONS(553),
    [anon_sym_noimplicitfloat] = ACTIONS(553),
    [anon_sym_noinline] = ACTIONS(553),
    [anon_sym_nomerge] = ACTIONS(553),
    [anon_sym_nonlazybind] = ACTIONS(553),
    [anon_sym_noprofile] = ACTIONS(553),
    [anon_sym_noredzone] = ACTIONS(553),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(553),
    [anon_sym_noreturn] = ACTIONS(553),
    [anon_sym_norecurse] = ACTIONS(553),
    [anon_sym_willreturn] = ACTIONS(553),
    [anon_sym_nosync] = ACTIONS(553),
    [anon_sym_nounwind] = ACTIONS(553),
    [anon_sym_nocallback] = ACTIONS(553),
    [anon_sym_nosanitize_coverage] = ACTIONS(553),
    [anon_sym_null_pointer_is_valid] = ACTIONS(553),
    [anon_sym_optforfuzzing] = ACTIONS(553),
    [anon_sym_optnone] = ACTIONS(553),
    [anon_sym_optsize] = ACTIONS(553),
    [anon_sym_readnone] = ACTIONS(553),
    [anon_sym_readonly] = ACTIONS(553),
    [anon_sym_writeonly] = ACTIONS(553),
    [anon_sym_argmemonly] = ACTIONS(553),
    [anon_sym_returns_twice] = ACTIONS(553),
    [anon_sym_safestack] = ACTIONS(553),
    [anon_sym_sanitize_address] = ACTIONS(553),
    [anon_sym_sanitize_memory] = ACTIONS(553),
    [anon_sym_sanitize_thread] = ACTIONS(553),
    [anon_sym_sanitize_hwaddress] = ACTIONS(553),
    [anon_sym_sanitize_memtag] = ACTIONS(553),
    [anon_sym_speculative_load_hardening] = ACTIONS(553),
    [anon_sym_speculatable] = ACTIONS(553),
    [anon_sym_ssp] = ACTIONS(555),
    [anon_sym_sspstrong] = ACTIONS(553),
    [anon_sym_sspreq] = ACTIONS(553),
    [anon_sym_strictfp] = ACTIONS(553),
    [anon_sym_nocf_check] = ACTIONS(553),
    [anon_sym_shadowcallstack] = ACTIONS(553),
    [anon_sym_mustprogress] = ACTIONS(553),
    [anon_sym_vscale_range] = ACTIONS(553),
    [anon_sym_preallocated] = ACTIONS(553),
    [anon_sym_zeroext] = ACTIONS(553),
    [anon_sym_signext] = ACTIONS(553),
    [anon_sym_inreg] = ACTIONS(553),
    [anon_sym_byval] = ACTIONS(553),
    [anon_sym_byref] = ACTIONS(553),
    [anon_sym_inalloca] = ACTIONS(553),
    [anon_sym_sret] = ACTIONS(553),
    [anon_sym_elementtype] = ACTIONS(553),
    [anon_sym_noalias] = ACTIONS(553),
    [anon_sym_nocapture] = ACTIONS(553),
    [anon_sym_nest] = ACTIONS(553),
    [anon_sym_returned] = ACTIONS(553),
    [anon_sym_nonnull] = ACTIONS(553),
    [anon_sym_dereferenceable] = ACTIONS(555),
    [anon_sym_dereferenceable_or_null] = ACTIONS(553),
    [anon_sym_swiftself] = ACTIONS(553),
    [anon_sym_swiftasync] = ACTIONS(553),
    [anon_sym_swifterror] = ACTIONS(553),
    [anon_sym_immarg] = ACTIONS(553),
    [anon_sym_noundef] = ACTIONS(553),
    [anon_sym_uwtable] = ACTIONS(553),
    [anon_sym_memory] = ACTIONS(553),
    [anon_sym_to] = ACTIONS(555),
    [anon_sym_uselistorder] = ACTIONS(555),
    [anon_sym_uselistorder_bb] = ACTIONS(553),
    [anon_sym_module] = ACTIONS(553),
    [anon_sym_attributes] = ACTIONS(553),
  },
  [316] = {
    [ts_builtin_sym_end] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(549),
    [sym_comdat_ref] = ACTIONS(549),
    [sym_global_var] = ACTIONS(549),
    [sym_local_var] = ACTIONS(549),
    [aux_sym_metadata_ref_token1] = ACTIONS(549),
    [sym_summary_ref] = ACTIONS(549),
    [sym_string] = ACTIONS(549),
    [anon_sym_target] = ACTIONS(549),
    [anon_sym_source_filename] = ACTIONS(549),
    [anon_sym_declare] = ACTIONS(549),
    [anon_sym_define] = ACTIONS(549),
    [anon_sym_void] = ACTIONS(549),
    [anon_sym_half] = ACTIONS(549),
    [anon_sym_bfloat] = ACTIONS(549),
    [anon_sym_float] = ACTIONS(549),
    [anon_sym_double] = ACTIONS(549),
    [anon_sym_x86_fp80] = ACTIONS(549),
    [anon_sym_fp128] = ACTIONS(549),
    [anon_sym_ppc_fp128] = ACTIONS(549),
    [anon_sym_label] = ACTIONS(549),
    [anon_sym_metadata] = ACTIONS(549),
    [anon_sym_x86_mmx] = ACTIONS(549),
    [anon_sym_x86_amx] = ACTIONS(549),
    [anon_sym_token] = ACTIONS(549),
    [anon_sym_opaque] = ACTIONS(549),
    [anon_sym_ptr] = ACTIONS(549),
    [aux_sym_type_keyword_token1] = ACTIONS(549),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(549),
    [anon_sym_LT_LBRACE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(549),
    [anon_sym_RBRACK] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_align] = ACTIONS(551),
    [anon_sym_section] = ACTIONS(549),
    [anon_sym_partition] = ACTIONS(549),
    [anon_sym_comdat] = ACTIONS(549),
    [anon_sym_gc] = ACTIONS(549),
    [anon_sym_prefix] = ACTIONS(549),
    [anon_sym_prologue] = ACTIONS(549),
    [anon_sym_personality] = ACTIONS(549),
    [anon_sym_alignstack] = ACTIONS(549),
    [anon_sym_allocsize] = ACTIONS(549),
    [anon_sym_alwaysinline] = ACTIONS(549),
    [anon_sym_builtin] = ACTIONS(549),
    [anon_sym_cold] = ACTIONS(549),
    [anon_sym_convergent] = ACTIONS(549),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(549),
    [anon_sym_hot] = ACTIONS(549),
    [anon_sym_inaccessiblememonly] = ACTIONS(549),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(549),
    [anon_sym_inlinehint] = ACTIONS(549),
    [anon_sym_jumptable] = ACTIONS(549),
    [anon_sym_minsize] = ACTIONS(549),
    [anon_sym_naked] = ACTIONS(549),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(549),
    [anon_sym_nobuiltin] = ACTIONS(549),
    [anon_sym_noduplicate] = ACTIONS(549),
    [anon_sym_nofree] = ACTIONS(549),
    [anon_sym_noimplicitfloat] = ACTIONS(549),
    [anon_sym_noinline] = ACTIONS(549),
    [anon_sym_nomerge] = ACTIONS(549),
    [anon_sym_nonlazybind] = ACTIONS(549),
    [anon_sym_noprofile] = ACTIONS(549),
    [anon_sym_noredzone] = ACTIONS(549),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(549),
    [anon_sym_noreturn] = ACTIONS(549),
    [anon_sym_norecurse] = ACTIONS(549),
    [anon_sym_willreturn] = ACTIONS(549),
    [anon_sym_nosync] = ACTIONS(549),
    [anon_sym_nounwind] = ACTIONS(549),
    [anon_sym_nocallback] = ACTIONS(549),
    [anon_sym_nosanitize_coverage] = ACTIONS(549),
    [anon_sym_null_pointer_is_valid] = ACTIONS(549),
    [anon_sym_optforfuzzing] = ACTIONS(549),
    [anon_sym_optnone] = ACTIONS(549),
    [anon_sym_optsize] = ACTIONS(549),
    [anon_sym_readnone] = ACTIONS(549),
    [anon_sym_readonly] = ACTIONS(549),
    [anon_sym_writeonly] = ACTIONS(549),
    [anon_sym_argmemonly] = ACTIONS(549),
    [anon_sym_returns_twice] = ACTIONS(549),
    [anon_sym_safestack] = ACTIONS(549),
    [anon_sym_sanitize_address] = ACTIONS(549),
    [anon_sym_sanitize_memory] = ACTIONS(549),
    [anon_sym_sanitize_thread] = ACTIONS(549),
    [anon_sym_sanitize_hwaddress] = ACTIONS(549),
    [anon_sym_sanitize_memtag] = ACTIONS(549),
    [anon_sym_speculative_load_hardening] = ACTIONS(549),
    [anon_sym_speculatable] = ACTIONS(549),
    [anon_sym_ssp] = ACTIONS(551),
    [anon_sym_sspstrong] = ACTIONS(549),
    [anon_sym_sspreq] = ACTIONS(549),
    [anon_sym_strictfp] = ACTIONS(549),
    [anon_sym_nocf_check] = ACTIONS(549),
    [anon_sym_shadowcallstack] = ACTIONS(549),
    [anon_sym_mustprogress] = ACTIONS(549),
    [anon_sym_vscale_range] = ACTIONS(549),
    [anon_sym_preallocated] = ACTIONS(549),
    [anon_sym_zeroext] = ACTIONS(549),
    [anon_sym_signext] = ACTIONS(549),
    [anon_sym_inreg] = ACTIONS(549),
    [anon_sym_byval] = ACTIONS(549),
    [anon_sym_byref] = ACTIONS(549),
    [anon_sym_inalloca] = ACTIONS(549),
    [anon_sym_sret] = ACTIONS(549),
    [anon_sym_elementtype] = ACTIONS(549),
    [anon_sym_noalias] = ACTIONS(549),
    [anon_sym_nocapture] = ACTIONS(549),
    [anon_sym_nest] = ACTIONS(549),
    [anon_sym_returned] = ACTIONS(549),
    [anon_sym_nonnull] = ACTIONS(549),
    [anon_sym_dereferenceable] = ACTIONS(551),
    [anon_sym_dereferenceable_or_null] = ACTIONS(549),
    [anon_sym_swiftself] = ACTIONS(549),
    [anon_sym_swiftasync] = ACTIONS(549),
    [anon_sym_swifterror] = ACTIONS(549),
    [anon_sym_immarg] = ACTIONS(549),
    [anon_sym_noundef] = ACTIONS(549),
    [anon_sym_uwtable] = ACTIONS(549),
    [anon_sym_memory] = ACTIONS(549),
    [anon_sym_to] = ACTIONS(551),
    [anon_sym_uselistorder] = ACTIONS(551),
    [anon_sym_uselistorder_bb] = ACTIONS(549),
    [anon_sym_module] = ACTIONS(549),
    [anon_sym_attributes] = ACTIONS(549),
  },
  [317] = {
    [ts_builtin_sym_end] = ACTIONS(655),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(655),
    [sym_comdat_ref] = ACTIONS(655),
    [sym_global_var] = ACTIONS(655),
    [sym_local_var] = ACTIONS(655),
    [aux_sym_metadata_ref_token1] = ACTIONS(655),
    [sym_summary_ref] = ACTIONS(655),
    [sym_string] = ACTIONS(655),
    [anon_sym_target] = ACTIONS(655),
    [anon_sym_source_filename] = ACTIONS(655),
    [anon_sym_declare] = ACTIONS(655),
    [anon_sym_define] = ACTIONS(655),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_half] = ACTIONS(655),
    [anon_sym_bfloat] = ACTIONS(655),
    [anon_sym_float] = ACTIONS(655),
    [anon_sym_double] = ACTIONS(655),
    [anon_sym_x86_fp80] = ACTIONS(655),
    [anon_sym_fp128] = ACTIONS(655),
    [anon_sym_ppc_fp128] = ACTIONS(655),
    [anon_sym_label] = ACTIONS(655),
    [anon_sym_metadata] = ACTIONS(655),
    [anon_sym_x86_mmx] = ACTIONS(655),
    [anon_sym_x86_amx] = ACTIONS(655),
    [anon_sym_token] = ACTIONS(655),
    [anon_sym_opaque] = ACTIONS(655),
    [anon_sym_ptr] = ACTIONS(655),
    [aux_sym_type_keyword_token1] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(655),
    [anon_sym_LT_LBRACE] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_RBRACK] = ACTIONS(655),
    [anon_sym_LT] = ACTIONS(657),
    [anon_sym_COMMA] = ACTIONS(655),
    [anon_sym_align] = ACTIONS(657),
    [anon_sym_section] = ACTIONS(655),
    [anon_sym_partition] = ACTIONS(655),
    [anon_sym_comdat] = ACTIONS(655),
    [anon_sym_gc] = ACTIONS(655),
    [anon_sym_prefix] = ACTIONS(655),
    [anon_sym_prologue] = ACTIONS(655),
    [anon_sym_personality] = ACTIONS(655),
    [anon_sym_alignstack] = ACTIONS(655),
    [anon_sym_allocsize] = ACTIONS(655),
    [anon_sym_alwaysinline] = ACTIONS(655),
    [anon_sym_builtin] = ACTIONS(655),
    [anon_sym_cold] = ACTIONS(655),
    [anon_sym_convergent] = ACTIONS(655),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(655),
    [anon_sym_hot] = ACTIONS(655),
    [anon_sym_inaccessiblememonly] = ACTIONS(655),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(655),
    [anon_sym_inlinehint] = ACTIONS(655),
    [anon_sym_jumptable] = ACTIONS(655),
    [anon_sym_minsize] = ACTIONS(655),
    [anon_sym_naked] = ACTIONS(655),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(655),
    [anon_sym_nobuiltin] = ACTIONS(655),
    [anon_sym_noduplicate] = ACTIONS(655),
    [anon_sym_nofree] = ACTIONS(655),
    [anon_sym_noimplicitfloat] = ACTIONS(655),
    [anon_sym_noinline] = ACTIONS(655),
    [anon_sym_nomerge] = ACTIONS(655),
    [anon_sym_nonlazybind] = ACTIONS(655),
    [anon_sym_noprofile] = ACTIONS(655),
    [anon_sym_noredzone] = ACTIONS(655),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(655),
    [anon_sym_noreturn] = ACTIONS(655),
    [anon_sym_norecurse] = ACTIONS(655),
    [anon_sym_willreturn] = ACTIONS(655),
    [anon_sym_nosync] = ACTIONS(655),
    [anon_sym_nounwind] = ACTIONS(655),
    [anon_sym_nocallback] = ACTIONS(655),
    [anon_sym_nosanitize_coverage] = ACTIONS(655),
    [anon_sym_null_pointer_is_valid] = ACTIONS(655),
    [anon_sym_optforfuzzing] = ACTIONS(655),
    [anon_sym_optnone] = ACTIONS(655),
    [anon_sym_optsize] = ACTIONS(655),
    [anon_sym_readnone] = ACTIONS(655),
    [anon_sym_readonly] = ACTIONS(655),
    [anon_sym_writeonly] = ACTIONS(655),
    [anon_sym_argmemonly] = ACTIONS(655),
    [anon_sym_returns_twice] = ACTIONS(655),
    [anon_sym_safestack] = ACTIONS(655),
    [anon_sym_sanitize_address] = ACTIONS(655),
    [anon_sym_sanitize_memory] = ACTIONS(655),
    [anon_sym_sanitize_thread] = ACTIONS(655),
    [anon_sym_sanitize_hwaddress] = ACTIONS(655),
    [anon_sym_sanitize_memtag] = ACTIONS(655),
    [anon_sym_speculative_load_hardening] = ACTIONS(655),
    [anon_sym_speculatable] = ACTIONS(655),
    [anon_sym_ssp] = ACTIONS(657),
    [anon_sym_sspstrong] = ACTIONS(655),
    [anon_sym_sspreq] = ACTIONS(655),
    [anon_sym_strictfp] = ACTIONS(655),
    [anon_sym_nocf_check] = ACTIONS(655),
    [anon_sym_shadowcallstack] = ACTIONS(655),
    [anon_sym_mustprogress] = ACTIONS(655),
    [anon_sym_vscale_range] = ACTIONS(655),
    [anon_sym_preallocated] = ACTIONS(655),
    [anon_sym_zeroext] = ACTIONS(655),
    [anon_sym_signext] = ACTIONS(655),
    [anon_sym_inreg] = ACTIONS(655),
    [anon_sym_byval] = ACTIONS(655),
    [anon_sym_byref] = ACTIONS(655),
    [anon_sym_inalloca] = ACTIONS(655),
    [anon_sym_sret] = ACTIONS(655),
    [anon_sym_elementtype] = ACTIONS(655),
    [anon_sym_noalias] = ACTIONS(655),
    [anon_sym_nocapture] = ACTIONS(655),
    [anon_sym_nest] = ACTIONS(655),
    [anon_sym_returned] = ACTIONS(655),
    [anon_sym_nonnull] = ACTIONS(655),
    [anon_sym_dereferenceable] = ACTIONS(657),
    [anon_sym_dereferenceable_or_null] = ACTIONS(655),
    [anon_sym_swiftself] = ACTIONS(655),
    [anon_sym_swiftasync] = ACTIONS(655),
    [anon_sym_swifterror] = ACTIONS(655),
    [anon_sym_immarg] = ACTIONS(655),
    [anon_sym_noundef] = ACTIONS(655),
    [anon_sym_uwtable] = ACTIONS(655),
    [anon_sym_memory] = ACTIONS(655),
    [anon_sym_to] = ACTIONS(657),
    [anon_sym_uselistorder] = ACTIONS(657),
    [anon_sym_uselistorder_bb] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_attributes] = ACTIONS(655),
  },
  [318] = {
    [ts_builtin_sym_end] = ACTIONS(647),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(647),
    [sym_comdat_ref] = ACTIONS(647),
    [sym_global_var] = ACTIONS(647),
    [sym_local_var] = ACTIONS(647),
    [aux_sym_metadata_ref_token1] = ACTIONS(647),
    [sym_summary_ref] = ACTIONS(647),
    [sym_string] = ACTIONS(647),
    [anon_sym_target] = ACTIONS(647),
    [anon_sym_source_filename] = ACTIONS(647),
    [anon_sym_declare] = ACTIONS(647),
    [anon_sym_define] = ACTIONS(647),
    [anon_sym_void] = ACTIONS(647),
    [anon_sym_half] = ACTIONS(647),
    [anon_sym_bfloat] = ACTIONS(647),
    [anon_sym_float] = ACTIONS(647),
    [anon_sym_double] = ACTIONS(647),
    [anon_sym_x86_fp80] = ACTIONS(647),
    [anon_sym_fp128] = ACTIONS(647),
    [anon_sym_ppc_fp128] = ACTIONS(647),
    [anon_sym_label] = ACTIONS(647),
    [anon_sym_metadata] = ACTIONS(647),
    [anon_sym_x86_mmx] = ACTIONS(647),
    [anon_sym_x86_amx] = ACTIONS(647),
    [anon_sym_token] = ACTIONS(647),
    [anon_sym_opaque] = ACTIONS(647),
    [anon_sym_ptr] = ACTIONS(647),
    [aux_sym_type_keyword_token1] = ACTIONS(647),
    [anon_sym_LBRACE] = ACTIONS(647),
    [anon_sym_RBRACE] = ACTIONS(647),
    [anon_sym_LT_LBRACE] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(647),
    [anon_sym_RBRACK] = ACTIONS(647),
    [anon_sym_LT] = ACTIONS(649),
    [anon_sym_COMMA] = ACTIONS(647),
    [anon_sym_align] = ACTIONS(649),
    [anon_sym_section] = ACTIONS(647),
    [anon_sym_partition] = ACTIONS(647),
    [anon_sym_comdat] = ACTIONS(647),
    [anon_sym_gc] = ACTIONS(647),
    [anon_sym_prefix] = ACTIONS(647),
    [anon_sym_prologue] = ACTIONS(647),
    [anon_sym_personality] = ACTIONS(647),
    [anon_sym_alignstack] = ACTIONS(647),
    [anon_sym_allocsize] = ACTIONS(647),
    [anon_sym_alwaysinline] = ACTIONS(647),
    [anon_sym_builtin] = ACTIONS(647),
    [anon_sym_cold] = ACTIONS(647),
    [anon_sym_convergent] = ACTIONS(647),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(647),
    [anon_sym_hot] = ACTIONS(647),
    [anon_sym_inaccessiblememonly] = ACTIONS(647),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(647),
    [anon_sym_inlinehint] = ACTIONS(647),
    [anon_sym_jumptable] = ACTIONS(647),
    [anon_sym_minsize] = ACTIONS(647),
    [anon_sym_naked] = ACTIONS(647),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(647),
    [anon_sym_nobuiltin] = ACTIONS(647),
    [anon_sym_noduplicate] = ACTIONS(647),
    [anon_sym_nofree] = ACTIONS(647),
    [anon_sym_noimplicitfloat] = ACTIONS(647),
    [anon_sym_noinline] = ACTIONS(647),
    [anon_sym_nomerge] = ACTIONS(647),
    [anon_sym_nonlazybind] = ACTIONS(647),
    [anon_sym_noprofile] = ACTIONS(647),
    [anon_sym_noredzone] = ACTIONS(647),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(647),
    [anon_sym_noreturn] = ACTIONS(647),
    [anon_sym_norecurse] = ACTIONS(647),
    [anon_sym_willreturn] = ACTIONS(647),
    [anon_sym_nosync] = ACTIONS(647),
    [anon_sym_nounwind] = ACTIONS(647),
    [anon_sym_nocallback] = ACTIONS(647),
    [anon_sym_nosanitize_coverage] = ACTIONS(647),
    [anon_sym_null_pointer_is_valid] = ACTIONS(647),
    [anon_sym_optforfuzzing] = ACTIONS(647),
    [anon_sym_optnone] = ACTIONS(647),
    [anon_sym_optsize] = ACTIONS(647),
    [anon_sym_readnone] = ACTIONS(647),
    [anon_sym_readonly] = ACTIONS(647),
    [anon_sym_writeonly] = ACTIONS(647),
    [anon_sym_argmemonly] = ACTIONS(647),
    [anon_sym_returns_twice] = ACTIONS(647),
    [anon_sym_safestack] = ACTIONS(647),
    [anon_sym_sanitize_address] = ACTIONS(647),
    [anon_sym_sanitize_memory] = ACTIONS(647),
    [anon_sym_sanitize_thread] = ACTIONS(647),
    [anon_sym_sanitize_hwaddress] = ACTIONS(647),
    [anon_sym_sanitize_memtag] = ACTIONS(647),
    [anon_sym_speculative_load_hardening] = ACTIONS(647),
    [anon_sym_speculatable] = ACTIONS(647),
    [anon_sym_ssp] = ACTIONS(649),
    [anon_sym_sspstrong] = ACTIONS(647),
    [anon_sym_sspreq] = ACTIONS(647),
    [anon_sym_strictfp] = ACTIONS(647),
    [anon_sym_nocf_check] = ACTIONS(647),
    [anon_sym_shadowcallstack] = ACTIONS(647),
    [anon_sym_mustprogress] = ACTIONS(647),
    [anon_sym_vscale_range] = ACTIONS(647),
    [anon_sym_preallocated] = ACTIONS(647),
    [anon_sym_zeroext] = ACTIONS(647),
    [anon_sym_signext] = ACTIONS(647),
    [anon_sym_inreg] = ACTIONS(647),
    [anon_sym_byval] = ACTIONS(647),
    [anon_sym_byref] = ACTIONS(647),
    [anon_sym_inalloca] = ACTIONS(647),
    [anon_sym_sret] = ACTIONS(647),
    [anon_sym_elementtype] = ACTIONS(647),
    [anon_sym_noalias] = ACTIONS(647),
    [anon_sym_nocapture] = ACTIONS(647),
    [anon_sym_nest] = ACTIONS(647),
    [anon_sym_returned] = ACTIONS(647),
    [anon_sym_nonnull] = ACTIONS(647),
    [anon_sym_dereferenceable] = ACTIONS(649),
    [anon_sym_dereferenceable_or_null] = ACTIONS(647),
    [anon_sym_swiftself] = ACTIONS(647),
    [anon_sym_swiftasync] = ACTIONS(647),
    [anon_sym_swifterror] = ACTIONS(647),
    [anon_sym_immarg] = ACTIONS(647),
    [anon_sym_noundef] = ACTIONS(647),
    [anon_sym_uwtable] = ACTIONS(647),
    [anon_sym_memory] = ACTIONS(647),
    [anon_sym_to] = ACTIONS(649),
    [anon_sym_uselistorder] = ACTIONS(649),
    [anon_sym_uselistorder_bb] = ACTIONS(647),
    [anon_sym_module] = ACTIONS(647),
    [anon_sym_attributes] = ACTIONS(647),
  },
  [319] = {
    [ts_builtin_sym_end] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(643),
    [sym_comdat_ref] = ACTIONS(643),
    [sym_global_var] = ACTIONS(643),
    [sym_local_var] = ACTIONS(643),
    [aux_sym_metadata_ref_token1] = ACTIONS(643),
    [sym_summary_ref] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [anon_sym_target] = ACTIONS(643),
    [anon_sym_source_filename] = ACTIONS(643),
    [anon_sym_declare] = ACTIONS(643),
    [anon_sym_define] = ACTIONS(643),
    [anon_sym_void] = ACTIONS(643),
    [anon_sym_half] = ACTIONS(643),
    [anon_sym_bfloat] = ACTIONS(643),
    [anon_sym_float] = ACTIONS(643),
    [anon_sym_double] = ACTIONS(643),
    [anon_sym_x86_fp80] = ACTIONS(643),
    [anon_sym_fp128] = ACTIONS(643),
    [anon_sym_ppc_fp128] = ACTIONS(643),
    [anon_sym_label] = ACTIONS(643),
    [anon_sym_metadata] = ACTIONS(643),
    [anon_sym_x86_mmx] = ACTIONS(643),
    [anon_sym_x86_amx] = ACTIONS(643),
    [anon_sym_token] = ACTIONS(643),
    [anon_sym_opaque] = ACTIONS(643),
    [anon_sym_ptr] = ACTIONS(643),
    [aux_sym_type_keyword_token1] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(643),
    [anon_sym_RBRACE] = ACTIONS(643),
    [anon_sym_LT_LBRACE] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(643),
    [anon_sym_LT] = ACTIONS(645),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_align] = ACTIONS(645),
    [anon_sym_section] = ACTIONS(643),
    [anon_sym_partition] = ACTIONS(643),
    [anon_sym_comdat] = ACTIONS(643),
    [anon_sym_gc] = ACTIONS(643),
    [anon_sym_prefix] = ACTIONS(643),
    [anon_sym_prologue] = ACTIONS(643),
    [anon_sym_personality] = ACTIONS(643),
    [anon_sym_alignstack] = ACTIONS(643),
    [anon_sym_allocsize] = ACTIONS(643),
    [anon_sym_alwaysinline] = ACTIONS(643),
    [anon_sym_builtin] = ACTIONS(643),
    [anon_sym_cold] = ACTIONS(643),
    [anon_sym_convergent] = ACTIONS(643),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(643),
    [anon_sym_hot] = ACTIONS(643),
    [anon_sym_inaccessiblememonly] = ACTIONS(643),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(643),
    [anon_sym_inlinehint] = ACTIONS(643),
    [anon_sym_jumptable] = ACTIONS(643),
    [anon_sym_minsize] = ACTIONS(643),
    [anon_sym_naked] = ACTIONS(643),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(643),
    [anon_sym_nobuiltin] = ACTIONS(643),
    [anon_sym_noduplicate] = ACTIONS(643),
    [anon_sym_nofree] = ACTIONS(643),
    [anon_sym_noimplicitfloat] = ACTIONS(643),
    [anon_sym_noinline] = ACTIONS(643),
    [anon_sym_nomerge] = ACTIONS(643),
    [anon_sym_nonlazybind] = ACTIONS(643),
    [anon_sym_noprofile] = ACTIONS(643),
    [anon_sym_noredzone] = ACTIONS(643),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(643),
    [anon_sym_noreturn] = ACTIONS(643),
    [anon_sym_norecurse] = ACTIONS(643),
    [anon_sym_willreturn] = ACTIONS(643),
    [anon_sym_nosync] = ACTIONS(643),
    [anon_sym_nounwind] = ACTIONS(643),
    [anon_sym_nocallback] = ACTIONS(643),
    [anon_sym_nosanitize_coverage] = ACTIONS(643),
    [anon_sym_null_pointer_is_valid] = ACTIONS(643),
    [anon_sym_optforfuzzing] = ACTIONS(643),
    [anon_sym_optnone] = ACTIONS(643),
    [anon_sym_optsize] = ACTIONS(643),
    [anon_sym_readnone] = ACTIONS(643),
    [anon_sym_readonly] = ACTIONS(643),
    [anon_sym_writeonly] = ACTIONS(643),
    [anon_sym_argmemonly] = ACTIONS(643),
    [anon_sym_returns_twice] = ACTIONS(643),
    [anon_sym_safestack] = ACTIONS(643),
    [anon_sym_sanitize_address] = ACTIONS(643),
    [anon_sym_sanitize_memory] = ACTIONS(643),
    [anon_sym_sanitize_thread] = ACTIONS(643),
    [anon_sym_sanitize_hwaddress] = ACTIONS(643),
    [anon_sym_sanitize_memtag] = ACTIONS(643),
    [anon_sym_speculative_load_hardening] = ACTIONS(643),
    [anon_sym_speculatable] = ACTIONS(643),
    [anon_sym_ssp] = ACTIONS(645),
    [anon_sym_sspstrong] = ACTIONS(643),
    [anon_sym_sspreq] = ACTIONS(643),
    [anon_sym_strictfp] = ACTIONS(643),
    [anon_sym_nocf_check] = ACTIONS(643),
    [anon_sym_shadowcallstack] = ACTIONS(643),
    [anon_sym_mustprogress] = ACTIONS(643),
    [anon_sym_vscale_range] = ACTIONS(643),
    [anon_sym_preallocated] = ACTIONS(643),
    [anon_sym_zeroext] = ACTIONS(643),
    [anon_sym_signext] = ACTIONS(643),
    [anon_sym_inreg] = ACTIONS(643),
    [anon_sym_byval] = ACTIONS(643),
    [anon_sym_byref] = ACTIONS(643),
    [anon_sym_inalloca] = ACTIONS(643),
    [anon_sym_sret] = ACTIONS(643),
    [anon_sym_elementtype] = ACTIONS(643),
    [anon_sym_noalias] = ACTIONS(643),
    [anon_sym_nocapture] = ACTIONS(643),
    [anon_sym_nest] = ACTIONS(643),
    [anon_sym_returned] = ACTIONS(643),
    [anon_sym_nonnull] = ACTIONS(643),
    [anon_sym_dereferenceable] = ACTIONS(645),
    [anon_sym_dereferenceable_or_null] = ACTIONS(643),
    [anon_sym_swiftself] = ACTIONS(643),
    [anon_sym_swiftasync] = ACTIONS(643),
    [anon_sym_swifterror] = ACTIONS(643),
    [anon_sym_immarg] = ACTIONS(643),
    [anon_sym_noundef] = ACTIONS(643),
    [anon_sym_uwtable] = ACTIONS(643),
    [anon_sym_memory] = ACTIONS(643),
    [anon_sym_to] = ACTIONS(645),
    [anon_sym_uselistorder] = ACTIONS(645),
    [anon_sym_uselistorder_bb] = ACTIONS(643),
    [anon_sym_module] = ACTIONS(643),
    [anon_sym_attributes] = ACTIONS(643),
  },
  [320] = {
    [ts_builtin_sym_end] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(627),
    [sym_comdat_ref] = ACTIONS(627),
    [sym_global_var] = ACTIONS(627),
    [sym_local_var] = ACTIONS(627),
    [aux_sym_metadata_ref_token1] = ACTIONS(627),
    [sym_summary_ref] = ACTIONS(627),
    [sym_string] = ACTIONS(627),
    [anon_sym_target] = ACTIONS(627),
    [anon_sym_source_filename] = ACTIONS(627),
    [anon_sym_declare] = ACTIONS(627),
    [anon_sym_define] = ACTIONS(627),
    [anon_sym_void] = ACTIONS(627),
    [anon_sym_half] = ACTIONS(627),
    [anon_sym_bfloat] = ACTIONS(627),
    [anon_sym_float] = ACTIONS(627),
    [anon_sym_double] = ACTIONS(627),
    [anon_sym_x86_fp80] = ACTIONS(627),
    [anon_sym_fp128] = ACTIONS(627),
    [anon_sym_ppc_fp128] = ACTIONS(627),
    [anon_sym_label] = ACTIONS(627),
    [anon_sym_metadata] = ACTIONS(627),
    [anon_sym_x86_mmx] = ACTIONS(627),
    [anon_sym_x86_amx] = ACTIONS(627),
    [anon_sym_token] = ACTIONS(627),
    [anon_sym_opaque] = ACTIONS(627),
    [anon_sym_ptr] = ACTIONS(627),
    [aux_sym_type_keyword_token1] = ACTIONS(627),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_RBRACE] = ACTIONS(627),
    [anon_sym_LT_LBRACE] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(627),
    [anon_sym_RBRACK] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(629),
    [anon_sym_COMMA] = ACTIONS(627),
    [anon_sym_align] = ACTIONS(629),
    [anon_sym_section] = ACTIONS(627),
    [anon_sym_partition] = ACTIONS(627),
    [anon_sym_comdat] = ACTIONS(627),
    [anon_sym_gc] = ACTIONS(627),
    [anon_sym_prefix] = ACTIONS(627),
    [anon_sym_prologue] = ACTIONS(627),
    [anon_sym_personality] = ACTIONS(627),
    [anon_sym_alignstack] = ACTIONS(627),
    [anon_sym_allocsize] = ACTIONS(627),
    [anon_sym_alwaysinline] = ACTIONS(627),
    [anon_sym_builtin] = ACTIONS(627),
    [anon_sym_cold] = ACTIONS(627),
    [anon_sym_convergent] = ACTIONS(627),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(627),
    [anon_sym_hot] = ACTIONS(627),
    [anon_sym_inaccessiblememonly] = ACTIONS(627),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(627),
    [anon_sym_inlinehint] = ACTIONS(627),
    [anon_sym_jumptable] = ACTIONS(627),
    [anon_sym_minsize] = ACTIONS(627),
    [anon_sym_naked] = ACTIONS(627),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(627),
    [anon_sym_nobuiltin] = ACTIONS(627),
    [anon_sym_noduplicate] = ACTIONS(627),
    [anon_sym_nofree] = ACTIONS(627),
    [anon_sym_noimplicitfloat] = ACTIONS(627),
    [anon_sym_noinline] = ACTIONS(627),
    [anon_sym_nomerge] = ACTIONS(627),
    [anon_sym_nonlazybind] = ACTIONS(627),
    [anon_sym_noprofile] = ACTIONS(627),
    [anon_sym_noredzone] = ACTIONS(627),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(627),
    [anon_sym_noreturn] = ACTIONS(627),
    [anon_sym_norecurse] = ACTIONS(627),
    [anon_sym_willreturn] = ACTIONS(627),
    [anon_sym_nosync] = ACTIONS(627),
    [anon_sym_nounwind] = ACTIONS(627),
    [anon_sym_nocallback] = ACTIONS(627),
    [anon_sym_nosanitize_coverage] = ACTIONS(627),
    [anon_sym_null_pointer_is_valid] = ACTIONS(627),
    [anon_sym_optforfuzzing] = ACTIONS(627),
    [anon_sym_optnone] = ACTIONS(627),
    [anon_sym_optsize] = ACTIONS(627),
    [anon_sym_readnone] = ACTIONS(627),
    [anon_sym_readonly] = ACTIONS(627),
    [anon_sym_writeonly] = ACTIONS(627),
    [anon_sym_argmemonly] = ACTIONS(627),
    [anon_sym_returns_twice] = ACTIONS(627),
    [anon_sym_safestack] = ACTIONS(627),
    [anon_sym_sanitize_address] = ACTIONS(627),
    [anon_sym_sanitize_memory] = ACTIONS(627),
    [anon_sym_sanitize_thread] = ACTIONS(627),
    [anon_sym_sanitize_hwaddress] = ACTIONS(627),
    [anon_sym_sanitize_memtag] = ACTIONS(627),
    [anon_sym_speculative_load_hardening] = ACTIONS(627),
    [anon_sym_speculatable] = ACTIONS(627),
    [anon_sym_ssp] = ACTIONS(629),
    [anon_sym_sspstrong] = ACTIONS(627),
    [anon_sym_sspreq] = ACTIONS(627),
    [anon_sym_strictfp] = ACTIONS(627),
    [anon_sym_nocf_check] = ACTIONS(627),
    [anon_sym_shadowcallstack] = ACTIONS(627),
    [anon_sym_mustprogress] = ACTIONS(627),
    [anon_sym_vscale_range] = ACTIONS(627),
    [anon_sym_preallocated] = ACTIONS(627),
    [anon_sym_zeroext] = ACTIONS(627),
    [anon_sym_signext] = ACTIONS(627),
    [anon_sym_inreg] = ACTIONS(627),
    [anon_sym_byval] = ACTIONS(627),
    [anon_sym_byref] = ACTIONS(627),
    [anon_sym_inalloca] = ACTIONS(627),
    [anon_sym_sret] = ACTIONS(627),
    [anon_sym_elementtype] = ACTIONS(627),
    [anon_sym_noalias] = ACTIONS(627),
    [anon_sym_nocapture] = ACTIONS(627),
    [anon_sym_nest] = ACTIONS(627),
    [anon_sym_returned] = ACTIONS(627),
    [anon_sym_nonnull] = ACTIONS(627),
    [anon_sym_dereferenceable] = ACTIONS(629),
    [anon_sym_dereferenceable_or_null] = ACTIONS(627),
    [anon_sym_swiftself] = ACTIONS(627),
    [anon_sym_swiftasync] = ACTIONS(627),
    [anon_sym_swifterror] = ACTIONS(627),
    [anon_sym_immarg] = ACTIONS(627),
    [anon_sym_noundef] = ACTIONS(627),
    [anon_sym_uwtable] = ACTIONS(627),
    [anon_sym_memory] = ACTIONS(627),
    [anon_sym_to] = ACTIONS(629),
    [anon_sym_uselistorder] = ACTIONS(629),
    [anon_sym_uselistorder_bb] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(627),
    [anon_sym_attributes] = ACTIONS(627),
  },
  [321] = {
    [ts_builtin_sym_end] = ACTIONS(671),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(671),
    [sym_comdat_ref] = ACTIONS(671),
    [sym_global_var] = ACTIONS(671),
    [sym_local_var] = ACTIONS(671),
    [aux_sym_metadata_ref_token1] = ACTIONS(671),
    [sym_summary_ref] = ACTIONS(671),
    [sym_string] = ACTIONS(671),
    [anon_sym_target] = ACTIONS(671),
    [anon_sym_source_filename] = ACTIONS(671),
    [anon_sym_declare] = ACTIONS(671),
    [anon_sym_define] = ACTIONS(671),
    [anon_sym_void] = ACTIONS(671),
    [anon_sym_half] = ACTIONS(671),
    [anon_sym_bfloat] = ACTIONS(671),
    [anon_sym_float] = ACTIONS(671),
    [anon_sym_double] = ACTIONS(671),
    [anon_sym_x86_fp80] = ACTIONS(671),
    [anon_sym_fp128] = ACTIONS(671),
    [anon_sym_ppc_fp128] = ACTIONS(671),
    [anon_sym_label] = ACTIONS(671),
    [anon_sym_metadata] = ACTIONS(671),
    [anon_sym_x86_mmx] = ACTIONS(671),
    [anon_sym_x86_amx] = ACTIONS(671),
    [anon_sym_token] = ACTIONS(671),
    [anon_sym_opaque] = ACTIONS(671),
    [anon_sym_ptr] = ACTIONS(671),
    [aux_sym_type_keyword_token1] = ACTIONS(671),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(671),
    [anon_sym_LT_LBRACE] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(671),
    [anon_sym_RBRACK] = ACTIONS(671),
    [anon_sym_LT] = ACTIONS(673),
    [anon_sym_COMMA] = ACTIONS(671),
    [anon_sym_align] = ACTIONS(673),
    [anon_sym_section] = ACTIONS(671),
    [anon_sym_partition] = ACTIONS(671),
    [anon_sym_comdat] = ACTIONS(671),
    [anon_sym_gc] = ACTIONS(671),
    [anon_sym_prefix] = ACTIONS(671),
    [anon_sym_prologue] = ACTIONS(671),
    [anon_sym_personality] = ACTIONS(671),
    [anon_sym_alignstack] = ACTIONS(671),
    [anon_sym_allocsize] = ACTIONS(671),
    [anon_sym_alwaysinline] = ACTIONS(671),
    [anon_sym_builtin] = ACTIONS(671),
    [anon_sym_cold] = ACTIONS(671),
    [anon_sym_convergent] = ACTIONS(671),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(671),
    [anon_sym_hot] = ACTIONS(671),
    [anon_sym_inaccessiblememonly] = ACTIONS(671),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(671),
    [anon_sym_inlinehint] = ACTIONS(671),
    [anon_sym_jumptable] = ACTIONS(671),
    [anon_sym_minsize] = ACTIONS(671),
    [anon_sym_naked] = ACTIONS(671),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(671),
    [anon_sym_nobuiltin] = ACTIONS(671),
    [anon_sym_noduplicate] = ACTIONS(671),
    [anon_sym_nofree] = ACTIONS(671),
    [anon_sym_noimplicitfloat] = ACTIONS(671),
    [anon_sym_noinline] = ACTIONS(671),
    [anon_sym_nomerge] = ACTIONS(671),
    [anon_sym_nonlazybind] = ACTIONS(671),
    [anon_sym_noprofile] = ACTIONS(671),
    [anon_sym_noredzone] = ACTIONS(671),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(671),
    [anon_sym_noreturn] = ACTIONS(671),
    [anon_sym_norecurse] = ACTIONS(671),
    [anon_sym_willreturn] = ACTIONS(671),
    [anon_sym_nosync] = ACTIONS(671),
    [anon_sym_nounwind] = ACTIONS(671),
    [anon_sym_nocallback] = ACTIONS(671),
    [anon_sym_nosanitize_coverage] = ACTIONS(671),
    [anon_sym_null_pointer_is_valid] = ACTIONS(671),
    [anon_sym_optforfuzzing] = ACTIONS(671),
    [anon_sym_optnone] = ACTIONS(671),
    [anon_sym_optsize] = ACTIONS(671),
    [anon_sym_readnone] = ACTIONS(671),
    [anon_sym_readonly] = ACTIONS(671),
    [anon_sym_writeonly] = ACTIONS(671),
    [anon_sym_argmemonly] = ACTIONS(671),
    [anon_sym_returns_twice] = ACTIONS(671),
    [anon_sym_safestack] = ACTIONS(671),
    [anon_sym_sanitize_address] = ACTIONS(671),
    [anon_sym_sanitize_memory] = ACTIONS(671),
    [anon_sym_sanitize_thread] = ACTIONS(671),
    [anon_sym_sanitize_hwaddress] = ACTIONS(671),
    [anon_sym_sanitize_memtag] = ACTIONS(671),
    [anon_sym_speculative_load_hardening] = ACTIONS(671),
    [anon_sym_speculatable] = ACTIONS(671),
    [anon_sym_ssp] = ACTIONS(673),
    [anon_sym_sspstrong] = ACTIONS(671),
    [anon_sym_sspreq] = ACTIONS(671),
    [anon_sym_strictfp] = ACTIONS(671),
    [anon_sym_nocf_check] = ACTIONS(671),
    [anon_sym_shadowcallstack] = ACTIONS(671),
    [anon_sym_mustprogress] = ACTIONS(671),
    [anon_sym_vscale_range] = ACTIONS(671),
    [anon_sym_preallocated] = ACTIONS(671),
    [anon_sym_zeroext] = ACTIONS(671),
    [anon_sym_signext] = ACTIONS(671),
    [anon_sym_inreg] = ACTIONS(671),
    [anon_sym_byval] = ACTIONS(671),
    [anon_sym_byref] = ACTIONS(671),
    [anon_sym_inalloca] = ACTIONS(671),
    [anon_sym_sret] = ACTIONS(671),
    [anon_sym_elementtype] = ACTIONS(671),
    [anon_sym_noalias] = ACTIONS(671),
    [anon_sym_nocapture] = ACTIONS(671),
    [anon_sym_nest] = ACTIONS(671),
    [anon_sym_returned] = ACTIONS(671),
    [anon_sym_nonnull] = ACTIONS(671),
    [anon_sym_dereferenceable] = ACTIONS(673),
    [anon_sym_dereferenceable_or_null] = ACTIONS(671),
    [anon_sym_swiftself] = ACTIONS(671),
    [anon_sym_swiftasync] = ACTIONS(671),
    [anon_sym_swifterror] = ACTIONS(671),
    [anon_sym_immarg] = ACTIONS(671),
    [anon_sym_noundef] = ACTIONS(671),
    [anon_sym_uwtable] = ACTIONS(671),
    [anon_sym_memory] = ACTIONS(671),
    [anon_sym_to] = ACTIONS(673),
    [anon_sym_uselistorder] = ACTIONS(673),
    [anon_sym_uselistorder_bb] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_attributes] = ACTIONS(671),
  },
  [322] = {
    [ts_builtin_sym_end] = ACTIONS(611),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(611),
    [sym_comdat_ref] = ACTIONS(611),
    [sym_global_var] = ACTIONS(611),
    [sym_local_var] = ACTIONS(611),
    [aux_sym_metadata_ref_token1] = ACTIONS(611),
    [sym_summary_ref] = ACTIONS(611),
    [sym_string] = ACTIONS(611),
    [anon_sym_target] = ACTIONS(611),
    [anon_sym_source_filename] = ACTIONS(611),
    [anon_sym_declare] = ACTIONS(611),
    [anon_sym_define] = ACTIONS(611),
    [anon_sym_void] = ACTIONS(611),
    [anon_sym_half] = ACTIONS(611),
    [anon_sym_bfloat] = ACTIONS(611),
    [anon_sym_float] = ACTIONS(611),
    [anon_sym_double] = ACTIONS(611),
    [anon_sym_x86_fp80] = ACTIONS(611),
    [anon_sym_fp128] = ACTIONS(611),
    [anon_sym_ppc_fp128] = ACTIONS(611),
    [anon_sym_label] = ACTIONS(611),
    [anon_sym_metadata] = ACTIONS(611),
    [anon_sym_x86_mmx] = ACTIONS(611),
    [anon_sym_x86_amx] = ACTIONS(611),
    [anon_sym_token] = ACTIONS(611),
    [anon_sym_opaque] = ACTIONS(611),
    [anon_sym_ptr] = ACTIONS(611),
    [aux_sym_type_keyword_token1] = ACTIONS(611),
    [anon_sym_LBRACE] = ACTIONS(611),
    [anon_sym_RBRACE] = ACTIONS(611),
    [anon_sym_LT_LBRACE] = ACTIONS(611),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_RBRACK] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_align] = ACTIONS(613),
    [anon_sym_section] = ACTIONS(611),
    [anon_sym_partition] = ACTIONS(611),
    [anon_sym_comdat] = ACTIONS(611),
    [anon_sym_gc] = ACTIONS(611),
    [anon_sym_prefix] = ACTIONS(611),
    [anon_sym_prologue] = ACTIONS(611),
    [anon_sym_personality] = ACTIONS(611),
    [anon_sym_alignstack] = ACTIONS(611),
    [anon_sym_allocsize] = ACTIONS(611),
    [anon_sym_alwaysinline] = ACTIONS(611),
    [anon_sym_builtin] = ACTIONS(611),
    [anon_sym_cold] = ACTIONS(611),
    [anon_sym_convergent] = ACTIONS(611),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(611),
    [anon_sym_hot] = ACTIONS(611),
    [anon_sym_inaccessiblememonly] = ACTIONS(611),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(611),
    [anon_sym_inlinehint] = ACTIONS(611),
    [anon_sym_jumptable] = ACTIONS(611),
    [anon_sym_minsize] = ACTIONS(611),
    [anon_sym_naked] = ACTIONS(611),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(611),
    [anon_sym_nobuiltin] = ACTIONS(611),
    [anon_sym_noduplicate] = ACTIONS(611),
    [anon_sym_nofree] = ACTIONS(611),
    [anon_sym_noimplicitfloat] = ACTIONS(611),
    [anon_sym_noinline] = ACTIONS(611),
    [anon_sym_nomerge] = ACTIONS(611),
    [anon_sym_nonlazybind] = ACTIONS(611),
    [anon_sym_noprofile] = ACTIONS(611),
    [anon_sym_noredzone] = ACTIONS(611),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(611),
    [anon_sym_noreturn] = ACTIONS(611),
    [anon_sym_norecurse] = ACTIONS(611),
    [anon_sym_willreturn] = ACTIONS(611),
    [anon_sym_nosync] = ACTIONS(611),
    [anon_sym_nounwind] = ACTIONS(611),
    [anon_sym_nocallback] = ACTIONS(611),
    [anon_sym_nosanitize_coverage] = ACTIONS(611),
    [anon_sym_null_pointer_is_valid] = ACTIONS(611),
    [anon_sym_optforfuzzing] = ACTIONS(611),
    [anon_sym_optnone] = ACTIONS(611),
    [anon_sym_optsize] = ACTIONS(611),
    [anon_sym_readnone] = ACTIONS(611),
    [anon_sym_readonly] = ACTIONS(611),
    [anon_sym_writeonly] = ACTIONS(611),
    [anon_sym_argmemonly] = ACTIONS(611),
    [anon_sym_returns_twice] = ACTIONS(611),
    [anon_sym_safestack] = ACTIONS(611),
    [anon_sym_sanitize_address] = ACTIONS(611),
    [anon_sym_sanitize_memory] = ACTIONS(611),
    [anon_sym_sanitize_thread] = ACTIONS(611),
    [anon_sym_sanitize_hwaddress] = ACTIONS(611),
    [anon_sym_sanitize_memtag] = ACTIONS(611),
    [anon_sym_speculative_load_hardening] = ACTIONS(611),
    [anon_sym_speculatable] = ACTIONS(611),
    [anon_sym_ssp] = ACTIONS(613),
    [anon_sym_sspstrong] = ACTIONS(611),
    [anon_sym_sspreq] = ACTIONS(611),
    [anon_sym_strictfp] = ACTIONS(611),
    [anon_sym_nocf_check] = ACTIONS(611),
    [anon_sym_shadowcallstack] = ACTIONS(611),
    [anon_sym_mustprogress] = ACTIONS(611),
    [anon_sym_vscale_range] = ACTIONS(611),
    [anon_sym_preallocated] = ACTIONS(611),
    [anon_sym_zeroext] = ACTIONS(611),
    [anon_sym_signext] = ACTIONS(611),
    [anon_sym_inreg] = ACTIONS(611),
    [anon_sym_byval] = ACTIONS(611),
    [anon_sym_byref] = ACTIONS(611),
    [anon_sym_inalloca] = ACTIONS(611),
    [anon_sym_sret] = ACTIONS(611),
    [anon_sym_elementtype] = ACTIONS(611),
    [anon_sym_noalias] = ACTIONS(611),
    [anon_sym_nocapture] = ACTIONS(611),
    [anon_sym_nest] = ACTIONS(611),
    [anon_sym_returned] = ACTIONS(611),
    [anon_sym_nonnull] = ACTIONS(611),
    [anon_sym_dereferenceable] = ACTIONS(613),
    [anon_sym_dereferenceable_or_null] = ACTIONS(611),
    [anon_sym_swiftself] = ACTIONS(611),
    [anon_sym_swiftasync] = ACTIONS(611),
    [anon_sym_swifterror] = ACTIONS(611),
    [anon_sym_immarg] = ACTIONS(611),
    [anon_sym_noundef] = ACTIONS(611),
    [anon_sym_uwtable] = ACTIONS(611),
    [anon_sym_memory] = ACTIONS(611),
    [anon_sym_to] = ACTIONS(613),
    [anon_sym_uselistorder] = ACTIONS(613),
    [anon_sym_uselistorder_bb] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(611),
    [anon_sym_attributes] = ACTIONS(611),
  },
  [323] = {
    [ts_builtin_sym_end] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(651),
    [sym_comdat_ref] = ACTIONS(651),
    [sym_global_var] = ACTIONS(651),
    [sym_local_var] = ACTIONS(651),
    [aux_sym_metadata_ref_token1] = ACTIONS(651),
    [sym_summary_ref] = ACTIONS(651),
    [sym_string] = ACTIONS(651),
    [anon_sym_target] = ACTIONS(651),
    [anon_sym_source_filename] = ACTIONS(651),
    [anon_sym_declare] = ACTIONS(651),
    [anon_sym_define] = ACTIONS(651),
    [anon_sym_void] = ACTIONS(651),
    [anon_sym_half] = ACTIONS(651),
    [anon_sym_bfloat] = ACTIONS(651),
    [anon_sym_float] = ACTIONS(651),
    [anon_sym_double] = ACTIONS(651),
    [anon_sym_x86_fp80] = ACTIONS(651),
    [anon_sym_fp128] = ACTIONS(651),
    [anon_sym_ppc_fp128] = ACTIONS(651),
    [anon_sym_label] = ACTIONS(651),
    [anon_sym_metadata] = ACTIONS(651),
    [anon_sym_x86_mmx] = ACTIONS(651),
    [anon_sym_x86_amx] = ACTIONS(651),
    [anon_sym_token] = ACTIONS(651),
    [anon_sym_opaque] = ACTIONS(651),
    [anon_sym_ptr] = ACTIONS(651),
    [aux_sym_type_keyword_token1] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(651),
    [anon_sym_RBRACE] = ACTIONS(651),
    [anon_sym_LT_LBRACE] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_RBRACK] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_align] = ACTIONS(653),
    [anon_sym_section] = ACTIONS(651),
    [anon_sym_partition] = ACTIONS(651),
    [anon_sym_comdat] = ACTIONS(651),
    [anon_sym_gc] = ACTIONS(651),
    [anon_sym_prefix] = ACTIONS(651),
    [anon_sym_prologue] = ACTIONS(651),
    [anon_sym_personality] = ACTIONS(651),
    [anon_sym_alignstack] = ACTIONS(651),
    [anon_sym_allocsize] = ACTIONS(651),
    [anon_sym_alwaysinline] = ACTIONS(651),
    [anon_sym_builtin] = ACTIONS(651),
    [anon_sym_cold] = ACTIONS(651),
    [anon_sym_convergent] = ACTIONS(651),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(651),
    [anon_sym_hot] = ACTIONS(651),
    [anon_sym_inaccessiblememonly] = ACTIONS(651),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(651),
    [anon_sym_inlinehint] = ACTIONS(651),
    [anon_sym_jumptable] = ACTIONS(651),
    [anon_sym_minsize] = ACTIONS(651),
    [anon_sym_naked] = ACTIONS(651),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(651),
    [anon_sym_nobuiltin] = ACTIONS(651),
    [anon_sym_noduplicate] = ACTIONS(651),
    [anon_sym_nofree] = ACTIONS(651),
    [anon_sym_noimplicitfloat] = ACTIONS(651),
    [anon_sym_noinline] = ACTIONS(651),
    [anon_sym_nomerge] = ACTIONS(651),
    [anon_sym_nonlazybind] = ACTIONS(651),
    [anon_sym_noprofile] = ACTIONS(651),
    [anon_sym_noredzone] = ACTIONS(651),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(651),
    [anon_sym_noreturn] = ACTIONS(651),
    [anon_sym_norecurse] = ACTIONS(651),
    [anon_sym_willreturn] = ACTIONS(651),
    [anon_sym_nosync] = ACTIONS(651),
    [anon_sym_nounwind] = ACTIONS(651),
    [anon_sym_nocallback] = ACTIONS(651),
    [anon_sym_nosanitize_coverage] = ACTIONS(651),
    [anon_sym_null_pointer_is_valid] = ACTIONS(651),
    [anon_sym_optforfuzzing] = ACTIONS(651),
    [anon_sym_optnone] = ACTIONS(651),
    [anon_sym_optsize] = ACTIONS(651),
    [anon_sym_readnone] = ACTIONS(651),
    [anon_sym_readonly] = ACTIONS(651),
    [anon_sym_writeonly] = ACTIONS(651),
    [anon_sym_argmemonly] = ACTIONS(651),
    [anon_sym_returns_twice] = ACTIONS(651),
    [anon_sym_safestack] = ACTIONS(651),
    [anon_sym_sanitize_address] = ACTIONS(651),
    [anon_sym_sanitize_memory] = ACTIONS(651),
    [anon_sym_sanitize_thread] = ACTIONS(651),
    [anon_sym_sanitize_hwaddress] = ACTIONS(651),
    [anon_sym_sanitize_memtag] = ACTIONS(651),
    [anon_sym_speculative_load_hardening] = ACTIONS(651),
    [anon_sym_speculatable] = ACTIONS(651),
    [anon_sym_ssp] = ACTIONS(653),
    [anon_sym_sspstrong] = ACTIONS(651),
    [anon_sym_sspreq] = ACTIONS(651),
    [anon_sym_strictfp] = ACTIONS(651),
    [anon_sym_nocf_check] = ACTIONS(651),
    [anon_sym_shadowcallstack] = ACTIONS(651),
    [anon_sym_mustprogress] = ACTIONS(651),
    [anon_sym_vscale_range] = ACTIONS(651),
    [anon_sym_preallocated] = ACTIONS(651),
    [anon_sym_zeroext] = ACTIONS(651),
    [anon_sym_signext] = ACTIONS(651),
    [anon_sym_inreg] = ACTIONS(651),
    [anon_sym_byval] = ACTIONS(651),
    [anon_sym_byref] = ACTIONS(651),
    [anon_sym_inalloca] = ACTIONS(651),
    [anon_sym_sret] = ACTIONS(651),
    [anon_sym_elementtype] = ACTIONS(651),
    [anon_sym_noalias] = ACTIONS(651),
    [anon_sym_nocapture] = ACTIONS(651),
    [anon_sym_nest] = ACTIONS(651),
    [anon_sym_returned] = ACTIONS(651),
    [anon_sym_nonnull] = ACTIONS(651),
    [anon_sym_dereferenceable] = ACTIONS(653),
    [anon_sym_dereferenceable_or_null] = ACTIONS(651),
    [anon_sym_swiftself] = ACTIONS(651),
    [anon_sym_swiftasync] = ACTIONS(651),
    [anon_sym_swifterror] = ACTIONS(651),
    [anon_sym_immarg] = ACTIONS(651),
    [anon_sym_noundef] = ACTIONS(651),
    [anon_sym_uwtable] = ACTIONS(651),
    [anon_sym_memory] = ACTIONS(651),
    [anon_sym_to] = ACTIONS(653),
    [anon_sym_uselistorder] = ACTIONS(653),
    [anon_sym_uselistorder_bb] = ACTIONS(651),
    [anon_sym_module] = ACTIONS(651),
    [anon_sym_attributes] = ACTIONS(651),
  },
  [324] = {
    [ts_builtin_sym_end] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(509),
    [sym_comdat_ref] = ACTIONS(509),
    [sym_global_var] = ACTIONS(509),
    [sym_local_var] = ACTIONS(509),
    [aux_sym_metadata_ref_token1] = ACTIONS(509),
    [sym_summary_ref] = ACTIONS(509),
    [sym_string] = ACTIONS(509),
    [anon_sym_target] = ACTIONS(509),
    [anon_sym_source_filename] = ACTIONS(509),
    [anon_sym_declare] = ACTIONS(509),
    [anon_sym_define] = ACTIONS(509),
    [anon_sym_void] = ACTIONS(509),
    [anon_sym_half] = ACTIONS(509),
    [anon_sym_bfloat] = ACTIONS(509),
    [anon_sym_float] = ACTIONS(509),
    [anon_sym_double] = ACTIONS(509),
    [anon_sym_x86_fp80] = ACTIONS(509),
    [anon_sym_fp128] = ACTIONS(509),
    [anon_sym_ppc_fp128] = ACTIONS(509),
    [anon_sym_label] = ACTIONS(509),
    [anon_sym_metadata] = ACTIONS(509),
    [anon_sym_x86_mmx] = ACTIONS(509),
    [anon_sym_x86_amx] = ACTIONS(509),
    [anon_sym_token] = ACTIONS(509),
    [anon_sym_opaque] = ACTIONS(509),
    [anon_sym_ptr] = ACTIONS(509),
    [aux_sym_type_keyword_token1] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_RBRACE] = ACTIONS(509),
    [anon_sym_LT_LBRACE] = ACTIONS(509),
    [anon_sym_LBRACK] = ACTIONS(509),
    [anon_sym_RBRACK] = ACTIONS(509),
    [anon_sym_LT] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(509),
    [anon_sym_align] = ACTIONS(511),
    [anon_sym_section] = ACTIONS(509),
    [anon_sym_partition] = ACTIONS(509),
    [anon_sym_comdat] = ACTIONS(509),
    [anon_sym_gc] = ACTIONS(509),
    [anon_sym_prefix] = ACTIONS(509),
    [anon_sym_prologue] = ACTIONS(509),
    [anon_sym_personality] = ACTIONS(509),
    [anon_sym_alignstack] = ACTIONS(509),
    [anon_sym_allocsize] = ACTIONS(509),
    [anon_sym_alwaysinline] = ACTIONS(509),
    [anon_sym_builtin] = ACTIONS(509),
    [anon_sym_cold] = ACTIONS(509),
    [anon_sym_convergent] = ACTIONS(509),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(509),
    [anon_sym_hot] = ACTIONS(509),
    [anon_sym_inaccessiblememonly] = ACTIONS(509),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(509),
    [anon_sym_inlinehint] = ACTIONS(509),
    [anon_sym_jumptable] = ACTIONS(509),
    [anon_sym_minsize] = ACTIONS(509),
    [anon_sym_naked] = ACTIONS(509),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(509),
    [anon_sym_nobuiltin] = ACTIONS(509),
    [anon_sym_noduplicate] = ACTIONS(509),
    [anon_sym_nofree] = ACTIONS(509),
    [anon_sym_noimplicitfloat] = ACTIONS(509),
    [anon_sym_noinline] = ACTIONS(509),
    [anon_sym_nomerge] = ACTIONS(509),
    [anon_sym_nonlazybind] = ACTIONS(509),
    [anon_sym_noprofile] = ACTIONS(509),
    [anon_sym_noredzone] = ACTIONS(509),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(509),
    [anon_sym_noreturn] = ACTIONS(509),
    [anon_sym_norecurse] = ACTIONS(509),
    [anon_sym_willreturn] = ACTIONS(509),
    [anon_sym_nosync] = ACTIONS(509),
    [anon_sym_nounwind] = ACTIONS(509),
    [anon_sym_nocallback] = ACTIONS(509),
    [anon_sym_nosanitize_coverage] = ACTIONS(509),
    [anon_sym_null_pointer_is_valid] = ACTIONS(509),
    [anon_sym_optforfuzzing] = ACTIONS(509),
    [anon_sym_optnone] = ACTIONS(509),
    [anon_sym_optsize] = ACTIONS(509),
    [anon_sym_readnone] = ACTIONS(509),
    [anon_sym_readonly] = ACTIONS(509),
    [anon_sym_writeonly] = ACTIONS(509),
    [anon_sym_argmemonly] = ACTIONS(509),
    [anon_sym_returns_twice] = ACTIONS(509),
    [anon_sym_safestack] = ACTIONS(509),
    [anon_sym_sanitize_address] = ACTIONS(509),
    [anon_sym_sanitize_memory] = ACTIONS(509),
    [anon_sym_sanitize_thread] = ACTIONS(509),
    [anon_sym_sanitize_hwaddress] = ACTIONS(509),
    [anon_sym_sanitize_memtag] = ACTIONS(509),
    [anon_sym_speculative_load_hardening] = ACTIONS(509),
    [anon_sym_speculatable] = ACTIONS(509),
    [anon_sym_ssp] = ACTIONS(511),
    [anon_sym_sspstrong] = ACTIONS(509),
    [anon_sym_sspreq] = ACTIONS(509),
    [anon_sym_strictfp] = ACTIONS(509),
    [anon_sym_nocf_check] = ACTIONS(509),
    [anon_sym_shadowcallstack] = ACTIONS(509),
    [anon_sym_mustprogress] = ACTIONS(509),
    [anon_sym_vscale_range] = ACTIONS(509),
    [anon_sym_preallocated] = ACTIONS(509),
    [anon_sym_zeroext] = ACTIONS(509),
    [anon_sym_signext] = ACTIONS(509),
    [anon_sym_inreg] = ACTIONS(509),
    [anon_sym_byval] = ACTIONS(509),
    [anon_sym_byref] = ACTIONS(509),
    [anon_sym_inalloca] = ACTIONS(509),
    [anon_sym_sret] = ACTIONS(509),
    [anon_sym_elementtype] = ACTIONS(509),
    [anon_sym_noalias] = ACTIONS(509),
    [anon_sym_nocapture] = ACTIONS(509),
    [anon_sym_nest] = ACTIONS(509),
    [anon_sym_returned] = ACTIONS(509),
    [anon_sym_nonnull] = ACTIONS(509),
    [anon_sym_dereferenceable] = ACTIONS(511),
    [anon_sym_dereferenceable_or_null] = ACTIONS(509),
    [anon_sym_swiftself] = ACTIONS(509),
    [anon_sym_swiftasync] = ACTIONS(509),
    [anon_sym_swifterror] = ACTIONS(509),
    [anon_sym_immarg] = ACTIONS(509),
    [anon_sym_noundef] = ACTIONS(509),
    [anon_sym_uwtable] = ACTIONS(509),
    [anon_sym_memory] = ACTIONS(509),
    [anon_sym_to] = ACTIONS(511),
    [anon_sym_uselistorder] = ACTIONS(511),
    [anon_sym_uselistorder_bb] = ACTIONS(509),
    [anon_sym_module] = ACTIONS(509),
    [anon_sym_attributes] = ACTIONS(509),
  },
  [325] = {
    [ts_builtin_sym_end] = ACTIONS(623),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(623),
    [sym_comdat_ref] = ACTIONS(623),
    [sym_global_var] = ACTIONS(623),
    [sym_local_var] = ACTIONS(623),
    [aux_sym_metadata_ref_token1] = ACTIONS(623),
    [sym_summary_ref] = ACTIONS(623),
    [sym_string] = ACTIONS(623),
    [anon_sym_target] = ACTIONS(623),
    [anon_sym_source_filename] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_define] = ACTIONS(623),
    [anon_sym_void] = ACTIONS(623),
    [anon_sym_half] = ACTIONS(623),
    [anon_sym_bfloat] = ACTIONS(623),
    [anon_sym_float] = ACTIONS(623),
    [anon_sym_double] = ACTIONS(623),
    [anon_sym_x86_fp80] = ACTIONS(623),
    [anon_sym_fp128] = ACTIONS(623),
    [anon_sym_ppc_fp128] = ACTIONS(623),
    [anon_sym_label] = ACTIONS(623),
    [anon_sym_metadata] = ACTIONS(623),
    [anon_sym_x86_mmx] = ACTIONS(623),
    [anon_sym_x86_amx] = ACTIONS(623),
    [anon_sym_token] = ACTIONS(623),
    [anon_sym_opaque] = ACTIONS(623),
    [anon_sym_ptr] = ACTIONS(623),
    [aux_sym_type_keyword_token1] = ACTIONS(623),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(623),
    [anon_sym_LT_LBRACE] = ACTIONS(623),
    [anon_sym_LBRACK] = ACTIONS(623),
    [anon_sym_RBRACK] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(623),
    [anon_sym_align] = ACTIONS(625),
    [anon_sym_section] = ACTIONS(623),
    [anon_sym_partition] = ACTIONS(623),
    [anon_sym_comdat] = ACTIONS(623),
    [anon_sym_gc] = ACTIONS(623),
    [anon_sym_prefix] = ACTIONS(623),
    [anon_sym_prologue] = ACTIONS(623),
    [anon_sym_personality] = ACTIONS(623),
    [anon_sym_alignstack] = ACTIONS(623),
    [anon_sym_allocsize] = ACTIONS(623),
    [anon_sym_alwaysinline] = ACTIONS(623),
    [anon_sym_builtin] = ACTIONS(623),
    [anon_sym_cold] = ACTIONS(623),
    [anon_sym_convergent] = ACTIONS(623),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(623),
    [anon_sym_hot] = ACTIONS(623),
    [anon_sym_inaccessiblememonly] = ACTIONS(623),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(623),
    [anon_sym_inlinehint] = ACTIONS(623),
    [anon_sym_jumptable] = ACTIONS(623),
    [anon_sym_minsize] = ACTIONS(623),
    [anon_sym_naked] = ACTIONS(623),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(623),
    [anon_sym_nobuiltin] = ACTIONS(623),
    [anon_sym_noduplicate] = ACTIONS(623),
    [anon_sym_nofree] = ACTIONS(623),
    [anon_sym_noimplicitfloat] = ACTIONS(623),
    [anon_sym_noinline] = ACTIONS(623),
    [anon_sym_nomerge] = ACTIONS(623),
    [anon_sym_nonlazybind] = ACTIONS(623),
    [anon_sym_noprofile] = ACTIONS(623),
    [anon_sym_noredzone] = ACTIONS(623),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(623),
    [anon_sym_noreturn] = ACTIONS(623),
    [anon_sym_norecurse] = ACTIONS(623),
    [anon_sym_willreturn] = ACTIONS(623),
    [anon_sym_nosync] = ACTIONS(623),
    [anon_sym_nounwind] = ACTIONS(623),
    [anon_sym_nocallback] = ACTIONS(623),
    [anon_sym_nosanitize_coverage] = ACTIONS(623),
    [anon_sym_null_pointer_is_valid] = ACTIONS(623),
    [anon_sym_optforfuzzing] = ACTIONS(623),
    [anon_sym_optnone] = ACTIONS(623),
    [anon_sym_optsize] = ACTIONS(623),
    [anon_sym_readnone] = ACTIONS(623),
    [anon_sym_readonly] = ACTIONS(623),
    [anon_sym_writeonly] = ACTIONS(623),
    [anon_sym_argmemonly] = ACTIONS(623),
    [anon_sym_returns_twice] = ACTIONS(623),
    [anon_sym_safestack] = ACTIONS(623),
    [anon_sym_sanitize_address] = ACTIONS(623),
    [anon_sym_sanitize_memory] = ACTIONS(623),
    [anon_sym_sanitize_thread] = ACTIONS(623),
    [anon_sym_sanitize_hwaddress] = ACTIONS(623),
    [anon_sym_sanitize_memtag] = ACTIONS(623),
    [anon_sym_speculative_load_hardening] = ACTIONS(623),
    [anon_sym_speculatable] = ACTIONS(623),
    [anon_sym_ssp] = ACTIONS(625),
    [anon_sym_sspstrong] = ACTIONS(623),
    [anon_sym_sspreq] = ACTIONS(623),
    [anon_sym_strictfp] = ACTIONS(623),
    [anon_sym_nocf_check] = ACTIONS(623),
    [anon_sym_shadowcallstack] = ACTIONS(623),
    [anon_sym_mustprogress] = ACTIONS(623),
    [anon_sym_vscale_range] = ACTIONS(623),
    [anon_sym_preallocated] = ACTIONS(623),
    [anon_sym_zeroext] = ACTIONS(623),
    [anon_sym_signext] = ACTIONS(623),
    [anon_sym_inreg] = ACTIONS(623),
    [anon_sym_byval] = ACTIONS(623),
    [anon_sym_byref] = ACTIONS(623),
    [anon_sym_inalloca] = ACTIONS(623),
    [anon_sym_sret] = ACTIONS(623),
    [anon_sym_elementtype] = ACTIONS(623),
    [anon_sym_noalias] = ACTIONS(623),
    [anon_sym_nocapture] = ACTIONS(623),
    [anon_sym_nest] = ACTIONS(623),
    [anon_sym_returned] = ACTIONS(623),
    [anon_sym_nonnull] = ACTIONS(623),
    [anon_sym_dereferenceable] = ACTIONS(625),
    [anon_sym_dereferenceable_or_null] = ACTIONS(623),
    [anon_sym_swiftself] = ACTIONS(623),
    [anon_sym_swiftasync] = ACTIONS(623),
    [anon_sym_swifterror] = ACTIONS(623),
    [anon_sym_immarg] = ACTIONS(623),
    [anon_sym_noundef] = ACTIONS(623),
    [anon_sym_uwtable] = ACTIONS(623),
    [anon_sym_memory] = ACTIONS(623),
    [anon_sym_to] = ACTIONS(625),
    [anon_sym_uselistorder] = ACTIONS(625),
    [anon_sym_uselistorder_bb] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_attributes] = ACTIONS(623),
  },
  [326] = {
    [ts_builtin_sym_end] = ACTIONS(705),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(705),
    [sym_comdat_ref] = ACTIONS(705),
    [sym_global_var] = ACTIONS(705),
    [sym_local_var] = ACTIONS(705),
    [aux_sym_metadata_ref_token1] = ACTIONS(705),
    [sym_summary_ref] = ACTIONS(705),
    [sym_string] = ACTIONS(705),
    [anon_sym_target] = ACTIONS(705),
    [anon_sym_source_filename] = ACTIONS(705),
    [anon_sym_declare] = ACTIONS(705),
    [anon_sym_define] = ACTIONS(705),
    [anon_sym_void] = ACTIONS(705),
    [anon_sym_half] = ACTIONS(705),
    [anon_sym_bfloat] = ACTIONS(705),
    [anon_sym_float] = ACTIONS(705),
    [anon_sym_double] = ACTIONS(705),
    [anon_sym_x86_fp80] = ACTIONS(705),
    [anon_sym_fp128] = ACTIONS(705),
    [anon_sym_ppc_fp128] = ACTIONS(705),
    [anon_sym_label] = ACTIONS(705),
    [anon_sym_metadata] = ACTIONS(705),
    [anon_sym_x86_mmx] = ACTIONS(705),
    [anon_sym_x86_amx] = ACTIONS(705),
    [anon_sym_token] = ACTIONS(705),
    [anon_sym_opaque] = ACTIONS(705),
    [anon_sym_ptr] = ACTIONS(705),
    [aux_sym_type_keyword_token1] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(705),
    [anon_sym_RBRACE] = ACTIONS(705),
    [anon_sym_LT_LBRACE] = ACTIONS(705),
    [anon_sym_LBRACK] = ACTIONS(705),
    [anon_sym_RBRACK] = ACTIONS(705),
    [anon_sym_LT] = ACTIONS(707),
    [anon_sym_COMMA] = ACTIONS(705),
    [anon_sym_align] = ACTIONS(707),
    [anon_sym_section] = ACTIONS(705),
    [anon_sym_partition] = ACTIONS(705),
    [anon_sym_comdat] = ACTIONS(705),
    [anon_sym_gc] = ACTIONS(705),
    [anon_sym_prefix] = ACTIONS(705),
    [anon_sym_prologue] = ACTIONS(705),
    [anon_sym_personality] = ACTIONS(705),
    [anon_sym_alignstack] = ACTIONS(705),
    [anon_sym_allocsize] = ACTIONS(705),
    [anon_sym_alwaysinline] = ACTIONS(705),
    [anon_sym_builtin] = ACTIONS(705),
    [anon_sym_cold] = ACTIONS(705),
    [anon_sym_convergent] = ACTIONS(705),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(705),
    [anon_sym_hot] = ACTIONS(705),
    [anon_sym_inaccessiblememonly] = ACTIONS(705),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(705),
    [anon_sym_inlinehint] = ACTIONS(705),
    [anon_sym_jumptable] = ACTIONS(705),
    [anon_sym_minsize] = ACTIONS(705),
    [anon_sym_naked] = ACTIONS(705),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(705),
    [anon_sym_nobuiltin] = ACTIONS(705),
    [anon_sym_noduplicate] = ACTIONS(705),
    [anon_sym_nofree] = ACTIONS(705),
    [anon_sym_noimplicitfloat] = ACTIONS(705),
    [anon_sym_noinline] = ACTIONS(705),
    [anon_sym_nomerge] = ACTIONS(705),
    [anon_sym_nonlazybind] = ACTIONS(705),
    [anon_sym_noprofile] = ACTIONS(705),
    [anon_sym_noredzone] = ACTIONS(705),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(705),
    [anon_sym_noreturn] = ACTIONS(705),
    [anon_sym_norecurse] = ACTIONS(705),
    [anon_sym_willreturn] = ACTIONS(705),
    [anon_sym_nosync] = ACTIONS(705),
    [anon_sym_nounwind] = ACTIONS(705),
    [anon_sym_nocallback] = ACTIONS(705),
    [anon_sym_nosanitize_coverage] = ACTIONS(705),
    [anon_sym_null_pointer_is_valid] = ACTIONS(705),
    [anon_sym_optforfuzzing] = ACTIONS(705),
    [anon_sym_optnone] = ACTIONS(705),
    [anon_sym_optsize] = ACTIONS(705),
    [anon_sym_readnone] = ACTIONS(705),
    [anon_sym_readonly] = ACTIONS(705),
    [anon_sym_writeonly] = ACTIONS(705),
    [anon_sym_argmemonly] = ACTIONS(705),
    [anon_sym_returns_twice] = ACTIONS(705),
    [anon_sym_safestack] = ACTIONS(705),
    [anon_sym_sanitize_address] = ACTIONS(705),
    [anon_sym_sanitize_memory] = ACTIONS(705),
    [anon_sym_sanitize_thread] = ACTIONS(705),
    [anon_sym_sanitize_hwaddress] = ACTIONS(705),
    [anon_sym_sanitize_memtag] = ACTIONS(705),
    [anon_sym_speculative_load_hardening] = ACTIONS(705),
    [anon_sym_speculatable] = ACTIONS(705),
    [anon_sym_ssp] = ACTIONS(707),
    [anon_sym_sspstrong] = ACTIONS(705),
    [anon_sym_sspreq] = ACTIONS(705),
    [anon_sym_strictfp] = ACTIONS(705),
    [anon_sym_nocf_check] = ACTIONS(705),
    [anon_sym_shadowcallstack] = ACTIONS(705),
    [anon_sym_mustprogress] = ACTIONS(705),
    [anon_sym_vscale_range] = ACTIONS(705),
    [anon_sym_preallocated] = ACTIONS(705),
    [anon_sym_zeroext] = ACTIONS(705),
    [anon_sym_signext] = ACTIONS(705),
    [anon_sym_inreg] = ACTIONS(705),
    [anon_sym_byval] = ACTIONS(705),
    [anon_sym_byref] = ACTIONS(705),
    [anon_sym_inalloca] = ACTIONS(705),
    [anon_sym_sret] = ACTIONS(705),
    [anon_sym_elementtype] = ACTIONS(705),
    [anon_sym_noalias] = ACTIONS(705),
    [anon_sym_nocapture] = ACTIONS(705),
    [anon_sym_nest] = ACTIONS(705),
    [anon_sym_returned] = ACTIONS(705),
    [anon_sym_nonnull] = ACTIONS(705),
    [anon_sym_dereferenceable] = ACTIONS(707),
    [anon_sym_dereferenceable_or_null] = ACTIONS(705),
    [anon_sym_swiftself] = ACTIONS(705),
    [anon_sym_swiftasync] = ACTIONS(705),
    [anon_sym_swifterror] = ACTIONS(705),
    [anon_sym_immarg] = ACTIONS(705),
    [anon_sym_noundef] = ACTIONS(705),
    [anon_sym_uwtable] = ACTIONS(705),
    [anon_sym_memory] = ACTIONS(705),
    [anon_sym_to] = ACTIONS(707),
    [anon_sym_uselistorder] = ACTIONS(707),
    [anon_sym_uselistorder_bb] = ACTIONS(705),
    [anon_sym_module] = ACTIONS(705),
    [anon_sym_attributes] = ACTIONS(705),
  },
  [327] = {
    [ts_builtin_sym_end] = ACTIONS(659),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(659),
    [sym_comdat_ref] = ACTIONS(659),
    [sym_global_var] = ACTIONS(659),
    [sym_local_var] = ACTIONS(659),
    [aux_sym_metadata_ref_token1] = ACTIONS(659),
    [sym_summary_ref] = ACTIONS(659),
    [sym_string] = ACTIONS(659),
    [anon_sym_target] = ACTIONS(659),
    [anon_sym_source_filename] = ACTIONS(659),
    [anon_sym_declare] = ACTIONS(659),
    [anon_sym_define] = ACTIONS(659),
    [anon_sym_void] = ACTIONS(659),
    [anon_sym_half] = ACTIONS(659),
    [anon_sym_bfloat] = ACTIONS(659),
    [anon_sym_float] = ACTIONS(659),
    [anon_sym_double] = ACTIONS(659),
    [anon_sym_x86_fp80] = ACTIONS(659),
    [anon_sym_fp128] = ACTIONS(659),
    [anon_sym_ppc_fp128] = ACTIONS(659),
    [anon_sym_label] = ACTIONS(659),
    [anon_sym_metadata] = ACTIONS(659),
    [anon_sym_x86_mmx] = ACTIONS(659),
    [anon_sym_x86_amx] = ACTIONS(659),
    [anon_sym_token] = ACTIONS(659),
    [anon_sym_opaque] = ACTIONS(659),
    [anon_sym_ptr] = ACTIONS(659),
    [aux_sym_type_keyword_token1] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(659),
    [anon_sym_LT_LBRACE] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_RBRACK] = ACTIONS(659),
    [anon_sym_LT] = ACTIONS(661),
    [anon_sym_COMMA] = ACTIONS(659),
    [anon_sym_align] = ACTIONS(661),
    [anon_sym_section] = ACTIONS(659),
    [anon_sym_partition] = ACTIONS(659),
    [anon_sym_comdat] = ACTIONS(659),
    [anon_sym_gc] = ACTIONS(659),
    [anon_sym_prefix] = ACTIONS(659),
    [anon_sym_prologue] = ACTIONS(659),
    [anon_sym_personality] = ACTIONS(659),
    [anon_sym_alignstack] = ACTIONS(659),
    [anon_sym_allocsize] = ACTIONS(659),
    [anon_sym_alwaysinline] = ACTIONS(659),
    [anon_sym_builtin] = ACTIONS(659),
    [anon_sym_cold] = ACTIONS(659),
    [anon_sym_convergent] = ACTIONS(659),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(659),
    [anon_sym_hot] = ACTIONS(659),
    [anon_sym_inaccessiblememonly] = ACTIONS(659),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(659),
    [anon_sym_inlinehint] = ACTIONS(659),
    [anon_sym_jumptable] = ACTIONS(659),
    [anon_sym_minsize] = ACTIONS(659),
    [anon_sym_naked] = ACTIONS(659),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(659),
    [anon_sym_nobuiltin] = ACTIONS(659),
    [anon_sym_noduplicate] = ACTIONS(659),
    [anon_sym_nofree] = ACTIONS(659),
    [anon_sym_noimplicitfloat] = ACTIONS(659),
    [anon_sym_noinline] = ACTIONS(659),
    [anon_sym_nomerge] = ACTIONS(659),
    [anon_sym_nonlazybind] = ACTIONS(659),
    [anon_sym_noprofile] = ACTIONS(659),
    [anon_sym_noredzone] = ACTIONS(659),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(659),
    [anon_sym_noreturn] = ACTIONS(659),
    [anon_sym_norecurse] = ACTIONS(659),
    [anon_sym_willreturn] = ACTIONS(659),
    [anon_sym_nosync] = ACTIONS(659),
    [anon_sym_nounwind] = ACTIONS(659),
    [anon_sym_nocallback] = ACTIONS(659),
    [anon_sym_nosanitize_coverage] = ACTIONS(659),
    [anon_sym_null_pointer_is_valid] = ACTIONS(659),
    [anon_sym_optforfuzzing] = ACTIONS(659),
    [anon_sym_optnone] = ACTIONS(659),
    [anon_sym_optsize] = ACTIONS(659),
    [anon_sym_readnone] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_writeonly] = ACTIONS(659),
    [anon_sym_argmemonly] = ACTIONS(659),
    [anon_sym_returns_twice] = ACTIONS(659),
    [anon_sym_safestack] = ACTIONS(659),
    [anon_sym_sanitize_address] = ACTIONS(659),
    [anon_sym_sanitize_memory] = ACTIONS(659),
    [anon_sym_sanitize_thread] = ACTIONS(659),
    [anon_sym_sanitize_hwaddress] = ACTIONS(659),
    [anon_sym_sanitize_memtag] = ACTIONS(659),
    [anon_sym_speculative_load_hardening] = ACTIONS(659),
    [anon_sym_speculatable] = ACTIONS(659),
    [anon_sym_ssp] = ACTIONS(661),
    [anon_sym_sspstrong] = ACTIONS(659),
    [anon_sym_sspreq] = ACTIONS(659),
    [anon_sym_strictfp] = ACTIONS(659),
    [anon_sym_nocf_check] = ACTIONS(659),
    [anon_sym_shadowcallstack] = ACTIONS(659),
    [anon_sym_mustprogress] = ACTIONS(659),
    [anon_sym_vscale_range] = ACTIONS(659),
    [anon_sym_preallocated] = ACTIONS(659),
    [anon_sym_zeroext] = ACTIONS(659),
    [anon_sym_signext] = ACTIONS(659),
    [anon_sym_inreg] = ACTIONS(659),
    [anon_sym_byval] = ACTIONS(659),
    [anon_sym_byref] = ACTIONS(659),
    [anon_sym_inalloca] = ACTIONS(659),
    [anon_sym_sret] = ACTIONS(659),
    [anon_sym_elementtype] = ACTIONS(659),
    [anon_sym_noalias] = ACTIONS(659),
    [anon_sym_nocapture] = ACTIONS(659),
    [anon_sym_nest] = ACTIONS(659),
    [anon_sym_returned] = ACTIONS(659),
    [anon_sym_nonnull] = ACTIONS(659),
    [anon_sym_dereferenceable] = ACTIONS(661),
    [anon_sym_dereferenceable_or_null] = ACTIONS(659),
    [anon_sym_swiftself] = ACTIONS(659),
    [anon_sym_swiftasync] = ACTIONS(659),
    [anon_sym_swifterror] = ACTIONS(659),
    [anon_sym_immarg] = ACTIONS(659),
    [anon_sym_noundef] = ACTIONS(659),
    [anon_sym_uwtable] = ACTIONS(659),
    [anon_sym_memory] = ACTIONS(659),
    [anon_sym_to] = ACTIONS(661),
    [anon_sym_uselistorder] = ACTIONS(661),
    [anon_sym_uselistorder_bb] = ACTIONS(659),
    [anon_sym_module] = ACTIONS(659),
    [anon_sym_attributes] = ACTIONS(659),
  },
  [328] = {
    [ts_builtin_sym_end] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(663),
    [sym_comdat_ref] = ACTIONS(663),
    [sym_global_var] = ACTIONS(663),
    [sym_local_var] = ACTIONS(663),
    [aux_sym_metadata_ref_token1] = ACTIONS(663),
    [sym_summary_ref] = ACTIONS(663),
    [sym_string] = ACTIONS(663),
    [anon_sym_target] = ACTIONS(663),
    [anon_sym_source_filename] = ACTIONS(663),
    [anon_sym_declare] = ACTIONS(663),
    [anon_sym_define] = ACTIONS(663),
    [anon_sym_void] = ACTIONS(663),
    [anon_sym_half] = ACTIONS(663),
    [anon_sym_bfloat] = ACTIONS(663),
    [anon_sym_float] = ACTIONS(663),
    [anon_sym_double] = ACTIONS(663),
    [anon_sym_x86_fp80] = ACTIONS(663),
    [anon_sym_fp128] = ACTIONS(663),
    [anon_sym_ppc_fp128] = ACTIONS(663),
    [anon_sym_label] = ACTIONS(663),
    [anon_sym_metadata] = ACTIONS(663),
    [anon_sym_x86_mmx] = ACTIONS(663),
    [anon_sym_x86_amx] = ACTIONS(663),
    [anon_sym_token] = ACTIONS(663),
    [anon_sym_opaque] = ACTIONS(663),
    [anon_sym_ptr] = ACTIONS(663),
    [aux_sym_type_keyword_token1] = ACTIONS(663),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_RBRACE] = ACTIONS(663),
    [anon_sym_LT_LBRACE] = ACTIONS(663),
    [anon_sym_LBRACK] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(663),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_align] = ACTIONS(665),
    [anon_sym_section] = ACTIONS(663),
    [anon_sym_partition] = ACTIONS(663),
    [anon_sym_comdat] = ACTIONS(663),
    [anon_sym_gc] = ACTIONS(663),
    [anon_sym_prefix] = ACTIONS(663),
    [anon_sym_prologue] = ACTIONS(663),
    [anon_sym_personality] = ACTIONS(663),
    [anon_sym_alignstack] = ACTIONS(663),
    [anon_sym_allocsize] = ACTIONS(663),
    [anon_sym_alwaysinline] = ACTIONS(663),
    [anon_sym_builtin] = ACTIONS(663),
    [anon_sym_cold] = ACTIONS(663),
    [anon_sym_convergent] = ACTIONS(663),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(663),
    [anon_sym_hot] = ACTIONS(663),
    [anon_sym_inaccessiblememonly] = ACTIONS(663),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(663),
    [anon_sym_inlinehint] = ACTIONS(663),
    [anon_sym_jumptable] = ACTIONS(663),
    [anon_sym_minsize] = ACTIONS(663),
    [anon_sym_naked] = ACTIONS(663),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(663),
    [anon_sym_nobuiltin] = ACTIONS(663),
    [anon_sym_noduplicate] = ACTIONS(663),
    [anon_sym_nofree] = ACTIONS(663),
    [anon_sym_noimplicitfloat] = ACTIONS(663),
    [anon_sym_noinline] = ACTIONS(663),
    [anon_sym_nomerge] = ACTIONS(663),
    [anon_sym_nonlazybind] = ACTIONS(663),
    [anon_sym_noprofile] = ACTIONS(663),
    [anon_sym_noredzone] = ACTIONS(663),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(663),
    [anon_sym_noreturn] = ACTIONS(663),
    [anon_sym_norecurse] = ACTIONS(663),
    [anon_sym_willreturn] = ACTIONS(663),
    [anon_sym_nosync] = ACTIONS(663),
    [anon_sym_nounwind] = ACTIONS(663),
    [anon_sym_nocallback] = ACTIONS(663),
    [anon_sym_nosanitize_coverage] = ACTIONS(663),
    [anon_sym_null_pointer_is_valid] = ACTIONS(663),
    [anon_sym_optforfuzzing] = ACTIONS(663),
    [anon_sym_optnone] = ACTIONS(663),
    [anon_sym_optsize] = ACTIONS(663),
    [anon_sym_readnone] = ACTIONS(663),
    [anon_sym_readonly] = ACTIONS(663),
    [anon_sym_writeonly] = ACTIONS(663),
    [anon_sym_argmemonly] = ACTIONS(663),
    [anon_sym_returns_twice] = ACTIONS(663),
    [anon_sym_safestack] = ACTIONS(663),
    [anon_sym_sanitize_address] = ACTIONS(663),
    [anon_sym_sanitize_memory] = ACTIONS(663),
    [anon_sym_sanitize_thread] = ACTIONS(663),
    [anon_sym_sanitize_hwaddress] = ACTIONS(663),
    [anon_sym_sanitize_memtag] = ACTIONS(663),
    [anon_sym_speculative_load_hardening] = ACTIONS(663),
    [anon_sym_speculatable] = ACTIONS(663),
    [anon_sym_ssp] = ACTIONS(665),
    [anon_sym_sspstrong] = ACTIONS(663),
    [anon_sym_sspreq] = ACTIONS(663),
    [anon_sym_strictfp] = ACTIONS(663),
    [anon_sym_nocf_check] = ACTIONS(663),
    [anon_sym_shadowcallstack] = ACTIONS(663),
    [anon_sym_mustprogress] = ACTIONS(663),
    [anon_sym_vscale_range] = ACTIONS(663),
    [anon_sym_preallocated] = ACTIONS(663),
    [anon_sym_zeroext] = ACTIONS(663),
    [anon_sym_signext] = ACTIONS(663),
    [anon_sym_inreg] = ACTIONS(663),
    [anon_sym_byval] = ACTIONS(663),
    [anon_sym_byref] = ACTIONS(663),
    [anon_sym_inalloca] = ACTIONS(663),
    [anon_sym_sret] = ACTIONS(663),
    [anon_sym_elementtype] = ACTIONS(663),
    [anon_sym_noalias] = ACTIONS(663),
    [anon_sym_nocapture] = ACTIONS(663),
    [anon_sym_nest] = ACTIONS(663),
    [anon_sym_returned] = ACTIONS(663),
    [anon_sym_nonnull] = ACTIONS(663),
    [anon_sym_dereferenceable] = ACTIONS(665),
    [anon_sym_dereferenceable_or_null] = ACTIONS(663),
    [anon_sym_swiftself] = ACTIONS(663),
    [anon_sym_swiftasync] = ACTIONS(663),
    [anon_sym_swifterror] = ACTIONS(663),
    [anon_sym_immarg] = ACTIONS(663),
    [anon_sym_noundef] = ACTIONS(663),
    [anon_sym_uwtable] = ACTIONS(663),
    [anon_sym_memory] = ACTIONS(663),
    [anon_sym_to] = ACTIONS(665),
    [anon_sym_uselistorder] = ACTIONS(665),
    [anon_sym_uselistorder_bb] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_attributes] = ACTIONS(663),
  },
  [329] = {
    [ts_builtin_sym_end] = ACTIONS(525),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(525),
    [sym_comdat_ref] = ACTIONS(525),
    [sym_global_var] = ACTIONS(525),
    [sym_local_var] = ACTIONS(525),
    [aux_sym_metadata_ref_token1] = ACTIONS(525),
    [sym_summary_ref] = ACTIONS(525),
    [sym_string] = ACTIONS(525),
    [anon_sym_target] = ACTIONS(525),
    [anon_sym_source_filename] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(525),
    [anon_sym_define] = ACTIONS(525),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_half] = ACTIONS(525),
    [anon_sym_bfloat] = ACTIONS(525),
    [anon_sym_float] = ACTIONS(525),
    [anon_sym_double] = ACTIONS(525),
    [anon_sym_x86_fp80] = ACTIONS(525),
    [anon_sym_fp128] = ACTIONS(525),
    [anon_sym_ppc_fp128] = ACTIONS(525),
    [anon_sym_label] = ACTIONS(525),
    [anon_sym_metadata] = ACTIONS(525),
    [anon_sym_x86_mmx] = ACTIONS(525),
    [anon_sym_x86_amx] = ACTIONS(525),
    [anon_sym_token] = ACTIONS(525),
    [anon_sym_opaque] = ACTIONS(525),
    [anon_sym_ptr] = ACTIONS(525),
    [aux_sym_type_keyword_token1] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(525),
    [anon_sym_RBRACE] = ACTIONS(525),
    [anon_sym_LT_LBRACE] = ACTIONS(525),
    [anon_sym_LBRACK] = ACTIONS(525),
    [anon_sym_RBRACK] = ACTIONS(525),
    [anon_sym_LT] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(525),
    [anon_sym_align] = ACTIONS(527),
    [anon_sym_section] = ACTIONS(525),
    [anon_sym_partition] = ACTIONS(525),
    [anon_sym_comdat] = ACTIONS(525),
    [anon_sym_gc] = ACTIONS(525),
    [anon_sym_prefix] = ACTIONS(525),
    [anon_sym_prologue] = ACTIONS(525),
    [anon_sym_personality] = ACTIONS(525),
    [anon_sym_alignstack] = ACTIONS(525),
    [anon_sym_allocsize] = ACTIONS(525),
    [anon_sym_alwaysinline] = ACTIONS(525),
    [anon_sym_builtin] = ACTIONS(525),
    [anon_sym_cold] = ACTIONS(525),
    [anon_sym_convergent] = ACTIONS(525),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(525),
    [anon_sym_hot] = ACTIONS(525),
    [anon_sym_inaccessiblememonly] = ACTIONS(525),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(525),
    [anon_sym_inlinehint] = ACTIONS(525),
    [anon_sym_jumptable] = ACTIONS(525),
    [anon_sym_minsize] = ACTIONS(525),
    [anon_sym_naked] = ACTIONS(525),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(525),
    [anon_sym_nobuiltin] = ACTIONS(525),
    [anon_sym_noduplicate] = ACTIONS(525),
    [anon_sym_nofree] = ACTIONS(525),
    [anon_sym_noimplicitfloat] = ACTIONS(525),
    [anon_sym_noinline] = ACTIONS(525),
    [anon_sym_nomerge] = ACTIONS(525),
    [anon_sym_nonlazybind] = ACTIONS(525),
    [anon_sym_noprofile] = ACTIONS(525),
    [anon_sym_noredzone] = ACTIONS(525),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(525),
    [anon_sym_noreturn] = ACTIONS(525),
    [anon_sym_norecurse] = ACTIONS(525),
    [anon_sym_willreturn] = ACTIONS(525),
    [anon_sym_nosync] = ACTIONS(525),
    [anon_sym_nounwind] = ACTIONS(525),
    [anon_sym_nocallback] = ACTIONS(525),
    [anon_sym_nosanitize_coverage] = ACTIONS(525),
    [anon_sym_null_pointer_is_valid] = ACTIONS(525),
    [anon_sym_optforfuzzing] = ACTIONS(525),
    [anon_sym_optnone] = ACTIONS(525),
    [anon_sym_optsize] = ACTIONS(525),
    [anon_sym_readnone] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_writeonly] = ACTIONS(525),
    [anon_sym_argmemonly] = ACTIONS(525),
    [anon_sym_returns_twice] = ACTIONS(525),
    [anon_sym_safestack] = ACTIONS(525),
    [anon_sym_sanitize_address] = ACTIONS(525),
    [anon_sym_sanitize_memory] = ACTIONS(525),
    [anon_sym_sanitize_thread] = ACTIONS(525),
    [anon_sym_sanitize_hwaddress] = ACTIONS(525),
    [anon_sym_sanitize_memtag] = ACTIONS(525),
    [anon_sym_speculative_load_hardening] = ACTIONS(525),
    [anon_sym_speculatable] = ACTIONS(525),
    [anon_sym_ssp] = ACTIONS(527),
    [anon_sym_sspstrong] = ACTIONS(525),
    [anon_sym_sspreq] = ACTIONS(525),
    [anon_sym_strictfp] = ACTIONS(525),
    [anon_sym_nocf_check] = ACTIONS(525),
    [anon_sym_shadowcallstack] = ACTIONS(525),
    [anon_sym_mustprogress] = ACTIONS(525),
    [anon_sym_vscale_range] = ACTIONS(525),
    [anon_sym_preallocated] = ACTIONS(525),
    [anon_sym_zeroext] = ACTIONS(525),
    [anon_sym_signext] = ACTIONS(525),
    [anon_sym_inreg] = ACTIONS(525),
    [anon_sym_byval] = ACTIONS(525),
    [anon_sym_byref] = ACTIONS(525),
    [anon_sym_inalloca] = ACTIONS(525),
    [anon_sym_sret] = ACTIONS(525),
    [anon_sym_elementtype] = ACTIONS(525),
    [anon_sym_noalias] = ACTIONS(525),
    [anon_sym_nocapture] = ACTIONS(525),
    [anon_sym_nest] = ACTIONS(525),
    [anon_sym_returned] = ACTIONS(525),
    [anon_sym_nonnull] = ACTIONS(525),
    [anon_sym_dereferenceable] = ACTIONS(527),
    [anon_sym_dereferenceable_or_null] = ACTIONS(525),
    [anon_sym_swiftself] = ACTIONS(525),
    [anon_sym_swiftasync] = ACTIONS(525),
    [anon_sym_swifterror] = ACTIONS(525),
    [anon_sym_immarg] = ACTIONS(525),
    [anon_sym_noundef] = ACTIONS(525),
    [anon_sym_uwtable] = ACTIONS(525),
    [anon_sym_memory] = ACTIONS(525),
    [anon_sym_to] = ACTIONS(527),
    [anon_sym_uselistorder] = ACTIONS(527),
    [anon_sym_uselistorder_bb] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(525),
    [anon_sym_attributes] = ACTIONS(525),
  },
  [330] = {
    [ts_builtin_sym_end] = ACTIONS(569),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(569),
    [sym_comdat_ref] = ACTIONS(569),
    [sym_global_var] = ACTIONS(569),
    [sym_local_var] = ACTIONS(569),
    [aux_sym_metadata_ref_token1] = ACTIONS(569),
    [sym_summary_ref] = ACTIONS(569),
    [sym_string] = ACTIONS(569),
    [anon_sym_target] = ACTIONS(569),
    [anon_sym_source_filename] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_define] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(569),
    [anon_sym_half] = ACTIONS(569),
    [anon_sym_bfloat] = ACTIONS(569),
    [anon_sym_float] = ACTIONS(569),
    [anon_sym_double] = ACTIONS(569),
    [anon_sym_x86_fp80] = ACTIONS(569),
    [anon_sym_fp128] = ACTIONS(569),
    [anon_sym_ppc_fp128] = ACTIONS(569),
    [anon_sym_label] = ACTIONS(569),
    [anon_sym_metadata] = ACTIONS(569),
    [anon_sym_x86_mmx] = ACTIONS(569),
    [anon_sym_x86_amx] = ACTIONS(569),
    [anon_sym_token] = ACTIONS(569),
    [anon_sym_opaque] = ACTIONS(569),
    [anon_sym_ptr] = ACTIONS(569),
    [aux_sym_type_keyword_token1] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_LT_LBRACE] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_RBRACK] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_align] = ACTIONS(571),
    [anon_sym_section] = ACTIONS(569),
    [anon_sym_partition] = ACTIONS(569),
    [anon_sym_comdat] = ACTIONS(569),
    [anon_sym_gc] = ACTIONS(569),
    [anon_sym_prefix] = ACTIONS(569),
    [anon_sym_prologue] = ACTIONS(569),
    [anon_sym_personality] = ACTIONS(569),
    [anon_sym_alignstack] = ACTIONS(569),
    [anon_sym_allocsize] = ACTIONS(569),
    [anon_sym_alwaysinline] = ACTIONS(569),
    [anon_sym_builtin] = ACTIONS(569),
    [anon_sym_cold] = ACTIONS(569),
    [anon_sym_convergent] = ACTIONS(569),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(569),
    [anon_sym_hot] = ACTIONS(569),
    [anon_sym_inaccessiblememonly] = ACTIONS(569),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(569),
    [anon_sym_inlinehint] = ACTIONS(569),
    [anon_sym_jumptable] = ACTIONS(569),
    [anon_sym_minsize] = ACTIONS(569),
    [anon_sym_naked] = ACTIONS(569),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(569),
    [anon_sym_nobuiltin] = ACTIONS(569),
    [anon_sym_noduplicate] = ACTIONS(569),
    [anon_sym_nofree] = ACTIONS(569),
    [anon_sym_noimplicitfloat] = ACTIONS(569),
    [anon_sym_noinline] = ACTIONS(569),
    [anon_sym_nomerge] = ACTIONS(569),
    [anon_sym_nonlazybind] = ACTIONS(569),
    [anon_sym_noprofile] = ACTIONS(569),
    [anon_sym_noredzone] = ACTIONS(569),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(569),
    [anon_sym_noreturn] = ACTIONS(569),
    [anon_sym_norecurse] = ACTIONS(569),
    [anon_sym_willreturn] = ACTIONS(569),
    [anon_sym_nosync] = ACTIONS(569),
    [anon_sym_nounwind] = ACTIONS(569),
    [anon_sym_nocallback] = ACTIONS(569),
    [anon_sym_nosanitize_coverage] = ACTIONS(569),
    [anon_sym_null_pointer_is_valid] = ACTIONS(569),
    [anon_sym_optforfuzzing] = ACTIONS(569),
    [anon_sym_optnone] = ACTIONS(569),
    [anon_sym_optsize] = ACTIONS(569),
    [anon_sym_readnone] = ACTIONS(569),
    [anon_sym_readonly] = ACTIONS(569),
    [anon_sym_writeonly] = ACTIONS(569),
    [anon_sym_argmemonly] = ACTIONS(569),
    [anon_sym_returns_twice] = ACTIONS(569),
    [anon_sym_safestack] = ACTIONS(569),
    [anon_sym_sanitize_address] = ACTIONS(569),
    [anon_sym_sanitize_memory] = ACTIONS(569),
    [anon_sym_sanitize_thread] = ACTIONS(569),
    [anon_sym_sanitize_hwaddress] = ACTIONS(569),
    [anon_sym_sanitize_memtag] = ACTIONS(569),
    [anon_sym_speculative_load_hardening] = ACTIONS(569),
    [anon_sym_speculatable] = ACTIONS(569),
    [anon_sym_ssp] = ACTIONS(571),
    [anon_sym_sspstrong] = ACTIONS(569),
    [anon_sym_sspreq] = ACTIONS(569),
    [anon_sym_strictfp] = ACTIONS(569),
    [anon_sym_nocf_check] = ACTIONS(569),
    [anon_sym_shadowcallstack] = ACTIONS(569),
    [anon_sym_mustprogress] = ACTIONS(569),
    [anon_sym_vscale_range] = ACTIONS(569),
    [anon_sym_preallocated] = ACTIONS(569),
    [anon_sym_zeroext] = ACTIONS(569),
    [anon_sym_signext] = ACTIONS(569),
    [anon_sym_inreg] = ACTIONS(569),
    [anon_sym_byval] = ACTIONS(569),
    [anon_sym_byref] = ACTIONS(569),
    [anon_sym_inalloca] = ACTIONS(569),
    [anon_sym_sret] = ACTIONS(569),
    [anon_sym_elementtype] = ACTIONS(569),
    [anon_sym_noalias] = ACTIONS(569),
    [anon_sym_nocapture] = ACTIONS(569),
    [anon_sym_nest] = ACTIONS(569),
    [anon_sym_returned] = ACTIONS(569),
    [anon_sym_nonnull] = ACTIONS(569),
    [anon_sym_dereferenceable] = ACTIONS(571),
    [anon_sym_dereferenceable_or_null] = ACTIONS(569),
    [anon_sym_swiftself] = ACTIONS(569),
    [anon_sym_swiftasync] = ACTIONS(569),
    [anon_sym_swifterror] = ACTIONS(569),
    [anon_sym_immarg] = ACTIONS(569),
    [anon_sym_noundef] = ACTIONS(569),
    [anon_sym_uwtable] = ACTIONS(569),
    [anon_sym_memory] = ACTIONS(569),
    [anon_sym_to] = ACTIONS(571),
    [anon_sym_uselistorder] = ACTIONS(571),
    [anon_sym_uselistorder_bb] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_attributes] = ACTIONS(569),
  },
  [331] = {
    [ts_builtin_sym_end] = ACTIONS(561),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(561),
    [sym_comdat_ref] = ACTIONS(561),
    [sym_global_var] = ACTIONS(561),
    [sym_local_var] = ACTIONS(561),
    [aux_sym_metadata_ref_token1] = ACTIONS(561),
    [sym_summary_ref] = ACTIONS(561),
    [sym_string] = ACTIONS(561),
    [anon_sym_target] = ACTIONS(561),
    [anon_sym_source_filename] = ACTIONS(561),
    [anon_sym_declare] = ACTIONS(561),
    [anon_sym_define] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_half] = ACTIONS(561),
    [anon_sym_bfloat] = ACTIONS(561),
    [anon_sym_float] = ACTIONS(561),
    [anon_sym_double] = ACTIONS(561),
    [anon_sym_x86_fp80] = ACTIONS(561),
    [anon_sym_fp128] = ACTIONS(561),
    [anon_sym_ppc_fp128] = ACTIONS(561),
    [anon_sym_label] = ACTIONS(561),
    [anon_sym_metadata] = ACTIONS(561),
    [anon_sym_x86_mmx] = ACTIONS(561),
    [anon_sym_x86_amx] = ACTIONS(561),
    [anon_sym_token] = ACTIONS(561),
    [anon_sym_opaque] = ACTIONS(561),
    [anon_sym_ptr] = ACTIONS(561),
    [aux_sym_type_keyword_token1] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(561),
    [anon_sym_RBRACE] = ACTIONS(561),
    [anon_sym_LT_LBRACE] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(561),
    [anon_sym_RBRACK] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(561),
    [anon_sym_align] = ACTIONS(563),
    [anon_sym_section] = ACTIONS(561),
    [anon_sym_partition] = ACTIONS(561),
    [anon_sym_comdat] = ACTIONS(561),
    [anon_sym_gc] = ACTIONS(561),
    [anon_sym_prefix] = ACTIONS(561),
    [anon_sym_prologue] = ACTIONS(561),
    [anon_sym_personality] = ACTIONS(561),
    [anon_sym_alignstack] = ACTIONS(561),
    [anon_sym_allocsize] = ACTIONS(561),
    [anon_sym_alwaysinline] = ACTIONS(561),
    [anon_sym_builtin] = ACTIONS(561),
    [anon_sym_cold] = ACTIONS(561),
    [anon_sym_convergent] = ACTIONS(561),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(561),
    [anon_sym_hot] = ACTIONS(561),
    [anon_sym_inaccessiblememonly] = ACTIONS(561),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(561),
    [anon_sym_inlinehint] = ACTIONS(561),
    [anon_sym_jumptable] = ACTIONS(561),
    [anon_sym_minsize] = ACTIONS(561),
    [anon_sym_naked] = ACTIONS(561),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(561),
    [anon_sym_nobuiltin] = ACTIONS(561),
    [anon_sym_noduplicate] = ACTIONS(561),
    [anon_sym_nofree] = ACTIONS(561),
    [anon_sym_noimplicitfloat] = ACTIONS(561),
    [anon_sym_noinline] = ACTIONS(561),
    [anon_sym_nomerge] = ACTIONS(561),
    [anon_sym_nonlazybind] = ACTIONS(561),
    [anon_sym_noprofile] = ACTIONS(561),
    [anon_sym_noredzone] = ACTIONS(561),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(561),
    [anon_sym_noreturn] = ACTIONS(561),
    [anon_sym_norecurse] = ACTIONS(561),
    [anon_sym_willreturn] = ACTIONS(561),
    [anon_sym_nosync] = ACTIONS(561),
    [anon_sym_nounwind] = ACTIONS(561),
    [anon_sym_nocallback] = ACTIONS(561),
    [anon_sym_nosanitize_coverage] = ACTIONS(561),
    [anon_sym_null_pointer_is_valid] = ACTIONS(561),
    [anon_sym_optforfuzzing] = ACTIONS(561),
    [anon_sym_optnone] = ACTIONS(561),
    [anon_sym_optsize] = ACTIONS(561),
    [anon_sym_readnone] = ACTIONS(561),
    [anon_sym_readonly] = ACTIONS(561),
    [anon_sym_writeonly] = ACTIONS(561),
    [anon_sym_argmemonly] = ACTIONS(561),
    [anon_sym_returns_twice] = ACTIONS(561),
    [anon_sym_safestack] = ACTIONS(561),
    [anon_sym_sanitize_address] = ACTIONS(561),
    [anon_sym_sanitize_memory] = ACTIONS(561),
    [anon_sym_sanitize_thread] = ACTIONS(561),
    [anon_sym_sanitize_hwaddress] = ACTIONS(561),
    [anon_sym_sanitize_memtag] = ACTIONS(561),
    [anon_sym_speculative_load_hardening] = ACTIONS(561),
    [anon_sym_speculatable] = ACTIONS(561),
    [anon_sym_ssp] = ACTIONS(563),
    [anon_sym_sspstrong] = ACTIONS(561),
    [anon_sym_sspreq] = ACTIONS(561),
    [anon_sym_strictfp] = ACTIONS(561),
    [anon_sym_nocf_check] = ACTIONS(561),
    [anon_sym_shadowcallstack] = ACTIONS(561),
    [anon_sym_mustprogress] = ACTIONS(561),
    [anon_sym_vscale_range] = ACTIONS(561),
    [anon_sym_preallocated] = ACTIONS(561),
    [anon_sym_zeroext] = ACTIONS(561),
    [anon_sym_signext] = ACTIONS(561),
    [anon_sym_inreg] = ACTIONS(561),
    [anon_sym_byval] = ACTIONS(561),
    [anon_sym_byref] = ACTIONS(561),
    [anon_sym_inalloca] = ACTIONS(561),
    [anon_sym_sret] = ACTIONS(561),
    [anon_sym_elementtype] = ACTIONS(561),
    [anon_sym_noalias] = ACTIONS(561),
    [anon_sym_nocapture] = ACTIONS(561),
    [anon_sym_nest] = ACTIONS(561),
    [anon_sym_returned] = ACTIONS(561),
    [anon_sym_nonnull] = ACTIONS(561),
    [anon_sym_dereferenceable] = ACTIONS(563),
    [anon_sym_dereferenceable_or_null] = ACTIONS(561),
    [anon_sym_swiftself] = ACTIONS(561),
    [anon_sym_swiftasync] = ACTIONS(561),
    [anon_sym_swifterror] = ACTIONS(561),
    [anon_sym_immarg] = ACTIONS(561),
    [anon_sym_noundef] = ACTIONS(561),
    [anon_sym_uwtable] = ACTIONS(561),
    [anon_sym_memory] = ACTIONS(561),
    [anon_sym_to] = ACTIONS(563),
    [anon_sym_uselistorder] = ACTIONS(563),
    [anon_sym_uselistorder_bb] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(561),
    [anon_sym_attributes] = ACTIONS(561),
  },
  [332] = {
    [ts_builtin_sym_end] = ACTIONS(631),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(631),
    [sym_comdat_ref] = ACTIONS(631),
    [sym_global_var] = ACTIONS(631),
    [sym_local_var] = ACTIONS(631),
    [aux_sym_metadata_ref_token1] = ACTIONS(631),
    [sym_summary_ref] = ACTIONS(631),
    [sym_string] = ACTIONS(631),
    [anon_sym_target] = ACTIONS(631),
    [anon_sym_source_filename] = ACTIONS(631),
    [anon_sym_declare] = ACTIONS(631),
    [anon_sym_define] = ACTIONS(631),
    [anon_sym_void] = ACTIONS(631),
    [anon_sym_half] = ACTIONS(631),
    [anon_sym_bfloat] = ACTIONS(631),
    [anon_sym_float] = ACTIONS(631),
    [anon_sym_double] = ACTIONS(631),
    [anon_sym_x86_fp80] = ACTIONS(631),
    [anon_sym_fp128] = ACTIONS(631),
    [anon_sym_ppc_fp128] = ACTIONS(631),
    [anon_sym_label] = ACTIONS(631),
    [anon_sym_metadata] = ACTIONS(631),
    [anon_sym_x86_mmx] = ACTIONS(631),
    [anon_sym_x86_amx] = ACTIONS(631),
    [anon_sym_token] = ACTIONS(631),
    [anon_sym_opaque] = ACTIONS(631),
    [anon_sym_ptr] = ACTIONS(631),
    [aux_sym_type_keyword_token1] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(631),
    [anon_sym_RBRACE] = ACTIONS(631),
    [anon_sym_LT_LBRACE] = ACTIONS(631),
    [anon_sym_LBRACK] = ACTIONS(631),
    [anon_sym_RBRACK] = ACTIONS(631),
    [anon_sym_LT] = ACTIONS(633),
    [anon_sym_COMMA] = ACTIONS(631),
    [anon_sym_align] = ACTIONS(633),
    [anon_sym_section] = ACTIONS(631),
    [anon_sym_partition] = ACTIONS(631),
    [anon_sym_comdat] = ACTIONS(631),
    [anon_sym_gc] = ACTIONS(631),
    [anon_sym_prefix] = ACTIONS(631),
    [anon_sym_prologue] = ACTIONS(631),
    [anon_sym_personality] = ACTIONS(631),
    [anon_sym_alignstack] = ACTIONS(631),
    [anon_sym_allocsize] = ACTIONS(631),
    [anon_sym_alwaysinline] = ACTIONS(631),
    [anon_sym_builtin] = ACTIONS(631),
    [anon_sym_cold] = ACTIONS(631),
    [anon_sym_convergent] = ACTIONS(631),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(631),
    [anon_sym_hot] = ACTIONS(631),
    [anon_sym_inaccessiblememonly] = ACTIONS(631),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(631),
    [anon_sym_inlinehint] = ACTIONS(631),
    [anon_sym_jumptable] = ACTIONS(631),
    [anon_sym_minsize] = ACTIONS(631),
    [anon_sym_naked] = ACTIONS(631),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(631),
    [anon_sym_nobuiltin] = ACTIONS(631),
    [anon_sym_noduplicate] = ACTIONS(631),
    [anon_sym_nofree] = ACTIONS(631),
    [anon_sym_noimplicitfloat] = ACTIONS(631),
    [anon_sym_noinline] = ACTIONS(631),
    [anon_sym_nomerge] = ACTIONS(631),
    [anon_sym_nonlazybind] = ACTIONS(631),
    [anon_sym_noprofile] = ACTIONS(631),
    [anon_sym_noredzone] = ACTIONS(631),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(631),
    [anon_sym_noreturn] = ACTIONS(631),
    [anon_sym_norecurse] = ACTIONS(631),
    [anon_sym_willreturn] = ACTIONS(631),
    [anon_sym_nosync] = ACTIONS(631),
    [anon_sym_nounwind] = ACTIONS(631),
    [anon_sym_nocallback] = ACTIONS(631),
    [anon_sym_nosanitize_coverage] = ACTIONS(631),
    [anon_sym_null_pointer_is_valid] = ACTIONS(631),
    [anon_sym_optforfuzzing] = ACTIONS(631),
    [anon_sym_optnone] = ACTIONS(631),
    [anon_sym_optsize] = ACTIONS(631),
    [anon_sym_readnone] = ACTIONS(631),
    [anon_sym_readonly] = ACTIONS(631),
    [anon_sym_writeonly] = ACTIONS(631),
    [anon_sym_argmemonly] = ACTIONS(631),
    [anon_sym_returns_twice] = ACTIONS(631),
    [anon_sym_safestack] = ACTIONS(631),
    [anon_sym_sanitize_address] = ACTIONS(631),
    [anon_sym_sanitize_memory] = ACTIONS(631),
    [anon_sym_sanitize_thread] = ACTIONS(631),
    [anon_sym_sanitize_hwaddress] = ACTIONS(631),
    [anon_sym_sanitize_memtag] = ACTIONS(631),
    [anon_sym_speculative_load_hardening] = ACTIONS(631),
    [anon_sym_speculatable] = ACTIONS(631),
    [anon_sym_ssp] = ACTIONS(633),
    [anon_sym_sspstrong] = ACTIONS(631),
    [anon_sym_sspreq] = ACTIONS(631),
    [anon_sym_strictfp] = ACTIONS(631),
    [anon_sym_nocf_check] = ACTIONS(631),
    [anon_sym_shadowcallstack] = ACTIONS(631),
    [anon_sym_mustprogress] = ACTIONS(631),
    [anon_sym_vscale_range] = ACTIONS(631),
    [anon_sym_preallocated] = ACTIONS(631),
    [anon_sym_zeroext] = ACTIONS(631),
    [anon_sym_signext] = ACTIONS(631),
    [anon_sym_inreg] = ACTIONS(631),
    [anon_sym_byval] = ACTIONS(631),
    [anon_sym_byref] = ACTIONS(631),
    [anon_sym_inalloca] = ACTIONS(631),
    [anon_sym_sret] = ACTIONS(631),
    [anon_sym_elementtype] = ACTIONS(631),
    [anon_sym_noalias] = ACTIONS(631),
    [anon_sym_nocapture] = ACTIONS(631),
    [anon_sym_nest] = ACTIONS(631),
    [anon_sym_returned] = ACTIONS(631),
    [anon_sym_nonnull] = ACTIONS(631),
    [anon_sym_dereferenceable] = ACTIONS(633),
    [anon_sym_dereferenceable_or_null] = ACTIONS(631),
    [anon_sym_swiftself] = ACTIONS(631),
    [anon_sym_swiftasync] = ACTIONS(631),
    [anon_sym_swifterror] = ACTIONS(631),
    [anon_sym_immarg] = ACTIONS(631),
    [anon_sym_noundef] = ACTIONS(631),
    [anon_sym_uwtable] = ACTIONS(631),
    [anon_sym_memory] = ACTIONS(631),
    [anon_sym_to] = ACTIONS(633),
    [anon_sym_uselistorder] = ACTIONS(633),
    [anon_sym_uselistorder_bb] = ACTIONS(631),
    [anon_sym_module] = ACTIONS(631),
    [anon_sym_attributes] = ACTIONS(631),
  },
  [333] = {
    [ts_builtin_sym_end] = ACTIONS(675),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(675),
    [sym_comdat_ref] = ACTIONS(675),
    [sym_global_var] = ACTIONS(675),
    [sym_local_var] = ACTIONS(675),
    [aux_sym_metadata_ref_token1] = ACTIONS(675),
    [sym_summary_ref] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [anon_sym_target] = ACTIONS(675),
    [anon_sym_source_filename] = ACTIONS(675),
    [anon_sym_declare] = ACTIONS(675),
    [anon_sym_define] = ACTIONS(675),
    [anon_sym_void] = ACTIONS(675),
    [anon_sym_half] = ACTIONS(675),
    [anon_sym_bfloat] = ACTIONS(675),
    [anon_sym_float] = ACTIONS(675),
    [anon_sym_double] = ACTIONS(675),
    [anon_sym_x86_fp80] = ACTIONS(675),
    [anon_sym_fp128] = ACTIONS(675),
    [anon_sym_ppc_fp128] = ACTIONS(675),
    [anon_sym_label] = ACTIONS(675),
    [anon_sym_metadata] = ACTIONS(675),
    [anon_sym_x86_mmx] = ACTIONS(675),
    [anon_sym_x86_amx] = ACTIONS(675),
    [anon_sym_token] = ACTIONS(675),
    [anon_sym_opaque] = ACTIONS(675),
    [anon_sym_ptr] = ACTIONS(675),
    [aux_sym_type_keyword_token1] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(675),
    [anon_sym_RBRACE] = ACTIONS(675),
    [anon_sym_LT_LBRACE] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_RBRACK] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(675),
    [anon_sym_align] = ACTIONS(677),
    [anon_sym_section] = ACTIONS(675),
    [anon_sym_partition] = ACTIONS(675),
    [anon_sym_comdat] = ACTIONS(675),
    [anon_sym_gc] = ACTIONS(675),
    [anon_sym_prefix] = ACTIONS(675),
    [anon_sym_prologue] = ACTIONS(675),
    [anon_sym_personality] = ACTIONS(675),
    [anon_sym_alignstack] = ACTIONS(675),
    [anon_sym_allocsize] = ACTIONS(675),
    [anon_sym_alwaysinline] = ACTIONS(675),
    [anon_sym_builtin] = ACTIONS(675),
    [anon_sym_cold] = ACTIONS(675),
    [anon_sym_convergent] = ACTIONS(675),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(675),
    [anon_sym_hot] = ACTIONS(675),
    [anon_sym_inaccessiblememonly] = ACTIONS(675),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(675),
    [anon_sym_inlinehint] = ACTIONS(675),
    [anon_sym_jumptable] = ACTIONS(675),
    [anon_sym_minsize] = ACTIONS(675),
    [anon_sym_naked] = ACTIONS(675),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(675),
    [anon_sym_nobuiltin] = ACTIONS(675),
    [anon_sym_noduplicate] = ACTIONS(675),
    [anon_sym_nofree] = ACTIONS(675),
    [anon_sym_noimplicitfloat] = ACTIONS(675),
    [anon_sym_noinline] = ACTIONS(675),
    [anon_sym_nomerge] = ACTIONS(675),
    [anon_sym_nonlazybind] = ACTIONS(675),
    [anon_sym_noprofile] = ACTIONS(675),
    [anon_sym_noredzone] = ACTIONS(675),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(675),
    [anon_sym_noreturn] = ACTIONS(675),
    [anon_sym_norecurse] = ACTIONS(675),
    [anon_sym_willreturn] = ACTIONS(675),
    [anon_sym_nosync] = ACTIONS(675),
    [anon_sym_nounwind] = ACTIONS(675),
    [anon_sym_nocallback] = ACTIONS(675),
    [anon_sym_nosanitize_coverage] = ACTIONS(675),
    [anon_sym_null_pointer_is_valid] = ACTIONS(675),
    [anon_sym_optforfuzzing] = ACTIONS(675),
    [anon_sym_optnone] = ACTIONS(675),
    [anon_sym_optsize] = ACTIONS(675),
    [anon_sym_readnone] = ACTIONS(675),
    [anon_sym_readonly] = ACTIONS(675),
    [anon_sym_writeonly] = ACTIONS(675),
    [anon_sym_argmemonly] = ACTIONS(675),
    [anon_sym_returns_twice] = ACTIONS(675),
    [anon_sym_safestack] = ACTIONS(675),
    [anon_sym_sanitize_address] = ACTIONS(675),
    [anon_sym_sanitize_memory] = ACTIONS(675),
    [anon_sym_sanitize_thread] = ACTIONS(675),
    [anon_sym_sanitize_hwaddress] = ACTIONS(675),
    [anon_sym_sanitize_memtag] = ACTIONS(675),
    [anon_sym_speculative_load_hardening] = ACTIONS(675),
    [anon_sym_speculatable] = ACTIONS(675),
    [anon_sym_ssp] = ACTIONS(677),
    [anon_sym_sspstrong] = ACTIONS(675),
    [anon_sym_sspreq] = ACTIONS(675),
    [anon_sym_strictfp] = ACTIONS(675),
    [anon_sym_nocf_check] = ACTIONS(675),
    [anon_sym_shadowcallstack] = ACTIONS(675),
    [anon_sym_mustprogress] = ACTIONS(675),
    [anon_sym_vscale_range] = ACTIONS(675),
    [anon_sym_preallocated] = ACTIONS(675),
    [anon_sym_zeroext] = ACTIONS(675),
    [anon_sym_signext] = ACTIONS(675),
    [anon_sym_inreg] = ACTIONS(675),
    [anon_sym_byval] = ACTIONS(675),
    [anon_sym_byref] = ACTIONS(675),
    [anon_sym_inalloca] = ACTIONS(675),
    [anon_sym_sret] = ACTIONS(675),
    [anon_sym_elementtype] = ACTIONS(675),
    [anon_sym_noalias] = ACTIONS(675),
    [anon_sym_nocapture] = ACTIONS(675),
    [anon_sym_nest] = ACTIONS(675),
    [anon_sym_returned] = ACTIONS(675),
    [anon_sym_nonnull] = ACTIONS(675),
    [anon_sym_dereferenceable] = ACTIONS(677),
    [anon_sym_dereferenceable_or_null] = ACTIONS(675),
    [anon_sym_swiftself] = ACTIONS(675),
    [anon_sym_swiftasync] = ACTIONS(675),
    [anon_sym_swifterror] = ACTIONS(675),
    [anon_sym_immarg] = ACTIONS(675),
    [anon_sym_noundef] = ACTIONS(675),
    [anon_sym_uwtable] = ACTIONS(675),
    [anon_sym_memory] = ACTIONS(675),
    [anon_sym_to] = ACTIONS(677),
    [anon_sym_uselistorder] = ACTIONS(677),
    [anon_sym_uselistorder_bb] = ACTIONS(675),
    [anon_sym_module] = ACTIONS(675),
    [anon_sym_attributes] = ACTIONS(675),
  },
  [334] = {
    [ts_builtin_sym_end] = ACTIONS(583),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(583),
    [sym_comdat_ref] = ACTIONS(583),
    [sym_global_var] = ACTIONS(583),
    [sym_local_var] = ACTIONS(583),
    [aux_sym_metadata_ref_token1] = ACTIONS(583),
    [sym_summary_ref] = ACTIONS(583),
    [sym_string] = ACTIONS(583),
    [anon_sym_target] = ACTIONS(583),
    [anon_sym_source_filename] = ACTIONS(583),
    [anon_sym_declare] = ACTIONS(583),
    [anon_sym_define] = ACTIONS(583),
    [anon_sym_void] = ACTIONS(583),
    [anon_sym_half] = ACTIONS(583),
    [anon_sym_bfloat] = ACTIONS(583),
    [anon_sym_float] = ACTIONS(583),
    [anon_sym_double] = ACTIONS(583),
    [anon_sym_x86_fp80] = ACTIONS(583),
    [anon_sym_fp128] = ACTIONS(583),
    [anon_sym_ppc_fp128] = ACTIONS(583),
    [anon_sym_label] = ACTIONS(583),
    [anon_sym_metadata] = ACTIONS(583),
    [anon_sym_x86_mmx] = ACTIONS(583),
    [anon_sym_x86_amx] = ACTIONS(583),
    [anon_sym_token] = ACTIONS(583),
    [anon_sym_opaque] = ACTIONS(583),
    [anon_sym_ptr] = ACTIONS(583),
    [aux_sym_type_keyword_token1] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(583),
    [anon_sym_LT_LBRACE] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(583),
    [anon_sym_RBRACK] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_align] = ACTIONS(585),
    [anon_sym_section] = ACTIONS(583),
    [anon_sym_partition] = ACTIONS(583),
    [anon_sym_comdat] = ACTIONS(583),
    [anon_sym_gc] = ACTIONS(583),
    [anon_sym_prefix] = ACTIONS(583),
    [anon_sym_prologue] = ACTIONS(583),
    [anon_sym_personality] = ACTIONS(583),
    [anon_sym_alignstack] = ACTIONS(583),
    [anon_sym_allocsize] = ACTIONS(583),
    [anon_sym_alwaysinline] = ACTIONS(583),
    [anon_sym_builtin] = ACTIONS(583),
    [anon_sym_cold] = ACTIONS(583),
    [anon_sym_convergent] = ACTIONS(583),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(583),
    [anon_sym_hot] = ACTIONS(583),
    [anon_sym_inaccessiblememonly] = ACTIONS(583),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(583),
    [anon_sym_inlinehint] = ACTIONS(583),
    [anon_sym_jumptable] = ACTIONS(583),
    [anon_sym_minsize] = ACTIONS(583),
    [anon_sym_naked] = ACTIONS(583),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(583),
    [anon_sym_nobuiltin] = ACTIONS(583),
    [anon_sym_noduplicate] = ACTIONS(583),
    [anon_sym_nofree] = ACTIONS(583),
    [anon_sym_noimplicitfloat] = ACTIONS(583),
    [anon_sym_noinline] = ACTIONS(583),
    [anon_sym_nomerge] = ACTIONS(583),
    [anon_sym_nonlazybind] = ACTIONS(583),
    [anon_sym_noprofile] = ACTIONS(583),
    [anon_sym_noredzone] = ACTIONS(583),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(583),
    [anon_sym_noreturn] = ACTIONS(583),
    [anon_sym_norecurse] = ACTIONS(583),
    [anon_sym_willreturn] = ACTIONS(583),
    [anon_sym_nosync] = ACTIONS(583),
    [anon_sym_nounwind] = ACTIONS(583),
    [anon_sym_nocallback] = ACTIONS(583),
    [anon_sym_nosanitize_coverage] = ACTIONS(583),
    [anon_sym_null_pointer_is_valid] = ACTIONS(583),
    [anon_sym_optforfuzzing] = ACTIONS(583),
    [anon_sym_optnone] = ACTIONS(583),
    [anon_sym_optsize] = ACTIONS(583),
    [anon_sym_readnone] = ACTIONS(583),
    [anon_sym_readonly] = ACTIONS(583),
    [anon_sym_writeonly] = ACTIONS(583),
    [anon_sym_argmemonly] = ACTIONS(583),
    [anon_sym_returns_twice] = ACTIONS(583),
    [anon_sym_safestack] = ACTIONS(583),
    [anon_sym_sanitize_address] = ACTIONS(583),
    [anon_sym_sanitize_memory] = ACTIONS(583),
    [anon_sym_sanitize_thread] = ACTIONS(583),
    [anon_sym_sanitize_hwaddress] = ACTIONS(583),
    [anon_sym_sanitize_memtag] = ACTIONS(583),
    [anon_sym_speculative_load_hardening] = ACTIONS(583),
    [anon_sym_speculatable] = ACTIONS(583),
    [anon_sym_ssp] = ACTIONS(585),
    [anon_sym_sspstrong] = ACTIONS(583),
    [anon_sym_sspreq] = ACTIONS(583),
    [anon_sym_strictfp] = ACTIONS(583),
    [anon_sym_nocf_check] = ACTIONS(583),
    [anon_sym_shadowcallstack] = ACTIONS(583),
    [anon_sym_mustprogress] = ACTIONS(583),
    [anon_sym_vscale_range] = ACTIONS(583),
    [anon_sym_preallocated] = ACTIONS(583),
    [anon_sym_zeroext] = ACTIONS(583),
    [anon_sym_signext] = ACTIONS(583),
    [anon_sym_inreg] = ACTIONS(583),
    [anon_sym_byval] = ACTIONS(583),
    [anon_sym_byref] = ACTIONS(583),
    [anon_sym_inalloca] = ACTIONS(583),
    [anon_sym_sret] = ACTIONS(583),
    [anon_sym_elementtype] = ACTIONS(583),
    [anon_sym_noalias] = ACTIONS(583),
    [anon_sym_nocapture] = ACTIONS(583),
    [anon_sym_nest] = ACTIONS(583),
    [anon_sym_returned] = ACTIONS(583),
    [anon_sym_nonnull] = ACTIONS(583),
    [anon_sym_dereferenceable] = ACTIONS(585),
    [anon_sym_dereferenceable_or_null] = ACTIONS(583),
    [anon_sym_swiftself] = ACTIONS(583),
    [anon_sym_swiftasync] = ACTIONS(583),
    [anon_sym_swifterror] = ACTIONS(583),
    [anon_sym_immarg] = ACTIONS(583),
    [anon_sym_noundef] = ACTIONS(583),
    [anon_sym_uwtable] = ACTIONS(583),
    [anon_sym_memory] = ACTIONS(583),
    [anon_sym_to] = ACTIONS(585),
    [anon_sym_uselistorder] = ACTIONS(585),
    [anon_sym_uselistorder_bb] = ACTIONS(583),
    [anon_sym_module] = ACTIONS(583),
    [anon_sym_attributes] = ACTIONS(583),
  },
  [335] = {
    [ts_builtin_sym_end] = ACTIONS(667),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(667),
    [sym_comdat_ref] = ACTIONS(667),
    [sym_global_var] = ACTIONS(667),
    [sym_local_var] = ACTIONS(667),
    [aux_sym_metadata_ref_token1] = ACTIONS(667),
    [sym_summary_ref] = ACTIONS(667),
    [sym_string] = ACTIONS(667),
    [anon_sym_target] = ACTIONS(667),
    [anon_sym_source_filename] = ACTIONS(667),
    [anon_sym_declare] = ACTIONS(667),
    [anon_sym_define] = ACTIONS(667),
    [anon_sym_void] = ACTIONS(667),
    [anon_sym_half] = ACTIONS(667),
    [anon_sym_bfloat] = ACTIONS(667),
    [anon_sym_float] = ACTIONS(667),
    [anon_sym_double] = ACTIONS(667),
    [anon_sym_x86_fp80] = ACTIONS(667),
    [anon_sym_fp128] = ACTIONS(667),
    [anon_sym_ppc_fp128] = ACTIONS(667),
    [anon_sym_label] = ACTIONS(667),
    [anon_sym_metadata] = ACTIONS(667),
    [anon_sym_x86_mmx] = ACTIONS(667),
    [anon_sym_x86_amx] = ACTIONS(667),
    [anon_sym_token] = ACTIONS(667),
    [anon_sym_opaque] = ACTIONS(667),
    [anon_sym_ptr] = ACTIONS(667),
    [aux_sym_type_keyword_token1] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(667),
    [anon_sym_LT_LBRACE] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(667),
    [anon_sym_RBRACK] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(669),
    [anon_sym_COMMA] = ACTIONS(667),
    [anon_sym_align] = ACTIONS(669),
    [anon_sym_section] = ACTIONS(667),
    [anon_sym_partition] = ACTIONS(667),
    [anon_sym_comdat] = ACTIONS(667),
    [anon_sym_gc] = ACTIONS(667),
    [anon_sym_prefix] = ACTIONS(667),
    [anon_sym_prologue] = ACTIONS(667),
    [anon_sym_personality] = ACTIONS(667),
    [anon_sym_alignstack] = ACTIONS(667),
    [anon_sym_allocsize] = ACTIONS(667),
    [anon_sym_alwaysinline] = ACTIONS(667),
    [anon_sym_builtin] = ACTIONS(667),
    [anon_sym_cold] = ACTIONS(667),
    [anon_sym_convergent] = ACTIONS(667),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(667),
    [anon_sym_hot] = ACTIONS(667),
    [anon_sym_inaccessiblememonly] = ACTIONS(667),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(667),
    [anon_sym_inlinehint] = ACTIONS(667),
    [anon_sym_jumptable] = ACTIONS(667),
    [anon_sym_minsize] = ACTIONS(667),
    [anon_sym_naked] = ACTIONS(667),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(667),
    [anon_sym_nobuiltin] = ACTIONS(667),
    [anon_sym_noduplicate] = ACTIONS(667),
    [anon_sym_nofree] = ACTIONS(667),
    [anon_sym_noimplicitfloat] = ACTIONS(667),
    [anon_sym_noinline] = ACTIONS(667),
    [anon_sym_nomerge] = ACTIONS(667),
    [anon_sym_nonlazybind] = ACTIONS(667),
    [anon_sym_noprofile] = ACTIONS(667),
    [anon_sym_noredzone] = ACTIONS(667),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(667),
    [anon_sym_noreturn] = ACTIONS(667),
    [anon_sym_norecurse] = ACTIONS(667),
    [anon_sym_willreturn] = ACTIONS(667),
    [anon_sym_nosync] = ACTIONS(667),
    [anon_sym_nounwind] = ACTIONS(667),
    [anon_sym_nocallback] = ACTIONS(667),
    [anon_sym_nosanitize_coverage] = ACTIONS(667),
    [anon_sym_null_pointer_is_valid] = ACTIONS(667),
    [anon_sym_optforfuzzing] = ACTIONS(667),
    [anon_sym_optnone] = ACTIONS(667),
    [anon_sym_optsize] = ACTIONS(667),
    [anon_sym_readnone] = ACTIONS(667),
    [anon_sym_readonly] = ACTIONS(667),
    [anon_sym_writeonly] = ACTIONS(667),
    [anon_sym_argmemonly] = ACTIONS(667),
    [anon_sym_returns_twice] = ACTIONS(667),
    [anon_sym_safestack] = ACTIONS(667),
    [anon_sym_sanitize_address] = ACTIONS(667),
    [anon_sym_sanitize_memory] = ACTIONS(667),
    [anon_sym_sanitize_thread] = ACTIONS(667),
    [anon_sym_sanitize_hwaddress] = ACTIONS(667),
    [anon_sym_sanitize_memtag] = ACTIONS(667),
    [anon_sym_speculative_load_hardening] = ACTIONS(667),
    [anon_sym_speculatable] = ACTIONS(667),
    [anon_sym_ssp] = ACTIONS(669),
    [anon_sym_sspstrong] = ACTIONS(667),
    [anon_sym_sspreq] = ACTIONS(667),
    [anon_sym_strictfp] = ACTIONS(667),
    [anon_sym_nocf_check] = ACTIONS(667),
    [anon_sym_shadowcallstack] = ACTIONS(667),
    [anon_sym_mustprogress] = ACTIONS(667),
    [anon_sym_vscale_range] = ACTIONS(667),
    [anon_sym_preallocated] = ACTIONS(667),
    [anon_sym_zeroext] = ACTIONS(667),
    [anon_sym_signext] = ACTIONS(667),
    [anon_sym_inreg] = ACTIONS(667),
    [anon_sym_byval] = ACTIONS(667),
    [anon_sym_byref] = ACTIONS(667),
    [anon_sym_inalloca] = ACTIONS(667),
    [anon_sym_sret] = ACTIONS(667),
    [anon_sym_elementtype] = ACTIONS(667),
    [anon_sym_noalias] = ACTIONS(667),
    [anon_sym_nocapture] = ACTIONS(667),
    [anon_sym_nest] = ACTIONS(667),
    [anon_sym_returned] = ACTIONS(667),
    [anon_sym_nonnull] = ACTIONS(667),
    [anon_sym_dereferenceable] = ACTIONS(669),
    [anon_sym_dereferenceable_or_null] = ACTIONS(667),
    [anon_sym_swiftself] = ACTIONS(667),
    [anon_sym_swiftasync] = ACTIONS(667),
    [anon_sym_swifterror] = ACTIONS(667),
    [anon_sym_immarg] = ACTIONS(667),
    [anon_sym_noundef] = ACTIONS(667),
    [anon_sym_uwtable] = ACTIONS(667),
    [anon_sym_memory] = ACTIONS(667),
    [anon_sym_to] = ACTIONS(669),
    [anon_sym_uselistorder] = ACTIONS(669),
    [anon_sym_uselistorder_bb] = ACTIONS(667),
    [anon_sym_module] = ACTIONS(667),
    [anon_sym_attributes] = ACTIONS(667),
  },
  [336] = {
    [ts_builtin_sym_end] = ACTIONS(591),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(591),
    [sym_comdat_ref] = ACTIONS(591),
    [sym_global_var] = ACTIONS(591),
    [sym_local_var] = ACTIONS(591),
    [aux_sym_metadata_ref_token1] = ACTIONS(591),
    [sym_summary_ref] = ACTIONS(591),
    [sym_string] = ACTIONS(591),
    [anon_sym_target] = ACTIONS(591),
    [anon_sym_source_filename] = ACTIONS(591),
    [anon_sym_declare] = ACTIONS(591),
    [anon_sym_define] = ACTIONS(591),
    [anon_sym_void] = ACTIONS(591),
    [anon_sym_half] = ACTIONS(591),
    [anon_sym_bfloat] = ACTIONS(591),
    [anon_sym_float] = ACTIONS(591),
    [anon_sym_double] = ACTIONS(591),
    [anon_sym_x86_fp80] = ACTIONS(591),
    [anon_sym_fp128] = ACTIONS(591),
    [anon_sym_ppc_fp128] = ACTIONS(591),
    [anon_sym_label] = ACTIONS(591),
    [anon_sym_metadata] = ACTIONS(591),
    [anon_sym_x86_mmx] = ACTIONS(591),
    [anon_sym_x86_amx] = ACTIONS(591),
    [anon_sym_token] = ACTIONS(591),
    [anon_sym_opaque] = ACTIONS(591),
    [anon_sym_ptr] = ACTIONS(591),
    [aux_sym_type_keyword_token1] = ACTIONS(591),
    [anon_sym_LBRACE] = ACTIONS(591),
    [anon_sym_RBRACE] = ACTIONS(591),
    [anon_sym_LT_LBRACE] = ACTIONS(591),
    [anon_sym_LBRACK] = ACTIONS(591),
    [anon_sym_RBRACK] = ACTIONS(591),
    [anon_sym_LT] = ACTIONS(593),
    [anon_sym_COMMA] = ACTIONS(591),
    [anon_sym_align] = ACTIONS(593),
    [anon_sym_section] = ACTIONS(591),
    [anon_sym_partition] = ACTIONS(591),
    [anon_sym_comdat] = ACTIONS(591),
    [anon_sym_gc] = ACTIONS(591),
    [anon_sym_prefix] = ACTIONS(591),
    [anon_sym_prologue] = ACTIONS(591),
    [anon_sym_personality] = ACTIONS(591),
    [anon_sym_alignstack] = ACTIONS(591),
    [anon_sym_allocsize] = ACTIONS(591),
    [anon_sym_alwaysinline] = ACTIONS(591),
    [anon_sym_builtin] = ACTIONS(591),
    [anon_sym_cold] = ACTIONS(591),
    [anon_sym_convergent] = ACTIONS(591),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(591),
    [anon_sym_hot] = ACTIONS(591),
    [anon_sym_inaccessiblememonly] = ACTIONS(591),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(591),
    [anon_sym_inlinehint] = ACTIONS(591),
    [anon_sym_jumptable] = ACTIONS(591),
    [anon_sym_minsize] = ACTIONS(591),
    [anon_sym_naked] = ACTIONS(591),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(591),
    [anon_sym_nobuiltin] = ACTIONS(591),
    [anon_sym_noduplicate] = ACTIONS(591),
    [anon_sym_nofree] = ACTIONS(591),
    [anon_sym_noimplicitfloat] = ACTIONS(591),
    [anon_sym_noinline] = ACTIONS(591),
    [anon_sym_nomerge] = ACTIONS(591),
    [anon_sym_nonlazybind] = ACTIONS(591),
    [anon_sym_noprofile] = ACTIONS(591),
    [anon_sym_noredzone] = ACTIONS(591),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(591),
    [anon_sym_noreturn] = ACTIONS(591),
    [anon_sym_norecurse] = ACTIONS(591),
    [anon_sym_willreturn] = ACTIONS(591),
    [anon_sym_nosync] = ACTIONS(591),
    [anon_sym_nounwind] = ACTIONS(591),
    [anon_sym_nocallback] = ACTIONS(591),
    [anon_sym_nosanitize_coverage] = ACTIONS(591),
    [anon_sym_null_pointer_is_valid] = ACTIONS(591),
    [anon_sym_optforfuzzing] = ACTIONS(591),
    [anon_sym_optnone] = ACTIONS(591),
    [anon_sym_optsize] = ACTIONS(591),
    [anon_sym_readnone] = ACTIONS(591),
    [anon_sym_readonly] = ACTIONS(591),
    [anon_sym_writeonly] = ACTIONS(591),
    [anon_sym_argmemonly] = ACTIONS(591),
    [anon_sym_returns_twice] = ACTIONS(591),
    [anon_sym_safestack] = ACTIONS(591),
    [anon_sym_sanitize_address] = ACTIONS(591),
    [anon_sym_sanitize_memory] = ACTIONS(591),
    [anon_sym_sanitize_thread] = ACTIONS(591),
    [anon_sym_sanitize_hwaddress] = ACTIONS(591),
    [anon_sym_sanitize_memtag] = ACTIONS(591),
    [anon_sym_speculative_load_hardening] = ACTIONS(591),
    [anon_sym_speculatable] = ACTIONS(591),
    [anon_sym_ssp] = ACTIONS(593),
    [anon_sym_sspstrong] = ACTIONS(591),
    [anon_sym_sspreq] = ACTIONS(591),
    [anon_sym_strictfp] = ACTIONS(591),
    [anon_sym_nocf_check] = ACTIONS(591),
    [anon_sym_shadowcallstack] = ACTIONS(591),
    [anon_sym_mustprogress] = ACTIONS(591),
    [anon_sym_vscale_range] = ACTIONS(591),
    [anon_sym_preallocated] = ACTIONS(591),
    [anon_sym_zeroext] = ACTIONS(591),
    [anon_sym_signext] = ACTIONS(591),
    [anon_sym_inreg] = ACTIONS(591),
    [anon_sym_byval] = ACTIONS(591),
    [anon_sym_byref] = ACTIONS(591),
    [anon_sym_inalloca] = ACTIONS(591),
    [anon_sym_sret] = ACTIONS(591),
    [anon_sym_elementtype] = ACTIONS(591),
    [anon_sym_noalias] = ACTIONS(591),
    [anon_sym_nocapture] = ACTIONS(591),
    [anon_sym_nest] = ACTIONS(591),
    [anon_sym_returned] = ACTIONS(591),
    [anon_sym_nonnull] = ACTIONS(591),
    [anon_sym_dereferenceable] = ACTIONS(593),
    [anon_sym_dereferenceable_or_null] = ACTIONS(591),
    [anon_sym_swiftself] = ACTIONS(591),
    [anon_sym_swiftasync] = ACTIONS(591),
    [anon_sym_swifterror] = ACTIONS(591),
    [anon_sym_immarg] = ACTIONS(591),
    [anon_sym_noundef] = ACTIONS(591),
    [anon_sym_uwtable] = ACTIONS(591),
    [anon_sym_memory] = ACTIONS(591),
    [anon_sym_to] = ACTIONS(593),
    [anon_sym_uselistorder] = ACTIONS(593),
    [anon_sym_uselistorder_bb] = ACTIONS(591),
    [anon_sym_module] = ACTIONS(591),
    [anon_sym_attributes] = ACTIONS(591),
  },
  [337] = {
    [ts_builtin_sym_end] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(587),
    [sym_comdat_ref] = ACTIONS(587),
    [sym_global_var] = ACTIONS(587),
    [sym_local_var] = ACTIONS(587),
    [aux_sym_metadata_ref_token1] = ACTIONS(587),
    [sym_summary_ref] = ACTIONS(587),
    [sym_string] = ACTIONS(587),
    [anon_sym_target] = ACTIONS(587),
    [anon_sym_source_filename] = ACTIONS(587),
    [anon_sym_declare] = ACTIONS(587),
    [anon_sym_define] = ACTIONS(587),
    [anon_sym_void] = ACTIONS(587),
    [anon_sym_half] = ACTIONS(587),
    [anon_sym_bfloat] = ACTIONS(587),
    [anon_sym_float] = ACTIONS(587),
    [anon_sym_double] = ACTIONS(587),
    [anon_sym_x86_fp80] = ACTIONS(587),
    [anon_sym_fp128] = ACTIONS(587),
    [anon_sym_ppc_fp128] = ACTIONS(587),
    [anon_sym_label] = ACTIONS(587),
    [anon_sym_metadata] = ACTIONS(587),
    [anon_sym_x86_mmx] = ACTIONS(587),
    [anon_sym_x86_amx] = ACTIONS(587),
    [anon_sym_token] = ACTIONS(587),
    [anon_sym_opaque] = ACTIONS(587),
    [anon_sym_ptr] = ACTIONS(587),
    [aux_sym_type_keyword_token1] = ACTIONS(587),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_RBRACE] = ACTIONS(587),
    [anon_sym_LT_LBRACE] = ACTIONS(587),
    [anon_sym_LBRACK] = ACTIONS(587),
    [anon_sym_RBRACK] = ACTIONS(587),
    [anon_sym_LT] = ACTIONS(589),
    [anon_sym_COMMA] = ACTIONS(587),
    [anon_sym_align] = ACTIONS(589),
    [anon_sym_section] = ACTIONS(587),
    [anon_sym_partition] = ACTIONS(587),
    [anon_sym_comdat] = ACTIONS(587),
    [anon_sym_gc] = ACTIONS(587),
    [anon_sym_prefix] = ACTIONS(587),
    [anon_sym_prologue] = ACTIONS(587),
    [anon_sym_personality] = ACTIONS(587),
    [anon_sym_alignstack] = ACTIONS(587),
    [anon_sym_allocsize] = ACTIONS(587),
    [anon_sym_alwaysinline] = ACTIONS(587),
    [anon_sym_builtin] = ACTIONS(587),
    [anon_sym_cold] = ACTIONS(587),
    [anon_sym_convergent] = ACTIONS(587),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(587),
    [anon_sym_hot] = ACTIONS(587),
    [anon_sym_inaccessiblememonly] = ACTIONS(587),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(587),
    [anon_sym_inlinehint] = ACTIONS(587),
    [anon_sym_jumptable] = ACTIONS(587),
    [anon_sym_minsize] = ACTIONS(587),
    [anon_sym_naked] = ACTIONS(587),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(587),
    [anon_sym_nobuiltin] = ACTIONS(587),
    [anon_sym_noduplicate] = ACTIONS(587),
    [anon_sym_nofree] = ACTIONS(587),
    [anon_sym_noimplicitfloat] = ACTIONS(587),
    [anon_sym_noinline] = ACTIONS(587),
    [anon_sym_nomerge] = ACTIONS(587),
    [anon_sym_nonlazybind] = ACTIONS(587),
    [anon_sym_noprofile] = ACTIONS(587),
    [anon_sym_noredzone] = ACTIONS(587),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(587),
    [anon_sym_noreturn] = ACTIONS(587),
    [anon_sym_norecurse] = ACTIONS(587),
    [anon_sym_willreturn] = ACTIONS(587),
    [anon_sym_nosync] = ACTIONS(587),
    [anon_sym_nounwind] = ACTIONS(587),
    [anon_sym_nocallback] = ACTIONS(587),
    [anon_sym_nosanitize_coverage] = ACTIONS(587),
    [anon_sym_null_pointer_is_valid] = ACTIONS(587),
    [anon_sym_optforfuzzing] = ACTIONS(587),
    [anon_sym_optnone] = ACTIONS(587),
    [anon_sym_optsize] = ACTIONS(587),
    [anon_sym_readnone] = ACTIONS(587),
    [anon_sym_readonly] = ACTIONS(587),
    [anon_sym_writeonly] = ACTIONS(587),
    [anon_sym_argmemonly] = ACTIONS(587),
    [anon_sym_returns_twice] = ACTIONS(587),
    [anon_sym_safestack] = ACTIONS(587),
    [anon_sym_sanitize_address] = ACTIONS(587),
    [anon_sym_sanitize_memory] = ACTIONS(587),
    [anon_sym_sanitize_thread] = ACTIONS(587),
    [anon_sym_sanitize_hwaddress] = ACTIONS(587),
    [anon_sym_sanitize_memtag] = ACTIONS(587),
    [anon_sym_speculative_load_hardening] = ACTIONS(587),
    [anon_sym_speculatable] = ACTIONS(587),
    [anon_sym_ssp] = ACTIONS(589),
    [anon_sym_sspstrong] = ACTIONS(587),
    [anon_sym_sspreq] = ACTIONS(587),
    [anon_sym_strictfp] = ACTIONS(587),
    [anon_sym_nocf_check] = ACTIONS(587),
    [anon_sym_shadowcallstack] = ACTIONS(587),
    [anon_sym_mustprogress] = ACTIONS(587),
    [anon_sym_vscale_range] = ACTIONS(587),
    [anon_sym_preallocated] = ACTIONS(587),
    [anon_sym_zeroext] = ACTIONS(587),
    [anon_sym_signext] = ACTIONS(587),
    [anon_sym_inreg] = ACTIONS(587),
    [anon_sym_byval] = ACTIONS(587),
    [anon_sym_byref] = ACTIONS(587),
    [anon_sym_inalloca] = ACTIONS(587),
    [anon_sym_sret] = ACTIONS(587),
    [anon_sym_elementtype] = ACTIONS(587),
    [anon_sym_noalias] = ACTIONS(587),
    [anon_sym_nocapture] = ACTIONS(587),
    [anon_sym_nest] = ACTIONS(587),
    [anon_sym_returned] = ACTIONS(587),
    [anon_sym_nonnull] = ACTIONS(587),
    [anon_sym_dereferenceable] = ACTIONS(589),
    [anon_sym_dereferenceable_or_null] = ACTIONS(587),
    [anon_sym_swiftself] = ACTIONS(587),
    [anon_sym_swiftasync] = ACTIONS(587),
    [anon_sym_swifterror] = ACTIONS(587),
    [anon_sym_immarg] = ACTIONS(587),
    [anon_sym_noundef] = ACTIONS(587),
    [anon_sym_uwtable] = ACTIONS(587),
    [anon_sym_memory] = ACTIONS(587),
    [anon_sym_to] = ACTIONS(589),
    [anon_sym_uselistorder] = ACTIONS(589),
    [anon_sym_uselistorder_bb] = ACTIONS(587),
    [anon_sym_module] = ACTIONS(587),
    [anon_sym_attributes] = ACTIONS(587),
  },
  [338] = {
    [ts_builtin_sym_end] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(709),
    [sym_comdat_ref] = ACTIONS(709),
    [sym_global_var] = ACTIONS(709),
    [sym_local_var] = ACTIONS(709),
    [aux_sym_metadata_ref_token1] = ACTIONS(709),
    [sym_summary_ref] = ACTIONS(709),
    [sym_string] = ACTIONS(709),
    [anon_sym_target] = ACTIONS(709),
    [anon_sym_source_filename] = ACTIONS(709),
    [anon_sym_declare] = ACTIONS(709),
    [anon_sym_define] = ACTIONS(709),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_half] = ACTIONS(709),
    [anon_sym_bfloat] = ACTIONS(709),
    [anon_sym_float] = ACTIONS(709),
    [anon_sym_double] = ACTIONS(709),
    [anon_sym_x86_fp80] = ACTIONS(709),
    [anon_sym_fp128] = ACTIONS(709),
    [anon_sym_ppc_fp128] = ACTIONS(709),
    [anon_sym_label] = ACTIONS(709),
    [anon_sym_metadata] = ACTIONS(709),
    [anon_sym_x86_mmx] = ACTIONS(709),
    [anon_sym_x86_amx] = ACTIONS(709),
    [anon_sym_token] = ACTIONS(709),
    [anon_sym_opaque] = ACTIONS(709),
    [anon_sym_ptr] = ACTIONS(709),
    [aux_sym_type_keyword_token1] = ACTIONS(709),
    [anon_sym_LBRACE] = ACTIONS(709),
    [anon_sym_RBRACE] = ACTIONS(709),
    [anon_sym_LT_LBRACE] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(709),
    [anon_sym_RBRACK] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_COMMA] = ACTIONS(709),
    [anon_sym_align] = ACTIONS(711),
    [anon_sym_section] = ACTIONS(709),
    [anon_sym_partition] = ACTIONS(709),
    [anon_sym_comdat] = ACTIONS(709),
    [anon_sym_gc] = ACTIONS(709),
    [anon_sym_prefix] = ACTIONS(709),
    [anon_sym_prologue] = ACTIONS(709),
    [anon_sym_personality] = ACTIONS(709),
    [anon_sym_alignstack] = ACTIONS(709),
    [anon_sym_allocsize] = ACTIONS(709),
    [anon_sym_alwaysinline] = ACTIONS(709),
    [anon_sym_builtin] = ACTIONS(709),
    [anon_sym_cold] = ACTIONS(709),
    [anon_sym_convergent] = ACTIONS(709),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(709),
    [anon_sym_hot] = ACTIONS(709),
    [anon_sym_inaccessiblememonly] = ACTIONS(709),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(709),
    [anon_sym_inlinehint] = ACTIONS(709),
    [anon_sym_jumptable] = ACTIONS(709),
    [anon_sym_minsize] = ACTIONS(709),
    [anon_sym_naked] = ACTIONS(709),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(709),
    [anon_sym_nobuiltin] = ACTIONS(709),
    [anon_sym_noduplicate] = ACTIONS(709),
    [anon_sym_nofree] = ACTIONS(709),
    [anon_sym_noimplicitfloat] = ACTIONS(709),
    [anon_sym_noinline] = ACTIONS(709),
    [anon_sym_nomerge] = ACTIONS(709),
    [anon_sym_nonlazybind] = ACTIONS(709),
    [anon_sym_noprofile] = ACTIONS(709),
    [anon_sym_noredzone] = ACTIONS(709),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(709),
    [anon_sym_noreturn] = ACTIONS(709),
    [anon_sym_norecurse] = ACTIONS(709),
    [anon_sym_willreturn] = ACTIONS(709),
    [anon_sym_nosync] = ACTIONS(709),
    [anon_sym_nounwind] = ACTIONS(709),
    [anon_sym_nocallback] = ACTIONS(709),
    [anon_sym_nosanitize_coverage] = ACTIONS(709),
    [anon_sym_null_pointer_is_valid] = ACTIONS(709),
    [anon_sym_optforfuzzing] = ACTIONS(709),
    [anon_sym_optnone] = ACTIONS(709),
    [anon_sym_optsize] = ACTIONS(709),
    [anon_sym_readnone] = ACTIONS(709),
    [anon_sym_readonly] = ACTIONS(709),
    [anon_sym_writeonly] = ACTIONS(709),
    [anon_sym_argmemonly] = ACTIONS(709),
    [anon_sym_returns_twice] = ACTIONS(709),
    [anon_sym_safestack] = ACTIONS(709),
    [anon_sym_sanitize_address] = ACTIONS(709),
    [anon_sym_sanitize_memory] = ACTIONS(709),
    [anon_sym_sanitize_thread] = ACTIONS(709),
    [anon_sym_sanitize_hwaddress] = ACTIONS(709),
    [anon_sym_sanitize_memtag] = ACTIONS(709),
    [anon_sym_speculative_load_hardening] = ACTIONS(709),
    [anon_sym_speculatable] = ACTIONS(709),
    [anon_sym_ssp] = ACTIONS(711),
    [anon_sym_sspstrong] = ACTIONS(709),
    [anon_sym_sspreq] = ACTIONS(709),
    [anon_sym_strictfp] = ACTIONS(709),
    [anon_sym_nocf_check] = ACTIONS(709),
    [anon_sym_shadowcallstack] = ACTIONS(709),
    [anon_sym_mustprogress] = ACTIONS(709),
    [anon_sym_vscale_range] = ACTIONS(709),
    [anon_sym_preallocated] = ACTIONS(709),
    [anon_sym_zeroext] = ACTIONS(709),
    [anon_sym_signext] = ACTIONS(709),
    [anon_sym_inreg] = ACTIONS(709),
    [anon_sym_byval] = ACTIONS(709),
    [anon_sym_byref] = ACTIONS(709),
    [anon_sym_inalloca] = ACTIONS(709),
    [anon_sym_sret] = ACTIONS(709),
    [anon_sym_elementtype] = ACTIONS(709),
    [anon_sym_noalias] = ACTIONS(709),
    [anon_sym_nocapture] = ACTIONS(709),
    [anon_sym_nest] = ACTIONS(709),
    [anon_sym_returned] = ACTIONS(709),
    [anon_sym_nonnull] = ACTIONS(709),
    [anon_sym_dereferenceable] = ACTIONS(711),
    [anon_sym_dereferenceable_or_null] = ACTIONS(709),
    [anon_sym_swiftself] = ACTIONS(709),
    [anon_sym_swiftasync] = ACTIONS(709),
    [anon_sym_swifterror] = ACTIONS(709),
    [anon_sym_immarg] = ACTIONS(709),
    [anon_sym_noundef] = ACTIONS(709),
    [anon_sym_uwtable] = ACTIONS(709),
    [anon_sym_memory] = ACTIONS(709),
    [anon_sym_to] = ACTIONS(711),
    [anon_sym_uselistorder] = ACTIONS(711),
    [anon_sym_uselistorder_bb] = ACTIONS(709),
    [anon_sym_module] = ACTIONS(709),
    [anon_sym_attributes] = ACTIONS(709),
  },
  [339] = {
    [ts_builtin_sym_end] = ACTIONS(679),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(679),
    [sym_comdat_ref] = ACTIONS(679),
    [sym_global_var] = ACTIONS(679),
    [sym_local_var] = ACTIONS(679),
    [aux_sym_metadata_ref_token1] = ACTIONS(679),
    [sym_summary_ref] = ACTIONS(679),
    [sym_string] = ACTIONS(679),
    [anon_sym_target] = ACTIONS(679),
    [anon_sym_source_filename] = ACTIONS(679),
    [anon_sym_declare] = ACTIONS(679),
    [anon_sym_define] = ACTIONS(679),
    [anon_sym_void] = ACTIONS(679),
    [anon_sym_half] = ACTIONS(679),
    [anon_sym_bfloat] = ACTIONS(679),
    [anon_sym_float] = ACTIONS(679),
    [anon_sym_double] = ACTIONS(679),
    [anon_sym_x86_fp80] = ACTIONS(679),
    [anon_sym_fp128] = ACTIONS(679),
    [anon_sym_ppc_fp128] = ACTIONS(679),
    [anon_sym_label] = ACTIONS(679),
    [anon_sym_metadata] = ACTIONS(679),
    [anon_sym_x86_mmx] = ACTIONS(679),
    [anon_sym_x86_amx] = ACTIONS(679),
    [anon_sym_token] = ACTIONS(679),
    [anon_sym_opaque] = ACTIONS(679),
    [anon_sym_ptr] = ACTIONS(679),
    [aux_sym_type_keyword_token1] = ACTIONS(679),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(679),
    [anon_sym_LT_LBRACE] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(679),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_COMMA] = ACTIONS(679),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_section] = ACTIONS(679),
    [anon_sym_partition] = ACTIONS(679),
    [anon_sym_comdat] = ACTIONS(679),
    [anon_sym_gc] = ACTIONS(679),
    [anon_sym_prefix] = ACTIONS(679),
    [anon_sym_prologue] = ACTIONS(679),
    [anon_sym_personality] = ACTIONS(679),
    [anon_sym_alignstack] = ACTIONS(679),
    [anon_sym_allocsize] = ACTIONS(679),
    [anon_sym_alwaysinline] = ACTIONS(679),
    [anon_sym_builtin] = ACTIONS(679),
    [anon_sym_cold] = ACTIONS(679),
    [anon_sym_convergent] = ACTIONS(679),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(679),
    [anon_sym_hot] = ACTIONS(679),
    [anon_sym_inaccessiblememonly] = ACTIONS(679),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(679),
    [anon_sym_inlinehint] = ACTIONS(679),
    [anon_sym_jumptable] = ACTIONS(679),
    [anon_sym_minsize] = ACTIONS(679),
    [anon_sym_naked] = ACTIONS(679),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(679),
    [anon_sym_nobuiltin] = ACTIONS(679),
    [anon_sym_noduplicate] = ACTIONS(679),
    [anon_sym_nofree] = ACTIONS(679),
    [anon_sym_noimplicitfloat] = ACTIONS(679),
    [anon_sym_noinline] = ACTIONS(679),
    [anon_sym_nomerge] = ACTIONS(679),
    [anon_sym_nonlazybind] = ACTIONS(679),
    [anon_sym_noprofile] = ACTIONS(679),
    [anon_sym_noredzone] = ACTIONS(679),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(679),
    [anon_sym_noreturn] = ACTIONS(679),
    [anon_sym_norecurse] = ACTIONS(679),
    [anon_sym_willreturn] = ACTIONS(679),
    [anon_sym_nosync] = ACTIONS(679),
    [anon_sym_nounwind] = ACTIONS(679),
    [anon_sym_nocallback] = ACTIONS(679),
    [anon_sym_nosanitize_coverage] = ACTIONS(679),
    [anon_sym_null_pointer_is_valid] = ACTIONS(679),
    [anon_sym_optforfuzzing] = ACTIONS(679),
    [anon_sym_optnone] = ACTIONS(679),
    [anon_sym_optsize] = ACTIONS(679),
    [anon_sym_readnone] = ACTIONS(679),
    [anon_sym_readonly] = ACTIONS(679),
    [anon_sym_writeonly] = ACTIONS(679),
    [anon_sym_argmemonly] = ACTIONS(679),
    [anon_sym_returns_twice] = ACTIONS(679),
    [anon_sym_safestack] = ACTIONS(679),
    [anon_sym_sanitize_address] = ACTIONS(679),
    [anon_sym_sanitize_memory] = ACTIONS(679),
    [anon_sym_sanitize_thread] = ACTIONS(679),
    [anon_sym_sanitize_hwaddress] = ACTIONS(679),
    [anon_sym_sanitize_memtag] = ACTIONS(679),
    [anon_sym_speculative_load_hardening] = ACTIONS(679),
    [anon_sym_speculatable] = ACTIONS(679),
    [anon_sym_ssp] = ACTIONS(681),
    [anon_sym_sspstrong] = ACTIONS(679),
    [anon_sym_sspreq] = ACTIONS(679),
    [anon_sym_strictfp] = ACTIONS(679),
    [anon_sym_nocf_check] = ACTIONS(679),
    [anon_sym_shadowcallstack] = ACTIONS(679),
    [anon_sym_mustprogress] = ACTIONS(679),
    [anon_sym_vscale_range] = ACTIONS(679),
    [anon_sym_preallocated] = ACTIONS(679),
    [anon_sym_zeroext] = ACTIONS(679),
    [anon_sym_signext] = ACTIONS(679),
    [anon_sym_inreg] = ACTIONS(679),
    [anon_sym_byval] = ACTIONS(679),
    [anon_sym_byref] = ACTIONS(679),
    [anon_sym_inalloca] = ACTIONS(679),
    [anon_sym_sret] = ACTIONS(679),
    [anon_sym_elementtype] = ACTIONS(679),
    [anon_sym_noalias] = ACTIONS(679),
    [anon_sym_nocapture] = ACTIONS(679),
    [anon_sym_nest] = ACTIONS(679),
    [anon_sym_returned] = ACTIONS(679),
    [anon_sym_nonnull] = ACTIONS(679),
    [anon_sym_dereferenceable] = ACTIONS(681),
    [anon_sym_dereferenceable_or_null] = ACTIONS(679),
    [anon_sym_swiftself] = ACTIONS(679),
    [anon_sym_swiftasync] = ACTIONS(679),
    [anon_sym_swifterror] = ACTIONS(679),
    [anon_sym_immarg] = ACTIONS(679),
    [anon_sym_noundef] = ACTIONS(679),
    [anon_sym_uwtable] = ACTIONS(679),
    [anon_sym_memory] = ACTIONS(679),
    [anon_sym_to] = ACTIONS(681),
    [anon_sym_uselistorder] = ACTIONS(681),
    [anon_sym_uselistorder_bb] = ACTIONS(679),
    [anon_sym_module] = ACTIONS(679),
    [anon_sym_attributes] = ACTIONS(679),
  },
  [340] = {
    [ts_builtin_sym_end] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(615),
    [sym_comdat_ref] = ACTIONS(615),
    [sym_global_var] = ACTIONS(615),
    [sym_local_var] = ACTIONS(615),
    [aux_sym_metadata_ref_token1] = ACTIONS(615),
    [sym_summary_ref] = ACTIONS(615),
    [sym_string] = ACTIONS(615),
    [anon_sym_target] = ACTIONS(615),
    [anon_sym_source_filename] = ACTIONS(615),
    [anon_sym_declare] = ACTIONS(615),
    [anon_sym_define] = ACTIONS(615),
    [anon_sym_void] = ACTIONS(615),
    [anon_sym_half] = ACTIONS(615),
    [anon_sym_bfloat] = ACTIONS(615),
    [anon_sym_float] = ACTIONS(615),
    [anon_sym_double] = ACTIONS(615),
    [anon_sym_x86_fp80] = ACTIONS(615),
    [anon_sym_fp128] = ACTIONS(615),
    [anon_sym_ppc_fp128] = ACTIONS(615),
    [anon_sym_label] = ACTIONS(615),
    [anon_sym_metadata] = ACTIONS(615),
    [anon_sym_x86_mmx] = ACTIONS(615),
    [anon_sym_x86_amx] = ACTIONS(615),
    [anon_sym_token] = ACTIONS(615),
    [anon_sym_opaque] = ACTIONS(615),
    [anon_sym_ptr] = ACTIONS(615),
    [aux_sym_type_keyword_token1] = ACTIONS(615),
    [anon_sym_LBRACE] = ACTIONS(615),
    [anon_sym_RBRACE] = ACTIONS(615),
    [anon_sym_LT_LBRACE] = ACTIONS(615),
    [anon_sym_LBRACK] = ACTIONS(615),
    [anon_sym_RBRACK] = ACTIONS(615),
    [anon_sym_LT] = ACTIONS(617),
    [anon_sym_COMMA] = ACTIONS(615),
    [anon_sym_align] = ACTIONS(617),
    [anon_sym_section] = ACTIONS(615),
    [anon_sym_partition] = ACTIONS(615),
    [anon_sym_comdat] = ACTIONS(615),
    [anon_sym_gc] = ACTIONS(615),
    [anon_sym_prefix] = ACTIONS(615),
    [anon_sym_prologue] = ACTIONS(615),
    [anon_sym_personality] = ACTIONS(615),
    [anon_sym_alignstack] = ACTIONS(615),
    [anon_sym_allocsize] = ACTIONS(615),
    [anon_sym_alwaysinline] = ACTIONS(615),
    [anon_sym_builtin] = ACTIONS(615),
    [anon_sym_cold] = ACTIONS(615),
    [anon_sym_convergent] = ACTIONS(615),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(615),
    [anon_sym_hot] = ACTIONS(615),
    [anon_sym_inaccessiblememonly] = ACTIONS(615),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(615),
    [anon_sym_inlinehint] = ACTIONS(615),
    [anon_sym_jumptable] = ACTIONS(615),
    [anon_sym_minsize] = ACTIONS(615),
    [anon_sym_naked] = ACTIONS(615),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(615),
    [anon_sym_nobuiltin] = ACTIONS(615),
    [anon_sym_noduplicate] = ACTIONS(615),
    [anon_sym_nofree] = ACTIONS(615),
    [anon_sym_noimplicitfloat] = ACTIONS(615),
    [anon_sym_noinline] = ACTIONS(615),
    [anon_sym_nomerge] = ACTIONS(615),
    [anon_sym_nonlazybind] = ACTIONS(615),
    [anon_sym_noprofile] = ACTIONS(615),
    [anon_sym_noredzone] = ACTIONS(615),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(615),
    [anon_sym_noreturn] = ACTIONS(615),
    [anon_sym_norecurse] = ACTIONS(615),
    [anon_sym_willreturn] = ACTIONS(615),
    [anon_sym_nosync] = ACTIONS(615),
    [anon_sym_nounwind] = ACTIONS(615),
    [anon_sym_nocallback] = ACTIONS(615),
    [anon_sym_nosanitize_coverage] = ACTIONS(615),
    [anon_sym_null_pointer_is_valid] = ACTIONS(615),
    [anon_sym_optforfuzzing] = ACTIONS(615),
    [anon_sym_optnone] = ACTIONS(615),
    [anon_sym_optsize] = ACTIONS(615),
    [anon_sym_readnone] = ACTIONS(615),
    [anon_sym_readonly] = ACTIONS(615),
    [anon_sym_writeonly] = ACTIONS(615),
    [anon_sym_argmemonly] = ACTIONS(615),
    [anon_sym_returns_twice] = ACTIONS(615),
    [anon_sym_safestack] = ACTIONS(615),
    [anon_sym_sanitize_address] = ACTIONS(615),
    [anon_sym_sanitize_memory] = ACTIONS(615),
    [anon_sym_sanitize_thread] = ACTIONS(615),
    [anon_sym_sanitize_hwaddress] = ACTIONS(615),
    [anon_sym_sanitize_memtag] = ACTIONS(615),
    [anon_sym_speculative_load_hardening] = ACTIONS(615),
    [anon_sym_speculatable] = ACTIONS(615),
    [anon_sym_ssp] = ACTIONS(617),
    [anon_sym_sspstrong] = ACTIONS(615),
    [anon_sym_sspreq] = ACTIONS(615),
    [anon_sym_strictfp] = ACTIONS(615),
    [anon_sym_nocf_check] = ACTIONS(615),
    [anon_sym_shadowcallstack] = ACTIONS(615),
    [anon_sym_mustprogress] = ACTIONS(615),
    [anon_sym_vscale_range] = ACTIONS(615),
    [anon_sym_preallocated] = ACTIONS(615),
    [anon_sym_zeroext] = ACTIONS(615),
    [anon_sym_signext] = ACTIONS(615),
    [anon_sym_inreg] = ACTIONS(615),
    [anon_sym_byval] = ACTIONS(615),
    [anon_sym_byref] = ACTIONS(615),
    [anon_sym_inalloca] = ACTIONS(615),
    [anon_sym_sret] = ACTIONS(615),
    [anon_sym_elementtype] = ACTIONS(615),
    [anon_sym_noalias] = ACTIONS(615),
    [anon_sym_nocapture] = ACTIONS(615),
    [anon_sym_nest] = ACTIONS(615),
    [anon_sym_returned] = ACTIONS(615),
    [anon_sym_nonnull] = ACTIONS(615),
    [anon_sym_dereferenceable] = ACTIONS(617),
    [anon_sym_dereferenceable_or_null] = ACTIONS(615),
    [anon_sym_swiftself] = ACTIONS(615),
    [anon_sym_swiftasync] = ACTIONS(615),
    [anon_sym_swifterror] = ACTIONS(615),
    [anon_sym_immarg] = ACTIONS(615),
    [anon_sym_noundef] = ACTIONS(615),
    [anon_sym_uwtable] = ACTIONS(615),
    [anon_sym_memory] = ACTIONS(615),
    [anon_sym_to] = ACTIONS(617),
    [anon_sym_uselistorder] = ACTIONS(617),
    [anon_sym_uselistorder_bb] = ACTIONS(615),
    [anon_sym_module] = ACTIONS(615),
    [anon_sym_attributes] = ACTIONS(615),
  },
  [341] = {
    [ts_builtin_sym_end] = ACTIONS(607),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(607),
    [sym_comdat_ref] = ACTIONS(607),
    [sym_global_var] = ACTIONS(607),
    [sym_local_var] = ACTIONS(607),
    [aux_sym_metadata_ref_token1] = ACTIONS(607),
    [sym_summary_ref] = ACTIONS(607),
    [sym_string] = ACTIONS(607),
    [anon_sym_target] = ACTIONS(607),
    [anon_sym_source_filename] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(607),
    [anon_sym_define] = ACTIONS(607),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_half] = ACTIONS(607),
    [anon_sym_bfloat] = ACTIONS(607),
    [anon_sym_float] = ACTIONS(607),
    [anon_sym_double] = ACTIONS(607),
    [anon_sym_x86_fp80] = ACTIONS(607),
    [anon_sym_fp128] = ACTIONS(607),
    [anon_sym_ppc_fp128] = ACTIONS(607),
    [anon_sym_label] = ACTIONS(607),
    [anon_sym_metadata] = ACTIONS(607),
    [anon_sym_x86_mmx] = ACTIONS(607),
    [anon_sym_x86_amx] = ACTIONS(607),
    [anon_sym_token] = ACTIONS(607),
    [anon_sym_opaque] = ACTIONS(607),
    [anon_sym_ptr] = ACTIONS(607),
    [aux_sym_type_keyword_token1] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(607),
    [anon_sym_RBRACE] = ACTIONS(607),
    [anon_sym_LT_LBRACE] = ACTIONS(607),
    [anon_sym_LBRACK] = ACTIONS(607),
    [anon_sym_RBRACK] = ACTIONS(607),
    [anon_sym_LT] = ACTIONS(609),
    [anon_sym_COMMA] = ACTIONS(607),
    [anon_sym_align] = ACTIONS(609),
    [anon_sym_section] = ACTIONS(607),
    [anon_sym_partition] = ACTIONS(607),
    [anon_sym_comdat] = ACTIONS(607),
    [anon_sym_gc] = ACTIONS(607),
    [anon_sym_prefix] = ACTIONS(607),
    [anon_sym_prologue] = ACTIONS(607),
    [anon_sym_personality] = ACTIONS(607),
    [anon_sym_alignstack] = ACTIONS(607),
    [anon_sym_allocsize] = ACTIONS(607),
    [anon_sym_alwaysinline] = ACTIONS(607),
    [anon_sym_builtin] = ACTIONS(607),
    [anon_sym_cold] = ACTIONS(607),
    [anon_sym_convergent] = ACTIONS(607),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(607),
    [anon_sym_hot] = ACTIONS(607),
    [anon_sym_inaccessiblememonly] = ACTIONS(607),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(607),
    [anon_sym_inlinehint] = ACTIONS(607),
    [anon_sym_jumptable] = ACTIONS(607),
    [anon_sym_minsize] = ACTIONS(607),
    [anon_sym_naked] = ACTIONS(607),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(607),
    [anon_sym_nobuiltin] = ACTIONS(607),
    [anon_sym_noduplicate] = ACTIONS(607),
    [anon_sym_nofree] = ACTIONS(607),
    [anon_sym_noimplicitfloat] = ACTIONS(607),
    [anon_sym_noinline] = ACTIONS(607),
    [anon_sym_nomerge] = ACTIONS(607),
    [anon_sym_nonlazybind] = ACTIONS(607),
    [anon_sym_noprofile] = ACTIONS(607),
    [anon_sym_noredzone] = ACTIONS(607),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(607),
    [anon_sym_noreturn] = ACTIONS(607),
    [anon_sym_norecurse] = ACTIONS(607),
    [anon_sym_willreturn] = ACTIONS(607),
    [anon_sym_nosync] = ACTIONS(607),
    [anon_sym_nounwind] = ACTIONS(607),
    [anon_sym_nocallback] = ACTIONS(607),
    [anon_sym_nosanitize_coverage] = ACTIONS(607),
    [anon_sym_null_pointer_is_valid] = ACTIONS(607),
    [anon_sym_optforfuzzing] = ACTIONS(607),
    [anon_sym_optnone] = ACTIONS(607),
    [anon_sym_optsize] = ACTIONS(607),
    [anon_sym_readnone] = ACTIONS(607),
    [anon_sym_readonly] = ACTIONS(607),
    [anon_sym_writeonly] = ACTIONS(607),
    [anon_sym_argmemonly] = ACTIONS(607),
    [anon_sym_returns_twice] = ACTIONS(607),
    [anon_sym_safestack] = ACTIONS(607),
    [anon_sym_sanitize_address] = ACTIONS(607),
    [anon_sym_sanitize_memory] = ACTIONS(607),
    [anon_sym_sanitize_thread] = ACTIONS(607),
    [anon_sym_sanitize_hwaddress] = ACTIONS(607),
    [anon_sym_sanitize_memtag] = ACTIONS(607),
    [anon_sym_speculative_load_hardening] = ACTIONS(607),
    [anon_sym_speculatable] = ACTIONS(607),
    [anon_sym_ssp] = ACTIONS(609),
    [anon_sym_sspstrong] = ACTIONS(607),
    [anon_sym_sspreq] = ACTIONS(607),
    [anon_sym_strictfp] = ACTIONS(607),
    [anon_sym_nocf_check] = ACTIONS(607),
    [anon_sym_shadowcallstack] = ACTIONS(607),
    [anon_sym_mustprogress] = ACTIONS(607),
    [anon_sym_vscale_range] = ACTIONS(607),
    [anon_sym_preallocated] = ACTIONS(607),
    [anon_sym_zeroext] = ACTIONS(607),
    [anon_sym_signext] = ACTIONS(607),
    [anon_sym_inreg] = ACTIONS(607),
    [anon_sym_byval] = ACTIONS(607),
    [anon_sym_byref] = ACTIONS(607),
    [anon_sym_inalloca] = ACTIONS(607),
    [anon_sym_sret] = ACTIONS(607),
    [anon_sym_elementtype] = ACTIONS(607),
    [anon_sym_noalias] = ACTIONS(607),
    [anon_sym_nocapture] = ACTIONS(607),
    [anon_sym_nest] = ACTIONS(607),
    [anon_sym_returned] = ACTIONS(607),
    [anon_sym_nonnull] = ACTIONS(607),
    [anon_sym_dereferenceable] = ACTIONS(609),
    [anon_sym_dereferenceable_or_null] = ACTIONS(607),
    [anon_sym_swiftself] = ACTIONS(607),
    [anon_sym_swiftasync] = ACTIONS(607),
    [anon_sym_swifterror] = ACTIONS(607),
    [anon_sym_immarg] = ACTIONS(607),
    [anon_sym_noundef] = ACTIONS(607),
    [anon_sym_uwtable] = ACTIONS(607),
    [anon_sym_memory] = ACTIONS(607),
    [anon_sym_to] = ACTIONS(609),
    [anon_sym_uselistorder] = ACTIONS(609),
    [anon_sym_uselistorder_bb] = ACTIONS(607),
    [anon_sym_module] = ACTIONS(607),
    [anon_sym_attributes] = ACTIONS(607),
  },
  [342] = {
    [ts_builtin_sym_end] = ACTIONS(599),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(599),
    [sym_comdat_ref] = ACTIONS(599),
    [sym_global_var] = ACTIONS(599),
    [sym_local_var] = ACTIONS(599),
    [aux_sym_metadata_ref_token1] = ACTIONS(599),
    [sym_summary_ref] = ACTIONS(599),
    [sym_string] = ACTIONS(599),
    [anon_sym_target] = ACTIONS(599),
    [anon_sym_source_filename] = ACTIONS(599),
    [anon_sym_declare] = ACTIONS(599),
    [anon_sym_define] = ACTIONS(599),
    [anon_sym_void] = ACTIONS(599),
    [anon_sym_half] = ACTIONS(599),
    [anon_sym_bfloat] = ACTIONS(599),
    [anon_sym_float] = ACTIONS(599),
    [anon_sym_double] = ACTIONS(599),
    [anon_sym_x86_fp80] = ACTIONS(599),
    [anon_sym_fp128] = ACTIONS(599),
    [anon_sym_ppc_fp128] = ACTIONS(599),
    [anon_sym_label] = ACTIONS(599),
    [anon_sym_metadata] = ACTIONS(599),
    [anon_sym_x86_mmx] = ACTIONS(599),
    [anon_sym_x86_amx] = ACTIONS(599),
    [anon_sym_token] = ACTIONS(599),
    [anon_sym_opaque] = ACTIONS(599),
    [anon_sym_ptr] = ACTIONS(599),
    [aux_sym_type_keyword_token1] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(599),
    [anon_sym_RBRACE] = ACTIONS(599),
    [anon_sym_LT_LBRACE] = ACTIONS(599),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_RBRACK] = ACTIONS(599),
    [anon_sym_LT] = ACTIONS(601),
    [anon_sym_COMMA] = ACTIONS(599),
    [anon_sym_align] = ACTIONS(601),
    [anon_sym_section] = ACTIONS(599),
    [anon_sym_partition] = ACTIONS(599),
    [anon_sym_comdat] = ACTIONS(599),
    [anon_sym_gc] = ACTIONS(599),
    [anon_sym_prefix] = ACTIONS(599),
    [anon_sym_prologue] = ACTIONS(599),
    [anon_sym_personality] = ACTIONS(599),
    [anon_sym_alignstack] = ACTIONS(599),
    [anon_sym_allocsize] = ACTIONS(599),
    [anon_sym_alwaysinline] = ACTIONS(599),
    [anon_sym_builtin] = ACTIONS(599),
    [anon_sym_cold] = ACTIONS(599),
    [anon_sym_convergent] = ACTIONS(599),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(599),
    [anon_sym_hot] = ACTIONS(599),
    [anon_sym_inaccessiblememonly] = ACTIONS(599),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(599),
    [anon_sym_inlinehint] = ACTIONS(599),
    [anon_sym_jumptable] = ACTIONS(599),
    [anon_sym_minsize] = ACTIONS(599),
    [anon_sym_naked] = ACTIONS(599),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(599),
    [anon_sym_nobuiltin] = ACTIONS(599),
    [anon_sym_noduplicate] = ACTIONS(599),
    [anon_sym_nofree] = ACTIONS(599),
    [anon_sym_noimplicitfloat] = ACTIONS(599),
    [anon_sym_noinline] = ACTIONS(599),
    [anon_sym_nomerge] = ACTIONS(599),
    [anon_sym_nonlazybind] = ACTIONS(599),
    [anon_sym_noprofile] = ACTIONS(599),
    [anon_sym_noredzone] = ACTIONS(599),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(599),
    [anon_sym_noreturn] = ACTIONS(599),
    [anon_sym_norecurse] = ACTIONS(599),
    [anon_sym_willreturn] = ACTIONS(599),
    [anon_sym_nosync] = ACTIONS(599),
    [anon_sym_nounwind] = ACTIONS(599),
    [anon_sym_nocallback] = ACTIONS(599),
    [anon_sym_nosanitize_coverage] = ACTIONS(599),
    [anon_sym_null_pointer_is_valid] = ACTIONS(599),
    [anon_sym_optforfuzzing] = ACTIONS(599),
    [anon_sym_optnone] = ACTIONS(599),
    [anon_sym_optsize] = ACTIONS(599),
    [anon_sym_readnone] = ACTIONS(599),
    [anon_sym_readonly] = ACTIONS(599),
    [anon_sym_writeonly] = ACTIONS(599),
    [anon_sym_argmemonly] = ACTIONS(599),
    [anon_sym_returns_twice] = ACTIONS(599),
    [anon_sym_safestack] = ACTIONS(599),
    [anon_sym_sanitize_address] = ACTIONS(599),
    [anon_sym_sanitize_memory] = ACTIONS(599),
    [anon_sym_sanitize_thread] = ACTIONS(599),
    [anon_sym_sanitize_hwaddress] = ACTIONS(599),
    [anon_sym_sanitize_memtag] = ACTIONS(599),
    [anon_sym_speculative_load_hardening] = ACTIONS(599),
    [anon_sym_speculatable] = ACTIONS(599),
    [anon_sym_ssp] = ACTIONS(601),
    [anon_sym_sspstrong] = ACTIONS(599),
    [anon_sym_sspreq] = ACTIONS(599),
    [anon_sym_strictfp] = ACTIONS(599),
    [anon_sym_nocf_check] = ACTIONS(599),
    [anon_sym_shadowcallstack] = ACTIONS(599),
    [anon_sym_mustprogress] = ACTIONS(599),
    [anon_sym_vscale_range] = ACTIONS(599),
    [anon_sym_preallocated] = ACTIONS(599),
    [anon_sym_zeroext] = ACTIONS(599),
    [anon_sym_signext] = ACTIONS(599),
    [anon_sym_inreg] = ACTIONS(599),
    [anon_sym_byval] = ACTIONS(599),
    [anon_sym_byref] = ACTIONS(599),
    [anon_sym_inalloca] = ACTIONS(599),
    [anon_sym_sret] = ACTIONS(599),
    [anon_sym_elementtype] = ACTIONS(599),
    [anon_sym_noalias] = ACTIONS(599),
    [anon_sym_nocapture] = ACTIONS(599),
    [anon_sym_nest] = ACTIONS(599),
    [anon_sym_returned] = ACTIONS(599),
    [anon_sym_nonnull] = ACTIONS(599),
    [anon_sym_dereferenceable] = ACTIONS(601),
    [anon_sym_dereferenceable_or_null] = ACTIONS(599),
    [anon_sym_swiftself] = ACTIONS(599),
    [anon_sym_swiftasync] = ACTIONS(599),
    [anon_sym_swifterror] = ACTIONS(599),
    [anon_sym_immarg] = ACTIONS(599),
    [anon_sym_noundef] = ACTIONS(599),
    [anon_sym_uwtable] = ACTIONS(599),
    [anon_sym_memory] = ACTIONS(599),
    [anon_sym_to] = ACTIONS(601),
    [anon_sym_uselistorder] = ACTIONS(601),
    [anon_sym_uselistorder_bb] = ACTIONS(599),
    [anon_sym_module] = ACTIONS(599),
    [anon_sym_attributes] = ACTIONS(599),
  },
  [343] = {
    [ts_builtin_sym_end] = ACTIONS(565),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(565),
    [sym_comdat_ref] = ACTIONS(565),
    [sym_global_var] = ACTIONS(565),
    [sym_local_var] = ACTIONS(565),
    [aux_sym_metadata_ref_token1] = ACTIONS(565),
    [sym_summary_ref] = ACTIONS(565),
    [sym_string] = ACTIONS(565),
    [anon_sym_target] = ACTIONS(565),
    [anon_sym_source_filename] = ACTIONS(565),
    [anon_sym_declare] = ACTIONS(565),
    [anon_sym_define] = ACTIONS(565),
    [anon_sym_void] = ACTIONS(565),
    [anon_sym_half] = ACTIONS(565),
    [anon_sym_bfloat] = ACTIONS(565),
    [anon_sym_float] = ACTIONS(565),
    [anon_sym_double] = ACTIONS(565),
    [anon_sym_x86_fp80] = ACTIONS(565),
    [anon_sym_fp128] = ACTIONS(565),
    [anon_sym_ppc_fp128] = ACTIONS(565),
    [anon_sym_label] = ACTIONS(565),
    [anon_sym_metadata] = ACTIONS(565),
    [anon_sym_x86_mmx] = ACTIONS(565),
    [anon_sym_x86_amx] = ACTIONS(565),
    [anon_sym_token] = ACTIONS(565),
    [anon_sym_opaque] = ACTIONS(565),
    [anon_sym_ptr] = ACTIONS(565),
    [aux_sym_type_keyword_token1] = ACTIONS(565),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_LT_LBRACE] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_RBRACK] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_align] = ACTIONS(567),
    [anon_sym_section] = ACTIONS(565),
    [anon_sym_partition] = ACTIONS(565),
    [anon_sym_comdat] = ACTIONS(565),
    [anon_sym_gc] = ACTIONS(565),
    [anon_sym_prefix] = ACTIONS(565),
    [anon_sym_prologue] = ACTIONS(565),
    [anon_sym_personality] = ACTIONS(565),
    [anon_sym_alignstack] = ACTIONS(565),
    [anon_sym_allocsize] = ACTIONS(565),
    [anon_sym_alwaysinline] = ACTIONS(565),
    [anon_sym_builtin] = ACTIONS(565),
    [anon_sym_cold] = ACTIONS(565),
    [anon_sym_convergent] = ACTIONS(565),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(565),
    [anon_sym_hot] = ACTIONS(565),
    [anon_sym_inaccessiblememonly] = ACTIONS(565),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(565),
    [anon_sym_inlinehint] = ACTIONS(565),
    [anon_sym_jumptable] = ACTIONS(565),
    [anon_sym_minsize] = ACTIONS(565),
    [anon_sym_naked] = ACTIONS(565),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(565),
    [anon_sym_nobuiltin] = ACTIONS(565),
    [anon_sym_noduplicate] = ACTIONS(565),
    [anon_sym_nofree] = ACTIONS(565),
    [anon_sym_noimplicitfloat] = ACTIONS(565),
    [anon_sym_noinline] = ACTIONS(565),
    [anon_sym_nomerge] = ACTIONS(565),
    [anon_sym_nonlazybind] = ACTIONS(565),
    [anon_sym_noprofile] = ACTIONS(565),
    [anon_sym_noredzone] = ACTIONS(565),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(565),
    [anon_sym_noreturn] = ACTIONS(565),
    [anon_sym_norecurse] = ACTIONS(565),
    [anon_sym_willreturn] = ACTIONS(565),
    [anon_sym_nosync] = ACTIONS(565),
    [anon_sym_nounwind] = ACTIONS(565),
    [anon_sym_nocallback] = ACTIONS(565),
    [anon_sym_nosanitize_coverage] = ACTIONS(565),
    [anon_sym_null_pointer_is_valid] = ACTIONS(565),
    [anon_sym_optforfuzzing] = ACTIONS(565),
    [anon_sym_optnone] = ACTIONS(565),
    [anon_sym_optsize] = ACTIONS(565),
    [anon_sym_readnone] = ACTIONS(565),
    [anon_sym_readonly] = ACTIONS(565),
    [anon_sym_writeonly] = ACTIONS(565),
    [anon_sym_argmemonly] = ACTIONS(565),
    [anon_sym_returns_twice] = ACTIONS(565),
    [anon_sym_safestack] = ACTIONS(565),
    [anon_sym_sanitize_address] = ACTIONS(565),
    [anon_sym_sanitize_memory] = ACTIONS(565),
    [anon_sym_sanitize_thread] = ACTIONS(565),
    [anon_sym_sanitize_hwaddress] = ACTIONS(565),
    [anon_sym_sanitize_memtag] = ACTIONS(565),
    [anon_sym_speculative_load_hardening] = ACTIONS(565),
    [anon_sym_speculatable] = ACTIONS(565),
    [anon_sym_ssp] = ACTIONS(567),
    [anon_sym_sspstrong] = ACTIONS(565),
    [anon_sym_sspreq] = ACTIONS(565),
    [anon_sym_strictfp] = ACTIONS(565),
    [anon_sym_nocf_check] = ACTIONS(565),
    [anon_sym_shadowcallstack] = ACTIONS(565),
    [anon_sym_mustprogress] = ACTIONS(565),
    [anon_sym_vscale_range] = ACTIONS(565),
    [anon_sym_preallocated] = ACTIONS(565),
    [anon_sym_zeroext] = ACTIONS(565),
    [anon_sym_signext] = ACTIONS(565),
    [anon_sym_inreg] = ACTIONS(565),
    [anon_sym_byval] = ACTIONS(565),
    [anon_sym_byref] = ACTIONS(565),
    [anon_sym_inalloca] = ACTIONS(565),
    [anon_sym_sret] = ACTIONS(565),
    [anon_sym_elementtype] = ACTIONS(565),
    [anon_sym_noalias] = ACTIONS(565),
    [anon_sym_nocapture] = ACTIONS(565),
    [anon_sym_nest] = ACTIONS(565),
    [anon_sym_returned] = ACTIONS(565),
    [anon_sym_nonnull] = ACTIONS(565),
    [anon_sym_dereferenceable] = ACTIONS(567),
    [anon_sym_dereferenceable_or_null] = ACTIONS(565),
    [anon_sym_swiftself] = ACTIONS(565),
    [anon_sym_swiftasync] = ACTIONS(565),
    [anon_sym_swifterror] = ACTIONS(565),
    [anon_sym_immarg] = ACTIONS(565),
    [anon_sym_noundef] = ACTIONS(565),
    [anon_sym_uwtable] = ACTIONS(565),
    [anon_sym_memory] = ACTIONS(565),
    [anon_sym_to] = ACTIONS(567),
    [anon_sym_uselistorder] = ACTIONS(567),
    [anon_sym_uselistorder_bb] = ACTIONS(565),
    [anon_sym_module] = ACTIONS(565),
    [anon_sym_attributes] = ACTIONS(565),
  },
  [344] = {
    [ts_builtin_sym_end] = ACTIONS(639),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(639),
    [sym_comdat_ref] = ACTIONS(639),
    [sym_global_var] = ACTIONS(639),
    [sym_local_var] = ACTIONS(639),
    [aux_sym_metadata_ref_token1] = ACTIONS(639),
    [sym_summary_ref] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [anon_sym_target] = ACTIONS(639),
    [anon_sym_source_filename] = ACTIONS(639),
    [anon_sym_declare] = ACTIONS(639),
    [anon_sym_define] = ACTIONS(639),
    [anon_sym_void] = ACTIONS(639),
    [anon_sym_half] = ACTIONS(639),
    [anon_sym_bfloat] = ACTIONS(639),
    [anon_sym_float] = ACTIONS(639),
    [anon_sym_double] = ACTIONS(639),
    [anon_sym_x86_fp80] = ACTIONS(639),
    [anon_sym_fp128] = ACTIONS(639),
    [anon_sym_ppc_fp128] = ACTIONS(639),
    [anon_sym_label] = ACTIONS(639),
    [anon_sym_metadata] = ACTIONS(639),
    [anon_sym_x86_mmx] = ACTIONS(639),
    [anon_sym_x86_amx] = ACTIONS(639),
    [anon_sym_token] = ACTIONS(639),
    [anon_sym_opaque] = ACTIONS(639),
    [anon_sym_ptr] = ACTIONS(639),
    [aux_sym_type_keyword_token1] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(639),
    [anon_sym_RBRACE] = ACTIONS(639),
    [anon_sym_LT_LBRACE] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(639),
    [anon_sym_LT] = ACTIONS(641),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_align] = ACTIONS(641),
    [anon_sym_section] = ACTIONS(639),
    [anon_sym_partition] = ACTIONS(639),
    [anon_sym_comdat] = ACTIONS(639),
    [anon_sym_gc] = ACTIONS(639),
    [anon_sym_prefix] = ACTIONS(639),
    [anon_sym_prologue] = ACTIONS(639),
    [anon_sym_personality] = ACTIONS(639),
    [anon_sym_alignstack] = ACTIONS(639),
    [anon_sym_allocsize] = ACTIONS(639),
    [anon_sym_alwaysinline] = ACTIONS(639),
    [anon_sym_builtin] = ACTIONS(639),
    [anon_sym_cold] = ACTIONS(639),
    [anon_sym_convergent] = ACTIONS(639),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(639),
    [anon_sym_hot] = ACTIONS(639),
    [anon_sym_inaccessiblememonly] = ACTIONS(639),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(639),
    [anon_sym_inlinehint] = ACTIONS(639),
    [anon_sym_jumptable] = ACTIONS(639),
    [anon_sym_minsize] = ACTIONS(639),
    [anon_sym_naked] = ACTIONS(639),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(639),
    [anon_sym_nobuiltin] = ACTIONS(639),
    [anon_sym_noduplicate] = ACTIONS(639),
    [anon_sym_nofree] = ACTIONS(639),
    [anon_sym_noimplicitfloat] = ACTIONS(639),
    [anon_sym_noinline] = ACTIONS(639),
    [anon_sym_nomerge] = ACTIONS(639),
    [anon_sym_nonlazybind] = ACTIONS(639),
    [anon_sym_noprofile] = ACTIONS(639),
    [anon_sym_noredzone] = ACTIONS(639),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(639),
    [anon_sym_noreturn] = ACTIONS(639),
    [anon_sym_norecurse] = ACTIONS(639),
    [anon_sym_willreturn] = ACTIONS(639),
    [anon_sym_nosync] = ACTIONS(639),
    [anon_sym_nounwind] = ACTIONS(639),
    [anon_sym_nocallback] = ACTIONS(639),
    [anon_sym_nosanitize_coverage] = ACTIONS(639),
    [anon_sym_null_pointer_is_valid] = ACTIONS(639),
    [anon_sym_optforfuzzing] = ACTIONS(639),
    [anon_sym_optnone] = ACTIONS(639),
    [anon_sym_optsize] = ACTIONS(639),
    [anon_sym_readnone] = ACTIONS(639),
    [anon_sym_readonly] = ACTIONS(639),
    [anon_sym_writeonly] = ACTIONS(639),
    [anon_sym_argmemonly] = ACTIONS(639),
    [anon_sym_returns_twice] = ACTIONS(639),
    [anon_sym_safestack] = ACTIONS(639),
    [anon_sym_sanitize_address] = ACTIONS(639),
    [anon_sym_sanitize_memory] = ACTIONS(639),
    [anon_sym_sanitize_thread] = ACTIONS(639),
    [anon_sym_sanitize_hwaddress] = ACTIONS(639),
    [anon_sym_sanitize_memtag] = ACTIONS(639),
    [anon_sym_speculative_load_hardening] = ACTIONS(639),
    [anon_sym_speculatable] = ACTIONS(639),
    [anon_sym_ssp] = ACTIONS(641),
    [anon_sym_sspstrong] = ACTIONS(639),
    [anon_sym_sspreq] = ACTIONS(639),
    [anon_sym_strictfp] = ACTIONS(639),
    [anon_sym_nocf_check] = ACTIONS(639),
    [anon_sym_shadowcallstack] = ACTIONS(639),
    [anon_sym_mustprogress] = ACTIONS(639),
    [anon_sym_vscale_range] = ACTIONS(639),
    [anon_sym_preallocated] = ACTIONS(639),
    [anon_sym_zeroext] = ACTIONS(639),
    [anon_sym_signext] = ACTIONS(639),
    [anon_sym_inreg] = ACTIONS(639),
    [anon_sym_byval] = ACTIONS(639),
    [anon_sym_byref] = ACTIONS(639),
    [anon_sym_inalloca] = ACTIONS(639),
    [anon_sym_sret] = ACTIONS(639),
    [anon_sym_elementtype] = ACTIONS(639),
    [anon_sym_noalias] = ACTIONS(639),
    [anon_sym_nocapture] = ACTIONS(639),
    [anon_sym_nest] = ACTIONS(639),
    [anon_sym_returned] = ACTIONS(639),
    [anon_sym_nonnull] = ACTIONS(639),
    [anon_sym_dereferenceable] = ACTIONS(641),
    [anon_sym_dereferenceable_or_null] = ACTIONS(639),
    [anon_sym_swiftself] = ACTIONS(639),
    [anon_sym_swiftasync] = ACTIONS(639),
    [anon_sym_swifterror] = ACTIONS(639),
    [anon_sym_immarg] = ACTIONS(639),
    [anon_sym_noundef] = ACTIONS(639),
    [anon_sym_uwtable] = ACTIONS(639),
    [anon_sym_memory] = ACTIONS(639),
    [anon_sym_to] = ACTIONS(641),
    [anon_sym_uselistorder] = ACTIONS(641),
    [anon_sym_uselistorder_bb] = ACTIONS(639),
    [anon_sym_module] = ACTIONS(639),
    [anon_sym_attributes] = ACTIONS(639),
  },
  [345] = {
    [ts_builtin_sym_end] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(685),
    [sym_comdat_ref] = ACTIONS(685),
    [sym_global_var] = ACTIONS(685),
    [sym_local_var] = ACTIONS(685),
    [aux_sym_metadata_ref_token1] = ACTIONS(685),
    [sym_summary_ref] = ACTIONS(685),
    [sym_string] = ACTIONS(685),
    [anon_sym_target] = ACTIONS(685),
    [anon_sym_source_filename] = ACTIONS(685),
    [anon_sym_declare] = ACTIONS(685),
    [anon_sym_define] = ACTIONS(685),
    [anon_sym_void] = ACTIONS(685),
    [anon_sym_half] = ACTIONS(685),
    [anon_sym_bfloat] = ACTIONS(685),
    [anon_sym_float] = ACTIONS(685),
    [anon_sym_double] = ACTIONS(685),
    [anon_sym_x86_fp80] = ACTIONS(685),
    [anon_sym_fp128] = ACTIONS(685),
    [anon_sym_ppc_fp128] = ACTIONS(685),
    [anon_sym_label] = ACTIONS(685),
    [anon_sym_metadata] = ACTIONS(685),
    [anon_sym_x86_mmx] = ACTIONS(685),
    [anon_sym_x86_amx] = ACTIONS(685),
    [anon_sym_token] = ACTIONS(685),
    [anon_sym_opaque] = ACTIONS(685),
    [anon_sym_ptr] = ACTIONS(685),
    [aux_sym_type_keyword_token1] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(685),
    [anon_sym_RBRACE] = ACTIONS(685),
    [anon_sym_LT_LBRACE] = ACTIONS(685),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_RBRACK] = ACTIONS(685),
    [anon_sym_LT] = ACTIONS(687),
    [anon_sym_COMMA] = ACTIONS(685),
    [anon_sym_align] = ACTIONS(687),
    [anon_sym_section] = ACTIONS(685),
    [anon_sym_partition] = ACTIONS(685),
    [anon_sym_comdat] = ACTIONS(685),
    [anon_sym_gc] = ACTIONS(685),
    [anon_sym_prefix] = ACTIONS(685),
    [anon_sym_prologue] = ACTIONS(685),
    [anon_sym_personality] = ACTIONS(685),
    [anon_sym_alignstack] = ACTIONS(685),
    [anon_sym_allocsize] = ACTIONS(685),
    [anon_sym_alwaysinline] = ACTIONS(685),
    [anon_sym_builtin] = ACTIONS(685),
    [anon_sym_cold] = ACTIONS(685),
    [anon_sym_convergent] = ACTIONS(685),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(685),
    [anon_sym_hot] = ACTIONS(685),
    [anon_sym_inaccessiblememonly] = ACTIONS(685),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(685),
    [anon_sym_inlinehint] = ACTIONS(685),
    [anon_sym_jumptable] = ACTIONS(685),
    [anon_sym_minsize] = ACTIONS(685),
    [anon_sym_naked] = ACTIONS(685),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(685),
    [anon_sym_nobuiltin] = ACTIONS(685),
    [anon_sym_noduplicate] = ACTIONS(685),
    [anon_sym_nofree] = ACTIONS(685),
    [anon_sym_noimplicitfloat] = ACTIONS(685),
    [anon_sym_noinline] = ACTIONS(685),
    [anon_sym_nomerge] = ACTIONS(685),
    [anon_sym_nonlazybind] = ACTIONS(685),
    [anon_sym_noprofile] = ACTIONS(685),
    [anon_sym_noredzone] = ACTIONS(685),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(685),
    [anon_sym_noreturn] = ACTIONS(685),
    [anon_sym_norecurse] = ACTIONS(685),
    [anon_sym_willreturn] = ACTIONS(685),
    [anon_sym_nosync] = ACTIONS(685),
    [anon_sym_nounwind] = ACTIONS(685),
    [anon_sym_nocallback] = ACTIONS(685),
    [anon_sym_nosanitize_coverage] = ACTIONS(685),
    [anon_sym_null_pointer_is_valid] = ACTIONS(685),
    [anon_sym_optforfuzzing] = ACTIONS(685),
    [anon_sym_optnone] = ACTIONS(685),
    [anon_sym_optsize] = ACTIONS(685),
    [anon_sym_readnone] = ACTIONS(685),
    [anon_sym_readonly] = ACTIONS(685),
    [anon_sym_writeonly] = ACTIONS(685),
    [anon_sym_argmemonly] = ACTIONS(685),
    [anon_sym_returns_twice] = ACTIONS(685),
    [anon_sym_safestack] = ACTIONS(685),
    [anon_sym_sanitize_address] = ACTIONS(685),
    [anon_sym_sanitize_memory] = ACTIONS(685),
    [anon_sym_sanitize_thread] = ACTIONS(685),
    [anon_sym_sanitize_hwaddress] = ACTIONS(685),
    [anon_sym_sanitize_memtag] = ACTIONS(685),
    [anon_sym_speculative_load_hardening] = ACTIONS(685),
    [anon_sym_speculatable] = ACTIONS(685),
    [anon_sym_ssp] = ACTIONS(687),
    [anon_sym_sspstrong] = ACTIONS(685),
    [anon_sym_sspreq] = ACTIONS(685),
    [anon_sym_strictfp] = ACTIONS(685),
    [anon_sym_nocf_check] = ACTIONS(685),
    [anon_sym_shadowcallstack] = ACTIONS(685),
    [anon_sym_mustprogress] = ACTIONS(685),
    [anon_sym_vscale_range] = ACTIONS(685),
    [anon_sym_preallocated] = ACTIONS(685),
    [anon_sym_zeroext] = ACTIONS(685),
    [anon_sym_signext] = ACTIONS(685),
    [anon_sym_inreg] = ACTIONS(685),
    [anon_sym_byval] = ACTIONS(685),
    [anon_sym_byref] = ACTIONS(685),
    [anon_sym_inalloca] = ACTIONS(685),
    [anon_sym_sret] = ACTIONS(685),
    [anon_sym_elementtype] = ACTIONS(685),
    [anon_sym_noalias] = ACTIONS(685),
    [anon_sym_nocapture] = ACTIONS(685),
    [anon_sym_nest] = ACTIONS(685),
    [anon_sym_returned] = ACTIONS(685),
    [anon_sym_nonnull] = ACTIONS(685),
    [anon_sym_dereferenceable] = ACTIONS(687),
    [anon_sym_dereferenceable_or_null] = ACTIONS(685),
    [anon_sym_swiftself] = ACTIONS(685),
    [anon_sym_swiftasync] = ACTIONS(685),
    [anon_sym_swifterror] = ACTIONS(685),
    [anon_sym_immarg] = ACTIONS(685),
    [anon_sym_noundef] = ACTIONS(685),
    [anon_sym_uwtable] = ACTIONS(685),
    [anon_sym_memory] = ACTIONS(685),
    [anon_sym_to] = ACTIONS(687),
    [anon_sym_uselistorder] = ACTIONS(687),
    [anon_sym_uselistorder_bb] = ACTIONS(685),
    [anon_sym_module] = ACTIONS(685),
    [anon_sym_attributes] = ACTIONS(685),
  },
  [346] = {
    [ts_builtin_sym_end] = ACTIONS(689),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(689),
    [sym_comdat_ref] = ACTIONS(689),
    [sym_global_var] = ACTIONS(689),
    [sym_local_var] = ACTIONS(689),
    [aux_sym_metadata_ref_token1] = ACTIONS(689),
    [sym_summary_ref] = ACTIONS(689),
    [sym_string] = ACTIONS(689),
    [anon_sym_target] = ACTIONS(689),
    [anon_sym_source_filename] = ACTIONS(689),
    [anon_sym_declare] = ACTIONS(689),
    [anon_sym_define] = ACTIONS(689),
    [anon_sym_void] = ACTIONS(689),
    [anon_sym_half] = ACTIONS(689),
    [anon_sym_bfloat] = ACTIONS(689),
    [anon_sym_float] = ACTIONS(689),
    [anon_sym_double] = ACTIONS(689),
    [anon_sym_x86_fp80] = ACTIONS(689),
    [anon_sym_fp128] = ACTIONS(689),
    [anon_sym_ppc_fp128] = ACTIONS(689),
    [anon_sym_label] = ACTIONS(689),
    [anon_sym_metadata] = ACTIONS(689),
    [anon_sym_x86_mmx] = ACTIONS(689),
    [anon_sym_x86_amx] = ACTIONS(689),
    [anon_sym_token] = ACTIONS(689),
    [anon_sym_opaque] = ACTIONS(689),
    [anon_sym_ptr] = ACTIONS(689),
    [aux_sym_type_keyword_token1] = ACTIONS(689),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_RBRACE] = ACTIONS(689),
    [anon_sym_LT_LBRACE] = ACTIONS(689),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_RBRACK] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(691),
    [anon_sym_COMMA] = ACTIONS(689),
    [anon_sym_align] = ACTIONS(691),
    [anon_sym_section] = ACTIONS(689),
    [anon_sym_partition] = ACTIONS(689),
    [anon_sym_comdat] = ACTIONS(689),
    [anon_sym_gc] = ACTIONS(689),
    [anon_sym_prefix] = ACTIONS(689),
    [anon_sym_prologue] = ACTIONS(689),
    [anon_sym_personality] = ACTIONS(689),
    [anon_sym_alignstack] = ACTIONS(689),
    [anon_sym_allocsize] = ACTIONS(689),
    [anon_sym_alwaysinline] = ACTIONS(689),
    [anon_sym_builtin] = ACTIONS(689),
    [anon_sym_cold] = ACTIONS(689),
    [anon_sym_convergent] = ACTIONS(689),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(689),
    [anon_sym_hot] = ACTIONS(689),
    [anon_sym_inaccessiblememonly] = ACTIONS(689),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(689),
    [anon_sym_inlinehint] = ACTIONS(689),
    [anon_sym_jumptable] = ACTIONS(689),
    [anon_sym_minsize] = ACTIONS(689),
    [anon_sym_naked] = ACTIONS(689),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(689),
    [anon_sym_nobuiltin] = ACTIONS(689),
    [anon_sym_noduplicate] = ACTIONS(689),
    [anon_sym_nofree] = ACTIONS(689),
    [anon_sym_noimplicitfloat] = ACTIONS(689),
    [anon_sym_noinline] = ACTIONS(689),
    [anon_sym_nomerge] = ACTIONS(689),
    [anon_sym_nonlazybind] = ACTIONS(689),
    [anon_sym_noprofile] = ACTIONS(689),
    [anon_sym_noredzone] = ACTIONS(689),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(689),
    [anon_sym_noreturn] = ACTIONS(689),
    [anon_sym_norecurse] = ACTIONS(689),
    [anon_sym_willreturn] = ACTIONS(689),
    [anon_sym_nosync] = ACTIONS(689),
    [anon_sym_nounwind] = ACTIONS(689),
    [anon_sym_nocallback] = ACTIONS(689),
    [anon_sym_nosanitize_coverage] = ACTIONS(689),
    [anon_sym_null_pointer_is_valid] = ACTIONS(689),
    [anon_sym_optforfuzzing] = ACTIONS(689),
    [anon_sym_optnone] = ACTIONS(689),
    [anon_sym_optsize] = ACTIONS(689),
    [anon_sym_readnone] = ACTIONS(689),
    [anon_sym_readonly] = ACTIONS(689),
    [anon_sym_writeonly] = ACTIONS(689),
    [anon_sym_argmemonly] = ACTIONS(689),
    [anon_sym_returns_twice] = ACTIONS(689),
    [anon_sym_safestack] = ACTIONS(689),
    [anon_sym_sanitize_address] = ACTIONS(689),
    [anon_sym_sanitize_memory] = ACTIONS(689),
    [anon_sym_sanitize_thread] = ACTIONS(689),
    [anon_sym_sanitize_hwaddress] = ACTIONS(689),
    [anon_sym_sanitize_memtag] = ACTIONS(689),
    [anon_sym_speculative_load_hardening] = ACTIONS(689),
    [anon_sym_speculatable] = ACTIONS(689),
    [anon_sym_ssp] = ACTIONS(691),
    [anon_sym_sspstrong] = ACTIONS(689),
    [anon_sym_sspreq] = ACTIONS(689),
    [anon_sym_strictfp] = ACTIONS(689),
    [anon_sym_nocf_check] = ACTIONS(689),
    [anon_sym_shadowcallstack] = ACTIONS(689),
    [anon_sym_mustprogress] = ACTIONS(689),
    [anon_sym_vscale_range] = ACTIONS(689),
    [anon_sym_preallocated] = ACTIONS(689),
    [anon_sym_zeroext] = ACTIONS(689),
    [anon_sym_signext] = ACTIONS(689),
    [anon_sym_inreg] = ACTIONS(689),
    [anon_sym_byval] = ACTIONS(689),
    [anon_sym_byref] = ACTIONS(689),
    [anon_sym_inalloca] = ACTIONS(689),
    [anon_sym_sret] = ACTIONS(689),
    [anon_sym_elementtype] = ACTIONS(689),
    [anon_sym_noalias] = ACTIONS(689),
    [anon_sym_nocapture] = ACTIONS(689),
    [anon_sym_nest] = ACTIONS(689),
    [anon_sym_returned] = ACTIONS(689),
    [anon_sym_nonnull] = ACTIONS(689),
    [anon_sym_dereferenceable] = ACTIONS(691),
    [anon_sym_dereferenceable_or_null] = ACTIONS(689),
    [anon_sym_swiftself] = ACTIONS(689),
    [anon_sym_swiftasync] = ACTIONS(689),
    [anon_sym_swifterror] = ACTIONS(689),
    [anon_sym_immarg] = ACTIONS(689),
    [anon_sym_noundef] = ACTIONS(689),
    [anon_sym_uwtable] = ACTIONS(689),
    [anon_sym_memory] = ACTIONS(689),
    [anon_sym_to] = ACTIONS(691),
    [anon_sym_uselistorder] = ACTIONS(691),
    [anon_sym_uselistorder_bb] = ACTIONS(689),
    [anon_sym_module] = ACTIONS(689),
    [anon_sym_attributes] = ACTIONS(689),
  },
  [347] = {
    [ts_builtin_sym_end] = ACTIONS(517),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(517),
    [sym_comdat_ref] = ACTIONS(517),
    [sym_global_var] = ACTIONS(517),
    [sym_local_var] = ACTIONS(517),
    [aux_sym_metadata_ref_token1] = ACTIONS(517),
    [sym_summary_ref] = ACTIONS(517),
    [sym_string] = ACTIONS(517),
    [anon_sym_target] = ACTIONS(517),
    [anon_sym_source_filename] = ACTIONS(517),
    [anon_sym_declare] = ACTIONS(517),
    [anon_sym_define] = ACTIONS(517),
    [anon_sym_void] = ACTIONS(517),
    [anon_sym_half] = ACTIONS(517),
    [anon_sym_bfloat] = ACTIONS(517),
    [anon_sym_float] = ACTIONS(517),
    [anon_sym_double] = ACTIONS(517),
    [anon_sym_x86_fp80] = ACTIONS(517),
    [anon_sym_fp128] = ACTIONS(517),
    [anon_sym_ppc_fp128] = ACTIONS(517),
    [anon_sym_label] = ACTIONS(517),
    [anon_sym_metadata] = ACTIONS(517),
    [anon_sym_x86_mmx] = ACTIONS(517),
    [anon_sym_x86_amx] = ACTIONS(517),
    [anon_sym_token] = ACTIONS(517),
    [anon_sym_opaque] = ACTIONS(517),
    [anon_sym_ptr] = ACTIONS(517),
    [aux_sym_type_keyword_token1] = ACTIONS(517),
    [anon_sym_LBRACE] = ACTIONS(517),
    [anon_sym_RBRACE] = ACTIONS(517),
    [anon_sym_LT_LBRACE] = ACTIONS(517),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_RBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_align] = ACTIONS(519),
    [anon_sym_section] = ACTIONS(517),
    [anon_sym_partition] = ACTIONS(517),
    [anon_sym_comdat] = ACTIONS(517),
    [anon_sym_gc] = ACTIONS(517),
    [anon_sym_prefix] = ACTIONS(517),
    [anon_sym_prologue] = ACTIONS(517),
    [anon_sym_personality] = ACTIONS(517),
    [anon_sym_alignstack] = ACTIONS(517),
    [anon_sym_allocsize] = ACTIONS(517),
    [anon_sym_alwaysinline] = ACTIONS(517),
    [anon_sym_builtin] = ACTIONS(517),
    [anon_sym_cold] = ACTIONS(517),
    [anon_sym_convergent] = ACTIONS(517),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(517),
    [anon_sym_hot] = ACTIONS(517),
    [anon_sym_inaccessiblememonly] = ACTIONS(517),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(517),
    [anon_sym_inlinehint] = ACTIONS(517),
    [anon_sym_jumptable] = ACTIONS(517),
    [anon_sym_minsize] = ACTIONS(517),
    [anon_sym_naked] = ACTIONS(517),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(517),
    [anon_sym_nobuiltin] = ACTIONS(517),
    [anon_sym_noduplicate] = ACTIONS(517),
    [anon_sym_nofree] = ACTIONS(517),
    [anon_sym_noimplicitfloat] = ACTIONS(517),
    [anon_sym_noinline] = ACTIONS(517),
    [anon_sym_nomerge] = ACTIONS(517),
    [anon_sym_nonlazybind] = ACTIONS(517),
    [anon_sym_noprofile] = ACTIONS(517),
    [anon_sym_noredzone] = ACTIONS(517),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(517),
    [anon_sym_noreturn] = ACTIONS(517),
    [anon_sym_norecurse] = ACTIONS(517),
    [anon_sym_willreturn] = ACTIONS(517),
    [anon_sym_nosync] = ACTIONS(517),
    [anon_sym_nounwind] = ACTIONS(517),
    [anon_sym_nocallback] = ACTIONS(517),
    [anon_sym_nosanitize_coverage] = ACTIONS(517),
    [anon_sym_null_pointer_is_valid] = ACTIONS(517),
    [anon_sym_optforfuzzing] = ACTIONS(517),
    [anon_sym_optnone] = ACTIONS(517),
    [anon_sym_optsize] = ACTIONS(517),
    [anon_sym_readnone] = ACTIONS(517),
    [anon_sym_readonly] = ACTIONS(517),
    [anon_sym_writeonly] = ACTIONS(517),
    [anon_sym_argmemonly] = ACTIONS(517),
    [anon_sym_returns_twice] = ACTIONS(517),
    [anon_sym_safestack] = ACTIONS(517),
    [anon_sym_sanitize_address] = ACTIONS(517),
    [anon_sym_sanitize_memory] = ACTIONS(517),
    [anon_sym_sanitize_thread] = ACTIONS(517),
    [anon_sym_sanitize_hwaddress] = ACTIONS(517),
    [anon_sym_sanitize_memtag] = ACTIONS(517),
    [anon_sym_speculative_load_hardening] = ACTIONS(517),
    [anon_sym_speculatable] = ACTIONS(517),
    [anon_sym_ssp] = ACTIONS(519),
    [anon_sym_sspstrong] = ACTIONS(517),
    [anon_sym_sspreq] = ACTIONS(517),
    [anon_sym_strictfp] = ACTIONS(517),
    [anon_sym_nocf_check] = ACTIONS(517),
    [anon_sym_shadowcallstack] = ACTIONS(517),
    [anon_sym_mustprogress] = ACTIONS(517),
    [anon_sym_vscale_range] = ACTIONS(517),
    [anon_sym_preallocated] = ACTIONS(517),
    [anon_sym_zeroext] = ACTIONS(517),
    [anon_sym_signext] = ACTIONS(517),
    [anon_sym_inreg] = ACTIONS(517),
    [anon_sym_byval] = ACTIONS(517),
    [anon_sym_byref] = ACTIONS(517),
    [anon_sym_inalloca] = ACTIONS(517),
    [anon_sym_sret] = ACTIONS(517),
    [anon_sym_elementtype] = ACTIONS(517),
    [anon_sym_noalias] = ACTIONS(517),
    [anon_sym_nocapture] = ACTIONS(517),
    [anon_sym_nest] = ACTIONS(517),
    [anon_sym_returned] = ACTIONS(517),
    [anon_sym_nonnull] = ACTIONS(517),
    [anon_sym_dereferenceable] = ACTIONS(519),
    [anon_sym_dereferenceable_or_null] = ACTIONS(517),
    [anon_sym_swiftself] = ACTIONS(517),
    [anon_sym_swiftasync] = ACTIONS(517),
    [anon_sym_swifterror] = ACTIONS(517),
    [anon_sym_immarg] = ACTIONS(517),
    [anon_sym_noundef] = ACTIONS(517),
    [anon_sym_uwtable] = ACTIONS(517),
    [anon_sym_memory] = ACTIONS(517),
    [anon_sym_to] = ACTIONS(519),
    [anon_sym_uselistorder] = ACTIONS(519),
    [anon_sym_uselistorder_bb] = ACTIONS(517),
    [anon_sym_module] = ACTIONS(517),
    [anon_sym_attributes] = ACTIONS(517),
  },
  [348] = {
    [ts_builtin_sym_end] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(529),
    [sym_comdat_ref] = ACTIONS(529),
    [sym_global_var] = ACTIONS(529),
    [sym_local_var] = ACTIONS(529),
    [aux_sym_metadata_ref_token1] = ACTIONS(529),
    [sym_summary_ref] = ACTIONS(529),
    [sym_string] = ACTIONS(529),
    [anon_sym_target] = ACTIONS(529),
    [anon_sym_source_filename] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_define] = ACTIONS(529),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_half] = ACTIONS(529),
    [anon_sym_bfloat] = ACTIONS(529),
    [anon_sym_float] = ACTIONS(529),
    [anon_sym_double] = ACTIONS(529),
    [anon_sym_x86_fp80] = ACTIONS(529),
    [anon_sym_fp128] = ACTIONS(529),
    [anon_sym_ppc_fp128] = ACTIONS(529),
    [anon_sym_label] = ACTIONS(529),
    [anon_sym_metadata] = ACTIONS(529),
    [anon_sym_x86_mmx] = ACTIONS(529),
    [anon_sym_x86_amx] = ACTIONS(529),
    [anon_sym_token] = ACTIONS(529),
    [anon_sym_opaque] = ACTIONS(529),
    [anon_sym_ptr] = ACTIONS(529),
    [aux_sym_type_keyword_token1] = ACTIONS(529),
    [anon_sym_LBRACE] = ACTIONS(529),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_LT_LBRACE] = ACTIONS(529),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_RBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(531),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_align] = ACTIONS(531),
    [anon_sym_section] = ACTIONS(529),
    [anon_sym_partition] = ACTIONS(529),
    [anon_sym_comdat] = ACTIONS(529),
    [anon_sym_gc] = ACTIONS(529),
    [anon_sym_prefix] = ACTIONS(529),
    [anon_sym_prologue] = ACTIONS(529),
    [anon_sym_personality] = ACTIONS(529),
    [anon_sym_alignstack] = ACTIONS(529),
    [anon_sym_allocsize] = ACTIONS(529),
    [anon_sym_alwaysinline] = ACTIONS(529),
    [anon_sym_builtin] = ACTIONS(529),
    [anon_sym_cold] = ACTIONS(529),
    [anon_sym_convergent] = ACTIONS(529),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(529),
    [anon_sym_hot] = ACTIONS(529),
    [anon_sym_inaccessiblememonly] = ACTIONS(529),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(529),
    [anon_sym_inlinehint] = ACTIONS(529),
    [anon_sym_jumptable] = ACTIONS(529),
    [anon_sym_minsize] = ACTIONS(529),
    [anon_sym_naked] = ACTIONS(529),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(529),
    [anon_sym_nobuiltin] = ACTIONS(529),
    [anon_sym_noduplicate] = ACTIONS(529),
    [anon_sym_nofree] = ACTIONS(529),
    [anon_sym_noimplicitfloat] = ACTIONS(529),
    [anon_sym_noinline] = ACTIONS(529),
    [anon_sym_nomerge] = ACTIONS(529),
    [anon_sym_nonlazybind] = ACTIONS(529),
    [anon_sym_noprofile] = ACTIONS(529),
    [anon_sym_noredzone] = ACTIONS(529),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(529),
    [anon_sym_noreturn] = ACTIONS(529),
    [anon_sym_norecurse] = ACTIONS(529),
    [anon_sym_willreturn] = ACTIONS(529),
    [anon_sym_nosync] = ACTIONS(529),
    [anon_sym_nounwind] = ACTIONS(529),
    [anon_sym_nocallback] = ACTIONS(529),
    [anon_sym_nosanitize_coverage] = ACTIONS(529),
    [anon_sym_null_pointer_is_valid] = ACTIONS(529),
    [anon_sym_optforfuzzing] = ACTIONS(529),
    [anon_sym_optnone] = ACTIONS(529),
    [anon_sym_optsize] = ACTIONS(529),
    [anon_sym_readnone] = ACTIONS(529),
    [anon_sym_readonly] = ACTIONS(529),
    [anon_sym_writeonly] = ACTIONS(529),
    [anon_sym_argmemonly] = ACTIONS(529),
    [anon_sym_returns_twice] = ACTIONS(529),
    [anon_sym_safestack] = ACTIONS(529),
    [anon_sym_sanitize_address] = ACTIONS(529),
    [anon_sym_sanitize_memory] = ACTIONS(529),
    [anon_sym_sanitize_thread] = ACTIONS(529),
    [anon_sym_sanitize_hwaddress] = ACTIONS(529),
    [anon_sym_sanitize_memtag] = ACTIONS(529),
    [anon_sym_speculative_load_hardening] = ACTIONS(529),
    [anon_sym_speculatable] = ACTIONS(529),
    [anon_sym_ssp] = ACTIONS(531),
    [anon_sym_sspstrong] = ACTIONS(529),
    [anon_sym_sspreq] = ACTIONS(529),
    [anon_sym_strictfp] = ACTIONS(529),
    [anon_sym_nocf_check] = ACTIONS(529),
    [anon_sym_shadowcallstack] = ACTIONS(529),
    [anon_sym_mustprogress] = ACTIONS(529),
    [anon_sym_vscale_range] = ACTIONS(529),
    [anon_sym_preallocated] = ACTIONS(529),
    [anon_sym_zeroext] = ACTIONS(529),
    [anon_sym_signext] = ACTIONS(529),
    [anon_sym_inreg] = ACTIONS(529),
    [anon_sym_byval] = ACTIONS(529),
    [anon_sym_byref] = ACTIONS(529),
    [anon_sym_inalloca] = ACTIONS(529),
    [anon_sym_sret] = ACTIONS(529),
    [anon_sym_elementtype] = ACTIONS(529),
    [anon_sym_noalias] = ACTIONS(529),
    [anon_sym_nocapture] = ACTIONS(529),
    [anon_sym_nest] = ACTIONS(529),
    [anon_sym_returned] = ACTIONS(529),
    [anon_sym_nonnull] = ACTIONS(529),
    [anon_sym_dereferenceable] = ACTIONS(531),
    [anon_sym_dereferenceable_or_null] = ACTIONS(529),
    [anon_sym_swiftself] = ACTIONS(529),
    [anon_sym_swiftasync] = ACTIONS(529),
    [anon_sym_swifterror] = ACTIONS(529),
    [anon_sym_immarg] = ACTIONS(529),
    [anon_sym_noundef] = ACTIONS(529),
    [anon_sym_uwtable] = ACTIONS(529),
    [anon_sym_memory] = ACTIONS(529),
    [anon_sym_to] = ACTIONS(531),
    [anon_sym_uselistorder] = ACTIONS(531),
    [anon_sym_uselistorder_bb] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_attributes] = ACTIONS(529),
  },
  [349] = {
    [ts_builtin_sym_end] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(545),
    [sym_comdat_ref] = ACTIONS(545),
    [sym_global_var] = ACTIONS(545),
    [sym_local_var] = ACTIONS(545),
    [aux_sym_metadata_ref_token1] = ACTIONS(545),
    [sym_summary_ref] = ACTIONS(545),
    [sym_string] = ACTIONS(545),
    [anon_sym_target] = ACTIONS(545),
    [anon_sym_source_filename] = ACTIONS(545),
    [anon_sym_declare] = ACTIONS(545),
    [anon_sym_define] = ACTIONS(545),
    [anon_sym_void] = ACTIONS(545),
    [anon_sym_half] = ACTIONS(545),
    [anon_sym_bfloat] = ACTIONS(545),
    [anon_sym_float] = ACTIONS(545),
    [anon_sym_double] = ACTIONS(545),
    [anon_sym_x86_fp80] = ACTIONS(545),
    [anon_sym_fp128] = ACTIONS(545),
    [anon_sym_ppc_fp128] = ACTIONS(545),
    [anon_sym_label] = ACTIONS(545),
    [anon_sym_metadata] = ACTIONS(545),
    [anon_sym_x86_mmx] = ACTIONS(545),
    [anon_sym_x86_amx] = ACTIONS(545),
    [anon_sym_token] = ACTIONS(545),
    [anon_sym_opaque] = ACTIONS(545),
    [anon_sym_ptr] = ACTIONS(545),
    [aux_sym_type_keyword_token1] = ACTIONS(545),
    [anon_sym_LBRACE] = ACTIONS(545),
    [anon_sym_RBRACE] = ACTIONS(545),
    [anon_sym_LT_LBRACE] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(545),
    [anon_sym_RBRACK] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_COMMA] = ACTIONS(545),
    [anon_sym_align] = ACTIONS(547),
    [anon_sym_section] = ACTIONS(545),
    [anon_sym_partition] = ACTIONS(545),
    [anon_sym_comdat] = ACTIONS(545),
    [anon_sym_gc] = ACTIONS(545),
    [anon_sym_prefix] = ACTIONS(545),
    [anon_sym_prologue] = ACTIONS(545),
    [anon_sym_personality] = ACTIONS(545),
    [anon_sym_alignstack] = ACTIONS(545),
    [anon_sym_allocsize] = ACTIONS(545),
    [anon_sym_alwaysinline] = ACTIONS(545),
    [anon_sym_builtin] = ACTIONS(545),
    [anon_sym_cold] = ACTIONS(545),
    [anon_sym_convergent] = ACTIONS(545),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(545),
    [anon_sym_hot] = ACTIONS(545),
    [anon_sym_inaccessiblememonly] = ACTIONS(545),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(545),
    [anon_sym_inlinehint] = ACTIONS(545),
    [anon_sym_jumptable] = ACTIONS(545),
    [anon_sym_minsize] = ACTIONS(545),
    [anon_sym_naked] = ACTIONS(545),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(545),
    [anon_sym_nobuiltin] = ACTIONS(545),
    [anon_sym_noduplicate] = ACTIONS(545),
    [anon_sym_nofree] = ACTIONS(545),
    [anon_sym_noimplicitfloat] = ACTIONS(545),
    [anon_sym_noinline] = ACTIONS(545),
    [anon_sym_nomerge] = ACTIONS(545),
    [anon_sym_nonlazybind] = ACTIONS(545),
    [anon_sym_noprofile] = ACTIONS(545),
    [anon_sym_noredzone] = ACTIONS(545),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(545),
    [anon_sym_noreturn] = ACTIONS(545),
    [anon_sym_norecurse] = ACTIONS(545),
    [anon_sym_willreturn] = ACTIONS(545),
    [anon_sym_nosync] = ACTIONS(545),
    [anon_sym_nounwind] = ACTIONS(545),
    [anon_sym_nocallback] = ACTIONS(545),
    [anon_sym_nosanitize_coverage] = ACTIONS(545),
    [anon_sym_null_pointer_is_valid] = ACTIONS(545),
    [anon_sym_optforfuzzing] = ACTIONS(545),
    [anon_sym_optnone] = ACTIONS(545),
    [anon_sym_optsize] = ACTIONS(545),
    [anon_sym_readnone] = ACTIONS(545),
    [anon_sym_readonly] = ACTIONS(545),
    [anon_sym_writeonly] = ACTIONS(545),
    [anon_sym_argmemonly] = ACTIONS(545),
    [anon_sym_returns_twice] = ACTIONS(545),
    [anon_sym_safestack] = ACTIONS(545),
    [anon_sym_sanitize_address] = ACTIONS(545),
    [anon_sym_sanitize_memory] = ACTIONS(545),
    [anon_sym_sanitize_thread] = ACTIONS(545),
    [anon_sym_sanitize_hwaddress] = ACTIONS(545),
    [anon_sym_sanitize_memtag] = ACTIONS(545),
    [anon_sym_speculative_load_hardening] = ACTIONS(545),
    [anon_sym_speculatable] = ACTIONS(545),
    [anon_sym_ssp] = ACTIONS(547),
    [anon_sym_sspstrong] = ACTIONS(545),
    [anon_sym_sspreq] = ACTIONS(545),
    [anon_sym_strictfp] = ACTIONS(545),
    [anon_sym_nocf_check] = ACTIONS(545),
    [anon_sym_shadowcallstack] = ACTIONS(545),
    [anon_sym_mustprogress] = ACTIONS(545),
    [anon_sym_vscale_range] = ACTIONS(545),
    [anon_sym_preallocated] = ACTIONS(545),
    [anon_sym_zeroext] = ACTIONS(545),
    [anon_sym_signext] = ACTIONS(545),
    [anon_sym_inreg] = ACTIONS(545),
    [anon_sym_byval] = ACTIONS(545),
    [anon_sym_byref] = ACTIONS(545),
    [anon_sym_inalloca] = ACTIONS(545),
    [anon_sym_sret] = ACTIONS(545),
    [anon_sym_elementtype] = ACTIONS(545),
    [anon_sym_noalias] = ACTIONS(545),
    [anon_sym_nocapture] = ACTIONS(545),
    [anon_sym_nest] = ACTIONS(545),
    [anon_sym_returned] = ACTIONS(545),
    [anon_sym_nonnull] = ACTIONS(545),
    [anon_sym_dereferenceable] = ACTIONS(547),
    [anon_sym_dereferenceable_or_null] = ACTIONS(545),
    [anon_sym_swiftself] = ACTIONS(545),
    [anon_sym_swiftasync] = ACTIONS(545),
    [anon_sym_swifterror] = ACTIONS(545),
    [anon_sym_immarg] = ACTIONS(545),
    [anon_sym_noundef] = ACTIONS(545),
    [anon_sym_uwtable] = ACTIONS(545),
    [anon_sym_memory] = ACTIONS(545),
    [anon_sym_to] = ACTIONS(547),
    [anon_sym_uselistorder] = ACTIONS(547),
    [anon_sym_uselistorder_bb] = ACTIONS(545),
    [anon_sym_module] = ACTIONS(545),
    [anon_sym_attributes] = ACTIONS(545),
  },
  [350] = {
    [ts_builtin_sym_end] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(579),
    [sym_comdat_ref] = ACTIONS(579),
    [sym_global_var] = ACTIONS(579),
    [sym_local_var] = ACTIONS(579),
    [aux_sym_metadata_ref_token1] = ACTIONS(579),
    [sym_summary_ref] = ACTIONS(579),
    [sym_string] = ACTIONS(579),
    [anon_sym_target] = ACTIONS(579),
    [anon_sym_source_filename] = ACTIONS(579),
    [anon_sym_declare] = ACTIONS(579),
    [anon_sym_define] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_half] = ACTIONS(579),
    [anon_sym_bfloat] = ACTIONS(579),
    [anon_sym_float] = ACTIONS(579),
    [anon_sym_double] = ACTIONS(579),
    [anon_sym_x86_fp80] = ACTIONS(579),
    [anon_sym_fp128] = ACTIONS(579),
    [anon_sym_ppc_fp128] = ACTIONS(579),
    [anon_sym_label] = ACTIONS(579),
    [anon_sym_metadata] = ACTIONS(579),
    [anon_sym_x86_mmx] = ACTIONS(579),
    [anon_sym_x86_amx] = ACTIONS(579),
    [anon_sym_token] = ACTIONS(579),
    [anon_sym_opaque] = ACTIONS(579),
    [anon_sym_ptr] = ACTIONS(579),
    [aux_sym_type_keyword_token1] = ACTIONS(579),
    [anon_sym_LBRACE] = ACTIONS(579),
    [anon_sym_RBRACE] = ACTIONS(579),
    [anon_sym_LT_LBRACE] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(579),
    [anon_sym_RBRACK] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(579),
    [anon_sym_align] = ACTIONS(581),
    [anon_sym_section] = ACTIONS(579),
    [anon_sym_partition] = ACTIONS(579),
    [anon_sym_comdat] = ACTIONS(579),
    [anon_sym_gc] = ACTIONS(579),
    [anon_sym_prefix] = ACTIONS(579),
    [anon_sym_prologue] = ACTIONS(579),
    [anon_sym_personality] = ACTIONS(579),
    [anon_sym_alignstack] = ACTIONS(579),
    [anon_sym_allocsize] = ACTIONS(579),
    [anon_sym_alwaysinline] = ACTIONS(579),
    [anon_sym_builtin] = ACTIONS(579),
    [anon_sym_cold] = ACTIONS(579),
    [anon_sym_convergent] = ACTIONS(579),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(579),
    [anon_sym_hot] = ACTIONS(579),
    [anon_sym_inaccessiblememonly] = ACTIONS(579),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(579),
    [anon_sym_inlinehint] = ACTIONS(579),
    [anon_sym_jumptable] = ACTIONS(579),
    [anon_sym_minsize] = ACTIONS(579),
    [anon_sym_naked] = ACTIONS(579),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(579),
    [anon_sym_nobuiltin] = ACTIONS(579),
    [anon_sym_noduplicate] = ACTIONS(579),
    [anon_sym_nofree] = ACTIONS(579),
    [anon_sym_noimplicitfloat] = ACTIONS(579),
    [anon_sym_noinline] = ACTIONS(579),
    [anon_sym_nomerge] = ACTIONS(579),
    [anon_sym_nonlazybind] = ACTIONS(579),
    [anon_sym_noprofile] = ACTIONS(579),
    [anon_sym_noredzone] = ACTIONS(579),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(579),
    [anon_sym_noreturn] = ACTIONS(579),
    [anon_sym_norecurse] = ACTIONS(579),
    [anon_sym_willreturn] = ACTIONS(579),
    [anon_sym_nosync] = ACTIONS(579),
    [anon_sym_nounwind] = ACTIONS(579),
    [anon_sym_nocallback] = ACTIONS(579),
    [anon_sym_nosanitize_coverage] = ACTIONS(579),
    [anon_sym_null_pointer_is_valid] = ACTIONS(579),
    [anon_sym_optforfuzzing] = ACTIONS(579),
    [anon_sym_optnone] = ACTIONS(579),
    [anon_sym_optsize] = ACTIONS(579),
    [anon_sym_readnone] = ACTIONS(579),
    [anon_sym_readonly] = ACTIONS(579),
    [anon_sym_writeonly] = ACTIONS(579),
    [anon_sym_argmemonly] = ACTIONS(579),
    [anon_sym_returns_twice] = ACTIONS(579),
    [anon_sym_safestack] = ACTIONS(579),
    [anon_sym_sanitize_address] = ACTIONS(579),
    [anon_sym_sanitize_memory] = ACTIONS(579),
    [anon_sym_sanitize_thread] = ACTIONS(579),
    [anon_sym_sanitize_hwaddress] = ACTIONS(579),
    [anon_sym_sanitize_memtag] = ACTIONS(579),
    [anon_sym_speculative_load_hardening] = ACTIONS(579),
    [anon_sym_speculatable] = ACTIONS(579),
    [anon_sym_ssp] = ACTIONS(581),
    [anon_sym_sspstrong] = ACTIONS(579),
    [anon_sym_sspreq] = ACTIONS(579),
    [anon_sym_strictfp] = ACTIONS(579),
    [anon_sym_nocf_check] = ACTIONS(579),
    [anon_sym_shadowcallstack] = ACTIONS(579),
    [anon_sym_mustprogress] = ACTIONS(579),
    [anon_sym_vscale_range] = ACTIONS(579),
    [anon_sym_preallocated] = ACTIONS(579),
    [anon_sym_zeroext] = ACTIONS(579),
    [anon_sym_signext] = ACTIONS(579),
    [anon_sym_inreg] = ACTIONS(579),
    [anon_sym_byval] = ACTIONS(579),
    [anon_sym_byref] = ACTIONS(579),
    [anon_sym_inalloca] = ACTIONS(579),
    [anon_sym_sret] = ACTIONS(579),
    [anon_sym_elementtype] = ACTIONS(579),
    [anon_sym_noalias] = ACTIONS(579),
    [anon_sym_nocapture] = ACTIONS(579),
    [anon_sym_nest] = ACTIONS(579),
    [anon_sym_returned] = ACTIONS(579),
    [anon_sym_nonnull] = ACTIONS(579),
    [anon_sym_dereferenceable] = ACTIONS(581),
    [anon_sym_dereferenceable_or_null] = ACTIONS(579),
    [anon_sym_swiftself] = ACTIONS(579),
    [anon_sym_swiftasync] = ACTIONS(579),
    [anon_sym_swifterror] = ACTIONS(579),
    [anon_sym_immarg] = ACTIONS(579),
    [anon_sym_noundef] = ACTIONS(579),
    [anon_sym_uwtable] = ACTIONS(579),
    [anon_sym_memory] = ACTIONS(579),
    [anon_sym_to] = ACTIONS(581),
    [anon_sym_uselistorder] = ACTIONS(581),
    [anon_sym_uselistorder_bb] = ACTIONS(579),
    [anon_sym_module] = ACTIONS(579),
    [anon_sym_attributes] = ACTIONS(579),
  },
  [351] = {
    [ts_builtin_sym_end] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(693),
    [sym_comdat_ref] = ACTIONS(693),
    [sym_global_var] = ACTIONS(693),
    [sym_local_var] = ACTIONS(693),
    [aux_sym_metadata_ref_token1] = ACTIONS(693),
    [sym_summary_ref] = ACTIONS(693),
    [sym_string] = ACTIONS(693),
    [anon_sym_target] = ACTIONS(693),
    [anon_sym_source_filename] = ACTIONS(693),
    [anon_sym_declare] = ACTIONS(693),
    [anon_sym_define] = ACTIONS(693),
    [anon_sym_void] = ACTIONS(693),
    [anon_sym_half] = ACTIONS(693),
    [anon_sym_bfloat] = ACTIONS(693),
    [anon_sym_float] = ACTIONS(693),
    [anon_sym_double] = ACTIONS(693),
    [anon_sym_x86_fp80] = ACTIONS(693),
    [anon_sym_fp128] = ACTIONS(693),
    [anon_sym_ppc_fp128] = ACTIONS(693),
    [anon_sym_label] = ACTIONS(693),
    [anon_sym_metadata] = ACTIONS(693),
    [anon_sym_x86_mmx] = ACTIONS(693),
    [anon_sym_x86_amx] = ACTIONS(693),
    [anon_sym_token] = ACTIONS(693),
    [anon_sym_opaque] = ACTIONS(693),
    [anon_sym_ptr] = ACTIONS(693),
    [aux_sym_type_keyword_token1] = ACTIONS(693),
    [anon_sym_LBRACE] = ACTIONS(693),
    [anon_sym_RBRACE] = ACTIONS(693),
    [anon_sym_LT_LBRACE] = ACTIONS(693),
    [anon_sym_LBRACK] = ACTIONS(693),
    [anon_sym_RBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_COMMA] = ACTIONS(693),
    [anon_sym_align] = ACTIONS(695),
    [anon_sym_section] = ACTIONS(693),
    [anon_sym_partition] = ACTIONS(693),
    [anon_sym_comdat] = ACTIONS(693),
    [anon_sym_gc] = ACTIONS(693),
    [anon_sym_prefix] = ACTIONS(693),
    [anon_sym_prologue] = ACTIONS(693),
    [anon_sym_personality] = ACTIONS(693),
    [anon_sym_alignstack] = ACTIONS(693),
    [anon_sym_allocsize] = ACTIONS(693),
    [anon_sym_alwaysinline] = ACTIONS(693),
    [anon_sym_builtin] = ACTIONS(693),
    [anon_sym_cold] = ACTIONS(693),
    [anon_sym_convergent] = ACTIONS(693),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(693),
    [anon_sym_hot] = ACTIONS(693),
    [anon_sym_inaccessiblememonly] = ACTIONS(693),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(693),
    [anon_sym_inlinehint] = ACTIONS(693),
    [anon_sym_jumptable] = ACTIONS(693),
    [anon_sym_minsize] = ACTIONS(693),
    [anon_sym_naked] = ACTIONS(693),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(693),
    [anon_sym_nobuiltin] = ACTIONS(693),
    [anon_sym_noduplicate] = ACTIONS(693),
    [anon_sym_nofree] = ACTIONS(693),
    [anon_sym_noimplicitfloat] = ACTIONS(693),
    [anon_sym_noinline] = ACTIONS(693),
    [anon_sym_nomerge] = ACTIONS(693),
    [anon_sym_nonlazybind] = ACTIONS(693),
    [anon_sym_noprofile] = ACTIONS(693),
    [anon_sym_noredzone] = ACTIONS(693),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(693),
    [anon_sym_noreturn] = ACTIONS(693),
    [anon_sym_norecurse] = ACTIONS(693),
    [anon_sym_willreturn] = ACTIONS(693),
    [anon_sym_nosync] = ACTIONS(693),
    [anon_sym_nounwind] = ACTIONS(693),
    [anon_sym_nocallback] = ACTIONS(693),
    [anon_sym_nosanitize_coverage] = ACTIONS(693),
    [anon_sym_null_pointer_is_valid] = ACTIONS(693),
    [anon_sym_optforfuzzing] = ACTIONS(693),
    [anon_sym_optnone] = ACTIONS(693),
    [anon_sym_optsize] = ACTIONS(693),
    [anon_sym_readnone] = ACTIONS(693),
    [anon_sym_readonly] = ACTIONS(693),
    [anon_sym_writeonly] = ACTIONS(693),
    [anon_sym_argmemonly] = ACTIONS(693),
    [anon_sym_returns_twice] = ACTIONS(693),
    [anon_sym_safestack] = ACTIONS(693),
    [anon_sym_sanitize_address] = ACTIONS(693),
    [anon_sym_sanitize_memory] = ACTIONS(693),
    [anon_sym_sanitize_thread] = ACTIONS(693),
    [anon_sym_sanitize_hwaddress] = ACTIONS(693),
    [anon_sym_sanitize_memtag] = ACTIONS(693),
    [anon_sym_speculative_load_hardening] = ACTIONS(693),
    [anon_sym_speculatable] = ACTIONS(693),
    [anon_sym_ssp] = ACTIONS(695),
    [anon_sym_sspstrong] = ACTIONS(693),
    [anon_sym_sspreq] = ACTIONS(693),
    [anon_sym_strictfp] = ACTIONS(693),
    [anon_sym_nocf_check] = ACTIONS(693),
    [anon_sym_shadowcallstack] = ACTIONS(693),
    [anon_sym_mustprogress] = ACTIONS(693),
    [anon_sym_vscale_range] = ACTIONS(693),
    [anon_sym_preallocated] = ACTIONS(693),
    [anon_sym_zeroext] = ACTIONS(693),
    [anon_sym_signext] = ACTIONS(693),
    [anon_sym_inreg] = ACTIONS(693),
    [anon_sym_byval] = ACTIONS(693),
    [anon_sym_byref] = ACTIONS(693),
    [anon_sym_inalloca] = ACTIONS(693),
    [anon_sym_sret] = ACTIONS(693),
    [anon_sym_elementtype] = ACTIONS(693),
    [anon_sym_noalias] = ACTIONS(693),
    [anon_sym_nocapture] = ACTIONS(693),
    [anon_sym_nest] = ACTIONS(693),
    [anon_sym_returned] = ACTIONS(693),
    [anon_sym_nonnull] = ACTIONS(693),
    [anon_sym_dereferenceable] = ACTIONS(695),
    [anon_sym_dereferenceable_or_null] = ACTIONS(693),
    [anon_sym_swiftself] = ACTIONS(693),
    [anon_sym_swiftasync] = ACTIONS(693),
    [anon_sym_swifterror] = ACTIONS(693),
    [anon_sym_immarg] = ACTIONS(693),
    [anon_sym_noundef] = ACTIONS(693),
    [anon_sym_uwtable] = ACTIONS(693),
    [anon_sym_memory] = ACTIONS(693),
    [anon_sym_to] = ACTIONS(695),
    [anon_sym_uselistorder] = ACTIONS(695),
    [anon_sym_uselistorder_bb] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(693),
    [anon_sym_attributes] = ACTIONS(693),
  },
  [352] = {
    [ts_builtin_sym_end] = ACTIONS(701),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(701),
    [sym_comdat_ref] = ACTIONS(701),
    [sym_global_var] = ACTIONS(701),
    [sym_local_var] = ACTIONS(701),
    [aux_sym_metadata_ref_token1] = ACTIONS(701),
    [sym_summary_ref] = ACTIONS(701),
    [sym_string] = ACTIONS(701),
    [anon_sym_target] = ACTIONS(701),
    [anon_sym_source_filename] = ACTIONS(701),
    [anon_sym_declare] = ACTIONS(701),
    [anon_sym_define] = ACTIONS(701),
    [anon_sym_void] = ACTIONS(701),
    [anon_sym_half] = ACTIONS(701),
    [anon_sym_bfloat] = ACTIONS(701),
    [anon_sym_float] = ACTIONS(701),
    [anon_sym_double] = ACTIONS(701),
    [anon_sym_x86_fp80] = ACTIONS(701),
    [anon_sym_fp128] = ACTIONS(701),
    [anon_sym_ppc_fp128] = ACTIONS(701),
    [anon_sym_label] = ACTIONS(701),
    [anon_sym_metadata] = ACTIONS(701),
    [anon_sym_x86_mmx] = ACTIONS(701),
    [anon_sym_x86_amx] = ACTIONS(701),
    [anon_sym_token] = ACTIONS(701),
    [anon_sym_opaque] = ACTIONS(701),
    [anon_sym_ptr] = ACTIONS(701),
    [aux_sym_type_keyword_token1] = ACTIONS(701),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_RBRACE] = ACTIONS(701),
    [anon_sym_LT_LBRACE] = ACTIONS(701),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_RBRACK] = ACTIONS(701),
    [anon_sym_LT] = ACTIONS(703),
    [anon_sym_COMMA] = ACTIONS(701),
    [anon_sym_align] = ACTIONS(703),
    [anon_sym_section] = ACTIONS(701),
    [anon_sym_partition] = ACTIONS(701),
    [anon_sym_comdat] = ACTIONS(701),
    [anon_sym_gc] = ACTIONS(701),
    [anon_sym_prefix] = ACTIONS(701),
    [anon_sym_prologue] = ACTIONS(701),
    [anon_sym_personality] = ACTIONS(701),
    [anon_sym_alignstack] = ACTIONS(701),
    [anon_sym_allocsize] = ACTIONS(701),
    [anon_sym_alwaysinline] = ACTIONS(701),
    [anon_sym_builtin] = ACTIONS(701),
    [anon_sym_cold] = ACTIONS(701),
    [anon_sym_convergent] = ACTIONS(701),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(701),
    [anon_sym_hot] = ACTIONS(701),
    [anon_sym_inaccessiblememonly] = ACTIONS(701),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(701),
    [anon_sym_inlinehint] = ACTIONS(701),
    [anon_sym_jumptable] = ACTIONS(701),
    [anon_sym_minsize] = ACTIONS(701),
    [anon_sym_naked] = ACTIONS(701),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(701),
    [anon_sym_nobuiltin] = ACTIONS(701),
    [anon_sym_noduplicate] = ACTIONS(701),
    [anon_sym_nofree] = ACTIONS(701),
    [anon_sym_noimplicitfloat] = ACTIONS(701),
    [anon_sym_noinline] = ACTIONS(701),
    [anon_sym_nomerge] = ACTIONS(701),
    [anon_sym_nonlazybind] = ACTIONS(701),
    [anon_sym_noprofile] = ACTIONS(701),
    [anon_sym_noredzone] = ACTIONS(701),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(701),
    [anon_sym_noreturn] = ACTIONS(701),
    [anon_sym_norecurse] = ACTIONS(701),
    [anon_sym_willreturn] = ACTIONS(701),
    [anon_sym_nosync] = ACTIONS(701),
    [anon_sym_nounwind] = ACTIONS(701),
    [anon_sym_nocallback] = ACTIONS(701),
    [anon_sym_nosanitize_coverage] = ACTIONS(701),
    [anon_sym_null_pointer_is_valid] = ACTIONS(701),
    [anon_sym_optforfuzzing] = ACTIONS(701),
    [anon_sym_optnone] = ACTIONS(701),
    [anon_sym_optsize] = ACTIONS(701),
    [anon_sym_readnone] = ACTIONS(701),
    [anon_sym_readonly] = ACTIONS(701),
    [anon_sym_writeonly] = ACTIONS(701),
    [anon_sym_argmemonly] = ACTIONS(701),
    [anon_sym_returns_twice] = ACTIONS(701),
    [anon_sym_safestack] = ACTIONS(701),
    [anon_sym_sanitize_address] = ACTIONS(701),
    [anon_sym_sanitize_memory] = ACTIONS(701),
    [anon_sym_sanitize_thread] = ACTIONS(701),
    [anon_sym_sanitize_hwaddress] = ACTIONS(701),
    [anon_sym_sanitize_memtag] = ACTIONS(701),
    [anon_sym_speculative_load_hardening] = ACTIONS(701),
    [anon_sym_speculatable] = ACTIONS(701),
    [anon_sym_ssp] = ACTIONS(703),
    [anon_sym_sspstrong] = ACTIONS(701),
    [anon_sym_sspreq] = ACTIONS(701),
    [anon_sym_strictfp] = ACTIONS(701),
    [anon_sym_nocf_check] = ACTIONS(701),
    [anon_sym_shadowcallstack] = ACTIONS(701),
    [anon_sym_mustprogress] = ACTIONS(701),
    [anon_sym_vscale_range] = ACTIONS(701),
    [anon_sym_preallocated] = ACTIONS(701),
    [anon_sym_zeroext] = ACTIONS(701),
    [anon_sym_signext] = ACTIONS(701),
    [anon_sym_inreg] = ACTIONS(701),
    [anon_sym_byval] = ACTIONS(701),
    [anon_sym_byref] = ACTIONS(701),
    [anon_sym_inalloca] = ACTIONS(701),
    [anon_sym_sret] = ACTIONS(701),
    [anon_sym_elementtype] = ACTIONS(701),
    [anon_sym_noalias] = ACTIONS(701),
    [anon_sym_nocapture] = ACTIONS(701),
    [anon_sym_nest] = ACTIONS(701),
    [anon_sym_returned] = ACTIONS(701),
    [anon_sym_nonnull] = ACTIONS(701),
    [anon_sym_dereferenceable] = ACTIONS(703),
    [anon_sym_dereferenceable_or_null] = ACTIONS(701),
    [anon_sym_swiftself] = ACTIONS(701),
    [anon_sym_swiftasync] = ACTIONS(701),
    [anon_sym_swifterror] = ACTIONS(701),
    [anon_sym_immarg] = ACTIONS(701),
    [anon_sym_noundef] = ACTIONS(701),
    [anon_sym_uwtable] = ACTIONS(701),
    [anon_sym_memory] = ACTIONS(701),
    [anon_sym_to] = ACTIONS(703),
    [anon_sym_uselistorder] = ACTIONS(703),
    [anon_sym_uselistorder_bb] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(701),
    [anon_sym_attributes] = ACTIONS(701),
  },
  [353] = {
    [ts_builtin_sym_end] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(595),
    [sym_comdat_ref] = ACTIONS(595),
    [sym_global_var] = ACTIONS(595),
    [sym_local_var] = ACTIONS(595),
    [aux_sym_metadata_ref_token1] = ACTIONS(595),
    [sym_summary_ref] = ACTIONS(595),
    [sym_string] = ACTIONS(595),
    [anon_sym_target] = ACTIONS(595),
    [anon_sym_source_filename] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_define] = ACTIONS(595),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_half] = ACTIONS(595),
    [anon_sym_bfloat] = ACTIONS(595),
    [anon_sym_float] = ACTIONS(595),
    [anon_sym_double] = ACTIONS(595),
    [anon_sym_x86_fp80] = ACTIONS(595),
    [anon_sym_fp128] = ACTIONS(595),
    [anon_sym_ppc_fp128] = ACTIONS(595),
    [anon_sym_label] = ACTIONS(595),
    [anon_sym_metadata] = ACTIONS(595),
    [anon_sym_x86_mmx] = ACTIONS(595),
    [anon_sym_x86_amx] = ACTIONS(595),
    [anon_sym_token] = ACTIONS(595),
    [anon_sym_opaque] = ACTIONS(595),
    [anon_sym_ptr] = ACTIONS(595),
    [aux_sym_type_keyword_token1] = ACTIONS(595),
    [anon_sym_LBRACE] = ACTIONS(595),
    [anon_sym_RBRACE] = ACTIONS(595),
    [anon_sym_LT_LBRACE] = ACTIONS(595),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_RBRACK] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(597),
    [anon_sym_COMMA] = ACTIONS(595),
    [anon_sym_align] = ACTIONS(597),
    [anon_sym_section] = ACTIONS(595),
    [anon_sym_partition] = ACTIONS(595),
    [anon_sym_comdat] = ACTIONS(595),
    [anon_sym_gc] = ACTIONS(595),
    [anon_sym_prefix] = ACTIONS(595),
    [anon_sym_prologue] = ACTIONS(595),
    [anon_sym_personality] = ACTIONS(595),
    [anon_sym_alignstack] = ACTIONS(595),
    [anon_sym_allocsize] = ACTIONS(595),
    [anon_sym_alwaysinline] = ACTIONS(595),
    [anon_sym_builtin] = ACTIONS(595),
    [anon_sym_cold] = ACTIONS(595),
    [anon_sym_convergent] = ACTIONS(595),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(595),
    [anon_sym_hot] = ACTIONS(595),
    [anon_sym_inaccessiblememonly] = ACTIONS(595),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(595),
    [anon_sym_inlinehint] = ACTIONS(595),
    [anon_sym_jumptable] = ACTIONS(595),
    [anon_sym_minsize] = ACTIONS(595),
    [anon_sym_naked] = ACTIONS(595),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(595),
    [anon_sym_nobuiltin] = ACTIONS(595),
    [anon_sym_noduplicate] = ACTIONS(595),
    [anon_sym_nofree] = ACTIONS(595),
    [anon_sym_noimplicitfloat] = ACTIONS(595),
    [anon_sym_noinline] = ACTIONS(595),
    [anon_sym_nomerge] = ACTIONS(595),
    [anon_sym_nonlazybind] = ACTIONS(595),
    [anon_sym_noprofile] = ACTIONS(595),
    [anon_sym_noredzone] = ACTIONS(595),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(595),
    [anon_sym_noreturn] = ACTIONS(595),
    [anon_sym_norecurse] = ACTIONS(595),
    [anon_sym_willreturn] = ACTIONS(595),
    [anon_sym_nosync] = ACTIONS(595),
    [anon_sym_nounwind] = ACTIONS(595),
    [anon_sym_nocallback] = ACTIONS(595),
    [anon_sym_nosanitize_coverage] = ACTIONS(595),
    [anon_sym_null_pointer_is_valid] = ACTIONS(595),
    [anon_sym_optforfuzzing] = ACTIONS(595),
    [anon_sym_optnone] = ACTIONS(595),
    [anon_sym_optsize] = ACTIONS(595),
    [anon_sym_readnone] = ACTIONS(595),
    [anon_sym_readonly] = ACTIONS(595),
    [anon_sym_writeonly] = ACTIONS(595),
    [anon_sym_argmemonly] = ACTIONS(595),
    [anon_sym_returns_twice] = ACTIONS(595),
    [anon_sym_safestack] = ACTIONS(595),
    [anon_sym_sanitize_address] = ACTIONS(595),
    [anon_sym_sanitize_memory] = ACTIONS(595),
    [anon_sym_sanitize_thread] = ACTIONS(595),
    [anon_sym_sanitize_hwaddress] = ACTIONS(595),
    [anon_sym_sanitize_memtag] = ACTIONS(595),
    [anon_sym_speculative_load_hardening] = ACTIONS(595),
    [anon_sym_speculatable] = ACTIONS(595),
    [anon_sym_ssp] = ACTIONS(597),
    [anon_sym_sspstrong] = ACTIONS(595),
    [anon_sym_sspreq] = ACTIONS(595),
    [anon_sym_strictfp] = ACTIONS(595),
    [anon_sym_nocf_check] = ACTIONS(595),
    [anon_sym_shadowcallstack] = ACTIONS(595),
    [anon_sym_mustprogress] = ACTIONS(595),
    [anon_sym_vscale_range] = ACTIONS(595),
    [anon_sym_preallocated] = ACTIONS(595),
    [anon_sym_zeroext] = ACTIONS(595),
    [anon_sym_signext] = ACTIONS(595),
    [anon_sym_inreg] = ACTIONS(595),
    [anon_sym_byval] = ACTIONS(595),
    [anon_sym_byref] = ACTIONS(595),
    [anon_sym_inalloca] = ACTIONS(595),
    [anon_sym_sret] = ACTIONS(595),
    [anon_sym_elementtype] = ACTIONS(595),
    [anon_sym_noalias] = ACTIONS(595),
    [anon_sym_nocapture] = ACTIONS(595),
    [anon_sym_nest] = ACTIONS(595),
    [anon_sym_returned] = ACTIONS(595),
    [anon_sym_nonnull] = ACTIONS(595),
    [anon_sym_dereferenceable] = ACTIONS(597),
    [anon_sym_dereferenceable_or_null] = ACTIONS(595),
    [anon_sym_swiftself] = ACTIONS(595),
    [anon_sym_swiftasync] = ACTIONS(595),
    [anon_sym_swifterror] = ACTIONS(595),
    [anon_sym_immarg] = ACTIONS(595),
    [anon_sym_noundef] = ACTIONS(595),
    [anon_sym_uwtable] = ACTIONS(595),
    [anon_sym_memory] = ACTIONS(595),
    [anon_sym_to] = ACTIONS(597),
    [anon_sym_uselistorder] = ACTIONS(597),
    [anon_sym_uselistorder_bb] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_attributes] = ACTIONS(595),
  },
  [354] = {
    [ts_builtin_sym_end] = ACTIONS(537),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(537),
    [sym_comdat_ref] = ACTIONS(537),
    [sym_global_var] = ACTIONS(537),
    [sym_local_var] = ACTIONS(537),
    [aux_sym_metadata_ref_token1] = ACTIONS(537),
    [sym_summary_ref] = ACTIONS(537),
    [sym_string] = ACTIONS(537),
    [anon_sym_target] = ACTIONS(537),
    [anon_sym_source_filename] = ACTIONS(537),
    [anon_sym_declare] = ACTIONS(537),
    [anon_sym_define] = ACTIONS(537),
    [anon_sym_void] = ACTIONS(537),
    [anon_sym_half] = ACTIONS(537),
    [anon_sym_bfloat] = ACTIONS(537),
    [anon_sym_float] = ACTIONS(537),
    [anon_sym_double] = ACTIONS(537),
    [anon_sym_x86_fp80] = ACTIONS(537),
    [anon_sym_fp128] = ACTIONS(537),
    [anon_sym_ppc_fp128] = ACTIONS(537),
    [anon_sym_label] = ACTIONS(537),
    [anon_sym_metadata] = ACTIONS(537),
    [anon_sym_x86_mmx] = ACTIONS(537),
    [anon_sym_x86_amx] = ACTIONS(537),
    [anon_sym_token] = ACTIONS(537),
    [anon_sym_opaque] = ACTIONS(537),
    [anon_sym_ptr] = ACTIONS(537),
    [aux_sym_type_keyword_token1] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_LT_LBRACE] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(537),
    [anon_sym_RBRACK] = ACTIONS(537),
    [anon_sym_LT] = ACTIONS(539),
    [anon_sym_COMMA] = ACTIONS(537),
    [anon_sym_align] = ACTIONS(539),
    [anon_sym_section] = ACTIONS(537),
    [anon_sym_partition] = ACTIONS(537),
    [anon_sym_comdat] = ACTIONS(537),
    [anon_sym_gc] = ACTIONS(537),
    [anon_sym_prefix] = ACTIONS(537),
    [anon_sym_prologue] = ACTIONS(537),
    [anon_sym_personality] = ACTIONS(537),
    [anon_sym_alignstack] = ACTIONS(537),
    [anon_sym_allocsize] = ACTIONS(537),
    [anon_sym_alwaysinline] = ACTIONS(537),
    [anon_sym_builtin] = ACTIONS(537),
    [anon_sym_cold] = ACTIONS(537),
    [anon_sym_convergent] = ACTIONS(537),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(537),
    [anon_sym_hot] = ACTIONS(537),
    [anon_sym_inaccessiblememonly] = ACTIONS(537),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(537),
    [anon_sym_inlinehint] = ACTIONS(537),
    [anon_sym_jumptable] = ACTIONS(537),
    [anon_sym_minsize] = ACTIONS(537),
    [anon_sym_naked] = ACTIONS(537),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(537),
    [anon_sym_nobuiltin] = ACTIONS(537),
    [anon_sym_noduplicate] = ACTIONS(537),
    [anon_sym_nofree] = ACTIONS(537),
    [anon_sym_noimplicitfloat] = ACTIONS(537),
    [anon_sym_noinline] = ACTIONS(537),
    [anon_sym_nomerge] = ACTIONS(537),
    [anon_sym_nonlazybind] = ACTIONS(537),
    [anon_sym_noprofile] = ACTIONS(537),
    [anon_sym_noredzone] = ACTIONS(537),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(537),
    [anon_sym_noreturn] = ACTIONS(537),
    [anon_sym_norecurse] = ACTIONS(537),
    [anon_sym_willreturn] = ACTIONS(537),
    [anon_sym_nosync] = ACTIONS(537),
    [anon_sym_nounwind] = ACTIONS(537),
    [anon_sym_nocallback] = ACTIONS(537),
    [anon_sym_nosanitize_coverage] = ACTIONS(537),
    [anon_sym_null_pointer_is_valid] = ACTIONS(537),
    [anon_sym_optforfuzzing] = ACTIONS(537),
    [anon_sym_optnone] = ACTIONS(537),
    [anon_sym_optsize] = ACTIONS(537),
    [anon_sym_readnone] = ACTIONS(537),
    [anon_sym_readonly] = ACTIONS(537),
    [anon_sym_writeonly] = ACTIONS(537),
    [anon_sym_argmemonly] = ACTIONS(537),
    [anon_sym_returns_twice] = ACTIONS(537),
    [anon_sym_safestack] = ACTIONS(537),
    [anon_sym_sanitize_address] = ACTIONS(537),
    [anon_sym_sanitize_memory] = ACTIONS(537),
    [anon_sym_sanitize_thread] = ACTIONS(537),
    [anon_sym_sanitize_hwaddress] = ACTIONS(537),
    [anon_sym_sanitize_memtag] = ACTIONS(537),
    [anon_sym_speculative_load_hardening] = ACTIONS(537),
    [anon_sym_speculatable] = ACTIONS(537),
    [anon_sym_ssp] = ACTIONS(539),
    [anon_sym_sspstrong] = ACTIONS(537),
    [anon_sym_sspreq] = ACTIONS(537),
    [anon_sym_strictfp] = ACTIONS(537),
    [anon_sym_nocf_check] = ACTIONS(537),
    [anon_sym_shadowcallstack] = ACTIONS(537),
    [anon_sym_mustprogress] = ACTIONS(537),
    [anon_sym_vscale_range] = ACTIONS(537),
    [anon_sym_preallocated] = ACTIONS(537),
    [anon_sym_zeroext] = ACTIONS(537),
    [anon_sym_signext] = ACTIONS(537),
    [anon_sym_inreg] = ACTIONS(537),
    [anon_sym_byval] = ACTIONS(537),
    [anon_sym_byref] = ACTIONS(537),
    [anon_sym_inalloca] = ACTIONS(537),
    [anon_sym_sret] = ACTIONS(537),
    [anon_sym_elementtype] = ACTIONS(537),
    [anon_sym_noalias] = ACTIONS(537),
    [anon_sym_nocapture] = ACTIONS(537),
    [anon_sym_nest] = ACTIONS(537),
    [anon_sym_returned] = ACTIONS(537),
    [anon_sym_nonnull] = ACTIONS(537),
    [anon_sym_dereferenceable] = ACTIONS(539),
    [anon_sym_dereferenceable_or_null] = ACTIONS(537),
    [anon_sym_swiftself] = ACTIONS(537),
    [anon_sym_swiftasync] = ACTIONS(537),
    [anon_sym_swifterror] = ACTIONS(537),
    [anon_sym_immarg] = ACTIONS(537),
    [anon_sym_noundef] = ACTIONS(537),
    [anon_sym_uwtable] = ACTIONS(537),
    [anon_sym_memory] = ACTIONS(537),
    [anon_sym_to] = ACTIONS(539),
    [anon_sym_uselistorder] = ACTIONS(539),
    [anon_sym_uselistorder_bb] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_attributes] = ACTIONS(537),
  },
  [355] = {
    [ts_builtin_sym_end] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(533),
    [sym_comdat_ref] = ACTIONS(533),
    [sym_global_var] = ACTIONS(533),
    [sym_local_var] = ACTIONS(533),
    [aux_sym_metadata_ref_token1] = ACTIONS(533),
    [sym_summary_ref] = ACTIONS(533),
    [sym_string] = ACTIONS(533),
    [anon_sym_target] = ACTIONS(533),
    [anon_sym_source_filename] = ACTIONS(533),
    [anon_sym_declare] = ACTIONS(533),
    [anon_sym_define] = ACTIONS(533),
    [anon_sym_void] = ACTIONS(533),
    [anon_sym_half] = ACTIONS(533),
    [anon_sym_bfloat] = ACTIONS(533),
    [anon_sym_float] = ACTIONS(533),
    [anon_sym_double] = ACTIONS(533),
    [anon_sym_x86_fp80] = ACTIONS(533),
    [anon_sym_fp128] = ACTIONS(533),
    [anon_sym_ppc_fp128] = ACTIONS(533),
    [anon_sym_label] = ACTIONS(533),
    [anon_sym_metadata] = ACTIONS(533),
    [anon_sym_x86_mmx] = ACTIONS(533),
    [anon_sym_x86_amx] = ACTIONS(533),
    [anon_sym_token] = ACTIONS(533),
    [anon_sym_opaque] = ACTIONS(533),
    [anon_sym_ptr] = ACTIONS(533),
    [aux_sym_type_keyword_token1] = ACTIONS(533),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_RBRACE] = ACTIONS(533),
    [anon_sym_LT_LBRACE] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(533),
    [anon_sym_RBRACK] = ACTIONS(533),
    [anon_sym_LT] = ACTIONS(535),
    [anon_sym_COMMA] = ACTIONS(533),
    [anon_sym_align] = ACTIONS(535),
    [anon_sym_section] = ACTIONS(533),
    [anon_sym_partition] = ACTIONS(533),
    [anon_sym_comdat] = ACTIONS(533),
    [anon_sym_gc] = ACTIONS(533),
    [anon_sym_prefix] = ACTIONS(533),
    [anon_sym_prologue] = ACTIONS(533),
    [anon_sym_personality] = ACTIONS(533),
    [anon_sym_alignstack] = ACTIONS(533),
    [anon_sym_allocsize] = ACTIONS(533),
    [anon_sym_alwaysinline] = ACTIONS(533),
    [anon_sym_builtin] = ACTIONS(533),
    [anon_sym_cold] = ACTIONS(533),
    [anon_sym_convergent] = ACTIONS(533),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(533),
    [anon_sym_hot] = ACTIONS(533),
    [anon_sym_inaccessiblememonly] = ACTIONS(533),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(533),
    [anon_sym_inlinehint] = ACTIONS(533),
    [anon_sym_jumptable] = ACTIONS(533),
    [anon_sym_minsize] = ACTIONS(533),
    [anon_sym_naked] = ACTIONS(533),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(533),
    [anon_sym_nobuiltin] = ACTIONS(533),
    [anon_sym_noduplicate] = ACTIONS(533),
    [anon_sym_nofree] = ACTIONS(533),
    [anon_sym_noimplicitfloat] = ACTIONS(533),
    [anon_sym_noinline] = ACTIONS(533),
    [anon_sym_nomerge] = ACTIONS(533),
    [anon_sym_nonlazybind] = ACTIONS(533),
    [anon_sym_noprofile] = ACTIONS(533),
    [anon_sym_noredzone] = ACTIONS(533),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(533),
    [anon_sym_noreturn] = ACTIONS(533),
    [anon_sym_norecurse] = ACTIONS(533),
    [anon_sym_willreturn] = ACTIONS(533),
    [anon_sym_nosync] = ACTIONS(533),
    [anon_sym_nounwind] = ACTIONS(533),
    [anon_sym_nocallback] = ACTIONS(533),
    [anon_sym_nosanitize_coverage] = ACTIONS(533),
    [anon_sym_null_pointer_is_valid] = ACTIONS(533),
    [anon_sym_optforfuzzing] = ACTIONS(533),
    [anon_sym_optnone] = ACTIONS(533),
    [anon_sym_optsize] = ACTIONS(533),
    [anon_sym_readnone] = ACTIONS(533),
    [anon_sym_readonly] = ACTIONS(533),
    [anon_sym_writeonly] = ACTIONS(533),
    [anon_sym_argmemonly] = ACTIONS(533),
    [anon_sym_returns_twice] = ACTIONS(533),
    [anon_sym_safestack] = ACTIONS(533),
    [anon_sym_sanitize_address] = ACTIONS(533),
    [anon_sym_sanitize_memory] = ACTIONS(533),
    [anon_sym_sanitize_thread] = ACTIONS(533),
    [anon_sym_sanitize_hwaddress] = ACTIONS(533),
    [anon_sym_sanitize_memtag] = ACTIONS(533),
    [anon_sym_speculative_load_hardening] = ACTIONS(533),
    [anon_sym_speculatable] = ACTIONS(533),
    [anon_sym_ssp] = ACTIONS(535),
    [anon_sym_sspstrong] = ACTIONS(533),
    [anon_sym_sspreq] = ACTIONS(533),
    [anon_sym_strictfp] = ACTIONS(533),
    [anon_sym_nocf_check] = ACTIONS(533),
    [anon_sym_shadowcallstack] = ACTIONS(533),
    [anon_sym_mustprogress] = ACTIONS(533),
    [anon_sym_vscale_range] = ACTIONS(533),
    [anon_sym_preallocated] = ACTIONS(533),
    [anon_sym_zeroext] = ACTIONS(533),
    [anon_sym_signext] = ACTIONS(533),
    [anon_sym_inreg] = ACTIONS(533),
    [anon_sym_byval] = ACTIONS(533),
    [anon_sym_byref] = ACTIONS(533),
    [anon_sym_inalloca] = ACTIONS(533),
    [anon_sym_sret] = ACTIONS(533),
    [anon_sym_elementtype] = ACTIONS(533),
    [anon_sym_noalias] = ACTIONS(533),
    [anon_sym_nocapture] = ACTIONS(533),
    [anon_sym_nest] = ACTIONS(533),
    [anon_sym_returned] = ACTIONS(533),
    [anon_sym_nonnull] = ACTIONS(533),
    [anon_sym_dereferenceable] = ACTIONS(535),
    [anon_sym_dereferenceable_or_null] = ACTIONS(533),
    [anon_sym_swiftself] = ACTIONS(533),
    [anon_sym_swiftasync] = ACTIONS(533),
    [anon_sym_swifterror] = ACTIONS(533),
    [anon_sym_immarg] = ACTIONS(533),
    [anon_sym_noundef] = ACTIONS(533),
    [anon_sym_uwtable] = ACTIONS(533),
    [anon_sym_memory] = ACTIONS(533),
    [anon_sym_to] = ACTIONS(535),
    [anon_sym_uselistorder] = ACTIONS(535),
    [anon_sym_uselistorder_bb] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_attributes] = ACTIONS(533),
  },
  [356] = {
    [ts_builtin_sym_end] = ACTIONS(603),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(603),
    [sym_comdat_ref] = ACTIONS(603),
    [sym_global_var] = ACTIONS(603),
    [sym_local_var] = ACTIONS(603),
    [aux_sym_metadata_ref_token1] = ACTIONS(603),
    [sym_summary_ref] = ACTIONS(603),
    [sym_string] = ACTIONS(603),
    [anon_sym_target] = ACTIONS(603),
    [anon_sym_source_filename] = ACTIONS(603),
    [anon_sym_declare] = ACTIONS(603),
    [anon_sym_define] = ACTIONS(603),
    [anon_sym_void] = ACTIONS(603),
    [anon_sym_half] = ACTIONS(603),
    [anon_sym_bfloat] = ACTIONS(603),
    [anon_sym_float] = ACTIONS(603),
    [anon_sym_double] = ACTIONS(603),
    [anon_sym_x86_fp80] = ACTIONS(603),
    [anon_sym_fp128] = ACTIONS(603),
    [anon_sym_ppc_fp128] = ACTIONS(603),
    [anon_sym_label] = ACTIONS(603),
    [anon_sym_metadata] = ACTIONS(603),
    [anon_sym_x86_mmx] = ACTIONS(603),
    [anon_sym_x86_amx] = ACTIONS(603),
    [anon_sym_token] = ACTIONS(603),
    [anon_sym_opaque] = ACTIONS(603),
    [anon_sym_ptr] = ACTIONS(603),
    [aux_sym_type_keyword_token1] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(603),
    [anon_sym_RBRACE] = ACTIONS(603),
    [anon_sym_LT_LBRACE] = ACTIONS(603),
    [anon_sym_LBRACK] = ACTIONS(603),
    [anon_sym_RBRACK] = ACTIONS(603),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_COMMA] = ACTIONS(603),
    [anon_sym_align] = ACTIONS(605),
    [anon_sym_section] = ACTIONS(603),
    [anon_sym_partition] = ACTIONS(603),
    [anon_sym_comdat] = ACTIONS(603),
    [anon_sym_gc] = ACTIONS(603),
    [anon_sym_prefix] = ACTIONS(603),
    [anon_sym_prologue] = ACTIONS(603),
    [anon_sym_personality] = ACTIONS(603),
    [anon_sym_alignstack] = ACTIONS(603),
    [anon_sym_allocsize] = ACTIONS(603),
    [anon_sym_alwaysinline] = ACTIONS(603),
    [anon_sym_builtin] = ACTIONS(603),
    [anon_sym_cold] = ACTIONS(603),
    [anon_sym_convergent] = ACTIONS(603),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(603),
    [anon_sym_hot] = ACTIONS(603),
    [anon_sym_inaccessiblememonly] = ACTIONS(603),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(603),
    [anon_sym_inlinehint] = ACTIONS(603),
    [anon_sym_jumptable] = ACTIONS(603),
    [anon_sym_minsize] = ACTIONS(603),
    [anon_sym_naked] = ACTIONS(603),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(603),
    [anon_sym_nobuiltin] = ACTIONS(603),
    [anon_sym_noduplicate] = ACTIONS(603),
    [anon_sym_nofree] = ACTIONS(603),
    [anon_sym_noimplicitfloat] = ACTIONS(603),
    [anon_sym_noinline] = ACTIONS(603),
    [anon_sym_nomerge] = ACTIONS(603),
    [anon_sym_nonlazybind] = ACTIONS(603),
    [anon_sym_noprofile] = ACTIONS(603),
    [anon_sym_noredzone] = ACTIONS(603),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(603),
    [anon_sym_noreturn] = ACTIONS(603),
    [anon_sym_norecurse] = ACTIONS(603),
    [anon_sym_willreturn] = ACTIONS(603),
    [anon_sym_nosync] = ACTIONS(603),
    [anon_sym_nounwind] = ACTIONS(603),
    [anon_sym_nocallback] = ACTIONS(603),
    [anon_sym_nosanitize_coverage] = ACTIONS(603),
    [anon_sym_null_pointer_is_valid] = ACTIONS(603),
    [anon_sym_optforfuzzing] = ACTIONS(603),
    [anon_sym_optnone] = ACTIONS(603),
    [anon_sym_optsize] = ACTIONS(603),
    [anon_sym_readnone] = ACTIONS(603),
    [anon_sym_readonly] = ACTIONS(603),
    [anon_sym_writeonly] = ACTIONS(603),
    [anon_sym_argmemonly] = ACTIONS(603),
    [anon_sym_returns_twice] = ACTIONS(603),
    [anon_sym_safestack] = ACTIONS(603),
    [anon_sym_sanitize_address] = ACTIONS(603),
    [anon_sym_sanitize_memory] = ACTIONS(603),
    [anon_sym_sanitize_thread] = ACTIONS(603),
    [anon_sym_sanitize_hwaddress] = ACTIONS(603),
    [anon_sym_sanitize_memtag] = ACTIONS(603),
    [anon_sym_speculative_load_hardening] = ACTIONS(603),
    [anon_sym_speculatable] = ACTIONS(603),
    [anon_sym_ssp] = ACTIONS(605),
    [anon_sym_sspstrong] = ACTIONS(603),
    [anon_sym_sspreq] = ACTIONS(603),
    [anon_sym_strictfp] = ACTIONS(603),
    [anon_sym_nocf_check] = ACTIONS(603),
    [anon_sym_shadowcallstack] = ACTIONS(603),
    [anon_sym_mustprogress] = ACTIONS(603),
    [anon_sym_vscale_range] = ACTIONS(603),
    [anon_sym_preallocated] = ACTIONS(603),
    [anon_sym_zeroext] = ACTIONS(603),
    [anon_sym_signext] = ACTIONS(603),
    [anon_sym_inreg] = ACTIONS(603),
    [anon_sym_byval] = ACTIONS(603),
    [anon_sym_byref] = ACTIONS(603),
    [anon_sym_inalloca] = ACTIONS(603),
    [anon_sym_sret] = ACTIONS(603),
    [anon_sym_elementtype] = ACTIONS(603),
    [anon_sym_noalias] = ACTIONS(603),
    [anon_sym_nocapture] = ACTIONS(603),
    [anon_sym_nest] = ACTIONS(603),
    [anon_sym_returned] = ACTIONS(603),
    [anon_sym_nonnull] = ACTIONS(603),
    [anon_sym_dereferenceable] = ACTIONS(605),
    [anon_sym_dereferenceable_or_null] = ACTIONS(603),
    [anon_sym_swiftself] = ACTIONS(603),
    [anon_sym_swiftasync] = ACTIONS(603),
    [anon_sym_swifterror] = ACTIONS(603),
    [anon_sym_immarg] = ACTIONS(603),
    [anon_sym_noundef] = ACTIONS(603),
    [anon_sym_uwtable] = ACTIONS(603),
    [anon_sym_memory] = ACTIONS(603),
    [anon_sym_to] = ACTIONS(605),
    [anon_sym_uselistorder] = ACTIONS(605),
    [anon_sym_uselistorder_bb] = ACTIONS(603),
    [anon_sym_module] = ACTIONS(603),
    [anon_sym_attributes] = ACTIONS(603),
  },
  [357] = {
    [ts_builtin_sym_end] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(635),
    [sym_comdat_ref] = ACTIONS(635),
    [sym_global_var] = ACTIONS(635),
    [sym_local_var] = ACTIONS(635),
    [aux_sym_metadata_ref_token1] = ACTIONS(635),
    [sym_summary_ref] = ACTIONS(635),
    [sym_string] = ACTIONS(635),
    [anon_sym_target] = ACTIONS(635),
    [anon_sym_source_filename] = ACTIONS(635),
    [anon_sym_declare] = ACTIONS(635),
    [anon_sym_define] = ACTIONS(635),
    [anon_sym_void] = ACTIONS(635),
    [anon_sym_half] = ACTIONS(635),
    [anon_sym_bfloat] = ACTIONS(635),
    [anon_sym_float] = ACTIONS(635),
    [anon_sym_double] = ACTIONS(635),
    [anon_sym_x86_fp80] = ACTIONS(635),
    [anon_sym_fp128] = ACTIONS(635),
    [anon_sym_ppc_fp128] = ACTIONS(635),
    [anon_sym_label] = ACTIONS(635),
    [anon_sym_metadata] = ACTIONS(635),
    [anon_sym_x86_mmx] = ACTIONS(635),
    [anon_sym_x86_amx] = ACTIONS(635),
    [anon_sym_token] = ACTIONS(635),
    [anon_sym_opaque] = ACTIONS(635),
    [anon_sym_ptr] = ACTIONS(635),
    [aux_sym_type_keyword_token1] = ACTIONS(635),
    [anon_sym_LBRACE] = ACTIONS(635),
    [anon_sym_RBRACE] = ACTIONS(635),
    [anon_sym_LT_LBRACE] = ACTIONS(635),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(637),
    [anon_sym_COMMA] = ACTIONS(635),
    [anon_sym_align] = ACTIONS(637),
    [anon_sym_section] = ACTIONS(635),
    [anon_sym_partition] = ACTIONS(635),
    [anon_sym_comdat] = ACTIONS(635),
    [anon_sym_gc] = ACTIONS(635),
    [anon_sym_prefix] = ACTIONS(635),
    [anon_sym_prologue] = ACTIONS(635),
    [anon_sym_personality] = ACTIONS(635),
    [anon_sym_alignstack] = ACTIONS(635),
    [anon_sym_allocsize] = ACTIONS(635),
    [anon_sym_alwaysinline] = ACTIONS(635),
    [anon_sym_builtin] = ACTIONS(635),
    [anon_sym_cold] = ACTIONS(635),
    [anon_sym_convergent] = ACTIONS(635),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(635),
    [anon_sym_hot] = ACTIONS(635),
    [anon_sym_inaccessiblememonly] = ACTIONS(635),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(635),
    [anon_sym_inlinehint] = ACTIONS(635),
    [anon_sym_jumptable] = ACTIONS(635),
    [anon_sym_minsize] = ACTIONS(635),
    [anon_sym_naked] = ACTIONS(635),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(635),
    [anon_sym_nobuiltin] = ACTIONS(635),
    [anon_sym_noduplicate] = ACTIONS(635),
    [anon_sym_nofree] = ACTIONS(635),
    [anon_sym_noimplicitfloat] = ACTIONS(635),
    [anon_sym_noinline] = ACTIONS(635),
    [anon_sym_nomerge] = ACTIONS(635),
    [anon_sym_nonlazybind] = ACTIONS(635),
    [anon_sym_noprofile] = ACTIONS(635),
    [anon_sym_noredzone] = ACTIONS(635),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(635),
    [anon_sym_noreturn] = ACTIONS(635),
    [anon_sym_norecurse] = ACTIONS(635),
    [anon_sym_willreturn] = ACTIONS(635),
    [anon_sym_nosync] = ACTIONS(635),
    [anon_sym_nounwind] = ACTIONS(635),
    [anon_sym_nocallback] = ACTIONS(635),
    [anon_sym_nosanitize_coverage] = ACTIONS(635),
    [anon_sym_null_pointer_is_valid] = ACTIONS(635),
    [anon_sym_optforfuzzing] = ACTIONS(635),
    [anon_sym_optnone] = ACTIONS(635),
    [anon_sym_optsize] = ACTIONS(635),
    [anon_sym_readnone] = ACTIONS(635),
    [anon_sym_readonly] = ACTIONS(635),
    [anon_sym_writeonly] = ACTIONS(635),
    [anon_sym_argmemonly] = ACTIONS(635),
    [anon_sym_returns_twice] = ACTIONS(635),
    [anon_sym_safestack] = ACTIONS(635),
    [anon_sym_sanitize_address] = ACTIONS(635),
    [anon_sym_sanitize_memory] = ACTIONS(635),
    [anon_sym_sanitize_thread] = ACTIONS(635),
    [anon_sym_sanitize_hwaddress] = ACTIONS(635),
    [anon_sym_sanitize_memtag] = ACTIONS(635),
    [anon_sym_speculative_load_hardening] = ACTIONS(635),
    [anon_sym_speculatable] = ACTIONS(635),
    [anon_sym_ssp] = ACTIONS(637),
    [anon_sym_sspstrong] = ACTIONS(635),
    [anon_sym_sspreq] = ACTIONS(635),
    [anon_sym_strictfp] = ACTIONS(635),
    [anon_sym_nocf_check] = ACTIONS(635),
    [anon_sym_shadowcallstack] = ACTIONS(635),
    [anon_sym_mustprogress] = ACTIONS(635),
    [anon_sym_vscale_range] = ACTIONS(635),
    [anon_sym_preallocated] = ACTIONS(635),
    [anon_sym_zeroext] = ACTIONS(635),
    [anon_sym_signext] = ACTIONS(635),
    [anon_sym_inreg] = ACTIONS(635),
    [anon_sym_byval] = ACTIONS(635),
    [anon_sym_byref] = ACTIONS(635),
    [anon_sym_inalloca] = ACTIONS(635),
    [anon_sym_sret] = ACTIONS(635),
    [anon_sym_elementtype] = ACTIONS(635),
    [anon_sym_noalias] = ACTIONS(635),
    [anon_sym_nocapture] = ACTIONS(635),
    [anon_sym_nest] = ACTIONS(635),
    [anon_sym_returned] = ACTIONS(635),
    [anon_sym_nonnull] = ACTIONS(635),
    [anon_sym_dereferenceable] = ACTIONS(637),
    [anon_sym_dereferenceable_or_null] = ACTIONS(635),
    [anon_sym_swiftself] = ACTIONS(635),
    [anon_sym_swiftasync] = ACTIONS(635),
    [anon_sym_swifterror] = ACTIONS(635),
    [anon_sym_immarg] = ACTIONS(635),
    [anon_sym_noundef] = ACTIONS(635),
    [anon_sym_uwtable] = ACTIONS(635),
    [anon_sym_memory] = ACTIONS(635),
    [anon_sym_to] = ACTIONS(637),
    [anon_sym_uselistorder] = ACTIONS(637),
    [anon_sym_uselistorder_bb] = ACTIONS(635),
    [anon_sym_module] = ACTIONS(635),
    [anon_sym_attributes] = ACTIONS(635),
  },
  [358] = {
    [ts_builtin_sym_end] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(697),
    [sym_comdat_ref] = ACTIONS(697),
    [sym_global_var] = ACTIONS(697),
    [sym_local_var] = ACTIONS(697),
    [aux_sym_metadata_ref_token1] = ACTIONS(697),
    [sym_summary_ref] = ACTIONS(697),
    [sym_string] = ACTIONS(697),
    [anon_sym_target] = ACTIONS(697),
    [anon_sym_source_filename] = ACTIONS(697),
    [anon_sym_declare] = ACTIONS(697),
    [anon_sym_define] = ACTIONS(697),
    [anon_sym_void] = ACTIONS(697),
    [anon_sym_half] = ACTIONS(697),
    [anon_sym_bfloat] = ACTIONS(697),
    [anon_sym_float] = ACTIONS(697),
    [anon_sym_double] = ACTIONS(697),
    [anon_sym_x86_fp80] = ACTIONS(697),
    [anon_sym_fp128] = ACTIONS(697),
    [anon_sym_ppc_fp128] = ACTIONS(697),
    [anon_sym_label] = ACTIONS(697),
    [anon_sym_metadata] = ACTIONS(697),
    [anon_sym_x86_mmx] = ACTIONS(697),
    [anon_sym_x86_amx] = ACTIONS(697),
    [anon_sym_token] = ACTIONS(697),
    [anon_sym_opaque] = ACTIONS(697),
    [anon_sym_ptr] = ACTIONS(697),
    [aux_sym_type_keyword_token1] = ACTIONS(697),
    [anon_sym_LBRACE] = ACTIONS(697),
    [anon_sym_RBRACE] = ACTIONS(697),
    [anon_sym_LT_LBRACE] = ACTIONS(697),
    [anon_sym_LBRACK] = ACTIONS(697),
    [anon_sym_RBRACK] = ACTIONS(697),
    [anon_sym_LT] = ACTIONS(699),
    [anon_sym_COMMA] = ACTIONS(697),
    [anon_sym_align] = ACTIONS(699),
    [anon_sym_section] = ACTIONS(697),
    [anon_sym_partition] = ACTIONS(697),
    [anon_sym_comdat] = ACTIONS(697),
    [anon_sym_gc] = ACTIONS(697),
    [anon_sym_prefix] = ACTIONS(697),
    [anon_sym_prologue] = ACTIONS(697),
    [anon_sym_personality] = ACTIONS(697),
    [anon_sym_alignstack] = ACTIONS(697),
    [anon_sym_allocsize] = ACTIONS(697),
    [anon_sym_alwaysinline] = ACTIONS(697),
    [anon_sym_builtin] = ACTIONS(697),
    [anon_sym_cold] = ACTIONS(697),
    [anon_sym_convergent] = ACTIONS(697),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(697),
    [anon_sym_hot] = ACTIONS(697),
    [anon_sym_inaccessiblememonly] = ACTIONS(697),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(697),
    [anon_sym_inlinehint] = ACTIONS(697),
    [anon_sym_jumptable] = ACTIONS(697),
    [anon_sym_minsize] = ACTIONS(697),
    [anon_sym_naked] = ACTIONS(697),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(697),
    [anon_sym_nobuiltin] = ACTIONS(697),
    [anon_sym_noduplicate] = ACTIONS(697),
    [anon_sym_nofree] = ACTIONS(697),
    [anon_sym_noimplicitfloat] = ACTIONS(697),
    [anon_sym_noinline] = ACTIONS(697),
    [anon_sym_nomerge] = ACTIONS(697),
    [anon_sym_nonlazybind] = ACTIONS(697),
    [anon_sym_noprofile] = ACTIONS(697),
    [anon_sym_noredzone] = ACTIONS(697),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(697),
    [anon_sym_noreturn] = ACTIONS(697),
    [anon_sym_norecurse] = ACTIONS(697),
    [anon_sym_willreturn] = ACTIONS(697),
    [anon_sym_nosync] = ACTIONS(697),
    [anon_sym_nounwind] = ACTIONS(697),
    [anon_sym_nocallback] = ACTIONS(697),
    [anon_sym_nosanitize_coverage] = ACTIONS(697),
    [anon_sym_null_pointer_is_valid] = ACTIONS(697),
    [anon_sym_optforfuzzing] = ACTIONS(697),
    [anon_sym_optnone] = ACTIONS(697),
    [anon_sym_optsize] = ACTIONS(697),
    [anon_sym_readnone] = ACTIONS(697),
    [anon_sym_readonly] = ACTIONS(697),
    [anon_sym_writeonly] = ACTIONS(697),
    [anon_sym_argmemonly] = ACTIONS(697),
    [anon_sym_returns_twice] = ACTIONS(697),
    [anon_sym_safestack] = ACTIONS(697),
    [anon_sym_sanitize_address] = ACTIONS(697),
    [anon_sym_sanitize_memory] = ACTIONS(697),
    [anon_sym_sanitize_thread] = ACTIONS(697),
    [anon_sym_sanitize_hwaddress] = ACTIONS(697),
    [anon_sym_sanitize_memtag] = ACTIONS(697),
    [anon_sym_speculative_load_hardening] = ACTIONS(697),
    [anon_sym_speculatable] = ACTIONS(697),
    [anon_sym_ssp] = ACTIONS(699),
    [anon_sym_sspstrong] = ACTIONS(697),
    [anon_sym_sspreq] = ACTIONS(697),
    [anon_sym_strictfp] = ACTIONS(697),
    [anon_sym_nocf_check] = ACTIONS(697),
    [anon_sym_shadowcallstack] = ACTIONS(697),
    [anon_sym_mustprogress] = ACTIONS(697),
    [anon_sym_vscale_range] = ACTIONS(697),
    [anon_sym_preallocated] = ACTIONS(697),
    [anon_sym_zeroext] = ACTIONS(697),
    [anon_sym_signext] = ACTIONS(697),
    [anon_sym_inreg] = ACTIONS(697),
    [anon_sym_byval] = ACTIONS(697),
    [anon_sym_byref] = ACTIONS(697),
    [anon_sym_inalloca] = ACTIONS(697),
    [anon_sym_sret] = ACTIONS(697),
    [anon_sym_elementtype] = ACTIONS(697),
    [anon_sym_noalias] = ACTIONS(697),
    [anon_sym_nocapture] = ACTIONS(697),
    [anon_sym_nest] = ACTIONS(697),
    [anon_sym_returned] = ACTIONS(697),
    [anon_sym_nonnull] = ACTIONS(697),
    [anon_sym_dereferenceable] = ACTIONS(699),
    [anon_sym_dereferenceable_or_null] = ACTIONS(697),
    [anon_sym_swiftself] = ACTIONS(697),
    [anon_sym_swiftasync] = ACTIONS(697),
    [anon_sym_swifterror] = ACTIONS(697),
    [anon_sym_immarg] = ACTIONS(697),
    [anon_sym_noundef] = ACTIONS(697),
    [anon_sym_uwtable] = ACTIONS(697),
    [anon_sym_memory] = ACTIONS(697),
    [anon_sym_to] = ACTIONS(699),
    [anon_sym_uselistorder] = ACTIONS(699),
    [anon_sym_uselistorder_bb] = ACTIONS(697),
    [anon_sym_module] = ACTIONS(697),
    [anon_sym_attributes] = ACTIONS(697),
  },
  [359] = {
    [ts_builtin_sym_end] = ACTIONS(521),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(521),
    [sym_comdat_ref] = ACTIONS(521),
    [sym_global_var] = ACTIONS(521),
    [sym_local_var] = ACTIONS(521),
    [aux_sym_metadata_ref_token1] = ACTIONS(521),
    [sym_summary_ref] = ACTIONS(521),
    [sym_string] = ACTIONS(521),
    [anon_sym_target] = ACTIONS(521),
    [anon_sym_source_filename] = ACTIONS(521),
    [anon_sym_declare] = ACTIONS(521),
    [anon_sym_define] = ACTIONS(521),
    [anon_sym_void] = ACTIONS(521),
    [anon_sym_half] = ACTIONS(521),
    [anon_sym_bfloat] = ACTIONS(521),
    [anon_sym_float] = ACTIONS(521),
    [anon_sym_double] = ACTIONS(521),
    [anon_sym_x86_fp80] = ACTIONS(521),
    [anon_sym_fp128] = ACTIONS(521),
    [anon_sym_ppc_fp128] = ACTIONS(521),
    [anon_sym_label] = ACTIONS(521),
    [anon_sym_metadata] = ACTIONS(521),
    [anon_sym_x86_mmx] = ACTIONS(521),
    [anon_sym_x86_amx] = ACTIONS(521),
    [anon_sym_token] = ACTIONS(521),
    [anon_sym_opaque] = ACTIONS(521),
    [anon_sym_ptr] = ACTIONS(521),
    [aux_sym_type_keyword_token1] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_RBRACE] = ACTIONS(521),
    [anon_sym_LT_LBRACE] = ACTIONS(521),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_RBRACK] = ACTIONS(521),
    [anon_sym_LT] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(521),
    [anon_sym_align] = ACTIONS(523),
    [anon_sym_section] = ACTIONS(521),
    [anon_sym_partition] = ACTIONS(521),
    [anon_sym_comdat] = ACTIONS(521),
    [anon_sym_gc] = ACTIONS(521),
    [anon_sym_prefix] = ACTIONS(521),
    [anon_sym_prologue] = ACTIONS(521),
    [anon_sym_personality] = ACTIONS(521),
    [anon_sym_alignstack] = ACTIONS(521),
    [anon_sym_allocsize] = ACTIONS(521),
    [anon_sym_alwaysinline] = ACTIONS(521),
    [anon_sym_builtin] = ACTIONS(521),
    [anon_sym_cold] = ACTIONS(521),
    [anon_sym_convergent] = ACTIONS(521),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(521),
    [anon_sym_hot] = ACTIONS(521),
    [anon_sym_inaccessiblememonly] = ACTIONS(521),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(521),
    [anon_sym_inlinehint] = ACTIONS(521),
    [anon_sym_jumptable] = ACTIONS(521),
    [anon_sym_minsize] = ACTIONS(521),
    [anon_sym_naked] = ACTIONS(521),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(521),
    [anon_sym_nobuiltin] = ACTIONS(521),
    [anon_sym_noduplicate] = ACTIONS(521),
    [anon_sym_nofree] = ACTIONS(521),
    [anon_sym_noimplicitfloat] = ACTIONS(521),
    [anon_sym_noinline] = ACTIONS(521),
    [anon_sym_nomerge] = ACTIONS(521),
    [anon_sym_nonlazybind] = ACTIONS(521),
    [anon_sym_noprofile] = ACTIONS(521),
    [anon_sym_noredzone] = ACTIONS(521),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(521),
    [anon_sym_noreturn] = ACTIONS(521),
    [anon_sym_norecurse] = ACTIONS(521),
    [anon_sym_willreturn] = ACTIONS(521),
    [anon_sym_nosync] = ACTIONS(521),
    [anon_sym_nounwind] = ACTIONS(521),
    [anon_sym_nocallback] = ACTIONS(521),
    [anon_sym_nosanitize_coverage] = ACTIONS(521),
    [anon_sym_null_pointer_is_valid] = ACTIONS(521),
    [anon_sym_optforfuzzing] = ACTIONS(521),
    [anon_sym_optnone] = ACTIONS(521),
    [anon_sym_optsize] = ACTIONS(521),
    [anon_sym_readnone] = ACTIONS(521),
    [anon_sym_readonly] = ACTIONS(521),
    [anon_sym_writeonly] = ACTIONS(521),
    [anon_sym_argmemonly] = ACTIONS(521),
    [anon_sym_returns_twice] = ACTIONS(521),
    [anon_sym_safestack] = ACTIONS(521),
    [anon_sym_sanitize_address] = ACTIONS(521),
    [anon_sym_sanitize_memory] = ACTIONS(521),
    [anon_sym_sanitize_thread] = ACTIONS(521),
    [anon_sym_sanitize_hwaddress] = ACTIONS(521),
    [anon_sym_sanitize_memtag] = ACTIONS(521),
    [anon_sym_speculative_load_hardening] = ACTIONS(521),
    [anon_sym_speculatable] = ACTIONS(521),
    [anon_sym_ssp] = ACTIONS(523),
    [anon_sym_sspstrong] = ACTIONS(521),
    [anon_sym_sspreq] = ACTIONS(521),
    [anon_sym_strictfp] = ACTIONS(521),
    [anon_sym_nocf_check] = ACTIONS(521),
    [anon_sym_shadowcallstack] = ACTIONS(521),
    [anon_sym_mustprogress] = ACTIONS(521),
    [anon_sym_vscale_range] = ACTIONS(521),
    [anon_sym_preallocated] = ACTIONS(521),
    [anon_sym_zeroext] = ACTIONS(521),
    [anon_sym_signext] = ACTIONS(521),
    [anon_sym_inreg] = ACTIONS(521),
    [anon_sym_byval] = ACTIONS(521),
    [anon_sym_byref] = ACTIONS(521),
    [anon_sym_inalloca] = ACTIONS(521),
    [anon_sym_sret] = ACTIONS(521),
    [anon_sym_elementtype] = ACTIONS(521),
    [anon_sym_noalias] = ACTIONS(521),
    [anon_sym_nocapture] = ACTIONS(521),
    [anon_sym_nest] = ACTIONS(521),
    [anon_sym_returned] = ACTIONS(521),
    [anon_sym_nonnull] = ACTIONS(521),
    [anon_sym_dereferenceable] = ACTIONS(523),
    [anon_sym_dereferenceable_or_null] = ACTIONS(521),
    [anon_sym_swiftself] = ACTIONS(521),
    [anon_sym_swiftasync] = ACTIONS(521),
    [anon_sym_swifterror] = ACTIONS(521),
    [anon_sym_immarg] = ACTIONS(521),
    [anon_sym_noundef] = ACTIONS(521),
    [anon_sym_uwtable] = ACTIONS(521),
    [anon_sym_memory] = ACTIONS(521),
    [anon_sym_to] = ACTIONS(523),
    [anon_sym_uselistorder] = ACTIONS(523),
    [anon_sym_uselistorder_bb] = ACTIONS(521),
    [anon_sym_module] = ACTIONS(521),
    [anon_sym_attributes] = ACTIONS(521),
  },
  [360] = {
    [ts_builtin_sym_end] = ACTIONS(679),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(679),
    [sym_comdat_ref] = ACTIONS(679),
    [sym_global_var] = ACTIONS(679),
    [sym_local_var] = ACTIONS(679),
    [aux_sym_metadata_ref_token1] = ACTIONS(679),
    [sym_summary_ref] = ACTIONS(679),
    [sym_string] = ACTIONS(679),
    [anon_sym_target] = ACTIONS(679),
    [anon_sym_source_filename] = ACTIONS(679),
    [anon_sym_declare] = ACTIONS(679),
    [anon_sym_define] = ACTIONS(679),
    [anon_sym_void] = ACTIONS(679),
    [anon_sym_half] = ACTIONS(679),
    [anon_sym_bfloat] = ACTIONS(679),
    [anon_sym_float] = ACTIONS(679),
    [anon_sym_double] = ACTIONS(679),
    [anon_sym_x86_fp80] = ACTIONS(679),
    [anon_sym_fp128] = ACTIONS(679),
    [anon_sym_ppc_fp128] = ACTIONS(679),
    [anon_sym_label] = ACTIONS(679),
    [anon_sym_metadata] = ACTIONS(679),
    [anon_sym_x86_mmx] = ACTIONS(679),
    [anon_sym_x86_amx] = ACTIONS(679),
    [anon_sym_token] = ACTIONS(679),
    [anon_sym_opaque] = ACTIONS(679),
    [anon_sym_ptr] = ACTIONS(679),
    [aux_sym_type_keyword_token1] = ACTIONS(679),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(679),
    [anon_sym_LT_LBRACE] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(679),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_COMMA] = ACTIONS(679),
    [anon_sym_align] = ACTIONS(681),
    [anon_sym_section] = ACTIONS(679),
    [anon_sym_partition] = ACTIONS(679),
    [anon_sym_comdat] = ACTIONS(679),
    [anon_sym_gc] = ACTIONS(679),
    [anon_sym_prefix] = ACTIONS(679),
    [anon_sym_prologue] = ACTIONS(679),
    [anon_sym_personality] = ACTIONS(679),
    [anon_sym_alignstack] = ACTIONS(679),
    [anon_sym_allocsize] = ACTIONS(679),
    [anon_sym_alwaysinline] = ACTIONS(679),
    [anon_sym_builtin] = ACTIONS(679),
    [anon_sym_cold] = ACTIONS(679),
    [anon_sym_convergent] = ACTIONS(679),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(679),
    [anon_sym_hot] = ACTIONS(679),
    [anon_sym_inaccessiblememonly] = ACTIONS(679),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(679),
    [anon_sym_inlinehint] = ACTIONS(679),
    [anon_sym_jumptable] = ACTIONS(679),
    [anon_sym_minsize] = ACTIONS(679),
    [anon_sym_naked] = ACTIONS(679),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(679),
    [anon_sym_nobuiltin] = ACTIONS(679),
    [anon_sym_noduplicate] = ACTIONS(679),
    [anon_sym_nofree] = ACTIONS(679),
    [anon_sym_noimplicitfloat] = ACTIONS(679),
    [anon_sym_noinline] = ACTIONS(679),
    [anon_sym_nomerge] = ACTIONS(679),
    [anon_sym_nonlazybind] = ACTIONS(679),
    [anon_sym_noprofile] = ACTIONS(679),
    [anon_sym_noredzone] = ACTIONS(679),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(679),
    [anon_sym_noreturn] = ACTIONS(679),
    [anon_sym_norecurse] = ACTIONS(679),
    [anon_sym_willreturn] = ACTIONS(679),
    [anon_sym_nosync] = ACTIONS(679),
    [anon_sym_nounwind] = ACTIONS(679),
    [anon_sym_nocallback] = ACTIONS(679),
    [anon_sym_nosanitize_coverage] = ACTIONS(679),
    [anon_sym_null_pointer_is_valid] = ACTIONS(679),
    [anon_sym_optforfuzzing] = ACTIONS(679),
    [anon_sym_optnone] = ACTIONS(679),
    [anon_sym_optsize] = ACTIONS(679),
    [anon_sym_readnone] = ACTIONS(679),
    [anon_sym_readonly] = ACTIONS(679),
    [anon_sym_writeonly] = ACTIONS(679),
    [anon_sym_argmemonly] = ACTIONS(679),
    [anon_sym_returns_twice] = ACTIONS(679),
    [anon_sym_safestack] = ACTIONS(679),
    [anon_sym_sanitize_address] = ACTIONS(679),
    [anon_sym_sanitize_memory] = ACTIONS(679),
    [anon_sym_sanitize_thread] = ACTIONS(679),
    [anon_sym_sanitize_hwaddress] = ACTIONS(679),
    [anon_sym_sanitize_memtag] = ACTIONS(679),
    [anon_sym_speculative_load_hardening] = ACTIONS(679),
    [anon_sym_speculatable] = ACTIONS(679),
    [anon_sym_ssp] = ACTIONS(681),
    [anon_sym_sspstrong] = ACTIONS(679),
    [anon_sym_sspreq] = ACTIONS(679),
    [anon_sym_strictfp] = ACTIONS(679),
    [anon_sym_nocf_check] = ACTIONS(679),
    [anon_sym_shadowcallstack] = ACTIONS(679),
    [anon_sym_mustprogress] = ACTIONS(679),
    [anon_sym_vscale_range] = ACTIONS(679),
    [anon_sym_preallocated] = ACTIONS(679),
    [anon_sym_zeroext] = ACTIONS(679),
    [anon_sym_signext] = ACTIONS(679),
    [anon_sym_inreg] = ACTIONS(679),
    [anon_sym_byval] = ACTIONS(679),
    [anon_sym_byref] = ACTIONS(679),
    [anon_sym_inalloca] = ACTIONS(679),
    [anon_sym_sret] = ACTIONS(679),
    [anon_sym_elementtype] = ACTIONS(679),
    [anon_sym_noalias] = ACTIONS(679),
    [anon_sym_nocapture] = ACTIONS(679),
    [anon_sym_nest] = ACTIONS(679),
    [anon_sym_returned] = ACTIONS(679),
    [anon_sym_nonnull] = ACTIONS(679),
    [anon_sym_dereferenceable] = ACTIONS(681),
    [anon_sym_dereferenceable_or_null] = ACTIONS(679),
    [anon_sym_swiftself] = ACTIONS(679),
    [anon_sym_swiftasync] = ACTIONS(679),
    [anon_sym_swifterror] = ACTIONS(679),
    [anon_sym_immarg] = ACTIONS(679),
    [anon_sym_noundef] = ACTIONS(679),
    [anon_sym_uwtable] = ACTIONS(679),
    [anon_sym_memory] = ACTIONS(679),
    [anon_sym_to] = ACTIONS(681),
    [anon_sym_uselistorder] = ACTIONS(681),
    [anon_sym_uselistorder_bb] = ACTIONS(679),
    [anon_sym_module] = ACTIONS(679),
    [anon_sym_attributes] = ACTIONS(679),
  },
  [361] = {
    [ts_builtin_sym_end] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(541),
    [sym_comdat_ref] = ACTIONS(541),
    [sym_global_var] = ACTIONS(541),
    [sym_local_var] = ACTIONS(541),
    [aux_sym_metadata_ref_token1] = ACTIONS(541),
    [sym_summary_ref] = ACTIONS(541),
    [sym_string] = ACTIONS(541),
    [anon_sym_target] = ACTIONS(541),
    [anon_sym_source_filename] = ACTIONS(541),
    [anon_sym_declare] = ACTIONS(541),
    [anon_sym_define] = ACTIONS(541),
    [anon_sym_void] = ACTIONS(541),
    [anon_sym_half] = ACTIONS(541),
    [anon_sym_bfloat] = ACTIONS(541),
    [anon_sym_float] = ACTIONS(541),
    [anon_sym_double] = ACTIONS(541),
    [anon_sym_x86_fp80] = ACTIONS(541),
    [anon_sym_fp128] = ACTIONS(541),
    [anon_sym_ppc_fp128] = ACTIONS(541),
    [anon_sym_label] = ACTIONS(541),
    [anon_sym_metadata] = ACTIONS(541),
    [anon_sym_x86_mmx] = ACTIONS(541),
    [anon_sym_x86_amx] = ACTIONS(541),
    [anon_sym_token] = ACTIONS(541),
    [anon_sym_opaque] = ACTIONS(541),
    [anon_sym_ptr] = ACTIONS(541),
    [aux_sym_type_keyword_token1] = ACTIONS(541),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(541),
    [anon_sym_LT_LBRACE] = ACTIONS(541),
    [anon_sym_LBRACK] = ACTIONS(541),
    [anon_sym_RBRACK] = ACTIONS(541),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_COMMA] = ACTIONS(541),
    [anon_sym_align] = ACTIONS(543),
    [anon_sym_section] = ACTIONS(541),
    [anon_sym_partition] = ACTIONS(541),
    [anon_sym_comdat] = ACTIONS(541),
    [anon_sym_gc] = ACTIONS(541),
    [anon_sym_prefix] = ACTIONS(541),
    [anon_sym_prologue] = ACTIONS(541),
    [anon_sym_personality] = ACTIONS(541),
    [anon_sym_alignstack] = ACTIONS(541),
    [anon_sym_allocsize] = ACTIONS(541),
    [anon_sym_alwaysinline] = ACTIONS(541),
    [anon_sym_builtin] = ACTIONS(541),
    [anon_sym_cold] = ACTIONS(541),
    [anon_sym_convergent] = ACTIONS(541),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(541),
    [anon_sym_hot] = ACTIONS(541),
    [anon_sym_inaccessiblememonly] = ACTIONS(541),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(541),
    [anon_sym_inlinehint] = ACTIONS(541),
    [anon_sym_jumptable] = ACTIONS(541),
    [anon_sym_minsize] = ACTIONS(541),
    [anon_sym_naked] = ACTIONS(541),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(541),
    [anon_sym_nobuiltin] = ACTIONS(541),
    [anon_sym_noduplicate] = ACTIONS(541),
    [anon_sym_nofree] = ACTIONS(541),
    [anon_sym_noimplicitfloat] = ACTIONS(541),
    [anon_sym_noinline] = ACTIONS(541),
    [anon_sym_nomerge] = ACTIONS(541),
    [anon_sym_nonlazybind] = ACTIONS(541),
    [anon_sym_noprofile] = ACTIONS(541),
    [anon_sym_noredzone] = ACTIONS(541),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(541),
    [anon_sym_noreturn] = ACTIONS(541),
    [anon_sym_norecurse] = ACTIONS(541),
    [anon_sym_willreturn] = ACTIONS(541),
    [anon_sym_nosync] = ACTIONS(541),
    [anon_sym_nounwind] = ACTIONS(541),
    [anon_sym_nocallback] = ACTIONS(541),
    [anon_sym_nosanitize_coverage] = ACTIONS(541),
    [anon_sym_null_pointer_is_valid] = ACTIONS(541),
    [anon_sym_optforfuzzing] = ACTIONS(541),
    [anon_sym_optnone] = ACTIONS(541),
    [anon_sym_optsize] = ACTIONS(541),
    [anon_sym_readnone] = ACTIONS(541),
    [anon_sym_readonly] = ACTIONS(541),
    [anon_sym_writeonly] = ACTIONS(541),
    [anon_sym_argmemonly] = ACTIONS(541),
    [anon_sym_returns_twice] = ACTIONS(541),
    [anon_sym_safestack] = ACTIONS(541),
    [anon_sym_sanitize_address] = ACTIONS(541),
    [anon_sym_sanitize_memory] = ACTIONS(541),
    [anon_sym_sanitize_thread] = ACTIONS(541),
    [anon_sym_sanitize_hwaddress] = ACTIONS(541),
    [anon_sym_sanitize_memtag] = ACTIONS(541),
    [anon_sym_speculative_load_hardening] = ACTIONS(541),
    [anon_sym_speculatable] = ACTIONS(541),
    [anon_sym_ssp] = ACTIONS(543),
    [anon_sym_sspstrong] = ACTIONS(541),
    [anon_sym_sspreq] = ACTIONS(541),
    [anon_sym_strictfp] = ACTIONS(541),
    [anon_sym_nocf_check] = ACTIONS(541),
    [anon_sym_shadowcallstack] = ACTIONS(541),
    [anon_sym_mustprogress] = ACTIONS(541),
    [anon_sym_vscale_range] = ACTIONS(541),
    [anon_sym_preallocated] = ACTIONS(541),
    [anon_sym_zeroext] = ACTIONS(541),
    [anon_sym_signext] = ACTIONS(541),
    [anon_sym_inreg] = ACTIONS(541),
    [anon_sym_byval] = ACTIONS(541),
    [anon_sym_byref] = ACTIONS(541),
    [anon_sym_inalloca] = ACTIONS(541),
    [anon_sym_sret] = ACTIONS(541),
    [anon_sym_elementtype] = ACTIONS(541),
    [anon_sym_noalias] = ACTIONS(541),
    [anon_sym_nocapture] = ACTIONS(541),
    [anon_sym_nest] = ACTIONS(541),
    [anon_sym_returned] = ACTIONS(541),
    [anon_sym_nonnull] = ACTIONS(541),
    [anon_sym_dereferenceable] = ACTIONS(543),
    [anon_sym_dereferenceable_or_null] = ACTIONS(541),
    [anon_sym_swiftself] = ACTIONS(541),
    [anon_sym_swiftasync] = ACTIONS(541),
    [anon_sym_swifterror] = ACTIONS(541),
    [anon_sym_immarg] = ACTIONS(541),
    [anon_sym_noundef] = ACTIONS(541),
    [anon_sym_uwtable] = ACTIONS(541),
    [anon_sym_memory] = ACTIONS(541),
    [anon_sym_to] = ACTIONS(543),
    [anon_sym_uselistorder] = ACTIONS(543),
    [anon_sym_uselistorder_bb] = ACTIONS(541),
    [anon_sym_module] = ACTIONS(541),
    [anon_sym_attributes] = ACTIONS(541),
  },
  [362] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(391),
    [sym_local_var] = ACTIONS(391),
    [sym_label] = ACTIONS(391),
    [sym_string] = ACTIONS(393),
    [aux_sym_number_token1] = ACTIONS(393),
    [aux_sym_number_token2] = ACTIONS(393),
    [sym_float] = ACTIONS(393),
    [sym_cstring] = ACTIONS(391),
    [anon_sym_no_cfi] = ACTIONS(393),
    [anon_sym_private] = ACTIONS(393),
    [anon_sym_internal] = ACTIONS(393),
    [anon_sym_weak] = ACTIONS(393),
    [anon_sym_weak_odr] = ACTIONS(393),
    [anon_sym_linkonce] = ACTIONS(393),
    [anon_sym_linkonce_odr] = ACTIONS(393),
    [anon_sym_available_externally] = ACTIONS(393),
    [anon_sym_appending] = ACTIONS(393),
    [anon_sym_common] = ACTIONS(393),
    [anon_sym_extern_weak] = ACTIONS(393),
    [anon_sym_external] = ACTIONS(393),
    [anon_sym_dso_local] = ACTIONS(393),
    [anon_sym_dso_local_equivalent] = ACTIONS(393),
    [anon_sym_dso_preemptable] = ACTIONS(393),
    [anon_sym_default] = ACTIONS(393),
    [anon_sym_hidden] = ACTIONS(393),
    [anon_sym_protected] = ACTIONS(393),
    [anon_sym_dllimport] = ACTIONS(393),
    [anon_sym_dllexport] = ACTIONS(393),
    [anon_sym_STAR] = ACTIONS(391),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_RBRACE] = ACTIONS(391),
    [anon_sym_LT_LBRACE] = ACTIONS(391),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LT] = ACTIONS(393),
    [anon_sym_COMMA] = ACTIONS(391),
    [anon_sym_none] = ACTIONS(393),
    [anon_sym_unreachable] = ACTIONS(393),
    [anon_sym_ret] = ACTIONS(393),
    [anon_sym_br] = ACTIONS(393),
    [anon_sym_resume] = ACTIONS(393),
    [anon_sym_freeze] = ACTIONS(393),
    [anon_sym_indirectbr] = ACTIONS(393),
    [anon_sym_extractelement] = ACTIONS(393),
    [anon_sym_insertelement] = ACTIONS(393),
    [anon_sym_select] = ACTIONS(393),
    [anon_sym_shufflevector] = ACTIONS(393),
    [anon_sym_fneg] = ACTIONS(393),
    [anon_sym_switch] = ACTIONS(393),
    [anon_sym_invoke] = ACTIONS(393),
    [anon_sym_cleanupret] = ACTIONS(393),
    [anon_sym_catchret] = ACTIONS(393),
    [anon_sym_catchswitch] = ACTIONS(393),
    [anon_sym_catchpad] = ACTIONS(393),
    [anon_sym_cleanuppad] = ACTIONS(393),
    [anon_sym_callbr] = ACTIONS(393),
    [anon_sym_icmp] = ACTIONS(393),
    [anon_sym_fcmp] = ACTIONS(393),
    [anon_sym_va_arg] = ACTIONS(393),
    [anon_sym_phi] = ACTIONS(393),
    [anon_sym_landingpad] = ACTIONS(393),
    [anon_sym_tail] = ACTIONS(393),
    [anon_sym_musttail] = ACTIONS(393),
    [anon_sym_notail] = ACTIONS(393),
    [anon_sym_call] = ACTIONS(393),
    [anon_sym_alloca] = ACTIONS(393),
    [anon_sym_load] = ACTIONS(393),
    [anon_sym_store] = ACTIONS(393),
    [anon_sym_cmpxchg] = ACTIONS(393),
    [anon_sym_atomicrmw] = ACTIONS(393),
    [anon_sym_fence] = ACTIONS(393),
    [anon_sym_getelementptr] = ACTIONS(393),
    [anon_sym_extractvalue] = ACTIONS(393),
    [anon_sym_insertvalue] = ACTIONS(393),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [anon_sym_null] = ACTIONS(393),
    [anon_sym_undef] = ACTIONS(393),
    [anon_sym_poison] = ACTIONS(393),
    [anon_sym_zeroinitializer] = ACTIONS(393),
    [anon_sym_catch] = ACTIONS(393),
    [anon_sym_filter] = ACTIONS(393),
    [anon_sym_blockaddress] = ACTIONS(393),
    [anon_sym_mul] = ACTIONS(393),
    [anon_sym_urem] = ACTIONS(393),
    [anon_sym_srem] = ACTIONS(393),
    [anon_sym_shl] = ACTIONS(393),
    [anon_sym_udiv] = ACTIONS(393),
    [anon_sym_sdiv] = ACTIONS(393),
    [anon_sym_lshr] = ACTIONS(393),
    [anon_sym_ashr] = ACTIONS(393),
    [anon_sym_fmul] = ACTIONS(393),
    [anon_sym_fdiv] = ACTIONS(393),
    [anon_sym_frem] = ACTIONS(393),
    [anon_sym_xchg] = ACTIONS(393),
    [anon_sym_add] = ACTIONS(393),
    [anon_sym_sub] = ACTIONS(393),
    [anon_sym_and] = ACTIONS(393),
    [anon_sym_nand] = ACTIONS(393),
    [anon_sym_or] = ACTIONS(393),
    [anon_sym_xor] = ACTIONS(393),
    [anon_sym_max] = ACTIONS(393),
    [anon_sym_min] = ACTIONS(393),
    [anon_sym_umax] = ACTIONS(393),
    [anon_sym_umin] = ACTIONS(393),
    [anon_sym_fadd] = ACTIONS(393),
    [anon_sym_fsub] = ACTIONS(393),
    [anon_sym_bitcast] = ACTIONS(393),
    [anon_sym_trunc] = ACTIONS(393),
    [anon_sym_zext] = ACTIONS(393),
    [anon_sym_sext] = ACTIONS(393),
    [anon_sym_fptrunc] = ACTIONS(393),
    [anon_sym_fpext] = ACTIONS(393),
    [anon_sym_addrspacecast] = ACTIONS(393),
    [anon_sym_uitofp] = ACTIONS(393),
    [anon_sym_sitofp] = ACTIONS(393),
    [anon_sym_fptoui] = ACTIONS(393),
    [anon_sym_fptosi] = ACTIONS(393),
    [anon_sym_inttoptr] = ACTIONS(393),
    [anon_sym_ptrtoint] = ACTIONS(393),
    [anon_sym_unordered] = ACTIONS(393),
    [anon_sym_monotonic] = ACTIONS(393),
    [anon_sym_acquire] = ACTIONS(393),
    [anon_sym_release] = ACTIONS(393),
    [anon_sym_acq_rel] = ACTIONS(393),
    [anon_sym_seq_cst] = ACTIONS(393),
    [anon_sym_syncscope] = ACTIONS(393),
    [anon_sym_uselistorder] = ACTIONS(393),
  },
  [363] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [sym_label] = ACTIONS(244),
    [sym_string] = ACTIONS(246),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(246),
    [sym_float] = ACTIONS(246),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(246),
    [anon_sym_private] = ACTIONS(246),
    [anon_sym_internal] = ACTIONS(246),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(246),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(246),
    [anon_sym_available_externally] = ACTIONS(246),
    [anon_sym_appending] = ACTIONS(246),
    [anon_sym_common] = ACTIONS(246),
    [anon_sym_extern_weak] = ACTIONS(246),
    [anon_sym_external] = ACTIONS(246),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(246),
    [anon_sym_dso_preemptable] = ACTIONS(246),
    [anon_sym_default] = ACTIONS(246),
    [anon_sym_hidden] = ACTIONS(246),
    [anon_sym_protected] = ACTIONS(246),
    [anon_sym_dllimport] = ACTIONS(246),
    [anon_sym_dllexport] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_none] = ACTIONS(246),
    [anon_sym_unreachable] = ACTIONS(246),
    [anon_sym_ret] = ACTIONS(246),
    [anon_sym_br] = ACTIONS(246),
    [anon_sym_resume] = ACTIONS(246),
    [anon_sym_freeze] = ACTIONS(246),
    [anon_sym_indirectbr] = ACTIONS(246),
    [anon_sym_extractelement] = ACTIONS(246),
    [anon_sym_insertelement] = ACTIONS(246),
    [anon_sym_select] = ACTIONS(246),
    [anon_sym_shufflevector] = ACTIONS(246),
    [anon_sym_fneg] = ACTIONS(246),
    [anon_sym_switch] = ACTIONS(246),
    [anon_sym_invoke] = ACTIONS(246),
    [anon_sym_cleanupret] = ACTIONS(246),
    [anon_sym_catchret] = ACTIONS(246),
    [anon_sym_catchswitch] = ACTIONS(246),
    [anon_sym_catchpad] = ACTIONS(246),
    [anon_sym_cleanuppad] = ACTIONS(246),
    [anon_sym_callbr] = ACTIONS(246),
    [anon_sym_icmp] = ACTIONS(246),
    [anon_sym_fcmp] = ACTIONS(246),
    [anon_sym_va_arg] = ACTIONS(246),
    [anon_sym_phi] = ACTIONS(246),
    [anon_sym_landingpad] = ACTIONS(246),
    [anon_sym_tail] = ACTIONS(246),
    [anon_sym_musttail] = ACTIONS(246),
    [anon_sym_notail] = ACTIONS(246),
    [anon_sym_call] = ACTIONS(246),
    [anon_sym_alloca] = ACTIONS(246),
    [anon_sym_load] = ACTIONS(246),
    [anon_sym_store] = ACTIONS(246),
    [anon_sym_cmpxchg] = ACTIONS(246),
    [anon_sym_atomicrmw] = ACTIONS(246),
    [anon_sym_fence] = ACTIONS(246),
    [anon_sym_getelementptr] = ACTIONS(246),
    [anon_sym_extractvalue] = ACTIONS(246),
    [anon_sym_insertvalue] = ACTIONS(246),
    [anon_sym_true] = ACTIONS(246),
    [anon_sym_false] = ACTIONS(246),
    [anon_sym_null] = ACTIONS(246),
    [anon_sym_undef] = ACTIONS(246),
    [anon_sym_poison] = ACTIONS(246),
    [anon_sym_zeroinitializer] = ACTIONS(246),
    [anon_sym_catch] = ACTIONS(246),
    [anon_sym_filter] = ACTIONS(246),
    [anon_sym_blockaddress] = ACTIONS(246),
    [anon_sym_mul] = ACTIONS(246),
    [anon_sym_urem] = ACTIONS(246),
    [anon_sym_srem] = ACTIONS(246),
    [anon_sym_shl] = ACTIONS(246),
    [anon_sym_udiv] = ACTIONS(246),
    [anon_sym_sdiv] = ACTIONS(246),
    [anon_sym_lshr] = ACTIONS(246),
    [anon_sym_ashr] = ACTIONS(246),
    [anon_sym_fmul] = ACTIONS(246),
    [anon_sym_fdiv] = ACTIONS(246),
    [anon_sym_frem] = ACTIONS(246),
    [anon_sym_xchg] = ACTIONS(246),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(246),
    [anon_sym_and] = ACTIONS(246),
    [anon_sym_nand] = ACTIONS(246),
    [anon_sym_or] = ACTIONS(246),
    [anon_sym_xor] = ACTIONS(246),
    [anon_sym_max] = ACTIONS(246),
    [anon_sym_min] = ACTIONS(246),
    [anon_sym_umax] = ACTIONS(246),
    [anon_sym_umin] = ACTIONS(246),
    [anon_sym_fadd] = ACTIONS(246),
    [anon_sym_fsub] = ACTIONS(246),
    [anon_sym_bitcast] = ACTIONS(246),
    [anon_sym_trunc] = ACTIONS(246),
    [anon_sym_zext] = ACTIONS(246),
    [anon_sym_sext] = ACTIONS(246),
    [anon_sym_fptrunc] = ACTIONS(246),
    [anon_sym_fpext] = ACTIONS(246),
    [anon_sym_addrspacecast] = ACTIONS(246),
    [anon_sym_uitofp] = ACTIONS(246),
    [anon_sym_sitofp] = ACTIONS(246),
    [anon_sym_fptoui] = ACTIONS(246),
    [anon_sym_fptosi] = ACTIONS(246),
    [anon_sym_inttoptr] = ACTIONS(246),
    [anon_sym_ptrtoint] = ACTIONS(246),
    [anon_sym_unordered] = ACTIONS(246),
    [anon_sym_monotonic] = ACTIONS(246),
    [anon_sym_acquire] = ACTIONS(246),
    [anon_sym_release] = ACTIONS(246),
    [anon_sym_acq_rel] = ACTIONS(246),
    [anon_sym_seq_cst] = ACTIONS(246),
    [anon_sym_syncscope] = ACTIONS(246),
    [anon_sym_uselistorder] = ACTIONS(246),
  },
  [364] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [sym_label] = ACTIONS(263),
    [sym_string] = ACTIONS(265),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(265),
    [sym_float] = ACTIONS(265),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(265),
    [anon_sym_private] = ACTIONS(265),
    [anon_sym_internal] = ACTIONS(265),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(265),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(265),
    [anon_sym_available_externally] = ACTIONS(265),
    [anon_sym_appending] = ACTIONS(265),
    [anon_sym_common] = ACTIONS(265),
    [anon_sym_extern_weak] = ACTIONS(265),
    [anon_sym_external] = ACTIONS(265),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(265),
    [anon_sym_dso_preemptable] = ACTIONS(265),
    [anon_sym_default] = ACTIONS(265),
    [anon_sym_hidden] = ACTIONS(265),
    [anon_sym_protected] = ACTIONS(265),
    [anon_sym_dllimport] = ACTIONS(265),
    [anon_sym_dllexport] = ACTIONS(265),
    [anon_sym_STAR] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_none] = ACTIONS(265),
    [anon_sym_unreachable] = ACTIONS(265),
    [anon_sym_ret] = ACTIONS(265),
    [anon_sym_br] = ACTIONS(265),
    [anon_sym_resume] = ACTIONS(265),
    [anon_sym_freeze] = ACTIONS(265),
    [anon_sym_indirectbr] = ACTIONS(265),
    [anon_sym_extractelement] = ACTIONS(265),
    [anon_sym_insertelement] = ACTIONS(265),
    [anon_sym_select] = ACTIONS(265),
    [anon_sym_shufflevector] = ACTIONS(265),
    [anon_sym_fneg] = ACTIONS(265),
    [anon_sym_switch] = ACTIONS(265),
    [anon_sym_invoke] = ACTIONS(265),
    [anon_sym_cleanupret] = ACTIONS(265),
    [anon_sym_catchret] = ACTIONS(265),
    [anon_sym_catchswitch] = ACTIONS(265),
    [anon_sym_catchpad] = ACTIONS(265),
    [anon_sym_cleanuppad] = ACTIONS(265),
    [anon_sym_callbr] = ACTIONS(265),
    [anon_sym_icmp] = ACTIONS(265),
    [anon_sym_fcmp] = ACTIONS(265),
    [anon_sym_va_arg] = ACTIONS(265),
    [anon_sym_phi] = ACTIONS(265),
    [anon_sym_landingpad] = ACTIONS(265),
    [anon_sym_tail] = ACTIONS(265),
    [anon_sym_musttail] = ACTIONS(265),
    [anon_sym_notail] = ACTIONS(265),
    [anon_sym_call] = ACTIONS(265),
    [anon_sym_alloca] = ACTIONS(265),
    [anon_sym_load] = ACTIONS(265),
    [anon_sym_store] = ACTIONS(265),
    [anon_sym_cmpxchg] = ACTIONS(265),
    [anon_sym_atomicrmw] = ACTIONS(265),
    [anon_sym_fence] = ACTIONS(265),
    [anon_sym_getelementptr] = ACTIONS(265),
    [anon_sym_extractvalue] = ACTIONS(265),
    [anon_sym_insertvalue] = ACTIONS(265),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [anon_sym_null] = ACTIONS(265),
    [anon_sym_undef] = ACTIONS(265),
    [anon_sym_poison] = ACTIONS(265),
    [anon_sym_zeroinitializer] = ACTIONS(265),
    [anon_sym_catch] = ACTIONS(265),
    [anon_sym_filter] = ACTIONS(265),
    [anon_sym_blockaddress] = ACTIONS(265),
    [anon_sym_mul] = ACTIONS(265),
    [anon_sym_urem] = ACTIONS(265),
    [anon_sym_srem] = ACTIONS(265),
    [anon_sym_shl] = ACTIONS(265),
    [anon_sym_udiv] = ACTIONS(265),
    [anon_sym_sdiv] = ACTIONS(265),
    [anon_sym_lshr] = ACTIONS(265),
    [anon_sym_ashr] = ACTIONS(265),
    [anon_sym_fmul] = ACTIONS(265),
    [anon_sym_fdiv] = ACTIONS(265),
    [anon_sym_frem] = ACTIONS(265),
    [anon_sym_xchg] = ACTIONS(265),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(265),
    [anon_sym_and] = ACTIONS(265),
    [anon_sym_nand] = ACTIONS(265),
    [anon_sym_or] = ACTIONS(265),
    [anon_sym_xor] = ACTIONS(265),
    [anon_sym_max] = ACTIONS(265),
    [anon_sym_min] = ACTIONS(265),
    [anon_sym_umax] = ACTIONS(265),
    [anon_sym_umin] = ACTIONS(265),
    [anon_sym_fadd] = ACTIONS(265),
    [anon_sym_fsub] = ACTIONS(265),
    [anon_sym_bitcast] = ACTIONS(265),
    [anon_sym_trunc] = ACTIONS(265),
    [anon_sym_zext] = ACTIONS(265),
    [anon_sym_sext] = ACTIONS(265),
    [anon_sym_fptrunc] = ACTIONS(265),
    [anon_sym_fpext] = ACTIONS(265),
    [anon_sym_addrspacecast] = ACTIONS(265),
    [anon_sym_uitofp] = ACTIONS(265),
    [anon_sym_sitofp] = ACTIONS(265),
    [anon_sym_fptoui] = ACTIONS(265),
    [anon_sym_fptosi] = ACTIONS(265),
    [anon_sym_inttoptr] = ACTIONS(265),
    [anon_sym_ptrtoint] = ACTIONS(265),
    [anon_sym_unordered] = ACTIONS(265),
    [anon_sym_monotonic] = ACTIONS(265),
    [anon_sym_acquire] = ACTIONS(265),
    [anon_sym_release] = ACTIONS(265),
    [anon_sym_acq_rel] = ACTIONS(265),
    [anon_sym_seq_cst] = ACTIONS(265),
    [anon_sym_syncscope] = ACTIONS(265),
    [anon_sym_uselistorder] = ACTIONS(265),
  },
  [365] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(395),
    [sym_local_var] = ACTIONS(395),
    [sym_label] = ACTIONS(395),
    [sym_string] = ACTIONS(397),
    [aux_sym_number_token1] = ACTIONS(397),
    [aux_sym_number_token2] = ACTIONS(397),
    [sym_float] = ACTIONS(397),
    [sym_cstring] = ACTIONS(395),
    [anon_sym_no_cfi] = ACTIONS(397),
    [anon_sym_private] = ACTIONS(397),
    [anon_sym_internal] = ACTIONS(397),
    [anon_sym_weak] = ACTIONS(397),
    [anon_sym_weak_odr] = ACTIONS(397),
    [anon_sym_linkonce] = ACTIONS(397),
    [anon_sym_linkonce_odr] = ACTIONS(397),
    [anon_sym_available_externally] = ACTIONS(397),
    [anon_sym_appending] = ACTIONS(397),
    [anon_sym_common] = ACTIONS(397),
    [anon_sym_extern_weak] = ACTIONS(397),
    [anon_sym_external] = ACTIONS(397),
    [anon_sym_dso_local] = ACTIONS(397),
    [anon_sym_dso_local_equivalent] = ACTIONS(397),
    [anon_sym_dso_preemptable] = ACTIONS(397),
    [anon_sym_default] = ACTIONS(397),
    [anon_sym_hidden] = ACTIONS(397),
    [anon_sym_protected] = ACTIONS(397),
    [anon_sym_dllimport] = ACTIONS(397),
    [anon_sym_dllexport] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_RBRACE] = ACTIONS(395),
    [anon_sym_LT_LBRACE] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(395),
    [anon_sym_LT] = ACTIONS(397),
    [anon_sym_COMMA] = ACTIONS(395),
    [anon_sym_none] = ACTIONS(397),
    [anon_sym_unreachable] = ACTIONS(397),
    [anon_sym_ret] = ACTIONS(397),
    [anon_sym_br] = ACTIONS(397),
    [anon_sym_resume] = ACTIONS(397),
    [anon_sym_freeze] = ACTIONS(397),
    [anon_sym_indirectbr] = ACTIONS(397),
    [anon_sym_extractelement] = ACTIONS(397),
    [anon_sym_insertelement] = ACTIONS(397),
    [anon_sym_select] = ACTIONS(397),
    [anon_sym_shufflevector] = ACTIONS(397),
    [anon_sym_fneg] = ACTIONS(397),
    [anon_sym_switch] = ACTIONS(397),
    [anon_sym_invoke] = ACTIONS(397),
    [anon_sym_cleanupret] = ACTIONS(397),
    [anon_sym_catchret] = ACTIONS(397),
    [anon_sym_catchswitch] = ACTIONS(397),
    [anon_sym_catchpad] = ACTIONS(397),
    [anon_sym_cleanuppad] = ACTIONS(397),
    [anon_sym_callbr] = ACTIONS(397),
    [anon_sym_icmp] = ACTIONS(397),
    [anon_sym_fcmp] = ACTIONS(397),
    [anon_sym_va_arg] = ACTIONS(397),
    [anon_sym_phi] = ACTIONS(397),
    [anon_sym_landingpad] = ACTIONS(397),
    [anon_sym_tail] = ACTIONS(397),
    [anon_sym_musttail] = ACTIONS(397),
    [anon_sym_notail] = ACTIONS(397),
    [anon_sym_call] = ACTIONS(397),
    [anon_sym_alloca] = ACTIONS(397),
    [anon_sym_load] = ACTIONS(397),
    [anon_sym_store] = ACTIONS(397),
    [anon_sym_cmpxchg] = ACTIONS(397),
    [anon_sym_atomicrmw] = ACTIONS(397),
    [anon_sym_fence] = ACTIONS(397),
    [anon_sym_getelementptr] = ACTIONS(397),
    [anon_sym_extractvalue] = ACTIONS(397),
    [anon_sym_insertvalue] = ACTIONS(397),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_false] = ACTIONS(397),
    [anon_sym_null] = ACTIONS(397),
    [anon_sym_undef] = ACTIONS(397),
    [anon_sym_poison] = ACTIONS(397),
    [anon_sym_zeroinitializer] = ACTIONS(397),
    [anon_sym_catch] = ACTIONS(397),
    [anon_sym_filter] = ACTIONS(397),
    [anon_sym_blockaddress] = ACTIONS(397),
    [anon_sym_mul] = ACTIONS(397),
    [anon_sym_urem] = ACTIONS(397),
    [anon_sym_srem] = ACTIONS(397),
    [anon_sym_shl] = ACTIONS(397),
    [anon_sym_udiv] = ACTIONS(397),
    [anon_sym_sdiv] = ACTIONS(397),
    [anon_sym_lshr] = ACTIONS(397),
    [anon_sym_ashr] = ACTIONS(397),
    [anon_sym_fmul] = ACTIONS(397),
    [anon_sym_fdiv] = ACTIONS(397),
    [anon_sym_frem] = ACTIONS(397),
    [anon_sym_xchg] = ACTIONS(397),
    [anon_sym_add] = ACTIONS(397),
    [anon_sym_sub] = ACTIONS(397),
    [anon_sym_and] = ACTIONS(397),
    [anon_sym_nand] = ACTIONS(397),
    [anon_sym_or] = ACTIONS(397),
    [anon_sym_xor] = ACTIONS(397),
    [anon_sym_max] = ACTIONS(397),
    [anon_sym_min] = ACTIONS(397),
    [anon_sym_umax] = ACTIONS(397),
    [anon_sym_umin] = ACTIONS(397),
    [anon_sym_fadd] = ACTIONS(397),
    [anon_sym_fsub] = ACTIONS(397),
    [anon_sym_bitcast] = ACTIONS(397),
    [anon_sym_trunc] = ACTIONS(397),
    [anon_sym_zext] = ACTIONS(397),
    [anon_sym_sext] = ACTIONS(397),
    [anon_sym_fptrunc] = ACTIONS(397),
    [anon_sym_fpext] = ACTIONS(397),
    [anon_sym_addrspacecast] = ACTIONS(397),
    [anon_sym_uitofp] = ACTIONS(397),
    [anon_sym_sitofp] = ACTIONS(397),
    [anon_sym_fptoui] = ACTIONS(397),
    [anon_sym_fptosi] = ACTIONS(397),
    [anon_sym_inttoptr] = ACTIONS(397),
    [anon_sym_ptrtoint] = ACTIONS(397),
    [anon_sym_unordered] = ACTIONS(397),
    [anon_sym_monotonic] = ACTIONS(397),
    [anon_sym_acquire] = ACTIONS(397),
    [anon_sym_release] = ACTIONS(397),
    [anon_sym_acq_rel] = ACTIONS(397),
    [anon_sym_seq_cst] = ACTIONS(397),
    [anon_sym_syncscope] = ACTIONS(397),
    [anon_sym_uselistorder] = ACTIONS(397),
  },
  [366] = {
    [sym_metadata_ref] = STATE(100),
    [sym_type] = STATE(292),
    [sym_type_keyword] = STATE(260),
    [sym_struct_type] = STATE(260),
    [sym_packed_struct_type] = STATE(260),
    [sym_array_type] = STATE(260),
    [sym_vector_type] = STATE(260),
    [sym_param_or_return_attrs] = STATE(405),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_type_and_value] = STATE(134),
    [sym_metadata] = STATE(1531),
    [sym_metadata_tuple] = STATE(134),
    [sym_specialized_md] = STATE(134),
    [aux_sym_function_header_repeat2] = STATE(405),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [aux_sym_metadata_ref_token1] = ACTIONS(13),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(440),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_COMMA] = ACTIONS(482),
    [anon_sym_RPAREN] = ACTIONS(482),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_null] = ACTIONS(230),
    [anon_sym_BANG] = ACTIONS(232),
  },
  [367] = {
    [sym_instruction] = STATE(368),
    [sym__instruction_body] = STATE(573),
    [sym_instruction_unreachable] = STATE(573),
    [sym_instruction_ret] = STATE(573),
    [sym_instruction_br] = STATE(573),
    [sym_instruction_resume] = STATE(573),
    [sym_instruction_freeze] = STATE(573),
    [sym_instruction_indirectbr] = STATE(573),
    [sym_instruction_extractelement] = STATE(573),
    [sym_instruction_insertelement] = STATE(573),
    [sym_instruction_select] = STATE(573),
    [sym_instruction_shufflevector] = STATE(573),
    [sym_instruction_fneg] = STATE(573),
    [sym_instruction_bin_op] = STATE(573),
    [sym_instruction_switch] = STATE(573),
    [sym_instruction_invoke] = STATE(573),
    [sym_instruction_cleanupret] = STATE(573),
    [sym_instruction_catchret] = STATE(573),
    [sym_instruction_catchswitch] = STATE(573),
    [sym_instruction_catchpad] = STATE(573),
    [sym_instruction_cleanuppad] = STATE(573),
    [sym_instruction_callbr] = STATE(573),
    [sym_instruction_icmp] = STATE(573),
    [sym_instruction_fcmp] = STATE(573),
    [sym_instruction_cast] = STATE(573),
    [sym_instruction_va_arg] = STATE(573),
    [sym_instruction_phi] = STATE(573),
    [sym_instruction_landingpad] = STATE(573),
    [sym_instruction_call] = STATE(573),
    [sym_instruction_alloca] = STATE(573),
    [sym_instruction_load] = STATE(573),
    [sym_instruction_store] = STATE(573),
    [sym_instruction_cmpxchg] = STATE(573),
    [sym_instruction_atomicrmw] = STATE(573),
    [sym_instruction_fence] = STATE(573),
    [sym_instruction_getelementptr] = STATE(573),
    [sym_instruction_extractvalue] = STATE(573),
    [sym_instruction_insertvalue] = STATE(573),
    [sym_bin_op_keyword] = STATE(729),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(835),
    [sym_use_list_order] = STATE(1222),
    [aux_sym_function_body_repeat1] = STATE(368),
    [aux_sym_function_body_repeat2] = STATE(1222),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1068),
    [sym_label] = ACTIONS(1070),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_unreachable] = ACTIONS(1074),
    [anon_sym_ret] = ACTIONS(1076),
    [anon_sym_br] = ACTIONS(1078),
    [anon_sym_resume] = ACTIONS(1080),
    [anon_sym_freeze] = ACTIONS(1082),
    [anon_sym_indirectbr] = ACTIONS(1084),
    [anon_sym_extractelement] = ACTIONS(1086),
    [anon_sym_insertelement] = ACTIONS(1088),
    [anon_sym_select] = ACTIONS(1090),
    [anon_sym_shufflevector] = ACTIONS(1092),
    [anon_sym_fneg] = ACTIONS(1094),
    [anon_sym_switch] = ACTIONS(1096),
    [anon_sym_invoke] = ACTIONS(1098),
    [anon_sym_cleanupret] = ACTIONS(1100),
    [anon_sym_catchret] = ACTIONS(1102),
    [anon_sym_catchswitch] = ACTIONS(1104),
    [anon_sym_catchpad] = ACTIONS(1106),
    [anon_sym_cleanuppad] = ACTIONS(1108),
    [anon_sym_callbr] = ACTIONS(1110),
    [anon_sym_icmp] = ACTIONS(1112),
    [anon_sym_fcmp] = ACTIONS(1114),
    [anon_sym_va_arg] = ACTIONS(1116),
    [anon_sym_phi] = ACTIONS(1118),
    [anon_sym_landingpad] = ACTIONS(1120),
    [anon_sym_tail] = ACTIONS(1122),
    [anon_sym_musttail] = ACTIONS(1122),
    [anon_sym_notail] = ACTIONS(1122),
    [anon_sym_call] = ACTIONS(1124),
    [anon_sym_alloca] = ACTIONS(1126),
    [anon_sym_load] = ACTIONS(1128),
    [anon_sym_store] = ACTIONS(1130),
    [anon_sym_cmpxchg] = ACTIONS(1132),
    [anon_sym_atomicrmw] = ACTIONS(1134),
    [anon_sym_fence] = ACTIONS(1136),
    [anon_sym_getelementptr] = ACTIONS(1138),
    [anon_sym_extractvalue] = ACTIONS(1140),
    [anon_sym_insertvalue] = ACTIONS(1142),
    [anon_sym_mul] = ACTIONS(1144),
    [anon_sym_urem] = ACTIONS(1144),
    [anon_sym_srem] = ACTIONS(1144),
    [anon_sym_shl] = ACTIONS(1144),
    [anon_sym_udiv] = ACTIONS(1144),
    [anon_sym_sdiv] = ACTIONS(1144),
    [anon_sym_lshr] = ACTIONS(1144),
    [anon_sym_ashr] = ACTIONS(1144),
    [anon_sym_fmul] = ACTIONS(1144),
    [anon_sym_fdiv] = ACTIONS(1144),
    [anon_sym_frem] = ACTIONS(1144),
    [anon_sym_xchg] = ACTIONS(112),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(112),
    [anon_sym_and] = ACTIONS(112),
    [anon_sym_nand] = ACTIONS(112),
    [anon_sym_or] = ACTIONS(112),
    [anon_sym_xor] = ACTIONS(112),
    [anon_sym_max] = ACTIONS(112),
    [anon_sym_min] = ACTIONS(112),
    [anon_sym_umax] = ACTIONS(112),
    [anon_sym_umin] = ACTIONS(112),
    [anon_sym_fadd] = ACTIONS(112),
    [anon_sym_fsub] = ACTIONS(112),
    [anon_sym_bitcast] = ACTIONS(1146),
    [anon_sym_trunc] = ACTIONS(1146),
    [anon_sym_zext] = ACTIONS(1146),
    [anon_sym_sext] = ACTIONS(1146),
    [anon_sym_fptrunc] = ACTIONS(1146),
    [anon_sym_fpext] = ACTIONS(1146),
    [anon_sym_addrspacecast] = ACTIONS(1146),
    [anon_sym_uitofp] = ACTIONS(1146),
    [anon_sym_sitofp] = ACTIONS(1146),
    [anon_sym_fptoui] = ACTIONS(1146),
    [anon_sym_fptosi] = ACTIONS(1146),
    [anon_sym_inttoptr] = ACTIONS(1146),
    [anon_sym_ptrtoint] = ACTIONS(1146),
    [anon_sym_uselistorder] = ACTIONS(25),
  },
  [368] = {
    [sym_instruction] = STATE(369),
    [sym__instruction_body] = STATE(573),
    [sym_instruction_unreachable] = STATE(573),
    [sym_instruction_ret] = STATE(573),
    [sym_instruction_br] = STATE(573),
    [sym_instruction_resume] = STATE(573),
    [sym_instruction_freeze] = STATE(573),
    [sym_instruction_indirectbr] = STATE(573),
    [sym_instruction_extractelement] = STATE(573),
    [sym_instruction_insertelement] = STATE(573),
    [sym_instruction_select] = STATE(573),
    [sym_instruction_shufflevector] = STATE(573),
    [sym_instruction_fneg] = STATE(573),
    [sym_instruction_bin_op] = STATE(573),
    [sym_instruction_switch] = STATE(573),
    [sym_instruction_invoke] = STATE(573),
    [sym_instruction_cleanupret] = STATE(573),
    [sym_instruction_catchret] = STATE(573),
    [sym_instruction_catchswitch] = STATE(573),
    [sym_instruction_catchpad] = STATE(573),
    [sym_instruction_cleanuppad] = STATE(573),
    [sym_instruction_callbr] = STATE(573),
    [sym_instruction_icmp] = STATE(573),
    [sym_instruction_fcmp] = STATE(573),
    [sym_instruction_cast] = STATE(573),
    [sym_instruction_va_arg] = STATE(573),
    [sym_instruction_phi] = STATE(573),
    [sym_instruction_landingpad] = STATE(573),
    [sym_instruction_call] = STATE(573),
    [sym_instruction_alloca] = STATE(573),
    [sym_instruction_load] = STATE(573),
    [sym_instruction_store] = STATE(573),
    [sym_instruction_cmpxchg] = STATE(573),
    [sym_instruction_atomicrmw] = STATE(573),
    [sym_instruction_fence] = STATE(573),
    [sym_instruction_getelementptr] = STATE(573),
    [sym_instruction_extractvalue] = STATE(573),
    [sym_instruction_insertvalue] = STATE(573),
    [sym_bin_op_keyword] = STATE(729),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(835),
    [sym_use_list_order] = STATE(1227),
    [aux_sym_function_body_repeat1] = STATE(369),
    [aux_sym_function_body_repeat2] = STATE(1227),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1068),
    [sym_label] = ACTIONS(1148),
    [anon_sym_RBRACE] = ACTIONS(1150),
    [anon_sym_unreachable] = ACTIONS(1074),
    [anon_sym_ret] = ACTIONS(1076),
    [anon_sym_br] = ACTIONS(1078),
    [anon_sym_resume] = ACTIONS(1080),
    [anon_sym_freeze] = ACTIONS(1082),
    [anon_sym_indirectbr] = ACTIONS(1084),
    [anon_sym_extractelement] = ACTIONS(1086),
    [anon_sym_insertelement] = ACTIONS(1088),
    [anon_sym_select] = ACTIONS(1090),
    [anon_sym_shufflevector] = ACTIONS(1092),
    [anon_sym_fneg] = ACTIONS(1094),
    [anon_sym_switch] = ACTIONS(1096),
    [anon_sym_invoke] = ACTIONS(1098),
    [anon_sym_cleanupret] = ACTIONS(1100),
    [anon_sym_catchret] = ACTIONS(1102),
    [anon_sym_catchswitch] = ACTIONS(1104),
    [anon_sym_catchpad] = ACTIONS(1106),
    [anon_sym_cleanuppad] = ACTIONS(1108),
    [anon_sym_callbr] = ACTIONS(1110),
    [anon_sym_icmp] = ACTIONS(1112),
    [anon_sym_fcmp] = ACTIONS(1114),
    [anon_sym_va_arg] = ACTIONS(1116),
    [anon_sym_phi] = ACTIONS(1118),
    [anon_sym_landingpad] = ACTIONS(1120),
    [anon_sym_tail] = ACTIONS(1122),
    [anon_sym_musttail] = ACTIONS(1122),
    [anon_sym_notail] = ACTIONS(1122),
    [anon_sym_call] = ACTIONS(1124),
    [anon_sym_alloca] = ACTIONS(1126),
    [anon_sym_load] = ACTIONS(1128),
    [anon_sym_store] = ACTIONS(1130),
    [anon_sym_cmpxchg] = ACTIONS(1132),
    [anon_sym_atomicrmw] = ACTIONS(1134),
    [anon_sym_fence] = ACTIONS(1136),
    [anon_sym_getelementptr] = ACTIONS(1138),
    [anon_sym_extractvalue] = ACTIONS(1140),
    [anon_sym_insertvalue] = ACTIONS(1142),
    [anon_sym_mul] = ACTIONS(1144),
    [anon_sym_urem] = ACTIONS(1144),
    [anon_sym_srem] = ACTIONS(1144),
    [anon_sym_shl] = ACTIONS(1144),
    [anon_sym_udiv] = ACTIONS(1144),
    [anon_sym_sdiv] = ACTIONS(1144),
    [anon_sym_lshr] = ACTIONS(1144),
    [anon_sym_ashr] = ACTIONS(1144),
    [anon_sym_fmul] = ACTIONS(1144),
    [anon_sym_fdiv] = ACTIONS(1144),
    [anon_sym_frem] = ACTIONS(1144),
    [anon_sym_xchg] = ACTIONS(112),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(112),
    [anon_sym_and] = ACTIONS(112),
    [anon_sym_nand] = ACTIONS(112),
    [anon_sym_or] = ACTIONS(112),
    [anon_sym_xor] = ACTIONS(112),
    [anon_sym_max] = ACTIONS(112),
    [anon_sym_min] = ACTIONS(112),
    [anon_sym_umax] = ACTIONS(112),
    [anon_sym_umin] = ACTIONS(112),
    [anon_sym_fadd] = ACTIONS(112),
    [anon_sym_fsub] = ACTIONS(112),
    [anon_sym_bitcast] = ACTIONS(1146),
    [anon_sym_trunc] = ACTIONS(1146),
    [anon_sym_zext] = ACTIONS(1146),
    [anon_sym_sext] = ACTIONS(1146),
    [anon_sym_fptrunc] = ACTIONS(1146),
    [anon_sym_fpext] = ACTIONS(1146),
    [anon_sym_addrspacecast] = ACTIONS(1146),
    [anon_sym_uitofp] = ACTIONS(1146),
    [anon_sym_sitofp] = ACTIONS(1146),
    [anon_sym_fptoui] = ACTIONS(1146),
    [anon_sym_fptosi] = ACTIONS(1146),
    [anon_sym_inttoptr] = ACTIONS(1146),
    [anon_sym_ptrtoint] = ACTIONS(1146),
    [anon_sym_uselistorder] = ACTIONS(25),
  },
  [369] = {
    [sym_instruction] = STATE(369),
    [sym__instruction_body] = STATE(573),
    [sym_instruction_unreachable] = STATE(573),
    [sym_instruction_ret] = STATE(573),
    [sym_instruction_br] = STATE(573),
    [sym_instruction_resume] = STATE(573),
    [sym_instruction_freeze] = STATE(573),
    [sym_instruction_indirectbr] = STATE(573),
    [sym_instruction_extractelement] = STATE(573),
    [sym_instruction_insertelement] = STATE(573),
    [sym_instruction_select] = STATE(573),
    [sym_instruction_shufflevector] = STATE(573),
    [sym_instruction_fneg] = STATE(573),
    [sym_instruction_bin_op] = STATE(573),
    [sym_instruction_switch] = STATE(573),
    [sym_instruction_invoke] = STATE(573),
    [sym_instruction_cleanupret] = STATE(573),
    [sym_instruction_catchret] = STATE(573),
    [sym_instruction_catchswitch] = STATE(573),
    [sym_instruction_catchpad] = STATE(573),
    [sym_instruction_cleanuppad] = STATE(573),
    [sym_instruction_callbr] = STATE(573),
    [sym_instruction_icmp] = STATE(573),
    [sym_instruction_fcmp] = STATE(573),
    [sym_instruction_cast] = STATE(573),
    [sym_instruction_va_arg] = STATE(573),
    [sym_instruction_phi] = STATE(573),
    [sym_instruction_landingpad] = STATE(573),
    [sym_instruction_call] = STATE(573),
    [sym_instruction_alloca] = STATE(573),
    [sym_instruction_load] = STATE(573),
    [sym_instruction_store] = STATE(573),
    [sym_instruction_cmpxchg] = STATE(573),
    [sym_instruction_atomicrmw] = STATE(573),
    [sym_instruction_fence] = STATE(573),
    [sym_instruction_getelementptr] = STATE(573),
    [sym_instruction_extractvalue] = STATE(573),
    [sym_instruction_insertvalue] = STATE(573),
    [sym_bin_op_keyword] = STATE(729),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(835),
    [aux_sym_function_body_repeat1] = STATE(369),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1152),
    [sym_label] = ACTIONS(1155),
    [anon_sym_RBRACE] = ACTIONS(1158),
    [anon_sym_unreachable] = ACTIONS(1160),
    [anon_sym_ret] = ACTIONS(1163),
    [anon_sym_br] = ACTIONS(1166),
    [anon_sym_resume] = ACTIONS(1169),
    [anon_sym_freeze] = ACTIONS(1172),
    [anon_sym_indirectbr] = ACTIONS(1175),
    [anon_sym_extractelement] = ACTIONS(1178),
    [anon_sym_insertelement] = ACTIONS(1181),
    [anon_sym_select] = ACTIONS(1184),
    [anon_sym_shufflevector] = ACTIONS(1187),
    [anon_sym_fneg] = ACTIONS(1190),
    [anon_sym_switch] = ACTIONS(1193),
    [anon_sym_invoke] = ACTIONS(1196),
    [anon_sym_cleanupret] = ACTIONS(1199),
    [anon_sym_catchret] = ACTIONS(1202),
    [anon_sym_catchswitch] = ACTIONS(1205),
    [anon_sym_catchpad] = ACTIONS(1208),
    [anon_sym_cleanuppad] = ACTIONS(1211),
    [anon_sym_callbr] = ACTIONS(1214),
    [anon_sym_icmp] = ACTIONS(1217),
    [anon_sym_fcmp] = ACTIONS(1220),
    [anon_sym_va_arg] = ACTIONS(1223),
    [anon_sym_phi] = ACTIONS(1226),
    [anon_sym_landingpad] = ACTIONS(1229),
    [anon_sym_tail] = ACTIONS(1232),
    [anon_sym_musttail] = ACTIONS(1232),
    [anon_sym_notail] = ACTIONS(1232),
    [anon_sym_call] = ACTIONS(1235),
    [anon_sym_alloca] = ACTIONS(1238),
    [anon_sym_load] = ACTIONS(1241),
    [anon_sym_store] = ACTIONS(1244),
    [anon_sym_cmpxchg] = ACTIONS(1247),
    [anon_sym_atomicrmw] = ACTIONS(1250),
    [anon_sym_fence] = ACTIONS(1253),
    [anon_sym_getelementptr] = ACTIONS(1256),
    [anon_sym_extractvalue] = ACTIONS(1259),
    [anon_sym_insertvalue] = ACTIONS(1262),
    [anon_sym_mul] = ACTIONS(1265),
    [anon_sym_urem] = ACTIONS(1265),
    [anon_sym_srem] = ACTIONS(1265),
    [anon_sym_shl] = ACTIONS(1265),
    [anon_sym_udiv] = ACTIONS(1265),
    [anon_sym_sdiv] = ACTIONS(1265),
    [anon_sym_lshr] = ACTIONS(1265),
    [anon_sym_ashr] = ACTIONS(1265),
    [anon_sym_fmul] = ACTIONS(1265),
    [anon_sym_fdiv] = ACTIONS(1265),
    [anon_sym_frem] = ACTIONS(1265),
    [anon_sym_xchg] = ACTIONS(1268),
    [anon_sym_add] = ACTIONS(1268),
    [anon_sym_sub] = ACTIONS(1268),
    [anon_sym_and] = ACTIONS(1268),
    [anon_sym_nand] = ACTIONS(1268),
    [anon_sym_or] = ACTIONS(1268),
    [anon_sym_xor] = ACTIONS(1268),
    [anon_sym_max] = ACTIONS(1268),
    [anon_sym_min] = ACTIONS(1268),
    [anon_sym_umax] = ACTIONS(1268),
    [anon_sym_umin] = ACTIONS(1268),
    [anon_sym_fadd] = ACTIONS(1268),
    [anon_sym_fsub] = ACTIONS(1268),
    [anon_sym_bitcast] = ACTIONS(1271),
    [anon_sym_trunc] = ACTIONS(1271),
    [anon_sym_zext] = ACTIONS(1271),
    [anon_sym_sext] = ACTIONS(1271),
    [anon_sym_fptrunc] = ACTIONS(1271),
    [anon_sym_fpext] = ACTIONS(1271),
    [anon_sym_addrspacecast] = ACTIONS(1271),
    [anon_sym_uitofp] = ACTIONS(1271),
    [anon_sym_sitofp] = ACTIONS(1271),
    [anon_sym_fptoui] = ACTIONS(1271),
    [anon_sym_fptosi] = ACTIONS(1271),
    [anon_sym_inttoptr] = ACTIONS(1271),
    [anon_sym_ptrtoint] = ACTIONS(1271),
    [anon_sym_uselistorder] = ACTIONS(1274),
  },
  [370] = {
    [sym_metadata_ref] = STATE(1309),
    [sym_type] = STATE(372),
    [sym_type_keyword] = STATE(545),
    [sym_struct_type] = STATE(545),
    [sym_packed_struct_type] = STATE(545),
    [sym_array_type] = STATE(545),
    [sym_vector_type] = STATE(545),
    [sym_type_and_value] = STATE(1475),
    [sym_metadata] = STATE(1476),
    [sym_metadata_tuple] = STATE(1475),
    [sym_specialized_md] = STATE(1475),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(1276),
    [aux_sym_metadata_ref_token1] = ACTIONS(1278),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(1280),
    [anon_sym_half] = ACTIONS(1280),
    [anon_sym_bfloat] = ACTIONS(1280),
    [anon_sym_float] = ACTIONS(1280),
    [anon_sym_double] = ACTIONS(1280),
    [anon_sym_x86_fp80] = ACTIONS(1280),
    [anon_sym_fp128] = ACTIONS(1280),
    [anon_sym_ppc_fp128] = ACTIONS(1280),
    [anon_sym_label] = ACTIONS(1280),
    [anon_sym_metadata] = ACTIONS(1282),
    [anon_sym_x86_mmx] = ACTIONS(1280),
    [anon_sym_x86_amx] = ACTIONS(1280),
    [anon_sym_token] = ACTIONS(1280),
    [anon_sym_opaque] = ACTIONS(1280),
    [anon_sym_ptr] = ACTIONS(1284),
    [aux_sym_type_keyword_token1] = ACTIONS(1280),
    [anon_sym_LBRACE] = ACTIONS(1286),
    [anon_sym_LT_LBRACE] = ACTIONS(1288),
    [anon_sym_RBRACE_GT] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(1292),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(1294),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(116),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(1296),
  },
  [371] = {
    [sym_number] = STATE(92),
    [sym_var] = STATE(92),
    [sym_linkage] = STATE(817),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(1498),
    [sym__primitive_value] = STATE(92),
    [sym_struct_value] = STATE(92),
    [sym_packed_struct_value] = STATE(92),
    [sym_array_value] = STATE(92),
    [sym_vector_value] = STATE(92),
    [sym_blockaddress] = STATE(92),
    [sym_constant_expr] = STATE(92),
    [sym_constant_cast] = STATE(87),
    [sym_constant_getelementptr] = STATE(87),
    [sym_constant_select] = STATE(87),
    [sym_constant_icmp] = STATE(87),
    [sym_constant_fcmp] = STATE(87),
    [sym_constant_extractelement] = STATE(87),
    [sym_constant_insertelement] = STATE(87),
    [sym_constant_shufflevector] = STATE(87),
    [sym_constant_extractvalue] = STATE(87),
    [sym_constant_insertvalue] = STATE(87),
    [sym_constant_fneg] = STATE(87),
    [sym_constant_bin_op] = STATE(87),
    [sym_bin_op_keyword] = STATE(1122),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1597),
    [sym_inline_asm] = STATE(1498),
    [aux_sym_function_header_repeat1] = STATE(817),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_LT_LBRACE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_LT] = ACTIONS(470),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
    [anon_sym_asm] = ACTIONS(1298),
  },
  [372] = {
    [sym_number] = STATE(1478),
    [sym_var] = STATE(1478),
    [sym_linkage] = STATE(819),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(1480),
    [sym__primitive_value] = STATE(1478),
    [sym_struct_value] = STATE(1478),
    [sym_packed_struct_value] = STATE(1478),
    [sym_array_value] = STATE(1478),
    [sym_vector_value] = STATE(1478),
    [sym_blockaddress] = STATE(1478),
    [sym_constant_expr] = STATE(1478),
    [sym_constant_cast] = STATE(1483),
    [sym_constant_getelementptr] = STATE(1483),
    [sym_constant_select] = STATE(1483),
    [sym_constant_icmp] = STATE(1483),
    [sym_constant_fcmp] = STATE(1483),
    [sym_constant_extractelement] = STATE(1483),
    [sym_constant_insertelement] = STATE(1483),
    [sym_constant_shufflevector] = STATE(1483),
    [sym_constant_extractvalue] = STATE(1483),
    [sym_constant_insertvalue] = STATE(1483),
    [sym_constant_fneg] = STATE(1483),
    [sym_constant_bin_op] = STATE(1483),
    [sym_bin_op_keyword] = STATE(1127),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1939),
    [aux_sym_function_header_repeat1] = STATE(819),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(1300),
    [sym_local_var] = ACTIONS(1300),
    [sym_string] = ACTIONS(1302),
    [aux_sym_number_token1] = ACTIONS(1304),
    [aux_sym_number_token2] = ACTIONS(1306),
    [sym_float] = ACTIONS(1302),
    [sym_cstring] = ACTIONS(1302),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(1308),
    [anon_sym_LT_LBRACE] = ACTIONS(1310),
    [anon_sym_RBRACE_GT] = ACTIONS(38),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LT] = ACTIONS(1314),
    [anon_sym_COMMA] = ACTIONS(38),
    [anon_sym_none] = ACTIONS(1302),
    [anon_sym_extractelement] = ACTIONS(1316),
    [anon_sym_insertelement] = ACTIONS(1318),
    [anon_sym_select] = ACTIONS(1320),
    [anon_sym_shufflevector] = ACTIONS(1322),
    [anon_sym_fneg] = ACTIONS(1324),
    [anon_sym_icmp] = ACTIONS(1326),
    [anon_sym_fcmp] = ACTIONS(1328),
    [anon_sym_getelementptr] = ACTIONS(1330),
    [anon_sym_extractvalue] = ACTIONS(1332),
    [anon_sym_insertvalue] = ACTIONS(1334),
    [anon_sym_true] = ACTIONS(1302),
    [anon_sym_false] = ACTIONS(1302),
    [anon_sym_null] = ACTIONS(1302),
    [anon_sym_undef] = ACTIONS(1302),
    [anon_sym_poison] = ACTIONS(1302),
    [anon_sym_zeroinitializer] = ACTIONS(1302),
    [anon_sym_blockaddress] = ACTIONS(1336),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [373] = {
    [sym_number] = STATE(92),
    [sym_var] = STATE(92),
    [sym_linkage] = STATE(817),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(1517),
    [sym__primitive_value] = STATE(92),
    [sym_struct_value] = STATE(92),
    [sym_packed_struct_value] = STATE(92),
    [sym_array_value] = STATE(92),
    [sym_vector_value] = STATE(92),
    [sym_blockaddress] = STATE(92),
    [sym_constant_expr] = STATE(92),
    [sym_constant_cast] = STATE(87),
    [sym_constant_getelementptr] = STATE(87),
    [sym_constant_select] = STATE(87),
    [sym_constant_icmp] = STATE(87),
    [sym_constant_fcmp] = STATE(87),
    [sym_constant_extractelement] = STATE(87),
    [sym_constant_insertelement] = STATE(87),
    [sym_constant_shufflevector] = STATE(87),
    [sym_constant_extractvalue] = STATE(87),
    [sym_constant_insertvalue] = STATE(87),
    [sym_constant_fneg] = STATE(87),
    [sym_constant_bin_op] = STATE(87),
    [sym_bin_op_keyword] = STATE(1122),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1597),
    [sym_inline_asm] = STATE(1517),
    [aux_sym_function_header_repeat1] = STATE(817),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_LT_LBRACE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_LT] = ACTIONS(470),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
    [anon_sym_asm] = ACTIONS(1298),
  },
  [374] = {
    [sym_number] = STATE(92),
    [sym_var] = STATE(92),
    [sym_linkage] = STATE(817),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(1530),
    [sym__primitive_value] = STATE(92),
    [sym_struct_value] = STATE(92),
    [sym_packed_struct_value] = STATE(92),
    [sym_array_value] = STATE(92),
    [sym_vector_value] = STATE(92),
    [sym_blockaddress] = STATE(92),
    [sym_constant_expr] = STATE(92),
    [sym_constant_cast] = STATE(87),
    [sym_constant_getelementptr] = STATE(87),
    [sym_constant_select] = STATE(87),
    [sym_constant_icmp] = STATE(87),
    [sym_constant_fcmp] = STATE(87),
    [sym_constant_extractelement] = STATE(87),
    [sym_constant_insertelement] = STATE(87),
    [sym_constant_shufflevector] = STATE(87),
    [sym_constant_extractvalue] = STATE(87),
    [sym_constant_insertvalue] = STATE(87),
    [sym_constant_fneg] = STATE(87),
    [sym_constant_bin_op] = STATE(87),
    [sym_bin_op_keyword] = STATE(1122),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1597),
    [sym_inline_asm] = STATE(1530),
    [aux_sym_function_header_repeat1] = STATE(817),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_LT_LBRACE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_LT] = ACTIONS(470),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
    [anon_sym_asm] = ACTIONS(1298),
  },
  [375] = {
    [sym_number] = STATE(92),
    [sym_var] = STATE(92),
    [sym_linkage] = STATE(817),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(1568),
    [sym__primitive_value] = STATE(92),
    [sym_struct_value] = STATE(92),
    [sym_packed_struct_value] = STATE(92),
    [sym_array_value] = STATE(92),
    [sym_vector_value] = STATE(92),
    [sym_blockaddress] = STATE(92),
    [sym_constant_expr] = STATE(92),
    [sym_constant_cast] = STATE(87),
    [sym_constant_getelementptr] = STATE(87),
    [sym_constant_select] = STATE(87),
    [sym_constant_icmp] = STATE(87),
    [sym_constant_fcmp] = STATE(87),
    [sym_constant_extractelement] = STATE(87),
    [sym_constant_insertelement] = STATE(87),
    [sym_constant_shufflevector] = STATE(87),
    [sym_constant_extractvalue] = STATE(87),
    [sym_constant_insertvalue] = STATE(87),
    [sym_constant_fneg] = STATE(87),
    [sym_constant_bin_op] = STATE(87),
    [sym_bin_op_keyword] = STATE(1122),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1597),
    [sym_inline_asm] = STATE(1568),
    [aux_sym_function_header_repeat1] = STATE(817),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_LT_LBRACE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_LT] = ACTIONS(470),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
    [anon_sym_asm] = ACTIONS(1298),
  },
  [376] = {
    [sym_metadata_ref] = STATE(302),
    [sym_type] = STATE(282),
    [sym_type_keyword] = STATE(260),
    [sym_struct_type] = STATE(260),
    [sym_packed_struct_type] = STATE(260),
    [sym_array_type] = STATE(260),
    [sym_vector_type] = STATE(260),
    [sym_type_and_value] = STATE(326),
    [sym_metadata] = STATE(339),
    [sym_metadata_tuple] = STATE(326),
    [sym_specialized_md] = STATE(326),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(436),
    [aux_sym_metadata_ref_token1] = ACTIONS(285),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(1338),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(442),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_RBRACK] = ACTIONS(116),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(1340),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(116),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(303),
  },
  [377] = {
    [sym_number] = STATE(92),
    [sym_var] = STATE(92),
    [sym_linkage] = STATE(817),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(1472),
    [sym__primitive_value] = STATE(92),
    [sym_struct_value] = STATE(92),
    [sym_packed_struct_value] = STATE(92),
    [sym_array_value] = STATE(92),
    [sym_vector_value] = STATE(92),
    [sym_blockaddress] = STATE(92),
    [sym_constant_expr] = STATE(92),
    [sym_constant_cast] = STATE(87),
    [sym_constant_getelementptr] = STATE(87),
    [sym_constant_select] = STATE(87),
    [sym_constant_icmp] = STATE(87),
    [sym_constant_fcmp] = STATE(87),
    [sym_constant_extractelement] = STATE(87),
    [sym_constant_insertelement] = STATE(87),
    [sym_constant_shufflevector] = STATE(87),
    [sym_constant_extractvalue] = STATE(87),
    [sym_constant_insertvalue] = STATE(87),
    [sym_constant_fneg] = STATE(87),
    [sym_constant_bin_op] = STATE(87),
    [sym_bin_op_keyword] = STATE(1122),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1597),
    [sym_inline_asm] = STATE(1472),
    [aux_sym_function_header_repeat1] = STATE(817),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_LT_LBRACE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_LT] = ACTIONS(470),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
    [anon_sym_asm] = ACTIONS(1298),
  },
  [378] = {
    [sym_number] = STATE(92),
    [sym_var] = STATE(92),
    [sym_linkage] = STATE(817),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(1497),
    [sym__primitive_value] = STATE(92),
    [sym_struct_value] = STATE(92),
    [sym_packed_struct_value] = STATE(92),
    [sym_array_value] = STATE(92),
    [sym_vector_value] = STATE(92),
    [sym_blockaddress] = STATE(92),
    [sym_constant_expr] = STATE(92),
    [sym_constant_cast] = STATE(87),
    [sym_constant_getelementptr] = STATE(87),
    [sym_constant_select] = STATE(87),
    [sym_constant_icmp] = STATE(87),
    [sym_constant_fcmp] = STATE(87),
    [sym_constant_extractelement] = STATE(87),
    [sym_constant_insertelement] = STATE(87),
    [sym_constant_shufflevector] = STATE(87),
    [sym_constant_extractvalue] = STATE(87),
    [sym_constant_insertvalue] = STATE(87),
    [sym_constant_fneg] = STATE(87),
    [sym_constant_bin_op] = STATE(87),
    [sym_bin_op_keyword] = STATE(1122),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1597),
    [sym_inline_asm] = STATE(1497),
    [aux_sym_function_header_repeat1] = STATE(817),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_LT_LBRACE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_LT] = ACTIONS(470),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
    [anon_sym_asm] = ACTIONS(1298),
  },
  [379] = {
    [sym_number] = STATE(92),
    [sym_var] = STATE(92),
    [sym_linkage] = STATE(817),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(1486),
    [sym__primitive_value] = STATE(92),
    [sym_struct_value] = STATE(92),
    [sym_packed_struct_value] = STATE(92),
    [sym_array_value] = STATE(92),
    [sym_vector_value] = STATE(92),
    [sym_blockaddress] = STATE(92),
    [sym_constant_expr] = STATE(92),
    [sym_constant_cast] = STATE(87),
    [sym_constant_getelementptr] = STATE(87),
    [sym_constant_select] = STATE(87),
    [sym_constant_icmp] = STATE(87),
    [sym_constant_fcmp] = STATE(87),
    [sym_constant_extractelement] = STATE(87),
    [sym_constant_insertelement] = STATE(87),
    [sym_constant_shufflevector] = STATE(87),
    [sym_constant_extractvalue] = STATE(87),
    [sym_constant_insertvalue] = STATE(87),
    [sym_constant_fneg] = STATE(87),
    [sym_constant_bin_op] = STATE(87),
    [sym_bin_op_keyword] = STATE(1122),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1597),
    [sym_inline_asm] = STATE(1486),
    [aux_sym_function_header_repeat1] = STATE(817),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_LT_LBRACE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_LT] = ACTIONS(470),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
    [anon_sym_asm] = ACTIONS(1298),
  },
  [380] = {
    [sym_number] = STATE(92),
    [sym_var] = STATE(92),
    [sym_linkage] = STATE(817),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(1487),
    [sym__primitive_value] = STATE(92),
    [sym_struct_value] = STATE(92),
    [sym_packed_struct_value] = STATE(92),
    [sym_array_value] = STATE(92),
    [sym_vector_value] = STATE(92),
    [sym_blockaddress] = STATE(92),
    [sym_constant_expr] = STATE(92),
    [sym_constant_cast] = STATE(87),
    [sym_constant_getelementptr] = STATE(87),
    [sym_constant_select] = STATE(87),
    [sym_constant_icmp] = STATE(87),
    [sym_constant_fcmp] = STATE(87),
    [sym_constant_extractelement] = STATE(87),
    [sym_constant_insertelement] = STATE(87),
    [sym_constant_shufflevector] = STATE(87),
    [sym_constant_extractvalue] = STATE(87),
    [sym_constant_insertvalue] = STATE(87),
    [sym_constant_fneg] = STATE(87),
    [sym_constant_bin_op] = STATE(87),
    [sym_bin_op_keyword] = STATE(1122),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1597),
    [sym_inline_asm] = STATE(1487),
    [aux_sym_function_header_repeat1] = STATE(817),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_LT_LBRACE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_LT] = ACTIONS(470),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
    [anon_sym_asm] = ACTIONS(1298),
  },
  [381] = {
    [sym_number] = STATE(92),
    [sym_var] = STATE(92),
    [sym_linkage] = STATE(817),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(136),
    [sym__primitive_value] = STATE(92),
    [sym_struct_value] = STATE(92),
    [sym_packed_struct_value] = STATE(92),
    [sym_array_value] = STATE(92),
    [sym_vector_value] = STATE(92),
    [sym_blockaddress] = STATE(92),
    [sym_constant_expr] = STATE(92),
    [sym_constant_cast] = STATE(87),
    [sym_constant_getelementptr] = STATE(87),
    [sym_constant_select] = STATE(87),
    [sym_constant_icmp] = STATE(87),
    [sym_constant_fcmp] = STATE(87),
    [sym_constant_extractelement] = STATE(87),
    [sym_constant_insertelement] = STATE(87),
    [sym_constant_shufflevector] = STATE(87),
    [sym_constant_extractvalue] = STATE(87),
    [sym_constant_insertvalue] = STATE(87),
    [sym_constant_fneg] = STATE(87),
    [sym_constant_bin_op] = STATE(87),
    [sym_bin_op_keyword] = STATE(1122),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1597),
    [aux_sym_function_header_repeat1] = STATE(817),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [aux_sym_metadata_ref_token1] = ACTIONS(38),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(72),
    [anon_sym_LT_LBRACE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_LT] = ACTIONS(470),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [382] = {
    [sym_metadata_ref] = STATE(100),
    [sym_type] = STATE(392),
    [sym_type_keyword] = STATE(260),
    [sym_struct_type] = STATE(260),
    [sym_packed_struct_type] = STATE(260),
    [sym_array_type] = STATE(260),
    [sym_vector_type] = STATE(260),
    [sym_type_and_value] = STATE(134),
    [sym_metadata] = STATE(126),
    [sym_metadata_tuple] = STATE(134),
    [sym_specialized_md] = STATE(134),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(436),
    [aux_sym_metadata_ref_token1] = ACTIONS(13),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(1342),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(442),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(1053),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(116),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(232),
  },
  [383] = {
    [sym_metadata_ref] = STATE(100),
    [sym_type] = STATE(381),
    [sym_type_keyword] = STATE(260),
    [sym_struct_type] = STATE(260),
    [sym_packed_struct_type] = STATE(260),
    [sym_array_type] = STATE(260),
    [sym_vector_type] = STATE(260),
    [sym_type_and_value] = STATE(134),
    [sym_metadata] = STATE(126),
    [sym_metadata_tuple] = STATE(134),
    [sym_specialized_md] = STATE(134),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(436),
    [aux_sym_metadata_ref_token1] = ACTIONS(13),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(1344),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(442),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(1053),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(116),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(232),
  },
  [384] = {
    [sym_number] = STATE(164),
    [sym_var] = STATE(164),
    [sym_linkage] = STATE(784),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(629),
    [sym__primitive_value] = STATE(164),
    [sym_struct_value] = STATE(164),
    [sym_packed_struct_value] = STATE(164),
    [sym_array_value] = STATE(164),
    [sym_vector_value] = STATE(164),
    [sym_blockaddress] = STATE(164),
    [sym_constant_expr] = STATE(164),
    [sym_constant_cast] = STATE(175),
    [sym_constant_getelementptr] = STATE(175),
    [sym_constant_select] = STATE(175),
    [sym_constant_icmp] = STATE(175),
    [sym_constant_fcmp] = STATE(175),
    [sym_constant_extractelement] = STATE(175),
    [sym_constant_insertelement] = STATE(175),
    [sym_constant_shufflevector] = STATE(175),
    [sym_constant_extractvalue] = STATE(175),
    [sym_constant_insertvalue] = STATE(175),
    [sym_constant_fneg] = STATE(175),
    [sym_constant_bin_op] = STATE(175),
    [sym_bin_op_keyword] = STATE(1106),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1954),
    [aux_sym_function_header_repeat1] = STATE(784),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(140),
    [sym_local_var] = ACTIONS(140),
    [sym_string] = ACTIONS(152),
    [aux_sym_number_token1] = ACTIONS(148),
    [aux_sym_number_token2] = ACTIONS(1346),
    [sym_float] = ACTIONS(152),
    [sym_cstring] = ACTIONS(152),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(164),
    [anon_sym_LT_LBRACE] = ACTIONS(166),
    [anon_sym_LBRACK] = ACTIONS(959),
    [anon_sym_LT] = ACTIONS(171),
    [anon_sym_none] = ACTIONS(152),
    [anon_sym_extractelement] = ACTIONS(1348),
    [anon_sym_insertelement] = ACTIONS(1350),
    [anon_sym_select] = ACTIONS(1352),
    [anon_sym_shufflevector] = ACTIONS(1354),
    [anon_sym_fneg] = ACTIONS(1356),
    [anon_sym_icmp] = ACTIONS(1358),
    [anon_sym_fcmp] = ACTIONS(1360),
    [anon_sym_getelementptr] = ACTIONS(1362),
    [anon_sym_extractvalue] = ACTIONS(1364),
    [anon_sym_insertvalue] = ACTIONS(1366),
    [anon_sym_true] = ACTIONS(152),
    [anon_sym_false] = ACTIONS(152),
    [anon_sym_null] = ACTIONS(152),
    [anon_sym_undef] = ACTIONS(152),
    [anon_sym_poison] = ACTIONS(152),
    [anon_sym_zeroinitializer] = ACTIONS(152),
    [anon_sym_blockaddress] = ACTIONS(1368),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [385] = {
    [sym_number] = STATE(92),
    [sym_var] = STATE(92),
    [sym_linkage] = STATE(817),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(1894),
    [sym__primitive_value] = STATE(92),
    [sym_struct_value] = STATE(92),
    [sym_packed_struct_value] = STATE(92),
    [sym_array_value] = STATE(92),
    [sym_vector_value] = STATE(92),
    [sym_blockaddress] = STATE(92),
    [sym_constant_expr] = STATE(92),
    [sym_constant_cast] = STATE(87),
    [sym_constant_getelementptr] = STATE(87),
    [sym_constant_select] = STATE(87),
    [sym_constant_icmp] = STATE(87),
    [sym_constant_fcmp] = STATE(87),
    [sym_constant_extractelement] = STATE(87),
    [sym_constant_insertelement] = STATE(87),
    [sym_constant_shufflevector] = STATE(87),
    [sym_constant_extractvalue] = STATE(87),
    [sym_constant_insertvalue] = STATE(87),
    [sym_constant_fneg] = STATE(87),
    [sym_constant_bin_op] = STATE(87),
    [sym_bin_op_keyword] = STATE(1122),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1597),
    [aux_sym_function_header_repeat1] = STATE(817),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_LT_LBRACE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_LT] = ACTIONS(470),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [386] = {
    [sym_number] = STATE(164),
    [sym_var] = STATE(164),
    [sym_linkage] = STATE(784),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(611),
    [sym__primitive_value] = STATE(164),
    [sym_struct_value] = STATE(164),
    [sym_packed_struct_value] = STATE(164),
    [sym_array_value] = STATE(164),
    [sym_vector_value] = STATE(164),
    [sym_blockaddress] = STATE(164),
    [sym_constant_expr] = STATE(164),
    [sym_constant_cast] = STATE(175),
    [sym_constant_getelementptr] = STATE(175),
    [sym_constant_select] = STATE(175),
    [sym_constant_icmp] = STATE(175),
    [sym_constant_fcmp] = STATE(175),
    [sym_constant_extractelement] = STATE(175),
    [sym_constant_insertelement] = STATE(175),
    [sym_constant_shufflevector] = STATE(175),
    [sym_constant_extractvalue] = STATE(175),
    [sym_constant_insertvalue] = STATE(175),
    [sym_constant_fneg] = STATE(175),
    [sym_constant_bin_op] = STATE(175),
    [sym_bin_op_keyword] = STATE(1106),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1954),
    [aux_sym_function_header_repeat1] = STATE(784),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(140),
    [sym_local_var] = ACTIONS(140),
    [sym_string] = ACTIONS(152),
    [aux_sym_number_token1] = ACTIONS(148),
    [aux_sym_number_token2] = ACTIONS(1346),
    [sym_float] = ACTIONS(152),
    [sym_cstring] = ACTIONS(152),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(164),
    [anon_sym_LT_LBRACE] = ACTIONS(166),
    [anon_sym_LBRACK] = ACTIONS(959),
    [anon_sym_LT] = ACTIONS(171),
    [anon_sym_none] = ACTIONS(152),
    [anon_sym_extractelement] = ACTIONS(1348),
    [anon_sym_insertelement] = ACTIONS(1350),
    [anon_sym_select] = ACTIONS(1352),
    [anon_sym_shufflevector] = ACTIONS(1354),
    [anon_sym_fneg] = ACTIONS(1356),
    [anon_sym_icmp] = ACTIONS(1358),
    [anon_sym_fcmp] = ACTIONS(1360),
    [anon_sym_getelementptr] = ACTIONS(1362),
    [anon_sym_extractvalue] = ACTIONS(1364),
    [anon_sym_insertvalue] = ACTIONS(1366),
    [anon_sym_true] = ACTIONS(152),
    [anon_sym_false] = ACTIONS(152),
    [anon_sym_null] = ACTIONS(152),
    [anon_sym_undef] = ACTIONS(152),
    [anon_sym_poison] = ACTIONS(152),
    [anon_sym_zeroinitializer] = ACTIONS(152),
    [anon_sym_blockaddress] = ACTIONS(1368),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [387] = {
    [sym_number] = STATE(164),
    [sym_var] = STATE(164),
    [sym_linkage] = STATE(784),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(634),
    [sym__primitive_value] = STATE(164),
    [sym_struct_value] = STATE(164),
    [sym_packed_struct_value] = STATE(164),
    [sym_array_value] = STATE(164),
    [sym_vector_value] = STATE(164),
    [sym_blockaddress] = STATE(164),
    [sym_constant_expr] = STATE(164),
    [sym_constant_cast] = STATE(175),
    [sym_constant_getelementptr] = STATE(175),
    [sym_constant_select] = STATE(175),
    [sym_constant_icmp] = STATE(175),
    [sym_constant_fcmp] = STATE(175),
    [sym_constant_extractelement] = STATE(175),
    [sym_constant_insertelement] = STATE(175),
    [sym_constant_shufflevector] = STATE(175),
    [sym_constant_extractvalue] = STATE(175),
    [sym_constant_insertvalue] = STATE(175),
    [sym_constant_fneg] = STATE(175),
    [sym_constant_bin_op] = STATE(175),
    [sym_bin_op_keyword] = STATE(1106),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1954),
    [aux_sym_function_header_repeat1] = STATE(784),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(140),
    [sym_local_var] = ACTIONS(140),
    [sym_string] = ACTIONS(152),
    [aux_sym_number_token1] = ACTIONS(148),
    [aux_sym_number_token2] = ACTIONS(1346),
    [sym_float] = ACTIONS(152),
    [sym_cstring] = ACTIONS(152),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(164),
    [anon_sym_LT_LBRACE] = ACTIONS(166),
    [anon_sym_LBRACK] = ACTIONS(959),
    [anon_sym_LT] = ACTIONS(171),
    [anon_sym_none] = ACTIONS(152),
    [anon_sym_extractelement] = ACTIONS(1348),
    [anon_sym_insertelement] = ACTIONS(1350),
    [anon_sym_select] = ACTIONS(1352),
    [anon_sym_shufflevector] = ACTIONS(1354),
    [anon_sym_fneg] = ACTIONS(1356),
    [anon_sym_icmp] = ACTIONS(1358),
    [anon_sym_fcmp] = ACTIONS(1360),
    [anon_sym_getelementptr] = ACTIONS(1362),
    [anon_sym_extractvalue] = ACTIONS(1364),
    [anon_sym_insertvalue] = ACTIONS(1366),
    [anon_sym_true] = ACTIONS(152),
    [anon_sym_false] = ACTIONS(152),
    [anon_sym_null] = ACTIONS(152),
    [anon_sym_undef] = ACTIONS(152),
    [anon_sym_poison] = ACTIONS(152),
    [anon_sym_zeroinitializer] = ACTIONS(152),
    [anon_sym_blockaddress] = ACTIONS(1368),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [388] = {
    [sym_number] = STATE(164),
    [sym_var] = STATE(164),
    [sym_linkage] = STATE(784),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(628),
    [sym__primitive_value] = STATE(164),
    [sym_struct_value] = STATE(164),
    [sym_packed_struct_value] = STATE(164),
    [sym_array_value] = STATE(164),
    [sym_vector_value] = STATE(164),
    [sym_blockaddress] = STATE(164),
    [sym_constant_expr] = STATE(164),
    [sym_constant_cast] = STATE(175),
    [sym_constant_getelementptr] = STATE(175),
    [sym_constant_select] = STATE(175),
    [sym_constant_icmp] = STATE(175),
    [sym_constant_fcmp] = STATE(175),
    [sym_constant_extractelement] = STATE(175),
    [sym_constant_insertelement] = STATE(175),
    [sym_constant_shufflevector] = STATE(175),
    [sym_constant_extractvalue] = STATE(175),
    [sym_constant_insertvalue] = STATE(175),
    [sym_constant_fneg] = STATE(175),
    [sym_constant_bin_op] = STATE(175),
    [sym_bin_op_keyword] = STATE(1106),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1954),
    [aux_sym_function_header_repeat1] = STATE(784),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(140),
    [sym_local_var] = ACTIONS(140),
    [sym_string] = ACTIONS(152),
    [aux_sym_number_token1] = ACTIONS(148),
    [aux_sym_number_token2] = ACTIONS(1346),
    [sym_float] = ACTIONS(152),
    [sym_cstring] = ACTIONS(152),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(164),
    [anon_sym_LT_LBRACE] = ACTIONS(166),
    [anon_sym_LBRACK] = ACTIONS(959),
    [anon_sym_LT] = ACTIONS(171),
    [anon_sym_none] = ACTIONS(152),
    [anon_sym_extractelement] = ACTIONS(1348),
    [anon_sym_insertelement] = ACTIONS(1350),
    [anon_sym_select] = ACTIONS(1352),
    [anon_sym_shufflevector] = ACTIONS(1354),
    [anon_sym_fneg] = ACTIONS(1356),
    [anon_sym_icmp] = ACTIONS(1358),
    [anon_sym_fcmp] = ACTIONS(1360),
    [anon_sym_getelementptr] = ACTIONS(1362),
    [anon_sym_extractvalue] = ACTIONS(1364),
    [anon_sym_insertvalue] = ACTIONS(1366),
    [anon_sym_true] = ACTIONS(152),
    [anon_sym_false] = ACTIONS(152),
    [anon_sym_null] = ACTIONS(152),
    [anon_sym_undef] = ACTIONS(152),
    [anon_sym_poison] = ACTIONS(152),
    [anon_sym_zeroinitializer] = ACTIONS(152),
    [anon_sym_blockaddress] = ACTIONS(1368),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [389] = {
    [sym_number] = STATE(92),
    [sym_var] = STATE(92),
    [sym_linkage] = STATE(817),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(1942),
    [sym__primitive_value] = STATE(92),
    [sym_struct_value] = STATE(92),
    [sym_packed_struct_value] = STATE(92),
    [sym_array_value] = STATE(92),
    [sym_vector_value] = STATE(92),
    [sym_blockaddress] = STATE(92),
    [sym_constant_expr] = STATE(92),
    [sym_constant_cast] = STATE(87),
    [sym_constant_getelementptr] = STATE(87),
    [sym_constant_select] = STATE(87),
    [sym_constant_icmp] = STATE(87),
    [sym_constant_fcmp] = STATE(87),
    [sym_constant_extractelement] = STATE(87),
    [sym_constant_insertelement] = STATE(87),
    [sym_constant_shufflevector] = STATE(87),
    [sym_constant_extractvalue] = STATE(87),
    [sym_constant_insertvalue] = STATE(87),
    [sym_constant_fneg] = STATE(87),
    [sym_constant_bin_op] = STATE(87),
    [sym_bin_op_keyword] = STATE(1122),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1597),
    [aux_sym_function_header_repeat1] = STATE(817),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_LT_LBRACE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_LT] = ACTIONS(470),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [390] = {
    [sym_number] = STATE(92),
    [sym_var] = STATE(92),
    [sym_linkage] = STATE(817),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(1633),
    [sym__primitive_value] = STATE(92),
    [sym_struct_value] = STATE(92),
    [sym_packed_struct_value] = STATE(92),
    [sym_array_value] = STATE(92),
    [sym_vector_value] = STATE(92),
    [sym_blockaddress] = STATE(92),
    [sym_constant_expr] = STATE(92),
    [sym_constant_cast] = STATE(87),
    [sym_constant_getelementptr] = STATE(87),
    [sym_constant_select] = STATE(87),
    [sym_constant_icmp] = STATE(87),
    [sym_constant_fcmp] = STATE(87),
    [sym_constant_extractelement] = STATE(87),
    [sym_constant_insertelement] = STATE(87),
    [sym_constant_shufflevector] = STATE(87),
    [sym_constant_extractvalue] = STATE(87),
    [sym_constant_insertvalue] = STATE(87),
    [sym_constant_fneg] = STATE(87),
    [sym_constant_bin_op] = STATE(87),
    [sym_bin_op_keyword] = STATE(1122),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1597),
    [aux_sym_function_header_repeat1] = STATE(817),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_LT_LBRACE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_LT] = ACTIONS(470),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [391] = {
    [sym_number] = STATE(164),
    [sym_var] = STATE(164),
    [sym_linkage] = STATE(784),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(673),
    [sym__primitive_value] = STATE(164),
    [sym_struct_value] = STATE(164),
    [sym_packed_struct_value] = STATE(164),
    [sym_array_value] = STATE(164),
    [sym_vector_value] = STATE(164),
    [sym_blockaddress] = STATE(164),
    [sym_constant_expr] = STATE(164),
    [sym_constant_cast] = STATE(175),
    [sym_constant_getelementptr] = STATE(175),
    [sym_constant_select] = STATE(175),
    [sym_constant_icmp] = STATE(175),
    [sym_constant_fcmp] = STATE(175),
    [sym_constant_extractelement] = STATE(175),
    [sym_constant_insertelement] = STATE(175),
    [sym_constant_shufflevector] = STATE(175),
    [sym_constant_extractvalue] = STATE(175),
    [sym_constant_insertvalue] = STATE(175),
    [sym_constant_fneg] = STATE(175),
    [sym_constant_bin_op] = STATE(175),
    [sym_bin_op_keyword] = STATE(1106),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1954),
    [aux_sym_function_header_repeat1] = STATE(784),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(140),
    [sym_local_var] = ACTIONS(140),
    [sym_string] = ACTIONS(152),
    [aux_sym_number_token1] = ACTIONS(148),
    [aux_sym_number_token2] = ACTIONS(1346),
    [sym_float] = ACTIONS(152),
    [sym_cstring] = ACTIONS(152),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(164),
    [anon_sym_LT_LBRACE] = ACTIONS(166),
    [anon_sym_LBRACK] = ACTIONS(959),
    [anon_sym_LT] = ACTIONS(171),
    [anon_sym_none] = ACTIONS(152),
    [anon_sym_extractelement] = ACTIONS(1348),
    [anon_sym_insertelement] = ACTIONS(1350),
    [anon_sym_select] = ACTIONS(1352),
    [anon_sym_shufflevector] = ACTIONS(1354),
    [anon_sym_fneg] = ACTIONS(1356),
    [anon_sym_icmp] = ACTIONS(1358),
    [anon_sym_fcmp] = ACTIONS(1360),
    [anon_sym_getelementptr] = ACTIONS(1362),
    [anon_sym_extractvalue] = ACTIONS(1364),
    [anon_sym_insertvalue] = ACTIONS(1366),
    [anon_sym_true] = ACTIONS(152),
    [anon_sym_false] = ACTIONS(152),
    [anon_sym_null] = ACTIONS(152),
    [anon_sym_undef] = ACTIONS(152),
    [anon_sym_poison] = ACTIONS(152),
    [anon_sym_zeroinitializer] = ACTIONS(152),
    [anon_sym_blockaddress] = ACTIONS(1368),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [392] = {
    [sym_number] = STATE(92),
    [sym_var] = STATE(92),
    [sym_linkage] = STATE(817),
    [sym_linkage_aux] = STATE(245),
    [sym_dso_local] = STATE(245),
    [sym_visibility] = STATE(245),
    [sym_dll_storage_class] = STATE(245),
    [sym_value] = STATE(136),
    [sym__primitive_value] = STATE(92),
    [sym_struct_value] = STATE(92),
    [sym_packed_struct_value] = STATE(92),
    [sym_array_value] = STATE(92),
    [sym_vector_value] = STATE(92),
    [sym_blockaddress] = STATE(92),
    [sym_constant_expr] = STATE(92),
    [sym_constant_cast] = STATE(87),
    [sym_constant_getelementptr] = STATE(87),
    [sym_constant_select] = STATE(87),
    [sym_constant_icmp] = STATE(87),
    [sym_constant_fcmp] = STATE(87),
    [sym_constant_extractelement] = STATE(87),
    [sym_constant_insertelement] = STATE(87),
    [sym_constant_shufflevector] = STATE(87),
    [sym_constant_extractvalue] = STATE(87),
    [sym_constant_insertvalue] = STATE(87),
    [sym_constant_fneg] = STATE(87),
    [sym_constant_bin_op] = STATE(87),
    [sym_bin_op_keyword] = STATE(1122),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1597),
    [aux_sym_function_header_repeat1] = STATE(817),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(33),
    [sym_local_var] = ACTIONS(33),
    [sym_string] = ACTIONS(47),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [sym_float] = ACTIONS(47),
    [sym_cstring] = ACTIONS(47),
    [anon_sym_no_cfi] = ACTIONS(317),
    [anon_sym_private] = ACTIONS(319),
    [anon_sym_internal] = ACTIONS(319),
    [anon_sym_weak] = ACTIONS(156),
    [anon_sym_weak_odr] = ACTIONS(319),
    [anon_sym_linkonce] = ACTIONS(156),
    [anon_sym_linkonce_odr] = ACTIONS(319),
    [anon_sym_available_externally] = ACTIONS(319),
    [anon_sym_appending] = ACTIONS(319),
    [anon_sym_common] = ACTIONS(319),
    [anon_sym_extern_weak] = ACTIONS(319),
    [anon_sym_external] = ACTIONS(319),
    [anon_sym_dso_local] = ACTIONS(158),
    [anon_sym_dso_local_equivalent] = ACTIONS(321),
    [anon_sym_dso_preemptable] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(323),
    [anon_sym_hidden] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_dllimport] = ACTIONS(325),
    [anon_sym_dllexport] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_LT_LBRACE] = ACTIONS(466),
    [anon_sym_LBRACK] = ACTIONS(78),
    [anon_sym_LT] = ACTIONS(470),
    [anon_sym_none] = ACTIONS(47),
    [anon_sym_extractelement] = ACTIONS(84),
    [anon_sym_insertelement] = ACTIONS(86),
    [anon_sym_select] = ACTIONS(88),
    [anon_sym_shufflevector] = ACTIONS(90),
    [anon_sym_fneg] = ACTIONS(92),
    [anon_sym_icmp] = ACTIONS(94),
    [anon_sym_fcmp] = ACTIONS(96),
    [anon_sym_getelementptr] = ACTIONS(98),
    [anon_sym_extractvalue] = ACTIONS(100),
    [anon_sym_insertvalue] = ACTIONS(102),
    [anon_sym_true] = ACTIONS(47),
    [anon_sym_false] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(47),
    [anon_sym_undef] = ACTIONS(47),
    [anon_sym_poison] = ACTIONS(47),
    [anon_sym_zeroinitializer] = ACTIONS(47),
    [anon_sym_blockaddress] = ACTIONS(106),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [393] = {
    [sym_unnamed_addr] = STATE(1079),
    [sym_type] = STATE(1640),
    [sym_type_keyword] = STATE(769),
    [sym_struct_type] = STATE(769),
    [sym_packed_struct_type] = STATE(769),
    [sym_array_type] = STATE(769),
    [sym_vector_type] = STATE(769),
    [sym_param_or_return_attrs] = STATE(405),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [aux_sym_function_header_repeat2] = STATE(405),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(717),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [394] = {
    [sym_unnamed_addr] = STATE(1047),
    [sym_type] = STATE(1775),
    [sym_type_keyword] = STATE(769),
    [sym_struct_type] = STATE(769),
    [sym_packed_struct_type] = STATE(769),
    [sym_array_type] = STATE(769),
    [sym_vector_type] = STATE(769),
    [sym_param_or_return_attrs] = STATE(405),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [aux_sym_function_header_repeat2] = STATE(405),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(717),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [395] = {
    [sym_unnamed_addr] = STATE(1076),
    [sym_type] = STATE(1708),
    [sym_type_keyword] = STATE(769),
    [sym_struct_type] = STATE(769),
    [sym_packed_struct_type] = STATE(769),
    [sym_array_type] = STATE(769),
    [sym_vector_type] = STATE(769),
    [sym_param_or_return_attrs] = STATE(405),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [aux_sym_function_header_repeat2] = STATE(405),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(717),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [396] = {
    [sym_unnamed_addr] = STATE(1074),
    [sym_type] = STATE(1786),
    [sym_type_keyword] = STATE(769),
    [sym_struct_type] = STATE(769),
    [sym_packed_struct_type] = STATE(769),
    [sym_array_type] = STATE(769),
    [sym_vector_type] = STATE(769),
    [sym_param_or_return_attrs] = STATE(405),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [aux_sym_function_header_repeat2] = STATE(405),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(717),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [397] = {
    [sym_unnamed_addr] = STATE(1074),
    [sym_type] = STATE(1786),
    [sym_type_keyword] = STATE(769),
    [sym_struct_type] = STATE(769),
    [sym_packed_struct_type] = STATE(769),
    [sym_array_type] = STATE(769),
    [sym_vector_type] = STATE(769),
    [sym_param_or_return_attrs] = STATE(398),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [aux_sym_function_header_repeat2] = STATE(398),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(717),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [398] = {
    [sym_unnamed_addr] = STATE(1059),
    [sym_type] = STATE(1789),
    [sym_type_keyword] = STATE(769),
    [sym_struct_type] = STATE(769),
    [sym_packed_struct_type] = STATE(769),
    [sym_array_type] = STATE(769),
    [sym_vector_type] = STATE(769),
    [sym_param_or_return_attrs] = STATE(405),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [aux_sym_function_header_repeat2] = STATE(405),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(717),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [399] = {
    [sym_unnamed_addr] = STATE(1047),
    [sym_type] = STATE(1775),
    [sym_type_keyword] = STATE(769),
    [sym_struct_type] = STATE(769),
    [sym_packed_struct_type] = STATE(769),
    [sym_array_type] = STATE(769),
    [sym_vector_type] = STATE(769),
    [sym_param_or_return_attrs] = STATE(393),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [aux_sym_function_header_repeat2] = STATE(393),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(717),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [400] = {
    [sym_unnamed_addr] = STATE(1045),
    [sym_type] = STATE(1780),
    [sym_type_keyword] = STATE(769),
    [sym_struct_type] = STATE(769),
    [sym_packed_struct_type] = STATE(769),
    [sym_array_type] = STATE(769),
    [sym_vector_type] = STATE(769),
    [sym_param_or_return_attrs] = STATE(405),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [aux_sym_function_header_repeat2] = STATE(405),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(717),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [401] = {
    [sym_unnamed_addr] = STATE(1079),
    [sym_type] = STATE(1640),
    [sym_type_keyword] = STATE(769),
    [sym_struct_type] = STATE(769),
    [sym_packed_struct_type] = STATE(769),
    [sym_array_type] = STATE(769),
    [sym_vector_type] = STATE(769),
    [sym_param_or_return_attrs] = STATE(395),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [aux_sym_function_header_repeat2] = STATE(395),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(717),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [402] = {
    [sym_unnamed_addr] = STATE(1045),
    [sym_type] = STATE(1780),
    [sym_type_keyword] = STATE(769),
    [sym_struct_type] = STATE(769),
    [sym_packed_struct_type] = STATE(769),
    [sym_array_type] = STATE(769),
    [sym_vector_type] = STATE(769),
    [sym_param_or_return_attrs] = STATE(396),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [aux_sym_function_header_repeat2] = STATE(396),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(717),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [403] = {
    [sym_unnamed_addr] = STATE(430),
    [sym_addrspace] = STATE(449),
    [sym_attribute] = STATE(456),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(456),
    [ts_builtin_sym_end] = ACTIONS(1370),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1370),
    [sym_global_var] = ACTIONS(1370),
    [sym_local_var] = ACTIONS(1370),
    [aux_sym_metadata_ref_token1] = ACTIONS(1370),
    [sym_summary_ref] = ACTIONS(1370),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1370),
    [anon_sym_source_filename] = ACTIONS(1370),
    [anon_sym_declare] = ACTIONS(1370),
    [anon_sym_define] = ACTIONS(1370),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1382),
    [anon_sym_uselistorder_bb] = ACTIONS(1370),
    [anon_sym_module] = ACTIONS(1370),
    [anon_sym_attributes] = ACTIONS(1370),
  },
  [404] = {
    [sym_type] = STATE(373),
    [sym_type_keyword] = STATE(260),
    [sym_struct_type] = STATE(260),
    [sym_packed_struct_type] = STATE(260),
    [sym_array_type] = STATE(260),
    [sym_vector_type] = STATE(260),
    [sym_addrspace] = STATE(1082),
    [sym_param_or_return_attrs] = STATE(409),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [aux_sym_function_header_repeat2] = STATE(409),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [405] = {
    [sym_param_or_return_attrs] = STATE(405),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [aux_sym_function_header_repeat2] = STATE(405),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(816),
    [aux_sym_metadata_ref_token1] = ACTIONS(816),
    [anon_sym_unnamed_addr] = ACTIONS(816),
    [anon_sym_local_unnamed_addr] = ACTIONS(816),
    [anon_sym_void] = ACTIONS(816),
    [anon_sym_half] = ACTIONS(816),
    [anon_sym_bfloat] = ACTIONS(816),
    [anon_sym_float] = ACTIONS(816),
    [anon_sym_double] = ACTIONS(816),
    [anon_sym_x86_fp80] = ACTIONS(816),
    [anon_sym_fp128] = ACTIONS(816),
    [anon_sym_ppc_fp128] = ACTIONS(816),
    [anon_sym_label] = ACTIONS(816),
    [anon_sym_metadata] = ACTIONS(816),
    [anon_sym_x86_mmx] = ACTIONS(816),
    [anon_sym_x86_amx] = ACTIONS(816),
    [anon_sym_token] = ACTIONS(816),
    [anon_sym_opaque] = ACTIONS(816),
    [anon_sym_ptr] = ACTIONS(816),
    [aux_sym_type_keyword_token1] = ACTIONS(816),
    [anon_sym_LBRACE] = ACTIONS(816),
    [anon_sym_LT_LBRACE] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_COMMA] = ACTIONS(816),
    [anon_sym_addrspace] = ACTIONS(816),
    [anon_sym_RPAREN] = ACTIONS(816),
    [anon_sym_align] = ACTIONS(1384),
    [anon_sym_alignstack] = ACTIONS(1387),
    [anon_sym_allocsize] = ACTIONS(1387),
    [anon_sym_alwaysinline] = ACTIONS(1387),
    [anon_sym_builtin] = ACTIONS(1387),
    [anon_sym_cold] = ACTIONS(1387),
    [anon_sym_convergent] = ACTIONS(1387),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1387),
    [anon_sym_hot] = ACTIONS(1387),
    [anon_sym_inaccessiblememonly] = ACTIONS(1387),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1387),
    [anon_sym_inlinehint] = ACTIONS(1387),
    [anon_sym_jumptable] = ACTIONS(1387),
    [anon_sym_minsize] = ACTIONS(1387),
    [anon_sym_naked] = ACTIONS(1387),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1387),
    [anon_sym_nobuiltin] = ACTIONS(1387),
    [anon_sym_noduplicate] = ACTIONS(1387),
    [anon_sym_nofree] = ACTIONS(1387),
    [anon_sym_noimplicitfloat] = ACTIONS(1387),
    [anon_sym_noinline] = ACTIONS(1387),
    [anon_sym_nomerge] = ACTIONS(1387),
    [anon_sym_nonlazybind] = ACTIONS(1387),
    [anon_sym_noprofile] = ACTIONS(1387),
    [anon_sym_noredzone] = ACTIONS(1387),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1387),
    [anon_sym_noreturn] = ACTIONS(1387),
    [anon_sym_norecurse] = ACTIONS(1387),
    [anon_sym_willreturn] = ACTIONS(1387),
    [anon_sym_nosync] = ACTIONS(1387),
    [anon_sym_nounwind] = ACTIONS(1387),
    [anon_sym_nocallback] = ACTIONS(1387),
    [anon_sym_nosanitize_coverage] = ACTIONS(1387),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1387),
    [anon_sym_optforfuzzing] = ACTIONS(1387),
    [anon_sym_optnone] = ACTIONS(1387),
    [anon_sym_optsize] = ACTIONS(1387),
    [anon_sym_readnone] = ACTIONS(1387),
    [anon_sym_readonly] = ACTIONS(1387),
    [anon_sym_writeonly] = ACTIONS(1387),
    [anon_sym_argmemonly] = ACTIONS(1387),
    [anon_sym_returns_twice] = ACTIONS(1387),
    [anon_sym_safestack] = ACTIONS(1387),
    [anon_sym_sanitize_address] = ACTIONS(1387),
    [anon_sym_sanitize_memory] = ACTIONS(1387),
    [anon_sym_sanitize_thread] = ACTIONS(1387),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1387),
    [anon_sym_sanitize_memtag] = ACTIONS(1387),
    [anon_sym_speculative_load_hardening] = ACTIONS(1387),
    [anon_sym_speculatable] = ACTIONS(1387),
    [anon_sym_ssp] = ACTIONS(1390),
    [anon_sym_sspstrong] = ACTIONS(1387),
    [anon_sym_sspreq] = ACTIONS(1387),
    [anon_sym_strictfp] = ACTIONS(1387),
    [anon_sym_nocf_check] = ACTIONS(1387),
    [anon_sym_shadowcallstack] = ACTIONS(1387),
    [anon_sym_mustprogress] = ACTIONS(1387),
    [anon_sym_vscale_range] = ACTIONS(1387),
    [anon_sym_preallocated] = ACTIONS(1387),
    [anon_sym_zeroext] = ACTIONS(1387),
    [anon_sym_signext] = ACTIONS(1387),
    [anon_sym_inreg] = ACTIONS(1387),
    [anon_sym_byval] = ACTIONS(1387),
    [anon_sym_byref] = ACTIONS(1387),
    [anon_sym_inalloca] = ACTIONS(1387),
    [anon_sym_sret] = ACTIONS(1387),
    [anon_sym_elementtype] = ACTIONS(1387),
    [anon_sym_noalias] = ACTIONS(1387),
    [anon_sym_nocapture] = ACTIONS(1387),
    [anon_sym_nest] = ACTIONS(1387),
    [anon_sym_returned] = ACTIONS(1387),
    [anon_sym_nonnull] = ACTIONS(1387),
    [anon_sym_dereferenceable] = ACTIONS(1390),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1387),
    [anon_sym_swiftself] = ACTIONS(1387),
    [anon_sym_swiftasync] = ACTIONS(1387),
    [anon_sym_swifterror] = ACTIONS(1387),
    [anon_sym_immarg] = ACTIONS(1387),
    [anon_sym_noundef] = ACTIONS(1387),
    [anon_sym_uwtable] = ACTIONS(1393),
    [anon_sym_memory] = ACTIONS(1396),
    [anon_sym_null] = ACTIONS(818),
    [anon_sym_BANG] = ACTIONS(818),
  },
  [406] = {
    [sym_type] = STATE(378),
    [sym_type_keyword] = STATE(260),
    [sym_struct_type] = STATE(260),
    [sym_packed_struct_type] = STATE(260),
    [sym_array_type] = STATE(260),
    [sym_vector_type] = STATE(260),
    [sym_addrspace] = STATE(1062),
    [sym_param_or_return_attrs] = STATE(405),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [aux_sym_function_header_repeat2] = STATE(405),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [407] = {
    [sym_type] = STATE(375),
    [sym_type_keyword] = STATE(260),
    [sym_struct_type] = STATE(260),
    [sym_packed_struct_type] = STATE(260),
    [sym_array_type] = STATE(260),
    [sym_vector_type] = STATE(260),
    [sym_addrspace] = STATE(1052),
    [sym_param_or_return_attrs] = STATE(405),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [aux_sym_function_header_repeat2] = STATE(405),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [408] = {
    [sym_unnamed_addr] = STATE(431),
    [sym_addrspace] = STATE(447),
    [sym_attribute] = STATE(444),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(444),
    [ts_builtin_sym_end] = ACTIONS(1399),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1399),
    [sym_global_var] = ACTIONS(1399),
    [sym_local_var] = ACTIONS(1399),
    [aux_sym_metadata_ref_token1] = ACTIONS(1399),
    [sym_summary_ref] = ACTIONS(1399),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1399),
    [anon_sym_source_filename] = ACTIONS(1399),
    [anon_sym_declare] = ACTIONS(1399),
    [anon_sym_define] = ACTIONS(1399),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1401),
    [anon_sym_uselistorder_bb] = ACTIONS(1399),
    [anon_sym_module] = ACTIONS(1399),
    [anon_sym_attributes] = ACTIONS(1399),
  },
  [409] = {
    [sym_type] = STATE(379),
    [sym_type_keyword] = STATE(260),
    [sym_struct_type] = STATE(260),
    [sym_packed_struct_type] = STATE(260),
    [sym_array_type] = STATE(260),
    [sym_vector_type] = STATE(260),
    [sym_addrspace] = STATE(1084),
    [sym_param_or_return_attrs] = STATE(405),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [aux_sym_function_header_repeat2] = STATE(405),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [410] = {
    [sym_unnamed_addr] = STATE(428),
    [sym_addrspace] = STATE(455),
    [sym_attribute] = STATE(465),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(465),
    [ts_builtin_sym_end] = ACTIONS(1403),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1403),
    [sym_global_var] = ACTIONS(1403),
    [sym_local_var] = ACTIONS(1403),
    [aux_sym_metadata_ref_token1] = ACTIONS(1403),
    [sym_summary_ref] = ACTIONS(1403),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1403),
    [anon_sym_source_filename] = ACTIONS(1403),
    [anon_sym_declare] = ACTIONS(1403),
    [anon_sym_define] = ACTIONS(1403),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1405),
    [anon_sym_uselistorder_bb] = ACTIONS(1403),
    [anon_sym_module] = ACTIONS(1403),
    [anon_sym_attributes] = ACTIONS(1403),
  },
  [411] = {
    [sym_unnamed_addr] = STATE(432),
    [sym_addrspace] = STATE(448),
    [sym_attribute] = STATE(453),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(453),
    [ts_builtin_sym_end] = ACTIONS(1407),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1407),
    [sym_global_var] = ACTIONS(1407),
    [sym_local_var] = ACTIONS(1407),
    [aux_sym_metadata_ref_token1] = ACTIONS(1407),
    [sym_summary_ref] = ACTIONS(1407),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1407),
    [anon_sym_source_filename] = ACTIONS(1407),
    [anon_sym_declare] = ACTIONS(1407),
    [anon_sym_define] = ACTIONS(1407),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1409),
    [anon_sym_uselistorder_bb] = ACTIONS(1407),
    [anon_sym_module] = ACTIONS(1407),
    [anon_sym_attributes] = ACTIONS(1407),
  },
  [412] = {
    [sym_type] = STATE(373),
    [sym_type_keyword] = STATE(260),
    [sym_struct_type] = STATE(260),
    [sym_packed_struct_type] = STATE(260),
    [sym_array_type] = STATE(260),
    [sym_vector_type] = STATE(260),
    [sym_addrspace] = STATE(1082),
    [sym_param_or_return_attrs] = STATE(405),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [aux_sym_function_header_repeat2] = STATE(405),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [413] = {
    [sym_unnamed_addr] = STATE(429),
    [sym_addrspace] = STATE(463),
    [sym_attribute] = STATE(457),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(457),
    [ts_builtin_sym_end] = ACTIONS(1411),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1411),
    [sym_global_var] = ACTIONS(1411),
    [sym_local_var] = ACTIONS(1411),
    [aux_sym_metadata_ref_token1] = ACTIONS(1411),
    [sym_summary_ref] = ACTIONS(1411),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1411),
    [anon_sym_source_filename] = ACTIONS(1411),
    [anon_sym_declare] = ACTIONS(1411),
    [anon_sym_define] = ACTIONS(1411),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1413),
    [anon_sym_uselistorder_bb] = ACTIONS(1411),
    [anon_sym_module] = ACTIONS(1411),
    [anon_sym_attributes] = ACTIONS(1411),
  },
  [414] = {
    [sym_type] = STATE(375),
    [sym_type_keyword] = STATE(260),
    [sym_struct_type] = STATE(260),
    [sym_packed_struct_type] = STATE(260),
    [sym_array_type] = STATE(260),
    [sym_vector_type] = STATE(260),
    [sym_addrspace] = STATE(1052),
    [sym_param_or_return_attrs] = STATE(406),
    [sym_attribute_name] = STATE(433),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [aux_sym_function_header_repeat2] = STATE(406),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(436),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(438),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(454),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [415] = {
    [sym_number] = STATE(477),
    [ts_builtin_sym_end] = ACTIONS(812),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(812),
    [sym_comdat_ref] = ACTIONS(812),
    [sym_global_var] = ACTIONS(812),
    [sym_local_var] = ACTIONS(812),
    [aux_sym_metadata_ref_token1] = ACTIONS(812),
    [sym_summary_ref] = ACTIONS(812),
    [sym_string] = ACTIONS(812),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [anon_sym_target] = ACTIONS(812),
    [anon_sym_EQ] = ACTIONS(812),
    [anon_sym_source_filename] = ACTIONS(812),
    [anon_sym_declare] = ACTIONS(812),
    [anon_sym_define] = ACTIONS(812),
    [anon_sym_LBRACE] = ACTIONS(812),
    [anon_sym_RBRACE] = ACTIONS(812),
    [anon_sym_LBRACK] = ACTIONS(812),
    [anon_sym_COMMA] = ACTIONS(812),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_align] = ACTIONS(814),
    [anon_sym_section] = ACTIONS(812),
    [anon_sym_partition] = ACTIONS(812),
    [anon_sym_comdat] = ACTIONS(812),
    [anon_sym_gc] = ACTIONS(812),
    [anon_sym_prefix] = ACTIONS(812),
    [anon_sym_prologue] = ACTIONS(812),
    [anon_sym_personality] = ACTIONS(812),
    [anon_sym_alignstack] = ACTIONS(812),
    [anon_sym_allocsize] = ACTIONS(812),
    [anon_sym_alwaysinline] = ACTIONS(812),
    [anon_sym_builtin] = ACTIONS(812),
    [anon_sym_cold] = ACTIONS(812),
    [anon_sym_convergent] = ACTIONS(812),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(812),
    [anon_sym_hot] = ACTIONS(812),
    [anon_sym_inaccessiblememonly] = ACTIONS(812),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(812),
    [anon_sym_inlinehint] = ACTIONS(812),
    [anon_sym_jumptable] = ACTIONS(812),
    [anon_sym_minsize] = ACTIONS(812),
    [anon_sym_naked] = ACTIONS(812),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(812),
    [anon_sym_nobuiltin] = ACTIONS(812),
    [anon_sym_noduplicate] = ACTIONS(812),
    [anon_sym_nofree] = ACTIONS(812),
    [anon_sym_noimplicitfloat] = ACTIONS(812),
    [anon_sym_noinline] = ACTIONS(812),
    [anon_sym_nomerge] = ACTIONS(812),
    [anon_sym_nonlazybind] = ACTIONS(812),
    [anon_sym_noprofile] = ACTIONS(812),
    [anon_sym_noredzone] = ACTIONS(812),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(812),
    [anon_sym_noreturn] = ACTIONS(812),
    [anon_sym_norecurse] = ACTIONS(812),
    [anon_sym_willreturn] = ACTIONS(812),
    [anon_sym_nosync] = ACTIONS(812),
    [anon_sym_nounwind] = ACTIONS(812),
    [anon_sym_nocallback] = ACTIONS(812),
    [anon_sym_nosanitize_coverage] = ACTIONS(812),
    [anon_sym_null_pointer_is_valid] = ACTIONS(812),
    [anon_sym_optforfuzzing] = ACTIONS(812),
    [anon_sym_optnone] = ACTIONS(812),
    [anon_sym_optsize] = ACTIONS(812),
    [anon_sym_readnone] = ACTIONS(812),
    [anon_sym_readonly] = ACTIONS(812),
    [anon_sym_writeonly] = ACTIONS(812),
    [anon_sym_argmemonly] = ACTIONS(812),
    [anon_sym_returns_twice] = ACTIONS(812),
    [anon_sym_safestack] = ACTIONS(812),
    [anon_sym_sanitize_address] = ACTIONS(812),
    [anon_sym_sanitize_memory] = ACTIONS(812),
    [anon_sym_sanitize_thread] = ACTIONS(812),
    [anon_sym_sanitize_hwaddress] = ACTIONS(812),
    [anon_sym_sanitize_memtag] = ACTIONS(812),
    [anon_sym_speculative_load_hardening] = ACTIONS(812),
    [anon_sym_speculatable] = ACTIONS(812),
    [anon_sym_ssp] = ACTIONS(814),
    [anon_sym_sspstrong] = ACTIONS(812),
    [anon_sym_sspreq] = ACTIONS(812),
    [anon_sym_strictfp] = ACTIONS(812),
    [anon_sym_nocf_check] = ACTIONS(812),
    [anon_sym_shadowcallstack] = ACTIONS(812),
    [anon_sym_mustprogress] = ACTIONS(812),
    [anon_sym_vscale_range] = ACTIONS(812),
    [anon_sym_preallocated] = ACTIONS(812),
    [anon_sym_zeroext] = ACTIONS(812),
    [anon_sym_signext] = ACTIONS(812),
    [anon_sym_inreg] = ACTIONS(812),
    [anon_sym_byval] = ACTIONS(812),
    [anon_sym_byref] = ACTIONS(812),
    [anon_sym_inalloca] = ACTIONS(812),
    [anon_sym_sret] = ACTIONS(812),
    [anon_sym_elementtype] = ACTIONS(812),
    [anon_sym_noalias] = ACTIONS(812),
    [anon_sym_nocapture] = ACTIONS(812),
    [anon_sym_nest] = ACTIONS(812),
    [anon_sym_returned] = ACTIONS(812),
    [anon_sym_nonnull] = ACTIONS(812),
    [anon_sym_dereferenceable] = ACTIONS(814),
    [anon_sym_dereferenceable_or_null] = ACTIONS(812),
    [anon_sym_swiftself] = ACTIONS(812),
    [anon_sym_swiftasync] = ACTIONS(812),
    [anon_sym_swifterror] = ACTIONS(812),
    [anon_sym_immarg] = ACTIONS(812),
    [anon_sym_noundef] = ACTIONS(812),
    [anon_sym_uwtable] = ACTIONS(812),
    [anon_sym_memory] = ACTIONS(812),
    [anon_sym_to] = ACTIONS(812),
    [anon_sym_uselistorder] = ACTIONS(814),
    [anon_sym_uselistorder_bb] = ACTIONS(812),
    [anon_sym_module] = ACTIONS(812),
    [anon_sym_attributes] = ACTIONS(812),
  },
  [416] = {
    [sym__instruction_body] = STATE(574),
    [sym_instruction_unreachable] = STATE(574),
    [sym_instruction_ret] = STATE(574),
    [sym_instruction_br] = STATE(574),
    [sym_instruction_resume] = STATE(574),
    [sym_instruction_freeze] = STATE(574),
    [sym_instruction_indirectbr] = STATE(574),
    [sym_instruction_extractelement] = STATE(574),
    [sym_instruction_insertelement] = STATE(574),
    [sym_instruction_select] = STATE(574),
    [sym_instruction_shufflevector] = STATE(574),
    [sym_instruction_fneg] = STATE(574),
    [sym_instruction_bin_op] = STATE(574),
    [sym_instruction_switch] = STATE(574),
    [sym_instruction_invoke] = STATE(574),
    [sym_instruction_cleanupret] = STATE(574),
    [sym_instruction_catchret] = STATE(574),
    [sym_instruction_catchswitch] = STATE(574),
    [sym_instruction_catchpad] = STATE(574),
    [sym_instruction_cleanuppad] = STATE(574),
    [sym_instruction_callbr] = STATE(574),
    [sym_instruction_icmp] = STATE(574),
    [sym_instruction_fcmp] = STATE(574),
    [sym_instruction_cast] = STATE(574),
    [sym_instruction_va_arg] = STATE(574),
    [sym_instruction_phi] = STATE(574),
    [sym_instruction_landingpad] = STATE(574),
    [sym_instruction_call] = STATE(574),
    [sym_instruction_alloca] = STATE(574),
    [sym_instruction_load] = STATE(574),
    [sym_instruction_store] = STATE(574),
    [sym_instruction_cmpxchg] = STATE(574),
    [sym_instruction_atomicrmw] = STATE(574),
    [sym_instruction_fence] = STATE(574),
    [sym_instruction_getelementptr] = STATE(574),
    [sym_instruction_extractvalue] = STATE(574),
    [sym_instruction_insertvalue] = STATE(574),
    [sym_bin_op_keyword] = STATE(729),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(835),
    [sym_comment] = ACTIONS(3),
    [anon_sym_unreachable] = ACTIONS(1415),
    [anon_sym_ret] = ACTIONS(1417),
    [anon_sym_br] = ACTIONS(1419),
    [anon_sym_resume] = ACTIONS(1421),
    [anon_sym_freeze] = ACTIONS(1423),
    [anon_sym_indirectbr] = ACTIONS(1425),
    [anon_sym_extractelement] = ACTIONS(1427),
    [anon_sym_insertelement] = ACTIONS(1429),
    [anon_sym_select] = ACTIONS(1431),
    [anon_sym_shufflevector] = ACTIONS(1433),
    [anon_sym_fneg] = ACTIONS(1435),
    [anon_sym_switch] = ACTIONS(1437),
    [anon_sym_invoke] = ACTIONS(1439),
    [anon_sym_cleanupret] = ACTIONS(1441),
    [anon_sym_catchret] = ACTIONS(1443),
    [anon_sym_catchswitch] = ACTIONS(1445),
    [anon_sym_catchpad] = ACTIONS(1447),
    [anon_sym_cleanuppad] = ACTIONS(1449),
    [anon_sym_callbr] = ACTIONS(1451),
    [anon_sym_icmp] = ACTIONS(1453),
    [anon_sym_fcmp] = ACTIONS(1455),
    [anon_sym_va_arg] = ACTIONS(1457),
    [anon_sym_phi] = ACTIONS(1459),
    [anon_sym_landingpad] = ACTIONS(1461),
    [anon_sym_tail] = ACTIONS(1463),
    [anon_sym_musttail] = ACTIONS(1463),
    [anon_sym_notail] = ACTIONS(1463),
    [anon_sym_call] = ACTIONS(1124),
    [anon_sym_alloca] = ACTIONS(1465),
    [anon_sym_load] = ACTIONS(1467),
    [anon_sym_store] = ACTIONS(1469),
    [anon_sym_cmpxchg] = ACTIONS(1471),
    [anon_sym_atomicrmw] = ACTIONS(1473),
    [anon_sym_fence] = ACTIONS(1475),
    [anon_sym_getelementptr] = ACTIONS(1477),
    [anon_sym_extractvalue] = ACTIONS(1479),
    [anon_sym_insertvalue] = ACTIONS(1481),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [417] = {
    [sym_number] = STATE(439),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(812),
    [aux_sym_metadata_ref_token1] = ACTIONS(812),
    [aux_sym_number_token1] = ACTIONS(311),
    [aux_sym_number_token2] = ACTIONS(313),
    [anon_sym_unnamed_addr] = ACTIONS(812),
    [anon_sym_local_unnamed_addr] = ACTIONS(812),
    [anon_sym_void] = ACTIONS(812),
    [anon_sym_half] = ACTIONS(812),
    [anon_sym_bfloat] = ACTIONS(812),
    [anon_sym_float] = ACTIONS(812),
    [anon_sym_double] = ACTIONS(812),
    [anon_sym_x86_fp80] = ACTIONS(812),
    [anon_sym_fp128] = ACTIONS(812),
    [anon_sym_ppc_fp128] = ACTIONS(812),
    [anon_sym_label] = ACTIONS(812),
    [anon_sym_metadata] = ACTIONS(812),
    [anon_sym_x86_mmx] = ACTIONS(812),
    [anon_sym_x86_amx] = ACTIONS(812),
    [anon_sym_token] = ACTIONS(812),
    [anon_sym_opaque] = ACTIONS(812),
    [anon_sym_ptr] = ACTIONS(812),
    [aux_sym_type_keyword_token1] = ACTIONS(812),
    [anon_sym_LBRACE] = ACTIONS(812),
    [anon_sym_LT_LBRACE] = ACTIONS(812),
    [anon_sym_LBRACK] = ACTIONS(812),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_COMMA] = ACTIONS(812),
    [anon_sym_addrspace] = ACTIONS(812),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_RPAREN] = ACTIONS(812),
    [anon_sym_align] = ACTIONS(814),
    [anon_sym_alignstack] = ACTIONS(812),
    [anon_sym_allocsize] = ACTIONS(812),
    [anon_sym_alwaysinline] = ACTIONS(812),
    [anon_sym_builtin] = ACTIONS(812),
    [anon_sym_cold] = ACTIONS(812),
    [anon_sym_convergent] = ACTIONS(812),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(812),
    [anon_sym_hot] = ACTIONS(812),
    [anon_sym_inaccessiblememonly] = ACTIONS(812),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(812),
    [anon_sym_inlinehint] = ACTIONS(812),
    [anon_sym_jumptable] = ACTIONS(812),
    [anon_sym_minsize] = ACTIONS(812),
    [anon_sym_naked] = ACTIONS(812),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(812),
    [anon_sym_nobuiltin] = ACTIONS(812),
    [anon_sym_noduplicate] = ACTIONS(812),
    [anon_sym_nofree] = ACTIONS(812),
    [anon_sym_noimplicitfloat] = ACTIONS(812),
    [anon_sym_noinline] = ACTIONS(812),
    [anon_sym_nomerge] = ACTIONS(812),
    [anon_sym_nonlazybind] = ACTIONS(812),
    [anon_sym_noprofile] = ACTIONS(812),
    [anon_sym_noredzone] = ACTIONS(812),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(812),
    [anon_sym_noreturn] = ACTIONS(812),
    [anon_sym_norecurse] = ACTIONS(812),
    [anon_sym_willreturn] = ACTIONS(812),
    [anon_sym_nosync] = ACTIONS(812),
    [anon_sym_nounwind] = ACTIONS(812),
    [anon_sym_nocallback] = ACTIONS(812),
    [anon_sym_nosanitize_coverage] = ACTIONS(812),
    [anon_sym_null_pointer_is_valid] = ACTIONS(812),
    [anon_sym_optforfuzzing] = ACTIONS(812),
    [anon_sym_optnone] = ACTIONS(812),
    [anon_sym_optsize] = ACTIONS(812),
    [anon_sym_readnone] = ACTIONS(812),
    [anon_sym_readonly] = ACTIONS(812),
    [anon_sym_writeonly] = ACTIONS(812),
    [anon_sym_argmemonly] = ACTIONS(812),
    [anon_sym_returns_twice] = ACTIONS(812),
    [anon_sym_safestack] = ACTIONS(812),
    [anon_sym_sanitize_address] = ACTIONS(812),
    [anon_sym_sanitize_memory] = ACTIONS(812),
    [anon_sym_sanitize_thread] = ACTIONS(812),
    [anon_sym_sanitize_hwaddress] = ACTIONS(812),
    [anon_sym_sanitize_memtag] = ACTIONS(812),
    [anon_sym_speculative_load_hardening] = ACTIONS(812),
    [anon_sym_speculatable] = ACTIONS(812),
    [anon_sym_ssp] = ACTIONS(814),
    [anon_sym_sspstrong] = ACTIONS(812),
    [anon_sym_sspreq] = ACTIONS(812),
    [anon_sym_strictfp] = ACTIONS(812),
    [anon_sym_nocf_check] = ACTIONS(812),
    [anon_sym_shadowcallstack] = ACTIONS(812),
    [anon_sym_mustprogress] = ACTIONS(812),
    [anon_sym_vscale_range] = ACTIONS(812),
    [anon_sym_preallocated] = ACTIONS(812),
    [anon_sym_zeroext] = ACTIONS(812),
    [anon_sym_signext] = ACTIONS(812),
    [anon_sym_inreg] = ACTIONS(812),
    [anon_sym_byval] = ACTIONS(812),
    [anon_sym_byref] = ACTIONS(812),
    [anon_sym_inalloca] = ACTIONS(812),
    [anon_sym_sret] = ACTIONS(812),
    [anon_sym_elementtype] = ACTIONS(812),
    [anon_sym_noalias] = ACTIONS(812),
    [anon_sym_nocapture] = ACTIONS(812),
    [anon_sym_nest] = ACTIONS(812),
    [anon_sym_returned] = ACTIONS(812),
    [anon_sym_nonnull] = ACTIONS(812),
    [anon_sym_dereferenceable] = ACTIONS(814),
    [anon_sym_dereferenceable_or_null] = ACTIONS(812),
    [anon_sym_swiftself] = ACTIONS(812),
    [anon_sym_swiftasync] = ACTIONS(812),
    [anon_sym_swifterror] = ACTIONS(812),
    [anon_sym_immarg] = ACTIONS(812),
    [anon_sym_noundef] = ACTIONS(812),
    [anon_sym_uwtable] = ACTIONS(812),
    [anon_sym_memory] = ACTIONS(812),
    [anon_sym_null] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(814),
  },
  [418] = {
    [sym_attribute] = STATE(435),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_metadata_refs] = STATE(1096),
    [sym_alignment] = STATE(474),
    [aux_sym_instruction_repeat1] = STATE(1096),
    [aux_sym_global_global_repeat1] = STATE(435),
    [ts_builtin_sym_end] = ACTIONS(1483),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1483),
    [sym_global_var] = ACTIONS(1483),
    [sym_local_var] = ACTIONS(1483),
    [aux_sym_metadata_ref_token1] = ACTIONS(1483),
    [sym_summary_ref] = ACTIONS(1483),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1483),
    [anon_sym_source_filename] = ACTIONS(1483),
    [anon_sym_declare] = ACTIONS(1483),
    [anon_sym_define] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(1485),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1487),
    [anon_sym_uselistorder_bb] = ACTIONS(1483),
    [anon_sym_module] = ACTIONS(1483),
    [anon_sym_attributes] = ACTIONS(1483),
  },
  [419] = {
    [sym_attribute] = STATE(435),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_metadata_refs] = STATE(1094),
    [sym_alignment] = STATE(474),
    [aux_sym_instruction_repeat1] = STATE(1094),
    [aux_sym_global_global_repeat1] = STATE(435),
    [ts_builtin_sym_end] = ACTIONS(1489),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1489),
    [sym_global_var] = ACTIONS(1489),
    [sym_local_var] = ACTIONS(1489),
    [aux_sym_metadata_ref_token1] = ACTIONS(1489),
    [sym_summary_ref] = ACTIONS(1489),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1489),
    [anon_sym_source_filename] = ACTIONS(1489),
    [anon_sym_declare] = ACTIONS(1489),
    [anon_sym_define] = ACTIONS(1489),
    [anon_sym_COMMA] = ACTIONS(1485),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1491),
    [anon_sym_uselistorder_bb] = ACTIONS(1489),
    [anon_sym_module] = ACTIONS(1489),
    [anon_sym_attributes] = ACTIONS(1489),
  },
  [420] = {
    [sym_attribute] = STATE(419),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_metadata_refs] = STATE(1098),
    [sym_alignment] = STATE(474),
    [aux_sym_instruction_repeat1] = STATE(1098),
    [aux_sym_global_global_repeat1] = STATE(419),
    [ts_builtin_sym_end] = ACTIONS(1493),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1493),
    [sym_global_var] = ACTIONS(1493),
    [sym_local_var] = ACTIONS(1493),
    [aux_sym_metadata_ref_token1] = ACTIONS(1493),
    [sym_summary_ref] = ACTIONS(1493),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1493),
    [anon_sym_source_filename] = ACTIONS(1493),
    [anon_sym_declare] = ACTIONS(1493),
    [anon_sym_define] = ACTIONS(1493),
    [anon_sym_COMMA] = ACTIONS(1485),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1495),
    [anon_sym_uselistorder_bb] = ACTIONS(1493),
    [anon_sym_module] = ACTIONS(1493),
    [anon_sym_attributes] = ACTIONS(1493),
  },
  [421] = {
    [sym_attribute] = STATE(426),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_metadata_refs] = STATE(1096),
    [sym_alignment] = STATE(474),
    [aux_sym_instruction_repeat1] = STATE(1096),
    [aux_sym_global_global_repeat1] = STATE(426),
    [ts_builtin_sym_end] = ACTIONS(1483),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1483),
    [sym_global_var] = ACTIONS(1483),
    [sym_local_var] = ACTIONS(1483),
    [aux_sym_metadata_ref_token1] = ACTIONS(1483),
    [sym_summary_ref] = ACTIONS(1483),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1483),
    [anon_sym_source_filename] = ACTIONS(1483),
    [anon_sym_declare] = ACTIONS(1483),
    [anon_sym_define] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(1485),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1487),
    [anon_sym_uselistorder_bb] = ACTIONS(1483),
    [anon_sym_module] = ACTIONS(1483),
    [anon_sym_attributes] = ACTIONS(1483),
  },
  [422] = {
    [sym_attribute] = STATE(435),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_metadata_refs] = STATE(1097),
    [sym_alignment] = STATE(474),
    [aux_sym_instruction_repeat1] = STATE(1097),
    [aux_sym_global_global_repeat1] = STATE(435),
    [ts_builtin_sym_end] = ACTIONS(1497),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1497),
    [sym_global_var] = ACTIONS(1497),
    [sym_local_var] = ACTIONS(1497),
    [aux_sym_metadata_ref_token1] = ACTIONS(1497),
    [sym_summary_ref] = ACTIONS(1497),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1497),
    [anon_sym_source_filename] = ACTIONS(1497),
    [anon_sym_declare] = ACTIONS(1497),
    [anon_sym_define] = ACTIONS(1497),
    [anon_sym_COMMA] = ACTIONS(1485),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1499),
    [anon_sym_uselistorder_bb] = ACTIONS(1497),
    [anon_sym_module] = ACTIONS(1497),
    [anon_sym_attributes] = ACTIONS(1497),
  },
  [423] = {
    [sym_attribute] = STATE(424),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_metadata_refs] = STATE(1097),
    [sym_alignment] = STATE(474),
    [aux_sym_instruction_repeat1] = STATE(1097),
    [aux_sym_global_global_repeat1] = STATE(424),
    [ts_builtin_sym_end] = ACTIONS(1497),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1497),
    [sym_global_var] = ACTIONS(1497),
    [sym_local_var] = ACTIONS(1497),
    [aux_sym_metadata_ref_token1] = ACTIONS(1497),
    [sym_summary_ref] = ACTIONS(1497),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1497),
    [anon_sym_source_filename] = ACTIONS(1497),
    [anon_sym_declare] = ACTIONS(1497),
    [anon_sym_define] = ACTIONS(1497),
    [anon_sym_COMMA] = ACTIONS(1485),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1499),
    [anon_sym_uselistorder_bb] = ACTIONS(1497),
    [anon_sym_module] = ACTIONS(1497),
    [anon_sym_attributes] = ACTIONS(1497),
  },
  [424] = {
    [sym_attribute] = STATE(435),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_metadata_refs] = STATE(1093),
    [sym_alignment] = STATE(474),
    [aux_sym_instruction_repeat1] = STATE(1093),
    [aux_sym_global_global_repeat1] = STATE(435),
    [ts_builtin_sym_end] = ACTIONS(1501),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1501),
    [sym_global_var] = ACTIONS(1501),
    [sym_local_var] = ACTIONS(1501),
    [aux_sym_metadata_ref_token1] = ACTIONS(1501),
    [sym_summary_ref] = ACTIONS(1501),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1501),
    [anon_sym_source_filename] = ACTIONS(1501),
    [anon_sym_declare] = ACTIONS(1501),
    [anon_sym_define] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(1485),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1503),
    [anon_sym_uselistorder_bb] = ACTIONS(1501),
    [anon_sym_module] = ACTIONS(1501),
    [anon_sym_attributes] = ACTIONS(1501),
  },
  [425] = {
    [sym_attribute] = STATE(422),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_metadata_refs] = STATE(1095),
    [sym_alignment] = STATE(474),
    [aux_sym_instruction_repeat1] = STATE(1095),
    [aux_sym_global_global_repeat1] = STATE(422),
    [ts_builtin_sym_end] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1505),
    [sym_global_var] = ACTIONS(1505),
    [sym_local_var] = ACTIONS(1505),
    [aux_sym_metadata_ref_token1] = ACTIONS(1505),
    [sym_summary_ref] = ACTIONS(1505),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1505),
    [anon_sym_source_filename] = ACTIONS(1505),
    [anon_sym_declare] = ACTIONS(1505),
    [anon_sym_define] = ACTIONS(1505),
    [anon_sym_COMMA] = ACTIONS(1485),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1507),
    [anon_sym_uselistorder_bb] = ACTIONS(1505),
    [anon_sym_module] = ACTIONS(1505),
    [anon_sym_attributes] = ACTIONS(1505),
  },
  [426] = {
    [sym_attribute] = STATE(435),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_metadata_refs] = STATE(1091),
    [sym_alignment] = STATE(474),
    [aux_sym_instruction_repeat1] = STATE(1091),
    [aux_sym_global_global_repeat1] = STATE(435),
    [ts_builtin_sym_end] = ACTIONS(1509),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1509),
    [sym_global_var] = ACTIONS(1509),
    [sym_local_var] = ACTIONS(1509),
    [aux_sym_metadata_ref_token1] = ACTIONS(1509),
    [sym_summary_ref] = ACTIONS(1509),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1509),
    [anon_sym_source_filename] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_define] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(1485),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1511),
    [anon_sym_uselistorder_bb] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_attributes] = ACTIONS(1509),
  },
  [427] = {
    [sym_attribute] = STATE(418),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_metadata_refs] = STATE(1090),
    [sym_alignment] = STATE(474),
    [aux_sym_instruction_repeat1] = STATE(1090),
    [aux_sym_global_global_repeat1] = STATE(418),
    [ts_builtin_sym_end] = ACTIONS(1513),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1513),
    [sym_global_var] = ACTIONS(1513),
    [sym_local_var] = ACTIONS(1513),
    [aux_sym_metadata_ref_token1] = ACTIONS(1513),
    [sym_summary_ref] = ACTIONS(1513),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1513),
    [anon_sym_source_filename] = ACTIONS(1513),
    [anon_sym_declare] = ACTIONS(1513),
    [anon_sym_define] = ACTIONS(1513),
    [anon_sym_COMMA] = ACTIONS(1485),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1515),
    [anon_sym_uselistorder_bb] = ACTIONS(1513),
    [anon_sym_module] = ACTIONS(1513),
    [anon_sym_attributes] = ACTIONS(1513),
  },
  [428] = {
    [sym_addrspace] = STATE(459),
    [sym_attribute] = STATE(461),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(461),
    [ts_builtin_sym_end] = ACTIONS(1517),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1517),
    [sym_global_var] = ACTIONS(1517),
    [sym_local_var] = ACTIONS(1517),
    [aux_sym_metadata_ref_token1] = ACTIONS(1517),
    [sym_summary_ref] = ACTIONS(1517),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1517),
    [anon_sym_source_filename] = ACTIONS(1517),
    [anon_sym_declare] = ACTIONS(1517),
    [anon_sym_define] = ACTIONS(1517),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1519),
    [anon_sym_uselistorder_bb] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(1517),
    [anon_sym_attributes] = ACTIONS(1517),
  },
  [429] = {
    [sym_addrspace] = STATE(458),
    [sym_attribute] = STATE(446),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(446),
    [ts_builtin_sym_end] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1521),
    [sym_global_var] = ACTIONS(1521),
    [sym_local_var] = ACTIONS(1521),
    [aux_sym_metadata_ref_token1] = ACTIONS(1521),
    [sym_summary_ref] = ACTIONS(1521),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1521),
    [anon_sym_source_filename] = ACTIONS(1521),
    [anon_sym_declare] = ACTIONS(1521),
    [anon_sym_define] = ACTIONS(1521),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1523),
    [anon_sym_uselistorder_bb] = ACTIONS(1521),
    [anon_sym_module] = ACTIONS(1521),
    [anon_sym_attributes] = ACTIONS(1521),
  },
  [430] = {
    [sym_addrspace] = STATE(450),
    [sym_attribute] = STATE(437),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(437),
    [ts_builtin_sym_end] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1525),
    [sym_global_var] = ACTIONS(1525),
    [sym_local_var] = ACTIONS(1525),
    [aux_sym_metadata_ref_token1] = ACTIONS(1525),
    [sym_summary_ref] = ACTIONS(1525),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1525),
    [anon_sym_source_filename] = ACTIONS(1525),
    [anon_sym_declare] = ACTIONS(1525),
    [anon_sym_define] = ACTIONS(1525),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1527),
    [anon_sym_uselistorder_bb] = ACTIONS(1525),
    [anon_sym_module] = ACTIONS(1525),
    [anon_sym_attributes] = ACTIONS(1525),
  },
  [431] = {
    [sym_addrspace] = STATE(454),
    [sym_attribute] = STATE(451),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(451),
    [ts_builtin_sym_end] = ACTIONS(1529),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1529),
    [sym_global_var] = ACTIONS(1529),
    [sym_local_var] = ACTIONS(1529),
    [aux_sym_metadata_ref_token1] = ACTIONS(1529),
    [sym_summary_ref] = ACTIONS(1529),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1529),
    [anon_sym_source_filename] = ACTIONS(1529),
    [anon_sym_declare] = ACTIONS(1529),
    [anon_sym_define] = ACTIONS(1529),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1531),
    [anon_sym_uselistorder_bb] = ACTIONS(1529),
    [anon_sym_module] = ACTIONS(1529),
    [anon_sym_attributes] = ACTIONS(1529),
  },
  [432] = {
    [sym_addrspace] = STATE(443),
    [sym_attribute] = STATE(442),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(442),
    [ts_builtin_sym_end] = ACTIONS(1533),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1533),
    [sym_global_var] = ACTIONS(1533),
    [sym_local_var] = ACTIONS(1533),
    [aux_sym_metadata_ref_token1] = ACTIONS(1533),
    [sym_summary_ref] = ACTIONS(1533),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1533),
    [anon_sym_source_filename] = ACTIONS(1533),
    [anon_sym_declare] = ACTIONS(1533),
    [anon_sym_define] = ACTIONS(1533),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1535),
    [anon_sym_uselistorder_bb] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(1533),
    [anon_sym_attributes] = ACTIONS(1533),
  },
  [433] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(895),
    [aux_sym_metadata_ref_token1] = ACTIONS(895),
    [anon_sym_unnamed_addr] = ACTIONS(895),
    [anon_sym_local_unnamed_addr] = ACTIONS(895),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_half] = ACTIONS(895),
    [anon_sym_bfloat] = ACTIONS(895),
    [anon_sym_float] = ACTIONS(895),
    [anon_sym_double] = ACTIONS(895),
    [anon_sym_x86_fp80] = ACTIONS(895),
    [anon_sym_fp128] = ACTIONS(895),
    [anon_sym_ppc_fp128] = ACTIONS(895),
    [anon_sym_label] = ACTIONS(895),
    [anon_sym_metadata] = ACTIONS(895),
    [anon_sym_x86_mmx] = ACTIONS(895),
    [anon_sym_x86_amx] = ACTIONS(895),
    [anon_sym_token] = ACTIONS(895),
    [anon_sym_opaque] = ACTIONS(895),
    [anon_sym_ptr] = ACTIONS(895),
    [aux_sym_type_keyword_token1] = ACTIONS(895),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_LT_LBRACE] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_COMMA] = ACTIONS(895),
    [anon_sym_addrspace] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_RPAREN] = ACTIONS(895),
    [anon_sym_align] = ACTIONS(897),
    [anon_sym_alignstack] = ACTIONS(895),
    [anon_sym_allocsize] = ACTIONS(895),
    [anon_sym_alwaysinline] = ACTIONS(895),
    [anon_sym_builtin] = ACTIONS(895),
    [anon_sym_cold] = ACTIONS(895),
    [anon_sym_convergent] = ACTIONS(895),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(895),
    [anon_sym_hot] = ACTIONS(895),
    [anon_sym_inaccessiblememonly] = ACTIONS(895),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(895),
    [anon_sym_inlinehint] = ACTIONS(895),
    [anon_sym_jumptable] = ACTIONS(895),
    [anon_sym_minsize] = ACTIONS(895),
    [anon_sym_naked] = ACTIONS(895),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(895),
    [anon_sym_nobuiltin] = ACTIONS(895),
    [anon_sym_noduplicate] = ACTIONS(895),
    [anon_sym_nofree] = ACTIONS(895),
    [anon_sym_noimplicitfloat] = ACTIONS(895),
    [anon_sym_noinline] = ACTIONS(895),
    [anon_sym_nomerge] = ACTIONS(895),
    [anon_sym_nonlazybind] = ACTIONS(895),
    [anon_sym_noprofile] = ACTIONS(895),
    [anon_sym_noredzone] = ACTIONS(895),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(895),
    [anon_sym_noreturn] = ACTIONS(895),
    [anon_sym_norecurse] = ACTIONS(895),
    [anon_sym_willreturn] = ACTIONS(895),
    [anon_sym_nosync] = ACTIONS(895),
    [anon_sym_nounwind] = ACTIONS(895),
    [anon_sym_nocallback] = ACTIONS(895),
    [anon_sym_nosanitize_coverage] = ACTIONS(895),
    [anon_sym_null_pointer_is_valid] = ACTIONS(895),
    [anon_sym_optforfuzzing] = ACTIONS(895),
    [anon_sym_optnone] = ACTIONS(895),
    [anon_sym_optsize] = ACTIONS(895),
    [anon_sym_readnone] = ACTIONS(895),
    [anon_sym_readonly] = ACTIONS(895),
    [anon_sym_writeonly] = ACTIONS(895),
    [anon_sym_argmemonly] = ACTIONS(895),
    [anon_sym_returns_twice] = ACTIONS(895),
    [anon_sym_safestack] = ACTIONS(895),
    [anon_sym_sanitize_address] = ACTIONS(895),
    [anon_sym_sanitize_memory] = ACTIONS(895),
    [anon_sym_sanitize_thread] = ACTIONS(895),
    [anon_sym_sanitize_hwaddress] = ACTIONS(895),
    [anon_sym_sanitize_memtag] = ACTIONS(895),
    [anon_sym_speculative_load_hardening] = ACTIONS(895),
    [anon_sym_speculatable] = ACTIONS(895),
    [anon_sym_ssp] = ACTIONS(897),
    [anon_sym_sspstrong] = ACTIONS(895),
    [anon_sym_sspreq] = ACTIONS(895),
    [anon_sym_strictfp] = ACTIONS(895),
    [anon_sym_nocf_check] = ACTIONS(895),
    [anon_sym_shadowcallstack] = ACTIONS(895),
    [anon_sym_mustprogress] = ACTIONS(895),
    [anon_sym_vscale_range] = ACTIONS(895),
    [anon_sym_preallocated] = ACTIONS(895),
    [anon_sym_zeroext] = ACTIONS(895),
    [anon_sym_signext] = ACTIONS(895),
    [anon_sym_inreg] = ACTIONS(895),
    [anon_sym_byval] = ACTIONS(895),
    [anon_sym_byref] = ACTIONS(895),
    [anon_sym_inalloca] = ACTIONS(895),
    [anon_sym_sret] = ACTIONS(895),
    [anon_sym_elementtype] = ACTIONS(895),
    [anon_sym_noalias] = ACTIONS(895),
    [anon_sym_nocapture] = ACTIONS(895),
    [anon_sym_nest] = ACTIONS(895),
    [anon_sym_returned] = ACTIONS(895),
    [anon_sym_nonnull] = ACTIONS(895),
    [anon_sym_dereferenceable] = ACTIONS(897),
    [anon_sym_dereferenceable_or_null] = ACTIONS(895),
    [anon_sym_swiftself] = ACTIONS(895),
    [anon_sym_swiftasync] = ACTIONS(895),
    [anon_sym_swifterror] = ACTIONS(895),
    [anon_sym_immarg] = ACTIONS(895),
    [anon_sym_noundef] = ACTIONS(895),
    [anon_sym_uwtable] = ACTIONS(895),
    [anon_sym_memory] = ACTIONS(895),
    [anon_sym_null] = ACTIONS(897),
    [anon_sym_BANG] = ACTIONS(897),
  },
  [434] = {
    [ts_builtin_sym_end] = ACTIONS(855),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(855),
    [sym_comdat_ref] = ACTIONS(855),
    [sym_global_var] = ACTIONS(855),
    [sym_local_var] = ACTIONS(855),
    [aux_sym_metadata_ref_token1] = ACTIONS(855),
    [sym_summary_ref] = ACTIONS(855),
    [sym_string] = ACTIONS(855),
    [anon_sym_target] = ACTIONS(855),
    [anon_sym_EQ] = ACTIONS(1539),
    [anon_sym_source_filename] = ACTIONS(855),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_define] = ACTIONS(855),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_RBRACE] = ACTIONS(855),
    [anon_sym_LBRACK] = ACTIONS(855),
    [anon_sym_COMMA] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(1541),
    [anon_sym_align] = ACTIONS(857),
    [anon_sym_section] = ACTIONS(855),
    [anon_sym_partition] = ACTIONS(855),
    [anon_sym_comdat] = ACTIONS(855),
    [anon_sym_gc] = ACTIONS(855),
    [anon_sym_prefix] = ACTIONS(855),
    [anon_sym_prologue] = ACTIONS(855),
    [anon_sym_personality] = ACTIONS(855),
    [anon_sym_alignstack] = ACTIONS(855),
    [anon_sym_allocsize] = ACTIONS(855),
    [anon_sym_alwaysinline] = ACTIONS(855),
    [anon_sym_builtin] = ACTIONS(855),
    [anon_sym_cold] = ACTIONS(855),
    [anon_sym_convergent] = ACTIONS(855),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(855),
    [anon_sym_hot] = ACTIONS(855),
    [anon_sym_inaccessiblememonly] = ACTIONS(855),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(855),
    [anon_sym_inlinehint] = ACTIONS(855),
    [anon_sym_jumptable] = ACTIONS(855),
    [anon_sym_minsize] = ACTIONS(855),
    [anon_sym_naked] = ACTIONS(855),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(855),
    [anon_sym_nobuiltin] = ACTIONS(855),
    [anon_sym_noduplicate] = ACTIONS(855),
    [anon_sym_nofree] = ACTIONS(855),
    [anon_sym_noimplicitfloat] = ACTIONS(855),
    [anon_sym_noinline] = ACTIONS(855),
    [anon_sym_nomerge] = ACTIONS(855),
    [anon_sym_nonlazybind] = ACTIONS(855),
    [anon_sym_noprofile] = ACTIONS(855),
    [anon_sym_noredzone] = ACTIONS(855),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(855),
    [anon_sym_noreturn] = ACTIONS(855),
    [anon_sym_norecurse] = ACTIONS(855),
    [anon_sym_willreturn] = ACTIONS(855),
    [anon_sym_nosync] = ACTIONS(855),
    [anon_sym_nounwind] = ACTIONS(855),
    [anon_sym_nocallback] = ACTIONS(855),
    [anon_sym_nosanitize_coverage] = ACTIONS(855),
    [anon_sym_null_pointer_is_valid] = ACTIONS(855),
    [anon_sym_optforfuzzing] = ACTIONS(855),
    [anon_sym_optnone] = ACTIONS(855),
    [anon_sym_optsize] = ACTIONS(855),
    [anon_sym_readnone] = ACTIONS(855),
    [anon_sym_readonly] = ACTIONS(855),
    [anon_sym_writeonly] = ACTIONS(855),
    [anon_sym_argmemonly] = ACTIONS(855),
    [anon_sym_returns_twice] = ACTIONS(855),
    [anon_sym_safestack] = ACTIONS(855),
    [anon_sym_sanitize_address] = ACTIONS(855),
    [anon_sym_sanitize_memory] = ACTIONS(855),
    [anon_sym_sanitize_thread] = ACTIONS(855),
    [anon_sym_sanitize_hwaddress] = ACTIONS(855),
    [anon_sym_sanitize_memtag] = ACTIONS(855),
    [anon_sym_speculative_load_hardening] = ACTIONS(855),
    [anon_sym_speculatable] = ACTIONS(855),
    [anon_sym_ssp] = ACTIONS(857),
    [anon_sym_sspstrong] = ACTIONS(855),
    [anon_sym_sspreq] = ACTIONS(855),
    [anon_sym_strictfp] = ACTIONS(855),
    [anon_sym_nocf_check] = ACTIONS(855),
    [anon_sym_shadowcallstack] = ACTIONS(855),
    [anon_sym_mustprogress] = ACTIONS(855),
    [anon_sym_vscale_range] = ACTIONS(855),
    [anon_sym_preallocated] = ACTIONS(855),
    [anon_sym_zeroext] = ACTIONS(855),
    [anon_sym_signext] = ACTIONS(855),
    [anon_sym_inreg] = ACTIONS(855),
    [anon_sym_byval] = ACTIONS(855),
    [anon_sym_byref] = ACTIONS(855),
    [anon_sym_inalloca] = ACTIONS(855),
    [anon_sym_sret] = ACTIONS(855),
    [anon_sym_elementtype] = ACTIONS(855),
    [anon_sym_noalias] = ACTIONS(855),
    [anon_sym_nocapture] = ACTIONS(855),
    [anon_sym_nest] = ACTIONS(855),
    [anon_sym_returned] = ACTIONS(855),
    [anon_sym_nonnull] = ACTIONS(855),
    [anon_sym_dereferenceable] = ACTIONS(857),
    [anon_sym_dereferenceable_or_null] = ACTIONS(855),
    [anon_sym_swiftself] = ACTIONS(855),
    [anon_sym_swiftasync] = ACTIONS(855),
    [anon_sym_swifterror] = ACTIONS(855),
    [anon_sym_immarg] = ACTIONS(855),
    [anon_sym_noundef] = ACTIONS(855),
    [anon_sym_uwtable] = ACTIONS(855),
    [anon_sym_memory] = ACTIONS(855),
    [anon_sym_to] = ACTIONS(855),
    [anon_sym_uselistorder] = ACTIONS(857),
    [anon_sym_uselistorder_bb] = ACTIONS(855),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_attributes] = ACTIONS(855),
  },
  [435] = {
    [sym_attribute] = STATE(435),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_global_global_repeat1] = STATE(435),
    [ts_builtin_sym_end] = ACTIONS(1543),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1545),
    [sym_comdat_ref] = ACTIONS(1543),
    [sym_global_var] = ACTIONS(1543),
    [sym_local_var] = ACTIONS(1543),
    [aux_sym_metadata_ref_token1] = ACTIONS(1543),
    [sym_summary_ref] = ACTIONS(1543),
    [sym_string] = ACTIONS(1545),
    [anon_sym_target] = ACTIONS(1543),
    [anon_sym_source_filename] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_define] = ACTIONS(1543),
    [anon_sym_COMMA] = ACTIONS(1548),
    [anon_sym_align] = ACTIONS(1551),
    [anon_sym_section] = ACTIONS(1554),
    [anon_sym_partition] = ACTIONS(1554),
    [anon_sym_comdat] = ACTIONS(1557),
    [anon_sym_gc] = ACTIONS(1554),
    [anon_sym_prefix] = ACTIONS(1560),
    [anon_sym_prologue] = ACTIONS(1560),
    [anon_sym_personality] = ACTIONS(1560),
    [anon_sym_alignstack] = ACTIONS(1563),
    [anon_sym_allocsize] = ACTIONS(1563),
    [anon_sym_alwaysinline] = ACTIONS(1563),
    [anon_sym_builtin] = ACTIONS(1563),
    [anon_sym_cold] = ACTIONS(1563),
    [anon_sym_convergent] = ACTIONS(1563),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1563),
    [anon_sym_hot] = ACTIONS(1563),
    [anon_sym_inaccessiblememonly] = ACTIONS(1563),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1563),
    [anon_sym_inlinehint] = ACTIONS(1563),
    [anon_sym_jumptable] = ACTIONS(1563),
    [anon_sym_minsize] = ACTIONS(1563),
    [anon_sym_naked] = ACTIONS(1563),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1563),
    [anon_sym_nobuiltin] = ACTIONS(1563),
    [anon_sym_noduplicate] = ACTIONS(1563),
    [anon_sym_nofree] = ACTIONS(1563),
    [anon_sym_noimplicitfloat] = ACTIONS(1563),
    [anon_sym_noinline] = ACTIONS(1563),
    [anon_sym_nomerge] = ACTIONS(1563),
    [anon_sym_nonlazybind] = ACTIONS(1563),
    [anon_sym_noprofile] = ACTIONS(1563),
    [anon_sym_noredzone] = ACTIONS(1563),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1563),
    [anon_sym_noreturn] = ACTIONS(1563),
    [anon_sym_norecurse] = ACTIONS(1563),
    [anon_sym_willreturn] = ACTIONS(1563),
    [anon_sym_nosync] = ACTIONS(1563),
    [anon_sym_nounwind] = ACTIONS(1563),
    [anon_sym_nocallback] = ACTIONS(1563),
    [anon_sym_nosanitize_coverage] = ACTIONS(1563),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1563),
    [anon_sym_optforfuzzing] = ACTIONS(1563),
    [anon_sym_optnone] = ACTIONS(1563),
    [anon_sym_optsize] = ACTIONS(1563),
    [anon_sym_readnone] = ACTIONS(1563),
    [anon_sym_readonly] = ACTIONS(1563),
    [anon_sym_writeonly] = ACTIONS(1563),
    [anon_sym_argmemonly] = ACTIONS(1563),
    [anon_sym_returns_twice] = ACTIONS(1563),
    [anon_sym_safestack] = ACTIONS(1563),
    [anon_sym_sanitize_address] = ACTIONS(1563),
    [anon_sym_sanitize_memory] = ACTIONS(1563),
    [anon_sym_sanitize_thread] = ACTIONS(1563),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1563),
    [anon_sym_sanitize_memtag] = ACTIONS(1563),
    [anon_sym_speculative_load_hardening] = ACTIONS(1563),
    [anon_sym_speculatable] = ACTIONS(1563),
    [anon_sym_ssp] = ACTIONS(1566),
    [anon_sym_sspstrong] = ACTIONS(1563),
    [anon_sym_sspreq] = ACTIONS(1563),
    [anon_sym_strictfp] = ACTIONS(1563),
    [anon_sym_nocf_check] = ACTIONS(1563),
    [anon_sym_shadowcallstack] = ACTIONS(1563),
    [anon_sym_mustprogress] = ACTIONS(1563),
    [anon_sym_vscale_range] = ACTIONS(1563),
    [anon_sym_preallocated] = ACTIONS(1563),
    [anon_sym_zeroext] = ACTIONS(1563),
    [anon_sym_signext] = ACTIONS(1563),
    [anon_sym_inreg] = ACTIONS(1563),
    [anon_sym_byval] = ACTIONS(1563),
    [anon_sym_byref] = ACTIONS(1563),
    [anon_sym_inalloca] = ACTIONS(1563),
    [anon_sym_sret] = ACTIONS(1563),
    [anon_sym_elementtype] = ACTIONS(1563),
    [anon_sym_noalias] = ACTIONS(1563),
    [anon_sym_nocapture] = ACTIONS(1563),
    [anon_sym_nest] = ACTIONS(1563),
    [anon_sym_returned] = ACTIONS(1563),
    [anon_sym_nonnull] = ACTIONS(1563),
    [anon_sym_dereferenceable] = ACTIONS(1566),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1563),
    [anon_sym_swiftself] = ACTIONS(1563),
    [anon_sym_swiftasync] = ACTIONS(1563),
    [anon_sym_swifterror] = ACTIONS(1563),
    [anon_sym_immarg] = ACTIONS(1563),
    [anon_sym_noundef] = ACTIONS(1563),
    [anon_sym_uwtable] = ACTIONS(1569),
    [anon_sym_memory] = ACTIONS(1572),
    [anon_sym_uselistorder] = ACTIONS(1575),
    [anon_sym_uselistorder_bb] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_attributes] = ACTIONS(1543),
  },
  [436] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(905),
    [aux_sym_metadata_ref_token1] = ACTIONS(905),
    [anon_sym_unnamed_addr] = ACTIONS(905),
    [anon_sym_local_unnamed_addr] = ACTIONS(905),
    [anon_sym_void] = ACTIONS(905),
    [anon_sym_half] = ACTIONS(905),
    [anon_sym_bfloat] = ACTIONS(905),
    [anon_sym_float] = ACTIONS(905),
    [anon_sym_double] = ACTIONS(905),
    [anon_sym_x86_fp80] = ACTIONS(905),
    [anon_sym_fp128] = ACTIONS(905),
    [anon_sym_ppc_fp128] = ACTIONS(905),
    [anon_sym_label] = ACTIONS(905),
    [anon_sym_metadata] = ACTIONS(905),
    [anon_sym_x86_mmx] = ACTIONS(905),
    [anon_sym_x86_amx] = ACTIONS(905),
    [anon_sym_token] = ACTIONS(905),
    [anon_sym_opaque] = ACTIONS(905),
    [anon_sym_ptr] = ACTIONS(905),
    [aux_sym_type_keyword_token1] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_LT_LBRACE] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(905),
    [anon_sym_addrspace] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_align] = ACTIONS(907),
    [anon_sym_alignstack] = ACTIONS(905),
    [anon_sym_allocsize] = ACTIONS(905),
    [anon_sym_alwaysinline] = ACTIONS(905),
    [anon_sym_builtin] = ACTIONS(905),
    [anon_sym_cold] = ACTIONS(905),
    [anon_sym_convergent] = ACTIONS(905),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(905),
    [anon_sym_hot] = ACTIONS(905),
    [anon_sym_inaccessiblememonly] = ACTIONS(905),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(905),
    [anon_sym_inlinehint] = ACTIONS(905),
    [anon_sym_jumptable] = ACTIONS(905),
    [anon_sym_minsize] = ACTIONS(905),
    [anon_sym_naked] = ACTIONS(905),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(905),
    [anon_sym_nobuiltin] = ACTIONS(905),
    [anon_sym_noduplicate] = ACTIONS(905),
    [anon_sym_nofree] = ACTIONS(905),
    [anon_sym_noimplicitfloat] = ACTIONS(905),
    [anon_sym_noinline] = ACTIONS(905),
    [anon_sym_nomerge] = ACTIONS(905),
    [anon_sym_nonlazybind] = ACTIONS(905),
    [anon_sym_noprofile] = ACTIONS(905),
    [anon_sym_noredzone] = ACTIONS(905),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(905),
    [anon_sym_noreturn] = ACTIONS(905),
    [anon_sym_norecurse] = ACTIONS(905),
    [anon_sym_willreturn] = ACTIONS(905),
    [anon_sym_nosync] = ACTIONS(905),
    [anon_sym_nounwind] = ACTIONS(905),
    [anon_sym_nocallback] = ACTIONS(905),
    [anon_sym_nosanitize_coverage] = ACTIONS(905),
    [anon_sym_null_pointer_is_valid] = ACTIONS(905),
    [anon_sym_optforfuzzing] = ACTIONS(905),
    [anon_sym_optnone] = ACTIONS(905),
    [anon_sym_optsize] = ACTIONS(905),
    [anon_sym_readnone] = ACTIONS(905),
    [anon_sym_readonly] = ACTIONS(905),
    [anon_sym_writeonly] = ACTIONS(905),
    [anon_sym_argmemonly] = ACTIONS(905),
    [anon_sym_returns_twice] = ACTIONS(905),
    [anon_sym_safestack] = ACTIONS(905),
    [anon_sym_sanitize_address] = ACTIONS(905),
    [anon_sym_sanitize_memory] = ACTIONS(905),
    [anon_sym_sanitize_thread] = ACTIONS(905),
    [anon_sym_sanitize_hwaddress] = ACTIONS(905),
    [anon_sym_sanitize_memtag] = ACTIONS(905),
    [anon_sym_speculative_load_hardening] = ACTIONS(905),
    [anon_sym_speculatable] = ACTIONS(905),
    [anon_sym_ssp] = ACTIONS(907),
    [anon_sym_sspstrong] = ACTIONS(905),
    [anon_sym_sspreq] = ACTIONS(905),
    [anon_sym_strictfp] = ACTIONS(905),
    [anon_sym_nocf_check] = ACTIONS(905),
    [anon_sym_shadowcallstack] = ACTIONS(905),
    [anon_sym_mustprogress] = ACTIONS(905),
    [anon_sym_vscale_range] = ACTIONS(905),
    [anon_sym_preallocated] = ACTIONS(905),
    [anon_sym_zeroext] = ACTIONS(905),
    [anon_sym_signext] = ACTIONS(905),
    [anon_sym_inreg] = ACTIONS(905),
    [anon_sym_byval] = ACTIONS(905),
    [anon_sym_byref] = ACTIONS(905),
    [anon_sym_inalloca] = ACTIONS(905),
    [anon_sym_sret] = ACTIONS(905),
    [anon_sym_elementtype] = ACTIONS(905),
    [anon_sym_noalias] = ACTIONS(905),
    [anon_sym_nocapture] = ACTIONS(905),
    [anon_sym_nest] = ACTIONS(905),
    [anon_sym_returned] = ACTIONS(905),
    [anon_sym_nonnull] = ACTIONS(905),
    [anon_sym_dereferenceable] = ACTIONS(907),
    [anon_sym_dereferenceable_or_null] = ACTIONS(905),
    [anon_sym_swiftself] = ACTIONS(905),
    [anon_sym_swiftasync] = ACTIONS(905),
    [anon_sym_swifterror] = ACTIONS(905),
    [anon_sym_immarg] = ACTIONS(905),
    [anon_sym_noundef] = ACTIONS(905),
    [anon_sym_uwtable] = ACTIONS(905),
    [anon_sym_memory] = ACTIONS(905),
    [anon_sym_null] = ACTIONS(907),
    [anon_sym_BANG] = ACTIONS(907),
  },
  [437] = {
    [sym_attribute] = STATE(441),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(441),
    [ts_builtin_sym_end] = ACTIONS(1577),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1577),
    [sym_global_var] = ACTIONS(1577),
    [sym_local_var] = ACTIONS(1577),
    [aux_sym_metadata_ref_token1] = ACTIONS(1577),
    [sym_summary_ref] = ACTIONS(1577),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1577),
    [anon_sym_source_filename] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_define] = ACTIONS(1577),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1579),
    [anon_sym_uselistorder_bb] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_attributes] = ACTIONS(1577),
  },
  [438] = {
    [sym_attribute] = STATE(441),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(441),
    [ts_builtin_sym_end] = ACTIONS(1581),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1581),
    [sym_global_var] = ACTIONS(1581),
    [sym_local_var] = ACTIONS(1581),
    [aux_sym_metadata_ref_token1] = ACTIONS(1581),
    [sym_summary_ref] = ACTIONS(1581),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1581),
    [anon_sym_source_filename] = ACTIONS(1581),
    [anon_sym_declare] = ACTIONS(1581),
    [anon_sym_define] = ACTIONS(1581),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1583),
    [anon_sym_uselistorder_bb] = ACTIONS(1581),
    [anon_sym_module] = ACTIONS(1581),
    [anon_sym_attributes] = ACTIONS(1581),
  },
  [439] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(909),
    [aux_sym_metadata_ref_token1] = ACTIONS(909),
    [anon_sym_unnamed_addr] = ACTIONS(909),
    [anon_sym_local_unnamed_addr] = ACTIONS(909),
    [anon_sym_void] = ACTIONS(909),
    [anon_sym_half] = ACTIONS(909),
    [anon_sym_bfloat] = ACTIONS(909),
    [anon_sym_float] = ACTIONS(909),
    [anon_sym_double] = ACTIONS(909),
    [anon_sym_x86_fp80] = ACTIONS(909),
    [anon_sym_fp128] = ACTIONS(909),
    [anon_sym_ppc_fp128] = ACTIONS(909),
    [anon_sym_label] = ACTIONS(909),
    [anon_sym_metadata] = ACTIONS(909),
    [anon_sym_x86_mmx] = ACTIONS(909),
    [anon_sym_x86_amx] = ACTIONS(909),
    [anon_sym_token] = ACTIONS(909),
    [anon_sym_opaque] = ACTIONS(909),
    [anon_sym_ptr] = ACTIONS(909),
    [aux_sym_type_keyword_token1] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_LT_LBRACE] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_addrspace] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_align] = ACTIONS(911),
    [anon_sym_alignstack] = ACTIONS(909),
    [anon_sym_allocsize] = ACTIONS(909),
    [anon_sym_alwaysinline] = ACTIONS(909),
    [anon_sym_builtin] = ACTIONS(909),
    [anon_sym_cold] = ACTIONS(909),
    [anon_sym_convergent] = ACTIONS(909),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(909),
    [anon_sym_hot] = ACTIONS(909),
    [anon_sym_inaccessiblememonly] = ACTIONS(909),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(909),
    [anon_sym_inlinehint] = ACTIONS(909),
    [anon_sym_jumptable] = ACTIONS(909),
    [anon_sym_minsize] = ACTIONS(909),
    [anon_sym_naked] = ACTIONS(909),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(909),
    [anon_sym_nobuiltin] = ACTIONS(909),
    [anon_sym_noduplicate] = ACTIONS(909),
    [anon_sym_nofree] = ACTIONS(909),
    [anon_sym_noimplicitfloat] = ACTIONS(909),
    [anon_sym_noinline] = ACTIONS(909),
    [anon_sym_nomerge] = ACTIONS(909),
    [anon_sym_nonlazybind] = ACTIONS(909),
    [anon_sym_noprofile] = ACTIONS(909),
    [anon_sym_noredzone] = ACTIONS(909),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(909),
    [anon_sym_noreturn] = ACTIONS(909),
    [anon_sym_norecurse] = ACTIONS(909),
    [anon_sym_willreturn] = ACTIONS(909),
    [anon_sym_nosync] = ACTIONS(909),
    [anon_sym_nounwind] = ACTIONS(909),
    [anon_sym_nocallback] = ACTIONS(909),
    [anon_sym_nosanitize_coverage] = ACTIONS(909),
    [anon_sym_null_pointer_is_valid] = ACTIONS(909),
    [anon_sym_optforfuzzing] = ACTIONS(909),
    [anon_sym_optnone] = ACTIONS(909),
    [anon_sym_optsize] = ACTIONS(909),
    [anon_sym_readnone] = ACTIONS(909),
    [anon_sym_readonly] = ACTIONS(909),
    [anon_sym_writeonly] = ACTIONS(909),
    [anon_sym_argmemonly] = ACTIONS(909),
    [anon_sym_returns_twice] = ACTIONS(909),
    [anon_sym_safestack] = ACTIONS(909),
    [anon_sym_sanitize_address] = ACTIONS(909),
    [anon_sym_sanitize_memory] = ACTIONS(909),
    [anon_sym_sanitize_thread] = ACTIONS(909),
    [anon_sym_sanitize_hwaddress] = ACTIONS(909),
    [anon_sym_sanitize_memtag] = ACTIONS(909),
    [anon_sym_speculative_load_hardening] = ACTIONS(909),
    [anon_sym_speculatable] = ACTIONS(909),
    [anon_sym_ssp] = ACTIONS(911),
    [anon_sym_sspstrong] = ACTIONS(909),
    [anon_sym_sspreq] = ACTIONS(909),
    [anon_sym_strictfp] = ACTIONS(909),
    [anon_sym_nocf_check] = ACTIONS(909),
    [anon_sym_shadowcallstack] = ACTIONS(909),
    [anon_sym_mustprogress] = ACTIONS(909),
    [anon_sym_vscale_range] = ACTIONS(909),
    [anon_sym_preallocated] = ACTIONS(909),
    [anon_sym_zeroext] = ACTIONS(909),
    [anon_sym_signext] = ACTIONS(909),
    [anon_sym_inreg] = ACTIONS(909),
    [anon_sym_byval] = ACTIONS(909),
    [anon_sym_byref] = ACTIONS(909),
    [anon_sym_inalloca] = ACTIONS(909),
    [anon_sym_sret] = ACTIONS(909),
    [anon_sym_elementtype] = ACTIONS(909),
    [anon_sym_noalias] = ACTIONS(909),
    [anon_sym_nocapture] = ACTIONS(909),
    [anon_sym_nest] = ACTIONS(909),
    [anon_sym_returned] = ACTIONS(909),
    [anon_sym_nonnull] = ACTIONS(909),
    [anon_sym_dereferenceable] = ACTIONS(911),
    [anon_sym_dereferenceable_or_null] = ACTIONS(909),
    [anon_sym_swiftself] = ACTIONS(909),
    [anon_sym_swiftasync] = ACTIONS(909),
    [anon_sym_swifterror] = ACTIONS(909),
    [anon_sym_immarg] = ACTIONS(909),
    [anon_sym_noundef] = ACTIONS(909),
    [anon_sym_uwtable] = ACTIONS(909),
    [anon_sym_memory] = ACTIONS(909),
    [anon_sym_null] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(911),
  },
  [440] = {
    [sym_attribute] = STATE(441),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(441),
    [ts_builtin_sym_end] = ACTIONS(1585),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1585),
    [sym_global_var] = ACTIONS(1585),
    [sym_local_var] = ACTIONS(1585),
    [aux_sym_metadata_ref_token1] = ACTIONS(1585),
    [sym_summary_ref] = ACTIONS(1585),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1585),
    [anon_sym_source_filename] = ACTIONS(1585),
    [anon_sym_declare] = ACTIONS(1585),
    [anon_sym_define] = ACTIONS(1585),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1587),
    [anon_sym_uselistorder_bb] = ACTIONS(1585),
    [anon_sym_module] = ACTIONS(1585),
    [anon_sym_attributes] = ACTIONS(1585),
  },
  [441] = {
    [sym_attribute] = STATE(441),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(441),
    [ts_builtin_sym_end] = ACTIONS(784),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1589),
    [sym_comdat_ref] = ACTIONS(784),
    [sym_global_var] = ACTIONS(784),
    [sym_local_var] = ACTIONS(784),
    [aux_sym_metadata_ref_token1] = ACTIONS(784),
    [sym_summary_ref] = ACTIONS(784),
    [sym_string] = ACTIONS(1589),
    [anon_sym_target] = ACTIONS(784),
    [anon_sym_source_filename] = ACTIONS(784),
    [anon_sym_declare] = ACTIONS(784),
    [anon_sym_define] = ACTIONS(784),
    [anon_sym_align] = ACTIONS(1592),
    [anon_sym_section] = ACTIONS(1595),
    [anon_sym_partition] = ACTIONS(1595),
    [anon_sym_comdat] = ACTIONS(1598),
    [anon_sym_gc] = ACTIONS(1595),
    [anon_sym_prefix] = ACTIONS(1601),
    [anon_sym_prologue] = ACTIONS(1601),
    [anon_sym_personality] = ACTIONS(1601),
    [anon_sym_alignstack] = ACTIONS(1604),
    [anon_sym_allocsize] = ACTIONS(1604),
    [anon_sym_alwaysinline] = ACTIONS(1604),
    [anon_sym_builtin] = ACTIONS(1604),
    [anon_sym_cold] = ACTIONS(1604),
    [anon_sym_convergent] = ACTIONS(1604),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1604),
    [anon_sym_hot] = ACTIONS(1604),
    [anon_sym_inaccessiblememonly] = ACTIONS(1604),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1604),
    [anon_sym_inlinehint] = ACTIONS(1604),
    [anon_sym_jumptable] = ACTIONS(1604),
    [anon_sym_minsize] = ACTIONS(1604),
    [anon_sym_naked] = ACTIONS(1604),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1604),
    [anon_sym_nobuiltin] = ACTIONS(1604),
    [anon_sym_noduplicate] = ACTIONS(1604),
    [anon_sym_nofree] = ACTIONS(1604),
    [anon_sym_noimplicitfloat] = ACTIONS(1604),
    [anon_sym_noinline] = ACTIONS(1604),
    [anon_sym_nomerge] = ACTIONS(1604),
    [anon_sym_nonlazybind] = ACTIONS(1604),
    [anon_sym_noprofile] = ACTIONS(1604),
    [anon_sym_noredzone] = ACTIONS(1604),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1604),
    [anon_sym_noreturn] = ACTIONS(1604),
    [anon_sym_norecurse] = ACTIONS(1604),
    [anon_sym_willreturn] = ACTIONS(1604),
    [anon_sym_nosync] = ACTIONS(1604),
    [anon_sym_nounwind] = ACTIONS(1604),
    [anon_sym_nocallback] = ACTIONS(1604),
    [anon_sym_nosanitize_coverage] = ACTIONS(1604),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1604),
    [anon_sym_optforfuzzing] = ACTIONS(1604),
    [anon_sym_optnone] = ACTIONS(1604),
    [anon_sym_optsize] = ACTIONS(1604),
    [anon_sym_readnone] = ACTIONS(1604),
    [anon_sym_readonly] = ACTIONS(1604),
    [anon_sym_writeonly] = ACTIONS(1604),
    [anon_sym_argmemonly] = ACTIONS(1604),
    [anon_sym_returns_twice] = ACTIONS(1604),
    [anon_sym_safestack] = ACTIONS(1604),
    [anon_sym_sanitize_address] = ACTIONS(1604),
    [anon_sym_sanitize_memory] = ACTIONS(1604),
    [anon_sym_sanitize_thread] = ACTIONS(1604),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1604),
    [anon_sym_sanitize_memtag] = ACTIONS(1604),
    [anon_sym_speculative_load_hardening] = ACTIONS(1604),
    [anon_sym_speculatable] = ACTIONS(1604),
    [anon_sym_ssp] = ACTIONS(1607),
    [anon_sym_sspstrong] = ACTIONS(1604),
    [anon_sym_sspreq] = ACTIONS(1604),
    [anon_sym_strictfp] = ACTIONS(1604),
    [anon_sym_nocf_check] = ACTIONS(1604),
    [anon_sym_shadowcallstack] = ACTIONS(1604),
    [anon_sym_mustprogress] = ACTIONS(1604),
    [anon_sym_vscale_range] = ACTIONS(1604),
    [anon_sym_preallocated] = ACTIONS(1604),
    [anon_sym_zeroext] = ACTIONS(1604),
    [anon_sym_signext] = ACTIONS(1604),
    [anon_sym_inreg] = ACTIONS(1604),
    [anon_sym_byval] = ACTIONS(1604),
    [anon_sym_byref] = ACTIONS(1604),
    [anon_sym_inalloca] = ACTIONS(1604),
    [anon_sym_sret] = ACTIONS(1604),
    [anon_sym_elementtype] = ACTIONS(1604),
    [anon_sym_noalias] = ACTIONS(1604),
    [anon_sym_nocapture] = ACTIONS(1604),
    [anon_sym_nest] = ACTIONS(1604),
    [anon_sym_returned] = ACTIONS(1604),
    [anon_sym_nonnull] = ACTIONS(1604),
    [anon_sym_dereferenceable] = ACTIONS(1607),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1604),
    [anon_sym_swiftself] = ACTIONS(1604),
    [anon_sym_swiftasync] = ACTIONS(1604),
    [anon_sym_swifterror] = ACTIONS(1604),
    [anon_sym_immarg] = ACTIONS(1604),
    [anon_sym_noundef] = ACTIONS(1604),
    [anon_sym_uwtable] = ACTIONS(1610),
    [anon_sym_memory] = ACTIONS(1613),
    [anon_sym_uselistorder] = ACTIONS(810),
    [anon_sym_uselistorder_bb] = ACTIONS(784),
    [anon_sym_module] = ACTIONS(784),
    [anon_sym_attributes] = ACTIONS(784),
  },
  [442] = {
    [sym_attribute] = STATE(441),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(441),
    [ts_builtin_sym_end] = ACTIONS(1616),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1616),
    [sym_global_var] = ACTIONS(1616),
    [sym_local_var] = ACTIONS(1616),
    [aux_sym_metadata_ref_token1] = ACTIONS(1616),
    [sym_summary_ref] = ACTIONS(1616),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1616),
    [anon_sym_source_filename] = ACTIONS(1616),
    [anon_sym_declare] = ACTIONS(1616),
    [anon_sym_define] = ACTIONS(1616),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1618),
    [anon_sym_uselistorder_bb] = ACTIONS(1616),
    [anon_sym_module] = ACTIONS(1616),
    [anon_sym_attributes] = ACTIONS(1616),
  },
  [443] = {
    [sym_attribute] = STATE(464),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(464),
    [ts_builtin_sym_end] = ACTIONS(1616),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1616),
    [sym_global_var] = ACTIONS(1616),
    [sym_local_var] = ACTIONS(1616),
    [aux_sym_metadata_ref_token1] = ACTIONS(1616),
    [sym_summary_ref] = ACTIONS(1616),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1616),
    [anon_sym_source_filename] = ACTIONS(1616),
    [anon_sym_declare] = ACTIONS(1616),
    [anon_sym_define] = ACTIONS(1616),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1618),
    [anon_sym_uselistorder_bb] = ACTIONS(1616),
    [anon_sym_module] = ACTIONS(1616),
    [anon_sym_attributes] = ACTIONS(1616),
  },
  [444] = {
    [sym_attribute] = STATE(441),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(441),
    [ts_builtin_sym_end] = ACTIONS(1529),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1529),
    [sym_global_var] = ACTIONS(1529),
    [sym_local_var] = ACTIONS(1529),
    [aux_sym_metadata_ref_token1] = ACTIONS(1529),
    [sym_summary_ref] = ACTIONS(1529),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1529),
    [anon_sym_source_filename] = ACTIONS(1529),
    [anon_sym_declare] = ACTIONS(1529),
    [anon_sym_define] = ACTIONS(1529),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1531),
    [anon_sym_uselistorder_bb] = ACTIONS(1529),
    [anon_sym_module] = ACTIONS(1529),
    [anon_sym_attributes] = ACTIONS(1529),
  },
  [445] = {
    [sym_number] = STATE(490),
    [sym_linkage_aux] = STATE(490),
    [sym_attribute_name] = STATE(490),
    [sym_uwtable] = STATE(493),
    [sym_memory_attribute] = STATE(493),
    [sym_summary_value] = STATE(445),
    [aux_sym_summary_entry_repeat1] = STATE(445),
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(1620),
    [sym_string] = ACTIONS(1620),
    [aux_sym_number_token1] = ACTIONS(1623),
    [aux_sym_number_token2] = ACTIONS(1623),
    [anon_sym_private] = ACTIONS(1626),
    [anon_sym_internal] = ACTIONS(1626),
    [anon_sym_weak] = ACTIONS(1626),
    [anon_sym_weak_odr] = ACTIONS(1626),
    [anon_sym_linkonce] = ACTIONS(1626),
    [anon_sym_linkonce_odr] = ACTIONS(1626),
    [anon_sym_available_externally] = ACTIONS(1626),
    [anon_sym_appending] = ACTIONS(1626),
    [anon_sym_common] = ACTIONS(1626),
    [anon_sym_extern_weak] = ACTIONS(1626),
    [anon_sym_external] = ACTIONS(1626),
    [anon_sym_LBRACK] = ACTIONS(1629),
    [anon_sym_RBRACK] = ACTIONS(1632),
    [anon_sym_COMMA] = ACTIONS(1620),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_RPAREN] = ACTIONS(1632),
    [anon_sym_align] = ACTIONS(1637),
    [anon_sym_alignstack] = ACTIONS(1637),
    [anon_sym_allocsize] = ACTIONS(1637),
    [anon_sym_alwaysinline] = ACTIONS(1637),
    [anon_sym_builtin] = ACTIONS(1637),
    [anon_sym_cold] = ACTIONS(1637),
    [anon_sym_convergent] = ACTIONS(1637),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1637),
    [anon_sym_hot] = ACTIONS(1637),
    [anon_sym_inaccessiblememonly] = ACTIONS(1637),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1637),
    [anon_sym_inlinehint] = ACTIONS(1637),
    [anon_sym_jumptable] = ACTIONS(1637),
    [anon_sym_minsize] = ACTIONS(1637),
    [anon_sym_naked] = ACTIONS(1637),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1637),
    [anon_sym_nobuiltin] = ACTIONS(1637),
    [anon_sym_noduplicate] = ACTIONS(1637),
    [anon_sym_nofree] = ACTIONS(1637),
    [anon_sym_noimplicitfloat] = ACTIONS(1637),
    [anon_sym_noinline] = ACTIONS(1637),
    [anon_sym_nomerge] = ACTIONS(1637),
    [anon_sym_nonlazybind] = ACTIONS(1637),
    [anon_sym_noprofile] = ACTIONS(1637),
    [anon_sym_noredzone] = ACTIONS(1637),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1637),
    [anon_sym_noreturn] = ACTIONS(1637),
    [anon_sym_norecurse] = ACTIONS(1637),
    [anon_sym_willreturn] = ACTIONS(1637),
    [anon_sym_nosync] = ACTIONS(1637),
    [anon_sym_nounwind] = ACTIONS(1637),
    [anon_sym_nocallback] = ACTIONS(1637),
    [anon_sym_nosanitize_coverage] = ACTIONS(1637),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1637),
    [anon_sym_optforfuzzing] = ACTIONS(1637),
    [anon_sym_optnone] = ACTIONS(1637),
    [anon_sym_optsize] = ACTIONS(1637),
    [anon_sym_readnone] = ACTIONS(1637),
    [anon_sym_readonly] = ACTIONS(1637),
    [anon_sym_writeonly] = ACTIONS(1637),
    [anon_sym_argmemonly] = ACTIONS(1637),
    [anon_sym_returns_twice] = ACTIONS(1637),
    [anon_sym_safestack] = ACTIONS(1637),
    [anon_sym_sanitize_address] = ACTIONS(1637),
    [anon_sym_sanitize_memory] = ACTIONS(1637),
    [anon_sym_sanitize_thread] = ACTIONS(1637),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1637),
    [anon_sym_sanitize_memtag] = ACTIONS(1637),
    [anon_sym_speculative_load_hardening] = ACTIONS(1637),
    [anon_sym_speculatable] = ACTIONS(1637),
    [anon_sym_ssp] = ACTIONS(1637),
    [anon_sym_sspstrong] = ACTIONS(1637),
    [anon_sym_sspreq] = ACTIONS(1637),
    [anon_sym_strictfp] = ACTIONS(1637),
    [anon_sym_nocf_check] = ACTIONS(1637),
    [anon_sym_shadowcallstack] = ACTIONS(1637),
    [anon_sym_mustprogress] = ACTIONS(1637),
    [anon_sym_vscale_range] = ACTIONS(1637),
    [anon_sym_preallocated] = ACTIONS(1637),
    [anon_sym_zeroext] = ACTIONS(1637),
    [anon_sym_signext] = ACTIONS(1637),
    [anon_sym_inreg] = ACTIONS(1637),
    [anon_sym_byval] = ACTIONS(1637),
    [anon_sym_byref] = ACTIONS(1637),
    [anon_sym_inalloca] = ACTIONS(1637),
    [anon_sym_sret] = ACTIONS(1637),
    [anon_sym_elementtype] = ACTIONS(1637),
    [anon_sym_noalias] = ACTIONS(1637),
    [anon_sym_nocapture] = ACTIONS(1637),
    [anon_sym_nest] = ACTIONS(1637),
    [anon_sym_returned] = ACTIONS(1637),
    [anon_sym_nonnull] = ACTIONS(1637),
    [anon_sym_dereferenceable] = ACTIONS(1637),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1637),
    [anon_sym_swiftself] = ACTIONS(1637),
    [anon_sym_swiftasync] = ACTIONS(1637),
    [anon_sym_swifterror] = ACTIONS(1637),
    [anon_sym_immarg] = ACTIONS(1637),
    [anon_sym_noundef] = ACTIONS(1637),
    [anon_sym_uwtable] = ACTIONS(1640),
    [anon_sym_memory] = ACTIONS(1643),
    [anon_sym_COLON] = ACTIONS(1620),
    [aux_sym_specialized_md_value_token1] = ACTIONS(1646),
  },
  [446] = {
    [sym_attribute] = STATE(441),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(441),
    [ts_builtin_sym_end] = ACTIONS(1649),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1649),
    [sym_global_var] = ACTIONS(1649),
    [sym_local_var] = ACTIONS(1649),
    [aux_sym_metadata_ref_token1] = ACTIONS(1649),
    [sym_summary_ref] = ACTIONS(1649),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1649),
    [anon_sym_source_filename] = ACTIONS(1649),
    [anon_sym_declare] = ACTIONS(1649),
    [anon_sym_define] = ACTIONS(1649),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1651),
    [anon_sym_uselistorder_bb] = ACTIONS(1649),
    [anon_sym_module] = ACTIONS(1649),
    [anon_sym_attributes] = ACTIONS(1649),
  },
  [447] = {
    [sym_attribute] = STATE(451),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(451),
    [ts_builtin_sym_end] = ACTIONS(1529),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1529),
    [sym_global_var] = ACTIONS(1529),
    [sym_local_var] = ACTIONS(1529),
    [aux_sym_metadata_ref_token1] = ACTIONS(1529),
    [sym_summary_ref] = ACTIONS(1529),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1529),
    [anon_sym_source_filename] = ACTIONS(1529),
    [anon_sym_declare] = ACTIONS(1529),
    [anon_sym_define] = ACTIONS(1529),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1531),
    [anon_sym_uselistorder_bb] = ACTIONS(1529),
    [anon_sym_module] = ACTIONS(1529),
    [anon_sym_attributes] = ACTIONS(1529),
  },
  [448] = {
    [sym_attribute] = STATE(442),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(442),
    [ts_builtin_sym_end] = ACTIONS(1533),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1533),
    [sym_global_var] = ACTIONS(1533),
    [sym_local_var] = ACTIONS(1533),
    [aux_sym_metadata_ref_token1] = ACTIONS(1533),
    [sym_summary_ref] = ACTIONS(1533),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1533),
    [anon_sym_source_filename] = ACTIONS(1533),
    [anon_sym_declare] = ACTIONS(1533),
    [anon_sym_define] = ACTIONS(1533),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1535),
    [anon_sym_uselistorder_bb] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(1533),
    [anon_sym_attributes] = ACTIONS(1533),
  },
  [449] = {
    [sym_attribute] = STATE(437),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(437),
    [ts_builtin_sym_end] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1525),
    [sym_global_var] = ACTIONS(1525),
    [sym_local_var] = ACTIONS(1525),
    [aux_sym_metadata_ref_token1] = ACTIONS(1525),
    [sym_summary_ref] = ACTIONS(1525),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1525),
    [anon_sym_source_filename] = ACTIONS(1525),
    [anon_sym_declare] = ACTIONS(1525),
    [anon_sym_define] = ACTIONS(1525),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1527),
    [anon_sym_uselistorder_bb] = ACTIONS(1525),
    [anon_sym_module] = ACTIONS(1525),
    [anon_sym_attributes] = ACTIONS(1525),
  },
  [450] = {
    [sym_attribute] = STATE(460),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(460),
    [ts_builtin_sym_end] = ACTIONS(1577),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1577),
    [sym_global_var] = ACTIONS(1577),
    [sym_local_var] = ACTIONS(1577),
    [aux_sym_metadata_ref_token1] = ACTIONS(1577),
    [sym_summary_ref] = ACTIONS(1577),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1577),
    [anon_sym_source_filename] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_define] = ACTIONS(1577),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1579),
    [anon_sym_uselistorder_bb] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_attributes] = ACTIONS(1577),
  },
  [451] = {
    [sym_attribute] = STATE(441),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(441),
    [ts_builtin_sym_end] = ACTIONS(1653),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1653),
    [sym_global_var] = ACTIONS(1653),
    [sym_local_var] = ACTIONS(1653),
    [aux_sym_metadata_ref_token1] = ACTIONS(1653),
    [sym_summary_ref] = ACTIONS(1653),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1653),
    [anon_sym_source_filename] = ACTIONS(1653),
    [anon_sym_declare] = ACTIONS(1653),
    [anon_sym_define] = ACTIONS(1653),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1655),
    [anon_sym_uselistorder_bb] = ACTIONS(1653),
    [anon_sym_module] = ACTIONS(1653),
    [anon_sym_attributes] = ACTIONS(1653),
  },
  [452] = {
    [ts_builtin_sym_end] = ACTIONS(855),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(855),
    [sym_comdat_ref] = ACTIONS(855),
    [sym_global_var] = ACTIONS(855),
    [sym_local_var] = ACTIONS(855),
    [aux_sym_metadata_ref_token1] = ACTIONS(855),
    [sym_summary_ref] = ACTIONS(855),
    [sym_string] = ACTIONS(855),
    [anon_sym_target] = ACTIONS(855),
    [anon_sym_source_filename] = ACTIONS(855),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_define] = ACTIONS(855),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_RBRACE] = ACTIONS(855),
    [anon_sym_LBRACK] = ACTIONS(855),
    [anon_sym_COMMA] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(1657),
    [anon_sym_align] = ACTIONS(857),
    [anon_sym_section] = ACTIONS(855),
    [anon_sym_partition] = ACTIONS(855),
    [anon_sym_comdat] = ACTIONS(855),
    [anon_sym_gc] = ACTIONS(855),
    [anon_sym_prefix] = ACTIONS(855),
    [anon_sym_prologue] = ACTIONS(855),
    [anon_sym_personality] = ACTIONS(855),
    [anon_sym_alignstack] = ACTIONS(855),
    [anon_sym_allocsize] = ACTIONS(855),
    [anon_sym_alwaysinline] = ACTIONS(855),
    [anon_sym_builtin] = ACTIONS(855),
    [anon_sym_cold] = ACTIONS(855),
    [anon_sym_convergent] = ACTIONS(855),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(855),
    [anon_sym_hot] = ACTIONS(855),
    [anon_sym_inaccessiblememonly] = ACTIONS(855),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(855),
    [anon_sym_inlinehint] = ACTIONS(855),
    [anon_sym_jumptable] = ACTIONS(855),
    [anon_sym_minsize] = ACTIONS(855),
    [anon_sym_naked] = ACTIONS(855),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(855),
    [anon_sym_nobuiltin] = ACTIONS(855),
    [anon_sym_noduplicate] = ACTIONS(855),
    [anon_sym_nofree] = ACTIONS(855),
    [anon_sym_noimplicitfloat] = ACTIONS(855),
    [anon_sym_noinline] = ACTIONS(855),
    [anon_sym_nomerge] = ACTIONS(855),
    [anon_sym_nonlazybind] = ACTIONS(855),
    [anon_sym_noprofile] = ACTIONS(855),
    [anon_sym_noredzone] = ACTIONS(855),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(855),
    [anon_sym_noreturn] = ACTIONS(855),
    [anon_sym_norecurse] = ACTIONS(855),
    [anon_sym_willreturn] = ACTIONS(855),
    [anon_sym_nosync] = ACTIONS(855),
    [anon_sym_nounwind] = ACTIONS(855),
    [anon_sym_nocallback] = ACTIONS(855),
    [anon_sym_nosanitize_coverage] = ACTIONS(855),
    [anon_sym_null_pointer_is_valid] = ACTIONS(855),
    [anon_sym_optforfuzzing] = ACTIONS(855),
    [anon_sym_optnone] = ACTIONS(855),
    [anon_sym_optsize] = ACTIONS(855),
    [anon_sym_readnone] = ACTIONS(855),
    [anon_sym_readonly] = ACTIONS(855),
    [anon_sym_writeonly] = ACTIONS(855),
    [anon_sym_argmemonly] = ACTIONS(855),
    [anon_sym_returns_twice] = ACTIONS(855),
    [anon_sym_safestack] = ACTIONS(855),
    [anon_sym_sanitize_address] = ACTIONS(855),
    [anon_sym_sanitize_memory] = ACTIONS(855),
    [anon_sym_sanitize_thread] = ACTIONS(855),
    [anon_sym_sanitize_hwaddress] = ACTIONS(855),
    [anon_sym_sanitize_memtag] = ACTIONS(855),
    [anon_sym_speculative_load_hardening] = ACTIONS(855),
    [anon_sym_speculatable] = ACTIONS(855),
    [anon_sym_ssp] = ACTIONS(857),
    [anon_sym_sspstrong] = ACTIONS(855),
    [anon_sym_sspreq] = ACTIONS(855),
    [anon_sym_strictfp] = ACTIONS(855),
    [anon_sym_nocf_check] = ACTIONS(855),
    [anon_sym_shadowcallstack] = ACTIONS(855),
    [anon_sym_mustprogress] = ACTIONS(855),
    [anon_sym_vscale_range] = ACTIONS(855),
    [anon_sym_preallocated] = ACTIONS(855),
    [anon_sym_zeroext] = ACTIONS(855),
    [anon_sym_signext] = ACTIONS(855),
    [anon_sym_inreg] = ACTIONS(855),
    [anon_sym_byval] = ACTIONS(855),
    [anon_sym_byref] = ACTIONS(855),
    [anon_sym_inalloca] = ACTIONS(855),
    [anon_sym_sret] = ACTIONS(855),
    [anon_sym_elementtype] = ACTIONS(855),
    [anon_sym_noalias] = ACTIONS(855),
    [anon_sym_nocapture] = ACTIONS(855),
    [anon_sym_nest] = ACTIONS(855),
    [anon_sym_returned] = ACTIONS(855),
    [anon_sym_nonnull] = ACTIONS(855),
    [anon_sym_dereferenceable] = ACTIONS(857),
    [anon_sym_dereferenceable_or_null] = ACTIONS(855),
    [anon_sym_swiftself] = ACTIONS(855),
    [anon_sym_swiftasync] = ACTIONS(855),
    [anon_sym_swifterror] = ACTIONS(855),
    [anon_sym_immarg] = ACTIONS(855),
    [anon_sym_noundef] = ACTIONS(855),
    [anon_sym_uwtable] = ACTIONS(855),
    [anon_sym_memory] = ACTIONS(855),
    [anon_sym_to] = ACTIONS(855),
    [anon_sym_uselistorder] = ACTIONS(857),
    [anon_sym_uselistorder_bb] = ACTIONS(855),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_attributes] = ACTIONS(855),
  },
  [453] = {
    [sym_attribute] = STATE(441),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(441),
    [ts_builtin_sym_end] = ACTIONS(1533),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1533),
    [sym_global_var] = ACTIONS(1533),
    [sym_local_var] = ACTIONS(1533),
    [aux_sym_metadata_ref_token1] = ACTIONS(1533),
    [sym_summary_ref] = ACTIONS(1533),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1533),
    [anon_sym_source_filename] = ACTIONS(1533),
    [anon_sym_declare] = ACTIONS(1533),
    [anon_sym_define] = ACTIONS(1533),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1535),
    [anon_sym_uselistorder_bb] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(1533),
    [anon_sym_attributes] = ACTIONS(1533),
  },
  [454] = {
    [sym_attribute] = STATE(462),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(462),
    [ts_builtin_sym_end] = ACTIONS(1653),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1653),
    [sym_global_var] = ACTIONS(1653),
    [sym_local_var] = ACTIONS(1653),
    [aux_sym_metadata_ref_token1] = ACTIONS(1653),
    [sym_summary_ref] = ACTIONS(1653),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1653),
    [anon_sym_source_filename] = ACTIONS(1653),
    [anon_sym_declare] = ACTIONS(1653),
    [anon_sym_define] = ACTIONS(1653),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1655),
    [anon_sym_uselistorder_bb] = ACTIONS(1653),
    [anon_sym_module] = ACTIONS(1653),
    [anon_sym_attributes] = ACTIONS(1653),
  },
  [455] = {
    [sym_attribute] = STATE(461),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(461),
    [ts_builtin_sym_end] = ACTIONS(1517),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1517),
    [sym_global_var] = ACTIONS(1517),
    [sym_local_var] = ACTIONS(1517),
    [aux_sym_metadata_ref_token1] = ACTIONS(1517),
    [sym_summary_ref] = ACTIONS(1517),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1517),
    [anon_sym_source_filename] = ACTIONS(1517),
    [anon_sym_declare] = ACTIONS(1517),
    [anon_sym_define] = ACTIONS(1517),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1519),
    [anon_sym_uselistorder_bb] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(1517),
    [anon_sym_attributes] = ACTIONS(1517),
  },
  [456] = {
    [sym_attribute] = STATE(441),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(441),
    [ts_builtin_sym_end] = ACTIONS(1525),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1525),
    [sym_global_var] = ACTIONS(1525),
    [sym_local_var] = ACTIONS(1525),
    [aux_sym_metadata_ref_token1] = ACTIONS(1525),
    [sym_summary_ref] = ACTIONS(1525),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1525),
    [anon_sym_source_filename] = ACTIONS(1525),
    [anon_sym_declare] = ACTIONS(1525),
    [anon_sym_define] = ACTIONS(1525),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1527),
    [anon_sym_uselistorder_bb] = ACTIONS(1525),
    [anon_sym_module] = ACTIONS(1525),
    [anon_sym_attributes] = ACTIONS(1525),
  },
  [457] = {
    [sym_attribute] = STATE(441),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(441),
    [ts_builtin_sym_end] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1521),
    [sym_global_var] = ACTIONS(1521),
    [sym_local_var] = ACTIONS(1521),
    [aux_sym_metadata_ref_token1] = ACTIONS(1521),
    [sym_summary_ref] = ACTIONS(1521),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1521),
    [anon_sym_source_filename] = ACTIONS(1521),
    [anon_sym_declare] = ACTIONS(1521),
    [anon_sym_define] = ACTIONS(1521),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1523),
    [anon_sym_uselistorder_bb] = ACTIONS(1521),
    [anon_sym_module] = ACTIONS(1521),
    [anon_sym_attributes] = ACTIONS(1521),
  },
  [458] = {
    [sym_attribute] = STATE(438),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(438),
    [ts_builtin_sym_end] = ACTIONS(1649),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1649),
    [sym_global_var] = ACTIONS(1649),
    [sym_local_var] = ACTIONS(1649),
    [aux_sym_metadata_ref_token1] = ACTIONS(1649),
    [sym_summary_ref] = ACTIONS(1649),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1649),
    [anon_sym_source_filename] = ACTIONS(1649),
    [anon_sym_declare] = ACTIONS(1649),
    [anon_sym_define] = ACTIONS(1649),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1651),
    [anon_sym_uselistorder_bb] = ACTIONS(1649),
    [anon_sym_module] = ACTIONS(1649),
    [anon_sym_attributes] = ACTIONS(1649),
  },
  [459] = {
    [sym_attribute] = STATE(440),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(440),
    [ts_builtin_sym_end] = ACTIONS(1659),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1659),
    [sym_global_var] = ACTIONS(1659),
    [sym_local_var] = ACTIONS(1659),
    [aux_sym_metadata_ref_token1] = ACTIONS(1659),
    [sym_summary_ref] = ACTIONS(1659),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1659),
    [anon_sym_source_filename] = ACTIONS(1659),
    [anon_sym_declare] = ACTIONS(1659),
    [anon_sym_define] = ACTIONS(1659),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1661),
    [anon_sym_uselistorder_bb] = ACTIONS(1659),
    [anon_sym_module] = ACTIONS(1659),
    [anon_sym_attributes] = ACTIONS(1659),
  },
  [460] = {
    [sym_attribute] = STATE(441),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(441),
    [ts_builtin_sym_end] = ACTIONS(1663),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1663),
    [sym_global_var] = ACTIONS(1663),
    [sym_local_var] = ACTIONS(1663),
    [aux_sym_metadata_ref_token1] = ACTIONS(1663),
    [sym_summary_ref] = ACTIONS(1663),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1663),
    [anon_sym_source_filename] = ACTIONS(1663),
    [anon_sym_declare] = ACTIONS(1663),
    [anon_sym_define] = ACTIONS(1663),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1665),
    [anon_sym_uselistorder_bb] = ACTIONS(1663),
    [anon_sym_module] = ACTIONS(1663),
    [anon_sym_attributes] = ACTIONS(1663),
  },
  [461] = {
    [sym_attribute] = STATE(441),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(441),
    [ts_builtin_sym_end] = ACTIONS(1659),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1659),
    [sym_global_var] = ACTIONS(1659),
    [sym_local_var] = ACTIONS(1659),
    [aux_sym_metadata_ref_token1] = ACTIONS(1659),
    [sym_summary_ref] = ACTIONS(1659),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1659),
    [anon_sym_source_filename] = ACTIONS(1659),
    [anon_sym_declare] = ACTIONS(1659),
    [anon_sym_define] = ACTIONS(1659),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1661),
    [anon_sym_uselistorder_bb] = ACTIONS(1659),
    [anon_sym_module] = ACTIONS(1659),
    [anon_sym_attributes] = ACTIONS(1659),
  },
  [462] = {
    [sym_attribute] = STATE(441),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(441),
    [ts_builtin_sym_end] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1667),
    [sym_global_var] = ACTIONS(1667),
    [sym_local_var] = ACTIONS(1667),
    [aux_sym_metadata_ref_token1] = ACTIONS(1667),
    [sym_summary_ref] = ACTIONS(1667),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1667),
    [anon_sym_source_filename] = ACTIONS(1667),
    [anon_sym_declare] = ACTIONS(1667),
    [anon_sym_define] = ACTIONS(1667),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1669),
    [anon_sym_uselistorder_bb] = ACTIONS(1667),
    [anon_sym_module] = ACTIONS(1667),
    [anon_sym_attributes] = ACTIONS(1667),
  },
  [463] = {
    [sym_attribute] = STATE(446),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(446),
    [ts_builtin_sym_end] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1521),
    [sym_global_var] = ACTIONS(1521),
    [sym_local_var] = ACTIONS(1521),
    [aux_sym_metadata_ref_token1] = ACTIONS(1521),
    [sym_summary_ref] = ACTIONS(1521),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1521),
    [anon_sym_source_filename] = ACTIONS(1521),
    [anon_sym_declare] = ACTIONS(1521),
    [anon_sym_define] = ACTIONS(1521),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1523),
    [anon_sym_uselistorder_bb] = ACTIONS(1521),
    [anon_sym_module] = ACTIONS(1521),
    [anon_sym_attributes] = ACTIONS(1521),
  },
  [464] = {
    [sym_attribute] = STATE(441),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(441),
    [ts_builtin_sym_end] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1671),
    [sym_global_var] = ACTIONS(1671),
    [sym_local_var] = ACTIONS(1671),
    [aux_sym_metadata_ref_token1] = ACTIONS(1671),
    [sym_summary_ref] = ACTIONS(1671),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1671),
    [anon_sym_source_filename] = ACTIONS(1671),
    [anon_sym_declare] = ACTIONS(1671),
    [anon_sym_define] = ACTIONS(1671),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1673),
    [anon_sym_uselistorder_bb] = ACTIONS(1671),
    [anon_sym_module] = ACTIONS(1671),
    [anon_sym_attributes] = ACTIONS(1671),
  },
  [465] = {
    [sym_attribute] = STATE(441),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(441),
    [ts_builtin_sym_end] = ACTIONS(1517),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_comdat_ref] = ACTIONS(1517),
    [sym_global_var] = ACTIONS(1517),
    [sym_local_var] = ACTIONS(1517),
    [aux_sym_metadata_ref_token1] = ACTIONS(1517),
    [sym_summary_ref] = ACTIONS(1517),
    [sym_string] = ACTIONS(1372),
    [anon_sym_target] = ACTIONS(1517),
    [anon_sym_source_filename] = ACTIONS(1517),
    [anon_sym_declare] = ACTIONS(1517),
    [anon_sym_define] = ACTIONS(1517),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_uselistorder] = ACTIONS(1519),
    [anon_sym_uselistorder_bb] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(1517),
    [anon_sym_attributes] = ACTIONS(1517),
  },
  [466] = {
    [sym_number] = STATE(490),
    [sym_linkage_aux] = STATE(490),
    [sym_attribute_name] = STATE(490),
    [sym_uwtable] = STATE(493),
    [sym_memory_attribute] = STATE(493),
    [sym_summary_value] = STATE(445),
    [aux_sym_summary_entry_repeat1] = STATE(445),
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(1675),
    [sym_string] = ACTIONS(1675),
    [aux_sym_number_token1] = ACTIONS(1677),
    [aux_sym_number_token2] = ACTIONS(1677),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_internal] = ACTIONS(1679),
    [anon_sym_weak] = ACTIONS(1679),
    [anon_sym_weak_odr] = ACTIONS(1679),
    [anon_sym_linkonce] = ACTIONS(1679),
    [anon_sym_linkonce_odr] = ACTIONS(1679),
    [anon_sym_available_externally] = ACTIONS(1679),
    [anon_sym_appending] = ACTIONS(1679),
    [anon_sym_common] = ACTIONS(1679),
    [anon_sym_extern_weak] = ACTIONS(1679),
    [anon_sym_external] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(1675),
    [anon_sym_LPAREN] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1685),
    [anon_sym_align] = ACTIONS(1687),
    [anon_sym_alignstack] = ACTIONS(1687),
    [anon_sym_allocsize] = ACTIONS(1687),
    [anon_sym_alwaysinline] = ACTIONS(1687),
    [anon_sym_builtin] = ACTIONS(1687),
    [anon_sym_cold] = ACTIONS(1687),
    [anon_sym_convergent] = ACTIONS(1687),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1687),
    [anon_sym_hot] = ACTIONS(1687),
    [anon_sym_inaccessiblememonly] = ACTIONS(1687),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1687),
    [anon_sym_inlinehint] = ACTIONS(1687),
    [anon_sym_jumptable] = ACTIONS(1687),
    [anon_sym_minsize] = ACTIONS(1687),
    [anon_sym_naked] = ACTIONS(1687),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1687),
    [anon_sym_nobuiltin] = ACTIONS(1687),
    [anon_sym_noduplicate] = ACTIONS(1687),
    [anon_sym_nofree] = ACTIONS(1687),
    [anon_sym_noimplicitfloat] = ACTIONS(1687),
    [anon_sym_noinline] = ACTIONS(1687),
    [anon_sym_nomerge] = ACTIONS(1687),
    [anon_sym_nonlazybind] = ACTIONS(1687),
    [anon_sym_noprofile] = ACTIONS(1687),
    [anon_sym_noredzone] = ACTIONS(1687),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1687),
    [anon_sym_noreturn] = ACTIONS(1687),
    [anon_sym_norecurse] = ACTIONS(1687),
    [anon_sym_willreturn] = ACTIONS(1687),
    [anon_sym_nosync] = ACTIONS(1687),
    [anon_sym_nounwind] = ACTIONS(1687),
    [anon_sym_nocallback] = ACTIONS(1687),
    [anon_sym_nosanitize_coverage] = ACTIONS(1687),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1687),
    [anon_sym_optforfuzzing] = ACTIONS(1687),
    [anon_sym_optnone] = ACTIONS(1687),
    [anon_sym_optsize] = ACTIONS(1687),
    [anon_sym_readnone] = ACTIONS(1687),
    [anon_sym_readonly] = ACTIONS(1687),
    [anon_sym_writeonly] = ACTIONS(1687),
    [anon_sym_argmemonly] = ACTIONS(1687),
    [anon_sym_returns_twice] = ACTIONS(1687),
    [anon_sym_safestack] = ACTIONS(1687),
    [anon_sym_sanitize_address] = ACTIONS(1687),
    [anon_sym_sanitize_memory] = ACTIONS(1687),
    [anon_sym_sanitize_thread] = ACTIONS(1687),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1687),
    [anon_sym_sanitize_memtag] = ACTIONS(1687),
    [anon_sym_speculative_load_hardening] = ACTIONS(1687),
    [anon_sym_speculatable] = ACTIONS(1687),
    [anon_sym_ssp] = ACTIONS(1687),
    [anon_sym_sspstrong] = ACTIONS(1687),
    [anon_sym_sspreq] = ACTIONS(1687),
    [anon_sym_strictfp] = ACTIONS(1687),
    [anon_sym_nocf_check] = ACTIONS(1687),
    [anon_sym_shadowcallstack] = ACTIONS(1687),
    [anon_sym_mustprogress] = ACTIONS(1687),
    [anon_sym_vscale_range] = ACTIONS(1687),
    [anon_sym_preallocated] = ACTIONS(1687),
    [anon_sym_zeroext] = ACTIONS(1687),
    [anon_sym_signext] = ACTIONS(1687),
    [anon_sym_inreg] = ACTIONS(1687),
    [anon_sym_byval] = ACTIONS(1687),
    [anon_sym_byref] = ACTIONS(1687),
    [anon_sym_inalloca] = ACTIONS(1687),
    [anon_sym_sret] = ACTIONS(1687),
    [anon_sym_elementtype] = ACTIONS(1687),
    [anon_sym_noalias] = ACTIONS(1687),
    [anon_sym_nocapture] = ACTIONS(1687),
    [anon_sym_nest] = ACTIONS(1687),
    [anon_sym_returned] = ACTIONS(1687),
    [anon_sym_nonnull] = ACTIONS(1687),
    [anon_sym_dereferenceable] = ACTIONS(1687),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1687),
    [anon_sym_swiftself] = ACTIONS(1687),
    [anon_sym_swiftasync] = ACTIONS(1687),
    [anon_sym_swifterror] = ACTIONS(1687),
    [anon_sym_immarg] = ACTIONS(1687),
    [anon_sym_noundef] = ACTIONS(1687),
    [anon_sym_uwtable] = ACTIONS(1689),
    [anon_sym_memory] = ACTIONS(1691),
    [anon_sym_COLON] = ACTIONS(1675),
    [aux_sym_specialized_md_value_token1] = ACTIONS(1693),
  },
  [467] = {
    [sym_number] = STATE(490),
    [sym_linkage_aux] = STATE(490),
    [sym_attribute_name] = STATE(490),
    [sym_uwtable] = STATE(493),
    [sym_memory_attribute] = STATE(493),
    [sym_summary_value] = STATE(471),
    [aux_sym_summary_entry_repeat1] = STATE(471),
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(1675),
    [sym_string] = ACTIONS(1675),
    [aux_sym_number_token1] = ACTIONS(1677),
    [aux_sym_number_token2] = ACTIONS(1677),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_internal] = ACTIONS(1679),
    [anon_sym_weak] = ACTIONS(1679),
    [anon_sym_weak_odr] = ACTIONS(1679),
    [anon_sym_linkonce] = ACTIONS(1679),
    [anon_sym_linkonce_odr] = ACTIONS(1679),
    [anon_sym_available_externally] = ACTIONS(1679),
    [anon_sym_appending] = ACTIONS(1679),
    [anon_sym_common] = ACTIONS(1679),
    [anon_sym_extern_weak] = ACTIONS(1679),
    [anon_sym_external] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(1675),
    [anon_sym_LPAREN] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1695),
    [anon_sym_align] = ACTIONS(1687),
    [anon_sym_alignstack] = ACTIONS(1687),
    [anon_sym_allocsize] = ACTIONS(1687),
    [anon_sym_alwaysinline] = ACTIONS(1687),
    [anon_sym_builtin] = ACTIONS(1687),
    [anon_sym_cold] = ACTIONS(1687),
    [anon_sym_convergent] = ACTIONS(1687),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1687),
    [anon_sym_hot] = ACTIONS(1687),
    [anon_sym_inaccessiblememonly] = ACTIONS(1687),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1687),
    [anon_sym_inlinehint] = ACTIONS(1687),
    [anon_sym_jumptable] = ACTIONS(1687),
    [anon_sym_minsize] = ACTIONS(1687),
    [anon_sym_naked] = ACTIONS(1687),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1687),
    [anon_sym_nobuiltin] = ACTIONS(1687),
    [anon_sym_noduplicate] = ACTIONS(1687),
    [anon_sym_nofree] = ACTIONS(1687),
    [anon_sym_noimplicitfloat] = ACTIONS(1687),
    [anon_sym_noinline] = ACTIONS(1687),
    [anon_sym_nomerge] = ACTIONS(1687),
    [anon_sym_nonlazybind] = ACTIONS(1687),
    [anon_sym_noprofile] = ACTIONS(1687),
    [anon_sym_noredzone] = ACTIONS(1687),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1687),
    [anon_sym_noreturn] = ACTIONS(1687),
    [anon_sym_norecurse] = ACTIONS(1687),
    [anon_sym_willreturn] = ACTIONS(1687),
    [anon_sym_nosync] = ACTIONS(1687),
    [anon_sym_nounwind] = ACTIONS(1687),
    [anon_sym_nocallback] = ACTIONS(1687),
    [anon_sym_nosanitize_coverage] = ACTIONS(1687),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1687),
    [anon_sym_optforfuzzing] = ACTIONS(1687),
    [anon_sym_optnone] = ACTIONS(1687),
    [anon_sym_optsize] = ACTIONS(1687),
    [anon_sym_readnone] = ACTIONS(1687),
    [anon_sym_readonly] = ACTIONS(1687),
    [anon_sym_writeonly] = ACTIONS(1687),
    [anon_sym_argmemonly] = ACTIONS(1687),
    [anon_sym_returns_twice] = ACTIONS(1687),
    [anon_sym_safestack] = ACTIONS(1687),
    [anon_sym_sanitize_address] = ACTIONS(1687),
    [anon_sym_sanitize_memory] = ACTIONS(1687),
    [anon_sym_sanitize_thread] = ACTIONS(1687),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1687),
    [anon_sym_sanitize_memtag] = ACTIONS(1687),
    [anon_sym_speculative_load_hardening] = ACTIONS(1687),
    [anon_sym_speculatable] = ACTIONS(1687),
    [anon_sym_ssp] = ACTIONS(1687),
    [anon_sym_sspstrong] = ACTIONS(1687),
    [anon_sym_sspreq] = ACTIONS(1687),
    [anon_sym_strictfp] = ACTIONS(1687),
    [anon_sym_nocf_check] = ACTIONS(1687),
    [anon_sym_shadowcallstack] = ACTIONS(1687),
    [anon_sym_mustprogress] = ACTIONS(1687),
    [anon_sym_vscale_range] = ACTIONS(1687),
    [anon_sym_preallocated] = ACTIONS(1687),
    [anon_sym_zeroext] = ACTIONS(1687),
    [anon_sym_signext] = ACTIONS(1687),
    [anon_sym_inreg] = ACTIONS(1687),
    [anon_sym_byval] = ACTIONS(1687),
    [anon_sym_byref] = ACTIONS(1687),
    [anon_sym_inalloca] = ACTIONS(1687),
    [anon_sym_sret] = ACTIONS(1687),
    [anon_sym_elementtype] = ACTIONS(1687),
    [anon_sym_noalias] = ACTIONS(1687),
    [anon_sym_nocapture] = ACTIONS(1687),
    [anon_sym_nest] = ACTIONS(1687),
    [anon_sym_returned] = ACTIONS(1687),
    [anon_sym_nonnull] = ACTIONS(1687),
    [anon_sym_dereferenceable] = ACTIONS(1687),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1687),
    [anon_sym_swiftself] = ACTIONS(1687),
    [anon_sym_swiftasync] = ACTIONS(1687),
    [anon_sym_swifterror] = ACTIONS(1687),
    [anon_sym_immarg] = ACTIONS(1687),
    [anon_sym_noundef] = ACTIONS(1687),
    [anon_sym_uwtable] = ACTIONS(1689),
    [anon_sym_memory] = ACTIONS(1691),
    [anon_sym_COLON] = ACTIONS(1675),
    [aux_sym_specialized_md_value_token1] = ACTIONS(1693),
  },
  [468] = {
    [ts_builtin_sym_end] = ACTIONS(901),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(901),
    [sym_comdat_ref] = ACTIONS(901),
    [sym_global_var] = ACTIONS(901),
    [sym_local_var] = ACTIONS(901),
    [aux_sym_metadata_ref_token1] = ACTIONS(901),
    [sym_summary_ref] = ACTIONS(901),
    [sym_string] = ACTIONS(901),
    [anon_sym_target] = ACTIONS(901),
    [anon_sym_source_filename] = ACTIONS(901),
    [anon_sym_declare] = ACTIONS(901),
    [anon_sym_define] = ACTIONS(901),
    [anon_sym_LBRACE] = ACTIONS(901),
    [anon_sym_RBRACE] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(901),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_align] = ACTIONS(903),
    [anon_sym_section] = ACTIONS(901),
    [anon_sym_partition] = ACTIONS(901),
    [anon_sym_comdat] = ACTIONS(901),
    [anon_sym_gc] = ACTIONS(901),
    [anon_sym_prefix] = ACTIONS(901),
    [anon_sym_prologue] = ACTIONS(901),
    [anon_sym_personality] = ACTIONS(901),
    [anon_sym_alignstack] = ACTIONS(901),
    [anon_sym_allocsize] = ACTIONS(901),
    [anon_sym_alwaysinline] = ACTIONS(901),
    [anon_sym_builtin] = ACTIONS(901),
    [anon_sym_cold] = ACTIONS(901),
    [anon_sym_convergent] = ACTIONS(901),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(901),
    [anon_sym_hot] = ACTIONS(901),
    [anon_sym_inaccessiblememonly] = ACTIONS(901),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(901),
    [anon_sym_inlinehint] = ACTIONS(901),
    [anon_sym_jumptable] = ACTIONS(901),
    [anon_sym_minsize] = ACTIONS(901),
    [anon_sym_naked] = ACTIONS(901),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(901),
    [anon_sym_nobuiltin] = ACTIONS(901),
    [anon_sym_noduplicate] = ACTIONS(901),
    [anon_sym_nofree] = ACTIONS(901),
    [anon_sym_noimplicitfloat] = ACTIONS(901),
    [anon_sym_noinline] = ACTIONS(901),
    [anon_sym_nomerge] = ACTIONS(901),
    [anon_sym_nonlazybind] = ACTIONS(901),
    [anon_sym_noprofile] = ACTIONS(901),
    [anon_sym_noredzone] = ACTIONS(901),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(901),
    [anon_sym_noreturn] = ACTIONS(901),
    [anon_sym_norecurse] = ACTIONS(901),
    [anon_sym_willreturn] = ACTIONS(901),
    [anon_sym_nosync] = ACTIONS(901),
    [anon_sym_nounwind] = ACTIONS(901),
    [anon_sym_nocallback] = ACTIONS(901),
    [anon_sym_nosanitize_coverage] = ACTIONS(901),
    [anon_sym_null_pointer_is_valid] = ACTIONS(901),
    [anon_sym_optforfuzzing] = ACTIONS(901),
    [anon_sym_optnone] = ACTIONS(901),
    [anon_sym_optsize] = ACTIONS(901),
    [anon_sym_readnone] = ACTIONS(901),
    [anon_sym_readonly] = ACTIONS(901),
    [anon_sym_writeonly] = ACTIONS(901),
    [anon_sym_argmemonly] = ACTIONS(901),
    [anon_sym_returns_twice] = ACTIONS(901),
    [anon_sym_safestack] = ACTIONS(901),
    [anon_sym_sanitize_address] = ACTIONS(901),
    [anon_sym_sanitize_memory] = ACTIONS(901),
    [anon_sym_sanitize_thread] = ACTIONS(901),
    [anon_sym_sanitize_hwaddress] = ACTIONS(901),
    [anon_sym_sanitize_memtag] = ACTIONS(901),
    [anon_sym_speculative_load_hardening] = ACTIONS(901),
    [anon_sym_speculatable] = ACTIONS(901),
    [anon_sym_ssp] = ACTIONS(903),
    [anon_sym_sspstrong] = ACTIONS(901),
    [anon_sym_sspreq] = ACTIONS(901),
    [anon_sym_strictfp] = ACTIONS(901),
    [anon_sym_nocf_check] = ACTIONS(901),
    [anon_sym_shadowcallstack] = ACTIONS(901),
    [anon_sym_mustprogress] = ACTIONS(901),
    [anon_sym_vscale_range] = ACTIONS(901),
    [anon_sym_preallocated] = ACTIONS(901),
    [anon_sym_zeroext] = ACTIONS(901),
    [anon_sym_signext] = ACTIONS(901),
    [anon_sym_inreg] = ACTIONS(901),
    [anon_sym_byval] = ACTIONS(901),
    [anon_sym_byref] = ACTIONS(901),
    [anon_sym_inalloca] = ACTIONS(901),
    [anon_sym_sret] = ACTIONS(901),
    [anon_sym_elementtype] = ACTIONS(901),
    [anon_sym_noalias] = ACTIONS(901),
    [anon_sym_nocapture] = ACTIONS(901),
    [anon_sym_nest] = ACTIONS(901),
    [anon_sym_returned] = ACTIONS(901),
    [anon_sym_nonnull] = ACTIONS(901),
    [anon_sym_dereferenceable] = ACTIONS(903),
    [anon_sym_dereferenceable_or_null] = ACTIONS(901),
    [anon_sym_swiftself] = ACTIONS(901),
    [anon_sym_swiftasync] = ACTIONS(901),
    [anon_sym_swifterror] = ACTIONS(901),
    [anon_sym_immarg] = ACTIONS(901),
    [anon_sym_noundef] = ACTIONS(901),
    [anon_sym_uwtable] = ACTIONS(901),
    [anon_sym_memory] = ACTIONS(901),
    [anon_sym_to] = ACTIONS(901),
    [anon_sym_uselistorder] = ACTIONS(903),
    [anon_sym_uselistorder_bb] = ACTIONS(901),
    [anon_sym_module] = ACTIONS(901),
    [anon_sym_attributes] = ACTIONS(901),
  },
  [469] = {
    [sym_number] = STATE(490),
    [sym_linkage_aux] = STATE(490),
    [sym_attribute_name] = STATE(490),
    [sym_uwtable] = STATE(493),
    [sym_memory_attribute] = STATE(493),
    [sym_summary_value] = STATE(445),
    [aux_sym_summary_entry_repeat1] = STATE(445),
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(1675),
    [sym_string] = ACTIONS(1675),
    [aux_sym_number_token1] = ACTIONS(1677),
    [aux_sym_number_token2] = ACTIONS(1677),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_internal] = ACTIONS(1679),
    [anon_sym_weak] = ACTIONS(1679),
    [anon_sym_weak_odr] = ACTIONS(1679),
    [anon_sym_linkonce] = ACTIONS(1679),
    [anon_sym_linkonce_odr] = ACTIONS(1679),
    [anon_sym_available_externally] = ACTIONS(1679),
    [anon_sym_appending] = ACTIONS(1679),
    [anon_sym_common] = ACTIONS(1679),
    [anon_sym_extern_weak] = ACTIONS(1679),
    [anon_sym_external] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_RBRACK] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1675),
    [anon_sym_LPAREN] = ACTIONS(1683),
    [anon_sym_align] = ACTIONS(1687),
    [anon_sym_alignstack] = ACTIONS(1687),
    [anon_sym_allocsize] = ACTIONS(1687),
    [anon_sym_alwaysinline] = ACTIONS(1687),
    [anon_sym_builtin] = ACTIONS(1687),
    [anon_sym_cold] = ACTIONS(1687),
    [anon_sym_convergent] = ACTIONS(1687),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1687),
    [anon_sym_hot] = ACTIONS(1687),
    [anon_sym_inaccessiblememonly] = ACTIONS(1687),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1687),
    [anon_sym_inlinehint] = ACTIONS(1687),
    [anon_sym_jumptable] = ACTIONS(1687),
    [anon_sym_minsize] = ACTIONS(1687),
    [anon_sym_naked] = ACTIONS(1687),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1687),
    [anon_sym_nobuiltin] = ACTIONS(1687),
    [anon_sym_noduplicate] = ACTIONS(1687),
    [anon_sym_nofree] = ACTIONS(1687),
    [anon_sym_noimplicitfloat] = ACTIONS(1687),
    [anon_sym_noinline] = ACTIONS(1687),
    [anon_sym_nomerge] = ACTIONS(1687),
    [anon_sym_nonlazybind] = ACTIONS(1687),
    [anon_sym_noprofile] = ACTIONS(1687),
    [anon_sym_noredzone] = ACTIONS(1687),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1687),
    [anon_sym_noreturn] = ACTIONS(1687),
    [anon_sym_norecurse] = ACTIONS(1687),
    [anon_sym_willreturn] = ACTIONS(1687),
    [anon_sym_nosync] = ACTIONS(1687),
    [anon_sym_nounwind] = ACTIONS(1687),
    [anon_sym_nocallback] = ACTIONS(1687),
    [anon_sym_nosanitize_coverage] = ACTIONS(1687),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1687),
    [anon_sym_optforfuzzing] = ACTIONS(1687),
    [anon_sym_optnone] = ACTIONS(1687),
    [anon_sym_optsize] = ACTIONS(1687),
    [anon_sym_readnone] = ACTIONS(1687),
    [anon_sym_readonly] = ACTIONS(1687),
    [anon_sym_writeonly] = ACTIONS(1687),
    [anon_sym_argmemonly] = ACTIONS(1687),
    [anon_sym_returns_twice] = ACTIONS(1687),
    [anon_sym_safestack] = ACTIONS(1687),
    [anon_sym_sanitize_address] = ACTIONS(1687),
    [anon_sym_sanitize_memory] = ACTIONS(1687),
    [anon_sym_sanitize_thread] = ACTIONS(1687),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1687),
    [anon_sym_sanitize_memtag] = ACTIONS(1687),
    [anon_sym_speculative_load_hardening] = ACTIONS(1687),
    [anon_sym_speculatable] = ACTIONS(1687),
    [anon_sym_ssp] = ACTIONS(1687),
    [anon_sym_sspstrong] = ACTIONS(1687),
    [anon_sym_sspreq] = ACTIONS(1687),
    [anon_sym_strictfp] = ACTIONS(1687),
    [anon_sym_nocf_check] = ACTIONS(1687),
    [anon_sym_shadowcallstack] = ACTIONS(1687),
    [anon_sym_mustprogress] = ACTIONS(1687),
    [anon_sym_vscale_range] = ACTIONS(1687),
    [anon_sym_preallocated] = ACTIONS(1687),
    [anon_sym_zeroext] = ACTIONS(1687),
    [anon_sym_signext] = ACTIONS(1687),
    [anon_sym_inreg] = ACTIONS(1687),
    [anon_sym_byval] = ACTIONS(1687),
    [anon_sym_byref] = ACTIONS(1687),
    [anon_sym_inalloca] = ACTIONS(1687),
    [anon_sym_sret] = ACTIONS(1687),
    [anon_sym_elementtype] = ACTIONS(1687),
    [anon_sym_noalias] = ACTIONS(1687),
    [anon_sym_nocapture] = ACTIONS(1687),
    [anon_sym_nest] = ACTIONS(1687),
    [anon_sym_returned] = ACTIONS(1687),
    [anon_sym_nonnull] = ACTIONS(1687),
    [anon_sym_dereferenceable] = ACTIONS(1687),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1687),
    [anon_sym_swiftself] = ACTIONS(1687),
    [anon_sym_swiftasync] = ACTIONS(1687),
    [anon_sym_swifterror] = ACTIONS(1687),
    [anon_sym_immarg] = ACTIONS(1687),
    [anon_sym_noundef] = ACTIONS(1687),
    [anon_sym_uwtable] = ACTIONS(1689),
    [anon_sym_memory] = ACTIONS(1691),
    [anon_sym_COLON] = ACTIONS(1675),
    [aux_sym_specialized_md_value_token1] = ACTIONS(1693),
  },
  [470] = {
    [ts_builtin_sym_end] = ACTIONS(891),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(891),
    [sym_comdat_ref] = ACTIONS(891),
    [sym_global_var] = ACTIONS(891),
    [sym_local_var] = ACTIONS(891),
    [aux_sym_metadata_ref_token1] = ACTIONS(891),
    [sym_summary_ref] = ACTIONS(891),
    [sym_string] = ACTIONS(891),
    [anon_sym_target] = ACTIONS(891),
    [anon_sym_source_filename] = ACTIONS(891),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_define] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_align] = ACTIONS(893),
    [anon_sym_section] = ACTIONS(891),
    [anon_sym_partition] = ACTIONS(891),
    [anon_sym_comdat] = ACTIONS(891),
    [anon_sym_gc] = ACTIONS(891),
    [anon_sym_prefix] = ACTIONS(891),
    [anon_sym_prologue] = ACTIONS(891),
    [anon_sym_personality] = ACTIONS(891),
    [anon_sym_alignstack] = ACTIONS(891),
    [anon_sym_allocsize] = ACTIONS(891),
    [anon_sym_alwaysinline] = ACTIONS(891),
    [anon_sym_builtin] = ACTIONS(891),
    [anon_sym_cold] = ACTIONS(891),
    [anon_sym_convergent] = ACTIONS(891),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(891),
    [anon_sym_hot] = ACTIONS(891),
    [anon_sym_inaccessiblememonly] = ACTIONS(891),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(891),
    [anon_sym_inlinehint] = ACTIONS(891),
    [anon_sym_jumptable] = ACTIONS(891),
    [anon_sym_minsize] = ACTIONS(891),
    [anon_sym_naked] = ACTIONS(891),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(891),
    [anon_sym_nobuiltin] = ACTIONS(891),
    [anon_sym_noduplicate] = ACTIONS(891),
    [anon_sym_nofree] = ACTIONS(891),
    [anon_sym_noimplicitfloat] = ACTIONS(891),
    [anon_sym_noinline] = ACTIONS(891),
    [anon_sym_nomerge] = ACTIONS(891),
    [anon_sym_nonlazybind] = ACTIONS(891),
    [anon_sym_noprofile] = ACTIONS(891),
    [anon_sym_noredzone] = ACTIONS(891),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(891),
    [anon_sym_noreturn] = ACTIONS(891),
    [anon_sym_norecurse] = ACTIONS(891),
    [anon_sym_willreturn] = ACTIONS(891),
    [anon_sym_nosync] = ACTIONS(891),
    [anon_sym_nounwind] = ACTIONS(891),
    [anon_sym_nocallback] = ACTIONS(891),
    [anon_sym_nosanitize_coverage] = ACTIONS(891),
    [anon_sym_null_pointer_is_valid] = ACTIONS(891),
    [anon_sym_optforfuzzing] = ACTIONS(891),
    [anon_sym_optnone] = ACTIONS(891),
    [anon_sym_optsize] = ACTIONS(891),
    [anon_sym_readnone] = ACTIONS(891),
    [anon_sym_readonly] = ACTIONS(891),
    [anon_sym_writeonly] = ACTIONS(891),
    [anon_sym_argmemonly] = ACTIONS(891),
    [anon_sym_returns_twice] = ACTIONS(891),
    [anon_sym_safestack] = ACTIONS(891),
    [anon_sym_sanitize_address] = ACTIONS(891),
    [anon_sym_sanitize_memory] = ACTIONS(891),
    [anon_sym_sanitize_thread] = ACTIONS(891),
    [anon_sym_sanitize_hwaddress] = ACTIONS(891),
    [anon_sym_sanitize_memtag] = ACTIONS(891),
    [anon_sym_speculative_load_hardening] = ACTIONS(891),
    [anon_sym_speculatable] = ACTIONS(891),
    [anon_sym_ssp] = ACTIONS(893),
    [anon_sym_sspstrong] = ACTIONS(891),
    [anon_sym_sspreq] = ACTIONS(891),
    [anon_sym_strictfp] = ACTIONS(891),
    [anon_sym_nocf_check] = ACTIONS(891),
    [anon_sym_shadowcallstack] = ACTIONS(891),
    [anon_sym_mustprogress] = ACTIONS(891),
    [anon_sym_vscale_range] = ACTIONS(891),
    [anon_sym_preallocated] = ACTIONS(891),
    [anon_sym_zeroext] = ACTIONS(891),
    [anon_sym_signext] = ACTIONS(891),
    [anon_sym_inreg] = ACTIONS(891),
    [anon_sym_byval] = ACTIONS(891),
    [anon_sym_byref] = ACTIONS(891),
    [anon_sym_inalloca] = ACTIONS(891),
    [anon_sym_sret] = ACTIONS(891),
    [anon_sym_elementtype] = ACTIONS(891),
    [anon_sym_noalias] = ACTIONS(891),
    [anon_sym_nocapture] = ACTIONS(891),
    [anon_sym_nest] = ACTIONS(891),
    [anon_sym_returned] = ACTIONS(891),
    [anon_sym_nonnull] = ACTIONS(891),
    [anon_sym_dereferenceable] = ACTIONS(893),
    [anon_sym_dereferenceable_or_null] = ACTIONS(891),
    [anon_sym_swiftself] = ACTIONS(891),
    [anon_sym_swiftasync] = ACTIONS(891),
    [anon_sym_swifterror] = ACTIONS(891),
    [anon_sym_immarg] = ACTIONS(891),
    [anon_sym_noundef] = ACTIONS(891),
    [anon_sym_uwtable] = ACTIONS(891),
    [anon_sym_memory] = ACTIONS(891),
    [anon_sym_to] = ACTIONS(891),
    [anon_sym_uselistorder] = ACTIONS(893),
    [anon_sym_uselistorder_bb] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_attributes] = ACTIONS(891),
  },
  [471] = {
    [sym_number] = STATE(490),
    [sym_linkage_aux] = STATE(490),
    [sym_attribute_name] = STATE(490),
    [sym_uwtable] = STATE(493),
    [sym_memory_attribute] = STATE(493),
    [sym_summary_value] = STATE(445),
    [aux_sym_summary_entry_repeat1] = STATE(445),
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(1675),
    [sym_string] = ACTIONS(1675),
    [aux_sym_number_token1] = ACTIONS(1677),
    [aux_sym_number_token2] = ACTIONS(1677),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_internal] = ACTIONS(1679),
    [anon_sym_weak] = ACTIONS(1679),
    [anon_sym_weak_odr] = ACTIONS(1679),
    [anon_sym_linkonce] = ACTIONS(1679),
    [anon_sym_linkonce_odr] = ACTIONS(1679),
    [anon_sym_available_externally] = ACTIONS(1679),
    [anon_sym_appending] = ACTIONS(1679),
    [anon_sym_common] = ACTIONS(1679),
    [anon_sym_extern_weak] = ACTIONS(1679),
    [anon_sym_external] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(1675),
    [anon_sym_LPAREN] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1697),
    [anon_sym_align] = ACTIONS(1687),
    [anon_sym_alignstack] = ACTIONS(1687),
    [anon_sym_allocsize] = ACTIONS(1687),
    [anon_sym_alwaysinline] = ACTIONS(1687),
    [anon_sym_builtin] = ACTIONS(1687),
    [anon_sym_cold] = ACTIONS(1687),
    [anon_sym_convergent] = ACTIONS(1687),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1687),
    [anon_sym_hot] = ACTIONS(1687),
    [anon_sym_inaccessiblememonly] = ACTIONS(1687),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1687),
    [anon_sym_inlinehint] = ACTIONS(1687),
    [anon_sym_jumptable] = ACTIONS(1687),
    [anon_sym_minsize] = ACTIONS(1687),
    [anon_sym_naked] = ACTIONS(1687),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1687),
    [anon_sym_nobuiltin] = ACTIONS(1687),
    [anon_sym_noduplicate] = ACTIONS(1687),
    [anon_sym_nofree] = ACTIONS(1687),
    [anon_sym_noimplicitfloat] = ACTIONS(1687),
    [anon_sym_noinline] = ACTIONS(1687),
    [anon_sym_nomerge] = ACTIONS(1687),
    [anon_sym_nonlazybind] = ACTIONS(1687),
    [anon_sym_noprofile] = ACTIONS(1687),
    [anon_sym_noredzone] = ACTIONS(1687),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1687),
    [anon_sym_noreturn] = ACTIONS(1687),
    [anon_sym_norecurse] = ACTIONS(1687),
    [anon_sym_willreturn] = ACTIONS(1687),
    [anon_sym_nosync] = ACTIONS(1687),
    [anon_sym_nounwind] = ACTIONS(1687),
    [anon_sym_nocallback] = ACTIONS(1687),
    [anon_sym_nosanitize_coverage] = ACTIONS(1687),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1687),
    [anon_sym_optforfuzzing] = ACTIONS(1687),
    [anon_sym_optnone] = ACTIONS(1687),
    [anon_sym_optsize] = ACTIONS(1687),
    [anon_sym_readnone] = ACTIONS(1687),
    [anon_sym_readonly] = ACTIONS(1687),
    [anon_sym_writeonly] = ACTIONS(1687),
    [anon_sym_argmemonly] = ACTIONS(1687),
    [anon_sym_returns_twice] = ACTIONS(1687),
    [anon_sym_safestack] = ACTIONS(1687),
    [anon_sym_sanitize_address] = ACTIONS(1687),
    [anon_sym_sanitize_memory] = ACTIONS(1687),
    [anon_sym_sanitize_thread] = ACTIONS(1687),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1687),
    [anon_sym_sanitize_memtag] = ACTIONS(1687),
    [anon_sym_speculative_load_hardening] = ACTIONS(1687),
    [anon_sym_speculatable] = ACTIONS(1687),
    [anon_sym_ssp] = ACTIONS(1687),
    [anon_sym_sspstrong] = ACTIONS(1687),
    [anon_sym_sspreq] = ACTIONS(1687),
    [anon_sym_strictfp] = ACTIONS(1687),
    [anon_sym_nocf_check] = ACTIONS(1687),
    [anon_sym_shadowcallstack] = ACTIONS(1687),
    [anon_sym_mustprogress] = ACTIONS(1687),
    [anon_sym_vscale_range] = ACTIONS(1687),
    [anon_sym_preallocated] = ACTIONS(1687),
    [anon_sym_zeroext] = ACTIONS(1687),
    [anon_sym_signext] = ACTIONS(1687),
    [anon_sym_inreg] = ACTIONS(1687),
    [anon_sym_byval] = ACTIONS(1687),
    [anon_sym_byref] = ACTIONS(1687),
    [anon_sym_inalloca] = ACTIONS(1687),
    [anon_sym_sret] = ACTIONS(1687),
    [anon_sym_elementtype] = ACTIONS(1687),
    [anon_sym_noalias] = ACTIONS(1687),
    [anon_sym_nocapture] = ACTIONS(1687),
    [anon_sym_nest] = ACTIONS(1687),
    [anon_sym_returned] = ACTIONS(1687),
    [anon_sym_nonnull] = ACTIONS(1687),
    [anon_sym_dereferenceable] = ACTIONS(1687),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1687),
    [anon_sym_swiftself] = ACTIONS(1687),
    [anon_sym_swiftasync] = ACTIONS(1687),
    [anon_sym_swifterror] = ACTIONS(1687),
    [anon_sym_immarg] = ACTIONS(1687),
    [anon_sym_noundef] = ACTIONS(1687),
    [anon_sym_uwtable] = ACTIONS(1689),
    [anon_sym_memory] = ACTIONS(1691),
    [anon_sym_COLON] = ACTIONS(1675),
    [aux_sym_specialized_md_value_token1] = ACTIONS(1693),
  },
  [472] = {
    [sym_number] = STATE(490),
    [sym_linkage_aux] = STATE(490),
    [sym_attribute_name] = STATE(490),
    [sym_uwtable] = STATE(493),
    [sym_memory_attribute] = STATE(493),
    [sym_summary_value] = STATE(466),
    [aux_sym_summary_entry_repeat1] = STATE(466),
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(1675),
    [sym_string] = ACTIONS(1675),
    [aux_sym_number_token1] = ACTIONS(1677),
    [aux_sym_number_token2] = ACTIONS(1677),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_internal] = ACTIONS(1679),
    [anon_sym_weak] = ACTIONS(1679),
    [anon_sym_weak_odr] = ACTIONS(1679),
    [anon_sym_linkonce] = ACTIONS(1679),
    [anon_sym_linkonce_odr] = ACTIONS(1679),
    [anon_sym_available_externally] = ACTIONS(1679),
    [anon_sym_appending] = ACTIONS(1679),
    [anon_sym_common] = ACTIONS(1679),
    [anon_sym_extern_weak] = ACTIONS(1679),
    [anon_sym_external] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(1675),
    [anon_sym_LPAREN] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1699),
    [anon_sym_align] = ACTIONS(1687),
    [anon_sym_alignstack] = ACTIONS(1687),
    [anon_sym_allocsize] = ACTIONS(1687),
    [anon_sym_alwaysinline] = ACTIONS(1687),
    [anon_sym_builtin] = ACTIONS(1687),
    [anon_sym_cold] = ACTIONS(1687),
    [anon_sym_convergent] = ACTIONS(1687),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1687),
    [anon_sym_hot] = ACTIONS(1687),
    [anon_sym_inaccessiblememonly] = ACTIONS(1687),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1687),
    [anon_sym_inlinehint] = ACTIONS(1687),
    [anon_sym_jumptable] = ACTIONS(1687),
    [anon_sym_minsize] = ACTIONS(1687),
    [anon_sym_naked] = ACTIONS(1687),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1687),
    [anon_sym_nobuiltin] = ACTIONS(1687),
    [anon_sym_noduplicate] = ACTIONS(1687),
    [anon_sym_nofree] = ACTIONS(1687),
    [anon_sym_noimplicitfloat] = ACTIONS(1687),
    [anon_sym_noinline] = ACTIONS(1687),
    [anon_sym_nomerge] = ACTIONS(1687),
    [anon_sym_nonlazybind] = ACTIONS(1687),
    [anon_sym_noprofile] = ACTIONS(1687),
    [anon_sym_noredzone] = ACTIONS(1687),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1687),
    [anon_sym_noreturn] = ACTIONS(1687),
    [anon_sym_norecurse] = ACTIONS(1687),
    [anon_sym_willreturn] = ACTIONS(1687),
    [anon_sym_nosync] = ACTIONS(1687),
    [anon_sym_nounwind] = ACTIONS(1687),
    [anon_sym_nocallback] = ACTIONS(1687),
    [anon_sym_nosanitize_coverage] = ACTIONS(1687),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1687),
    [anon_sym_optforfuzzing] = ACTIONS(1687),
    [anon_sym_optnone] = ACTIONS(1687),
    [anon_sym_optsize] = ACTIONS(1687),
    [anon_sym_readnone] = ACTIONS(1687),
    [anon_sym_readonly] = ACTIONS(1687),
    [anon_sym_writeonly] = ACTIONS(1687),
    [anon_sym_argmemonly] = ACTIONS(1687),
    [anon_sym_returns_twice] = ACTIONS(1687),
    [anon_sym_safestack] = ACTIONS(1687),
    [anon_sym_sanitize_address] = ACTIONS(1687),
    [anon_sym_sanitize_memory] = ACTIONS(1687),
    [anon_sym_sanitize_thread] = ACTIONS(1687),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1687),
    [anon_sym_sanitize_memtag] = ACTIONS(1687),
    [anon_sym_speculative_load_hardening] = ACTIONS(1687),
    [anon_sym_speculatable] = ACTIONS(1687),
    [anon_sym_ssp] = ACTIONS(1687),
    [anon_sym_sspstrong] = ACTIONS(1687),
    [anon_sym_sspreq] = ACTIONS(1687),
    [anon_sym_strictfp] = ACTIONS(1687),
    [anon_sym_nocf_check] = ACTIONS(1687),
    [anon_sym_shadowcallstack] = ACTIONS(1687),
    [anon_sym_mustprogress] = ACTIONS(1687),
    [anon_sym_vscale_range] = ACTIONS(1687),
    [anon_sym_preallocated] = ACTIONS(1687),
    [anon_sym_zeroext] = ACTIONS(1687),
    [anon_sym_signext] = ACTIONS(1687),
    [anon_sym_inreg] = ACTIONS(1687),
    [anon_sym_byval] = ACTIONS(1687),
    [anon_sym_byref] = ACTIONS(1687),
    [anon_sym_inalloca] = ACTIONS(1687),
    [anon_sym_sret] = ACTIONS(1687),
    [anon_sym_elementtype] = ACTIONS(1687),
    [anon_sym_noalias] = ACTIONS(1687),
    [anon_sym_nocapture] = ACTIONS(1687),
    [anon_sym_nest] = ACTIONS(1687),
    [anon_sym_returned] = ACTIONS(1687),
    [anon_sym_nonnull] = ACTIONS(1687),
    [anon_sym_dereferenceable] = ACTIONS(1687),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1687),
    [anon_sym_swiftself] = ACTIONS(1687),
    [anon_sym_swiftasync] = ACTIONS(1687),
    [anon_sym_swifterror] = ACTIONS(1687),
    [anon_sym_immarg] = ACTIONS(1687),
    [anon_sym_noundef] = ACTIONS(1687),
    [anon_sym_uwtable] = ACTIONS(1689),
    [anon_sym_memory] = ACTIONS(1691),
    [anon_sym_COLON] = ACTIONS(1675),
    [aux_sym_specialized_md_value_token1] = ACTIONS(1693),
  },
  [473] = {
    [sym_number] = STATE(490),
    [sym_linkage_aux] = STATE(490),
    [sym_attribute_name] = STATE(490),
    [sym_uwtable] = STATE(493),
    [sym_memory_attribute] = STATE(493),
    [sym_summary_value] = STATE(469),
    [aux_sym_summary_entry_repeat1] = STATE(469),
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(1675),
    [sym_string] = ACTIONS(1675),
    [aux_sym_number_token1] = ACTIONS(1677),
    [aux_sym_number_token2] = ACTIONS(1677),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_internal] = ACTIONS(1679),
    [anon_sym_weak] = ACTIONS(1679),
    [anon_sym_weak_odr] = ACTIONS(1679),
    [anon_sym_linkonce] = ACTIONS(1679),
    [anon_sym_linkonce_odr] = ACTIONS(1679),
    [anon_sym_available_externally] = ACTIONS(1679),
    [anon_sym_appending] = ACTIONS(1679),
    [anon_sym_common] = ACTIONS(1679),
    [anon_sym_extern_weak] = ACTIONS(1679),
    [anon_sym_external] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(1681),
    [anon_sym_RBRACK] = ACTIONS(1699),
    [anon_sym_COMMA] = ACTIONS(1675),
    [anon_sym_LPAREN] = ACTIONS(1683),
    [anon_sym_align] = ACTIONS(1687),
    [anon_sym_alignstack] = ACTIONS(1687),
    [anon_sym_allocsize] = ACTIONS(1687),
    [anon_sym_alwaysinline] = ACTIONS(1687),
    [anon_sym_builtin] = ACTIONS(1687),
    [anon_sym_cold] = ACTIONS(1687),
    [anon_sym_convergent] = ACTIONS(1687),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1687),
    [anon_sym_hot] = ACTIONS(1687),
    [anon_sym_inaccessiblememonly] = ACTIONS(1687),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1687),
    [anon_sym_inlinehint] = ACTIONS(1687),
    [anon_sym_jumptable] = ACTIONS(1687),
    [anon_sym_minsize] = ACTIONS(1687),
    [anon_sym_naked] = ACTIONS(1687),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1687),
    [anon_sym_nobuiltin] = ACTIONS(1687),
    [anon_sym_noduplicate] = ACTIONS(1687),
    [anon_sym_nofree] = ACTIONS(1687),
    [anon_sym_noimplicitfloat] = ACTIONS(1687),
    [anon_sym_noinline] = ACTIONS(1687),
    [anon_sym_nomerge] = ACTIONS(1687),
    [anon_sym_nonlazybind] = ACTIONS(1687),
    [anon_sym_noprofile] = ACTIONS(1687),
    [anon_sym_noredzone] = ACTIONS(1687),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1687),
    [anon_sym_noreturn] = ACTIONS(1687),
    [anon_sym_norecurse] = ACTIONS(1687),
    [anon_sym_willreturn] = ACTIONS(1687),
    [anon_sym_nosync] = ACTIONS(1687),
    [anon_sym_nounwind] = ACTIONS(1687),
    [anon_sym_nocallback] = ACTIONS(1687),
    [anon_sym_nosanitize_coverage] = ACTIONS(1687),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1687),
    [anon_sym_optforfuzzing] = ACTIONS(1687),
    [anon_sym_optnone] = ACTIONS(1687),
    [anon_sym_optsize] = ACTIONS(1687),
    [anon_sym_readnone] = ACTIONS(1687),
    [anon_sym_readonly] = ACTIONS(1687),
    [anon_sym_writeonly] = ACTIONS(1687),
    [anon_sym_argmemonly] = ACTIONS(1687),
    [anon_sym_returns_twice] = ACTIONS(1687),
    [anon_sym_safestack] = ACTIONS(1687),
    [anon_sym_sanitize_address] = ACTIONS(1687),
    [anon_sym_sanitize_memory] = ACTIONS(1687),
    [anon_sym_sanitize_thread] = ACTIONS(1687),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1687),
    [anon_sym_sanitize_memtag] = ACTIONS(1687),
    [anon_sym_speculative_load_hardening] = ACTIONS(1687),
    [anon_sym_speculatable] = ACTIONS(1687),
    [anon_sym_ssp] = ACTIONS(1687),
    [anon_sym_sspstrong] = ACTIONS(1687),
    [anon_sym_sspreq] = ACTIONS(1687),
    [anon_sym_strictfp] = ACTIONS(1687),
    [anon_sym_nocf_check] = ACTIONS(1687),
    [anon_sym_shadowcallstack] = ACTIONS(1687),
    [anon_sym_mustprogress] = ACTIONS(1687),
    [anon_sym_vscale_range] = ACTIONS(1687),
    [anon_sym_preallocated] = ACTIONS(1687),
    [anon_sym_zeroext] = ACTIONS(1687),
    [anon_sym_signext] = ACTIONS(1687),
    [anon_sym_inreg] = ACTIONS(1687),
    [anon_sym_byval] = ACTIONS(1687),
    [anon_sym_byref] = ACTIONS(1687),
    [anon_sym_inalloca] = ACTIONS(1687),
    [anon_sym_sret] = ACTIONS(1687),
    [anon_sym_elementtype] = ACTIONS(1687),
    [anon_sym_noalias] = ACTIONS(1687),
    [anon_sym_nocapture] = ACTIONS(1687),
    [anon_sym_nest] = ACTIONS(1687),
    [anon_sym_returned] = ACTIONS(1687),
    [anon_sym_nonnull] = ACTIONS(1687),
    [anon_sym_dereferenceable] = ACTIONS(1687),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1687),
    [anon_sym_swiftself] = ACTIONS(1687),
    [anon_sym_swiftasync] = ACTIONS(1687),
    [anon_sym_swifterror] = ACTIONS(1687),
    [anon_sym_immarg] = ACTIONS(1687),
    [anon_sym_noundef] = ACTIONS(1687),
    [anon_sym_uwtable] = ACTIONS(1689),
    [anon_sym_memory] = ACTIONS(1691),
    [anon_sym_COLON] = ACTIONS(1675),
    [aux_sym_specialized_md_value_token1] = ACTIONS(1693),
  },
  [474] = {
    [ts_builtin_sym_end] = ACTIONS(855),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(855),
    [sym_comdat_ref] = ACTIONS(855),
    [sym_global_var] = ACTIONS(855),
    [sym_local_var] = ACTIONS(855),
    [aux_sym_metadata_ref_token1] = ACTIONS(855),
    [sym_summary_ref] = ACTIONS(855),
    [sym_string] = ACTIONS(855),
    [anon_sym_target] = ACTIONS(855),
    [anon_sym_source_filename] = ACTIONS(855),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_define] = ACTIONS(855),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_RBRACE] = ACTIONS(855),
    [anon_sym_LBRACK] = ACTIONS(855),
    [anon_sym_COMMA] = ACTIONS(855),
    [anon_sym_align] = ACTIONS(857),
    [anon_sym_section] = ACTIONS(855),
    [anon_sym_partition] = ACTIONS(855),
    [anon_sym_comdat] = ACTIONS(855),
    [anon_sym_gc] = ACTIONS(855),
    [anon_sym_prefix] = ACTIONS(855),
    [anon_sym_prologue] = ACTIONS(855),
    [anon_sym_personality] = ACTIONS(855),
    [anon_sym_alignstack] = ACTIONS(855),
    [anon_sym_allocsize] = ACTIONS(855),
    [anon_sym_alwaysinline] = ACTIONS(855),
    [anon_sym_builtin] = ACTIONS(855),
    [anon_sym_cold] = ACTIONS(855),
    [anon_sym_convergent] = ACTIONS(855),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(855),
    [anon_sym_hot] = ACTIONS(855),
    [anon_sym_inaccessiblememonly] = ACTIONS(855),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(855),
    [anon_sym_inlinehint] = ACTIONS(855),
    [anon_sym_jumptable] = ACTIONS(855),
    [anon_sym_minsize] = ACTIONS(855),
    [anon_sym_naked] = ACTIONS(855),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(855),
    [anon_sym_nobuiltin] = ACTIONS(855),
    [anon_sym_noduplicate] = ACTIONS(855),
    [anon_sym_nofree] = ACTIONS(855),
    [anon_sym_noimplicitfloat] = ACTIONS(855),
    [anon_sym_noinline] = ACTIONS(855),
    [anon_sym_nomerge] = ACTIONS(855),
    [anon_sym_nonlazybind] = ACTIONS(855),
    [anon_sym_noprofile] = ACTIONS(855),
    [anon_sym_noredzone] = ACTIONS(855),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(855),
    [anon_sym_noreturn] = ACTIONS(855),
    [anon_sym_norecurse] = ACTIONS(855),
    [anon_sym_willreturn] = ACTIONS(855),
    [anon_sym_nosync] = ACTIONS(855),
    [anon_sym_nounwind] = ACTIONS(855),
    [anon_sym_nocallback] = ACTIONS(855),
    [anon_sym_nosanitize_coverage] = ACTIONS(855),
    [anon_sym_null_pointer_is_valid] = ACTIONS(855),
    [anon_sym_optforfuzzing] = ACTIONS(855),
    [anon_sym_optnone] = ACTIONS(855),
    [anon_sym_optsize] = ACTIONS(855),
    [anon_sym_readnone] = ACTIONS(855),
    [anon_sym_readonly] = ACTIONS(855),
    [anon_sym_writeonly] = ACTIONS(855),
    [anon_sym_argmemonly] = ACTIONS(855),
    [anon_sym_returns_twice] = ACTIONS(855),
    [anon_sym_safestack] = ACTIONS(855),
    [anon_sym_sanitize_address] = ACTIONS(855),
    [anon_sym_sanitize_memory] = ACTIONS(855),
    [anon_sym_sanitize_thread] = ACTIONS(855),
    [anon_sym_sanitize_hwaddress] = ACTIONS(855),
    [anon_sym_sanitize_memtag] = ACTIONS(855),
    [anon_sym_speculative_load_hardening] = ACTIONS(855),
    [anon_sym_speculatable] = ACTIONS(855),
    [anon_sym_ssp] = ACTIONS(857),
    [anon_sym_sspstrong] = ACTIONS(855),
    [anon_sym_sspreq] = ACTIONS(855),
    [anon_sym_strictfp] = ACTIONS(855),
    [anon_sym_nocf_check] = ACTIONS(855),
    [anon_sym_shadowcallstack] = ACTIONS(855),
    [anon_sym_mustprogress] = ACTIONS(855),
    [anon_sym_vscale_range] = ACTIONS(855),
    [anon_sym_preallocated] = ACTIONS(855),
    [anon_sym_zeroext] = ACTIONS(855),
    [anon_sym_signext] = ACTIONS(855),
    [anon_sym_inreg] = ACTIONS(855),
    [anon_sym_byval] = ACTIONS(855),
    [anon_sym_byref] = ACTIONS(855),
    [anon_sym_inalloca] = ACTIONS(855),
    [anon_sym_sret] = ACTIONS(855),
    [anon_sym_elementtype] = ACTIONS(855),
    [anon_sym_noalias] = ACTIONS(855),
    [anon_sym_nocapture] = ACTIONS(855),
    [anon_sym_nest] = ACTIONS(855),
    [anon_sym_returned] = ACTIONS(855),
    [anon_sym_nonnull] = ACTIONS(855),
    [anon_sym_dereferenceable] = ACTIONS(857),
    [anon_sym_dereferenceable_or_null] = ACTIONS(855),
    [anon_sym_swiftself] = ACTIONS(855),
    [anon_sym_swiftasync] = ACTIONS(855),
    [anon_sym_swifterror] = ACTIONS(855),
    [anon_sym_immarg] = ACTIONS(855),
    [anon_sym_noundef] = ACTIONS(855),
    [anon_sym_uwtable] = ACTIONS(855),
    [anon_sym_memory] = ACTIONS(855),
    [anon_sym_to] = ACTIONS(855),
    [anon_sym_uselistorder] = ACTIONS(857),
    [anon_sym_uselistorder_bb] = ACTIONS(855),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_attributes] = ACTIONS(855),
  },
  [475] = {
    [ts_builtin_sym_end] = ACTIONS(887),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(887),
    [sym_comdat_ref] = ACTIONS(887),
    [sym_global_var] = ACTIONS(887),
    [sym_local_var] = ACTIONS(887),
    [aux_sym_metadata_ref_token1] = ACTIONS(887),
    [sym_summary_ref] = ACTIONS(887),
    [sym_string] = ACTIONS(887),
    [anon_sym_target] = ACTIONS(887),
    [anon_sym_source_filename] = ACTIONS(887),
    [anon_sym_declare] = ACTIONS(887),
    [anon_sym_define] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(887),
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_align] = ACTIONS(889),
    [anon_sym_section] = ACTIONS(887),
    [anon_sym_partition] = ACTIONS(887),
    [anon_sym_comdat] = ACTIONS(887),
    [anon_sym_gc] = ACTIONS(887),
    [anon_sym_prefix] = ACTIONS(887),
    [anon_sym_prologue] = ACTIONS(887),
    [anon_sym_personality] = ACTIONS(887),
    [anon_sym_alignstack] = ACTIONS(887),
    [anon_sym_allocsize] = ACTIONS(887),
    [anon_sym_alwaysinline] = ACTIONS(887),
    [anon_sym_builtin] = ACTIONS(887),
    [anon_sym_cold] = ACTIONS(887),
    [anon_sym_convergent] = ACTIONS(887),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(887),
    [anon_sym_hot] = ACTIONS(887),
    [anon_sym_inaccessiblememonly] = ACTIONS(887),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(887),
    [anon_sym_inlinehint] = ACTIONS(887),
    [anon_sym_jumptable] = ACTIONS(887),
    [anon_sym_minsize] = ACTIONS(887),
    [anon_sym_naked] = ACTIONS(887),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(887),
    [anon_sym_nobuiltin] = ACTIONS(887),
    [anon_sym_noduplicate] = ACTIONS(887),
    [anon_sym_nofree] = ACTIONS(887),
    [anon_sym_noimplicitfloat] = ACTIONS(887),
    [anon_sym_noinline] = ACTIONS(887),
    [anon_sym_nomerge] = ACTIONS(887),
    [anon_sym_nonlazybind] = ACTIONS(887),
    [anon_sym_noprofile] = ACTIONS(887),
    [anon_sym_noredzone] = ACTIONS(887),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(887),
    [anon_sym_noreturn] = ACTIONS(887),
    [anon_sym_norecurse] = ACTIONS(887),
    [anon_sym_willreturn] = ACTIONS(887),
    [anon_sym_nosync] = ACTIONS(887),
    [anon_sym_nounwind] = ACTIONS(887),
    [anon_sym_nocallback] = ACTIONS(887),
    [anon_sym_nosanitize_coverage] = ACTIONS(887),
    [anon_sym_null_pointer_is_valid] = ACTIONS(887),
    [anon_sym_optforfuzzing] = ACTIONS(887),
    [anon_sym_optnone] = ACTIONS(887),
    [anon_sym_optsize] = ACTIONS(887),
    [anon_sym_readnone] = ACTIONS(887),
    [anon_sym_readonly] = ACTIONS(887),
    [anon_sym_writeonly] = ACTIONS(887),
    [anon_sym_argmemonly] = ACTIONS(887),
    [anon_sym_returns_twice] = ACTIONS(887),
    [anon_sym_safestack] = ACTIONS(887),
    [anon_sym_sanitize_address] = ACTIONS(887),
    [anon_sym_sanitize_memory] = ACTIONS(887),
    [anon_sym_sanitize_thread] = ACTIONS(887),
    [anon_sym_sanitize_hwaddress] = ACTIONS(887),
    [anon_sym_sanitize_memtag] = ACTIONS(887),
    [anon_sym_speculative_load_hardening] = ACTIONS(887),
    [anon_sym_speculatable] = ACTIONS(887),
    [anon_sym_ssp] = ACTIONS(889),
    [anon_sym_sspstrong] = ACTIONS(887),
    [anon_sym_sspreq] = ACTIONS(887),
    [anon_sym_strictfp] = ACTIONS(887),
    [anon_sym_nocf_check] = ACTIONS(887),
    [anon_sym_shadowcallstack] = ACTIONS(887),
    [anon_sym_mustprogress] = ACTIONS(887),
    [anon_sym_vscale_range] = ACTIONS(887),
    [anon_sym_preallocated] = ACTIONS(887),
    [anon_sym_zeroext] = ACTIONS(887),
    [anon_sym_signext] = ACTIONS(887),
    [anon_sym_inreg] = ACTIONS(887),
    [anon_sym_byval] = ACTIONS(887),
    [anon_sym_byref] = ACTIONS(887),
    [anon_sym_inalloca] = ACTIONS(887),
    [anon_sym_sret] = ACTIONS(887),
    [anon_sym_elementtype] = ACTIONS(887),
    [anon_sym_noalias] = ACTIONS(887),
    [anon_sym_nocapture] = ACTIONS(887),
    [anon_sym_nest] = ACTIONS(887),
    [anon_sym_returned] = ACTIONS(887),
    [anon_sym_nonnull] = ACTIONS(887),
    [anon_sym_dereferenceable] = ACTIONS(889),
    [anon_sym_dereferenceable_or_null] = ACTIONS(887),
    [anon_sym_swiftself] = ACTIONS(887),
    [anon_sym_swiftasync] = ACTIONS(887),
    [anon_sym_swifterror] = ACTIONS(887),
    [anon_sym_immarg] = ACTIONS(887),
    [anon_sym_noundef] = ACTIONS(887),
    [anon_sym_uwtable] = ACTIONS(887),
    [anon_sym_memory] = ACTIONS(887),
    [anon_sym_to] = ACTIONS(887),
    [anon_sym_uselistorder] = ACTIONS(889),
    [anon_sym_uselistorder_bb] = ACTIONS(887),
    [anon_sym_module] = ACTIONS(887),
    [anon_sym_attributes] = ACTIONS(887),
  },
  [476] = {
    [ts_builtin_sym_end] = ACTIONS(880),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(880),
    [sym_comdat_ref] = ACTIONS(880),
    [sym_global_var] = ACTIONS(880),
    [sym_local_var] = ACTIONS(880),
    [aux_sym_metadata_ref_token1] = ACTIONS(880),
    [sym_summary_ref] = ACTIONS(880),
    [sym_string] = ACTIONS(880),
    [anon_sym_target] = ACTIONS(880),
    [anon_sym_source_filename] = ACTIONS(880),
    [anon_sym_declare] = ACTIONS(880),
    [anon_sym_define] = ACTIONS(880),
    [anon_sym_LBRACE] = ACTIONS(880),
    [anon_sym_RBRACE] = ACTIONS(880),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_COMMA] = ACTIONS(880),
    [anon_sym_align] = ACTIONS(882),
    [anon_sym_section] = ACTIONS(880),
    [anon_sym_partition] = ACTIONS(880),
    [anon_sym_comdat] = ACTIONS(880),
    [anon_sym_gc] = ACTIONS(880),
    [anon_sym_prefix] = ACTIONS(880),
    [anon_sym_prologue] = ACTIONS(880),
    [anon_sym_personality] = ACTIONS(880),
    [anon_sym_alignstack] = ACTIONS(880),
    [anon_sym_allocsize] = ACTIONS(880),
    [anon_sym_alwaysinline] = ACTIONS(880),
    [anon_sym_builtin] = ACTIONS(880),
    [anon_sym_cold] = ACTIONS(880),
    [anon_sym_convergent] = ACTIONS(880),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(880),
    [anon_sym_hot] = ACTIONS(880),
    [anon_sym_inaccessiblememonly] = ACTIONS(880),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(880),
    [anon_sym_inlinehint] = ACTIONS(880),
    [anon_sym_jumptable] = ACTIONS(880),
    [anon_sym_minsize] = ACTIONS(880),
    [anon_sym_naked] = ACTIONS(880),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(880),
    [anon_sym_nobuiltin] = ACTIONS(880),
    [anon_sym_noduplicate] = ACTIONS(880),
    [anon_sym_nofree] = ACTIONS(880),
    [anon_sym_noimplicitfloat] = ACTIONS(880),
    [anon_sym_noinline] = ACTIONS(880),
    [anon_sym_nomerge] = ACTIONS(880),
    [anon_sym_nonlazybind] = ACTIONS(880),
    [anon_sym_noprofile] = ACTIONS(880),
    [anon_sym_noredzone] = ACTIONS(880),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(880),
    [anon_sym_noreturn] = ACTIONS(880),
    [anon_sym_norecurse] = ACTIONS(880),
    [anon_sym_willreturn] = ACTIONS(880),
    [anon_sym_nosync] = ACTIONS(880),
    [anon_sym_nounwind] = ACTIONS(880),
    [anon_sym_nocallback] = ACTIONS(880),
    [anon_sym_nosanitize_coverage] = ACTIONS(880),
    [anon_sym_null_pointer_is_valid] = ACTIONS(880),
    [anon_sym_optforfuzzing] = ACTIONS(880),
    [anon_sym_optnone] = ACTIONS(880),
    [anon_sym_optsize] = ACTIONS(880),
    [anon_sym_readnone] = ACTIONS(880),
    [anon_sym_readonly] = ACTIONS(880),
    [anon_sym_writeonly] = ACTIONS(880),
    [anon_sym_argmemonly] = ACTIONS(880),
    [anon_sym_returns_twice] = ACTIONS(880),
    [anon_sym_safestack] = ACTIONS(880),
    [anon_sym_sanitize_address] = ACTIONS(880),
    [anon_sym_sanitize_memory] = ACTIONS(880),
    [anon_sym_sanitize_thread] = ACTIONS(880),
    [anon_sym_sanitize_hwaddress] = ACTIONS(880),
    [anon_sym_sanitize_memtag] = ACTIONS(880),
    [anon_sym_speculative_load_hardening] = ACTIONS(880),
    [anon_sym_speculatable] = ACTIONS(880),
    [anon_sym_ssp] = ACTIONS(882),
    [anon_sym_sspstrong] = ACTIONS(880),
    [anon_sym_sspreq] = ACTIONS(880),
    [anon_sym_strictfp] = ACTIONS(880),
    [anon_sym_nocf_check] = ACTIONS(880),
    [anon_sym_shadowcallstack] = ACTIONS(880),
    [anon_sym_mustprogress] = ACTIONS(880),
    [anon_sym_vscale_range] = ACTIONS(880),
    [anon_sym_preallocated] = ACTIONS(880),
    [anon_sym_zeroext] = ACTIONS(880),
    [anon_sym_signext] = ACTIONS(880),
    [anon_sym_inreg] = ACTIONS(880),
    [anon_sym_byval] = ACTIONS(880),
    [anon_sym_byref] = ACTIONS(880),
    [anon_sym_inalloca] = ACTIONS(880),
    [anon_sym_sret] = ACTIONS(880),
    [anon_sym_elementtype] = ACTIONS(880),
    [anon_sym_noalias] = ACTIONS(880),
    [anon_sym_nocapture] = ACTIONS(880),
    [anon_sym_nest] = ACTIONS(880),
    [anon_sym_returned] = ACTIONS(880),
    [anon_sym_nonnull] = ACTIONS(880),
    [anon_sym_dereferenceable] = ACTIONS(882),
    [anon_sym_dereferenceable_or_null] = ACTIONS(880),
    [anon_sym_swiftself] = ACTIONS(880),
    [anon_sym_swiftasync] = ACTIONS(880),
    [anon_sym_swifterror] = ACTIONS(880),
    [anon_sym_immarg] = ACTIONS(880),
    [anon_sym_noundef] = ACTIONS(880),
    [anon_sym_uwtable] = ACTIONS(880),
    [anon_sym_memory] = ACTIONS(880),
    [anon_sym_to] = ACTIONS(880),
    [anon_sym_uselistorder] = ACTIONS(882),
    [anon_sym_uselistorder_bb] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(880),
    [anon_sym_attributes] = ACTIONS(880),
  },
  [477] = {
    [ts_builtin_sym_end] = ACTIONS(876),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(876),
    [sym_comdat_ref] = ACTIONS(876),
    [sym_global_var] = ACTIONS(876),
    [sym_local_var] = ACTIONS(876),
    [aux_sym_metadata_ref_token1] = ACTIONS(876),
    [sym_summary_ref] = ACTIONS(876),
    [sym_string] = ACTIONS(876),
    [anon_sym_target] = ACTIONS(876),
    [anon_sym_source_filename] = ACTIONS(876),
    [anon_sym_declare] = ACTIONS(876),
    [anon_sym_define] = ACTIONS(876),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_RBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(876),
    [anon_sym_COMMA] = ACTIONS(876),
    [anon_sym_align] = ACTIONS(878),
    [anon_sym_section] = ACTIONS(876),
    [anon_sym_partition] = ACTIONS(876),
    [anon_sym_comdat] = ACTIONS(876),
    [anon_sym_gc] = ACTIONS(876),
    [anon_sym_prefix] = ACTIONS(876),
    [anon_sym_prologue] = ACTIONS(876),
    [anon_sym_personality] = ACTIONS(876),
    [anon_sym_alignstack] = ACTIONS(876),
    [anon_sym_allocsize] = ACTIONS(876),
    [anon_sym_alwaysinline] = ACTIONS(876),
    [anon_sym_builtin] = ACTIONS(876),
    [anon_sym_cold] = ACTIONS(876),
    [anon_sym_convergent] = ACTIONS(876),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(876),
    [anon_sym_hot] = ACTIONS(876),
    [anon_sym_inaccessiblememonly] = ACTIONS(876),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(876),
    [anon_sym_inlinehint] = ACTIONS(876),
    [anon_sym_jumptable] = ACTIONS(876),
    [anon_sym_minsize] = ACTIONS(876),
    [anon_sym_naked] = ACTIONS(876),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(876),
    [anon_sym_nobuiltin] = ACTIONS(876),
    [anon_sym_noduplicate] = ACTIONS(876),
    [anon_sym_nofree] = ACTIONS(876),
    [anon_sym_noimplicitfloat] = ACTIONS(876),
    [anon_sym_noinline] = ACTIONS(876),
    [anon_sym_nomerge] = ACTIONS(876),
    [anon_sym_nonlazybind] = ACTIONS(876),
    [anon_sym_noprofile] = ACTIONS(876),
    [anon_sym_noredzone] = ACTIONS(876),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(876),
    [anon_sym_noreturn] = ACTIONS(876),
    [anon_sym_norecurse] = ACTIONS(876),
    [anon_sym_willreturn] = ACTIONS(876),
    [anon_sym_nosync] = ACTIONS(876),
    [anon_sym_nounwind] = ACTIONS(876),
    [anon_sym_nocallback] = ACTIONS(876),
    [anon_sym_nosanitize_coverage] = ACTIONS(876),
    [anon_sym_null_pointer_is_valid] = ACTIONS(876),
    [anon_sym_optforfuzzing] = ACTIONS(876),
    [anon_sym_optnone] = ACTIONS(876),
    [anon_sym_optsize] = ACTIONS(876),
    [anon_sym_readnone] = ACTIONS(876),
    [anon_sym_readonly] = ACTIONS(876),
    [anon_sym_writeonly] = ACTIONS(876),
    [anon_sym_argmemonly] = ACTIONS(876),
    [anon_sym_returns_twice] = ACTIONS(876),
    [anon_sym_safestack] = ACTIONS(876),
    [anon_sym_sanitize_address] = ACTIONS(876),
    [anon_sym_sanitize_memory] = ACTIONS(876),
    [anon_sym_sanitize_thread] = ACTIONS(876),
    [anon_sym_sanitize_hwaddress] = ACTIONS(876),
    [anon_sym_sanitize_memtag] = ACTIONS(876),
    [anon_sym_speculative_load_hardening] = ACTIONS(876),
    [anon_sym_speculatable] = ACTIONS(876),
    [anon_sym_ssp] = ACTIONS(878),
    [anon_sym_sspstrong] = ACTIONS(876),
    [anon_sym_sspreq] = ACTIONS(876),
    [anon_sym_strictfp] = ACTIONS(876),
    [anon_sym_nocf_check] = ACTIONS(876),
    [anon_sym_shadowcallstack] = ACTIONS(876),
    [anon_sym_mustprogress] = ACTIONS(876),
    [anon_sym_vscale_range] = ACTIONS(876),
    [anon_sym_preallocated] = ACTIONS(876),
    [anon_sym_zeroext] = ACTIONS(876),
    [anon_sym_signext] = ACTIONS(876),
    [anon_sym_inreg] = ACTIONS(876),
    [anon_sym_byval] = ACTIONS(876),
    [anon_sym_byref] = ACTIONS(876),
    [anon_sym_inalloca] = ACTIONS(876),
    [anon_sym_sret] = ACTIONS(876),
    [anon_sym_elementtype] = ACTIONS(876),
    [anon_sym_noalias] = ACTIONS(876),
    [anon_sym_nocapture] = ACTIONS(876),
    [anon_sym_nest] = ACTIONS(876),
    [anon_sym_returned] = ACTIONS(876),
    [anon_sym_nonnull] = ACTIONS(876),
    [anon_sym_dereferenceable] = ACTIONS(878),
    [anon_sym_dereferenceable_or_null] = ACTIONS(876),
    [anon_sym_swiftself] = ACTIONS(876),
    [anon_sym_swiftasync] = ACTIONS(876),
    [anon_sym_swifterror] = ACTIONS(876),
    [anon_sym_immarg] = ACTIONS(876),
    [anon_sym_noundef] = ACTIONS(876),
    [anon_sym_uwtable] = ACTIONS(876),
    [anon_sym_memory] = ACTIONS(876),
    [anon_sym_to] = ACTIONS(876),
    [anon_sym_uselistorder] = ACTIONS(878),
    [anon_sym_uselistorder_bb] = ACTIONS(876),
    [anon_sym_module] = ACTIONS(876),
    [anon_sym_attributes] = ACTIONS(876),
  },
  [478] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1701),
    [anon_sym_unnamed_addr] = ACTIONS(1701),
    [anon_sym_local_unnamed_addr] = ACTIONS(1701),
    [anon_sym_void] = ACTIONS(1701),
    [anon_sym_half] = ACTIONS(1701),
    [anon_sym_bfloat] = ACTIONS(1701),
    [anon_sym_float] = ACTIONS(1701),
    [anon_sym_double] = ACTIONS(1701),
    [anon_sym_x86_fp80] = ACTIONS(1701),
    [anon_sym_fp128] = ACTIONS(1701),
    [anon_sym_ppc_fp128] = ACTIONS(1701),
    [anon_sym_label] = ACTIONS(1701),
    [anon_sym_metadata] = ACTIONS(1701),
    [anon_sym_x86_mmx] = ACTIONS(1701),
    [anon_sym_x86_amx] = ACTIONS(1701),
    [anon_sym_token] = ACTIONS(1701),
    [anon_sym_opaque] = ACTIONS(1701),
    [anon_sym_ptr] = ACTIONS(1701),
    [aux_sym_type_keyword_token1] = ACTIONS(1701),
    [anon_sym_LBRACE] = ACTIONS(1701),
    [anon_sym_LT_LBRACE] = ACTIONS(1701),
    [anon_sym_LBRACK] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1703),
    [anon_sym_addrspace] = ACTIONS(1701),
    [anon_sym_align] = ACTIONS(1703),
    [anon_sym_alignstack] = ACTIONS(1701),
    [anon_sym_allocsize] = ACTIONS(1701),
    [anon_sym_alwaysinline] = ACTIONS(1701),
    [anon_sym_builtin] = ACTIONS(1701),
    [anon_sym_cold] = ACTIONS(1701),
    [anon_sym_convergent] = ACTIONS(1701),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1701),
    [anon_sym_hot] = ACTIONS(1701),
    [anon_sym_inaccessiblememonly] = ACTIONS(1701),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1701),
    [anon_sym_inlinehint] = ACTIONS(1701),
    [anon_sym_jumptable] = ACTIONS(1701),
    [anon_sym_minsize] = ACTIONS(1701),
    [anon_sym_naked] = ACTIONS(1701),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1701),
    [anon_sym_nobuiltin] = ACTIONS(1701),
    [anon_sym_noduplicate] = ACTIONS(1701),
    [anon_sym_nofree] = ACTIONS(1701),
    [anon_sym_noimplicitfloat] = ACTIONS(1701),
    [anon_sym_noinline] = ACTIONS(1701),
    [anon_sym_nomerge] = ACTIONS(1701),
    [anon_sym_nonlazybind] = ACTIONS(1701),
    [anon_sym_noprofile] = ACTIONS(1701),
    [anon_sym_noredzone] = ACTIONS(1701),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1701),
    [anon_sym_noreturn] = ACTIONS(1701),
    [anon_sym_norecurse] = ACTIONS(1701),
    [anon_sym_willreturn] = ACTIONS(1701),
    [anon_sym_nosync] = ACTIONS(1701),
    [anon_sym_nounwind] = ACTIONS(1701),
    [anon_sym_nocallback] = ACTIONS(1701),
    [anon_sym_nosanitize_coverage] = ACTIONS(1701),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1701),
    [anon_sym_optforfuzzing] = ACTIONS(1701),
    [anon_sym_optnone] = ACTIONS(1701),
    [anon_sym_optsize] = ACTIONS(1701),
    [anon_sym_readnone] = ACTIONS(1701),
    [anon_sym_readonly] = ACTIONS(1701),
    [anon_sym_writeonly] = ACTIONS(1701),
    [anon_sym_argmemonly] = ACTIONS(1701),
    [anon_sym_returns_twice] = ACTIONS(1701),
    [anon_sym_safestack] = ACTIONS(1701),
    [anon_sym_sanitize_address] = ACTIONS(1701),
    [anon_sym_sanitize_memory] = ACTIONS(1701),
    [anon_sym_sanitize_thread] = ACTIONS(1701),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1701),
    [anon_sym_sanitize_memtag] = ACTIONS(1701),
    [anon_sym_speculative_load_hardening] = ACTIONS(1701),
    [anon_sym_speculatable] = ACTIONS(1701),
    [anon_sym_ssp] = ACTIONS(1703),
    [anon_sym_sspstrong] = ACTIONS(1701),
    [anon_sym_sspreq] = ACTIONS(1701),
    [anon_sym_strictfp] = ACTIONS(1701),
    [anon_sym_nocf_check] = ACTIONS(1701),
    [anon_sym_shadowcallstack] = ACTIONS(1701),
    [anon_sym_mustprogress] = ACTIONS(1701),
    [anon_sym_vscale_range] = ACTIONS(1701),
    [anon_sym_preallocated] = ACTIONS(1701),
    [anon_sym_zeroext] = ACTIONS(1701),
    [anon_sym_signext] = ACTIONS(1701),
    [anon_sym_inreg] = ACTIONS(1701),
    [anon_sym_byval] = ACTIONS(1701),
    [anon_sym_byref] = ACTIONS(1701),
    [anon_sym_inalloca] = ACTIONS(1701),
    [anon_sym_sret] = ACTIONS(1701),
    [anon_sym_elementtype] = ACTIONS(1701),
    [anon_sym_noalias] = ACTIONS(1701),
    [anon_sym_nocapture] = ACTIONS(1701),
    [anon_sym_nest] = ACTIONS(1701),
    [anon_sym_returned] = ACTIONS(1701),
    [anon_sym_nonnull] = ACTIONS(1701),
    [anon_sym_dereferenceable] = ACTIONS(1703),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1701),
    [anon_sym_swiftself] = ACTIONS(1701),
    [anon_sym_swiftasync] = ACTIONS(1701),
    [anon_sym_swifterror] = ACTIONS(1701),
    [anon_sym_immarg] = ACTIONS(1701),
    [anon_sym_noundef] = ACTIONS(1701),
    [anon_sym_uwtable] = ACTIONS(1701),
    [anon_sym_memory] = ACTIONS(1701),
  },
  [479] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1705),
    [anon_sym_unnamed_addr] = ACTIONS(1705),
    [anon_sym_local_unnamed_addr] = ACTIONS(1705),
    [anon_sym_void] = ACTIONS(1705),
    [anon_sym_half] = ACTIONS(1705),
    [anon_sym_bfloat] = ACTIONS(1705),
    [anon_sym_float] = ACTIONS(1705),
    [anon_sym_double] = ACTIONS(1705),
    [anon_sym_x86_fp80] = ACTIONS(1705),
    [anon_sym_fp128] = ACTIONS(1705),
    [anon_sym_ppc_fp128] = ACTIONS(1705),
    [anon_sym_label] = ACTIONS(1705),
    [anon_sym_metadata] = ACTIONS(1705),
    [anon_sym_x86_mmx] = ACTIONS(1705),
    [anon_sym_x86_amx] = ACTIONS(1705),
    [anon_sym_token] = ACTIONS(1705),
    [anon_sym_opaque] = ACTIONS(1705),
    [anon_sym_ptr] = ACTIONS(1705),
    [aux_sym_type_keyword_token1] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1705),
    [anon_sym_LT_LBRACE] = ACTIONS(1705),
    [anon_sym_LBRACK] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_addrspace] = ACTIONS(1705),
    [anon_sym_align] = ACTIONS(1707),
    [anon_sym_alignstack] = ACTIONS(1705),
    [anon_sym_allocsize] = ACTIONS(1705),
    [anon_sym_alwaysinline] = ACTIONS(1705),
    [anon_sym_builtin] = ACTIONS(1705),
    [anon_sym_cold] = ACTIONS(1705),
    [anon_sym_convergent] = ACTIONS(1705),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1705),
    [anon_sym_hot] = ACTIONS(1705),
    [anon_sym_inaccessiblememonly] = ACTIONS(1705),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1705),
    [anon_sym_inlinehint] = ACTIONS(1705),
    [anon_sym_jumptable] = ACTIONS(1705),
    [anon_sym_minsize] = ACTIONS(1705),
    [anon_sym_naked] = ACTIONS(1705),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1705),
    [anon_sym_nobuiltin] = ACTIONS(1705),
    [anon_sym_noduplicate] = ACTIONS(1705),
    [anon_sym_nofree] = ACTIONS(1705),
    [anon_sym_noimplicitfloat] = ACTIONS(1705),
    [anon_sym_noinline] = ACTIONS(1705),
    [anon_sym_nomerge] = ACTIONS(1705),
    [anon_sym_nonlazybind] = ACTIONS(1705),
    [anon_sym_noprofile] = ACTIONS(1705),
    [anon_sym_noredzone] = ACTIONS(1705),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1705),
    [anon_sym_noreturn] = ACTIONS(1705),
    [anon_sym_norecurse] = ACTIONS(1705),
    [anon_sym_willreturn] = ACTIONS(1705),
    [anon_sym_nosync] = ACTIONS(1705),
    [anon_sym_nounwind] = ACTIONS(1705),
    [anon_sym_nocallback] = ACTIONS(1705),
    [anon_sym_nosanitize_coverage] = ACTIONS(1705),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1705),
    [anon_sym_optforfuzzing] = ACTIONS(1705),
    [anon_sym_optnone] = ACTIONS(1705),
    [anon_sym_optsize] = ACTIONS(1705),
    [anon_sym_readnone] = ACTIONS(1705),
    [anon_sym_readonly] = ACTIONS(1705),
    [anon_sym_writeonly] = ACTIONS(1705),
    [anon_sym_argmemonly] = ACTIONS(1705),
    [anon_sym_returns_twice] = ACTIONS(1705),
    [anon_sym_safestack] = ACTIONS(1705),
    [anon_sym_sanitize_address] = ACTIONS(1705),
    [anon_sym_sanitize_memory] = ACTIONS(1705),
    [anon_sym_sanitize_thread] = ACTIONS(1705),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1705),
    [anon_sym_sanitize_memtag] = ACTIONS(1705),
    [anon_sym_speculative_load_hardening] = ACTIONS(1705),
    [anon_sym_speculatable] = ACTIONS(1705),
    [anon_sym_ssp] = ACTIONS(1707),
    [anon_sym_sspstrong] = ACTIONS(1705),
    [anon_sym_sspreq] = ACTIONS(1705),
    [anon_sym_strictfp] = ACTIONS(1705),
    [anon_sym_nocf_check] = ACTIONS(1705),
    [anon_sym_shadowcallstack] = ACTIONS(1705),
    [anon_sym_mustprogress] = ACTIONS(1705),
    [anon_sym_vscale_range] = ACTIONS(1705),
    [anon_sym_preallocated] = ACTIONS(1705),
    [anon_sym_zeroext] = ACTIONS(1705),
    [anon_sym_signext] = ACTIONS(1705),
    [anon_sym_inreg] = ACTIONS(1705),
    [anon_sym_byval] = ACTIONS(1705),
    [anon_sym_byref] = ACTIONS(1705),
    [anon_sym_inalloca] = ACTIONS(1705),
    [anon_sym_sret] = ACTIONS(1705),
    [anon_sym_elementtype] = ACTIONS(1705),
    [anon_sym_noalias] = ACTIONS(1705),
    [anon_sym_nocapture] = ACTIONS(1705),
    [anon_sym_nest] = ACTIONS(1705),
    [anon_sym_returned] = ACTIONS(1705),
    [anon_sym_nonnull] = ACTIONS(1705),
    [anon_sym_dereferenceable] = ACTIONS(1707),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1705),
    [anon_sym_swiftself] = ACTIONS(1705),
    [anon_sym_swiftasync] = ACTIONS(1705),
    [anon_sym_swifterror] = ACTIONS(1705),
    [anon_sym_immarg] = ACTIONS(1705),
    [anon_sym_noundef] = ACTIONS(1705),
    [anon_sym_uwtable] = ACTIONS(1705),
    [anon_sym_memory] = ACTIONS(1705),
  },
  [480] = {
    [ts_builtin_sym_end] = ACTIONS(1543),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1543),
    [sym_comdat_ref] = ACTIONS(1543),
    [sym_global_var] = ACTIONS(1543),
    [sym_local_var] = ACTIONS(1543),
    [aux_sym_metadata_ref_token1] = ACTIONS(1543),
    [sym_summary_ref] = ACTIONS(1543),
    [sym_string] = ACTIONS(1543),
    [anon_sym_target] = ACTIONS(1543),
    [anon_sym_source_filename] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_define] = ACTIONS(1543),
    [anon_sym_COMMA] = ACTIONS(1543),
    [anon_sym_align] = ACTIONS(1575),
    [anon_sym_section] = ACTIONS(1543),
    [anon_sym_partition] = ACTIONS(1543),
    [anon_sym_comdat] = ACTIONS(1543),
    [anon_sym_gc] = ACTIONS(1543),
    [anon_sym_prefix] = ACTIONS(1543),
    [anon_sym_prologue] = ACTIONS(1543),
    [anon_sym_personality] = ACTIONS(1543),
    [anon_sym_alignstack] = ACTIONS(1543),
    [anon_sym_allocsize] = ACTIONS(1543),
    [anon_sym_alwaysinline] = ACTIONS(1543),
    [anon_sym_builtin] = ACTIONS(1543),
    [anon_sym_cold] = ACTIONS(1543),
    [anon_sym_convergent] = ACTIONS(1543),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1543),
    [anon_sym_hot] = ACTIONS(1543),
    [anon_sym_inaccessiblememonly] = ACTIONS(1543),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1543),
    [anon_sym_inlinehint] = ACTIONS(1543),
    [anon_sym_jumptable] = ACTIONS(1543),
    [anon_sym_minsize] = ACTIONS(1543),
    [anon_sym_naked] = ACTIONS(1543),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1543),
    [anon_sym_nobuiltin] = ACTIONS(1543),
    [anon_sym_noduplicate] = ACTIONS(1543),
    [anon_sym_nofree] = ACTIONS(1543),
    [anon_sym_noimplicitfloat] = ACTIONS(1543),
    [anon_sym_noinline] = ACTIONS(1543),
    [anon_sym_nomerge] = ACTIONS(1543),
    [anon_sym_nonlazybind] = ACTIONS(1543),
    [anon_sym_noprofile] = ACTIONS(1543),
    [anon_sym_noredzone] = ACTIONS(1543),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1543),
    [anon_sym_noreturn] = ACTIONS(1543),
    [anon_sym_norecurse] = ACTIONS(1543),
    [anon_sym_willreturn] = ACTIONS(1543),
    [anon_sym_nosync] = ACTIONS(1543),
    [anon_sym_nounwind] = ACTIONS(1543),
    [anon_sym_nocallback] = ACTIONS(1543),
    [anon_sym_nosanitize_coverage] = ACTIONS(1543),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1543),
    [anon_sym_optforfuzzing] = ACTIONS(1543),
    [anon_sym_optnone] = ACTIONS(1543),
    [anon_sym_optsize] = ACTIONS(1543),
    [anon_sym_readnone] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_writeonly] = ACTIONS(1543),
    [anon_sym_argmemonly] = ACTIONS(1543),
    [anon_sym_returns_twice] = ACTIONS(1543),
    [anon_sym_safestack] = ACTIONS(1543),
    [anon_sym_sanitize_address] = ACTIONS(1543),
    [anon_sym_sanitize_memory] = ACTIONS(1543),
    [anon_sym_sanitize_thread] = ACTIONS(1543),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1543),
    [anon_sym_sanitize_memtag] = ACTIONS(1543),
    [anon_sym_speculative_load_hardening] = ACTIONS(1543),
    [anon_sym_speculatable] = ACTIONS(1543),
    [anon_sym_ssp] = ACTIONS(1575),
    [anon_sym_sspstrong] = ACTIONS(1543),
    [anon_sym_sspreq] = ACTIONS(1543),
    [anon_sym_strictfp] = ACTIONS(1543),
    [anon_sym_nocf_check] = ACTIONS(1543),
    [anon_sym_shadowcallstack] = ACTIONS(1543),
    [anon_sym_mustprogress] = ACTIONS(1543),
    [anon_sym_vscale_range] = ACTIONS(1543),
    [anon_sym_preallocated] = ACTIONS(1543),
    [anon_sym_zeroext] = ACTIONS(1543),
    [anon_sym_signext] = ACTIONS(1543),
    [anon_sym_inreg] = ACTIONS(1543),
    [anon_sym_byval] = ACTIONS(1543),
    [anon_sym_byref] = ACTIONS(1543),
    [anon_sym_inalloca] = ACTIONS(1543),
    [anon_sym_sret] = ACTIONS(1543),
    [anon_sym_elementtype] = ACTIONS(1543),
    [anon_sym_noalias] = ACTIONS(1543),
    [anon_sym_nocapture] = ACTIONS(1543),
    [anon_sym_nest] = ACTIONS(1543),
    [anon_sym_returned] = ACTIONS(1543),
    [anon_sym_nonnull] = ACTIONS(1543),
    [anon_sym_dereferenceable] = ACTIONS(1575),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1543),
    [anon_sym_swiftself] = ACTIONS(1543),
    [anon_sym_swiftasync] = ACTIONS(1543),
    [anon_sym_swifterror] = ACTIONS(1543),
    [anon_sym_immarg] = ACTIONS(1543),
    [anon_sym_noundef] = ACTIONS(1543),
    [anon_sym_uwtable] = ACTIONS(1543),
    [anon_sym_memory] = ACTIONS(1543),
    [anon_sym_uselistorder] = ACTIONS(1575),
    [anon_sym_uselistorder_bb] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_attributes] = ACTIONS(1543),
  },
  [481] = {
    [sym_unnamed_addr] = STATE(500),
    [sym_addrspace] = STATE(511),
    [sym_attribute] = STATE(519),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(519),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1407),
    [sym_string] = ACTIONS(1372),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [482] = {
    [sym_unnamed_addr] = STATE(499),
    [sym_addrspace] = STATE(522),
    [sym_attribute] = STATE(518),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(518),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1370),
    [sym_string] = ACTIONS(1372),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_LBRACE] = ACTIONS(1370),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [483] = {
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(851),
    [sym_string] = ACTIONS(851),
    [aux_sym_number_token1] = ACTIONS(853),
    [aux_sym_number_token2] = ACTIONS(853),
    [anon_sym_private] = ACTIONS(853),
    [anon_sym_internal] = ACTIONS(853),
    [anon_sym_weak] = ACTIONS(853),
    [anon_sym_weak_odr] = ACTIONS(853),
    [anon_sym_linkonce] = ACTIONS(853),
    [anon_sym_linkonce_odr] = ACTIONS(853),
    [anon_sym_available_externally] = ACTIONS(853),
    [anon_sym_appending] = ACTIONS(853),
    [anon_sym_common] = ACTIONS(853),
    [anon_sym_extern_weak] = ACTIONS(853),
    [anon_sym_external] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(851),
    [anon_sym_RBRACK] = ACTIONS(851),
    [anon_sym_COMMA] = ACTIONS(851),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_RPAREN] = ACTIONS(851),
    [anon_sym_align] = ACTIONS(853),
    [anon_sym_alignstack] = ACTIONS(853),
    [anon_sym_allocsize] = ACTIONS(853),
    [anon_sym_alwaysinline] = ACTIONS(853),
    [anon_sym_builtin] = ACTIONS(853),
    [anon_sym_cold] = ACTIONS(853),
    [anon_sym_convergent] = ACTIONS(853),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(853),
    [anon_sym_hot] = ACTIONS(853),
    [anon_sym_inaccessiblememonly] = ACTIONS(853),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(853),
    [anon_sym_inlinehint] = ACTIONS(853),
    [anon_sym_jumptable] = ACTIONS(853),
    [anon_sym_minsize] = ACTIONS(853),
    [anon_sym_naked] = ACTIONS(853),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(853),
    [anon_sym_nobuiltin] = ACTIONS(853),
    [anon_sym_noduplicate] = ACTIONS(853),
    [anon_sym_nofree] = ACTIONS(853),
    [anon_sym_noimplicitfloat] = ACTIONS(853),
    [anon_sym_noinline] = ACTIONS(853),
    [anon_sym_nomerge] = ACTIONS(853),
    [anon_sym_nonlazybind] = ACTIONS(853),
    [anon_sym_noprofile] = ACTIONS(853),
    [anon_sym_noredzone] = ACTIONS(853),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(853),
    [anon_sym_noreturn] = ACTIONS(853),
    [anon_sym_norecurse] = ACTIONS(853),
    [anon_sym_willreturn] = ACTIONS(853),
    [anon_sym_nosync] = ACTIONS(853),
    [anon_sym_nounwind] = ACTIONS(853),
    [anon_sym_nocallback] = ACTIONS(853),
    [anon_sym_nosanitize_coverage] = ACTIONS(853),
    [anon_sym_null_pointer_is_valid] = ACTIONS(853),
    [anon_sym_optforfuzzing] = ACTIONS(853),
    [anon_sym_optnone] = ACTIONS(853),
    [anon_sym_optsize] = ACTIONS(853),
    [anon_sym_readnone] = ACTIONS(853),
    [anon_sym_readonly] = ACTIONS(853),
    [anon_sym_writeonly] = ACTIONS(853),
    [anon_sym_argmemonly] = ACTIONS(853),
    [anon_sym_returns_twice] = ACTIONS(853),
    [anon_sym_safestack] = ACTIONS(853),
    [anon_sym_sanitize_address] = ACTIONS(853),
    [anon_sym_sanitize_memory] = ACTIONS(853),
    [anon_sym_sanitize_thread] = ACTIONS(853),
    [anon_sym_sanitize_hwaddress] = ACTIONS(853),
    [anon_sym_sanitize_memtag] = ACTIONS(853),
    [anon_sym_speculative_load_hardening] = ACTIONS(853),
    [anon_sym_speculatable] = ACTIONS(853),
    [anon_sym_ssp] = ACTIONS(853),
    [anon_sym_sspstrong] = ACTIONS(853),
    [anon_sym_sspreq] = ACTIONS(853),
    [anon_sym_strictfp] = ACTIONS(853),
    [anon_sym_nocf_check] = ACTIONS(853),
    [anon_sym_shadowcallstack] = ACTIONS(853),
    [anon_sym_mustprogress] = ACTIONS(853),
    [anon_sym_vscale_range] = ACTIONS(853),
    [anon_sym_preallocated] = ACTIONS(853),
    [anon_sym_zeroext] = ACTIONS(853),
    [anon_sym_signext] = ACTIONS(853),
    [anon_sym_inreg] = ACTIONS(853),
    [anon_sym_byval] = ACTIONS(853),
    [anon_sym_byref] = ACTIONS(853),
    [anon_sym_inalloca] = ACTIONS(853),
    [anon_sym_sret] = ACTIONS(853),
    [anon_sym_elementtype] = ACTIONS(853),
    [anon_sym_noalias] = ACTIONS(853),
    [anon_sym_nocapture] = ACTIONS(853),
    [anon_sym_nest] = ACTIONS(853),
    [anon_sym_returned] = ACTIONS(853),
    [anon_sym_nonnull] = ACTIONS(853),
    [anon_sym_dereferenceable] = ACTIONS(853),
    [anon_sym_dereferenceable_or_null] = ACTIONS(853),
    [anon_sym_swiftself] = ACTIONS(853),
    [anon_sym_swiftasync] = ACTIONS(853),
    [anon_sym_swifterror] = ACTIONS(853),
    [anon_sym_immarg] = ACTIONS(853),
    [anon_sym_noundef] = ACTIONS(853),
    [anon_sym_uwtable] = ACTIONS(853),
    [anon_sym_memory] = ACTIONS(853),
    [anon_sym_COLON] = ACTIONS(851),
    [aux_sym_specialized_md_value_token1] = ACTIONS(853),
  },
  [484] = {
    [sym_unnamed_addr] = STATE(501),
    [sym_addrspace] = STATE(532),
    [sym_attribute] = STATE(531),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(531),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1399),
    [sym_string] = ACTIONS(1372),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_LBRACE] = ACTIONS(1399),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [485] = {
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(843),
    [sym_string] = ACTIONS(843),
    [aux_sym_number_token1] = ACTIONS(845),
    [aux_sym_number_token2] = ACTIONS(845),
    [anon_sym_private] = ACTIONS(845),
    [anon_sym_internal] = ACTIONS(845),
    [anon_sym_weak] = ACTIONS(845),
    [anon_sym_weak_odr] = ACTIONS(845),
    [anon_sym_linkonce] = ACTIONS(845),
    [anon_sym_linkonce_odr] = ACTIONS(845),
    [anon_sym_available_externally] = ACTIONS(845),
    [anon_sym_appending] = ACTIONS(845),
    [anon_sym_common] = ACTIONS(845),
    [anon_sym_extern_weak] = ACTIONS(845),
    [anon_sym_external] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(843),
    [anon_sym_RBRACK] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_RPAREN] = ACTIONS(843),
    [anon_sym_align] = ACTIONS(845),
    [anon_sym_alignstack] = ACTIONS(845),
    [anon_sym_allocsize] = ACTIONS(845),
    [anon_sym_alwaysinline] = ACTIONS(845),
    [anon_sym_builtin] = ACTIONS(845),
    [anon_sym_cold] = ACTIONS(845),
    [anon_sym_convergent] = ACTIONS(845),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(845),
    [anon_sym_hot] = ACTIONS(845),
    [anon_sym_inaccessiblememonly] = ACTIONS(845),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(845),
    [anon_sym_inlinehint] = ACTIONS(845),
    [anon_sym_jumptable] = ACTIONS(845),
    [anon_sym_minsize] = ACTIONS(845),
    [anon_sym_naked] = ACTIONS(845),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(845),
    [anon_sym_nobuiltin] = ACTIONS(845),
    [anon_sym_noduplicate] = ACTIONS(845),
    [anon_sym_nofree] = ACTIONS(845),
    [anon_sym_noimplicitfloat] = ACTIONS(845),
    [anon_sym_noinline] = ACTIONS(845),
    [anon_sym_nomerge] = ACTIONS(845),
    [anon_sym_nonlazybind] = ACTIONS(845),
    [anon_sym_noprofile] = ACTIONS(845),
    [anon_sym_noredzone] = ACTIONS(845),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(845),
    [anon_sym_noreturn] = ACTIONS(845),
    [anon_sym_norecurse] = ACTIONS(845),
    [anon_sym_willreturn] = ACTIONS(845),
    [anon_sym_nosync] = ACTIONS(845),
    [anon_sym_nounwind] = ACTIONS(845),
    [anon_sym_nocallback] = ACTIONS(845),
    [anon_sym_nosanitize_coverage] = ACTIONS(845),
    [anon_sym_null_pointer_is_valid] = ACTIONS(845),
    [anon_sym_optforfuzzing] = ACTIONS(845),
    [anon_sym_optnone] = ACTIONS(845),
    [anon_sym_optsize] = ACTIONS(845),
    [anon_sym_readnone] = ACTIONS(845),
    [anon_sym_readonly] = ACTIONS(845),
    [anon_sym_writeonly] = ACTIONS(845),
    [anon_sym_argmemonly] = ACTIONS(845),
    [anon_sym_returns_twice] = ACTIONS(845),
    [anon_sym_safestack] = ACTIONS(845),
    [anon_sym_sanitize_address] = ACTIONS(845),
    [anon_sym_sanitize_memory] = ACTIONS(845),
    [anon_sym_sanitize_thread] = ACTIONS(845),
    [anon_sym_sanitize_hwaddress] = ACTIONS(845),
    [anon_sym_sanitize_memtag] = ACTIONS(845),
    [anon_sym_speculative_load_hardening] = ACTIONS(845),
    [anon_sym_speculatable] = ACTIONS(845),
    [anon_sym_ssp] = ACTIONS(845),
    [anon_sym_sspstrong] = ACTIONS(845),
    [anon_sym_sspreq] = ACTIONS(845),
    [anon_sym_strictfp] = ACTIONS(845),
    [anon_sym_nocf_check] = ACTIONS(845),
    [anon_sym_shadowcallstack] = ACTIONS(845),
    [anon_sym_mustprogress] = ACTIONS(845),
    [anon_sym_vscale_range] = ACTIONS(845),
    [anon_sym_preallocated] = ACTIONS(845),
    [anon_sym_zeroext] = ACTIONS(845),
    [anon_sym_signext] = ACTIONS(845),
    [anon_sym_inreg] = ACTIONS(845),
    [anon_sym_byval] = ACTIONS(845),
    [anon_sym_byref] = ACTIONS(845),
    [anon_sym_inalloca] = ACTIONS(845),
    [anon_sym_sret] = ACTIONS(845),
    [anon_sym_elementtype] = ACTIONS(845),
    [anon_sym_noalias] = ACTIONS(845),
    [anon_sym_nocapture] = ACTIONS(845),
    [anon_sym_nest] = ACTIONS(845),
    [anon_sym_returned] = ACTIONS(845),
    [anon_sym_nonnull] = ACTIONS(845),
    [anon_sym_dereferenceable] = ACTIONS(845),
    [anon_sym_dereferenceable_or_null] = ACTIONS(845),
    [anon_sym_swiftself] = ACTIONS(845),
    [anon_sym_swiftasync] = ACTIONS(845),
    [anon_sym_swifterror] = ACTIONS(845),
    [anon_sym_immarg] = ACTIONS(845),
    [anon_sym_noundef] = ACTIONS(845),
    [anon_sym_uwtable] = ACTIONS(845),
    [anon_sym_memory] = ACTIONS(845),
    [anon_sym_COLON] = ACTIONS(843),
    [aux_sym_specialized_md_value_token1] = ACTIONS(845),
  },
  [486] = {
    [sym_unnamed_addr] = STATE(502),
    [sym_addrspace] = STATE(521),
    [sym_attribute] = STATE(520),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(520),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1411),
    [sym_string] = ACTIONS(1372),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_LBRACE] = ACTIONS(1411),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [487] = {
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(839),
    [sym_string] = ACTIONS(839),
    [aux_sym_number_token1] = ACTIONS(841),
    [aux_sym_number_token2] = ACTIONS(841),
    [anon_sym_private] = ACTIONS(841),
    [anon_sym_internal] = ACTIONS(841),
    [anon_sym_weak] = ACTIONS(841),
    [anon_sym_weak_odr] = ACTIONS(841),
    [anon_sym_linkonce] = ACTIONS(841),
    [anon_sym_linkonce_odr] = ACTIONS(841),
    [anon_sym_available_externally] = ACTIONS(841),
    [anon_sym_appending] = ACTIONS(841),
    [anon_sym_common] = ACTIONS(841),
    [anon_sym_extern_weak] = ACTIONS(841),
    [anon_sym_external] = ACTIONS(841),
    [anon_sym_LBRACK] = ACTIONS(839),
    [anon_sym_RBRACK] = ACTIONS(839),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_RPAREN] = ACTIONS(839),
    [anon_sym_align] = ACTIONS(841),
    [anon_sym_alignstack] = ACTIONS(841),
    [anon_sym_allocsize] = ACTIONS(841),
    [anon_sym_alwaysinline] = ACTIONS(841),
    [anon_sym_builtin] = ACTIONS(841),
    [anon_sym_cold] = ACTIONS(841),
    [anon_sym_convergent] = ACTIONS(841),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(841),
    [anon_sym_hot] = ACTIONS(841),
    [anon_sym_inaccessiblememonly] = ACTIONS(841),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(841),
    [anon_sym_inlinehint] = ACTIONS(841),
    [anon_sym_jumptable] = ACTIONS(841),
    [anon_sym_minsize] = ACTIONS(841),
    [anon_sym_naked] = ACTIONS(841),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(841),
    [anon_sym_nobuiltin] = ACTIONS(841),
    [anon_sym_noduplicate] = ACTIONS(841),
    [anon_sym_nofree] = ACTIONS(841),
    [anon_sym_noimplicitfloat] = ACTIONS(841),
    [anon_sym_noinline] = ACTIONS(841),
    [anon_sym_nomerge] = ACTIONS(841),
    [anon_sym_nonlazybind] = ACTIONS(841),
    [anon_sym_noprofile] = ACTIONS(841),
    [anon_sym_noredzone] = ACTIONS(841),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(841),
    [anon_sym_noreturn] = ACTIONS(841),
    [anon_sym_norecurse] = ACTIONS(841),
    [anon_sym_willreturn] = ACTIONS(841),
    [anon_sym_nosync] = ACTIONS(841),
    [anon_sym_nounwind] = ACTIONS(841),
    [anon_sym_nocallback] = ACTIONS(841),
    [anon_sym_nosanitize_coverage] = ACTIONS(841),
    [anon_sym_null_pointer_is_valid] = ACTIONS(841),
    [anon_sym_optforfuzzing] = ACTIONS(841),
    [anon_sym_optnone] = ACTIONS(841),
    [anon_sym_optsize] = ACTIONS(841),
    [anon_sym_readnone] = ACTIONS(841),
    [anon_sym_readonly] = ACTIONS(841),
    [anon_sym_writeonly] = ACTIONS(841),
    [anon_sym_argmemonly] = ACTIONS(841),
    [anon_sym_returns_twice] = ACTIONS(841),
    [anon_sym_safestack] = ACTIONS(841),
    [anon_sym_sanitize_address] = ACTIONS(841),
    [anon_sym_sanitize_memory] = ACTIONS(841),
    [anon_sym_sanitize_thread] = ACTIONS(841),
    [anon_sym_sanitize_hwaddress] = ACTIONS(841),
    [anon_sym_sanitize_memtag] = ACTIONS(841),
    [anon_sym_speculative_load_hardening] = ACTIONS(841),
    [anon_sym_speculatable] = ACTIONS(841),
    [anon_sym_ssp] = ACTIONS(841),
    [anon_sym_sspstrong] = ACTIONS(841),
    [anon_sym_sspreq] = ACTIONS(841),
    [anon_sym_strictfp] = ACTIONS(841),
    [anon_sym_nocf_check] = ACTIONS(841),
    [anon_sym_shadowcallstack] = ACTIONS(841),
    [anon_sym_mustprogress] = ACTIONS(841),
    [anon_sym_vscale_range] = ACTIONS(841),
    [anon_sym_preallocated] = ACTIONS(841),
    [anon_sym_zeroext] = ACTIONS(841),
    [anon_sym_signext] = ACTIONS(841),
    [anon_sym_inreg] = ACTIONS(841),
    [anon_sym_byval] = ACTIONS(841),
    [anon_sym_byref] = ACTIONS(841),
    [anon_sym_inalloca] = ACTIONS(841),
    [anon_sym_sret] = ACTIONS(841),
    [anon_sym_elementtype] = ACTIONS(841),
    [anon_sym_noalias] = ACTIONS(841),
    [anon_sym_nocapture] = ACTIONS(841),
    [anon_sym_nest] = ACTIONS(841),
    [anon_sym_returned] = ACTIONS(841),
    [anon_sym_nonnull] = ACTIONS(841),
    [anon_sym_dereferenceable] = ACTIONS(841),
    [anon_sym_dereferenceable_or_null] = ACTIONS(841),
    [anon_sym_swiftself] = ACTIONS(841),
    [anon_sym_swiftasync] = ACTIONS(841),
    [anon_sym_swifterror] = ACTIONS(841),
    [anon_sym_immarg] = ACTIONS(841),
    [anon_sym_noundef] = ACTIONS(841),
    [anon_sym_uwtable] = ACTIONS(841),
    [anon_sym_memory] = ACTIONS(841),
    [anon_sym_COLON] = ACTIONS(839),
    [aux_sym_specialized_md_value_token1] = ACTIONS(841),
  },
  [488] = {
    [sym_unnamed_addr] = STATE(498),
    [sym_addrspace] = STATE(534),
    [sym_attribute] = STATE(535),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(535),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1403),
    [sym_string] = ACTIONS(1372),
    [anon_sym_unnamed_addr] = ACTIONS(727),
    [anon_sym_local_unnamed_addr] = ACTIONS(727),
    [anon_sym_LBRACE] = ACTIONS(1403),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [489] = {
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(863),
    [sym_string] = ACTIONS(863),
    [aux_sym_number_token1] = ACTIONS(865),
    [aux_sym_number_token2] = ACTIONS(865),
    [anon_sym_private] = ACTIONS(865),
    [anon_sym_internal] = ACTIONS(865),
    [anon_sym_weak] = ACTIONS(865),
    [anon_sym_weak_odr] = ACTIONS(865),
    [anon_sym_linkonce] = ACTIONS(865),
    [anon_sym_linkonce_odr] = ACTIONS(865),
    [anon_sym_available_externally] = ACTIONS(865),
    [anon_sym_appending] = ACTIONS(865),
    [anon_sym_common] = ACTIONS(865),
    [anon_sym_extern_weak] = ACTIONS(865),
    [anon_sym_external] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_RBRACK] = ACTIONS(863),
    [anon_sym_COMMA] = ACTIONS(863),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_RPAREN] = ACTIONS(863),
    [anon_sym_align] = ACTIONS(865),
    [anon_sym_alignstack] = ACTIONS(865),
    [anon_sym_allocsize] = ACTIONS(865),
    [anon_sym_alwaysinline] = ACTIONS(865),
    [anon_sym_builtin] = ACTIONS(865),
    [anon_sym_cold] = ACTIONS(865),
    [anon_sym_convergent] = ACTIONS(865),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(865),
    [anon_sym_hot] = ACTIONS(865),
    [anon_sym_inaccessiblememonly] = ACTIONS(865),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(865),
    [anon_sym_inlinehint] = ACTIONS(865),
    [anon_sym_jumptable] = ACTIONS(865),
    [anon_sym_minsize] = ACTIONS(865),
    [anon_sym_naked] = ACTIONS(865),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(865),
    [anon_sym_nobuiltin] = ACTIONS(865),
    [anon_sym_noduplicate] = ACTIONS(865),
    [anon_sym_nofree] = ACTIONS(865),
    [anon_sym_noimplicitfloat] = ACTIONS(865),
    [anon_sym_noinline] = ACTIONS(865),
    [anon_sym_nomerge] = ACTIONS(865),
    [anon_sym_nonlazybind] = ACTIONS(865),
    [anon_sym_noprofile] = ACTIONS(865),
    [anon_sym_noredzone] = ACTIONS(865),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(865),
    [anon_sym_noreturn] = ACTIONS(865),
    [anon_sym_norecurse] = ACTIONS(865),
    [anon_sym_willreturn] = ACTIONS(865),
    [anon_sym_nosync] = ACTIONS(865),
    [anon_sym_nounwind] = ACTIONS(865),
    [anon_sym_nocallback] = ACTIONS(865),
    [anon_sym_nosanitize_coverage] = ACTIONS(865),
    [anon_sym_null_pointer_is_valid] = ACTIONS(865),
    [anon_sym_optforfuzzing] = ACTIONS(865),
    [anon_sym_optnone] = ACTIONS(865),
    [anon_sym_optsize] = ACTIONS(865),
    [anon_sym_readnone] = ACTIONS(865),
    [anon_sym_readonly] = ACTIONS(865),
    [anon_sym_writeonly] = ACTIONS(865),
    [anon_sym_argmemonly] = ACTIONS(865),
    [anon_sym_returns_twice] = ACTIONS(865),
    [anon_sym_safestack] = ACTIONS(865),
    [anon_sym_sanitize_address] = ACTIONS(865),
    [anon_sym_sanitize_memory] = ACTIONS(865),
    [anon_sym_sanitize_thread] = ACTIONS(865),
    [anon_sym_sanitize_hwaddress] = ACTIONS(865),
    [anon_sym_sanitize_memtag] = ACTIONS(865),
    [anon_sym_speculative_load_hardening] = ACTIONS(865),
    [anon_sym_speculatable] = ACTIONS(865),
    [anon_sym_ssp] = ACTIONS(865),
    [anon_sym_sspstrong] = ACTIONS(865),
    [anon_sym_sspreq] = ACTIONS(865),
    [anon_sym_strictfp] = ACTIONS(865),
    [anon_sym_nocf_check] = ACTIONS(865),
    [anon_sym_shadowcallstack] = ACTIONS(865),
    [anon_sym_mustprogress] = ACTIONS(865),
    [anon_sym_vscale_range] = ACTIONS(865),
    [anon_sym_preallocated] = ACTIONS(865),
    [anon_sym_zeroext] = ACTIONS(865),
    [anon_sym_signext] = ACTIONS(865),
    [anon_sym_inreg] = ACTIONS(865),
    [anon_sym_byval] = ACTIONS(865),
    [anon_sym_byref] = ACTIONS(865),
    [anon_sym_inalloca] = ACTIONS(865),
    [anon_sym_sret] = ACTIONS(865),
    [anon_sym_elementtype] = ACTIONS(865),
    [anon_sym_noalias] = ACTIONS(865),
    [anon_sym_nocapture] = ACTIONS(865),
    [anon_sym_nest] = ACTIONS(865),
    [anon_sym_returned] = ACTIONS(865),
    [anon_sym_nonnull] = ACTIONS(865),
    [anon_sym_dereferenceable] = ACTIONS(865),
    [anon_sym_dereferenceable_or_null] = ACTIONS(865),
    [anon_sym_swiftself] = ACTIONS(865),
    [anon_sym_swiftasync] = ACTIONS(865),
    [anon_sym_swifterror] = ACTIONS(865),
    [anon_sym_immarg] = ACTIONS(865),
    [anon_sym_noundef] = ACTIONS(865),
    [anon_sym_uwtable] = ACTIONS(865),
    [anon_sym_memory] = ACTIONS(865),
    [anon_sym_COLON] = ACTIONS(863),
    [aux_sym_specialized_md_value_token1] = ACTIONS(865),
  },
  [490] = {
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(1714),
    [sym_string] = ACTIONS(1714),
    [aux_sym_number_token1] = ACTIONS(1716),
    [aux_sym_number_token2] = ACTIONS(1716),
    [anon_sym_private] = ACTIONS(1716),
    [anon_sym_internal] = ACTIONS(1716),
    [anon_sym_weak] = ACTIONS(1716),
    [anon_sym_weak_odr] = ACTIONS(1716),
    [anon_sym_linkonce] = ACTIONS(1716),
    [anon_sym_linkonce_odr] = ACTIONS(1716),
    [anon_sym_available_externally] = ACTIONS(1716),
    [anon_sym_appending] = ACTIONS(1716),
    [anon_sym_common] = ACTIONS(1716),
    [anon_sym_extern_weak] = ACTIONS(1716),
    [anon_sym_external] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1714),
    [anon_sym_RBRACK] = ACTIONS(1714),
    [anon_sym_COMMA] = ACTIONS(1714),
    [anon_sym_LPAREN] = ACTIONS(1714),
    [anon_sym_RPAREN] = ACTIONS(1714),
    [anon_sym_align] = ACTIONS(1716),
    [anon_sym_alignstack] = ACTIONS(1716),
    [anon_sym_allocsize] = ACTIONS(1716),
    [anon_sym_alwaysinline] = ACTIONS(1716),
    [anon_sym_builtin] = ACTIONS(1716),
    [anon_sym_cold] = ACTIONS(1716),
    [anon_sym_convergent] = ACTIONS(1716),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1716),
    [anon_sym_hot] = ACTIONS(1716),
    [anon_sym_inaccessiblememonly] = ACTIONS(1716),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1716),
    [anon_sym_inlinehint] = ACTIONS(1716),
    [anon_sym_jumptable] = ACTIONS(1716),
    [anon_sym_minsize] = ACTIONS(1716),
    [anon_sym_naked] = ACTIONS(1716),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1716),
    [anon_sym_nobuiltin] = ACTIONS(1716),
    [anon_sym_noduplicate] = ACTIONS(1716),
    [anon_sym_nofree] = ACTIONS(1716),
    [anon_sym_noimplicitfloat] = ACTIONS(1716),
    [anon_sym_noinline] = ACTIONS(1716),
    [anon_sym_nomerge] = ACTIONS(1716),
    [anon_sym_nonlazybind] = ACTIONS(1716),
    [anon_sym_noprofile] = ACTIONS(1716),
    [anon_sym_noredzone] = ACTIONS(1716),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1716),
    [anon_sym_noreturn] = ACTIONS(1716),
    [anon_sym_norecurse] = ACTIONS(1716),
    [anon_sym_willreturn] = ACTIONS(1716),
    [anon_sym_nosync] = ACTIONS(1716),
    [anon_sym_nounwind] = ACTIONS(1716),
    [anon_sym_nocallback] = ACTIONS(1716),
    [anon_sym_nosanitize_coverage] = ACTIONS(1716),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1716),
    [anon_sym_optforfuzzing] = ACTIONS(1716),
    [anon_sym_optnone] = ACTIONS(1716),
    [anon_sym_optsize] = ACTIONS(1716),
    [anon_sym_readnone] = ACTIONS(1716),
    [anon_sym_readonly] = ACTIONS(1716),
    [anon_sym_writeonly] = ACTIONS(1716),
    [anon_sym_argmemonly] = ACTIONS(1716),
    [anon_sym_returns_twice] = ACTIONS(1716),
    [anon_sym_safestack] = ACTIONS(1716),
    [anon_sym_sanitize_address] = ACTIONS(1716),
    [anon_sym_sanitize_memory] = ACTIONS(1716),
    [anon_sym_sanitize_thread] = ACTIONS(1716),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1716),
    [anon_sym_sanitize_memtag] = ACTIONS(1716),
    [anon_sym_speculative_load_hardening] = ACTIONS(1716),
    [anon_sym_speculatable] = ACTIONS(1716),
    [anon_sym_ssp] = ACTIONS(1716),
    [anon_sym_sspstrong] = ACTIONS(1716),
    [anon_sym_sspreq] = ACTIONS(1716),
    [anon_sym_strictfp] = ACTIONS(1716),
    [anon_sym_nocf_check] = ACTIONS(1716),
    [anon_sym_shadowcallstack] = ACTIONS(1716),
    [anon_sym_mustprogress] = ACTIONS(1716),
    [anon_sym_vscale_range] = ACTIONS(1716),
    [anon_sym_preallocated] = ACTIONS(1716),
    [anon_sym_zeroext] = ACTIONS(1716),
    [anon_sym_signext] = ACTIONS(1716),
    [anon_sym_inreg] = ACTIONS(1716),
    [anon_sym_byval] = ACTIONS(1716),
    [anon_sym_byref] = ACTIONS(1716),
    [anon_sym_inalloca] = ACTIONS(1716),
    [anon_sym_sret] = ACTIONS(1716),
    [anon_sym_elementtype] = ACTIONS(1716),
    [anon_sym_noalias] = ACTIONS(1716),
    [anon_sym_nocapture] = ACTIONS(1716),
    [anon_sym_nest] = ACTIONS(1716),
    [anon_sym_returned] = ACTIONS(1716),
    [anon_sym_nonnull] = ACTIONS(1716),
    [anon_sym_dereferenceable] = ACTIONS(1716),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1716),
    [anon_sym_swiftself] = ACTIONS(1716),
    [anon_sym_swiftasync] = ACTIONS(1716),
    [anon_sym_swifterror] = ACTIONS(1716),
    [anon_sym_immarg] = ACTIONS(1716),
    [anon_sym_noundef] = ACTIONS(1716),
    [anon_sym_uwtable] = ACTIONS(1716),
    [anon_sym_memory] = ACTIONS(1716),
    [anon_sym_COLON] = ACTIONS(1714),
    [aux_sym_specialized_md_value_token1] = ACTIONS(1716),
  },
  [491] = {
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(713),
    [sym_string] = ACTIONS(713),
    [aux_sym_number_token1] = ACTIONS(715),
    [aux_sym_number_token2] = ACTIONS(715),
    [anon_sym_private] = ACTIONS(715),
    [anon_sym_internal] = ACTIONS(715),
    [anon_sym_weak] = ACTIONS(715),
    [anon_sym_weak_odr] = ACTIONS(715),
    [anon_sym_linkonce] = ACTIONS(715),
    [anon_sym_linkonce_odr] = ACTIONS(715),
    [anon_sym_available_externally] = ACTIONS(715),
    [anon_sym_appending] = ACTIONS(715),
    [anon_sym_common] = ACTIONS(715),
    [anon_sym_extern_weak] = ACTIONS(715),
    [anon_sym_external] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(713),
    [anon_sym_RBRACK] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(713),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(713),
    [anon_sym_align] = ACTIONS(715),
    [anon_sym_alignstack] = ACTIONS(715),
    [anon_sym_allocsize] = ACTIONS(715),
    [anon_sym_alwaysinline] = ACTIONS(715),
    [anon_sym_builtin] = ACTIONS(715),
    [anon_sym_cold] = ACTIONS(715),
    [anon_sym_convergent] = ACTIONS(715),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(715),
    [anon_sym_hot] = ACTIONS(715),
    [anon_sym_inaccessiblememonly] = ACTIONS(715),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(715),
    [anon_sym_inlinehint] = ACTIONS(715),
    [anon_sym_jumptable] = ACTIONS(715),
    [anon_sym_minsize] = ACTIONS(715),
    [anon_sym_naked] = ACTIONS(715),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(715),
    [anon_sym_nobuiltin] = ACTIONS(715),
    [anon_sym_noduplicate] = ACTIONS(715),
    [anon_sym_nofree] = ACTIONS(715),
    [anon_sym_noimplicitfloat] = ACTIONS(715),
    [anon_sym_noinline] = ACTIONS(715),
    [anon_sym_nomerge] = ACTIONS(715),
    [anon_sym_nonlazybind] = ACTIONS(715),
    [anon_sym_noprofile] = ACTIONS(715),
    [anon_sym_noredzone] = ACTIONS(715),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(715),
    [anon_sym_noreturn] = ACTIONS(715),
    [anon_sym_norecurse] = ACTIONS(715),
    [anon_sym_willreturn] = ACTIONS(715),
    [anon_sym_nosync] = ACTIONS(715),
    [anon_sym_nounwind] = ACTIONS(715),
    [anon_sym_nocallback] = ACTIONS(715),
    [anon_sym_nosanitize_coverage] = ACTIONS(715),
    [anon_sym_null_pointer_is_valid] = ACTIONS(715),
    [anon_sym_optforfuzzing] = ACTIONS(715),
    [anon_sym_optnone] = ACTIONS(715),
    [anon_sym_optsize] = ACTIONS(715),
    [anon_sym_readnone] = ACTIONS(715),
    [anon_sym_readonly] = ACTIONS(715),
    [anon_sym_writeonly] = ACTIONS(715),
    [anon_sym_argmemonly] = ACTIONS(715),
    [anon_sym_returns_twice] = ACTIONS(715),
    [anon_sym_safestack] = ACTIONS(715),
    [anon_sym_sanitize_address] = ACTIONS(715),
    [anon_sym_sanitize_memory] = ACTIONS(715),
    [anon_sym_sanitize_thread] = ACTIONS(715),
    [anon_sym_sanitize_hwaddress] = ACTIONS(715),
    [anon_sym_sanitize_memtag] = ACTIONS(715),
    [anon_sym_speculative_load_hardening] = ACTIONS(715),
    [anon_sym_speculatable] = ACTIONS(715),
    [anon_sym_ssp] = ACTIONS(715),
    [anon_sym_sspstrong] = ACTIONS(715),
    [anon_sym_sspreq] = ACTIONS(715),
    [anon_sym_strictfp] = ACTIONS(715),
    [anon_sym_nocf_check] = ACTIONS(715),
    [anon_sym_shadowcallstack] = ACTIONS(715),
    [anon_sym_mustprogress] = ACTIONS(715),
    [anon_sym_vscale_range] = ACTIONS(715),
    [anon_sym_preallocated] = ACTIONS(715),
    [anon_sym_zeroext] = ACTIONS(715),
    [anon_sym_signext] = ACTIONS(715),
    [anon_sym_inreg] = ACTIONS(715),
    [anon_sym_byval] = ACTIONS(715),
    [anon_sym_byref] = ACTIONS(715),
    [anon_sym_inalloca] = ACTIONS(715),
    [anon_sym_sret] = ACTIONS(715),
    [anon_sym_elementtype] = ACTIONS(715),
    [anon_sym_noalias] = ACTIONS(715),
    [anon_sym_nocapture] = ACTIONS(715),
    [anon_sym_nest] = ACTIONS(715),
    [anon_sym_returned] = ACTIONS(715),
    [anon_sym_nonnull] = ACTIONS(715),
    [anon_sym_dereferenceable] = ACTIONS(715),
    [anon_sym_dereferenceable_or_null] = ACTIONS(715),
    [anon_sym_swiftself] = ACTIONS(715),
    [anon_sym_swiftasync] = ACTIONS(715),
    [anon_sym_swifterror] = ACTIONS(715),
    [anon_sym_immarg] = ACTIONS(715),
    [anon_sym_noundef] = ACTIONS(715),
    [anon_sym_uwtable] = ACTIONS(715),
    [anon_sym_memory] = ACTIONS(715),
    [anon_sym_COLON] = ACTIONS(713),
    [aux_sym_specialized_md_value_token1] = ACTIONS(715),
  },
  [492] = {
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(847),
    [sym_string] = ACTIONS(847),
    [aux_sym_number_token1] = ACTIONS(849),
    [aux_sym_number_token2] = ACTIONS(849),
    [anon_sym_private] = ACTIONS(849),
    [anon_sym_internal] = ACTIONS(849),
    [anon_sym_weak] = ACTIONS(849),
    [anon_sym_weak_odr] = ACTIONS(849),
    [anon_sym_linkonce] = ACTIONS(849),
    [anon_sym_linkonce_odr] = ACTIONS(849),
    [anon_sym_available_externally] = ACTIONS(849),
    [anon_sym_appending] = ACTIONS(849),
    [anon_sym_common] = ACTIONS(849),
    [anon_sym_extern_weak] = ACTIONS(849),
    [anon_sym_external] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_RBRACK] = ACTIONS(847),
    [anon_sym_COMMA] = ACTIONS(847),
    [anon_sym_LPAREN] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(847),
    [anon_sym_align] = ACTIONS(849),
    [anon_sym_alignstack] = ACTIONS(849),
    [anon_sym_allocsize] = ACTIONS(849),
    [anon_sym_alwaysinline] = ACTIONS(849),
    [anon_sym_builtin] = ACTIONS(849),
    [anon_sym_cold] = ACTIONS(849),
    [anon_sym_convergent] = ACTIONS(849),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(849),
    [anon_sym_hot] = ACTIONS(849),
    [anon_sym_inaccessiblememonly] = ACTIONS(849),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(849),
    [anon_sym_inlinehint] = ACTIONS(849),
    [anon_sym_jumptable] = ACTIONS(849),
    [anon_sym_minsize] = ACTIONS(849),
    [anon_sym_naked] = ACTIONS(849),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(849),
    [anon_sym_nobuiltin] = ACTIONS(849),
    [anon_sym_noduplicate] = ACTIONS(849),
    [anon_sym_nofree] = ACTIONS(849),
    [anon_sym_noimplicitfloat] = ACTIONS(849),
    [anon_sym_noinline] = ACTIONS(849),
    [anon_sym_nomerge] = ACTIONS(849),
    [anon_sym_nonlazybind] = ACTIONS(849),
    [anon_sym_noprofile] = ACTIONS(849),
    [anon_sym_noredzone] = ACTIONS(849),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(849),
    [anon_sym_noreturn] = ACTIONS(849),
    [anon_sym_norecurse] = ACTIONS(849),
    [anon_sym_willreturn] = ACTIONS(849),
    [anon_sym_nosync] = ACTIONS(849),
    [anon_sym_nounwind] = ACTIONS(849),
    [anon_sym_nocallback] = ACTIONS(849),
    [anon_sym_nosanitize_coverage] = ACTIONS(849),
    [anon_sym_null_pointer_is_valid] = ACTIONS(849),
    [anon_sym_optforfuzzing] = ACTIONS(849),
    [anon_sym_optnone] = ACTIONS(849),
    [anon_sym_optsize] = ACTIONS(849),
    [anon_sym_readnone] = ACTIONS(849),
    [anon_sym_readonly] = ACTIONS(849),
    [anon_sym_writeonly] = ACTIONS(849),
    [anon_sym_argmemonly] = ACTIONS(849),
    [anon_sym_returns_twice] = ACTIONS(849),
    [anon_sym_safestack] = ACTIONS(849),
    [anon_sym_sanitize_address] = ACTIONS(849),
    [anon_sym_sanitize_memory] = ACTIONS(849),
    [anon_sym_sanitize_thread] = ACTIONS(849),
    [anon_sym_sanitize_hwaddress] = ACTIONS(849),
    [anon_sym_sanitize_memtag] = ACTIONS(849),
    [anon_sym_speculative_load_hardening] = ACTIONS(849),
    [anon_sym_speculatable] = ACTIONS(849),
    [anon_sym_ssp] = ACTIONS(849),
    [anon_sym_sspstrong] = ACTIONS(849),
    [anon_sym_sspreq] = ACTIONS(849),
    [anon_sym_strictfp] = ACTIONS(849),
    [anon_sym_nocf_check] = ACTIONS(849),
    [anon_sym_shadowcallstack] = ACTIONS(849),
    [anon_sym_mustprogress] = ACTIONS(849),
    [anon_sym_vscale_range] = ACTIONS(849),
    [anon_sym_preallocated] = ACTIONS(849),
    [anon_sym_zeroext] = ACTIONS(849),
    [anon_sym_signext] = ACTIONS(849),
    [anon_sym_inreg] = ACTIONS(849),
    [anon_sym_byval] = ACTIONS(849),
    [anon_sym_byref] = ACTIONS(849),
    [anon_sym_inalloca] = ACTIONS(849),
    [anon_sym_sret] = ACTIONS(849),
    [anon_sym_elementtype] = ACTIONS(849),
    [anon_sym_noalias] = ACTIONS(849),
    [anon_sym_nocapture] = ACTIONS(849),
    [anon_sym_nest] = ACTIONS(849),
    [anon_sym_returned] = ACTIONS(849),
    [anon_sym_nonnull] = ACTIONS(849),
    [anon_sym_dereferenceable] = ACTIONS(849),
    [anon_sym_dereferenceable_or_null] = ACTIONS(849),
    [anon_sym_swiftself] = ACTIONS(849),
    [anon_sym_swiftasync] = ACTIONS(849),
    [anon_sym_swifterror] = ACTIONS(849),
    [anon_sym_immarg] = ACTIONS(849),
    [anon_sym_noundef] = ACTIONS(849),
    [anon_sym_uwtable] = ACTIONS(849),
    [anon_sym_memory] = ACTIONS(849),
    [anon_sym_COLON] = ACTIONS(847),
    [aux_sym_specialized_md_value_token1] = ACTIONS(849),
  },
  [493] = {
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(812),
    [sym_string] = ACTIONS(812),
    [aux_sym_number_token1] = ACTIONS(814),
    [aux_sym_number_token2] = ACTIONS(814),
    [anon_sym_private] = ACTIONS(814),
    [anon_sym_internal] = ACTIONS(814),
    [anon_sym_weak] = ACTIONS(814),
    [anon_sym_weak_odr] = ACTIONS(814),
    [anon_sym_linkonce] = ACTIONS(814),
    [anon_sym_linkonce_odr] = ACTIONS(814),
    [anon_sym_available_externally] = ACTIONS(814),
    [anon_sym_appending] = ACTIONS(814),
    [anon_sym_common] = ACTIONS(814),
    [anon_sym_extern_weak] = ACTIONS(814),
    [anon_sym_external] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(812),
    [anon_sym_RBRACK] = ACTIONS(812),
    [anon_sym_COMMA] = ACTIONS(812),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_RPAREN] = ACTIONS(812),
    [anon_sym_align] = ACTIONS(814),
    [anon_sym_alignstack] = ACTIONS(814),
    [anon_sym_allocsize] = ACTIONS(814),
    [anon_sym_alwaysinline] = ACTIONS(814),
    [anon_sym_builtin] = ACTIONS(814),
    [anon_sym_cold] = ACTIONS(814),
    [anon_sym_convergent] = ACTIONS(814),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(814),
    [anon_sym_hot] = ACTIONS(814),
    [anon_sym_inaccessiblememonly] = ACTIONS(814),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(814),
    [anon_sym_inlinehint] = ACTIONS(814),
    [anon_sym_jumptable] = ACTIONS(814),
    [anon_sym_minsize] = ACTIONS(814),
    [anon_sym_naked] = ACTIONS(814),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(814),
    [anon_sym_nobuiltin] = ACTIONS(814),
    [anon_sym_noduplicate] = ACTIONS(814),
    [anon_sym_nofree] = ACTIONS(814),
    [anon_sym_noimplicitfloat] = ACTIONS(814),
    [anon_sym_noinline] = ACTIONS(814),
    [anon_sym_nomerge] = ACTIONS(814),
    [anon_sym_nonlazybind] = ACTIONS(814),
    [anon_sym_noprofile] = ACTIONS(814),
    [anon_sym_noredzone] = ACTIONS(814),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(814),
    [anon_sym_noreturn] = ACTIONS(814),
    [anon_sym_norecurse] = ACTIONS(814),
    [anon_sym_willreturn] = ACTIONS(814),
    [anon_sym_nosync] = ACTIONS(814),
    [anon_sym_nounwind] = ACTIONS(814),
    [anon_sym_nocallback] = ACTIONS(814),
    [anon_sym_nosanitize_coverage] = ACTIONS(814),
    [anon_sym_null_pointer_is_valid] = ACTIONS(814),
    [anon_sym_optforfuzzing] = ACTIONS(814),
    [anon_sym_optnone] = ACTIONS(814),
    [anon_sym_optsize] = ACTIONS(814),
    [anon_sym_readnone] = ACTIONS(814),
    [anon_sym_readonly] = ACTIONS(814),
    [anon_sym_writeonly] = ACTIONS(814),
    [anon_sym_argmemonly] = ACTIONS(814),
    [anon_sym_returns_twice] = ACTIONS(814),
    [anon_sym_safestack] = ACTIONS(814),
    [anon_sym_sanitize_address] = ACTIONS(814),
    [anon_sym_sanitize_memory] = ACTIONS(814),
    [anon_sym_sanitize_thread] = ACTIONS(814),
    [anon_sym_sanitize_hwaddress] = ACTIONS(814),
    [anon_sym_sanitize_memtag] = ACTIONS(814),
    [anon_sym_speculative_load_hardening] = ACTIONS(814),
    [anon_sym_speculatable] = ACTIONS(814),
    [anon_sym_ssp] = ACTIONS(814),
    [anon_sym_sspstrong] = ACTIONS(814),
    [anon_sym_sspreq] = ACTIONS(814),
    [anon_sym_strictfp] = ACTIONS(814),
    [anon_sym_nocf_check] = ACTIONS(814),
    [anon_sym_shadowcallstack] = ACTIONS(814),
    [anon_sym_mustprogress] = ACTIONS(814),
    [anon_sym_vscale_range] = ACTIONS(814),
    [anon_sym_preallocated] = ACTIONS(814),
    [anon_sym_zeroext] = ACTIONS(814),
    [anon_sym_signext] = ACTIONS(814),
    [anon_sym_inreg] = ACTIONS(814),
    [anon_sym_byval] = ACTIONS(814),
    [anon_sym_byref] = ACTIONS(814),
    [anon_sym_inalloca] = ACTIONS(814),
    [anon_sym_sret] = ACTIONS(814),
    [anon_sym_elementtype] = ACTIONS(814),
    [anon_sym_noalias] = ACTIONS(814),
    [anon_sym_nocapture] = ACTIONS(814),
    [anon_sym_nest] = ACTIONS(814),
    [anon_sym_returned] = ACTIONS(814),
    [anon_sym_nonnull] = ACTIONS(814),
    [anon_sym_dereferenceable] = ACTIONS(814),
    [anon_sym_dereferenceable_or_null] = ACTIONS(814),
    [anon_sym_swiftself] = ACTIONS(814),
    [anon_sym_swiftasync] = ACTIONS(814),
    [anon_sym_swifterror] = ACTIONS(814),
    [anon_sym_immarg] = ACTIONS(814),
    [anon_sym_noundef] = ACTIONS(814),
    [anon_sym_uwtable] = ACTIONS(814),
    [anon_sym_memory] = ACTIONS(814),
    [anon_sym_COLON] = ACTIONS(812),
    [aux_sym_specialized_md_value_token1] = ACTIONS(814),
  },
  [494] = {
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(835),
    [sym_string] = ACTIONS(835),
    [aux_sym_number_token1] = ACTIONS(837),
    [aux_sym_number_token2] = ACTIONS(837),
    [anon_sym_private] = ACTIONS(837),
    [anon_sym_internal] = ACTIONS(837),
    [anon_sym_weak] = ACTIONS(837),
    [anon_sym_weak_odr] = ACTIONS(837),
    [anon_sym_linkonce] = ACTIONS(837),
    [anon_sym_linkonce_odr] = ACTIONS(837),
    [anon_sym_available_externally] = ACTIONS(837),
    [anon_sym_appending] = ACTIONS(837),
    [anon_sym_common] = ACTIONS(837),
    [anon_sym_extern_weak] = ACTIONS(837),
    [anon_sym_external] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_RBRACK] = ACTIONS(835),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(835),
    [anon_sym_RPAREN] = ACTIONS(835),
    [anon_sym_align] = ACTIONS(837),
    [anon_sym_alignstack] = ACTIONS(837),
    [anon_sym_allocsize] = ACTIONS(837),
    [anon_sym_alwaysinline] = ACTIONS(837),
    [anon_sym_builtin] = ACTIONS(837),
    [anon_sym_cold] = ACTIONS(837),
    [anon_sym_convergent] = ACTIONS(837),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(837),
    [anon_sym_hot] = ACTIONS(837),
    [anon_sym_inaccessiblememonly] = ACTIONS(837),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(837),
    [anon_sym_inlinehint] = ACTIONS(837),
    [anon_sym_jumptable] = ACTIONS(837),
    [anon_sym_minsize] = ACTIONS(837),
    [anon_sym_naked] = ACTIONS(837),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(837),
    [anon_sym_nobuiltin] = ACTIONS(837),
    [anon_sym_noduplicate] = ACTIONS(837),
    [anon_sym_nofree] = ACTIONS(837),
    [anon_sym_noimplicitfloat] = ACTIONS(837),
    [anon_sym_noinline] = ACTIONS(837),
    [anon_sym_nomerge] = ACTIONS(837),
    [anon_sym_nonlazybind] = ACTIONS(837),
    [anon_sym_noprofile] = ACTIONS(837),
    [anon_sym_noredzone] = ACTIONS(837),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(837),
    [anon_sym_noreturn] = ACTIONS(837),
    [anon_sym_norecurse] = ACTIONS(837),
    [anon_sym_willreturn] = ACTIONS(837),
    [anon_sym_nosync] = ACTIONS(837),
    [anon_sym_nounwind] = ACTIONS(837),
    [anon_sym_nocallback] = ACTIONS(837),
    [anon_sym_nosanitize_coverage] = ACTIONS(837),
    [anon_sym_null_pointer_is_valid] = ACTIONS(837),
    [anon_sym_optforfuzzing] = ACTIONS(837),
    [anon_sym_optnone] = ACTIONS(837),
    [anon_sym_optsize] = ACTIONS(837),
    [anon_sym_readnone] = ACTIONS(837),
    [anon_sym_readonly] = ACTIONS(837),
    [anon_sym_writeonly] = ACTIONS(837),
    [anon_sym_argmemonly] = ACTIONS(837),
    [anon_sym_returns_twice] = ACTIONS(837),
    [anon_sym_safestack] = ACTIONS(837),
    [anon_sym_sanitize_address] = ACTIONS(837),
    [anon_sym_sanitize_memory] = ACTIONS(837),
    [anon_sym_sanitize_thread] = ACTIONS(837),
    [anon_sym_sanitize_hwaddress] = ACTIONS(837),
    [anon_sym_sanitize_memtag] = ACTIONS(837),
    [anon_sym_speculative_load_hardening] = ACTIONS(837),
    [anon_sym_speculatable] = ACTIONS(837),
    [anon_sym_ssp] = ACTIONS(837),
    [anon_sym_sspstrong] = ACTIONS(837),
    [anon_sym_sspreq] = ACTIONS(837),
    [anon_sym_strictfp] = ACTIONS(837),
    [anon_sym_nocf_check] = ACTIONS(837),
    [anon_sym_shadowcallstack] = ACTIONS(837),
    [anon_sym_mustprogress] = ACTIONS(837),
    [anon_sym_vscale_range] = ACTIONS(837),
    [anon_sym_preallocated] = ACTIONS(837),
    [anon_sym_zeroext] = ACTIONS(837),
    [anon_sym_signext] = ACTIONS(837),
    [anon_sym_inreg] = ACTIONS(837),
    [anon_sym_byval] = ACTIONS(837),
    [anon_sym_byref] = ACTIONS(837),
    [anon_sym_inalloca] = ACTIONS(837),
    [anon_sym_sret] = ACTIONS(837),
    [anon_sym_elementtype] = ACTIONS(837),
    [anon_sym_noalias] = ACTIONS(837),
    [anon_sym_nocapture] = ACTIONS(837),
    [anon_sym_nest] = ACTIONS(837),
    [anon_sym_returned] = ACTIONS(837),
    [anon_sym_nonnull] = ACTIONS(837),
    [anon_sym_dereferenceable] = ACTIONS(837),
    [anon_sym_dereferenceable_or_null] = ACTIONS(837),
    [anon_sym_swiftself] = ACTIONS(837),
    [anon_sym_swiftasync] = ACTIONS(837),
    [anon_sym_swifterror] = ACTIONS(837),
    [anon_sym_immarg] = ACTIONS(837),
    [anon_sym_noundef] = ACTIONS(837),
    [anon_sym_uwtable] = ACTIONS(837),
    [anon_sym_memory] = ACTIONS(837),
    [anon_sym_COLON] = ACTIONS(835),
    [aux_sym_specialized_md_value_token1] = ACTIONS(837),
  },
  [495] = {
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(967),
    [sym_string] = ACTIONS(967),
    [aux_sym_number_token1] = ACTIONS(969),
    [aux_sym_number_token2] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_internal] = ACTIONS(969),
    [anon_sym_weak] = ACTIONS(969),
    [anon_sym_weak_odr] = ACTIONS(969),
    [anon_sym_linkonce] = ACTIONS(969),
    [anon_sym_linkonce_odr] = ACTIONS(969),
    [anon_sym_available_externally] = ACTIONS(969),
    [anon_sym_appending] = ACTIONS(969),
    [anon_sym_common] = ACTIONS(969),
    [anon_sym_extern_weak] = ACTIONS(969),
    [anon_sym_external] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(967),
    [anon_sym_RBRACK] = ACTIONS(967),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(967),
    [anon_sym_RPAREN] = ACTIONS(967),
    [anon_sym_align] = ACTIONS(969),
    [anon_sym_alignstack] = ACTIONS(969),
    [anon_sym_allocsize] = ACTIONS(969),
    [anon_sym_alwaysinline] = ACTIONS(969),
    [anon_sym_builtin] = ACTIONS(969),
    [anon_sym_cold] = ACTIONS(969),
    [anon_sym_convergent] = ACTIONS(969),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(969),
    [anon_sym_hot] = ACTIONS(969),
    [anon_sym_inaccessiblememonly] = ACTIONS(969),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(969),
    [anon_sym_inlinehint] = ACTIONS(969),
    [anon_sym_jumptable] = ACTIONS(969),
    [anon_sym_minsize] = ACTIONS(969),
    [anon_sym_naked] = ACTIONS(969),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(969),
    [anon_sym_nobuiltin] = ACTIONS(969),
    [anon_sym_noduplicate] = ACTIONS(969),
    [anon_sym_nofree] = ACTIONS(969),
    [anon_sym_noimplicitfloat] = ACTIONS(969),
    [anon_sym_noinline] = ACTIONS(969),
    [anon_sym_nomerge] = ACTIONS(969),
    [anon_sym_nonlazybind] = ACTIONS(969),
    [anon_sym_noprofile] = ACTIONS(969),
    [anon_sym_noredzone] = ACTIONS(969),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(969),
    [anon_sym_noreturn] = ACTIONS(969),
    [anon_sym_norecurse] = ACTIONS(969),
    [anon_sym_willreturn] = ACTIONS(969),
    [anon_sym_nosync] = ACTIONS(969),
    [anon_sym_nounwind] = ACTIONS(969),
    [anon_sym_nocallback] = ACTIONS(969),
    [anon_sym_nosanitize_coverage] = ACTIONS(969),
    [anon_sym_null_pointer_is_valid] = ACTIONS(969),
    [anon_sym_optforfuzzing] = ACTIONS(969),
    [anon_sym_optnone] = ACTIONS(969),
    [anon_sym_optsize] = ACTIONS(969),
    [anon_sym_readnone] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_writeonly] = ACTIONS(969),
    [anon_sym_argmemonly] = ACTIONS(969),
    [anon_sym_returns_twice] = ACTIONS(969),
    [anon_sym_safestack] = ACTIONS(969),
    [anon_sym_sanitize_address] = ACTIONS(969),
    [anon_sym_sanitize_memory] = ACTIONS(969),
    [anon_sym_sanitize_thread] = ACTIONS(969),
    [anon_sym_sanitize_hwaddress] = ACTIONS(969),
    [anon_sym_sanitize_memtag] = ACTIONS(969),
    [anon_sym_speculative_load_hardening] = ACTIONS(969),
    [anon_sym_speculatable] = ACTIONS(969),
    [anon_sym_ssp] = ACTIONS(969),
    [anon_sym_sspstrong] = ACTIONS(969),
    [anon_sym_sspreq] = ACTIONS(969),
    [anon_sym_strictfp] = ACTIONS(969),
    [anon_sym_nocf_check] = ACTIONS(969),
    [anon_sym_shadowcallstack] = ACTIONS(969),
    [anon_sym_mustprogress] = ACTIONS(969),
    [anon_sym_vscale_range] = ACTIONS(969),
    [anon_sym_preallocated] = ACTIONS(969),
    [anon_sym_zeroext] = ACTIONS(969),
    [anon_sym_signext] = ACTIONS(969),
    [anon_sym_inreg] = ACTIONS(969),
    [anon_sym_byval] = ACTIONS(969),
    [anon_sym_byref] = ACTIONS(969),
    [anon_sym_inalloca] = ACTIONS(969),
    [anon_sym_sret] = ACTIONS(969),
    [anon_sym_elementtype] = ACTIONS(969),
    [anon_sym_noalias] = ACTIONS(969),
    [anon_sym_nocapture] = ACTIONS(969),
    [anon_sym_nest] = ACTIONS(969),
    [anon_sym_returned] = ACTIONS(969),
    [anon_sym_nonnull] = ACTIONS(969),
    [anon_sym_dereferenceable] = ACTIONS(969),
    [anon_sym_dereferenceable_or_null] = ACTIONS(969),
    [anon_sym_swiftself] = ACTIONS(969),
    [anon_sym_swiftasync] = ACTIONS(969),
    [anon_sym_swifterror] = ACTIONS(969),
    [anon_sym_immarg] = ACTIONS(969),
    [anon_sym_noundef] = ACTIONS(969),
    [anon_sym_uwtable] = ACTIONS(969),
    [anon_sym_memory] = ACTIONS(969),
    [anon_sym_COLON] = ACTIONS(967),
    [aux_sym_specialized_md_value_token1] = ACTIONS(969),
  },
  [496] = {
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(1718),
    [sym_string] = ACTIONS(1718),
    [aux_sym_number_token1] = ACTIONS(1720),
    [aux_sym_number_token2] = ACTIONS(1720),
    [anon_sym_private] = ACTIONS(1720),
    [anon_sym_internal] = ACTIONS(1720),
    [anon_sym_weak] = ACTIONS(1720),
    [anon_sym_weak_odr] = ACTIONS(1720),
    [anon_sym_linkonce] = ACTIONS(1720),
    [anon_sym_linkonce_odr] = ACTIONS(1720),
    [anon_sym_available_externally] = ACTIONS(1720),
    [anon_sym_appending] = ACTIONS(1720),
    [anon_sym_common] = ACTIONS(1720),
    [anon_sym_extern_weak] = ACTIONS(1720),
    [anon_sym_external] = ACTIONS(1720),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [anon_sym_RBRACK] = ACTIONS(1718),
    [anon_sym_COMMA] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(1718),
    [anon_sym_RPAREN] = ACTIONS(1718),
    [anon_sym_align] = ACTIONS(1720),
    [anon_sym_alignstack] = ACTIONS(1720),
    [anon_sym_allocsize] = ACTIONS(1720),
    [anon_sym_alwaysinline] = ACTIONS(1720),
    [anon_sym_builtin] = ACTIONS(1720),
    [anon_sym_cold] = ACTIONS(1720),
    [anon_sym_convergent] = ACTIONS(1720),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1720),
    [anon_sym_hot] = ACTIONS(1720),
    [anon_sym_inaccessiblememonly] = ACTIONS(1720),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1720),
    [anon_sym_inlinehint] = ACTIONS(1720),
    [anon_sym_jumptable] = ACTIONS(1720),
    [anon_sym_minsize] = ACTIONS(1720),
    [anon_sym_naked] = ACTIONS(1720),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1720),
    [anon_sym_nobuiltin] = ACTIONS(1720),
    [anon_sym_noduplicate] = ACTIONS(1720),
    [anon_sym_nofree] = ACTIONS(1720),
    [anon_sym_noimplicitfloat] = ACTIONS(1720),
    [anon_sym_noinline] = ACTIONS(1720),
    [anon_sym_nomerge] = ACTIONS(1720),
    [anon_sym_nonlazybind] = ACTIONS(1720),
    [anon_sym_noprofile] = ACTIONS(1720),
    [anon_sym_noredzone] = ACTIONS(1720),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1720),
    [anon_sym_noreturn] = ACTIONS(1720),
    [anon_sym_norecurse] = ACTIONS(1720),
    [anon_sym_willreturn] = ACTIONS(1720),
    [anon_sym_nosync] = ACTIONS(1720),
    [anon_sym_nounwind] = ACTIONS(1720),
    [anon_sym_nocallback] = ACTIONS(1720),
    [anon_sym_nosanitize_coverage] = ACTIONS(1720),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1720),
    [anon_sym_optforfuzzing] = ACTIONS(1720),
    [anon_sym_optnone] = ACTIONS(1720),
    [anon_sym_optsize] = ACTIONS(1720),
    [anon_sym_readnone] = ACTIONS(1720),
    [anon_sym_readonly] = ACTIONS(1720),
    [anon_sym_writeonly] = ACTIONS(1720),
    [anon_sym_argmemonly] = ACTIONS(1720),
    [anon_sym_returns_twice] = ACTIONS(1720),
    [anon_sym_safestack] = ACTIONS(1720),
    [anon_sym_sanitize_address] = ACTIONS(1720),
    [anon_sym_sanitize_memory] = ACTIONS(1720),
    [anon_sym_sanitize_thread] = ACTIONS(1720),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1720),
    [anon_sym_sanitize_memtag] = ACTIONS(1720),
    [anon_sym_speculative_load_hardening] = ACTIONS(1720),
    [anon_sym_speculatable] = ACTIONS(1720),
    [anon_sym_ssp] = ACTIONS(1720),
    [anon_sym_sspstrong] = ACTIONS(1720),
    [anon_sym_sspreq] = ACTIONS(1720),
    [anon_sym_strictfp] = ACTIONS(1720),
    [anon_sym_nocf_check] = ACTIONS(1720),
    [anon_sym_shadowcallstack] = ACTIONS(1720),
    [anon_sym_mustprogress] = ACTIONS(1720),
    [anon_sym_vscale_range] = ACTIONS(1720),
    [anon_sym_preallocated] = ACTIONS(1720),
    [anon_sym_zeroext] = ACTIONS(1720),
    [anon_sym_signext] = ACTIONS(1720),
    [anon_sym_inreg] = ACTIONS(1720),
    [anon_sym_byval] = ACTIONS(1720),
    [anon_sym_byref] = ACTIONS(1720),
    [anon_sym_inalloca] = ACTIONS(1720),
    [anon_sym_sret] = ACTIONS(1720),
    [anon_sym_elementtype] = ACTIONS(1720),
    [anon_sym_noalias] = ACTIONS(1720),
    [anon_sym_nocapture] = ACTIONS(1720),
    [anon_sym_nest] = ACTIONS(1720),
    [anon_sym_returned] = ACTIONS(1720),
    [anon_sym_nonnull] = ACTIONS(1720),
    [anon_sym_dereferenceable] = ACTIONS(1720),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1720),
    [anon_sym_swiftself] = ACTIONS(1720),
    [anon_sym_swiftasync] = ACTIONS(1720),
    [anon_sym_swifterror] = ACTIONS(1720),
    [anon_sym_immarg] = ACTIONS(1720),
    [anon_sym_noundef] = ACTIONS(1720),
    [anon_sym_uwtable] = ACTIONS(1720),
    [anon_sym_memory] = ACTIONS(1720),
    [anon_sym_COLON] = ACTIONS(1718),
    [aux_sym_specialized_md_value_token1] = ACTIONS(1720),
  },
  [497] = {
    [sym_comment] = ACTIONS(3),
    [sym_summary_ref] = ACTIONS(1722),
    [sym_string] = ACTIONS(1722),
    [aux_sym_number_token1] = ACTIONS(1724),
    [aux_sym_number_token2] = ACTIONS(1724),
    [anon_sym_private] = ACTIONS(1724),
    [anon_sym_internal] = ACTIONS(1724),
    [anon_sym_weak] = ACTIONS(1724),
    [anon_sym_weak_odr] = ACTIONS(1724),
    [anon_sym_linkonce] = ACTIONS(1724),
    [anon_sym_linkonce_odr] = ACTIONS(1724),
    [anon_sym_available_externally] = ACTIONS(1724),
    [anon_sym_appending] = ACTIONS(1724),
    [anon_sym_common] = ACTIONS(1724),
    [anon_sym_extern_weak] = ACTIONS(1724),
    [anon_sym_external] = ACTIONS(1724),
    [anon_sym_LBRACK] = ACTIONS(1722),
    [anon_sym_RBRACK] = ACTIONS(1722),
    [anon_sym_COMMA] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(1722),
    [anon_sym_RPAREN] = ACTIONS(1722),
    [anon_sym_align] = ACTIONS(1724),
    [anon_sym_alignstack] = ACTIONS(1724),
    [anon_sym_allocsize] = ACTIONS(1724),
    [anon_sym_alwaysinline] = ACTIONS(1724),
    [anon_sym_builtin] = ACTIONS(1724),
    [anon_sym_cold] = ACTIONS(1724),
    [anon_sym_convergent] = ACTIONS(1724),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1724),
    [anon_sym_hot] = ACTIONS(1724),
    [anon_sym_inaccessiblememonly] = ACTIONS(1724),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1724),
    [anon_sym_inlinehint] = ACTIONS(1724),
    [anon_sym_jumptable] = ACTIONS(1724),
    [anon_sym_minsize] = ACTIONS(1724),
    [anon_sym_naked] = ACTIONS(1724),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1724),
    [anon_sym_nobuiltin] = ACTIONS(1724),
    [anon_sym_noduplicate] = ACTIONS(1724),
    [anon_sym_nofree] = ACTIONS(1724),
    [anon_sym_noimplicitfloat] = ACTIONS(1724),
    [anon_sym_noinline] = ACTIONS(1724),
    [anon_sym_nomerge] = ACTIONS(1724),
    [anon_sym_nonlazybind] = ACTIONS(1724),
    [anon_sym_noprofile] = ACTIONS(1724),
    [anon_sym_noredzone] = ACTIONS(1724),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1724),
    [anon_sym_noreturn] = ACTIONS(1724),
    [anon_sym_norecurse] = ACTIONS(1724),
    [anon_sym_willreturn] = ACTIONS(1724),
    [anon_sym_nosync] = ACTIONS(1724),
    [anon_sym_nounwind] = ACTIONS(1724),
    [anon_sym_nocallback] = ACTIONS(1724),
    [anon_sym_nosanitize_coverage] = ACTIONS(1724),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1724),
    [anon_sym_optforfuzzing] = ACTIONS(1724),
    [anon_sym_optnone] = ACTIONS(1724),
    [anon_sym_optsize] = ACTIONS(1724),
    [anon_sym_readnone] = ACTIONS(1724),
    [anon_sym_readonly] = ACTIONS(1724),
    [anon_sym_writeonly] = ACTIONS(1724),
    [anon_sym_argmemonly] = ACTIONS(1724),
    [anon_sym_returns_twice] = ACTIONS(1724),
    [anon_sym_safestack] = ACTIONS(1724),
    [anon_sym_sanitize_address] = ACTIONS(1724),
    [anon_sym_sanitize_memory] = ACTIONS(1724),
    [anon_sym_sanitize_thread] = ACTIONS(1724),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1724),
    [anon_sym_sanitize_memtag] = ACTIONS(1724),
    [anon_sym_speculative_load_hardening] = ACTIONS(1724),
    [anon_sym_speculatable] = ACTIONS(1724),
    [anon_sym_ssp] = ACTIONS(1724),
    [anon_sym_sspstrong] = ACTIONS(1724),
    [anon_sym_sspreq] = ACTIONS(1724),
    [anon_sym_strictfp] = ACTIONS(1724),
    [anon_sym_nocf_check] = ACTIONS(1724),
    [anon_sym_shadowcallstack] = ACTIONS(1724),
    [anon_sym_mustprogress] = ACTIONS(1724),
    [anon_sym_vscale_range] = ACTIONS(1724),
    [anon_sym_preallocated] = ACTIONS(1724),
    [anon_sym_zeroext] = ACTIONS(1724),
    [anon_sym_signext] = ACTIONS(1724),
    [anon_sym_inreg] = ACTIONS(1724),
    [anon_sym_byval] = ACTIONS(1724),
    [anon_sym_byref] = ACTIONS(1724),
    [anon_sym_inalloca] = ACTIONS(1724),
    [anon_sym_sret] = ACTIONS(1724),
    [anon_sym_elementtype] = ACTIONS(1724),
    [anon_sym_noalias] = ACTIONS(1724),
    [anon_sym_nocapture] = ACTIONS(1724),
    [anon_sym_nest] = ACTIONS(1724),
    [anon_sym_returned] = ACTIONS(1724),
    [anon_sym_nonnull] = ACTIONS(1724),
    [anon_sym_dereferenceable] = ACTIONS(1724),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1724),
    [anon_sym_swiftself] = ACTIONS(1724),
    [anon_sym_swiftasync] = ACTIONS(1724),
    [anon_sym_swifterror] = ACTIONS(1724),
    [anon_sym_immarg] = ACTIONS(1724),
    [anon_sym_noundef] = ACTIONS(1724),
    [anon_sym_uwtable] = ACTIONS(1724),
    [anon_sym_memory] = ACTIONS(1724),
    [anon_sym_COLON] = ACTIONS(1722),
    [aux_sym_specialized_md_value_token1] = ACTIONS(1724),
  },
  [498] = {
    [sym_addrspace] = STATE(526),
    [sym_attribute] = STATE(524),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(524),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1517),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [499] = {
    [sym_addrspace] = STATE(525),
    [sym_attribute] = STATE(517),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(517),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1525),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1525),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [500] = {
    [sym_addrspace] = STATE(529),
    [sym_attribute] = STATE(528),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(528),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1533),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1533),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [501] = {
    [sym_addrspace] = STATE(537),
    [sym_attribute] = STATE(512),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(512),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1529),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [502] = {
    [sym_addrspace] = STATE(515),
    [sym_attribute] = STATE(514),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(514),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1521),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_addrspace] = ACTIONS(961),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [503] = {
    [sym_attribute] = STATE(513),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_operand_bundles] = STATE(1841),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(513),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACK] = ACTIONS(1726),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1728),
    [anon_sym_prologue] = ACTIONS(1728),
    [anon_sym_personality] = ACTIONS(1728),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_to] = ACTIONS(777),
  },
  [504] = {
    [sym_attribute] = STATE(513),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_operand_bundles] = STATE(1762),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(513),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACK] = ACTIONS(1726),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1728),
    [anon_sym_prologue] = ACTIONS(1728),
    [anon_sym_personality] = ACTIONS(1728),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_to] = ACTIONS(765),
  },
  [505] = {
    [sym_attribute] = STATE(513),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_operand_bundles] = STATE(1890),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(513),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACK] = ACTIONS(1726),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1728),
    [anon_sym_prologue] = ACTIONS(1728),
    [anon_sym_personality] = ACTIONS(1728),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_to] = ACTIONS(761),
  },
  [506] = {
    [sym_attribute] = STATE(503),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_operand_bundles] = STATE(1886),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(503),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACK] = ACTIONS(1726),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1728),
    [anon_sym_prologue] = ACTIONS(1728),
    [anon_sym_personality] = ACTIONS(1728),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_to] = ACTIONS(757),
  },
  [507] = {
    [sym_attribute] = STATE(513),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_operand_bundles] = STATE(1953),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(513),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACK] = ACTIONS(1726),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1728),
    [anon_sym_prologue] = ACTIONS(1728),
    [anon_sym_personality] = ACTIONS(1728),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_to] = ACTIONS(753),
  },
  [508] = {
    [sym_attribute] = STATE(507),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_operand_bundles] = STATE(1909),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(507),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACK] = ACTIONS(1726),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1728),
    [anon_sym_prologue] = ACTIONS(1728),
    [anon_sym_personality] = ACTIONS(1728),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_to] = ACTIONS(769),
  },
  [509] = {
    [sym_attribute] = STATE(504),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_operand_bundles] = STATE(1838),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(504),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACK] = ACTIONS(1726),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1728),
    [anon_sym_prologue] = ACTIONS(1728),
    [anon_sym_personality] = ACTIONS(1728),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_to] = ACTIONS(773),
  },
  [510] = {
    [sym_attribute] = STATE(505),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_operand_bundles] = STATE(1974),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(505),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACK] = ACTIONS(1726),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1728),
    [anon_sym_prologue] = ACTIONS(1728),
    [anon_sym_personality] = ACTIONS(1728),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
    [anon_sym_to] = ACTIONS(731),
  },
  [511] = {
    [sym_attribute] = STATE(528),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(528),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1533),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1533),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [512] = {
    [sym_attribute] = STATE(533),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(533),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1653),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1653),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [513] = {
    [sym_attribute] = STATE(513),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(513),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1589),
    [sym_string] = ACTIONS(1589),
    [anon_sym_LBRACK] = ACTIONS(784),
    [anon_sym_align] = ACTIONS(1592),
    [anon_sym_section] = ACTIONS(1595),
    [anon_sym_partition] = ACTIONS(1595),
    [anon_sym_comdat] = ACTIONS(1598),
    [anon_sym_gc] = ACTIONS(1595),
    [anon_sym_prefix] = ACTIONS(1730),
    [anon_sym_prologue] = ACTIONS(1730),
    [anon_sym_personality] = ACTIONS(1730),
    [anon_sym_alignstack] = ACTIONS(1604),
    [anon_sym_allocsize] = ACTIONS(1604),
    [anon_sym_alwaysinline] = ACTIONS(1604),
    [anon_sym_builtin] = ACTIONS(1604),
    [anon_sym_cold] = ACTIONS(1604),
    [anon_sym_convergent] = ACTIONS(1604),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1604),
    [anon_sym_hot] = ACTIONS(1604),
    [anon_sym_inaccessiblememonly] = ACTIONS(1604),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1604),
    [anon_sym_inlinehint] = ACTIONS(1604),
    [anon_sym_jumptable] = ACTIONS(1604),
    [anon_sym_minsize] = ACTIONS(1604),
    [anon_sym_naked] = ACTIONS(1604),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1604),
    [anon_sym_nobuiltin] = ACTIONS(1604),
    [anon_sym_noduplicate] = ACTIONS(1604),
    [anon_sym_nofree] = ACTIONS(1604),
    [anon_sym_noimplicitfloat] = ACTIONS(1604),
    [anon_sym_noinline] = ACTIONS(1604),
    [anon_sym_nomerge] = ACTIONS(1604),
    [anon_sym_nonlazybind] = ACTIONS(1604),
    [anon_sym_noprofile] = ACTIONS(1604),
    [anon_sym_noredzone] = ACTIONS(1604),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1604),
    [anon_sym_noreturn] = ACTIONS(1604),
    [anon_sym_norecurse] = ACTIONS(1604),
    [anon_sym_willreturn] = ACTIONS(1604),
    [anon_sym_nosync] = ACTIONS(1604),
    [anon_sym_nounwind] = ACTIONS(1604),
    [anon_sym_nocallback] = ACTIONS(1604),
    [anon_sym_nosanitize_coverage] = ACTIONS(1604),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1604),
    [anon_sym_optforfuzzing] = ACTIONS(1604),
    [anon_sym_optnone] = ACTIONS(1604),
    [anon_sym_optsize] = ACTIONS(1604),
    [anon_sym_readnone] = ACTIONS(1604),
    [anon_sym_readonly] = ACTIONS(1604),
    [anon_sym_writeonly] = ACTIONS(1604),
    [anon_sym_argmemonly] = ACTIONS(1604),
    [anon_sym_returns_twice] = ACTIONS(1604),
    [anon_sym_safestack] = ACTIONS(1604),
    [anon_sym_sanitize_address] = ACTIONS(1604),
    [anon_sym_sanitize_memory] = ACTIONS(1604),
    [anon_sym_sanitize_thread] = ACTIONS(1604),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1604),
    [anon_sym_sanitize_memtag] = ACTIONS(1604),
    [anon_sym_speculative_load_hardening] = ACTIONS(1604),
    [anon_sym_speculatable] = ACTIONS(1604),
    [anon_sym_ssp] = ACTIONS(1607),
    [anon_sym_sspstrong] = ACTIONS(1604),
    [anon_sym_sspreq] = ACTIONS(1604),
    [anon_sym_strictfp] = ACTIONS(1604),
    [anon_sym_nocf_check] = ACTIONS(1604),
    [anon_sym_shadowcallstack] = ACTIONS(1604),
    [anon_sym_mustprogress] = ACTIONS(1604),
    [anon_sym_vscale_range] = ACTIONS(1604),
    [anon_sym_preallocated] = ACTIONS(1604),
    [anon_sym_zeroext] = ACTIONS(1604),
    [anon_sym_signext] = ACTIONS(1604),
    [anon_sym_inreg] = ACTIONS(1604),
    [anon_sym_byval] = ACTIONS(1604),
    [anon_sym_byref] = ACTIONS(1604),
    [anon_sym_inalloca] = ACTIONS(1604),
    [anon_sym_sret] = ACTIONS(1604),
    [anon_sym_elementtype] = ACTIONS(1604),
    [anon_sym_noalias] = ACTIONS(1604),
    [anon_sym_nocapture] = ACTIONS(1604),
    [anon_sym_nest] = ACTIONS(1604),
    [anon_sym_returned] = ACTIONS(1604),
    [anon_sym_nonnull] = ACTIONS(1604),
    [anon_sym_dereferenceable] = ACTIONS(1607),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1604),
    [anon_sym_swiftself] = ACTIONS(1604),
    [anon_sym_swiftasync] = ACTIONS(1604),
    [anon_sym_swifterror] = ACTIONS(1604),
    [anon_sym_immarg] = ACTIONS(1604),
    [anon_sym_noundef] = ACTIONS(1604),
    [anon_sym_uwtable] = ACTIONS(1610),
    [anon_sym_memory] = ACTIONS(1613),
    [anon_sym_to] = ACTIONS(784),
  },
  [514] = {
    [sym_attribute] = STATE(533),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(533),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1649),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1649),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [515] = {
    [sym_attribute] = STATE(536),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(536),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1649),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1649),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [516] = {
    [sym_attribute] = STATE(533),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(533),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1585),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [517] = {
    [sym_attribute] = STATE(533),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(533),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1577),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1577),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [518] = {
    [sym_attribute] = STATE(533),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(533),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1525),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1525),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [519] = {
    [sym_attribute] = STATE(533),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(533),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1533),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1533),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [520] = {
    [sym_attribute] = STATE(533),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(533),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1521),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [521] = {
    [sym_attribute] = STATE(514),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(514),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1521),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [522] = {
    [sym_attribute] = STATE(517),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(517),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1525),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1525),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [523] = {
    [sym_attribute] = STATE(533),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(533),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1667),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1667),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [524] = {
    [sym_attribute] = STATE(533),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(533),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1659),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [525] = {
    [sym_attribute] = STATE(530),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(530),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1577),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1577),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [526] = {
    [sym_attribute] = STATE(516),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(516),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1659),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [527] = {
    [sym_attribute] = STATE(533),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(533),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1671),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [528] = {
    [sym_attribute] = STATE(533),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(533),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1616),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1616),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [529] = {
    [sym_attribute] = STATE(527),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(527),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1616),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1616),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [530] = {
    [sym_attribute] = STATE(533),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(533),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1663),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [531] = {
    [sym_attribute] = STATE(533),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(533),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1529),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [532] = {
    [sym_attribute] = STATE(512),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(512),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1529),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [533] = {
    [sym_attribute] = STATE(533),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(533),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1589),
    [aux_sym_metadata_ref_token1] = ACTIONS(784),
    [sym_string] = ACTIONS(1589),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_align] = ACTIONS(1592),
    [anon_sym_section] = ACTIONS(1595),
    [anon_sym_partition] = ACTIONS(1595),
    [anon_sym_comdat] = ACTIONS(1598),
    [anon_sym_gc] = ACTIONS(1595),
    [anon_sym_prefix] = ACTIONS(1733),
    [anon_sym_prologue] = ACTIONS(1733),
    [anon_sym_personality] = ACTIONS(1733),
    [anon_sym_alignstack] = ACTIONS(1604),
    [anon_sym_allocsize] = ACTIONS(1604),
    [anon_sym_alwaysinline] = ACTIONS(1604),
    [anon_sym_builtin] = ACTIONS(1604),
    [anon_sym_cold] = ACTIONS(1604),
    [anon_sym_convergent] = ACTIONS(1604),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1604),
    [anon_sym_hot] = ACTIONS(1604),
    [anon_sym_inaccessiblememonly] = ACTIONS(1604),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1604),
    [anon_sym_inlinehint] = ACTIONS(1604),
    [anon_sym_jumptable] = ACTIONS(1604),
    [anon_sym_minsize] = ACTIONS(1604),
    [anon_sym_naked] = ACTIONS(1604),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1604),
    [anon_sym_nobuiltin] = ACTIONS(1604),
    [anon_sym_noduplicate] = ACTIONS(1604),
    [anon_sym_nofree] = ACTIONS(1604),
    [anon_sym_noimplicitfloat] = ACTIONS(1604),
    [anon_sym_noinline] = ACTIONS(1604),
    [anon_sym_nomerge] = ACTIONS(1604),
    [anon_sym_nonlazybind] = ACTIONS(1604),
    [anon_sym_noprofile] = ACTIONS(1604),
    [anon_sym_noredzone] = ACTIONS(1604),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1604),
    [anon_sym_noreturn] = ACTIONS(1604),
    [anon_sym_norecurse] = ACTIONS(1604),
    [anon_sym_willreturn] = ACTIONS(1604),
    [anon_sym_nosync] = ACTIONS(1604),
    [anon_sym_nounwind] = ACTIONS(1604),
    [anon_sym_nocallback] = ACTIONS(1604),
    [anon_sym_nosanitize_coverage] = ACTIONS(1604),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1604),
    [anon_sym_optforfuzzing] = ACTIONS(1604),
    [anon_sym_optnone] = ACTIONS(1604),
    [anon_sym_optsize] = ACTIONS(1604),
    [anon_sym_readnone] = ACTIONS(1604),
    [anon_sym_readonly] = ACTIONS(1604),
    [anon_sym_writeonly] = ACTIONS(1604),
    [anon_sym_argmemonly] = ACTIONS(1604),
    [anon_sym_returns_twice] = ACTIONS(1604),
    [anon_sym_safestack] = ACTIONS(1604),
    [anon_sym_sanitize_address] = ACTIONS(1604),
    [anon_sym_sanitize_memory] = ACTIONS(1604),
    [anon_sym_sanitize_thread] = ACTIONS(1604),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1604),
    [anon_sym_sanitize_memtag] = ACTIONS(1604),
    [anon_sym_speculative_load_hardening] = ACTIONS(1604),
    [anon_sym_speculatable] = ACTIONS(1604),
    [anon_sym_ssp] = ACTIONS(1607),
    [anon_sym_sspstrong] = ACTIONS(1604),
    [anon_sym_sspreq] = ACTIONS(1604),
    [anon_sym_strictfp] = ACTIONS(1604),
    [anon_sym_nocf_check] = ACTIONS(1604),
    [anon_sym_shadowcallstack] = ACTIONS(1604),
    [anon_sym_mustprogress] = ACTIONS(1604),
    [anon_sym_vscale_range] = ACTIONS(1604),
    [anon_sym_preallocated] = ACTIONS(1604),
    [anon_sym_zeroext] = ACTIONS(1604),
    [anon_sym_signext] = ACTIONS(1604),
    [anon_sym_inreg] = ACTIONS(1604),
    [anon_sym_byval] = ACTIONS(1604),
    [anon_sym_byref] = ACTIONS(1604),
    [anon_sym_inalloca] = ACTIONS(1604),
    [anon_sym_sret] = ACTIONS(1604),
    [anon_sym_elementtype] = ACTIONS(1604),
    [anon_sym_noalias] = ACTIONS(1604),
    [anon_sym_nocapture] = ACTIONS(1604),
    [anon_sym_nest] = ACTIONS(1604),
    [anon_sym_returned] = ACTIONS(1604),
    [anon_sym_nonnull] = ACTIONS(1604),
    [anon_sym_dereferenceable] = ACTIONS(1607),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1604),
    [anon_sym_swiftself] = ACTIONS(1604),
    [anon_sym_swiftasync] = ACTIONS(1604),
    [anon_sym_swifterror] = ACTIONS(1604),
    [anon_sym_immarg] = ACTIONS(1604),
    [anon_sym_noundef] = ACTIONS(1604),
    [anon_sym_uwtable] = ACTIONS(1610),
    [anon_sym_memory] = ACTIONS(1613),
  },
  [534] = {
    [sym_attribute] = STATE(524),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(524),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1517),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [535] = {
    [sym_attribute] = STATE(533),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(533),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1517),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [536] = {
    [sym_attribute] = STATE(533),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(533),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1581),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1581),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [537] = {
    [sym_attribute] = STATE(523),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(523),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(1653),
    [sym_string] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1653),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1709),
    [anon_sym_prologue] = ACTIONS(1709),
    [anon_sym_personality] = ACTIONS(1709),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [538] = {
    [sym_attribute] = STATE(538),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(538),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1589),
    [sym_string] = ACTIONS(1589),
    [anon_sym_RBRACE] = ACTIONS(784),
    [anon_sym_align] = ACTIONS(1592),
    [anon_sym_section] = ACTIONS(1595),
    [anon_sym_partition] = ACTIONS(1595),
    [anon_sym_comdat] = ACTIONS(1598),
    [anon_sym_gc] = ACTIONS(1595),
    [anon_sym_prefix] = ACTIONS(1736),
    [anon_sym_prologue] = ACTIONS(1736),
    [anon_sym_personality] = ACTIONS(1736),
    [anon_sym_alignstack] = ACTIONS(1604),
    [anon_sym_allocsize] = ACTIONS(1604),
    [anon_sym_alwaysinline] = ACTIONS(1604),
    [anon_sym_builtin] = ACTIONS(1604),
    [anon_sym_cold] = ACTIONS(1604),
    [anon_sym_convergent] = ACTIONS(1604),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(1604),
    [anon_sym_hot] = ACTIONS(1604),
    [anon_sym_inaccessiblememonly] = ACTIONS(1604),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(1604),
    [anon_sym_inlinehint] = ACTIONS(1604),
    [anon_sym_jumptable] = ACTIONS(1604),
    [anon_sym_minsize] = ACTIONS(1604),
    [anon_sym_naked] = ACTIONS(1604),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(1604),
    [anon_sym_nobuiltin] = ACTIONS(1604),
    [anon_sym_noduplicate] = ACTIONS(1604),
    [anon_sym_nofree] = ACTIONS(1604),
    [anon_sym_noimplicitfloat] = ACTIONS(1604),
    [anon_sym_noinline] = ACTIONS(1604),
    [anon_sym_nomerge] = ACTIONS(1604),
    [anon_sym_nonlazybind] = ACTIONS(1604),
    [anon_sym_noprofile] = ACTIONS(1604),
    [anon_sym_noredzone] = ACTIONS(1604),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(1604),
    [anon_sym_noreturn] = ACTIONS(1604),
    [anon_sym_norecurse] = ACTIONS(1604),
    [anon_sym_willreturn] = ACTIONS(1604),
    [anon_sym_nosync] = ACTIONS(1604),
    [anon_sym_nounwind] = ACTIONS(1604),
    [anon_sym_nocallback] = ACTIONS(1604),
    [anon_sym_nosanitize_coverage] = ACTIONS(1604),
    [anon_sym_null_pointer_is_valid] = ACTIONS(1604),
    [anon_sym_optforfuzzing] = ACTIONS(1604),
    [anon_sym_optnone] = ACTIONS(1604),
    [anon_sym_optsize] = ACTIONS(1604),
    [anon_sym_readnone] = ACTIONS(1604),
    [anon_sym_readonly] = ACTIONS(1604),
    [anon_sym_writeonly] = ACTIONS(1604),
    [anon_sym_argmemonly] = ACTIONS(1604),
    [anon_sym_returns_twice] = ACTIONS(1604),
    [anon_sym_safestack] = ACTIONS(1604),
    [anon_sym_sanitize_address] = ACTIONS(1604),
    [anon_sym_sanitize_memory] = ACTIONS(1604),
    [anon_sym_sanitize_thread] = ACTIONS(1604),
    [anon_sym_sanitize_hwaddress] = ACTIONS(1604),
    [anon_sym_sanitize_memtag] = ACTIONS(1604),
    [anon_sym_speculative_load_hardening] = ACTIONS(1604),
    [anon_sym_speculatable] = ACTIONS(1604),
    [anon_sym_ssp] = ACTIONS(1607),
    [anon_sym_sspstrong] = ACTIONS(1604),
    [anon_sym_sspreq] = ACTIONS(1604),
    [anon_sym_strictfp] = ACTIONS(1604),
    [anon_sym_nocf_check] = ACTIONS(1604),
    [anon_sym_shadowcallstack] = ACTIONS(1604),
    [anon_sym_mustprogress] = ACTIONS(1604),
    [anon_sym_vscale_range] = ACTIONS(1604),
    [anon_sym_preallocated] = ACTIONS(1604),
    [anon_sym_zeroext] = ACTIONS(1604),
    [anon_sym_signext] = ACTIONS(1604),
    [anon_sym_inreg] = ACTIONS(1604),
    [anon_sym_byval] = ACTIONS(1604),
    [anon_sym_byref] = ACTIONS(1604),
    [anon_sym_inalloca] = ACTIONS(1604),
    [anon_sym_sret] = ACTIONS(1604),
    [anon_sym_elementtype] = ACTIONS(1604),
    [anon_sym_noalias] = ACTIONS(1604),
    [anon_sym_nocapture] = ACTIONS(1604),
    [anon_sym_nest] = ACTIONS(1604),
    [anon_sym_returned] = ACTIONS(1604),
    [anon_sym_nonnull] = ACTIONS(1604),
    [anon_sym_dereferenceable] = ACTIONS(1607),
    [anon_sym_dereferenceable_or_null] = ACTIONS(1604),
    [anon_sym_swiftself] = ACTIONS(1604),
    [anon_sym_swiftasync] = ACTIONS(1604),
    [anon_sym_swifterror] = ACTIONS(1604),
    [anon_sym_immarg] = ACTIONS(1604),
    [anon_sym_noundef] = ACTIONS(1604),
    [anon_sym_uwtable] = ACTIONS(1610),
    [anon_sym_memory] = ACTIONS(1613),
  },
  [539] = {
    [sym_attribute] = STATE(541),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(541),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_string] = ACTIONS(1372),
    [anon_sym_RBRACE] = ACTIONS(1739),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1741),
    [anon_sym_prologue] = ACTIONS(1741),
    [anon_sym_personality] = ACTIONS(1741),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [540] = {
    [sym_metadata_name] = STATE(750),
    [sym_attribute] = STATE(480),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [aux_sym_metadata_ref_token1] = ACTIONS(719),
    [sym_string] = ACTIONS(1372),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [541] = {
    [sym_attribute] = STATE(538),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [aux_sym_function_header_repeat3] = STATE(538),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_string] = ACTIONS(1372),
    [anon_sym_RBRACE] = ACTIONS(1743),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1741),
    [anon_sym_prologue] = ACTIONS(1741),
    [anon_sym_personality] = ACTIONS(1741),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [542] = {
    [sym_attribute] = STATE(480),
    [sym_attribute_name] = STATE(434),
    [sym_uwtable] = STATE(274),
    [sym_memory_attribute] = STATE(274),
    [sym_alignment] = STATE(474),
    [sym_comment] = ACTIONS(3),
    [sym_attr_ref] = ACTIONS(1372),
    [sym_string] = ACTIONS(1372),
    [anon_sym_align] = ACTIONS(1374),
    [anon_sym_section] = ACTIONS(1376),
    [anon_sym_partition] = ACTIONS(1376),
    [anon_sym_comdat] = ACTIONS(1378),
    [anon_sym_gc] = ACTIONS(1376),
    [anon_sym_prefix] = ACTIONS(1380),
    [anon_sym_prologue] = ACTIONS(1380),
    [anon_sym_personality] = ACTIONS(1380),
    [anon_sym_alignstack] = ACTIONS(456),
    [anon_sym_allocsize] = ACTIONS(456),
    [anon_sym_alwaysinline] = ACTIONS(456),
    [anon_sym_builtin] = ACTIONS(456),
    [anon_sym_cold] = ACTIONS(456),
    [anon_sym_convergent] = ACTIONS(456),
    [anon_sym_disable_sanitizer_instrumentation] = ACTIONS(456),
    [anon_sym_hot] = ACTIONS(456),
    [anon_sym_inaccessiblememonly] = ACTIONS(456),
    [anon_sym_inaccessiblemem_or_argmemonly] = ACTIONS(456),
    [anon_sym_inlinehint] = ACTIONS(456),
    [anon_sym_jumptable] = ACTIONS(456),
    [anon_sym_minsize] = ACTIONS(456),
    [anon_sym_naked] = ACTIONS(456),
    [anon_sym_no_DASHjump_DASHtables] = ACTIONS(456),
    [anon_sym_nobuiltin] = ACTIONS(456),
    [anon_sym_noduplicate] = ACTIONS(456),
    [anon_sym_nofree] = ACTIONS(456),
    [anon_sym_noimplicitfloat] = ACTIONS(456),
    [anon_sym_noinline] = ACTIONS(456),
    [anon_sym_nomerge] = ACTIONS(456),
    [anon_sym_nonlazybind] = ACTIONS(456),
    [anon_sym_noprofile] = ACTIONS(456),
    [anon_sym_noredzone] = ACTIONS(456),
    [anon_sym_indirect_DASHtls_DASHseg_DASHrefs] = ACTIONS(456),
    [anon_sym_noreturn] = ACTIONS(456),
    [anon_sym_norecurse] = ACTIONS(456),
    [anon_sym_willreturn] = ACTIONS(456),
    [anon_sym_nosync] = ACTIONS(456),
    [anon_sym_nounwind] = ACTIONS(456),
    [anon_sym_nocallback] = ACTIONS(456),
    [anon_sym_nosanitize_coverage] = ACTIONS(456),
    [anon_sym_null_pointer_is_valid] = ACTIONS(456),
    [anon_sym_optforfuzzing] = ACTIONS(456),
    [anon_sym_optnone] = ACTIONS(456),
    [anon_sym_optsize] = ACTIONS(456),
    [anon_sym_readnone] = ACTIONS(456),
    [anon_sym_readonly] = ACTIONS(456),
    [anon_sym_writeonly] = ACTIONS(456),
    [anon_sym_argmemonly] = ACTIONS(456),
    [anon_sym_returns_twice] = ACTIONS(456),
    [anon_sym_safestack] = ACTIONS(456),
    [anon_sym_sanitize_address] = ACTIONS(456),
    [anon_sym_sanitize_memory] = ACTIONS(456),
    [anon_sym_sanitize_thread] = ACTIONS(456),
    [anon_sym_sanitize_hwaddress] = ACTIONS(456),
    [anon_sym_sanitize_memtag] = ACTIONS(456),
    [anon_sym_speculative_load_hardening] = ACTIONS(456),
    [anon_sym_speculatable] = ACTIONS(456),
    [anon_sym_ssp] = ACTIONS(458),
    [anon_sym_sspstrong] = ACTIONS(456),
    [anon_sym_sspreq] = ACTIONS(456),
    [anon_sym_strictfp] = ACTIONS(456),
    [anon_sym_nocf_check] = ACTIONS(456),
    [anon_sym_shadowcallstack] = ACTIONS(456),
    [anon_sym_mustprogress] = ACTIONS(456),
    [anon_sym_vscale_range] = ACTIONS(456),
    [anon_sym_preallocated] = ACTIONS(456),
    [anon_sym_zeroext] = ACTIONS(456),
    [anon_sym_signext] = ACTIONS(456),
    [anon_sym_inreg] = ACTIONS(456),
    [anon_sym_byval] = ACTIONS(456),
    [anon_sym_byref] = ACTIONS(456),
    [anon_sym_inalloca] = ACTIONS(456),
    [anon_sym_sret] = ACTIONS(456),
    [anon_sym_elementtype] = ACTIONS(456),
    [anon_sym_noalias] = ACTIONS(456),
    [anon_sym_nocapture] = ACTIONS(456),
    [anon_sym_nest] = ACTIONS(456),
    [anon_sym_returned] = ACTIONS(456),
    [anon_sym_nonnull] = ACTIONS(456),
    [anon_sym_dereferenceable] = ACTIONS(458),
    [anon_sym_dereferenceable_or_null] = ACTIONS(456),
    [anon_sym_swiftself] = ACTIONS(456),
    [anon_sym_swiftasync] = ACTIONS(456),
    [anon_sym_swifterror] = ACTIONS(456),
    [anon_sym_immarg] = ACTIONS(456),
    [anon_sym_noundef] = ACTIONS(456),
    [anon_sym_uwtable] = ACTIONS(460),
    [anon_sym_memory] = ACTIONS(462),
  },
  [543] = {
    [sym_addrspace] = STATE(565),
    [sym_argument_list] = STATE(544),
    [aux_sym_type_repeat1] = STATE(546),
    [aux_sym_type_repeat2] = STATE(544),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE_GT] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(1747),
    [anon_sym_LPAREN] = ACTIONS(1749),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(244),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(244),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
  },
  [544] = {
    [sym_addrspace] = STATE(1730),
    [sym_argument_list] = STATE(544),
    [aux_sym_type_repeat1] = STATE(1185),
    [aux_sym_type_repeat2] = STATE(544),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [sym_string] = ACTIONS(250),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(250),
    [sym_float] = ACTIONS(250),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(250),
    [anon_sym_private] = ACTIONS(250),
    [anon_sym_internal] = ACTIONS(250),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(250),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(250),
    [anon_sym_available_externally] = ACTIONS(250),
    [anon_sym_appending] = ACTIONS(250),
    [anon_sym_common] = ACTIONS(250),
    [anon_sym_extern_weak] = ACTIONS(250),
    [anon_sym_external] = ACTIONS(250),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(250),
    [anon_sym_dso_preemptable] = ACTIONS(250),
    [anon_sym_default] = ACTIONS(250),
    [anon_sym_hidden] = ACTIONS(250),
    [anon_sym_protected] = ACTIONS(250),
    [anon_sym_dllimport] = ACTIONS(250),
    [anon_sym_dllexport] = ACTIONS(250),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE_GT] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(257),
    [anon_sym_LPAREN] = ACTIONS(1754),
    [anon_sym_none] = ACTIONS(250),
    [anon_sym_extractelement] = ACTIONS(250),
    [anon_sym_insertelement] = ACTIONS(250),
    [anon_sym_select] = ACTIONS(250),
    [anon_sym_shufflevector] = ACTIONS(250),
    [anon_sym_fneg] = ACTIONS(250),
    [anon_sym_icmp] = ACTIONS(250),
    [anon_sym_fcmp] = ACTIONS(250),
    [anon_sym_getelementptr] = ACTIONS(250),
    [anon_sym_extractvalue] = ACTIONS(250),
    [anon_sym_insertvalue] = ACTIONS(250),
    [anon_sym_true] = ACTIONS(250),
    [anon_sym_false] = ACTIONS(250),
    [anon_sym_null] = ACTIONS(250),
    [anon_sym_undef] = ACTIONS(250),
    [anon_sym_poison] = ACTIONS(250),
    [anon_sym_zeroinitializer] = ACTIONS(250),
    [anon_sym_blockaddress] = ACTIONS(250),
    [anon_sym_mul] = ACTIONS(250),
    [anon_sym_urem] = ACTIONS(250),
    [anon_sym_srem] = ACTIONS(250),
    [anon_sym_shl] = ACTIONS(250),
    [anon_sym_udiv] = ACTIONS(250),
    [anon_sym_sdiv] = ACTIONS(250),
    [anon_sym_lshr] = ACTIONS(250),
    [anon_sym_ashr] = ACTIONS(250),
    [anon_sym_fmul] = ACTIONS(250),
    [anon_sym_fdiv] = ACTIONS(250),
    [anon_sym_frem] = ACTIONS(250),
    [anon_sym_xchg] = ACTIONS(250),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(250),
    [anon_sym_and] = ACTIONS(250),
    [anon_sym_nand] = ACTIONS(250),
    [anon_sym_or] = ACTIONS(250),
    [anon_sym_xor] = ACTIONS(250),
    [anon_sym_max] = ACTIONS(250),
    [anon_sym_min] = ACTIONS(250),
    [anon_sym_umax] = ACTIONS(250),
    [anon_sym_umin] = ACTIONS(250),
    [anon_sym_fadd] = ACTIONS(250),
    [anon_sym_fsub] = ACTIONS(250),
    [anon_sym_bitcast] = ACTIONS(250),
    [anon_sym_trunc] = ACTIONS(250),
    [anon_sym_zext] = ACTIONS(250),
    [anon_sym_sext] = ACTIONS(250),
    [anon_sym_fptrunc] = ACTIONS(250),
    [anon_sym_fpext] = ACTIONS(250),
    [anon_sym_addrspacecast] = ACTIONS(250),
    [anon_sym_uitofp] = ACTIONS(250),
    [anon_sym_sitofp] = ACTIONS(250),
    [anon_sym_fptoui] = ACTIONS(250),
    [anon_sym_fptosi] = ACTIONS(250),
    [anon_sym_inttoptr] = ACTIONS(250),
    [anon_sym_ptrtoint] = ACTIONS(250),
  },
  [545] = {
    [sym_addrspace] = STATE(566),
    [sym_argument_list] = STATE(543),
    [aux_sym_type_repeat1] = STATE(547),
    [aux_sym_type_repeat2] = STATE(543),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(234),
    [sym_local_var] = ACTIONS(234),
    [sym_string] = ACTIONS(234),
    [aux_sym_number_token1] = ACTIONS(236),
    [aux_sym_number_token2] = ACTIONS(234),
    [sym_float] = ACTIONS(234),
    [sym_cstring] = ACTIONS(234),
    [anon_sym_no_cfi] = ACTIONS(234),
    [anon_sym_private] = ACTIONS(234),
    [anon_sym_internal] = ACTIONS(234),
    [anon_sym_weak] = ACTIONS(236),
    [anon_sym_weak_odr] = ACTIONS(234),
    [anon_sym_linkonce] = ACTIONS(236),
    [anon_sym_linkonce_odr] = ACTIONS(234),
    [anon_sym_available_externally] = ACTIONS(234),
    [anon_sym_appending] = ACTIONS(234),
    [anon_sym_common] = ACTIONS(234),
    [anon_sym_extern_weak] = ACTIONS(234),
    [anon_sym_external] = ACTIONS(234),
    [anon_sym_dso_local] = ACTIONS(236),
    [anon_sym_dso_local_equivalent] = ACTIONS(234),
    [anon_sym_dso_preemptable] = ACTIONS(234),
    [anon_sym_default] = ACTIONS(234),
    [anon_sym_hidden] = ACTIONS(234),
    [anon_sym_protected] = ACTIONS(234),
    [anon_sym_dllimport] = ACTIONS(234),
    [anon_sym_dllexport] = ACTIONS(234),
    [anon_sym_STAR] = ACTIONS(1757),
    [anon_sym_LBRACE] = ACTIONS(234),
    [anon_sym_LT_LBRACE] = ACTIONS(234),
    [anon_sym_RBRACE_GT] = ACTIONS(234),
    [anon_sym_LBRACK] = ACTIONS(234),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_COMMA] = ACTIONS(234),
    [anon_sym_addrspace] = ACTIONS(1747),
    [anon_sym_LPAREN] = ACTIONS(1749),
    [anon_sym_none] = ACTIONS(234),
    [anon_sym_extractelement] = ACTIONS(234),
    [anon_sym_insertelement] = ACTIONS(234),
    [anon_sym_select] = ACTIONS(234),
    [anon_sym_shufflevector] = ACTIONS(234),
    [anon_sym_fneg] = ACTIONS(234),
    [anon_sym_icmp] = ACTIONS(234),
    [anon_sym_fcmp] = ACTIONS(234),
    [anon_sym_getelementptr] = ACTIONS(234),
    [anon_sym_extractvalue] = ACTIONS(234),
    [anon_sym_insertvalue] = ACTIONS(234),
    [anon_sym_true] = ACTIONS(234),
    [anon_sym_false] = ACTIONS(234),
    [anon_sym_null] = ACTIONS(234),
    [anon_sym_undef] = ACTIONS(234),
    [anon_sym_poison] = ACTIONS(234),
    [anon_sym_zeroinitializer] = ACTIONS(234),
    [anon_sym_blockaddress] = ACTIONS(234),
    [anon_sym_mul] = ACTIONS(234),
    [anon_sym_urem] = ACTIONS(234),
    [anon_sym_srem] = ACTIONS(234),
    [anon_sym_shl] = ACTIONS(234),
    [anon_sym_udiv] = ACTIONS(234),
    [anon_sym_sdiv] = ACTIONS(234),
    [anon_sym_lshr] = ACTIONS(234),
    [anon_sym_ashr] = ACTIONS(234),
    [anon_sym_fmul] = ACTIONS(234),
    [anon_sym_fdiv] = ACTIONS(234),
    [anon_sym_frem] = ACTIONS(234),
    [anon_sym_xchg] = ACTIONS(234),
    [anon_sym_add] = ACTIONS(236),
    [anon_sym_sub] = ACTIONS(234),
    [anon_sym_and] = ACTIONS(234),
    [anon_sym_nand] = ACTIONS(234),
    [anon_sym_or] = ACTIONS(234),
    [anon_sym_xor] = ACTIONS(234),
    [anon_sym_max] = ACTIONS(234),
    [anon_sym_min] = ACTIONS(234),
    [anon_sym_umax] = ACTIONS(234),
    [anon_sym_umin] = ACTIONS(234),
    [anon_sym_fadd] = ACTIONS(234),
    [anon_sym_fsub] = ACTIONS(234),
    [anon_sym_bitcast] = ACTIONS(234),
    [anon_sym_trunc] = ACTIONS(234),
    [anon_sym_zext] = ACTIONS(234),
    [anon_sym_sext] = ACTIONS(234),
    [anon_sym_fptrunc] = ACTIONS(234),
    [anon_sym_fpext] = ACTIONS(234),
    [anon_sym_addrspacecast] = ACTIONS(234),
    [anon_sym_uitofp] = ACTIONS(234),
    [anon_sym_sitofp] = ACTIONS(234),
    [anon_sym_fptoui] = ACTIONS(234),
    [anon_sym_fptosi] = ACTIONS(234),
    [anon_sym_inttoptr] = ACTIONS(234),
    [anon_sym_ptrtoint] = ACTIONS(234),
  },
  [546] = {
    [sym_addrspace] = STATE(564),
    [sym_argument_list] = STATE(556),
    [aux_sym_type_repeat1] = STATE(548),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [sym_string] = ACTIONS(263),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(263),
    [sym_float] = ACTIONS(263),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(263),
    [anon_sym_private] = ACTIONS(263),
    [anon_sym_internal] = ACTIONS(263),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(263),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(263),
    [anon_sym_available_externally] = ACTIONS(263),
    [anon_sym_appending] = ACTIONS(263),
    [anon_sym_common] = ACTIONS(263),
    [anon_sym_extern_weak] = ACTIONS(263),
    [anon_sym_external] = ACTIONS(263),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(263),
    [anon_sym_dso_preemptable] = ACTIONS(263),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_hidden] = ACTIONS(263),
    [anon_sym_protected] = ACTIONS(263),
    [anon_sym_dllimport] = ACTIONS(263),
    [anon_sym_dllexport] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE_GT] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_addrspace] = ACTIONS(1747),
    [anon_sym_LPAREN] = ACTIONS(1749),
    [anon_sym_none] = ACTIONS(263),
    [anon_sym_extractelement] = ACTIONS(263),
    [anon_sym_insertelement] = ACTIONS(263),
    [anon_sym_select] = ACTIONS(263),
    [anon_sym_shufflevector] = ACTIONS(263),
    [anon_sym_fneg] = ACTIONS(263),
    [anon_sym_icmp] = ACTIONS(263),
    [anon_sym_fcmp] = ACTIONS(263),
    [anon_sym_getelementptr] = ACTIONS(263),
    [anon_sym_extractvalue] = ACTIONS(263),
    [anon_sym_insertvalue] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(263),
    [anon_sym_false] = ACTIONS(263),
    [anon_sym_null] = ACTIONS(263),
    [anon_sym_undef] = ACTIONS(263),
    [anon_sym_poison] = ACTIONS(263),
    [anon_sym_zeroinitializer] = ACTIONS(263),
    [anon_sym_blockaddress] = ACTIONS(263),
    [anon_sym_mul] = ACTIONS(263),
    [anon_sym_urem] = ACTIONS(263),
    [anon_sym_srem] = ACTIONS(263),
    [anon_sym_shl] = ACTIONS(263),
    [anon_sym_udiv] = ACTIONS(263),
    [anon_sym_sdiv] = ACTIONS(263),
    [anon_sym_lshr] = ACTIONS(263),
    [anon_sym_ashr] = ACTIONS(263),
    [anon_sym_fmul] = ACTIONS(263),
    [anon_sym_fdiv] = ACTIONS(263),
    [anon_sym_frem] = ACTIONS(263),
    [anon_sym_xchg] = ACTIONS(263),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(263),
    [anon_sym_and] = ACTIONS(263),
    [anon_sym_nand] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(263),
    [anon_sym_xor] = ACTIONS(263),
    [anon_sym_max] = ACTIONS(263),
    [anon_sym_min] = ACTIONS(263),
    [anon_sym_umax] = ACTIONS(263),
    [anon_sym_umin] = ACTIONS(263),
    [anon_sym_fadd] = ACTIONS(263),
    [anon_sym_fsub] = ACTIONS(263),
    [anon_sym_bitcast] = ACTIONS(263),
    [anon_sym_trunc] = ACTIONS(263),
    [anon_sym_zext] = ACTIONS(263),
    [anon_sym_sext] = ACTIONS(263),
    [anon_sym_fptrunc] = ACTIONS(263),
    [anon_sym_fpext] = ACTIONS(263),
    [anon_sym_addrspacecast] = ACTIONS(263),
    [anon_sym_uitofp] = ACTIONS(263),
    [anon_sym_sitofp] = ACTIONS(263),
    [anon_sym_fptoui] = ACTIONS(263),
    [anon_sym_fptosi] = ACTIONS(263),
    [anon_sym_inttoptr] = ACTIONS(263),
    [anon_sym_ptrtoint] = ACTIONS(263),
  },
  [547] = {
    [sym_addrspace] = STATE(565),
    [sym_argument_list] = STATE(556),
    [aux_sym_type_repeat1] = STATE(548),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE_GT] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_addrspace] = ACTIONS(1747),
    [anon_sym_LPAREN] = ACTIONS(1749),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(244),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(244),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
  },
  [548] = {
    [sym_addrspace] = STATE(1914),
    [aux_sym_type_repeat1] = STATE(548),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [sym_string] = ACTIONS(269),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(269),
    [sym_float] = ACTIONS(269),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_internal] = ACTIONS(269),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(269),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(269),
    [anon_sym_available_externally] = ACTIONS(269),
    [anon_sym_appending] = ACTIONS(269),
    [anon_sym_common] = ACTIONS(269),
    [anon_sym_extern_weak] = ACTIONS(269),
    [anon_sym_external] = ACTIONS(269),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(269),
    [anon_sym_dso_preemptable] = ACTIONS(269),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_hidden] = ACTIONS(269),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_dllimport] = ACTIONS(269),
    [anon_sym_dllexport] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE_GT] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_none] = ACTIONS(269),
    [anon_sym_extractelement] = ACTIONS(269),
    [anon_sym_insertelement] = ACTIONS(269),
    [anon_sym_select] = ACTIONS(269),
    [anon_sym_shufflevector] = ACTIONS(269),
    [anon_sym_fneg] = ACTIONS(269),
    [anon_sym_icmp] = ACTIONS(269),
    [anon_sym_fcmp] = ACTIONS(269),
    [anon_sym_getelementptr] = ACTIONS(269),
    [anon_sym_extractvalue] = ACTIONS(269),
    [anon_sym_insertvalue] = ACTIONS(269),
    [anon_sym_true] = ACTIONS(269),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_null] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(269),
    [anon_sym_poison] = ACTIONS(269),
    [anon_sym_zeroinitializer] = ACTIONS(269),
    [anon_sym_blockaddress] = ACTIONS(269),
    [anon_sym_mul] = ACTIONS(269),
    [anon_sym_urem] = ACTIONS(269),
    [anon_sym_srem] = ACTIONS(269),
    [anon_sym_shl] = ACTIONS(269),
    [anon_sym_udiv] = ACTIONS(269),
    [anon_sym_sdiv] = ACTIONS(269),
    [anon_sym_lshr] = ACTIONS(269),
    [anon_sym_ashr] = ACTIONS(269),
    [anon_sym_fmul] = ACTIONS(269),
    [anon_sym_fdiv] = ACTIONS(269),
    [anon_sym_frem] = ACTIONS(269),
    [anon_sym_xchg] = ACTIONS(269),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(269),
    [anon_sym_and] = ACTIONS(269),
    [anon_sym_nand] = ACTIONS(269),
    [anon_sym_or] = ACTIONS(269),
    [anon_sym_xor] = ACTIONS(269),
    [anon_sym_max] = ACTIONS(269),
    [anon_sym_min] = ACTIONS(269),
    [anon_sym_umax] = ACTIONS(269),
    [anon_sym_umin] = ACTIONS(269),
    [anon_sym_fadd] = ACTIONS(269),
    [anon_sym_fsub] = ACTIONS(269),
    [anon_sym_bitcast] = ACTIONS(269),
    [anon_sym_trunc] = ACTIONS(269),
    [anon_sym_zext] = ACTIONS(269),
    [anon_sym_sext] = ACTIONS(269),
    [anon_sym_fptrunc] = ACTIONS(269),
    [anon_sym_fpext] = ACTIONS(269),
    [anon_sym_addrspacecast] = ACTIONS(269),
    [anon_sym_uitofp] = ACTIONS(269),
    [anon_sym_sitofp] = ACTIONS(269),
    [anon_sym_fptoui] = ACTIONS(269),
    [anon_sym_fptosi] = ACTIONS(269),
    [anon_sym_inttoptr] = ACTIONS(269),
    [anon_sym_ptrtoint] = ACTIONS(269),
  },
  [549] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(387),
    [sym_local_var] = ACTIONS(387),
    [sym_string] = ACTIONS(387),
    [aux_sym_number_token1] = ACTIONS(389),
    [aux_sym_number_token2] = ACTIONS(387),
    [sym_float] = ACTIONS(387),
    [sym_cstring] = ACTIONS(387),
    [anon_sym_no_cfi] = ACTIONS(387),
    [anon_sym_private] = ACTIONS(387),
    [anon_sym_internal] = ACTIONS(387),
    [anon_sym_weak] = ACTIONS(389),
    [anon_sym_weak_odr] = ACTIONS(387),
    [anon_sym_linkonce] = ACTIONS(389),
    [anon_sym_linkonce_odr] = ACTIONS(387),
    [anon_sym_available_externally] = ACTIONS(387),
    [anon_sym_appending] = ACTIONS(387),
    [anon_sym_common] = ACTIONS(387),
    [anon_sym_extern_weak] = ACTIONS(387),
    [anon_sym_external] = ACTIONS(387),
    [anon_sym_dso_local] = ACTIONS(389),
    [anon_sym_dso_local_equivalent] = ACTIONS(387),
    [anon_sym_dso_preemptable] = ACTIONS(387),
    [anon_sym_default] = ACTIONS(387),
    [anon_sym_hidden] = ACTIONS(387),
    [anon_sym_protected] = ACTIONS(387),
    [anon_sym_dllimport] = ACTIONS(387),
    [anon_sym_dllexport] = ACTIONS(387),
    [anon_sym_STAR] = ACTIONS(387),
    [anon_sym_LBRACE] = ACTIONS(387),
    [anon_sym_LT_LBRACE] = ACTIONS(387),
    [anon_sym_RBRACE_GT] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_COMMA] = ACTIONS(387),
    [anon_sym_addrspace] = ACTIONS(389),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_none] = ACTIONS(387),
    [anon_sym_extractelement] = ACTIONS(387),
    [anon_sym_insertelement] = ACTIONS(387),
    [anon_sym_select] = ACTIONS(387),
    [anon_sym_shufflevector] = ACTIONS(387),
    [anon_sym_fneg] = ACTIONS(387),
    [anon_sym_icmp] = ACTIONS(387),
    [anon_sym_fcmp] = ACTIONS(387),
    [anon_sym_getelementptr] = ACTIONS(387),
    [anon_sym_extractvalue] = ACTIONS(387),
    [anon_sym_insertvalue] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(387),
    [anon_sym_false] = ACTIONS(387),
    [anon_sym_null] = ACTIONS(387),
    [anon_sym_undef] = ACTIONS(387),
    [anon_sym_poison] = ACTIONS(387),
    [anon_sym_zeroinitializer] = ACTIONS(387),
    [anon_sym_blockaddress] = ACTIONS(387),
    [anon_sym_mul] = ACTIONS(387),
    [anon_sym_urem] = ACTIONS(387),
    [anon_sym_srem] = ACTIONS(387),
    [anon_sym_shl] = ACTIONS(387),
    [anon_sym_udiv] = ACTIONS(387),
    [anon_sym_sdiv] = ACTIONS(387),
    [anon_sym_lshr] = ACTIONS(387),
    [anon_sym_ashr] = ACTIONS(387),
    [anon_sym_fmul] = ACTIONS(387),
    [anon_sym_fdiv] = ACTIONS(387),
    [anon_sym_frem] = ACTIONS(387),
    [anon_sym_xchg] = ACTIONS(387),
    [anon_sym_add] = ACTIONS(389),
    [anon_sym_sub] = ACTIONS(387),
    [anon_sym_and] = ACTIONS(387),
    [anon_sym_nand] = ACTIONS(387),
    [anon_sym_or] = ACTIONS(387),
    [anon_sym_xor] = ACTIONS(387),
    [anon_sym_max] = ACTIONS(387),
    [anon_sym_min] = ACTIONS(387),
    [anon_sym_umax] = ACTIONS(387),
    [anon_sym_umin] = ACTIONS(387),
    [anon_sym_fadd] = ACTIONS(387),
    [anon_sym_fsub] = ACTIONS(387),
    [anon_sym_bitcast] = ACTIONS(387),
    [anon_sym_trunc] = ACTIONS(387),
    [anon_sym_zext] = ACTIONS(387),
    [anon_sym_sext] = ACTIONS(387),
    [anon_sym_fptrunc] = ACTIONS(387),
    [anon_sym_fpext] = ACTIONS(387),
    [anon_sym_addrspacecast] = ACTIONS(387),
    [anon_sym_uitofp] = ACTIONS(387),
    [anon_sym_sitofp] = ACTIONS(387),
    [anon_sym_fptoui] = ACTIONS(387),
    [anon_sym_fptosi] = ACTIONS(387),
    [anon_sym_inttoptr] = ACTIONS(387),
    [anon_sym_ptrtoint] = ACTIONS(387),
  },
  [550] = {
    [sym_type] = STATE(691),
    [sym_type_keyword] = STATE(260),
    [sym_struct_type] = STATE(260),
    [sym_packed_struct_type] = STATE(260),
    [sym_array_type] = STATE(260),
    [sym_vector_type] = STATE(260),
    [sym_constant_expr] = STATE(425),
    [sym_constant_cast] = STATE(359),
    [sym_constant_getelementptr] = STATE(359),
    [sym_constant_select] = STATE(359),
    [sym_constant_icmp] = STATE(359),
    [sym_constant_fcmp] = STATE(359),
    [sym_constant_extractelement] = STATE(359),
    [sym_constant_insertelement] = STATE(359),
    [sym_constant_shufflevector] = STATE(359),
    [sym_constant_extractvalue] = STATE(359),
    [sym_constant_insertvalue] = STATE(359),
    [sym_constant_fneg] = STATE(359),
    [sym_constant_bin_op] = STATE(359),
    [sym_bin_op_keyword] = STATE(1133),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1924),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(1764),
    [sym_local_var] = ACTIONS(436),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(442),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_extractelement] = ACTIONS(335),
    [anon_sym_insertelement] = ACTIONS(337),
    [anon_sym_select] = ACTIONS(339),
    [anon_sym_shufflevector] = ACTIONS(341),
    [anon_sym_fneg] = ACTIONS(343),
    [anon_sym_icmp] = ACTIONS(345),
    [anon_sym_fcmp] = ACTIONS(347),
    [anon_sym_getelementptr] = ACTIONS(349),
    [anon_sym_extractvalue] = ACTIONS(351),
    [anon_sym_insertvalue] = ACTIONS(353),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [551] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(367),
    [sym_local_var] = ACTIONS(367),
    [sym_string] = ACTIONS(367),
    [aux_sym_number_token1] = ACTIONS(369),
    [aux_sym_number_token2] = ACTIONS(367),
    [sym_float] = ACTIONS(367),
    [sym_cstring] = ACTIONS(367),
    [anon_sym_no_cfi] = ACTIONS(367),
    [anon_sym_private] = ACTIONS(367),
    [anon_sym_internal] = ACTIONS(367),
    [anon_sym_weak] = ACTIONS(369),
    [anon_sym_weak_odr] = ACTIONS(367),
    [anon_sym_linkonce] = ACTIONS(369),
    [anon_sym_linkonce_odr] = ACTIONS(367),
    [anon_sym_available_externally] = ACTIONS(367),
    [anon_sym_appending] = ACTIONS(367),
    [anon_sym_common] = ACTIONS(367),
    [anon_sym_extern_weak] = ACTIONS(367),
    [anon_sym_external] = ACTIONS(367),
    [anon_sym_dso_local] = ACTIONS(369),
    [anon_sym_dso_local_equivalent] = ACTIONS(367),
    [anon_sym_dso_preemptable] = ACTIONS(367),
    [anon_sym_default] = ACTIONS(367),
    [anon_sym_hidden] = ACTIONS(367),
    [anon_sym_protected] = ACTIONS(367),
    [anon_sym_dllimport] = ACTIONS(367),
    [anon_sym_dllexport] = ACTIONS(367),
    [anon_sym_STAR] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(367),
    [anon_sym_LT_LBRACE] = ACTIONS(367),
    [anon_sym_RBRACE_GT] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_COMMA] = ACTIONS(367),
    [anon_sym_addrspace] = ACTIONS(369),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_none] = ACTIONS(367),
    [anon_sym_extractelement] = ACTIONS(367),
    [anon_sym_insertelement] = ACTIONS(367),
    [anon_sym_select] = ACTIONS(367),
    [anon_sym_shufflevector] = ACTIONS(367),
    [anon_sym_fneg] = ACTIONS(367),
    [anon_sym_icmp] = ACTIONS(367),
    [anon_sym_fcmp] = ACTIONS(367),
    [anon_sym_getelementptr] = ACTIONS(367),
    [anon_sym_extractvalue] = ACTIONS(367),
    [anon_sym_insertvalue] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(367),
    [anon_sym_false] = ACTIONS(367),
    [anon_sym_null] = ACTIONS(367),
    [anon_sym_undef] = ACTIONS(367),
    [anon_sym_poison] = ACTIONS(367),
    [anon_sym_zeroinitializer] = ACTIONS(367),
    [anon_sym_blockaddress] = ACTIONS(367),
    [anon_sym_mul] = ACTIONS(367),
    [anon_sym_urem] = ACTIONS(367),
    [anon_sym_srem] = ACTIONS(367),
    [anon_sym_shl] = ACTIONS(367),
    [anon_sym_udiv] = ACTIONS(367),
    [anon_sym_sdiv] = ACTIONS(367),
    [anon_sym_lshr] = ACTIONS(367),
    [anon_sym_ashr] = ACTIONS(367),
    [anon_sym_fmul] = ACTIONS(367),
    [anon_sym_fdiv] = ACTIONS(367),
    [anon_sym_frem] = ACTIONS(367),
    [anon_sym_xchg] = ACTIONS(367),
    [anon_sym_add] = ACTIONS(369),
    [anon_sym_sub] = ACTIONS(367),
    [anon_sym_and] = ACTIONS(367),
    [anon_sym_nand] = ACTIONS(367),
    [anon_sym_or] = ACTIONS(367),
    [anon_sym_xor] = ACTIONS(367),
    [anon_sym_max] = ACTIONS(367),
    [anon_sym_min] = ACTIONS(367),
    [anon_sym_umax] = ACTIONS(367),
    [anon_sym_umin] = ACTIONS(367),
    [anon_sym_fadd] = ACTIONS(367),
    [anon_sym_fsub] = ACTIONS(367),
    [anon_sym_bitcast] = ACTIONS(367),
    [anon_sym_trunc] = ACTIONS(367),
    [anon_sym_zext] = ACTIONS(367),
    [anon_sym_sext] = ACTIONS(367),
    [anon_sym_fptrunc] = ACTIONS(367),
    [anon_sym_fpext] = ACTIONS(367),
    [anon_sym_addrspacecast] = ACTIONS(367),
    [anon_sym_uitofp] = ACTIONS(367),
    [anon_sym_sitofp] = ACTIONS(367),
    [anon_sym_fptoui] = ACTIONS(367),
    [anon_sym_fptosi] = ACTIONS(367),
    [anon_sym_inttoptr] = ACTIONS(367),
    [anon_sym_ptrtoint] = ACTIONS(367),
  },
  [552] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(116),
    [sym_local_var] = ACTIONS(116),
    [sym_string] = ACTIONS(116),
    [aux_sym_number_token1] = ACTIONS(122),
    [aux_sym_number_token2] = ACTIONS(116),
    [sym_float] = ACTIONS(116),
    [sym_cstring] = ACTIONS(116),
    [anon_sym_no_cfi] = ACTIONS(116),
    [anon_sym_private] = ACTIONS(116),
    [anon_sym_internal] = ACTIONS(116),
    [anon_sym_weak] = ACTIONS(122),
    [anon_sym_weak_odr] = ACTIONS(116),
    [anon_sym_linkonce] = ACTIONS(122),
    [anon_sym_linkonce_odr] = ACTIONS(116),
    [anon_sym_available_externally] = ACTIONS(116),
    [anon_sym_appending] = ACTIONS(116),
    [anon_sym_common] = ACTIONS(116),
    [anon_sym_extern_weak] = ACTIONS(116),
    [anon_sym_external] = ACTIONS(116),
    [anon_sym_dso_local] = ACTIONS(122),
    [anon_sym_dso_local_equivalent] = ACTIONS(116),
    [anon_sym_dso_preemptable] = ACTIONS(116),
    [anon_sym_default] = ACTIONS(116),
    [anon_sym_hidden] = ACTIONS(116),
    [anon_sym_protected] = ACTIONS(116),
    [anon_sym_dllimport] = ACTIONS(116),
    [anon_sym_dllexport] = ACTIONS(116),
    [anon_sym_STAR] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(116),
    [anon_sym_LT_LBRACE] = ACTIONS(116),
    [anon_sym_RBRACE_GT] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(116),
    [anon_sym_LT] = ACTIONS(122),
    [anon_sym_COMMA] = ACTIONS(116),
    [anon_sym_addrspace] = ACTIONS(122),
    [anon_sym_LPAREN] = ACTIONS(116),
    [anon_sym_none] = ACTIONS(116),
    [anon_sym_extractelement] = ACTIONS(116),
    [anon_sym_insertelement] = ACTIONS(116),
    [anon_sym_select] = ACTIONS(116),
    [anon_sym_shufflevector] = ACTIONS(116),
    [anon_sym_fneg] = ACTIONS(116),
    [anon_sym_icmp] = ACTIONS(116),
    [anon_sym_fcmp] = ACTIONS(116),
    [anon_sym_getelementptr] = ACTIONS(116),
    [anon_sym_extractvalue] = ACTIONS(116),
    [anon_sym_insertvalue] = ACTIONS(116),
    [anon_sym_true] = ACTIONS(116),
    [anon_sym_false] = ACTIONS(116),
    [anon_sym_null] = ACTIONS(116),
    [anon_sym_undef] = ACTIONS(116),
    [anon_sym_poison] = ACTIONS(116),
    [anon_sym_zeroinitializer] = ACTIONS(116),
    [anon_sym_blockaddress] = ACTIONS(116),
    [anon_sym_mul] = ACTIONS(116),
    [anon_sym_urem] = ACTIONS(116),
    [anon_sym_srem] = ACTIONS(116),
    [anon_sym_shl] = ACTIONS(116),
    [anon_sym_udiv] = ACTIONS(116),
    [anon_sym_sdiv] = ACTIONS(116),
    [anon_sym_lshr] = ACTIONS(116),
    [anon_sym_ashr] = ACTIONS(116),
    [anon_sym_fmul] = ACTIONS(116),
    [anon_sym_fdiv] = ACTIONS(116),
    [anon_sym_frem] = ACTIONS(116),
    [anon_sym_xchg] = ACTIONS(116),
    [anon_sym_add] = ACTIONS(122),
    [anon_sym_sub] = ACTIONS(116),
    [anon_sym_and] = ACTIONS(116),
    [anon_sym_nand] = ACTIONS(116),
    [anon_sym_or] = ACTIONS(116),
    [anon_sym_xor] = ACTIONS(116),
    [anon_sym_max] = ACTIONS(116),
    [anon_sym_min] = ACTIONS(116),
    [anon_sym_umax] = ACTIONS(116),
    [anon_sym_umin] = ACTIONS(116),
    [anon_sym_fadd] = ACTIONS(116),
    [anon_sym_fsub] = ACTIONS(116),
    [anon_sym_bitcast] = ACTIONS(116),
    [anon_sym_trunc] = ACTIONS(116),
    [anon_sym_zext] = ACTIONS(116),
    [anon_sym_sext] = ACTIONS(116),
    [anon_sym_fptrunc] = ACTIONS(116),
    [anon_sym_fpext] = ACTIONS(116),
    [anon_sym_addrspacecast] = ACTIONS(116),
    [anon_sym_uitofp] = ACTIONS(116),
    [anon_sym_sitofp] = ACTIONS(116),
    [anon_sym_fptoui] = ACTIONS(116),
    [anon_sym_fptosi] = ACTIONS(116),
    [anon_sym_inttoptr] = ACTIONS(116),
    [anon_sym_ptrtoint] = ACTIONS(116),
  },
  [553] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(383),
    [sym_local_var] = ACTIONS(383),
    [sym_string] = ACTIONS(383),
    [aux_sym_number_token1] = ACTIONS(385),
    [aux_sym_number_token2] = ACTIONS(383),
    [sym_float] = ACTIONS(383),
    [sym_cstring] = ACTIONS(383),
    [anon_sym_no_cfi] = ACTIONS(383),
    [anon_sym_private] = ACTIONS(383),
    [anon_sym_internal] = ACTIONS(383),
    [anon_sym_weak] = ACTIONS(385),
    [anon_sym_weak_odr] = ACTIONS(383),
    [anon_sym_linkonce] = ACTIONS(385),
    [anon_sym_linkonce_odr] = ACTIONS(383),
    [anon_sym_available_externally] = ACTIONS(383),
    [anon_sym_appending] = ACTIONS(383),
    [anon_sym_common] = ACTIONS(383),
    [anon_sym_extern_weak] = ACTIONS(383),
    [anon_sym_external] = ACTIONS(383),
    [anon_sym_dso_local] = ACTIONS(385),
    [anon_sym_dso_local_equivalent] = ACTIONS(383),
    [anon_sym_dso_preemptable] = ACTIONS(383),
    [anon_sym_default] = ACTIONS(383),
    [anon_sym_hidden] = ACTIONS(383),
    [anon_sym_protected] = ACTIONS(383),
    [anon_sym_dllimport] = ACTIONS(383),
    [anon_sym_dllexport] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_LBRACE] = ACTIONS(383),
    [anon_sym_LT_LBRACE] = ACTIONS(383),
    [anon_sym_RBRACE_GT] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_addrspace] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_none] = ACTIONS(383),
    [anon_sym_extractelement] = ACTIONS(383),
    [anon_sym_insertelement] = ACTIONS(383),
    [anon_sym_select] = ACTIONS(383),
    [anon_sym_shufflevector] = ACTIONS(383),
    [anon_sym_fneg] = ACTIONS(383),
    [anon_sym_icmp] = ACTIONS(383),
    [anon_sym_fcmp] = ACTIONS(383),
    [anon_sym_getelementptr] = ACTIONS(383),
    [anon_sym_extractvalue] = ACTIONS(383),
    [anon_sym_insertvalue] = ACTIONS(383),
    [anon_sym_true] = ACTIONS(383),
    [anon_sym_false] = ACTIONS(383),
    [anon_sym_null] = ACTIONS(383),
    [anon_sym_undef] = ACTIONS(383),
    [anon_sym_poison] = ACTIONS(383),
    [anon_sym_zeroinitializer] = ACTIONS(383),
    [anon_sym_blockaddress] = ACTIONS(383),
    [anon_sym_mul] = ACTIONS(383),
    [anon_sym_urem] = ACTIONS(383),
    [anon_sym_srem] = ACTIONS(383),
    [anon_sym_shl] = ACTIONS(383),
    [anon_sym_udiv] = ACTIONS(383),
    [anon_sym_sdiv] = ACTIONS(383),
    [anon_sym_lshr] = ACTIONS(383),
    [anon_sym_ashr] = ACTIONS(383),
    [anon_sym_fmul] = ACTIONS(383),
    [anon_sym_fdiv] = ACTIONS(383),
    [anon_sym_frem] = ACTIONS(383),
    [anon_sym_xchg] = ACTIONS(383),
    [anon_sym_add] = ACTIONS(385),
    [anon_sym_sub] = ACTIONS(383),
    [anon_sym_and] = ACTIONS(383),
    [anon_sym_nand] = ACTIONS(383),
    [anon_sym_or] = ACTIONS(383),
    [anon_sym_xor] = ACTIONS(383),
    [anon_sym_max] = ACTIONS(383),
    [anon_sym_min] = ACTIONS(383),
    [anon_sym_umax] = ACTIONS(383),
    [anon_sym_umin] = ACTIONS(383),
    [anon_sym_fadd] = ACTIONS(383),
    [anon_sym_fsub] = ACTIONS(383),
    [anon_sym_bitcast] = ACTIONS(383),
    [anon_sym_trunc] = ACTIONS(383),
    [anon_sym_zext] = ACTIONS(383),
    [anon_sym_sext] = ACTIONS(383),
    [anon_sym_fptrunc] = ACTIONS(383),
    [anon_sym_fpext] = ACTIONS(383),
    [anon_sym_addrspacecast] = ACTIONS(383),
    [anon_sym_uitofp] = ACTIONS(383),
    [anon_sym_sitofp] = ACTIONS(383),
    [anon_sym_fptoui] = ACTIONS(383),
    [anon_sym_fptosi] = ACTIONS(383),
    [anon_sym_inttoptr] = ACTIONS(383),
    [anon_sym_ptrtoint] = ACTIONS(383),
  },
  [554] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(279),
    [sym_local_var] = ACTIONS(279),
    [sym_string] = ACTIONS(279),
    [aux_sym_number_token1] = ACTIONS(281),
    [aux_sym_number_token2] = ACTIONS(279),
    [sym_float] = ACTIONS(279),
    [sym_cstring] = ACTIONS(279),
    [anon_sym_no_cfi] = ACTIONS(279),
    [anon_sym_private] = ACTIONS(279),
    [anon_sym_internal] = ACTIONS(279),
    [anon_sym_weak] = ACTIONS(281),
    [anon_sym_weak_odr] = ACTIONS(279),
    [anon_sym_linkonce] = ACTIONS(281),
    [anon_sym_linkonce_odr] = ACTIONS(279),
    [anon_sym_available_externally] = ACTIONS(279),
    [anon_sym_appending] = ACTIONS(279),
    [anon_sym_common] = ACTIONS(279),
    [anon_sym_extern_weak] = ACTIONS(279),
    [anon_sym_external] = ACTIONS(279),
    [anon_sym_dso_local] = ACTIONS(281),
    [anon_sym_dso_local_equivalent] = ACTIONS(279),
    [anon_sym_dso_preemptable] = ACTIONS(279),
    [anon_sym_default] = ACTIONS(279),
    [anon_sym_hidden] = ACTIONS(279),
    [anon_sym_protected] = ACTIONS(279),
    [anon_sym_dllimport] = ACTIONS(279),
    [anon_sym_dllexport] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(279),
    [anon_sym_LT_LBRACE] = ACTIONS(279),
    [anon_sym_RBRACE_GT] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(281),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_addrspace] = ACTIONS(281),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_none] = ACTIONS(279),
    [anon_sym_extractelement] = ACTIONS(279),
    [anon_sym_insertelement] = ACTIONS(279),
    [anon_sym_select] = ACTIONS(279),
    [anon_sym_shufflevector] = ACTIONS(279),
    [anon_sym_fneg] = ACTIONS(279),
    [anon_sym_icmp] = ACTIONS(279),
    [anon_sym_fcmp] = ACTIONS(279),
    [anon_sym_getelementptr] = ACTIONS(279),
    [anon_sym_extractvalue] = ACTIONS(279),
    [anon_sym_insertvalue] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(279),
    [anon_sym_false] = ACTIONS(279),
    [anon_sym_null] = ACTIONS(279),
    [anon_sym_undef] = ACTIONS(279),
    [anon_sym_poison] = ACTIONS(279),
    [anon_sym_zeroinitializer] = ACTIONS(279),
    [anon_sym_blockaddress] = ACTIONS(279),
    [anon_sym_mul] = ACTIONS(279),
    [anon_sym_urem] = ACTIONS(279),
    [anon_sym_srem] = ACTIONS(279),
    [anon_sym_shl] = ACTIONS(279),
    [anon_sym_udiv] = ACTIONS(279),
    [anon_sym_sdiv] = ACTIONS(279),
    [anon_sym_lshr] = ACTIONS(279),
    [anon_sym_ashr] = ACTIONS(279),
    [anon_sym_fmul] = ACTIONS(279),
    [anon_sym_fdiv] = ACTIONS(279),
    [anon_sym_frem] = ACTIONS(279),
    [anon_sym_xchg] = ACTIONS(279),
    [anon_sym_add] = ACTIONS(281),
    [anon_sym_sub] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_nand] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_xor] = ACTIONS(279),
    [anon_sym_max] = ACTIONS(279),
    [anon_sym_min] = ACTIONS(279),
    [anon_sym_umax] = ACTIONS(279),
    [anon_sym_umin] = ACTIONS(279),
    [anon_sym_fadd] = ACTIONS(279),
    [anon_sym_fsub] = ACTIONS(279),
    [anon_sym_bitcast] = ACTIONS(279),
    [anon_sym_trunc] = ACTIONS(279),
    [anon_sym_zext] = ACTIONS(279),
    [anon_sym_sext] = ACTIONS(279),
    [anon_sym_fptrunc] = ACTIONS(279),
    [anon_sym_fpext] = ACTIONS(279),
    [anon_sym_addrspacecast] = ACTIONS(279),
    [anon_sym_uitofp] = ACTIONS(279),
    [anon_sym_sitofp] = ACTIONS(279),
    [anon_sym_fptoui] = ACTIONS(279),
    [anon_sym_fptosi] = ACTIONS(279),
    [anon_sym_inttoptr] = ACTIONS(279),
    [anon_sym_ptrtoint] = ACTIONS(279),
  },
  [555] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(359),
    [sym_local_var] = ACTIONS(359),
    [sym_string] = ACTIONS(359),
    [aux_sym_number_token1] = ACTIONS(361),
    [aux_sym_number_token2] = ACTIONS(359),
    [sym_float] = ACTIONS(359),
    [sym_cstring] = ACTIONS(359),
    [anon_sym_no_cfi] = ACTIONS(359),
    [anon_sym_private] = ACTIONS(359),
    [anon_sym_internal] = ACTIONS(359),
    [anon_sym_weak] = ACTIONS(361),
    [anon_sym_weak_odr] = ACTIONS(359),
    [anon_sym_linkonce] = ACTIONS(361),
    [anon_sym_linkonce_odr] = ACTIONS(359),
    [anon_sym_available_externally] = ACTIONS(359),
    [anon_sym_appending] = ACTIONS(359),
    [anon_sym_common] = ACTIONS(359),
    [anon_sym_extern_weak] = ACTIONS(359),
    [anon_sym_external] = ACTIONS(359),
    [anon_sym_dso_local] = ACTIONS(361),
    [anon_sym_dso_local_equivalent] = ACTIONS(359),
    [anon_sym_dso_preemptable] = ACTIONS(359),
    [anon_sym_default] = ACTIONS(359),
    [anon_sym_hidden] = ACTIONS(359),
    [anon_sym_protected] = ACTIONS(359),
    [anon_sym_dllimport] = ACTIONS(359),
    [anon_sym_dllexport] = ACTIONS(359),
    [anon_sym_STAR] = ACTIONS(359),
    [anon_sym_LBRACE] = ACTIONS(359),
    [anon_sym_LT_LBRACE] = ACTIONS(359),
    [anon_sym_RBRACE_GT] = ACTIONS(359),
    [anon_sym_LBRACK] = ACTIONS(359),
    [anon_sym_LT] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(359),
    [anon_sym_addrspace] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(359),
    [anon_sym_none] = ACTIONS(359),
    [anon_sym_extractelement] = ACTIONS(359),
    [anon_sym_insertelement] = ACTIONS(359),
    [anon_sym_select] = ACTIONS(359),
    [anon_sym_shufflevector] = ACTIONS(359),
    [anon_sym_fneg] = ACTIONS(359),
    [anon_sym_icmp] = ACTIONS(359),
    [anon_sym_fcmp] = ACTIONS(359),
    [anon_sym_getelementptr] = ACTIONS(359),
    [anon_sym_extractvalue] = ACTIONS(359),
    [anon_sym_insertvalue] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(359),
    [anon_sym_false] = ACTIONS(359),
    [anon_sym_null] = ACTIONS(359),
    [anon_sym_undef] = ACTIONS(359),
    [anon_sym_poison] = ACTIONS(359),
    [anon_sym_zeroinitializer] = ACTIONS(359),
    [anon_sym_blockaddress] = ACTIONS(359),
    [anon_sym_mul] = ACTIONS(359),
    [anon_sym_urem] = ACTIONS(359),
    [anon_sym_srem] = ACTIONS(359),
    [anon_sym_shl] = ACTIONS(359),
    [anon_sym_udiv] = ACTIONS(359),
    [anon_sym_sdiv] = ACTIONS(359),
    [anon_sym_lshr] = ACTIONS(359),
    [anon_sym_ashr] = ACTIONS(359),
    [anon_sym_fmul] = ACTIONS(359),
    [anon_sym_fdiv] = ACTIONS(359),
    [anon_sym_frem] = ACTIONS(359),
    [anon_sym_xchg] = ACTIONS(359),
    [anon_sym_add] = ACTIONS(361),
    [anon_sym_sub] = ACTIONS(359),
    [anon_sym_and] = ACTIONS(359),
    [anon_sym_nand] = ACTIONS(359),
    [anon_sym_or] = ACTIONS(359),
    [anon_sym_xor] = ACTIONS(359),
    [anon_sym_max] = ACTIONS(359),
    [anon_sym_min] = ACTIONS(359),
    [anon_sym_umax] = ACTIONS(359),
    [anon_sym_umin] = ACTIONS(359),
    [anon_sym_fadd] = ACTIONS(359),
    [anon_sym_fsub] = ACTIONS(359),
    [anon_sym_bitcast] = ACTIONS(359),
    [anon_sym_trunc] = ACTIONS(359),
    [anon_sym_zext] = ACTIONS(359),
    [anon_sym_sext] = ACTIONS(359),
    [anon_sym_fptrunc] = ACTIONS(359),
    [anon_sym_fpext] = ACTIONS(359),
    [anon_sym_addrspacecast] = ACTIONS(359),
    [anon_sym_uitofp] = ACTIONS(359),
    [anon_sym_sitofp] = ACTIONS(359),
    [anon_sym_fptoui] = ACTIONS(359),
    [anon_sym_fptosi] = ACTIONS(359),
    [anon_sym_inttoptr] = ACTIONS(359),
    [anon_sym_ptrtoint] = ACTIONS(359),
  },
  [556] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(250),
    [sym_local_var] = ACTIONS(250),
    [sym_string] = ACTIONS(250),
    [aux_sym_number_token1] = ACTIONS(252),
    [aux_sym_number_token2] = ACTIONS(250),
    [sym_float] = ACTIONS(250),
    [sym_cstring] = ACTIONS(250),
    [anon_sym_no_cfi] = ACTIONS(250),
    [anon_sym_private] = ACTIONS(250),
    [anon_sym_internal] = ACTIONS(250),
    [anon_sym_weak] = ACTIONS(252),
    [anon_sym_weak_odr] = ACTIONS(250),
    [anon_sym_linkonce] = ACTIONS(252),
    [anon_sym_linkonce_odr] = ACTIONS(250),
    [anon_sym_available_externally] = ACTIONS(250),
    [anon_sym_appending] = ACTIONS(250),
    [anon_sym_common] = ACTIONS(250),
    [anon_sym_extern_weak] = ACTIONS(250),
    [anon_sym_external] = ACTIONS(250),
    [anon_sym_dso_local] = ACTIONS(252),
    [anon_sym_dso_local_equivalent] = ACTIONS(250),
    [anon_sym_dso_preemptable] = ACTIONS(250),
    [anon_sym_default] = ACTIONS(250),
    [anon_sym_hidden] = ACTIONS(250),
    [anon_sym_protected] = ACTIONS(250),
    [anon_sym_dllimport] = ACTIONS(250),
    [anon_sym_dllexport] = ACTIONS(250),
    [anon_sym_STAR] = ACTIONS(250),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_LT_LBRACE] = ACTIONS(250),
    [anon_sym_RBRACE_GT] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(252),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_addrspace] = ACTIONS(252),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_none] = ACTIONS(250),
    [anon_sym_extractelement] = ACTIONS(250),
    [anon_sym_insertelement] = ACTIONS(250),
    [anon_sym_select] = ACTIONS(250),
    [anon_sym_shufflevector] = ACTIONS(250),
    [anon_sym_fneg] = ACTIONS(250),
    [anon_sym_icmp] = ACTIONS(250),
    [anon_sym_fcmp] = ACTIONS(250),
    [anon_sym_getelementptr] = ACTIONS(250),
    [anon_sym_extractvalue] = ACTIONS(250),
    [anon_sym_insertvalue] = ACTIONS(250),
    [anon_sym_true] = ACTIONS(250),
    [anon_sym_false] = ACTIONS(250),
    [anon_sym_null] = ACTIONS(250),
    [anon_sym_undef] = ACTIONS(250),
    [anon_sym_poison] = ACTIONS(250),
    [anon_sym_zeroinitializer] = ACTIONS(250),
    [anon_sym_blockaddress] = ACTIONS(250),
    [anon_sym_mul] = ACTIONS(250),
    [anon_sym_urem] = ACTIONS(250),
    [anon_sym_srem] = ACTIONS(250),
    [anon_sym_shl] = ACTIONS(250),
    [anon_sym_udiv] = ACTIONS(250),
    [anon_sym_sdiv] = ACTIONS(250),
    [anon_sym_lshr] = ACTIONS(250),
    [anon_sym_ashr] = ACTIONS(250),
    [anon_sym_fmul] = ACTIONS(250),
    [anon_sym_fdiv] = ACTIONS(250),
    [anon_sym_frem] = ACTIONS(250),
    [anon_sym_xchg] = ACTIONS(250),
    [anon_sym_add] = ACTIONS(252),
    [anon_sym_sub] = ACTIONS(250),
    [anon_sym_and] = ACTIONS(250),
    [anon_sym_nand] = ACTIONS(250),
    [anon_sym_or] = ACTIONS(250),
    [anon_sym_xor] = ACTIONS(250),
    [anon_sym_max] = ACTIONS(250),
    [anon_sym_min] = ACTIONS(250),
    [anon_sym_umax] = ACTIONS(250),
    [anon_sym_umin] = ACTIONS(250),
    [anon_sym_fadd] = ACTIONS(250),
    [anon_sym_fsub] = ACTIONS(250),
    [anon_sym_bitcast] = ACTIONS(250),
    [anon_sym_trunc] = ACTIONS(250),
    [anon_sym_zext] = ACTIONS(250),
    [anon_sym_sext] = ACTIONS(250),
    [anon_sym_fptrunc] = ACTIONS(250),
    [anon_sym_fpext] = ACTIONS(250),
    [anon_sym_addrspacecast] = ACTIONS(250),
    [anon_sym_uitofp] = ACTIONS(250),
    [anon_sym_sitofp] = ACTIONS(250),
    [anon_sym_fptoui] = ACTIONS(250),
    [anon_sym_fptosi] = ACTIONS(250),
    [anon_sym_inttoptr] = ACTIONS(250),
    [anon_sym_ptrtoint] = ACTIONS(250),
  },
  [557] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(379),
    [sym_local_var] = ACTIONS(379),
    [sym_string] = ACTIONS(379),
    [aux_sym_number_token1] = ACTIONS(381),
    [aux_sym_number_token2] = ACTIONS(379),
    [sym_float] = ACTIONS(379),
    [sym_cstring] = ACTIONS(379),
    [anon_sym_no_cfi] = ACTIONS(379),
    [anon_sym_private] = ACTIONS(379),
    [anon_sym_internal] = ACTIONS(379),
    [anon_sym_weak] = ACTIONS(381),
    [anon_sym_weak_odr] = ACTIONS(379),
    [anon_sym_linkonce] = ACTIONS(381),
    [anon_sym_linkonce_odr] = ACTIONS(379),
    [anon_sym_available_externally] = ACTIONS(379),
    [anon_sym_appending] = ACTIONS(379),
    [anon_sym_common] = ACTIONS(379),
    [anon_sym_extern_weak] = ACTIONS(379),
    [anon_sym_external] = ACTIONS(379),
    [anon_sym_dso_local] = ACTIONS(381),
    [anon_sym_dso_local_equivalent] = ACTIONS(379),
    [anon_sym_dso_preemptable] = ACTIONS(379),
    [anon_sym_default] = ACTIONS(379),
    [anon_sym_hidden] = ACTIONS(379),
    [anon_sym_protected] = ACTIONS(379),
    [anon_sym_dllimport] = ACTIONS(379),
    [anon_sym_dllexport] = ACTIONS(379),
    [anon_sym_STAR] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_LT_LBRACE] = ACTIONS(379),
    [anon_sym_RBRACE_GT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(379),
    [anon_sym_addrspace] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_none] = ACTIONS(379),
    [anon_sym_extractelement] = ACTIONS(379),
    [anon_sym_insertelement] = ACTIONS(379),
    [anon_sym_select] = ACTIONS(379),
    [anon_sym_shufflevector] = ACTIONS(379),
    [anon_sym_fneg] = ACTIONS(379),
    [anon_sym_icmp] = ACTIONS(379),
    [anon_sym_fcmp] = ACTIONS(379),
    [anon_sym_getelementptr] = ACTIONS(379),
    [anon_sym_extractvalue] = ACTIONS(379),
    [anon_sym_insertvalue] = ACTIONS(379),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [anon_sym_null] = ACTIONS(379),
    [anon_sym_undef] = ACTIONS(379),
    [anon_sym_poison] = ACTIONS(379),
    [anon_sym_zeroinitializer] = ACTIONS(379),
    [anon_sym_blockaddress] = ACTIONS(379),
    [anon_sym_mul] = ACTIONS(379),
    [anon_sym_urem] = ACTIONS(379),
    [anon_sym_srem] = ACTIONS(379),
    [anon_sym_shl] = ACTIONS(379),
    [anon_sym_udiv] = ACTIONS(379),
    [anon_sym_sdiv] = ACTIONS(379),
    [anon_sym_lshr] = ACTIONS(379),
    [anon_sym_ashr] = ACTIONS(379),
    [anon_sym_fmul] = ACTIONS(379),
    [anon_sym_fdiv] = ACTIONS(379),
    [anon_sym_frem] = ACTIONS(379),
    [anon_sym_xchg] = ACTIONS(379),
    [anon_sym_add] = ACTIONS(381),
    [anon_sym_sub] = ACTIONS(379),
    [anon_sym_and] = ACTIONS(379),
    [anon_sym_nand] = ACTIONS(379),
    [anon_sym_or] = ACTIONS(379),
    [anon_sym_xor] = ACTIONS(379),
    [anon_sym_max] = ACTIONS(379),
    [anon_sym_min] = ACTIONS(379),
    [anon_sym_umax] = ACTIONS(379),
    [anon_sym_umin] = ACTIONS(379),
    [anon_sym_fadd] = ACTIONS(379),
    [anon_sym_fsub] = ACTIONS(379),
    [anon_sym_bitcast] = ACTIONS(379),
    [anon_sym_trunc] = ACTIONS(379),
    [anon_sym_zext] = ACTIONS(379),
    [anon_sym_sext] = ACTIONS(379),
    [anon_sym_fptrunc] = ACTIONS(379),
    [anon_sym_fpext] = ACTIONS(379),
    [anon_sym_addrspacecast] = ACTIONS(379),
    [anon_sym_uitofp] = ACTIONS(379),
    [anon_sym_sitofp] = ACTIONS(379),
    [anon_sym_fptoui] = ACTIONS(379),
    [anon_sym_fptosi] = ACTIONS(379),
    [anon_sym_inttoptr] = ACTIONS(379),
    [anon_sym_ptrtoint] = ACTIONS(379),
  },
  [558] = {
    [sym_type] = STATE(692),
    [sym_type_keyword] = STATE(260),
    [sym_struct_type] = STATE(260),
    [sym_packed_struct_type] = STATE(260),
    [sym_array_type] = STATE(260),
    [sym_vector_type] = STATE(260),
    [sym_constant_expr] = STATE(427),
    [sym_constant_cast] = STATE(359),
    [sym_constant_getelementptr] = STATE(359),
    [sym_constant_select] = STATE(359),
    [sym_constant_icmp] = STATE(359),
    [sym_constant_fcmp] = STATE(359),
    [sym_constant_extractelement] = STATE(359),
    [sym_constant_insertelement] = STATE(359),
    [sym_constant_shufflevector] = STATE(359),
    [sym_constant_extractvalue] = STATE(359),
    [sym_constant_insertvalue] = STATE(359),
    [sym_constant_fneg] = STATE(359),
    [sym_constant_bin_op] = STATE(359),
    [sym_bin_op_keyword] = STATE(1133),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1924),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(1766),
    [sym_local_var] = ACTIONS(436),
    [anon_sym_void] = ACTIONS(438),
    [anon_sym_half] = ACTIONS(438),
    [anon_sym_bfloat] = ACTIONS(438),
    [anon_sym_float] = ACTIONS(438),
    [anon_sym_double] = ACTIONS(438),
    [anon_sym_x86_fp80] = ACTIONS(438),
    [anon_sym_fp128] = ACTIONS(438),
    [anon_sym_ppc_fp128] = ACTIONS(438),
    [anon_sym_label] = ACTIONS(438),
    [anon_sym_metadata] = ACTIONS(438),
    [anon_sym_x86_mmx] = ACTIONS(438),
    [anon_sym_x86_amx] = ACTIONS(438),
    [anon_sym_token] = ACTIONS(438),
    [anon_sym_opaque] = ACTIONS(438),
    [anon_sym_ptr] = ACTIONS(442),
    [aux_sym_type_keyword_token1] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_LT_LBRACE] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_extractelement] = ACTIONS(335),
    [anon_sym_insertelement] = ACTIONS(337),
    [anon_sym_select] = ACTIONS(339),
    [anon_sym_shufflevector] = ACTIONS(341),
    [anon_sym_fneg] = ACTIONS(343),
    [anon_sym_icmp] = ACTIONS(345),
    [anon_sym_fcmp] = ACTIONS(347),
    [anon_sym_getelementptr] = ACTIONS(349),
    [anon_sym_extractvalue] = ACTIONS(351),
    [anon_sym_insertvalue] = ACTIONS(353),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [559] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(371),
    [sym_local_var] = ACTIONS(371),
    [sym_string] = ACTIONS(371),
    [aux_sym_number_token1] = ACTIONS(373),
    [aux_sym_number_token2] = ACTIONS(371),
    [sym_float] = ACTIONS(371),
    [sym_cstring] = ACTIONS(371),
    [anon_sym_no_cfi] = ACTIONS(371),
    [anon_sym_private] = ACTIONS(371),
    [anon_sym_internal] = ACTIONS(371),
    [anon_sym_weak] = ACTIONS(373),
    [anon_sym_weak_odr] = ACTIONS(371),
    [anon_sym_linkonce] = ACTIONS(373),
    [anon_sym_linkonce_odr] = ACTIONS(371),
    [anon_sym_available_externally] = ACTIONS(371),
    [anon_sym_appending] = ACTIONS(371),
    [anon_sym_common] = ACTIONS(371),
    [anon_sym_extern_weak] = ACTIONS(371),
    [anon_sym_external] = ACTIONS(371),
    [anon_sym_dso_local] = ACTIONS(373),
    [anon_sym_dso_local_equivalent] = ACTIONS(371),
    [anon_sym_dso_preemptable] = ACTIONS(371),
    [anon_sym_default] = ACTIONS(371),
    [anon_sym_hidden] = ACTIONS(371),
    [anon_sym_protected] = ACTIONS(371),
    [anon_sym_dllimport] = ACTIONS(371),
    [anon_sym_dllexport] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_LT_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE_GT] = ACTIONS(371),
    [anon_sym_LBRACK] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_COMMA] = ACTIONS(371),
    [anon_sym_addrspace] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_none] = ACTIONS(371),
    [anon_sym_extractelement] = ACTIONS(371),
    [anon_sym_insertelement] = ACTIONS(371),
    [anon_sym_select] = ACTIONS(371),
    [anon_sym_shufflevector] = ACTIONS(371),
    [anon_sym_fneg] = ACTIONS(371),
    [anon_sym_icmp] = ACTIONS(371),
    [anon_sym_fcmp] = ACTIONS(371),
    [anon_sym_getelementptr] = ACTIONS(371),
    [anon_sym_extractvalue] = ACTIONS(371),
    [anon_sym_insertvalue] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(371),
    [anon_sym_false] = ACTIONS(371),
    [anon_sym_null] = ACTIONS(371),
    [anon_sym_undef] = ACTIONS(371),
    [anon_sym_poison] = ACTIONS(371),
    [anon_sym_zeroinitializer] = ACTIONS(371),
    [anon_sym_blockaddress] = ACTIONS(371),
    [anon_sym_mul] = ACTIONS(371),
    [anon_sym_urem] = ACTIONS(371),
    [anon_sym_srem] = ACTIONS(371),
    [anon_sym_shl] = ACTIONS(371),
    [anon_sym_udiv] = ACTIONS(371),
    [anon_sym_sdiv] = ACTIONS(371),
    [anon_sym_lshr] = ACTIONS(371),
    [anon_sym_ashr] = ACTIONS(371),
    [anon_sym_fmul] = ACTIONS(371),
    [anon_sym_fdiv] = ACTIONS(371),
    [anon_sym_frem] = ACTIONS(371),
    [anon_sym_xchg] = ACTIONS(371),
    [anon_sym_add] = ACTIONS(373),
    [anon_sym_sub] = ACTIONS(371),
    [anon_sym_and] = ACTIONS(371),
    [anon_sym_nand] = ACTIONS(371),
    [anon_sym_or] = ACTIONS(371),
    [anon_sym_xor] = ACTIONS(371),
    [anon_sym_max] = ACTIONS(371),
    [anon_sym_min] = ACTIONS(371),
    [anon_sym_umax] = ACTIONS(371),
    [anon_sym_umin] = ACTIONS(371),
    [anon_sym_fadd] = ACTIONS(371),
    [anon_sym_fsub] = ACTIONS(371),
    [anon_sym_bitcast] = ACTIONS(371),
    [anon_sym_trunc] = ACTIONS(371),
    [anon_sym_zext] = ACTIONS(371),
    [anon_sym_sext] = ACTIONS(371),
    [anon_sym_fptrunc] = ACTIONS(371),
    [anon_sym_fpext] = ACTIONS(371),
    [anon_sym_addrspacecast] = ACTIONS(371),
    [anon_sym_uitofp] = ACTIONS(371),
    [anon_sym_sitofp] = ACTIONS(371),
    [anon_sym_fptoui] = ACTIONS(371),
    [anon_sym_fptosi] = ACTIONS(371),
    [anon_sym_inttoptr] = ACTIONS(371),
    [anon_sym_ptrtoint] = ACTIONS(371),
  },
  [560] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(363),
    [sym_local_var] = ACTIONS(363),
    [sym_string] = ACTIONS(363),
    [aux_sym_number_token1] = ACTIONS(365),
    [aux_sym_number_token2] = ACTIONS(363),
    [sym_float] = ACTIONS(363),
    [sym_cstring] = ACTIONS(363),
    [anon_sym_no_cfi] = ACTIONS(363),
    [anon_sym_private] = ACTIONS(363),
    [anon_sym_internal] = ACTIONS(363),
    [anon_sym_weak] = ACTIONS(365),
    [anon_sym_weak_odr] = ACTIONS(363),
    [anon_sym_linkonce] = ACTIONS(365),
    [anon_sym_linkonce_odr] = ACTIONS(363),
    [anon_sym_available_externally] = ACTIONS(363),
    [anon_sym_appending] = ACTIONS(363),
    [anon_sym_common] = ACTIONS(363),
    [anon_sym_extern_weak] = ACTIONS(363),
    [anon_sym_external] = ACTIONS(363),
    [anon_sym_dso_local] = ACTIONS(365),
    [anon_sym_dso_local_equivalent] = ACTIONS(363),
    [anon_sym_dso_preemptable] = ACTIONS(363),
    [anon_sym_default] = ACTIONS(363),
    [anon_sym_hidden] = ACTIONS(363),
    [anon_sym_protected] = ACTIONS(363),
    [anon_sym_dllimport] = ACTIONS(363),
    [anon_sym_dllexport] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(363),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_LT_LBRACE] = ACTIONS(363),
    [anon_sym_RBRACE_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_LT] = ACTIONS(365),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_addrspace] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_none] = ACTIONS(363),
    [anon_sym_extractelement] = ACTIONS(363),
    [anon_sym_insertelement] = ACTIONS(363),
    [anon_sym_select] = ACTIONS(363),
    [anon_sym_shufflevector] = ACTIONS(363),
    [anon_sym_fneg] = ACTIONS(363),
    [anon_sym_icmp] = ACTIONS(363),
    [anon_sym_fcmp] = ACTIONS(363),
    [anon_sym_getelementptr] = ACTIONS(363),
    [anon_sym_extractvalue] = ACTIONS(363),
    [anon_sym_insertvalue] = ACTIONS(363),
    [anon_sym_true] = ACTIONS(363),
    [anon_sym_false] = ACTIONS(363),
    [anon_sym_null] = ACTIONS(363),
    [anon_sym_undef] = ACTIONS(363),
    [anon_sym_poison] = ACTIONS(363),
    [anon_sym_zeroinitializer] = ACTIONS(363),
    [anon_sym_blockaddress] = ACTIONS(363),
    [anon_sym_mul] = ACTIONS(363),
    [anon_sym_urem] = ACTIONS(363),
    [anon_sym_srem] = ACTIONS(363),
    [anon_sym_shl] = ACTIONS(363),
    [anon_sym_udiv] = ACTIONS(363),
    [anon_sym_sdiv] = ACTIONS(363),
    [anon_sym_lshr] = ACTIONS(363),
    [anon_sym_ashr] = ACTIONS(363),
    [anon_sym_fmul] = ACTIONS(363),
    [anon_sym_fdiv] = ACTIONS(363),
    [anon_sym_frem] = ACTIONS(363),
    [anon_sym_xchg] = ACTIONS(363),
    [anon_sym_add] = ACTIONS(365),
    [anon_sym_sub] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_nand] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_xor] = ACTIONS(363),
    [anon_sym_max] = ACTIONS(363),
    [anon_sym_min] = ACTIONS(363),
    [anon_sym_umax] = ACTIONS(363),
    [anon_sym_umin] = ACTIONS(363),
    [anon_sym_fadd] = ACTIONS(363),
    [anon_sym_fsub] = ACTIONS(363),
    [anon_sym_bitcast] = ACTIONS(363),
    [anon_sym_trunc] = ACTIONS(363),
    [anon_sym_zext] = ACTIONS(363),
    [anon_sym_sext] = ACTIONS(363),
    [anon_sym_fptrunc] = ACTIONS(363),
    [anon_sym_fpext] = ACTIONS(363),
    [anon_sym_addrspacecast] = ACTIONS(363),
    [anon_sym_uitofp] = ACTIONS(363),
    [anon_sym_sitofp] = ACTIONS(363),
    [anon_sym_fptoui] = ACTIONS(363),
    [anon_sym_fptosi] = ACTIONS(363),
    [anon_sym_inttoptr] = ACTIONS(363),
    [anon_sym_ptrtoint] = ACTIONS(363),
  },
  [561] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(269),
    [sym_local_var] = ACTIONS(269),
    [sym_string] = ACTIONS(269),
    [aux_sym_number_token1] = ACTIONS(271),
    [aux_sym_number_token2] = ACTIONS(269),
    [sym_float] = ACTIONS(269),
    [sym_cstring] = ACTIONS(269),
    [anon_sym_no_cfi] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_internal] = ACTIONS(269),
    [anon_sym_weak] = ACTIONS(271),
    [anon_sym_weak_odr] = ACTIONS(269),
    [anon_sym_linkonce] = ACTIONS(271),
    [anon_sym_linkonce_odr] = ACTIONS(269),
    [anon_sym_available_externally] = ACTIONS(269),
    [anon_sym_appending] = ACTIONS(269),
    [anon_sym_common] = ACTIONS(269),
    [anon_sym_extern_weak] = ACTIONS(269),
    [anon_sym_external] = ACTIONS(269),
    [anon_sym_dso_local] = ACTIONS(271),
    [anon_sym_dso_local_equivalent] = ACTIONS(269),
    [anon_sym_dso_preemptable] = ACTIONS(269),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_hidden] = ACTIONS(269),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_dllimport] = ACTIONS(269),
    [anon_sym_dllexport] = ACTIONS(269),
    [anon_sym_STAR] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(269),
    [anon_sym_LT_LBRACE] = ACTIONS(269),
    [anon_sym_RBRACE_GT] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(269),
    [anon_sym_LT] = ACTIONS(271),
    [anon_sym_COMMA] = ACTIONS(269),
    [anon_sym_addrspace] = ACTIONS(271),
    [anon_sym_LPAREN] = ACTIONS(269),
    [anon_sym_none] = ACTIONS(269),
    [anon_sym_extractelement] = ACTIONS(269),
    [anon_sym_insertelement] = ACTIONS(269),
    [anon_sym_select] = ACTIONS(269),
    [anon_sym_shufflevector] = ACTIONS(269),
    [anon_sym_fneg] = ACTIONS(269),
    [anon_sym_icmp] = ACTIONS(269),
    [anon_sym_fcmp] = ACTIONS(269),
    [anon_sym_getelementptr] = ACTIONS(269),
    [anon_sym_extractvalue] = ACTIONS(269),
    [anon_sym_insertvalue] = ACTIONS(269),
    [anon_sym_true] = ACTIONS(269),
    [anon_sym_false] = ACTIONS(269),
    [anon_sym_null] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(269),
    [anon_sym_poison] = ACTIONS(269),
    [anon_sym_zeroinitializer] = ACTIONS(269),
    [anon_sym_blockaddress] = ACTIONS(269),
    [anon_sym_mul] = ACTIONS(269),
    [anon_sym_urem] = ACTIONS(269),
    [anon_sym_srem] = ACTIONS(269),
    [anon_sym_shl] = ACTIONS(269),
    [anon_sym_udiv] = ACTIONS(269),
    [anon_sym_sdiv] = ACTIONS(269),
    [anon_sym_lshr] = ACTIONS(269),
    [anon_sym_ashr] = ACTIONS(269),
    [anon_sym_fmul] = ACTIONS(269),
    [anon_sym_fdiv] = ACTIONS(269),
    [anon_sym_frem] = ACTIONS(269),
    [anon_sym_xchg] = ACTIONS(269),
    [anon_sym_add] = ACTIONS(271),
    [anon_sym_sub] = ACTIONS(269),
    [anon_sym_and] = ACTIONS(269),
    [anon_sym_nand] = ACTIONS(269),
    [anon_sym_or] = ACTIONS(269),
    [anon_sym_xor] = ACTIONS(269),
    [anon_sym_max] = ACTIONS(269),
    [anon_sym_min] = ACTIONS(269),
    [anon_sym_umax] = ACTIONS(269),
    [anon_sym_umin] = ACTIONS(269),
    [anon_sym_fadd] = ACTIONS(269),
    [anon_sym_fsub] = ACTIONS(269),
    [anon_sym_bitcast] = ACTIONS(269),
    [anon_sym_trunc] = ACTIONS(269),
    [anon_sym_zext] = ACTIONS(269),
    [anon_sym_sext] = ACTIONS(269),
    [anon_sym_fptrunc] = ACTIONS(269),
    [anon_sym_fpext] = ACTIONS(269),
    [anon_sym_addrspacecast] = ACTIONS(269),
    [anon_sym_uitofp] = ACTIONS(269),
    [anon_sym_sitofp] = ACTIONS(269),
    [anon_sym_fptoui] = ACTIONS(269),
    [anon_sym_fptosi] = ACTIONS(269),
    [anon_sym_inttoptr] = ACTIONS(269),
    [anon_sym_ptrtoint] = ACTIONS(269),
  },
  [562] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(375),
    [sym_local_var] = ACTIONS(375),
    [sym_string] = ACTIONS(375),
    [aux_sym_number_token1] = ACTIONS(377),
    [aux_sym_number_token2] = ACTIONS(375),
    [sym_float] = ACTIONS(375),
    [sym_cstring] = ACTIONS(375),
    [anon_sym_no_cfi] = ACTIONS(375),
    [anon_sym_private] = ACTIONS(375),
    [anon_sym_internal] = ACTIONS(375),
    [anon_sym_weak] = ACTIONS(377),
    [anon_sym_weak_odr] = ACTIONS(375),
    [anon_sym_linkonce] = ACTIONS(377),
    [anon_sym_linkonce_odr] = ACTIONS(375),
    [anon_sym_available_externally] = ACTIONS(375),
    [anon_sym_appending] = ACTIONS(375),
    [anon_sym_common] = ACTIONS(375),
    [anon_sym_extern_weak] = ACTIONS(375),
    [anon_sym_external] = ACTIONS(375),
    [anon_sym_dso_local] = ACTIONS(377),
    [anon_sym_dso_local_equivalent] = ACTIONS(375),
    [anon_sym_dso_preemptable] = ACTIONS(375),
    [anon_sym_default] = ACTIONS(375),
    [anon_sym_hidden] = ACTIONS(375),
    [anon_sym_protected] = ACTIONS(375),
    [anon_sym_dllimport] = ACTIONS(375),
    [anon_sym_dllexport] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(375),
    [anon_sym_LT_LBRACE] = ACTIONS(375),
    [anon_sym_RBRACE_GT] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_COMMA] = ACTIONS(375),
    [anon_sym_addrspace] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_none] = ACTIONS(375),
    [anon_sym_extractelement] = ACTIONS(375),
    [anon_sym_insertelement] = ACTIONS(375),
    [anon_sym_select] = ACTIONS(375),
    [anon_sym_shufflevector] = ACTIONS(375),
    [anon_sym_fneg] = ACTIONS(375),
    [anon_sym_icmp] = ACTIONS(375),
    [anon_sym_fcmp] = ACTIONS(375),
    [anon_sym_getelementptr] = ACTIONS(375),
    [anon_sym_extractvalue] = ACTIONS(375),
    [anon_sym_insertvalue] = ACTIONS(375),
    [anon_sym_true] = ACTIONS(375),
    [anon_sym_false] = ACTIONS(375),
    [anon_sym_null] = ACTIONS(375),
    [anon_sym_undef] = ACTIONS(375),
    [anon_sym_poison] = ACTIONS(375),
    [anon_sym_zeroinitializer] = ACTIONS(375),
    [anon_sym_blockaddress] = ACTIONS(375),
    [anon_sym_mul] = ACTIONS(375),
    [anon_sym_urem] = ACTIONS(375),
    [anon_sym_srem] = ACTIONS(375),
    [anon_sym_shl] = ACTIONS(375),
    [anon_sym_udiv] = ACTIONS(375),
    [anon_sym_sdiv] = ACTIONS(375),
    [anon_sym_lshr] = ACTIONS(375),
    [anon_sym_ashr] = ACTIONS(375),
    [anon_sym_fmul] = ACTIONS(375),
    [anon_sym_fdiv] = ACTIONS(375),
    [anon_sym_frem] = ACTIONS(375),
    [anon_sym_xchg] = ACTIONS(375),
    [anon_sym_add] = ACTIONS(377),
    [anon_sym_sub] = ACTIONS(375),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_nand] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_xor] = ACTIONS(375),
    [anon_sym_max] = ACTIONS(375),
    [anon_sym_min] = ACTIONS(375),
    [anon_sym_umax] = ACTIONS(375),
    [anon_sym_umin] = ACTIONS(375),
    [anon_sym_fadd] = ACTIONS(375),
    [anon_sym_fsub] = ACTIONS(375),
    [anon_sym_bitcast] = ACTIONS(375),
    [anon_sym_trunc] = ACTIONS(375),
    [anon_sym_zext] = ACTIONS(375),
    [anon_sym_sext] = ACTIONS(375),
    [anon_sym_fptrunc] = ACTIONS(375),
    [anon_sym_fpext] = ACTIONS(375),
    [anon_sym_addrspacecast] = ACTIONS(375),
    [anon_sym_uitofp] = ACTIONS(375),
    [anon_sym_sitofp] = ACTIONS(375),
    [anon_sym_fptoui] = ACTIONS(375),
    [anon_sym_fptosi] = ACTIONS(375),
    [anon_sym_inttoptr] = ACTIONS(375),
    [anon_sym_ptrtoint] = ACTIONS(375),
  },
  [563] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(391),
    [sym_local_var] = ACTIONS(391),
    [sym_string] = ACTIONS(391),
    [aux_sym_number_token1] = ACTIONS(393),
    [aux_sym_number_token2] = ACTIONS(391),
    [sym_float] = ACTIONS(391),
    [sym_cstring] = ACTIONS(391),
    [anon_sym_no_cfi] = ACTIONS(391),
    [anon_sym_private] = ACTIONS(391),
    [anon_sym_internal] = ACTIONS(391),
    [anon_sym_weak] = ACTIONS(393),
    [anon_sym_weak_odr] = ACTIONS(391),
    [anon_sym_linkonce] = ACTIONS(393),
    [anon_sym_linkonce_odr] = ACTIONS(391),
    [anon_sym_available_externally] = ACTIONS(391),
    [anon_sym_appending] = ACTIONS(391),
    [anon_sym_common] = ACTIONS(391),
    [anon_sym_extern_weak] = ACTIONS(391),
    [anon_sym_external] = ACTIONS(391),
    [anon_sym_dso_local] = ACTIONS(393),
    [anon_sym_dso_local_equivalent] = ACTIONS(391),
    [anon_sym_dso_preemptable] = ACTIONS(391),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_hidden] = ACTIONS(391),
    [anon_sym_protected] = ACTIONS(391),
    [anon_sym_dllimport] = ACTIONS(391),
    [anon_sym_dllexport] = ACTIONS(391),
    [anon_sym_STAR] = ACTIONS(391),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_LT_LBRACE] = ACTIONS(391),
    [anon_sym_RBRACE_GT] = ACTIONS(391),
    [anon_sym_LBRACK] = ACTIONS(391),
    [anon_sym_LT] = ACTIONS(393),
    [anon_sym_COMMA] = ACTIONS(391),
    [anon_sym_none] = ACTIONS(391),
    [anon_sym_extractelement] = ACTIONS(391),
    [anon_sym_insertelement] = ACTIONS(391),
    [anon_sym_select] = ACTIONS(391),
    [anon_sym_shufflevector] = ACTIONS(391),
    [anon_sym_fneg] = ACTIONS(391),
    [anon_sym_icmp] = ACTIONS(391),
    [anon_sym_fcmp] = ACTIONS(391),
    [anon_sym_getelementptr] = ACTIONS(391),
    [anon_sym_extractvalue] = ACTIONS(391),
    [anon_sym_insertvalue] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(391),
    [anon_sym_false] = ACTIONS(391),
    [anon_sym_null] = ACTIONS(391),
    [anon_sym_undef] = ACTIONS(391),
    [anon_sym_poison] = ACTIONS(391),
    [anon_sym_zeroinitializer] = ACTIONS(391),
    [anon_sym_blockaddress] = ACTIONS(391),
    [anon_sym_mul] = ACTIONS(391),
    [anon_sym_urem] = ACTIONS(391),
    [anon_sym_srem] = ACTIONS(391),
    [anon_sym_shl] = ACTIONS(391),
    [anon_sym_udiv] = ACTIONS(391),
    [anon_sym_sdiv] = ACTIONS(391),
    [anon_sym_lshr] = ACTIONS(391),
    [anon_sym_ashr] = ACTIONS(391),
    [anon_sym_fmul] = ACTIONS(391),
    [anon_sym_fdiv] = ACTIONS(391),
    [anon_sym_frem] = ACTIONS(391),
    [anon_sym_xchg] = ACTIONS(391),
    [anon_sym_add] = ACTIONS(393),
    [anon_sym_sub] = ACTIONS(391),
    [anon_sym_and] = ACTIONS(391),
    [anon_sym_nand] = ACTIONS(391),
    [anon_sym_or] = ACTIONS(391),
    [anon_sym_xor] = ACTIONS(391),
    [anon_sym_max] = ACTIONS(391),
    [anon_sym_min] = ACTIONS(391),
    [anon_sym_umax] = ACTIONS(391),
    [anon_sym_umin] = ACTIONS(391),
    [anon_sym_fadd] = ACTIONS(391),
    [anon_sym_fsub] = ACTIONS(391),
    [anon_sym_bitcast] = ACTIONS(391),
    [anon_sym_trunc] = ACTIONS(391),
    [anon_sym_zext] = ACTIONS(391),
    [anon_sym_sext] = ACTIONS(391),
    [anon_sym_fptrunc] = ACTIONS(391),
    [anon_sym_fpext] = ACTIONS(391),
    [anon_sym_addrspacecast] = ACTIONS(391),
    [anon_sym_uitofp] = ACTIONS(391),
    [anon_sym_sitofp] = ACTIONS(391),
    [anon_sym_fptoui] = ACTIONS(391),
    [anon_sym_fptosi] = ACTIONS(391),
    [anon_sym_inttoptr] = ACTIONS(391),
    [anon_sym_ptrtoint] = ACTIONS(391),
  },
  [564] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(395),
    [sym_local_var] = ACTIONS(395),
    [sym_string] = ACTIONS(395),
    [aux_sym_number_token1] = ACTIONS(397),
    [aux_sym_number_token2] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_cstring] = ACTIONS(395),
    [anon_sym_no_cfi] = ACTIONS(395),
    [anon_sym_private] = ACTIONS(395),
    [anon_sym_internal] = ACTIONS(395),
    [anon_sym_weak] = ACTIONS(397),
    [anon_sym_weak_odr] = ACTIONS(395),
    [anon_sym_linkonce] = ACTIONS(397),
    [anon_sym_linkonce_odr] = ACTIONS(395),
    [anon_sym_available_externally] = ACTIONS(395),
    [anon_sym_appending] = ACTIONS(395),
    [anon_sym_common] = ACTIONS(395),
    [anon_sym_extern_weak] = ACTIONS(395),
    [anon_sym_external] = ACTIONS(395),
    [anon_sym_dso_local] = ACTIONS(397),
    [anon_sym_dso_local_equivalent] = ACTIONS(395),
    [anon_sym_dso_preemptable] = ACTIONS(395),
    [anon_sym_default] = ACTIONS(395),
    [anon_sym_hidden] = ACTIONS(395),
    [anon_sym_protected] = ACTIONS(395),
    [anon_sym_dllimport] = ACTIONS(395),
    [anon_sym_dllexport] = ACTIONS(395),
    [anon_sym_STAR] = ACTIONS(1768),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_LT_LBRACE] = ACTIONS(395),
    [anon_sym_RBRACE_GT] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(395),
    [anon_sym_LT] = ACTIONS(397),
    [anon_sym_COMMA] = ACTIONS(395),
    [anon_sym_none] = ACTIONS(395),
    [anon_sym_extractelement] = ACTIONS(395),
    [anon_sym_insertelement] = ACTIONS(395),
    [anon_sym_select] = ACTIONS(395),
    [anon_sym_shufflevector] = ACTIONS(395),
    [anon_sym_fneg] = ACTIONS(395),
    [anon_sym_icmp] = ACTIONS(395),
    [anon_sym_fcmp] = ACTIONS(395),
    [anon_sym_getelementptr] = ACTIONS(395),
    [anon_sym_extractvalue] = ACTIONS(395),
    [anon_sym_insertvalue] = ACTIONS(395),
    [anon_sym_true] = ACTIONS(395),
    [anon_sym_false] = ACTIONS(395),
    [anon_sym_null] = ACTIONS(395),
    [anon_sym_undef] = ACTIONS(395),
    [anon_sym_poison] = ACTIONS(395),
    [anon_sym_zeroinitializer] = ACTIONS(395),
    [anon_sym_blockaddress] = ACTIONS(395),
    [anon_sym_mul] = ACTIONS(395),
    [anon_sym_urem] = ACTIONS(395),
    [anon_sym_srem] = ACTIONS(395),
    [anon_sym_shl] = ACTIONS(395),
    [anon_sym_udiv] = ACTIONS(395),
    [anon_sym_sdiv] = ACTIONS(395),
    [anon_sym_lshr] = ACTIONS(395),
    [anon_sym_ashr] = ACTIONS(395),
    [anon_sym_fmul] = ACTIONS(395),
    [anon_sym_fdiv] = ACTIONS(395),
    [anon_sym_frem] = ACTIONS(395),
    [anon_sym_xchg] = ACTIONS(395),
    [anon_sym_add] = ACTIONS(397),
    [anon_sym_sub] = ACTIONS(395),
    [anon_sym_and] = ACTIONS(395),
    [anon_sym_nand] = ACTIONS(395),
    [anon_sym_or] = ACTIONS(395),
    [anon_sym_xor] = ACTIONS(395),
    [anon_sym_max] = ACTIONS(395),
    [anon_sym_min] = ACTIONS(395),
    [anon_sym_umax] = ACTIONS(395),
    [anon_sym_umin] = ACTIONS(395),
    [anon_sym_fadd] = ACTIONS(395),
    [anon_sym_fsub] = ACTIONS(395),
    [anon_sym_bitcast] = ACTIONS(395),
    [anon_sym_trunc] = ACTIONS(395),
    [anon_sym_zext] = ACTIONS(395),
    [anon_sym_sext] = ACTIONS(395),
    [anon_sym_fptrunc] = ACTIONS(395),
    [anon_sym_fpext] = ACTIONS(395),
    [anon_sym_addrspacecast] = ACTIONS(395),
    [anon_sym_uitofp] = ACTIONS(395),
    [anon_sym_sitofp] = ACTIONS(395),
    [anon_sym_fptoui] = ACTIONS(395),
    [anon_sym_fptosi] = ACTIONS(395),
    [anon_sym_inttoptr] = ACTIONS(395),
    [anon_sym_ptrtoint] = ACTIONS(395),
  },
  [565] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(263),
    [sym_local_var] = ACTIONS(263),
    [sym_string] = ACTIONS(263),
    [aux_sym_number_token1] = ACTIONS(265),
    [aux_sym_number_token2] = ACTIONS(263),
    [sym_float] = ACTIONS(263),
    [sym_cstring] = ACTIONS(263),
    [anon_sym_no_cfi] = ACTIONS(263),
    [anon_sym_private] = ACTIONS(263),
    [anon_sym_internal] = ACTIONS(263),
    [anon_sym_weak] = ACTIONS(265),
    [anon_sym_weak_odr] = ACTIONS(263),
    [anon_sym_linkonce] = ACTIONS(265),
    [anon_sym_linkonce_odr] = ACTIONS(263),
    [anon_sym_available_externally] = ACTIONS(263),
    [anon_sym_appending] = ACTIONS(263),
    [anon_sym_common] = ACTIONS(263),
    [anon_sym_extern_weak] = ACTIONS(263),
    [anon_sym_external] = ACTIONS(263),
    [anon_sym_dso_local] = ACTIONS(265),
    [anon_sym_dso_local_equivalent] = ACTIONS(263),
    [anon_sym_dso_preemptable] = ACTIONS(263),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_hidden] = ACTIONS(263),
    [anon_sym_protected] = ACTIONS(263),
    [anon_sym_dllimport] = ACTIONS(263),
    [anon_sym_dllexport] = ACTIONS(263),
    [anon_sym_STAR] = ACTIONS(1768),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_LT_LBRACE] = ACTIONS(263),
    [anon_sym_RBRACE_GT] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(263),
    [anon_sym_LT] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_none] = ACTIONS(263),
    [anon_sym_extractelement] = ACTIONS(263),
    [anon_sym_insertelement] = ACTIONS(263),
    [anon_sym_select] = ACTIONS(263),
    [anon_sym_shufflevector] = ACTIONS(263),
    [anon_sym_fneg] = ACTIONS(263),
    [anon_sym_icmp] = ACTIONS(263),
    [anon_sym_fcmp] = ACTIONS(263),
    [anon_sym_getelementptr] = ACTIONS(263),
    [anon_sym_extractvalue] = ACTIONS(263),
    [anon_sym_insertvalue] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(263),
    [anon_sym_false] = ACTIONS(263),
    [anon_sym_null] = ACTIONS(263),
    [anon_sym_undef] = ACTIONS(263),
    [anon_sym_poison] = ACTIONS(263),
    [anon_sym_zeroinitializer] = ACTIONS(263),
    [anon_sym_blockaddress] = ACTIONS(263),
    [anon_sym_mul] = ACTIONS(263),
    [anon_sym_urem] = ACTIONS(263),
    [anon_sym_srem] = ACTIONS(263),
    [anon_sym_shl] = ACTIONS(263),
    [anon_sym_udiv] = ACTIONS(263),
    [anon_sym_sdiv] = ACTIONS(263),
    [anon_sym_lshr] = ACTIONS(263),
    [anon_sym_ashr] = ACTIONS(263),
    [anon_sym_fmul] = ACTIONS(263),
    [anon_sym_fdiv] = ACTIONS(263),
    [anon_sym_frem] = ACTIONS(263),
    [anon_sym_xchg] = ACTIONS(263),
    [anon_sym_add] = ACTIONS(265),
    [anon_sym_sub] = ACTIONS(263),
    [anon_sym_and] = ACTIONS(263),
    [anon_sym_nand] = ACTIONS(263),
    [anon_sym_or] = ACTIONS(263),
    [anon_sym_xor] = ACTIONS(263),
    [anon_sym_max] = ACTIONS(263),
    [anon_sym_min] = ACTIONS(263),
    [anon_sym_umax] = ACTIONS(263),
    [anon_sym_umin] = ACTIONS(263),
    [anon_sym_fadd] = ACTIONS(263),
    [anon_sym_fsub] = ACTIONS(263),
    [anon_sym_bitcast] = ACTIONS(263),
    [anon_sym_trunc] = ACTIONS(263),
    [anon_sym_zext] = ACTIONS(263),
    [anon_sym_sext] = ACTIONS(263),
    [anon_sym_fptrunc] = ACTIONS(263),
    [anon_sym_fpext] = ACTIONS(263),
    [anon_sym_addrspacecast] = ACTIONS(263),
    [anon_sym_uitofp] = ACTIONS(263),
    [anon_sym_sitofp] = ACTIONS(263),
    [anon_sym_fptoui] = ACTIONS(263),
    [anon_sym_fptosi] = ACTIONS(263),
    [anon_sym_inttoptr] = ACTIONS(263),
    [anon_sym_ptrtoint] = ACTIONS(263),
  },
  [566] = {
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(244),
    [sym_local_var] = ACTIONS(244),
    [sym_string] = ACTIONS(244),
    [aux_sym_number_token1] = ACTIONS(246),
    [aux_sym_number_token2] = ACTIONS(244),
    [sym_float] = ACTIONS(244),
    [sym_cstring] = ACTIONS(244),
    [anon_sym_no_cfi] = ACTIONS(244),
    [anon_sym_private] = ACTIONS(244),
    [anon_sym_internal] = ACTIONS(244),
    [anon_sym_weak] = ACTIONS(246),
    [anon_sym_weak_odr] = ACTIONS(244),
    [anon_sym_linkonce] = ACTIONS(246),
    [anon_sym_linkonce_odr] = ACTIONS(244),
    [anon_sym_available_externally] = ACTIONS(244),
    [anon_sym_appending] = ACTIONS(244),
    [anon_sym_common] = ACTIONS(244),
    [anon_sym_extern_weak] = ACTIONS(244),
    [anon_sym_external] = ACTIONS(244),
    [anon_sym_dso_local] = ACTIONS(246),
    [anon_sym_dso_local_equivalent] = ACTIONS(244),
    [anon_sym_dso_preemptable] = ACTIONS(244),
    [anon_sym_default] = ACTIONS(244),
    [anon_sym_hidden] = ACTIONS(244),
    [anon_sym_protected] = ACTIONS(244),
    [anon_sym_dllimport] = ACTIONS(244),
    [anon_sym_dllexport] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(1768),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_LT_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE_GT] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_none] = ACTIONS(244),
    [anon_sym_extractelement] = ACTIONS(244),
    [anon_sym_insertelement] = ACTIONS(244),
    [anon_sym_select] = ACTIONS(244),
    [anon_sym_shufflevector] = ACTIONS(244),
    [anon_sym_fneg] = ACTIONS(244),
    [anon_sym_icmp] = ACTIONS(244),
    [anon_sym_fcmp] = ACTIONS(244),
    [anon_sym_getelementptr] = ACTIONS(244),
    [anon_sym_extractvalue] = ACTIONS(244),
    [anon_sym_insertvalue] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(244),
    [anon_sym_false] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(244),
    [anon_sym_undef] = ACTIONS(244),
    [anon_sym_poison] = ACTIONS(244),
    [anon_sym_zeroinitializer] = ACTIONS(244),
    [anon_sym_blockaddress] = ACTIONS(244),
    [anon_sym_mul] = ACTIONS(244),
    [anon_sym_urem] = ACTIONS(244),
    [anon_sym_srem] = ACTIONS(244),
    [anon_sym_shl] = ACTIONS(244),
    [anon_sym_udiv] = ACTIONS(244),
    [anon_sym_sdiv] = ACTIONS(244),
    [anon_sym_lshr] = ACTIONS(244),
    [anon_sym_ashr] = ACTIONS(244),
    [anon_sym_fmul] = ACTIONS(244),
    [anon_sym_fdiv] = ACTIONS(244),
    [anon_sym_frem] = ACTIONS(244),
    [anon_sym_xchg] = ACTIONS(244),
    [anon_sym_add] = ACTIONS(246),
    [anon_sym_sub] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(244),
    [anon_sym_nand] = ACTIONS(244),
    [anon_sym_or] = ACTIONS(244),
    [anon_sym_xor] = ACTIONS(244),
    [anon_sym_max] = ACTIONS(244),
    [anon_sym_min] = ACTIONS(244),
    [anon_sym_umax] = ACTIONS(244),
    [anon_sym_umin] = ACTIONS(244),
    [anon_sym_fadd] = ACTIONS(244),
    [anon_sym_fsub] = ACTIONS(244),
    [anon_sym_bitcast] = ACTIONS(244),
    [anon_sym_trunc] = ACTIONS(244),
    [anon_sym_zext] = ACTIONS(244),
    [anon_sym_sext] = ACTIONS(244),
    [anon_sym_fptrunc] = ACTIONS(244),
    [anon_sym_fpext] = ACTIONS(244),
    [anon_sym_addrspacecast] = ACTIONS(244),
    [anon_sym_uitofp] = ACTIONS(244),
    [anon_sym_sitofp] = ACTIONS(244),
    [anon_sym_fptoui] = ACTIONS(244),
    [anon_sym_fptosi] = ACTIONS(244),
    [anon_sym_inttoptr] = ACTIONS(244),
    [anon_sym_ptrtoint] = ACTIONS(244),
  },
  [567] = {
    [sym_atomic_ordering] = STATE(623),
    [sym_syncscope] = STATE(568),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1770),
    [sym_label] = ACTIONS(1770),
    [anon_sym_RBRACE] = ACTIONS(1770),
    [anon_sym_COMMA] = ACTIONS(1772),
    [anon_sym_unreachable] = ACTIONS(1775),
    [anon_sym_ret] = ACTIONS(1775),
    [anon_sym_br] = ACTIONS(1775),
    [anon_sym_resume] = ACTIONS(1775),
    [anon_sym_freeze] = ACTIONS(1775),
    [anon_sym_indirectbr] = ACTIONS(1775),
    [anon_sym_extractelement] = ACTIONS(1775),
    [anon_sym_insertelement] = ACTIONS(1775),
    [anon_sym_select] = ACTIONS(1775),
    [anon_sym_shufflevector] = ACTIONS(1775),
    [anon_sym_fneg] = ACTIONS(1775),
    [anon_sym_switch] = ACTIONS(1775),
    [anon_sym_invoke] = ACTIONS(1775),
    [anon_sym_cleanupret] = ACTIONS(1775),
    [anon_sym_catchret] = ACTIONS(1775),
    [anon_sym_catchswitch] = ACTIONS(1775),
    [anon_sym_catchpad] = ACTIONS(1775),
    [anon_sym_cleanuppad] = ACTIONS(1775),
    [anon_sym_callbr] = ACTIONS(1775),
    [anon_sym_icmp] = ACTIONS(1775),
    [anon_sym_fcmp] = ACTIONS(1775),
    [anon_sym_va_arg] = ACTIONS(1775),
    [anon_sym_phi] = ACTIONS(1775),
    [anon_sym_landingpad] = ACTIONS(1775),
    [anon_sym_tail] = ACTIONS(1775),
    [anon_sym_musttail] = ACTIONS(1775),
    [anon_sym_notail] = ACTIONS(1775),
    [anon_sym_call] = ACTIONS(1775),
    [anon_sym_alloca] = ACTIONS(1775),
    [anon_sym_load] = ACTIONS(1775),
    [anon_sym_store] = ACTIONS(1775),
    [anon_sym_cmpxchg] = ACTIONS(1775),
    [anon_sym_atomicrmw] = ACTIONS(1775),
    [anon_sym_fence] = ACTIONS(1775),
    [anon_sym_getelementptr] = ACTIONS(1775),
    [anon_sym_extractvalue] = ACTIONS(1775),
    [anon_sym_insertvalue] = ACTIONS(1775),
    [anon_sym_mul] = ACTIONS(1775),
    [anon_sym_urem] = ACTIONS(1775),
    [anon_sym_srem] = ACTIONS(1775),
    [anon_sym_shl] = ACTIONS(1775),
    [anon_sym_udiv] = ACTIONS(1775),
    [anon_sym_sdiv] = ACTIONS(1775),
    [anon_sym_lshr] = ACTIONS(1775),
    [anon_sym_ashr] = ACTIONS(1775),
    [anon_sym_fmul] = ACTIONS(1775),
    [anon_sym_fdiv] = ACTIONS(1775),
    [anon_sym_frem] = ACTIONS(1775),
    [anon_sym_xchg] = ACTIONS(1775),
    [anon_sym_add] = ACTIONS(1775),
    [anon_sym_sub] = ACTIONS(1775),
    [anon_sym_and] = ACTIONS(1775),
    [anon_sym_nand] = ACTIONS(1775),
    [anon_sym_or] = ACTIONS(1775),
    [anon_sym_xor] = ACTIONS(1775),
    [anon_sym_max] = ACTIONS(1775),
    [anon_sym_min] = ACTIONS(1775),
    [anon_sym_umax] = ACTIONS(1775),
    [anon_sym_umin] = ACTIONS(1775),
    [anon_sym_fadd] = ACTIONS(1775),
    [anon_sym_fsub] = ACTIONS(1775),
    [anon_sym_bitcast] = ACTIONS(1775),
    [anon_sym_trunc] = ACTIONS(1775),
    [anon_sym_zext] = ACTIONS(1775),
    [anon_sym_sext] = ACTIONS(1775),
    [anon_sym_fptrunc] = ACTIONS(1775),
    [anon_sym_fpext] = ACTIONS(1775),
    [anon_sym_addrspacecast] = ACTIONS(1775),
    [anon_sym_uitofp] = ACTIONS(1775),
    [anon_sym_sitofp] = ACTIONS(1775),
    [anon_sym_fptoui] = ACTIONS(1775),
    [anon_sym_fptosi] = ACTIONS(1775),
    [anon_sym_inttoptr] = ACTIONS(1775),
    [anon_sym_ptrtoint] = ACTIONS(1775),
    [anon_sym_unordered] = ACTIONS(1777),
    [anon_sym_monotonic] = ACTIONS(1777),
    [anon_sym_acquire] = ACTIONS(1777),
    [anon_sym_release] = ACTIONS(1777),
    [anon_sym_acq_rel] = ACTIONS(1777),
    [anon_sym_seq_cst] = ACTIONS(1777),
    [anon_sym_syncscope] = ACTIONS(1779),
    [anon_sym_uselistorder] = ACTIONS(1775),
  },
  [568] = {
    [sym_atomic_ordering] = STATE(649),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1781),
    [sym_label] = ACTIONS(1781),
    [anon_sym_RBRACE] = ACTIONS(1781),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_unreachable] = ACTIONS(1786),
    [anon_sym_ret] = ACTIONS(1786),
    [anon_sym_br] = ACTIONS(1786),
    [anon_sym_resume] = ACTIONS(1786),
    [anon_sym_freeze] = ACTIONS(1786),
    [anon_sym_indirectbr] = ACTIONS(1786),
    [anon_sym_extractelement] = ACTIONS(1786),
    [anon_sym_insertelement] = ACTIONS(1786),
    [anon_sym_select] = ACTIONS(1786),
    [anon_sym_shufflevector] = ACTIONS(1786),
    [anon_sym_fneg] = ACTIONS(1786),
    [anon_sym_switch] = ACTIONS(1786),
    [anon_sym_invoke] = ACTIONS(1786),
    [anon_sym_cleanupret] = ACTIONS(1786),
    [anon_sym_catchret] = ACTIONS(1786),
    [anon_sym_catchswitch] = ACTIONS(1786),
    [anon_sym_catchpad] = ACTIONS(1786),
    [anon_sym_cleanuppad] = ACTIONS(1786),
    [anon_sym_callbr] = ACTIONS(1786),
    [anon_sym_icmp] = ACTIONS(1786),
    [anon_sym_fcmp] = ACTIONS(1786),
    [anon_sym_va_arg] = ACTIONS(1786),
    [anon_sym_phi] = ACTIONS(1786),
    [anon_sym_landingpad] = ACTIONS(1786),
    [anon_sym_tail] = ACTIONS(1786),
    [anon_sym_musttail] = ACTIONS(1786),
    [anon_sym_notail] = ACTIONS(1786),
    [anon_sym_call] = ACTIONS(1786),
    [anon_sym_alloca] = ACTIONS(1786),
    [anon_sym_load] = ACTIONS(1786),
    [anon_sym_store] = ACTIONS(1786),
    [anon_sym_cmpxchg] = ACTIONS(1786),
    [anon_sym_atomicrmw] = ACTIONS(1786),
    [anon_sym_fence] = ACTIONS(1786),
    [anon_sym_getelementptr] = ACTIONS(1786),
    [anon_sym_extractvalue] = ACTIONS(1786),
    [anon_sym_insertvalue] = ACTIONS(1786),
    [anon_sym_mul] = ACTIONS(1786),
    [anon_sym_urem] = ACTIONS(1786),
    [anon_sym_srem] = ACTIONS(1786),
    [anon_sym_shl] = ACTIONS(1786),
    [anon_sym_udiv] = ACTIONS(1786),
    [anon_sym_sdiv] = ACTIONS(1786),
    [anon_sym_lshr] = ACTIONS(1786),
    [anon_sym_ashr] = ACTIONS(1786),
    [anon_sym_fmul] = ACTIONS(1786),
    [anon_sym_fdiv] = ACTIONS(1786),
    [anon_sym_frem] = ACTIONS(1786),
    [anon_sym_xchg] = ACTIONS(1786),
    [anon_sym_add] = ACTIONS(1786),
    [anon_sym_sub] = ACTIONS(1786),
    [anon_sym_and] = ACTIONS(1786),
    [anon_sym_nand] = ACTIONS(1786),
    [anon_sym_or] = ACTIONS(1786),
    [anon_sym_xor] = ACTIONS(1786),
    [anon_sym_max] = ACTIONS(1786),
    [anon_sym_min] = ACTIONS(1786),
    [anon_sym_umax] = ACTIONS(1786),
    [anon_sym_umin] = ACTIONS(1786),
    [anon_sym_fadd] = ACTIONS(1786),
    [anon_sym_fsub] = ACTIONS(1786),
    [anon_sym_bitcast] = ACTIONS(1786),
    [anon_sym_trunc] = ACTIONS(1786),
    [anon_sym_zext] = ACTIONS(1786),
    [anon_sym_sext] = ACTIONS(1786),
    [anon_sym_fptrunc] = ACTIONS(1786),
    [anon_sym_fpext] = ACTIONS(1786),
    [anon_sym_addrspacecast] = ACTIONS(1786),
    [anon_sym_uitofp] = ACTIONS(1786),
    [anon_sym_sitofp] = ACTIONS(1786),
    [anon_sym_fptoui] = ACTIONS(1786),
    [anon_sym_fptosi] = ACTIONS(1786),
    [anon_sym_inttoptr] = ACTIONS(1786),
    [anon_sym_ptrtoint] = ACTIONS(1786),
    [anon_sym_unordered] = ACTIONS(1777),
    [anon_sym_monotonic] = ACTIONS(1777),
    [anon_sym_acquire] = ACTIONS(1777),
    [anon_sym_release] = ACTIONS(1777),
    [anon_sym_acq_rel] = ACTIONS(1777),
    [anon_sym_seq_cst] = ACTIONS(1777),
    [anon_sym_uselistorder] = ACTIONS(1786),
  },
  [569] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1788),
    [sym_label] = ACTIONS(1788),
    [anon_sym_RBRACE] = ACTIONS(1788),
    [anon_sym_COMMA] = ACTIONS(1788),
    [anon_sym_unreachable] = ACTIONS(1790),
    [anon_sym_ret] = ACTIONS(1790),
    [anon_sym_br] = ACTIONS(1790),
    [anon_sym_resume] = ACTIONS(1790),
    [anon_sym_freeze] = ACTIONS(1790),
    [anon_sym_indirectbr] = ACTIONS(1790),
    [anon_sym_extractelement] = ACTIONS(1790),
    [anon_sym_insertelement] = ACTIONS(1790),
    [anon_sym_select] = ACTIONS(1790),
    [anon_sym_shufflevector] = ACTIONS(1790),
    [anon_sym_fneg] = ACTIONS(1790),
    [anon_sym_switch] = ACTIONS(1790),
    [anon_sym_invoke] = ACTIONS(1790),
    [anon_sym_cleanupret] = ACTIONS(1790),
    [anon_sym_catchret] = ACTIONS(1790),
    [anon_sym_catchswitch] = ACTIONS(1790),
    [anon_sym_catchpad] = ACTIONS(1790),
    [anon_sym_cleanuppad] = ACTIONS(1790),
    [anon_sym_callbr] = ACTIONS(1790),
    [anon_sym_icmp] = ACTIONS(1790),
    [anon_sym_fcmp] = ACTIONS(1790),
    [anon_sym_va_arg] = ACTIONS(1790),
    [anon_sym_phi] = ACTIONS(1790),
    [anon_sym_landingpad] = ACTIONS(1790),
    [anon_sym_tail] = ACTIONS(1790),
    [anon_sym_musttail] = ACTIONS(1790),
    [anon_sym_notail] = ACTIONS(1790),
    [anon_sym_call] = ACTIONS(1790),
    [anon_sym_alloca] = ACTIONS(1790),
    [anon_sym_load] = ACTIONS(1790),
    [anon_sym_store] = ACTIONS(1790),
    [anon_sym_cmpxchg] = ACTIONS(1790),
    [anon_sym_atomicrmw] = ACTIONS(1790),
    [anon_sym_fence] = ACTIONS(1790),
    [anon_sym_getelementptr] = ACTIONS(1790),
    [anon_sym_extractvalue] = ACTIONS(1790),
    [anon_sym_insertvalue] = ACTIONS(1790),
    [anon_sym_mul] = ACTIONS(1790),
    [anon_sym_urem] = ACTIONS(1790),
    [anon_sym_srem] = ACTIONS(1790),
    [anon_sym_shl] = ACTIONS(1790),
    [anon_sym_udiv] = ACTIONS(1790),
    [anon_sym_sdiv] = ACTIONS(1790),
    [anon_sym_lshr] = ACTIONS(1790),
    [anon_sym_ashr] = ACTIONS(1790),
    [anon_sym_fmul] = ACTIONS(1790),
    [anon_sym_fdiv] = ACTIONS(1790),
    [anon_sym_frem] = ACTIONS(1790),
    [anon_sym_xchg] = ACTIONS(1790),
    [anon_sym_add] = ACTIONS(1790),
    [anon_sym_sub] = ACTIONS(1790),
    [anon_sym_and] = ACTIONS(1790),
    [anon_sym_nand] = ACTIONS(1790),
    [anon_sym_or] = ACTIONS(1790),
    [anon_sym_xor] = ACTIONS(1790),
    [anon_sym_max] = ACTIONS(1790),
    [anon_sym_min] = ACTIONS(1790),
    [anon_sym_umax] = ACTIONS(1790),
    [anon_sym_umin] = ACTIONS(1790),
    [anon_sym_fadd] = ACTIONS(1790),
    [anon_sym_fsub] = ACTIONS(1790),
    [anon_sym_bitcast] = ACTIONS(1790),
    [anon_sym_trunc] = ACTIONS(1790),
    [anon_sym_zext] = ACTIONS(1790),
    [anon_sym_sext] = ACTIONS(1790),
    [anon_sym_fptrunc] = ACTIONS(1790),
    [anon_sym_fpext] = ACTIONS(1790),
    [anon_sym_addrspacecast] = ACTIONS(1790),
    [anon_sym_uitofp] = ACTIONS(1790),
    [anon_sym_sitofp] = ACTIONS(1790),
    [anon_sym_fptoui] = ACTIONS(1790),
    [anon_sym_fptosi] = ACTIONS(1790),
    [anon_sym_inttoptr] = ACTIONS(1790),
    [anon_sym_ptrtoint] = ACTIONS(1790),
    [anon_sym_unordered] = ACTIONS(1790),
    [anon_sym_monotonic] = ACTIONS(1790),
    [anon_sym_acquire] = ACTIONS(1790),
    [anon_sym_release] = ACTIONS(1790),
    [anon_sym_acq_rel] = ACTIONS(1790),
    [anon_sym_seq_cst] = ACTIONS(1790),
    [anon_sym_uselistorder] = ACTIONS(1790),
  },
  [570] = {
    [sym_landingpad_clause] = STATE(572),
    [aux_sym_instruction_landingpad_repeat1] = STATE(572),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1792),
    [sym_label] = ACTIONS(1792),
    [anon_sym_RBRACE] = ACTIONS(1792),
    [anon_sym_COMMA] = ACTIONS(1792),
    [anon_sym_unreachable] = ACTIONS(1794),
    [anon_sym_ret] = ACTIONS(1794),
    [anon_sym_br] = ACTIONS(1794),
    [anon_sym_resume] = ACTIONS(1794),
    [anon_sym_freeze] = ACTIONS(1794),
    [anon_sym_indirectbr] = ACTIONS(1794),
    [anon_sym_extractelement] = ACTIONS(1794),
    [anon_sym_insertelement] = ACTIONS(1794),
    [anon_sym_select] = ACTIONS(1794),
    [anon_sym_shufflevector] = ACTIONS(1794),
    [anon_sym_fneg] = ACTIONS(1794),
    [anon_sym_switch] = ACTIONS(1794),
    [anon_sym_invoke] = ACTIONS(1794),
    [anon_sym_cleanupret] = ACTIONS(1794),
    [anon_sym_catchret] = ACTIONS(1794),
    [anon_sym_catchswitch] = ACTIONS(1794),
    [anon_sym_catchpad] = ACTIONS(1794),
    [anon_sym_cleanuppad] = ACTIONS(1794),
    [anon_sym_callbr] = ACTIONS(1794),
    [anon_sym_icmp] = ACTIONS(1794),
    [anon_sym_fcmp] = ACTIONS(1794),
    [anon_sym_va_arg] = ACTIONS(1794),
    [anon_sym_phi] = ACTIONS(1794),
    [anon_sym_landingpad] = ACTIONS(1794),
    [anon_sym_tail] = ACTIONS(1794),
    [anon_sym_musttail] = ACTIONS(1794),
    [anon_sym_notail] = ACTIONS(1794),
    [anon_sym_call] = ACTIONS(1794),
    [anon_sym_alloca] = ACTIONS(1794),
    [anon_sym_load] = ACTIONS(1794),
    [anon_sym_store] = ACTIONS(1794),
    [anon_sym_cmpxchg] = ACTIONS(1794),
    [anon_sym_atomicrmw] = ACTIONS(1794),
    [anon_sym_fence] = ACTIONS(1794),
    [anon_sym_getelementptr] = ACTIONS(1794),
    [anon_sym_extractvalue] = ACTIONS(1794),
    [anon_sym_insertvalue] = ACTIONS(1794),
    [anon_sym_catch] = ACTIONS(1796),
    [anon_sym_filter] = ACTIONS(1796),
    [anon_sym_mul] = ACTIONS(1794),
    [anon_sym_urem] = ACTIONS(1794),
    [anon_sym_srem] = ACTIONS(1794),
    [anon_sym_shl] = ACTIONS(1794),
    [anon_sym_udiv] = ACTIONS(1794),
    [anon_sym_sdiv] = ACTIONS(1794),
    [anon_sym_lshr] = ACTIONS(1794),
    [anon_sym_ashr] = ACTIONS(1794),
    [anon_sym_fmul] = ACTIONS(1794),
    [anon_sym_fdiv] = ACTIONS(1794),
    [anon_sym_frem] = ACTIONS(1794),
    [anon_sym_xchg] = ACTIONS(1794),
    [anon_sym_add] = ACTIONS(1794),
    [anon_sym_sub] = ACTIONS(1794),
    [anon_sym_and] = ACTIONS(1794),
    [anon_sym_nand] = ACTIONS(1794),
    [anon_sym_or] = ACTIONS(1794),
    [anon_sym_xor] = ACTIONS(1794),
    [anon_sym_max] = ACTIONS(1794),
    [anon_sym_min] = ACTIONS(1794),
    [anon_sym_umax] = ACTIONS(1794),
    [anon_sym_umin] = ACTIONS(1794),
    [anon_sym_fadd] = ACTIONS(1794),
    [anon_sym_fsub] = ACTIONS(1794),
    [anon_sym_bitcast] = ACTIONS(1794),
    [anon_sym_trunc] = ACTIONS(1794),
    [anon_sym_zext] = ACTIONS(1794),
    [anon_sym_sext] = ACTIONS(1794),
    [anon_sym_fptrunc] = ACTIONS(1794),
    [anon_sym_fpext] = ACTIONS(1794),
    [anon_sym_addrspacecast] = ACTIONS(1794),
    [anon_sym_uitofp] = ACTIONS(1794),
    [anon_sym_sitofp] = ACTIONS(1794),
    [anon_sym_fptoui] = ACTIONS(1794),
    [anon_sym_fptosi] = ACTIONS(1794),
    [anon_sym_inttoptr] = ACTIONS(1794),
    [anon_sym_ptrtoint] = ACTIONS(1794),
    [anon_sym_uselistorder] = ACTIONS(1794),
  },
  [571] = {
    [sym_landingpad_clause] = STATE(571),
    [aux_sym_instruction_landingpad_repeat1] = STATE(571),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1798),
    [sym_label] = ACTIONS(1798),
    [anon_sym_RBRACE] = ACTIONS(1798),
    [anon_sym_COMMA] = ACTIONS(1798),
    [anon_sym_unreachable] = ACTIONS(1800),
    [anon_sym_ret] = ACTIONS(1800),
    [anon_sym_br] = ACTIONS(1800),
    [anon_sym_resume] = ACTIONS(1800),
    [anon_sym_freeze] = ACTIONS(1800),
    [anon_sym_indirectbr] = ACTIONS(1800),
    [anon_sym_extractelement] = ACTIONS(1800),
    [anon_sym_insertelement] = ACTIONS(1800),
    [anon_sym_select] = ACTIONS(1800),
    [anon_sym_shufflevector] = ACTIONS(1800),
    [anon_sym_fneg] = ACTIONS(1800),
    [anon_sym_switch] = ACTIONS(1800),
    [anon_sym_invoke] = ACTIONS(1800),
    [anon_sym_cleanupret] = ACTIONS(1800),
    [anon_sym_catchret] = ACTIONS(1800),
    [anon_sym_catchswitch] = ACTIONS(1800),
    [anon_sym_catchpad] = ACTIONS(1800),
    [anon_sym_cleanuppad] = ACTIONS(1800),
    [anon_sym_callbr] = ACTIONS(1800),
    [anon_sym_icmp] = ACTIONS(1800),
    [anon_sym_fcmp] = ACTIONS(1800),
    [anon_sym_va_arg] = ACTIONS(1800),
    [anon_sym_phi] = ACTIONS(1800),
    [anon_sym_landingpad] = ACTIONS(1800),
    [anon_sym_tail] = ACTIONS(1800),
    [anon_sym_musttail] = ACTIONS(1800),
    [anon_sym_notail] = ACTIONS(1800),
    [anon_sym_call] = ACTIONS(1800),
    [anon_sym_alloca] = ACTIONS(1800),
    [anon_sym_load] = ACTIONS(1800),
    [anon_sym_store] = ACTIONS(1800),
    [anon_sym_cmpxchg] = ACTIONS(1800),
    [anon_sym_atomicrmw] = ACTIONS(1800),
    [anon_sym_fence] = ACTIONS(1800),
    [anon_sym_getelementptr] = ACTIONS(1800),
    [anon_sym_extractvalue] = ACTIONS(1800),
    [anon_sym_insertvalue] = ACTIONS(1800),
    [anon_sym_catch] = ACTIONS(1802),
    [anon_sym_filter] = ACTIONS(1802),
    [anon_sym_mul] = ACTIONS(1800),
    [anon_sym_urem] = ACTIONS(1800),
    [anon_sym_srem] = ACTIONS(1800),
    [anon_sym_shl] = ACTIONS(1800),
    [anon_sym_udiv] = ACTIONS(1800),
    [anon_sym_sdiv] = ACTIONS(1800),
    [anon_sym_lshr] = ACTIONS(1800),
    [anon_sym_ashr] = ACTIONS(1800),
    [anon_sym_fmul] = ACTIONS(1800),
    [anon_sym_fdiv] = ACTIONS(1800),
    [anon_sym_frem] = ACTIONS(1800),
    [anon_sym_xchg] = ACTIONS(1800),
    [anon_sym_add] = ACTIONS(1800),
    [anon_sym_sub] = ACTIONS(1800),
    [anon_sym_and] = ACTIONS(1800),
    [anon_sym_nand] = ACTIONS(1800),
    [anon_sym_or] = ACTIONS(1800),
    [anon_sym_xor] = ACTIONS(1800),
    [anon_sym_max] = ACTIONS(1800),
    [anon_sym_min] = ACTIONS(1800),
    [anon_sym_umax] = ACTIONS(1800),
    [anon_sym_umin] = ACTIONS(1800),
    [anon_sym_fadd] = ACTIONS(1800),
    [anon_sym_fsub] = ACTIONS(1800),
    [anon_sym_bitcast] = ACTIONS(1800),
    [anon_sym_trunc] = ACTIONS(1800),
    [anon_sym_zext] = ACTIONS(1800),
    [anon_sym_sext] = ACTIONS(1800),
    [anon_sym_fptrunc] = ACTIONS(1800),
    [anon_sym_fpext] = ACTIONS(1800),
    [anon_sym_addrspacecast] = ACTIONS(1800),
    [anon_sym_uitofp] = ACTIONS(1800),
    [anon_sym_sitofp] = ACTIONS(1800),
    [anon_sym_fptoui] = ACTIONS(1800),
    [anon_sym_fptosi] = ACTIONS(1800),
    [anon_sym_inttoptr] = ACTIONS(1800),
    [anon_sym_ptrtoint] = ACTIONS(1800),
    [anon_sym_uselistorder] = ACTIONS(1800),
  },
  [572] = {
    [sym_landingpad_clause] = STATE(571),
    [aux_sym_instruction_landingpad_repeat1] = STATE(571),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1805),
    [sym_label] = ACTIONS(1805),
    [anon_sym_RBRACE] = ACTIONS(1805),
    [anon_sym_COMMA] = ACTIONS(1805),
    [anon_sym_unreachable] = ACTIONS(1807),
    [anon_sym_ret] = ACTIONS(1807),
    [anon_sym_br] = ACTIONS(1807),
    [anon_sym_resume] = ACTIONS(1807),
    [anon_sym_freeze] = ACTIONS(1807),
    [anon_sym_indirectbr] = ACTIONS(1807),
    [anon_sym_extractelement] = ACTIONS(1807),
    [anon_sym_insertelement] = ACTIONS(1807),
    [anon_sym_select] = ACTIONS(1807),
    [anon_sym_shufflevector] = ACTIONS(1807),
    [anon_sym_fneg] = ACTIONS(1807),
    [anon_sym_switch] = ACTIONS(1807),
    [anon_sym_invoke] = ACTIONS(1807),
    [anon_sym_cleanupret] = ACTIONS(1807),
    [anon_sym_catchret] = ACTIONS(1807),
    [anon_sym_catchswitch] = ACTIONS(1807),
    [anon_sym_catchpad] = ACTIONS(1807),
    [anon_sym_cleanuppad] = ACTIONS(1807),
    [anon_sym_callbr] = ACTIONS(1807),
    [anon_sym_icmp] = ACTIONS(1807),
    [anon_sym_fcmp] = ACTIONS(1807),
    [anon_sym_va_arg] = ACTIONS(1807),
    [anon_sym_phi] = ACTIONS(1807),
    [anon_sym_landingpad] = ACTIONS(1807),
    [anon_sym_tail] = ACTIONS(1807),
    [anon_sym_musttail] = ACTIONS(1807),
    [anon_sym_notail] = ACTIONS(1807),
    [anon_sym_call] = ACTIONS(1807),
    [anon_sym_alloca] = ACTIONS(1807),
    [anon_sym_load] = ACTIONS(1807),
    [anon_sym_store] = ACTIONS(1807),
    [anon_sym_cmpxchg] = ACTIONS(1807),
    [anon_sym_atomicrmw] = ACTIONS(1807),
    [anon_sym_fence] = ACTIONS(1807),
    [anon_sym_getelementptr] = ACTIONS(1807),
    [anon_sym_extractvalue] = ACTIONS(1807),
    [anon_sym_insertvalue] = ACTIONS(1807),
    [anon_sym_catch] = ACTIONS(1796),
    [anon_sym_filter] = ACTIONS(1796),
    [anon_sym_mul] = ACTIONS(1807),
    [anon_sym_urem] = ACTIONS(1807),
    [anon_sym_srem] = ACTIONS(1807),
    [anon_sym_shl] = ACTIONS(1807),
    [anon_sym_udiv] = ACTIONS(1807),
    [anon_sym_sdiv] = ACTIONS(1807),
    [anon_sym_lshr] = ACTIONS(1807),
    [anon_sym_ashr] = ACTIONS(1807),
    [anon_sym_fmul] = ACTIONS(1807),
    [anon_sym_fdiv] = ACTIONS(1807),
    [anon_sym_frem] = ACTIONS(1807),
    [anon_sym_xchg] = ACTIONS(1807),
    [anon_sym_add] = ACTIONS(1807),
    [anon_sym_sub] = ACTIONS(1807),
    [anon_sym_and] = ACTIONS(1807),
    [anon_sym_nand] = ACTIONS(1807),
    [anon_sym_or] = ACTIONS(1807),
    [anon_sym_xor] = ACTIONS(1807),
    [anon_sym_max] = ACTIONS(1807),
    [anon_sym_min] = ACTIONS(1807),
    [anon_sym_umax] = ACTIONS(1807),
    [anon_sym_umin] = ACTIONS(1807),
    [anon_sym_fadd] = ACTIONS(1807),
    [anon_sym_fsub] = ACTIONS(1807),
    [anon_sym_bitcast] = ACTIONS(1807),
    [anon_sym_trunc] = ACTIONS(1807),
    [anon_sym_zext] = ACTIONS(1807),
    [anon_sym_sext] = ACTIONS(1807),
    [anon_sym_fptrunc] = ACTIONS(1807),
    [anon_sym_fpext] = ACTIONS(1807),
    [anon_sym_addrspacecast] = ACTIONS(1807),
    [anon_sym_uitofp] = ACTIONS(1807),
    [anon_sym_sitofp] = ACTIONS(1807),
    [anon_sym_fptoui] = ACTIONS(1807),
    [anon_sym_fptosi] = ACTIONS(1807),
    [anon_sym_inttoptr] = ACTIONS(1807),
    [anon_sym_ptrtoint] = ACTIONS(1807),
    [anon_sym_uselistorder] = ACTIONS(1807),
  },
  [573] = {
    [sym_metadata_refs] = STATE(577),
    [aux_sym_instruction_repeat1] = STATE(577),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1809),
    [sym_label] = ACTIONS(1809),
    [anon_sym_RBRACE] = ACTIONS(1809),
    [anon_sym_COMMA] = ACTIONS(1811),
    [anon_sym_unreachable] = ACTIONS(1813),
    [anon_sym_ret] = ACTIONS(1813),
    [anon_sym_br] = ACTIONS(1813),
    [anon_sym_resume] = ACTIONS(1813),
    [anon_sym_freeze] = ACTIONS(1813),
    [anon_sym_indirectbr] = ACTIONS(1813),
    [anon_sym_extractelement] = ACTIONS(1813),
    [anon_sym_insertelement] = ACTIONS(1813),
    [anon_sym_select] = ACTIONS(1813),
    [anon_sym_shufflevector] = ACTIONS(1813),
    [anon_sym_fneg] = ACTIONS(1813),
    [anon_sym_switch] = ACTIONS(1813),
    [anon_sym_invoke] = ACTIONS(1813),
    [anon_sym_cleanupret] = ACTIONS(1813),
    [anon_sym_catchret] = ACTIONS(1813),
    [anon_sym_catchswitch] = ACTIONS(1813),
    [anon_sym_catchpad] = ACTIONS(1813),
    [anon_sym_cleanuppad] = ACTIONS(1813),
    [anon_sym_callbr] = ACTIONS(1813),
    [anon_sym_icmp] = ACTIONS(1813),
    [anon_sym_fcmp] = ACTIONS(1813),
    [anon_sym_va_arg] = ACTIONS(1813),
    [anon_sym_phi] = ACTIONS(1813),
    [anon_sym_landingpad] = ACTIONS(1813),
    [anon_sym_tail] = ACTIONS(1813),
    [anon_sym_musttail] = ACTIONS(1813),
    [anon_sym_notail] = ACTIONS(1813),
    [anon_sym_call] = ACTIONS(1813),
    [anon_sym_alloca] = ACTIONS(1813),
    [anon_sym_load] = ACTIONS(1813),
    [anon_sym_store] = ACTIONS(1813),
    [anon_sym_cmpxchg] = ACTIONS(1813),
    [anon_sym_atomicrmw] = ACTIONS(1813),
    [anon_sym_fence] = ACTIONS(1813),
    [anon_sym_getelementptr] = ACTIONS(1813),
    [anon_sym_extractvalue] = ACTIONS(1813),
    [anon_sym_insertvalue] = ACTIONS(1813),
    [anon_sym_mul] = ACTIONS(1813),
    [anon_sym_urem] = ACTIONS(1813),
    [anon_sym_srem] = ACTIONS(1813),
    [anon_sym_shl] = ACTIONS(1813),
    [anon_sym_udiv] = ACTIONS(1813),
    [anon_sym_sdiv] = ACTIONS(1813),
    [anon_sym_lshr] = ACTIONS(1813),
    [anon_sym_ashr] = ACTIONS(1813),
    [anon_sym_fmul] = ACTIONS(1813),
    [anon_sym_fdiv] = ACTIONS(1813),
    [anon_sym_frem] = ACTIONS(1813),
    [anon_sym_xchg] = ACTIONS(1813),
    [anon_sym_add] = ACTIONS(1813),
    [anon_sym_sub] = ACTIONS(1813),
    [anon_sym_and] = ACTIONS(1813),
    [anon_sym_nand] = ACTIONS(1813),
    [anon_sym_or] = ACTIONS(1813),
    [anon_sym_xor] = ACTIONS(1813),
    [anon_sym_max] = ACTIONS(1813),
    [anon_sym_min] = ACTIONS(1813),
    [anon_sym_umax] = ACTIONS(1813),
    [anon_sym_umin] = ACTIONS(1813),
    [anon_sym_fadd] = ACTIONS(1813),
    [anon_sym_fsub] = ACTIONS(1813),
    [anon_sym_bitcast] = ACTIONS(1813),
    [anon_sym_trunc] = ACTIONS(1813),
    [anon_sym_zext] = ACTIONS(1813),
    [anon_sym_sext] = ACTIONS(1813),
    [anon_sym_fptrunc] = ACTIONS(1813),
    [anon_sym_fpext] = ACTIONS(1813),
    [anon_sym_addrspacecast] = ACTIONS(1813),
    [anon_sym_uitofp] = ACTIONS(1813),
    [anon_sym_sitofp] = ACTIONS(1813),
    [anon_sym_fptoui] = ACTIONS(1813),
    [anon_sym_fptosi] = ACTIONS(1813),
    [anon_sym_inttoptr] = ACTIONS(1813),
    [anon_sym_ptrtoint] = ACTIONS(1813),
    [anon_sym_uselistorder] = ACTIONS(1813),
  },
  [574] = {
    [sym_metadata_refs] = STATE(575),
    [aux_sym_instruction_repeat1] = STATE(575),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1815),
    [sym_label] = ACTIONS(1815),
    [anon_sym_RBRACE] = ACTIONS(1815),
    [anon_sym_COMMA] = ACTIONS(1811),
    [anon_sym_unreachable] = ACTIONS(1817),
    [anon_sym_ret] = ACTIONS(1817),
    [anon_sym_br] = ACTIONS(1817),
    [anon_sym_resume] = ACTIONS(1817),
    [anon_sym_freeze] = ACTIONS(1817),
    [anon_sym_indirectbr] = ACTIONS(1817),
    [anon_sym_extractelement] = ACTIONS(1817),
    [anon_sym_insertelement] = ACTIONS(1817),
    [anon_sym_select] = ACTIONS(1817),
    [anon_sym_shufflevector] = ACTIONS(1817),
    [anon_sym_fneg] = ACTIONS(1817),
    [anon_sym_switch] = ACTIONS(1817),
    [anon_sym_invoke] = ACTIONS(1817),
    [anon_sym_cleanupret] = ACTIONS(1817),
    [anon_sym_catchret] = ACTIONS(1817),
    [anon_sym_catchswitch] = ACTIONS(1817),
    [anon_sym_catchpad] = ACTIONS(1817),
    [anon_sym_cleanuppad] = ACTIONS(1817),
    [anon_sym_callbr] = ACTIONS(1817),
    [anon_sym_icmp] = ACTIONS(1817),
    [anon_sym_fcmp] = ACTIONS(1817),
    [anon_sym_va_arg] = ACTIONS(1817),
    [anon_sym_phi] = ACTIONS(1817),
    [anon_sym_landingpad] = ACTIONS(1817),
    [anon_sym_tail] = ACTIONS(1817),
    [anon_sym_musttail] = ACTIONS(1817),
    [anon_sym_notail] = ACTIONS(1817),
    [anon_sym_call] = ACTIONS(1817),
    [anon_sym_alloca] = ACTIONS(1817),
    [anon_sym_load] = ACTIONS(1817),
    [anon_sym_store] = ACTIONS(1817),
    [anon_sym_cmpxchg] = ACTIONS(1817),
    [anon_sym_atomicrmw] = ACTIONS(1817),
    [anon_sym_fence] = ACTIONS(1817),
    [anon_sym_getelementptr] = ACTIONS(1817),
    [anon_sym_extractvalue] = ACTIONS(1817),
    [anon_sym_insertvalue] = ACTIONS(1817),
    [anon_sym_mul] = ACTIONS(1817),
    [anon_sym_urem] = ACTIONS(1817),
    [anon_sym_srem] = ACTIONS(1817),
    [anon_sym_shl] = ACTIONS(1817),
    [anon_sym_udiv] = ACTIONS(1817),
    [anon_sym_sdiv] = ACTIONS(1817),
    [anon_sym_lshr] = ACTIONS(1817),
    [anon_sym_ashr] = ACTIONS(1817),
    [anon_sym_fmul] = ACTIONS(1817),
    [anon_sym_fdiv] = ACTIONS(1817),
    [anon_sym_frem] = ACTIONS(1817),
    [anon_sym_xchg] = ACTIONS(1817),
    [anon_sym_add] = ACTIONS(1817),
    [anon_sym_sub] = ACTIONS(1817),
    [anon_sym_and] = ACTIONS(1817),
    [anon_sym_nand] = ACTIONS(1817),
    [anon_sym_or] = ACTIONS(1817),
    [anon_sym_xor] = ACTIONS(1817),
    [anon_sym_max] = ACTIONS(1817),
    [anon_sym_min] = ACTIONS(1817),
    [anon_sym_umax] = ACTIONS(1817),
    [anon_sym_umin] = ACTIONS(1817),
    [anon_sym_fadd] = ACTIONS(1817),
    [anon_sym_fsub] = ACTIONS(1817),
    [anon_sym_bitcast] = ACTIONS(1817),
    [anon_sym_trunc] = ACTIONS(1817),
    [anon_sym_zext] = ACTIONS(1817),
    [anon_sym_sext] = ACTIONS(1817),
    [anon_sym_fptrunc] = ACTIONS(1817),
    [anon_sym_fpext] = ACTIONS(1817),
    [anon_sym_addrspacecast] = ACTIONS(1817),
    [anon_sym_uitofp] = ACTIONS(1817),
    [anon_sym_sitofp] = ACTIONS(1817),
    [anon_sym_fptoui] = ACTIONS(1817),
    [anon_sym_fptosi] = ACTIONS(1817),
    [anon_sym_inttoptr] = ACTIONS(1817),
    [anon_sym_ptrtoint] = ACTIONS(1817),
    [anon_sym_uselistorder] = ACTIONS(1817),
  },
  [575] = {
    [sym_metadata_refs] = STATE(576),
    [aux_sym_instruction_repeat1] = STATE(576),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1819),
    [sym_label] = ACTIONS(1819),
    [anon_sym_RBRACE] = ACTIONS(1819),
    [anon_sym_COMMA] = ACTIONS(1811),
    [anon_sym_unreachable] = ACTIONS(1821),
    [anon_sym_ret] = ACTIONS(1821),
    [anon_sym_br] = ACTIONS(1821),
    [anon_sym_resume] = ACTIONS(1821),
    [anon_sym_freeze] = ACTIONS(1821),
    [anon_sym_indirectbr] = ACTIONS(1821),
    [anon_sym_extractelement] = ACTIONS(1821),
    [anon_sym_insertelement] = ACTIONS(1821),
    [anon_sym_select] = ACTIONS(1821),
    [anon_sym_shufflevector] = ACTIONS(1821),
    [anon_sym_fneg] = ACTIONS(1821),
    [anon_sym_switch] = ACTIONS(1821),
    [anon_sym_invoke] = ACTIONS(1821),
    [anon_sym_cleanupret] = ACTIONS(1821),
    [anon_sym_catchret] = ACTIONS(1821),
    [anon_sym_catchswitch] = ACTIONS(1821),
    [anon_sym_catchpad] = ACTIONS(1821),
    [anon_sym_cleanuppad] = ACTIONS(1821),
    [anon_sym_callbr] = ACTIONS(1821),
    [anon_sym_icmp] = ACTIONS(1821),
    [anon_sym_fcmp] = ACTIONS(1821),
    [anon_sym_va_arg] = ACTIONS(1821),
    [anon_sym_phi] = ACTIONS(1821),
    [anon_sym_landingpad] = ACTIONS(1821),
    [anon_sym_tail] = ACTIONS(1821),
    [anon_sym_musttail] = ACTIONS(1821),
    [anon_sym_notail] = ACTIONS(1821),
    [anon_sym_call] = ACTIONS(1821),
    [anon_sym_alloca] = ACTIONS(1821),
    [anon_sym_load] = ACTIONS(1821),
    [anon_sym_store] = ACTIONS(1821),
    [anon_sym_cmpxchg] = ACTIONS(1821),
    [anon_sym_atomicrmw] = ACTIONS(1821),
    [anon_sym_fence] = ACTIONS(1821),
    [anon_sym_getelementptr] = ACTIONS(1821),
    [anon_sym_extractvalue] = ACTIONS(1821),
    [anon_sym_insertvalue] = ACTIONS(1821),
    [anon_sym_mul] = ACTIONS(1821),
    [anon_sym_urem] = ACTIONS(1821),
    [anon_sym_srem] = ACTIONS(1821),
    [anon_sym_shl] = ACTIONS(1821),
    [anon_sym_udiv] = ACTIONS(1821),
    [anon_sym_sdiv] = ACTIONS(1821),
    [anon_sym_lshr] = ACTIONS(1821),
    [anon_sym_ashr] = ACTIONS(1821),
    [anon_sym_fmul] = ACTIONS(1821),
    [anon_sym_fdiv] = ACTIONS(1821),
    [anon_sym_frem] = ACTIONS(1821),
    [anon_sym_xchg] = ACTIONS(1821),
    [anon_sym_add] = ACTIONS(1821),
    [anon_sym_sub] = ACTIONS(1821),
    [anon_sym_and] = ACTIONS(1821),
    [anon_sym_nand] = ACTIONS(1821),
    [anon_sym_or] = ACTIONS(1821),
    [anon_sym_xor] = ACTIONS(1821),
    [anon_sym_max] = ACTIONS(1821),
    [anon_sym_min] = ACTIONS(1821),
    [anon_sym_umax] = ACTIONS(1821),
    [anon_sym_umin] = ACTIONS(1821),
    [anon_sym_fadd] = ACTIONS(1821),
    [anon_sym_fsub] = ACTIONS(1821),
    [anon_sym_bitcast] = ACTIONS(1821),
    [anon_sym_trunc] = ACTIONS(1821),
    [anon_sym_zext] = ACTIONS(1821),
    [anon_sym_sext] = ACTIONS(1821),
    [anon_sym_fptrunc] = ACTIONS(1821),
    [anon_sym_fpext] = ACTIONS(1821),
    [anon_sym_addrspacecast] = ACTIONS(1821),
    [anon_sym_uitofp] = ACTIONS(1821),
    [anon_sym_sitofp] = ACTIONS(1821),
    [anon_sym_fptoui] = ACTIONS(1821),
    [anon_sym_fptosi] = ACTIONS(1821),
    [anon_sym_inttoptr] = ACTIONS(1821),
    [anon_sym_ptrtoint] = ACTIONS(1821),
    [anon_sym_uselistorder] = ACTIONS(1821),
  },
  [576] = {
    [sym_metadata_refs] = STATE(576),
    [aux_sym_instruction_repeat1] = STATE(576),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1823),
    [sym_label] = ACTIONS(1823),
    [anon_sym_RBRACE] = ACTIONS(1823),
    [anon_sym_COMMA] = ACTIONS(1825),
    [anon_sym_unreachable] = ACTIONS(1828),
    [anon_sym_ret] = ACTIONS(1828),
    [anon_sym_br] = ACTIONS(1828),
    [anon_sym_resume] = ACTIONS(1828),
    [anon_sym_freeze] = ACTIONS(1828),
    [anon_sym_indirectbr] = ACTIONS(1828),
    [anon_sym_extractelement] = ACTIONS(1828),
    [anon_sym_insertelement] = ACTIONS(1828),
    [anon_sym_select] = ACTIONS(1828),
    [anon_sym_shufflevector] = ACTIONS(1828),
    [anon_sym_fneg] = ACTIONS(1828),
    [anon_sym_switch] = ACTIONS(1828),
    [anon_sym_invoke] = ACTIONS(1828),
    [anon_sym_cleanupret] = ACTIONS(1828),
    [anon_sym_catchret] = ACTIONS(1828),
    [anon_sym_catchswitch] = ACTIONS(1828),
    [anon_sym_catchpad] = ACTIONS(1828),
    [anon_sym_cleanuppad] = ACTIONS(1828),
    [anon_sym_callbr] = ACTIONS(1828),
    [anon_sym_icmp] = ACTIONS(1828),
    [anon_sym_fcmp] = ACTIONS(1828),
    [anon_sym_va_arg] = ACTIONS(1828),
    [anon_sym_phi] = ACTIONS(1828),
    [anon_sym_landingpad] = ACTIONS(1828),
    [anon_sym_tail] = ACTIONS(1828),
    [anon_sym_musttail] = ACTIONS(1828),
    [anon_sym_notail] = ACTIONS(1828),
    [anon_sym_call] = ACTIONS(1828),
    [anon_sym_alloca] = ACTIONS(1828),
    [anon_sym_load] = ACTIONS(1828),
    [anon_sym_store] = ACTIONS(1828),
    [anon_sym_cmpxchg] = ACTIONS(1828),
    [anon_sym_atomicrmw] = ACTIONS(1828),
    [anon_sym_fence] = ACTIONS(1828),
    [anon_sym_getelementptr] = ACTIONS(1828),
    [anon_sym_extractvalue] = ACTIONS(1828),
    [anon_sym_insertvalue] = ACTIONS(1828),
    [anon_sym_mul] = ACTIONS(1828),
    [anon_sym_urem] = ACTIONS(1828),
    [anon_sym_srem] = ACTIONS(1828),
    [anon_sym_shl] = ACTIONS(1828),
    [anon_sym_udiv] = ACTIONS(1828),
    [anon_sym_sdiv] = ACTIONS(1828),
    [anon_sym_lshr] = ACTIONS(1828),
    [anon_sym_ashr] = ACTIONS(1828),
    [anon_sym_fmul] = ACTIONS(1828),
    [anon_sym_fdiv] = ACTIONS(1828),
    [anon_sym_frem] = ACTIONS(1828),
    [anon_sym_xchg] = ACTIONS(1828),
    [anon_sym_add] = ACTIONS(1828),
    [anon_sym_sub] = ACTIONS(1828),
    [anon_sym_and] = ACTIONS(1828),
    [anon_sym_nand] = ACTIONS(1828),
    [anon_sym_or] = ACTIONS(1828),
    [anon_sym_xor] = ACTIONS(1828),
    [anon_sym_max] = ACTIONS(1828),
    [anon_sym_min] = ACTIONS(1828),
    [anon_sym_umax] = ACTIONS(1828),
    [anon_sym_umin] = ACTIONS(1828),
    [anon_sym_fadd] = ACTIONS(1828),
    [anon_sym_fsub] = ACTIONS(1828),
    [anon_sym_bitcast] = ACTIONS(1828),
    [anon_sym_trunc] = ACTIONS(1828),
    [anon_sym_zext] = ACTIONS(1828),
    [anon_sym_sext] = ACTIONS(1828),
    [anon_sym_fptrunc] = ACTIONS(1828),
    [anon_sym_fpext] = ACTIONS(1828),
    [anon_sym_addrspacecast] = ACTIONS(1828),
    [anon_sym_uitofp] = ACTIONS(1828),
    [anon_sym_sitofp] = ACTIONS(1828),
    [anon_sym_fptoui] = ACTIONS(1828),
    [anon_sym_fptosi] = ACTIONS(1828),
    [anon_sym_inttoptr] = ACTIONS(1828),
    [anon_sym_ptrtoint] = ACTIONS(1828),
    [anon_sym_uselistorder] = ACTIONS(1828),
  },
  [577] = {
    [sym_metadata_refs] = STATE(576),
    [aux_sym_instruction_repeat1] = STATE(576),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1830),
    [sym_label] = ACTIONS(1830),
    [anon_sym_RBRACE] = ACTIONS(1830),
    [anon_sym_COMMA] = ACTIONS(1811),
    [anon_sym_unreachable] = ACTIONS(1832),
    [anon_sym_ret] = ACTIONS(1832),
    [anon_sym_br] = ACTIONS(1832),
    [anon_sym_resume] = ACTIONS(1832),
    [anon_sym_freeze] = ACTIONS(1832),
    [anon_sym_indirectbr] = ACTIONS(1832),
    [anon_sym_extractelement] = ACTIONS(1832),
    [anon_sym_insertelement] = ACTIONS(1832),
    [anon_sym_select] = ACTIONS(1832),
    [anon_sym_shufflevector] = ACTIONS(1832),
    [anon_sym_fneg] = ACTIONS(1832),
    [anon_sym_switch] = ACTIONS(1832),
    [anon_sym_invoke] = ACTIONS(1832),
    [anon_sym_cleanupret] = ACTIONS(1832),
    [anon_sym_catchret] = ACTIONS(1832),
    [anon_sym_catchswitch] = ACTIONS(1832),
    [anon_sym_catchpad] = ACTIONS(1832),
    [anon_sym_cleanuppad] = ACTIONS(1832),
    [anon_sym_callbr] = ACTIONS(1832),
    [anon_sym_icmp] = ACTIONS(1832),
    [anon_sym_fcmp] = ACTIONS(1832),
    [anon_sym_va_arg] = ACTIONS(1832),
    [anon_sym_phi] = ACTIONS(1832),
    [anon_sym_landingpad] = ACTIONS(1832),
    [anon_sym_tail] = ACTIONS(1832),
    [anon_sym_musttail] = ACTIONS(1832),
    [anon_sym_notail] = ACTIONS(1832),
    [anon_sym_call] = ACTIONS(1832),
    [anon_sym_alloca] = ACTIONS(1832),
    [anon_sym_load] = ACTIONS(1832),
    [anon_sym_store] = ACTIONS(1832),
    [anon_sym_cmpxchg] = ACTIONS(1832),
    [anon_sym_atomicrmw] = ACTIONS(1832),
    [anon_sym_fence] = ACTIONS(1832),
    [anon_sym_getelementptr] = ACTIONS(1832),
    [anon_sym_extractvalue] = ACTIONS(1832),
    [anon_sym_insertvalue] = ACTIONS(1832),
    [anon_sym_mul] = ACTIONS(1832),
    [anon_sym_urem] = ACTIONS(1832),
    [anon_sym_srem] = ACTIONS(1832),
    [anon_sym_shl] = ACTIONS(1832),
    [anon_sym_udiv] = ACTIONS(1832),
    [anon_sym_sdiv] = ACTIONS(1832),
    [anon_sym_lshr] = ACTIONS(1832),
    [anon_sym_ashr] = ACTIONS(1832),
    [anon_sym_fmul] = ACTIONS(1832),
    [anon_sym_fdiv] = ACTIONS(1832),
    [anon_sym_frem] = ACTIONS(1832),
    [anon_sym_xchg] = ACTIONS(1832),
    [anon_sym_add] = ACTIONS(1832),
    [anon_sym_sub] = ACTIONS(1832),
    [anon_sym_and] = ACTIONS(1832),
    [anon_sym_nand] = ACTIONS(1832),
    [anon_sym_or] = ACTIONS(1832),
    [anon_sym_xor] = ACTIONS(1832),
    [anon_sym_max] = ACTIONS(1832),
    [anon_sym_min] = ACTIONS(1832),
    [anon_sym_umax] = ACTIONS(1832),
    [anon_sym_umin] = ACTIONS(1832),
    [anon_sym_fadd] = ACTIONS(1832),
    [anon_sym_fsub] = ACTIONS(1832),
    [anon_sym_bitcast] = ACTIONS(1832),
    [anon_sym_trunc] = ACTIONS(1832),
    [anon_sym_zext] = ACTIONS(1832),
    [anon_sym_sext] = ACTIONS(1832),
    [anon_sym_fptrunc] = ACTIONS(1832),
    [anon_sym_fpext] = ACTIONS(1832),
    [anon_sym_addrspacecast] = ACTIONS(1832),
    [anon_sym_uitofp] = ACTIONS(1832),
    [anon_sym_sitofp] = ACTIONS(1832),
    [anon_sym_fptoui] = ACTIONS(1832),
    [anon_sym_fptosi] = ACTIONS(1832),
    [anon_sym_inttoptr] = ACTIONS(1832),
    [anon_sym_ptrtoint] = ACTIONS(1832),
    [anon_sym_uselistorder] = ACTIONS(1832),
  },
  [578] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1834),
    [sym_label] = ACTIONS(1834),
    [anon_sym_RBRACE] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1834),
    [anon_sym_unreachable] = ACTIONS(1836),
    [anon_sym_ret] = ACTIONS(1836),
    [anon_sym_br] = ACTIONS(1836),
    [anon_sym_resume] = ACTIONS(1836),
    [anon_sym_freeze] = ACTIONS(1836),
    [anon_sym_indirectbr] = ACTIONS(1836),
    [anon_sym_extractelement] = ACTIONS(1836),
    [anon_sym_insertelement] = ACTIONS(1836),
    [anon_sym_select] = ACTIONS(1836),
    [anon_sym_shufflevector] = ACTIONS(1836),
    [anon_sym_fneg] = ACTIONS(1836),
    [anon_sym_switch] = ACTIONS(1836),
    [anon_sym_invoke] = ACTIONS(1836),
    [anon_sym_cleanupret] = ACTIONS(1836),
    [anon_sym_catchret] = ACTIONS(1836),
    [anon_sym_catchswitch] = ACTIONS(1836),
    [anon_sym_catchpad] = ACTIONS(1836),
    [anon_sym_cleanuppad] = ACTIONS(1836),
    [anon_sym_callbr] = ACTIONS(1836),
    [anon_sym_icmp] = ACTIONS(1836),
    [anon_sym_fcmp] = ACTIONS(1836),
    [anon_sym_va_arg] = ACTIONS(1836),
    [anon_sym_phi] = ACTIONS(1836),
    [anon_sym_landingpad] = ACTIONS(1836),
    [anon_sym_tail] = ACTIONS(1836),
    [anon_sym_musttail] = ACTIONS(1836),
    [anon_sym_notail] = ACTIONS(1836),
    [anon_sym_call] = ACTIONS(1836),
    [anon_sym_alloca] = ACTIONS(1836),
    [anon_sym_load] = ACTIONS(1836),
    [anon_sym_store] = ACTIONS(1836),
    [anon_sym_cmpxchg] = ACTIONS(1836),
    [anon_sym_atomicrmw] = ACTIONS(1836),
    [anon_sym_fence] = ACTIONS(1836),
    [anon_sym_getelementptr] = ACTIONS(1836),
    [anon_sym_extractvalue] = ACTIONS(1836),
    [anon_sym_insertvalue] = ACTIONS(1836),
    [anon_sym_catch] = ACTIONS(1836),
    [anon_sym_filter] = ACTIONS(1836),
    [anon_sym_mul] = ACTIONS(1836),
    [anon_sym_urem] = ACTIONS(1836),
    [anon_sym_srem] = ACTIONS(1836),
    [anon_sym_shl] = ACTIONS(1836),
    [anon_sym_udiv] = ACTIONS(1836),
    [anon_sym_sdiv] = ACTIONS(1836),
    [anon_sym_lshr] = ACTIONS(1836),
    [anon_sym_ashr] = ACTIONS(1836),
    [anon_sym_fmul] = ACTIONS(1836),
    [anon_sym_fdiv] = ACTIONS(1836),
    [anon_sym_frem] = ACTIONS(1836),
    [anon_sym_xchg] = ACTIONS(1836),
    [anon_sym_add] = ACTIONS(1836),
    [anon_sym_sub] = ACTIONS(1836),
    [anon_sym_and] = ACTIONS(1836),
    [anon_sym_nand] = ACTIONS(1836),
    [anon_sym_or] = ACTIONS(1836),
    [anon_sym_xor] = ACTIONS(1836),
    [anon_sym_max] = ACTIONS(1836),
    [anon_sym_min] = ACTIONS(1836),
    [anon_sym_umax] = ACTIONS(1836),
    [anon_sym_umin] = ACTIONS(1836),
    [anon_sym_fadd] = ACTIONS(1836),
    [anon_sym_fsub] = ACTIONS(1836),
    [anon_sym_bitcast] = ACTIONS(1836),
    [anon_sym_trunc] = ACTIONS(1836),
    [anon_sym_zext] = ACTIONS(1836),
    [anon_sym_sext] = ACTIONS(1836),
    [anon_sym_fptrunc] = ACTIONS(1836),
    [anon_sym_fpext] = ACTIONS(1836),
    [anon_sym_addrspacecast] = ACTIONS(1836),
    [anon_sym_uitofp] = ACTIONS(1836),
    [anon_sym_sitofp] = ACTIONS(1836),
    [anon_sym_fptoui] = ACTIONS(1836),
    [anon_sym_fptosi] = ACTIONS(1836),
    [anon_sym_inttoptr] = ACTIONS(1836),
    [anon_sym_ptrtoint] = ACTIONS(1836),
    [anon_sym_uselistorder] = ACTIONS(1836),
  },
  [579] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1838),
    [sym_label] = ACTIONS(1838),
    [anon_sym_RBRACE] = ACTIONS(1838),
    [anon_sym_COMMA] = ACTIONS(1838),
    [anon_sym_RPAREN] = ACTIONS(1838),
    [anon_sym_unreachable] = ACTIONS(1840),
    [anon_sym_ret] = ACTIONS(1840),
    [anon_sym_br] = ACTIONS(1840),
    [anon_sym_resume] = ACTIONS(1840),
    [anon_sym_freeze] = ACTIONS(1840),
    [anon_sym_indirectbr] = ACTIONS(1840),
    [anon_sym_extractelement] = ACTIONS(1840),
    [anon_sym_insertelement] = ACTIONS(1840),
    [anon_sym_select] = ACTIONS(1840),
    [anon_sym_shufflevector] = ACTIONS(1840),
    [anon_sym_fneg] = ACTIONS(1840),
    [anon_sym_switch] = ACTIONS(1840),
    [anon_sym_invoke] = ACTIONS(1840),
    [anon_sym_cleanupret] = ACTIONS(1840),
    [anon_sym_catchret] = ACTIONS(1840),
    [anon_sym_catchswitch] = ACTIONS(1840),
    [anon_sym_catchpad] = ACTIONS(1840),
    [anon_sym_cleanuppad] = ACTIONS(1840),
    [anon_sym_callbr] = ACTIONS(1840),
    [anon_sym_icmp] = ACTIONS(1840),
    [anon_sym_fcmp] = ACTIONS(1840),
    [anon_sym_va_arg] = ACTIONS(1840),
    [anon_sym_phi] = ACTIONS(1840),
    [anon_sym_landingpad] = ACTIONS(1840),
    [anon_sym_tail] = ACTIONS(1840),
    [anon_sym_musttail] = ACTIONS(1840),
    [anon_sym_notail] = ACTIONS(1840),
    [anon_sym_call] = ACTIONS(1840),
    [anon_sym_alloca] = ACTIONS(1840),
    [anon_sym_load] = ACTIONS(1840),
    [anon_sym_store] = ACTIONS(1840),
    [anon_sym_cmpxchg] = ACTIONS(1840),
    [anon_sym_atomicrmw] = ACTIONS(1840),
    [anon_sym_fence] = ACTIONS(1840),
    [anon_sym_getelementptr] = ACTIONS(1840),
    [anon_sym_extractvalue] = ACTIONS(1840),
    [anon_sym_insertvalue] = ACTIONS(1840),
    [anon_sym_mul] = ACTIONS(1840),
    [anon_sym_urem] = ACTIONS(1840),
    [anon_sym_srem] = ACTIONS(1840),
    [anon_sym_shl] = ACTIONS(1840),
    [anon_sym_udiv] = ACTIONS(1840),
    [anon_sym_sdiv] = ACTIONS(1840),
    [anon_sym_lshr] = ACTIONS(1840),
    [anon_sym_ashr] = ACTIONS(1840),
    [anon_sym_fmul] = ACTIONS(1840),
    [anon_sym_fdiv] = ACTIONS(1840),
    [anon_sym_frem] = ACTIONS(1840),
    [anon_sym_xchg] = ACTIONS(1840),
    [anon_sym_add] = ACTIONS(1840),
    [anon_sym_sub] = ACTIONS(1840),
    [anon_sym_and] = ACTIONS(1840),
    [anon_sym_nand] = ACTIONS(1840),
    [anon_sym_or] = ACTIONS(1840),
    [anon_sym_xor] = ACTIONS(1840),
    [anon_sym_max] = ACTIONS(1840),
    [anon_sym_min] = ACTIONS(1840),
    [anon_sym_umax] = ACTIONS(1840),
    [anon_sym_umin] = ACTIONS(1840),
    [anon_sym_fadd] = ACTIONS(1840),
    [anon_sym_fsub] = ACTIONS(1840),
    [anon_sym_bitcast] = ACTIONS(1840),
    [anon_sym_trunc] = ACTIONS(1840),
    [anon_sym_zext] = ACTIONS(1840),
    [anon_sym_sext] = ACTIONS(1840),
    [anon_sym_fptrunc] = ACTIONS(1840),
    [anon_sym_fpext] = ACTIONS(1840),
    [anon_sym_addrspacecast] = ACTIONS(1840),
    [anon_sym_uitofp] = ACTIONS(1840),
    [anon_sym_sitofp] = ACTIONS(1840),
    [anon_sym_fptoui] = ACTIONS(1840),
    [anon_sym_fptosi] = ACTIONS(1840),
    [anon_sym_inttoptr] = ACTIONS(1840),
    [anon_sym_ptrtoint] = ACTIONS(1840),
    [anon_sym_uselistorder] = ACTIONS(1840),
  },
  [580] = {
    [aux_sym_instruction_alloca_repeat1] = STATE(580),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1842),
    [sym_label] = ACTIONS(1842),
    [anon_sym_RBRACE] = ACTIONS(1842),
    [anon_sym_COMMA] = ACTIONS(1844),
    [anon_sym_unreachable] = ACTIONS(1847),
    [anon_sym_ret] = ACTIONS(1847),
    [anon_sym_br] = ACTIONS(1847),
    [anon_sym_resume] = ACTIONS(1847),
    [anon_sym_freeze] = ACTIONS(1847),
    [anon_sym_indirectbr] = ACTIONS(1847),
    [anon_sym_extractelement] = ACTIONS(1847),
    [anon_sym_insertelement] = ACTIONS(1847),
    [anon_sym_select] = ACTIONS(1847),
    [anon_sym_shufflevector] = ACTIONS(1847),
    [anon_sym_fneg] = ACTIONS(1847),
    [anon_sym_switch] = ACTIONS(1847),
    [anon_sym_invoke] = ACTIONS(1847),
    [anon_sym_cleanupret] = ACTIONS(1847),
    [anon_sym_catchret] = ACTIONS(1847),
    [anon_sym_catchswitch] = ACTIONS(1847),
    [anon_sym_catchpad] = ACTIONS(1847),
    [anon_sym_cleanuppad] = ACTIONS(1847),
    [anon_sym_callbr] = ACTIONS(1847),
    [anon_sym_icmp] = ACTIONS(1847),
    [anon_sym_fcmp] = ACTIONS(1847),
    [anon_sym_va_arg] = ACTIONS(1847),
    [anon_sym_phi] = ACTIONS(1847),
    [anon_sym_landingpad] = ACTIONS(1847),
    [anon_sym_tail] = ACTIONS(1847),
    [anon_sym_musttail] = ACTIONS(1847),
    [anon_sym_notail] = ACTIONS(1847),
    [anon_sym_call] = ACTIONS(1847),
    [anon_sym_alloca] = ACTIONS(1847),
    [anon_sym_load] = ACTIONS(1847),
    [anon_sym_store] = ACTIONS(1847),
    [anon_sym_cmpxchg] = ACTIONS(1847),
    [anon_sym_atomicrmw] = ACTIONS(1847),
    [anon_sym_fence] = ACTIONS(1847),
    [anon_sym_getelementptr] = ACTIONS(1847),
    [anon_sym_extractvalue] = ACTIONS(1847),
    [anon_sym_insertvalue] = ACTIONS(1847),
    [anon_sym_mul] = ACTIONS(1847),
    [anon_sym_urem] = ACTIONS(1847),
    [anon_sym_srem] = ACTIONS(1847),
    [anon_sym_shl] = ACTIONS(1847),
    [anon_sym_udiv] = ACTIONS(1847),
    [anon_sym_sdiv] = ACTIONS(1847),
    [anon_sym_lshr] = ACTIONS(1847),
    [anon_sym_ashr] = ACTIONS(1847),
    [anon_sym_fmul] = ACTIONS(1847),
    [anon_sym_fdiv] = ACTIONS(1847),
    [anon_sym_frem] = ACTIONS(1847),
    [anon_sym_xchg] = ACTIONS(1847),
    [anon_sym_add] = ACTIONS(1847),
    [anon_sym_sub] = ACTIONS(1847),
    [anon_sym_and] = ACTIONS(1847),
    [anon_sym_nand] = ACTIONS(1847),
    [anon_sym_or] = ACTIONS(1847),
    [anon_sym_xor] = ACTIONS(1847),
    [anon_sym_max] = ACTIONS(1847),
    [anon_sym_min] = ACTIONS(1847),
    [anon_sym_umax] = ACTIONS(1847),
    [anon_sym_umin] = ACTIONS(1847),
    [anon_sym_fadd] = ACTIONS(1847),
    [anon_sym_fsub] = ACTIONS(1847),
    [anon_sym_bitcast] = ACTIONS(1847),
    [anon_sym_trunc] = ACTIONS(1847),
    [anon_sym_zext] = ACTIONS(1847),
    [anon_sym_sext] = ACTIONS(1847),
    [anon_sym_fptrunc] = ACTIONS(1847),
    [anon_sym_fpext] = ACTIONS(1847),
    [anon_sym_addrspacecast] = ACTIONS(1847),
    [anon_sym_uitofp] = ACTIONS(1847),
    [anon_sym_sitofp] = ACTIONS(1847),
    [anon_sym_fptoui] = ACTIONS(1847),
    [anon_sym_fptosi] = ACTIONS(1847),
    [anon_sym_inttoptr] = ACTIONS(1847),
    [anon_sym_ptrtoint] = ACTIONS(1847),
    [anon_sym_uselistorder] = ACTIONS(1847),
  },
  [581] = {
    [aux_sym_instruction_alloca_repeat1] = STATE(580),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1849),
    [sym_label] = ACTIONS(1849),
    [anon_sym_RBRACE] = ACTIONS(1849),
    [anon_sym_COMMA] = ACTIONS(1851),
    [anon_sym_unreachable] = ACTIONS(1854),
    [anon_sym_ret] = ACTIONS(1854),
    [anon_sym_br] = ACTIONS(1854),
    [anon_sym_resume] = ACTIONS(1854),
    [anon_sym_freeze] = ACTIONS(1854),
    [anon_sym_indirectbr] = ACTIONS(1854),
    [anon_sym_extractelement] = ACTIONS(1854),
    [anon_sym_insertelement] = ACTIONS(1854),
    [anon_sym_select] = ACTIONS(1854),
    [anon_sym_shufflevector] = ACTIONS(1854),
    [anon_sym_fneg] = ACTIONS(1854),
    [anon_sym_switch] = ACTIONS(1854),
    [anon_sym_invoke] = ACTIONS(1854),
    [anon_sym_cleanupret] = ACTIONS(1854),
    [anon_sym_catchret] = ACTIONS(1854),
    [anon_sym_catchswitch] = ACTIONS(1854),
    [anon_sym_catchpad] = ACTIONS(1854),
    [anon_sym_cleanuppad] = ACTIONS(1854),
    [anon_sym_callbr] = ACTIONS(1854),
    [anon_sym_icmp] = ACTIONS(1854),
    [anon_sym_fcmp] = ACTIONS(1854),
    [anon_sym_va_arg] = ACTIONS(1854),
    [anon_sym_phi] = ACTIONS(1854),
    [anon_sym_landingpad] = ACTIONS(1854),
    [anon_sym_tail] = ACTIONS(1854),
    [anon_sym_musttail] = ACTIONS(1854),
    [anon_sym_notail] = ACTIONS(1854),
    [anon_sym_call] = ACTIONS(1854),
    [anon_sym_alloca] = ACTIONS(1854),
    [anon_sym_load] = ACTIONS(1854),
    [anon_sym_store] = ACTIONS(1854),
    [anon_sym_cmpxchg] = ACTIONS(1854),
    [anon_sym_atomicrmw] = ACTIONS(1854),
    [anon_sym_fence] = ACTIONS(1854),
    [anon_sym_getelementptr] = ACTIONS(1854),
    [anon_sym_extractvalue] = ACTIONS(1854),
    [anon_sym_insertvalue] = ACTIONS(1854),
    [anon_sym_mul] = ACTIONS(1854),
    [anon_sym_urem] = ACTIONS(1854),
    [anon_sym_srem] = ACTIONS(1854),
    [anon_sym_shl] = ACTIONS(1854),
    [anon_sym_udiv] = ACTIONS(1854),
    [anon_sym_sdiv] = ACTIONS(1854),
    [anon_sym_lshr] = ACTIONS(1854),
    [anon_sym_ashr] = ACTIONS(1854),
    [anon_sym_fmul] = ACTIONS(1854),
    [anon_sym_fdiv] = ACTIONS(1854),
    [anon_sym_frem] = ACTIONS(1854),
    [anon_sym_xchg] = ACTIONS(1854),
    [anon_sym_add] = ACTIONS(1854),
    [anon_sym_sub] = ACTIONS(1854),
    [anon_sym_and] = ACTIONS(1854),
    [anon_sym_nand] = ACTIONS(1854),
    [anon_sym_or] = ACTIONS(1854),
    [anon_sym_xor] = ACTIONS(1854),
    [anon_sym_max] = ACTIONS(1854),
    [anon_sym_min] = ACTIONS(1854),
    [anon_sym_umax] = ACTIONS(1854),
    [anon_sym_umin] = ACTIONS(1854),
    [anon_sym_fadd] = ACTIONS(1854),
    [anon_sym_fsub] = ACTIONS(1854),
    [anon_sym_bitcast] = ACTIONS(1854),
    [anon_sym_trunc] = ACTIONS(1854),
    [anon_sym_zext] = ACTIONS(1854),
    [anon_sym_sext] = ACTIONS(1854),
    [anon_sym_fptrunc] = ACTIONS(1854),
    [anon_sym_fpext] = ACTIONS(1854),
    [anon_sym_addrspacecast] = ACTIONS(1854),
    [anon_sym_uitofp] = ACTIONS(1854),
    [anon_sym_sitofp] = ACTIONS(1854),
    [anon_sym_fptoui] = ACTIONS(1854),
    [anon_sym_fptosi] = ACTIONS(1854),
    [anon_sym_inttoptr] = ACTIONS(1854),
    [anon_sym_ptrtoint] = ACTIONS(1854),
    [anon_sym_uselistorder] = ACTIONS(1854),
  },
  [582] = {
    [aux_sym_instruction_extractvalue_repeat1] = STATE(602),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1856),
    [sym_label] = ACTIONS(1856),
    [anon_sym_RBRACE] = ACTIONS(1856),
    [anon_sym_COMMA] = ACTIONS(1858),
    [anon_sym_unreachable] = ACTIONS(1861),
    [anon_sym_ret] = ACTIONS(1861),
    [anon_sym_br] = ACTIONS(1861),
    [anon_sym_resume] = ACTIONS(1861),
    [anon_sym_freeze] = ACTIONS(1861),
    [anon_sym_indirectbr] = ACTIONS(1861),
    [anon_sym_extractelement] = ACTIONS(1861),
    [anon_sym_insertelement] = ACTIONS(1861),
    [anon_sym_select] = ACTIONS(1861),
    [anon_sym_shufflevector] = ACTIONS(1861),
    [anon_sym_fneg] = ACTIONS(1861),
    [anon_sym_switch] = ACTIONS(1861),
    [anon_sym_invoke] = ACTIONS(1861),
    [anon_sym_cleanupret] = ACTIONS(1861),
    [anon_sym_catchret] = ACTIONS(1861),
    [anon_sym_catchswitch] = ACTIONS(1861),
    [anon_sym_catchpad] = ACTIONS(1861),
    [anon_sym_cleanuppad] = ACTIONS(1861),
    [anon_sym_callbr] = ACTIONS(1861),
    [anon_sym_icmp] = ACTIONS(1861),
    [anon_sym_fcmp] = ACTIONS(1861),
    [anon_sym_va_arg] = ACTIONS(1861),
    [anon_sym_phi] = ACTIONS(1861),
    [anon_sym_landingpad] = ACTIONS(1861),
    [anon_sym_tail] = ACTIONS(1861),
    [anon_sym_musttail] = ACTIONS(1861),
    [anon_sym_notail] = ACTIONS(1861),
    [anon_sym_call] = ACTIONS(1861),
    [anon_sym_alloca] = ACTIONS(1861),
    [anon_sym_load] = ACTIONS(1861),
    [anon_sym_store] = ACTIONS(1861),
    [anon_sym_cmpxchg] = ACTIONS(1861),
    [anon_sym_atomicrmw] = ACTIONS(1861),
    [anon_sym_fence] = ACTIONS(1861),
    [anon_sym_getelementptr] = ACTIONS(1861),
    [anon_sym_extractvalue] = ACTIONS(1861),
    [anon_sym_insertvalue] = ACTIONS(1861),
    [anon_sym_mul] = ACTIONS(1861),
    [anon_sym_urem] = ACTIONS(1861),
    [anon_sym_srem] = ACTIONS(1861),
    [anon_sym_shl] = ACTIONS(1861),
    [anon_sym_udiv] = ACTIONS(1861),
    [anon_sym_sdiv] = ACTIONS(1861),
    [anon_sym_lshr] = ACTIONS(1861),
    [anon_sym_ashr] = ACTIONS(1861),
    [anon_sym_fmul] = ACTIONS(1861),
    [anon_sym_fdiv] = ACTIONS(1861),
    [anon_sym_frem] = ACTIONS(1861),
    [anon_sym_xchg] = ACTIONS(1861),
    [anon_sym_add] = ACTIONS(1861),
    [anon_sym_sub] = ACTIONS(1861),
    [anon_sym_and] = ACTIONS(1861),
    [anon_sym_nand] = ACTIONS(1861),
    [anon_sym_or] = ACTIONS(1861),
    [anon_sym_xor] = ACTIONS(1861),
    [anon_sym_max] = ACTIONS(1861),
    [anon_sym_min] = ACTIONS(1861),
    [anon_sym_umax] = ACTIONS(1861),
    [anon_sym_umin] = ACTIONS(1861),
    [anon_sym_fadd] = ACTIONS(1861),
    [anon_sym_fsub] = ACTIONS(1861),
    [anon_sym_bitcast] = ACTIONS(1861),
    [anon_sym_trunc] = ACTIONS(1861),
    [anon_sym_zext] = ACTIONS(1861),
    [anon_sym_sext] = ACTIONS(1861),
    [anon_sym_fptrunc] = ACTIONS(1861),
    [anon_sym_fpext] = ACTIONS(1861),
    [anon_sym_addrspacecast] = ACTIONS(1861),
    [anon_sym_uitofp] = ACTIONS(1861),
    [anon_sym_sitofp] = ACTIONS(1861),
    [anon_sym_fptoui] = ACTIONS(1861),
    [anon_sym_fptosi] = ACTIONS(1861),
    [anon_sym_inttoptr] = ACTIONS(1861),
    [anon_sym_ptrtoint] = ACTIONS(1861),
    [anon_sym_uselistorder] = ACTIONS(1861),
  },
  [583] = {
    [aux_sym_instruction_alloca_repeat1] = STATE(593),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1849),
    [sym_label] = ACTIONS(1849),
    [anon_sym_RBRACE] = ACTIONS(1849),
    [anon_sym_COMMA] = ACTIONS(1851),
    [anon_sym_unreachable] = ACTIONS(1854),
    [anon_sym_ret] = ACTIONS(1854),
    [anon_sym_br] = ACTIONS(1854),
    [anon_sym_resume] = ACTIONS(1854),
    [anon_sym_freeze] = ACTIONS(1854),
    [anon_sym_indirectbr] = ACTIONS(1854),
    [anon_sym_extractelement] = ACTIONS(1854),
    [anon_sym_insertelement] = ACTIONS(1854),
    [anon_sym_select] = ACTIONS(1854),
    [anon_sym_shufflevector] = ACTIONS(1854),
    [anon_sym_fneg] = ACTIONS(1854),
    [anon_sym_switch] = ACTIONS(1854),
    [anon_sym_invoke] = ACTIONS(1854),
    [anon_sym_cleanupret] = ACTIONS(1854),
    [anon_sym_catchret] = ACTIONS(1854),
    [anon_sym_catchswitch] = ACTIONS(1854),
    [anon_sym_catchpad] = ACTIONS(1854),
    [anon_sym_cleanuppad] = ACTIONS(1854),
    [anon_sym_callbr] = ACTIONS(1854),
    [anon_sym_icmp] = ACTIONS(1854),
    [anon_sym_fcmp] = ACTIONS(1854),
    [anon_sym_va_arg] = ACTIONS(1854),
    [anon_sym_phi] = ACTIONS(1854),
    [anon_sym_landingpad] = ACTIONS(1854),
    [anon_sym_tail] = ACTIONS(1854),
    [anon_sym_musttail] = ACTIONS(1854),
    [anon_sym_notail] = ACTIONS(1854),
    [anon_sym_call] = ACTIONS(1854),
    [anon_sym_alloca] = ACTIONS(1854),
    [anon_sym_load] = ACTIONS(1854),
    [anon_sym_store] = ACTIONS(1854),
    [anon_sym_cmpxchg] = ACTIONS(1854),
    [anon_sym_atomicrmw] = ACTIONS(1854),
    [anon_sym_fence] = ACTIONS(1854),
    [anon_sym_getelementptr] = ACTIONS(1854),
    [anon_sym_extractvalue] = ACTIONS(1854),
    [anon_sym_insertvalue] = ACTIONS(1854),
    [anon_sym_mul] = ACTIONS(1854),
    [anon_sym_urem] = ACTIONS(1854),
    [anon_sym_srem] = ACTIONS(1854),
    [anon_sym_shl] = ACTIONS(1854),
    [anon_sym_udiv] = ACTIONS(1854),
    [anon_sym_sdiv] = ACTIONS(1854),
    [anon_sym_lshr] = ACTIONS(1854),
    [anon_sym_ashr] = ACTIONS(1854),
    [anon_sym_fmul] = ACTIONS(1854),
    [anon_sym_fdiv] = ACTIONS(1854),
    [anon_sym_frem] = ACTIONS(1854),
    [anon_sym_xchg] = ACTIONS(1854),
    [anon_sym_add] = ACTIONS(1854),
    [anon_sym_sub] = ACTIONS(1854),
    [anon_sym_and] = ACTIONS(1854),
    [anon_sym_nand] = ACTIONS(1854),
    [anon_sym_or] = ACTIONS(1854),
    [anon_sym_xor] = ACTIONS(1854),
    [anon_sym_max] = ACTIONS(1854),
    [anon_sym_min] = ACTIONS(1854),
    [anon_sym_umax] = ACTIONS(1854),
    [anon_sym_umin] = ACTIONS(1854),
    [anon_sym_fadd] = ACTIONS(1854),
    [anon_sym_fsub] = ACTIONS(1854),
    [anon_sym_bitcast] = ACTIONS(1854),
    [anon_sym_trunc] = ACTIONS(1854),
    [anon_sym_zext] = ACTIONS(1854),
    [anon_sym_sext] = ACTIONS(1854),
    [anon_sym_fptrunc] = ACTIONS(1854),
    [anon_sym_fpext] = ACTIONS(1854),
    [anon_sym_addrspacecast] = ACTIONS(1854),
    [anon_sym_uitofp] = ACTIONS(1854),
    [anon_sym_sitofp] = ACTIONS(1854),
    [anon_sym_fptoui] = ACTIONS(1854),
    [anon_sym_fptosi] = ACTIONS(1854),
    [anon_sym_inttoptr] = ACTIONS(1854),
    [anon_sym_ptrtoint] = ACTIONS(1854),
    [anon_sym_uselistorder] = ACTIONS(1854),
  },
  [584] = {
    [aux_sym_instruction_getelementptr_repeat1] = STATE(597),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1863),
    [sym_label] = ACTIONS(1863),
    [anon_sym_RBRACE] = ACTIONS(1863),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_unreachable] = ACTIONS(1868),
    [anon_sym_ret] = ACTIONS(1868),
    [anon_sym_br] = ACTIONS(1868),
    [anon_sym_resume] = ACTIONS(1868),
    [anon_sym_freeze] = ACTIONS(1868),
    [anon_sym_indirectbr] = ACTIONS(1868),
    [anon_sym_extractelement] = ACTIONS(1868),
    [anon_sym_insertelement] = ACTIONS(1868),
    [anon_sym_select] = ACTIONS(1868),
    [anon_sym_shufflevector] = ACTIONS(1868),
    [anon_sym_fneg] = ACTIONS(1868),
    [anon_sym_switch] = ACTIONS(1868),
    [anon_sym_invoke] = ACTIONS(1868),
    [anon_sym_cleanupret] = ACTIONS(1868),
    [anon_sym_catchret] = ACTIONS(1868),
    [anon_sym_catchswitch] = ACTIONS(1868),
    [anon_sym_catchpad] = ACTIONS(1868),
    [anon_sym_cleanuppad] = ACTIONS(1868),
    [anon_sym_callbr] = ACTIONS(1868),
    [anon_sym_icmp] = ACTIONS(1868),
    [anon_sym_fcmp] = ACTIONS(1868),
    [anon_sym_va_arg] = ACTIONS(1868),
    [anon_sym_phi] = ACTIONS(1868),
    [anon_sym_landingpad] = ACTIONS(1868),
    [anon_sym_tail] = ACTIONS(1868),
    [anon_sym_musttail] = ACTIONS(1868),
    [anon_sym_notail] = ACTIONS(1868),
    [anon_sym_call] = ACTIONS(1868),
    [anon_sym_alloca] = ACTIONS(1868),
    [anon_sym_load] = ACTIONS(1868),
    [anon_sym_store] = ACTIONS(1868),
    [anon_sym_cmpxchg] = ACTIONS(1868),
    [anon_sym_atomicrmw] = ACTIONS(1868),
    [anon_sym_fence] = ACTIONS(1868),
    [anon_sym_getelementptr] = ACTIONS(1868),
    [anon_sym_extractvalue] = ACTIONS(1868),
    [anon_sym_insertvalue] = ACTIONS(1868),
    [anon_sym_mul] = ACTIONS(1868),
    [anon_sym_urem] = ACTIONS(1868),
    [anon_sym_srem] = ACTIONS(1868),
    [anon_sym_shl] = ACTIONS(1868),
    [anon_sym_udiv] = ACTIONS(1868),
    [anon_sym_sdiv] = ACTIONS(1868),
    [anon_sym_lshr] = ACTIONS(1868),
    [anon_sym_ashr] = ACTIONS(1868),
    [anon_sym_fmul] = ACTIONS(1868),
    [anon_sym_fdiv] = ACTIONS(1868),
    [anon_sym_frem] = ACTIONS(1868),
    [anon_sym_xchg] = ACTIONS(1868),
    [anon_sym_add] = ACTIONS(1868),
    [anon_sym_sub] = ACTIONS(1868),
    [anon_sym_and] = ACTIONS(1868),
    [anon_sym_nand] = ACTIONS(1868),
    [anon_sym_or] = ACTIONS(1868),
    [anon_sym_xor] = ACTIONS(1868),
    [anon_sym_max] = ACTIONS(1868),
    [anon_sym_min] = ACTIONS(1868),
    [anon_sym_umax] = ACTIONS(1868),
    [anon_sym_umin] = ACTIONS(1868),
    [anon_sym_fadd] = ACTIONS(1868),
    [anon_sym_fsub] = ACTIONS(1868),
    [anon_sym_bitcast] = ACTIONS(1868),
    [anon_sym_trunc] = ACTIONS(1868),
    [anon_sym_zext] = ACTIONS(1868),
    [anon_sym_sext] = ACTIONS(1868),
    [anon_sym_fptrunc] = ACTIONS(1868),
    [anon_sym_fpext] = ACTIONS(1868),
    [anon_sym_addrspacecast] = ACTIONS(1868),
    [anon_sym_uitofp] = ACTIONS(1868),
    [anon_sym_sitofp] = ACTIONS(1868),
    [anon_sym_fptoui] = ACTIONS(1868),
    [anon_sym_fptosi] = ACTIONS(1868),
    [anon_sym_inttoptr] = ACTIONS(1868),
    [anon_sym_ptrtoint] = ACTIONS(1868),
    [anon_sym_uselistorder] = ACTIONS(1868),
  },
  [585] = {
    [aux_sym_instruction_getelementptr_repeat1] = STATE(594),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1863),
    [sym_label] = ACTIONS(1863),
    [anon_sym_RBRACE] = ACTIONS(1863),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_unreachable] = ACTIONS(1868),
    [anon_sym_ret] = ACTIONS(1868),
    [anon_sym_br] = ACTIONS(1868),
    [anon_sym_resume] = ACTIONS(1868),
    [anon_sym_freeze] = ACTIONS(1868),
    [anon_sym_indirectbr] = ACTIONS(1868),
    [anon_sym_extractelement] = ACTIONS(1868),
    [anon_sym_insertelement] = ACTIONS(1868),
    [anon_sym_select] = ACTIONS(1868),
    [anon_sym_shufflevector] = ACTIONS(1868),
    [anon_sym_fneg] = ACTIONS(1868),
    [anon_sym_switch] = ACTIONS(1868),
    [anon_sym_invoke] = ACTIONS(1868),
    [anon_sym_cleanupret] = ACTIONS(1868),
    [anon_sym_catchret] = ACTIONS(1868),
    [anon_sym_catchswitch] = ACTIONS(1868),
    [anon_sym_catchpad] = ACTIONS(1868),
    [anon_sym_cleanuppad] = ACTIONS(1868),
    [anon_sym_callbr] = ACTIONS(1868),
    [anon_sym_icmp] = ACTIONS(1868),
    [anon_sym_fcmp] = ACTIONS(1868),
    [anon_sym_va_arg] = ACTIONS(1868),
    [anon_sym_phi] = ACTIONS(1868),
    [anon_sym_landingpad] = ACTIONS(1868),
    [anon_sym_tail] = ACTIONS(1868),
    [anon_sym_musttail] = ACTIONS(1868),
    [anon_sym_notail] = ACTIONS(1868),
    [anon_sym_call] = ACTIONS(1868),
    [anon_sym_alloca] = ACTIONS(1868),
    [anon_sym_load] = ACTIONS(1868),
    [anon_sym_store] = ACTIONS(1868),
    [anon_sym_cmpxchg] = ACTIONS(1868),
    [anon_sym_atomicrmw] = ACTIONS(1868),
    [anon_sym_fence] = ACTIONS(1868),
    [anon_sym_getelementptr] = ACTIONS(1868),
    [anon_sym_extractvalue] = ACTIONS(1868),
    [anon_sym_insertvalue] = ACTIONS(1868),
    [anon_sym_mul] = ACTIONS(1868),
    [anon_sym_urem] = ACTIONS(1868),
    [anon_sym_srem] = ACTIONS(1868),
    [anon_sym_shl] = ACTIONS(1868),
    [anon_sym_udiv] = ACTIONS(1868),
    [anon_sym_sdiv] = ACTIONS(1868),
    [anon_sym_lshr] = ACTIONS(1868),
    [anon_sym_ashr] = ACTIONS(1868),
    [anon_sym_fmul] = ACTIONS(1868),
    [anon_sym_fdiv] = ACTIONS(1868),
    [anon_sym_frem] = ACTIONS(1868),
    [anon_sym_xchg] = ACTIONS(1868),
    [anon_sym_add] = ACTIONS(1868),
    [anon_sym_sub] = ACTIONS(1868),
    [anon_sym_and] = ACTIONS(1868),
    [anon_sym_nand] = ACTIONS(1868),
    [anon_sym_or] = ACTIONS(1868),
    [anon_sym_xor] = ACTIONS(1868),
    [anon_sym_max] = ACTIONS(1868),
    [anon_sym_min] = ACTIONS(1868),
    [anon_sym_umax] = ACTIONS(1868),
    [anon_sym_umin] = ACTIONS(1868),
    [anon_sym_fadd] = ACTIONS(1868),
    [anon_sym_fsub] = ACTIONS(1868),
    [anon_sym_bitcast] = ACTIONS(1868),
    [anon_sym_trunc] = ACTIONS(1868),
    [anon_sym_zext] = ACTIONS(1868),
    [anon_sym_sext] = ACTIONS(1868),
    [anon_sym_fptrunc] = ACTIONS(1868),
    [anon_sym_fpext] = ACTIONS(1868),
    [anon_sym_addrspacecast] = ACTIONS(1868),
    [anon_sym_uitofp] = ACTIONS(1868),
    [anon_sym_sitofp] = ACTIONS(1868),
    [anon_sym_fptoui] = ACTIONS(1868),
    [anon_sym_fptosi] = ACTIONS(1868),
    [anon_sym_inttoptr] = ACTIONS(1868),
    [anon_sym_ptrtoint] = ACTIONS(1868),
    [anon_sym_uselistorder] = ACTIONS(1868),
  },
  [586] = {
    [aux_sym_instruction_phi_repeat1] = STATE(587),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1870),
    [sym_label] = ACTIONS(1870),
    [anon_sym_RBRACE] = ACTIONS(1870),
    [anon_sym_COMMA] = ACTIONS(1872),
    [anon_sym_unreachable] = ACTIONS(1875),
    [anon_sym_ret] = ACTIONS(1875),
    [anon_sym_br] = ACTIONS(1875),
    [anon_sym_resume] = ACTIONS(1875),
    [anon_sym_freeze] = ACTIONS(1875),
    [anon_sym_indirectbr] = ACTIONS(1875),
    [anon_sym_extractelement] = ACTIONS(1875),
    [anon_sym_insertelement] = ACTIONS(1875),
    [anon_sym_select] = ACTIONS(1875),
    [anon_sym_shufflevector] = ACTIONS(1875),
    [anon_sym_fneg] = ACTIONS(1875),
    [anon_sym_switch] = ACTIONS(1875),
    [anon_sym_invoke] = ACTIONS(1875),
    [anon_sym_cleanupret] = ACTIONS(1875),
    [anon_sym_catchret] = ACTIONS(1875),
    [anon_sym_catchswitch] = ACTIONS(1875),
    [anon_sym_catchpad] = ACTIONS(1875),
    [anon_sym_cleanuppad] = ACTIONS(1875),
    [anon_sym_callbr] = ACTIONS(1875),
    [anon_sym_icmp] = ACTIONS(1875),
    [anon_sym_fcmp] = ACTIONS(1875),
    [anon_sym_va_arg] = ACTIONS(1875),
    [anon_sym_phi] = ACTIONS(1875),
    [anon_sym_landingpad] = ACTIONS(1875),
    [anon_sym_tail] = ACTIONS(1875),
    [anon_sym_musttail] = ACTIONS(1875),
    [anon_sym_notail] = ACTIONS(1875),
    [anon_sym_call] = ACTIONS(1875),
    [anon_sym_alloca] = ACTIONS(1875),
    [anon_sym_load] = ACTIONS(1875),
    [anon_sym_store] = ACTIONS(1875),
    [anon_sym_cmpxchg] = ACTIONS(1875),
    [anon_sym_atomicrmw] = ACTIONS(1875),
    [anon_sym_fence] = ACTIONS(1875),
    [anon_sym_getelementptr] = ACTIONS(1875),
    [anon_sym_extractvalue] = ACTIONS(1875),
    [anon_sym_insertvalue] = ACTIONS(1875),
    [anon_sym_mul] = ACTIONS(1875),
    [anon_sym_urem] = ACTIONS(1875),
    [anon_sym_srem] = ACTIONS(1875),
    [anon_sym_shl] = ACTIONS(1875),
    [anon_sym_udiv] = ACTIONS(1875),
    [anon_sym_sdiv] = ACTIONS(1875),
    [anon_sym_lshr] = ACTIONS(1875),
    [anon_sym_ashr] = ACTIONS(1875),
    [anon_sym_fmul] = ACTIONS(1875),
    [anon_sym_fdiv] = ACTIONS(1875),
    [anon_sym_frem] = ACTIONS(1875),
    [anon_sym_xchg] = ACTIONS(1875),
    [anon_sym_add] = ACTIONS(1875),
    [anon_sym_sub] = ACTIONS(1875),
    [anon_sym_and] = ACTIONS(1875),
    [anon_sym_nand] = ACTIONS(1875),
    [anon_sym_or] = ACTIONS(1875),
    [anon_sym_xor] = ACTIONS(1875),
    [anon_sym_max] = ACTIONS(1875),
    [anon_sym_min] = ACTIONS(1875),
    [anon_sym_umax] = ACTIONS(1875),
    [anon_sym_umin] = ACTIONS(1875),
    [anon_sym_fadd] = ACTIONS(1875),
    [anon_sym_fsub] = ACTIONS(1875),
    [anon_sym_bitcast] = ACTIONS(1875),
    [anon_sym_trunc] = ACTIONS(1875),
    [anon_sym_zext] = ACTIONS(1875),
    [anon_sym_sext] = ACTIONS(1875),
    [anon_sym_fptrunc] = ACTIONS(1875),
    [anon_sym_fpext] = ACTIONS(1875),
    [anon_sym_addrspacecast] = ACTIONS(1875),
    [anon_sym_uitofp] = ACTIONS(1875),
    [anon_sym_sitofp] = ACTIONS(1875),
    [anon_sym_fptoui] = ACTIONS(1875),
    [anon_sym_fptosi] = ACTIONS(1875),
    [anon_sym_inttoptr] = ACTIONS(1875),
    [anon_sym_ptrtoint] = ACTIONS(1875),
    [anon_sym_uselistorder] = ACTIONS(1875),
  },
  [587] = {
    [aux_sym_instruction_phi_repeat1] = STATE(589),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1877),
    [sym_label] = ACTIONS(1877),
    [anon_sym_RBRACE] = ACTIONS(1877),
    [anon_sym_COMMA] = ACTIONS(1879),
    [anon_sym_unreachable] = ACTIONS(1882),
    [anon_sym_ret] = ACTIONS(1882),
    [anon_sym_br] = ACTIONS(1882),
    [anon_sym_resume] = ACTIONS(1882),
    [anon_sym_freeze] = ACTIONS(1882),
    [anon_sym_indirectbr] = ACTIONS(1882),
    [anon_sym_extractelement] = ACTIONS(1882),
    [anon_sym_insertelement] = ACTIONS(1882),
    [anon_sym_select] = ACTIONS(1882),
    [anon_sym_shufflevector] = ACTIONS(1882),
    [anon_sym_fneg] = ACTIONS(1882),
    [anon_sym_switch] = ACTIONS(1882),
    [anon_sym_invoke] = ACTIONS(1882),
    [anon_sym_cleanupret] = ACTIONS(1882),
    [anon_sym_catchret] = ACTIONS(1882),
    [anon_sym_catchswitch] = ACTIONS(1882),
    [anon_sym_catchpad] = ACTIONS(1882),
    [anon_sym_cleanuppad] = ACTIONS(1882),
    [anon_sym_callbr] = ACTIONS(1882),
    [anon_sym_icmp] = ACTIONS(1882),
    [anon_sym_fcmp] = ACTIONS(1882),
    [anon_sym_va_arg] = ACTIONS(1882),
    [anon_sym_phi] = ACTIONS(1882),
    [anon_sym_landingpad] = ACTIONS(1882),
    [anon_sym_tail] = ACTIONS(1882),
    [anon_sym_musttail] = ACTIONS(1882),
    [anon_sym_notail] = ACTIONS(1882),
    [anon_sym_call] = ACTIONS(1882),
    [anon_sym_alloca] = ACTIONS(1882),
    [anon_sym_load] = ACTIONS(1882),
    [anon_sym_store] = ACTIONS(1882),
    [anon_sym_cmpxchg] = ACTIONS(1882),
    [anon_sym_atomicrmw] = ACTIONS(1882),
    [anon_sym_fence] = ACTIONS(1882),
    [anon_sym_getelementptr] = ACTIONS(1882),
    [anon_sym_extractvalue] = ACTIONS(1882),
    [anon_sym_insertvalue] = ACTIONS(1882),
    [anon_sym_mul] = ACTIONS(1882),
    [anon_sym_urem] = ACTIONS(1882),
    [anon_sym_srem] = ACTIONS(1882),
    [anon_sym_shl] = ACTIONS(1882),
    [anon_sym_udiv] = ACTIONS(1882),
    [anon_sym_sdiv] = ACTIONS(1882),
    [anon_sym_lshr] = ACTIONS(1882),
    [anon_sym_ashr] = ACTIONS(1882),
    [anon_sym_fmul] = ACTIONS(1882),
    [anon_sym_fdiv] = ACTIONS(1882),
    [anon_sym_frem] = ACTIONS(1882),
    [anon_sym_xchg] = ACTIONS(1882),
    [anon_sym_add] = ACTIONS(1882),
    [anon_sym_sub] = ACTIONS(1882),
    [anon_sym_and] = ACTIONS(1882),
    [anon_sym_nand] = ACTIONS(1882),
    [anon_sym_or] = ACTIONS(1882),
    [anon_sym_xor] = ACTIONS(1882),
    [anon_sym_max] = ACTIONS(1882),
    [anon_sym_min] = ACTIONS(1882),
    [anon_sym_umax] = ACTIONS(1882),
    [anon_sym_umin] = ACTIONS(1882),
    [anon_sym_fadd] = ACTIONS(1882),
    [anon_sym_fsub] = ACTIONS(1882),
    [anon_sym_bitcast] = ACTIONS(1882),
    [anon_sym_trunc] = ACTIONS(1882),
    [anon_sym_zext] = ACTIONS(1882),
    [anon_sym_sext] = ACTIONS(1882),
    [anon_sym_fptrunc] = ACTIONS(1882),
    [anon_sym_fpext] = ACTIONS(1882),
    [anon_sym_addrspacecast] = ACTIONS(1882),
    [anon_sym_uitofp] = ACTIONS(1882),
    [anon_sym_sitofp] = ACTIONS(1882),
    [anon_sym_fptoui] = ACTIONS(1882),
    [anon_sym_fptosi] = ACTIONS(1882),
    [anon_sym_inttoptr] = ACTIONS(1882),
    [anon_sym_ptrtoint] = ACTIONS(1882),
    [anon_sym_uselistorder] = ACTIONS(1882),
  },
  [588] = {
    [aux_sym_instruction_phi_repeat1] = STATE(590),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1877),
    [sym_label] = ACTIONS(1877),
    [anon_sym_RBRACE] = ACTIONS(1877),
    [anon_sym_COMMA] = ACTIONS(1879),
    [anon_sym_unreachable] = ACTIONS(1882),
    [anon_sym_ret] = ACTIONS(1882),
    [anon_sym_br] = ACTIONS(1882),
    [anon_sym_resume] = ACTIONS(1882),
    [anon_sym_freeze] = ACTIONS(1882),
    [anon_sym_indirectbr] = ACTIONS(1882),
    [anon_sym_extractelement] = ACTIONS(1882),
    [anon_sym_insertelement] = ACTIONS(1882),
    [anon_sym_select] = ACTIONS(1882),
    [anon_sym_shufflevector] = ACTIONS(1882),
    [anon_sym_fneg] = ACTIONS(1882),
    [anon_sym_switch] = ACTIONS(1882),
    [anon_sym_invoke] = ACTIONS(1882),
    [anon_sym_cleanupret] = ACTIONS(1882),
    [anon_sym_catchret] = ACTIONS(1882),
    [anon_sym_catchswitch] = ACTIONS(1882),
    [anon_sym_catchpad] = ACTIONS(1882),
    [anon_sym_cleanuppad] = ACTIONS(1882),
    [anon_sym_callbr] = ACTIONS(1882),
    [anon_sym_icmp] = ACTIONS(1882),
    [anon_sym_fcmp] = ACTIONS(1882),
    [anon_sym_va_arg] = ACTIONS(1882),
    [anon_sym_phi] = ACTIONS(1882),
    [anon_sym_landingpad] = ACTIONS(1882),
    [anon_sym_tail] = ACTIONS(1882),
    [anon_sym_musttail] = ACTIONS(1882),
    [anon_sym_notail] = ACTIONS(1882),
    [anon_sym_call] = ACTIONS(1882),
    [anon_sym_alloca] = ACTIONS(1882),
    [anon_sym_load] = ACTIONS(1882),
    [anon_sym_store] = ACTIONS(1882),
    [anon_sym_cmpxchg] = ACTIONS(1882),
    [anon_sym_atomicrmw] = ACTIONS(1882),
    [anon_sym_fence] = ACTIONS(1882),
    [anon_sym_getelementptr] = ACTIONS(1882),
    [anon_sym_extractvalue] = ACTIONS(1882),
    [anon_sym_insertvalue] = ACTIONS(1882),
    [anon_sym_mul] = ACTIONS(1882),
    [anon_sym_urem] = ACTIONS(1882),
    [anon_sym_srem] = ACTIONS(1882),
    [anon_sym_shl] = ACTIONS(1882),
    [anon_sym_udiv] = ACTIONS(1882),
    [anon_sym_sdiv] = ACTIONS(1882),
    [anon_sym_lshr] = ACTIONS(1882),
    [anon_sym_ashr] = ACTIONS(1882),
    [anon_sym_fmul] = ACTIONS(1882),
    [anon_sym_fdiv] = ACTIONS(1882),
    [anon_sym_frem] = ACTIONS(1882),
    [anon_sym_xchg] = ACTIONS(1882),
    [anon_sym_add] = ACTIONS(1882),
    [anon_sym_sub] = ACTIONS(1882),
    [anon_sym_and] = ACTIONS(1882),
    [anon_sym_nand] = ACTIONS(1882),
    [anon_sym_or] = ACTIONS(1882),
    [anon_sym_xor] = ACTIONS(1882),
    [anon_sym_max] = ACTIONS(1882),
    [anon_sym_min] = ACTIONS(1882),
    [anon_sym_umax] = ACTIONS(1882),
    [anon_sym_umin] = ACTIONS(1882),
    [anon_sym_fadd] = ACTIONS(1882),
    [anon_sym_fsub] = ACTIONS(1882),
    [anon_sym_bitcast] = ACTIONS(1882),
    [anon_sym_trunc] = ACTIONS(1882),
    [anon_sym_zext] = ACTIONS(1882),
    [anon_sym_sext] = ACTIONS(1882),
    [anon_sym_fptrunc] = ACTIONS(1882),
    [anon_sym_fpext] = ACTIONS(1882),
    [anon_sym_addrspacecast] = ACTIONS(1882),
    [anon_sym_uitofp] = ACTIONS(1882),
    [anon_sym_sitofp] = ACTIONS(1882),
    [anon_sym_fptoui] = ACTIONS(1882),
    [anon_sym_fptosi] = ACTIONS(1882),
    [anon_sym_inttoptr] = ACTIONS(1882),
    [anon_sym_ptrtoint] = ACTIONS(1882),
    [anon_sym_uselistorder] = ACTIONS(1882),
  },
  [589] = {
    [aux_sym_instruction_phi_repeat1] = STATE(589),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1884),
    [sym_label] = ACTIONS(1884),
    [anon_sym_RBRACE] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(1886),
    [anon_sym_unreachable] = ACTIONS(1889),
    [anon_sym_ret] = ACTIONS(1889),
    [anon_sym_br] = ACTIONS(1889),
    [anon_sym_resume] = ACTIONS(1889),
    [anon_sym_freeze] = ACTIONS(1889),
    [anon_sym_indirectbr] = ACTIONS(1889),
    [anon_sym_extractelement] = ACTIONS(1889),
    [anon_sym_insertelement] = ACTIONS(1889),
    [anon_sym_select] = ACTIONS(1889),
    [anon_sym_shufflevector] = ACTIONS(1889),
    [anon_sym_fneg] = ACTIONS(1889),
    [anon_sym_switch] = ACTIONS(1889),
    [anon_sym_invoke] = ACTIONS(1889),
    [anon_sym_cleanupret] = ACTIONS(1889),
    [anon_sym_catchret] = ACTIONS(1889),
    [anon_sym_catchswitch] = ACTIONS(1889),
    [anon_sym_catchpad] = ACTIONS(1889),
    [anon_sym_cleanuppad] = ACTIONS(1889),
    [anon_sym_callbr] = ACTIONS(1889),
    [anon_sym_icmp] = ACTIONS(1889),
    [anon_sym_fcmp] = ACTIONS(1889),
    [anon_sym_va_arg] = ACTIONS(1889),
    [anon_sym_phi] = ACTIONS(1889),
    [anon_sym_landingpad] = ACTIONS(1889),
    [anon_sym_tail] = ACTIONS(1889),
    [anon_sym_musttail] = ACTIONS(1889),
    [anon_sym_notail] = ACTIONS(1889),
    [anon_sym_call] = ACTIONS(1889),
    [anon_sym_alloca] = ACTIONS(1889),
    [anon_sym_load] = ACTIONS(1889),
    [anon_sym_store] = ACTIONS(1889),
    [anon_sym_cmpxchg] = ACTIONS(1889),
    [anon_sym_atomicrmw] = ACTIONS(1889),
    [anon_sym_fence] = ACTIONS(1889),
    [anon_sym_getelementptr] = ACTIONS(1889),
    [anon_sym_extractvalue] = ACTIONS(1889),
    [anon_sym_insertvalue] = ACTIONS(1889),
    [anon_sym_mul] = ACTIONS(1889),
    [anon_sym_urem] = ACTIONS(1889),
    [anon_sym_srem] = ACTIONS(1889),
    [anon_sym_shl] = ACTIONS(1889),
    [anon_sym_udiv] = ACTIONS(1889),
    [anon_sym_sdiv] = ACTIONS(1889),
    [anon_sym_lshr] = ACTIONS(1889),
    [anon_sym_ashr] = ACTIONS(1889),
    [anon_sym_fmul] = ACTIONS(1889),
    [anon_sym_fdiv] = ACTIONS(1889),
    [anon_sym_frem] = ACTIONS(1889),
    [anon_sym_xchg] = ACTIONS(1889),
    [anon_sym_add] = ACTIONS(1889),
    [anon_sym_sub] = ACTIONS(1889),
    [anon_sym_and] = ACTIONS(1889),
    [anon_sym_nand] = ACTIONS(1889),
    [anon_sym_or] = ACTIONS(1889),
    [anon_sym_xor] = ACTIONS(1889),
    [anon_sym_max] = ACTIONS(1889),
    [anon_sym_min] = ACTIONS(1889),
    [anon_sym_umax] = ACTIONS(1889),
    [anon_sym_umin] = ACTIONS(1889),
    [anon_sym_fadd] = ACTIONS(1889),
    [anon_sym_fsub] = ACTIONS(1889),
    [anon_sym_bitcast] = ACTIONS(1889),
    [anon_sym_trunc] = ACTIONS(1889),
    [anon_sym_zext] = ACTIONS(1889),
    [anon_sym_sext] = ACTIONS(1889),
    [anon_sym_fptrunc] = ACTIONS(1889),
    [anon_sym_fpext] = ACTIONS(1889),
    [anon_sym_addrspacecast] = ACTIONS(1889),
    [anon_sym_uitofp] = ACTIONS(1889),
    [anon_sym_sitofp] = ACTIONS(1889),
    [anon_sym_fptoui] = ACTIONS(1889),
    [anon_sym_fptosi] = ACTIONS(1889),
    [anon_sym_inttoptr] = ACTIONS(1889),
    [anon_sym_ptrtoint] = ACTIONS(1889),
    [anon_sym_uselistorder] = ACTIONS(1889),
  },
  [590] = {
    [aux_sym_instruction_phi_repeat1] = STATE(589),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1891),
    [sym_label] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_COMMA] = ACTIONS(1893),
    [anon_sym_unreachable] = ACTIONS(1896),
    [anon_sym_ret] = ACTIONS(1896),
    [anon_sym_br] = ACTIONS(1896),
    [anon_sym_resume] = ACTIONS(1896),
    [anon_sym_freeze] = ACTIONS(1896),
    [anon_sym_indirectbr] = ACTIONS(1896),
    [anon_sym_extractelement] = ACTIONS(1896),
    [anon_sym_insertelement] = ACTIONS(1896),
    [anon_sym_select] = ACTIONS(1896),
    [anon_sym_shufflevector] = ACTIONS(1896),
    [anon_sym_fneg] = ACTIONS(1896),
    [anon_sym_switch] = ACTIONS(1896),
    [anon_sym_invoke] = ACTIONS(1896),
    [anon_sym_cleanupret] = ACTIONS(1896),
    [anon_sym_catchret] = ACTIONS(1896),
    [anon_sym_catchswitch] = ACTIONS(1896),
    [anon_sym_catchpad] = ACTIONS(1896),
    [anon_sym_cleanuppad] = ACTIONS(1896),
    [anon_sym_callbr] = ACTIONS(1896),
    [anon_sym_icmp] = ACTIONS(1896),
    [anon_sym_fcmp] = ACTIONS(1896),
    [anon_sym_va_arg] = ACTIONS(1896),
    [anon_sym_phi] = ACTIONS(1896),
    [anon_sym_landingpad] = ACTIONS(1896),
    [anon_sym_tail] = ACTIONS(1896),
    [anon_sym_musttail] = ACTIONS(1896),
    [anon_sym_notail] = ACTIONS(1896),
    [anon_sym_call] = ACTIONS(1896),
    [anon_sym_alloca] = ACTIONS(1896),
    [anon_sym_load] = ACTIONS(1896),
    [anon_sym_store] = ACTIONS(1896),
    [anon_sym_cmpxchg] = ACTIONS(1896),
    [anon_sym_atomicrmw] = ACTIONS(1896),
    [anon_sym_fence] = ACTIONS(1896),
    [anon_sym_getelementptr] = ACTIONS(1896),
    [anon_sym_extractvalue] = ACTIONS(1896),
    [anon_sym_insertvalue] = ACTIONS(1896),
    [anon_sym_mul] = ACTIONS(1896),
    [anon_sym_urem] = ACTIONS(1896),
    [anon_sym_srem] = ACTIONS(1896),
    [anon_sym_shl] = ACTIONS(1896),
    [anon_sym_udiv] = ACTIONS(1896),
    [anon_sym_sdiv] = ACTIONS(1896),
    [anon_sym_lshr] = ACTIONS(1896),
    [anon_sym_ashr] = ACTIONS(1896),
    [anon_sym_fmul] = ACTIONS(1896),
    [anon_sym_fdiv] = ACTIONS(1896),
    [anon_sym_frem] = ACTIONS(1896),
    [anon_sym_xchg] = ACTIONS(1896),
    [anon_sym_add] = ACTIONS(1896),
    [anon_sym_sub] = ACTIONS(1896),
    [anon_sym_and] = ACTIONS(1896),
    [anon_sym_nand] = ACTIONS(1896),
    [anon_sym_or] = ACTIONS(1896),
    [anon_sym_xor] = ACTIONS(1896),
    [anon_sym_max] = ACTIONS(1896),
    [anon_sym_min] = ACTIONS(1896),
    [anon_sym_umax] = ACTIONS(1896),
    [anon_sym_umin] = ACTIONS(1896),
    [anon_sym_fadd] = ACTIONS(1896),
    [anon_sym_fsub] = ACTIONS(1896),
    [anon_sym_bitcast] = ACTIONS(1896),
    [anon_sym_trunc] = ACTIONS(1896),
    [anon_sym_zext] = ACTIONS(1896),
    [anon_sym_sext] = ACTIONS(1896),
    [anon_sym_fptrunc] = ACTIONS(1896),
    [anon_sym_fpext] = ACTIONS(1896),
    [anon_sym_addrspacecast] = ACTIONS(1896),
    [anon_sym_uitofp] = ACTIONS(1896),
    [anon_sym_sitofp] = ACTIONS(1896),
    [anon_sym_fptoui] = ACTIONS(1896),
    [anon_sym_fptosi] = ACTIONS(1896),
    [anon_sym_inttoptr] = ACTIONS(1896),
    [anon_sym_ptrtoint] = ACTIONS(1896),
    [anon_sym_uselistorder] = ACTIONS(1896),
  },
  [591] = {
    [aux_sym_instruction_extractvalue_repeat1] = STATE(582),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1898),
    [sym_label] = ACTIONS(1898),
    [anon_sym_RBRACE] = ACTIONS(1898),
    [anon_sym_COMMA] = ACTIONS(1900),
    [anon_sym_unreachable] = ACTIONS(1903),
    [anon_sym_ret] = ACTIONS(1903),
    [anon_sym_br] = ACTIONS(1903),
    [anon_sym_resume] = ACTIONS(1903),
    [anon_sym_freeze] = ACTIONS(1903),
    [anon_sym_indirectbr] = ACTIONS(1903),
    [anon_sym_extractelement] = ACTIONS(1903),
    [anon_sym_insertelement] = ACTIONS(1903),
    [anon_sym_select] = ACTIONS(1903),
    [anon_sym_shufflevector] = ACTIONS(1903),
    [anon_sym_fneg] = ACTIONS(1903),
    [anon_sym_switch] = ACTIONS(1903),
    [anon_sym_invoke] = ACTIONS(1903),
    [anon_sym_cleanupret] = ACTIONS(1903),
    [anon_sym_catchret] = ACTIONS(1903),
    [anon_sym_catchswitch] = ACTIONS(1903),
    [anon_sym_catchpad] = ACTIONS(1903),
    [anon_sym_cleanuppad] = ACTIONS(1903),
    [anon_sym_callbr] = ACTIONS(1903),
    [anon_sym_icmp] = ACTIONS(1903),
    [anon_sym_fcmp] = ACTIONS(1903),
    [anon_sym_va_arg] = ACTIONS(1903),
    [anon_sym_phi] = ACTIONS(1903),
    [anon_sym_landingpad] = ACTIONS(1903),
    [anon_sym_tail] = ACTIONS(1903),
    [anon_sym_musttail] = ACTIONS(1903),
    [anon_sym_notail] = ACTIONS(1903),
    [anon_sym_call] = ACTIONS(1903),
    [anon_sym_alloca] = ACTIONS(1903),
    [anon_sym_load] = ACTIONS(1903),
    [anon_sym_store] = ACTIONS(1903),
    [anon_sym_cmpxchg] = ACTIONS(1903),
    [anon_sym_atomicrmw] = ACTIONS(1903),
    [anon_sym_fence] = ACTIONS(1903),
    [anon_sym_getelementptr] = ACTIONS(1903),
    [anon_sym_extractvalue] = ACTIONS(1903),
    [anon_sym_insertvalue] = ACTIONS(1903),
    [anon_sym_mul] = ACTIONS(1903),
    [anon_sym_urem] = ACTIONS(1903),
    [anon_sym_srem] = ACTIONS(1903),
    [anon_sym_shl] = ACTIONS(1903),
    [anon_sym_udiv] = ACTIONS(1903),
    [anon_sym_sdiv] = ACTIONS(1903),
    [anon_sym_lshr] = ACTIONS(1903),
    [anon_sym_ashr] = ACTIONS(1903),
    [anon_sym_fmul] = ACTIONS(1903),
    [anon_sym_fdiv] = ACTIONS(1903),
    [anon_sym_frem] = ACTIONS(1903),
    [anon_sym_xchg] = ACTIONS(1903),
    [anon_sym_add] = ACTIONS(1903),
    [anon_sym_sub] = ACTIONS(1903),
    [anon_sym_and] = ACTIONS(1903),
    [anon_sym_nand] = ACTIONS(1903),
    [anon_sym_or] = ACTIONS(1903),
    [anon_sym_xor] = ACTIONS(1903),
    [anon_sym_max] = ACTIONS(1903),
    [anon_sym_min] = ACTIONS(1903),
    [anon_sym_umax] = ACTIONS(1903),
    [anon_sym_umin] = ACTIONS(1903),
    [anon_sym_fadd] = ACTIONS(1903),
    [anon_sym_fsub] = ACTIONS(1903),
    [anon_sym_bitcast] = ACTIONS(1903),
    [anon_sym_trunc] = ACTIONS(1903),
    [anon_sym_zext] = ACTIONS(1903),
    [anon_sym_sext] = ACTIONS(1903),
    [anon_sym_fptrunc] = ACTIONS(1903),
    [anon_sym_fpext] = ACTIONS(1903),
    [anon_sym_addrspacecast] = ACTIONS(1903),
    [anon_sym_uitofp] = ACTIONS(1903),
    [anon_sym_sitofp] = ACTIONS(1903),
    [anon_sym_fptoui] = ACTIONS(1903),
    [anon_sym_fptosi] = ACTIONS(1903),
    [anon_sym_inttoptr] = ACTIONS(1903),
    [anon_sym_ptrtoint] = ACTIONS(1903),
    [anon_sym_uselistorder] = ACTIONS(1903),
  },
  [592] = {
    [aux_sym_instruction_extractvalue_repeat1] = STATE(606),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1905),
    [sym_label] = ACTIONS(1905),
    [anon_sym_RBRACE] = ACTIONS(1905),
    [anon_sym_COMMA] = ACTIONS(1907),
    [anon_sym_unreachable] = ACTIONS(1910),
    [anon_sym_ret] = ACTIONS(1910),
    [anon_sym_br] = ACTIONS(1910),
    [anon_sym_resume] = ACTIONS(1910),
    [anon_sym_freeze] = ACTIONS(1910),
    [anon_sym_indirectbr] = ACTIONS(1910),
    [anon_sym_extractelement] = ACTIONS(1910),
    [anon_sym_insertelement] = ACTIONS(1910),
    [anon_sym_select] = ACTIONS(1910),
    [anon_sym_shufflevector] = ACTIONS(1910),
    [anon_sym_fneg] = ACTIONS(1910),
    [anon_sym_switch] = ACTIONS(1910),
    [anon_sym_invoke] = ACTIONS(1910),
    [anon_sym_cleanupret] = ACTIONS(1910),
    [anon_sym_catchret] = ACTIONS(1910),
    [anon_sym_catchswitch] = ACTIONS(1910),
    [anon_sym_catchpad] = ACTIONS(1910),
    [anon_sym_cleanuppad] = ACTIONS(1910),
    [anon_sym_callbr] = ACTIONS(1910),
    [anon_sym_icmp] = ACTIONS(1910),
    [anon_sym_fcmp] = ACTIONS(1910),
    [anon_sym_va_arg] = ACTIONS(1910),
    [anon_sym_phi] = ACTIONS(1910),
    [anon_sym_landingpad] = ACTIONS(1910),
    [anon_sym_tail] = ACTIONS(1910),
    [anon_sym_musttail] = ACTIONS(1910),
    [anon_sym_notail] = ACTIONS(1910),
    [anon_sym_call] = ACTIONS(1910),
    [anon_sym_alloca] = ACTIONS(1910),
    [anon_sym_load] = ACTIONS(1910),
    [anon_sym_store] = ACTIONS(1910),
    [anon_sym_cmpxchg] = ACTIONS(1910),
    [anon_sym_atomicrmw] = ACTIONS(1910),
    [anon_sym_fence] = ACTIONS(1910),
    [anon_sym_getelementptr] = ACTIONS(1910),
    [anon_sym_extractvalue] = ACTIONS(1910),
    [anon_sym_insertvalue] = ACTIONS(1910),
    [anon_sym_mul] = ACTIONS(1910),
    [anon_sym_urem] = ACTIONS(1910),
    [anon_sym_srem] = ACTIONS(1910),
    [anon_sym_shl] = ACTIONS(1910),
    [anon_sym_udiv] = ACTIONS(1910),
    [anon_sym_sdiv] = ACTIONS(1910),
    [anon_sym_lshr] = ACTIONS(1910),
    [anon_sym_ashr] = ACTIONS(1910),
    [anon_sym_fmul] = ACTIONS(1910),
    [anon_sym_fdiv] = ACTIONS(1910),
    [anon_sym_frem] = ACTIONS(1910),
    [anon_sym_xchg] = ACTIONS(1910),
    [anon_sym_add] = ACTIONS(1910),
    [anon_sym_sub] = ACTIONS(1910),
    [anon_sym_and] = ACTIONS(1910),
    [anon_sym_nand] = ACTIONS(1910),
    [anon_sym_or] = ACTIONS(1910),
    [anon_sym_xor] = ACTIONS(1910),
    [anon_sym_max] = ACTIONS(1910),
    [anon_sym_min] = ACTIONS(1910),
    [anon_sym_umax] = ACTIONS(1910),
    [anon_sym_umin] = ACTIONS(1910),
    [anon_sym_fadd] = ACTIONS(1910),
    [anon_sym_fsub] = ACTIONS(1910),
    [anon_sym_bitcast] = ACTIONS(1910),
    [anon_sym_trunc] = ACTIONS(1910),
    [anon_sym_zext] = ACTIONS(1910),
    [anon_sym_sext] = ACTIONS(1910),
    [anon_sym_fptrunc] = ACTIONS(1910),
    [anon_sym_fpext] = ACTIONS(1910),
    [anon_sym_addrspacecast] = ACTIONS(1910),
    [anon_sym_uitofp] = ACTIONS(1910),
    [anon_sym_sitofp] = ACTIONS(1910),
    [anon_sym_fptoui] = ACTIONS(1910),
    [anon_sym_fptosi] = ACTIONS(1910),
    [anon_sym_inttoptr] = ACTIONS(1910),
    [anon_sym_ptrtoint] = ACTIONS(1910),
    [anon_sym_uselistorder] = ACTIONS(1910),
  },
  [593] = {
    [aux_sym_instruction_alloca_repeat1] = STATE(580),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1912),
    [sym_label] = ACTIONS(1912),
    [anon_sym_RBRACE] = ACTIONS(1912),
    [anon_sym_COMMA] = ACTIONS(1914),
    [anon_sym_unreachable] = ACTIONS(1917),
    [anon_sym_ret] = ACTIONS(1917),
    [anon_sym_br] = ACTIONS(1917),
    [anon_sym_resume] = ACTIONS(1917),
    [anon_sym_freeze] = ACTIONS(1917),
    [anon_sym_indirectbr] = ACTIONS(1917),
    [anon_sym_extractelement] = ACTIONS(1917),
    [anon_sym_insertelement] = ACTIONS(1917),
    [anon_sym_select] = ACTIONS(1917),
    [anon_sym_shufflevector] = ACTIONS(1917),
    [anon_sym_fneg] = ACTIONS(1917),
    [anon_sym_switch] = ACTIONS(1917),
    [anon_sym_invoke] = ACTIONS(1917),
    [anon_sym_cleanupret] = ACTIONS(1917),
    [anon_sym_catchret] = ACTIONS(1917),
    [anon_sym_catchswitch] = ACTIONS(1917),
    [anon_sym_catchpad] = ACTIONS(1917),
    [anon_sym_cleanuppad] = ACTIONS(1917),
    [anon_sym_callbr] = ACTIONS(1917),
    [anon_sym_icmp] = ACTIONS(1917),
    [anon_sym_fcmp] = ACTIONS(1917),
    [anon_sym_va_arg] = ACTIONS(1917),
    [anon_sym_phi] = ACTIONS(1917),
    [anon_sym_landingpad] = ACTIONS(1917),
    [anon_sym_tail] = ACTIONS(1917),
    [anon_sym_musttail] = ACTIONS(1917),
    [anon_sym_notail] = ACTIONS(1917),
    [anon_sym_call] = ACTIONS(1917),
    [anon_sym_alloca] = ACTIONS(1917),
    [anon_sym_load] = ACTIONS(1917),
    [anon_sym_store] = ACTIONS(1917),
    [anon_sym_cmpxchg] = ACTIONS(1917),
    [anon_sym_atomicrmw] = ACTIONS(1917),
    [anon_sym_fence] = ACTIONS(1917),
    [anon_sym_getelementptr] = ACTIONS(1917),
    [anon_sym_extractvalue] = ACTIONS(1917),
    [anon_sym_insertvalue] = ACTIONS(1917),
    [anon_sym_mul] = ACTIONS(1917),
    [anon_sym_urem] = ACTIONS(1917),
    [anon_sym_srem] = ACTIONS(1917),
    [anon_sym_shl] = ACTIONS(1917),
    [anon_sym_udiv] = ACTIONS(1917),
    [anon_sym_sdiv] = ACTIONS(1917),
    [anon_sym_lshr] = ACTIONS(1917),
    [anon_sym_ashr] = ACTIONS(1917),
    [anon_sym_fmul] = ACTIONS(1917),
    [anon_sym_fdiv] = ACTIONS(1917),
    [anon_sym_frem] = ACTIONS(1917),
    [anon_sym_xchg] = ACTIONS(1917),
    [anon_sym_add] = ACTIONS(1917),
    [anon_sym_sub] = ACTIONS(1917),
    [anon_sym_and] = ACTIONS(1917),
    [anon_sym_nand] = ACTIONS(1917),
    [anon_sym_or] = ACTIONS(1917),
    [anon_sym_xor] = ACTIONS(1917),
    [anon_sym_max] = ACTIONS(1917),
    [anon_sym_min] = ACTIONS(1917),
    [anon_sym_umax] = ACTIONS(1917),
    [anon_sym_umin] = ACTIONS(1917),
    [anon_sym_fadd] = ACTIONS(1917),
    [anon_sym_fsub] = ACTIONS(1917),
    [anon_sym_bitcast] = ACTIONS(1917),
    [anon_sym_trunc] = ACTIONS(1917),
    [anon_sym_zext] = ACTIONS(1917),
    [anon_sym_sext] = ACTIONS(1917),
    [anon_sym_fptrunc] = ACTIONS(1917),
    [anon_sym_fpext] = ACTIONS(1917),
    [anon_sym_addrspacecast] = ACTIONS(1917),
    [anon_sym_uitofp] = ACTIONS(1917),
    [anon_sym_sitofp] = ACTIONS(1917),
    [anon_sym_fptoui] = ACTIONS(1917),
    [anon_sym_fptosi] = ACTIONS(1917),
    [anon_sym_inttoptr] = ACTIONS(1917),
    [anon_sym_ptrtoint] = ACTIONS(1917),
    [anon_sym_uselistorder] = ACTIONS(1917),
  },
  [594] = {
    [aux_sym_instruction_getelementptr_repeat1] = STATE(594),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1919),
    [sym_label] = ACTIONS(1919),
    [anon_sym_RBRACE] = ACTIONS(1919),
    [anon_sym_COMMA] = ACTIONS(1921),
    [anon_sym_unreachable] = ACTIONS(1924),
    [anon_sym_ret] = ACTIONS(1924),
    [anon_sym_br] = ACTIONS(1924),
    [anon_sym_resume] = ACTIONS(1924),
    [anon_sym_freeze] = ACTIONS(1924),
    [anon_sym_indirectbr] = ACTIONS(1924),
    [anon_sym_extractelement] = ACTIONS(1924),
    [anon_sym_insertelement] = ACTIONS(1924),
    [anon_sym_select] = ACTIONS(1924),
    [anon_sym_shufflevector] = ACTIONS(1924),
    [anon_sym_fneg] = ACTIONS(1924),
    [anon_sym_switch] = ACTIONS(1924),
    [anon_sym_invoke] = ACTIONS(1924),
    [anon_sym_cleanupret] = ACTIONS(1924),
    [anon_sym_catchret] = ACTIONS(1924),
    [anon_sym_catchswitch] = ACTIONS(1924),
    [anon_sym_catchpad] = ACTIONS(1924),
    [anon_sym_cleanuppad] = ACTIONS(1924),
    [anon_sym_callbr] = ACTIONS(1924),
    [anon_sym_icmp] = ACTIONS(1924),
    [anon_sym_fcmp] = ACTIONS(1924),
    [anon_sym_va_arg] = ACTIONS(1924),
    [anon_sym_phi] = ACTIONS(1924),
    [anon_sym_landingpad] = ACTIONS(1924),
    [anon_sym_tail] = ACTIONS(1924),
    [anon_sym_musttail] = ACTIONS(1924),
    [anon_sym_notail] = ACTIONS(1924),
    [anon_sym_call] = ACTIONS(1924),
    [anon_sym_alloca] = ACTIONS(1924),
    [anon_sym_load] = ACTIONS(1924),
    [anon_sym_store] = ACTIONS(1924),
    [anon_sym_cmpxchg] = ACTIONS(1924),
    [anon_sym_atomicrmw] = ACTIONS(1924),
    [anon_sym_fence] = ACTIONS(1924),
    [anon_sym_getelementptr] = ACTIONS(1924),
    [anon_sym_extractvalue] = ACTIONS(1924),
    [anon_sym_insertvalue] = ACTIONS(1924),
    [anon_sym_mul] = ACTIONS(1924),
    [anon_sym_urem] = ACTIONS(1924),
    [anon_sym_srem] = ACTIONS(1924),
    [anon_sym_shl] = ACTIONS(1924),
    [anon_sym_udiv] = ACTIONS(1924),
    [anon_sym_sdiv] = ACTIONS(1924),
    [anon_sym_lshr] = ACTIONS(1924),
    [anon_sym_ashr] = ACTIONS(1924),
    [anon_sym_fmul] = ACTIONS(1924),
    [anon_sym_fdiv] = ACTIONS(1924),
    [anon_sym_frem] = ACTIONS(1924),
    [anon_sym_xchg] = ACTIONS(1924),
    [anon_sym_add] = ACTIONS(1924),
    [anon_sym_sub] = ACTIONS(1924),
    [anon_sym_and] = ACTIONS(1924),
    [anon_sym_nand] = ACTIONS(1924),
    [anon_sym_or] = ACTIONS(1924),
    [anon_sym_xor] = ACTIONS(1924),
    [anon_sym_max] = ACTIONS(1924),
    [anon_sym_min] = ACTIONS(1924),
    [anon_sym_umax] = ACTIONS(1924),
    [anon_sym_umin] = ACTIONS(1924),
    [anon_sym_fadd] = ACTIONS(1924),
    [anon_sym_fsub] = ACTIONS(1924),
    [anon_sym_bitcast] = ACTIONS(1924),
    [anon_sym_trunc] = ACTIONS(1924),
    [anon_sym_zext] = ACTIONS(1924),
    [anon_sym_sext] = ACTIONS(1924),
    [anon_sym_fptrunc] = ACTIONS(1924),
    [anon_sym_fpext] = ACTIONS(1924),
    [anon_sym_addrspacecast] = ACTIONS(1924),
    [anon_sym_uitofp] = ACTIONS(1924),
    [anon_sym_sitofp] = ACTIONS(1924),
    [anon_sym_fptoui] = ACTIONS(1924),
    [anon_sym_fptosi] = ACTIONS(1924),
    [anon_sym_inttoptr] = ACTIONS(1924),
    [anon_sym_ptrtoint] = ACTIONS(1924),
    [anon_sym_uselistorder] = ACTIONS(1924),
  },
  [595] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1919),
    [sym_label] = ACTIONS(1919),
    [anon_sym_RBRACE] = ACTIONS(1919),
    [anon_sym_COMMA] = ACTIONS(1919),
    [anon_sym_RPAREN] = ACTIONS(1919),
    [anon_sym_unreachable] = ACTIONS(1924),
    [anon_sym_ret] = ACTIONS(1924),
    [anon_sym_br] = ACTIONS(1924),
    [anon_sym_resume] = ACTIONS(1924),
    [anon_sym_freeze] = ACTIONS(1924),
    [anon_sym_indirectbr] = ACTIONS(1924),
    [anon_sym_extractelement] = ACTIONS(1924),
    [anon_sym_insertelement] = ACTIONS(1924),
    [anon_sym_select] = ACTIONS(1924),
    [anon_sym_shufflevector] = ACTIONS(1924),
    [anon_sym_fneg] = ACTIONS(1924),
    [anon_sym_switch] = ACTIONS(1924),
    [anon_sym_invoke] = ACTIONS(1924),
    [anon_sym_cleanupret] = ACTIONS(1924),
    [anon_sym_catchret] = ACTIONS(1924),
    [anon_sym_catchswitch] = ACTIONS(1924),
    [anon_sym_catchpad] = ACTIONS(1924),
    [anon_sym_cleanuppad] = ACTIONS(1924),
    [anon_sym_callbr] = ACTIONS(1924),
    [anon_sym_icmp] = ACTIONS(1924),
    [anon_sym_fcmp] = ACTIONS(1924),
    [anon_sym_va_arg] = ACTIONS(1924),
    [anon_sym_phi] = ACTIONS(1924),
    [anon_sym_landingpad] = ACTIONS(1924),
    [anon_sym_tail] = ACTIONS(1924),
    [anon_sym_musttail] = ACTIONS(1924),
    [anon_sym_notail] = ACTIONS(1924),
    [anon_sym_call] = ACTIONS(1924),
    [anon_sym_alloca] = ACTIONS(1924),
    [anon_sym_load] = ACTIONS(1924),
    [anon_sym_store] = ACTIONS(1924),
    [anon_sym_cmpxchg] = ACTIONS(1924),
    [anon_sym_atomicrmw] = ACTIONS(1924),
    [anon_sym_fence] = ACTIONS(1924),
    [anon_sym_getelementptr] = ACTIONS(1924),
    [anon_sym_extractvalue] = ACTIONS(1924),
    [anon_sym_insertvalue] = ACTIONS(1924),
    [anon_sym_mul] = ACTIONS(1924),
    [anon_sym_urem] = ACTIONS(1924),
    [anon_sym_srem] = ACTIONS(1924),
    [anon_sym_shl] = ACTIONS(1924),
    [anon_sym_udiv] = ACTIONS(1924),
    [anon_sym_sdiv] = ACTIONS(1924),
    [anon_sym_lshr] = ACTIONS(1924),
    [anon_sym_ashr] = ACTIONS(1924),
    [anon_sym_fmul] = ACTIONS(1924),
    [anon_sym_fdiv] = ACTIONS(1924),
    [anon_sym_frem] = ACTIONS(1924),
    [anon_sym_xchg] = ACTIONS(1924),
    [anon_sym_add] = ACTIONS(1924),
    [anon_sym_sub] = ACTIONS(1924),
    [anon_sym_and] = ACTIONS(1924),
    [anon_sym_nand] = ACTIONS(1924),
    [anon_sym_or] = ACTIONS(1924),
    [anon_sym_xor] = ACTIONS(1924),
    [anon_sym_max] = ACTIONS(1924),
    [anon_sym_min] = ACTIONS(1924),
    [anon_sym_umax] = ACTIONS(1924),
    [anon_sym_umin] = ACTIONS(1924),
    [anon_sym_fadd] = ACTIONS(1924),
    [anon_sym_fsub] = ACTIONS(1924),
    [anon_sym_bitcast] = ACTIONS(1924),
    [anon_sym_trunc] = ACTIONS(1924),
    [anon_sym_zext] = ACTIONS(1924),
    [anon_sym_sext] = ACTIONS(1924),
    [anon_sym_fptrunc] = ACTIONS(1924),
    [anon_sym_fpext] = ACTIONS(1924),
    [anon_sym_addrspacecast] = ACTIONS(1924),
    [anon_sym_uitofp] = ACTIONS(1924),
    [anon_sym_sitofp] = ACTIONS(1924),
    [anon_sym_fptoui] = ACTIONS(1924),
    [anon_sym_fptosi] = ACTIONS(1924),
    [anon_sym_inttoptr] = ACTIONS(1924),
    [anon_sym_ptrtoint] = ACTIONS(1924),
    [anon_sym_uselistorder] = ACTIONS(1924),
  },
  [596] = {
    [aux_sym_instruction_alloca_repeat1] = STATE(580),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1926),
    [sym_label] = ACTIONS(1926),
    [anon_sym_RBRACE] = ACTIONS(1926),
    [anon_sym_COMMA] = ACTIONS(1928),
    [anon_sym_unreachable] = ACTIONS(1931),
    [anon_sym_ret] = ACTIONS(1931),
    [anon_sym_br] = ACTIONS(1931),
    [anon_sym_resume] = ACTIONS(1931),
    [anon_sym_freeze] = ACTIONS(1931),
    [anon_sym_indirectbr] = ACTIONS(1931),
    [anon_sym_extractelement] = ACTIONS(1931),
    [anon_sym_insertelement] = ACTIONS(1931),
    [anon_sym_select] = ACTIONS(1931),
    [anon_sym_shufflevector] = ACTIONS(1931),
    [anon_sym_fneg] = ACTIONS(1931),
    [anon_sym_switch] = ACTIONS(1931),
    [anon_sym_invoke] = ACTIONS(1931),
    [anon_sym_cleanupret] = ACTIONS(1931),
    [anon_sym_catchret] = ACTIONS(1931),
    [anon_sym_catchswitch] = ACTIONS(1931),
    [anon_sym_catchpad] = ACTIONS(1931),
    [anon_sym_cleanuppad] = ACTIONS(1931),
    [anon_sym_callbr] = ACTIONS(1931),
    [anon_sym_icmp] = ACTIONS(1931),
    [anon_sym_fcmp] = ACTIONS(1931),
    [anon_sym_va_arg] = ACTIONS(1931),
    [anon_sym_phi] = ACTIONS(1931),
    [anon_sym_landingpad] = ACTIONS(1931),
    [anon_sym_tail] = ACTIONS(1931),
    [anon_sym_musttail] = ACTIONS(1931),
    [anon_sym_notail] = ACTIONS(1931),
    [anon_sym_call] = ACTIONS(1931),
    [anon_sym_alloca] = ACTIONS(1931),
    [anon_sym_load] = ACTIONS(1931),
    [anon_sym_store] = ACTIONS(1931),
    [anon_sym_cmpxchg] = ACTIONS(1931),
    [anon_sym_atomicrmw] = ACTIONS(1931),
    [anon_sym_fence] = ACTIONS(1931),
    [anon_sym_getelementptr] = ACTIONS(1931),
    [anon_sym_extractvalue] = ACTIONS(1931),
    [anon_sym_insertvalue] = ACTIONS(1931),
    [anon_sym_mul] = ACTIONS(1931),
    [anon_sym_urem] = ACTIONS(1931),
    [anon_sym_srem] = ACTIONS(1931),
    [anon_sym_shl] = ACTIONS(1931),
    [anon_sym_udiv] = ACTIONS(1931),
    [anon_sym_sdiv] = ACTIONS(1931),
    [anon_sym_lshr] = ACTIONS(1931),
    [anon_sym_ashr] = ACTIONS(1931),
    [anon_sym_fmul] = ACTIONS(1931),
    [anon_sym_fdiv] = ACTIONS(1931),
    [anon_sym_frem] = ACTIONS(1931),
    [anon_sym_xchg] = ACTIONS(1931),
    [anon_sym_add] = ACTIONS(1931),
    [anon_sym_sub] = ACTIONS(1931),
    [anon_sym_and] = ACTIONS(1931),
    [anon_sym_nand] = ACTIONS(1931),
    [anon_sym_or] = ACTIONS(1931),
    [anon_sym_xor] = ACTIONS(1931),
    [anon_sym_max] = ACTIONS(1931),
    [anon_sym_min] = ACTIONS(1931),
    [anon_sym_umax] = ACTIONS(1931),
    [anon_sym_umin] = ACTIONS(1931),
    [anon_sym_fadd] = ACTIONS(1931),
    [anon_sym_fsub] = ACTIONS(1931),
    [anon_sym_bitcast] = ACTIONS(1931),
    [anon_sym_trunc] = ACTIONS(1931),
    [anon_sym_zext] = ACTIONS(1931),
    [anon_sym_sext] = ACTIONS(1931),
    [anon_sym_fptrunc] = ACTIONS(1931),
    [anon_sym_fpext] = ACTIONS(1931),
    [anon_sym_addrspacecast] = ACTIONS(1931),
    [anon_sym_uitofp] = ACTIONS(1931),
    [anon_sym_sitofp] = ACTIONS(1931),
    [anon_sym_fptoui] = ACTIONS(1931),
    [anon_sym_fptosi] = ACTIONS(1931),
    [anon_sym_inttoptr] = ACTIONS(1931),
    [anon_sym_ptrtoint] = ACTIONS(1931),
    [anon_sym_uselistorder] = ACTIONS(1931),
  },
  [597] = {
    [aux_sym_instruction_getelementptr_repeat1] = STATE(594),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1933),
    [sym_label] = ACTIONS(1933),
    [anon_sym_RBRACE] = ACTIONS(1933),
    [anon_sym_COMMA] = ACTIONS(1935),
    [anon_sym_unreachable] = ACTIONS(1938),
    [anon_sym_ret] = ACTIONS(1938),
    [anon_sym_br] = ACTIONS(1938),
    [anon_sym_resume] = ACTIONS(1938),
    [anon_sym_freeze] = ACTIONS(1938),
    [anon_sym_indirectbr] = ACTIONS(1938),
    [anon_sym_extractelement] = ACTIONS(1938),
    [anon_sym_insertelement] = ACTIONS(1938),
    [anon_sym_select] = ACTIONS(1938),
    [anon_sym_shufflevector] = ACTIONS(1938),
    [anon_sym_fneg] = ACTIONS(1938),
    [anon_sym_switch] = ACTIONS(1938),
    [anon_sym_invoke] = ACTIONS(1938),
    [anon_sym_cleanupret] = ACTIONS(1938),
    [anon_sym_catchret] = ACTIONS(1938),
    [anon_sym_catchswitch] = ACTIONS(1938),
    [anon_sym_catchpad] = ACTIONS(1938),
    [anon_sym_cleanuppad] = ACTIONS(1938),
    [anon_sym_callbr] = ACTIONS(1938),
    [anon_sym_icmp] = ACTIONS(1938),
    [anon_sym_fcmp] = ACTIONS(1938),
    [anon_sym_va_arg] = ACTIONS(1938),
    [anon_sym_phi] = ACTIONS(1938),
    [anon_sym_landingpad] = ACTIONS(1938),
    [anon_sym_tail] = ACTIONS(1938),
    [anon_sym_musttail] = ACTIONS(1938),
    [anon_sym_notail] = ACTIONS(1938),
    [anon_sym_call] = ACTIONS(1938),
    [anon_sym_alloca] = ACTIONS(1938),
    [anon_sym_load] = ACTIONS(1938),
    [anon_sym_store] = ACTIONS(1938),
    [anon_sym_cmpxchg] = ACTIONS(1938),
    [anon_sym_atomicrmw] = ACTIONS(1938),
    [anon_sym_fence] = ACTIONS(1938),
    [anon_sym_getelementptr] = ACTIONS(1938),
    [anon_sym_extractvalue] = ACTIONS(1938),
    [anon_sym_insertvalue] = ACTIONS(1938),
    [anon_sym_mul] = ACTIONS(1938),
    [anon_sym_urem] = ACTIONS(1938),
    [anon_sym_srem] = ACTIONS(1938),
    [anon_sym_shl] = ACTIONS(1938),
    [anon_sym_udiv] = ACTIONS(1938),
    [anon_sym_sdiv] = ACTIONS(1938),
    [anon_sym_lshr] = ACTIONS(1938),
    [anon_sym_ashr] = ACTIONS(1938),
    [anon_sym_fmul] = ACTIONS(1938),
    [anon_sym_fdiv] = ACTIONS(1938),
    [anon_sym_frem] = ACTIONS(1938),
    [anon_sym_xchg] = ACTIONS(1938),
    [anon_sym_add] = ACTIONS(1938),
    [anon_sym_sub] = ACTIONS(1938),
    [anon_sym_and] = ACTIONS(1938),
    [anon_sym_nand] = ACTIONS(1938),
    [anon_sym_or] = ACTIONS(1938),
    [anon_sym_xor] = ACTIONS(1938),
    [anon_sym_max] = ACTIONS(1938),
    [anon_sym_min] = ACTIONS(1938),
    [anon_sym_umax] = ACTIONS(1938),
    [anon_sym_umin] = ACTIONS(1938),
    [anon_sym_fadd] = ACTIONS(1938),
    [anon_sym_fsub] = ACTIONS(1938),
    [anon_sym_bitcast] = ACTIONS(1938),
    [anon_sym_trunc] = ACTIONS(1938),
    [anon_sym_zext] = ACTIONS(1938),
    [anon_sym_sext] = ACTIONS(1938),
    [anon_sym_fptrunc] = ACTIONS(1938),
    [anon_sym_fpext] = ACTIONS(1938),
    [anon_sym_addrspacecast] = ACTIONS(1938),
    [anon_sym_uitofp] = ACTIONS(1938),
    [anon_sym_sitofp] = ACTIONS(1938),
    [anon_sym_fptoui] = ACTIONS(1938),
    [anon_sym_fptosi] = ACTIONS(1938),
    [anon_sym_inttoptr] = ACTIONS(1938),
    [anon_sym_ptrtoint] = ACTIONS(1938),
    [anon_sym_uselistorder] = ACTIONS(1938),
  },
  [598] = {
    [aux_sym_instruction_getelementptr_repeat1] = STATE(585),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1940),
    [sym_label] = ACTIONS(1940),
    [anon_sym_RBRACE] = ACTIONS(1940),
    [anon_sym_COMMA] = ACTIONS(1942),
    [anon_sym_unreachable] = ACTIONS(1945),
    [anon_sym_ret] = ACTIONS(1945),
    [anon_sym_br] = ACTIONS(1945),
    [anon_sym_resume] = ACTIONS(1945),
    [anon_sym_freeze] = ACTIONS(1945),
    [anon_sym_indirectbr] = ACTIONS(1945),
    [anon_sym_extractelement] = ACTIONS(1945),
    [anon_sym_insertelement] = ACTIONS(1945),
    [anon_sym_select] = ACTIONS(1945),
    [anon_sym_shufflevector] = ACTIONS(1945),
    [anon_sym_fneg] = ACTIONS(1945),
    [anon_sym_switch] = ACTIONS(1945),
    [anon_sym_invoke] = ACTIONS(1945),
    [anon_sym_cleanupret] = ACTIONS(1945),
    [anon_sym_catchret] = ACTIONS(1945),
    [anon_sym_catchswitch] = ACTIONS(1945),
    [anon_sym_catchpad] = ACTIONS(1945),
    [anon_sym_cleanuppad] = ACTIONS(1945),
    [anon_sym_callbr] = ACTIONS(1945),
    [anon_sym_icmp] = ACTIONS(1945),
    [anon_sym_fcmp] = ACTIONS(1945),
    [anon_sym_va_arg] = ACTIONS(1945),
    [anon_sym_phi] = ACTIONS(1945),
    [anon_sym_landingpad] = ACTIONS(1945),
    [anon_sym_tail] = ACTIONS(1945),
    [anon_sym_musttail] = ACTIONS(1945),
    [anon_sym_notail] = ACTIONS(1945),
    [anon_sym_call] = ACTIONS(1945),
    [anon_sym_alloca] = ACTIONS(1945),
    [anon_sym_load] = ACTIONS(1945),
    [anon_sym_store] = ACTIONS(1945),
    [anon_sym_cmpxchg] = ACTIONS(1945),
    [anon_sym_atomicrmw] = ACTIONS(1945),
    [anon_sym_fence] = ACTIONS(1945),
    [anon_sym_getelementptr] = ACTIONS(1945),
    [anon_sym_extractvalue] = ACTIONS(1945),
    [anon_sym_insertvalue] = ACTIONS(1945),
    [anon_sym_mul] = ACTIONS(1945),
    [anon_sym_urem] = ACTIONS(1945),
    [anon_sym_srem] = ACTIONS(1945),
    [anon_sym_shl] = ACTIONS(1945),
    [anon_sym_udiv] = ACTIONS(1945),
    [anon_sym_sdiv] = ACTIONS(1945),
    [anon_sym_lshr] = ACTIONS(1945),
    [anon_sym_ashr] = ACTIONS(1945),
    [anon_sym_fmul] = ACTIONS(1945),
    [anon_sym_fdiv] = ACTIONS(1945),
    [anon_sym_frem] = ACTIONS(1945),
    [anon_sym_xchg] = ACTIONS(1945),
    [anon_sym_add] = ACTIONS(1945),
    [anon_sym_sub] = ACTIONS(1945),
    [anon_sym_and] = ACTIONS(1945),
    [anon_sym_nand] = ACTIONS(1945),
    [anon_sym_or] = ACTIONS(1945),
    [anon_sym_xor] = ACTIONS(1945),
    [anon_sym_max] = ACTIONS(1945),
    [anon_sym_min] = ACTIONS(1945),
    [anon_sym_umax] = ACTIONS(1945),
    [anon_sym_umin] = ACTIONS(1945),
    [anon_sym_fadd] = ACTIONS(1945),
    [anon_sym_fsub] = ACTIONS(1945),
    [anon_sym_bitcast] = ACTIONS(1945),
    [anon_sym_trunc] = ACTIONS(1945),
    [anon_sym_zext] = ACTIONS(1945),
    [anon_sym_sext] = ACTIONS(1945),
    [anon_sym_fptrunc] = ACTIONS(1945),
    [anon_sym_fpext] = ACTIONS(1945),
    [anon_sym_addrspacecast] = ACTIONS(1945),
    [anon_sym_uitofp] = ACTIONS(1945),
    [anon_sym_sitofp] = ACTIONS(1945),
    [anon_sym_fptoui] = ACTIONS(1945),
    [anon_sym_fptosi] = ACTIONS(1945),
    [anon_sym_inttoptr] = ACTIONS(1945),
    [anon_sym_ptrtoint] = ACTIONS(1945),
    [anon_sym_uselistorder] = ACTIONS(1945),
  },
  [599] = {
    [aux_sym_instruction_alloca_repeat1] = STATE(581),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1926),
    [sym_label] = ACTIONS(1926),
    [anon_sym_RBRACE] = ACTIONS(1926),
    [anon_sym_COMMA] = ACTIONS(1928),
    [anon_sym_unreachable] = ACTIONS(1931),
    [anon_sym_ret] = ACTIONS(1931),
    [anon_sym_br] = ACTIONS(1931),
    [anon_sym_resume] = ACTIONS(1931),
    [anon_sym_freeze] = ACTIONS(1931),
    [anon_sym_indirectbr] = ACTIONS(1931),
    [anon_sym_extractelement] = ACTIONS(1931),
    [anon_sym_insertelement] = ACTIONS(1931),
    [anon_sym_select] = ACTIONS(1931),
    [anon_sym_shufflevector] = ACTIONS(1931),
    [anon_sym_fneg] = ACTIONS(1931),
    [anon_sym_switch] = ACTIONS(1931),
    [anon_sym_invoke] = ACTIONS(1931),
    [anon_sym_cleanupret] = ACTIONS(1931),
    [anon_sym_catchret] = ACTIONS(1931),
    [anon_sym_catchswitch] = ACTIONS(1931),
    [anon_sym_catchpad] = ACTIONS(1931),
    [anon_sym_cleanuppad] = ACTIONS(1931),
    [anon_sym_callbr] = ACTIONS(1931),
    [anon_sym_icmp] = ACTIONS(1931),
    [anon_sym_fcmp] = ACTIONS(1931),
    [anon_sym_va_arg] = ACTIONS(1931),
    [anon_sym_phi] = ACTIONS(1931),
    [anon_sym_landingpad] = ACTIONS(1931),
    [anon_sym_tail] = ACTIONS(1931),
    [anon_sym_musttail] = ACTIONS(1931),
    [anon_sym_notail] = ACTIONS(1931),
    [anon_sym_call] = ACTIONS(1931),
    [anon_sym_alloca] = ACTIONS(1931),
    [anon_sym_load] = ACTIONS(1931),
    [anon_sym_store] = ACTIONS(1931),
    [anon_sym_cmpxchg] = ACTIONS(1931),
    [anon_sym_atomicrmw] = ACTIONS(1931),
    [anon_sym_fence] = ACTIONS(1931),
    [anon_sym_getelementptr] = ACTIONS(1931),
    [anon_sym_extractvalue] = ACTIONS(1931),
    [anon_sym_insertvalue] = ACTIONS(1931),
    [anon_sym_mul] = ACTIONS(1931),
    [anon_sym_urem] = ACTIONS(1931),
    [anon_sym_srem] = ACTIONS(1931),
    [anon_sym_shl] = ACTIONS(1931),
    [anon_sym_udiv] = ACTIONS(1931),
    [anon_sym_sdiv] = ACTIONS(1931),
    [anon_sym_lshr] = ACTIONS(1931),
    [anon_sym_ashr] = ACTIONS(1931),
    [anon_sym_fmul] = ACTIONS(1931),
    [anon_sym_fdiv] = ACTIONS(1931),
    [anon_sym_frem] = ACTIONS(1931),
    [anon_sym_xchg] = ACTIONS(1931),
    [anon_sym_add] = ACTIONS(1931),
    [anon_sym_sub] = ACTIONS(1931),
    [anon_sym_and] = ACTIONS(1931),
    [anon_sym_nand] = ACTIONS(1931),
    [anon_sym_or] = ACTIONS(1931),
    [anon_sym_xor] = ACTIONS(1931),
    [anon_sym_max] = ACTIONS(1931),
    [anon_sym_min] = ACTIONS(1931),
    [anon_sym_umax] = ACTIONS(1931),
    [anon_sym_umin] = ACTIONS(1931),
    [anon_sym_fadd] = ACTIONS(1931),
    [anon_sym_fsub] = ACTIONS(1931),
    [anon_sym_bitcast] = ACTIONS(1931),
    [anon_sym_trunc] = ACTIONS(1931),
    [anon_sym_zext] = ACTIONS(1931),
    [anon_sym_sext] = ACTIONS(1931),
    [anon_sym_fptrunc] = ACTIONS(1931),
    [anon_sym_fpext] = ACTIONS(1931),
    [anon_sym_addrspacecast] = ACTIONS(1931),
    [anon_sym_uitofp] = ACTIONS(1931),
    [anon_sym_sitofp] = ACTIONS(1931),
    [anon_sym_fptoui] = ACTIONS(1931),
    [anon_sym_fptosi] = ACTIONS(1931),
    [anon_sym_inttoptr] = ACTIONS(1931),
    [anon_sym_ptrtoint] = ACTIONS(1931),
    [anon_sym_uselistorder] = ACTIONS(1931),
  },
  [600] = {
    [aux_sym_instruction_getelementptr_repeat1] = STATE(601),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1933),
    [sym_label] = ACTIONS(1933),
    [anon_sym_RBRACE] = ACTIONS(1933),
    [anon_sym_COMMA] = ACTIONS(1935),
    [anon_sym_unreachable] = ACTIONS(1938),
    [anon_sym_ret] = ACTIONS(1938),
    [anon_sym_br] = ACTIONS(1938),
    [anon_sym_resume] = ACTIONS(1938),
    [anon_sym_freeze] = ACTIONS(1938),
    [anon_sym_indirectbr] = ACTIONS(1938),
    [anon_sym_extractelement] = ACTIONS(1938),
    [anon_sym_insertelement] = ACTIONS(1938),
    [anon_sym_select] = ACTIONS(1938),
    [anon_sym_shufflevector] = ACTIONS(1938),
    [anon_sym_fneg] = ACTIONS(1938),
    [anon_sym_switch] = ACTIONS(1938),
    [anon_sym_invoke] = ACTIONS(1938),
    [anon_sym_cleanupret] = ACTIONS(1938),
    [anon_sym_catchret] = ACTIONS(1938),
    [anon_sym_catchswitch] = ACTIONS(1938),
    [anon_sym_catchpad] = ACTIONS(1938),
    [anon_sym_cleanuppad] = ACTIONS(1938),
    [anon_sym_callbr] = ACTIONS(1938),
    [anon_sym_icmp] = ACTIONS(1938),
    [anon_sym_fcmp] = ACTIONS(1938),
    [anon_sym_va_arg] = ACTIONS(1938),
    [anon_sym_phi] = ACTIONS(1938),
    [anon_sym_landingpad] = ACTIONS(1938),
    [anon_sym_tail] = ACTIONS(1938),
    [anon_sym_musttail] = ACTIONS(1938),
    [anon_sym_notail] = ACTIONS(1938),
    [anon_sym_call] = ACTIONS(1938),
    [anon_sym_alloca] = ACTIONS(1938),
    [anon_sym_load] = ACTIONS(1938),
    [anon_sym_store] = ACTIONS(1938),
    [anon_sym_cmpxchg] = ACTIONS(1938),
    [anon_sym_atomicrmw] = ACTIONS(1938),
    [anon_sym_fence] = ACTIONS(1938),
    [anon_sym_getelementptr] = ACTIONS(1938),
    [anon_sym_extractvalue] = ACTIONS(1938),
    [anon_sym_insertvalue] = ACTIONS(1938),
    [anon_sym_mul] = ACTIONS(1938),
    [anon_sym_urem] = ACTIONS(1938),
    [anon_sym_srem] = ACTIONS(1938),
    [anon_sym_shl] = ACTIONS(1938),
    [anon_sym_udiv] = ACTIONS(1938),
    [anon_sym_sdiv] = ACTIONS(1938),
    [anon_sym_lshr] = ACTIONS(1938),
    [anon_sym_ashr] = ACTIONS(1938),
    [anon_sym_fmul] = ACTIONS(1938),
    [anon_sym_fdiv] = ACTIONS(1938),
    [anon_sym_frem] = ACTIONS(1938),
    [anon_sym_xchg] = ACTIONS(1938),
    [anon_sym_add] = ACTIONS(1938),
    [anon_sym_sub] = ACTIONS(1938),
    [anon_sym_and] = ACTIONS(1938),
    [anon_sym_nand] = ACTIONS(1938),
    [anon_sym_or] = ACTIONS(1938),
    [anon_sym_xor] = ACTIONS(1938),
    [anon_sym_max] = ACTIONS(1938),
    [anon_sym_min] = ACTIONS(1938),
    [anon_sym_umax] = ACTIONS(1938),
    [anon_sym_umin] = ACTIONS(1938),
    [anon_sym_fadd] = ACTIONS(1938),
    [anon_sym_fsub] = ACTIONS(1938),
    [anon_sym_bitcast] = ACTIONS(1938),
    [anon_sym_trunc] = ACTIONS(1938),
    [anon_sym_zext] = ACTIONS(1938),
    [anon_sym_sext] = ACTIONS(1938),
    [anon_sym_fptrunc] = ACTIONS(1938),
    [anon_sym_fpext] = ACTIONS(1938),
    [anon_sym_addrspacecast] = ACTIONS(1938),
    [anon_sym_uitofp] = ACTIONS(1938),
    [anon_sym_sitofp] = ACTIONS(1938),
    [anon_sym_fptoui] = ACTIONS(1938),
    [anon_sym_fptosi] = ACTIONS(1938),
    [anon_sym_inttoptr] = ACTIONS(1938),
    [anon_sym_ptrtoint] = ACTIONS(1938),
    [anon_sym_uselistorder] = ACTIONS(1938),
  },
  [601] = {
    [aux_sym_instruction_getelementptr_repeat1] = STATE(594),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1947),
    [sym_label] = ACTIONS(1947),
    [anon_sym_RBRACE] = ACTIONS(1947),
    [anon_sym_COMMA] = ACTIONS(1949),
    [anon_sym_unreachable] = ACTIONS(1952),
    [anon_sym_ret] = ACTIONS(1952),
    [anon_sym_br] = ACTIONS(1952),
    [anon_sym_resume] = ACTIONS(1952),
    [anon_sym_freeze] = ACTIONS(1952),
    [anon_sym_indirectbr] = ACTIONS(1952),
    [anon_sym_extractelement] = ACTIONS(1952),
    [anon_sym_insertelement] = ACTIONS(1952),
    [anon_sym_select] = ACTIONS(1952),
    [anon_sym_shufflevector] = ACTIONS(1952),
    [anon_sym_fneg] = ACTIONS(1952),
    [anon_sym_switch] = ACTIONS(1952),
    [anon_sym_invoke] = ACTIONS(1952),
    [anon_sym_cleanupret] = ACTIONS(1952),
    [anon_sym_catchret] = ACTIONS(1952),
    [anon_sym_catchswitch] = ACTIONS(1952),
    [anon_sym_catchpad] = ACTIONS(1952),
    [anon_sym_cleanuppad] = ACTIONS(1952),
    [anon_sym_callbr] = ACTIONS(1952),
    [anon_sym_icmp] = ACTIONS(1952),
    [anon_sym_fcmp] = ACTIONS(1952),
    [anon_sym_va_arg] = ACTIONS(1952),
    [anon_sym_phi] = ACTIONS(1952),
    [anon_sym_landingpad] = ACTIONS(1952),
    [anon_sym_tail] = ACTIONS(1952),
    [anon_sym_musttail] = ACTIONS(1952),
    [anon_sym_notail] = ACTIONS(1952),
    [anon_sym_call] = ACTIONS(1952),
    [anon_sym_alloca] = ACTIONS(1952),
    [anon_sym_load] = ACTIONS(1952),
    [anon_sym_store] = ACTIONS(1952),
    [anon_sym_cmpxchg] = ACTIONS(1952),
    [anon_sym_atomicrmw] = ACTIONS(1952),
    [anon_sym_fence] = ACTIONS(1952),
    [anon_sym_getelementptr] = ACTIONS(1952),
    [anon_sym_extractvalue] = ACTIONS(1952),
    [anon_sym_insertvalue] = ACTIONS(1952),
    [anon_sym_mul] = ACTIONS(1952),
    [anon_sym_urem] = ACTIONS(1952),
    [anon_sym_srem] = ACTIONS(1952),
    [anon_sym_shl] = ACTIONS(1952),
    [anon_sym_udiv] = ACTIONS(1952),
    [anon_sym_sdiv] = ACTIONS(1952),
    [anon_sym_lshr] = ACTIONS(1952),
    [anon_sym_ashr] = ACTIONS(1952),
    [anon_sym_fmul] = ACTIONS(1952),
    [anon_sym_fdiv] = ACTIONS(1952),
    [anon_sym_frem] = ACTIONS(1952),
    [anon_sym_xchg] = ACTIONS(1952),
    [anon_sym_add] = ACTIONS(1952),
    [anon_sym_sub] = ACTIONS(1952),
    [anon_sym_and] = ACTIONS(1952),
    [anon_sym_nand] = ACTIONS(1952),
    [anon_sym_or] = ACTIONS(1952),
    [anon_sym_xor] = ACTIONS(1952),
    [anon_sym_max] = ACTIONS(1952),
    [anon_sym_min] = ACTIONS(1952),
    [anon_sym_umax] = ACTIONS(1952),
    [anon_sym_umin] = ACTIONS(1952),
    [anon_sym_fadd] = ACTIONS(1952),
    [anon_sym_fsub] = ACTIONS(1952),
    [anon_sym_bitcast] = ACTIONS(1952),
    [anon_sym_trunc] = ACTIONS(1952),
    [anon_sym_zext] = ACTIONS(1952),
    [anon_sym_sext] = ACTIONS(1952),
    [anon_sym_fptrunc] = ACTIONS(1952),
    [anon_sym_fpext] = ACTIONS(1952),
    [anon_sym_addrspacecast] = ACTIONS(1952),
    [anon_sym_uitofp] = ACTIONS(1952),
    [anon_sym_sitofp] = ACTIONS(1952),
    [anon_sym_fptoui] = ACTIONS(1952),
    [anon_sym_fptosi] = ACTIONS(1952),
    [anon_sym_inttoptr] = ACTIONS(1952),
    [anon_sym_ptrtoint] = ACTIONS(1952),
    [anon_sym_uselistorder] = ACTIONS(1952),
  },
  [602] = {
    [aux_sym_instruction_extractvalue_repeat1] = STATE(602),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1838),
    [sym_label] = ACTIONS(1838),
    [anon_sym_RBRACE] = ACTIONS(1838),
    [anon_sym_COMMA] = ACTIONS(1954),
    [anon_sym_unreachable] = ACTIONS(1840),
    [anon_sym_ret] = ACTIONS(1840),
    [anon_sym_br] = ACTIONS(1840),
    [anon_sym_resume] = ACTIONS(1840),
    [anon_sym_freeze] = ACTIONS(1840),
    [anon_sym_indirectbr] = ACTIONS(1840),
    [anon_sym_extractelement] = ACTIONS(1840),
    [anon_sym_insertelement] = ACTIONS(1840),
    [anon_sym_select] = ACTIONS(1840),
    [anon_sym_shufflevector] = ACTIONS(1840),
    [anon_sym_fneg] = ACTIONS(1840),
    [anon_sym_switch] = ACTIONS(1840),
    [anon_sym_invoke] = ACTIONS(1840),
    [anon_sym_cleanupret] = ACTIONS(1840),
    [anon_sym_catchret] = ACTIONS(1840),
    [anon_sym_catchswitch] = ACTIONS(1840),
    [anon_sym_catchpad] = ACTIONS(1840),
    [anon_sym_cleanuppad] = ACTIONS(1840),
    [anon_sym_callbr] = ACTIONS(1840),
    [anon_sym_icmp] = ACTIONS(1840),
    [anon_sym_fcmp] = ACTIONS(1840),
    [anon_sym_va_arg] = ACTIONS(1840),
    [anon_sym_phi] = ACTIONS(1840),
    [anon_sym_landingpad] = ACTIONS(1840),
    [anon_sym_tail] = ACTIONS(1840),
    [anon_sym_musttail] = ACTIONS(1840),
    [anon_sym_notail] = ACTIONS(1840),
    [anon_sym_call] = ACTIONS(1840),
    [anon_sym_alloca] = ACTIONS(1840),
    [anon_sym_load] = ACTIONS(1840),
    [anon_sym_store] = ACTIONS(1840),
    [anon_sym_cmpxchg] = ACTIONS(1840),
    [anon_sym_atomicrmw] = ACTIONS(1840),
    [anon_sym_fence] = ACTIONS(1840),
    [anon_sym_getelementptr] = ACTIONS(1840),
    [anon_sym_extractvalue] = ACTIONS(1840),
    [anon_sym_insertvalue] = ACTIONS(1840),
    [anon_sym_mul] = ACTIONS(1840),
    [anon_sym_urem] = ACTIONS(1840),
    [anon_sym_srem] = ACTIONS(1840),
    [anon_sym_shl] = ACTIONS(1840),
    [anon_sym_udiv] = ACTIONS(1840),
    [anon_sym_sdiv] = ACTIONS(1840),
    [anon_sym_lshr] = ACTIONS(1840),
    [anon_sym_ashr] = ACTIONS(1840),
    [anon_sym_fmul] = ACTIONS(1840),
    [anon_sym_fdiv] = ACTIONS(1840),
    [anon_sym_frem] = ACTIONS(1840),
    [anon_sym_xchg] = ACTIONS(1840),
    [anon_sym_add] = ACTIONS(1840),
    [anon_sym_sub] = ACTIONS(1840),
    [anon_sym_and] = ACTIONS(1840),
    [anon_sym_nand] = ACTIONS(1840),
    [anon_sym_or] = ACTIONS(1840),
    [anon_sym_xor] = ACTIONS(1840),
    [anon_sym_max] = ACTIONS(1840),
    [anon_sym_min] = ACTIONS(1840),
    [anon_sym_umax] = ACTIONS(1840),
    [anon_sym_umin] = ACTIONS(1840),
    [anon_sym_fadd] = ACTIONS(1840),
    [anon_sym_fsub] = ACTIONS(1840),
    [anon_sym_bitcast] = ACTIONS(1840),
    [anon_sym_trunc] = ACTIONS(1840),
    [anon_sym_zext] = ACTIONS(1840),
    [anon_sym_sext] = ACTIONS(1840),
    [anon_sym_fptrunc] = ACTIONS(1840),
    [anon_sym_fpext] = ACTIONS(1840),
    [anon_sym_addrspacecast] = ACTIONS(1840),
    [anon_sym_uitofp] = ACTIONS(1840),
    [anon_sym_sitofp] = ACTIONS(1840),
    [anon_sym_fptoui] = ACTIONS(1840),
    [anon_sym_fptosi] = ACTIONS(1840),
    [anon_sym_inttoptr] = ACTIONS(1840),
    [anon_sym_ptrtoint] = ACTIONS(1840),
    [anon_sym_uselistorder] = ACTIONS(1840),
  },
  [603] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1957),
    [sym_label] = ACTIONS(1957),
    [anon_sym_RBRACE] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(1957),
    [anon_sym_RPAREN] = ACTIONS(1957),
    [anon_sym_unreachable] = ACTIONS(1959),
    [anon_sym_ret] = ACTIONS(1959),
    [anon_sym_br] = ACTIONS(1959),
    [anon_sym_resume] = ACTIONS(1959),
    [anon_sym_freeze] = ACTIONS(1959),
    [anon_sym_indirectbr] = ACTIONS(1959),
    [anon_sym_extractelement] = ACTIONS(1959),
    [anon_sym_insertelement] = ACTIONS(1959),
    [anon_sym_select] = ACTIONS(1959),
    [anon_sym_shufflevector] = ACTIONS(1959),
    [anon_sym_fneg] = ACTIONS(1959),
    [anon_sym_switch] = ACTIONS(1959),
    [anon_sym_invoke] = ACTIONS(1959),
    [anon_sym_cleanupret] = ACTIONS(1959),
    [anon_sym_catchret] = ACTIONS(1959),
    [anon_sym_catchswitch] = ACTIONS(1959),
    [anon_sym_catchpad] = ACTIONS(1959),
    [anon_sym_cleanuppad] = ACTIONS(1959),
    [anon_sym_callbr] = ACTIONS(1959),
    [anon_sym_icmp] = ACTIONS(1959),
    [anon_sym_fcmp] = ACTIONS(1959),
    [anon_sym_va_arg] = ACTIONS(1959),
    [anon_sym_phi] = ACTIONS(1959),
    [anon_sym_landingpad] = ACTIONS(1959),
    [anon_sym_tail] = ACTIONS(1959),
    [anon_sym_musttail] = ACTIONS(1959),
    [anon_sym_notail] = ACTIONS(1959),
    [anon_sym_call] = ACTIONS(1959),
    [anon_sym_alloca] = ACTIONS(1959),
    [anon_sym_load] = ACTIONS(1959),
    [anon_sym_store] = ACTIONS(1959),
    [anon_sym_cmpxchg] = ACTIONS(1959),
    [anon_sym_atomicrmw] = ACTIONS(1959),
    [anon_sym_fence] = ACTIONS(1959),
    [anon_sym_getelementptr] = ACTIONS(1959),
    [anon_sym_extractvalue] = ACTIONS(1959),
    [anon_sym_insertvalue] = ACTIONS(1959),
    [anon_sym_mul] = ACTIONS(1959),
    [anon_sym_urem] = ACTIONS(1959),
    [anon_sym_srem] = ACTIONS(1959),
    [anon_sym_shl] = ACTIONS(1959),
    [anon_sym_udiv] = ACTIONS(1959),
    [anon_sym_sdiv] = ACTIONS(1959),
    [anon_sym_lshr] = ACTIONS(1959),
    [anon_sym_ashr] = ACTIONS(1959),
    [anon_sym_fmul] = ACTIONS(1959),
    [anon_sym_fdiv] = ACTIONS(1959),
    [anon_sym_frem] = ACTIONS(1959),
    [anon_sym_xchg] = ACTIONS(1959),
    [anon_sym_add] = ACTIONS(1959),
    [anon_sym_sub] = ACTIONS(1959),
    [anon_sym_and] = ACTIONS(1959),
    [anon_sym_nand] = ACTIONS(1959),
    [anon_sym_or] = ACTIONS(1959),
    [anon_sym_xor] = ACTIONS(1959),
    [anon_sym_max] = ACTIONS(1959),
    [anon_sym_min] = ACTIONS(1959),
    [anon_sym_umax] = ACTIONS(1959),
    [anon_sym_umin] = ACTIONS(1959),
    [anon_sym_fadd] = ACTIONS(1959),
    [anon_sym_fsub] = ACTIONS(1959),
    [anon_sym_bitcast] = ACTIONS(1959),
    [anon_sym_trunc] = ACTIONS(1959),
    [anon_sym_zext] = ACTIONS(1959),
    [anon_sym_sext] = ACTIONS(1959),
    [anon_sym_fptrunc] = ACTIONS(1959),
    [anon_sym_fpext] = ACTIONS(1959),
    [anon_sym_addrspacecast] = ACTIONS(1959),
    [anon_sym_uitofp] = ACTIONS(1959),
    [anon_sym_sitofp] = ACTIONS(1959),
    [anon_sym_fptoui] = ACTIONS(1959),
    [anon_sym_fptosi] = ACTIONS(1959),
    [anon_sym_inttoptr] = ACTIONS(1959),
    [anon_sym_ptrtoint] = ACTIONS(1959),
    [anon_sym_uselistorder] = ACTIONS(1959),
  },
  [604] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1961),
    [sym_label] = ACTIONS(1961),
    [anon_sym_RBRACE] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_COMMA] = ACTIONS(1961),
    [anon_sym_unreachable] = ACTIONS(1965),
    [anon_sym_ret] = ACTIONS(1965),
    [anon_sym_br] = ACTIONS(1965),
    [anon_sym_resume] = ACTIONS(1965),
    [anon_sym_freeze] = ACTIONS(1965),
    [anon_sym_indirectbr] = ACTIONS(1965),
    [anon_sym_extractelement] = ACTIONS(1965),
    [anon_sym_insertelement] = ACTIONS(1965),
    [anon_sym_select] = ACTIONS(1965),
    [anon_sym_shufflevector] = ACTIONS(1965),
    [anon_sym_fneg] = ACTIONS(1965),
    [anon_sym_switch] = ACTIONS(1965),
    [anon_sym_invoke] = ACTIONS(1965),
    [anon_sym_cleanupret] = ACTIONS(1965),
    [anon_sym_catchret] = ACTIONS(1965),
    [anon_sym_catchswitch] = ACTIONS(1965),
    [anon_sym_catchpad] = ACTIONS(1965),
    [anon_sym_cleanuppad] = ACTIONS(1965),
    [anon_sym_callbr] = ACTIONS(1965),
    [anon_sym_icmp] = ACTIONS(1965),
    [anon_sym_fcmp] = ACTIONS(1965),
    [anon_sym_va_arg] = ACTIONS(1965),
    [anon_sym_phi] = ACTIONS(1965),
    [anon_sym_landingpad] = ACTIONS(1965),
    [anon_sym_tail] = ACTIONS(1965),
    [anon_sym_musttail] = ACTIONS(1965),
    [anon_sym_notail] = ACTIONS(1965),
    [anon_sym_call] = ACTIONS(1965),
    [anon_sym_alloca] = ACTIONS(1965),
    [anon_sym_load] = ACTIONS(1965),
    [anon_sym_store] = ACTIONS(1965),
    [anon_sym_cmpxchg] = ACTIONS(1965),
    [anon_sym_atomicrmw] = ACTIONS(1965),
    [anon_sym_fence] = ACTIONS(1965),
    [anon_sym_getelementptr] = ACTIONS(1965),
    [anon_sym_extractvalue] = ACTIONS(1965),
    [anon_sym_insertvalue] = ACTIONS(1965),
    [anon_sym_mul] = ACTIONS(1965),
    [anon_sym_urem] = ACTIONS(1965),
    [anon_sym_srem] = ACTIONS(1965),
    [anon_sym_shl] = ACTIONS(1965),
    [anon_sym_udiv] = ACTIONS(1965),
    [anon_sym_sdiv] = ACTIONS(1965),
    [anon_sym_lshr] = ACTIONS(1965),
    [anon_sym_ashr] = ACTIONS(1965),
    [anon_sym_fmul] = ACTIONS(1965),
    [anon_sym_fdiv] = ACTIONS(1965),
    [anon_sym_frem] = ACTIONS(1965),
    [anon_sym_xchg] = ACTIONS(1965),
    [anon_sym_add] = ACTIONS(1965),
    [anon_sym_sub] = ACTIONS(1965),
    [anon_sym_and] = ACTIONS(1965),
    [anon_sym_nand] = ACTIONS(1965),
    [anon_sym_or] = ACTIONS(1965),
    [anon_sym_xor] = ACTIONS(1965),
    [anon_sym_max] = ACTIONS(1965),
    [anon_sym_min] = ACTIONS(1965),
    [anon_sym_umax] = ACTIONS(1965),
    [anon_sym_umin] = ACTIONS(1965),
    [anon_sym_fadd] = ACTIONS(1965),
    [anon_sym_fsub] = ACTIONS(1965),
    [anon_sym_bitcast] = ACTIONS(1965),
    [anon_sym_trunc] = ACTIONS(1965),
    [anon_sym_zext] = ACTIONS(1965),
    [anon_sym_sext] = ACTIONS(1965),
    [anon_sym_fptrunc] = ACTIONS(1965),
    [anon_sym_fpext] = ACTIONS(1965),
    [anon_sym_addrspacecast] = ACTIONS(1965),
    [anon_sym_uitofp] = ACTIONS(1965),
    [anon_sym_sitofp] = ACTIONS(1965),
    [anon_sym_fptoui] = ACTIONS(1965),
    [anon_sym_fptosi] = ACTIONS(1965),
    [anon_sym_inttoptr] = ACTIONS(1965),
    [anon_sym_ptrtoint] = ACTIONS(1965),
    [anon_sym_uselistorder] = ACTIONS(1965),
  },
  [605] = {
    [aux_sym_instruction_alloca_repeat1] = STATE(596),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1967),
    [sym_label] = ACTIONS(1967),
    [anon_sym_RBRACE] = ACTIONS(1967),
    [anon_sym_COMMA] = ACTIONS(1969),
    [anon_sym_unreachable] = ACTIONS(1972),
    [anon_sym_ret] = ACTIONS(1972),
    [anon_sym_br] = ACTIONS(1972),
    [anon_sym_resume] = ACTIONS(1972),
    [anon_sym_freeze] = ACTIONS(1972),
    [anon_sym_indirectbr] = ACTIONS(1972),
    [anon_sym_extractelement] = ACTIONS(1972),
    [anon_sym_insertelement] = ACTIONS(1972),
    [anon_sym_select] = ACTIONS(1972),
    [anon_sym_shufflevector] = ACTIONS(1972),
    [anon_sym_fneg] = ACTIONS(1972),
    [anon_sym_switch] = ACTIONS(1972),
    [anon_sym_invoke] = ACTIONS(1972),
    [anon_sym_cleanupret] = ACTIONS(1972),
    [anon_sym_catchret] = ACTIONS(1972),
    [anon_sym_catchswitch] = ACTIONS(1972),
    [anon_sym_catchpad] = ACTIONS(1972),
    [anon_sym_cleanuppad] = ACTIONS(1972),
    [anon_sym_callbr] = ACTIONS(1972),
    [anon_sym_icmp] = ACTIONS(1972),
    [anon_sym_fcmp] = ACTIONS(1972),
    [anon_sym_va_arg] = ACTIONS(1972),
    [anon_sym_phi] = ACTIONS(1972),
    [anon_sym_landingpad] = ACTIONS(1972),
    [anon_sym_tail] = ACTIONS(1972),
    [anon_sym_musttail] = ACTIONS(1972),
    [anon_sym_notail] = ACTIONS(1972),
    [anon_sym_call] = ACTIONS(1972),
    [anon_sym_alloca] = ACTIONS(1972),
    [anon_sym_load] = ACTIONS(1972),
    [anon_sym_store] = ACTIONS(1972),
    [anon_sym_cmpxchg] = ACTIONS(1972),
    [anon_sym_atomicrmw] = ACTIONS(1972),
    [anon_sym_fence] = ACTIONS(1972),
    [anon_sym_getelementptr] = ACTIONS(1972),
    [anon_sym_extractvalue] = ACTIONS(1972),
    [anon_sym_insertvalue] = ACTIONS(1972),
    [anon_sym_mul] = ACTIONS(1972),
    [anon_sym_urem] = ACTIONS(1972),
    [anon_sym_srem] = ACTIONS(1972),
    [anon_sym_shl] = ACTIONS(1972),
    [anon_sym_udiv] = ACTIONS(1972),
    [anon_sym_sdiv] = ACTIONS(1972),
    [anon_sym_lshr] = ACTIONS(1972),
    [anon_sym_ashr] = ACTIONS(1972),
    [anon_sym_fmul] = ACTIONS(1972),
    [anon_sym_fdiv] = ACTIONS(1972),
    [anon_sym_frem] = ACTIONS(1972),
    [anon_sym_xchg] = ACTIONS(1972),
    [anon_sym_add] = ACTIONS(1972),
    [anon_sym_sub] = ACTIONS(1972),
    [anon_sym_and] = ACTIONS(1972),
    [anon_sym_nand] = ACTIONS(1972),
    [anon_sym_or] = ACTIONS(1972),
    [anon_sym_xor] = ACTIONS(1972),
    [anon_sym_max] = ACTIONS(1972),
    [anon_sym_min] = ACTIONS(1972),
    [anon_sym_umax] = ACTIONS(1972),
    [anon_sym_umin] = ACTIONS(1972),
    [anon_sym_fadd] = ACTIONS(1972),
    [anon_sym_fsub] = ACTIONS(1972),
    [anon_sym_bitcast] = ACTIONS(1972),
    [anon_sym_trunc] = ACTIONS(1972),
    [anon_sym_zext] = ACTIONS(1972),
    [anon_sym_sext] = ACTIONS(1972),
    [anon_sym_fptrunc] = ACTIONS(1972),
    [anon_sym_fpext] = ACTIONS(1972),
    [anon_sym_addrspacecast] = ACTIONS(1972),
    [anon_sym_uitofp] = ACTIONS(1972),
    [anon_sym_sitofp] = ACTIONS(1972),
    [anon_sym_fptoui] = ACTIONS(1972),
    [anon_sym_fptosi] = ACTIONS(1972),
    [anon_sym_inttoptr] = ACTIONS(1972),
    [anon_sym_ptrtoint] = ACTIONS(1972),
    [anon_sym_uselistorder] = ACTIONS(1972),
  },
  [606] = {
    [aux_sym_instruction_extractvalue_repeat1] = STATE(602),
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1974),
    [sym_label] = ACTIONS(1974),
    [anon_sym_RBRACE] = ACTIONS(1974),
    [anon_sym_COMMA] = ACTIONS(1976),
    [anon_sym_unreachable] = ACTIONS(1979),
    [anon_sym_ret] = ACTIONS(1979),
    [anon_sym_br] = ACTIONS(1979),
    [anon_sym_resume] = ACTIONS(1979),
    [anon_sym_freeze] = ACTIONS(1979),
    [anon_sym_indirectbr] = ACTIONS(1979),
    [anon_sym_extractelement] = ACTIONS(1979),
    [anon_sym_insertelement] = ACTIONS(1979),
    [anon_sym_select] = ACTIONS(1979),
    [anon_sym_shufflevector] = ACTIONS(1979),
    [anon_sym_fneg] = ACTIONS(1979),
    [anon_sym_switch] = ACTIONS(1979),
    [anon_sym_invoke] = ACTIONS(1979),
    [anon_sym_cleanupret] = ACTIONS(1979),
    [anon_sym_catchret] = ACTIONS(1979),
    [anon_sym_catchswitch] = ACTIONS(1979),
    [anon_sym_catchpad] = ACTIONS(1979),
    [anon_sym_cleanuppad] = ACTIONS(1979),
    [anon_sym_callbr] = ACTIONS(1979),
    [anon_sym_icmp] = ACTIONS(1979),
    [anon_sym_fcmp] = ACTIONS(1979),
    [anon_sym_va_arg] = ACTIONS(1979),
    [anon_sym_phi] = ACTIONS(1979),
    [anon_sym_landingpad] = ACTIONS(1979),
    [anon_sym_tail] = ACTIONS(1979),
    [anon_sym_musttail] = ACTIONS(1979),
    [anon_sym_notail] = ACTIONS(1979),
    [anon_sym_call] = ACTIONS(1979),
    [anon_sym_alloca] = ACTIONS(1979),
    [anon_sym_load] = ACTIONS(1979),
    [anon_sym_store] = ACTIONS(1979),
    [anon_sym_cmpxchg] = ACTIONS(1979),
    [anon_sym_atomicrmw] = ACTIONS(1979),
    [anon_sym_fence] = ACTIONS(1979),
    [anon_sym_getelementptr] = ACTIONS(1979),
    [anon_sym_extractvalue] = ACTIONS(1979),
    [anon_sym_insertvalue] = ACTIONS(1979),
    [anon_sym_mul] = ACTIONS(1979),
    [anon_sym_urem] = ACTIONS(1979),
    [anon_sym_srem] = ACTIONS(1979),
    [anon_sym_shl] = ACTIONS(1979),
    [anon_sym_udiv] = ACTIONS(1979),
    [anon_sym_sdiv] = ACTIONS(1979),
    [anon_sym_lshr] = ACTIONS(1979),
    [anon_sym_ashr] = ACTIONS(1979),
    [anon_sym_fmul] = ACTIONS(1979),
    [anon_sym_fdiv] = ACTIONS(1979),
    [anon_sym_frem] = ACTIONS(1979),
    [anon_sym_xchg] = ACTIONS(1979),
    [anon_sym_add] = ACTIONS(1979),
    [anon_sym_sub] = ACTIONS(1979),
    [anon_sym_and] = ACTIONS(1979),
    [anon_sym_nand] = ACTIONS(1979),
    [anon_sym_or] = ACTIONS(1979),
    [anon_sym_xor] = ACTIONS(1979),
    [anon_sym_max] = ACTIONS(1979),
    [anon_sym_min] = ACTIONS(1979),
    [anon_sym_umax] = ACTIONS(1979),
    [anon_sym_umin] = ACTIONS(1979),
    [anon_sym_fadd] = ACTIONS(1979),
    [anon_sym_fsub] = ACTIONS(1979),
    [anon_sym_bitcast] = ACTIONS(1979),
    [anon_sym_trunc] = ACTIONS(1979),
    [anon_sym_zext] = ACTIONS(1979),
    [anon_sym_sext] = ACTIONS(1979),
    [anon_sym_fptrunc] = ACTIONS(1979),
    [anon_sym_fpext] = ACTIONS(1979),
    [anon_sym_addrspacecast] = ACTIONS(1979),
    [anon_sym_uitofp] = ACTIONS(1979),
    [anon_sym_sitofp] = ACTIONS(1979),
    [anon_sym_fptoui] = ACTIONS(1979),
    [anon_sym_fptosi] = ACTIONS(1979),
    [anon_sym_inttoptr] = ACTIONS(1979),
    [anon_sym_ptrtoint] = ACTIONS(1979),
    [anon_sym_uselistorder] = ACTIONS(1979),
  },
  [607] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1981),
    [sym_label] = ACTIONS(1981),
    [anon_sym_RBRACE] = ACTIONS(1981),
    [anon_sym_COMMA] = ACTIONS(1983),
    [anon_sym_unreachable] = ACTIONS(1986),
    [anon_sym_ret] = ACTIONS(1986),
    [anon_sym_br] = ACTIONS(1986),
    [anon_sym_resume] = ACTIONS(1986),
    [anon_sym_freeze] = ACTIONS(1986),
    [anon_sym_indirectbr] = ACTIONS(1986),
    [anon_sym_extractelement] = ACTIONS(1986),
    [anon_sym_insertelement] = ACTIONS(1986),
    [anon_sym_select] = ACTIONS(1986),
    [anon_sym_shufflevector] = ACTIONS(1986),
    [anon_sym_fneg] = ACTIONS(1986),
    [anon_sym_switch] = ACTIONS(1986),
    [anon_sym_invoke] = ACTIONS(1986),
    [anon_sym_cleanupret] = ACTIONS(1986),
    [anon_sym_catchret] = ACTIONS(1986),
    [anon_sym_catchswitch] = ACTIONS(1986),
    [anon_sym_catchpad] = ACTIONS(1986),
    [anon_sym_cleanuppad] = ACTIONS(1986),
    [anon_sym_callbr] = ACTIONS(1986),
    [anon_sym_icmp] = ACTIONS(1986),
    [anon_sym_fcmp] = ACTIONS(1986),
    [anon_sym_va_arg] = ACTIONS(1986),
    [anon_sym_phi] = ACTIONS(1986),
    [anon_sym_landingpad] = ACTIONS(1986),
    [anon_sym_tail] = ACTIONS(1986),
    [anon_sym_musttail] = ACTIONS(1986),
    [anon_sym_notail] = ACTIONS(1986),
    [anon_sym_call] = ACTIONS(1986),
    [anon_sym_alloca] = ACTIONS(1986),
    [anon_sym_load] = ACTIONS(1986),
    [anon_sym_store] = ACTIONS(1986),
    [anon_sym_cmpxchg] = ACTIONS(1986),
    [anon_sym_atomicrmw] = ACTIONS(1986),
    [anon_sym_fence] = ACTIONS(1986),
    [anon_sym_getelementptr] = ACTIONS(1986),
    [anon_sym_extractvalue] = ACTIONS(1986),
    [anon_sym_insertvalue] = ACTIONS(1986),
    [anon_sym_mul] = ACTIONS(1986),
    [anon_sym_urem] = ACTIONS(1986),
    [anon_sym_srem] = ACTIONS(1986),
    [anon_sym_shl] = ACTIONS(1986),
    [anon_sym_udiv] = ACTIONS(1986),
    [anon_sym_sdiv] = ACTIONS(1986),
    [anon_sym_lshr] = ACTIONS(1986),
    [anon_sym_ashr] = ACTIONS(1986),
    [anon_sym_fmul] = ACTIONS(1986),
    [anon_sym_fdiv] = ACTIONS(1986),
    [anon_sym_frem] = ACTIONS(1986),
    [anon_sym_xchg] = ACTIONS(1986),
    [anon_sym_add] = ACTIONS(1986),
    [anon_sym_sub] = ACTIONS(1986),
    [anon_sym_and] = ACTIONS(1986),
    [anon_sym_nand] = ACTIONS(1986),
    [anon_sym_or] = ACTIONS(1986),
    [anon_sym_xor] = ACTIONS(1986),
    [anon_sym_max] = ACTIONS(1986),
    [anon_sym_min] = ACTIONS(1986),
    [anon_sym_umax] = ACTIONS(1986),
    [anon_sym_umin] = ACTIONS(1986),
    [anon_sym_fadd] = ACTIONS(1986),
    [anon_sym_fsub] = ACTIONS(1986),
    [anon_sym_bitcast] = ACTIONS(1986),
    [anon_sym_trunc] = ACTIONS(1986),
    [anon_sym_zext] = ACTIONS(1986),
    [anon_sym_sext] = ACTIONS(1986),
    [anon_sym_fptrunc] = ACTIONS(1986),
    [anon_sym_fpext] = ACTIONS(1986),
    [anon_sym_addrspacecast] = ACTIONS(1986),
    [anon_sym_uitofp] = ACTIONS(1986),
    [anon_sym_sitofp] = ACTIONS(1986),
    [anon_sym_fptoui] = ACTIONS(1986),
    [anon_sym_fptosi] = ACTIONS(1986),
    [anon_sym_inttoptr] = ACTIONS(1986),
    [anon_sym_ptrtoint] = ACTIONS(1986),
    [anon_sym_uselistorder] = ACTIONS(1986),
  },
  [608] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1988),
    [sym_label] = ACTIONS(1988),
    [anon_sym_RBRACE] = ACTIONS(1988),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_unreachable] = ACTIONS(1990),
    [anon_sym_ret] = ACTIONS(1990),
    [anon_sym_br] = ACTIONS(1990),
    [anon_sym_resume] = ACTIONS(1990),
    [anon_sym_freeze] = ACTIONS(1990),
    [anon_sym_indirectbr] = ACTIONS(1990),
    [anon_sym_extractelement] = ACTIONS(1990),
    [anon_sym_insertelement] = ACTIONS(1990),
    [anon_sym_select] = ACTIONS(1990),
    [anon_sym_shufflevector] = ACTIONS(1990),
    [anon_sym_fneg] = ACTIONS(1990),
    [anon_sym_switch] = ACTIONS(1990),
    [anon_sym_invoke] = ACTIONS(1990),
    [anon_sym_cleanupret] = ACTIONS(1990),
    [anon_sym_catchret] = ACTIONS(1990),
    [anon_sym_catchswitch] = ACTIONS(1990),
    [anon_sym_catchpad] = ACTIONS(1990),
    [anon_sym_cleanuppad] = ACTIONS(1990),
    [anon_sym_callbr] = ACTIONS(1990),
    [anon_sym_icmp] = ACTIONS(1990),
    [anon_sym_fcmp] = ACTIONS(1990),
    [anon_sym_va_arg] = ACTIONS(1990),
    [anon_sym_phi] = ACTIONS(1990),
    [anon_sym_landingpad] = ACTIONS(1990),
    [anon_sym_tail] = ACTIONS(1990),
    [anon_sym_musttail] = ACTIONS(1990),
    [anon_sym_notail] = ACTIONS(1990),
    [anon_sym_call] = ACTIONS(1990),
    [anon_sym_alloca] = ACTIONS(1990),
    [anon_sym_load] = ACTIONS(1990),
    [anon_sym_store] = ACTIONS(1990),
    [anon_sym_cmpxchg] = ACTIONS(1990),
    [anon_sym_atomicrmw] = ACTIONS(1990),
    [anon_sym_fence] = ACTIONS(1990),
    [anon_sym_getelementptr] = ACTIONS(1990),
    [anon_sym_extractvalue] = ACTIONS(1990),
    [anon_sym_insertvalue] = ACTIONS(1990),
    [anon_sym_mul] = ACTIONS(1990),
    [anon_sym_urem] = ACTIONS(1990),
    [anon_sym_srem] = ACTIONS(1990),
    [anon_sym_shl] = ACTIONS(1990),
    [anon_sym_udiv] = ACTIONS(1990),
    [anon_sym_sdiv] = ACTIONS(1990),
    [anon_sym_lshr] = ACTIONS(1990),
    [anon_sym_ashr] = ACTIONS(1990),
    [anon_sym_fmul] = ACTIONS(1990),
    [anon_sym_fdiv] = ACTIONS(1990),
    [anon_sym_frem] = ACTIONS(1990),
    [anon_sym_xchg] = ACTIONS(1990),
    [anon_sym_add] = ACTIONS(1990),
    [anon_sym_sub] = ACTIONS(1990),
    [anon_sym_and] = ACTIONS(1990),
    [anon_sym_nand] = ACTIONS(1990),
    [anon_sym_or] = ACTIONS(1990),
    [anon_sym_xor] = ACTIONS(1990),
    [anon_sym_max] = ACTIONS(1990),
    [anon_sym_min] = ACTIONS(1990),
    [anon_sym_umax] = ACTIONS(1990),
    [anon_sym_umin] = ACTIONS(1990),
    [anon_sym_fadd] = ACTIONS(1990),
    [anon_sym_fsub] = ACTIONS(1990),
    [anon_sym_bitcast] = ACTIONS(1990),
    [anon_sym_trunc] = ACTIONS(1990),
    [anon_sym_zext] = ACTIONS(1990),
    [anon_sym_sext] = ACTIONS(1990),
    [anon_sym_fptrunc] = ACTIONS(1990),
    [anon_sym_fpext] = ACTIONS(1990),
    [anon_sym_addrspacecast] = ACTIONS(1990),
    [anon_sym_uitofp] = ACTIONS(1990),
    [anon_sym_sitofp] = ACTIONS(1990),
    [anon_sym_fptoui] = ACTIONS(1990),
    [anon_sym_fptosi] = ACTIONS(1990),
    [anon_sym_inttoptr] = ACTIONS(1990),
    [anon_sym_ptrtoint] = ACTIONS(1990),
    [anon_sym_uselistorder] = ACTIONS(1990),
  },
  [609] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1992),
    [sym_label] = ACTIONS(1992),
    [anon_sym_RBRACE] = ACTIONS(1992),
    [anon_sym_COMMA] = ACTIONS(1992),
    [anon_sym_unreachable] = ACTIONS(1994),
    [anon_sym_ret] = ACTIONS(1994),
    [anon_sym_br] = ACTIONS(1994),
    [anon_sym_resume] = ACTIONS(1994),
    [anon_sym_freeze] = ACTIONS(1994),
    [anon_sym_indirectbr] = ACTIONS(1994),
    [anon_sym_extractelement] = ACTIONS(1994),
    [anon_sym_insertelement] = ACTIONS(1994),
    [anon_sym_select] = ACTIONS(1994),
    [anon_sym_shufflevector] = ACTIONS(1994),
    [anon_sym_fneg] = ACTIONS(1994),
    [anon_sym_switch] = ACTIONS(1994),
    [anon_sym_invoke] = ACTIONS(1994),
    [anon_sym_cleanupret] = ACTIONS(1994),
    [anon_sym_catchret] = ACTIONS(1994),
    [anon_sym_catchswitch] = ACTIONS(1994),
    [anon_sym_catchpad] = ACTIONS(1994),
    [anon_sym_cleanuppad] = ACTIONS(1994),
    [anon_sym_callbr] = ACTIONS(1994),
    [anon_sym_icmp] = ACTIONS(1994),
    [anon_sym_fcmp] = ACTIONS(1994),
    [anon_sym_va_arg] = ACTIONS(1994),
    [anon_sym_phi] = ACTIONS(1994),
    [anon_sym_landingpad] = ACTIONS(1994),
    [anon_sym_tail] = ACTIONS(1994),
    [anon_sym_musttail] = ACTIONS(1994),
    [anon_sym_notail] = ACTIONS(1994),
    [anon_sym_call] = ACTIONS(1994),
    [anon_sym_alloca] = ACTIONS(1994),
    [anon_sym_load] = ACTIONS(1994),
    [anon_sym_store] = ACTIONS(1994),
    [anon_sym_cmpxchg] = ACTIONS(1994),
    [anon_sym_atomicrmw] = ACTIONS(1994),
    [anon_sym_fence] = ACTIONS(1994),
    [anon_sym_getelementptr] = ACTIONS(1994),
    [anon_sym_extractvalue] = ACTIONS(1994),
    [anon_sym_insertvalue] = ACTIONS(1994),
    [anon_sym_mul] = ACTIONS(1994),
    [anon_sym_urem] = ACTIONS(1994),
    [anon_sym_srem] = ACTIONS(1994),
    [anon_sym_shl] = ACTIONS(1994),
    [anon_sym_udiv] = ACTIONS(1994),
    [anon_sym_sdiv] = ACTIONS(1994),
    [anon_sym_lshr] = ACTIONS(1994),
    [anon_sym_ashr] = ACTIONS(1994),
    [anon_sym_fmul] = ACTIONS(1994),
    [anon_sym_fdiv] = ACTIONS(1994),
    [anon_sym_frem] = ACTIONS(1994),
    [anon_sym_xchg] = ACTIONS(1994),
    [anon_sym_add] = ACTIONS(1994),
    [anon_sym_sub] = ACTIONS(1994),
    [anon_sym_and] = ACTIONS(1994),
    [anon_sym_nand] = ACTIONS(1994),
    [anon_sym_or] = ACTIONS(1994),
    [anon_sym_xor] = ACTIONS(1994),
    [anon_sym_max] = ACTIONS(1994),
    [anon_sym_min] = ACTIONS(1994),
    [anon_sym_umax] = ACTIONS(1994),
    [anon_sym_umin] = ACTIONS(1994),
    [anon_sym_fadd] = ACTIONS(1994),
    [anon_sym_fsub] = ACTIONS(1994),
    [anon_sym_bitcast] = ACTIONS(1994),
    [anon_sym_trunc] = ACTIONS(1994),
    [anon_sym_zext] = ACTIONS(1994),
    [anon_sym_sext] = ACTIONS(1994),
    [anon_sym_fptrunc] = ACTIONS(1994),
    [anon_sym_fpext] = ACTIONS(1994),
    [anon_sym_addrspacecast] = ACTIONS(1994),
    [anon_sym_uitofp] = ACTIONS(1994),
    [anon_sym_sitofp] = ACTIONS(1994),
    [anon_sym_fptoui] = ACTIONS(1994),
    [anon_sym_fptosi] = ACTIONS(1994),
    [anon_sym_inttoptr] = ACTIONS(1994),
    [anon_sym_ptrtoint] = ACTIONS(1994),
    [anon_sym_uselistorder] = ACTIONS(1994),
  },
  [610] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1996),
    [sym_label] = ACTIONS(1996),
    [anon_sym_RBRACE] = ACTIONS(1996),
    [anon_sym_COMMA] = ACTIONS(1996),
    [anon_sym_unreachable] = ACTIONS(1998),
    [anon_sym_ret] = ACTIONS(1998),
    [anon_sym_br] = ACTIONS(1998),
    [anon_sym_resume] = ACTIONS(1998),
    [anon_sym_freeze] = ACTIONS(1998),
    [anon_sym_indirectbr] = ACTIONS(1998),
    [anon_sym_extractelement] = ACTIONS(1998),
    [anon_sym_insertelement] = ACTIONS(1998),
    [anon_sym_select] = ACTIONS(1998),
    [anon_sym_shufflevector] = ACTIONS(1998),
    [anon_sym_fneg] = ACTIONS(1998),
    [anon_sym_switch] = ACTIONS(1998),
    [anon_sym_invoke] = ACTIONS(1998),
    [anon_sym_cleanupret] = ACTIONS(1998),
    [anon_sym_catchret] = ACTIONS(1998),
    [anon_sym_catchswitch] = ACTIONS(1998),
    [anon_sym_catchpad] = ACTIONS(1998),
    [anon_sym_cleanuppad] = ACTIONS(1998),
    [anon_sym_callbr] = ACTIONS(1998),
    [anon_sym_icmp] = ACTIONS(1998),
    [anon_sym_fcmp] = ACTIONS(1998),
    [anon_sym_va_arg] = ACTIONS(1998),
    [anon_sym_phi] = ACTIONS(1998),
    [anon_sym_landingpad] = ACTIONS(1998),
    [anon_sym_tail] = ACTIONS(1998),
    [anon_sym_musttail] = ACTIONS(1998),
    [anon_sym_notail] = ACTIONS(1998),
    [anon_sym_call] = ACTIONS(1998),
    [anon_sym_alloca] = ACTIONS(1998),
    [anon_sym_load] = ACTIONS(1998),
    [anon_sym_store] = ACTIONS(1998),
    [anon_sym_cmpxchg] = ACTIONS(1998),
    [anon_sym_atomicrmw] = ACTIONS(1998),
    [anon_sym_fence] = ACTIONS(1998),
    [anon_sym_getelementptr] = ACTIONS(1998),
    [anon_sym_extractvalue] = ACTIONS(1998),
    [anon_sym_insertvalue] = ACTIONS(1998),
    [anon_sym_mul] = ACTIONS(1998),
    [anon_sym_urem] = ACTIONS(1998),
    [anon_sym_srem] = ACTIONS(1998),
    [anon_sym_shl] = ACTIONS(1998),
    [anon_sym_udiv] = ACTIONS(1998),
    [anon_sym_sdiv] = ACTIONS(1998),
    [anon_sym_lshr] = ACTIONS(1998),
    [anon_sym_ashr] = ACTIONS(1998),
    [anon_sym_fmul] = ACTIONS(1998),
    [anon_sym_fdiv] = ACTIONS(1998),
    [anon_sym_frem] = ACTIONS(1998),
    [anon_sym_xchg] = ACTIONS(1998),
    [anon_sym_add] = ACTIONS(1998),
    [anon_sym_sub] = ACTIONS(1998),
    [anon_sym_and] = ACTIONS(1998),
    [anon_sym_nand] = ACTIONS(1998),
    [anon_sym_or] = ACTIONS(1998),
    [anon_sym_xor] = ACTIONS(1998),
    [anon_sym_max] = ACTIONS(1998),
    [anon_sym_min] = ACTIONS(1998),
    [anon_sym_umax] = ACTIONS(1998),
    [anon_sym_umin] = ACTIONS(1998),
    [anon_sym_fadd] = ACTIONS(1998),
    [anon_sym_fsub] = ACTIONS(1998),
    [anon_sym_bitcast] = ACTIONS(1998),
    [anon_sym_trunc] = ACTIONS(1998),
    [anon_sym_zext] = ACTIONS(1998),
    [anon_sym_sext] = ACTIONS(1998),
    [anon_sym_fptrunc] = ACTIONS(1998),
    [anon_sym_fpext] = ACTIONS(1998),
    [anon_sym_addrspacecast] = ACTIONS(1998),
    [anon_sym_uitofp] = ACTIONS(1998),
    [anon_sym_sitofp] = ACTIONS(1998),
    [anon_sym_fptoui] = ACTIONS(1998),
    [anon_sym_fptosi] = ACTIONS(1998),
    [anon_sym_inttoptr] = ACTIONS(1998),
    [anon_sym_ptrtoint] = ACTIONS(1998),
    [anon_sym_uselistorder] = ACTIONS(1998),
  },
  [611] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2000),
    [sym_label] = ACTIONS(2000),
    [anon_sym_RBRACE] = ACTIONS(2000),
    [anon_sym_COMMA] = ACTIONS(2000),
    [anon_sym_unreachable] = ACTIONS(2002),
    [anon_sym_ret] = ACTIONS(2002),
    [anon_sym_br] = ACTIONS(2002),
    [anon_sym_resume] = ACTIONS(2002),
    [anon_sym_freeze] = ACTIONS(2002),
    [anon_sym_indirectbr] = ACTIONS(2002),
    [anon_sym_extractelement] = ACTIONS(2002),
    [anon_sym_insertelement] = ACTIONS(2002),
    [anon_sym_select] = ACTIONS(2002),
    [anon_sym_shufflevector] = ACTIONS(2002),
    [anon_sym_fneg] = ACTIONS(2002),
    [anon_sym_switch] = ACTIONS(2002),
    [anon_sym_invoke] = ACTIONS(2002),
    [anon_sym_cleanupret] = ACTIONS(2002),
    [anon_sym_catchret] = ACTIONS(2002),
    [anon_sym_catchswitch] = ACTIONS(2002),
    [anon_sym_catchpad] = ACTIONS(2002),
    [anon_sym_cleanuppad] = ACTIONS(2002),
    [anon_sym_callbr] = ACTIONS(2002),
    [anon_sym_icmp] = ACTIONS(2002),
    [anon_sym_fcmp] = ACTIONS(2002),
    [anon_sym_va_arg] = ACTIONS(2002),
    [anon_sym_phi] = ACTIONS(2002),
    [anon_sym_landingpad] = ACTIONS(2002),
    [anon_sym_tail] = ACTIONS(2002),
    [anon_sym_musttail] = ACTIONS(2002),
    [anon_sym_notail] = ACTIONS(2002),
    [anon_sym_call] = ACTIONS(2002),
    [anon_sym_alloca] = ACTIONS(2002),
    [anon_sym_load] = ACTIONS(2002),
    [anon_sym_store] = ACTIONS(2002),
    [anon_sym_cmpxchg] = ACTIONS(2002),
    [anon_sym_atomicrmw] = ACTIONS(2002),
    [anon_sym_fence] = ACTIONS(2002),
    [anon_sym_getelementptr] = ACTIONS(2002),
    [anon_sym_extractvalue] = ACTIONS(2002),
    [anon_sym_insertvalue] = ACTIONS(2002),
    [anon_sym_mul] = ACTIONS(2002),
    [anon_sym_urem] = ACTIONS(2002),
    [anon_sym_srem] = ACTIONS(2002),
    [anon_sym_shl] = ACTIONS(2002),
    [anon_sym_udiv] = ACTIONS(2002),
    [anon_sym_sdiv] = ACTIONS(2002),
    [anon_sym_lshr] = ACTIONS(2002),
    [anon_sym_ashr] = ACTIONS(2002),
    [anon_sym_fmul] = ACTIONS(2002),
    [anon_sym_fdiv] = ACTIONS(2002),
    [anon_sym_frem] = ACTIONS(2002),
    [anon_sym_xchg] = ACTIONS(2002),
    [anon_sym_add] = ACTIONS(2002),
    [anon_sym_sub] = ACTIONS(2002),
    [anon_sym_and] = ACTIONS(2002),
    [anon_sym_nand] = ACTIONS(2002),
    [anon_sym_or] = ACTIONS(2002),
    [anon_sym_xor] = ACTIONS(2002),
    [anon_sym_max] = ACTIONS(2002),
    [anon_sym_min] = ACTIONS(2002),
    [anon_sym_umax] = ACTIONS(2002),
    [anon_sym_umin] = ACTIONS(2002),
    [anon_sym_fadd] = ACTIONS(2002),
    [anon_sym_fsub] = ACTIONS(2002),
    [anon_sym_bitcast] = ACTIONS(2002),
    [anon_sym_trunc] = ACTIONS(2002),
    [anon_sym_zext] = ACTIONS(2002),
    [anon_sym_sext] = ACTIONS(2002),
    [anon_sym_fptrunc] = ACTIONS(2002),
    [anon_sym_fpext] = ACTIONS(2002),
    [anon_sym_addrspacecast] = ACTIONS(2002),
    [anon_sym_uitofp] = ACTIONS(2002),
    [anon_sym_sitofp] = ACTIONS(2002),
    [anon_sym_fptoui] = ACTIONS(2002),
    [anon_sym_fptosi] = ACTIONS(2002),
    [anon_sym_inttoptr] = ACTIONS(2002),
    [anon_sym_ptrtoint] = ACTIONS(2002),
    [anon_sym_uselistorder] = ACTIONS(2002),
  },
  [612] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2004),
    [sym_label] = ACTIONS(2004),
    [anon_sym_RBRACE] = ACTIONS(2004),
    [anon_sym_COMMA] = ACTIONS(2004),
    [anon_sym_unreachable] = ACTIONS(2006),
    [anon_sym_ret] = ACTIONS(2006),
    [anon_sym_br] = ACTIONS(2006),
    [anon_sym_resume] = ACTIONS(2006),
    [anon_sym_freeze] = ACTIONS(2006),
    [anon_sym_indirectbr] = ACTIONS(2006),
    [anon_sym_extractelement] = ACTIONS(2006),
    [anon_sym_insertelement] = ACTIONS(2006),
    [anon_sym_select] = ACTIONS(2006),
    [anon_sym_shufflevector] = ACTIONS(2006),
    [anon_sym_fneg] = ACTIONS(2006),
    [anon_sym_switch] = ACTIONS(2006),
    [anon_sym_invoke] = ACTIONS(2006),
    [anon_sym_cleanupret] = ACTIONS(2006),
    [anon_sym_catchret] = ACTIONS(2006),
    [anon_sym_catchswitch] = ACTIONS(2006),
    [anon_sym_catchpad] = ACTIONS(2006),
    [anon_sym_cleanuppad] = ACTIONS(2006),
    [anon_sym_callbr] = ACTIONS(2006),
    [anon_sym_icmp] = ACTIONS(2006),
    [anon_sym_fcmp] = ACTIONS(2006),
    [anon_sym_va_arg] = ACTIONS(2006),
    [anon_sym_phi] = ACTIONS(2006),
    [anon_sym_landingpad] = ACTIONS(2006),
    [anon_sym_tail] = ACTIONS(2006),
    [anon_sym_musttail] = ACTIONS(2006),
    [anon_sym_notail] = ACTIONS(2006),
    [anon_sym_call] = ACTIONS(2006),
    [anon_sym_alloca] = ACTIONS(2006),
    [anon_sym_load] = ACTIONS(2006),
    [anon_sym_store] = ACTIONS(2006),
    [anon_sym_cmpxchg] = ACTIONS(2006),
    [anon_sym_atomicrmw] = ACTIONS(2006),
    [anon_sym_fence] = ACTIONS(2006),
    [anon_sym_getelementptr] = ACTIONS(2006),
    [anon_sym_extractvalue] = ACTIONS(2006),
    [anon_sym_insertvalue] = ACTIONS(2006),
    [anon_sym_mul] = ACTIONS(2006),
    [anon_sym_urem] = ACTIONS(2006),
    [anon_sym_srem] = ACTIONS(2006),
    [anon_sym_shl] = ACTIONS(2006),
    [anon_sym_udiv] = ACTIONS(2006),
    [anon_sym_sdiv] = ACTIONS(2006),
    [anon_sym_lshr] = ACTIONS(2006),
    [anon_sym_ashr] = ACTIONS(2006),
    [anon_sym_fmul] = ACTIONS(2006),
    [anon_sym_fdiv] = ACTIONS(2006),
    [anon_sym_frem] = ACTIONS(2006),
    [anon_sym_xchg] = ACTIONS(2006),
    [anon_sym_add] = ACTIONS(2006),
    [anon_sym_sub] = ACTIONS(2006),
    [anon_sym_and] = ACTIONS(2006),
    [anon_sym_nand] = ACTIONS(2006),
    [anon_sym_or] = ACTIONS(2006),
    [anon_sym_xor] = ACTIONS(2006),
    [anon_sym_max] = ACTIONS(2006),
    [anon_sym_min] = ACTIONS(2006),
    [anon_sym_umax] = ACTIONS(2006),
    [anon_sym_umin] = ACTIONS(2006),
    [anon_sym_fadd] = ACTIONS(2006),
    [anon_sym_fsub] = ACTIONS(2006),
    [anon_sym_bitcast] = ACTIONS(2006),
    [anon_sym_trunc] = ACTIONS(2006),
    [anon_sym_zext] = ACTIONS(2006),
    [anon_sym_sext] = ACTIONS(2006),
    [anon_sym_fptrunc] = ACTIONS(2006),
    [anon_sym_fpext] = ACTIONS(2006),
    [anon_sym_addrspacecast] = ACTIONS(2006),
    [anon_sym_uitofp] = ACTIONS(2006),
    [anon_sym_sitofp] = ACTIONS(2006),
    [anon_sym_fptoui] = ACTIONS(2006),
    [anon_sym_fptosi] = ACTIONS(2006),
    [anon_sym_inttoptr] = ACTIONS(2006),
    [anon_sym_ptrtoint] = ACTIONS(2006),
    [anon_sym_uselistorder] = ACTIONS(2006),
  },
  [613] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2008),
    [sym_label] = ACTIONS(2008),
    [anon_sym_RBRACE] = ACTIONS(2008),
    [anon_sym_COMMA] = ACTIONS(2008),
    [anon_sym_unreachable] = ACTIONS(2010),
    [anon_sym_ret] = ACTIONS(2010),
    [anon_sym_br] = ACTIONS(2010),
    [anon_sym_resume] = ACTIONS(2010),
    [anon_sym_freeze] = ACTIONS(2010),
    [anon_sym_indirectbr] = ACTIONS(2010),
    [anon_sym_extractelement] = ACTIONS(2010),
    [anon_sym_insertelement] = ACTIONS(2010),
    [anon_sym_select] = ACTIONS(2010),
    [anon_sym_shufflevector] = ACTIONS(2010),
    [anon_sym_fneg] = ACTIONS(2010),
    [anon_sym_switch] = ACTIONS(2010),
    [anon_sym_invoke] = ACTIONS(2010),
    [anon_sym_cleanupret] = ACTIONS(2010),
    [anon_sym_catchret] = ACTIONS(2010),
    [anon_sym_catchswitch] = ACTIONS(2010),
    [anon_sym_catchpad] = ACTIONS(2010),
    [anon_sym_cleanuppad] = ACTIONS(2010),
    [anon_sym_callbr] = ACTIONS(2010),
    [anon_sym_icmp] = ACTIONS(2010),
    [anon_sym_fcmp] = ACTIONS(2010),
    [anon_sym_va_arg] = ACTIONS(2010),
    [anon_sym_phi] = ACTIONS(2010),
    [anon_sym_landingpad] = ACTIONS(2010),
    [anon_sym_tail] = ACTIONS(2010),
    [anon_sym_musttail] = ACTIONS(2010),
    [anon_sym_notail] = ACTIONS(2010),
    [anon_sym_call] = ACTIONS(2010),
    [anon_sym_alloca] = ACTIONS(2010),
    [anon_sym_load] = ACTIONS(2010),
    [anon_sym_store] = ACTIONS(2010),
    [anon_sym_cmpxchg] = ACTIONS(2010),
    [anon_sym_atomicrmw] = ACTIONS(2010),
    [anon_sym_fence] = ACTIONS(2010),
    [anon_sym_getelementptr] = ACTIONS(2010),
    [anon_sym_extractvalue] = ACTIONS(2010),
    [anon_sym_insertvalue] = ACTIONS(2010),
    [anon_sym_mul] = ACTIONS(2010),
    [anon_sym_urem] = ACTIONS(2010),
    [anon_sym_srem] = ACTIONS(2010),
    [anon_sym_shl] = ACTIONS(2010),
    [anon_sym_udiv] = ACTIONS(2010),
    [anon_sym_sdiv] = ACTIONS(2010),
    [anon_sym_lshr] = ACTIONS(2010),
    [anon_sym_ashr] = ACTIONS(2010),
    [anon_sym_fmul] = ACTIONS(2010),
    [anon_sym_fdiv] = ACTIONS(2010),
    [anon_sym_frem] = ACTIONS(2010),
    [anon_sym_xchg] = ACTIONS(2010),
    [anon_sym_add] = ACTIONS(2010),
    [anon_sym_sub] = ACTIONS(2010),
    [anon_sym_and] = ACTIONS(2010),
    [anon_sym_nand] = ACTIONS(2010),
    [anon_sym_or] = ACTIONS(2010),
    [anon_sym_xor] = ACTIONS(2010),
    [anon_sym_max] = ACTIONS(2010),
    [anon_sym_min] = ACTIONS(2010),
    [anon_sym_umax] = ACTIONS(2010),
    [anon_sym_umin] = ACTIONS(2010),
    [anon_sym_fadd] = ACTIONS(2010),
    [anon_sym_fsub] = ACTIONS(2010),
    [anon_sym_bitcast] = ACTIONS(2010),
    [anon_sym_trunc] = ACTIONS(2010),
    [anon_sym_zext] = ACTIONS(2010),
    [anon_sym_sext] = ACTIONS(2010),
    [anon_sym_fptrunc] = ACTIONS(2010),
    [anon_sym_fpext] = ACTIONS(2010),
    [anon_sym_addrspacecast] = ACTIONS(2010),
    [anon_sym_uitofp] = ACTIONS(2010),
    [anon_sym_sitofp] = ACTIONS(2010),
    [anon_sym_fptoui] = ACTIONS(2010),
    [anon_sym_fptosi] = ACTIONS(2010),
    [anon_sym_inttoptr] = ACTIONS(2010),
    [anon_sym_ptrtoint] = ACTIONS(2010),
    [anon_sym_uselistorder] = ACTIONS(2010),
  },
  [614] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2012),
    [sym_label] = ACTIONS(2012),
    [anon_sym_RBRACE] = ACTIONS(2012),
    [anon_sym_COMMA] = ACTIONS(2012),
    [anon_sym_unreachable] = ACTIONS(2014),
    [anon_sym_ret] = ACTIONS(2014),
    [anon_sym_br] = ACTIONS(2014),
    [anon_sym_resume] = ACTIONS(2014),
    [anon_sym_freeze] = ACTIONS(2014),
    [anon_sym_indirectbr] = ACTIONS(2014),
    [anon_sym_extractelement] = ACTIONS(2014),
    [anon_sym_insertelement] = ACTIONS(2014),
    [anon_sym_select] = ACTIONS(2014),
    [anon_sym_shufflevector] = ACTIONS(2014),
    [anon_sym_fneg] = ACTIONS(2014),
    [anon_sym_switch] = ACTIONS(2014),
    [anon_sym_invoke] = ACTIONS(2014),
    [anon_sym_cleanupret] = ACTIONS(2014),
    [anon_sym_catchret] = ACTIONS(2014),
    [anon_sym_catchswitch] = ACTIONS(2014),
    [anon_sym_catchpad] = ACTIONS(2014),
    [anon_sym_cleanuppad] = ACTIONS(2014),
    [anon_sym_callbr] = ACTIONS(2014),
    [anon_sym_icmp] = ACTIONS(2014),
    [anon_sym_fcmp] = ACTIONS(2014),
    [anon_sym_va_arg] = ACTIONS(2014),
    [anon_sym_phi] = ACTIONS(2014),
    [anon_sym_landingpad] = ACTIONS(2014),
    [anon_sym_tail] = ACTIONS(2014),
    [anon_sym_musttail] = ACTIONS(2014),
    [anon_sym_notail] = ACTIONS(2014),
    [anon_sym_call] = ACTIONS(2014),
    [anon_sym_alloca] = ACTIONS(2014),
    [anon_sym_load] = ACTIONS(2014),
    [anon_sym_store] = ACTIONS(2014),
    [anon_sym_cmpxchg] = ACTIONS(2014),
    [anon_sym_atomicrmw] = ACTIONS(2014),
    [anon_sym_fence] = ACTIONS(2014),
    [anon_sym_getelementptr] = ACTIONS(2014),
    [anon_sym_extractvalue] = ACTIONS(2014),
    [anon_sym_insertvalue] = ACTIONS(2014),
    [anon_sym_mul] = ACTIONS(2014),
    [anon_sym_urem] = ACTIONS(2014),
    [anon_sym_srem] = ACTIONS(2014),
    [anon_sym_shl] = ACTIONS(2014),
    [anon_sym_udiv] = ACTIONS(2014),
    [anon_sym_sdiv] = ACTIONS(2014),
    [anon_sym_lshr] = ACTIONS(2014),
    [anon_sym_ashr] = ACTIONS(2014),
    [anon_sym_fmul] = ACTIONS(2014),
    [anon_sym_fdiv] = ACTIONS(2014),
    [anon_sym_frem] = ACTIONS(2014),
    [anon_sym_xchg] = ACTIONS(2014),
    [anon_sym_add] = ACTIONS(2014),
    [anon_sym_sub] = ACTIONS(2014),
    [anon_sym_and] = ACTIONS(2014),
    [anon_sym_nand] = ACTIONS(2014),
    [anon_sym_or] = ACTIONS(2014),
    [anon_sym_xor] = ACTIONS(2014),
    [anon_sym_max] = ACTIONS(2014),
    [anon_sym_min] = ACTIONS(2014),
    [anon_sym_umax] = ACTIONS(2014),
    [anon_sym_umin] = ACTIONS(2014),
    [anon_sym_fadd] = ACTIONS(2014),
    [anon_sym_fsub] = ACTIONS(2014),
    [anon_sym_bitcast] = ACTIONS(2014),
    [anon_sym_trunc] = ACTIONS(2014),
    [anon_sym_zext] = ACTIONS(2014),
    [anon_sym_sext] = ACTIONS(2014),
    [anon_sym_fptrunc] = ACTIONS(2014),
    [anon_sym_fpext] = ACTIONS(2014),
    [anon_sym_addrspacecast] = ACTIONS(2014),
    [anon_sym_uitofp] = ACTIONS(2014),
    [anon_sym_sitofp] = ACTIONS(2014),
    [anon_sym_fptoui] = ACTIONS(2014),
    [anon_sym_fptosi] = ACTIONS(2014),
    [anon_sym_inttoptr] = ACTIONS(2014),
    [anon_sym_ptrtoint] = ACTIONS(2014),
    [anon_sym_uselistorder] = ACTIONS(2014),
  },
  [615] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2016),
    [sym_label] = ACTIONS(2016),
    [anon_sym_RBRACE] = ACTIONS(2016),
    [anon_sym_COMMA] = ACTIONS(2016),
    [anon_sym_unreachable] = ACTIONS(2018),
    [anon_sym_ret] = ACTIONS(2018),
    [anon_sym_br] = ACTIONS(2018),
    [anon_sym_resume] = ACTIONS(2018),
    [anon_sym_freeze] = ACTIONS(2018),
    [anon_sym_indirectbr] = ACTIONS(2018),
    [anon_sym_extractelement] = ACTIONS(2018),
    [anon_sym_insertelement] = ACTIONS(2018),
    [anon_sym_select] = ACTIONS(2018),
    [anon_sym_shufflevector] = ACTIONS(2018),
    [anon_sym_fneg] = ACTIONS(2018),
    [anon_sym_switch] = ACTIONS(2018),
    [anon_sym_invoke] = ACTIONS(2018),
    [anon_sym_cleanupret] = ACTIONS(2018),
    [anon_sym_catchret] = ACTIONS(2018),
    [anon_sym_catchswitch] = ACTIONS(2018),
    [anon_sym_catchpad] = ACTIONS(2018),
    [anon_sym_cleanuppad] = ACTIONS(2018),
    [anon_sym_callbr] = ACTIONS(2018),
    [anon_sym_icmp] = ACTIONS(2018),
    [anon_sym_fcmp] = ACTIONS(2018),
    [anon_sym_va_arg] = ACTIONS(2018),
    [anon_sym_phi] = ACTIONS(2018),
    [anon_sym_landingpad] = ACTIONS(2018),
    [anon_sym_tail] = ACTIONS(2018),
    [anon_sym_musttail] = ACTIONS(2018),
    [anon_sym_notail] = ACTIONS(2018),
    [anon_sym_call] = ACTIONS(2018),
    [anon_sym_alloca] = ACTIONS(2018),
    [anon_sym_load] = ACTIONS(2018),
    [anon_sym_store] = ACTIONS(2018),
    [anon_sym_cmpxchg] = ACTIONS(2018),
    [anon_sym_atomicrmw] = ACTIONS(2018),
    [anon_sym_fence] = ACTIONS(2018),
    [anon_sym_getelementptr] = ACTIONS(2018),
    [anon_sym_extractvalue] = ACTIONS(2018),
    [anon_sym_insertvalue] = ACTIONS(2018),
    [anon_sym_mul] = ACTIONS(2018),
    [anon_sym_urem] = ACTIONS(2018),
    [anon_sym_srem] = ACTIONS(2018),
    [anon_sym_shl] = ACTIONS(2018),
    [anon_sym_udiv] = ACTIONS(2018),
    [anon_sym_sdiv] = ACTIONS(2018),
    [anon_sym_lshr] = ACTIONS(2018),
    [anon_sym_ashr] = ACTIONS(2018),
    [anon_sym_fmul] = ACTIONS(2018),
    [anon_sym_fdiv] = ACTIONS(2018),
    [anon_sym_frem] = ACTIONS(2018),
    [anon_sym_xchg] = ACTIONS(2018),
    [anon_sym_add] = ACTIONS(2018),
    [anon_sym_sub] = ACTIONS(2018),
    [anon_sym_and] = ACTIONS(2018),
    [anon_sym_nand] = ACTIONS(2018),
    [anon_sym_or] = ACTIONS(2018),
    [anon_sym_xor] = ACTIONS(2018),
    [anon_sym_max] = ACTIONS(2018),
    [anon_sym_min] = ACTIONS(2018),
    [anon_sym_umax] = ACTIONS(2018),
    [anon_sym_umin] = ACTIONS(2018),
    [anon_sym_fadd] = ACTIONS(2018),
    [anon_sym_fsub] = ACTIONS(2018),
    [anon_sym_bitcast] = ACTIONS(2018),
    [anon_sym_trunc] = ACTIONS(2018),
    [anon_sym_zext] = ACTIONS(2018),
    [anon_sym_sext] = ACTIONS(2018),
    [anon_sym_fptrunc] = ACTIONS(2018),
    [anon_sym_fpext] = ACTIONS(2018),
    [anon_sym_addrspacecast] = ACTIONS(2018),
    [anon_sym_uitofp] = ACTIONS(2018),
    [anon_sym_sitofp] = ACTIONS(2018),
    [anon_sym_fptoui] = ACTIONS(2018),
    [anon_sym_fptosi] = ACTIONS(2018),
    [anon_sym_inttoptr] = ACTIONS(2018),
    [anon_sym_ptrtoint] = ACTIONS(2018),
    [anon_sym_uselistorder] = ACTIONS(2018),
  },
  [616] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2020),
    [sym_label] = ACTIONS(2020),
    [anon_sym_RBRACE] = ACTIONS(2020),
    [anon_sym_COMMA] = ACTIONS(2020),
    [anon_sym_unreachable] = ACTIONS(2022),
    [anon_sym_ret] = ACTIONS(2022),
    [anon_sym_br] = ACTIONS(2022),
    [anon_sym_resume] = ACTIONS(2022),
    [anon_sym_freeze] = ACTIONS(2022),
    [anon_sym_indirectbr] = ACTIONS(2022),
    [anon_sym_extractelement] = ACTIONS(2022),
    [anon_sym_insertelement] = ACTIONS(2022),
    [anon_sym_select] = ACTIONS(2022),
    [anon_sym_shufflevector] = ACTIONS(2022),
    [anon_sym_fneg] = ACTIONS(2022),
    [anon_sym_switch] = ACTIONS(2022),
    [anon_sym_invoke] = ACTIONS(2022),
    [anon_sym_cleanupret] = ACTIONS(2022),
    [anon_sym_catchret] = ACTIONS(2022),
    [anon_sym_catchswitch] = ACTIONS(2022),
    [anon_sym_catchpad] = ACTIONS(2022),
    [anon_sym_cleanuppad] = ACTIONS(2022),
    [anon_sym_callbr] = ACTIONS(2022),
    [anon_sym_icmp] = ACTIONS(2022),
    [anon_sym_fcmp] = ACTIONS(2022),
    [anon_sym_va_arg] = ACTIONS(2022),
    [anon_sym_phi] = ACTIONS(2022),
    [anon_sym_landingpad] = ACTIONS(2022),
    [anon_sym_tail] = ACTIONS(2022),
    [anon_sym_musttail] = ACTIONS(2022),
    [anon_sym_notail] = ACTIONS(2022),
    [anon_sym_call] = ACTIONS(2022),
    [anon_sym_alloca] = ACTIONS(2022),
    [anon_sym_load] = ACTIONS(2022),
    [anon_sym_store] = ACTIONS(2022),
    [anon_sym_cmpxchg] = ACTIONS(2022),
    [anon_sym_atomicrmw] = ACTIONS(2022),
    [anon_sym_fence] = ACTIONS(2022),
    [anon_sym_getelementptr] = ACTIONS(2022),
    [anon_sym_extractvalue] = ACTIONS(2022),
    [anon_sym_insertvalue] = ACTIONS(2022),
    [anon_sym_mul] = ACTIONS(2022),
    [anon_sym_urem] = ACTIONS(2022),
    [anon_sym_srem] = ACTIONS(2022),
    [anon_sym_shl] = ACTIONS(2022),
    [anon_sym_udiv] = ACTIONS(2022),
    [anon_sym_sdiv] = ACTIONS(2022),
    [anon_sym_lshr] = ACTIONS(2022),
    [anon_sym_ashr] = ACTIONS(2022),
    [anon_sym_fmul] = ACTIONS(2022),
    [anon_sym_fdiv] = ACTIONS(2022),
    [anon_sym_frem] = ACTIONS(2022),
    [anon_sym_xchg] = ACTIONS(2022),
    [anon_sym_add] = ACTIONS(2022),
    [anon_sym_sub] = ACTIONS(2022),
    [anon_sym_and] = ACTIONS(2022),
    [anon_sym_nand] = ACTIONS(2022),
    [anon_sym_or] = ACTIONS(2022),
    [anon_sym_xor] = ACTIONS(2022),
    [anon_sym_max] = ACTIONS(2022),
    [anon_sym_min] = ACTIONS(2022),
    [anon_sym_umax] = ACTIONS(2022),
    [anon_sym_umin] = ACTIONS(2022),
    [anon_sym_fadd] = ACTIONS(2022),
    [anon_sym_fsub] = ACTIONS(2022),
    [anon_sym_bitcast] = ACTIONS(2022),
    [anon_sym_trunc] = ACTIONS(2022),
    [anon_sym_zext] = ACTIONS(2022),
    [anon_sym_sext] = ACTIONS(2022),
    [anon_sym_fptrunc] = ACTIONS(2022),
    [anon_sym_fpext] = ACTIONS(2022),
    [anon_sym_addrspacecast] = ACTIONS(2022),
    [anon_sym_uitofp] = ACTIONS(2022),
    [anon_sym_sitofp] = ACTIONS(2022),
    [anon_sym_fptoui] = ACTIONS(2022),
    [anon_sym_fptosi] = ACTIONS(2022),
    [anon_sym_inttoptr] = ACTIONS(2022),
    [anon_sym_ptrtoint] = ACTIONS(2022),
    [anon_sym_uselistorder] = ACTIONS(2022),
  },
  [617] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2024),
    [sym_label] = ACTIONS(2024),
    [anon_sym_RBRACE] = ACTIONS(2024),
    [anon_sym_COMMA] = ACTIONS(2024),
    [anon_sym_unreachable] = ACTIONS(2026),
    [anon_sym_ret] = ACTIONS(2026),
    [anon_sym_br] = ACTIONS(2026),
    [anon_sym_resume] = ACTIONS(2026),
    [anon_sym_freeze] = ACTIONS(2026),
    [anon_sym_indirectbr] = ACTIONS(2026),
    [anon_sym_extractelement] = ACTIONS(2026),
    [anon_sym_insertelement] = ACTIONS(2026),
    [anon_sym_select] = ACTIONS(2026),
    [anon_sym_shufflevector] = ACTIONS(2026),
    [anon_sym_fneg] = ACTIONS(2026),
    [anon_sym_switch] = ACTIONS(2026),
    [anon_sym_invoke] = ACTIONS(2026),
    [anon_sym_cleanupret] = ACTIONS(2026),
    [anon_sym_catchret] = ACTIONS(2026),
    [anon_sym_catchswitch] = ACTIONS(2026),
    [anon_sym_catchpad] = ACTIONS(2026),
    [anon_sym_cleanuppad] = ACTIONS(2026),
    [anon_sym_callbr] = ACTIONS(2026),
    [anon_sym_icmp] = ACTIONS(2026),
    [anon_sym_fcmp] = ACTIONS(2026),
    [anon_sym_va_arg] = ACTIONS(2026),
    [anon_sym_phi] = ACTIONS(2026),
    [anon_sym_landingpad] = ACTIONS(2026),
    [anon_sym_tail] = ACTIONS(2026),
    [anon_sym_musttail] = ACTIONS(2026),
    [anon_sym_notail] = ACTIONS(2026),
    [anon_sym_call] = ACTIONS(2026),
    [anon_sym_alloca] = ACTIONS(2026),
    [anon_sym_load] = ACTIONS(2026),
    [anon_sym_store] = ACTIONS(2026),
    [anon_sym_cmpxchg] = ACTIONS(2026),
    [anon_sym_atomicrmw] = ACTIONS(2026),
    [anon_sym_fence] = ACTIONS(2026),
    [anon_sym_getelementptr] = ACTIONS(2026),
    [anon_sym_extractvalue] = ACTIONS(2026),
    [anon_sym_insertvalue] = ACTIONS(2026),
    [anon_sym_mul] = ACTIONS(2026),
    [anon_sym_urem] = ACTIONS(2026),
    [anon_sym_srem] = ACTIONS(2026),
    [anon_sym_shl] = ACTIONS(2026),
    [anon_sym_udiv] = ACTIONS(2026),
    [anon_sym_sdiv] = ACTIONS(2026),
    [anon_sym_lshr] = ACTIONS(2026),
    [anon_sym_ashr] = ACTIONS(2026),
    [anon_sym_fmul] = ACTIONS(2026),
    [anon_sym_fdiv] = ACTIONS(2026),
    [anon_sym_frem] = ACTIONS(2026),
    [anon_sym_xchg] = ACTIONS(2026),
    [anon_sym_add] = ACTIONS(2026),
    [anon_sym_sub] = ACTIONS(2026),
    [anon_sym_and] = ACTIONS(2026),
    [anon_sym_nand] = ACTIONS(2026),
    [anon_sym_or] = ACTIONS(2026),
    [anon_sym_xor] = ACTIONS(2026),
    [anon_sym_max] = ACTIONS(2026),
    [anon_sym_min] = ACTIONS(2026),
    [anon_sym_umax] = ACTIONS(2026),
    [anon_sym_umin] = ACTIONS(2026),
    [anon_sym_fadd] = ACTIONS(2026),
    [anon_sym_fsub] = ACTIONS(2026),
    [anon_sym_bitcast] = ACTIONS(2026),
    [anon_sym_trunc] = ACTIONS(2026),
    [anon_sym_zext] = ACTIONS(2026),
    [anon_sym_sext] = ACTIONS(2026),
    [anon_sym_fptrunc] = ACTIONS(2026),
    [anon_sym_fpext] = ACTIONS(2026),
    [anon_sym_addrspacecast] = ACTIONS(2026),
    [anon_sym_uitofp] = ACTIONS(2026),
    [anon_sym_sitofp] = ACTIONS(2026),
    [anon_sym_fptoui] = ACTIONS(2026),
    [anon_sym_fptosi] = ACTIONS(2026),
    [anon_sym_inttoptr] = ACTIONS(2026),
    [anon_sym_ptrtoint] = ACTIONS(2026),
    [anon_sym_uselistorder] = ACTIONS(2026),
  },
  [618] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2028),
    [sym_label] = ACTIONS(2028),
    [anon_sym_RBRACE] = ACTIONS(2028),
    [anon_sym_COMMA] = ACTIONS(2028),
    [anon_sym_unreachable] = ACTIONS(2030),
    [anon_sym_ret] = ACTIONS(2030),
    [anon_sym_br] = ACTIONS(2030),
    [anon_sym_resume] = ACTIONS(2030),
    [anon_sym_freeze] = ACTIONS(2030),
    [anon_sym_indirectbr] = ACTIONS(2030),
    [anon_sym_extractelement] = ACTIONS(2030),
    [anon_sym_insertelement] = ACTIONS(2030),
    [anon_sym_select] = ACTIONS(2030),
    [anon_sym_shufflevector] = ACTIONS(2030),
    [anon_sym_fneg] = ACTIONS(2030),
    [anon_sym_switch] = ACTIONS(2030),
    [anon_sym_invoke] = ACTIONS(2030),
    [anon_sym_cleanupret] = ACTIONS(2030),
    [anon_sym_catchret] = ACTIONS(2030),
    [anon_sym_catchswitch] = ACTIONS(2030),
    [anon_sym_catchpad] = ACTIONS(2030),
    [anon_sym_cleanuppad] = ACTIONS(2030),
    [anon_sym_callbr] = ACTIONS(2030),
    [anon_sym_icmp] = ACTIONS(2030),
    [anon_sym_fcmp] = ACTIONS(2030),
    [anon_sym_va_arg] = ACTIONS(2030),
    [anon_sym_phi] = ACTIONS(2030),
    [anon_sym_landingpad] = ACTIONS(2030),
    [anon_sym_tail] = ACTIONS(2030),
    [anon_sym_musttail] = ACTIONS(2030),
    [anon_sym_notail] = ACTIONS(2030),
    [anon_sym_call] = ACTIONS(2030),
    [anon_sym_alloca] = ACTIONS(2030),
    [anon_sym_load] = ACTIONS(2030),
    [anon_sym_store] = ACTIONS(2030),
    [anon_sym_cmpxchg] = ACTIONS(2030),
    [anon_sym_atomicrmw] = ACTIONS(2030),
    [anon_sym_fence] = ACTIONS(2030),
    [anon_sym_getelementptr] = ACTIONS(2030),
    [anon_sym_extractvalue] = ACTIONS(2030),
    [anon_sym_insertvalue] = ACTIONS(2030),
    [anon_sym_mul] = ACTIONS(2030),
    [anon_sym_urem] = ACTIONS(2030),
    [anon_sym_srem] = ACTIONS(2030),
    [anon_sym_shl] = ACTIONS(2030),
    [anon_sym_udiv] = ACTIONS(2030),
    [anon_sym_sdiv] = ACTIONS(2030),
    [anon_sym_lshr] = ACTIONS(2030),
    [anon_sym_ashr] = ACTIONS(2030),
    [anon_sym_fmul] = ACTIONS(2030),
    [anon_sym_fdiv] = ACTIONS(2030),
    [anon_sym_frem] = ACTIONS(2030),
    [anon_sym_xchg] = ACTIONS(2030),
    [anon_sym_add] = ACTIONS(2030),
    [anon_sym_sub] = ACTIONS(2030),
    [anon_sym_and] = ACTIONS(2030),
    [anon_sym_nand] = ACTIONS(2030),
    [anon_sym_or] = ACTIONS(2030),
    [anon_sym_xor] = ACTIONS(2030),
    [anon_sym_max] = ACTIONS(2030),
    [anon_sym_min] = ACTIONS(2030),
    [anon_sym_umax] = ACTIONS(2030),
    [anon_sym_umin] = ACTIONS(2030),
    [anon_sym_fadd] = ACTIONS(2030),
    [anon_sym_fsub] = ACTIONS(2030),
    [anon_sym_bitcast] = ACTIONS(2030),
    [anon_sym_trunc] = ACTIONS(2030),
    [anon_sym_zext] = ACTIONS(2030),
    [anon_sym_sext] = ACTIONS(2030),
    [anon_sym_fptrunc] = ACTIONS(2030),
    [anon_sym_fpext] = ACTIONS(2030),
    [anon_sym_addrspacecast] = ACTIONS(2030),
    [anon_sym_uitofp] = ACTIONS(2030),
    [anon_sym_sitofp] = ACTIONS(2030),
    [anon_sym_fptoui] = ACTIONS(2030),
    [anon_sym_fptosi] = ACTIONS(2030),
    [anon_sym_inttoptr] = ACTIONS(2030),
    [anon_sym_ptrtoint] = ACTIONS(2030),
    [anon_sym_uselistorder] = ACTIONS(2030),
  },
  [619] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2032),
    [sym_label] = ACTIONS(2032),
    [anon_sym_RBRACE] = ACTIONS(2032),
    [anon_sym_COMMA] = ACTIONS(2032),
    [anon_sym_unreachable] = ACTIONS(2034),
    [anon_sym_ret] = ACTIONS(2034),
    [anon_sym_br] = ACTIONS(2034),
    [anon_sym_resume] = ACTIONS(2034),
    [anon_sym_freeze] = ACTIONS(2034),
    [anon_sym_indirectbr] = ACTIONS(2034),
    [anon_sym_extractelement] = ACTIONS(2034),
    [anon_sym_insertelement] = ACTIONS(2034),
    [anon_sym_select] = ACTIONS(2034),
    [anon_sym_shufflevector] = ACTIONS(2034),
    [anon_sym_fneg] = ACTIONS(2034),
    [anon_sym_switch] = ACTIONS(2034),
    [anon_sym_invoke] = ACTIONS(2034),
    [anon_sym_cleanupret] = ACTIONS(2034),
    [anon_sym_catchret] = ACTIONS(2034),
    [anon_sym_catchswitch] = ACTIONS(2034),
    [anon_sym_catchpad] = ACTIONS(2034),
    [anon_sym_cleanuppad] = ACTIONS(2034),
    [anon_sym_callbr] = ACTIONS(2034),
    [anon_sym_icmp] = ACTIONS(2034),
    [anon_sym_fcmp] = ACTIONS(2034),
    [anon_sym_va_arg] = ACTIONS(2034),
    [anon_sym_phi] = ACTIONS(2034),
    [anon_sym_landingpad] = ACTIONS(2034),
    [anon_sym_tail] = ACTIONS(2034),
    [anon_sym_musttail] = ACTIONS(2034),
    [anon_sym_notail] = ACTIONS(2034),
    [anon_sym_call] = ACTIONS(2034),
    [anon_sym_alloca] = ACTIONS(2034),
    [anon_sym_load] = ACTIONS(2034),
    [anon_sym_store] = ACTIONS(2034),
    [anon_sym_cmpxchg] = ACTIONS(2034),
    [anon_sym_atomicrmw] = ACTIONS(2034),
    [anon_sym_fence] = ACTIONS(2034),
    [anon_sym_getelementptr] = ACTIONS(2034),
    [anon_sym_extractvalue] = ACTIONS(2034),
    [anon_sym_insertvalue] = ACTIONS(2034),
    [anon_sym_mul] = ACTIONS(2034),
    [anon_sym_urem] = ACTIONS(2034),
    [anon_sym_srem] = ACTIONS(2034),
    [anon_sym_shl] = ACTIONS(2034),
    [anon_sym_udiv] = ACTIONS(2034),
    [anon_sym_sdiv] = ACTIONS(2034),
    [anon_sym_lshr] = ACTIONS(2034),
    [anon_sym_ashr] = ACTIONS(2034),
    [anon_sym_fmul] = ACTIONS(2034),
    [anon_sym_fdiv] = ACTIONS(2034),
    [anon_sym_frem] = ACTIONS(2034),
    [anon_sym_xchg] = ACTIONS(2034),
    [anon_sym_add] = ACTIONS(2034),
    [anon_sym_sub] = ACTIONS(2034),
    [anon_sym_and] = ACTIONS(2034),
    [anon_sym_nand] = ACTIONS(2034),
    [anon_sym_or] = ACTIONS(2034),
    [anon_sym_xor] = ACTIONS(2034),
    [anon_sym_max] = ACTIONS(2034),
    [anon_sym_min] = ACTIONS(2034),
    [anon_sym_umax] = ACTIONS(2034),
    [anon_sym_umin] = ACTIONS(2034),
    [anon_sym_fadd] = ACTIONS(2034),
    [anon_sym_fsub] = ACTIONS(2034),
    [anon_sym_bitcast] = ACTIONS(2034),
    [anon_sym_trunc] = ACTIONS(2034),
    [anon_sym_zext] = ACTIONS(2034),
    [anon_sym_sext] = ACTIONS(2034),
    [anon_sym_fptrunc] = ACTIONS(2034),
    [anon_sym_fpext] = ACTIONS(2034),
    [anon_sym_addrspacecast] = ACTIONS(2034),
    [anon_sym_uitofp] = ACTIONS(2034),
    [anon_sym_sitofp] = ACTIONS(2034),
    [anon_sym_fptoui] = ACTIONS(2034),
    [anon_sym_fptosi] = ACTIONS(2034),
    [anon_sym_inttoptr] = ACTIONS(2034),
    [anon_sym_ptrtoint] = ACTIONS(2034),
    [anon_sym_uselistorder] = ACTIONS(2034),
  },
  [620] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2036),
    [sym_label] = ACTIONS(2036),
    [anon_sym_RBRACE] = ACTIONS(2036),
    [anon_sym_COMMA] = ACTIONS(2036),
    [anon_sym_unreachable] = ACTIONS(2038),
    [anon_sym_ret] = ACTIONS(2038),
    [anon_sym_br] = ACTIONS(2038),
    [anon_sym_resume] = ACTIONS(2038),
    [anon_sym_freeze] = ACTIONS(2038),
    [anon_sym_indirectbr] = ACTIONS(2038),
    [anon_sym_extractelement] = ACTIONS(2038),
    [anon_sym_insertelement] = ACTIONS(2038),
    [anon_sym_select] = ACTIONS(2038),
    [anon_sym_shufflevector] = ACTIONS(2038),
    [anon_sym_fneg] = ACTIONS(2038),
    [anon_sym_switch] = ACTIONS(2038),
    [anon_sym_invoke] = ACTIONS(2038),
    [anon_sym_cleanupret] = ACTIONS(2038),
    [anon_sym_catchret] = ACTIONS(2038),
    [anon_sym_catchswitch] = ACTIONS(2038),
    [anon_sym_catchpad] = ACTIONS(2038),
    [anon_sym_cleanuppad] = ACTIONS(2038),
    [anon_sym_callbr] = ACTIONS(2038),
    [anon_sym_icmp] = ACTIONS(2038),
    [anon_sym_fcmp] = ACTIONS(2038),
    [anon_sym_va_arg] = ACTIONS(2038),
    [anon_sym_phi] = ACTIONS(2038),
    [anon_sym_landingpad] = ACTIONS(2038),
    [anon_sym_tail] = ACTIONS(2038),
    [anon_sym_musttail] = ACTIONS(2038),
    [anon_sym_notail] = ACTIONS(2038),
    [anon_sym_call] = ACTIONS(2038),
    [anon_sym_alloca] = ACTIONS(2038),
    [anon_sym_load] = ACTIONS(2038),
    [anon_sym_store] = ACTIONS(2038),
    [anon_sym_cmpxchg] = ACTIONS(2038),
    [anon_sym_atomicrmw] = ACTIONS(2038),
    [anon_sym_fence] = ACTIONS(2038),
    [anon_sym_getelementptr] = ACTIONS(2038),
    [anon_sym_extractvalue] = ACTIONS(2038),
    [anon_sym_insertvalue] = ACTIONS(2038),
    [anon_sym_mul] = ACTIONS(2038),
    [anon_sym_urem] = ACTIONS(2038),
    [anon_sym_srem] = ACTIONS(2038),
    [anon_sym_shl] = ACTIONS(2038),
    [anon_sym_udiv] = ACTIONS(2038),
    [anon_sym_sdiv] = ACTIONS(2038),
    [anon_sym_lshr] = ACTIONS(2038),
    [anon_sym_ashr] = ACTIONS(2038),
    [anon_sym_fmul] = ACTIONS(2038),
    [anon_sym_fdiv] = ACTIONS(2038),
    [anon_sym_frem] = ACTIONS(2038),
    [anon_sym_xchg] = ACTIONS(2038),
    [anon_sym_add] = ACTIONS(2038),
    [anon_sym_sub] = ACTIONS(2038),
    [anon_sym_and] = ACTIONS(2038),
    [anon_sym_nand] = ACTIONS(2038),
    [anon_sym_or] = ACTIONS(2038),
    [anon_sym_xor] = ACTIONS(2038),
    [anon_sym_max] = ACTIONS(2038),
    [anon_sym_min] = ACTIONS(2038),
    [anon_sym_umax] = ACTIONS(2038),
    [anon_sym_umin] = ACTIONS(2038),
    [anon_sym_fadd] = ACTIONS(2038),
    [anon_sym_fsub] = ACTIONS(2038),
    [anon_sym_bitcast] = ACTIONS(2038),
    [anon_sym_trunc] = ACTIONS(2038),
    [anon_sym_zext] = ACTIONS(2038),
    [anon_sym_sext] = ACTIONS(2038),
    [anon_sym_fptrunc] = ACTIONS(2038),
    [anon_sym_fpext] = ACTIONS(2038),
    [anon_sym_addrspacecast] = ACTIONS(2038),
    [anon_sym_uitofp] = ACTIONS(2038),
    [anon_sym_sitofp] = ACTIONS(2038),
    [anon_sym_fptoui] = ACTIONS(2038),
    [anon_sym_fptosi] = ACTIONS(2038),
    [anon_sym_inttoptr] = ACTIONS(2038),
    [anon_sym_ptrtoint] = ACTIONS(2038),
    [anon_sym_uselistorder] = ACTIONS(2038),
  },
  [621] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2040),
    [sym_label] = ACTIONS(2040),
    [anon_sym_RBRACE] = ACTIONS(2040),
    [anon_sym_COMMA] = ACTIONS(2040),
    [anon_sym_unreachable] = ACTIONS(2042),
    [anon_sym_ret] = ACTIONS(2042),
    [anon_sym_br] = ACTIONS(2042),
    [anon_sym_resume] = ACTIONS(2042),
    [anon_sym_freeze] = ACTIONS(2042),
    [anon_sym_indirectbr] = ACTIONS(2042),
    [anon_sym_extractelement] = ACTIONS(2042),
    [anon_sym_insertelement] = ACTIONS(2042),
    [anon_sym_select] = ACTIONS(2042),
    [anon_sym_shufflevector] = ACTIONS(2042),
    [anon_sym_fneg] = ACTIONS(2042),
    [anon_sym_switch] = ACTIONS(2042),
    [anon_sym_invoke] = ACTIONS(2042),
    [anon_sym_cleanupret] = ACTIONS(2042),
    [anon_sym_catchret] = ACTIONS(2042),
    [anon_sym_catchswitch] = ACTIONS(2042),
    [anon_sym_catchpad] = ACTIONS(2042),
    [anon_sym_cleanuppad] = ACTIONS(2042),
    [anon_sym_callbr] = ACTIONS(2042),
    [anon_sym_icmp] = ACTIONS(2042),
    [anon_sym_fcmp] = ACTIONS(2042),
    [anon_sym_va_arg] = ACTIONS(2042),
    [anon_sym_phi] = ACTIONS(2042),
    [anon_sym_landingpad] = ACTIONS(2042),
    [anon_sym_tail] = ACTIONS(2042),
    [anon_sym_musttail] = ACTIONS(2042),
    [anon_sym_notail] = ACTIONS(2042),
    [anon_sym_call] = ACTIONS(2042),
    [anon_sym_alloca] = ACTIONS(2042),
    [anon_sym_load] = ACTIONS(2042),
    [anon_sym_store] = ACTIONS(2042),
    [anon_sym_cmpxchg] = ACTIONS(2042),
    [anon_sym_atomicrmw] = ACTIONS(2042),
    [anon_sym_fence] = ACTIONS(2042),
    [anon_sym_getelementptr] = ACTIONS(2042),
    [anon_sym_extractvalue] = ACTIONS(2042),
    [anon_sym_insertvalue] = ACTIONS(2042),
    [anon_sym_mul] = ACTIONS(2042),
    [anon_sym_urem] = ACTIONS(2042),
    [anon_sym_srem] = ACTIONS(2042),
    [anon_sym_shl] = ACTIONS(2042),
    [anon_sym_udiv] = ACTIONS(2042),
    [anon_sym_sdiv] = ACTIONS(2042),
    [anon_sym_lshr] = ACTIONS(2042),
    [anon_sym_ashr] = ACTIONS(2042),
    [anon_sym_fmul] = ACTIONS(2042),
    [anon_sym_fdiv] = ACTIONS(2042),
    [anon_sym_frem] = ACTIONS(2042),
    [anon_sym_xchg] = ACTIONS(2042),
    [anon_sym_add] = ACTIONS(2042),
    [anon_sym_sub] = ACTIONS(2042),
    [anon_sym_and] = ACTIONS(2042),
    [anon_sym_nand] = ACTIONS(2042),
    [anon_sym_or] = ACTIONS(2042),
    [anon_sym_xor] = ACTIONS(2042),
    [anon_sym_max] = ACTIONS(2042),
    [anon_sym_min] = ACTIONS(2042),
    [anon_sym_umax] = ACTIONS(2042),
    [anon_sym_umin] = ACTIONS(2042),
    [anon_sym_fadd] = ACTIONS(2042),
    [anon_sym_fsub] = ACTIONS(2042),
    [anon_sym_bitcast] = ACTIONS(2042),
    [anon_sym_trunc] = ACTIONS(2042),
    [anon_sym_zext] = ACTIONS(2042),
    [anon_sym_sext] = ACTIONS(2042),
    [anon_sym_fptrunc] = ACTIONS(2042),
    [anon_sym_fpext] = ACTIONS(2042),
    [anon_sym_addrspacecast] = ACTIONS(2042),
    [anon_sym_uitofp] = ACTIONS(2042),
    [anon_sym_sitofp] = ACTIONS(2042),
    [anon_sym_fptoui] = ACTIONS(2042),
    [anon_sym_fptosi] = ACTIONS(2042),
    [anon_sym_inttoptr] = ACTIONS(2042),
    [anon_sym_ptrtoint] = ACTIONS(2042),
    [anon_sym_uselistorder] = ACTIONS(2042),
  },
  [622] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2044),
    [sym_label] = ACTIONS(2044),
    [anon_sym_RBRACE] = ACTIONS(2044),
    [anon_sym_COMMA] = ACTIONS(2044),
    [anon_sym_unreachable] = ACTIONS(2046),
    [anon_sym_ret] = ACTIONS(2046),
    [anon_sym_br] = ACTIONS(2046),
    [anon_sym_resume] = ACTIONS(2046),
    [anon_sym_freeze] = ACTIONS(2046),
    [anon_sym_indirectbr] = ACTIONS(2046),
    [anon_sym_extractelement] = ACTIONS(2046),
    [anon_sym_insertelement] = ACTIONS(2046),
    [anon_sym_select] = ACTIONS(2046),
    [anon_sym_shufflevector] = ACTIONS(2046),
    [anon_sym_fneg] = ACTIONS(2046),
    [anon_sym_switch] = ACTIONS(2046),
    [anon_sym_invoke] = ACTIONS(2046),
    [anon_sym_cleanupret] = ACTIONS(2046),
    [anon_sym_catchret] = ACTIONS(2046),
    [anon_sym_catchswitch] = ACTIONS(2046),
    [anon_sym_catchpad] = ACTIONS(2046),
    [anon_sym_cleanuppad] = ACTIONS(2046),
    [anon_sym_callbr] = ACTIONS(2046),
    [anon_sym_icmp] = ACTIONS(2046),
    [anon_sym_fcmp] = ACTIONS(2046),
    [anon_sym_va_arg] = ACTIONS(2046),
    [anon_sym_phi] = ACTIONS(2046),
    [anon_sym_landingpad] = ACTIONS(2046),
    [anon_sym_tail] = ACTIONS(2046),
    [anon_sym_musttail] = ACTIONS(2046),
    [anon_sym_notail] = ACTIONS(2046),
    [anon_sym_call] = ACTIONS(2046),
    [anon_sym_alloca] = ACTIONS(2046),
    [anon_sym_load] = ACTIONS(2046),
    [anon_sym_store] = ACTIONS(2046),
    [anon_sym_cmpxchg] = ACTIONS(2046),
    [anon_sym_atomicrmw] = ACTIONS(2046),
    [anon_sym_fence] = ACTIONS(2046),
    [anon_sym_getelementptr] = ACTIONS(2046),
    [anon_sym_extractvalue] = ACTIONS(2046),
    [anon_sym_insertvalue] = ACTIONS(2046),
    [anon_sym_mul] = ACTIONS(2046),
    [anon_sym_urem] = ACTIONS(2046),
    [anon_sym_srem] = ACTIONS(2046),
    [anon_sym_shl] = ACTIONS(2046),
    [anon_sym_udiv] = ACTIONS(2046),
    [anon_sym_sdiv] = ACTIONS(2046),
    [anon_sym_lshr] = ACTIONS(2046),
    [anon_sym_ashr] = ACTIONS(2046),
    [anon_sym_fmul] = ACTIONS(2046),
    [anon_sym_fdiv] = ACTIONS(2046),
    [anon_sym_frem] = ACTIONS(2046),
    [anon_sym_xchg] = ACTIONS(2046),
    [anon_sym_add] = ACTIONS(2046),
    [anon_sym_sub] = ACTIONS(2046),
    [anon_sym_and] = ACTIONS(2046),
    [anon_sym_nand] = ACTIONS(2046),
    [anon_sym_or] = ACTIONS(2046),
    [anon_sym_xor] = ACTIONS(2046),
    [anon_sym_max] = ACTIONS(2046),
    [anon_sym_min] = ACTIONS(2046),
    [anon_sym_umax] = ACTIONS(2046),
    [anon_sym_umin] = ACTIONS(2046),
    [anon_sym_fadd] = ACTIONS(2046),
    [anon_sym_fsub] = ACTIONS(2046),
    [anon_sym_bitcast] = ACTIONS(2046),
    [anon_sym_trunc] = ACTIONS(2046),
    [anon_sym_zext] = ACTIONS(2046),
    [anon_sym_sext] = ACTIONS(2046),
    [anon_sym_fptrunc] = ACTIONS(2046),
    [anon_sym_fpext] = ACTIONS(2046),
    [anon_sym_addrspacecast] = ACTIONS(2046),
    [anon_sym_uitofp] = ACTIONS(2046),
    [anon_sym_sitofp] = ACTIONS(2046),
    [anon_sym_fptoui] = ACTIONS(2046),
    [anon_sym_fptosi] = ACTIONS(2046),
    [anon_sym_inttoptr] = ACTIONS(2046),
    [anon_sym_ptrtoint] = ACTIONS(2046),
    [anon_sym_uselistorder] = ACTIONS(2046),
  },
  [623] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1781),
    [sym_label] = ACTIONS(1781),
    [anon_sym_RBRACE] = ACTIONS(1781),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_unreachable] = ACTIONS(1786),
    [anon_sym_ret] = ACTIONS(1786),
    [anon_sym_br] = ACTIONS(1786),
    [anon_sym_resume] = ACTIONS(1786),
    [anon_sym_freeze] = ACTIONS(1786),
    [anon_sym_indirectbr] = ACTIONS(1786),
    [anon_sym_extractelement] = ACTIONS(1786),
    [anon_sym_insertelement] = ACTIONS(1786),
    [anon_sym_select] = ACTIONS(1786),
    [anon_sym_shufflevector] = ACTIONS(1786),
    [anon_sym_fneg] = ACTIONS(1786),
    [anon_sym_switch] = ACTIONS(1786),
    [anon_sym_invoke] = ACTIONS(1786),
    [anon_sym_cleanupret] = ACTIONS(1786),
    [anon_sym_catchret] = ACTIONS(1786),
    [anon_sym_catchswitch] = ACTIONS(1786),
    [anon_sym_catchpad] = ACTIONS(1786),
    [anon_sym_cleanuppad] = ACTIONS(1786),
    [anon_sym_callbr] = ACTIONS(1786),
    [anon_sym_icmp] = ACTIONS(1786),
    [anon_sym_fcmp] = ACTIONS(1786),
    [anon_sym_va_arg] = ACTIONS(1786),
    [anon_sym_phi] = ACTIONS(1786),
    [anon_sym_landingpad] = ACTIONS(1786),
    [anon_sym_tail] = ACTIONS(1786),
    [anon_sym_musttail] = ACTIONS(1786),
    [anon_sym_notail] = ACTIONS(1786),
    [anon_sym_call] = ACTIONS(1786),
    [anon_sym_alloca] = ACTIONS(1786),
    [anon_sym_load] = ACTIONS(1786),
    [anon_sym_store] = ACTIONS(1786),
    [anon_sym_cmpxchg] = ACTIONS(1786),
    [anon_sym_atomicrmw] = ACTIONS(1786),
    [anon_sym_fence] = ACTIONS(1786),
    [anon_sym_getelementptr] = ACTIONS(1786),
    [anon_sym_extractvalue] = ACTIONS(1786),
    [anon_sym_insertvalue] = ACTIONS(1786),
    [anon_sym_mul] = ACTIONS(1786),
    [anon_sym_urem] = ACTIONS(1786),
    [anon_sym_srem] = ACTIONS(1786),
    [anon_sym_shl] = ACTIONS(1786),
    [anon_sym_udiv] = ACTIONS(1786),
    [anon_sym_sdiv] = ACTIONS(1786),
    [anon_sym_lshr] = ACTIONS(1786),
    [anon_sym_ashr] = ACTIONS(1786),
    [anon_sym_fmul] = ACTIONS(1786),
    [anon_sym_fdiv] = ACTIONS(1786),
    [anon_sym_frem] = ACTIONS(1786),
    [anon_sym_xchg] = ACTIONS(1786),
    [anon_sym_add] = ACTIONS(1786),
    [anon_sym_sub] = ACTIONS(1786),
    [anon_sym_and] = ACTIONS(1786),
    [anon_sym_nand] = ACTIONS(1786),
    [anon_sym_or] = ACTIONS(1786),
    [anon_sym_xor] = ACTIONS(1786),
    [anon_sym_max] = ACTIONS(1786),
    [anon_sym_min] = ACTIONS(1786),
    [anon_sym_umax] = ACTIONS(1786),
    [anon_sym_umin] = ACTIONS(1786),
    [anon_sym_fadd] = ACTIONS(1786),
    [anon_sym_fsub] = ACTIONS(1786),
    [anon_sym_bitcast] = ACTIONS(1786),
    [anon_sym_trunc] = ACTIONS(1786),
    [anon_sym_zext] = ACTIONS(1786),
    [anon_sym_sext] = ACTIONS(1786),
    [anon_sym_fptrunc] = ACTIONS(1786),
    [anon_sym_fpext] = ACTIONS(1786),
    [anon_sym_addrspacecast] = ACTIONS(1786),
    [anon_sym_uitofp] = ACTIONS(1786),
    [anon_sym_sitofp] = ACTIONS(1786),
    [anon_sym_fptoui] = ACTIONS(1786),
    [anon_sym_fptosi] = ACTIONS(1786),
    [anon_sym_inttoptr] = ACTIONS(1786),
    [anon_sym_ptrtoint] = ACTIONS(1786),
    [anon_sym_uselistorder] = ACTIONS(1786),
  },
  [624] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2048),
    [sym_label] = ACTIONS(2048),
    [anon_sym_RBRACE] = ACTIONS(2048),
    [anon_sym_COMMA] = ACTIONS(2048),
    [anon_sym_unreachable] = ACTIONS(2050),
    [anon_sym_ret] = ACTIONS(2050),
    [anon_sym_br] = ACTIONS(2050),
    [anon_sym_resume] = ACTIONS(2050),
    [anon_sym_freeze] = ACTIONS(2050),
    [anon_sym_indirectbr] = ACTIONS(2050),
    [anon_sym_extractelement] = ACTIONS(2050),
    [anon_sym_insertelement] = ACTIONS(2050),
    [anon_sym_select] = ACTIONS(2050),
    [anon_sym_shufflevector] = ACTIONS(2050),
    [anon_sym_fneg] = ACTIONS(2050),
    [anon_sym_switch] = ACTIONS(2050),
    [anon_sym_invoke] = ACTIONS(2050),
    [anon_sym_cleanupret] = ACTIONS(2050),
    [anon_sym_catchret] = ACTIONS(2050),
    [anon_sym_catchswitch] = ACTIONS(2050),
    [anon_sym_catchpad] = ACTIONS(2050),
    [anon_sym_cleanuppad] = ACTIONS(2050),
    [anon_sym_callbr] = ACTIONS(2050),
    [anon_sym_icmp] = ACTIONS(2050),
    [anon_sym_fcmp] = ACTIONS(2050),
    [anon_sym_va_arg] = ACTIONS(2050),
    [anon_sym_phi] = ACTIONS(2050),
    [anon_sym_landingpad] = ACTIONS(2050),
    [anon_sym_tail] = ACTIONS(2050),
    [anon_sym_musttail] = ACTIONS(2050),
    [anon_sym_notail] = ACTIONS(2050),
    [anon_sym_call] = ACTIONS(2050),
    [anon_sym_alloca] = ACTIONS(2050),
    [anon_sym_load] = ACTIONS(2050),
    [anon_sym_store] = ACTIONS(2050),
    [anon_sym_cmpxchg] = ACTIONS(2050),
    [anon_sym_atomicrmw] = ACTIONS(2050),
    [anon_sym_fence] = ACTIONS(2050),
    [anon_sym_getelementptr] = ACTIONS(2050),
    [anon_sym_extractvalue] = ACTIONS(2050),
    [anon_sym_insertvalue] = ACTIONS(2050),
    [anon_sym_mul] = ACTIONS(2050),
    [anon_sym_urem] = ACTIONS(2050),
    [anon_sym_srem] = ACTIONS(2050),
    [anon_sym_shl] = ACTIONS(2050),
    [anon_sym_udiv] = ACTIONS(2050),
    [anon_sym_sdiv] = ACTIONS(2050),
    [anon_sym_lshr] = ACTIONS(2050),
    [anon_sym_ashr] = ACTIONS(2050),
    [anon_sym_fmul] = ACTIONS(2050),
    [anon_sym_fdiv] = ACTIONS(2050),
    [anon_sym_frem] = ACTIONS(2050),
    [anon_sym_xchg] = ACTIONS(2050),
    [anon_sym_add] = ACTIONS(2050),
    [anon_sym_sub] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_nand] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_xor] = ACTIONS(2050),
    [anon_sym_max] = ACTIONS(2050),
    [anon_sym_min] = ACTIONS(2050),
    [anon_sym_umax] = ACTIONS(2050),
    [anon_sym_umin] = ACTIONS(2050),
    [anon_sym_fadd] = ACTIONS(2050),
    [anon_sym_fsub] = ACTIONS(2050),
    [anon_sym_bitcast] = ACTIONS(2050),
    [anon_sym_trunc] = ACTIONS(2050),
    [anon_sym_zext] = ACTIONS(2050),
    [anon_sym_sext] = ACTIONS(2050),
    [anon_sym_fptrunc] = ACTIONS(2050),
    [anon_sym_fpext] = ACTIONS(2050),
    [anon_sym_addrspacecast] = ACTIONS(2050),
    [anon_sym_uitofp] = ACTIONS(2050),
    [anon_sym_sitofp] = ACTIONS(2050),
    [anon_sym_fptoui] = ACTIONS(2050),
    [anon_sym_fptosi] = ACTIONS(2050),
    [anon_sym_inttoptr] = ACTIONS(2050),
    [anon_sym_ptrtoint] = ACTIONS(2050),
    [anon_sym_uselistorder] = ACTIONS(2050),
  },
  [625] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2052),
    [sym_label] = ACTIONS(2052),
    [anon_sym_RBRACE] = ACTIONS(2052),
    [anon_sym_COMMA] = ACTIONS(2052),
    [anon_sym_unreachable] = ACTIONS(2054),
    [anon_sym_ret] = ACTIONS(2054),
    [anon_sym_br] = ACTIONS(2054),
    [anon_sym_resume] = ACTIONS(2054),
    [anon_sym_freeze] = ACTIONS(2054),
    [anon_sym_indirectbr] = ACTIONS(2054),
    [anon_sym_extractelement] = ACTIONS(2054),
    [anon_sym_insertelement] = ACTIONS(2054),
    [anon_sym_select] = ACTIONS(2054),
    [anon_sym_shufflevector] = ACTIONS(2054),
    [anon_sym_fneg] = ACTIONS(2054),
    [anon_sym_switch] = ACTIONS(2054),
    [anon_sym_invoke] = ACTIONS(2054),
    [anon_sym_cleanupret] = ACTIONS(2054),
    [anon_sym_catchret] = ACTIONS(2054),
    [anon_sym_catchswitch] = ACTIONS(2054),
    [anon_sym_catchpad] = ACTIONS(2054),
    [anon_sym_cleanuppad] = ACTIONS(2054),
    [anon_sym_callbr] = ACTIONS(2054),
    [anon_sym_icmp] = ACTIONS(2054),
    [anon_sym_fcmp] = ACTIONS(2054),
    [anon_sym_va_arg] = ACTIONS(2054),
    [anon_sym_phi] = ACTIONS(2054),
    [anon_sym_landingpad] = ACTIONS(2054),
    [anon_sym_tail] = ACTIONS(2054),
    [anon_sym_musttail] = ACTIONS(2054),
    [anon_sym_notail] = ACTIONS(2054),
    [anon_sym_call] = ACTIONS(2054),
    [anon_sym_alloca] = ACTIONS(2054),
    [anon_sym_load] = ACTIONS(2054),
    [anon_sym_store] = ACTIONS(2054),
    [anon_sym_cmpxchg] = ACTIONS(2054),
    [anon_sym_atomicrmw] = ACTIONS(2054),
    [anon_sym_fence] = ACTIONS(2054),
    [anon_sym_getelementptr] = ACTIONS(2054),
    [anon_sym_extractvalue] = ACTIONS(2054),
    [anon_sym_insertvalue] = ACTIONS(2054),
    [anon_sym_mul] = ACTIONS(2054),
    [anon_sym_urem] = ACTIONS(2054),
    [anon_sym_srem] = ACTIONS(2054),
    [anon_sym_shl] = ACTIONS(2054),
    [anon_sym_udiv] = ACTIONS(2054),
    [anon_sym_sdiv] = ACTIONS(2054),
    [anon_sym_lshr] = ACTIONS(2054),
    [anon_sym_ashr] = ACTIONS(2054),
    [anon_sym_fmul] = ACTIONS(2054),
    [anon_sym_fdiv] = ACTIONS(2054),
    [anon_sym_frem] = ACTIONS(2054),
    [anon_sym_xchg] = ACTIONS(2054),
    [anon_sym_add] = ACTIONS(2054),
    [anon_sym_sub] = ACTIONS(2054),
    [anon_sym_and] = ACTIONS(2054),
    [anon_sym_nand] = ACTIONS(2054),
    [anon_sym_or] = ACTIONS(2054),
    [anon_sym_xor] = ACTIONS(2054),
    [anon_sym_max] = ACTIONS(2054),
    [anon_sym_min] = ACTIONS(2054),
    [anon_sym_umax] = ACTIONS(2054),
    [anon_sym_umin] = ACTIONS(2054),
    [anon_sym_fadd] = ACTIONS(2054),
    [anon_sym_fsub] = ACTIONS(2054),
    [anon_sym_bitcast] = ACTIONS(2054),
    [anon_sym_trunc] = ACTIONS(2054),
    [anon_sym_zext] = ACTIONS(2054),
    [anon_sym_sext] = ACTIONS(2054),
    [anon_sym_fptrunc] = ACTIONS(2054),
    [anon_sym_fpext] = ACTIONS(2054),
    [anon_sym_addrspacecast] = ACTIONS(2054),
    [anon_sym_uitofp] = ACTIONS(2054),
    [anon_sym_sitofp] = ACTIONS(2054),
    [anon_sym_fptoui] = ACTIONS(2054),
    [anon_sym_fptosi] = ACTIONS(2054),
    [anon_sym_inttoptr] = ACTIONS(2054),
    [anon_sym_ptrtoint] = ACTIONS(2054),
    [anon_sym_uselistorder] = ACTIONS(2054),
  },
  [626] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2056),
    [sym_label] = ACTIONS(2056),
    [anon_sym_RBRACE] = ACTIONS(2056),
    [anon_sym_COMMA] = ACTIONS(2056),
    [anon_sym_unreachable] = ACTIONS(2058),
    [anon_sym_ret] = ACTIONS(2058),
    [anon_sym_br] = ACTIONS(2058),
    [anon_sym_resume] = ACTIONS(2058),
    [anon_sym_freeze] = ACTIONS(2058),
    [anon_sym_indirectbr] = ACTIONS(2058),
    [anon_sym_extractelement] = ACTIONS(2058),
    [anon_sym_insertelement] = ACTIONS(2058),
    [anon_sym_select] = ACTIONS(2058),
    [anon_sym_shufflevector] = ACTIONS(2058),
    [anon_sym_fneg] = ACTIONS(2058),
    [anon_sym_switch] = ACTIONS(2058),
    [anon_sym_invoke] = ACTIONS(2058),
    [anon_sym_cleanupret] = ACTIONS(2058),
    [anon_sym_catchret] = ACTIONS(2058),
    [anon_sym_catchswitch] = ACTIONS(2058),
    [anon_sym_catchpad] = ACTIONS(2058),
    [anon_sym_cleanuppad] = ACTIONS(2058),
    [anon_sym_callbr] = ACTIONS(2058),
    [anon_sym_icmp] = ACTIONS(2058),
    [anon_sym_fcmp] = ACTIONS(2058),
    [anon_sym_va_arg] = ACTIONS(2058),
    [anon_sym_phi] = ACTIONS(2058),
    [anon_sym_landingpad] = ACTIONS(2058),
    [anon_sym_tail] = ACTIONS(2058),
    [anon_sym_musttail] = ACTIONS(2058),
    [anon_sym_notail] = ACTIONS(2058),
    [anon_sym_call] = ACTIONS(2058),
    [anon_sym_alloca] = ACTIONS(2058),
    [anon_sym_load] = ACTIONS(2058),
    [anon_sym_store] = ACTIONS(2058),
    [anon_sym_cmpxchg] = ACTIONS(2058),
    [anon_sym_atomicrmw] = ACTIONS(2058),
    [anon_sym_fence] = ACTIONS(2058),
    [anon_sym_getelementptr] = ACTIONS(2058),
    [anon_sym_extractvalue] = ACTIONS(2058),
    [anon_sym_insertvalue] = ACTIONS(2058),
    [anon_sym_mul] = ACTIONS(2058),
    [anon_sym_urem] = ACTIONS(2058),
    [anon_sym_srem] = ACTIONS(2058),
    [anon_sym_shl] = ACTIONS(2058),
    [anon_sym_udiv] = ACTIONS(2058),
    [anon_sym_sdiv] = ACTIONS(2058),
    [anon_sym_lshr] = ACTIONS(2058),
    [anon_sym_ashr] = ACTIONS(2058),
    [anon_sym_fmul] = ACTIONS(2058),
    [anon_sym_fdiv] = ACTIONS(2058),
    [anon_sym_frem] = ACTIONS(2058),
    [anon_sym_xchg] = ACTIONS(2058),
    [anon_sym_add] = ACTIONS(2058),
    [anon_sym_sub] = ACTIONS(2058),
    [anon_sym_and] = ACTIONS(2058),
    [anon_sym_nand] = ACTIONS(2058),
    [anon_sym_or] = ACTIONS(2058),
    [anon_sym_xor] = ACTIONS(2058),
    [anon_sym_max] = ACTIONS(2058),
    [anon_sym_min] = ACTIONS(2058),
    [anon_sym_umax] = ACTIONS(2058),
    [anon_sym_umin] = ACTIONS(2058),
    [anon_sym_fadd] = ACTIONS(2058),
    [anon_sym_fsub] = ACTIONS(2058),
    [anon_sym_bitcast] = ACTIONS(2058),
    [anon_sym_trunc] = ACTIONS(2058),
    [anon_sym_zext] = ACTIONS(2058),
    [anon_sym_sext] = ACTIONS(2058),
    [anon_sym_fptrunc] = ACTIONS(2058),
    [anon_sym_fpext] = ACTIONS(2058),
    [anon_sym_addrspacecast] = ACTIONS(2058),
    [anon_sym_uitofp] = ACTIONS(2058),
    [anon_sym_sitofp] = ACTIONS(2058),
    [anon_sym_fptoui] = ACTIONS(2058),
    [anon_sym_fptosi] = ACTIONS(2058),
    [anon_sym_inttoptr] = ACTIONS(2058),
    [anon_sym_ptrtoint] = ACTIONS(2058),
    [anon_sym_uselistorder] = ACTIONS(2058),
  },
  [627] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2060),
    [sym_label] = ACTIONS(2060),
    [anon_sym_RBRACE] = ACTIONS(2060),
    [anon_sym_COMMA] = ACTIONS(2060),
    [anon_sym_unreachable] = ACTIONS(2062),
    [anon_sym_ret] = ACTIONS(2062),
    [anon_sym_br] = ACTIONS(2062),
    [anon_sym_resume] = ACTIONS(2062),
    [anon_sym_freeze] = ACTIONS(2062),
    [anon_sym_indirectbr] = ACTIONS(2062),
    [anon_sym_extractelement] = ACTIONS(2062),
    [anon_sym_insertelement] = ACTIONS(2062),
    [anon_sym_select] = ACTIONS(2062),
    [anon_sym_shufflevector] = ACTIONS(2062),
    [anon_sym_fneg] = ACTIONS(2062),
    [anon_sym_switch] = ACTIONS(2062),
    [anon_sym_invoke] = ACTIONS(2062),
    [anon_sym_cleanupret] = ACTIONS(2062),
    [anon_sym_catchret] = ACTIONS(2062),
    [anon_sym_catchswitch] = ACTIONS(2062),
    [anon_sym_catchpad] = ACTIONS(2062),
    [anon_sym_cleanuppad] = ACTIONS(2062),
    [anon_sym_callbr] = ACTIONS(2062),
    [anon_sym_icmp] = ACTIONS(2062),
    [anon_sym_fcmp] = ACTIONS(2062),
    [anon_sym_va_arg] = ACTIONS(2062),
    [anon_sym_phi] = ACTIONS(2062),
    [anon_sym_landingpad] = ACTIONS(2062),
    [anon_sym_tail] = ACTIONS(2062),
    [anon_sym_musttail] = ACTIONS(2062),
    [anon_sym_notail] = ACTIONS(2062),
    [anon_sym_call] = ACTIONS(2062),
    [anon_sym_alloca] = ACTIONS(2062),
    [anon_sym_load] = ACTIONS(2062),
    [anon_sym_store] = ACTIONS(2062),
    [anon_sym_cmpxchg] = ACTIONS(2062),
    [anon_sym_atomicrmw] = ACTIONS(2062),
    [anon_sym_fence] = ACTIONS(2062),
    [anon_sym_getelementptr] = ACTIONS(2062),
    [anon_sym_extractvalue] = ACTIONS(2062),
    [anon_sym_insertvalue] = ACTIONS(2062),
    [anon_sym_mul] = ACTIONS(2062),
    [anon_sym_urem] = ACTIONS(2062),
    [anon_sym_srem] = ACTIONS(2062),
    [anon_sym_shl] = ACTIONS(2062),
    [anon_sym_udiv] = ACTIONS(2062),
    [anon_sym_sdiv] = ACTIONS(2062),
    [anon_sym_lshr] = ACTIONS(2062),
    [anon_sym_ashr] = ACTIONS(2062),
    [anon_sym_fmul] = ACTIONS(2062),
    [anon_sym_fdiv] = ACTIONS(2062),
    [anon_sym_frem] = ACTIONS(2062),
    [anon_sym_xchg] = ACTIONS(2062),
    [anon_sym_add] = ACTIONS(2062),
    [anon_sym_sub] = ACTIONS(2062),
    [anon_sym_and] = ACTIONS(2062),
    [anon_sym_nand] = ACTIONS(2062),
    [anon_sym_or] = ACTIONS(2062),
    [anon_sym_xor] = ACTIONS(2062),
    [anon_sym_max] = ACTIONS(2062),
    [anon_sym_min] = ACTIONS(2062),
    [anon_sym_umax] = ACTIONS(2062),
    [anon_sym_umin] = ACTIONS(2062),
    [anon_sym_fadd] = ACTIONS(2062),
    [anon_sym_fsub] = ACTIONS(2062),
    [anon_sym_bitcast] = ACTIONS(2062),
    [anon_sym_trunc] = ACTIONS(2062),
    [anon_sym_zext] = ACTIONS(2062),
    [anon_sym_sext] = ACTIONS(2062),
    [anon_sym_fptrunc] = ACTIONS(2062),
    [anon_sym_fpext] = ACTIONS(2062),
    [anon_sym_addrspacecast] = ACTIONS(2062),
    [anon_sym_uitofp] = ACTIONS(2062),
    [anon_sym_sitofp] = ACTIONS(2062),
    [anon_sym_fptoui] = ACTIONS(2062),
    [anon_sym_fptosi] = ACTIONS(2062),
    [anon_sym_inttoptr] = ACTIONS(2062),
    [anon_sym_ptrtoint] = ACTIONS(2062),
    [anon_sym_uselistorder] = ACTIONS(2062),
  },
  [628] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2064),
    [sym_label] = ACTIONS(2064),
    [anon_sym_RBRACE] = ACTIONS(2064),
    [anon_sym_COMMA] = ACTIONS(2064),
    [anon_sym_unreachable] = ACTIONS(2066),
    [anon_sym_ret] = ACTIONS(2066),
    [anon_sym_br] = ACTIONS(2066),
    [anon_sym_resume] = ACTIONS(2066),
    [anon_sym_freeze] = ACTIONS(2066),
    [anon_sym_indirectbr] = ACTIONS(2066),
    [anon_sym_extractelement] = ACTIONS(2066),
    [anon_sym_insertelement] = ACTIONS(2066),
    [anon_sym_select] = ACTIONS(2066),
    [anon_sym_shufflevector] = ACTIONS(2066),
    [anon_sym_fneg] = ACTIONS(2066),
    [anon_sym_switch] = ACTIONS(2066),
    [anon_sym_invoke] = ACTIONS(2066),
    [anon_sym_cleanupret] = ACTIONS(2066),
    [anon_sym_catchret] = ACTIONS(2066),
    [anon_sym_catchswitch] = ACTIONS(2066),
    [anon_sym_catchpad] = ACTIONS(2066),
    [anon_sym_cleanuppad] = ACTIONS(2066),
    [anon_sym_callbr] = ACTIONS(2066),
    [anon_sym_icmp] = ACTIONS(2066),
    [anon_sym_fcmp] = ACTIONS(2066),
    [anon_sym_va_arg] = ACTIONS(2066),
    [anon_sym_phi] = ACTIONS(2066),
    [anon_sym_landingpad] = ACTIONS(2066),
    [anon_sym_tail] = ACTIONS(2066),
    [anon_sym_musttail] = ACTIONS(2066),
    [anon_sym_notail] = ACTIONS(2066),
    [anon_sym_call] = ACTIONS(2066),
    [anon_sym_alloca] = ACTIONS(2066),
    [anon_sym_load] = ACTIONS(2066),
    [anon_sym_store] = ACTIONS(2066),
    [anon_sym_cmpxchg] = ACTIONS(2066),
    [anon_sym_atomicrmw] = ACTIONS(2066),
    [anon_sym_fence] = ACTIONS(2066),
    [anon_sym_getelementptr] = ACTIONS(2066),
    [anon_sym_extractvalue] = ACTIONS(2066),
    [anon_sym_insertvalue] = ACTIONS(2066),
    [anon_sym_mul] = ACTIONS(2066),
    [anon_sym_urem] = ACTIONS(2066),
    [anon_sym_srem] = ACTIONS(2066),
    [anon_sym_shl] = ACTIONS(2066),
    [anon_sym_udiv] = ACTIONS(2066),
    [anon_sym_sdiv] = ACTIONS(2066),
    [anon_sym_lshr] = ACTIONS(2066),
    [anon_sym_ashr] = ACTIONS(2066),
    [anon_sym_fmul] = ACTIONS(2066),
    [anon_sym_fdiv] = ACTIONS(2066),
    [anon_sym_frem] = ACTIONS(2066),
    [anon_sym_xchg] = ACTIONS(2066),
    [anon_sym_add] = ACTIONS(2066),
    [anon_sym_sub] = ACTIONS(2066),
    [anon_sym_and] = ACTIONS(2066),
    [anon_sym_nand] = ACTIONS(2066),
    [anon_sym_or] = ACTIONS(2066),
    [anon_sym_xor] = ACTIONS(2066),
    [anon_sym_max] = ACTIONS(2066),
    [anon_sym_min] = ACTIONS(2066),
    [anon_sym_umax] = ACTIONS(2066),
    [anon_sym_umin] = ACTIONS(2066),
    [anon_sym_fadd] = ACTIONS(2066),
    [anon_sym_fsub] = ACTIONS(2066),
    [anon_sym_bitcast] = ACTIONS(2066),
    [anon_sym_trunc] = ACTIONS(2066),
    [anon_sym_zext] = ACTIONS(2066),
    [anon_sym_sext] = ACTIONS(2066),
    [anon_sym_fptrunc] = ACTIONS(2066),
    [anon_sym_fpext] = ACTIONS(2066),
    [anon_sym_addrspacecast] = ACTIONS(2066),
    [anon_sym_uitofp] = ACTIONS(2066),
    [anon_sym_sitofp] = ACTIONS(2066),
    [anon_sym_fptoui] = ACTIONS(2066),
    [anon_sym_fptosi] = ACTIONS(2066),
    [anon_sym_inttoptr] = ACTIONS(2066),
    [anon_sym_ptrtoint] = ACTIONS(2066),
    [anon_sym_uselistorder] = ACTIONS(2066),
  },
  [629] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2068),
    [sym_label] = ACTIONS(2068),
    [anon_sym_RBRACE] = ACTIONS(2068),
    [anon_sym_COMMA] = ACTIONS(2068),
    [anon_sym_unreachable] = ACTIONS(2070),
    [anon_sym_ret] = ACTIONS(2070),
    [anon_sym_br] = ACTIONS(2070),
    [anon_sym_resume] = ACTIONS(2070),
    [anon_sym_freeze] = ACTIONS(2070),
    [anon_sym_indirectbr] = ACTIONS(2070),
    [anon_sym_extractelement] = ACTIONS(2070),
    [anon_sym_insertelement] = ACTIONS(2070),
    [anon_sym_select] = ACTIONS(2070),
    [anon_sym_shufflevector] = ACTIONS(2070),
    [anon_sym_fneg] = ACTIONS(2070),
    [anon_sym_switch] = ACTIONS(2070),
    [anon_sym_invoke] = ACTIONS(2070),
    [anon_sym_cleanupret] = ACTIONS(2070),
    [anon_sym_catchret] = ACTIONS(2070),
    [anon_sym_catchswitch] = ACTIONS(2070),
    [anon_sym_catchpad] = ACTIONS(2070),
    [anon_sym_cleanuppad] = ACTIONS(2070),
    [anon_sym_callbr] = ACTIONS(2070),
    [anon_sym_icmp] = ACTIONS(2070),
    [anon_sym_fcmp] = ACTIONS(2070),
    [anon_sym_va_arg] = ACTIONS(2070),
    [anon_sym_phi] = ACTIONS(2070),
    [anon_sym_landingpad] = ACTIONS(2070),
    [anon_sym_tail] = ACTIONS(2070),
    [anon_sym_musttail] = ACTIONS(2070),
    [anon_sym_notail] = ACTIONS(2070),
    [anon_sym_call] = ACTIONS(2070),
    [anon_sym_alloca] = ACTIONS(2070),
    [anon_sym_load] = ACTIONS(2070),
    [anon_sym_store] = ACTIONS(2070),
    [anon_sym_cmpxchg] = ACTIONS(2070),
    [anon_sym_atomicrmw] = ACTIONS(2070),
    [anon_sym_fence] = ACTIONS(2070),
    [anon_sym_getelementptr] = ACTIONS(2070),
    [anon_sym_extractvalue] = ACTIONS(2070),
    [anon_sym_insertvalue] = ACTIONS(2070),
    [anon_sym_mul] = ACTIONS(2070),
    [anon_sym_urem] = ACTIONS(2070),
    [anon_sym_srem] = ACTIONS(2070),
    [anon_sym_shl] = ACTIONS(2070),
    [anon_sym_udiv] = ACTIONS(2070),
    [anon_sym_sdiv] = ACTIONS(2070),
    [anon_sym_lshr] = ACTIONS(2070),
    [anon_sym_ashr] = ACTIONS(2070),
    [anon_sym_fmul] = ACTIONS(2070),
    [anon_sym_fdiv] = ACTIONS(2070),
    [anon_sym_frem] = ACTIONS(2070),
    [anon_sym_xchg] = ACTIONS(2070),
    [anon_sym_add] = ACTIONS(2070),
    [anon_sym_sub] = ACTIONS(2070),
    [anon_sym_and] = ACTIONS(2070),
    [anon_sym_nand] = ACTIONS(2070),
    [anon_sym_or] = ACTIONS(2070),
    [anon_sym_xor] = ACTIONS(2070),
    [anon_sym_max] = ACTIONS(2070),
    [anon_sym_min] = ACTIONS(2070),
    [anon_sym_umax] = ACTIONS(2070),
    [anon_sym_umin] = ACTIONS(2070),
    [anon_sym_fadd] = ACTIONS(2070),
    [anon_sym_fsub] = ACTIONS(2070),
    [anon_sym_bitcast] = ACTIONS(2070),
    [anon_sym_trunc] = ACTIONS(2070),
    [anon_sym_zext] = ACTIONS(2070),
    [anon_sym_sext] = ACTIONS(2070),
    [anon_sym_fptrunc] = ACTIONS(2070),
    [anon_sym_fpext] = ACTIONS(2070),
    [anon_sym_addrspacecast] = ACTIONS(2070),
    [anon_sym_uitofp] = ACTIONS(2070),
    [anon_sym_sitofp] = ACTIONS(2070),
    [anon_sym_fptoui] = ACTIONS(2070),
    [anon_sym_fptosi] = ACTIONS(2070),
    [anon_sym_inttoptr] = ACTIONS(2070),
    [anon_sym_ptrtoint] = ACTIONS(2070),
    [anon_sym_uselistorder] = ACTIONS(2070),
  },
  [630] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2072),
    [sym_label] = ACTIONS(2072),
    [anon_sym_RBRACE] = ACTIONS(2072),
    [anon_sym_COMMA] = ACTIONS(2072),
    [anon_sym_unreachable] = ACTIONS(2074),
    [anon_sym_ret] = ACTIONS(2074),
    [anon_sym_br] = ACTIONS(2074),
    [anon_sym_resume] = ACTIONS(2074),
    [anon_sym_freeze] = ACTIONS(2074),
    [anon_sym_indirectbr] = ACTIONS(2074),
    [anon_sym_extractelement] = ACTIONS(2074),
    [anon_sym_insertelement] = ACTIONS(2074),
    [anon_sym_select] = ACTIONS(2074),
    [anon_sym_shufflevector] = ACTIONS(2074),
    [anon_sym_fneg] = ACTIONS(2074),
    [anon_sym_switch] = ACTIONS(2074),
    [anon_sym_invoke] = ACTIONS(2074),
    [anon_sym_cleanupret] = ACTIONS(2074),
    [anon_sym_catchret] = ACTIONS(2074),
    [anon_sym_catchswitch] = ACTIONS(2074),
    [anon_sym_catchpad] = ACTIONS(2074),
    [anon_sym_cleanuppad] = ACTIONS(2074),
    [anon_sym_callbr] = ACTIONS(2074),
    [anon_sym_icmp] = ACTIONS(2074),
    [anon_sym_fcmp] = ACTIONS(2074),
    [anon_sym_va_arg] = ACTIONS(2074),
    [anon_sym_phi] = ACTIONS(2074),
    [anon_sym_landingpad] = ACTIONS(2074),
    [anon_sym_tail] = ACTIONS(2074),
    [anon_sym_musttail] = ACTIONS(2074),
    [anon_sym_notail] = ACTIONS(2074),
    [anon_sym_call] = ACTIONS(2074),
    [anon_sym_alloca] = ACTIONS(2074),
    [anon_sym_load] = ACTIONS(2074),
    [anon_sym_store] = ACTIONS(2074),
    [anon_sym_cmpxchg] = ACTIONS(2074),
    [anon_sym_atomicrmw] = ACTIONS(2074),
    [anon_sym_fence] = ACTIONS(2074),
    [anon_sym_getelementptr] = ACTIONS(2074),
    [anon_sym_extractvalue] = ACTIONS(2074),
    [anon_sym_insertvalue] = ACTIONS(2074),
    [anon_sym_mul] = ACTIONS(2074),
    [anon_sym_urem] = ACTIONS(2074),
    [anon_sym_srem] = ACTIONS(2074),
    [anon_sym_shl] = ACTIONS(2074),
    [anon_sym_udiv] = ACTIONS(2074),
    [anon_sym_sdiv] = ACTIONS(2074),
    [anon_sym_lshr] = ACTIONS(2074),
    [anon_sym_ashr] = ACTIONS(2074),
    [anon_sym_fmul] = ACTIONS(2074),
    [anon_sym_fdiv] = ACTIONS(2074),
    [anon_sym_frem] = ACTIONS(2074),
    [anon_sym_xchg] = ACTIONS(2074),
    [anon_sym_add] = ACTIONS(2074),
    [anon_sym_sub] = ACTIONS(2074),
    [anon_sym_and] = ACTIONS(2074),
    [anon_sym_nand] = ACTIONS(2074),
    [anon_sym_or] = ACTIONS(2074),
    [anon_sym_xor] = ACTIONS(2074),
    [anon_sym_max] = ACTIONS(2074),
    [anon_sym_min] = ACTIONS(2074),
    [anon_sym_umax] = ACTIONS(2074),
    [anon_sym_umin] = ACTIONS(2074),
    [anon_sym_fadd] = ACTIONS(2074),
    [anon_sym_fsub] = ACTIONS(2074),
    [anon_sym_bitcast] = ACTIONS(2074),
    [anon_sym_trunc] = ACTIONS(2074),
    [anon_sym_zext] = ACTIONS(2074),
    [anon_sym_sext] = ACTIONS(2074),
    [anon_sym_fptrunc] = ACTIONS(2074),
    [anon_sym_fpext] = ACTIONS(2074),
    [anon_sym_addrspacecast] = ACTIONS(2074),
    [anon_sym_uitofp] = ACTIONS(2074),
    [anon_sym_sitofp] = ACTIONS(2074),
    [anon_sym_fptoui] = ACTIONS(2074),
    [anon_sym_fptosi] = ACTIONS(2074),
    [anon_sym_inttoptr] = ACTIONS(2074),
    [anon_sym_ptrtoint] = ACTIONS(2074),
    [anon_sym_uselistorder] = ACTIONS(2074),
  },
  [631] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2076),
    [sym_label] = ACTIONS(2076),
    [anon_sym_RBRACE] = ACTIONS(2076),
    [anon_sym_COMMA] = ACTIONS(2076),
    [anon_sym_unreachable] = ACTIONS(2078),
    [anon_sym_ret] = ACTIONS(2078),
    [anon_sym_br] = ACTIONS(2078),
    [anon_sym_resume] = ACTIONS(2078),
    [anon_sym_freeze] = ACTIONS(2078),
    [anon_sym_indirectbr] = ACTIONS(2078),
    [anon_sym_extractelement] = ACTIONS(2078),
    [anon_sym_insertelement] = ACTIONS(2078),
    [anon_sym_select] = ACTIONS(2078),
    [anon_sym_shufflevector] = ACTIONS(2078),
    [anon_sym_fneg] = ACTIONS(2078),
    [anon_sym_switch] = ACTIONS(2078),
    [anon_sym_invoke] = ACTIONS(2078),
    [anon_sym_cleanupret] = ACTIONS(2078),
    [anon_sym_catchret] = ACTIONS(2078),
    [anon_sym_catchswitch] = ACTIONS(2078),
    [anon_sym_catchpad] = ACTIONS(2078),
    [anon_sym_cleanuppad] = ACTIONS(2078),
    [anon_sym_callbr] = ACTIONS(2078),
    [anon_sym_icmp] = ACTIONS(2078),
    [anon_sym_fcmp] = ACTIONS(2078),
    [anon_sym_va_arg] = ACTIONS(2078),
    [anon_sym_phi] = ACTIONS(2078),
    [anon_sym_landingpad] = ACTIONS(2078),
    [anon_sym_tail] = ACTIONS(2078),
    [anon_sym_musttail] = ACTIONS(2078),
    [anon_sym_notail] = ACTIONS(2078),
    [anon_sym_call] = ACTIONS(2078),
    [anon_sym_alloca] = ACTIONS(2078),
    [anon_sym_load] = ACTIONS(2078),
    [anon_sym_store] = ACTIONS(2078),
    [anon_sym_cmpxchg] = ACTIONS(2078),
    [anon_sym_atomicrmw] = ACTIONS(2078),
    [anon_sym_fence] = ACTIONS(2078),
    [anon_sym_getelementptr] = ACTIONS(2078),
    [anon_sym_extractvalue] = ACTIONS(2078),
    [anon_sym_insertvalue] = ACTIONS(2078),
    [anon_sym_mul] = ACTIONS(2078),
    [anon_sym_urem] = ACTIONS(2078),
    [anon_sym_srem] = ACTIONS(2078),
    [anon_sym_shl] = ACTIONS(2078),
    [anon_sym_udiv] = ACTIONS(2078),
    [anon_sym_sdiv] = ACTIONS(2078),
    [anon_sym_lshr] = ACTIONS(2078),
    [anon_sym_ashr] = ACTIONS(2078),
    [anon_sym_fmul] = ACTIONS(2078),
    [anon_sym_fdiv] = ACTIONS(2078),
    [anon_sym_frem] = ACTIONS(2078),
    [anon_sym_xchg] = ACTIONS(2078),
    [anon_sym_add] = ACTIONS(2078),
    [anon_sym_sub] = ACTIONS(2078),
    [anon_sym_and] = ACTIONS(2078),
    [anon_sym_nand] = ACTIONS(2078),
    [anon_sym_or] = ACTIONS(2078),
    [anon_sym_xor] = ACTIONS(2078),
    [anon_sym_max] = ACTIONS(2078),
    [anon_sym_min] = ACTIONS(2078),
    [anon_sym_umax] = ACTIONS(2078),
    [anon_sym_umin] = ACTIONS(2078),
    [anon_sym_fadd] = ACTIONS(2078),
    [anon_sym_fsub] = ACTIONS(2078),
    [anon_sym_bitcast] = ACTIONS(2078),
    [anon_sym_trunc] = ACTIONS(2078),
    [anon_sym_zext] = ACTIONS(2078),
    [anon_sym_sext] = ACTIONS(2078),
    [anon_sym_fptrunc] = ACTIONS(2078),
    [anon_sym_fpext] = ACTIONS(2078),
    [anon_sym_addrspacecast] = ACTIONS(2078),
    [anon_sym_uitofp] = ACTIONS(2078),
    [anon_sym_sitofp] = ACTIONS(2078),
    [anon_sym_fptoui] = ACTIONS(2078),
    [anon_sym_fptosi] = ACTIONS(2078),
    [anon_sym_inttoptr] = ACTIONS(2078),
    [anon_sym_ptrtoint] = ACTIONS(2078),
    [anon_sym_uselistorder] = ACTIONS(2078),
  },
  [632] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2080),
    [sym_label] = ACTIONS(2080),
    [anon_sym_RBRACE] = ACTIONS(2080),
    [anon_sym_COMMA] = ACTIONS(2080),
    [anon_sym_unreachable] = ACTIONS(2082),
    [anon_sym_ret] = ACTIONS(2082),
    [anon_sym_br] = ACTIONS(2082),
    [anon_sym_resume] = ACTIONS(2082),
    [anon_sym_freeze] = ACTIONS(2082),
    [anon_sym_indirectbr] = ACTIONS(2082),
    [anon_sym_extractelement] = ACTIONS(2082),
    [anon_sym_insertelement] = ACTIONS(2082),
    [anon_sym_select] = ACTIONS(2082),
    [anon_sym_shufflevector] = ACTIONS(2082),
    [anon_sym_fneg] = ACTIONS(2082),
    [anon_sym_switch] = ACTIONS(2082),
    [anon_sym_invoke] = ACTIONS(2082),
    [anon_sym_cleanupret] = ACTIONS(2082),
    [anon_sym_catchret] = ACTIONS(2082),
    [anon_sym_catchswitch] = ACTIONS(2082),
    [anon_sym_catchpad] = ACTIONS(2082),
    [anon_sym_cleanuppad] = ACTIONS(2082),
    [anon_sym_callbr] = ACTIONS(2082),
    [anon_sym_icmp] = ACTIONS(2082),
    [anon_sym_fcmp] = ACTIONS(2082),
    [anon_sym_va_arg] = ACTIONS(2082),
    [anon_sym_phi] = ACTIONS(2082),
    [anon_sym_landingpad] = ACTIONS(2082),
    [anon_sym_tail] = ACTIONS(2082),
    [anon_sym_musttail] = ACTIONS(2082),
    [anon_sym_notail] = ACTIONS(2082),
    [anon_sym_call] = ACTIONS(2082),
    [anon_sym_alloca] = ACTIONS(2082),
    [anon_sym_load] = ACTIONS(2082),
    [anon_sym_store] = ACTIONS(2082),
    [anon_sym_cmpxchg] = ACTIONS(2082),
    [anon_sym_atomicrmw] = ACTIONS(2082),
    [anon_sym_fence] = ACTIONS(2082),
    [anon_sym_getelementptr] = ACTIONS(2082),
    [anon_sym_extractvalue] = ACTIONS(2082),
    [anon_sym_insertvalue] = ACTIONS(2082),
    [anon_sym_mul] = ACTIONS(2082),
    [anon_sym_urem] = ACTIONS(2082),
    [anon_sym_srem] = ACTIONS(2082),
    [anon_sym_shl] = ACTIONS(2082),
    [anon_sym_udiv] = ACTIONS(2082),
    [anon_sym_sdiv] = ACTIONS(2082),
    [anon_sym_lshr] = ACTIONS(2082),
    [anon_sym_ashr] = ACTIONS(2082),
    [anon_sym_fmul] = ACTIONS(2082),
    [anon_sym_fdiv] = ACTIONS(2082),
    [anon_sym_frem] = ACTIONS(2082),
    [anon_sym_xchg] = ACTIONS(2082),
    [anon_sym_add] = ACTIONS(2082),
    [anon_sym_sub] = ACTIONS(2082),
    [anon_sym_and] = ACTIONS(2082),
    [anon_sym_nand] = ACTIONS(2082),
    [anon_sym_or] = ACTIONS(2082),
    [anon_sym_xor] = ACTIONS(2082),
    [anon_sym_max] = ACTIONS(2082),
    [anon_sym_min] = ACTIONS(2082),
    [anon_sym_umax] = ACTIONS(2082),
    [anon_sym_umin] = ACTIONS(2082),
    [anon_sym_fadd] = ACTIONS(2082),
    [anon_sym_fsub] = ACTIONS(2082),
    [anon_sym_bitcast] = ACTIONS(2082),
    [anon_sym_trunc] = ACTIONS(2082),
    [anon_sym_zext] = ACTIONS(2082),
    [anon_sym_sext] = ACTIONS(2082),
    [anon_sym_fptrunc] = ACTIONS(2082),
    [anon_sym_fpext] = ACTIONS(2082),
    [anon_sym_addrspacecast] = ACTIONS(2082),
    [anon_sym_uitofp] = ACTIONS(2082),
    [anon_sym_sitofp] = ACTIONS(2082),
    [anon_sym_fptoui] = ACTIONS(2082),
    [anon_sym_fptosi] = ACTIONS(2082),
    [anon_sym_inttoptr] = ACTIONS(2082),
    [anon_sym_ptrtoint] = ACTIONS(2082),
    [anon_sym_uselistorder] = ACTIONS(2082),
  },
  [633] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2084),
    [sym_label] = ACTIONS(2084),
    [anon_sym_RBRACE] = ACTIONS(2084),
    [anon_sym_COMMA] = ACTIONS(2084),
    [anon_sym_unreachable] = ACTIONS(2086),
    [anon_sym_ret] = ACTIONS(2086),
    [anon_sym_br] = ACTIONS(2086),
    [anon_sym_resume] = ACTIONS(2086),
    [anon_sym_freeze] = ACTIONS(2086),
    [anon_sym_indirectbr] = ACTIONS(2086),
    [anon_sym_extractelement] = ACTIONS(2086),
    [anon_sym_insertelement] = ACTIONS(2086),
    [anon_sym_select] = ACTIONS(2086),
    [anon_sym_shufflevector] = ACTIONS(2086),
    [anon_sym_fneg] = ACTIONS(2086),
    [anon_sym_switch] = ACTIONS(2086),
    [anon_sym_invoke] = ACTIONS(2086),
    [anon_sym_cleanupret] = ACTIONS(2086),
    [anon_sym_catchret] = ACTIONS(2086),
    [anon_sym_catchswitch] = ACTIONS(2086),
    [anon_sym_catchpad] = ACTIONS(2086),
    [anon_sym_cleanuppad] = ACTIONS(2086),
    [anon_sym_callbr] = ACTIONS(2086),
    [anon_sym_icmp] = ACTIONS(2086),
    [anon_sym_fcmp] = ACTIONS(2086),
    [anon_sym_va_arg] = ACTIONS(2086),
    [anon_sym_phi] = ACTIONS(2086),
    [anon_sym_landingpad] = ACTIONS(2086),
    [anon_sym_tail] = ACTIONS(2086),
    [anon_sym_musttail] = ACTIONS(2086),
    [anon_sym_notail] = ACTIONS(2086),
    [anon_sym_call] = ACTIONS(2086),
    [anon_sym_alloca] = ACTIONS(2086),
    [anon_sym_load] = ACTIONS(2086),
    [anon_sym_store] = ACTIONS(2086),
    [anon_sym_cmpxchg] = ACTIONS(2086),
    [anon_sym_atomicrmw] = ACTIONS(2086),
    [anon_sym_fence] = ACTIONS(2086),
    [anon_sym_getelementptr] = ACTIONS(2086),
    [anon_sym_extractvalue] = ACTIONS(2086),
    [anon_sym_insertvalue] = ACTIONS(2086),
    [anon_sym_mul] = ACTIONS(2086),
    [anon_sym_urem] = ACTIONS(2086),
    [anon_sym_srem] = ACTIONS(2086),
    [anon_sym_shl] = ACTIONS(2086),
    [anon_sym_udiv] = ACTIONS(2086),
    [anon_sym_sdiv] = ACTIONS(2086),
    [anon_sym_lshr] = ACTIONS(2086),
    [anon_sym_ashr] = ACTIONS(2086),
    [anon_sym_fmul] = ACTIONS(2086),
    [anon_sym_fdiv] = ACTIONS(2086),
    [anon_sym_frem] = ACTIONS(2086),
    [anon_sym_xchg] = ACTIONS(2086),
    [anon_sym_add] = ACTIONS(2086),
    [anon_sym_sub] = ACTIONS(2086),
    [anon_sym_and] = ACTIONS(2086),
    [anon_sym_nand] = ACTIONS(2086),
    [anon_sym_or] = ACTIONS(2086),
    [anon_sym_xor] = ACTIONS(2086),
    [anon_sym_max] = ACTIONS(2086),
    [anon_sym_min] = ACTIONS(2086),
    [anon_sym_umax] = ACTIONS(2086),
    [anon_sym_umin] = ACTIONS(2086),
    [anon_sym_fadd] = ACTIONS(2086),
    [anon_sym_fsub] = ACTIONS(2086),
    [anon_sym_bitcast] = ACTIONS(2086),
    [anon_sym_trunc] = ACTIONS(2086),
    [anon_sym_zext] = ACTIONS(2086),
    [anon_sym_sext] = ACTIONS(2086),
    [anon_sym_fptrunc] = ACTIONS(2086),
    [anon_sym_fpext] = ACTIONS(2086),
    [anon_sym_addrspacecast] = ACTIONS(2086),
    [anon_sym_uitofp] = ACTIONS(2086),
    [anon_sym_sitofp] = ACTIONS(2086),
    [anon_sym_fptoui] = ACTIONS(2086),
    [anon_sym_fptosi] = ACTIONS(2086),
    [anon_sym_inttoptr] = ACTIONS(2086),
    [anon_sym_ptrtoint] = ACTIONS(2086),
    [anon_sym_uselistorder] = ACTIONS(2086),
  },
  [634] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2088),
    [sym_label] = ACTIONS(2088),
    [anon_sym_RBRACE] = ACTIONS(2088),
    [anon_sym_COMMA] = ACTIONS(2088),
    [anon_sym_unreachable] = ACTIONS(2090),
    [anon_sym_ret] = ACTIONS(2090),
    [anon_sym_br] = ACTIONS(2090),
    [anon_sym_resume] = ACTIONS(2090),
    [anon_sym_freeze] = ACTIONS(2090),
    [anon_sym_indirectbr] = ACTIONS(2090),
    [anon_sym_extractelement] = ACTIONS(2090),
    [anon_sym_insertelement] = ACTIONS(2090),
    [anon_sym_select] = ACTIONS(2090),
    [anon_sym_shufflevector] = ACTIONS(2090),
    [anon_sym_fneg] = ACTIONS(2090),
    [anon_sym_switch] = ACTIONS(2090),
    [anon_sym_invoke] = ACTIONS(2090),
    [anon_sym_cleanupret] = ACTIONS(2090),
    [anon_sym_catchret] = ACTIONS(2090),
    [anon_sym_catchswitch] = ACTIONS(2090),
    [anon_sym_catchpad] = ACTIONS(2090),
    [anon_sym_cleanuppad] = ACTIONS(2090),
    [anon_sym_callbr] = ACTIONS(2090),
    [anon_sym_icmp] = ACTIONS(2090),
    [anon_sym_fcmp] = ACTIONS(2090),
    [anon_sym_va_arg] = ACTIONS(2090),
    [anon_sym_phi] = ACTIONS(2090),
    [anon_sym_landingpad] = ACTIONS(2090),
    [anon_sym_tail] = ACTIONS(2090),
    [anon_sym_musttail] = ACTIONS(2090),
    [anon_sym_notail] = ACTIONS(2090),
    [anon_sym_call] = ACTIONS(2090),
    [anon_sym_alloca] = ACTIONS(2090),
    [anon_sym_load] = ACTIONS(2090),
    [anon_sym_store] = ACTIONS(2090),
    [anon_sym_cmpxchg] = ACTIONS(2090),
    [anon_sym_atomicrmw] = ACTIONS(2090),
    [anon_sym_fence] = ACTIONS(2090),
    [anon_sym_getelementptr] = ACTIONS(2090),
    [anon_sym_extractvalue] = ACTIONS(2090),
    [anon_sym_insertvalue] = ACTIONS(2090),
    [anon_sym_mul] = ACTIONS(2090),
    [anon_sym_urem] = ACTIONS(2090),
    [anon_sym_srem] = ACTIONS(2090),
    [anon_sym_shl] = ACTIONS(2090),
    [anon_sym_udiv] = ACTIONS(2090),
    [anon_sym_sdiv] = ACTIONS(2090),
    [anon_sym_lshr] = ACTIONS(2090),
    [anon_sym_ashr] = ACTIONS(2090),
    [anon_sym_fmul] = ACTIONS(2090),
    [anon_sym_fdiv] = ACTIONS(2090),
    [anon_sym_frem] = ACTIONS(2090),
    [anon_sym_xchg] = ACTIONS(2090),
    [anon_sym_add] = ACTIONS(2090),
    [anon_sym_sub] = ACTIONS(2090),
    [anon_sym_and] = ACTIONS(2090),
    [anon_sym_nand] = ACTIONS(2090),
    [anon_sym_or] = ACTIONS(2090),
    [anon_sym_xor] = ACTIONS(2090),
    [anon_sym_max] = ACTIONS(2090),
    [anon_sym_min] = ACTIONS(2090),
    [anon_sym_umax] = ACTIONS(2090),
    [anon_sym_umin] = ACTIONS(2090),
    [anon_sym_fadd] = ACTIONS(2090),
    [anon_sym_fsub] = ACTIONS(2090),
    [anon_sym_bitcast] = ACTIONS(2090),
    [anon_sym_trunc] = ACTIONS(2090),
    [anon_sym_zext] = ACTIONS(2090),
    [anon_sym_sext] = ACTIONS(2090),
    [anon_sym_fptrunc] = ACTIONS(2090),
    [anon_sym_fpext] = ACTIONS(2090),
    [anon_sym_addrspacecast] = ACTIONS(2090),
    [anon_sym_uitofp] = ACTIONS(2090),
    [anon_sym_sitofp] = ACTIONS(2090),
    [anon_sym_fptoui] = ACTIONS(2090),
    [anon_sym_fptosi] = ACTIONS(2090),
    [anon_sym_inttoptr] = ACTIONS(2090),
    [anon_sym_ptrtoint] = ACTIONS(2090),
    [anon_sym_uselistorder] = ACTIONS(2090),
  },
  [635] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2092),
    [sym_label] = ACTIONS(2092),
    [anon_sym_RBRACE] = ACTIONS(2092),
    [anon_sym_COMMA] = ACTIONS(2092),
    [anon_sym_unreachable] = ACTIONS(2094),
    [anon_sym_ret] = ACTIONS(2094),
    [anon_sym_br] = ACTIONS(2094),
    [anon_sym_resume] = ACTIONS(2094),
    [anon_sym_freeze] = ACTIONS(2094),
    [anon_sym_indirectbr] = ACTIONS(2094),
    [anon_sym_extractelement] = ACTIONS(2094),
    [anon_sym_insertelement] = ACTIONS(2094),
    [anon_sym_select] = ACTIONS(2094),
    [anon_sym_shufflevector] = ACTIONS(2094),
    [anon_sym_fneg] = ACTIONS(2094),
    [anon_sym_switch] = ACTIONS(2094),
    [anon_sym_invoke] = ACTIONS(2094),
    [anon_sym_cleanupret] = ACTIONS(2094),
    [anon_sym_catchret] = ACTIONS(2094),
    [anon_sym_catchswitch] = ACTIONS(2094),
    [anon_sym_catchpad] = ACTIONS(2094),
    [anon_sym_cleanuppad] = ACTIONS(2094),
    [anon_sym_callbr] = ACTIONS(2094),
    [anon_sym_icmp] = ACTIONS(2094),
    [anon_sym_fcmp] = ACTIONS(2094),
    [anon_sym_va_arg] = ACTIONS(2094),
    [anon_sym_phi] = ACTIONS(2094),
    [anon_sym_landingpad] = ACTIONS(2094),
    [anon_sym_tail] = ACTIONS(2094),
    [anon_sym_musttail] = ACTIONS(2094),
    [anon_sym_notail] = ACTIONS(2094),
    [anon_sym_call] = ACTIONS(2094),
    [anon_sym_alloca] = ACTIONS(2094),
    [anon_sym_load] = ACTIONS(2094),
    [anon_sym_store] = ACTIONS(2094),
    [anon_sym_cmpxchg] = ACTIONS(2094),
    [anon_sym_atomicrmw] = ACTIONS(2094),
    [anon_sym_fence] = ACTIONS(2094),
    [anon_sym_getelementptr] = ACTIONS(2094),
    [anon_sym_extractvalue] = ACTIONS(2094),
    [anon_sym_insertvalue] = ACTIONS(2094),
    [anon_sym_mul] = ACTIONS(2094),
    [anon_sym_urem] = ACTIONS(2094),
    [anon_sym_srem] = ACTIONS(2094),
    [anon_sym_shl] = ACTIONS(2094),
    [anon_sym_udiv] = ACTIONS(2094),
    [anon_sym_sdiv] = ACTIONS(2094),
    [anon_sym_lshr] = ACTIONS(2094),
    [anon_sym_ashr] = ACTIONS(2094),
    [anon_sym_fmul] = ACTIONS(2094),
    [anon_sym_fdiv] = ACTIONS(2094),
    [anon_sym_frem] = ACTIONS(2094),
    [anon_sym_xchg] = ACTIONS(2094),
    [anon_sym_add] = ACTIONS(2094),
    [anon_sym_sub] = ACTIONS(2094),
    [anon_sym_and] = ACTIONS(2094),
    [anon_sym_nand] = ACTIONS(2094),
    [anon_sym_or] = ACTIONS(2094),
    [anon_sym_xor] = ACTIONS(2094),
    [anon_sym_max] = ACTIONS(2094),
    [anon_sym_min] = ACTIONS(2094),
    [anon_sym_umax] = ACTIONS(2094),
    [anon_sym_umin] = ACTIONS(2094),
    [anon_sym_fadd] = ACTIONS(2094),
    [anon_sym_fsub] = ACTIONS(2094),
    [anon_sym_bitcast] = ACTIONS(2094),
    [anon_sym_trunc] = ACTIONS(2094),
    [anon_sym_zext] = ACTIONS(2094),
    [anon_sym_sext] = ACTIONS(2094),
    [anon_sym_fptrunc] = ACTIONS(2094),
    [anon_sym_fpext] = ACTIONS(2094),
    [anon_sym_addrspacecast] = ACTIONS(2094),
    [anon_sym_uitofp] = ACTIONS(2094),
    [anon_sym_sitofp] = ACTIONS(2094),
    [anon_sym_fptoui] = ACTIONS(2094),
    [anon_sym_fptosi] = ACTIONS(2094),
    [anon_sym_inttoptr] = ACTIONS(2094),
    [anon_sym_ptrtoint] = ACTIONS(2094),
    [anon_sym_uselistorder] = ACTIONS(2094),
  },
  [636] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2096),
    [sym_label] = ACTIONS(2096),
    [anon_sym_RBRACE] = ACTIONS(2096),
    [anon_sym_COMMA] = ACTIONS(2096),
    [anon_sym_unreachable] = ACTIONS(2098),
    [anon_sym_ret] = ACTIONS(2098),
    [anon_sym_br] = ACTIONS(2098),
    [anon_sym_resume] = ACTIONS(2098),
    [anon_sym_freeze] = ACTIONS(2098),
    [anon_sym_indirectbr] = ACTIONS(2098),
    [anon_sym_extractelement] = ACTIONS(2098),
    [anon_sym_insertelement] = ACTIONS(2098),
    [anon_sym_select] = ACTIONS(2098),
    [anon_sym_shufflevector] = ACTIONS(2098),
    [anon_sym_fneg] = ACTIONS(2098),
    [anon_sym_switch] = ACTIONS(2098),
    [anon_sym_invoke] = ACTIONS(2098),
    [anon_sym_cleanupret] = ACTIONS(2098),
    [anon_sym_catchret] = ACTIONS(2098),
    [anon_sym_catchswitch] = ACTIONS(2098),
    [anon_sym_catchpad] = ACTIONS(2098),
    [anon_sym_cleanuppad] = ACTIONS(2098),
    [anon_sym_callbr] = ACTIONS(2098),
    [anon_sym_icmp] = ACTIONS(2098),
    [anon_sym_fcmp] = ACTIONS(2098),
    [anon_sym_va_arg] = ACTIONS(2098),
    [anon_sym_phi] = ACTIONS(2098),
    [anon_sym_landingpad] = ACTIONS(2098),
    [anon_sym_tail] = ACTIONS(2098),
    [anon_sym_musttail] = ACTIONS(2098),
    [anon_sym_notail] = ACTIONS(2098),
    [anon_sym_call] = ACTIONS(2098),
    [anon_sym_alloca] = ACTIONS(2098),
    [anon_sym_load] = ACTIONS(2098),
    [anon_sym_store] = ACTIONS(2098),
    [anon_sym_cmpxchg] = ACTIONS(2098),
    [anon_sym_atomicrmw] = ACTIONS(2098),
    [anon_sym_fence] = ACTIONS(2098),
    [anon_sym_getelementptr] = ACTIONS(2098),
    [anon_sym_extractvalue] = ACTIONS(2098),
    [anon_sym_insertvalue] = ACTIONS(2098),
    [anon_sym_mul] = ACTIONS(2098),
    [anon_sym_urem] = ACTIONS(2098),
    [anon_sym_srem] = ACTIONS(2098),
    [anon_sym_shl] = ACTIONS(2098),
    [anon_sym_udiv] = ACTIONS(2098),
    [anon_sym_sdiv] = ACTIONS(2098),
    [anon_sym_lshr] = ACTIONS(2098),
    [anon_sym_ashr] = ACTIONS(2098),
    [anon_sym_fmul] = ACTIONS(2098),
    [anon_sym_fdiv] = ACTIONS(2098),
    [anon_sym_frem] = ACTIONS(2098),
    [anon_sym_xchg] = ACTIONS(2098),
    [anon_sym_add] = ACTIONS(2098),
    [anon_sym_sub] = ACTIONS(2098),
    [anon_sym_and] = ACTIONS(2098),
    [anon_sym_nand] = ACTIONS(2098),
    [anon_sym_or] = ACTIONS(2098),
    [anon_sym_xor] = ACTIONS(2098),
    [anon_sym_max] = ACTIONS(2098),
    [anon_sym_min] = ACTIONS(2098),
    [anon_sym_umax] = ACTIONS(2098),
    [anon_sym_umin] = ACTIONS(2098),
    [anon_sym_fadd] = ACTIONS(2098),
    [anon_sym_fsub] = ACTIONS(2098),
    [anon_sym_bitcast] = ACTIONS(2098),
    [anon_sym_trunc] = ACTIONS(2098),
    [anon_sym_zext] = ACTIONS(2098),
    [anon_sym_sext] = ACTIONS(2098),
    [anon_sym_fptrunc] = ACTIONS(2098),
    [anon_sym_fpext] = ACTIONS(2098),
    [anon_sym_addrspacecast] = ACTIONS(2098),
    [anon_sym_uitofp] = ACTIONS(2098),
    [anon_sym_sitofp] = ACTIONS(2098),
    [anon_sym_fptoui] = ACTIONS(2098),
    [anon_sym_fptosi] = ACTIONS(2098),
    [anon_sym_inttoptr] = ACTIONS(2098),
    [anon_sym_ptrtoint] = ACTIONS(2098),
    [anon_sym_uselistorder] = ACTIONS(2098),
  },
  [637] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2100),
    [sym_label] = ACTIONS(2100),
    [anon_sym_RBRACE] = ACTIONS(2100),
    [anon_sym_COMMA] = ACTIONS(2100),
    [anon_sym_unreachable] = ACTIONS(2102),
    [anon_sym_ret] = ACTIONS(2102),
    [anon_sym_br] = ACTIONS(2102),
    [anon_sym_resume] = ACTIONS(2102),
    [anon_sym_freeze] = ACTIONS(2102),
    [anon_sym_indirectbr] = ACTIONS(2102),
    [anon_sym_extractelement] = ACTIONS(2102),
    [anon_sym_insertelement] = ACTIONS(2102),
    [anon_sym_select] = ACTIONS(2102),
    [anon_sym_shufflevector] = ACTIONS(2102),
    [anon_sym_fneg] = ACTIONS(2102),
    [anon_sym_switch] = ACTIONS(2102),
    [anon_sym_invoke] = ACTIONS(2102),
    [anon_sym_cleanupret] = ACTIONS(2102),
    [anon_sym_catchret] = ACTIONS(2102),
    [anon_sym_catchswitch] = ACTIONS(2102),
    [anon_sym_catchpad] = ACTIONS(2102),
    [anon_sym_cleanuppad] = ACTIONS(2102),
    [anon_sym_callbr] = ACTIONS(2102),
    [anon_sym_icmp] = ACTIONS(2102),
    [anon_sym_fcmp] = ACTIONS(2102),
    [anon_sym_va_arg] = ACTIONS(2102),
    [anon_sym_phi] = ACTIONS(2102),
    [anon_sym_landingpad] = ACTIONS(2102),
    [anon_sym_tail] = ACTIONS(2102),
    [anon_sym_musttail] = ACTIONS(2102),
    [anon_sym_notail] = ACTIONS(2102),
    [anon_sym_call] = ACTIONS(2102),
    [anon_sym_alloca] = ACTIONS(2102),
    [anon_sym_load] = ACTIONS(2102),
    [anon_sym_store] = ACTIONS(2102),
    [anon_sym_cmpxchg] = ACTIONS(2102),
    [anon_sym_atomicrmw] = ACTIONS(2102),
    [anon_sym_fence] = ACTIONS(2102),
    [anon_sym_getelementptr] = ACTIONS(2102),
    [anon_sym_extractvalue] = ACTIONS(2102),
    [anon_sym_insertvalue] = ACTIONS(2102),
    [anon_sym_mul] = ACTIONS(2102),
    [anon_sym_urem] = ACTIONS(2102),
    [anon_sym_srem] = ACTIONS(2102),
    [anon_sym_shl] = ACTIONS(2102),
    [anon_sym_udiv] = ACTIONS(2102),
    [anon_sym_sdiv] = ACTIONS(2102),
    [anon_sym_lshr] = ACTIONS(2102),
    [anon_sym_ashr] = ACTIONS(2102),
    [anon_sym_fmul] = ACTIONS(2102),
    [anon_sym_fdiv] = ACTIONS(2102),
    [anon_sym_frem] = ACTIONS(2102),
    [anon_sym_xchg] = ACTIONS(2102),
    [anon_sym_add] = ACTIONS(2102),
    [anon_sym_sub] = ACTIONS(2102),
    [anon_sym_and] = ACTIONS(2102),
    [anon_sym_nand] = ACTIONS(2102),
    [anon_sym_or] = ACTIONS(2102),
    [anon_sym_xor] = ACTIONS(2102),
    [anon_sym_max] = ACTIONS(2102),
    [anon_sym_min] = ACTIONS(2102),
    [anon_sym_umax] = ACTIONS(2102),
    [anon_sym_umin] = ACTIONS(2102),
    [anon_sym_fadd] = ACTIONS(2102),
    [anon_sym_fsub] = ACTIONS(2102),
    [anon_sym_bitcast] = ACTIONS(2102),
    [anon_sym_trunc] = ACTIONS(2102),
    [anon_sym_zext] = ACTIONS(2102),
    [anon_sym_sext] = ACTIONS(2102),
    [anon_sym_fptrunc] = ACTIONS(2102),
    [anon_sym_fpext] = ACTIONS(2102),
    [anon_sym_addrspacecast] = ACTIONS(2102),
    [anon_sym_uitofp] = ACTIONS(2102),
    [anon_sym_sitofp] = ACTIONS(2102),
    [anon_sym_fptoui] = ACTIONS(2102),
    [anon_sym_fptosi] = ACTIONS(2102),
    [anon_sym_inttoptr] = ACTIONS(2102),
    [anon_sym_ptrtoint] = ACTIONS(2102),
    [anon_sym_uselistorder] = ACTIONS(2102),
  },
  [638] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2104),
    [sym_label] = ACTIONS(2104),
    [anon_sym_RBRACE] = ACTIONS(2104),
    [anon_sym_COMMA] = ACTIONS(2104),
    [anon_sym_unreachable] = ACTIONS(2106),
    [anon_sym_ret] = ACTIONS(2106),
    [anon_sym_br] = ACTIONS(2106),
    [anon_sym_resume] = ACTIONS(2106),
    [anon_sym_freeze] = ACTIONS(2106),
    [anon_sym_indirectbr] = ACTIONS(2106),
    [anon_sym_extractelement] = ACTIONS(2106),
    [anon_sym_insertelement] = ACTIONS(2106),
    [anon_sym_select] = ACTIONS(2106),
    [anon_sym_shufflevector] = ACTIONS(2106),
    [anon_sym_fneg] = ACTIONS(2106),
    [anon_sym_switch] = ACTIONS(2106),
    [anon_sym_invoke] = ACTIONS(2106),
    [anon_sym_cleanupret] = ACTIONS(2106),
    [anon_sym_catchret] = ACTIONS(2106),
    [anon_sym_catchswitch] = ACTIONS(2106),
    [anon_sym_catchpad] = ACTIONS(2106),
    [anon_sym_cleanuppad] = ACTIONS(2106),
    [anon_sym_callbr] = ACTIONS(2106),
    [anon_sym_icmp] = ACTIONS(2106),
    [anon_sym_fcmp] = ACTIONS(2106),
    [anon_sym_va_arg] = ACTIONS(2106),
    [anon_sym_phi] = ACTIONS(2106),
    [anon_sym_landingpad] = ACTIONS(2106),
    [anon_sym_tail] = ACTIONS(2106),
    [anon_sym_musttail] = ACTIONS(2106),
    [anon_sym_notail] = ACTIONS(2106),
    [anon_sym_call] = ACTIONS(2106),
    [anon_sym_alloca] = ACTIONS(2106),
    [anon_sym_load] = ACTIONS(2106),
    [anon_sym_store] = ACTIONS(2106),
    [anon_sym_cmpxchg] = ACTIONS(2106),
    [anon_sym_atomicrmw] = ACTIONS(2106),
    [anon_sym_fence] = ACTIONS(2106),
    [anon_sym_getelementptr] = ACTIONS(2106),
    [anon_sym_extractvalue] = ACTIONS(2106),
    [anon_sym_insertvalue] = ACTIONS(2106),
    [anon_sym_mul] = ACTIONS(2106),
    [anon_sym_urem] = ACTIONS(2106),
    [anon_sym_srem] = ACTIONS(2106),
    [anon_sym_shl] = ACTIONS(2106),
    [anon_sym_udiv] = ACTIONS(2106),
    [anon_sym_sdiv] = ACTIONS(2106),
    [anon_sym_lshr] = ACTIONS(2106),
    [anon_sym_ashr] = ACTIONS(2106),
    [anon_sym_fmul] = ACTIONS(2106),
    [anon_sym_fdiv] = ACTIONS(2106),
    [anon_sym_frem] = ACTIONS(2106),
    [anon_sym_xchg] = ACTIONS(2106),
    [anon_sym_add] = ACTIONS(2106),
    [anon_sym_sub] = ACTIONS(2106),
    [anon_sym_and] = ACTIONS(2106),
    [anon_sym_nand] = ACTIONS(2106),
    [anon_sym_or] = ACTIONS(2106),
    [anon_sym_xor] = ACTIONS(2106),
    [anon_sym_max] = ACTIONS(2106),
    [anon_sym_min] = ACTIONS(2106),
    [anon_sym_umax] = ACTIONS(2106),
    [anon_sym_umin] = ACTIONS(2106),
    [anon_sym_fadd] = ACTIONS(2106),
    [anon_sym_fsub] = ACTIONS(2106),
    [anon_sym_bitcast] = ACTIONS(2106),
    [anon_sym_trunc] = ACTIONS(2106),
    [anon_sym_zext] = ACTIONS(2106),
    [anon_sym_sext] = ACTIONS(2106),
    [anon_sym_fptrunc] = ACTIONS(2106),
    [anon_sym_fpext] = ACTIONS(2106),
    [anon_sym_addrspacecast] = ACTIONS(2106),
    [anon_sym_uitofp] = ACTIONS(2106),
    [anon_sym_sitofp] = ACTIONS(2106),
    [anon_sym_fptoui] = ACTIONS(2106),
    [anon_sym_fptosi] = ACTIONS(2106),
    [anon_sym_inttoptr] = ACTIONS(2106),
    [anon_sym_ptrtoint] = ACTIONS(2106),
    [anon_sym_uselistorder] = ACTIONS(2106),
  },
  [639] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2108),
    [sym_label] = ACTIONS(2108),
    [anon_sym_RBRACE] = ACTIONS(2108),
    [anon_sym_COMMA] = ACTIONS(2108),
    [anon_sym_unreachable] = ACTIONS(2110),
    [anon_sym_ret] = ACTIONS(2110),
    [anon_sym_br] = ACTIONS(2110),
    [anon_sym_resume] = ACTIONS(2110),
    [anon_sym_freeze] = ACTIONS(2110),
    [anon_sym_indirectbr] = ACTIONS(2110),
    [anon_sym_extractelement] = ACTIONS(2110),
    [anon_sym_insertelement] = ACTIONS(2110),
    [anon_sym_select] = ACTIONS(2110),
    [anon_sym_shufflevector] = ACTIONS(2110),
    [anon_sym_fneg] = ACTIONS(2110),
    [anon_sym_switch] = ACTIONS(2110),
    [anon_sym_invoke] = ACTIONS(2110),
    [anon_sym_cleanupret] = ACTIONS(2110),
    [anon_sym_catchret] = ACTIONS(2110),
    [anon_sym_catchswitch] = ACTIONS(2110),
    [anon_sym_catchpad] = ACTIONS(2110),
    [anon_sym_cleanuppad] = ACTIONS(2110),
    [anon_sym_callbr] = ACTIONS(2110),
    [anon_sym_icmp] = ACTIONS(2110),
    [anon_sym_fcmp] = ACTIONS(2110),
    [anon_sym_va_arg] = ACTIONS(2110),
    [anon_sym_phi] = ACTIONS(2110),
    [anon_sym_landingpad] = ACTIONS(2110),
    [anon_sym_tail] = ACTIONS(2110),
    [anon_sym_musttail] = ACTIONS(2110),
    [anon_sym_notail] = ACTIONS(2110),
    [anon_sym_call] = ACTIONS(2110),
    [anon_sym_alloca] = ACTIONS(2110),
    [anon_sym_load] = ACTIONS(2110),
    [anon_sym_store] = ACTIONS(2110),
    [anon_sym_cmpxchg] = ACTIONS(2110),
    [anon_sym_atomicrmw] = ACTIONS(2110),
    [anon_sym_fence] = ACTIONS(2110),
    [anon_sym_getelementptr] = ACTIONS(2110),
    [anon_sym_extractvalue] = ACTIONS(2110),
    [anon_sym_insertvalue] = ACTIONS(2110),
    [anon_sym_mul] = ACTIONS(2110),
    [anon_sym_urem] = ACTIONS(2110),
    [anon_sym_srem] = ACTIONS(2110),
    [anon_sym_shl] = ACTIONS(2110),
    [anon_sym_udiv] = ACTIONS(2110),
    [anon_sym_sdiv] = ACTIONS(2110),
    [anon_sym_lshr] = ACTIONS(2110),
    [anon_sym_ashr] = ACTIONS(2110),
    [anon_sym_fmul] = ACTIONS(2110),
    [anon_sym_fdiv] = ACTIONS(2110),
    [anon_sym_frem] = ACTIONS(2110),
    [anon_sym_xchg] = ACTIONS(2110),
    [anon_sym_add] = ACTIONS(2110),
    [anon_sym_sub] = ACTIONS(2110),
    [anon_sym_and] = ACTIONS(2110),
    [anon_sym_nand] = ACTIONS(2110),
    [anon_sym_or] = ACTIONS(2110),
    [anon_sym_xor] = ACTIONS(2110),
    [anon_sym_max] = ACTIONS(2110),
    [anon_sym_min] = ACTIONS(2110),
    [anon_sym_umax] = ACTIONS(2110),
    [anon_sym_umin] = ACTIONS(2110),
    [anon_sym_fadd] = ACTIONS(2110),
    [anon_sym_fsub] = ACTIONS(2110),
    [anon_sym_bitcast] = ACTIONS(2110),
    [anon_sym_trunc] = ACTIONS(2110),
    [anon_sym_zext] = ACTIONS(2110),
    [anon_sym_sext] = ACTIONS(2110),
    [anon_sym_fptrunc] = ACTIONS(2110),
    [anon_sym_fpext] = ACTIONS(2110),
    [anon_sym_addrspacecast] = ACTIONS(2110),
    [anon_sym_uitofp] = ACTIONS(2110),
    [anon_sym_sitofp] = ACTIONS(2110),
    [anon_sym_fptoui] = ACTIONS(2110),
    [anon_sym_fptosi] = ACTIONS(2110),
    [anon_sym_inttoptr] = ACTIONS(2110),
    [anon_sym_ptrtoint] = ACTIONS(2110),
    [anon_sym_uselistorder] = ACTIONS(2110),
  },
  [640] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2112),
    [sym_label] = ACTIONS(2112),
    [anon_sym_RBRACE] = ACTIONS(2112),
    [anon_sym_COMMA] = ACTIONS(2112),
    [anon_sym_unreachable] = ACTIONS(2114),
    [anon_sym_ret] = ACTIONS(2114),
    [anon_sym_br] = ACTIONS(2114),
    [anon_sym_resume] = ACTIONS(2114),
    [anon_sym_freeze] = ACTIONS(2114),
    [anon_sym_indirectbr] = ACTIONS(2114),
    [anon_sym_extractelement] = ACTIONS(2114),
    [anon_sym_insertelement] = ACTIONS(2114),
    [anon_sym_select] = ACTIONS(2114),
    [anon_sym_shufflevector] = ACTIONS(2114),
    [anon_sym_fneg] = ACTIONS(2114),
    [anon_sym_switch] = ACTIONS(2114),
    [anon_sym_invoke] = ACTIONS(2114),
    [anon_sym_cleanupret] = ACTIONS(2114),
    [anon_sym_catchret] = ACTIONS(2114),
    [anon_sym_catchswitch] = ACTIONS(2114),
    [anon_sym_catchpad] = ACTIONS(2114),
    [anon_sym_cleanuppad] = ACTIONS(2114),
    [anon_sym_callbr] = ACTIONS(2114),
    [anon_sym_icmp] = ACTIONS(2114),
    [anon_sym_fcmp] = ACTIONS(2114),
    [anon_sym_va_arg] = ACTIONS(2114),
    [anon_sym_phi] = ACTIONS(2114),
    [anon_sym_landingpad] = ACTIONS(2114),
    [anon_sym_tail] = ACTIONS(2114),
    [anon_sym_musttail] = ACTIONS(2114),
    [anon_sym_notail] = ACTIONS(2114),
    [anon_sym_call] = ACTIONS(2114),
    [anon_sym_alloca] = ACTIONS(2114),
    [anon_sym_load] = ACTIONS(2114),
    [anon_sym_store] = ACTIONS(2114),
    [anon_sym_cmpxchg] = ACTIONS(2114),
    [anon_sym_atomicrmw] = ACTIONS(2114),
    [anon_sym_fence] = ACTIONS(2114),
    [anon_sym_getelementptr] = ACTIONS(2114),
    [anon_sym_extractvalue] = ACTIONS(2114),
    [anon_sym_insertvalue] = ACTIONS(2114),
    [anon_sym_mul] = ACTIONS(2114),
    [anon_sym_urem] = ACTIONS(2114),
    [anon_sym_srem] = ACTIONS(2114),
    [anon_sym_shl] = ACTIONS(2114),
    [anon_sym_udiv] = ACTIONS(2114),
    [anon_sym_sdiv] = ACTIONS(2114),
    [anon_sym_lshr] = ACTIONS(2114),
    [anon_sym_ashr] = ACTIONS(2114),
    [anon_sym_fmul] = ACTIONS(2114),
    [anon_sym_fdiv] = ACTIONS(2114),
    [anon_sym_frem] = ACTIONS(2114),
    [anon_sym_xchg] = ACTIONS(2114),
    [anon_sym_add] = ACTIONS(2114),
    [anon_sym_sub] = ACTIONS(2114),
    [anon_sym_and] = ACTIONS(2114),
    [anon_sym_nand] = ACTIONS(2114),
    [anon_sym_or] = ACTIONS(2114),
    [anon_sym_xor] = ACTIONS(2114),
    [anon_sym_max] = ACTIONS(2114),
    [anon_sym_min] = ACTIONS(2114),
    [anon_sym_umax] = ACTIONS(2114),
    [anon_sym_umin] = ACTIONS(2114),
    [anon_sym_fadd] = ACTIONS(2114),
    [anon_sym_fsub] = ACTIONS(2114),
    [anon_sym_bitcast] = ACTIONS(2114),
    [anon_sym_trunc] = ACTIONS(2114),
    [anon_sym_zext] = ACTIONS(2114),
    [anon_sym_sext] = ACTIONS(2114),
    [anon_sym_fptrunc] = ACTIONS(2114),
    [anon_sym_fpext] = ACTIONS(2114),
    [anon_sym_addrspacecast] = ACTIONS(2114),
    [anon_sym_uitofp] = ACTIONS(2114),
    [anon_sym_sitofp] = ACTIONS(2114),
    [anon_sym_fptoui] = ACTIONS(2114),
    [anon_sym_fptosi] = ACTIONS(2114),
    [anon_sym_inttoptr] = ACTIONS(2114),
    [anon_sym_ptrtoint] = ACTIONS(2114),
    [anon_sym_uselistorder] = ACTIONS(2114),
  },
  [641] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2116),
    [sym_label] = ACTIONS(2116),
    [anon_sym_RBRACE] = ACTIONS(2116),
    [anon_sym_COMMA] = ACTIONS(2116),
    [anon_sym_unreachable] = ACTIONS(2118),
    [anon_sym_ret] = ACTIONS(2118),
    [anon_sym_br] = ACTIONS(2118),
    [anon_sym_resume] = ACTIONS(2118),
    [anon_sym_freeze] = ACTIONS(2118),
    [anon_sym_indirectbr] = ACTIONS(2118),
    [anon_sym_extractelement] = ACTIONS(2118),
    [anon_sym_insertelement] = ACTIONS(2118),
    [anon_sym_select] = ACTIONS(2118),
    [anon_sym_shufflevector] = ACTIONS(2118),
    [anon_sym_fneg] = ACTIONS(2118),
    [anon_sym_switch] = ACTIONS(2118),
    [anon_sym_invoke] = ACTIONS(2118),
    [anon_sym_cleanupret] = ACTIONS(2118),
    [anon_sym_catchret] = ACTIONS(2118),
    [anon_sym_catchswitch] = ACTIONS(2118),
    [anon_sym_catchpad] = ACTIONS(2118),
    [anon_sym_cleanuppad] = ACTIONS(2118),
    [anon_sym_callbr] = ACTIONS(2118),
    [anon_sym_icmp] = ACTIONS(2118),
    [anon_sym_fcmp] = ACTIONS(2118),
    [anon_sym_va_arg] = ACTIONS(2118),
    [anon_sym_phi] = ACTIONS(2118),
    [anon_sym_landingpad] = ACTIONS(2118),
    [anon_sym_tail] = ACTIONS(2118),
    [anon_sym_musttail] = ACTIONS(2118),
    [anon_sym_notail] = ACTIONS(2118),
    [anon_sym_call] = ACTIONS(2118),
    [anon_sym_alloca] = ACTIONS(2118),
    [anon_sym_load] = ACTIONS(2118),
    [anon_sym_store] = ACTIONS(2118),
    [anon_sym_cmpxchg] = ACTIONS(2118),
    [anon_sym_atomicrmw] = ACTIONS(2118),
    [anon_sym_fence] = ACTIONS(2118),
    [anon_sym_getelementptr] = ACTIONS(2118),
    [anon_sym_extractvalue] = ACTIONS(2118),
    [anon_sym_insertvalue] = ACTIONS(2118),
    [anon_sym_mul] = ACTIONS(2118),
    [anon_sym_urem] = ACTIONS(2118),
    [anon_sym_srem] = ACTIONS(2118),
    [anon_sym_shl] = ACTIONS(2118),
    [anon_sym_udiv] = ACTIONS(2118),
    [anon_sym_sdiv] = ACTIONS(2118),
    [anon_sym_lshr] = ACTIONS(2118),
    [anon_sym_ashr] = ACTIONS(2118),
    [anon_sym_fmul] = ACTIONS(2118),
    [anon_sym_fdiv] = ACTIONS(2118),
    [anon_sym_frem] = ACTIONS(2118),
    [anon_sym_xchg] = ACTIONS(2118),
    [anon_sym_add] = ACTIONS(2118),
    [anon_sym_sub] = ACTIONS(2118),
    [anon_sym_and] = ACTIONS(2118),
    [anon_sym_nand] = ACTIONS(2118),
    [anon_sym_or] = ACTIONS(2118),
    [anon_sym_xor] = ACTIONS(2118),
    [anon_sym_max] = ACTIONS(2118),
    [anon_sym_min] = ACTIONS(2118),
    [anon_sym_umax] = ACTIONS(2118),
    [anon_sym_umin] = ACTIONS(2118),
    [anon_sym_fadd] = ACTIONS(2118),
    [anon_sym_fsub] = ACTIONS(2118),
    [anon_sym_bitcast] = ACTIONS(2118),
    [anon_sym_trunc] = ACTIONS(2118),
    [anon_sym_zext] = ACTIONS(2118),
    [anon_sym_sext] = ACTIONS(2118),
    [anon_sym_fptrunc] = ACTIONS(2118),
    [anon_sym_fpext] = ACTIONS(2118),
    [anon_sym_addrspacecast] = ACTIONS(2118),
    [anon_sym_uitofp] = ACTIONS(2118),
    [anon_sym_sitofp] = ACTIONS(2118),
    [anon_sym_fptoui] = ACTIONS(2118),
    [anon_sym_fptosi] = ACTIONS(2118),
    [anon_sym_inttoptr] = ACTIONS(2118),
    [anon_sym_ptrtoint] = ACTIONS(2118),
    [anon_sym_uselistorder] = ACTIONS(2118),
  },
  [642] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2120),
    [sym_label] = ACTIONS(2120),
    [anon_sym_RBRACE] = ACTIONS(2120),
    [anon_sym_COMMA] = ACTIONS(2120),
    [anon_sym_unreachable] = ACTIONS(2122),
    [anon_sym_ret] = ACTIONS(2122),
    [anon_sym_br] = ACTIONS(2122),
    [anon_sym_resume] = ACTIONS(2122),
    [anon_sym_freeze] = ACTIONS(2122),
    [anon_sym_indirectbr] = ACTIONS(2122),
    [anon_sym_extractelement] = ACTIONS(2122),
    [anon_sym_insertelement] = ACTIONS(2122),
    [anon_sym_select] = ACTIONS(2122),
    [anon_sym_shufflevector] = ACTIONS(2122),
    [anon_sym_fneg] = ACTIONS(2122),
    [anon_sym_switch] = ACTIONS(2122),
    [anon_sym_invoke] = ACTIONS(2122),
    [anon_sym_cleanupret] = ACTIONS(2122),
    [anon_sym_catchret] = ACTIONS(2122),
    [anon_sym_catchswitch] = ACTIONS(2122),
    [anon_sym_catchpad] = ACTIONS(2122),
    [anon_sym_cleanuppad] = ACTIONS(2122),
    [anon_sym_callbr] = ACTIONS(2122),
    [anon_sym_icmp] = ACTIONS(2122),
    [anon_sym_fcmp] = ACTIONS(2122),
    [anon_sym_va_arg] = ACTIONS(2122),
    [anon_sym_phi] = ACTIONS(2122),
    [anon_sym_landingpad] = ACTIONS(2122),
    [anon_sym_tail] = ACTIONS(2122),
    [anon_sym_musttail] = ACTIONS(2122),
    [anon_sym_notail] = ACTIONS(2122),
    [anon_sym_call] = ACTIONS(2122),
    [anon_sym_alloca] = ACTIONS(2122),
    [anon_sym_load] = ACTIONS(2122),
    [anon_sym_store] = ACTIONS(2122),
    [anon_sym_cmpxchg] = ACTIONS(2122),
    [anon_sym_atomicrmw] = ACTIONS(2122),
    [anon_sym_fence] = ACTIONS(2122),
    [anon_sym_getelementptr] = ACTIONS(2122),
    [anon_sym_extractvalue] = ACTIONS(2122),
    [anon_sym_insertvalue] = ACTIONS(2122),
    [anon_sym_mul] = ACTIONS(2122),
    [anon_sym_urem] = ACTIONS(2122),
    [anon_sym_srem] = ACTIONS(2122),
    [anon_sym_shl] = ACTIONS(2122),
    [anon_sym_udiv] = ACTIONS(2122),
    [anon_sym_sdiv] = ACTIONS(2122),
    [anon_sym_lshr] = ACTIONS(2122),
    [anon_sym_ashr] = ACTIONS(2122),
    [anon_sym_fmul] = ACTIONS(2122),
    [anon_sym_fdiv] = ACTIONS(2122),
    [anon_sym_frem] = ACTIONS(2122),
    [anon_sym_xchg] = ACTIONS(2122),
    [anon_sym_add] = ACTIONS(2122),
    [anon_sym_sub] = ACTIONS(2122),
    [anon_sym_and] = ACTIONS(2122),
    [anon_sym_nand] = ACTIONS(2122),
    [anon_sym_or] = ACTIONS(2122),
    [anon_sym_xor] = ACTIONS(2122),
    [anon_sym_max] = ACTIONS(2122),
    [anon_sym_min] = ACTIONS(2122),
    [anon_sym_umax] = ACTIONS(2122),
    [anon_sym_umin] = ACTIONS(2122),
    [anon_sym_fadd] = ACTIONS(2122),
    [anon_sym_fsub] = ACTIONS(2122),
    [anon_sym_bitcast] = ACTIONS(2122),
    [anon_sym_trunc] = ACTIONS(2122),
    [anon_sym_zext] = ACTIONS(2122),
    [anon_sym_sext] = ACTIONS(2122),
    [anon_sym_fptrunc] = ACTIONS(2122),
    [anon_sym_fpext] = ACTIONS(2122),
    [anon_sym_addrspacecast] = ACTIONS(2122),
    [anon_sym_uitofp] = ACTIONS(2122),
    [anon_sym_sitofp] = ACTIONS(2122),
    [anon_sym_fptoui] = ACTIONS(2122),
    [anon_sym_fptosi] = ACTIONS(2122),
    [anon_sym_inttoptr] = ACTIONS(2122),
    [anon_sym_ptrtoint] = ACTIONS(2122),
    [anon_sym_uselistorder] = ACTIONS(2122),
  },
  [643] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2124),
    [sym_label] = ACTIONS(2124),
    [anon_sym_RBRACE] = ACTIONS(2124),
    [anon_sym_COMMA] = ACTIONS(2124),
    [anon_sym_unreachable] = ACTIONS(2126),
    [anon_sym_ret] = ACTIONS(2126),
    [anon_sym_br] = ACTIONS(2126),
    [anon_sym_resume] = ACTIONS(2126),
    [anon_sym_freeze] = ACTIONS(2126),
    [anon_sym_indirectbr] = ACTIONS(2126),
    [anon_sym_extractelement] = ACTIONS(2126),
    [anon_sym_insertelement] = ACTIONS(2126),
    [anon_sym_select] = ACTIONS(2126),
    [anon_sym_shufflevector] = ACTIONS(2126),
    [anon_sym_fneg] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_invoke] = ACTIONS(2126),
    [anon_sym_cleanupret] = ACTIONS(2126),
    [anon_sym_catchret] = ACTIONS(2126),
    [anon_sym_catchswitch] = ACTIONS(2126),
    [anon_sym_catchpad] = ACTIONS(2126),
    [anon_sym_cleanuppad] = ACTIONS(2126),
    [anon_sym_callbr] = ACTIONS(2126),
    [anon_sym_icmp] = ACTIONS(2126),
    [anon_sym_fcmp] = ACTIONS(2126),
    [anon_sym_va_arg] = ACTIONS(2126),
    [anon_sym_phi] = ACTIONS(2126),
    [anon_sym_landingpad] = ACTIONS(2126),
    [anon_sym_tail] = ACTIONS(2126),
    [anon_sym_musttail] = ACTIONS(2126),
    [anon_sym_notail] = ACTIONS(2126),
    [anon_sym_call] = ACTIONS(2126),
    [anon_sym_alloca] = ACTIONS(2126),
    [anon_sym_load] = ACTIONS(2126),
    [anon_sym_store] = ACTIONS(2126),
    [anon_sym_cmpxchg] = ACTIONS(2126),
    [anon_sym_atomicrmw] = ACTIONS(2126),
    [anon_sym_fence] = ACTIONS(2126),
    [anon_sym_getelementptr] = ACTIONS(2126),
    [anon_sym_extractvalue] = ACTIONS(2126),
    [anon_sym_insertvalue] = ACTIONS(2126),
    [anon_sym_mul] = ACTIONS(2126),
    [anon_sym_urem] = ACTIONS(2126),
    [anon_sym_srem] = ACTIONS(2126),
    [anon_sym_shl] = ACTIONS(2126),
    [anon_sym_udiv] = ACTIONS(2126),
    [anon_sym_sdiv] = ACTIONS(2126),
    [anon_sym_lshr] = ACTIONS(2126),
    [anon_sym_ashr] = ACTIONS(2126),
    [anon_sym_fmul] = ACTIONS(2126),
    [anon_sym_fdiv] = ACTIONS(2126),
    [anon_sym_frem] = ACTIONS(2126),
    [anon_sym_xchg] = ACTIONS(2126),
    [anon_sym_add] = ACTIONS(2126),
    [anon_sym_sub] = ACTIONS(2126),
    [anon_sym_and] = ACTIONS(2126),
    [anon_sym_nand] = ACTIONS(2126),
    [anon_sym_or] = ACTIONS(2126),
    [anon_sym_xor] = ACTIONS(2126),
    [anon_sym_max] = ACTIONS(2126),
    [anon_sym_min] = ACTIONS(2126),
    [anon_sym_umax] = ACTIONS(2126),
    [anon_sym_umin] = ACTIONS(2126),
    [anon_sym_fadd] = ACTIONS(2126),
    [anon_sym_fsub] = ACTIONS(2126),
    [anon_sym_bitcast] = ACTIONS(2126),
    [anon_sym_trunc] = ACTIONS(2126),
    [anon_sym_zext] = ACTIONS(2126),
    [anon_sym_sext] = ACTIONS(2126),
    [anon_sym_fptrunc] = ACTIONS(2126),
    [anon_sym_fpext] = ACTIONS(2126),
    [anon_sym_addrspacecast] = ACTIONS(2126),
    [anon_sym_uitofp] = ACTIONS(2126),
    [anon_sym_sitofp] = ACTIONS(2126),
    [anon_sym_fptoui] = ACTIONS(2126),
    [anon_sym_fptosi] = ACTIONS(2126),
    [anon_sym_inttoptr] = ACTIONS(2126),
    [anon_sym_ptrtoint] = ACTIONS(2126),
    [anon_sym_uselistorder] = ACTIONS(2126),
  },
  [644] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2128),
    [sym_label] = ACTIONS(2128),
    [anon_sym_RBRACE] = ACTIONS(2128),
    [anon_sym_COMMA] = ACTIONS(2128),
    [anon_sym_unreachable] = ACTIONS(2130),
    [anon_sym_ret] = ACTIONS(2130),
    [anon_sym_br] = ACTIONS(2130),
    [anon_sym_resume] = ACTIONS(2130),
    [anon_sym_freeze] = ACTIONS(2130),
    [anon_sym_indirectbr] = ACTIONS(2130),
    [anon_sym_extractelement] = ACTIONS(2130),
    [anon_sym_insertelement] = ACTIONS(2130),
    [anon_sym_select] = ACTIONS(2130),
    [anon_sym_shufflevector] = ACTIONS(2130),
    [anon_sym_fneg] = ACTIONS(2130),
    [anon_sym_switch] = ACTIONS(2130),
    [anon_sym_invoke] = ACTIONS(2130),
    [anon_sym_cleanupret] = ACTIONS(2130),
    [anon_sym_catchret] = ACTIONS(2130),
    [anon_sym_catchswitch] = ACTIONS(2130),
    [anon_sym_catchpad] = ACTIONS(2130),
    [anon_sym_cleanuppad] = ACTIONS(2130),
    [anon_sym_callbr] = ACTIONS(2130),
    [anon_sym_icmp] = ACTIONS(2130),
    [anon_sym_fcmp] = ACTIONS(2130),
    [anon_sym_va_arg] = ACTIONS(2130),
    [anon_sym_phi] = ACTIONS(2130),
    [anon_sym_landingpad] = ACTIONS(2130),
    [anon_sym_tail] = ACTIONS(2130),
    [anon_sym_musttail] = ACTIONS(2130),
    [anon_sym_notail] = ACTIONS(2130),
    [anon_sym_call] = ACTIONS(2130),
    [anon_sym_alloca] = ACTIONS(2130),
    [anon_sym_load] = ACTIONS(2130),
    [anon_sym_store] = ACTIONS(2130),
    [anon_sym_cmpxchg] = ACTIONS(2130),
    [anon_sym_atomicrmw] = ACTIONS(2130),
    [anon_sym_fence] = ACTIONS(2130),
    [anon_sym_getelementptr] = ACTIONS(2130),
    [anon_sym_extractvalue] = ACTIONS(2130),
    [anon_sym_insertvalue] = ACTIONS(2130),
    [anon_sym_mul] = ACTIONS(2130),
    [anon_sym_urem] = ACTIONS(2130),
    [anon_sym_srem] = ACTIONS(2130),
    [anon_sym_shl] = ACTIONS(2130),
    [anon_sym_udiv] = ACTIONS(2130),
    [anon_sym_sdiv] = ACTIONS(2130),
    [anon_sym_lshr] = ACTIONS(2130),
    [anon_sym_ashr] = ACTIONS(2130),
    [anon_sym_fmul] = ACTIONS(2130),
    [anon_sym_fdiv] = ACTIONS(2130),
    [anon_sym_frem] = ACTIONS(2130),
    [anon_sym_xchg] = ACTIONS(2130),
    [anon_sym_add] = ACTIONS(2130),
    [anon_sym_sub] = ACTIONS(2130),
    [anon_sym_and] = ACTIONS(2130),
    [anon_sym_nand] = ACTIONS(2130),
    [anon_sym_or] = ACTIONS(2130),
    [anon_sym_xor] = ACTIONS(2130),
    [anon_sym_max] = ACTIONS(2130),
    [anon_sym_min] = ACTIONS(2130),
    [anon_sym_umax] = ACTIONS(2130),
    [anon_sym_umin] = ACTIONS(2130),
    [anon_sym_fadd] = ACTIONS(2130),
    [anon_sym_fsub] = ACTIONS(2130),
    [anon_sym_bitcast] = ACTIONS(2130),
    [anon_sym_trunc] = ACTIONS(2130),
    [anon_sym_zext] = ACTIONS(2130),
    [anon_sym_sext] = ACTIONS(2130),
    [anon_sym_fptrunc] = ACTIONS(2130),
    [anon_sym_fpext] = ACTIONS(2130),
    [anon_sym_addrspacecast] = ACTIONS(2130),
    [anon_sym_uitofp] = ACTIONS(2130),
    [anon_sym_sitofp] = ACTIONS(2130),
    [anon_sym_fptoui] = ACTIONS(2130),
    [anon_sym_fptosi] = ACTIONS(2130),
    [anon_sym_inttoptr] = ACTIONS(2130),
    [anon_sym_ptrtoint] = ACTIONS(2130),
    [anon_sym_uselistorder] = ACTIONS(2130),
  },
  [645] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2132),
    [sym_label] = ACTIONS(2132),
    [anon_sym_RBRACE] = ACTIONS(2132),
    [anon_sym_COMMA] = ACTIONS(2132),
    [anon_sym_unreachable] = ACTIONS(2134),
    [anon_sym_ret] = ACTIONS(2134),
    [anon_sym_br] = ACTIONS(2134),
    [anon_sym_resume] = ACTIONS(2134),
    [anon_sym_freeze] = ACTIONS(2134),
    [anon_sym_indirectbr] = ACTIONS(2134),
    [anon_sym_extractelement] = ACTIONS(2134),
    [anon_sym_insertelement] = ACTIONS(2134),
    [anon_sym_select] = ACTIONS(2134),
    [anon_sym_shufflevector] = ACTIONS(2134),
    [anon_sym_fneg] = ACTIONS(2134),
    [anon_sym_switch] = ACTIONS(2134),
    [anon_sym_invoke] = ACTIONS(2134),
    [anon_sym_cleanupret] = ACTIONS(2134),
    [anon_sym_catchret] = ACTIONS(2134),
    [anon_sym_catchswitch] = ACTIONS(2134),
    [anon_sym_catchpad] = ACTIONS(2134),
    [anon_sym_cleanuppad] = ACTIONS(2134),
    [anon_sym_callbr] = ACTIONS(2134),
    [anon_sym_icmp] = ACTIONS(2134),
    [anon_sym_fcmp] = ACTIONS(2134),
    [anon_sym_va_arg] = ACTIONS(2134),
    [anon_sym_phi] = ACTIONS(2134),
    [anon_sym_landingpad] = ACTIONS(2134),
    [anon_sym_tail] = ACTIONS(2134),
    [anon_sym_musttail] = ACTIONS(2134),
    [anon_sym_notail] = ACTIONS(2134),
    [anon_sym_call] = ACTIONS(2134),
    [anon_sym_alloca] = ACTIONS(2134),
    [anon_sym_load] = ACTIONS(2134),
    [anon_sym_store] = ACTIONS(2134),
    [anon_sym_cmpxchg] = ACTIONS(2134),
    [anon_sym_atomicrmw] = ACTIONS(2134),
    [anon_sym_fence] = ACTIONS(2134),
    [anon_sym_getelementptr] = ACTIONS(2134),
    [anon_sym_extractvalue] = ACTIONS(2134),
    [anon_sym_insertvalue] = ACTIONS(2134),
    [anon_sym_mul] = ACTIONS(2134),
    [anon_sym_urem] = ACTIONS(2134),
    [anon_sym_srem] = ACTIONS(2134),
    [anon_sym_shl] = ACTIONS(2134),
    [anon_sym_udiv] = ACTIONS(2134),
    [anon_sym_sdiv] = ACTIONS(2134),
    [anon_sym_lshr] = ACTIONS(2134),
    [anon_sym_ashr] = ACTIONS(2134),
    [anon_sym_fmul] = ACTIONS(2134),
    [anon_sym_fdiv] = ACTIONS(2134),
    [anon_sym_frem] = ACTIONS(2134),
    [anon_sym_xchg] = ACTIONS(2134),
    [anon_sym_add] = ACTIONS(2134),
    [anon_sym_sub] = ACTIONS(2134),
    [anon_sym_and] = ACTIONS(2134),
    [anon_sym_nand] = ACTIONS(2134),
    [anon_sym_or] = ACTIONS(2134),
    [anon_sym_xor] = ACTIONS(2134),
    [anon_sym_max] = ACTIONS(2134),
    [anon_sym_min] = ACTIONS(2134),
    [anon_sym_umax] = ACTIONS(2134),
    [anon_sym_umin] = ACTIONS(2134),
    [anon_sym_fadd] = ACTIONS(2134),
    [anon_sym_fsub] = ACTIONS(2134),
    [anon_sym_bitcast] = ACTIONS(2134),
    [anon_sym_trunc] = ACTIONS(2134),
    [anon_sym_zext] = ACTIONS(2134),
    [anon_sym_sext] = ACTIONS(2134),
    [anon_sym_fptrunc] = ACTIONS(2134),
    [anon_sym_fpext] = ACTIONS(2134),
    [anon_sym_addrspacecast] = ACTIONS(2134),
    [anon_sym_uitofp] = ACTIONS(2134),
    [anon_sym_sitofp] = ACTIONS(2134),
    [anon_sym_fptoui] = ACTIONS(2134),
    [anon_sym_fptosi] = ACTIONS(2134),
    [anon_sym_inttoptr] = ACTIONS(2134),
    [anon_sym_ptrtoint] = ACTIONS(2134),
    [anon_sym_uselistorder] = ACTIONS(2134),
  },
  [646] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(753),
    [sym_label] = ACTIONS(753),
    [anon_sym_RBRACE] = ACTIONS(753),
    [anon_sym_COMMA] = ACTIONS(753),
    [anon_sym_unreachable] = ACTIONS(755),
    [anon_sym_ret] = ACTIONS(755),
    [anon_sym_br] = ACTIONS(755),
    [anon_sym_resume] = ACTIONS(755),
    [anon_sym_freeze] = ACTIONS(755),
    [anon_sym_indirectbr] = ACTIONS(755),
    [anon_sym_extractelement] = ACTIONS(755),
    [anon_sym_insertelement] = ACTIONS(755),
    [anon_sym_select] = ACTIONS(755),
    [anon_sym_shufflevector] = ACTIONS(755),
    [anon_sym_fneg] = ACTIONS(755),
    [anon_sym_switch] = ACTIONS(755),
    [anon_sym_invoke] = ACTIONS(755),
    [anon_sym_cleanupret] = ACTIONS(755),
    [anon_sym_catchret] = ACTIONS(755),
    [anon_sym_catchswitch] = ACTIONS(755),
    [anon_sym_catchpad] = ACTIONS(755),
    [anon_sym_cleanuppad] = ACTIONS(755),
    [anon_sym_callbr] = ACTIONS(755),
    [anon_sym_icmp] = ACTIONS(755),
    [anon_sym_fcmp] = ACTIONS(755),
    [anon_sym_va_arg] = ACTIONS(755),
    [anon_sym_phi] = ACTIONS(755),
    [anon_sym_landingpad] = ACTIONS(755),
    [anon_sym_tail] = ACTIONS(755),
    [anon_sym_musttail] = ACTIONS(755),
    [anon_sym_notail] = ACTIONS(755),
    [anon_sym_call] = ACTIONS(755),
    [anon_sym_alloca] = ACTIONS(755),
    [anon_sym_load] = ACTIONS(755),
    [anon_sym_store] = ACTIONS(755),
    [anon_sym_cmpxchg] = ACTIONS(755),
    [anon_sym_atomicrmw] = ACTIONS(755),
    [anon_sym_fence] = ACTIONS(755),
    [anon_sym_getelementptr] = ACTIONS(755),
    [anon_sym_extractvalue] = ACTIONS(755),
    [anon_sym_insertvalue] = ACTIONS(755),
    [anon_sym_mul] = ACTIONS(755),
    [anon_sym_urem] = ACTIONS(755),
    [anon_sym_srem] = ACTIONS(755),
    [anon_sym_shl] = ACTIONS(755),
    [anon_sym_udiv] = ACTIONS(755),
    [anon_sym_sdiv] = ACTIONS(755),
    [anon_sym_lshr] = ACTIONS(755),
    [anon_sym_ashr] = ACTIONS(755),
    [anon_sym_fmul] = ACTIONS(755),
    [anon_sym_fdiv] = ACTIONS(755),
    [anon_sym_frem] = ACTIONS(755),
    [anon_sym_xchg] = ACTIONS(755),
    [anon_sym_add] = ACTIONS(755),
    [anon_sym_sub] = ACTIONS(755),
    [anon_sym_and] = ACTIONS(755),
    [anon_sym_nand] = ACTIONS(755),
    [anon_sym_or] = ACTIONS(755),
    [anon_sym_xor] = ACTIONS(755),
    [anon_sym_max] = ACTIONS(755),
    [anon_sym_min] = ACTIONS(755),
    [anon_sym_umax] = ACTIONS(755),
    [anon_sym_umin] = ACTIONS(755),
    [anon_sym_fadd] = ACTIONS(755),
    [anon_sym_fsub] = ACTIONS(755),
    [anon_sym_bitcast] = ACTIONS(755),
    [anon_sym_trunc] = ACTIONS(755),
    [anon_sym_zext] = ACTIONS(755),
    [anon_sym_sext] = ACTIONS(755),
    [anon_sym_fptrunc] = ACTIONS(755),
    [anon_sym_fpext] = ACTIONS(755),
    [anon_sym_addrspacecast] = ACTIONS(755),
    [anon_sym_uitofp] = ACTIONS(755),
    [anon_sym_sitofp] = ACTIONS(755),
    [anon_sym_fptoui] = ACTIONS(755),
    [anon_sym_fptosi] = ACTIONS(755),
    [anon_sym_inttoptr] = ACTIONS(755),
    [anon_sym_ptrtoint] = ACTIONS(755),
    [anon_sym_uselistorder] = ACTIONS(755),
  },
  [647] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2136),
    [sym_label] = ACTIONS(2136),
    [anon_sym_RBRACE] = ACTIONS(2136),
    [anon_sym_COMMA] = ACTIONS(2136),
    [anon_sym_unreachable] = ACTIONS(2138),
    [anon_sym_ret] = ACTIONS(2138),
    [anon_sym_br] = ACTIONS(2138),
    [anon_sym_resume] = ACTIONS(2138),
    [anon_sym_freeze] = ACTIONS(2138),
    [anon_sym_indirectbr] = ACTIONS(2138),
    [anon_sym_extractelement] = ACTIONS(2138),
    [anon_sym_insertelement] = ACTIONS(2138),
    [anon_sym_select] = ACTIONS(2138),
    [anon_sym_shufflevector] = ACTIONS(2138),
    [anon_sym_fneg] = ACTIONS(2138),
    [anon_sym_switch] = ACTIONS(2138),
    [anon_sym_invoke] = ACTIONS(2138),
    [anon_sym_cleanupret] = ACTIONS(2138),
    [anon_sym_catchret] = ACTIONS(2138),
    [anon_sym_catchswitch] = ACTIONS(2138),
    [anon_sym_catchpad] = ACTIONS(2138),
    [anon_sym_cleanuppad] = ACTIONS(2138),
    [anon_sym_callbr] = ACTIONS(2138),
    [anon_sym_icmp] = ACTIONS(2138),
    [anon_sym_fcmp] = ACTIONS(2138),
    [anon_sym_va_arg] = ACTIONS(2138),
    [anon_sym_phi] = ACTIONS(2138),
    [anon_sym_landingpad] = ACTIONS(2138),
    [anon_sym_tail] = ACTIONS(2138),
    [anon_sym_musttail] = ACTIONS(2138),
    [anon_sym_notail] = ACTIONS(2138),
    [anon_sym_call] = ACTIONS(2138),
    [anon_sym_alloca] = ACTIONS(2138),
    [anon_sym_load] = ACTIONS(2138),
    [anon_sym_store] = ACTIONS(2138),
    [anon_sym_cmpxchg] = ACTIONS(2138),
    [anon_sym_atomicrmw] = ACTIONS(2138),
    [anon_sym_fence] = ACTIONS(2138),
    [anon_sym_getelementptr] = ACTIONS(2138),
    [anon_sym_extractvalue] = ACTIONS(2138),
    [anon_sym_insertvalue] = ACTIONS(2138),
    [anon_sym_mul] = ACTIONS(2138),
    [anon_sym_urem] = ACTIONS(2138),
    [anon_sym_srem] = ACTIONS(2138),
    [anon_sym_shl] = ACTIONS(2138),
    [anon_sym_udiv] = ACTIONS(2138),
    [anon_sym_sdiv] = ACTIONS(2138),
    [anon_sym_lshr] = ACTIONS(2138),
    [anon_sym_ashr] = ACTIONS(2138),
    [anon_sym_fmul] = ACTIONS(2138),
    [anon_sym_fdiv] = ACTIONS(2138),
    [anon_sym_frem] = ACTIONS(2138),
    [anon_sym_xchg] = ACTIONS(2138),
    [anon_sym_add] = ACTIONS(2138),
    [anon_sym_sub] = ACTIONS(2138),
    [anon_sym_and] = ACTIONS(2138),
    [anon_sym_nand] = ACTIONS(2138),
    [anon_sym_or] = ACTIONS(2138),
    [anon_sym_xor] = ACTIONS(2138),
    [anon_sym_max] = ACTIONS(2138),
    [anon_sym_min] = ACTIONS(2138),
    [anon_sym_umax] = ACTIONS(2138),
    [anon_sym_umin] = ACTIONS(2138),
    [anon_sym_fadd] = ACTIONS(2138),
    [anon_sym_fsub] = ACTIONS(2138),
    [anon_sym_bitcast] = ACTIONS(2138),
    [anon_sym_trunc] = ACTIONS(2138),
    [anon_sym_zext] = ACTIONS(2138),
    [anon_sym_sext] = ACTIONS(2138),
    [anon_sym_fptrunc] = ACTIONS(2138),
    [anon_sym_fpext] = ACTIONS(2138),
    [anon_sym_addrspacecast] = ACTIONS(2138),
    [anon_sym_uitofp] = ACTIONS(2138),
    [anon_sym_sitofp] = ACTIONS(2138),
    [anon_sym_fptoui] = ACTIONS(2138),
    [anon_sym_fptosi] = ACTIONS(2138),
    [anon_sym_inttoptr] = ACTIONS(2138),
    [anon_sym_ptrtoint] = ACTIONS(2138),
    [anon_sym_uselistorder] = ACTIONS(2138),
  },
  [648] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2140),
    [sym_label] = ACTIONS(2140),
    [anon_sym_RBRACE] = ACTIONS(2140),
    [anon_sym_COMMA] = ACTIONS(2140),
    [anon_sym_unreachable] = ACTIONS(2142),
    [anon_sym_ret] = ACTIONS(2142),
    [anon_sym_br] = ACTIONS(2142),
    [anon_sym_resume] = ACTIONS(2142),
    [anon_sym_freeze] = ACTIONS(2142),
    [anon_sym_indirectbr] = ACTIONS(2142),
    [anon_sym_extractelement] = ACTIONS(2142),
    [anon_sym_insertelement] = ACTIONS(2142),
    [anon_sym_select] = ACTIONS(2142),
    [anon_sym_shufflevector] = ACTIONS(2142),
    [anon_sym_fneg] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_invoke] = ACTIONS(2142),
    [anon_sym_cleanupret] = ACTIONS(2142),
    [anon_sym_catchret] = ACTIONS(2142),
    [anon_sym_catchswitch] = ACTIONS(2142),
    [anon_sym_catchpad] = ACTIONS(2142),
    [anon_sym_cleanuppad] = ACTIONS(2142),
    [anon_sym_callbr] = ACTIONS(2142),
    [anon_sym_icmp] = ACTIONS(2142),
    [anon_sym_fcmp] = ACTIONS(2142),
    [anon_sym_va_arg] = ACTIONS(2142),
    [anon_sym_phi] = ACTIONS(2142),
    [anon_sym_landingpad] = ACTIONS(2142),
    [anon_sym_tail] = ACTIONS(2142),
    [anon_sym_musttail] = ACTIONS(2142),
    [anon_sym_notail] = ACTIONS(2142),
    [anon_sym_call] = ACTIONS(2142),
    [anon_sym_alloca] = ACTIONS(2142),
    [anon_sym_load] = ACTIONS(2142),
    [anon_sym_store] = ACTIONS(2142),
    [anon_sym_cmpxchg] = ACTIONS(2142),
    [anon_sym_atomicrmw] = ACTIONS(2142),
    [anon_sym_fence] = ACTIONS(2142),
    [anon_sym_getelementptr] = ACTIONS(2142),
    [anon_sym_extractvalue] = ACTIONS(2142),
    [anon_sym_insertvalue] = ACTIONS(2142),
    [anon_sym_mul] = ACTIONS(2142),
    [anon_sym_urem] = ACTIONS(2142),
    [anon_sym_srem] = ACTIONS(2142),
    [anon_sym_shl] = ACTIONS(2142),
    [anon_sym_udiv] = ACTIONS(2142),
    [anon_sym_sdiv] = ACTIONS(2142),
    [anon_sym_lshr] = ACTIONS(2142),
    [anon_sym_ashr] = ACTIONS(2142),
    [anon_sym_fmul] = ACTIONS(2142),
    [anon_sym_fdiv] = ACTIONS(2142),
    [anon_sym_frem] = ACTIONS(2142),
    [anon_sym_xchg] = ACTIONS(2142),
    [anon_sym_add] = ACTIONS(2142),
    [anon_sym_sub] = ACTIONS(2142),
    [anon_sym_and] = ACTIONS(2142),
    [anon_sym_nand] = ACTIONS(2142),
    [anon_sym_or] = ACTIONS(2142),
    [anon_sym_xor] = ACTIONS(2142),
    [anon_sym_max] = ACTIONS(2142),
    [anon_sym_min] = ACTIONS(2142),
    [anon_sym_umax] = ACTIONS(2142),
    [anon_sym_umin] = ACTIONS(2142),
    [anon_sym_fadd] = ACTIONS(2142),
    [anon_sym_fsub] = ACTIONS(2142),
    [anon_sym_bitcast] = ACTIONS(2142),
    [anon_sym_trunc] = ACTIONS(2142),
    [anon_sym_zext] = ACTIONS(2142),
    [anon_sym_sext] = ACTIONS(2142),
    [anon_sym_fptrunc] = ACTIONS(2142),
    [anon_sym_fpext] = ACTIONS(2142),
    [anon_sym_addrspacecast] = ACTIONS(2142),
    [anon_sym_uitofp] = ACTIONS(2142),
    [anon_sym_sitofp] = ACTIONS(2142),
    [anon_sym_fptoui] = ACTIONS(2142),
    [anon_sym_fptosi] = ACTIONS(2142),
    [anon_sym_inttoptr] = ACTIONS(2142),
    [anon_sym_ptrtoint] = ACTIONS(2142),
    [anon_sym_uselistorder] = ACTIONS(2142),
  },
  [649] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2144),
    [sym_label] = ACTIONS(2144),
    [anon_sym_RBRACE] = ACTIONS(2144),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_unreachable] = ACTIONS(2149),
    [anon_sym_ret] = ACTIONS(2149),
    [anon_sym_br] = ACTIONS(2149),
    [anon_sym_resume] = ACTIONS(2149),
    [anon_sym_freeze] = ACTIONS(2149),
    [anon_sym_indirectbr] = ACTIONS(2149),
    [anon_sym_extractelement] = ACTIONS(2149),
    [anon_sym_insertelement] = ACTIONS(2149),
    [anon_sym_select] = ACTIONS(2149),
    [anon_sym_shufflevector] = ACTIONS(2149),
    [anon_sym_fneg] = ACTIONS(2149),
    [anon_sym_switch] = ACTIONS(2149),
    [anon_sym_invoke] = ACTIONS(2149),
    [anon_sym_cleanupret] = ACTIONS(2149),
    [anon_sym_catchret] = ACTIONS(2149),
    [anon_sym_catchswitch] = ACTIONS(2149),
    [anon_sym_catchpad] = ACTIONS(2149),
    [anon_sym_cleanuppad] = ACTIONS(2149),
    [anon_sym_callbr] = ACTIONS(2149),
    [anon_sym_icmp] = ACTIONS(2149),
    [anon_sym_fcmp] = ACTIONS(2149),
    [anon_sym_va_arg] = ACTIONS(2149),
    [anon_sym_phi] = ACTIONS(2149),
    [anon_sym_landingpad] = ACTIONS(2149),
    [anon_sym_tail] = ACTIONS(2149),
    [anon_sym_musttail] = ACTIONS(2149),
    [anon_sym_notail] = ACTIONS(2149),
    [anon_sym_call] = ACTIONS(2149),
    [anon_sym_alloca] = ACTIONS(2149),
    [anon_sym_load] = ACTIONS(2149),
    [anon_sym_store] = ACTIONS(2149),
    [anon_sym_cmpxchg] = ACTIONS(2149),
    [anon_sym_atomicrmw] = ACTIONS(2149),
    [anon_sym_fence] = ACTIONS(2149),
    [anon_sym_getelementptr] = ACTIONS(2149),
    [anon_sym_extractvalue] = ACTIONS(2149),
    [anon_sym_insertvalue] = ACTIONS(2149),
    [anon_sym_mul] = ACTIONS(2149),
    [anon_sym_urem] = ACTIONS(2149),
    [anon_sym_srem] = ACTIONS(2149),
    [anon_sym_shl] = ACTIONS(2149),
    [anon_sym_udiv] = ACTIONS(2149),
    [anon_sym_sdiv] = ACTIONS(2149),
    [anon_sym_lshr] = ACTIONS(2149),
    [anon_sym_ashr] = ACTIONS(2149),
    [anon_sym_fmul] = ACTIONS(2149),
    [anon_sym_fdiv] = ACTIONS(2149),
    [anon_sym_frem] = ACTIONS(2149),
    [anon_sym_xchg] = ACTIONS(2149),
    [anon_sym_add] = ACTIONS(2149),
    [anon_sym_sub] = ACTIONS(2149),
    [anon_sym_and] = ACTIONS(2149),
    [anon_sym_nand] = ACTIONS(2149),
    [anon_sym_or] = ACTIONS(2149),
    [anon_sym_xor] = ACTIONS(2149),
    [anon_sym_max] = ACTIONS(2149),
    [anon_sym_min] = ACTIONS(2149),
    [anon_sym_umax] = ACTIONS(2149),
    [anon_sym_umin] = ACTIONS(2149),
    [anon_sym_fadd] = ACTIONS(2149),
    [anon_sym_fsub] = ACTIONS(2149),
    [anon_sym_bitcast] = ACTIONS(2149),
    [anon_sym_trunc] = ACTIONS(2149),
    [anon_sym_zext] = ACTIONS(2149),
    [anon_sym_sext] = ACTIONS(2149),
    [anon_sym_fptrunc] = ACTIONS(2149),
    [anon_sym_fpext] = ACTIONS(2149),
    [anon_sym_addrspacecast] = ACTIONS(2149),
    [anon_sym_uitofp] = ACTIONS(2149),
    [anon_sym_sitofp] = ACTIONS(2149),
    [anon_sym_fptoui] = ACTIONS(2149),
    [anon_sym_fptosi] = ACTIONS(2149),
    [anon_sym_inttoptr] = ACTIONS(2149),
    [anon_sym_ptrtoint] = ACTIONS(2149),
    [anon_sym_uselistorder] = ACTIONS(2149),
  },
  [650] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2151),
    [sym_label] = ACTIONS(2151),
    [anon_sym_RBRACE] = ACTIONS(2151),
    [anon_sym_COMMA] = ACTIONS(2151),
    [anon_sym_unreachable] = ACTIONS(2153),
    [anon_sym_ret] = ACTIONS(2153),
    [anon_sym_br] = ACTIONS(2153),
    [anon_sym_resume] = ACTIONS(2153),
    [anon_sym_freeze] = ACTIONS(2153),
    [anon_sym_indirectbr] = ACTIONS(2153),
    [anon_sym_extractelement] = ACTIONS(2153),
    [anon_sym_insertelement] = ACTIONS(2153),
    [anon_sym_select] = ACTIONS(2153),
    [anon_sym_shufflevector] = ACTIONS(2153),
    [anon_sym_fneg] = ACTIONS(2153),
    [anon_sym_switch] = ACTIONS(2153),
    [anon_sym_invoke] = ACTIONS(2153),
    [anon_sym_cleanupret] = ACTIONS(2153),
    [anon_sym_catchret] = ACTIONS(2153),
    [anon_sym_catchswitch] = ACTIONS(2153),
    [anon_sym_catchpad] = ACTIONS(2153),
    [anon_sym_cleanuppad] = ACTIONS(2153),
    [anon_sym_callbr] = ACTIONS(2153),
    [anon_sym_icmp] = ACTIONS(2153),
    [anon_sym_fcmp] = ACTIONS(2153),
    [anon_sym_va_arg] = ACTIONS(2153),
    [anon_sym_phi] = ACTIONS(2153),
    [anon_sym_landingpad] = ACTIONS(2153),
    [anon_sym_tail] = ACTIONS(2153),
    [anon_sym_musttail] = ACTIONS(2153),
    [anon_sym_notail] = ACTIONS(2153),
    [anon_sym_call] = ACTIONS(2153),
    [anon_sym_alloca] = ACTIONS(2153),
    [anon_sym_load] = ACTIONS(2153),
    [anon_sym_store] = ACTIONS(2153),
    [anon_sym_cmpxchg] = ACTIONS(2153),
    [anon_sym_atomicrmw] = ACTIONS(2153),
    [anon_sym_fence] = ACTIONS(2153),
    [anon_sym_getelementptr] = ACTIONS(2153),
    [anon_sym_extractvalue] = ACTIONS(2153),
    [anon_sym_insertvalue] = ACTIONS(2153),
    [anon_sym_mul] = ACTIONS(2153),
    [anon_sym_urem] = ACTIONS(2153),
    [anon_sym_srem] = ACTIONS(2153),
    [anon_sym_shl] = ACTIONS(2153),
    [anon_sym_udiv] = ACTIONS(2153),
    [anon_sym_sdiv] = ACTIONS(2153),
    [anon_sym_lshr] = ACTIONS(2153),
    [anon_sym_ashr] = ACTIONS(2153),
    [anon_sym_fmul] = ACTIONS(2153),
    [anon_sym_fdiv] = ACTIONS(2153),
    [anon_sym_frem] = ACTIONS(2153),
    [anon_sym_xchg] = ACTIONS(2153),
    [anon_sym_add] = ACTIONS(2153),
    [anon_sym_sub] = ACTIONS(2153),
    [anon_sym_and] = ACTIONS(2153),
    [anon_sym_nand] = ACTIONS(2153),
    [anon_sym_or] = ACTIONS(2153),
    [anon_sym_xor] = ACTIONS(2153),
    [anon_sym_max] = ACTIONS(2153),
    [anon_sym_min] = ACTIONS(2153),
    [anon_sym_umax] = ACTIONS(2153),
    [anon_sym_umin] = ACTIONS(2153),
    [anon_sym_fadd] = ACTIONS(2153),
    [anon_sym_fsub] = ACTIONS(2153),
    [anon_sym_bitcast] = ACTIONS(2153),
    [anon_sym_trunc] = ACTIONS(2153),
    [anon_sym_zext] = ACTIONS(2153),
    [anon_sym_sext] = ACTIONS(2153),
    [anon_sym_fptrunc] = ACTIONS(2153),
    [anon_sym_fpext] = ACTIONS(2153),
    [anon_sym_addrspacecast] = ACTIONS(2153),
    [anon_sym_uitofp] = ACTIONS(2153),
    [anon_sym_sitofp] = ACTIONS(2153),
    [anon_sym_fptoui] = ACTIONS(2153),
    [anon_sym_fptosi] = ACTIONS(2153),
    [anon_sym_inttoptr] = ACTIONS(2153),
    [anon_sym_ptrtoint] = ACTIONS(2153),
    [anon_sym_uselistorder] = ACTIONS(2153),
  },
  [651] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(1842),
    [sym_label] = ACTIONS(1842),
    [anon_sym_RBRACE] = ACTIONS(1842),
    [anon_sym_COMMA] = ACTIONS(1842),
    [anon_sym_unreachable] = ACTIONS(1847),
    [anon_sym_ret] = ACTIONS(1847),
    [anon_sym_br] = ACTIONS(1847),
    [anon_sym_resume] = ACTIONS(1847),
    [anon_sym_freeze] = ACTIONS(1847),
    [anon_sym_indirectbr] = ACTIONS(1847),
    [anon_sym_extractelement] = ACTIONS(1847),
    [anon_sym_insertelement] = ACTIONS(1847),
    [anon_sym_select] = ACTIONS(1847),
    [anon_sym_shufflevector] = ACTIONS(1847),
    [anon_sym_fneg] = ACTIONS(1847),
    [anon_sym_switch] = ACTIONS(1847),
    [anon_sym_invoke] = ACTIONS(1847),
    [anon_sym_cleanupret] = ACTIONS(1847),
    [anon_sym_catchret] = ACTIONS(1847),
    [anon_sym_catchswitch] = ACTIONS(1847),
    [anon_sym_catchpad] = ACTIONS(1847),
    [anon_sym_cleanuppad] = ACTIONS(1847),
    [anon_sym_callbr] = ACTIONS(1847),
    [anon_sym_icmp] = ACTIONS(1847),
    [anon_sym_fcmp] = ACTIONS(1847),
    [anon_sym_va_arg] = ACTIONS(1847),
    [anon_sym_phi] = ACTIONS(1847),
    [anon_sym_landingpad] = ACTIONS(1847),
    [anon_sym_tail] = ACTIONS(1847),
    [anon_sym_musttail] = ACTIONS(1847),
    [anon_sym_notail] = ACTIONS(1847),
    [anon_sym_call] = ACTIONS(1847),
    [anon_sym_alloca] = ACTIONS(1847),
    [anon_sym_load] = ACTIONS(1847),
    [anon_sym_store] = ACTIONS(1847),
    [anon_sym_cmpxchg] = ACTIONS(1847),
    [anon_sym_atomicrmw] = ACTIONS(1847),
    [anon_sym_fence] = ACTIONS(1847),
    [anon_sym_getelementptr] = ACTIONS(1847),
    [anon_sym_extractvalue] = ACTIONS(1847),
    [anon_sym_insertvalue] = ACTIONS(1847),
    [anon_sym_mul] = ACTIONS(1847),
    [anon_sym_urem] = ACTIONS(1847),
    [anon_sym_srem] = ACTIONS(1847),
    [anon_sym_shl] = ACTIONS(1847),
    [anon_sym_udiv] = ACTIONS(1847),
    [anon_sym_sdiv] = ACTIONS(1847),
    [anon_sym_lshr] = ACTIONS(1847),
    [anon_sym_ashr] = ACTIONS(1847),
    [anon_sym_fmul] = ACTIONS(1847),
    [anon_sym_fdiv] = ACTIONS(1847),
    [anon_sym_frem] = ACTIONS(1847),
    [anon_sym_xchg] = ACTIONS(1847),
    [anon_sym_add] = ACTIONS(1847),
    [anon_sym_sub] = ACTIONS(1847),
    [anon_sym_and] = ACTIONS(1847),
    [anon_sym_nand] = ACTIONS(1847),
    [anon_sym_or] = ACTIONS(1847),
    [anon_sym_xor] = ACTIONS(1847),
    [anon_sym_max] = ACTIONS(1847),
    [anon_sym_min] = ACTIONS(1847),
    [anon_sym_umax] = ACTIONS(1847),
    [anon_sym_umin] = ACTIONS(1847),
    [anon_sym_fadd] = ACTIONS(1847),
    [anon_sym_fsub] = ACTIONS(1847),
    [anon_sym_bitcast] = ACTIONS(1847),
    [anon_sym_trunc] = ACTIONS(1847),
    [anon_sym_zext] = ACTIONS(1847),
    [anon_sym_sext] = ACTIONS(1847),
    [anon_sym_fptrunc] = ACTIONS(1847),
    [anon_sym_fpext] = ACTIONS(1847),
    [anon_sym_addrspacecast] = ACTIONS(1847),
    [anon_sym_uitofp] = ACTIONS(1847),
    [anon_sym_sitofp] = ACTIONS(1847),
    [anon_sym_fptoui] = ACTIONS(1847),
    [anon_sym_fptosi] = ACTIONS(1847),
    [anon_sym_inttoptr] = ACTIONS(1847),
    [anon_sym_ptrtoint] = ACTIONS(1847),
    [anon_sym_uselistorder] = ACTIONS(1847),
  },
  [652] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2155),
    [sym_label] = ACTIONS(2155),
    [anon_sym_RBRACE] = ACTIONS(2155),
    [anon_sym_COMMA] = ACTIONS(2155),
    [anon_sym_unreachable] = ACTIONS(2157),
    [anon_sym_ret] = ACTIONS(2157),
    [anon_sym_br] = ACTIONS(2157),
    [anon_sym_resume] = ACTIONS(2157),
    [anon_sym_freeze] = ACTIONS(2157),
    [anon_sym_indirectbr] = ACTIONS(2157),
    [anon_sym_extractelement] = ACTIONS(2157),
    [anon_sym_insertelement] = ACTIONS(2157),
    [anon_sym_select] = ACTIONS(2157),
    [anon_sym_shufflevector] = ACTIONS(2157),
    [anon_sym_fneg] = ACTIONS(2157),
    [anon_sym_switch] = ACTIONS(2157),
    [anon_sym_invoke] = ACTIONS(2157),
    [anon_sym_cleanupret] = ACTIONS(2157),
    [anon_sym_catchret] = ACTIONS(2157),
    [anon_sym_catchswitch] = ACTIONS(2157),
    [anon_sym_catchpad] = ACTIONS(2157),
    [anon_sym_cleanuppad] = ACTIONS(2157),
    [anon_sym_callbr] = ACTIONS(2157),
    [anon_sym_icmp] = ACTIONS(2157),
    [anon_sym_fcmp] = ACTIONS(2157),
    [anon_sym_va_arg] = ACTIONS(2157),
    [anon_sym_phi] = ACTIONS(2157),
    [anon_sym_landingpad] = ACTIONS(2157),
    [anon_sym_tail] = ACTIONS(2157),
    [anon_sym_musttail] = ACTIONS(2157),
    [anon_sym_notail] = ACTIONS(2157),
    [anon_sym_call] = ACTIONS(2157),
    [anon_sym_alloca] = ACTIONS(2157),
    [anon_sym_load] = ACTIONS(2157),
    [anon_sym_store] = ACTIONS(2157),
    [anon_sym_cmpxchg] = ACTIONS(2157),
    [anon_sym_atomicrmw] = ACTIONS(2157),
    [anon_sym_fence] = ACTIONS(2157),
    [anon_sym_getelementptr] = ACTIONS(2157),
    [anon_sym_extractvalue] = ACTIONS(2157),
    [anon_sym_insertvalue] = ACTIONS(2157),
    [anon_sym_mul] = ACTIONS(2157),
    [anon_sym_urem] = ACTIONS(2157),
    [anon_sym_srem] = ACTIONS(2157),
    [anon_sym_shl] = ACTIONS(2157),
    [anon_sym_udiv] = ACTIONS(2157),
    [anon_sym_sdiv] = ACTIONS(2157),
    [anon_sym_lshr] = ACTIONS(2157),
    [anon_sym_ashr] = ACTIONS(2157),
    [anon_sym_fmul] = ACTIONS(2157),
    [anon_sym_fdiv] = ACTIONS(2157),
    [anon_sym_frem] = ACTIONS(2157),
    [anon_sym_xchg] = ACTIONS(2157),
    [anon_sym_add] = ACTIONS(2157),
    [anon_sym_sub] = ACTIONS(2157),
    [anon_sym_and] = ACTIONS(2157),
    [anon_sym_nand] = ACTIONS(2157),
    [anon_sym_or] = ACTIONS(2157),
    [anon_sym_xor] = ACTIONS(2157),
    [anon_sym_max] = ACTIONS(2157),
    [anon_sym_min] = ACTIONS(2157),
    [anon_sym_umax] = ACTIONS(2157),
    [anon_sym_umin] = ACTIONS(2157),
    [anon_sym_fadd] = ACTIONS(2157),
    [anon_sym_fsub] = ACTIONS(2157),
    [anon_sym_bitcast] = ACTIONS(2157),
    [anon_sym_trunc] = ACTIONS(2157),
    [anon_sym_zext] = ACTIONS(2157),
    [anon_sym_sext] = ACTIONS(2157),
    [anon_sym_fptrunc] = ACTIONS(2157),
    [anon_sym_fpext] = ACTIONS(2157),
    [anon_sym_addrspacecast] = ACTIONS(2157),
    [anon_sym_uitofp] = ACTIONS(2157),
    [anon_sym_sitofp] = ACTIONS(2157),
    [anon_sym_fptoui] = ACTIONS(2157),
    [anon_sym_fptosi] = ACTIONS(2157),
    [anon_sym_inttoptr] = ACTIONS(2157),
    [anon_sym_ptrtoint] = ACTIONS(2157),
    [anon_sym_uselistorder] = ACTIONS(2157),
  },
  [653] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2159),
    [sym_label] = ACTIONS(2159),
    [anon_sym_RBRACE] = ACTIONS(2159),
    [anon_sym_COMMA] = ACTIONS(2161),
    [anon_sym_unreachable] = ACTIONS(2164),
    [anon_sym_ret] = ACTIONS(2164),
    [anon_sym_br] = ACTIONS(2164),
    [anon_sym_resume] = ACTIONS(2164),
    [anon_sym_freeze] = ACTIONS(2164),
    [anon_sym_indirectbr] = ACTIONS(2164),
    [anon_sym_extractelement] = ACTIONS(2164),
    [anon_sym_insertelement] = ACTIONS(2164),
    [anon_sym_select] = ACTIONS(2164),
    [anon_sym_shufflevector] = ACTIONS(2164),
    [anon_sym_fneg] = ACTIONS(2164),
    [anon_sym_switch] = ACTIONS(2164),
    [anon_sym_invoke] = ACTIONS(2164),
    [anon_sym_cleanupret] = ACTIONS(2164),
    [anon_sym_catchret] = ACTIONS(2164),
    [anon_sym_catchswitch] = ACTIONS(2164),
    [anon_sym_catchpad] = ACTIONS(2164),
    [anon_sym_cleanuppad] = ACTIONS(2164),
    [anon_sym_callbr] = ACTIONS(2164),
    [anon_sym_icmp] = ACTIONS(2164),
    [anon_sym_fcmp] = ACTIONS(2164),
    [anon_sym_va_arg] = ACTIONS(2164),
    [anon_sym_phi] = ACTIONS(2164),
    [anon_sym_landingpad] = ACTIONS(2164),
    [anon_sym_tail] = ACTIONS(2164),
    [anon_sym_musttail] = ACTIONS(2164),
    [anon_sym_notail] = ACTIONS(2164),
    [anon_sym_call] = ACTIONS(2164),
    [anon_sym_alloca] = ACTIONS(2164),
    [anon_sym_load] = ACTIONS(2164),
    [anon_sym_store] = ACTIONS(2164),
    [anon_sym_cmpxchg] = ACTIONS(2164),
    [anon_sym_atomicrmw] = ACTIONS(2164),
    [anon_sym_fence] = ACTIONS(2164),
    [anon_sym_getelementptr] = ACTIONS(2164),
    [anon_sym_extractvalue] = ACTIONS(2164),
    [anon_sym_insertvalue] = ACTIONS(2164),
    [anon_sym_mul] = ACTIONS(2164),
    [anon_sym_urem] = ACTIONS(2164),
    [anon_sym_srem] = ACTIONS(2164),
    [anon_sym_shl] = ACTIONS(2164),
    [anon_sym_udiv] = ACTIONS(2164),
    [anon_sym_sdiv] = ACTIONS(2164),
    [anon_sym_lshr] = ACTIONS(2164),
    [anon_sym_ashr] = ACTIONS(2164),
    [anon_sym_fmul] = ACTIONS(2164),
    [anon_sym_fdiv] = ACTIONS(2164),
    [anon_sym_frem] = ACTIONS(2164),
    [anon_sym_xchg] = ACTIONS(2164),
    [anon_sym_add] = ACTIONS(2164),
    [anon_sym_sub] = ACTIONS(2164),
    [anon_sym_and] = ACTIONS(2164),
    [anon_sym_nand] = ACTIONS(2164),
    [anon_sym_or] = ACTIONS(2164),
    [anon_sym_xor] = ACTIONS(2164),
    [anon_sym_max] = ACTIONS(2164),
    [anon_sym_min] = ACTIONS(2164),
    [anon_sym_umax] = ACTIONS(2164),
    [anon_sym_umin] = ACTIONS(2164),
    [anon_sym_fadd] = ACTIONS(2164),
    [anon_sym_fsub] = ACTIONS(2164),
    [anon_sym_bitcast] = ACTIONS(2164),
    [anon_sym_trunc] = ACTIONS(2164),
    [anon_sym_zext] = ACTIONS(2164),
    [anon_sym_sext] = ACTIONS(2164),
    [anon_sym_fptrunc] = ACTIONS(2164),
    [anon_sym_fpext] = ACTIONS(2164),
    [anon_sym_addrspacecast] = ACTIONS(2164),
    [anon_sym_uitofp] = ACTIONS(2164),
    [anon_sym_sitofp] = ACTIONS(2164),
    [anon_sym_fptoui] = ACTIONS(2164),
    [anon_sym_fptosi] = ACTIONS(2164),
    [anon_sym_inttoptr] = ACTIONS(2164),
    [anon_sym_ptrtoint] = ACTIONS(2164),
    [anon_sym_uselistorder] = ACTIONS(2164),
  },
  [654] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2166),
    [sym_label] = ACTIONS(2166),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [anon_sym_COMMA] = ACTIONS(2166),
    [anon_sym_unreachable] = ACTIONS(2168),
    [anon_sym_ret] = ACTIONS(2168),
    [anon_sym_br] = ACTIONS(2168),
    [anon_sym_resume] = ACTIONS(2168),
    [anon_sym_freeze] = ACTIONS(2168),
    [anon_sym_indirectbr] = ACTIONS(2168),
    [anon_sym_extractelement] = ACTIONS(2168),
    [anon_sym_insertelement] = ACTIONS(2168),
    [anon_sym_select] = ACTIONS(2168),
    [anon_sym_shufflevector] = ACTIONS(2168),
    [anon_sym_fneg] = ACTIONS(2168),
    [anon_sym_switch] = ACTIONS(2168),
    [anon_sym_invoke] = ACTIONS(2168),
    [anon_sym_cleanupret] = ACTIONS(2168),
    [anon_sym_catchret] = ACTIONS(2168),
    [anon_sym_catchswitch] = ACTIONS(2168),
    [anon_sym_catchpad] = ACTIONS(2168),
    [anon_sym_cleanuppad] = ACTIONS(2168),
    [anon_sym_callbr] = ACTIONS(2168),
    [anon_sym_icmp] = ACTIONS(2168),
    [anon_sym_fcmp] = ACTIONS(2168),
    [anon_sym_va_arg] = ACTIONS(2168),
    [anon_sym_phi] = ACTIONS(2168),
    [anon_sym_landingpad] = ACTIONS(2168),
    [anon_sym_tail] = ACTIONS(2168),
    [anon_sym_musttail] = ACTIONS(2168),
    [anon_sym_notail] = ACTIONS(2168),
    [anon_sym_call] = ACTIONS(2168),
    [anon_sym_alloca] = ACTIONS(2168),
    [anon_sym_load] = ACTIONS(2168),
    [anon_sym_store] = ACTIONS(2168),
    [anon_sym_cmpxchg] = ACTIONS(2168),
    [anon_sym_atomicrmw] = ACTIONS(2168),
    [anon_sym_fence] = ACTIONS(2168),
    [anon_sym_getelementptr] = ACTIONS(2168),
    [anon_sym_extractvalue] = ACTIONS(2168),
    [anon_sym_insertvalue] = ACTIONS(2168),
    [anon_sym_mul] = ACTIONS(2168),
    [anon_sym_urem] = ACTIONS(2168),
    [anon_sym_srem] = ACTIONS(2168),
    [anon_sym_shl] = ACTIONS(2168),
    [anon_sym_udiv] = ACTIONS(2168),
    [anon_sym_sdiv] = ACTIONS(2168),
    [anon_sym_lshr] = ACTIONS(2168),
    [anon_sym_ashr] = ACTIONS(2168),
    [anon_sym_fmul] = ACTIONS(2168),
    [anon_sym_fdiv] = ACTIONS(2168),
    [anon_sym_frem] = ACTIONS(2168),
    [anon_sym_xchg] = ACTIONS(2168),
    [anon_sym_add] = ACTIONS(2168),
    [anon_sym_sub] = ACTIONS(2168),
    [anon_sym_and] = ACTIONS(2168),
    [anon_sym_nand] = ACTIONS(2168),
    [anon_sym_or] = ACTIONS(2168),
    [anon_sym_xor] = ACTIONS(2168),
    [anon_sym_max] = ACTIONS(2168),
    [anon_sym_min] = ACTIONS(2168),
    [anon_sym_umax] = ACTIONS(2168),
    [anon_sym_umin] = ACTIONS(2168),
    [anon_sym_fadd] = ACTIONS(2168),
    [anon_sym_fsub] = ACTIONS(2168),
    [anon_sym_bitcast] = ACTIONS(2168),
    [anon_sym_trunc] = ACTIONS(2168),
    [anon_sym_zext] = ACTIONS(2168),
    [anon_sym_sext] = ACTIONS(2168),
    [anon_sym_fptrunc] = ACTIONS(2168),
    [anon_sym_fpext] = ACTIONS(2168),
    [anon_sym_addrspacecast] = ACTIONS(2168),
    [anon_sym_uitofp] = ACTIONS(2168),
    [anon_sym_sitofp] = ACTIONS(2168),
    [anon_sym_fptoui] = ACTIONS(2168),
    [anon_sym_fptosi] = ACTIONS(2168),
    [anon_sym_inttoptr] = ACTIONS(2168),
    [anon_sym_ptrtoint] = ACTIONS(2168),
    [anon_sym_uselistorder] = ACTIONS(2168),
  },
  [655] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2170),
    [sym_label] = ACTIONS(2170),
    [anon_sym_RBRACE] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2172),
    [anon_sym_unreachable] = ACTIONS(2175),
    [anon_sym_ret] = ACTIONS(2175),
    [anon_sym_br] = ACTIONS(2175),
    [anon_sym_resume] = ACTIONS(2175),
    [anon_sym_freeze] = ACTIONS(2175),
    [anon_sym_indirectbr] = ACTIONS(2175),
    [anon_sym_extractelement] = ACTIONS(2175),
    [anon_sym_insertelement] = ACTIONS(2175),
    [anon_sym_select] = ACTIONS(2175),
    [anon_sym_shufflevector] = ACTIONS(2175),
    [anon_sym_fneg] = ACTIONS(2175),
    [anon_sym_switch] = ACTIONS(2175),
    [anon_sym_invoke] = ACTIONS(2175),
    [anon_sym_cleanupret] = ACTIONS(2175),
    [anon_sym_catchret] = ACTIONS(2175),
    [anon_sym_catchswitch] = ACTIONS(2175),
    [anon_sym_catchpad] = ACTIONS(2175),
    [anon_sym_cleanuppad] = ACTIONS(2175),
    [anon_sym_callbr] = ACTIONS(2175),
    [anon_sym_icmp] = ACTIONS(2175),
    [anon_sym_fcmp] = ACTIONS(2175),
    [anon_sym_va_arg] = ACTIONS(2175),
    [anon_sym_phi] = ACTIONS(2175),
    [anon_sym_landingpad] = ACTIONS(2175),
    [anon_sym_tail] = ACTIONS(2175),
    [anon_sym_musttail] = ACTIONS(2175),
    [anon_sym_notail] = ACTIONS(2175),
    [anon_sym_call] = ACTIONS(2175),
    [anon_sym_alloca] = ACTIONS(2175),
    [anon_sym_load] = ACTIONS(2175),
    [anon_sym_store] = ACTIONS(2175),
    [anon_sym_cmpxchg] = ACTIONS(2175),
    [anon_sym_atomicrmw] = ACTIONS(2175),
    [anon_sym_fence] = ACTIONS(2175),
    [anon_sym_getelementptr] = ACTIONS(2175),
    [anon_sym_extractvalue] = ACTIONS(2175),
    [anon_sym_insertvalue] = ACTIONS(2175),
    [anon_sym_mul] = ACTIONS(2175),
    [anon_sym_urem] = ACTIONS(2175),
    [anon_sym_srem] = ACTIONS(2175),
    [anon_sym_shl] = ACTIONS(2175),
    [anon_sym_udiv] = ACTIONS(2175),
    [anon_sym_sdiv] = ACTIONS(2175),
    [anon_sym_lshr] = ACTIONS(2175),
    [anon_sym_ashr] = ACTIONS(2175),
    [anon_sym_fmul] = ACTIONS(2175),
    [anon_sym_fdiv] = ACTIONS(2175),
    [anon_sym_frem] = ACTIONS(2175),
    [anon_sym_xchg] = ACTIONS(2175),
    [anon_sym_add] = ACTIONS(2175),
    [anon_sym_sub] = ACTIONS(2175),
    [anon_sym_and] = ACTIONS(2175),
    [anon_sym_nand] = ACTIONS(2175),
    [anon_sym_or] = ACTIONS(2175),
    [anon_sym_xor] = ACTIONS(2175),
    [anon_sym_max] = ACTIONS(2175),
    [anon_sym_min] = ACTIONS(2175),
    [anon_sym_umax] = ACTIONS(2175),
    [anon_sym_umin] = ACTIONS(2175),
    [anon_sym_fadd] = ACTIONS(2175),
    [anon_sym_fsub] = ACTIONS(2175),
    [anon_sym_bitcast] = ACTIONS(2175),
    [anon_sym_trunc] = ACTIONS(2175),
    [anon_sym_zext] = ACTIONS(2175),
    [anon_sym_sext] = ACTIONS(2175),
    [anon_sym_fptrunc] = ACTIONS(2175),
    [anon_sym_fpext] = ACTIONS(2175),
    [anon_sym_addrspacecast] = ACTIONS(2175),
    [anon_sym_uitofp] = ACTIONS(2175),
    [anon_sym_sitofp] = ACTIONS(2175),
    [anon_sym_fptoui] = ACTIONS(2175),
    [anon_sym_fptosi] = ACTIONS(2175),
    [anon_sym_inttoptr] = ACTIONS(2175),
    [anon_sym_ptrtoint] = ACTIONS(2175),
    [anon_sym_uselistorder] = ACTIONS(2175),
  },
  [656] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2177),
    [sym_label] = ACTIONS(2177),
    [anon_sym_RBRACE] = ACTIONS(2177),
    [anon_sym_COMMA] = ACTIONS(2177),
    [anon_sym_unreachable] = ACTIONS(2179),
    [anon_sym_ret] = ACTIONS(2179),
    [anon_sym_br] = ACTIONS(2179),
    [anon_sym_resume] = ACTIONS(2179),
    [anon_sym_freeze] = ACTIONS(2179),
    [anon_sym_indirectbr] = ACTIONS(2179),
    [anon_sym_extractelement] = ACTIONS(2179),
    [anon_sym_insertelement] = ACTIONS(2179),
    [anon_sym_select] = ACTIONS(2179),
    [anon_sym_shufflevector] = ACTIONS(2179),
    [anon_sym_fneg] = ACTIONS(2179),
    [anon_sym_switch] = ACTIONS(2179),
    [anon_sym_invoke] = ACTIONS(2179),
    [anon_sym_cleanupret] = ACTIONS(2179),
    [anon_sym_catchret] = ACTIONS(2179),
    [anon_sym_catchswitch] = ACTIONS(2179),
    [anon_sym_catchpad] = ACTIONS(2179),
    [anon_sym_cleanuppad] = ACTIONS(2179),
    [anon_sym_callbr] = ACTIONS(2179),
    [anon_sym_icmp] = ACTIONS(2179),
    [anon_sym_fcmp] = ACTIONS(2179),
    [anon_sym_va_arg] = ACTIONS(2179),
    [anon_sym_phi] = ACTIONS(2179),
    [anon_sym_landingpad] = ACTIONS(2179),
    [anon_sym_tail] = ACTIONS(2179),
    [anon_sym_musttail] = ACTIONS(2179),
    [anon_sym_notail] = ACTIONS(2179),
    [anon_sym_call] = ACTIONS(2179),
    [anon_sym_alloca] = ACTIONS(2179),
    [anon_sym_load] = ACTIONS(2179),
    [anon_sym_store] = ACTIONS(2179),
    [anon_sym_cmpxchg] = ACTIONS(2179),
    [anon_sym_atomicrmw] = ACTIONS(2179),
    [anon_sym_fence] = ACTIONS(2179),
    [anon_sym_getelementptr] = ACTIONS(2179),
    [anon_sym_extractvalue] = ACTIONS(2179),
    [anon_sym_insertvalue] = ACTIONS(2179),
    [anon_sym_mul] = ACTIONS(2179),
    [anon_sym_urem] = ACTIONS(2179),
    [anon_sym_srem] = ACTIONS(2179),
    [anon_sym_shl] = ACTIONS(2179),
    [anon_sym_udiv] = ACTIONS(2179),
    [anon_sym_sdiv] = ACTIONS(2179),
    [anon_sym_lshr] = ACTIONS(2179),
    [anon_sym_ashr] = ACTIONS(2179),
    [anon_sym_fmul] = ACTIONS(2179),
    [anon_sym_fdiv] = ACTIONS(2179),
    [anon_sym_frem] = ACTIONS(2179),
    [anon_sym_xchg] = ACTIONS(2179),
    [anon_sym_add] = ACTIONS(2179),
    [anon_sym_sub] = ACTIONS(2179),
    [anon_sym_and] = ACTIONS(2179),
    [anon_sym_nand] = ACTIONS(2179),
    [anon_sym_or] = ACTIONS(2179),
    [anon_sym_xor] = ACTIONS(2179),
    [anon_sym_max] = ACTIONS(2179),
    [anon_sym_min] = ACTIONS(2179),
    [anon_sym_umax] = ACTIONS(2179),
    [anon_sym_umin] = ACTIONS(2179),
    [anon_sym_fadd] = ACTIONS(2179),
    [anon_sym_fsub] = ACTIONS(2179),
    [anon_sym_bitcast] = ACTIONS(2179),
    [anon_sym_trunc] = ACTIONS(2179),
    [anon_sym_zext] = ACTIONS(2179),
    [anon_sym_sext] = ACTIONS(2179),
    [anon_sym_fptrunc] = ACTIONS(2179),
    [anon_sym_fpext] = ACTIONS(2179),
    [anon_sym_addrspacecast] = ACTIONS(2179),
    [anon_sym_uitofp] = ACTIONS(2179),
    [anon_sym_sitofp] = ACTIONS(2179),
    [anon_sym_fptoui] = ACTIONS(2179),
    [anon_sym_fptosi] = ACTIONS(2179),
    [anon_sym_inttoptr] = ACTIONS(2179),
    [anon_sym_ptrtoint] = ACTIONS(2179),
    [anon_sym_uselistorder] = ACTIONS(2179),
  },
  [657] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2181),
    [sym_label] = ACTIONS(2181),
    [anon_sym_RBRACE] = ACTIONS(2181),
    [anon_sym_COMMA] = ACTIONS(2181),
    [anon_sym_unreachable] = ACTIONS(2183),
    [anon_sym_ret] = ACTIONS(2183),
    [anon_sym_br] = ACTIONS(2183),
    [anon_sym_resume] = ACTIONS(2183),
    [anon_sym_freeze] = ACTIONS(2183),
    [anon_sym_indirectbr] = ACTIONS(2183),
    [anon_sym_extractelement] = ACTIONS(2183),
    [anon_sym_insertelement] = ACTIONS(2183),
    [anon_sym_select] = ACTIONS(2183),
    [anon_sym_shufflevector] = ACTIONS(2183),
    [anon_sym_fneg] = ACTIONS(2183),
    [anon_sym_switch] = ACTIONS(2183),
    [anon_sym_invoke] = ACTIONS(2183),
    [anon_sym_cleanupret] = ACTIONS(2183),
    [anon_sym_catchret] = ACTIONS(2183),
    [anon_sym_catchswitch] = ACTIONS(2183),
    [anon_sym_catchpad] = ACTIONS(2183),
    [anon_sym_cleanuppad] = ACTIONS(2183),
    [anon_sym_callbr] = ACTIONS(2183),
    [anon_sym_icmp] = ACTIONS(2183),
    [anon_sym_fcmp] = ACTIONS(2183),
    [anon_sym_va_arg] = ACTIONS(2183),
    [anon_sym_phi] = ACTIONS(2183),
    [anon_sym_landingpad] = ACTIONS(2183),
    [anon_sym_tail] = ACTIONS(2183),
    [anon_sym_musttail] = ACTIONS(2183),
    [anon_sym_notail] = ACTIONS(2183),
    [anon_sym_call] = ACTIONS(2183),
    [anon_sym_alloca] = ACTIONS(2183),
    [anon_sym_load] = ACTIONS(2183),
    [anon_sym_store] = ACTIONS(2183),
    [anon_sym_cmpxchg] = ACTIONS(2183),
    [anon_sym_atomicrmw] = ACTIONS(2183),
    [anon_sym_fence] = ACTIONS(2183),
    [anon_sym_getelementptr] = ACTIONS(2183),
    [anon_sym_extractvalue] = ACTIONS(2183),
    [anon_sym_insertvalue] = ACTIONS(2183),
    [anon_sym_mul] = ACTIONS(2183),
    [anon_sym_urem] = ACTIONS(2183),
    [anon_sym_srem] = ACTIONS(2183),
    [anon_sym_shl] = ACTIONS(2183),
    [anon_sym_udiv] = ACTIONS(2183),
    [anon_sym_sdiv] = ACTIONS(2183),
    [anon_sym_lshr] = ACTIONS(2183),
    [anon_sym_ashr] = ACTIONS(2183),
    [anon_sym_fmul] = ACTIONS(2183),
    [anon_sym_fdiv] = ACTIONS(2183),
    [anon_sym_frem] = ACTIONS(2183),
    [anon_sym_xchg] = ACTIONS(2183),
    [anon_sym_add] = ACTIONS(2183),
    [anon_sym_sub] = ACTIONS(2183),
    [anon_sym_and] = ACTIONS(2183),
    [anon_sym_nand] = ACTIONS(2183),
    [anon_sym_or] = ACTIONS(2183),
    [anon_sym_xor] = ACTIONS(2183),
    [anon_sym_max] = ACTIONS(2183),
    [anon_sym_min] = ACTIONS(2183),
    [anon_sym_umax] = ACTIONS(2183),
    [anon_sym_umin] = ACTIONS(2183),
    [anon_sym_fadd] = ACTIONS(2183),
    [anon_sym_fsub] = ACTIONS(2183),
    [anon_sym_bitcast] = ACTIONS(2183),
    [anon_sym_trunc] = ACTIONS(2183),
    [anon_sym_zext] = ACTIONS(2183),
    [anon_sym_sext] = ACTIONS(2183),
    [anon_sym_fptrunc] = ACTIONS(2183),
    [anon_sym_fpext] = ACTIONS(2183),
    [anon_sym_addrspacecast] = ACTIONS(2183),
    [anon_sym_uitofp] = ACTIONS(2183),
    [anon_sym_sitofp] = ACTIONS(2183),
    [anon_sym_fptoui] = ACTIONS(2183),
    [anon_sym_fptosi] = ACTIONS(2183),
    [anon_sym_inttoptr] = ACTIONS(2183),
    [anon_sym_ptrtoint] = ACTIONS(2183),
    [anon_sym_uselistorder] = ACTIONS(2183),
  },
  [658] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2185),
    [sym_label] = ACTIONS(2185),
    [anon_sym_RBRACE] = ACTIONS(2185),
    [anon_sym_COMMA] = ACTIONS(2185),
    [anon_sym_unreachable] = ACTIONS(2187),
    [anon_sym_ret] = ACTIONS(2187),
    [anon_sym_br] = ACTIONS(2187),
    [anon_sym_resume] = ACTIONS(2187),
    [anon_sym_freeze] = ACTIONS(2187),
    [anon_sym_indirectbr] = ACTIONS(2187),
    [anon_sym_extractelement] = ACTIONS(2187),
    [anon_sym_insertelement] = ACTIONS(2187),
    [anon_sym_select] = ACTIONS(2187),
    [anon_sym_shufflevector] = ACTIONS(2187),
    [anon_sym_fneg] = ACTIONS(2187),
    [anon_sym_switch] = ACTIONS(2187),
    [anon_sym_invoke] = ACTIONS(2187),
    [anon_sym_cleanupret] = ACTIONS(2187),
    [anon_sym_catchret] = ACTIONS(2187),
    [anon_sym_catchswitch] = ACTIONS(2187),
    [anon_sym_catchpad] = ACTIONS(2187),
    [anon_sym_cleanuppad] = ACTIONS(2187),
    [anon_sym_callbr] = ACTIONS(2187),
    [anon_sym_icmp] = ACTIONS(2187),
    [anon_sym_fcmp] = ACTIONS(2187),
    [anon_sym_va_arg] = ACTIONS(2187),
    [anon_sym_phi] = ACTIONS(2187),
    [anon_sym_landingpad] = ACTIONS(2187),
    [anon_sym_tail] = ACTIONS(2187),
    [anon_sym_musttail] = ACTIONS(2187),
    [anon_sym_notail] = ACTIONS(2187),
    [anon_sym_call] = ACTIONS(2187),
    [anon_sym_alloca] = ACTIONS(2187),
    [anon_sym_load] = ACTIONS(2187),
    [anon_sym_store] = ACTIONS(2187),
    [anon_sym_cmpxchg] = ACTIONS(2187),
    [anon_sym_atomicrmw] = ACTIONS(2187),
    [anon_sym_fence] = ACTIONS(2187),
    [anon_sym_getelementptr] = ACTIONS(2187),
    [anon_sym_extractvalue] = ACTIONS(2187),
    [anon_sym_insertvalue] = ACTIONS(2187),
    [anon_sym_mul] = ACTIONS(2187),
    [anon_sym_urem] = ACTIONS(2187),
    [anon_sym_srem] = ACTIONS(2187),
    [anon_sym_shl] = ACTIONS(2187),
    [anon_sym_udiv] = ACTIONS(2187),
    [anon_sym_sdiv] = ACTIONS(2187),
    [anon_sym_lshr] = ACTIONS(2187),
    [anon_sym_ashr] = ACTIONS(2187),
    [anon_sym_fmul] = ACTIONS(2187),
    [anon_sym_fdiv] = ACTIONS(2187),
    [anon_sym_frem] = ACTIONS(2187),
    [anon_sym_xchg] = ACTIONS(2187),
    [anon_sym_add] = ACTIONS(2187),
    [anon_sym_sub] = ACTIONS(2187),
    [anon_sym_and] = ACTIONS(2187),
    [anon_sym_nand] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2187),
    [anon_sym_xor] = ACTIONS(2187),
    [anon_sym_max] = ACTIONS(2187),
    [anon_sym_min] = ACTIONS(2187),
    [anon_sym_umax] = ACTIONS(2187),
    [anon_sym_umin] = ACTIONS(2187),
    [anon_sym_fadd] = ACTIONS(2187),
    [anon_sym_fsub] = ACTIONS(2187),
    [anon_sym_bitcast] = ACTIONS(2187),
    [anon_sym_trunc] = ACTIONS(2187),
    [anon_sym_zext] = ACTIONS(2187),
    [anon_sym_sext] = ACTIONS(2187),
    [anon_sym_fptrunc] = ACTIONS(2187),
    [anon_sym_fpext] = ACTIONS(2187),
    [anon_sym_addrspacecast] = ACTIONS(2187),
    [anon_sym_uitofp] = ACTIONS(2187),
    [anon_sym_sitofp] = ACTIONS(2187),
    [anon_sym_fptoui] = ACTIONS(2187),
    [anon_sym_fptosi] = ACTIONS(2187),
    [anon_sym_inttoptr] = ACTIONS(2187),
    [anon_sym_ptrtoint] = ACTIONS(2187),
    [anon_sym_uselistorder] = ACTIONS(2187),
  },
  [659] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2189),
    [sym_label] = ACTIONS(2189),
    [anon_sym_RBRACE] = ACTIONS(2189),
    [anon_sym_COMMA] = ACTIONS(2189),
    [anon_sym_unreachable] = ACTIONS(2191),
    [anon_sym_ret] = ACTIONS(2191),
    [anon_sym_br] = ACTIONS(2191),
    [anon_sym_resume] = ACTIONS(2191),
    [anon_sym_freeze] = ACTIONS(2191),
    [anon_sym_indirectbr] = ACTIONS(2191),
    [anon_sym_extractelement] = ACTIONS(2191),
    [anon_sym_insertelement] = ACTIONS(2191),
    [anon_sym_select] = ACTIONS(2191),
    [anon_sym_shufflevector] = ACTIONS(2191),
    [anon_sym_fneg] = ACTIONS(2191),
    [anon_sym_switch] = ACTIONS(2191),
    [anon_sym_invoke] = ACTIONS(2191),
    [anon_sym_cleanupret] = ACTIONS(2191),
    [anon_sym_catchret] = ACTIONS(2191),
    [anon_sym_catchswitch] = ACTIONS(2191),
    [anon_sym_catchpad] = ACTIONS(2191),
    [anon_sym_cleanuppad] = ACTIONS(2191),
    [anon_sym_callbr] = ACTIONS(2191),
    [anon_sym_icmp] = ACTIONS(2191),
    [anon_sym_fcmp] = ACTIONS(2191),
    [anon_sym_va_arg] = ACTIONS(2191),
    [anon_sym_phi] = ACTIONS(2191),
    [anon_sym_landingpad] = ACTIONS(2191),
    [anon_sym_tail] = ACTIONS(2191),
    [anon_sym_musttail] = ACTIONS(2191),
    [anon_sym_notail] = ACTIONS(2191),
    [anon_sym_call] = ACTIONS(2191),
    [anon_sym_alloca] = ACTIONS(2191),
    [anon_sym_load] = ACTIONS(2191),
    [anon_sym_store] = ACTIONS(2191),
    [anon_sym_cmpxchg] = ACTIONS(2191),
    [anon_sym_atomicrmw] = ACTIONS(2191),
    [anon_sym_fence] = ACTIONS(2191),
    [anon_sym_getelementptr] = ACTIONS(2191),
    [anon_sym_extractvalue] = ACTIONS(2191),
    [anon_sym_insertvalue] = ACTIONS(2191),
    [anon_sym_mul] = ACTIONS(2191),
    [anon_sym_urem] = ACTIONS(2191),
    [anon_sym_srem] = ACTIONS(2191),
    [anon_sym_shl] = ACTIONS(2191),
    [anon_sym_udiv] = ACTIONS(2191),
    [anon_sym_sdiv] = ACTIONS(2191),
    [anon_sym_lshr] = ACTIONS(2191),
    [anon_sym_ashr] = ACTIONS(2191),
    [anon_sym_fmul] = ACTIONS(2191),
    [anon_sym_fdiv] = ACTIONS(2191),
    [anon_sym_frem] = ACTIONS(2191),
    [anon_sym_xchg] = ACTIONS(2191),
    [anon_sym_add] = ACTIONS(2191),
    [anon_sym_sub] = ACTIONS(2191),
    [anon_sym_and] = ACTIONS(2191),
    [anon_sym_nand] = ACTIONS(2191),
    [anon_sym_or] = ACTIONS(2191),
    [anon_sym_xor] = ACTIONS(2191),
    [anon_sym_max] = ACTIONS(2191),
    [anon_sym_min] = ACTIONS(2191),
    [anon_sym_umax] = ACTIONS(2191),
    [anon_sym_umin] = ACTIONS(2191),
    [anon_sym_fadd] = ACTIONS(2191),
    [anon_sym_fsub] = ACTIONS(2191),
    [anon_sym_bitcast] = ACTIONS(2191),
    [anon_sym_trunc] = ACTIONS(2191),
    [anon_sym_zext] = ACTIONS(2191),
    [anon_sym_sext] = ACTIONS(2191),
    [anon_sym_fptrunc] = ACTIONS(2191),
    [anon_sym_fpext] = ACTIONS(2191),
    [anon_sym_addrspacecast] = ACTIONS(2191),
    [anon_sym_uitofp] = ACTIONS(2191),
    [anon_sym_sitofp] = ACTIONS(2191),
    [anon_sym_fptoui] = ACTIONS(2191),
    [anon_sym_fptosi] = ACTIONS(2191),
    [anon_sym_inttoptr] = ACTIONS(2191),
    [anon_sym_ptrtoint] = ACTIONS(2191),
    [anon_sym_uselistorder] = ACTIONS(2191),
  },
  [660] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2185),
    [sym_label] = ACTIONS(2185),
    [anon_sym_RBRACE] = ACTIONS(2185),
    [anon_sym_COMMA] = ACTIONS(2193),
    [anon_sym_unreachable] = ACTIONS(2187),
    [anon_sym_ret] = ACTIONS(2187),
    [anon_sym_br] = ACTIONS(2187),
    [anon_sym_resume] = ACTIONS(2187),
    [anon_sym_freeze] = ACTIONS(2187),
    [anon_sym_indirectbr] = ACTIONS(2187),
    [anon_sym_extractelement] = ACTIONS(2187),
    [anon_sym_insertelement] = ACTIONS(2187),
    [anon_sym_select] = ACTIONS(2187),
    [anon_sym_shufflevector] = ACTIONS(2187),
    [anon_sym_fneg] = ACTIONS(2187),
    [anon_sym_switch] = ACTIONS(2187),
    [anon_sym_invoke] = ACTIONS(2187),
    [anon_sym_cleanupret] = ACTIONS(2187),
    [anon_sym_catchret] = ACTIONS(2187),
    [anon_sym_catchswitch] = ACTIONS(2187),
    [anon_sym_catchpad] = ACTIONS(2187),
    [anon_sym_cleanuppad] = ACTIONS(2187),
    [anon_sym_callbr] = ACTIONS(2187),
    [anon_sym_icmp] = ACTIONS(2187),
    [anon_sym_fcmp] = ACTIONS(2187),
    [anon_sym_va_arg] = ACTIONS(2187),
    [anon_sym_phi] = ACTIONS(2187),
    [anon_sym_landingpad] = ACTIONS(2187),
    [anon_sym_tail] = ACTIONS(2187),
    [anon_sym_musttail] = ACTIONS(2187),
    [anon_sym_notail] = ACTIONS(2187),
    [anon_sym_call] = ACTIONS(2187),
    [anon_sym_alloca] = ACTIONS(2187),
    [anon_sym_load] = ACTIONS(2187),
    [anon_sym_store] = ACTIONS(2187),
    [anon_sym_cmpxchg] = ACTIONS(2187),
    [anon_sym_atomicrmw] = ACTIONS(2187),
    [anon_sym_fence] = ACTIONS(2187),
    [anon_sym_getelementptr] = ACTIONS(2187),
    [anon_sym_extractvalue] = ACTIONS(2187),
    [anon_sym_insertvalue] = ACTIONS(2187),
    [anon_sym_mul] = ACTIONS(2187),
    [anon_sym_urem] = ACTIONS(2187),
    [anon_sym_srem] = ACTIONS(2187),
    [anon_sym_shl] = ACTIONS(2187),
    [anon_sym_udiv] = ACTIONS(2187),
    [anon_sym_sdiv] = ACTIONS(2187),
    [anon_sym_lshr] = ACTIONS(2187),
    [anon_sym_ashr] = ACTIONS(2187),
    [anon_sym_fmul] = ACTIONS(2187),
    [anon_sym_fdiv] = ACTIONS(2187),
    [anon_sym_frem] = ACTIONS(2187),
    [anon_sym_xchg] = ACTIONS(2187),
    [anon_sym_add] = ACTIONS(2187),
    [anon_sym_sub] = ACTIONS(2187),
    [anon_sym_and] = ACTIONS(2187),
    [anon_sym_nand] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2187),
    [anon_sym_xor] = ACTIONS(2187),
    [anon_sym_max] = ACTIONS(2187),
    [anon_sym_min] = ACTIONS(2187),
    [anon_sym_umax] = ACTIONS(2187),
    [anon_sym_umin] = ACTIONS(2187),
    [anon_sym_fadd] = ACTIONS(2187),
    [anon_sym_fsub] = ACTIONS(2187),
    [anon_sym_bitcast] = ACTIONS(2187),
    [anon_sym_trunc] = ACTIONS(2187),
    [anon_sym_zext] = ACTIONS(2187),
    [anon_sym_sext] = ACTIONS(2187),
    [anon_sym_fptrunc] = ACTIONS(2187),
    [anon_sym_fpext] = ACTIONS(2187),
    [anon_sym_addrspacecast] = ACTIONS(2187),
    [anon_sym_uitofp] = ACTIONS(2187),
    [anon_sym_sitofp] = ACTIONS(2187),
    [anon_sym_fptoui] = ACTIONS(2187),
    [anon_sym_fptosi] = ACTIONS(2187),
    [anon_sym_inttoptr] = ACTIONS(2187),
    [anon_sym_ptrtoint] = ACTIONS(2187),
    [anon_sym_uselistorder] = ACTIONS(2187),
  },
  [661] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2196),
    [sym_label] = ACTIONS(2196),
    [anon_sym_RBRACE] = ACTIONS(2196),
    [anon_sym_COMMA] = ACTIONS(2196),
    [anon_sym_unreachable] = ACTIONS(2198),
    [anon_sym_ret] = ACTIONS(2198),
    [anon_sym_br] = ACTIONS(2198),
    [anon_sym_resume] = ACTIONS(2198),
    [anon_sym_freeze] = ACTIONS(2198),
    [anon_sym_indirectbr] = ACTIONS(2198),
    [anon_sym_extractelement] = ACTIONS(2198),
    [anon_sym_insertelement] = ACTIONS(2198),
    [anon_sym_select] = ACTIONS(2198),
    [anon_sym_shufflevector] = ACTIONS(2198),
    [anon_sym_fneg] = ACTIONS(2198),
    [anon_sym_switch] = ACTIONS(2198),
    [anon_sym_invoke] = ACTIONS(2198),
    [anon_sym_cleanupret] = ACTIONS(2198),
    [anon_sym_catchret] = ACTIONS(2198),
    [anon_sym_catchswitch] = ACTIONS(2198),
    [anon_sym_catchpad] = ACTIONS(2198),
    [anon_sym_cleanuppad] = ACTIONS(2198),
    [anon_sym_callbr] = ACTIONS(2198),
    [anon_sym_icmp] = ACTIONS(2198),
    [anon_sym_fcmp] = ACTIONS(2198),
    [anon_sym_va_arg] = ACTIONS(2198),
    [anon_sym_phi] = ACTIONS(2198),
    [anon_sym_landingpad] = ACTIONS(2198),
    [anon_sym_tail] = ACTIONS(2198),
    [anon_sym_musttail] = ACTIONS(2198),
    [anon_sym_notail] = ACTIONS(2198),
    [anon_sym_call] = ACTIONS(2198),
    [anon_sym_alloca] = ACTIONS(2198),
    [anon_sym_load] = ACTIONS(2198),
    [anon_sym_store] = ACTIONS(2198),
    [anon_sym_cmpxchg] = ACTIONS(2198),
    [anon_sym_atomicrmw] = ACTIONS(2198),
    [anon_sym_fence] = ACTIONS(2198),
    [anon_sym_getelementptr] = ACTIONS(2198),
    [anon_sym_extractvalue] = ACTIONS(2198),
    [anon_sym_insertvalue] = ACTIONS(2198),
    [anon_sym_mul] = ACTIONS(2198),
    [anon_sym_urem] = ACTIONS(2198),
    [anon_sym_srem] = ACTIONS(2198),
    [anon_sym_shl] = ACTIONS(2198),
    [anon_sym_udiv] = ACTIONS(2198),
    [anon_sym_sdiv] = ACTIONS(2198),
    [anon_sym_lshr] = ACTIONS(2198),
    [anon_sym_ashr] = ACTIONS(2198),
    [anon_sym_fmul] = ACTIONS(2198),
    [anon_sym_fdiv] = ACTIONS(2198),
    [anon_sym_frem] = ACTIONS(2198),
    [anon_sym_xchg] = ACTIONS(2198),
    [anon_sym_add] = ACTIONS(2198),
    [anon_sym_sub] = ACTIONS(2198),
    [anon_sym_and] = ACTIONS(2198),
    [anon_sym_nand] = ACTIONS(2198),
    [anon_sym_or] = ACTIONS(2198),
    [anon_sym_xor] = ACTIONS(2198),
    [anon_sym_max] = ACTIONS(2198),
    [anon_sym_min] = ACTIONS(2198),
    [anon_sym_umax] = ACTIONS(2198),
    [anon_sym_umin] = ACTIONS(2198),
    [anon_sym_fadd] = ACTIONS(2198),
    [anon_sym_fsub] = ACTIONS(2198),
    [anon_sym_bitcast] = ACTIONS(2198),
    [anon_sym_trunc] = ACTIONS(2198),
    [anon_sym_zext] = ACTIONS(2198),
    [anon_sym_sext] = ACTIONS(2198),
    [anon_sym_fptrunc] = ACTIONS(2198),
    [anon_sym_fpext] = ACTIONS(2198),
    [anon_sym_addrspacecast] = ACTIONS(2198),
    [anon_sym_uitofp] = ACTIONS(2198),
    [anon_sym_sitofp] = ACTIONS(2198),
    [anon_sym_fptoui] = ACTIONS(2198),
    [anon_sym_fptosi] = ACTIONS(2198),
    [anon_sym_inttoptr] = ACTIONS(2198),
    [anon_sym_ptrtoint] = ACTIONS(2198),
    [anon_sym_uselistorder] = ACTIONS(2198),
  },
  [662] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2200),
    [sym_label] = ACTIONS(2200),
    [anon_sym_RBRACE] = ACTIONS(2200),
    [anon_sym_COMMA] = ACTIONS(2200),
    [anon_sym_unreachable] = ACTIONS(2202),
    [anon_sym_ret] = ACTIONS(2202),
    [anon_sym_br] = ACTIONS(2202),
    [anon_sym_resume] = ACTIONS(2202),
    [anon_sym_freeze] = ACTIONS(2202),
    [anon_sym_indirectbr] = ACTIONS(2202),
    [anon_sym_extractelement] = ACTIONS(2202),
    [anon_sym_insertelement] = ACTIONS(2202),
    [anon_sym_select] = ACTIONS(2202),
    [anon_sym_shufflevector] = ACTIONS(2202),
    [anon_sym_fneg] = ACTIONS(2202),
    [anon_sym_switch] = ACTIONS(2202),
    [anon_sym_invoke] = ACTIONS(2202),
    [anon_sym_cleanupret] = ACTIONS(2202),
    [anon_sym_catchret] = ACTIONS(2202),
    [anon_sym_catchswitch] = ACTIONS(2202),
    [anon_sym_catchpad] = ACTIONS(2202),
    [anon_sym_cleanuppad] = ACTIONS(2202),
    [anon_sym_callbr] = ACTIONS(2202),
    [anon_sym_icmp] = ACTIONS(2202),
    [anon_sym_fcmp] = ACTIONS(2202),
    [anon_sym_va_arg] = ACTIONS(2202),
    [anon_sym_phi] = ACTIONS(2202),
    [anon_sym_landingpad] = ACTIONS(2202),
    [anon_sym_tail] = ACTIONS(2202),
    [anon_sym_musttail] = ACTIONS(2202),
    [anon_sym_notail] = ACTIONS(2202),
    [anon_sym_call] = ACTIONS(2202),
    [anon_sym_alloca] = ACTIONS(2202),
    [anon_sym_load] = ACTIONS(2202),
    [anon_sym_store] = ACTIONS(2202),
    [anon_sym_cmpxchg] = ACTIONS(2202),
    [anon_sym_atomicrmw] = ACTIONS(2202),
    [anon_sym_fence] = ACTIONS(2202),
    [anon_sym_getelementptr] = ACTIONS(2202),
    [anon_sym_extractvalue] = ACTIONS(2202),
    [anon_sym_insertvalue] = ACTIONS(2202),
    [anon_sym_mul] = ACTIONS(2202),
    [anon_sym_urem] = ACTIONS(2202),
    [anon_sym_srem] = ACTIONS(2202),
    [anon_sym_shl] = ACTIONS(2202),
    [anon_sym_udiv] = ACTIONS(2202),
    [anon_sym_sdiv] = ACTIONS(2202),
    [anon_sym_lshr] = ACTIONS(2202),
    [anon_sym_ashr] = ACTIONS(2202),
    [anon_sym_fmul] = ACTIONS(2202),
    [anon_sym_fdiv] = ACTIONS(2202),
    [anon_sym_frem] = ACTIONS(2202),
    [anon_sym_xchg] = ACTIONS(2202),
    [anon_sym_add] = ACTIONS(2202),
    [anon_sym_sub] = ACTIONS(2202),
    [anon_sym_and] = ACTIONS(2202),
    [anon_sym_nand] = ACTIONS(2202),
    [anon_sym_or] = ACTIONS(2202),
    [anon_sym_xor] = ACTIONS(2202),
    [anon_sym_max] = ACTIONS(2202),
    [anon_sym_min] = ACTIONS(2202),
    [anon_sym_umax] = ACTIONS(2202),
    [anon_sym_umin] = ACTIONS(2202),
    [anon_sym_fadd] = ACTIONS(2202),
    [anon_sym_fsub] = ACTIONS(2202),
    [anon_sym_bitcast] = ACTIONS(2202),
    [anon_sym_trunc] = ACTIONS(2202),
    [anon_sym_zext] = ACTIONS(2202),
    [anon_sym_sext] = ACTIONS(2202),
    [anon_sym_fptrunc] = ACTIONS(2202),
    [anon_sym_fpext] = ACTIONS(2202),
    [anon_sym_addrspacecast] = ACTIONS(2202),
    [anon_sym_uitofp] = ACTIONS(2202),
    [anon_sym_sitofp] = ACTIONS(2202),
    [anon_sym_fptoui] = ACTIONS(2202),
    [anon_sym_fptosi] = ACTIONS(2202),
    [anon_sym_inttoptr] = ACTIONS(2202),
    [anon_sym_ptrtoint] = ACTIONS(2202),
    [anon_sym_uselistorder] = ACTIONS(2202),
  },
  [663] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2204),
    [sym_label] = ACTIONS(2204),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_unreachable] = ACTIONS(2206),
    [anon_sym_ret] = ACTIONS(2206),
    [anon_sym_br] = ACTIONS(2206),
    [anon_sym_resume] = ACTIONS(2206),
    [anon_sym_freeze] = ACTIONS(2206),
    [anon_sym_indirectbr] = ACTIONS(2206),
    [anon_sym_extractelement] = ACTIONS(2206),
    [anon_sym_insertelement] = ACTIONS(2206),
    [anon_sym_select] = ACTIONS(2206),
    [anon_sym_shufflevector] = ACTIONS(2206),
    [anon_sym_fneg] = ACTIONS(2206),
    [anon_sym_switch] = ACTIONS(2206),
    [anon_sym_invoke] = ACTIONS(2206),
    [anon_sym_cleanupret] = ACTIONS(2206),
    [anon_sym_catchret] = ACTIONS(2206),
    [anon_sym_catchswitch] = ACTIONS(2206),
    [anon_sym_catchpad] = ACTIONS(2206),
    [anon_sym_cleanuppad] = ACTIONS(2206),
    [anon_sym_callbr] = ACTIONS(2206),
    [anon_sym_icmp] = ACTIONS(2206),
    [anon_sym_fcmp] = ACTIONS(2206),
    [anon_sym_va_arg] = ACTIONS(2206),
    [anon_sym_phi] = ACTIONS(2206),
    [anon_sym_landingpad] = ACTIONS(2206),
    [anon_sym_tail] = ACTIONS(2206),
    [anon_sym_musttail] = ACTIONS(2206),
    [anon_sym_notail] = ACTIONS(2206),
    [anon_sym_call] = ACTIONS(2206),
    [anon_sym_alloca] = ACTIONS(2206),
    [anon_sym_load] = ACTIONS(2206),
    [anon_sym_store] = ACTIONS(2206),
    [anon_sym_cmpxchg] = ACTIONS(2206),
    [anon_sym_atomicrmw] = ACTIONS(2206),
    [anon_sym_fence] = ACTIONS(2206),
    [anon_sym_getelementptr] = ACTIONS(2206),
    [anon_sym_extractvalue] = ACTIONS(2206),
    [anon_sym_insertvalue] = ACTIONS(2206),
    [anon_sym_mul] = ACTIONS(2206),
    [anon_sym_urem] = ACTIONS(2206),
    [anon_sym_srem] = ACTIONS(2206),
    [anon_sym_shl] = ACTIONS(2206),
    [anon_sym_udiv] = ACTIONS(2206),
    [anon_sym_sdiv] = ACTIONS(2206),
    [anon_sym_lshr] = ACTIONS(2206),
    [anon_sym_ashr] = ACTIONS(2206),
    [anon_sym_fmul] = ACTIONS(2206),
    [anon_sym_fdiv] = ACTIONS(2206),
    [anon_sym_frem] = ACTIONS(2206),
    [anon_sym_xchg] = ACTIONS(2206),
    [anon_sym_add] = ACTIONS(2206),
    [anon_sym_sub] = ACTIONS(2206),
    [anon_sym_and] = ACTIONS(2206),
    [anon_sym_nand] = ACTIONS(2206),
    [anon_sym_or] = ACTIONS(2206),
    [anon_sym_xor] = ACTIONS(2206),
    [anon_sym_max] = ACTIONS(2206),
    [anon_sym_min] = ACTIONS(2206),
    [anon_sym_umax] = ACTIONS(2206),
    [anon_sym_umin] = ACTIONS(2206),
    [anon_sym_fadd] = ACTIONS(2206),
    [anon_sym_fsub] = ACTIONS(2206),
    [anon_sym_bitcast] = ACTIONS(2206),
    [anon_sym_trunc] = ACTIONS(2206),
    [anon_sym_zext] = ACTIONS(2206),
    [anon_sym_sext] = ACTIONS(2206),
    [anon_sym_fptrunc] = ACTIONS(2206),
    [anon_sym_fpext] = ACTIONS(2206),
    [anon_sym_addrspacecast] = ACTIONS(2206),
    [anon_sym_uitofp] = ACTIONS(2206),
    [anon_sym_sitofp] = ACTIONS(2206),
    [anon_sym_fptoui] = ACTIONS(2206),
    [anon_sym_fptosi] = ACTIONS(2206),
    [anon_sym_inttoptr] = ACTIONS(2206),
    [anon_sym_ptrtoint] = ACTIONS(2206),
    [anon_sym_uselistorder] = ACTIONS(2206),
  },
  [664] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2204),
    [sym_label] = ACTIONS(2204),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2208),
    [anon_sym_unreachable] = ACTIONS(2206),
    [anon_sym_ret] = ACTIONS(2206),
    [anon_sym_br] = ACTIONS(2206),
    [anon_sym_resume] = ACTIONS(2206),
    [anon_sym_freeze] = ACTIONS(2206),
    [anon_sym_indirectbr] = ACTIONS(2206),
    [anon_sym_extractelement] = ACTIONS(2206),
    [anon_sym_insertelement] = ACTIONS(2206),
    [anon_sym_select] = ACTIONS(2206),
    [anon_sym_shufflevector] = ACTIONS(2206),
    [anon_sym_fneg] = ACTIONS(2206),
    [anon_sym_switch] = ACTIONS(2206),
    [anon_sym_invoke] = ACTIONS(2206),
    [anon_sym_cleanupret] = ACTIONS(2206),
    [anon_sym_catchret] = ACTIONS(2206),
    [anon_sym_catchswitch] = ACTIONS(2206),
    [anon_sym_catchpad] = ACTIONS(2206),
    [anon_sym_cleanuppad] = ACTIONS(2206),
    [anon_sym_callbr] = ACTIONS(2206),
    [anon_sym_icmp] = ACTIONS(2206),
    [anon_sym_fcmp] = ACTIONS(2206),
    [anon_sym_va_arg] = ACTIONS(2206),
    [anon_sym_phi] = ACTIONS(2206),
    [anon_sym_landingpad] = ACTIONS(2206),
    [anon_sym_tail] = ACTIONS(2206),
    [anon_sym_musttail] = ACTIONS(2206),
    [anon_sym_notail] = ACTIONS(2206),
    [anon_sym_call] = ACTIONS(2206),
    [anon_sym_alloca] = ACTIONS(2206),
    [anon_sym_load] = ACTIONS(2206),
    [anon_sym_store] = ACTIONS(2206),
    [anon_sym_cmpxchg] = ACTIONS(2206),
    [anon_sym_atomicrmw] = ACTIONS(2206),
    [anon_sym_fence] = ACTIONS(2206),
    [anon_sym_getelementptr] = ACTIONS(2206),
    [anon_sym_extractvalue] = ACTIONS(2206),
    [anon_sym_insertvalue] = ACTIONS(2206),
    [anon_sym_mul] = ACTIONS(2206),
    [anon_sym_urem] = ACTIONS(2206),
    [anon_sym_srem] = ACTIONS(2206),
    [anon_sym_shl] = ACTIONS(2206),
    [anon_sym_udiv] = ACTIONS(2206),
    [anon_sym_sdiv] = ACTIONS(2206),
    [anon_sym_lshr] = ACTIONS(2206),
    [anon_sym_ashr] = ACTIONS(2206),
    [anon_sym_fmul] = ACTIONS(2206),
    [anon_sym_fdiv] = ACTIONS(2206),
    [anon_sym_frem] = ACTIONS(2206),
    [anon_sym_xchg] = ACTIONS(2206),
    [anon_sym_add] = ACTIONS(2206),
    [anon_sym_sub] = ACTIONS(2206),
    [anon_sym_and] = ACTIONS(2206),
    [anon_sym_nand] = ACTIONS(2206),
    [anon_sym_or] = ACTIONS(2206),
    [anon_sym_xor] = ACTIONS(2206),
    [anon_sym_max] = ACTIONS(2206),
    [anon_sym_min] = ACTIONS(2206),
    [anon_sym_umax] = ACTIONS(2206),
    [anon_sym_umin] = ACTIONS(2206),
    [anon_sym_fadd] = ACTIONS(2206),
    [anon_sym_fsub] = ACTIONS(2206),
    [anon_sym_bitcast] = ACTIONS(2206),
    [anon_sym_trunc] = ACTIONS(2206),
    [anon_sym_zext] = ACTIONS(2206),
    [anon_sym_sext] = ACTIONS(2206),
    [anon_sym_fptrunc] = ACTIONS(2206),
    [anon_sym_fpext] = ACTIONS(2206),
    [anon_sym_addrspacecast] = ACTIONS(2206),
    [anon_sym_uitofp] = ACTIONS(2206),
    [anon_sym_sitofp] = ACTIONS(2206),
    [anon_sym_fptoui] = ACTIONS(2206),
    [anon_sym_fptosi] = ACTIONS(2206),
    [anon_sym_inttoptr] = ACTIONS(2206),
    [anon_sym_ptrtoint] = ACTIONS(2206),
    [anon_sym_uselistorder] = ACTIONS(2206),
  },
  [665] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2211),
    [sym_label] = ACTIONS(2211),
    [anon_sym_RBRACE] = ACTIONS(2211),
    [anon_sym_COMMA] = ACTIONS(2211),
    [anon_sym_unreachable] = ACTIONS(2213),
    [anon_sym_ret] = ACTIONS(2213),
    [anon_sym_br] = ACTIONS(2213),
    [anon_sym_resume] = ACTIONS(2213),
    [anon_sym_freeze] = ACTIONS(2213),
    [anon_sym_indirectbr] = ACTIONS(2213),
    [anon_sym_extractelement] = ACTIONS(2213),
    [anon_sym_insertelement] = ACTIONS(2213),
    [anon_sym_select] = ACTIONS(2213),
    [anon_sym_shufflevector] = ACTIONS(2213),
    [anon_sym_fneg] = ACTIONS(2213),
    [anon_sym_switch] = ACTIONS(2213),
    [anon_sym_invoke] = ACTIONS(2213),
    [anon_sym_cleanupret] = ACTIONS(2213),
    [anon_sym_catchret] = ACTIONS(2213),
    [anon_sym_catchswitch] = ACTIONS(2213),
    [anon_sym_catchpad] = ACTIONS(2213),
    [anon_sym_cleanuppad] = ACTIONS(2213),
    [anon_sym_callbr] = ACTIONS(2213),
    [anon_sym_icmp] = ACTIONS(2213),
    [anon_sym_fcmp] = ACTIONS(2213),
    [anon_sym_va_arg] = ACTIONS(2213),
    [anon_sym_phi] = ACTIONS(2213),
    [anon_sym_landingpad] = ACTIONS(2213),
    [anon_sym_tail] = ACTIONS(2213),
    [anon_sym_musttail] = ACTIONS(2213),
    [anon_sym_notail] = ACTIONS(2213),
    [anon_sym_call] = ACTIONS(2213),
    [anon_sym_alloca] = ACTIONS(2213),
    [anon_sym_load] = ACTIONS(2213),
    [anon_sym_store] = ACTIONS(2213),
    [anon_sym_cmpxchg] = ACTIONS(2213),
    [anon_sym_atomicrmw] = ACTIONS(2213),
    [anon_sym_fence] = ACTIONS(2213),
    [anon_sym_getelementptr] = ACTIONS(2213),
    [anon_sym_extractvalue] = ACTIONS(2213),
    [anon_sym_insertvalue] = ACTIONS(2213),
    [anon_sym_mul] = ACTIONS(2213),
    [anon_sym_urem] = ACTIONS(2213),
    [anon_sym_srem] = ACTIONS(2213),
    [anon_sym_shl] = ACTIONS(2213),
    [anon_sym_udiv] = ACTIONS(2213),
    [anon_sym_sdiv] = ACTIONS(2213),
    [anon_sym_lshr] = ACTIONS(2213),
    [anon_sym_ashr] = ACTIONS(2213),
    [anon_sym_fmul] = ACTIONS(2213),
    [anon_sym_fdiv] = ACTIONS(2213),
    [anon_sym_frem] = ACTIONS(2213),
    [anon_sym_xchg] = ACTIONS(2213),
    [anon_sym_add] = ACTIONS(2213),
    [anon_sym_sub] = ACTIONS(2213),
    [anon_sym_and] = ACTIONS(2213),
    [anon_sym_nand] = ACTIONS(2213),
    [anon_sym_or] = ACTIONS(2213),
    [anon_sym_xor] = ACTIONS(2213),
    [anon_sym_max] = ACTIONS(2213),
    [anon_sym_min] = ACTIONS(2213),
    [anon_sym_umax] = ACTIONS(2213),
    [anon_sym_umin] = ACTIONS(2213),
    [anon_sym_fadd] = ACTIONS(2213),
    [anon_sym_fsub] = ACTIONS(2213),
    [anon_sym_bitcast] = ACTIONS(2213),
    [anon_sym_trunc] = ACTIONS(2213),
    [anon_sym_zext] = ACTIONS(2213),
    [anon_sym_sext] = ACTIONS(2213),
    [anon_sym_fptrunc] = ACTIONS(2213),
    [anon_sym_fpext] = ACTIONS(2213),
    [anon_sym_addrspacecast] = ACTIONS(2213),
    [anon_sym_uitofp] = ACTIONS(2213),
    [anon_sym_sitofp] = ACTIONS(2213),
    [anon_sym_fptoui] = ACTIONS(2213),
    [anon_sym_fptosi] = ACTIONS(2213),
    [anon_sym_inttoptr] = ACTIONS(2213),
    [anon_sym_ptrtoint] = ACTIONS(2213),
    [anon_sym_uselistorder] = ACTIONS(2213),
  },
  [666] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2215),
    [sym_label] = ACTIONS(2215),
    [anon_sym_RBRACE] = ACTIONS(2215),
    [anon_sym_COMMA] = ACTIONS(2215),
    [anon_sym_unreachable] = ACTIONS(2217),
    [anon_sym_ret] = ACTIONS(2217),
    [anon_sym_br] = ACTIONS(2217),
    [anon_sym_resume] = ACTIONS(2217),
    [anon_sym_freeze] = ACTIONS(2217),
    [anon_sym_indirectbr] = ACTIONS(2217),
    [anon_sym_extractelement] = ACTIONS(2217),
    [anon_sym_insertelement] = ACTIONS(2217),
    [anon_sym_select] = ACTIONS(2217),
    [anon_sym_shufflevector] = ACTIONS(2217),
    [anon_sym_fneg] = ACTIONS(2217),
    [anon_sym_switch] = ACTIONS(2217),
    [anon_sym_invoke] = ACTIONS(2217),
    [anon_sym_cleanupret] = ACTIONS(2217),
    [anon_sym_catchret] = ACTIONS(2217),
    [anon_sym_catchswitch] = ACTIONS(2217),
    [anon_sym_catchpad] = ACTIONS(2217),
    [anon_sym_cleanuppad] = ACTIONS(2217),
    [anon_sym_callbr] = ACTIONS(2217),
    [anon_sym_icmp] = ACTIONS(2217),
    [anon_sym_fcmp] = ACTIONS(2217),
    [anon_sym_va_arg] = ACTIONS(2217),
    [anon_sym_phi] = ACTIONS(2217),
    [anon_sym_landingpad] = ACTIONS(2217),
    [anon_sym_tail] = ACTIONS(2217),
    [anon_sym_musttail] = ACTIONS(2217),
    [anon_sym_notail] = ACTIONS(2217),
    [anon_sym_call] = ACTIONS(2217),
    [anon_sym_alloca] = ACTIONS(2217),
    [anon_sym_load] = ACTIONS(2217),
    [anon_sym_store] = ACTIONS(2217),
    [anon_sym_cmpxchg] = ACTIONS(2217),
    [anon_sym_atomicrmw] = ACTIONS(2217),
    [anon_sym_fence] = ACTIONS(2217),
    [anon_sym_getelementptr] = ACTIONS(2217),
    [anon_sym_extractvalue] = ACTIONS(2217),
    [anon_sym_insertvalue] = ACTIONS(2217),
    [anon_sym_mul] = ACTIONS(2217),
    [anon_sym_urem] = ACTIONS(2217),
    [anon_sym_srem] = ACTIONS(2217),
    [anon_sym_shl] = ACTIONS(2217),
    [anon_sym_udiv] = ACTIONS(2217),
    [anon_sym_sdiv] = ACTIONS(2217),
    [anon_sym_lshr] = ACTIONS(2217),
    [anon_sym_ashr] = ACTIONS(2217),
    [anon_sym_fmul] = ACTIONS(2217),
    [anon_sym_fdiv] = ACTIONS(2217),
    [anon_sym_frem] = ACTIONS(2217),
    [anon_sym_xchg] = ACTIONS(2217),
    [anon_sym_add] = ACTIONS(2217),
    [anon_sym_sub] = ACTIONS(2217),
    [anon_sym_and] = ACTIONS(2217),
    [anon_sym_nand] = ACTIONS(2217),
    [anon_sym_or] = ACTIONS(2217),
    [anon_sym_xor] = ACTIONS(2217),
    [anon_sym_max] = ACTIONS(2217),
    [anon_sym_min] = ACTIONS(2217),
    [anon_sym_umax] = ACTIONS(2217),
    [anon_sym_umin] = ACTIONS(2217),
    [anon_sym_fadd] = ACTIONS(2217),
    [anon_sym_fsub] = ACTIONS(2217),
    [anon_sym_bitcast] = ACTIONS(2217),
    [anon_sym_trunc] = ACTIONS(2217),
    [anon_sym_zext] = ACTIONS(2217),
    [anon_sym_sext] = ACTIONS(2217),
    [anon_sym_fptrunc] = ACTIONS(2217),
    [anon_sym_fpext] = ACTIONS(2217),
    [anon_sym_addrspacecast] = ACTIONS(2217),
    [anon_sym_uitofp] = ACTIONS(2217),
    [anon_sym_sitofp] = ACTIONS(2217),
    [anon_sym_fptoui] = ACTIONS(2217),
    [anon_sym_fptosi] = ACTIONS(2217),
    [anon_sym_inttoptr] = ACTIONS(2217),
    [anon_sym_ptrtoint] = ACTIONS(2217),
    [anon_sym_uselistorder] = ACTIONS(2217),
  },
  [667] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(761),
    [sym_label] = ACTIONS(761),
    [anon_sym_RBRACE] = ACTIONS(761),
    [anon_sym_COMMA] = ACTIONS(761),
    [anon_sym_unreachable] = ACTIONS(763),
    [anon_sym_ret] = ACTIONS(763),
    [anon_sym_br] = ACTIONS(763),
    [anon_sym_resume] = ACTIONS(763),
    [anon_sym_freeze] = ACTIONS(763),
    [anon_sym_indirectbr] = ACTIONS(763),
    [anon_sym_extractelement] = ACTIONS(763),
    [anon_sym_insertelement] = ACTIONS(763),
    [anon_sym_select] = ACTIONS(763),
    [anon_sym_shufflevector] = ACTIONS(763),
    [anon_sym_fneg] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(763),
    [anon_sym_invoke] = ACTIONS(763),
    [anon_sym_cleanupret] = ACTIONS(763),
    [anon_sym_catchret] = ACTIONS(763),
    [anon_sym_catchswitch] = ACTIONS(763),
    [anon_sym_catchpad] = ACTIONS(763),
    [anon_sym_cleanuppad] = ACTIONS(763),
    [anon_sym_callbr] = ACTIONS(763),
    [anon_sym_icmp] = ACTIONS(763),
    [anon_sym_fcmp] = ACTIONS(763),
    [anon_sym_va_arg] = ACTIONS(763),
    [anon_sym_phi] = ACTIONS(763),
    [anon_sym_landingpad] = ACTIONS(763),
    [anon_sym_tail] = ACTIONS(763),
    [anon_sym_musttail] = ACTIONS(763),
    [anon_sym_notail] = ACTIONS(763),
    [anon_sym_call] = ACTIONS(763),
    [anon_sym_alloca] = ACTIONS(763),
    [anon_sym_load] = ACTIONS(763),
    [anon_sym_store] = ACTIONS(763),
    [anon_sym_cmpxchg] = ACTIONS(763),
    [anon_sym_atomicrmw] = ACTIONS(763),
    [anon_sym_fence] = ACTIONS(763),
    [anon_sym_getelementptr] = ACTIONS(763),
    [anon_sym_extractvalue] = ACTIONS(763),
    [anon_sym_insertvalue] = ACTIONS(763),
    [anon_sym_mul] = ACTIONS(763),
    [anon_sym_urem] = ACTIONS(763),
    [anon_sym_srem] = ACTIONS(763),
    [anon_sym_shl] = ACTIONS(763),
    [anon_sym_udiv] = ACTIONS(763),
    [anon_sym_sdiv] = ACTIONS(763),
    [anon_sym_lshr] = ACTIONS(763),
    [anon_sym_ashr] = ACTIONS(763),
    [anon_sym_fmul] = ACTIONS(763),
    [anon_sym_fdiv] = ACTIONS(763),
    [anon_sym_frem] = ACTIONS(763),
    [anon_sym_xchg] = ACTIONS(763),
    [anon_sym_add] = ACTIONS(763),
    [anon_sym_sub] = ACTIONS(763),
    [anon_sym_and] = ACTIONS(763),
    [anon_sym_nand] = ACTIONS(763),
    [anon_sym_or] = ACTIONS(763),
    [anon_sym_xor] = ACTIONS(763),
    [anon_sym_max] = ACTIONS(763),
    [anon_sym_min] = ACTIONS(763),
    [anon_sym_umax] = ACTIONS(763),
    [anon_sym_umin] = ACTIONS(763),
    [anon_sym_fadd] = ACTIONS(763),
    [anon_sym_fsub] = ACTIONS(763),
    [anon_sym_bitcast] = ACTIONS(763),
    [anon_sym_trunc] = ACTIONS(763),
    [anon_sym_zext] = ACTIONS(763),
    [anon_sym_sext] = ACTIONS(763),
    [anon_sym_fptrunc] = ACTIONS(763),
    [anon_sym_fpext] = ACTIONS(763),
    [anon_sym_addrspacecast] = ACTIONS(763),
    [anon_sym_uitofp] = ACTIONS(763),
    [anon_sym_sitofp] = ACTIONS(763),
    [anon_sym_fptoui] = ACTIONS(763),
    [anon_sym_fptosi] = ACTIONS(763),
    [anon_sym_inttoptr] = ACTIONS(763),
    [anon_sym_ptrtoint] = ACTIONS(763),
    [anon_sym_uselistorder] = ACTIONS(763),
  },
  [668] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2219),
    [sym_label] = ACTIONS(2219),
    [anon_sym_RBRACE] = ACTIONS(2219),
    [anon_sym_COMMA] = ACTIONS(2219),
    [anon_sym_unreachable] = ACTIONS(2221),
    [anon_sym_ret] = ACTIONS(2221),
    [anon_sym_br] = ACTIONS(2221),
    [anon_sym_resume] = ACTIONS(2221),
    [anon_sym_freeze] = ACTIONS(2221),
    [anon_sym_indirectbr] = ACTIONS(2221),
    [anon_sym_extractelement] = ACTIONS(2221),
    [anon_sym_insertelement] = ACTIONS(2221),
    [anon_sym_select] = ACTIONS(2221),
    [anon_sym_shufflevector] = ACTIONS(2221),
    [anon_sym_fneg] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_invoke] = ACTIONS(2221),
    [anon_sym_cleanupret] = ACTIONS(2221),
    [anon_sym_catchret] = ACTIONS(2221),
    [anon_sym_catchswitch] = ACTIONS(2221),
    [anon_sym_catchpad] = ACTIONS(2221),
    [anon_sym_cleanuppad] = ACTIONS(2221),
    [anon_sym_callbr] = ACTIONS(2221),
    [anon_sym_icmp] = ACTIONS(2221),
    [anon_sym_fcmp] = ACTIONS(2221),
    [anon_sym_va_arg] = ACTIONS(2221),
    [anon_sym_phi] = ACTIONS(2221),
    [anon_sym_landingpad] = ACTIONS(2221),
    [anon_sym_tail] = ACTIONS(2221),
    [anon_sym_musttail] = ACTIONS(2221),
    [anon_sym_notail] = ACTIONS(2221),
    [anon_sym_call] = ACTIONS(2221),
    [anon_sym_alloca] = ACTIONS(2221),
    [anon_sym_load] = ACTIONS(2221),
    [anon_sym_store] = ACTIONS(2221),
    [anon_sym_cmpxchg] = ACTIONS(2221),
    [anon_sym_atomicrmw] = ACTIONS(2221),
    [anon_sym_fence] = ACTIONS(2221),
    [anon_sym_getelementptr] = ACTIONS(2221),
    [anon_sym_extractvalue] = ACTIONS(2221),
    [anon_sym_insertvalue] = ACTIONS(2221),
    [anon_sym_mul] = ACTIONS(2221),
    [anon_sym_urem] = ACTIONS(2221),
    [anon_sym_srem] = ACTIONS(2221),
    [anon_sym_shl] = ACTIONS(2221),
    [anon_sym_udiv] = ACTIONS(2221),
    [anon_sym_sdiv] = ACTIONS(2221),
    [anon_sym_lshr] = ACTIONS(2221),
    [anon_sym_ashr] = ACTIONS(2221),
    [anon_sym_fmul] = ACTIONS(2221),
    [anon_sym_fdiv] = ACTIONS(2221),
    [anon_sym_frem] = ACTIONS(2221),
    [anon_sym_xchg] = ACTIONS(2221),
    [anon_sym_add] = ACTIONS(2221),
    [anon_sym_sub] = ACTIONS(2221),
    [anon_sym_and] = ACTIONS(2221),
    [anon_sym_nand] = ACTIONS(2221),
    [anon_sym_or] = ACTIONS(2221),
    [anon_sym_xor] = ACTIONS(2221),
    [anon_sym_max] = ACTIONS(2221),
    [anon_sym_min] = ACTIONS(2221),
    [anon_sym_umax] = ACTIONS(2221),
    [anon_sym_umin] = ACTIONS(2221),
    [anon_sym_fadd] = ACTIONS(2221),
    [anon_sym_fsub] = ACTIONS(2221),
    [anon_sym_bitcast] = ACTIONS(2221),
    [anon_sym_trunc] = ACTIONS(2221),
    [anon_sym_zext] = ACTIONS(2221),
    [anon_sym_sext] = ACTIONS(2221),
    [anon_sym_fptrunc] = ACTIONS(2221),
    [anon_sym_fpext] = ACTIONS(2221),
    [anon_sym_addrspacecast] = ACTIONS(2221),
    [anon_sym_uitofp] = ACTIONS(2221),
    [anon_sym_sitofp] = ACTIONS(2221),
    [anon_sym_fptoui] = ACTIONS(2221),
    [anon_sym_fptosi] = ACTIONS(2221),
    [anon_sym_inttoptr] = ACTIONS(2221),
    [anon_sym_ptrtoint] = ACTIONS(2221),
    [anon_sym_uselistorder] = ACTIONS(2221),
  },
  [669] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2223),
    [sym_label] = ACTIONS(2223),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_unreachable] = ACTIONS(2225),
    [anon_sym_ret] = ACTIONS(2225),
    [anon_sym_br] = ACTIONS(2225),
    [anon_sym_resume] = ACTIONS(2225),
    [anon_sym_freeze] = ACTIONS(2225),
    [anon_sym_indirectbr] = ACTIONS(2225),
    [anon_sym_extractelement] = ACTIONS(2225),
    [anon_sym_insertelement] = ACTIONS(2225),
    [anon_sym_select] = ACTIONS(2225),
    [anon_sym_shufflevector] = ACTIONS(2225),
    [anon_sym_fneg] = ACTIONS(2225),
    [anon_sym_switch] = ACTIONS(2225),
    [anon_sym_invoke] = ACTIONS(2225),
    [anon_sym_cleanupret] = ACTIONS(2225),
    [anon_sym_catchret] = ACTIONS(2225),
    [anon_sym_catchswitch] = ACTIONS(2225),
    [anon_sym_catchpad] = ACTIONS(2225),
    [anon_sym_cleanuppad] = ACTIONS(2225),
    [anon_sym_callbr] = ACTIONS(2225),
    [anon_sym_icmp] = ACTIONS(2225),
    [anon_sym_fcmp] = ACTIONS(2225),
    [anon_sym_va_arg] = ACTIONS(2225),
    [anon_sym_phi] = ACTIONS(2225),
    [anon_sym_landingpad] = ACTIONS(2225),
    [anon_sym_tail] = ACTIONS(2225),
    [anon_sym_musttail] = ACTIONS(2225),
    [anon_sym_notail] = ACTIONS(2225),
    [anon_sym_call] = ACTIONS(2225),
    [anon_sym_alloca] = ACTIONS(2225),
    [anon_sym_load] = ACTIONS(2225),
    [anon_sym_store] = ACTIONS(2225),
    [anon_sym_cmpxchg] = ACTIONS(2225),
    [anon_sym_atomicrmw] = ACTIONS(2225),
    [anon_sym_fence] = ACTIONS(2225),
    [anon_sym_getelementptr] = ACTIONS(2225),
    [anon_sym_extractvalue] = ACTIONS(2225),
    [anon_sym_insertvalue] = ACTIONS(2225),
    [anon_sym_mul] = ACTIONS(2225),
    [anon_sym_urem] = ACTIONS(2225),
    [anon_sym_srem] = ACTIONS(2225),
    [anon_sym_shl] = ACTIONS(2225),
    [anon_sym_udiv] = ACTIONS(2225),
    [anon_sym_sdiv] = ACTIONS(2225),
    [anon_sym_lshr] = ACTIONS(2225),
    [anon_sym_ashr] = ACTIONS(2225),
    [anon_sym_fmul] = ACTIONS(2225),
    [anon_sym_fdiv] = ACTIONS(2225),
    [anon_sym_frem] = ACTIONS(2225),
    [anon_sym_xchg] = ACTIONS(2225),
    [anon_sym_add] = ACTIONS(2225),
    [anon_sym_sub] = ACTIONS(2225),
    [anon_sym_and] = ACTIONS(2225),
    [anon_sym_nand] = ACTIONS(2225),
    [anon_sym_or] = ACTIONS(2225),
    [anon_sym_xor] = ACTIONS(2225),
    [anon_sym_max] = ACTIONS(2225),
    [anon_sym_min] = ACTIONS(2225),
    [anon_sym_umax] = ACTIONS(2225),
    [anon_sym_umin] = ACTIONS(2225),
    [anon_sym_fadd] = ACTIONS(2225),
    [anon_sym_fsub] = ACTIONS(2225),
    [anon_sym_bitcast] = ACTIONS(2225),
    [anon_sym_trunc] = ACTIONS(2225),
    [anon_sym_zext] = ACTIONS(2225),
    [anon_sym_sext] = ACTIONS(2225),
    [anon_sym_fptrunc] = ACTIONS(2225),
    [anon_sym_fpext] = ACTIONS(2225),
    [anon_sym_addrspacecast] = ACTIONS(2225),
    [anon_sym_uitofp] = ACTIONS(2225),
    [anon_sym_sitofp] = ACTIONS(2225),
    [anon_sym_fptoui] = ACTIONS(2225),
    [anon_sym_fptosi] = ACTIONS(2225),
    [anon_sym_inttoptr] = ACTIONS(2225),
    [anon_sym_ptrtoint] = ACTIONS(2225),
    [anon_sym_uselistorder] = ACTIONS(2225),
  },
  [670] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2227),
    [sym_label] = ACTIONS(2227),
    [anon_sym_RBRACE] = ACTIONS(2227),
    [anon_sym_COMMA] = ACTIONS(2227),
    [anon_sym_unreachable] = ACTIONS(2229),
    [anon_sym_ret] = ACTIONS(2229),
    [anon_sym_br] = ACTIONS(2229),
    [anon_sym_resume] = ACTIONS(2229),
    [anon_sym_freeze] = ACTIONS(2229),
    [anon_sym_indirectbr] = ACTIONS(2229),
    [anon_sym_extractelement] = ACTIONS(2229),
    [anon_sym_insertelement] = ACTIONS(2229),
    [anon_sym_select] = ACTIONS(2229),
    [anon_sym_shufflevector] = ACTIONS(2229),
    [anon_sym_fneg] = ACTIONS(2229),
    [anon_sym_switch] = ACTIONS(2229),
    [anon_sym_invoke] = ACTIONS(2229),
    [anon_sym_cleanupret] = ACTIONS(2229),
    [anon_sym_catchret] = ACTIONS(2229),
    [anon_sym_catchswitch] = ACTIONS(2229),
    [anon_sym_catchpad] = ACTIONS(2229),
    [anon_sym_cleanuppad] = ACTIONS(2229),
    [anon_sym_callbr] = ACTIONS(2229),
    [anon_sym_icmp] = ACTIONS(2229),
    [anon_sym_fcmp] = ACTIONS(2229),
    [anon_sym_va_arg] = ACTIONS(2229),
    [anon_sym_phi] = ACTIONS(2229),
    [anon_sym_landingpad] = ACTIONS(2229),
    [anon_sym_tail] = ACTIONS(2229),
    [anon_sym_musttail] = ACTIONS(2229),
    [anon_sym_notail] = ACTIONS(2229),
    [anon_sym_call] = ACTIONS(2229),
    [anon_sym_alloca] = ACTIONS(2229),
    [anon_sym_load] = ACTIONS(2229),
    [anon_sym_store] = ACTIONS(2229),
    [anon_sym_cmpxchg] = ACTIONS(2229),
    [anon_sym_atomicrmw] = ACTIONS(2229),
    [anon_sym_fence] = ACTIONS(2229),
    [anon_sym_getelementptr] = ACTIONS(2229),
    [anon_sym_extractvalue] = ACTIONS(2229),
    [anon_sym_insertvalue] = ACTIONS(2229),
    [anon_sym_mul] = ACTIONS(2229),
    [anon_sym_urem] = ACTIONS(2229),
    [anon_sym_srem] = ACTIONS(2229),
    [anon_sym_shl] = ACTIONS(2229),
    [anon_sym_udiv] = ACTIONS(2229),
    [anon_sym_sdiv] = ACTIONS(2229),
    [anon_sym_lshr] = ACTIONS(2229),
    [anon_sym_ashr] = ACTIONS(2229),
    [anon_sym_fmul] = ACTIONS(2229),
    [anon_sym_fdiv] = ACTIONS(2229),
    [anon_sym_frem] = ACTIONS(2229),
    [anon_sym_xchg] = ACTIONS(2229),
    [anon_sym_add] = ACTIONS(2229),
    [anon_sym_sub] = ACTIONS(2229),
    [anon_sym_and] = ACTIONS(2229),
    [anon_sym_nand] = ACTIONS(2229),
    [anon_sym_or] = ACTIONS(2229),
    [anon_sym_xor] = ACTIONS(2229),
    [anon_sym_max] = ACTIONS(2229),
    [anon_sym_min] = ACTIONS(2229),
    [anon_sym_umax] = ACTIONS(2229),
    [anon_sym_umin] = ACTIONS(2229),
    [anon_sym_fadd] = ACTIONS(2229),
    [anon_sym_fsub] = ACTIONS(2229),
    [anon_sym_bitcast] = ACTIONS(2229),
    [anon_sym_trunc] = ACTIONS(2229),
    [anon_sym_zext] = ACTIONS(2229),
    [anon_sym_sext] = ACTIONS(2229),
    [anon_sym_fptrunc] = ACTIONS(2229),
    [anon_sym_fpext] = ACTIONS(2229),
    [anon_sym_addrspacecast] = ACTIONS(2229),
    [anon_sym_uitofp] = ACTIONS(2229),
    [anon_sym_sitofp] = ACTIONS(2229),
    [anon_sym_fptoui] = ACTIONS(2229),
    [anon_sym_fptosi] = ACTIONS(2229),
    [anon_sym_inttoptr] = ACTIONS(2229),
    [anon_sym_ptrtoint] = ACTIONS(2229),
    [anon_sym_uselistorder] = ACTIONS(2229),
  },
  [671] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2231),
    [sym_label] = ACTIONS(2231),
    [anon_sym_RBRACE] = ACTIONS(2231),
    [anon_sym_COMMA] = ACTIONS(2231),
    [anon_sym_unreachable] = ACTIONS(2233),
    [anon_sym_ret] = ACTIONS(2233),
    [anon_sym_br] = ACTIONS(2233),
    [anon_sym_resume] = ACTIONS(2233),
    [anon_sym_freeze] = ACTIONS(2233),
    [anon_sym_indirectbr] = ACTIONS(2233),
    [anon_sym_extractelement] = ACTIONS(2233),
    [anon_sym_insertelement] = ACTIONS(2233),
    [anon_sym_select] = ACTIONS(2233),
    [anon_sym_shufflevector] = ACTIONS(2233),
    [anon_sym_fneg] = ACTIONS(2233),
    [anon_sym_switch] = ACTIONS(2233),
    [anon_sym_invoke] = ACTIONS(2233),
    [anon_sym_cleanupret] = ACTIONS(2233),
    [anon_sym_catchret] = ACTIONS(2233),
    [anon_sym_catchswitch] = ACTIONS(2233),
    [anon_sym_catchpad] = ACTIONS(2233),
    [anon_sym_cleanuppad] = ACTIONS(2233),
    [anon_sym_callbr] = ACTIONS(2233),
    [anon_sym_icmp] = ACTIONS(2233),
    [anon_sym_fcmp] = ACTIONS(2233),
    [anon_sym_va_arg] = ACTIONS(2233),
    [anon_sym_phi] = ACTIONS(2233),
    [anon_sym_landingpad] = ACTIONS(2233),
    [anon_sym_tail] = ACTIONS(2233),
    [anon_sym_musttail] = ACTIONS(2233),
    [anon_sym_notail] = ACTIONS(2233),
    [anon_sym_call] = ACTIONS(2233),
    [anon_sym_alloca] = ACTIONS(2233),
    [anon_sym_load] = ACTIONS(2233),
    [anon_sym_store] = ACTIONS(2233),
    [anon_sym_cmpxchg] = ACTIONS(2233),
    [anon_sym_atomicrmw] = ACTIONS(2233),
    [anon_sym_fence] = ACTIONS(2233),
    [anon_sym_getelementptr] = ACTIONS(2233),
    [anon_sym_extractvalue] = ACTIONS(2233),
    [anon_sym_insertvalue] = ACTIONS(2233),
    [anon_sym_mul] = ACTIONS(2233),
    [anon_sym_urem] = ACTIONS(2233),
    [anon_sym_srem] = ACTIONS(2233),
    [anon_sym_shl] = ACTIONS(2233),
    [anon_sym_udiv] = ACTIONS(2233),
    [anon_sym_sdiv] = ACTIONS(2233),
    [anon_sym_lshr] = ACTIONS(2233),
    [anon_sym_ashr] = ACTIONS(2233),
    [anon_sym_fmul] = ACTIONS(2233),
    [anon_sym_fdiv] = ACTIONS(2233),
    [anon_sym_frem] = ACTIONS(2233),
    [anon_sym_xchg] = ACTIONS(2233),
    [anon_sym_add] = ACTIONS(2233),
    [anon_sym_sub] = ACTIONS(2233),
    [anon_sym_and] = ACTIONS(2233),
    [anon_sym_nand] = ACTIONS(2233),
    [anon_sym_or] = ACTIONS(2233),
    [anon_sym_xor] = ACTIONS(2233),
    [anon_sym_max] = ACTIONS(2233),
    [anon_sym_min] = ACTIONS(2233),
    [anon_sym_umax] = ACTIONS(2233),
    [anon_sym_umin] = ACTIONS(2233),
    [anon_sym_fadd] = ACTIONS(2233),
    [anon_sym_fsub] = ACTIONS(2233),
    [anon_sym_bitcast] = ACTIONS(2233),
    [anon_sym_trunc] = ACTIONS(2233),
    [anon_sym_zext] = ACTIONS(2233),
    [anon_sym_sext] = ACTIONS(2233),
    [anon_sym_fptrunc] = ACTIONS(2233),
    [anon_sym_fpext] = ACTIONS(2233),
    [anon_sym_addrspacecast] = ACTIONS(2233),
    [anon_sym_uitofp] = ACTIONS(2233),
    [anon_sym_sitofp] = ACTIONS(2233),
    [anon_sym_fptoui] = ACTIONS(2233),
    [anon_sym_fptosi] = ACTIONS(2233),
    [anon_sym_inttoptr] = ACTIONS(2233),
    [anon_sym_ptrtoint] = ACTIONS(2233),
    [anon_sym_uselistorder] = ACTIONS(2233),
  },
  [672] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2235),
    [sym_label] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_unreachable] = ACTIONS(2237),
    [anon_sym_ret] = ACTIONS(2237),
    [anon_sym_br] = ACTIONS(2237),
    [anon_sym_resume] = ACTIONS(2237),
    [anon_sym_freeze] = ACTIONS(2237),
    [anon_sym_indirectbr] = ACTIONS(2237),
    [anon_sym_extractelement] = ACTIONS(2237),
    [anon_sym_insertelement] = ACTIONS(2237),
    [anon_sym_select] = ACTIONS(2237),
    [anon_sym_shufflevector] = ACTIONS(2237),
    [anon_sym_fneg] = ACTIONS(2237),
    [anon_sym_switch] = ACTIONS(2237),
    [anon_sym_invoke] = ACTIONS(2237),
    [anon_sym_cleanupret] = ACTIONS(2237),
    [anon_sym_catchret] = ACTIONS(2237),
    [anon_sym_catchswitch] = ACTIONS(2237),
    [anon_sym_catchpad] = ACTIONS(2237),
    [anon_sym_cleanuppad] = ACTIONS(2237),
    [anon_sym_callbr] = ACTIONS(2237),
    [anon_sym_icmp] = ACTIONS(2237),
    [anon_sym_fcmp] = ACTIONS(2237),
    [anon_sym_va_arg] = ACTIONS(2237),
    [anon_sym_phi] = ACTIONS(2237),
    [anon_sym_landingpad] = ACTIONS(2237),
    [anon_sym_tail] = ACTIONS(2237),
    [anon_sym_musttail] = ACTIONS(2237),
    [anon_sym_notail] = ACTIONS(2237),
    [anon_sym_call] = ACTIONS(2237),
    [anon_sym_alloca] = ACTIONS(2237),
    [anon_sym_load] = ACTIONS(2237),
    [anon_sym_store] = ACTIONS(2237),
    [anon_sym_cmpxchg] = ACTIONS(2237),
    [anon_sym_atomicrmw] = ACTIONS(2237),
    [anon_sym_fence] = ACTIONS(2237),
    [anon_sym_getelementptr] = ACTIONS(2237),
    [anon_sym_extractvalue] = ACTIONS(2237),
    [anon_sym_insertvalue] = ACTIONS(2237),
    [anon_sym_mul] = ACTIONS(2237),
    [anon_sym_urem] = ACTIONS(2237),
    [anon_sym_srem] = ACTIONS(2237),
    [anon_sym_shl] = ACTIONS(2237),
    [anon_sym_udiv] = ACTIONS(2237),
    [anon_sym_sdiv] = ACTIONS(2237),
    [anon_sym_lshr] = ACTIONS(2237),
    [anon_sym_ashr] = ACTIONS(2237),
    [anon_sym_fmul] = ACTIONS(2237),
    [anon_sym_fdiv] = ACTIONS(2237),
    [anon_sym_frem] = ACTIONS(2237),
    [anon_sym_xchg] = ACTIONS(2237),
    [anon_sym_add] = ACTIONS(2237),
    [anon_sym_sub] = ACTIONS(2237),
    [anon_sym_and] = ACTIONS(2237),
    [anon_sym_nand] = ACTIONS(2237),
    [anon_sym_or] = ACTIONS(2237),
    [anon_sym_xor] = ACTIONS(2237),
    [anon_sym_max] = ACTIONS(2237),
    [anon_sym_min] = ACTIONS(2237),
    [anon_sym_umax] = ACTIONS(2237),
    [anon_sym_umin] = ACTIONS(2237),
    [anon_sym_fadd] = ACTIONS(2237),
    [anon_sym_fsub] = ACTIONS(2237),
    [anon_sym_bitcast] = ACTIONS(2237),
    [anon_sym_trunc] = ACTIONS(2237),
    [anon_sym_zext] = ACTIONS(2237),
    [anon_sym_sext] = ACTIONS(2237),
    [anon_sym_fptrunc] = ACTIONS(2237),
    [anon_sym_fpext] = ACTIONS(2237),
    [anon_sym_addrspacecast] = ACTIONS(2237),
    [anon_sym_uitofp] = ACTIONS(2237),
    [anon_sym_sitofp] = ACTIONS(2237),
    [anon_sym_fptoui] = ACTIONS(2237),
    [anon_sym_fptosi] = ACTIONS(2237),
    [anon_sym_inttoptr] = ACTIONS(2237),
    [anon_sym_ptrtoint] = ACTIONS(2237),
    [anon_sym_uselistorder] = ACTIONS(2237),
  },
  [673] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2239),
    [sym_label] = ACTIONS(2239),
    [anon_sym_RBRACE] = ACTIONS(2239),
    [anon_sym_COMMA] = ACTIONS(2239),
    [anon_sym_unreachable] = ACTIONS(2241),
    [anon_sym_ret] = ACTIONS(2241),
    [anon_sym_br] = ACTIONS(2241),
    [anon_sym_resume] = ACTIONS(2241),
    [anon_sym_freeze] = ACTIONS(2241),
    [anon_sym_indirectbr] = ACTIONS(2241),
    [anon_sym_extractelement] = ACTIONS(2241),
    [anon_sym_insertelement] = ACTIONS(2241),
    [anon_sym_select] = ACTIONS(2241),
    [anon_sym_shufflevector] = ACTIONS(2241),
    [anon_sym_fneg] = ACTIONS(2241),
    [anon_sym_switch] = ACTIONS(2241),
    [anon_sym_invoke] = ACTIONS(2241),
    [anon_sym_cleanupret] = ACTIONS(2241),
    [anon_sym_catchret] = ACTIONS(2241),
    [anon_sym_catchswitch] = ACTIONS(2241),
    [anon_sym_catchpad] = ACTIONS(2241),
    [anon_sym_cleanuppad] = ACTIONS(2241),
    [anon_sym_callbr] = ACTIONS(2241),
    [anon_sym_icmp] = ACTIONS(2241),
    [anon_sym_fcmp] = ACTIONS(2241),
    [anon_sym_va_arg] = ACTIONS(2241),
    [anon_sym_phi] = ACTIONS(2241),
    [anon_sym_landingpad] = ACTIONS(2241),
    [anon_sym_tail] = ACTIONS(2241),
    [anon_sym_musttail] = ACTIONS(2241),
    [anon_sym_notail] = ACTIONS(2241),
    [anon_sym_call] = ACTIONS(2241),
    [anon_sym_alloca] = ACTIONS(2241),
    [anon_sym_load] = ACTIONS(2241),
    [anon_sym_store] = ACTIONS(2241),
    [anon_sym_cmpxchg] = ACTIONS(2241),
    [anon_sym_atomicrmw] = ACTIONS(2241),
    [anon_sym_fence] = ACTIONS(2241),
    [anon_sym_getelementptr] = ACTIONS(2241),
    [anon_sym_extractvalue] = ACTIONS(2241),
    [anon_sym_insertvalue] = ACTIONS(2241),
    [anon_sym_mul] = ACTIONS(2241),
    [anon_sym_urem] = ACTIONS(2241),
    [anon_sym_srem] = ACTIONS(2241),
    [anon_sym_shl] = ACTIONS(2241),
    [anon_sym_udiv] = ACTIONS(2241),
    [anon_sym_sdiv] = ACTIONS(2241),
    [anon_sym_lshr] = ACTIONS(2241),
    [anon_sym_ashr] = ACTIONS(2241),
    [anon_sym_fmul] = ACTIONS(2241),
    [anon_sym_fdiv] = ACTIONS(2241),
    [anon_sym_frem] = ACTIONS(2241),
    [anon_sym_xchg] = ACTIONS(2241),
    [anon_sym_add] = ACTIONS(2241),
    [anon_sym_sub] = ACTIONS(2241),
    [anon_sym_and] = ACTIONS(2241),
    [anon_sym_nand] = ACTIONS(2241),
    [anon_sym_or] = ACTIONS(2241),
    [anon_sym_xor] = ACTIONS(2241),
    [anon_sym_max] = ACTIONS(2241),
    [anon_sym_min] = ACTIONS(2241),
    [anon_sym_umax] = ACTIONS(2241),
    [anon_sym_umin] = ACTIONS(2241),
    [anon_sym_fadd] = ACTIONS(2241),
    [anon_sym_fsub] = ACTIONS(2241),
    [anon_sym_bitcast] = ACTIONS(2241),
    [anon_sym_trunc] = ACTIONS(2241),
    [anon_sym_zext] = ACTIONS(2241),
    [anon_sym_sext] = ACTIONS(2241),
    [anon_sym_fptrunc] = ACTIONS(2241),
    [anon_sym_fpext] = ACTIONS(2241),
    [anon_sym_addrspacecast] = ACTIONS(2241),
    [anon_sym_uitofp] = ACTIONS(2241),
    [anon_sym_sitofp] = ACTIONS(2241),
    [anon_sym_fptoui] = ACTIONS(2241),
    [anon_sym_fptosi] = ACTIONS(2241),
    [anon_sym_inttoptr] = ACTIONS(2241),
    [anon_sym_ptrtoint] = ACTIONS(2241),
    [anon_sym_uselistorder] = ACTIONS(2241),
  },
  [674] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2243),
    [sym_label] = ACTIONS(2243),
    [anon_sym_RBRACE] = ACTIONS(2243),
    [anon_sym_COMMA] = ACTIONS(2243),
    [anon_sym_unreachable] = ACTIONS(2245),
    [anon_sym_ret] = ACTIONS(2245),
    [anon_sym_br] = ACTIONS(2245),
    [anon_sym_resume] = ACTIONS(2245),
    [anon_sym_freeze] = ACTIONS(2245),
    [anon_sym_indirectbr] = ACTIONS(2245),
    [anon_sym_extractelement] = ACTIONS(2245),
    [anon_sym_insertelement] = ACTIONS(2245),
    [anon_sym_select] = ACTIONS(2245),
    [anon_sym_shufflevector] = ACTIONS(2245),
    [anon_sym_fneg] = ACTIONS(2245),
    [anon_sym_switch] = ACTIONS(2245),
    [anon_sym_invoke] = ACTIONS(2245),
    [anon_sym_cleanupret] = ACTIONS(2245),
    [anon_sym_catchret] = ACTIONS(2245),
    [anon_sym_catchswitch] = ACTIONS(2245),
    [anon_sym_catchpad] = ACTIONS(2245),
    [anon_sym_cleanuppad] = ACTIONS(2245),
    [anon_sym_callbr] = ACTIONS(2245),
    [anon_sym_icmp] = ACTIONS(2245),
    [anon_sym_fcmp] = ACTIONS(2245),
    [anon_sym_va_arg] = ACTIONS(2245),
    [anon_sym_phi] = ACTIONS(2245),
    [anon_sym_landingpad] = ACTIONS(2245),
    [anon_sym_tail] = ACTIONS(2245),
    [anon_sym_musttail] = ACTIONS(2245),
    [anon_sym_notail] = ACTIONS(2245),
    [anon_sym_call] = ACTIONS(2245),
    [anon_sym_alloca] = ACTIONS(2245),
    [anon_sym_load] = ACTIONS(2245),
    [anon_sym_store] = ACTIONS(2245),
    [anon_sym_cmpxchg] = ACTIONS(2245),
    [anon_sym_atomicrmw] = ACTIONS(2245),
    [anon_sym_fence] = ACTIONS(2245),
    [anon_sym_getelementptr] = ACTIONS(2245),
    [anon_sym_extractvalue] = ACTIONS(2245),
    [anon_sym_insertvalue] = ACTIONS(2245),
    [anon_sym_mul] = ACTIONS(2245),
    [anon_sym_urem] = ACTIONS(2245),
    [anon_sym_srem] = ACTIONS(2245),
    [anon_sym_shl] = ACTIONS(2245),
    [anon_sym_udiv] = ACTIONS(2245),
    [anon_sym_sdiv] = ACTIONS(2245),
    [anon_sym_lshr] = ACTIONS(2245),
    [anon_sym_ashr] = ACTIONS(2245),
    [anon_sym_fmul] = ACTIONS(2245),
    [anon_sym_fdiv] = ACTIONS(2245),
    [anon_sym_frem] = ACTIONS(2245),
    [anon_sym_xchg] = ACTIONS(2245),
    [anon_sym_add] = ACTIONS(2245),
    [anon_sym_sub] = ACTIONS(2245),
    [anon_sym_and] = ACTIONS(2245),
    [anon_sym_nand] = ACTIONS(2245),
    [anon_sym_or] = ACTIONS(2245),
    [anon_sym_xor] = ACTIONS(2245),
    [anon_sym_max] = ACTIONS(2245),
    [anon_sym_min] = ACTIONS(2245),
    [anon_sym_umax] = ACTIONS(2245),
    [anon_sym_umin] = ACTIONS(2245),
    [anon_sym_fadd] = ACTIONS(2245),
    [anon_sym_fsub] = ACTIONS(2245),
    [anon_sym_bitcast] = ACTIONS(2245),
    [anon_sym_trunc] = ACTIONS(2245),
    [anon_sym_zext] = ACTIONS(2245),
    [anon_sym_sext] = ACTIONS(2245),
    [anon_sym_fptrunc] = ACTIONS(2245),
    [anon_sym_fpext] = ACTIONS(2245),
    [anon_sym_addrspacecast] = ACTIONS(2245),
    [anon_sym_uitofp] = ACTIONS(2245),
    [anon_sym_sitofp] = ACTIONS(2245),
    [anon_sym_fptoui] = ACTIONS(2245),
    [anon_sym_fptosi] = ACTIONS(2245),
    [anon_sym_inttoptr] = ACTIONS(2245),
    [anon_sym_ptrtoint] = ACTIONS(2245),
    [anon_sym_uselistorder] = ACTIONS(2245),
  },
  [675] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2247),
    [sym_label] = ACTIONS(2247),
    [anon_sym_RBRACE] = ACTIONS(2247),
    [anon_sym_COMMA] = ACTIONS(2247),
    [anon_sym_unreachable] = ACTIONS(2249),
    [anon_sym_ret] = ACTIONS(2249),
    [anon_sym_br] = ACTIONS(2249),
    [anon_sym_resume] = ACTIONS(2249),
    [anon_sym_freeze] = ACTIONS(2249),
    [anon_sym_indirectbr] = ACTIONS(2249),
    [anon_sym_extractelement] = ACTIONS(2249),
    [anon_sym_insertelement] = ACTIONS(2249),
    [anon_sym_select] = ACTIONS(2249),
    [anon_sym_shufflevector] = ACTIONS(2249),
    [anon_sym_fneg] = ACTIONS(2249),
    [anon_sym_switch] = ACTIONS(2249),
    [anon_sym_invoke] = ACTIONS(2249),
    [anon_sym_cleanupret] = ACTIONS(2249),
    [anon_sym_catchret] = ACTIONS(2249),
    [anon_sym_catchswitch] = ACTIONS(2249),
    [anon_sym_catchpad] = ACTIONS(2249),
    [anon_sym_cleanuppad] = ACTIONS(2249),
    [anon_sym_callbr] = ACTIONS(2249),
    [anon_sym_icmp] = ACTIONS(2249),
    [anon_sym_fcmp] = ACTIONS(2249),
    [anon_sym_va_arg] = ACTIONS(2249),
    [anon_sym_phi] = ACTIONS(2249),
    [anon_sym_landingpad] = ACTIONS(2249),
    [anon_sym_tail] = ACTIONS(2249),
    [anon_sym_musttail] = ACTIONS(2249),
    [anon_sym_notail] = ACTIONS(2249),
    [anon_sym_call] = ACTIONS(2249),
    [anon_sym_alloca] = ACTIONS(2249),
    [anon_sym_load] = ACTIONS(2249),
    [anon_sym_store] = ACTIONS(2249),
    [anon_sym_cmpxchg] = ACTIONS(2249),
    [anon_sym_atomicrmw] = ACTIONS(2249),
    [anon_sym_fence] = ACTIONS(2249),
    [anon_sym_getelementptr] = ACTIONS(2249),
    [anon_sym_extractvalue] = ACTIONS(2249),
    [anon_sym_insertvalue] = ACTIONS(2249),
    [anon_sym_mul] = ACTIONS(2249),
    [anon_sym_urem] = ACTIONS(2249),
    [anon_sym_srem] = ACTIONS(2249),
    [anon_sym_shl] = ACTIONS(2249),
    [anon_sym_udiv] = ACTIONS(2249),
    [anon_sym_sdiv] = ACTIONS(2249),
    [anon_sym_lshr] = ACTIONS(2249),
    [anon_sym_ashr] = ACTIONS(2249),
    [anon_sym_fmul] = ACTIONS(2249),
    [anon_sym_fdiv] = ACTIONS(2249),
    [anon_sym_frem] = ACTIONS(2249),
    [anon_sym_xchg] = ACTIONS(2249),
    [anon_sym_add] = ACTIONS(2249),
    [anon_sym_sub] = ACTIONS(2249),
    [anon_sym_and] = ACTIONS(2249),
    [anon_sym_nand] = ACTIONS(2249),
    [anon_sym_or] = ACTIONS(2249),
    [anon_sym_xor] = ACTIONS(2249),
    [anon_sym_max] = ACTIONS(2249),
    [anon_sym_min] = ACTIONS(2249),
    [anon_sym_umax] = ACTIONS(2249),
    [anon_sym_umin] = ACTIONS(2249),
    [anon_sym_fadd] = ACTIONS(2249),
    [anon_sym_fsub] = ACTIONS(2249),
    [anon_sym_bitcast] = ACTIONS(2249),
    [anon_sym_trunc] = ACTIONS(2249),
    [anon_sym_zext] = ACTIONS(2249),
    [anon_sym_sext] = ACTIONS(2249),
    [anon_sym_fptrunc] = ACTIONS(2249),
    [anon_sym_fpext] = ACTIONS(2249),
    [anon_sym_addrspacecast] = ACTIONS(2249),
    [anon_sym_uitofp] = ACTIONS(2249),
    [anon_sym_sitofp] = ACTIONS(2249),
    [anon_sym_fptoui] = ACTIONS(2249),
    [anon_sym_fptosi] = ACTIONS(2249),
    [anon_sym_inttoptr] = ACTIONS(2249),
    [anon_sym_ptrtoint] = ACTIONS(2249),
    [anon_sym_uselistorder] = ACTIONS(2249),
  },
  [676] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2251),
    [sym_label] = ACTIONS(2251),
    [anon_sym_RBRACE] = ACTIONS(2251),
    [anon_sym_COMMA] = ACTIONS(2251),
    [anon_sym_unreachable] = ACTIONS(2253),
    [anon_sym_ret] = ACTIONS(2253),
    [anon_sym_br] = ACTIONS(2253),
    [anon_sym_resume] = ACTIONS(2253),
    [anon_sym_freeze] = ACTIONS(2253),
    [anon_sym_indirectbr] = ACTIONS(2253),
    [anon_sym_extractelement] = ACTIONS(2253),
    [anon_sym_insertelement] = ACTIONS(2253),
    [anon_sym_select] = ACTIONS(2253),
    [anon_sym_shufflevector] = ACTIONS(2253),
    [anon_sym_fneg] = ACTIONS(2253),
    [anon_sym_switch] = ACTIONS(2253),
    [anon_sym_invoke] = ACTIONS(2253),
    [anon_sym_cleanupret] = ACTIONS(2253),
    [anon_sym_catchret] = ACTIONS(2253),
    [anon_sym_catchswitch] = ACTIONS(2253),
    [anon_sym_catchpad] = ACTIONS(2253),
    [anon_sym_cleanuppad] = ACTIONS(2253),
    [anon_sym_callbr] = ACTIONS(2253),
    [anon_sym_icmp] = ACTIONS(2253),
    [anon_sym_fcmp] = ACTIONS(2253),
    [anon_sym_va_arg] = ACTIONS(2253),
    [anon_sym_phi] = ACTIONS(2253),
    [anon_sym_landingpad] = ACTIONS(2253),
    [anon_sym_tail] = ACTIONS(2253),
    [anon_sym_musttail] = ACTIONS(2253),
    [anon_sym_notail] = ACTIONS(2253),
    [anon_sym_call] = ACTIONS(2253),
    [anon_sym_alloca] = ACTIONS(2253),
    [anon_sym_load] = ACTIONS(2253),
    [anon_sym_store] = ACTIONS(2253),
    [anon_sym_cmpxchg] = ACTIONS(2253),
    [anon_sym_atomicrmw] = ACTIONS(2253),
    [anon_sym_fence] = ACTIONS(2253),
    [anon_sym_getelementptr] = ACTIONS(2253),
    [anon_sym_extractvalue] = ACTIONS(2253),
    [anon_sym_insertvalue] = ACTIONS(2253),
    [anon_sym_mul] = ACTIONS(2253),
    [anon_sym_urem] = ACTIONS(2253),
    [anon_sym_srem] = ACTIONS(2253),
    [anon_sym_shl] = ACTIONS(2253),
    [anon_sym_udiv] = ACTIONS(2253),
    [anon_sym_sdiv] = ACTIONS(2253),
    [anon_sym_lshr] = ACTIONS(2253),
    [anon_sym_ashr] = ACTIONS(2253),
    [anon_sym_fmul] = ACTIONS(2253),
    [anon_sym_fdiv] = ACTIONS(2253),
    [anon_sym_frem] = ACTIONS(2253),
    [anon_sym_xchg] = ACTIONS(2253),
    [anon_sym_add] = ACTIONS(2253),
    [anon_sym_sub] = ACTIONS(2253),
    [anon_sym_and] = ACTIONS(2253),
    [anon_sym_nand] = ACTIONS(2253),
    [anon_sym_or] = ACTIONS(2253),
    [anon_sym_xor] = ACTIONS(2253),
    [anon_sym_max] = ACTIONS(2253),
    [anon_sym_min] = ACTIONS(2253),
    [anon_sym_umax] = ACTIONS(2253),
    [anon_sym_umin] = ACTIONS(2253),
    [anon_sym_fadd] = ACTIONS(2253),
    [anon_sym_fsub] = ACTIONS(2253),
    [anon_sym_bitcast] = ACTIONS(2253),
    [anon_sym_trunc] = ACTIONS(2253),
    [anon_sym_zext] = ACTIONS(2253),
    [anon_sym_sext] = ACTIONS(2253),
    [anon_sym_fptrunc] = ACTIONS(2253),
    [anon_sym_fpext] = ACTIONS(2253),
    [anon_sym_addrspacecast] = ACTIONS(2253),
    [anon_sym_uitofp] = ACTIONS(2253),
    [anon_sym_sitofp] = ACTIONS(2253),
    [anon_sym_fptoui] = ACTIONS(2253),
    [anon_sym_fptosi] = ACTIONS(2253),
    [anon_sym_inttoptr] = ACTIONS(2253),
    [anon_sym_ptrtoint] = ACTIONS(2253),
    [anon_sym_uselistorder] = ACTIONS(2253),
  },
  [677] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2255),
    [sym_label] = ACTIONS(2255),
    [anon_sym_RBRACE] = ACTIONS(2255),
    [anon_sym_COMMA] = ACTIONS(2255),
    [anon_sym_unreachable] = ACTIONS(2257),
    [anon_sym_ret] = ACTIONS(2257),
    [anon_sym_br] = ACTIONS(2257),
    [anon_sym_resume] = ACTIONS(2257),
    [anon_sym_freeze] = ACTIONS(2257),
    [anon_sym_indirectbr] = ACTIONS(2257),
    [anon_sym_extractelement] = ACTIONS(2257),
    [anon_sym_insertelement] = ACTIONS(2257),
    [anon_sym_select] = ACTIONS(2257),
    [anon_sym_shufflevector] = ACTIONS(2257),
    [anon_sym_fneg] = ACTIONS(2257),
    [anon_sym_switch] = ACTIONS(2257),
    [anon_sym_invoke] = ACTIONS(2257),
    [anon_sym_cleanupret] = ACTIONS(2257),
    [anon_sym_catchret] = ACTIONS(2257),
    [anon_sym_catchswitch] = ACTIONS(2257),
    [anon_sym_catchpad] = ACTIONS(2257),
    [anon_sym_cleanuppad] = ACTIONS(2257),
    [anon_sym_callbr] = ACTIONS(2257),
    [anon_sym_icmp] = ACTIONS(2257),
    [anon_sym_fcmp] = ACTIONS(2257),
    [anon_sym_va_arg] = ACTIONS(2257),
    [anon_sym_phi] = ACTIONS(2257),
    [anon_sym_landingpad] = ACTIONS(2257),
    [anon_sym_tail] = ACTIONS(2257),
    [anon_sym_musttail] = ACTIONS(2257),
    [anon_sym_notail] = ACTIONS(2257),
    [anon_sym_call] = ACTIONS(2257),
    [anon_sym_alloca] = ACTIONS(2257),
    [anon_sym_load] = ACTIONS(2257),
    [anon_sym_store] = ACTIONS(2257),
    [anon_sym_cmpxchg] = ACTIONS(2257),
    [anon_sym_atomicrmw] = ACTIONS(2257),
    [anon_sym_fence] = ACTIONS(2257),
    [anon_sym_getelementptr] = ACTIONS(2257),
    [anon_sym_extractvalue] = ACTIONS(2257),
    [anon_sym_insertvalue] = ACTIONS(2257),
    [anon_sym_mul] = ACTIONS(2257),
    [anon_sym_urem] = ACTIONS(2257),
    [anon_sym_srem] = ACTIONS(2257),
    [anon_sym_shl] = ACTIONS(2257),
    [anon_sym_udiv] = ACTIONS(2257),
    [anon_sym_sdiv] = ACTIONS(2257),
    [anon_sym_lshr] = ACTIONS(2257),
    [anon_sym_ashr] = ACTIONS(2257),
    [anon_sym_fmul] = ACTIONS(2257),
    [anon_sym_fdiv] = ACTIONS(2257),
    [anon_sym_frem] = ACTIONS(2257),
    [anon_sym_xchg] = ACTIONS(2257),
    [anon_sym_add] = ACTIONS(2257),
    [anon_sym_sub] = ACTIONS(2257),
    [anon_sym_and] = ACTIONS(2257),
    [anon_sym_nand] = ACTIONS(2257),
    [anon_sym_or] = ACTIONS(2257),
    [anon_sym_xor] = ACTIONS(2257),
    [anon_sym_max] = ACTIONS(2257),
    [anon_sym_min] = ACTIONS(2257),
    [anon_sym_umax] = ACTIONS(2257),
    [anon_sym_umin] = ACTIONS(2257),
    [anon_sym_fadd] = ACTIONS(2257),
    [anon_sym_fsub] = ACTIONS(2257),
    [anon_sym_bitcast] = ACTIONS(2257),
    [anon_sym_trunc] = ACTIONS(2257),
    [anon_sym_zext] = ACTIONS(2257),
    [anon_sym_sext] = ACTIONS(2257),
    [anon_sym_fptrunc] = ACTIONS(2257),
    [anon_sym_fpext] = ACTIONS(2257),
    [anon_sym_addrspacecast] = ACTIONS(2257),
    [anon_sym_uitofp] = ACTIONS(2257),
    [anon_sym_sitofp] = ACTIONS(2257),
    [anon_sym_fptoui] = ACTIONS(2257),
    [anon_sym_fptosi] = ACTIONS(2257),
    [anon_sym_inttoptr] = ACTIONS(2257),
    [anon_sym_ptrtoint] = ACTIONS(2257),
    [anon_sym_uselistorder] = ACTIONS(2257),
  },
  [678] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2259),
    [sym_label] = ACTIONS(2259),
    [anon_sym_RBRACE] = ACTIONS(2259),
    [anon_sym_COMMA] = ACTIONS(2259),
    [anon_sym_unreachable] = ACTIONS(2261),
    [anon_sym_ret] = ACTIONS(2261),
    [anon_sym_br] = ACTIONS(2261),
    [anon_sym_resume] = ACTIONS(2261),
    [anon_sym_freeze] = ACTIONS(2261),
    [anon_sym_indirectbr] = ACTIONS(2261),
    [anon_sym_extractelement] = ACTIONS(2261),
    [anon_sym_insertelement] = ACTIONS(2261),
    [anon_sym_select] = ACTIONS(2261),
    [anon_sym_shufflevector] = ACTIONS(2261),
    [anon_sym_fneg] = ACTIONS(2261),
    [anon_sym_switch] = ACTIONS(2261),
    [anon_sym_invoke] = ACTIONS(2261),
    [anon_sym_cleanupret] = ACTIONS(2261),
    [anon_sym_catchret] = ACTIONS(2261),
    [anon_sym_catchswitch] = ACTIONS(2261),
    [anon_sym_catchpad] = ACTIONS(2261),
    [anon_sym_cleanuppad] = ACTIONS(2261),
    [anon_sym_callbr] = ACTIONS(2261),
    [anon_sym_icmp] = ACTIONS(2261),
    [anon_sym_fcmp] = ACTIONS(2261),
    [anon_sym_va_arg] = ACTIONS(2261),
    [anon_sym_phi] = ACTIONS(2261),
    [anon_sym_landingpad] = ACTIONS(2261),
    [anon_sym_tail] = ACTIONS(2261),
    [anon_sym_musttail] = ACTIONS(2261),
    [anon_sym_notail] = ACTIONS(2261),
    [anon_sym_call] = ACTIONS(2261),
    [anon_sym_alloca] = ACTIONS(2261),
    [anon_sym_load] = ACTIONS(2261),
    [anon_sym_store] = ACTIONS(2261),
    [anon_sym_cmpxchg] = ACTIONS(2261),
    [anon_sym_atomicrmw] = ACTIONS(2261),
    [anon_sym_fence] = ACTIONS(2261),
    [anon_sym_getelementptr] = ACTIONS(2261),
    [anon_sym_extractvalue] = ACTIONS(2261),
    [anon_sym_insertvalue] = ACTIONS(2261),
    [anon_sym_mul] = ACTIONS(2261),
    [anon_sym_urem] = ACTIONS(2261),
    [anon_sym_srem] = ACTIONS(2261),
    [anon_sym_shl] = ACTIONS(2261),
    [anon_sym_udiv] = ACTIONS(2261),
    [anon_sym_sdiv] = ACTIONS(2261),
    [anon_sym_lshr] = ACTIONS(2261),
    [anon_sym_ashr] = ACTIONS(2261),
    [anon_sym_fmul] = ACTIONS(2261),
    [anon_sym_fdiv] = ACTIONS(2261),
    [anon_sym_frem] = ACTIONS(2261),
    [anon_sym_xchg] = ACTIONS(2261),
    [anon_sym_add] = ACTIONS(2261),
    [anon_sym_sub] = ACTIONS(2261),
    [anon_sym_and] = ACTIONS(2261),
    [anon_sym_nand] = ACTIONS(2261),
    [anon_sym_or] = ACTIONS(2261),
    [anon_sym_xor] = ACTIONS(2261),
    [anon_sym_max] = ACTIONS(2261),
    [anon_sym_min] = ACTIONS(2261),
    [anon_sym_umax] = ACTIONS(2261),
    [anon_sym_umin] = ACTIONS(2261),
    [anon_sym_fadd] = ACTIONS(2261),
    [anon_sym_fsub] = ACTIONS(2261),
    [anon_sym_bitcast] = ACTIONS(2261),
    [anon_sym_trunc] = ACTIONS(2261),
    [anon_sym_zext] = ACTIONS(2261),
    [anon_sym_sext] = ACTIONS(2261),
    [anon_sym_fptrunc] = ACTIONS(2261),
    [anon_sym_fpext] = ACTIONS(2261),
    [anon_sym_addrspacecast] = ACTIONS(2261),
    [anon_sym_uitofp] = ACTIONS(2261),
    [anon_sym_sitofp] = ACTIONS(2261),
    [anon_sym_fptoui] = ACTIONS(2261),
    [anon_sym_fptosi] = ACTIONS(2261),
    [anon_sym_inttoptr] = ACTIONS(2261),
    [anon_sym_ptrtoint] = ACTIONS(2261),
    [anon_sym_uselistorder] = ACTIONS(2261),
  },
  [679] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(765),
    [sym_label] = ACTIONS(765),
    [anon_sym_RBRACE] = ACTIONS(765),
    [anon_sym_COMMA] = ACTIONS(765),
    [anon_sym_unreachable] = ACTIONS(767),
    [anon_sym_ret] = ACTIONS(767),
    [anon_sym_br] = ACTIONS(767),
    [anon_sym_resume] = ACTIONS(767),
    [anon_sym_freeze] = ACTIONS(767),
    [anon_sym_indirectbr] = ACTIONS(767),
    [anon_sym_extractelement] = ACTIONS(767),
    [anon_sym_insertelement] = ACTIONS(767),
    [anon_sym_select] = ACTIONS(767),
    [anon_sym_shufflevector] = ACTIONS(767),
    [anon_sym_fneg] = ACTIONS(767),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_invoke] = ACTIONS(767),
    [anon_sym_cleanupret] = ACTIONS(767),
    [anon_sym_catchret] = ACTIONS(767),
    [anon_sym_catchswitch] = ACTIONS(767),
    [anon_sym_catchpad] = ACTIONS(767),
    [anon_sym_cleanuppad] = ACTIONS(767),
    [anon_sym_callbr] = ACTIONS(767),
    [anon_sym_icmp] = ACTIONS(767),
    [anon_sym_fcmp] = ACTIONS(767),
    [anon_sym_va_arg] = ACTIONS(767),
    [anon_sym_phi] = ACTIONS(767),
    [anon_sym_landingpad] = ACTIONS(767),
    [anon_sym_tail] = ACTIONS(767),
    [anon_sym_musttail] = ACTIONS(767),
    [anon_sym_notail] = ACTIONS(767),
    [anon_sym_call] = ACTIONS(767),
    [anon_sym_alloca] = ACTIONS(767),
    [anon_sym_load] = ACTIONS(767),
    [anon_sym_store] = ACTIONS(767),
    [anon_sym_cmpxchg] = ACTIONS(767),
    [anon_sym_atomicrmw] = ACTIONS(767),
    [anon_sym_fence] = ACTIONS(767),
    [anon_sym_getelementptr] = ACTIONS(767),
    [anon_sym_extractvalue] = ACTIONS(767),
    [anon_sym_insertvalue] = ACTIONS(767),
    [anon_sym_mul] = ACTIONS(767),
    [anon_sym_urem] = ACTIONS(767),
    [anon_sym_srem] = ACTIONS(767),
    [anon_sym_shl] = ACTIONS(767),
    [anon_sym_udiv] = ACTIONS(767),
    [anon_sym_sdiv] = ACTIONS(767),
    [anon_sym_lshr] = ACTIONS(767),
    [anon_sym_ashr] = ACTIONS(767),
    [anon_sym_fmul] = ACTIONS(767),
    [anon_sym_fdiv] = ACTIONS(767),
    [anon_sym_frem] = ACTIONS(767),
    [anon_sym_xchg] = ACTIONS(767),
    [anon_sym_add] = ACTIONS(767),
    [anon_sym_sub] = ACTIONS(767),
    [anon_sym_and] = ACTIONS(767),
    [anon_sym_nand] = ACTIONS(767),
    [anon_sym_or] = ACTIONS(767),
    [anon_sym_xor] = ACTIONS(767),
    [anon_sym_max] = ACTIONS(767),
    [anon_sym_min] = ACTIONS(767),
    [anon_sym_umax] = ACTIONS(767),
    [anon_sym_umin] = ACTIONS(767),
    [anon_sym_fadd] = ACTIONS(767),
    [anon_sym_fsub] = ACTIONS(767),
    [anon_sym_bitcast] = ACTIONS(767),
    [anon_sym_trunc] = ACTIONS(767),
    [anon_sym_zext] = ACTIONS(767),
    [anon_sym_sext] = ACTIONS(767),
    [anon_sym_fptrunc] = ACTIONS(767),
    [anon_sym_fpext] = ACTIONS(767),
    [anon_sym_addrspacecast] = ACTIONS(767),
    [anon_sym_uitofp] = ACTIONS(767),
    [anon_sym_sitofp] = ACTIONS(767),
    [anon_sym_fptoui] = ACTIONS(767),
    [anon_sym_fptosi] = ACTIONS(767),
    [anon_sym_inttoptr] = ACTIONS(767),
    [anon_sym_ptrtoint] = ACTIONS(767),
    [anon_sym_uselistorder] = ACTIONS(767),
  },
  [680] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2263),
    [sym_label] = ACTIONS(2263),
    [anon_sym_RBRACE] = ACTIONS(2263),
    [anon_sym_COMMA] = ACTIONS(2263),
    [anon_sym_unreachable] = ACTIONS(2265),
    [anon_sym_ret] = ACTIONS(2265),
    [anon_sym_br] = ACTIONS(2265),
    [anon_sym_resume] = ACTIONS(2265),
    [anon_sym_freeze] = ACTIONS(2265),
    [anon_sym_indirectbr] = ACTIONS(2265),
    [anon_sym_extractelement] = ACTIONS(2265),
    [anon_sym_insertelement] = ACTIONS(2265),
    [anon_sym_select] = ACTIONS(2265),
    [anon_sym_shufflevector] = ACTIONS(2265),
    [anon_sym_fneg] = ACTIONS(2265),
    [anon_sym_switch] = ACTIONS(2265),
    [anon_sym_invoke] = ACTIONS(2265),
    [anon_sym_cleanupret] = ACTIONS(2265),
    [anon_sym_catchret] = ACTIONS(2265),
    [anon_sym_catchswitch] = ACTIONS(2265),
    [anon_sym_catchpad] = ACTIONS(2265),
    [anon_sym_cleanuppad] = ACTIONS(2265),
    [anon_sym_callbr] = ACTIONS(2265),
    [anon_sym_icmp] = ACTIONS(2265),
    [anon_sym_fcmp] = ACTIONS(2265),
    [anon_sym_va_arg] = ACTIONS(2265),
    [anon_sym_phi] = ACTIONS(2265),
    [anon_sym_landingpad] = ACTIONS(2265),
    [anon_sym_tail] = ACTIONS(2265),
    [anon_sym_musttail] = ACTIONS(2265),
    [anon_sym_notail] = ACTIONS(2265),
    [anon_sym_call] = ACTIONS(2265),
    [anon_sym_alloca] = ACTIONS(2265),
    [anon_sym_load] = ACTIONS(2265),
    [anon_sym_store] = ACTIONS(2265),
    [anon_sym_cmpxchg] = ACTIONS(2265),
    [anon_sym_atomicrmw] = ACTIONS(2265),
    [anon_sym_fence] = ACTIONS(2265),
    [anon_sym_getelementptr] = ACTIONS(2265),
    [anon_sym_extractvalue] = ACTIONS(2265),
    [anon_sym_insertvalue] = ACTIONS(2265),
    [anon_sym_mul] = ACTIONS(2265),
    [anon_sym_urem] = ACTIONS(2265),
    [anon_sym_srem] = ACTIONS(2265),
    [anon_sym_shl] = ACTIONS(2265),
    [anon_sym_udiv] = ACTIONS(2265),
    [anon_sym_sdiv] = ACTIONS(2265),
    [anon_sym_lshr] = ACTIONS(2265),
    [anon_sym_ashr] = ACTIONS(2265),
    [anon_sym_fmul] = ACTIONS(2265),
    [anon_sym_fdiv] = ACTIONS(2265),
    [anon_sym_frem] = ACTIONS(2265),
    [anon_sym_xchg] = ACTIONS(2265),
    [anon_sym_add] = ACTIONS(2265),
    [anon_sym_sub] = ACTIONS(2265),
    [anon_sym_and] = ACTIONS(2265),
    [anon_sym_nand] = ACTIONS(2265),
    [anon_sym_or] = ACTIONS(2265),
    [anon_sym_xor] = ACTIONS(2265),
    [anon_sym_max] = ACTIONS(2265),
    [anon_sym_min] = ACTIONS(2265),
    [anon_sym_umax] = ACTIONS(2265),
    [anon_sym_umin] = ACTIONS(2265),
    [anon_sym_fadd] = ACTIONS(2265),
    [anon_sym_fsub] = ACTIONS(2265),
    [anon_sym_bitcast] = ACTIONS(2265),
    [anon_sym_trunc] = ACTIONS(2265),
    [anon_sym_zext] = ACTIONS(2265),
    [anon_sym_sext] = ACTIONS(2265),
    [anon_sym_fptrunc] = ACTIONS(2265),
    [anon_sym_fpext] = ACTIONS(2265),
    [anon_sym_addrspacecast] = ACTIONS(2265),
    [anon_sym_uitofp] = ACTIONS(2265),
    [anon_sym_sitofp] = ACTIONS(2265),
    [anon_sym_fptoui] = ACTIONS(2265),
    [anon_sym_fptosi] = ACTIONS(2265),
    [anon_sym_inttoptr] = ACTIONS(2265),
    [anon_sym_ptrtoint] = ACTIONS(2265),
    [anon_sym_uselistorder] = ACTIONS(2265),
  },
  [681] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2267),
    [sym_label] = ACTIONS(2267),
    [anon_sym_RBRACE] = ACTIONS(2267),
    [anon_sym_COMMA] = ACTIONS(2267),
    [anon_sym_unreachable] = ACTIONS(2269),
    [anon_sym_ret] = ACTIONS(2269),
    [anon_sym_br] = ACTIONS(2269),
    [anon_sym_resume] = ACTIONS(2269),
    [anon_sym_freeze] = ACTIONS(2269),
    [anon_sym_indirectbr] = ACTIONS(2269),
    [anon_sym_extractelement] = ACTIONS(2269),
    [anon_sym_insertelement] = ACTIONS(2269),
    [anon_sym_select] = ACTIONS(2269),
    [anon_sym_shufflevector] = ACTIONS(2269),
    [anon_sym_fneg] = ACTIONS(2269),
    [anon_sym_switch] = ACTIONS(2269),
    [anon_sym_invoke] = ACTIONS(2269),
    [anon_sym_cleanupret] = ACTIONS(2269),
    [anon_sym_catchret] = ACTIONS(2269),
    [anon_sym_catchswitch] = ACTIONS(2269),
    [anon_sym_catchpad] = ACTIONS(2269),
    [anon_sym_cleanuppad] = ACTIONS(2269),
    [anon_sym_callbr] = ACTIONS(2269),
    [anon_sym_icmp] = ACTIONS(2269),
    [anon_sym_fcmp] = ACTIONS(2269),
    [anon_sym_va_arg] = ACTIONS(2269),
    [anon_sym_phi] = ACTIONS(2269),
    [anon_sym_landingpad] = ACTIONS(2269),
    [anon_sym_tail] = ACTIONS(2269),
    [anon_sym_musttail] = ACTIONS(2269),
    [anon_sym_notail] = ACTIONS(2269),
    [anon_sym_call] = ACTIONS(2269),
    [anon_sym_alloca] = ACTIONS(2269),
    [anon_sym_load] = ACTIONS(2269),
    [anon_sym_store] = ACTIONS(2269),
    [anon_sym_cmpxchg] = ACTIONS(2269),
    [anon_sym_atomicrmw] = ACTIONS(2269),
    [anon_sym_fence] = ACTIONS(2269),
    [anon_sym_getelementptr] = ACTIONS(2269),
    [anon_sym_extractvalue] = ACTIONS(2269),
    [anon_sym_insertvalue] = ACTIONS(2269),
    [anon_sym_mul] = ACTIONS(2269),
    [anon_sym_urem] = ACTIONS(2269),
    [anon_sym_srem] = ACTIONS(2269),
    [anon_sym_shl] = ACTIONS(2269),
    [anon_sym_udiv] = ACTIONS(2269),
    [anon_sym_sdiv] = ACTIONS(2269),
    [anon_sym_lshr] = ACTIONS(2269),
    [anon_sym_ashr] = ACTIONS(2269),
    [anon_sym_fmul] = ACTIONS(2269),
    [anon_sym_fdiv] = ACTIONS(2269),
    [anon_sym_frem] = ACTIONS(2269),
    [anon_sym_xchg] = ACTIONS(2269),
    [anon_sym_add] = ACTIONS(2269),
    [anon_sym_sub] = ACTIONS(2269),
    [anon_sym_and] = ACTIONS(2269),
    [anon_sym_nand] = ACTIONS(2269),
    [anon_sym_or] = ACTIONS(2269),
    [anon_sym_xor] = ACTIONS(2269),
    [anon_sym_max] = ACTIONS(2269),
    [anon_sym_min] = ACTIONS(2269),
    [anon_sym_umax] = ACTIONS(2269),
    [anon_sym_umin] = ACTIONS(2269),
    [anon_sym_fadd] = ACTIONS(2269),
    [anon_sym_fsub] = ACTIONS(2269),
    [anon_sym_bitcast] = ACTIONS(2269),
    [anon_sym_trunc] = ACTIONS(2269),
    [anon_sym_zext] = ACTIONS(2269),
    [anon_sym_sext] = ACTIONS(2269),
    [anon_sym_fptrunc] = ACTIONS(2269),
    [anon_sym_fpext] = ACTIONS(2269),
    [anon_sym_addrspacecast] = ACTIONS(2269),
    [anon_sym_uitofp] = ACTIONS(2269),
    [anon_sym_sitofp] = ACTIONS(2269),
    [anon_sym_fptoui] = ACTIONS(2269),
    [anon_sym_fptosi] = ACTIONS(2269),
    [anon_sym_inttoptr] = ACTIONS(2269),
    [anon_sym_ptrtoint] = ACTIONS(2269),
    [anon_sym_uselistorder] = ACTIONS(2269),
  },
  [682] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2271),
    [sym_label] = ACTIONS(2271),
    [anon_sym_RBRACE] = ACTIONS(2271),
    [anon_sym_COMMA] = ACTIONS(2271),
    [anon_sym_unreachable] = ACTIONS(2273),
    [anon_sym_ret] = ACTIONS(2273),
    [anon_sym_br] = ACTIONS(2273),
    [anon_sym_resume] = ACTIONS(2273),
    [anon_sym_freeze] = ACTIONS(2273),
    [anon_sym_indirectbr] = ACTIONS(2273),
    [anon_sym_extractelement] = ACTIONS(2273),
    [anon_sym_insertelement] = ACTIONS(2273),
    [anon_sym_select] = ACTIONS(2273),
    [anon_sym_shufflevector] = ACTIONS(2273),
    [anon_sym_fneg] = ACTIONS(2273),
    [anon_sym_switch] = ACTIONS(2273),
    [anon_sym_invoke] = ACTIONS(2273),
    [anon_sym_cleanupret] = ACTIONS(2273),
    [anon_sym_catchret] = ACTIONS(2273),
    [anon_sym_catchswitch] = ACTIONS(2273),
    [anon_sym_catchpad] = ACTIONS(2273),
    [anon_sym_cleanuppad] = ACTIONS(2273),
    [anon_sym_callbr] = ACTIONS(2273),
    [anon_sym_icmp] = ACTIONS(2273),
    [anon_sym_fcmp] = ACTIONS(2273),
    [anon_sym_va_arg] = ACTIONS(2273),
    [anon_sym_phi] = ACTIONS(2273),
    [anon_sym_landingpad] = ACTIONS(2273),
    [anon_sym_tail] = ACTIONS(2273),
    [anon_sym_musttail] = ACTIONS(2273),
    [anon_sym_notail] = ACTIONS(2273),
    [anon_sym_call] = ACTIONS(2273),
    [anon_sym_alloca] = ACTIONS(2273),
    [anon_sym_load] = ACTIONS(2273),
    [anon_sym_store] = ACTIONS(2273),
    [anon_sym_cmpxchg] = ACTIONS(2273),
    [anon_sym_atomicrmw] = ACTIONS(2273),
    [anon_sym_fence] = ACTIONS(2273),
    [anon_sym_getelementptr] = ACTIONS(2273),
    [anon_sym_extractvalue] = ACTIONS(2273),
    [anon_sym_insertvalue] = ACTIONS(2273),
    [anon_sym_mul] = ACTIONS(2273),
    [anon_sym_urem] = ACTIONS(2273),
    [anon_sym_srem] = ACTIONS(2273),
    [anon_sym_shl] = ACTIONS(2273),
    [anon_sym_udiv] = ACTIONS(2273),
    [anon_sym_sdiv] = ACTIONS(2273),
    [anon_sym_lshr] = ACTIONS(2273),
    [anon_sym_ashr] = ACTIONS(2273),
    [anon_sym_fmul] = ACTIONS(2273),
    [anon_sym_fdiv] = ACTIONS(2273),
    [anon_sym_frem] = ACTIONS(2273),
    [anon_sym_xchg] = ACTIONS(2273),
    [anon_sym_add] = ACTIONS(2273),
    [anon_sym_sub] = ACTIONS(2273),
    [anon_sym_and] = ACTIONS(2273),
    [anon_sym_nand] = ACTIONS(2273),
    [anon_sym_or] = ACTIONS(2273),
    [anon_sym_xor] = ACTIONS(2273),
    [anon_sym_max] = ACTIONS(2273),
    [anon_sym_min] = ACTIONS(2273),
    [anon_sym_umax] = ACTIONS(2273),
    [anon_sym_umin] = ACTIONS(2273),
    [anon_sym_fadd] = ACTIONS(2273),
    [anon_sym_fsub] = ACTIONS(2273),
    [anon_sym_bitcast] = ACTIONS(2273),
    [anon_sym_trunc] = ACTIONS(2273),
    [anon_sym_zext] = ACTIONS(2273),
    [anon_sym_sext] = ACTIONS(2273),
    [anon_sym_fptrunc] = ACTIONS(2273),
    [anon_sym_fpext] = ACTIONS(2273),
    [anon_sym_addrspacecast] = ACTIONS(2273),
    [anon_sym_uitofp] = ACTIONS(2273),
    [anon_sym_sitofp] = ACTIONS(2273),
    [anon_sym_fptoui] = ACTIONS(2273),
    [anon_sym_fptosi] = ACTIONS(2273),
    [anon_sym_inttoptr] = ACTIONS(2273),
    [anon_sym_ptrtoint] = ACTIONS(2273),
    [anon_sym_uselistorder] = ACTIONS(2273),
  },
  [683] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2271),
    [sym_label] = ACTIONS(2271),
    [anon_sym_RBRACE] = ACTIONS(2271),
    [anon_sym_COMMA] = ACTIONS(2275),
    [anon_sym_unreachable] = ACTIONS(2273),
    [anon_sym_ret] = ACTIONS(2273),
    [anon_sym_br] = ACTIONS(2273),
    [anon_sym_resume] = ACTIONS(2273),
    [anon_sym_freeze] = ACTIONS(2273),
    [anon_sym_indirectbr] = ACTIONS(2273),
    [anon_sym_extractelement] = ACTIONS(2273),
    [anon_sym_insertelement] = ACTIONS(2273),
    [anon_sym_select] = ACTIONS(2273),
    [anon_sym_shufflevector] = ACTIONS(2273),
    [anon_sym_fneg] = ACTIONS(2273),
    [anon_sym_switch] = ACTIONS(2273),
    [anon_sym_invoke] = ACTIONS(2273),
    [anon_sym_cleanupret] = ACTIONS(2273),
    [anon_sym_catchret] = ACTIONS(2273),
    [anon_sym_catchswitch] = ACTIONS(2273),
    [anon_sym_catchpad] = ACTIONS(2273),
    [anon_sym_cleanuppad] = ACTIONS(2273),
    [anon_sym_callbr] = ACTIONS(2273),
    [anon_sym_icmp] = ACTIONS(2273),
    [anon_sym_fcmp] = ACTIONS(2273),
    [anon_sym_va_arg] = ACTIONS(2273),
    [anon_sym_phi] = ACTIONS(2273),
    [anon_sym_landingpad] = ACTIONS(2273),
    [anon_sym_tail] = ACTIONS(2273),
    [anon_sym_musttail] = ACTIONS(2273),
    [anon_sym_notail] = ACTIONS(2273),
    [anon_sym_call] = ACTIONS(2273),
    [anon_sym_alloca] = ACTIONS(2273),
    [anon_sym_load] = ACTIONS(2273),
    [anon_sym_store] = ACTIONS(2273),
    [anon_sym_cmpxchg] = ACTIONS(2273),
    [anon_sym_atomicrmw] = ACTIONS(2273),
    [anon_sym_fence] = ACTIONS(2273),
    [anon_sym_getelementptr] = ACTIONS(2273),
    [anon_sym_extractvalue] = ACTIONS(2273),
    [anon_sym_insertvalue] = ACTIONS(2273),
    [anon_sym_mul] = ACTIONS(2273),
    [anon_sym_urem] = ACTIONS(2273),
    [anon_sym_srem] = ACTIONS(2273),
    [anon_sym_shl] = ACTIONS(2273),
    [anon_sym_udiv] = ACTIONS(2273),
    [anon_sym_sdiv] = ACTIONS(2273),
    [anon_sym_lshr] = ACTIONS(2273),
    [anon_sym_ashr] = ACTIONS(2273),
    [anon_sym_fmul] = ACTIONS(2273),
    [anon_sym_fdiv] = ACTIONS(2273),
    [anon_sym_frem] = ACTIONS(2273),
    [anon_sym_xchg] = ACTIONS(2273),
    [anon_sym_add] = ACTIONS(2273),
    [anon_sym_sub] = ACTIONS(2273),
    [anon_sym_and] = ACTIONS(2273),
    [anon_sym_nand] = ACTIONS(2273),
    [anon_sym_or] = ACTIONS(2273),
    [anon_sym_xor] = ACTIONS(2273),
    [anon_sym_max] = ACTIONS(2273),
    [anon_sym_min] = ACTIONS(2273),
    [anon_sym_umax] = ACTIONS(2273),
    [anon_sym_umin] = ACTIONS(2273),
    [anon_sym_fadd] = ACTIONS(2273),
    [anon_sym_fsub] = ACTIONS(2273),
    [anon_sym_bitcast] = ACTIONS(2273),
    [anon_sym_trunc] = ACTIONS(2273),
    [anon_sym_zext] = ACTIONS(2273),
    [anon_sym_sext] = ACTIONS(2273),
    [anon_sym_fptrunc] = ACTIONS(2273),
    [anon_sym_fpext] = ACTIONS(2273),
    [anon_sym_addrspacecast] = ACTIONS(2273),
    [anon_sym_uitofp] = ACTIONS(2273),
    [anon_sym_sitofp] = ACTIONS(2273),
    [anon_sym_fptoui] = ACTIONS(2273),
    [anon_sym_fptosi] = ACTIONS(2273),
    [anon_sym_inttoptr] = ACTIONS(2273),
    [anon_sym_ptrtoint] = ACTIONS(2273),
    [anon_sym_uselistorder] = ACTIONS(2273),
  },
  [684] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2278),
    [sym_label] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_COMMA] = ACTIONS(2280),
    [anon_sym_unreachable] = ACTIONS(2283),
    [anon_sym_ret] = ACTIONS(2283),
    [anon_sym_br] = ACTIONS(2283),
    [anon_sym_resume] = ACTIONS(2283),
    [anon_sym_freeze] = ACTIONS(2283),
    [anon_sym_indirectbr] = ACTIONS(2283),
    [anon_sym_extractelement] = ACTIONS(2283),
    [anon_sym_insertelement] = ACTIONS(2283),
    [anon_sym_select] = ACTIONS(2283),
    [anon_sym_shufflevector] = ACTIONS(2283),
    [anon_sym_fneg] = ACTIONS(2283),
    [anon_sym_switch] = ACTIONS(2283),
    [anon_sym_invoke] = ACTIONS(2283),
    [anon_sym_cleanupret] = ACTIONS(2283),
    [anon_sym_catchret] = ACTIONS(2283),
    [anon_sym_catchswitch] = ACTIONS(2283),
    [anon_sym_catchpad] = ACTIONS(2283),
    [anon_sym_cleanuppad] = ACTIONS(2283),
    [anon_sym_callbr] = ACTIONS(2283),
    [anon_sym_icmp] = ACTIONS(2283),
    [anon_sym_fcmp] = ACTIONS(2283),
    [anon_sym_va_arg] = ACTIONS(2283),
    [anon_sym_phi] = ACTIONS(2283),
    [anon_sym_landingpad] = ACTIONS(2283),
    [anon_sym_tail] = ACTIONS(2283),
    [anon_sym_musttail] = ACTIONS(2283),
    [anon_sym_notail] = ACTIONS(2283),
    [anon_sym_call] = ACTIONS(2283),
    [anon_sym_alloca] = ACTIONS(2283),
    [anon_sym_load] = ACTIONS(2283),
    [anon_sym_store] = ACTIONS(2283),
    [anon_sym_cmpxchg] = ACTIONS(2283),
    [anon_sym_atomicrmw] = ACTIONS(2283),
    [anon_sym_fence] = ACTIONS(2283),
    [anon_sym_getelementptr] = ACTIONS(2283),
    [anon_sym_extractvalue] = ACTIONS(2283),
    [anon_sym_insertvalue] = ACTIONS(2283),
    [anon_sym_mul] = ACTIONS(2283),
    [anon_sym_urem] = ACTIONS(2283),
    [anon_sym_srem] = ACTIONS(2283),
    [anon_sym_shl] = ACTIONS(2283),
    [anon_sym_udiv] = ACTIONS(2283),
    [anon_sym_sdiv] = ACTIONS(2283),
    [anon_sym_lshr] = ACTIONS(2283),
    [anon_sym_ashr] = ACTIONS(2283),
    [anon_sym_fmul] = ACTIONS(2283),
    [anon_sym_fdiv] = ACTIONS(2283),
    [anon_sym_frem] = ACTIONS(2283),
    [anon_sym_xchg] = ACTIONS(2283),
    [anon_sym_add] = ACTIONS(2283),
    [anon_sym_sub] = ACTIONS(2283),
    [anon_sym_and] = ACTIONS(2283),
    [anon_sym_nand] = ACTIONS(2283),
    [anon_sym_or] = ACTIONS(2283),
    [anon_sym_xor] = ACTIONS(2283),
    [anon_sym_max] = ACTIONS(2283),
    [anon_sym_min] = ACTIONS(2283),
    [anon_sym_umax] = ACTIONS(2283),
    [anon_sym_umin] = ACTIONS(2283),
    [anon_sym_fadd] = ACTIONS(2283),
    [anon_sym_fsub] = ACTIONS(2283),
    [anon_sym_bitcast] = ACTIONS(2283),
    [anon_sym_trunc] = ACTIONS(2283),
    [anon_sym_zext] = ACTIONS(2283),
    [anon_sym_sext] = ACTIONS(2283),
    [anon_sym_fptrunc] = ACTIONS(2283),
    [anon_sym_fpext] = ACTIONS(2283),
    [anon_sym_addrspacecast] = ACTIONS(2283),
    [anon_sym_uitofp] = ACTIONS(2283),
    [anon_sym_sitofp] = ACTIONS(2283),
    [anon_sym_fptoui] = ACTIONS(2283),
    [anon_sym_fptosi] = ACTIONS(2283),
    [anon_sym_inttoptr] = ACTIONS(2283),
    [anon_sym_ptrtoint] = ACTIONS(2283),
    [anon_sym_uselistorder] = ACTIONS(2283),
  },
  [685] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2285),
    [sym_label] = ACTIONS(2285),
    [anon_sym_RBRACE] = ACTIONS(2285),
    [anon_sym_COMMA] = ACTIONS(2287),
    [anon_sym_unreachable] = ACTIONS(2290),
    [anon_sym_ret] = ACTIONS(2290),
    [anon_sym_br] = ACTIONS(2290),
    [anon_sym_resume] = ACTIONS(2290),
    [anon_sym_freeze] = ACTIONS(2290),
    [anon_sym_indirectbr] = ACTIONS(2290),
    [anon_sym_extractelement] = ACTIONS(2290),
    [anon_sym_insertelement] = ACTIONS(2290),
    [anon_sym_select] = ACTIONS(2290),
    [anon_sym_shufflevector] = ACTIONS(2290),
    [anon_sym_fneg] = ACTIONS(2290),
    [anon_sym_switch] = ACTIONS(2290),
    [anon_sym_invoke] = ACTIONS(2290),
    [anon_sym_cleanupret] = ACTIONS(2290),
    [anon_sym_catchret] = ACTIONS(2290),
    [anon_sym_catchswitch] = ACTIONS(2290),
    [anon_sym_catchpad] = ACTIONS(2290),
    [anon_sym_cleanuppad] = ACTIONS(2290),
    [anon_sym_callbr] = ACTIONS(2290),
    [anon_sym_icmp] = ACTIONS(2290),
    [anon_sym_fcmp] = ACTIONS(2290),
    [anon_sym_va_arg] = ACTIONS(2290),
    [anon_sym_phi] = ACTIONS(2290),
    [anon_sym_landingpad] = ACTIONS(2290),
    [anon_sym_tail] = ACTIONS(2290),
    [anon_sym_musttail] = ACTIONS(2290),
    [anon_sym_notail] = ACTIONS(2290),
    [anon_sym_call] = ACTIONS(2290),
    [anon_sym_alloca] = ACTIONS(2290),
    [anon_sym_load] = ACTIONS(2290),
    [anon_sym_store] = ACTIONS(2290),
    [anon_sym_cmpxchg] = ACTIONS(2290),
    [anon_sym_atomicrmw] = ACTIONS(2290),
    [anon_sym_fence] = ACTIONS(2290),
    [anon_sym_getelementptr] = ACTIONS(2290),
    [anon_sym_extractvalue] = ACTIONS(2290),
    [anon_sym_insertvalue] = ACTIONS(2290),
    [anon_sym_mul] = ACTIONS(2290),
    [anon_sym_urem] = ACTIONS(2290),
    [anon_sym_srem] = ACTIONS(2290),
    [anon_sym_shl] = ACTIONS(2290),
    [anon_sym_udiv] = ACTIONS(2290),
    [anon_sym_sdiv] = ACTIONS(2290),
    [anon_sym_lshr] = ACTIONS(2290),
    [anon_sym_ashr] = ACTIONS(2290),
    [anon_sym_fmul] = ACTIONS(2290),
    [anon_sym_fdiv] = ACTIONS(2290),
    [anon_sym_frem] = ACTIONS(2290),
    [anon_sym_xchg] = ACTIONS(2290),
    [anon_sym_add] = ACTIONS(2290),
    [anon_sym_sub] = ACTIONS(2290),
    [anon_sym_and] = ACTIONS(2290),
    [anon_sym_nand] = ACTIONS(2290),
    [anon_sym_or] = ACTIONS(2290),
    [anon_sym_xor] = ACTIONS(2290),
    [anon_sym_max] = ACTIONS(2290),
    [anon_sym_min] = ACTIONS(2290),
    [anon_sym_umax] = ACTIONS(2290),
    [anon_sym_umin] = ACTIONS(2290),
    [anon_sym_fadd] = ACTIONS(2290),
    [anon_sym_fsub] = ACTIONS(2290),
    [anon_sym_bitcast] = ACTIONS(2290),
    [anon_sym_trunc] = ACTIONS(2290),
    [anon_sym_zext] = ACTIONS(2290),
    [anon_sym_sext] = ACTIONS(2290),
    [anon_sym_fptrunc] = ACTIONS(2290),
    [anon_sym_fpext] = ACTIONS(2290),
    [anon_sym_addrspacecast] = ACTIONS(2290),
    [anon_sym_uitofp] = ACTIONS(2290),
    [anon_sym_sitofp] = ACTIONS(2290),
    [anon_sym_fptoui] = ACTIONS(2290),
    [anon_sym_fptosi] = ACTIONS(2290),
    [anon_sym_inttoptr] = ACTIONS(2290),
    [anon_sym_ptrtoint] = ACTIONS(2290),
    [anon_sym_uselistorder] = ACTIONS(2290),
  },
  [686] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2292),
    [sym_label] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(2292),
    [anon_sym_COMMA] = ACTIONS(2292),
    [anon_sym_unreachable] = ACTIONS(2294),
    [anon_sym_ret] = ACTIONS(2294),
    [anon_sym_br] = ACTIONS(2294),
    [anon_sym_resume] = ACTIONS(2294),
    [anon_sym_freeze] = ACTIONS(2294),
    [anon_sym_indirectbr] = ACTIONS(2294),
    [anon_sym_extractelement] = ACTIONS(2294),
    [anon_sym_insertelement] = ACTIONS(2294),
    [anon_sym_select] = ACTIONS(2294),
    [anon_sym_shufflevector] = ACTIONS(2294),
    [anon_sym_fneg] = ACTIONS(2294),
    [anon_sym_switch] = ACTIONS(2294),
    [anon_sym_invoke] = ACTIONS(2294),
    [anon_sym_cleanupret] = ACTIONS(2294),
    [anon_sym_catchret] = ACTIONS(2294),
    [anon_sym_catchswitch] = ACTIONS(2294),
    [anon_sym_catchpad] = ACTIONS(2294),
    [anon_sym_cleanuppad] = ACTIONS(2294),
    [anon_sym_callbr] = ACTIONS(2294),
    [anon_sym_icmp] = ACTIONS(2294),
    [anon_sym_fcmp] = ACTIONS(2294),
    [anon_sym_va_arg] = ACTIONS(2294),
    [anon_sym_phi] = ACTIONS(2294),
    [anon_sym_landingpad] = ACTIONS(2294),
    [anon_sym_tail] = ACTIONS(2294),
    [anon_sym_musttail] = ACTIONS(2294),
    [anon_sym_notail] = ACTIONS(2294),
    [anon_sym_call] = ACTIONS(2294),
    [anon_sym_alloca] = ACTIONS(2294),
    [anon_sym_load] = ACTIONS(2294),
    [anon_sym_store] = ACTIONS(2294),
    [anon_sym_cmpxchg] = ACTIONS(2294),
    [anon_sym_atomicrmw] = ACTIONS(2294),
    [anon_sym_fence] = ACTIONS(2294),
    [anon_sym_getelementptr] = ACTIONS(2294),
    [anon_sym_extractvalue] = ACTIONS(2294),
    [anon_sym_insertvalue] = ACTIONS(2294),
    [anon_sym_mul] = ACTIONS(2294),
    [anon_sym_urem] = ACTIONS(2294),
    [anon_sym_srem] = ACTIONS(2294),
    [anon_sym_shl] = ACTIONS(2294),
    [anon_sym_udiv] = ACTIONS(2294),
    [anon_sym_sdiv] = ACTIONS(2294),
    [anon_sym_lshr] = ACTIONS(2294),
    [anon_sym_ashr] = ACTIONS(2294),
    [anon_sym_fmul] = ACTIONS(2294),
    [anon_sym_fdiv] = ACTIONS(2294),
    [anon_sym_frem] = ACTIONS(2294),
    [anon_sym_xchg] = ACTIONS(2294),
    [anon_sym_add] = ACTIONS(2294),
    [anon_sym_sub] = ACTIONS(2294),
    [anon_sym_and] = ACTIONS(2294),
    [anon_sym_nand] = ACTIONS(2294),
    [anon_sym_or] = ACTIONS(2294),
    [anon_sym_xor] = ACTIONS(2294),
    [anon_sym_max] = ACTIONS(2294),
    [anon_sym_min] = ACTIONS(2294),
    [anon_sym_umax] = ACTIONS(2294),
    [anon_sym_umin] = ACTIONS(2294),
    [anon_sym_fadd] = ACTIONS(2294),
    [anon_sym_fsub] = ACTIONS(2294),
    [anon_sym_bitcast] = ACTIONS(2294),
    [anon_sym_trunc] = ACTIONS(2294),
    [anon_sym_zext] = ACTIONS(2294),
    [anon_sym_sext] = ACTIONS(2294),
    [anon_sym_fptrunc] = ACTIONS(2294),
    [anon_sym_fpext] = ACTIONS(2294),
    [anon_sym_addrspacecast] = ACTIONS(2294),
    [anon_sym_uitofp] = ACTIONS(2294),
    [anon_sym_sitofp] = ACTIONS(2294),
    [anon_sym_fptoui] = ACTIONS(2294),
    [anon_sym_fptosi] = ACTIONS(2294),
    [anon_sym_inttoptr] = ACTIONS(2294),
    [anon_sym_ptrtoint] = ACTIONS(2294),
    [anon_sym_uselistorder] = ACTIONS(2294),
  },
  [687] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2296),
    [sym_label] = ACTIONS(2296),
    [anon_sym_RBRACE] = ACTIONS(2296),
    [anon_sym_COMMA] = ACTIONS(2296),
    [anon_sym_unreachable] = ACTIONS(2298),
    [anon_sym_ret] = ACTIONS(2298),
    [anon_sym_br] = ACTIONS(2298),
    [anon_sym_resume] = ACTIONS(2298),
    [anon_sym_freeze] = ACTIONS(2298),
    [anon_sym_indirectbr] = ACTIONS(2298),
    [anon_sym_extractelement] = ACTIONS(2298),
    [anon_sym_insertelement] = ACTIONS(2298),
    [anon_sym_select] = ACTIONS(2298),
    [anon_sym_shufflevector] = ACTIONS(2298),
    [anon_sym_fneg] = ACTIONS(2298),
    [anon_sym_switch] = ACTIONS(2298),
    [anon_sym_invoke] = ACTIONS(2298),
    [anon_sym_cleanupret] = ACTIONS(2298),
    [anon_sym_catchret] = ACTIONS(2298),
    [anon_sym_catchswitch] = ACTIONS(2298),
    [anon_sym_catchpad] = ACTIONS(2298),
    [anon_sym_cleanuppad] = ACTIONS(2298),
    [anon_sym_callbr] = ACTIONS(2298),
    [anon_sym_icmp] = ACTIONS(2298),
    [anon_sym_fcmp] = ACTIONS(2298),
    [anon_sym_va_arg] = ACTIONS(2298),
    [anon_sym_phi] = ACTIONS(2298),
    [anon_sym_landingpad] = ACTIONS(2298),
    [anon_sym_tail] = ACTIONS(2298),
    [anon_sym_musttail] = ACTIONS(2298),
    [anon_sym_notail] = ACTIONS(2298),
    [anon_sym_call] = ACTIONS(2298),
    [anon_sym_alloca] = ACTIONS(2298),
    [anon_sym_load] = ACTIONS(2298),
    [anon_sym_store] = ACTIONS(2298),
    [anon_sym_cmpxchg] = ACTIONS(2298),
    [anon_sym_atomicrmw] = ACTIONS(2298),
    [anon_sym_fence] = ACTIONS(2298),
    [anon_sym_getelementptr] = ACTIONS(2298),
    [anon_sym_extractvalue] = ACTIONS(2298),
    [anon_sym_insertvalue] = ACTIONS(2298),
    [anon_sym_mul] = ACTIONS(2298),
    [anon_sym_urem] = ACTIONS(2298),
    [anon_sym_srem] = ACTIONS(2298),
    [anon_sym_shl] = ACTIONS(2298),
    [anon_sym_udiv] = ACTIONS(2298),
    [anon_sym_sdiv] = ACTIONS(2298),
    [anon_sym_lshr] = ACTIONS(2298),
    [anon_sym_ashr] = ACTIONS(2298),
    [anon_sym_fmul] = ACTIONS(2298),
    [anon_sym_fdiv] = ACTIONS(2298),
    [anon_sym_frem] = ACTIONS(2298),
    [anon_sym_xchg] = ACTIONS(2298),
    [anon_sym_add] = ACTIONS(2298),
    [anon_sym_sub] = ACTIONS(2298),
    [anon_sym_and] = ACTIONS(2298),
    [anon_sym_nand] = ACTIONS(2298),
    [anon_sym_or] = ACTIONS(2298),
    [anon_sym_xor] = ACTIONS(2298),
    [anon_sym_max] = ACTIONS(2298),
    [anon_sym_min] = ACTIONS(2298),
    [anon_sym_umax] = ACTIONS(2298),
    [anon_sym_umin] = ACTIONS(2298),
    [anon_sym_fadd] = ACTIONS(2298),
    [anon_sym_fsub] = ACTIONS(2298),
    [anon_sym_bitcast] = ACTIONS(2298),
    [anon_sym_trunc] = ACTIONS(2298),
    [anon_sym_zext] = ACTIONS(2298),
    [anon_sym_sext] = ACTIONS(2298),
    [anon_sym_fptrunc] = ACTIONS(2298),
    [anon_sym_fpext] = ACTIONS(2298),
    [anon_sym_addrspacecast] = ACTIONS(2298),
    [anon_sym_uitofp] = ACTIONS(2298),
    [anon_sym_sitofp] = ACTIONS(2298),
    [anon_sym_fptoui] = ACTIONS(2298),
    [anon_sym_fptosi] = ACTIONS(2298),
    [anon_sym_inttoptr] = ACTIONS(2298),
    [anon_sym_ptrtoint] = ACTIONS(2298),
    [anon_sym_uselistorder] = ACTIONS(2298),
  },
  [688] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(777),
    [sym_label] = ACTIONS(777),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_unreachable] = ACTIONS(779),
    [anon_sym_ret] = ACTIONS(779),
    [anon_sym_br] = ACTIONS(779),
    [anon_sym_resume] = ACTIONS(779),
    [anon_sym_freeze] = ACTIONS(779),
    [anon_sym_indirectbr] = ACTIONS(779),
    [anon_sym_extractelement] = ACTIONS(779),
    [anon_sym_insertelement] = ACTIONS(779),
    [anon_sym_select] = ACTIONS(779),
    [anon_sym_shufflevector] = ACTIONS(779),
    [anon_sym_fneg] = ACTIONS(779),
    [anon_sym_switch] = ACTIONS(779),
    [anon_sym_invoke] = ACTIONS(779),
    [anon_sym_cleanupret] = ACTIONS(779),
    [anon_sym_catchret] = ACTIONS(779),
    [anon_sym_catchswitch] = ACTIONS(779),
    [anon_sym_catchpad] = ACTIONS(779),
    [anon_sym_cleanuppad] = ACTIONS(779),
    [anon_sym_callbr] = ACTIONS(779),
    [anon_sym_icmp] = ACTIONS(779),
    [anon_sym_fcmp] = ACTIONS(779),
    [anon_sym_va_arg] = ACTIONS(779),
    [anon_sym_phi] = ACTIONS(779),
    [anon_sym_landingpad] = ACTIONS(779),
    [anon_sym_tail] = ACTIONS(779),
    [anon_sym_musttail] = ACTIONS(779),
    [anon_sym_notail] = ACTIONS(779),
    [anon_sym_call] = ACTIONS(779),
    [anon_sym_alloca] = ACTIONS(779),
    [anon_sym_load] = ACTIONS(779),
    [anon_sym_store] = ACTIONS(779),
    [anon_sym_cmpxchg] = ACTIONS(779),
    [anon_sym_atomicrmw] = ACTIONS(779),
    [anon_sym_fence] = ACTIONS(779),
    [anon_sym_getelementptr] = ACTIONS(779),
    [anon_sym_extractvalue] = ACTIONS(779),
    [anon_sym_insertvalue] = ACTIONS(779),
    [anon_sym_mul] = ACTIONS(779),
    [anon_sym_urem] = ACTIONS(779),
    [anon_sym_srem] = ACTIONS(779),
    [anon_sym_shl] = ACTIONS(779),
    [anon_sym_udiv] = ACTIONS(779),
    [anon_sym_sdiv] = ACTIONS(779),
    [anon_sym_lshr] = ACTIONS(779),
    [anon_sym_ashr] = ACTIONS(779),
    [anon_sym_fmul] = ACTIONS(779),
    [anon_sym_fdiv] = ACTIONS(779),
    [anon_sym_frem] = ACTIONS(779),
    [anon_sym_xchg] = ACTIONS(779),
    [anon_sym_add] = ACTIONS(779),
    [anon_sym_sub] = ACTIONS(779),
    [anon_sym_and] = ACTIONS(779),
    [anon_sym_nand] = ACTIONS(779),
    [anon_sym_or] = ACTIONS(779),
    [anon_sym_xor] = ACTIONS(779),
    [anon_sym_max] = ACTIONS(779),
    [anon_sym_min] = ACTIONS(779),
    [anon_sym_umax] = ACTIONS(779),
    [anon_sym_umin] = ACTIONS(779),
    [anon_sym_fadd] = ACTIONS(779),
    [anon_sym_fsub] = ACTIONS(779),
    [anon_sym_bitcast] = ACTIONS(779),
    [anon_sym_trunc] = ACTIONS(779),
    [anon_sym_zext] = ACTIONS(779),
    [anon_sym_sext] = ACTIONS(779),
    [anon_sym_fptrunc] = ACTIONS(779),
    [anon_sym_fpext] = ACTIONS(779),
    [anon_sym_addrspacecast] = ACTIONS(779),
    [anon_sym_uitofp] = ACTIONS(779),
    [anon_sym_sitofp] = ACTIONS(779),
    [anon_sym_fptoui] = ACTIONS(779),
    [anon_sym_fptosi] = ACTIONS(779),
    [anon_sym_inttoptr] = ACTIONS(779),
    [anon_sym_ptrtoint] = ACTIONS(779),
    [anon_sym_uselistorder] = ACTIONS(779),
  },
  [689] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2300),
    [sym_label] = ACTIONS(2300),
    [anon_sym_RBRACE] = ACTIONS(2300),
    [anon_sym_COMMA] = ACTIONS(2300),
    [anon_sym_unreachable] = ACTIONS(2302),
    [anon_sym_ret] = ACTIONS(2302),
    [anon_sym_br] = ACTIONS(2302),
    [anon_sym_resume] = ACTIONS(2302),
    [anon_sym_freeze] = ACTIONS(2302),
    [anon_sym_indirectbr] = ACTIONS(2302),
    [anon_sym_extractelement] = ACTIONS(2302),
    [anon_sym_insertelement] = ACTIONS(2302),
    [anon_sym_select] = ACTIONS(2302),
    [anon_sym_shufflevector] = ACTIONS(2302),
    [anon_sym_fneg] = ACTIONS(2302),
    [anon_sym_switch] = ACTIONS(2302),
    [anon_sym_invoke] = ACTIONS(2302),
    [anon_sym_cleanupret] = ACTIONS(2302),
    [anon_sym_catchret] = ACTIONS(2302),
    [anon_sym_catchswitch] = ACTIONS(2302),
    [anon_sym_catchpad] = ACTIONS(2302),
    [anon_sym_cleanuppad] = ACTIONS(2302),
    [anon_sym_callbr] = ACTIONS(2302),
    [anon_sym_icmp] = ACTIONS(2302),
    [anon_sym_fcmp] = ACTIONS(2302),
    [anon_sym_va_arg] = ACTIONS(2302),
    [anon_sym_phi] = ACTIONS(2302),
    [anon_sym_landingpad] = ACTIONS(2302),
    [anon_sym_tail] = ACTIONS(2302),
    [anon_sym_musttail] = ACTIONS(2302),
    [anon_sym_notail] = ACTIONS(2302),
    [anon_sym_call] = ACTIONS(2302),
    [anon_sym_alloca] = ACTIONS(2302),
    [anon_sym_load] = ACTIONS(2302),
    [anon_sym_store] = ACTIONS(2302),
    [anon_sym_cmpxchg] = ACTIONS(2302),
    [anon_sym_atomicrmw] = ACTIONS(2302),
    [anon_sym_fence] = ACTIONS(2302),
    [anon_sym_getelementptr] = ACTIONS(2302),
    [anon_sym_extractvalue] = ACTIONS(2302),
    [anon_sym_insertvalue] = ACTIONS(2302),
    [anon_sym_mul] = ACTIONS(2302),
    [anon_sym_urem] = ACTIONS(2302),
    [anon_sym_srem] = ACTIONS(2302),
    [anon_sym_shl] = ACTIONS(2302),
    [anon_sym_udiv] = ACTIONS(2302),
    [anon_sym_sdiv] = ACTIONS(2302),
    [anon_sym_lshr] = ACTIONS(2302),
    [anon_sym_ashr] = ACTIONS(2302),
    [anon_sym_fmul] = ACTIONS(2302),
    [anon_sym_fdiv] = ACTIONS(2302),
    [anon_sym_frem] = ACTIONS(2302),
    [anon_sym_xchg] = ACTIONS(2302),
    [anon_sym_add] = ACTIONS(2302),
    [anon_sym_sub] = ACTIONS(2302),
    [anon_sym_and] = ACTIONS(2302),
    [anon_sym_nand] = ACTIONS(2302),
    [anon_sym_or] = ACTIONS(2302),
    [anon_sym_xor] = ACTIONS(2302),
    [anon_sym_max] = ACTIONS(2302),
    [anon_sym_min] = ACTIONS(2302),
    [anon_sym_umax] = ACTIONS(2302),
    [anon_sym_umin] = ACTIONS(2302),
    [anon_sym_fadd] = ACTIONS(2302),
    [anon_sym_fsub] = ACTIONS(2302),
    [anon_sym_bitcast] = ACTIONS(2302),
    [anon_sym_trunc] = ACTIONS(2302),
    [anon_sym_zext] = ACTIONS(2302),
    [anon_sym_sext] = ACTIONS(2302),
    [anon_sym_fptrunc] = ACTIONS(2302),
    [anon_sym_fpext] = ACTIONS(2302),
    [anon_sym_addrspacecast] = ACTIONS(2302),
    [anon_sym_uitofp] = ACTIONS(2302),
    [anon_sym_sitofp] = ACTIONS(2302),
    [anon_sym_fptoui] = ACTIONS(2302),
    [anon_sym_fptosi] = ACTIONS(2302),
    [anon_sym_inttoptr] = ACTIONS(2302),
    [anon_sym_ptrtoint] = ACTIONS(2302),
    [anon_sym_uselistorder] = ACTIONS(2302),
  },
  [690] = {
    [sym_comment] = ACTIONS(3),
    [sym_local_var] = ACTIONS(2304),
    [sym_label] = ACTIONS(2304),
    [anon_sym_RBRACE] = ACTIONS(2304),
    [anon_sym_COMMA] = ACTIONS(2304),
    [anon_sym_unreachable] = ACTIONS(2306),
    [anon_sym_ret] = ACTIONS(2306),
    [anon_sym_br] = ACTIONS(2306),
    [anon_sym_resume] = ACTIONS(2306),
    [anon_sym_freeze] = ACTIONS(2306),
    [anon_sym_indirectbr] = ACTIONS(2306),
    [anon_sym_extractelement] = ACTIONS(2306),
    [anon_sym_insertelement] = ACTIONS(2306),
    [anon_sym_select] = ACTIONS(2306),
    [anon_sym_shufflevector] = ACTIONS(2306),
    [anon_sym_fneg] = ACTIONS(2306),
    [anon_sym_switch] = ACTIONS(2306),
    [anon_sym_invoke] = ACTIONS(2306),
    [anon_sym_cleanupret] = ACTIONS(2306),
    [anon_sym_catchret] = ACTIONS(2306),
    [anon_sym_catchswitch] = ACTIONS(2306),
    [anon_sym_catchpad] = ACTIONS(2306),
    [anon_sym_cleanuppad] = ACTIONS(2306),
    [anon_sym_callbr] = ACTIONS(2306),
    [anon_sym_icmp] = ACTIONS(2306),
    [anon_sym_fcmp] = ACTIONS(2306),
    [anon_sym_va_arg] = ACTIONS(2306),
    [anon_sym_phi] = ACTIONS(2306),
    [anon_sym_landingpad] = ACTIONS(2306),
    [anon_sym_tail] = ACTIONS(2306),
    [anon_sym_musttail] = ACTIONS(2306),
    [anon_sym_notail] = ACTIONS(2306),
    [anon_sym_call] = ACTIONS(2306),
    [anon_sym_alloca] = ACTIONS(2306),
    [anon_sym_load] = ACTIONS(2306),
    [anon_sym_store] = ACTIONS(2306),
    [anon_sym_cmpxchg] = ACTIONS(2306),
    [anon_sym_atomicrmw] = ACTIONS(2306),
    [anon_sym_fence] = ACTIONS(2306),
    [anon_sym_getelementptr] = ACTIONS(2306),
    [anon_sym_extractvalue] = ACTIONS(2306),
    [anon_sym_insertvalue] = ACTIONS(2306),
    [anon_sym_mul] = ACTIONS(2306),
    [anon_sym_urem] = ACTIONS(2306),
    [anon_sym_srem] = ACTIONS(2306),
    [anon_sym_shl] = ACTIONS(2306),
    [anon_sym_udiv] = ACTIONS(2306),
    [anon_sym_sdiv] = ACTIONS(2306),
    [anon_sym_lshr] = ACTIONS(2306),
    [anon_sym_ashr] = ACTIONS(2306),
    [anon_sym_fmul] = ACTIONS(2306),
    [anon_sym_fdiv] = ACTIONS(2306),
    [anon_sym_frem] = ACTIONS(2306),
    [anon_sym_xchg] = ACTIONS(2306),
    [anon_sym_add] = ACTIONS(2306),
    [anon_sym_sub] = ACTIONS(2306),
    [anon_sym_and] = ACTIONS(2306),
    [anon_sym_nand] = ACTIONS(2306),
    [anon_sym_or] = ACTIONS(2306),
    [anon_sym_xor] = ACTIONS(2306),
    [anon_sym_max] = ACTIONS(2306),
    [anon_sym_min] = ACTIONS(2306),
    [anon_sym_umax] = ACTIONS(2306),
    [anon_sym_umin] = ACTIONS(2306),
    [anon_sym_fadd] = ACTIONS(2306),
    [anon_sym_fsub] = ACTIONS(2306),
    [anon_sym_bitcast] = ACTIONS(2306),
    [anon_sym_trunc] = ACTIONS(2306),
    [anon_sym_zext] = ACTIONS(2306),
    [anon_sym_sext] = ACTIONS(2306),
    [anon_sym_fptrunc] = ACTIONS(2306),
    [anon_sym_fpext] = ACTIONS(2306),
    [anon_sym_addrspacecast] = ACTIONS(2306),
    [anon_sym_uitofp] = ACTIONS(2306),
    [anon_sym_sitofp] = ACTIONS(2306),
    [anon_sym_fptoui] = ACTIONS(2306),
    [anon_sym_fptosi] = ACTIONS(2306),
    [anon_sym_inttoptr] = ACTIONS(2306),
    [anon_sym_ptrtoint] = ACTIONS(2306),
    [anon_sym_uselistorder] = ACTIONS(2306),
  },
  [691] = {
    [sym_constant_expr] = STATE(423),
    [sym_constant_cast] = STATE(359),
    [sym_constant_getelementptr] = STATE(359),
    [sym_constant_select] = STATE(359),
    [sym_constant_icmp] = STATE(359),
    [sym_constant_fcmp] = STATE(359),
    [sym_constant_extractelement] = STATE(359),
    [sym_constant_insertelement] = STATE(359),
    [sym_constant_shufflevector] = STATE(359),
    [sym_constant_extractvalue] = STATE(359),
    [sym_constant_insertvalue] = STATE(359),
    [sym_constant_fneg] = STATE(359),
    [sym_constant_bin_op] = STATE(359),
    [sym_bin_op_keyword] = STATE(1133),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1924),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(2308),
    [anon_sym_extractelement] = ACTIONS(335),
    [anon_sym_insertelement] = ACTIONS(337),
    [anon_sym_select] = ACTIONS(339),
    [anon_sym_shufflevector] = ACTIONS(341),
    [anon_sym_fneg] = ACTIONS(343),
    [anon_sym_icmp] = ACTIONS(345),
    [anon_sym_fcmp] = ACTIONS(347),
    [anon_sym_getelementptr] = ACTIONS(349),
    [anon_sym_extractvalue] = ACTIONS(351),
    [anon_sym_insertvalue] = ACTIONS(353),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
  [692] = {
    [sym_constant_expr] = STATE(421),
    [sym_constant_cast] = STATE(359),
    [sym_constant_getelementptr] = STATE(359),
    [sym_constant_select] = STATE(359),
    [sym_constant_icmp] = STATE(359),
    [sym_constant_fcmp] = STATE(359),
    [sym_constant_extractelement] = STATE(359),
    [sym_constant_insertelement] = STATE(359),
    [sym_constant_shufflevector] = STATE(359),
    [sym_constant_extractvalue] = STATE(359),
    [sym_constant_insertvalue] = STATE(359),
    [sym_constant_fneg] = STATE(359),
    [sym_constant_bin_op] = STATE(359),
    [sym_bin_op_keyword] = STATE(1133),
    [sym_atomic_bin_op_keyword] = STATE(752),
    [sym_cast_inst] = STATE(1924),
    [sym_comment] = ACTIONS(3),
    [sym_global_var] = ACTIONS(2310),
    [anon_sym_extractelement] = ACTIONS(335),
    [anon_sym_insertelement] = ACTIONS(337),
    [anon_sym_select] = ACTIONS(339),
    [anon_sym_shufflevector] = ACTIONS(341),
    [anon_sym_fneg] = ACTIONS(343),
    [anon_sym_icmp] = ACTIONS(345),
    [anon_sym_fcmp] = ACTIONS(347),
    [anon_sym_getelementptr] = ACTIONS(349),
    [anon_sym_extractvalue] = ACTIONS(351),
    [anon_sym_insertvalue] = ACTIONS(353),
    [anon_sym_mul] = ACTIONS(108),
    [anon_sym_urem] = ACTIONS(108),
    [anon_sym_srem] = ACTIONS(108),
    [anon_sym_shl] = ACTIONS(108),
    [anon_sym_udiv] = ACTIONS(108),
    [anon_sym_sdiv] = ACTIONS(108),
    [anon_sym_lshr] = ACTIONS(108),
    [anon_sym_ashr] = ACTIONS(108),
    [anon_sym_fmul] = ACTIONS(108),
    [anon_sym_fdiv] = ACTIONS(108),
    [anon_sym_frem] = ACTIONS(108),
    [anon_sym_xchg] = ACTIONS(110),
    [anon_sym_add] = ACTIONS(112),
    [anon_sym_sub] = ACTIONS(110),
    [anon_sym_and] = ACTIONS(110),
    [anon_sym_nand] = ACTIONS(110),
    [anon_sym_or] = ACTIONS(110),
    [anon_sym_xor] = ACTIONS(110),
    [anon_sym_max] = ACTIONS(110),
    [anon_sym_min] = ACTIONS(110),
    [anon_sym_umax] = ACTIONS(110),
    [anon_sym_umin] = ACTIONS(110),
    [anon_sym_fadd] = ACTIONS(110),
    [anon_sym_fsub] = ACTIONS(110),
    [anon_sym_bitcast] = ACTIONS(114),
    [anon_sym_trunc] = ACTIONS(114),
    [anon_sym_zext] = ACTIONS(114),
    [anon_sym_sext] = ACTIONS(114),
    [anon_sym_fptrunc] = ACTIONS(114),
    [anon_sym_fpext] = ACTIONS(114),
    [anon_sym_addrspacecast] = ACTIONS(114),
    [anon_sym_uitofp] = ACTIONS(114),
    [anon_sym_sitofp] = ACTIONS(114),
    [anon_sym_fptoui] = ACTIONS(114),
    [anon_sym_fptosi] = ACTIONS(114),
    [anon_sym_inttoptr] = ACTIONS(114),
    [anon_sym_ptrtoint] = ACTIONS(114),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2315), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2330), 1,
      anon_sym_LBRACE,
    ACTIONS(2335), 1,
      anon_sym_LBRACK,
    ACTIONS(2338), 1,
      anon_sym_LT,
    ACTIONS(2341), 1,
      anon_sym_addrspace,
    ACTIONS(2344), 1,
      anon_sym_LPAREN,
    ACTIONS(2347), 1,
      anon_sym_BANG,
    STATE(715), 1,
      sym_metadata_ref,
    ACTIONS(2312), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2321), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(693), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2333), 4,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_RPAREN,
    ACTIONS(2318), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(719), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2324), 9,
      sym_float,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2327), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [92] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2364), 1,
      anon_sym_LBRACK,
    ACTIONS(2366), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      anon_sym_addrspace,
    ACTIONS(2370), 1,
      anon_sym_LPAREN,
    ACTIONS(2372), 1,
      anon_sym_RPAREN,
    ACTIONS(2374), 1,
      anon_sym_BANG,
    STATE(715), 1,
      sym_metadata_ref,
    ACTIONS(2350), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2356), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(696), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2354), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(719), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2358), 9,
      sym_float,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2360), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [181] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2364), 1,
      anon_sym_LBRACK,
    ACTIONS(2366), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      anon_sym_addrspace,
    ACTIONS(2370), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_BANG,
    ACTIONS(2376), 1,
      anon_sym_RPAREN,
    STATE(715), 1,
      sym_metadata_ref,
    ACTIONS(2350), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2356), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(693), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2354), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(719), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2358), 9,
      sym_float,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2360), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [270] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2364), 1,
      anon_sym_LBRACK,
    ACTIONS(2366), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      anon_sym_addrspace,
    ACTIONS(2370), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_BANG,
    ACTIONS(2378), 1,
      anon_sym_RPAREN,
    STATE(715), 1,
      sym_metadata_ref,
    ACTIONS(2350), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2356), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(693), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2354), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(719), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2358), 9,
      sym_float,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2360), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [359] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2364), 1,
      anon_sym_LBRACK,
    ACTIONS(2366), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      anon_sym_addrspace,
    ACTIONS(2370), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_BANG,
    ACTIONS(2380), 1,
      anon_sym_RPAREN,
    STATE(715), 1,
      sym_metadata_ref,
    ACTIONS(2350), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2356), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(711), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2354), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(719), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2358), 9,
      sym_float,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2360), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [448] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2364), 1,
      anon_sym_LBRACK,
    ACTIONS(2366), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      anon_sym_addrspace,
    ACTIONS(2370), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_BANG,
    ACTIONS(2382), 1,
      anon_sym_RPAREN,
    STATE(715), 1,
      sym_metadata_ref,
    ACTIONS(2350), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2356), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(704), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2354), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(719), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2358), 9,
      sym_float,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2360), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [537] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2364), 1,
      anon_sym_LBRACK,
    ACTIONS(2366), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      anon_sym_addrspace,
    ACTIONS(2370), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_BANG,
    ACTIONS(2384), 1,
      anon_sym_RBRACE,
    STATE(715), 1,
      sym_metadata_ref,
    ACTIONS(2350), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2356), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(693), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2354), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(719), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2358), 9,
      sym_float,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2360), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [626] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2364), 1,
      anon_sym_LBRACK,
    ACTIONS(2366), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      anon_sym_addrspace,
    ACTIONS(2370), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_BANG,
    ACTIONS(2386), 1,
      anon_sym_RPAREN,
    STATE(715), 1,
      sym_metadata_ref,
    ACTIONS(2350), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2356), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(693), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2354), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(719), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2358), 9,
      sym_float,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2360), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [715] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2364), 1,
      anon_sym_LBRACK,
    ACTIONS(2366), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      anon_sym_addrspace,
    ACTIONS(2370), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_BANG,
    ACTIONS(2380), 1,
      anon_sym_RBRACK,
    STATE(715), 1,
      sym_metadata_ref,
    ACTIONS(2350), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2356), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(705), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2354), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(719), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2358), 9,
      sym_float,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2360), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [804] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2364), 1,
      anon_sym_LBRACK,
    ACTIONS(2366), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      anon_sym_addrspace,
    ACTIONS(2370), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_BANG,
    ACTIONS(2388), 1,
      anon_sym_RPAREN,
    STATE(715), 1,
      sym_metadata_ref,
    ACTIONS(2350), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2356), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(700), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2354), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(719), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2358), 9,
      sym_float,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2360), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [893] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2364), 1,
      anon_sym_LBRACK,
    ACTIONS(2366), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      anon_sym_addrspace,
    ACTIONS(2370), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_BANG,
    ACTIONS(2390), 1,
      anon_sym_RPAREN,
    STATE(715), 1,
      sym_metadata_ref,
    ACTIONS(2350), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2356), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(695), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2354), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(719), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2358), 9,
      sym_float,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2360), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [982] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2364), 1,
      anon_sym_LBRACK,
    ACTIONS(2366), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      anon_sym_addrspace,
    ACTIONS(2370), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_BANG,
    ACTIONS(2392), 1,
      anon_sym_RPAREN,
    STATE(715), 1,
      sym_metadata_ref,
    ACTIONS(2350), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2356), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(693), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2354), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(719), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2358), 9,
      sym_float,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2360), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [1071] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2364), 1,
      anon_sym_LBRACK,
    ACTIONS(2366), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      anon_sym_addrspace,
    ACTIONS(2370), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_BANG,
    ACTIONS(2384), 1,
      anon_sym_RBRACK,
    STATE(715), 1,
      sym_metadata_ref,
    ACTIONS(2350), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2356), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(693), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2354), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(719), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2358), 9,
      sym_float,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2360), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [1160] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2364), 1,
      anon_sym_LBRACK,
    ACTIONS(2366), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      anon_sym_addrspace,
    ACTIONS(2370), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_BANG,
    ACTIONS(2380), 1,
      anon_sym_RBRACE,
    STATE(715), 1,
      sym_metadata_ref,
    ACTIONS(2350), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2356), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(699), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2354), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(719), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2358), 9,
      sym_float,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2360), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [1249] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2364), 1,
      anon_sym_LBRACK,
    ACTIONS(2366), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      anon_sym_addrspace,
    ACTIONS(2370), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_BANG,
    ACTIONS(2394), 1,
      anon_sym_RPAREN,
    STATE(715), 1,
      sym_metadata_ref,
    ACTIONS(2350), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2356), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(693), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2354), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(719), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2358), 9,
      sym_float,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2360), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [1338] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2364), 1,
      anon_sym_LBRACK,
    ACTIONS(2366), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      anon_sym_addrspace,
    ACTIONS(2370), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_BANG,
    ACTIONS(2384), 1,
      anon_sym_GT,
    STATE(715), 1,
      sym_metadata_ref,
    ACTIONS(2350), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2356), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(693), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2354), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(719), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2358), 9,
      sym_float,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2360), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [1427] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2364), 1,
      anon_sym_LBRACK,
    ACTIONS(2366), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      anon_sym_addrspace,
    ACTIONS(2370), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_BANG,
    ACTIONS(2396), 1,
      anon_sym_RPAREN,
    STATE(715), 1,
      sym_metadata_ref,
    ACTIONS(2350), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2356), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(707), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2354), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(719), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2358), 9,
      sym_float,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2360), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [1516] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2364), 1,
      anon_sym_LBRACK,
    ACTIONS(2366), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      anon_sym_addrspace,
    ACTIONS(2370), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_BANG,
    ACTIONS(2380), 1,
      anon_sym_GT,
    STATE(715), 1,
      sym_metadata_ref,
    ACTIONS(2350), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2356), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(708), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2354), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(719), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2358), 9,
      sym_float,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2360), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [1605] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2364), 1,
      anon_sym_LBRACK,
    ACTIONS(2366), 1,
      anon_sym_LT,
    ACTIONS(2368), 1,
      anon_sym_addrspace,
    ACTIONS(2370), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_BANG,
    ACTIONS(2384), 1,
      anon_sym_RPAREN,
    STATE(715), 1,
      sym_metadata_ref,
    ACTIONS(2350), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(2356), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(693), 2,
      sym_specialized_md_value,
      aux_sym_specialized_md_repeat1,
    ACTIONS(2354), 6,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    STATE(719), 7,
      sym_number,
      sym_var,
      sym_type_keyword,
      sym_addrspace,
      sym__primitive_value,
      sym_metadata_tuple,
      sym_specialized_md,
    ACTIONS(2358), 9,
      sym_float,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      aux_sym_specialized_md_value_token1,
    ACTIONS(2360), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [1694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 1,
      anon_sym_LT,
    ACTIONS(1003), 49,
      sym_local_var,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_LBRACE,
      anon_sym_LT_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
      anon_sym_disjoint,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [1752] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(995), 1,
      anon_sym_LT,
    STATE(713), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2398), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(993), 37,
      sym_local_var,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_LBRACE,
      anon_sym_LT_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
  [1812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LPAREN2,
      anon_sym_PIPE,
    ACTIONS(507), 30,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_LPAREN,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [1867] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2401), 1,
      anon_sym_LPAREN2,
    ACTIONS(573), 16,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(575), 30,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_LPAREN,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [1924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2403), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(2405), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [1978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(687), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [2032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(116), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(122), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [2086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2407), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(2409), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [2140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(701), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(703), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [2194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(391), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(393), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [2248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(709), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(711), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [2302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(695), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [2356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(715), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [2410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2411), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(2413), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [2464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(689), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(691), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [2518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 17,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_string,
      sym_cstring,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(641), 29,
      aux_sym_number_token1,
      aux_sym_number_token2,
      sym_float,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_addrspace,
      anon_sym_none,
      anon_sym_true,
      anon_sym_false,
      anon_sym_null,
      anon_sym_undef,
      anon_sym_poison,
      anon_sym_zeroinitializer,
      anon_sym_BANG,
      aux_sym_specialized_md_value_token1,
  [2572] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1660), 1,
      sym_type_and_value,
    STATE(744), 2,
      sym_fast_math,
      aux_sym_instruction_bin_op_repeat1,
    ACTIONS(2415), 4,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
      anon_sym_disjoint,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [2644] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1783), 1,
      sym_type_and_value,
    STATE(728), 2,
      sym_fast_math,
      aux_sym_instruction_bin_op_repeat1,
    ACTIONS(2419), 4,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
      anon_sym_disjoint,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [2716] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(625), 1,
      sym_type_and_value,
    STATE(733), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [2782] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(961), 1,
      anon_sym_addrspace,
    ACTIONS(2425), 1,
      anon_sym_no_cfi,
    ACTIONS(2431), 1,
      anon_sym_dso_local,
    ACTIONS(2439), 1,
      anon_sym_externally_initialized,
    ACTIONS(2443), 1,
      anon_sym_thread_local,
    STATE(1152), 1,
      sym_thread_local,
    STATE(1176), 1,
      sym_unnamed_addr,
    STATE(1215), 1,
      sym_addrspace,
    ACTIONS(727), 2,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
    ACTIONS(2433), 2,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
    ACTIONS(2437), 2,
      anon_sym_dllimport,
      anon_sym_dllexport,
    STATE(751), 2,
      sym_linkage,
      aux_sym_function_header_repeat1,
    ACTIONS(2429), 3,
      anon_sym_weak,
      anon_sym_linkonce,
      anon_sym_external,
    ACTIONS(2435), 3,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
    ACTIONS(2441), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
    STATE(829), 4,
      sym_linkage_aux,
      sym_dso_local,
      sym_visibility,
      sym_dll_storage_class,
    ACTIONS(2427), 8,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
  [2858] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(961), 1,
      anon_sym_addrspace,
    ACTIONS(2425), 1,
      anon_sym_no_cfi,
    ACTIONS(2431), 1,
      anon_sym_dso_local,
    ACTIONS(2443), 1,
      anon_sym_thread_local,
    ACTIONS(2445), 1,
      anon_sym_externally_initialized,
    STATE(1153), 1,
      sym_thread_local,
    STATE(1169), 1,
      sym_unnamed_addr,
    STATE(1201), 1,
      sym_addrspace,
    ACTIONS(727), 2,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
    ACTIONS(2433), 2,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
    ACTIONS(2437), 2,
      anon_sym_dllimport,
      anon_sym_dllexport,
    STATE(731), 2,
      sym_linkage,
      aux_sym_function_header_repeat1,
    ACTIONS(2429), 3,
      anon_sym_weak,
      anon_sym_linkonce,
      anon_sym_external,
    ACTIONS(2435), 3,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
    ACTIONS(2447), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
    STATE(829), 4,
      sym_linkage_aux,
      sym_dso_local,
      sym_visibility,
      sym_dll_storage_class,
    ACTIONS(2427), 8,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
  [2934] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(661), 1,
      sym_type_and_value,
    STATE(713), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3000] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1676), 1,
      sym_type_and_value,
    STATE(735), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3066] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1915), 1,
      sym_type_and_value,
    STATE(713), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3132] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1734), 1,
      sym_type,
    STATE(737), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3193] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1842), 1,
      sym_type,
    STATE(713), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3254] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(232), 1,
      anon_sym_BANG,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(1053), 1,
      anon_sym_null,
    ACTIONS(2449), 1,
      anon_sym_RBRACE,
    STATE(100), 1,
      sym_metadata_ref,
    STATE(292), 1,
      sym_type,
    STATE(1335), 1,
      sym_metadata,
    STATE(134), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3326] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(232), 1,
      anon_sym_BANG,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(1053), 1,
      anon_sym_null,
    ACTIONS(2451), 1,
      anon_sym_RBRACE,
    STATE(100), 1,
      sym_metadata_ref,
    STATE(292), 1,
      sym_type,
    STATE(1432), 1,
      sym_metadata,
    STATE(134), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3398] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(232), 1,
      anon_sym_BANG,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(1053), 1,
      anon_sym_null,
    ACTIONS(2453), 1,
      anon_sym_RBRACE,
    STATE(100), 1,
      sym_metadata_ref,
    STATE(292), 1,
      sym_type,
    STATE(1306), 1,
      sym_metadata,
    STATE(134), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3470] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(232), 1,
      anon_sym_BANG,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(1053), 1,
      anon_sym_null,
    ACTIONS(2455), 1,
      anon_sym_RBRACE,
    STATE(100), 1,
      sym_metadata_ref,
    STATE(292), 1,
      sym_type,
    STATE(1376), 1,
      sym_metadata,
    STATE(134), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3542] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(232), 1,
      anon_sym_BANG,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(1053), 1,
      anon_sym_null,
    ACTIONS(2457), 1,
      anon_sym_RBRACE,
    STATE(100), 1,
      sym_metadata_ref,
    STATE(292), 1,
      sym_type,
    STATE(1403), 1,
      sym_metadata,
    STATE(134), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3614] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(232), 1,
      anon_sym_BANG,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(1053), 1,
      anon_sym_null,
    ACTIONS(1058), 1,
      anon_sym_metadata,
    ACTIONS(2459), 1,
      anon_sym_distinct,
    STATE(100), 1,
      sym_metadata_ref,
    STATE(296), 1,
      sym_type,
    STATE(1123), 1,
      sym_metadata,
    STATE(134), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3686] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2463), 1,
      anon_sym_LT,
    STATE(744), 2,
      sym_fast_math,
      aux_sym_instruction_bin_op_repeat1,
    ACTIONS(2465), 4,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
      anon_sym_disjoint,
    ACTIONS(2468), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2461), 20,
      sym_local_var,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_LBRACE,
      anon_sym_LT_LBRACE,
      anon_sym_LBRACK,
  [3735] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(232), 1,
      anon_sym_BANG,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(1053), 1,
      anon_sym_null,
    ACTIONS(1344), 1,
      anon_sym_metadata,
    STATE(100), 1,
      sym_metadata_ref,
    STATE(243), 1,
      sym_metadata,
    STATE(381), 1,
      sym_type,
    STATE(134), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3804] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(232), 1,
      anon_sym_BANG,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(1053), 1,
      anon_sym_null,
    ACTIONS(1058), 1,
      anon_sym_metadata,
    STATE(100), 1,
      sym_metadata_ref,
    STATE(296), 1,
      sym_type,
    STATE(1121), 1,
      sym_metadata,
    STATE(134), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3873] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(214), 1,
      sym_local_var,
    ACTIONS(220), 1,
      anon_sym_metadata,
    ACTIONS(222), 1,
      anon_sym_LBRACE,
    ACTIONS(224), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(226), 1,
      anon_sym_LBRACK,
    ACTIONS(228), 1,
      anon_sym_LT,
    ACTIONS(232), 1,
      anon_sym_BANG,
    ACTIONS(1053), 1,
      anon_sym_null,
    STATE(2), 1,
      sym_type,
    STATE(100), 1,
      sym_metadata_ref,
    STATE(243), 1,
      sym_metadata,
    STATE(134), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(6), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(216), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [3942] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(232), 1,
      anon_sym_BANG,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(1053), 1,
      anon_sym_null,
    STATE(100), 1,
      sym_metadata_ref,
    STATE(292), 1,
      sym_type,
    STATE(1573), 1,
      sym_metadata,
    STATE(134), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4011] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(120), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(138), 1,
      anon_sym_BANG,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    ACTIONS(2471), 1,
      anon_sym_null,
    STATE(128), 1,
      sym_metadata_ref,
    STATE(237), 1,
      sym_type,
    STATE(610), 1,
      sym_metadata,
    STATE(145), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4080] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(232), 1,
      anon_sym_BANG,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(1053), 1,
      anon_sym_null,
    ACTIONS(1058), 1,
      anon_sym_metadata,
    STATE(100), 1,
      sym_metadata_ref,
    STATE(296), 1,
      sym_type,
    STATE(1104), 1,
      sym_metadata,
    STATE(134), 3,
      sym_type_and_value,
      sym_metadata_tuple,
      sym_specialized_md,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4149] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_no_cfi,
    ACTIONS(2482), 1,
      anon_sym_dso_local,
    ACTIONS(2485), 2,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
    ACTIONS(2491), 2,
      anon_sym_dllimport,
      anon_sym_dllexport,
    STATE(751), 2,
      sym_linkage,
      aux_sym_function_header_repeat1,
    ACTIONS(2479), 3,
      anon_sym_weak,
      anon_sym_linkonce,
      anon_sym_external,
    ACTIONS(2488), 3,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
    STATE(829), 4,
      sym_linkage_aux,
      sym_dso_local,
      sym_visibility,
      sym_dll_storage_class,
    ACTIONS(2476), 8,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
    ACTIONS(913), 9,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
      anon_sym_addrspace,
      anon_sym_externally_initialized,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
      anon_sym_thread_local,
  [4208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2496), 1,
      anon_sym_LT,
    ACTIONS(2494), 33,
      sym_local_var,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_LBRACE,
      anon_sym_LT_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
      anon_sym_disjoint,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [4250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2500), 1,
      anon_sym_LT,
    ACTIONS(2498), 33,
      sym_local_var,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_LBRACE,
      anon_sym_LT_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
      anon_sym_disjoint,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [4292] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2502), 1,
      ts_builtin_sym_end,
    ACTIONS(2504), 1,
      sym_comdat_ref,
    ACTIONS(2507), 1,
      sym_global_var,
    ACTIONS(2510), 1,
      sym_local_var,
    ACTIONS(2513), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2516), 1,
      sym_summary_ref,
    ACTIONS(2519), 1,
      anon_sym_target,
    ACTIONS(2522), 1,
      anon_sym_source_filename,
    ACTIONS(2525), 1,
      anon_sym_declare,
    ACTIONS(2528), 1,
      anon_sym_define,
    ACTIONS(2531), 1,
      anon_sym_uselistorder,
    ACTIONS(2534), 1,
      anon_sym_uselistorder_bb,
    ACTIONS(2537), 1,
      anon_sym_module,
    ACTIONS(2540), 1,
      anon_sym_attributes,
    STATE(1226), 1,
      sym__global_prefix,
    STATE(1784), 1,
      sym_metadata_ref,
    STATE(754), 16,
      sym_target_definition,
      sym_source_file_name,
      sym_declare,
      sym_define,
      sym_use_list_order,
      sym_use_list_order_bb,
      sym_module_asm,
      sym_global_type,
      sym_global_global,
      sym_alias,
      sym_ifunc,
      sym_comdat,
      sym_global_metadata,
      sym_summary_entry,
      sym_unnamed_attr_grp,
      aux_sym_module_repeat1,
  [4362] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_comdat_ref,
    ACTIONS(9), 1,
      sym_global_var,
    ACTIONS(11), 1,
      sym_local_var,
    ACTIONS(13), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(15), 1,
      sym_summary_ref,
    ACTIONS(17), 1,
      anon_sym_target,
    ACTIONS(19), 1,
      anon_sym_source_filename,
    ACTIONS(21), 1,
      anon_sym_declare,
    ACTIONS(23), 1,
      anon_sym_define,
    ACTIONS(25), 1,
      anon_sym_uselistorder,
    ACTIONS(27), 1,
      anon_sym_uselistorder_bb,
    ACTIONS(29), 1,
      anon_sym_module,
    ACTIONS(31), 1,
      anon_sym_attributes,
    ACTIONS(2543), 1,
      ts_builtin_sym_end,
    STATE(1226), 1,
      sym__global_prefix,
    STATE(1784), 1,
      sym_metadata_ref,
    STATE(754), 16,
      sym_target_definition,
      sym_source_file_name,
      sym_declare,
      sym_define,
      sym_use_list_order,
      sym_use_list_order_bb,
      sym_module_asm,
      sym_global_type,
      sym_global_global,
      sym_alias,
      sym_ifunc,
      sym_comdat,
      sym_global_metadata,
      sym_summary_entry,
      sym_unnamed_attr_grp,
      aux_sym_module_repeat1,
  [4432] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    ACTIONS(2545), 1,
      anon_sym_addrspace,
    ACTIONS(2547), 1,
      anon_sym_align,
    STATE(237), 1,
      sym_type,
    STATE(651), 3,
      sym_addrspace,
      sym_type_and_value,
      sym_alignment,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4492] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    ACTIONS(2549), 1,
      anon_sym_RPAREN,
    STATE(1325), 2,
      sym_number,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4549] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    ACTIONS(2551), 1,
      anon_sym_RPAREN,
    STATE(1431), 2,
      sym_number,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4606] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2553), 1,
      anon_sym_atomic,
    ACTIONS(2555), 1,
      anon_sym_volatile,
    STATE(292), 1,
      sym_type,
    STATE(1618), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4664] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(246), 1,
      anon_sym_uselistorder,
    ACTIONS(961), 1,
      anon_sym_addrspace,
    ACTIONS(1020), 1,
      anon_sym_LPAREN,
    ACTIONS(2557), 1,
      anon_sym_STAR,
    STATE(283), 1,
      sym_addrspace,
    STATE(845), 1,
      aux_sym_type_repeat1,
    STATE(256), 2,
      sym_argument_list,
      aux_sym_type_repeat2,
    ACTIONS(244), 22,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_cleanup,
      anon_sym_catch,
      anon_sym_filter,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [4714] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(283), 1,
      sym_local_var,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(295), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(297), 1,
      anon_sym_LBRACK,
    ACTIONS(299), 1,
      anon_sym_LT,
    ACTIONS(2559), 1,
      anon_sym_metadata,
    ACTIONS(2561), 1,
      anon_sym_RPAREN,
    ACTIONS(2563), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(59), 1,
      sym_type,
    STATE(1349), 1,
      sym_argument,
    STATE(62), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(287), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4772] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2565), 1,
      anon_sym_RBRACK,
    STATE(292), 1,
      sym_type,
    STATE(764), 1,
      aux_sym_instruction_switch_repeat1,
    STATE(1975), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4830] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(283), 1,
      sym_local_var,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(295), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(297), 1,
      anon_sym_LBRACK,
    ACTIONS(299), 1,
      anon_sym_LT,
    ACTIONS(2559), 1,
      anon_sym_metadata,
    ACTIONS(2563), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2567), 1,
      anon_sym_RPAREN,
    STATE(59), 1,
      sym_type,
    STATE(1327), 1,
      sym_argument,
    STATE(62), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(287), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4888] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2569), 1,
      anon_sym_RBRACK,
    STATE(292), 1,
      sym_type,
    STATE(775), 1,
      aux_sym_instruction_switch_repeat1,
    STATE(1975), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [4946] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1477), 2,
      sym_number,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5000] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(283), 1,
      sym_local_var,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(295), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(297), 1,
      anon_sym_LBRACK,
    ACTIONS(299), 1,
      anon_sym_LT,
    ACTIONS(2559), 1,
      anon_sym_metadata,
    ACTIONS(2563), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2571), 1,
      anon_sym_RPAREN,
    STATE(59), 1,
      sym_type,
    STATE(1387), 1,
      sym_argument,
    STATE(62), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(287), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5058] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1645), 2,
      sym_number,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5112] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(283), 1,
      sym_local_var,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(295), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(297), 1,
      anon_sym_LBRACK,
    ACTIONS(299), 1,
      anon_sym_LT,
    ACTIONS(2559), 1,
      anon_sym_metadata,
    ACTIONS(2563), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2573), 1,
      anon_sym_RPAREN,
    STATE(59), 1,
      sym_type,
    STATE(1449), 1,
      sym_argument,
    STATE(62), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(287), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5170] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(236), 1,
      anon_sym_uselistorder,
    ACTIONS(961), 1,
      anon_sym_addrspace,
    ACTIONS(1020), 1,
      anon_sym_LPAREN,
    ACTIONS(2575), 1,
      anon_sym_STAR,
    STATE(288), 1,
      sym_addrspace,
    STATE(780), 1,
      aux_sym_type_repeat1,
    STATE(760), 2,
      sym_argument_list,
      aux_sym_type_repeat2,
    ACTIONS(234), 22,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_cleanup,
      anon_sym_catch,
      anon_sym_filter,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [5220] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(283), 1,
      sym_local_var,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(295), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(297), 1,
      anon_sym_LBRACK,
    ACTIONS(299), 1,
      anon_sym_LT,
    ACTIONS(2559), 1,
      anon_sym_metadata,
    ACTIONS(2563), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2577), 1,
      anon_sym_RPAREN,
    STATE(59), 1,
      sym_type,
    STATE(1384), 1,
      sym_argument,
    STATE(62), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(287), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5278] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1710), 2,
      sym_number,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5332] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(283), 1,
      sym_local_var,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(295), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(297), 1,
      anon_sym_LBRACK,
    ACTIONS(299), 1,
      anon_sym_LT,
    ACTIONS(2559), 1,
      anon_sym_metadata,
    ACTIONS(2563), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2579), 1,
      anon_sym_RPAREN,
    STATE(59), 1,
      sym_type,
    STATE(1331), 1,
      sym_argument,
    STATE(62), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(287), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5390] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(283), 1,
      sym_local_var,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(295), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(297), 1,
      anon_sym_LBRACK,
    ACTIONS(299), 1,
      anon_sym_LT,
    ACTIONS(2559), 1,
      anon_sym_metadata,
    ACTIONS(2563), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2581), 1,
      anon_sym_RPAREN,
    STATE(59), 1,
      sym_type,
    STATE(1339), 1,
      sym_argument,
    STATE(62), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(287), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5448] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    ACTIONS(2583), 1,
      anon_sym_inbounds,
    ACTIONS(2585), 1,
      anon_sym_inrange,
    STATE(237), 1,
      sym_type,
    STATE(598), 1,
      sym_type_and_value,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5506] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2587), 1,
      sym_local_var,
    ACTIONS(2593), 1,
      anon_sym_metadata,
    ACTIONS(2596), 1,
      anon_sym_LBRACE,
    ACTIONS(2599), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(2602), 1,
      anon_sym_LBRACK,
    ACTIONS(2605), 1,
      anon_sym_RBRACK,
    ACTIONS(2607), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(775), 1,
      aux_sym_instruction_switch_repeat1,
    STATE(1975), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2590), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5564] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2610), 1,
      anon_sym_weak,
    ACTIONS(2612), 1,
      anon_sym_volatile,
    STATE(292), 1,
      sym_type,
    STATE(1625), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5622] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2614), 1,
      anon_sym_RBRACK,
    STATE(292), 1,
      sym_type,
    STATE(1315), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5677] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2616), 1,
      anon_sym_RPAREN,
    STATE(292), 1,
      sym_type,
    STATE(1275), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5732] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2618), 1,
      anon_sym_RBRACK,
    STATE(292), 1,
      sym_type,
    STATE(1442), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5787] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(246), 1,
      anon_sym_uselistorder,
    ACTIONS(961), 1,
      anon_sym_addrspace,
    ACTIONS(1020), 1,
      anon_sym_LPAREN,
    ACTIONS(1024), 1,
      anon_sym_STAR,
    STATE(258), 1,
      aux_sym_type_repeat1,
    STATE(276), 1,
      sym_argument_list,
    STATE(283), 1,
      sym_addrspace,
    ACTIONS(244), 22,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_cleanup,
      anon_sym_catch,
      anon_sym_filter,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [5836] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2620), 1,
      anon_sym_RBRACE,
    STATE(292), 1,
      sym_type,
    STATE(1274), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5891] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1276), 1,
      sym_local_var,
    ACTIONS(1282), 1,
      anon_sym_metadata,
    ACTIONS(1286), 1,
      anon_sym_LBRACE,
    ACTIONS(1288), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(1290), 1,
      anon_sym_LBRACK,
    ACTIONS(1292), 1,
      anon_sym_LT,
    ACTIONS(2622), 1,
      anon_sym_RBRACE_GT,
    STATE(372), 1,
      sym_type,
    STATE(1273), 1,
      sym_type_and_value,
    STATE(545), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(1280), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [5946] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2624), 1,
      anon_sym_RBRACK,
    STATE(292), 1,
      sym_type,
    STATE(1266), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6001] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(158), 1,
      anon_sym_dso_local,
    ACTIONS(317), 1,
      anon_sym_no_cfi,
    STATE(176), 1,
      sym_var,
    ACTIONS(140), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(156), 2,
      anon_sym_weak,
      anon_sym_linkonce,
    ACTIONS(321), 2,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
    ACTIONS(325), 2,
      anon_sym_dllimport,
      anon_sym_dllexport,
    STATE(234), 2,
      sym_linkage,
      aux_sym_function_header_repeat1,
    ACTIONS(323), 3,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
    STATE(245), 4,
      sym_linkage_aux,
      sym_dso_local,
      sym_visibility,
      sym_dll_storage_class,
    ACTIONS(319), 9,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
      anon_sym_external,
  [6056] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2626), 1,
      anon_sym_GT,
    STATE(292), 1,
      sym_type,
    STATE(1265), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6111] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    ACTIONS(2628), 1,
      anon_sym_RBRACE,
    STATE(1466), 1,
      sym_type,
    STATE(1880), 1,
      sym_struct_body,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6164] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(214), 1,
      sym_local_var,
    ACTIONS(222), 1,
      anon_sym_LBRACE,
    ACTIONS(224), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(226), 1,
      anon_sym_LBRACK,
    ACTIONS(228), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_RBRACE_GT,
    STATE(1319), 1,
      sym_type,
    STATE(1877), 1,
      sym_struct_body,
    STATE(6), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(216), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6217] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2632), 1,
      anon_sym_RBRACE,
    STATE(292), 1,
      sym_type,
    STATE(1441), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6272] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1276), 1,
      sym_local_var,
    ACTIONS(1282), 1,
      anon_sym_metadata,
    ACTIONS(1286), 1,
      anon_sym_LBRACE,
    ACTIONS(1288), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(1290), 1,
      anon_sym_LBRACK,
    ACTIONS(1292), 1,
      anon_sym_LT,
    ACTIONS(2634), 1,
      anon_sym_RBRACE_GT,
    STATE(372), 1,
      sym_type,
    STATE(1440), 1,
      sym_type_and_value,
    STATE(545), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(1280), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6327] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2636), 1,
      anon_sym_RBRACK,
    STATE(292), 1,
      sym_type,
    STATE(1439), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6382] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2638), 1,
      anon_sym_GT,
    STATE(292), 1,
      sym_type,
    STATE(1438), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6437] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(567), 1,
      sym_type_and_value,
    STATE(656), 1,
      sym__load_store_suffix,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6492] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(567), 1,
      sym_type_and_value,
    STATE(659), 1,
      sym__load_store_suffix,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6547] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    ACTIONS(2640), 1,
      anon_sym_RBRACE,
    STATE(1466), 1,
      sym_type,
    STATE(1692), 1,
      sym_struct_body,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6600] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(214), 1,
      sym_local_var,
    ACTIONS(222), 1,
      anon_sym_LBRACE,
    ACTIONS(224), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(226), 1,
      anon_sym_LBRACK,
    ACTIONS(228), 1,
      anon_sym_LT,
    ACTIONS(2642), 1,
      anon_sym_RBRACE_GT,
    STATE(1319), 1,
      sym_type,
    STATE(1683), 1,
      sym_struct_body,
    STATE(6), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(216), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6653] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_inrange,
    STATE(292), 1,
      sym_type,
    STATE(595), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6708] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2646), 1,
      anon_sym_RBRACE,
    STATE(292), 1,
      sym_type,
    STATE(1382), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6763] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1276), 1,
      sym_local_var,
    ACTIONS(1282), 1,
      anon_sym_metadata,
    ACTIONS(1286), 1,
      anon_sym_LBRACE,
    ACTIONS(1288), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(1290), 1,
      anon_sym_LBRACK,
    ACTIONS(1292), 1,
      anon_sym_LT,
    ACTIONS(2648), 1,
      anon_sym_RBRACE_GT,
    STATE(372), 1,
      sym_type,
    STATE(1381), 1,
      sym_type_and_value,
    STATE(545), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(1280), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6818] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    ACTIONS(2650), 1,
      anon_sym_inrange,
    STATE(237), 1,
      sym_type,
    STATE(595), 1,
      sym_type_and_value,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6873] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2652), 1,
      anon_sym_RBRACK,
    STATE(292), 1,
      sym_type,
    STATE(1380), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6928] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2654), 1,
      anon_sym_GT,
    STATE(292), 1,
      sym_type,
    STATE(1379), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [6983] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2656), 1,
      anon_sym_GT,
    STATE(292), 1,
      sym_type,
    STATE(1236), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7038] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2658), 1,
      anon_sym_inrange,
    STATE(292), 1,
      sym_type,
    STATE(1341), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7093] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2660), 1,
      anon_sym_RBRACK,
    STATE(292), 1,
      sym_type,
    STATE(1395), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7148] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1276), 1,
      sym_local_var,
    ACTIONS(1282), 1,
      anon_sym_metadata,
    ACTIONS(1286), 1,
      anon_sym_LBRACE,
    ACTIONS(1288), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(1290), 1,
      anon_sym_LBRACK,
    ACTIONS(1292), 1,
      anon_sym_LT,
    ACTIONS(2662), 1,
      anon_sym_RBRACE_GT,
    STATE(372), 1,
      sym_type,
    STATE(1394), 1,
      sym_type_and_value,
    STATE(545), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(1280), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7203] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(567), 1,
      sym_type_and_value,
    STATE(652), 1,
      sym__load_store_suffix,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7258] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    ACTIONS(2664), 1,
      anon_sym_RBRACE,
    STATE(1466), 1,
      sym_type,
    STATE(1636), 1,
      sym_struct_body,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7311] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(214), 1,
      sym_local_var,
    ACTIONS(222), 1,
      anon_sym_LBRACE,
    ACTIONS(224), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(226), 1,
      anon_sym_LBRACK,
    ACTIONS(228), 1,
      anon_sym_LT,
    ACTIONS(2666), 1,
      anon_sym_RBRACE_GT,
    STATE(1319), 1,
      sym_type,
    STATE(1637), 1,
      sym_struct_body,
    STATE(6), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(216), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7364] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(567), 1,
      sym_type_and_value,
    STATE(636), 1,
      sym__load_store_suffix,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7419] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(214), 1,
      sym_local_var,
    ACTIONS(222), 1,
      anon_sym_LBRACE,
    ACTIONS(224), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(226), 1,
      anon_sym_LBRACK,
    ACTIONS(228), 1,
      anon_sym_LT,
    ACTIONS(2668), 1,
      anon_sym_RBRACE_GT,
    STATE(1319), 1,
      sym_type,
    STATE(1970), 1,
      sym_struct_body,
    STATE(6), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(216), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7472] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2670), 1,
      anon_sym_RBRACE,
    STATE(292), 1,
      sym_type,
    STATE(1393), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7527] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    ACTIONS(2672), 1,
      anon_sym_RBRACE,
    STATE(1466), 1,
      sym_type,
    STATE(1977), 1,
      sym_struct_body,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7580] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    ACTIONS(2674), 1,
      anon_sym_RBRACE,
    STATE(1466), 1,
      sym_type,
    STATE(1653), 1,
      sym_struct_body,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7633] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(214), 1,
      sym_local_var,
    ACTIONS(222), 1,
      anon_sym_LBRACE,
    ACTIONS(224), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(226), 1,
      anon_sym_LBRACK,
    ACTIONS(228), 1,
      anon_sym_LT,
    ACTIONS(2676), 1,
      anon_sym_RBRACE_GT,
    STATE(1319), 1,
      sym_type,
    STATE(1654), 1,
      sym_struct_body,
    STATE(6), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(216), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7686] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(214), 1,
      sym_local_var,
    ACTIONS(222), 1,
      anon_sym_LBRACE,
    ACTIONS(224), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(226), 1,
      anon_sym_LBRACK,
    ACTIONS(228), 1,
      anon_sym_LT,
    ACTIONS(2678), 1,
      anon_sym_RBRACE_GT,
    STATE(1319), 1,
      sym_type,
    STATE(1635), 1,
      sym_struct_body,
    STATE(6), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(216), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7739] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    ACTIONS(2680), 1,
      anon_sym_RBRACE,
    STATE(1466), 1,
      sym_type,
    STATE(1629), 1,
      sym_struct_body,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7792] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(158), 1,
      anon_sym_dso_local,
    ACTIONS(317), 1,
      anon_sym_no_cfi,
    STATE(105), 1,
      sym_var,
    ACTIONS(33), 2,
      sym_global_var,
      sym_local_var,
    ACTIONS(156), 2,
      anon_sym_weak,
      anon_sym_linkonce,
    ACTIONS(321), 2,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
    ACTIONS(325), 2,
      anon_sym_dllimport,
      anon_sym_dllexport,
    STATE(234), 2,
      sym_linkage,
      aux_sym_function_header_repeat1,
    ACTIONS(323), 3,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
    STATE(245), 4,
      sym_linkage_aux,
      sym_dso_local,
      sym_visibility,
      sym_dll_storage_class,
    ACTIONS(319), 9,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
      anon_sym_external,
  [7847] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2682), 1,
      anon_sym_inrange,
    STATE(292), 1,
      sym_type,
    STATE(1386), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [7902] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(158), 1,
      anon_sym_dso_local,
    ACTIONS(317), 1,
      anon_sym_no_cfi,
    STATE(1495), 1,
      sym_var,
    ACTIONS(156), 2,
      anon_sym_weak,
      anon_sym_linkonce,
    ACTIONS(321), 2,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
    ACTIONS(325), 2,
      anon_sym_dllimport,
      anon_sym_dllexport,
    ACTIONS(1300), 2,
      sym_global_var,
      sym_local_var,
    STATE(234), 2,
      sym_linkage,
      aux_sym_function_header_repeat1,
    ACTIONS(323), 3,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
    STATE(245), 4,
      sym_linkage_aux,
      sym_dso_local,
      sym_visibility,
      sym_dll_storage_class,
    ACTIONS(319), 9,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
      anon_sym_external,
  [7957] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(158), 1,
      anon_sym_dso_local,
    ACTIONS(317), 1,
      anon_sym_no_cfi,
    STATE(353), 1,
      sym_var,
    ACTIONS(156), 2,
      anon_sym_weak,
      anon_sym_linkonce,
    ACTIONS(321), 2,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
    ACTIONS(325), 2,
      anon_sym_dllimport,
      anon_sym_dllexport,
    ACTIONS(426), 2,
      sym_global_var,
      sym_local_var,
    STATE(234), 2,
      sym_linkage,
      aux_sym_function_header_repeat1,
    ACTIONS(323), 3,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
    STATE(245), 4,
      sym_linkage_aux,
      sym_dso_local,
      sym_visibility,
      sym_dll_storage_class,
    ACTIONS(319), 9,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
      anon_sym_external,
  [8012] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2684), 1,
      anon_sym_inrange,
    STATE(292), 1,
      sym_type,
    STATE(1415), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8067] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2686), 1,
      anon_sym_inrange,
    STATE(292), 1,
      sym_type,
    STATE(1429), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8122] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    ACTIONS(2688), 1,
      anon_sym_inrange,
    STATE(237), 1,
      sym_type,
    STATE(584), 1,
      sym_type_and_value,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8177] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    ACTIONS(2690), 1,
      anon_sym_to,
    STATE(237), 1,
      sym_type,
    STATE(648), 1,
      sym_type_and_value,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(985), 4,
      anon_sym_weak,
      anon_sym_linkonce,
      anon_sym_external,
      anon_sym_dso_local,
    ACTIONS(983), 25,
      anon_sym_no_cfi,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
      anon_sym_dllimport,
      anon_sym_dllexport,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
      anon_sym_addrspace,
      anon_sym_externally_initialized,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
      anon_sym_thread_local,
  [8269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(989), 4,
      anon_sym_weak,
      anon_sym_linkonce,
      anon_sym_external,
      anon_sym_dso_local,
    ACTIONS(987), 25,
      anon_sym_no_cfi,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
      anon_sym_dllimport,
      anon_sym_dllexport,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
      anon_sym_addrspace,
      anon_sym_externally_initialized,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
      anon_sym_thread_local,
  [8306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(977), 4,
      anon_sym_weak,
      anon_sym_linkonce,
      anon_sym_external,
      anon_sym_dso_local,
    ACTIONS(975), 25,
      anon_sym_no_cfi,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
      anon_sym_dllimport,
      anon_sym_dllexport,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
      anon_sym_addrspace,
      anon_sym_externally_initialized,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
      anon_sym_thread_local,
  [8343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 4,
      anon_sym_weak,
      anon_sym_linkonce,
      anon_sym_external,
      anon_sym_dso_local,
    ACTIONS(967), 25,
      anon_sym_no_cfi,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
      anon_sym_dllimport,
      anon_sym_dllexport,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
      anon_sym_addrspace,
      anon_sym_externally_initialized,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
      anon_sym_thread_local,
  [8380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(981), 4,
      anon_sym_weak,
      anon_sym_linkonce,
      anon_sym_external,
      anon_sym_dso_local,
    ACTIONS(979), 25,
      anon_sym_no_cfi,
      anon_sym_private,
      anon_sym_internal,
      anon_sym_weak_odr,
      anon_sym_linkonce_odr,
      anon_sym_available_externally,
      anon_sym_appending,
      anon_sym_common,
      anon_sym_extern_weak,
      anon_sym_dso_local_equivalent,
      anon_sym_dso_preemptable,
      anon_sym_default,
      anon_sym_hidden,
      anon_sym_protected,
      anon_sym_dllimport,
      anon_sym_dllexport,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
      anon_sym_addrspace,
      anon_sym_externally_initialized,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
      anon_sym_thread_local,
  [8417] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2692), 1,
      anon_sym_RPAREN,
    STATE(292), 1,
      sym_type,
    STATE(1314), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8472] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2694), 1,
      anon_sym_inrange,
    STATE(292), 1,
      sym_type,
    STATE(1462), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8527] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(283), 1,
      sym_local_var,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(295), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(297), 1,
      anon_sym_LBRACK,
    ACTIONS(299), 1,
      anon_sym_LT,
    ACTIONS(2559), 1,
      anon_sym_metadata,
    ACTIONS(2563), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(59), 1,
      sym_type,
    STATE(1525), 1,
      sym_argument,
    STATE(62), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(287), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8582] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2696), 1,
      anon_sym_inrange,
    STATE(292), 1,
      sym_type,
    STATE(1458), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8637] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(567), 1,
      sym_type_and_value,
    STATE(624), 1,
      sym__load_store_suffix,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8692] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2698), 1,
      anon_sym_nneg,
    STATE(292), 1,
      sym_type,
    STATE(1601), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8747] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2700), 1,
      anon_sym_volatile,
    STATE(292), 1,
      sym_type,
    STATE(1704), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8802] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2702), 1,
      anon_sym_inrange,
    STATE(292), 1,
      sym_type,
    STATE(1424), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8857] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2704), 1,
      anon_sym_volatile,
    STATE(292), 1,
      sym_type,
    STATE(1773), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8912] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(567), 1,
      sym_type_and_value,
    STATE(621), 1,
      sym__load_store_suffix,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [8967] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2706), 1,
      anon_sym_inrange,
    STATE(292), 1,
      sym_type,
    STATE(1420), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9022] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2708), 1,
      anon_sym_RPAREN,
    STATE(292), 1,
      sym_type,
    STATE(1308), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9077] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2710), 1,
      anon_sym_inrange,
    STATE(292), 1,
      sym_type,
    STATE(1399), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9132] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2712), 1,
      anon_sym_inrange,
    STATE(292), 1,
      sym_type,
    STATE(1397), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9187] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2714), 1,
      anon_sym_inrange,
    STATE(292), 1,
      sym_type,
    STATE(1368), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9242] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(265), 1,
      anon_sym_uselistorder,
    ACTIONS(961), 1,
      anon_sym_addrspace,
    ACTIONS(1020), 1,
      anon_sym_LPAREN,
    ACTIONS(1024), 1,
      anon_sym_STAR,
    STATE(258), 1,
      aux_sym_type_repeat1,
    STATE(276), 1,
      sym_argument_list,
    STATE(284), 1,
      sym_addrspace,
    ACTIONS(263), 22,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_cleanup,
      anon_sym_catch,
      anon_sym_filter,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [9291] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2716), 1,
      anon_sym_inrange,
    STATE(292), 1,
      sym_type,
    STATE(1363), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9346] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2718), 1,
      anon_sym_inrange,
    STATE(292), 1,
      sym_type,
    STATE(1291), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9401] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2720), 1,
      anon_sym_inrange,
    STATE(292), 1,
      sym_type,
    STATE(1350), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9456] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2722), 1,
      anon_sym_inrange,
    STATE(292), 1,
      sym_type,
    STATE(1348), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9511] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    ACTIONS(2724), 1,
      anon_sym_atomic,
    ACTIONS(2726), 1,
      anon_sym_volatile,
    STATE(1624), 1,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9564] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2728), 1,
      anon_sym_inalloca,
    ACTIONS(2730), 1,
      anon_sym_swifterror,
    STATE(605), 1,
      sym_type,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9617] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(2732), 1,
      anon_sym_inrange,
    STATE(292), 1,
      sym_type,
    STATE(1285), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9672] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1392), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9724] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1849), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9776] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1822), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9828] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(620), 1,
      sym_type_and_value,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9880] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1821), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9932] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(1338), 1,
      anon_sym_metadata,
    STATE(282), 1,
      sym_type,
    STATE(1087), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [9984] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(619), 1,
      sym_type_and_value,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10036] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(618), 1,
      sym_type_and_value,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10088] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1810), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10140] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1809), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10192] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(617), 1,
      sym_type_and_value,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10244] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1808), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10296] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1807), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10348] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1806), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10400] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1594), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10452] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1803), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10504] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1962), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10556] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1802), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10608] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1960), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10660] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1680), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10712] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1798), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10764] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1797), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10816] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1795), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10868] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1157), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10920] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(616), 1,
      sym_type_and_value,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [10972] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1794), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11024] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1681), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11076] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1686), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11128] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1627), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11180] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1959), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11232] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1687), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11284] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(1342), 1,
      anon_sym_metadata,
    STATE(392), 1,
      sym_type,
    STATE(1690), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11336] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1986), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11388] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1958), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11440] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1900), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11492] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1694), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11544] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1667), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11596] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1700), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11648] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1674), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11700] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1688), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11752] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1691), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11804] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1736), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11856] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1595), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11908] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2734), 1,
      anon_sym_metadata,
    STATE(250), 1,
      sym_type,
    STATE(604), 1,
      sym_type_and_value,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [11960] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1906), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12012] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1707), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12064] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(627), 1,
      sym_type_and_value,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12116] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(608), 1,
      sym_type_and_value,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12168] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(655), 1,
      sym_type_and_value,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12220] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(657), 1,
      sym_type_and_value,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12272] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1947), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12324] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1344), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12376] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1703), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12428] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1864), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12480] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1863), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12532] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1348), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12584] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1847), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12636] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1610), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12688] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1987), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12740] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1825), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12792] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1291), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12844] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1623), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12896] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1988), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [12948] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1622), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13000] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1621), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13052] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1620), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13104] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1619), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13156] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1616), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13208] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1615), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13260] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(603), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13312] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1613), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13364] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1357), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13416] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1608), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13468] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1826), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13520] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1363), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13572] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1715), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13624] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(283), 1,
      sym_local_var,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(295), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(297), 1,
      anon_sym_LBRACK,
    ACTIONS(299), 1,
      anon_sym_LT,
    ACTIONS(420), 1,
      anon_sym_metadata,
    STATE(55), 1,
      sym_type,
    STATE(470), 1,
      sym_type_and_value,
    STATE(62), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(287), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13676] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1651), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13728] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1604), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13780] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1827), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13832] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1828), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13884] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1300), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13936] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1599), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [13988] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(603), 1,
      sym_type_and_value,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14040] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2736), 1,
      anon_sym_swifterror,
    STATE(599), 1,
      sym_type,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14090] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1945), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14142] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    ACTIONS(2738), 1,
      anon_sym_volatile,
    STATE(1782), 1,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14192] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1721), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14244] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1397), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14296] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1829), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14348] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1609), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14400] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1722), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14452] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1723), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14504] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(283), 1,
      sym_local_var,
    ACTIONS(289), 1,
      anon_sym_metadata,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(295), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(297), 1,
      anon_sym_LBRACK,
    ACTIONS(299), 1,
      anon_sym_LT,
    STATE(15), 1,
      sym_type,
    STATE(420), 1,
      sym_type_and_value,
    STATE(62), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(287), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14556] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1728), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14608] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1160), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14660] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1732), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14712] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1735), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14764] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1737), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14816] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1738), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14868] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1830), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14920] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1729), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [14972] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1744), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15024] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1409), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15076] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1752), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15128] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1976), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15180] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1831), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15232] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1832), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15284] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1420), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15336] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1763), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15388] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1833), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15440] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1843), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15492] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1770), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15544] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1773), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15596] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1844), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15648] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1846), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15700] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1704), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15752] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1454), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15804] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1458), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15856] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(626), 1,
      sym_type_and_value,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15908] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1719), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [15960] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1159), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16012] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1996), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16064] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1905), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16116] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1848), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16168] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1824), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16220] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1850), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16272] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1851), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16324] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(578), 1,
      sym_type_and_value,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16376] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(2008), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16428] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(639), 1,
      sym_type_and_value,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16480] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1852), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16532] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(2009), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16584] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1885), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16636] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1980), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16688] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1675), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16740] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1979), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16792] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1853), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16844] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1944), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16896] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1978), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [16948] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1731), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17000] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1839), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17052] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1446), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17104] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1791), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17156] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1891), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17208] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1854), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17260] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1429), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17312] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1772), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17364] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(584), 1,
      sym_type_and_value,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17416] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1257), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17468] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1748), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17520] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1766), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17572] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1908), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17624] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1855), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17676] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1643), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17728] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1193), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17780] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1714), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17832] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1943), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17884] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1657), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17936] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1664), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [17988] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(600), 1,
      sym_type_and_value,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18040] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1155), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18092] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1596), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18144] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1156), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18196] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1747), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18248] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(283), 1,
      sym_local_var,
    ACTIONS(289), 1,
      anon_sym_metadata,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(295), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(297), 1,
      anon_sym_LBRACK,
    ACTIONS(299), 1,
      anon_sym_LT,
    STATE(15), 1,
      sym_type,
    STATE(470), 1,
      sym_type_and_value,
    STATE(62), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(287), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18300] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    ACTIONS(2423), 1,
      anon_sym_metadata,
    STATE(237), 1,
      sym_type,
    STATE(665), 1,
      sym_type_and_value,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18352] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(283), 1,
      sym_local_var,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(295), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(297), 1,
      anon_sym_LBRACK,
    ACTIONS(299), 1,
      anon_sym_LT,
    ACTIONS(431), 1,
      anon_sym_metadata,
    STATE(57), 1,
      sym_type,
    STATE(470), 1,
      sym_type_and_value,
    STATE(62), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(287), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18404] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1910), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18456] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1668), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18508] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1749), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18560] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1867), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18612] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1750), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18664] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1819), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18716] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1928), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18768] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(118), 1,
      sym_local_var,
    ACTIONS(128), 1,
      anon_sym_LBRACE,
    ACTIONS(130), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(132), 1,
      anon_sym_LBRACK,
    ACTIONS(134), 1,
      anon_sym_LT,
    ACTIONS(2742), 1,
      anon_sym_metadata,
    STATE(4), 1,
      sym_type,
    STATE(222), 1,
      sym_type_and_value,
    STATE(30), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2740), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18820] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1929), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18872] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1283), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18924] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1634), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [18976] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1804), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19028] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1930), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19080] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1276), 1,
      sym_local_var,
    ACTIONS(1282), 1,
      anon_sym_metadata,
    ACTIONS(1286), 1,
      anon_sym_LBRACE,
    ACTIONS(1288), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(1290), 1,
      anon_sym_LBRACK,
    ACTIONS(1292), 1,
      anon_sym_LT,
    STATE(372), 1,
      sym_type,
    STATE(1575), 1,
      sym_type_and_value,
    STATE(545), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(1280), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19132] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1984), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19184] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1765), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19236] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1751), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19288] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1932), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19340] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(283), 1,
      sym_local_var,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(295), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(297), 1,
      anon_sym_LBRACK,
    ACTIONS(299), 1,
      anon_sym_LT,
    ACTIONS(422), 1,
      anon_sym_metadata,
    STATE(52), 1,
      sym_type,
    STATE(470), 1,
      sym_type_and_value,
    STATE(62), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(287), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19392] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1754), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19444] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(440), 1,
      anon_sym_metadata,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(292), 1,
      sym_type,
    STATE(1341), 1,
      sym_type_and_value,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 15,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19496] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1780), 1,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19543] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    STATE(583), 1,
      sym_type,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19590] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1926), 1,
      sym_fcmp_cond,
    STATE(1072), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2744), 16,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
  [19629] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1786), 1,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19676] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1871), 1,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19723] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1640), 1,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19770] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1941), 1,
      sym_fcmp_cond,
    STATE(1070), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2744), 16,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
  [19809] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1672), 1,
      sym_fcmp_cond,
    STATE(713), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2744), 16,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
  [19848] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    STATE(676), 1,
      sym_type,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19895] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1963), 1,
      sym_fcmp_cond,
    STATE(1049), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2744), 16,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
  [19934] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(378), 1,
      sym_type,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [19981] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1961), 1,
      sym_fcmp_cond,
    STATE(713), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2744), 16,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
  [20020] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(907), 1,
      sym_fcmp_cond,
    STATE(1069), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2744), 16,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
  [20059] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(214), 1,
      sym_local_var,
    ACTIONS(222), 1,
      anon_sym_LBRACE,
    ACTIONS(224), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(226), 1,
      anon_sym_LBRACK,
    ACTIONS(228), 1,
      anon_sym_LT,
    STATE(1590), 1,
      sym_type,
    STATE(6), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(216), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20106] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1108), 1,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20153] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1606), 1,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20200] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1709), 1,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20247] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1799), 1,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20294] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1775), 1,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20341] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1933), 1,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20388] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(380), 1,
      sym_type,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20435] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1741), 1,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20482] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1782), 1,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20529] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1576), 1,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20576] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    STATE(599), 1,
      sym_type,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20623] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    STATE(609), 1,
      sym_type,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20670] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1553), 1,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20717] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(905), 1,
      sym_fcmp_cond,
    STATE(713), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2744), 16,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
  [20756] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1946), 1,
      sym_fcmp_cond,
    STATE(713), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2744), 16,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
  [20795] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1605), 1,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20842] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1931), 1,
      sym_fcmp_cond,
    STATE(713), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2744), 16,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
  [20881] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1221), 1,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20928] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1789), 1,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [20975] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1614), 1,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [21022] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1983), 1,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [21069] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym_local_var,
    ACTIONS(944), 1,
      anon_sym_LBRACE,
    ACTIONS(946), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(948), 1,
      anon_sym_LBRACK,
    ACTIONS(950), 1,
      anon_sym_LT,
    STATE(642), 1,
      sym_type,
    STATE(285), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(2421), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [21116] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1554), 1,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [21163] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    ACTIONS(717), 1,
      sym_local_var,
    STATE(1708), 1,
      sym_type,
    STATE(769), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [21210] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(375), 1,
      sym_type,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [21257] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(373), 1,
      sym_type,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [21304] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(379), 1,
      sym_type,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [21351] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1956), 1,
      sym_fcmp_cond,
    STATE(1053), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
    ACTIONS(2744), 16,
      anon_sym_true,
      anon_sym_false,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_oeq,
      anon_sym_ogt,
      anon_sym_oge,
      anon_sym_olt,
      anon_sym_ole,
      anon_sym_one,
      anon_sym_ord,
      anon_sym_ueq,
      anon_sym_une,
      anon_sym_uno,
  [21390] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 1,
      sym_local_var,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_LBRACE,
    ACTIONS(448), 1,
      anon_sym_LBRACK,
    ACTIONS(450), 1,
      anon_sym_LT,
    STATE(377), 1,
      sym_type,
    STATE(260), 5,
      sym_type_keyword,
      sym_struct_type,
      sym_packed_struct_type,
      sym_array_type,
      sym_vector_type,
    ACTIONS(438), 16,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
  [21437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2748), 2,
      anon_sym_LT,
      anon_sym_BANG,
    ACTIONS(2746), 22,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_LBRACE,
      anon_sym_LT_LBRACE,
      anon_sym_LBRACK,
      anon_sym_null,
  [21469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2752), 1,
      anon_sym_LT,
    ACTIONS(2750), 22,
      sym_local_var,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_LBRACE,
      anon_sym_LT_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_nneg,
  [21500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2756), 1,
      anon_sym_LT,
    ACTIONS(2754), 21,
      sym_local_var,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_LBRACE,
      anon_sym_LT_LBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [21530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_LT,
    ACTIONS(2758), 21,
      sym_local_var,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_LBRACE,
      anon_sym_LT_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [21560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2764), 1,
      anon_sym_LT,
    ACTIONS(2762), 21,
      sym_local_var,
      anon_sym_void,
      anon_sym_half,
      anon_sym_bfloat,
      anon_sym_float,
      anon_sym_double,
      anon_sym_x86_fp80,
      anon_sym_fp128,
      anon_sym_ppc_fp128,
      anon_sym_label,
      anon_sym_metadata,
      anon_sym_x86_mmx,
      anon_sym_x86_amx,
      anon_sym_token,
      anon_sym_opaque,
      anon_sym_ptr,
      aux_sym_type_keyword_token1,
      anon_sym_LBRACE,
      anon_sym_LT_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [21590] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1487), 1,
      anon_sym_uselistorder,
    ACTIONS(2766), 1,
      anon_sym_COMMA,
    STATE(1092), 2,
      sym_metadata_refs,
      aux_sym_instruction_repeat1,
    ACTIONS(1483), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21619] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2766), 1,
      anon_sym_COMMA,
    ACTIONS(2770), 1,
      anon_sym_uselistorder,
    STATE(1092), 2,
      sym_metadata_refs,
      aux_sym_instruction_repeat1,
    ACTIONS(2768), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21648] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1828), 1,
      anon_sym_uselistorder,
    ACTIONS(2772), 1,
      anon_sym_COMMA,
    STATE(1092), 2,
      sym_metadata_refs,
      aux_sym_instruction_repeat1,
    ACTIONS(1823), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21677] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2766), 1,
      anon_sym_COMMA,
    ACTIONS(2777), 1,
      anon_sym_uselistorder,
    STATE(1092), 2,
      sym_metadata_refs,
      aux_sym_instruction_repeat1,
    ACTIONS(2775), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21706] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2766), 1,
      anon_sym_COMMA,
    ACTIONS(2781), 1,
      anon_sym_uselistorder,
    STATE(1092), 2,
      sym_metadata_refs,
      aux_sym_instruction_repeat1,
    ACTIONS(2779), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21735] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1499), 1,
      anon_sym_uselistorder,
    ACTIONS(2766), 1,
      anon_sym_COMMA,
    STATE(1092), 2,
      sym_metadata_refs,
      aux_sym_instruction_repeat1,
    ACTIONS(1497), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21764] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_uselistorder,
    ACTIONS(2766), 1,
      anon_sym_COMMA,
    STATE(1092), 2,
      sym_metadata_refs,
      aux_sym_instruction_repeat1,
    ACTIONS(1509), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21793] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1503), 1,
      anon_sym_uselistorder,
    ACTIONS(2766), 1,
      anon_sym_COMMA,
    STATE(1092), 2,
      sym_metadata_refs,
      aux_sym_instruction_repeat1,
    ACTIONS(1501), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21822] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 1,
      anon_sym_uselistorder,
    ACTIONS(2766), 1,
      anon_sym_COMMA,
    STATE(1092), 2,
      sym_metadata_refs,
      aux_sym_instruction_repeat1,
    ACTIONS(1489), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2785), 1,
      anon_sym_uselistorder,
    ACTIONS(2783), 14,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_RBRACE,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2789), 1,
      anon_sym_uselistorder,
    ACTIONS(2787), 14,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_RBRACE,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2793), 1,
      anon_sym_uselistorder,
    ACTIONS(2791), 14,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_RBRACE,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2797), 1,
      anon_sym_uselistorder,
    ACTIONS(2795), 14,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_COMMA,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21943] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2799), 1,
      anon_sym_volatile,
    STATE(988), 1,
      sym_atomic_bin_op_keyword,
    ACTIONS(110), 13,
      anon_sym_xchg,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_and,
      anon_sym_nand,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_max,
      anon_sym_min,
      anon_sym_umax,
      anon_sym_umin,
      anon_sym_fadd,
      anon_sym_fsub,
  [21968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1998), 1,
      anon_sym_uselistorder,
    ACTIONS(1996), 14,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_COMMA,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [21991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2803), 1,
      anon_sym_uselistorder,
    ACTIONS(2801), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22013] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2805), 1,
      anon_sym_LPAREN,
    STATE(1118), 2,
      sym_fast_math,
      aux_sym_constant_bin_op_repeat1,
    ACTIONS(2807), 3,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [22039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2811), 1,
      anon_sym_uselistorder,
    ACTIONS(2809), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2815), 1,
      anon_sym_uselistorder,
    ACTIONS(2813), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22083] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2817), 1,
      anon_sym_LPAREN,
    STATE(1124), 2,
      sym_fast_math,
      aux_sym_constant_bin_op_repeat1,
    ACTIONS(2819), 3,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [22109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(993), 1,
      sym_atomic_bin_op_keyword,
    ACTIONS(110), 13,
      anon_sym_xchg,
      anon_sym_add,
      anon_sym_sub,
      anon_sym_and,
      anon_sym_nand,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_max,
      anon_sym_min,
      anon_sym_umax,
      anon_sym_umin,
      anon_sym_fadd,
      anon_sym_fsub,
  [22131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2823), 1,
      anon_sym_uselistorder,
    ACTIONS(2821), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2827), 1,
      anon_sym_uselistorder,
    ACTIONS(2825), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2831), 1,
      anon_sym_uselistorder,
    ACTIONS(2829), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2835), 1,
      anon_sym_uselistorder,
    ACTIONS(2833), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2839), 1,
      anon_sym_uselistorder,
    ACTIONS(2837), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2843), 1,
      anon_sym_uselistorder,
    ACTIONS(2841), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2847), 1,
      anon_sym_uselistorder,
    ACTIONS(2845), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22285] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2849), 1,
      anon_sym_LPAREN,
    STATE(1124), 2,
      sym_fast_math,
      aux_sym_constant_bin_op_repeat1,
    ACTIONS(2819), 3,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [22311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2853), 1,
      anon_sym_uselistorder,
    ACTIONS(2851), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2857), 1,
      anon_sym_uselistorder,
    ACTIONS(2855), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2861), 1,
      anon_sym_uselistorder,
    ACTIONS(2859), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22377] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2863), 1,
      anon_sym_LPAREN,
    STATE(1109), 2,
      sym_fast_math,
      aux_sym_constant_bin_op_repeat1,
    ACTIONS(2865), 3,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [22403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2869), 1,
      anon_sym_uselistorder,
    ACTIONS(2867), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22425] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2871), 1,
      anon_sym_LPAREN,
    STATE(1124), 2,
      sym_fast_math,
      aux_sym_constant_bin_op_repeat1,
    ACTIONS(2873), 3,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
    ACTIONS(2876), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [22451] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2879), 1,
      anon_sym_LPAREN,
    STATE(1124), 2,
      sym_fast_math,
      aux_sym_constant_bin_op_repeat1,
    ACTIONS(2819), 3,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [22477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2883), 1,
      anon_sym_uselistorder,
    ACTIONS(2881), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22499] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2885), 1,
      anon_sym_LPAREN,
    STATE(1125), 2,
      sym_fast_math,
      aux_sym_constant_bin_op_repeat1,
    ACTIONS(2887), 3,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [22525] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2889), 1,
      anon_sym_LPAREN,
    STATE(1124), 2,
      sym_fast_math,
      aux_sym_constant_bin_op_repeat1,
    ACTIONS(2819), 3,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [22551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2893), 1,
      anon_sym_uselistorder,
    ACTIONS(2891), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2897), 1,
      anon_sym_uselistorder,
    ACTIONS(2895), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 1,
      anon_sym_uselistorder,
    ACTIONS(2899), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2905), 1,
      anon_sym_uselistorder,
    ACTIONS(2903), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22639] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2907), 1,
      anon_sym_LPAREN,
    STATE(1128), 2,
      sym_fast_math,
      aux_sym_constant_bin_op_repeat1,
    ACTIONS(2909), 3,
      anon_sym_nsw,
      anon_sym_nuw,
      anon_sym_exact,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [22665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2913), 1,
      anon_sym_uselistorder,
    ACTIONS(2911), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_uselistorder,
    ACTIONS(2915), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2921), 1,
      anon_sym_uselistorder,
    ACTIONS(2919), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_uselistorder,
    ACTIONS(2923), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2929), 1,
      anon_sym_uselistorder,
    ACTIONS(2927), 13,
      ts_builtin_sym_end,
      sym_comdat_ref,
      sym_global_var,
      sym_local_var,
      aux_sym_metadata_ref_token1,
      sym_summary_ref,
      anon_sym_target,
      anon_sym_source_filename,
      anon_sym_declare,
      anon_sym_define,
      anon_sym_uselistorder_bb,
      anon_sym_module,
      anon_sym_attributes,
  [22775] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2931), 1,
      anon_sym_LPAREN,
    STATE(713), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [22796] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    STATE(713), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [22817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1940), 1,
      sym_icmp_cond,
    ACTIONS(2935), 10,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_sgt,
      anon_sym_sge,
      anon_sym_slt,
      anon_sym_sle,
  [22836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2937), 1,
      anon_sym_LPAREN,
    STATE(713), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [22857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(906), 1,
      sym_icmp_cond,
    ACTIONS(2935), 10,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_sgt,
      anon_sym_sge,
      anon_sym_slt,
      anon_sym_sle,
  [22876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1925), 1,
      sym_icmp_cond,
    ACTIONS(2935), 10,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_sgt,
      anon_sym_sge,
      anon_sym_slt,
      anon_sym_sle,
  [22895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1955), 1,
      sym_icmp_cond,
    ACTIONS(2935), 10,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_sgt,
      anon_sym_sge,
      anon_sym_slt,
      anon_sym_sle,
  [22914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2939), 1,
      anon_sym_LPAREN,
    STATE(1142), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [22935] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    STATE(713), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [22956] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      anon_sym_LPAREN,
    STATE(1147), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [22977] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LPAREN,
    STATE(1139), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [22998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1896), 1,
      sym_icmp_cond,
    ACTIONS(2935), 10,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_ugt,
      anon_sym_uge,
      anon_sym_ult,
      anon_sym_ule,
      anon_sym_sgt,
      anon_sym_sge,
      anon_sym_slt,
      anon_sym_sle,
  [23017] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2947), 1,
      anon_sym_LPAREN,
    STATE(1140), 2,
      sym_fast_math,
      aux_sym_instruction_select_repeat1,
    ACTIONS(2417), 8,
      anon_sym_nnan,
      anon_sym_ninf,
      anon_sym_nsz,
      anon_sym_arcp,
      anon_sym_contract,
      anon_sym_afn,
      anon_sym_reassoc,
      anon_sym_fast,
  [23038] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(961), 1,
      anon_sym_addrspace,
    ACTIONS(2949), 1,
      anon_sym_externally_initialized,
    STATE(1177), 1,
      sym_unnamed_addr,
    STATE(1214), 1,
      sym_addrspace,
    ACTIONS(727), 2,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
    ACTIONS(2951), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [23064] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(961), 1,
      anon_sym_addrspace,
    ACTIONS(2439), 1,
      anon_sym_externally_initialized,
    STATE(1176), 1,
      sym_unnamed_addr,
    STATE(1215), 1,
      sym_addrspace,
    ACTIONS(727), 2,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
    ACTIONS(2441), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [23090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LPAREN,
    ACTIONS(2953), 8,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
      anon_sym_addrspace,
      anon_sym_externally_initialized,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [23107] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2959), 1,
      anon_sym_syncscope,
    STATE(685), 1,
      sym_atomic_ordering,
    STATE(1164), 1,
      sym_syncscope,
    ACTIONS(2957), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [23128] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2959), 1,
      anon_sym_syncscope,
    STATE(1162), 1,
      sym_syncscope,
    STATE(1168), 1,
      sym_atomic_ordering,
    ACTIONS(2961), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [23149] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2959), 1,
      anon_sym_syncscope,
    STATE(1163), 1,
      sym_syncscope,
    STATE(1179), 1,
      sym_atomic_ordering,
    ACTIONS(2961), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [23170] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2959), 1,
      anon_sym_syncscope,
    STATE(614), 1,
      sym_atomic_ordering,
    STATE(1165), 1,
      sym_syncscope,
    ACTIONS(2957), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [23191] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2959), 1,
      anon_sym_syncscope,
    STATE(1173), 1,
      sym_atomic_ordering,
    STATE(1175), 1,
      sym_syncscope,
    ACTIONS(2961), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [23212] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2959), 1,
      anon_sym_syncscope,
    STATE(653), 1,
      sym_atomic_ordering,
    STATE(1172), 1,
      sym_syncscope,
    ACTIONS(2957), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [23233] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2963), 8,
      anon_sym_unnamed_addr,
      anon_sym_local_unnamed_addr,
      anon_sym_addrspace,
      anon_sym_externally_initialized,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [23247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1173), 1,
      sym_atomic_ordering,
    ACTIONS(2961), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [23262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1174), 1,
      sym_atomic_ordering,
    ACTIONS(2961), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [23277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(683), 1,
      sym_atomic_ordering,
    ACTIONS(2957), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [23292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(631), 1,
      sym_atomic_ordering,
    ACTIONS(2957), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [23307] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_read,
    STATE(1340), 1,
      sym_memory_attribute_val,
    ACTIONS(2965), 2,
      anon_sym_argmem,
      anon_sym_inaccessiblemem,
    ACTIONS(2967), 3,
      anon_sym_none,
      anon_sym_write,
      anon_sym_readwrite,
  [23326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_read,
    STATE(1389), 1,
      sym_memory_attribute_val,
    ACTIONS(2971), 2,
      anon_sym_argmem,
      anon_sym_inaccessiblemem,
    ACTIONS(2967), 3,
      anon_sym_none,
      anon_sym_write,
      anon_sym_readwrite,
  [23345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(684), 1,
      sym_atomic_ordering,
    ACTIONS(2957), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [23360] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(961), 1,
      anon_sym_addrspace,
    ACTIONS(2439), 1,
      anon_sym_externally_initialized,
    STATE(1215), 1,
      sym_addrspace,
    ACTIONS(2441), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [23379] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_read,
    STATE(1481), 1,
      sym_memory_attribute_val,
    ACTIONS(2973), 2,
      anon_sym_argmem,
      anon_sym_inaccessiblemem,
    ACTIONS(2967), 3,
      anon_sym_none,
      anon_sym_write,
      anon_sym_readwrite,
  [23398] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_read,
    STATE(1448), 1,
      sym_memory_attribute_val,
    ACTIONS(2975), 2,
      anon_sym_argmem,
      anon_sym_inaccessiblemem,
    ACTIONS(2967), 3,
      anon_sym_none,
      anon_sym_write,
      anon_sym_readwrite,
  [23417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(685), 1,
      sym_atomic_ordering,
    ACTIONS(2957), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [23432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(607), 1,
      sym_atomic_ordering,
    ACTIONS(2957), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [23447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(660), 1,
      sym_atomic_ordering,
    ACTIONS(2957), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [23462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1179), 1,
      sym_atomic_ordering,
    ACTIONS(2961), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [23477] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(961), 1,
      anon_sym_addrspace,
    ACTIONS(2949), 1,
      anon_sym_externally_initialized,
    STATE(1214), 1,
      sym_addrspace,
    ACTIONS(2951), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [23496] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(961), 1,
      anon_sym_addrspace,
    ACTIONS(2977), 1,
      anon_sym_externally_initialized,
    STATE(1199), 1,
      sym_addrspace,
    ACTIONS(2979), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [23515] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_read,
    STATE(1383), 1,
      sym_memory_attribute_val,
    ACTIONS(2981), 2,
      anon_sym_argmem,
      anon_sym_inaccessiblemem,
    ACTIONS(2967), 3,
      anon_sym_none,
      anon_sym_write,
      anon_sym_readwrite,
  [23534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(664), 1,
      sym_atomic_ordering,
    ACTIONS(2957), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [23549] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym_string,
    ACTIONS(2985), 1,
      anon_sym_alignstack,
    ACTIONS(2987), 1,
      anon_sym_unwind,
    ACTIONS(2989), 1,
      anon_sym_sideeffect,
    ACTIONS(2991), 1,
      anon_sym_inteldialect,
    STATE(1699), 1,
      sym_asm,
  [23571] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(719), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2993), 1,
      anon_sym_LBRACE,
    STATE(745), 1,
      sym_metadata_name,
    STATE(1120), 1,
      sym_function_body,
    STATE(1206), 2,
      sym_metadata_attachment,
      aux_sym_declare_repeat1,
  [23591] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(719), 1,
      aux_sym_metadata_ref_token1,
    ACTIONS(2993), 1,
      anon_sym_LBRACE,
    STATE(745), 1,
      sym_metadata_name,
    STATE(1107), 1,
      sym_function_body,
    STATE(1181), 2,
      sym_metadata_attachment,
      aux_sym_declare_repeat1,
  [23611] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(242), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_addrspace,
    ACTIONS(1024), 1,
      anon_sym_STAR,
    STATE(16), 1,
      sym_argument_list,
    STATE(258), 1,
      aux_sym_type_repeat1,
    STATE(1730), 1,
      sym_addrspace,
  [23633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2008), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [23645] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(961), 1,
      anon_sym_addrspace,
    ACTIONS(1024), 1,
      anon_sym_STAR,
    ACTIONS(1749), 1,
      anon_sym_LPAREN,
    STATE(258), 1,
      aux_sym_type_repeat1,
    STATE(556), 1,
      sym_argument_list,
    STATE(1730), 1,
      sym_addrspace,
  [23667] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_addrspace,
    ACTIONS(1024), 1,
      anon_sym_STAR,
    STATE(77), 1,
      sym_argument_list,
    STATE(258), 1,
      aux_sym_type_repeat1,
    STATE(1730), 1,
      sym_addrspace,
  [23689] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(961), 1,
      anon_sym_addrspace,
    ACTIONS(1020), 1,
      anon_sym_LPAREN,
    ACTIONS(1024), 1,
      anon_sym_STAR,
    STATE(258), 1,
      aux_sym_type_repeat1,
    STATE(276), 1,
      sym_argument_list,
    STATE(1730), 1,
      sym_addrspace,
  [23711] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_COMMA,
    STATE(1188), 1,
      aux_sym_instruction_callbr_repeat1,
    ACTIONS(2995), 4,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_RPAREN,
  [23727] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(405), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_addrspace,
    ACTIONS(1024), 1,
      anon_sym_STAR,
    STATE(40), 1,
      sym_argument_list,
    STATE(258), 1,
      aux_sym_type_repeat1,
    STATE(1730), 1,
      sym_addrspace,
  [23749] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(961), 1,
      anon_sym_addrspace,
    ACTIONS(1024), 1,
      anon_sym_STAR,
    ACTIONS(1041), 1,
      anon_sym_LPAREN,
    STATE(258), 1,
      aux_sym_type_repeat1,
    STATE(306), 1,
      sym_argument_list,
    STATE(1730), 1,
      sym_addrspace,
  [23771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1788), 6,
      anon_sym_unordered,
      anon_sym_monotonic,
      anon_sym_acquire,
      anon_sym_release,
      anon_sym_acq_rel,
      anon_sym_seq_cst,
  [23783] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    ACTIONS(3002), 1,
      anon_sym_LPAREN,
    STATE(1132), 1,
      sym_number,
    ACTIONS(3000), 2,
      sym_summary_ref,
      sym_string,
  [23803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2995), 5,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [23814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3004), 5,
      anon_sym_any,
      anon_sym_exactmatch,
      anon_sym_largest,
      anon_sym_nodeduplicate,
      anon_sym_samesize,
  [23825] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 1,
      aux_sym_number_token1,
    ACTIONS(1306), 1,
      aux_sym_number_token2,
    ACTIONS(3006), 1,
      anon_sym_vscale,
    STATE(1649), 1,
      sym_array_vector_body,
    STATE(1949), 1,
      sym_number,
  [23844] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 1,
      aux_sym_number_token1,
    ACTIONS(1306), 1,
      aux_sym_number_token2,
    ACTIONS(3006), 1,
      anon_sym_vscale,
    STATE(1648), 1,
      sym_array_vector_body,
    STATE(1949), 1,
      sym_number,
  [23863] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym_string,
    ACTIONS(3008), 1,
      anon_sym_alignstack,
    ACTIONS(3010), 1,
      anon_sym_unwind,
    ACTIONS(3012), 1,
      anon_sym_inteldialect,
    STATE(1897), 1,
      sym_asm,
  [23882] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 1,
      aux_sym_number_token1,
    ACTIONS(1306), 1,
      aux_sym_number_token2,
    ACTIONS(3006), 1,
      anon_sym_vscale,
    STATE(1874), 1,
      sym_array_vector_body,
    STATE(1949), 1,
      sym_number,
  [23901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 1,
      anon_sym_externally_initialized,
    ACTIONS(3016), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [23914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_read,
    STATE(1417), 1,
      sym_memory_attribute_val,
    ACTIONS(2967), 3,
      anon_sym_none,
      anon_sym_write,
      anon_sym_readwrite,
  [23929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2439), 1,
      anon_sym_externally_initialized,
    ACTIONS(2441), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [23942] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 1,
      aux_sym_number_token1,
    ACTIONS(1306), 1,
      aux_sym_number_token2,
    ACTIONS(3006), 1,
      anon_sym_vscale,
    STATE(1873), 1,
      sym_array_vector_body,
    STATE(1949), 1,
      sym_number,
  [23961] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_read,
    STATE(1423), 1,
      sym_memory_attribute_val,
    ACTIONS(2967), 3,
      anon_sym_none,
      anon_sym_write,
      anon_sym_readwrite,
  [23976] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 1,
      aux_sym_number_token1,
    ACTIONS(1306), 1,
      aux_sym_number_token2,
    ACTIONS(3006), 1,
      anon_sym_vscale,
    STATE(1656), 1,
      sym_array_vector_body,
    STATE(1949), 1,
      sym_number,
  [23995] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_read,
    STATE(1443), 1,
      sym_memory_attribute_val,
    ACTIONS(2967), 3,
      anon_sym_none,
      anon_sym_write,
      anon_sym_readwrite,
  [24010] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(952), 1,
      anon_sym_LBRACE,
    ACTIONS(954), 1,
      aux_sym_metadata_ref_token1,
    STATE(745), 1,
      sym_metadata_name,
    STATE(1206), 2,
      sym_metadata_attachment,
      aux_sym_declare_repeat1,
  [24027] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 1,
      aux_sym_number_token1,
    ACTIONS(1306), 1,
      aux_sym_number_token2,
    ACTIONS(3006), 1,
      anon_sym_vscale,
    STATE(1948), 1,
      sym_array_vector_body,
    STATE(1949), 1,
      sym_number,
  [24046] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 1,
      aux_sym_number_token1,
    ACTIONS(1306), 1,
      aux_sym_number_token2,
    ACTIONS(3006), 1,
      anon_sym_vscale,
    STATE(1934), 1,
      sym_array_vector_body,
    STATE(1949), 1,
      sym_number,
  [24065] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 1,
      aux_sym_number_token1,
    ACTIONS(1306), 1,
      aux_sym_number_token2,
    ACTIONS(3006), 1,
      anon_sym_vscale,
    STATE(1679), 1,
      sym_array_vector_body,
    STATE(1949), 1,
      sym_number,
  [24084] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 1,
      aux_sym_number_token1,
    ACTIONS(1306), 1,
      aux_sym_number_token2,
    ACTIONS(3006), 1,
      anon_sym_vscale,
    STATE(1655), 1,
      sym_array_vector_body,
    STATE(1949), 1,
      sym_number,
  [24103] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 1,
      aux_sym_number_token1,
    ACTIONS(1306), 1,
      aux_sym_number_token2,
    ACTIONS(3006), 1,
      anon_sym_vscale,
    STATE(1677), 1,
      sym_array_vector_body,
    STATE(1949), 1,
      sym_number,
  [24122] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 1,
      aux_sym_number_token1,
    ACTIONS(1306), 1,
      aux_sym_number_token2,
    ACTIONS(3006), 1,
      anon_sym_vscale,
    STATE(1639), 1,
      sym_array_vector_body,
    STATE(1949), 1,
      sym_number,
  [24141] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 1,
      aux_sym_number_token1,
    ACTIONS(1306), 1,
      aux_sym_number_token2,
    ACTIONS(3006), 1,
      anon_sym_vscale,
    STATE(1638), 1,
      sym_array_vector_body,
    STATE(1949), 1,
      sym_number,
  [24160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2977), 1,
      anon_sym_externally_initialized,
    ACTIONS(2979), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [24173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2949), 1,
      anon_sym_externally_initialized,
    ACTIONS(2951), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [24186] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_read,
    STATE(1500), 1,
      sym_memory_attribute_val,
    ACTIONS(2967), 3,
      anon_sym_none,
      anon_sym_write,
      anon_sym_readwrite,
  [24201] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_read,
    STATE(1366), 1,
      sym_memory_attribute_val,
    ACTIONS(2967), 3,
      anon_sym_none,
      anon_sym_write,
      anon_sym_readwrite,
  [24216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2951), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [24226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2979), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [24236] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      aux_sym_number_token1,
    ACTIONS(1346), 1,
      aux_sym_number_token2,
    ACTIONS(2551), 1,
      sym_string,
    STATE(228), 1,
      sym_number,
  [24252] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3018), 1,
      anon_sym_cleanup,
    STATE(570), 1,
      sym_landingpad_clause,
    ACTIONS(3020), 2,
      anon_sym_catch,
      anon_sym_filter,
  [24266] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 1,
      anon_sym_RBRACE,
    ACTIONS(3022), 1,
      anon_sym_uselistorder,
    STATE(1230), 2,
      sym_use_list_order,
      aux_sym_function_body_repeat2,
  [24280] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym_string,
    ACTIONS(3024), 1,
      anon_sym_unwind,
    ACTIONS(3026), 1,
      anon_sym_inteldialect,
    STATE(1969), 1,
      sym_asm,
  [24296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3028), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [24306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [24316] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3032), 1,
      anon_sym_alias,
    ACTIONS(3034), 1,
      anon_sym_ifunc,
    ACTIONS(3030), 2,
      anon_sym_global,
      anon_sym_constant,
  [24330] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3022), 1,
      anon_sym_uselistorder,
    ACTIONS(3036), 1,
      anon_sym_RBRACE,
    STATE(1230), 2,
      sym_use_list_order,
      aux_sym_function_body_repeat2,
  [24344] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    ACTIONS(2549), 1,
      sym_string,
    STATE(468), 1,
      sym_number,
  [24360] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    ACTIONS(3038), 1,
      anon_sym_RBRACE,
    STATE(1422), 1,
      sym_number,
  [24376] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3040), 1,
      anon_sym_RBRACE,
    ACTIONS(3042), 1,
      anon_sym_uselistorder,
    STATE(1230), 2,
      sym_use_list_order,
      aux_sym_function_body_repeat2,
  [24390] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3016), 4,
      anon_sym_global,
      anon_sym_constant,
      anon_sym_alias,
      anon_sym_ifunc,
  [24400] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3045), 1,
      anon_sym_COMMA,
    STATE(1232), 1,
      aux_sym_instruction_extractvalue_repeat1,
    ACTIONS(1838), 2,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
  [24414] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3048), 1,
      anon_sym_triple,
    ACTIONS(3050), 1,
      anon_sym_datalayout,
    STATE(1105), 2,
      sym_target_triple,
      sym_data_layout,
  [24428] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    ACTIONS(3052), 1,
      anon_sym_RBRACE,
    STATE(1267), 1,
      sym_number,
  [24444] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym_string,
    ACTIONS(3010), 1,
      anon_sym_unwind,
    ACTIONS(3012), 1,
      anon_sym_inteldialect,
    STATE(1897), 1,
      sym_asm,
  [24460] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 1,
      anon_sym_GT,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    STATE(1413), 1,
      aux_sym_instruction_callbr_repeat1,
  [24473] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_COMMA,
    ACTIONS(3060), 1,
      anon_sym_RPAREN,
    STATE(1232), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [24486] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1991), 1,
      sym_number,
  [24499] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1990), 1,
      sym_number,
  [24512] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1982), 1,
      sym_number,
  [24525] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1981), 1,
      sym_number,
  [24538] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1973), 1,
      sym_number,
  [24551] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1972), 1,
      sym_number,
  [24564] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1260), 1,
      sym_number,
  [24577] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_COMMA,
    ACTIONS(3062), 1,
      anon_sym_RBRACE,
    STATE(1232), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [24590] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3064), 1,
      anon_sym_COMMA,
    ACTIONS(3067), 1,
      anon_sym_RPAREN,
    STATE(1246), 1,
      aux_sym_attribute_repeat1,
  [24603] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3071), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [24616] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1899), 1,
      sym_number,
  [24629] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      aux_sym_number_token1,
    ACTIONS(1346), 1,
      aux_sym_number_token2,
    STATE(591), 1,
      sym_number,
  [24642] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym_string,
    ACTIONS(3073), 1,
      anon_sym_unwind,
    STATE(1883), 1,
      sym_asm,
  [24655] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1919), 1,
      sym_number,
  [24668] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1918), 1,
      sym_number,
  [24681] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1904), 1,
      sym_number,
  [24694] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1903), 1,
      sym_number,
  [24707] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1889), 1,
      sym_number,
  [24720] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1888), 1,
      sym_number,
  [24733] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3075), 1,
      anon_sym_RBRACK,
    STATE(1262), 1,
      aux_sym_instruction_callbr_repeat1,
  [24746] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3077), 1,
      anon_sym_RBRACK,
    STATE(1188), 1,
      aux_sym_instruction_callbr_repeat1,
  [24759] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      aux_sym_number_token1,
    ACTIONS(1346), 1,
      aux_sym_number_token2,
    STATE(681), 1,
      sym_number,
  [24772] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_COMMA,
    ACTIONS(3079), 1,
      anon_sym_RPAREN,
    STATE(1268), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [24785] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym_string,
    ACTIONS(3024), 1,
      anon_sym_unwind,
    STATE(1969), 1,
      sym_asm,
  [24798] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3081), 1,
      anon_sym_RBRACK,
    STATE(1188), 1,
      aux_sym_instruction_callbr_repeat1,
  [24811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3083), 1,
      anon_sym_COMMA,
    ACTIONS(3085), 1,
      anon_sym_RPAREN,
    STATE(1246), 1,
      aux_sym_attribute_repeat1,
  [24824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      aux_sym_number_token1,
    ACTIONS(1346), 1,
      aux_sym_number_token2,
    STATE(686), 1,
      sym_number,
  [24837] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3087), 1,
      anon_sym_GT,
    STATE(1373), 1,
      aux_sym_instruction_callbr_repeat1,
  [24850] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3089), 1,
      anon_sym_RBRACK,
    STATE(1372), 1,
      aux_sym_instruction_callbr_repeat1,
  [24863] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_COMMA,
    ACTIONS(3091), 1,
      anon_sym_RBRACE,
    STATE(1245), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [24876] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_COMMA,
    ACTIONS(3093), 1,
      anon_sym_RPAREN,
    STATE(1232), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [24889] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_COMMA,
    ACTIONS(3095), 1,
      anon_sym_RPAREN,
    STATE(1232), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [24902] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 1,
      anon_sym_LPAREN,
    ACTIONS(3099), 1,
      anon_sym_inbounds,
    ACTIONS(3101), 1,
      anon_sym_inrange,
  [24915] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3103), 1,
      anon_sym_LPAREN,
    ACTIONS(3105), 1,
      anon_sym_inbounds,
    ACTIONS(3107), 1,
      anon_sym_inrange,
  [24928] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3109), 1,
      anon_sym_RBRACK,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    STATE(1287), 1,
      aux_sym_operand_bundles_repeat1,
  [24941] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3113), 1,
      anon_sym_RBRACE_GT,
    ACTIONS(3115), 1,
      anon_sym_COMMA,
    STATE(1370), 1,
      aux_sym_instruction_callbr_repeat1,
  [24954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3117), 1,
      anon_sym_RBRACE,
    STATE(1367), 1,
      aux_sym_instruction_callbr_repeat1,
  [24967] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3119), 1,
      anon_sym_RPAREN,
    STATE(1289), 1,
      aux_sym_instruction_callbr_repeat1,
  [24980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3121), 1,
      anon_sym_LPAREN,
    ACTIONS(3123), 1,
      anon_sym_inbounds,
    ACTIONS(3125), 1,
      anon_sym_inrange,
  [24993] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_COMMA,
    ACTIONS(3127), 1,
      anon_sym_RPAREN,
    STATE(1269), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [25006] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1665), 1,
      sym_number,
  [25019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1663), 1,
      sym_number,
  [25032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1658), 1,
      sym_number,
  [25045] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1711), 1,
      sym_number,
  [25058] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1644), 1,
      sym_number,
  [25071] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3129), 1,
      anon_sym_RPAREN,
    STATE(1247), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      aux_sym_number_token1,
    ACTIONS(1346), 1,
      aux_sym_number_token2,
    STATE(675), 1,
      sym_number,
  [25097] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3131), 1,
      anon_sym_RPAREN,
    STATE(1292), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25110] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1352), 1,
      sym_number,
  [25123] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3133), 1,
      anon_sym_RBRACK,
    STATE(1294), 1,
      aux_sym_operand_bundles_repeat1,
  [25136] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3133), 1,
      anon_sym_RBRACK,
    STATE(1295), 1,
      aux_sym_operand_bundles_repeat1,
  [25149] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3135), 1,
      anon_sym_RPAREN,
    STATE(1188), 1,
      aux_sym_instruction_callbr_repeat1,
  [25162] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1356), 1,
      sym_number,
  [25175] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3137), 1,
      anon_sym_RPAREN,
    STATE(1301), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25188] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3137), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25201] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1642), 1,
      sym_number,
  [25214] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3139), 1,
      anon_sym_RBRACK,
    ACTIONS(3141), 1,
      anon_sym_COMMA,
    STATE(1294), 1,
      aux_sym_operand_bundles_repeat1,
  [25227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3144), 1,
      anon_sym_RBRACK,
    STATE(1294), 1,
      aux_sym_operand_bundles_repeat1,
  [25240] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3144), 1,
      anon_sym_RBRACK,
    STATE(1303), 1,
      aux_sym_operand_bundles_repeat1,
  [25253] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3129), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 3,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
  [25275] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1405), 1,
      sym_number,
  [25288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3146), 1,
      anon_sym_RPAREN,
    STATE(1307), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25301] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3146), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25314] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3148), 1,
      anon_sym_RBRACE,
    ACTIONS(3150), 1,
      anon_sym_COMMA,
    STATE(1302), 1,
      aux_sym_struct_body_repeat1,
  [25327] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3153), 1,
      anon_sym_RBRACK,
    STATE(1294), 1,
      aux_sym_operand_bundles_repeat1,
  [25340] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1408), 1,
      sym_number,
  [25353] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3155), 1,
      anon_sym_COMMA,
    ACTIONS(3157), 1,
      anon_sym_RPAREN,
    STATE(1468), 1,
      aux_sym_memory_attribute_repeat1,
  [25366] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3159), 1,
      anon_sym_RBRACE,
    ACTIONS(3161), 1,
      anon_sym_COMMA,
    STATE(1355), 1,
      aux_sym_metadata_tuple_repeat1,
  [25379] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3163), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25392] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3165), 1,
      anon_sym_RPAREN,
    STATE(1311), 1,
      aux_sym_instruction_callbr_repeat1,
  [25405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3167), 1,
      anon_sym_LPAREN2,
    ACTIONS(573), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [25416] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1781), 1,
      sym_number,
  [25429] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3169), 1,
      anon_sym_RPAREN,
    STATE(1188), 1,
      aux_sym_instruction_callbr_repeat1,
  [25442] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3171), 1,
      anon_sym_RPAREN,
    STATE(1188), 1,
      aux_sym_instruction_callbr_repeat1,
  [25455] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      aux_sym_number_token1,
    ACTIONS(1346), 1,
      aux_sym_number_token2,
    STATE(217), 1,
      sym_number,
  [25468] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3173), 1,
      anon_sym_RPAREN,
    STATE(1312), 1,
      aux_sym_instruction_callbr_repeat1,
  [25481] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3175), 1,
      anon_sym_RBRACK,
    STATE(1258), 1,
      aux_sym_instruction_callbr_repeat1,
  [25494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1469), 1,
      sym_number,
  [25507] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym_string,
    ACTIONS(3010), 1,
      anon_sym_unwind,
    STATE(1897), 1,
      sym_asm,
  [25520] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(713), 3,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
      anon_sym_x,
  [25529] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3177), 1,
      anon_sym_RBRACE_GT,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    STATE(1324), 1,
      aux_sym_struct_body_repeat1,
  [25542] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1447), 1,
      sym_number,
  [25555] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3181), 1,
      anon_sym_RBRACE,
    ACTIONS(3183), 1,
      anon_sym_COMMA,
    STATE(1321), 1,
      aux_sym_metadata_tuple_repeat1,
  [25568] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3155), 1,
      anon_sym_COMMA,
    ACTIONS(3186), 1,
      anon_sym_RPAREN,
    STATE(1468), 1,
      aux_sym_memory_attribute_repeat1,
  [25581] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1713), 1,
      sym_number,
  [25594] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3188), 1,
      anon_sym_RBRACE_GT,
    STATE(1364), 1,
      aux_sym_struct_body_repeat1,
  [25607] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3083), 1,
      anon_sym_COMMA,
    ACTIONS(3190), 1,
      anon_sym_RPAREN,
    STATE(1263), 1,
      aux_sym_attribute_repeat1,
  [25620] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 1,
      anon_sym_COMMA,
    ACTIONS(3194), 1,
      anon_sym_RPAREN,
    STATE(1435), 1,
      aux_sym_argument_list_repeat1,
  [25633] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 1,
      anon_sym_COMMA,
    ACTIONS(3196), 1,
      anon_sym_RPAREN,
    STATE(1326), 1,
      aux_sym_argument_list_repeat1,
  [25646] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_COMMA,
    ACTIONS(3198), 1,
      anon_sym_RBRACE,
    STATE(1232), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [25659] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(579), 1,
      sym_number,
  [25672] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 1,
      anon_sym_COMMA,
    ACTIONS(3200), 1,
      anon_sym_RPAREN,
    STATE(1435), 1,
      aux_sym_argument_list_repeat1,
  [25685] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 1,
      anon_sym_COMMA,
    ACTIONS(3202), 1,
      anon_sym_RPAREN,
    STATE(1330), 1,
      aux_sym_argument_list_repeat1,
  [25698] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(479), 1,
      sym_number,
  [25711] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3161), 1,
      anon_sym_COMMA,
    ACTIONS(3204), 1,
      anon_sym_RBRACE,
    STATE(1321), 1,
      aux_sym_metadata_tuple_repeat1,
  [25724] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1277), 1,
      sym_number,
  [25737] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3161), 1,
      anon_sym_COMMA,
    ACTIONS(3206), 1,
      anon_sym_RBRACE,
    STATE(1333), 1,
      aux_sym_metadata_tuple_repeat1,
  [25750] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 1,
      anon_sym_COMMA,
    ACTIONS(3208), 1,
      anon_sym_RPAREN,
    STATE(1435), 1,
      aux_sym_argument_list_repeat1,
  [25763] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1771), 1,
      sym_number,
  [25776] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3210), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25789] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 1,
      anon_sym_COMMA,
    ACTIONS(3212), 1,
      anon_sym_RPAREN,
    STATE(1336), 1,
      aux_sym_argument_list_repeat1,
  [25802] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3155), 1,
      anon_sym_COMMA,
    ACTIONS(3214), 1,
      anon_sym_RPAREN,
    STATE(1305), 1,
      aux_sym_memory_attribute_repeat1,
  [25815] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3210), 1,
      anon_sym_RPAREN,
    STATE(1297), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25828] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3216), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25841] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3218), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25854] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3218), 1,
      anon_sym_RPAREN,
    STATE(1342), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25867] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 1,
      aux_sym_number_token1,
    ACTIONS(1306), 1,
      aux_sym_number_token2,
    STATE(1726), 1,
      sym_number,
  [25880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3188), 1,
      anon_sym_RBRACE,
    ACTIONS(3220), 1,
      anon_sym_COMMA,
    STATE(1302), 1,
      aux_sym_struct_body_repeat1,
  [25893] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3222), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25906] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3222), 1,
      anon_sym_RPAREN,
    STATE(1343), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 1,
      anon_sym_COMMA,
    ACTIONS(3224), 1,
      anon_sym_RPAREN,
    STATE(1351), 1,
      aux_sym_argument_list_repeat1,
  [25932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3226), 1,
      anon_sym_RPAREN,
    STATE(1347), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 1,
      anon_sym_COMMA,
    ACTIONS(3228), 1,
      anon_sym_RPAREN,
    STATE(1435), 1,
      aux_sym_argument_list_repeat1,
  [25958] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_COMMA,
    ACTIONS(3230), 1,
      anon_sym_RPAREN,
    STATE(1237), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [25971] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_COMMA,
    ACTIONS(3232), 1,
      anon_sym_RPAREN,
    STATE(1232), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [25984] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3234), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [25997] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3161), 1,
      anon_sym_COMMA,
    ACTIONS(3236), 1,
      anon_sym_RBRACE,
    STATE(1321), 1,
      aux_sym_metadata_tuple_repeat1,
  [26010] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_COMMA,
    ACTIONS(3238), 1,
      anon_sym_RPAREN,
    STATE(1353), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [26023] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3240), 1,
      anon_sym_RPAREN,
    STATE(1354), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [26036] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3240), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [26049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3242), 3,
      anon_sym_localdynamic,
      anon_sym_initialexec,
      anon_sym_localexec,
  [26058] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(2002), 1,
      sym_number,
  [26071] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3155), 1,
      anon_sym_COMMA,
    ACTIONS(3244), 1,
      anon_sym_RPAREN,
    STATE(1468), 1,
      aux_sym_memory_attribute_repeat1,
  [26084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3246), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [26097] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3246), 1,
      anon_sym_RPAREN,
    STATE(1358), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [26110] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3148), 1,
      anon_sym_RBRACE_GT,
    ACTIONS(3248), 1,
      anon_sym_COMMA,
    STATE(1364), 1,
      aux_sym_struct_body_repeat1,
  [26123] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3161), 1,
      anon_sym_COMMA,
    ACTIONS(3251), 1,
      anon_sym_RBRACE,
    STATE(1321), 1,
      aux_sym_metadata_tuple_repeat1,
  [26136] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3155), 1,
      anon_sym_COMMA,
    ACTIONS(3253), 1,
      anon_sym_RPAREN,
    STATE(1361), 1,
      aux_sym_memory_attribute_repeat1,
  [26149] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3255), 1,
      anon_sym_RBRACE,
    STATE(1188), 1,
      aux_sym_instruction_callbr_repeat1,
  [26162] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3257), 1,
      anon_sym_RPAREN,
    STATE(1362), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [26175] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3259), 1,
      anon_sym_GT,
    STATE(1188), 1,
      aux_sym_instruction_callbr_repeat1,
  [26188] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3115), 1,
      anon_sym_COMMA,
    ACTIONS(3261), 1,
      anon_sym_RBRACE_GT,
    STATE(1388), 1,
      aux_sym_instruction_callbr_repeat1,
  [26201] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3263), 1,
      anon_sym_RBRACK,
    STATE(1188), 1,
      aux_sym_instruction_callbr_repeat1,
  [26214] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3265), 1,
      anon_sym_RBRACK,
    STATE(1188), 1,
      aux_sym_instruction_callbr_repeat1,
  [26227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3267), 1,
      anon_sym_GT,
    STATE(1188), 1,
      aux_sym_instruction_callbr_repeat1,
  [26240] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3115), 1,
      anon_sym_COMMA,
    ACTIONS(3269), 1,
      anon_sym_RBRACE_GT,
    STATE(1388), 1,
      aux_sym_instruction_callbr_repeat1,
  [26253] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3271), 1,
      anon_sym_RBRACE,
    STATE(1188), 1,
      aux_sym_instruction_callbr_repeat1,
  [26266] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3161), 1,
      anon_sym_COMMA,
    ACTIONS(3273), 1,
      anon_sym_RBRACE,
    STATE(1365), 1,
      aux_sym_metadata_tuple_repeat1,
  [26279] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3155), 1,
      anon_sym_COMMA,
    ACTIONS(3275), 1,
      anon_sym_RPAREN,
    STATE(1468), 1,
      aux_sym_memory_attribute_repeat1,
  [26292] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 1,
      anon_sym_COMMA,
    ACTIONS(3277), 1,
      anon_sym_RPAREN,
    STATE(1435), 1,
      aux_sym_argument_list_repeat1,
  [26305] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3279), 1,
      anon_sym_GT,
    STATE(1369), 1,
      aux_sym_instruction_callbr_repeat1,
  [26318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3281), 1,
      anon_sym_RBRACK,
    STATE(1371), 1,
      aux_sym_instruction_callbr_repeat1,
  [26331] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3115), 1,
      anon_sym_COMMA,
    ACTIONS(3283), 1,
      anon_sym_RBRACE_GT,
    STATE(1374), 1,
      aux_sym_instruction_callbr_repeat1,
  [26344] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3285), 1,
      anon_sym_RBRACE,
    STATE(1375), 1,
      aux_sym_instruction_callbr_repeat1,
  [26357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3155), 1,
      anon_sym_COMMA,
    ACTIONS(3287), 1,
      anon_sym_RPAREN,
    STATE(1377), 1,
      aux_sym_memory_attribute_repeat1,
  [26370] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 1,
      anon_sym_COMMA,
    ACTIONS(3289), 1,
      anon_sym_RPAREN,
    STATE(1378), 1,
      aux_sym_argument_list_repeat1,
  [26383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      aux_sym_number_token1,
    ACTIONS(1346), 1,
      aux_sym_number_token2,
    STATE(592), 1,
      sym_number,
  [26396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3291), 1,
      anon_sym_RPAREN,
    STATE(1338), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [26409] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 1,
      anon_sym_COMMA,
    ACTIONS(3293), 1,
      anon_sym_RPAREN,
    STATE(1400), 1,
      aux_sym_argument_list_repeat1,
  [26422] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2995), 1,
      anon_sym_RBRACE_GT,
    ACTIONS(3295), 1,
      anon_sym_COMMA,
    STATE(1388), 1,
      aux_sym_instruction_callbr_repeat1,
  [26435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3155), 1,
      anon_sym_COMMA,
    ACTIONS(3298), 1,
      anon_sym_RPAREN,
    STATE(1402), 1,
      aux_sym_memory_attribute_repeat1,
  [26448] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3300), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [26461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3302), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [26474] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3302), 1,
      anon_sym_RPAREN,
    STATE(1390), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [26487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3304), 1,
      anon_sym_RBRACE,
    STATE(1410), 1,
      aux_sym_instruction_callbr_repeat1,
  [26500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3115), 1,
      anon_sym_COMMA,
    ACTIONS(3306), 1,
      anon_sym_RBRACE_GT,
    STATE(1411), 1,
      aux_sym_instruction_callbr_repeat1,
  [26513] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3308), 1,
      anon_sym_RBRACK,
    STATE(1412), 1,
      aux_sym_instruction_callbr_repeat1,
  [26526] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3310), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [26539] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3310), 1,
      anon_sym_RPAREN,
    STATE(1391), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [26552] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      aux_sym_number_token1,
    ACTIONS(313), 1,
      aux_sym_number_token2,
    STATE(1646), 1,
      sym_number,
  [26565] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3312), 1,
      anon_sym_RPAREN,
    STATE(1396), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [26578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 1,
      anon_sym_COMMA,
    ACTIONS(3314), 1,
      anon_sym_RPAREN,
    STATE(1435), 1,
      aux_sym_argument_list_repeat1,
  [26591] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_COMMA,
    ACTIONS(3316), 1,
      anon_sym_RPAREN,
    STATE(1232), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [26604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3155), 1,
      anon_sym_COMMA,
    ACTIONS(3318), 1,
      anon_sym_RPAREN,
    STATE(1468), 1,
      aux_sym_memory_attribute_repeat1,
  [26617] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3161), 1,
      anon_sym_COMMA,
    ACTIONS(3320), 1,
      anon_sym_RBRACE,
    STATE(1418), 1,
      aux_sym_metadata_tuple_repeat1,
  [26630] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3324), 1,
      anon_sym_inbounds,
    ACTIONS(3326), 1,
      anon_sym_inrange,
  [26643] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_COMMA,
    ACTIONS(3328), 1,
      anon_sym_RPAREN,
    STATE(1401), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [26656] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_COMMA,
    ACTIONS(3330), 1,
      anon_sym_RPAREN,
    STATE(1232), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [26669] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3332), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [26682] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_COMMA,
    ACTIONS(3334), 1,
      anon_sym_RPAREN,
    STATE(1406), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [26695] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3336), 1,
      anon_sym_RPAREN,
    STATE(1407), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [26708] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3338), 1,
      anon_sym_RBRACE,
    STATE(1188), 1,
      aux_sym_instruction_callbr_repeat1,
  [26721] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3115), 1,
      anon_sym_COMMA,
    ACTIONS(3340), 1,
      anon_sym_RBRACE_GT,
    STATE(1388), 1,
      aux_sym_instruction_callbr_repeat1,
  [26734] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3342), 1,
      anon_sym_RBRACK,
    STATE(1188), 1,
      aux_sym_instruction_callbr_repeat1,
  [26747] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3344), 1,
      anon_sym_GT,
    STATE(1188), 1,
      aux_sym_instruction_callbr_repeat1,
  [26760] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3336), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [26773] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3346), 1,
      anon_sym_RPAREN,
    STATE(1430), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [26786] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3155), 1,
      anon_sym_COMMA,
    ACTIONS(3348), 1,
      anon_sym_RPAREN,
    STATE(1468), 1,
      aux_sym_memory_attribute_repeat1,
  [26799] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3155), 1,
      anon_sym_COMMA,
    ACTIONS(3350), 1,
      anon_sym_RPAREN,
    STATE(1433), 1,
      aux_sym_memory_attribute_repeat1,
  [26812] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3161), 1,
      anon_sym_COMMA,
    ACTIONS(3352), 1,
      anon_sym_RBRACE,
    STATE(1321), 1,
      aux_sym_metadata_tuple_repeat1,
  [26825] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3354), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [26838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3354), 1,
      anon_sym_RPAREN,
    STATE(1414), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [26851] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3161), 1,
      anon_sym_COMMA,
    ACTIONS(3356), 1,
      anon_sym_RBRACE,
    STATE(1321), 1,
      aux_sym_metadata_tuple_repeat1,
  [26864] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_COMMA,
    ACTIONS(3358), 1,
      anon_sym_RBRACE,
    STATE(1328), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [26877] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3155), 1,
      anon_sym_COMMA,
    ACTIONS(3360), 1,
      anon_sym_RPAREN,
    STATE(1416), 1,
      aux_sym_memory_attribute_repeat1,
  [26890] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3362), 1,
      anon_sym_RPAREN,
    STATE(1419), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [26903] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3364), 1,
      anon_sym_GT,
    STATE(1188), 1,
      aux_sym_instruction_callbr_repeat1,
  [26916] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3366), 1,
      anon_sym_RBRACK,
    STATE(1188), 1,
      aux_sym_instruction_callbr_repeat1,
  [26929] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3115), 1,
      anon_sym_COMMA,
    ACTIONS(3368), 1,
      anon_sym_RBRACE_GT,
    STATE(1388), 1,
      aux_sym_instruction_callbr_repeat1,
  [26942] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3370), 1,
      anon_sym_RBRACE,
    STATE(1188), 1,
      aux_sym_instruction_callbr_repeat1,
  [26955] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3372), 1,
      anon_sym_RPAREN,
    STATE(1445), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [26968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3372), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [26981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3083), 1,
      anon_sym_COMMA,
    ACTIONS(3374), 1,
      anon_sym_RPAREN,
    STATE(1451), 1,
      aux_sym_attribute_repeat1,
  [26994] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3161), 1,
      anon_sym_COMMA,
    ACTIONS(3376), 1,
      anon_sym_RBRACE,
    STATE(1421), 1,
      aux_sym_metadata_tuple_repeat1,
  [27007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3155), 1,
      anon_sym_COMMA,
    ACTIONS(3378), 1,
      anon_sym_RPAREN,
    STATE(1468), 1,
      aux_sym_memory_attribute_repeat1,
  [27020] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3155), 1,
      anon_sym_COMMA,
    ACTIONS(3380), 1,
      anon_sym_RPAREN,
    STATE(1468), 1,
      aux_sym_memory_attribute_repeat1,
  [27033] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3382), 1,
      anon_sym_COMMA,
    ACTIONS(3385), 1,
      anon_sym_RPAREN,
    STATE(1435), 1,
      aux_sym_argument_list_repeat1,
  [27046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      aux_sym_number_token1,
    ACTIONS(1346), 1,
      aux_sym_number_token2,
    STATE(579), 1,
      sym_number,
  [27059] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 1,
      anon_sym_COMMA,
    ACTIONS(3387), 1,
      anon_sym_RPAREN,
    STATE(1435), 1,
      aux_sym_argument_list_repeat1,
  [27072] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3389), 1,
      anon_sym_GT,
    STATE(1425), 1,
      aux_sym_instruction_callbr_repeat1,
  [27085] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3391), 1,
      anon_sym_RBRACK,
    STATE(1426), 1,
      aux_sym_instruction_callbr_repeat1,
  [27098] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3115), 1,
      anon_sym_COMMA,
    ACTIONS(3393), 1,
      anon_sym_RBRACE_GT,
    STATE(1427), 1,
      aux_sym_instruction_callbr_repeat1,
  [27111] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3395), 1,
      anon_sym_RBRACE,
    STATE(1428), 1,
      aux_sym_instruction_callbr_repeat1,
  [27124] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3397), 1,
      anon_sym_RBRACK,
    STATE(1460), 1,
      aux_sym_instruction_callbr_repeat1,
  [27137] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3155), 1,
      anon_sym_COMMA,
    ACTIONS(3399), 1,
      anon_sym_RPAREN,
    STATE(1322), 1,
      aux_sym_memory_attribute_repeat1,
  [27150] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1919), 1,
      anon_sym_RPAREN,
    ACTIONS(3401), 1,
      anon_sym_COMMA,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [27163] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3404), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [27176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3404), 1,
      anon_sym_RPAREN,
    STATE(1463), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [27189] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_COMMA,
    ACTIONS(3406), 1,
      anon_sym_RPAREN,
    STATE(1464), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [27202] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3155), 1,
      anon_sym_COMMA,
    ACTIONS(3408), 1,
      anon_sym_RPAREN,
    STATE(1434), 1,
      aux_sym_memory_attribute_repeat1,
  [27215] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 1,
      anon_sym_COMMA,
    ACTIONS(3410), 1,
      anon_sym_RPAREN,
    STATE(1437), 1,
      aux_sym_argument_list_repeat1,
  [27228] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3412), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [27241] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3083), 1,
      anon_sym_COMMA,
    ACTIONS(3414), 1,
      anon_sym_RPAREN,
    STATE(1246), 1,
      aux_sym_attribute_repeat1,
  [27254] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3416), 1,
      anon_sym_RBRACK,
    STATE(1294), 1,
      aux_sym_operand_bundles_repeat1,
  [27267] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3418), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [27280] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3418), 1,
      anon_sym_RPAREN,
    STATE(1450), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [27293] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3420), 1,
      anon_sym_RBRACK,
    STATE(1452), 1,
      aux_sym_operand_bundles_repeat1,
  [27306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3420), 1,
      anon_sym_RBRACK,
    STATE(1294), 1,
      aux_sym_operand_bundles_repeat1,
  [27319] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3422), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [27332] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3422), 1,
      anon_sym_RPAREN,
    STATE(1453), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [27345] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3424), 1,
      anon_sym_RBRACK,
    STATE(1456), 1,
      aux_sym_operand_bundles_repeat1,
  [27358] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3426), 1,
      anon_sym_RBRACK,
    STATE(1188), 1,
      aux_sym_instruction_callbr_repeat1,
  [27371] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3424), 1,
      anon_sym_RBRACK,
    STATE(1294), 1,
      aux_sym_operand_bundles_repeat1,
  [27384] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3428), 1,
      anon_sym_RPAREN,
    STATE(1457), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [27397] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3430), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_instruction_getelementptr_repeat1,
  [27410] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_COMMA,
    ACTIONS(3432), 1,
      anon_sym_RPAREN,
    STATE(1232), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [27423] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3434), 1,
      anon_sym_RBRACK,
    STATE(1461), 1,
      aux_sym_operand_bundles_repeat1,
  [27436] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3177), 1,
      anon_sym_RBRACE,
    ACTIONS(3220), 1,
      anon_sym_COMMA,
    STATE(1346), 1,
      aux_sym_struct_body_repeat1,
  [27449] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_COMMA,
    ACTIONS(3436), 1,
      anon_sym_RPAREN,
    STATE(1232), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [27462] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3438), 1,
      anon_sym_COMMA,
    ACTIONS(3441), 1,
      anon_sym_RPAREN,
    STATE(1468), 1,
      aux_sym_memory_attribute_repeat1,
  [27475] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_COMMA,
    ACTIONS(3443), 1,
      anon_sym_RPAREN,
    STATE(1467), 1,
      aux_sym_instruction_extractvalue_repeat1,
  [27488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(719), 1,
      aux_sym_metadata_ref_token1,
    STATE(749), 1,
      sym_metadata_name,
  [27506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3445), 1,
      anon_sym_LPAREN,
    STATE(195), 1,
      sym_argument_list,
  [27516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [27524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [27532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(705), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(679), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3067), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [27556] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(541), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    STATE(413), 1,
      sym_argument_list,
  [27574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(679), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3441), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [27590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3447), 1,
      anon_sym_LBRACK,
    STATE(615), 1,
      sym__value_array,
  [27600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym_string,
    STATE(1969), 1,
      sym_asm,
  [27618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3449), 1,
      anon_sym_LPAREN,
    ACTIONS(3451), 1,
      anon_sym_inrange,
  [27628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3445), 1,
      anon_sym_LPAREN,
    STATE(191), 1,
      sym_argument_list,
  [27638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    STATE(509), 1,
      sym_argument_list,
  [27648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym_string,
    STATE(1883), 1,
      sym_asm,
  [27658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(697), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(635), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(603), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3453), 2,
      anon_sym_sync,
      anon_sym_async,
  [27698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(537), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(595), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    STATE(506), 1,
      sym_argument_list,
  [27732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    STATE(508), 1,
      sym_argument_list,
  [27742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3455), 1,
      anon_sym_unwind,
    STATE(633), 1,
      sym__unwind_label,
  [27752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3457), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [27760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym_string,
    STATE(1800), 1,
      sym_asm,
  [27770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(545), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(517), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(565), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_align,
    STATE(682), 1,
      sym_alignment,
  [27804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(599), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3459), 1,
      sym_string,
    ACTIONS(3461), 1,
      anon_sym_LBRACE2,
  [27822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3455), 1,
      anon_sym_unwind,
    STATE(637), 1,
      sym__unwind_label,
  [27832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(607), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3463), 1,
      anon_sym_LPAREN,
    ACTIONS(3465), 1,
      anon_sym_inrange,
  [27850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(615), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3467), 1,
      anon_sym_LPAREN,
    ACTIONS(3469), 1,
      anon_sym_inrange,
  [27868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(513), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(651), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3471), 1,
      anon_sym_LPAREN,
    ACTIONS(3473), 1,
      anon_sym_inrange,
  [27894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3445), 1,
      anon_sym_LPAREN,
    STATE(189), 1,
      sym_argument_list,
  [27912] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(591), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3475), 1,
      sym_string,
    ACTIONS(3477), 1,
      anon_sym_LBRACE2,
  [27930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(667), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    STATE(481), 1,
      sym_argument_list,
  [27948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(631), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    STATE(411), 1,
      sym_argument_list,
  [27974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [27982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(619), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(623), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [27998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(525), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3479), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [28014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3445), 1,
      anon_sym_LPAREN,
    STATE(194), 1,
      sym_argument_list,
  [28024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3479), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [28032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(663), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_align,
    STATE(668), 1,
      sym_alignment,
  [28058] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(655), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(647), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(643), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(627), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_align,
    STATE(663), 1,
      sym_alignment,
  [28116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_align,
    STATE(662), 1,
      sym_alignment,
  [28126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(719), 1,
      aux_sym_metadata_ref_token1,
    STATE(750), 1,
      sym_metadata_name,
  [28136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(569), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3481), 2,
      anon_sym_sync,
      anon_sym_async,
  [28160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(561), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28184] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(549), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_align,
    STATE(658), 1,
      sym_alignment,
  [28210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3148), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [28218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3483), 2,
      anon_sym_RBRACK,
      anon_sym_GT,
  [28226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_align,
    STATE(654), 1,
      sym_alignment,
  [28236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3485), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [28244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(639), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_align,
    STATE(643), 1,
      sym_alignment,
  [28262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 2,
      anon_sym_sync,
      anon_sym_async,
  [28270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [28278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    STATE(410), 1,
      sym_argument_list,
  [28288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [28296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_within,
    STATE(1591), 1,
      sym__within,
  [28306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_within,
    STATE(1587), 1,
      sym__within,
  [28316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym_string,
    STATE(1130), 1,
      sym_asm,
  [28326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      anon_sym_within,
    STATE(1586), 1,
      sym__within,
  [28336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2983), 1,
      sym_string,
    STATE(1897), 1,
      sym_asm,
  [28346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    STATE(510), 1,
      sym_argument_list,
  [28356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    STATE(482), 1,
      sym_argument_list,
  [28366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    STATE(486), 1,
      sym_argument_list,
  [28376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    STATE(403), 1,
      sym_argument_list,
  [28386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    STATE(488), 1,
      sym_argument_list,
  [28396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3181), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [28404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3495), 1,
      sym_string,
    ACTIONS(3497), 1,
      anon_sym_LBRACE2,
  [28414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2995), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28422] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 2,
      anon_sym_RBRACK,
      anon_sym_GT,
  [28430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    STATE(484), 1,
      sym_argument_list,
  [28440] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3501), 2,
      anon_sym_sync,
      anon_sym_async,
  [28448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(701), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(689), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(709), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 2,
      sym_local_var,
      anon_sym_none,
  [28496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3505), 1,
      sym_string,
    ACTIONS(3507), 1,
      anon_sym_LBRACE2,
  [28506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3509), 1,
      anon_sym_LBRACK,
    STATE(1508), 1,
      sym__value_array,
  [28516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3447), 1,
      anon_sym_LBRACK,
    STATE(644), 1,
      sym__value_array,
  [28526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    STATE(408), 1,
      sym_argument_list,
  [28536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3511), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [28544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3148), 2,
      anon_sym_RBRACE_GT,
      anon_sym_COMMA,
  [28552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3447), 1,
      anon_sym_LBRACK,
    STATE(641), 1,
      sym__value_array,
  [28562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(452), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [28570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3513), 1,
      anon_sym_LPAREN,
  [28577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 1,
      anon_sym_COMMA,
  [28584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 1,
      anon_sym_COMMA,
  [28591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3519), 1,
      anon_sym_COMMA,
  [28598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3521), 1,
      anon_sym_LPAREN,
  [28605] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_LBRACE,
  [28612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3525), 1,
      anon_sym_RPAREN,
  [28619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      sym_local_var,
  [28626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3529), 1,
      anon_sym_to,
  [28633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3531), 1,
      anon_sym_LBRACE,
  [28640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3533), 1,
      anon_sym_LPAREN,
  [28647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3535), 1,
      anon_sym_RPAREN,
  [28654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 1,
      anon_sym_COMMA,
  [28661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3539), 1,
      anon_sym_COMMA,
  [28668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LPAREN,
  [28675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3543), 1,
      anon_sym_RPAREN,
  [28682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3545), 1,
      anon_sym_COMMA,
  [28689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_COMMA,
  [28696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3549), 1,
      anon_sym_LPAREN,
  [28703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_RPAREN,
  [28710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3553), 1,
      anon_sym_RPAREN,
  [28717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3555), 1,
      anon_sym_RPAREN,
  [28724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3557), 1,
      anon_sym_RPAREN,
  [28731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3559), 1,
      anon_sym_RPAREN,
  [28738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(503), 1,
      anon_sym_STAR,
  [28745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3561), 1,
      anon_sym_COMMA,
  [28752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3563), 1,
      anon_sym_RPAREN,
  [28759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3565), 1,
      anon_sym_RPAREN,
  [28766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3567), 1,
      anon_sym_RPAREN,
  [28773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3569), 1,
      anon_sym_RPAREN,
  [28780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3571), 1,
      anon_sym_RPAREN,
  [28787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 1,
      anon_sym_COMMA,
  [28794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_COMMA,
  [28801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3577), 1,
      anon_sym_LPAREN,
  [28808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_COMMA,
  [28815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 1,
      anon_sym_to,
  [28822] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3583), 1,
      anon_sym_RBRACE,
  [28829] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 1,
      anon_sym_RPAREN,
  [28836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_COLON,
  [28843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3589), 1,
      anon_sym_comdat,
  [28850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3591), 1,
      anon_sym_COMMA,
  [28857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3593), 1,
      anon_sym_RPAREN,
  [28864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3595), 1,
      anon_sym_RBRACE_GT,
  [28871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3597), 1,
      anon_sym_RBRACE,
  [28878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3599), 1,
      anon_sym_RBRACE_GT,
  [28885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3601), 1,
      anon_sym_RBRACK,
  [28892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3603), 1,
      anon_sym_GT,
  [28899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3605), 1,
      sym_global_var,
  [28906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_STAR,
  [28913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3607), 1,
      anon_sym_RPAREN,
  [28920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3609), 1,
      anon_sym_to,
  [28927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3611), 1,
      anon_sym_RPAREN,
  [28934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3613), 1,
      anon_sym_RPAREN,
  [28941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_COMMA,
  [28948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3617), 1,
      anon_sym_EQ,
  [28955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_RBRACK,
  [28962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3621), 1,
      anon_sym_GT,
  [28969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3623), 1,
      sym_local_var,
  [28976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3625), 1,
      anon_sym_COMMA,
  [28983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3627), 1,
      sym_local_var,
  [28990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3629), 1,
      anon_sym_RBRACE,
  [28997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3631), 1,
      anon_sym_RBRACE_GT,
  [29004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3633), 1,
      anon_sym_RBRACK,
  [29011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3635), 1,
      anon_sym_GT,
  [29018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3637), 1,
      anon_sym_COMMA,
  [29025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3639), 1,
      anon_sym_RPAREN,
  [29032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3641), 1,
      sym_global_var,
  [29039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3643), 1,
      anon_sym_COMMA,
  [29046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3645), 1,
      sym_local_var,
  [29053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3647), 1,
      anon_sym_to,
  [29060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3649), 1,
      anon_sym_RPAREN,
  [29067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3651), 1,
      anon_sym_COMMA,
  [29074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      anon_sym_RPAREN,
  [29081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3655), 1,
      anon_sym_RPAREN,
  [29088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3657), 1,
      anon_sym_COMMA,
  [29095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3659), 1,
      anon_sym_RPAREN,
  [29102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3190), 1,
      anon_sym_RPAREN,
  [29109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3661), 1,
      sym_string,
  [29116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1066), 1,
      anon_sym_STAR,
  [29123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym_LPAREN,
  [29130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3665), 1,
      sym_string,
  [29137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3667), 1,
      anon_sym_COMMA,
  [29144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3669), 1,
      anon_sym_COMMA,
  [29151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3671), 1,
      anon_sym_COMMA,
  [29158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3673), 1,
      anon_sym_GT,
  [29165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3675), 1,
      anon_sym_EQ,
  [29172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3677), 1,
      anon_sym_RBRACK,
  [29179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3679), 1,
      anon_sym_COMMA,
  [29186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3681), 1,
      anon_sym_COMMA,
  [29193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3683), 1,
      sym_comdat_ref,
  [29200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3685), 1,
      anon_sym_RBRACE_GT,
  [29207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3687), 1,
      anon_sym_EQ,
  [29214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3689), 1,
      sym_string,
  [29221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_COMMA,
  [29228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3693), 1,
      anon_sym_COMMA,
  [29235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3695), 1,
      anon_sym_COMMA,
  [29242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3697), 1,
      sym_local_var,
  [29249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3699), 1,
      anon_sym_LBRACK,
  [29256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3701), 1,
      anon_sym_COMMA,
  [29263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3703), 1,
      anon_sym_RBRACE,
  [29270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3705), 1,
      aux_sym_specialized_md_value_token1,
  [29277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3707), 1,
      anon_sym_COMMA,
  [29284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3709), 1,
      anon_sym_from,
  [29291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3711), 1,
      anon_sym_COMMA,
  [29298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3713), 1,
      anon_sym_type,
  [29305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3715), 1,
      anon_sym_from,
  [29312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3717), 1,
      anon_sym_COMMA,
  [29319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_unwind,
  [29326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2112), 1,
      anon_sym_unwind,
  [29333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3721), 1,
      anon_sym_RPAREN,
  [29340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3723), 1,
      anon_sym_COMMA,
  [29347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3725), 1,
      anon_sym_COMMA,
  [29354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3727), 1,
      anon_sym_LPAREN,
  [29361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3729), 1,
      anon_sym_LPAREN,
  [29368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3731), 1,
      anon_sym_COMMA,
  [29375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3733), 1,
      sym_global_var,
  [29382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3735), 1,
      anon_sym_COMMA,
  [29389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3737), 1,
      anon_sym_RPAREN,
  [29396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3739), 1,
      anon_sym_RPAREN,
  [29403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3741), 1,
      sym_string,
  [29410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3743), 1,
      anon_sym_RPAREN,
  [29417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3745), 1,
      anon_sym_COMMA,
  [29424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3747), 1,
      anon_sym_COMMA,
  [29431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3749), 1,
      anon_sym_RBRACK,
  [29438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_to,
  [29445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3751), 1,
      anon_sym_LBRACE2,
  [29452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3753), 1,
      anon_sym_COMMA,
  [29459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3755), 1,
      anon_sym_call,
  [29466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3757), 1,
      anon_sym_COMMA,
  [29473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3759), 1,
      anon_sym_RPAREN,
  [29480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3761), 1,
      anon_sym_RPAREN,
  [29487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 1,
      sym_local_var,
  [29494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3765), 1,
      sym_local_var,
  [29501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3767), 1,
      anon_sym_x,
  [29508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2235), 1,
      anon_sym_to,
  [29515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3769), 1,
      anon_sym_RPAREN,
  [29522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3771), 1,
      anon_sym_COMMA,
  [29529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 1,
      anon_sym_STAR,
  [29536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3773), 1,
      anon_sym_COMMA,
  [29543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3775), 1,
      anon_sym_RPAREN,
  [29550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_RPAREN,
  [29557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3779), 1,
      anon_sym_LBRACK,
  [29564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3781), 1,
      anon_sym_RPAREN,
  [29571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3783), 1,
      anon_sym_COMMA,
  [29578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3785), 1,
      anon_sym_RPAREN,
  [29585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3787), 1,
      anon_sym_RPAREN,
  [29592] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_to,
  [29599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3789), 1,
      anon_sym_LPAREN,
  [29606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_RPAREN,
  [29613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3793), 1,
      anon_sym_COLON,
  [29620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3795), 1,
      anon_sym_COMMA,
  [29627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3797), 1,
      anon_sym_RPAREN,
  [29634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3799), 1,
      anon_sym_RPAREN,
  [29641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_LPAREN,
  [29648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3803), 1,
      anon_sym_COMMA,
  [29655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3805), 1,
      anon_sym_RPAREN,
  [29662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3807), 1,
      anon_sym_RPAREN,
  [29669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3809), 1,
      anon_sym_COMMA,
  [29676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3811), 1,
      anon_sym_COMMA,
  [29683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3813), 1,
      anon_sym_RPAREN,
  [29690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3815), 1,
      sym_local_var,
  [29697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3817), 1,
      anon_sym_COMMA,
  [29704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3819), 1,
      anon_sym_LPAREN,
  [29711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3821), 1,
      anon_sym_LPAREN,
  [29718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3823), 1,
      anon_sym_LPAREN,
  [29725] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3825), 1,
      sym_string,
  [29732] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2255), 1,
      anon_sym_to,
  [29739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3827), 1,
      sym_string,
  [29746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3829), 1,
      anon_sym_LPAREN,
  [29753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2259), 1,
      anon_sym_to,
  [29760] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3831), 1,
      anon_sym_RPAREN,
  [29767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3833), 1,
      anon_sym_EQ,
  [29774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3835), 1,
      anon_sym_COMMA,
  [29781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3837), 1,
      anon_sym_to,
  [29788] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3839), 1,
      anon_sym_RPAREN,
  [29795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3841), 1,
      anon_sym_LBRACE,
  [29802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3843), 1,
      sym_comdat_ref,
  [29809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      anon_sym_RPAREN,
  [29816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_COMMA,
  [29823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3849), 1,
      anon_sym_RPAREN,
  [29830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3851), 1,
      anon_sym_COMMA,
  [29837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3374), 1,
      anon_sym_RPAREN,
  [29844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3853), 1,
      sym_global_var,
  [29851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3855), 1,
      anon_sym_LPAREN,
  [29858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3857), 1,
      anon_sym_LPAREN,
  [29865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3859), 1,
      anon_sym_EQ,
  [29872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3861), 1,
      anon_sym_LBRACK,
  [29879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3863), 1,
      sym_global_var,
  [29886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3865), 1,
      anon_sym_RPAREN,
  [29893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3867), 1,
      anon_sym_COMMA,
  [29900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3869), 1,
      anon_sym_COMMA,
  [29907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_EQ,
  [29914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_COLON,
  [29921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3875), 1,
      sym_global_var,
  [29928] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3877), 1,
      anon_sym_COLON,
  [29935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3879), 1,
      anon_sym_RPAREN,
  [29942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3881), 1,
      sym_global_var,
  [29949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3883), 1,
      ts_builtin_sym_end,
  [29956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3885), 1,
      anon_sym_RPAREN,
  [29963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3887), 1,
      sym_attr_ref,
  [29970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3889), 1,
      anon_sym_LPAREN,
  [29977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3891), 1,
      anon_sym_COMMA,
  [29984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3893), 1,
      anon_sym_COMMA,
  [29991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3895), 1,
      anon_sym_COMMA,
  [29998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3897), 1,
      anon_sym_COMMA,
  [30005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3899), 1,
      anon_sym_to,
  [30012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3901), 1,
      sym_global_var,
  [30019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_COMMA,
  [30026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3905), 1,
      anon_sym_asm,
  [30033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3907), 1,
      anon_sym_COMMA,
  [30040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3909), 1,
      anon_sym_COMMA,
  [30047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3911), 1,
      anon_sym_COMMA,
  [30054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3913), 1,
      sym_string,
  [30061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3915), 1,
      anon_sym_COMMA,
  [30068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3917), 1,
      anon_sym_COMMA,
  [30075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3919), 1,
      anon_sym_COMMA,
  [30082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3921), 1,
      anon_sym_COMMA,
  [30089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3923), 1,
      anon_sym_COMMA,
  [30096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3925), 1,
      anon_sym_LPAREN,
  [30103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3927), 1,
      anon_sym_LPAREN,
  [30110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3929), 1,
      anon_sym_LPAREN,
  [30117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3931), 1,
      anon_sym_LPAREN,
  [30124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3933), 1,
      anon_sym_LPAREN,
  [30131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3935), 1,
      anon_sym_LPAREN,
  [30138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3937), 1,
      anon_sym_RPAREN,
  [30145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3939), 1,
      anon_sym_COLON,
  [30152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3941), 1,
      anon_sym_COMMA,
  [30159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3943), 1,
      anon_sym_RPAREN,
  [30166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3945), 1,
      anon_sym_COMMA,
  [30173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3947), 1,
      anon_sym_COMMA,
  [30180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3949), 1,
      anon_sym_COMMA,
  [30187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3951), 1,
      anon_sym_COMMA,
  [30194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3953), 1,
      anon_sym_to,
  [30201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3955), 1,
      anon_sym_COMMA,
  [30208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3957), 1,
      anon_sym_COMMA,
  [30215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3959), 1,
      anon_sym_COMMA,
  [30222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3961), 1,
      anon_sym_COMMA,
  [30229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3963), 1,
      anon_sym_COMMA,
  [30236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3965), 1,
      anon_sym_COMMA,
  [30243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3967), 1,
      anon_sym_COMMA,
  [30250] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3969), 1,
      anon_sym_COMMA,
  [30257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3971), 1,
      anon_sym_LPAREN,
  [30264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
  [30271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3975), 1,
      anon_sym_LPAREN,
  [30278] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3977), 1,
      anon_sym_LPAREN,
  [30285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(765), 1,
      anon_sym_to,
  [30292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3979), 1,
      anon_sym_RPAREN,
  [30299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3981), 1,
      anon_sym_COLON,
  [30306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2296), 1,
      anon_sym_to,
  [30313] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3983), 1,
      anon_sym_LBRACK,
  [30320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3985), 1,
      anon_sym_COMMA,
  [30327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3987), 1,
      anon_sym_COMMA,
  [30334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3989), 1,
      anon_sym_COMMA,
  [30341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3991), 1,
      anon_sym_COMMA,
  [30348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3993), 1,
      anon_sym_to,
  [30355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3995), 1,
      anon_sym_COMMA,
  [30362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3997), 1,
      anon_sym_COMMA,
  [30369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3999), 1,
      anon_sym_COMMA,
  [30376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4001), 1,
      anon_sym_COMMA,
  [30383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4003), 1,
      anon_sym_COMMA,
  [30390] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4005), 1,
      anon_sym_COMMA,
  [30397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4007), 1,
      anon_sym_COMMA,
  [30404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 1,
      anon_sym_COMMA,
  [30411] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4011), 1,
      anon_sym_LPAREN,
  [30418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
  [30425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4015), 1,
      anon_sym_LPAREN,
  [30432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4017), 1,
      anon_sym_LPAREN,
  [30439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4019), 1,
      anon_sym_LPAREN,
  [30446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 1,
      anon_sym_LPAREN,
  [30453] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4023), 1,
      sym_global_var,
  [30460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4025), 1,
      anon_sym_COMMA,
  [30467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4027), 1,
      anon_sym_COMMA,
  [30474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4029), 1,
      sym_global_var,
  [30481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4031), 1,
      anon_sym_EQ,
  [30488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4033), 1,
      anon_sym_RPAREN,
  [30495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4035), 1,
      anon_sym_LPAREN,
  [30502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4037), 1,
      anon_sym_EQ,
  [30509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4039), 1,
      anon_sym_EQ,
  [30516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4041), 1,
      anon_sym_RPAREN,
  [30523] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4043), 1,
      anon_sym_EQ,
  [30530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4045), 1,
      anon_sym_GT,
  [30537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4047), 1,
      anon_sym_RBRACK,
  [30544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4049), 1,
      sym_global_var,
  [30551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4051), 1,
      anon_sym_align,
  [30558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      anon_sym_RBRACE_GT,
  [30565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4055), 1,
      sym_string,
  [30572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4057), 1,
      anon_sym_RBRACK,
  [30579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4059), 1,
      anon_sym_RBRACE,
  [30586] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4061), 1,
      anon_sym_LBRACK,
  [30593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4063), 1,
      anon_sym_LPAREN,
  [30600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4065), 1,
      anon_sym_COMMA,
  [30607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4067), 1,
      sym_string,
  [30614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4069), 1,
      anon_sym_RPAREN,
  [30621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(777), 1,
      anon_sym_to,
  [30628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4071), 1,
      sym_string,
  [30635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4073), 1,
      anon_sym_RPAREN,
  [30642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4075), 1,
      anon_sym_RPAREN,
  [30649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2304), 1,
      anon_sym_to,
  [30656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4077), 1,
      anon_sym_COMMA,
  [30663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4079), 1,
      sym_global_var,
  [30670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4081), 1,
      anon_sym_to,
  [30677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4083), 1,
      anon_sym_COMMA,
  [30684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 1,
      anon_sym_STAR,
  [30691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4085), 1,
      anon_sym_LPAREN,
  [30698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4087), 1,
      anon_sym_COMMA,
  [30705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4089), 1,
      anon_sym_LPAREN,
  [30712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4091), 1,
      anon_sym_RPAREN,
  [30719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4093), 1,
      anon_sym_RPAREN,
  [30726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4095), 1,
      sym_string,
  [30733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4097), 1,
      sym_string,
  [30740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4099), 1,
      anon_sym_RPAREN,
  [30747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4101), 1,
      anon_sym_RPAREN,
  [30754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4103), 1,
      anon_sym_RPAREN,
  [30761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4105), 1,
      anon_sym_RPAREN,
  [30768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4107), 1,
      sym_global_var,
  [30775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4109), 1,
      anon_sym_RPAREN,
  [30782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(753), 1,
      anon_sym_to,
  [30789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4111), 1,
      anon_sym_COMMA,
  [30796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4113), 1,
      anon_sym_caller,
  [30803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2080), 1,
      anon_sym_unwind,
  [30810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4115), 1,
      anon_sym_align,
  [30817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1768), 1,
      anon_sym_STAR,
  [30824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4117), 1,
      anon_sym_COMMA,
  [30831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4119), 1,
      sym_local_var,
  [30838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4121), 1,
      anon_sym_RBRACK,
  [30845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4123), 1,
      anon_sym_RPAREN,
  [30852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4125), 1,
      anon_sym_RPAREN,
  [30859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4127), 1,
      anon_sym_LPAREN,
  [30866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4129), 1,
      anon_sym_LPAREN,
  [30873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4131), 1,
      anon_sym_LPAREN,
  [30880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
  [30887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4135), 1,
      anon_sym_LPAREN,
  [30894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4137), 1,
      anon_sym_LPAREN,
  [30901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4139), 1,
      anon_sym_LPAREN,
  [30908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2231), 1,
      anon_sym_unwind,
  [30915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4141), 1,
      anon_sym_COMMA,
  [30922] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4143), 1,
      anon_sym_COMMA,
  [30929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4145), 1,
      anon_sym_COMMA,
  [30936] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4147), 1,
      anon_sym_LPAREN,
  [30943] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_COMMA,
  [30950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4151), 1,
      anon_sym_RPAREN,
  [30957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4153), 1,
      anon_sym_GT,
  [30964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4155), 1,
      anon_sym_LPAREN,
  [30971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4157), 1,
      anon_sym_LPAREN,
  [30978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4159), 1,
      anon_sym_LPAREN,
  [30985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4161), 1,
      sym_local_var,
  [30992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4163), 1,
      anon_sym_LPAREN,
  [30999] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4165), 1,
      anon_sym_LPAREN,
  [31006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_LPAREN,
  [31013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 1,
      anon_sym_COMMA,
  [31020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4171), 1,
      anon_sym_COMMA,
  [31027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4173), 1,
      anon_sym_COMMA,
  [31034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4175), 1,
      anon_sym_COMMA,
  [31041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4177), 1,
      anon_sym_LPAREN,
  [31048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4179), 1,
      anon_sym_COMMA,
  [31055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4181), 1,
      anon_sym_RBRACK,
  [31062] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4183), 1,
      anon_sym_x,
  [31069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_LPAREN,
  [31076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4187), 1,
      anon_sym_LPAREN,
  [31083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4189), 1,
      anon_sym_LPAREN,
  [31090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_to,
  [31097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4191), 1,
      anon_sym_LPAREN,
  [31104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_LPAREN,
  [31111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4195), 1,
      anon_sym_LPAREN,
  [31118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4197), 1,
      anon_sym_LPAREN,
  [31125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4199), 1,
      anon_sym_COMMA,
  [31132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4201), 1,
      anon_sym_COMMA,
  [31139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4203), 1,
      anon_sym_COMMA,
  [31146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4205), 1,
      anon_sym_LPAREN,
  [31153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4207), 1,
      anon_sym_COMMA,
  [31160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_LPAREN,
  [31167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4211), 1,
      anon_sym_LPAREN,
  [31174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4213), 1,
      anon_sym_LPAREN,
  [31181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4215), 1,
      sym_global_var,
  [31188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4217), 1,
      sym_string,
  [31195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4219), 1,
      anon_sym_x,
  [31202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4221), 1,
      anon_sym_COMMA,
  [31209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4223), 1,
      anon_sym_RBRACE_GT,
  [31216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4225), 1,
      anon_sym_align,
  [31223] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4227), 1,
      anon_sym_COMMA,
  [31230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4229), 1,
      anon_sym_COMMA,
  [31237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(761), 1,
      anon_sym_to,
  [31244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4231), 1,
      anon_sym_COMMA,
  [31251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4233), 1,
      anon_sym_COMMA,
  [31258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4235), 1,
      anon_sym_RBRACE,
  [31265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4237), 1,
      anon_sym_RPAREN,
  [31272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4239), 1,
      anon_sym_RPAREN,
  [31279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4241), 1,
      anon_sym_RPAREN,
  [31286] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4243), 1,
      anon_sym_COMMA,
  [31293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4245), 1,
      anon_sym_COMMA,
  [31300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4247), 1,
      sym_global_var,
  [31307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4249), 1,
      anon_sym_COMMA,
  [31314] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4251), 1,
      sym_string,
  [31321] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4253), 1,
      anon_sym_RPAREN,
  [31328] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4255), 1,
      anon_sym_RPAREN,
  [31335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4257), 1,
      anon_sym_RPAREN,
  [31342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4259), 1,
      anon_sym_COMMA,
  [31349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4261), 1,
      anon_sym_COMMA,
  [31356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4263), 1,
      anon_sym_COMMA,
  [31363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4265), 1,
      anon_sym_LPAREN,
  [31370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_LPAREN,
  [31377] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4269), 1,
      anon_sym_LPAREN,
  [31384] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4271), 1,
      anon_sym_LPAREN,
  [31391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4273), 1,
      anon_sym_RPAREN,
  [31398] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4275), 1,
      sym_string,
  [31405] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LPAREN,
  [31412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4279), 1,
      anon_sym_LPAREN,
  [31419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4281), 1,
      anon_sym_LPAREN,
  [31426] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_LPAREN,
  [31433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4285), 1,
      anon_sym_RPAREN,
  [31440] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4287), 1,
      anon_sym_RPAREN,
  [31447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4289), 1,
      anon_sym_LPAREN,
  [31454] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4291), 1,
      anon_sym_LPAREN,
  [31461] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4293), 1,
      anon_sym_LPAREN,
  [31468] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4295), 1,
      anon_sym_LPAREN,
  [31475] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4297), 1,
      anon_sym_RPAREN,
  [31482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_RPAREN,
  [31489] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4301), 1,
      anon_sym_LPAREN,
  [31496] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4303), 1,
      anon_sym_LPAREN,
  [31503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4305), 1,
      anon_sym_LPAREN,
  [31510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4307), 1,
      anon_sym_LPAREN,
  [31517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4309), 1,
      anon_sym_LPAREN,
  [31524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4311), 1,
      anon_sym_LPAREN,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(693)] = 0,
  [SMALL_STATE(694)] = 92,
  [SMALL_STATE(695)] = 181,
  [SMALL_STATE(696)] = 270,
  [SMALL_STATE(697)] = 359,
  [SMALL_STATE(698)] = 448,
  [SMALL_STATE(699)] = 537,
  [SMALL_STATE(700)] = 626,
  [SMALL_STATE(701)] = 715,
  [SMALL_STATE(702)] = 804,
  [SMALL_STATE(703)] = 893,
  [SMALL_STATE(704)] = 982,
  [SMALL_STATE(705)] = 1071,
  [SMALL_STATE(706)] = 1160,
  [SMALL_STATE(707)] = 1249,
  [SMALL_STATE(708)] = 1338,
  [SMALL_STATE(709)] = 1427,
  [SMALL_STATE(710)] = 1516,
  [SMALL_STATE(711)] = 1605,
  [SMALL_STATE(712)] = 1694,
  [SMALL_STATE(713)] = 1752,
  [SMALL_STATE(714)] = 1812,
  [SMALL_STATE(715)] = 1867,
  [SMALL_STATE(716)] = 1924,
  [SMALL_STATE(717)] = 1978,
  [SMALL_STATE(718)] = 2032,
  [SMALL_STATE(719)] = 2086,
  [SMALL_STATE(720)] = 2140,
  [SMALL_STATE(721)] = 2194,
  [SMALL_STATE(722)] = 2248,
  [SMALL_STATE(723)] = 2302,
  [SMALL_STATE(724)] = 2356,
  [SMALL_STATE(725)] = 2410,
  [SMALL_STATE(726)] = 2464,
  [SMALL_STATE(727)] = 2518,
  [SMALL_STATE(728)] = 2572,
  [SMALL_STATE(729)] = 2644,
  [SMALL_STATE(730)] = 2716,
  [SMALL_STATE(731)] = 2782,
  [SMALL_STATE(732)] = 2858,
  [SMALL_STATE(733)] = 2934,
  [SMALL_STATE(734)] = 3000,
  [SMALL_STATE(735)] = 3066,
  [SMALL_STATE(736)] = 3132,
  [SMALL_STATE(737)] = 3193,
  [SMALL_STATE(738)] = 3254,
  [SMALL_STATE(739)] = 3326,
  [SMALL_STATE(740)] = 3398,
  [SMALL_STATE(741)] = 3470,
  [SMALL_STATE(742)] = 3542,
  [SMALL_STATE(743)] = 3614,
  [SMALL_STATE(744)] = 3686,
  [SMALL_STATE(745)] = 3735,
  [SMALL_STATE(746)] = 3804,
  [SMALL_STATE(747)] = 3873,
  [SMALL_STATE(748)] = 3942,
  [SMALL_STATE(749)] = 4011,
  [SMALL_STATE(750)] = 4080,
  [SMALL_STATE(751)] = 4149,
  [SMALL_STATE(752)] = 4208,
  [SMALL_STATE(753)] = 4250,
  [SMALL_STATE(754)] = 4292,
  [SMALL_STATE(755)] = 4362,
  [SMALL_STATE(756)] = 4432,
  [SMALL_STATE(757)] = 4492,
  [SMALL_STATE(758)] = 4549,
  [SMALL_STATE(759)] = 4606,
  [SMALL_STATE(760)] = 4664,
  [SMALL_STATE(761)] = 4714,
  [SMALL_STATE(762)] = 4772,
  [SMALL_STATE(763)] = 4830,
  [SMALL_STATE(764)] = 4888,
  [SMALL_STATE(765)] = 4946,
  [SMALL_STATE(766)] = 5000,
  [SMALL_STATE(767)] = 5058,
  [SMALL_STATE(768)] = 5112,
  [SMALL_STATE(769)] = 5170,
  [SMALL_STATE(770)] = 5220,
  [SMALL_STATE(771)] = 5278,
  [SMALL_STATE(772)] = 5332,
  [SMALL_STATE(773)] = 5390,
  [SMALL_STATE(774)] = 5448,
  [SMALL_STATE(775)] = 5506,
  [SMALL_STATE(776)] = 5564,
  [SMALL_STATE(777)] = 5622,
  [SMALL_STATE(778)] = 5677,
  [SMALL_STATE(779)] = 5732,
  [SMALL_STATE(780)] = 5787,
  [SMALL_STATE(781)] = 5836,
  [SMALL_STATE(782)] = 5891,
  [SMALL_STATE(783)] = 5946,
  [SMALL_STATE(784)] = 6001,
  [SMALL_STATE(785)] = 6056,
  [SMALL_STATE(786)] = 6111,
  [SMALL_STATE(787)] = 6164,
  [SMALL_STATE(788)] = 6217,
  [SMALL_STATE(789)] = 6272,
  [SMALL_STATE(790)] = 6327,
  [SMALL_STATE(791)] = 6382,
  [SMALL_STATE(792)] = 6437,
  [SMALL_STATE(793)] = 6492,
  [SMALL_STATE(794)] = 6547,
  [SMALL_STATE(795)] = 6600,
  [SMALL_STATE(796)] = 6653,
  [SMALL_STATE(797)] = 6708,
  [SMALL_STATE(798)] = 6763,
  [SMALL_STATE(799)] = 6818,
  [SMALL_STATE(800)] = 6873,
  [SMALL_STATE(801)] = 6928,
  [SMALL_STATE(802)] = 6983,
  [SMALL_STATE(803)] = 7038,
  [SMALL_STATE(804)] = 7093,
  [SMALL_STATE(805)] = 7148,
  [SMALL_STATE(806)] = 7203,
  [SMALL_STATE(807)] = 7258,
  [SMALL_STATE(808)] = 7311,
  [SMALL_STATE(809)] = 7364,
  [SMALL_STATE(810)] = 7419,
  [SMALL_STATE(811)] = 7472,
  [SMALL_STATE(812)] = 7527,
  [SMALL_STATE(813)] = 7580,
  [SMALL_STATE(814)] = 7633,
  [SMALL_STATE(815)] = 7686,
  [SMALL_STATE(816)] = 7739,
  [SMALL_STATE(817)] = 7792,
  [SMALL_STATE(818)] = 7847,
  [SMALL_STATE(819)] = 7902,
  [SMALL_STATE(820)] = 7957,
  [SMALL_STATE(821)] = 8012,
  [SMALL_STATE(822)] = 8067,
  [SMALL_STATE(823)] = 8122,
  [SMALL_STATE(824)] = 8177,
  [SMALL_STATE(825)] = 8232,
  [SMALL_STATE(826)] = 8269,
  [SMALL_STATE(827)] = 8306,
  [SMALL_STATE(828)] = 8343,
  [SMALL_STATE(829)] = 8380,
  [SMALL_STATE(830)] = 8417,
  [SMALL_STATE(831)] = 8472,
  [SMALL_STATE(832)] = 8527,
  [SMALL_STATE(833)] = 8582,
  [SMALL_STATE(834)] = 8637,
  [SMALL_STATE(835)] = 8692,
  [SMALL_STATE(836)] = 8747,
  [SMALL_STATE(837)] = 8802,
  [SMALL_STATE(838)] = 8857,
  [SMALL_STATE(839)] = 8912,
  [SMALL_STATE(840)] = 8967,
  [SMALL_STATE(841)] = 9022,
  [SMALL_STATE(842)] = 9077,
  [SMALL_STATE(843)] = 9132,
  [SMALL_STATE(844)] = 9187,
  [SMALL_STATE(845)] = 9242,
  [SMALL_STATE(846)] = 9291,
  [SMALL_STATE(847)] = 9346,
  [SMALL_STATE(848)] = 9401,
  [SMALL_STATE(849)] = 9456,
  [SMALL_STATE(850)] = 9511,
  [SMALL_STATE(851)] = 9564,
  [SMALL_STATE(852)] = 9617,
  [SMALL_STATE(853)] = 9672,
  [SMALL_STATE(854)] = 9724,
  [SMALL_STATE(855)] = 9776,
  [SMALL_STATE(856)] = 9828,
  [SMALL_STATE(857)] = 9880,
  [SMALL_STATE(858)] = 9932,
  [SMALL_STATE(859)] = 9984,
  [SMALL_STATE(860)] = 10036,
  [SMALL_STATE(861)] = 10088,
  [SMALL_STATE(862)] = 10140,
  [SMALL_STATE(863)] = 10192,
  [SMALL_STATE(864)] = 10244,
  [SMALL_STATE(865)] = 10296,
  [SMALL_STATE(866)] = 10348,
  [SMALL_STATE(867)] = 10400,
  [SMALL_STATE(868)] = 10452,
  [SMALL_STATE(869)] = 10504,
  [SMALL_STATE(870)] = 10556,
  [SMALL_STATE(871)] = 10608,
  [SMALL_STATE(872)] = 10660,
  [SMALL_STATE(873)] = 10712,
  [SMALL_STATE(874)] = 10764,
  [SMALL_STATE(875)] = 10816,
  [SMALL_STATE(876)] = 10868,
  [SMALL_STATE(877)] = 10920,
  [SMALL_STATE(878)] = 10972,
  [SMALL_STATE(879)] = 11024,
  [SMALL_STATE(880)] = 11076,
  [SMALL_STATE(881)] = 11128,
  [SMALL_STATE(882)] = 11180,
  [SMALL_STATE(883)] = 11232,
  [SMALL_STATE(884)] = 11284,
  [SMALL_STATE(885)] = 11336,
  [SMALL_STATE(886)] = 11388,
  [SMALL_STATE(887)] = 11440,
  [SMALL_STATE(888)] = 11492,
  [SMALL_STATE(889)] = 11544,
  [SMALL_STATE(890)] = 11596,
  [SMALL_STATE(891)] = 11648,
  [SMALL_STATE(892)] = 11700,
  [SMALL_STATE(893)] = 11752,
  [SMALL_STATE(894)] = 11804,
  [SMALL_STATE(895)] = 11856,
  [SMALL_STATE(896)] = 11908,
  [SMALL_STATE(897)] = 11960,
  [SMALL_STATE(898)] = 12012,
  [SMALL_STATE(899)] = 12064,
  [SMALL_STATE(900)] = 12116,
  [SMALL_STATE(901)] = 12168,
  [SMALL_STATE(902)] = 12220,
  [SMALL_STATE(903)] = 12272,
  [SMALL_STATE(904)] = 12324,
  [SMALL_STATE(905)] = 12376,
  [SMALL_STATE(906)] = 12428,
  [SMALL_STATE(907)] = 12480,
  [SMALL_STATE(908)] = 12532,
  [SMALL_STATE(909)] = 12584,
  [SMALL_STATE(910)] = 12636,
  [SMALL_STATE(911)] = 12688,
  [SMALL_STATE(912)] = 12740,
  [SMALL_STATE(913)] = 12792,
  [SMALL_STATE(914)] = 12844,
  [SMALL_STATE(915)] = 12896,
  [SMALL_STATE(916)] = 12948,
  [SMALL_STATE(917)] = 13000,
  [SMALL_STATE(918)] = 13052,
  [SMALL_STATE(919)] = 13104,
  [SMALL_STATE(920)] = 13156,
  [SMALL_STATE(921)] = 13208,
  [SMALL_STATE(922)] = 13260,
  [SMALL_STATE(923)] = 13312,
  [SMALL_STATE(924)] = 13364,
  [SMALL_STATE(925)] = 13416,
  [SMALL_STATE(926)] = 13468,
  [SMALL_STATE(927)] = 13520,
  [SMALL_STATE(928)] = 13572,
  [SMALL_STATE(929)] = 13624,
  [SMALL_STATE(930)] = 13676,
  [SMALL_STATE(931)] = 13728,
  [SMALL_STATE(932)] = 13780,
  [SMALL_STATE(933)] = 13832,
  [SMALL_STATE(934)] = 13884,
  [SMALL_STATE(935)] = 13936,
  [SMALL_STATE(936)] = 13988,
  [SMALL_STATE(937)] = 14040,
  [SMALL_STATE(938)] = 14090,
  [SMALL_STATE(939)] = 14142,
  [SMALL_STATE(940)] = 14192,
  [SMALL_STATE(941)] = 14244,
  [SMALL_STATE(942)] = 14296,
  [SMALL_STATE(943)] = 14348,
  [SMALL_STATE(944)] = 14400,
  [SMALL_STATE(945)] = 14452,
  [SMALL_STATE(946)] = 14504,
  [SMALL_STATE(947)] = 14556,
  [SMALL_STATE(948)] = 14608,
  [SMALL_STATE(949)] = 14660,
  [SMALL_STATE(950)] = 14712,
  [SMALL_STATE(951)] = 14764,
  [SMALL_STATE(952)] = 14816,
  [SMALL_STATE(953)] = 14868,
  [SMALL_STATE(954)] = 14920,
  [SMALL_STATE(955)] = 14972,
  [SMALL_STATE(956)] = 15024,
  [SMALL_STATE(957)] = 15076,
  [SMALL_STATE(958)] = 15128,
  [SMALL_STATE(959)] = 15180,
  [SMALL_STATE(960)] = 15232,
  [SMALL_STATE(961)] = 15284,
  [SMALL_STATE(962)] = 15336,
  [SMALL_STATE(963)] = 15388,
  [SMALL_STATE(964)] = 15440,
  [SMALL_STATE(965)] = 15492,
  [SMALL_STATE(966)] = 15544,
  [SMALL_STATE(967)] = 15596,
  [SMALL_STATE(968)] = 15648,
  [SMALL_STATE(969)] = 15700,
  [SMALL_STATE(970)] = 15752,
  [SMALL_STATE(971)] = 15804,
  [SMALL_STATE(972)] = 15856,
  [SMALL_STATE(973)] = 15908,
  [SMALL_STATE(974)] = 15960,
  [SMALL_STATE(975)] = 16012,
  [SMALL_STATE(976)] = 16064,
  [SMALL_STATE(977)] = 16116,
  [SMALL_STATE(978)] = 16168,
  [SMALL_STATE(979)] = 16220,
  [SMALL_STATE(980)] = 16272,
  [SMALL_STATE(981)] = 16324,
  [SMALL_STATE(982)] = 16376,
  [SMALL_STATE(983)] = 16428,
  [SMALL_STATE(984)] = 16480,
  [SMALL_STATE(985)] = 16532,
  [SMALL_STATE(986)] = 16584,
  [SMALL_STATE(987)] = 16636,
  [SMALL_STATE(988)] = 16688,
  [SMALL_STATE(989)] = 16740,
  [SMALL_STATE(990)] = 16792,
  [SMALL_STATE(991)] = 16844,
  [SMALL_STATE(992)] = 16896,
  [SMALL_STATE(993)] = 16948,
  [SMALL_STATE(994)] = 17000,
  [SMALL_STATE(995)] = 17052,
  [SMALL_STATE(996)] = 17104,
  [SMALL_STATE(997)] = 17156,
  [SMALL_STATE(998)] = 17208,
  [SMALL_STATE(999)] = 17260,
  [SMALL_STATE(1000)] = 17312,
  [SMALL_STATE(1001)] = 17364,
  [SMALL_STATE(1002)] = 17416,
  [SMALL_STATE(1003)] = 17468,
  [SMALL_STATE(1004)] = 17520,
  [SMALL_STATE(1005)] = 17572,
  [SMALL_STATE(1006)] = 17624,
  [SMALL_STATE(1007)] = 17676,
  [SMALL_STATE(1008)] = 17728,
  [SMALL_STATE(1009)] = 17780,
  [SMALL_STATE(1010)] = 17832,
  [SMALL_STATE(1011)] = 17884,
  [SMALL_STATE(1012)] = 17936,
  [SMALL_STATE(1013)] = 17988,
  [SMALL_STATE(1014)] = 18040,
  [SMALL_STATE(1015)] = 18092,
  [SMALL_STATE(1016)] = 18144,
  [SMALL_STATE(1017)] = 18196,
  [SMALL_STATE(1018)] = 18248,
  [SMALL_STATE(1019)] = 18300,
  [SMALL_STATE(1020)] = 18352,
  [SMALL_STATE(1021)] = 18404,
  [SMALL_STATE(1022)] = 18456,
  [SMALL_STATE(1023)] = 18508,
  [SMALL_STATE(1024)] = 18560,
  [SMALL_STATE(1025)] = 18612,
  [SMALL_STATE(1026)] = 18664,
  [SMALL_STATE(1027)] = 18716,
  [SMALL_STATE(1028)] = 18768,
  [SMALL_STATE(1029)] = 18820,
  [SMALL_STATE(1030)] = 18872,
  [SMALL_STATE(1031)] = 18924,
  [SMALL_STATE(1032)] = 18976,
  [SMALL_STATE(1033)] = 19028,
  [SMALL_STATE(1034)] = 19080,
  [SMALL_STATE(1035)] = 19132,
  [SMALL_STATE(1036)] = 19184,
  [SMALL_STATE(1037)] = 19236,
  [SMALL_STATE(1038)] = 19288,
  [SMALL_STATE(1039)] = 19340,
  [SMALL_STATE(1040)] = 19392,
  [SMALL_STATE(1041)] = 19444,
  [SMALL_STATE(1042)] = 19496,
  [SMALL_STATE(1043)] = 19543,
  [SMALL_STATE(1044)] = 19590,
  [SMALL_STATE(1045)] = 19629,
  [SMALL_STATE(1046)] = 19676,
  [SMALL_STATE(1047)] = 19723,
  [SMALL_STATE(1048)] = 19770,
  [SMALL_STATE(1049)] = 19809,
  [SMALL_STATE(1050)] = 19848,
  [SMALL_STATE(1051)] = 19895,
  [SMALL_STATE(1052)] = 19934,
  [SMALL_STATE(1053)] = 19981,
  [SMALL_STATE(1054)] = 20020,
  [SMALL_STATE(1055)] = 20059,
  [SMALL_STATE(1056)] = 20106,
  [SMALL_STATE(1057)] = 20153,
  [SMALL_STATE(1058)] = 20200,
  [SMALL_STATE(1059)] = 20247,
  [SMALL_STATE(1060)] = 20294,
  [SMALL_STATE(1061)] = 20341,
  [SMALL_STATE(1062)] = 20388,
  [SMALL_STATE(1063)] = 20435,
  [SMALL_STATE(1064)] = 20482,
  [SMALL_STATE(1065)] = 20529,
  [SMALL_STATE(1066)] = 20576,
  [SMALL_STATE(1067)] = 20623,
  [SMALL_STATE(1068)] = 20670,
  [SMALL_STATE(1069)] = 20717,
  [SMALL_STATE(1070)] = 20756,
  [SMALL_STATE(1071)] = 20795,
  [SMALL_STATE(1072)] = 20842,
  [SMALL_STATE(1073)] = 20881,
  [SMALL_STATE(1074)] = 20928,
  [SMALL_STATE(1075)] = 20975,
  [SMALL_STATE(1076)] = 21022,
  [SMALL_STATE(1077)] = 21069,
  [SMALL_STATE(1078)] = 21116,
  [SMALL_STATE(1079)] = 21163,
  [SMALL_STATE(1080)] = 21210,
  [SMALL_STATE(1081)] = 21257,
  [SMALL_STATE(1082)] = 21304,
  [SMALL_STATE(1083)] = 21351,
  [SMALL_STATE(1084)] = 21390,
  [SMALL_STATE(1085)] = 21437,
  [SMALL_STATE(1086)] = 21469,
  [SMALL_STATE(1087)] = 21500,
  [SMALL_STATE(1088)] = 21530,
  [SMALL_STATE(1089)] = 21560,
  [SMALL_STATE(1090)] = 21590,
  [SMALL_STATE(1091)] = 21619,
  [SMALL_STATE(1092)] = 21648,
  [SMALL_STATE(1093)] = 21677,
  [SMALL_STATE(1094)] = 21706,
  [SMALL_STATE(1095)] = 21735,
  [SMALL_STATE(1096)] = 21764,
  [SMALL_STATE(1097)] = 21793,
  [SMALL_STATE(1098)] = 21822,
  [SMALL_STATE(1099)] = 21851,
  [SMALL_STATE(1100)] = 21874,
  [SMALL_STATE(1101)] = 21897,
  [SMALL_STATE(1102)] = 21920,
  [SMALL_STATE(1103)] = 21943,
  [SMALL_STATE(1104)] = 21968,
  [SMALL_STATE(1105)] = 21991,
  [SMALL_STATE(1106)] = 22013,
  [SMALL_STATE(1107)] = 22039,
  [SMALL_STATE(1108)] = 22061,
  [SMALL_STATE(1109)] = 22083,
  [SMALL_STATE(1110)] = 22109,
  [SMALL_STATE(1111)] = 22131,
  [SMALL_STATE(1112)] = 22153,
  [SMALL_STATE(1113)] = 22175,
  [SMALL_STATE(1114)] = 22197,
  [SMALL_STATE(1115)] = 22219,
  [SMALL_STATE(1116)] = 22241,
  [SMALL_STATE(1117)] = 22263,
  [SMALL_STATE(1118)] = 22285,
  [SMALL_STATE(1119)] = 22311,
  [SMALL_STATE(1120)] = 22333,
  [SMALL_STATE(1121)] = 22355,
  [SMALL_STATE(1122)] = 22377,
  [SMALL_STATE(1123)] = 22403,
  [SMALL_STATE(1124)] = 22425,
  [SMALL_STATE(1125)] = 22451,
  [SMALL_STATE(1126)] = 22477,
  [SMALL_STATE(1127)] = 22499,
  [SMALL_STATE(1128)] = 22525,
  [SMALL_STATE(1129)] = 22551,
  [SMALL_STATE(1130)] = 22573,
  [SMALL_STATE(1131)] = 22595,
  [SMALL_STATE(1132)] = 22617,
  [SMALL_STATE(1133)] = 22639,
  [SMALL_STATE(1134)] = 22665,
  [SMALL_STATE(1135)] = 22687,
  [SMALL_STATE(1136)] = 22709,
  [SMALL_STATE(1137)] = 22731,
  [SMALL_STATE(1138)] = 22753,
  [SMALL_STATE(1139)] = 22775,
  [SMALL_STATE(1140)] = 22796,
  [SMALL_STATE(1141)] = 22817,
  [SMALL_STATE(1142)] = 22836,
  [SMALL_STATE(1143)] = 22857,
  [SMALL_STATE(1144)] = 22876,
  [SMALL_STATE(1145)] = 22895,
  [SMALL_STATE(1146)] = 22914,
  [SMALL_STATE(1147)] = 22935,
  [SMALL_STATE(1148)] = 22956,
  [SMALL_STATE(1149)] = 22977,
  [SMALL_STATE(1150)] = 22998,
  [SMALL_STATE(1151)] = 23017,
  [SMALL_STATE(1152)] = 23038,
  [SMALL_STATE(1153)] = 23064,
  [SMALL_STATE(1154)] = 23090,
  [SMALL_STATE(1155)] = 23107,
  [SMALL_STATE(1156)] = 23128,
  [SMALL_STATE(1157)] = 23149,
  [SMALL_STATE(1158)] = 23170,
  [SMALL_STATE(1159)] = 23191,
  [SMALL_STATE(1160)] = 23212,
  [SMALL_STATE(1161)] = 23233,
  [SMALL_STATE(1162)] = 23247,
  [SMALL_STATE(1163)] = 23262,
  [SMALL_STATE(1164)] = 23277,
  [SMALL_STATE(1165)] = 23292,
  [SMALL_STATE(1166)] = 23307,
  [SMALL_STATE(1167)] = 23326,
  [SMALL_STATE(1168)] = 23345,
  [SMALL_STATE(1169)] = 23360,
  [SMALL_STATE(1170)] = 23379,
  [SMALL_STATE(1171)] = 23398,
  [SMALL_STATE(1172)] = 23417,
  [SMALL_STATE(1173)] = 23432,
  [SMALL_STATE(1174)] = 23447,
  [SMALL_STATE(1175)] = 23462,
  [SMALL_STATE(1176)] = 23477,
  [SMALL_STATE(1177)] = 23496,
  [SMALL_STATE(1178)] = 23515,
  [SMALL_STATE(1179)] = 23534,
  [SMALL_STATE(1180)] = 23549,
  [SMALL_STATE(1181)] = 23571,
  [SMALL_STATE(1182)] = 23591,
  [SMALL_STATE(1183)] = 23611,
  [SMALL_STATE(1184)] = 23633,
  [SMALL_STATE(1185)] = 23645,
  [SMALL_STATE(1186)] = 23667,
  [SMALL_STATE(1187)] = 23689,
  [SMALL_STATE(1188)] = 23711,
  [SMALL_STATE(1189)] = 23727,
  [SMALL_STATE(1190)] = 23749,
  [SMALL_STATE(1191)] = 23771,
  [SMALL_STATE(1192)] = 23783,
  [SMALL_STATE(1193)] = 23803,
  [SMALL_STATE(1194)] = 23814,
  [SMALL_STATE(1195)] = 23825,
  [SMALL_STATE(1196)] = 23844,
  [SMALL_STATE(1197)] = 23863,
  [SMALL_STATE(1198)] = 23882,
  [SMALL_STATE(1199)] = 23901,
  [SMALL_STATE(1200)] = 23914,
  [SMALL_STATE(1201)] = 23929,
  [SMALL_STATE(1202)] = 23942,
  [SMALL_STATE(1203)] = 23961,
  [SMALL_STATE(1204)] = 23976,
  [SMALL_STATE(1205)] = 23995,
  [SMALL_STATE(1206)] = 24010,
  [SMALL_STATE(1207)] = 24027,
  [SMALL_STATE(1208)] = 24046,
  [SMALL_STATE(1209)] = 24065,
  [SMALL_STATE(1210)] = 24084,
  [SMALL_STATE(1211)] = 24103,
  [SMALL_STATE(1212)] = 24122,
  [SMALL_STATE(1213)] = 24141,
  [SMALL_STATE(1214)] = 24160,
  [SMALL_STATE(1215)] = 24173,
  [SMALL_STATE(1216)] = 24186,
  [SMALL_STATE(1217)] = 24201,
  [SMALL_STATE(1218)] = 24216,
  [SMALL_STATE(1219)] = 24226,
  [SMALL_STATE(1220)] = 24236,
  [SMALL_STATE(1221)] = 24252,
  [SMALL_STATE(1222)] = 24266,
  [SMALL_STATE(1223)] = 24280,
  [SMALL_STATE(1224)] = 24296,
  [SMALL_STATE(1225)] = 24306,
  [SMALL_STATE(1226)] = 24316,
  [SMALL_STATE(1227)] = 24330,
  [SMALL_STATE(1228)] = 24344,
  [SMALL_STATE(1229)] = 24360,
  [SMALL_STATE(1230)] = 24376,
  [SMALL_STATE(1231)] = 24390,
  [SMALL_STATE(1232)] = 24400,
  [SMALL_STATE(1233)] = 24414,
  [SMALL_STATE(1234)] = 24428,
  [SMALL_STATE(1235)] = 24444,
  [SMALL_STATE(1236)] = 24460,
  [SMALL_STATE(1237)] = 24473,
  [SMALL_STATE(1238)] = 24486,
  [SMALL_STATE(1239)] = 24499,
  [SMALL_STATE(1240)] = 24512,
  [SMALL_STATE(1241)] = 24525,
  [SMALL_STATE(1242)] = 24538,
  [SMALL_STATE(1243)] = 24551,
  [SMALL_STATE(1244)] = 24564,
  [SMALL_STATE(1245)] = 24577,
  [SMALL_STATE(1246)] = 24590,
  [SMALL_STATE(1247)] = 24603,
  [SMALL_STATE(1248)] = 24616,
  [SMALL_STATE(1249)] = 24629,
  [SMALL_STATE(1250)] = 24642,
  [SMALL_STATE(1251)] = 24655,
  [SMALL_STATE(1252)] = 24668,
  [SMALL_STATE(1253)] = 24681,
  [SMALL_STATE(1254)] = 24694,
  [SMALL_STATE(1255)] = 24707,
  [SMALL_STATE(1256)] = 24720,
  [SMALL_STATE(1257)] = 24733,
  [SMALL_STATE(1258)] = 24746,
  [SMALL_STATE(1259)] = 24759,
  [SMALL_STATE(1260)] = 24772,
  [SMALL_STATE(1261)] = 24785,
  [SMALL_STATE(1262)] = 24798,
  [SMALL_STATE(1263)] = 24811,
  [SMALL_STATE(1264)] = 24824,
  [SMALL_STATE(1265)] = 24837,
  [SMALL_STATE(1266)] = 24850,
  [SMALL_STATE(1267)] = 24863,
  [SMALL_STATE(1268)] = 24876,
  [SMALL_STATE(1269)] = 24889,
  [SMALL_STATE(1270)] = 24902,
  [SMALL_STATE(1271)] = 24915,
  [SMALL_STATE(1272)] = 24928,
  [SMALL_STATE(1273)] = 24941,
  [SMALL_STATE(1274)] = 24954,
  [SMALL_STATE(1275)] = 24967,
  [SMALL_STATE(1276)] = 24980,
  [SMALL_STATE(1277)] = 24993,
  [SMALL_STATE(1278)] = 25006,
  [SMALL_STATE(1279)] = 25019,
  [SMALL_STATE(1280)] = 25032,
  [SMALL_STATE(1281)] = 25045,
  [SMALL_STATE(1282)] = 25058,
  [SMALL_STATE(1283)] = 25071,
  [SMALL_STATE(1284)] = 25084,
  [SMALL_STATE(1285)] = 25097,
  [SMALL_STATE(1286)] = 25110,
  [SMALL_STATE(1287)] = 25123,
  [SMALL_STATE(1288)] = 25136,
  [SMALL_STATE(1289)] = 25149,
  [SMALL_STATE(1290)] = 25162,
  [SMALL_STATE(1291)] = 25175,
  [SMALL_STATE(1292)] = 25188,
  [SMALL_STATE(1293)] = 25201,
  [SMALL_STATE(1294)] = 25214,
  [SMALL_STATE(1295)] = 25227,
  [SMALL_STATE(1296)] = 25240,
  [SMALL_STATE(1297)] = 25253,
  [SMALL_STATE(1298)] = 25266,
  [SMALL_STATE(1299)] = 25275,
  [SMALL_STATE(1300)] = 25288,
  [SMALL_STATE(1301)] = 25301,
  [SMALL_STATE(1302)] = 25314,
  [SMALL_STATE(1303)] = 25327,
  [SMALL_STATE(1304)] = 25340,
  [SMALL_STATE(1305)] = 25353,
  [SMALL_STATE(1306)] = 25366,
  [SMALL_STATE(1307)] = 25379,
  [SMALL_STATE(1308)] = 25392,
  [SMALL_STATE(1309)] = 25405,
  [SMALL_STATE(1310)] = 25416,
  [SMALL_STATE(1311)] = 25429,
  [SMALL_STATE(1312)] = 25442,
  [SMALL_STATE(1313)] = 25455,
  [SMALL_STATE(1314)] = 25468,
  [SMALL_STATE(1315)] = 25481,
  [SMALL_STATE(1316)] = 25494,
  [SMALL_STATE(1317)] = 25507,
  [SMALL_STATE(1318)] = 25520,
  [SMALL_STATE(1319)] = 25529,
  [SMALL_STATE(1320)] = 25542,
  [SMALL_STATE(1321)] = 25555,
  [SMALL_STATE(1322)] = 25568,
  [SMALL_STATE(1323)] = 25581,
  [SMALL_STATE(1324)] = 25594,
  [SMALL_STATE(1325)] = 25607,
  [SMALL_STATE(1326)] = 25620,
  [SMALL_STATE(1327)] = 25633,
  [SMALL_STATE(1328)] = 25646,
  [SMALL_STATE(1329)] = 25659,
  [SMALL_STATE(1330)] = 25672,
  [SMALL_STATE(1331)] = 25685,
  [SMALL_STATE(1332)] = 25698,
  [SMALL_STATE(1333)] = 25711,
  [SMALL_STATE(1334)] = 25724,
  [SMALL_STATE(1335)] = 25737,
  [SMALL_STATE(1336)] = 25750,
  [SMALL_STATE(1337)] = 25763,
  [SMALL_STATE(1338)] = 25776,
  [SMALL_STATE(1339)] = 25789,
  [SMALL_STATE(1340)] = 25802,
  [SMALL_STATE(1341)] = 25815,
  [SMALL_STATE(1342)] = 25828,
  [SMALL_STATE(1343)] = 25841,
  [SMALL_STATE(1344)] = 25854,
  [SMALL_STATE(1345)] = 25867,
  [SMALL_STATE(1346)] = 25880,
  [SMALL_STATE(1347)] = 25893,
  [SMALL_STATE(1348)] = 25906,
  [SMALL_STATE(1349)] = 25919,
  [SMALL_STATE(1350)] = 25932,
  [SMALL_STATE(1351)] = 25945,
  [SMALL_STATE(1352)] = 25958,
  [SMALL_STATE(1353)] = 25971,
  [SMALL_STATE(1354)] = 25984,
  [SMALL_STATE(1355)] = 25997,
  [SMALL_STATE(1356)] = 26010,
  [SMALL_STATE(1357)] = 26023,
  [SMALL_STATE(1358)] = 26036,
  [SMALL_STATE(1359)] = 26049,
  [SMALL_STATE(1360)] = 26058,
  [SMALL_STATE(1361)] = 26071,
  [SMALL_STATE(1362)] = 26084,
  [SMALL_STATE(1363)] = 26097,
  [SMALL_STATE(1364)] = 26110,
  [SMALL_STATE(1365)] = 26123,
  [SMALL_STATE(1366)] = 26136,
  [SMALL_STATE(1367)] = 26149,
  [SMALL_STATE(1368)] = 26162,
  [SMALL_STATE(1369)] = 26175,
  [SMALL_STATE(1370)] = 26188,
  [SMALL_STATE(1371)] = 26201,
  [SMALL_STATE(1372)] = 26214,
  [SMALL_STATE(1373)] = 26227,
  [SMALL_STATE(1374)] = 26240,
  [SMALL_STATE(1375)] = 26253,
  [SMALL_STATE(1376)] = 26266,
  [SMALL_STATE(1377)] = 26279,
  [SMALL_STATE(1378)] = 26292,
  [SMALL_STATE(1379)] = 26305,
  [SMALL_STATE(1380)] = 26318,
  [SMALL_STATE(1381)] = 26331,
  [SMALL_STATE(1382)] = 26344,
  [SMALL_STATE(1383)] = 26357,
  [SMALL_STATE(1384)] = 26370,
  [SMALL_STATE(1385)] = 26383,
  [SMALL_STATE(1386)] = 26396,
  [SMALL_STATE(1387)] = 26409,
  [SMALL_STATE(1388)] = 26422,
  [SMALL_STATE(1389)] = 26435,
  [SMALL_STATE(1390)] = 26448,
  [SMALL_STATE(1391)] = 26461,
  [SMALL_STATE(1392)] = 26474,
  [SMALL_STATE(1393)] = 26487,
  [SMALL_STATE(1394)] = 26500,
  [SMALL_STATE(1395)] = 26513,
  [SMALL_STATE(1396)] = 26526,
  [SMALL_STATE(1397)] = 26539,
  [SMALL_STATE(1398)] = 26552,
  [SMALL_STATE(1399)] = 26565,
  [SMALL_STATE(1400)] = 26578,
  [SMALL_STATE(1401)] = 26591,
  [SMALL_STATE(1402)] = 26604,
  [SMALL_STATE(1403)] = 26617,
  [SMALL_STATE(1404)] = 26630,
  [SMALL_STATE(1405)] = 26643,
  [SMALL_STATE(1406)] = 26656,
  [SMALL_STATE(1407)] = 26669,
  [SMALL_STATE(1408)] = 26682,
  [SMALL_STATE(1409)] = 26695,
  [SMALL_STATE(1410)] = 26708,
  [SMALL_STATE(1411)] = 26721,
  [SMALL_STATE(1412)] = 26734,
  [SMALL_STATE(1413)] = 26747,
  [SMALL_STATE(1414)] = 26760,
  [SMALL_STATE(1415)] = 26773,
  [SMALL_STATE(1416)] = 26786,
  [SMALL_STATE(1417)] = 26799,
  [SMALL_STATE(1418)] = 26812,
  [SMALL_STATE(1419)] = 26825,
  [SMALL_STATE(1420)] = 26838,
  [SMALL_STATE(1421)] = 26851,
  [SMALL_STATE(1422)] = 26864,
  [SMALL_STATE(1423)] = 26877,
  [SMALL_STATE(1424)] = 26890,
  [SMALL_STATE(1425)] = 26903,
  [SMALL_STATE(1426)] = 26916,
  [SMALL_STATE(1427)] = 26929,
  [SMALL_STATE(1428)] = 26942,
  [SMALL_STATE(1429)] = 26955,
  [SMALL_STATE(1430)] = 26968,
  [SMALL_STATE(1431)] = 26981,
  [SMALL_STATE(1432)] = 26994,
  [SMALL_STATE(1433)] = 27007,
  [SMALL_STATE(1434)] = 27020,
  [SMALL_STATE(1435)] = 27033,
  [SMALL_STATE(1436)] = 27046,
  [SMALL_STATE(1437)] = 27059,
  [SMALL_STATE(1438)] = 27072,
  [SMALL_STATE(1439)] = 27085,
  [SMALL_STATE(1440)] = 27098,
  [SMALL_STATE(1441)] = 27111,
  [SMALL_STATE(1442)] = 27124,
  [SMALL_STATE(1443)] = 27137,
  [SMALL_STATE(1444)] = 27150,
  [SMALL_STATE(1445)] = 27163,
  [SMALL_STATE(1446)] = 27176,
  [SMALL_STATE(1447)] = 27189,
  [SMALL_STATE(1448)] = 27202,
  [SMALL_STATE(1449)] = 27215,
  [SMALL_STATE(1450)] = 27228,
  [SMALL_STATE(1451)] = 27241,
  [SMALL_STATE(1452)] = 27254,
  [SMALL_STATE(1453)] = 27267,
  [SMALL_STATE(1454)] = 27280,
  [SMALL_STATE(1455)] = 27293,
  [SMALL_STATE(1456)] = 27306,
  [SMALL_STATE(1457)] = 27319,
  [SMALL_STATE(1458)] = 27332,
  [SMALL_STATE(1459)] = 27345,
  [SMALL_STATE(1460)] = 27358,
  [SMALL_STATE(1461)] = 27371,
  [SMALL_STATE(1462)] = 27384,
  [SMALL_STATE(1463)] = 27397,
  [SMALL_STATE(1464)] = 27410,
  [SMALL_STATE(1465)] = 27423,
  [SMALL_STATE(1466)] = 27436,
  [SMALL_STATE(1467)] = 27449,
  [SMALL_STATE(1468)] = 27462,
  [SMALL_STATE(1469)] = 27475,
  [SMALL_STATE(1470)] = 27488,
  [SMALL_STATE(1471)] = 27496,
  [SMALL_STATE(1472)] = 27506,
  [SMALL_STATE(1473)] = 27516,
  [SMALL_STATE(1474)] = 27524,
  [SMALL_STATE(1475)] = 27532,
  [SMALL_STATE(1476)] = 27540,
  [SMALL_STATE(1477)] = 27548,
  [SMALL_STATE(1478)] = 27556,
  [SMALL_STATE(1479)] = 27564,
  [SMALL_STATE(1480)] = 27574,
  [SMALL_STATE(1481)] = 27582,
  [SMALL_STATE(1482)] = 27590,
  [SMALL_STATE(1483)] = 27600,
  [SMALL_STATE(1484)] = 27608,
  [SMALL_STATE(1485)] = 27618,
  [SMALL_STATE(1486)] = 27628,
  [SMALL_STATE(1487)] = 27638,
  [SMALL_STATE(1488)] = 27648,
  [SMALL_STATE(1489)] = 27658,
  [SMALL_STATE(1490)] = 27666,
  [SMALL_STATE(1491)] = 27674,
  [SMALL_STATE(1492)] = 27682,
  [SMALL_STATE(1493)] = 27690,
  [SMALL_STATE(1494)] = 27698,
  [SMALL_STATE(1495)] = 27706,
  [SMALL_STATE(1496)] = 27714,
  [SMALL_STATE(1497)] = 27722,
  [SMALL_STATE(1498)] = 27732,
  [SMALL_STATE(1499)] = 27742,
  [SMALL_STATE(1500)] = 27752,
  [SMALL_STATE(1501)] = 27760,
  [SMALL_STATE(1502)] = 27770,
  [SMALL_STATE(1503)] = 27778,
  [SMALL_STATE(1504)] = 27786,
  [SMALL_STATE(1505)] = 27794,
  [SMALL_STATE(1506)] = 27804,
  [SMALL_STATE(1507)] = 27812,
  [SMALL_STATE(1508)] = 27822,
  [SMALL_STATE(1509)] = 27832,
  [SMALL_STATE(1510)] = 27840,
  [SMALL_STATE(1511)] = 27850,
  [SMALL_STATE(1512)] = 27858,
  [SMALL_STATE(1513)] = 27868,
  [SMALL_STATE(1514)] = 27876,
  [SMALL_STATE(1515)] = 27884,
  [SMALL_STATE(1516)] = 27894,
  [SMALL_STATE(1517)] = 27902,
  [SMALL_STATE(1518)] = 27912,
  [SMALL_STATE(1519)] = 27920,
  [SMALL_STATE(1520)] = 27930,
  [SMALL_STATE(1521)] = 27938,
  [SMALL_STATE(1522)] = 27948,
  [SMALL_STATE(1523)] = 27956,
  [SMALL_STATE(1524)] = 27964,
  [SMALL_STATE(1525)] = 27974,
  [SMALL_STATE(1526)] = 27982,
  [SMALL_STATE(1527)] = 27990,
  [SMALL_STATE(1528)] = 27998,
  [SMALL_STATE(1529)] = 28006,
  [SMALL_STATE(1530)] = 28014,
  [SMALL_STATE(1531)] = 28024,
  [SMALL_STATE(1532)] = 28032,
  [SMALL_STATE(1533)] = 28040,
  [SMALL_STATE(1534)] = 28048,
  [SMALL_STATE(1535)] = 28058,
  [SMALL_STATE(1536)] = 28066,
  [SMALL_STATE(1537)] = 28074,
  [SMALL_STATE(1538)] = 28082,
  [SMALL_STATE(1539)] = 28090,
  [SMALL_STATE(1540)] = 28098,
  [SMALL_STATE(1541)] = 28106,
  [SMALL_STATE(1542)] = 28116,
  [SMALL_STATE(1543)] = 28126,
  [SMALL_STATE(1544)] = 28136,
  [SMALL_STATE(1545)] = 28144,
  [SMALL_STATE(1546)] = 28152,
  [SMALL_STATE(1547)] = 28160,
  [SMALL_STATE(1548)] = 28168,
  [SMALL_STATE(1549)] = 28176,
  [SMALL_STATE(1550)] = 28184,
  [SMALL_STATE(1551)] = 28192,
  [SMALL_STATE(1552)] = 28200,
  [SMALL_STATE(1553)] = 28210,
  [SMALL_STATE(1554)] = 28218,
  [SMALL_STATE(1555)] = 28226,
  [SMALL_STATE(1556)] = 28236,
  [SMALL_STATE(1557)] = 28244,
  [SMALL_STATE(1558)] = 28252,
  [SMALL_STATE(1559)] = 28262,
  [SMALL_STATE(1560)] = 28270,
  [SMALL_STATE(1561)] = 28278,
  [SMALL_STATE(1562)] = 28288,
  [SMALL_STATE(1563)] = 28296,
  [SMALL_STATE(1564)] = 28306,
  [SMALL_STATE(1565)] = 28316,
  [SMALL_STATE(1566)] = 28326,
  [SMALL_STATE(1567)] = 28336,
  [SMALL_STATE(1568)] = 28346,
  [SMALL_STATE(1569)] = 28356,
  [SMALL_STATE(1570)] = 28366,
  [SMALL_STATE(1571)] = 28376,
  [SMALL_STATE(1572)] = 28386,
  [SMALL_STATE(1573)] = 28396,
  [SMALL_STATE(1574)] = 28404,
  [SMALL_STATE(1575)] = 28414,
  [SMALL_STATE(1576)] = 28422,
  [SMALL_STATE(1577)] = 28430,
  [SMALL_STATE(1578)] = 28440,
  [SMALL_STATE(1579)] = 28448,
  [SMALL_STATE(1580)] = 28456,
  [SMALL_STATE(1581)] = 28464,
  [SMALL_STATE(1582)] = 28472,
  [SMALL_STATE(1583)] = 28480,
  [SMALL_STATE(1584)] = 28488,
  [SMALL_STATE(1585)] = 28496,
  [SMALL_STATE(1586)] = 28506,
  [SMALL_STATE(1587)] = 28516,
  [SMALL_STATE(1588)] = 28526,
  [SMALL_STATE(1589)] = 28536,
  [SMALL_STATE(1590)] = 28544,
  [SMALL_STATE(1591)] = 28552,
  [SMALL_STATE(1592)] = 28562,
  [SMALL_STATE(1593)] = 28570,
  [SMALL_STATE(1594)] = 28577,
  [SMALL_STATE(1595)] = 28584,
  [SMALL_STATE(1596)] = 28591,
  [SMALL_STATE(1597)] = 28598,
  [SMALL_STATE(1598)] = 28605,
  [SMALL_STATE(1599)] = 28612,
  [SMALL_STATE(1600)] = 28619,
  [SMALL_STATE(1601)] = 28626,
  [SMALL_STATE(1602)] = 28633,
  [SMALL_STATE(1603)] = 28640,
  [SMALL_STATE(1604)] = 28647,
  [SMALL_STATE(1605)] = 28654,
  [SMALL_STATE(1606)] = 28661,
  [SMALL_STATE(1607)] = 28668,
  [SMALL_STATE(1608)] = 28675,
  [SMALL_STATE(1609)] = 28682,
  [SMALL_STATE(1610)] = 28689,
  [SMALL_STATE(1611)] = 28696,
  [SMALL_STATE(1612)] = 28703,
  [SMALL_STATE(1613)] = 28710,
  [SMALL_STATE(1614)] = 28717,
  [SMALL_STATE(1615)] = 28724,
  [SMALL_STATE(1616)] = 28731,
  [SMALL_STATE(1617)] = 28738,
  [SMALL_STATE(1618)] = 28745,
  [SMALL_STATE(1619)] = 28752,
  [SMALL_STATE(1620)] = 28759,
  [SMALL_STATE(1621)] = 28766,
  [SMALL_STATE(1622)] = 28773,
  [SMALL_STATE(1623)] = 28780,
  [SMALL_STATE(1624)] = 28787,
  [SMALL_STATE(1625)] = 28794,
  [SMALL_STATE(1626)] = 28801,
  [SMALL_STATE(1627)] = 28808,
  [SMALL_STATE(1628)] = 28815,
  [SMALL_STATE(1629)] = 28822,
  [SMALL_STATE(1630)] = 28829,
  [SMALL_STATE(1631)] = 28836,
  [SMALL_STATE(1632)] = 28843,
  [SMALL_STATE(1633)] = 28850,
  [SMALL_STATE(1634)] = 28857,
  [SMALL_STATE(1635)] = 28864,
  [SMALL_STATE(1636)] = 28871,
  [SMALL_STATE(1637)] = 28878,
  [SMALL_STATE(1638)] = 28885,
  [SMALL_STATE(1639)] = 28892,
  [SMALL_STATE(1640)] = 28899,
  [SMALL_STATE(1641)] = 28906,
  [SMALL_STATE(1642)] = 28913,
  [SMALL_STATE(1643)] = 28920,
  [SMALL_STATE(1644)] = 28927,
  [SMALL_STATE(1645)] = 28934,
  [SMALL_STATE(1646)] = 28941,
  [SMALL_STATE(1647)] = 28948,
  [SMALL_STATE(1648)] = 28955,
  [SMALL_STATE(1649)] = 28962,
  [SMALL_STATE(1650)] = 28969,
  [SMALL_STATE(1651)] = 28976,
  [SMALL_STATE(1652)] = 28983,
  [SMALL_STATE(1653)] = 28990,
  [SMALL_STATE(1654)] = 28997,
  [SMALL_STATE(1655)] = 29004,
  [SMALL_STATE(1656)] = 29011,
  [SMALL_STATE(1657)] = 29018,
  [SMALL_STATE(1658)] = 29025,
  [SMALL_STATE(1659)] = 29032,
  [SMALL_STATE(1660)] = 29039,
  [SMALL_STATE(1661)] = 29046,
  [SMALL_STATE(1662)] = 29053,
  [SMALL_STATE(1663)] = 29060,
  [SMALL_STATE(1664)] = 29067,
  [SMALL_STATE(1665)] = 29074,
  [SMALL_STATE(1666)] = 29081,
  [SMALL_STATE(1667)] = 29088,
  [SMALL_STATE(1668)] = 29095,
  [SMALL_STATE(1669)] = 29102,
  [SMALL_STATE(1670)] = 29109,
  [SMALL_STATE(1671)] = 29116,
  [SMALL_STATE(1672)] = 29123,
  [SMALL_STATE(1673)] = 29130,
  [SMALL_STATE(1674)] = 29137,
  [SMALL_STATE(1675)] = 29144,
  [SMALL_STATE(1676)] = 29151,
  [SMALL_STATE(1677)] = 29158,
  [SMALL_STATE(1678)] = 29165,
  [SMALL_STATE(1679)] = 29172,
  [SMALL_STATE(1680)] = 29179,
  [SMALL_STATE(1681)] = 29186,
  [SMALL_STATE(1682)] = 29193,
  [SMALL_STATE(1683)] = 29200,
  [SMALL_STATE(1684)] = 29207,
  [SMALL_STATE(1685)] = 29214,
  [SMALL_STATE(1686)] = 29221,
  [SMALL_STATE(1687)] = 29228,
  [SMALL_STATE(1688)] = 29235,
  [SMALL_STATE(1689)] = 29242,
  [SMALL_STATE(1690)] = 29249,
  [SMALL_STATE(1691)] = 29256,
  [SMALL_STATE(1692)] = 29263,
  [SMALL_STATE(1693)] = 29270,
  [SMALL_STATE(1694)] = 29277,
  [SMALL_STATE(1695)] = 29284,
  [SMALL_STATE(1696)] = 29291,
  [SMALL_STATE(1697)] = 29298,
  [SMALL_STATE(1698)] = 29305,
  [SMALL_STATE(1699)] = 29312,
  [SMALL_STATE(1700)] = 29319,
  [SMALL_STATE(1701)] = 29326,
  [SMALL_STATE(1702)] = 29333,
  [SMALL_STATE(1703)] = 29340,
  [SMALL_STATE(1704)] = 29347,
  [SMALL_STATE(1705)] = 29354,
  [SMALL_STATE(1706)] = 29361,
  [SMALL_STATE(1707)] = 29368,
  [SMALL_STATE(1708)] = 29375,
  [SMALL_STATE(1709)] = 29382,
  [SMALL_STATE(1710)] = 29389,
  [SMALL_STATE(1711)] = 29396,
  [SMALL_STATE(1712)] = 29403,
  [SMALL_STATE(1713)] = 29410,
  [SMALL_STATE(1714)] = 29417,
  [SMALL_STATE(1715)] = 29424,
  [SMALL_STATE(1716)] = 29431,
  [SMALL_STATE(1717)] = 29438,
  [SMALL_STATE(1718)] = 29445,
  [SMALL_STATE(1719)] = 29452,
  [SMALL_STATE(1720)] = 29459,
  [SMALL_STATE(1721)] = 29466,
  [SMALL_STATE(1722)] = 29473,
  [SMALL_STATE(1723)] = 29480,
  [SMALL_STATE(1724)] = 29487,
  [SMALL_STATE(1725)] = 29494,
  [SMALL_STATE(1726)] = 29501,
  [SMALL_STATE(1727)] = 29508,
  [SMALL_STATE(1728)] = 29515,
  [SMALL_STATE(1729)] = 29522,
  [SMALL_STATE(1730)] = 29529,
  [SMALL_STATE(1731)] = 29536,
  [SMALL_STATE(1732)] = 29543,
  [SMALL_STATE(1733)] = 29550,
  [SMALL_STATE(1734)] = 29557,
  [SMALL_STATE(1735)] = 29564,
  [SMALL_STATE(1736)] = 29571,
  [SMALL_STATE(1737)] = 29578,
  [SMALL_STATE(1738)] = 29585,
  [SMALL_STATE(1739)] = 29592,
  [SMALL_STATE(1740)] = 29599,
  [SMALL_STATE(1741)] = 29606,
  [SMALL_STATE(1742)] = 29613,
  [SMALL_STATE(1743)] = 29620,
  [SMALL_STATE(1744)] = 29627,
  [SMALL_STATE(1745)] = 29634,
  [SMALL_STATE(1746)] = 29641,
  [SMALL_STATE(1747)] = 29648,
  [SMALL_STATE(1748)] = 29655,
  [SMALL_STATE(1749)] = 29662,
  [SMALL_STATE(1750)] = 29669,
  [SMALL_STATE(1751)] = 29676,
  [SMALL_STATE(1752)] = 29683,
  [SMALL_STATE(1753)] = 29690,
  [SMALL_STATE(1754)] = 29697,
  [SMALL_STATE(1755)] = 29704,
  [SMALL_STATE(1756)] = 29711,
  [SMALL_STATE(1757)] = 29718,
  [SMALL_STATE(1758)] = 29725,
  [SMALL_STATE(1759)] = 29732,
  [SMALL_STATE(1760)] = 29739,
  [SMALL_STATE(1761)] = 29746,
  [SMALL_STATE(1762)] = 29753,
  [SMALL_STATE(1763)] = 29760,
  [SMALL_STATE(1764)] = 29767,
  [SMALL_STATE(1765)] = 29774,
  [SMALL_STATE(1766)] = 29781,
  [SMALL_STATE(1767)] = 29788,
  [SMALL_STATE(1768)] = 29795,
  [SMALL_STATE(1769)] = 29802,
  [SMALL_STATE(1770)] = 29809,
  [SMALL_STATE(1771)] = 29816,
  [SMALL_STATE(1772)] = 29823,
  [SMALL_STATE(1773)] = 29830,
  [SMALL_STATE(1774)] = 29837,
  [SMALL_STATE(1775)] = 29844,
  [SMALL_STATE(1776)] = 29851,
  [SMALL_STATE(1777)] = 29858,
  [SMALL_STATE(1778)] = 29865,
  [SMALL_STATE(1779)] = 29872,
  [SMALL_STATE(1780)] = 29879,
  [SMALL_STATE(1781)] = 29886,
  [SMALL_STATE(1782)] = 29893,
  [SMALL_STATE(1783)] = 29900,
  [SMALL_STATE(1784)] = 29907,
  [SMALL_STATE(1785)] = 29914,
  [SMALL_STATE(1786)] = 29921,
  [SMALL_STATE(1787)] = 29928,
  [SMALL_STATE(1788)] = 29935,
  [SMALL_STATE(1789)] = 29942,
  [SMALL_STATE(1790)] = 29949,
  [SMALL_STATE(1791)] = 29956,
  [SMALL_STATE(1792)] = 29963,
  [SMALL_STATE(1793)] = 29970,
  [SMALL_STATE(1794)] = 29977,
  [SMALL_STATE(1795)] = 29984,
  [SMALL_STATE(1796)] = 29991,
  [SMALL_STATE(1797)] = 29998,
  [SMALL_STATE(1798)] = 30005,
  [SMALL_STATE(1799)] = 30012,
  [SMALL_STATE(1800)] = 30019,
  [SMALL_STATE(1801)] = 30026,
  [SMALL_STATE(1802)] = 30033,
  [SMALL_STATE(1803)] = 30040,
  [SMALL_STATE(1804)] = 30047,
  [SMALL_STATE(1805)] = 30054,
  [SMALL_STATE(1806)] = 30061,
  [SMALL_STATE(1807)] = 30068,
  [SMALL_STATE(1808)] = 30075,
  [SMALL_STATE(1809)] = 30082,
  [SMALL_STATE(1810)] = 30089,
  [SMALL_STATE(1811)] = 30096,
  [SMALL_STATE(1812)] = 30103,
  [SMALL_STATE(1813)] = 30110,
  [SMALL_STATE(1814)] = 30117,
  [SMALL_STATE(1815)] = 30124,
  [SMALL_STATE(1816)] = 30131,
  [SMALL_STATE(1817)] = 30138,
  [SMALL_STATE(1818)] = 30145,
  [SMALL_STATE(1819)] = 30152,
  [SMALL_STATE(1820)] = 30159,
  [SMALL_STATE(1821)] = 30166,
  [SMALL_STATE(1822)] = 30173,
  [SMALL_STATE(1823)] = 30180,
  [SMALL_STATE(1824)] = 30187,
  [SMALL_STATE(1825)] = 30194,
  [SMALL_STATE(1826)] = 30201,
  [SMALL_STATE(1827)] = 30208,
  [SMALL_STATE(1828)] = 30215,
  [SMALL_STATE(1829)] = 30222,
  [SMALL_STATE(1830)] = 30229,
  [SMALL_STATE(1831)] = 30236,
  [SMALL_STATE(1832)] = 30243,
  [SMALL_STATE(1833)] = 30250,
  [SMALL_STATE(1834)] = 30257,
  [SMALL_STATE(1835)] = 30264,
  [SMALL_STATE(1836)] = 30271,
  [SMALL_STATE(1837)] = 30278,
  [SMALL_STATE(1838)] = 30285,
  [SMALL_STATE(1839)] = 30292,
  [SMALL_STATE(1840)] = 30299,
  [SMALL_STATE(1841)] = 30306,
  [SMALL_STATE(1842)] = 30313,
  [SMALL_STATE(1843)] = 30320,
  [SMALL_STATE(1844)] = 30327,
  [SMALL_STATE(1845)] = 30334,
  [SMALL_STATE(1846)] = 30341,
  [SMALL_STATE(1847)] = 30348,
  [SMALL_STATE(1848)] = 30355,
  [SMALL_STATE(1849)] = 30362,
  [SMALL_STATE(1850)] = 30369,
  [SMALL_STATE(1851)] = 30376,
  [SMALL_STATE(1852)] = 30383,
  [SMALL_STATE(1853)] = 30390,
  [SMALL_STATE(1854)] = 30397,
  [SMALL_STATE(1855)] = 30404,
  [SMALL_STATE(1856)] = 30411,
  [SMALL_STATE(1857)] = 30418,
  [SMALL_STATE(1858)] = 30425,
  [SMALL_STATE(1859)] = 30432,
  [SMALL_STATE(1860)] = 30439,
  [SMALL_STATE(1861)] = 30446,
  [SMALL_STATE(1862)] = 30453,
  [SMALL_STATE(1863)] = 30460,
  [SMALL_STATE(1864)] = 30467,
  [SMALL_STATE(1865)] = 30474,
  [SMALL_STATE(1866)] = 30481,
  [SMALL_STATE(1867)] = 30488,
  [SMALL_STATE(1868)] = 30495,
  [SMALL_STATE(1869)] = 30502,
  [SMALL_STATE(1870)] = 30509,
  [SMALL_STATE(1871)] = 30516,
  [SMALL_STATE(1872)] = 30523,
  [SMALL_STATE(1873)] = 30530,
  [SMALL_STATE(1874)] = 30537,
  [SMALL_STATE(1875)] = 30544,
  [SMALL_STATE(1876)] = 30551,
  [SMALL_STATE(1877)] = 30558,
  [SMALL_STATE(1878)] = 30565,
  [SMALL_STATE(1879)] = 30572,
  [SMALL_STATE(1880)] = 30579,
  [SMALL_STATE(1881)] = 30586,
  [SMALL_STATE(1882)] = 30593,
  [SMALL_STATE(1883)] = 30600,
  [SMALL_STATE(1884)] = 30607,
  [SMALL_STATE(1885)] = 30614,
  [SMALL_STATE(1886)] = 30621,
  [SMALL_STATE(1887)] = 30628,
  [SMALL_STATE(1888)] = 30635,
  [SMALL_STATE(1889)] = 30642,
  [SMALL_STATE(1890)] = 30649,
  [SMALL_STATE(1891)] = 30656,
  [SMALL_STATE(1892)] = 30663,
  [SMALL_STATE(1893)] = 30670,
  [SMALL_STATE(1894)] = 30677,
  [SMALL_STATE(1895)] = 30684,
  [SMALL_STATE(1896)] = 30691,
  [SMALL_STATE(1897)] = 30698,
  [SMALL_STATE(1898)] = 30705,
  [SMALL_STATE(1899)] = 30712,
  [SMALL_STATE(1900)] = 30719,
  [SMALL_STATE(1901)] = 30726,
  [SMALL_STATE(1902)] = 30733,
  [SMALL_STATE(1903)] = 30740,
  [SMALL_STATE(1904)] = 30747,
  [SMALL_STATE(1905)] = 30754,
  [SMALL_STATE(1906)] = 30761,
  [SMALL_STATE(1907)] = 30768,
  [SMALL_STATE(1908)] = 30775,
  [SMALL_STATE(1909)] = 30782,
  [SMALL_STATE(1910)] = 30789,
  [SMALL_STATE(1911)] = 30796,
  [SMALL_STATE(1912)] = 30803,
  [SMALL_STATE(1913)] = 30810,
  [SMALL_STATE(1914)] = 30817,
  [SMALL_STATE(1915)] = 30824,
  [SMALL_STATE(1916)] = 30831,
  [SMALL_STATE(1917)] = 30838,
  [SMALL_STATE(1918)] = 30845,
  [SMALL_STATE(1919)] = 30852,
  [SMALL_STATE(1920)] = 30859,
  [SMALL_STATE(1921)] = 30866,
  [SMALL_STATE(1922)] = 30873,
  [SMALL_STATE(1923)] = 30880,
  [SMALL_STATE(1924)] = 30887,
  [SMALL_STATE(1925)] = 30894,
  [SMALL_STATE(1926)] = 30901,
  [SMALL_STATE(1927)] = 30908,
  [SMALL_STATE(1928)] = 30915,
  [SMALL_STATE(1929)] = 30922,
  [SMALL_STATE(1930)] = 30929,
  [SMALL_STATE(1931)] = 30936,
  [SMALL_STATE(1932)] = 30943,
  [SMALL_STATE(1933)] = 30950,
  [SMALL_STATE(1934)] = 30957,
  [SMALL_STATE(1935)] = 30964,
  [SMALL_STATE(1936)] = 30971,
  [SMALL_STATE(1937)] = 30978,
  [SMALL_STATE(1938)] = 30985,
  [SMALL_STATE(1939)] = 30992,
  [SMALL_STATE(1940)] = 30999,
  [SMALL_STATE(1941)] = 31006,
  [SMALL_STATE(1942)] = 31013,
  [SMALL_STATE(1943)] = 31020,
  [SMALL_STATE(1944)] = 31027,
  [SMALL_STATE(1945)] = 31034,
  [SMALL_STATE(1946)] = 31041,
  [SMALL_STATE(1947)] = 31048,
  [SMALL_STATE(1948)] = 31055,
  [SMALL_STATE(1949)] = 31062,
  [SMALL_STATE(1950)] = 31069,
  [SMALL_STATE(1951)] = 31076,
  [SMALL_STATE(1952)] = 31083,
  [SMALL_STATE(1953)] = 31090,
  [SMALL_STATE(1954)] = 31097,
  [SMALL_STATE(1955)] = 31104,
  [SMALL_STATE(1956)] = 31111,
  [SMALL_STATE(1957)] = 31118,
  [SMALL_STATE(1958)] = 31125,
  [SMALL_STATE(1959)] = 31132,
  [SMALL_STATE(1960)] = 31139,
  [SMALL_STATE(1961)] = 31146,
  [SMALL_STATE(1962)] = 31153,
  [SMALL_STATE(1963)] = 31160,
  [SMALL_STATE(1964)] = 31167,
  [SMALL_STATE(1965)] = 31174,
  [SMALL_STATE(1966)] = 31181,
  [SMALL_STATE(1967)] = 31188,
  [SMALL_STATE(1968)] = 31195,
  [SMALL_STATE(1969)] = 31202,
  [SMALL_STATE(1970)] = 31209,
  [SMALL_STATE(1971)] = 31216,
  [SMALL_STATE(1972)] = 31223,
  [SMALL_STATE(1973)] = 31230,
  [SMALL_STATE(1974)] = 31237,
  [SMALL_STATE(1975)] = 31244,
  [SMALL_STATE(1976)] = 31251,
  [SMALL_STATE(1977)] = 31258,
  [SMALL_STATE(1978)] = 31265,
  [SMALL_STATE(1979)] = 31272,
  [SMALL_STATE(1980)] = 31279,
  [SMALL_STATE(1981)] = 31286,
  [SMALL_STATE(1982)] = 31293,
  [SMALL_STATE(1983)] = 31300,
  [SMALL_STATE(1984)] = 31307,
  [SMALL_STATE(1985)] = 31314,
  [SMALL_STATE(1986)] = 31321,
  [SMALL_STATE(1987)] = 31328,
  [SMALL_STATE(1988)] = 31335,
  [SMALL_STATE(1989)] = 31342,
  [SMALL_STATE(1990)] = 31349,
  [SMALL_STATE(1991)] = 31356,
  [SMALL_STATE(1992)] = 31363,
  [SMALL_STATE(1993)] = 31370,
  [SMALL_STATE(1994)] = 31377,
  [SMALL_STATE(1995)] = 31384,
  [SMALL_STATE(1996)] = 31391,
  [SMALL_STATE(1997)] = 31398,
  [SMALL_STATE(1998)] = 31405,
  [SMALL_STATE(1999)] = 31412,
  [SMALL_STATE(2000)] = 31419,
  [SMALL_STATE(2001)] = 31426,
  [SMALL_STATE(2002)] = 31433,
  [SMALL_STATE(2003)] = 31440,
  [SMALL_STATE(2004)] = 31447,
  [SMALL_STATE(2005)] = 31454,
  [SMALL_STATE(2006)] = 31461,
  [SMALL_STATE(2007)] = 31468,
  [SMALL_STATE(2008)] = 31475,
  [SMALL_STATE(2009)] = 31482,
  [SMALL_STATE(2010)] = 31489,
  [SMALL_STATE(2011)] = 31496,
  [SMALL_STATE(2012)] = 31503,
  [SMALL_STATE(2013)] = 31510,
  [SMALL_STATE(2014)] = 31517,
  [SMALL_STATE(2015)] = 31524,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [35] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(116),
  [38] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_and_value, 1, 0, 0),
  [40] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(92),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [49] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(245),
  [52] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(242),
  [55] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(242),
  [58] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(244),
  [61] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(244),
  [64] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(248),
  [67] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(247),
  [70] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_and_value, 1, 0, 0),
  [72] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(781),
  [75] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(782),
  [78] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(783),
  [81] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(785),
  [84] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [86] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [88] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [90] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [92] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [94] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [96] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [98] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_keyword, 1, 0, 0),
  [118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_keyword, 1, 0, 0),
  [124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1574),
  [140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [142] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(148),
  [145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(164),
  [148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(248),
  [162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(247),
  [164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(800),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(1950),
  [176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(2004),
  [179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(2005),
  [182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(2006),
  [185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(1146),
  [188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(1145),
  [191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(1083),
  [194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(1270),
  [197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(1951),
  [200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(2007),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1952),
  [205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(752),
  [208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(753),
  [211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(1086),
  [214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1519),
  [234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 0),
  [236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1, 0, 0),
  [238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1815),
  [242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 2, 0, 0),
  [246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 2, 0, 0),
  [248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2, 0, 0),
  [252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_repeat2, 2, 0, 0),
  [254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2, 0, 0), SHIFT_REPEAT(1183),
  [257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_repeat2, 2, 0, 0), SHIFT_REPEAT(1755),
  [260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2, 0, 0), SHIFT_REPEAT(766),
  [263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 3, 0, 0),
  [265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 3, 0, 0),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_repeat1, 2, 0, 0),
  [271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_repeat1, 2, 0, 0),
  [273] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat1, 2, 0, 0), SHIFT_REPEAT(11),
  [276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1755),
  [279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_packed_struct_type, 3, 0, 0),
  [281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_packed_struct_type, 3, 0, 0),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1585),
  [305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(344),
  [308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(361),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_type, 3, 0, 0),
  [361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_type, 3, 0, 0),
  [363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0),
  [365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 0),
  [367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vector_type, 3, 0, 0),
  [369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vector_type, 3, 0, 0),
  [371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 0),
  [373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 0),
  [375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_type, 2, 0, 0),
  [377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_type, 2, 0, 0),
  [379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_packed_struct_type, 2, 0, 0),
  [381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_packed_struct_type, 2, 0, 0),
  [383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_addrspace, 4, 0, 0),
  [393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_addrspace, 4, 0, 0),
  [395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 4, 0, 0),
  [397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 4, 0, 0),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1861),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2, 0, 0), SHIFT_REPEAT(1189),
  [410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2, 0, 0), SHIFT_REPEAT(763),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [417] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat1, 2, 0, 0), SHIFT_REPEAT(35),
  [420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(804),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(811),
  [436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1208),
  [452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 1, 0, 0),
  [454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 2, 0, 0),
  [484] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2, 0, 0), SHIFT_REPEAT(1186),
  [487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2, 0, 0), SHIFT_REPEAT(768),
  [490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1837),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat1, 2, 0, 0), SHIFT_REPEAT(68),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata_ref, 1, 0, 0),
  [507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata_ref, 1, 0, 0),
  [509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_fcmp, 8, 0, 3),
  [511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_fcmp, 8, 0, 3),
  [513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_fneg, 4, 0, 3),
  [515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_fneg, 4, 0, 3),
  [517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vector_value, 3, 0, 0),
  [519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vector_value, 3, 0, 0),
  [521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_expr, 1, 0, 0),
  [523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_expr, 1, 0, 0),
  [525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_cast, 6, 0, 3),
  [527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_cast, 6, 0, 3),
  [529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_value, 3, 0, 0),
  [531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_value, 3, 0, 0),
  [533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_value, 2, 0, 0),
  [535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_value, 2, 0, 0),
  [537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vector_value, 2, 0, 0),
  [539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vector_value, 2, 0, 0),
  [541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value, 1, 0, 0),
  [543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value, 1, 0, 0),
  [545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_packed_struct_value, 3, 0, 0),
  [547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_packed_struct_value, 3, 0, 0),
  [549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_getelementptr, 13, 0, 3),
  [551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_getelementptr, 13, 0, 3),
  [553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_getelementptr, 12, 0, 3),
  [555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_getelementptr, 12, 0, 3),
  [557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_getelementptr, 11, 0, 3),
  [559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_getelementptr, 11, 0, 3),
  [561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_getelementptr, 10, 0, 3),
  [563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_getelementptr, 10, 0, 3),
  [565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_value, 4, 0, 0),
  [567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_value, 4, 0, 0),
  [569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_bin_op, 6, 0, 3),
  [571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_bin_op, 6, 0, 3),
  [573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_specialized_md, 1, 0, 0),
  [575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_specialized_md, 1, 0, 0),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_value, 3, 0, 0),
  [581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_value, 3, 0, 0),
  [583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_insertvalue, 9, 0, 3),
  [585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_insertvalue, 9, 0, 3),
  [587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_fneg, 5, 0, 3),
  [589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_fneg, 5, 0, 3),
  [591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_getelementptr, 5, 0, 3),
  [593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_getelementptr, 5, 0, 3),
  [595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value, 2, 0, 0),
  [597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value, 2, 0, 0),
  [599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_packed_struct_value, 4, 0, 0),
  [601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_packed_struct_value, 4, 0, 0),
  [603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_packed_struct_value, 2, 0, 0),
  [605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_packed_struct_value, 2, 0, 0),
  [607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_value, 4, 0, 0),
  [609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_value, 4, 0, 0),
  [611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_shufflevector, 8, 0, 3),
  [613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_shufflevector, 8, 0, 3),
  [615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vector_value, 4, 0, 0),
  [617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vector_value, 4, 0, 0),
  [619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_blockaddress, 6, 0, 0),
  [621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_blockaddress, 6, 0, 0),
  [623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_insertvalue, 8, 0, 3),
  [625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_insertvalue, 8, 0, 3),
  [627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_insertelement, 8, 0, 3),
  [629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_insertelement, 8, 0, 3),
  [631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_extractvalue, 6, 0, 3),
  [633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_extractvalue, 6, 0, 3),
  [635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_value, 2, 0, 0),
  [637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_value, 2, 0, 0),
  [639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var, 1, 0, 0),
  [641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var, 1, 0, 0),
  [643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_bin_op, 7, 0, 3),
  [645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_bin_op, 7, 0, 3),
  [647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_extractvalue, 7, 0, 3),
  [649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_extractvalue, 7, 0, 3),
  [651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_getelementptr, 4, 0, 3),
  [653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_getelementptr, 4, 0, 3),
  [655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_getelementptr, 7, 0, 3),
  [657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_getelementptr, 7, 0, 3),
  [659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_fcmp, 7, 0, 3),
  [661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_fcmp, 7, 0, 3),
  [663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_icmp, 7, 0, 3),
  [665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_icmp, 7, 0, 3),
  [667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_extractelement, 6, 0, 3),
  [669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_extractelement, 6, 0, 3),
  [671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_select, 8, 0, 3),
  [673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_select, 8, 0, 3),
  [675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_getelementptr, 6, 0, 3),
  [677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_getelementptr, 6, 0, 3),
  [679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_and_value, 2, 0, 0),
  [681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_and_value, 2, 0, 0),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_specialized_md, 4, 0, 0),
  [687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_specialized_md, 4, 0, 0),
  [689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata_tuple, 4, 0, 0),
  [691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata_tuple, 4, 0, 0),
  [693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_specialized_md, 3, 0, 0),
  [695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_specialized_md, 3, 0, 0),
  [697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata, 2, 0, 0),
  [699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata, 2, 0, 0),
  [701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata_tuple, 3, 0, 0),
  [703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata_tuple, 3, 0, 0),
  [705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata, 1, 0, 0),
  [707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata, 1, 0, 0),
  [709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata_tuple, 5, 0, 0),
  [711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata_tuple, 5, 0, 0),
  [713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number, 1, 0, 0),
  [715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_number, 1, 0, 0),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1332),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 4, 0, 15),
  [733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1712),
  [741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1836),
  [751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 4, 0, 15),
  [753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 4, 0, 12),
  [755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 4, 0, 12),
  [757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 5, 0, 16),
  [759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 5, 0, 16),
  [761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 5, 0, 15),
  [763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 5, 0, 15),
  [765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 7, 0, 17),
  [767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 7, 0, 17),
  [769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 3, 0, 12),
  [771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 3, 0, 12),
  [773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 6, 0, 17),
  [775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 6, 0, 17),
  [777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 6, 0, 16),
  [779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 6, 0, 16),
  [781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat3, 2, 0, 0), SHIFT_REPEAT(209),
  [784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_header_repeat3, 2, 0, 0),
  [786] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat3, 2, 0, 0), SHIFT_REPEAT(209),
  [789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat3, 2, 0, 0), SHIFT_REPEAT(199),
  [792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat3, 2, 0, 0), SHIFT_REPEAT(1712),
  [795] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat3, 2, 0, 0), SHIFT_REPEAT(212),
  [798] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat3, 2, 0, 0), SHIFT_REPEAT(1028),
  [801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat3, 2, 0, 0), SHIFT_REPEAT(211),
  [804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat3, 2, 0, 0), SHIFT_REPEAT(210),
  [807] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat3, 2, 0, 0), SHIFT_REPEAT(1836),
  [810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_header_repeat3, 2, 0, 0),
  [812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_name, 1, 0, 0),
  [814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_name, 1, 0, 0),
  [816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_header_repeat2, 2, 0, 0),
  [818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_header_repeat2, 2, 0, 0),
  [820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat2, 2, 0, 0), SHIFT_REPEAT(213),
  [823] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat2, 2, 0, 0), SHIFT_REPEAT(216),
  [826] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat2, 2, 0, 0), SHIFT_REPEAT(216),
  [829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat2, 2, 0, 0), SHIFT_REPEAT(219),
  [832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat2, 2, 0, 0), SHIFT_REPEAT(1776),
  [835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uwtable, 4, 0, 0),
  [837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_uwtable, 4, 0, 0),
  [839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_memory_attribute, 5, 0, 0),
  [841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_memory_attribute, 5, 0, 0),
  [843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_memory_attribute, 6, 0, 0),
  [845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_memory_attribute, 6, 0, 0),
  [847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_memory_attribute, 4, 0, 0),
  [849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_memory_attribute, 4, 0, 0),
  [851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_memory_attribute, 7, 0, 0),
  [853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_memory_attribute, 7, 0, 0),
  [855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 0),
  [857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 1, 0, 0),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uwtable, 1, 0, 0),
  [865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_uwtable, 1, 0, 0),
  [867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_uwtable, 1, 0, 0), SHIFT(1546),
  [870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignment, 2, 0, 0),
  [878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignment, 2, 0, 0),
  [880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 4, 0, 0),
  [882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 4, 0, 0),
  [884] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_uwtable, 1, 0, 0), SHIFT(1578),
  [887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 5, 0, 0),
  [889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 5, 0, 0),
  [891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, 0, 0),
  [893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 2, 0, 0),
  [895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_param_or_return_attrs, 1, 0, 0),
  [897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_param_or_return_attrs, 1, 0, 0),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, 0, 0),
  [903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 3, 0, 0),
  [905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_param_or_return_attrs, 4, 0, 0),
  [907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_param_or_return_attrs, 4, 0, 0),
  [909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_param_or_return_attrs, 2, 0, 0),
  [911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_param_or_return_attrs, 2, 0, 0),
  [913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_header_repeat1, 2, 0, 0),
  [915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat1, 2, 0, 0), SHIFT_REPEAT(245),
  [918] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat1, 2, 0, 0), SHIFT_REPEAT(242),
  [921] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat1, 2, 0, 0), SHIFT_REPEAT(242),
  [924] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat1, 2, 0, 0), SHIFT_REPEAT(244),
  [927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat1, 2, 0, 0), SHIFT_REPEAT(244),
  [930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat1, 2, 0, 0), SHIFT_REPEAT(248),
  [933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat1, 2, 0, 0), SHIFT_REPEAT(247),
  [936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_header_repeat1, 2, 0, 0),
  [938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1212),
  [952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declare_repeat1, 2, 0, 0),
  [954] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declare_repeat1, 2, 0, 0), SHIFT_REPEAT(1085),
  [957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declare_repeat1, 2, 0, 0),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_linkage_aux, 1, 0, 0),
  [969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_linkage_aux, 1, 0, 0),
  [971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata_attachment, 2, 0, 0),
  [973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata_attachment, 2, 0, 0),
  [975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dso_local, 1, 0, 0),
  [977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dso_local, 1, 0, 0),
  [979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_linkage, 1, 0, 0),
  [981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_linkage, 1, 0, 0),
  [983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dll_storage_class, 1, 0, 0),
  [985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dll_storage_class, 1, 0, 0),
  [987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility, 1, 0, 0),
  [989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility, 1, 0, 0),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_select_repeat1, 2, 0, 0),
  [995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instruction_select_repeat1, 2, 0, 0),
  [997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_select_repeat1, 2, 0, 0), SHIFT_REPEAT(255),
  [1000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_instruction_select_repeat1, 2, 0, 0), SHIFT_REPEAT(255),
  [1003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fast_math, 1, 0, 0),
  [1005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fast_math, 1, 0, 0),
  [1007] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2, 0, 0), SHIFT_REPEAT(1187),
  [1010] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2, 0, 0), SHIFT_REPEAT(761),
  [1013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat1, 2, 0, 0), SHIFT_REPEAT(258),
  [1016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [1018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [1020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [1022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [1024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [1026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_uwtable, 1, 0, 0), SHIFT(1493),
  [1029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(805),
  [1032] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_and_value, 1, 0, 0), SHIFT(802),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [1043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2, 0, 0), SHIFT_REPEAT(1190),
  [1046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2, 0, 0), SHIFT_REPEAT(773),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [1055] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat1, 2, 0, 0), SHIFT_REPEAT(293),
  [1058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [1060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unnamed_addr, 1, 0, 0),
  [1062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unnamed_addr, 1, 0, 0),
  [1064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [1066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [1068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [1070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [1072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [1074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [1076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [1078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [1080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(900),
  [1082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(899),
  [1084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [1086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [1088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [1090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [1092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [1094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [1096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [1098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [1100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1695),
  [1102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1698),
  [1104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1566),
  [1106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [1108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1563),
  [1110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [1112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [1114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [1116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [1118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [1120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1073),
  [1122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1720),
  [1124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [1126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [1128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [1130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [1132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [1134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1103),
  [1136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [1138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [1140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [1142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(943),
  [1144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [1146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [1148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [1150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [1152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1647),
  [1155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(369),
  [1158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0),
  [1160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(645),
  [1163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(902),
  [1166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(901),
  [1169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(900),
  [1172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(899),
  [1175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(898),
  [1178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(893),
  [1181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(892),
  [1184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(734),
  [1187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(891),
  [1190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(730),
  [1193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(889),
  [1196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(251),
  [1199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1695),
  [1202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1698),
  [1205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1566),
  [1208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1564),
  [1211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1563),
  [1214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(252),
  [1217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1143),
  [1220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1054),
  [1223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(881),
  [1226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(736),
  [1229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1073),
  [1232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1720),
  [1235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(241),
  [1238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(851),
  [1241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(850),
  [1244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(759),
  [1247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(776),
  [1250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1103),
  [1253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1158),
  [1256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(774),
  [1259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(910),
  [1262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(943),
  [1265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(752),
  [1268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(753),
  [1271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1086),
  [1274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_body_repeat1, 2, 0, 0),
  [1276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [1278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [1280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [1282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [1284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [1286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [1290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [1292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1211),
  [1294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [1296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1507),
  [1298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [1300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [1302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [1304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [1306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [1308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [1310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [1312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [1314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [1316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [1318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [1320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [1322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [1324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [1326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [1328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [1330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [1332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [1334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [1338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [1340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [1342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [1344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [1346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [1348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [1352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [1354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [1360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [1362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [1364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [1366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [1368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [1370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 7, 0, 14),
  [1372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [1374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [1376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [1382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 7, 0, 14),
  [1384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat2, 2, 0, 0), SHIFT_REPEAT(417),
  [1387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat2, 2, 0, 0), SHIFT_REPEAT(274),
  [1390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat2, 2, 0, 0), SHIFT_REPEAT(274),
  [1393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat2, 2, 0, 0), SHIFT_REPEAT(279),
  [1396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat2, 2, 0, 0), SHIFT_REPEAT(1923),
  [1399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 4, 0, 6),
  [1401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 4, 0, 6),
  [1403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 5, 0, 8),
  [1405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 5, 0, 8),
  [1407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 3, 0, 2),
  [1409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 3, 0, 2),
  [1411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 6, 0, 11),
  [1413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 6, 0, 11),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [1483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias, 6, 0, 0),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [1487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias, 6, 0, 0),
  [1489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_global, 4, 0, 0),
  [1491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_global, 4, 0, 0),
  [1493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_global, 3, 0, 0),
  [1495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_global, 3, 0, 0),
  [1497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ifunc, 6, 0, 0),
  [1499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ifunc, 6, 0, 0),
  [1501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ifunc, 7, 0, 0),
  [1503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ifunc, 7, 0, 0),
  [1505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ifunc, 5, 0, 0),
  [1507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ifunc, 5, 0, 0),
  [1509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias, 7, 0, 0),
  [1511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias, 7, 0, 0),
  [1513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias, 5, 0, 0),
  [1515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias, 5, 0, 0),
  [1517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 6, 0, 8),
  [1519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 6, 0, 8),
  [1521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 7, 0, 11),
  [1523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 7, 0, 11),
  [1525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 8, 0, 14),
  [1527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 8, 0, 14),
  [1529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 5, 0, 6),
  [1531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 5, 0, 6),
  [1533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 4, 0, 2),
  [1535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 4, 0, 2),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [1541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [1543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_global_global_repeat1, 2, 0, 0),
  [1545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_global_repeat1, 2, 0, 0), SHIFT_REPEAT(434),
  [1548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_global_repeat1, 2, 0, 0), SHIFT_REPEAT(542),
  [1551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_global_global_repeat1, 2, 0, 0), SHIFT_REPEAT(415),
  [1554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_global_repeat1, 2, 0, 0), SHIFT_REPEAT(1997),
  [1557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_global_repeat1, 2, 0, 0), SHIFT_REPEAT(452),
  [1560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_global_repeat1, 2, 0, 0), SHIFT_REPEAT(1018),
  [1563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_global_repeat1, 2, 0, 0), SHIFT_REPEAT(274),
  [1566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_global_global_repeat1, 2, 0, 0), SHIFT_REPEAT(274),
  [1569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_global_repeat1, 2, 0, 0), SHIFT_REPEAT(279),
  [1572] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_global_repeat1, 2, 0, 0), SHIFT_REPEAT(1923),
  [1575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_global_global_repeat1, 2, 0, 0),
  [1577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 9, 0, 14),
  [1579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 9, 0, 14),
  [1581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 9, 0, 11),
  [1583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 9, 0, 11),
  [1585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 8, 0, 8),
  [1587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 8, 0, 8),
  [1589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat3, 2, 0, 0), SHIFT_REPEAT(434),
  [1592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat3, 2, 0, 0), SHIFT_REPEAT(415),
  [1595] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat3, 2, 0, 0), SHIFT_REPEAT(1997),
  [1598] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat3, 2, 0, 0), SHIFT_REPEAT(452),
  [1601] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat3, 2, 0, 0), SHIFT_REPEAT(1018),
  [1604] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat3, 2, 0, 0), SHIFT_REPEAT(274),
  [1607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat3, 2, 0, 0), SHIFT_REPEAT(274),
  [1610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat3, 2, 0, 0), SHIFT_REPEAT(279),
  [1613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat3, 2, 0, 0), SHIFT_REPEAT(1923),
  [1616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 5, 0, 2),
  [1618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 5, 0, 2),
  [1620] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_summary_entry_repeat1, 2, 0, 0), SHIFT_REPEAT(490),
  [1623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_summary_entry_repeat1, 2, 0, 0), SHIFT_REPEAT(491),
  [1626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_summary_entry_repeat1, 2, 0, 0), SHIFT_REPEAT(495),
  [1629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_summary_entry_repeat1, 2, 0, 0), SHIFT_REPEAT(473),
  [1632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_summary_entry_repeat1, 2, 0, 0),
  [1634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_summary_entry_repeat1, 2, 0, 0), SHIFT_REPEAT(472),
  [1637] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_summary_entry_repeat1, 2, 0, 0), SHIFT_REPEAT(493),
  [1640] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_summary_entry_repeat1, 2, 0, 0), SHIFT_REPEAT(489),
  [1643] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_summary_entry_repeat1, 2, 0, 0), SHIFT_REPEAT(1814),
  [1646] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_summary_entry_repeat1, 2, 0, 0), SHIFT_REPEAT(490),
  [1649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 8, 0, 11),
  [1651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 8, 0, 11),
  [1653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 6, 0, 6),
  [1655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 6, 0, 6),
  [1657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [1659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 7, 0, 8),
  [1661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 7, 0, 8),
  [1663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 10, 0, 14),
  [1665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 10, 0, 14),
  [1667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 7, 0, 6),
  [1669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 7, 0, 6),
  [1671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_header, 6, 0, 2),
  [1673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_header, 6, 0, 2),
  [1675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [1679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [1681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [1683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [1687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [1689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [1691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1814),
  [1693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [1695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [1701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_calling_conv, 1, 0, 0),
  [1703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_calling_conv, 1, 0, 0),
  [1705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_calling_conv, 2, 0, 0),
  [1707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_calling_conv, 2, 0, 0),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [1711] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_uwtable, 1, 0, 0), SHIFT(1559),
  [1714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_summary_value, 1, 0, 0),
  [1716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_summary_value, 1, 0, 0),
  [1718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_summary_value, 2, 0, 0),
  [1720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_summary_value, 2, 0, 0),
  [1722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_summary_value, 3, 0, 0),
  [1724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_summary_value, 3, 0, 0),
  [1726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [1728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [1730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat3, 2, 0, 0), SHIFT_REPEAT(1039),
  [1733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat3, 2, 0, 0), SHIFT_REPEAT(1020),
  [1736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat3, 2, 0, 0), SHIFT_REPEAT(929),
  [1739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [1743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [1745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [1747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [1749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [1751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2, 0, 0), SHIFT_REPEAT(1185),
  [1754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2, 0, 0), SHIFT_REPEAT(770),
  [1757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [1759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [1761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat1, 2, 0, 0), SHIFT_REPEAT(548),
  [1764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [1766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [1768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [1770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__load_store_suffix, 1, 0, 0),
  [1772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__load_store_suffix, 1, 0, 0), SHIFT(1971),
  [1775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__load_store_suffix, 1, 0, 0),
  [1777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(613),
  [1779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1793),
  [1781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__load_store_suffix, 2, 0, 0),
  [1783] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__load_store_suffix, 2, 0, 0), SHIFT(1913),
  [1786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__load_store_suffix, 2, 0, 0),
  [1788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_syncscope, 4, 0, 0),
  [1790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_syncscope, 4, 0, 0),
  [1792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_landingpad, 3, 0, 3),
  [1794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_landingpad, 3, 0, 3),
  [1796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [1798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_landingpad_repeat1, 2, 0, 0),
  [1800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instruction_landingpad_repeat1, 2, 0, 0),
  [1802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_instruction_landingpad_repeat1, 2, 0, 0), SHIFT_REPEAT(981),
  [1805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_landingpad, 4, 0, 3),
  [1807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_landingpad, 4, 0, 3),
  [1809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction, 1, 0, 0),
  [1811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [1813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction, 1, 0, 0),
  [1815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction, 3, 0, 0),
  [1817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction, 3, 0, 0),
  [1819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction, 4, 0, 0),
  [1821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction, 4, 0, 0),
  [1823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_repeat1, 2, 0, 0),
  [1825] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_repeat1, 2, 0, 0), SHIFT_REPEAT(1471),
  [1828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instruction_repeat1, 2, 0, 0),
  [1830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction, 2, 0, 0),
  [1832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction, 2, 0, 0),
  [1834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_landingpad_clause, 2, 0, 0),
  [1836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_landingpad_clause, 2, 0, 0),
  [1838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_extractvalue_repeat1, 2, 0, 0),
  [1840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instruction_extractvalue_repeat1, 2, 0, 0),
  [1842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_alloca_repeat1, 2, 0, 0),
  [1844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_alloca_repeat1, 2, 0, 0), SHIFT_REPEAT(756),
  [1847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instruction_alloca_repeat1, 2, 0, 0),
  [1849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_alloca, 4, 0, 3),
  [1851] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_alloca, 4, 0, 3), SHIFT(756),
  [1854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_alloca, 4, 0, 3),
  [1856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_insertvalue, 7, 0, 3),
  [1858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_insertvalue, 7, 0, 3), SHIFT(1436),
  [1861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_insertvalue, 7, 0, 3),
  [1863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_getelementptr, 3, 0, 3),
  [1865] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_getelementptr, 3, 0, 3), SHIFT(799),
  [1868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_getelementptr, 3, 0, 3),
  [1870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_phi, 7, 0, 3),
  [1872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_phi, 7, 0, 3), SHIFT(1779),
  [1875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_phi, 7, 0, 3),
  [1877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_phi, 8, 0, 3),
  [1879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_phi, 8, 0, 3), SHIFT(1779),
  [1882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_phi, 8, 0, 3),
  [1884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_phi_repeat1, 2, 0, 0),
  [1886] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_phi_repeat1, 2, 0, 0), SHIFT_REPEAT(1779),
  [1889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instruction_phi_repeat1, 2, 0, 0),
  [1891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_phi, 9, 0, 3),
  [1893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_phi, 9, 0, 3), SHIFT(1779),
  [1896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_phi, 9, 0, 3),
  [1898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_insertvalue, 6, 0, 3),
  [1900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_insertvalue, 6, 0, 3), SHIFT(1436),
  [1903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_insertvalue, 6, 0, 3),
  [1905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_extractvalue, 4, 0, 3),
  [1907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_extractvalue, 4, 0, 3), SHIFT(1436),
  [1910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_extractvalue, 4, 0, 3),
  [1912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_alloca, 5, 0, 3),
  [1914] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_alloca, 5, 0, 3), SHIFT(756),
  [1917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_alloca, 5, 0, 3),
  [1919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_getelementptr_repeat1, 2, 0, 0),
  [1921] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_getelementptr_repeat1, 2, 0, 0), SHIFT_REPEAT(799),
  [1924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instruction_getelementptr_repeat1, 2, 0, 0),
  [1926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_alloca, 3, 0, 3),
  [1928] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_alloca, 3, 0, 3), SHIFT(756),
  [1931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_alloca, 3, 0, 3),
  [1933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_getelementptr, 4, 0, 3),
  [1935] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_getelementptr, 4, 0, 3), SHIFT(799),
  [1938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_getelementptr, 4, 0, 3),
  [1940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_getelementptr, 2, 0, 3),
  [1942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_getelementptr, 2, 0, 3), SHIFT(799),
  [1945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_getelementptr, 2, 0, 3),
  [1947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_getelementptr, 5, 0, 3),
  [1949] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_getelementptr, 5, 0, 3), SHIFT(799),
  [1952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_getelementptr, 5, 0, 3),
  [1954] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_extractvalue_repeat1, 2, 0, 0), SHIFT_REPEAT(1436),
  [1957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_getelementptr_repeat1, 3, 0, 0),
  [1959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instruction_getelementptr_repeat1, 3, 0, 0),
  [1961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_callbr, 4, 0, 7),
  [1963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [1965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_callbr, 4, 0, 7),
  [1967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_alloca, 2, 0, 3),
  [1969] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_alloca, 2, 0, 3), SHIFT(756),
  [1972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_alloca, 2, 0, 3),
  [1974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_extractvalue, 5, 0, 3),
  [1976] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_extractvalue, 5, 0, 3), SHIFT(1436),
  [1979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_extractvalue, 5, 0, 3),
  [1981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_cmpxchg, 9, 0, 3),
  [1983] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_cmpxchg, 9, 0, 3), SHIFT(1552),
  [1986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_cmpxchg, 9, 0, 3),
  [1988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_resume, 2, 0, 3),
  [1990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_resume, 2, 0, 3),
  [1992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_cast, 5, 0, 3),
  [1994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_cast, 5, 0, 3),
  [1996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata_refs, 3, 0, 0),
  [1998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata_refs, 3, 0, 0),
  [2000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_bin_op, 5, 0, 3),
  [2002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_bin_op, 5, 0, 3),
  [2004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_call, 2, 0, 7),
  [2006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_call, 2, 0, 7),
  [2008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_atomic_ordering, 1, 0, 0),
  [2010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_atomic_ordering, 1, 0, 0),
  [2012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_fence, 2, 0, 3),
  [2014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_fence, 2, 0, 3),
  [2016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_indirectbr, 4, 0, 3),
  [2018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_indirectbr, 4, 0, 3),
  [2020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_extractelement, 4, 0, 3),
  [2022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_extractelement, 4, 0, 3),
  [2024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_br, 6, 0, 3),
  [2026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_br, 6, 0, 3),
  [2028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_insertelement, 6, 0, 3),
  [2030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_insertelement, 6, 0, 3),
  [2032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_select, 6, 0, 3),
  [2034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_select, 6, 0, 3),
  [2036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_shufflevector, 6, 0, 3),
  [2038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_shufflevector, 6, 0, 3),
  [2040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_store, 5, 0, 3),
  [2042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_store, 5, 0, 3),
  [2044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_switch, 6, 0, 3),
  [2046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_switch, 6, 0, 3),
  [2048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_load, 5, 0, 3),
  [2050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_load, 5, 0, 3),
  [2052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_fneg, 2, 0, 3),
  [2054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_fneg, 2, 0, 3),
  [2056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_invoke, 6, 0, 7),
  [2058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_invoke, 6, 0, 7),
  [2060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_freeze, 2, 0, 3),
  [2062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_freeze, 2, 0, 3),
  [2064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_fcmp, 5, 0, 3),
  [2066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_fcmp, 5, 0, 3),
  [2068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_icmp, 5, 0, 3),
  [2070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_icmp, 5, 0, 3),
  [2072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unwind_label, 3, 0, 0),
  [2074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unwind_label, 3, 0, 0),
  [2076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_fence, 3, 0, 3),
  [2078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_fence, 3, 0, 3),
  [2080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__value_array, 3, 0, 0),
  [2082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__value_array, 3, 0, 0),
  [2084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_cleanupret, 4, 0, 3),
  [2086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_cleanupret, 4, 0, 3),
  [2088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_fcmp, 6, 0, 3),
  [2090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_fcmp, 6, 0, 3),
  [2092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_call, 3, 0, 10),
  [2094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_call, 3, 0, 10),
  [2096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_load, 6, 0, 3),
  [2098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_load, 6, 0, 3),
  [2100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_catchswitch, 4, 0, 3),
  [2102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_catchswitch, 4, 0, 3),
  [2104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_call, 3, 0, 9),
  [2106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_call, 3, 0, 9),
  [2108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_catchret, 5, 0, 3),
  [2110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_catchret, 5, 0, 3),
  [2112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__value_array, 2, 0, 0),
  [2114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__value_array, 2, 0, 0),
  [2116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_cleanuppad, 3, 0, 3),
  [2118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_cleanuppad, 3, 0, 3),
  [2120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_va_arg, 4, 0, 3),
  [2122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_va_arg, 4, 0, 3),
  [2124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_cmpxchg, 13, 0, 3),
  [2126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_cmpxchg, 13, 0, 3),
  [2128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_catchpad, 3, 0, 3),
  [2130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_catchpad, 3, 0, 3),
  [2132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_unreachable, 1, 0, 3),
  [2134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_unreachable, 1, 0, 3),
  [2136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_call, 4, 0, 13),
  [2138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_call, 4, 0, 13),
  [2140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unwind_label, 2, 0, 0),
  [2142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unwind_label, 2, 0, 0),
  [2144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__load_store_suffix, 3, 0, 0),
  [2146] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__load_store_suffix, 3, 0, 0), SHIFT(1876),
  [2149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__load_store_suffix, 3, 0, 0),
  [2151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_phi_repeat1, 6, 0, 0),
  [2153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instruction_phi_repeat1, 6, 0, 0),
  [2155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_store, 6, 0, 3),
  [2157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_store, 6, 0, 3),
  [2159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_atomicrmw, 6, 0, 3),
  [2161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_atomicrmw, 6, 0, 3), SHIFT(1505),
  [2164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_atomicrmw, 6, 0, 3),
  [2166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_cmpxchg, 12, 0, 3),
  [2168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_cmpxchg, 12, 0, 3),
  [2170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_br, 2, 0, 3),
  [2172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_br, 2, 0, 3), SHIFT(872),
  [2175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_br, 2, 0, 3),
  [2177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_load, 4, 0, 3),
  [2179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_load, 4, 0, 3),
  [2181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_ret, 2, 0, 3),
  [2183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_ret, 2, 0, 3),
  [2185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_cmpxchg, 11, 0, 3),
  [2187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_cmpxchg, 11, 0, 3),
  [2189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_store, 4, 0, 3),
  [2191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_store, 4, 0, 3),
  [2193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_cmpxchg, 11, 0, 3), SHIFT(1558),
  [2196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_fneg, 3, 0, 3),
  [2198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_fneg, 3, 0, 3),
  [2200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_atomicrmw, 10, 0, 3),
  [2202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_atomicrmw, 10, 0, 3),
  [2204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_cmpxchg, 10, 0, 3),
  [2206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_cmpxchg, 10, 0, 3),
  [2208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_cmpxchg, 10, 0, 3), SHIFT(1555),
  [2211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_select, 7, 0, 3),
  [2213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_select, 7, 0, 3),
  [2215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_switch, 7, 0, 3),
  [2217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_switch, 7, 0, 3),
  [2219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_atomicrmw, 9, 0, 3),
  [2221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_atomicrmw, 9, 0, 3),
  [2223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operand_bundles, 8, 0, 0),
  [2225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operand_bundles, 8, 0, 0),
  [2227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 5, 0, 12),
  [2229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 5, 0, 12),
  [2231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__value_array, 4, 0, 0),
  [2233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__value_array, 4, 0, 0),
  [2235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operand_bundles, 7, 0, 0),
  [2237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operand_bundles, 7, 0, 0),
  [2239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_bin_op, 4, 0, 3),
  [2241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_bin_op, 4, 0, 3),
  [2243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operand_bundles, 6, 0, 0),
  [2245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operand_bundles, 6, 0, 0),
  [2247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__load_store_suffix, 6, 0, 0),
  [2249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__load_store_suffix, 6, 0, 0),
  [2251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_cast, 4, 0, 3),
  [2253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_cast, 4, 0, 3),
  [2255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operand_bundles, 5, 0, 0),
  [2257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operand_bundles, 5, 0, 0),
  [2259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 8, 0, 17),
  [2261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 8, 0, 17),
  [2263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_callbr, 7, 0, 7),
  [2265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_callbr, 7, 0, 7),
  [2267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__load_store_suffix, 4, 0, 0),
  [2269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__load_store_suffix, 4, 0, 0),
  [2271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_atomicrmw, 8, 0, 3),
  [2273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_atomicrmw, 8, 0, 3),
  [2275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_atomicrmw, 8, 0, 3), SHIFT(1542),
  [2278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_cmpxchg, 8, 0, 3),
  [2280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_cmpxchg, 8, 0, 3), SHIFT(1541),
  [2283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_cmpxchg, 8, 0, 3),
  [2285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_atomicrmw, 7, 0, 3),
  [2287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_instruction_atomicrmw, 7, 0, 3), SHIFT(1534),
  [2290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_atomicrmw, 7, 0, 3),
  [2292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__load_store_suffix, 5, 0, 0),
  [2294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__load_store_suffix, 5, 0, 0),
  [2296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 7, 0, 16),
  [2298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 7, 0, 16),
  [2300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction_callbr, 8, 0, 7),
  [2302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction_callbr, 8, 0, 7),
  [2304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_part, 6, 0, 15),
  [2306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_part, 6, 0, 15),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [2312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_specialized_md_repeat1, 2, 0, 0), SHIFT_REPEAT(727),
  [2315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_specialized_md_repeat1, 2, 0, 0), SHIFT_REPEAT(714),
  [2318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_specialized_md_repeat1, 2, 0, 0), SHIFT_REPEAT(719),
  [2321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_specialized_md_repeat1, 2, 0, 0), SHIFT_REPEAT(724),
  [2324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_specialized_md_repeat1, 2, 0, 0), SHIFT_REPEAT(719),
  [2327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_specialized_md_repeat1, 2, 0, 0), SHIFT_REPEAT(718),
  [2330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_specialized_md_repeat1, 2, 0, 0), SHIFT_REPEAT(706),
  [2333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_specialized_md_repeat1, 2, 0, 0),
  [2335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_specialized_md_repeat1, 2, 0, 0), SHIFT_REPEAT(701),
  [2338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_specialized_md_repeat1, 2, 0, 0), SHIFT_REPEAT(710),
  [2341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_specialized_md_repeat1, 2, 0, 0), SHIFT_REPEAT(1858),
  [2344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_specialized_md_repeat1, 2, 0, 0), SHIFT_REPEAT(697),
  [2347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_specialized_md_repeat1, 2, 0, 0), SHIFT_REPEAT(1718),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [2352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [2356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [2358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [2360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [2362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [2366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [2368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1858),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [2374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1718),
  [2376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [2398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_select_repeat1, 2, 0, 0), SHIFT_REPEAT(712),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [2403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_specialized_md_value, 3, 0, 0),
  [2405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_specialized_md_value, 3, 0, 0),
  [2407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_specialized_md_value, 1, 0, 0),
  [2409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_specialized_md_value, 1, 0, 0),
  [2411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_specialized_md_value, 2, 0, 0),
  [2413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_specialized_md_value, 2, 0, 0),
  [2415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [2417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [2419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [2421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [2423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [2425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [2427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [2429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [2431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [2433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [2435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [2437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [2439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [2441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__global_prefix, 3, 0, 0),
  [2443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [2445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [2447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__global_prefix, 2, 0, 0),
  [2449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [2451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [2453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [2455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [2457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [2459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [2461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_bin_op_repeat1, 2, 0, 0),
  [2463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instruction_bin_op_repeat1, 2, 0, 0),
  [2465] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_bin_op_repeat1, 2, 0, 0), SHIFT_REPEAT(744),
  [2468] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_bin_op_repeat1, 2, 0, 0), SHIFT_REPEAT(712),
  [2471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [2473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat1, 2, 0, 0), SHIFT_REPEAT(829),
  [2476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat1, 2, 0, 0), SHIFT_REPEAT(828),
  [2479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat1, 2, 0, 0), SHIFT_REPEAT(828),
  [2482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_header_repeat1, 2, 0, 0), SHIFT_REPEAT(827),
  [2485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat1, 2, 0, 0), SHIFT_REPEAT(827),
  [2488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat1, 2, 0, 0), SHIFT_REPEAT(826),
  [2491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_header_repeat1, 2, 0, 0), SHIFT_REPEAT(825),
  [2494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bin_op_keyword, 1, 0, 0),
  [2496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bin_op_keyword, 1, 0, 0),
  [2498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_atomic_bin_op_keyword, 1, 0, 0),
  [2500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_atomic_bin_op_keyword, 1, 0, 0),
  [2502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0),
  [2504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(1778),
  [2507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(1872),
  [2510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(1870),
  [2513] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(83),
  [2516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(1869),
  [2519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(1233),
  [2522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(1866),
  [2525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(197),
  [2528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(201),
  [2531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(888),
  [2534] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(1862),
  [2537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(1801),
  [2540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(1792),
  [2543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 1, 0, 0),
  [2545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [2547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [2549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [2551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [2553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [2555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [2557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [2559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [2561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [2563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [2565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [2567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [2569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [2571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [2575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [2577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [2579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [2581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [2583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [2587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_switch_repeat1, 2, 0, 0), SHIFT_REPEAT(260),
  [2590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_switch_repeat1, 2, 0, 0), SHIFT_REPEAT(275),
  [2593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_switch_repeat1, 2, 0, 0), SHIFT_REPEAT(291),
  [2596] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_switch_repeat1, 2, 0, 0), SHIFT_REPEAT(812),
  [2599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_switch_repeat1, 2, 0, 0), SHIFT_REPEAT(810),
  [2602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_switch_repeat1, 2, 0, 0), SHIFT_REPEAT(1207),
  [2605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_switch_repeat1, 2, 0, 0),
  [2607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_instruction_switch_repeat1, 2, 0, 0), SHIFT_REPEAT(1208),
  [2610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [2612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [2614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [2616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [2618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [2620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [2624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [2628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [2632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [2634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [2636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [2638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [2648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [2650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [2652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [2654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [2658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [2660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [2662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [2664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [2666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [2670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [2672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [2674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [2676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [2678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [2680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [2682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [2684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [2686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [2688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [2690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [2692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [2698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [2702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [2704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [2708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [2710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [2712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [2714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [2716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [2718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [2720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [2722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [2724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [2726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [2736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [2746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata_name, 1, 0, 0),
  [2748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata_name, 1, 0, 0),
  [2750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_inst, 1, 0, 0),
  [2752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_inst, 1, 0, 0),
  [2754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_switch_repeat1, 3, 0, 0),
  [2756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instruction_switch_repeat1, 3, 0, 0),
  [2758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fcmp_cond, 1, 0, 0),
  [2760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fcmp_cond, 1, 0, 0),
  [2762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_icmp_cond, 1, 0, 0),
  [2764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_icmp_cond, 1, 0, 0),
  [2766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [2768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias, 8, 0, 0),
  [2770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias, 8, 0, 0),
  [2772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_repeat1, 2, 0, 0), SHIFT_REPEAT(1543),
  [2775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ifunc, 8, 0, 0),
  [2777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ifunc, 8, 0, 0),
  [2779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_global, 5, 0, 0),
  [2781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_global, 5, 0, 0),
  [2783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list_order, 5, 0, 0),
  [2785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_list_order, 5, 0, 0),
  [2787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list_order, 7, 0, 0),
  [2789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_list_order, 7, 0, 0),
  [2791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list_order, 6, 0, 0),
  [2793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_list_order, 6, 0, 0),
  [2795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm, 1, 0, 0),
  [2797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_asm, 1, 0, 0),
  [2799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [2801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_target_definition, 2, 0, 0),
  [2803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_target_definition, 2, 0, 0),
  [2805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [2807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [2809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_define, 3, 0, 1),
  [2811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_define, 3, 0, 1),
  [2813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_type, 4, 0, 0),
  [2815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_type, 4, 0, 0),
  [2817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [2821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_summary_entry, 6, 0, 5),
  [2823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_summary_entry, 6, 0, 5),
  [2825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_target_triple, 3, 0, 0),
  [2827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_target_triple, 3, 0, 0),
  [2829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_layout, 3, 0, 0),
  [2831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_data_layout, 3, 0, 0),
  [2833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list_order_bb, 8, 0, 0),
  [2835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_list_order_bb, 8, 0, 0),
  [2837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file_name, 3, 0, 0),
  [2839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_source_file_name, 3, 0, 0),
  [2841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 2, 0, 0),
  [2843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 2, 0, 0),
  [2845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_summary_entry, 7, 0, 5),
  [2847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_summary_entry, 7, 0, 5),
  [2849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [2851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unnamed_attr_grp, 5, 0, 0),
  [2853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unnamed_attr_grp, 5, 0, 0),
  [2855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_define, 4, 0, 4),
  [2857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_define, 4, 0, 4),
  [2859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_metadata, 4, 0, 0),
  [2861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_metadata, 4, 0, 0),
  [2863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [2865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [2867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_metadata, 3, 0, 0),
  [2869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_metadata, 3, 0, 0),
  [2871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constant_bin_op_repeat1, 2, 0, 0),
  [2873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constant_bin_op_repeat1, 2, 0, 0), SHIFT_REPEAT(1124),
  [2876] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constant_bin_op_repeat1, 2, 0, 0), SHIFT_REPEAT(712),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [2881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 3, 0, 0),
  [2883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 3, 0, 0),
  [2885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [2887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [2889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [2891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comdat, 4, 0, 0),
  [2893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comdat, 4, 0, 0),
  [2895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_asm, 3, 0, 0),
  [2897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_asm, 3, 0, 0),
  [2899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 4, 0, 0),
  [2901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 4, 0, 0),
  [2903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_summary_entry, 5, 0, 5),
  [2905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_summary_entry, 5, 0, 5),
  [2907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [2909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [2911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unnamed_attr_grp, 6, 0, 0),
  [2913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unnamed_attr_grp, 6, 0, 0),
  [2915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list_order_bb, 9, 0, 0),
  [2917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_list_order_bb, 9, 0, 0),
  [2919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declare, 2, 0, 0),
  [2921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declare, 2, 0, 0),
  [2923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declare, 3, 0, 0),
  [2925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declare, 3, 0, 0),
  [2927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list_order_bb, 7, 0, 0),
  [2929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_list_order_bb, 7, 0, 0),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [2935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [2949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [2951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__global_prefix, 4, 0, 0),
  [2953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_thread_local, 1, 0, 0),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [2963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_thread_local, 4, 0, 0),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [2969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1589),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [2973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [2977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [2979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__global_prefix, 5, 0, 0),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [2991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [2995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instruction_callbr_repeat1, 2, 0, 0),
  [2997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_callbr_repeat1, 2, 0, 0), SHIFT_REPEAT(1008),
  [3000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [3002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [3004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [3006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [3008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [3010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [3012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [3014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [3016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__global_prefix, 6, 0, 0),
  [3018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [3020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [3022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [3024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [3026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [3028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__global_prefix, 7, 0, 0),
  [3030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [3032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [3034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [3036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [3038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [3040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_body_repeat2, 2, 0, 0),
  [3042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat2, 2, 0, 0), SHIFT_REPEAT(888),
  [3045] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_extractvalue_repeat1, 2, 0, 0), SHIFT_REPEAT(1329),
  [3048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [3050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [3052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [3054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [3056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [3058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [3060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [3062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [3064] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_repeat1, 2, 0, 0), SHIFT_REPEAT(765),
  [3067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_repeat1, 2, 0, 0),
  [3069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [3071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [3073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [3075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [3077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [3079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [3081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [3083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [3089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [3091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [3093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [3095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [3097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [3101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [3103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [3105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [3107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [3109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [3111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [3113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [3115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [3117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [3119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [3121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [3131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [3133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [3137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [3139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_operand_bundles_repeat1, 2, 0, 0),
  [3141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_operand_bundles_repeat1, 2, 0, 0), SHIFT_REPEAT(1758),
  [3144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [3146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [3148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_body_repeat1, 2, 0, 0),
  [3150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1068),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [3167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [3173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [3177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_body, 1, 0, 0),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [3181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_metadata_tuple_repeat1, 2, 0, 0),
  [3183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_metadata_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(748),
  [3186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [3188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_body, 2, 0, 0),
  [3190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [3196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [3200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [3206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [3212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [3218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [3220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [3224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [3226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [3228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [3230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [3232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [3234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [3236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [3238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [3240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [3242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [3246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [3248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1055),
  [3251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [3253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [3255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [3257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [3259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [3261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [3263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [3265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [3267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [3269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [3271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [3273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [3275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [3277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [3279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [3281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [3283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [3285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [3287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [3289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [3291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [3293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [3295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_callbr_repeat1, 2, 0, 0), SHIFT_REPEAT(1034),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [3300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [3302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [3304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [3306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [3308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [3310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [3312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [3314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [3316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [3318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [3320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [3322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [3324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [3326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [3330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [3332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [3334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [3336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [3338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [3340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [3342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [3346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [3348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [3350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [3356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [3360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [3362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [3364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [3368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [3370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [3372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [3374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [3378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [3380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [3382] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(832),
  [3385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [3387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [3389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [3391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [3393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [3395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [3397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [3399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [3401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instruction_getelementptr_repeat1, 2, 0, 0), SHIFT_REPEAT(796),
  [3404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [3406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [3408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [3414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [3418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [3422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [3424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [3426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [3428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [3430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [3432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [3434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [3436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [3438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_memory_attribute_repeat1, 2, 0, 0), SHIFT_REPEAT(1170),
  [3441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_memory_attribute_repeat1, 2, 0, 0),
  [3443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [3445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [3447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [3449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [3451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [3453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [3455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [3457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_memory_attribute_repeat1, 4, 0, 0),
  [3459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [3461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [3463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [3465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [3467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [3469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [3471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [3473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [3475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [3477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [3479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 3, 0, 0),
  [3481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [3483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_vector_body, 3, 0, 0),
  [3485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_operand_bundles_repeat1, 4, 0, 0),
  [3487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [3489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_operand_bundles_repeat1, 5, 0, 0),
  [3491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_operand_bundles_repeat1, 6, 0, 0),
  [3493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [3495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [3497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [3499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_vector_body, 5, 0, 0),
  [3501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [3503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [3505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [3507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [3509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [3511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_memory_attribute_val, 1, 0, 0),
  [3513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [3515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [3517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [3519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [3521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [3523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [3525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [3527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [3529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [3531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [3533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [3535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [3537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [3539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [3541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [3543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [3545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [3547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [3549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [3551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [3553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [3555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [3557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [3559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [3561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [3563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [3565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [3567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [3569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [3571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [3573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [3575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [3577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [3579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [3581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [3583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [3585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [3587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [3589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [3591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [3593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [3595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [3597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [3599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [3601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [3603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [3605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [3607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [3609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [3611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [3613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [3615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [3617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [3619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [3621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [3623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [3625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [3627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [3629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [3631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [3633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [3635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [3637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [3639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [3641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [3643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [3645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [3647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [3649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [3651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [3653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [3655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [3657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [3659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [3661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [3663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [3665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [3667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [3669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [3671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [3673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [3675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [3677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [3679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [3681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [3683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [3685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [3687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [3689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [3691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [3693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [3695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [3697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [3699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [3701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [3703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [3705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [3707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [3709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [3711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [3713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [3715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [3717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [3719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [3721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [3723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [3725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [3727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [3729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [3731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [3733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [3735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [3737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [3739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [3741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [3743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [3745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [3747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [3749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [3751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [3753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [3755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [3757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [3759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [3761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [3763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [3765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [3767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [3769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [3771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [3773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [3775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [3777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [3779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [3781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [3783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [3785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [3787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [3789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [3791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [3793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [3795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [3797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [3799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [3801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [3803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [3805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [3807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [3809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [3811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [3813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [3815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [3817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [3819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [3821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_asm, 8, 0, 0),
  [3823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [3825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [3827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [3829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_asm, 7, 0, 0),
  [3831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [3833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [3835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [3839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [3841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [3843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [3845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [3847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [3851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [3853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [3855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [3857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [3859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [3861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [3863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [3865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [3867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [3869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [3871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [3873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [3875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [3877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [3879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [3881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [3883] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [3885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [3887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [3889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [3891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [3893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [3895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [3897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [3899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [3901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [3903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [3905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [3907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [3909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [3911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [3913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [3915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [3917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [3919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [3921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [3923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [3925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [3927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [3929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [3931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [3933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [3935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_asm, 6, 0, 0),
  [3937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [3939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [3941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [3943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [3945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [3947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [3949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [3951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [3953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [3955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [3957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [3959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [3961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [3963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [3965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [3967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [3969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [3971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [3973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [3975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [3977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [3979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [3981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [3983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [3985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [3987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [3989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [3991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [3997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [3999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [4001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [4003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [4005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [4007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [4009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [4011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [4013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [4015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [4017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [4021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [4023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [4025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [4027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [4029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [4031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [4033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [4037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [4039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [4041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [4043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [4045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [4047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [4049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [4051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [4053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [4055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [4057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [4059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [4061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__within, 2, 0, 0),
  [4063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_asm, 5, 0, 0),
  [4065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [4067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [4069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [4071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [4073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [4075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [4077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [4079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [4081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [4083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [4085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [4087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [4091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [4093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [4095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [4097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [4099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [4101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [4103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [4105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [4109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [4111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [4113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [4115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [4117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [4119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [4121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [4123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [4125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [4127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [4129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [4131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [4133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [4135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [4137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [4139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [4141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [4143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [4145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [4147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [4149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [4151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [4153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [4155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [4157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [4159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [4161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [4163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [4165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [4167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [4171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [4173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [4175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [4177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [4179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [4181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [4183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [4185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [4187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [4189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [4191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [4193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [4195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [4197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [4199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [4201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [4203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [4205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [4207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [4209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [4213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_asm, 4, 0, 0),
  [4215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [4217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [4219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [4221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [4223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [4225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [4227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [4229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [4231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [4233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [4235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [4239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [4241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [4243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [4245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [4249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [4251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [4253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [4255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [4257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [4259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [4261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [4263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [4265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [4269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [4271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [4273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [4275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [4277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [4281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [4283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [4285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [4287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [4289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [4291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [4293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [4295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [4301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [4303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [4305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [4307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [4309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [4311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_llvm(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
